Visual DataFlex Windows Application and Web Application Class Library

Show Only Public Classes Windows Application Library Web Application Library

A

AboutDialog | Used to create an About Dialog in an application
AbstractFileDialog | Abstract class used to provide access to the Windows file dialog (Abstract)
AbstractShapeControl | Abstract class used to demonstrate Visual DataFlex communicating with the Windows API (Abstract)
AbstractTreeView | Abstract low level TreeView Class (Abstract)
AppClientArea | Provides a client area to contain all of an application's views (MDI child dialogs) (Abstract)
AppDialog | Extends the MDIDialog class to provide support with a level consistent with the App... classes (Abstract)
AppPanel | Provides a top-level window for applications that is independent of all other windows (Abstract)
Array | Used to create a collection of values which are stored and accessed via item numbers

B

BaseData_Set | Abstract class providing methods for accessing databases in a program (Abstract)
BaseXmlDomAttribute | Abstract XML class for handling an attribute node (Abstract)
BaseXmlDomcDataSection | Abstract XML class for handling cDataSection nodes (Abstract)
BaseXmlDomCharacterData | Abstract XML class for handling character/text nodes (Abstract)
BaseXmlDomComment | Abstract XML class for handling comment nodes (Abstract)
BaseXmlDomDocument | Abstract XML class for handling an XML document (Abstract)
BaseXmlDomDocumentFragment | Abstract XML class for handling an XML document fragment (Abstract)
BaseXmlDomDocumentType | Abstract XML class for handling Document Type (DTD) nodes (Abstract)
BaseXmlDomElement | Abstract XML class for handling element nodes (Abstract)
BaseXmlDomEntity | Abstract XML class for handling Entity nodes (Abstract)
BaseXmlDomEntityReference | Abstract XML class for handling Entity Reference nodes (Abstract)
BaseXmlDomImplementation | Abstract XML class for handling Implementation nodes (Abstract)
BaseXmlDomNamedNodeMap | Abstract XML class for handling named node map nodes (Abstract)
BaseXmlDomNode | The ultimate XML abstract superclass designed to handle all XML node types (Abstract)
BaseXmlDomNodeList | Abstract XML class for handling node lists (Abstract)
BaseXmlDomNotation | Abstract XML class for handling notation nodes (Abstract)
BaseXMLDomParseError | Provides support reporting parsing errors in an XML document
BaseXmlDomProcessingInstruction | Abstract XML class for handling Processing Instructions (PIs) nodes (Abstract)
BaseXmlDomTextNode | Abstract XML class for handling text nodes (Abstract)
BasicPanel | Provides a top-level window for applications that is independent of all other windows
BasicReport | Supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it
BitmapContainer | Provides a means for enabling users to select bitmap graphic files to display in programs
Broadcaster | Provides grouping and message-relaying services for a set of objects
BusinessProcess | Contains and executes the statements to perform a batch process on an application's database tables
Button | To create visual representations of keys or buttons that, when pressed by users, produce a specific action with an immediate response

C

cAnimation | Displays an AVI animation clip
cApplication | Encapsulates methods and properties that are essential to the running of your application
cAutoWebReport | Used to create quick prototype reports based around the main file of a cWebBusinessProcess object
cBaseHTTPTransfer | Abstract class for handling HTTP transfers (Abstract)
cBasicReport | Abstract Basic Reporting class (Abstract)
cClientWebService | The base class for all client web-services
cCLIHandler | Implements functionality common for the CLI based Connectivity Kits (SQL Server, DB2 and ODBC)
cCollection | Maintains a collection of object-handles
cComActiveXControl | Generates wrapper classes for imported ActiveX controls
cComActiveXEntryControl_ | Abstract class for creating DDO aware Active X controls (Abstract)
cComAutomationObject | Generates wrapper classes for imported OLE Automation Objects (Abstract)
cComDbActiveXControl | Generates data-aware wrapper classes for imported ActiveX controls
cComDbActiveXControl_ | Abstract class for creating DDO aware Active X controls (Abstract)
cComDocumentObject | Generates wrapper classes for imported Embedded Document objects
cCommandLine | Encapsulates access to the command-line of the running program
cComStdFont | OLE conventions implement fonts as Automation objects that contain the properties of the font
cComStdPicture | OLE conventions implement pictures as Automation objects that contain the properties of the picture
cCrystal | Enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports
cCrystal_ICRViewerSelectionEvents | In Progress...
cCrystalActiveXReportViewer | COM object used to access the ActiveXReportViewer object in the Crystal RDC object model
cCrystalApplication | COM object used to access the Application object in the Crystal RDC object model
cCrystalArea | COM object used to access the Area object in the Crystal RDC object model
cCrystalAreas | COM object used to access the Areas object in the Crystal RDC object model
cCrystalBlobFieldObject | COM object used to access the BlobFieldObject object in the Crystal RDC object model
cCrystalBoxObject | COM object used to access the BoxObject object in the Crystal RDC object model
cCrystalConnectionProperties | COM object used to access the ConnectionProperties object in the Crystal RDC object model
cCrystalConnectionProperty | COM object used to access the ConnectionProperty object in the Crystal RDC object model
cCrystalCRCrystalReportViewerViewInfo | COM object used to access the CRCrystalReportViewerViewInfo object in the Crystal RDC object model
cCrystalCrossTabGroup | COM object used to access the CrossTabGroup object in the Crystal RDC object model
cCrystalCrossTabGroups | COM object used to access the CrossTabGroups object in the Crystal RDC object model
cCrystalCrossTabObject | COM object used to access the CrossTabObject object in the Crystal RDC object model
cCrystalCRVEventInfo | COM object used to access the CRVEventInfo object in the Crystal RDC object model
cCrystalCRVField | COM object used to access the CRVField object in the Crystal RDC object model
cCrystalCRVFields | COM object used to access the CRVFields object in the Crystal RDC object model
cCrystalCRVParameterPromptRuntimeOM | COM object used to access the CRVParameterPromptRuntimeOM object in the Crystal RDC object model
cCrystalCRVSelectionItem | COM object used to access the CRVSelectionItem object in the Crystal RDC object model
cCrystalCRVSelectionItems | COM object used to access the CRVSelectionItems object in the Crystal RDC object model
cCrystalCRVTrackCursorInfo | COM object used to access the CRVTrackCursorInfo object in the Crystal RDC object model
cCrystalCrystalComObject | COM object used to access the CrystalComObject object in the Crystal RDC object model
cCrystalCSFontDescription | COM object used to access the CSFontDescription object in the Crystal RDC object model
cCrystalDatabase | COM object used to access the Database object in the Crystal RDC object model
cCrystalDatabaseFieldDefinition | COM object used to access the DatabaseFieldDefinition object in the Crystal RDC object model
cCrystalDatabaseFieldDefinitions | COM object used to access the DatabaseFieldDefinitions object in the Crystal RDC object model
cCrystalDatabaseTable | COM object used to access the DatabaseTable object in the Crystal RDC object model
cCrystalDatabaseTables | COM object used to access the DatabaseTables object in the Crystal RDC object model
cCrystalExportOptions | COM object used to access the ExportOptions object in the Crystal RDC object model
cCrystalFieldDefinitions | COM object used to access the FieldDefinitions object in the Crystal RDC object model
cCrystalFieldElement | COM object used to access the FieldElement object in the Crystal RDC object model
cCrystalFieldElements | COM object used to access the FieldElements object in the Crystal RDC object model
cCrystalFieldMappingData | COM object used to access the FieldMappingData object in the Crystal RDC object model
cCrystalFieldObject | COM object used to access the FieldObject object in the Crystal RDC object model
cCrystalFormattingInfo | COM object used to access the FormattingInfo object in the Crystal RDC object model
cCrystalFormulaFieldDefinition | COM object used to access the FormulaFieldDefinition object in the Crystal RDC object model
cCrystalFormulaFieldDefinitions | COM object used to access the FormulaFieldDefinitions object in the Crystal RDC object model
cCrystalGraphObject | COM object used to access the GraphObject object in the Crystal RDC object model
cCrystalGroupNameFieldDefinition | COM object used to access the GroupNameFieldDefinition object in the Crystal RDC object model
cCrystalGroupNameFieldDefinitions | COM object used to access the GroupNameFieldDefinitions object in the Crystal RDC object model
cCrystalLineObject | COM object used to access the LineObject object in the Crystal RDC object model
cCrystalMapObject | COM object used to access the MapObject object in the Crystal RDC object model
cCrystalObjectSummaryFieldDefinitions | COM object used to access the ObjectSummaryFieldDefinitions object in the Crystal RDC object model
cCrystalOlapGridObject | COM object used to access the OlapGridObject object in the Crystal RDC object model
cCrystalOleObject | COM object used to access the OleObject object in the Crystal RDC object model
cCrystalPage | COM object used to access the Page object in the Crystal RDC object model
cCrystalPageEngine | COM object used to access the PageEngine object in the Crystal RDC object model
cCrystalPageGenerator | COM object used to access the PageGenerator object in the Crystal RDC object model
cCrystalPages | COM object used to access the Pages object in the Crystal RDC object model
cCrystalParameterFieldDefinition | COM object used to access the ParameterFieldDefinition object in the Crystal RDC object model
cCrystalParameterFieldDefinitions | COM object used to access the ParameterFieldDefinitions object in the Crystal RDC object model
cCrystalParameterValue | COM object used to access the ParameterValue object in the Crystal RDC object model
cCrystalParameterValueInfo | COM object used to access the ParameterValueInfo object in the Crystal RDC object model
cCrystalParameterValueInfos | COM object used to access the ParameterValueInfos object in the Crystal RDC object model
cCrystalParameterValues | COM object used to access the ParameterValues object in the Crystal RDC object model
cCrystalPreview | This class acts as a container for the Crystal COM object which the Crystal Reports report is displayed within
cCrystalPrintingStatus | COM object used to access the PrintingStatus object in the Crystal RDC object model
cCrystalReport | Provides a COM connection to a Crystal Reports report
cCrystalReportAlert | COM object used to access the ReportAlert object in the Crystal RDC object model
cCrystalReportAlertInstance | COM object used to access the ReportAlertInstance object in the Crystal RDC object model
cCrystalReportAlertInstances | COM object used to access the ReportAlertInstances object in the Crystal RDC object model
cCrystalReportAlerts | COM object used to access the ReportAlerts object in the Crystal RDC object model
cCrystalReportObjects | COM object used to access the ReportObjects object in the Crystal RDC object model
cCrystalReportSourceRouter | COM object used to access the ReportSourceRouter object in the Crystal RDC object model
cCrystalRunningTotalFieldDefinition | COM object used to access the RunningTotalFieldDefinition object in the Crystal RDC object model
cCrystalRunningTotalFieldDefinitions | COM object used to access the RunningTotalFieldDefinitions object in the Crystal RDC object model
cCrystalSection | COM object used to access the Section object in the Crystal RDC object model
cCrystalSections | COM object used to access the Sections object in the Crystal RDC object model
cCrystalSortField | COM object used to access the SortField object in the Crystal RDC object model
cCrystalSortFields | COM object used to access the SortFields object in the Crystal RDC object model
cCrystalSpecialVarFieldDefinition | COM object used to access the SpecialVarFieldDefinition object in the Crystal RDC object model
cCrystalSQLExpressionFieldDefinition | COM object used to access the SQLExpressionFieldDefinition object in the Crystal RDC object model
cCrystalSQLExpressionFieldDefinitions | COM object used to access the SQLExpressionFieldDefinitions object in the Crystal RDC object model
cCrystalSubreportLink | COM object used to access the SubreportLink object in the Crystal RDC object model
cCrystalSubreportLinks | COM object used to access the SubreportLinks object in the Crystal RDC object model
cCrystalSubreportObject | COM object used to access the SubreportObject object in the Crystal RDC object model
cCrystalSummaryFieldDefinition | COM object used to access the SummaryFieldDefinition object in the Crystal RDC object model
cCrystalSummaryFieldDefinitions | COM object used to access the SummaryFieldDefinitions object in the Crystal RDC object model
cCrystalTableLink | COM object used to access the TableLink object in the Crystal RDC object model
cCrystalTableLinks | COM object used to access the TableLinks object in the Crystal RDC object model
cCrystalTableQualifiers | COM object used to access the TableQualifiers object in the Crystal RDC object model
cCrystalTextObject | COM object used to access the TextObject object in the Crystal RDC object model
cDB2Handler | Implements functionality specific to DB2.
cDbRichEdit | Allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table
cDbRichEdit_ | Allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table (Abstract)
cDbRichEditDS_ | Allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table (Abstract)
cDbTextEdit | Allows the user to enter and edit text connected to a column in a database table
cDbTextEdit_ | Allows the user to enter and edit text connected to a column in a database table (Abstract)
cDbTextEditDS_ | Allows the user to enter and edit text connected to a column in a database table (Abstract)
cDesktop | Used to create the desktop object which contains all other objects within an application
cDFBtrDrvHandler | In Progress...
cDistributedBusinessProcess | Abstract class used to create Web Browser Process objects (Abstract)
cFTPTransfer | Implements FTP client-side operations
CheckBox | To enable users to select items (or options) in applications
cHtmlHelp | Used to provide access to an HTML-based help system
cHtmlReport | Abstract class that creates HTML reports (Abstract)
cHttpTransfer | Implements HTTP client-side operations
cImageList | A collection of images of the same size, each of which can be referred to by its index
cIniFile | Provides access to Windows INI (configuration) files
cInternetSessionBusinessProcess | Abstract class used to create Web Browser Process objects (Abstract)
ClientArea | Provides an area on the screen to contain all of an application's views
Cm_Entry | Abstract class that provides Entry class capabilities to the prototype_entry class (Abstract)
Cm_Menu | Abstract class that provides Menu class capabilities to the prototype_entry class (Abstract)
cMapiHandler | Consists of functions for sending mail, reading received mail and sending documents
cMSSQLHandler | Implements functionality specific to SQL Server.
cObject | The fundamental class from which all classes are derived
cODBCHandler | Implements functionality specific to ODBC.
CodePickList | Allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets
CodePickList_ | Abstract class that allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets (Abstract)
CodeValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
ColorDialog | Provides an interface to the Windows standard Color dialog
ComboEntry | Combines the capabilities of the Entry and ComboForm classes in a single class (Abstract)
ComboForm | Combines the functionality of the form class with that of a standard Windows drop-down list
Container | Creates non-visual container objects
Container3d | This class creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional (3-D) appearance.
cProcessStatusPanel | Supports a visual object to displayed by long-running processes that may be unattended to report errors that arise in the job
cProgressBar | Indicates the progress within a range
cRegistry | Provides access to the Windows system Registry
cRemoteEntryProcess | Abstract class used to create Web Browser Process objects (Abstract)
cReport | Abstract low level Report Class (Abstract)
cReportDS | Abstract Reporting with a DDO support layerclass (Abstract)
cRichEdit | Allows the user to enter and edit RTF (rich-text format) text
CrystalReport | Enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports
cSQLConnection | Handles all Embedded SQL operations for one connection.
cSQLHandleManager | Base entry point for all Embedded SQL operations.
cSQLStatement | Handles all Embedded SQL operation for one statement. The statement is the most used entity in any SQL environment.
cStatusBar | A control, usually placed at the bottom of a window, that is divided into "panes"
cStatusPane | Represents a single pane of a cStatusBar
cStatusPanel | Abstract class that can be used to create status panels (Abstract)
cTableColumnFetchHelper | Allows creation of a helper object that makes it easy to enable or disable Selected Column Fetching (SCF) for a large number of tables.
cTextEdit | Allows the user to enter and edit text
cToolbar | A control, usually placed at the top of a window, that contains buttons which act as shortcuts to frequently used functionality
cToolbarButton | Each instance represents a single button of a toolbar
cUIObject | An abstract class that provides the standard capabilities of a user interface object (Abstract)
CursorShape | Enables programs to change the appearance of the Windows cursor for any of various purposes
cVersionInfo | Contains information relating to the application's embedded Version Information resources
cWebApp | Creates a web application wrapper object, which is used to contain all Web Browser Objects (WBOs) and Web Service Objects (WSOs)
cWebBusinessProcess | Creates Web Browser Process objects - the basic component of all Browser based Web Applications
cWebReport | Creates HTML reports to be used with WebApp Server
cWebService | Creates Web Service Objects - the basic component of all web-service based Web Applications
cWinControl | Provides a base class to use when subclassing a Windows control (Abstract)
cWinReport2 | Provides most of the capabilities of the BasicReport class and provides the ability to use WinPrint2 to provide more-graphical reports
cWmlreport | A subclass of sWebReport that is customized for WML reports
cWorkspace | Encapsulates access to a Workspace file to set the program's filelist and DFPATH
cXMLDOMAttribute | XML class for handling an attribute node
cXMLDOMCDATASection | XML class for handling CDATA Section nodes
cXMLDOMComment | XML class for handling Comment nodes
cXMLDOMDocument | Provides the Interface to the root node of an XML document
cXMLDOMDocumentFragment | XML class for handling Document Fragments
cXMLDOMDocumentType | Contains information associated with the document type declaration
cXMLDOMElement | XML class for handling an element node
cXMLDOMEntity | XML class for handling an Entity node
cXMLDOMEntityReference | XML class for handling Entity Reference nodes
cXMLDOMNamedNodeMap | XML class for handling Named Node map (collections of attributes)
cXMLDOMNode | Creates a generic XML DOM Node object
cXMLDOMNodeList | Supports iteration through the node collection
cXMLDOMNotation | XML class for handling a Notation node
cXMLDOMProcessingInstruction | XML class for handling Processing Instruction (PI) nodes
cXMLDOMTextNode | XML class for handling a text node
cXmlHttpTransfer | Provides an easy mechanism for sending and receiving XML documents via Http.

D

DataDictionary | This class provides the main method for accessing databases in Visual DataFlex programs.
DataList | Implements the behavior common to virtual scrolling lists and provides an interface to a DSO to support virtual list viewing (Abstract)
DataList_ | Abstract class that implements the behavior common to virtual scrolling lists (Abstract)
DataSet | Abstract class providing methods for accessing databases in a program (Abstract)
dbAppClient_ | Abstract class that creates view objects (Abstract)
dbAppView_ | Abstract class that creates view objects (Abstract)
dbBasicComboForm | Combines the capabilities of the ComboEntry class and the dbForm class (Abstract)
dbBasicComboForm_ | Abstract class that combines the capabilities of the ComboEntry class and the dbForm class (Abstract)
dbBitmap | Provides for automatic display of bitmap graphics by addressing a database field with an entry_display message
dbCheckbox | To combine the functionality of dbForm and CheckBox allowing a data-entry element to be represented in a checkbox format
dbCheckBoxDS | Abstract class that combines the functionality of dbForm and CheckBox allowing a data-entry element to be represented in a checkbox format (Abstract)
dbCodeComboForm | Provides combo objects that automatically use a central codes database file such as CODEMAST
dbComboForm | Provides general-purpose comboform DEOs
dbComboFormDD_ | Abstract class providing general-purpose comboform DEOs (Abstract)
dbComboFormDS | Abstract class providing combo objects that automatically use a central codes database file (Abstract)
dbContainer | Groups together data-entry objects within an invisible container
dbContainer3d | Creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional appearance
dbContainer3d_ | Abstract class creating visual container objects and by default, providing a gray background with a raised border having a three-dimensional appearance (Abstract)
dbDataComboForm | Extends the functionality of the dbBasicComboForm to support the separation of description and database values (Abstract)
dbEdit | (Obsolete) Supports data entry for memo fields or sequential ASCII files from DEOs
dbEdit_ | (Obsolete) Abstract class that supports data entry for memo fields or sequential ASCII files from DEOs (Abstract)
dbEditDS | (Obsolete) Abstract class that supports data entry for memo fields or sequential ASCII files from DEOs (Abstract)
dbFloatingPanel | In Progress...
dbFloatingPanel_ | In Progress...
dbFloatingPopupMenu | Creates standard data-aware (DEO) floating popup menus
dbForm | To support data entry through an entry_item to one field of one logical record at a time
dbForm_ | Abstract class that supports data entry through an entry_item to one field of one logical record at a time (Abstract)
dbFormDS | Abstract class that supports data entry through an entry_item to one field of one logical record at a time (Abstract)
dbFormExternalControl | Abstract class that enables applications to provide users with a data aware visual control to 'slide' through a range of values (Abstract)
dbGrid | Enables users to view and edit a scrolling, multi-column list of field values from a database file
dbGrid_ | Abstract class that enables users to view and edit a scrolling, multi-column list of field values from a database file (Abstract)
dbGridDD | In Progress...
dbGridDS | Abstract class that enables users to view and edit a scrolling, multi-column list of field values from a database file (Abstract)
dbGroup | Creates visual group container objects and by default, provides a gray background with a rectangular 3 D line border with a text label embedded in the top left edge
dbGroup_ | Abstract class that creates visual group container objects and by default, provides a gray background with a rectangular 3 D line border with a text label embedded in the top left edge (Abstract)
dbList | Enables users to select one or more values from a list of choices
dbList_ | Abstract class enabling users to select one or more values from a list of choices (Abstract)
dbListDS | Abstract class enabling users to select one or more values from a list of choices (Abstract)
dbModalPanel | Provides a modal container for selection lists (dblist) and other DEOs
dbRadioContainer | Provides all of the functionality of a dbRadioGroup within an invisible container
dbRadioGroup | Groups multiple radio objects in a visible object, providing selection of no more than one at a time
dbRadioGroupDS | Abstract class that groups multiple radio objects in a visible object, providing selection of no more than one at a time (Abstract)
dbSpinForm | Provides an entry form that users can edit that contains an integer or date that can be driven through a range with buttons
dbSpinFormDS | Abstract class that provides an entry form that users can edit that contains an integer or date that can be driven through a range with buttons (Abstract)
dbTabDialog | Contains and provides coordinated access to dbTabPage objects
dbTabDialog_ | Abstract class that contains and provides coordinated access to dbTabPage objects (Abstract)
dbTabDialogView | Contains and provides coordinated access to dbTabView objects
dbTabPage | Used when all of the pages in a view share the same DDO structure
dbTabView | Used when each tab-page will contain a stand-alone view with its own DDO structure
dbTabView_ | Abstract class used when each tab-page will contain a stand-alone view with its own DDO structure (Abstract)
dbTrackBar | Enables applications to provide users with a data aware visual control to 'slide' through a range of values
dbView | Creates view objects
dbViewFloatingPanel | In Progress...
dbViewToolPanel | Abstract class that provides a modal container for selection lists (dblist) and other DEOs (Abstract)
DEOPopupMenu | Creates pulldown objects that disables messages not sent to DEOs
DescriptionValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
DfBaseActionBar | Abstract class that provides the capabilities of a standard GUI menu bar (Abstract)
DfBaseButton | An abstract class used for defining all button classes (Abstract)
DfBaseCheckbox | Abstract class that enables users to select items (or options) in applications (Abstract)
DfBaseComboBox | Abstract class that combines the functionality of the form class with that of a standard Windows drop-down list (Abstract)
DfBaseComboBoxEntry | Abstract class thta combines the capabilities of the Entry and ComboForm classes in a single class (Abstract)
DfBaseContainer | An abstract class for defining GUI containers (Abstract)
DfBaseControl | An abstract class for defining GUI controls (Abstract)
DfBaseDialog | A container class that manages the controls that are placed in its scope (Abstract)
DfBaseEdit | (Obsolete) Abstract class that allows users to enter multiple lines of text (Abstract)
DfBaseEditPullDown | Abstract class that creates standard floating popup menus (Abstract)
DfBaseEntry | Allows the retrieval, display and storage of information between a database field and a form (Abstract)
DfBaseEntryList | Abstract class suitable for "table" style data entry (Abstract)
DfBaseForm | DfBaseForm is a superclass for classes supporting form data entry (Abstract)
DfBaseFormList | Abstract class which should be used for creating multi-row, multi-column entry lists (Abstract)
DfBaseGroup | Abstract class creating visual group container objects with a gray background with a rectangular 3 D line border with a text label embedded in the top left edge (Abstract)
DfBaselineControl | Abstract class that creates divider lines on a container most-often to create a 3 D horizontal dividing line (Abstract)
DfBaseList | An intermediate class that is used as the basis for all "item- and form-based" classes (Abstract)
DfBaseListbox | Abstract low level List Class (Abstract)
DfBasemdiclient | Abstract class providing low-level support for an MDI-style client area (Abstract)
DfBaseObject | Provides a level of abstraction that separates the basic object support from the GUI support (Abstract)
DfBasePanel | Provides a top-level window for applications that is independent of all other windows (Abstract)
DfBasePullDown | Abstract class that creates standard floating popup menus (Abstract)
DfBasePushButton | Abstract class creating visual representations of keys or buttons that, when pressed by users, produce a specific action with an immediate response (Abstract)
DfBaseRadioButton | Abstract class that provides support for stand-alone radio buttons (Abstract)
DFBaseRichEdit | In Progress...
DfBasetabDialog | Abstract class used for TabDialogs (Abstract)
DfBaseTextbox | Abstract class that enables placing static text strings on the display (Abstract)
DFBaseTextEdit | In Progress...
DfBasetoolPanel | Abstract class that creates tool panels - panels that are not listed on the Windows task list (Abstract)
DfBaseUIWindow | Adds a layer of support for user interaction to DfBaseWindow (Abstract)
DfBaseWindow | Specifies a layer of presentation support for GUI objects (Abstract)
DfComActiveXControl | Abstract class which provides support forwrapping of Active X controls (Abstract)
DfComAutomationObject | Abstract class for imported OLE Automation Objects (Abstract)
DFComDocumentObject | Abstract class which provides support for embedded document objects (Abstract)
DfComUIObject | Abstract class which provides standard UI interfaces for Com Objects (Abstract)
DfInPlaceComObject | Abstract class which provides standard COM interfaces for Com Objects (Abstract)
DFTimer | DFTimer objects can be used to trigger an event after a certain amount of time has passed.
Dialog | Creates non-MDI-child dialog objects

E

Edit | (Obsolete) Allows users to enter multiple lines of text
Entry | The basis of more-sophisticated data-entry classes,
EntryList | An abstract class suitable for "table" style data entry (Abstract)
ErrorSystem | Supports Visual DataFlex's interactive interface for all errors generated in a program

F

FileValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
FloatingPanel | In Progress...
FloatingPopupMenu | Creates standard floating popup menus (context menus)
FontDialog | Permits users to select fonts
Form | To display and accept keyboard input
FormExternalControl | Abstract class enabling applications to provide users with a visual control to 'slide' through a range of values (Abstract)
FormFloatingPopupMenu | Creates standard floating popup menus for Windows forms (context menus)

G

Grid | A basic class which should be used for creating multi-row, multi-column entry lists
Group | To create visual group container objects with (by default) a gray background with a rectangular 3 D line border with a text label embedded in the top left edge

H

HelpSystem Used to create help object for a Windows Help Files

I

InetTransfer Abstract class for handling HTTP and FTP transfers (Abstract)

L

LineControl | Creates divider lines on a container most-often to create a 3 D horizontal dividing line
List | Manipulates dynamic lists of information

M

MdiClientArea | Provides low-level support for an MDI-style client area
MdiDialog | Creates MDI child dialog objects for use inside a MDI client-area object (Abstract)
MenuBar | Provides the capabilities of a standard GUI menu bar
Mixin | Provides a method for mixing additional skills into a class
ModalPanel | Creates modal popup panels

O

OpenDialog Provides access to the Windows file-open dialog

P

Panel | Provides a top-level window for applications that is independent of all other windows
PickList | Abstract class that allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets (Abstract)
PickList_ | Abstract class that allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets (Abstract)
PopupMenu | Displayed whenever a choice is made from a menu bar and from certain choices made from an already-displayed popup menu
PrintDialog | A wrapper for the Windows Print dialog box used by the CrystalReport class
Prototype_Entry | Helper Class used by DEO Grid classes (dbGrids and dbLists) to define row information

R

Radio | Provides visual selection icons that are used in groups exclusively within radio containers
RadioButton | An intermediate that provides support for stand-alone radio buttons
RadioContainer | Groups multiple Radio objects in a non-visible object, providing selection of no more than one at a tim
RadioGroup | Groups multiple Radio objects in a visible group object, providing selection of no more than one at a time, and navigation among the objects
Report | Abstract class that supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it (Abstract)
Report_DS | Abstract class that supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it (Abstract)
ReportPanel | Provides a modal popup user interface for running reports
ReportView | Provides a non-modal user interface selected from a menu choice for running reports

S

SaveAsDialog | Provides access to the Windows file-save dialog
Set | Assembles and maintains a set of unique values
ShapeControl | Demonstrates Visual DataFlex communicating with the Windows API
SpinForm | Adds a spin button to a Form
SplashScreenPanel | Provides a way to display a splash screen in your application
StatusAsciiLog | Used for logging status and error reports from unattended (batch) processes to an ascii file
StatusdbLog | Used for logging status and error reports from unattended (batch) processes to a database file
StatusPanel | (Obsolete) Supports a visual object to displayed by long-running processes that may be unattended to report errors that arise in the job
SystemMenu | Class used to create system menus

T

TabDialog | Created by creating a TabDialog object and then creating TabPage objects inside it
TabDialog_ | Abstract class created by creating a TabDialog object and then creating TabPage objects inside it (Abstract)
TabPage | Creates a page within a tab-dialog container
TextBox | Enables placing static text strings on the display
ToolPanel | Creates tool panels - panels that are not listed on the Windows task list
TrackBar | Enables applications to provide users with a visual control to 'slide' through a range of values
TreeView | Provides a control that displays a hierarchical list of items, such as the headings in a document, the entries in an index, or the files and directories on a disk

V

ValidationList | Provides a default interface object for validation tables used as prompt objects
ValidationTable | Provides a one-column table of validation data for validation lists used with DataDictionary objects.
View | Provides a "basic" (non DEO) MDI view
ViewPopupMenu | Creates popup menu objects that will redirect item messages to the MDI container area object

W

WideList | An abstract class defining the common procedures and properties of data-entry classes and dbLists (Abstract)
WideList_ | Abstract class defining the common procedures and properties of data-entry classes and dbLists (Abstract)
WinReport | (Obsolete) Provides most of the capabilities of the BasicReport class and provides the ability to use WinPrint to provide more-graphical reports


Welcome

Class documentation is provided for all public classes and all public interfaces. For the most part, use of this documentation should be self explanatory.

The main Class Reference page contains an alphabetical list of all classes along with a short description of the class. You can choose to view this list for windows applications, web applications or both. You may also choose to view only the public classes (filtering out all abstract classes).

The Hierarchy page displays the class hierarchy. You can view the hierarchy for web application classes, windows application classes or the combined hierarchy.

Both the class list and the hierarchy page provides links to each class documentation page. This page contains a full description of the class and links to all of the public interfaces: properties, events and methods (procedures and functions). These interfaces are provided in a list accompanied by a short description for each item and a link to documentation for each interface. When you view a list of interfaces (properties, events, methods) you will be shown a complete list of the class interfaces including all super-class interfaces. This list is presented in class hierarchy order where interfaces are grouped within the class that defines them. You can also choose to view these lists in alphabetical order. This makes it easy to find the message you need without having to search through the entire class hierarchy.

Note that only non-private classes (public and abstract) and public messages are documented. Private classes and interfaces are part of the internal implementation and therefore should not be used by the developer. For that reason, they are not documented. When debugging applications you will, of course, still see these messages.

Accessing Class Documentation from within the Studio

The Visual DataFlex Studio provides quick contextual access to the referential documentation - class and command. When inside the Studio's editor, place the cursor over the word you wish to research and press F1. The help system will be invoked and an attempt will be made to find the keyword in the help system. If the search keyword is a class name (e.g. Button), the class documentation page will be loaded. If the search keyword is an interface (e.g. OnClick) and that interface name is unique, the page for that interface will be loaded. If the name is not unique (e.g. Value), a list of choices will be presented.

You may also use the F1 feature to search for command documentation (e.g. Move).

Class Documentation Meta Information

The class documentation structure is imported directly from the package source code. This insures that all classes and interfaces are always up to date and accurate. All of the packages contain special markup code that enable us to import the proper information. These are referred to as meta documentation commands and take the form of "//doc/ ...".

While you do not need to understand how the meta tags are used, you may wish to understand the concepts they represent in our class library. Here is a quick summary:

Class Types: Public, Abstract, Mixin, Private

This represents the different attributes of a class.

A class marked Public can be used for both sub-classing and object instantiation by the developer. Public classes are documented.

An Abstract class is a class that should never be used for instantiation and rarely used for sub-classing. It is usually an intermediate class that is needed to create a Public sub-class. While an Abstract class is not used for object instantiation or custom sub-classing, its interfaces may be used by its sub-classes and requires documentation.

A mixin class is a class that is always based on the Mixin class and is used to mix "skills" into other classes. They are never used for sub-classing or instantiation. A mixin class's interface is directly added to the class that imports the mixin skills. Accordingly, mixin class interfaces will be documented as part of the class that uses the mixin.

A class marked as Private, is used internally and should never be used by the developer. These classes are never documented.

Class Library Type: Windows Application, Web Application, Common

A class can be used for Windows applications, web applications or both (Common). A class's library type is defined with the Class Library meta documentation command.

If a class library type is not specified, Windows Application is used.

Method Types: Event, Procedure, Function, Property, ProcedureSet

These are the different types of method types we support. Most of their meanings should be obvious. Within the documentation we will have three interface sections: Properties, Events and Methods. Properties can be defined using the property command or by using the Procedure Set / Function methods. Events are usually defined as a Procedure although they can also be defined as a function. Methods are defined as a a Procedure, a Function or, in rare cases as a Procedure Set.

The ProcedureSet type is rarely used. Normally a method defined with "Procedure Set" has a corresponding "Function" and is defined as a property. In some cases, Procedure Set is not used as a property but is used as an alternate syntax for a procedure and will be documented as such. The ProcedureSet type exists to support old, and now discouraged, interfaces. If you create a new Procedure Set method, you are encouraged to only use this to define a property. If it is not a property, define the method with the Procedure command.

Interface Types: Private, Public

A property, event of method can be either public or private. If public, the method is documented. If private, the interface is part of implementation detail, should not be used, and is not documented.

Obsolete Classes and Interfaces

Classes and interfaces (events, methods, properties) may be designated to be obsolete. An obsolete class or method still exists, may still be used and might exist in your application. It should not be used for new development as a better non-obsolete solution has replaced it. If the class or method is public and obsolete it will be documented. However, you should never use obsolete interfaces when creating new work.


_Classes.htm

Combined Class Hierarchy

View Windows Application Class Hierarchy View Web Application Class Hierarchy

   cObject
   ├──AbstractFileDialog [Abstract]
   │  ├──OpenDialog
   │  └──SaveAsDialog
   ├──Array
   │  ├──cCLIHandler
   │  │  ├──cDB2Handler
   │  │  ├──cMSSQLHandler
   │  │  └──cODBCHandler
   │  ├──cCollection
   │  ├──cDFBtrDrvHandler
   │  ├──cSQLConnection
   │  ├──cSQLHandleManager
   │  ├──cSQLStatement
   │  ├──Set
   │  │  └──Broadcaster
   │  └──ValidationTable
   │     └──DescriptionValidationTable
   │        └──FileValidationTable
   │           └──CodeValidationTable
   ├──BaseData_Set [Abstract]
   │  └──DataSet [Abstract]
   │     └──DataDictionary
   ├──BaseXmlDomImplementation [Abstract]
   ├──BaseXmlDomNamedNodeMap [Abstract]
   │  └──cXMLDOMNamedNodeMap
   ├──BaseXmlDomNode [Abstract]
   │  ├──BaseXmlDomAttribute [Abstract]
   │  │  └──cXMLDOMAttribute
   │  ├──BaseXmlDomCharacterData [Abstract]
   │  │  ├──BaseXmlDomComment [Abstract]
   │  │  │  └──cXMLDOMComment
   │  │  └──BaseXmlDomTextNode [Abstract]
   │  │     ├──BaseXmlDomcDataSection [Abstract]
   │  │     │  └──cXMLDOMCDATASection
   │  │     └──cXMLDOMTextNode
   │  ├──BaseXmlDomDocument [Abstract]
   │  │  └──cXMLDOMDocument
   │  ├──BaseXmlDomDocumentFragment [Abstract]
   │  │  └──cXMLDOMDocumentFragment
   │  ├──BaseXmlDomDocumentType [Abstract]
   │  │  └──cXMLDOMDocumentType
   │  ├──BaseXmlDomElement [Abstract]
   │  │  └──cXMLDOMElement
   │  ├──BaseXmlDomEntity [Abstract]
   │  │  └──cXMLDOMEntity
   │  ├──BaseXmlDomEntityReference [Abstract]
   │  │  └──cXMLDOMEntityReference
   │  ├──BaseXmlDomNotation [Abstract]
   │  │  └──cXMLDOMNotation
   │  ├──BaseXmlDomProcessingInstruction [Abstract]
   │  │  └──cXMLDOMProcessingInstruction
   │  └──cXMLDOMNode
   ├──BaseXmlDomNodeList [Abstract]
   │  └──cXMLDOMNodeList
   ├──BaseXMLDomParseError
   ├──BusinessProcess
   ├──cApplication
   ├──cClientWebService
   ├──cCommandLine
   ├──cCrystal
   ├──cDistributedBusinessProcess [Abstract]
   │  └──cRemoteEntryProcess [Abstract]
   │     └──cInternetSessionBusinessProcess [Abstract]
   │        └──cWebBusinessProcess
   ├──cHtmlHelp
   ├──cImageList
   ├──cIniFile
   ├──Cm_Entry_mixin
   ├──Cm_List_Mixin
   ├──Cm_Menu_Mixin
   ├──cMapiHandler
   ├──ColorDialog
   ├──cRegistry
   ├──cReport [Abstract]
   │  └──cReportDS [Abstract]
   │     └──cBasicReport [Abstract]
   │        └──cHtmlReport [Abstract]
   │           └──cWebReport
   │              ├──cAutoWebReport
   │              └──cWmlreport
   ├──CrystalReport
   ├──cStatusPane
   ├──cTableColumnFetchHelper
   ├──cToolbarButton
   ├──cUIObject [Abstract]
   │  ├──Cm_Menu [Abstract]
   │  │  └──Cm_Entry [Abstract]
   │  │     └──Prototype_Entry
   │  ├──DfBaseObject [Abstract]
   │  │  └──DfBaseWindow [Abstract]
   │  │     └──DfBaseUIWindow [Abstract]
   │  │        ├──DfBaseContainer [Abstract]
   │  │        │  ├──DfBaseDialog [Abstract]
   │  │        │  │  ├──Container3d
   │  │        │  │  │  ├──BitmapContainer
   │  │        │  │  │  │  └──dbBitmap
   │  │        │  │  │  ├──Container
   │  │        │  │  │  ├──dbContainer3d_ [Abstract]
   │  │        │  │  │  │  └──dbContainer3d
   │  │        │  │  │  │     ├──dbContainer
   │  │        │  │  │  │     ├──dbTabPage
   │  │        │  │  │  │     └──dbTabView_ [Abstract]
   │  │        │  │  │  │        └──dbTabView
   │  │        │  │  │  ├──Dialog
   │  │        │  │  │  ├──MdiDialog [Abstract]
   │  │        │  │  │  │  └──AppDialog [Abstract]
   │  │        │  │  │  │     └──View
   │  │        │  │  │  │        ├──cCrystalPreview
   │  │        │  │  │  │        ├──dbAppClient_ [Abstract]
   │  │        │  │  │  │        │  └──dbAppView_ [Abstract]
   │  │        │  │  │  │        │     └──dbView
   │  │        │  │  │  │        └──ReportView
   │  │        │  │  │  └──TabPage
   │  │        │  │  ├──DfBasemdiclient [Abstract]
   │  │        │  │  │  └──MdiClientArea
   │  │        │  │  │     └──AppClientArea [Abstract]
   │  │        │  │  │        └──ClientArea
   │  │        │  │  └──DfBasePanel [Abstract]
   │  │        │  │     ├──BasicPanel
   │  │        │  │     │  └──AppPanel [Abstract]
   │  │        │  │     │     └──Panel
   │  │        │  │     ├──cDesktop
   │  │        │  │     └──DfBasetoolPanel [Abstract]
   │  │        │  │        ├──CursorShape
   │  │        │  │        └──FloatingPanel [Abstract]
   │  │        │  │           ├──cStatusPanel [Abstract]
   │  │        │  │           │  └──cProcessStatusPanel
   │  │        │  │           ├──dbFloatingPanel_ [Abstract]
   │  │        │  │           │  └──dbFloatingPanel [Abstract]
   │  │        │  │           │     └──dbViewFloatingPanel [Abstract]
   │  │        │  │           │        ├──dbModalPanel
   │  │        │  │           │        │  └──ValidationList
   │  │        │  │           │        └──dbViewToolPanel [Abstract]
   │  │        │  │           ├──ModalPanel
   │  │        │  │           │  ├──AboutDialog
   │  │        │  │           │  └──ReportPanel
   │  │        │  │           └──ToolPanel
   │  │        │  │              └──SplashScreenPanel
   │  │        │  └──DfBaseGroup [Abstract]
   │  │        │     └──Group
   │  │        │        ├──dbGroup_ [Abstract]
   │  │        │        │  └──dbGroup
   │  │        │        └──RadioGroup
   │  │        │           ├──dbRadioGroupDS [Abstract]
   │  │        │           │  └──dbRadioGroup
   │  │        │           │     └──dbRadioContainer
   │  │        │           └──RadioContainer
   │  │        └──DfBaseControl [Abstract]
   │  │           ├──AbstractShapeControl [Abstract]
   │  │           │  └──ShapeControl
   │  │           ├──cWinControl [Abstract]
   │  │           │  ├──cAnimation
   │  │           │  ├──cProgressBar
   │  │           │  ├──cStatusBar
   │  │           │  └──cToolbar
   │  │           ├──DfBaseEdit [Abstract]
   │  │           │  └──Edit
   │  │           │     └──dbEdit_ [Abstract]
   │  │           │        └──dbEditDS [Abstract]
   │  │           │           └──dbEdit
   │  │           ├──DfBaselineControl [Abstract]
   │  │           │  └──LineControl
   │  │           ├──DfBaseList [Abstract]
   │  │           │  ├──DfBaseActionBar [Abstract]
   │  │           │  │  ├──DfBasePullDown [Abstract]
   │  │           │  │  │  ├──DfBaseEditPullDown [Abstract]
   │  │           │  │  │  │  └──FormFloatingPopupMenu
   │  │           │  │  │  │     ├──dbFloatingPopupMenu
   │  │           │  │  │  │     └──FloatingPopupMenu
   │  │           │  │  │  ├──PopupMenu
   │  │           │  │  │  │  ├──DEOPopupMenu
   │  │           │  │  │  │  └──ViewPopupMenu
   │  │           │  │  │  └──SystemMenu
   │  │           │  │  └──MenuBar
   │  │           │  ├──DfBaseButton [Abstract]
   │  │           │  │  ├──DfBaseCheckbox [Abstract]
   │  │           │  │  │  ├──CheckBox
   │  │           │  │  │  └──DfBaseRadioButton [Abstract]
   │  │           │  │  │     └──RadioButton
   │  │           │  │  │        └──Radio
   │  │           │  │  └──DfBasePushButton [Abstract]
   │  │           │  │     └──Button
   │  │           │  ├──DfBaseForm [Abstract]
   │  │           │  │  ├──DfBaseComboBox [Abstract]
   │  │           │  │  │  └──ComboForm
   │  │           │  │  ├──DfBaseEntry [Abstract]
   │  │           │  │  │  ├──DfBaseComboBoxEntry [Abstract]
   │  │           │  │  │  │  └──ComboEntry [Abstract]
   │  │           │  │  │  │     └──dbBasicComboForm_ [Abstract]
   │  │           │  │  │  │        └──dbBasicComboForm [Abstract]
   │  │           │  │  │  │           └──dbDataComboForm [Abstract]
   │  │           │  │  │  │              └──dbComboFormDS [Abstract]
   │  │           │  │  │  │                 ├──dbCodeComboForm
   │  │           │  │  │  │                 └──dbComboFormDD_ [Abstract]
   │  │           │  │  │  │                    └──dbComboForm
   │  │           │  │  │  ├──DfBaseEntryList [Abstract]
   │  │           │  │  │  │  └──EntryList [Abstract]
   │  │           │  │  │  │     └──WideList_ [Abstract]
   │  │           │  │  │  │        └──WideList [Abstract]
   │  │           │  │  │  │           ├──DataList_ [Abstract]
   │  │           │  │  │  │           │  └──DataList [Abstract]
   │  │           │  │  │  │           │     ├──dbGrid_ [Abstract]
   │  │           │  │  │  │           │     │  └──dbGridDS [Abstract]
   │  │           │  │  │  │           │     │     └──dbGridDD [Abstract]
   │  │           │  │  │  │           │     │        └──dbGrid
   │  │           │  │  │  │           │     └──dbList_ [Abstract]
   │  │           │  │  │  │           │        └──dbListDS [Abstract]
   │  │           │  │  │  │           │           └──dbList
   │  │           │  │  │  │           └──PickList_ [Abstract]
   │  │           │  │  │  │              └──PickList [Abstract]
   │  │           │  │  │  │                 └──CodePickList_ [Abstract]
   │  │           │  │  │  │                    └──CodePickList
   │  │           │  │  │  └──Entry
   │  │           │  │  │     └──dbForm_ [Abstract]
   │  │           │  │  │        └──dbFormDS [Abstract]
   │  │           │  │  │           ├──dbCheckBoxDS [Abstract]
   │  │           │  │  │           │  └──dbCheckbox
   │  │           │  │  │           ├──dbForm
   │  │           │  │  │           │  └──dbFormExternalControl [Abstract]
   │  │           │  │  │           │     └──dbTrackBar
   │  │           │  │  │           └──dbSpinFormDS [Abstract]
   │  │           │  │  │              └──dbSpinForm
   │  │           │  │  ├──DfBaseFormList [Abstract]
   │  │           │  │  │  └──Grid
   │  │           │  │  ├──DfBasetabDialog [Abstract]
   │  │           │  │  │  └──TabDialog_ [Abstract]
   │  │           │  │  │     └──TabDialog
   │  │           │  │  │        └──dbTabDialog_ [Abstract]
   │  │           │  │  │           └──dbTabDialog
   │  │           │  │  │              └──dbTabDialogView
   │  │           │  │  └──Form
   │  │           │  │     ├──FormExternalControl [Abstract]
   │  │           │  │     │  └──TrackBar
   │  │           │  │     └──SpinForm
   │  │           │  └──DfBaseListbox [Abstract]
   │  │           │     └──List
   │  │           │        └──AbstractTreeView [Abstract]
   │  │           │           └──TreeView
   │  │           ├──DFBaseRichEdit
   │  │           │  └──cRichEdit
   │  │           │     └──cDbRichEdit_ [Abstract]
   │  │           │        └──cDbRichEditDS_ [Abstract]
   │  │           │           └──cDbRichEdit
   │  │           ├──DfBaseTextbox [Abstract]
   │  │           │  └──TextBox
   │  │           │     └──DFTimer
   │  │           └──DFBaseTextEdit
   │  │              └──cTextEdit
   │  │                 └──cDbTextEdit_ [Abstract]
   │  │                    └──cDbTextEditDS_ [Abstract]
   │  │                       └──cDbTextEdit
   │  └──DfComUIObject [Abstract]
   │     └──DfInPlaceComObject [Abstract]
   │        ├──DfComActiveXControl [Abstract]
   │        │  └──cComActiveXControl
   │        │     ├──cComActiveXEntryControl_ [Abstract]
   │        │     │  └──cComDbActiveXControl_ [Abstract]
   │        │     │     └──cComDbActiveXControl
   │        │     └──cCrystalActiveXReportViewer
   │        └──DFComDocumentObject [Abstract]
   │           └──cComDocumentObject
   ├──cVersionInfo
   ├──cWebApp
   ├──cWebService
   ├──cWorkspace
   ├──DfComAutomationObject [Abstract]
   │  └──cComAutomationObject [Abstract]
   │     ├──cComStdFont
   │     ├──cComStdPicture
   │     ├──cCrystal_ICRViewerSelectionEvents
   │     ├──cCrystalApplication
   │     ├──cCrystalArea
   │     ├──cCrystalAreas
   │     ├──cCrystalBlobFieldObject
   │     ├──cCrystalBoxObject
   │     ├──cCrystalConnectionProperties
   │     ├──cCrystalConnectionProperty
   │     ├──cCrystalCRCrystalReportViewerViewInfo
   │     ├──cCrystalCrossTabGroup
   │     ├──cCrystalCrossTabGroups
   │     ├──cCrystalCrossTabObject
   │     ├──cCrystalCRVEventInfo
   │     ├──cCrystalCRVField
   │     ├──cCrystalCRVFields
   │     ├──cCrystalCRVParameterPromptRuntimeOM
   │     ├──cCrystalCRVSelectionItem
   │     ├──cCrystalCRVSelectionItems
   │     ├──cCrystalCRVTrackCursorInfo
   │     ├──cCrystalCrystalComObject
   │     ├──cCrystalCSFontDescription
   │     ├──cCrystalDatabase
   │     ├──cCrystalDatabaseFieldDefinition
   │     ├──cCrystalDatabaseFieldDefinitions
   │     ├──cCrystalDatabaseTable
   │     ├──cCrystalDatabaseTables
   │     ├──cCrystalExportOptions
   │     ├──cCrystalFieldDefinitions
   │     ├──cCrystalFieldElement
   │     ├──cCrystalFieldElements
   │     ├──cCrystalFieldMappingData
   │     ├──cCrystalFieldObject
   │     ├──cCrystalFormattingInfo
   │     ├──cCrystalFormulaFieldDefinition
   │     ├──cCrystalFormulaFieldDefinitions
   │     ├──cCrystalGraphObject
   │     ├──cCrystalGroupNameFieldDefinition
   │     ├──cCrystalGroupNameFieldDefinitions
   │     ├──cCrystalLineObject
   │     ├──cCrystalMapObject
   │     ├──cCrystalObjectSummaryFieldDefinitions
   │     ├──cCrystalOlapGridObject
   │     ├──cCrystalOleObject
   │     ├──cCrystalPage
   │     ├──cCrystalPageEngine
   │     ├──cCrystalPageGenerator
   │     ├──cCrystalPages
   │     ├──cCrystalParameterFieldDefinition
   │     ├──cCrystalParameterFieldDefinitions
   │     ├──cCrystalParameterValue
   │     ├──cCrystalParameterValueInfo
   │     ├──cCrystalParameterValueInfos
   │     ├──cCrystalParameterValues
   │     ├──cCrystalPrintingStatus
   │     ├──cCrystalReport
   │     ├──cCrystalReportAlert
   │     ├──cCrystalReportAlertInstance
   │     ├──cCrystalReportAlertInstances
   │     ├──cCrystalReportAlerts
   │     ├──cCrystalReportObjects
   │     ├──cCrystalReportSourceRouter
   │     ├──cCrystalRunningTotalFieldDefinition
   │     ├──cCrystalRunningTotalFieldDefinitions
   │     ├──cCrystalSection
   │     ├──cCrystalSections
   │     ├──cCrystalSortField
   │     ├──cCrystalSortFields
   │     ├──cCrystalSpecialVarFieldDefinition
   │     ├──cCrystalSQLExpressionFieldDefinition
   │     ├──cCrystalSQLExpressionFieldDefinitions
   │     ├──cCrystalSubreportLink
   │     ├──cCrystalSubreportLinks
   │     ├──cCrystalSubreportObject
   │     ├──cCrystalSummaryFieldDefinition
   │     ├──cCrystalSummaryFieldDefinitions
   │     ├──cCrystalTableLink
   │     ├──cCrystalTableLinks
   │     ├──cCrystalTableQualifiers
   │     └──cCrystalTextObject
   ├──DfFormList_Mixin
   ├──DFListMenu_Mixin
   ├──ErrorSystem
   ├──FontDialog
   ├──HelpSystem
   ├──InetTransfer [Abstract]
   │  ├──cBaseHTTPTransfer [Abstract]
   │  │  └──cHttpTransfer
   │  │     └──cXmlHttpTransfer
   │  └──cFTPTransfer
   ├──Mixin
   │  ├──Action_Bar_Mixin
   │  ├──Auto_Locate_Mixin
   │  ├──Auto_Setup_Mixin
   │  ├──Bitmap_Support_Mixin
   │  ├──cCallInterfaceHelper_mixin
   │  ├──cComFont
   │  ├──cComFontEvents
   │  ├──cComPicture
   │  ├──cCrystal_ICRViewerEvents
   │  ├──cCrystalIApplication
   │  ├──cCrystalIArea
   │  ├──cCrystalIAreas
   │  ├──cCrystalIBlobFieldObject
   │  ├──cCrystalIBoxObject
   │  ├──cCrystalIConnectionProperty
   │  ├──cCrystalICRField
   │  ├──cCrystalICRFields
   │  ├──cCrystalICROleObject
   │  ├──cCrystalICrossTabGroup
   │  ├──cCrystalICrossTabGroups
   │  ├──cCrystalICrossTabObject
   │  ├──cCrystalICRVEventInfo
   │  ├──cCrystalICRVParameterPromptRuntimeOM
   │  ├──cCrystalICRVSelectionItem
   │  ├──cCrystalICRVSelectionItems
   │  ├──cCrystalICRVTrackCursorInfo
   │  ├──cCrystalICrystalDataObject
   │  ├──cCrystalICrystalReportSourceRouter
   │  ├──cCrystalICrystalReportViewer11
   │  ├──cCrystalICrystalReportViewerViewInfo
   │  ├──cCrystalICSFontDescription
   │  ├──cCrystalIDatabase
   │  ├──cCrystalIDatabaseFieldDefinition
   │  ├──cCrystalIDatabaseFieldDefinitions
   │  ├──cCrystalIDatabaseTable
   │  ├──cCrystalIDatabaseTables
   │  ├──cCrystalIExportOptions
   │  ├──cCrystalIFieldDefinitions
   │  ├──cCrystalIFieldElement
   │  ├──cCrystalIFieldElements
   │  ├──cCrystalIFieldMappingData
   │  ├──cCrystalIFieldObject
   │  ├──cCrystalIFormattingInfo
   │  ├──cCrystalIFormulaFieldDefinition
   │  ├──cCrystalIFormulaFieldDefinitions
   │  ├──cCrystalIGraphObject
   │  ├──cCrystalIGroupNameFieldDefinition
   │  ├──cCrystalIGroupNameFieldDefinitions
   │  ├──cCrystalILineObject
   │  ├──cCrystalIMapObject
   │  ├──cCrystalINameValuePairs
   │  ├──cCrystalIObjectSummaryFieldDefinitions
   │  ├──cCrystalIOlapGridObject
   │  ├──cCrystalIPage
   │  ├──cCrystalIPageEngine
   │  ├──cCrystalIPageGenerator
   │  ├──cCrystalIPages
   │  ├──cCrystalIParameterFieldDefinition
   │  ├──cCrystalIParameterFieldDefinitions
   │  ├──cCrystalIParameterValue
   │  ├──cCrystalIParameterValueInfo
   │  ├──cCrystalIParameterValueInfos
   │  ├──cCrystalIParameterValues
   │  ├──cCrystalIPrintingStatus
   │  ├──cCrystalIReport
   │  ├──cCrystalIReportAlert
   │  ├──cCrystalIReportAlertInstance
   │  ├──cCrystalIReportAlertInstances
   │  ├──cCrystalIReportAlerts
   │  ├──cCrystalIReportEvent
   │  ├──cCrystalIReportObjects
   │  ├──cCrystalIRunningTotalFieldDefinition
   │  ├──cCrystalIRunningTotalFieldDefinitions
   │  ├──cCrystalISection
   │  ├──cCrystalISectionEvent
   │  ├──cCrystalISections
   │  ├──cCrystalISortField
   │  ├──cCrystalISortFields
   │  ├──cCrystalISpecialVarFieldDefinition
   │  ├──cCrystalISQLExpressionFieldDefinition
   │  ├──cCrystalISQLExpressionFieldDefinitions
   │  ├──cCrystalISubreportLink
   │  ├──cCrystalISubreportLinks
   │  ├──cCrystalISubreportObject
   │  ├──cCrystalISummaryFieldDefinition
   │  ├──cCrystalISummaryFieldDefinitions
   │  ├──cCrystalITableLink
   │  ├──cCrystalITableLinks
   │  ├──cCrystalITableQualifiers
   │  ├──cCrystalITextObject
   │  ├──cEdit_Mixin
   │  ├──Clear_Defaults_Mixin
   │  ├──Code_Description_Mixin
   │  ├──Code_Pick_List_mixin
   │  ├──Combo_Mixin
   │  ├──cXMLDOMCollectionMixin
   │  ├──cXMLDOMMixin
   │  ├──cXMLDOMNodeMixin
   │  ├──Data_List_mixin
   │  ├──DataFile_Help_Mixin
   │  ├──dbItemMixin
   │  ├──DefaultActionButton_Mixin
   │  ├──deo_delegate_mixin
   │  ├──DEO_Dependent_item_mixin
   │  ├──dfAuto_Locate_Mixin
   │  ├──DFCode_DEO_Mixin
   │  ├──DFEntry_Radio_Group_Mixin
   │  ├──DFLabel_Mixin
   │  ├──DFnavigate_mixin
   │  ├──DFRadio_Group_Mixin
   │  ├──Entry_CheckBox_Mixin
   │  ├──Entry_Client_mixin
   │  ├──Entry_Form_DS_mixin
   │  ├──Entry_Item_Mixin
   │  ├──Entry_Shadow_Mixin
   │  ├──Entry_View_Client_mixin
   │  ├──Extended_Deo_dfCombo_mixin
   │  ├──Extended_DEO_Mixin
   │  ├──Extended_DEO_Prompt_Mixin
   │  ├──Extended_Deo_Radio_mixin
   │  ├──Extended_DEO_Spin_Mixin
   │  ├──Extended_Deo_Status_Help_Mixin
   │  ├──External_Class_Mixin
   │  ├──find_edit_mixin
   │  ├──FloatingPopupMenu_Mixin
   │  ├──Help_Mixin
   │  ├──HtmlFormat_mixin
   │  ├──HtmlWrite_mixin
   │  ├──Label_Mixin
   │  ├──list_mixin
   │  ├──Mask_Form_Mixin
   │  ├──Modal_Mixin
   │  ├──Multi_Item_Shadow_Mixin
   │  ├──navigate_mixin
   │  ├──nesting_mixin
   │  ├──Non_Dependent_item_mixin
   │  ├──NonVisual_Container_Mixin
   │  ├──Panel_Mixin
   │  ├──pick_list_mixin
   │  ├──Print_Dialog_Mixin
   │  ├──Prompt_Button_Mixin
   │  ├──RemoteEntryMixin
   │  ├──ReportView_Mixin
   │  ├──RGB_Support_Temp_Mixin
   │  ├──Select_Mixin
   │  ├──Selection_List_DS_mixin
   │  ├──server_mixin
   │  ├──Shadow_Mixin
   │  ├──Single_Item_Navigate_Mixin
   │  ├──SpinForm_Mixin
   │  ├──Standard_Container_Mixin
   │  ├──Standard_Form_Mixin
   │  ├──Standard_Grid_Mixin
   │  ├──Standard_Object_Mixin
   │  ├──Standard_Select_Mixin
   │  ├──StatusHelp_Item_mixin
   │  ├──Tab_DEO_page_Mixin
   │  ├──Tab_Dialog_Mixin
   │  ├──Tab_Page_Mixin
   │  ├──Table_DS_mixin
   │  ├──Text_Window_mixin
   │  ├──TopMostMixin
   │  ├──TrackBar_Mixin
   │  ├──Validate_Mixin
   │  ├──verify_mixin
   │  ├──View_Dependent_item_mixin
   │  ├──Wide_List_mixin
   │  ├──WmlFormat_mixin
   │  └──WmlWrite_mixin
   ├──PrintDialog
   ├──Report [Abstract]
   │  └──Report_DS [Abstract]
   │     └──BasicReport
   │        ├──cWinReport2
   │        └──WinReport
   ├──StatusAsciiLog
   ├──StatusdbLog
   └──StatusPanel


Class: AboutDialog

Properties Events Methods Index of Classes

Used to create an About Dialog in an application

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------ModalPanel
---------------------------------AboutDialog

Library: Windows Application Class Library

Package: Dfabout.pkg

Description

The AboutDialog class is used to create a popup about dialog object. The object displays information about the application (title, version, copyright, author and a bitmap) which is determined by setting properties within this object. In addition, the dialog contains an additional edit area that automatically provides detailed information about your application and your environment.

The object is invoked by sending the popup_modal message to it.

All of the Visual DataFlex Samples contain an AboutDialog object. You create code this objects as follows:

Use DfAbout.pkg

Object oAbout is an AboutDialog
      Set ProductName to "Order Sample Application"
      Set Copyright   to "Copyright: 2004 Data Access Corporation"
      Set Author      to "Author: Data Access Worldwide"
End_Object

Procedure Activate_About
      Send Popup_Modal of oAbout
End_Procedure

If you use the standard the help pulldown include file named HelpA_pm.inc instead of Help_pm.inc your menu will contain an "About" option. Selecting this option, sends the message Activate_about to applications client area. As you can see in the above example, you should provide this method and use it to send Popup_Modal to your about object.

The AboutDialog Interface

There are only a few properties which will be set in an AboutDialog objecy. Those are:

Property Name | Description
ProductName | Name of application. If none provided, uses caption-bar title
Version | Version Line. If none provided, will be blank
CopyRight | Copyright Line. If none provided, will be blank
Author | Author name. If none provided, will be blank
Logo | Bitmap logo. If none provided, standard VDF bitmap is used.

Only one method is used with this object, Popup_modal. This method pops up the about dialog.

Review the Windows Order sample to see what the about dialog looks like in code and when running.

Note:The StdAbout.pkg is provided to provide acccess to a standard about dialog object. It provides a generic about package with no special information about the application's name, revision, copyright or author. It is used by simply adding the line "use StdAbout.pkg" inside of your client area object. The use of the stdabout.pkg package is no longer recommended. You are encouraged to create your own about object as shown in the example above.

Last Edited: June 22, 2005


Properties for AboutDialog

View property list in alphabetical order

Name | Description
Author | The author name
Copyright | The copyright line
Logo | The bitmap logo
ProductName | The name of application
Version | The version line
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for AboutDialog

View event list in alphabetical order

Name | Description
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for AboutDialog

View method list in alphabetical order

Name | Type | Description
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Close_Panel | Procedure |
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: AbstractFileDialog

Class: AbstractFileDialog (Abstract)

Properties Events Methods Index of Classes

Abstract class used to provide access to the Windows file dialog

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---AbstractFileDialog
------OpenDialog
------SaveAsDialog

Library: Windows Application Class Library

Package: File_dlg.pkg

Description

AbstractFileDialog is used to provide access to the Windows file dialog. Its sub-classes OpenDialog and SaveAsDialog should be used for sub-classing and instantiation.

Last Edited: April 22, 2005


Properties for AbstractFileDialog

View property list in alphabetical order

Name | Description
AllowReadOnly_State | Determines whether users without write access can select files that are read-only or in a read-only folder
CreatePrompt_State | Determines if a message box will ask users whether they want to create the entered filename, when such filename is not found
Dialog_Caption | Sets this object's caption
File_Name | Holds the full pathname of the file and can be considered a read-only property
File_Title | Holds the title of the file (i.e., without path)
FileMustExist_State | Specifies whether users can enter a file title that doesn't exist
Filter_Index | Determines which filter you would like this object's Filter combobox to start with
Filter_String | Holds the descriptions and filters that will be available to users
HideReadOnly_State | Determines whether the checkbox is hidden
Initial_Folder | Determines the starting point for this object
NoChangeDir_State | Restores the current directory to the original directory if the user switched the current directory while searching for files
OverwritePrompt_State | Specifies whether users should be prompted before selecting a file name that already exists
PathMustExist_State | Specifies whether users can enter a file path that doesn't exist
ShowFileTitle_State | Specifies whether the contents of the file_title property should be inserted into the dialog box as a default for selectin
TickReadOnly_State | Checks/un-checks the Read-only checkbox
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for AbstractFileDialog

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for AbstractFileDialog

View method list in alphabetical order

Name | Type | Description
Show_Dialog | Function | Determines how the dialog box is constructed and behaves
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: AbstractShapeControl

Class: AbstractShapeControl (Abstract)

Properties Events Methods Index of Classes

Abstract class used to demonstrate Visual DataFlex communicating with the Windows API

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------AbstractShapeControl
---------------------ShapeControl

Library: Windows Application Class Library

Package: Dfshape.pkg

Description

AbstractShapeControl is an abstract class used to demonstrate Visual DataFlex communicating with the Windows API. Its sub-class ShapeControl should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for AbstractShapeControl

View property list in alphabetical order

Name | Description
Shape_Back_Color | Maintains the RGB color of the object's background that is visible beyond the boundaries of the GDI object
Shape_Fill_Color | Maintains the RGB value of the "brush" to use to fill the object
Shape_Pen_Color | Maintains the RGB color value that the object's pen will use
Shape_Pen_Style | Specifies the style of pen that Windows will use to draw the object
Shape_Pen_Width | Maintains the width of the pen to use
Shape_Style | Determines which GDI object to draw in the container area
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for AbstractShapeControl

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for AbstractShapeControl

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: AbstractTreeView

Class: AbstractTreeView (Abstract)

Properties Events Methods Index of Classes

Abstract low level TreeView Class

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseListbox
------------------------List
---------------------------AbstractTreeView
------------------------------TreeView

Library: Windows Application Class Library

Package: Dftreevw.pkg

Description

This is an abstract class and is used by the sub-class TreeView.

Last Edited: November 21, 2004


Properties for AbstractTreeView

View property list in alphabetical order

Name | Description
CurrentTreeItem | Gets or sets the handle of the item that is currently selected
ExpandedOnceState | Returns a boolean value of true if hItem has been expanded since it was created
ImageListObject | Uses an ImageList control to supply the images that each item displays
ItemChildCount | Getting this property returns whether there are childitems
ItemData | Stores an application-specific value
ItemImage | Gets and sets the index of the regular image in the control's ImageList
ItemLabel | Sets label that is displayed alongside the image
ItemSelectedImage | Gets and sets the index of the selected image in the control's ImageList that you associated with the item
pbCancelEdit | Used in OnBeginLabelEdit and OnEndLabelEdit to cancel the editing of a treeview label
pbFullRowSelect | Enables full-row selection in the treeview
pbHotTracking | automatically highlights an item when the mouse hovers over it
pbShowTooltips | Determines if a tool tip should be displayed when the mouse hovers over a long tip
pbSingleExpand | Determines if item being selected will collapse if it was expanded, or expand if it was collapsed
piBackColor | Controls the color of the background of the treeview
piLineColor | Controls the color of the lines drawn in the treeview
piTextColor | Controls the color of text in the items of the treeview
TreeButtonsState | Determines if button will be displayed
TreeEditLabelsState | Supports in-line editing of the label
TreeIndentWidth | Governs the number of pixels that are used to indent child items from their parent items
TreeLevelDelimeter | Holds the character to use as a delimiter of tree levels
TreeLinesState | Determines if the control draws graphical lines between connecting items
TreeRetainSelState | Determines if item will still visibly indicate that it was the focused item, whenever this object loses the focus
TreeRootLinesState | Specifies whether graphical lines should be drawn to connect "Root Items"
TreeSortedState |
Inherited Properties from List
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Select_Count |
Select_State |
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Mode | Determines how item-level selections are processed
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for AbstractTreeView

View event list in alphabetical order

Name | Description
OnBeginDrag | Whenever a user instigates a drag operation, this event is fired
OnBeginLabelEdit | Fired just prior to the user starting in-line editing of the label
OnBeginRDrag | Whenever the user instigates a drag operation, this event is fired
OnDeleteItem | Whenever an item is deleted from the control, this event is fired
OnEndLabelEdit | Fired if the user completes the edit when user performs in-line editing of the label
OnGetDispInfo |
OnItemChanged | Fired whenever the current item has just changed
OnItemChanging | Fired whenever the current item is about to change
OnItemClick | Fired whenever a user clicks an item to make it become the current item
OnItemCollapsed | Fired whenever a parent item has just been collapsed and its children hidden
OnItemCollapsing | Fired whenever a parent item is about to be collapsed
OnItemDblClick | Fired whenever a user double-clicks an item
OnItemEnter | Fired whenever a user presses Enter on an item
OnItemExpanded | Fired whenever a parent item has just been expanded to display its child items
OnItemExpanding | Fired whenever an item is about to be opened
OnItemRClick | Sent when a user clicks on an item
OnItemRDblClick | Sent when a user double-clicks on an item
OnKeyDown |
OnSetDispInfo |
Inherited Events from List
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for AbstractTreeView

View method list in alphabetical order

Name | Type | Description
AddTreeItem | Function | Adds an entry to the treeview
DoDeleteItem | Procedure | Deletes an item
DoEnumerateTree | Procedure | Recurses the items in the control starting with the item you pass, hItem
DoEnumerateTreeUp | Procedure | Recurses the items in the control starting with the item you pass, hItem
InsertTreeItem | Function |
Inherited Methods from List
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Select_Count | Procedure Set |
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: AppClientArea

Class: AppClientArea (Abstract)

Properties Events Methods Index of Classes

Provides a client area to contain all of an application's views (MDI child dialogs)

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasemdiclient
------------------------MdiClientArea
---------------------------AppClientArea
------------------------------ClientArea

Library: Windows Application Class Library

Package: Dfaclnt.pkg

Description

AppClientArea is used to provide a client area to contain all of an application's views (MDI child dialogs). The container is placed within an MDI panel (AppPanel or subclass) and will contain MDI child dialogs (AppDialog or subclass thereof). Objects based on this class are automatically sized and support an interface to control various aspects of its child objects.

Sample

Object Pnl is an AppPanel
    Set Size to 200 250
    Set Label to "MyTest Panel"
    :
    Object ClientArea is an AppClientArea
        : Add MDI view objects
    End_object
    :
End_Object

Syntax

Object object_name is an AppClientArea
    :
    : Add MDI view objects
    :
End_object

Of Special Note

Three levels of programming classes are supported: basic (non-MDI, no support for tool bars or status bars), application (App... classes - MDI support, basic tool bar and tool-bar support), and high-level-application.

A proper MDI (Multiple Document Interface) application consists of an MDI Panel object (which contains and supports a menu bar, a tool bar, a status bar and a client area), an MDI client-area object which contains and supports child MDI dialogs or views. The App... classes (AppPanel, AppClientArea, AppDialog) provide the needed cooperative support to create an MDI application.

Although complete applications can be written using the App... classes, they are considered to be intermediate-level classes. A higher and more-powerful level of classes exists and it is expected that most applications will be written using these high-level classes (Panel, ClientArea, cToolBar, cStatusBar, MenuBar, View, and dbView).

Normally you will not set properties or send messages directly within an object of this class. Its size, location and characteristics are set by its parent panel object (AppPanel) either automatically or through the panel's public interface. Often messages sent from the panel will require the client area to direct these messages to its children. A number of these messages are predefined. This object can be instructed to do the following to all child view objects: minimize, restore, arrange all icons, cascade, tile, verify exit application, and notify exit application. If a custom process is required, the next_mdi_dialog message can used to retrieve the object ID of all child dialog objects.

The Panel's Client_ID Property

When an object of this class is created, it makes itself known to its container by setting the property client_id in its parent panel object. This will be set to the object ID of this object. This allows the AppPanel object to communicate with this object.

Last Edited: February 18, 2004


Properties for AppClientArea

View property list in alphabetical order

Name | Description
Inherited Properties from MdiClientArea
Bitmap | Displays a bitmap in an object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Inherited Properties from DfBasemdiclient
Scroll_Bar_Visible_State | Specifies whether this object is to display a scroll bar (or bars) when the content of the object exceeds this object's same-time display capacity
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for AppClientArea

View event list in alphabetical order

Name | Description
Inherited Events from MdiClientArea
OnKillFocus |
OnSetFocus |
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for AppClientArea

View method list in alphabetical order

Name | Type | Description
Next_Mdi_Dialog | Function | Provides a way to obtain the object ID of all views contained by this container
Inherited Methods from MdiClientArea
DoHtmlHelp | Procedure | Launches Compiled HTML Help
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Inherited Methods from DfBasemdiclient
Arrange_Icons | Procedure | Arranges the icons for all minimized views contained by this object
Cascade_Windows | Procedure | Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it
Switch_Next_View | Procedure | Switches the focus to the next view object in this object
Switch_Prior_View | Procedure | Switches the focus to the previous view object in this object
Tile_Windows_Horizontal | Procedure | Arranges this object's views from left to right across the top, and then down to the next line, also so arranged
Tile_Windows_Vertical | Procedure | Arranges this object's views from top to bottom down the left side, and then right to the next column, also so arranged
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: AppDialog

Class: AppDialog (Abstract)

Properties Events Methods Index of Classes

Extends the MDIDialog class to provide support with a level consistent with the App... classes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------MdiDialog
---------------------------AppDialog
------------------------------View

Library: Windows Application Class Library

Package: Dfadlg.pkg

Description

AppDialog is used to extend the MDIDialog class to provide support with a level consistent with the App... classes. An object of this class is registered with and cooperates with its parent client-area object and all other App... level objects (AppClientArea, MenuBar).

This class provides a "basic" (non-DEO) MDI view which may contain objects of basic classes (Container, Group, TabDialog, Form, Grid, Button, etc.) and may never contain data-aware objects (any of the db... classes), such as dbView, used to create DEO views.

This class is not normally used for instantiation. Use the subclass View or dbView instead.

Sample

Object MyClient is an AppClientArea

    Activate_View Activate_View1 for View1

    Object View1 is a AppDialog
        Set Label  to "My View1 Label"
        Set Size   to 120 280
        :
    End_Object

    Deferred_View Activate_View1 For ;
    ;
    Object View1 is a AppDialog
        Set Label  to "My View1 Label"
        Set Size   to 120 280
        :
    CD_End_Object

End_object

Syntax

Activate_View Activate_object_name for object_name

object object_name is a AppDialog
    Set Label to text
    Set Size to height length
    :
end_object

Deferred_View Activate_object_name for ;
;
object object_name is a AppDialog
    Set Label to text
    Set Size to height length
    :
CD_end_object

Of Special Note

Three levels of programming classes are supported: basic (non-MDI, no support for tool bars or status bars), application (App... classes - MDI support, basic tool bar and tool-bar support), and high-level-application.

The application classes provide integrated support between all App...-level components (AppDialog, AppClientArea, AppStatusBar, AppToolBar, and MenuBar). Accordingly, the AppDialog class registers itself with its parent client-area when it is created. This client-area object must be based on the AppClientArea class (or a sub-class).

A proper MDI (Multiple Document Interface) application consists of an MDI Panel object (which contains and supports a menu bar, a tool bar, a status bar and a client area), an MDI client-area object which contains and supports child MDI dialogs or views. The App... classes (AppPanel, AppClientArea, AppDialog) provide the needed cooperative support to create an MDI application.

Although complete applications can be written using the App... classes, they are considered to be intermediate-level classes. A higher and more-powerful level of classes exists and it is expected that most applications will be written using these high-level classes (Panel, ClientArea, cToolBar, cStatusBar, MenuBar, View, and dbView).

When an object of this class is created, it will register itself with its parent client area. This way, the client-area object has a method for sending messages to all MDI child objects.

Activating Views

Views are usually activated from the popup menu by sending a custom activate message to the client-area object. The custom message is defined by the command Activate_View or Deferred_View. Views may also be activated by sending the message Activate_view to the object.

Deferred Views

The Deferred_View command is used in conjunction with the CD_end_Object command to defer the creation of this object until it is activated. Deferring views will improve program-load time.

Application Exit Behavior

When an application is about to be exited, the client-area object will send two messages to each (registered) view. It sends the message get verify_exit_application to each view. If any view returns a non-zero value, the application will not be exited.

When the verify_exit_application function is called, the default behavior of all objects of this class is to call the view_changed function. If this function returns a non-zero, a verification message is displayed (changes exist.) and the user is given the chance to halt the program exit.

If all views allow the application to be closed, the client area will send the message notify_exit_application to all views. By default, this does nothing. It provides a hook to which you can attach any system-closedown operations you desire. It cannot be used to stop the program exit. The program will then be closed.

Last Edited: August 1, 2003


Properties for AppDialog

View property list in alphabetical order

Name | Description
Inherited Properties from MdiDialog
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for AppDialog

View event list in alphabetical order

Name | Description
Notify_Exit_Application | Called when an application is about to be closed
Verify_Exit_Application | Sent by the client area to verify that an application may be exited
Inherited Events from MdiDialog
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for AppDialog

View method list in alphabetical order

Name | Type | Description
Activate_View | Procedure | Activates the view
Inherited Methods from MdiDialog
Close_Panel | Procedure |
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: AppPanel

Class: AppPanel (Abstract)

Properties Events Methods Index of Classes

Provides a top-level window for applications that is independent of all other windows

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------BasicPanel
---------------------------AppPanel
------------------------------Panel

Library: Windows Application Class Library

Package: Dfpanel.pkg

Description

AppPanel container class provides a top-level window for applications that is independent of all other windows. This class is an extension of the BasicPanel class and provides support for an MDI (Multiple-Document Interface) application. This class supports and controls MDI child components (a menu bar, a tool bar, a status bar and a client area). The descendant class, Panel, is the class normally used for instantiation. By default, an object of this class has icons for maximize and minimize, a resizable border, system-menu icon, and a caption bar.

Sample

Object Pnl is an AppPanel
    Set Size to 200 250
    Set Label to "MyTest Panel"
    :
    Object ClientArea is an AppClientArea
        : Add Mdi view objects
    End_object
    :
End_Object

Syntax

Object object_name is an AppPanel
    Set Size to Height Width
    Set Label to CaptionText
    :
    : Add MenuBar object
    : Add Tool bar object
    : Add Client area object
    : Add Status-bar object
    :
End_object

Of Special Note

Three levels of programming classes are supported: basic (non-MDI, no support for tool bars or status bars), application (App... classes - MDI support, basic tool bar and tool-bar support), and high-level-application.

A proper MDI (Multiple Document Interface) application consists of an MDI Panel object (which contains and supports a menu bar, a tool bar, a status bar and a client area), an MDI client-area object which contains and supports child MDI dialogs or views. The App... classes (AppPanel, AppClientArea, AppDialog) provide the needed cooperative support to create an MDI application.

Although complete applications can be written using the App... classes, they are considered to be intermediate-level classes. A higher and more-powerful level of classes exists and it is expected that most applications will be written using these high-level classes (Panel, ClientArea, cToolBar, cStatusBar, MenuBar, View, and dbView).

Child component IDs

It is this object's job to coordinate activity between its various child components. In order to do this, this object must know if a component exists and what its object ID is. When a child AppClientArea, AppToolBar, or AppStatusBar is created, it registers itself with its parent (the object of this class) by setting the pertinent property in this object. These properties are Client_id, Toolbar_id and StatusBar_ID, respectively. These objects can be used by all objects within this object (via delegation) to coordinate activity between components. For example, entry objects will request status help by getting the StatusBar_ID of this object and sending the message to that status-bar object.

Controlling Components

This object automatically controls the size and placement of its components (menu bar, tool bar, status-bar, client-area). As components are added or removed from the desktop, this object handles the resizing and relocating of all components as required.

In addition, this object supports a number of properties and messages that control attributes and behaviors of the components. It may toggle the visibility of the tool bar and the status bar. It may also arrange the view objects within the client area (cascade, tile, minimize all, restore all).

Many of these messages are sent by other component objects to this object. For example, a popup menu choice may toggle the status bar's visibility by sending the toggle_statusBar message. This message will delegate to this object, where it will be acted on. Similarly, the popup menu may determine the status of the status bar by getting the StatusBar_state property (again by delegating to this object).

Exiting the Application

When a program is about to be closed, several messages are sent to this object. First, a verification function (verify_exit_application) is sent. It is the responsibility of code in this object to determine if it is appropriate to exit the application and return a zero value to close, or a non-zero value to abort the close. It meets this responsibility by sending this message to its client-area object. The client-area object will, in turn, send this message to all of its child view objects. This process allows all views in an application to verify that it is appropriate to exit the application. If any of these returns a non-zero value, the exit will not occur.

Once it has been determined that the application can be closed, a notification message is sent to this object (notify_exit_application) indicating that the program will be closed. This object sends this message to the client area, which in turn sends this message to all views. This ensures that all views are notified when an application is about to be closed. This allows each view to take whatever steps are necessary for a proper closedown.

Last Edited: August 1, 2003


Properties for AppPanel

View property list in alphabetical order

Name | Description
Auto_Activate_State | Determines whether object will activate automatically after it has been created
Auto_Arrange_Icons_State | Determines if icons are rearranged each time this object is resized
Client_Scrollbar_State | Determines if a scroll bar should appear when a contained view's size or placement causes it to exceed the display capacity of its client area
StatusBar_State | Determines if object will display a status bar
ToolBar_State | Determines if the object will display its tool bar
Inherited Properties from BasicPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id | The ID of the panels's client-area object
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id | The ID of the panel's status-bar object
Toolbar_Id | The ID of the panel's tool-bar objec
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for AppPanel

View event list in alphabetical order

Name | Description
Notify_Exit_Application | Received when an application is about to be exited
Verify_Exit_Application | Called when an exit-application request has been made
Inherited Events from BasicPanel
OnActivateApp | Sent when the panel and, therefore, the application is activated
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp | Sent when this object is deactivated
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for AppPanel

View method list in alphabetical order

Name | Type | Description
Cascade_Windows | Procedure | Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it
Minimize_all_Windows | Procedure | Minimizes all views within the client area
Restore_all_Windows | Procedure | Restores all minimized windows (views) in the client area
Tile_Windows_Horizontal | Procedure | Horizontally tiles all windows (views) in the client area
Tile_Windows_Vertical | Procedure | Vertically tiles all windows (views) in the client area
Toggle_Statusbar | Procedure | Toggles the value of the statusBar_state property
Toggle_Toolbar | Procedure | Toggles the value of the Toolbar_state property
Inherited Methods from BasicPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Close_Panel | Procedure |
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Array

Properties Events Methods Index of Classes

Used to create a collection of values which are stored and accessed via item numbers

Hierarchy

cObject
---Array
------cCLIHandler
------cCollection
------cDFBtrDrvHandler
------cSQLConnection
------cSQLHandleManager
------cSQLStatement
------Set
------ValidationTable

Library: Common (Windows and Web Application) Class Library

Package:

Description

The Array class is a general storage device. It is used to store all data types. Its size grows dynamically to accommodate the storage requirements. Data elements in the array are accessed by an integer index.

For most purposes, developers should use the much more efficient native arrays built into the Visual DataFlex language.

An array may store any type of data in any item. It is up to the program to know what the data-type of each item should be.

Each data item is accessed with the Value property. The number of elements in an array is maintained in the Item_count propery. Array items may be sorted used the the Sort_items method.

Sample

Object oArray1 is an Array
End_Object

Procedure DoFillArray
     Integer iCounter

     Send Delete_Data of oArray1
     For iCounter from 0 to 100
           Set Value of oArray1 iCounter to (string(iCounter ) * "name"))
     Loop
End_procedure

Procedure DoShowArray
     Integer iCounter iItems
     String sValue

     Get Item_Count of oArray1 to iItems
     For iCounter from 0 to (iItems-1)
           Get Value of oArray1 iCounter to sValue
           showln sValue
     loop
End_Procedure

Last Edited: June 20, 2005


Properties for Array

View property list in alphabetical order

Name | Description
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Array

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Array

View method list in alphabetical order

Name | Type | Description
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseData_Set

Class: BaseData_Set (Abstract)

Properties Events Methods Index of Classes

Abstract class providing methods for accessing databases in a program

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseData_Set
------DataSet

Library: Common (Windows and Web Application) Class Library

Package: BaseData_Set.pkg

Description

BaseData_Set is an abstract class used to provide methods for accessing databases in a program. Its sub-class DataDictionary should be used for sub-classing and instantiation.

Last Edited: December 2, 2005


Properties for BaseData_Set

View property list in alphabetical order

Name | Description
Can_Delete | Determines if a delete operation of the current record is permitted
Cascade_Delete_State | Determines how a delete should be affected by the existence of child-file records that relate to the record being deleted
Changed_State | Determines whether DEOs attached to this object have changed and/or whether a related parent record has changed
Client_File | Returns the number of the table at the passed-in position in this object's client table list
Client_File_Count | Returns the number of files in this object's client file list
Current_Record | The number of the record most recently retrieved from the database
Data_Set_Client | Returns the object id of the DataDictionary object (DDO) at position iItem in this object's container DDO list
Data_Set_Client_Count | Returns the number of DataDictionary objects (DDOs) in this object's container DDO list
Data_Set_Server | Returns the object id of the DataDictionary object (DDO) at position iItem in this object's server DDO list
Data_Set_Server_Count | Returns the number of DataDictionary objects (DDOs) in this object's server DDO list
Data_Set_User_Interface | Returns the object id of the data entry object (DEO) at position iItem in this object's user-interface DEO list
Data_Set_User_Interface_Count | Returns the number of data entry objects (DEOs) in this object's user-interface DEO list
Entry_Permissive_State | (Obsolete) Determines whether changing of parent record relationships is permitted.
In_Use_State | Determines whether this object has at least one active user-interface object or one of this object's containers is in use
Main_File | Identifies the table managed by this Data Dictionary class/object
No_Delete_State | Determines whether delete operations via this object are permitted
No_Relate_State | Determines whether relate operations will be executed after find operations by this object
Ordering | Specifies the index which should be used for all find operations
pbAutoFillFromFirst | Allows child DDOs to auto-fill from the last record
pbInheritConstraints | Determines if a main DDO should inherit its constraints (finding filters) from its parent DDOs
Read_Only_State | Determines whether save or delete operations will occur in this object's main table
Server_File | Returns the number of the table at the passed in position in this object's server-file list
Server_File_Count | Returns the number of table in this object's server-file list
Should_Save | Can be used to determine if a DDO has changed.
Should_Save_Row | Determines if a DDO is changed according to dbGrid "row" logic
Smart_Filemode_For_Lock | Determines the locked file mode setting for tables participating in save or delete operations
Smart_Filemode_For_No_Lock | Determines the unlocked file mode setting for tables that should not participate in save or delete operations
Smart_Filemode_State | Governs whether this object can use file-locking optimization for its tables
Which_Data_Set | Returns object id of object owning specified table
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseData_Set

View event list in alphabetical order

Name | Description
Attach_Main_File | Performs attach command on main file
Backout | Hook for performing operations when editing or deleting a new record
Clear_Main_File | Performs clear command on main table of this object
Creating | Hook for performing operations required when creating a new record
Delete_Main_File | Performs the actual delete of the record
Deleting | Hook for performing operations when deleting a record
New_Current_Record | (Obsolete) Hook for performing operations during save, delete, and clear operations
OnNewCurrentRecord |
Relate_Main_File | Does nothing by default. Called after the normal relate on the main table has been executed.
Reset_Filemodes_For_Lock | Temporarily resets the file modes of the Main_File of this object and of any updated DataDictionary objects for a save/delete operation
Save_Main_File | Saves the main file
Update | Hook for performing operations when saving a record
Validate_Delete | Guards execution of delete operation
Validate_Delete_No_Cascade | Guards against deleting records with existing child records
Validate_Save | Used to enforce business rules and integrity rules
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseData_Set

View method list in alphabetical order

Name | Type | Description
Add_Client_File | Procedure | Adds a table to this object's related-child list
Add_Server_File | Procedure | Adds a table to this object's related-parent list
Add_User_Interface | Procedure | Adds the passed in hoDEO to the list of data entry objects (DEOs) for this object
Attach_Server | Procedure | (Obsolete) Use DDO_Server instead
Clear | Procedure | Clears all files owned by this object
Clear_All | Procedure | Clears all files owned by this object and all connected server DataDictionary objects (DDOs)
Constrain | Procedure | Defines constraint set for this object
CurrentRowId | Function | Returns the RowId of the current record
Detach_Server | Procedure | Disconnects this object and the specified DataDictionary object (DDO), where this object was the client of that DDO server
Establish_Find_Direction | Procedure | Initializes the constrained find commands to perform searches using the given parameters
Find_By_Recnum | Procedure | Finds record in specified table with record number equal to the passed in record number
FindByRowId | Procedure | Finds record in specified table with record identity equal to the passed RowId and updates the DDO structure
HasRecord | Function | Determines if the DataDictionary object (DDO) has a current record
Locate_Next | Procedure | Finds the next logical record using the passed in find mode, file, and index specified in a prior Establish_Find_Direction invocation
Operation_Not_Allowed | Procedure | Executes the error command with the passed in error number. Intended for augmentation
Read_By_Recnum | Procedure | Finds record in specified tabile with record number equal to the passed in record number
ReadByRowId | Procedure | Finds record in specified table with record identity equal to the passed RowId without updating or altering the DDO structure
Rebuild_Constraints | Procedure | Reconstructs constraints for a DDO
Refind_Records | Procedure | Checks to see if the record in the File-Buffer is the same as the record in the DDO-Field-Buffer and refinds the record if needed
Remove_Client_File | Procedure | Removes a table from this object's container-file list
Remove_Server_File | Procedure | Removes a table from this object's server-file list
Remove_User_Interface | Procedure | Removes a table from this object's data entry object (DEO)-list
Request_Assign | Procedure | Causes the Refresh message to be sent to all data entry objects for this object and its client and server DataDictionary objects as appropriate
Request_Clear_File | Procedure | Performs the Clear command on the specified table of the data-server structure
Request_Delete | Procedure | esponsible for deleting a record in the DDO for the main_file, updating all parent DDOs (and tables) and possibly deleting all child records
Request_Entry_Update | Procedure | Sends entry_update to all DEOs of the data set and DEOs of servers of the data set as required to store changes to record buffers
Request_Find | Procedure | Finds on specified table using given find mode and index
Request_Read | Procedure | Finds on specified table using given find mode and index
Request_Relate | Procedure | Performs a relate on the specified table without initializing the done-array
Request_Save | Procedure | Saves all changes in DEOs attached to this object or to any DDO that is a server of this object directly or indirectly
Request_Superfind | Procedure | Performs superfind on the designated table by the Main_Index of the designated field and notifies all connected DataDictionary objects (DDOs) of the result
Request_Validate | Function | Request_Validate sends validation messages to all DDO Field's that will participate in the upcoming save
Validate_Constraints | Function | Validates this object's constraints against the record buffer's current content
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomAttribute

Class: BaseXmlDomAttribute (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling an attribute node

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomAttribute
---------cXMLDOMAttribute

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomAttribute provides interface support for handling XML attribute nodes. Its sub-class cXmlDomAttribute should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomAttribute

View property list in alphabetical order

Name | Description
psName | Contains the attribute name
Value | Contains the attribute value
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomAttribute

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomAttribute

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomcDataSection

Class: BaseXmlDomcDataSection (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling cDataSection nodes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomCharacterData
---------BaseXmlDomTextNode
------------BaseXmlDomcDataSection
---------------cXMLDOMCDATASection

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomcDataSection provides interface support for handling XML cDataSection nodes. Its sub-class cXmlDomcDataSection should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomcDataSection

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomCharacterData
piLength | Returns the number of characters in the data string
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomcDataSection

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomcDataSection

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomCharacterData

Class: BaseXmlDomCharacterData (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling character/text nodes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomCharacterData
---------BaseXmlDomComment
---------BaseXmlDomTextNode

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomCharacterData provides interface support for handling XML character data nodes. Its sub-classes cXmlDomComment, cXmlDomTextNode and cXmlDomcDataSection should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomCharacterData

View property list in alphabetical order

Name | Description
piLength | Returns the number of characters in the data string
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomCharacterData

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomCharacterData

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomComment

Class: BaseXmlDomComment (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling comment nodes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomCharacterData
---------BaseXmlDomComment
------------cXMLDOMComment

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomComment provides interface support for handling XML element nodes. Its sub-class cXmlDomComment should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomComment

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomCharacterData
piLength | Returns the number of characters in the data string
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomComment

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomComment

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomDocument

Class: BaseXmlDomDocument (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling an XML document

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomDocument
---------cXMLDOMDocument

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomDocument provides interface support for handling an XML document. Its sub-class cXmlDomDocument should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomDocument

View property list in alphabetical order

Name | Description
pbAsync | Indicates whether asynchronous download is enabled
pbPreserveWhiteSpace | Indicates whether whitespace will be preserved in the document
pbResolveExternals | Contains the external resolution state of the XML parser for this document
pbValidateOnParse | Returns the validation state of the parser
psURL | Returns the URL of the most recent XML document that contained an error
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomDocument

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomDocument

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomDocumentFragment

Class: BaseXmlDomDocumentFragment (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling an XML document fragment

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomDocumentFragment
---------cXMLDOMDocumentFragment

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomdocumentFragment provides interface support for handling an XML document fragment. Its sub-class cXmlDomdocumentFragment should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomDocumentFragment

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomDocumentFragment

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomDocumentFragment

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomDocumentType

Class: BaseXmlDomDocumentType (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling Document Type (DTD) nodes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomDocumentType
---------cXMLDOMDocumentType

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomdocumentType provides interface support for handling XML Document Type (DTD) nodes. Its sub-class cXmlDomdocumentType should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomDocumentType

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomDocumentType

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomDocumentType

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomElement

Class: BaseXmlDomElement (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling element nodes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomElement
---------cXMLDOMElement

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomElement provides interface support for handling XML element nodes. It's sub-class cXmlDomElement should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomElement

View property list in alphabetical order

Name | Description
AttributeValue | Gets and sets attributes in an element
psTagName | The element name
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomElement

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomElement

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomEntity

Class: BaseXmlDomEntity (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling Entity nodes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomEntity
---------cXMLDOMEntity

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomEntity provides interface support for handling XML entity nodes. Its sub-class cXmlDomEntity should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomEntity

View property list in alphabetical order

Name | Description
psNotationName |
psPublicId |
psSystemId |
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomEntity

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomEntity

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomEntityReference

Class: BaseXmlDomEntityReference (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling Entity Reference nodes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomEntityReference
---------cXMLDOMEntityReference

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomEntityReference provides interface support for handling XML entity reference nodes. Its sub-class cXmlDomEntityReference should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomEntityReference

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomEntityReference

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomEntityReference

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomImplementation

Class: BaseXmlDomImplementation (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling Implementation nodes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomImplementation

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomImplementation provides interface support for handling XML Implementation nodes. This abstract class is curerntly not used by an sub-class.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomImplementation

View property list in alphabetical order

Name | Description
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomImplementation

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomImplementation

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomNamedNodeMap

Class: BaseXmlDomNamedNodeMap (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling named node map nodes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNamedNodeMap
------cXMLDOMNamedNodeMap

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomNamedNodeMap provides interface support for handling XML named node maps. Its sub-class cXmlDomNamedNodeMap should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomNamedNodeMap

View property list in alphabetical order

Name | Description
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomNamedNodeMap

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomNamedNodeMap

View method list in alphabetical order

Name | Type | Description
Reset | Function |
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomNode

Class: BaseXmlDomNode (Abstract)

Properties Events Methods Index of Classes

The ultimate XML abstract superclass designed to handle all XML node types

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomAttribute
------BaseXmlDomCharacterData
------BaseXmlDomDocument
------BaseXmlDomDocumentFragment
------BaseXmlDomDocumentType
------BaseXmlDomElement
------BaseXmlDomEntity
------BaseXmlDomEntityReference
------BaseXmlDomNotation
------BaseXmlDomProcessingInstruction
------cXMLDOMNode

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomNode is the superclass of all data storage components for XML, both for the document data and its description, whether in DTD or Schema format. A BaseXmlDomNode represents a single node in a Document Object Model tree representation of a document. Sub-classes of this class are used to support the each specific type of node (e.g. element, attribute).

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomNode

View property list in alphabetical order

Name | Description
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomNode

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomNode

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomNodeList

Class: BaseXmlDomNodeList (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling node lists

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNodeList
------cXMLDOMNodeList

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomNodeList provides interface support for handling XML node lists. Its sub-class cXmlDomNodeList should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomNodeList

View property list in alphabetical order

Name | Description
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomNodeList

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomNodeList

View method list in alphabetical order

Name | Type | Description
Reset | Function |
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomNotation

Class: BaseXmlDomNotation (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling notation nodes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomNotation
---------cXMLDOMNotation

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomNotation provides interface support for handling XML notation nodes. Its sub-class cXmlDomNotation should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomNotation

View property list in alphabetical order

Name | Description
psPublicId |
psSystemId |
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomNotation

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomNotation

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXMLDomParseError

Properties Events Methods Index of Classes

Provides support reporting parsing errors in an XML document

Hierarchy

cObject
---BaseXMLDomParseError

Library: Common (Windows and Web Application) Class Library

Package:

Description

When an XML parsing error occurs, the information for that error is obtained by creating a ParseError object and using information from that error object to report the error conditions. When error reporting is complete, the ParseError object is destroyed.

A typical error reporting cycle might be:

  • Create a ParseError object
  • Report the error using properties of the ParseError object
  • Destroy the ParseError object

The message Get phXMLErrorObject is used to create the error object. It should be sent to the your main XML document object (cXmlDomDocument) and it will return an object handle that points to a newly-created object based on the BaseXmlDomParseError class. The error object supports the following read-only properties:

Constant | Meaning
piErrorCode | Returns an error code
piFilePos | Returns the absolute character position in the file where the error occurred
piLine | Returns the number of the line in the document that contains the error
piLinePos | Returns the character position of the error within the line in which it occurred
psReason | Returns the text description of the source and the reason for the error, and can also include the URL of the DTD or SCHEMA and the node within it that that corresponds to the error
psSrcText | Returns the full text of the line that contains the error, or an empty string if the error cannot be assigned to a specific line
psURL | Returns the URL of the most recent XML document that contained an error

Sample

A simple error handler might look like the following procedure. This creates the error handling object, collects information about the error and directs this information to the VDF error handler.

Procedure XMLError
    String sDescr
    String sReason
    Integer hoParseErrorObject

    // 1. Create the error object
    Get phXMLErrorObject of hoXML To hoParseErrorObject

    // 2. Report the error using properties of the parse-error-object
    Get psReason of hoParseErrorObject to sReason
    Move ("Error loading XML file: " * sReason) to sDescr
    Error DFERR_OPERATOR sDescr

    // 3. Destroy the parse-error-object
    Send Destroy of hoParseErrorObject
End_Procedure

This procedure could be used as follows:

Get LoadXMLDocument of hoXML to bOK
If not bOK Begin
   Send XMLError
   procedure_return
End

You can customize your error reporting procedure as needed. As mentioned above, the cXmlDomDocument class supports the method Get phXMLErrorObject, which is used to create an error object. It also supports a method named BasicParseErrorReport, which can be used to generate a standard error response. The code for this method is displayed below. You may find this to be a useful starting point when creating your own error handlers.

Procedure BasicParseErrorReport
    String sProblem
    String sLinePosition
    String sDescr
    String sReason
    String sSource
    Integer hoParseErrorObject
    Get phXMLErrorObject To hoParseErrorObject
    Move ("Cannot load " + (psDocumentName(Self)) + ;
               "."+character(13)+character(10)) To sProblem
    Move ("A Parsing Error has occurred on line " + ;
        string(piLine(hoParseErrorObject)) + " at pos " + ;
                  string(piLinePos(hoParseErrorObject)) + "."+ ;
                  character(13)+character(10) ) To sLinePosition
    Move ("Reason: " + (psReason(hoParseErrorObject))) To sReason
    Move ("Source: " + (psSrcText(hoParseErrorObject))) To sSource
    Move (sProblem + sLinePosition + sReason + sSource) To sDescr
    Error DFERR_OPERATOR sDescr
    Send Destroy of hoParseErrorObject
End_Procedure

If you use this error handler, remember that you must send the BasicParseErrorReport to the XML object (which is where it is defined).

Get LoadXMLDocument of hoXML to bOK
If not bOK Begin
   // this will print out a basic error report
   Send BasicParseErrorReport of hoXml
   procedure_return
End

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXMLDomParseError

View property list in alphabetical order

Name | Description
piErrorCode | Returns an error code
piFilePos | Returns the absolute character position in the file where the error occurred
piLine | Returns the number of the line in the document that contains the error
piLinePos | Returns the character position of the error within the line in which it occurred
psReason | Returns the text description of the source and the reason for the error
psSrcText | Returns the full text of the line that contains the error, or an empty string if the error cannot be assigned to a specific line
psURL | Returns the URL of the most recent XML document that contained an error
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXMLDomParseError

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXMLDomParseError

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomProcessingInstruction

Class: BaseXmlDomProcessingInstruction (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling Processing Instructions (PIs) nodes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomProcessingInstruction
---------cXMLDOMProcessingInstruction

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomProcessingInstruction provides interface support for handling XML processing instruction nodes (PIs). Its sub-class cXmlDomProcessingInstruction should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomProcessingInstruction

View property list in alphabetical order

Name | Description
psTarget |
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomProcessingInstruction

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomProcessingInstruction

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BaseXmlDomTextNode

Class: BaseXmlDomTextNode (Abstract)

Properties Events Methods Index of Classes

Abstract XML class for handling text nodes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomCharacterData
---------BaseXmlDomTextNode
------------BaseXmlDomcDataSection
------------cXMLDOMTextNode

Library: Common (Windows and Web Application) Class Library

Package:

Description

The BaseXmlDomTextNode provides interface support for handling XML tex nodes. Its sub-classes cXmlDomTextNode and cXmlDomCDataSection should be used for sub-classing and instantiation.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

Last Edited: November 21, 2004


Properties for BaseXmlDomTextNode

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomCharacterData
piLength | Returns the number of characters in the data string
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BaseXmlDomTextNode

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BaseXmlDomTextNode

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BasicPanel

Properties Events Methods Index of Classes

Provides a top-level window for applications that is independent of all other windows

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------BasicPanel
---------------------------AppPanel

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Container_Mixin Panel_Mixin Standard_Object_Mixin Label_Mixin dfAuto_Locate_Mixin Shadow_Mixin Bitmap_Support_Mixin Modal_Mixin DefaultActionButton_Mixin RGB_Support_Temp_Mixin Help_Mixin

Description

BasicPanel container class provides a top-level window for applications that is independent of all other windows. While BasicPanel objects can be used for creating simple non-MDI programs (usually test programs), objects are usually not based directly on this class. The descendant class, Panel, is normally used for instantiation. By default, an object of this class has icons for maximize and minimize, a resizable border, system-menu icon, and a caption bar.

Sample

Object MyPanel is a BasicPanel
    Set Size to 100 150
    Set Label to "My Test Panel"

    Object F1 is a form
        Set Location to 10 70
        Set Size to 13 40
        Set Label to "Name:"
    End_Object

    Object Dlg1 is a Container3D
        Set Size to 30 130
        Set Location to 25 10

        Object F2 is a form
            Set Location to 10 70
            Set Size to 13 30
            Set Label to "Id:"
        End_Object

    End_Object

End_Object

Send Activate to (MyPanel(self))
Start_UI

Syntax

Use dfbase

 Object object_name  is a BasicPanel
    set size to height width
    set locate_mode to  LocateMode
    set label to title

    set Border_style to borderMode
    set Maximize_icon to true|false
    set Minimize_icon to true|false
    set location to vertical horizontal
    set Caption_bar to true|false
    set Icon to to IconFileName
    set SysMenu_icon to true|false
    :
End_Object

Of Special Note

A typical application in Visual DataFlex will consist of a single main panel that contains visual components that are bound within this panel. These components (which will comprise most of your application) consist of menus, tool bars, status bars, and a client area. The client area will contain a number of views (dialogs that are bound within the client area). This describes a typical Windows MDI (Multiple-Document Interface) application structure. Additional panels may be used which are not bound to the main panel (i.e., they can be moved off the main panel). These tend to be popup objects and will be non-modal tool panels or modal panels. Specialized classes, all descendants of the DFBasePanel class, exist for main, tool, and modal panels (Panel, ToolPanel, and ModalPanel). The Panel class (a subclass of the AppPanel, which is a subclass of BasicPanel) is used to create a main-panel object. Although objects can be based on the BasicPanel class, its main purpose is that of an intermediate class.

Caption Bar Label

The text that will appear in a panel's caption bar is set with the Label property.

This label will also appear in the Windows task list. Normally your main-panel object should be the only entry in the Windows task list. If you need to create a panel that does not appear on the task list, you should base your object on the ToolPanel or ModalPanel class.

Resizing a Panel

When an object of this class is resized by users, this object sends the onResize message to itself. This message is supplied with no definition as a "hook" procedure to use when some action, such as resizing child objects, is desired on resizing of this object.

Locating a Panel

The location of a panel is determined by the properties location and locate_mode. The defaut "smart" locate_mode will cause the panel to be centered on the screen unless a location is explicitly set. When no location is set, the panel is centered-usually a good default.

Tool Bars, Status Bars, Client-area IDs

Properties are defined in this class to hold the object IDs of a child tool bar, status, bar and client area. None of these components is directly supported by this class and their property values should all be zero. These properties exist so that child objects may obtain these IDs and react accordingly. For example, a form placed inside this object will see that there is no status bar object for this object and not attempt to display status help. Full support for tool bar, status bars and client areas is added to AppPanel, which adds an MDI-support layer. This capability is inherited in turn by Panel.

Exiting the Application

When a program is about to be closed, several messages are sent to the program's panel object. First, a verification function (verify_exit_application) is sent. It is the responsibility of the panel to determine if it is appropriate to exit the application and return a zero value to close, and a non-zero value to stop the close. Once it has been determined that the application can be closed, a notification message is sent to the panel (notify_exit_application) indicating that the program will be closed. It is the responsibility of the panel to perform any special closedown activities. Both of these messages do nothing in this class. These behaviors are augmented in the AppPanel and Panel subclasses.

Last Edited: December 2, 2005


Properties for BasicPanel

View property list in alphabetical order

Name | Description
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id | The ID of the panels's client-area object
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id | The ID of the panel's status-bar object
Toolbar_Id | The ID of the panel's tool-bar objec
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BasicPanel

View event list in alphabetical order

Name | Description
Notify_Exit_Application | Sent when the application is about to be ended
OnActivateApp | Sent when the panel and, therefore, the application is activated
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp | Sent when this object is deactivated
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Verify_Exit_Application | Sent when there has been a request made to close the application
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BasicPanel

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Close_Panel | Procedure |
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BasicReport

Properties Events Methods Index of Classes

Supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it

Hierarchy

cObject
---Report
------Report_DS
---------BasicReport
------------cWinReport2
------------WinReport

Library: Windows Application Class Library

Package: Dfrpt.pkg

Description

The BasicReport class supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it. Objects of this class support all types of constraints including parent-table, full access to indexes with multi-level subsection totalling, access to child-table records by parent-table indexes, and complete control of pagination. They are capable of using the database services (finding, deleting, saving, constraints) of data-dictionary objects.

This class provides display of a Working message, a Cancel/Continue interruption option, and a prompt for end-of-screen. It also supports the maintenance of a status-log file for progress reports and/or errors that arise during unattended (batch) operations.

The Command Interface

The BasicReport class uses a number of commands created for use by this class and its subclasses. Those commands are:

  • Begin_Constraints / End_Constraints (obsolete)
  • Output_Imagenum
  • Output_Pagecheck
  • Output_wrap_pagecheck
  • Procedure_Section
  • Report_Breaks
  • Report_Data_Set
  • Report_Index
  • Report_Main_File
  • Zero_Subtotals

Usage

use dfrpt

Object ReportName is a BasicReport ;
    [main_file MainTableName [by IndexNumber [break var1 [... varN]]]]

    report_main_file MainTableName
    report_index {by| down} {IndexNumber | table.field}
    report_breaks var1 [... varN]
    report_data_set data_set

    begin_constraints
        constrain ...
        :
    end_constraints

    procedure_section sectionName [as imageName] [lines]
        print ...
        :
        output_pageCheck
    end_procedure

    procedure_section ...
        :
    end_procedure
end_object

Argument Explanation

Constant | Meaning
object_name | The name of the object
MainTableName | The name of the main database table being reported on
IndexNumber | Identifies the index of MainTableName to use for ordering output
table.field | Identifies the field of MainTableName whose Main Index is to be used for ordering output
varN | The variable or expression, a change in the value of which is to trigger a break at Level N
sectionName | The predefined name of an optional functional section of the object. There may be one section each for any or all of report_header, page_header, page_top, page_title, subHeader_initN, subHeaderN, body, page_total, page_footer, page_bottom, report_footer, filler, subTotalN, and total
imageName | The name of the image to be used by each functional section
lines | The number of lines that must remain usable on the current page to prevent triggering of a page break before output of imageName
DSOname | The name of the DataDictionary or DataSet object through which this object accesses the database. Also the initial value of this object's server property

Of Special Note

This class supports creation of objects for outputting data from or modifying data in, the database. When used with DDOs, they can also support batch updating of the database. They can also be used with DDOs where it is desired to make use in the report of business rules for the table(s) in question that are embodied in existing DDOs and subclasses.

This class produces report objects with all the facilities commonly needed in reports. This includes a display on the screen to show at all times while the report is running, that it is running. The same display offers a means to interrupt the report (a keypress), and upon being interrupted, then offers the options to abandon the report or to resume it. To support unattended operations, this class supports a status-log file for error reports and/or status messages that are generated during the unattended process.

Objects of this class can, and should, be nested for any of a variety of special requirements, such as conditional execution of reports, use of an index of a parent table with records of a child table, multiple executions of reports and so on. Nesting one report within another automatically constrains the records selected in the nested report's (child) table to those related to by the record in the outer report's (parent) table buffer.

The internal syntax with which this object is defined is closely patterned after that used with the predecessor DataFlex Report Macro, which this class replaces. All the capabilities of the Report Macro are supported in this class, along with many additional ones. This object uses several, but not all, of the global variables maintained and used by the Report Macro.

Finally note that if this object has no server assigned to it, all of the record finding will be handled by the report instead of the DSO. While it is theoretically possible to mix DDO and non-DDO reports in a nested report structure, this is not advised.

This class uses output images, unlike GUI report classes. Its output is always in a single mono-spaced font. It cannot output to the screen or the printer directly; all output must be to a file for later printing or display. It can format output for any output device.

Objects of this class should be encapsulated in a manner similar to that recommended for views (groups of DEOs), and accessed in a similar manner (through global messages). A program may have as many report objects and report "views" in it as desired.

Commands Used By BasicReport

The following commands are used by BasicReport:

  • Begin_Constraints / End Constraints (obsolete)
  • Output_Imagenum
  • Output_Pagecheck
  • Output_wrap_pagecheck
  • Procedure_Section
  • Report_Breaks
  • Report_Data_Set
  • Report_Index
  • Report_Main_File
  • Zero_Subtotals

Begin_Constraints / End_Constraints

Thesa are obsolete commands. You should use the OnConstrain event in its place

This is the same as the command used by DDOs. It is essentially a command of convenience. It gives you a place to place your constraints while ensuring that any built-in constraints (nesting constraints) are respected. You could actually write a constrain procedure which would accomplish the same thing. These two examples are identical:

Begin_Constraints
    Constrain Vndr.Status eq 'A'
End_Constraints

Procedure Constrain
    constrain Vndr.Status eq 'A'
    Forward send constrain
End_Procedure

Because the begin_constraints-end_constraints commands actually create the constrain procedure, you cannot place both a begin_constraints-end_constraints and a Procedure constrain in the same object or class.

Output_Imagenum

This outputs the image represented by image_number. This command is used by the output_imageNum procedure.

Output_Pagecheck

This command does a remaining-page-space check and then outputs image, if specified or, if not, the image specified in the preceding procedure_section command. If there is insufficient space left on the page for image or (if specified) lines lines, a new page will be started. This command will almost always be placed inside a procedure_section.

When no parameters (image [lines]) are passed, the image that was named in the procedure_section command will be output. If no lines height was specified, the pagecheck will be based on the length of the image. This will be the most common usage of this command. If a lines height was named in the procedure_section command, the pagecheck will be based on that length.

Note that there is an output_pagecheck command and an output_pagecheck procedure. When the command is expanded, it sends the message. The command was created to make the Report Package easier to program.

Output_wrap_pagecheck

This command performs a pagecheck and an output on an image that contains a print_wrapped field. The wrapped fields will be word-wrapped and printed in as many lines as is required to print the entire text. A field that is print-wrapped is created by using the DataFlex print_wrap command. Page breaks will be handled as they are needed. Note that an image is required with this command.

Procedure_Section

This command defines the start of a procedure section. It is similar to the predecessor Report Macro's section command. The procedure_section command allows you to:

  • Define a procedure section for your report (header, footer, subheader, body, etc).
  • Assign an image to this procedure section. This image is autopaged, and can be used by the output_pagecheck command.
  • Optionally determine the number of lines that should be used by the output_pagecheck command.

Section_name must be one of the following keywords. Each of these is described above in the section on Procedures:

Page_Top
Report_Header
Page_Header
Page_Title
SubHeader_Init1..n
SubHeader1..n
Body
SubTotal1..n
Total
Page_Total
Page_Footer
Report_Footer
Page_Bottom

If the as image parameter is not used, then the command will use an image named section_name (i.e., procedure_section body will attempt to use an image named body). Since the Report Package supports multiple report objects per program, you are advised to always use the as image option.

If the as image option is not used and there is no Image section_name, then no image is defined, and this command acts the same as a procedure command. This is valid and is often used with subHeader_init procedure sections and any section that is not image-based.

The procedure_section command is a command of convenience. You could gain the same functionality with a procedure command with some extra commands. For example, these two examples are actually identical:

Example 1

Procedure_Section Body as VndrBody
    forward send body
    Print Vndr.Name
    Output_PageCheck
End_Procedure

Example 2

Procedure Body
    Integer Output_Lines OutPut_Image
    forward send body
    Move VndrBody.LINES to Output_Lines
    Move VndrBody.N     to Output_Image
    AutoPage VndrBody
    Print Vndr.Name
    Output_PageCheck
End_Procedure

This example should also explain how the output_pagecheck command works with no parameters-it uses the values of the local variables output_image and output_lines.

In the above examples, the output_pagecheck statements could have been replaced with either of these two statements:

output_pageCheck vndrbody.N vndrbody.Lines

output_pageCheck output_image output_lines

Report_Breaks

This command defines the breakpoints needed in a report and is the same as using the break parameter in the report object-creation statement. The report_breaks command is the more-flexible approach because it may be used in class construction. In addition, when using the break parameter, you cannot define a break that is a function local to the report object you are creating. This doesn't work:

Object aReport is a basicReport Break (aFunction(Self))

This does work:

Object R is a basicReport
    Report_Breaks (F(self)

The breakpoints can be just about anything. They can be a table.field (as in the Report Macro), they can be a variable or a window, or they can be a built-in or a user-defined function.

Report_Breaks (Left(Vndr.Name, 1)) Vndr.Name

Report_Breaks (G_Func(Desktop, Vndr.Id))

Report_Breaks (L_Func(Self, Vndr.Due))

The report_breaks command actually creates a custom function named test_breakpoints. Therefore, when used in a class, the report_breaks command must not be placed in a procedure or function, but should be placed directly inside the class. The following example shows how a basicReport subclass should be created using the various report_???? commands.

Class V_Report is a basicReport

    Report_Breaks (left(Vndr.name, 1)) Vndr.Name

    Procedure Construct_Object
        Forward send Construct_Object
        Report_Main_file Vndr
        Report_Index by Vndr.Name
    End_Procedure
    :
End_Class

Report_Data_Set

This command determines which DDO will serve this report object. It does this by setting the server property to the DDO's object ID. The server property may also be set in the report object's creation statement with the using option, or it may be set by setting the server property.

The following examples are all identical:

Object VndrReport is a basicReport Using (Vndr_DS(self))

Object VndrReport is a basicReport
    Report_Data_Set (Vndr_DS(self))

Object VndrReport is a basicReport
    Set Server to (Vndr_DS(self))

Report_Index

This command sets the index of the main_file to be used by the report and the direction the index should be traversed. It does this by setting two properties: ordering and find_down_state. This may also be accomplished by placing this command's parameters in the report-object-creation statement, or by directly setting the properties.

The report_index command is the most-flexible approach because it can be used inside of class construction and it can used with either an index number or with a table.field whose main index should be used.

Examples

Report_Index BY 2

Report_Index DOWN Vndr.Name

Report_Index BY IntVar

If the report_index command is used in a class, remember that it must be placed inside a procedure or function (most likely Procedure construct_object). Also note that this command (and the associated properties) may be used and changed at runtime.

Report_Main_File

This command determines the main table for a report. It does this by simply setting the main_file property to the df_filename's filenumber. This property may also be set by the report object's creation statement with the main_file file_name option, or it may be set by setting the main_file property.

The following examples are all identical:

Object VndrReport is a basicReport Main_File Vndr

Object VndrReport is a basicReport
    Report_Main_File Vndr

Object VndrReport is a basicReport
    Set Main_File to Vndr.File_number

The report_main_file command (or setting the main_file property) are more flexible than the command-line main_file option because they can be used in both object and class definitions.

If the report_main_file command (or a set main_file ... statement) are used in a class, remember that it must be placed inside a procedure or function (most likely Procedure construct_object). Also note that the main_file property may be set and changed at runtime.

Zero_Subtotals

This object does not zero sub-totals before a report is run. This means that if you cancel a report in the middle and restart without leaving the program, the subtotals may be wrong. Zero_subtotals zeros the subtotal accumulators of all image windows named. This command should be executed as part of a report's initialization, possibly in the starting_report function. It is a good idea to zero the subtotal accumulators of any image that uses a subtotal. You can find all subtotals by doing a search of your program for all subtotal commands.

Function Starting_Report Returns Integer
    Zero_SubTotals SubTotal2.2 SubTotal2.3 SubTotal1.2
    Zero_SubTotals VndrTotal VndrDue VndrPaid
End_Function

Last Edited: December 16, 2004


Properties for BasicReport

View property list in alphabetical order

Name | Description
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button
Display_Error_State |
Output_Device | Handles the name of the output device
Report_Caption | Contains the text that will appear in the status panel's caption bar
Report_Message | An additional message area that will appear below the report_title in the status panel
Report_Status_Panel |
Report_Title | A centered title that appears in the status panel
Status_Log_Id | Object ID of status-log object
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs
Inherited Properties from Report_DS
Server | Contains the object ID of this object's server
Inherited Properties from Report
Assigned_Channel |
Cancelled_State | Setting this true will cancel a report
Child_Rpt_State | Set true if the current Report object is nested
Current_Rec | (Obsolete) Contains the record number of the current valid record found
Find_Down_state | Determines if an index should be traversed in forward or reverse order
Find_Mode | Maintains the current finding mode
Footer_Lines | Contains the number of lines in the page_bottom image plus the page_footer image plus the page_total image
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function
Has_Children_Rpt_State | Is set true if other reports are nested inside this report object
Last_Rec | (Obsolete) Contains the record number of the last selected record found
Main_File | Contains the filenumber of the file which the report will use for finding records
Main_Report_Id | Contains the object ID of the outer report
New_Page_State | Set true when a new page is needed
No_Constrained_Find_State | Determines if constrained record finding should be disabled
No_Finding_State | Determines how the Report object will find records
No_PageCheck_State | Set true when the Report object is processing a new page
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found
Num_Breaks | Returns the number of breaks in a report
Ordering | Contains the index number which will be used for finding records
Page_Count | Keeps track of the current page number
Page_End | Determines how many lines on a page are allowed before a page break will occur
Page_End_State | If this property is set true below the forward send statement in the starting_main_report procedure, then the next page_check will cause an end-of-page/new-page sequence
Page_Feed | Used by the formfeed procedure
Page_Footer_Lines | The number of lines in the page_footer image
priCurrentRec | Contains the RowId of the current valid record found
priFoundRec | Contains the RowId of the record found by the find_rec function
priLastRec | Contains the RowId of the last selected record found
Rec_Count | Contains the number of records found for the current report
Refind_for_SubTotal_State | Ensures that the subtotal is processed with the last valid record for that break level
Report_Channel | Determines which output channel will be used for your report output
Report_Footer_Lines | The number of lines in the report_footer image
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing
Sub_Totaling_State | Set true when the Report object is processing subtotals or totals
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BasicReport

View event list in alphabetical order

Name | Description
Ending_Main_Report | Augmented to print/preview the report if AutoOutput_State is set to true
Error_Report | Sent whenever an error is generated
onError | Provided as a hook to handle custom error reporting
Report_Interrupt | Called when the status panel's Cancel button has been pressed
Starting_Main_Report | Called only if the current report is an outer report
Inherited Events from Report
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property
Body | Called once for every record selected for the report to provide processing for record data (if any) not used for subheaders and subtotals
Ending_Report | This handler is called at the end of every report
Final_Formfeed |
OnConstrain |
Page_Bottom | The last thing printed on every page
Page_Footer | Printed after page_total on every page except the last page
Page_Header | Called after page_top on every new page except the first
Page_Title | Called on every new page after report_header or page_header
Page_Top | Called first at the top of each new page
Page_Total | Called on every new page and is printed as the first part of a page break at the bottom of each page
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found
Report_Footer | Printed after page_total on the last page of the report
Report_Header | Called only on the first page of the report, after page_top
Selection | Validates a record
Starting_Report | Called at the start of every report
SubHeader_Init1..n | Called for every break level (n) for which you define a SubHeader_init1..n procedure section in your program
SubHeader1..n | Called for every break level (n) for which you define a subHeader procedure section in your program
SubTotal1..n | Called for every break level (n) for which you define a subTotal procedure section in your program
Total | Called once at the end of a report after the final subtotals are output
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BasicReport

View method list in alphabetical order

Name | Type | Description
End_Log | Procedure | Sends an end-log message to the log object
Error_Log_Status | Procedure | Called by error_report if status_log_state is true
Log_Status | Procedure | Sends passed message to the log object
Start_Log | Procedure | Sends a start-log message to the log object
Update_Status | Procedure | Send this message to update the action area of the status panel
Inherited Methods from Report_DS
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO
Request_Save | Procedure | If sent, this saves the current record
Inherited Methods from Report
Formfeed | Procedure | Handles formfeeds
Output_ImageNum | Procedure | Outputs the image represented by ImageNum
Run_Report | Procedure | Sends a message to the report object telling it to start the report with internal finding
Start_Report | Function | Augmented to check the server property and if the property is non-zero (and a DSO exists), to establish a client-server link between the report object and the DSO
WriteLn | Procedure | Outputs the string message to the current output channel
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BitmapContainer

Properties Events Methods Index of Classes

Provides a means for enabling users to select bitmap graphic files to display in programs

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------BitmapContainer
---------------------------dbBitmap

Library: Windows Application Class Library

Package: Dfbitmap.pkg

Description

BitmapContainer is used to provide a means for enabling users to select bitmap graphic files to display in programs.

Usage

Object aBitMapContainer is a BitMapContainer
    Set Size to height width
    Set Location to column row
    Set Bitmap to "bitmapname.bmp"
    Set Allow_Select_Bitmap_State to True | False
    Set Dialog_Caption to "Title for common-file-dialog object"
    Set Initial_Folder to "initial file directory"
End_object

Of Special Note

Each object of this class supports the display of a single bitmap. You can control whether users may select the bitmap from files in a directory by setting the allow_select_bitmap_state property. If this property is true, a common open-file dialog will be displayed when this object is double-clicked to support the selection from the directory named in the initial_folder property. The double_click sends the message Invoke_Select_Bitmap. This dialog will display a title consisting of the value of the dialog_caption property, in which you can display the name of the current directory, describe the subject matter of the filenames displayed, or the like.

Last Edited: November 21, 2004


Properties for BitmapContainer

View property list in alphabetical order

Name | Description
Allow_Select_Bitmap_State | Determines if users will be able to browse a list of the bitmap files in a directory and select one for display
Changed_State | Determines if one or more of the child objects has changed
Dialog_Caption | Specifies the legend (Select a bitmap file by default) to be displayed at the top of the common open-file dialog that users will interact with
Initial_Folder | Specifies the path of the directory in which bitmap filenames will be searched for and displayed by the common file-open dialog
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BitmapContainer

View event list in alphabetical order

Name | Description
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BitmapContainer

View method list in alphabetical order

Name | Type | Description
Invoke_Select_Bitmap | Procedure | Public message causing bitmap selection dialog to appear and if selected displays the bitmap
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Broadcaster

Properties Events Methods Index of Classes

Provides grouping and message-relaying services for a set of objects

Hierarchy

cObject
---Array
------Set
---------Broadcaster

Library: Common (Windows and Web Application) Class Library

Package: brdcster.pkg

Description

The Broadcaster class is used to provide grouping and message-relaying services for a set of objects. Broadcasters are provided to allow you to create a specialized set of objects that will act in concert with any received messages. The Broadcaster-class object provides an alternative to assigning parentage to a set of objects in order to allow the broadcasting of messages to each child object.

Usage

use brdcster

object object_name is a broadcaster
    :
end_object

Argument Explanation

Constant | Meaning
object_name | The name of the object.

Alternatively, you may use the global function make_broadcaster to create an instance of this class.

Of Special Note

Broadcasting

Instances of this class are intended to hold a set of object identifiers for the purpose of broadcasting messages to all listed objects. Object identifiers may be contained in more than one broadcaster at a time. For example, the following code creates a broadcaster, adds three object identifiers to its elements, and then causes the broadcaster instance to send the message destroy_object to the three objects referenced:

use brdcster
object object_name is a broadcaster
    send add_element (existing_object(self))
    :
    send add_element (existing_object(self))
end_object
set broadcast_state of (example_object(self)) to true
send destroy_object to (example_object(self))

Note: Re-sending of messages only occurs if broadcast_state is true. If broadcast_state is false, a broadcaster object is equivalent to a set object. Also, when broadcast_state is true, it is no longer possible to retrieve the object_name _id through the object_id function. To reference a broadcaster object by its ID, use the make_broadcaster function when creating it.

Last Edited: December 20, 2005


Properties for Broadcaster

View property list in alphabetical order

Name | Description
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Broadcaster

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Broadcaster

View method list in alphabetical order

Name | Type | Description
Inherited Methods from Set
Add_Element | Procedure | Adds an element to the set if the element does not already exist
Find_Element | Function | Returns the index of an element in a set or -1 if not found
Remove_Element | Procedure | Removes specified value from the set if present, and compacts remaining values
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: BusinessProcess

Properties Events Methods Index of Classes

Contains and executes the statements to perform a batch process on an application's database tables

Hierarchy

cObject
---BusinessProcess

Library: Common (Windows and Web Application) Class Library

Package: Batchdd.pkg

Description

To contain and execute the statements to perform a batch process on an application's database tables, together with the data dictionaries containing the business rules applicable to the process.

Sample

This sample batch process creates ten test customers. The process cannot be interrupted. If an error occurs during the save, an error message will be displayed and the process will stop.

Object CreateCustomers is a BusinessProcess

    Set Process_Title To "Let's add some test customers"

    Object Customer_DD is a Customer_DataDictionary
    End_Object

    Procedure onProcess
        Integer i iServer
        Boolean bNotOK

        Move (Customer_DD(Self)) to Server#

        For i from 1 to 10
            Send Update_Status ("Adding Test Customer #" *String(i) *"of 10"))
            Send Clear of iServer
            // add any data we need into our DD Buffer
            Set Field_Changed_Value of iServer FIELD Customer.Name to "Test"
            Set Field_Changed_Value of iServer FIELD Customer.Etc  to "Etc."
            Get Request_Validate of iServer to bNotOk
            If (bNotOk) Procedure_Return
            Send Request_Save of iServer
            If (Err) Procedure_Return
        Loop
    End_Procedure

End_Object

Syntax

Filename.bp file:
Object name is a BusinessProcess
    //Set properties
    :
    //Create process's DDO structure
    :
    Procedure onProcess
        :
    End_Procedure
End_Object

End of file filename.bp
Filename.vw file:

Object oReportName is a ReportView
    :
    #INCLUDE filename.bp // include the batch-process plug-in name

    //User-interface object

    Procedure DoIt // assume some button sends this
        Send doProcess of ObjectName
    End_Procedure
End_Object

End of file filename.vw

BPOs can also be added to normal views to handle special batch-update conditions. Just plug in the BP and send DoProcess to it.

Object oViewName is a dbView

    #INCLUDE filename.bp // include batch-process plug-in name

    Procedure DoIt // assume some button starts this
        Send doProcess of (Name(Self))
    End_Procedure
     :
    //Create view's DDO structure
    :
    //Create DEOs
    :
End_Object

OnProcess vs. DoProcess

It is important to understand the difference between the OnProcess and DoProcess message. It is expected that you will start a BPO process by sending the message DoProcess to the object. This is how the process is started. However, you will very rarely ever augment or change the DoProcess procedures - that is the job of OnProcess.

OnProcess is the event that we expect you to customize to actually run the process. That is where you drop your custom code. You will never explicitly send the message OnProcess. That is what DoProcess is used for.

If you are calling OnProcess directly, very little will work properly. When you do this, you are not allowing the BPO to initialize itself before starting and to de-initialize itself upon completion. You will get no status panel, no error redirection (which is crucial), and no status logging.

Restated:

  • Create your custom process by placing code within the OnProcess procedure. By default, this procedure does nothing. It should never be called.
  • Once the BPO is created, its processing is started by sending DoProcess. It will rarely be augmented.

Of Special Note

You create a business process exactly like you create a report view. The business process is just a different type of plug-in. Business processes automatically support status panels (which optionally support cancellation) and error redirection handling (during processing, all errors are redirected to the BusinessProcess object). BPOs also support a message protocol for logging process activity.

A BPO consists of a non-visual object that contains a DDO structure and the logic to run the process. Normally a process is called by sending the message DoProcess. This is a predefined message that intializes the object (start_process), sends the event message onProcess, and then closes the process (end_process).

The heart of the process is the onProcess procedure. It is the main processing loop. By default it does nothing and it is expected that you will place your process code in this procedure. You should try to process all database activity through the DDO structure. To do this, you must send messages to the appropriate DDO. These messages will most-likely include:

  • Clearing: Send Clear or Clear_All
  • Finding: Send Find, Request_Assign, or Request_Find
  • Saving: Get Request_Validate and send Request_Save
  • Deleting: send Request_Delete
  • Field changing: Get/Set Field_Value, Field_Changed_Value, etc.

Validation

By default, request_save does not perform field validation. You must get Request_Validate to the DDO to perform field validation. Request_save is then sent if the field validation was OK (returned 0). Note the validate_save is always called as part of request_save. We separate the field validation from saving because this is a batch process and you may wish to optimize this process by not performing field validation on every field in every DDO that is part of the save. We provide the ability to do the validation, but give you the flexibility to skip it.

Error Handling

During a batch process, all errors are redirected to the BPO. When an error occurs, the message Error_Report is sent to the BPO. Depending on how several properties are set, the BPO will handle the error in different ways. If the property display_error_state is true, the error will get redirected to the standard Visual DataFlex error object, which will cause the error message to be displayed in a message box. Since you normally do not want interactive error messages displayed during a batch process, this property defaults to false. If a status-log object is defined and status_log_state is true, errors will get logged in the status file. Error_Report does this by sending the message Error_Status_Log. If status logging is not enabled, the program code could send this message itself. In addition, the message onError is sent. You can use this to handle custom errors any way you want. Finally, errors set the err indicator true. You can use this information within your batch-processing loop to determine how and whether a process should continue.

Interrupting a Process

Since you control the processing loop, you can control whether and how the process should be canceled. A message is provided which you may use that will check for a cancel (from the status panel) or an error (from the error). A complete interface is provided to support this.

Status Logging Status logging refers to a defined interface for sending information to a status-logging object. Various properties and methods are created within BPOs to support easy status logging. The program must set the property Status_log_Id to the object ID of the status-log object. It can then set the property Status_log_State to true. When true, a log entry is sent when a BPO process is started, a BPO process is ended, and when an error occurs. Additional status lines can be sent by sending the message log_status passing the text to be logged.

The actual interface to the status-log object consists of two public messages: Log_Status and Log_Clear. It is the status-log object's responsibility to do something useful with these messages. The prototype log object provided with Visual DataFlex (found in StatLog.pkg and StatFLog.pkg) writes a log entry consisting of date, time, and comment to a simple table. It is expected that you may wish to expand upon this logging process by extending the table (e.g., adding a user name), its indexes, by moving the log file to another filelist entry, or by expanding the interface (e.g., add ability to review the log, sort by user name). The log object was purposely kept simple. It does however provide basic multi-user logging.

Last Edited: December 16, 2004


Properties for BusinessProcess

View property list in alphabetical order

Name | Description
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button
Display_Error_State |
Error_Count | Keeps track of errors encountered during process
main_dd | Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function
Process_Caption | Caption-bar text for status panel
Process_Message | Message that appears in status panel
Process_Title | Title that appears in status panel
Status_Log_Id | When Log_Status is sent, it directs the message to status_log_ID
Status_Log_State | Determines if automatic status logging occurs
Status_Panel_State | Determines if a status panel should be presented
Status_Params |
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for BusinessProcess

View event list in alphabetical order

Name | Description
onError | Provided as a hook to handle custom error reporting
OnProcess | Where you put your processing code
Process_Interrupt | Called by Cancel_Check if a user response is required to determine if a process should be canceled
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for BusinessProcess

View method list in alphabetical order

Name | Type | Description
Cancel_Check | Function | Determines whether the process should be interrupted
DoProcess | Procedure | Starts the batch process
End_Log | Procedure | Sends an end-log message to the log object
End_Process | Procedure | Ends the batch process
End_Status | Procedure | Ends the status panel
Error_Log_Status | Procedure | Called by error_report if status_log_state is true
Log_Status | Procedure | Sends passed message to log object
Resume_Status | Procedure | Resumes a status panel that has been stopped
Start_Log | Procedure | Sends a start-log message to the log object
Start_Process | Procedure | Starts the batch process
Update_Status | Procedure | Can be sent to update a status panel's progress
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Button

Properties Events Methods Index of Classes

To create visual representations of keys or buttons that, when pressed by users, produce a specific action with an immediate response

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseButton
------------------------DfBasePushButton
---------------------------Button

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Object_Mixin Label_Mixin Single_Item_Navigate_Mixin Bitmap_Support_Mixin RGB_Support_Temp_Mixin Help_Mixin Shadow_Mixin

Description

The Button class is used to create visual representations of keys or buttons that, when pressed by users, produce a specific action with an immediate response. Cancel and OK are typical uses of Buttons.

Sample

Object OkButton is a Button
    Set Location to 30 30
    Set Label to "&OK"
    Set Status_Help to "Print the report."

    Procedure onClick
        delegate Send Print_Report
    End_Procedure

End_Object

Object CancelButton is a Button
    Set Location to 30 85
    Set Label to "&Cancel"
    Set Status_Help to "Close current panel"

    Procedure onClick
        send close_Panel
    End_Procedure

End_Object

on_Key Key_Alt+Key_O Send KeyAction of OkButton
on_Key Key_Alt_Key_C Send KeyAction of CancelButton

Syntax

Use windows

Object object_name is a Button
    Set Location to row column
    Set Label to text
    Set enabled_state to true|false
    Set Status_Help to text

    Procedure onClick
        :
    End_Procedure

End_Object

On_Key Key_alt+Key_ch send KeyAction of object_name

Of Special Note

This class is a subclass of the DfBasePushButton class and therefore inherits all its properties and capabilities. It has been extended to support help, status help display, object shadowing, and label display.

Processing a Button Event

When a button is pressed (with the keyboard or the mouse), the event message onClick is sent. Therefore, a button will almost always contain a custom definition of the onClick message. The KeyAction message sends the onClick message if the button is active and it is enabled (enabled_state is true). This provides a simple way to bind an accelerator key to a button action. The key will do whatever the button normally does but will only do it if the button is active and enabled.

Creating Default-Action Buttons

Often a Windows panel will contain a "default" button. The action associated with this button is executed when users press the Enter key from any other non-button object within the panel. When a default button is enabled, it is visibly highlighted to indicate that pressing the Enter key will execute the button's action.

In Visual DataFlex we refer to such a button as being the default-action button. Within a DataFlex dialog object (a view, dbView, ModalPanel, dbModalPanel, ReportView, etc.), a single default action button may be assigned. When this dialog has the focus pressing, the Enter key from within any control except another button will cause the default button's click behavior to get executed. Normally this executes the button's onClick message. A default button's border will be highlighted when it is "active" (when pressing Enter from within another object will execute the default button behavior).

A default-action button is defined by setting the desired button's default_state property to true. Only one button within a dialog may have this property set to true. Setting this to true in one button sets this property to false in all others. (Technically, this is not a property at all, but from a usage perspective it is best to think of it as such.).

Object OK_bn is a Button
    Set Label to "&Ok"
    Set Location to 115 152
    Set default_state to TRUE

    Procedure OnClick
         Send Save_record
    End_Procedure

End_Object

Shadowing

Shadowing refers to the process of making an object or an item unavailable for data entry. Usually the appearance of a shadowed object is changed in some way to indicate its unavailability. This class supports object shadowing. Accordingly, objects of this class will be shadowed whenever an ancestor object is shadowed or when the object is explicitly shadowed by setting its enabled_state property to false.

Labels

The label of a button object refers to the text within this object.

Button Size

The default size of this object is the standard size of a Windows button (14 x 50). You only need to set the size of this object if you wish to create a non-standard-sized button.

Last Edited: December 2, 2005


Properties for Button

View property list in alphabetical order

Name | Description
Bitmap | Displays a bitmap in an object
CurrentButtonState |
Default_State | Determines if the button is designated as the default-action button for its dialog
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
FlatState | Determines if the button will have a flat appearance or 3d appearance
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
MultiLineState | Allows the text in Label property to wrap onto multiple lines if it cannot be displayed in one line
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Button

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnClick | Sent by this object every time it is pressed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Button

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
KeyAction | Procedure | Sent to a button, usually via an on_key, to perform the same action as when the button is pressed
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cAnimation

Properties Events Methods Index of Classes

Displays an AVI animation clip

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------cWinControl
---------------------cAnimation

Library: Windows Application Class Library

Package: cAnimation.pkg

Description

The cAnimation control displays an AVI animation clip. An AVI clip is a series of bitmap frames like a movie. cAnimation controls can only display AVI clips that do not contain audio.

One common use for an animation control is to indicate system activity during a lengthy operation. This is possible because the operation thread continues executing while the AVI clip is displayed. For example, the Find dialog box of Windows' Explorer displays a moving magnifying glass as the system searches for a file.

An animation control can display an AVI clip originating from either an uncompressed AVI file or from an AVI file that was compressed using run-length (BI_RLE8) encoding.

Note: The AVI file must not have a sound channel. The capabilities of the animation control are very limited and are subject to change by Microsoft.

Usage

Several animation files are provided and you can access these with the peAnimation property. To use other AVI files, use the psFileName property. Use the pbActive property to play and stop the animation.

Use the pbTransparent property to play the animation clip with a transparent background, and the pbAutoSize property to automatically size the control to the size of the frames of the animation clip. You can control the number of repetitions that the animation plays with the piRepetitions property.

You can also use the DoOpen and DoClose methods to open and close an animation file. The DoPlay and DoStop methods to play and stop the animation.

When an animation clip starts to pay, the OnStart event is sent. When the clip finishes playing, the OnStop event is sent.

The pbIsOpen property is used to determine if an animation file was opened successfully.

Sample

Object oDeleteFiles is a cAnimation
    Set Location To 5 5
    Set pbTransparent To True // play "transparently"
    Set pbAutoSize To True // size the control from the AVI
    Set piRepetitions To 0 // repeat indefinitely

    Procedure DoDeleteFiles
        Set peAnimation To aviFileDelete // copy \Bitmap\FileDel.AVI file to workspace
        Set pbActive To True // open and start playing
        // ToDo: add code to delete records here...
        // The Info_Box will keep the AVI on screen long enough to see it in our sample
        Send Info_Box "Click 'OK' button to continue"

        Set pbActive To False // stop playing
        Set peAnimation To aviNone // close the animation
    End_Procedure

End_Object

Object oDelete_bn is a Button
    Set Location to 100 120
    Set Label to "Delete Selected Files"
    Procedure onClick
        Send DoDeleteFiles of oDeleteFiles
    End_Procedure
End_Object

See Also

Info_Box

Last Edited: November 23, 2004


Properties for cAnimation

View property list in alphabetical order

Name | Description
pbActive | Determines if animation file can be played
pbAutoSize | Determines if animation frame is automatically sized
pbIsOpen | Determines whether the animation file is open
pbTransparent | Allows you to match an animation's background color to that of the control's Color property, creating a "transparent" background
peAnimation | Built-in animation files
piRepetitions | Determines the number of times that an animation file will repeat, when it is played
psFileName | Set this property to the name of an animation file on disk that you want to play
Inherited Properties from cWinControl
pbEnabled | Enables the control to take user input
pbVisible | Makes a control visible or invisible
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cAnimation

View event list in alphabetical order

Name | Description
OnStart | Sent whenever the animation starts to play
OnStop | Sent whenever the animation stops playing
Inherited Events from cWinControl
OnMouseDoubleClick | Received whenever a mouse button is double-clicked on the control
OnMouseDown | Received whenever a mouse button is pressed on the control
OnMouseMove | Received whenever the mouse cursor moves over a control
OnMouseUp | Received whenever a mouse button is released on the control
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cAnimation

View method list in alphabetical order

Name | Type | Description
DoClose | Procedure | Closes the animation file that you have opened
DoOpen | Procedure | Opens an AVI file
DoPlay | Procedure | Plays the animation file that you must have already opened
DoStop | Procedure | Stops the currently playing animation file
Inherited Methods from cWinControl
DoRecreateWindow | Procedure | Recreates a window
DoUpdateWindow | Procedure | Updates a window if it needs repainting
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cApplication

Properties Events Methods Index of Classes

Encapsulates methods and properties that are essential to the running of your application

Hierarchy

cObject
---cApplication

Library: Common (Windows and Web Application) Class Library

Package: cApplication.pkg

Description

The cApplication class encapsulates methods and properties that are essential to the running of your application. It is the central location that handles the help system, the Workspace, the command-line, version information and coordinates access to the Registry for storing window sizes, etc.

In your application, you create an object of this class like this:

Use cApplication.pkg

Object oApplication is a cApplication
    // Define properties for Registry access:
    Set psCompany To "Data Access Worldwide"
    Set psProduct To "Visual DataFlex 12.0 Examples"
    Set psVersion To "12.0"
    Set psProgram To "Order"

    // Define the help system:
    Set peHelpType To htHtmlHelp
    Set psHelpFile To "Order.chm"

    // Determine if application should use the Registry for settings:
    Set pbPreserveEnvironment To True

    // Should the Enter key act like the Tab key:
    Set pbEnterKeyAsTabKey To True
End_Object // oApplication

A standard cApplication object like this will open a workspace file named Config.ws. As long as you have a workspace file named Config.ws in the same directory as your compiled program (.exe file), the application will load and run. If you wish to customize your workspace file by naming it something other than Config.ws, you can do so by either changing the value of psAutoOpenWorkspace or augmenting the OnCreate event.

Your application will automatically use the Registry to preserve the size and locations of its windows. Use the pbPreserveEnvironment property to determine if you want to preserve your settings after the program exits. The settings that are stored in the Registry are stored per-user under HKEY_CURRENT_USER. You determine the exact subkey name that is used by defining the psCompany, psProduct, psVersion and psProgram properties.

You can write data to the Registry for your application using the WriteString, WriteDWord and WriteBinary methods. You can read the data back using ReadString, ReadDword and ReadBinary. To test if a Value exists, use ValueExists.

You determine which help engine to use by setting the peHelpType property: You can use HTML help by setting it to htHtmlHelp; use WinHelp by setting it to htWinHelp. The help file that will be used is determined by setting the psHelpFile property.

If you want your application to use the Enter key as though it were the Tab key, then set the pbEnterKeyAsTabKey property to True.

To gain access to the embedded cWorkspace object that controls the Workspace, use the phoWorkspace property.

To gain access to the command-line arguments that were passed to your program, use the embedded cCommandLine object, which exposes its object handle through the phoCommandLine property.

To query embedded Version Information, use the embedded cVersionInfo object, which exposes its object handle through the phoVersionInfo property.

Note:A global variable, ghoApplication, is automatically created that contains the object-handle of the application object that you create

See Also

cWorkspace | cVersionInfo | cCommandLine

Last Edited: July 26, 2006


Properties for cApplication

View property list in alphabetical order

Name | Description
pbEnterKeyAsTabKey | Determines whether the Enter key should act like the Tab key
pbPreserveEnvironment | Determines whether program information is automatically saved and restored
peHelpType | Determines which type of help system is used by the program
phoCommandLine | Holds the object-handle of the embedded cCommandLine object
phoMainPanel | Holds the object-handle of the program's main panel
phoVersionInfo | Holds the object-handle of the embedded cVersionInfo object
phoWorkspace | Holds the object-handle of the embedded cWorkspace object
psAutoOpenWorkspace | Controls which workspace file is opened by cApplication object in program
psCompany | The name of the company producing the program
psHelpFile | Name of the compiled HTML (CHM) helpfile to display
psProduct | The name of the product
psProgram | The name of the program
psVersion | The version of the program
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cApplication

View event list in alphabetical order

Name | Description
OnCreate | Use this event to open a Workspace or perform other pre-startup logic
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cApplication

View method list in alphabetical order

Name | Type | Description
DoLoadEnvironment | Procedure | Loads size/location information from the registry at startup
DoOpenWorkspace | Procedure | Opens a Workspace
DoSaveEnvironment | Procedure | Writes the Program/Views size and location to the registry
GetApplicationFileName | Function | Returns the filename of the application
GetApplicationName | Function | Returns filename of the application without any path or extension
GetApplicationPath | Function | Returns the path that the program is running in
ReadBinary | Function | Reads binary data from the registry
ReadDword | Function | Reads DWord data from the registry
ReadString | Function | Reads string data from the registry
RegistryKeyString | Function | Returns the name of the Key that will be used to access the registry for user-defined values in the application object
ValueExists | Function | Tests whether an application-specific registry key/value exists
WriteBinary | Procedure | Writes binary data to the registry
WriteDword | Procedure | Writes DWord data to the registry
WriteString | Procedure | Writes string data to the registry
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cAutoWebReport

Properties Events Methods Index of Classes

Used to create quick prototype reports based around the main file of a cWebBusinessProcess object

Hierarchy

cObject
---cReport
------cReportDS
---------cBasicReport
------------cHtmlReport
---------------cWebReport
------------------cAutoWebReport

Library: Web Application Class Library

Package: cAutoWebreport.pkg

Description

This class will automatically create a protoype report for the main file of the WBO. The report is started by sending the message AutoReport to the cWebBusinessProcess object, All fields except overlap and binary fields will be displayed.

Normally, there is no interface used with this object at all. You use "use" the appropriate package and create a cAutoWebReport in your WBO. The WBO will register this object and handle all messages to this report.

// make sure the package is used.
cAutoWebReport.pkg
:
:
Object oMyWbo is a cWebBusinessProcess
    :
    Object oAutoWebReport is a cAutoWebReport
    End_Object
    :
End_Object

An AutoReport is designed for quick report prototyping. It can be added to any WBO and can be called from ASP script by invoking the call message with get_AutoReport.

When run, an HTML report containting all columns within the table will be sent to the browser. This provides an easy and quick way to verify your data. You will probably find this report and its interface too inflexible for actual application deployment.

An AutoReport must be placed inside of a WBO object. It assumes that only one AutoReport will placed within any WBO. When placed within a WBO it is automatically registered by the WBO. An AutoReport is started by sending the message get_AutoReport to the WBO object. Note this message is sent to the WBO and not directly to the report object. An AutoReport will usually be called from your ASP script.

The short label of each field (as described in the Database Builder in the DD file for this database table) is used when creating the report headers.

The WBO must contain a server, if no server object is found, an error will be generated and the report will terminated.

See Also

AutoReport

Last Edited: November 21, 2004


Properties for cAutoWebReport

View property list in alphabetical order

Name | Description
Inherited Properties from cWebReport
piLastRecord | (Obsolete) Holds the record that was processed when a report was halted because the maximum number of records was encountered
piMaxCount | Holds the maximum number of records to print
piMaxCountBreakLevel | Determines what is considered to be a "record" when record counting is used to create partial reports
piStartRecord | (Obsolete) Allows you to create partial reports providing a method for creating web report "pages"
priLastRowId | Holds the RowId of the record that was processed when a report was halted because the maximum number of records was encountered
priStartRowId | Determines the RowId of the first record of a report allowing you to create partial web reports
psHRefName | Holds the full URL of a file (ASP or HTML) to be displayed as part of a "drill down" operation
Inherited Properties from cHtmlReport
piConstrainFile | Used when creating reports to limit the printing to a single parent record and the related children
piConstrainRecord | (Obsolete) Used when creating reports to limit the printing to a single parent record and the related children
priConstrainRowId | Used when creating reports to limit the printing to a single parent record and the related children
Inherited Properties from cBasicReport
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button
Display_Error_State |
Output_Device | Handles the name of the output device
Report_Caption | Contains the text that will appear in the status panel's caption bar
Report_Message | An additional message area that will appear below the report_title in the status panel
Report_Status_Panel |
Report_Title | A centered title that appears in the status panel
Status_Log_Id | Object ID of status-log object
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs
Inherited Properties from cReportDS
Server | Identifies the object handle that is used as the report object's main data-dictionary object
Inherited Properties from cReport
Assigned_Channel |
Find_Mode | Maintains the current finding mode
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function
Last_Rec | (Obsolete) Contains the record number of the last selected record found
Main_File | Contains the filenumber of the file which the report will use for finding records
New_Page_State | Set true when a new page is needed
No_Constrained_Find_State | Determines if constrained record finding should be disabled
No_Finding_State | Determines how the cReport object will find records
No_PageCheck_State | Set true when the cReport object is processing a new page
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found
Page_Count | Keeps track of the current page number
Page_End | Determines how many lines on a page are allowed before a page break will occur
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence
Page_Feed | Used by the formfeed procedure
Page_Footer_Lines | The number of lines in the page_footer image
pbCanceled | Setting this true will cancel a report
pbChildReport | Set true if the current cReport object is nested
pbFindDown | Determines if the report should traverse up or down the index
pbHasChildReports | Is set true if other reports are nested inside this report object
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level
phMainReport | Contains the object ID of the outer report
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found
piNumberBreaks | Returns the number of breaks in a report
piOrdering | Contains the index number which will be used for finding records
piRecordCount | Contains the number of records found for the current report
priCurrentRec | Contains the RowId of the current valid record found
priFoundRec | Contains the RowId of the record found by the find_rec function
priLastRec | Contains the RowId of the last selected record found
Report_Channel | Determines which output channel will be used for your report output
Report_Footer_Lines | The number of lines in the OnReportFooter image
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cAutoWebReport

View event list in alphabetical order

Name | Description
Inherited Events from cWebReport
OnInitBreakPoints | Determines the number and order of your breakpoints
Inherited Events from cBasicReport
Error_Report | Sent whenever an error is generated
OnEndingMainReport | User Handler Intended for override
onError | Provided as a hook to handle custom error reporting
OnStartingMainReport | Called when a report is started
Report_Interrupt | Called when the status panel's Cancel button has been pressed
Inherited Events from cReport
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property
Final_Formfeed |
OnBody | Called every time a valid record has been found
OnConstrain |
OnEndingReport | Called at the end of all reports
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables
OnPageFooter | Printed after OnPageTotal on every page except the last page
OnPageHeader | Called after OnPageTop on every new page except the first
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader.
OnPageTop | Called when printing the top of every report
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page
OnReportFooter | Printed after OnPageTotal on the last page of the report
OnReportHeader | Called only on the first page of the report, after OnPageTop
OnSelection | Validates a record
OnStartingReport | Called when a report is started
OnSubHeader1..n | Called each time a subheader needs to be printed
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program
OnSubTotal1..n | Called when a subtotal needs to be processed
OnTotal | Called at the end of a report after all final sub-totals have been printed
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cAutoWebReport

View method list in alphabetical order

Name | Type | Description
DoAutoReport | Function | (Obsolete) Starts an Auto-Report
DoAutoReport1 | Function |
Inherited Methods from cWebReport
AddRecordLink | Function | (Obsolete) Creates a cell that contains a link to another web page
AddRowIdLink | Function | Creates a cell that contains a link to another web page
RegisterBreakpoint | Procedure | registers a breakpoint function
Inherited Methods from cHtmlReport
AddSubTotal | Procedure | Adds the passed value to the total maintained in level iCount
ClearAllSubTotals | Procedure | Clears all the SubTotal accumulators
ClearSubTotal | Procedure | Clears a single Subtotal accumulator
HtmlAnchor | Function | Adds an Html Anchor
HtmlBig | Function | Makes the string big
HtmlBlink | Function | Makes the string blink
HtmlBold | Function | Makes the string bold
HtmlEmph | Function | Makes the string emphasized
HtmlFixed | Function | Makes the string fixed width
HtmlFontcolor | Function | Sets the strings font color
HtmlFontsize | Function | Sets the font size
HtmlHeader | Function | Creates a header string of level iHeader
HtmlItalics | Function | Makes the string italics
HtmlLink | Function | Adds a hyperlink to a string
HtmlSmall | Function | Makes the string small
HtmlStrike | Function | Overstrikes through the string
HtmlStrong | Function | Adds strong emphasis to the string
HtmlSub | Function | Makes the string subscript
HtmlSup | Function | Makes the string superscript
SubTotal | Function | Returns the appropriate subtotal and clears the subtotal accumulator
SumSubTotal | Function | Returns the appropriate subtotal but does not clear the subtotal accumulator
WriteHtml | Procedure | Outputs the passed string to the web page and ends the line
WriteHtmlBreak | Procedure | Outputs the passed string and ends the line
WriteHtmlCell | Procedure | Outputs a table cell containing sData
WriteHtmlCellHeader | Procedure | Outputs a table header cell containing sData
WriteHtmlHorzLine | Procedure | Outputs a horizontal line to the HTML file
WriteHtmlRowBegin | Procedure | Outputs a "begin" row HTML string
WriteHtmlRowEnd | Procedure | Outputs an end row html string
WriteHtmlTableBegin | Procedure | Outputs a "begin" table html string
WriteHtmlTableEnd | Procedure | Outputs an end table html string
WriteLn | Procedure | Outputs the string and ends the Line
Inherited Methods from cBasicReport
End_Log | Procedure | Sends an end-log message to the log object
Error_Log_Status | Procedure | Called by error_report if status_log_state is true
Log_Status | Procedure | Sends passed message to the log object
Start_Log | Procedure | Sends a start-log message to the log object
Update_Status | Procedure | Send this message to update the action area of the status panel
Inherited Methods from cReportDS
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO
Request_Save | Procedure | If sent, this saves the current record
Inherited Methods from cReport
DoRunReport | Function | The main entry point for reportsT
Formfeed | Procedure | Handles formfeeds
Output_ImageNum | Procedure | Outputs the image represented by ImageNum
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cBaseHTTPTransfer

Class: cBaseHTTPTransfer (Abstract)

Properties Events Methods Index of Classes

Abstract class for handling HTTP transfers

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---InetTransfer
------cBaseHTTPTransfer
---------cHttpTransfer

Library: Common (Windows and Web Application) Class Library

Package:

Description

cBaseHTTPTransfer provides interface support for handling HTTP transfers. Its sub-class cHTTPTransfer should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for cBaseHTTPTransfer

View property list in alphabetical order

Name | Description
pbShowErrorDialog | Determines if a popup dialog will appear when a client certificate or usename/password is needed for an Http Request
psAcceptTypes | Specifies the HTTP content types accepted by the client
psProtocolVersion | Specifies the HTTP protocol version
psSaveasFile | Saves response from the remote host to the specified file instead of triggering the OnDataReceived event
Inherited Properties from InetTransfer
LastErrorCode | Returns the last error code from the HTTP / FTP Transfer
peTransferFlags | Various flags that control how file/data should be transferred
piBufferSize | Specifies the size of the file transfer buffer
piRemotePort | Specifies the port to connect to on RemoteHost
psAgent | Specifies the name of the application
psPassword | Specifies the password to use to log on
psProxy | Specifies the name of the Proxy server used, if any
psRemoteHost | Specifies the hostname or the IP address of the remote server
psUserName | Specifies the name of the user to log on
RootHandle | Returns the root HINTERNET handle used for the session
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cBaseHTTPTransfer

View event list in alphabetical order

Name | Description
OnDataReceived | Is triggered several times during a GetRequest, PostRequest and PutRequest when data arrives from RemoteHost
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cBaseHTTPTransfer

View method list in alphabetical order

Name | Type | Description
AddHeader | Function | Adds the HTTP header named sHeaderName with the value sHeaderValue to the HTTP headers
ClearHeaders | Procedure | Clears all HTTP headers added using AddHeader
HTTPGetRequest | Function | Performs an HTTP GET request using sFilePath
HTTPPostAddrRequest | Function | Performs an HTTP POST request
HTTPputAddrRequest | Function | Performs an HTTP PUT request using sFilePath
ResponseHeader | Function | Returns the value for a named http response header
ResponseStatusCode | Function | Returns the response http status code
SelectClientCertificate | Function | Selects a client certificate to be used in an Http request
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cBasicReport

Class: cBasicReport (Abstract)

Properties Events Methods Index of Classes

Abstract Basic Reporting class

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cReport
------cReportDS
---------cBasicReport
------------cHtmlReport

Library: Web Application Class Library

Package: cBasicReport.pkg

Description

The cBasicReport class is used to create reports.This abstract class is used by the sub-classes cWebReport and cWmlReport to generate HTML and WML WebApp Report.

This class was modelled after the BasicReport class. It has the same capabilities with an interface that is "more up to date". It was created for WebApp usage but could be used with standard VDF desktop style applications.

Last Edited: November 21, 2004


Properties for cBasicReport

View property list in alphabetical order

Name | Description
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button
Display_Error_State |
Output_Device | Handles the name of the output device
Report_Caption | Contains the text that will appear in the status panel's caption bar
Report_Message | An additional message area that will appear below the report_title in the status panel
Report_Status_Panel |
Report_Title | A centered title that appears in the status panel
Status_Log_Id | Object ID of status-log object
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs
Inherited Properties from cReportDS
Server | Identifies the object handle that is used as the report object's main data-dictionary object
Inherited Properties from cReport
Assigned_Channel |
Find_Mode | Maintains the current finding mode
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function
Last_Rec | (Obsolete) Contains the record number of the last selected record found
Main_File | Contains the filenumber of the file which the report will use for finding records
New_Page_State | Set true when a new page is needed
No_Constrained_Find_State | Determines if constrained record finding should be disabled
No_Finding_State | Determines how the cReport object will find records
No_PageCheck_State | Set true when the cReport object is processing a new page
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found
Page_Count | Keeps track of the current page number
Page_End | Determines how many lines on a page are allowed before a page break will occur
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence
Page_Feed | Used by the formfeed procedure
Page_Footer_Lines | The number of lines in the page_footer image
pbCanceled | Setting this true will cancel a report
pbChildReport | Set true if the current cReport object is nested
pbFindDown | Determines if the report should traverse up or down the index
pbHasChildReports | Is set true if other reports are nested inside this report object
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level
phMainReport | Contains the object ID of the outer report
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found
piNumberBreaks | Returns the number of breaks in a report
piOrdering | Contains the index number which will be used for finding records
piRecordCount | Contains the number of records found for the current report
priCurrentRec | Contains the RowId of the current valid record found
priFoundRec | Contains the RowId of the record found by the find_rec function
priLastRec | Contains the RowId of the last selected record found
Report_Channel | Determines which output channel will be used for your report output
Report_Footer_Lines | The number of lines in the OnReportFooter image
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cBasicReport

View event list in alphabetical order

Name | Description
Error_Report | Sent whenever an error is generated
OnEndingMainReport | User Handler Intended for override
onError | Provided as a hook to handle custom error reporting
OnStartingMainReport | Called when a report is started
Report_Interrupt | Called when the status panel's Cancel button has been pressed
Inherited Events from cReport
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property
Final_Formfeed |
OnBody | Called every time a valid record has been found
OnConstrain |
OnEndingReport | Called at the end of all reports
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables
OnPageFooter | Printed after OnPageTotal on every page except the last page
OnPageHeader | Called after OnPageTop on every new page except the first
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader.
OnPageTop | Called when printing the top of every report
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page
OnReportFooter | Printed after OnPageTotal on the last page of the report
OnReportHeader | Called only on the first page of the report, after OnPageTop
OnSelection | Validates a record
OnStartingReport | Called when a report is started
OnSubHeader1..n | Called each time a subheader needs to be printed
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program
OnSubTotal1..n | Called when a subtotal needs to be processed
OnTotal | Called at the end of a report after all final sub-totals have been printed
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cBasicReport

View method list in alphabetical order

Name | Type | Description
End_Log | Procedure | Sends an end-log message to the log object
Error_Log_Status | Procedure | Called by error_report if status_log_state is true
Log_Status | Procedure | Sends passed message to the log object
Start_Log | Procedure | Sends a start-log message to the log object
Update_Status | Procedure | Send this message to update the action area of the status panel
Inherited Methods from cReportDS
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO
Request_Save | Procedure | If sent, this saves the current record
Inherited Methods from cReport
DoRunReport | Function | The main entry point for reportsT
Formfeed | Procedure | Handles formfeeds
Output_ImageNum | Procedure | Outputs the image represented by ImageNum
WriteLn | Procedure | Outputs the string message to the current output channel
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cClientWebService

Properties Events Methods Index of Classes

The base class for all client web-services

Hierarchy

cObject
---cClientWebService

Library: Common (Windows and Web Application) Class Library

Package: cClientWebService.pkg

Description

Within a Visual DataFlex windows application, a web service is accessed by:

1. Generating a sub-class that provides access to a web-service.

This class, which will be automatically generated by accessing to the web-service's description. The new class will contain a method interface (function name and parameters) that matches the interface of the actual web-service.

2. Creating an object within your program that is based on this sub-class.

This is accomplished by selecting the web-service class from the Studio's control palette and dropping it into your view.

3. Calling the function within this client object.

The object will convert your function into a SOAP request and send it to the server. When it gets a response from the server it will unpack the SOAP response and place the data into the function's return value.

SOAP Headers

The SoapHeaderResponseNode, ClearSoapHeaders, AddSoapHeaderNode and SoapHeaderRequestNode methods provide a low level mechanism for working with SOAP headers.

Creating a Client Web-Service Class

The cClientWebService class is used as the basis for all client web-services. This class knows how to handle generic SOAP messages. Each web-service has its own definition and therefore each web-service will be represented on the client side as a sub-class, based on cClientWebService. These custom classes contain functions that correspond to the functions that exist in the actual service.

A tool, the Web-Service Client Class Generator is provided for automatically creating client web-service classes. This class generator requires that you provide it with the location of a web-service's description (its WSDL location). The tool will parse the WSDL document and create a sub-class based on that information. It will create the class and all additional files required to integrate the class directly in the Studio so that it can be accessed from the Studio's Control Palette.

Adding a Client Web Service Object to your Application

Once a web service client sub-class has been created it can be added to any program in the same manner that any object is added to a Visual DataFlex application. You will need to find your web-service class in your Control Palette, grab it and drag and drop it into your component.

Calling a Web-Service

If you look at the client web-service object that was created you will see that the service's interface is shown as part of the object's documentation. These interfaces will appear as standard functions consisting of a function name, parameter data-types and names, and a return data-type. A web service is called, by sending a message to this object (i.e., you just call the function). The object will take this local function call, turn it into a proper SOAP request and make the needed HTTP request to the server. The server will process the request and send back a SOAP response. The client object will take this response, parse it and set up the return value or, if needed, handle any error messages. As a developer, you will see none of this. You will simply be calling a method within an object and getting return value.

Methods from cClientWebService that you might use in your sub-class

When you a web-client sub-class you will usually just access the methods defined for this sub-class. There are a few methods from the cClientWebService class that you may use:

The property pbSuppressLastError determines if errors encountered during a web-service call should be reported.

The property peTransferStatus returns the error status of the last web-service call.

The function TransferErrorDescription can be used to return the error text for any transfer status error.

The properties psFaultString and psFaultString can be used to return SOAP Fault information

The procedure LastError can be sent to manually display error information about your last web-service call.

The property phoSoapClientHelper can be used along with the WebClientHelper.vw view to display debug information about a web-service call.

The properties phoSoapRequest and phoSoapResponse can be used to access the raw information about a web-service request and response.

The property psServiceLocation contains the URL location of the web-service.

User name and Password

If the Http site hosting the web service requires that you login, you must provide a username and password. You do this using the psUserName and psPassWord properties. This information is not found in the WSDL so it must be added manually by the programmer.

HTTPS/ Secure SSL Sites

Secure HTTPS sites are supported. If the URL in psServiceLocation contains "HTTPS" the object will recognize that this is an secure site and will change the default port to rpHttpSSL (443) and will set the appropriate transfer flag in the http object. When your web-service client is created, this information should be contained in your WSDL and the generated client class will automatically support this.

In some cases a client certificate may be required for a secure site. This information is not stored in the WSDL. The programmer will need to select the certificate by setting the properties psCertificateStore and psCertificateSubject

Using the cClientWebService Class without the Class generator

Because the class is generated automatically for you, you do not need to know much about the cClientWebService class. Most of the public methods in this class will not be used by the developer. They will just call the custom methods created in their sub-class. For this reason, this class might almost be considered to be abstract and most of the methods could be considered to be private. However, this class could be used by the developer for advanced purposes such as using the class to support dynamic client web-service access (i.e., using the same object to access multiple web-services). In such as case, much can be learned by studying the sub-classes created by the class generator - this will show you how the cClientWebService class is used.

Last Edited: November 2, 2006


Properties for cClientWebService

View property list in alphabetical order

Name | Description
pbRequestBare | Determines if the web service's soap request uses a bare style for parameters
pbResponseBare | Determines if the web service's soap response uses a bare style for parameters
pbSuppressLastError | Determines if a web-service call error should be reported
pbValidateResponse | Determines if validation of a SOAP response should be relaxed
peResponseSoapEncoding | Encoding Style for the SOAP response
peSoapEncoding | Encoding Style for the SOAP request
peSoapStyle | Soap Style - Document or RPC
peTransferStatus | Returns the status of the last web-service call
phoHttp | Contains the handle of the Http object used by the client web-service
phoSoapClientHelper | Provides a mechanism for connecting any Web Service to a test view
phoSoapRequest | A handle to an XML document object containing the last SOAP request
phoSoapResponse | A handle to an XML document object containing the last SOAP Response
piPort | Determines the port used for a web-service call
psCertificateStore | Set the Certificate Store string for selecting a client certficate
psCertificateSubject | Set the Certificate Subject string for selecting a client certficate
psContentType | Determines the content type for the soap/http request
psFaultCode | Returns the FaultCode of the last web service call
psFaultString | Returns the FaultCode of the last web service call
psMethodRequest | The name of the operation's request
psMethodResponse | The name of the operation response
psPassword | Specifies the password to use to log on
psRequestNSURI | Sets the Request NameSpace URI (targetNameSpace)
psResponseNSURI | Sets the Response NameSpace URI (targetNameSpace)
psServiceLocation | Determines the URL location of your web-service
psSOAPAction | Sets the SOAPAction for the Web-service call
psUserName | Specifies the name of the user to log on
psWSDLLocation | Determines the URL location of the WSDL document used to create the class
psXmlEncoding | Sets the encoding style used for the web-service call
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cClientWebService

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cClientWebService

View method list in alphabetical order

Name | Type | Description
AddParameter | Procedure | (Obsolete) Adds or sets a Parameter's data-value
AddSoapHeaderNode | Procedure | Adds a SOAP header node to a method's request.
ClearSoapHeaders | Procedure | Clears all SOAP request headers.
DefineParameter | Function | Defines an operation parameter for a web service operation
DefineParameter | Procedure | (Obsolete) Sets a parameters data-type, name and schema type name
DefineReturn | Procedure | (Obsolete) Sets an operation's return data-type, name and schema type name
DefineStructParameter | Function | Defines an operation parameter for a web service operation
DoInvokeService | Function | Invokes a web service call
LastError | Procedure | Used to manually report an error after a Web Service call
Reset | Procedure | Resets all object information in preparation for a new web-service call
ReturnValue | Function | (Obsolete) Returns the last web-service class return value in the proper data-type
SoapHeaderRequestNode | Function | Returns SOAP header request information that was passed to a web service.
SoapHeaderResponseNode | Function | Returns SOAP header response information passed from the web service as an XML object.
TransferErrorDescription | Function | Returns an error description for the last transfer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCLIHandler

Properties Events Methods Index of Classes

Implements functionality common for the CLI based Connectivity Kits (SQL Server, DB2 and ODBC)

Hierarchy

cObject
---Array
------cCLIHandler
---------cDB2Handler
---------cMSSQLHandler
---------cODBCHandler

Library: Common (Windows and Web Application) Class Library

Package: cli.pkg

Description

The cCLIHandler class implements functionality common for the CLI based Connectivity Kits (SQL Server, DB2 and ODBC), the cMSSQLHandler class implements functionality specific for SQL Server.

Setting the Driver

When creating an object of the cCLIHandler class you must set the psDriverID property.

In order for the class to work with the ODBC Connectivity Kit the property should be set to "ODBC_DRV".

Get Create U_cCLIHandler To hoCliHandler
Set psDriverID Of hoCLIHandler To "ODBC_DRV"

In order for the class to work with the Connectivity Kit for SQL Server, the property should be set to "MSSQLDRV".

Get Create U_cCLIHandler To hoCliHandler
Set psDriverID Of hoCLIHandler To "MSSQLDRV"

In order for the class to work with the Connectivity Kit for DB2, the property should be set to "DB2_DRV".

Get Create U_cCLIHandler To hoCliHandler
Set psDriverID Of hoCLIHandler To "DB2_DRV

If you use the cMSSQLHandler, cDB2Handler or cODBCHandler classes (subclasses of this class) instead, this property is already set for you.

Revision Handling

There are a number of functions available that return the current Connectivity Kit revision.

Function CKRevision Returns String
Function CKMajorRevision Returns Integer
Function CKMinorRevision Returns Integer
Function CKReleaseRevision Returns Integer
Function CKBuildRevision Returns Integer
Function IsMinimalRevision Integer iMajor Integer iMinor Integer iRelease Integer iBuild Returns Integer

You can use these functions to display the current revision number of the Connectivity Kit.

Procedure ShowCKRevision String sDRiverID
    Handle hoCLIHandler

    Get Create U_cCLIHandler To hoCLIHandler
    Set psDriverID To sDRiverID
    Showln (CKRevision(hoCLIHandler))
    Send Destroy Of hoCLIHandler
End_Procedure // ShowCKRevision

You can also check the current Connectivity Kit revision and act upon that information. If, for example, certain functionality only works for version 3.0.0.48 or higher of the MS SQL Connectivity Kit, one could program:

Procedure DoVersionDependentThing
    Handle hoCLIHandler

    Get Create U_cCLIHandler To hoCLIHandler
    Set psDriverID Of hoCLIHandler To "MSSQLDRV"
    If (IsMinimalRevision(hoCLIHandler, 3, 0, 0, 48)) ;
        Send DoMyThing
    Else ;
        Send Stop_Box "Function not supported by this CK"
End_Procedure // DoVersionDependentThing

Registration Information

There are a number of functions that return registration information.

Function RegistrationName Returns String
Function SerialNumber Returns Integer
Function MaxUsers Returns Integer

Status Dump

It is possible to dump the current status of the Connectivity Kit. This is intended as a debugging aid. In some cases the point where a problem occurs is known. In such cases one can call the DumpStatus procedure.

Procedure DumpStatus String sFileName

The DumpStatus procedure expects a disk file name as parameter. If the disk file already exists, the current status will be appended to that disk file.

Procedure ShowStatus
    Handle hoCLI

    Get Create U_cCLIHandler To hoCLI
    Set psDriverID Of hoCLI To MSSQLDRV_ID
    Send DumpStatus Of hoCLI "c:\status\mssqldump.txt"
    Send Destroy Of hoCLI
End_Procedure // ShowStatus

Text to Enum Conversion

A number of attributes can be set to a value from an enumeration list. Functions are available to convert the enumeration list values to strings and vice-versa.

Function TextToRIMValue String sText Returns Integer
Function RIMValueToText Integer iAttrValue Returns String
Function TextToROValue String sText Returns Integer
Function ROValueToText Integer iAttrValue Returns String

To show the current value of the DF_FIELD_READ_ONLY attribute one could program something like:

Procedure ShowRO Handle hoCLIHandler ;
    Handle hTable ;
    Handle hColumn

    Integer eReadOnly

    Get_Attribute DF_FIELD_READ_ONLY hTable hColumn ;
        To eReadOnly
    Showln "Read only attribute is set to " ;
        (ROValueToText(hoCLIHandler, eReadOnly))
End_Procedure // ShowRO

Last Error Text

Error texts generated by SQL Server and other client/server databases are generally larger than those generated by the embedded database. In character mode environments, it happens that the text is larger than the supported maximum error text length. In those cases, you can get the complete error text by using the LastDriverError function.

Function LastDriverError Returns String

To show the last error text, one would program:

Procedure ShowLastSQLErrorText
    Handle hoCLIHandler
    String sLastError

    Get Create U_cCLIHandler To hoCLIHandler
    If (hoCLIHandler > 0) Begin
        Set psDriverID Of hoCLIHandler To MSSQLDRV_ID
        Get LastDriverError Of hoCLIHandler To sLastError
    End
    Send Destroy Of hoCLIHandler
    Showln "ERROR: " sLastError
End_Procedure // ShowLastSQLErrorText

Re-read Configuration File

The driver configuration file is read once in a session. When the Connectivity Kit initializes, it reads the configuration file mssqldrv.int. You can force the configuration file to be read by using the ReadConfiguration procedure.

Procedure ReadConfiguration

When this procedure is called all driver level settings will be set to their default value, then the driver configuration file is read.
For more information on driver level attributes, see Appendix B - Configuration file MSSQLDRV.INT

Enumerating Tables and Columns

Several functions are available that enumerate table and column information. They can be used to show all tables that exist in a database regardless if there is a connection to these tables.

Function EnumerateTables String sLogin Returns Integer
Function TableName Integer iIndex Returns String
Function SchemaName Integer iIndex Returns String
Function TableType Integer iIndex Returns String
Function TableComment Integer iIndex Returns String
Function EnumerateColumns String sLogin String sTableName Returns Integer
Function ColumnName Integer iIndex Returns String

If we want to show all tables in a Microsoft SQL Server database and for every table all column names, we would program:

Procedure ShowAllTablesAndColumns String sDriver String sLogin
    Handle hoCLIHandler
    Integer iNumTables
    Integer iNumColumns
    Integer iTableCount
    Integer iColumnCount

    Get Create U_cCLIHandler To hoCLIhandler
    If (hoCLIHandler > 0) Begin
        Set psDriverID Of hoCLIHandler To sDriver
        Get EnumerateTables Of hoCLIHandler sLogin To iNumTables
        For iTableCount From 1 To iNumTables
            Show (TableName(hoCLIHandler, iTableCount)) "; "
            Show (SchemaName(hoCLIHandler, iTableCount)) "; "
            Show (TableType(hoCLIHandler, iTableCount)) "; "
            Showln (TableComment(hoCLIHandler, iTableCount))
            Get EnumerateColumns Of hoCLIHandler sLogin ;
            (TableName(hoCLIHandler, iTableCount)) To iNumColumns
            For iColumnCount From 1 To iNumColumns
                Showln " " (ColumnName(hoCLIHandler, iColumnCount))
            Loop
            Showln
        Loop
        Send Destroy Of hoCLIHandler
    End
End_Procedure // ShowAllTablesAndColumns

If you want to use the above procedure for database D on server X with user account Y and password Z it would be called in the following way:

Send ShowAllTablesAndColumns MSSQLDRV_ID ;
    "DRIVER={SQL Server};SERVER=X;UID=Y;PWD=Z;DATABASE=D"

See Also

cTableColumnFetchHelper

Last Edited: June 22, 2005


Properties for cCLIHandler

View property list in alphabetical order

Name | Description
psDriverID | The identification of the CLI driver.
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCLIHandler

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCLIHandler

View method list in alphabetical order

Name | Type | Description
CKBuildRevision | Function | Returns the build revision of the Connectivity Kit.
CKMajorRevision | Function | Returns the major revision of the Connectivity Kit.
CKMinorRevision | Function | Returns the minor revision of the Connectivity Kit.
CKReleaseRevision | Function | Returns the release revision of the Connectivity Kit.
CKRevision | Function | Returns the Connectivity Kit revision in the format Major.Minor.Release.Build.
CLIDFDateToSQLDate | Function |
CLISQLDateToDFDate | Function |
ColumnName | Function | Returns the name of the column enumerated at the given position by EnumerateColumns.
DumpStatus | Procedure | Dumps the current status of the Connectivity Kit to an ASCII disk file.
EnumerateColumns | Function | Enumerates all column names for a given table.
EnumerateTables | Function | Enumerates tables in the given database.
ExtractPartFromRevision | Function |
IsMinimalRevision | Function | Checks if a Connectivity Kit complies with a minimal revision.
LastDriverError | Function | Returns the string value of the last generated driver error.
MaxUsers | Function | Returns the maximum number of users of the Connectivity Kit.
ReadConfiguration | Procedure | Forces the Connectivity Kit to reread the driver configuration file.
RedirectConnection | Function |
RegistrationName | Function | Returns the registration name of the Connectivity Kit.
RIMValueToText | Function | Converts a DF_FILE_GENERATE_RECORD_ID_METHOD attribute value to the corresponding text.
ROValueToText | Function | Converts a DF_FIELD_READ_ONLY attribute value to the corresponding text.
SchemaName | Function | Returns the schema of the table enumerated at the given position by EnumerateTables.
SerialNumber | Function | Returns the Connectivity Kit serial number.
TableComment | Function | Returns the comment of the table enumerated at the given position by EnumerateTables.
TableName | Function | Returns the name of the table enumerated at the given position by EnumerateTables.
TableType | Function | Returns the type of the table enumerated at the given position by EnumerateTables.
TextToRIMValue | Function | Converts a record identity text to the DF_FILE_GENERATE_RECORD_ID_METHOD attribute value
TextToROValue | Function | Converts a read only text to the DF_FIELD_READ_ONLY attribute value.
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCollection

Properties Events Methods Index of Classes

Maintains a collection of object-handles

Hierarchy

cObject
---Array
------cCollection

Library: Common (Windows and Web Application) Class Library

Package: cCollection.pkg

Description

A cCollection is used to maintain a collection of object-handles. It is typically used in objects to maintain a list of its child objects. For example, the cStatusBar uses one to keep track of the embedded cStatusPane objects and the cToolbar uses one to keep track of its embedded cToolbarButton objects.

The collection doesn't actually store the objects as child objects. Rather, it just keeps the object-handle of the objects. As such, the objects that are being pointed to by the object-handles have no direct meaning to the collection.

To add objects-handles into the collection, use DoAppendObject or DoInsertObject. To remove an object-handle, use DoRemoveObject. To determine the number of object-handles in the collection, use CountOfObjects.

Each object-handle in the collection has an index. This index represents the zero-based ordinal position in the collection. For example, the first object-handle added to a collection will have an index of zero, and the second one added will have an index of one, and so on. Given an object-handle, you can determine its index by using IndexFromObject, and from an index, you can determine the object-handle using ObjectFromIndex.

To prevent duplicate object-handles in the collection, use pbAllowDuplicates.

Sample

Object oCollection is a cCollection
    Set pbAllowDuplicates To True
End_Object

Last Edited: December 20, 2005


Properties for cCollection

View property list in alphabetical order

Name | Description
pbAllowDuplicates | Determines if text within the pane is aligned left, right or centered
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCollection

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCollection

View method list in alphabetical order

Name | Type | Description
CountOfObjects | Function | Returns the number of objects that are currently in the collection
DoAppendObject | Procedure | Appends an object-handle, ho, to the end of the collection
DoInsertObject | Procedure | Inserts an object-handle, ho, into the collection before the hoBefore object-handle
DoRemoveObject | Procedure | Removes the object-handle, ho, from the collection
IndexFromObject | Function | Returns the index for the object-handle, ho, in the collection
IsObjectIn | Function | Used to determine if object handle exists in the collection
ObjectFromIndex | Function | Returns the object-handle at index, iIndex, in the collection
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cComActiveXControl

Properties Events Methods Index of Classes

Generates wrapper classes for imported ActiveX controls

Hierarchy

cObject
---cUIObject
------DfComUIObject
---------DfInPlaceComObject
------------DfComActiveXControl
---------------cComActiveXControl
------------------cComActiveXEntryControl_
------------------cCrystalActiveXReportViewer

Library: Windows Application Class Library

Package: FlexCOM20.pkg

Mixins: Standard_Object_Mixin Single_Item_Navigate_Mixin Dflabel_Mixin RGB_Support_Temp_Mixin Help_Mixin Shadow_Mixin

Description

This class is used to generate wrapper classes for imported ActiveX controls.

See Also

cComDbActiveXControl

Last Edited: July 14, 2003


Properties for cComActiveXControl

View property list in alphabetical order

Name | Description
ControlValue | Used as a hook to link a property in the ActiveX control with the Value Property
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Changed_State |
Item_Count |
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
pbBindValue | Controls whether an ActiveX's bindable property is bound to the Value property
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Value |
Inherited Properties from DfInPlaceComObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key when ActiveX controls use a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from DfComUIObject
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Border_Style | Specifies the border style of this object
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
Mouse_Capture |
peAnchors | Describes how you want the control to react whenever its container changes size
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Shadow_State | Determines if item is enabled (not shadowed)
TextColor | Sets the text color of the object
Window_Handle | Returns the Windows window handle of the DataFlex object
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cComActiveXControl

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Can perform a task each time the ActiveX control's 'binded' property is changed
OnCreate | Sent right after a COM object is created
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display |
Inherited Events from DfComUIObject
Command | Sent from external controls
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cComActiveXControl

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfInPlaceComObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object
RegisterComEvent | Procedure |
RegisterPropertyChangeEvent | Procedure |
ReleaseComObject | Procedure | Releases ActiveX control associated with this object
Inherited Methods from DfComUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
Release_Mouse_Capture | Procedure |
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cComActiveXEntryControl_

Class: cComActiveXEntryControl_ (Abstract)

Properties Events Methods Index of Classes

Abstract class for creating DDO aware Active X controls

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfComUIObject
---------DfInPlaceComObject
------------DfComActiveXControl
---------------cComActiveXControl
------------------cComActiveXEntryControl_
---------------------cComDbActiveXControl_

Library: Windows Application Class Library

Package: cComDbActiveXControl.pkg

Mixins: dbItemMixin

Description

The cComActiveXEntryControl_ provides interface support for wrapping data_aware Active X controls. Its sub-class cComDbActiveXControl should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for cComActiveXEntryControl_

View property list in alphabetical order

Name | Description
Checkbox_Item_State | Any item may become a checkbox-type item when its checkbox_item_state is set to true
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Form_Datatype |
Form_Mask |
Form_Options |
Item_Changed_State |
Item_Entry_Msg |
Item_Exit_Msg |
Item_Option |
Item_Options |
Item_Validate_Msg |
phoEntryForm |
Prompt_Object |
Prototype_Object |
Select_State |
Value |
Zoom_Object |
Inherited Properties from cComActiveXControl
ControlValue | Used as a hook to link a property in the ActiveX control with the Value Property
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Count |
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
pbBindValue | Controls whether an ActiveX's bindable property is bound to the Value property
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfInPlaceComObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key when ActiveX controls use a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from DfComUIObject
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Border_Style | Specifies the border style of this object
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
Mouse_Capture |
peAnchors | Describes how you want the control to react whenever its container changes size
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Shadow_State | Determines if item is enabled (not shadowed)
TextColor | Sets the text color of the object
Window_Handle | Returns the Windows window handle of the DataFlex object
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cComActiveXEntryControl_

View event list in alphabetical order

Name | Description
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Refresh |
Inherited Events from cComActiveXControl
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Can perform a task each time the ActiveX control's 'binded' property is changed
OnCreate | Sent right after a COM object is created
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display |
Inherited Events from DfComUIObject
Command | Sent from external controls
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cComActiveXEntryControl_

View method list in alphabetical order

Name | Type | Description
Validate_Items | Function |
Inherited Methods from cComActiveXControl
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfInPlaceComObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object
RegisterComEvent | Procedure |
RegisterPropertyChangeEvent | Procedure |
ReleaseComObject | Procedure | Releases ActiveX control associated with this object
Inherited Methods from DfComUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
Release_Mouse_Capture | Procedure |
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cComAutomationObject

Class: cComAutomationObject (Abstract)

Properties Events Methods Index of Classes

Generates wrapper classes for imported OLE Automation Objects

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cComStdFont
---------cComStdPicture
---------cCrystal_ICRViewerSelectionEvents
---------cCrystalApplication
---------cCrystalArea
---------cCrystalAreas
---------cCrystalBlobFieldObject
---------cCrystalBoxObject
---------cCrystalConnectionProperties
---------cCrystalConnectionProperty
---------cCrystalCRCrystalReportViewerViewInfo
---------cCrystalCrossTabGroup
---------cCrystalCrossTabGroups
---------cCrystalCrossTabObject
---------cCrystalCRVEventInfo
---------cCrystalCRVField
---------cCrystalCRVFields
---------cCrystalCRVParameterPromptRuntimeOM
---------cCrystalCRVSelectionItem
---------cCrystalCRVSelectionItems
---------cCrystalCRVTrackCursorInfo
---------cCrystalCrystalComObject
---------cCrystalCSFontDescription
---------cCrystalDatabase
---------cCrystalDatabaseFieldDefinition
---------cCrystalDatabaseFieldDefinitions
---------cCrystalDatabaseTable
---------cCrystalDatabaseTables
---------cCrystalExportOptions
---------cCrystalFieldDefinitions
---------cCrystalFieldElement
---------cCrystalFieldElements
---------cCrystalFieldMappingData
---------cCrystalFieldObject
---------cCrystalFormattingInfo
---------cCrystalFormulaFieldDefinition
---------cCrystalFormulaFieldDefinitions
---------cCrystalGraphObject
---------cCrystalGroupNameFieldDefinition
---------cCrystalGroupNameFieldDefinitions
---------cCrystalLineObject
---------cCrystalMapObject
---------cCrystalObjectSummaryFieldDefinitions
---------cCrystalOlapGridObject
---------cCrystalOleObject
---------cCrystalPage
---------cCrystalPageEngine
---------cCrystalPageGenerator
---------cCrystalPages
---------cCrystalParameterFieldDefinition
---------cCrystalParameterFieldDefinitions
---------cCrystalParameterValue
---------cCrystalParameterValueInfo
---------cCrystalParameterValueInfos
---------cCrystalParameterValues
---------cCrystalPrintingStatus
---------cCrystalReport
---------cCrystalReportAlert
---------cCrystalReportAlertInstance
---------cCrystalReportAlertInstances
---------cCrystalReportAlerts
---------cCrystalReportObjects
---------cCrystalReportSourceRouter
---------cCrystalRunningTotalFieldDefinition
---------cCrystalRunningTotalFieldDefinitions
---------cCrystalSection
---------cCrystalSections
---------cCrystalSortField
---------cCrystalSortFields
---------cCrystalSpecialVarFieldDefinition
---------cCrystalSQLExpressionFieldDefinition
---------cCrystalSQLExpressionFieldDefinitions
---------cCrystalSubreportLink
---------cCrystalSubreportLinks
---------cCrystalSubreportObject
---------cCrystalSummaryFieldDefinition
---------cCrystalSummaryFieldDefinitions
---------cCrystalTableLink
---------cCrystalTableLinks
---------cCrystalTableQualifiers
---------cCrystalTextObject

Library: Common (Windows and Web Application) Class Library

Package: FlexCOM20_Base.pkg

Description

This class is used to generate wrapper classes for imported OLE Automation Objects.

See Also

cComStdFont | | cComStdPicture

Last Edited: July 2, 2003


Properties for cComAutomationObject

View property list in alphabetical order

Name | Description
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cComAutomationObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cComAutomationObject

View method list in alphabetical order

Name | Type | Description
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cComDbActiveXControl

Properties Events Methods Index of Classes

Generates data-aware wrapper classes for imported ActiveX controls

Hierarchy

cObject
---cUIObject
------DfComUIObject
---------DfInPlaceComObject
------------DfComActiveXControl
---------------cComActiveXControl
------------------cComActiveXEntryControl_
---------------------cComDbActiveXControl_
------------------------cComDbActiveXControl

Library: Windows Application Class Library

Package: cComDbActiveXControl.pkg

Mixins: DFNavigate_Mixin DFCode_DEO_Mixin Extended_DEO_Mixin Extended_DEO_Status_Help_Mixin

Description

This class is used to generate data-aware wrapper classes for imported ActiveX controls.

This class inherits all of the properties, events and methods of the cComActiveXControl class. It also inherits the public interface methods that are shared by all Visual DataFlex data-aware controls such as dbForm, dbEdit or dbGrid.

In summary, cComDbActiveXControl is used to wrap and ActiveX control so that it becomes functionally identical to any VDF data-aware control.

The following code, taken from the COM sample application, shows the code for instantiating a data-aware calendar ActiveX control.

Object oOrderCalendar is a cComDbCalendar
    Set Size to 140 140
    Set Location to 1 -3

    Embed_ActiveX_Resource
    // The ActiveX properties will be embedded in the control's source code here in binary format.
    End_Embed_ActiveX_Resource

    Entry_Item Orderhea.Order_date
End_Object    // oOrderCalendar

Note: All of the standard data entry object keys and features are automatically built into this class. Such as:
  • Standard key support (F4=prompt, F7, F8, F9=find, F2=save, etc.)
  • Support for the tool bar buttons.

Last Edited: August 10, 2006


Properties for cComDbActiveXControl

View property list in alphabetical order

Name | Description
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Inherited Properties from cComDbActiveXControl_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from cComActiveXEntryControl_
Checkbox_Item_State | Any item may become a checkbox-type item when its checkbox_item_state is set to true
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Form_Datatype |
Form_Mask |
Form_Options |
Item_Changed_State |
Item_Entry_Msg |
Item_Exit_Msg |
Item_Option |
Item_Options |
Item_Validate_Msg |
phoEntryForm |
Prompt_Object |
Prototype_Object |
Select_State |
Value |
Zoom_Object |
Inherited Properties from cComActiveXControl
ControlValue | Used as a hook to link a property in the ActiveX control with the Value Property
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Count |
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
pbBindValue | Controls whether an ActiveX's bindable property is bound to the Value property
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfInPlaceComObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key when ActiveX controls use a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from DfComUIObject
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Border_Style | Specifies the border style of this object
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
Mouse_Capture |
peAnchors | Describes how you want the control to react whenever its container changes size
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Shadow_State | Determines if item is enabled (not shadowed)
TextColor | Sets the text color of the object
Window_Handle | Returns the Windows window handle of the DataFlex object
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cComDbActiveXControl

View event list in alphabetical order

Name | Description
Inherited Events from cComDbActiveXControl_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from cComActiveXEntryControl_
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Refresh |
Inherited Events from cComActiveXControl
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Can perform a task each time the ActiveX control's 'binded' property is changed
OnCreate | Sent right after a COM object is created
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display |
Inherited Events from DfComUIObject
Command | Sent from external controls
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cComDbActiveXControl

View method list in alphabetical order

Name | Type | Description
Bind_Data | Procedure |
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from cComDbActiveXControl_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from cComActiveXControl
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfInPlaceComObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object
RegisterComEvent | Procedure |
RegisterPropertyChangeEvent | Procedure |
ReleaseComObject | Procedure | Releases ActiveX control associated with this object
Inherited Methods from DfComUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
Release_Mouse_Capture | Procedure |
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cComDbActiveXControl_

Class: cComDbActiveXControl_ (Abstract)

Properties Events Methods Index of Classes

Abstract class for creating DDO aware Active X controls

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfComUIObject
---------DfInPlaceComObject
------------DfComActiveXControl
---------------cComActiveXControl
------------------cComActiveXEntryControl_
---------------------cComDbActiveXControl_
------------------------cComDbActiveXControl

Library: Windows Application Class Library

Package: cComDbActiveXControl.pkg

Mixins: Entry_Form_DS_mixin Nesting_Mixin Navigate_Mixin Verify_Mixin Server_Mixin Action_Bar_Mixin Find_Edit_Mixin Entry_Item_Mixin DEO_Dependent_item_mixin Entry_CheckBox_Mixin DEO_Delegate_Mixin Validate_Mixin Clear_Defaults_Mixin

Description

The cComDbActiveXControl_ provides interface support for wrapping data-aware Active X controls. Its sub-class cComdbActiveXControl should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for cComDbActiveXControl_

View property list in alphabetical order

Name | Description
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from cComActiveXEntryControl_
Checkbox_Item_State | Any item may become a checkbox-type item when its checkbox_item_state is set to true
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Form_Datatype |
Form_Mask |
Form_Options |
Item_Changed_State |
Item_Entry_Msg |
Item_Exit_Msg |
Item_Option |
Item_Options |
Item_Validate_Msg |
phoEntryForm |
Prompt_Object |
Prototype_Object |
Select_State |
Value |
Zoom_Object |
Inherited Properties from cComActiveXControl
ControlValue | Used as a hook to link a property in the ActiveX control with the Value Property
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Count |
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
pbBindValue | Controls whether an ActiveX's bindable property is bound to the Value property
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfInPlaceComObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key when ActiveX controls use a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from DfComUIObject
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Border_Style | Specifies the border style of this object
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
Mouse_Capture |
peAnchors | Describes how you want the control to react whenever its container changes size
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Shadow_State | Determines if item is enabled (not shadowed)
TextColor | Sets the text color of the object
Window_Handle | Returns the Windows window handle of the DataFlex object
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cComDbActiveXControl_

View event list in alphabetical order

Name | Description
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from cComActiveXEntryControl_
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Refresh |
Inherited Events from cComActiveXControl
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Can perform a task each time the ActiveX control's 'binded' property is changed
OnCreate | Sent right after a COM object is created
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display |
Inherited Events from DfComUIObject
Command | Sent from external controls
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cComDbActiveXControl_

View method list in alphabetical order

Name | Type | Description
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from cComActiveXControl
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfInPlaceComObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object
RegisterComEvent | Procedure |
RegisterPropertyChangeEvent | Procedure |
ReleaseComObject | Procedure | Releases ActiveX control associated with this object
Inherited Methods from DfComUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
Release_Mouse_Capture | Procedure |
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cComDocumentObject

Properties Events Methods Index of Classes

Generates wrapper classes for imported Embedded Document objects

Hierarchy

cObject
---cUIObject
------DfComUIObject
---------DfInPlaceComObject
------------DFComDocumentObject
---------------cComDocumentObject

Library: Windows Application Class Library

Package: FlexCOM20.pkg

Mixins: Standard_Object_Mixin Shadow_Mixin RGB_Support_Temp_Mixin Help_Mixin

Description

This class is used to generate wrapper classes for imported Embedded Document objects.

Last Edited: July 14, 2003


Properties for cComDocumentObject

View property list in alphabetical order

Name | Description
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfInPlaceComObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key when ActiveX controls use a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from DfComUIObject
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Border_Style | Specifies the border style of this object
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
Mouse_Capture |
peAnchors | Describes how you want the control to react whenever its container changes size
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Shadow_State | Determines if item is enabled (not shadowed)
TextColor | Sets the text color of the object
Window_Handle | Returns the Windows window handle of the DataFlex object
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cComDocumentObject

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfInPlaceComObject
OnCreate |
Inherited Events from DfComUIObject
Command | Sent from external controls
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cComDocumentObject

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DFComDocumentObject
CreateComObjectFromFile | Procedure | Creates a new document and initializes it with data read in from the file passed in the sFile parameter
SaveToFile | Procedure |
Inherited Methods from DfInPlaceComObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object
RegisterComEvent | Procedure |
RegisterPropertyChangeEvent | Procedure |
ReleaseComObject | Procedure | Releases ActiveX control associated with this object
Inherited Methods from DfComUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
Release_Mouse_Capture | Procedure |
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCommandLine

Properties Events Methods Index of Classes

Encapsulates access to the command-line of the running program

Hierarchy

cObject
---cCommandLine

Library: Common (Windows and Web Application) Class Library

Package: cCommandLine.pkg

Description

An object of cCommandLine is automatically instantiated within the program's cApplication object to encapsulate the values of the command-line that was passed to the running program by Windows. To access this object, use the cApplication's phoCommandLine property.

Two methods are used to access the command-line: CountOfArgs returns the number of arguments that were passed; you can obtain the value of any argument by using the Argument function, passing it the index of the argument that you want.

When passing a command-line to the program, you can pass an argument containing a space by enclosing it within quotes, as in this example:

C:\Program FilesVisual DataFlex\Order\Programs\order.exe Customer "ABC, Inc" Good No

This would result in the program receiving four arguments: (1) Customer (2) ABC, Inc (3) Good (4) No. Notice that the quote marks are removed when the argument is received.

Note:This class supersedes use of the CmdLine command. A limitation of the CmdLine command is that once an argument was obtained, you could no longer gain access to it again as subsequent calls to CmdLine would return the next argument, etc. This class removes this limitation and ensures that you can access the command-line arguments as often as you desire and in any order. However, you can only use one of these options in your program. You can use either cCommandLine or CmdLine. To maintain compatibility with existing programs, this class will not "steal" the command-line, unless you specifically ask it to. That is, once you call either CountOfArgs or Argument, the class will take the contents of the command-line and store them internally. At this point, you will not be able to use the CmdLine in your program. Conversely, if you use CmdLine, then call either of these methods, they will not work (as CmdLine will have "stolen" the command-line.)

Example

In this example, the number of command-line arguments is displayed and then each argument is displayed.

Object oApplication is a cApplication

    Procedure OnCreate
        Handle hoCmdLine
        Integer iNumArgs iArg

        Get phoCommandLine To hoCmdLine
        Get CountOfArgs of hoCmdLine To iNumArgs

        Showln 'Number of command-line arguments=' iNumArgs
        For iArg from 1 to iNumArgs
            Showln 'Arg ' iArg ' :' (Argument(hoCmdLine, iArg))
        Loop

        Send DoOpenWorkspace 'Accounts'
    End_Procedure

End_Object // oApplication

See Also

cApplication

Last Edited: November 21, 2004


Properties for cCommandLine

View property list in alphabetical order

Name | Description
phoArgs | Holds the object-handle of the internal array
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCommandLine

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCommandLine

View method list in alphabetical order

Name | Type | Description
Argument | Function | Returns individual arguments from the program's command-line
CountOfArgs | Function | Returns the number of arguments passed to the program
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cComStdFont

Properties Events Methods Index of Classes

OLE conventions implement fonts as Automation objects that contain the properties of the font

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cComStdFont

Library: Common (Windows and Web Application) Class Library

Package: StdFont.pkg

Mixins: cComFont cComFontEvents

Description

OLE conventions implement fonts as Automation objects that contain the properties of the font. An object of this class is a wrapper object around a Windows font object, and all the common functionality for dealing with Windows fonts is provided in this class.

In many cases a COM object provides some way of changing a component's font. In this case you can access the font by creating an instance of the cComStdFont wrapper class and connect it to the OLE Font.

Typically, the COM object that you are dealing with will provide access to the OLE font by providing a function that returns an IDispatch* value that points to that font. You would then set the cComStdFont object's pvComObject property to the IDispatch* value to connect it with the OLE font.

For example the cComCalendar class used in the COM Sample application uses font objects to access the font attributes of the calendar's Day, Grid, and Title.

You can create a new OLE font object by sending CreateComObject to an instance of cComStdFont.

Example

Below is an example of how you would manipulate the calendar object's title font in the COM sample application. The procedure shown is the OnChange method of a checkbox object.

Procedure OnChange
    // click this checkbox to underline the Calendar Object's title.
    Handle  hoFont
    Variant vFont
    Boolean bIsComObjectCreated
    Boolean bChecked

    // test If the calendar COM Object is active. You
    // cannot access any COM interface methods unless
    // this is True!
    Get IsComObjectCreated of oCalendar1 to bIsComObjectCreated

    If (bIsComObjectCreated) Begin
        // Get the checkbox's current checked state...
        Get Checked_State to bChecked
        // create an instance of OLE Font wrapper class...
        Get Create U_cComStdFont to hoFont
        // Get an IDispatch* to the calendar's Title font
        Get ComTitleFont of oCalendar1 to vFont
        // bind our wrapper Object to the title font.....
        Set pvComObject of hoFont to vFont
        // now we can change the title font...
        Set ComUnderline of hoFont To bChecked
        // destroy the OLE Font wrapper now that we are
        // finished with it...
        Send Destroy of hoFont
    End
End_Procedure

See Also

cComAutomationObject | cComStdPicture

Last Edited: December 20, 2005


Properties for cComStdFont

View property list in alphabetical order

Name | Description
ComBold | Specifies whether the font is bold
ComCharset | Specifies the character set of the font
ComItalic | Specifies whether the font is italic
ComName | Holds the name of the font family
ComSize | Holds the point size of the font
ComStrikethrough | Specifies whether the font displays a strikethrough
ComUnderline | Specifies whether the font is underlined
ComWeight | Specifies the weight of the font
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cComStdFont

View event list in alphabetical order

Name | Description
OnComFontChanged |
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cComStdFont

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cComStdPicture

Properties Events Methods Index of Classes

OLE conventions implement pictures as Automation objects that contain the properties of the picture

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cComStdPicture

Library: Common (Windows and Web Application) Class Library

Package: StdPicture.pkg

Mixins: cComPicture

Description

OLE conventions implement pictures as Automation objects that contain the properties of the picture. An object of this class manages a bitmap, icon or metafile picture.

In many cases a COM object provides some way of changing a component's bitmap, icon or metafile. In this case you can access the picture by creating an instance of the cComStdPicture wrapper class and connect it to the OLE bitmap, icon or metafile.

Typically, the COM object that you are dealing with will provide access to the object by providing a function that returns an IDispatch* value that points to it. You would then set the cComStdPicture object's pvComObject property to the IDispatch* value to connect it with the OLE bitmap, icon or metafile.

You can create a new bitmap, icon or metafile object by sending CreateComObject to an instance of cComStdPicture.

For an example on how you would access an OLE picture object study the cComStdFont example.

See Also

cComAutomationObject | cComStdFont

Last Edited: December 20, 2005


Properties for cComStdPicture

View property list in alphabetical order

Name | Description
ComHandle | Returns the Windows GDI handle of the picture
ComHeight | Returns the height of the picture
ComHPal | Holds the Windows handle of the palette used by the picture
ComType | Returns the type of picture contained in the picture object
ComWidth | Returns the width of the picture
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cComStdPicture

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cComStdPicture

View method list in alphabetical order

Name | Type | Description
ComRender | Procedure | Draws the specified portion of the picture contained in this cComStdPicture object
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystal

Properties Events Methods Index of Classes

Enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports

Hierarchy

cObject
---cCrystal

Library: Common (Windows and Web Application) Class Library

Package: cCrystal.pkg

Description

Please read Using Crystal Reports in Applications for a conceptual understanding of working with Crystal Reports in Visual DataFlex. For help regarding the Crystal Reports RDC class model, refer to the Crystal RDC documentation.

The cCrystal class enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports. This class is used to contain all of the Crystal Report Design Component (RDC) COM objects.

The RDC is comprised of many COM objects. The most important COM class is cCrystalReport. An object of this instance is created when a report is run. Most of the customization of a report will be handled by sending messages to the cCrystal or cCrystalReport object.

This class has a limited number of interfaces:

  • The psReportName property determines which report is run.
  • The peOutputDestination property determines where the report is output.
  • The RunReport message is used to run a report. It opens, runs and closes the report.
  • The OnInitializeReport event is used is to initialize and customize a report.
  • The OnPrintReport, OnDisplayReport and OnExportReport events are used to customize output options

Object oCustomerReport is a cCrystal
    Set psReportName To "CustRpt.rpt"
    Set peOutputDestination to PRINT_TO_FILE

    Procedure OnInitializeReport Handle hoReport
        Forward Send OnInitializeReport hoReport

        Set ComRecordSelectionFormula of hoReport To ;
            "{wines.YEAR} <90 and {wines.COST} >6 and {wines.QUANTITY} >2"
    End_Procedure // OnInitializeReport
End_Object // oCustomerReport

Using The cCrystal Class

Creating Crystal Reports for Visual Dataflex

When you create a Crystal Reports report, you need to make sure that the report and the report's tables can be found by your VDF program. When creating a Crystal Reports report, we make the following recommendations:

  • Use Runtime Workspaces. This is the default behavior for a Studio-created VDF program.
  • Place your Crystal Report reports in the workspace's data path. Your workspace's data path may contain multiple paths so data and reports do not need to reside in the same directory. You only need to make sure that all data and all reports can be found within one of the data paths.

If the above steps are followed, VDF will locate report definitions and tables automatically.

Output Destinations

This class allows you to output your report to a printer, a preview window, or to export to a file. You may select a printer destination by setting the peOutputDestination property to one of three predefined constants (PRINT_TO_WINDOW, PRINT_TO_PRINTER, PRINT_TO_FILE). If the value of this property is not set, the default PRINT_TO_WINDOW will be used.

Print to Window

The PRINT_TO_WINDOW serves as a print preview. The report is displayed in a COM object within a View object. The properties of the view and the COM object can be set during an event of the cCrystal OnDisplayReport.

Sample

Object oMyReport is a cCrystal
    Set psReportName To "wines1.rpt"

    Procedure OnDisplayReport Handle hoReport
        Handle hoPreview

        Forward Send OnDisplayReport

        Get PreviewObject of hoReport to hoPreview
        If (hoPreview) Begin
            Set Label of hoPreview to "Sample Report Output"
        End
    End_Procedure // OnDisplayReport
End_Object // oMyReport

Print to Printer

The PRINT_TO_PRINTER sends the report directly to the printer. By default, the user will not be prompted for the printer setup. You can change this default behavior by setting pbPrinterPrompt to TRUE. The COM object properties and methods for the printer should be set during the event OnPrintReport. Using these COM methods, you can set the printer destination of the report without prompting the user, set the number of copies to print, set the page range to print, and more.

Sample

Set the number of copies to print.

Object oMyReport is a cCrystal
    Set psReportName To "wines1.rpt"
    Set peOutputDestination to PRINT_TO_PRINTER

    Procedure OnPrintReport Handle hoReport
        Forward Send OnPrintReport hoReport

        Set piPrinterCopies of hoReport to 2
    End_Procedure // OnPrintReport
End_Object // oMyReport

Send report to a predefined printer.

Object oMyReport is a cCrystal
    Set psReportName To "wines1.rpt"
    Set peOutputDestination to PRINT_TO_PRINTER

    Procedure OnPrintReport Handle hoReport
        Forward Send OnPrintReport hoReport

        Send ComSelectPrinter of hoReport "winspool" "Lexmark 3320" "LPT1:"
        Set ComPaperOrientation of hoReport to crLandscape
        Set ComPaperSize of hoReport to crPaperLetter
    End_Procedure // OnPrintReport
End_Object // oMyReport

Prompt for printer options

Object oMyReport is a cCrystal
    Set psReportName To "wines1.rpt"
    Set peOutputDestination to PRINT_TO_PRINTER

    Procedure OnPrintReport Handle hoReport
        Forward Send OnPrintReport hoReport

        Set pbPrinterPrompt of hoReport to TRUE
    End_Procedure // OnPrintReport
End_Object // oMyReport

Print to File

The PRINT_TO_FILE creates a document which can be saved to the hard drive, previewed in another application, or sent via MAPI. By default, the user will be prompted to set all the export options. If you are providing all the export options and do not want the users input, set the property pbExportPrompt to FALSE. The COM properties and methods for the export options should be set during the event OnExportReport.

Sample

Export as a PDF to MAPI

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"
    Set peOutputDestination to PRINT_TO_FILE

    Procedure OnExportReport Handle hoReport
        Handle hoExport

        Set pbExportPrompt of hoReport to FALSE
        Forward Send OnExportReport hoReport

        Get ExportObject of hoReport to hoExport
        If (hoExport) Begin
            Set ComDestinationType  of hoExport To crEDTEMailMAPI
            Set ComMailToListof hoExport to "someoneelse@hotmail.com"
            Set ComMailSubject of hoExport to "Testing"
            Set ComMailMessage of hoExport to "This is a test"
            Set ComMailBccList of hoExport to "someoneelse@hotmail.com"
            Set ComMailUserName of hoExport to "me@hotmail.com"
            Set ComMailPassword of hoExport to "secret"
            Set ComExportFileName of hoExport To "CustomerList.pdf"
            Set ComFormatType of hoExport To crEFTPortableDocFormat // PDF
        End
    End_Procedure // OnExportReport
End_Object // oCrystalReport

Export as RTF to file

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"
    Set peOutputDestination to PRINT_TO_FILE

    Procedure OnExportReport Handle hoReport
        Handle hoExport

        Set pbExportPrompt of hoReport to FALSE
        Forward Send OnExportReport hoReport

        Get ExportObject of hoReport to hoExport
        If (hoExport) Begin
            Set ComDiskFileName of hoExport To "D:\Documents\MyReport.rtf"
            Set ComFormatType of hoExport To crEFTExactRichText // Rich Text
        End
    End_Procedure // OnExportReport
End_Object // oCrystalReport

Sort Fields

You may change, delete, or add sort fields of a Crystal Reports report from VDF. Sort Fields determine the sort order of a Crystal Reports report. You can specify the sort direction of every sort field. Helper methods have been added to make this process easier. Use DeleteSortOrder to remove all fields from the current sort order. To add a sort field send AppendSortField with the name of the table, the field name, and the sort direction. The most common sort options you will use are crAscendingOrder and crDescendingOrder. To remove a single sort field, use DeleteNthSortField. Sort fields are 1-based.

Sample

Object oCrystalReport1 is a cCrystal
    Set psReportName to "CustLst.rpt"

    Procedure OnInitializeReport Handle hoReport
        Forward Send OnInitializeReport hoReport

        Send DeleteSortOrder of hoReport
        Send AppendSortField of hoReport "Customer" "State" crAscendingOrder
        Send AppendSortField of hoReport "Customer" "Zip"   crAscendingOrder
        Send AppendSortField of hoReport "Customer" "Name"  crDescendingOrder
    End_Procedure

End_Object

Formulas

Crystal Reports allows you to create variable fields called formulas. A formula typically contains code which can be use to calculate a value, or a set of "if/then" statements to determine what value it should be. A formula can also be a static value. Formulas can also be used as a label. A formula field in Crystal Reports is identified by the "@" sign in front of the formula name (i.e. "@CompanyName"). When you set a formula value from VDF, you do not use the "@" sign (i.e. "CompanyName").

List of some reasons to set a formula field

  • By using a formula field within your sort order, you can change the sort order by altering the value of your formula
  • By using a formula field for a group, you can change the group order by altering the value of your formula
  • By using the formula field within your selection formula, you can select a different set of records.
  • Your using the formula field as a label for your report to print runtime specific information (i.e. selection criteria, company name, user name)
  • Your using the formula field as a variable to perform calculations in another formula field.

Sample

Object oMyReport is a cCrystal
    Set psReportName To "wines1.rpt"

    Procedure OnInitializeReport Handle hoReport
        Forward Send OnInitializeReport hoReport

        // Don't supply the "@" sign with the formula name.
        Send AssignFormula of hoReport "ext_price" "{wines.QUANTITY} * {wines.COST}"
    End_Procedure // OnInitializeReport

End_Object // oMyReport

Record Selection Formula

A record selection formula is used to determine which records will be printed in your report. Crystal Reports will test every record in a file against the selection formula to determine if it should be printed. You may set a selection formula from VDF. If a selection formula exists in your report definition, it will be overridden.

Crystal Data Object (CDO)

CDO is a data source used within a report that only exists at runtime. A CDO is stored in memory and not as a physical file on the hard drive. This makes CDO's a great relpacement for temporary files because you don't have to clean them up and they are multi-user by nature.

CDO's can contain a variety of different datatypes (Please refer to your Crystal Reports documentation for a list of supported datatypes). You need to be aware of the datatype you want Crystal Reports to see your data as when you create your TTX file. When using the helper function AppendCDOData, VDF takes care of the datatypes for you. What that means is if you put a string value of "100" into a CDO field which is an integer datatype, the data will be converted to an integer. If you do not use the helper functions, all data you pass to the CDO will have to be cast in the proper datatype before attaching it to the CDO. Below is a list of CDO datatypes.

  • Each of the datatypes you use must be represented in the list of CDO datatypes.
  • The TTX file must be located in the same directory as the Crystal Reports report.
  • If changes to the CDO structure are required after the CDO has been added to the Crystal Reports report, you must create a new CDO or rename the existing CDO. You must also remove the existing CDO from the report and reimport it under a new name. The new CDO structure will not be recognized by Crystal Reports unless this is done.

CDO's are a great tool to help you accomplish some of those difficult reports. Here are some ideas on how you can use CDO's to simplify your report creation:

  • Merge multiple tables into a single CDO
  • Perform calculations using VDF code to fill fields that only exist in the CDO
  • Make your reports multi-user
  • Collect the data you will be reporting for a post-printing process (i.e. mark records printed, post checks)
  • Report data linked to a validation table
  • Read data from an external text file into a CDO.

CDO's can contain a variety of different datatypes (Please refer to your Crystal Reports documentation for a list of supported datatypes). You need to be aware of the datatype you want Crystal Reports to see your data as when you create your TTX file. When using the helper function AppendCDOData, VDF takes care of the datatypes for you which means you can put a string value of "100" into a CDO field which is an integer datatype. If you do not use the helper functions, all data you pass to the CDO will have to be cast in the proper datatype before attaching it to the CDO. Below is a list of CDO datatypes.

  • blob
  • boolean
  • byte
  • currency
  • date
  • datetime
  • long
  • memo
  • number
  • short
  • string

CDO Requirements

  • Each of the datatypes must be represented in the list of CDO datatypes.
  • The TTX file must be located in the same directory as the Crystal Reports report.
  • If changes to the CDO structure are required after the CDO has been added to the Crystal Reports report, you must create a new CDO or rename the existing CDO. You must also remove the existing CDO from the report and reimport it under a new name. The new CDO structure will not be recognized by Crystal Reports unless this is done.

Global Conversion Functions

Crystal Reports expects strings, numbers, dates, and integers to be in a specific format. Functions have been provided to return those formats.

  • CrystalDate
  • CrystalString
  • CrystalInteger
  • CrystalNumber

See Also

cCrystalReport | cCrystalExportOptions | Using Crystal Reports in Applications | Crystal RDC documentation

Last Edited: December 20, 2005


Properties for cCrystal

View property list in alphabetical order

Name | Description
Display_Error_State | Determines whether crystal errors will be sent to the error object
Output_Destination | (Obsolete) This method is obsolete and has been replaced by peOutputDestination.
pbAutoLocateDFFiles | Determines whether embedded database or INT files are automatically located
pbCanceled | Stops a report from running
pbCancelIfError | Determines if a report should be canceled if an error occurs
pbHasErrors | Is set to TRUE if an error occurred while printing the report
peOutputDestination | Indicates the destination of the report
phcExportObject | Controls the class used for the export object
phcPreviewObject | Controls the class used for the preview object.
phcReportObject | Controls the class used for the report and subreport objects
psReportName | The name of the Crystal report to be run when RunReport is received
Report_Name | (Obsolete) This method is obsolete and has been replaced by psReportName.
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystal

View event list in alphabetical order

Name | Description
OnDisplayReport | An event that is called when a report is about to be displayed to the previewer
onError | An event that is called when an error occurs during the running of a Crystal report
OnExportReport | An event that is called when a report is about to be exported to a file or application
OnInitializeReport | An event provided to initialize a Crystal Report
OnPrintReport | An event that is called when a report is about to be printed
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystal

View method list in alphabetical order

Name | Type | Description
ApplicationObject | Function | Returns handle of attached COM Application Object
CloseReport | Procedure | Used by RunReport to close a report
CrystalDate | Function | Returns a date as a string formatted for Crystal Reports
CrystalInteger | Function | Returns an integer as a string formatted for Crystal Reports
CrystalNumber | Function | Returns a number as a string formatted for Crystal Reports
CrystalString | Function | Returns a string as a string formatted for Crystal Reports
DisplayReport | Procedure | Used by RunReport todisplay a report
ExportReport | Procedure | Used by RunReport to export a report
OpenReport | Function | Used by RunReport to open a Crystal Report. Returns TRUE if it was successful
OutputReport | Procedure | Used by Runreport to output a report to the output destination
PrintReport | Procedure | Used by RunReport to print a report to the printer
ReportObject | Function | Returns handle of attached COM Crystal Report object
Run_Report | Procedure | (Obsolete) This method is obsolete and has been replaced by RunReport
RunReport | Procedure | Main message used to run a Crystal Report
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystal_ICRViewerSelectionEvents

Properties Events Methods Index of Classes

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystal_ICRViewerSelectionEvents

Library: Common (Windows and Web Application) Class Library

Package: cCrystalActiveXReportViewer.pkg

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerSelectionEvents object, refer to the Crystal RDC Report Viewer Object Model documentation. This link will take you to the Crystal Report Designer Component (RDC) Report Viewer/ActiveX Object Model page, which lists all objects and collections in the Crystal RDC Report Viewer. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystal_ICRViewerSelectionEvents

View property list in alphabetical order

Name | Description
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystal_ICRViewerSelectionEvents

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystal_ICRViewerSelectionEvents

View method list in alphabetical order

Name | Type | Description
ComSelectionStatusUpdate | Procedure |
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalActiveXReportViewer

Properties Events Methods Index of Classes

COM object used to access the ActiveXReportViewer object in the Crystal RDC object model

Hierarchy

cObject
---cUIObject
------DfComUIObject
---------DfInPlaceComObject
------------DfComActiveXControl
---------------cComActiveXControl
------------------cCrystalActiveXReportViewer

Library: Windows Application Class Library

Package: cCrystalActiveXReportViewer.pkg

Mixins: cCrystalICrystalReportViewer11 cCrystal_ICRViewerEvents

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalActiveXReportViewer object, refer to the Crystal RDC Report Viewer Object Model documentation. This link will take you to the Crystal Report Designer Component (RDC) Report Viewer/ActiveX Object Model page, which lists all objects and collections in the Crystal RDC Report Viewer. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: August 15, 2005


Properties for cCrystalActiveXReportViewer

View property list in alphabetical order

Name | Description
ComActiveViewIndex | ActiveViewIndex returns the 1-based index of the current view (tab)
ComDisplayBackgroundEdge | Determines if the report is offset from the edge of its view window.
ComDisplayBorder | DisplayBorder indicates if the viewer has a border
ComDisplayGroupTree | Determine if the group tree is visible
ComDisplayTabs | DisplayTabs indicates if the viewer has tabs for navigation between views
ComDisplayToolbar | Determine if the toolbar is visible
ComEnableAnimationCtrl | Determine if the animation control is visible
ComEnableCloseButton | Determine if the close button is visible
ComEnableDrillDown | Deterimine if drill down is allowed
ComEnableExportButton | Status of the Export toolbar button
ComEnableGroupTree | Determine if the group tree is available
ComEnableHelpButton | Enable the help button on the toolbar
ComEnableNavigationControls | Determines if the viewer has navigation controls
ComEnablePopupMenu | Determine if the pop menu is available
ComEnablePrintButton | Determine if the print button is visible
ComEnableProgressControl | Determine if the progress control will be shown
ComEnableRefreshButton | Determine if the Refresh button is visible
ComEnableSearchControl | Determine if the search control is visible
ComEnableSearchExpertButton | Status of the Search Expert toolbar button
ComEnableSelectExpertButton | Determine if the Select Expert button is showing
ComEnableStopButton | Determines if the viewer has a stop button
ComEnableToolbar | EnableToolbar indicates if the viewer has a toolbar (shown or hidden)
ComEnableZoomControl | Determine if the zoom control is visible
ComIsBusy | IsBusy indicates if the control is busy.
ComLaunchHTTPHyperlinksInNewBrowser | Launch HTTP Hyperlinks in a new browser
ComLocaleID | Get the locale ID
ComReportSource | Get the report source
ComTrackCursorInfo | Get the TrackCursorInfo object
ComViewCount | ViewCount returns the current number of views (tabs)
Inherited Properties from cComActiveXControl
ControlValue | Used as a hook to link a property in the ActiveX control with the Value Property
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Changed_State |
Item_Count |
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
pbBindValue | Controls whether an ActiveX's bindable property is bound to the Value property
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Value |
Inherited Properties from DfInPlaceComObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key when ActiveX controls use a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from DfComUIObject
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Border_Style | Specifies the border style of this object
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
Mouse_Capture |
peAnchors | Describes how you want the control to react whenever its container changes size
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Shadow_State | Determines if item is enabled (not shadowed)
TextColor | Sets the text color of the object
Window_Handle | Returns the Windows window handle of the DataFlex object
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalActiveXReportViewer

View event list in alphabetical order

Name | Description
OnComChangeObjectRect | x,y,width,height in document units (twips).
OnComClicked |
OnComCloseButtonClicked |
OnComContextMenu | x,y are screen coordinates. Set UseDefault to false if you want to display your own menu.
OnComDblClicked |
OnComDownloadFinished |
OnComDownloadStarted |
OnComDrillOnGraph |
OnComDrillOnGroup |
OnComDrillOnSubreport |
OnComExportButtonClicked |
OnComFirstPageButtonClicked |
OnComFocusChanged |
OnComGoToPageNClicked |
OnComGroupTreeButtonClicked |
OnComHelpButtonClicked |
OnComLastPageButtonClicked |
OnComLaunchHyperlink | Fired before launching a hyperlink. Set UseDefault to False to avoid launching. Change the hyperlink to redirect elsewhere.
OnComNextPageButtonClicked |
OnComPrevPageButtonClicked |
OnComPrintButtonClicked |
OnComRefreshButtonClicked |
OnComReportSourceError |
OnComSearchButtonClicked |
OnComSearchExpertButtonClicked |
OnComSelectionFormulaBuilt |
OnComSelectionFormulaButtonClicked |
OnComShowGroup |
OnComStopButtonClicked |
OnComViewChanged |
OnComViewChanging |
OnComViewClosed | Fired when a view closes
OnComZoomLevelChanged |
Inherited Events from cComActiveXControl
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Can perform a task each time the ActiveX control's 'binded' property is changed
OnCreate | Sent right after a COM object is created
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display |
Inherited Events from DfComUIObject
Command | Sent from external controls
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalActiveXReportViewer

View method list in alphabetical order

Name | Type | Description
ComActivateView | Procedure | ActivateView activates a particular view by 1-based index
ComAddView | Procedure | AddView adds a new view (tab). GroupPath can be a colon-delimited string (Country:State:City), a safe array of strings (Country, State, City), or a safe array of longs (1, 2, 0).
ComCloseView | Procedure | CloseView closes the view, given the 1-based index number of the view. S_FALSE is returned if the user was prompted to close drill-down or subreport views and elected not to proceed.
ComGetCurrentPageNumber | Function | GetCurrentPageNumber returns the page number of the report being viewed
ComGetGroup | Function | Get the group path of the current view. The the VT type of the VARIANT to control the type of result: VT_ARRAY | VT_I4 or VT_BSTR
ComGetLastPageNumber | Procedure | Get the last page number. The last page number may not have been calculated so it may not be known. For Visual Basic, a Long and a Boolean should be passed, Procedure style.
ComGetViewName | Function | GetViewName returns the current view's tab name and the current report document's name.
ComGetViewPath | Function | GetViewPath returns the path to the current view, given the 1-based index number of the view. Path contains a safe array of strings
ComPrintReport | Procedure | PrintReport initiates printing of the report in the current view
ComRefresh | Procedure | Refresh causes the view information to be reloaded and displayed
ComRefreshEx | Procedure | Refresh the report, optionally causing the server to refresh its data
ComSearchByFormula | Procedure | Search using the search formula. Search UI is shown if formula is empty.
ComSearchForText | Procedure | SearchForText allows searching for text across pages of the current view
ComShowFirstPage | Procedure | ShowFirstPage shows the first page of the current view
ComShowGroup | Procedure | ShowGroup displays the indicated group in the current view. GroupPath can be a colon-delimited string (Country:State:City), a safe array of strings (Country, State, City), or a safe array of longs (1, 2, 0).
ComShowLastPage | Procedure | ShowLastPage shows the last page of the current view
ComShowNextPage | Procedure | ShowNextPage shows the next page of the current view
ComShowNthPage | Procedure | ShowNthPage shows the desired page of the current view
ComShowPreviousPage | Procedure | ShowPreviousPage shows the previous page of the current view
ComViewReport | Procedure | ViewReport
ComZoom | Procedure | Zoom changes the display of the report. All numbers are percentages except: 1 - fit width, 2 - fit page
Inherited Methods from cComActiveXControl
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfInPlaceComObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object
RegisterComEvent | Procedure |
RegisterPropertyChangeEvent | Procedure |
ReleaseComObject | Procedure | Releases ActiveX control associated with this object
Inherited Methods from DfComUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
Release_Mouse_Capture | Procedure |
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalApplication

Properties Events Methods Index of Classes

COM object used to access the Application object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalApplication

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIApplication

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalApplication object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalApplication

View property list in alphabetical order

Name | Description
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalApplication

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalApplication

View method list in alphabetical order

Name | Type | Description
ComCanClose | Function | Returns whether it is safe to quit the application.
ComGetVersion | Function | Gets version number.
ComLogOffServer | Procedure | Log off server.
ComLogOnServer | Procedure | Log on server.
ComLogOnServerEx | Procedure | Log on server with server type or connect info.
ComNewReport | Function | Creates an empty report.
ComOpenReport | Function | Opens a specified report.
ComRunReportWizard | Procedure | Creates a report with the Report Wizard.
ComSetMatchLogOnInfo | Procedure | Sets global match log on info option.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalArea

Properties Events Methods Index of Classes

COM object used to access the Area object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalArea

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIArea

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalArea

View property list in alphabetical order

Name | Description
ComConditionFormula | Gets or sets section conditional formula.
ComCopiesToPrint | Gets or sets number of copy instance to print.
ComDetailHeight | Gets mailling label report detail area height (Twips).
ComDetailWidth | Gets multilple column report detail area width (Twips).
ComDiscardOtherGroups | Gets or sets discard other groups option.
ComEnableHierarchicalGroupSorting | Gets or sets group hierarchically flag.
ComGroupCondition | Gets or sets group condition.
ComGroupConditionField | Gets or sets group condition field.
ComGroupIndent | Gets or sets group indent (twips).
ComGroupNumber | Gets group number for this area if it is a group area.
ComHideForDrillDown | Gets or sets hide for drill down option.
ComHorizontalGap | Gets multiple column report horizontal gaps going across page.
ComInstanceIDField | Gets instance ID field.
ComKeepGroupTogether | Gets or sets keeping group together option.
ComKeepTogether | Gets or sets keeping area together option.
ComKind | Gets area kind.
ComName | Gets or sets area name.
ComNewPageAfter | Gets or sets new page after option.
ComNewPageBefore | Gets or sets new page before option.
ComNumberOfTopOrBottomNGroups | Gets or sets number of top or bottom groups
ComParent | Gets parent object(Report).
ComParentIDField | Gets parent ID field.
ComPrintAtBottomOfPage | Gets or sets printing at bottom of page option.
ComRepeatGroupHeader | Gets or sets repeating group header option.
ComResetPageNumberAfter | Gets or sets reset page number after option.
ComSections | Gets section collection within the area.
ComSortDirection | Gets or sets group sort direction.
ComSpecifiedGroups | Gets or sets the specifed groups
ComSuppress | Gets or sets area visibility.
ComTopOrBottomNGroupSortOrder | Gets or set top or bottom n group sort order
ComTopOrBottomNSortField | Gets or sets top or bottom n sort field.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalArea

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalArea

View method list in alphabetical order

Name | Type | Description
ComSetInstanceIDField | Procedure | Sets instance ID field.
ComSetParentIDField | Procedure | Sets parent ID field.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalAreas

Properties Events Methods Index of Classes

COM object used to access the Areas object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalAreas

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIAreas

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalAreas object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalAreas

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets areas parent.(report)
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalAreas

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalAreas

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalBlobFieldObject

Properties Events Methods Index of Classes

COM object used to access the BlobFieldObject object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalBlobFieldObject

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIBlobFieldObject

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalBlobFieldObject

View property list in alphabetical order

Name | Description
ComBackColor | Gets or sets object background color.
ComBorderColor | Gets or sets object border color.
ComBottomCropping | Gets or sets bottom cropping size (twips).
ComBottomLineStyle | Gets or sets bottom line style.
ComCloseAtPageBreak | Gets or sets close border on page break.
ComConditionFormula | Gets or sets conditional formula.
ComCssClass | Gets or sets CSS class.
ComField | Gets database field.
ComHasDropShadow | Gets or sets border drop shadow.
ComHeight | Gets or sets object height (twips).
ComHyperlinkText | Gets or sets hyperlink text.
ComHyperlinkType | Gets or sets hyperlink type.
ComKeepTogether | Gets or sets keep object together.
ComKind | Gets report object kind.
ComLeft | Gets or sets object upper left position (twips).
ComLeftCropping | Gets or sets left cropping size (twips).
ComLeftLineStyle | Gets or sets left line style.
ComName | Gets or sets object name.
ComParent | Gets object parent (Section).
ComRightCropping | Gets or sets right cropping size (twips).
ComRightLineStyle | Gets or sets right line style.
ComSuppress | Gets or sets object visibility.
ComTop | Gets or sets object upper top position (twips).
ComTopCropping | Gets or sets top cropping size (twips).
ComTopLineStyle | Gets or sets top line style.
ComWidth | Gets or sets object width (twips).
ComXScaling | Gets or sets width scaling factor. E.g. 1 means 100%, 2 means 200%, 0.5 means 50%, etc. Range from 0.01 to 100.
ComYScaling | Gets or sets height scaling factor. E.g. 1 means 100%, 2 means 200%, 0.5 means 50%, etc. Range from 0.01 to 100.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalBlobFieldObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalBlobFieldObject

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalBoxObject

Properties Events Methods Index of Classes

COM object used to access the BoxObject object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalBoxObject

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIBoxObject

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalBoxObject

View property list in alphabetical order

Name | Description
ComBottom | Gets or sets object lower bottom position (twips).
ComBottomRightSection | Gets bottom right section.
ComCloseAtPageBreak | Gets or sets close border on page break.
ComConditionFormula | Gets or sets conditional formula.
ComCornerEllipseHeight | Gets or sets corner ellipse height.
ComCornerEllipseWidth | Gets or sets corner ellipse width.
ComCssClass | Gets or sets CSS class.
ComExtendToBottomOfSection | Gets or sets extend to bottom of section option.
ComFillColor | Gets or sets fill color.
ComHasDropShadow | Gets or sets border drop shadow.
ComKind | Gets report object kind.
ComLeft | Gets or sets object upper left position (twips).
ComLineColor | Gets or sets line color.
ComLineStyle | Gets or sets line style.
ComLineThickness | Gets or sets box line thickness (twips).
ComName | Gets or sets object name.
ComParent | Gets object parent (Section).
ComRight | Gets or sets object lower right position (twips).
ComSuppress | Gets or sets object visibility.
ComTop | Gets or sets object upper top position (twips).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalBoxObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalBoxObject

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalConnectionProperties

Properties Events Methods Index of Classes

COM object used to access the ConnectionProperties object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalConnectionProperties

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalINameValuePairs

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalConnectionProperties object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalConnectionProperties

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets value by name.
ComNameIDs | Gets all names in name value pairs
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalConnectionProperties

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalConnectionProperties

View method list in alphabetical order

Name | Type | Description
ComAdd | Procedure | Adds a name value pair
ComDelete | Procedure | Deletes a name value pair
ComDeleteAll | Procedure | Deletes all name value pairs
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalConnectionProperty

Properties Events Methods Index of Classes

COM object used to access the ConnectionProperty object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalConnectionProperty

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIConnectionProperty

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalConnectionProperty object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalConnectionProperty

View property list in alphabetical order

Name | Description
ComChildProperties | Gets the child properties of this property in a hierarchical property structure.
ComDescription | Gets or sets the connection property description
ComLocalizedName | Gets or sets the connection property localized name
ComName | Gets or sets the connection property name
ComValue | Gets or sets the connection property value
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalConnectionProperty

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalConnectionProperty

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCRCrystalReportViewerViewInfo

Properties Events Methods Index of Classes

COM object used to access the CRCrystalReportViewerViewInfo object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCRCrystalReportViewerViewInfo

Library: Common (Windows and Web Application) Class Library

Package: cCrystalActiveXReportViewer.pkg

Mixins: cCrystalICrystalReportViewerViewInfo

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCRCrystalReportViewerViewInfo object, refer to the Crystal RDC Report Viewer Object Model documentation. This link will take you to the Crystal Report Designer Component (RDC) Report Viewer/ActiveX Object Model page, which lists all objects and collections in the Crystal RDC Report Viewer. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCRCrystalReportViewerViewInfo

View property list in alphabetical order

Name | Description
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCRCrystalReportViewerViewInfo

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCRCrystalReportViewerViewInfo

View method list in alphabetical order

Name | Type | Description
ComGetGroupPath | Function | VARIANT contains a safe array of integers. vt = VT_I4 | VT_ARRAY
ComGetReportName | Function |
ComGetSubreportName | Function |
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCrossTabGroup

Properties Events Methods Index of Classes

COM object used to access the CrossTabGroup object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCrossTabGroup

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalICrossTabGroup

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCrossTabGroup object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCrossTabGroup

View property list in alphabetical order

Name | Description
ComBackColor | Gets or sets crosstab group's back color.
ComCondition | Gets or sets crosstab group's condition.
ComEnableSuppressLabel | Gets or sets crosstab group's enable suppress label.
ComEnableSuppressSubtotal | Gets or sets crosstab group's enable suppress subtotal.
ComField | Gets or sets crosstab group's field.
ComParent | Gets crosstab group's parent.
ComSortDirection | Gets or sets crosstab group's sort direction.
ComSpecifiedGroups | Gets or sets the specifed groups from a row or column group in the crosstab
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCrossTabGroup

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCrossTabGroup

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCrossTabGroups

Properties Events Methods Index of Classes

COM object used to access the CrossTabGroups object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCrossTabGroups

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalICrossTabGroups

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCrossTabGroups object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCrossTabGroups

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets crosstab groups count.
ComItem | Gets crosstab groups item.
ComParent | Gets crosstab groups' parent (crosstab object).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCrossTabGroups

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCrossTabGroups

View method list in alphabetical order

Name | Type | Description
ComAdd | Function | Adds a crosstab group
ComDelete | Procedure | Deletes a crosstab group
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCrossTabObject

Properties Events Methods Index of Classes

COM object used to access the CrossTabObject object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCrossTabObject

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalICrossTabObject

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCrossTabObject

View property list in alphabetical order

Name | Description
ComBackColor | Gets or sets object background color.
ComBorderColor | Gets or sets object border color.
ComBottomLineStyle | Gets or sets bottom line style.
ComCloseAtPageBreak | Gets or sets close border on page break.
ComColumnGrandTotalColor | Gets or sets column grand totals color.
ComColumnGroups | Gets column groups.
ComConditionFormula | Gets or sets conditional formula.
ComCssClass | Gets or sets CSS class.
ComEnableKeepColumnsTogether | Gets or sets enable keep columns together.
ComEnableRepeatRowLabels | Gets or sets enable repeat row labels.
ComEnableShowCellMargins | Gets or sets enable show cell margins.
ComEnableShowGrid | Gets or sets enable show grid.
ComEnableSuppressColumnGrandTotals | Gets or sets enable suppress column grand totals.
ComEnableSuppressEmptyColumns | Gets or sets enable suppress empty columns.
ComEnableSuppressEmptyRows | Gets or sets enable suppress empty rows.
ComEnableSuppressRowGrandTotals | Gets or sets enable suppress row grand totals.
ComHasDropShadow | Gets or sets border drop shadow.
ComHeight | Gets object height (twips).
ComHyperlinkText | Gets or sets hyperlink text.
ComHyperlinkType | Gets or sets hyperlink type.
ComKeepTogether | Gets or sets keep object together.
ComKind | Gets report object kind.
ComLeft | Gets or sets object upper left position (twips).
ComLeftLineStyle | Gets or sets left line style.
ComName | Gets or sets object name.
ComParent | Gets object parent (Section).
ComRightLineStyle | Gets or sets right line style.
ComRowGrandTotalColor | Gets or sets row grand totals color.
ComRowGroups | Gets row groups.
ComSummaryFields | Gets summary fields.
ComSuppress | Gets or sets object visibility.
ComTop | Gets or sets object upper top position (twips).
ComTopLineStyle | Gets or sets top line style.
ComWidth | Gets object width (twips).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCrossTabObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCrossTabObject

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCRVEventInfo

Properties Events Methods Index of Classes

COM object used to access the CRVEventInfo object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCRVEventInfo

Library: Common (Windows and Web Application) Class Library

Package: cCrystalActiveXReportViewer.pkg

Mixins: cCrystalICRVEventInfo

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCRVEventInfo object, refer to the Crystal RDC Report Viewer Object Model documentation. This link will take you to the Crystal Report Designer Component (RDC) Report Viewer/ActiveX Object Model page, which lists all objects and collections in the Crystal RDC Report Viewer. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCRVEventInfo

View property list in alphabetical order

Name | Description
ComCanDrillDown | Indicates if the object is drillable
ComIndex | Index
ComParentIndex | Parent's index
ComText | Object's Text
ComType | Object type
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCRVEventInfo

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCRVEventInfo

View method list in alphabetical order

Name | Type | Description
ComGetFields | Function | Get the fields collection
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCRVField

Properties Events Methods Index of Classes

COM object used to access the CRVField object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCRVField

Library: Common (Windows and Web Application) Class Library

Package: cCrystalActiveXReportViewer.pkg

Mixins: cCrystalICRField

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCRVField object, refer to the Crystal RDC Report Viewer Object Model documentation. This link will take you to the Crystal Report Designer Component (RDC) Report Viewer/ActiveX Object Model page, which lists all objects and collections in the Crystal RDC Report Viewer. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCRVField

View property list in alphabetical order

Name | Description
ComFieldType | property FieldType
ComIsRawData | property IsRawData
ComName | property Name
ComValue | property Value
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCRVField

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCRVField

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCRVFields

Properties Events Methods Index of Classes

COM object used to access the CRVFields object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCRVFields

Library: Common (Windows and Web Application) Class Library

Package: cCrystalActiveXReportViewer.pkg

Mixins: cCrystalICRFields

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCRVFields object, refer to the Crystal RDC Report Viewer Object Model documentation. This link will take you to the Crystal Report Designer Component (RDC) Report Viewer/ActiveX Object Model page, which lists all objects and collections in the Crystal RDC Report Viewer. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCRVFields

View property list in alphabetical order

Name | Description
Com_NewEnum | Fields Collection
ComCount | Number of items in the collection
ComItem | Item - index is 1-based
ComSelectedFieldIndex | Index of the selected field
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCRVFields

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCRVFields

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCRVParameterPromptRuntimeOM

Properties Events Methods Index of Classes

COM object used to access the CRVParameterPromptRuntimeOM object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCRVParameterPromptRuntimeOM

Library: Common (Windows and Web Application) Class Library

Package: cCrystalActiveXReportViewer.pkg

Mixins: cCrystalICRVParameterPromptRuntimeOM

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCRVParameterPromptRuntimeOM object, refer to the Crystal RDC Report Viewer Object Model documentation. This link will take you to the Crystal Report Designer Component (RDC) Report Viewer/ActiveX Object Model page, which lists all objects and collections in the Crystal RDC Report Viewer. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCRVParameterPromptRuntimeOM

View property list in alphabetical order

Name | Description
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCRVParameterPromptRuntimeOM

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCRVParameterPromptRuntimeOM

View method list in alphabetical order

Name | Type | Description
ComSubmit | Procedure | submit the form data
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCRVSelectionItem

Properties Events Methods Index of Classes

COM object used to access the CRVSelectionItem object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCRVSelectionItem

Library: Common (Windows and Web Application) Class Library

Package: cCrystalActiveXReportViewer.pkg

Mixins: cCrystalICRVSelectionItem

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCRVSelectionItem object, refer to the Crystal RDC Report Viewer Object Model documentation. This link will take you to the Crystal Report Designer Component (RDC) Report Viewer/ActiveX Object Model page, which lists all objects and collections in the Crystal RDC Report Viewer. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCRVSelectionItem

View property list in alphabetical order

Name | Description
ComObjectName | Object Name
ComObjectPosition | Object Position
ComObjectType | Object Type
ComPageNumber | Page Number
ComSectionGroupNamePath | Group Name Path
ComSectionName | Section Name
ComSectionType | Section Type
ComSelectionUsesViewContext | Selection Uses View Context
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCRVSelectionItem

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCRVSelectionItem

View method list in alphabetical order

Name | Type | Description
ComGetSectionGroupPath | Function | Get Section Group Path
ComGetViewContext | Function | Get Section Group Path
ComPutSectionGroupPath | Function | Put Section Group Path
ComPutViewContext | Function | Put Section Group Path
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCRVSelectionItems

Properties Events Methods Index of Classes

COM object used to access the CRVSelectionItems object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCRVSelectionItems

Library: Common (Windows and Web Application) Class Library

Package: cCrystalActiveXReportViewer.pkg

Mixins: cCrystalICRVSelectionItems

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCRVSelectionItems object, refer to the Crystal RDC Report Viewer Object Model documentation. This link will take you to the Crystal Report Designer Component (RDC) Report Viewer/ActiveX Object Model page, which lists all objects and collections in the Crystal RDC Report Viewer. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCRVSelectionItems

View property list in alphabetical order

Name | Description
ComCount | Item count
ComItem | Get an item
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCRVSelectionItems

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCRVSelectionItems

View method list in alphabetical order

Name | Type | Description
ComAddItem | Function |
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCRVTrackCursorInfo

Properties Events Methods Index of Classes

COM object used to access the CRVTrackCursorInfo object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCRVTrackCursorInfo

Library: Common (Windows and Web Application) Class Library

Package: cCrystalActiveXReportViewer.pkg

Mixins: cCrystalICRVTrackCursorInfo

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCRVTrackCursorInfo object, refer to the Crystal RDC Report Viewer Object Model documentation. This link will take you to the Crystal Report Designer Component (RDC) Report Viewer/ActiveX Object Model page, which lists all objects and collections in the Crystal RDC Report Viewer. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCRVTrackCursorInfo

View property list in alphabetical order

Name | Description
ComDetailAreaCursor | Get the DetailAreaCursor type
ComDetailAreaFieldCursor | Get the DetailAreaFieldCursor type
ComGraphCursor | Get the GraphCursor type
ComGroupAreaCursor | Get the GroupAreaCursor type
ComGroupAreaFieldCursor | Get the GroupAreaFieldCursor type
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCRVTrackCursorInfo

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCRVTrackCursorInfo

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCrystalComObject

Properties Events Methods Index of Classes

COM object used to access the CrystalComObject object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCrystalComObject

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcdo32.pkg

Mixins: cCrystalICrystalDataObject

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCrystalComObject object, refer to the Crystal Data Source Object Models documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCrystalComObject

View property list in alphabetical order

Name | Description
ComRowCount | property RowCount
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCrystalComObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCrystalComObject

View method list in alphabetical order

Name | Type | Description
ComAddField | Function | method AddField
ComAddRows | Procedure | method AddRows
ComDeleteField | Function | method DeleteField
ComGetColCount | Function | method GetColCount
ComGetEOF | Function | method getEOF
ComGetFieldData | Function | method GetFieldData
ComGetFieldName | Function | method GetFieldName
ComGetFieldType | Function | method GetFieldType
ComMoveFirst | Function | method MoveFirst
ComMoveNext | Function | method MoveNext
ComMoveTo | Function | method MoveTo
ComReset | Procedure | method Reset
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalCSFontDescription

Properties Events Methods Index of Classes

COM object used to access the CSFontDescription object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalCSFontDescription

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalICSFontDescription

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalCSFontDescription object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalCSFontDescription

View property list in alphabetical order

Name | Description
ComEffects | Gets or sets effects.
ComFaceName | Gets or sets face name.
ComFontType | Gets or sets font type.
ComMask | Gets or sets mask.
ComPitchAndFamily | Gets or sets pitchAndFamily.
ComSize | Gets or sets size.
ComWeight | Gets or sets weight.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalCSFontDescription

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalCSFontDescription

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalDatabase

Properties Events Methods Index of Classes

COM object used to access the Database object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalDatabase

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIDatabase

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalDatabase object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalDatabase

View property list in alphabetical order

Name | Description
ComLinks | Gets database link collection.
ComParent | Gets database parent (Report).
ComTables | Gets database table collection.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalDatabase

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalDatabase

View method list in alphabetical order

Name | Type | Description
ComAddADOCommand | Procedure | Add a database table through ADO connection and command.
ComAddOLEDBSource | Procedure | Add a database table through OLE DB provider.
ComLogOffServer | Procedure | Log off server.
ComLogOnServer | Procedure | Log on server.
ComLogOnServerEx | Procedure | Log on server with server type or connect info.
ComSetDataSource | Procedure | sets specified table data source
ComVerify | Procedure | Verifies the database.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalDatabaseFieldDefinition

Properties Events Methods Index of Classes

COM object used to access the DatabaseFieldDefinition object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalDatabaseFieldDefinition

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIDatabaseFieldDefinition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalDatabaseFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalDatabaseFieldDefinition

View property list in alphabetical order

Name | Description
ComDatabaseFieldDisplayName | Gets database field display name.
ComDatabaseFieldName | Gets database field name.
ComKind | Gets field definition kind.
ComName | Gets field definition unique formula name.
ComNextValue | Gets field next value.
ComNumberOfBytes | Gets field number of bytes.
ComParent | Gets database field parent (Report).
ComPreviousValue | Gets field previous value.
ComTableAliasName | Gets table alias name the field is in.
ComValue | Gets field value.
ComValueType | Gets field value type.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalDatabaseFieldDefinition

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalDatabaseFieldDefinition

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalDatabaseFieldDefinitions

Properties Events Methods Index of Classes

COM object used to access the DatabaseFieldDefinitions object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalDatabaseFieldDefinitions

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIDatabaseFieldDefinitions

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalDatabaseFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalDatabaseFieldDefinitions

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets database field collection parent (DatabaseTable).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalDatabaseFieldDefinitions

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalDatabaseFieldDefinitions

View method list in alphabetical order

Name | Type | Description
ComGetItemByName | Function | Gets collection item by name index.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalDatabaseTable

Properties Events Methods Index of Classes

COM object used to access the DatabaseTable object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalDatabaseTable

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIDatabaseTable

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalDatabaseTable

View property list in alphabetical order

Name | Description
ComConnectBufferString | Gets or sets table connection string.
ComConnectionProperties | Gets the connection log on properties collection of a table.
ComDatabaseType | Gets table type.
ComDllName | Gets or sets table driver dll name.
ComFields | Gets database field definition collection.
ComLocation | Gets or sets table location.
ComName | Gets or sets table alias name.
ComParent | Gets database table parent (Database).
ComQualifiers | Gets the table's full qualifiers.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalDatabaseTable

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalDatabaseTable

View method list in alphabetical order

Name | Type | Description
ComCheckDifferences | Procedure | Checks table differences.
ComSetDataSource | Procedure | Sets table data source.
ComSetTableLocation | Procedure | Sets table location.
ComTestConnectivity | Function | Tests table connectivity.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalDatabaseTables

Properties Events Methods Index of Classes

COM object used to access the DatabaseTables object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalDatabaseTables

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIDatabaseTables

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalDatabaseTables object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalDatabaseTables

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets database table collection parent (Database).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalDatabaseTables

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalDatabaseTables

View method list in alphabetical order

Name | Type | Description
ComAdd | Procedure | Adds a database table.
ComAddStoredProcedure | Procedure | Adds a stored procedure.
ComDelete | Procedure | Delete a database table.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalExportOptions

Properties Events Methods Index of Classes

COM object used to access the ExportOptions object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalExportOptions

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIExportOptions

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalExportOptions

View property list in alphabetical order

Name | Description
ComApplicationFileName | Gets or sets destination application file name.
ComCharFieldDelimiter | Gets or sets char field delimiter.
ComCharStringDelimiter | Gets or sets char string delimiter.
ComDestinationDllName | Gets export destination dll name.
ComDestinationType | Gets or sets export destination type.
ComDiskFileName | Gets or sets destination disk file name.
ComExcelAreaGroupNumber | Gets or sets the base area group number if the area type is group area when exporting to Excel.
ComExcelAreaType | Gets or sets the base area type if not using constant column width when exporting to Excel.
ComExcelChopPageHeader | Gets or sets export to Excel chop page heaader option.
ComExcelConstantColumnWidth | Gets or sets the column width when exporting to Excel.
ComExcelConvertDateToString | Gets or sets export to Excel has converting date values to strings option.
ComExcelExportAllPages | Gets or sets export to Excel with all pages.
ComExcelExportImagesInDataOnly | Gets or sets export to Excel including image in data only option.
ComExcelExportPageAreaPair | Gets or sets export to Excel page header and footer options.
ComExcelFirstPageNumber | Gets or sets export to Excel for first page number.
ComExcelLastPageNumber | Gets or sets export to Excel for last page number.
ComExcelMaintainColumnAlignment | Gets or sets export to Excel column alignment option.
ComExcelMaintainRelativeObjectPosition | Gets or sets export to Excel maintain relative object position option.
ComExcelPageBreaks | Gets or sets export to Excel has page break option.
ComExcelShowGridlines | Gets or sets export to Excel show gridlines option.
ComExcelTabHasColumnHeadings | Gets or sets exporting to Excel has column headings option.
ComExcelUseConstantColumnWidth | Gets or sets export to Excel to use constant column width.
ComExcelUseFormatInDataOnly | Gets or sets export to Excel including object formats and fonts in data only option.
ComExcelUseTabularFormat | Gets or sets exporting to Excel to use tabular format.
ComExcelUseWorksheetFunctions | Gets or sets export to Excel to use worksheet functions to represent subtotal fields in the report.
ComExchangeDestinationType | Gets or sets exchange destination type.
ComExchangeFolderPath | Gets or sets exchange folder path.
ComExchangePassword | Sets exchange password.
ComExchangeProfile | Gets or sets export to Exchange profile.
ComExportPageBreaks | Gets or sets insert page break option.
ComFormatDllName | Gets export format dll name.
ComFormatType | Gets or sets export format type.
ComHTMLEnableSeparatedPages | Gets or sets export to HTML for separated pages.
ComHTMLFileName | Gets or sets HTML file name.
ComHTMLHasPageNavigator | Gets or sets export to HTML to have page navigator.
ComLotusDominoComments | Gets or sets destination Lotus Domino comments.
ComLotusDominoDatabaseName | Gets or sets destination Lotus Domino database name.
ComLotusDominoFormName | Gets or sets destination Lotus Domino form name.
ComMailBccList | Gets or sets mail Bcc list.
ComMailCcList | Gets or sets mail cc list.
ComMailMessage | Gets or sets mail message.
ComMailPassword | Gets or sets mail user password.
ComMailSubject | Gets or sets mail subjects.
ComMailToList | Gets or sets mail to list.
ComMailUserName | Gets or sets mail user name.
ComNumberOfLinesPerPage | Gets or sets number of line per page option.
ComODBCDataSourceName | Gets or sets ODBC data source name.
ComODBCDataSourcePassword | Sets ODBC data source password.
ComODBCDataSourceUserID | Gets or sets ODBC data source user ID.
ComODBCExportTableName | Gets or sets ODBC table name.
ComParent | Gets export options' parent (IReport)
ComPDFExportAllPages | Gets or sets export to PDF with all pages.
ComPDFFirstPageNumber | Gets or sets export to PDF for first page number.
ComPDFLastPageNumber | Gets or sets export to PDF for last page number.
ComRTFExportAllPages | Gets or sets export to RTF with all pages.
ComRTFFirstPageNumber | Gets or sets export to RTF for first page number.
ComRTFLastPageNumber | Gets or sets export to RTF for last page number.
ComUseDefaultCharactersPerInch | Gets or sets use default characters per inch option.
ComUserDefinedCharactersPerInch | Gets or sets user defined characters per inch.
ComUseReportDateFormat | Gets or sets use report date format option.
ComUseReportNumberFormat | Gets or sets use report number format option.
ComWORDWExportAllPages | Gets or sets export to Word with all pages.
ComWORDWFirstPageNumber | Gets or sets export to Word for first page number.
ComWORDWLastPageNumber | Gets or sets export to Word for last page number.
ComXMLAllowMultipleFiles | Gets or sets XML allow multiple files.
ComXMLFileName | Gets or sets XML file name.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalExportOptions

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalExportOptions

View method list in alphabetical order

Name | Type | Description
ComPromptForExportOptions | Procedure | Prompts for export options.
ComReset | Procedure | Resets export options.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalFieldDefinitions

Properties Events Methods Index of Classes

COM object used to access the FieldDefinitions object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalFieldDefinitions

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIFieldDefinitions

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalFieldDefinitions

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets field collection parent (ReportObject).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalFieldDefinitions

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalFieldDefinitions

View method list in alphabetical order

Name | Type | Description
ComAdd | Procedure | Adds a field.
ComDelete | Procedure | Delete a field.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalFieldElement

Properties Events Methods Index of Classes

COM object used to access the FieldElement object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalFieldElement

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIFieldElement

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalFieldElement

View property list in alphabetical order

Name | Description
ComAmPmType | Gets or sets AM/PM type.
ComAmString | Gets or sets AM string.
ComBooleanOutputType | Gets or sets boolean output type.
ComCharacterSpacing | Gets or sets character spacing.
ComColor | Gets or sets field element color.
ComConditionFormula | Gets or sets conditional formula.
ComCurrencyPositionType | Gets or sets currency position type.
ComCurrencySymbol | Gets or sets currency symbol.
ComCurrencySymbolType | Gets or sets currency symbol type.
ComDateCalendarType | Gets or sets date calendar type.
ComDateEraType | Gets or sets date era type.
ComDateFirstSeparator | Gets or sets date first separator.
ComDateOrder | Gets or sets date order.
ComDatePrefixSeparator | Gets or sets date prefix separator.
ComDateSecondSeparator | Gets or sets date second separator.
ComDateSuffixSeparator | Gets or sets date suffix separator.
ComDateWindowsDefaultType | Gets or sets date windows default type.
ComDayType | Gets or sets day type.
ComDecimalPlaces | Gets or sets number decimal places.
ComDecimalSymbol | Gets or sets decimal symbol.
ComDisplayReverseSign | Gets or sets reverse sign option.
ComFieldDefinition | Gets or sets field definition
ComFirstLineIndent | Gets or sets first line indent.
ComFont | Gets or sets standard OLE font.
ComHourMinuteSeparator | Gets or sets hour minute separator.
ComHourType | Gets or sets hour type.
ComLeadingDayPosition | Gets or sets leading day position type.
ComLeadingDaySeparator | Gets or sets leading day separator.
ComLeadingDayType | Gets or sets leading day type.
ComLeftIndent | Gets or sets left indent.
ComLineSpacing | Gets or sets line spacing.
ComLineSpacingType | Gets or sets line spacing type.
ComMaxNumberOfLines | Gets or sets max of number of line for string memo field.
ComMinuteSecondSeparator | Gets or sets minute second separator.
ComMinuteType | Gets or sets minute type.
ComMonthType | Gets or sets month type.
ComNegativeType | Gets or sets number negative type.
ComParent | Gets parent object(fieldElements).
ComPmString | Gets or sets PM string.
ComRightIndent | Gets or sets right indent.
ComRoundingType | Gets or sets number rounding type.
ComSecondType | Gets or sets second type.
ComSuppressIfDuplicated | Gets or sets suppress if duplicated option.
ComSuppressIfZero | Gets or sets suppress if zero option.
ComTextFormat | Gets or sets text format option for string memo field.
ComThousandsSeparators | Gets or sets enable number thousands separators.
ComThousandSymbol | Gets or sets thousand symbol.
ComTimeBase | Gets or sets time base.
ComUseLeadingZero | Gets or sets number uses leading zero option.
ComUseOneSymbolPerPage | Gets or sets use one symbol per page option.
ComUseSystemDefaults | Gets or sets use system defaults formatting option.
ComYearType | Gets or sets year type.
ComZeroValueString | Gets or sets zero value string for number field format.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalFieldElement

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalFieldElement

View method list in alphabetical order

Name | Type | Description
ComSetLineSpacing | Procedure | Sets line spacing type and line spacing.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalFieldElements

Properties Events Methods Index of Classes

COM object used to access the FieldElements object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalFieldElements

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIFieldElements

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalFieldElements object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalFieldElements

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets field elements parent.(textObject)
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalFieldElements

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalFieldElements

View method list in alphabetical order

Name | Type | Description
ComAdd | Procedure | Adds an embedded field element
ComDelete | Procedure | Deletes a embedded field element
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalFieldMappingData

Properties Events Methods Index of Classes

COM object used to access the FieldMappingData object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalFieldMappingData

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIFieldMappingData

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalFieldMappingData object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalFieldMappingData

View property list in alphabetical order

Name | Description
ComFieldName | Gets or sets field name.
ComMappingToFieldIndex | Gets or sets the mapping to field's index in the new database's field list.
ComTableName | Gets or sets field's table name.
ComValueType | Gets or sets field's value type.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalFieldMappingData

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalFieldMappingData

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalFieldObject

Properties Events Methods Index of Classes

COM object used to access the FieldObject object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalFieldObject

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIFieldObject

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalFieldObject

View property list in alphabetical order

Name | Description
ComAmPmType | Gets or sets AM/PM type.
ComAmString | Gets or sets AM string.
ComBackColor | Gets or sets object background color.
ComBooleanOutputType | Gets or sets boolean output type.
ComBorderColor | Gets or sets object border color.
ComBottomLineStyle | Gets or sets bottom line style.
ComCanGrow | Gets or sets can grow option.
ComCharacterSpacing | Gets or sets character spacing.
ComCloseAtPageBreak | Gets or sets close border on page break.
ComConditionFormula | Gets or sets conditional formula.
ComCssClass | Gets or sets CSS class.
ComCurrencyPositionType | Gets or sets currency position type.
ComCurrencySymbol | Gets or sets currency symbol.
ComCurrencySymbolType | Gets or sets currency symbol type.
ComDateCalendarType | Gets or sets date calendar type.
ComDateEraType | Gets or sets date era type.
ComDateFirstSeparator | Gets or sets date first separator.
ComDateOrder | Gets or sets date order.
ComDatePrefixSeparator | Gets or sets date prefix separator.
ComDateSecondSeparator | Gets or sets date second separator.
ComDateSuffixSeparator | Gets or sets date suffix separator.
ComDateWindowsDefaultType | Gets or sets date windows default type.
ComDayType | Gets or sets day type.
ComDecimalPlaces | Gets or sets number decimal places.
ComDecimalSymbol | Gets or sets decimal symbol.
ComDisplayReverseSign | Gets or sets reverse sign option.
ComEnableTightHorizontal | Gets or sets tight horizontal.
ComField | Gets field definition.
ComFirstLineIndent | Gets or sets first line indent.
ComFont | Gets or sets standard OLE font.
ComHasDropShadow | Gets or sets border drop shadow.
ComHeight | Gets or sets object height (twips).
ComHorAlignment | Gets or sets horizontal alignment.
ComHourMinuteSeparator | Gets or sets hour minute separator.
ComHourType | Gets or sets hour type.
ComHyperlinkText | Gets or sets hyperlink text.
ComHyperlinkType | Gets or sets hyperlink type.
ComKeepTogether | Gets or sets keep object together.
ComKind | Gets report object kind.
ComLeadingDayPosition | Gets or sets leading day position type.
ComLeadingDaySeparator | Gets or sets leading day separator.
ComLeadingDayType | Gets or sets leading day type.
ComLeft | Gets or sets object upper left position (twips).
ComLeftIndent | Gets or sets left indent.
ComLeftLineStyle | Gets or sets left line style.
ComLineSpacing | Gets or sets line spacing.
ComLineSpacingType | Gets or sets line spacing type.
ComMaxNumberOfLines | Gets or sets max of number of line for string memo field.
ComMinuteSecondSeparator | Gets or sets minute second separator.
ComMinuteType | Gets or sets minute type.
ComMonthType | Gets or sets month type.
ComName | Gets or sets object name.
ComNegativeType | Gets or sets number negative type.
ComNextValue | Gets field next value.
ComParent | Gets object parent (Section).
ComPmString | Gets or sets PM string.
ComPreviousValue | Gets field previous value.
ComRightIndent | Gets or sets right indent.
ComRightLineStyle | Gets or sets right line style.
ComRoundingType | Gets or sets number rounding type.
ComSecondType | Gets or sets second type.
ComSuppress | Gets or sets object visibility.
ComSuppressIfDuplicated | Gets or sets suppress if duplicated option.
ComSuppressIfZero | Gets or sets suppress if zero option.
ComTextColor | Gets or sets object text color.
ComTextFormat | Gets or sets text format option for string memo field.
ComTextRotationAngle | Gets or sets text rotation angle.
ComThousandsSeparators | Gets or sets enable number thousands separators.
ComThousandSymbol | Gets or sets thousand symbol.
ComTimeBase | Gets or sets time base.
ComTop | Gets or sets object upper top position (twips).
ComTopLineStyle | Gets or sets top line style.
ComUseLeadingZero | Gets or sets number uses leading zero option.
ComUseOneSymbolPerPage | Gets or sets use one symbol per page option.
ComUseSystemDefaults | Gets or sets use system defaults formatting option.
ComValue | Gets field value.
ComWidth | Gets or sets object width (twips).
ComYearType | Gets or sets year type.
ComZeroValueString | Gets or sets zero value string for number field format.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalFieldObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalFieldObject

View method list in alphabetical order

Name | Type | Description
ComSetLineSpacing | Procedure | Sets line spacing type and line spacing.
ComSetUnboundFieldSource | Procedure | Sets unbound field formula text
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalFormattingInfo

Properties Events Methods Index of Classes

COM object used to access the FormattingInfo object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalFormattingInfo

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIFormattingInfo

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalFormattingInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalFormattingInfo

View property list in alphabetical order

Name | Description
ComIsEndOfGroup | Indicates the current formatting section is end of a group.
ComIsRepeatedGroupHeader | Indicates the current formatting section is repeated group header.
ComIsStartOfGroup | Indicates the current formatting section is start of a group.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalFormattingInfo

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalFormattingInfo

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalFormulaFieldDefinition

Properties Events Methods Index of Classes

COM object used to access the FormulaFieldDefinition object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalFormulaFieldDefinition

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIFormulaFieldDefinition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalFormulaFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalFormulaFieldDefinition

View property list in alphabetical order

Name | Description
ComFormulaFieldName | Gets formula field name.
ComKind | Gets field definition kind.
ComName | Gets field definition unique formula name.
ComNextValue | Gets field next value.
ComNumberOfBytes | Gets field number of bytes.
ComParent | Gets formula field parent (Report).
ComPreviousValue | Gets field previous value.
ComText | Gets or sets formula field text.
ComValue | Gets field value.
ComValueType | Gets field value type.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalFormulaFieldDefinition

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalFormulaFieldDefinition

View method list in alphabetical order

Name | Type | Description
ComCheck | Procedure | Checks formula.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalFormulaFieldDefinitions

Properties Events Methods Index of Classes

COM object used to access the FormulaFieldDefinitions object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalFormulaFieldDefinitions

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIFormulaFieldDefinitions

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalFormulaFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalFormulaFieldDefinitions

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets formula field collection parent (Report).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalFormulaFieldDefinitions

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalFormulaFieldDefinitions

View method list in alphabetical order

Name | Type | Description
ComAdd | Function | Add a formula field collection item
ComDelete | Procedure | Delete a formula field collection item
ComGetItemByName | Function | Gets collection item by name index.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalGraphObject

Properties Events Methods Index of Classes

COM object used to access the GraphObject object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalGraphObject

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIGraphObject

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalGraphObject

View property list in alphabetical order

Name | Description
ComAutoRangeData2Axis | Gets or sets auto range option for data2 axis
ComAutoRangeDataAxis | Gets or sets auto range option for data axis
ComAutoRangeSeriesAxis | Gets or sets auto range option for series axis
ComBackColor | Gets or sets object background color.
ComBarSize | Gets or sets bar size
ComBorderColor | Gets or sets object border color.
ComBottomLineStyle | Gets or sets bottom line style.
ComCloseAtPageBreak | Gets or sets close border on page break.
ComConditionFields | Gets condition fields.
ComConditionFieldSortOrder | Gets or sets condition field sort order for detail chart
ComConditionFormula | Gets or sets conditional formula.
ComCrossTabObject | Gets crosstab object.
ComCssClass | Gets or sets CSS class.
ComData2AxisDivisionMethod | Gets or sets data2 axis division method
ComData2AxisDivisionNumber | Gets or sets data2 axis division number
ComData2AxisGridline | Gets or sets data2 axis grid line type
ComData2AxisNumberFormat | Gets or sets data2 axis number format
ComData2LabelFont | Gets or sets standard OLE font for chart data2 labels
ComData2Title | Gets or sets data2 title
ComData2TitleFont | Gets or sets standard OLE font for chart data2 title
ComDataAxisDivisionMethod | Gets or sets data axis division method
ComDataAxisDivisionNumber | Gets or sets data axis division number
ComDataAxisGridline | Gets or sets data axis grid line type
ComDataAxisNumberFormat | Gets or sets data axis number format
ComDataLabelFont | Gets or sets standard OLE font for chart data labels
ComDataPoint | Gets or sets data points on risers
ComDataTitle | Gets or sets data title
ComDataTitleFont | Gets or sets standard OLE font for chart data title
ComDataType | Gets graph data type
ComDataValueNumberFormat | Gets or sets data value number format
ComEnableAutoScaleData2Axis | Gets or sets data2 axis auto-scale
ComEnableAutoScaleDataAxis | Gets or sets data axis auto-scale
ComEnableAutoScaleSeriesAxis | Gets or sets series axis auto-scale
ComEnableForEachRecord | Gets or sets enable for each record.
ComEnableShowLegend | Gets or sets show legend
ComEnableSummarizeValues | Gets or sets enable summarize values.
ComFootNote | Gets or sets footnote
ComFootnoteFont | Gets or sets standard OLE font for chart footnote
ComGraphColor | Gets or sets graph color
ComGraphDirection | Gets or sets graph direction
ComGraphType | Gets or sets graph type
ComGroupAxisGridline | Gets or sets group axis grid line type
ComGroupLabelFont | Gets or sets standard OLE font for chart group labels
ComGroupsTitle | Gets or sets groups title
ComGroupTitleFont | Gets or sets standard OLE font for chart group title
ComHasDropShadow | Gets or sets border drop shadow.
ComHeight | Gets or sets object height (twips).
ComHyperlinkText | Gets or sets hyperlink text.
ComHyperlinkType | Gets or sets hyperlink type.
ComIsData2TitleByDefault | Gets or sets data2 title default flag
ComIsDataTitleByDefault | Gets or sets data title default flag
ComIsFootnoteByDefault | Gets or sets footnote default flag
ComIsGroupsTitleByDefault | Gets or sets groups title default flag
ComIsSeriesTitleByDefault | Gets or sets series title default flag
ComIsSubTitleByDefault | Gets or sets subtitle default flag
ComIsTitleByDefault | Gets or sets title default flag
ComIsXAxisTitleByDefault | Gets or sets X-axis title default flag
ComIsYAxisTitleByDefault | Gets or sets Y-axis title default flag
ComIsZAxisTitleByDefault | Gets or sets Z-axis title default flag
ComKeepTogether | Gets or sets keep object together.
ComKind | Gets report object kind.
ComLeft | Gets or sets object upper left position (twips).
ComLeftLineStyle | Gets or sets left line style.
ComLegendFont | Gets or sets standard OLE font for legend
ComLegendLayout | Gets or sets pie legend layout
ComLegendPosition | Gets or sets legend position
ComMarkerShape | Gets or sets marker shape
ComMarkerSize | Gets or sets marker size
ComMaxData2AxisValue | Gets or sets data2-axis max value
ComMaxDataAxisValue | Gets or sets data-axis max value
ComMaxSeriesAxisValue | Gets or sets series-axis max value
ComMinData2AxisValue | Gets or sets data2-axis min value
ComMinDataAxisValue | Gets or sets data-axis min value
ComMinSeriesAxisValue | Gets or sets series-axis min value
ComName | Gets or sets object name.
ComParent | Gets object parent (Section).
ComPieSize | Gets or sets pie size
ComRightLineStyle | Gets or sets right line style.
ComSeriesAxisDivisionMethod | Gets or sets series axis division method
ComSeriesAxisDivisionNumber | Gets or sets series axis division number
ComSeriesAxisGridline | Gets or sets series axis grid line type
ComSeriesAxisNumberFormat | Gets or sets series axis number format
ComSeriesLabelFont | Gets or sets standard OLE font for chart series labels
ComSeriesTitle | Gets or sets series title
ComSeriesTitleFont | Gets or sets standard OLE font for chart series title
ComSliceDetachment | Gets or sets slice detachment
ComSpecifiedGroups | Gets or sets the specifed groups
ComSubTitle | Gets or sets subtitle
ComSubTitleFont | Gets or sets standard OLE font for chart subtitle
ComSummaryFields | Gets summary fields.
ComSuppress | Gets or sets object visibility.
ComTitle | Gets or sets title
ComTitleFont | Gets or sets standard OLE font for chart title
ComTop | Gets or sets object upper top position (twips).
ComTopLineStyle | Gets or sets top line style.
ComViewingAngle | Gets or sets viewing angle
ComWidth | Gets or sets object width (twips).
ComXAxisTitle | Gets or sets X-Axis title
ComY2AxisTitle | Gets or sets Y2-Axis title
ComYAxisTitle | Gets or sets Y-Axis title
ComZAxisTitle | Gets or sets Z-Axis title.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalGraphObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalGraphObject

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalGroupNameFieldDefinition

Properties Events Methods Index of Classes

COM object used to access the GroupNameFieldDefinition object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalGroupNameFieldDefinition

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIGroupNameFieldDefinition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalGroupNameFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalGroupNameFieldDefinition

View property list in alphabetical order

Name | Description
ComGroupNameConditionFormula | Gets or sets conditional formula.
ComGroupNameFieldName | Gets group name field name.
ComGroupNumber | Gets group number the group name fields represents.
ComKind | Gets field definition kind.
ComName | Gets field definition unique formula name.
ComNextValue | Gets field next value.
ComNumberOfBytes | Gets field number of bytes.
ComParent | Gets group name field parent (Report).
ComPreviousValue | Gets field previous value.
ComValue | Gets field value.
ComValueType | Gets field value type.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalGroupNameFieldDefinition

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalGroupNameFieldDefinition

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalGroupNameFieldDefinitions

Properties Events Methods Index of Classes

COM object used to access the GroupNameFieldDefinitions object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalGroupNameFieldDefinitions

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIGroupNameFieldDefinitions

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalGroupNameFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalGroupNameFieldDefinitions

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets group name field collection parent (report).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalGroupNameFieldDefinitions

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalGroupNameFieldDefinitions

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalLineObject

Properties Events Methods Index of Classes

COM object used to access the LineObject object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalLineObject

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalILineObject

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalLineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalLineObject

View property list in alphabetical order

Name | Description
ComBottom | Gets or sets line lower bottom position (twips).
ComConditionFormula | Gets or sets conditional formula.
ComCssClass | Gets or sets CSS class.
ComEndSection | Gets end section.
ComExtendToBottomOfSection | Gets or sets extend to bottom of section option.
ComKind | Gets report object kind.
ComLeft | Gets or sets object upper left position (twips).
ComLineColor | Gets or sets line color.
ComLineStyle | Gets or sets line style.
ComLineThickness | Gets or sets line thickness (twips).
ComName | Gets or sets object name.
ComParent | Gets object parent (Section).
ComRight | Gets or sets line lower right position (twips).
ComSuppress | Gets or sets object visibility.
ComTop | Gets or sets object upper top position (twips).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalLineObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalLineObject

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalMapObject

Properties Events Methods Index of Classes

COM object used to access the MapObject object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalMapObject

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIMapObject

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalMapObject

View property list in alphabetical order

Name | Description
ComBackColor | Gets or sets object background color.
ComBorderColor | Gets or sets object border color.
ComBottomLineStyle | Gets or sets bottom line style.
ComCloseAtPageBreak | Gets or sets close border on page break.
ComConditionFormula | Gets or sets conditional formula.
ComCssClass | Gets or sets CSS class.
ComHasDropShadow | Gets or sets border drop shadow.
ComHeight | Gets or sets object height (twips).
ComHyperlinkText | Gets or sets hyperlink text.
ComHyperlinkType | Gets or sets hyperlink type.
ComKeepTogether | Gets or sets keep object together.
ComKind | Gets report object kind.
ComLeft | Gets or sets object upper left position (twips).
ComLeftLineStyle | Gets or sets left line style.
ComName | Gets or sets object name.
ComParent | Gets object parent (Section).
ComRightLineStyle | Gets or sets right line style.
ComSuppress | Gets or sets object visibility.
ComTop | Gets or sets object upper top position (twips).
ComTopLineStyle | Gets or sets top line style.
ComWidth | Gets or sets object width (twips).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalMapObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalMapObject

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalObjectSummaryFieldDefinitions

Properties Events Methods Index of Classes

COM object used to access the ObjectSummaryFieldDefinitions object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalObjectSummaryFieldDefinitions

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIObjectSummaryFieldDefinitions

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalObjectSummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalObjectSummaryFieldDefinitions

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets object summary field collection parent (ReportObject).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalObjectSummaryFieldDefinitions

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalObjectSummaryFieldDefinitions

View method list in alphabetical order

Name | Type | Description
ComAdd | Procedure | Adds a field.
ComDelete | Procedure | Delete a field.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalOlapGridObject

Properties Events Methods Index of Classes

COM object used to access the OlapGridObject object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalOlapGridObject

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIOlapGridObject

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalOlapGridObject

View property list in alphabetical order

Name | Description
ComBackColor | Gets or sets object background color.
ComBorderColor | Gets or sets object border color.
ComBottomLineStyle | Gets or sets bottom line style.
ComCloseAtPageBreak | Gets or sets close border on page break.
ComConditionFormula | Gets or sets conditional formula.
ComHasDropShadow | Gets or sets border drop shadow.
ComHeight | Gets object height (twips).
ComKeepTogether | Gets or sets keep object together.
ComKind | Gets report object kind.
ComLeft | Gets or sets object upper left position (twips).
ComLeftLineStyle | Gets or sets left line style.
ComName | Gets or sets object name.
ComParent | Gets object parent (Section).
ComRightLineStyle | Gets or sets right line style.
ComSuppress | Gets or sets object visibility.
ComTop | Gets or sets object upper top position (twips).
ComTopLineStyle | Gets or sets top line style.
ComWidth | Gets object width (twips).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalOlapGridObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalOlapGridObject

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalOleObject

Properties Events Methods Index of Classes

COM object used to access the OleObject object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalOleObject

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalICROleObject

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalOleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalOleObject

View property list in alphabetical order

Name | Description
ComBackColor | Gets or sets object background color.
ComBorderColor | Gets or sets object border color.
ComBottomCropping | Gets or sets bottom cropping size (twips).
ComBottomLineStyle | Gets or sets bottom line style.
ComCloseAtPageBreak | Gets or sets close border on page break.
ComConditionFormula | Gets or sets conditional formula.
ComCssClass | Gets or sets CSS class.
ComFormattedPicture | Gets the specified picture during formatting
ComHasDropShadow | Gets or sets border drop shadow.
ComHeight | Gets or sets object height (twips).
ComHyperlinkText | Gets or sets hyperlink text.
ComHyperlinkType | Gets or sets hyperlink type.
ComKeepTogether | Gets or sets keep object together.
ComKind | Gets report object kind.
ComLeft | Gets or sets object upper left position (twips).
ComLeftCropping | Gets or sets left cropping size (twips).
ComLeftLineStyle | Gets or sets left line style.
ComName | Gets or sets object name.
ComParent | Gets object parent (Section).
ComRightCropping | Gets or sets right cropping size (twips).
ComRightLineStyle | Gets or sets right line style.
ComSuppress | Gets or sets object visibility.
ComTop | Gets or sets object upper top position (twips).
ComTopCropping | Gets or sets top cropping size (twips).
ComTopLineStyle | Gets or sets top line style.
ComWidth | Gets or sets object width (twips).
ComXScaling | Gets or sets width scaling factor. E.g. 1 means 100%, 2 means 200%, 0.5 means 50%, etc. Range from 0.01 to 100.
ComYScaling | Gets or sets height scaling factor. E.g. 1 means 100%, 2 means 200%, 0.5 means 50%, etc. Range from 0.01 to 100.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalOleObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalOleObject

View method list in alphabetical order

Name | Type | Description
ComGetLinkSource | Function | Gets linked OLE object path.
ComSetOleLocation | Procedure | Sets OLE object location
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalPage

Properties Events Methods Index of Classes

COM object used to access the Page object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalPage

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIPage

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalPage object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalPage

View property list in alphabetical order

Name | Description
ComIsLastPage | Returns whether the page is the last page.
ComIsMissingTotalPageCount | Returns whether the page misses the total page count.
ComPageNumber | Gets page number.
ComParent | Gets page's parent (PageGenerator).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalPage

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalPage

View method list in alphabetical order

Name | Type | Description
ComRenderEPF | Function | Gets EPF stream.
ComRenderHTML | Function | Gets HTML stream.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalPageEngine

Properties Events Methods Index of Classes

COM object used to access the PageEngine object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalPageEngine

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIPageEngine

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalPageEngine object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalPageEngine

View property list in alphabetical order

Name | Description
ComImageOptions | Gets or sets EPF image options.
ComParent | Gets page engine's parent (Report)
ComPlaceHolderOptions | Gets or sets EPF place holder options.
ComValueFormatOptions | Gets or sets EPF value format options.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalPageEngine

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalPageEngine

View method list in alphabetical order

Name | Type | Description
ComCreatePageGenerator | Function | Creates a page generator object.
ComRenderTotallerETF | Function | Gets totaller ETF stream.
ComRenderTotallerHTML | Function | Gets totaller HTML stream.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalPageGenerator

Properties Events Methods Index of Classes

COM object used to access the PageGenerator object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalPageGenerator

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIPageGenerator

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalPageGenerator

View property list in alphabetical order

Name | Description
ComContainingGroupName | Gets contatining group name for out of place subreport view.
ComContainingGroupPath | Gets containining group path for out of place subreport view.
ComContainingPageNumber | Gets containing page number for out of place subreport view.
ComDrillDownLevel | Gets drill down level
ComGroupName | Get group name for drill down on graph view
ComGroupPath | Gets group path.
ComPages | Gets page collection.
ComParent | Gets page generator's parent (PageEngine).
ComReportName | Gets report name for drill down on out of place subreport view.
ComXOffset | Gets object xoffset.
ComYOffset | Gets object yoffset.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalPageGenerator

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalPageGenerator

View method list in alphabetical order

Name | Type | Description
ComCreateSubreportPageGenerator | Function | Creates a page generator that contains subreport view context.
ComDrillOnGraph | Function | Gets a page generator for drilling on graph.
ComDrillOnMap | Function | Gets a page generator for drilling on a map.
ComDrillOnSubreport | Function | Gets a page generator for drilling on a out of place subreport.
ComExport | Function | Gets export data stream.
ComFindText | Function | Searchs for the specified text in the current drill down view, starting with specified page.
ComGetPageNumberForGroup | Function | Gets page number for the specified group path.
ComRenderTotallerETF | Function | Gets totaller ETF stream.
ComRenderTotallerHTML | Function | Gets totaller HTML stream.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalPages

Properties Events Methods Index of Classes

COM object used to access the Pages object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalPages

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIPages

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalPages object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalPages

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets pages parent(PageGenerator)
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalPages

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalPages

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalParameterFieldDefinition

Properties Events Methods Index of Classes

COM object used to access the ParameterFieldDefinition object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalParameterFieldDefinition

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIParameterFieldDefinition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalParameterFieldDefinition

View property list in alphabetical order

Name | Description
ComDisallowEditing | Gets or sets disallowing editing option.
ComDiscreteOrRangeKind | Gets or sets parameter value kind (discrete or range).
ComEditMask | Gets or sets edit mask for string parameter.
ComEnableExclusiveGroup | Gets or sets boolean mutuallyExclusiveGroup.
ComEnableMultipleValues | Gets or sets allowing multiple values.
ComEnableNullValue | Gets or sets value nullable.
ComEnableRangeLimit | Gets or sets the option which specifies if this parameter field value should be in the specified range.
ComEnableShowDescriptionOnly | Gets or sets show description only in pick list option.
ComEnableSortBasedOnDesc | Gets or sets sort based on description in pick list option.
ComGroupNumber | Gets or sets boolean group number.
ComIsCurrentValueSet | Gets whether the current value has been set.
ComIsDefaultValueSet | Gets whether the default value has been set.
ComKind | Gets field definition kind.
ComMaximumValue | Gets or sets maximum value.
ComMinimumValue | Gets or sets minimum value.
ComName | Gets field definition unique formula name.
ComNeedsCurrentValue | Gets whether the parameter field needs current value.
ComNextValue | Gets field next value.
ComNthValueDescription | Gets or sets nth value description.
ComNumberOfBytes | Gets field number of bytes.
ComNumberOfCurrentRanges | Gets total number of ranges.
ComNumberOfCurrentValues | Gets total number of current values.
ComNumberOfDefaultValues | Gets total number of default values.
ComParameterFieldName | Gets parameter field name.
ComParameterType | Gets parameter type
ComParent | Gets parameter field parent (Report).
ComPicklistSortMethod | Gets or sets sort method in pick list option.
ComPlaceInGroup | Gets or sets boolean place in group option.
ComPreviousValue | Gets field previous value.
ComPrompt | Gets or sets parameter field prompting string.
ComReportName | Gets the report name the parameter field is in.
ComValue | Gets field value.
ComValueType | Gets field value type.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalParameterFieldDefinition

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalParameterFieldDefinition

View method list in alphabetical order

Name | Type | Description
ComAddCurrentRange | Procedure | Adds current range.
ComAddCurrentValue | Procedure | Adds current value.
ComAddDefaultValue | Procedure | Adds a default value.
ComClearCurrentValueAndRange | Procedure | Clears all the current values and ranges.
ComDeleteNthDefaultValue | Procedure | Deletes nth default value.
ComGetNthCurrentRange | Procedure | Gets nth current range.
ComGetNthCurrentValue | Function | Gets nth current value.
ComGetNthDefaultValue | Function | Gets nth default value
ComSetNthDefaultValue | Procedure | Sets nth default value
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalParameterFieldDefinitions

Properties Events Methods Index of Classes

COM object used to access the ParameterFieldDefinitions object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalParameterFieldDefinitions

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIParameterFieldDefinitions

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalParameterFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalParameterFieldDefinitions

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets parameter field collection parent (report).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalParameterFieldDefinitions

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalParameterFieldDefinitions

View method list in alphabetical order

Name | Type | Description
ComAdd | Function | Add a parameter field collection item
ComDelete | Procedure | Delete a parameter field collection item
ComGetItemByName | Function | Gets collection item by name index.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalParameterValue

Properties Events Methods Index of Classes

COM object used to access the ParameterValue object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalParameterValue

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIParameterValue

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalParameterValue object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalParameterValue

View property list in alphabetical order

Name | Description
ComEndValue | Gets or sets value's end value.
ComRangeInfo | Gets or sets end value's range info.
ComRangeValue | Gets or sets end value's range or single value.
ComStartValue | Gets or sets value's start value.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalParameterValue

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalParameterValue

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalParameterValueInfo

Properties Events Methods Index of Classes

COM object used to access the ParameterValueInfo object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalParameterValueInfo

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIParameterValueInfo

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalParameterValueInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalParameterValueInfo

View property list in alphabetical order

Name | Description
ComParameterName | Gets or sets parameter name.
ComParameterValues | Gets or sets parameter value collection.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalParameterValueInfo

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalParameterValueInfo

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalParameterValueInfos

Properties Events Methods Index of Classes

COM object used to access the ParameterValueInfos object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalParameterValueInfos

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIParameterValueInfos

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalParameterValueInfos object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalParameterValueInfos

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets value info count.
ComItem | Gets a value info.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalParameterValueInfos

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalParameterValueInfos

View method list in alphabetical order

Name | Type | Description
ComAdd | Procedure | Adds a value info.
ComDelete | Procedure | Delete a value info.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalParameterValues

Properties Events Methods Index of Classes

COM object used to access the ParameterValues object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalParameterValues

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIParameterValues

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalParameterValues object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalParameterValues

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets parameter value count.
ComItem | Gets a parameter value.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalParameterValues

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalParameterValues

View method list in alphabetical order

Name | Type | Description
ComAdd | Procedure | Adds a parameter value.
ComDelete | Procedure | Delete a parameter value.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalPreview

Properties Events Methods Index of Classes

This class acts as a container for the Crystal COM object which the Crystal Reports report is displayed within

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------MdiDialog
---------------------------AppDialog
------------------------------View
---------------------------------cCrystalPreview

Library: Windows Application Class Library

Package: cCrystalPreview.pkg

Description

This class provides a container for the cCrystalActiveXReportViewer which is used to display a Crystal Reports report. The cCrystalPreview class will be used to display a report when printed to the screen. A new preview will be created each time a report is printed to the screen. Previews are child objects of the ClientArea. When a preview is closed, it is automatically destroyed.

The size of the preview object is determined by the current monitor resolution of the user in order to give the user the maximum viewing area. The location of the preview object is set automatically.

If you want to set properties of the preview object or use any of the COM messages for the cCrystalActiveXReportViewer, you can do so during the cCrystal event OnDisplayReport. Use the method PreviewObject to get the handle of the preview object for the current print job, and use ActiveXReportViewerObject to get the handle of the preview COM object.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"
    Set peOutputDestination to PRINT_TO_SCREEN

    Procedure OnDisplayReport Handle hoReport
        Handle hoPreview

        Forward Send OnDisplayReport hoReport

        Get PreviewObject of hoReport to hoPreview
        If (hoPreview) Begin
            Set Label of hoPreview to "Report Output Window"
            Set pbPreserveEnvironment of hoPreview to False
        End
    End_Procedure
End_Object // oCrystalReport

Life span of a cCrystalPreview

You must have a report with the peOutputDestination set to PRINT_TO_SCREEN.

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"
    Set peOutputDestination to PRINT_TO_SCREEN
End_Object // oCrystalReport

You have to run the report.

Object oButton1 is a Button
    Procedure OnClick
        Send RunReport of oCrystalReport
    End_Procedure // OnClick
End_Object // oButton1

The OnDisplayReport event is called before the report is displayed to the screen. During this event, you can set properties of the preview object or the COM preview object.

// :
    Procedure OnDisplayReport Handle hoReport
        Forward Send OnDisplayReport hoReport
    End_Procedure // OnDisplayReport
// :

Next, the method DisplayReport of the cCrystalPreview is called which attaches the report to the COM preview and activates the view. From here, the user can resize the preview, interact with the report, or close the preview. By default the preview is not modal so the user can leave the preview open and run another report to compare them side-by-side. When a preview is closed it is destroyed.

See Also

phcPreviewObject | OnDisplayReport | DisplayReport

Last Edited: January 10, 2006


Properties for cCrystalPreview

View property list in alphabetical order

Name | Description
phoActiveXReportViewer | Holds the object-handle of the Crystal COM preview object
piZoom | Default zoom level for the report
Inherited Properties from MdiDialog
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalPreview

View event list in alphabetical order

Name | Description
Inherited Events from AppDialog
Notify_Exit_Application | Called when an application is about to be closed
Verify_Exit_Application | Sent by the client area to verify that an application may be exited
Inherited Events from MdiDialog
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalPreview

View method list in alphabetical order

Name | Type | Description
AssignViewerDefaults | Procedure | Sets the default COM properties of the cCrystalActiveXReportViewer
DisplayReport | Procedure | Attaches a report to COM previewer and activates preview
Inherited Methods from AppDialog
Activate_View | Procedure | Activates the view
Inherited Methods from MdiDialog
Close_Panel | Procedure |
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalPrintingStatus

Properties Events Methods Index of Classes

COM object used to access the PrintingStatus object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalPrintingStatus

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIPrintingStatus

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalPrintingStatus object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalPrintingStatus

View property list in alphabetical order

Name | Description
ComNumberOfPages | Gets total number of pages in the report.
ComNumberOfRecordPrinted | Gets the number of record printed.
ComNumberOfRecordRead | Gets the number of record read.
ComNumberOfRecordSelected | Gets the number of record selected.
ComParent | Gets printing status's parent (Report)
ComProgress | Gets the printing progress.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalPrintingStatus

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalPrintingStatus

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalReport

Properties Events Methods Index of Classes

Provides a COM connection to a Crystal Reports report

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalReport

Library: Common (Windows and Web Application) Class Library

Package: cCrystal.pkg

Mixins: cCrystalIReport cCrystalIReportEvent

Description

Please read Using Crystal Reports in Applications for a conceptual understanding of working with Crystal Reports in Visual DataFlex. For help regarding the Crystal Reports RDC class model, refer to the Crystal RDC documentation.

Of all the cCrystal COM classes, this is probably the most important. An object based on this class must be created in order to read, modify, or output a Crystal Report report. All other cCrystal COM classes are obtained through this class. For this reason, all events of the cCrystal class pass the handle of the cCrystalReport as an argument to its events.

This class contains all of the standard RDC COM interfaces. The methods and properties are all prefaced with the COM prefix; events are prefixed with OnCOM.

In addition to the standard messsages, helper methods were added to this class to make many of the common functions you will be using easier to work with. For example, helper methods were added to create a VDF object, attach the COM object to it and return a handle. Knowledge of how COM automation works is not needed when using the helper methods.

This class provides the connection to the Crystal Reports report. This object is created when the report is run and destroyed when the report has finished running. When this object is destroyed the connection is closed. When using any of the COM methods for any of the cCrystal COM classes, you should do so during one of the events within the cCrystal class: These events, OnInitializeReport, OnPrintReport, OnExportReport and OnDisplayReport, have been provided to give developers a hook where they can access the COM objects.

Sample

This sample shows how the OnInitializeReport event is passed a handle to the cCrystalReport object. This handle is used to access COM methods (e.g. RecordSelectionFormula) and to access the helper methods (e.g. DeleteSortOrder, AppendSortField)

Object oCrystalReport1 is a cCrystal
    Set psReportName to "CustLst.rpt"

    Procedure OnInitializeReport Handle hoReport
        Forward Send OnInitializeReport hoReport

        Set ComRecordSelectionFormula of hoReport To ;
            "{wines.YEAR} <90 and {wines.COST} >6 and {wines.QUANTITY} >2"

        Send DeleteSortOrder of hoReport
        Send AppendSortField of hoReport "Customer" "State" crAscendingOrder
        Send AppendSortField of hoReport "Customer" "Name"  crDescendingOrder
    End_Procedure

End_Object

Sample

This sample shows how OnExportReport event is passed a handle to the cCrystalReport object. This handle can be used to access the handle of other COM objects (e.g., ExportObject is used to access methods in the cCrystalExportOptions object).

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"
    Set peOutputDestination to PRINT_TO_FILE

    Procedure OnExportReport Handle hoReport
        Handle hoExport

        Forward Send OnExportReport hoReport

        Set pbExportPrompt of hoReport to FALSE

        Get ExportObject of hoReport to hoExport
        If (hoExport) Begin
            Set ComDiskFileName of hoExport To "D:\Documents\MyReport.rtf"
            Set ComFormatType of hoExport To crEFTExactRichText // Rich Text
        End
    End_Procedure // OnExportReport
End_Object // oCrystalReport

In the unlikely case you will need to use the events of this class, you will need to create a subclass. For more information on subclassing, please see RDC Advanced Programming.

See Also

cCrystal | cCrystalExportOptions | Using Crystal Reports in Applications | Crystal RDC documentation

Last Edited: December 20, 2005


Properties for cCrystalReport

View property list in alphabetical order

Name | Description
ComApplication | Gets application object
ComApplicationName | Gets or sets application name.
ComAreas | Gets area collection.
ComBottomMargin | Gets or sets page bottom margin (twips).
ComCanPerformGroupingOnServer | Checks whether the report can perform grouping on the server.
ComCaseInsensitiveSQLData | Gets or sets case insensitive SQL data report option.
ComConvertDateTimeType | Gets or sets convert date time to date report option.
ComConvertNullFieldToDefault | Gets or sets convert Null field to default report option.
ComDatabase | Gets database manager.
ComDisplayProgressDialog | Enables or disables progress dialog
ComDriverName | Gets driver name used by the current printer.
ComEnableAsyncQuery | Gets or sets enable AsyncQuery.
ComEnableGeneratingDataForHiddenObject | Gets or sets Enable Generating Data For Hidden Object.
ComEnableParameterPrompting | Enables or disables prompting for parameter field
ComEnablePerformQueriesAsynchronously | Gets or sets perform queries asynchronously option.
ComEnableSelectDistinctRecords | Gets or sets select distinct records option.
ComExportOptions | Gets export options object.
ComFieldMappingType | Gets or Sets field mapping type.
ComFormulaFields | Gets formula field definition collection.
ComFormulaSyntax | Gets or sets report formula syntax.
ComGroupNameFields | Gets group name field definition collection.
ComGroupSelectionFormula | Gets or sets group selection formula.
ComGroupSortFields | Gets group sort field collection.
ComHasSavedData | Checks whether the report has saved data in memory.
ComKeywordsInReport | Gets or sets keywords in report.
ComKind | Gets report kind.
ComLastGetFormulaSyntax | Gets formula syntax of last formula text returned.
ComLeftMargin | Gets or sets page left margin (twips).
ComNeedUpdatePages | Gets whether the user needs to reget pages for display because of the changes in the report.
ComNumberOfGroup | Gets the number of groups in the report.
ComPageEngine | Get pageEngine object.
ComPaperOrientation | Gets or sets current printer paper orientation.
ComPaperSize | Gets or sets current printer paper size.
ComPaperSource | Gets or Sets the current printer paper source.
ComParameterFields | Gets parameter field definition collection.
ComParent | Gets report parent. (NULL or Main Report)
ComPerformGroupingOnServer | Gets or sets performing grouping on server option.
ComPortName | Gets port name used by the current printer.
ComPrintDate | Gets or sets print date.
ComPrinterDuplex | Gets or Sets the current printer duplex option.
ComPrinterName | Gets current printer name.
ComPrintingStatus | Gets printing status object.
ComRecordSelectionFormula | Gets or sets record selection formula.
ComRecordSortFields | Gets reocord sort field collection.
ComReportAlerts | Gets report alert.
ComReportAuthor | Gets or sets report author.
ComReportComments | Gets or sets report comments.
ComReportFormatStyle | Gets or sets a report format style.
ComReportSubject | Gets or sets report subject.
ComReportTemplate | Gets or sets report template.
ComReportTitle | Gets or sets report title.
ComRightMargin | Gets or sets page right margin (twips).
ComRunningTotalFields | Gets running total field collection.
ComSavePreviewPicture | Gets or sets save preview picture with report option.
ComSections | Gets section collection within the report.
ComSQLExpressionFields | Gets SQL expression field collection.
ComSQLQueryString | Gets or sets SQL query string.
ComSummaryFields | Gets summary field definition collection.
ComTopMargin | Gets or sets page top margin (twips).
ComUseIndexForSpeed | Gets or sets use index for speed report option.
ComVerifyOnEveryPrint | Gets or sets verify on every print report option.
pbExportPrompt | Controls automatic prompting of export options
pbPrinterCollate | Controls collate property for the printer
pbPrinterPrompt | Controls automatic prompting of printer setup
piPrinterCopies | Number of copies to print
piPrinterEndPage | Last page to print
piPrinterStartPage | First page to print
psReportLocation | Contains the full path to the Crystal Reports report
psSubReportName | For subreport objects only. Contains the name of the subreport opened from main report
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalReport

View event list in alphabetical order

Name | Description
OnComAfterFormatPage | Fires this event after formatting a page
OnComBeforeFormatPage | Fires this event before formatting a page
OnComFieldMapping | Fires this event if database is changed while verifing database
OnComNoData | Fires this event when there is no data
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalReport

View method list in alphabetical order

Name | Type | Description
ActiveXReportViewerObject | Function | Returns handle of the ActiveX Report Viewer COM object in which the Crystal Reports report is displayed
AppendCDOData | Procedure | Adds data from a safe-array to a Crystal Data Object (CDO)
AppendSortField | Procedure | Adds a field to the Crystal Reports report sort order
AppendSortFormulaField | Procedure | Adds a formula field to the Crystal Reports report sort order
AssignFormula | Procedure | Sets the value of a Crystal Reports report formula field
AssignPreviewObject | Procedure | Sets the object to receive the report output
AttachCDO | Procedure | Attaches an existing CDO to a Crystal Reports report
ComAddGroup | Procedure | Adds a group.
ComAddReportVariable | Procedure | Adds a report variable
ComAutoSetUnboundFieldSource | Procedure | Automatically bind unbound fields to database fields.
ComCancelPrinting | Procedure | Cancels exporting/printing.
ComDeleteGroup | Procedure | Delete a group
ComDiscardSavedData | Procedure | Discards report saved data.
ComExport | Procedure | Exports the report to other formats.
ComGetNextRows | Function | Get Rowset.
ComGetReportVariableValue | Function | Gets a report variable
ComOpenSubreport | Function | Gets specified subreport.
ComPrinterSetup | Procedure | Set up current printer.
ComPrinterSetupEx | Function | Set up current printer.
ComPrintOut | Procedure | Prints the report to printer.
ComPrintOutEx | Procedure | Prints the report to printer or file.
ComReadRecords | Procedure | Forces to read in data.
ComSaveAs | Procedure | Saves the report to another file.
ComSelectPrinter | Procedure | Selects a printer.
ComSetDialogParentWindow | Procedure | Sets dialog parent window.
ComSetReportVariableValue | Procedure | Sets a report variable value
ComSetUserPaperSize | Procedure | sets customer printer paper size.
CreateCDO | Function | Returns the handle to a CDO COM object based on a TTX file
DatabaseObject | Function | Returns handle of cCrystalDatabase COM object assigned to the report.
DeleteNthSortField | Procedure | Removes a field in the Nth position from the sort order of a Crystal Reports report
DeleteSortOrder | Procedure | Deletes a field sort order in a Crystal Reports report
ExportObject | Function | Returns handle of COM object for export options
GetParamObjectByName | Function | Returns handle of the Name Parameter Field Definition COM object
GetSubReportObjectbyName | Function | Returns handle of the name Sub-report COM object
GetTableObjectByName | Function | Returns handle of the named Database Table COM object
LocateDFFile | Function | Set the location of an embedded database (DataFlex) data file (.dat or .int) to the data directory
LocateDFFiles | Function | Locate all embedded database (DataFlex) files for report and sub-report assign them to the data directory
ParamObjects | Function | Returns an array of object handles attached to all Parameter Field Definition COM objects
PreviewObject | Function | Returns handle of preview object
SubReportObjects | Function | Returns an array of object handles attached to all Sub-Report COM objects
TableObjects | Function | Returns an array of object handles attached to Database Table COM objects
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalReportAlert

Properties Events Methods Index of Classes

COM object used to access the ReportAlert object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalReportAlert

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIReportAlert

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalReportAlert object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalReportAlert

View property list in alphabetical order

Name | Description
ComAlertInstances | Gets report alert's instances
ComConditionFormula | Gets or sets report alert's condition formula
ComDefaultMessage | Gets or sets report alert's default message
ComIsEnabled | Gets or sets report alert's enable status
ComMessageFormula | Gets or sets report alert's message formula
ComName | Gets or sets report alert's name
ComParent | Gets report alert's parent (Report)
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalReportAlert

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalReportAlert

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalReportAlertInstance

Properties Events Methods Index of Classes

COM object used to access the ReportAlertInstance object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalReportAlertInstance

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIReportAlertInstance

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalReportAlertInstance object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalReportAlertInstance

View property list in alphabetical order

Name | Description
ComAlertMessage | Gets report alert instance's alert message
ComParent | Gets report alert instance's parent (IReportAlert)
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalReportAlertInstance

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalReportAlertInstance

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalReportAlertInstances

Properties Events Methods Index of Classes

COM object used to access the ReportAlertInstances object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalReportAlertInstances

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIReportAlertInstances

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalReportAlertInstances object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalReportAlertInstances

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets report alertinstances' parent (IReportAlert).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalReportAlertInstances

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalReportAlertInstances

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalReportAlerts

Properties Events Methods Index of Classes

COM object used to access the ReportAlerts object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalReportAlerts

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIReportAlerts

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalReportAlerts object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalReportAlerts

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets report alerts' parent (Report).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalReportAlerts

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalReportAlerts

View method list in alphabetical order

Name | Type | Description
ComAdd | Function | Adds a report alert
ComDelete | Procedure | Deletes a report alert
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalReportObjects

Properties Events Methods Index of Classes

COM object used to access the ReportObjects object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalReportObjects

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIReportObjects

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalReportObjects object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalReportObjects

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets report object collection parent (section)
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalReportObjects

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalReportObjects

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalReportSourceRouter

Properties Events Methods Index of Classes

COM object used to access the ReportSourceRouter object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalReportSourceRouter

Library: Common (Windows and Web Application) Class Library

Package: cCrystalActiveXReportViewer.pkg

Mixins: cCrystalICrystalReportSourceRouter

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalReportSourceRouter object, refer to the Crystal RDC Report Viewer Object Model documentation. This link will take you to the Crystal Report Designer Component (RDC) Report Viewer/ActiveX Object Model page, which lists all objects and collections in the Crystal RDC Report Viewer. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalReportSourceRouter

View property list in alphabetical order

Name | Description
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalReportSourceRouter

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalReportSourceRouter

View method list in alphabetical order

Name | Type | Description
ComAddReport | Procedure | method AddReport
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalRunningTotalFieldDefinition

Properties Events Methods Index of Classes

COM object used to access the RunningTotalFieldDefinition object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalRunningTotalFieldDefinition

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIRunningTotalFieldDefinition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalRunningTotalFieldDefinition

View property list in alphabetical order

Name | Description
ComEvaluateCondition | Gets evaluate condition
ComEvaluateConditionField | Gets evaluate condition field
ComEvaluateConditionFormula | Gets or sets evaluate condition formula
ComEvaluateGroupNumber | Gets or sets evaluate group number
ComHierarchicalSummaryType | Gets or sets summary hierarchical type
ComKind | Gets field definition kind.
ComName | Gets field definition unique formula name.
ComNextValue | Gets field next value.
ComNumberOfBytes | Gets field number of bytes.
ComParent | Gets summary field parent (report).
ComPreviousValue | Gets field previous value.
ComResetCondition | Gets reset condition
ComResetConditionField | Gets reset condition field
ComResetConditionFormula | Gets or sets reset condition formula
ComResetGroupNumber | Gets or sets reset group number
ComRunningTotalFieldName | Gets running total field name.
ComSecondarySummarizedField | Gets secondary summarized field
ComSummarizedField | Gets summarized field
ComSummaryOperationParameter | Gets or sets summary operation parameter
ComSummaryType | Gets or sets summary type
ComValue | Gets field value.
ComValueType | Gets field value type.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalRunningTotalFieldDefinition

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalRunningTotalFieldDefinition

View method list in alphabetical order

Name | Type | Description
ComSetEvaluateConditionField | Procedure | Sets evaluate condition field
ComSetNoEvaluateCondition | Procedure | Sets to no evaluate condition
ComSetNoResetCondition | Procedure | Sets to no reset condition
ComSetResetConditionField | Procedure | Sets reset condition field
ComSetSecondarySummarizedField | Procedure | Sets secondary summarized field
ComSetSummarizedField | Procedure | Sets summarized field
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalRunningTotalFieldDefinitions

Properties Events Methods Index of Classes

COM object used to access the RunningTotalFieldDefinitions object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalRunningTotalFieldDefinitions

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalIRunningTotalFieldDefinitions

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalRunningTotalFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalRunningTotalFieldDefinitions

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets summary field collection parent (report).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalRunningTotalFieldDefinitions

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalRunningTotalFieldDefinitions

View method list in alphabetical order

Name | Type | Description
ComAdd | Function | Add a RunningTotal field collection item
ComDelete | Procedure | Delete a RunningTotal field collection item
ComGetItemByName | Function | Gets collection item by name index.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalSection

Properties Events Methods Index of Classes

COM object used to access the Section object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalSection

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalISection cCrystalISectionEvent

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalSection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalSection

View property list in alphabetical order

Name | Description
ComBackColor | Gets or sets section background color.
ComConditionFormula | Gets or sets section conditional formula.
ComCssClass | Gets or sets CSS class.
ComHeight | Gets or sets section height (twips).
ComKeepTogether | Gets or sets keeping section together option.
ComMinimumHeight | Gets minimum section height (twips).
ComName | Gets or sets section name.
ComNewPageAfter | Gets or sets new page after option.
ComNewPageBefore | Gets or sets new page before option.
ComNumber | Gets the section index within the report.
ComParent | Gets the section parent (Report or Area).
ComPrintAtBottomOfPage | Gets or sets print at bottom of page option.
ComReportObjects | Gets report object collection within the section.
ComResetPageNumberAfter | Gets or sets reset page after option.
ComSuppress | Gets or sets section visibility.
ComSuppressIfBlank | Gets or sets suppress section if blank option.
ComUnderlaySection | Gets or sets underlay following section option.
ComWidth | Gets section width (twips).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalSection

View event list in alphabetical order

Name | Description
OnComFormat | Fires this event before starting to format a section
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalSection

View method list in alphabetical order

Name | Type | Description
ComAddBlobFieldObject | Function | Adds a blob field object into the section.
ComAddBoxObject | Function | Adds a box object into the section.
ComAddCrossTabObject | Function | Adds a crosstab object into the section.
ComAddFieldObject | Function | Adds a field object into the section.
ComAddGraphObject | Function | Adds a graph object into the section.
ComAddLineObject | Function | Adds a line object into the section.
ComAddPictureObject | Function | Adds a picture field object into the section.
ComAddSpecialVarFieldObject | Function | Adds a special var field object into the section.
ComAddSubreportObject | Function | Adds a subreport object into the section.
ComAddSummaryFieldObject | Function | Adds a summary field object into the section
ComAddTextObject | Function | Adds a text object into the section.
ComAddUnboundFieldObject | Function | Adds an unbound field object into the report.
ComDeleteObject | Procedure | Deletes an object into the section.
ComImportSubreport | Function | Imports a subreport into the section.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalSections

Properties Events Methods Index of Classes

COM object used to access the Sections object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalSections

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalISections

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalSections object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalSections

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets section collection parent (report or area).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalSections

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalSections

View method list in alphabetical order

Name | Type | Description
ComAdd | Function | Adds a section.
ComDelete | Procedure | Delete collection item.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalSortField

Properties Events Methods Index of Classes

COM object used to access the SortField object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalSortField

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalISortField

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalSortField object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalSortField

View property list in alphabetical order

Name | Description
ComField | Gets or sets sorting field.
ComParent | Gets sort field's parent (Report)
ComSortDirection | Gets or sets sort direction.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalSortField

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalSortField

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalSortFields

Properties Events Methods Index of Classes

COM object used to access the SortFields object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalSortFields

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalISortFields

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalSortFields object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalSortFields

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets sort field collection's parent (Report).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalSortFields

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalSortFields

View method list in alphabetical order

Name | Type | Description
ComAdd | Procedure | Adds a sort field
ComDelete | Procedure | Deletes a sort field
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalSpecialVarFieldDefinition

Properties Events Methods Index of Classes

COM object used to access the SpecialVarFieldDefinition object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalSpecialVarFieldDefinition

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalISpecialVarFieldDefinition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalSpecialVarFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalSpecialVarFieldDefinition

View property list in alphabetical order

Name | Description
ComKind | Gets field definition kind.
ComName | Gets field definition unique formula name.
ComNextValue | Gets field next value.
ComNumberOfBytes | Gets field number of bytes.
ComParent | Gets special variable field parent (report).
ComPreviousValue | Gets field previous value.
ComSpecialVarType | Gets special variable type.
ComValue | Gets field value.
ComValueType | Gets field value type.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalSpecialVarFieldDefinition

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalSpecialVarFieldDefinition

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalSQLExpressionFieldDefinition

Properties Events Methods Index of Classes

COM object used to access the SQLExpressionFieldDefinition object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalSQLExpressionFieldDefinition

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalISQLExpressionFieldDefinition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalSQLExpressionFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalSQLExpressionFieldDefinition

View property list in alphabetical order

Name | Description
ComKind | Gets field definition kind.
ComName | Gets field definition unique formula name.
ComNextValue | Gets field next value.
ComNumberOfBytes | Gets field number of bytes.
ComParent | Gets summary field parent (report).
ComPreviousValue | Gets field previous value.
ComSQLExpressionFieldName | Gets SQL expression field name.
ComText | Gets or sets SQL expression text.
ComValue | Gets field value.
ComValueType | Gets field value type.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalSQLExpressionFieldDefinition

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalSQLExpressionFieldDefinition

View method list in alphabetical order

Name | Type | Description
ComCheck | Procedure | Checks whether the SQL expression is valid
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalSQLExpressionFieldDefinitions

Properties Events Methods Index of Classes

COM object used to access the SQLExpressionFieldDefinitions object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalSQLExpressionFieldDefinitions

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalISQLExpressionFieldDefinitions

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalSQLExpressionFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalSQLExpressionFieldDefinitions

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets SQL expression field collection parent (report).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalSQLExpressionFieldDefinitions

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalSQLExpressionFieldDefinitions

View method list in alphabetical order

Name | Type | Description
ComAdd | Function | Add a SQL expression field collection item
ComDelete | Procedure | Delete a SQL expression field collection item
ComGetItemByName | Function | Gets collection item by name index.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalSubreportLink

Properties Events Methods Index of Classes

COM object used to access the SubreportLink object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalSubreportLink

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalISubreportLink

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalSubreportLink object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalSubreportLink

View property list in alphabetical order

Name | Description
ComMainReportField | Gets main report field.
ComParent | Gets subreport link's parent (Report)
ComSubreportField | Gets subreport field.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalSubreportLink

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalSubreportLink

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalSubreportLinks

Properties Events Methods Index of Classes

COM object used to access the SubreportLinks object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalSubreportLinks

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalISubreportLinks

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalSubreportLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalSubreportLinks

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets subreport link's parent (Report).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalSubreportLinks

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalSubreportLinks

View method list in alphabetical order

Name | Type | Description
ComAdd | Function | Adds a subreport link
ComDelete | Procedure | Deletes a subreport link
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalSubreportObject

Properties Events Methods Index of Classes

COM object used to access the SubreportObject object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalSubreportObject

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalISubreportObject

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalSubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalSubreportObject

View property list in alphabetical order

Name | Description
ComBackColor | Gets or sets object background color.
ComBorderColor | Gets or sets object border color.
ComBottomLineStyle | Gets or sets bottom line style.
ComCanGrow | Gets or sets can grow option.
ComCloseAtPageBreak | Gets or sets close border on page break.
ComConditionFormula | Gets or sets conditional formula.
ComCssClass | Gets or sets CSS class.
ComEnableOnDemand | Gets on-demand subreport option.
ComHasDropShadow | Gets or sets border drop shadow.
ComHeight | Gets or sets object height (twips).
ComKeepTogether | Gets or sets keep object together.
ComKind | Gets report object kind.
ComLeft | Gets or sets object upper left position (twips).
ComLeftLineStyle | Gets or sets left line style.
ComLinks | Gets subreport links.
ComName | Gets or sets object name.
ComParent | Gets object parent (Section).
ComRightLineStyle | Gets or sets right line style.
ComSubreportName | Gets or sets subreport name.
ComSuppress | Gets or sets object visibility.
ComTop | Gets or sets object upper top position (twips).
ComTopLineStyle | Gets or sets top line style.
ComWidth | Gets or sets object width (twips).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalSubreportObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalSubreportObject

View method list in alphabetical order

Name | Type | Description
ComOpenSubreport | Function | Opens the subreport object.
ComReimportSubreport | Procedure | Reimport subreport object.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalSummaryFieldDefinition

Properties Events Methods Index of Classes

COM object used to access the SummaryFieldDefinition object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalSummaryFieldDefinition

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalISummaryFieldDefinition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalSummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalSummaryFieldDefinition

View property list in alphabetical order

Name | Description
ComFooterArea | Get the area pair the summary is in.
ComForCrossTab | Gets for-cross-tab
ComHeaderArea | Gets the area pair the summary is in
ComHierarchicalSummaryType | Gets or sets summary hierarchical type
ComKind | Gets field definition kind.
ComName | Gets field definition unique formula name.
ComNextValue | Gets field next value.
ComNumberOfBytes | Gets field number of bytes.
ComParent | Gets summary field parent (report).
ComPreviousValue | Gets field previous value.
ComSecondarySummarizedField | Gets secondary summarized field
ComSummarizedField | Gets summarized field
ComSummaryOperationParameter | Gets or sets summary operation parameter
ComSummaryType | Gets or sets summary type
ComValue | Gets field value.
ComValueType | Gets field value type.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalSummaryFieldDefinition

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalSummaryFieldDefinition

View method list in alphabetical order

Name | Type | Description
ComSetSecondarySummarizedField | Procedure | Sets secondary summarized field
ComSetSummarizedField | Procedure | Sets summarized field
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalSummaryFieldDefinitions

Properties Events Methods Index of Classes

COM object used to access the SummaryFieldDefinitions object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalSummaryFieldDefinitions

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalISummaryFieldDefinitions

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalSummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalSummaryFieldDefinitions

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets summary field collection parent (report).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalSummaryFieldDefinitions

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalSummaryFieldDefinitions

View method list in alphabetical order

Name | Type | Description
ComAdd | Function | Add a Summary field collection item
ComDelete | Procedure | Delete a Summary field collection item
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalTableLink

Properties Events Methods Index of Classes

COM object used to access the TableLink object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalTableLink

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalITableLink

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalTableLink object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalTableLink

View property list in alphabetical order

Name | Description
ComDestinationFields | Gets table link destination field definitions.
ComDestinationTable | Gets table link destination table.
ComJoinType | Gets table link join type.
ComLookupType | Gets table link lookup type.
ComParent | Gets table link parent (Database).
ComSourceFields | Gets table link source field definitions.
ComSourceTable | Gets table link source table.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalTableLink

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalTableLink

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalTableLinks

Properties Events Methods Index of Classes

COM object used to access the TableLinks object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalTableLinks

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalITableLinks

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalTableLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalTableLinks

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets collection count.
ComItem | Gets collection item.
ComParent | Gets database links parent (Database).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalTableLinks

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalTableLinks

View method list in alphabetical order

Name | Type | Description
ComAdd | Function | Adds a database link.
ComDelete | Procedure | Delete a table link.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalTableQualifiers

Properties Events Methods Index of Classes

COM object used to access the TableQualifiers object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalTableQualifiers

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalITableQualifiers

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalTableQualifiers object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalTableQualifiers

View property list in alphabetical order

Name | Description
Com_NewEnum |
ComCount | Gets the count of qualifiers.
ComItem | Gets the qualifier by index.
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalTableQualifiers

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalTableQualifiers

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cCrystalTextObject

Properties Events Methods Index of Classes

COM object used to access the TextObject object in the Crystal RDC object model

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject
---------cCrystalTextObject

Library: Common (Windows and Web Application) Class Library

Package: cCrystalcraxddrt.pkg

Mixins: cCrystalITextObject

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalTextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

See Also

cCrystal | cCrystalReport

Last Edited: December 20, 2005


Properties for cCrystalTextObject

View property list in alphabetical order

Name | Description
ComBackColor | Gets or sets object background color.
ComBorderColor | Gets or sets object border color.
ComBottomLineStyle | Gets or sets bottom line style.
ComCanGrow | Gets or sets can grow option.
ComCharacterSpacing | Gets or sets character spacing.
ComCloseAtPageBreak | Gets or sets close border on page break.
ComConditionFormula | Gets or sets conditional formula.
ComCssClass | Gets or sets CSS class.
ComFieldElements | Gets or sets embedded field elements.
ComFirstLineIndent | Gets or sets first line indent.
ComFont | Gets or sets standard OLE font.
ComHasDropShadow | Gets or sets border drop shadow.
ComHeight | Gets or sets object height (twips).
ComHorAlignment | Gets or sets horizontal alignment.
ComHyperlinkText | Gets or sets hyperlink text.
ComHyperlinkType | Gets or sets hyperlink type.
ComKeepTogether | Gets or sets keep object together.
ComKind | Gets report object kind.
ComLeft | Gets or sets object upper left position (twips).
ComLeftIndent | Gets or sets left indent.
ComLeftLineStyle | Gets or sets left line style.
ComLineSpacing | Gets line spacing.
ComLineSpacingType | Gets line spacing type.
ComMaxNumberOfLines | Gets or sets max of number of line option.
ComName | Gets or sets object name.
ComParent | Gets object parent (Section).
ComRightIndent | Gets or sets right indent.
ComRightLineStyle | Gets or sets right line style.
ComSuppress | Gets or sets object visibility.
ComSuppressIfDuplicated | Gets or sets suppress if duplicated option.
ComText | Gets whole text string.
ComTextColor | Gets or sets object text color.
ComTextRotationAngle | Gets or sets text rotation angle.
ComTop | Gets or sets object upper top position (twips).
ComTopLineStyle | Gets or sets top line style.
ComWidth | Gets or sets object width (twips).
Inherited Properties from DfComAutomationObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cCrystalTextObject

View event list in alphabetical order

Name | Description
Inherited Events from DfComAutomationObject
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cCrystalTextObject

View method list in alphabetical order

Name | Type | Description
ComSetLineSpacing | Procedure | Sets line spacing type and line spacing.
ComSetText | Procedure | Sets text object text to be the specified text.
Inherited Methods from cComAutomationObject
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated
Inherited Methods from DfComAutomationObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cDB2Handler

Properties Events Methods Index of Classes

Implements functionality specific to DB2.

Hierarchy

cObject
---Array
------cCLIHandler
---------cDB2Handler

Library: Common (Windows and Web Application) Class Library

Package: db2_drv.pkg

Description

The cDB2Handler class implements functionality specific to DB2.

Enumerating data sources

Two methods are available to enumerate data sources. They can be used to present lists of available data sources in utilities. A procedure to show all available data sources with comments looks like:

Use DB2_DRV.pkg

Procedure ShowDB2DataSources
    Handle hoDB2Handler
    String sDataSourceAndComment

    Get Create U_cDB2Handler To hoDB2Handler
    If (hoDB2Handler > 0) Begin
        Send SeedDataSources Of hoDB2Handler
        Repeat
            Get DataSources Of hoDB2Handler To sDataSourceAndComment
            Showln sDataSourceAndComment
        Until (sDataSourceAndComment = "")
        Send Destroy Of hoDB2Handler
    End
End_Procedure // ShowDB2DataSources

Last Edited: April 21, 2005


Properties for cDB2Handler

View property list in alphabetical order

Name | Description
Inherited Properties from cCLIHandler
psDriverID | The identification of the CLI driver.
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cDB2Handler

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cDB2Handler

View method list in alphabetical order

Name | Type | Description
DataSources | Function |
SeedDataSources | Procedure |
Inherited Methods from cCLIHandler
CKBuildRevision | Function | Returns the build revision of the Connectivity Kit.
CKMajorRevision | Function | Returns the major revision of the Connectivity Kit.
CKMinorRevision | Function | Returns the minor revision of the Connectivity Kit.
CKReleaseRevision | Function | Returns the release revision of the Connectivity Kit.
CKRevision | Function | Returns the Connectivity Kit revision in the format Major.Minor.Release.Build.
CLIDFDateToSQLDate | Function |
CLISQLDateToDFDate | Function |
ColumnName | Function | Returns the name of the column enumerated at the given position by EnumerateColumns.
DumpStatus | Procedure | Dumps the current status of the Connectivity Kit to an ASCII disk file.
EnumerateColumns | Function | Enumerates all column names for a given table.
EnumerateTables | Function | Enumerates tables in the given database.
ExtractPartFromRevision | Function |
IsMinimalRevision | Function | Checks if a Connectivity Kit complies with a minimal revision.
LastDriverError | Function | Returns the string value of the last generated driver error.
MaxUsers | Function | Returns the maximum number of users of the Connectivity Kit.
ReadConfiguration | Procedure | Forces the Connectivity Kit to reread the driver configuration file.
RedirectConnection | Function |
RegistrationName | Function | Returns the registration name of the Connectivity Kit.
RIMValueToText | Function | Converts a DF_FILE_GENERATE_RECORD_ID_METHOD attribute value to the corresponding text.
ROValueToText | Function | Converts a DF_FIELD_READ_ONLY attribute value to the corresponding text.
SchemaName | Function | Returns the schema of the table enumerated at the given position by EnumerateTables.
SerialNumber | Function | Returns the Connectivity Kit serial number.
TableComment | Function | Returns the comment of the table enumerated at the given position by EnumerateTables.
TableName | Function | Returns the name of the table enumerated at the given position by EnumerateTables.
TableType | Function | Returns the type of the table enumerated at the given position by EnumerateTables.
TextToRIMValue | Function | Converts a record identity text to the DF_FILE_GENERATE_RECORD_ID_METHOD attribute value
TextToROValue | Function | Converts a read only text to the DF_FIELD_READ_ONLY attribute value.
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cDbRichEdit

Properties Events Methods Index of Classes

Allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DFBaseRichEdit
---------------------cRichEdit
------------------------cDbRichEdit_
---------------------------cDbRichEditDS_
------------------------------cDbRichEdit

Library: Windows Application Class Library

Package: cDbRichEdit.pkg

Mixins: Extended_DEO_Status_Help_Mixin

Description

The data-aware cDbRichEdit class allows the user to enter and edit text while also providing more advanced formatting features than the plain-text dbEdit class.

The cDbRichEdit class is a data-aware class similar to the cRichEdit class.
The cDbTextEdit class is a plain-text class similar to the cDbRichEdit class.

The default maximum number of characters for the control is 64 KB (65536 bytes or characters). This can be changed or retrieved via piMaxChars.

A linefeed (LF) character can be added to text programmatically by adding ASCII character 10 to a string using the character function. A carriage return (CR) character can be added to text programmatically by adding ASCII character 13 to a string using the character function. Either a LF or CR character will break the current line in the control. Also see AppendTextLn.

Sample

Object oRichEdit1 is a cDbRichEdit
    Set Size to 168 276
    Set Location to 6 10
    Set peAnchors to anAll
End_Object    // oDbRichEdit1

Syntax

Use cDbRichEdit.pkg

Object oObjectName is a cDbRichEdit
    Set Size to iHeight iWidth
    Set Location to iRow iColumn
End_Object  // oDbObjectName

Text Formatting

An application can send messages to a rich edit control to format characters and paragraphs to retrieve formatting information. Paragraph formatting attributes include alignment, tabs, indents, numbering, and simple tables. For characters, you can specify font name, size, color, and effects such as bold, italic, and protected.

The character formatting of the insertion point is applied to newly inserted text only if the current selection is empty (if the current selection is an insertion point). Otherwise, the new text assumes the character formatting of the text it replaces. If the selection changes, the default character formatting changes to match the first character in the new selection.

Current Selection in a Rich Edit Control

The user can select text in a rich edit control by using the mouse or the keyboard. The current selection is the range of selected characters, or the position of the insertion point if no characters are selected. An application can get information about the current selection, set it, determine when it changes, and show or hide the selection highlight.

Word and Line Breaks

A rich edit control calls a function called a word-break procedure to find breaks between words and to determine where it can break lines. The control uses this information when performing word-wrap operations and when processing CTRL+LEFT ARROW key and CTRL+RIGHT ARROW key combinations. An application can send messages to a rich edit control to replace the default word-break procedure, to retrieve word-break information, and to determine what line a given character falls on.

Rich Edit Shortcut Keys

Rich edit controls support the following shortcut keys.

Keys | Operations | Comments
Shift+Backspace | Generate a LRM/LRM on a bidi keyboard | BiDi specific
Ctrl+Tab | Tab |
Ctrl+Clear | Select all |
Ctrl+Number Pad 5 | Select all |
Ctrl+A | Select all |
Ctrl+E | Center alignment |
Ctrl+J | Justify alignment |
Ctrl+R | Right alignment |
Ctrl+L | Left alignment |
Ctrl+C | Copy |
Ctrl+V | Paste |
Ctrl+X | Cut |
Ctrl+Z | Undo |
Ctrl+Y | Redo |
Ctrl+'+' (Ctrl+Shift+'=') | Superscript |
Ctrl+'=' | Subscript |
Ctrl+1 | Line spacing = 1 line. |
Ctrl+2 | Line spacing = 2 lines. |
Ctrl+5 | Line spacing = 1.5 lines. |
Ctrl+' (apostrophe) | Accent acute | After pressing the short cut key, press the appropriate letter (for example a, e, or u). This applies to English, French, German, Italian, and Spanish keyboards only.
Ctrl+` (grave) | Accent grave | See Ctrl+' comments.
Ctrl+~ (tilde) | Accent tilde | See Ctrl+' comments.
Ctrl+; (semicolon) | Accent umlaut | See Ctrl+' comments.
Ctrl+Shift+6 | Accent caret (circumflex) | See Ctrl+' comments.
Ctrl+, (comma) | Accent cedilla | See Ctrl+' comments.
Ctrl+Shift+' (apostrophe) | Activate smart quotes |
Backspace | If text is protected, beep and do not delete it. Otherwise, delete previous character. |
Ctrl+Backspace | Delete previous word. This generates a VK_F16 code. |
F16 | Same as Backspace. |
Ctrl+Insert | Copy |
Shift+Insert | Paste |
Insert | Overwrite | DBCS (double-byte character set) does not overwrite.
Ctrl+Left Arrow | Move cursor one word to the left. | On bidi keyboard, this depends on the direction of the text.
Ctrl+Right Arrow | Move cursor one word to the right. | See Ctrl+Left Arrow comments.
Ctrl+Left Shift | Left alignment | In BiDi documents, this is for left-to-right reading order.
Ctrl+Right Shift | Right alignment | In BiDi documents, this is for right-to-left reading order.
Ctrl+Up Arrow | Move to the line above. |
Ctrl+Down Arrow | Move to the line below. |
Ctrl+Home | Move to the beginning of the document. |
Ctrl+End | Move to the end of the document. |
Ctrl+Page Up | Move one page up. | If in SystemEditMode and Single Line control, do nothing.
Ctrl+Page Down | Move one page down. | See Ctrl+Page Up comments.
Ctrl+Delete | Delete the next word or selected characters. |
Shift+Delete | Cut the selected characters. |
Esc | Stop drag-drop. | While doing a drag-drop of text.
Alt+Esc | Change the active application. |
Alt+X | Converts the Unicode hexadecimal value preceding the insertion point to the corresponding Unicode character. |
Alt+Shift+X | Converts the Unicode character preceding the insertion point to the corresponding Unicode hexadecimal value. |
Alt+0xxx (Number Pad) | Inserts Unicode values if xxx is greater than 255. When xxx is less than 256, ASCI range text is inserted based on the current keyboard. | Must enter decimal values.
Alt+Shift+Ctrl+F12 | Hex to Unicode. | In case Alt+X is already taken for another use.
Alt+Shift+Ctrl+F11 | Selected text will be output to the debugger window and saved to %temp%\DumpFontInfo.txt. | For Debug only (need to set Flag=8 in Win.ini)
Ctrl+Shift+A | Set all caps. |
Ctrl+Shift+L | Fiddle bullet style. |

Last Edited: May 4, 2005


Properties for cDbRichEdit

View property list in alphabetical order

Name | Description
Auto_Label_State | Determines if the control will draw label values from the DataDictionary instead of the Label property
Inherited Properties from cDbRichEdit_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Data_Field | The field number of the target text field
Data_File | The file number of target memo field
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Item_Count | Created for simulation of entry item
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from cRichEdit
Changed_State | Determines whether the content of the control has changed
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DFBaseRichEdit
Line_Count | Returns number of lines in control
paValue | Sets content of control from memory address or places RTF stream in control into memory address
pbAutoUrl | Toggles the ability for the control to automatically detect URLs and add hyperlinks
pbBold | Toggles selected text between bold and normal text
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard
pbCanRedo | Determines whether a redo operation can be performed
pbCanUndo | Determines whether an undo operation can be performed
pbItalics | Toggles selected text between italicized and normal text
pbLink | Toggles selected text between hyperlinked and normal text
pbProtect | Toggles selected text between protected and normal text
pbStrikeOut | Toggles selected text between strikeout and normal text
pbSubScript | Toggles selected text between subcripted and normal text
pbSuperScript | Toggles selected text between superscripted and normal text
pbUnderline | Toggles selected text between underlined and normal text
pbWrap | Determines whether text input will break and wrap to the next line at right margin
peAlignment | Sets or returns alignment of selected paragraph or paragraphs
peBullets | Sets or returns bullets or numbering of selected paragraph or paragraphs
peBulletStyle | Sets or returns numbering styles of selected paragraph or paragraphs
peCharSet | Sets or returns character set of selected text
peLineSpacingType | Determines type of line spacing of selected paragraph or paragraphs
pePitchandFamily | Sets or returns the font pitch and family of selected text
piBulletStart | Sets or returns the starting number of paragraph numbering of selected paragraph or paragraphs
piBulletTab | Sets or returns the minimum space between a paragraph bullet or number and the paragraph text of selected paragraph or paragraphs
piFontSize | Sets or returns font size of selected text
piFontWeight | Sets or returns font weight of selected text
piLineSpacing | Determines exact line spacing of selected paragraph or paragraphs
piMaxChars | Sets or returns maximum number of characters
piOffsetIndent | Sets or returns indentation of 2nd and subsequent lines, relative to first line, of selected paragraph or paragraphs
piParagraphIndent | Sets or returns indentation of selected paragraph or paragraphs
piRightMargin | Determines indentation of right side of control's text, relative to the right margin
piSpacingAfter | Determines the spacing below selected paragraph or paragraphs
piSpacingBefore | Determines the spacing above selected paragraph or paragraphs
psTypeFace | Sets or returns font typeface of selected text
Read_Only_State | Determines whether users may edit the content of the control
TextBackColor | Sets or returns background color of selected text
TextColor | Sets or returns color of selected text
Value | Sets or returns content of control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cDbRichEdit

View event list in alphabetical order

Name | Description
Inherited Events from cDbRichEdit_
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from cRichEdit
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Fires whenever the value of the control is changed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText | Fires when maximum text size is exceeded
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Fired whenever a change in enabled state occurs
Inherited Events from DFBaseRichEdit
OnLinkClicked | Fires when hyperlink in text is clicked
OnSelectionChanged | Fires when selection changes
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cDbRichEdit

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cDbRichEditDS_
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Items | Function | Returns whether data in the control is valid
Validate_Prompt | Function | (Obsolete)
Inherited Methods from cDbRichEdit_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Prompt | Procedure | Cancelled in this class
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Cancelled in this class
Inherited Methods from cRichEdit
Activate_Area | Procedure |
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
ToggleBold | Procedure | Toggles selected text between bold and normal text
ToggleItalics | Procedure | Toggles selected text between italicized and normal text
ToggleUnderline | Procedure | Toggles selected text between underlined and normal text
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DFBaseRichEdit
AppendText | Procedure | Appends text to end of text in control
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control
Beginning_of_Line | Procedure | Places the cursor at beginning of current line
CharCount | Function | Returns length of RTF stream in the control
ClearUndoBuffer | Procedure | Clears undo buffer
Delete_Data | Procedure | Deletes all data in control
End_of_Data | Procedure | Places the cursor at end of the text in control
End_of_Line | Procedure | Places the cursor at end of current line
FindText | Function | Searches for specified text in control
FirstCharInLinePos | Function | Returns position of first character in a line
FirstVisibleLine | Function | Returns number of first visible line
HideSelection | Procedure | Toggles selection highlighting on or off
LastErrorCode | Function | Returns error code for last operation
Line | Function | Returns specified line of text
LineFromChar | Function | Returns number of line that contains specified character position or current line
LineLength | Function | Returns number of characters in line
Read | Procedure | Reads RTF document and displays it in the control
Redo | Procedure | Redoes the last operation
RedoType | Function | Returns type of redo operation at top of redo queue
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements
ReplaceSel | Procedure | Replaces selected text with specified text
Scroll | Procedure | Scrolls up or down the control using specified scroll mode
ScrollCaret | Procedure | Scrolls caret into view
ScrollLines | Procedure | Scrolls control vertically for specified number of lines
Select_All | Procedure | Selects entire contents of control
SelEnd | Function | Returns end of selection
SelStart | Function | Returns beginning of selection
SelText | Function | Returns selected text
SetSel | Procedure | Selects text in given position range
TextRange | Function | Returns text in given position range
Undo | Procedure | Undoes the last operation
UndoType | Function | Returns type of undo operation at top of undo queue
Write | Procedure | Writes RTF stream content of control to file
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cDbRichEdit_

Class: cDbRichEdit_ (Abstract)

Properties Events Methods Index of Classes

Allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DFBaseRichEdit
---------------------cRichEdit
------------------------cDbRichEdit_
---------------------------cDbRichEditDS_

Library: Windows Application Class Library

Package: cDbRichEdit.pkg

Mixins: Text_Window_mixin Nesting_Mixin Navigate_Mixin Verify_Mixin Server_Mixin Action_Bar_Mixin Find_Edit_Mixin Non_Dependent_Item_Mixin DEO_Delegate_Mixin

Description

cDbRichEdit_ allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table. Its sub-class cDbRichEdit should be used for sub-classing and instantiation.

Last Edited: November 24, 2004


Properties for cDbRichEdit_

View property list in alphabetical order

Name | Description
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Data_Field | The field number of the target text field
Data_File | The file number of target memo field
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Item_Count | Created for simulation of entry item
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from cRichEdit
Changed_State | Determines whether the content of the control has changed
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DFBaseRichEdit
Line_Count | Returns number of lines in control
paValue | Sets content of control from memory address or places RTF stream in control into memory address
pbAutoUrl | Toggles the ability for the control to automatically detect URLs and add hyperlinks
pbBold | Toggles selected text between bold and normal text
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard
pbCanRedo | Determines whether a redo operation can be performed
pbCanUndo | Determines whether an undo operation can be performed
pbItalics | Toggles selected text between italicized and normal text
pbLink | Toggles selected text between hyperlinked and normal text
pbProtect | Toggles selected text between protected and normal text
pbStrikeOut | Toggles selected text between strikeout and normal text
pbSubScript | Toggles selected text between subcripted and normal text
pbSuperScript | Toggles selected text between superscripted and normal text
pbUnderline | Toggles selected text between underlined and normal text
pbWrap | Determines whether text input will break and wrap to the next line at right margin
peAlignment | Sets or returns alignment of selected paragraph or paragraphs
peBullets | Sets or returns bullets or numbering of selected paragraph or paragraphs
peBulletStyle | Sets or returns numbering styles of selected paragraph or paragraphs
peCharSet | Sets or returns character set of selected text
peLineSpacingType | Determines type of line spacing of selected paragraph or paragraphs
pePitchandFamily | Sets or returns the font pitch and family of selected text
piBulletStart | Sets or returns the starting number of paragraph numbering of selected paragraph or paragraphs
piBulletTab | Sets or returns the minimum space between a paragraph bullet or number and the paragraph text of selected paragraph or paragraphs
piFontSize | Sets or returns font size of selected text
piFontWeight | Sets or returns font weight of selected text
piLineSpacing | Determines exact line spacing of selected paragraph or paragraphs
piMaxChars | Sets or returns maximum number of characters
piOffsetIndent | Sets or returns indentation of 2nd and subsequent lines, relative to first line, of selected paragraph or paragraphs
piParagraphIndent | Sets or returns indentation of selected paragraph or paragraphs
piRightMargin | Determines indentation of right side of control's text, relative to the right margin
piSpacingAfter | Determines the spacing below selected paragraph or paragraphs
piSpacingBefore | Determines the spacing above selected paragraph or paragraphs
psTypeFace | Sets or returns font typeface of selected text
Read_Only_State | Determines whether users may edit the content of the control
TextBackColor | Sets or returns background color of selected text
TextColor | Sets or returns color of selected text
Value | Sets or returns content of control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cDbRichEdit_

View event list in alphabetical order

Name | Description
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from cRichEdit
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Fires whenever the value of the control is changed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText | Fires when maximum text size is exceeded
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Fired whenever a change in enabled state occurs
Inherited Events from DFBaseRichEdit
OnLinkClicked | Fires when hyperlink in text is clicked
OnSelectionChanged | Fires when selection changes
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cDbRichEdit_

View method list in alphabetical order

Name | Type | Description
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Prompt | Procedure | Cancelled in this class
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Returns 0 by default, to indicate that entered text is valid
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Cancelled in this class
Inherited Methods from cRichEdit
Activate_Area | Procedure |
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
ToggleBold | Procedure | Toggles selected text between bold and normal text
ToggleItalics | Procedure | Toggles selected text between italicized and normal text
ToggleUnderline | Procedure | Toggles selected text between underlined and normal text
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DFBaseRichEdit
AppendText | Procedure | Appends text to end of text in control
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control
Beginning_of_Line | Procedure | Places the cursor at beginning of current line
CharCount | Function | Returns length of RTF stream in the control
ClearUndoBuffer | Procedure | Clears undo buffer
Delete_Data | Procedure | Deletes all data in control
End_of_Data | Procedure | Places the cursor at end of the text in control
End_of_Line | Procedure | Places the cursor at end of current line
FindText | Function | Searches for specified text in control
FirstCharInLinePos | Function | Returns position of first character in a line
FirstVisibleLine | Function | Returns number of first visible line
HideSelection | Procedure | Toggles selection highlighting on or off
LastErrorCode | Function | Returns error code for last operation
Line | Function | Returns specified line of text
LineFromChar | Function | Returns number of line that contains specified character position or current line
LineLength | Function | Returns number of characters in line
Read | Procedure | Reads RTF document and displays it in the control
Redo | Procedure | Redoes the last operation
RedoType | Function | Returns type of redo operation at top of redo queue
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements
ReplaceSel | Procedure | Replaces selected text with specified text
Scroll | Procedure | Scrolls up or down the control using specified scroll mode
ScrollCaret | Procedure | Scrolls caret into view
ScrollLines | Procedure | Scrolls control vertically for specified number of lines
Select_All | Procedure | Selects entire contents of control
SelEnd | Function | Returns end of selection
SelStart | Function | Returns beginning of selection
SelText | Function | Returns selected text
SetSel | Procedure | Selects text in given position range
TextRange | Function | Returns text in given position range
Undo | Procedure | Undoes the last operation
UndoType | Function | Returns type of undo operation at top of undo queue
Write | Procedure | Writes RTF stream content of control to file
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cDbRichEditDS_

Class: cDbRichEditDS_ (Abstract)

Properties Events Methods Index of Classes

Allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DFBaseRichEdit
---------------------cRichEdit
------------------------cDbRichEdit_
---------------------------cDbRichEditDS_
------------------------------cDbRichEdit

Library: Windows Application Class Library

Package: cDbRichEdit.pkg

Mixins: DFNavigate_Mixin DFCode_DEO_Mixin DataFile_Help_Mixin

Description

cDbRichEditDS_ allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table. Its sub-class cDbRichEdit should be used for sub-classing and instantiation.

Last Edited: November 24, 2004


Properties for cDbRichEditDS_

View property list in alphabetical order

Name | Description
Inherited Properties from cDbRichEdit_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Data_Field | The field number of the target text field
Data_File | The file number of target memo field
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Item_Count | Created for simulation of entry item
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from cRichEdit
Changed_State | Determines whether the content of the control has changed
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DFBaseRichEdit
Line_Count | Returns number of lines in control
paValue | Sets content of control from memory address or places RTF stream in control into memory address
pbAutoUrl | Toggles the ability for the control to automatically detect URLs and add hyperlinks
pbBold | Toggles selected text between bold and normal text
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard
pbCanRedo | Determines whether a redo operation can be performed
pbCanUndo | Determines whether an undo operation can be performed
pbItalics | Toggles selected text between italicized and normal text
pbLink | Toggles selected text between hyperlinked and normal text
pbProtect | Toggles selected text between protected and normal text
pbStrikeOut | Toggles selected text between strikeout and normal text
pbSubScript | Toggles selected text between subcripted and normal text
pbSuperScript | Toggles selected text between superscripted and normal text
pbUnderline | Toggles selected text between underlined and normal text
pbWrap | Determines whether text input will break and wrap to the next line at right margin
peAlignment | Sets or returns alignment of selected paragraph or paragraphs
peBullets | Sets or returns bullets or numbering of selected paragraph or paragraphs
peBulletStyle | Sets or returns numbering styles of selected paragraph or paragraphs
peCharSet | Sets or returns character set of selected text
peLineSpacingType | Determines type of line spacing of selected paragraph or paragraphs
pePitchandFamily | Sets or returns the font pitch and family of selected text
piBulletStart | Sets or returns the starting number of paragraph numbering of selected paragraph or paragraphs
piBulletTab | Sets or returns the minimum space between a paragraph bullet or number and the paragraph text of selected paragraph or paragraphs
piFontSize | Sets or returns font size of selected text
piFontWeight | Sets or returns font weight of selected text
piLineSpacing | Determines exact line spacing of selected paragraph or paragraphs
piMaxChars | Sets or returns maximum number of characters
piOffsetIndent | Sets or returns indentation of 2nd and subsequent lines, relative to first line, of selected paragraph or paragraphs
piParagraphIndent | Sets or returns indentation of selected paragraph or paragraphs
piRightMargin | Determines indentation of right side of control's text, relative to the right margin
piSpacingAfter | Determines the spacing below selected paragraph or paragraphs
piSpacingBefore | Determines the spacing above selected paragraph or paragraphs
psTypeFace | Sets or returns font typeface of selected text
Read_Only_State | Determines whether users may edit the content of the control
TextBackColor | Sets or returns background color of selected text
TextColor | Sets or returns color of selected text
Value | Sets or returns content of control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cDbRichEditDS_

View event list in alphabetical order

Name | Description
Inherited Events from cDbRichEdit_
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from cRichEdit
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Fires whenever the value of the control is changed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText | Fires when maximum text size is exceeded
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Fired whenever a change in enabled state occurs
Inherited Events from DFBaseRichEdit
OnLinkClicked | Fires when hyperlink in text is clicked
OnSelectionChanged | Fires when selection changes
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cDbRichEditDS_

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Items | Function | Returns whether data in the control is valid
Validate_Prompt | Function | (Obsolete)
Inherited Methods from cDbRichEdit_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Prompt | Procedure | Cancelled in this class
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Cancelled in this class
Inherited Methods from cRichEdit
Activate_Area | Procedure |
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
ToggleBold | Procedure | Toggles selected text between bold and normal text
ToggleItalics | Procedure | Toggles selected text between italicized and normal text
ToggleUnderline | Procedure | Toggles selected text between underlined and normal text
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DFBaseRichEdit
AppendText | Procedure | Appends text to end of text in control
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control
Beginning_of_Line | Procedure | Places the cursor at beginning of current line
CharCount | Function | Returns length of RTF stream in the control
ClearUndoBuffer | Procedure | Clears undo buffer
Delete_Data | Procedure | Deletes all data in control
End_of_Data | Procedure | Places the cursor at end of the text in control
End_of_Line | Procedure | Places the cursor at end of current line
FindText | Function | Searches for specified text in control
FirstCharInLinePos | Function | Returns position of first character in a line
FirstVisibleLine | Function | Returns number of first visible line
HideSelection | Procedure | Toggles selection highlighting on or off
LastErrorCode | Function | Returns error code for last operation
Line | Function | Returns specified line of text
LineFromChar | Function | Returns number of line that contains specified character position or current line
LineLength | Function | Returns number of characters in line
Read | Procedure | Reads RTF document and displays it in the control
Redo | Procedure | Redoes the last operation
RedoType | Function | Returns type of redo operation at top of redo queue
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements
ReplaceSel | Procedure | Replaces selected text with specified text
Scroll | Procedure | Scrolls up or down the control using specified scroll mode
ScrollCaret | Procedure | Scrolls caret into view
ScrollLines | Procedure | Scrolls control vertically for specified number of lines
Select_All | Procedure | Selects entire contents of control
SelEnd | Function | Returns end of selection
SelStart | Function | Returns beginning of selection
SelText | Function | Returns selected text
SetSel | Procedure | Selects text in given position range
TextRange | Function | Returns text in given position range
Undo | Procedure | Undoes the last operation
UndoType | Function | Returns type of undo operation at top of undo queue
Write | Procedure | Writes RTF stream content of control to file
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cDbTextEdit

Properties Events Methods Index of Classes

Allows the user to enter and edit text connected to a column in a database table

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DFBaseTextEdit
---------------------cTextEdit
------------------------cDbTextEdit_
---------------------------cDbTextEditDS_
------------------------------cDbTextEdit

Library: Windows Application Class Library

Package: cDbTextEdit.pkg

Mixins: Extended_DEO_Status_Help_Mixin

Description

The data-aware cDbTextEdit class allows the user to enter and edit text connected to a column in a database table.

The cDbTextEdit class is a data-aware class similar to the cTextEdit class.
The cDbRichEdit class is a rich-text class similar to the cDbTextEdit class.

The default maximum number of characters for the control is 64 KB (65536 bytes or characters). This can be changed or retrieved via piMaxChars.

A linefeed (LF) character can be added to text programmatically by adding ASCII character 10 to a string using the character function. A carriage return (CR) character can be added to text programmatically by adding ASCII character 13 to a string using the character function. Either a LF or CR character will break the current line in the control. Also see AppendTextLn.

Sample

Object oDbTextEdit1 is a cDbTextEdit
    Set Size to 168 276
    Set Location to 6 10
    Set peAnchors to anAll
End_Object    // oDbTextEdit1

Syntax

Use cDbTextEdit.pkg

Object oObjectName is a cDbTextEdit
    Set Size to iHeight iWidth
    Set Location to iRow iColumn
 End_Object  // oObjectName

Current Selection in a Rich Edit Control

The user can select text in a rich edit control by using the mouse or the keyboard. The current selection is the range of selected characters, or the position of the insertion point if no characters are selected. An application can get information about the current selection, set it, determine when it changes, and show or hide the selection highlight.

Word and Line Breaks

A rich edit control calls a function called a word-break procedure to find breaks between words and to determine where it can break lines. The control uses this information when performing word-wrap operations and when processing CTRL+LEFT ARROW key and CTRL+RIGHT ARROW key combinations. An application can send messages to a rich edit control to replace the default word-break procedure, to retrieve word-break information, and to determine what line a given character falls on.

Text Edit Shortcut Keys

Text edit controls support the following shortcut keys.

Keys | Operations | Comments
Shift+Backspace | Generate a LRM/LRM on a bidi keyboard | BiDi specific
Ctrl+Tab | Tab |
Ctrl+Clear | Select all |
Ctrl+Number Pad 5 | Select all |
Ctrl+A | Select all |
Ctrl+C | Copy |
Ctrl+V | Paste |
Ctrl+X | Cut |
Ctrl+Z | Undo |
Ctrl+Y | Redo |
Ctrl+' (apostrophe) | Accent acute | After pressing the short cut key, press the appropriate letter (for example a, e, or u). This applies to English, French, German, Italian, and Spanish keyboards only.
Ctrl+` (grave) | Accent grave | See Ctrl+' comments.
Ctrl+~ (tilde) | Accent tilde | See Ctrl+' comments.
Ctrl+; (semicolon) | Accent umlaut | See Ctrl+' comments.
Ctrl+Shift+6 | Accent caret (circumflex) | See Ctrl+' comments.
Ctrl+, (comma) | Accent cedilla | See Ctrl+' comments.
Ctrl+Shift+' (apostrophe) | Activate smart quotes |
Backspace | If text is protected, beep and do not delete it. Otherwise, delete previous character. |
Ctrl+Backspace | Delete previous word. This generates a VK_F16 code. |
F16 | Same as Backspace. |
Ctrl+Insert | Copy |
Shift+Insert | Paste |
Insert | Overwrite | DBCS (double-byte character set) does not overwrite.
Ctrl+Left Arrow | Move cursor one word to the left. | On bidi keyboard, this depends on the direction of the text.
Ctrl+Right Arrow | Move cursor one word to the right. | See Ctrl+Left Arrow comments.
Ctrl+Left Shift | Left alignment | In BiDi documents, this is for left-to-right reading order.
Ctrl+Right Shift | Right alignment | In BiDi documents, this is for right-to-left reading order.
Ctrl+Up Arrow | Move to the line above. |
Ctrl+Down Arrow | Move to the line below. |
Ctrl+Home | Move to the beginning of the document. |
Ctrl+End | Move to the end of the document. |
Ctrl+Page Up | Move one page up. | If in SystemEditMode and Single Line control, do nothing.
Ctrl+Page Down | Move one page down. | See Ctrl+Page Up comments.
Ctrl+Delete | Delete the next word or selected characters. |
Shift+Delete | Cut the selected characters. |
Esc | Stop drag-drop. | While doing a drag-drop of text.
Alt+Esc | Change the active application. |
Alt+X | Converts the Unicode hexadecimal value preceding the insertion point to the corresponding Unicode character. |
Alt+Shift+X | Converts the Unicode character preceding the insertion point to the corresponding Unicode hexadecimal value. |
Alt+0xxx (Number Pad) | Inserts Unicode values if xxx is greater than 255. When xxx is less than 256, ASCI range text is inserted based on the current keyboard. | Must enter decimal values.
Alt+Shift+Ctrl+F12 | Hex to Unicode. | In case Alt+X is already taken for another use.
Alt+Shift+Ctrl+F11 | Selected text will be output to the debugger window and saved to %temp%\DumpFontInfo.txt. | For Debug only (need to set Flag=8 in Win.ini)

Last Edited: February 22, 2005


Properties for cDbTextEdit

View property list in alphabetical order

Name | Description
Auto_Label_State | Determines if the control will draw label values from the DataDictionary instead of the Label property
Inherited Properties from cDbTextEdit_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Data_Field | The field number of the target text field
Data_File | The file number of target memo field
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Item_Count | Created for simulation of entry item
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from cTextEdit
Changed_State | Determines whether the content of the control has changed
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DFBaseTextEdit
Line_Count | Returns number of lines in control
paValue | Sets content of control from memory address or places text in control into memory address
pbBold | Toggles all text in control between bold and normal text
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard
pbCanRedo | Determines whether a redo operation can be performed
pbCanUndo | Determines whether an undo operation can be performed
pbItalics | Toggles all text in control between italic and normal text
pbWrap | Determines whether text input will break and wrap to the next line at right margin
piFontSize | Sets or returns font size of all text in control
piFontWeight | Sets or returns font weight of all text in control
piMaxChars | Sets or returns maximum number of visible characters
piRightMargin | Determines indentation of right side of control's text, relative to the right margin
psTypeFace | Sets or returns font typeface of all text in control
Read_Only_State | Determines whether users may edit the content of the control
Value | Sets or returns content of control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cDbTextEdit

View event list in alphabetical order

Name | Description
Inherited Events from cDbTextEdit_
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from cTextEdit
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Fires whenever the value of the control is changed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText | Fires when maximum text size is exceeded
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Fired whenever a change in enabled state occurs
Inherited Events from DFBaseTextEdit
OnSelectionChanged | Fires when selection changes
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cDbTextEdit

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cDbTextEditDS_
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Items | Function | Checks the number of characters in the control (using CharCount) against the size of the column in the table.
Validate_Prompt | Function | (Obsolete)
Inherited Methods from cDbTextEdit_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Prompt | Procedure | Cancelled in this class
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Cancelled in this class
Inherited Methods from cTextEdit
Activate_Area | Procedure |
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DFBaseTextEdit
AppendText | Procedure | Appends text to end of text in control
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control
Beginning_of_Line | Procedure | Places the cursor at beginning of current line
CharCount | Function | Returns the number of characters in the control
ClearUndoBuffer | Procedure | Clears undo buffer
Delete_Data | Procedure | Deletes all data in control
End_of_Data | Procedure | Places the cursor at end of the text in control
End_of_Line | Procedure | Places the cursor at end of current line
FindText | Function | Searches for specified text in control
FirstCharInLinePos | Function | Returns position of first character in a line
FirstVisibleLine | Function | Returns number of first visible line
HideSelection | Procedure | Toggles selection highlighting on or off
LastErrorCode | Function | Returns error code for last operation
Line | Function | Returns specified line of text
LineFromChar | Function | Returns number of line that contains specified character position or current line
LineLength | Function | Returns number of characters in line
Read | Procedure | Reads text file and displays it in the control
Redo | Procedure | Redoes the last operation
RedoType | Function | Returns type of redo operation at top of redo queue
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements
ReplaceSel | Procedure | Replaces selected text with specified text
Scroll | Procedure | Scrolls up or down the control using specified scroll mode
ScrollCaret | Procedure | Scrolls caret into view
ScrollLines | Procedure | Scrolls control vertically for specified number of lines
Select_All | Procedure | Selects entire contents of control
SelEnd | Function | Returns end of selection
SelStart | Function | Returns beginning position of selection
SelText | Function | Returns selected text
SetSel | Procedure | Selects text in given position range
TextRange | Function | Returns text in given position range
Undo | Procedure | Undoes the last operation
UndoType | Function | Returns type of undo operation at top of undo queue
Write | Procedure | Writes text file content of control to file
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cDbTextEdit_

Class: cDbTextEdit_ (Abstract)

Properties Events Methods Index of Classes

Allows the user to enter and edit text connected to a column in a database table

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DFBaseTextEdit
---------------------cTextEdit
------------------------cDbTextEdit_
---------------------------cDbTextEditDS_

Library: Windows Application Class Library

Package: cDbTextEdit.pkg

Mixins: Text_Window_mixin Nesting_Mixin Navigate_Mixin Verify_Mixin Server_Mixin Action_Bar_Mixin Find_Edit_Mixin Non_Dependent_Item_Mixin DEO_Delegate_Mixin

Description

cDbTextEdit_ allows the user to enter and edit text connected to a column in a database table. Its sub-class cDbTextEdit should be used for sub-classing and instantiation.

Last Edited: November 24, 2004


Properties for cDbTextEdit_

View property list in alphabetical order

Name | Description
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Data_Field | The field number of the target text field
Data_File | The file number of target memo field
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Item_Count | Created for simulation of entry item
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from cTextEdit
Changed_State | Determines whether the content of the control has changed
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DFBaseTextEdit
Line_Count | Returns number of lines in control
paValue | Sets content of control from memory address or places text in control into memory address
pbBold | Toggles all text in control between bold and normal text
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard
pbCanRedo | Determines whether a redo operation can be performed
pbCanUndo | Determines whether an undo operation can be performed
pbItalics | Toggles all text in control between italic and normal text
pbWrap | Determines whether text input will break and wrap to the next line at right margin
piFontSize | Sets or returns font size of all text in control
piFontWeight | Sets or returns font weight of all text in control
piMaxChars | Sets or returns maximum number of visible characters
piRightMargin | Determines indentation of right side of control's text, relative to the right margin
psTypeFace | Sets or returns font typeface of all text in control
Read_Only_State | Determines whether users may edit the content of the control
Value | Sets or returns content of control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cDbTextEdit_

View event list in alphabetical order

Name | Description
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from cTextEdit
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Fires whenever the value of the control is changed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText | Fires when maximum text size is exceeded
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Fired whenever a change in enabled state occurs
Inherited Events from DFBaseTextEdit
OnSelectionChanged | Fires when selection changes
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cDbTextEdit_

View method list in alphabetical order

Name | Type | Description
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Prompt | Procedure | Cancelled in this class
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Returns 0 by default, to indicate that entered text is valid
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Cancelled in this class
Inherited Methods from cTextEdit
Activate_Area | Procedure |
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DFBaseTextEdit
AppendText | Procedure | Appends text to end of text in control
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control
Beginning_of_Line | Procedure | Places the cursor at beginning of current line
CharCount | Function | Returns the number of characters in the control
ClearUndoBuffer | Procedure | Clears undo buffer
Delete_Data | Procedure | Deletes all data in control
End_of_Data | Procedure | Places the cursor at end of the text in control
End_of_Line | Procedure | Places the cursor at end of current line
FindText | Function | Searches for specified text in control
FirstCharInLinePos | Function | Returns position of first character in a line
FirstVisibleLine | Function | Returns number of first visible line
HideSelection | Procedure | Toggles selection highlighting on or off
LastErrorCode | Function | Returns error code for last operation
Line | Function | Returns specified line of text
LineFromChar | Function | Returns number of line that contains specified character position or current line
LineLength | Function | Returns number of characters in line
Read | Procedure | Reads text file and displays it in the control
Redo | Procedure | Redoes the last operation
RedoType | Function | Returns type of redo operation at top of redo queue
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements
ReplaceSel | Procedure | Replaces selected text with specified text
Scroll | Procedure | Scrolls up or down the control using specified scroll mode
ScrollCaret | Procedure | Scrolls caret into view
ScrollLines | Procedure | Scrolls control vertically for specified number of lines
Select_All | Procedure | Selects entire contents of control
SelEnd | Function | Returns end of selection
SelStart | Function | Returns beginning position of selection
SelText | Function | Returns selected text
SetSel | Procedure | Selects text in given position range
TextRange | Function | Returns text in given position range
Undo | Procedure | Undoes the last operation
UndoType | Function | Returns type of undo operation at top of undo queue
Write | Procedure | Writes text file content of control to file
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cDbTextEditDS_

Class: cDbTextEditDS_ (Abstract)

Properties Events Methods Index of Classes

Allows the user to enter and edit text connected to a column in a database table

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DFBaseTextEdit
---------------------cTextEdit
------------------------cDbTextEdit_
---------------------------cDbTextEditDS_
------------------------------cDbTextEdit

Library: Windows Application Class Library

Package: cDbTextEdit.pkg

Mixins: DFNavigate_Mixin DFCode_DEO_Mixin DataFile_Help_Mixin

Description

cDbTextEditDS_ allows the user to enter and edit text connected to a column in a database table. Its sub-class cDbTextEdit should be used for sub-classing and instantiation.

Last Edited: November 24, 2004


Properties for cDbTextEditDS_

View property list in alphabetical order

Name | Description
Inherited Properties from cDbTextEdit_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Data_Field | The field number of the target text field
Data_File | The file number of target memo field
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Item_Count | Created for simulation of entry item
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from cTextEdit
Changed_State | Determines whether the content of the control has changed
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DFBaseTextEdit
Line_Count | Returns number of lines in control
paValue | Sets content of control from memory address or places text in control into memory address
pbBold | Toggles all text in control between bold and normal text
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard
pbCanRedo | Determines whether a redo operation can be performed
pbCanUndo | Determines whether an undo operation can be performed
pbItalics | Toggles all text in control between italic and normal text
pbWrap | Determines whether text input will break and wrap to the next line at right margin
piFontSize | Sets or returns font size of all text in control
piFontWeight | Sets or returns font weight of all text in control
piMaxChars | Sets or returns maximum number of visible characters
piRightMargin | Determines indentation of right side of control's text, relative to the right margin
psTypeFace | Sets or returns font typeface of all text in control
Read_Only_State | Determines whether users may edit the content of the control
Value | Sets or returns content of control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cDbTextEditDS_

View event list in alphabetical order

Name | Description
Inherited Events from cDbTextEdit_
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from cTextEdit
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Fires whenever the value of the control is changed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText | Fires when maximum text size is exceeded
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Fired whenever a change in enabled state occurs
Inherited Events from DFBaseTextEdit
OnSelectionChanged | Fires when selection changes
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cDbTextEditDS_

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Items | Function | Checks the number of characters in the control (using CharCount) against the size of the column in the table.
Validate_Prompt | Function | (Obsolete)
Inherited Methods from cDbTextEdit_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Prompt | Procedure | Cancelled in this class
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Cancelled in this class
Inherited Methods from cTextEdit
Activate_Area | Procedure |
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DFBaseTextEdit
AppendText | Procedure | Appends text to end of text in control
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control
Beginning_of_Line | Procedure | Places the cursor at beginning of current line
CharCount | Function | Returns the number of characters in the control
ClearUndoBuffer | Procedure | Clears undo buffer
Delete_Data | Procedure | Deletes all data in control
End_of_Data | Procedure | Places the cursor at end of the text in control
End_of_Line | Procedure | Places the cursor at end of current line
FindText | Function | Searches for specified text in control
FirstCharInLinePos | Function | Returns position of first character in a line
FirstVisibleLine | Function | Returns number of first visible line
HideSelection | Procedure | Toggles selection highlighting on or off
LastErrorCode | Function | Returns error code for last operation
Line | Function | Returns specified line of text
LineFromChar | Function | Returns number of line that contains specified character position or current line
LineLength | Function | Returns number of characters in line
Read | Procedure | Reads text file and displays it in the control
Redo | Procedure | Redoes the last operation
RedoType | Function | Returns type of redo operation at top of redo queue
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements
ReplaceSel | Procedure | Replaces selected text with specified text
Scroll | Procedure | Scrolls up or down the control using specified scroll mode
ScrollCaret | Procedure | Scrolls caret into view
ScrollLines | Procedure | Scrolls control vertically for specified number of lines
Select_All | Procedure | Selects entire contents of control
SelEnd | Function | Returns end of selection
SelStart | Function | Returns beginning position of selection
SelText | Function | Returns selected text
SetSel | Procedure | Selects text in given position range
TextRange | Function | Returns text in given position range
Undo | Procedure | Undoes the last operation
UndoType | Function | Returns type of undo operation at top of undo queue
Write | Procedure | Writes text file content of control to file
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cDesktop

Properties Events Methods Index of Classes

Used to create the desktop object which contains all other objects within an application

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------cDesktop

Library: Common (Windows and Web Application) Class Library

Package:

Description

A single desktop object is automatically created in every program. It is based on the cDesktop class. Objects that are not surrounded by other objects in a program are actually still child objects - they are children of the Desktop, and are also known as global objects.

The Desktop object is created for for you. You cannot create additional desktop objects and you cannot sub-class the cDesktop class. You can create additional methods and properties for the desktop object - this is described below.

The Desktop and Delegation

Messages received by an object that does not understand them are typically delegated to the receiving object's parent object. If the message is not understood by the parent object, the parent delegates the message until some ancestor object understands the message. If none does, it is ultimately delegated to the ultimate object, the Desktop. If the Desktop does not understand the message, an error is generated.

Sending Messages Directly to the Desktop Object

Messages can also be sent explicitly to the desktop by sending the message to the object named desktop

Get Focus of Desktop to iVar

Creating objects on the Desktop

An object can be added to the deskop using one of two methods. If you create an object using the Object and End_object command that is not placed inside of any object, this object is a child of the desktop You can also create an object for the desktop by sending the create messages directly to the desktop object

Get Create u_Array of Desktop to hoArray

Desktop and Global Functions/Procedures

Visual DataFlex allows you to create methods (functions and procedures) that reside on the desktop. It also allows you to create global function and procedures. While these may seem to do the same thing, they are quite different.

Global Functions and Procedures

A global function or procedure is global to your entire application and exists outside of the object-oriented model. Because it is global they are not messages and they are not sent to an object. They are part of the global structure. Global procedures and functions are not as flexible as object oriented methods.

A function or procedure is defined as global by using the keyword global within the declartion.

Function MyGlobalFoo Global integer i returns string

If a function or procedure is marked as being Global it is actually not a method at all. It is a function or procedure, which is accessed outside of any object considerations. A global function/procedure can be defined anywhere in an application and it can be defined one time only. Once a name is assigned to a global function or procedure that name can not be used for any other class and object methods. In other words object methods and global functions/procedures can not have the same name and will result in a compiler error.

Functions and Procedures defined at the Desktop

We recommend that global functions and procedures be used sparingly. In an object-based system, you should use methods, properties and events.

A desktop method is defined by using the keyword desktop within the message declaration.

Function MyDesktopFoo Desktop Integer i returns String

If the word Desktop immediately follows the method name, then this method becomes a method of the desktop object. The desktop object is the container object for all other objects in VDF. Desktop methods can be resolved either by sending the method directly to the Desktop or by delegation (assuming the objects within the desktop object all support delegation and the method is not understood by some other object).

// the method is resolved by sending directly to the desktop
get MyDesktopFoo of Desktop iVal to sString

// the method will be solved by delegating to the desktop
get MyDesktopFoo iVal to sString

Like the Global keyword, the Desktop keyword can be used anywhere to mark a method as a desktop method. Desktop methods are object-based methods. Therefore, you can use this name for a desktop method and use the same name for any other object or class you wish.

We also recommend that desktop methods be used sparingly. If your application contains many desktop methods or many global functions/procedures, you may wish to review your program structure. You may be creating code that is not properly encapsulated.

Compatibility Notes

The Desktop syntax was added to revision 8.3. Also note that this syntax is different than using the old "for Desktop", a syntax which is highly discouraged.

As of revision 8.3, we suggest that all methods that are coded at the desktop level (i.e. methods not contained within any other class or object) be explicitly marked as being GLOBAL or DESKTOP. All other syntaxes are considered either obsolete or not recommended. In particular, previous versions of Visual DataFlex allowed methods placed on the desktop to contain no special marking. We refer to this as an "ambiguous" desktop method:

// if this were on the desktop, it would be considered Ambiguous
Function MyDesktopFoo Integer i returns String

We now discourage the use of ambiguous desktop methods. In 8.3, all old syntaxes will be supported including ambiguous desktop methods. They will continue to work exactly as they did in all prior versions of Visual DataFlex. However, using ambiguous desktop methods is now strongly discouraged. In future revisions Visual DataFlex , ambiguous desktop methods will generate error messages. Therefore, we advise that you start changing your programs now. Also note that an ambigious method is neither global or desktop - it actually modifies the cObject class, an action that is strongly discouraged.

Last Edited: June 22, 2005


Properties for cDesktop

View property list in alphabetical order

Name | Description
Exit_System_Confirmation |
Main_Window |
Sentinel_Program |
Sentinel_Return_Value |
Sentinelwindow |
Start_Sentinel_Program |
Stop_Sentinel_Program |
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cDesktop

View event list in alphabetical order

Name | Description
OnSentinelDataChange |
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cDesktop

View method list in alphabetical order

Name | Type | Description
ComActiveObject | Function | Returns Variant containing an IUnknown* to an active COM object matching the passed program ID
ComLoadPicture | Function |
CreateSQLmanager | Function |
Exit_Application | Procedure |
Help | Procedure |
HostData | Function |
Network_User_Name | Function |
SentinelData | Function |
SentinelData | Procedure Set |
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cDFBtrDrvHandler

Properties Events Methods Index of Classes

Hierarchy

cObject
---Array
------cDFBtrDrvHandler

Library: Common (Windows and Web Application) Class Library

Package: DFBTRDRV.PKG

Description

Last Edited: May 5, 2006


Properties for cDFBtrDrvHandler

View property list in alphabetical order

Name | Description
psDriverID |
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cDFBtrDrvHandler

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cDFBtrDrvHandler

View method list in alphabetical order

Name | Type | Description
CKBuildRevision | Function |
CKMajorRevision | Function |
CKMinorRevision | Function |
CKReleaseRevision | Function |
CKRevision | Function |
CkUsesUri | Function |
ExtractPartFromRevision | Function |
IsMinimalRevision | Function |
PSQLLocalEngineVersionInfo | Function |
PSQLRequesterVersionInfo | Function |
PSQLServerEngineVersionInfo | Function |
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cDistributedBusinessProcess

Class: cDistributedBusinessProcess (Abstract)

Properties Events Methods Index of Classes

Abstract class used to create Web Browser Process objects

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cDistributedBusinessProcess
------cRemoteEntryProcess

Library: Web Application Class Library

Package: cDistributedBusinessProcess.pkg

Description

cDistributedBusinessProcess is an abstract class used for creating Web Browser Process objects. Its sub-class cWebBusinessProcess should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for cDistributedBusinessProcess

View property list in alphabetical order

Name | Description
Main_dd | Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function
pbClearDDOsOnDetach |
pbShowEntryError |
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cDistributedBusinessProcess

View event list in alphabetical order

Name | Description
OnAttachProcess | When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object
OnDetachProcess | When process pooling is used, this event is sent first to the WebApp object and then to every WBO object
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cDistributedBusinessProcess

View method list in alphabetical order

Name | Type | Description
ClearErrors | Procedure | Clears the error queue
ErrorCount | Function | Returns the number of errors in the current error queue
ErrorQueueEnd | Procedure | Ends an error queue process
ErrorQueueStart | Procedure | Starts an error queue process
LogEvent | Procedure | Logs an event to the Web Application's event log
MapFileNametoDD | Function |
MaptoFieldNumber | Function |
MaptoFileNumber | Function |
ReportAllErrors | Procedure | Generates a list of all errors that have occurred since this error queue was last cleared
ReportErrorItem | Procedure | Displays the error for iItem in the error queue
ReportLastError | Procedure | Displays the last error in the error queue
RequestFileFieldValues | Procedure |
RequestFileRecords | Procedure |
Search_Field_Name | Function |
Search_File_Name | Function |
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cFTPTransfer

Properties Events Methods Index of Classes

Implements FTP client-side operations

Hierarchy

cObject
---InetTransfer
------cFTPTransfer

Library: Common (Windows and Web Application) Class Library

Package:

Description

The cFtpTransfer class implements FTP client-side operations.

To communicate with an Internet/intranet FTP server, you must first create an object of this class, and then set the psRemoteHost property to the fully qualified domain name, or the IP address, of the FTP server. If your network requires traffic to go through a proxy server, you should also set the psProxy property to the protocol for the proxy server, and the fully qualified domain name or IP address of that proxy server. Unless the remote FTP server listens to port 21 (default), you also have to set the piRemotePort property to the specified port number. Then just call the Connect function to connect to the FTP server.

Last Edited: November 21, 2004


Properties for cFTPTransfer

View property list in alphabetical order

Name | Description
Connectionhandle | Returns the HINTERNET handle associated with the current established the connection
pbPassiveMode | Specifies whether to connect to the FTP server RemoteHost using passive mode
peTransferType | Specifies whether the file should be transferred as ASCII or Binary
Inherited Properties from InetTransfer
LastErrorCode | Returns the last error code from the HTTP / FTP Transfer
peTransferFlags | Various flags that control how file/data should be transferred
piBufferSize | Specifies the size of the file transfer buffer
piRemotePort | Specifies the port to connect to on RemoteHost
psAgent | Specifies the name of the application
psPassword | Specifies the password to use to log on
psProxy | Specifies the name of the Proxy server used, if any
psRemoteHost | Specifies the hostname or the IP address of the remote server
psUserName | Specifies the name of the user to log on
RootHandle | Returns the root HINTERNET handle used for the session
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cFTPTransfer

View event list in alphabetical order

Name | Description
OnDirectoryList | Triggered by the DirectoryList procedure for every file/directory found matching the given search pattern
OnTransferStatus | Triggered several times during a file transfer, every time a chunk of BufferSize bytes has been transferred
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cFTPTransfer

View method list in alphabetical order

Name | Type | Description
CancelTransfer | Procedure | Aborts the current file transfer operation
ChangeDirectory | Function | Changes the current working directory on RemoteHost to sNewDir
Connect | Function | Establishes an FTP connection with RemoteHost
CreateFTPdirectory | Function | Creates the directory sNewDir on RemoteHost
CurrentDirectory | Function | Returns the current working directory on RemoteHost
DeleteFTPFile | Function | Deletes the file sName on RemoteHost
Directorylist | Procedure | Performs a directory list on the remote host, and triggers the OnDirectoryList event for every file/directory found matching the pattern sPattern
Disconnect | Function | Disconnects an established FTP connection with RemoteHost
DownloadFile | Function | Downloads the file sRemoteFile from RemoteHost and saves it locally as sLocalFile
EndFTPFileFind | Procedure |
FileAttributes | Function | Returns the file attributes of the file sFilename on RemoteHost
FileSize | Function | Returns the size of the file sFilename on RemoteHost in bytes
FindFirstFTPFile | Function |
FindNextFTPFile | Function |
FTPFileExist | Function | Returns true if sFile exist on the remote host, and false otherwise
RemoveFTPdirectory | Function | Removes the directory sDirectory on RemoteHost
RenameFTPFile | Function | Renames the file sExistingName on RemoteHost to sNewName
UploadFile | Function | Uploads the file sLocalFile to RemoteHost and stores it using the filename sRemoteFile
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: CheckBox

Properties Events Methods Index of Classes

To enable users to select items (or options) in applications

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseButton
------------------------DfBaseCheckbox
---------------------------CheckBox

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Select_Mixin Bitmap_Support_Mixin Standard_Object_Mixin Single_Item_Navigate_Mixin Select_Mixin RGB_Support_Temp_Mixin Help_Mixin Shadow_Mixin

Description

The CheckBox class is used to select items (or options) in applications. A CheckBox appears as a square box with text (usually located to the right of the check box). The checked_state of the check box may be toggled on or off by placing the cursor on it and pressing a key or clicking it with the mouse or by directly setting this property. The appearance of the box indicates at all times whether it is selected.

The dbCheckBox class is a data-aware class similar to the CheckBox class.

Sample

Object check1 is a CheckBox
    Set Location to 10 5
    Set Label "Show All Detail"
    Set Checked_State to true
End_Object

Function Show_detail returns integer
    integer State
    Get checked_State of check1 to State
    Function_return State
End_Function

Object FileName_Form is a Form
    Set location to 25 65
    Size size to 13 100
    Set Label to "File name:"
End_Object

Object check2 is a CheckBox
    Set Location to 40 5
    Set Label "Print to File"
    Set Checked_State to true

    // Shadow file name form is print to file is false
    Procedure onChange
        integer state
        Get checked_state to State
        Set enabled_state of FileName_Form to State
    End_Procedure
End_Object

Syntax

Use windows

Object object_name is a CheckBox
    Set Location to row column
    Set Label to text
    Set Checked_State to true|false
    Set enabled_state to true|false
    Set Status_Help to text

     Procedure onChange
        :
    End_Procedure

    Procedure onSetFocus
        :
    End_Procedure

    Procedure onKillFocus
        :
    End_Procedure
End_Object

Of Special Note

This class is a subclass of the DfBaseCheckbox class and therefore inherits all its properties and capabilities. It has been extended to support help, status-help display, object shadowing, and label display. It is expected that you will use this class for your simple non-database checkbox entry needs. Data-aware check boxes are supported in the dbCheckBox class.

There will be one single item (Item 0) per object of this class.

The Checked State of a Checkbox

The state of this object may be set and retrieved (get) with the checked_state property. This message actually uses the internal property select_state (for Item 0). When this object has the focus, users can toggle the checked_state property by pressing the spacebar or by clicking the mouse button. Any time the checkbox state is changed, the event message onChange is sent. Also, if users enter any change to the displayed text, the item_changed_state (of Item 0) and the changed_state of the object are set true.

Shadowing

Shadowing refers to the process of making an object or an item unavailable for data entry. Usually the appearance of a shadowed object is changed in some way to indicate its unavailability. This class supports object shadowing. Accordingly, objects of this class will be shadowed whenever an ancestor object is shadowed or when the object's enabled_state property is set false.

Labels

The label of this object refers to the text that will appear the right of this object. If you wish to show text to the left (similar to labels found on forms), you will need to create a separate TextBox for the text and leave the label of this object blank.

Auto-Sizing

The size of this object is determined automatically based on the size of its label text. This auto-sizing may be disabled by setting the auto_size_state property to false.

Last Edited: December 2, 2005


Properties for CheckBox

View property list in alphabetical order

Name | Description
AlignmentMode | Determines if the Label property will be displayed on the left or right of the checkbox icon
Auto_Size_State | Determines if object will be resized to the length of the label text
Bitmap | Displays a bitmap in an object
Checked_State | Reflects whether this object is checked
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label |
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for CheckBox

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange |
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for CheckBox

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cHtmlHelp

Properties Events Methods Index of Classes

Used to provide access to an HTML-based help system

Hierarchy

cObject
---cHtmlHelp

Library: Common (Windows and Web Application) Class Library

Package: cHtmlHelp.pkg

Description

The cHtmlHelp class provides support for an application to access an HTML help file. An application can be designed to use HTML help or Windows Help. It is expected that you will want to use HTML help in your applications.

Creating Help in Your Application

Help support is standard part of the framework classes. To use help in an application you need to do three things:

1. Use the package Std_help.pkg. This creates global HTML and windows help objects that will be used by the application.

Use Std_Help.pkg

2. Set two properties in your application to determine the help type (HTML or windows) and the help file name. This is done by setting two properties in the cApplication object - psHelpFile peHelpType.

Object oApplication is a cApplication
    Set psCompany to "Data Access Worldwide"
    Set psProduct to "Visual DataFlex 9 Examples"
    Set psVersion to "9.1"
    Set psProgram to "Order"

    Set psHelpFile to "OrderEntry.chm"
    Set peHelpType to htHtmlHelp

    Procedure OnCreate
        Send DoOpenWorkspace CURRENT$WORKSPACE
    End_Procedure

End_Object    // oApplication

3. Assign help context to your objects. You can assign either a help context id (help_id) or a help context keyword (help_keyword). Normally, you will want to use help context Ids. You do not need to assign a help id for each object. If an object does not have a help id (or context keyword) assigned it will delegate to its parent object and attempt to find help context at this level. This process continues until a help id is found or the desktop is encountered. This lets you choose the specificity of your help context ranging from unique help context for every object (unlikely) to no help context at all. If no help context is provided the help system's table of contents is invoked. Often, you will find that you want to provide help at the view or panel level.

Once an object has the appropriate help context it will send the appropriate help message to the HTML help object passing along the context as required. That message will be either DoShowMapId (for context ids), DoDisplayKeyword (for keyword context) or DoDisplayTOC (if no context exists). The help object, will then invoke your help system.

Set Help_Id to CustomerViewHelpId // assume this constant was defined and represents a numeric ID

Accessing the Help Object

When the HTML help object is created, its object handle is assigned to the global variable ghoHtmlHelp. You can use this handle to determine if an HTML help object exists and to send messages to it. Because help is a part of the framework, you will rarely set properties in this object, and rarely send messages to the help object. However, if you do need to send a message to your HTML help object you may do so.

Send DoDisplayTOC of ghoHtmlHelp   // display table of contents

Help and the Application Object

You are strongly encouraged to use the cApplication object to define your help type and help file. An interface is provided in the cHtmlHelp class that sets the help filename (psHelpFile). You should avoid using this property and use the one in the cApplication object.

If you are not using an application object, you must make sure that you manually set the help property phoOwner to the object id of your main application panel. When you use an application object, this property is set for you automatically.

Note:Never invoke help if your main application panel is not yet active. The help system needs to use the window handle of the object as its parent handle.

Note:The HelpSystem class is also part of the framework and is used to provide windows help. Using windows help is considered to be obsolete. You are encouraged to build an HTML based help system.

Last Edited: August 10, 2006


Properties for cHtmlHelp

View property list in alphabetical order

Name | Description
pbAlwaysOnTop | Determines whether the help file is always on top of the application
phoOwner | Owner of the Help file
psHelpFile | Name of the compiled HTML (CHM) helpfile to display
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cHtmlHelp

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cHtmlHelp

View method list in alphabetical order

Name | Type | Description
DoDisplayIndex | Procedure | Selects the Index tab of the helpfile
DoDisplayIndexString | Procedure | Selects a keyword in the Index
DoDisplayKeyword | Procedure | Selects a keyword in the Index and displays the related Topic
DoDisplayTOC | Procedure | Displays the Table of Contents
DoDisplayTopic | Procedure | Displays a Topic
DoShowMapId | Procedure | Displays a Topic based upon its Map-ID
DoSyncToc | Procedure | Synchronizes the Table of Contents
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cHtmlReport

Class: cHtmlReport (Abstract)

Properties Events Methods Index of Classes

Abstract class that creates HTML reports

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cReport
------cReportDS
---------cBasicReport
------------cHtmlReport
---------------cWebReport

Library: Web Application Class Library

Package: cHtmlreport.pkg

Mixins: HtmlFormat_Mixin HtmlWrite_Mixin

Description

The cHtmlReport class is used to create HTML reports.This abstract class and used by the sub-classes cWebReport and cWmlReport to generate WebApp Report. This class takes the basic reporting capabilities of cBasicReport and adds a layer of interface support for generating HTML marked up reports.

Last Edited: November 21, 2004


Properties for cHtmlReport

View property list in alphabetical order

Name | Description
piConstrainFile | Used when creating reports to limit the printing to a single parent record and the related children
piConstrainRecord | (Obsolete) Used when creating reports to limit the printing to a single parent record and the related children
priConstrainRowId | Used when creating reports to limit the printing to a single parent record and the related children
Inherited Properties from cBasicReport
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button
Display_Error_State |
Output_Device | Handles the name of the output device
Report_Caption | Contains the text that will appear in the status panel's caption bar
Report_Message | An additional message area that will appear below the report_title in the status panel
Report_Status_Panel |
Report_Title | A centered title that appears in the status panel
Status_Log_Id | Object ID of status-log object
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs
Inherited Properties from cReportDS
Server | Identifies the object handle that is used as the report object's main data-dictionary object
Inherited Properties from cReport
Assigned_Channel |
Find_Mode | Maintains the current finding mode
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function
Last_Rec | (Obsolete) Contains the record number of the last selected record found
Main_File | Contains the filenumber of the file which the report will use for finding records
New_Page_State | Set true when a new page is needed
No_Constrained_Find_State | Determines if constrained record finding should be disabled
No_Finding_State | Determines how the cReport object will find records
No_PageCheck_State | Set true when the cReport object is processing a new page
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found
Page_Count | Keeps track of the current page number
Page_End | Determines how many lines on a page are allowed before a page break will occur
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence
Page_Feed | Used by the formfeed procedure
Page_Footer_Lines | The number of lines in the page_footer image
pbCanceled | Setting this true will cancel a report
pbChildReport | Set true if the current cReport object is nested
pbFindDown | Determines if the report should traverse up or down the index
pbHasChildReports | Is set true if other reports are nested inside this report object
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level
phMainReport | Contains the object ID of the outer report
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found
piNumberBreaks | Returns the number of breaks in a report
piOrdering | Contains the index number which will be used for finding records
piRecordCount | Contains the number of records found for the current report
priCurrentRec | Contains the RowId of the current valid record found
priFoundRec | Contains the RowId of the record found by the find_rec function
priLastRec | Contains the RowId of the last selected record found
Report_Channel | Determines which output channel will be used for your report output
Report_Footer_Lines | The number of lines in the OnReportFooter image
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cHtmlReport

View event list in alphabetical order

Name | Description
Inherited Events from cBasicReport
Error_Report | Sent whenever an error is generated
OnEndingMainReport | User Handler Intended for override
onError | Provided as a hook to handle custom error reporting
OnStartingMainReport | Called when a report is started
Report_Interrupt | Called when the status panel's Cancel button has been pressed
Inherited Events from cReport
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property
Final_Formfeed |
OnBody | Called every time a valid record has been found
OnConstrain |
OnEndingReport | Called at the end of all reports
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables
OnPageFooter | Printed after OnPageTotal on every page except the last page
OnPageHeader | Called after OnPageTop on every new page except the first
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader.
OnPageTop | Called when printing the top of every report
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page
OnReportFooter | Printed after OnPageTotal on the last page of the report
OnReportHeader | Called only on the first page of the report, after OnPageTop
OnSelection | Validates a record
OnStartingReport | Called when a report is started
OnSubHeader1..n | Called each time a subheader needs to be printed
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program
OnSubTotal1..n | Called when a subtotal needs to be processed
OnTotal | Called at the end of a report after all final sub-totals have been printed
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cHtmlReport

View method list in alphabetical order

Name | Type | Description
AddSubTotal | Procedure | Adds the passed value to the total maintained in level iCount
ClearAllSubTotals | Procedure | Clears all the SubTotal accumulators
ClearSubTotal | Procedure | Clears a single Subtotal accumulator
HtmlAnchor | Function | Adds an Html Anchor
HtmlBig | Function | Makes the string big
HtmlBlink | Function | Makes the string blink
HtmlBold | Function | Makes the string bold
HtmlEmph | Function | Makes the string emphasized
HtmlFixed | Function | Makes the string fixed width
HtmlFontcolor | Function | Sets the strings font color
HtmlFontsize | Function | Sets the font size
HtmlHeader | Function | Creates a header string of level iHeader
HtmlItalics | Function | Makes the string italics
HtmlLink | Function | Adds a hyperlink to a string
HtmlSmall | Function | Makes the string small
HtmlStrike | Function | Overstrikes through the string
HtmlStrong | Function | Adds strong emphasis to the string
HtmlSub | Function | Makes the string subscript
HtmlSup | Function | Makes the string superscript
SubTotal | Function | Returns the appropriate subtotal and clears the subtotal accumulator
SumSubTotal | Function | Returns the appropriate subtotal but does not clear the subtotal accumulator
WriteHtml | Procedure | Outputs the passed string to the web page and ends the line
WriteHtmlBreak | Procedure | Outputs the passed string and ends the line
WriteHtmlCell | Procedure | Outputs a table cell containing sData
WriteHtmlCellHeader | Procedure | Outputs a table header cell containing sData
WriteHtmlHorzLine | Procedure | Outputs a horizontal line to the HTML file
WriteHtmlRowBegin | Procedure | Outputs a "begin" row HTML string
WriteHtmlRowEnd | Procedure | Outputs an end row html string
WriteHtmlTableBegin | Procedure | Outputs a "begin" table html string
WriteHtmlTableEnd | Procedure | Outputs an end table html string
WriteLn | Procedure | Outputs the string and ends the Line
Inherited Methods from cBasicReport
End_Log | Procedure | Sends an end-log message to the log object
Error_Log_Status | Procedure | Called by error_report if status_log_state is true
Log_Status | Procedure | Sends passed message to the log object
Start_Log | Procedure | Sends a start-log message to the log object
Update_Status | Procedure | Send this message to update the action area of the status panel
Inherited Methods from cReportDS
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO
Request_Save | Procedure | If sent, this saves the current record
Inherited Methods from cReport
DoRunReport | Function | The main entry point for reportsT
Formfeed | Procedure | Handles formfeeds
Output_ImageNum | Procedure | Outputs the image represented by ImageNum
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cHttpTransfer

Properties Events Methods Index of Classes

Implements HTTP client-side operations

Hierarchy

cObject
---InetTransfer
------cBaseHTTPTransfer
---------cHttpTransfer
------------cXmlHttpTransfer

Library: Common (Windows and Web Application) Class Library

Package: cHttpTransfer.pkg

Description

The cHttpTransfer class implements HTTP client-side operations.

To communicate with an Internet/intranet HTTP server, you must first create an object of this class, and then set the psRemoteHost property to the fully qualified domain name, or the IP address, of the HTTP server. If your network requires traffic to go through a proxy server, you should also set the psProxy property to the protocol for the proxy server, and the fully qualified domain name or IP address of that proxy server. Unless the remote HTTP server listens to port rpHttp (80 - the default), you also have to set the piRemotePort property to the specified port number.

User name and Password

If your Http site requires that you login, you may provide a username and password using the psUserName and psPassWord properties. Alternately, you can set the pbShowErrorDialog to True, which will cause a login dialog to popup when needed.

HTTPS - Secure SSL sites

This class can be used to access secure sites. A secure HTTPS site is usually accessed over a different port - rpHttpSSL (443), which you should set using piRemotePort. In addition, a secure site will require that you add the ifSecure to your transfer flags, which you set using peTransferFlags.

// properties to set to access an HTTPS site
Set piRemotePort to rpHttpSSL
Set peTransferFlags to ifSecure

In some cases, your secure site may require that you proivde a client certificate. The certificate may be selected using the SelectClientCertificate message. It may also be selected by the user by setting pbShowErrorDialog property to true. In both, cases a client certificate must be installed on your client computer.

Last Edited: November 21, 2004


Properties for cHttpTransfer

View property list in alphabetical order

Name | Description
Inherited Properties from cBaseHTTPTransfer
pbShowErrorDialog | Determines if a popup dialog will appear when a client certificate or usename/password is needed for an Http Request
psAcceptTypes | Specifies the HTTP content types accepted by the client
psProtocolVersion | Specifies the HTTP protocol version
psSaveasFile | Saves response from the remote host to the specified file instead of triggering the OnDataReceived event
Inherited Properties from InetTransfer
LastErrorCode | Returns the last error code from the HTTP / FTP Transfer
peTransferFlags | Various flags that control how file/data should be transferred
piBufferSize | Specifies the size of the file transfer buffer
piRemotePort | Specifies the port to connect to on RemoteHost
psAgent | Specifies the name of the application
psPassword | Specifies the password to use to log on
psProxy | Specifies the name of the Proxy server used, if any
psRemoteHost | Specifies the hostname or the IP address of the remote server
psUserName | Specifies the name of the user to log on
RootHandle | Returns the root HINTERNET handle used for the session
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cHttpTransfer

View event list in alphabetical order

Name | Description
Inherited Events from cBaseHTTPTransfer
OnDataReceived | Is triggered several times during a GetRequest, PostRequest and PutRequest when data arrives from RemoteHost
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cHttpTransfer

View method list in alphabetical order

Name | Type | Description
HttpPostRequest | Function | Performs an HTTP POST request using sFilePath
HttpPutRequest | Function | Performs an HTTP PUT request using sFilePath
Inherited Methods from cBaseHTTPTransfer
AddHeader | Function | Adds the HTTP header named sHeaderName with the value sHeaderValue to the HTTP headers
ClearHeaders | Procedure | Clears all HTTP headers added using AddHeader
HTTPGetRequest | Function | Performs an HTTP GET request using sFilePath
HTTPPostAddrRequest | Function | Performs an HTTP POST request
HTTPputAddrRequest | Function | Performs an HTTP PUT request using sFilePath
ResponseHeader | Function | Returns the value for a named http response header
ResponseStatusCode | Function | Returns the response http status code
SelectClientCertificate | Function | Selects a client certificate to be used in an Http request
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cImageList

Properties Events Methods Index of Classes

A collection of images of the same size, each of which can be referred to by its index

Hierarchy

cObject
---cImageList

Library: Common (Windows and Web Application) Class Library

Package: cImageList.pkg

Description

An imagelist is a collection of images of the same size, each of which can be referred to by its index. Imagelists are used to efficiently manage large sets of images, which can then be shared by multiple objects requiring images to be displayed.

A single imagelist object can provide images to the TreeView, cToolbar and TabDialog classes.

A transparent color can be set for each image added into the imagelist. This allows the same image to be used seamlessly in a TreeView with a white background and a TabPage with a gray background.

You add images during the OnCreate event. Two functions are provided to add images: AddTransparentImage, to add transparent images, and AddImage to add non-transparent images. You need to declare how many images will be in the imagelist. You do this with the piMaxImages property. You also need to set the width and height of each image, and you do this with the piImageWidth and piImageHeight properties. When you add an image into the imagelist, the number of images actually added will be automatically inferred by dividing the width of the image you add by the size of the piImageWidth property.

Example

The following sample creates an imagelist with three images, with the default size of 16 by 16 pixels.

Object oImages is a cImageList
    Set piMaxImages To 5
    Procedure OnCreate
        Get AddTransparentImage "Cut.bmp" clFuchsia To giCutIndex
        Get AddTransparentImage "Copy.bmp" clFuchsia To giCopyIndex
        Get AddTransparentImage "Paste.bmp" clFuchsia To giPasteIndex
    End_Procedure
End_Object

Note that the index of each image is stored in a global variable that is not declared in this sample. The returned indexes could be used in the TreeView or TabDialog, etc.

Compatibility Note

The cImageList class supersedes the ImageList class shipped with Visual DataFlex prior to version 7.0, which you should no longer use.

Last Edited: December 20, 2005


Properties for cImageList

View property list in alphabetical order

Name | Description
phImageList | Contains the handle that Windows uses to communicate with the imagelist
piBackColor | Sets the background color of the images
piImageHeight | Specifies the height, in pixels, of each imag
piImageWidth | Specifies the width, in pixels, of each image
piMaxImages | Determines the maximum number of images that will be held in the imagelist
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cImageList

View event list in alphabetical order

Name | Description
OnCreate | Called when the imagelist is ready to accept images to be added
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cImageList

View method list in alphabetical order

Name | Type | Description
AddImage | Function | Adds images into the imagelist during the OnCreate event
AddTransparentImage | Function | Adds transparent images into the imagelist during the OnCreate event
ImageCount | Function | Returns the number of images in the imagelist
RemoveAllImages | Procedure | Removes all the images in the Imagelist
RemoveImage | Procedure | Removes an image from the imagelist
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cIniFile

Properties Events Methods Index of Classes

Provides access to Windows INI (configuration) files

Hierarchy

cObject
---cIniFile

Library: Common (Windows and Web Application) Class Library

Package: cIniFile.pkg

Description

An INI file is a text file that stores data in logical groups called sections. Each section can contain mulitple keys. Each key stores a single value. Section names must be unique within the file and Key names must be unique within each Section.

INI files are convenient for storing application data, as an alternative to the system Registry, because they are physical files that can easily be copied. An example of an INI file would be a "Workspace file" that Visual DataFlex uses to store information about a Workspace. Unlike the Registry, though, data does not have a data-type associated with it, and all data is assumed to be of type String.

Prior to writing or reading data in an INI file, set its psFileName property. To write data, use the WriteString method and to read data, use the ReadString. If you write to a file that doesn't exist, it will be created. Before reading from an INI file, you should check that the Section/Key exists. To verify the existence of a Section, use SectionExists and for a Key, use KeyExists.

The ReadSections method is used to discover the names of all existing Sections. To discover the names of all Keys within a Section, use ReadSection.

To delete a Section, use DeleteSection, which will remove the Section and all Keys. To delete a Key, use DeleteKey.

Note:It is customary for INI files to have an ".ini" file extension, but this is not a requirement.

Sample

In this sample, the date is written to a Key called "Date" in Section called "Last Accessed" in an INI file called "Preferences.ini" that we want placed in the first path of the Workspace's DataPath.

Function PrimaryDataPath Returns String
    // Returns the first directory of the Workspace's DataPath
    String sDataPath sPrimaryDataPath

    Get psProgramPath of (phoWorkspace(ghoApplication)) To sDataPath
    Get PathAtIndex of (phoWorkspace(ghoApplication)) sDataPath 1 To sPrimaryDataPath

    Function_Return sPrimaryDataPath
End_Function

Object oPreferences is a cIniFile
    Set psFileName To (PrimaryDataPath(self) +"\Preferences.ini")
    Send WriteString "Last Accessed" "Date" (CurrentDateTime())
End_Object

In this sample, the date is retrieved and displayed in a message box.

Object oPreferences is a cIniFile
    Procedure DoDisplayLastAccessed
        Boolean bAccessed
        String sDate

        Set psFileName To (PrimaryDataPath(self) +"\Preferences.ini")
        Get KeyExists "Last Accessed" "Date"To bAccessed
        If bAccessed Begin
            Get ReadString "Last Accessed" "Date" "" To sDate
            Send Info_Box ("Last access was: " + sDate)
        End
        Else Send Info_Box "You have not accessed the program before"
    End_Procedure
End_Object

See Also

cRegistry | Info_Box

Last Edited: October 26, 2006


Properties for cIniFile

View property list in alphabetical order

Name | Description
psFileName | The filename of the INI file
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cIniFile

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cIniFile

View method list in alphabetical order

Name | Type | Description
DeleteKey | Procedure | Deletes a Key from a Section of an INI file
DeleteSection | Procedure | Deletes an entire Section from an INI file
KeyExists | Function | Determines whether a Key exists in a Section of an INI file
ReadSection | Procedure | Obtains a list of Key names with an INI file Section
ReadSections | Procedure | Obtains a list of Sections names within an INI file
ReadString | Function | Reads a string from an INI file
SectionExists | Function | Indicates whether a Section exists in an INI file
WriteString | Procedure | Writes a string value into an INI file
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cInternetSessionBusinessProcess

Class: cInternetSessionBusinessProcess (Abstract)

Properties Events Methods Index of Classes

Abstract class used to create Web Browser Process objects

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cDistributedBusinessProcess
------cRemoteEntryProcess
---------cInternetSessionBusinessProcess
------------cWebBusinessProcess

Library: Web Application Class Library

Package: cInternetSessionBusinessProcess.pkg

Mixins: cCallInterfaceHelper_mixin

Description

cInternetSessionBusinessProcess is an abstract class used for creating Web Browser Process objects. Its sub-class cWebBusinessProcess should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for cInternetSessionBusinessProcess

View property list in alphabetical order

Name | Description
pbAllErrorstoEventLog | Determines if errors will be placed in the event log
pbAllErrorsToHtml | Determines if non-queued errors are sent
pbAllErrorstoLocal | Determines if errors are directed to the standard VDF error handler
pbQueueErrors | Determines where errors are placed
pbUseOpenEvalInterface | Determines if the Call interface should allow access to all WBO messages
pbVerboseErrors | Determines how much information is presented when an HTML error is displayed
psDescription | Adds a description to the WBO object
Inherited Properties from cRemoteEntryProcess
pbAllowClear | Determines whether the WBO object will support the Clear operation
pbAllowDDUpdate | Determines whether the WBO object will support update operations to the DataDictionary
pbAllowDelete | Determines whether the WBO object will support the Delete operation
pbAllowFind | Determines whether the WBO object will support the Find operation
pbAllowSaveEdit | Determines whether the WBO object will support an edit Save operation
pbAllowSaveNew | Determines whether the WBO object will support a new Save operation
pbClearAfterSave | Determines what should happen after a successful save
pbReportErrors | Suppresses the automatic generation of errors when set false
peFieldMultiUser | Determines if the data submitted by a web application browser should report changes at the field level
phREO_MainDD |
piREO_OperationStatus |
Inherited Properties from cDistributedBusinessProcess
Main_dd | Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function
pbClearDDOsOnDetach |
pbShowEntryError |
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cInternetSessionBusinessProcess

View event list in alphabetical order

Name | Description
Inherited Events from cRemoteEntryProcess
OnReportClearStatus | After a clear operation, augments point to handle whatever additional processing is required
OnReportDeleteStatus | After a delete operation, augmentats point to handle whatever additional processing is required
OnReportFindStatus | After a find operation, augments point to handle whatever additional processing is required
OnReportSaveStatus | After a save operation, augments point to handle whatever additional processing is required
OnReportValidateStatus | After an update operation, augments point to handle whatever additional processing is required
Inherited Events from cDistributedBusinessProcess
OnAttachProcess | When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object
OnDetachProcess | When process pooling is used, this event is sent first to the WebApp object and then to every WBO object
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cInternetSessionBusinessProcess

View method list in alphabetical order

Name | Type | Description
ClearErrors | Procedure | Clears the error queue
Cookie | Function |
Cookie | Procedure Set |
CookieAttribute | Procedure Set |
DDCurrentValue | Function |
DDHndValue | Function | Called within an ASP file by using the DDValue message
DDValue | Function | Returns the value of a file.field from the DataDictionary in a specified form
DDValueEncode | Function | Returns the value of a file.field from the DataDictionary in HTMLEncoded form
DoGetHtmlFormValue | Function | Obtains the value of any posted HTML form value
DoGetHtmlQueryString | Function | Obtains the value of any ASP variables
ErrorCount | Function | Returns the number of errors in the current error queue
ErrorMessage | Function | Returns an HTML formatted error message for item iItem in the error queue
ErrorQueueEnd | Procedure | Ends an error queue process
ErrorQueueStart | Procedure | Starts an error queue process
FileFieldErrorItem | Function | Checks the error queue for an error associated with the passed file and field
isFieldChanged | Function |
LogErrorEvent | Procedure | Logs an error event
LogEvent | Procedure | Logs an event to the Web Application's event log
RegisterInterface | Procedure | Registers a message (property, function, procedure) and make it available as a Call message within an ASP page
RegisterStandardInterface | Procedure |
RemoveInterface | Procedure | When sent, removes any message from the Call interface
ReportAllErrors | Procedure | Generates a list of all errors that have occurred since this error queue was last cleared
ReportErrorItem | Procedure | Displays the error for iItem in the error queue
ReportLastError | Procedure | Displays the last error in the error queue
Search_Field_Name | Function |
Search_File_Name | Function |
ServerVariable | Function |
SetChangedFields | Procedure |
SetDDCurrentValue | Procedure |
SetDDHndValue | Procedure |
SetDDValue | Procedure | Directly sets the value of a file.field in the DataDictionary buffer
Inherited Methods from cRemoteEntryProcess
ClearConfirmation | Function |
DeleteConfirmation | Function |
DoRequestClear | Function | Generates a remote clear process
DoRequestDDUpdate | Function | Provides another way to build the WBO's data dictionary structure based on information passed from the browser
DoRequestDelete | Function | Generates a remote delete process
DoRequestFind | Function | Performs a field find for the passed file name, field name and find mode
DoRequestSave | Function | Generates a remote save process
SaveConfirmation | Function |
Inherited Methods from cDistributedBusinessProcess
MapFileNametoDD | Function |
MaptoFieldNumber | Function |
MaptoFileNumber | Function |
RequestFileFieldValues | Procedure |
RequestFileRecords | Procedure |
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ClientArea

Properties Events Methods Index of Classes

Provides an area on the screen to contain all of an application's views

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasemdiclient
------------------------MdiClientArea
---------------------------AppClientArea
------------------------------ClientArea

Library: Windows Application Class Library

Package: Dfpanel.pkg

Description

ClientArea is used to provide an area on the screen to contain all of an application's views. The container is placed within a the program's main panel object (based on Panel class) and contains child views (View, dbView, ReportView).

Sample

Object oMain is an Panel
    :
    Object oClientArea is a ClientArea
        : Add MDI view objects
    End_Object
    :
End_Object

Syntax

Object object_name is a ClientArea
    :
    : Add view objects
    :
End_object

Of Special Notice

Three levels of programming classes are supported: basic (non-MDI, no support for tool bars or status bars), application (App... classes - MDI support, basic tool bar and tool-bar support), and high-level-application.

A proper MDI (Multiple Document Interface) application consists of an MDI Panel object (which contains and supports a menu bar, a tool bar, a status bar and a client area), an MDI client-area object which contains and supports child MDI dialogs or views. The App... classes (AppPanel, AppClientArea, AppDialog) provide the needed cooperative support to create an MDI application.

Although complete applications can be written using the App... classes, they are considered to be intermediate-level classes. A higher and more-powerful level of classes exists and it is expected that most applications will be written using these high-level classes (Panel, ClientArea, cToolBar, cStatusBar, MenuBar, View, dbView, and ReportView).

A normal program is structured as follows:

    oMain (Panel)
        MenuBar
            PopupMenus
            :
        ToolBar
        oClientArea (ClieantArea)
            :
            Views (View, dbView, ReportView)
            :
        Statusbar

Normally you will not set properties or send messages directly within a ClientArea object. Its size, location and characteristics is set by its parent panel object (Panel) either automatically or through the panel's public interface. Often messages sent from the panel will require the client-area to direct these messages to its children. A number of these messages are pre-defined. The ClientArea object can be instructed to do the following to all child view objects: minimize, restore, arrange all icons, cascade, tile, verify exit application, and notify exit application. If a custom process is required, the next_mdi_dialog message can used to retrieve the object id of all child MDI dialog objects.

This class is a subclass of AppClientArea and inherits all of its interface with no changes. It exists to provide a logical separation between the three levels of program classes.

Last Edited: November 21, 2004


Properties for ClientArea

View property list in alphabetical order

Name | Description
Inherited Properties from MdiClientArea
Bitmap | Displays a bitmap in an object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Inherited Properties from DfBasemdiclient
Scroll_Bar_Visible_State | Specifies whether this object is to display a scroll bar (or bars) when the content of the object exceeds this object's same-time display capacity
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ClientArea

View event list in alphabetical order

Name | Description
Inherited Events from MdiClientArea
OnKillFocus |
OnSetFocus |
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ClientArea

View method list in alphabetical order

Name | Type | Description
Inherited Methods from AppClientArea
Next_Mdi_Dialog | Function | Provides a way to obtain the object ID of all views contained by this container
Inherited Methods from MdiClientArea
DoHtmlHelp | Procedure | Launches Compiled HTML Help
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Inherited Methods from DfBasemdiclient
Arrange_Icons | Procedure | Arranges the icons for all minimized views contained by this object
Cascade_Windows | Procedure | Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it
Switch_Next_View | Procedure | Switches the focus to the next view object in this object
Switch_Prior_View | Procedure | Switches the focus to the previous view object in this object
Tile_Windows_Horizontal | Procedure | Arranges this object's views from left to right across the top, and then down to the next line, also so arranged
Tile_Windows_Vertical | Procedure | Arranges this object's views from top to bottom down the left side, and then right to the next column, also so arranged
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Cm_Entry

Class: Cm_Entry (Abstract)

Properties Events Methods Index of Classes

Abstract class that provides Entry class capabilities to the prototype_entry class

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------Cm_Menu
---------Cm_Entry
------------Prototype_Entry

Library: Windows Application Class Library

Package:

Mixins: cm_Entry_Mixin

Description

This abstract class is used by the prototype_entry object (which is also instantiated or sub-classed).

Last Edited: November 21, 2004


Properties for Cm_Entry

View property list in alphabetical order

Name | Description
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from Cm_Menu
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Cm_Entry

View event list in alphabetical order

Name | Description
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from Cm_Menu
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Cm_Entry

View method list in alphabetical order

Name | Type | Description
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from Cm_Menu
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Down | Procedure | Sends the key kdownarrow message to the object
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Cm_Menu

Class: Cm_Menu (Abstract)

Properties Events Methods Index of Classes

Abstract class that provides Menu class capabilities to the prototype_entry class

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------Cm_Menu
---------Cm_Entry

Library: Windows Application Class Library

Package:

Mixins: Cm_Menu_Mixin

Description

This abstract class is used by the prototype_entry object (which is also instantiated or sub-classed).

Last Edited: November 21, 2004


Properties for Cm_Menu

View property list in alphabetical order

Name | Description
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Cm_Menu

View event list in alphabetical order

Name | Description
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Cm_Menu

View method list in alphabetical order

Name | Type | Description
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Down | Procedure | Sends the key kdownarrow message to the object
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cMapiHandler

Properties Events Methods Index of Classes

Consists of functions for sending mail, reading received mail and sending documents

Hierarchy

cObject
---cMapiHandler

Library: Common (Windows and Web Application) Class Library

Package: cMapiHandler.Pkg

Description

Simple MAPI consists of functions for sending mail, reading received mail and sending documents. Consider MAPI as a transport mechanism for mail and fax messages. Connected to a message we can send enclosures. It is usually default installed on your and the customer's computer in the form of a DLL. Many software packages do use the Windows MAPI layer for sending and receiving mail. Microsoft Outlook does also use MAPI but adds many extra features on top of it. Do not confuse the functionality of Outlook with MAPI via Visual DataFlex. The common part of it is sending and reading mail. If you need the functionality of Outlook (read from other Outlook or compliant product folders for example) inside your applications you should create an Outlook Active-X connection.

To establish a connection between your application and the Windows MAPI you need to create an object of the cMapiHandler class. A global cMapiHandler object will be created. Using multiple cMapiHandler objects makes it possible to use multiple profiles/accounts from within one Visual DataFlex application. Using one object makes it possible to globally logon/logoff to MAPI and makes sending messages easier.

Sending Mail

To be able to send mail to an addressee one needs to fulfill the following requirements:

  • Login to the MAPI system and get a MAPI Handle.
  • Initialize the Visual DataFlex MAPI elements. This way a new message can be a composed.
  • Specify the message subject and body (text of the message).
  • Specify at least one addressee.
  • Specify enclosures/attachments if you want.
  • Send the message.
  • Logoff from the MAPI system.

Of course, you can leave the logon/logoff out of the above scheme if you want to do this once.

Reading Mail

Only already received mail (placed in the INBOX) can be read. Do the following:

  • Login to the MAPI system and get a MAPI Handle.
  • Scan for messages (new or already as read marked messages).
  • Process each message that is placed in the properties of your cMapiHandler object.
  • Logoff from the MAPI system.

Of course, you can leave the logon/logoff out of the above scheme if you want to do this once.

User interface sample

Study the MAPI sample installed in the Examples directory. These are only examples of how you could use it. The components are reusable.

Manually compose/send a message

When you want to send a message via MAPI without using the dialogs (UI) you can use the code from the following sample as an example.

Use Windows.pkg
Use DFError.pkg
Use MapiSession.Pkg

// In this method we will demonstrate how to send a message using NEW MAPI
// without using visual controls
Procedure DoCreateSendMessage
    Integer iRetVal
    Handle hoMapiSession

    Move oMapiSession To hoMapiSession
    If (hoMapiSession > 0) Begin
        Send DoInit To hoMapiSession
        Set psMessageSubject Of hoMapiSession To "A test message for the book"
        Set psMessageText Of hoMapiSession To ("This is line 1 of the message body" + Character (13) + Character (13) + "and this is line 3")
        Send DoAddReceiver To hoMapiSession MAPI_TO "somename" "SMTP:somename@somehost.com" "" 0
        Get Logon Of hoMapiSession "" "" 0 To iRetval
        Get SendMail Of hoMapiSession (MAPI_NEW_SESSION iOr MAPI_LOGON_UI) True To iRetval
        Get Logoff Of hoMapiSession To iRetval
    End
End_Procedure // DoCreateSendMessage

Send DoCreateSendMessage

As an extra you can set the psUsername and psPassword properties or replace the "0" in the Get Logon. line with MAPI_LOGON_UI constant. This will popup a logon dialog in which the user can select the profile to use and if required specify a password.

Since the default for pbReportErrors property is false, you have to check the results of the MAPI functions and see whether you want to continue the operation or not. You can find samples of this usage in the sample dialogs and MAPI view.

Sample

Object oMapiSession is a cMapiHandler
End_Object

Last Edited: July 7, 2005


Properties for cMapiHandler

View property list in alphabetical order

Name | Description
pbBodyAsFile | Flag to store the message as file attachment
pbEnvelopeOnly | Flag to tell if only the header should be returned or not
pbGuaranteeFiFo | Flag to tell if messages from mapi must be sorted in date time order
pbLongMsgId | Flag to tell using a long message-id or a short one
pbMapiMessageReturnRequest | Contains a true/false value whether a return receipt is requested or not
pbPeek | Flag to tell whether MapiReadMail should flag an unread message as been read
pbReportErrors | Determines if MAPI errors should be reported directly
pbSuppressAttach | Flag to tell whether the attachments should be written out to disk or not
pbUnreadOnly | Flag to tell if only unread messages must be returned or not
phSessionID | Contains the handle returned on logon to the MAPI system
piMessageFileCount | Contains the number of enclosures that were found by the MapiReadMail method
piMessageFlags | Contains the flags returned by MapiReadMail
piMessageRecipCount | Contains the number of recipients that were found by the MapiReadMail method
piResolvedEntryIDLength | Contains the length of the entry-id
psFindNextMessageType | Message class to search with
psMessageConversationId | The conversation thread to which the message belongs
psMessageDateReceived | The date and time when the message was received according to MAPI and returned by MapiReadMail
psMessageId |
psMessageSenderAddress | Allows the MapiReadMail to return the senderaddress
psMessageSenderName | Allows the MapiReadMail to return the sendername
psMessageSubject | Allows MapiReadMail to return the subject of the read message
psMessageText | Allows MapiReadMail to return the full message text
psMessageType | The messagetype returned by MapiReadMail
psPassword | Password to use for connecting to MAPI on logon
psResolvedAddress |
psResolvedEntryID | Contains the entry-id for the resolved name
psResolvedName | Contains the returned name value
psUserName | Username to use for connecting to MAPI on logon
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cMapiHandler

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cMapiHandler

View method list in alphabetical order

Name | Type | Description
AddressBook | Function | Used to browse / select an entry from the Addressbook
AddresseeDetails | Function | Displays a dialog box containing the details of a selected address list entry
AttachmentFileName | Function | Returns the N-th attachment filename
AttachmentPathName | Function | Returns the N-th attachment pathname
DeleteMail | Function | Deletes a message from the message base
DoAddAttachment | Procedure | Adds an attachment to the list
DoAddReceiver | Procedure | Stores the name, address and type in the child object called "oReceiversArray"
DoClearAttachmentsList | Procedure | Sends Delete_Data message to "oAttachmentsArray" child object, erasing the list of message attachments
DoClearReceiversList | Procedure | Sends Delete_Data message to "oReceiversArray" child object, erasing the list of message receivers
DoClearRecipientsList | Procedure | Sends Delete_Data message to "oRecipientsArray" child object, erasing the list of message recipients
DoInit | Procedure | Initializes the cMapiHandler object and prepares for composing a new message
FindNext | Function | Finds either the first or the next message in the queue
FindNextFlags | Function | Returns the result of the properties valid for FindNext operation by composing a value based on the status properties pbGuaranteeFifo, pbLongMsgId and pbUnreadOnly
Logoff | Function | Disconnects the DataFlex application from the MAPI system
Logon | Function | Makes a connection between DataFlex and MAPI using either the passed username and password or the values from the properties psUserName and psPassword
ReadMail | Function | Reads the mail message, addressed by, the passed message id and flags and returns the status of the action
ReadMailFlags | Function | Returns the result of the properties valid for ReadMail operation
RecipientAddress | Function | Returns the N-th recipient address
RecipientEntryId | Function | Returns the N-th recipient ID
RecipientEntryIdLength | Function |
RecipientName | Function | Returns the N-th recipient name
ResolveName | Function | Transforms a message recipient's name as entered by a user to an unambiguous address list entry
SendDocuments | Function | Opens a message dialog in which the user can enter/specify receivers of the document(s) and can specify a body text
SendMail | Function | Sends a message
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cMSSQLHandler

Properties Events Methods Index of Classes

Implements functionality specific to SQL Server.

Hierarchy

cObject
---Array
------cCLIHandler
---------cMSSQLHandler

Library: Common (Windows and Web Application) Class Library

Package: MSSqldrv.pkg

Description

Enumerating Servers and Databases

The enumeration functions available will store the lists they enumerate in the object itself. After calling an enumeration function one can get the enumerated values by using the value function.

Function EnumerateServers Returns Integer
Function EnumerateDatabases String sServer String sUser String sPassWord Returns Integer

If, for example, we would like to show all servers and available databases therein we would use:

Use MSSQLDRV.pkg

Procedure ShowAllServersAndDatabases
    Handle hoSQLHandler
    Integer iNumServers
    Integer iNumDatabases
    Integer iServerCount
    Integer iDatabaseCount

    Get Create U_cMSSQLHandler To hoSQLHandler
    If (hoSQLHandler > 0) Begin
        Get EnumerateServers Of hoSQLHandler To iNumServers
        For iServerCount From 0 To (iNumServers - 1)
            Showln "SERVER: " (Value(hoSQLhandler, iServerCount))
            //*** Assuming every server has an sa account with
            //*** empty password
            Get EnumerateDatabases of hoSQLHandler ;
            (Value(hoSQLhandler)) "sa" "" To iNumDatabases
            For iDatabaseCount From 0 To (iNumDatabases - 1)
                Showln " " (Value(hoSQLHandler, iDatabaseCount))
            Loop
            //*** Need to enumerate servers again, the enumerate
            //*** databases overwrites the server information
            Get EnumerateServers Of hoSQLHandler To iNumServers
        Loop
        Send Destroy Of hoSQLHandler
    End
End_Procedure // ShowAllServersAndDatabases

The EnumerateDatabases function expects a user account and password. It is not possible to use NT Authentication to enumerate databases.

Last Edited: April 19, 2005


Properties for cMSSQLHandler

View property list in alphabetical order

Name | Description
Inherited Properties from cCLIHandler
psDriverID | The identification of the CLI driver.
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cMSSQLHandler

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cMSSQLHandler

View method list in alphabetical order

Name | Type | Description
BrowseConnect | Function |
EnumerateDatabases | Function |
EnumerateServers | Function |
ExtractList | Function |
Inherited Methods from cCLIHandler
CKBuildRevision | Function | Returns the build revision of the Connectivity Kit.
CKMajorRevision | Function | Returns the major revision of the Connectivity Kit.
CKMinorRevision | Function | Returns the minor revision of the Connectivity Kit.
CKReleaseRevision | Function | Returns the release revision of the Connectivity Kit.
CKRevision | Function | Returns the Connectivity Kit revision in the format Major.Minor.Release.Build.
CLIDFDateToSQLDate | Function |
CLISQLDateToDFDate | Function |
ColumnName | Function | Returns the name of the column enumerated at the given position by EnumerateColumns.
DumpStatus | Procedure | Dumps the current status of the Connectivity Kit to an ASCII disk file.
EnumerateColumns | Function | Enumerates all column names for a given table.
EnumerateTables | Function | Enumerates tables in the given database.
ExtractPartFromRevision | Function |
IsMinimalRevision | Function | Checks if a Connectivity Kit complies with a minimal revision.
LastDriverError | Function | Returns the string value of the last generated driver error.
MaxUsers | Function | Returns the maximum number of users of the Connectivity Kit.
ReadConfiguration | Procedure | Forces the Connectivity Kit to reread the driver configuration file.
RedirectConnection | Function |
RegistrationName | Function | Returns the registration name of the Connectivity Kit.
RIMValueToText | Function | Converts a DF_FILE_GENERATE_RECORD_ID_METHOD attribute value to the corresponding text.
ROValueToText | Function | Converts a DF_FIELD_READ_ONLY attribute value to the corresponding text.
SchemaName | Function | Returns the schema of the table enumerated at the given position by EnumerateTables.
SerialNumber | Function | Returns the Connectivity Kit serial number.
TableComment | Function | Returns the comment of the table enumerated at the given position by EnumerateTables.
TableName | Function | Returns the name of the table enumerated at the given position by EnumerateTables.
TableType | Function | Returns the type of the table enumerated at the given position by EnumerateTables.
TextToRIMValue | Function | Converts a record identity text to the DF_FILE_GENERATE_RECORD_ID_METHOD attribute value
TextToROValue | Function | Converts a read only text to the DF_FIELD_READ_ONLY attribute value.
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cObject

Properties Events Methods Index of Classes

The fundamental class from which all classes are derived

Hierarchy

cObject
---AbstractFileDialog
---Array
---BaseData_Set
---BaseXmlDomImplementation
---BaseXmlDomNamedNodeMap
---BaseXmlDomNode
---BaseXmlDomNodeList
---BaseXMLDomParseError
---BusinessProcess
---cApplication
---cClientWebService
---cCommandLine
---cCrystal
---cDistributedBusinessProcess
---cHtmlHelp
---cImageList
---cIniFile
---cMapiHandler
---ColorDialog
---cRegistry
---cReport
---CrystalReport
---cStatusPane
---cTableColumnFetchHelper
---cToolbarButton
---cUIObject
---cVersionInfo
---cWebApp
---cWebService
---cWorkspace
---DfComAutomationObject
---ErrorSystem
---FontDialog
---HelpSystem
---InetTransfer
---Mixin
---PrintDialog
---Report
---StatusAsciiLog
---StatusdbLog
---StatusPanel

Library: Common (Windows and Web Application) Class Library

Package:

Description

cObject is the ultimate base class. It contains only the interfaces required to support basic Visual DataFlex object behaviors. Those standard behaviors consist of:

  • Object creation and destruction (Create, Destroy, Destroy_Object)
  • Object naming (Name, Object_Label, Object_Id)
  • Controlling an object's parent and children (Child_Count, Parent)
  • Message Delegation (Delegation_Mode)
  • Object Neighborhoods (peNeighborhood)

Sub-classes and objects may be created based on cObject using standard syntax. For example:

This creates a sub-class based on cObject and creates an object based on this sub-class

Class cMyInfoClass is a cObject
      Procedure Construct_Object
           Forward Send Construct_Object
           Property String psMyInfo1
           Property String psMyInfo2
      End_Procedure
End_Class

Object oMyInfo is a cMyInfoClass
      Set psMyInfo1 to "hi"
      Set psMyInfo2 to "there"
End_object

Below is an alternate method for creating on object based on the sub-class

Get Create U_cMyInfoClass to hoInfo
Set psMyInfo1 of hoInfo to "hi"
Set psMyInfo2 of hoInfo to "there"

In this example an object is created based on cObject and interfaces (in this case properties) are defined for this instance

Object oMyInfo is a cObject
      Property String psMyInfo1 "hi"
      Property String psMyInfo2 "there"
End_object

Object Delegation

By default, the delegation_mode of cObject is delegate_to_parent, which means that messages not understood by this object will delegate the parent and attempt to resolve the message there. When creating classes and objects based on cObject you may decide to disable delegation by setting the property to no_delegation. If you have created a class or object that does not need automatic delegation (and you will find that this is often the case), setting delegation_mode to no_delegation creates a class that is much easier to debug. Messages that are not understood are reported as errors, instead of delegating where they might be improperly understood. Even if delegation is turned off you can always explicitly delegate a message by using the delegate command. This often makes your intention clearer.

Note:Two private methods exist in cObject, Set Focus_mode and Set Size. If either of these methods is sent to a cObject, the object will intentionally return an error. This was added for backward compatibility considerations. These are not messages you should ever send to a non-UI object but the old class hierarchy might have required this. These errors are there to provide you with a warning that they should be removed.

Last Edited: November 21, 2004


Properties for cObject

View property list in alphabetical order

Name | Description
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cObject

View event list in alphabetical order

Name | Description
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cObject

View method list in alphabetical order

Name | Type | Description
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cODBCHandler

Properties Events Methods Index of Classes

Implements functionality specific to ODBC.

Hierarchy

cObject
---Array
------cCLIHandler
---------cODBCHandler

Library: Common (Windows and Web Application) Class Library

Package: odbc_drv.pkg

Description

The cODBCHandler class implements functionality specific to Open Database Connectivity (ODBC).

Enumerating Data Sources

Two methods are available to enumerate data sources. They can be used to present lists of available data sources in utilities. A procedure to show all available data sources with driver identification looks like:

Use ODBC_DRV.pkg

Procedure ShowODBCDataSources Integer iDataSourceType
    Handle hoODBCHandler
    String sDataSourceAndDriver

    Get Create U_cODBCHandler To hoODBCHandler
    If (hoODBCHandler > 0) Begin
        Set DataSourceType Of hooDBCHandler To iDataSourceType
        Repeat
            Get DataSources Of hoODBCHandler To sDataSourceAndDriver
            Showln sDataSourceAndDriver
        Until (sDataSourceAndDriver = "")
        Send Destroy Of hoODBCHandler
    End
End_Procedure // ShowODBCDataSources

Showln "All datasources:"
Send ShowODBCDataSources SQL_FETCH_ALL
Showln
Showln "All USER datasources:"
Send ShowODBCDataSources SQL_FETCH_USER
Showln
Showln "All SYSTEM datasources:"
Send ShowODBCDataSources SQL_FETCH_SYSTEM

Last Edited: April 21, 2005


Properties for cODBCHandler

View property list in alphabetical order

Name | Description
Inherited Properties from cCLIHandler
psDriverID | The identification of the CLI driver.
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cODBCHandler

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cODBCHandler

View method list in alphabetical order

Name | Type | Description
DataSources | Function |
DataSourceType | Procedure Set |
Inherited Methods from cCLIHandler
CKBuildRevision | Function | Returns the build revision of the Connectivity Kit.
CKMajorRevision | Function | Returns the major revision of the Connectivity Kit.
CKMinorRevision | Function | Returns the minor revision of the Connectivity Kit.
CKReleaseRevision | Function | Returns the release revision of the Connectivity Kit.
CKRevision | Function | Returns the Connectivity Kit revision in the format Major.Minor.Release.Build.
CLIDFDateToSQLDate | Function |
CLISQLDateToDFDate | Function |
ColumnName | Function | Returns the name of the column enumerated at the given position by EnumerateColumns.
DumpStatus | Procedure | Dumps the current status of the Connectivity Kit to an ASCII disk file.
EnumerateColumns | Function | Enumerates all column names for a given table.
EnumerateTables | Function | Enumerates tables in the given database.
ExtractPartFromRevision | Function |
IsMinimalRevision | Function | Checks if a Connectivity Kit complies with a minimal revision.
LastDriverError | Function | Returns the string value of the last generated driver error.
MaxUsers | Function | Returns the maximum number of users of the Connectivity Kit.
ReadConfiguration | Procedure | Forces the Connectivity Kit to reread the driver configuration file.
RedirectConnection | Function |
RegistrationName | Function | Returns the registration name of the Connectivity Kit.
RIMValueToText | Function | Converts a DF_FILE_GENERATE_RECORD_ID_METHOD attribute value to the corresponding text.
ROValueToText | Function | Converts a DF_FIELD_READ_ONLY attribute value to the corresponding text.
SchemaName | Function | Returns the schema of the table enumerated at the given position by EnumerateTables.
SerialNumber | Function | Returns the Connectivity Kit serial number.
TableComment | Function | Returns the comment of the table enumerated at the given position by EnumerateTables.
TableName | Function | Returns the name of the table enumerated at the given position by EnumerateTables.
TableType | Function | Returns the type of the table enumerated at the given position by EnumerateTables.
TextToRIMValue | Function | Converts a record identity text to the DF_FILE_GENERATE_RECORD_ID_METHOD attribute value
TextToROValue | Function | Converts a read only text to the DF_FIELD_READ_ONLY attribute value.
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: CodePickList

Properties Events Methods Index of Classes

Allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------PickList_
------------------------------------------PickList
---------------------------------------------CodePickList_
------------------------------------------------CodePickList

Library: Windows Application Class Library

Package: Dfcdpk.pkg

Description

CodePickList is used to allow selection of one or more values from a list of static choices for insertion into database records by a code (usually one character) for each choice in programs handling the database through DataSets. In programs using DataDictionarys, the CodeValidationTable class should be used.

Usage

use codepick

object object_name is a CodePickList
    [set Server to DDOName]
    [set Modal_State to True]
    [Entry_Item File.Field]
    :
    Item_List
        On_Item [value]
        :
    End_Item_List
    :
End_Object

Argument Explanation

Constant | Meaning
object_name | The name of the object.
File.Field | The name of the table and field which is to receive the selected value (only for single-select or auto-select lists).
DDOName | The name of the DataDictionary or DataSet object through which this object accesses the database. Also the initial value of this object's server property.
value | The value to display for the item.

Of Special Note

This class extends its superclass Pick_list, to enable it to display a selection code, usually a single character, on the same line as the selection value itself is displayed.

The auto_locate_state of a CodePickList is set true.

Updating a Code Field and a Description in a DEO

Often in data-entry screens it is desirable to have a data field represented in two items. The first item will contain the actual database field value, and the second item will contain a display-only description of its meaning.

If the pick-list values were Open, Closed, and New, the pick list should return the first letter to the first item (this is the item that will get written to the database), and the entire text in the second item (this is a displayonly field). The following example shows how to do this:

Object Stat_List is a CodePickList POPUP
    Set export_description_state to TRUE
    item_list
        on_item  "Open"
        on_item  "Closed"
        on_item  "New"
    end_item_list
end_object

Object File_Entry is a dbForm
    :
    item_list
        :
        entry_name_item Stat## File.Status { Capslock, ;
            iPrompt   =(Stat_List(self)), ;
            iValidate =GET_validate_prompt, ;
            iExit     =MSG_prompt_description }
        entry_item (prompt_description(self, Stat##))

Alternatively, if the list values were 1 Open, 2 Closed, and 3 New, we would want the number to be returned to the invoking item, and the word returned to the next item.

Export_description_state tells the list that it must move two values out (the description will be exported to the following DEO item). The prompt_description (this is a procedure imported from the code_deo_mixin class) in the iExit procedure makes sure that the description is updated as users leave the item (in case they entered the status value manually). If the iValidate =GET_Validate_Prompt option is used, the iExit message will not be needed (as a programming convenience, the iValidate will provide this service). Therefore, in this example, the iExit message was actually not needed.

The prompt_description expression in the display-only description item makes sure that the description is updated when the DEO is refreshed by its server DSO. Note that this function must be passed the number of the item that contains the iPrompt message. This will usually be the previous item (using entry_name_item makes this much easier).

A property named description_offset allows you separate your code and your description in the pick list. By default, this value is zero. This works well when the first letter of a description is the code and the first letter of the description (the prior example works this way). If the code and the description are separate, you can tell the CodePickList where the descriptions start by setting this property (2 is often a suigrid value).

Object Stat_List is an CodePickList POPUP
    Set export_description_state to TRUE
    Set description_offset to 2
    item_list
        on_item  "1 Open"
        on_item  "2 Closed"
        on_item  "3 New"
    end_item_list
end_object

When export_description_state is set true, the description is returned by default to the item following the iPrompt item. This can be changed. The property description_item_offset determines the position of the DEO's description item relative to prompt item. The default value is 1. In the following example, this property is used in an unconventional fashion:

Object Card_List is an CodePickList Choose_Card POPUP
    Set export_description_state to TRUE
    Set description_item_offset to 0
    item_list
        on_item  "AMEX"
        on_item  "DINERS"
        on_item  "MASTERCD"
        on_item  "VISA"
    end_item_list
end_object
:

in the DEO's item list:

    entry_name_item Card_1## Person.Card_1 { Capslock, ;
        iPrompt   =(Card_List(self)), ;
        iValidate =GET_Validate_Prompt }

The description will get displayed right on top of the actual code item. Why do this? Users may now press a single letter (A, D, M, or V) and press Enter. During the iValidate, the description (AMEX, DINERS, MASTERCD, VISA) will replace the single letter. This provides us with an autofind-like behavior.

Accelerator Keys

This class's accelerator keys are unchanged from those of its superclass.

Last Edited: February 18, 2004


Properties for CodePickList

View property list in alphabetical order

Name | Description
Inherited Properties from CodePickList_
Allow_Blank_State | Determines if item validation will accept a blank window as a valid entry for the item
Default_Item | Defines which item in the code pick list is inserted into the invoking object item by the default_prompt message
Description_Item_Offset | Defines the number of items sequentially after the invoking item the description is returned to when export_description_state is true
Description_Offset | Defines the position in the value of the code-pick-list item at and to the right of which the description will be copied from when export_description_state is true
Error_Message | Sets the text of the message displayed when validation fails
Error_Number | Sets the number of the error that will be returned when validation fails
Export_Description_State | Determines if the code pick list returns the value of the selected item to the first item of the invoking object following the item from which the code pick list was invoked
Match_Length | Sets the number of character that must be typed into the invoking item to satisfy the requirements for a match with a value of an item in this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Inherited Properties from PickList
CustomScrollState | Determines changing scroll bar behaviors
ScrollOnThumbTrackState |
ThumbScrollState |
Inherited Properties from PickList_
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational
Invoking_Object_ID | Identifies the object which activated this object
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent
Original_Selection | Identifies the item that was selected when this object was originally activated
Popup_State | (Obsolete)
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for CodePickList

View event list in alphabetical order

Name | Description
Inherited Events from PickList
Mouse_Click |
Inherited Events from PickList_
Fill_List |
Initialize_List |
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Click | Sent whenever a header has received a mouse click
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
onInitSpin | Augmented to set the minimum and maximum positions for a spinner
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for CodePickList

View method list in alphabetical order

Name | Type | Description
Inherited Methods from PickList_
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the first enterable column of the first row
Cancel | Procedure | Deactivates this object
End_of_Data | Procedure | Causes the grid's current item to be set to the last enterable column of the last row
first_selected_item | Function |
Init_Selected_Item | Procedure | Sets enumeration_counter to zero
Move_Value_Out | Procedure | Overridden to set the value of the current item of the invoking object to the code value of the current item of this object upon selection, and then to send display_description to the invoking object
next_selection | Function | Returns identifier of next selected item
Ok | Procedure | Oks a list selection
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
Up_Row | Procedure | Changes the current item to the prior row, if any, at the same item relative to the beginning of the row
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: CodePickList_

Class: CodePickList_ (Abstract)

Properties Events Methods Index of Classes

Abstract class that allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------PickList_
------------------------------------------PickList
---------------------------------------------CodePickList_
------------------------------------------------CodePickList

Library: Windows Application Class Library

Package: Dfcdpk.pkg

Mixins: Code_Pick_list_mixin

Description

CodePickList_ is an abstract class used to allow selection of one or more values from a list of static choices for insertion into database records by a code (usually one character) for each choice in programs handling the database through DataSets. Its sub-class CodePickList should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for CodePickList_

View property list in alphabetical order

Name | Description
Allow_Blank_State | Determines if item validation will accept a blank window as a valid entry for the item
Default_Item | Defines which item in the code pick list is inserted into the invoking object item by the default_prompt message
Description_Item_Offset | Defines the number of items sequentially after the invoking item the description is returned to when export_description_state is true
Description_Offset | Defines the position in the value of the code-pick-list item at and to the right of which the description will be copied from when export_description_state is true
Error_Message | Sets the text of the message displayed when validation fails
Error_Number | Sets the number of the error that will be returned when validation fails
Export_Description_State | Determines if the code pick list returns the value of the selected item to the first item of the invoking object following the item from which the code pick list was invoked
Match_Length | Sets the number of character that must be typed into the invoking item to satisfy the requirements for a match with a value of an item in this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Inherited Properties from PickList
CustomScrollState | Determines changing scroll bar behaviors
ScrollOnThumbTrackState |
ThumbScrollState |
Inherited Properties from PickList_
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational
Invoking_Object_ID | Identifies the object which activated this object
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent
Original_Selection | Identifies the item that was selected when this object was originally activated
Popup_State | (Obsolete)
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for CodePickList_

View event list in alphabetical order

Name | Description
Inherited Events from PickList
Mouse_Click |
Inherited Events from PickList_
Fill_List |
Initialize_List |
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Click | Sent whenever a header has received a mouse click
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
onInitSpin | Augmented to set the minimum and maximum positions for a spinner
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for CodePickList_

View method list in alphabetical order

Name | Type | Description
Inherited Methods from PickList_
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the first enterable column of the first row
Cancel | Procedure | Deactivates this object
End_of_Data | Procedure | Causes the grid's current item to be set to the last enterable column of the last row
first_selected_item | Function |
Init_Selected_Item | Procedure | Sets enumeration_counter to zero
Move_Value_Out | Procedure | Overridden to set the value of the current item of the invoking object to the code value of the current item of this object upon selection, and then to send display_description to the invoking object
next_selection | Function | Returns identifier of next selected item
Ok | Procedure | Oks a list selection
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
Up_Row | Procedure | Changes the current item to the prior row, if any, at the same item relative to the beginning of the row
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: CodeValidationTable

Properties Events Methods Index of Classes

Provides a two-column table of validation data for validation lists used with DataDictionary objects.

Hierarchy

cObject
---Array
------ValidationTable
---------DescriptionValidationTable
------------FileValidationTable
---------------CodeValidationTable

Library: Common (Windows and Web Application) Class Library

Package: Ddvaltbl.pkg

Mixins: cCodeMaintOpen_Mixin

Description

This is an object for assignment in DataDictionary objects to database fields with the Field_Value_Table property. It provides both values for insertion into the database and descriptions to explain each value. It draws its data from up to two fields of a central codes database file, by default one named CODEMAST. This file contains, along with the value and description fields (known by default to all objects of this class), a field for type values by which to group value/description records for selection for all the (possibly unrelated) validation fields in an application, and an index that orders the records both for this selection and for their presentation in all the application's objects of this class.

If the Validate_State property is set to False, entries are permitted that are not in the list; in its default True state, it requires an entry that matches one of the existing table items. If the Static_State property is set to False, the list will be loaded every time the table is activated; in its default True state, the object is loaded with its list only once in each session.

Sample

Object Ship_Table  is a CodeValidationTable
    Set Type_Value        To "SHIPPING"
    Set Allow_Blank_State To TRUE
End_Object   // Ship_Table
:
Class OrderHea_Data_Set is a DataDictionary
    :
    Procedure Define_Fields
    :
    Set Field_Value_Table Field OrderHea.Via to (Ship_Table(Self))

See Also

Using Validation Tables

Last Edited: July 12, 2005


Properties for CodeValidationTable

View property list in alphabetical order

Name | Description
Inherited Properties from FileValidationTable
Code_Field | The database field from which the values are to be drawn for validation and insertion into the database
Description_Field | Identifies the field from which the descriptions are to be drawn for validation and insertion into the database
Ordering | Identifies the index to be used for ordering values in this object.
Type_Field | Identifies the field in the CodeMast data file that contains the type values to be used for the validation table
Type_Value | Sets the value in the Type_Field by which records for validation are selected
Inherited Properties from ValidationTable
Allow_Blank_State | Controls whether blank entries are accepted in this object
Main_File | Identifies the data file from which the values are to be drawn to fill this object
Static_State | Determines whether object loads once per session or dynamically.
Table_Title | The title shown in the caption bar of the validation table
Validate_State | Determines whether values are validated against the items contained in the validation table.
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for CodeValidationTable

View event list in alphabetical order

Name | Description
Inherited Events from ValidationTable
Fill_List | Fills the list of entires in the validation table
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for CodeValidationTable

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DescriptionValidationTable
Add_Table_Value | Procedure | Should be sent for each sDescription and sValue you wish to add to your validation table
Inherited Methods from ValidationTable
Find_Code_Description | Function |
TableData | Function | Returns the validation table's data in a two dimensional variant array
Validate_Value | Function | Determines whether a value is valid or not (is listed in the validation table or not)
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ColorDialog

Properties Events Methods Index of Classes

Provides an interface to the Windows standard Color dialog

Hierarchy

cObject
---ColorDialog

Library: Windows Application Class Library

Package: Colr_dlg.pkg

Description

The ColorDialog class provides an interface to the Windows standard Color dialog. The dialog will maintain its own list of custom colors and return the selected RGB color.

Sample

This example shows how to use a color dialog to select a color and to set custom colors.

Use dfAllEnt.pkg // standard
Use Colr_Dlg.pkg // ColorDialog class

Object oPanel is a Panel
    Set Size     To 80 150
    Set Location To 25 25
    Set Label    To 'Test of ColorDialog'

    Object oColorDlg is a ColorDialog
        Set SelectedColor To (RGB(255, 0, 0))

        Procedure Choose_Color
            Integer rgbColor bOK
            String sMessage
            Get Show_Dialog To bOK
            If bOK Begin
                Get SelectedColor To rgbColor

                Move 'COLOR SELECTED\n\n' To sMessage
                Append sMessage 'Red='   (R_From_RGB(rgbColor)) '\n'
                Append sMessage 'Green=' (G_From_RGB(rgbColor)) '\n'
                Append sMessage 'Blue='  (B_From_RGB(rgbColor))
                Send Info_Box sMessage
            End
        End_Procedure

        Procedure ShowCustomColors
            Integer rgbColor iLoop iRed iGreen iBlue
            String sMessage
            Move 'CUSTOM COLORS\n\n' To sMessage
            For iLoop From 0 To 15
                Get Custom_Color iLoop To rgbColor
                Move (R_From_RGB(rgbColor)) To iRed
                Move (G_From_RGB(rgbColor)) To iGreen
                Move (B_From_RGB(rgbColor)) To iBlue
                Append sMessage 'Color ' iLoop
                Append sMessage '= RGB(' iRed ',' iGreen ',' iBlue ')\n'
            Loop
            Send Info_Box sMessage
        End_Procedure
    End_Object

    Object oPick_bn is a Button
        Set Location To 20 20
        Set Size To 12 120
        Set Label To 'Pick a Color...'
        Procedure OnClick
            Send Choose_Color To (oColorDlg(self))
        End_Procedure
    End_Object

    Object oShow_bn is a Button
        Set Location To 50 20
        Set Size To 12 120
        Set Label To 'Show Custom Colors...'
        Procedure OnClick
            Send ShowCustomColors To (oColorDlg(self))
        End_Procedure
    End_Object

End_Object

Start_UI

Syntax

Use Colr_Dlg.pkg

Object object_name is a ColorDialog
    Set SelectedColor To rgb-color
End_Object

See Also

Info_Box

Last Edited: November 23, 2004


Properties for ColorDialog

View property list in alphabetical order

Name | Description
Custom_Color | Contains the RGB value of any of the custom colors
FullOpen_State | Determines whether the dialog box should show both color sections upon initialization
PreventFullOpen_State | Determines if users are prevented from displaying the custom-colors section of the dialog box
SelectedColor | Holds the color that will be used as the default when the dialog box is displayed
SelectedColor_State | Determines if the dialog will initialize with the value of the SelectedColor property as its default color
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ColorDialog

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ColorDialog

View method list in alphabetical order

Name | Type | Description
AssignCustomColors | Procedure | Facilitates the copying of custom-color arrays between instances
Show_Dialog | Function | Determines how the color dialog box is constructed and behaves
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ComboEntry

Class: ComboEntry (Abstract)

Properties Events Methods Index of Classes

Combines the capabilities of the Entry and ComboForm classes in a single class

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseComboBoxEntry
------------------------------ComboEntry
---------------------------------dbBasicComboForm_

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Form_Mixin Auto_Setup_Mixin DataFile_Help_Mixin Entry_Shadow_Mixin Combo_Mixin Standard_Object_Mixin Dflabel_Mixin Single_Item_Navigate_Mixin Mask_form_Mixin FloatingPopupMenu_Mixin RGB_Support_Temp_Mixin Help_Mixin Shadow_Mixin

Description

ComboEntry is used to combine the capabilities of the Entry and ComboForm classes in a single class. This is an intermediate class.

Syntax

This class is used only for the creation of other classes; objects should not be created directly from it.

Of Special Note

All behaviors, procedures, functions and properties are inherited unchnaged from its superclasses, Entry and ComboForm. It is used as the basis for the dbComboForm class, a data-aware combo form. The dbComboForm class is a complex class that is built by using a series of intermediate super-classes (ComboEntry, dbBasicComboForm, dbDataComboForm).

This class's properties are unchanged from those of its superclasses.

This class's procedures and functions are unchanged from those of its superclasses.

Last Edited: May 5, 2006


Properties for ComboEntry

View property list in alphabetical order

Name | Description
Allow_Blank_State | Determines if a blank value is valid
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Combo_Item_Count | Returns the number of choices in the combo object's list
Combo_Sort_State | Determines if the object will sort its visual list
Combo_Value | Specifies the value of an item in the combo objects data-list
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
ListRowCount | Determines the number of rows in a combo form
ListWidth | Detrmines the width of a combo's drop down list
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseComboBoxEntry
Combo_Data_Object | Specifies the object ID of the internal l combo object
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ComboEntry

View event list in alphabetical order

Name | Description
Combo_Edit_Changed | Sets the item_changed_state of this object's item true
Combo_Fill_List | Called when the combo list is to be filled
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnCloseUp | Called when a drop-down list closes
OnDropDown | Called when a drop-down list opens
OnDropKey |
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ComboEntry

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Combo_Add_Item | Procedure | Adds an item to the combo list
Combo_Delete_Data | Procedure | Deletes all this object's items
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Validate_Combo_Value | Function | Determines if a combo form's value is valid
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ComboForm

Properties Events Methods Index of Classes

Combines the functionality of the form class with that of a standard Windows drop-down list

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseComboBox
---------------------------ComboForm

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Form_Mixin Combo_Mixin Standard_Object_Mixin Dflabel_Mixin Single_Item_Navigate_Mixin Mask_form_Mixin FloatingPopupMenu_Mixin RGB_Support_Temp_Mixin Help_Mixin Shadow_Mixin

Description

The ComboForm combines the functionality of the form class with that of a standard Windows drop-down list. This class is used when it is appropriate to supply a form with a list of static options. Both drop-down and drop-down edit functionality is supported. This class is used for simple, non-database entry.

The dbComboForm class is a data-aware version of the ComboForm class.

Sample

Object Field1 is a ComboForm
    Set Size to 13 100
    Set Location to 10 70
    Set Label to "User Name:"
    Set Combo_Sort_State to False

    Procedure Combo_Fill_List
        Send Combo_Add_Item "John"
        Send Combo_Add_Item "Susan"
        Send Combo_Add_Item "Michael"
    End_Procedure
End_object

Object Field2 is a Form
    Set Size to 50 100
    Set Location to 25 70
    Set Label to "Department:"
    Set Entry_State 0 to False

    Procedure Combo_Fill_List
        Send Combo_Add_Item "Research"
        Send Combo_Add_Item "Accounting"
        Send Combo_Add_Item "Support"
        Send Combo_Add_Item "Marketing"
    End_Procedure
End_Object

Syntax

Use windows

Object object_name is a ComboForm
    Set Size to Listheight width
    Set Location to row column
    Set ListRowCount to Rows
    Set Value item 0 to value

    Set Label to text
    Set Label_Justification_Mode to mode
    Set Label_row_Offset to Num
    Set Label_Col_Offset to Num

    Set Form_Margin item 0 to number
    Set enabled_state to true|false
    Set Status_Help to text

    Set Entry_State item 0 to true|false
    Set Combo_Sort_state to true|false

    Procedure Combo_Fill_List
        : (add combo items by sending Combo_Add_Item)
    End_Procedure

    Procedure onChange
        :
    End_Procedure

    Procedure onSetFocus
        :
    End_Procedure

    Procedure onKillFocus
        :
    End_Procedure

End_Object

Of Special Note

The ComboForm class is descended from the Form class and therefore, except where noted, inherits all of the properties and capabilities of the Form class. While there are many new messages provided for this class, its expected usage is quite simple. You use it just like form class except that a combo list must be filled (combo_fill_list and combo_add_item). This list may or may not be sorted (combo_sort_state). Setting entry_state determines if the form supports keyboard editing or incremental search.

The Form Component

A ComboForm really consists of two components, a form and a list. The form behaves exactly like a standard form. It is single-item and supports the standard single-item interface. When item numbers must be passed, the number will always be 0 (e.g., get value item 0 to val)

The contents of the form are stored in its value property. When a Form-class object has the focus, it will accept data from the keyboard directly into the value of the item. The value can also be directly changed and retrieved with the get and set value messages (get/set value item 0 to val). Any time the contents of a Form are changed (through keyboard input, list selection, or by set value message) the event message onChange is sent. Also, if users enter any change to the window, the item_changed_state (Item 0) and the changed_state of the object are set true.

The entry_state (Item 0) of the form determines how keyboard interaction is handled. When true (the default), normal entry is allowed into the form. This is referred to as a drop-down edit list. When set to false, the value in the form must match a value from the list and a keyboard action performs an incremental search. This is referred to as a drop-down list. The search method is determined by Windows (the ComboForm uses a standard Windows control).

The Size of a ComboForm

The height of the form component is determined by Windows and is 13 dialog units. This cannot be changed. The maximum height of the list is determined by the ListRowCount property and defaults to 10. Therefore the actual height you enter when setting the size property does usually not matter because it will be set by the by the object using ListRowCount. It is normally set to 13 making it easy to convert Forms into CombForms without having to remember to change the size property.

The List Component

When a ComboForm object is created, an internal list object is created. This list's object ID is stored in the combo_data_object property. This list is used only for storage. When a ComboForm is paged, the contents of this list is copied to the window's drop-down list.

A public message interface is supported to control this internal list. Most of these messages are prefixed with "combo_" (e.g., combo_fill_list, combo_add_item, combo_delete_item, combo_value, combo_item_matching) When working with ComboForms, you should use these messages and avoid sending messages directly to the combo_data_object list object.

Combo_sort_state specifies if the items in the list should be sorted. When true, the default, the Windows list is sorted. The internal list is never sorted. This means that the items in the internal list may not be in the same order as the items in the displayed list.

Shadowing

This class supports object shadowing. Objects of this class can either be explicitly shadowed (set enabled_state) or shadowed implicitly when an ancestor object is shadowed. When shadowed, access to the drop-down list is disabled.

Masking

The ComboForm does not support masking.

Labels

Forms often require an associated description or label. Most often these appear to the left of the form. Labels are supported with the set label message. The default location and justification mode of labels can be controlled with the properties label_col_offset, label_row_offset, and label_justification_mode.

Last Edited: May 5, 2006


Properties for ComboForm

View property list in alphabetical order

Name | Description
Allow_Blank_State | Determines if a blank value is valid
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Combo_Item_Count | Returns the number of choices in the combo object's list
Combo_Sort_State | Determines if the object will sort its visual list
Combo_Value | Specifies the value of an item in the combo objects data-list
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
ListRowCount | Determines the number of rows in a combo form
ListWidth | Detrmines the width of a combo's drop down list
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseComboBox
Combo_Data_Object | Specifies the object ID of the internal l combo object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ComboForm

View event list in alphabetical order

Name | Description
Combo_Edit_Changed | Sets the item_changed_state of this object's item true
Combo_Fill_List | Called when the combo list is to be filled
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnCloseUp | Called when a drop-down list closes
OnDropDown | Called when a drop-down list opens
OnDropKey |
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ComboForm

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Combo_Add_Item | Procedure | Adds an item to the combo list
Combo_Delete_Data | Procedure | Deletes all this object's items
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Validate_Combo_Value | Function | Determines if a combo form's value is valid
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Container

Properties Events Methods Index of Classes

Creates non-visual container objects

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------Container

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: NonVisual_Container_Mixin

Description

The Container class is used to create non-visual container objects. It is designed to be the parent of other container objects and to control their activation and deactivation. The Container also controls aspects of the navigation of its child objects.

Usage

Object Dlg is a Container

    Object F1 is a form
        Set Location to 10 70
        Set Size to 13 40
        Set Label to "Name:"
    End_Object

    Object F2 is a form
        Set Location to 25 70
        Set Size to 13 30
        Set Label to "Id:"
    End_Object

End_Object

Syntax

Use windows

Object object_name is a Container
    :
End_Object

Of Special Note

This class is descended from the Container3d class. Its abilities to group objects and manipulate them as a single unit are most-important. The Container class is used when you need to group objects together non-visually. The non-visual Container must be placed inside a visual container. Child objects will be located relative to this visual ancestor.

This class will rarely be needed. You are encouraged to use visual container objects (Container3d or Group) whenever possible.

Last Edited: December 2, 2005


Properties for Container

View property list in alphabetical order

Name | Description
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Container

View event list in alphabetical order

Name | Description
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Container

View method list in alphabetical order

Name | Type | Description
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Container3d

Properties Events Methods Index of Classes

This class creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional (3-D) appearance.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------BitmapContainer
------------------------Container
------------------------dbContainer3d_
------------------------Dialog
------------------------MdiDialog
------------------------TabPage

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Container_Mixin Standard_Object_Mixin Label_Mixin dfAuto_Locate_Mixin Shadow_Mixin Bitmap_Support_Mixin RGB_Support_Temp_Mixin Help_Mixin

Description

The Container3d class creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional (3-D) appearance. Objects based on this class will be contain controls (forms, buttons, edits, etc.) and other container objects (which will themselves contain controls).

Visual access for providing and managing objects of this class is provided in the Studio.

The dbContainer3d class is a data-aware class similar to the Container3d class.

Sample

Object Dlg is a Container3D
    Set Size to 70 150
    Set Location to 5 5

    Object F1 is a form
        Set Location to 10 70
        Set Size to 13 40
        Set Label to "Name:"
    End_Object

    Object Dlg1 is a Container3D
        Set Size to 30 130
        Set Location to 25 10
        Set Border_Style to border_StaticEdge // lowered edge

        Object F2 is a form
            Set Location to 10 70
            Set Size to 13 30
            Set Label to "Id:"
        End_Object

    End_Object

End_Object

Syntax

Use windows

Object object_name is a Container3D
    Set Size to height width
    Set Location to row column
    Set Border_Style to BorderMode
    :
End_Object

Of Special Note

This object's client_area_state is set to true. When the object is activated it will activate all child objects and then give the focus to the first focusable object. The ring_state of this object is set to false, allowing for navigation out of the container.

Container3d and Group objects are used to group objects together. They are functionally identical and differ only in appearance.

Only objects of the basic classes(i.e., the non db... classes such as Form, Edit, Button, Group, etc.) should be placed inside this object. Objects of data-aware classes (dbForm, dbEdit, dbGroup, etc.) must be placed inside data-aware containers (dbContainer, dbGroup).

Shadowing

Container objects may be shadowed by setting the enabled_state property to false. When set, all descendant objects are indirectly (or implicitly) shadowed.

Last Edited: December 2, 2005


Properties for Container3d

View property list in alphabetical order

Name | Description
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Container3d

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Container3d

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cProcessStatusPanel

Properties Events Methods Index of Classes

Supports a visual object to displayed by long-running processes that may be unattended to report errors that arise in the job

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------cStatusPanel
---------------------------------cProcessStatusPanel

Library: Windows Application Class Library

Package: cProcessStatusPanel.pkg

Description

This is the class used to create Status panel objects

This class does not provide any of the inner objects that make up a status panel. Instead an interface is provided that is used to update the various areas of status panel. At this level, those areas (title area, message area, action area, button area) are logical. You create the physical objects at the object level and then bind these objects to the interface.

Take a look at StatPnl.pkg to see how this is used.

cProcessStatusPanel is used to support a visual object to be displayed by long-running processes that may be unattended (batch processes) to report errors that arise in the job, the proportion to which the job is complete from time to time, and other information of potential interest to users running such jobs. This class supports the display of "host/sentinel" monitoring.

Syntax

Use cProcessStatusPanel.pkg

An object of this class named Status_Panel is instantiated automatically by any program that uses its package. The object's behaviors are controlled entirely by messages sent to it. The global variable ghoStatusPanel can be used in place of the object name (Status_Panel). This provides a cleaner more robust interface.

Usage

:
Procedure theProcess
    Send Initialize_StatusPanel of ghoStatusPanel aCaption aTitle aMessage
    Send Start_StatusPanel of ghoStatusPanel
    Repeat
        :   //process batch item(s)
        Send Update_StatusPanel of ghoStatusPanel aProgressString
        Get Check_StatusPanel of ghoStatusPanel to userCancel
        :
    Until (done or userCancel)
    Send Stop_StatusPanel of ghoStatusPanel
    :
End_Procedure

Notes

The status panel is used to create an interruptible progress dialog to be used during modal processes like report and batch processes. The panel is defined by setting the contents of several displayed areas:

Caption bar | The value in the caption bar
Title | A centered title that appears inside the dialog
Message | A longer message that appears below the title
Action | An area below that message that is used to display progress
Button | A Cancel button that appears below the display

When running, a status panel looks like the image (by default). You can see where each area is defined.

You can change the default size of the status panel by setting it before calling Start_StatusPanel. You can also resize the status panel while running.

All the properties of this class are defined and set in the class. They cannot be changed in programs except by sending messages to the object.

See Also

Monitoring Batch Processes

Last Edited: June 19, 2006


Properties for cProcessStatusPanel

View property list in alphabetical order

Name | Description
Action_Text | Determines the action text - an area below that message that is used to display progress
allow_cancel_state | Specifies whether the status panel will support a Cancel button
Button_Text | Determines the button text of a Cancel button that appears below the display
Caption_Text | Determines the caption text - the value in the caption bar
Message_Text | Determines the message text - a longer message that appears below the title
Title_Text | Determines the title text - a centered title that appears inside the dialog
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cProcessStatusPanel

View event list in alphabetical order

Name | Description
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cProcessStatusPanel

View method list in alphabetical order

Name | Type | Description
Check_StatusPanel | Function | Returns a status value from the status panel, usually used to determine whether the user wants to cancel (abort) a process.
close_panel | Procedure |
EnableCancelButton | Procedure | Called when status panel is activated passing whether a Cancel button should appear
Initialize_StatusPanel | Procedure | Sets the values of the popup-status-panel elements
Start_StatusPanel | Procedure | Starts the status panel process
Stop_StatusPanel | Procedure | Stops the status popup and restores the current program's normal modality
Update_StatusPanel | Procedure | Places a value in the "action window" of an active status panel
Inherited Methods from cStatusPanel
Activate | Procedure |
Deactivate | Procedure |
ProcessEvents | Procedure |
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cProgressBar

Properties Events Methods Index of Classes

Indicates the progress within a range

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------cWinControl
---------------------cProgressBar

Library: Windows Application Class Library

Package: cProgressBar.pkg

Description

A typical usage might be to show the progress being made through a batch process of record updates.

You set the range of the progress with piMinimum and piMaximum. The actual position within the range is governed by the piPosition property, which you can set manually, or automatically by sending either the DoAdvance or DoAdvanceBy methods.

The position is indicated with a bar that is drawn to reflect the percentage of completion. The bar can be drawn vertically or horizontally, using the pbVertical property, and it can be drawn segmented or smooth by using the pbSmooth property.

The color of the bar is controlled by the piBarColor property and the color of the background with the piBackColor property.

Sample

Use cProgressBar.pkg

Object oProgressBar is a cProgressBar
    Set Size To 14 60
    Set Location to 30 30
    Set piMinimum To 0
    Set piMaximum To 100
End_Object

Object oProgressButton is a Button
    Procedure OnClick
         // increment piPosition by piAdvanceBy
        Send DoAdvance of oProgressBar
    End_Procedure
End_Object

Object oProgressByButton is a Button
    Procedure OnClick
         // increment piPosition by 5
        Send DoAdvanceBy of oProgressBar 5
    End_Procedure
End_Object

See Also

TrackBar

Last Edited: November 21, 2004


Properties for cProgressBar

View property list in alphabetical order

Name | Description
pbSmooth | Determines whether the progress bar will be drawn as a smooth, contiguous bar or a segmented bar
pbVertical | Determines whether to display the progress bar vertically or horizontally
piAdvanceBy | Stores the amount that the progress bar will increment by each time it is advanced
piBackColor | The background color of the progress bar
piBarColor | The color of the progress bar
piMaximum | The value that represents 100 percent of the range the progress bar covers
piMinimum | Maintains the value that represents zero percent of the range the progress bar covers
piPosition | The current position of the progress within the progress bar
Inherited Properties from cWinControl
pbEnabled | Enables the control to take user input
pbVisible | Makes a control visible or invisible
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cProgressBar

View event list in alphabetical order

Name | Description
Inherited Events from cWinControl
OnMouseDoubleClick | Received whenever a mouse button is double-clicked on the control
OnMouseDown | Received whenever a mouse button is pressed on the control
OnMouseMove | Received whenever the mouse cursor moves over a control
OnMouseUp | Received whenever a mouse button is released on the control
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cProgressBar

View method list in alphabetical order

Name | Type | Description
DoAdvance | Procedure | Advances the progress bar by the amount stored in piAdvanceBy
DoAdvanceBy | Procedure | Advances the progress bar by an explicit amount
Inherited Methods from cWinControl
DoRecreateWindow | Procedure | Recreates a window
DoUpdateWindow | Procedure | Updates a window if it needs repainting
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cRegistry

Properties Events Methods Index of Classes

Provides access to the Windows system Registry

Hierarchy

cObject
---cRegistry

Library: Common (Windows and Web Application) Class Library

Package: cRegistry.pkg

Description

The Registry is a database that an application can use to store information. The Registry stores information in a hierarchical tree, with each node of the tree referred to as a Key. Each Key can contain other Keys, referred to as Subkeys, and application data. The data is contained in Values.

All Keys that an application creates, opens, reads, or writes are Subkeys of predefined root Keys. By default, a cRegistry object is created with a root key of HKEY_CURRENT_USER.

A Key can contain an unlimited number of Subkeys and Values.

To access Values or Subkeys, you must first open or create a Key. When you have finished accessing the Subkeys or Values, you must close the Key.

Each object of cRegistry can only access one Key at a time. Therefore, you must close the current Key before opening another Key.

To create a Key, use CreateKey; to open a Key, use OpenKey; and to delete a Key, use the DeleteKey method. To determine the root branch of the Registry that these methods operate on, use the phRootKey property. You can discover how many Subkeys there are of a Key with the CountOfSubkeys method, and you can enumerate them using the GetSubkeys method. To determine whether a Key exists, use the KeyExists method.

You can write Values to the open Key using WriteDword, WriteString and WriteBinary, which write dword, string and binary data respectively. You can read the Values back using ReadDword, ReadString and ReadBinary. You can discover how many Values there are with CountOfValues and you can enumerate them with GetValues. To determine whether a Value already exists, use ValueExists . To determine the datatype of a Value, use the ValueType method. You can delete a Value with DeleteValue.

When you have finished accessing a Key, you should close it with CloseKey. For performance, Windows can delay committing your changes, but you can force Windows to commit the changes when you close the Key by setting the pbLazyWrite property to False.

When you open or create a Key, you can determine the type of access that you want. So, for example, if you only want to read a Key, you can set the access to read-only. This can be necessary when you are accessing Keys that will not grant you write privileges. To change the access privileges, use the pfAccessRights property.

When a Key is opened, the phCurrentKey property is set to the handle that Windows refers to the Key by. Generally, you will not use this property. However, as the cRegistry is a wrapper to the Windows Registry, you can use this handle to communicate with the Windows API.

Each Key has a special Value, called the "Default Value". This Key does not have a name; to access it, you will need to provide a null string as the Value name in any function that requires the name of a Value.

See Also

cIniFile

Last Edited: April 28, 2005


Properties for cRegistry

View property list in alphabetical order

Name | Description
pbLazyWrite | Determines when Windows flushes any writes to the Registry
pfAccessRights | Specifies the level of access when opening and creating Keys
phCurrentKey | The Windows handle of the Key
phRootKey | Specifies the root branch of the Registry to use
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cRegistry

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cRegistry

View method list in alphabetical order

Name | Type | Description
CloseKey | Procedure | Closes a Registry Key
CountOfSubkeys | Function | Returns the number of Subkeys for the Key that is currently open
CountOfValues | Function | Returns the number of Values that exist for the Key that is currently open
CreateKey | Function | Adds a new Key to the Registry
DeleteKey | Function | Deletes a Key from the Registry
DeleteValue | Function | Deletes a Value from a Key in the Registry
GetSubkeys | Function | Retrieves the names of all Subkeys belonging to the open Key
GetValues | Function | Retrieves the names of all Values belonging to the open Key
KeyExists | Function | Determines whether a Key exists
LongestDataLength | Function | Returns the length of the longest data in all Values for the currently open Key
LongestSubkeyLength | Function | Returns the length of the longest Subkey name for the currently open Key
LongestValueLength | Function | Returns the length of the longest Value name for the currently open Key
OpenKey | Function | Opens a Registry Key for access
ReadBinary | Function | Reads a binary Value from the currently open Key
ReadDword | Function | Use ReadDword to read a Dword Value from the currently open Key
ReadString | Function | Read a string from a Key in the Registry
ValueExists | Function | Tests whether a named Value exists in the open Key
ValueLength | Function | Returns the length of the data for a named Value of the currently open Key
ValueType | Function | Returns the data type for the named Value of the currently open Key
WriteBinary | Procedure | Writes a Binary Value into the currently open Key of the Registry
WriteDword | Procedure | Writes Dword data to the Registry
WriteString | Procedure | Writes a string into the Registry
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cRemoteEntryProcess

Class: cRemoteEntryProcess (Abstract)

Properties Events Methods Index of Classes

Abstract class used to create Web Browser Process objects

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cDistributedBusinessProcess
------cRemoteEntryProcess
---------cInternetSessionBusinessProcess

Library: Web Application Class Library

Package: cRemoteEntryProcess.pkg

Mixins: RemoteEntryMixin

Description

cRemoteEntryProcess is an abstract class used for creating Web Browser Process objects. Its sub-class cWebBusinessProcess should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for cRemoteEntryProcess

View property list in alphabetical order

Name | Description
pbAllowClear | Determines whether the WBO object will support the Clear operation
pbAllowDDUpdate | Determines whether the WBO object will support update operations to the DataDictionary
pbAllowDelete | Determines whether the WBO object will support the Delete operation
pbAllowFind | Determines whether the WBO object will support the Find operation
pbAllowSaveEdit | Determines whether the WBO object will support an edit Save operation
pbAllowSaveNew | Determines whether the WBO object will support a new Save operation
pbClearAfterSave | Determines what should happen after a successful save
pbReportErrors | Suppresses the automatic generation of errors when set false
peFieldMultiUser | Determines if the data submitted by a web application browser should report changes at the field level
phREO_MainDD |
piREO_OperationStatus |
Inherited Properties from cDistributedBusinessProcess
Main_dd | Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function
pbClearDDOsOnDetach |
pbShowEntryError |
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cRemoteEntryProcess

View event list in alphabetical order

Name | Description
OnReportClearStatus | After a clear operation, augments point to handle whatever additional processing is required
OnReportDeleteStatus | After a delete operation, augmentats point to handle whatever additional processing is required
OnReportFindStatus | After a find operation, augments point to handle whatever additional processing is required
OnReportSaveStatus | After a save operation, augments point to handle whatever additional processing is required
OnReportValidateStatus | After an update operation, augments point to handle whatever additional processing is required
Inherited Events from cDistributedBusinessProcess
OnAttachProcess | When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object
OnDetachProcess | When process pooling is used, this event is sent first to the WebApp object and then to every WBO object
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cRemoteEntryProcess

View method list in alphabetical order

Name | Type | Description
ClearConfirmation | Function |
DeleteConfirmation | Function |
DoRequestClear | Function | Generates a remote clear process
DoRequestDDUpdate | Function | Provides another way to build the WBO's data dictionary structure based on information passed from the browser
DoRequestDelete | Function | Generates a remote delete process
DoRequestFind | Function | Performs a field find for the passed file name, field name and find mode
DoRequestSave | Function | Generates a remote save process
SaveConfirmation | Function |
Inherited Methods from cDistributedBusinessProcess
ClearErrors | Procedure | Clears the error queue
ErrorCount | Function | Returns the number of errors in the current error queue
ErrorQueueEnd | Procedure | Ends an error queue process
ErrorQueueStart | Procedure | Starts an error queue process
LogEvent | Procedure | Logs an event to the Web Application's event log
MapFileNametoDD | Function |
MaptoFieldNumber | Function |
MaptoFileNumber | Function |
ReportAllErrors | Procedure | Generates a list of all errors that have occurred since this error queue was last cleared
ReportErrorItem | Procedure | Displays the error for iItem in the error queue
ReportLastError | Procedure | Displays the last error in the error queue
RequestFileFieldValues | Procedure |
RequestFileRecords | Procedure |
Search_Field_Name | Function |
Search_File_Name | Function |
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cReport

Class: cReport (Abstract)

Properties Events Methods Index of Classes

Abstract low level Report Class

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cReport
------cReportDS

Library: Web Application Class Library

Package: cReport.pkg

Description

The cReport class is used to create reports.This abstract class is used by the sub-classes cWebReport and cWmlReport to generate HTML and WML Web application reports.

This class provides basic reporting capabilities. Sub-class layers will be added to this report to add DDO support (cReportDS), HTML support (cHtmlReport), WebApp Html Broswer support (cWebReport) and Web application WAP support (cWmlReport)

This class was modeled after the Report class. It has the same capabilities with an interface that is "more up to date". It was created for Web application usage but could be used with Windows applications.

Last Edited: November 21, 2004


Properties for cReport

View property list in alphabetical order

Name | Description
Assigned_Channel |
Find_Mode | Maintains the current finding mode
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function
Last_Rec | (Obsolete) Contains the record number of the last selected record found
Main_File | Contains the filenumber of the file which the report will use for finding records
New_Page_State | Set true when a new page is needed
No_Constrained_Find_State | Determines if constrained record finding should be disabled
No_Finding_State | Determines how the cReport object will find records
No_PageCheck_State | Set true when the cReport object is processing a new page
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found
Page_Count | Keeps track of the current page number
Page_End | Determines how many lines on a page are allowed before a page break will occur
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence
Page_Feed | Used by the formfeed procedure
Page_Footer_Lines | The number of lines in the page_footer image
pbCanceled | Setting this true will cancel a report
pbChildReport | Set true if the current cReport object is nested
pbFindDown | Determines if the report should traverse up or down the index
pbHasChildReports | Is set true if other reports are nested inside this report object
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level
phMainReport | Contains the object ID of the outer report
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found
piNumberBreaks | Returns the number of breaks in a report
piOrdering | Contains the index number which will be used for finding records
piRecordCount | Contains the number of records found for the current report
priCurrentRec | Contains the RowId of the current valid record found
priFoundRec | Contains the RowId of the record found by the find_rec function
priLastRec | Contains the RowId of the last selected record found
Report_Channel | Determines which output channel will be used for your report output
Report_Footer_Lines | The number of lines in the OnReportFooter image
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cReport

View event list in alphabetical order

Name | Description
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property
Final_Formfeed |
OnBody | Called every time a valid record has been found
OnConstrain |
OnEndingMainReport | Sent by the report object only if the current report is the outer report (it has no parent-its pbChildReport is false)
OnEndingReport | Called at the end of all reports
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables
OnPageFooter | Printed after OnPageTotal on every page except the last page
OnPageHeader | Called after OnPageTop on every new page except the first
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader.
OnPageTop | Called when printing the top of every report
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page
OnReportFooter | Printed after OnPageTotal on the last page of the report
OnReportHeader | Called only on the first page of the report, after OnPageTop
OnSelection | Validates a record
OnStartingMainReport | Called when a report is started
OnStartingReport | Called when a report is started
OnSubHeader1..n | Called each time a subheader needs to be printed
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program
OnSubTotal1..n | Called when a subtotal needs to be processed
OnTotal | Called at the end of a report after all final sub-totals have been printed
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cReport

View method list in alphabetical order

Name | Type | Description
DoRunReport | Function | The main entry point for reportsT
Formfeed | Procedure | Handles formfeeds
Output_ImageNum | Procedure | Outputs the image represented by ImageNum
WriteLn | Procedure | Outputs the string message to the current output channel
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cReportDS

Class: cReportDS (Abstract)

Properties Events Methods Index of Classes

Abstract Reporting with a DDO support layerclass

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cReport
------cReportDS
---------cBasicReport

Library: Web Application Class Library

Package: cReportDS.pkg

Description

The cReportDS class is used to create reports.This abstract class is used by the sub-classes cWebReport and cWmlReport to generate HTML and WML Web application reports.

This class takes the capbilities of the cReport class and adds an interface layer to support DDOs.

This class was modeled after the Report_DS class. It has the same capabilities with an interface that is "more up to date". It was created for Web application usage but could be used with Windows applications.

Last Edited: November 21, 2004


Properties for cReportDS

View property list in alphabetical order

Name | Description
Server | Identifies the object handle that is used as the report object's main data-dictionary object
Inherited Properties from cReport
Assigned_Channel |
Find_Mode | Maintains the current finding mode
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function
Last_Rec | (Obsolete) Contains the record number of the last selected record found
Main_File | Contains the filenumber of the file which the report will use for finding records
New_Page_State | Set true when a new page is needed
No_Constrained_Find_State | Determines if constrained record finding should be disabled
No_Finding_State | Determines how the cReport object will find records
No_PageCheck_State | Set true when the cReport object is processing a new page
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found
Page_Count | Keeps track of the current page number
Page_End | Determines how many lines on a page are allowed before a page break will occur
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence
Page_Feed | Used by the formfeed procedure
Page_Footer_Lines | The number of lines in the page_footer image
pbCanceled | Setting this true will cancel a report
pbChildReport | Set true if the current cReport object is nested
pbFindDown | Determines if the report should traverse up or down the index
pbHasChildReports | Is set true if other reports are nested inside this report object
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level
phMainReport | Contains the object ID of the outer report
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found
piNumberBreaks | Returns the number of breaks in a report
piOrdering | Contains the index number which will be used for finding records
piRecordCount | Contains the number of records found for the current report
priCurrentRec | Contains the RowId of the current valid record found
priFoundRec | Contains the RowId of the record found by the find_rec function
priLastRec | Contains the RowId of the last selected record found
Report_Channel | Determines which output channel will be used for your report output
Report_Footer_Lines | The number of lines in the OnReportFooter image
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cReportDS

View event list in alphabetical order

Name | Description
Inherited Events from cReport
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property
Final_Formfeed |
OnBody | Called every time a valid record has been found
OnConstrain |
OnEndingMainReport | Sent by the report object only if the current report is the outer report (it has no parent-its pbChildReport is false)
OnEndingReport | Called at the end of all reports
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables
OnPageFooter | Printed after OnPageTotal on every page except the last page
OnPageHeader | Called after OnPageTop on every new page except the first
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader.
OnPageTop | Called when printing the top of every report
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page
OnReportFooter | Printed after OnPageTotal on the last page of the report
OnReportHeader | Called only on the first page of the report, after OnPageTop
OnSelection | Validates a record
OnStartingMainReport | Called when a report is started
OnStartingReport | Called when a report is started
OnSubHeader1..n | Called each time a subheader needs to be printed
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program
OnSubTotal1..n | Called when a subtotal needs to be processed
OnTotal | Called at the end of a report after all final sub-totals have been printed
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cReportDS

View method list in alphabetical order

Name | Type | Description
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO
Request_Save | Procedure | If sent, this saves the current record
Inherited Methods from cReport
DoRunReport | Function | The main entry point for reportsT
Formfeed | Procedure | Handles formfeeds
Output_ImageNum | Procedure | Outputs the image represented by ImageNum
WriteLn | Procedure | Outputs the string message to the current output channel
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cRichEdit

Properties Events Methods Index of Classes

Allows the user to enter and edit RTF (rich-text format) text

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DFBaseRichEdit
---------------------cRichEdit
------------------------cDbRichEdit_

Library: Windows Application Class Library

Package: cRichEdit.pkg

Mixins: cEdit_Mixin Standard_Object_Mixin Dflabel_Mixin Shadow_Mixin RGB_Support_Temp_Mixin Help_Mixin

Description

The cRichEdit class allows the user to enter and edit text while also providing more advanced formatting features than the plain-text cTextEdit class.

The cDbRichEdit class is a data-aware class similar to the cRichEdit class.
The cTextEdit class is a plain-text class similar to the cRichEdit class.

The default maximum number of characters for the control is 64 KB (65536 bytes or characters). This can be changed or retrieved via piMaxChars.

A linefeed (LF) character can be added to text programmatically by adding ASCII character 10 to a string using the character function. A carriage return (CR) character can be added to text programmatically by adding ASCII character 13 to a string using the character function. Either a LF or CR character will break the current line in the control. Also see AppendTextLn.

Sample

Object oRichEdit1 is a cRichEdit
    Set Size to 168 276
    Set Location to 6 10
    Set peAnchors to anAll
End_Object    // oRichEdit1

Syntax

Use cRichEdit.pkg

Object oObjectName is a cRichEdit
    Set Size to iHeight iWidth
    Set Location to iRow iColumn

    Set Label to sLabelText
    Set Label_Justification_Mode to jMode
    Set Label_Row_Offset to iOffset
    Set Label_Col_Offset to iOffset

    Set Status_Help to sStatusHelpText
    Set Enabled_State to True | False
End_Object  // oObjectName

Text Formatting

An application can send messages to a rich edit control to format characters and paragraphs to retrieve formatting information. Paragraph formatting attributes include alignment, tabs, indents, numbering, and simple tables. For characters, you can specify font name, size, color, and effects such as bold, italic, and protected.

The character formatting of the insertion point is applied to newly inserted text only if the current selection is empty (if the current selection is an insertion point). Otherwise, the new text assumes the character formatting of the text it replaces. If the selection changes, the default character formatting changes to match the first character in the new selection.

Current Selection in a Rich Edit Control

The user can select text in a rich edit control by using the mouse or the keyboard. The current selection is the range of selected characters, or the position of the insertion point if no characters are selected. An application can get information about the current selection, set it, determine when it changes, and show or hide the selection highlight.

Word and Line Breaks

A rich edit control calls a function called a word-break procedure to find breaks between words and to determine where it can break lines. The control uses this information when performing word-wrap operations and when processing CTRL+LEFT ARROW key and CTRL+RIGHT ARROW key combinations. An application can send messages to a rich edit control to replace the default word-break procedure, to retrieve word-break information, and to determine what line a given character falls on.

Rich Edit Shortcut Keys

Rich edit controls support the following shortcut keys.

Keys | Operations | Comments
Shift+Backspace | Generate a LRM/LRM on a bidi keyboard | BiDi specific
Ctrl+Tab | Tab |
Ctrl+Clear | Select all |
Ctrl+Number Pad 5 | Select all |
Ctrl+A | Select all |
Ctrl+E | Center alignment |
Ctrl+J | Justify alignment |
Ctrl+R | Right alignment |
Ctrl+L | Left alignment |
Ctrl+C | Copy |
Ctrl+V | Paste |
Ctrl+X | Cut |
Ctrl+Z | Undo |
Ctrl+Y | Redo |
Ctrl+'+' (Ctrl+Shift+'=') | Superscript |
Ctrl+'=' | Subscript |
Ctrl+1 | Line spacing = 1 line. |
Ctrl+2 | Line spacing = 2 lines. |
Ctrl+5 | Line spacing = 1.5 lines. |
Ctrl+' (apostrophe) | Accent acute | After pressing the short cut key, press the appropriate letter (for example a, e, or u). This applies to English, French, German, Italian, and Spanish keyboards only.
Ctrl+` (grave) | Accent grave | See Ctrl+' comments.
Ctrl+~ (tilde) | Accent tilde | See Ctrl+' comments.
Ctrl+; (semicolon) | Accent umlaut | See Ctrl+' comments.
Ctrl+Shift+6 | Accent caret (circumflex) | See Ctrl+' comments.
Ctrl+, (comma) | Accent cedilla | See Ctrl+' comments.
Ctrl+Shift+' (apostrophe) | Activate smart quotes |
Backspace | If text is protected, beep and do not delete it. Otherwise, delete previous character. |
Ctrl+Backspace | Delete previous word. This generates a VK_F16 code. |
F16 | Same as Backspace. |
Ctrl+Insert | Copy |
Shift+Insert | Paste |
Insert | Overwrite | DBCS (double-byte character set) does not overwrite.
Ctrl+Left Arrow | Move cursor one word to the left. | On bidi keyboard, this depends on the direction of the text.
Ctrl+Right Arrow | Move cursor one word to the right. | See Ctrl+Left Arrow comments.
Ctrl+Left Shift | Left alignment | In BiDi documents, this is for left-to-right reading order.
Ctrl+Right Shift | Right alignment | In BiDi documents, this is for right-to-left reading order.
Ctrl+Up Arrow | Move to the line above. |
Ctrl+Down Arrow | Move to the line below. |
Ctrl+Home | Move to the beginning of the document. |
Ctrl+End | Move to the end of the document. |
Ctrl+Page Up | Move one page up. | If in SystemEditMode and Single Line control, do nothing.
Ctrl+Page Down | Move one page down. | See Ctrl+Page Up comments.
Ctrl+Delete | Delete the next word or selected characters. |
Shift+Delete | Cut the selected characters. |
Esc | Stop drag-drop. | While doing a drag-drop of text.
Alt+Esc | Change the active application. |
Alt+X | Converts the Unicode hexadecimal value preceding the insertion point to the corresponding Unicode character. |
Alt+Shift+X | Converts the Unicode character preceding the insertion point to the corresponding Unicode hexadecimal value. |
Alt+0xxx (Number Pad) | Inserts Unicode values if xxx is greater than 255. When xxx is less than 256, ASCI range text is inserted based on the current keyboard. | Must enter decimal values.
Alt+Shift+Ctrl+F12 | Hex to Unicode. | In case Alt+X is already taken for another use.
Ctrl+Shift+A | Set all caps. |
Ctrl+Shift+L | Change bullet style. |

Last Edited: April 25, 2005


Properties for cRichEdit

View property list in alphabetical order

Name | Description
Changed_State | Determines whether the content of the control has changed
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DFBaseRichEdit
Line_Count | Returns number of lines in control
paValue | Sets content of control from memory address or places RTF stream in control into memory address
pbAutoUrl | Toggles the ability for the control to automatically detect URLs and add hyperlinks
pbBold | Toggles selected text between bold and normal text
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard
pbCanRedo | Determines whether a redo operation can be performed
pbCanUndo | Determines whether an undo operation can be performed
pbItalics | Toggles selected text between italicized and normal text
pbLink | Toggles selected text between hyperlinked and normal text
pbProtect | Toggles selected text between protected and normal text
pbStrikeOut | Toggles selected text between strikeout and normal text
pbSubScript | Toggles selected text between subcripted and normal text
pbSuperScript | Toggles selected text between superscripted and normal text
pbUnderline | Toggles selected text between underlined and normal text
pbWrap | Determines whether text input will break and wrap to the next line at right margin
peAlignment | Sets or returns alignment of selected paragraph or paragraphs
peBullets | Sets or returns bullets or numbering of selected paragraph or paragraphs
peBulletStyle | Sets or returns numbering styles of selected paragraph or paragraphs
peCharSet | Sets or returns character set of selected text
peLineSpacingType | Determines type of line spacing of selected paragraph or paragraphs
pePitchandFamily | Sets or returns the font pitch and family of selected text
piBulletStart | Sets or returns the starting number of paragraph numbering of selected paragraph or paragraphs
piBulletTab | Sets or returns the minimum space between a paragraph bullet or number and the paragraph text of selected paragraph or paragraphs
piFontSize | Sets or returns font size of selected text
piFontWeight | Sets or returns font weight of selected text
piLineSpacing | Determines exact line spacing of selected paragraph or paragraphs
piMaxChars | Sets or returns maximum number of characters
piOffsetIndent | Sets or returns indentation of 2nd and subsequent lines, relative to first line, of selected paragraph or paragraphs
piParagraphIndent | Sets or returns indentation of selected paragraph or paragraphs
piRightMargin | Determines indentation of right side of control's text, relative to the right margin
piSpacingAfter | Determines the spacing below selected paragraph or paragraphs
piSpacingBefore | Determines the spacing above selected paragraph or paragraphs
psTypeFace | Sets or returns font typeface of selected text
Read_Only_State | Determines whether users may edit the content of the control
TextBackColor | Sets or returns background color of selected text
TextColor | Sets or returns color of selected text
Value | Sets or returns content of control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cRichEdit

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Fires whenever the value of the control is changed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText | Fires when maximum text size is exceeded
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Fired whenever a change in enabled state occurs
Inherited Events from DFBaseRichEdit
OnLinkClicked | Fires when hyperlink in text is clicked
OnSelectionChanged | Fires when selection changes
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cRichEdit

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
ToggleBold | Procedure | Toggles selected text between bold and normal text
ToggleItalics | Procedure | Toggles selected text between italicized and normal text
ToggleUnderline | Procedure | Toggles selected text between underlined and normal text
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DFBaseRichEdit
AppendText | Procedure | Appends text to end of text in control
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control
Beginning_of_Line | Procedure | Places the cursor at beginning of current line
CharCount | Function | Returns length of RTF stream in the control
ClearUndoBuffer | Procedure | Clears undo buffer
Delete_Data | Procedure | Deletes all data in control
End_of_Data | Procedure | Places the cursor at end of the text in control
End_of_Line | Procedure | Places the cursor at end of current line
FindText | Function | Searches for specified text in control
FirstCharInLinePos | Function | Returns position of first character in a line
FirstVisibleLine | Function | Returns number of first visible line
HideSelection | Procedure | Toggles selection highlighting on or off
LastErrorCode | Function | Returns error code for last operation
Line | Function | Returns specified line of text
LineFromChar | Function | Returns number of line that contains specified character position or current line
LineLength | Function | Returns number of characters in line
Read | Procedure | Reads RTF document and displays it in the control
Redo | Procedure | Redoes the last operation
RedoType | Function | Returns type of redo operation at top of redo queue
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements
ReplaceSel | Procedure | Replaces selected text with specified text
Scroll | Procedure | Scrolls up or down the control using specified scroll mode
ScrollCaret | Procedure | Scrolls caret into view
ScrollLines | Procedure | Scrolls control vertically for specified number of lines
Select_All | Procedure | Selects entire contents of control
SelEnd | Function | Returns end of selection
SelStart | Function | Returns beginning of selection
SelText | Function | Returns selected text
SetSel | Procedure | Selects text in given position range
TextRange | Function | Returns text in given position range
Undo | Procedure | Undoes the last operation
UndoType | Function | Returns type of undo operation at top of undo queue
Write | Procedure | Writes RTF stream content of control to file
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: CrystalReport

Properties Events Methods Index of Classes

Enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports

Hierarchy

cObject
---CrystalReport

Library: Windows Application Class Library

Package: CrystalReport.pkg

Description

The CrystalReport class enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports.

Usage

Object oCustomerReport is a CrystalReport
    Set Report_Name To "CustRpt.rpt"

    Procedure OnInitializeReport
        Forward Send OnInitializeReport
        Set SelectionFormula To ;
            "{wines.YEAR} <90 and {wines.COST} >6 and {wines.QUANTITY} >2"
    End_Procedure // OnInitializeReport
End_Object // oCustomerReport

Using The CrystalReport Class

Creating Crystal Reports for Visual DataFlex

When you create a Crystal Reports report, you need to make sure that the report and the report's tables can be found by your VDF program. When creating a Crystal Reports report, we make the following recommendations:

  • Use Runtime Workspaces. This is the default behavior for a Studio-created VDF program.
  • Place your Crystal Reports reports in the workspace's Data directory (e.g., \VDF\Order\Data).
  • When you create your Crystal Report reports, specify the locations of your tables to be the Same as Report. This option is set from the Database/Set Location menu in Crystal Reports. This instructs Crystal Reports to look for the tables in the same directory where the Crystal Reports report is located.

If the above steps are followed, VDF will locate report definitions and tables automatically.

Output Destinations

This package allows you to output your report to a printer or a preview window, or export it to a file or MAPI. You may select a print destination by setting the output_destination property to one of five predefined constants. If the value of this property is PRINT_TO_UNDEFINED (the default) and this object is in a report view or report panel (i.e., the Report_View_Id property is set), it will use this container's output_device_mode. If this is undefined, output will be to the printer.

Output to Window

If a preview window is specified as the output destination, the following properties can be used to control the appearance of the output window. WindowTitle holds the string that will appear on the title bar. The properties WindowLeftCoordinate and WindowTopCoordinate control the position of the preview window. Furthermore, WindowWidth and WindowHeight control the size of the preview window. You can control the style of the window using the WindowStyle-refer to the WindowStyle property for a complete list of possible values. The property ParentWindowHandle controls whether the preview window is to be created as a top-level window (a window without a parent) or a child window.

Object oMyReport is a CrystalReport
    Set Report_Name To "wines1.rpt"
    Set Output_Destination To CRW_PRINT_TO_WINDOW
    Set WindowTitle To "This is my report"
    Set WindowWidth To 500
    Set WindowHeight To 300
End_Object // oMyReport

Output to Printer

If you print to a printer, you may specify the number of copies by setting the property Copies to the desired number. Crystal Reports uses the following logic in determining to which printer the output is to be sent:

  • If a printer has been specified via the SelectPrinter function, output will be sent to that printer.
  • If there is no SelectPrinter selection but there is a printer specified in the report, output will be sent to that printer.
  • If there is no SelectPrinter selection, and there is no printer specified in the report, output will be to the Windows default printer.

Object oMyReport is a CrystalReport
    Set Report_Name To "wines1.rpt"
    Set Output_Destination To CRW_PRINT_TO_PRINTER
    Set Copies To 1
End_Object // oMyReport

Export to Disk

When exporting to disk, there are a number of properties that you may use to control the export format and the filename created. The property ExportFormatType determines the type of file created during the export. For a complete list of export format types, refer to the ExportFormatType property.

The UseReportNumberFormat_State and UseReportDateFormat_State instruct the package to use the number and date formats used in the report, if set to true. Otherwise, the types are optimized for the export format type. There are also two properties that hold the string and field delimiters. These are used when exporting using a character-delimited format.

The last property is the ExportFileName property. This property can hold the filename to be created. This filename may contain drive and path names. You should check if the file already exists, if the file exists an error will be generated. If you choose not to set the ExportFileName property, you will be prompted to supply a filename. If the supplied file exists, you will be prompted to overwrite it.

The following code will set up the object to export to Word format.

Object oCustomerReport is a CrystalReport
    Set Report_Name To "CustRpt.rpt"
    Set Output_Destination To CRW_PRINT_TO_FILE
    Set ExportFileName To "CustRpt.doc"
    Set ExportFormatType To CRW_WordWinType
End_Object // oCustomerReport

The following code will set up the object to export to PDF format.

Object oCustomerReport is a CrystalReport
    Set Report_Name To "CustRpt.rpt"
    Set Output_Destination To CRW_PRINT_TO_FILE
    Set ExportFileName To "CustRpt.pdf"
    Set ExportFormatType To CRW_AcrobatType
End_Object // oCustomerReport

Export to MAPI

This package allows you to export to MAPI (Mail API). The export to MAPI procedure uses the same export format type properties as the export to disk procedure. The ToList property specifies the e-mail destination addresses. If you have a mail program, for example MS Exchange, installed on your machine, you may specify an entry from the address book. Multiple addresses should be separated by semi-colons. The CCList property specifies the list to which you want your e-mail message copied. The SubjectText and MessageText properties can be used to supply a subject and a message body for your e-mail. The report itself will be inserted as a file (with the format you have specified) into your e-mail. If you supply a FAX address, you must make sure that the export format type that you have specified has an accompanying program. That is, you must make sure that MS Word is installed on your machine if you specify Word as the export format type. If you don't supply an e-mail address in the ToList property, you will be prompted for one.

Object oMyReport is a CrystalReport
    Set Report_Name To "wines1.rpt"
    Set Output_Destination To CRW_PRINT_TO_MAPI
    Set ExportFormatType To CRW_WordWinType
    Set ToList To ;
        "info@dataaccess.nl;info@dataaccess.com"
    Set SubjectText To "latest info"
    Set MessageText To "We hereby mail you the lastest info."
End_Object  // oMyReport

Object oMyReport is a CrystalReport
    Set Report_Name To "wines1.rpt"
    Set Output_Destination To PRINT_TO_MAPI
    Set ExportFormatType To CRW_WordWinType
    Set ToList To "fax:074-2503466"
    Set SubjectText To "latest info"
    Set MessageText To "We hereby fax you the lastest info."
End_Object // oMyReport

Sort Fields

You may change, delete, or add sort fields of a Crystal Reports report from VDF. Sort fields determine the sort order of a Crystal Reports report. Sort fields are accessed by number, and are zero-based. Thus, the first sort field is numbered 0, the second, 1, etc. Also, you can specify the sort direction of every sort field. Since the names of database fields in Crystal Reports are enclosed by braces, you must supply the braces if you wish to add a sort field.

Object oMyReport is a CrystalReport
    Set Report_Name To "wines1.rpt"

    Procedure OnInitializeReport
        Integer iSortFields iCounter

        Forward Send OnInitializeReport

        // Delete all sort fields except for the first,
        // and then add a sort field.
        Get NSortFields To iSortFields
        Move 1 To iCounter // We want to keep the first sort field
        While iCounter Lt iSortFields
            Send DeleteNthSortField iCounter
            Increment iCounter
        End // While iCounter Lt iSortFields
        Send AddSortField "{wine.year}" PE_SF_ASCENDING
    End_Procedure // OnInitializeReport

End_Object // oMyReport

Group-Sort Fields

As with sort fields, you may change, delete, or add group-sort fields. Group-sort fields define the sort order in a group. Group-sort fields can only be specified by number and are 0-based.

Formulas

With Crystal Reports you can create formulas. A formula is a symbolic statement according to which data can be manipulated before it is printed. Crystal Report formulas can be accessed in two ways. First, you may access a formula by name. This requires you to have some knowledge of the report you are running from VDF. In Crystal Reports, formulas are identified by the "@" sign in front of the formula name. If you access a formula by name from VDF, you don't need to supply the "@" sign. You cannot add a formula to the Crystal Reports report from VDF.

Object oMyReport is a CrystalReport
    Set Report_Name To "wines1.rpt"

    Procedure OnInitializeReport
        Forward Send OnInitializeReport

        // Don't supply the "@" sign with the formula name.
        Set Formula "ext_price" to "{wines.QUANTITY} * {wines.COST}"
    End_Procedure // OnInitializeReport

End_Object // oMyReport

The second method for accessing formulas is by number. Formula numbers are zero-based, thus the first formula is numbered 0, the second, 1, etc. This method of accessing formulas doesn't require any knowledge of the report.

Object oMyReport is a CrystalReport
    Set Report_Name To "wines1.rpt"

    Procedure OnInitializeReport
        Integer iNFormulas iCounter bResult
        String sFormulaName

        // Check all formulas in the report.
        Move 0 To iCounter // Start with first formula
        Get NFormulas To iNFormulas // Get the number of formulas
        While (iCounter < iNFormulas) Begin
            Get NthFormulaName iCounter To sFormulaName
            Get CheckFormula sFormulaName To bResult
            If Not (bResult) ;
                Send Stop_Box ("Error in formula: " +sFormulaName)
            Increment iCounter
        End // While iCounter Lt iNFormulas
    End_Procedure // OnInitializeReport

End_Object // oMyReport

Selection Formulas

A selection formula is used to determine which records should be printed in your report. Crystal Reports will test every record in a file against the selection formula to determine if it should be printed. You may set a selection formula from VDF. If a selection formula exists in your report definition, it will be overridden.

Object oMyReport is a CrystalReport
    Set Report_Name To "wines1.rpt"

    Procedure OnInitializeReport
        String sSelectionFormula

        Get SelectionFormula To sSelectionFormula
        // If the selection formula already contains some selection,
        // we will `and' them together.
        // We're only interested in the old wines.
        If (Trim(sSelectionFormula) > "") ;
            Append sSelectionFormula " and "
            Append sSelectionFormula " {wines.year} <1980"
        Set SelectionFormula To sSelectionFormula
    End_Procedure // OnInitializeReport

End_Object // oMyReport

Group-Selection Formulas

A group-selection formula is similar to a selection formula. It is used to determine if a group should be printed. You may set a group-selection formula from VDF. If a group-selection formula exists in your report definition, it will be overridden.

Global Conversion Functions

In order for the link to the CrystalReport DLL to work, we need to convert Visual DataFlex types to CrystalReport types. These conversions are supplied by four global conversion functions. The conversion functions are considered private. All functions accept a Visual DataFlex type and return the CrystalReport counterpart.

WinQL_Date

Obsolete: Use the CrystalDate function instead.
Function
Parameters:
Date dVal
The Visual DataFlex Date to convert
Returns: String
Convert the Date to a String.

WinQL_Integer

Obsolete: Use the CrystalInteger function instead.
Function
Parameters:
Integer iVal
The Visual DataFlex Integer to convert
Returns: String
Convert the Integer to a String.

WinQL_Number

Obsolete: Use the CrystalNumber function instead.
Function
Parameters:
Number nVal
The Visual DataFlex Number to convert
Returns: String
Convert the Number to a String.

WinQL_String

Obsolete: Use the CrystalString function instead.
Function
Parameters:
String sVal
The Visual DataFlex String to convert.
Returns: String
Places the Visual DataFlex String in double quotes (").

Last Edited: December 16, 2004


Properties for CrystalReport

View property list in alphabetical order

Name | Description
BottomMargin | Sets the bottom page margin in twips
CCList | Contains the "CC" list for the e-mail message
Collation | Specifies how copies of the report, when printing multiple copies, must be collated
Copies | Specifies the number of copies you want Crystal Reports to print when printing to a printer
CurrentDataPath | Returns the location of the current workspace's data directory
DiscardSavedData_State | Forces the print engine to retrieve new data when the report is printed
DisplayPageN | Returns the number of the currently displayed page
DLLVersion | Retrieves the version number of the print engine DLL
EngineVersion | Returns the version of the print engine
ExportFileName | Contains the file name under which the report output is to be saved
ExportFormatType | Specifies the format you want when printing to a file or MAPI
FieldDelimiter | Specifies the string you want to use to separate the fields in the character-separated values format
Formula | The name of the formula
FunctionGeneratedError_State | Reflects whether the last call to a procedure or function generated an error
GraphColGroupN | The group number in the report that is used to create the values in the columns of the graph
GraphDirection | The direction of the graph
GraphFontFaceName | Specifies the font for all text and values in the entire graph
GraphFootNote | The footnote text that will appear under the graph
GraphGroupsTitle | The title of the groups which are being graphed
GraphMaxValue | The maximum value that will appear in the graph
GraphMinValue | The minimum value that will appear in the graph
GraphRowGroupN | The group number in the report that is used to create the values in the rows of the graph
GraphSeriesTitle | The title of the series which is being graphed
GraphShowDataValue | Specifies whether to display the numerical value associated with each riser on the chart
GraphShowGridLine | Specifies whether or not to display grid lines on the graph
GraphShowLegend | Specifies whether to display the graph legend
GraphSubTitle | The subtitle text that will appear directly under the main title
GraphSummarizedFieldN | The summary field in the report that is used to set the values of the risers in the graph
GraphTitle | The main title text that will appear above the graph
GraphType | The type used for the specified graph in the specified section
GraphVerticalBars | Specifies whether to display the bars in a bar graph vertically or horizontally
GraphXAxisTitle | The title text that will appear for the X axis
GraphYAxisTitle | The title text that will appear for the Y axis
GraphZAxisTitle | The title text that will appear for the Z axis
GroupCondition | The condition for a given group section in the report
GroupField | The field name for a given group section in the report
GroupSelectionFormula | Holds the group-selection formula of the report
GroupSortDirection | The sort direction for a given group section in the report
HTMLFileName |
IsPrintJobFinished | Monitors the print job to see if it is finished or still in progress
KeepTogether | Specifies whether or not the program is to keep all lines of the section together
LatestPageN | Returns the number of the last page that is currently available
LeftMargin | The left page margin in twips
LineAscent | The line ascent for the specified section in twips
LineHeight | The line height for the specified section in twips
MessageText | Specifies the string you want to appear as the body of your E-mail or FAX message
MinimumSectionHeight | The minimum section height for the specified section in twips
NDetailCopies | The number of copies to be printed of the Details section
NewPageAfter | Specifies whether the program is to insert a page break after the section is printed
NewPageBefore | Specifies whether the program is to insert a page break before the section is printed
NFormulas | The number of formulas defined in the report
NGroups | The number of groups in the report
NGroupSortFields | Returns the number of group-sort fields defined in the report
NLinesInSection | The number of lines in the specified report section
NParams | The number of parameters used in the stored procedure of the report
NReportCopies | Specifies the number of copies to print
NSortFields | Returns the number of sort fields defined in the report
NTables | The number of tables in the report
NthFormulaName | The name of the Nth formula
NthFormulaText | The contents of the Nth formula
NthGroupSortFieldDirection | The number of the sort field
NthGroupSortFieldName | The number of the sort field
NthParam | The value of the parameter of the stored procedure
NthSortFieldDirection | The sort direction of the Nth sort field
NthSortFieldName | The name of the Nth sort field
NthTableDBType | The type of the database file of interest
NthTableDescriptiveName | The name of the database file of interest
NthTableDLLName | The name of the appropriate database DLL for the database file of interest
NthTableLocation | The location of a specified database file
NumRecordsPrinted | Returns the number of records actually printed
NumRecordsRead | Returns the number of records actually processed
NumRecordsSelected | Returns the number of records selected for inclusion in the report out of the total number of records read
Output_Destination | Indicates the destination of the report
ParentWindowHandle | Specifies the handle to the parent window if the Preview window is a child of that window
PreviewWindow_Id |
PrintAtBottomOfPage | Specifies whether the program is to cause each group value to print only at the bottom of a page or to have the values print in their normal positions
PrintDate | The print date of the report
PrintEnded | Returns whether the printing process is completed
PrinterDriver | Obtains information about the printer driver
PrinterName | Obtains information about the printer name
PrinterPort | Obtains information about the printer port
Report_Data_Path | Controls the pathnames of the tables used by the loaded report
Report_Name | Determines if the report defined in the named file will be run when Run_Report is received
Report_View_Id | Contains the object ID of the parent report view/panel
ReportTitle | Holds the title string that is to appear on the title bar of the report when the report prints to a Preview window
ResetPageNAfter | Specifies whether or not the program is to reset the page number to one (1) for the following page, after it prints a group total
RightMargin | The right page margin in twips
Selection_Formula | Obsolete -- provided for backward compatibility reasons.
SelectionFormula | Holds the selection formula of the report
ShowPrintControls | Indicates whether the print controls on the preview window are displayed
SQLQuery | Holds the string containing the SQL query generated by the report
StartPageN | Returns the number of the starting page
StopPageN | The stopping page number of the report
StringDelimiter | Specifies the character you want to use to enclose alphanumeric field data in the character-separated values format
SubjectText | Specifies the string you want to appear as the subject line in the e-mail or FAX message
SuppressBlankLines | Specifies whether the program is to eliminate lines from your report that are blank due to fields being suppressed
ToList | Contains the To list to which you want your e-mail message directed
TopMargin | The top page margin in twips
UseReportDateFormat_State | Indicates whether the program should save dates in the same format (MDY, DMY, etc.) that you used in the report
UseReportNumberFormat_State | Indicates whether the program should save numbers in the same format (decimal places, negatives, etc.) that you have used in the report
Visible | Specifies whether the selected section is to be visible
WindowHandle | Returns the Preview window handle
WindowHeight | Specifies the height of the Preview window, in twips
WindowLeftCoordinate | Specifies the x coordinate of the upper left corner of the Preview window, in twips
WindowStyle | Specifies the style of the window being created
WindowTitle | Contains the title you want to appear in the Preview window title bar when printing to a preview window
WindowTopCoordinate | Specifies the y coordinate of the upper left corner of the Preview window, in twips
WindowWidth | Specifies the width of the Preview window, in twips
ZoomPreviewWindow | Sets the magnification level
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for CrystalReport

View event list in alphabetical order

Name | Description
OnDeInitializeReport | A hook message sent by the Close_report procedure
OnInitializeReport | A hook message sent by the Open_report procedure
OnStartPrinting | A hook message sent just before starting a print job
OnStopPrinting | A hook message sent after completion of a print job
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for CrystalReport

View method list in alphabetical order

Name | Type | Description
AddGroupSortField | Procedure | Adds a field to the group sort order of the report
AddSortField | Procedure | Adds a field to the sort order of the report
CancelPrintJob | Procedure | Used to cancel a print job in progress
CheckFormula | Function | Checks if the contents of a formula are valid
CheckGroupSelectionFormula | Function | Checks if the contents of the group-selection formula are valid
CheckSelectionFormula | Function | Checks if the contents of the selection formula are valid
ClosePrintEngine | Procedure | Closes the print engine
CloseReport | Procedure | Sends the OnDeInitializeReport hook message, and closes the report
CloseWindow | Procedure | Closes the Preview window
CrystalDate | Function | Converts date to Crystal format
CrystalInteger | Function | Converts integer to CrystalInteger format
CrystalNumber | Function | Converts number to CrystalNumber format
CrystalString | Function | Converts string to CrystalString format
DeleteNthGroupSortField | Procedure | Deletes the Nth group-sort field of the current sort order of the report
DeleteNthSortField | Procedure | Deletes the Nth sort field of the current sort order of the report
DoWinQLReport | Procedure | (Obsolete) Obsolete. Use RunCrystalReport instead.
ExportOptions | Function | Used to present a series of dialog boxes that retrieve export options from users
ExportPrintWindow | Procedure | Exports the report currently in the preview window
ExportWindowToDisk | Procedure |
ExportWindowToMail | Procedure |
Font | Procedure Set | Sets the font for field and/or text characters in the report section(s) specified
Full_Report_Name | Function | Determines the full name of the report
JobStatus | Function | Evaluates the status of a print job
LogOffServer | Procedure | Logs off the specified server
LogOnServer | Procedure | Logs on to the specified server
NextPrintWindowMagnification | Procedure | Changes the Preview-window magnification to the next magnification level in order
NthTableLogOnDatabaseName | Function | The name of the table within the server
NthTableLogOnDatabaseName | Procedure Set | Sets the NthTableLogOnDatabaseName table name
NthTableLogOnPassword | Function | The password of the user on the server
NthTableLogOnPassword | Procedure Set | Sets the password of the user on the server
NthTableLogOnServerName | Function | The logon name for the server
NthTableLogOnServerName | Procedure Set | Sets the logon name for the server
NthTableLogOnUserID | Function | The user ID on the server
NthTableLogOnUserID | Procedure Set | Sets the user ID on the server
NthTableSessionHandle | Function | Specifies the handle to Microsoft Access Tables sessions
NthTableSessionHandle | Procedure | Sets the handle to Microsoft Access Tables sessions
NthTableSessionPassword | Function | Specifies the password for Micrisoft Access Tables only session
NthTableSessionPassword | Procedure Set | Sets the password for Micrisoft Access Tables only session
NthTableSessionUserID | Function | Specifies the user ID for Microsoft Access Tables
NthTableSessionUserID | Procedure Set | Sets the user ID for Microsoft Access Tables
OpenPrintEngine | Procedure | Opens the print engine
OpenReport | Procedure | Open the report and send the OnInitializeReport hook
OutputToPrinter | Procedure | Print the report to a printer
OutputToWindow | Procedure | Prints the report to a Preview window
PrinterDEVMODE | Function | Returns the DEVMODE structure
PrintReportToPrinter | Procedure | (Obsolete) Prints the report, identified with the sReportName parameter, to the printer
PrintReportToWindow | Procedure | (Obsolete)
PrintWindow | Procedure | Prints the report displayed in the Preview window
Report_Base_File_Name | Function | Removes the directory information from the name passed and returns that name
Run_Report | Procedure | Runs the report
RunCrystalReport | Procedure | Runs the CrystalReport report as defined in its properties
SelectAndPrintWindow | Procedure |
SelectAndSetFont | Procedure |
SelectAndSetPrinter | Procedure |
SelectPrinter | Procedure | Specifies a printer other than the default printer as a print destination
ShowFirstPage | Procedure | Shows the first page in the preview window
ShowLastPage | Procedure | Shows the last page in the preview window
ShowNextPage | Procedure | Shows the next page in the preview window
ShowPreviousPage | Procedure | Shows the previous page in the preview window
TestNthTableConnectivity | Function | Tests if a connection to the database file can be made
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cSQLConnection

Properties Events Methods Index of Classes

Handles all Embedded SQL operations for one connection.

Hierarchy

cObject
---Array
------cSQLConnection

Library: Common (Windows and Web Application) Class Library

Package: sql.pkg

Description

The cSQLConnection class handles all Embedded SQL operations for one connection. Its main purpose is to manage the statement handles used for the connection.

The number of operations you can perform for a connection is very limited. Basically, the connection is the vehicle to create statement handles.

Last Edited: April 19, 2005


Properties for cSQLConnection

View property list in alphabetical order

Name | Description
phCLIHandle |
piBindFile | The default file to bind statement results to.
psDriverID |
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cSQLConnection

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cSQLConnection

View method list in alphabetical order

Name | Type | Description
CreateHandle | Function |
FreeHandle | Procedure |
SQLConnect | Function |
SQLDisconnect | Procedure | Disconnect from the database and free the connection object.
SQLFileConnect | Function |
SQLOpen | Function | Open a statement handle.
StoreHandleInfo | Procedure |
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cSQLHandleManager

Properties Events Methods Index of Classes

Base entry point for all Embedded SQL operations.

Hierarchy

cObject
---Array
------cSQLHandleManager

Library: Common (Windows and Web Application) Class Library

Package: sql.pkg

Description

The cSQLHandleManager class is the base entry point for all Embedded SQL operations. All connections are created through an object of this class.

An object of the cSQLHandleManager class can handle connections to multiple drivers. You would never need more than one object of this class in any program. However, programmer's preference and readability of code can be good arguments to create more than one cSQLHandleManager object in a program. Furthermore, third parties may offer classes that internally use cSQLHandleManager objects. All these different types of usage are supported.

When including the package, an object of the cSQLHandleManager class will automatically be defined at desktop level. This object is used by the command interface.

Last Edited: April 19, 2005


Properties for cSQLHandleManager

View property list in alphabetical order

Name | Description
psDefaultConnection |
psDefaultDriver |
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cSQLHandleManager

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cSQLHandleManager

View method list in alphabetical order

Name | Type | Description
CreateHandle | Function |
SQLConnect | Function | Creates a connection and returns the handle to the connection.
SQLFileConnect | Function | Returns a handle to the same connection of the table opened under the number passed in iFileNum.
SQLSetConnect | Procedure | Can be used to set up a default driver and connection for subsequent SQLConnect function calls.
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cSQLStatement

Properties Events Methods Index of Classes

Handles all Embedded SQL operation for one statement. The statement is the most used entity in any SQL environment.

Hierarchy

cObject
---Array
------cSQLStatement

Library: Common (Windows and Web Application) Class Library

Package: sql.pkg

Description

The cSQLStatement class handles all Embedded SQL operation for one statement. The statement is the most used entity in any SQL environment. The other SQL classes are intended to create an environment in which statements can be created and destroyed.

Last Edited: April 19, 2005


Properties for cSQLStatement

View property list in alphabetical order

Name | Description
phCLIHandle |
phStmtConnection |
piBindFile | The default file for file-fetch operations.
piLastArgument |
piLastColumn |
psDriverID |
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cSQLStatement

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cSQLStatement

View method list in alphabetical order

Name | Type | Description
DFDateToSQLDate | Function |
FreeHandle | Procedure |
HandleError | Procedure |
RemoveComponentIdentifier | Function | Can be used to remove a component identifier from an informational message obtained by calling SQLGetMessage.
SQLBindFile | Procedure | Add a file to the list of files bound to the statement result.
SQLCall | Procedure | Call a stored procedure.
SQLClose | Procedure | Close the statement handle and free the DataFlex statement handle object.
SQLColAttribute | Function | Returns a column attribute.
SQLColumnMap | Function | Returns a column number for a name.
SQLColumnValue | Function | Get a column value.
SQLDateToDFDate | Function |
SQLExecDirect | Procedure | This procedure combines the SQLPrepare and SQLExecute.
SQLExecute | Procedure | Execute the prepared statement.
SQLFetch | Function | Fetch the next row of the statement's result set.
SQLFetchActivatesBuffer | Procedure | Connect or disconnect a file buffer to a statement result set.
SQLGetArgument | Function | Get a stored procedure argument.
SQLGetData | Function | Get data of a column.
SQLGetMessage | Function | Get informational messages (if any).
SQLGetNextArgument | Function |
SQLIllegalAttribute | Procedure |
SQLNextColumn | Function |
SQLNextResultSet | Function | Switch to the next result set of a batch or stored procedure.
SQLPrepare | Procedure | Prepare a statement that is passed for execution.
SQLPrivateColAttribute | Function |
SQLPrivateColumnIsLegal | Function |
SQLPrivateColumnValue | Function |
SQLPrivateStmtAttribute | Function |
SQLReturnValue | Function | Get a stored function return value.
SQLSetArgument | Procedure | Setup a stored procedure argument so it can be passed.
SQLSetNextArgument | Procedure |
SQLSetProcedureName | Procedure | Setup a stored procedure name so it can be called.
SQLStmtAttribute | Function | Returns a statement attribute.
StmtError | Procedure |
StoreHandleInfo | Procedure |
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cStatusBar

Properties Events Methods Index of Classes

A control, usually placed at the bottom of a window, that is divided into "panes"

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------cWinControl
---------------------cStatusBar

Library: Windows Application Class Library

Package: cStatusbar.pkg

Description

The statusbar is a control, usually placed at the bottom of a window, that is divided into "panes". Each pane is used to show either a string or an icon. The status bar is used to relay information to a user about the program. For example, you may have a pane that shows the current View and another that shows status-help for the currently-focused control.

To create the panes, embed objects derived from cStatusPane. The last pane will automatically stretch to the end of the statusbar.

The statusbar has two modes: Simple, where a single string is displayed across the whole statusbar, and Panes, where the multiple panes are displayed. Only one mode is active and that is determined by the pbSimple property.

Use the piBackColor property to set the color of the statusbar, and the pbSizeGrip property to position a Grip in the bottom-right corner as visual indicator that the panel containing the statusbar can be resized.

Usually, the statusbar is part of the MDI interface. In this mode, the statusbar will automatically size and align itself with the panel's client-area.

If you want to use the statusbar in a non-MDI container, set its pbInMdiPanel property to false, to prevent it from communicating with the MDI interface. To prevent the statusbar from aligning to the bottom of the parent window, change the peAlign property to alNone and size and locate the statusbar manually.

Sample

Object oStatusBar is a cStatusBar

    Object oStatusHelp is a cStatusPane
        Set piWidth To 350
    End_Object

    Object oViewLabel is a cStatusPane
        Set piWidth To 40
        Set psLabel To "View:"
        Set peBevel To bsNone
    End_Object

    Object oViewName is a cStatusPane
        Set piWidth To 200
    End_Object

End_Object

Last Edited: July 16, 2003


Properties for cStatusBar

View property list in alphabetical order

Name | Description
pbInMdiPanel | Determines if the statusbar will communicate with the MDI-panel
pbSimple | Determines if statusbar shows its panes and the text/icon within them
pbSizeGrip | Determines if Grip is shown or hidden
pbTooltips |
peAlign | Determines how the statusbar is aligned within the parent object
phoPanes | Stores the object-handle of the internal cCollection object that holds the object-handles of the child cStatusPane objects
piBackColor | Sets the background color of the statusbar
piStatusHelpPaneIndex | Determines which pane should show this status-help
psSimpleValue | Stores the string that will be displayed when the statusbar is in simple mode
psStatusHelp |
Inherited Properties from cWinControl
pbEnabled | Enables the control to take user input
pbVisible | Makes a control visible or invisible
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cStatusBar

View event list in alphabetical order

Name | Description
OnClick | Received whenever the mouse's left button is clicked in the statusbar
OnDoubleClick | Received whenever the mouse's left button is double-clicked in the statusbar
OnDoubleRightClick | Received whenever the mouse's right button is double-clicked in the statusbar
OnRightClick | Received whenever the mouse's right button is clicked in the statusbar
OnSimpleModeChange | Received whenever the statusbar changes between the modes of Simple or Panes
Inherited Events from cWinControl
OnMouseDoubleClick | Received whenever a mouse button is double-clicked on the control
OnMouseDown | Received whenever a mouse button is pressed on the control
OnMouseMove | Received whenever the mouse cursor moves over a control
OnMouseUp | Received whenever a mouse button is released on the control
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cStatusBar

View method list in alphabetical order

Name | Type | Description
NumberOfPanes | Function | Returns the number of panes (that is, cStatusPane objects) that are in the statusbar
PaneTextWidth | Function | Returns the width, in pixels, of the string, sText
Inherited Methods from cWinControl
DoRecreateWindow | Procedure | Recreates a window
DoUpdateWindow | Procedure | Updates a window if it needs repainting
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cStatusPane

Properties Events Methods Index of Classes

Represents a single pane of a cStatusBar

Hierarchy

cObject
---cStatusPane

Library: Windows Application Class Library

Package: cStatusPane.pkg

Description

Each instance of a cStatusPane class represents a single pane of a status bar. You embed them within an instance of the cStatusBar to display either text or an icon to the user.

You can set the text of a pane with the psLabel property or you can display an icon in the pane instead using the psIcon property. To align the text within the pane, use the peAlignment property.

Set the width of the pane with the piWidth property and draw a graphical edge around the pane with the peBevel property.

Sample

Object oStatusBar is a cStatusBar

    Object oStatusHelp is a cStatusPane
        Set piWidth To 350
    End_Object

    Object oReadOnlyLabel is a cStatusPane
        Set piWidth To 80
        Set psLabel To "ReadOnly:"
        Set peBevel To bsNone
    End_Object

    Object oReadOnly is a cStatusPane
        Set piWidth To 200
        Set psLabel To "ReadOnly"
        Procedure OnClick
            // the pane was clicked, so do something
        End_Procedure
    End_Object

End_Object

Shared Handlers

The panes allow you to use a shared-handler. For example, rather than handling the OnClick event within each pane, you could write a single handler at the statusbar that would receive the OnClick events for several panes. To do this, set this property to the message-handle of shared handler. When this happens, the pane will automatically pass the object-handle of the pane to the shared handler as the first parameter. The shared handler must be in the delegation path of the pane.

A frequent use of shared-handlers is when the panes are created dynamically and there is no local object definition to handle the event in.

This sample shows two panes using the same handler:

Object oStatusbar is a cStatusbar
    Procedure OnClickShared Integer hoPane
        Showln "OnClick happened in " (Name(hoPane))
    End_Procedure

    Object oPane1 is a cStatusPane
        Set phmOnClick To msg_OnClickShared
    End_Object

    Object oPane2 is a cStatusPane
        Set phmOnClick To msg_OnClickShared
    End_Object
End_Object

Last Edited: November 22, 2004


Properties for cStatusPane

View property list in alphabetical order

Name | Description
peAlignment | Determines how the text is aligned
peBevel | Determines where the beveled edge is drawn
phIcon | Stores the window handle of an icon that is loaded into memory
phmOnClick | Stores the method-handle of the event to send whenever the pane is clicked
phmOnDoubleClick | Stores the method-handle of the event to send whenever the pane is double-clicked with the left mouse button
phmOnDoubleRightClick | Stores the method-handle of the event to send whenever the pane is double-clicked with the right mouse button
phmOnRightClick | Stores the method-handle of the event to send whenever the pane is clicked with the right mouse button
piWidth | Determines the width of the pane
psIcon | Determines whether pane is displayed as an Icon or a string
psLabel | Contains the text that you want to display in a pane
psToolTip |
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cStatusPane

View event list in alphabetical order

Name | Description
OnClick | Received whenever the mouse's left button is clicked in the pane
OnDoubleClick | Received whenever the mouse's left button is double-clicked in the pane
OnDoubleRightClick | Received whenever the mouse's right button is double-clicked in the pane
OnRightClick | Received whenever the mouse's right button is clicked in the pane
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cStatusPane

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cStatusPanel

Class: cStatusPanel (Abstract)

Properties Events Methods Index of Classes

Abstract class that can be used to create status panels

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------cStatusPanel
---------------------------------cProcessStatusPanel

Library: Windows Application Class Library

Package: cStatusPanel.pkg

Description

This is an abstract class that can be used to create status panels. The interface at this level is very simple. You can start, stop, request a cancel and allow the object to paint.

Look at cProcessStatusPanel.pkg to see how this is used.

Creating your own Status Panel objects

If a developer wishes to create a custom panel, he/she should use cProcessStatusPanel.pkg as a template. This panel can be visually modeled and changed any way you wish. Just save your new custom panel with a different file and object name and direct your status panel request to the new object.

If the new panel changes the interface and updates objects that are not currently defined, you want to make sure you send the message ProcessEvents after you've updated the object. This allows the object to paint when inside of a tight loop. For example, if you wanted to add a progress bar (cProgressBar) you would want to Send ProcessEvents after you update the progress bar.

e.g.

      Procedure UpdateStatusBar
          Send DoAdvance of oProgressBar
          Send ProcessEvents
      End_Procedure

Of course, if you use the standard interfaces in status bar and your forward send these messages this will be done for you.

Last Edited: June 2, 2006


Properties for cStatusPanel

View property list in alphabetical order

Name | Description
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cStatusPanel

View event list in alphabetical order

Name | Description
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cStatusPanel

View method list in alphabetical order

Name | Type | Description
Activate | Procedure |
close_panel | Procedure |
Deactivate | Procedure |
ProcessEvents | Procedure |
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cTableColumnFetchHelper

Properties Events Methods Index of Classes

Allows creation of a helper object that makes it easy to enable or disable Selected Column Fetching (SCF) for a large number of tables.

Hierarchy

cObject
---cTableColumnFetchHelper

Library: Common (Windows and Web Application) Class Library

Package: cTableColumnFetchHelper.pkg

Description

The cTableColumnFetchHelper class allows you to create a helper object that makes it easy to enable or disable Selected Column Fetching (SCF) for a large number of tables in a database with a few simple methods.

The DataFlex Connectivity Kits support an interface that allows you to retrieve selected columns from a record. When used properly this can speed up some operations. You are most likely to see a speed difference when this is used in batch processes such as updates or reports and when the columns not fetched are Text. A command interface exists that allows you to:

1. Determine if a table should fetch all columns or fetch selected columns. The normal behavior for a table is to fetch all columns. This is controlled by the attribute DF_FILE_FETCH_ALL_COLUMNS and is used as follows:

Set_Attribute DF_FILE_FETCH_ALL_COLUMNS of iTable to True|False
Get_Attribute DF_FILE_FETCH_ALL_COLUMNS of iTable to bFetchAll

2. If selected columns are fetched the DF_FIELD_FETCH_STATE allows you to determine which fields should be retrieved. This attribute is used as follows:

Set_Attribute DF_FIELD_FETCH_STATE of iTable iColumn To True|False
Get_Attribute DF_FIELD_FETCH_STATE of iTable iColumn To bFetchCol

Rather than passing a columns (field) number you can also pass the symbol DF_ALL_COLUMNS which operates on all columns, allowing you to select all or no columns for fetching in a single command.

Set_Attribute DF_FIELD_FETCH_STATE of iTable DF_ALL_COLUMNS ;
    To True|False

These commands allow you to do anything you want, but they do require that you execute these commands on a table by table (and column by column) basis. The cTableColumnFetchHelper class makes it a little bit easier to perform the most commonly required SCF operations on all open tables in your database. It performs two main functions.

1. Enable or Disable Selected Column Fetching for all Tables.
This allows you to toggle selected column fetching for all tables making it easy to create procedures where you can toggle between selected and full fetching modes.

2. Enable or Disable column fetching for all text fields in all tables.
The ability to disable the fetching of text columns is the most useful feature of this class. Most of the performance gains of selected column fetching occur when text fields are not fetched. This class provides an easy way to control text column fetching without you having to individually find the tables and columns you wish to mark. For example, a typical use of disabling text fields before a report might look like the
following:

Send DisableAllTextColumnFetching of oFetchHelper
Send RunTheReport
Send EnableAllColumnFetching of oFetchHelper

Note that the methods DisableAllTextColumnFetching and EnableAllColumnFetching may be the only two methods you will ever need to send.

Normally these operations are performed on all open files. An additional mode exists where these operations can be performed on a set of tables that you have specifically declared within the object. This would allow you to create multiple fetch helper objects that operate on different sets of tables.

If wish to operate on all open tables, which is how we expect you to use the class, you can create a single helper object based on this class and use it throughout your application.

// Top of program
Use cTableColumnFetchHelper.pkg

Object oFetchHelper is a cTableColumnFetchHelper
End_Object

// in any part of your application
Send DisableAllTextColumnFetching of oFetchHelper
Send RunTheReport
Send EnableAllColumnFetching of oFetchHelper

If you use this class with databases that do not support selected column fetching, this class will do nothing - no error will be declared.

You must be careful that the columns that you choose not to select are really not needed. If you attempt to disable columns that are used within your application, you may receive a runtime error message. You will always receive an error if you attempt to move data into a non-fetching (inactive) column. You will receive an error if you attempt to move data from a non-fetching (inactive) column if the DRVR_REPORTACTIVECOLUMNERRORS attribute is set to true using the CLI_Set_Driver_Attribute command. We advise that you set this attribute to true so that you do not accidentally rely on column data in your application that does not exist.

See Also

cCLIHandler

Last Edited: April 22, 2005


Properties for cTableColumnFetchHelper

View property list in alphabetical order

Name | Description
pbUseAllTables | Determines if all open tables should be operated on, or the object contains a list of tables that should be used instead.
phoFiles |
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cTableColumnFetchHelper

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cTableColumnFetchHelper

View method list in alphabetical order

Name | Type | Description
AddTable | Procedure | This adds iTable to the object's list of tables.
DisableAllColumnFetching | Procedure | Disables the fetching of all columns in all tables.
DisableAllTextColumnFetching | Procedure | Disables the fetching of all text columns in all tables.
EnableAllColumnFetching | Procedure | Enables the fetching of all columns in all tables.
IsTableIn | Function | Determines if iTable is added to this object's list of tables.
RemoveTable | Procedure | Removes iTable from the object's list of tables.
SetAllTableColumnFetching | Procedure |
SetColumns | Procedure |
SetFetchAllColumns | Procedure | This sets the DF_FILE_FETCH_ALL_COLUMNS attribute for all tables to the value of bFetchAll.
TableCount | Function | Returns the number of tables in the object's table list.
TableHandle | Function | Returns the table handle (file number) for the table that is stored in index position iIndex.
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cTextEdit

Properties Events Methods Index of Classes

Allows the user to enter and edit text

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DFBaseTextEdit
---------------------cTextEdit
------------------------cDbTextEdit_

Library: Windows Application Class Library

Package: cTextEdit.pkg

Mixins: cEdit_Mixin Standard_Object_Mixin Dflabel_Mixin Shadow_Mixin RGB_Support_Temp_Mixin Help_Mixin

Description

The cTextEdit class allows the user to enter and edit text.

The cDbTextEdit class is a data-aware class similar to the cTextEdit class.
The cRichEdit class is a rich-text class similar to the cTextEdit class.

The default maximum number of characters for the control is 64 KB (65536 bytes or characters). This can be changed or retrieved via piMaxChars.

A linefeed (LF) character can be added to text programmatically by adding ASCII character 10 to a string using the character function. A carriage return (CR) character can be added to text programmatically by adding ASCII character 13 to a string using the character function. Either a LF or CR character will break the current line in the control. Also see AppendTextLn.

Sample

Object oTextEdit1 is a cTextEdit
    Set Size to 168 276
    Set Location to 6 10
    Set peAnchors to anAll
End_Object    // oTextEdit1

Syntax

Use cTextEdit.pkg

Object oObjectName is a cTextEdit
    Set Size to iHeight iWidth
    Set Location to iRow iColumn

    Set Label to sLabelText
    Set Label_Justification_Mode to jMode
    Set Label_Row_Offset to iOffset
    Set Label_Col_Offset to iOffset

    Set Status_Help to sStatusHelpText
    Set Enabled_State to True | False
End_Object  // oObjectName

Current Selection in a Rich Edit Control

The user can select text in a rich edit control by using the mouse or the keyboard. The current selection is the range of selected characters, or the position of the insertion point if no characters are selected. An application can get information about the current selection, set it, determine when it changes, and show or hide the selection highlight.

Word and Line Breaks

A rich edit control calls a function called a word-break procedure to find breaks between words and to determine where it can break lines. The control uses this information when performing word-wrap operations and when processing CTRL+LEFT ARROW key and CTRL+RIGHT ARROW key combinations. An application can send messages to a rich edit control to replace the default word-break procedure, to retrieve word-break information, and to determine what line a given character falls on.

Text Edit Shortcut Keys

Text edit controls support the following shortcut keys.

Keys | Operations | Comments
Shift+Backspace | Generate a LRM/LRM on a bidi keyboard | BiDi specific
Ctrl+Tab | Tab |
Ctrl+Clear | Select all |
Ctrl+Number Pad 5 | Select all |
Ctrl+A | Select all |
Ctrl+C | Copy |
Ctrl+V | Paste |
Ctrl+X | Cut |
Ctrl+Z | Undo |
Ctrl+Y | Redo |
Ctrl+' (apostrophe) | Accent acute | After pressing the short cut key, press the appropriate letter (for example a, e, or u). This applies to English, French, German, Italian, and Spanish keyboards only.
Ctrl+` (grave) | Accent grave | See Ctrl+' comments.
Ctrl+~ (tilde) | Accent tilde | See Ctrl+' comments.
Ctrl+; (semicolon) | Accent umlaut | See Ctrl+' comments.
Ctrl+Shift+6 | Accent caret (circumflex) | See Ctrl+' comments.
Ctrl+, (comma) | Accent cedilla | See Ctrl+' comments.
Ctrl+Shift+' (apostrophe) | Activate smart quotes |
Backspace | If text is protected, beep and do not delete it. Otherwise, delete previous character. |
Ctrl+Backspace | Delete previous word. This generates a VK_F16 code. |
F16 | Same as Backspace. |
Ctrl+Insert | Copy |
Shift+Insert | Paste |
Insert | Overwrite | DBCS (double-byte character set) does not overwrite.
Ctrl+Left Arrow | Move cursor one word to the left. | On bidi keyboard, this depends on the direction of the text.
Ctrl+Right Arrow | Move cursor one word to the right. | See Ctrl+Left Arrow comments.
Ctrl+Left Shift | Left alignment | In BiDi documents, this is for left-to-right reading order.
Ctrl+Right Shift | Right alignment | In BiDi documents, this is for right-to-left reading order.
Ctrl+Up Arrow | Move to the line above. |
Ctrl+Down Arrow | Move to the line below. |
Ctrl+Home | Move to the beginning of the document. |
Ctrl+End | Move to the end of the document. |
Ctrl+Page Up | Move one page up. | If in SystemEditMode and Single Line control, do nothing.
Ctrl+Page Down | Move one page down. | See Ctrl+Page Up comments.
Ctrl+Delete | Delete the next word or selected characters. |
Shift+Delete | Cut the selected characters. |
Esc | Stop drag-drop. | While doing a drag-drop of text.
Alt+Esc | Change the active application. |
Alt+X | Converts the Unicode hexadecimal value preceding the insertion point to the corresponding Unicode character. |
Alt+Shift+X | Converts the Unicode character preceding the insertion point to the corresponding Unicode hexadecimal value. |
Alt+0xxx (Number Pad) | Inserts Unicode values if xxx is greater than 255. When xxx is less than 256, ASCI range text is inserted based on the current keyboard. | Must enter decimal values.
Alt+Shift+Ctrl+F12 | Hex to Unicode. | In case Alt+X is already taken for another use.

Last Edited: February 22, 2005


Properties for cTextEdit

View property list in alphabetical order

Name | Description
Changed_State | Determines whether the content of the control has changed
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DFBaseTextEdit
Line_Count | Returns number of lines in control
paValue | Sets content of control from memory address or places text in control into memory address
pbBold | Toggles all text in control between bold and normal text
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard
pbCanRedo | Determines whether a redo operation can be performed
pbCanUndo | Determines whether an undo operation can be performed
pbItalics | Toggles all text in control between italic and normal text
pbWrap | Determines whether text input will break and wrap to the next line at right margin
piFontSize | Sets or returns font size of all text in control
piFontWeight | Sets or returns font weight of all text in control
piMaxChars | Sets or returns maximum number of visible characters
piRightMargin | Determines indentation of right side of control's text, relative to the right margin
psTypeFace | Sets or returns font typeface of all text in control
Read_Only_State | Determines whether users may edit the content of the control
Value | Sets or returns content of control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cTextEdit

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Fires whenever the value of the control is changed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText | Fires when maximum text size is exceeded
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Fired whenever a change in enabled state occurs
Inherited Events from DFBaseTextEdit
OnSelectionChanged | Fires when selection changes
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cTextEdit

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DFBaseTextEdit
AppendText | Procedure | Appends text to end of text in control
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control
Beginning_of_Line | Procedure | Places the cursor at beginning of current line
CharCount | Function | Returns the number of characters in the control
ClearUndoBuffer | Procedure | Clears undo buffer
Delete_Data | Procedure | Deletes all data in control
End_of_Data | Procedure | Places the cursor at end of the text in control
End_of_Line | Procedure | Places the cursor at end of current line
FindText | Function | Searches for specified text in control
FirstCharInLinePos | Function | Returns position of first character in a line
FirstVisibleLine | Function | Returns number of first visible line
HideSelection | Procedure | Toggles selection highlighting on or off
LastErrorCode | Function | Returns error code for last operation
Line | Function | Returns specified line of text
LineFromChar | Function | Returns number of line that contains specified character position or current line
LineLength | Function | Returns number of characters in line
Read | Procedure | Reads text file and displays it in the control
Redo | Procedure | Redoes the last operation
RedoType | Function | Returns type of redo operation at top of redo queue
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements
ReplaceSel | Procedure | Replaces selected text with specified text
Scroll | Procedure | Scrolls up or down the control using specified scroll mode
ScrollCaret | Procedure | Scrolls caret into view
ScrollLines | Procedure | Scrolls control vertically for specified number of lines
Select_All | Procedure | Selects entire contents of control
SelEnd | Function | Returns end of selection
SelStart | Function | Returns beginning position of selection
SelText | Function | Returns selected text
SetSel | Procedure | Selects text in given position range
TextRange | Function | Returns text in given position range
Undo | Procedure | Undoes the last operation
UndoType | Function | Returns type of undo operation at top of undo queue
Write | Procedure | Writes text file content of control to file
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cToolbar

Properties Events Methods Index of Classes

A control, usually placed at the top of a window, that contains buttons which act as shortcuts to frequently used functionality

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------cWinControl
---------------------cToolbar

Library: Windows Application Class Library

Package: cToolbar.pkg

Description

The toolbar is a control, usually placed at the top of a window, that contains buttons which act as shortcuts to frequently used functionality.

To create the buttons, embed objects derived from cToolbarButton.

Usually, the toolbar is part of the MDI interface. In this mode, the toolbar will automatically size and align itself with the panel's client-area.

If you want to use a toolbar in a non-MDI container, set its pbInMdiPanel property to false, to prevent it from communicating with the MDI interface. To prevent the toolbar from aligning to the bottom of the parent window, change the peAlign property to alNone and size and locate the toolbar manually.

Sample

Object oToolBar is a cToolBar

    Object oImages is a cImageList
        Set piMaxImages To 4
        Procedure OnCreate
            Integer iVoid

            Get AddTransparentImage "Customer.bmp" clFuchsia To iVoid
            Get AddTransparentImage "Cut16.bmp"    clFuchsia To iVoid
            Get AddTransparentImage "Copy16.bmp"   clFuchsia To iVoid
            Get AddTransparentImage "Paste16.bmp"  clFuchsia To iVoid
        End_Procedure
    End_Object

    Set phoImageList To (oImages(self))

    Object oCustomer is a cToolbarButton
        Set psTooltip To 'Customer View'
        Set psStatusHelp To 'Activate the Customer View'
        Set piImage To 0
        Procedure OnClick
            Send DoShowCustomer
        End_Procedure
    End_Object

    Object oSeparator is a cToolbarButton
        Set peStyle To bsSeparator
    End_Object

    Object oCut is a cToolbarButton
        Set psTooltip To 'Cut'
        Set psStatusHelp To 'Cuts the selection to the Clipboard'
        Set piImage To 1
        Procedure OnClick
            Send DoSendToFocus msg_cut
        End_Procedure
    End_Object

    Object oCopy is a cToolbarButton
        Set psTooltip To 'Copy'
        Set psStatusHelp To 'Copies the selection to the Clipboard'
        Set piImage To 2
        Procedure OnClick
            Send DoSendToFocus msg_copy
        End_Procedure
    End_Object

    Object oPaste is a cToolbarButton
        Set psTooltip To 'Paste'
        Set psStatusHelp To 'Inserts Clipboard contents'
        Set piImage To 3
        Procedure OnClick
            Send DoSendToFocus msg_paste
        End_Procedure
    End_Object

End_Object // oToolbar

Last Edited: July 16, 2003


Properties for cToolbar

View property list in alphabetical order

Name | Description
pbFlat | Determines if buttons are displayed flat or raised
pbInMdiPanel | Determines if the toolbar will communicate with the MDI-panel
pbList | Determines if the button's label is displayed underneath the image or to the right of it
pbNoDivider | Determines if the toolbar is drawn with a dividing graphical line above it
pbShowLabels | Determines if labels are actually shown.
pbTooltips | Decides whether to show the tooltips or not
pbWrapable | Determines if the toolbar wraps its buttons onto multiple lines or clips the toolbar, so that the buttons are not visible
peAlign | Determines how the toolbar is aligned within the parent object
phoButtons | Stores the object-handle of the internal cCollection object that holds the object-handles of the child cToolbarButton objects
phoImageList | Provides images for the buttons on the toolbar
phoImageListDisabled | Disables images for the buttons on the toolbar
phoImageListHot | Provides hot images for the buttons on the toolbar
piBorderHorz | Creates a blank area between the edge of the button and the button's image and/or text
piBorderVert | Creates a blank area between the edge of the button and the button's image and/or text
piButtonHeight | Sets a button's height explicitly
piButtonWidth | Sets a button's width explicitly
piButtonWidthMax | Defines the maximum width, expressed in pixels, that each button can be
piButtonWidthMin | Defines the minimum width, expressed in pixels, that each button must be
piIndent | Determines the number of pixels to use as an indent on the toolbar
piTextRowsMax | Determine the maximum number of rows that can be created
psDisabledSuffix | Determines what you can append when the button is disabled
Inherited Properties from cWinControl
pbEnabled | Enables the control to take user input
pbVisible | Makes a control visible or invisible
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cToolbar

View event list in alphabetical order

Name | Description
OnRightClick | Received whenever the mouse's right button is clicked in the toolbar
Inherited Events from cWinControl
OnMouseDoubleClick | Received whenever a mouse button is double-clicked on the control
OnMouseDown | Received whenever a mouse button is pressed on the control
OnMouseMove | Received whenever the mouse cursor moves over a control
OnMouseUp | Received whenever a mouse button is released on the control
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cToolbar

View method list in alphabetical order

Name | Type | Description
DoResize | Procedure | Sent internally if the toolbar is part of an MDI pane to automatically set its size and align it the parent's window
DoSendToDeoFocus | Procedure | Redirects a message, hmMessage, to the focused control
DoSendToFocus | Procedure | Redirects a message, hmMessage, to the focused control
NumberOfButtons | Function | Returns the number of buttons that are in the toolbar
Inherited Methods from cWinControl
DoRecreateWindow | Procedure | Recreates a window
DoUpdateWindow | Procedure | Updates a window if it needs repainting
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cToolbarButton

Properties Events Methods Index of Classes

Each instance represents a single button of a toolbar

Hierarchy

cObject
---cToolbarButton

Library: Windows Application Class Library

Package: cToolbarButton.pkg

Description

Each instance of a cToolbarButton class represents a single button of a toolbar. You embed them within an instance of the cToolbar to provide a quick way to access functionality of the program.

Sample

Object oToolBar is a cToolBar

    Object oImages is a cImageList
        Set piMaxImages To 4
        Procedure OnCreate
            Integer iVoid

            Get AddTransparentImage "Customer.bmp" clFuchsia To iVoid
            Get AddTransparentImage "Cut16.bmp"    clFuchsia To iVoid
            Get AddTransparentImage "Copy16.bmp"   clFuchsia To iVoid
            Get AddTransparentImage "Paste16.bmp"  clFuchsia To iVoid
        End_Procedure
    End_Object

    Set phoImageList To (oImages(self))

    Object oCustomer is a cToolbarButton
        Set psTooltip To 'Customer View'
        Set psStatusHelp To 'Activate the Customer View'
        Set piImage To 0
        Procedure OnClick
            Send DoShowCustomer
        End_Procedure
    End_Object

    Object oSeparator is a cToolbarButton
        Set peStyle To bsSeparator
    End_Object

    Object oCut is a cToolbarButton
        Set psTooltip To 'Cut'
        Set psStatusHelp To 'Cuts the selection to the Clipboard'
        Set piImage To 1
        Procedure OnClick
            Send DoSendToFocus msg_cut
        End_Procedure
    End_Object

    Object oCopy is a cToolbarButton
        Set psTooltip To 'Copy'
        Set psStatusHelp To 'Copies the selection to the Clipboard'
        Set piImage To 2
        Procedure OnClick
            Send DoSendToFocus msg_copy
        End_Procedure
    End_Object

    Object oPaste is a cToolbarButton
        Set psTooltip To 'Paste'
        Set psStatusHelp To 'Inserts Clipboard contents'
        Set piImage To 3
        Procedure OnClick
            Send DoSendToFocus msg_paste
        End_Procedure
    End_Object

End_Object // oToolbar

Shared Handlers

The buttons allow you to use a shared-handler. For example, rather than handling the OnClick event within each button, you could write a single handler at the toolbar that would receive the OnClick events for several buttons. To do this, set this property to the message-handle of shared handler. When this happens, the button will automatically pass the object-handle of the button to the shared handler as the first parameter. The shared handler must be in the delegation path of the button.

A frequent use of shared-handlers is when the buttons are created dynamically and there is no local object definition to handle the event in.

This sample shows two buttons using the same handler:

Object oToolbar is a cToolBar
    Procedure OnClickShared Integer hoButton
        Showln "OnClick happened in " (Name(hoButton))
    End_Procedure

    Object oButton1 is a cToolbarButton
        Set phmOnClick To msg_OnClickShared
    End_Object

    Object oButton2 is a cToolbarButton
        Set phmOnClick To msg_OnClickShared
    End_Object
End_Object

Last Edited: July 17, 2003


Properties for cToolbarButton

View property list in alphabetical order

Name | Description
pbAutoSize | Allows you to create buttons with variable width
pbChecked | Programmatically checks/unchecks a button with a peStyle of bsCheck
pbEnabled | Enables or disables a button
pbGrouped | Creates groups of buttons
pbIndeterminate | Has no predetermined meaning and you are free to implement your own application-logic
pbPressed | Programmatically sets the pressed/released state of a button
pbVisible | Determines whether the button is visible in the toolbar
pbWrap | Determines if next button wil wrap
peStyle | Changes the style of a button
phmOnClick | Stores the method-handle of the event to send whenever the button is clicked
phmOnDropDown | Stores the method-handle of the event to send whenever the drop-down element of a button with the peStyle property set to bsDropDown is clicked
phmOnHotItemEntering | Stores the method-handle of the event to send whenever the mouse cursor enters the bounds of the button
phmOnHotItemLeaving | Stores the method-handle of the event to send whenever the mouse cursor leaves the bounds of the button
phmOnRightClick | Stores the method-handle of the event to send whenever the button is clicked with the right mouse button
piImage | Set this property to the index of an image in an imagelist
psLabel | Determines the text that will be displayed as the label
psStatusHelp | Displayed in the panel's statusbar, whenever the tooltip is displayed
psTooltip | Determines text that is displayed whenever a tooltip is displayed
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cToolbarButton

View event list in alphabetical order

Name | Description
OnClick | Received whenever the mouse's left button is clicked in the button
OnDropDown | Received whenever the drop-down arrow is clicked on a button with the peStyle property set to bsDropDown
OnHideHint | Received whenever the toolbar is about to hide the tooltip/statushelp hints for a button
OnHotItemEntering | Received whenever the mouse cursor enters the bounds of the button
OnHotItemLeaving | Received whenever the mouse cursor leaves the bounds of the button
OnRightClick | Received whenever the mouse's right button is clicked in the button
OnShowHint | Received whenever the toolbar is about to show the tooltip/statushelp hints for a button
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cToolbarButton

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cUIObject

Class: cUIObject (Abstract)

Properties Events Methods Index of Classes

An abstract class that provides the standard capabilities of a user interface object

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------Cm_Menu
------DfBaseObject
------DfComUIObject

Library: Windows Application Class Library

Package:

Description

cUIObject is an abstract class that provides the standard capabilities of a user interface object. All classes that have a user interface for display inherit all aspects of this class. Although this is a base class, its power and complexity are equal to those of any other class in the hierarchy.

Of Special Note

This class does not actually exist as a stand-alone class, and therefore, cannot be used as a superclass or class of an object when defining new classes and objects. Instead, the base classes that provide a user interface for display (Edit, Menu, Message, and Scrollb) automatically incorporate all aspects of this class.

Accelerator Keys

cUIObject is the most basic level at which accelerator keys are defined. The kcancel key has a null definition in this class because its desired actions (undo + leave) are application-specific.

Name | Message Sent | Defining Class
kexit_application | exit_application | ui_object
khelp | help | ui_object
knext_item | next | ui_object
kprevious_item | previous | ui_object
kprint_screen | print_screen | ui_object
krefresh_screen | refresh_screen | ui_object

Last Edited: November 21, 2004


Properties for cUIObject

View property list in alphabetical order

Name | Description
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cUIObject

View event list in alphabetical order

Name | Description
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cUIObject

View method list in alphabetical order

Name | Type | Description
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: CursorShape

Properties Events Methods Index of Classes

Enables programs to change the appearance of the Windows cursor for any of various purposes

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------CursorShape

Library: Windows Application Class Library

Package: Cursor.pkg

Description

The CursorShape class enables programs to change the appearance of the Windows cursor for any of various purposes. Its primary use is automatic, and is controlled by the class definitions of your programs' objects. While any special cursor is in effect, mouse capture is on, so mouse events will be processed only by the CursorShape object.

Syntax

To use this class manually, simply use the DfCursor.pkg package and set the cursor property to one of the cursor_types listed below. To return the cursor to what it was before, use Set Cursor, passing 0 as the cursor_type. DfCursor.pkg creates a global cursor object named Cursor_Control.

Use DfCursor.pkg
:
Set Cursor to Cursor_Type

Most often, you will use the Cursor_Wait and Cursor_Ready methods to change the cursor to an hourglass and back to the normal cursor.

Last Edited: August 19, 2004


Properties for CursorShape

View property list in alphabetical order

Name | Description
ClassCursorHandle | Saves the original cursor_type of the class of the current object so that it can be restored when the object receives a set cursor to 0 message
Cursor | Sets the cursor to the passed cursor_type
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for CursorShape

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for CursorShape

View method list in alphabetical order

Name | Type | Description
Cursor_Ready | Procedure |
Cursor_Wait | Procedure |
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cVersionInfo

Properties Events Methods Index of Classes

Contains information relating to the application's embedded Version Information resources

Hierarchy

cObject
---cVersionInfo

Library: Common (Windows and Web Application) Class Library

Package: cVersionInfo.pkg

Description

Use this class to determine whether Version Information was embedded into an application, and if it was, to retrieve information from it.

Note: The cApplication class automatically instantiates an object of this class (and exposes it through its phoVersionInfo property), so typically you do not need to create objects of this class directly.

To test if Version Information was included, use the pbIncluded property. To retrieve the build numbers, use the piVersionMajor, piVersionMinor, piVersionRelease and piVersionBuild properties. The pbSpecialBuild and pbPrivateBuild properties will indicate whether the application was flagged as being either "Special" or "Private" when it was compiled.

To read version information about a different application than the current one, use the DoCreate method.

Sample

This sample shows how to retrieve Version Information that was embedded in an application.

Object oApplication is a cApplication
    Procedure OnCreate
        Boolean bIncluded
        Handle hoVersionInfo

        Get phoVersionInfo To hoVersionInfo
        Get pbIncluded of hoVersionInfo To bIncluded
        If bIncluded Begin
            Showln "Special build=" (pbSpecialBuild(hoVersionInfo))
            Showln "Private build=" (pbPrivateBuild(hoVersionInfo))
            Show   "Build=" (piVersionMajor(hoVersionInfo)) "."
            Show   (piVersionMinor(hoVersionInfo)) "."
            Show   (piVersionRelease(hoVersionInfo)) "."
            ShowLn (piVersionBuild(hoVersionInfo))
        End
        Else ;
            Showln "Sorry, Version Information was not embedded in the application"

    End_Procedure
End_Object

See Also

cApplication

Last Edited: November 9, 2006


Properties for cVersionInfo

View property list in alphabetical order

Name | Description
pbIncluded | Indicates whether Version Information resources have been included in the application
pbPrivateBuild | Indicates whether the application is marked as being a "Private Build"
pbSpecialBuild | Indicates whether the application is marked as being a "Special Build"
piVersionBuild | Retrieves the "build" part of the build number
piVersionMajor | Retrieves the "major" part of the build number
piVersionMinor | Retrieves the "minor" part of the build number
piVersionRelease | Retrieves the "release" part of the build number
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cVersionInfo

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cVersionInfo

View method list in alphabetical order

Name | Type | Description
DoCreate | Procedure | Reads the version information from a named application
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cWebApp

Properties Events Methods Index of Classes

Creates a web application wrapper object, which is used to contain all Web Browser Objects (WBOs) and Web Service Objects (WSOs)

Hierarchy

cObject
---cWebApp

Library: Web Application Class Library

Package: cWebApp.pkg

Description

The cWebApp class creates a web application wrapper object, which is used to contain all Web Browser Objects (WBOs) and Web Service Objects (WSOs).

Usage

Sample

Use cWebApp.pkg
Object ProgramWorkspace is a Workspace
    Set WorkspaceName to "WebOrder"
End_Object
Object Main is a cWebApp
    // These are the only properties supported by this class
    Set psLabel  to "WebAppOrder"
    Set psDescription to "Sample Web Order Entry System"
    Set psProductName to "Order Entry for the web"
    Set psAuthor   to "Author: John J. Smth"
    Set psCopyright   to "Copyright JJS Worldwide 1999"
    Set psVersion  to "Version: 1.00"
    Set psLogo to "myWebAppLogo.bmp" // 42 x 42 is best size
    //Set peHtmlOutput to C_hoConsole  // for testing purposes only
    // this includes cWebBusinessProcess objects
    Use SalesP.wbo
    Use Customer.wbo
    Use Vendor.wbo
    Use Invt.wbo
    Use login.wbo

   End_Object
Start_UI

Of Special Note

The properties of this object are used only to assist in the maintenance of the application. The COMWBO on the ASP side uses none of these properties.

Normally, a WebApp program is run as part of a web server application and is run on the web server. However, when run in this mode, the application has no visual representation on the server's console.

You can also run a WebApp program directly. While this program will be unable to interact with the Web Server it does serve a very useful purpose. When run directly, an application panel will display on your console. The panel displays basic information about the web application (Label, Description, ProductName, Author, Copyright, Version and a Bitmap Logo). Running this panel verifies that your WebApp program is properly compiled and can be run.

IMPORTANT: If you cannot run a WebApp program directly you will not be able to run it as part of a web server application. You should always first verify that your program will run directly by using the "Run a WebApp" button in the Studio.

When run directly, you can choose to view application details by clicking the Details button. This displays relevant information about the running program in an edit window that opens up. In addition, a copy of this data will be written to a text file named "WebApp.txt" in your workspace's data directory.

A second button, Xml out writes similar data in XML format. This file is written to a file named "WebApp.xml" in your workspace's data directory.

Both of these output methods display information about each web browser object in the application. For each WBO, the following information is provided:

  • A list of all DDO objects. The Main-DDO is identified and all field.field values are presented for each DDO.
  • All public interface information, including:
  • Whether the Requestxxxx operations are allowed (e.g., RequestSave)
  • A list of all options for the DDValue interface
  • A list of all messages registered as public Call messages.

Note: The term public refers to messages that are used from within your ASP files via the COMWBO object.

The CWebApp class has no external methods.

Last Edited: November 21, 2004


Properties for cWebApp

View property list in alphabetical order

Name | Description
peAttachStatus |
peHtmlOutput | Redirects Html output while debugging a program
WBOCount |
WBOHandle |
WSOCount |
WSOHandle |
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cWebApp

View event list in alphabetical order

Name | Description
OnAttachProcess | When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object
OnDetachProcess | When process pooling is used, this event is sent first to the WebApp object and then to every WBO object
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cWebApp

View method list in alphabetical order

Name | Type | Description
DoDetachAllTables | Procedure |
DoInterfaceReport | Procedure |
EnumerateWBOs | Procedure |
EnumerateWSOs | Procedure |
IgnoreError | Procedure |
LogEvent | Procedure |
StartWebApp | Procedure |
TrapAllErrors | Procedure |
TrapError | Procedure |
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cWebBusinessProcess

Properties Events Methods Index of Classes

Creates Web Browser Process objects - the basic component of all Browser based Web Applications

Hierarchy

cObject
---cDistributedBusinessProcess
------cRemoteEntryProcess
---------cInternetSessionBusinessProcess
------------cWebBusinessProcess

Library: Web Application Class Library

Package: cWebBusinessProcess.pkg

Mixins: HtmlFormat_Mixin HtmlWrite_Mixin WmlFormat_Mixin WmlWrite_Mixin

Description

Web Applications consist of a web application object (cWebApp) that contains Web Objects (WOs). Web Objects can be Web Browser objects (WBOs - cWebBusinessProcess) and Web Service Objects (WSOs - cWebService).

The cWebBusinessProcess class is used to create Web Browser objects. They contain complete stand-alone and independent data-entry units that may include their own DDO structure and all interfaces required to perform operations (e.g., saves, finds, deletes and any custom process). An important function of this class is to communicate between the WebCom objects and the DataDictionary Structure. The interfaces available in this class allow you to retrieve or send data from your ASP page.

The ddValue function is most often used in ASP code. For more information on this functionality, please see the section ddValue Function in the Creating Active Server Pages book.

DataDictionary Information Options

These options return data dictionary field information. This information can be used within HTML input controls, within HTML general text, or within server side scripts. Some of these are of limited use but are provided to give an ASP file complete access to a field's DD values.

Options 0-99 for DataDictionary field information values

# | Option Symbol Name | Return Value
0 | DDCRNTVALUE | Field_Current_Value
1 | DDDESC | Field_Current_Description
2 | DDLONGLABEL | Field_Label DDLONGLABEL
3 | DDSHORTLABEL | Field_Label DDSHORTLABEL
4 | DDTAGLABEL | Field_Label DDTAGLABEL
5 | DDSTHELP | Status_Help
6 | DDOPT | File_Field_options (w/ foreign support)
7 | DDVALNUM | Number of val-table items
8 | DDVALDATA | Data value for val-table [pass index]
9 | DDVALDESC | Desc value for val-table [pass index]

Example

Here is an example of using the ddValue function in VDF code in a WBO.

Function ChangeOrderDtl Integer iOrderNo Integer iDetailNo Integer iQty Returns Integer
    Integer iTmpQty bOk

    Get ddClear "OrderDtl" to bOK
    Send SetDDValue "Orderdtl.Order_Number"  iOrderNo
    Send SetDDValue "Orderdtl.Detail_Number" iDetailNo
    Get ddFind "Orderdtl" 1 EQ to bOk
    If (bOk) Begin
        Get ddValue "Orderdtl.Qty_Ordered" to iTmpQty
        Move (iTmpQty + iQty) to iTmpQty
        Send SetddValue "Orderdtl.Qty_Ordered" iTmpQty
        Get ddSave "Orderdtl" to bOK  // does a save and validate
    End

     Function_Return (bOK=0)  // if error return True
End_Function //  IncOrderDtl

Usage

Example

Use cWebBusinessProcess.pkg
Use DataDict.pkg

Use CUSTOMER.DD

Object oHelloWBO is a cWebBusinessProcess

    Object Customer_DD is a Customer_DataDictionary
        Send DefineAllExtendedFields
    End_Object    // Customer_DD

    Set Main_DD to Customer_DD

    Function HelloAgain string sFirst string sLast returns string
        string sReply
        Move ("Hello again," * sFirst * sLast - ", here we are again") to sReply
        Function_Return sReply
    End_Function

    Send RegisterInterface get_HelloAgain "get_HelloAgain" "string sFirst string sLast Returns string" ""
End_Object    // oHelloWBO

Note: The RegisterInterface message and corresponding messages defined in this class, allow most messages to be exposed to the ASP script side. Methods are registered by publishing them within the Studio

Last Edited: August 10, 2006


Properties for cWebBusinessProcess

View property list in alphabetical order

Name | Description
psAutoEntryDataEnd | Determines the appearance of the end of the entry data that are created by the AutoEntry message
psAutoEntryDataStart | Determines the appearance of the start of the entry data that are created by the AutoEntry message
psAutoEntryLabelEnd | Determines the appearance of the end of the entry labels that are created by the AutoEntry message
psAutoEntryLabelStart | Determines the appearance of the start of the entry labels that are created by the AutoEntry message
Inherited Properties from cInternetSessionBusinessProcess
pbAllErrorstoEventLog | Determines if errors will be placed in the event log
pbAllErrorsToHtml | Determines if non-queued errors are sent
pbAllErrorstoLocal | Determines if errors are directed to the standard VDF error handler
pbQueueErrors | Determines where errors are placed
pbUseOpenEvalInterface | Determines if the Call interface should allow access to all WBO messages
pbVerboseErrors | Determines how much information is presented when an HTML error is displayed
psDescription | Adds a description to the WBO object
Inherited Properties from cRemoteEntryProcess
pbAllowClear | Determines whether the WBO object will support the Clear operation
pbAllowDDUpdate | Determines whether the WBO object will support update operations to the DataDictionary
pbAllowDelete | Determines whether the WBO object will support the Delete operation
pbAllowFind | Determines whether the WBO object will support the Find operation
pbAllowSaveEdit | Determines whether the WBO object will support an edit Save operation
pbAllowSaveNew | Determines whether the WBO object will support a new Save operation
pbClearAfterSave | Determines what should happen after a successful save
pbReportErrors | Suppresses the automatic generation of errors when set false
peFieldMultiUser | Determines if the data submitted by a web application browser should report changes at the field level
phREO_MainDD |
piREO_OperationStatus |
Inherited Properties from cDistributedBusinessProcess
Main_dd | Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function
pbClearDDOsOnDetach |
pbShowEntryError |
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cWebBusinessProcess

View event list in alphabetical order

Name | Description
Inherited Events from cRemoteEntryProcess
OnReportClearStatus | After a clear operation, augments point to handle whatever additional processing is required
OnReportDeleteStatus | After a delete operation, augmentats point to handle whatever additional processing is required
OnReportFindStatus | After a find operation, augments point to handle whatever additional processing is required
OnReportSaveStatus | After a save operation, augments point to handle whatever additional processing is required
OnReportValidateStatus | After an update operation, augments point to handle whatever additional processing is required
Inherited Events from cDistributedBusinessProcess
OnAttachProcess | When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object
OnDetachProcess | When process pooling is used, this event is sent first to the WebApp object and then to every WBO object
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cWebBusinessProcess

View method list in alphabetical order

Name | Type | Description
AutoEntry | Function | Creates a label and an input control for each field in the passed file name
AutoReport | Function | Generates a report for the passed filename, using the passed index with support for hypertext links to another web page
CreateFindIndexCombo | Function | Creates a control that lists all available indexes for a table
DDAutoControl | Function |
ddClear | Function | Clears the DataDictionary buffer
DDComboControl | Function |
DDComboOptions | Function |
ddDelete | Function | Deletes current record in the DataDictionary buffer
DDEditControl | Function |
DDFieldErr | Function |
ddFind | Function | Finds a record and places it in the DataDictionary buffer
ddFindbyRecId | Function | Finds a record using passed record id (RECNUM) and places it in the DataDictionary buffer
ddFindbyRowId | Function |
ddFindFirst | Function | Finds first record and places it in the DataDictionary buffer
ddFindLast | Function | Finds last record and places it in the DataDictionary buffer
ddFindNext | Function | Finds next record and places it in DataDictionary buffer
ddFindPrev | Function | Finds previous record and places it in DataDictionary buffer
DDFormControl | Function |
DDHndValue | Function | Called within an ASP file by using the DDValue message
DDParentComboControl | Function |
DDRadioControl | Function |
DDReadOnlyHTML | Function |
DDRecsOptions | Function |
DDRowIdsOptions | Function |
ddSave | Function | Performs a data validation and, once validated, saves a record using the current information in the DataDictionary buffer
DDTitleHTML | Function |
ddValidate | Function | Validates all fields using current data in the DataDictionary buffer
DDWMLInputControl | Function |
DoRequestFindbyRecId | Function | Performs a find by Record ID for the passed file name and record number
DoRequestFindbyRowId | Function |
Html_Ctrl_Name | Function |
Html_Ctrl_RowId_Name | Function |
HtmlAnchor | Function | Adds an Html Anchor
HtmlBig | Function | Makes the string big
HtmlBlink | Function | Makes the string blink
HtmlBold | Function | Makes the string bold
HtmlEmph | Function | Makes the string emphasized
HtmlFixed | Function | Makes the string fixed width
HtmlFontcolor | Function | Sets the strings font color
HtmlFontsize | Function | Sets the font size
HtmlHeader | Function | Creates a header string of level iHeader
HtmlItalics | Function | Makes the string italics
HtmlLink | Function | Adds a hyperlink to a string
HtmlSmall | Function | Makes the string small
HtmlStrike | Function | Overstrikes through the string
HtmlStrong | Function | Adds strong emphasis to the string
HtmlSub | Function | Makes the string subscript
HtmlSup | Function | Makes the string superscript
IndexMainField | Function |
RegisterAutoEntryInterface | Procedure | Provides ASP support for the AutoEntry function
RegisterBasicErrorInterface | Procedure | Adds messages that are often needed when creating ASP pages, that require special error handling within the ASP page
RegisterDDInterface | Procedure |
RegisterDebugInterface | Procedure | Adds messages that are often needed when debugging programs
RegisterFullErrorInterface | Procedure | Adds messages that are often needed when creating complex ASP pages, that require full information about errors within a WBO process
RegisterStandardInterface | Procedure | The Call messages that are often needed for a normal program
ValTbl_ItemData | Function |
ValTbl_ItemDesc | Function |
ValTbl_Items | Function |
WmlAnchor | Function | Adds an Wml Anchor
WmlBig | Function | Makes the string big
WmlBold | Function | Makes the string bold
WmlCreateFindIndexSelect | Function |
WmlEm | Function | Makes the string emphasized
WmlItalics | Function | Makes the string italics
WmlLink | Function | Adds a hyperlink (sURL) to a string (sDat)
WmlSmall | Function | Makes the string small
WmlStrong | Function | Adds strong emphasis (usually appears as bold) to the string
WriteData | Procedure | Like WriteHtml except it is used to output data by an address pointer
WriteHtml | Procedure | Outputs the passed string to the web page and ends the line
WriteHtmlBreak | Procedure | Outputs the passed string and ends the line
WriteHtmlCell | Procedure | Outputs a table cell containing sData
WriteHtmlCellHeader | Procedure | Outputs a table header cell containing sData
WriteHtmlHorzLine | Procedure | Outputs a horizontal line to the HTML file
WriteHtmlPlainText | Procedure | Encodes and then outputs the passed text to the HTML file
WriteHtmlRowBegin | Procedure | Outputs a "begin" row HTML string
WriteHtmlRowEnd | Procedure | Outputs an end row html string
WriteHtmlTableBegin | Procedure | Outputs a "begin" table html string
WriteHtmlTableEnd | Procedure | Outputs an end table html string
WriteWml | Procedure | Outputs the passed string to the web page and ends the line
WriteWmlBreak | Procedure | Outputs the passed string and ends the line
WriteWmlCell | Procedure | Outputs a table cell containing sData
WriteWmlDataBegin | Procedure | Outputs a begin table data WML string
WriteWmlDataEnd | Procedure | Outputs an end table data WML string
WriteWmlImg | Procedure | Adds a WML image
WriteWmlRowBegin | Procedure | Outputs a "begin" row WML string
WriteWmlRowEnd | Procedure | Outputs an end row WML string
WriteWmlTableBegin | Procedure | Outputs a "begin" table html string
WriteWmlTableEnd | Procedure | Outputs an end table wml string
Inherited Methods from cInternetSessionBusinessProcess
ClearErrors | Procedure | Clears the error queue
Cookie | Function |
Cookie | Procedure Set |
CookieAttribute | Procedure Set |
DDCurrentValue | Function |
DDValue | Function | Returns the value of a file.field from the DataDictionary in a specified form
DDValueEncode | Function | Returns the value of a file.field from the DataDictionary in HTMLEncoded form
DoGetHtmlFormValue | Function | Obtains the value of any posted HTML form value
DoGetHtmlQueryString | Function | Obtains the value of any ASP variables
ErrorCount | Function | Returns the number of errors in the current error queue
ErrorMessage | Function | Returns an HTML formatted error message for item iItem in the error queue
ErrorQueueEnd | Procedure | Ends an error queue process
ErrorQueueStart | Procedure | Starts an error queue process
FileFieldErrorItem | Function | Checks the error queue for an error associated with the passed file and field
isFieldChanged | Function |
LogErrorEvent | Procedure | Logs an error event
LogEvent | Procedure | Logs an event to the Web Application's event log
RegisterInterface | Procedure | Registers a message (property, function, procedure) and make it available as a Call message within an ASP page
RemoveInterface | Procedure | When sent, removes any message from the Call interface
ReportAllErrors | Procedure | Generates a list of all errors that have occurred since this error queue was last cleared
ReportErrorItem | Procedure | Displays the error for iItem in the error queue
ReportLastError | Procedure | Displays the last error in the error queue
Search_Field_Name | Function |
Search_File_Name | Function |
ServerVariable | Function |
SetChangedFields | Procedure |
SetDDCurrentValue | Procedure |
SetDDHndValue | Procedure |
SetDDValue | Procedure | Directly sets the value of a file.field in the DataDictionary buffer
Inherited Methods from cRemoteEntryProcess
ClearConfirmation | Function |
DeleteConfirmation | Function |
DoRequestClear | Function | Generates a remote clear process
DoRequestDDUpdate | Function | Provides another way to build the WBO's data dictionary structure based on information passed from the browser
DoRequestDelete | Function | Generates a remote delete process
DoRequestFind | Function | Performs a field find for the passed file name, field name and find mode
DoRequestSave | Function | Generates a remote save process
SaveConfirmation | Function |
Inherited Methods from cDistributedBusinessProcess
MapFileNametoDD | Function |
MaptoFieldNumber | Function |
MaptoFileNumber | Function |
RequestFileFieldValues | Procedure |
RequestFileRecords | Procedure |
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cWebReport

Properties Events Methods Index of Classes

Creates HTML reports to be used with WebApp Server

Hierarchy

cObject
---cReport
------cReportDS
---------cBasicReport
------------cHtmlReport
---------------cWebReport
------------------cAutoWebReport
------------------cWmlreport

Library: Web Application Class Library

Package: cWebReport.pkg

Description

The cWebReport class is used to create HTML reports. It has been specifically designed to work with WebApp applications with all output by default being generated to the web page being built.

Example

Object oReport is a cWebReport
    Procedure OnPageTop
        Send WriteHtmlTableBegin 'border="0" width="99%" Class="ReportTable"'
        Send WriteHtmlRowBegin
            Send WriteHtmlCellHeader 'Number' 'Class="Header" Align="right"'
            Send WriteHtmlCellHeader 'Customer Name' 'Class="Header" Align="left"'
            Send WriteHtmlCellHeader 'Address' 'Class="Header" Align="left"'
            Send WriteHtmlCellHeader 'City' 'Class="Header" Align="left"'
            Send WriteHtmlCellHeader 'St.' 'Class="Header" Align="left"'
            Send WriteHtmlCellHeader 'Zip' 'Class="Header" Align="left"'
        Send WriteHtmlRowEnd
    End_Procedure // OnPageTop
    Procedure OnBody
        String sText
        Send WriteHtmlRowBegin
            Get AddRecordLink (FormatNumber(Customer.Customer_Number,0)) to sText
            Send WriteHtmlCell sText 'Class="Data" Align="right"'
            Send WriteHtmlCell (HtmlEncode(Customer.Name)) 'Class="Data" Align="left"'
            Send WriteHtmlCell (HtmlEncode(Customer.Address)) 'Class="Data" Align="left"'
            Send WriteHtmlCell (HtmlEncode(Customer.City)) 'Class="Data" Align="left"'
            Send WriteHtmlCell (HtmlEncode(Customer.State)) 'Class="Data" Align="left"'
            Send WriteHtmlCell (HtmlEncode(Customer.Zip)) 'Class="Data" Align="left"'
        Send WriteHtmlRowEnd
    End_Procedure // OnBody
    Procedure OnPageBottom
        Send WriteHtmlTableEnd
    End_Procedure // OnPageBottom
    Function RunCustomerReport integer iIndex integer iStart integer iMax Returns Integer
        Integer iEnd iStat
        Set piOrdering           to iIndex
        Set piMaxCount           to iMax
        Set piMaxCountBreakLevel to 0
        Set piStartRecord        to iStart
        Get DoRunReport          to iStat
        Get piLastRecord         to iEnd
        Function_return iEnd
    End_Function // RunCustomerReport
End_Object // oReport
Procedure SetHRefName string sName
        Set psHRefname of oReport to sName
    End_Procedure // SetHRefName
    Function RunCustomerReport integer iIndex integer iStart integer iMax Returns Integer
        Integer iEnd
        Get RunCustomerReport of oReport iIndex iStart iMax to iEnd
        Function_return iEnd
    End_Function // RunCustomerReport
End_Procedure

In the above sample, sending the message RunCustomerReport to the WBO runs the report. This message could be sent from an ASP file using the following code:

<% Lastrec=WBO.Call( "get_RunCustomerReport", iIndex,iStart,iMax) %>

Understanding cWebReport

Using the Report Wizard

The best way to learn about the report object is to use the report wizards to generate test reports. The wizards will generate WBO and ASP code that shows you how to:
1. Connect reports to a DDO structure
2. Create DDO constraints (record filters for the report)
3. Create report indexes which can be selected at runtime.
4. Display properly formatted record data.
5. Create drill down and zoom reports
6. Create a child report with a breakpoint
7. Create partial reports where a large report is presented as a series of mulitple report pages

This code will also show you how the ASP and WBO objects interact with each other.

The Report Process

When you start a report you should have already set properties and messages that determines the report's:

1. Main DDO: Server
2. Index Order: piOrdering
3. Constraints: OnConstrain in the DDO
4. Record Count Limit: piStartRecord, piMaxCount, piMaxCountBreakLevel
5. Breakpoints: OnInitBreakpoints, RegisterBreakpoint

A typical report consists of the following sections:

1. Page Top: OnPageTop
2. Subheaders: OnSubHeader1 . OnSubHeader9
3. A Body: OnBody
4. Subtotals: OnSubTotal1 . OnSubTotal9
5. Page Bottom: OnPageBottom

When a report is run it will first call the event OnPageTop. It is expected that you will create code that set up the report. This often consists of creating an Html table and a header row.

The report will find records in the index order specified. If the DDO's constraints allow it, this finding will be optimized. The report will jump in and jump out of the index when required.

For each valid record, all breakpoint levels will be checked. A break condition occurs if the new record contains a breakpoint value that is different than the previous value. When a breakpoint occurs all sub-total sections are called as needed (the OnSubTotalx event). Then, all sub-header setions are called as needed (the OnSubHeaderx event).

Once breaks are processed the OnBody event is called. It is expected that you will add code to this event to support whatever kind of Html output you desire. You might also use this section to keep track of sub-total values.

This process continues until no more records are found or the maximum number of records have been encountered for this report. When this occurs, the event OnPageBottom is called. Normally this will end the table that was created in OnPageTop.

The Report's DDO Server and Main File

It is expected that a WebReport will be connected to a Data-dictionary server. By default, this server will be your WBO's main_DDO (phMainDD). If this is the case there is no need to explictly set a DDO server for the report. If you wish to center the report around a different DDO, you must explicitly set the report object's Server property. All reports must have a DDO server.

A report's main-file is determined by its DDO server. The main file is usually the report's child most file. Records are found based around this file. The report's order is determined by the index used from this main file. This index is determined by setting the property piOrdering.

Report Record Constraints

Often you will wish to create selection criteria for your reports. These criteria are not placed within the report object - they are placed inside of your DDO object using the OnConstrain procedure.Limiting the size of a Report

You rarely want to run very long reports over the internet. If a report is very long you will want some way to break this report into smaller sections. When your ASP page requests a report only a report section is processed and sent to the browser. The browser then needs a way to tell the server to send the next section (or page) of the report. The Report object provides a mechanism to do this.

The properties piStartRecord, piLastRecord, piMaxCount, and piMaxCountBreakLevel can be used to create partial report pages.

Breakpoints

The report object allows you to define breakpoints within a report. Each breakpoint will have an associated sub-header and sub-total section. A single report may contain up to nine levels of breakpoints.

When breakpoints are defined you must make sure that your report output order is an appropriate order for your breakpoints. If for example you create two break points of Customer.Status and Customer.Region, you should use an index that is Customer.Status x Customer.Region. If the order is wrong, your breakpoints will appear to random.

Each level of breakpoint requires a custom function that will return the value that should be evaluated for a break. If the value returned, is different than the value from the previous record, a break has occurred. When a break occurs, the old section's OnSubTotal message is called (as needed) and the new section's OnSubHeader message is called.

The following messages are used as part of breakpoint processing: OnInitBreakpoints, RegisterBreakpoint, OnSubHeader1..9, and OnSubTotal1..9.

Drill down and Linked Reports

A web report should usually not contain many breakpoint levels. Instead, you should design drill down reports where a cell in a table row contains a link to a web page that displays additional detail information about the row. For example, you may have a customer report where each row (customer record) contains a link to a page that starts a report that displays all orders for that one customer. That order report may contain a link in each of its order rows that links to a web page that starts a report that displays all detail rows for the selected order.

The report object and the report wizards provide easy mechanisms for creating drill down and link reports. The messages psHRefName, AddRecordLink and the global message HtmlLink can be used to create drill down and lined reports.

Maintaining Totals and Sub-Totals

Often you will need to maintain totals and sub-totals in your reports. The report object provides an interface for maintaining multiple accumulators. Each accumulator level can be used to maintain running totals which can be retrieved as needed.

Typically a sub-total is accumulated within the body of a report. During a break the sub-total may be printed. Usually when the total is printed and its total is cleared. Sometimes, before clearing the total, this sub-total will be added to yet another accumulated total (perhaps the total of all sub-totals).

You must keep track of which accumulator level is assigned to which total. Each accumulator is assigned a level. You may define an unlimited number of accumulation totals.

The messages AddSubTotal, SubTotal, SumSubTotal, ClearSubTotal and ClearAllSubTotals are used to maintain and manipulate totals within a report object.Maintaining Totals and Sub-Totals

Reporting database values in a Report

When a record is found the OnBody event is called (and possibly OnSubTotal and OnSubHeader events are also called.) When this event (or events) is called the DDO and the file buffer contain current record information. You will display this record information using some kind out Html output command - usually WriteHtmlCell.

Your DDO value can be retrieved one of two ways. You can get the DD's current field value by sending the message File_Field_Current_Value to the DDO as follows:

Get Server to hDDGet File_Field_Current_Value of hdd FILE_FIELD Customer.Name to sTextSend WriteHtmlCell (HtmlEncode(sText))Get File_Field_Current_Value of hdd FILE_FIELD Customer.Address to sTextSend WriteHtmlCell (HtmlEncode(sText))

Since, you know that your DDO file buffers also contain the current file information you could also choose to directly access the file buffer. This results in a simpler syntax.

Send WriteHtmlCell (HtmlEncode(Customer.Name))Send WriteHtmlCell (HtmlEncode(Customer.Address))

You can usually use this simpler syntax. There will be times when you need to access data through the data-dictionary. For example, you may have a field named OrderHea.Terms that is linked to a validation table. If you wish to display the values description instead of its data value you would need to access that description though the DDO as follows:

Get Server to hDDGet File_Field_Current_Description of hdd FILE_FIELD OrderHea.Terms to sTextSend WriteHtmlCell (HtmlEncode(sText))

You also may wish to access other DDO information such as a label value:

Get Server to hDDGet File_Field_Label of hdd FILE_FIELD Customer.Name DD_LABEL_LONG to sTextSend WriteHtmlCell (HtmlEncode(sText))Send WriteHtmlCell (HtmlEncode(Customer.Name))

Encoding and Formatting text and numbers

String and text values that are coming out of your data-files and DDOs should be encoded before they are sent to the web page. Encoding insures that special characters such as "<" and ">" are not interpreted by your browser as special Html tag symbols. To do this, you should always use the global function HtmlEncode on all strings and text.

Move ("Customer Balance is > than $1000") to sTextSend WriteHtmlCell sText // the > will cause a problem with your browserSend WriteHtmlCell (HtmlEncode(sText)) // this will probably encode the >

Numbers do not normally need to be encoded. However, you may wish to format your numbers before sending them to the browser. You can do this using the global functions FormatCurrency and FormatNumber.

Send WriteHtmlCell (FormatNumber(Customer.Customer_Number,0))Send WriteHtmlCell (FormatCurrency(Customer.Total,2))

Last Edited: December 16, 2004


Properties for cWebReport

View property list in alphabetical order

Name | Description
piLastRecord | (Obsolete) Holds the record that was processed when a report was halted because the maximum number of records was encountered
piMaxCount | Holds the maximum number of records to print
piMaxCountBreakLevel | Determines what is considered to be a "record" when record counting is used to create partial reports
piStartRecord | (Obsolete) Allows you to create partial reports providing a method for creating web report "pages"
priLastRowId | Holds the RowId of the record that was processed when a report was halted because the maximum number of records was encountered
priStartRowId | Determines the RowId of the first record of a report allowing you to create partial web reports
psHRefName | Holds the full URL of a file (ASP or HTML) to be displayed as part of a "drill down" operation
Inherited Properties from cHtmlReport
piConstrainFile | Used when creating reports to limit the printing to a single parent record and the related children
piConstrainRecord | (Obsolete) Used when creating reports to limit the printing to a single parent record and the related children
priConstrainRowId | Used when creating reports to limit the printing to a single parent record and the related children
Inherited Properties from cBasicReport
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button
Display_Error_State |
Output_Device | Handles the name of the output device
Report_Caption | Contains the text that will appear in the status panel's caption bar
Report_Message | An additional message area that will appear below the report_title in the status panel
Report_Status_Panel |
Report_Title | A centered title that appears in the status panel
Status_Log_Id | Object ID of status-log object
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs
Inherited Properties from cReportDS
Server | Identifies the object handle that is used as the report object's main data-dictionary object
Inherited Properties from cReport
Assigned_Channel |
Find_Mode | Maintains the current finding mode
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function
Last_Rec | (Obsolete) Contains the record number of the last selected record found
Main_File | Contains the filenumber of the file which the report will use for finding records
New_Page_State | Set true when a new page is needed
No_Constrained_Find_State | Determines if constrained record finding should be disabled
No_Finding_State | Determines how the cReport object will find records
No_PageCheck_State | Set true when the cReport object is processing a new page
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found
Page_Count | Keeps track of the current page number
Page_End | Determines how many lines on a page are allowed before a page break will occur
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence
Page_Feed | Used by the formfeed procedure
Page_Footer_Lines | The number of lines in the page_footer image
pbCanceled | Setting this true will cancel a report
pbChildReport | Set true if the current cReport object is nested
pbFindDown | Determines if the report should traverse up or down the index
pbHasChildReports | Is set true if other reports are nested inside this report object
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level
phMainReport | Contains the object ID of the outer report
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found
piNumberBreaks | Returns the number of breaks in a report
piOrdering | Contains the index number which will be used for finding records
piRecordCount | Contains the number of records found for the current report
priCurrentRec | Contains the RowId of the current valid record found
priFoundRec | Contains the RowId of the record found by the find_rec function
priLastRec | Contains the RowId of the last selected record found
Report_Channel | Determines which output channel will be used for your report output
Report_Footer_Lines | The number of lines in the OnReportFooter image
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cWebReport

View event list in alphabetical order

Name | Description
OnInitBreakPoints | Determines the number and order of your breakpoints
Inherited Events from cBasicReport
Error_Report | Sent whenever an error is generated
OnEndingMainReport | User Handler Intended for override
onError | Provided as a hook to handle custom error reporting
OnStartingMainReport | Called when a report is started
Report_Interrupt | Called when the status panel's Cancel button has been pressed
Inherited Events from cReport
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property
Final_Formfeed |
OnBody | Called every time a valid record has been found
OnConstrain |
OnEndingReport | Called at the end of all reports
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables
OnPageFooter | Printed after OnPageTotal on every page except the last page
OnPageHeader | Called after OnPageTop on every new page except the first
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader.
OnPageTop | Called when printing the top of every report
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page
OnReportFooter | Printed after OnPageTotal on the last page of the report
OnReportHeader | Called only on the first page of the report, after OnPageTop
OnSelection | Validates a record
OnStartingReport | Called when a report is started
OnSubHeader1..n | Called each time a subheader needs to be printed
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program
OnSubTotal1..n | Called when a subtotal needs to be processed
OnTotal | Called at the end of a report after all final sub-totals have been printed
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cWebReport

View method list in alphabetical order

Name | Type | Description
AddRecordLink | Function | (Obsolete) Creates a cell that contains a link to another web page
AddRowIdLink | Function | Creates a cell that contains a link to another web page
RegisterBreakpoint | Procedure | registers a breakpoint function
Inherited Methods from cHtmlReport
AddSubTotal | Procedure | Adds the passed value to the total maintained in level iCount
ClearAllSubTotals | Procedure | Clears all the SubTotal accumulators
ClearSubTotal | Procedure | Clears a single Subtotal accumulator
HtmlAnchor | Function | Adds an Html Anchor
HtmlBig | Function | Makes the string big
HtmlBlink | Function | Makes the string blink
HtmlBold | Function | Makes the string bold
HtmlEmph | Function | Makes the string emphasized
HtmlFixed | Function | Makes the string fixed width
HtmlFontcolor | Function | Sets the strings font color
HtmlFontsize | Function | Sets the font size
HtmlHeader | Function | Creates a header string of level iHeader
HtmlItalics | Function | Makes the string italics
HtmlLink | Function | Adds a hyperlink to a string
HtmlSmall | Function | Makes the string small
HtmlStrike | Function | Overstrikes through the string
HtmlStrong | Function | Adds strong emphasis to the string
HtmlSub | Function | Makes the string subscript
HtmlSup | Function | Makes the string superscript
SubTotal | Function | Returns the appropriate subtotal and clears the subtotal accumulator
SumSubTotal | Function | Returns the appropriate subtotal but does not clear the subtotal accumulator
WriteHtml | Procedure | Outputs the passed string to the web page and ends the line
WriteHtmlBreak | Procedure | Outputs the passed string and ends the line
WriteHtmlCell | Procedure | Outputs a table cell containing sData
WriteHtmlCellHeader | Procedure | Outputs a table header cell containing sData
WriteHtmlHorzLine | Procedure | Outputs a horizontal line to the HTML file
WriteHtmlRowBegin | Procedure | Outputs a "begin" row HTML string
WriteHtmlRowEnd | Procedure | Outputs an end row html string
WriteHtmlTableBegin | Procedure | Outputs a "begin" table html string
WriteHtmlTableEnd | Procedure | Outputs an end table html string
WriteLn | Procedure | Outputs the string and ends the Line
Inherited Methods from cBasicReport
End_Log | Procedure | Sends an end-log message to the log object
Error_Log_Status | Procedure | Called by error_report if status_log_state is true
Log_Status | Procedure | Sends passed message to the log object
Start_Log | Procedure | Sends a start-log message to the log object
Update_Status | Procedure | Send this message to update the action area of the status panel
Inherited Methods from cReportDS
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO
Request_Save | Procedure | If sent, this saves the current record
Inherited Methods from cReport
DoRunReport | Function | The main entry point for reportsT
Formfeed | Procedure | Handles formfeeds
Output_ImageNum | Procedure | Outputs the image represented by ImageNum
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cWebService

Properties Events Methods Index of Classes

Creates Web Service Objects - the basic component of all web-service based Web Applications

Hierarchy

cObject
---cWebService

Library: Web Application Class Library

Package: cWebService.pkg

Mixins: cCallInterfaceHelper_mixin

Description

Web Applications consist of a web application object (cWebApp) that contains Web Objects (WOs). Web Objects can be Web Browser objects (WBOs - cWebBusinessProcess) and Web Service Objects (WSOs - cWebService).

Web Service Object creates a Web-service. This web-service contains operations that can be called by remote clients. Each operation corresponds to a function inside of your WSO. You can make these functions do anything a normal DataFlex can do (in other words, you can do anything). WSO objects may contain a Data Dictionary object structure (DataDictionary ). This makes it easy to create web-services that communicate with your data and your data logic.

Web Service Objects are used to communicate with web-service clients. A web-service client will be part of some remote application. When needed, the application will make a call to the web-service client and the client will make the request to a web service. If this web service is part of a Visual DataFlex web-application, the request will be sent to as a function call within the WSO. This function will do whatever it needs to do, and return information to the client. Web Service clients are built in a Visual DataFlex windowss application using the cClientWebService class.

WSDLs - Service Descriptions

It is expected that any web-service provide a description of its service. This is done by providing a formal service description document that describes exactly how the service should be accessed. This document is called a WSDL document (Web Service Description Language).

A WSDL document tells you everything you need to know about a web-service. It tells you where the service is located, how it is accessed and what operations are available for the service. It defines the parameters and data-types for each operation. It also specifies exactly how the SOAP request and response should be encoded.

A WSDL document is an XML file. While it is human readable, it is really designed to be written (generated) and read (parsed) by a computer. On the server side, the Visual DataFlex web-application server generates WSDL documents. On the client side, Visual DataFlex contains a parser that reads WSDL documents and creates client web-service classes.

SOAP Headers

The SoapHeaderRequestNode and AddSoapHeaderNode methods provide a low level mechanism for working with SOAP headers.

Creating a Web Service Object

Web Service obejcts are created within the Visual DataFlex Studio as follows:

  • Create a New WSO component
  • Create your functions (operations) that you wish to make public
  • Publish these functions
  • Document the operations and the service
  • Set the name of the service
  • Save the component and add it to your web-application

Here are these same steps, described in more detail:

1. In the Studio, select the "File | New | Web Object." file menu option. You may also access Web Objects using the New button in the toolbar.

2. Select "Web Service Object". This will create a new Web Service component.

3. Using the Studio's code editor, edit the source code of the Web Service Object and write your code. To keep it simple, we suggest that you create a simple "Hello World" function to start with. This function may look like the following:

Function Hello string sName string sLast returns string
    string sReply
    Move ("Hello," * sName - ", how are you today") to sReply
    Function_Return sReply
End_Function

Note that this is a very simple example. A WSO object is a business process object and is capable of performing sophisticated operations. You can create data-dictionary object structures within the WSO and use web-service operations to store and retrieve data from your DDOs. You can create additional private processing methods within your WSO, which can be called by your public web-service operations. Additionally, you can choose to have your public operations access program logic outside of your WSO. Think of a web-service operation as a portal into your application, your application logic and your application data.

4. A WSO may contain many functions and not all of them should be exposed as a web-service. You expose a web-service method by publishing it. You do this by finding that method in Code Explorer's outline (the tree view on the left), right-click on the function and select Published from the context menu. After publishing the function, the Studio has inserted the following meta-data tags above the function declaration line in your source code:

{ Published = True }
{ Description = "" }

5. You may create an optional but recommended comment for any web-service function. This comment will be published as part of the service's description in the WSDL file. Type some descriptive text inside the quotes of the Description meta-data tag.

6. You will want to create a description for the entire web-service to be published as part of the service's description. You can do this by find the following source code and replacing it with meaningful information. This is done by setting the psDocumentation property within your code. Note that this source is broken up into multiple lines to demonstrate how to create long, yet readable description within the edit area.

Set psDocumentation to ;
    ("Visual DataFlex Web Service .... " +;
          " ... " +  ;
              "documentation")

7. You need to set the Service name. This name uniquely identifies the service within your application and is used by clients to access the service. For example, if the name of your service was "HelloService" in an application whose virtual directory was http://localhost/MyApplication the service would be accessed with the URL http://localhost/MyApplication/HelloService.wso. The name is set with the psServiceName property in the Object Properties window. The default name is tempService.

8. Save and test the component.

You can see more details about creating web services in the Creating Your First Web Service tutorial.

Supported Data-types

Web service parameters may consist of any of the following:

  • Fundamental data types - these are the built in simple data types (e.g. string, integer)
  • Struct data types - these are custom data types created using this struct command (e.g. tMyOrder)
  • Arrays - these can be arrays of fundamental or struct data types. (e.g. string[], integer[][], MyOrder[])
  • XmlHandle - this is a special type that indicates that the data is passed as XML

Structs, Arrays and XmlHandle data types can only be used with Document style web services (pbDocumentStyle = true).

Fundamental Data-types

The following fundamental DataFlex data-types can be used as parameters in web-services:

String | Number | Date | Integer
Bigint | Real | Boolean | Time
Datetime | Float | Char | Uchar
Short | Ushort | Uinteger | Ubigint
Currency | Decimal |  |

Any of these data-types may be passed or returned in a web-service. All of these data-types will map to an appropriate XML data-type as defined by the XML schema definitions. It is not expected that you will need to use most of these data-types. As with any DataFlex application, you will primarily use String, Number, Date and Integer.

Here are several very simple web-services operations using various data-types:

Function Echo String echoString Returns String
    Function_Return echoString
End_Function

Function SayHello String sName Returns String
    String sReturn
    Move ("Hello," * sName) to sReturn
    Function_Return sReturn
End_Function

Function TestDateTime DateTime dDateTime Returns String
    String sReturn
    Move ("The datetime in VDF locale is" * string(sDateTime) ) to sReturn
    Function_Return sReturn
End_Function

Struct Data-types

A web service parameter may be a custom defined type created using the struct command. Using struct parameters allows you to pass and return complex data (e.g. an order), as a single parameter. The struct members may consist of any of the allowed fundamental data types or other structs. Struct members may be defined as arrays.

This sample shows how to define and return struct data.

Struct tCustomerInfo
    integer iCustNumber
    string  sName
    string  sCustAddress
    string  sCity
    string  sState
    string  sZip
    string  sPhoneNumber
    string  sFaxNumber
    string  sEmailAddress
    real    rCreditLimit
    real    rPurchases
    real    rBalance
    string  sComments
    string  sStatus
End_Struct
:
Function GetCustomerInfo integer iCustNum Returns tCustomerInfo
    tCustomerInfo CustomerInfo
    Get CustomerInfo iCustNum to CustomerInfo // this finds the customer and fill the struct data
    Function_Return OneCustomer
End_Function  // GetCustomerInfo

The following example is passed a more complex struct parameter that contains a member that is, itself, an array of structs.

// Order Detail
Struct tOrderDet
    string  sItemID
    integer iQty
    real    rUnitPrice
    real    rPrice
End_Struct

// Order
Struct tOrder
    integer     iOrderNumber
    integer     iCustNumber
    date        dOrdDate
    string      sTerms
    string      sShipVia
    string      sOrderedBy
    string      sSalesPerson
    real        rOrderTotal
    tOrderDet[] ArrayOfDetails
End_Struct
:
Function GetOrderInfo tOrder TheOrder returns Boolean
    Boolean bSuccess

    Send SaveTheOrder TheOrder
    Function_Return True
End_Function

Arrays

Any web service parameter may be defined as an array. Arrays may be based on fundamental data types or struct types. Arrays may be single or multi-dimensional. Note that not all web service clients are capable of supporting multi-dimensional arrays.

This sample is passsed an array of customers numbers and returns an array of struct customer information.

Function SelectedCustomerInformation integer[] iCustomers returns tCustomerInfo[]
    tCustomerInfo[] Customers
    integer i iCustomerCount

    Move (SizeOfArray(iCustomers)) to iCustomerCount
    For i from 0 to (iCustomerCount-1)
        Get CustomerInfo iCustomers[i] to Customers[i] // this finds the customer and fill the struct data
    Loop

    function_return Customers
End_Function

XmlHandle Data-type

A special data-type, XmlHandle may be defined as a parameter. The XmlHandle data-type should only be used with web-services. It is used when you define a function`s parameter or return data-type.

Function DelCustomerXMLList XmlHandle CustomerList Returns XmlHandle

Defining this data-type in a web-service function indicates that the data being passed and returned is an object handle pointing to an XML Dom object (based on the cXmlDomDocument class). This provides an easy mechanism for passing data as pure XML. Within your program you treat an XmlHandle data-type exactly the same way you would treat any object handle. The object can be parsed and processed using the standard methods provided for handling XML DOM objects.

The one important distinction about this data-type is that the VDF web-services module will automatically handle the disposal of these objects when they are no longer needed. You do not need to destroy these objects yourself.

For example, this web-service operation is passed an XML document containing customer information. The service will search for customers to be deleted and attempt to delete these based on the rules in the data-dictionary. It will then return an XML document containing a list of remaining customers. Notice that the XML data is passed in and out as objects.

Function DelCustomerXMLList XmlHandle CustomerList Returns XmlHandle
   Integer bOk i iItems
   Handle hoRoot hoList hoCust hoWrapper hoXml1 hoRoot1
   String sDel sNumber
   Handle hoCustomerDD hoXML
   Move Customer_dd to hoCustomerDD

   If not CustomerList function_return 0

   Get DocumentElement Of CustomerList To hoRoot
   // create node list of all customers
   Get FindNodeList Of hoRoot "Customer" To hoList
   Get NodeListLength Of hoList To iItems // number of items in our node list.
   Decrement iItems
   // go through array looking for customers to delete
   For i From 0 To iItems
       Get CollectionNode Of hoList i To hoCust
       // if attribute "Delete" is "Y" we will delete it
       Get AttributeValue Of hoCust "Delete" To sDel
       If (sDel="Y") Begin
            // attempt to delete customer
            Get ChildNodeValue Of hoCust "Number" To sNumber
            Send Clear of hoCustomerDD
            Move sNumber to Customer.Customer_number
            Send Find of hoCustomerDD eq 1
            If (found) Begin
                Send Request_delete of hoCustomerDD
                If not (err) begin
                    Get RemoveNode Of hoRoot hoCust To hoCust
                End
            End
       End
       //
       Send Destroy Of hoCust
   Loop
   Send Destroy Of hoList

   Function_Return CustomerList
End_Function

Using XmlHandle versus Using Struct/Array Data-types

Passing data as pure XML has advantages and disadvantages. This provides a mechanism for passing and returning complex data. Often this type of complex data is most efficiently processed as an XML DOM object. The disadvantage of using XML as a parameter is that the data is not fully defined within the WSDL description. The WSDL document simply knows that the data is a well formed XML document.

If you need to pass complex data that is fully defined within the WSDL description, you can pass the parameters as structs and arrays. The above example could easily be rewritten to use an arrays of structs as follows:

Struct tCustomerList
    integer   iCustomerNumber
    string     sCustomerName
    Boolean bDelete
End_Struct
:
Function DelCustomerXMLList tCustomerList[] CustomerList Returns tCustomerList[]
    tCustomerList NewCustomerList
    Integer i iCustomerCount  iNewCount
    Boolean bWasDeleted

    Move Customer_dd to hoCustomerDD

    Move (SizeOfArray(CustomerList)) to iCustomerCount
    // go through node list looking for customers to delete
    For i From 0 To (iCustomerCount-1)

        If CustomerList.bDelete begin
            // attempt to delete customer
            Send Clear of hoCustomerDD
            Move CustomerList.iCustomerNumber to Customer.Customer_number
            Send Find of hoCustomerDD eq 1
            If (found) Begin
                Send Request_delete of hoCustomerDD
                Move (not(err)) to bWasDeleted // it is possible the delete will not be allowed
            End
       End
       Else Begin
            Move False to bWasDelete
       end
       if not bWasDeleted
           Move CustomerList[i] to NewCustomerList[iNewCount]
           Increment iNewCount
       end
    Loop
    Function_Return NewCustomerList
End_Function

Usage

Example

Use cWebService.pkg
Use DataDict.pkg

Use CUSTOMER.DD

Object oHelloWSO is a cWebService

    //------------------------------------------------------------------------------------
    // psDocumentation provides high level documentation of your web service. Clients using
    // this service will see and use this documentation.
    //------------------------------------------------------------------------------------
    Set psDocumentation to ;
        ("Visual DataFlex Web Service that can do all kind of good" +;
          "things to make your life easier")

    Set psServiceName to "HelloService"
    Set psServiceURI to "http://tempuri.org/"
    Set psServiceTitle to "Visual DataFlex Web Service"

    Object Customer_DD is a Customer_DataDictionary
        Send DefineAllExtendedFields
    End_Object    // Customer_DD

    Set Main_DD to Customer_DD

    Function Hello string sFirst string sLast returns string
        string sReply
        Move ("Hello," * sFirst * sLast - ", here we are again") to sReply
        Function_Return sReply
    End_Function

    Send RegisterInterface get_Hello "get_Hello" "string sFirst string sLast Returns string" "What do  you think it's going to do."
End_Object    // oHelloWSO

Note: The RegisterInterface message determines which functions in your WSO should be exposed as a public operation. Methods are registered by publishing them within the Studio

Last Edited: November 2, 2006


Properties for cWebService

View property list in alphabetical order

Name | Description
Main_dd | Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function
pbAllErrorstoEventLog | Determines if errors will be placed in the event log
pbAllErrorstoLocal | Determines if errors are directed to the standard VDF error handler
pbDocumentStyle | Determines if a Web Service should use Document or RPC style
psDescription | Provides a short description of a web-service
psDocumentation | Provides documentation for a Web-service that is added to the WSDL document
psServiceName | Determines the service name
psServiceTitle | Provides a Title for your web-service
psServiceURI | Determines the TargetNamespace URI for your web-service
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cWebService

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cWebService

View method list in alphabetical order

Name | Type | Description
AddSoapHeaderNode | Procedure | Adds a SOAP header node to a method's SOAP response.
LogErrorEvent | Procedure | Logs an error event
LogEvent | Procedure | Logs an event to the Web Application's event log
RegisterInterface | Procedure | Registers a message (property, function, procedure) and make it available as a Call message within an ASP page
RegisterStandardInterface | Procedure |
RemoveInterface | Procedure | When sent, removes any message from the Call interface
SoapHeaderRequestNode | Function | Returns SOAP header information passed to the web service as an XML object.
WebServiceException | Procedure | Used to generate a web service exception (soap fault)
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cWinControl

Class: cWinControl (Abstract)

Properties Events Methods Index of Classes

Provides a base class to use when subclassing a Windows control

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------cWinControl
---------------------cAnimation
---------------------cProgressBar
---------------------cStatusBar
---------------------cToolbar

Library: Windows Application Class Library

Package: cWinControl.pkg

Description

Provides a base class to use when wanting to subclass a Windows class. You should not instantiate this class directly, but instead, create subclasses from it.

The class provides low-level mouse messages, and allows you to create message handlers for Windows events. To enable an object of this class, use the pbEnabled property and to control its visibility, use pbVisible.

To create an external-class, you must set External_Class_name, and to handle Windows messages, you must set External_Message, as in this example:

Class cMyControl is a cWinControl
    Procedure Construct_Object
        Forward Send Construct_Object
        Set External_Class_Name "cMyControl" To "Static"
        //Set External_Message WM_XXX To msg_OnWmXXX
    End_Procedure

    Procedure Command Integer wParam Integer lParam
        // showln "Windows Command message received!"
    End_Procedure

    Procedure Notify Integer wParam Integer lParam
        // showln "Windows Notify message received!"
    End_Procedure

    Procedure OnWmXXX Integer wParam Integer lParam
        // received the WM_XXX Windows message
    End_Procedure

End_Class

Note:cWinControl replaces the obsolete DFControl class.

Last Edited: December 20, 2005


Properties for cWinControl

View property list in alphabetical order

Name | Description
pbEnabled | Enables the control to take user input
pbVisible | Makes a control visible or invisible
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cWinControl

View event list in alphabetical order

Name | Description
OnMouseDoubleClick | Received whenever a mouse button is double-clicked on the control
OnMouseDown | Received whenever a mouse button is pressed on the control
OnMouseMove | Received whenever the mouse cursor moves over a control
OnMouseUp | Received whenever a mouse button is released on the control
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cWinControl

View method list in alphabetical order

Name | Type | Description
DoRecreateWindow | Procedure | Recreates a window
DoUpdateWindow | Procedure | Updates a window if it needs repainting
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cWinReport2

Properties Events Methods Index of Classes

Provides most of the capabilities of the BasicReport class and provides the ability to use WinPrint2 to provide more-graphical reports

Hierarchy

cObject
---Report
------Report_DS
---------BasicReport
------------cWinReport2

Library: Windows Application Class Library

Package: cWinReport2.pkg

Description

The WinReport2 class is a subclass of BasicReport. This provides most of the capabilities of the BasicReport class and provides the ability to use WinPrint2 to provide more-graphical reports (different font styles, font weights, font orientations, graphics, etc.). It does not use images for creating reports. Instead, output is specified with the WinPrint2 command extensions.

To support printing of reports in Windows (proportional) fonts. All reporting functions are supported, including nested reports. Objects of this class support all types of constraints including parent-file, full access to indexes with multi-level subsection totalling, and access to child-file records by parent-file indexes.

The cWinReport2 Wizard

The cWinReport2 wizard in the Studio makes it easy to get started with this class and is a great learning tool. Try generating some reports using this wizard. After the report is generated, load the report and study the code.

The Constants Interface

The cWinReport2 class uses a number of constants created for use by this class and its subclasses. The constant categories are:

  • Page Numbering Constants
  • Line Output Constants (Fonts, Colors, etc.)
  • Printer, Page, Output Constants

The Command Interface

The cWinReport2 class uses a number of commands created for use by this class and its subclasses. Those commands are:

  • DFBeginHeader
  • DFEndHeader
  • DFFont
  • DFFontSize
  • DFHeaderFrame
  • DFHeaderLineCheck
  • DFHeaderMargin
  • DFHeaderPos
  • DFHeaderWrap
  • DFLineCheck
  • DfTopMargin
  • DfBottomMargin
  • DfLeftMargin
  • DfRightMargin
  • DfSetMargins
  • DFWrite
  • DFWriteBMP
  • DFWriteEllip
  • DFWriteLine
  • DFWriteLn
  • DFWriteLnPos
  • DFWritePos
  • DFWriteRect
  • DFWriteXYLine
  • Report_Breaks
  • Report_Data_Set (obsolete)
  • Report_Index (obsolete)
  • Report_Main_File (obsolete)

Sample

Object oCustomer_WinPrint is a cWinReport2
    Set Report_Title to "Printing Customer Names"

    Set Server to Customer_dd
    Set Ordering to 1

    Function Starting_Main_Report Returns Integer
        Integer iRetVal
        Send DFSetLandscape True
        Send DFSetMetrics WPM_CM
        Send DFSetmargins 1 1 1 1
        Forward Get Starting_Main_Report To iRetVal
    End_Function

    Procedure Page_Top
        string sFont
        integer iSize iStyle

        Move "Ariel" to sFont
        Move 8 to iSize
        Move (font_default) to iStyle

        DFFont sFont
        DFFontSize iSize
        DFBeginHeader DFPageTop
            DFHeaderPos   HDR_Left
            DFHeaderFrame HDR_NOFRAME
            DFWriteLn ("Page:" * "#pagecount#") (iStyle+Font_Right)
        DFEndHeader

    End_Procedure

    Procedure Page_Header
        string sFont
        integer iSize iStyle iFill iBorder

        Move "Ariel" to sFont
        Move 16 to iSize
        Move (font_Bold+rgb_white) to iStyle
        Move (rgb_dGrey) to iFill
        Move (rgb_dGrey) to iBorder

        DFFont sFont
            DFFontSize iSize
            DFBeginHeader DFPageHeader
            DFHeaderFrame HDR_MARGINs 0 iBorder iFill
            DFHeaderMargin HM_BottomOuter 0.08
            DFHEADERPOS HDR_LEFT
            DFWritelnPos "Customer List " 0.10 (iStyle)
        DFEndHeader
    End_Procedure

    Procedure Page_Title
        Boolean bOn
        string sFont
        integer iSize iStyle iFill iBorder

        Get pbLandscape to bOn

        Move "Ariel" to sFont
        Move 8 to iSize
        Move (font_Bold+rgb_dBlue) to iStyle
        Move rgb_Grey to iFill
        Move rgb_Grey to iBorder

        DFFont sFont
        DFFontSize iSize

        DFBeginHeader DFPageTitle
            DFHeaderFrame HDR_MARGINs 0 iBorder iFill
            DFHeaderMargin HM_BottomOuter 0.16
            DFHEADERMargin HM_TopInner 0.01
            DFHEADERMargin HM_BottomInner 0.01
            DFHEADERPOS HDR_LEFT
            DFWritePos "Number"       0.1  (iStyle)
            DFWritePos "Name"           2  (iStyle)
            DFWritePos "Address"        7  (iStyle)
            DFWritePos "City"          12  (iStyle)
            DFWritePos "State"         15  (iStyle)
            DFWritePos "Zip"           16  (iStyle)
            DFWritePos "Comments"   18  (iStyle)
            DfWriteln
        DFEndHeader

    End_Procedure

    Procedure_Section Body
        string sFont
        integer iSize
        integer iStyle

        Send Update_Status (String(Customer.Customer_number))

        Move "Ariel" to sFont
        Move 8 to iSize
        Move (font_default) to iStyle

        DFFont sFont
        DFFontSize iSize
        DFLineCheck 5

        DFWritePos  Customer.Customer_number 0.8 (iStyle+Font_Right) 0
        DFWritePos  Customer.Name      2 (iStyle) -1 4.08
        DFWritePos  Customer.Address   7 (iStyle) -1 4.98
        DFWritePos  Customer.City     12 (iStyle) -1 3.98
        DFWritePos  Customer.State    15 (iStyle) -1 0.98
        DFWritePos  Customer.Zip      16 (iStyle) -1 1.98
        DFWritePos  Customer.Comments 18 (iStyle) -1 0
        DfWriteln
        DfWriteln
    End_Procedure   // Body

    Procedure Page_Bottom
        DateTime dtDT
        string sFont
        integer iSize iStyle iBorder iFill

        Move (CurrentDateTime()) to dtDT

        Move "Ariel" to sFont
        Move 8 to iSize
        Move rgb_dBlue to iStyle
        Move rgb_dGrey to iBorder
        Move rgb_White to iFill

        DFFont sFont
        DFFontSize iSize
        DFBeginHeader DFPageBottom
            DFHeaderPos   HDR_LEFT
            DFHeaderFrame HDR_MARGINS 0 iBorder iFill
            DFWriteLn   ("Report Printed on: " +string(dtDT)) (iStyle+Font_Center)
        DFEndHeader

    End_Procedure
End_Object    // oCustomer_WinPrint

The cWinReport2 Report Sections

cWinReport2 objects use the same reports sections as the BasicReport. Each of these sections are represented in your report with a Procedure. For example, report_header will be represented inside of "Procedure report_header". All sections, except the body section will use a cWinPrint2 Header that is created within your procedure using the DFBeginHeader command. For example, the report_footer procedure will contain "DFBeginHeader DFReportHeader". The following table provides information about these report sections:

Procedure Name | DFBeginHeader Name | Description
Page_top | DFPageTop | Page_top is printed first at the physical top margin of each page.
Report_header | DFReportHeader | Report_header is printed once in a report after Page_top.
Page_header | DFPageHeader | Page_header is printed on every page following Report_Header. Note that this is different than the BasicReport behavior.
Page_title | DFPageTitle | Page_title appears on every page after Page_heading.
SubHeader1..n | DFSubHeader 1..9 | Subheaders appear for each break level. They are ouput for each new break. They are usually reprinted on page breaks.
Body | none | The Body section is called once for every valid record. There is no DFHeader associated with this.
SubTotal1..n | DFSubTotal 1..9 | Subtotals appear for each break level. They are output at the end of a break. They are normally not reprinted on page breaks.
Total | DFTotal | The Total section appears once at the end of a report following all sub-totals.
Report_footer | DFReportFooter | Report_footer is printed once on the last page before Page_footer.
Page_footer | DFPageFooter | Page_footer is printed on every page before Page_bottom. Note that this is different than the BasicReport behavior.
Page_bottom | DFPageBottom | Page_Bottom is printed at the physical bottom margin of each page.

Of Special Note

  • The WinPrint2 engine handles page breaks automatically; the only programmable page-breaking capability in this class is the DFNew_Page procedure. Where you unconditionally desire a page break in your report (as at the triggering of a certain level of section break), use DFNew_Page.
  • A global integer ghoWinPrintID contains the object Id of the global WinPrint2 object. This is the WinPrint2 report engine. When a report is run, the global variable WinPrintID is set to this value. This is required because the same commands used in both WinPrint1 and WinPrint2 and both must send messages to WinPrintId. You should normally never need to access the global report object - if you do you should use ghoWinPrint2 or, even better, the phoWinPrint property.
  • When report objects are nested, all subtotals for all objects are stored in the outer object. This means you don't have to keep track of which object contains each subtotal.
  • The overall structure of this object is the same as the BasicReport object. The sections are the same, the processing is the same, and the error handling is the same. The main difference is the method of viewing and output.
  • Output is defined with a number of special WinPrint commands. These commands are used to define font style, size, orientation, placement. Examples of these commands are DFBeginHeader, DFfEndHeader, DFFonts, DFFontSize and DFWrite.
  • Output can be directed to a printer or to the WinPrint print preview panel. This is controlled by setting the output_device_mode property in the report view.

Constants Used By cWinReport2

The following constants are used by cWinReport2:

  • Page Numbering Constants
  • Line Output Constants (Fonts, Colors, etc.)
  • Printer, Page, Output Constants

Page Numbering

In WinPrint2, three keywords used as the argument of any of the DFWrite* commands support printing page numbers. It is very important that #pagecount#, #subpagecount# and #zerosubpagecount# are written in lowercase letters and enclosed in quotation marks.

#pagecount#

#pagecount# prints page numbers that increment from the beginning of the report to the end.

DFWriteLn    '#pagecount#' (FONT_RIGHT)

DFWriteLnPos '#pagecount#' 5              (FONT_DEFAULT)

#subpagecount#

#subpagecount# prints page numbers that increment until a #zerosubpagecount# is executed, at which point they resume incrementing from 1. #subpagecount# would typically be used in Sections pageTop and pageBottom.

DFWriteLn    '#subpagecount#' FONT_DEFAULT

DFWriteLnPos '#subpagecount#' 5              FONT_DEFAULT

If you have a report printing multi-page invoices and you want each invoice to start with Page 1, then you should use #subpagecount# and zerosubpagecount#.

#zerosubpagecount#

#zerosubpagecount# zeroes the #subpagecount# counter. You must do a #zerosubpagecount# before you create a new page. #zerosubpagecount# would typically be used in a Section subTotal or subHeader. #zerosubpagecount# must be used inside a DFBeginHeader...DFEndHeader block.

DFWrite '#zerosubpagecount#'

Because the numbering of report pages and section pages is done with different arguments, you can have a report whose pages are numbered both ways, if you wish.

Line Output Constants (Fonts, Colors, etc.)

Many of the commands in WinPrint2 use named constants as arguments. Certain arguments can only be one of the named constants. These constants include font attributes, colors, and print dialog/setup flags.

Font Attributes

These named constants, along with all colors, can be used in attributes in DFWrite... statements. When used more than one at a time in a statement, they should be separated by plus (+) signs and all enclosed together by a single pair of parentheses.

FONT_DEFAULT | Font with no attributes
FONT_UNDER | Underline attribute
FONT_BOLD | Bold attribute
FONT_ITALIC | Italic attribute
FONT_STRIKE | Strikeout attribute
FONT_LEFT | Output left-justified to the margin, column, or position.
FONT_CENTER | Output centered on position, in the column, or between the margins.
FONT_RIGHT | Output right-justified to the margin, column, or position.

Colors

These constants provide a convenience for outputting in various standard colors. They can be used with all commands that take color as an argument, including in attributes in DFWrite... statements. With the DFGetDFColor function, you can create any color you desire for output.

Regular colors | Dark colors
RGB_BLACK |
RGB_WHITE |
RGB_BLUE | RGB_DBLUE
RGB_CYAN | RGB_DCYAN
RGB_GREEN | RGB_DGREEN
RGB_GREY | RGB_DGREY
RGB_MAGENTA | RGB_DMAGENTA
RGB_RED | RGB_DRED
RGB_YELLOW | RGB_DYELLOW

Printer, Page, Output Constants

Page Orientation

Page Orientation (landscape or portrait) is controlled using the DfSetLandscape and DfGetLandscape messages.

Default Paper Bin

The paper bin is contolled using the DfSetPrinterBin, DfGetPrinterBin and DFPrinterBinFirstPage messages. The following bin types may be selected:

DF_BIN_AUTO
DF_BIN_CASSETTE
DF_BIN_ENVELOPE
DF_BIN_ENVMANUAL
DF_BIN_FIRST
DF_BIN_LARGECAPACITY
DF_BIN_LARGEFMT
DF_BIN_LAST
DF_BIN_LOWER
DF_BIN_MANUAL
DF_BIN_MIDDLE
DF_BIN_ONLYONE
DF_BIN_SMALLFMT
DF_BIN_TRACTOR
DF_BIN_UPPER

Default Paper Size

Paper size is controlled using the DFSetPrinterPaper, DFGetPrinterPaper, DFSetUserDefinedPapersize, DFGetUserDefinedLength and DFGetUserDefinedWidth messages. The following paper sizes may be selected

DF_PAPER_10X14 | 10 by 14 inch sheet
DF_PAPER_11X17 | 11 by 17 inch sheet
DF_PAPER_A3 | A3 sheet, 297 by 420 millimeters
DF_PAPER_A4 | A4 Sheet, 210 by 297 millimeters
DF_PAPER_A4SMALL | A4 small sheet, 210 by 297 millimeters
DF_PAPER_A5 | A5 sheet, 148 by 210 millimeters
DF_PAPER_B4 | B4 sheet, 250 by 354 millimeters
DF_PAPER_B5 | B5 sheet, 182 by 257 millimeter paper
DF_PAPER_CSHEET | C Sheet, 17 by 22 inches
DF_PAPER_DSHEET | D Sheet, 22 by 34 inches
DF_PAPER_ENV_10 | #10 Envelope, 4 1/8 by 9 1/2 inches
DF_PAPER_ENV_11 | #11 Envelope, 4 1/2 by 10 3/8 inches
DF_PAPER_ENV_12 | #12 Envelope, 4 3/4 by 11 inches
DF_PAPER_ENV_14 | #14 Envelope, 5 by 11 1/2 inches
DF_PAPER_ENV_9 | #9 Envelope, 3 7/8 by 8 7/8 inches
DF_PAPER_ENV_B4 | B4 Envelope, 250 by 353 millimeters
DF_PAPER_ENV_B5 | B5 Envelope, 176 by 250 millimeters
DF_PAPER_ENV_B6 | B6 Envelope, 176 by 125 millimeters
DF_PAPER_ENV_C3 | C5 Envelope, 162 by 229 millimeters
DF_PAPER_ENV_C4 | C3 Envelope, 324 by 458 millimeters
DF_PAPER_ENV_C5 | C4 Envelope, 229 by 324 millimeters
DF_PAPER_ENV_C6 | C6 Envelope, 114 by 162 millimeters
DF_PAPER_ENV_C65 | C65 Envelope, 114 by 229 millimeters
DF_PAPER_ENV_DL | DL Envelope, 110 by 220 millimeters
DF_PAPER_ENV_ITALY | Italy Envelope, 110 by 230 millimeters
DF_PAPER_ENV_MONARCH | Monarch Envelope, 3 7/8 by 7 1/2 inches
DF_PAPER_ENV_PERSONAL | 6 3/4 Envelope, 3 5/8 by 6 1/2 inches
DF_PAPER_ESHEET | E Sheet, 34 by 44 inches
DF_PAPER_EXECUTIVE | Executive, 7 1/4 by 10 1/2 inches
DF_PAPER_FANFOLD_LGL_GERMAN | German Legal Fanfold, 8 1/2 by 13 inches
DF_PAPER_FANFOLD_STD_GERMAN | German Std Fanfold, 8 1/2 by 12 inches
DF_PAPER_FANFOLD_US | US Std Fanfold, 14 7/8 by 11 inches
DF_PAPER_FOLIO | Folio, 8 1/2 by 13 inch paper
DF_PAPER_LEDGER | Ledger, 17 by 11 inches
DF_PAPER_LEGAL | Legal, 8 1/2 by 14 inches
DF_PAPER_LETTER | Letter, 8 1/2 by 11 inches
DF_PAPER_LETTERSMALL | Letter Small, 8 1/2 by 11 inches
DF_PAPER_NOTE | Note, 8 1/2 by 11 inches
DF_PAPER_QUARTO | Quarto, 215 by 275 millimeter paper
DF_PAPER_STATEMENT | Statement, 5 1/2 by 8 1/2 inches
DF_PAPER_TABLOID | Tabloid, 11 by 17 inches
DF_PAPER_USER | User defined paper size, used in conjunction with DFSetUserDefinedPapersize

Default Printer Resolution

Printer resolution is controlled using the DFSetPrinterResolution and DFGetPrinterResolution messages. The following resolutions may be selected:

DF_RES_DRAFT
DF_RES_HIGH
DF_RES_LOW
DF_RES_MEDIUM

Commands Used by cWinReport2

The following commands are used by WinReport:

  • DFBeginHeader
  • DFEndHeader
  • DFFont
  • DFFontSize
  • DFHeaderFrame
  • DFHeaderLineCheck
  • DFHeaderMargin
  • DFHeaderPos
  • DFHeaderWrap
  • DFLineCheck
  • DfTopMargin
  • DfBottomMargin
  • DfLeftMargin
  • DfRightMargin
  • DfSetMargins
  • DFWrite
  • DFWriteBMP
  • DFWriteEllip
  • DFWriteLine
  • DFWriteLn
  • DFWriteLnPos
  • DFWritePos
  • DFWriteRect
  • DFWriteXYLine
  • Report_Breaks
  • Report_Data_Set (obsolete)
  • Report_Index (obsolete)
  • Report_Main_File (obsolete)

DFBeginHeader

Purpose

DFBeginHeader starts the definition of section headers and footers in the output.

Syntax

DFBeginHeader {header-type} [{level#}]

Argument | Type | Explanation
Header-type constant Type of Header. Must be one of thefollowing constants

Constant | Meaning
DFReportHeader | Once only, at beginning of report
DFPageTop | Page top
DFPageTitle | Page title
DFPageHeader | Page header
DFSubHeader | Section breaks, levels 1-9
DFSubTotal | Section breaks, levels 1-9
DFTotal | Total
DFPageFooter | Page footer
DFPageTotal | Page total
DFPageBottom | Page bottom
DFReportFooter | Once only, at end of report

level# | integer | Section level number (only used with DFSubHeader or DFSubTotal)

If you use Header Type DFSubHeader or DFSubTotal, level# is required. If you are defining a SubHeader1, the level# is 1, if you are defining a SubTotal2, level# is 2, and so on. In nested reports, level# should be the level of the overall report, not that of the nested report.

Do not nest the definitions of section headers and footers.

DFBeginHeader DFSubHeader 1
    DFHeaderWrap    HDR_NOWRAP
    DFHeaderPos     HDR_LEFT
    DFHeaderFrame   HDR_MARGINS
    DFWritePos      Customer.Recnum   0.5 (FONT_ITALIC +FONT_BOLD +RGB_RED) 1.5
    DFWritelnPos    Customer.Customer 2   (FONT_ITALIC +FONT_BOLD)
DFEndHeader

DFEndHeader

Purpose

DFEndHeader ends a section header or footer begun with DFBeginHeader.

Syntax

DFEndHeader

DFBeginHeader DFSubHeader 1
    DFHeaderWrap    HDR_NOWRAP
    DFHeaderPos     HDR_LEFT
    DFHeaderFrame   HDR_MARGINS
    DFWritePos      Customer.Recnum   0.5 (FONT_ITALIC +FONT_BOLD +RGB_RED) 1.5
    DFWritelnPos    Customer.Customer 2   (FONT_ITALIC +FONT_BOLD)
DFEndHeader

DFFont

Purpose

DFFont sets the default font to any valid Windows font.

Syntax

DFFont {fontname}

Argument | Type | Explanation
fontname | string | Any font valid in the Windows installation

DFFont sets the default font to any valid Windows font. The font remains active until you change it to another font with this command.

DFFont    'Arial'

DFFont    'Times New Roman'

DFFontSize

Purpose

DFFontSize sets the font size to any valid size for that font

Syntax

DFFontSize {height}

Argument | Type | Explanation
height | number | Height of font in points

DFFontSize sets the font size to any valid size for that font. The size remains active until you change it to another size with this command.

DFFontSize    14

DFHeaderFrame

Purpose

DFHeaderFrame sets the frame style of a header or footer section.

Syntax

DFHeaderFrame {style} [{border_width} [{border_color} [{fill_color}]]]

Argument | Type | Explanation
style constant Frame style. Must be one of the following constants.

Constant | Meaning
HDR_FRMSIZE | Fit to data
HDR_MARGINS | Left-margin-to-right-margin
HDR_NOFRAME | No frame

border_width | number | Optional. Width of border (using current metrics)
border_color | number | Optional. Border Color
fill_color | consant | Optional. Fill Color

DFHeaderFrame may be used only inside a header or footer section begun with dfBeginHeader.

DFBeginHeader DFSubHeader 1
    DFHeaderPos     HDR_LEFT
    DFHeaderFrame   HDR_MARGINS        0.1 RGB_BLACK  RGB_CYAN
    DFWritePos      Customer.Recnum    0.5 (FONT_ITALIC +FONT_BOLD)
    DFWriteLnPos    Customer.Customer    2 (FONT_ITALIC +FONT_BOLD)
DFEndHeader

DFHeaderLineCheck

Purpose

DFHeaderLineCheck specifies that the header plus a specified number of lines fits on a page.

Syntax

DFHeaderLineCheck {lines}

Argument | Type | Explanation
lines | integer | Number of lines to check (in addition to the header)

Whenever a header is triggered, it automatically checks the current page to ascertain whether there is room on that page for the whole header. If not, the header will be printed on a new page. DFHeaderLineCheck enables you to specify that this check be performed for the header plus whatever number of lines you feel your program requires for a meaningful beginning of a new section. This command may be used only inside a header section begun with DFBeginHeader.

Number of lines will be checked according the font and size last used.

DFBeginHeader DFSubHeader 1
    DFHeaderLineCheck    4
    DFHeaderPos      HDR_LEFT
    DFHeaderFrame    HDR_MARGINS
    DFWritePos       Customer.Recnum   0.5 (FONT_ITALIC +FONT_BOLD) 1.5
    DFWriteLnPos     Customer.Customer 2   (FONT_ITALIC +FONT_BOLD)
DFEndHeader

DFHeaderMargin

Purpose

DFHeaderMarging sets inner and outer padding for top and bottom margins in a header

Syntax

DFHeaderLineCheck ePadPosition nPadding

Argument | Type | Explanation
ePadPosition constant Location for padding

Constant | Meaning
HM_TopOuter | Top outside of header frame
HM_TopInner | Top inside of header frame
HM_BottomInner | Bottom inside of header frame
HM_BottomOuter | Bottom outside of header frame

nPaddding | number | Amount of space (padding) in current metrics.

Normally the outside padding of a frame is 0 and the inside padding of a frame is created based on the size of the header's font. DFHeaderMargin allows you to specify the exact space at the top and bottom of a header. You can specify padding outside and inside of a header frame.

Setting a value to zero, restores the default. Therefore 0.01 is the smallest padding you can specify.

The Hm_BottomOuter is a particularly useful setting.

DFBeginHeader DFSubHeader 1
    DFHeaderLineCheck    4
    DFHeaderPos      HDR_LEFT
    DFHeaderFrame    HDR_MARGINS
    DFHeaderMargin   HM_TopOuter 0.04
    DFHeaderMargin   HM_TopInner  0.01
    DFHeaderMargin   HM_BottomInnerr 0.01
    DFHeaderMargin   HM_BottomOuter 0.10
    DFWritePos       Customer.Recnum  0.5 (FONT_ITALIC +FONT_BOLD)
    DFWriteLnPos     Customer.Customer  2   (FONT_ITALIC +FONT_BOLD)
DFEndHeader

DFHeaderPos

Purpose

DFHeaderPos positions the section header according to a justification mode

Syntax

DFHeaderPos {justification}

Argument Type Explanation
justification constant Justification mode. Must be one of the following constants

Constant | Meaning
HDR_LEFT | Justify the header or footer to the left margin
HDR_RIGHT | Justify the header or footer to the right margin
HDR_CENTER | Center the header or footer between the margins

DFHeaderPos positions the section header or footer according to the value of justification. DFHeaderPos may be used only inside a header section (a section begun by DFBeginHeader).

Unless you are using HDR_FRMSIZE as your frame style, it is suggested that you always set DFHeaderPos to HDR_LEFT. This will allow you to justify text within the entire width of the page using FONT_LEFT, FONT_CENTER and FONT_RIGHT.

DFBeginHeader DFSubHeader 1
    DFHeaderWrap    HDR_NOWRAP
    DFHeaderPos     HDR_LEFT
    DFHeaderFrame   HDR_FRMSIZE
    DFWritePos      Customer.Recnum   0.5 (FONT_ITALIC +FONT_BOLD) 1.5
    DFWritePos      Customer.Customer 2   (FONT_ITALIC +FONT_BOLD)
    DFWriteLn       Customer.Address   (FONT_ITALIC +FONT_BOLD+FONT_RIGHT)
DFEndHeader

DFHeaderWrap

Purpose

DFHeaderWrap tells a header section to reprint at the top of the new page

Syntax

DFHeaderWrap {wrap}

Argument Type Explanation
wrap constant Wrap mode. Must be one of the following constants.

Constant | Meaning
HDR_NOWRAP | Header is not printed on new pages
HDR_WRAP | Header is printed on new pages

DFHeaderWrap tells a header section to reprint at the top of the new page if a page break occurs within the section's data (before the beginning of the next section). DFHeaderWrap may be used only inside a header section begun with DFBeginHeader, and has no effect in footer-section definitions. By default, sub-headers wrap and sub-totals do not.

DFBeginHeader DFSubHeader 1
    DFHeaderWrap    HDR_NOWRAP
    DFHeaderPos     HDR_LEFT
    DFHeaderFrame   HDR_MARGINS
    DFWritePos      Customer.Recnum    0.5 (FONT_ITALIC +FONT_BOLD)
    DFWriteLnPos    Customer.Customer    2   (FONT_ITALIC +FONT_BOLD)
DFEndHeader

This command may be used only in a header or footer section begun by DFBeginHeader.

DFLineCheck

Purpose

DFLineCheck checks that a given number of lines fit on the page

Syntax

DFLineCheck {lines}

Argument | Type | Explanation
lines | integer | Number of lines to check for

DFLineCheck checks that a given number of lines fit on the page. If not, a page break will be done. It is very useful where the record body has more than one line, to ensure that no record is split by a page break.

Number of lines is checked for the font and size last used in the program.

DFLineCheck 3
DFWriteLnPos Customer.Recnum   2 (FONT_ITALIC +FONT_BOLD)
DFWriteLnPos Customer.Customer 2 (FONT_ITALIC +FONT_BOLD)
DFWriteLnPos Customer.Address  2 (FONT_ITALIC +FONT_BOLD)

The DF MarginCommands

DfLeftMargin

DfTopMargin

DfRightMargin

DfBottomMargin

Send DfSetMargins

Purpose

The DF Margin commands set the margins of your document

Syntax

DFTopMargin {position}
DFBottomMargin {position}
DFLeftMargin {position}
DFRightMargin {position}

Argument | Type | Explanation
position | number | Margin in the current metrics

The DF Margin commands set the margins of your document using the current metrics, specified by the value of dfCurrent_metrics in the WinPrint Global Object. The default metrics is centimeters and all margins are set to 2.53cm as default. 2.53cm equals 1inch. You cannot set the margins for individual pages. The margins you have set will be valid for all pages of the report.

You can set all margins at one time by calling the procedure DFSetMarginsand passing the values for left, top, right, and bottom in that order.

DFTopMargin            1.25
DFBottomMargin        1.25

Send DFSetMargins nLeft nTop nRight nBottom

All the position measurements (vert, horz, etc.) of the other commands are taken vertically down from the top margin and horizontally right from the left margin.

DFWrite

Purpose

DFWrite appends data to the current line

Syntax

DFWrite {variable} [{attributes} [{decimal-places}]]

Argument | Type | Explanation
variable | string | A literal, variable, or database field whose value is to be output
attributes | constant | Optional. Font attributes and colors
decimal_places | integer | Optional. Number of digits to the right of the decimal for numeric values

If you use decimal_places, you must use all preceding arguments. If you use this argument, the output will be displayed with the number of decimal digits specified, right-justified to the page/header.

If you use FONT_LEFT, FONT_CENTER or FONT_RIGHT in attributes, the output will be justified to the page/header.

DFWrite "Balance"           (FONT_ITALIC +FONT_BOLD +RGB_RED)

DFWrite product.description (FONT_DEFAULT)

DFWrite 12345.67            (FONT_ITALIC +RGB_BLUE)           2

DFWriteBMP

Purpose

DFWriteBMP is used to place an image on the page.
DFWriteBMP supports .BMP (standard Windows bit-mapped graphics format), .RLE (run-length encoded graphics), .JPG/.JPEG (Joint Photographic Experts Group graphics), .ICO (icon files), .WMF (Windows meta files) and .EMF (extended/enhanced Windows meta files).

Syntax

DFWriteBMP {path\filename} {vert_Location} {horz_Location} {height} {width} [{update_cur_pos}]

Argument | Type | Explanation
path\filename | string | Name and path of image file
vert_Location | number | (upper-left corner) vertical coordinate in the current metrics
horz_Location | number | (upper-left corner) horizontal coordinate in the current metrics
height | number | Height of bitmap in the current metrics
width | number | Width of bitmap in the current metrics
update_cur_pos constant Optional. Determines where current position pointer will be placed

Constant | Meaning
DFGR_SETPOS | Move current position to end of bitmap
DFGR_NOPOS | Leave current position unchanged

Path is only required if the bitmap is not in the same directory as the application.

The vertical and horizontal start positions use current metrics for the position on the page. Height and width of the bitmap also use current metrics.

Position is from the margin.

DFWriteBMP 'UGLYFACE.BMP' 2 10 4 3 DFGR_NOPOS
DFWriteBMP "logo.jpg" 14 7 12 9 DFGR_NOPOS

DFWriteEllip

Purpose

DFWriteEllip writes an ellipse to the page.

Syntax

DFWriteEllip {vert} {horz} {height} {width} [{border_color} [{border-width} [{reprint} [{fill_color} [{update_cur_pos}]]]]]

Argument | Type | Explanation
vert | number | Location (upper-left corner) vertical coordinate in the current metrics. DFGR_CURRLINE= current line position
horz | number | Location (upper-left corner) horizontal coordinate in the current metrics. DFGR_CURRLINE= current line position
height | number | Height of the ellipse in the current metrics. DFGR_RB_MARGIN = height of entire header
width | number | Width of the ellipse in the current metrics. DFGR_RB_MARGIN = width of header / width of page
border_color | constant | Optional. Border lines color (default black)
border_width | constant | Optional. Width of border lines in the current metrics
reprint constant Optional. Determines if graphic is reprinted in succeeding page

Constant | Meaning
DFGR_NOWRAP | Print once only
DFGR_WRAP | Print on each succeeding page

fill_color | constant | Optional. Fill color(default transparent)
update_cur_pos constant Optional. Determines where current position pointer will be placed

Constant | Meaning
DFGR_SETPOS | Move current position to end of ellipse
DFGR_NOPOS | Leave current position unchanged

DFGR_RB_MARGIN refers to the full distance between the top and bottom margins or the left and right margins, as appropriate.
DFGR_CURRLINE refers to the current line position

DFWriteEllip 2 4 6 4 RGB_BLACK 0.1 DFGR_NOWRAP RGB_RED DFGR_NOPOS
DFWriteEllip 0 0 DFGR_RB_MARGIN DFGR_RB_MARGIN 0.3

DFWriteLine

Purpose

DFWriteLine is used to output a graphic line (rule) to a page.

Syntax

DFWriteLine {vert} {horz} {length} [{orientation} [{color} [{width} [{update_cur_pos}]]]]

Argument | Type | Explanation
vert | number | Location (upper or left end) vertical coordinate in the current metrics. DFGR_CURRLINE= current line position
horz | number | Location (upper or left end) horizontal coordinate in the current metrics. DFGR_CURRLINE= current line position
length | number | Length of line in the current metrics. DFGR_RB_MARGIN = height/width of entire header/page as appropriate.
orientation constant Optional. Determines if line is horizontal of vertical.

Constant | Meaning
DFGR_HORI | Horizontal line (default)
DFGR_VERT | Vertical line

color | constant | Optional. Line color(default black)
width | number | Optional. Width of line in the current metrics
update_cur_pos constant Optional. Determines where current position pointer will be placed

Constant | Meaning
DFGR_SETPOS | Move current position to end of line
DFGR_NOPOS | Leave current position unchanged

DFWriteLine, which is not the same as DFWriteLn, is used to output a line (rule) to a page.

Many of the arguments can be named constants.
DFGR_HORI (the default) provides for a horizontal line
DFGR_VERT provides for a vertical line.
DFGR_RB_MARGIN refers to the full distance the top and bottom margins or the left and right margins, as appropriate.
DFGR_CURRLINE refers to the current line position

DFWriteLine 2             4 6              DFGR_HORI RGB_RED 0.1 DFGR_NOPOS

DFWriteLine DFGR_CURRLINE 3 DFGR_RB_MARGIN DFGR_VERT

DFWriteLn

Purpose

DFWriteLn writes data to the current output line and begins a new output line.

Syntax

DFWriteLn {variable} [{attributes} [{decimal-places}]]

Argument | Type | Explanation
variable | A literal, variable, or database field whose value is to be output
attributes | Font attributes and colors
decimal_places | Optional. Number of digits to the right of the decimal for numeric values

If you use decimal_places, you must use all three arguments. If you use this argument, the output will be displayed with the number of decimal digits specified, right-justified to the page/header.

If you use FONT_LEFT, FONT_CENTER or FONT_RIGHT in attributes, the output will be justified to the page/header.

DFWriteln    "End of report" (FONT_ITALIC +FONT_BOLD +RGB_RED)

DFWriteln     visitors.id     (FONT_DEFAULT)

DFWriteln     12345.67        (FONT_ITALIC +RGB_BLUE)            2

DFWriteLnPos

Purpose

DFWriteLnPos appends data to the current line at a specified position from the left margin and begins a new output line.

Syntax

DFWriteLnPos {variable} {position} [{attributes} [{decimal_places} [{MaxLength}]]]

Argument | Type | Explanation
variable | string | A literal, variable, or database field whose value is to be output
position | number | Position to write at in the current metrics
attributes | constant | Optional. Font attributes and colors
decimal_places | integer | Optional. Number of digits to the right of the decimal for numeric values. Pass -1 for no-decimal places (i.e., a string output).
MaxLength | number | Optional. Determines maximum length of output value using the current system metrics (Inch or Cm)

DFWriteLnPos appends data to the current line at a specified position from the left margin using the current metrics, specified by the value of dfCurrent_metrics in the WinPrint Global Object, and opens the next new line at the left margin.

If you use decimal_places, you must use all preceding arguments. If you use this argument, the output will be displayed with the number of decimal digits specified, right-justified to the position. When using decimals, set the position for the right side of the data.

MaxLength is an optional parameter and if not passed the entire output value will be output. Passing a length of zero (0) will also output the entire string. If you wish to pass the MaxLength parameter you must also pass parameters for Attributes and Decimal_places. Pass -1 for no-decimal places (i.e., a string output). The following commands are the same:

DfWriteLnPos Customer.Name 10
DfWriteLnPos Customer.Name 10 FONT.DEFAULT
DfWriteLnPos Customer.Name 10 FONT.DEFAULT -1
DfWriteLnPos Customer.Name 10 FONT.DEFAULT -1 0

If you use FONT_LEFT, FONT_CENTER or FONT_RIGHT in attributes, the text will be justified to the position.

DFWriteLnPos "Felons at Large" 0.5 (FONT_ITALIC +FONT_BOLD +RGB_RED) -1 10

DFWriteLnPos ammo.caliber      5   (FONT_DEFAULT) -1 5

DFWriteLnPos 12345.67         12.5 (FONT_ITALIC +RGB_BLUE)       2  4

DFWritePos

Purpose

DFWritePos appends data to the current line at a specified position from the left margin.

Syntax

DFWritePos {variable} {position} [{attributes} [{decimal_places} [{MaxLength}]]]

Argument | Type | Explanation
variable | string | A literal, variable, or database field whose value is to be output
position | number | Position to write at in the current metrics
attributes | constant | Optional. Font attributes and colors
decimal_places | integer | Optional. Number of digits to the right of the decimal for numeric values. Pass -1 for no-decimal places (i.e., a string output).
MaxLength | number | Optional. Determines maximum length of output value using the current system metrics (Inch or Cm)

DfWritePos appends data to the current line at a specified position from the left margin using the current metrics, specified by the value of dfCurrent_metrics in theWinPrint Global Object.

If you use decimal_places, you must use all preceding arguments. If you use this argument, the output will be displayed with the number of decimal digits specified, right-justified to the position. When using decimals, set the position for the right side of the data.

MaxLength is an optional parameter and if not passed the entire output value will be output. Passing a length of zero (0) will also output the entire string. If you wish to pass the MaxLength parameter you must also pass parameters for Attributes and Decimal_places. Pass -1 for no-decimal places (i.e., a string output). The following commands are the same:

DfWritePos Customer.Name 10
DfWritePos Customer.Name 10 FONT.DEFAULT
DfWritePos Customer.Name 10 FONT.DEFAULT -1
DfWritePos Customer.Name 10 FONT.DEFAULT -1 0

If you use FONT_LEFT, FONT_CENTER or FONT_RIGHT in attributes, the text will be justified to the position.

DFWritePos "Prior Convictions"   0.5 (FONT_ITALIC +FONT_BOLD +RGB_RED) -1 10

DFWritePos sentence.length       5   (FONT_DEFAULT)  -1 5

DFWritePos 12345.67             12.5 (FONT_ITALIC +RGB_BLUE)      2  4

DFWriteRect

Purpose

DFWriteRect is used to write a rectangle to the page. DFWriteRect is very useful to place borders around section headers and/or footers.

Syntax

DFWriteRect {vert} {horz} {height} {width} [{line_color} [{line_width} [{reprint} [{fill_color} [{update_cur_pos}]]]]]

Argument | Type | Explanation
vert | number | Location (upper-left corner) vertical coordinate. DFGR_CURRLINE= current line position
horz | number | Location (upper-left corner) horizontal coordinate. DFGR_CURRLINE= current line position
height | number | Height of rectangle in the current metrics. DFGR_RB_MARGIN = height of entire header
width | number | Width of rectangle in the current metrics. DFGR_RB_MARGIN = width of header / width of page
line_color | constant | Optional. Color of rectangle border lines (default black)
line_width | number | Optional. Width of rectangle border lines in the current metrics
reprint constant Optional. determines if graphic is reprinted on each page.

Constant | Meaning
DFGR_NOWRAP | Print once only
DFGR_WRAP | Print on each succeeding page

fill_color | constant | Optional. Fill Color (default transparent)
update_cur_pos constant Optional. Determines where current position pointer will be placed

Constant | Meaning
DFGR_SETPOS | Move current position to end of rectangle
DFGR_NOPOS | Leave current position unchanged

DFGR_RB_MARGIN refers to the full distance between the top and bottom margins or left and right margins, as appropriate.
DFGR_CURRLINE refers to the current line position.

DFWriteRect 2 4 6              4              RGB_BLACK 0.1 DFGR_NOWRAP ;
    RGB_RED DFGR_NOPOS

DFWriteRect 0 0 DFGR_RB_MARGIN DFGR_RB_MARGIN RGB_BLACK 0.3

DFWriteXYLine

Purpose

DFWriteXYLine is used to place a line (rule) on the page from one point to another.

Syntax

DFWriteXYLine {vert} {horz} {vert_stop} {horz_stop} [{color} [{width} [{reprint} [{update_cur_pos}]]]]

Argument | Type | Explanation
vert | number | Start location vertical coordinate in the current metrics. DFGR_CURRLINE= current line position.
horz | number | Start location horizontal coordinate in the current metrics. DFGR_CURRLINE= current line position.
vert_stop | number | Stop location vertical coordinate in the current metrics.DFGR_RB_MARGIN = height of entire header.
horz_stop | number | Stop location horizontal coordinate in the current metrics. DFGR_RB_MARGIN = width of header / width of page.
color | constant | Optional. Line Color (default black)
width | number | Optional. Width of line in the current metrics
reprintconstant Optional. Determines how line is drawn on pages

Constant | Meaning
DFGR_NOWRAP | Print once only
DFGR_WRAP | Print on each succeeding page

update_cur_posconstant Optional. Determine how current line is affected

Constant | Meaning
DFGR_SETPOS | Move current position to end of line
DFGR_NOPOS | Leave current position unchanged

The line need not be either horizontal or vertical. You cannot use DFGR_CURRLINE with DFWriteXYLine.
DFGR_RB_MARGIN refers to the full distance between the top and bottom margins or the left and right margins, as appropriate.
DFGR_CURRLINE refers to the current line position.

DFWriteXYLine    0 0 DFGR_RB_MARGIN DFGR_RB_MARGIN RGB_BLACK    0.1 DFGR_WRAP ;
    DFGR_NOPOS

DFWriteXYLine    1 1 10             15             RGB_BLACK

Report_Breaks

This command defines the breakpoints needed in a report.

Object oReport is a cWinReport2
    Report_Breaks OrderHea.Customer_Number
    :

Object oReport is a cWinReport2
    Report_Breaks Customer.Region Customer.SubRegion
    :

The breakpoints can be just about anything. They can be a file.field , they can be a variable, or they can be a built-in or a user-defined function.

Object oReport is a cWinReport2
    Report_Breaks (SomeBreakFunction(self))

Report_Breaks (Left(Vndr.Name, 1)) Vndr.Name

Report_Breaks (G_Func(Desktop, Vndr.Id))

Report_Breaks (L_Func(Self, Vndr.Due))

The report_breaks command actually creates a custom function named test_breakpoints. Therefore, when used in a class, the report_breaks command must not be placed in a procedure or function, but should be placed directly inside the class. The following example shows how a basicReport subclass should be created using the various report_???? commands.

Class cVReport is a cWinReport2

    Report_Breaks (left(Vndr.name, 1)) Vndr.Name

    Procedure Construct_Object integer iMyImage
        Forward Send Construct_Object iMyImage

        Report_Main_File Vndr
        Report_Index by Vndr.Name
    End_Procedure
    :
End_Class

Report_Data_Set

Report_Data_Set is an obsolete command. You should always use the Set Server property to define the main file in a report.

Object oVndrReport is a cWinReport2
    Set Server to oVndr_DD
    Set Ordering to 2
    Report_Breaks Vendor.State
    :

Report_Index

Report_Index is an obsolete command. You should always use set Ordering to set the ordering of a report.

Object oVndrReport is a cWinReport2
    Set Server to oVndr_DD
    Set Ordering to 2
    Report_Breaks Vendor.State
    :

Report_Main_File

Report_Main_File is an obsolete command. You should always use set Main_File to set the main file of a report.

Object oVndrReport is a cWinReport2
    Set Server to oVndr_DD
    Set Main_File to Vndr.File_Number
    Report_Breaks Vendor.State
    :

Last Edited: August 10, 2006


Properties for cWinReport2

View property list in alphabetical order

Name | Description
AutoNew_Page_State | Determines if a new page is generated when a multi-report starts the next report
AutoOutPut_State | Determines if the report is automatically output to the printer or the Previewer when it is complete
Output_Device_Mode | Determines how the report is output
pbMultiReports | Provides a mechanism for linking multiple report objects to create a single report
phoWinPrint | Contains the handle of the Winprint2 global print object
Inherited Properties from BasicReport
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button
Display_Error_State |
Output_Device | Handles the name of the output device
Report_Caption | Contains the text that will appear in the status panel's caption bar
Report_Message | An additional message area that will appear below the report_title in the status panel
Report_Status_Panel |
Report_Title | A centered title that appears in the status panel
Status_Log_Id | Object ID of status-log object
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs
Inherited Properties from Report_DS
Server | Contains the object ID of this object's server
Inherited Properties from Report
Assigned_Channel |
Cancelled_State | Setting this true will cancel a report
Child_Rpt_State | Set true if the current Report object is nested
Current_Rec | (Obsolete) Contains the record number of the current valid record found
Find_Down_state | Determines if an index should be traversed in forward or reverse order
Find_Mode | Maintains the current finding mode
Footer_Lines | Contains the number of lines in the page_bottom image plus the page_footer image plus the page_total image
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function
Has_Children_Rpt_State | Is set true if other reports are nested inside this report object
Last_Rec | (Obsolete) Contains the record number of the last selected record found
Main_File | Contains the filenumber of the file which the report will use for finding records
Main_Report_Id | Contains the object ID of the outer report
New_Page_State | Set true when a new page is needed
No_Constrained_Find_State | Determines if constrained record finding should be disabled
No_Finding_State | Determines how the Report object will find records
No_PageCheck_State | Set true when the Report object is processing a new page
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found
Num_Breaks | Returns the number of breaks in a report
Ordering | Contains the index number which will be used for finding records
Page_Count | Keeps track of the current page number
Page_End | Determines how many lines on a page are allowed before a page break will occur
Page_End_State | If this property is set true below the forward send statement in the starting_main_report procedure, then the next page_check will cause an end-of-page/new-page sequence
Page_Feed | Used by the formfeed procedure
Page_Footer_Lines | The number of lines in the page_footer image
priCurrentRec | Contains the RowId of the current valid record found
priFoundRec | Contains the RowId of the record found by the find_rec function
priLastRec | Contains the RowId of the last selected record found
Rec_Count | Contains the number of records found for the current report
Refind_for_SubTotal_State | Ensures that the subtotal is processed with the last valid record for that break level
Report_Channel | Determines which output channel will be used for your report output
Report_Footer_Lines | The number of lines in the report_footer image
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing
Sub_Totaling_State | Set true when the Report object is processing subtotals or totals
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cWinReport2

View event list in alphabetical order

Name | Description
Inherited Events from BasicReport
Ending_Main_Report | Augmented to print/preview the report if AutoOutput_State is set to true
Error_Report | Sent whenever an error is generated
onError | Provided as a hook to handle custom error reporting
Report_Interrupt | Called when the status panel's Cancel button has been pressed
Starting_Main_Report | Called only if the current report is an outer report
Inherited Events from Report
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property
Body | Called once for every record selected for the report to provide processing for record data (if any) not used for subheaders and subtotals
Ending_Report | This handler is called at the end of every report
Final_Formfeed |
OnConstrain |
Page_Bottom | The last thing printed on every page
Page_Footer | Printed after page_total on every page except the last page
Page_Header | Called after page_top on every new page except the first
Page_Title | Called on every new page after report_header or page_header
Page_Top | Called first at the top of each new page
Page_Total | Called on every new page and is printed as the first part of a page break at the bottom of each page
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found
Report_Footer | Printed after page_total on the last page of the report
Report_Header | Called only on the first page of the report, after page_top
Selection | Validates a record
Starting_Report | Called at the start of every report
SubHeader_Init1..n | Called for every break level (n) for which you define a SubHeader_init1..n procedure section in your program
SubHeader1..n | Called for every break level (n) for which you define a subHeader procedure section in your program
SubTotal1..n | Called for every break level (n) for which you define a subTotal procedure section in your program
Total | Called once at the end of a report after the final subtotals are output
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cWinReport2

View method list in alphabetical order

Name | Type | Description
Add_SubTotal | Procedure | Adds the value of nData to the subtotal for the passed iCounter
ArePrintersInstalled | Function | Returns true if printers are installed
Clr_AllSubTotals | Procedure | Zeroes all the subtotal accumulators for the report
Clr_SubTotal | Procedure | Zeroes the subtotal accumulator for the passed iCounter
DfClearDoc | Procedure | DFClearDoc clears the generated report
DFClearPrinter | Procedure | Clears the printer data channel and the printer settings
DfClosePreview | Procedure | Closes the report viewer
DfEndDocument | Procedure | Specifies that a report is complete
DFGetCurrentDevice | Function | Returns the name of the current print device
DFGetDFColor | Function | Converts individual R(ed), G(reen), B(lue) values into a WinPrint2 color value.
DFGetEnablePrintFromPreview | Function | Determines is printing is allowed within the WinPrint2 report viewer
DFGetLandscape | Function | Determines if a report page orientation should be Landscape or Portrait
DFGetMetrics | Function | Returns the metrics used by the report
DFGetPrintDlgInPreview | Function | Determines if the print job dialog will appear when the viewer's print button is pressed
DFGetPrinterBin | Function | Determines the bin source for a report
DFGetPrinterPaper | Function | Determines the paper type/size used in a report
DFGetPrinterResolution | Function | Determines the printer resolution used in a report
DFGetUserDefinedLength | Function | Returns the length for user defined paper
DFGetUserDefinedWidth | Function | Returns the width for user defined paper
DFNew_Page | Procedure | Outputs a new page
DFPreview | Procedure | Opens the printer viewer
DFPreviewNoWait | Procedure | Opens the printer viewer as a modeless viewer
DFPreviewWait | Procedure | Opens the printer viewer as a modal viewer
DFPrint | Procedure | Invokes the printer job dialog and prints the document using current settings in the print setup
DFPrintDialog | Procedure | Invokes the WinPrint2 Print Job Dialog
DFPrintDoc | Procedure | Prints the document without invoking the Print Job Dialog
DFPrinterBinFirstPage | Procedure | Allows you to set a different printer bin for report's first page
DFPrintSetup | Procedure | (Obsolete)
DFPrintSetupDialog | Function | Invokes the the Printer Setup Dialog allowing the user to select a printer
DFSetDevice | Procedure | Sets the location and name of the print device
DFSetEnablePrintFromPreview | Procedure | Determines if WinPrint2 viewer allows printing
DFSetLandscape | Procedure | Sets a report's orientation to Landscape or Portrait
DFSetMargins | Procedure | Sets Left, Top, Right and Bottom Margins for a report
DFSetMetrics | Procedure | Sets a report's metrics to centimeters or Inches
DFSetNumberOfCopies | Procedure | Sets the number of copies to printed
DFSetPrintDlgInPreview | Procedure | Determines if the print job dialog will appear when printing is selected from the WinPrint2 viewer
DFSetPrinterBin | Procedure | Sets the printer bin to be used in a report
DFSetPrinterPaper | Procedure | Sets the paper type/size for a report
DFSetPrinterResolution | Procedure | Sets the printer resolution used in a report
DFSetTopBottom | Procedure | Sets the top and bottom margins used by the Page_Top and Page_Bottom sections
DFSetUserDefinedPapersize | Procedure | Sets the length and width of a user defined papersize
DocumentStatus | Function | Returns the status of a report
EndMultiReport | Procedure | Ends a linked multi-report
IsViewerActive | Function | Returns true of the Winprint2 viewer is actve
PrintReport | Procedure | Outputs the current report to printer or viewer based on output_device_mode
RGBToWPColor | Function | Converts a standard RGB color to a Winprint RGB color value
ShowRuler | Procedure | Displays a ruler in the report
SubTotal | Function | Returns the appropriate subtotal and clears the subtotal accumulator
Sum_SubTotal | Function | Returns the value of the subtotal for the passed iTotal, but does not zero the subtotal accumulator
Update_Status | Procedure | Updates a report's status in the report viewer
Inherited Methods from BasicReport
End_Log | Procedure | Sends an end-log message to the log object
Error_Log_Status | Procedure | Called by error_report if status_log_state is true
Log_Status | Procedure | Sends passed message to the log object
Start_Log | Procedure | Sends a start-log message to the log object
Inherited Methods from Report_DS
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO
Request_Save | Procedure | If sent, this saves the current record
Inherited Methods from Report
Formfeed | Procedure | Handles formfeeds
Output_ImageNum | Procedure | Outputs the image represented by ImageNum
Run_Report | Procedure | Sends a message to the report object telling it to start the report with internal finding
Start_Report | Function | Augmented to check the server property and if the property is non-zero (and a DSO exists), to establish a client-server link between the report object and the DSO
WriteLn | Procedure | Outputs the string message to the current output channel
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cWmlreport

Properties Events Methods Index of Classes

A subclass of sWebReport that is customized for WML reports

Hierarchy

cObject
---cReport
------cReportDS
---------cBasicReport
------------cHtmlReport
---------------cWebReport
------------------cWmlreport

Library: Web Application Class Library

Package: cWmlReport.pkg

Mixins: WmlFormat_Mixin WmlWrite_Mixin

Description

cWmlReport is a subclass of sWebReport that is customized for WML reports.

It assumes the report will be short and simple (a WAP requirement), with just a body section with a single short line.

You set piWmlMaxLength as the approximate number of characters per report (1000 is suggested).
You can determine how many items are placed in a single WML card (9 is often suggested for fast 1 to 9 access).

BreakPoints:
The limited size of a WML deck makes it unlikely that you would create reports with many or possibly even any breakpoint levels.

If you set piItemsPerCard, a single breakpoint is created for you and is called each time the card reaches the maximum number of items. The breakpoint calls OnSubHeader1..n and OnSubTotal1..n. You will be expected to put any special code that deals with creating new cards in these events. If you set piItemsPerCard to a non-zero value, it is not expected that you will create any other breakpoints -- you get the one automatic breakpoint and that is it. If the value of piItemsPerCard is zero, you can create breakpoints exactly like you would in a cWebReport.

Example

Object oReport Is A cWmlReport
    Procedure OnPageTop
         Send WriteWML '<select name="recid" >'
    End_Procedure // OnPageTop
    Procedure OnBody
         String sLinkText
        String sRecId
        String sCustomerCustomer_Number
        String sCustomerName
        String sCustomerPhone_Number
        String sCustomerEmail_Address
        Get ddValue "Customer.Recnum" To sRecId
        Get ddValueEncode "Customer.Customer_Number" To sCustomerCustomer_Number
        Get ddValueEncode "Customer.Name" To sCustomerName
        Get ddValueEncode "Customer.Phone_Number" To sCustomerPhone_Number
        Get ddValueEncode "Customer.Email_Address" To sCustomerEmail_Address
        Send WriteWml ('<option value="' - sRecId - '">')
        Send WriteWml (FormatNumber(sCustomerCustomer_Number,0))
        Send WriteWml " "
        Send WriteWml sCustomerName
        Send WriteWml " "
        Send WriteWml sCustomerPhone_Number
        Send WriteWml " "
        Send WriteWml sCustomerEmail_Address
        Send WriteWml '</option>'
    End_Procedure // OnBody
    Procedure OnPageBottom
         String sIndex sLink
        Get psHrefName To sLink
        Get piOrdering To sIndex
        Send WriteWml '</select><br/>'
        Send WriteWml '<do type="accept" label="Show">'
        Send WriteWml ('   <go href="' - sLink - '?RecId=$(recid)&Index=' - sIndex - '"/>')
        Send WriteWml '</do>'
    End_Procedure // OnPageBottom
    Function RunCustWapReport Integer iIndex Integer iStart Returns Integer
        Integer iEnd iStat
        Set piOrdering           To iIndex
        Set piStartRecord        To iStart
        Get DoRunReport          To iStat
        Get piLastRecord         To iEnd
        Function_Return iEnd
    End_Function // RunCustWapReport
End_Object // oReport
Procedure SetHRefName String sName
    Set psHRefname Of oReport To sName
End_Procedure // SetHRefName
Procedure SetMaxChars String sChars
    Set piWmlMaxLength Of oReport To sChars
End_Procedure // SetMaxChars
Procedure SetMaxLines String sLines
    Set piMaxCount Of oReport To sLines
End_Procedure // SetMaxLines
Function RunCustWapReport Integer iIndex Integer iStart Returns Integer
    Integer iEnd
    Get RunCustWapReport Of oReport iIndex iStart To iEnd
    Function_Return iEnd
End_Function // RunCustWapReport

In the above sample, sending the message RunCustWapReport to the WBO runs the report. This message could be sent from an ASP file using the following code:

<% Lastrec=WBO.Call( "get_RunCustWapReport", iIndex,iStart,iMax) %>

Last Edited: November 21, 2004


Properties for cWmlreport

View property list in alphabetical order

Name | Description
piItemsPerCard | Determines the number of items allowed per WML card
piWmlLength | Contains the current length of WML output at the start of a new record
piWmlMaxLength | Determines the maximum suggested length for output
Inherited Properties from cWebReport
piLastRecord | (Obsolete) Holds the record that was processed when a report was halted because the maximum number of records was encountered
piMaxCount | Holds the maximum number of records to print
piMaxCountBreakLevel | Determines what is considered to be a "record" when record counting is used to create partial reports
piStartRecord | (Obsolete) Allows you to create partial reports providing a method for creating web report "pages"
priLastRowId | Holds the RowId of the record that was processed when a report was halted because the maximum number of records was encountered
priStartRowId | Determines the RowId of the first record of a report allowing you to create partial web reports
psHRefName | Holds the full URL of a file (ASP or HTML) to be displayed as part of a "drill down" operation
Inherited Properties from cHtmlReport
piConstrainFile | Used when creating reports to limit the printing to a single parent record and the related children
piConstrainRecord | (Obsolete) Used when creating reports to limit the printing to a single parent record and the related children
priConstrainRowId | Used when creating reports to limit the printing to a single parent record and the related children
Inherited Properties from cBasicReport
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button
Display_Error_State |
Output_Device | Handles the name of the output device
Report_Caption | Contains the text that will appear in the status panel's caption bar
Report_Message | An additional message area that will appear below the report_title in the status panel
Report_Status_Panel |
Report_Title | A centered title that appears in the status panel
Status_Log_Id | Object ID of status-log object
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs
Inherited Properties from cReportDS
Server | Identifies the object handle that is used as the report object's main data-dictionary object
Inherited Properties from cReport
Assigned_Channel |
Find_Mode | Maintains the current finding mode
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function
Last_Rec | (Obsolete) Contains the record number of the last selected record found
Main_File | Contains the filenumber of the file which the report will use for finding records
New_Page_State | Set true when a new page is needed
No_Constrained_Find_State | Determines if constrained record finding should be disabled
No_Finding_State | Determines how the cReport object will find records
No_PageCheck_State | Set true when the cReport object is processing a new page
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found
Page_Count | Keeps track of the current page number
Page_End | Determines how many lines on a page are allowed before a page break will occur
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence
Page_Feed | Used by the formfeed procedure
Page_Footer_Lines | The number of lines in the page_footer image
pbCanceled | Setting this true will cancel a report
pbChildReport | Set true if the current cReport object is nested
pbFindDown | Determines if the report should traverse up or down the index
pbHasChildReports | Is set true if other reports are nested inside this report object
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level
phMainReport | Contains the object ID of the outer report
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found
piNumberBreaks | Returns the number of breaks in a report
piOrdering | Contains the index number which will be used for finding records
piRecordCount | Contains the number of records found for the current report
priCurrentRec | Contains the RowId of the current valid record found
priFoundRec | Contains the RowId of the record found by the find_rec function
priLastRec | Contains the RowId of the last selected record found
Report_Channel | Determines which output channel will be used for your report output
Report_Footer_Lines | The number of lines in the OnReportFooter image
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cWmlreport

View event list in alphabetical order

Name | Description
Inherited Events from cWebReport
OnInitBreakPoints | Determines the number and order of your breakpoints
Inherited Events from cBasicReport
Error_Report | Sent whenever an error is generated
OnEndingMainReport | User Handler Intended for override
onError | Provided as a hook to handle custom error reporting
OnStartingMainReport | Called when a report is started
Report_Interrupt | Called when the status panel's Cancel button has been pressed
Inherited Events from cReport
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property
Final_Formfeed |
OnBody | Called every time a valid record has been found
OnConstrain |
OnEndingReport | Called at the end of all reports
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables
OnPageFooter | Printed after OnPageTotal on every page except the last page
OnPageHeader | Called after OnPageTop on every new page except the first
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader.
OnPageTop | Called when printing the top of every report
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page
OnReportFooter | Printed after OnPageTotal on the last page of the report
OnReportHeader | Called only on the first page of the report, after OnPageTop
OnSelection | Validates a record
OnStartingReport | Called when a report is started
OnSubHeader1..n | Called each time a subheader needs to be printed
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program
OnSubTotal1..n | Called when a subtotal needs to be processed
OnTotal | Called at the end of a report after all final sub-totals have been printed
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cWmlreport

View method list in alphabetical order

Name | Type | Description
AddWmlRecordLink | Function | (Obsolete) Creates a cell that contains a link to another web page
AddWmlRowIdLink | Function | Creates a cell that contains a link to another web page
WmlAnchor | Function | Adds an Wml Anchor
WmlBig | Function | Makes the string big
WmlBold | Function | Makes the string bold
WmlEm | Function | Makes the string emphasized
WmlItalics | Function | Makes the string italics
WmlLink | Function | Adds a hyperlink (sURL) to a string (sDat)
WmlSmall | Function | Makes the string small
WmlStrong | Function | Adds strong emphasis (usually appears as bold) to the string
WriteWml | Procedure | Outputs the passed string to the web page and ends the line
WriteWmlBreak | Procedure | Outputs the passed string and ends the line
WriteWmlCell | Procedure | Outputs a table cell containing sData
WriteWmlDataBegin | Procedure | Outputs a begin table data WML string
WriteWmlDataEnd | Procedure | Outputs an end table data WML string
WriteWmlImg | Procedure | Adds a WML image
WriteWmlRowBegin | Procedure | Outputs a "begin" row WML string
WriteWmlRowEnd | Procedure | Outputs an end row WML string
WriteWmlTableBegin | Procedure | Outputs a "begin" table html string
WriteWmlTableEnd | Procedure | Outputs an end table wml string
Inherited Methods from cWebReport
AddRecordLink | Function | (Obsolete) Creates a cell that contains a link to another web page
AddRowIdLink | Function | Creates a cell that contains a link to another web page
RegisterBreakpoint | Procedure | registers a breakpoint function
Inherited Methods from cHtmlReport
AddSubTotal | Procedure | Adds the passed value to the total maintained in level iCount
ClearAllSubTotals | Procedure | Clears all the SubTotal accumulators
ClearSubTotal | Procedure | Clears a single Subtotal accumulator
HtmlAnchor | Function | Adds an Html Anchor
HtmlBig | Function | Makes the string big
HtmlBlink | Function | Makes the string blink
HtmlBold | Function | Makes the string bold
HtmlEmph | Function | Makes the string emphasized
HtmlFixed | Function | Makes the string fixed width
HtmlFontcolor | Function | Sets the strings font color
HtmlFontsize | Function | Sets the font size
HtmlHeader | Function | Creates a header string of level iHeader
HtmlItalics | Function | Makes the string italics
HtmlLink | Function | Adds a hyperlink to a string
HtmlSmall | Function | Makes the string small
HtmlStrike | Function | Overstrikes through the string
HtmlStrong | Function | Adds strong emphasis to the string
HtmlSub | Function | Makes the string subscript
HtmlSup | Function | Makes the string superscript
SubTotal | Function | Returns the appropriate subtotal and clears the subtotal accumulator
SumSubTotal | Function | Returns the appropriate subtotal but does not clear the subtotal accumulator
WriteHtml | Procedure | Outputs the passed string to the web page and ends the line
WriteHtmlBreak | Procedure | Outputs the passed string and ends the line
WriteHtmlCell | Procedure | Outputs a table cell containing sData
WriteHtmlCellHeader | Procedure | Outputs a table header cell containing sData
WriteHtmlHorzLine | Procedure | Outputs a horizontal line to the HTML file
WriteHtmlRowBegin | Procedure | Outputs a "begin" row HTML string
WriteHtmlRowEnd | Procedure | Outputs an end row html string
WriteHtmlTableBegin | Procedure | Outputs a "begin" table html string
WriteHtmlTableEnd | Procedure | Outputs an end table html string
WriteLn | Procedure | Outputs the string and ends the Line
Inherited Methods from cBasicReport
End_Log | Procedure | Sends an end-log message to the log object
Error_Log_Status | Procedure | Called by error_report if status_log_state is true
Log_Status | Procedure | Sends passed message to the log object
Start_Log | Procedure | Sends a start-log message to the log object
Update_Status | Procedure | Send this message to update the action area of the status panel
Inherited Methods from cReportDS
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO
Request_Save | Procedure | If sent, this saves the current record
Inherited Methods from cReport
DoRunReport | Function | The main entry point for reportsT
Formfeed | Procedure | Handles formfeeds
Output_ImageNum | Procedure | Outputs the image represented by ImageNum
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cWorkspace

Properties Events Methods Index of Classes

Encapsulates access to a Workspace file to set the program's filelist and DFPATH

Hierarchy

cObject
---cWorkspace

Library: Common (Windows and Web Application) Class Library

Package: cWorkspace.pkg

Description

An instance of cWorkspace is automatically created in the cApplication class, so you will rarely need to instantiate an object of this class explicitly. You can obtain the handle of this instance from cApplication's phoWorkspace property.

psWorkspaceWSFile contains the full path name of the workspace (.ws) file.

Typically, you open a Workspace using the cApplication's DoOpenWorkspace method. But, for more control, you can open a Workspace using this class's OpenWorkspace to open a registered Workspace, or OpenWorkspaceFile, to open a non-registered Workspace. If an error occurs opening a Workspace, you can use OpenWorkspaceErrorMessage to retrieve a meaningful description of the error.

Once you have opened a Workspace, you can obtain information about the paths of the Workspace using psAppSrcPath, psBitmapPath, psDataPath, psDdSrcPath, psHelpPath, psIdeSrcPath, psAppHtmlPath and even the system paths psSystemDfPath and psSystemMakePath. As any of these properties can contain multiple paths, you can use the CountOfPaths to return the number of paths contained within them and you can retrieve them individually using PathAtIndex.

When you open a Workspace, the properties of the class are populated with the contents of the WorkspaceFile. For example, psAppSrcPath will contain the contents of the AppSrcPath entry of the Workspace file. However, when the paths are copied, they are converted from relative to absolute paths. The paths are resolved to their absolute names using the value of the Home entry. Home is itself resolved relative to the folder where the file is found. For example, using this file in the "c:\Accounts\Programs" folder:

Home = ..\

AppSrcPath = .\AppSrc

Home would be resolved to the fully qualified path of "c:\Accounts" and placed into the psHome property. It is resolved to "c:\Accounts" as the directory where the file is found is "c:\Accounts\Programs" and Home was set to "..\" Therefore, home was resolved as "c:\Accounts\Programs\..\", which is "c:\Accounts".

The psAppSrcPath property would be set to "c:\Accounts\AppSrc". This is because the AppSrcPath value is resolved relative to Home. As home is "c:\Accounts" and AppSrcPath is ".\AppSrc", the qualified name becomes "c:\Accounts\.\AppSrc". This rule is applied to all the properties containing paths, when they are copied from the Workspace file.

There is one case, however, when the values are not copied from the Workspace file, and that is when the properties already contain a value. This provides great flexibility in manipulating how the Workspace paths are resolved. There are two ways that the properties can contain a value before opening a Workspace. The first is because you have already opened a Workspace and you are changing to another one. If this is the case, you should send DoClearPaths to ensure that all the properties are cleared. The other reason is that you explicitly set their value, so that it would override the values of the Workspace file.

In the following example, the DataPath of the Workspace file is to be ignored and the "test" data path used instead:

Object oApplication is a cApplication

    Procedure OnCreate
        Handle hoWorkspace

        Get phoWorkspace To hoWorkspace
        Set psDataPath of hoWorkspace To ".\Data\Test"

        Send DoOpenWorkspace "ABC, Inc.Accounts"
    End_Procedure

End_Object

This example assumes that there is a folder below the Workspace's Data directory called "Test".

In this next example, we go further and read the name of a Workspace file (which may or may not be registered) and its DataPath from the command-line:

Object oApplication is a cApplication

    Procedure OnCreate
        Handle hoWorkspace hoCmdLine
        Integer eOpened
        String sWorkspace sDataPath

        Get phoWorkspace To hoWorkspace
        Get phoCommandLine To hoCmdLine

        If (CountOfArgs(hoCmdLine) >=1) Begin // read the Workspace name
            Get Argument of hoCmdLine 1 To sWorkspace
        End
        Else Move "ABC, Inc.Accounts" To sWorkspace

        If (CountOfArgs(hoCmdLine) >=2) Begin // read the DataPath name
            Get Argument of hoCmdLine 2 To sDataPath
            Set psDataPath of hoWorkspace To sDataPath
        End

        Get OpenWorkspaceFile of hoWorkspace sWorkspace To eOpened
        If (eOpened <> wsWorkspaceOpened) Begin
            Get OpenWorkspaceErrorMessage of hoWorkspace eOpened To sError
            Send Stop_Box sError "Error Opening Workspace"
            Abort
        End
    End_Procedure

End_Object

Notice that in this example, we used the OpenWorkspaceFile function. This ensures that as long as the Workspace file exists, it doesn't need to be registered. This is a very useful technique. You could have multiple Workspace files that have different entries. For example, you could have two files, Accounts.Real and Accounts.Test. The Accounts.Test file could have its DataPath pointing to test data. In your program, you could decide which one to use and just open it dynamically.

See Also

cApplication

Last Edited: July 26, 2006


Properties for cWorkspace

View property list in alphabetical order

Name | Description
psAppHtmlPath | Contains the path(s) of the Workspace used to store HTML and associated files
psAppSrcPath | Contains the path(s) of the Workspace used to store the application source code
psBitmapPath | Contains the path(s) of the Workspace used to store the bitmaps (and other media)
psDataPath | Contains the path(s) of the Workspace used to store the application's tables
psDdSrcPath | Contains the path(s) of the Workspace used to store the Data-Dictionaries and related files
psDescription | Contains the description of the Workspace
psDfPath | A string of all the paths that will constitute the program's DFPATH
psFileList | Contains the path and name of the Filelist.cfg that your program should use
psHelpPath | Contains the path(s) of the Workspace used to store the help-related files
psHome | Contains the path that the Workspace should use as its "home"
psIdeSrcPath | Contains the path(s) of the Workspace used to store the code that the Studio uses during development.
psProgramPath | Contains the path(s) of the Workspace used to store the compiled programs.
psSystemDfPath | A string of the paths that are used in every Workspace for finding files at runtime
psSystemMakePath | A string of the paths that are used in every Workspace for finding files at compile-time
psWorkspaceName | The name of the current open Workspace
psWorkspaceWSFile | Contains the full path name of the workspace (.ws) file
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cWorkspace

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cWorkspace

View method list in alphabetical order

Name | Type | Description
CountOfPaths | Function | Returns the number of paths present in a string of paths
DoAssignPaths | Procedure | Automatically called when a Workspace is opened to set the psDfPath property
DoClearPaths | Procedure | Clears all properties associated with opening a new Workspace
DoSetPaths | Procedure | Automatically sets the Filelist and Dfpath for the program, when a Workspace is opened
EnumerateWorkspaceData | Procedure | Sends information about the current Workspace to another object
GetWorkspaceFileName | Function | Returns the name of the physical Workspace file for a Workspace name
IsRegistered | Function | Determines whether a Workspace is registered
OpenWorkspace | Function | Opens a registered Workspace
OpenWorkspaceErrorMessage | Function | Returns a description for an error code that was returned opening a Workspace
OpenWorkspaceFile | Function | Opens a Workspace using its filename
PathAtIndex | Function | Returns a single path from a string containing multiple delimited paths
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMAttribute

Properties Events Methods Index of Classes

XML class for handling an attribute node

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomAttribute
---------cXMLDOMAttribute

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

This class is used to create an attribute node object. The object is created by sending the CreateAttributeNode message to an element node object (cXmlDomElement).

Get CreateAttributeNode of hoElement "Attr-Name" "Attr-Value" to hoAttribute

Attribute processing within Element Node objects

Attribute node objects are rarely created in XML processing. Attributes, which can only be children of Elements, are usually handled with the attribute handling interfaces provided within the cXMLDomElement class. Those Interfaces are AddAttribute, AttributeNodes, EnumerateAttributes, RemoveAttribute and SetAttributeValue.

Of Note

An attribute is regarded as being a property of an element, rather than a distinct part of a document. As such, attributes have no parents or siblings and the object's ParentNode, PreviousSibling and NextSibling properties have null values. They cannot have child nodes. Typically, the allowable values for the attribute are defined in a document type definition (DTD).

In objects of this class, the relationship between the value and specified properties can be summarized as follows: If the attribute has an assigned value in the document and the specified property is true, the value is the assigned value. If the attribute has no assigned value in the document and has a default value in the DTD, the specified property is false, and the value is the default value in the DTD. If the attribute has no assigned value in the document and has a value of #IMPLIED in the DTD, the attribute does not appear in the structure model of the document.

In XML, the value of an attribute is represented by the child nodes of the attribute node because the value can contain entity references. Thus, attributes that contain entity references will have a child list containing both text nodes and entity reference nodes. In addition, because the attribute type might be unknown, there are no tokenized attribute values.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNodeList | cXmlDomNotation | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMAttribute

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomAttribute
psName | Contains the attribute name
Value | Contains the attribute value
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMAttribute

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMAttribute

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
ParentNode | Function | Returns an object that is the parent of the current node
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMCDATASection

Properties Events Methods Index of Classes

XML class for handling CDATA Section nodes

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomCharacterData
---------BaseXmlDomTextNode
------------BaseXmlDomcDataSection
---------------cXMLDOMCDATASection

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

CDATA sections are used to escape blocks of text containing characters that would otherwise be regarded as markup. The only delimiter that is recognized in a CDATA section is the "]]>" string that ends the CDATA section. CDATA sections cannot be nested. The primary purpose is for including material such as XML fragments, without needing to escape all the delimiters.

Note: The text contained by the CDATA section is stored in a text node. Note that this text can contain characters that need to be escaped outside CDATA sections.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNodeList | cXmlDomNotation | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMCDATASection

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomCharacterData
piLength | Returns the number of characters in the data string
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMCDATASection

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMCDATASection

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
ParentNode | Function | Returns an object that is the parent of the current node
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMComment

Properties Events Methods Index of Classes

XML class for handling Comment nodes

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomCharacterData
---------BaseXmlDomComment
------------cXMLDOMComment

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

The comment field is entirely ignored by the parser. It is essentially character data, but its context in the document is unique - it has no semantic or syntactic value, only documentation value. No methods or properties distinguish it from a BaseXmlDomCharacterData node.

Note: The content refers to all characters between the starting . This object has no unique properties or methods of its own, but exposes the same objects and properties as objects of the BaseXmlDomCharacterDataBaseXmlDomCharacterData class.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomCDataSection | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNodeList | cXmlDomNotation | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMComment

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomCharacterData
piLength | Returns the number of characters in the data string
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMComment

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMComment

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
ParentNode | Function | Returns an object that is the parent of the current node
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMDocument

Properties Events Methods Index of Classes

Provides the Interface to the root node of an XML document

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomDocument
---------cXMLDOMDocument

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

The cXMLDOMDocument class provides the Interface to the root node of an XML document. It includes methods and properties used to obtain or create all other XML objects. An object of the cXmlDomDocument class is a grouping of nodes that logically describe an XML document. There is a root element, from which all other elements descend in a tree-like structure.

The cXMLDOMDocument class is your starting point for XML processing. Normally you create a cXMLDOMDocument and then create all of your other XML node objects dynamically, destroying those nodes when they are no longer needed. This section contains a good deal of introductory material designed to guide you through all of the XML classes and messages. This section is divided into the following sections:

XML Basics - an XML Overview

  • Introduction - an Introduction to XML
  • XML Essentials - a brief reminder of XML basics
  • XML In Visual DataFlex - how XML is used in VDF
  • The Main XML Classes - using the XML classes in VDF

Examples - XML Sample code

  • Parsing an XML Document within a BPO
  • Display attributes for an element
  • Displaying data from a file
  • Displaying data from several files
  • Traversing a list of nodes forwards
  • Traversing a list of nodes backwards

XML Basics

Introduction

Extensible Markup Language (XML) is a markup language for describing structured data in a text file or elsewhere. It is not the purpose of this Help to describe the theory of XML, but rather the Visual DataFlex support for it. There are many good books written on XML which you can find in local bookstores and the local library. In addition, you can find much information on the Internet.

Visual DataFlex supports XML through an interface consisting of several classes, which allow you to access elements in an XML document; work on them, then save them back into the document. Each element you request is returned as a fully-formed DataFlex Object for you to work on. When you are done, it is saved back into the document.

The top-level Visual DataFlex interface is simple and powerful but, for advanced use, you can also access the lower levels if you wish. For this reason, all the classes and messages are given here, but you can often achieve the results you want by using only the top-level interface.

XML Essentials

The following is a very brief reminder of the essentials you need to keep in mind when using the XML classes.

While Hypertext Markup Language (HTML) specifies how to display data in a browser (e.g. bold or italic), XML defines the content of the data as elements (e.g. Name and Address). In XML, you then use stylesheets to describe the presentation. You can then use different stylesheets and applications to present and process the same data differently in different browsers.

The structure of an XML document can be implied through its contents, or it can be formally defined, either by a Document Type Definition (DTD) or by a Schema. A DTD describes the rules of the document it accompanies, whereas a Schema is an extensible language which users can augment with additional information such as data types, inheritance, and presentation rules.

Data sent with a DTD or Schema is known as "valid XML". As long as it follows a few rules, data sent without a DTD or Schema is known as "well-formed" and implicitly describes itself. The rules are: Each start tag must have a corresponding end tag (and tags are case-sensitive); Elements must not overlap; Certain characters (<, >) cannot be used without special treatment, and each XML document must have a unique root element.

In HTML, there is always a single Document object, which always has one or more Forms child objects, each of which has a single Images Collection child object. In XML, there is no advance knowledge of the structure of a document, and objects can be named anything you like. For this reason, XML documents are thought of as trees, with multiple nodes. Some will have no children of their own, and some will have collections of other nodes as children. A Node can only have one parent, and either zero or one collection of children. Some nodes can also have attributes, and each such attribute is itself a node..

There are various types of nodes, such as Text, Element, Comment, Entity Reference, Processing Instructions.

Some types of node (mostly the document and element nodes) may have an attribute property which contains either a reference to a NamedNodeMap containing the attribute node objects, or null if there are none.

Every node also has a childnodes property which contains either a reference to a NodeList containing a list of the child node objects, or null if there are none.

XML In Visual DataFlex

The key to understanding XML support in Visual DataFlex is the Document Object Model (DOM). You can think of this as a tree-view with each branch being a node. In DOM you parse a document on a node-by-node basis. You never create all the nodes needed to represent a document. Instead you get a handle to the node or nodes you need, you work on them, then destroy the handle when no longer needed. Destroying the handle does not affect the actual XML document - just your access to it via a node handle.

In DOM the handles are referred to as interface handles. You ask an XML document to create an interface handle for a particular part of the XML structure. In Visual DataFlex (VDF), we wrap the interface handles inside a DataFlex object. Actually, we create a VDF node object and bind the interface handle to the object. We talk to the node via VDF messages. When we are done, we destroy the VDF object which destroys the interface handle (one must always dispose of the interfaces).

The VDF model uses a very dynamic object creation/destruction scheme. You never really name the objects - you refer to them by their object handle (VDF Object ID). You call a function that says: "create me an XML node object, bind it to the following interface handle, and return its VDF object handle". You then work on the VDF node object. When done, you send a message saying "destroy the VDF node object".

Any message that returns or sends a handle is using VDF object handles. With the exception of the cXmlDomDocument object, all other objects are created by sending a message to the Document object or some other node object. When needed, a VDF object will be created and the object's ID (handle) will be returned. The object will be based on the appropriate class type, determined by the message being sent and the data being retrieved.

When you no longer need the node object it should be destroyed. This is done by sending the message Destroy to the object. This is extremely important. Any time an object handle is returned from an XML message, you have created a new object. It is your responsibility to destroy it when you no longer need it. If you forget to destroy an object it will be properly destroyed when you destroy its parent. Since all objects reside within an Xml document object, destroying the document object will properly dispose of child objects. However, this is considered bad technique.

You can traverse the Document tree by using property handles (and similarly-named functions) such as get DocumentObject, ParentNode, FirstChild, LastChild, NextSibling and PreviousSibling.

You can change the structure of the loaded XML document with methods such as CreateChildNode, CloneNode, RemoveNode, AddElement (procedure), AddElement (function), AddAttribute and others. You can change the content of nodes by setting read/write properties such as psNodeValue.

DTDs

There is no message that allows you to create a new DTD (it's not part of the Microsoft DOM specification.) The only way to create a new XML document with a DTD declaration is to create a new XML document and load a skeleton XML document that contains a DTD. You can do this by using LoadXML.(or LoadXMLDocument.)

Error Messages

Functions that fail when creating nodes return a 0. This is used by developers as normal error checking. All the node creation functions return an object handle. If the handle is zero, then no object was created and, most likely, an error that should be dealt with occurred.

Procedures that fail when creating nodes generate an error. Any of the Send AddXxxxxx messages (Send AddElement, Send AddChildComment, etc.) will generate an error DFERR_XML_INTERNAL_ERROR (4380) if the object can not be created and added. This is the only way you could tell if the operation succeeded or not. The assumption is made that you will never use the messages unless you are sure there will not be an error. If an error if possible you should use functions (Get CreateXxxxx followed by Get AppendNode or Get InsertBeforeNode) where you can check the return value to make sure the operation suceeded and proceed as needed.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

The Main XML Classes

The XML classes are derived from one of two super-classes - a cXmlDom Node class, or a cXmlDom Collection class.

Node Classes

The Node class exists in Visual DataFlex as the cXmlDomNode class and is the super-class for all of the other XML node classes (document, elements, attributes, etc.) When you need to create access to a node you use one of these classes.

cXmlDomNode contains the interface to handle all processing needs common to all node classes. Its sub-classes contain specialized messages that apply to each special node type. For this reason, it is wise to thoroughly understand the cXmlDomNode interface - it is used by all of the other classes.

While you will normally create an object based on the special XML node type you are working with, you can use the cXmlDomNode class to represent any XML node, but then you will be limited to using the generic node interface.

The most commonly used node objects are:

cXmlDomDocument - this represents your entire XML document. Typically you will create this object using standard DataFlex object-creation syntax. All other XML objects will be created, dynamically, within this object. A normal lifespan of a document object is:

  • create the XML document object
  • load the document (unless it is new)
  • retrieve information from the document, or alter the document by creating XML node objects that represent a part of the object. The node objects are very dynamic.
  • save the document (unless you are just retrieving information)
  • destroy the xml Document object

cXMLDomElement - this is is used to represent XML elements.

cXMLDomAttribute - this is used to represent attributes of an element.

Collection classes

Collection classes allow you to create an object that contains a collection of others nodes or attributes. FleXML has two types of collection objects - cXmlDomNodeList and cXmlDomNamedNodeMap. The cXmlDomNodeList is used to contain collections of other XML nodes (e.g. a collection of elements that all match a specified search pattern). The cXmlDomNamedNodeMap is used to contain collections of attributes (attributes are not considered to be nodes - although you can create attribute nodes).

Methods

The Visual DataFlex methods (messages) allow you to traverse the DOM tree and manipulate its nodes. Each node is defined as a specific node type, which also defines valid parent and child nodes for each node type. For most XML documents, the most common node types are element, attribute and text.

XML Examples

The following examples show different aspects of using XML within Visual DataFlex

  • Parsing an XML Document within a BPO
  • Display attributes for an element
  • Displaying data from a file
  • Displaying data from several files
  • Traversing a list of nodes forwards
  • Traversing a list of nodes backwards

Parsing an XML Document within a BPO

This sample shows you how to access an XML Document. To access an XML document for editing or reporting purposes you do the following:

  • Declare an object of the cXmlDomDocument class and set its properties
  • Get a handle to the document by sending a "Get LoadXMLDocument" message (and preferably testing for a valid response)
  • Get a handle to the main document element by sending a "Get DocumentElement" message
  • Get a handle to the rootnode of the element you are interested in by sending a "Get FindNodeList" message with an appropriate parameter
  • Find the number of items in the returened NodeList by sending a "Get NodeListLength" message
  • Decrement the length by one (because it is zero-based)
  • Loop through the nodelist, sending a "Get CollectionNode" message; working on the value, then destroying the handle to the nodelist item
  • Destroy the handles to the nodelist and the document

The translates into DataFlex code as follows:

Object oBPOXML is a BusinessProcess
    :
    Procedure OnProcess
           handle hoXML hoRoot hoList hoCust
           Integer iItems i bOK

           Get Create U_cXMLDOMDocument to hoXML

           // you can use Create (as above) or create
           // the object using standard Object syntax (as below)
           //    Object oXML is a cXmlDomDocument
           //       Move Self to hoXML
           //    End_Object

           Set psDocumentName of hoXML to "http://localhost/xml/customer.xml"
           Set pbAsync of hoXML To False
           Set pbValidateOnParse of hoXML To True

           Get LoadXMLDocument of hoXML to bOK

           If not bOK Begin
               Send BasicParseErrorReport Of hoXml
               procedure_return
           end
           showln 'loaded'
           Get DocumentElement of hoXML to hoRoot
           Get FindNodeList of hoRoot "CUSTOMER" to hoList
           Get NodeListLength of hoList to iItems
           Decrement iItems
           For i from 0 to iItems
               Get CollectionNode of hoList i to hoCust
               Send ShowCust hoCust

               Send Destroy of hoCust
           Loop
           send Destroy of hoList
           send Destroy of hoXML
        End_Procedure  // OnProcess

        Procedure ShowCust handle hoCust
           string sName sPhone sState
           Get AttributeValue of hoCust "NAME" to sName
           Get ChildNodeValue of hoCust "TELEPHONE" to sPhone
           Get ChildNodeValue of hoCust "ADDRESS/STATE" to sState
           Showln sName ' ' sPhone ' ' sState

        End_procedure
End_Object    // oBPOXML

Display attributes for an element

The following program displays the attributes for an element on the screen.

Use dfallent.pkg
use Flexml.pkg

Object oTest Is A Panel

    Procedure Test
        Integer i // Index used to iterate through the list of attributes
        Integer bOk // Boolean to test return value
        Handle  hoXML      // Handle to XML document object
        Handle  hoRootNode // Handle to root node of document
        Handle  hoNode     // Handle to XML interface of search node
        Handle  hoAttributeCollection // Handle to collection of attributes
        Integer iAttributeCount  // Number of attributes of node found
        Handle  hoAttributeNode  // Hndl to dynamic object to access atributes
        String  sQueryString     // String to query for search node
        String  sAttributeName   // String that holds each attribute's name
        String  sAttributeValue  // String that holds each attribute's value

        // Create document object
        Get Create U_cXmlDomDocument to hoXML

        // Set the name of the document
        Set psDocumentName of hoXML to ".\Customer.xml"

        // Turn on the xml parse test so errors are reported.
        Set pbValidateOnParse of hoXML to True

        // Load the document
        Get LoadXMLDocument of hoXml to bOK

        // If the document fails to load, abort the program
        If Not bOK begin
            Send BasicParseErrorReport of hoXML
            Send Destroy of hoXML
            Procedure_Return
        End

        // Search from the root
        Get DocumentElement of hoXML to hoRootNode
        if (hoRootNode = 0) Begin
            Error 10001 "Cannot get the root node for the XML document test.xml"
            Send Destroy of hoXml
            Procedure_Return
        End

        // Do a query for a customer whose name is "Ming Foo Bakery"
        Move ("CUSTOMER[@NAME='Ming Foo Bakery']") to sQueryString
        Get FindNode of hoRootNode sQueryString to hoNode

        If (hoNode=0) Begin
            Error 10002  "Cannot find customer Ming. in the XML document test.xml"
        End
        Else Begin
            // Now do test - get attribute collection
            Get AttributeNodes of hoNode to hoAttributeCollection
            If (hoAttributeCollection = 0) Begin
                ERROR 10003 "Cannot get collection of attributes for Ming. node"
            End
            Else Begin
                // Show the attributes of the collection.
                // First, get the number of items in the set
                Get NodeListLength of hoAttributeCollection to iAttributeCount
                // Now, iterate through the list of items.
                For i From 0 to (iAttributeCount-1)
                    // Get each attribute (indexed by i) -
                    // a dynamic object is returned.
                    Get CollectionNode of hoAttributeCollection i to hoAttributeNode
                    // Get the name of the attribute.
                    Get psNodeName of hoAttributeNode to sAttributeName
                    // Get its value.
                    Get psText of hoAttributeNode to sAttributeValue
                    // Show on the screen.
                    Showln "Attribute " sAttributeName " has the value "  sAttributeValue
                    // Destroy the attribute object.
                    Send Destroy of hoAttributeNode
                Loop
                Send Destroy of hoAttributeCollection
            End
            Send Destroy of hoNode
        End

        // Cleanup. Destroy objects that were created.
        Send Destroy of hoRootNode
        Send Destroy of hoXML
    End_Procedure

End_Object

Send Test of oTest
Send Stop_Box "Program has completed"

Displaying data from a file

The following program accesses data from a datafile and writes it to an XML file. For full explanations and commented code, see the examples in the "..\VDF9.1\Examples\XML-Sample\AppSrc" directory.

Use Flexml.pkg
Use Customer.dd

ACTIVATE_VIEW Activate_oXMLSample2 FOR oXMLSample2
Object oXMLSample2 is a dbView
    Set Label to "XML - Sample 2"
    Set Size to 262 412
    Set Location to 7 5

    Object oSaveCustomertoXML is a BusinessProcess
        Property integer pbAllowDuplicates false
        Set Location to 2 388
        Set Status_Panel_State to FALSE

        Object Customer_DD is a Customer_DataDictionary
        End_object

        Procedure OnProcess
            Handle hoXML hoRoot hoList hoCust hoDD
            Integer iItems i bErr  bAllowDuplicates bOk
            String sDataPath
            Get pbAllowDuplicates to bAllowDuplicates
            Get Create U_cXMLDOMDocument to hoXML
            Get CurrentDataPath of ghoWorkSpace to sDataPath
            Set psDocumentName of hoXML to (sDatapath - "\Mycustomer.xml")
            Set pbValidateOnParse of hoXML To True
            Get LoadXMLDocument of hoXML to bOK
            Get DocumentElement of hoXML to hoRoot
            If not hoRoot ;
                Get CreateDocumentElement of hoXML "Customers" to hoRoot
            Move Customer_DD to hoDD
            Send Clear of hoDD
            Send Find of hoDD GT 1
            While (found)
                Send AddCustomer hoRoot bAllowDuplicates
                Send Find of hoDD GT 1
            end
            Send Destroy of hoRoot
            Get SaveXMLDocument of hoXML to bErr
            Send Destroy of hoXML
        End_Procedure

        Procedure AddCustomer handle hoRoot integer bAllowDuplicates
            handle hoCust hoAdd hoEle
            string sQuery
            If not bAllowDuplicates begin
             Move ("Customer[@Customer-Id='"+trim(Customer.Customer_Number)+"']") to sQuery
               Get  FindNode of hoRoot sQuery to hoCust
               If hoCust Begin
                    Send Destroy of hoCust
                    Procedure_return
               end
            end
            Get  AddElement of hoRoot "Customer" "" to hoCust
            Send AddAttribute of hoCust "Customer-Id" (trim(Customer.Customer_Number))
            Send AddElement   of hoCust "Name" (trim(Customer.Name))
            Get  AddElement   of hoCust "Address" "" to hoAdd
            Send AddElement   of hoAdd "Street" (trim(Customer.Address))
            Send AddElement   of hoAdd "City" (trim(Customer.City))
            Send AddElement   of hoAdd "State" (trim(Customer.State))
            Send AddElement   of hoAdd "Zip" (trim(Customer.Zip))
            Send Destroy of hoAdd
            Send AddElement   of hoCust "Telephone" (trim(Customer.Phone_Number))
            Send Destroy of hoCust
        end_procedure
    End_Object

    Object oWriteCustomertoXML is a Button
        Set Label to "Write Customers to XML file"
        Set Size to 14 91
        Set Location to 210 208
        Procedure OnClick
            Send DoProcess of oSaveCustomertoXML
            Send Info_Box "XML File has been Created"
        End_Procedure
    End_Object

End_Object

Displaying data from several files

The following program accesses data from multiple related datafiles and writes it to an XML file. For full explanations and commented code, see the examples in the "..\VDFx\Examples\XML-Sample\AppSrc" directory.

Use Flexml.pkg
Open customer
Open SalesP
Open vendor
Open Invt
Open OrderHea
Open OrderDtl

ACTIVATE_VIEW Activate_oXMLSample4 FOR oXMLSample4
Object oXMLSample4 is a dbView
        Set Label to "XML4"
        Set Size to 286 435
        Set Location to 1 2

        Object oBPOXMLWrite1 is a BusinessProcess
            Set Location to 196 96
            Set Display_Error_State to TRUE
            Set Status_Panel_State to FALSE

            Property Integer pbUseCData False

            Function Encode string sDat Returns string
               Move (Replaces("&",sDat,"&"))      to sDat
               Move (Replaces("<",sDat,"<"))           to sDat
               Move (Replaces(">",sDat,">"))          to sDat
               Move (Replaces('"',sDat,"""))        to sDat
               Function_Return sDat
            End_Function

            Procedure OnProcess
                Integer bTest
                Handle  hoRoot hoXML
                string sDataPath
                Get CurrentDataPath of ghoWorkSpace to sDataPath
                Get Create U_cXMLDOMDocument to hoXML
                Set psDocumentName of hoXML to (sDatapath - "\records-1.XML")
                Get LoadXMLDocument of hoXML to bTest
                Get DocumentElement of hoXML to hoRoot
                If Not hoRoot ;
                   Get CreateDocumentElement of hoXML "Tables" to hoRoot
                Showln "Writing XML"
                Send OutPutTable hoRoot Customer.File_number
                Send OutPutTable hoRoot SalesP.File_number
                Send OutPutTable hoRoot OrderHea.File_number
                Send OutPutTable hoRoot OrderDtl.File_number
                Send OutPutTable hoRoot Invt.File_number
                Send OutPutTable hoRoot Vendor.File_number
                Send Destroy Of hoRoot
                Get  SaveXMLDocument of hoXML to bTest
                Showln "Saving XML"
                Send Destroy Of hoXML
                Showln "Done"
            End_Procedure

            Procedure OutputTable handle hoRoot integer iFile
                String  sFile sQuery
                Handle  hoTable
                Integer bRetVal bUseCData
                Get pbUSeCData to bUseCData
                Get_Attribute DF_FILE_LOGICAL_NAME of iFile to sFile
                Move ("Table[@Name='" + sFile + "']") to sQuery
                Get FindNode of hoRoot sQuery to hoTable
                If hoTable Begin
                   Get YesNo_Box (sFile * "exists. Replace?") to bRetVal
                   If (bRetVal=MBR_No) Begin
                      Send destroy of hoTable
                      Procedure_return
                   end
                   Else Begin
                      Get RemoveNode of hoRoot hoTable to hoTable
                      Send destroy of hoTable
                   End
                End

                Showln "Writing " sfile
                Get  AddElement of hoRoot "Table" "" to hoTable
                Send AddAttribute    Of hoTable "Name" sFile
                Send AddAttribute    Of hoTable "File" iFile
                Clear iFile
                VFind iFile 0 GT
                While (Found)
                    Send OutputRows hoTable iFile bUseCData
                    VFind iFile 0 GT
                End
                Send Destroy of hoTable
            End_procedure

            Procedure OutPutRows ;
                      handle hoNode integer iFile integer bUseCData
                integer iField iFields bRetVal iType
                string sTag sField
                handle hoRow hoField
                Get AddElement of hoNode "Row" "" to hoRow
                Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
                For iField from 1 to iFields
                    Get_Attribute DF_FIELD_TYPE of iFile iField to iType
                    If (iType<>DF_OVERLAP) Begin
                        Get_Field_Value iFile iField to sField
                        Move (trim(sField)) to sfield
                        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

                        Get AddElement of hoRow "Field" "" to hoField
                        If bUseCData ;
                            Send AddCDataSection of hoField sField
                        Else Begin
                            Get Encode sField to sField // encode < > ; and "
                            Send AddChildTextNode of hoField sField
                        End

                        Send AddAttribute Of hoField "Field-number" iField
                        Send AddAttribute Of hoField "Name" sTag
                        Send Destroy of hoField
                    end
                Loop
                Send Destroy of hoRow
            End_procedure
        End_Object

        Object oWriteXml1 is a Button
            Set Label to "Write Tables to XML "
            Set Size to 14 82
            Set Location to 218 6
            Procedure OnClick
                send DoProcess of oBPOXMLWrite1
            End_Procedure
        End_Object

End_Object

Traversing a list of nodes forwards

The following program shows how to navigate a list of nodes from first to last.

Use DFAllent.pkg
Use Flexml.pkg

Object oTest Is A cObject

    Procedure ShowInformation Integer hoNode Integer iLineCount
        String sName
        Integer iType
        // If the node is an element (e.g. Customer), get the element's nodename and the attribute value for NAME
        // skip all non-element nodes
        Get piNodeType of hoNode to iType
        If (iType = NODE_ELEMENT) Begin
           Get AttributeValue of hoNode "NAME" to sName
           Showln iLineCount ": Node is [" (psNodeName(hoNode)) "] Name is [" sName "]"
        End
    End_Procedure

    Procedure Test
        Integer bOk              // Boolean to test return value.
        Integer hoXML            // Handle to XML Document object
        Integer hoRoot           // Handle to root node of document.
        Integer hoNode           // handle to a node for testing
        Integer hoNextNode       // used to find the previous node
        Integer iLineCount

        // Create document object

        Get Create U_cXmlDomDocument to hoXML
        Set psDocumentName of hoXML to ".\Customer.xml"
        // Turn on the xml parse test so errors are reported.
        Set pbValidateOnParse of hoXML to True

        // Load the document
        Get LoadXMLDocument of hoXml to bOK

        // If the document fails to load, abort the program
        If nOT bOK begin
            Send BasicParseErrorReport of hoXml
            Send Destroy of hoXML
            Procedure_Return
        End

        // Search from the root.
        Get DocumentElement of hoXml to hoRoot
        if (hoRoot=0) Begin
            Error 10001 "Cannot get the root node for the XML document test.xml"
            Send Destroy of hoXml
            Procedure_Return
        End

        // traverse through nodes. Start with first child and then
        // move through each sibling
        Move 0 to iLineCount
        Get FirstChild of hoRoot to hoNode // get the first node
        While (hoNode<>0)
            Increment iLineCount
            Send ShowInformation hoNode iLineCount
            Get NextNode of hoNode to hoNode // now get next sibling node, destroy current node
        Loop

        Send Destroy of hoRoot
        Send Destroy of hoXml

    End_Procedure

End_Object

Send Test of oTest
Send Stop_Box "Program has completed"

Traversing a list of nodes backwards

The following program demonstrates the use of phLastChild to traverse a list of nodes backwards.

Use DFAllent.pkg
Use Flexml.pkg

Object oTest Is A cObject

    Procedure ShowInformation Integer hoNode Integer iLineCount
        String sName
        Integer iType
        // If the node is an element (e.g. Customer), get the element's nodename and the attribute value for NAME
        // skip all non-element nodes
        Get piNodeType of hoNode to iType
        If (iType = NODE_ELEMENT) Begin
           Get AttributeValue of hoNode "NAME" to sName
           Showln iLineCount ": Node is [" (psNodeName(hoNode)) "] Name is [" sName "]"
        End
    End_Procedure

    Procedure Test
        Integer bOk              // Boolean to test return value.
        Integer hoXML            // Handle to XML Document object
        Integer hoRoot           // Handle to root node of document.
        Integer hoNode           // handle to a node for testing
        Integer hoNextNode       // used to find the previous node
        Integer iLineCount

        // Create document object

        Get Create U_cXmlDomDocument to hoXML
        Set psDocumentName of hoXML to ".\Customer.xml"
        // Turn on the xml parse test so errors are reported.
        Set pbValidateOnParse of hoXML to True

        // Load the document
        Get LoadXMLDocument of hoXml to bOK

        // If the document fails to load, abort the program
        If not bOK begin
            Send BasicParseErrorReport of hoXml
            Send Destroy of hoXML
            Procedure_Return
        End

        // Search from the root.
        Get DocumentElement of hoXml to hoRoot
        if (hoRoot=0) Begin
            Error 10001 "Cannot get the root node for the XML document test.xml"
            Send Destroy of hoXml
            Procedure_Return
        End

        // traverse through nodes in backwards order. Start with last child and then
        // move up through each sibling
        Move 0 to iLineCount
        Get LastChild of hoRoot to hoNode // get the last node
        While (hoNode<>0)
            Increment iLineCount
            Send ShowInformation hoNode iLineCount
            Get PreviousSibling of hoNode to hoNextNode // now get previous sibling node
            Send Destroy of hoNode     // Important: get rid of the previous node object
            Move hoNextNode to hoNode
        Loop

        Send Destroy of hoRoot
        Send Destroy of hoXml

    End_Procedure

End_Object

Send Test of oTest
Send Stop_Box "Program has completed"

See Also

cXmlDomAttribute | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNodeList | cXmlDomNotation | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError | Info_Box

Last Edited: November 23, 2004


Properties for cXMLDOMDocument

View property list in alphabetical order

Name | Description
psDocumentName | The property for the document name
Inherited Properties from BaseXmlDomDocument
pbAsync | Indicates whether asynchronous download is enabled
pbPreserveWhiteSpace | Indicates whether whitespace will be preserved in the document
pbResolveExternals | Contains the external resolution state of the XML parser for this document
pbValidateOnParse | Returns the validation state of the parser
psURL | Returns the URL of the most recent XML document that contained an error
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMDocument

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMDocument

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
BasicParseErrorReport | Procedure | Returns detailed information about the last parse error
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentElement | Function | Sets up the first element in a document
CreateDocumentElementNS | Function | Sets up the first/root element in a document (that is namespace aware)
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
DocTypeNode | Function | Returns a DocumentType object if a DTD exists for this document
DocumentElement | Function | Returns a handle to the root element of the document
DocumentObject | Function | Returns handle of an XML node's parent document object
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
LoadXML | Function | Loads an XML document from a string
LoadXMLDocument | Function | Loads an XML Document
LoadXMLFromAddress | Function | Loads an XML document from data pointed to by address
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
NodeClassId | Function | Returns the classId for the passed iType
ParentNode | Function | Returns an object that is the parent of the current node
phXMLErrorObject | Function | Handle to the last parse error reported
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SaveXMLDocument | Function | Saves an XML Document
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMDocumentFragment

Properties Events Methods Index of Classes

XML class for handling Document Fragments

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomDocumentFragment
---------cXMLDOMDocumentFragment

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

cXmlDomDocumentFragment is similar to a cXmlDomDocument object, but it is not tied to a specified URL. Sometimes it is useful to extract a portion of a document's tree (for example, to copy to multiple documents) or to create a new document node by node. The cXmlDomDocumentObject fits this purpose well. The document can be assembled offline and then assigned to a document.

Note: Nodes of the cXmlDomDocumentFragment class have special, defined behavior for cXmlDomNode insert operations that makes it especially convenient for developers. When an DocumentFragment is inserted into a node of the cXmlDomElement class (or other node that can take children), the children of the DocumentFragment are inserted into the node rather than the DocumentFragment itself. This makes the DocumentFragment useful when the user wants to create nodes that are siblings; the DocumentFragment acts as the parent of these nodes so that the user can employ the standard methods from the cXMLDomNode interface, such as InsertBeforeNode and AddChildNode.

The children of a DocumentFragment node are zero or more nodes representing the tops of any subtrees defining the structure of the document. DocumentFragment nodes do not need to be well-formed XML documents (although they do need to follow the rules imposed upon well-formed XML parsed entities, which can have multiple top nodes). For example, a DocumentFragment might have only one child, and that child node could be a Text node. Such a structure model represents neither an HTML document nor a well-formed XML document.

This object has no unique properties or methods of its own, but exposes the same objects and properties as the cXMLDomNode Interface.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNodeList | cXmlDomNotation | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMDocumentFragment

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMDocumentFragment

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMDocumentFragment

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
ParentNode | Function | Returns an object that is the parent of the current node
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMDocumentType

Properties Events Methods Index of Classes

Contains information associated with the document type declaration

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomDocumentType
---------cXMLDOMDocumentType

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

The XMLDOMDocumentType object contains information associated with the document type declaration. Each document may have a document type definition node that allows the entities and notations of a DTD or schema to be obtained. Because nothing is currently (June 1999) settled as far as schema definitions are concerned, there is nothing else that a Document Type interface does, aside from giving us an interface to enumerate through the entities and notations. The version 1.0 DOM specification does not allow Document Type nodes to be manipulated. It's read-only.

Note: Each object of the cXmlDomDocumentType class includes a property that identifies the document's XMLDOMDocument object. The XMLDOMDocumentType object provides access to the list of entities and notations defined for the document.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomElement | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNodeList | cXmlDomNotation | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMDocumentType

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMDocumentType

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMDocumentType

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
ParentNode | Function | Returns an object that is the parent of the current node
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMElement

Properties Events Methods Index of Classes

XML class for handling an element node

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomElement
---------cXMLDOMElement

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

The purpose of the cXMLDOMElement is for creating element node objects. Elements are the nodes that provide the framework for the document object. Because elements can have children, they are the focal points of the document structure. Other types of data nodes (such as attributes and text nodes) are generally placed at strategic points to embellish the content of the document, but the element nodes form the document's core.

Note: Element nodes are among the most common objects in the XML document tree. Element nodes can have attributes associated with them. By definition, attributes are not defined as child nodes of an element and are not considered to be part of the document tree. Accordingly, the cXmlDomElement class provides methods to make it easier to manage attributes, including methods to associate an attribute with an element, and to retrieve an attribute object and the attribute value by name.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNodeList | cXmlDomNotation | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMElement

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomElement
AttributeValue | Gets and sets attributes in an element
psTagName | The element name
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMElement

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMElement

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
AttributeValueNS | Function | Returns the value of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
ParentNode | Function | Returns an object that is the parent of the current node
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveAttribute | Procedure | Removes an attribute from an element node
RemoveAttributeNS | Procedure | Removes an attribute from an element node based on NamespaceURI and BaseName
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SetAttributeValue | Procedure | Creates/Replaces and sets an attribute value
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMEntity

Properties Events Methods Index of Classes

XML class for handling an Entity node

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomEntity
---------cXMLDOMEntity

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

This interface represents an entity, either parsed or unparsed, in an XML document. Note that this models the entity itself, not the entity declaration. Entity declaration modeling has been left for a later level of the DOM specification.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNodeList | cXmlDomNotation | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMEntity

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomEntity
psNotationName |
psPublicId |
psSystemId |
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMEntity

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMEntity

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
ParentNode | Function | Returns an object that is the parent of the current node
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMEntityReference

Properties Events Methods Index of Classes

XML class for handling Entity Reference nodes

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomEntityReference
---------cXMLDOMEntityReference

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

EntityReference objects are used when an entity reference is in the source document, or when the programmer wishes to create an entity reference. The processor may choose to expand all entity references at the time of the document's loading. The resolution of the children of the EntityReference (the replacement value of the referenced Entity) may only be evaluated when necessary. Actions by the programmer (such as returning the phChildNodes property of an EntityReference node) force the evaluation to occur.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntity | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNodeList | cXmlDomNotation | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMEntityReference

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMEntityReference

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMEntityReference

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
ParentNode | Function | Returns an object that is the parent of the current node
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMNamedNodeMap

Properties Events Methods Index of Classes

XML class for handling Named Node map (collections of attributes)

Hierarchy

cObject
---BaseXmlDomNamedNodeMap
------cXMLDOMNamedNodeMap

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMCollectionMixin cXMLDOMMixin

Description

Objects of the XMLDOMNamedNodeMap class have support for iteration through the collection of attribute nodes, which are not maintained in any particular order.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNode | cXmlDomNodeList | cXmlDomNotation | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMNamedNodeMap

View property list in alphabetical order

Name | Description
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMNamedNodeMap

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMNamedNodeMap

View method list in alphabetical order

Name | Type | Description
ChangeNodeClass | Function | Changes the class of an XML node
CollectionNode | Function | Accesses items of a collection by item number
NamedNode | Function |
NodeListLength | Function | Returns number of items in the collection
QualifiedNode | Function | Returns an object handle to an attribute node that matches the NamespaceURI and Basename
RemoveNamedNode | Function | Removes a named attribute node and returns removed node
RemoveQualifiedNode | Function | Removes an attribute node that matches the NamespaceURI and Basename and returns the removed node's handle
SetNamedNode | Function |
Inherited Methods from BaseXmlDomNamedNodeMap
Reset | Function |
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMNode

Properties Events Methods Index of Classes

Creates a generic XML DOM Node object

Hierarchy

cObject
---BaseXmlDomNode
------cXMLDOMNode

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

The cXmlDomNode class is a generic node class that can be used to describe generic interfaces for any XML node. Object are rarely created based on this class.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNodeList | cXmlDomNotation | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMNode

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMNode

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMNode

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
ParentNode | Function | Returns an object that is the parent of the current node
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMNodeList

Properties Events Methods Index of Classes

Supports iteration through the node collection

Hierarchy

cObject
---BaseXmlDomNodeList
------cXMLDOMNodeList

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMCollectionMixin cXMLDOMMixin

Description

The cXmlDomNodeList supports iteration through the node collection, which is not maintained in any particular order.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNotation | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMNodeList

View property list in alphabetical order

Name | Description
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMNodeList

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMNodeList

View method list in alphabetical order

Name | Type | Description
ChangeNodeClass | Function | Changes the class of an XML node
CollectionNode | Function | Accesses items of a collection by item number
NodeListLength | Function | Returns number of items in the collection
Inherited Methods from BaseXmlDomNodeList
Reset | Function |
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMNotation

Properties Events Methods Index of Classes

XML class for handling a Notation node

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomNotation
---------cXMLDOMNotation

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

cXMLDOMNotation is a notation declared in the DTD. A notation either declares, by name, the format of an unparsed entity (see section 4.7 of the XML 1.0 specification), or is used for formal declaration of Processing Instruction targets (see section 2.6 of the XML 1.0 specification).

Note: Notations identify by name the format of unparsed entities, the format of elements that bear a notation attribute, or the application to which a processing instruction is addressed.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNodeList | cXmlDomProcessingInstruction | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMNotation

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomNotation
psPublicId |
psSystemId |
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMNotation

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMNotation

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
ParentNode | Function | Returns an object that is the parent of the current node
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMProcessingInstruction

Properties Events Methods Index of Classes

XML class for handling Processing Instruction (PI) nodes

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomProcessingInstruction
---------cXMLDOMProcessingInstruction

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

Processing instruction nodes are used to communicate with XML processors - programs that implement XML vocabularies. This allows processing instructions to be placed in the document and processed by XML processors. The format of a processing instruction is:

 <? Target: Data >

Target is the first token following the <? delimiter. It is separated from the data of the processing instruction by the colon delimiter.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNodeList | cXmlDomNotation | cXmlDomTextNode | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMProcessingInstruction

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomProcessingInstruction
psTarget |
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMProcessingInstruction

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMProcessingInstruction

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
ParentNode | Function | Returns an object that is the parent of the current node
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXMLDOMTextNode

Properties Events Methods Index of Classes

XML class for handling a text node

Hierarchy

cObject
---BaseXmlDomNode
------BaseXmlDomCharacterData
---------BaseXmlDomTextNode
------------cXMLDOMTextNode

Library: Common (Windows and Web Application) Class Library

Package: Flexml.pkg

Mixins: cXMLDOMNodeMixin cXMLDOMMixin

Description

The Text interface represents the textual content (termed character data in XML) of an Element or Attribute

Note: XML refers to this text content as character data and distinguishes it from markup - the tags that modify that character data. If there is no markup inside an element, that element's text is contained in a single cXmlDomTextNode object that is the child of the element. If there is markup inside an element, it is parsed into child elements that are siblings of the cXmlDomTextNode object(s). Note that the content of the markup elements also appears within text nodes, which are the children of the specific markup element.

Using the XML Classes

The cXmlDomDocument class is the starting point for most XML processing. Refer to the cXmlDomDocument class for more information about the XML Document Object Model (DOM) and using XML within Visual Dataflex. Samples are provided in this section.

See Also

cXmlDomDocument | cXmlDomAttribute | cXmlDomCDataSection | cXmlDomComment | cXmlDomDocumentFragment | cXmlDomDocumentType | cXmlDomElement | cXmlDomEntity | cXmlDomEntityReference | cXmlDomNamedNodeMap | cXmlDomNode | cXmlDomNodeList | cXmlDomNotation | cXmlDomProcessingInstruction | BaseXmlDomParseError

Last Edited: August 6, 2003


Properties for cXMLDOMTextNode

View property list in alphabetical order

Name | Description
Inherited Properties from BaseXmlDomCharacterData
piLength | Returns the number of characters in the data string
Inherited Properties from BaseXmlDomNode
HasChildNodes | Indicates whether a node has child nodes
paXML | Returns an address of the XML representation of the node and its descendant nodes
pbParsed | Returns true if node has been parsed
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema
piNodeType | The type of the node
psBaseName | Returns the node name with the namespace prefix removed
psNamespaceURI | Returns the URI for the namespace as a string
psNodeName | Returns a string containing the name that was set at the time the node was created
psNodeValue | Contains the contents of a node
psPrefix | Returns the element namespace prefix
psText | Returns a string that is the textual representation of the node and its descendants
psXML | Returns the XML representation of the node and its descendant nodes as a string
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXMLDOMTextNode

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXMLDOMTextNode

View method list in alphabetical order

Name | Type | Description
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node
AddAttributeNode | Function |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node
AddChildNode | Function | Adds a child node of specified type
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node
AddElement | Function | Creates a new node and appends it to the list
AddElement | Procedure | Creates a new node and append it to the list
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list
AppendNode | Function | Appends a node to the end of list
AttributeNodes | Function | Creates a collection of all attributes
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string
ChangeNodeClass | Function | Changes the class of an XML node
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value
ChildNodes | Function | Creates a collection of all nodes
ChildNodeValue | Function | Gets the "value" of an element
CloneNode | Function | Creates a clone of the passed node
CreateAttributeNode | Function | Creates an attribute in a document
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle
CreateCDATASectionNode | Function | Creates a cDataSection text node
CreateChildComment | Function | Creates a child comment
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object
CreateChildProcessingInstruction | Function | Creates a child processing instruction
CreateChildTextNode | Function | Creates a child text node
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node
CreateElementNode | Function | Creates an XML Element node
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware
ElementNodes | Function | Returns a collection of just the elements
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes
EnumerateElements | Procedure | Provides a way to enumerate through all child elements
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes
FindNode | Function | Returns a handle to a single XML node
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object
FirstChild | Function | Finds the first child of a node and returns a handle to it
InsertBeforeNode | Function | Inserts a new node before the current node
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename
LastChild | Function | Finds the last child of a node and returns a handle to it
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values
NextNode | Function | Returns the object's next sibling node and destroys the current node
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list
ParentNode | Function | Returns an object that is the parent of the current node
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list
RemoveNamedNode | Function | Removes the named node
RemoveNode | Function | Removes a node
ReplaceNode | Function | Replaces a node
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: cXmlHttpTransfer

Properties Events Methods Index of Classes

Provides an easy mechanism for sending and receiving XML documents via Http.

Hierarchy

cObject
---InetTransfer
------cBaseHTTPTransfer
---------cHttpTransfer
------------cXmlHttpTransfer

Library: Common (Windows and Web Application) Class Library

Package: cXmlHttpTransfer.pkg

Description

This class provides an easy mechanism for sending and receiving XML documents via Http. XML documents can be sent and retrieved as XML objects. XML data (actually any data) can also be sent using strings or data pointers but the main purpose of this class is to allow the sending and receiving of XML document wrapped in DOM objects. In addition, properties exist that allow you to determine if and how your posted and received data will be translated.

Sample

Here is an example of GETting XML data. It will return the received data as an XML object.

Function GetMyData returns Handle
    handle hoHttp
    handle hoRcvdXml

    // Create xmlHttp transfer object.
    Get Create U_cXmlHttpTransfer to hoHttp
    // we choose not to translate the incoming data
    Set peTranslateReceived of hoHttp to xtNoTranslate
    // post xml document and receive returned Xml document
    Get HttpGetXmlNode of hoHttp "dataaccess.com" ;
        "MyApplication/XmlService.asp" to hoRcvdXml
    // transfer object no longer needed
    Send Destroy of hoHttp
    // return rcvd XML document, or 0 if error
    Function_Return hoRcvdXml // this is newly created, and must be destroyed by the calling method
End_Function

Sample

Here is an example of posting and receiving XML data. The XML document to be posted is sent to this function as a DOM object. It will return the received data as an XML object.

Function PostMyData handle hoSentXml returns Handle
    handle hoHttp
    handle hoRcvdXml

    // create xmlHttp transfer object.
    Get Create U_cXmlHttpTransfer to hoHttp
    // post xml document and receive returned Xml document
    Get HttpPostXmlNode of hoHttp "dataaccess.com" ;
        "MyApplication/XmlService.asp" hoSentXml to hoRcvdXml
    // transfer object no longer needed
    Send Destroy of hoHttp
    // return rcvd XML document, or 0 if error
    Function_Return hoRcvdXml // this is newly created, and must be destroyed by the calling method
End_Function

This class allows you to transfer and receive data that is larger than the string size limitations imposed by DataFlex. It does this by augmenting OnDataReceived and using heap functions and address data types to manipulate the data. You may wish to study the class source code to see how this is done so you can create other cHttpTransfer subclasses that allow you to transfer large amounts of data. Also note that the event, OnDataReceived, is not a public event in this class - you should not change it.

Last Edited: August 12, 2005


Properties for cXmlHttpTransfer

View property list in alphabetical order

Name | Description
pbClearHeaders | Determines if Http Headers should be cleared before XML data is posted
pbDataRequiredReceived | Determines if a respose of no data should be considered valid
pbDataRequiredSent | Determines if a request of no data should be considered valid
peTranslateReceived | Determines character translation for received data
peTranslateSent | Determines character translation for posted (sent) data
peXmlTransferStatus | Returns the status of the last xml http request
psContentTypeExpected | Specifies the expected content type of the response
psContentTypeReceived | Contains the content type of the received data after an XML Http request
psContentTypeSent | Contains the content type that is used for posted data
Inherited Properties from cBaseHTTPTransfer
pbShowErrorDialog | Determines if a popup dialog will appear when a client certificate or usename/password is needed for an Http Request
psAcceptTypes | Specifies the HTTP content types accepted by the client
psProtocolVersion | Specifies the HTTP protocol version
psSaveasFile | Saves response from the remote host to the specified file instead of triggering the OnDataReceived event
Inherited Properties from InetTransfer
LastErrorCode | Returns the last error code from the HTTP / FTP Transfer
peTransferFlags | Various flags that control how file/data should be transferred
piBufferSize | Specifies the size of the file transfer buffer
piRemotePort | Specifies the port to connect to on RemoteHost
psAgent | Specifies the name of the application
psPassword | Specifies the password to use to log on
psProxy | Specifies the name of the Proxy server used, if any
psRemoteHost | Specifies the hostname or the IP address of the remote server
psUserName | Specifies the name of the user to log on
RootHandle | Returns the root HINTERNET handle used for the session
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for cXmlHttpTransfer

View event list in alphabetical order

Name | Description
OnDataReceived | Sent when data is received - this method should not be augmented.
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for cXmlHttpTransfer

View method list in alphabetical order

Name | Type | Description
HttpGetXmlAddr | Function | Retrieves XML data and returns the memory address of that data
HttpGetXmlNode | Function | Requests XML data
HttpGetXmlString | Function | Retrieves XML data as a string
HttpPostXmlAddr | Function | Posts and receives XML data as pointers
HttpPostXmlNode | Function | Posts and receives XML data via XML object nodes
HttpPostXmlString | Function | Posts and receives XML data as string
LastError | Procedure | Used to report an error after a failed xml http transfer
TransferErrorDescription | Function | Returns an error description for the last transfer
TranslateData | Function | Translates the data based on the mode and returns a pointer to the translated data
Inherited Methods from cHttpTransfer
HttpPostRequest | Function | Performs an HTTP POST request using sFilePath
HttpPutRequest | Function | Performs an HTTP PUT request using sFilePath
Inherited Methods from cBaseHTTPTransfer
AddHeader | Function | Adds the HTTP header named sHeaderName with the value sHeaderValue to the HTTP headers
ClearHeaders | Procedure | Clears all HTTP headers added using AddHeader
HTTPGetRequest | Function | Performs an HTTP GET request using sFilePath
HTTPPostAddrRequest | Function | Performs an HTTP POST request
HTTPputAddrRequest | Function | Performs an HTTP PUT request using sFilePath
ResponseHeader | Function | Returns the value for a named http response header
ResponseStatusCode | Function | Returns the response http status code
SelectClientCertificate | Function | Selects a client certificate to be used in an Http request
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DataDictionary

Properties Events Methods Index of Classes

This class provides the main method for accessing databases in Visual DataFlex programs.

Hierarchy

cObject
---BaseData_Set
------DataSet
---------DataDictionary

Library: Common (Windows and Web Application) Class Library

Package: Datadict.pkg

Description

Data Dictionaries

Data Dictionaries are one of the most important and most complex topics in Visual DataFlex. The Class Reference will provide you with syntactical and usage information, but you should read the Data Dictionary Guide to learn the concepts behind this powerful class.

In Visual DataFlex, your application business rules are expressed through and managed by Data Dictionaries. Data Dictionaries create a layer between your application logic and your data. This has the following advantages:

  • It lets your application interact more effectively with your database -- Data Dictionaries provides your application with a wealth of information about your database that is not part of your physical database. It extends your database.

  • It protects your data -- Data Dictionaries make sure that only valid data is added to your database.

  • It centralizes application logic -- All of the information and rules about a Table is stored in a single place. If you need to make a change, you make a change in a single place and all parts of your application acquire the change.

Data Dictionary Classes

Data Dictionaries are defined as classes. You will create a Data Dictionary class for each table in your database. These classes will be used while you are building your application and when you run your application.

Data Dictionary classes are built using Database Builder. See the Defining Data Dictionary Classes section of the Data Dictionary Guide for conceptual help on building Data Dictionary Classes.

Syntax

Object {DDOName} is a {DataDictionaryClassName}
End_Object    // {DDOName}

or

Object {DDOName} is a {DataDictionaryClassName}
    Set DDO_Server to {Parent1-DDOName}
    Set DDO_Server to {Parent2-DDOName}
    Set Constrain_File to {ParentTableName}.File_Number
End_Object    // {DDOName}

Argument Explanation

Constant | Meaning
{DDOName} | The name of the DataDictionary object (DDO)
{DataDictionaryClassName} | The name of the DataDictionary subclass object {DDOName} is based on. This subclass is maintained in Database Builder
{Parent1-DDOName},{Parent2-DDOName},... | The name of the parent table DDOs
{ParentTableName} | The name of a parent table that this {DDOName} is constrained to

Usage

This is a typical DataDictionary Object (DDO) structure you would use in a Visual DataFlex component, such as a dbView.

Object oVendor_DD is a Vendor_DataDictionary
End_Object    // oVendor_DD

Object oInvt_DD is a Invt_DataDictionary
    Set DDO_Server to oVendor_DD
End_Object    // oInvt_DD

Object oCustomer_DD is a Customer_DataDictionary
End_Object    // oCustomer_DD

Object oSalesp_DD is a Salesp_DataDictionary
End_Object    // oSalesp_DD

Object oOrderhea_DD is a Orderhea_DataDictionary
    Set DDO_Server to oCustomer_DD
    Set DDO_Server to oSalesp_DD
End_Object    // oOrderhea_DD

Object oOrderdtl_DD is a Orderdtl_DataDictionary
    Set DDO_Server to oOrderhea_DD
    Set DDO_Server to oInvt_DD
    Set Constrain_File to Orderhea.File_Number
End_Object    // oOrderdtl_DD

Set Main_DD to oOrderhea_DD
Set Server to oOrderhea_DD

Last Edited: July 26, 2006


Properties for DataDictionary

View property list in alphabetical order

Name | Description
Allow_Foreign_New_Save_State | Allows saving of a new record when the file is being used as a foreign file (e.g. related parent or grandparent) in a component (e.g. dbView)
Error_Report_Mode | Determines how errors are generated through the messages Operation_Not_Allowed and Data_Set_Error
Existing_Key_Value | Holds the concatenated values of all the fields that have been flagged to be key fields
Field_Changed_State | Flags a field as changed or not, which determines whether the field participates in a save operation
Field_Changed_Value | Changes the current value of a database field and to set the field's changed state to true.
Field_CheckBox_Value | Returns the value for a field for the passed in checkbox state (checked or unchecked)
Field_CheckBox_Values | Sets the field up for use in a checkbox contro
Field_Class_Name | Assigns the class name of a specific control to each field
Field_Count | Returns the number of fields in the object
Field_Current_Description | Returns the description for the current value of a data file field as listed in the field's validation table
Field_Current_Pointer_Value | Returns a pointer to the data in the extended field object
Field_Current_Value | Gets or sets the current value of a database field
Field_Default_Value | Sets the default value of a field, for defaulting values in new records
Field_Entry_MSG | Sets the ID of the message to be sent when the cursor enters the field
Field_Error | Assigns a specific error message for validation errors for this field
Field_Error_Message | Retrieves the error message for a table field
Field_Error_Number | Retrieves the error number for a data file field
Field_Exit_MSG | Sets the ID of the message to be sent when the cursor exits the field
Field_Index | Used to retrieve the index for a field owned by this DDO
Field_Label | Returns the value of the Field_Label_Long or the Field_Label_Short properties, or the tag name of a data file field
Field_Label_Long | A long description (or translation) of the name of iField for such purposes as form captions
Field_Label_Short | A short description (or translation) of the name of iField for such purposes as form captions
Field_Mask | Provides the token characters for the mask for a database field
Field_Mask_Type | Controls the mask type of the field
Field_Option | The state of the passed field property for the passed data file field
Field_Options | Sets field properties for a database field
Field_Prompt_Object | Used to get/set the ID of the Prompt_Object for a field, such as a lookup (selection) list
Field_Select_State | Sets the field's state in the local buffer
Field_Table_Object | Returns the object handle of a field's ValidationTable if one exists
Field_Validate_MSG | Lets you assign a general-purpose message to be sent when a field should be validated
Field_Value_Check | Defines the field to use a check-type validation
Field_Value_Range | Allows you to define a minimum and maximum range for the field
Field_Value_Table | Identifies the object id of a validation table set up to validate this field
Field_Zoom_Object | Get/sets the ID of the Zoom_Object for a field, such as a lookup (selection) list
File_Field_Changed_State | Flags a foreign field as changed or not, which determines whether the field participates in a save operation
File_Field_Changed_Value | Changes the current value of a foreign database field and to set the field's changed state to true.
File_Field_CheckBox_Value | Returns the value for a foreign field for the passed in checkbox state (checked or unchecked)
File_Field_Current_Description | Returns the description for the current value of a data file field as listed in the field's validation table
File_Field_Current_Pointer_Value | Returns a pointer to the data in the extended field object
File_Field_Current_Value | Gets or sets the current value of a foreign database field
File_Field_default_Value | Sets the default value of a foreign field, for defaulting values in new records
File_Field_Index | Used to retrieve the index for a file and field
File_Field_Label | Returns the value of the value of the Field_Label_Long or the Field_Label_Short properties, or the tag name of a data file field
File_Field_Label_Long | A long description (or translation) of the name of a foreign field for such purposes as form captions
File_Field_Label_Short | A short description (or translation) of the name of a foreign field for such purposes as form captions
File_Field_Mask | Provides the token characters for the mask for a database field
File_Field_Mask_Type | Controls the mask type of the field
File_Field_Option | Sets a DD field option
File_Field_Options | Sets field properties for a database field
File_Field_Prompt_Object | Gets/sets the ID of the Prompt_Object for a field, such as a lookup (selection) list
File_Field_Select_State | Sets the field's state in the local buffer
File_Field_Status_Help | Gets/Sets status-line help text for the passed field
File_Field_Table_Object | Returns the object handle of a file and field's ValidationTable if one exists
File_Field_Zoom_Object | Gets/sets the ID of the Zoom_Object for a field, such as a lookup (selection) list
Foreign_Field_Options | Allows you to assign additional item options to a field when that field is used as a parent field
Key_Field_State | Designates a field as the primary key field for a table
Key_Value | Returns the complete (all fields) key value for the current record
pbDDAttach | Detemines if an Attach is limited to the current DDO Structure
Protect_Key_State | Determines whether users are prevented from changing the values of key fields
Status_Help | Gets/Sets status-line help text for the field
System_File_Count | Determines the number of System Files used by the DDO
System_File_Lock_Mode | Returns the File Lock mode for a system file
System_File_Number | Returns the File number for a system file
Validate_All_Fields_State | Supports Request_Validate_All
Validate_Delete_Structure_Mode | Determines what type of DataDictionary object-structure validation will occur before a delete operation
Validate_DEOs_Only_State | Determines whether validation is limited to fields represented in the current view
Validate_Foreign_File_State | Determines if field validation should be applied to foreign (parent) tables
Validate_Save_Structure_Mode | Determines what type of DataDictionary object structure validation will occur before a save operation
Inherited Properties from DataSet
Auto_Fill_State | Determines whether a DataDictionary object (DDO) will attempt to find the first record in its defined set when it becomes in-use
Constrain_File | The number of the table that should constrain the main file of this object
DDO_Server | The Object_ID of this object's server DataDictionary object (DDO)
Field_Main_Index | (Obsolete) Returns the number of the index to use for finding on the specified table field.
Inherited Properties from BaseData_Set
Can_Delete | Determines if a delete operation of the current record is permitted
Cascade_Delete_State | Determines how a delete should be affected by the existence of child-file records that relate to the record being deleted
Changed_State | Determines whether DEOs attached to this object have changed and/or whether a related parent record has changed
Client_File | Returns the number of the table at the passed-in position in this object's client table list
Client_File_Count | Returns the number of files in this object's client file list
Current_Record | The number of the record most recently retrieved from the database
Data_Set_Client | Returns the object id of the DataDictionary object (DDO) at position iItem in this object's container DDO list
Data_Set_Client_Count | Returns the number of DataDictionary objects (DDOs) in this object's container DDO list
Data_Set_Server | Returns the object id of the DataDictionary object (DDO) at position iItem in this object's server DDO list
Data_Set_Server_Count | Returns the number of DataDictionary objects (DDOs) in this object's server DDO list
Data_Set_User_Interface | Returns the object id of the data entry object (DEO) at position iItem in this object's user-interface DEO list
Data_Set_User_Interface_Count | Returns the number of data entry objects (DEOs) in this object's user-interface DEO list
Entry_Permissive_State | (Obsolete) Determines whether changing of parent record relationships is permitted.
In_Use_State | Determines whether this object has at least one active user-interface object or one of this object's containers is in use
Main_File | Identifies the table managed by this Data Dictionary class/object
No_Delete_State | Determines whether delete operations via this object are permitted
No_Relate_State | Determines whether relate operations will be executed after find operations by this object
Ordering | Specifies the index which should be used for all find operations
pbAutoFillFromFirst | Allows child DDOs to auto-fill from the last record
pbInheritConstraints | Determines if a main DDO should inherit its constraints (finding filters) from its parent DDOs
Read_Only_State | Determines whether save or delete operations will occur in this object's main table
Server_File | Returns the number of the table at the passed in position in this object's server-file list
Server_File_Count | Returns the number of table in this object's server-file list
Should_Save | Can be used to determine if a DDO has changed.
Should_Save_Row | Determines if a DDO is changed according to dbGrid "row" logic
Smart_Filemode_For_Lock | Determines the locked file mode setting for tables participating in save or delete operations
Smart_Filemode_For_No_Lock | Determines the unlocked file mode setting for tables that should not participate in save or delete operations
Smart_Filemode_State | Governs whether this object can use file-locking optimization for its tables
Which_Data_Set | Returns object id of object owning specified table
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DataDictionary

View event list in alphabetical order

Name | Description
Attach_Main_File | Performs attach command on main file
Define_Fields | Defines DataDictionary rules for data file fields at the class level
Field_Defaults | Designed to be augmented to establish the default values that will appear after a clear operation
New_Current_Record | (Obsolete) Hook for performing operations during save, delete, and clear operations
OnNewCurrentRecord | Notification event that is sent every time the DDO's record is switched
Inherited Events from DataSet
OnConstrain | Defines constraint sets within a DataDictionary object (DDO)
Inherited Events from BaseData_Set
Backout | Hook for performing operations when editing or deleting a new record
Clear_Main_File | Performs clear command on main table of this object
Creating | Hook for performing operations required when creating a new record
Delete_Main_File | Performs the actual delete of the record
Deleting | Hook for performing operations when deleting a record
Relate_Main_File | Does nothing by default. Called after the normal relate on the main table has been executed.
Reset_Filemodes_For_Lock | Temporarily resets the file modes of the Main_File of this object and of any updated DataDictionary objects for a save/delete operation
Save_Main_File | Saves the main file
Update | Hook for performing operations when saving a record
Validate_Delete | Guards execution of delete operation
Validate_Delete_No_Cascade | Guards against deleting records with existing child records
Validate_Save | Used to enforce business rules and integrity rules
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DataDictionary

View method list in alphabetical order

Name | Type | Description
Add_System_File | Procedure | Adds iFile to this object's system file list
Data_Set | Function | Returns the object id of the DataDictionary object whose main file is passed to the function
Data_set_error | Procedure | Declares DataDictionary object (DDO) errors
DefineAllExtendedFields | Procedure | Creates extended DataDictionary fields for all text and binary fields within a DataDictionary object (DDO)
DefineExtendedField | Procedure | Creates extended DataDictionary field for a text or binary field within a DataDictionary object (DDO)
Extended_Error_Field | Function | Extends the extended error logic of the Error handler
Extended_Error_File | Function | Extends the extended error logic of the Error handler
Extended_error_message | Function | Called by the standard Visual DataFlex error handler when a DataDictionary error occurs
Field_Option_Clear | Procedure Set | Clears a DD field option
Field_Option_Toggle | Procedure Set | Toggles (reverse) the value of a DD field option
File_Field_AutoFind | Procedure | Performs an autofind based on the passed data file and field
File_Field_Default_AutoFind | Procedure | Performs an autofind in "default" mode based on the passed file and field
File_Field_Entry | Procedure Set | Allows you to place data into a DataDictionary field buffer using all the same logic that gets applied to data entry object/keyboard entry
File_Field_Find | Procedure | Allows you to simulate the find-key process of data entry objects within batch processes
File_Field_Option_Clear | Procedure Set | Clears a DD field option
File_Field_Option_Toggle | Procedure Set | Toggles (reverse) the value of a DD field option
File_Field_Pointer_Entry | Procedure Set | Called to move data from an entry source to the DataDictionary (DD) extended buffer
Find | Procedure | Performs a find operation on the DataDictionary's main data file using the passed mode and index
Operation_Not_Allowed | Procedure | Executes the error command with the passed in error number. Intended for augmentation
Remove_System_File | Procedure | Removes a table from this object's system file list
Request_Clear | Procedure | (Obsolete) See (and use) Clear message.
Request_Validate_All | Function | Similar to Request_Validate, except that a validation will continue after a validation error has occurred
Inherited Methods from BaseData_Set
Add_Client_File | Procedure | Adds a table to this object's related-child list
Add_Server_File | Procedure | Adds a table to this object's related-parent list
Add_User_Interface | Procedure | Adds the passed in hoDEO to the list of data entry objects (DEOs) for this object
Attach_Server | Procedure | (Obsolete) Use DDO_Server instead
Clear | Procedure | Clears all files owned by this object
Clear_All | Procedure | Clears all files owned by this object and all connected server DataDictionary objects (DDOs)
Constrain | Procedure | Defines constraint set for this object
CurrentRowId | Function | Returns the RowId of the current record
Detach_Server | Procedure | Disconnects this object and the specified DataDictionary object (DDO), where this object was the client of that DDO server
Establish_Find_Direction | Procedure | Initializes the constrained find commands to perform searches using the given parameters
Find_By_Recnum | Procedure | Finds record in specified table with record number equal to the passed in record number
FindByRowId | Procedure | Finds record in specified table with record identity equal to the passed RowId and updates the DDO structure
HasRecord | Function | Determines if the DataDictionary object (DDO) has a current record
Locate_Next | Procedure | Finds the next logical record using the passed in find mode, file, and index specified in a prior Establish_Find_Direction invocation
Read_By_Recnum | Procedure | Finds record in specified tabile with record number equal to the passed in record number
ReadByRowId | Procedure | Finds record in specified table with record identity equal to the passed RowId without updating or altering the DDO structure
Rebuild_Constraints | Procedure | Reconstructs constraints for a DDO
Refind_Records | Procedure | Checks to see if the record in the File-Buffer is the same as the record in the DDO-Field-Buffer and refinds the record if needed
Remove_Client_File | Procedure | Removes a table from this object's container-file list
Remove_Server_File | Procedure | Removes a table from this object's server-file list
Remove_User_Interface | Procedure | Removes a table from this object's data entry object (DEO)-list
Request_Assign | Procedure | Causes the Refresh message to be sent to all data entry objects for this object and its client and server DataDictionary objects as appropriate
Request_Clear_File | Procedure | Performs the Clear command on the specified table of the data-server structure
Request_Delete | Procedure | esponsible for deleting a record in the DDO for the main_file, updating all parent DDOs (and tables) and possibly deleting all child records
Request_Entry_Update | Procedure | Sends entry_update to all DEOs of the data set and DEOs of servers of the data set as required to store changes to record buffers
Request_Find | Procedure | Finds on specified table using given find mode and index
Request_Read | Procedure | Finds on specified table using given find mode and index
Request_Relate | Procedure | Performs a relate on the specified table without initializing the done-array
Request_Save | Procedure | Saves all changes in DEOs attached to this object or to any DDO that is a server of this object directly or indirectly
Request_Superfind | Procedure | Performs superfind on the designated table by the Main_Index of the designated field and notifies all connected DataDictionary objects (DDOs) of the result
Request_Validate | Function | Request_Validate sends validation messages to all DDO Field's that will participate in the upcoming save
Validate_Constraints | Function | Validates this object's constraints against the record buffer's current content
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DataList

Class: DataList (Abstract)

Properties Events Methods Index of Classes

Implements the behavior common to virtual scrolling lists and provides an interface to a DSO to support virtual list viewing

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------DataList_
------------------------------------------DataList
---------------------------------------------dbGrid_
---------------------------------------------dbList_

Library: Windows Application Class Library

Package: Dfdata.pkg

Description

DataList implements the behavior common to virtual scrolling lists, including dbList and dbGrid. DataList provides an interface to a DSO to support virtual list viewing.

Of Special Note

DataList defines the properties, procedures, and functions necessary to interface a virtual scrolling list with a DSO. The behavior of DataList is inherited by the dbList and dbGrid classes.

Customizing Cell Values with Entry_Display

Normally the contents of a cell is determined by the parameter defined in the entry_item command. This parameter is usually a data field value (entry_item customer.cust_name) or an expression ( entry_item (Customer.Balance/100) ). The values of row are updated by the entry_display message. This message is a good augmentation point and can be used to customize display output. When this procedure is called the proper record data is in the file buffers. When using this data you want to use the data from the file buffers and not from the data-dictionary buffers (the data-dictionary buffer only contains the refreshed data for the single selected row and not for the data for every row in the table).

You can use this procedure the value of cell and to change other attributes (fonts, colors, etc.). For example, in a dbList you may wish to display the values "Yes" and "No". In the following example, assume that column 0 is customer name, column 1 is customer name and column 2 shows if the customer's credit limit is exceeded. Your row structure would look like the following:

Begin_Row
    Entry_Item Customer.number
    Entry_Item Customer.Cust_Name
    Entry_Item ("") // we will fill this in entry_display
End_Row

Entry_display will be used as follows. Note that we must set values relative to column zero of the current row. This offset is determined by getting the base_item property.

Procedure Entry_Display integer i1 integer i2
    integer iBase
    integer bIsOver
    Forward send entry_display i1 i2 // normal display
    Move (Customer.Balance>Customer.Credit_Limit) to bIsOver
    Get base_item to iBase  // Item value of first column
    // we will use the if function to select a text value
    Set Value item (iBase+2) to (If(bIsOver, "Yes", "No"))
End_Procedure

Placing Bitmaps in Grid Cells

You can place bitmaps in individual cells of DbLists and dbGrids by setting the form_bitmap property. Normally this property will be set within the entry_display procedure. The named bitmap will be displayed within the cell along with whatever data (the item's value) may be set. Normally, a cell should contain data or a bitmap, but not both. If you are placing a bitmap in a cell, you will probably want to clear the cell's data contents by assigning its entry_item to a blank string (e.g. entry_item ("") ).

When setting form_bitmaps within entry_display, the program must set the item number by finding the item number of the first column and then adding the column offset. The following example adds a bitmap to a dbList based on the value of data field.

Object oSelList is a dbList
    Set Main_File to Salesp.File_Number
    Set Ordering to 1
    Set Size to 71 251
    Set Location to 6 6

    Begin_Row
        Entry_Item Salesp.Id
        Entry_Item Salesp.Name
        Entry_Item ("") // we will place our bitmap here
    End_Row

    Set Form_Width    item 0 to 40
    Set Header_Label  item 0 to "Id"

    Set Form_Width    item 1 to 175
    Set Header_Label  item 1 to "Name"

    Set Form_Width item 2 to 25
    Set Header_Label to "Region"

    // display a bitmap for each of the four regions in the company.
    Procedure Entry_Display integer i1 integer i2
        integer iBase // Item value of first column
        Forward send entry_display i1 i2 // normal display
        Get base_item to iBase
        If      Salep.Region eq "A" Set Form_BitMap item (iBase +2) to
            "RegionA.bmp"
        Else If Salep.Region eq "B" Set Form_BitMap item (iBase +2) to
            "RegionB.bmp"
            Else If Salep.Region eq "C" Set Form_BitMap item (iBase +2) to
                "RegionC.bmp"
                Else                     Set Form_BitMap item (iBase +2) to
                    "RegionD.bmp"
    End_Procedure

End_Object    // oSelList

It is up to you to provide appropriately designed and sized bitmaps. A good starting size is a width of 26 pixels and a height of 16 pixels.

Checkboxes are often represented with checkboxes and four bitmaps are provided in VDF's bitmap area that may be used for display or as a starting point for your customizations. These are bitmaps that represent four states of a checkbox used by dbLists:

1. Checked / Enabled (ChkOnE.bmp)

2. Not checked / Enabled (ChkOffE.bmp)

3. Checked / Disabled (ChkOnD.bmp)

4. Not checked / Disabled (ChkOffD.bmp)

These bitmaps may be used in a fashion similar to the above example. A special message, OnDisplayCheckBox, is provided that automatically displays the appropriate checkbox bitmap. You send this message an item number and a state and the procedure will display the appropriate bitmap based on the passed information and the item_shadow_state of the passed item. The following two samples would accomplish the same thing:

// display a check if Customer.Balance exceeds Customer.Credit_Limit.
// assume column 0 is customer number, column 1 is name, and
// column 2 is the credit exceeded checkbox
Procedure Entry_Display integer i1 integer i2
    integer iBase
    integer bIsOver
    Forward send entry_display i1 i2 // normal display
    Move (Customer.Balance >Customer.Credit_Limit) to bIsOver
    Get base_item to iBase  // Item value of first column
    // we will use the if function to select a bitmap
    Set Form_Bitmap item (iBase +2) to (If(bIsOver, "ChkOnD.Bmp", "ChkOffD.Bmp"))
End_Procedure

Procedure Entry_Display integer i1 integer i2
    integer iBase
    integer bIsOver
    Forward send entry_display i1 i2 // normal display
    Move (Customer.Balance >Customer.Credit_Limit) to bIsOver
    Get base_item to iBase  // Item value of first column
    Send DoDisplayCheckBox (iBase +2) bIsOver
End_Procedure

Using Checkboxes in dbGrids and dbLists

If your data dictionary defines a field as a checkbox field, you may display these as checkboxes in dbGrids and dbLists by setting the column's column_checkbox_state to true. The dbGrid and dbList class automatically create and support checkboxes. The method of display and interaction is distinctive to each class. The dbGrid displays a standard checkbox that may be used for editing and saving data. The dbList uses bitmaps to represent checkboxes that may be used for display and searching. Refer to the appropriate class for more information.

Child Objects

element - prototype_entry - user

This child is forward referenced by this object, and actually created by the begin_row/end_row commands. It serves as the prototype for all rows in the list.

records - array - self

This child holds the record numbers in the main file corresponding to the rows of the currently displayed page of items.

Last Edited: August 10, 2006


Properties for DataList

View property list in alphabetical order

Name | Description
Column_Button |
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to
Column_Option | Allows you to query or change the iOption option line for Column iCol
Column_Options | Allows you to copy column options or set them in a group
Column_Prompt_Object | Specifies the default receiving object for the popup message
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object
CustomScrollState | Determines changing scroll bar behaviors
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction
psEmbeddedButtonValue |
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior
Inherited Properties from DataList_
Auto_index_state | Determines how the popup lists will be ordered
Batch_State | Determines how much data from the database is read into memory
Current_Record | (Obsolete) The number of the record of the current row
CurrentRecordStatus |
CurrentRowHasRecord |
CurrentRowId |
Init_from_Top_State | Determines in what order images are displayed
Initial_Column | Determines where the cursor is located when the list is activated
Initial_Row | Governs the location in the display of the record (if any) in the buffer
Main_File | Holds the file number of the main file of the list
No_Relate_State | Determines if relates occur with lists that do not use DDOs
Ordering | Holds the index of the main file to be used to display the database records of the main file
pbReverseOrdering | Determines if the list should be displayed in reverse index order
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own
Prototype_Object | Returns the object-id of the internal object
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object
Record_Number | (Obsolete) Indicates the record number for the record in the specified row
record_rowId |
RecordStatus |
RowHasRecord |
Static_State | Determines if the list will only be initialized once the first time this object is activated
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DataList

View event list in alphabetical order

Name | Description
Header_Mouse_Click |
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view
onInitSpin |
Inherited Events from DataList_
OnNewOrdering | Called whenever the ordering is changed
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from WideList_
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DataList

View method list in alphabetical order

Name | Type | Description
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm
Inherited Methods from DataList_
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful
Clear_Current_Record | Procedure |
Col_Index | Function | Returns the number of the main index for the field connected to Column Item#
Display | Procedure |
DoCheckDisplayableRows | Procedure |
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList
DoToggleColumnOrdering | Procedure |
End_of_Data | Procedure | Finds the last record in the main_file of this object, and displays a new list page ending with that record if the find was successful
Establish_Find_Mode | Procedure |
File_Record | Function | (Obsolete)
FileRecord | Function |
FileRowId | Function |
Fill_List | Procedure |
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer
Find_Init | Procedure |
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object
find_RowId | Procedure |
Goto_Bottom_Row | Procedure |
Goto_Top_Row | Procedure |
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in
Read_By_Recnum | Procedure | (Obsolete)
Read_Next_Record | Procedure |
ReadByRowId | Procedure |
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col#
Reorder_list | Procedure | Permits manual reordering of the contents of the data list
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own
Up_Row | Procedure |
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DataList_

Class: DataList_ (Abstract)

Properties Events Methods Index of Classes

Abstract class that implements the behavior common to virtual scrolling lists

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------DataList_
------------------------------------------DataList

Library: Windows Application Class Library

Package: Dfdata.pkg

Mixins: Data_List_mixin

Description

DataList_ is an abstract class used to implement the behavior common to virtual scrolling lists, including dbList and dbGrid. Its sub-classes dbList and dbGrid should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DataList_

View property list in alphabetical order

Name | Description
Auto_index_state | Determines how the popup lists will be ordered
Batch_State | Determines how much data from the database is read into memory
Current_Record | (Obsolete) The number of the record of the current row
CurrentRecordStatus |
CurrentRowHasRecord |
CurrentRowId |
Init_from_Top_State | Determines in what order images are displayed
Initial_Column | Determines where the cursor is located when the list is activated
Initial_Row | Governs the location in the display of the record (if any) in the buffer
Main_File | Holds the file number of the main file of the list
No_Relate_State | Determines if relates occur with lists that do not use DDOs
Ordering | Holds the index of the main file to be used to display the database records of the main file
pbReverseOrdering | Determines if the list should be displayed in reverse index order
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own
Prototype_Object | Returns the object-id of the internal object
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object
Record_Number | (Obsolete) Indicates the record number for the record in the specified row
record_rowId |
RecordStatus |
RowHasRecord |
Static_State | Determines if the list will only be initialized once the first time this object is activated
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DataList_

View event list in alphabetical order

Name | Description
OnNewOrdering | Called whenever the ordering is changed
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from WideList_
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Click | Sent whenever a header has received a mouse click
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
onInitSpin | Augmented to set the minimum and maximum positions for a spinner
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DataList_

View method list in alphabetical order

Name | Type | Description
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful
Clear_Current_Record | Procedure |
Col_Index | Function | Returns the number of the main index for the field connected to Column Item#
Display | Procedure |
DoCheckDisplayableRows | Procedure |
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList
DoToggleColumnOrdering | Procedure |
End_of_Data | Procedure | Finds the last record in the main_file of this object, and displays a new list page ending with that record if the find was successful
Establish_Find_Mode | Procedure |
File_Record | Function | (Obsolete)
FileRecord | Function |
FileRowId | Function |
Fill_List | Procedure |
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer
Find_Init | Procedure |
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object
find_RowId | Procedure |
Goto_Bottom_Row | Procedure |
Goto_Top_Row | Procedure |
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in
Read_By_Recnum | Procedure | (Obsolete)
Read_Next_Record | Procedure |
ReadByRowId | Procedure |
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col#
Reorder_list | Procedure | Permits manual reordering of the contents of the data list
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own
Up_Row | Procedure |
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DataSet

Class: DataSet (Abstract)

Properties Events Methods Index of Classes

Abstract class providing methods for accessing databases in a program

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---BaseData_Set
------DataSet
---------DataDictionary

Library: Common (Windows and Web Application) Class Library

Package: Data_set.pkg

Description

DataSet is an abstract class used to provide methods for accessing databases in a program. Its sub-class DataDictionary should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DataSet

View property list in alphabetical order

Name | Description
Auto_Fill_State | Determines whether a DataDictionary object (DDO) will attempt to find the first record in its defined set when it becomes in-use
Constrain_File | The number of the table that should constrain the main file of this object
DDO_Server | The Object_ID of this object's server DataDictionary object (DDO)
Field_Main_Index | (Obsolete) Returns the number of the index to use for finding on the specified table field.
Inherited Properties from BaseData_Set
Can_Delete | Determines if a delete operation of the current record is permitted
Cascade_Delete_State | Determines how a delete should be affected by the existence of child-file records that relate to the record being deleted
Changed_State | Determines whether DEOs attached to this object have changed and/or whether a related parent record has changed
Client_File | Returns the number of the table at the passed-in position in this object's client table list
Client_File_Count | Returns the number of files in this object's client file list
Current_Record | The number of the record most recently retrieved from the database
Data_Set_Client | Returns the object id of the DataDictionary object (DDO) at position iItem in this object's container DDO list
Data_Set_Client_Count | Returns the number of DataDictionary objects (DDOs) in this object's container DDO list
Data_Set_Server | Returns the object id of the DataDictionary object (DDO) at position iItem in this object's server DDO list
Data_Set_Server_Count | Returns the number of DataDictionary objects (DDOs) in this object's server DDO list
Data_Set_User_Interface | Returns the object id of the data entry object (DEO) at position iItem in this object's user-interface DEO list
Data_Set_User_Interface_Count | Returns the number of data entry objects (DEOs) in this object's user-interface DEO list
Entry_Permissive_State | (Obsolete) Determines whether changing of parent record relationships is permitted.
In_Use_State | Determines whether this object has at least one active user-interface object or one of this object's containers is in use
Main_File | Identifies the table managed by this Data Dictionary class/object
No_Delete_State | Determines whether delete operations via this object are permitted
No_Relate_State | Determines whether relate operations will be executed after find operations by this object
Ordering | Specifies the index which should be used for all find operations
pbAutoFillFromFirst | Allows child DDOs to auto-fill from the last record
pbInheritConstraints | Determines if a main DDO should inherit its constraints (finding filters) from its parent DDOs
Read_Only_State | Determines whether save or delete operations will occur in this object's main table
Server_File | Returns the number of the table at the passed in position in this object's server-file list
Server_File_Count | Returns the number of table in this object's server-file list
Should_Save | Can be used to determine if a DDO has changed.
Should_Save_Row | Determines if a DDO is changed according to dbGrid "row" logic
Smart_Filemode_For_Lock | Determines the locked file mode setting for tables participating in save or delete operations
Smart_Filemode_For_No_Lock | Determines the unlocked file mode setting for tables that should not participate in save or delete operations
Smart_Filemode_State | Governs whether this object can use file-locking optimization for its tables
Which_Data_Set | Returns object id of object owning specified table
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DataSet

View event list in alphabetical order

Name | Description
OnConstrain | Defines constraint sets within a DataDictionary object (DDO)
Inherited Events from BaseData_Set
Attach_Main_File | Performs attach command on main file
Backout | Hook for performing operations when editing or deleting a new record
Clear_Main_File | Performs clear command on main table of this object
Creating | Hook for performing operations required when creating a new record
Delete_Main_File | Performs the actual delete of the record
Deleting | Hook for performing operations when deleting a record
New_Current_Record | (Obsolete) Hook for performing operations during save, delete, and clear operations
OnNewCurrentRecord |
Relate_Main_File | Does nothing by default. Called after the normal relate on the main table has been executed.
Reset_Filemodes_For_Lock | Temporarily resets the file modes of the Main_File of this object and of any updated DataDictionary objects for a save/delete operation
Save_Main_File | Saves the main file
Update | Hook for performing operations when saving a record
Validate_Delete | Guards execution of delete operation
Validate_Delete_No_Cascade | Guards against deleting records with existing child records
Validate_Save | Used to enforce business rules and integrity rules
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DataSet

View method list in alphabetical order

Name | Type | Description
Inherited Methods from BaseData_Set
Add_Client_File | Procedure | Adds a table to this object's related-child list
Add_Server_File | Procedure | Adds a table to this object's related-parent list
Add_User_Interface | Procedure | Adds the passed in hoDEO to the list of data entry objects (DEOs) for this object
Attach_Server | Procedure | (Obsolete) Use DDO_Server instead
Clear | Procedure | Clears all files owned by this object
Clear_All | Procedure | Clears all files owned by this object and all connected server DataDictionary objects (DDOs)
Constrain | Procedure | Defines constraint set for this object
CurrentRowId | Function | Returns the RowId of the current record
Detach_Server | Procedure | Disconnects this object and the specified DataDictionary object (DDO), where this object was the client of that DDO server
Establish_Find_Direction | Procedure | Initializes the constrained find commands to perform searches using the given parameters
Find_By_Recnum | Procedure | Finds record in specified table with record number equal to the passed in record number
FindByRowId | Procedure | Finds record in specified table with record identity equal to the passed RowId and updates the DDO structure
HasRecord | Function | Determines if the DataDictionary object (DDO) has a current record
Locate_Next | Procedure | Finds the next logical record using the passed in find mode, file, and index specified in a prior Establish_Find_Direction invocation
Operation_Not_Allowed | Procedure | Executes the error command with the passed in error number. Intended for augmentation
Read_By_Recnum | Procedure | Finds record in specified tabile with record number equal to the passed in record number
ReadByRowId | Procedure | Finds record in specified table with record identity equal to the passed RowId without updating or altering the DDO structure
Rebuild_Constraints | Procedure | Reconstructs constraints for a DDO
Refind_Records | Procedure | Checks to see if the record in the File-Buffer is the same as the record in the DDO-Field-Buffer and refinds the record if needed
Remove_Client_File | Procedure | Removes a table from this object's container-file list
Remove_Server_File | Procedure | Removes a table from this object's server-file list
Remove_User_Interface | Procedure | Removes a table from this object's data entry object (DEO)-list
Request_Assign | Procedure | Causes the Refresh message to be sent to all data entry objects for this object and its client and server DataDictionary objects as appropriate
Request_Clear_File | Procedure | Performs the Clear command on the specified table of the data-server structure
Request_Delete | Procedure | esponsible for deleting a record in the DDO for the main_file, updating all parent DDOs (and tables) and possibly deleting all child records
Request_Entry_Update | Procedure | Sends entry_update to all DEOs of the data set and DEOs of servers of the data set as required to store changes to record buffers
Request_Find | Procedure | Finds on specified table using given find mode and index
Request_Read | Procedure | Finds on specified table using given find mode and index
Request_Relate | Procedure | Performs a relate on the specified table without initializing the done-array
Request_Save | Procedure | Saves all changes in DEOs attached to this object or to any DDO that is a server of this object directly or indirectly
Request_Superfind | Procedure | Performs superfind on the designated table by the Main_Index of the designated field and notifies all connected DataDictionary objects (DDOs) of the result
Request_Validate | Function | Request_Validate sends validation messages to all DDO Field's that will participate in the upcoming save
Validate_Constraints | Function | Validates this object's constraints against the record buffer's current content
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbAppClient_

Class: dbAppClient_ (Abstract)

Properties Events Methods Index of Classes

Abstract class that creates view objects

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------MdiDialog
---------------------------AppDialog
------------------------------View
---------------------------------dbAppClient_
------------------------------------dbAppView_

Library: Windows Application Class Library

Package: Dfclient.pkg

Mixins: Entry_Client_mixin NESTING_Mixin NAVIGATE_Mixin SERVER_Mixin VERIFY_Mixin ACTION_BAR_Mixin Auto_Locate_Mixin Non_Dependent_Item_Mixin Deo_Delegate_Mixin

Description

The dbAppClient_ class is used to create view objects. Its sub-class dbView should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbAppClient_

View property list in alphabetical order

Name | Description
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from MdiDialog
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbAppClient_

View event list in alphabetical order

Name | Description
Inherited Events from AppDialog
Notify_Exit_Application | Called when an application is about to be closed
Verify_Exit_Application | Sent by the client area to verify that an application may be exited
Inherited Events from MdiDialog
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbAppClient_

View method list in alphabetical order

Name | Type | Description
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from AppDialog
Activate_View | Procedure | Activates the view
Inherited Methods from MdiDialog
Close_Panel | Procedure |
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbAppView_

Class: dbAppView_ (Abstract)

Properties Events Methods Index of Classes

Abstract class that creates view objects

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------MdiDialog
---------------------------AppDialog
------------------------------View
---------------------------------dbAppClient_
------------------------------------dbAppView_
---------------------------------------dbView

Library: Windows Application Class Library

Package: Dfclient.pkg

Mixins: entry_view_Client_mixin View_Dependent_Item_Mixin

Description

The dbAppView_ class is used to create view objects. Its sub-class dbView should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbAppView_

View property list in alphabetical order

Name | Description
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to
Auto_Top_Item_State |
Auto_top_view_State |
DEO_Attach_All_State |
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function
priInitialRowId |
View_Latch_State | Determines if the view's DSO structure will be initialized with the data
Inherited Properties from dbAppClient_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from MdiDialog
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbAppView_

View event list in alphabetical order

Name | Description
Closing_View |
Opening_View |
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used
Inherited Events from AppDialog
Notify_Exit_Application | Called when an application is about to be closed
Verify_Exit_Application | Sent by the client area to verify that an application may be exited
Inherited Events from MdiDialog
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbAppView_

View method list in alphabetical order

Name | Type | Description
Exit_Application_Check | Function |
Inherited Methods from dbAppClient_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from AppDialog
Activate_View | Procedure | Activates the view
Inherited Methods from MdiDialog
Close_Panel | Procedure |
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbBasicComboForm

Class: dbBasicComboForm (Abstract)

Properties Events Methods Index of Classes

Combines the capabilities of the ComboEntry class and the dbForm class

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseComboBoxEntry
------------------------------ComboEntry
---------------------------------dbBasicComboForm_
------------------------------------dbBasicComboForm
---------------------------------------dbDataComboForm

Library: Windows Application Class Library

Package: Dfbscent.pkg

Mixins: DFNavigate_Mixin DFCode_DEO_Mixin

Description

dbBasicComboForm is used to combine the capabilities of the ComboEntry class and the dbForm class. Use the sub-class dbComboForm for instantiation.

Note:
The primary purpose of this class is to mix DEO capabilities into a ComboForm. This supports the ability to fill a combo list with valid database values. Its subclass dbDataComboForm extends this class by allowing it to support separate values for display and database. The dbDataComboForm is also considered to be an intermediate class. Its subclass dbComboForm supports all these abilities and adds data-dictionary support. The dbComboForm should be used for instantiation. It supports data-value combo lists, description-value combo lists, and can be used with and without data dictionaries.

Please refer to the dbForm class concerning DEO form messages and behaviors. Refer to the ComboForm class for information regarding combo-form messages and behaviors.

Last Edited: November 21, 2004


Properties for dbBasicComboForm

View property list in alphabetical order

Name | Description
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Error_Message | Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value
Error_Number | The number of the error to be reported whenever validate_combo_item returns a non-zero value
Inherited Properties from dbBasicComboForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from ComboEntry
Allow_Blank_State | Determines if a blank value is valid
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Combo_Item_Count | Returns the number of choices in the combo object's list
Combo_Sort_State | Determines if the object will sort its visual list
Combo_Value | Specifies the value of an item in the combo objects data-list
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
ListRowCount | Determines the number of rows in a combo form
ListWidth | Detrmines the width of a combo's drop down list
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseComboBoxEntry
Combo_Data_Object | Specifies the object ID of the internal l combo object
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbBasicComboForm

View event list in alphabetical order

Name | Description
Inherited Events from dbBasicComboForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from ComboEntry
Combo_Edit_Changed | Sets the item_changed_state of this object's item true
Combo_Fill_List | Called when the combo list is to be filled
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnCloseUp | Called when a drop-down list closes
OnDropDown | Called when a drop-down list opens
OnDropKey |
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbBasicComboForm

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbBasicComboForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from ComboEntry
Activate_Area | Procedure |
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Combo_Add_Item | Procedure | Adds an item to the combo list
Combo_Delete_Data | Procedure | Deletes all this object's items
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Validate_Combo_Value | Function | Determines if a combo form's value is valid
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbBasicComboForm_

Class: dbBasicComboForm_ (Abstract)

Properties Events Methods Index of Classes

Abstract class that combines the capabilities of the ComboEntry class and the dbForm class

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseComboBoxEntry
------------------------------ComboEntry
---------------------------------dbBasicComboForm_
------------------------------------dbBasicComboForm

Library: Windows Application Class Library

Package: Dfbscent.pkg

Mixins: Entry_Form_ds_mixin Nesting_Mixin Navigate_Mixin Verify_Mixin Server_Mixin Action_Bar_Mixin Find_Edit_Mixin Entry_Item_Mixin DEO_Dependent_item_mixin Entry_CheckBox_Mixin DEO_Delegate_Mixin Validate_Mixin Clear_Defaults_Mixin

Description

dbBasicComboForm_ is an abstract class used to combine the capabilities of the ComboEntry class and the dbForm class. Its sub-classes dbComboForm and dbCodeComboForm should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbBasicComboForm_

View property list in alphabetical order

Name | Description
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from ComboEntry
Allow_Blank_State | Determines if a blank value is valid
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Combo_Item_Count | Returns the number of choices in the combo object's list
Combo_Sort_State | Determines if the object will sort its visual list
Combo_Value | Specifies the value of an item in the combo objects data-list
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
ListRowCount | Determines the number of rows in a combo form
ListWidth | Detrmines the width of a combo's drop down list
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseComboBoxEntry
Combo_Data_Object | Specifies the object ID of the internal l combo object
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbBasicComboForm_

View event list in alphabetical order

Name | Description
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from ComboEntry
Combo_Edit_Changed | Sets the item_changed_state of this object's item true
Combo_Fill_List | Called when the combo list is to be filled
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnCloseUp | Called when a drop-down list closes
OnDropDown | Called when a drop-down list opens
OnDropKey |
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbBasicComboForm_

View method list in alphabetical order

Name | Type | Description
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from ComboEntry
Activate_Area | Procedure |
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Combo_Add_Item | Procedure | Adds an item to the combo list
Combo_Delete_Data | Procedure | Deletes all this object's items
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Validate_Combo_Value | Function | Determines if a combo form's value is valid
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbBitmap

Properties Events Methods Index of Classes

Provides for automatic display of bitmap graphics by addressing a database field with an entry_display message

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------BitmapContainer
---------------------------dbBitmap

Library: Windows Application Class Library

Package: Dbbitmap.pkg

Mixins: Nesting_Mixin Navigate_Mixin Server_Mixin

Description

dbBitMap is used to provide for automatic display of bitmap graphics by addressing a database field with an entry_display message.

Usage

Object Country_Flag is a dbBitmap
    Entry_Item Country.Flag
    Set Border_Style to Border_Dialog    // Raised border
    Set Bitmap_Style to Bitmap_Stretch    // Auto-resize bitmap to fit object
    Set Size to 83 149
    Set Location to 12 54
End_Object

Of Special Note

Objects of this class display the bitmap file named in a database field to which it is linked, upon receiving the entry_display message from their data dictionary. With this class, you can associate one or more bitmap files with each record of a database file, such as personnel, customers, or virtually anything else.

If you want to clear the name of the bitmap to be displayed you need to set the bitmap name to blank (via set bitmap to) plus you need to set the changed state to true.

Sample

Set Bitmap Of oBitmapContainer To ""
Set Changed_State Of oBitmapContainer To True

Last Edited: November 21, 2004


Properties for dbBitmap

View property list in alphabetical order

Name | Description
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
NoPut_State | Specifies whether this object should store the filename of its current bitmap back to the database during a save
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Store_With_Pathname_State | Specifies whether the object should save back to the database the full pathname of the bitmap being displayed
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from BitmapContainer
Allow_Select_Bitmap_State | Determines if users will be able to browse a list of the bitmap files in a directory and select one for display
Changed_State | Determines if one or more of the child objects has changed
Dialog_Caption | Specifies the legend (Select a bitmap file by default) to be displayed at the top of the common open-file dialog that users will interact with
Initial_Folder | Specifies the path of the directory in which bitmap filenames will be searched for and displayed by the common file-open dialog
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbBitmap

View event list in alphabetical order

Name | Description
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbBitmap

View method list in alphabetical order

Name | Type | Description
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Inherited Methods from BitmapContainer
Invoke_Select_Bitmap | Procedure | Public message causing bitmap selection dialog to appear and if selected displays the bitmap
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbCheckbox

Properties Events Methods Index of Classes

To combine the functionality of dbForm and CheckBox allowing a data-entry element to be represented in a checkbox format

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------Entry
------------------------------dbForm_
---------------------------------dbFormDS
------------------------------------dbCheckBoxDS
---------------------------------------dbCheckbox

Library: Windows Application Class Library

Package: Dfenchk.pkg

Mixins: Extended_DEO_Mixin Extended_DEO_Status_Help_Mixin

Description

The dbCheckbox class is used to combine the functionality of dbForm and CheckBox allowing a data-entry element to be represented in a checkbox format. The data-entry element may only support one of two states, checked (true) and unchecked (false). The actual database value for checked and unchecked may be any value you wish. When used with a data dictionary, the database value for true and false is defined in the data dictionary. When used with a data set, the database value for true and false must be defined within this object.

Sample

Object MyCheckBox is a DbCheckBox // assume we are using a data dictionary
    Set location to 15 70
    Entry_Item Customer.Status
    Set Label to "Status"
End_Object

Object MyCheckBox is a DbCheckBox // assume we are using a data set
    Set location to 15 70
    Entry_Item Customer.Status
    Set CheckBox_Item "Status" "O" "C" // Open (true) Closed (False)
    Set Status_Help to "Is the customer currently open"

End_Object

Syntax

use dfentry

object object_name is a dbCheckBox
    Set location to Row Column
    entry_item file.field
    Set Label to CheckBoxLabel

    Set enabled_state to true|false

    Procedure onChange
        :
    End_Procedure

    Procedure onSetFocus
        :
    End_Procedure

    Procedure onKillFocus
        :
    End_Procedure

    // these are set when not using a data-dictionary
    Set CheckBox_Item to CheckBoxText TrueDBValue FalseDBValue
    Set Status_Help to text

end_object

Of Special Note

The dbCheckBox class is a subclass of the dbForm class and it inherits all of its data-aware knowledege. It is capable of performing saves, deletes, clears, and finds. Only the method of performing data entry is changed.

Using Data Dictionaries

When this object's server is a data dictionary, this object will acquire a great deal of "knowledge" from the server. It will "know" data types, input masks, status help and prompt objects, validation rules, entry rules, exit rule, display formats (capslock, etc., noput, displayonly, etc.) and much more regarding the data file and its fields. The dbCheckBox object will expect the data-field type to be defined as a checkbox in the data dictionary. It is expected that the data dictionary will provide the true and false database value. If you use data sets, you will need to provide the true and false value database values within the dbCheckBox object. This is done with the set checkbox_item message which sets the checkbox label, true database value, and false database value.

Labels

The label of a dbCheckBox object refers to the text that will appear the right of the check-box. If you wish to show a label to the left of the checkbox (similar to labels found on forms) you will need to create a separate textbox. The label value will be drawn from field properties in the DDO if you set auto_label_state true, overriding any label value you may have set in this object.

Auto-Sizing

The size of a checkbox is determined automatically based on the size of its label text. This auto-sizing may be disabled by setting the auto_size_state property to false.

The Server

Every object of this class should always be connected to a server (a data-dictionary object). While the server can be explicitly set within the object, it will usually be set within a parent (or other ancestor) container object.

Last Edited: November 21, 2004


Properties for dbCheckbox

View property list in alphabetical order

Name | Description
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
Inherited Properties from dbCheckBoxDS
AlignmentMode | Determines if the Label property will be displayed on the left or right of the checkbox icon
Auto_Size_State | Determines if object will be resized to the length of the label text
Checked_State | Reflects whether this object is checked
Label |
Inherited Properties from dbFormDS
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Inherited Properties from dbForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Entry
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbCheckbox

View event list in alphabetical order

Name | Description
Inherited Events from dbCheckBoxDS
OnChange |
Inherited Events from dbForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from Entry
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbCheckbox

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbFormDS
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Request_Save | Procedure |
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from Entry
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbCheckBoxDS

Class: dbCheckBoxDS (Abstract)

Properties Events Methods Index of Classes

Abstract class that combines the functionality of dbForm and CheckBox allowing a data-entry element to be represented in a checkbox format

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------Entry
------------------------------dbForm_
---------------------------------dbFormDS
------------------------------------dbCheckBoxDS
---------------------------------------dbCheckbox

Library: Windows Application Class Library

Package: Dfenchk.pkg

Mixins: Select_Mixin

Description

The dbCheckboxDS class is an abstract class used to combine the functionality of dbForm and CheckBox allowing a data-entry element to be represented in a checkbox format. Its sub-class dbCheckBox should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbCheckBoxDS

View property list in alphabetical order

Name | Description
AlignmentMode | Determines if the Label property will be displayed on the left or right of the checkbox icon
Auto_Size_State | Determines if object will be resized to the length of the label text
Checked_State | Reflects whether this object is checked
Label |
Inherited Properties from dbFormDS
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Inherited Properties from dbForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Entry
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbCheckBoxDS

View event list in alphabetical order

Name | Description
OnChange |
Inherited Events from dbForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from Entry
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbCheckBoxDS

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbFormDS
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Request_Save | Procedure |
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from Entry
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbCodeComboForm

Properties Events Methods Index of Classes

Provides combo objects that automatically use a central codes database file such as CODEMAST

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseComboBoxEntry
------------------------------ComboEntry
---------------------------------dbBasicComboForm_
------------------------------------dbBasicComboForm
---------------------------------------dbDataComboForm
------------------------------------------dbComboFormDS
---------------------------------------------dbCodeComboForm

Library: Windows Application Class Library

Package: Dfcdcent.pkg

Mixins: cCodeMaintOpen_Mixin

Description

dbCodeComboForm is used to provide combo objects that automatically use a central codes database file such as CODEMAST. These are never used used with data dictionaries. Combo forms that use data dictionaries automatically acquire CODEMAST access through the DDO with the dbComboForm class.

Sample

Object Orderhea_VIA is a dbCodeComboForm
    Entry_Item Orderhea.Via {iValidate =get_Validate_Combo_item}
    set entry_state to true
    Set Location TO 64 146
    Set Size     TO 60 95
    Set Label    TO 'Ship Via:'
    Set type_value to "SHIPPING"
    Set Status_Helpt to "Select Shipping Type"
End_Object

Syntax

Object object_name is a dbCodeComboForm
    set location to vertical horizontal
    set size to height width
    Entry_Item filename.field
    set label to text
    set type_value to typeName
    set entry_state to true|false
    set enabled_state to true|false
    set code_display_mode to DisplayMode
    Set Combo_Sort_state to true|false
    set status_help to StatusHelpT ext
    set allow_blank_state to true|false
End_Object

Of Special Note

Applications that use DataDictionary objects for database access do not need to use this class because this class's functionality can all be attained within the DataDictionary objects.

This class is preconfigured to draw its insertion and display values from the CODEMAST central codes database file supplied with Visual DataFlex.

The property type_value sets the CODEMAST type value. All records having this type will be added to the combo list (i.e., each Code and Description for a record of the type specified by type_value will be available).

The property code_display_mode may be used to determine whether the combo list displays the description (default - CB_CODE_DISPLAY_DESCRIPTION), the code (CB_CODE_DISPLAY_CODE), or both (CB_CODE_DISPLAY_BOTH).

Last Edited: November 21, 2004


Properties for dbCodeComboForm

View property list in alphabetical order

Name | Description
Inherited Properties from dbComboFormDS
Allow_Undefined_State | Determines if an undefined value is added to the combo list
Code_Field | The number of the field in the combo_data_file from which values are to be drawn for insertion into the main database file through the Code_field object
Code_File |
Code_Index |
Combo_Data_File | The file number containing the code_field
Combo_Index | The Index used by the combo form
Description_Field | The description field number in the combo_data_file
Type_Field |
Type_Value | Determines the type value of the validation list
Inherited Properties from dbDataComboForm
Code_Display_Mode | Specifies whether the list will display the choices' codes, descriptions, or both
Default_Value | Used by default_prompt procedure to set the default item upon the cursor's first entering this object
Undefined_Display_Mode | Used by find_item to decide what to display when this object is filled from the database with a value that is not found among the values of this object's combo items
Undefined_Save_Mode | Used by entry_update to decide what to save when a save is requested with a value in the window that is not among the prompts of this object
Undefined_Value | Used for display by find_item and for insertion into the database by entry_update when this item's undefined_display_mode or undefined_save_mode respectively is cb_err_update_blank_value
Inherited Properties from dbBasicComboForm
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Error_Message | Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value
Error_Number | The number of the error to be reported whenever validate_combo_item returns a non-zero value
Inherited Properties from dbBasicComboForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from ComboEntry
Allow_Blank_State | Determines if a blank value is valid
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Combo_Item_Count | Returns the number of choices in the combo object's list
Combo_Sort_State | Determines if the object will sort its visual list
Combo_Value | Specifies the value of an item in the combo objects data-list
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
ListRowCount | Determines the number of rows in a combo form
ListWidth | Detrmines the width of a combo's drop down list
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseComboBoxEntry
Combo_Data_Object | Specifies the object ID of the internal l combo object
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbCodeComboForm

View event list in alphabetical order

Name | Description
Inherited Events from dbComboFormDS
Combo_Fill_List | Sent by the construct_object procedure, and must be defined in this object if the object does not draw its data from a database file via combo_data_file, code_field, description_field, etc
Inherited Events from dbDataComboForm
Combo_Description_Value | A "hook" message that by default merely returns prompt
Inherited Events from dbBasicComboForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from ComboEntry
Combo_Edit_Changed | Sets the item_changed_state of this object's item true
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnCloseUp | Called when a drop-down list closes
OnDropDown | Called when a drop-down list opens
OnDropKey |
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbCodeComboForm

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbDataComboForm
Combo_Add_Item | Procedure | Augmented to support two parameters: a display value and a database value
Default_Code | Procedure | Sets current_item to the item having prompt equal to the value of the default_value property
Default_Prompt | Procedure | Sets the default item upon the cursor's first entering this object by sending default_code with parameter of default_value
Inherited Methods from dbBasicComboForm
Close_Panel | Procedure | Closes the panel or component currently open
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbBasicComboForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from ComboEntry
Activate_Area | Procedure |
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Combo_Delete_Data | Procedure | Deletes all this object's items
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Validate_Combo_Value | Function | Determines if a combo form's value is valid
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbComboForm

Properties Events Methods Index of Classes

Provides general-purpose comboform DEOs

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseComboBoxEntry
------------------------------ComboEntry
---------------------------------dbBasicComboForm_
------------------------------------dbBasicComboForm
---------------------------------------dbDataComboForm
------------------------------------------dbComboFormDS
---------------------------------------------dbComboFormDD_
------------------------------------------------dbComboForm

Library: Windows Application Class Library

Package: Dfcentry.pkg

Mixins: Extended_Deo_dfCombo_mixin

Description

dbComboForm is used to provide general-purpose comboform DEOs. This class optionally supports separate values for display and database storage. When used with a data dictionary, the list of combo data and display values is loaded automatically. When entry_state is true, the list is a dropdown edit list (data entry is permitted in the form). When entry_state is false, the list is a dropdown list (the form can only be filled with an item selected from the list).

Sample

Object Orderhea_VIA is a dbComboForm // when used with a data dictionary
    Entry_Item Orderhea.Via
    set entry_state to true
    Set Location TO 64 146
    Set Size     TO 60 95
    SET Label    TO 'Ship Via:'
End_Object

Object Orderhea_VIA is a dbComboForm // when used with a data set
    Entry_Item Orderhea.Via {iValidate =get_Validate_Combo_item}
    Set Location TO 64 146
    Set Size     TO 60 95
    Set Label    TO 'Ship Via:'
    procedure combo_fill_list
        send combo_add_Item "FEDEX" "F"
        send combo_add_Item "UPS"   "U"
        send combo_add_Item "COD"   "C"
    End_procedure
End_Object

Syntax

Object object_name is a dbComboForm
    set location to vertical horizontal
    set size to height width
    entry_item filename.field
    set label to text
    set entry_state to true|false
    set enabled_state to true|false
    set code_display_mode to DisplayMode
    Set Combo_Sort_state to true|false

// when used with a server, the following may be used
    set auto_label_state to true

// when used with no server, the following may be used
    set status_help to StatusHelpT ext
    set allow_blank_state to true|false

    procedure combo_fill_list
        send combo_add_item [DisplayValue] DataBaseValue
        :
    End_procedure
or:
    set combo_data_file to file_number
    set code_field to field_number
    set combo_index to index_number
    set description_field to field_number

End_Object

Of Special Note

A dbComboForm object is associated with a single data element which is assigned with the entry_item command. Each value in the dropdown list is a valid value for the entry item. The current value is displayed in the form. This class supports the separation of display value and database value. Each valid choice is defined with a data value (the value that is read and written to the database) and a description (the text value that is displayed in the form and the list). This separation is optional; the data value and description value may be the same. When using a data-dictionary these value are supplied automatically. When not using the data dictonary, the list must be filled within the object with the Combo_fill_list procedure.

Sorting the Combo List

By default the combo list is displayed in sorted order. This can be disabled by setting the property combo_sort_state to false.

Combo Lists vs. Selection Lists

Combo lists (dbComboForm) should not be used in place of selection lists (dbList). Normally selection lists should be used to look up records from a database (both main files and parent files) and combo lists should be used to find static choices provided from validation tables. Popup selection lists are used to look up data that is potentially large and potentially dynamic. In addition, selection lists support a number of flexible multi-index search capabilities that make it easy to find data. For example, a customer lookup should use a dbList.

A combo list is designed to be used with static data. The list is loaded once and does not change. When using data dictionaries, this distinction is very clear. Selection lists are used to find data from data files. Combo forms should be used to find data from validation tables.

Display Value and Database Value

A combo list may display the database values, the description values, or both. The property code_display_mode determines what is displayed. Valid modes are CB_Code_display_description (the default-displays the description), CB_Code_display_code (displays the code), and CB_Code_display_both (displays the code followed by the description). A list may contain only codes, in which case the code is displayed regardless of the code_display_mode. The default display-description mode is the most-flexible setting. It supports a complete separation of display and data.

Entry State of Forms

The entry_state (Item 0) of the form determines how keyboard interaction is handled. When true (the default), normal entry is allowed into the form. This is referred to as a dropdown-edit list. When set to false, the value in the form must match a value from the list and keyboard input performs an incremental search. This is referred to as a dropdown list.

The Form Component

A dbComboForm really consists of two components, a form and a list. The form behaves exactly like a dbForm. It is single-item and supports the standard single-item interface. When a dbForm-class object has the focus, it will accept data from the keyboard directly into the value of the item. The value can also be directly changed and retrieved with the get and set value messages (get/set value item 0 to val).

The Size of a dbComboForm

The height of the form component is determined by Windows and is 13 dialog units. This cannot be changed. The maximum height of the list is determined by the ListRowCount property and defaults to 10. Therefore the actual height you enter when setting the size property does usually not matter because it will be set by the by the object using ListRowCount. It is normally set to 13 making it easy to convert dbForms into dbCombForms without having to remember to change the size property.

Shadowing

This class supports object shadowing. Objects of this class can either be explicitly shadowed (set enabled_state) or shadowed implicitly when an ancestor object is shadowed. When shadowed, access to the form and the dropdown list is disabled.

Masking

This class does not support masking.

Labels

Forms often require an associated description or label. Most-often, these appear to the left of the form. Labels are supported with the label message. If this object is connected to a data dictionary, you can use field-property values in the DDO by setting the auto_label_state property true. These will override any label values you may have set in this object. The default location and justification mode of labels can be controlled with the properties label_col_offset, label_row_offset, and label_justification_mode.

Validation of Entries

When used with data dictionaries, the combo form is not used for data validation. The data dictionary handles all validation. When used without data dictionaries, a message is provided for validating the value against the combo list. The item-validation function validate_combo_item may be used to report an error if the form value does not match a value in the list. It will respect the allow_blank_state property, which allows a blank entry. This is only required when entry_state is false. When entry_state is true, the value in the form will always match a value from the combo list.

Entry_Item Orderhea.Via {iValidate =get_Validate_Combo_item}
Set entry_State to false
Set Allow_Blank_State to true // empty is OK

Again, note that this type of validation should never be used with data dictionaries. Data dictionaries do this for you (another good reason to use them).

Last Edited: November 21, 2004


Properties for dbComboForm

View property list in alphabetical order

Name | Description
Inherited Properties from dbComboFormDD_
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
Inherited Properties from dbComboFormDS
Allow_Undefined_State | Determines if an undefined value is added to the combo list
Code_Field | The number of the field in the combo_data_file from which values are to be drawn for insertion into the main database file through the Code_field object
Code_File |
Code_Index |
Combo_Data_File | The file number containing the code_field
Combo_Index | The Index used by the combo form
Description_Field | The description field number in the combo_data_file
Type_Field |
Type_Value | Determines the type value of the validation list
Inherited Properties from dbDataComboForm
Code_Display_Mode | Specifies whether the list will display the choices' codes, descriptions, or both
Default_Value | Used by default_prompt procedure to set the default item upon the cursor's first entering this object
Undefined_Display_Mode | Used by find_item to decide what to display when this object is filled from the database with a value that is not found among the values of this object's combo items
Undefined_Save_Mode | Used by entry_update to decide what to save when a save is requested with a value in the window that is not among the prompts of this object
Undefined_Value | Used for display by find_item and for insertion into the database by entry_update when this item's undefined_display_mode or undefined_save_mode respectively is cb_err_update_blank_value
Inherited Properties from dbBasicComboForm
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Error_Message | Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value
Error_Number | The number of the error to be reported whenever validate_combo_item returns a non-zero value
Inherited Properties from dbBasicComboForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from ComboEntry
Allow_Blank_State | Determines if a blank value is valid
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Combo_Item_Count | Returns the number of choices in the combo object's list
Combo_Sort_State | Determines if the object will sort its visual list
Combo_Value | Specifies the value of an item in the combo objects data-list
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
ListRowCount | Determines the number of rows in a combo form
ListWidth | Detrmines the width of a combo's drop down list
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseComboBoxEntry
Combo_Data_Object | Specifies the object ID of the internal l combo object
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbComboForm

View event list in alphabetical order

Name | Description
Inherited Events from dbComboFormDS
Combo_Fill_List | Sent by the construct_object procedure, and must be defined in this object if the object does not draw its data from a database file via combo_data_file, code_field, description_field, etc
Inherited Events from dbDataComboForm
Combo_Description_Value | A "hook" message that by default merely returns prompt
Inherited Events from dbBasicComboForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from ComboEntry
Combo_Edit_Changed | Sets the item_changed_state of this object's item true
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnCloseUp | Called when a drop-down list closes
OnDropDown | Called when a drop-down list opens
OnDropKey |
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbComboForm

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbDataComboForm
Combo_Add_Item | Procedure | Augmented to support two parameters: a display value and a database value
Default_Code | Procedure | Sets current_item to the item having prompt equal to the value of the default_value property
Default_Prompt | Procedure | Sets the default item upon the cursor's first entering this object by sending default_code with parameter of default_value
Inherited Methods from dbBasicComboForm
Close_Panel | Procedure | Closes the panel or component currently open
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbBasicComboForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from ComboEntry
Activate_Area | Procedure |
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Combo_Delete_Data | Procedure | Deletes all this object's items
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Validate_Combo_Value | Function | Determines if a combo form's value is valid
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbComboFormDD_

Class: dbComboFormDD_ (Abstract)

Properties Events Methods Index of Classes

Abstract class providing general-purpose comboform DEOs

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseComboBoxEntry
------------------------------ComboEntry
---------------------------------dbBasicComboForm_
------------------------------------dbBasicComboForm
---------------------------------------dbDataComboForm
------------------------------------------dbComboFormDS
---------------------------------------------dbComboFormDD_
------------------------------------------------dbComboForm

Library: Windows Application Class Library

Package: Dfcentry.pkg

Mixins: Extended_DEO_Mixin Extended_DEO_Status_Help_Mixin

Description

dbComboFormDD_ is used to provide general-purpose comboform DEOs. Its sub-class dbComboForm should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbComboFormDD_

View property list in alphabetical order

Name | Description
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
Inherited Properties from dbComboFormDS
Allow_Undefined_State | Determines if an undefined value is added to the combo list
Code_Field | The number of the field in the combo_data_file from which values are to be drawn for insertion into the main database file through the Code_field object
Code_File |
Code_Index |
Combo_Data_File | The file number containing the code_field
Combo_Index | The Index used by the combo form
Description_Field | The description field number in the combo_data_file
Type_Field |
Type_Value | Determines the type value of the validation list
Inherited Properties from dbDataComboForm
Code_Display_Mode | Specifies whether the list will display the choices' codes, descriptions, or both
Default_Value | Used by default_prompt procedure to set the default item upon the cursor's first entering this object
Undefined_Display_Mode | Used by find_item to decide what to display when this object is filled from the database with a value that is not found among the values of this object's combo items
Undefined_Save_Mode | Used by entry_update to decide what to save when a save is requested with a value in the window that is not among the prompts of this object
Undefined_Value | Used for display by find_item and for insertion into the database by entry_update when this item's undefined_display_mode or undefined_save_mode respectively is cb_err_update_blank_value
Inherited Properties from dbBasicComboForm
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Error_Message | Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value
Error_Number | The number of the error to be reported whenever validate_combo_item returns a non-zero value
Inherited Properties from dbBasicComboForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from ComboEntry
Allow_Blank_State | Determines if a blank value is valid
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Combo_Item_Count | Returns the number of choices in the combo object's list
Combo_Sort_State | Determines if the object will sort its visual list
Combo_Value | Specifies the value of an item in the combo objects data-list
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
ListRowCount | Determines the number of rows in a combo form
ListWidth | Detrmines the width of a combo's drop down list
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseComboBoxEntry
Combo_Data_Object | Specifies the object ID of the internal l combo object
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbComboFormDD_

View event list in alphabetical order

Name | Description
Inherited Events from dbComboFormDS
Combo_Fill_List | Sent by the construct_object procedure, and must be defined in this object if the object does not draw its data from a database file via combo_data_file, code_field, description_field, etc
Inherited Events from dbDataComboForm
Combo_Description_Value | A "hook" message that by default merely returns prompt
Inherited Events from dbBasicComboForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from ComboEntry
Combo_Edit_Changed | Sets the item_changed_state of this object's item true
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnCloseUp | Called when a drop-down list closes
OnDropDown | Called when a drop-down list opens
OnDropKey |
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbComboFormDD_

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbDataComboForm
Combo_Add_Item | Procedure | Augmented to support two parameters: a display value and a database value
Default_Code | Procedure | Sets current_item to the item having prompt equal to the value of the default_value property
Default_Prompt | Procedure | Sets the default item upon the cursor's first entering this object by sending default_code with parameter of default_value
Inherited Methods from dbBasicComboForm
Close_Panel | Procedure | Closes the panel or component currently open
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbBasicComboForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from ComboEntry
Activate_Area | Procedure |
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Combo_Delete_Data | Procedure | Deletes all this object's items
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Validate_Combo_Value | Function | Determines if a combo form's value is valid
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbComboFormDS

Class: dbComboFormDS (Abstract)

Properties Events Methods Index of Classes

Abstract class providing combo objects that automatically use a central codes database file

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseComboBoxEntry
------------------------------ComboEntry
---------------------------------dbBasicComboForm_
------------------------------------dbBasicComboForm
---------------------------------------dbDataComboForm
------------------------------------------dbComboFormDS
---------------------------------------------dbCodeComboForm
---------------------------------------------dbComboFormDD_

Library: Windows Application Class Library

Package: Dfcentry.pkg

Description

dbComboFormDS is used to provide combo objects that automatically use a central codes database file. Its sub-classes dbComboForm and dbCodeComboForm should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbComboFormDS

View property list in alphabetical order

Name | Description
Allow_Undefined_State | Determines if an undefined value is added to the combo list
Code_Field | The number of the field in the combo_data_file from which values are to be drawn for insertion into the main database file through the Code_field object
Code_File |
Code_Index |
Combo_Data_File | The file number containing the code_field
Combo_Index | The Index used by the combo form
Description_Field | The description field number in the combo_data_file
Type_Field |
Type_Value | Determines the type value of the validation list
Inherited Properties from dbDataComboForm
Code_Display_Mode | Specifies whether the list will display the choices' codes, descriptions, or both
Default_Value | Used by default_prompt procedure to set the default item upon the cursor's first entering this object
Undefined_Display_Mode | Used by find_item to decide what to display when this object is filled from the database with a value that is not found among the values of this object's combo items
Undefined_Save_Mode | Used by entry_update to decide what to save when a save is requested with a value in the window that is not among the prompts of this object
Undefined_Value | Used for display by find_item and for insertion into the database by entry_update when this item's undefined_display_mode or undefined_save_mode respectively is cb_err_update_blank_value
Inherited Properties from dbBasicComboForm
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Error_Message | Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value
Error_Number | The number of the error to be reported whenever validate_combo_item returns a non-zero value
Inherited Properties from dbBasicComboForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from ComboEntry
Allow_Blank_State | Determines if a blank value is valid
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Combo_Item_Count | Returns the number of choices in the combo object's list
Combo_Sort_State | Determines if the object will sort its visual list
Combo_Value | Specifies the value of an item in the combo objects data-list
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
ListRowCount | Determines the number of rows in a combo form
ListWidth | Detrmines the width of a combo's drop down list
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseComboBoxEntry
Combo_Data_Object | Specifies the object ID of the internal l combo object
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbComboFormDS

View event list in alphabetical order

Name | Description
Combo_Fill_List | Sent by the construct_object procedure, and must be defined in this object if the object does not draw its data from a database file via combo_data_file, code_field, description_field, etc
Inherited Events from dbDataComboForm
Combo_Description_Value | A "hook" message that by default merely returns prompt
Inherited Events from dbBasicComboForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from ComboEntry
Combo_Edit_Changed | Sets the item_changed_state of this object's item true
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnCloseUp | Called when a drop-down list closes
OnDropDown | Called when a drop-down list opens
OnDropKey |
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbComboFormDS

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbDataComboForm
Combo_Add_Item | Procedure | Augmented to support two parameters: a display value and a database value
Default_Code | Procedure | Sets current_item to the item having prompt equal to the value of the default_value property
Default_Prompt | Procedure | Sets the default item upon the cursor's first entering this object by sending default_code with parameter of default_value
Inherited Methods from dbBasicComboForm
Close_Panel | Procedure | Closes the panel or component currently open
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbBasicComboForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from ComboEntry
Activate_Area | Procedure |
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Combo_Delete_Data | Procedure | Deletes all this object's items
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Validate_Combo_Value | Function | Determines if a combo form's value is valid
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbContainer

Properties Events Methods Index of Classes

Groups together data-entry objects within an invisible container

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------dbContainer3d_
---------------------------dbContainer3d
------------------------------dbContainer

Library: Windows Application Class Library

Package: Dfclient.pkg

Mixins: NonVisual_Container_Mixin

Description

The dbContainer class is used to group together data-entry objects within an invisible container.

Sample

Object Dlg is a dbContainer
    Set Server to (Customer_DD(self))

    Object F1 is a dbform
        Set Location to 10 70
        Set Size to 13 40
        Entry_Item Customer.Name
        Set Label to "Name:"
    End_Object

    Object F2 is a dbform
        Set Location to 25 70
        Set Size to 13 30
        Entry_Item Customer.Id
        Set Label to "Id:"
    End_Object

End_Object

Syntax

Use windows

Object object_name is a dbContainer
    Set enabled_state to true|false
    :
    : DEO objects
    :
End_Object

Of Special Note

This class is descended from the dbContainer3D class and inherits all of its non-visual attributes. Its abilities to group objects and manipulate them as a single unit are most-important. This class is used when you need to group objects together non-visually. This object must be placed inside a visual container. Child objects will be located relative to this visual ancestor.

This class will rarely be needed. You are encouraged to use visual DEO container objects (dbContainer3d, dbGroup, or dbTabDialog) whenever possible.

Last Edited: July 25, 2003


Properties for dbContainer

View property list in alphabetical order

Name | Description
Inherited Properties from dbContainer3d_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbContainer

View event list in alphabetical order

Name | Description
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbContainer

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbContainer3d
Close_Panel | Procedure | Closes the panel or component currently open
Inherited Methods from dbContainer3d_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbContainer3d

Properties Events Methods Index of Classes

Creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional appearance

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------dbContainer3d_
---------------------------dbContainer3d
------------------------------dbContainer
------------------------------dbTabPage
------------------------------dbTabView_

Library: Windows Application Class Library

Package: Dfclient.pkg

Mixins: DFNavigate_Mixin

Description

The dbContainer3d class creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional (3-D) appearance. This is to be used with other DEOs within a data-aware view. It must be placed inside a db... container (dbView, dbContainer, etc). Objects based on this class will contain DEO controls (dbForm, dbEdit, etc), basic controls (button, etc.) and other data-aware (db...) container objects (which will themselves contain controls).

Sample

Object Dlg is a dbContainer3D
    Set Size to 70 150
    Set Location to 5 5
    Set Server to Customer_DD

    Object F1 is a dbform
        Set Location to 10 70
        Set Size to 13 40
        Entry_Item Customer.Name
        Set Label to "Name:"
    End_Object

    Object Dlg1 is a dbContainer3D
        Set Size to 30 130
        Set Location to 25 10
        Set Border_Style to Border_StaticEdge // lowered edge

        Object F2 is a dbform
            Set Location to 10 70
            Set Size to 13 30
            Entry_Item Customer.Id
            Set Label to "Id:"
        End_Object

    End_Object

End_Object

Syntax

Use DFClient
:
Object oObjectName is a dbContainer3D
    Set Size to height width
    Set Location to row column
    Set Border_Style to BorderMode

    Set Enabled_State to True | False

    Set Server to (DDO(self))
    Set Verify_Save_msg to get_SaveMessage
    Set Verify_Delete_msg to get_DeleteMessage
    Set Verify_Data_loss_msg to get_DataLossMessage
    Set Verify_Exit_msg to get_ExitMessage
    :
    : DEO objects
    :
End_Object

Of Special Note

A dbContainer3D is a visual container for data-entry objects. Many of the properties and messages of this class are provided (and controlled) solely for use with child objects. In these respects, using a container object provides a convenience for the programmer, and greater interface consistency for users.

DbContainer3D and dbGroup objects are used to group objects together. They are functionally identical and differ only in appearance.

You will use dbContainer3D objects primarily for navigation and display purposes. All DEOs inside a dbContainer3D are activated (and therefore displayed) as a unit. When users navigate from one dbContainer3D to another (within the same view) all the objects within the container will be brought forward on the screen as a unit.

Container Object for DEOs

The dbContainerForm is a data-entry container object (DEO container). A DEO container is an object whose native capabilities are augmented with data-aware behaviors. These behaviors include:

  • The finding, clearing, saving and deleting of records (and sets of records)
  • Change verification (save, delete, and data-loss verifications)
  • Server support : DEOs connect to data-dictionary or data-set object structures

These data-aware "skills" are added to all DEO classes through a series of mix-in classes. The message are listed here but documented in the mix-in classes. You are encouraged to study the documentation of the mix-in classes. Information provided in the documentation of these classes may be applied to all DEO classes (all db... classes). Those classes are: Nesting_Mixin, Navigate_Mixin, Verify_Mixin, Server_Mixin, and DEO_Delegate_Mixin.

DEO Nesting Rules

When creating data-aware views and db... objects, you must observe the following object-placement rules:

  • All DEO containers (dbContainer3d, dbContainer, dbGroup, dbTabDialog, etc.) must always be placed directly within a DEO container. These will all be contained within a dbView or a dbModalPanel.
  • All DEO controls (dbForm, dbComboForm, dbGrid, etc.) must always be placed directly within a DEO object, usually a container.
  • Non DEO controls and containers may be placed inside of DEO containers. It is common to add buttons to a view or a container. If a non-db container (Container3d, Group, etc.) is placed inside of a DEO container the non-DEO container may only contain non-DEO child objects (form, radio, Container3d, etc.)
  • It is almost always an error to place a db...object inside a non- db... parent.

The Server

All dbContainer3d objects should be connected to a server (a data-dictionary object). The server can be explicit (directly set with the Server message) or acquired from a parent DEO container. Often the dbView object will provide the server. All child objects will also use the server unless a child object explicitly sets a different server for itself. Do not explicitly set a server if you do not have to. If the acquired server from the parent is correct, use it.

You can set custom verification messages to supply save, delete, data-loss and exit confirmations. Normally, these verifications are defined within the view object (dbView) and acquired by all children. If new messages are required, they often occur within the same object that sets a new server.

The dbContainer class supports the messages request_save, request_clear, request_clear_all, and request_delete. Normally these messages are sent from a DEO entry object and will delegate down through DEO structure until they encounter the object that explicitly sets the server (often a DEO container). This makes it possible to define request-message behaviors at the container level so that child DEOs can make use of them by delegation.

Using Data Dictionaries

When this object's server is a dataDictionary (instead of a dataSet), this object will acquire a great deal of "knowledge" from the server. Although the container itself will not need to use this knowledge, it will be used by all the DEOs that acquire the server.

Accelerator Keys

Name | Message Sent | Defining Class
kbegin_of_panel | beginning_of_panel | navigate_mixin
kcancel | request_cancel | navigate_mixin
kend_of_panel | end_of_panel | navigate_mixin
kexit_function | exit_function | navigate_mixin
kswitch | switch | navigate_mixin
kswitch_back | switch_back | navigate_mixin
kswitch_panel | switch_next_group | navigate_mixin
kswitch_panel_back | switch_prior_group | navigate_mixin

Last Edited: November 21, 2004


Properties for dbContainer3d

View property list in alphabetical order

Name | Description
Inherited Properties from dbContainer3d_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbContainer3d

View event list in alphabetical order

Name | Description
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbContainer3d

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure | Closes the panel or component currently open
Inherited Methods from dbContainer3d_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbContainer3d_

Class: dbContainer3d_ (Abstract)

Properties Events Methods Index of Classes

Abstract class creating visual container objects and by default, providing a gray background with a raised border having a three-dimensional appearance

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------dbContainer3d_
---------------------------dbContainer3d

Library: Windows Application Class Library

Package: Dfclient.pkg

Mixins: Entry_Client_mixin NESTING_Mixin NAVIGATE_Mixin SERVER_Mixin VERIFY_Mixin ACTION_BAR_Mixin Auto_Locate_Mixin Non_Dependent_Item_Mixin Deo_Delegate_Mixin

Description

The dbContainer3d_ class creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional (3-D) appearance. Its sub-classes dbContainer3d, dbContainer, dbTabPage and dbTabView should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbContainer3d_

View property list in alphabetical order

Name | Description
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbContainer3d_

View event list in alphabetical order

Name | Description
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbContainer3d_

View method list in alphabetical order

Name | Type | Description
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbDataComboForm

Class: dbDataComboForm (Abstract)

Properties Events Methods Index of Classes

Extends the functionality of the dbBasicComboForm to support the separation of description and database values

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseComboBoxEntry
------------------------------ComboEntry
---------------------------------dbBasicComboForm_
------------------------------------dbBasicComboForm
---------------------------------------dbDataComboForm
------------------------------------------dbComboFormDS

Library: Windows Application Class Library

Package: Dfdtcent.pkg

Description

dbDataComboForm is used to extend the functionality of the dbBasicComboForm to support the separation of description and database values. This class is intermediate. Its subclass, dbComboForm, should be used for instantiation.

Note:
A dbDataComboForm object is associated with a single data element which is assigned with the entry_item command. Each value in the dropdown lists a valid value for the entry item. The current value is displayed in the form. This class supports the separation of display value and database value. Each valid choice is defined with a data value (the value that is read and written to the database) and a description (the text value that is displayed in the form and the list). This separation is optional (the data value and description value may be the same).

Combo_Add_item

Just like its superclass, the combo list is filled by calling the Combo_fill_list procedure (which is called automatically). Each item is added to the list with the combo_add_item message. Unlike its superclass, the combo_add_item in this class accepts two parameters: a description value and a data value.

    procedure combo_fill_list
        send combo_add_Item "FEDEX" "F" // description and code
        send combo_add_Item "UPS"   "U"
        send combo_add_Item "COD"   "C"
    End_procedure

Note:
When the dbComboForm is used in conjunction with a data dictionary, the list is filled automatically by the data dictionary.

Display Value and Database Value

The property code_display_mode determines what is displayed. Valid modes are CB_Code_display_description (the default-displays the description), CB_Code_display_code (displays the code) and CB_Code_display_both (displays the code followed by the description).

Last Edited: November 21, 2004


Properties for dbDataComboForm

View property list in alphabetical order

Name | Description
Code_Display_Mode | Specifies whether the list will display the choices' codes, descriptions, or both
Default_Value | Used by default_prompt procedure to set the default item upon the cursor's first entering this object
Undefined_Display_Mode | Used by find_item to decide what to display when this object is filled from the database with a value that is not found among the values of this object's combo items
Undefined_Save_Mode | Used by entry_update to decide what to save when a save is requested with a value in the window that is not among the prompts of this object
Undefined_Value | Used for display by find_item and for insertion into the database by entry_update when this item's undefined_display_mode or undefined_save_mode respectively is cb_err_update_blank_value
Inherited Properties from dbBasicComboForm
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Error_Message | Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value
Error_Number | The number of the error to be reported whenever validate_combo_item returns a non-zero value
Inherited Properties from dbBasicComboForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from ComboEntry
Allow_Blank_State | Determines if a blank value is valid
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Combo_Item_Count | Returns the number of choices in the combo object's list
Combo_Sort_State | Determines if the object will sort its visual list
Combo_Value | Specifies the value of an item in the combo objects data-list
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
ListRowCount | Determines the number of rows in a combo form
ListWidth | Detrmines the width of a combo's drop down list
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseComboBoxEntry
Combo_Data_Object | Specifies the object ID of the internal l combo object
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbDataComboForm

View event list in alphabetical order

Name | Description
Combo_Description_Value | A "hook" message that by default merely returns prompt
Inherited Events from dbBasicComboForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from ComboEntry
Combo_Edit_Changed | Sets the item_changed_state of this object's item true
Combo_Fill_List | Called when the combo list is to be filled
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnCloseUp | Called when a drop-down list closes
OnDropDown | Called when a drop-down list opens
OnDropKey |
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbDataComboForm

View method list in alphabetical order

Name | Type | Description
Combo_Add_Item | Procedure | Augmented to support two parameters: a display value and a database value
Default_Code | Procedure | Sets current_item to the item having prompt equal to the value of the default_value property
Default_Prompt | Procedure | Sets the default item upon the cursor's first entering this object by sending default_code with parameter of default_value
Inherited Methods from dbBasicComboForm
Close_Panel | Procedure | Closes the panel or component currently open
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbBasicComboForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from ComboEntry
Activate_Area | Procedure |
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Combo_Delete_Data | Procedure | Deletes all this object's items
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Validate_Combo_Value | Function | Determines if a combo form's value is valid
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbEdit

Properties Events Methods Index of Classes

(Obsolete) Supports data entry for memo fields or sequential ASCII files from DEOs

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseEdit
---------------------Edit
------------------------dbEdit_
---------------------------dbEditDS
------------------------------dbEdit

Library: Windows Application Class Library

Package: Dftxtwin.pkg

Mixins: Extended_DEO_Status_Help_Mixin

Description

Obsolete

This class is obsolete. It has been replaced with the cDbTextEdit class.

dbEdit is used to support data entry for memo fields or sequential ASCII files from DEOs.

Sample

Object Customer_Comments is a dbEdit
    Entry_item Customer.Comments
    Set Location TO 147 5
    Set Size     TO 48 305
    Set Label to "Comments:"
End_Object

Syntax

use dftxtwin

Object oObecjtName is a dbEdit
    Set Size to height width
    Set Location to Row Column
    entry_item file.field

    Set Label to text
    Set Label_Justification_Mode to mode
    Set Label_Row_Offset to Num
    Set Label_Col_Offset to Num

    set Wrap_State to true|false
    set Enabled_State to true|false
    set Read_Only_State to true|false

    Procedure onChange
        :
    End_Procedure

    Procedure onSetFocus
        :
    End_Procedure

    Procedure onKillFocus
        :
    End_Procedure

end_object

Of Special Note

Although dbEdits are complex objects containing many messages, their actual usage is quite simple. When this class is used in conjunction with data dictionaries, very few properties need to be set within this object. Usually a dbEdit object will contain a label, a size and location setting, and an entry_item statement.

DbEdits should always be placed inside a dbView object or a data-aware container (dbContainer3d, dbGroup, dbTabPage, dbTabView). The DataDictionary used by the edit should be above the object and inside the entry-view container.

Data-Entry Object

The dbEdit is a data-entry object (DEO). A DEO object is an object, whose native capbilties (in this case a edit) is augmented to support data-aware behaviors. These behaviors include:

  • The finding, clearing, saving and deleting of records (and sets of records)
  • Prompt and zoom object support
  • Change verification (save, delete, and data-loss verifications)
  • Object and item entering, exiting and validation
  • Server support: DEOs connect to data-server structures

These data-aware "skills" are added to all DEO classes through a series of mix-in classes. The message are listed here but documented in the mix-in classes. You are encouraged to study the documentation of the mix-in classes. Information provided in the documentation of these classes may be applied to all DEO classes (all db... classes). Those classes are: Nesting_Mixin, Navigate_Mixin, Verify_Mixin, Server_Mixin, Find_Edit_Mixin, and DEO_Delegate_Mixin.

Using Data Dictionaries

When this object's server is a data dictionary, this object will acquire a great deal of "knowledge" from the server. It will "know" data types, status help, and much more regarding the data file and its fields. If you use data sets, these settings will all require setting properties. While possible, this requires a great deal more work and greatly increases the chances of errors and inconsistencies.

Labels

Edits often require an associated description or label. With edits, they most often appear above the edit object in the left corner. Labels are supported with the label message. The default location and justification mode of labels can be controlled with the properties label_col_offset, label_row_offset and label_justification_mode. If you set auto_locate_state true, label values will be drawn from field properties in the DDO, overriding the label value, if any.

The Server

All dbEdit objects should always be connected to a server (a data-dictionary object). While the server can be explicitly set within the object, it will usually be set within a parent (or other ancestor) container object.

Maximum Length of a dbEdit

When a dbEdit object is created, the maximum number of characters will be set automatically by checking the allowed length of the file.field attached to this object in the entry_item statement.

Accelerator Keys

dbEdit defines the kprompt and kzoom keys to send the prompt and zoom message. These procedures, however, have no action by default. If prompting/zooming is desired on a text_window, the action must be defined (by the program) by overriding the prompt and/or zoom messages.

Name | Message Sent | Defining Class
kbegin_of_data | beginning_of_data | find_edit_mixin
kbegin_of_panel | beginning_of_panel | navigate_mixin
kcancel | request_cancel | navigate_mixin
kclear | request_clear | find_edit_mixin
kclear_all | request_clear_all | find_edit_mixin
kdelete_record | request_delete | find_edit_mixin
kend_of_data | end_of_data | find_edit_mixin
kend_of_panel | end_of_panel | navigate_mixin
kexit_function | exit_function | navigate_mixin
kfind | find_ge | find_edit_mixin
kfind_next | find_next | find_edit_mixin
kfind_previous | find_previous | find_edit_mixin
ksave_record | request_save | find_edit_mixin
ksuper_find | superfind | find_edit_mixin
ksuper_find_next | superfind_next | find_edit_mixin
ksuper_find_previous | superfind_previous | find_edit_mixin
kswitch | switch | navigate_mixin
kswitch_back | switch_back | navigate_mixin
kswitch_panel | switch_next_group | navigate_mixin
kswitch_panel_back | switch_prior_group | navigate_mixin

Last Edited: November 20, 2004


Properties for dbEdit

View property list in alphabetical order

Name | Description
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
Inherited Properties from dbEdit_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Data_Field | The field number of the target text field
Data_File | The file number of target memo field
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Item_Count | Created for simulation of entry item
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Edit
Capslock_State | Determines if all text displayed will be in upper-case letters
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Value | Determines the value of an item/paragraph
Wrap_State | Governs whether strings of text input will break and wrap to the next line at the end of this object, or will continue onward on the same line until a carriage return/linefeed is input
Inherited Properties from DfBaseEdit
Edit_Buffer_Count | The number of characters currently in the object
File_Name | Used whenever a read or write message is sent to the Edit object and a file_name parameter is not specified
Line_Count | Returns number of "lines" in Edit object
Position | Returns the location of the cursor in the object
Read_Only_State | Allows you to protect the contents of the buffer while still allowing users freedom to navigate
Text_Limit | The number of characters that can be entered into the edit
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbEdit

View event list in alphabetical order

Name | Description
Inherited Events from dbEdit_
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from Edit
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent every time the edit buffer is changed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText | Sent when the edit buffer is full and an attempt has been made to add additional data to the buffer
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbEdit

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbEditDS
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbEdit_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Prompt | Procedure | Cancelled in this class
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Returns 0 by default, to indicate that entered text is valid
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Cancelled in this class
Inherited Methods from Edit
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEdit
Append_Text | Procedure | Inserts data to the end of the existing contents of the object
Beginning_of_Data | Procedure | Moves the cursor to the beginning of the data in the object
Beginning_of_Line | Procedure | Moves then cursor to the beginning of the current line
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Delete_Char | Procedure | Deletes the character under the cursor
Delete_Data | Procedure | Destroys all of the data in the object and returns the edit cursor to the top of the buffer
Delete_Line | Procedure | Deletes the current line
Down | Procedure | Moves the cursor down one line
End_of_Data | Procedure | Moves the cursor to the end of the data
End_of_Line | Procedure | Moves the cursor to the end of the current line
Find | Procedure | Searches the text in an edit window
Insert | Procedure | Inserts a string of text into the edit buffer at the current cursor location
Left | Procedure | Moves the cursor one space to the left
Page_Down | Procedure | Moves the edit cursor down one page
Page_Up | Procedure | Moves the edit cursor up one page
Paste | Procedure | Copies the contents of the Clipboard into this object at the current cursor position
Read | Procedure | Imports information from an external source to the Edit object's buffer
Read_Dbms | Procedure | Reads information from a database file
Replace | Procedure | Finds and Replaces Text in an edit object
Reset_Find | Procedure | Causes the next find to search from the start of the text
Reset_Replace | Procedure | Causes the next replace to search from the start of the text.
Right | Procedure | Moves the cursor one space to the right
Select | Procedure | Marks the text in the editor beginning at position iPosition for the number of bytes set in charcount
Undo | Procedure | Will undo the last change in the edit
Up | Procedure | Moves the edit cursor up one line
Write | Procedure | Writes the contents of the edit buffer to the specified file
Write_Dbms | Procedure | Writes information from the edit buffer to a database field
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbEdit_

Class: dbEdit_ (Abstract)

Properties Events Methods Index of Classes

(Obsolete) Abstract class that supports data entry for memo fields or sequential ASCII files from DEOs

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseEdit
---------------------Edit
------------------------dbEdit_
---------------------------dbEditDS

Library: Windows Application Class Library

Package: Dftxtwin.pkg

Mixins: Text_Window_mixin Nesting_Mixin Navigate_Mixin Verify_Mixin Server_Mixin Action_Bar_Mixin Find_Edit_Mixin Non_Dependent_Item_Mixin DEO_Delegate_Mixin

Description

Obsolete

This class is obsolete. It has been replaced with the cDbTextEdit_ class.

dbEdit_ is used to support data entry for memo fields or sequential ASCII files from DEOs. Its sub-class dbEdit should be used for sub-classing and instantiation.

Last Edited: November 22, 2004


Properties for dbEdit_

View property list in alphabetical order

Name | Description
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Data_Field | The field number of the target text field
Data_File | The file number of target memo field
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Item_Count | Created for simulation of entry item
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Edit
Capslock_State | Determines if all text displayed will be in upper-case letters
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Value | Determines the value of an item/paragraph
Wrap_State | Governs whether strings of text input will break and wrap to the next line at the end of this object, or will continue onward on the same line until a carriage return/linefeed is input
Inherited Properties from DfBaseEdit
Edit_Buffer_Count | The number of characters currently in the object
File_Name | Used whenever a read or write message is sent to the Edit object and a file_name parameter is not specified
Line_Count | Returns number of "lines" in Edit object
Position | Returns the location of the cursor in the object
Read_Only_State | Allows you to protect the contents of the buffer while still allowing users freedom to navigate
Text_Limit | The number of characters that can be entered into the edit
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbEdit_

View event list in alphabetical order

Name | Description
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from Edit
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent every time the edit buffer is changed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText | Sent when the edit buffer is full and an attempt has been made to add additional data to the buffer
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbEdit_

View method list in alphabetical order

Name | Type | Description
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Prompt | Procedure | Cancelled in this class
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Returns 0 by default, to indicate that entered text is valid
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Cancelled in this class
Inherited Methods from Edit
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEdit
Append_Text | Procedure | Inserts data to the end of the existing contents of the object
Beginning_of_Data | Procedure | Moves the cursor to the beginning of the data in the object
Beginning_of_Line | Procedure | Moves then cursor to the beginning of the current line
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Delete_Char | Procedure | Deletes the character under the cursor
Delete_Data | Procedure | Destroys all of the data in the object and returns the edit cursor to the top of the buffer
Delete_Line | Procedure | Deletes the current line
Down | Procedure | Moves the cursor down one line
End_of_Data | Procedure | Moves the cursor to the end of the data
End_of_Line | Procedure | Moves the cursor to the end of the current line
Find | Procedure | Searches the text in an edit window
Insert | Procedure | Inserts a string of text into the edit buffer at the current cursor location
Left | Procedure | Moves the cursor one space to the left
Page_Down | Procedure | Moves the edit cursor down one page
Page_Up | Procedure | Moves the edit cursor up one page
Paste | Procedure | Copies the contents of the Clipboard into this object at the current cursor position
Read | Procedure | Imports information from an external source to the Edit object's buffer
Read_Dbms | Procedure | Reads information from a database file
Replace | Procedure | Finds and Replaces Text in an edit object
Reset_Find | Procedure | Causes the next find to search from the start of the text
Reset_Replace | Procedure | Causes the next replace to search from the start of the text.
Right | Procedure | Moves the cursor one space to the right
Select | Procedure | Marks the text in the editor beginning at position iPosition for the number of bytes set in charcount
Undo | Procedure | Will undo the last change in the edit
Up | Procedure | Moves the edit cursor up one line
Write | Procedure | Writes the contents of the edit buffer to the specified file
Write_Dbms | Procedure | Writes information from the edit buffer to a database field
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbEditDS

Class: dbEditDS (Abstract)

Properties Events Methods Index of Classes

(Obsolete) Abstract class that supports data entry for memo fields or sequential ASCII files from DEOs

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseEdit
---------------------Edit
------------------------dbEdit_
---------------------------dbEditDS
------------------------------dbEdit

Library: Windows Application Class Library

Package: Dftxtwin.pkg

Mixins: DFNavigate_Mixin DFCode_DEO_Mixin DataFile_Help_Mixin

Description

Obsolete

This class is obsolete. It has been replaced with the cDbTextEditDS_ class.

dbEditDS is used to support data entry for memo fields or sequential ASCII files from DEOs. Its sub-class dbEdit should be used for sub-classing and instantiation.

Last Edited: November 22, 2004


Properties for dbEditDS

View property list in alphabetical order

Name | Description
Inherited Properties from dbEdit_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Data_Field | The field number of the target text field
Data_File | The file number of target memo field
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Item_Count | Created for simulation of entry item
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Edit
Capslock_State | Determines if all text displayed will be in upper-case letters
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Value | Determines the value of an item/paragraph
Wrap_State | Governs whether strings of text input will break and wrap to the next line at the end of this object, or will continue onward on the same line until a carriage return/linefeed is input
Inherited Properties from DfBaseEdit
Edit_Buffer_Count | The number of characters currently in the object
File_Name | Used whenever a read or write message is sent to the Edit object and a file_name parameter is not specified
Line_Count | Returns number of "lines" in Edit object
Position | Returns the location of the cursor in the object
Read_Only_State | Allows you to protect the contents of the buffer while still allowing users freedom to navigate
Text_Limit | The number of characters that can be entered into the edit
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbEditDS

View event list in alphabetical order

Name | Description
Inherited Events from dbEdit_
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from Edit
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent every time the edit buffer is changed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText | Sent when the edit buffer is full and an attempt has been made to add additional data to the buffer
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbEditDS

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbEdit_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Prompt | Procedure | Cancelled in this class
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Returns 0 by default, to indicate that entered text is valid
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Cancelled in this class
Inherited Methods from Edit
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEdit
Append_Text | Procedure | Inserts data to the end of the existing contents of the object
Beginning_of_Data | Procedure | Moves the cursor to the beginning of the data in the object
Beginning_of_Line | Procedure | Moves then cursor to the beginning of the current line
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Delete_Char | Procedure | Deletes the character under the cursor
Delete_Data | Procedure | Destroys all of the data in the object and returns the edit cursor to the top of the buffer
Delete_Line | Procedure | Deletes the current line
Down | Procedure | Moves the cursor down one line
End_of_Data | Procedure | Moves the cursor to the end of the data
End_of_Line | Procedure | Moves the cursor to the end of the current line
Find | Procedure | Searches the text in an edit window
Insert | Procedure | Inserts a string of text into the edit buffer at the current cursor location
Left | Procedure | Moves the cursor one space to the left
Page_Down | Procedure | Moves the edit cursor down one page
Page_Up | Procedure | Moves the edit cursor up one page
Paste | Procedure | Copies the contents of the Clipboard into this object at the current cursor position
Read | Procedure | Imports information from an external source to the Edit object's buffer
Read_Dbms | Procedure | Reads information from a database file
Replace | Procedure | Finds and Replaces Text in an edit object
Reset_Find | Procedure | Causes the next find to search from the start of the text
Reset_Replace | Procedure | Causes the next replace to search from the start of the text.
Right | Procedure | Moves the cursor one space to the right
Select | Procedure | Marks the text in the editor beginning at position iPosition for the number of bytes set in charcount
Undo | Procedure | Will undo the last change in the edit
Up | Procedure | Moves the edit cursor up one line
Write | Procedure | Writes the contents of the edit buffer to the specified file
Write_Dbms | Procedure | Writes information from the edit buffer to a database field
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbFloatingPanel

Class: dbFloatingPanel (Abstract)

Properties Events Methods Index of Classes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------dbFloatingPanel_
---------------------------------dbFloatingPanel
------------------------------------dbViewFloatingPanel

Library: Windows Application Class Library

Package: Dfclient.pkg

Mixins: DFNavigate_Mixin

Description

Last Edited: December 2, 2005


Properties for dbFloatingPanel

View property list in alphabetical order

Name | Description
DEO_Object |
Inherited Properties from dbFloatingPanel_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbFloatingPanel

View event list in alphabetical order

Name | Description
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbFloatingPanel

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure | Closes the panel or component currently open
Inherited Methods from dbFloatingPanel_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbFloatingPanel_

Class: dbFloatingPanel_ (Abstract)

Properties Events Methods Index of Classes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------dbFloatingPanel_
---------------------------------dbFloatingPanel

Library: Windows Application Class Library

Package: Dfclient.pkg

Mixins: Entry_Client_mixin NESTING_Mixin NAVIGATE_Mixin SERVER_Mixin VERIFY_Mixin ACTION_BAR_Mixin Auto_Locate_Mixin Non_Dependent_Item_Mixin Deo_Delegate_Mixin

Description

Last Edited: December 2, 2005


Properties for dbFloatingPanel_

View property list in alphabetical order

Name | Description
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbFloatingPanel_

View event list in alphabetical order

Name | Description
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbFloatingPanel_

View method list in alphabetical order

Name | Type | Description
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Close_Panel | Procedure |
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbFloatingPopupMenu

Properties Events Methods Index of Classes

Creates standard data-aware (DEO) floating popup menus

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseActionBar
------------------------DfBasePullDown
---------------------------DfBaseEditPullDown
------------------------------FormFloatingPopupMenu
---------------------------------dbFloatingPopupMenu

Library: Windows Application Class Library

Package: Dfdeoft.pkg

Description

dbFloatingPopupMenu is used to create standard data-aware (DEO) floating popup menus. This is used to create a "right-mouse context menu" for db... form objects (dbForm, dbGrid, etc.). This creates a menu of items for standard form-edit operations (undo, cut, copy, paste, delete and select all) and standard database operations (prompt, find next, find previous, clear, clear all, delete, and save). In addition, each item is shadowed or not shadowed to indicate the availability of the option. An object is automatically created based on this class and all DEO form controls use this object.

Sample

The object dbFloatingMenu is created and is assigned to all db... forms.

Of Special Note

Automatic Floating Popup Menu
By default, an object named dbFormFloatingMenu is created based on this class. DEO form-class objects (dbForm, dbGrid, etc.) use this object for floating context menu support. When the right mouse button is pressed in a DEO form, the form object is given the focus, and, if this focus change is successful, the popup message is sent to the dbFormFloatingMenu object. This causes the context menu to appear relative to the location of the mouse pointer. This provides support for the standard editing and database operations. All of this is provided automatically. No program changes are required to support this. In addition to this automatic support, a programmer interface is provided to customize these behaviors.

Assigning a floating menu to a DEO form

When a program is run, an object named dbFormFloatingMenu is created based on this class. In addition, a global integer, default_dbFloating_Menu_id, is created which contains the object ID of dbFormFloatingMenu. The form DEO property floating_menu_object is set to this value by default. This is the method used to assign a DEO to a floating context menu. If you wish to assign a different floating menu to a form, you may either set the DEO's floating_menu_object property or you may change the value of Global Integer default_dbFloating_menu_Id. You would do the later if you wished to change the assignment of floating menus within all DEO forms.

Refer to the code in the package. It demonstrates how to create custom floating popup menus.

Last Edited: August 13, 2003


Properties for dbFloatingPopupMenu

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbFloatingPopupMenu

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseActionBar
Initialize_Menu | Sent when the Menubar system is about to be selected
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbFloatingPopupMenu

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseActionBar
Exit_Menu | Procedure |
Redirect_Message | Procedure |
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbForm

Properties Events Methods Index of Classes

To support data entry through an entry_item to one field of one logical record at a time

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------Entry
------------------------------dbForm_
---------------------------------dbFormDS
------------------------------------dbForm
---------------------------------------dbFormExternalControl

Library: Windows Application Class Library

Package: Dfentry.pkg

Mixins: Extended_DEO_Mixin Extended_DEO_Status_Help_Mixin Extended_DEO_Prompt_Mixin

Description

The dbForm class is used to support data entry through an entry_item to one field of one logical record at a time.

Sample

Use dfEntry.pkg

Object MyForm is a DbForm
    Set Size to 13 100
    Set Location to 15 70

    Entry_Item Customer.Address

    Set Label to "Address"
End_Object

Object MyExpression is a DbForm
    Set Size to 13 100
    Set Location to 15 70

    Entry_Item (Customer.Balance / 12)

    Set Label to "Average"
    Set Currency_Mask to 8 2
End_Object

Syntax

Use dfEntry.pkg

// when data field is connected to a DataDictionary object
Object oObjectName is a dbForm
    Set Size to height width
    Set Location to Row Column

    Entry_Item Table.Field

    Set Auto_Label_State to true | false
    Set Label to text
    Set Label_Justification_Mode to mode
    Set Label_Row_Offset to Num
    Set Label_Col_Offset to Num
    Set Enabled_State to true | false

    Procedure onChange
        :
    End_Procedure

    Procedure onSetFocus
        :
    End_Procedure

    Procedure onKillFocus
        :
    End_Procedure

End_Object

// when connected to data-dictionary objects or using a variable or expression:
Object oObjectName is a dbForm
    Set Size to height width
    Set Location to row column

    Entry_Item {Table.Field | variable | expression}

    Set Label to text
    Set Label_Justification_Mode to mode
    Set Label_Row_Offset to integer
    Set Label_Col_Offset to integer

    Set Form_DataType to mode
    Set Form_Margin to mode
    Set Form_Mask to mask-string
    Set Numeric_Mask to leftDigits rightDigits {template}
    Set Currency_Mask to leftDigits rightDigits {template}

    Set Enabled_State to true|false
    Set Status_Help to text

    Procedure onChange
        :
    End_Procedure

    Procedure onSetFocus
        :
    End_Procedure

    Procedure onKillFocus
        :
    End_Procedure

End_Object

Of Special Note

Although this object is is complex and contains many messages, its actual usage is quite simple. When this class is used in conjunction with data dictionaries, very few properties need to be set within this object. Usually a dbForm object will contain a label, a size, and location setting, and an entry_item statement.

DbForms should always be placed inside a dbView object or a data-aware container (dbContainer3d, dbGroup, dbTabPage, dbTabView). The DataDictionary used by the entry form should be above the entry form in the source code and inside the entry-view container.

DbForms can be used for entry to fields of all types except Text and Binary.

Data-Entry Object

This object is a data-entry object (DEO). A DEO is an object (in this case a form) whose native capabilities are augmented with data-aware behaviors. These behaviors include:

  • The finding, clearing, saving, and deleting of records (and sets of records)
  • Prompt- and zoom-object support
  • Change verification (save, delete, and data-loss verifications)
  • Object and item entering, exiting, and validation
  • Server support: DEOs connect to data-server structures

These data-aware "skills" are added to all DEO classes through a series of mix-in classes. The messages are listed here but documented in the mix-in classes. You are encouraged to study the documentation of the mix-in classes. Information provided in the documentation of these classes may be applied to all DEO classes (all db... classes). Those classes are: Nesting_Mixin, Navigate_Mixin, Verify_Mixin, Server_Mixin, Find_Edit_Mixin, Entry_Item_Mixin, DEO_Delegate_Mixin, Validate_Mixin and Clear_Defaults_Mixin.

Masking

This class supports input and display masking for a variety of data types (text, numeric, currency, and dates). When using data dictionaries, the mask and mask type of an object will usually be defined within the data file's data-dictionary subclass. The only time you will need to deal with masks is when you are creating masks for non-data-dictionary-based objects (expressions and variables).

When manually setting masks, the type of masking used is determined by the object's form_datatype (which supports both masked and non-masked types) and the object's form_mask. Two additional messages, set currency_mask and set numeric_mask make it particularly easy to define currency and numeric data types and fields with a single message.

Setting Entry Parameters for Columns

Previous revisions of DataFlex allowed you to set column parameters by placing special parameters on the entry_item command line. These options would be placed inside French braces (entry_item file.field {capslock, iPrompt =(myObj(Self)), iEntry =msg_MyMessage} ). Data dictionaries all but obviate the need for these settings. Normally these settings can and should be placed inside your data-dictionary subclasses. In addition, the Studio does not support the use of these command-line options.

In the rare case where you need to set any of these options for columns within your data-entry object, a complete interface is provided for getting and setting any of them. The single-item data-entry classes (such as this class) use one set of messages for setting these parameters, while the row-based data-entry classes provide a parallel set of messages for setting these parameters on a column-by-column basis. These messages are documented in the datalist class. Below is a summary of all these messages. This list shows the single-item-based message, its equivalent row-based message, and the entry_item option it replaces. Each of these messages supports a get and a set syntax.

Form-Based Messages dbForm, dbComboForm | Grid Column-Based Messages dbGrid, dbList | Old Entry_Item {option} (no longer used)
Item_Options | Column_Options | Required, FindReq, NoEnter, NoPut, DisplayOnly, AutoFind, etc.
Item_Option | Column_Option | (same as above)
Enabled_State (formerly object_shadow_state) | Column_Shadow_State | DisplayOnly
Capslock_State | Column_Capslock_State | Capslock
Prompt_Object | Column_Prompt_Object | iPrompt=
Zoom_Object | Column_Zoom_Object | iZoom=
Item_Entry_msg | Column_Entry_msg | iEntry=
Item_Exit_msg | Column_Exit_msg | iExit=
Item_Validate_msg | Column_Validate_msg | iValidate=

Prompt Buttons

This class automatically supports prompt buttons. If a prompt object is defined for this object, a prompt button will appear automatically in it. When the button is pressed, the prompt message will be sent and a prompt object (usually a selection list) will appear. Prompt objects are usually acquired from the data-dictionary object, but may be explicitly defined by setting the prompt_object property.

If you do not want automatic prompt-button creation, this feature may be disabled by setting the property prompt_button_mode to PB_PromptOff. A prompt button may be explicitly created by setting the prompt_button_mode property to PB_PromptAuto.

Labels

Forms often require an associated description or label. Most-often, these appear to the left of the form. Labels are supported with the label message. The default location and justification mode of labels can be controlled with the properties label_col_offset, label_row_offset and label_justification_mode. If this object is connected to a server and its auto_label_state is set true, the label value, if any, will be overridden by the value of a field property in the Ddo.

The Server

All dbForm objects should always be connected to a server (a data-dictionary object). While the server can be explicitly set within the object, it will usually be set within a parent (or other ancestor) container object.

Using Data Dictionaries

When this object's server is a data dictionary, this object will acquire a great deal of "knowledge" from the server. It will "know" data types, input masks, status-help and prompt objects, validation rules, entry rules, exit rules, display formats (capslock, noput, displayonly, etc.) and much more regarding the data file and its fields. If you use data sets, these settings may all be controlled by setting properties. While possible, this requires a great deal more work and greatly increases the chance of errors and inconsistencies.

Accelerator Keys

Name | Message Sent | Defining Class
kbegin_of_data | beginning_of_data | find_edit_mixin
kbegin_of_panel | beginning_of_panel | navigate_mixin
kcancel | request_cancel | navigate_mixin
kclear | request_clear | find_edit_mixin
kclear_all | request_clear_all | find_edit_mixin
kdelete_record | request_delete | find_edit_mixin
kend_of_data | end_of_data | find_edit_mixin
kend_of_panel | end_of_panel | navigate_mixin
kexit_function | exit_function | navigate_mixin
kfind | find_ge | find_edit_mixin
kfind_next | find_next | find_edit_mixin
kfind_previous | find_previous | find_edit_mixin
kprompt | prompt | entry_item_mixin
ksave_record | request_save | find_edit_mixin
ksuper_find | superfind | find_edit_mixin
ksuper_find_next | superfind_next | find_edit_mixin
ksuper_find_previous | superfind_previous | find_edit_mixin
kswitch | switch | navigate_mixin
kswitch_back | switch_back | navigate_mixin
kswitch_panel | switch_next_group | navigate_mixin
kswitch_panel_back | switch_prior_group | navigate_mixin
kzoom | zoom | entry_item_mixin

Last Edited: July 26, 2006


Properties for dbForm

View property list in alphabetical order

Name | Description
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
Inherited Properties from dbFormDS
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Inherited Properties from dbForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Entry
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbForm

View event list in alphabetical order

Name | Description
Inherited Events from dbForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from Entry
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbForm

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbFormDS
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Request_Save | Procedure |
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from Entry
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbForm_

Class: dbForm_ (Abstract)

Properties Events Methods Index of Classes

Abstract class that supports data entry through an entry_item to one field of one logical record at a time

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------Entry
------------------------------dbForm_
---------------------------------dbFormDS

Library: Windows Application Class Library

Package: Dfentry.pkg

Mixins: Entry_Form_DS_mixin Nesting_Mixin Navigate_Mixin Verify_Mixin Server_Mixin Action_Bar_Mixin Find_Edit_Mixin Entry_Item_Mixin DEO_Dependent_item_mixin Entry_CheckBox_Mixin DEO_Delegate_Mixin Validate_Mixin Clear_Defaults_Mixin

Description

dbForm_ is used to support data entry through an entry_item to one field of one logical record at a time. Its sub-classes dbForm, dbCheckBox, and dbSpinForm should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbForm_

View property list in alphabetical order

Name | Description
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Entry
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbForm_

View event list in alphabetical order

Name | Description
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from Entry
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbForm_

View method list in alphabetical order

Name | Type | Description
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record of this object's server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from Entry
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbFormDS

Class: dbFormDS (Abstract)

Properties Events Methods Index of Classes

Abstract class that supports data entry through an entry_item to one field of one logical record at a time

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------Entry
------------------------------dbForm_
---------------------------------dbFormDS
------------------------------------dbCheckBoxDS
------------------------------------dbForm
------------------------------------dbSpinFormDS

Library: Windows Application Class Library

Package: Dfentry.pkg

Mixins: DFNavigate_Mixin DFCode_DEO_Mixin

Description

dbForm_ is used to support data entry through an entry_item to one field of one logical record at a time. Its sub-classes dbForm, dbCheckBox, and dbSpinForm should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbFormDS

View property list in alphabetical order

Name | Description
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Inherited Properties from dbForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Entry
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbFormDS

View event list in alphabetical order

Name | Description
Inherited Events from dbForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from Entry
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbFormDS

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Request_Save | Procedure |
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from Entry
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbFormExternalControl

Class: dbFormExternalControl (Abstract)

Properties Events Methods Index of Classes

Abstract class that enables applications to provide users with a data aware visual control to 'slide' through a range of values

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------Entry
------------------------------dbForm_
---------------------------------dbFormDS
------------------------------------dbForm
---------------------------------------dbFormExternalControl
------------------------------------------dbTrackBar

Library: Windows Application Class Library

Package: dbExtFrm.pkg

Description

dbFormExternalControl is used to enable applications to provide users with a data aware visual control to 'slide' through a range of values. Its sub-class dbTrackBar should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbFormExternalControl

View property list in alphabetical order

Name | Description
Inherited Properties from dbForm
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
Inherited Properties from dbFormDS
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Inherited Properties from dbForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Entry
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbFormExternalControl

View event list in alphabetical order

Name | Description
Inherited Events from dbForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from Entry
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbFormExternalControl

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbFormDS
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Request_Save | Procedure |
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from Entry
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbGrid

Properties Events Methods Index of Classes

Enables users to view and edit a scrolling, multi-column list of field values from a database file

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------DataList_
------------------------------------------DataList
---------------------------------------------dbGrid_
------------------------------------------------dbGridDS
---------------------------------------------------dbGridDD
------------------------------------------------------dbGrid

Library: Windows Application Class Library

Package: Dftable.pkg

Description

dbGrid is used to enable users to view and edit a scrolling, multi-column list of field values from a database file. The dbGrid class supports combo forms, checkboxes, spin forms and prompt buttons in individual columns or cells.

Sample

Object OrderDtl_Grid is a dbGrid
    Set Main_File to Orderdtl.File_Number
    Set Server to Orderdtl_DD
    Set Ordering to 1
    Set Wrap_State to TRUE
    Set Size to 63 377
    Set Location to 90 3

    Begin_Row
        Entry_Item Invt.Item_id
        Entry_Item Invt.Description
        Entry_Item Invt.Unit_price
        Entry_Item Orderdtl.Price
        Entry_Item Orderdtl.Qty_ordered
        Entry_Item Orderdtl.Extended_price
    End_Row

    Set Form_Width    0 to 55
    Set Header_Label  0 to "Item Id"

    Set Form_Width    1 to 116
    Set Header_Label  1 to "Description"

    Set Form_Width    2 to 55
    Set Header_Label  2 to "Unit Price"

    Set Form_Width    3 to 43
    Set Header_Label  3 to "Price"

    Set Form_Width    4 to 43
    Set Header_Label  4 to "Qty"

    Set Form_Width    5 to 55
    Set Header_Label  5 to "Total"

    Set Child_Table_State to True     // Saves when exit object
End_Object    // OrderDtl_Grid

Syntax

Use dftable

Object oObjectName is a dbGrid
    Set Size to Height Width
    Set Location to Row Column
    Set Main_File to FileName.File_Number
    Set Ordering to Index#
    Set Server to DDOName

    Set Child_Table_State to true|false
    Set Wrap_State to true|false
    Set Allow_Bottom_Add_State to true|false
    Set Allow_Top_Add_State to true|false
    Set Allow_Insert_State to true|false
    Set No_Create_State to true|false
    Set No_Delete_State to true|false
    Set Read_Only_State to true|false
    Set Auto_Regenerate_State to true|false
    :
    Begin_Row
        entry_item {table.field | expression}
        :
    End_Row
    :
    Set Highlight_Row_State to true|false
    Set Gridline_Mode to GridVisibleMode

    Set Header_Visible_State to true|false
    Set Resize_Column_State to true|false

    Set CurrentCellColor to RGBColor
    Set CurrentCellTextColor to RGBColor
    Set CurrentRowColor to RGBColor
    Set CurrentRowTextColor to RGBColor
    Set Highlight_Row_State to true|false
    Set Gridline_Mode to GridVisibleMode

    Set Form_width col# to ColumnWidth

    Set Header_Label col# to HeaderLabel
    Set Header_Justification_Mode col# to Mode

    // These are set when there is no data-dictionary
    Set Status_Help col# to StatusHelpText
    Set Form_DataType col# to type
    Set Form_Mask col# to Mask
    Set Numeric_Mask col# to leftDigits rightDigits {template}
    Set Currency_Mask col# to leftDigits rightDigits {template}
End_Object

Of Special Note

A dbGrid displays multiple records from a main file and any ancestor (parent) files, and allows users to edit them one at a time. At any given moment, the row of the grid the cursor is on is considered the current row, and the record in the main file whose data is displayed therein, the current record. Thus, the dbGrid appears for purposes of editing and display the same as a dbForm.

DbGrids should always be placed inside a dbView object or a data-aware container (dbContainer3d, dbGroup, dbTabPage, dbTabView). The DataDictionary used by the object should be above the entry grid and inside the entry-view container.

Data-Entry Object

The dbGrid is a multi-item data-entry object (DEO). A DEO is an object whose native capabilities (in this case a grid) are augmented with data-aware behaviors. These behaviors include:

  • The finding, clearing, saving and deleting of records (and sets of records)
  • Prompt and zoom object support
  • Change verification (save, delete, and data-loss verifications)
  • Object and item entering, exiting, and validation
  • Server support : DEOs connect to data-server structures

Setting Entry Parameters for Columns

Previous revisions of DataFlex allowed you to set column parameters by placing special parameters on the entry_item command line. These options would be placed inside French braces (entry_item file.field {capslock, iPrompt =(myObj(Self)), iEntry =msg_MyMessage} ). Data dictionaries all but obviate the need for these settings. Normally these settings can and should be placed inside your data-dictionary subclasses. In addition, the Studio does not support the use of these command-line options.

In the rare case where you need to set any of these options for columns within your data-entry object, a complete interface is provided for getting and setting any of them. The single-item data-entry classes use one set of messages for setting these parameters, while the row-based data-entry classes (such as this class) provide a parallel set of messages for setting these parameters on a column-by-column basis. These messages are documented in the datalist class. Below is a summary of all these messages. This list shows the single-item-based message, its equivalent row-based message, and the entry_item option it replaces. Each of these messages supports a get and a set syntax.

Form-Based Messages dbForm, dbComboForm | Grid Column-Based Messages dbGrid, dbList | Old Entry_Item {option} (no longer used)
Item_Options | Column_Options | Required, FindReq, NoEnter, NoPut, DisplayOnly, AutoFind, etc.
Item_Option | Column_Option | (same as above)
Enabled_State (formerly object_shadow_state) | Column_Shadow_State | DisplayOnly
Capslock_State | Column_Capslock_State | Capslock
Prompt_Object | Column_Prompt_Object | iPrompt=
Zoom_Object | Column_Zoom_Object | iZoom=
Item_Entry_msg | Column_Entry_msg | iEntry=
Item_Exit_msg | Column_Exit_msg | iExit=
Item_Validate_msg | Column_Validate_msg | iValidate=

Using Data Dictionaries

When this object's server is a data dictionary, this object will acquire a great deal of "knowledge" from the server. It will "know" data types, input masks, status-help and prompt objects, validation rules, entry rules, exit rules, display formats (capslock, etc., noput, displayonly, etc.) and much more regarding the data file and its fields. If you use data sets, these settings may all be controlled by setting properties. While possible, this requires a great deal more work and greatly increases the chances of errors and inconsistencies.

Masking

This class supports input and display masking for a variety of data-types (text, numeric, currency, and dates). When using data dictionaries, the mask and mask type of the object's items will usually be defined within the data file's data-dictionary subclass. The only time you will need to deal with masks is when you are creating masks for non-data-dictionary based items (expressions and variables).

When manually setting masks, the type of masking used is determined by the object's column form_datatype (which supports both masked and non-masked types) and the object's column form_mask. Two additional messages, currency_mask and numeric_mask, make it particularly easy to define currency and numeric data types and fields with a single message.

Saving and Deleting a Row

Any time a user navigates off of a grid line, any changes made must be saved or cleared. The auto_save_state of a dbGrid is, by default, set to true Anytime a user attempts to move off a line on which they have made a change, a save is done. Tables are usually most-intuitive when saves occur automatically.

The verify_save_msg is set to get_no_confirmation. This disables a verification message with each record save. If desired, you may set this property to get_line_save_confirmation, which causes a line-save confirmation to appear each time a record is about to be saved. The verify_delete_msg has been changed to get_line_delete_confirmation which causes a line-delete confirmation to appear before a delete.

Prompt Headers

This class automatically supports prompt-button labels. If a prompt object is defined for this object, its header becomes "prompt-button-enabled". When any column heading is clicked, the prompt message will be sent and a prompt object (usually a selection list) will appear. Prompt objects are usually acquired from the data-dictionary object, but may be specified in this object by setting the prompt_object property. When a header is prompt-button-enabled, the symbols >> are added to the right of the header label to indicate that a prompt is available.

If you do not want automatic prompt-button creation, you may disable this feature by setting the property prompt_button_mode to PB_PromptOff.

The Server

All dbGrid objects should always be connected to a server (a data-dictionary object). When used as a child table (e.g. order entry detail table), it is quite likely that the server property will be set explicitly within the dbGrid object. If not set in the object, it must be set within a parent (or other ancestor) container object.

Main File, Server DDO, and Index

A main file must be specified for this object, either through an explicit main_file declaration, or by relying on the main_file of DDOname through the server property. Likewise, an index must be named unless one is named in DDOname. The selection list can use a different main_file and index from that of a named DDO, but the index must be one of the indexes of the main_file. If no index is specified at any level, records are listed in recnum order.

Descended from Grid Super-class

The dbGrid class is descended from the grid class. There are numerous messages supporting header labels, form width, grid lines, etc. Refer to the Grid class for a full description of these properties.

Most of the default column-property settings will perform as desired. Normally you will only need to set the form_width and header_label properties.

Item and Row Color and Grid lines

The color of the current row and current item is set with the CurrentCellColor and the CurrentRowColor. These are rgb colors. By default, these values are set by reading keys from the registry. This allows for the customization of colors without recompiling. The colors must be set in the registry because there is no standard Windows default color for highlighted rows and cells.

The ItemColor message allows you to manage the background color of any cell or cells in a grid. When used inside the entry_display procedure, this message can be used to color items according to a field's value. The entry_display message is called every time a row is updated with information from the database. By using the value in the current record buffer, a set ItemColor statement, a get base_item statement (to ascertain the first cell in the current row), and a get item_limit statement (to ascertain the number of cells in a row), you can manage row and cell colors.

The background color of an item is determined by three states. An item may be the current item, an item may be an item within the current row, or an item may be a member of a non-current row. The precedence of color assignment is as follows:

1. CurrentCellColor overrides all other colors.
2. CurrentRowColor, if used (highlight_row_state is true), overrides non-current row color.
3. Non-current row uses ItemColor.

If you wish to use ItemColor to create custom row colors, you will probably wish to set the highlight_row_state property to false.

The following example, which could be added to a dbGrid or a dbList, shows how ItemColor could be used to set a custom color for a row and a cell.

// Changes the color of all items in the current row to RGB color 'iColor'
// This should be sent from Entry_Display as shown later...
Procedure Change_Row_Color Integer iColor
    Integer iBase iItem iItems

    Get Base_Item to iBase               // first item of current row
    Get Item_Limit  to iItems              // items per row
    Move (iBase+iItems-1) to iItems     // last item in the current row

    For iItem from iBase to iItems         // set all items in row to color
        Set ItemColor iItem to iColor
    Loop
End_Procedure // Change_Row_Color

// Augmented in order to get the row, and possibly cell, highlighted
// with a specific color depending on its file-buffer values
Procedure Entry_Display Integer iFile Integer iType
    integer iColor iItem

    // set current row color based on value of extended price
    If (OrderDtl.Extended_Price < 0) ;
        Move clRed to iColor
    Else ;
        If (OrderDtl.Extended_Price = 0 ) ;
            Move clYellow to iColor
        Else ;
            Move clTeal to iColor

    Send Change_Row_Color iColor

    // Set single cell (column 5) based on contents of qty_ordered
    If OrderDtl.Qty_Ordered ge 10 Begin
        Get Base_Item to iItem // first item of the current row
        Set ItemColor (iItem+4) to clPurple // Fifth column
    End

    Forward Send Entry_Display iFile iType
End_Procedure // Entry_Display

The gridline_mode, which specifies whether horizontal and vertical lines should appear in the list, can also be set with a registry setting. If you set the key TableGrid in the registry, you must use the values 0 through 3 (0=Grid_Visible_none, 1=Grid_Visible_Horz, 2=Grid_Visible_Vert, 3=Grid_Visible_Both).

Refer to the Grid class for more information on these properties.

The purpose of supporting unique settings for colors in dbGrids and dbLists (which have their own registry key values) is to provide a mechanism for distinguishing between selection lists (dbLists) and entry tables (dbGrids). DbGrid uses the standard grid and color provided with the grid class.

Creating Checkbox Columns in dbGrids

Any column in a dbGrid may be represented as a checkbox by setting the column property column_checkbox_state to true. If that column's field is defined as a checkbox field in its data dictionary, the column will the display the field's true and false values (which are defined in the data dictionary) in a checkbox format.

In the following example, assume that Column 3 in a dbGrid represents the data field Customer.Active. Within the data dictionary, this field is defined to be a checkbox field with a true value of T and a false value of F. If this field is represented in normal non-checkbox format, Column 3 will be displayed as a column of Ts and Fs. Users can edit these values by changing their value to either T or F. All other values will result in a validation error. This column can be converted to a checkbox column with the following code.

    Set Column_CheckBox_State 3 to True

When set in this fashion, all data values of T will appear as a checked item and all data values of F will appear as an unchecked item. If the checked state of a cell is changed by a user, the underlying data value will also be appropriately changed to T or F.

Accelerator Keys

Name | Message Sent | Defining Class
kadd_mode | add_or_remove_row | dbGrid
kbegin_of_data | beginning_of_data | find_edit_mixin
kclear | request_clear | find_edit_mixin
kclear_all | request_clear_all | find_edit_mixin
kdelete_record | request_delete | find_edit_mixin
kend_of_data | end_of_data | find_edit_mixin
kfind | find_ge | find_edit_mixin
kfind_next | find_next | find_edit_mixin
kfind_previous | find_previous | find_edit_mixin
ksave_record | request_save | find_edit_mixin
ksuper_find | superfind | find_edit_mixin
ksuper_find_next | superfind_next | find_edit_mixin
ksuper_find_previous | superfind_previous | find_edit_mixin

Last Edited: November 9, 2006


Properties for dbGrid

View property list in alphabetical order

Name | Description
Column_Combo_Code_Display_mode | Determines what is displayed in the combo form and its dropdown list
Inherited Properties from dbGridDD
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
Export_Code_Description_State | Determines if the next item will be used to display a code description
Inherited Properties from dbGridDS
Prompt_Button_Mode | Determines if prompt_button_value will be displayed to the right of column labels
Prompt_Button_Value | Specifies the character(s) to be appended to a column-header label to indicate that it supports prompting
Inherited Properties from dbGrid_
Allow_Bottom_add_State | Determines if additional rows may be added to the end of the grid
Allow_Insert_Add_State | Determines if new rows may be inserted within the grid
Allow_top_add_State | Determines if additional rows may be added to the top of the grid
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Regenerate_State | Controls the behavior of the object when add mode is exited, or when the object is initialized as it takes the focus
Auto_Save_State | Determines if auto save should be performed
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Child_Table_State | Determines if the entering message sends the child_entering message and the exiting message sends the child_exiting message
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
No_Create_State | Controls whether or not this object can create records
No_Delete_State | Controls whether this object can delete records
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Should_Save | Gets and returns the value of the row_changed function
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from DataList
Column_Button |
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to
Column_Option | Allows you to query or change the iOption option line for Column iCol
Column_Options | Allows you to copy column options or set them in a group
Column_Prompt_Object | Specifies the default receiving object for the popup message
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object
CustomScrollState | Determines changing scroll bar behaviors
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction
psEmbeddedButtonValue |
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior
Inherited Properties from DataList_
Auto_index_state | Determines how the popup lists will be ordered
Batch_State | Determines how much data from the database is read into memory
Current_Record | (Obsolete) The number of the record of the current row
CurrentRecordStatus |
CurrentRowHasRecord |
CurrentRowId |
Init_from_Top_State | Determines in what order images are displayed
Initial_Column | Determines where the cursor is located when the list is activated
Initial_Row | Governs the location in the display of the record (if any) in the buffer
Main_File | Holds the file number of the main file of the list
No_Relate_State | Determines if relates occur with lists that do not use DDOs
Ordering | Holds the index of the main file to be used to display the database records of the main file
pbReverseOrdering | Determines if the list should be displayed in reverse index order
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own
Prototype_Object | Returns the object-id of the internal object
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object
Record_Number | (Obsolete) Indicates the record number for the record in the specified row
record_rowId |
RecordStatus |
RowHasRecord |
Static_State | Determines if the list will only be initialized once the first time this object is activated
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbGrid

View event list in alphabetical order

Name | Description
Column_Combo_Description_Value | Called to determine what should be displayed in the combo form
Column_Combo_Fill_List | Called when the column combo form's dropdown list needs to be filled
Inherited Events from dbGridDS
Header_Mouse_Click |
Inherited Events from dbGrid_
Child_Entering | Provided to permit programming of required grid actions when this object is a child of a header grid object
Child_Exiting | Event that is sent when a child table is about to be exited
Entering | Augmented to call child_entering if this object's child_table_state is true
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from DataList
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view
onInitSpin |
Inherited Events from DataList_
OnNewOrdering | Called whenever the ordering is changed
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from WideList_
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbGrid

View method list in alphabetical order

Name | Type | Description
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Inherited Methods from dbGridDS
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Inherited Methods from dbGrid_
add_new_row | Procedure | Inserts a blank row into the grid if the cursor is not already in a new row
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Augmented to respect the value of the allow_row_change property
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Reorder_list | Procedure |
Request_Clear | Procedure | Clears the current row of any changes entered to it
Request_Clear_All | Procedure | Clears list page, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Determines if the current record of the server of the object is deleted
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record
Request_Save_No_Clear | Procedure |
Request_Superfind | Procedure | Superfinds record using specified mode, by sending request_superfind to server, if any
Row_save | Function | Sent by request_save to save the current record in the server file
Scroll | Procedure |
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from DataList
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm
Inherited Methods from DataList_
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list
Clear_Current_Record | Procedure |
Col_Index | Function | Returns the number of the main index for the field connected to Column Item#
Display | Procedure |
DoCheckDisplayableRows | Procedure |
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList
DoToggleColumnOrdering | Procedure |
Establish_Find_Mode | Procedure |
File_Record | Function | (Obsolete)
FileRecord | Function |
FileRowId | Function |
Fill_List | Procedure |
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer
Find_Init | Procedure |
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object
find_RowId | Procedure |
Goto_Bottom_Row | Procedure |
Goto_Top_Row | Procedure |
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in
Read_By_Recnum | Procedure | (Obsolete)
Read_Next_Record | Procedure |
ReadByRowId | Procedure |
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col#
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own
Up_Row | Procedure |
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbGrid_

Class: dbGrid_ (Abstract)

Properties Events Methods Index of Classes

Abstract class that enables users to view and edit a scrolling, multi-column list of field values from a database file

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------DataList_
------------------------------------------DataList
---------------------------------------------dbGrid_
------------------------------------------------dbGridDS

Library: Windows Application Class Library

Package: Dftable.pkg

Mixins: Table_ds_mixin VERIFY_Mixin FIND_EDIT_Mixin Validate_Mixin DEO_Delegate_Mixin DEO_Dependent_item_mixin Clear_Defaults_Mixin Entry_CheckBox_Mixin

Description

dbGrid_ is used to enable users to view and edit a scrolling, multi-column list of field values from a database file. Its sub-class dbGrid should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbGrid_

View property list in alphabetical order

Name | Description
Allow_Bottom_add_State | Determines if additional rows may be added to the end of the grid
Allow_Insert_Add_State | Determines if new rows may be inserted within the grid
Allow_top_add_State | Determines if additional rows may be added to the top of the grid
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Regenerate_State | Controls the behavior of the object when add mode is exited, or when the object is initialized as it takes the focus
Auto_Save_State | Determines if auto save should be performed
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Child_Table_State | Determines if the entering message sends the child_entering message and the exiting message sends the child_exiting message
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
No_Create_State | Controls whether or not this object can create records
No_Delete_State | Controls whether this object can delete records
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Should_Save | Gets and returns the value of the row_changed function
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from DataList
Column_Button |
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to
Column_Option | Allows you to query or change the iOption option line for Column iCol
Column_Options | Allows you to copy column options or set them in a group
Column_Prompt_Object | Specifies the default receiving object for the popup message
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object
CustomScrollState | Determines changing scroll bar behaviors
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction
psEmbeddedButtonValue |
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior
Inherited Properties from DataList_
Auto_index_state | Determines how the popup lists will be ordered
Batch_State | Determines how much data from the database is read into memory
Current_Record | (Obsolete) The number of the record of the current row
CurrentRecordStatus |
CurrentRowHasRecord |
CurrentRowId |
Init_from_Top_State | Determines in what order images are displayed
Initial_Column | Determines where the cursor is located when the list is activated
Initial_Row | Governs the location in the display of the record (if any) in the buffer
Main_File | Holds the file number of the main file of the list
No_Relate_State | Determines if relates occur with lists that do not use DDOs
Ordering | Holds the index of the main file to be used to display the database records of the main file
pbReverseOrdering | Determines if the list should be displayed in reverse index order
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own
Prototype_Object | Returns the object-id of the internal object
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object
Record_Number | (Obsolete) Indicates the record number for the record in the specified row
record_rowId |
RecordStatus |
RowHasRecord |
Static_State | Determines if the list will only be initialized once the first time this object is activated
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbGrid_

View event list in alphabetical order

Name | Description
Child_Entering | Provided to permit programming of required grid actions when this object is a child of a header grid object
Child_Exiting | Event that is sent when a child table is about to be exited
Entering | Augmented to call child_entering if this object's child_table_state is true
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from DataList
Header_Mouse_Click |
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view
onInitSpin |
Inherited Events from DataList_
OnNewOrdering | Called whenever the ordering is changed
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from WideList_
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbGrid_

View method list in alphabetical order

Name | Type | Description
add_new_row | Procedure | Inserts a blank row into the grid if the cursor is not already in a new row
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Augmented to respect the value of the allow_row_change property
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Reorder_list | Procedure |
Request_Clear | Procedure | Clears the current row of any changes entered to it
Request_Clear_All | Procedure | Clears list page, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Determines if the current record of the server of the object is deleted
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record
Request_Save_No_Clear | Procedure |
Request_Superfind | Procedure | Superfinds record using specified mode, by sending request_superfind to server, if any
Row_save | Function | Sent by request_save to save the current record in the server file
Scroll | Procedure |
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from DataList
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm
Inherited Methods from DataList_
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list
Clear_Current_Record | Procedure |
Col_Index | Function | Returns the number of the main index for the field connected to Column Item#
Display | Procedure |
DoCheckDisplayableRows | Procedure |
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList
DoToggleColumnOrdering | Procedure |
Establish_Find_Mode | Procedure |
File_Record | Function | (Obsolete)
FileRecord | Function |
FileRowId | Function |
Fill_List | Procedure |
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer
Find_Init | Procedure |
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object
find_RowId | Procedure |
Goto_Bottom_Row | Procedure |
Goto_Top_Row | Procedure |
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in
Read_By_Recnum | Procedure | (Obsolete)
Read_Next_Record | Procedure |
ReadByRowId | Procedure |
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col#
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own
Up_Row | Procedure |
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbGridDD

Class: dbGridDD (Abstract)

Properties Events Methods Index of Classes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------DataList_
------------------------------------------DataList
---------------------------------------------dbGrid_
------------------------------------------------dbGridDS
---------------------------------------------------dbGridDD
------------------------------------------------------dbGrid

Library: Windows Application Class Library

Package: Dftable.pkg

Mixins: Extended_DEO_Mixin Extended_DEO_Status_Help_Mixin Code_Description_Mixin

Description

Last Edited: November 11, 2004


Properties for dbGridDD

View property list in alphabetical order

Name | Description
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
Export_Code_Description_State | Determines if the next item will be used to display a code description
Inherited Properties from dbGridDS
Prompt_Button_Mode | Determines if prompt_button_value will be displayed to the right of column labels
Prompt_Button_Value | Specifies the character(s) to be appended to a column-header label to indicate that it supports prompting
Inherited Properties from dbGrid_
Allow_Bottom_add_State | Determines if additional rows may be added to the end of the grid
Allow_Insert_Add_State | Determines if new rows may be inserted within the grid
Allow_top_add_State | Determines if additional rows may be added to the top of the grid
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Regenerate_State | Controls the behavior of the object when add mode is exited, or when the object is initialized as it takes the focus
Auto_Save_State | Determines if auto save should be performed
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Child_Table_State | Determines if the entering message sends the child_entering message and the exiting message sends the child_exiting message
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
No_Create_State | Controls whether or not this object can create records
No_Delete_State | Controls whether this object can delete records
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Should_Save | Gets and returns the value of the row_changed function
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from DataList
Column_Button |
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to
Column_Option | Allows you to query or change the iOption option line for Column iCol
Column_Options | Allows you to copy column options or set them in a group
Column_Prompt_Object | Specifies the default receiving object for the popup message
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object
CustomScrollState | Determines changing scroll bar behaviors
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction
psEmbeddedButtonValue |
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior
Inherited Properties from DataList_
Auto_index_state | Determines how the popup lists will be ordered
Batch_State | Determines how much data from the database is read into memory
Current_Record | (Obsolete) The number of the record of the current row
CurrentRecordStatus |
CurrentRowHasRecord |
CurrentRowId |
Init_from_Top_State | Determines in what order images are displayed
Initial_Column | Determines where the cursor is located when the list is activated
Initial_Row | Governs the location in the display of the record (if any) in the buffer
Main_File | Holds the file number of the main file of the list
No_Relate_State | Determines if relates occur with lists that do not use DDOs
Ordering | Holds the index of the main file to be used to display the database records of the main file
pbReverseOrdering | Determines if the list should be displayed in reverse index order
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own
Prototype_Object | Returns the object-id of the internal object
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object
Record_Number | (Obsolete) Indicates the record number for the record in the specified row
record_rowId |
RecordStatus |
RowHasRecord |
Static_State | Determines if the list will only be initialized once the first time this object is activated
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbGridDD

View event list in alphabetical order

Name | Description
Inherited Events from dbGridDS
Header_Mouse_Click |
Inherited Events from dbGrid_
Child_Entering | Provided to permit programming of required grid actions when this object is a child of a header grid object
Child_Exiting | Event that is sent when a child table is about to be exited
Entering | Augmented to call child_entering if this object's child_table_state is true
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from DataList
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view
onInitSpin |
Inherited Events from DataList_
OnNewOrdering | Called whenever the ordering is changed
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from WideList_
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbGridDD

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbGridDS
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Inherited Methods from dbGrid_
add_new_row | Procedure | Inserts a blank row into the grid if the cursor is not already in a new row
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Augmented to respect the value of the allow_row_change property
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Reorder_list | Procedure |
Request_Clear | Procedure | Clears the current row of any changes entered to it
Request_Clear_All | Procedure | Clears list page, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Determines if the current record of the server of the object is deleted
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record
Request_Save_No_Clear | Procedure |
Request_Superfind | Procedure | Superfinds record using specified mode, by sending request_superfind to server, if any
Row_save | Function | Sent by request_save to save the current record in the server file
Scroll | Procedure |
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from DataList
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm
Inherited Methods from DataList_
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list
Clear_Current_Record | Procedure |
Col_Index | Function | Returns the number of the main index for the field connected to Column Item#
Display | Procedure |
DoCheckDisplayableRows | Procedure |
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList
DoToggleColumnOrdering | Procedure |
Establish_Find_Mode | Procedure |
File_Record | Function | (Obsolete)
FileRecord | Function |
FileRowId | Function |
Fill_List | Procedure |
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer
Find_Init | Procedure |
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object
find_RowId | Procedure |
Goto_Bottom_Row | Procedure |
Goto_Top_Row | Procedure |
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in
Read_By_Recnum | Procedure | (Obsolete)
Read_Next_Record | Procedure |
ReadByRowId | Procedure |
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col#
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own
Up_Row | Procedure |
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbGridDS

Class: dbGridDS (Abstract)

Properties Events Methods Index of Classes

Abstract class that enables users to view and edit a scrolling, multi-column list of field values from a database file

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------DataList_
------------------------------------------DataList
---------------------------------------------dbGrid_
------------------------------------------------dbGridDS
---------------------------------------------------dbGridDD

Library: Windows Application Class Library

Package: Dftable.pkg

Description

dbGridDS is used to enable users to view and edit a scrolling, multi-column list of field values from a database file. Its sub-class dbGrid should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbGridDS

View property list in alphabetical order

Name | Description
Prompt_Button_Mode | Determines if prompt_button_value will be displayed to the right of column labels
Prompt_Button_Value | Specifies the character(s) to be appended to a column-header label to indicate that it supports prompting
Inherited Properties from dbGrid_
Allow_Bottom_add_State | Determines if additional rows may be added to the end of the grid
Allow_Insert_Add_State | Determines if new rows may be inserted within the grid
Allow_top_add_State | Determines if additional rows may be added to the top of the grid
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Regenerate_State | Controls the behavior of the object when add mode is exited, or when the object is initialized as it takes the focus
Auto_Save_State | Determines if auto save should be performed
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Child_Table_State | Determines if the entering message sends the child_entering message and the exiting message sends the child_exiting message
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
No_Create_State | Controls whether or not this object can create records
No_Delete_State | Controls whether this object can delete records
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Should_Save | Gets and returns the value of the row_changed function
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from DataList
Column_Button |
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to
Column_Option | Allows you to query or change the iOption option line for Column iCol
Column_Options | Allows you to copy column options or set them in a group
Column_Prompt_Object | Specifies the default receiving object for the popup message
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object
CustomScrollState | Determines changing scroll bar behaviors
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction
psEmbeddedButtonValue |
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior
Inherited Properties from DataList_
Auto_index_state | Determines how the popup lists will be ordered
Batch_State | Determines how much data from the database is read into memory
Current_Record | (Obsolete) The number of the record of the current row
CurrentRecordStatus |
CurrentRowHasRecord |
CurrentRowId |
Init_from_Top_State | Determines in what order images are displayed
Initial_Column | Determines where the cursor is located when the list is activated
Initial_Row | Governs the location in the display of the record (if any) in the buffer
Main_File | Holds the file number of the main file of the list
No_Relate_State | Determines if relates occur with lists that do not use DDOs
Ordering | Holds the index of the main file to be used to display the database records of the main file
pbReverseOrdering | Determines if the list should be displayed in reverse index order
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own
Prototype_Object | Returns the object-id of the internal object
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object
Record_Number | (Obsolete) Indicates the record number for the record in the specified row
record_rowId |
RecordStatus |
RowHasRecord |
Static_State | Determines if the list will only be initialized once the first time this object is activated
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbGridDS

View event list in alphabetical order

Name | Description
Header_Mouse_Click |
Inherited Events from dbGrid_
Child_Entering | Provided to permit programming of required grid actions when this object is a child of a header grid object
Child_Exiting | Event that is sent when a child table is about to be exited
Entering | Augmented to call child_entering if this object's child_table_state is true
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from DataList
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view
onInitSpin |
Inherited Events from DataList_
OnNewOrdering | Called whenever the ordering is changed
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from WideList_
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbGridDS

View method list in alphabetical order

Name | Type | Description
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Inherited Methods from dbGrid_
add_new_row | Procedure | Inserts a blank row into the grid if the cursor is not already in a new row
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Augmented to respect the value of the allow_row_change property
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Reorder_list | Procedure |
Request_Clear | Procedure | Clears the current row of any changes entered to it
Request_Clear_All | Procedure | Clears list page, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Determines if the current record of the server of the object is deleted
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any
Request_Save | Procedure | Saves changes to the current record
Request_Save_No_Clear | Procedure |
Request_Superfind | Procedure | Superfinds record using specified mode, by sending request_superfind to server, if any
Row_save | Function | Sent by request_save to save the current record in the server file
Scroll | Procedure |
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from DataList
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm
Inherited Methods from DataList_
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list
Clear_Current_Record | Procedure |
Col_Index | Function | Returns the number of the main index for the field connected to Column Item#
Display | Procedure |
DoCheckDisplayableRows | Procedure |
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList
DoToggleColumnOrdering | Procedure |
Establish_Find_Mode | Procedure |
File_Record | Function | (Obsolete)
FileRecord | Function |
FileRowId | Function |
Fill_List | Procedure |
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer
Find_Init | Procedure |
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object
find_RowId | Procedure |
Goto_Bottom_Row | Procedure |
Goto_Top_Row | Procedure |
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in
Read_By_Recnum | Procedure | (Obsolete)
Read_Next_Record | Procedure |
ReadByRowId | Procedure |
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col#
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own
Up_Row | Procedure |
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbGroup

Properties Events Methods Index of Classes

Creates visual group container objects and by default, provides a gray background with a rectangular 3 D line border with a text label embedded in the top left edge

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseGroup
---------------------Group
------------------------dbGroup_
---------------------------dbGroup

Library: Windows Application Class Library

Package: Dfclient.pkg

Mixins: DFNavigate_Mixin

Description

The dbGroup class creates visual group container objects and by default, provides a gray background with a rectangular 3 D line border with a text label embedded in the top left edge. This is to be used with other DEOs within a data-aware view. It must be placed inside a db... container (dbView, dbContainer, etc). Objects based on this class will contain DEO controls (dbForm, dbEdit, etc), basic controls (button, etc.) and other data-aware (db...) container objects (which will themselves contain controls).

Sample

Object oObjectName is a dbGroup
    Set Size to 70 150
    Set Location to 5 5
    Set Label to "Customer Data"

    Object F1 is a dbform
        Set Location to 10 70
        Set Size to 13 40
        Entry_Item Customer.Name
        Set Label to "Name:"
    End_Object

    Object F2 is a dbform
        Set Location to 25 70
        Set Size to 13 30
        Entry_Item Customer.Id
        Set Label to "Id:"
    End_Object

End_Object

Syntax

Use dfClient.pkg
:
Object oObjectName is a dbGroup
    Set Size to height width
    Set Location to row column
    Set Label to LabelText

    Set Enabled_State to true|false

    Set Server to (DDO(self))
    Set Verify_Save_msg to get_SaveMessage
    Set Verify_Delete_msg to get_DeleteMessage
    Set Verify_Data_Loss_msg to get_DataLossMessage
    Set Verify_Exit_msg to get_ExitMessage
    :
    : DEO objects
    :
End_Object

Of Special Note

A dbGroup is a visual container for data-entry objects. Many of the properties and messages of this class are provided (and controlled) solely for use with child objects. In these respects, using a container object provides a convenience for the programmer, and greater interface consistency for users.

You will use dbGroup objects primarily for navigation and display purposes. All DEOs inside a dbGroup are activated (and therefore displayed) as a unit.

DbContainer3d and dbGroup objects are used to group objects together. They are functionally identical and differ only in appearance.

Do not place radio objects inside a dbGroup object. Radio objects should be placed inside dbRadioGroup and dbRadioContainer objects.

The Group Label

The group's text label is set by setting the label property. If you do not wish to display a label, you may set the label property to "" resulting in the display of an unbroken 3 D-line rectangle.

DEO Container Object

The dbGroup is a data-entry container object (DEO container). A DEO container is an object (in this case a Group) whose native capabilities are augmented with data-aware behaviors. These behaviors include:

  • Finding, clearing, saving, and deleting records (and sets of records)
  • Change verification (save, delete, and data-loss verifications)
  • Server support: DEOs connect to data-server structures

These data-aware "skills" are added to all DEO classes through a series of mix-in classes. The message are listed here but documented in the mix-in classes. You are encouraged to study the documentation of the mix-in classes. Information provided in the documentation of these classes may be applied to all DEO classes (all db... classes). Those classes are: Nesting_Mixin, Navigate_Mixin, Verify_Mixin, Server_Mixin, and DEO_Delegate_Mixin.

DEO Nesting Rules

When creating data-aware views and db... objects, you must observe the following object-placement rules:

  • All DEO containers (dbContainer3d, dbContainer, dbGroup, dbTabDialog, etc.) must always be placed directly within a DEO container. These will all be contained within a dbView or a dbModalPanel.
  • All DEO controls (dbForm, dbComboForm, dbGrid, etc.) must always be placed directly within a DEO object, usually a container.
  • Non DEO controls and containers may be placed inside DEO containers. It is common to add buttons to a view or a container. If a non- db... container (Container3d, Group, etc.) is placed inside a DEO container, the non-DEO container may only contain non-DEO child objects (form, radio, Container3d, etc.)
  • It is almost always an error to place a DEO inside a non-db... parent.

The Server

All dbGroup objects should be connected to a server (a data-dictionary object). The server can be explicit (directly set with the set Server message) or acquired from a parent DEO container. Often the dbView object will provide the server for a DEO container. All child objects will also use the server unless a child object explicitly sets a different server. Do not explicitly set a server if you do not have to. If the acquired server from the parent is correct, use it.

You can set custom verification messages to supply save, delete, data-loss and exit confirmations. Normally, these verifications are defined within the view object (dbView) and acquired by all children. If new messages are required, they often are required within the same object that sets a new server.

The dbContainer class supports the messages request_save, request_clear, request_clear_all, and request_delete. Normally these messages are sent from a DEO and will delegate down through the DEO structure until they encounter the object that explicitly set the server (often a DEO container). This makes it possible to define request-message behaviors at the container level so that child DEOs can make use of the definitions by delegation.

Using Data Dictionaries

When this object's server is a data dictionary, this object will acquire a great deal of "knowledge" from the server. Although the container itself will not need to use this knowledge, it will be used by all DEO entry objects that acquire the server through this object.

Shadowing

Container objects may shadowed by setting the enabled_state property to true. When set, all descendant objects are indirectly (or implicitly) shadowed. When shadowed (explicitly or by a parent) the group's label will display in shadowed mode to indicate its unavailability.

Accelerator Keys

Name | Message Sent | Defining Class
kbegin_of_panel | beginning_of_panel | navigate_mixin
kcancel | request_cancel | navigate_mixin
kend_of_panel | end_of_panel | navigate_mixin
kexit_function | exit_function | navigate_mixin
kswitch | switch | navigate_mixin
kswitch_back | switch_back | navigate_mixin
kswitch_panel | switch_next_group | navigate_mixin
kswitch_panel_back | switch_prior_group | navigate_mixin

Last Edited: November 21, 2004


Properties for dbGroup

View property list in alphabetical order

Name | Description
Inherited Properties from dbGroup_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Group
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbGroup

View event list in alphabetical order

Name | Description
Inherited Events from Group
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbGroup

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure | Closes the panel or component currently open
Inherited Methods from dbGroup_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from Group
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbGroup_

Class: dbGroup_ (Abstract)

Properties Events Methods Index of Classes

Abstract class that creates visual group container objects and by default, provides a gray background with a rectangular 3 D line border with a text label embedded in the top left edge

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseGroup
---------------------Group
------------------------dbGroup_
---------------------------dbGroup

Library: Windows Application Class Library

Package: Dfclient.pkg

Mixins: Entry_Client_mixin NESTING_Mixin NAVIGATE_Mixin SERVER_Mixin VERIFY_Mixin ACTION_BAR_Mixin Auto_Locate_Mixin Non_Dependent_Item_Mixin Deo_Delegate_Mixin

Description

dbGroup_ is used to create visual group container objects and by default, provides a gray background with a rectangular 3 D line border with a text label embedded in the top left edge. Its sub-class dbGroup should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbGroup_

View property list in alphabetical order

Name | Description
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Group
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbGroup_

View event list in alphabetical order

Name | Description
Inherited Events from Group
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbGroup_

View method list in alphabetical order

Name | Type | Description
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from Group
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbList

Properties Events Methods Index of Classes

Enables users to select one or more values from a list of choices

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------DataList_
------------------------------------------DataList
---------------------------------------------dbList_
------------------------------------------------dbListDS
---------------------------------------------------dbList

Library: Windows Application Class Library

Package: Dfsellst.pkg

Mixins: Extended_DEO_Mixin

Description

dbList is used to enable users to select one or more values from a list of choices. The choices must come from database file(s). DbLists must be placed inside a DEO container. When used as selection lists, they are placed inside a dbModalPanel object.

Sample

Use dfAllEnt.pkg

Object Salesp_sl is a dbModalPanel
    Set Label to "Sales People List"
    Set Size to 119 265

    Object SalesP_DD is a SalesP_DataDictionary
        Procedure OnConstrain
            Constrain SalesP.Status eq "A"
        End_Procedure
    End_Object
    Set Server to SalesP_DD
    // Note: do not set main_DD

    Object oList is a dbList
        Set Main_File to Salesp.File_Number
        Set Size to 71 251
        Set Location to 6 6
        Begin_Row
            Entry_Item Salesp.Id
            Entry_Item Salesp.Name
        End_Row

        Set Form_Width    0 to 40
        Set Header_Label  0 to "Id"

        Set Form_Width    1 to 200
        Set Header_Label  1 to "Name"
    End_Object    // oList

    Object OK_bn is a Button
        Set Label to "&Ok"
        Set Location to 84 99
        Procedure OnClick
            Send Ok of oList
        End_Procedure
    End_Object    // OK_bn

    Object Cancel_bn is a Button
        Set Label to "&Cancel"
        Set Location to 84 153
        Procedure OnClick
            Send Cancel of oList
        End_Procedure

    End_Object    // Cancel_bn

    Object Search_bn is a Button
        Set Label to "&Search..."
        Set Location to 84 207
        Procedure OnClick
            Send Search of oList
        End_Procedure
    End_Object    // Search_bn

    On_Key Key_Alt+Key_O Send KeyAction of Ok_bn
    On_Key Key_Alt+Key_C Send KeyAction of Cancel_bn
    On_Key Key_Alt+Key_S Send KeyAction of Search_bn
End_Object    // Salesp_sl

Syntax

Use dfSelLst.pkg

Object oObjectName is a dbList
    Set Size to Height Width
    Set Location to Row Column
    Set Main_File to FileName.File_Number
    Set Ordering to Index#
    Set Server to (DDO(self))
    Set Auto_Index_State to true| false
    Set Auto_Column_State to true| false
    Set Auto_Server_State to true| false
    Set Auto_Shadow_State to true| false
    Set Auto_Label_State to true| false
    :
    begin_row
        entry_item {file.field | expression}
        :
    end_row
    :
    Set Highlight_Row_State to true| false
    Set Gridline_Mode to GridVisibleMode

    Set Header_Visible_State to true| false
    Set Resize_Column_State to true| false

    Set CurrentCellColor to RGBColor
    Set CurrentRowColor to RGBColor
    Set Highlight_Row_State to true| false
    Set Gridline_Mode to GridVisibleMode
    // Column-based properties. repeat for each column
    Set Form_Width col# to ColumnWidth
    Set Form_DataType col# to type
    Set Form_Mask col# to Mask
    Set Numeric_Mask col# to leftDigits rightDigits {template}
    Set Currency_Mask col# to leftDigits rightDigits {template}

    Set Header_Label col# to HeaderLabel
    Set Header_Justification_Mode col# to Mode
End_Object

Of Special Note

This class specifies a single- or multi-select list of choices from a database file(s). By default, a selection list will seed itself with the contents of the object item from which it was invoked, start in the column of the list that matches the field for the item from which it was invoked, employ a fast, non-incremental search method for jumping around the list, and automatically update the invoking object without its needing to share that object's DDO.

The default behaviors of the dbList are quite powerful. With auto_index_state true (which causes the sort order to change automatically when users switch from column to column) and auto_column_state true (which causes the column to be selected automatically upon startup based on the file.field of the invoking item), it will handle most of your selection-list needs. There are a number of properties and message handlers that can allow even greater control over selection lists. You will normally not need to use these, but when needed, they can make the difference between a good selection list and a great one.

Using with a Data Dictionary

Objects of this class can and should be used with data dictionaries. A dbList may contain its own data-dictionary object (create a DDO structure and connect the DEO with the set server message.) or it may use the DDO of its invoking object (set auto_server_state to true). When a dbList is connected to a DDO, it uses information about a column's shadow state (DD_DisplayOnly), mask type and value, Capslock status, and, if auto_label_state is true, its label. Using data dictionaries therefore makes lookup lists much easier to program.

DD objects are also used to provide finding constraints for a list. If a dbList uses its own DDO, that DDO may be used to define constraints. If the dbList uses an auto-server, the constraints of the invoking DDO will be used.

Auto_label_state is used to specify whether a list's header labels should be assigned explicitly with the set header_label message or if the labels should be assigned from the data dictionary.

Selection List vs. Display List

The dbList class is normally used as a modal popup selection list. It is placed inside a modal panel object (dbModalPanel) and is used by views to select a record. All of the behaviors required to support lookups are supported by a default dbList.

A dbList may also be used for non-lookup purposes. In this case, it is used more like a dbGrid except that does not support data entry into the cells. When using one this way, you need to disable a number of the startup (seed the list, find the right column) and shut-down (move the selected value to the invoking object) properties. You do this by setting the property move_value_out_state to false. When used in this fashion, it is very important to set this property false. Failing to do will generate a number of runtime errors.

Exporting the Selected Value

When used as a lookup list (move_value_out_state is true), this object will need to update the invoking object with a selected record or value, a process called "export." There are two types of export behaviors: relational and non-relational. Usually a lookup is "relational". This means that the list's main file is the same as the main file of the invoking object. In such a case, the selected record must be returned to the invoking object. In fact, the selected record must be returned to the invoking object's data-dictionary object. This way, all other records (parent and children) are found as needed and all objects in the view are properly updated with the new record.

This object might alternatively be used to find a non-relational record. In this case, the main file of the list and of the invoking object are different. The list will return the selected item back to the invoking object (no record finding in the view is involved).

This object will determine if it is being used for a relational or non-relational lookup and will update the invoking object accordingly. If you wish, you may override this automatic behavior by setting the property auto_export_state to false, and setting the property export_item_state to false to force a relational update, and true to force a non-relational update. There should be little need to do this.

Main File, Server DSO, and Index

A main file must be specified for the object, either through an explicit main_file declaration, or by relying on the main_file of DSOname through the server property. Likewise, an index must be named unless one is named in DSOname or Auto_index_State is used (which is suggested). The selection list can use a different main_file and index from that of a named DSO, but the index must be one of the indexes of the main_file. If no index is specified at any level, records are listed in recnum order.

Often you will want this object to respect the finding constraints of the view that invoked it. Technically, you will want it to acquire the constraints of the invoking object's server. This is done by setting this object's auto_server_state to true. When this property is true, this object will latch onto the invoking view's data-server structure upon activation and disconnect upon deactivation.

Searching for Records in a List

If users need to jump from one row in a sorted column to another, they may simply start typing the new target value. This pops up a search window. Type in the value and press Enter (or press the OK button) and the list will refresh itself around the new target item. This is the preferred method of searching through a list. It is fast, easy, and intuitive. This behavior is supported when the property popup_search_state is true, and the property find_search_state is false. This is the default. Several other search options are supported.

If popup_search_state is false and find_search_state is false, the list will support an "in-place" incremental search. When used this way, the list is refreshed each time a key is pressed. Each refresh results in a refinding of each record in the list. Since this method often requires many keystrokes before getting close to the target, this is not a particularly effective way to find records in a large database It also does not work well with numbers or dates.

If popup_search_state is false and find_search_state is true, the list will support an "in-place" non-incremental search. This works exactly like a popup search except that a search window is never displayed.

The auto_shadow_state property specifies whether items should be shadowed if they cannot participate in a find. By default, this property is set to true. This means that you normally do not need to explicitly set list columns to display-only. Note that this will be used in combination with any data-dictionary No-enter assignments.

Searching with Parent File and Fields

Both of the non-incremental search methods support the ability to find the main-file field based on a parent-file field. For example, in an order lookup, you might use a field named Order.Cust_Number or its parent field named Customer.Number. When faced with such a choice, you should use the parent field. When a find occurs with the parent field, the object will first find the record using the parent field's index (e.g., it finds the Customer record). It will then find the relational link between the parent and main field (e.g., it finds a relationship between Customer.Number and Order.Cust_Number). It will then find and display the appropriate records in the main file. You may even find on a parent field that does not directly relate to the main file. For example, you could find on Customer.Name. It would find the record by the customer-name index, find the relational link between the Customer and Order files (which will not be the name field), and find the records in the main file. While this capability might appear abstruse at first, it is a powerful feature.

Lists that are visually designed within Visual DataFlex will automatically use the parent field (and not the relating-to child). This is standard behavior for all objects and has in fact been a standard requirement of DataFlex since the very beginning (always use parent.fields and not the relating child fields).

Setting Entry Parameters for Columns

Previous revisions of DataFlex allowed you to set column parameters by placing special parameters on the entry_item command line. These options would be placed inside French braces (entry_item file.field {capslock, iPrompt =(myObj(Self)), iEntry =msg_MyMessage} ). Data dictionaries all but obviate the need for these settings. Normally these settings can and should be placed inside your data-dictionary subclasses. In addition, the Studio does not support the use of these command-line options.

In the rare case where you need to set any of these options for columns within your data-entry object, a complete interface is provided for getting and setting any of them. The single-item data-entry classes use one set of messages for setting these parameters, while the row-based data-entry classes (such as this class) provide a parallel set of messages for setting these parameters on a column-by-column basis. These messages are documented in the datalist class. Below is a summary of all these messages. This list shows the single-item-based message, its equivalent row-based message, and the entry_item option it replaces. Each of these messages supports a get and a set syntax.

Form-Based Messages | dbForm, dbComboForm Grid Column-Based Messages | dbGrid, dbList Old Entry_Item {option} (no longer used)
Item_Options | Column_Options | Required, FindReq, NoEnter, NoPut, DisplayOnly, AutoFind, etc.
Item_Option | Column_Option | (same as above)
Enabled_State (formerly object_shadow_state) | Column_Shadow_State | DisplayOnly
Capslock_State | Column_Capslock_State | Capslock
Prompt_Object | Column_Prompt_Object | iPrompt=
Zoom_Object | Column_Zoom_Object | iZoom=
Item_Entry_msg | Column_Entry_msg | iEntry=
Item_Exit_msg | Column_Exit_msg | iExit=
Item_Validate_msg | Column_Validate_msg | iValidate=

Item and Row Color and Grid Lines

The color of the current row and current item is set with the CurrentCellColor and the CurrentRowColor. These are rgb colors. By default, these values are set by reading key values from the registry. This allows for the customization of colors without recompiling. The colors must be set in the registry because there is no standard Windows default color for highlighted rows and cells.

The ItemColor message allows you to manage the background color of any cell or cells in a grid. When used inside the entry_display procedure, this message can be used to color items according to a field's value. The entry_display message is called every time a row is updated with information from the database. By using the value in the current record buffer, a set ItemColor statement, a get base_item statement (to ascertain the first cell in the current row), and a get item_limit statement (to ascertain the number of cells in a row), you can manage row and cell colors.

The background color of an item is determined by three states. An item may be the current item, an item may be an item within the current row, or an item may be a member of a non-current row. The precedence of color assignment is as follows:

1. CurrentCellColor overrides all other colors.
2. CurrentRowColor, if used (highlight_row_state is true), overrides non-current row color.
3. Non-current row uses ItemColor.

If you wish to use ItemColor to create custom row colors, you will probably wish to set the highlight_row_state property to false.

The following example, which could be added to a dbGrid or a dbList, shows how ItemColor could be used to set a custom color for a row and a cell.

// Changes the color of all items in the current row to RGB color 'iColor'
// This should be sent from Entry_Display as shown later...
Procedure Change_Row_Color Integer iColor
    Integer iBase iItem iItems

    Get Base_Item to iBase               // first item of current row
    Get Item_Limit to iItems              // items per row
    Move (iBase+iItems+1) to iItems     // last item in the current row

    For iItem from iBase to iItems         // set all items in row to color
        Set ItemColor iItem to iColor
    Loop
End_Procedure // Change_Row_Color

// Augmented in order to get the row, and possibly cell, highlighted
// with a specific color depending on its file-buffer values
Procedure Entry_Display Integer iFile Integer iType
    integer iColor iItem

    // set current row color based on value of extended price
    If (OrderDtl.Extended_Price < 0);
        Move clRed to iColor
    Else ;
        If (OrderDtl.Extended_Price = 0) ;
            Move clYellow to iColor
        Else ;
            Move clTeal   to iColor

    Send Change_Row_Color iColor

    // Set single cell (column 5) based on contents of qty_ordered
    If (OrderDtl.Qty_Ordered >= 10) Begin
        Get Base_Item to iItem // first item of the current row
        Set ItemColor (iItem +4) to clPurple // Fifth column
    End

    Forward Send Entry_Display iFile iType
End_Procedure // Entry_Display

The gridline_mode, which determines if horizontal and vertical lines should appear in the list can also be set with a registry setting. If you set the key TableGrid in the registry, you must use the values 0 through 3 (0=Grid_Visible_none, 1=Grid_Visible_Horz, 2=Grid_Visible_Vert, 3=Grid_Visible_Both).

Refer to the Grid class for more information on these properties.

The purpose of supporting unique settings for colors in dbGrids and dbLists (which have their own registry key values) is to provide a mechanism for distinguishing between selection lists (dbLists) and entry tables (dbGrids). DbGrid uses the standard grid and color provided with the grid class.

Placing Checkboxes in dbList Cells

A special method is provided for assigning checkboxes to data-dictionary-aware objects of this class. If the data-dictionary field is defined as a checkbox field, you may display the value as a checkbox by setting the column's column_checkbox_state to true. If the underlying field has an index associated with it, you will be able to sort and search by that column (as you would with any indexed column). Different checkbox bitmaps are displayed for enabled (indexed) and disabled (non-indexed) fields. All of this is automatic. The following example shows how this is used. Note that a width of 25 is good for checkboxes.

Object oSelList is a dbList
    Set Main_File to Progrmr.File_Number
    Set Size to 105 239
    Set Location to 6 6

    Begin_Row
        Entry_Item Progrmr.Resp_programmer
        Entry_Item Progrmr.Name
        Entry_Item Progrmr.Knows_oop
        Entry_Item Progrmr.Knows_procedrl
        Entry_Item Progrmr.Knows_c
    End_Row

    Set Form_Width    0 to 30
    Set Header_Label  0 to "ID"

    Set Form_Width    1 to 124
    Set Header_Label  1 to "Name"

    Set Form_Width    2 to 25
    Set Header_Label  2 to "OOP"

    Set Form_Width    3 to 25
    Set Header_Label  3 to "DF"

    Set Form_Width    4 to 25
    Set Header_Label  4 to "C"

    // Display columns 2, 3, and 4 are checkboxes.
    set Column_CheckBox_State 2 to True
    set Column_CheckBox_State 3 to True
    set Column_CheckBox_State 4 to True
End_Object    // oSelList

If you are not using data dictionaries, you can still use checkboxes by using the entry_display method described in the DataList class. You can also use the entry_display method to display checkboxes and other types of bitmaps based on other, more-complex data conditions.

Accelerator Keys

Name | Message Sent | Defining Class
kbegin_of_data | beginning_of_data | Menu
kcancel | cancel | WideList
kend_of_data | end_of_data | Menu
kenter | find_or_ok | dbList
kspace | toggle_select | Menu

Child Objects

element - prototype_entry

This component is forward referenced by the class and actually defined by the begin_row...end_row macros. It is used as a prototype for the items in a row of the list.

selected_items - set

This component holds the set of selected item identifiers for virtual lists. It is emptied by delete_data, and is also operated on by set select_state.

Last Edited: August 10, 2006


Properties for dbList

View property list in alphabetical order

Name | Description
Auto_Label_State | Determines if the column is assigned a header label from the data dictionary
Auto_Shadow_State | Determines if columns whose data file and field are not part of an index will be set to display-only or if they will be shadowed explicitly
Inherited Properties from dbListDS
Popup_Search_State | Determines if pressing a key will cause the search pop-up dialog to appear
Inherited Properties from dbList_
Auto_Column_State | Determines if the cursor is automatically located upon activation in the column for the main-file field in the popup selection list
Auto_Export_State | Determines if the invoking item should be updated relationally or non-relationally
Auto_Save_State | Returns zero to other DEOs, which send this message to this object
Auto_Server_State | Determines if the object will use the constraints in the invoking object's server DDO or its own DDO
Display_Buffer_Msg | Handle of an optional message that can be sent to the invoking object when a selection is complete
Export_Column | Determines which column's value is returned to invoking object
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational
Find_Search_State | Determines how list searching is performed
Invoking_Object_ID | Identifies the object which activated this object
Load_Buffer_Msg | Handle of optional message sent to invoking object during list activation
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent
Original_RowId |
Original_Selection | Identifies the item that was selected when this object was originally activated
Popup_State | (Obsolete)
Seed_List_State | Determines if the seed_list message is sent when this object is activated causing the display of list items to scroll automatically
Select_Count | Returns the value of the select_count of this object
Inherited Properties from DataList
Column_Button |
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to
Column_Option | Allows you to query or change the iOption option line for Column iCol
Column_Options | Allows you to copy column options or set them in a group
Column_Prompt_Object | Specifies the default receiving object for the popup message
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object
CustomScrollState | Determines changing scroll bar behaviors
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction
psEmbeddedButtonValue |
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior
Inherited Properties from DataList_
Auto_index_state | Determines how the popup lists will be ordered
Batch_State | Determines how much data from the database is read into memory
Current_Record | (Obsolete) The number of the record of the current row
CurrentRecordStatus |
CurrentRowHasRecord |
CurrentRowId |
Init_from_Top_State | Determines in what order images are displayed
Initial_Column | Determines where the cursor is located when the list is activated
Initial_Row | Governs the location in the display of the record (if any) in the buffer
Main_File | Holds the file number of the main file of the list
No_Relate_State | Determines if relates occur with lists that do not use DDOs
Ordering | Holds the index of the main file to be used to display the database records of the main file
pbReverseOrdering | Determines if the list should be displayed in reverse index order
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own
Prototype_Object | Returns the object-id of the internal object
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object
Record_Number | (Obsolete) Indicates the record number for the record in the specified row
record_rowId |
RecordStatus |
RowHasRecord |
Static_State | Determines if the list will only be initialized once the first time this object is activated
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbList

View event list in alphabetical order

Name | Description
Inherited Events from dbList_
Export_Item | Sets the value of the item from which this object was invoked to the value in the selected row of this object that is in the column indicated by the value of the export_column property
Restore_Defaults | Restores the previous values of the properties listed below after they have been stored before this object was popped up with the prompt_callback message and then deactivated
Store_Defaults | Stores the existing values of the properties listed below so that they can be restored after this object is popped up with the prompt_callback message and then deactivated
Inherited Events from DataList
Header_Mouse_Click |
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view
onInitSpin |
Inherited Events from DataList_
OnNewOrdering | Called whenever the ordering is changed
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from WideList_
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbList

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbListDS
Request_Search | Procedure | Scrolls the search list to display the database value found for the search string entered up to that point
Inherited Methods from dbList_
Cancel | Procedure | Deactivates this object and its scope, if any
Find_or_Ok | Procedure | Determines whether the value in the item window has been changed, or remains as retrieved from the database
first_selected_item | Function | Returns the first selected item
FirstSelectedRowId | Function | Returns the first selected RowId
Init_Selected_Item | Procedure | Sets enumeration_counter to zero
next_selected_Item | Function | Returns the next selected item
NextSelectedRowId | Function | Returns the next selected RowId
Ok | Procedure | Oks a list selection
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any
Request_Lookup | Procedure | Enables you to program special finding behaviors for items for which you desire such
Select_Best_Column | Function | Returns the number of the column of this object that is best for the file_number and field_number of the invoking-object item
Toggle_Select | Procedure | Sets select_state of current item to toggle_state, i.e., sets select_state of current item to true if it is currently false, and vice-versa
Inherited Methods from DataList
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm
Inherited Methods from DataList_
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful
Clear_Current_Record | Procedure |
Col_Index | Function | Returns the number of the main index for the field connected to Column Item#
Display | Procedure |
DoCheckDisplayableRows | Procedure |
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList
DoToggleColumnOrdering | Procedure |
End_of_Data | Procedure | Finds the last record in the main_file of this object, and displays a new list page ending with that record if the find was successful
Establish_Find_Mode | Procedure |
File_Record | Function | (Obsolete)
FileRecord | Function |
FileRowId | Function |
Fill_List | Procedure |
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer
Find_Init | Procedure |
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object
find_RowId | Procedure |
Goto_Bottom_Row | Procedure |
Goto_Top_Row | Procedure |
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in
Read_By_Recnum | Procedure | (Obsolete)
Read_Next_Record | Procedure |
ReadByRowId | Procedure |
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col#
Reorder_list | Procedure | Permits manual reordering of the contents of the data list
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own
Up_Row | Procedure |
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbList_

Class: dbList_ (Abstract)

Properties Events Methods Index of Classes

Abstract class enabling users to select one or more values from a list of choices

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------DataList_
------------------------------------------DataList
---------------------------------------------dbList_
------------------------------------------------dbListDS

Library: Windows Application Class Library

Package: Dfsellst.pkg

Mixins: Selection_List_ds_mixin LIST_Mixin Auto_Locate_Mixin

Description

dbList_ is used to enable users to select one or more values from a list of choices. Its sub-class dbList should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbList_

View property list in alphabetical order

Name | Description
Auto_Column_State | Determines if the cursor is automatically located upon activation in the column for the main-file field in the popup selection list
Auto_Export_State | Determines if the invoking item should be updated relationally or non-relationally
Auto_Save_State | Returns zero to other DEOs, which send this message to this object
Auto_Server_State | Determines if the object will use the constraints in the invoking object's server DDO or its own DDO
Display_Buffer_Msg | Handle of an optional message that can be sent to the invoking object when a selection is complete
Export_Column | Determines which column's value is returned to invoking object
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational
Find_Search_State | Determines how list searching is performed
Invoking_Object_ID | Identifies the object which activated this object
Load_Buffer_Msg | Handle of optional message sent to invoking object during list activation
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent
Original_RowId |
Original_Selection | Identifies the item that was selected when this object was originally activated
Popup_State | (Obsolete)
Seed_List_State | Determines if the seed_list message is sent when this object is activated causing the display of list items to scroll automatically
Select_Count | Returns the value of the select_count of this object
Inherited Properties from DataList
Column_Button |
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to
Column_Option | Allows you to query or change the iOption option line for Column iCol
Column_Options | Allows you to copy column options or set them in a group
Column_Prompt_Object | Specifies the default receiving object for the popup message
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object
CustomScrollState | Determines changing scroll bar behaviors
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction
psEmbeddedButtonValue |
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior
Inherited Properties from DataList_
Auto_index_state | Determines how the popup lists will be ordered
Batch_State | Determines how much data from the database is read into memory
Current_Record | (Obsolete) The number of the record of the current row
CurrentRecordStatus |
CurrentRowHasRecord |
CurrentRowId |
Init_from_Top_State | Determines in what order images are displayed
Initial_Column | Determines where the cursor is located when the list is activated
Initial_Row | Governs the location in the display of the record (if any) in the buffer
Main_File | Holds the file number of the main file of the list
No_Relate_State | Determines if relates occur with lists that do not use DDOs
Ordering | Holds the index of the main file to be used to display the database records of the main file
pbReverseOrdering | Determines if the list should be displayed in reverse index order
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own
Prototype_Object | Returns the object-id of the internal object
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object
Record_Number | (Obsolete) Indicates the record number for the record in the specified row
record_rowId |
RecordStatus |
RowHasRecord |
Static_State | Determines if the list will only be initialized once the first time this object is activated
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbList_

View event list in alphabetical order

Name | Description
Export_Item | Sets the value of the item from which this object was invoked to the value in the selected row of this object that is in the column indicated by the value of the export_column property
Restore_Defaults | Restores the previous values of the properties listed below after they have been stored before this object was popped up with the prompt_callback message and then deactivated
Store_Defaults | Stores the existing values of the properties listed below so that they can be restored after this object is popped up with the prompt_callback message and then deactivated
Inherited Events from DataList
Header_Mouse_Click |
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view
onInitSpin |
Inherited Events from DataList_
OnNewOrdering | Called whenever the ordering is changed
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from WideList_
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbList_

View method list in alphabetical order

Name | Type | Description
Cancel | Procedure | Deactivates this object and its scope, if any
Find_or_Ok | Procedure | Determines whether the value in the item window has been changed, or remains as retrieved from the database
first_selected_item | Function | Returns the first selected item
FirstSelectedRowId | Function | Returns the first selected RowId
Init_Selected_Item | Procedure | Sets enumeration_counter to zero
next_selected_Item | Function | Returns the next selected item
NextSelectedRowId | Function | Returns the next selected RowId
Ok | Procedure | Oks a list selection
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any
Request_Lookup | Procedure | Enables you to program special finding behaviors for items for which you desire such
Select_Best_Column | Function | Returns the number of the column of this object that is best for the file_number and field_number of the invoking-object item
Toggle_Select | Procedure | Sets select_state of current item to toggle_state, i.e., sets select_state of current item to true if it is currently false, and vice-versa
Inherited Methods from DataList
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm
Inherited Methods from DataList_
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful
Clear_Current_Record | Procedure |
Col_Index | Function | Returns the number of the main index for the field connected to Column Item#
Display | Procedure |
DoCheckDisplayableRows | Procedure |
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList
DoToggleColumnOrdering | Procedure |
End_of_Data | Procedure | Finds the last record in the main_file of this object, and displays a new list page ending with that record if the find was successful
Establish_Find_Mode | Procedure |
File_Record | Function | (Obsolete)
FileRecord | Function |
FileRowId | Function |
Fill_List | Procedure |
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer
Find_Init | Procedure |
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object
find_RowId | Procedure |
Goto_Bottom_Row | Procedure |
Goto_Top_Row | Procedure |
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in
Read_By_Recnum | Procedure | (Obsolete)
Read_Next_Record | Procedure |
ReadByRowId | Procedure |
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col#
Reorder_list | Procedure | Permits manual reordering of the contents of the data list
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own
Up_Row | Procedure |
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbListDS

Class: dbListDS (Abstract)

Properties Events Methods Index of Classes

Abstract class enabling users to select one or more values from a list of choices

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------DataList_
------------------------------------------DataList
---------------------------------------------dbList_
------------------------------------------------dbListDS
---------------------------------------------------dbList

Library: Windows Application Class Library

Package: Dfsellst.pkg

Description

dbListDS is used to enable users to select one or more values from a list of choices. Its sub-class dbList should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbListDS

View property list in alphabetical order

Name | Description
Popup_Search_State | Determines if pressing a key will cause the search pop-up dialog to appear
Inherited Properties from dbList_
Auto_Column_State | Determines if the cursor is automatically located upon activation in the column for the main-file field in the popup selection list
Auto_Export_State | Determines if the invoking item should be updated relationally or non-relationally
Auto_Save_State | Returns zero to other DEOs, which send this message to this object
Auto_Server_State | Determines if the object will use the constraints in the invoking object's server DDO or its own DDO
Display_Buffer_Msg | Handle of an optional message that can be sent to the invoking object when a selection is complete
Export_Column | Determines which column's value is returned to invoking object
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational
Find_Search_State | Determines how list searching is performed
Invoking_Object_ID | Identifies the object which activated this object
Load_Buffer_Msg | Handle of optional message sent to invoking object during list activation
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent
Original_RowId |
Original_Selection | Identifies the item that was selected when this object was originally activated
Popup_State | (Obsolete)
Seed_List_State | Determines if the seed_list message is sent when this object is activated causing the display of list items to scroll automatically
Select_Count | Returns the value of the select_count of this object
Inherited Properties from DataList
Column_Button |
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to
Column_Option | Allows you to query or change the iOption option line for Column iCol
Column_Options | Allows you to copy column options or set them in a group
Column_Prompt_Object | Specifies the default receiving object for the popup message
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object
CustomScrollState | Determines changing scroll bar behaviors
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction
psEmbeddedButtonValue |
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior
Inherited Properties from DataList_
Auto_index_state | Determines how the popup lists will be ordered
Batch_State | Determines how much data from the database is read into memory
Current_Record | (Obsolete) The number of the record of the current row
CurrentRecordStatus |
CurrentRowHasRecord |
CurrentRowId |
Init_from_Top_State | Determines in what order images are displayed
Initial_Column | Determines where the cursor is located when the list is activated
Initial_Row | Governs the location in the display of the record (if any) in the buffer
Main_File | Holds the file number of the main file of the list
No_Relate_State | Determines if relates occur with lists that do not use DDOs
Ordering | Holds the index of the main file to be used to display the database records of the main file
pbReverseOrdering | Determines if the list should be displayed in reverse index order
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own
Prototype_Object | Returns the object-id of the internal object
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object
Record_Number | (Obsolete) Indicates the record number for the record in the specified row
record_rowId |
RecordStatus |
RowHasRecord |
Static_State | Determines if the list will only be initialized once the first time this object is activated
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbListDS

View event list in alphabetical order

Name | Description
Inherited Events from dbList_
Export_Item | Sets the value of the item from which this object was invoked to the value in the selected row of this object that is in the column indicated by the value of the export_column property
Restore_Defaults | Restores the previous values of the properties listed below after they have been stored before this object was popped up with the prompt_callback message and then deactivated
Store_Defaults | Stores the existing values of the properties listed below so that they can be restored after this object is popped up with the prompt_callback message and then deactivated
Inherited Events from DataList
Header_Mouse_Click |
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view
onInitSpin |
Inherited Events from DataList_
OnNewOrdering | Called whenever the ordering is changed
Refresh | Displays items from some files at the same time as clearing items from other files
Inherited Events from WideList_
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbListDS

View method list in alphabetical order

Name | Type | Description
Request_Search | Procedure | Scrolls the search list to display the database value found for the search string entered up to that point
Inherited Methods from dbList_
Cancel | Procedure | Deactivates this object and its scope, if any
Find_or_Ok | Procedure | Determines whether the value in the item window has been changed, or remains as retrieved from the database
first_selected_item | Function | Returns the first selected item
FirstSelectedRowId | Function | Returns the first selected RowId
Init_Selected_Item | Procedure | Sets enumeration_counter to zero
next_selected_Item | Function | Returns the next selected item
NextSelectedRowId | Function | Returns the next selected RowId
Ok | Procedure | Oks a list selection
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any
Request_Lookup | Procedure | Enables you to program special finding behaviors for items for which you desire such
Select_Best_Column | Function | Returns the number of the column of this object that is best for the file_number and field_number of the invoking-object item
Toggle_Select | Procedure | Sets select_state of current item to toggle_state, i.e., sets select_state of current item to true if it is currently false, and vice-versa
Inherited Methods from DataList
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm
Inherited Methods from DataList_
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful
Clear_Current_Record | Procedure |
Col_Index | Function | Returns the number of the main index for the field connected to Column Item#
Display | Procedure |
DoCheckDisplayableRows | Procedure |
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList
DoToggleColumnOrdering | Procedure |
End_of_Data | Procedure | Finds the last record in the main_file of this object, and displays a new list page ending with that record if the find was successful
Establish_Find_Mode | Procedure |
File_Record | Function | (Obsolete)
FileRecord | Function |
FileRowId | Function |
Fill_List | Procedure |
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer
Find_Init | Procedure |
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object
find_RowId | Procedure |
Goto_Bottom_Row | Procedure |
Goto_Top_Row | Procedure |
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in
Read_By_Recnum | Procedure | (Obsolete)
Read_Next_Record | Procedure |
ReadByRowId | Procedure |
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col#
Reorder_list | Procedure | Permits manual reordering of the contents of the data list
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own
Up_Row | Procedure |
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbModalPanel

Properties Events Methods Index of Classes

Provides a modal container for selection lists (dblist) and other DEOs

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------dbFloatingPanel_
---------------------------------dbFloatingPanel
------------------------------------dbViewFloatingPanel
---------------------------------------dbModalPanel
------------------------------------------ValidationList

Library: Windows Application Class Library

Package: DFClient.pkg

Description

dbModalPanel is used to provide a modal container for selection lists (dblist) and other DEOs. Optional support is provided for resizable buttons and resizable lists.

Sample

Object MyModal IS A dbModalPanel
    Set Size  to 138 297
    Set Label to "My Modal Panel"
    :
End_object

Object Customer_sl IS A dbModalPanel
    Set Size  to 138 297
    Set Label to 'Customer List'

    Object sl IS A dbList
        :
    End_object

    Set List_Object to (Sl(self))
    Send Add_Button "OK"            MSG_Ok
    Send Add_Button "Cancel"        MSG_Cancel
End_object

Syntax

Use dfallent

Object object_name is a dbModalPanel
    set size to height width
    set locate_mode to LocateMode
    set label to title
    :
    : Create DEO objects (e.g., dblist)
    :
    set List_object to (listObject(self))
    send Add_Button ButtonText Button_Message
:
End_Object

Of Special Note

This can be used anytime a DEO-based modal panel is required. Refer to ModalPanel for information about modal panels. Most-often dbModalPanels will be used to create popup selection lists. In such a case, the panel will contain a selection list (dbList) and several buttons.

Automatic Buttons

This will create buttons at the bottom of the container that are of equal size and equally spaced. If the list is resized, the buttons are re-spaced and the list is resized to fit properly within the new bounds. To use the auto-button feature you must identify the object ID of your dblist object. Buttons are added by sending the Add_Button message.

Last Edited: December 20, 2005


Properties for dbModalPanel

View property list in alphabetical order

Name | Description
button_height | (Obsolete)
button_width | (Obsolete)
List_Object | (Obsolete)
Inherited Properties from dbViewFloatingPanel
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to
Auto_Top_Item_State |
Auto_top_view_State |
DEO_Attach_All_State |
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function
priInitialRowId |
View_Latch_State | Determines if the view's DSO structure will be initialized with the data
Inherited Properties from dbFloatingPanel
DEO_Object |
Inherited Properties from dbFloatingPanel_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbModalPanel

View event list in alphabetical order

Name | Description
Inherited Events from dbViewFloatingPanel
Closing_View |
Opening_View |
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbModalPanel

View method list in alphabetical order

Name | Type | Description
Add_Button | Procedure | (Obsolete)
Search | Procedure | (Obsolete)
Inherited Methods from dbViewFloatingPanel
Exit_Application_Check | Function |
Inherited Methods from dbFloatingPanel
Close_Panel | Procedure | Closes the panel or component currently open
Inherited Methods from dbFloatingPanel_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbRadioContainer

Properties Events Methods Index of Classes

Provides all of the functionality of a dbRadioGroup within an invisible container

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseGroup
---------------------Group
------------------------RadioGroup
---------------------------dbRadioGroupDS
------------------------------dbRadioGroup
---------------------------------dbRadioContainer

Library: Windows Application Class Library

Package: Dfenrad.pkg

Mixins: NonVisual_Container_Mixin

Description

dbRadioContainer is used to provide all of the functionality of a dbRadioGroup within an invisible container. This is used to create more-complicated visual interfaces where non-radio objects appear to be mixed with radio objects.

Sample

Object Status is a dbRadioContainer
    entry_item Customer.Status

    object r1 is a Radio
        set location to 10 10 // label provided by DD
    end_object

    object r2 is a Radio
        set location to 25 10
    end_object

    object r3 is a Radio
        set location to 40 10
    end_object

end_object

Syntax

// when used with a Data-dictionary
object object_name is a dbRadioContainer
    entry_item file.field

    object radio_name is a Radio
        Set Location to vertical horizontal
    End_Object

    object radio_name is a Radio
        Set Location to vertical horizontal
    End_Object
    :
End_Object

// when used with a Data-Set
object object_name is a dbRadioContainer
    entry_item file.field
    Set Status_Help to StatusHelpText

    object radio_name is a Radio
        Set Location to vertical horizontal
    End_Object

    object radio_name is a Radio
        Set Location to vertical horizontal
    End_Object
    :
    Procedure Fill_List
        Send Add_radio_item Description DataValue

        Send Add_radio_item Description DataValue
        :
    End_Object

End_Object

Of Special Note

The dbRadioContainer class is a subclass of the dbRadioGroup class and inherits all of its attributes. Since this is a non-visual grouping class, all visual properties (size, location, label, etc.) are effectively cancelled. Because the object is non-visual, the child radio objects will be located relative to this object's parent container.

This class is used when you need to appear to mix radio and non-radio objects within the same group. This is not permitted with radio-group objects, which may only contain radio objects. This can be simulated by placing the dbRadioContainer and the other non-radio objects within a non-radio container like a dbGroup.

This class will rarely be needed. You are encouraged to use the visual dbRadioGroup whenever possible.

Last Edited: July 25, 2003


Properties for dbRadioContainer

View property list in alphabetical order

Name | Description
Inherited Properties from dbRadioGroup
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
Inherited Properties from dbRadioGroupDS
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Code_Display_Mode | Specifies whether the radio object's label will display the choices' codes, descriptions, or both
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Default_Value |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Item_Changed_State |
Item_Entry_Msg |
Item_Exit_Msg |
Item_Validate_Msg |
object_item_entry_exit |
Object_Validation |
Prompt_Object |
Select_State |
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State |
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Zoom_Object |
Inherited Properties from RadioGroup
Changed_State | Gets or sets the changed_state for the entire radio group
Current_Radio | Makes Item item_num the "selected" radio object
Current_Radio_Object | Similar to Current_Radio except that it operates with object IDs instead of item IDs
Radio_Count | Returns the number of radio objects within this object
Radio_Value | Gets and sets the label of a child radio object
Inherited Properties from Group
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbRadioContainer

View event list in alphabetical order

Name | Description
Inherited Events from dbRadioGroup
Item_Change |
Inherited Events from dbRadioGroupDS
Entry_Defaults |
Fill_List |
OnRadioGroupEntering |
OnRadioGroupExiting |
Inherited Events from RadioGroup
Notify_Select_State | Sent to notify the group that the current radio item has changed
Inherited Events from Group
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbRadioContainer

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbRadioGroupDS
Add_Radio_Item | Procedure |
exec_entry | Function | Invokes the item_entry_msg of the specified item number, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item number, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item number, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Prompt | Procedure | Sends the Popup message to the prompt_object property ID
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Find | Procedure |
Request_Superfind | Procedure |
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Sends the Popup message to the zoom_object property ID
Inherited Methods from RadioGroup
Radio_Object | Function | Returns the handle of a radio object for a passed radio item
Radio_Object_Item | Function | Returns the index (Item number) for a passed a radio object handle
Inherited Methods from Group
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbRadioGroup

Properties Events Methods Index of Classes

Groups multiple radio objects in a visible object, providing selection of no more than one at a time

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseGroup
---------------------Group
------------------------RadioGroup
---------------------------dbRadioGroupDS
------------------------------dbRadioGroup
---------------------------------dbRadioContainer

Library: Windows Application Class Library

Package: Dfenrad.pkg

Mixins: Extended_DEO_Mixin Extended_DEO_Status_Help_Mixin Extended_DEO_Radio_mixin

Description

dbRadioGroup is used to group multiple radio objects in a visible object, providing selection of no more than one at a time. The group represents the value of a single data-entry element. Each Radio object within the group represents a possible value for that data item.

Sample

Object Status is a dbRadioGroup
    Set Size     to 60 100
    Set Location to 10 50
    entry_item Customer.Status
    Set Label    to "Customer Status"

    object r1 is a Radio
        set location to 10 10 // label provided by DD
    end_object

    object r2 is a Radio
        set location to 25 10
    end_object

    object r3 is a Radio
        set location to 40 10
    end_object

End_Object

Syntax

use dfbase

// when used with a DataDictionary:
object object_name is a dbRadioGroup
    Set Location to vertical horizontal
    Set Size to height width
    entry_item file.field
    set Auto_Label_State to true | false
    Set Label to "text"
    Get/Set Changed_State

    Object oRadioObjectID is a Radio
        Set Location to vertical horizontal
    End_Object
    :
    Object oRadioObjectID is a Radio
        Set Location to vertical horizontal
    End_Object

End_Object

// when used with a DataSet:
object object_name is a dbRadioGroup
    Set Location to vertical horizontal
    Set Size to height width
    entry_item file.field
    Set Label to text
    Set Status_Help to StatusHelpText

    Object oRadioName is a Radio
        Set Location to vertical horizontal
    End_Object

    Object oRadioName is a Radio
        Set Location to vertical horizontal
    End_Object
    :
    Procedure Fill_List
        Send Add_Radio_Item Description DataValue
        Send Add_Radio_Item Description DataValue
        :
    End_Procedure

End_Object

Of Special Note

This class is a subclass of RadioGroup and inherits all of its behaviors and attributes.

An object of this class is associated with a single data element, which is assigned with the entry_item command. Each radio object within this object represents a valid value for the entry item. Each valid choice is defined with a data value (the value that is read and written to the database) and a description (the text value that is displayed with the radio object). These values are supplied automatically by the data dictionary, or they must defined within the object by the fill_list procedure.

Radio child Objects

The radio objects within this object are very simple. Normally, you only set their location. All other information is provided by this object. It is important that you create a radio object for each data value option (whether supplied by the data dictionary or through fill_list).

Note that an object of this class will contain objects based on the Radio class (there is no dbRadio class).

Data-entry Object

An object of this class is a data-entry object (DEO). A DEO is an object (in this case a RadioGroup) whose native capabilities are augmented with data-aware behaviors. These behaviors include:

  • Finding, clearing, saving, and deleting of records (and sets of records)
  • Prompt- and zoom-object support
  • Change verification (save, delete, and data-loss verifications)
  • Object and item entering, exiting, and validation
  • Server support: DEOs connect to data-server structures

These data-aware "skills" are added to all DEO classes through a series of mix-in classes. The messages are listed here but documented in the mix-in classes. You are encouraged to study the documentation of the mix-in classes. Information provided in these classes may be applied to all DEO classes (all db... classes). Those classes are: Nesting_Mixin, Navigate_Mixin, Verify_Mixin, Server_Mixin, Find_Edit_Mixin, Entry_Item_Mixin, DEO_Delegate_Mixin, Validate_Mixin and Clear_Defaults_Mixin.

Suitability of Radios for Data Entry

Radio objects are of limited use within data-entry views. They are static. You must know how many choices are available for an entry item and you must create a Radio object for each choice. If you add or remove a choice, you must redesign your screen to add or remove a Radio object. The dbComboForm represents a more-flexible method of presenting choices. In addition, groups of radio objects take up a relatively large amount of screen space. If a radio consists of only two choices, a dbCheckBox can more-effectively be used. If more than two choices are supported, a dbComboForm is more space-efficient.

For the above reasons, data-aware radio objects should be used judiciously.

Use with Data Dictionaries

Objects of this class are designed to be used most-effectively with a dataDictionary. This object is assigned to a data file and field with this object's entry_item statement. The data dictionary will automatically provide a label for each child radio object and handle the interface between the data dictionary and this object, provided that you provide a validation table for the field in the data dictionary that lists every valid value. It will also provide status help for this group. When designing your radio group, you must know how many items will be supplied by the data dictionary and create a child radio object for each item.

Changing a Radio's Description

When using Radios with data dictionaries, each radio object's description is provided by the data dictionary. The label provided by the data dictionary or provided through fill_list will override any label you directly set in the radio object. If you wish to alter or override this label provided from the data dictionary, you have several choices:

  • The dbRadioGroup's property Code_Display_Mode can be set to display the description (default), the code, or the code and the description.

Set Code_Display_Mode to CD_Display_Code

  • You can augment the function Code_Description_Value. This is passed the description value and the data value and returns the display value.

Function Code_description_value string DescVal string DataVal returns string
    string sDisplayVal
    Move (DataVal - ":" * Uppercase(DescVal)) to sDisplayVal
    Function_Return sDisplayVal
End_Function

  • You can directly set the label within the radio objects and cancel the RadioGroup message set radio_value.

Procedure Set Radio_Value integer item# string Val
End_Procedure

Object R1 is a radio
    set Location to 10 10
    set Label to "Custom"
End_Object

Use with Data Sets

If you are using DataSets instead of DataDictionarys, you will need to define the radio labels manually. This is done by defining a procedure by the name of Fill_list. Within this procedure, you create the radios with values by sending the Add_radio_Item message passing the description value (the value that appears next to the radio item) and the data value (the value that is read and written to the database). Here is an example that uses add_radio_item:

Object Status is a dbRadioGroup
    Set Size     to 60 100
    Set Location to 10 50
    entry_item Customer.Status
    Set Label    to "Customer Status"
    Set Status_Help to "Customer's Current Status"

    object r1 is a Radio
        set location to 10 10
    end_object

    object r2 is a Radio
        set location to 25 10
    end_object

    object r3 is a Radio
        set location to 40 10
    end_object

    // If we do not have a DD to supply the radio values, we must
    // do this manually.
    Procedure Fill_List
        send Add_Radio_Item "New"      "N"
        send Add_Radio_Item "Current"  "C"
        send Add_Radio_Item "Old"      "O"
    End_Procedure

End_Object

Last Edited: November 21, 2004


Properties for dbRadioGroup

View property list in alphabetical order

Name | Description
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
Inherited Properties from dbRadioGroupDS
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Code_Display_Mode | Specifies whether the radio object's label will display the choices' codes, descriptions, or both
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Default_Value |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Item_Changed_State |
Item_Entry_Msg |
Item_Exit_Msg |
Item_Validate_Msg |
object_item_entry_exit |
Object_Validation |
Prompt_Object |
Select_State |
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State |
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Zoom_Object |
Inherited Properties from RadioGroup
Changed_State | Gets or sets the changed_state for the entire radio group
Current_Radio | Makes Item item_num the "selected" radio object
Current_Radio_Object | Similar to Current_Radio except that it operates with object IDs instead of item IDs
Radio_Count | Returns the number of radio objects within this object
Radio_Value | Gets and sets the label of a child radio object
Inherited Properties from Group
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbRadioGroup

View event list in alphabetical order

Name | Description
Item_Change |
Inherited Events from dbRadioGroupDS
Entry_Defaults |
Fill_List |
OnRadioGroupEntering |
OnRadioGroupExiting |
Inherited Events from RadioGroup
Notify_Select_State | Sent to notify the group that the current radio item has changed
Inherited Events from Group
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbRadioGroup

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbRadioGroupDS
Add_Radio_Item | Procedure |
exec_entry | Function | Invokes the item_entry_msg of the specified item number, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item number, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item number, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Prompt | Procedure | Sends the Popup message to the prompt_object property ID
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Find | Procedure |
Request_Superfind | Procedure |
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Sends the Popup message to the zoom_object property ID
Inherited Methods from RadioGroup
Radio_Object | Function | Returns the handle of a radio object for a passed radio item
Radio_Object_Item | Function | Returns the index (Item number) for a passed a radio object handle
Inherited Methods from Group
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbRadioGroupDS

Class: dbRadioGroupDS (Abstract)

Properties Events Methods Index of Classes

Abstract class that groups multiple radio objects in a visible object, providing selection of no more than one at a time

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseGroup
---------------------Group
------------------------RadioGroup
---------------------------dbRadioGroupDS
------------------------------dbRadioGroup

Library: Windows Application Class Library

Package: Dfenrad.pkg

Mixins: DFEntry_Radio_Group_Mixin Nesting_Mixin Navigate_Mixin Server_Mixin Verify_Mixin Find_Edit_Mixin

Description

dbRadioGroupDS is used to group multiple radio objects in a visible object, providing selection of no more than one at a time. Its sub-classes dbRadioGroup and dbRadioContainer should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbRadioGroupDS

View property list in alphabetical order

Name | Description
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Code_Display_Mode | Specifies whether the radio object's label will display the choices' codes, descriptions, or both
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Default_Value |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Item_Changed_State |
Item_Entry_Msg |
Item_Exit_Msg |
Item_Validate_Msg |
object_item_entry_exit |
Object_Validation |
Prompt_Object |
Select_State |
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State |
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Zoom_Object |
Inherited Properties from RadioGroup
Changed_State | Gets or sets the changed_state for the entire radio group
Current_Radio | Makes Item item_num the "selected" radio object
Current_Radio_Object | Similar to Current_Radio except that it operates with object IDs instead of item IDs
Radio_Count | Returns the number of radio objects within this object
Radio_Value | Gets and sets the label of a child radio object
Inherited Properties from Group
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbRadioGroupDS

View event list in alphabetical order

Name | Description
Entry_Defaults |
Fill_List |
OnRadioGroupEntering |
OnRadioGroupExiting |
Inherited Events from RadioGroup
Notify_Select_State | Sent to notify the group that the current radio item has changed
Inherited Events from Group
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbRadioGroupDS

View method list in alphabetical order

Name | Type | Description
Add_Radio_Item | Procedure |
exec_entry | Function | Invokes the item_entry_msg of the specified item number, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item number, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item number, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Prompt | Procedure | Sends the Popup message to the prompt_object property ID
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Find | Procedure |
Request_Superfind | Procedure |
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Sends the Popup message to the zoom_object property ID
Inherited Methods from RadioGroup
Radio_Object | Function | Returns the handle of a radio object for a passed radio item
Radio_Object_Item | Function | Returns the index (Item number) for a passed a radio object handle
Inherited Methods from Group
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbSpinForm

Properties Events Methods Index of Classes

Provides an entry form that users can edit that contains an integer or date that can be driven through a range with buttons

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------Entry
------------------------------dbForm_
---------------------------------dbFormDS
------------------------------------dbSpinFormDS
---------------------------------------dbSpinForm

Library: Windows Application Class Library

Package: Dfspnent.pkg

Mixins: Extended_DEO_Mixin Extended_DEO_Status_Help_Mixin Extended_DEO_Spin_Mixin

Description

dbSpinForm is used to provide an entry form that users can edit that contains an integer or date that can be driven through a range with buttons. The value can be manually changed by users in the entry form and the spin buttons will pick up the modified value, and resume spinning from that value.

Sample

Object MyForm is a DbSpinForm
    Set Size to 13 100
    Set location to 15 70
    Entry_Item Customer.Discount
    Set Label to "Discount:"
End_Object

Object MyDate is a DbSpinForm
    Set Size to 13 100
    Set location to 15 70
    Entry_Item OrderHea.Date
    Set Label to "Order Date:"
End_Object

Syntax

use dfentry

// when data field is connected to a Data-Dictionary object
object object_name is a dbSpinForm
    Set Size to height width
    Set location to Row Column
    entry_item file.field
    Set wrap_state to true|false

    set auto_label_state to true| false
    Set Label to text
    Set Label_Justification_Mode to mode
    Set Label_row_Offset to Num
    Set Label_Col_Offset to Num
    Set enabled_state to true|false

    Procedure onChange
        :
    End_Procedure

    Procedure onSetFocus
        :
    End_Procedure

    Procedure onKillFocus
        :
    End_Procedure

End_object

When connected to data-set objects or using a variable:

Object oObjectName is a dbSpinForm
    Set Size to height width
    Set Location to row column

    entry_item {file.field | variable}

    Set Wrap_State to true|false
    Set Maximum_Position to MaxValue
    Set Minimum_Position to MinValue

    Set Label to text
    Set Label_Justification_Mode to mode
    Set Label_Row_Offset to Num
    Set Label_Col_Offset to Num

    Set Form_DataType 0 to mode
    Set Form_Margin 0 to mode
    Set Form_Mask 0 to maskstring
    Set Numeric_Mask 0 to leftDigits rightDigits {template}
    Set Currency_Mask 0 to leftDigits rightDigits {template}

    Set Enabled_State to true|false
    Set Status_Help to text

    Procedure onChange
        :
    End_Procedure

    Procedure onSetFocus
        :
    End_Procedure

    Procedure onKillFocus
        :
    End_Procedure
End_Object

Of Special Note

DbSpinForm is a subclass of dbForm and inherits all of its behaviors. Refer to dbForm for information on the basic usage of this class.

The range of a spinner is set with the minimum_position and maximum_position properties. When using the dbSpinForm with a data-dictionary object, these ranges can be determined automatically.

The spin button will appear as an integrated part of your form - it appears inside the form and is right justified.

Spin buttons are capable of a maximum range of 32K, within the range ñ32K. Both numbers and dates are automatically supported with this object. String values may also be supported, but will require the augmentation of the get and set spin_value messages to make this conversion.

Last Edited: November 21, 2004


Properties for dbSpinForm

View property list in alphabetical order

Name | Description
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
Inherited Properties from dbSpinFormDS
Current_Position | Contains the current position of the spin button
Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to
Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to
Spin_Value | Called anytime the spin button needs to synchronize its value with the form value
Wrap_State | Determines whether the spin button will wrap
Inherited Properties from dbFormDS
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Inherited Properties from dbForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Entry
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbSpinForm

View event list in alphabetical order

Name | Description
Inherited Events from dbForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from Entry
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbSpinForm

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbSpinFormDS
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
Inherited Methods from dbFormDS
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Request_Save | Procedure |
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from Entry
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbSpinFormDS

Class: dbSpinFormDS (Abstract)

Properties Events Methods Index of Classes

Abstract class that provides an entry form that users can edit that contains an integer or date that can be driven through a range with buttons

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------Entry
------------------------------dbForm_
---------------------------------dbFormDS
------------------------------------dbSpinFormDS
---------------------------------------dbSpinForm

Library: Windows Application Class Library

Package: Dfspnent.pkg

Mixins: SpinForm_Mixin

Description

dbSpinFormDS is used to provide an entry form that users can edit that contains an integer or date that can be driven through a range with buttons. Its sub-class dbSpinForm should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbSpinFormDS

View property list in alphabetical order

Name | Description
Current_Position | Contains the current position of the spin button
Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to
Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to
Spin_Value | Called anytime the spin button needs to synchronize its value with the form value
Wrap_State | Determines whether the spin button will wrap
Inherited Properties from dbFormDS
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Inherited Properties from dbForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Entry
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbSpinFormDS

View event list in alphabetical order

Name | Description
Inherited Events from dbForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from Entry
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbSpinFormDS

View method list in alphabetical order

Name | Type | Description
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
Inherited Methods from dbFormDS
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Request_Save | Procedure |
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from Entry
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbTabDialog

Properties Events Methods Index of Classes

Contains and provides coordinated access to dbTabPage objects

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBasetabDialog
---------------------------TabDialog_
------------------------------TabDialog
---------------------------------dbTabDialog_
------------------------------------dbTabDialog
---------------------------------------dbTabDialogView

Library: Windows Application Class Library

Package: Dftabdlg.pkg

Mixins: DFNavigate_Mixin

Description

dbTabDialog is used to contain and provide coordinated access to dbTabPage objects. Each tab page displays a tab with its name on it within this object at all times.

The dbTabDialogView class is a class similar to the dbTabDialog class, but it is used to contain and provide coordinated access to dbTabView objects, each of which supports a separate DataDictionary object (DDO) structure. The dbTabDialog class supports only one DDO structure for the entire dialog.

Sample

Object TabDialog1 is dbTabDialog
    Set Size to 117 271
    Set Location to 10 15

    Object TabPage1 is a dbTabPage
        Set Label to "TabPage1"
        :
    End_Object    // TabPage1

    Object TabPage2 is a dbTabPage
        Set Label to "TabPage2"
        :
    End_Object    // TabPage2

End_Object    // TabDialog1

Syntax

Use windows.pkg

Object oObjectName is a dbTabDialog
    Set Size to height width
    Set Location to row column
    Set Rotate_Mode to RotateMode

    Object oObjectName is a dbTabPage | dbTabView
        :
    End_Object

    Object oObjectName is a dbTabPage | dbTabView
        :
    End_Object

End_Object

Of Special Note

The only visual objects that can be placed directly inside an object of this class are dbTabPage objects. All other visual objects must be placed inside the dbTabPage objects. Objects of this class must be placed inside another DEO container, usually a dbView.

DbTabPages are used when all of the pages in a view share the same DDO structure (the DDO structure will reside in the parent dbView object).

If there is not enough room in this object to fit all of tab pages, this object will scroll the tabs horizontally, or will create multiple rows of tabs by "wrapping".

Shadowing

Setting the enabled_state property to false will disable entry into all tab pages inside this object. Individual pages can be disabled by setting each tab page's button_shadow_state to true (the tab cannot be selected and the tab page cannot be displayed) or by setting the page's enabled_state to false (the tab is enabled, the page can be displayed, but it cannot be entered).

Navigation

The rotate_mode property allows you specify where next navigation should proceed from the last object of a tab page. Modes are supported to allow users to leave this object (RM_None), ring within the tab page (RM_Ring), ring within this object (RM_Rotate_in_Ring), and to rotate through all tab pages once, exiting when the last object of the last page is departed (RM_Rotate).

DEO Container Object

This class provides a data-entry container object (DEO container) . A DEO container is an object whose native capabilities (in this case, those of a TabDialog) are augmented by data-aware behaviors. These behaviors include:

  • The finding, clearing, saving and deleting of records (and sets of records)
  • Change verification (save, delete, and data-loss verifications)
  • Server support : DEOs connect to data-dictionary or data-set object structures

These data-aware "skills" are added to all DEO classes through a series of mixin classes. The message are listed here but documented in the mixin classes. You are encouraged to study the mixin classes. Information provided in these classes may be applied to all DEO classes (all "db" classes). Those classes are: Nesting_Mixin, Navigate_Mixin, Verify_Mixin, Server_Mixin, and DEO_Delegate_Mixin.

The Server

Objects of this class should be connected to a server (a data-dictionary object). The server can be explicit (directly set with the set Server message) or acquired from a parent DEO container. Often the dbView object will provide the server for a DEO container. All child objects will also use the server. Do not explicitly set a server if you do not have to. If the acquired server from the parent is correct, use it.

You can set custom verification messages to supply save, delete, data-loss and exit confirmations. Normally, these verifications are defined within the view object (dbView) and acquired by all children. If new messages are required, they often occur within the same object that sets a new server.

The dbContainer class supports the messages request_save, request_clear, request_clear_all, and request_delete. Normally these messages are sent from a DEO and will delegate down through the DEO structure until it encounters the object that explicitly set the server (often a DEO container). This makes it possible to define request-message behaviors at the container level so that child DEOs can make use of the definitions by delegation.

Using Data Dictionaries

When this object's server is a data dictionary, this object will acquire a great deal of "knowledge" from the server. Although this object itself will not need to use this knowledge, it will be used by all dbTabPages.

Last Edited: November 21, 2004


Properties for dbTabDialog

View property list in alphabetical order

Name | Description
Inherited Properties from dbTabDialog_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from TabDialog
Button_Count | Returns the number of tabs in this object
Current_Tab | Returns the number of the tab in this object that has the focus
Default_Tab | Determines what tab page will be displayed as a default
MultiLine_State | Determines if tabs will wrap across multiple lines
NumberOfRows | Returns the number of rows of tabs that are displayed
pbFlatSeparators | Determines if separators are drawn
pbHotTrack | Determines hot-tracking on the labels of the tab-pages
pbResetPageOnActivate | Determines how a tab dialog should behave when the dialog takes the focus as part of forward keyboard activation
peTabPosition | Determines if positions of the tabs are at the top or the bottom of the tab-dialog
peTabStyle | Determines if tabs are displayed as tabs or buttons
phoImageList | Permits images to be displayed on tab-pages
Pointer_only_State | Determines how tab buttons will respond to the mouse
Rotate_Mode | Governs cursor movement on keyboard navigation when the Next key is pressed in the last object in a tab page
Skip_Button_Mode | Governs the way tab button navigation is done with the keyboard and mouse (when pointer_only_state is True)
Tab_page_Id | Contains the object_ID of the tab_page object associated with each of this object's items
TabWidth_Mode | Makes each tab just wide enough to display its label, all the same width on each line sufficient to fill the width of this object, or all the width of the widest tab in the object
Inherited Properties from TabDialog_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBasetabDialog
Tooltip_State |
Tooltip_Value |
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbTabDialog

View event list in alphabetical order

Name | Description
Inherited Events from TabDialog
OnBeginningOfPanel | Sent to the tab-dialog when Beginning_of_panel is sent by a parent
OnDisplay |
OnResize | Fires when the tab-dialog is created and whenever it is resized
Inherited Events from TabDialog_
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbTabDialog

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure | Closes the panel or component currently open
Exit_Loss_Confirmation | Function |
Inherited Methods from dbTabDialog_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from TabDialog
Request_Next_Tab | Procedure | Causes the next tab page to be displayed
Request_Previous_Tab | Procedure | Causes the previous tab page to be displayed and take the focus
Request_Switch_To_Tab | Procedure | Displays and activates the requested tab#
Request_Tab_Display | Procedure | Causes the selected tab page to be displayed but does not give the page the focus
Inherited Methods from TabDialog_
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBasetabDialog
Auto_Page | Procedure |
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbTabDialog_

Class: dbTabDialog_ (Abstract)

Properties Events Methods Index of Classes

Abstract class that contains and provides coordinated access to dbTabPage objects

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBasetabDialog
---------------------------TabDialog_
------------------------------TabDialog
---------------------------------dbTabDialog_
------------------------------------dbTabDialog

Library: Windows Application Class Library

Package: Dftabdlg.pkg

Mixins: Entry_Client_mixin NESTING_Mixin NAVIGATE_Mixin SERVER_Mixin VERIFY_Mixin ACTION_BAR_Mixin Auto_Locate_Mixin Non_Dependent_Item_Mixin Deo_Delegate_Mixin

Description

dbTabDialog_ is used to contain and provide coordinated access to dbTabPage objects. Its sub-classes dbTabDialog and dbTabDialogView should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbTabDialog_

View property list in alphabetical order

Name | Description
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from TabDialog
Button_Count | Returns the number of tabs in this object
Current_Tab | Returns the number of the tab in this object that has the focus
Default_Tab | Determines what tab page will be displayed as a default
MultiLine_State | Determines if tabs will wrap across multiple lines
NumberOfRows | Returns the number of rows of tabs that are displayed
pbFlatSeparators | Determines if separators are drawn
pbHotTrack | Determines hot-tracking on the labels of the tab-pages
pbResetPageOnActivate | Determines how a tab dialog should behave when the dialog takes the focus as part of forward keyboard activation
peTabPosition | Determines if positions of the tabs are at the top or the bottom of the tab-dialog
peTabStyle | Determines if tabs are displayed as tabs or buttons
phoImageList | Permits images to be displayed on tab-pages
Pointer_only_State | Determines how tab buttons will respond to the mouse
Rotate_Mode | Governs cursor movement on keyboard navigation when the Next key is pressed in the last object in a tab page
Skip_Button_Mode | Governs the way tab button navigation is done with the keyboard and mouse (when pointer_only_state is True)
Tab_page_Id | Contains the object_ID of the tab_page object associated with each of this object's items
TabWidth_Mode | Makes each tab just wide enough to display its label, all the same width on each line sufficient to fill the width of this object, or all the width of the widest tab in the object
Inherited Properties from TabDialog_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBasetabDialog
Tooltip_State |
Tooltip_Value |
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbTabDialog_

View event list in alphabetical order

Name | Description
Inherited Events from TabDialog
OnBeginningOfPanel | Sent to the tab-dialog when Beginning_of_panel is sent by a parent
OnDisplay |
OnResize | Fires when the tab-dialog is created and whenever it is resized
Inherited Events from TabDialog_
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbTabDialog_

View method list in alphabetical order

Name | Type | Description
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from TabDialog
Request_Next_Tab | Procedure | Causes the next tab page to be displayed
Request_Previous_Tab | Procedure | Causes the previous tab page to be displayed and take the focus
Request_Switch_To_Tab | Procedure | Displays and activates the requested tab#
Request_Tab_Display | Procedure | Causes the selected tab page to be displayed but does not give the page the focus
Inherited Methods from TabDialog_
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBasetabDialog
Auto_Page | Procedure |
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbTabDialogView

Properties Events Methods Index of Classes

Contains and provides coordinated access to dbTabView objects

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBasetabDialog
---------------------------TabDialog_
------------------------------TabDialog
---------------------------------dbTabDialog_
------------------------------------dbTabDialog
---------------------------------------dbTabDialogView

Library: Windows Application Class Library

Package: Dftabdlg.pkg

Description

dbTabDialogView is used to contain and provide coordinated access to dbTabView objects. Each tab view displays a tab with its name on it within this object at all times. Each dbTabView object supports a separate DataDictionary object (DDO) structure.

The dbTabDialog class is a class similar to the dbTabDialogView class, which is used to contain and provide coordinated access to dbTabPage objects. The dbTabDialog class supports only one DDO structure for the entire dialog.

Sample

Object TabDialogView1 is dbTabDialogView
    Set Size to 117 271
    Set Location to 10 15

    Object TabView1 is a dbTabView
        Set Label to "TabView1"
        :
    End_Object    // TabView1

    Object TabView2 is a dbTabView
        Set Label to "TabView2"
        :
    End_Object    // TabView2

End_Object    // TabDialogView1

Syntax

Use Windows.pkg

Object oObjectName is a dbTabDialogView
    Set Size to height width
    Set Location to row column
    Set Rotate_Mode to RotateMode

    Object oObjectName is a dbTabView
        :
    End_Object

    Object oObjectName is a dbTabView
        :
    End_Object

End_Object

Of Special Note

The only visual objects that can be placed directly inside an object of this class are dbTabView objects. All other visual objects will be placed inside the dbTabView objects. Objects of this class must be placed inside another DEO container, usually a dbView.

DbTabViews are used when each tab page will contain a stand-alone view with its own DDO structure. In this case, a unique DDO structure will reside inside each dbTabView object. You may not use dbTabPage objects in objects of this class (place these in a dbTabDialog).

If there is not enough room in this object to fit all of the tab views, this object will scroll the tabs horizontally, or will create multiple rows of tabs by "wrapping" them.

Shadowing

Setting the enabled_state property to false will disable entry into all tab views inside this object. Individual tab views can be disabled by setting the tab view's button_shadow_state to true (the tab cannot be selected and the tab view cannot be displayed) or by setting the tab view's enabled_state to false (the button is enabled, the view can be displayed, but it cannot be entered).

Navigation

The rotate_mode property allows you specify where next navigation should proceed from the last object of a tab view. Modes are supported to allow users to leave this object (RM_None), ring within the tab view (RM_Ring), ring within this object (RM_Rotate_in_Ring), and to rotate through all tab views once, exiting when the last object of the last view is departed (RM_Rotate).

DEO Container Object

This object is a data-entry container object (DEO container). A DEO container is an object whose native capabilities (in this case, those of a TabDialog) are augmented by data-aware behaviors. These behaviors include:

  • The finding, clearing, saving, and deleting of records (and sets of records)
  • Change verification (save, delete, and data-loss verifications)

These data-aware "skills" are added to all DEO classes through a series of mixin classes. The messages are listed here, but documented in the mixin classes. You are encouraged to study the mixin classes. Information provided in these classes may be applied to all DEO classes (all db... classes). Those classes are: Nesting_Mixin, Navigate_Mixin, Verify_Mixin, Server_Mixin, and DEO_Delegate_Mixin.

Last Edited: November 21, 2004


Properties for dbTabDialogView

View property list in alphabetical order

Name | Description
Inherited Properties from dbTabDialog_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from TabDialog
Button_Count | Returns the number of tabs in this object
Current_Tab | Returns the number of the tab in this object that has the focus
Default_Tab | Determines what tab page will be displayed as a default
MultiLine_State | Determines if tabs will wrap across multiple lines
NumberOfRows | Returns the number of rows of tabs that are displayed
pbFlatSeparators | Determines if separators are drawn
pbHotTrack | Determines hot-tracking on the labels of the tab-pages
pbResetPageOnActivate | Determines how a tab dialog should behave when the dialog takes the focus as part of forward keyboard activation
peTabPosition | Determines if positions of the tabs are at the top or the bottom of the tab-dialog
peTabStyle | Determines if tabs are displayed as tabs or buttons
phoImageList | Permits images to be displayed on tab-pages
Pointer_only_State | Determines how tab buttons will respond to the mouse
Rotate_Mode | Governs cursor movement on keyboard navigation when the Next key is pressed in the last object in a tab page
Skip_Button_Mode | Governs the way tab button navigation is done with the keyboard and mouse (when pointer_only_state is True)
Tab_page_Id | Contains the object_ID of the tab_page object associated with each of this object's items
TabWidth_Mode | Makes each tab just wide enough to display its label, all the same width on each line sufficient to fill the width of this object, or all the width of the widest tab in the object
Inherited Properties from TabDialog_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBasetabDialog
Tooltip_State |
Tooltip_Value |
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbTabDialogView

View event list in alphabetical order

Name | Description
Inherited Events from TabDialog
OnBeginningOfPanel | Sent to the tab-dialog when Beginning_of_panel is sent by a parent
OnDisplay |
OnResize | Fires when the tab-dialog is created and whenever it is resized
Inherited Events from TabDialog_
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbTabDialogView

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbTabDialog
Close_Panel | Procedure | Closes the panel or component currently open
Exit_Loss_Confirmation | Function |
Inherited Methods from dbTabDialog_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from TabDialog
Request_Next_Tab | Procedure | Causes the next tab page to be displayed
Request_Previous_Tab | Procedure | Causes the previous tab page to be displayed and take the focus
Request_Switch_To_Tab | Procedure | Displays and activates the requested tab#
Request_Tab_Display | Procedure | Causes the selected tab page to be displayed but does not give the page the focus
Inherited Methods from TabDialog_
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBasetabDialog
Auto_Page | Procedure |
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbTabPage

Properties Events Methods Index of Classes

Used when all of the pages in a view share the same DDO structure

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------dbContainer3d_
---------------------------dbContainer3d
------------------------------dbTabPage

Library: Windows Application Class Library

Package: Dftabdlg.pkg

Mixins: tab_DEO_page_mixin tab_page_mixin

Description

A data-aware tab dialog is created by creating a dbTabDialog object and then creating dbTabPage (or dbTabView) objects inside of it. DbTabPages are used when all of the pages in a view share the same DDO structure (the DDO structure will reside in the parent dbView object). Each tab page displays a tab with its name on it within the tab dialog at all times.

Sample

Object TabDialog1 is dbTabDialog
    Set Size to 117 271
    Set Location to 10 15

    Object TabPage1 is a dbTabPage
        Set Label to "TabPage1"
        Set ToolTip_Value to "Tab Page 1 tool tip"
        :
    End_Object    // TabPage1

    Object TabPage2 is a dbTabPage
        Set Label to "TabPage2"
        Set ToolTip_Value to "Tab Page 2 tool tip"
        :
    End_Object    // TabPage2

End_Object    // TabDialog1

Syntax

Use windows

Object object_name is a dbTabDialog
    Set Size to height width
    Set Location to row column
    Set Rotate_mode to RotateMode

    Object object_name is a dbTabPage
        Set Label to TabButtonLabel
        Set Tab_ToolTip_Value to ToolTipText
        :
        : DEO objects
        :
    End_Object

    Object object_name is a dbTabPage
        :
    End_Object

End_Object

Of Special Note

The only visual objects that can be placed directly inside of a dbTabDialog are dbTabPage or dbTabView objects. All other visual objects will be placed inside of the dbTabPage or dbTabView objects. DbTabDialog objects must be placed inside of another DEO container, usually a dbView.

DbTabPages are used when all of the pages in a view share the same DDO structure (the DDO structure will reside in the parent dbView object). DbTabViews are used when each tab-page will contain a stand-alone view with its own DDO structure. In this case, a unique DDSO structure will reside inside each dbTabView object. You may not mix dbTabPage and dbTabView objects within the same dbTabDialog.

If there is not room in the tab dialog to fit all of tab-pages the tab dialog will allow the tab-buttons to be scrolled, or, will create multiple rows of tab buttons.

Auto-Size / Auto-Location

The size and location of a tab page is set automatically and is determined by the size and location of its parent tab dialog object.

Tab Button Labels

The label displayed by the tab page's button is set and queried with the label property.

Shadowing

Individual pages can be disabled by setting the tab-page's button_shadow_state to true (the tab button can not be selected and tab-page cannot be displayed) or by setting the page's enabled_state to false (the button is enabled, the page can be displayed but it cannot be entered).

Tool-Tips

Tab Pages support tool-tips. When the mouse is moved over a tab button the tool-tip text for that button is displayed. The text value is stored in the Tab_ToolTip_Value property. The display of a tool-tip is disabled if the text value is blank.

Navigation

The rotate_mode property allows you specify where next navigation should proceed from the last object of a tab page. Modes are supported to allow you to leave the dbTabDialog (RM_None), ring within the tab page (RM_Ring), ring within the tab dialog (RM_Rotate_in_Ring) and to rotate through all tab pages exiting when the last object of the last page is encountered (RM_Rotate).

DEO Container Object

The dbTabPage is a data-entry container object (DEO container) . A DEO container is an object, whose native capabilties (in this case a TabPage) is augmented to support data-aware behaviors. These behaviors include:

  • The finding, clearing, saving and deleting of records (and sets of records)
  • Change verification (save, delete, and data-loss verifications)
  • Server support : DEOs connect to data-dictionary or data-set object structures

These data-aware "skills" are added to all DEO classes through a series of mixin classes. The message are listed here but documented in the mixin classes. You are encouraged to study the mixin classes. Information provided in these classes may be applied to all DEO classes (all "db" classes). Those classes are: Nesting_Mixin, Navigate_Mixin, Verify_Mixin, Server_Mixin, and DEO_Delegate_Mixin.

The Server

A dbTabPage should be connected to a server (a data-dictionary object). The server can be explicit (directly set with the set Server message) or acquired from a parent DEO container. Often the dbView object will provide the server for a DEO container. All child objects will also use the server unless a child object explicitly sets a different server. Do not explicitly set a server if you do not have to. If the acquired server from the parent is correct, use it.

You can set custom verification messages to supply save, delete, data-loss and exit confirmations. Normally, these verifications are defined within the view object (dbView) and acquired by all children. If new messages are required they often occur within the same object that sets a new server.

The dbContainer class supports the messages request_save, request_clear, request_clear_all, and request_delete. Normally these messages are sent from a DEO entry object and will delegate down through DEO structure until it encounters the obejct that explicitly set the server (often a DEO container). This makes it possible to define request-message behaviors at the container level so that child DEOs can make use of the definitions by delegation.

Using Data Dictionaries

When this object's server is a data dictionary, this object will acquire a great deal of "knowledge" from the server. Although the container itself will not need to use this knowledge it will be used by all DEO entry objects that acquire the server.

Last Edited: November 21, 2004


Properties for dbTabPage

View property list in alphabetical order

Name | Description
Button_Shadow_State | Determines if both the page and the button will be shadowed
Label |
pbHighlightTab | Highlights the tab, using the Windows clHighlight color
piImageIndex | The index of the image from the tab-dialog's imagelist
Tab_Button_item | Contains this tab-page's item number
Tab_ToolTip_Value | Sets the text that is displayed as a tool tip for this object's tab in the container tab-dialog object
Inherited Properties from dbContainer3d_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbTabPage

View event list in alphabetical order

Name | Description
OnResize | Fires when the tab-page is created and whenever it is resized
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbTabPage

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbContainer3d
Close_Panel | Procedure | Closes the panel or component currently open
Inherited Methods from dbContainer3d_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbTabView

Properties Events Methods Index of Classes

Used when each tab-page will contain a stand-alone view with its own DDO structure

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------dbContainer3d_
---------------------------dbContainer3d
------------------------------dbTabView_
---------------------------------dbTabView

Library: Windows Application Class Library

Package: Dftabdlg.pkg

Mixins: tab_DEO_page_mixin tab_page_mixin

Description

A data-aware tab dialog is created by creating a dbTabDialogView object and then creating dbTabView (or dbTabPage) objects inside of it. DbTabViews are used when each tab-page will contain a stand-alone view with its own DDO structure. In this case, a unique DDO structure will reside inside each dbTabView object. Each tab page displays a tab with its name on it within the tab dialog at all times.

Sample

Object TabDialog1 is dbTabDialog
    Set Size to 117 271
    Set Location to 10 15

    Object TabPage1 is a dbTabView
        Set Label to "TabPage1"
        Set ToolTip_Value to "Tab Page 1 tool tip"
        :
    End_Object    // TabPage1

    Object TabPage2 is a dbTabView
        Set Label to "TabPage2"
        Set ToolTip_Value to "Tab Page 2 tool tip"
        :
    End_Object    // TabPage2

End_Object    // TabDialog1

Syntax

Use windows

Object object_name is a dbTabDialog
    Set Size to height width
    Set Location to row column
    Set Rotate_mode to RotateMode

    Object object_name is a dbTabView
        Set Label to TabButtonLabel
        Set Tab_ToolTip_Value to ToolTipText
        :
        : DDO Structure
        : DEO objects
        :
    End_Object

    Object object_name is a dbTabView
        :
    End_Object

End_Object

Of Special Note

The only visual objects that can be placed directly inside of a dbTabDialog are dbTabPage or dbTabView objects. All other visual objects will be placed inside of the dbTabPage or dbTabView objects. DbTabDialog objects must be placed inside of another DEO container, usually a dbView.

DbTabPages are used when all of the pages in a view share the same DDO structure (the DDO structure will reside in the parent dbView object. DbTabViews are used when each tab-page will contain a stand-alone view with its own DDO structure. In this case, a unique DDO structure will reside inside each dbTabView object. You may not mix dbTabPage and dbTabView objects within the same dbTabDialog.

If there is not room in the tab dialog to fit all of tab-pages the tab dialog will allow the tab-buttons to be scrolled, or, will create multiple rows of tab buttons.

Auto-Size / Auto-Location

The size and location of a tab page is set automatically and is determined by the size and location of its parent tab dialog object.

Tab Button Labels

The label displayed by the tab page's button is set and queried with the label property.

Shadowing

Individual pages can be disabled by setting the tab page's button_shadow_state to true (the tab button can not be selected and the tab page cannot be displayed) or by setting the page's enabled_state to false (the button is enabled, the page can be displayed but it cannot be entered).

Tool Tips

Tab pages support tool tips. When the mouse is moved over a tab, the tool-tip text for that tab is displayed. The text value is stored in the Tab_ToolTip_Value property. The display of a tool tip is disabled if the text value is blank.

Navigation

The rotate_mode property allows you specify where next navigation should proceed from the last object of a tab page. Modes are supported to allow you to leave the dbTabDialog (RM_None), ring within the tab page (RM_Ring), ring within the tab dialog (RM_Rotate_in_Ring) and to rotate through all tab pages exiting when the last object of the last page is encountered (RM_Rotate).

DEO Container Object

The dbTabView is a data-entry container object (DEO container) . A DEO container is an object, whose native capbilties (in this case a dbTabView )is augmented to support data-aware behaviors. These behaviors include:

  • The finding, clearing, saving and deleting of records (and sets of records)
  • Change verification (save, delete, and data-loss verifications)
  • Server support : DEOs connect to data-dictionary or data-set object structures

These data-aware "skills" are added to all DEO classes through a series of mixin classes. The message are listed here but documented in the mixin classes. You are encouraged to study the mixin classes. Information provided in these classes may be applied to all DEO classes (all "db" classes). Those classes are: Nesting_Mixin, Navigate_Mixin, Verify_Mixin, Server_Mixin, and DEO_Delegate_Mixin.

The Server

Each dbTabView must contain a data-dictionary structure. It acts like a dbView and should be structured the same way dbView objects are structured. If an explicit server is set in this object it will most likely be the Main-DDO server for the view. All child DEOs will acquire this server unless they explicitly are changed.

You can set custom verification messages to supply save, delete, data-loss and exit confirmations. Normally, these verifications are defined within the view object (dbView) and acquired by all children. If new messages are required they often occur within the same object that sets a new server.

The dbTabView class supports the messages request_save, request_clear, request_clear_all, and request_delete. Normally these messages are sent from a DEO entry object and will delegate down through DEO structure until it encounters the obejct that explicitly set the server (often a DEO container). This makes it possible to define request-message behaviors at the container level so that child DEOs can make use of the definitions by delegation.

Using Data Dictionaries

When this object's server is a data dictionary, this object will acquire a great deal of "knowledge" from the server. Although the container itself will not need to use this knowledge it will be used by all DEO entry objects that acquire the server.

Last Edited: November 21, 2004


Properties for dbTabView

View property list in alphabetical order

Name | Description
Button_Shadow_State | Determines if both the page and the button will be shadowed
Label |
pbHighlightTab | Highlights the tab, using the Windows clHighlight color
piImageIndex | The index of the image from the tab-dialog's imagelist
Tab_Button_item | Contains this tab-page's item number
Tab_ToolTip_Value | Sets the text that is displayed as a tool tip for this object's tab in the container tab-dialog object
Inherited Properties from dbTabView_
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to
Auto_Top_Item_State |
Auto_top_view_State |
DEO_Attach_All_State |
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function
priInitialRowId |
View_Latch_State | Determines if the view's DSO structure will be initialized with the data
Inherited Properties from dbContainer3d_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbTabView

View event list in alphabetical order

Name | Description
OnResize | Fires when the tab-page is created and whenever it is resized
Inherited Events from dbTabView_
Closing_View |
Opening_View |
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbTabView

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbTabView_
Exit_Application_Check | Function |
Inherited Methods from dbContainer3d
Close_Panel | Procedure | Closes the panel or component currently open
Inherited Methods from dbContainer3d_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbTabView_

Class: dbTabView_ (Abstract)

Properties Events Methods Index of Classes

Abstract class used when each tab-page will contain a stand-alone view with its own DDO structure

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------dbContainer3d_
---------------------------dbContainer3d
------------------------------dbTabView_
---------------------------------dbTabView

Library: Windows Application Class Library

Package: Dftabdlg.pkg

Mixins: entry_view_Client_mixin View_Dependent_Item_Mixin

Description

dbTabView_ is used when each tab-page will contain a stand-alone view with its own DDO structure. Its sub-class dbTabView should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for dbTabView_

View property list in alphabetical order

Name | Description
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to
Auto_Top_Item_State |
Auto_top_view_State |
DEO_Attach_All_State |
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function
priInitialRowId |
View_Latch_State | Determines if the view's DSO structure will be initialized with the data
Inherited Properties from dbContainer3d_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbTabView_

View event list in alphabetical order

Name | Description
Closing_View |
Opening_View |
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbTabView_

View method list in alphabetical order

Name | Type | Description
Exit_Application_Check | Function |
Inherited Methods from dbContainer3d
Close_Panel | Procedure | Closes the panel or component currently open
Inherited Methods from dbContainer3d_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbTrackBar

Properties Events Methods Index of Classes

Enables applications to provide users with a data aware visual control to 'slide' through a range of values

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------Entry
------------------------------dbForm_
---------------------------------dbFormDS
------------------------------------dbForm
---------------------------------------dbFormExternalControl
------------------------------------------dbTrackBar

Library: Windows Application Class Library

Package: dbTrckbr.pkg

Mixins: Trackbar_Mixin External_Class_Mixin

Description

dbTrackbar is used to enable applications to provide users with a data aware visual control to 'slide' through a range of values. The objects have the visual appearance of the type of slider control commonly found on stereo/graphic equalizers. The control can be either horizontal or vertical and can have "tick" marks along either or both sides.

Sample

Object Reportby_Reliability is a dbTrackBar
      Entry_Item Reportby.Reliability
      Set Label to "Reliability:   Low"
      Set Maximum_Position to 10
      Set Visible_Tick_State to FALSE
      Set Tick_Orientation to tkBOTTOM
      Set Tick_Frequency to 1
      Set Page_Size to 1
      Set Size to 15 186
      Set Location to 53 70
End_Object    // Reportby_Reliability

Syntax

Use dbTrckBr.pkg

Object object_name is a dbTrackBar
    Set Minimum_Position To lowest track value
    Set maximum_Position To hight track value
    Set Visible_Tick_State to True|False
    Set Tick_Orientation to orientation
    Set Tick_Frequency to number
    Set Page_Size to size

    Set Size to height width
    Set location to Row Column
    entry_item file.field

    Set Label to text
    Set Label_Justification_Mode to mode
    Set Label_row_Offset to Num
    Set Label_Col_Offset to Num

    Set enabled_state to true|false

    Procedure Set ControlValue string sVal
        :
     End_Procedure

    Function ControlValue Returns String
        :
    End_Function

    Procedure onChange
        :
    End_Procedure

    Procedure onSetFocus

        :
    End_Procedure

    Procedure onKillFocus
        :
    End_Procedure

    Procedure OnSetPosition
        :
    End_Procedure

End_Object

Of Special Note

This class is usually used to represent integer field values as a trackbar. In such a case you need to simply set the minimum_position and maximum_position properties. In such a case, your data base value and the slider have a one to one correspondence.

You can translate other database values to a trackbar integer value (and back) by augmenting the methods Set and Get ControlValue. For example, the string database field Customer.Status could map the values "A", "B", "C" and "D" slider values 0, 1, 2 and 3 as follows:

Object Customer_status is a dbTrackBar
     Entry_Item Customer_Status
     Set Maximum_Position to 4
     Set Minimum_Position to 0
     Set Size to 15 186
     Set Location to 53 70

    Procedure Set ControlValue string sVal // s/b A B C  or D
         Integer iPos
         Move (ascii(sVal)-ascii("A")) to iPos
         Set current_Position to iPos
   End_Procedure

   Function ControlValue Returns String
        Integer iPos
        Get current_position to iPos
        Function_return ( character(iPos+ascii("A" ) )
    End_Function

End_Object

Last Edited: November 21, 2004


Properties for dbTrackBar

View property list in alphabetical order

Name | Description
ControlValue |
Current_Position | Contains the absolute position of the slider
Line_Size | Determines the amount the Current_Position changes whenever users move the slider by use of the arrow keys
Maximum_Position | Maintains the absolute value of the slider when it is slid to its maximum position
Minimum_Position | Maintains the absolute value of the slider when it is slid to its lowest position
Orientation_Mode | Specifies whether the control should be displayed horizontally or vertically
Page_Size | Determines the amount the Current_Position changes whenever users move the slider by use of the PageUp or PageDown keys
pbTooltips | Determines if tooltips should be displayed for this object
Tick_Frequency | Maintains the increment at which to display tick marks
Tick_Orientation | Specifies where the ticks should be placed in relation to the slider
Visible_Tick_State | Specifies whether tick marks are displayed in the control
Inherited Properties from dbForm
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object
Inherited Properties from dbFormDS
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO)
Inherited Properties from dbForm_
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Save_State | Determines if auto save should be performed
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Validate_All_Items_State | Determines if all items are being validated
Validate_Mode | Determines how and when object validation occurs
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from Entry
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbTrackBar

View event list in alphabetical order

Name | Description
OnFinishedSliding | Sent whenever the slider has stopped moving by either the mouse or keyboard interface
OnGoneToEnd | Sent when a user pressed the End key to take the slider to the end
OnGoneToStart | Sent when a user pressed the Home key to return the slider to the beginning of the track
OnLineDown | Sent when a user presses one of the arrow keys to increment the Current_Position by the value of Line_Size
OnLineUp | Sent when a user presses one of the arrow keys todecrement the Current_Position by the value of Line_Size
OnPageDown | Sent when a user presses the PageDown key to increment the Current_Position by the value of Page_Size
OnPageUp | Sent when a user presses the PageUp key to decrement the Current_Position by the value of Page_Size
OnSetPosition | Sent whenever the value of Current_Position changes
OnSliding | Sent when a user drags the slider with the mouse
Inherited Events from dbForm_
Entry_Defaults | "Hook" for providing default-setting routines
Inherited Events from Entry
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbTrackBar

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbFormDS
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Request_Save | Procedure |
Validate_Prompt | Function | (Obsolete)
Inherited Methods from dbForm_
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true
Request_Delete | Procedure | Deletes the current record of this object's server, if any
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from Entry
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbView

Properties Events Methods Index of Classes

Creates view objects

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------MdiDialog
---------------------------AppDialog
------------------------------View
---------------------------------dbAppClient_
------------------------------------dbAppView_
---------------------------------------dbView

Library: Windows Application Class Library

Package: Dfclient.pkg

Mixins: DFNavigate_Mixin

Description

The dbView class is used to create view objects. Views contain complete stand-alone and independent data-entry units that may include their own DDO structure and DEO objects that connect to this structure.

Source

// View1.vw - non-deferred view
Use dfClient.pkg
Use Windows.pkg
:
Activate_View Activate_View1 For View1

Object View1 is a dbView
    Set Label  to "My View1 Label"
    Set Size   to 120 280
    Set Border_Style to Border_Thick
:
End_Object

// View1.vw - deferred view
Use dfClient.pkg
Use Windows.pkg
:
Deferred_View Activate_View1 For ;
;
Object View1 is a dbView
    Set Label  to "My View1 Label"
    Set Size   to 120 280
    Use dfClient.pkg
Use Windows.pkg
:
CD_End_Object

Syntax

Usage

Activate_View Activate_object_name for object_name

object object_name is a dbView
    set size to Height Width
    set label to CaptionText
    :
    : Create Data-dictionary (or data-set) object structure
    :
    set Main_DD to DDObjectName
    set Server to DDObjectName
    :
    set View_Latch_State to true| false
    set DSO_Detach_Mode to detachMode
    :
    Set Verify_Save_msg to get_SaveMessage
    Set Verify_Delete_msg to get_DeleteMessage
    Set Verify_Data_loss_msg to get_DataLossMessage
    Set Verify_Exit_msg to get_ExitMessage
    :
    : DEO objects
    :
end_object

Deferred_View Activate_object_name for ;
;
object object_name is a dbView
    :
CD_end_object

Of Special Note

The dbView provides a DEO view. DbViews will contain a data-dictionary object structure and other DEO objects which connect to the DSO structure. A dbView object is an MDI (multiple document interface) object and must be placed inside of a MDI client-area object (ClientArea). dbView and (View) objects are usually saved in their own source files (.vw files) and placed inside of a client-area object with the use or #include command.

dbViews are usually activated by selecting an option from a view pulldown menu. A dbView should act independently of other views within a program. A view object will often be placed in its own package file. These object packages can be written and tested stand-alone and then easily added to any program.

DEO Container Object

The dbContainerForm is a data-entry container object (DEO container) . A DEO container is an object, whose native capabilties (in this case a Container3d )is augmented to support data-aware behaviors. These behaviors include:

  • The finding, clearing, saving and deleting of records (and sets of records)
  • Change verification (save, delete, and data-loss verifications)
  • Server support : DEOs connect to data-dictionary or data-set object structures

These data-aware "skills" are added to all DEO classes through a series of mixin classes. The message are listed here but documented in the mixin classes. You are encouraged to study the mixin classes. Information provided in these classes may be applied to all DEO classes (all "db" classes). Those classes are: Nesting_Mixin, Navigate_Mixin, Verify_Mixin, Server_Mixin, and DEO_Delegate_Mixin.

Initializing DD Record Buffers

You may control how the data-dictionary structures' records are initialized when a view is activated. You may also control how the data-dictionary should react when a view is closed.

The default behavior is as follows.

When a view is activated the record that happens to be in the buffer is loaded into the DDO and displayed in the view. When the view is closed, the DDO record buffer is cleared losing any changes.

You may change this. A common change is to force the view to always activate with cleared DDO buffer. Another change might be for the view to remember the record it was closed with and to reload that record (maintainting any changes). These behaviors are changed by setting the properties view_latch_state and DSO_detach_mode.

For these behaviors to work properly you must declare a main-data-dictionary within you view by setting the main_dd property.

The Main_DD

The main data-dictionary is the primary DDO for a view. Sometimes this will be the child-most DD in a multi-file DDO structure. Other times this will be a DD that has parent files and child files. The child files are usually constrained to this main file (you can only see children of the main file) and are often represented in grids. A typical example would be an order-entry view. The order header file would be the main file. It will have constrained children (order-detail) displayed in a table.

The main data-dictionary is defined by setting the main_dd property. When a view is activated the record latch behavior centers around the file of the main-dd.

You will usually set the server of a view to the same DDO as the main_dd. Very often this will be the only server that will be set. All other DEOs in the view will acquire this server.

Activating Views

View are usually activated from the popup menu by sending a custom activate message to the client-area object. The custom message is defined by the command Activate_View or Deferred_View. Views may also be activated by sending the message Activate_view to the object.

Deferred Views

The Deferred_View command is used in conjunction with the CD_end_Object command to defer the creation of the view until it is activated. Deferring views will improve program load time.

Application Exit Behavior

When an application is about the be exited the client-area object will send two messages to each registered view. First it sends the message get verify_exit_application to each view. If any view returns a non-zero value the application will not be closed.

When the verify_exit_application function is called the default behavior of all dbView objects is to call the view_changed function. View_Changed determines if the view is changed by checking the changed condition of all child Data-dictionary (or data-set) objects returning a non-zero value if any are changed. If View_Changed reports a changed condition (returns a non-zero value) a verification message is displayed ("changes exist..") and the user is given the chance to halt the program exit.

If all views allow the application to be closed, the client-area will send the message notify_exit_application to all views. By default this sends the message save_environment which saves the location of an active view. The next time the program is run and the view is activated the view will appear in this location.

Verification Messages

Views are supplied default verification messages for the following operations: save, delete, clear with data-loss and exit with data-loss. These defaults can be changed by setting the verify_save_msg, verify_delete_msg, verify_data_loss_msg and the verify_exit_msg properties.

Last Edited: June 23, 2005


Properties for dbView

View property list in alphabetical order

Name | Description
DEO_Object | Indicates whether the control is a Data Entry Object (DEO) container
Inherited Properties from dbAppView_
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to
Auto_Top_Item_State |
Auto_top_view_State |
DEO_Attach_All_State |
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function
priInitialRowId |
View_Latch_State | Determines if the view's DSO structure will be initialized with the data
Inherited Properties from dbAppClient_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from MdiDialog
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbView

View event list in alphabetical order

Name | Description
Inherited Events from dbAppView_
Closing_View |
Opening_View |
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used
Inherited Events from AppDialog
Notify_Exit_Application | Called when an application is about to be closed
Verify_Exit_Application | Sent by the client area to verify that an application may be exited
Inherited Events from MdiDialog
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbView

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure | Closes the panel or component currently open
Inherited Methods from dbAppView_
Exit_Application_Check | Function |
Inherited Methods from dbAppClient_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from AppDialog
Activate_View | Procedure | Activates the view
Inherited Methods from MdiDialog
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbViewFloatingPanel

Class: dbViewFloatingPanel (Abstract)

Properties Events Methods Index of Classes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------dbFloatingPanel_
---------------------------------dbFloatingPanel
------------------------------------dbViewFloatingPanel
---------------------------------------dbModalPanel
---------------------------------------dbViewToolPanel

Library: Windows Application Class Library

Package: Dfclient.pkg

Mixins: entry_view_Client_mixin View_Dependent_Item_Mixin

Description

Last Edited: December 2, 2005


Properties for dbViewFloatingPanel

View property list in alphabetical order

Name | Description
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to
Auto_Top_Item_State |
Auto_top_view_State |
DEO_Attach_All_State |
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function
priInitialRowId |
View_Latch_State | Determines if the view's DSO structure will be initialized with the data
Inherited Properties from dbFloatingPanel
DEO_Object |
Inherited Properties from dbFloatingPanel_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbViewFloatingPanel

View event list in alphabetical order

Name | Description
Closing_View |
Opening_View |
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbViewFloatingPanel

View method list in alphabetical order

Name | Type | Description
Exit_Application_Check | Function |
Inherited Methods from dbFloatingPanel
Close_Panel | Procedure | Closes the panel or component currently open
Inherited Methods from dbFloatingPanel_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: dbViewToolPanel

Class: dbViewToolPanel (Abstract)

Properties Events Methods Index of Classes

Abstract class that provides a modal container for selection lists (dblist) and other DEOs

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------dbFloatingPanel_
---------------------------------dbFloatingPanel
------------------------------------dbViewFloatingPanel
---------------------------------------dbViewToolPanel

Library: Windows Application Class Library

Package: Dfclient.pkg

Description

dbViewToolPanel is used to provide a modal container for selection lists (dblist) and other DEOs. Its sub-classes dbModalPanel and ValidationList should be used for sub-classing and instantiation.

Last Edited: December 2, 2005


Properties for dbViewToolPanel

View property list in alphabetical order

Name | Description
Inherited Properties from dbViewFloatingPanel
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to
Auto_Top_Item_State |
Auto_top_view_State |
DEO_Attach_All_State |
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function
priInitialRowId |
View_Latch_State | Determines if the view's DSO structure will be initialized with the data
Inherited Properties from dbFloatingPanel
DEO_Object |
Inherited Properties from dbFloatingPanel_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for dbViewToolPanel

View event list in alphabetical order

Name | Description
Inherited Events from dbViewFloatingPanel
Closing_View |
Opening_View |
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for dbViewToolPanel

View method list in alphabetical order

Name | Type | Description
Inherited Methods from dbViewFloatingPanel
Exit_Application_Check | Function |
Inherited Methods from dbFloatingPanel
Close_Panel | Procedure | Closes the panel or component currently open
Inherited Methods from dbFloatingPanel_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DEOPopupMenu

Properties Events Methods Index of Classes

Creates pulldown objects that disables messages not sent to DEOs

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseActionBar
------------------------DfBasePullDown
---------------------------PopupMenu
------------------------------DEOPopupMenu

Library: Windows Application Class Library

Package: Dfdeomnu.pkg

Description

DEOPopupMenu is used to create pulldown objects that disables messages not sent to DEOs. A special function Is_Function is provided that allows the menu to query the invoking focus object and ask if the object is a DEO object, and, if the object is a DEO control object (as opposed to a container). This information can be used to set the shadow state of menu items appropriately. This should be used inside of onInitMenu. This ensures that DEO messages (save, clear, delete, etc.) are not sent to non-DEOs.

Sample

Use DFDEOMnu

DFCreate_Menu "&Navigate" NAVIGATE_Menu is a DEOPopupMenu
    On_Item "&Next area\aF6"            send Switch_Next_Area
    Set Status_Help To  'Move to the Next area'

    On_Item "P&revious area\aShift+F6"  send Switch_Prior_Area
    Set Status_Help To  'Move to the Previous area'

    On_Item "Ne&xt view\aAlt+F6"        send Switch_Next_View
    Set Status_Help To  'Move to the Next view'

    On_Item "Pre&vious View\aCtrl+F6"   send Switch_Prior_View
    Set Status_Help To  'Move to the Previous view'

    On_Item ""                          send none

    On_Item "&Prompt\aF4"               send Prompt
    Set Status_Help To  'Show available selections'

    On_Item "&Zoom\aAlt+F9"             send Zoom
    Set Status_Help To  'Show appropriate Zoom'

    //  When ever the menu [pulldown] is initialized, check/set
    //  the state of its items.
    //
    Procedure OnInitMenu
        integer Obj# IsDeo Itm prmpt zm isDeoControl
        Get Focus to Obj#
        Get is_Function Get_DEO_Object Obj# TRUE to IsDeo
        If IsDeo Begin
            Get is_Function Get_DEO_Control_Object Obj# False to IsDeoControl
            If IsDeoControl Begin
                Get Prompt_Object of Obj# to Prmpt
                Get Zoom_Object of Obj# to zm
            End
            Set Shadow_state item 0  to False
            Set Shadow_state item 1  to False
            Set Shadow_state item 2  to False
            Set Shadow_state item 3  to False
            Set Shadow_state item 5  to (Prmpt=0)
            Set Shadow_state item 6  to (Zm=0)
        End
        Else Begin
            for itm from 0 to 6
                Set shadow_State item itm to TRUE
            Loop
        End
    End_Procedure //Initialize_Menu

End_Menu
Set Status_Help to "Move to different areas of the application."

Syntax

Use windows
:
Object object_name is a DEOPopupMenu
    Set Select_Mode to No_Select|Multi_Select
    Item_List
        On_Item MenuText Send message [to dest_object]
        Set Status_Help to StatusHelpText
        On_Item "" send none // separator
        :
    End_Item_List

    Procedure OnInitMenu
        integer isDEO isDEOControl Obj#
        Get Focus to Obj#
        // determine if a DEO
        Get is_Function Get_DEO_Object Obj# TRUE to IsDeo
        If IsDeo Begin
            // determine if a DEO control
            Get is_Function Get_DEO_Control_Object Obj# False to IsDeoControl
            :
        End
        :
        : (set shadow_state of item as needed
        :
    End_Procedure
End_Object

Of Special Notice

It is expected that object using this class will create an onInitMenu procedure which will check if the focus object is a DEO (Get is_Function Get_DEO_Object Obj# TRUE to IsDeo) or if the focus object is a DEO control (Get is_Function Get_DEO_Control_Object Obj# False to IsDeoControl). It will use this information to set each item's shadow_state as required.

The focus object is considered to be a DEO if it or any of its parent objects understands the function DEO_Object and returns a non-zero value. By default, all "db" objects do this.

The focus object is considered to be a DEO control if it objects understands the function DEO_Control_Object and returns a non-zero value. By default, all "db" control objects do this (dbform, dbComboForm, dbGrid, etc.)

You should not directly send the DEO_object or DEO_Control_Object message. If the focus object is not a DEO it will return an error message (the message will not be understood). Instead these properties are acquired indirectly by using the Is_Function function.

The packages Navi_pm.pkg and File_pm.pkg provide good examples of this class's usage.

This class's properties are unchanged from those of its superclass.

Last Edited: August 6, 2004


Properties for DEOPopupMenu

View property list in alphabetical order

Name | Description
Inherited Properties from PopupMenu
Shadow_Status_Help | Specifies the display in the status bar for items of this object that are shadowed
Simple_Status_Help_State |
Status_Help | The status-bar help text for Item item#
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DEOPopupMenu

View event list in alphabetical order

Name | Description
Inherited Events from PopupMenu
OnChange | Called every time a menu changes
OnInitMenu | Sent when a PopupMenu object is about to be selected
Inherited Events from DfBaseActionBar
Initialize_Menu | Sent when the Menubar system is about to be selected
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DEOPopupMenu

View method list in alphabetical order

Name | Type | Description
Is_Function | Function | Returns a value from MsgId for ObjId
Inherited Methods from PopupMenu
Menu_Status_Help | Function |
Inherited Methods from DfBaseActionBar
Exit_Menu | Procedure |
Redirect_Message | Procedure |
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DescriptionValidationTable

Properties Events Methods Index of Classes

Provides a two-column table of validation data for validation lists used with DataDictionary objects.

Hierarchy

cObject
---Array
------ValidationTable
---------DescriptionValidationTable
------------FileValidationTable

Library: Common (Windows and Web Application) Class Library

Package: Ddvaltbl.pkg

Description

To provide a two-column table of validation data statically defined within the object itself for validation lists used through the Field_Value_Table field property in DataDictionary objects.

Sample

Use ddvaltbl.pkg

Object Terms_Table  is a DescriptionValidationTable
    Procedure Fill_List
        Forward Send Fill_List
        Send Add_Table_Value  "NONE"  "None established"
        Send Add_Table_Value  "COD"  "COD"
        Send Add_Table_Value  "NET30"  "Net 30"
        Send Add_Table_Value  "NET60"  "Net 60"
        Send Add_Table_Value  "NET90"  "Net 90"
        Send Add_Table_Value  "PREPAY"  "Pre-payment required"
    End_Procedure    // Fill_List
End_Object   // Terms_table
:
Class OrderHea_Data_Set is a DataDictionary
    :
    Procedure Define_Fields
    :
    Set Field_Value_Table Field Orderhea.Terms to (Terms_Table(Self))

This is an object for assignment in DataDictionary objects to database fields with the Field_Value_Table property. It provides both values for insertion into the database and descriptions to explain each value. It is the superclass of a hierarchy of more-capable and -complex validation classes, but is usable in its own right in simple, static situations.

If the Validate_State property is set to False, entries are permitted that are not in the list; in its default True state, it requires an entry that matches one of the existing table items. If the Static_State property is set to False, the list will be filled every time the table is activated; in its default True state, the object is loaded with its list only once in each session.

See Also

Using Validation Tables

Last Edited: July 12, 2005


Properties for DescriptionValidationTable

View property list in alphabetical order

Name | Description
Inherited Properties from ValidationTable
Allow_Blank_State | Controls whether blank entries are accepted in this object
Main_File | Identifies the data file from which the values are to be drawn to fill this object
Static_State | Determines whether object loads once per session or dynamically.
Table_Title | The title shown in the caption bar of the validation table
Validate_State | Determines whether values are validated against the items contained in the validation table.
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DescriptionValidationTable

View event list in alphabetical order

Name | Description
Inherited Events from ValidationTable
Fill_List | Fills the list of entires in the validation table
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DescriptionValidationTable

View method list in alphabetical order

Name | Type | Description
Add_Table_Value | Procedure | Should be sent for each sDescription and sValue you wish to add to your validation table
Inherited Methods from ValidationTable
Find_Code_Description | Function |
TableData | Function | Returns the validation table's data in a two dimensional variant array
Validate_Value | Function | Determines whether a value is valid or not (is listed in the validation table or not)
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseActionBar

Class: DfBaseActionBar (Abstract)

Properties Events Methods Index of Classes

Abstract class that provides the capabilities of a standard GUI menu bar

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseActionBar
------------------------DfBasePullDown
------------------------MenuBar

Library: Windows Application Class Library

Package:

Description

DfBaseActionBar is used to provide the capabilities of a standard GUI menu bar. This is an abstract class. Its sub-classes MenuBar, FormFloatingPopupMenu, dbFloatingPopupMenu, FloatingPopupMenu, PopupMenu, DEOPopupMenu, and ViewPopupMenu should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBaseActionBar

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseActionBar

View event list in alphabetical order

Name | Description
Initialize_Menu | Sent when the Menubar system is about to be selected
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseActionBar

View method list in alphabetical order

Name | Type | Description
Exit_Menu | Procedure |
Redirect_Message | Procedure |
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseButton

Class: DfBaseButton (Abstract)

Properties Events Methods Index of Classes

An abstract class used for defining all button classes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseButton
------------------------DfBaseCheckbox
------------------------DfBasePushButton

Library: Windows Application Class Library

Package:

Description

DFBaseButton is used for defining all button classes (Button, CheckBox and Radio).

Of Special Note

This class is based on the DfBaseList and shares its interface but not its appearance. Subclasses of DfBaseButton are all single item classes - only one button is expected in each object. When item messages are required the item number should always be item 0. See the Button class for more usage information .

There are no new or changed properties for this class

There are no new or changed procedures or functions for this class

Last Edited: November 21, 2004


Properties for DfBaseButton

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseButton

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseButton

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseCheckbox

Class: DfBaseCheckbox (Abstract)

Properties Events Methods Index of Classes

Abstract class that enables users to select items (or options) in applications

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseButton
------------------------DfBaseCheckbox
---------------------------CheckBox
---------------------------DfBaseRadioButton

Library: Windows Application Class Library

Package:

Description

DfBaseCheckbox is used to enable users to select items (or options) in applications. This is an abstract class. Its sub-classes Checkbox, RadioButton, and Radio should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBaseCheckbox

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseCheckbox

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseCheckbox

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseComboBox

Class: DfBaseComboBox (Abstract)

Properties Events Methods Index of Classes

Abstract class that combines the functionality of the form class with that of a standard Windows drop-down list

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseComboBox
---------------------------ComboForm

Library: Windows Application Class Library

Package:

Description

DfBaseComboBox is used to combine the functionality of the form class with that of a standard Windows drop-down list. Its sub-class ComboForm should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBaseComboBox

View property list in alphabetical order

Name | Description
Combo_Data_Object | Specifies the object ID of the internal l combo object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseComboBox

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseComboBox

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseComboBoxEntry

Class: DfBaseComboBoxEntry (Abstract)

Properties Events Methods Index of Classes

Abstract class thta combines the capabilities of the Entry and ComboForm classes in a single class

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseComboBoxEntry
------------------------------ComboEntry

Library: Windows Application Class Library

Package:

Mixins: DfBaseComboBox

Description

DfBaseComboBoxEntry is an abstract class used to combine the capabilities of the Entry and ComboForm classes in a single class. Its sub-classes dbComboForm and dbCodeComboForm should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBaseComboBoxEntry

View property list in alphabetical order

Name | Description
Combo_Data_Object | Specifies the object ID of the internal l combo object
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseComboBoxEntry

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseComboBoxEntry

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseContainer

Class: DfBaseContainer (Abstract)

Properties Events Methods Index of Classes

An abstract class for defining GUI containers

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
------------------DfBaseGroup

Library: Windows Application Class Library

Package:

Description

DfBaseContainer is used for defining GUI containers. A containers is a window that is designed for containing control and other containers. Examples of controls are Container3d, Group, Panel, ModalPanel, and, ToolPanel.

Last Edited: November 21, 2004


Properties for DfBaseContainer

View property list in alphabetical order

Name | Description
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseContainer

View event list in alphabetical order

Name | Description
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseContainer

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseControl

Class: DfBaseControl (Abstract)

Properties Events Methods Index of Classes

An abstract class for defining GUI controls

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------AbstractShapeControl
------------------cWinControl
------------------DfBaseEdit
------------------DfBaselineControl
------------------DfBaseList
------------------DFBaseRichEdit
------------------DfBaseTextbox
------------------DFBaseTextEdit

Library: Windows Application Class Library

Package:

Description

DfBaseControl is used for defining GUI controls. A control is a window that is designed for guiding and obtaining user input. Examples of controls are menus, buttons, edits, and lists. Subclasses of DfBaseControl are always contained by objects of the container classes (DfBaseDialog, BasicPanel, and DFDesktop).

Last Edited: November 21, 2004


Properties for DfBaseControl

View property list in alphabetical order

Name | Description
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseControl

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseControl

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseDialog

Class: DfBaseDialog (Abstract)

Properties Events Methods Index of Classes

A container class that manages the controls that are placed in its scope

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
---------------------DfBasemdiclient
---------------------DfBasePanel

Library: Windows Application Class Library

Package:

Description

The DFBaseDialog class is a container class that manages the controls that are placed in its scope. This class is not intended to be used for instantiation. It does serve as the basis for a number of important classes (BasicPanel, ToolPanel, and Container3d and all of their subclasses.)

Of Special Note

The DfBaseDialog is never instantiated in applications. It is, however, used as the basis for most of the other container sub-classes. While this class contains a large number of properties most of them are properly set within the sub-class. For this reason, most of the properties and methods in this class are considered to be "advanced" - you should never need to change their default settings. In fact, it is the purpose of most of these sub-classes to hide the complexity of this class.

Client_Area_State

The DfBaseDialog class object initializes its client_area_state to true. This property controls the way activation and deactivation is performed on the object. When activated, it automatically activates all of its children (that do not have their focus_modes set to no_activate). The object then gives the focus to its first focusable child. This ability allows programs to activate a whole set of objects with one message. Note that the container object is never the focus itself.

Just as the DfBaseDialog changes the activate message, it also changes the deactivate message to remove all children of the container from the focus tree.

Container areas also change the default way that objects are added to the focus tree. Normally, objects are added to the next level of the focus and are kept in a linear-linked list. At the end of each level, the focus is directed to the next object at the prior level. All child objects that are activated with a container are added to the focus tree as a child of container.

Ring_State

Containers may change navigation at the end of a level by setting the ring_state property of the container object. The ends of the focus tree of a container will point to each other, creating a circular "ring" of navigation. This ring is often useful when the processing of information is repeated. Rings are ususally desriable within panel and view objects (BasicPanel, ModalPanel, View, etc.) and are undesirable for grouping objects (Container3d, Group). These sub-classes all set ring_state appropriately. You will rarely need to change this

Last Edited: November 21, 2004


Properties for DfBaseDialog

View property list in alphabetical order

Name | Description
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseDialog

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseDialog

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseEdit

Class: DfBaseEdit (Abstract)

Properties Events Methods Index of Classes

(Obsolete) Abstract class that allows users to enter multiple lines of text

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseEdit
---------------------Edit

Library: Windows Application Class Library

Package:

Description

Obsolete

This class is obsolete. It has been replaced with the DFBaseTextEdit class.

DfBaseEdit is used to allow users to enter multiple lines of text. Its sub-classes Edit and dbEdit should be used for sub-classing and instantiation.

Last Edited: November 22, 2004


Properties for DfBaseEdit

View property list in alphabetical order

Name | Description
Edit_Buffer_Count | The number of characters currently in the object
File_Name | Used whenever a read or write message is sent to the Edit object and a file_name parameter is not specified
Line_Count | Returns number of "lines" in Edit object
Position | Returns the location of the cursor in the object
Read_Only_State | Allows you to protect the contents of the buffer while still allowing users freedom to navigate
Text_Limit | The number of characters that can be entered into the edit
Value | The text value of an edit "line"
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseEdit

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseEdit

View method list in alphabetical order

Name | Type | Description
Append_Text | Procedure | Inserts data to the end of the existing contents of the object
Beginning_of_Data | Procedure | Moves the cursor to the beginning of the data in the object
Beginning_of_Line | Procedure | Moves then cursor to the beginning of the current line
Beginning_of_Panel | Procedure | Moves the cursor to the beginning of the data currently displayed
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Delete_Char | Procedure | Deletes the character under the cursor
Delete_Data | Procedure | Destroys all of the data in the object and returns the edit cursor to the top of the buffer
Delete_Line | Procedure | Deletes the current line
Down | Procedure | Moves the cursor down one line
End_of_Data | Procedure | Moves the cursor to the end of the data
End_of_Line | Procedure | Moves the cursor to the end of the current line
End_of_Panel | Procedure | Moves the cursor to the end of the last line on the current screen
Find | Procedure | Searches the text in an edit window
Insert | Procedure | Inserts a string of text into the edit buffer at the current cursor location
Left | Procedure | Moves the cursor one space to the left
Page_Down | Procedure | Moves the edit cursor down one page
Page_Up | Procedure | Moves the edit cursor up one page
Paste | Procedure | Copies the contents of the Clipboard into this object at the current cursor position
Read | Procedure | Imports information from an external source to the Edit object's buffer
Read_Dbms | Procedure | Reads information from a database file
Replace | Procedure | Finds and Replaces Text in an edit object
Reset_Find | Procedure | Causes the next find to search from the start of the text
Reset_Replace | Procedure | Causes the next replace to search from the start of the text.
Right | Procedure | Moves the cursor one space to the right
Select | Procedure | Marks the text in the editor beginning at position iPosition for the number of bytes set in charcount
Undo | Procedure | Will undo the last change in the edit
Up | Procedure | Moves the edit cursor up one line
Write | Procedure | Writes the contents of the edit buffer to the specified file
Write_Dbms | Procedure | Writes information from the edit buffer to a database field
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseEditPullDown

Class: DfBaseEditPullDown (Abstract)

Properties Events Methods Index of Classes

Abstract class that creates standard floating popup menus

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseActionBar
------------------------DfBasePullDown
---------------------------DfBaseEditPullDown
------------------------------FormFloatingPopupMenu

Library: Windows Application Class Library

Package:

Description

DfBaseEditPullDown is used to create standard floating popup menus. Its sub-classes FormFloatingPopupMenu, dbFloatingPopupMenu and FloatingPopupMenu should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBaseEditPullDown

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseEditPullDown

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseActionBar
Initialize_Menu | Sent when the Menubar system is about to be selected
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseEditPullDown

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseActionBar
Exit_Menu | Procedure |
Redirect_Message | Procedure |
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseEntry

Class: DfBaseEntry (Abstract)

Properties Events Methods Index of Classes

Allows the retrieval, display and storage of information between a database field and a form

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseComboBoxEntry
---------------------------DfBaseEntryList
---------------------------Entry

Library: Windows Application Class Library

Package:

Mixins: cm_Entry_Mixin

Description

DfBaseEntry is designed to be the basis of more-sophisticated data-entry classes (the dbEntry class) and is not intended for instantiation. The class allows the retrieval, display and storage of information between a database field and a form. The Entry class also provides for data verifications.

Of Special Note

DfBaseEntry objects provide entry items as the main data-interface mechanism of an application. An entry_item is a complex item based on the Form. In addition to the base definition, entry_items contain information that allow them to interface to the database and perform a variety of data entry related functions. Although the DfBaseEntry class supports multiple items (as does its form super-class) it is expected that there will only exist one item per entry object. Accordingly, all item-based messages will always refer to a single item, Item 0.

The EntryList class inherits all of the capabilities of this class through internal multiple inheritance. You will note that this class contains a number of multi-item, row based messages. These have little application for single item entry classes (like dbEntry) but are needed for the row based EntryList descendant classes (like dbGrid).

Entry_Item Command

An entry_item must be associated with a data source/destination. The source/destination is most-often a database field, but it also may include expressions, or variables. If the argument is a database field, then the normal data movement in both directions between the DBMS and the display will take place. Information will be displayed from the database and changed fields will be stored back in the record buffer. If the argument is a variable, then the variable is treated like a simple data file. The only difference is that the variable may not have any implied database access performed. If the argument is an expression, data will be displayed into the data window based on the evaluated value of the expression. However, the entry_item will be automatically marked as display only, so that users will be prevented from making entries to the item.

Entry_items have a full array of entry options designed to allow the DEO to control data being put to the database. These options include autofind, findreq, noput, skipfound, retainall, retain, forceput and autofind_ge. In addition to the above options, entry options exist (ientry, iexit, and ivalidate) that allow specialized processing when an entry_item is entered, validated and exited. These options are typically (usually preferably) applied to the field globally in a DataDictionary object, but they can be applied on an exception basis in individual DEOs.

Entry_items also have two properties designed to be used in the subclasses of DfBaseEntry. The iprompt and izoom entry options each specify an object. When users press the prompt or zoom accelerator keys, a message is sent to the object identified in the property. This allows custom zooming and prompting in a context-sensitive mode. These options are typically (usually preferably) applied to the field globally in a DataDictionary object, but they can be applied on an exception basis in individual DEOs.

DfBaseEntry options may be changed during the running of the program. The item_option(s) message(s) may be used to change the entry option(s) based on some condition in your program.

Prompt buttons

This class automatically supports prompt buttons. If a prompt object is defined for this object, a prompt button will appear automatically in it. When the button is pressed, the prompt message will be sent and a prompt object (usually a selection list) will appear. Prompt objects are usually acquired from the data-dictionary object, but may be explicitly defined by setting the prompt_object_id property.

If you do not want automatic prompt-button creation, this feature may be disabled by setting the property prompt_button_mode to PB_PromptOff. A prompt button may be explicitly created by setting the prompt_button_mode property to PB_PromptAuto.

The Form Superclass of DfBaseEntry

The DfBaseEntry class is a sub-class of the form class and inherits all of its capabilities. This includes support for masking, object-shadowing, status-help display, and context help support.

Subclasses of DfBaseEntry
The dbForm class is a full data-entry environment built from the DfBaseEntry class. Most often, you will be able to use the dbForm class to easily accomplish complex tasks. Creating new class definitions based on the DfBaseEntry class directly would be limited strictly to advanced, highly specialized purposes.

Last Edited: November 21, 2004


Properties for DfBaseEntry

View property list in alphabetical order

Name | Description
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseEntry

View event list in alphabetical order

Name | Description
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseEntry

View method list in alphabetical order

Name | Type | Description
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseEntryList

Class: DfBaseEntryList (Abstract)

Properties Events Methods Index of Classes

Abstract class suitable for "table" style data entry

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList

Library: Windows Application Class Library

Package:

Mixins: DfFormList_Mixin

Description

DfBaseEntryList combines all of the capabilities of the Grid class and the Entry class resulting in an abstract class suitable for "table" style data entry. Its sub-classes EntryList, dbGrid, dbList and CodePickList should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBaseEntryList

View property list in alphabetical order

Name | Description
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseEntryList

View event list in alphabetical order

Name | Description
Header_Notification | Sent when the header has received a mouse event
OnMouseWheel | An event sent everytime a mouse wheel is clicked
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseEntryList

View method list in alphabetical order

Name | Type | Description
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseForm

Class: DfBaseForm (Abstract)

Properties Events Methods Index of Classes

DfBaseForm is a superclass for classes supporting form data entry

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseComboBox
------------------------DfBaseEntry
------------------------DfBaseFormList
------------------------DfBasetabDialog
------------------------Form

Library: Windows Application Class Library

Package:

Description

DfBaseForm is a superclass for classes supporting form data entry. This is a private class and is not intended for instantiation or sub-classing. It is used as the basis for single item entry (Form) and multiple item row entry (Grid). It is also the ancestor class for database aware data entry - both single item (Entry) and multiple item (EntryList).

Of Special Note

The DfBaseForm class is designed to be the basis for more-capable data-entry classes. It is descended from the DfBaseList class and therefore inherits all of the properties and capabilities of the DfBaseList class. Its primary difference is that it sets each item's entry_state property to true. This allows keyboard entry when the object has the focus.

A number of important behaviors are added to this runtime class which is supported through the interface listed below.

The Value of a Form

The contents of a form is stored in its value property. When a Form-class object has the focus it will accept data from the keyboard directly into the value of the item. The value can also be directly changed and retrieved with the get and set value messages (get/set value item x to val). Any time the contents of a Form is changed (through keyboard or the set value message) the event message onChange is sent. Also, if users enter any change to the window, the item_changed_state and the changed_state of the object are set true.

Editing a Form's Value

The maximum length of a form's value is specified by the form_margin property. This property and a form's value may be longer than the actual width of the form's object. When this occurs, the text within a form scrolls horizontally.

Masking

This class supports input and display masking for a variety of data types (text, numeric, currency, and dates). The type of masking used is determined by the object's form_datatype (which supports both masked and non-masked types) and the object's form_mask.

Some masked forms support different formats for display and edit. When a masked form is displayed but is not the focus, the masked value is displayed with full format characters. For example, a currency mask might display with a currency symbol, decimal separators, and special symbols designating negative values. When this form takes the focus, the special symbols are all removed, since they cannot really be edited. When the focus is lost, the form is again reformatted.

The masking support provided here is low-level. Higher-level classes provide additional messages to make it easier to define and maintain masks. At the highest level, masks are defined in data dictionaries and applied to fields. All forms using those fields will acquire the required mask.

Form Buttons

The DfBaseForm class supports the ability to embed a button within a form. This is used by subclasses to support prompt buttons and spin buttons. The interface defined here is a low-level interface and should not be needed in normal programs. When spin buttons and prompt buttons are required, you are encouraged to use the higher-level classes that directly support them (SpinForm, dbSpinForm, dbForm).

Last Edited: November 21, 2004


Properties for DfBaseForm

View property list in alphabetical order

Name | Description
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseForm

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseForm

View method list in alphabetical order

Name | Type | Description
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseFormList

Class: DfBaseFormList (Abstract)

Properties Events Methods Index of Classes

Abstract class which should be used for creating multi-row, multi-column entry lists

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseFormList
---------------------------Grid

Library: Windows Application Class Library

Package:

Mixins: DfFormList_Mixin

Description

DfBaseFormList should be used for creating multi-row, multi-column entry lists. Its sub-class Grid should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBaseFormList

View property list in alphabetical order

Name | Description
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseFormList

View event list in alphabetical order

Name | Description
Header_Notification | Sent when the header has received a mouse event
OnMouseWheel | An event sent everytime a mouse wheel is clicked
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseFormList

View method list in alphabetical order

Name | Type | Description
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseGroup

Class: DfBaseGroup (Abstract)

Properties Events Methods Index of Classes

Abstract class creating visual group container objects with a gray background with a rectangular 3 D line border with a text label embedded in the top left edge

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseGroup
---------------------Group

Library: Windows Application Class Library

Package:

Description

DfBaseGroup is used to create visual group container objects with (by default) a gray background with a rectangular 3 D line border with a text label embedded in the top left edge. Its sub-classes Group, dbGroup, RadioGroup, RadioContainer, dbRadioGroup, and dbRadioContainer should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBaseGroup

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseGroup

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseGroup

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaselineControl

Class: DfBaselineControl (Abstract)

Properties Events Methods Index of Classes

Abstract class that creates divider lines on a container most-often to create a 3 D horizontal dividing line

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaselineControl
---------------------LineControl

Library: Windows Application Class Library

Package:

Description

DfBaselineControl is used to create divider lines on a container most-often to create a 3 D horizontal dividing line. Its sub-class LineControl should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBaselineControl

View property list in alphabetical order

Name | Description
Bottom_Line_Color |
Horizontal_State | Specifies whether the line is horizontal or vertical
Line_Offset |
Line_Style | Supports the line styles LnDip, LnBump, and LnSingle
Line_Thickness | Determines the pixel thickness of the line
Top_Line_Color |
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaselineControl

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaselineControl

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseList

Class: DfBaseList (Abstract)

Properties Events Methods Index of Classes

An intermediate class that is used as the basis for all "item- and form-based" classes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseActionBar
---------------------DfBaseButton
---------------------DfBaseForm
---------------------DfBaseListbox

Library: Windows Application Class Library

Package:

Mixins: Cm_List_Mixin Cm_Menu_Mixin DFListMenu_Mixin

Description

DFBaseList is an intermediate class that is used as the basis for all "item- and form-based" classes. This includes: menus (MenuBar, PopupMenu), entry forms (form, ComboForm), buttons (Button, Radio, CheckBox), lists (list) and entry tables (grid). All of the low-level item-based messages item_changed_state, value, aux_value, etc.) and form-based messages form_width, form_margin, etc.) are introduced in this class. This is an abstract class and is not intended for subclassing or instantiation.

Of Special Note

The DFBaseList class is the basic for most of the DataFlex control classes. This include single item classes (form, button, radio, etc.) and multiple item classes (list, grid, etc.). A number of important properties and messages are defined at this class level.

In older programs you will see the keyword item before the index value (e.g., set Value item 0 to "x"). The item keyword is optional. Its usage is no longer recommended.

Single-Item and Multi-Item Objects

The DfBaseList class is used as the basis for single-item and multi-item classes. A single-item object can be thought of as a multi-item class with only a single item. When setting item and form properties, this single item is usually identified as item 0. This simplifies the interface by allowing a single set of messages to be used with single- and multple-item objects. This does add a slight overhead to the interface by requiring that the single item number always be identified as item 0.

Multi-item objects are initialized with an empty list. The items must be added by the program. This is done using the commands item_list, on_item, end_item_list, or by using the messages add_item, insert_item, delete_item, and delete_data. The item_list commands tend to be used for creating static items. The messages are used for more-dynamic list manipulation. Normally you should use the messages (add_item, etc.) for all list creation. They are more-flexible and they allow you to use a single interface for static and dynamic list maintanence.

Single-item objects (form, button, radio, ComboForm, etc.) do not have to be added to an item list - the single item already exists. You control these values by setting their item and form properties (always for item 0).

Rows

Often a multi-item object needs to be arranged in rows. A row consists of a display area of one or more columns. Rows are defined by setting the line_width property. This expects two parameters: the number of columns in a row and the number of rows. Normally you only need to specify the number of columns and would like the object to calculate the number of rows based on the size of the object. This is done by passing a zero for number of rows. By default, the number of columns is 0. This creates a single-column list.

Set Line_Width to 1 0 // two columns,
Set Line_Width to 3 0 // four columns

The line_width of single-item objects will always be 0, 0.

Item-Based Properties

Item properties are those properties that are associated with a single item. Items exist independently of their display area. For example, a list object that can visually display five rows of data may contain 10 items or no items. An item may appear in any position within an object's display area or it may not appear in the display at all. Each item stores information in a number of item properties. The most-commonly used item properties are value, aux_value, message, shadow_state, entry_state, item_changed_state, and select_state. In addition, a number of item-based messages are supported to manipulate this item data. The most-commonly used messages are: send add_item, send delete_data, send insert_item, send delete_item, get item_count, and get/set current_item. Item properties and messages must be passed an item number. If an item number is not passed, the "current" item is used. If it is not clear what the current item will be (and it often is not) you should simply pass the item number in your message.

Set Value 0 to "John"

Get Item_Changed_State 3 to state

Get current_item to itm
Get shadow_state itm to state

Forms

Forms represent a display region. For example a display area may consist of 3 rows by 4 columns. There will be 12 forms (or form display regions) for this area. A number of display properties may be assigned to each form region. These properties all begin with the Form prefix. Examples of form properties are form_width, form_height, form_row, and form_datatype.

Form properties must be set passing a form number and the property setting. The form number must be passed.

Set Form_margin 0 to 20

Get Form_Height 10 to Var

There are many form messages. It would be rather tedious to have to assign each form property to each form region in the display. Fortunately, this is not required. The following rules are applied when creating form properties:

Most form properties will not need to be set. The class will usually set the appropriate form value for you. If a subclass does not refer to a form property in its documentation, you probably will not need to set it.

A form property applied to Item 0 (set form_property Item 0 to value) will be copied to all other form regions.

A form property applied to any form in the first column is copied to all other forms within the column. Number of columns is determined by setting the line_width property. When used with row-based objects, the form properties are most-often used with columns, and the reference Set Form_property item item# to value should probably be thought of as Set Form_property item column# to value.

Last Edited: November 21, 2004


Properties for DfBaseList

View property list in alphabetical order

Name | Description
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseList

View event list in alphabetical order

Name | Description
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseList

View method list in alphabetical order

Name | Type | Description
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseListbox

Class: DfBaseListbox (Abstract)

Properties Events Methods Index of Classes

Abstract low level List Class

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseListbox
------------------------List

Library: Windows Application Class Library

Package:

Description

Last Edited: November 21, 2004


Properties for DfBaseListbox

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseListbox

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseListbox

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBasemdiclient

Class: DfBasemdiclient (Abstract)

Properties Events Methods Index of Classes

Abstract class providing low-level support for an MDI-style client area

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasemdiclient
------------------------MdiClientArea

Library: Windows Application Class Library

Package:

Description

DfBasemdiclient is used to provide low-level support for an MDI-style client area. Its sub-classes MdiClientArea, AppClientArea, and ClientArea should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBasemdiclient

View property list in alphabetical order

Name | Description
Scroll_Bar_Visible_State | Specifies whether this object is to display a scroll bar (or bars) when the content of the object exceeds this object's same-time display capacity
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBasemdiclient

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBasemdiclient

View method list in alphabetical order

Name | Type | Description
Arrange_Icons | Procedure | Arranges the icons for all minimized views contained by this object
Cascade_Windows | Procedure | Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it
Switch_Next_View | Procedure | Switches the focus to the next view object in this object
Switch_Prior_View | Procedure | Switches the focus to the previous view object in this object
Tile_Windows_Horizontal | Procedure | Arranges this object's views from left to right across the top, and then down to the next line, also so arranged
Tile_Windows_Vertical | Procedure | Arranges this object's views from top to bottom down the left side, and then right to the next column, also so arranged
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseObject

Class: DfBaseObject (Abstract)

Properties Events Methods Index of Classes

Provides a level of abstraction that separates the basic object support from the GUI support

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow

Library: Windows Application Class Library

Package:

Description

The DfBaseObject class provides a level of abstraction that separates the basic object support from the GUI support.

Of Special Note

This merges the most basic window object behavior with the Visual DataFlex cUIObject class. None of these changes are public.

Last Edited: November 21, 2004


Properties for DfBaseObject

View property list in alphabetical order

Name | Description
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseObject

View event list in alphabetical order

Name | Description
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseObject

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBasePanel

Class: DfBasePanel (Abstract)

Properties Events Methods Index of Classes

Provides a top-level window for applications that is independent of all other windows

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------BasicPanel
------------------------cDesktop
------------------------DfBasetoolPanel

Library: Windows Application Class Library

Package:

Description

The DfBasePanel container class provides a top-level window for applications that is independent of all other windows. By default, a DFPanel object has icons for maximize and minimize, a resizable border, system-menu icon, and a caption bar.

Of Special Note

This class inherits all the capabilities of the DfBaseDialog class, but with several different property settings. For example, Maximize_icon, minimize_icon, caption_bar, and sysmenu_icon are all set to true. Also, the border_style (border_thick) allows the objects to be resized.

Panel objects reside visually on the Windows desktop and may be moved anywhere on this desktop. They are never bound by another panel. This class will probably never be used for instantiation or user sub-classing. It is the ancestor class of a number of important panel classes: Panel, BasicPanel, ToolPanel and ModalPanel.

Different Panel Classes

A typical application in Visual DataFlex will consist of a single main-panel that contains visual components that are bound within this panel. These components (which will comprise most of your application) consists of menus, tool-bars, status-bars, and a client-area. The client area will contain a number of views (dialogs that are bound within the client area). This describes a typical windows MDI (multiple-document interface) application structure. Additional panels may be used which are not bound to the main-panel (i.e., they can be moved off of the main-panel). These tend to be popup objects and will be non-modal tool-panels or modal panels. Specialized classes, all descendant of the DFPanel class, exist for main, tool and modal panels (Panel, ToolPanel and ModalPanel).

Objects based on this class will always appear in the windows task list. Normally your main-panel object should be the only entry in the windows task list. If you need to create a panel that does not appear on the task list you should base your objects on the ToolPanel or ModalPanel class.

This class's properties are unchanged from those of its superclass.

This class's procedures and functions are unchanged from those of its superclass.

Last Edited: November 21, 2004


Properties for DfBasePanel

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBasePanel

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBasePanel

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBasePullDown

Class: DfBasePullDown (Abstract)

Properties Events Methods Index of Classes

Abstract class that creates standard floating popup menus

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseActionBar
------------------------DfBasePullDown
---------------------------DfBaseEditPullDown
---------------------------PopupMenu
---------------------------SystemMenu

Library: Windows Application Class Library

Package:

Description

DfBaseEditPullDown is used to create standard floating popup menus. Its sub-classes FormFloatingPopupMenu, dbFloatingPopupMenu, FloatingPopupMenu, PopupMenu, DEOPopupMenu, and ViewPopupMenushould be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBasePullDown

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBasePullDown

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseActionBar
Initialize_Menu | Sent when the Menubar system is about to be selected
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBasePullDown

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseActionBar
Exit_Menu | Procedure |
Redirect_Message | Procedure |
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBasePushButton

Class: DfBasePushButton (Abstract)

Properties Events Methods Index of Classes

Abstract class creating visual representations of keys or buttons that, when pressed by users, produce a specific action with an immediate response

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseButton
------------------------DfBasePushButton
---------------------------Button

Library: Windows Application Class Library

Package:

Description

DfBasePushButton class is used to create visual representations of keys or buttons that, when pressed by users, produce a specific action with an immediate response. Its sub-class Button should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBasePushButton

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBasePushButton

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBasePushButton

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseRadioButton

Class: DfBaseRadioButton (Abstract)

Properties Events Methods Index of Classes

Abstract class that provides support for stand-alone radio buttons

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseButton
------------------------DfBaseCheckbox
---------------------------DfBaseRadioButton
------------------------------RadioButton

Library: Windows Application Class Library

Package:

Description

DfBaseRadioButton provides support for stand-alone radio buttons. Its sub-classes RadioButton and Radio should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBaseRadioButton

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseRadioButton

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseRadioButton

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DFBaseRichEdit

Properties Events Methods Index of Classes

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DFBaseRichEdit
---------------------cRichEdit

Library: Windows Application Class Library

Package:

Description

Last Edited: November 11, 2004


Properties for DFBaseRichEdit

View property list in alphabetical order

Name | Description
Line_Count | Returns number of lines in control
paValue | Sets content of control from memory address or places RTF stream in control into memory address
pbAutoUrl | Toggles the ability for the control to automatically detect URLs and add hyperlinks
pbBold | Toggles selected text between bold and normal text
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard
pbCanRedo | Determines whether a redo operation can be performed
pbCanUndo | Determines whether an undo operation can be performed
pbItalics | Toggles selected text between italicized and normal text
pbLink | Toggles selected text between hyperlinked and normal text
pbProtect | Toggles selected text between protected and normal text
pbStrikeOut | Toggles selected text between strikeout and normal text
pbSubScript | Toggles selected text between subcripted and normal text
pbSuperScript | Toggles selected text between superscripted and normal text
pbUnderline | Toggles selected text between underlined and normal text
pbWrap | Determines whether text input will break and wrap to the next line at right margin
peAlignment | Sets or returns alignment of selected paragraph or paragraphs
peBullets | Sets or returns bullets or numbering of selected paragraph or paragraphs
peBulletStyle | Sets or returns numbering styles of selected paragraph or paragraphs
peCharSet | Sets or returns character set of selected text
peLineSpacingType | Determines type of line spacing of selected paragraph or paragraphs
pePitchandFamily | Sets or returns the font pitch and family of selected text
piBulletStart | Sets or returns the starting number of paragraph numbering of selected paragraph or paragraphs
piBulletTab | Sets or returns the minimum space between a paragraph bullet or number and the paragraph text of selected paragraph or paragraphs
piFontSize | Sets or returns font size of selected text
piFontWeight | Sets or returns font weight of selected text
piLineSpacing | Determines exact line spacing of selected paragraph or paragraphs
piMaxChars | Sets or returns maximum number of characters
piOffsetIndent | Sets or returns indentation of 2nd and subsequent lines, relative to first line, of selected paragraph or paragraphs
piParagraphIndent | Sets or returns indentation of selected paragraph or paragraphs
piRightMargin | Determines indentation of right side of control's text, relative to the right margin
piSpacingAfter | Determines the spacing below selected paragraph or paragraphs
piSpacingBefore | Determines the spacing above selected paragraph or paragraphs
psTypeFace | Sets or returns font typeface of selected text
Read_Only_State | Determines whether users may edit the content of the control
TextBackColor | Sets or returns background color of selected text
TextColor | Sets or returns color of selected text
Value | Sets or returns content of control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DFBaseRichEdit

View event list in alphabetical order

Name | Description
OnLinkClicked | Fires when hyperlink in text is clicked
OnSelectionChanged | Fires when selection changes
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DFBaseRichEdit

View method list in alphabetical order

Name | Type | Description
AppendText | Procedure | Appends text to end of text in control
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control
Beginning_of_Line | Procedure | Places the cursor at beginning of current line
CharCount | Function | Returns length of RTF stream in the control
ClearUndoBuffer | Procedure | Clears undo buffer
Delete_Data | Procedure | Deletes all data in control
End_of_Data | Procedure | Places the cursor at end of the text in control
End_of_Line | Procedure | Places the cursor at end of current line
FindText | Function | Searches for specified text in control
FirstCharInLinePos | Function | Returns position of first character in a line
FirstVisibleLine | Function | Returns number of first visible line
HideSelection | Procedure | Toggles selection highlighting on or off
LastErrorCode | Function | Returns error code for last operation
Line | Function | Returns specified line of text
LineFromChar | Function | Returns number of line that contains specified character position or current line
LineLength | Function | Returns number of characters in line
Read | Procedure | Reads RTF document and displays it in the control
Redo | Procedure | Redoes the last operation
RedoType | Function | Returns type of redo operation at top of redo queue
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements
ReplaceSel | Procedure | Replaces selected text with specified text
Scroll | Procedure | Scrolls up or down the control using specified scroll mode
ScrollCaret | Procedure | Scrolls caret into view
ScrollLines | Procedure | Scrolls control vertically for specified number of lines
Select_All | Procedure | Selects entire contents of control
SelEnd | Function | Returns end of selection
SelStart | Function | Returns beginning of selection
SelText | Function | Returns selected text
SetSel | Procedure | Selects text in given position range
TextRange | Function | Returns text in given position range
Undo | Procedure | Undoes the last operation
UndoType | Function | Returns type of undo operation at top of undo queue
Write | Procedure | Writes RTF stream content of control to file
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBasetabDialog

Class: DfBasetabDialog (Abstract)

Properties Events Methods Index of Classes

Abstract class used for TabDialogs

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBasetabDialog
---------------------------TabDialog_

Library: Windows Application Class Library

Package:

Description

A tab dialog is created by creating a TabDialog object and then creating TabPage objects inside it. Its sub-classes TabDialog, dbTabDialog and dbTabDialogView should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBasetabDialog

View property list in alphabetical order

Name | Description
Tooltip_State |
Tooltip_Value |
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBasetabDialog

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBasetabDialog

View method list in alphabetical order

Name | Type | Description
Auto_Page | Procedure |
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseTextbox

Class: DfBaseTextbox (Abstract)

Properties Events Methods Index of Classes

Abstract class that enables placing static text strings on the display

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseTextbox
---------------------TextBox

Library: Windows Application Class Library

Package:

Description

DfBaseTextbox is used to enable placing static text strings on the display. Its sub-classes Textbox and DfTimer should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfBaseTextbox

View property list in alphabetical order

Name | Description
Justification_Mode | Aligns the text in the control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseTextbox

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseTextbox

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DFBaseTextEdit

Properties Events Methods Index of Classes

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DFBaseTextEdit
---------------------cTextEdit

Library: Windows Application Class Library

Package:

Description

Last Edited: November 19, 2004


Properties for DFBaseTextEdit

View property list in alphabetical order

Name | Description
Line_Count | Returns number of lines in control
paValue | Sets content of control from memory address or places text in control into memory address
pbBold | Toggles all text in control between bold and normal text
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard
pbCanRedo | Determines whether a redo operation can be performed
pbCanUndo | Determines whether an undo operation can be performed
pbItalics | Toggles all text in control between italic and normal text
pbWrap | Determines whether text input will break and wrap to the next line at right margin
piFontSize | Sets or returns font size of all text in control
piFontWeight | Sets or returns font weight of all text in control
piMaxChars | Sets or returns maximum number of visible characters
piRightMargin | Determines indentation of right side of control's text, relative to the right margin
psTypeFace | Sets or returns font typeface of all text in control
Read_Only_State | Determines whether users may edit the content of the control
Value | Sets or returns content of control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DFBaseTextEdit

View event list in alphabetical order

Name | Description
OnSelectionChanged | Fires when selection changes
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DFBaseTextEdit

View method list in alphabetical order

Name | Type | Description
AppendText | Procedure | Appends text to end of text in control
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control
Beginning_of_Line | Procedure | Places the cursor at beginning of current line
CharCount | Function | Returns the number of characters in the control
ClearUndoBuffer | Procedure | Clears undo buffer
Delete_Data | Procedure | Deletes all data in control
End_of_Data | Procedure | Places the cursor at end of the text in control
End_of_Line | Procedure | Places the cursor at end of current line
FindText | Function | Searches for specified text in control
FirstCharInLinePos | Function | Returns position of first character in a line
FirstVisibleLine | Function | Returns number of first visible line
HideSelection | Procedure | Toggles selection highlighting on or off
LastErrorCode | Function | Returns error code for last operation
Line | Function | Returns specified line of text
LineFromChar | Function | Returns number of line that contains specified character position or current line
LineLength | Function | Returns number of characters in line
Read | Procedure | Reads text file and displays it in the control
Redo | Procedure | Redoes the last operation
RedoType | Function | Returns type of redo operation at top of redo queue
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements
ReplaceSel | Procedure | Replaces selected text with specified text
Scroll | Procedure | Scrolls up or down the control using specified scroll mode
ScrollCaret | Procedure | Scrolls caret into view
ScrollLines | Procedure | Scrolls control vertically for specified number of lines
Select_All | Procedure | Selects entire contents of control
SelEnd | Function | Returns end of selection
SelStart | Function | Returns beginning position of selection
SelText | Function | Returns selected text
SetSel | Procedure | Selects text in given position range
TextRange | Function | Returns text in given position range
Undo | Procedure | Undoes the last operation
UndoType | Function | Returns type of undo operation at top of undo queue
Write | Procedure | Writes text file content of control to file
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBasetoolPanel

Class: DfBasetoolPanel (Abstract)

Properties Events Methods Index of Classes

Abstract class that creates tool panels - panels that are not listed on the Windows task list

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------CursorShape
---------------------------FloatingPanel

Library: Windows Application Class Library

Package:

Description

The DfBasetoolPanel class provides runtime support for handling toolpanels. ToolPanel container classes create panels that are not listed on the Windows task list. The can be modal (modal-panels) and non-modal (tool-panels). Its sub-classes ToolPanel, ModalPanel, and dbModalPanel should be used for sub-classing and instantiation.

See Also

ToolPanel | ModalPanel | dbModalPanel

Last Edited: November 21, 2004


Properties for DfBasetoolPanel

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBasetoolPanel

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBasetoolPanel

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseUIWindow

Class: DfBaseUIWindow (Abstract)

Properties Events Methods Index of Classes

Adds a layer of support for user interaction to DfBaseWindow

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
---------------DfBaseControl

Library: Windows Application Class Library

Package:

Description

The DfBaseUIWindow class adds a layer of support for user interaction (such as mouse and keyboard input) to DfBaseWindow.

Last Edited: July 10, 2003


Properties for DfBaseUIWindow

View property list in alphabetical order

Name | Description
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseUIWindow

View event list in alphabetical order

Name | Description
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseUIWindow

View method list in alphabetical order

Name | Type | Description
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfBaseWindow

Class: DfBaseWindow (Abstract)

Properties Events Methods Index of Classes

Specifies a layer of presentation support for GUI objects

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow

Library: Windows Application Class Library

Package:

Description

The DfBaseWindow class specifies a layer of presentation support for GUI objects. DfBaseWindow manages the colors, fonts, location and size of a GUI object.

Of Special Notice

This class provides the interface level required to create and display visual objects. Messages are provided to size and locate objects and set other display characteristics common to all all visual classes.

Windows Objects

Each Visual DataFlex object has the ability to create, use, and then destroy Windows objects. When a Visual DataFlex object is paged it creates windows object and displays it. When the Visual DataFlex object is un-paged, the Windows object is removed and destroyed. Under normal circumstances all communication with this Windows object is private; the Visual DataFlex object handles this for you.

It is possible to send messages directly to a Windows object. This class adds that layer of interface support. The messages that allow you to directly communicate with the Windows object are: get/set window_handle, get/set container_handle, get/set window_style, get/set extended_window_style, send page, and send page_delete.

This is a very low level interface. You are bypassing the Visual DataFlex message interface and communicating directly with the windows object. If you choose to do this:

  • You must understand the Windows classes and their interface (API). This is a C style interface and, like most C style programs, improper use may result in serious and unpredictable problems.
  • If you are familiar with the Windows API you should study the WinUser.pkg and CommCtrl.pkg packages. These provide replacements for a number of the Windows API constants. These packages are purposefully undocumented. If they do not make sense, you probably should not be using them.
  • Be aware the Windows objects are created and destroyed each time the Visual DataFlex object is paged and unpaged. When an object is not paged, there is no Windows object to send a message to (window_handle will be 0). If you are using a Windows object as a storage structure be aware that this storage structure only exists while the object is paged. On the other hande, the Visual DataFlex object and all of its data exists until it is explicitly destroyed or the program ends.

It is not intended that you should need to use this low level Windows interface. It is, however, an extremely powerful extension which provides full access to standard Windows controls.

Last Edited: November 21, 2004


Properties for DfBaseWindow

View property list in alphabetical order

Name | Description
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfBaseWindow

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfBaseWindow

View method list in alphabetical order

Name | Type | Description
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfComActiveXControl

Class: DfComActiveXControl (Abstract)

Properties Events Methods Index of Classes

Abstract class which provides support forwrapping of Active X controls

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfComUIObject
---------DfInPlaceComObject
------------DfComActiveXControl
---------------cComActiveXControl

Library: Windows Application Class Library

Package:

Description

The DfComActiveXControl provides interface support for wrapping Active X controls. Its sub-classes cComActiveXControl and cComdbActiveXControl should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfComActiveXControl

View property list in alphabetical order

Name | Description
Inherited Properties from DfInPlaceComObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key when ActiveX controls use a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from DfComUIObject
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Border_Style | Specifies the border style of this object
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
Mouse_Capture |
peAnchors | Describes how you want the control to react whenever its container changes size
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Shadow_State | Determines if item is enabled (not shadowed)
TextColor | Sets the text color of the object
Window_Handle | Returns the Windows window handle of the DataFlex object
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfComActiveXControl

View event list in alphabetical order

Name | Description
Inherited Events from DfInPlaceComObject
OnCreate |
Inherited Events from DfComUIObject
Command | Sent from external controls
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfComActiveXControl

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfInPlaceComObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object
RegisterComEvent | Procedure |
RegisterPropertyChangeEvent | Procedure |
ReleaseComObject | Procedure | Releases ActiveX control associated with this object
Inherited Methods from DfComUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
Release_Mouse_Capture | Procedure |
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfComAutomationObject

Class: DfComAutomationObject (Abstract)

Properties Events Methods Index of Classes

Abstract class for imported OLE Automation Objects

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---DfComAutomationObject
------cComAutomationObject

Library: Windows Application Class Library

Package:

Description

The DfComAutomationObject provides interface support for wrapping OLE Automation objects. Its sub-class cComAutomationObject should be used for sub-classing and instantiation.

Last Edited: December 20, 2005


Properties for DfComAutomationObject

View property list in alphabetical order

Name | Description
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key for Automation objects using a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfComAutomationObject

View event list in alphabetical order

Name | Description
OnCreate | Sent right after a COM object is created
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfComAutomationObject

View method list in alphabetical order

Name | Type | Description
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Connects to an instance of the Automation object
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine.
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DFComDocumentObject

Class: DFComDocumentObject (Abstract)

Properties Events Methods Index of Classes

Abstract class which provides support for embedded document objects

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfComUIObject
---------DfInPlaceComObject
------------DFComDocumentObject
---------------cComDocumentObject

Library: Windows Application Class Library

Package:

Description

The DFComDocumentObject provides interface support for wrapping OLE Automation objects. Its sub-class cComDocumentObject should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DFComDocumentObject

View property list in alphabetical order

Name | Description
Inherited Properties from DfInPlaceComObject
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key when ActiveX controls use a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from DfComUIObject
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Border_Style | Specifies the border style of this object
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
Mouse_Capture |
peAnchors | Describes how you want the control to react whenever its container changes size
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Shadow_State | Determines if item is enabled (not shadowed)
TextColor | Sets the text color of the object
Window_Handle | Returns the Windows window handle of the DataFlex object
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DFComDocumentObject

View event list in alphabetical order

Name | Description
Inherited Events from DfInPlaceComObject
OnCreate |
Inherited Events from DfComUIObject
Command | Sent from external controls
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DFComDocumentObject

View method list in alphabetical order

Name | Type | Description
CreateComObjectFromFile | Procedure | Creates a new document and initializes it with data read in from the file passed in the sFile parameter
SaveToFile | Procedure |
Inherited Methods from DfInPlaceComObject
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object
RegisterComEvent | Procedure |
RegisterPropertyChangeEvent | Procedure |
ReleaseComObject | Procedure | Releases ActiveX control associated with this object
Inherited Methods from DfComUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
Release_Mouse_Capture | Procedure |
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfComUIObject

Class: DfComUIObject (Abstract)

Properties Events Methods Index of Classes

Abstract class which provides standard UI interfaces for Com Objects

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfComUIObject
---------DfInPlaceComObject

Library: Windows Application Class Library

Package:

Description

The DfComUIObject provides standard UI interfaces support for wrapping OLE Active/X objects. Its sub-classes cComActiveXControl, cComdbActiveXControl, and cComDocumentObject should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfComUIObject

View property list in alphabetical order

Name | Description
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Border_Style | Specifies the border style of this object
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
Mouse_Capture |
peAnchors | Describes how you want the control to react whenever its container changes size
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Shadow_State | Determines if item is enabled (not shadowed)
TextColor | Sets the text color of the object
Window_Handle | Returns the Windows window handle of the DataFlex object
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfComUIObject

View event list in alphabetical order

Name | Description
Command | Sent from external controls
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfComUIObject

View method list in alphabetical order

Name | Type | Description
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
Release_Mouse_Capture | Procedure |
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DfInPlaceComObject

Class: DfInPlaceComObject (Abstract)

Properties Events Methods Index of Classes

Abstract class which provides standard COM interfaces for Com Objects

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfComUIObject
---------DfInPlaceComObject
------------DfComActiveXControl
------------DFComDocumentObject

Library: Windows Application Class Library

Package:

Description

The DfInPlaceComObject provides standard COM interfaces support for wrapping OLE Active/X objects. Its sub-classes cComActiveXControl, cComdbActiveXControl, and cComDocumentObject should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for DfInPlaceComObject

View property list in alphabetical order

Name | Description
peAutoCreate | Manipulates COM Object instantiation
psLicenseKey | Contains the license key when ActiveX controls use a run-time license
psProgID | Holds the CLSID (class ID) of the COM class represented
pvComObject | Returns an IDispatch pointer to the external COM object
Inherited Properties from DfComUIObject
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Border_Style | Specifies the border style of this object
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
Mouse_Capture |
peAnchors | Describes how you want the control to react whenever its container changes size
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Shadow_State | Determines if item is enabled (not shadowed)
TextColor | Sets the text color of the object
Window_Handle | Returns the Windows window handle of the DataFlex object
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DfInPlaceComObject

View event list in alphabetical order

Name | Description
OnCreate |
Inherited Events from DfComUIObject
Command | Sent from external controls
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DfInPlaceComObject

View method list in alphabetical order

Name | Type | Description
ComAddref | Procedure |
ComQueryInterface | Function |
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object
RegisterComEvent | Procedure |
RegisterPropertyChangeEvent | Procedure |
ReleaseComObject | Procedure | Releases ActiveX control associated with this object
Inherited Methods from DfComUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
Release_Mouse_Capture | Procedure |
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: DFTimer

Properties Events Methods Index of Classes

DFTimer objects can be used to trigger an event after a certain amount of time has passed.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseTextbox
---------------------TextBox
------------------------DFTimer

Library: Windows Application Class Library

Package: Dftimer.pkg

Description

DFTimer objects can be used to trigger an event after a certain amount of time has passed.

Sample

Use windows.pkg
Use DFTimer.pkg

Object oTestPanel is a BasicPanel
    Set Label to "Timer Test Panel"
    Set Size to 162 178
    Set Minimize_Icon to FALSE
    Set Maximize_Icon to FALSE
    Set Border_Style to Border_Dialog

    Property Integer piUserTimeout 1000

    Set Locate_Mode to Center_on_Screen

    Object oBorder1 is a Container3d
        Set Size to 114 162
        Set Location to 7 6

        Object oGroup1 is a Group
            Set Label to "Explanation"
            Set Size to 56 151
            Set Location to 9 4

            Object TextBox1 is a TextBox
                Set Label to "This sample program triggers a timer event"
                Set Location to 12 6
            End_Object    // TextBox1

            Object TextBox2 is a TextBox
                Set Label to "whenever 'Timeout' milliseconds have "
                Set Location to 21 6
            End_Object    // TextBox2

            Object TextBox3 is a TextBox
                Set Label to "passed. You can change the time out value"
                Set Location to 30 6
            End_Object    // TextBox3

            Object TextBox4 is a TextBox
                Set Label to "dynamically. Timer has been 'Auto_Started'."
                Set Location to 39 6
            End_Object    // TextBox4

        End_Object  // oGroup1

        Object oTimeoutForm is a Form
            Set Label to "Timeout value"
            Set Label_Col_Offset to 4
            Set Label_Justification_Mode to jMode_Right
            Set Size to 13 51
            Set Location to 73 56
            Set Value to (piUserTimeout(self))

            Procedure OnKillFocus
                Integer iTimeOut

                Get Value to iTimeOut
                Set piUserTimeout to iTimeOut // will delegate
            End_Procedure

            // This procedure will be called by the timer object
            // whenever a timout occurs.
            Procedure Increment_Counter
                Integer iValue

                Get Value to iValue
                Increment iValue
                Set Value to iValue
            End_Procedure

        End_Object    // Timeout

        Object oEventCount is a Form
            Set Label to "Event fired"
            Set Label_Col_Offset to 4
            Set Label_Justification_Mode to jMode_Right
            Set Size to 13 51
            Set Location to 90 56
            Set Enabled_State to False

            // This procedure will be called by the timer object
            // whenever a time out occurs.
            Procedure Increment_Counter
                Integer iValue

                Get Value to iValue
                Increment iValue
                Set Value to iValue
            End_Procedure

        End_Object    // oEventCount

        Object TextBox1 is a TextBox
            Set Label to "milliseconds"
            Set Location to 74 112
        End_Object    // TextBox1

        Object TextBox2 is a TextBox
            Set Label to "times"
            Set Location to 92 112
        End_Object    // TextBox2

    End_Object    // oBorder1

    Object oStartButton is a Button
        Set Label to 'Start Timer'
        Set Location to 127 6
        Procedure OnClick
           Send Start_Timer
        End_Procedure // OnClick
    End_Object    // oStartButton

    Object oStopButton is a Button
        Set Label to 'Stop Timer'
        Set Location to 127 62
        Procedure OnClick
           Send Stop_Timer
        End_Procedure // OnClick
    End_Object    // oStopButton

    Object oCancelButton is a Button
        Set Label to 'Close'
        Set Location to 127 118
        Procedure OnClick
           Send Exit_Application
        End_Procedure // OnClick
    End_Object    // oCancelButton

    // This is the actual timer object.
    Object oTimer is a DFTimer
        // Things you might set:
        //   Set Timeout to 2000
        //   Set Auto_Start_State to TRUE|FALSE
        //   Set Auto_Stop_State to TRUE|FALSE
        //   Set Timer_Message to MyMessage
        //   Set Timer_Object to oMyObject
        //   Set Timer_Active_State to TRUE|FALSE
        Procedure OnTimer
            Send Increment_Counter of ;
                (oEventCount(oBorder1))
            // Or whatever you like!
        End_Procedure
        // The same as above can be accomplished by this:
        //    Set Timer_Message to Increment_Counter
        //    Set Timer_Object  of (oEventCount(oDialog1))
    End_Object  // oTimer

    Procedure Start_Timer
        Set Timeout of oTimer to (piUserTimeout(Self))
        Set Timer_Active_State of oTimer to True
    End_Procedure

    Procedure Stop_Timer
        Set Timer_Active_State of oTimer to False
    End_Procedure
End_Object    // oTestPanel

Send Activate of oTestPanel
Start_UI

Syntax

Object oMyTimer is a DFTimer
    Set TimeOut to 2000                // Default 1000
    Set Auto_Start_State to TRUE| FALSE
    Set Auto_Stop_State to TRUE| FALSE
    Set Timer_Message to MyMessage
    Set Timer_Object to oMyObject
    Set Timer_Active_State to TRUE|FALSE

    // Define when no Timer_Message
    Procedure OnTimer
        Send Info_Box "text"
    End_Procedure
End_Object

Of Special Note

Objects of this class can be used to trigger an event every time a certain amount of time has passed since the last event or the timer was activated. You can specify this time interval by setting the timeout property of the object. This value is stated in milliseconds, but the effective resolution of events is about 55 milliseconds, so there would be little point in specifying intervals more-precisely than this.

At the prescribed interval, the timer will send an onTimer event. You can trap this event to do whatever you want. By default, this onTimer event will send the timer_message to the timer_object, when both of these exist and have been specified.

A timer is activated by setting its timer_active_state true. When the timer has been placed inside a user-interface object, it will be activated automatically when the user-interface object is activated. This is governed by the auto_start_state property, which is true by default. The timer will automatically stop when the user-interface object is deactivated. This is governed by the auto_stop_state property, which is also true by default.

When you wish to set a new timeout interval, you can do so even when the timer is active. It will adjust the timeout immediately.

Note that timer events depend on Windows for the delivery of the event. Since timer events get a low priority in Windows, Windows may stop the timer process when other programs are very busy. When this happens, the timer will stop until the process is resumed. There is no way, other than calculating it yourself, to determine how much time passed or how many timer events should have happened between the last timer event before the process was stopped and the first event after the process is resumed.

See Also

Info_Box

Last Edited: November 23, 2004


Properties for DFTimer

View property list in alphabetical order

Name | Description
Auto_Start_State | Specifies whether this object will initialize when its container object is activated
Auto_Stop_State | Specifies whether this object will stop running when its container object is deactivated
Timeout | Contains the number of milliseconds that you wish to pass between each timer event
Timer_Active_State | Starts and stops the timer
Timer_Message | Contains the message_id of the message to be sent on every timer event
Timer_Object | Handle of optional object that timer will send timer_message to
Inherited Properties from TextBox
Auto_Size_State | Determines if textbox object will automatically size itself
Bitmap | Displays a bitmap in an object
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Label_Shadow_Display_Mode | Controls under what conditions this object is shadowed
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Inherited Properties from DfBaseTextbox
Justification_Mode | Aligns the text in the control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for DFTimer

View event list in alphabetical order

Name | Description
OnTimer | Sent every time the timeout interval passes
Inherited Events from TextBox
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for DFTimer

View method list in alphabetical order

Name | Type | Description
Inherited Methods from TextBox
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Dialog

Properties Events Methods Index of Classes

Creates non-MDI-child dialog objects

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------Dialog

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Panel_Mixin Modal_Mixin DefaultActionButton_Mixin

Description

The Dialog creates non-MDI-child dialog objects. A Dialog object has icons for maximize and minimize, a non-resizable border, system-menu icon, and a caption bar. Since views in Visual DataFlex should be MDI views, this class serves little purpose and is included for completeness.

Syntax

This class is not intended for instantiation.

Resizing a Dialog

When an object of this class is resized by users, this object sends the OnResize message to itself. This message is supplied with no definition as a "hook" procedure to use when some action, such as resizing child list objects, is desired on resizing of this object.

Most likely, you would use anchors (see peAnchors) for resizing, unless you need some specialized resizing that anchors do not handle.

Last Edited: December 2, 2005


Properties for Dialog

View property list in alphabetical order

Name | Description
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Dialog

View event list in alphabetical order

Name | Description
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Dialog

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure |
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Edit

Properties Events Methods Index of Classes

(Obsolete) Allows users to enter multiple lines of text

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseEdit
---------------------Edit
------------------------dbEdit_

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Object_Mixin Dflabel_Mixin Shadow_Mixin RGB_Support_Temp_Mixin Help_Mixin

Description

Obsolete

This class is obsolete. It has been replaced with the cTextEdit class.

Edit-class objects are general variable-length text editors. Applications use the Edit class to allow users to enter multiple lines of text.

Sample

Object Edit1 is an Edit
    Set Location to 10 15
    Set Size to 40 40
    Set Label to "Comments:"
End_Object

Object Edit2 is an Edit
    Set Location to 60 15
    Set Size to 50 40
    Set Wrap_State to False // horizontal scroll support
    Set Label to "Source Listing:"
    Set Read_Only_State to True
End_Object

Syntax

Use windows

Object object_name is an Edit
    Set Size to height width
    Set Location to row column

    Set Label to LabelText
    Set Label_Justification_Mode to mode
    Set Label_Row_Offset to Num
    Set Label_Col_Offset to Num

    Set Status_Help to StatusHelpText

    Set Text_Limit to MaximumCharacters
    Set Wrap_State to true| false
    Set Enabled_State to true| false
    Set Read_Only_State to true| false
    Set Capslock_State to true| false

    Procedure onChange
        :
    End_Procedure

    Procedure onSetFocus
        :
    End_Procedure

    Procedure onKillFocus
        :
    End_Procedure

    Procedure onMaxText
        :
    End_Procedure
End_Object

Shadowing

Shadowing refers to the process of making an object or an item unavailable for data entry. Usually the appearance of a shadowed object is changed in some way to indicate its unavailability.

This class supports object shadowing. Accordingly, objects of this class will be shadowed whenever an ancestor object is shadowed or when the object's enabled_state is explicitly set to false. When shadowed, the edit object cannot be entered (it will not take the focus).

Read-Only

It is often desirable to disallow modification of the contents of an edit area by users. The read_only_state will allow you to protect the contents of the buffer while still allowing users freedom to navigate. Shadowing disallows entry into the object. A read-only object may take the focus but will disallow changes.

Labels

Edits often require an associated description or label. Labels are supported with the set label message. By default, labels appear above the top left corner of the edit object. The location and justification mode of labels can be controlled with the properties label_col_offset, label_row_offset and label_justification_mode.

Position and Offset of the Caret

To find the position of the caret use the position function to return its row and column. To get the offset from the beginning of the buffer in bytes, use the current_offset function.

The position of the caret can be changed (thereby changing where data entry will occur) by using the move_absolute function or any of the navigation messages such as page_up or end_of_panel. These are described in the section "Procedures and Functions" below. It may be necessary to send the activate message to the control when the position is changed programmatically to redisplay the caret in the correct position.

The Current Selection

The current selection is displayed in inverse colors in the edit. It can be marked by dragging the mouse across the text or moving the arrow keys with the Shift key down. It can also be set programmatically using the select procedure and queried using the current_selection_range function. The current selection is often set as a side-effect of using navigation procedures such as move_absolute, so they shouldn't be used if there is a current selection.

Subclasses of Edit

The dbEdit class is a ready-made edit class designed to be used directly in data-entry applications. Generally, the dbEdit class is the best choice for applications.

Tab Function in Edit Objects

Tab stops can be set in an edit by using the tabstop property. By default, tab stops are set in 32-pixel increments, a spacing on average of 8 characters. The tabstop items are accessed exactly like an array. This is an example that changes the tab stops to 10-pixel increments:

Object oObjectName is an Edit
    set Size to 200 200
    set Location to 10 10
    set TabStop 1 to 20
    set TabStop 2 to 30
    set TabStop 3 to 40
End_Object

Setting the tabstop for Item 0 will set default tabs for all items.

Object oObjectName is an Edit
    set Size to 200 200
    set Location to 10 10
    set TabStop 0 to 20  // tab stops every 20 dialog units.
End_Object

Last Edited: December 2, 2005


Properties for Edit

View property list in alphabetical order

Name | Description
Capslock_State | Determines if all text displayed will be in upper-case letters
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Value | Determines the value of an item/paragraph
Wrap_State | Governs whether strings of text input will break and wrap to the next line at the end of this object, or will continue onward on the same line until a carriage return/linefeed is input
Inherited Properties from DfBaseEdit
Edit_Buffer_Count | The number of characters currently in the object
File_Name | Used whenever a read or write message is sent to the Edit object and a file_name parameter is not specified
Line_Count | Returns number of "lines" in Edit object
Position | Returns the location of the cursor in the object
Read_Only_State | Allows you to protect the contents of the buffer while still allowing users freedom to navigate
Text_Limit | The number of characters that can be entered into the edit
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Edit

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent every time the edit buffer is changed
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText | Sent when the edit buffer is full and an attempt has been made to add additional data to the buffer
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Edit

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEdit
Append_Text | Procedure | Inserts data to the end of the existing contents of the object
Beginning_of_Data | Procedure | Moves the cursor to the beginning of the data in the object
Beginning_of_Line | Procedure | Moves then cursor to the beginning of the current line
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Delete_Char | Procedure | Deletes the character under the cursor
Delete_Data | Procedure | Destroys all of the data in the object and returns the edit cursor to the top of the buffer
Delete_Line | Procedure | Deletes the current line
Down | Procedure | Moves the cursor down one line
End_of_Data | Procedure | Moves the cursor to the end of the data
End_of_Line | Procedure | Moves the cursor to the end of the current line
Find | Procedure | Searches the text in an edit window
Insert | Procedure | Inserts a string of text into the edit buffer at the current cursor location
Left | Procedure | Moves the cursor one space to the left
Page_Down | Procedure | Moves the edit cursor down one page
Page_Up | Procedure | Moves the edit cursor up one page
Paste | Procedure | Copies the contents of the Clipboard into this object at the current cursor position
Read | Procedure | Imports information from an external source to the Edit object's buffer
Read_Dbms | Procedure | Reads information from a database file
Replace | Procedure | Finds and Replaces Text in an edit object
Reset_Find | Procedure | Causes the next find to search from the start of the text
Reset_Replace | Procedure | Causes the next replace to search from the start of the text.
Right | Procedure | Moves the cursor one space to the right
Select | Procedure | Marks the text in the editor beginning at position iPosition for the number of bytes set in charcount
Undo | Procedure | Will undo the last change in the edit
Up | Procedure | Moves the edit cursor up one line
Write | Procedure | Writes the contents of the edit buffer to the specified file
Write_Dbms | Procedure | Writes information from the edit buffer to a database field
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Entry

Properties Events Methods Index of Classes

The basis of more-sophisticated data-entry classes,

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------Entry
------------------------------dbForm_

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Form_Mixin Auto_Setup_Mixin Datafile_Help_Mixin Entry_Shadow_Mixin Prompt_Button_Mixin Standard_Object_Mixin Dflabel_Mixin Single_Item_Navigate_Mixin Mask_form_Mixin FloatingPopupMenu_Mixin RGB_Support_Temp_Mixin Help_Mixin Shadow_Mixin

Description

Entry is designed to be the basis of more-sophisticated data-entry classes (the dbForm class) and is not intended for instantiation. The class allows the retrieval, display and storage of information between a database field and a form. The Entry class also provides for data verifications.

Of Special Note

Entry objects provide entry items as the main data-interface mechanism of an application. An entry_item is a complex item based on the Form. In addition to the base definition, entry_items contain information that allow them to interface to the database and perform a variety of data entry related functions. Although the Entry class supports multiple items (as does its form super-class) it is expected that there will only exist one item per entry object. Accordingly, all item-based messages will always refer to a single item, Item 0.

The EntryList class inherits all of the capabilities of this class through internal multiple inheritance. You will note that this class contains a number of multi-item, row based messages. These have little application for single item entry classes (like dbForm) but are needed for the row based EntryList descendant classes (like dbGrid).

Entry_Item Command

An entry_item must be associated with a data source/destination. The source/destination is most-often a database field, but it also may include expressions, or variables. If the argument is a database field, then the normal data movement in both directions between the DBMS and the display will take place. Information will be displayed from the database and changed fields will be stored back in the record buffer. If the argument is a variable, then the variable is treated like a simple data file. The only difference is that the variable may not have any implied database access performed. If the argument is an expression, data will be displayed into the data window based on the evaluated value of the expression. However, the entry_item will be automatically marked as display only, so that users will be prevented from making entries to the item.

Entry_items have a full array of entry options designed to allow the DEO to control data being put to the database. These options include autofind, findreq, noput, skipfound, retainall, retain, forceput and autofind_ge. In addition to the above options, entry options exist (ientry, iexit, and ivalidate) that allow specialized processing when an entry_item is entered, validated and exited. These options are typically (usually preferably) applied to the field globally in a DataDictionary object, but they can be applied on an exception basis in individual DEOs.

Entry_items also have two properties designed to be used in the subclasses of Entry. The iprompt and izoom entry options each specify an object. When users press the prompt or zoom accelerator keys, a message is sent to the object identified in the property. This allows custom zooming and prompting in a context-sensitive mode. These options are typically (usually preferably) applied to the field globally in a DataDictionary object, but they can be applied on an exception basis in individual DEOs.

Entry options may be changed during the running of the program. The item_option(s) message(s) may be used to change the entry option(s) based on some condition in your program.

Prompt buttons

This class automatically supports prompt buttons. If a prompt object is defined for this object, a prompt button will appear automatically in it. When the button is pressed, the prompt message will be sent and a prompt object (usually a selection list) will appear. Prompt objects are usually acquired from the data-dictionary object, but may be explicitly defined by setting the prompt_object_id property.

If you do not want automatic prompt-button creation, this feature may be disabled by setting the property prompt_button_mode to PB_PromptOff. A prompt button may be explicitly created by setting the prompt_button_mode property to PB_PromptAuto.

The Form Superclass of Entry

The Entry class is a sub-class of the form class and inherits all of its capabilities. This includes support for masking, object-shadowing, status-help display, and context help support.

Subclasses of Entry

The dbForm class is a full data-entry environment built from the Entry class. Most often, you will be able to use the dbForm class to easily accomplish complex tasks. Creating new class definitions based on the Entry class directly would be limited strictly to advanced, highly specialized purposes.

Last Edited: December 2, 2005


Properties for Entry

View property list in alphabetical order

Name | Description
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Entry

View event list in alphabetical order

Name | Description
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Entry

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: EntryList

Class: EntryList (Abstract)

Properties Events Methods Index of Classes

An abstract class suitable for "table" style data entry

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Grid_Mixin Datafile_Help_Mixin Standard_Object_Mixin Multi_Item_Shadow_Mixin Mask_form_Mixin FloatingPopupMenu_Mixin Auto_Setup_Mixin RGB_Support_Temp_Mixin Help_Mixin Shadow_Mixin

Description

EntryList combines all of the capabilities of the Grid class and the Entry class resulting in an abstract class suitable for "table" style data entry. This class is intermediate and serves as the basis for more-sophisticated data-entry classes (dbGrid and dbList).

Of Special Note

The primary purpose of the EntryList class is to combine all of the capabilities of the Entry class and the Grid class.

Scrolling data-entry forms are very useful when large amounts of data are to be managed, however, the base EntryList class is an in-memory data-storage object. You should be aware of the amount of memory available, or modify the object to perform in a virtual mechanism. This is the idea behind the dbGrid and dbList class.

There are no messages that are unique to the EntryList class. Objects of the EntryList class understand all of the messages of the Entry class and the Grid class, and you should refer to the articles on these classes for information on their protocol.

Multi-item and Row based messages from Entry

You will note that the Entry class contains a large number of multi-item messages that seem to serve little purpose when using the Entry class for single-item entry. Those messages are inherited by the EntryList class and, when used in a row-based context, are important. Although these messages are unchanged from their Entry superclass, they are listed here so that their purpose may be more-clearly understood.

Accelerator Keys

This class's accelerator keys are unchanged from those of its superclass.

Last Edited: December 2, 2005


Properties for EntryList

View property list in alphabetical order

Name | Description
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for EntryList

View event list in alphabetical order

Name | Description
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Click | Sent whenever a header has received a mouse click
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
onInitSpin | Augmented to set the minimum and maximum positions for a spinner
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for EntryList

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the current column of the first row
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Data | Procedure | Causes the grid's current item to be set to the current column of the last row
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Prompt | Procedure | The default message sent by this object's prompt button
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ErrorSystem

Properties Events Methods Index of Classes

Supports Visual DataFlex's interactive interface for all errors generated in a program

Hierarchy

cObject
---ErrorSystem

Library: Common (Windows and Web Application) Class Library

Package: Dferror.pkg

Description

The package DfError.pkg creates the class ErrorSystem and an error-handling object based on this class. This object supports Visual DataFlex's interactive interface for all errors generated in a program.

Usage

use DFError.pkg

An instance of this class named error_info_object is created by use of the DFError package. You should not create an instance of this class by any other means. When the object is created, its object ID is placed in the global Integer error_object_id. All access to this object should be through this Integer ID and not through the object's name. This package is a standard part of DFAllEnt.pkg, so there is usually no need to explicitly add this package to your application.

Of Special Note

In most applications, you will not need to make any changes in the error handling as supplied and described here. This handler works well for most data-entry programs. The Visual DataFlex report- and batch-processing objects provide their own custom error-redirection logic to handle batch errors, and can be easily customized. The information provided below is provided for advanced usage.

Understanding How Error Handling works

A global integer named error_object_id identifies the object that should receive errors. Anytime an error occurs, the message error_report is sent to the object identified by this global integer. It is expected this will handle the error as required.

When the standard error package, DfError.Pkg, is used, a global error object is created and its object ID is moved to error_object_id. Anytime an error occurs, the message error_report is sent to the error object.

Never call error_report directly to generate an error. Errors should be generated through the use of the error command. The message error_report may be sent if the sending object is itself an error object. This occurs when a custom error handler within an object has been created to handle a process.

Trapping and Ignoring Errors

An error can be fatal, ignored, or trapped. If an error is fatal, an error message is displayed and the program is terminated. If an error is trapped, it is displayed with a pop up error dialog. If an error is ignored, it is ignored. When initialized, the error system will trap all errors except Error 41 (Find past end of file) and Error 42 (Find prior to beginning of file). You may choose to trap or ignore other errors. You may change this through the use of the trap_error, ignore_error, trap_all, and ignore_all messages.

There is a single error that will never be passed to the error object, Error 10 (Out of memory). Since the message-passing mechanism uses dynamically allocated memory, this would most-certainly cause a system failure.

Creating Your Own Error Handler

You can turn any object into an error-handling object. This is done as follows:

1. The global integer error_object_id must be assigned to this object. Usually this assignment is temporary.

2. The Integer Property error_processing_state must be created within the object and supported within your custom error_report procedure.

3. The procedure error_report must be created within the object to handle the error.

Directing and Redirecting Errors

Custom error handlers are created when you need to change the way errors are handled during a process. Usually you will turn the object that is running the process into its own error handler. When the process begins, you save the current value of error_object_id (usually to a property) and set the value of error_object_id to the current object. At this point, all errors will be directed to the current object. When the process is complete, error_object_id should be restored to its original value. This is typically done as follows:

// create property to keep track of previous error handler
Property integer OldErrorId 0
:
Procedure Run_Process
    integer hID
    Set OldErrorId to Error_object_id // remember old error object
    Move Self to Error_object_id // make self the error object
    // At this point, all errors will be directed to error_report
    // within this object.
    Repeat
        //run the process
    Until (done)
    Get OldErrorId to hId
    Move hId to Error_object_id // restore original error object
    // At this point, all errors will again be directed to
    // the previous (presumably standard) error handler
End_Procedure

Protecting against Error Recursion

While custom error handler error_report can be made to do anything you wish, you must provide logic to prevent recursive error reports (i.e., an error creating an error). You do this by creating a property named error_processing_state and setting this property to true while within the error_report procedure and resetting it to false when the procedure is complete. Because other objects may check the value of this property to see if an error is in process, this is a public property and must be provided in all error handlers. Here is a typical example of how this property is used:

// This property MUST be created within the object or the object's class.
Property Integer Error_Processing_State False
:
Procedure Error_Report Integer iErrNum Integer iErrLine String sErrText
    // if we are already within an error, do nothing
    If (Error_Processing_State(self)) ;
        Procedure_Return

    // mark that we are now processing an error
    Set Error_Processing_State to True

    // perform custom error handling

    // mark that we are no longer processing an error
    Set Error_Processing_State to False
End_Procedure

Augmenting the Standard Error_Report Behavior

Often a custom error handler will want to augment the behavior of the standard error handler. For example, an error handler may wish to log an error and, if the error is of the right type, display a standard pop-up error dialog. Your custom error_report procedure does this by sending the message error_report to the standard error handler (usually the previous error handler). This is done as follows:

Procedure Error_Report Integer iErrNum Integer iErrLine String sErrText
    Integer hId

    If (Error_Processing_State(Self)) ;
        Procedure_Return

    Set Error_Processing_State to True

    // perform custom error handling

    // Now direct the error to the standard error handler
    Get OldErrorId to hId
    Send Error_Report of hId iErrNum iErrLine sErrText
    Set Error_Processing_State to False
End_Procedure

More information is provided in the error_report procedure's documentation.

Last Edited: June 26, 2006


Properties for ErrorSystem

View property list in alphabetical order

Name | Description
Current_Error_Number |
Error_line_Number |
Verbose_State | Hides/shows the technical details of the error in the error display
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ErrorSystem

View event list in alphabetical order

Name | Description
Error_Report | Sent if you have redirected your errors to another object, and this new error object wishes to use the services of the standard error handler
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ErrorSystem

View method list in alphabetical order

Name | Type | Description
Ignore_All | Procedure | Used when all errors are to be ignored
Ignore_Error | Procedure | Used when a specific error number is to be ignored
Trap_All | Procedure | Used when all errors are to be trapped
Trap_Error | Procedure | Used when a specific error number is to be trapped
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: FileValidationTable

Properties Events Methods Index of Classes

Provides a two-column table of validation data for validation lists used with DataDictionary objects.

Hierarchy

cObject
---Array
------ValidationTable
---------DescriptionValidationTable
------------FileValidationTable
---------------CodeValidationTable

Library: Common (Windows and Web Application) Class Library

Package: Ddvaltbl.pkg

Description

This class allows you to maintain a list of values and descriptions that can be easily loaded from a specified DataFlex data file.

Set the Table_Title property to describe or explain the list as a whole. Set the Main_File property to the number of the file that contains the data to be presented and used by this object. Set the Code_Field property to the number of the field in file that contains the value to use for validation or prompting. Set the Description_Field property to the number of the field in file that contains descriptive text to be presented with value to explain its meaning. Set the Ordering property to the number of the index of file by which to order the records containing the values and descriptions.

This is an object for assignment in DataDictionary objects to database fields with the Field_Value_Table property. It provides both values for insertion into the database and descriptions to explain each value. It draws its data from up to two fields of a database file identified in the definition of the object. Also specified in the object definition is the index of the database file by which to order the presentation of the values and descriptions.

If the Validate_State property is set to False, entries are permitted that are not in the list; in its default True state, it requires an entry that matches one of the existing table items. If the Static_State property is set to False, the list will be filled every time the table is activated; in its default True state, the object is loaded with its list only once in each session.

Sample

Object oStatusTable is a FileValidationTable
    Set Main_File to CustStat.File_Number
End_Object

Any of the above validation tables can be linked to a field with the Field_Value_Table property in a DataDictionary.

Sample

Set Field_Value_Table Field Customer.Status to oStatusTable

See Also

Using Validation Tables

Last Edited: July 12, 2005


Properties for FileValidationTable

View property list in alphabetical order

Name | Description
Code_Field | The database field from which the values are to be drawn for validation and insertion into the database
Description_Field | Identifies the field from which the descriptions are to be drawn for validation and insertion into the database
Ordering | Identifies the index to be used for ordering values in this object.
Type_Field | Identifies the field in the CodeMast data file that contains the type values to be used for the validation table
Type_Value | Sets the value in the Type_Field by which records for validation are selected
Inherited Properties from ValidationTable
Allow_Blank_State | Controls whether blank entries are accepted in this object
Main_File | Identifies the data file from which the values are to be drawn to fill this object
Static_State | Determines whether object loads once per session or dynamically.
Table_Title | The title shown in the caption bar of the validation table
Validate_State | Determines whether values are validated against the items contained in the validation table.
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for FileValidationTable

View event list in alphabetical order

Name | Description
Inherited Events from ValidationTable
Fill_List | Fills the list of entires in the validation table
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for FileValidationTable

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DescriptionValidationTable
Add_Table_Value | Procedure | Should be sent for each sDescription and sValue you wish to add to your validation table
Inherited Methods from ValidationTable
Find_Code_Description | Function |
TableData | Function | Returns the validation table's data in a two dimensional variant array
Validate_Value | Function | Determines whether a value is valid or not (is listed in the validation table or not)
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: FloatingPanel

Class: FloatingPanel (Abstract)

Properties Events Methods Index of Classes

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------cStatusPanel
------------------------------dbFloatingPanel_
------------------------------ModalPanel
------------------------------ToolPanel

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Container_Mixin Panel_Mixin Standard_Object_Mixin Label_Mixin dfAuto_Locate_Mixin Shadow_Mixin Bitmap_Support_Mixin Modal_Mixin DefaultActionButton_Mixin RGB_Support_Temp_Mixin Help_Mixin

Description

Last Edited: December 2, 2005


Properties for FloatingPanel

View property list in alphabetical order

Name | Description
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for FloatingPanel

View event list in alphabetical order

Name | Description
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for FloatingPanel

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Close_Panel | Procedure |
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: FloatingPopupMenu

Properties Events Methods Index of Classes

Creates standard floating popup menus (context menus)

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseActionBar
------------------------DfBasePullDown
---------------------------DfBaseEditPullDown
------------------------------FormFloatingPopupMenu
---------------------------------FloatingPopupMenu

Library: Windows Application Class Library

Package: Windows.pkg

Description

The FloatingPopupMenu class creates a menu that "floats" with the mouse cursor and pops up on a click of the secondary (usually right) button of the mouse. Objects of this class contain no items by default, all items must be provided by the developer.

The FormFloatingPopupMenu class contains some default items and additional items can be added to the existing items.

Sample

Object CustomMenu is a FloatingPopupMenu
    Send Add_Item msg_Clear "&Clear"
    Send Add_Item msg_Edit  "&Edit"
    Send Add_Item msg_None "" // create a spacer
    Send Add_Item msg_Exit_Application  "E&xit Application"

    Procedure Popup
        Integer iFocus iItem
        Boolean bChanged

        Get Focus to iFocus // the object that called us
        Get Changed_State of iFocus to bChanged
        // if changed, shadow exit option
        Set Shadow_State 3 to bChanged

        forward send Popup
    End_Procedure
End_Object

Syntax

Use windows
:
Object oObjectName is a FloatingPopupMenu
    Send Add_Item message MenuText
    Set Aux_Value item item# to ObjectId // optional destination
    :
    Send Add_Item msg_None ""    // separator
    :
    Procedure Popup
        :
        Set Shadow_State item# to True | False
        :
        Forward Send Popup
    End_Procedure
End_Object

Last Edited: December 2, 2005


Properties for FloatingPopupMenu

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for FloatingPopupMenu

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseActionBar
Initialize_Menu | Sent when the Menubar system is about to be selected
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for FloatingPopupMenu

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseActionBar
Exit_Menu | Procedure |
Redirect_Message | Procedure |
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: FontDialog

Properties Events Methods Index of Classes

Permits users to select fonts

Hierarchy

cObject
---FontDialog

Library: Windows Application Class Library

Package: Font_dlg.pkg

Description

FontDialog is used to permit users to select fonts. It is an encapsulation of the Windows Common Font Dialog. All aspects of the dialog can be set before it is displayed, and queried upon its return.

Usage

DEFERRED_VIEW Activate_FontChangeRV FOR ;
  ;
  Object FontChangeRV is a ReportView
    Set Label to "Font Change"
    Set Size to 206 313
    Set Location to 6 6

    Object FontTextBox is a Textbox
      Set Label To "The quick brown fox jumps over the lazy dog"
      Set FontSize To 4 0
      Set Size     To 10 142
      Set Location To 10 13
    End_Object    // FontTextBox

    Object FontButton is a Button
      Set Label    To "Change Font"
      Set Location To 166 243

      Procedure OnClick
        Integer Selected
        Integer FontDlg

        //*** Create a font dialog object
        Object oFontDialog Is A FontDialog
          Set Effects_State To False

          Move Self To FontDlg
        End_object // oFontDialog

        //*** Let the user select a font, if one was selected
        //*** copy selection to the textbox
        Get FontDialog Of (oFontDialog(Self)) To Selected
        If Selected Begin
          Set TypeFace      Of (FontTextBox(Self)) To ;
                               (FaceName(FontDlg))
          Set FontSize      Of (FontTextBox(Self)) To ;
                               (FontHeight(FontDlg)) (FontWidth(FontDlg))
          Set FontWeight    Of (FontTextBox(Self)) To ;
                               (FontWeight(FontDlg))
          Set FontItalics   Of (FontTextBox(Self)) To ;
                               (FontItalic(FontDlg))
          Set FontUnderline Of (FontTextBox(Self)) To ;
                               (FontUnderline(FontDlg))
        End

        //*** Destroy the font dialog object
        Send Destroy_object To FontDlg
      End_procedure // OnClick

    End_Object    // FontButton
  CD_End_Object    // FontChangeRV

Syntax

Use Font_Dlg

Object object_name is a FontDialog
End_Object

Of Special Note

This class is a DataFlex wrapper for the Windows API common font dialog. You are able to handle all properties that can be set by the Windows API common font dialog. It is possible that not all of those font properties are supported by all Visual DataFlex objects.

Last Edited: November 21, 2004


Properties for FontDialog

View property list in alphabetical order

Name | Description
ANSIOnly_State | Obsolete, provided for completeness
Effects_State | Indicates whether the dialog box displays the controls that allow users to specify strikeout, underline, and text color options
FaceName | Specifies the typeface name of the font
FixedPitchOnly_State | Indicates whether only fixed-pitch fonts can be selected in the dialog box
FontCharSet | Specifies the character set
FontClipPrecision | Specifies the clipping precision
FontEscapement | Specifies the angle, in tenths of degrees, between the escapement vector and the x-axis of the device
FontFamily | Describes the look of a font in a general way
FontHeight | Specifies the height, in logical units, of the font's character cell or character
FontItalic | Indicates whether the font is italic
FontOrientation | Specifies the angle, in tenths of degrees, between each character's base line and the x axis of the device
FontOutPrecision | Specifies the output precision
FontPitch | Specifies the pitch of the font
FontPointSize | Specifies the size of the selected font, in units of 1/10 of a point
FontQuality | Specifies the output quality
FontRGBColors | Determines the initial text color
FontSizeMax | Specifies the maximum point size a user can select
FontSizeMin | Specifies the minimum point size a user can select
FontStrikeOut | Indicates whether the font is struck out
FontType | Specifies the type of the selected font when the font dialog returns
FontUnderline | Indicates whether the font is underlined
FontWeight | Specifies the weight of the font in the range 0 through 1000
FontWidth | Specifies the average width, in logical units, of the font's character cell, or character
ForceFontExist_State | Indicates whether the font and style that are selected by the user must exist
NoFaceSel_State | Indicates whether to selectively prevent the font dialog box from displaying an initial selection for the font name combo box
NoOEMFonts_State | Indicates whether vector font selection is allowed in the dialog box
NoScriptSel_State | Indicates whether the script combo box in the font dialog is disabled
NoSimulations_State | Indicates whether graphics-device-interface (GDI) font simulations are allowed in the dialog box
NoSizeSel_State | Indicates whether to selectively prevent the dialog box from displaying an initial selection for the font size combo box
NoStyleSel_State | Indicates whether to selectively prevent the dialog box from displaying an initial selection for the font style combo box
NoVectorFonts_State | Indicates whether vector font selection is allowed in the dialog box
NoVertFonts_State | Indicates whether the font dialog should display vertically oriented fonts
ScalableOnly_State | Indicates whether only scalable fonts should be selected
ScreenFonts_State |
ScriptsOnly_State | Indicates whether the font dialog should allow selection of fonts for all non-OEM and Symbol character sets, as well as the ANSI character set
SelectScript_State | Determines if only fonts with the character set identified by the FontCharSet property will be displayed by the font dialog box
ShowHelp_State | Indicates if the dialog box shows the help button on the dialog box
TTOnly_State | Indicates if only TrueType fonts should be selected in the font dialog box
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for FontDialog

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for FontDialog

View method list in alphabetical order

Name | Type | Description
FontDialog | Function | Starts the common Windows font dialog
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Form

Properties Events Methods Index of Classes

To display and accept keyboard input

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------Form
---------------------------FormExternalControl
---------------------------SpinForm

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Form_Mixin Prompt_Button_Mixin Standard_Object_Mixin Dflabel_Mixin Single_Item_Navigate_Mixin Mask_form_Mixin FloatingPopupMenu_Mixin RGB_Support_Temp_Mixin Help_Mixin Shadow_Mixin

Description

The Form class is used to display and accept keyboard input. This class can be used for all non-database entry needs.

The dbForm class is a data-aware class similar to the Form class.

Sample

Object Field1 is a Form
    Set Size to 13 100
    Set Location to 10 70
    Set Label to "User Name:"
    Set Value to "Guest"
End_object

Object Field2 is a Form
    Set Size to 13 50
    Set Location to 25 70
    Set Label to "User Id:"
    Set Form_Margin item 0 to 20
    Set Capslock_State to True

    Function User_Id returns string
        string sId
        Get Value to sId
        Function_Return sId
    End_Function
End_Object

Syntax

Use Windows.pkg

Object oObjectName is a Form
    Set Size to height width
    Set Location to row column
    Set Value to value

    Set Label to text
    Set Label_Justification_Mode to mode
    Set Label_Row_Offset to Num
    Set Label_Col_Offset to Num

    Set Form_DataType to mode
    Set Form_Margin to mode
    Set Form_Mask to MaskString
    Set Numeric_Mask to leftDigits rightDigits {template}
    Set Currency_Mask to leftDigits rightDigits {template}

    Set Capslock_State to true| false
    Set Enabled_State to true| false
    Set Status_Help to text

    Procedure onChange
        :
    End_Procedure

    Procedure onSetFocus
        :
    End_Procedure

    Procedure onKillFocus
        :
    End_Procedure

End_Object

Of Special Note

The Form class is descended from the DfBaseForm class and therefore inherits all of the properties and capabilities of that class. It has been extended to support help, status help display, item masking, object shadowing, and label display. It is expected that you will use this class (and not DfBaseForm) for your simple non-database entry needs.

This class will be used for single item entry. When item numbers must be passed the number will always be 0 (e.g., get value item 0 to val)

The Value of a Form

The contents of a form is stored in its value property. When a Form-class object has the focus it will accept data from the keyboard directly into the value of the item. The value can also be directly changed and retrieved the with the get and set value messages (get/set value item 0 to val) . Any time the contents of a Form is changed (through keyboard or the set value message) the event message onChange is sent. Also, if users enter any change to the window, the item_changed_state (item 0) and the changed_state of the object are set true.

Shadowing

Shadowing refers to the process of making an object or an item unavailable for data entry. Usually the appearance of a shadowed object is changed in some way to indicate its unavailability. This class supports object shadowing. Accordingly, objects of this class will be shadowed whenever an ancestor object is shadowed or whenever the obejct's enabled_state property is false.

Masking

This class supports input and display masking for a variety of data types (text, numeric, currency, and dates). The type of masking used is determined by the object's form_datatype (which supports both masked and non-masked types) and the object's form_mask. Two additional messages, set currency_mask and set numeric_mask, make it particularly easy to define currency and numeric data types and fields with a single message.

Labels

Forms often require an associated description or label. Most-often, these appear to the left of the form. Labels are supported with the set label message. The default location and justification mode of labels can be controlled with the properties label_col_offset, label_row_offset and label_justification_mode.

Prompt Buttons

This class automatically supports prompt buttons. If a prompt object is defined for this object, a prompt button will appear automatically in it. When the button is pressed, the prompt message will be sent and a prompt object (usually a selection list) will appear. Prompt objects are usually acquired from the data-dictionary object, but may be explicitly defined by setting the prompt_object property.

If you do not want automatic prompt-button creation, this feature may be disabled by setting the property prompt_button_mode to PB_PromptOff. A prompt button may be explicitly created by setting the prompt_button_mode property to PB_PromptAuto.

Last Edited: December 2, 2005


Properties for Form

View property list in alphabetical order

Name | Description
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
Prompt_Object | Specifies the default receiving object for the popup message
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Form

View event list in alphabetical order

Name | Description
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Form

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Prompt | Procedure | The default message sent by this object's prompt button
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: FormExternalControl

Class: FormExternalControl (Abstract)

Properties Events Methods Index of Classes

Abstract class enabling applications to provide users with a visual control to 'slide' through a range of values

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------Form
---------------------------FormExternalControl
------------------------------TrackBar

Library: Windows Application Class Library

Package: ExtFrm.pkg

Description

FormExternalControl is used to enable applications to provide users with a visual control to 'slide' through a range of values.

The purpose of the class is to allow developers to create their own controls that exhibit Form-like or dbForm-like behaviour. So for instance, you could make a dbFormExternalControl that has an entry item, but from a UI perspective is a toolbar button running in checked, or group mode. No custom code to write to deal with updates or anything, just respond to the proper messages and add an entry_item and voila, a db(database)-aware toolbar button.

Sample

This sample updates a group of toolbar buttons:

Object oMyToolbarUpdater is a dbFormExternalControl
    set GUISize to 0 0
    set GUILocation to 0 0
    set Focus_Mode to NonFocusable

    Entry_Item Job.Status

    // The class expects a message named Set ControlValue. It is passed a string
    // and should be used to change the value of the windows control. This
    // is the message "C" from above.
    Procedure Set ControlValue string sVal
        if (sVal = "O") begin
            set pbEnabled of (oActive(oMyToolbar)) to true
            set pbEnabled of (oCancel(oMyToolbar)) to true
            set pbChecked of (oActive(oMyToolbar)) to true
            set pbChecked of (oCancel(oMyToolbar)) to false
        end
        if (sVal = "X") begin
            set pbEnabled of (oActive(oMyToolbar)) to true
            set pbEnabled of (oCancel(oMyToolbar)) to true
            set pbChecked of (oActive(oMyToolbar)) to false
            set pbChecked of (oCancel(oMyToolbar)) to true
        end
        if (sVal = "C") begin
            set pbEnabled of (oActive(oMyToolbar)) to false
            set pbEnabled of (oCancel(oMyToolbar)) to false
            set pbChecked of (oActive(oMyToolbar)) to false
            set pbChecked of (oCancel(oMyToolbar)) to false
        end
    End_Procedure

    // The class expects a messsage named get controlValue. It will return
    // the control's data value.
    Function ControlValue Returns String
        string sVal
        Boolean bActive bCancel

        get pbChecked of (oActive(oMyToolbar)) to bActive
        get pbChecked of (oCancel(oMyToolbar)) to bCancel

        if (bActive and not(bCancel)) function_return "O"
        if (not(bActive) and bCancel) function_return "X"
        if (not(bActive) and not(bCancel)) function_return "C"
        else function_return "C"
    End_Function

End_Object  // oMyToolbarUpdater

Last Edited: June 21, 2005


Properties for FormExternalControl

View property list in alphabetical order

Name | Description
ControlValue |
Value |
Inherited Properties from Form
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
Prompt_Object | Specifies the default receiving object for the popup message
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for FormExternalControl

View event list in alphabetical order

Name | Description
Inherited Events from Form
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for FormExternalControl

View method list in alphabetical order

Name | Type | Description
ControlValueChanged | Procedure |
RefreshControl | Procedure |
Inherited Methods from Form
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Prompt | Procedure | The default message sent by this object's prompt button
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: FormFloatingPopupMenu

Properties Events Methods Index of Classes

Creates standard floating popup menus for Windows forms (context menus)

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseActionBar
------------------------DfBasePullDown
---------------------------DfBaseEditPullDown
------------------------------FormFloatingPopupMenu
---------------------------------dbFloatingPopupMenu
---------------------------------FloatingPopupMenu

Library: Windows Application Class Library

Package: Windows.pkg

Description

FormFloatingPopupMenu is used to create standard floating popup menus. This is used to create a "right-mouse-button context menu". This creates a menu of items for standard form-edit operations (undo, cut, copy, paste, delete and select all). An object is automatically created based on this class and all non-DEO form controls use this object.

The FloatingPopupMenu class contains no default items and all items must be provided by the developer.

Sample

Object oCustomMenu is a FormFloatingPopupMenu
    // these get added to the existing items.
    Send Add_Item msg_none "" // create a spacer
    Send Add_Item msg_Exit_Application  "E&xit Application"

    Procedure Popup
        integer iFocus iItemCount
        boolean bChanged

        Get Focus to iFocus // the object that called us
        Get Changed_State of iFocus to bChanged
        Get Item_Count to iItemCount // exit is the last item
        // if changed, shadow exit option
        Set Shadow_State (iItemCount - 1) to bChanged

        forward send Popup
    End_Procedure  // Popup
End_Object

Syntax

Use windows.pkg
:
Object object_name is a FormFloatingPopupMenu
    Send Add_Item message MenuText
    Set Aux_Value item (item_count(self)-1) to ObjectId // optional destination
    :
    Send Add_Item msg_none ""    // separator
    :
    Procedure Popup
        :
        Set Shadow_State item item# to true|false
        :
        Forward send popup
    End_Procedure
End_Object

    In your Form object:

Set Floating_Menu_Object to object_name

Of Special Note

Automatic Floating Popup Menu Support
By default an object named FormFloatingMenu is created based on this class. Non DEO Form objects (form, grid, etc.) use this object for floating context menu support. When the right mouse button is pressed in a form, the form object is given the focus, and, if this focus change is successful the popup message is sent to the FormFloatingMenu object. This causes the context menu to appear relative to the location of the mouse pointer. This provides support for the standard editing operations (undo, cut, copy, paste, delete, and select all).

DEO forms (dbForm, dbGrid, etc.) use a more-sophisticated popup menu which supports all the standard editing support plus many data entry options (save, prompt, clear, delete, find, etc.). (See dbFloatingPopupMenu for more information on this.)

All of this is provided automatically. No program changes are required to support this. In addition to this automatic support an interface is provided to customize these behaviors.

Assigning a Floating Menu to a Form

When a program is run an object named FormFloatingMenu is created based on this class. In addition a global integer, default_form_floating_menu_id, is created which contains the object id of FormFloatingMenu.

Form objects (form, grid, dbForm, dbGrid, etc.) have a property named floating_menu_object. This contains the object ID of the floating popup menu object that should be used when the right mouse button is selected. When a non DEO form object (form, grid) is created the floating_menu_object property is set to the value of the default_form_floating_menu_id. This is the method used to assign an object to a floating context menu. If you wish to assign a different floating menu to a form you may either set the form's floating_menu_object property or you may change the value of global integer default_form_floating_menu_Id. You would do the later if you wished to change the assignment of floating menus within all forms.

Customizing a Floating Popup Menu

Floating menus support a standard item interface. Items are changed by sending the messages Add_Item, Insert_Item, Delete_item, and Delete_Data. Item characteristics are changed by setting the properties value, aux_value, message and shadow_state. This interface is identical to the PopupMenu interface. These items may be set when the object is created, or, when the object is about to be invoked. You should augment the Popup message to dynamically change menu item values.

Some examples should clarify this. The following example creates an object that adds the option "Exit application" to the menu. In addition, this item will shadowed if the invoking form's changed_state is true.

Object CustomMenu is a FloatingPopupMenu
    // these get added to the existing items.
    Send Add_Item msg_none "" // create a spacer
    Send Add_Item msg_exit_application  "E&xit Application"

    Procedure Popup
        integer foc changed Itm
        Get focus to foc // the object that called us
        Get Changed_State of foc to changed
        Get Item_Count to Itm // exit is the last item
        // if changed, shadow exit option
        Set Shadow_state item (itm-1) to changed
End_Object

This could be assigned to a form by setting the form's property as follows:

Object MyForm is a Form
    :
    Set Form_Menu_Object to (CustomMenu(self))
End_Object

Or, all form objects could be assigned to this custom menu with the following:

Move (CustomMenu(self)) to default_form_floating_menu_id

All forms created after this statement will be assigned to new context menu.

Subclasses of the FormFloatingPopupMenu

The dbFormFloatingPopupMenu creates a DEO floating popup menu and is used automatically by DEO forms (dbForm, dbGrid, etc.). The FloatingPopupMenu creates a floating menu with no items.

No new properties are created for this class. It is expected that you will use the following item properties: value, aux_value, message, and shadow_state.

No new procedures or functions are created for this class. It is expected that you will use the following messages: send add_Item, send insert_value, send delete_item, send delete_data, get item_count, and, send popup. Note that you will not use the following messages from the PopupMenu class: onInitMenu (use Popup instead), change_menu and redirect_message.

Last Edited: December 2, 2005


Properties for FormFloatingPopupMenu

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for FormFloatingPopupMenu

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseActionBar
Initialize_Menu | Sent when the Menubar system is about to be selected
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for FormFloatingPopupMenu

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseActionBar
Exit_Menu | Procedure |
Redirect_Message | Procedure |
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Grid

Properties Events Methods Index of Classes

A basic class which should be used for creating multi-row, multi-column entry lists

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseFormList
---------------------------Grid

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Grid_Mixin Standard_Object_Mixin Multi_Item_Shadow_Mixin Mask_form_Mixin FloatingPopupMenu_Mixin Auto_Setup_Mixin RGB_Support_Temp_Mixin Help_Mixin Shadow_Mixin

Description

Grid is a basic class which should be used for creating multi-row, multi-column entry lists. The Grid class supports data entry in data windows. The data is stored in items and may be accessed and manipulated like other objects with items. The Grid object scrolls in the display and uses a scroll bar for navigation and visual clues. Both vertical and, if required, horizontal scrolling are supported. Grids also support the ability to create resizable header labels. The Grid class supports combo forms, checkboxes, spin forms and prompt buttons in individual columns or cells.

The dbGrid class is a data-aware class similar to the Grid class.

Sample

Object MyGrid is a Grid
   Set Location to 10 10
   Set Size to 100 170
   Set Line_Width to 2 0

   Set CurrentCellColor     to clRed
   Set CurrentCellTextColor to clWhite

   Set CurrentRowColor      to clWhite
   Set CurrentRowTextColor  to clNavy

   Set GridLine_Mode to Grid_Visible_Both
   Set Resize_Column_State to False

   Set Header_Label              item 0 To 'Name'
   Set Form_Width                item 0 to 100

   Set Header_Label              item 1 To 'Due'
   Set Header_Justification_Mode item 1 to jMode_Right
   Set Form_Width                item 1 to 60
   Set Currency_Mask             item 1 to 6 2

    Procedure Fill_the_List
        integer iItemCount

        Clear MyData
        Find gt MyData.Name
        While (Found)
            Send Add_Item 0 MyData.Name
            Send Add_Item 0 MyData.Amount
            if MyData.Amount lt 0 Begin
                Get Item_Count to iItemCount
                Set ItemColor (iItemCount-1) to clRed
            End
            Find Gt MyData.Name
        Loop
    End_Procedure

    Send Fill_the_List

End_Object

Syntax

Use dfClient.pkg
Use Windows.pkg
:
Object object_name  is a Grid
    // object based properties
    Set Size to height width
    Set Location to Row  Column
    Set Line_Width to NumberColumns 0

    Set Header_Visible_State to true|false
    Set Resize_Column_State to true|false

    Set CurrentCellColor to RGBColor
    Set CurrentCellTextColor to RGBColor

    Set CurrentRowColor to RGBColor
    Set CurrentRowTextColor to RGBColor

    Set Highlight_Row_State to true|false
    Set GridLine_Mode to GridVisibleMode

    Set Enabled_State to true|false

    // Column based properties. repeat for each column
    Set Status_Help col# to StatusHelpText

    Set Form_Width col# to ColumnWidth
    Set Form_DataType col# to type
    Set Form_Mask  col# to Mask
    Set Numeric_Mask col# to leftDigits rightDigits {template}
    Set Currency_Mask col# to leftDigits rightDigits {template}

    Set Header_Label col# to HeaderLabel
    Set Header_Justification_Mode col# to Mode

    // Item-based properties. repeat as needed
    Send Add_Item msg# ItemValue
    Set ItemColor item# to RGBColor
    Set ItemTextColor item# to RGBColor
    Set Entry_State item# to true|false
    Set Item_Shadow_State item# to true|false
    Set Checkbox_Item_State item# to true|false
End_Object

Of Special Note

Grids are based on the DfBaseForm class and therefore inherit all of the item-based protocols of this class (which is actually inherited from DfBaseList). Each item is a grid is represented by a number of properties (value, message, aux_value, item_changed_state, entry_state, checkbox_item_state, etc.). In most cases, you will only deal with the value property. Be aware that all other item properties still exist.

Determining the Number of Columns and Rows in a Grid

The number of current rows can be obtained via line_size and the number of rows which are available for display of data via displayable_rows.

Creating a Grid Matrix

By default a grid is created consisting of a single column. If you need more than one column in your grid, you must set the line_width property. This is passed two parameters, the number of columns and the number of displayable rows. You should always pass 0 for the number of rows. This instructs the grid to determine the number of displayable rows based on the display size of the object. In the Studio, Line_Width is handled for you via the Grid Options dialog, unless you create columns dynamically.

Creating a List of Items

This class is designed to allow the number of items to change based on the amount of data needed when the program is being executed. Normally, the items are added into the object with the add_item and/or insert_item messages and normally this is done inside some kind of initialization procedure. However, if there is an initial set of items to be used when the object is first created, an item list can be defined in this object. We recommend that lists be filled using add_item message and not with the static item-list construct. You will find this to be more flexible.

Grid lists do not have to be static. Items can be changed, added, inserted and deleted. Entire lists can be deleted (delete_data) and completely rebuilt.

RGB Colors

The color of items, rows, and cells in grids is set using RGB (red, green, blue) colors. A color setting is passed a single value representing a complex RGB color. Each individual color is represented as a number between 0 and 255. These individual red, green, and blue colors are converted to a single value by using the RGB function. This is standard method for representing colors in windows.

Set CurrentCellColor to (rgb(255,0,0)) // red

The rgb.pkg package contains names for most of commonly used colors. It also contains names for most of the system defined colors. You can use these replacements names when setting color values

Set CurrentCellColor to clPurple
Set CurrentCellColor to clBtnFace // color for a button face

Scrolling

Grids support vertical and, when required, horizontal scrolling. A vertical scroll bar is provided to support vertical scrolling.

When the width of the columns exceeds the width of the grid, horizontal scrolling is enabled. Normally, a horizontal scroll bar will appear when this type of scrolling is required (although it can be disabled). The grid is always scrolled so that the current column is entirely visible. For this reason, a grid scrolls horizontally one column at a time.

Shadowing

Shadowing refers to the process of making an object or an item unavailable for data entry. Usually the appearance of a shadowed object is changed in some way to indicate its unavailability. This class supports object shadowing. A grid will be shadowed whenever an ancestor object is shadowed or when the grid's enabled_state is set false. In addition, individual items can be shadowed within a grid by setting the item_shadow_state property.

Masking

This class supports input and display masking for a variety of data types (text, numeric, currency, and dates). The type of masking used is determined by the object's form_datatype (which supports both masked and non-masked types) and the object's form_mask. Two additional messages, set currency_mask and set numeric_mask make it particularly easy to define currency and numeric data types and fields with a single message. Masking is supported for each column in a grid.

Header Labels

Grids often require a header description or label. Each column may contain a label and each label may be left-justified, right-justified, or centered. Headers are optional and can be disabled. When present the size of a column can be resized by mouse dragging the header divider. This resize feature can also be disabled. Headers support mouse events and will respond to both single and double clicks. The action of these events can be controlled by the program.

Status Help

Status help is supported at the column level. All items within the same column will display the same status-help value.

Accelerator Keys

This class's accelerator keys are unchanged from those of its superclass.

Last Edited: December 2, 2005


Properties for Grid

View property list in alphabetical order

Name | Description
Current_Col | Returns the number of the column of the list that the cursor currently is located in
CustomScrollState | Determines changing scroll bar behaviors
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseFormList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Grid

View event list in alphabetical order

Name | Description
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Click | Sent whenever a header has received a mouse click
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
onInitSpin | Augmented to set the minimum and maximum positions for a spinner
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseFormList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Grid

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the current column of the first row
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Data | Procedure | Causes the grid's current item to be set to the current column of the last row
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Prompt | Procedure | The default message sent by this object's prompt button
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseFormList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Group

Properties Events Methods Index of Classes

To create visual group container objects with (by default) a gray background with a rectangular 3 D line border with a text label embedded in the top left edge

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseGroup
---------------------Group
------------------------dbGroup_
------------------------RadioGroup

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Container_Mixin Standard_Object_Mixin Label_Mixin dfAuto_Locate_Mixin Shadow_Mixin Bitmap_Support_Mixin RGB_Support_Temp_Mixin Help_Mixin

Description

The Group class is used to create visual group container objects with (by default) a gray background with a rectangular 3 D line border with a text label embedded in the top left edge. Objects based on this class are intended to contain controls (forms, buttons, edits, etc.) and other container objects (which will themselves contain controls).

The dbGroup class is a data-aware class similar to the Group class.

Sample

Object oObjectName is a Group
    Set Size to 70 150
    Set Location to 5 5
    Set Label to "Group 1"

    Object F1 is a form
        Set Location to 15 70
        Set Size to 13 40
        Set Label to "Name:"
    End_Object

    Object G2 is a Group
        Set Size to 30 130
        Set Location to 25 10
        Object F2 is a form
            Set Location to 10 70
            Set Size to 13 30
            Set Label to "Id:"
        End_Object

    End_Object

End_Object

Syntax

Object oObjectName is a Group
    Set Size to height width
    set Location to vertical horizontal
    set Label to title
    :
End_Object

Argument Explanation

object_name | The name of the Group object.
height | The height of object_name.
width | The width of object_name.
vertical | The vertical coordinate of object_name's upper-left corner.
horizontal | The horizontal coordinate of the object_name's upper-left corner.
title | A string informing users the purpose of the object.

Of Special Note

This object's client_area_state is set to true. When the object is activated, it will activate all child objects and then give the focus to the first focusable object. The ring_state of object is set to false, allowing for navigation out of the container.

Container3d and Group objects are used to group objects together. They are functionally identical and differ only in appearance.

If you do not wish to display a label, you may set the label property to "", resulting in the display of an unbroken 3 D-line rectangle.

Only basic objects (i.e. the non db... classes such as Form, Edit, Button, Group, etc.) should be placed inside of this object. Data-aware objects (dbForm, dbEdit, dbGroup, etc.) must be placed inside of data-aware containers (dbContainer, dbGroup).

Do not place radio objects inside a Group or dbGroup object. Radio objects must be placed within RadioGroup and dbRadioGroup objects.

Shadowing

Container objects may shadowed by setting the enabled_state property to false. When set, all descendant objects are indirectly (or implicitly) shadowed. When shadowed, (explicitly or by a parent) the group's label will displayed shadowed to indicate its unavailability.

Last Edited: December 2, 2005


Properties for Group

View property list in alphabetical order

Name | Description
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Group

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Group

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: HelpSystem

Properties Events Methods Index of Classes

Used to create help object for a Windows Help Files

Hierarchy

cObject
---HelpSystem

Library: Windows Application Class Library

Package: Dfhlpcl.pkg

Description

The HelpSystem class provides support for an application to access a windows help file. An application can be designed to use HTML help or Windows Help. The use of Windows help is no longer recommended. Therefore, the use of this class is also not recommended. It is provided to allow you to continue to access legacy windows help files. We recommend that you use HTML based help and that you use the cHtmlHelp class provided for this.

The process of using help is an automatic part of the framework. This process is the same for windows and HTML help. Refer the the cHtmlHelp class for more information about using help in an application.

Last Edited: June 21, 2005


Properties for HelpSystem

View property list in alphabetical order

Name | Description
Help_Id_Errors | Holds the name of the topic that should be presented for general error help
Help_Id_Files | Should be set to the help file's help-on-data-files topic ID
Help_Id_General | Should be set to the help file's general-help-topic ID
Help_Id_Index | Should be set to the help file's index-topic ID
Help_Id_Keys | Should be set to the help file's accelerator-keys-help-topic ID
psHelpFile | Assigns a help file name within the help object (not normally used)
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for HelpSystem

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for HelpSystem

View method list in alphabetical order

Name | Type | Description
View_Context_Help | Procedure | Sent when the requesting object has requested keyword or ID help
View_Context_ID_Help | Procedure | Sent when the requesting object has requested integer-ID context help
View_Context_KeyWord_Help | Procedure | Sent when the requesting object has requested keyword-context help
View_Error_Help | Procedure | Displays an error help topic
View_File_Help | Procedure | Sent when the requesting object has requested help about a database file
View_Help_for_help | Procedure | Calls the standard Windows "Help on Help" file
View_help_index | Procedure | Displays the help file's index
View_Help_on_Topic | Procedure | Pops up the help system's "Search" dialog
View_Keys_Help | Procedure | Displays the help file's key topic
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: InetTransfer

Class: InetTransfer (Abstract)

Properties Events Methods Index of Classes

Abstract class for handling HTTP and FTP transfers

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---InetTransfer
------cBaseHTTPTransfer
------cFTPTransfer

Library: Common (Windows and Web Application) Class Library

Package:

Description

InetTransfer provides interface support for handling internet (HTTP and FTP) transfers. Its sub-classes cHTTPTransfer and cFTPTransfer should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for InetTransfer

View property list in alphabetical order

Name | Description
LastErrorCode | Returns the last error code from the HTTP / FTP Transfer
peTransferFlags | Various flags that control how file/data should be transferred
piBufferSize | Specifies the size of the file transfer buffer
piRemotePort | Specifies the port to connect to on RemoteHost
psAgent | Specifies the name of the application
psPassword | Specifies the password to use to log on
psProxy | Specifies the name of the Proxy server used, if any
psRemoteHost | Specifies the hostname or the IP address of the remote server
psUserName | Specifies the name of the user to log on
RootHandle | Returns the root HINTERNET handle used for the session
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for InetTransfer

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for InetTransfer

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: LineControl

Properties Events Methods Index of Classes

Creates divider lines on a container most-often to create a 3 D horizontal dividing line

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaselineControl
---------------------LineControl

Library: Windows Application Class Library

Package: Dfline.pkg

Description

LineControl is used to create divider lines on a container most-often to create a 3 D horizontal dividing line.

Sample

Object Line1 is a LineControl // horizontal 3 D line
    Set Size to 2 100
    Set Location to 50 5
End_Object

Object Line2 is a LineControl // vertical 3 D line
    Set Size to 100 2
    Set Location to 5 5
    Set Horizontal_State to False
End_Object

Object Line3 is a LineControl  // single thick horizontal line
    Set Size to 3 100
    Set Location to 50 5
    Set Line_Style to LnSingle // single blank line
    Set Line_Thickness to 3    // 3-pixel thickness
End_Object

Syntax

Use DFLine
:
Object oObjectName is a LineControl
    Set Size to Height Width
    Set Location to Row Column
    Set Line_Style to iLineStyle
    Set Line_Thickness to PixelThickness
End_Object

Of Special Note

This class allows you to create vertical or horizontal lines of various appearance. Two styles of 3 D gray lines (dip or bump) or a single dark line may be drawn. The thickness of these lines may also be adjusted.

Last Edited: November 21, 2004


Properties for LineControl

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaselineControl
Bottom_Line_Color |
Horizontal_State | Specifies whether the line is horizontal or vertical
Line_Offset |
Line_Style | Supports the line styles LnDip, LnBump, and LnSingle
Line_Thickness | Determines the pixel thickness of the line
Top_Line_Color |
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for LineControl

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for LineControl

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: List

Properties Events Methods Index of Classes

Manipulates dynamic lists of information

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseListbox
------------------------List
---------------------------AbstractTreeView

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Object_Mixin Dflabel_Mixin Multi_Item_Shadow_Mixin RGB_Support_Temp_Mixin Help_Mixin Shadow_Mixin

Description

List is used to manipulate dynamic lists of information. This control class is designed to add, insert, delete and sort items. In addition, the List class uses a scrollbar object to allow users to see more information and use the mouse to navigate through the list.

The dbList class is a data-aware class similar to the List class.

Sample.

Use Windows.pkg

Object oDialog is a ModalPanel
    Set Size to 10 40
    Set Caption_Bar to true
    Set Label to "Mechanic Checklist"
    Object oList is a List
        Set Size to 80 50
        Item_List
            On_Item "Oil Filter" send None
            On_Item "Spark Plugs" send None
            On_Item "Tire pressure" send None
            On_Item "Brake pad" send None
            On_Item "Exhaust" send None
            On_item "Radiator" send None
        End_Item_List
    End_Object
End_Object

Start_Ui oDialog

Syntax

Use dfbase.pkg
Object oContainer is a ContainerClass
    :
    Object oObjectName is a List
        Set Size to height width
        Item_List
            On_Item [prompt [Send message [of dest_object]]]
            :
        End_Item_List
    End_Object
End_Object

Argument Explanation

Container | The object that contains the List object.
ContainerClass | The class (Panel or BasicPanel) of Container.
object_name | The name of the List object.
height | The height of object_name.
width | The width of object_name.
prompt | The prompt to display in an item.
messages | A message to send when an item is chosen.
dest_object | An object to which message is sent.

Of Special Note

List-class objects automatically create their own scroll bar, and assign its location and colors to match itself. When the object is activated, deactivated, paged, rotated up or moved, the scrollbar is automatically manipulated by the List-class object. You may make the scrollbar invisible by setting the object's scroll_bar_visible_state to false.

Use of Item List for Initialization

This class is designed to allow the number of items to change based on the amount of data needed when the program is being executed. Normally, the items are added into the object with the add_item and/or insert_item messages. However, if there is an initial set of items to be used when the object is first created, an item list can be defined in this object. This does not preclude changing the content or number of items later in the program.

Shadowing

Shadowing refers to the process of making an object or an item unavailable for data entry. Usually the appearance of a shadowed object/item is changed in some way to indicate its unavailability. Two types of shadowing are supported: object shadowing and item shadowing.

This class supports both object and item shadowing. Accordingly, objects of this class will be shadowed whenever an ancestor object is shadowed, and its items can be shadowed individually or all together. The enabled_state and item_shadow_state properties are supported, as well as the entire public interface for shadowing.

Accelerator Keys

Name | Message Sent | Defining Class
kscroll_back | key kscroll_back | List
kscroll_forward | key kscroll_forward | List

Last Edited: December 2, 2005


Properties for List

View property list in alphabetical order

Name | Description
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Select_Count |
Select_State |
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Mode | Determines how item-level selections are processed
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for List

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for List

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Select_Count | Procedure Set |
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: MdiClientArea

Properties Events Methods Index of Classes

Provides low-level support for an MDI-style client area

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasemdiclient
------------------------MdiClientArea
---------------------------AppClientArea

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: RGB_Support_Temp_Mixin Bitmap_Support_Mixin Help_Mixin

Description

MDIClientArea is used to provide low-level support for an MDI-style client area. This class is low-level and intended for subclassing and not instantiation.

Syntax

This class is not intended for instantiation.

Of Special Notice

A proper MDI (Multiple Document Interface) application consists of an MDI Panel object (which contains and supports a menu bar, a tool bar, a status bar and a client area), and an MDI client-area object (which contains and supports MDI child dialogs, or views). The MdiClientArea class adds low-level Windows MDI client-area support to the DfBaseDialog class. Before this class can be used for instantiation, an additional level of support must be created. This additional layer is added in the App... classes (AppPanel, AppClientArea, AppDialog). This additional layer is required to enable MDI objects to cooperate with each other. For this reason, the MdiClientArea class is intended only for subclassing (primarily to create AppClientArea).

Last Edited: December 2, 2005


Properties for MdiClientArea

View property list in alphabetical order

Name | Description
Bitmap | Displays a bitmap in an object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Inherited Properties from DfBasemdiclient
Scroll_Bar_Visible_State | Specifies whether this object is to display a scroll bar (or bars) when the content of the object exceeds this object's same-time display capacity
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for MdiClientArea

View event list in alphabetical order

Name | Description
OnKillFocus |
OnSetFocus |
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for MdiClientArea

View method list in alphabetical order

Name | Type | Description
DoHtmlHelp | Procedure | Launches Compiled HTML Help
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Inherited Methods from DfBasemdiclient
Arrange_Icons | Procedure | Arranges the icons for all minimized views contained by this object
Cascade_Windows | Procedure | Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it
Switch_Next_View | Procedure | Switches the focus to the next view object in this object
Switch_Prior_View | Procedure | Switches the focus to the previous view object in this object
Tile_Windows_Horizontal | Procedure | Arranges this object's views from left to right across the top, and then down to the next line, also so arranged
Tile_Windows_Vertical | Procedure | Arranges this object's views from top to bottom down the left side, and then right to the next column, also so arranged
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: MdiDialog

Class: MdiDialog (Abstract)

Properties Events Methods Index of Classes

Creates MDI child dialog objects for use inside a MDI client-area object

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------MdiDialog
---------------------------AppDialog

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Panel_Mixin Modal_Mixin DefaultActionButton_Mixin

Description

MDIDialog is used to create MDI child dialog objects for use inside a MDI client-area object (MdiClientArea or subclass thereof). An MdiDialog object has icons for maximize and minimize, a non-resizable border, system-menu icon, and a caption bar. The object is bound (clipped) by its client area. Use the subclass View or dbView for instantiation.

Of Special Note

A proper MDI (Multiple-Document-Interface) application consists of an MDI panel object (which contains and supports a menu bar, a tool bar, a status bar and a client area), and an MDI client-area object (which contains and supports MDI child dialogs, or views). The MDIDialog class adds low-level Windows MDI child-dialog support. Although the MDIDialog is descended from the Container3d class, its purpose, appearance, and usage are quite different.

Before this class can be used for instantiation, an additional level of support must be created. This additional layer is added in the App... classes (AppPanel, AppClientArea, AppDialog). This additional layer is required to enable MDI objects to cooperate with each other. For this reason, the MDIDialog class is intended only for subclassing (primarily to create AppDialog).

Objects based on this class or a subclass must be placed inside a MDI client-area object.

Normally a MDIDialog object has icons for maximize and minimize, a non-resizable border, system-menu icon, and a caption bar. The object is bound (clipped) by its client area. The caption bar will contain a text caption which is set with the label property.

The MDIDialog sets a number of properties to make its behavior and appearance consistent with MDI child-dialog objects. It sets the following properties to true: Mdi_State, Minimize_Icon, Sysmenu_Icon, Caption_Bar, Attach_Parent_State, Scope_State, Ring_State and Popup_State. It sets Maximize_Icon to False. It is not important that you understand these properties.

Resizing a MDIDialog

When an object of this class is resized by users, this object sends the onResize message to itself. This message is supplied with no definition as a "hook" procedure to use when some action, such as resizing child list objects, is desired on resizing of this object.

Last Edited: December 2, 2005


Properties for MdiDialog

View property list in alphabetical order

Name | Description
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for MdiDialog

View event list in alphabetical order

Name | Description
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for MdiDialog

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure |
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: MenuBar

Properties Events Methods Index of Classes

Provides the capabilities of a standard GUI menu bar

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseActionBar
------------------------MenuBar

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: StatusHelp_Item_Mixin

Description

The MenuBar class provides the capabilities of a standard GUI menu bar.

Sample

Register_object FileMenu
Register_object ToolMenu

Object MainPanel is a Panel
    :
    Object ActionBar is a MenuBar
        Item_List
            On_Item "&File"  send MenuPopup to (FileMenu(self))
            Set Status_Help to "Display file menu options."
            On_Item "&Tools" send MenuPopup to (ToolMenu(self))
            Set Status_Help to "Display tools menu options."
            On_Item "T&asks" send Task_popup
            Set Status_Help to "Popup local task tool menu."
        End_Item_List

        Object FileMenu is a PopupMenu
            :
        End_Object

        Object ToolMenu is a PopupMenu
            :
        End_Object

        Procedure Task_Popup
            integer Foc
            get focus to foc
            Send Start_task to foc
        End_Procedure

    End_Object
    :
End_Object

Syntax

Use windows
:
Object object_name is a MenuBar
    Item_List
        On_Item MenuText Send message [to dest_object]
        Set Status_Help to StatusHelpText
        :
    End_Item_List
End_Object

Of Special Note

The MenuBar class is a subclass of the DfBaseList class and inherits its item-based interface. Items in a MenuBar are normally created using the item_list / end_item_list syntax. Items may also be created, changed and deleted using the dynamic item-interface messages (delete_data, Add_item, Insert_item, delete_item). Items should only be added or deleted when the menu bar is inactive.

Each item in a MenuBar is defined with the following properties: Value, Message, Aux_Value, Shadow_state, and status_help.

Value | An item's value is the text that will be displayed in a menu item. It is set by the on_item command, the add_item and insert_item messages, and can be directly changed with the set value message.
Message and Aux_Value | An item's message determines the message that will be sent when the item is selected. If aux_value is 0, the message is sent to the current focus object. If aux_value is non-zero, the message is sent to the object ID in aux_value. If the message is MenuPopup (or 0), the object ID represented in Aux_Value is activated as a popup menu. This is the method used by menubar objects to create PopupMenu "pulldown" objects.
Shadow_State | If an item's shadow_state is true, the item will appear disabled and users will be unable to select the item.
Status_Help | Each item may have status-help text associated with it. When the menu item is selected, this help will appear in the status bar.

The Focus

The menu bar and its popup-menu children never take the focus. When a MenuBar or PopupMenu is selected, the focus does not change and no focus-change messages are sent. This is actually a very useful feature. If you wish to know what object was the focus object when the menu bar was selected, simply get the focus property.

Character Highlighting

A highlight character may be defined by prefixing the & symbol to the letter that should be highlighted. When the Alt key plus the highlighted letter is pressed, the highlighted letter's popup menu will be activated.

On_Item "&File" Send PopupMenu to (obj(self))

MenuBar Events

Each time a menubar object (or one of its PopupMenu objects) is selected, the event message onInitMenu is sent. This is a notification that the menu is now active. The message InitializeMenu is also sent. If you augment this message, you must remember to forward it. When a PopupMenu is being exited, the message Exit_Menu is sent. If augmented, this also must be forwarded.

Any time any menu item change occurs within the MenuBar or within any PopupMenu in the MenuBar, the message change_menu is sent to the MenuBar. This message is passed both an item number and an object number. This allows the message to determine which object caused the event. If augmented, this must be forwarded-it controls the display of status help.

MenuBar system

The menu-bar-system package defined in DfMenu.pkg provides a number of macro commands to make it easier to create MenuBar / PopupMenu systems. This is described in the Menu System section.

Last Edited: December 2, 2005


Properties for MenuBar

View property list in alphabetical order

Name | Description
Shadow_Status_Help | Specifies the display in the status bar for items of this object that are shadowed
Simple_Status_Help_State |
Status_Help | The status-bar help text for Item item#
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for MenuBar

View event list in alphabetical order

Name | Description
OnChange | A "hook" procedure has no definition; it is provided for your use
OnInitMenu | Sent when a menu-bar system is about to be activated
Inherited Events from DfBaseActionBar
Initialize_Menu | Sent when the Menubar system is about to be selected
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for MenuBar

View method list in alphabetical order

Name | Type | Description
Menu_Status_Help | Function |
Inherited Methods from DfBaseActionBar
Exit_Menu | Procedure |
Redirect_Message | Procedure |
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Mixin

Properties Events Methods Index of Classes

Provides a method for mixing additional skills into a class

Hierarchy

cObject
---Mixin

Library: Common (Windows and Web Application) Class Library

Package: VdfBase.pkg

Description

While the DataFlex class-construction process does not support multiple inheritance, it does support a method of importing common methods into a class. The Mixin class provides some of the functionality of multiple inheritance without its overhead or complexity. This advanced technique should primarily be of interest to tool builders. All of the DataFlex data-entry classes make extensive use of this technique.

Often multiple classes will all need to exhibit similar behaviors. If these classes share the same superclass, these common behaviors will all be acquired through inheritance. For example, all of the data-entry classes acquire their user-interface behaviors through class inheritance. In other cases, common behaviors cannot be acquired through inheritance. In a single-inheritance object system, this means that these non-inherited behaviors must be added to each class. An example of this is the data-server-connectivity behaviors that all DEOs must exhibit. While you could accomplish this by including the same code in every class, this duplication has a high overhead.

Rather than requiring you to include duplicate code, DataFlex supports the ability to import all functions and procedures from one class into another. This is similar to including the actual functions and procedures in each class without the overhead of duplication. Because the imported class does not import the class structure itself, this is not multiple inheritance. This should be thought of as a method of importing skills into classes.

The command import_class_protocol provides the mechanism for importing skills (functions, procedures, and properties) from one class into another. This command supports several options that are documented in full in the Language Reference.

Classes from which skills are imported are special-purpose classes, often with names ending with _mixin. Not only can these classes not be subclassed, they cannot be instantiated,either. Objects needing the skills of the "mixin" class are based on a (non-mixin) class that imports the skills. Mixins should be based on the Mixin class. This is a simple class based on cObject. It contains no new methods, events or properties. A mixin class has no native methods because those methods should never be mixed into another class. Only the interfaces actually defined in the mixin will be mixed into another class.

Example

We have two classes that both need to share a number of common procedures that will not be acquired through class inheritance. We will place all of these procedures in a mixin class. These skills will all be imported with the import_class_protocol command. Here is the package that contains the mixin class, called new_skills_mixin:

// NewSkill.pkg
use Windows.pkg

Class New_Skills_Mixin is a Mixin
    Procedure New_Skill_1
        :
    End_Procedure
    :
    Procedure New_Skill_37
        :
    End_Procedure
End_Class

This package contains the first of the two importing classes:

// Deo1.pkg
Use DeoSpr1.pkg  // the superclass deo class package
Use NewSkill.pkg // our mixin class package
Class Deo_1 is a Some_Deo_Super_Class
    :
    Import_Class_Protocol New_Skills_Mixin
    :
End_Class

This package contains the second of the two importing classes:

// Deo2.pkg
Use DeoSpr2.pkg  // the super class deo class package
Use NewSkill.pkg // our mixin class package
Class Deo_s is a Some_Other_Deo_Super_Class
    :
    Import_Class_Protocol New_Skills_Mixin
    :
End_Class

Importing Property Definitions

The above method shows how to import procedures and functions. Properties also may be imported. Since properties should be created during the construct_object process, we will need to send a message in construct_object (in the importing class-mixin classes should never contain a construct_object procedure). The procedure to handle this message will reside in the mixin class. We will define our properties inside of this procedure.

The following example shows how to mix in properties. Here is code from the mixin package:

// NewSkill.pkg
use Windows.pkg

Class New_Skills_Mixin is a Mixin

    // this will get called once and only once during the
    // construct_object phase of the main class. Here we can
    // declare properties, set properties or set accelerator keys.
    Procedure Define_New_Skills_Mixin
        Property Integer piProp1 0
        :
        Property Integer psPropX  "XXX"
    End_Procedure

    Procedure New_Skill_1
        :
    End_Procedure
    :
    Procedure New_Skill_37
        :
    End_Procedure
End_Class

Here is an importing-class package:

// Deo1.pkg
Use DeoSpr1.pkg  // the deo superclass package
Use NewSkill.pkg // our mixin class package
Class Deo_1 is a Some_Deo_Super_Class
    Procedure Construct_Object
        Forward Send Construct_Object
        :
        send Define_New_Skills_Mixin // define any properties or whatever.
    End_Procedure
    :
    Import_Class_Protocol New_Skills_Mixin
    :
End_Class

You can import mixin classes at any class level, you can import as many mixin classes as you wish, your mixin can contain as many messages as you wish, and your importing class may contain any number of messages. If a mixin class and the importing class both define or augment the same message, one of the augmentations will be ignored. If two mixin classes define or augment the same message, one of the augmentations will be ignored. The last message handler defined will actually be the message. This kind of overlap is usually undesirable, and when it occurs it is usually a bug. Because of this, you must be careful with the management of your mixin classes.

The use of mixin classes is an advanced technique and is certainly not required for successful programming. It is however, a very powerful technique. If you wish to learn more about this technique, you are encouraged to review the DataFlex package files in the /pkg folder.

Last Edited: December 2, 2005


Properties for Mixin

View property list in alphabetical order

Name | Description
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Mixin

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Mixin

View method list in alphabetical order

Name | Type | Description
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ModalPanel

Properties Events Methods Index of Classes

Creates modal popup panels

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------ModalPanel
---------------------------------AboutDialog
---------------------------------ReportPanel

Library: Windows Application Class Library

Package: Windows.pkg

Description

ModalPanel is used to create modal popup panels. By default, the modal panel will appear relative to the object that invoked it. It can be moved anywhere on the screen. While it is active, all other panels in the application are disabled. This class is used with non-data-aware child objects. If you need to use DEOs within your modal panel, you should use the dbModalPanel class.

Sample

Object MyPopupPanel is a ModalPanel
    Set Size to 100 150
    Set Label to "My Tool Panel"
    :
End_Object

Syntax

Use windows

Object object_name is a ModalPanel
    set size to height width
    set locate_mode to LocateMode
    set label to title
    :
End_Object

Of Special Note

Caption Bar Label

The text that will appear in a panel's caption bar is set with the Label property. Note that this label will not appear in the Windows task list.

Resizing a Panel

When an object of this class is resized by users, this object sends the onResize message to itself. This message is supplied with no definition as a "hook" procedure to use when some action, such as resizing child list objects, is desired on resizing of this object.

Locating a Panel

The location of a panel is controlled by the properties location and locate_mode. The default "smart" locate_mode will cause the panel to appear relative to the object that invoked it. This can be changed by changing the locate_mode property to no_locate and setting location as desired.

Exiting the Application

When a ModalPanel receives an exit_application message (e.g., the user presses the exit-application key), this message is converted into a close_panel message. This causes the panel and not the application to close. This behavior is consistent with all other Windows applications.

Invoking a ModalPanel

A ModalPanel object is activated by sending it the Popup_Modal message. This activates the object and starts a new level of user interface. When the panel is closed, the new level of user interface is ended and execution proceeds from the calling procedure. Often it is desirable to create a special interface to a modal panel which returns a status value to the calling procedure. In the following example, the ModalPanel's custom function LoginUser will pop up a password screen and return a 0 if the password failed and a 1 if it succeeded.

Object LoginPanel is a ModalPanel
    Set size to 100 100
    Set label to "Password"
    // custom property. The panel will set this true if the login is valid
    Property Integer LoginOk public False
    // objects and logic to enter and confirm password goes here
    :

    Function LoginUser returns integer
        integer PassWordOK
        Send Popup_Modal
        Get LoginOK to PassWordOK
        Function_Return PassWordOk
    End_Function
End_Object

This would be called with the following invoking procedure:

Procedure ..
    Integer PassWordOk
    Get LoginUser of (LoginPanel(self)) to PassWordOk
    If PassWordOk .
    else .
End_procedure

Message Boxes

Often modal popup objects are required to present simple confirmation messages (Save this record) or to present information (This is not a valid option). Although you could use a ModalPanel for this purpose, you will probably find it easier to use standard Windows message boxes to perform these tasks.

There are no new properties in this class. The following properties are set to give an object the proper modal appearance and behavior: Caption_bar is true, Border_Style is set to Border_Dialog, Minimize_Icon is false, Maximize_Icon is false, SysMenu_Icon is true, and Modal_State is true.

Last Edited: December 2, 2005


Properties for ModalPanel

View property list in alphabetical order

Name | Description
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ModalPanel

View event list in alphabetical order

Name | Description
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ModalPanel

View method list in alphabetical order

Name | Type | Description
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Close_Panel | Procedure |
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: OpenDialog

Properties Events Methods Index of Classes

Provides access to the Windows file-open dialog

Hierarchy

cObject
---AbstractFileDialog
------OpenDialog

Library: Windows Application Class Library

Package: File_dlg.pkg

Description

OpenDialog is used to provide access to the Windows file-open dialog. It permits users to select an existing file or enter a name to create.

Sample

Use dfAllEnt
Use File_Dlg

Object oPanel is A Panel
    Set Size     To 50 175
    Set Location To 25 12
    Set Label    To 'Open Dialog Example'

    Object oOpenFile is an OpenDialog
        Set Filter_String To ;
        'Source|*.src|Include Files|*.inc|Packages|
            *.pkg|All Source|*.src;*.pkg;*.inc'
        Set Initial_Folder    To 'C:\Program Files\Visual DataFlex 11.1'
        Set Filter_Index      To 2
    End_Object

    Object oOpen_bn IS A Button
        Set Location To  10 10
        Set Label    To 'Open...'

        Procedure OnClick
            integer bOpen bReadOnly
            String sFileTitle sFileName

            Get Show_Dialog of (oOpenFile(self)) To bOpen
            If bOpen Begin
                Get TickReadOnly_State of (oOpenFile(self)) To bReadOnly
                Get File_Title of (oOpenFile(self)) To sFileTitle
                Get File_Name  of (oOpenFile(self)) To sFileName
                If bReadOnly Append sFileName ' (Read-Only)'
                Send Info_Box ;
                    ("File Title=" +sFileTitle +"\nFile Name=" +sFileName)
            End
            Else Send Info_Box "You did NOT choose a file"
        End_Procedure
    End_Object
End_Object

Start_UI

Syntax

Use File_Dlg

Object object_name is an OpenDialog
    Set Filter_String To filter-string
    Set Initial_Folder To folder-name
    Set Dialog_Caption To text
End_Object

See Also

Info_Box

Last Edited: August 18, 2005


Properties for OpenDialog

View property list in alphabetical order

Name | Description
Inherited Properties from AbstractFileDialog
AllowReadOnly_State | Determines whether users without write access can select files that are read-only or in a read-only folder
CreatePrompt_State | Determines if a message box will ask users whether they want to create the entered filename, when such filename is not found
Dialog_Caption | Sets this object's caption
File_Name | Holds the full pathname of the file and can be considered a read-only property
File_Title | Holds the title of the file (i.e., without path)
FileMustExist_State | Specifies whether users can enter a file title that doesn't exist
Filter_Index | Determines which filter you would like this object's Filter combobox to start with
Filter_String | Holds the descriptions and filters that will be available to users
HideReadOnly_State | Determines whether the checkbox is hidden
Initial_Folder | Determines the starting point for this object
NoChangeDir_State | Restores the current directory to the original directory if the user switched the current directory while searching for files
OverwritePrompt_State | Specifies whether users should be prompted before selecting a file name that already exists
PathMustExist_State | Specifies whether users can enter a file path that doesn't exist
ShowFileTitle_State | Specifies whether the contents of the file_title property should be inserted into the dialog box as a default for selectin
TickReadOnly_State | Checks/un-checks the Read-only checkbox
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for OpenDialog

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for OpenDialog

View method list in alphabetical order

Name | Type | Description
Inherited Methods from AbstractFileDialog
Show_Dialog | Function | Determines how the dialog box is constructed and behaves
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Panel

Properties Events Methods Index of Classes

Provides a top-level window for applications that is independent of all other windows

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------BasicPanel
---------------------------AppPanel
------------------------------Panel

Library: Windows Application Class Library

Package: Dfpanel.pkg

Description

Panel container class provides a top-level window for applications that is independent of all other windows. Essentially, an object based on this class contains your application. It is expected that a Panel object will contain a single MenuBar, cToolBar, ClientArea and cStatusBar. By default, a Panel object has icons for maximize and minimize, a resizable border, system-menu icon, and a caption bar.

Sample

Object Pnl is an Panel
    Set Size to 200 250
    Set Label to "MyTest Panel"
    :
    Object ClientArea is a ClientArea
        : Add Mdi view objects
    End_object
    :
End_Object

Syntax

Object object_name is an Panel
    Set Size to Height Width
    Set Label to CaptionText
    :
    : Add MenuBar object
    : Add Tool bar object
    : Add Client area object
    : Add Status-bar object
    :
End_object

Of Special Notice

Three levels of programming classes are supported: basic (non-MDI, no support for tool bars or status bars), application (App... classes-MDI support, basic tool-bar and status-bar support), and high-level-application.

A proper MDI (Multiple-Document Interface) application consists of an MDI panel object with a menu bar, a tool bar an MDI client-area object and a status bar. The MDI client area contains and supports MDI child dialogs and/or views.

Although complete applications can be written using the App... classes, they are considered to be intermediate-level classes. A higher and more-powerful level of classes exists, and it is expected that most applications will be written using the high-level classes (Panel, MenuBar, cToolBar, ClientArea, cStatusBar, View, dbView, ReportView). A normal program is structured as follows:

    Panel
        MenuBar
            PopupMenus
            :
        ToolBar
        ClientArea
            :
            Views (View, dbView, ReportView)
            :
        Statusbar

Size and Location

Objects based on this class have the ability to store the object's size, location and view mode in the registry when the program is closed. The next time the application is loaded, these setting are retrieved and used. This information is only saved if the registry key SaveEnvironment is set to YES.

HourGlass Mouse Pointer

A panel contains most of the other objects within an application. Upon object construction, all child objects must be created and initialized. While this occurs, the mouse pointer is changed to an hourglass, giving users a visual sign that the program is starting up.

This class's properties are unchanged from those of its superclass.

Last Edited: September 2, 2005


Properties for Panel

View property list in alphabetical order

Name | Description
Inherited Properties from AppPanel
Auto_Activate_State | Determines whether object will activate automatically after it has been created
Auto_Arrange_Icons_State | Determines if icons are rearranged each time this object is resized
Client_Scrollbar_State | Determines if a scroll bar should appear when a contained view's size or placement causes it to exceed the display capacity of its client area
StatusBar_State | Determines if object will display a status bar
ToolBar_State | Determines if the object will display its tool bar
Inherited Properties from BasicPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id | The ID of the panels's client-area object
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id | The ID of the panel's status-bar object
Toolbar_Id | The ID of the panel's tool-bar objec
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Panel

View event list in alphabetical order

Name | Description
Inherited Events from AppPanel
Notify_Exit_Application | Received when an application is about to be exited
Verify_Exit_Application | Called when an exit-application request has been made
Inherited Events from BasicPanel
OnActivateApp | Sent when the panel and, therefore, the application is activated
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp | Sent when this object is deactivated
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Panel

View method list in alphabetical order

Name | Type | Description
Inherited Methods from AppPanel
Cascade_Windows | Procedure | Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it
Minimize_all_Windows | Procedure | Minimizes all views within the client area
Restore_all_Windows | Procedure | Restores all minimized windows (views) in the client area
Tile_Windows_Horizontal | Procedure | Horizontally tiles all windows (views) in the client area
Tile_Windows_Vertical | Procedure | Vertically tiles all windows (views) in the client area
Toggle_Statusbar | Procedure | Toggles the value of the statusBar_state property
Toggle_Toolbar | Procedure | Toggles the value of the Toolbar_state property
Inherited Methods from BasicPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Close_Panel | Procedure |
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: PickList

Class: PickList (Abstract)

Properties Events Methods Index of Classes

Abstract class that allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------PickList_
------------------------------------------PickList
---------------------------------------------CodePickList_

Library: Windows Application Class Library

Package: Dfpcklst.pkg

Description

PickList is used to allow selection of one or more values from a list of static choices for insertion into database records by a code (usually one character) for each choice in programs handling the database through DataSets. Its sub-class CodePickList should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for PickList

View property list in alphabetical order

Name | Description
CustomScrollState | Determines changing scroll bar behaviors
ScrollOnThumbTrackState |
ThumbScrollState |
Inherited Properties from PickList_
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational
Invoking_Object_ID | Identifies the object which activated this object
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent
Original_Selection | Identifies the item that was selected when this object was originally activated
Popup_State | (Obsolete)
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for PickList

View event list in alphabetical order

Name | Description
Mouse_Click |
Inherited Events from PickList_
Fill_List |
Initialize_List |
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Click | Sent whenever a header has received a mouse click
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
onInitSpin | Augmented to set the minimum and maximum positions for a spinner
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for PickList

View method list in alphabetical order

Name | Type | Description
Inherited Methods from PickList_
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the first enterable column of the first row
Cancel | Procedure | Deactivates this object
End_of_Data | Procedure | Causes the grid's current item to be set to the last enterable column of the last row
first_selected_item | Function |
Init_Selected_Item | Procedure | Sets enumeration_counter to zero
Move_Value_Out | Procedure | Overridden to set the value of the current item of the invoking object to the code value of the current item of this object upon selection, and then to send display_description to the invoking object
next_selection | Function | Returns identifier of next selected item
Ok | Procedure | Oks a list selection
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
Up_Row | Procedure | Changes the current item to the prior row, if any, at the same item relative to the beginning of the row
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: PickList_

Class: PickList_ (Abstract)

Properties Events Methods Index of Classes

Abstract class that allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------PickList_
------------------------------------------PickList

Library: Windows Application Class Library

Package: Dfpcklst.pkg

Mixins: Pick_List_mixin LIST_Mixin Non_Dependent_Item_Mixin Auto_Locate_Mixin

Description

PickList_ is used to allow selection of one or more values from a list of static choices for insertion into database records by a code (usually one character) for each choice in programs handling the database through DataSets. Its sub-class CodePickList should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for PickList_

View property list in alphabetical order

Name | Description
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational
Invoking_Object_ID | Identifies the object which activated this object
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent
Original_Selection | Identifies the item that was selected when this object was originally activated
Popup_State | (Obsolete)
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for PickList_

View event list in alphabetical order

Name | Description
Fill_List |
Initialize_List |
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Click | Sent whenever a header has received a mouse click
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
onInitSpin | Augmented to set the minimum and maximum positions for a spinner
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for PickList_

View method list in alphabetical order

Name | Type | Description
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the first enterable column of the first row
Cancel | Procedure | Deactivates this object
End_of_Data | Procedure | Causes the grid's current item to be set to the last enterable column of the last row
first_selected_item | Function |
Init_Selected_Item | Procedure | Sets enumeration_counter to zero
Move_Value_Out | Procedure | Overridden to set the value of the current item of the invoking object to the code value of the current item of this object upon selection, and then to send display_description to the invoking object
next_selection | Function | Returns identifier of next selected item
Ok | Procedure | Oks a list selection
Inherited Methods from WideList
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
Up_Row | Procedure | Changes the current item to the prior row, if any, at the same item relative to the beginning of the row
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: PopupMenu

Properties Events Methods Index of Classes

Displayed whenever a choice is made from a menu bar and from certain choices made from an already-displayed popup menu

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseActionBar
------------------------DfBasePullDown
---------------------------PopupMenu
------------------------------DEOPopupMenu
------------------------------ViewPopupMenu

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Statushelp_Item_Mixin

Description

A PopupMenu object is displayed whenever a choice is made from a menu bar and from certain choices made from an already-displayed popup menu.

Sample

Object MainPanel is a Panel
    :
    Object ActionBar is a MenuBar
        Item_List
            On_Item "&File"  send MenuPopup to (FileMenu(self))
            Set Status_Help to "Display file menu options."
            :
        End_Item_List

        Object FileMenu is a PopupMenu
            Item_List
                On_Item "&Open" Send Open_File
                Set Status_Help to "Open a new File"
                On_Item "&Close Send Close_File
                Set Status_Help to "Close the File"
                On_Item "" Send None // separator
                On_Item "&Exit" Send Exit_Application
                Set Status_Help to "Exit current Application"
            End_Item_List

            Procedure OnInitMenu
                integer Opened
                Delegate get File_Opened to Opened
                Set Shadow_State item 1 to (Opened=0)
            End_Procedure

        End_Object

    End_Object
    :
End_Object

Syntax

Use windows
:
Object object_name is a PopupMenu
    Item_List
        On_Item MenuText Send message [to dest_object]
        Set Status_Help to StatusHelpText
        On_Item "" send none // separator
        :
    End_Item_List

    Procedure OnInitMenu
        :
    End_Procedure
End_Object

Of Special Note

The PopupMenu class is a subclass of the MenuBar class and inherits its item-based interface. Items in a PopupMenu are normally created using the item_list / end_item_list syntax. Items may also be created, changed, and deleted using the dynamic item-interface messages (delete_data, add_item, Insert_item, delete_item). Items should only be added or deleted when the menu bar is inactive. The dynamic adding of items may be performed within the OnInitMenu event procedure.

Each item in a PopupMenu is defined with the following properties: Value, Message, Aux_Value, Shadow_state, status_help and select_state.

Value | An item's value is the text that will be displayed in the menu item. It is set by the on_item command, the add_item and insert_item messages, and can be directly changed with the set value message.
Message and Aux_Value | An item's message specifies the message that will be sent when the item is selected. If aux_value is 0 (and it normally is), the message is sent to the current focus object. If aux_value is non-zero, the message is sent to the object ID in aux_value. If the message is MenuPopup (or 0), the object ID represented in Aux_Value is activated as a child PopupMenu. This is referred to as a cascading popup menu.
Shadow_State | If an item's shadow_state is true, the item will appear disabled and users will be unable to select the item.
Status_Help | Each item may have status-help text associated with it. When the menu item is selected, this help will appear in the status bar.
Select_State | If the popup-menu object's select_mode is set to Multi_Select, users may set the select_state of any menu item. When selected, the item will appear with a check mark in front of it.

Separators

Item separators may be created by creating a blank item. A 3 D line will be drawn to separate the other menu items. Although this item cannot be selected, it does exist.

On_Item "" Send None

Send Add_Item msg_none ""

Character Highlighting

A highlight character may be defined by prefixing the & symbol to the letter that should be highlighted. When the menu is selected, pressing that highlighted letter (actually it will appear underlined) will select the item.

On_Item "&Save" Send SaveIt

Send Add_Item msg_SaveIt "&Save"

The Focus

The menu bar and its popup-menu children never take the focus. When a MenuBar or PopupMenu is selected, the focus does not change and no focus change messages are sent. This is actually a very useful feature. If you wish to know what object was the focus object when the menu bar was selected, simply get the focus property.

PopupMenu Events

Each time a PopupMenu object is selected, the event message onInitMenu is sent to the object. This is a very useful message. This occurs before the object has been displayed. This is a good time for changing menu items or setting shadow states or select states.

Anytime any menu item change occurs within the a PopupMenu, the message change_menu is sent to the MenuBar. This message is passed both an item number and an object number. This allows the message to determine which object caused the event. If augmented, this must be forwarded-it controls the display of status help.

The following example shows how OnInitMenu might be used to set the shadow_state of various items based on a user login level.

Procedure OnInitMenu
    integer Level
    Get UserID_Level to Level
    Set Shadow_state item 0  to False
    Set Shadow_state item 1  to False
    Set Shadow_state item 2  to (Level lt 1)
    Set Shadow_state item 3  to (Level lt 2)
    Set Shadow_state item 4  to (Level lt 3)
End_Procedure

The following example shows how select_state may be set and changed within an object. This is using the DFCreate_Menu syntax described in the Menu_System section.

DFCreate_Menu "&Display_Options" Display_Options_Menu
    Set select_mode to Multi_Select
    // note: sending to Self will force the message to get sent to the
    //       PopupMenu which will then delegate to the panel object which
    //       understands these messages.
    On_Item "&Tool-bar"   send Toggle_ToolBar   To Self
    On_Item "&Status-bar" send Toggle_StatusBar To Self

    Procedure OnInitMenu
        integer bState
        Delegate Get ToolBar_State to bState
        Set Select_State Item 0 to bState
        if  bState   Set Status_Help Item 0 To 'Remove the Tool bar'
        Else         Set Status_Help Item 0 to 'Add the Tool bar'

        Delegate Get Statusbar_State to bState
        Set Select_State Item 1 to bState
        if  bState  Set Status_Help Item 1 To 'Remove the Status bar'
        Else        Set Status_Help Item 1 to 'Add the Status bar'
    End_procedure
End_Menu

MenuBar System

The menubar-system package defined in DfMenu.pkg provides a number of macro commands to make it easier to create MenuBar / PopupMenu systems. This is described in the Menu System section.

SubClasses of PopupMenu

Two PopupMenu subclasses are provided to support special popup menus. The ViewPopupMenu redirects messages to the client-area object instead of the focus object. This is used activate views and report views from a menu. The DEOPopupMenu provides a mechanism for the menu to determine if the invoking focus object is a DEO and if it is a DEO control. This is used to properly shadow items (within onInitMenu), which ensures that DEO messages are never sent to non-DEOs.

Last Edited: December 2, 2005


Properties for PopupMenu

View property list in alphabetical order

Name | Description
Shadow_Status_Help | Specifies the display in the status bar for items of this object that are shadowed
Simple_Status_Help_State |
Status_Help | The status-bar help text for Item item#
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for PopupMenu

View event list in alphabetical order

Name | Description
OnChange | Called every time a menu changes
OnInitMenu | Sent when a PopupMenu object is about to be selected
Inherited Events from DfBaseActionBar
Initialize_Menu | Sent when the Menubar system is about to be selected
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for PopupMenu

View method list in alphabetical order

Name | Type | Description
Menu_Status_Help | Function |
Inherited Methods from DfBaseActionBar
Exit_Menu | Procedure |
Redirect_Message | Procedure |
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: PrintDialog

Properties Events Methods Index of Classes

A wrapper for the Windows Print dialog box used by the CrystalReport class

Hierarchy

cObject
---PrintDialog

Library: Windows Application Class Library

Package: Prnt_dlg.pkg

Mixins: Print_Dialog_Mixin

Description

The PrintDialog class is a wrapper for the Windows Print dialog box. This dialog box is used to specify the properties of a print job. This class is intended to be used with the CrystalReport class exclusively. The CrystalReport method SelectAndSetPrinter is normally used to invoke the print dialog. The CrystalReport package creates a global object named WinQLSelectPrinter for you to use.

Object oReport is a CrystalReport
    :
    Procedure OnInitializeReport
        Integer iResult iFromPage

        Get SelectAndSetPrinter To iResult
        If iResult Begin
              Get FromPage Of WinQLSelectPrinter To iFromPage
              :
        End
    End_Procedure // OnInitializeReport

End_Object // oReport

Note:This class was not designed to be used outside of the CrystalReport class. Developers who choose to use this class beyond its intended purpose will need to review the class code in the package and be familiar with the windows API. Improper use of this class can result in memory leaks.

See Also

CrystalReport

Last Edited: November 21, 2004


Properties for PrintDialog

View property list in alphabetical order

Name | Description
Collate | Specifies whether collation should be used when printing multiple copies
Color | Specifies whether color printing should be used with color printers
Copies | Specifies the number of copies printed
DefaultSource | Specifies the default paper source (tray)
DeviceContext | Holds a handle to the device context that can be used in windows API calls.
DeviceName | Specifies the name of the printer
DitherType | Specifies the dithering type
DriverName | Specifies the driver name
Duplex | specifies the double-sided printing type
Flags | Print Dialog bit flag property
FormName | Specifies the name of the form
FromPage | The value of the starting page
ICMIntent | Specifies the color matching method, or intent
ICMMethod | Specifies how ICM is handled
MaxPage | The maximum value for the ToPage property
MediaType | Specifies the type of media, paper or film, being printed on
MinPage | The minimum value for the FromPage property.
Orientation | specifies the orientation of the paper
OutputName | Holds the device name for the physical output medium (output port)
PaperLength | If set, overrides the length of the paper specified by the PaperSize
PaperSize | Specifies the size of the paper to print on
PaperWidth | If set, overrides the width of the paper specified by the PaperSize property
PrintQuality | Specifies the printer resolution
Scale | Specifies the factor by which the printed output is to be scaled
ToPage | The value of the ending page
TTOption | Specifies how TrueType fonts should be printed
YResolution | Specifies the y-resolution, in dots per inch (DPI), of the printer
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for PrintDialog

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for PrintDialog

View method list in alphabetical order

Name | Type | Description
PrintDialog | Function | Used to display the print dialog box
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Prototype_Entry

Properties Events Methods Index of Classes

Helper Class used by DEO Grid classes (dbGrids and dbLists) to define row information

Hierarchy

cObject
---cUIObject
------Cm_Menu
---------Cm_Entry
------------Prototype_Entry

Library: Windows Application Class Library

Package: Protoent.pkg

Description

The Prototype_Entry class is used by the DEO dbGrid and dbList classes to help define information about each a row in the grid. A child prototype_entry object is created that is used to model each row added to a data-aware grid.

For the most part, this class and object created based on this class are considered part of the implementation detail of DEO grids. You will never create objects or sub-classes based on this class. Most access to information in this child object is handled by the DEO grid class and, therefore, you will rarely need to access properties from objects based on this class.

In those rare cases where you do need to access information from this class you will do so by querying the dbGrid or dbList's prototype_object property. This contains a handle pointer to the prototype_entry object.

Get Prototype_entry of oOrderGrid to hoElement
Get data_file   of hoElement 0 to iFirstColumnFile
Get data_field of hoElement 0 to iFirstColumnField

Last Edited: August 8, 2003


Properties for Prototype_Entry

View property list in alphabetical order

Name | Description
Inherited Properties from Cm_Entry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from Cm_Menu
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Prototype_Entry

View event list in alphabetical order

Name | Description
Inherited Events from Cm_Entry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from Cm_Menu
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Prototype_Entry

View method list in alphabetical order

Name | Type | Description
Inherited Methods from Cm_Entry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from Cm_Menu
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Down | Procedure | Sends the key kdownarrow message to the object
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Radio

Properties Events Methods Index of Classes

Provides visual selection icons that are used in groups exclusively within radio containers

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseButton
------------------------DfBaseCheckbox
---------------------------DfBaseRadioButton
------------------------------RadioButton
---------------------------------Radio

Library: Windows Application Class Library

Package: Windows.pkg

Description

Radio is used to provide visual selection icons that are used in groups exclusively within radio containers. They are selected by use of the mouse or the selection cursor, which is moved among them with arrow keys. Each Radio object can display a label describing the choice it offers. Radio objects must be placed inside a radio grouping object (RadioGroup, dbRadioGroup, RadioContainer, or dbRadioContainer).

Sample

See samples in RadioGroup, RadioContainer, dbRadioGroup and dbRadioContainer.

If you add a radio object to a container that is not of one of the 4 classes listed above (or descendants), you will get runtime errors that tell you that the radio object could not be registered properly.

Syntax

Use windows

Object RadioContainer is a RadioContainerClass
    :
    Object object_name is a Radio
        Set location to vertical horizontal
        Set label to text
    End_Object
End_Object

Of Special Note

Objects of this class are very simple objects and are used as items by radio-container objects. You are encouraged to keep radio objects as simple as possible (only set their location and label) and to add all other programming changes to their radio-container. The radio-grouping classes are RadioGroup, RadioContainer, dbRadioGroup, and dbRadioContainer.

Last Edited: November 9, 2006


Properties for Radio

View property list in alphabetical order

Name | Description
Inherited Properties from RadioButton
AlignmentMode | Determines if text is displayed to the right of the radio or the left of the radio
Auto_Size_State | Determines if object will be resized to the length of the label text
Bitmap | Displays a bitmap in an object
Checked_State | Reflects whether this object is checked
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label |
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Radio

View event list in alphabetical order

Name | Description
Inherited Events from RadioButton
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange |
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Radio

View method list in alphabetical order

Name | Type | Description
Next_Item | Procedure | Moves to the next radio object within the group and sets the object's changed_state to true
Previous_Item | Procedure | Moves to the prior radio object within the group and sets the object's changed_state to true
Inherited Methods from RadioButton
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: RadioButton

Properties Events Methods Index of Classes

An intermediate that provides support for stand-alone radio buttons

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseButton
------------------------DfBaseCheckbox
---------------------------DfBaseRadioButton
------------------------------RadioButton
---------------------------------Radio

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Select_Mixin Bitmap_Support_Mixin Standard_Object_Mixin Single_Item_Navigate_Mixin Select_Mixin RGB_Support_Temp_Mixin Help_Mixin Shadow_Mixin

Description

The RadioButton class is an intermediate that provides support for stand-alone radio buttons. This class is used by the Radio subclass and is not intended for instantiation.

Of Special Note

This class is a subclass of the Checkbox class and inherits all of its attributes. This class is essentially a checkbox with a radio appearance. This is of little use for instantiation, since radio buttons are designed to be used with other radio buttons. Instead, you would use its subclass, Radio.

Last Edited: December 2, 2005


Properties for RadioButton

View property list in alphabetical order

Name | Description
AlignmentMode | Determines if text is displayed to the right of the radio or the left of the radio
Auto_Size_State | Determines if object will be resized to the length of the label text
Bitmap | Displays a bitmap in an object
Checked_State | Reflects whether this object is checked
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label |
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for RadioButton

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange |
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for RadioButton

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: RadioContainer

Properties Events Methods Index of Classes

Groups multiple Radio objects in a non-visible object, providing selection of no more than one at a tim

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseGroup
---------------------Group
------------------------RadioGroup
---------------------------RadioContainer

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: NonVisual_Container_Mixin

Description

RadioContainer is used to group multiple Radio objects in a non-visible object, providing selection of no more than one at a time. This is used to create more-complicated visual interfaces where non-radio objects appear to be mixed with radio objects.

Sample

Object G1 is a Group
    Set Label to "Complex Radio and Checkbox Group"
    Set Location    TO 15   10
    Set Size        TO 120 200

    Object G2 is a RadioContainer

        object r1 is a Radio
            Set location to 10 10
            Set Label to "Enable Checkbox"
       end_object

        object r2 is a Radio
            set location to 25 10
            Set Label to "Shadow Checkbox"
        end_object

        Procedure Notify_Select_State integer NewId integer OldId
            // If moving to first radio, enable checkbox, else disable
            If OldId eq 0 delegate Send Shadow_Ckbox True
            Else          delegate Send Shadow_Ckbox False
        end_Procedure
    End_Object

    object C1 is a Checkbox
        set location to 10 90
        Set Label to "Checkbox"
    end_object

    Procedure Shadow_CkBox integer st
        Set enabled_state of (C1(self)) to (not (St))
    End_procedure

end_object

Syntax

use windows

object object_name is a RadioContainer
    Set enabled_state to true|false
    Set Status_Help to text

    Procedure Notify_Select_State integer toItem integer fromItem
        : //for augmentation
    End_function

    object object_name is a Radio
        Set Location to Row Column
        Set Label to text
    End_Object
    :
    object object_name is a Radio
        Set Location to Row Column
        Set Label to text
    End_Object

End_Object

Of Special Note

This class is a subclass of the RadioGroup class and inherits all of its attributes. Since this is a non-visual grouping class, all visual properties (size, location, label, etc.) are effectively canceled. Because the object is non-visual, the child radio objects will be located relative to this objects parent container.

This class is used when the program needs to appear to mix radio and non-radio objects within the same group. This is not permitted with radio-group objects, which may only contain radio objects. This can be simulated by placing the RadioContainer and the other non-radio objects within a non-radio container like a Group. The above example demonstrates this technique.

Last Edited: December 2, 2005


Properties for RadioContainer

View property list in alphabetical order

Name | Description
Inherited Properties from RadioGroup
Changed_State | Gets or sets the changed_state for the entire radio group
Current_Radio | Makes Item item_num the "selected" radio object
Current_Radio_Object | Similar to Current_Radio except that it operates with object IDs instead of item IDs
Radio_Count | Returns the number of radio objects within this object
Radio_Value | Gets and sets the label of a child radio object
Inherited Properties from Group
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for RadioContainer

View event list in alphabetical order

Name | Description
Inherited Events from RadioGroup
Notify_Select_State | Sent to notify the group that the current radio item has changed
OnRadioGroupEntering |
OnRadioGroupExiting |
Inherited Events from Group
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for RadioContainer

View method list in alphabetical order

Name | Type | Description
Inherited Methods from RadioGroup
Radio_Object | Function | Returns the handle of a radio object for a passed radio item
Radio_Object_Item | Function | Returns the index (Item number) for a passed a radio object handle
Inherited Methods from Group
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: RadioGroup

Properties Events Methods Index of Classes

Groups multiple Radio objects in a visible group object, providing selection of no more than one at a time, and navigation among the objects

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseGroup
---------------------Group
------------------------RadioGroup
---------------------------dbRadioGroupDS
---------------------------RadioContainer

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: DfRadio_Group_Mixin

Description

RadioGroup is used to group multiple Radio objects in a visible group object, providing selection of no more than one at a time, and navigation among the objects by the use of arrow keys and into and out of the object by the use of Tab and Shift+Tab, as well by the mouse. Only objects of the radio class should be placed inside of RadioGroup objects.

The dbRadioGroup class is a data-aware class similar to the RadioGroup class.

Sample

Object oOutputRadio is a RadioGroup
    Set Label to "Output Order"
    Set Size to 57 121
    Set Location to 10 8
    Set Status_Help to "Choose order to print report"

    Object R1 is a Radio
        Set Label to "Order Number"
        Set Location to 10 10
    End_Object    // R1

    Object R2 is a Radio
        Set Label to "Customer ID Order"
        Set Location to 25 10
    End_Object    // R2

    Object R3 is a Radio
        Set Label to "Customer Name Order"
        Set Location to 40 10
    End_Object    // R3

End_Object    // oOutputRadio

Function OutputOrder returns Integer
    integer iOrder
    Get Current_Radio of oOutputRadio to iOrder
    Function_Return iOrder // 0 - order id, 1 - cust id, 2 - cust name
End_Function

Syntax

Use windows.pkg

Object oObjectName is a RadioGroup
    Set Location to vertical horizontal
    Set Size to height width
    Set Label to text
    Set Enabled_State to true|false
    Set Status_Help to text

    Procedure Notify_Select_State integer toItem integer fromItem
        : //for augmentation
    End_procedure

    Object oObjectName is a Radio
        Set Location to Row Column
        Set Label to text
    End_Object
    :
    Object oObjectName is a Radio
        Set Location to Row Column
        Set Label to text
    End_Object

End_Object

Of Special Note

Objects of this class cannot be used without one or more child objects of Class Radio. Class RadioContainer has the same functionality as this class, but is not visible. Objects of this class are not data-aware and do not automatically connect to the database. The classes dbRadioGroup and dbRadioContainer provide this functionality.

The Radio Item and Radio Objects

A radio group will contain a number of radio child objects. When a radio object is created, it automatically registers itself with its parent. The radio object is then assigned an item number. The radio-grouping object supports an item-style interface. Usually this is the simplest way to program radio objects. In addition, methods are provided to convert radio item numbers to object IDs and vice-versa. This means that child radio objects may be addressed by either their object ID (number or name) or by the assigned radio item number.

The Current Radio

Only one radio button within a group may be selected at any one time. The message get current_radio may be used to find that current radio. It returns the item number. The message set current_radio is used to set the current radio item. Users may also select a radio through the keyboard or the mouse. When a new radio item is selected, the notification message notify_select_state is sent passing the new and old radio item numbers. This message is intended for augmentation.

Shadowing

Shadowing refers to the process of making an object or an item unavailable for data entry. Usually the appearance of a shadowed object is changed in some way to indicate its unavailability. This class supports object shadowing. Accordingly, objects of this class will be shadowed whenever an ancestor object is shadowed. The enabled_state property is supported, as well as the entire public interface for shadowing. When an object of this class is shadowed all child radio objects will also be affected. In addition, the radio_shadow_state message supports the shadowing of individual radio items within the group.

Last Edited: December 2, 2005


Properties for RadioGroup

View property list in alphabetical order

Name | Description
Changed_State | Gets or sets the changed_state for the entire radio group
Current_Radio | Makes Item item_num the "selected" radio object
Current_Radio_Object | Similar to Current_Radio except that it operates with object IDs instead of item IDs
Radio_Count | Returns the number of radio objects within this object
Radio_Value | Gets and sets the label of a child radio object
Inherited Properties from Group
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for RadioGroup

View event list in alphabetical order

Name | Description
Notify_Select_State | Sent to notify the group that the current radio item has changed
OnRadioGroupEntering |
OnRadioGroupExiting |
Inherited Events from Group
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for RadioGroup

View method list in alphabetical order

Name | Type | Description
Radio_Object | Function | Returns the handle of a radio object for a passed radio item
Radio_Object_Item | Function | Returns the index (Item number) for a passed a radio object handle
Inherited Methods from Group
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Report

Class: Report (Abstract)

Properties Events Methods Index of Classes

Abstract class that supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---Report
------Report_DS

Library: Windows Application Class Library

Package: Report.pkg

Description

The Report class supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it. Its sub-classes BasicReport and WinReport should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for Report

View property list in alphabetical order

Name | Description
Assigned_Channel |
Cancelled_State | Setting this true will cancel a report
Child_Rpt_State | Set true if the current Report object is nested
Current_Rec | (Obsolete) Contains the record number of the current valid record found
Find_Down_state | Determines if an index should be traversed in forward or reverse order
Find_Mode | Maintains the current finding mode
Footer_Lines | Contains the number of lines in the page_bottom image plus the page_footer image plus the page_total image
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function
Has_Children_Rpt_State | Is set true if other reports are nested inside this report object
Last_Rec | (Obsolete) Contains the record number of the last selected record found
Main_File | Contains the filenumber of the file which the report will use for finding records
Main_Report_Id | Contains the object ID of the outer report
New_Page_State | Set true when a new page is needed
No_Constrained_Find_State | Determines if constrained record finding should be disabled
No_Finding_State | Determines how the Report object will find records
No_PageCheck_State | Set true when the Report object is processing a new page
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found
Num_Breaks | Returns the number of breaks in a report
Ordering | Contains the index number which will be used for finding records
Page_Count | Keeps track of the current page number
Page_End | Determines how many lines on a page are allowed before a page break will occur
Page_End_State | If this property is set true below the forward send statement in the starting_main_report procedure, then the next page_check will cause an end-of-page/new-page sequence
Page_Feed | Used by the formfeed procedure
Page_Footer_Lines | The number of lines in the page_footer image
priCurrentRec | Contains the RowId of the current valid record found
priFoundRec | Contains the RowId of the record found by the find_rec function
priLastRec | Contains the RowId of the last selected record found
Rec_Count | Contains the number of records found for the current report
Refind_for_SubTotal_State | Ensures that the subtotal is processed with the last valid record for that break level
Report_Channel | Determines which output channel will be used for your report output
Report_Footer_Lines | The number of lines in the report_footer image
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing
Sub_Totaling_State | Set true when the Report object is processing subtotals or totals
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Report

View event list in alphabetical order

Name | Description
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property
Body | Called once for every record selected for the report to provide processing for record data (if any) not used for subheaders and subtotals
Ending_Main_Report | Sent by the report object only if the current report is the outer report (it has no parent-its child_rpt_state is false)
Ending_Report | This handler is called at the end of every report
Final_Formfeed |
OnConstrain |
Page_Bottom | The last thing printed on every page
Page_Footer | Printed after page_total on every page except the last page
Page_Header | Called after page_top on every new page except the first
Page_Title | Called on every new page after report_header or page_header
Page_Top | Called first at the top of each new page
Page_Total | Called on every new page and is printed as the first part of a page break at the bottom of each page
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found
Report_Footer | Printed after page_total on the last page of the report
Report_Header | Called only on the first page of the report, after page_top
Selection | Validates a record
Starting_Main_Report | Can be used to set flags in WinPrint reports
Starting_Report | Called at the start of every report
SubHeader_Init1..n | Called for every break level (n) for which you define a SubHeader_init1..n procedure section in your program
SubHeader1..n | Called for every break level (n) for which you define a subHeader procedure section in your program
SubTotal1..n | Called for every break level (n) for which you define a subTotal procedure section in your program
Total | Called once at the end of a report after the final subtotals are output
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Report

View method list in alphabetical order

Name | Type | Description
Formfeed | Procedure | Handles formfeeds
Output_ImageNum | Procedure | Outputs the image represented by ImageNum
Run_Report | Procedure | Sends a message to the report object telling it to start the report with internal finding
Start_Report | Function | Augmented to check the server property and if the property is non-zero (and a DSO exists), to establish a client-server link between the report object and the DSO
WriteLn | Procedure | Outputs the string message to the current output channel
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Report_DS

Class: Report_DS (Abstract)

Properties Events Methods Index of Classes

Abstract class that supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---Report
------Report_DS
---------BasicReport

Library: Windows Application Class Library

Package: Reportds.pkg

Description

The Report_DS class supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it. Its sub-classes BasicReport and WinReport should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for Report_DS

View property list in alphabetical order

Name | Description
Server | Contains the object ID of this object's server
Inherited Properties from Report
Assigned_Channel |
Cancelled_State | Setting this true will cancel a report
Child_Rpt_State | Set true if the current Report object is nested
Current_Rec | (Obsolete) Contains the record number of the current valid record found
Find_Down_state | Determines if an index should be traversed in forward or reverse order
Find_Mode | Maintains the current finding mode
Footer_Lines | Contains the number of lines in the page_bottom image plus the page_footer image plus the page_total image
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function
Has_Children_Rpt_State | Is set true if other reports are nested inside this report object
Last_Rec | (Obsolete) Contains the record number of the last selected record found
Main_File | Contains the filenumber of the file which the report will use for finding records
Main_Report_Id | Contains the object ID of the outer report
New_Page_State | Set true when a new page is needed
No_Constrained_Find_State | Determines if constrained record finding should be disabled
No_Finding_State | Determines how the Report object will find records
No_PageCheck_State | Set true when the Report object is processing a new page
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found
Num_Breaks | Returns the number of breaks in a report
Ordering | Contains the index number which will be used for finding records
Page_Count | Keeps track of the current page number
Page_End | Determines how many lines on a page are allowed before a page break will occur
Page_End_State | If this property is set true below the forward send statement in the starting_main_report procedure, then the next page_check will cause an end-of-page/new-page sequence
Page_Feed | Used by the formfeed procedure
Page_Footer_Lines | The number of lines in the page_footer image
priCurrentRec | Contains the RowId of the current valid record found
priFoundRec | Contains the RowId of the record found by the find_rec function
priLastRec | Contains the RowId of the last selected record found
Rec_Count | Contains the number of records found for the current report
Refind_for_SubTotal_State | Ensures that the subtotal is processed with the last valid record for that break level
Report_Channel | Determines which output channel will be used for your report output
Report_Footer_Lines | The number of lines in the report_footer image
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing
Sub_Totaling_State | Set true when the Report object is processing subtotals or totals
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Report_DS

View event list in alphabetical order

Name | Description
Inherited Events from Report
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property
Body | Called once for every record selected for the report to provide processing for record data (if any) not used for subheaders and subtotals
Ending_Main_Report | Sent by the report object only if the current report is the outer report (it has no parent-its child_rpt_state is false)
Ending_Report | This handler is called at the end of every report
Final_Formfeed |
OnConstrain |
Page_Bottom | The last thing printed on every page
Page_Footer | Printed after page_total on every page except the last page
Page_Header | Called after page_top on every new page except the first
Page_Title | Called on every new page after report_header or page_header
Page_Top | Called first at the top of each new page
Page_Total | Called on every new page and is printed as the first part of a page break at the bottom of each page
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found
Report_Footer | Printed after page_total on the last page of the report
Report_Header | Called only on the first page of the report, after page_top
Selection | Validates a record
Starting_Main_Report | Can be used to set flags in WinPrint reports
Starting_Report | Called at the start of every report
SubHeader_Init1..n | Called for every break level (n) for which you define a SubHeader_init1..n procedure section in your program
SubHeader1..n | Called for every break level (n) for which you define a subHeader procedure section in your program
SubTotal1..n | Called for every break level (n) for which you define a subTotal procedure section in your program
Total | Called once at the end of a report after the final subtotals are output
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Report_DS

View method list in alphabetical order

Name | Type | Description
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO
Request_Save | Procedure | If sent, this saves the current record
Inherited Methods from Report
Formfeed | Procedure | Handles formfeeds
Output_ImageNum | Procedure | Outputs the image represented by ImageNum
Run_Report | Procedure | Sends a message to the report object telling it to start the report with internal finding
Start_Report | Function | Augmented to check the server property and if the property is non-zero (and a DSO exists), to establish a client-server link between the report object and the DSO
WriteLn | Procedure | Outputs the string message to the current output channel
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ReportPanel

Properties Events Methods Index of Classes

Provides a modal popup user interface for running reports

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------ModalPanel
---------------------------------ReportPanel

Library: Windows Application Class Library

Package: Dfrptvw.pkg

Mixins: ReportView_Mixin

Description

ReportPanel is used to provide a modal popup user interface for running reports.

Usage

Object MyReport is a ReportPanel
    :
    //visual objects
    :
    //reporting object(s)
End_Object

This would get added to a program in the following fashion.

// Some entry View
Use MyReport.pkg
:
Object MyView is a DbView
    :
    Object ReportBtn is a Button
        Set Label to "Print Order."
        set location to y x
        Procedure OnClick
            Send Popup to (MyReport(self))
        End_Procedure
    End_Object
    :
End_Object

Of Special Note

This class provides modal popup report panels. This type of report is not selected from a menu. They are usually selected from within a data-entry view. For example, an order view may contain a button which can be pressed for printing the current order. The only differences between report views and report panels are the way they are selected and their modality. Once selected, the functionality and usage is the same.

Last Edited: July 28, 2003


Properties for ReportPanel

View property list in alphabetical order

Name | Description
Main_DD |
Output_Device_Mode | Directs the output of reports from WinReport and CrystalReport objects
Output_Device_Name | Directs the output of reports from BasicReport objects
Server |
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ReportPanel

View event list in alphabetical order

Name | Description
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ReportPanel

View method list in alphabetical order

Name | Type | Description
Request_Cancel | Procedure | Sends deactivate
Run_Report | Procedure | Runs the report inside the reportpanel
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Close_Panel | Procedure |
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ReportView

Properties Events Methods Index of Classes

Provides a non-modal user interface selected from a menu choice for running reports

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------MdiDialog
---------------------------AppDialog
------------------------------View
---------------------------------ReportView

Library: Windows Application Class Library

Package: Dfrptvw.pkg

Mixins: ReportView_Mixin

Description

ReportView is used to provide a non-modal user interface selected from a menu choice for running reports.

Usage

// MyReport.vw
// Use whatever packages are needed

Activate_View Activate_MyReport for  MyReport

Object MyReport is a ReportView
    :
    visual objects
    :
    reporting object(s)
End_Object

This would get added to a program in the following fashion:

Object Main is a Panel
    :
    DFCreate_Menu Main_Menu
        :
        DFCreate_Menu "&Reports" Reports_PullDown is a ViewPopupMenu
            On_Item "&My Report Sample"  send Activate_MyReport
            Set Status_Help to "A sample report view"
            :
        End_Pull_down
        Set Status_Help to "Select available Reports."
        :
    End_Menu
    :
    Object Main_Client is a ClientArea
        :
        Use MyReport.rvw
        :
    End_Object

End_Object

As you can see, this is identical to adding a regular data-entry view. You may also create deferred report views (deferred_view and cd_end_object) in the exact same manner that entry views are deferred.

Of Special Note

A report view is similar to a data-entry view except that it is used to print a report or execute a batch process. It is selected from a popup menu (most likely a Report menu) and is accessed the same way a data-entry view is accessed. The view dialog is modeless until the actual reporting process starts. A report view will be contained in its own source code (with the standard .vw view-filename extension). These might contain any combination of report types (Basicreport, Winreport, CrystalReport). While possible, this type of mixing would be unusual.

Last Edited: July 28, 2003


Properties for ReportView

View property list in alphabetical order

Name | Description
Main_DD |
Output_Device_Mode | Directs the output of reports from WinReport and CrystalReport objects
Output_Device_Name | Directs the output of reports from BasicReport objects
Server |
Inherited Properties from MdiDialog
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ReportView

View event list in alphabetical order

Name | Description
Inherited Events from AppDialog
Notify_Exit_Application | Called when an application is about to be closed
Verify_Exit_Application | Sent by the client area to verify that an application may be exited
Inherited Events from MdiDialog
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ReportView

View method list in alphabetical order

Name | Type | Description
Request_Cancel | Procedure | Sends deactivate
Run_Report | Procedure | Runs the report inside the reportpanel
Inherited Methods from AppDialog
Activate_View | Procedure | Activates the view
Inherited Methods from MdiDialog
Close_Panel | Procedure |
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: SaveAsDialog

Properties Events Methods Index of Classes

Provides access to the Windows file-save dialog

Hierarchy

cObject
---AbstractFileDialog
------SaveAsDialog

Library: Windows Application Class Library

Package: File_dlg.pkg

Description

SaveAsDialog is used to provide access to the Windows file-save dialog. Objects of this class enable users to enter file names.

Sample

Use dfAllEnt.pkg
Use File_Dlg.pkg

Object oPanel is A Panel
    Set Size     To 50 175
    Set Location To 25 12
    Set Label    To 'SaveAs Dialog Example'

    Object oSaveFile is a SaveAsDialog
        Set Filter_String To ;
            'Source|*.src|Include Files|*.inc|Packages|;
            *.pkg|All Source|*.src;*.pkg;*.inc'

        Set Initial_Folder To 'C:\Program Files\Visual DataFlex 10\pkg'
        Set Dialog_Caption To 'Please Give the Package a Name...'
        Set File_Title To 'MyPackage'
    End_Object

    Object oSave_bn IS A Button
        Set Location To 10 10
        Set Label To 'Save As...'

        Procedure OnClick
            Boolean bSave
            String sFileTitle sFileName

            Get Show_Dialog of (oSaveFile(Self)) To bSave

            If (bSave) Begin
                Get File_Title of (oSaveFile(Self)) To sFileTitle
                Get File_Name  of (oSaveFile(Self)) To sFileName
                Send Info_Box ;
                    ("File Title=" +sFileTitle +"\nFile Name=" +sFileName)
            End
            Else ;
                Send Info_Box "You choose NOT to save"
        End_Procedure
    End_Object
End_Object

Start_UI

Syntax

Use File_Dlg.pkg

Object oObjectName is a SaveAsDialog
    Set Filter_String To filter-string
    Set Initial_Folder To folder-name
    Set Dialog_Caption To text
    Set File_Title To default file-name
End_Object

See Also

Info_Box

Last Edited: November 23, 2004


Properties for SaveAsDialog

View property list in alphabetical order

Name | Description
Inherited Properties from AbstractFileDialog
AllowReadOnly_State | Determines whether users without write access can select files that are read-only or in a read-only folder
CreatePrompt_State | Determines if a message box will ask users whether they want to create the entered filename, when such filename is not found
Dialog_Caption | Sets this object's caption
File_Name | Holds the full pathname of the file and can be considered a read-only property
File_Title | Holds the title of the file (i.e., without path)
FileMustExist_State | Specifies whether users can enter a file title that doesn't exist
Filter_Index | Determines which filter you would like this object's Filter combobox to start with
Filter_String | Holds the descriptions and filters that will be available to users
HideReadOnly_State | Determines whether the checkbox is hidden
Initial_Folder | Determines the starting point for this object
NoChangeDir_State | Restores the current directory to the original directory if the user switched the current directory while searching for files
OverwritePrompt_State | Specifies whether users should be prompted before selecting a file name that already exists
PathMustExist_State | Specifies whether users can enter a file path that doesn't exist
ShowFileTitle_State | Specifies whether the contents of the file_title property should be inserted into the dialog box as a default for selectin
TickReadOnly_State | Checks/un-checks the Read-only checkbox
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for SaveAsDialog

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for SaveAsDialog

View method list in alphabetical order

Name | Type | Description
Inherited Methods from AbstractFileDialog
Show_Dialog | Function | Determines how the dialog box is constructed and behaves
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: Set

Properties Events Methods Index of Classes

Assembles and maintains a set of unique values

Hierarchy

cObject
---Array
------Set
---------Broadcaster

Library: Common (Windows and Web Application) Class Library

Package: set.pkg

Description

To assemble and maintain a set of unique values, with operations to add, remove, and find elements.

For most purposes, developers should use the much more efficient native arrays built into the Visual DataFlex language.

Usage

Use Set.Pkg

Object oUniqueValues is a Set
End_Object // oUniqueValues

or

Use Set.Pkg

Get Create U_Set To hoSet
// Dosomething with the set
Send Destroy Of hoSet

Argument Explanation

Constant | Meaning
Object_name | The name of the object.

Of Special Note

This class treats its elements as a collection of unique, ordered strings. The values placed into a set object may be searched, removed, and added, but not inserted. This class is used by the SelectionList class to maintain selected item identifiers.

This class's properties are unchanged from those of its superclass.

Last Edited: June 16, 2005


Properties for Set

View property list in alphabetical order

Name | Description
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for Set

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for Set

View method list in alphabetical order

Name | Type | Description
Add_Element | Procedure | Adds an element to the set if the element does not already exist
Find_Element | Function | Returns the index of an element in a set or -1 if not found
Remove_Element | Procedure | Removes specified value from the set if present, and compacts remaining values
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ShapeControl

Properties Events Methods Index of Classes

Demonstrates Visual DataFlex communicating with the Windows API

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------AbstractShapeControl
---------------------ShapeControl

Library: Windows Application Class Library

Package: Dfshape.pkg

Description

ShapeControl is used to demonstrate Visual DataFlex communicating with the Windows API. The class is primarily intended for programmers wishing to understand the integration issues involved between DataFlex and the WinAPI. While no knowledge of WinAPI is needed to use this class, it will be required to understand the class's well-documented source code.

Sample

Use dfAllEnt
Use DFShape  // DFShape control
Use DFSlider // TrackBar control

Object oPanel is a Panel
    Set Size         To 95 140
    Set Location     To 25 25
    Set Object_Color To WinColor_BtnText WinColor_BtnFace
    Set Value        To 'ShapeControl Test'

    Object oShape is a ShapeControl
        Set Size             To 35 120
        Set Location         To 10 10
        Set Shape_Fill_Color To clRed
        Set Shape_Style      To shEllipse
    End_Object

    Object oSlider is a TrackBar
        Set Size             To 20 120
        Set Location         To 50 10
        Set Minimum_Position To 1
        Set Maximum_Position To 50

        Procedure OnSliding
            Integer iPos
            Get Current_Position To iPos
            Set Shape_Fill_Color of (oShape(self)) To ;
                (RGB((iPos *5), 0, 0))
        End_Procedure

        Procedure OnFinishedSliding
            Integer iPos
            Get Current_Position To iPos
            Set Shape_Pen_Width of (oShape(self)) To iPos
        End_Procedure

    End_Object

End_Object

Start_UI

Syntax

Use DFShape

Object object_name is a ShapeControl
    Set Shape_Style To style
    Set Shape_Pen_Color To rgb color
    Set Shape_Pen_Width To width
    Set Shape_Pen_Style To windows' pen-style
    Set Shape_Fill_Color To rgb color
    Set Shape_Back_Color To rgb color

    Procedure UserPaint
        :
    End_Procedure

End_Object

Of Special Note

You are not expected to find a useful purpose for this class. Its sole purpose is to provide an example of low-level integration with Windows. To understand the source code (which is heavily commented), you will need a working knowledge of Windows's architecture and the GDI specifically.

Last Edited: August 6, 2004


Properties for ShapeControl

View property list in alphabetical order

Name | Description
Inherited Properties from AbstractShapeControl
Shape_Back_Color | Maintains the RGB color of the object's background that is visible beyond the boundaries of the GDI object
Shape_Fill_Color | Maintains the RGB value of the "brush" to use to fill the object
Shape_Pen_Color | Maintains the RGB color value that the object's pen will use
Shape_Pen_Style | Specifies the style of pen that Windows will use to draw the object
Shape_Pen_Width | Maintains the width of the pen to use
Shape_Style | Determines which GDI object to draw in the container area
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ShapeControl

View event list in alphabetical order

Name | Description
UserPaint | An interface for augmentation to the internal painting of the control
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ShapeControl

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: SpinForm

Properties Events Methods Index of Classes

Adds a spin button to a Form

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------Form
---------------------------SpinForm

Library: Windows Application Class Library

Package: Dfspnfrm.pkg

Mixins: SpinForm_Mixin

Description

SpinForm is used to add a spin button to a Form. Its purpose is to provide a form that users can edit, that displays an integer that can be "spun" through a range. The value can be manually changed by users in the form and the spin buttons will pick up the modified value, and resume spinning from that value.

The dbSpinForm class is a data-aware class similar to the SpinForm class.

Sample

Use DFSpnFrm  // Flex Spin Button
:
Object oSpinForm1 is a SpinForm
    set Location to 10 70
    set Size to 13 40
    set Label to "Spin 0-100:"
    Set Maximum_Position to 100
    Set Minimum_Position to 0
    Set Wrap_State to True
End_Object

Object oSpinForm2 is a SpinForm
    set Location to 25 90
    set Size to 13 70
    Set Value Item 0 to 'Open'
    Set Minimum_Position to 0
    Set Maximum_Position to 2
    Set Wrap_State to True

    Procedure Set Spin_Value integer iItem
        If (iItem = 0) ;
            Set Value to "Open"
        Else if (iItem = 1) ;
           Set Value to "Closed"
        Else if (iItem = 2) ;
            Set Value to "Cancelled"
    End_Procedure

    Function Spin_Value returns integer
        string sVal
        integer iRetVal

        Get Value to sVal
        If (sVal = "Open") ;
             Move 0 to iRetVal
        Else if (sVal = "Closed") ;
            Move 1 to iRetVal
        Else if (sVal = "Cancelled") ;
            Move 2 to iRetVal
        Function_Return iRetVal
    End_Function
End_Object

Syntax

Use DFSpnFrm
:
Object object_name is a SpinForm
    Set Size to height width
    Set Location to row column
    Set Value item 0 to value

    Set Minimum_Position To MinValue
    Set Maximum_Position To MaxValue
    Set Wrap_State to To true|false

    Set Label to text
    Set Label_Justification_Mode to mode
    Set Label_Row_Offset to Num
    Set Label_Col_Offset to Num

    Set Form_DataType 0 to mode
    Set Form_Margin 0 to mode
    Set Form_Mask 0 to maskstring
    Set Numeric_Mask 0 to leftDigits rightDigits {template}
    Set Currency_Mask 0 to leftDigits rightDigits {template}

    Set Enabled_State to true|false
    Set Status_Help to text

    Procedure onChange
        :
    End_Procedure

    Procedure onSetFocus
        :
    End_Procedure

    Procedure onKillFocus
        :
    End_Procedure

End_Object

Of Special Note

You program the component as though it were a Form, but can set additional properties to define the behavior of the spin button. The behavior of the Form is not modified in any way by the addition of the spin button.

The spin button will appear as an integrated part of your form-it appears inside the form and is right-justified.

SpinButtons are capable of a maximum range of 32K, within the range ñ32K. Both numbers and dates are automatically supported with this object. When used as a date, the ñ32K range is relative to today's date. String values may also be supported, but will require the augmentation of the get and set spin_value messages to make this conversion.

Last Edited: November 21, 2004


Properties for SpinForm

View property list in alphabetical order

Name | Description
Current_Position | Contains the current position of the spin button
Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to
Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to
Spin_Value | Called anytime the spin button needs to synchronize its value with the form value
Wrap_State | Determines whether the spin button will wrap
Inherited Properties from Form
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
Prompt_Object | Specifies the default receiving object for the popup message
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for SpinForm

View event list in alphabetical order

Name | Description
Inherited Events from Form
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for SpinForm

View method list in alphabetical order

Name | Type | Description
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
Inherited Methods from Form
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Prompt | Procedure | The default message sent by this object's prompt button
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: SplashScreenPanel

Properties Events Methods Index of Classes

Provides a way to display a splash screen in your application

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------ToolPanel
---------------------------------SplashScreenPanel

Library: Windows Application Class Library

Package: Startup.pkg

Description

The SplashScreenPanel allows you to add a logo splashscreen to your applications and include a startup sound (wave file) if you wish. Note
that the splash screen object should be deactivated before your main panel is activated to avoid focus tree problems.

The Bitmap file is specificied by the Bitmap property

The wave file can be specified by the wavefile property.

Example Usage

// added towards the start of your application
Object oSplashScreen Is A SplashScreenPanel
    Set Bitmap To 'MYLOGO.BMP'
    Set WaveFile To 'tada.wav'
End_Object
Send Activate of  oSplashScreen
:
: ... additional program initialization
:
Send Deactivate of oSplashScreen   // Remove splash screen

See Also

Bitmap | WaveFile

Last Edited: August 8, 2003


Properties for SplashScreenPanel

View property list in alphabetical order

Name | Description
WaveFile |
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for SplashScreenPanel

View event list in alphabetical order

Name | Description
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for SplashScreenPanel

View method list in alphabetical order

Name | Type | Description
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Close_Panel | Procedure |
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: StatusAsciiLog

Properties Events Methods Index of Classes

Used for logging status and error reports from unattended (batch) processes to an ascii file

Hierarchy

cObject
---StatusAsciiLog

Library: Common (Windows and Web Application) Class Library

Package: statALog.pkg

Description

StatusAsciiLog is used for logging status and error reports from unattended (batch) processes to an ascii file. This is a prototype status logging class that can be used for adding status log entries. It uses an ascii file to write the log values. For this reason this is not a multi-user solution. This package is handy if you want to test your programs without using a database file.

Use StatALog.Pkg // StatusdbLog class
:
Object Status_Log is a StatusAsciiLog
End_Object

Batch Process objects such as BusinessProcess and BasicReport contain an interface that uses this object. The batch process is connected to the status log object bet setting the Status_log_id property in the batch object

object name is a {businessProcess| basicReport}
    Set Status_log_id to Status_Log

If no properties are set this will write the log information out to a file named ".\DFLog.txt".

This class is provided as an example of a simple example of status logging. You are encouraged to create you own sub-classes or replacements for this class. Batch process objects that use objects based on this class must use the standard interface created to use this class. The two public messages that must be supported are Log_Status and Log_Clear.

Status Logging in Processes

Status logging refers to a defined interface for sending information to a status-logging object. Various properties and methods are created within a BusinessProcess class (BPOs) to support easy status logging. The program must set the property Status_log_Id to the object ID of the status-log object. It can then set the property Status_log_State to true. When true, a log entry is sent when a BPO process is started, a BPO process is ended, and when an error occurs. Additional status lines can be sent by sending the message log_status passing the text to be logged.

The actual interface to the status-log object consists of two public messages: Log_Status and Log_Clear. It is the status-log object's responsibility to do something useful with these messages. The prototype log object provided with Visual DataFlex (found in StatLog.pkg, StatALog.pkg and StatFLog.pkg) writes a log entry consisting of date, time, and comment to a simple data file. It is expected that you may wish to expand upon this logging process by extending the data file (e.g., adding a user name), its indexes, by moving the log file to another file-list entry, or by expanding the interface (e.g., add ability to review the log, sort by user name). The log object was purposely kept simple. The database status logging class StatusdbLog, does however provide basic multi-user logging.

See Also

StatusDbLog | BusinessProcess | BasicReport | cReport

Last Edited: September 10, 2003


Properties for StatusAsciiLog

View property list in alphabetical order

Name | Description
Close_Always_State | Determines if the ascii File should be closed between each log
Log_Channel | Determines the Channel number used for the ascii file
Log_Name | Determines the file name of the ascii log file
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for StatusAsciiLog

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for StatusAsciiLog

View method list in alphabetical order

Name | Type | Description
Close_Log | Procedure | Closes the status log ascii file
Log_Clear | Procedure | Clears (empties) the Status log ascii file
Log_Status | Procedure | Creates a new log entry in the status-log file
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: StatusdbLog

Properties Events Methods Index of Classes

Used for logging status and error reports from unattended (batch) processes to a database file

Hierarchy

cObject
---StatusdbLog

Library: Common (Windows and Web Application) Class Library

Package: StatFLog.pkg

Description

StatusdbLog is used to create an used for logging status and error reports from unattended (batch) processes to a database file. Objects based on this class must have access to a table named StatLog.

Use StatFLog.Pkg // StatusdbLog class
:
Object Status_Log is a StatusdbLog    // this needs table StatLog
End_Object

Batch Process objects such as BusinessProcess and BasicReport contain an interface that uses this object. The batch process is connected to the status log object bet setting the Status_log_id property in the batch object

object name is a {businessProcess| basicReport}
    Set Status_log_id to Status_Log

Using the StatLog.pkg

Objects of this class can be instantiated by use-ing the STATLOG.PKG file in a program. The resultant global status-log object is named status_log and can be placed in use simply by setting the status_log_id property of the object requiring its services (a business process or report) to the value of that object by name.

Use StatLog.pkg
:
object name is a {BusinessProcess | BasicReport}
    Set Status_log_id to Status_Log

Use of this class for subclassing to create custom status-log capabilities is encouraged. The provided class is quite rudimentary, and is intended to be used as a framework on which you can build your desired functionalities as extensions. Direct instantiation of this class or any subclass of it is not encouraged. The STATLOG.PKG file should be used.

This class is provided as an example of a simple example of status logging. You are encouraged to create you own sub-classes or replacements for this class. Batch process objects that use objects based on this class must use the standard interface created to use this class. The two public messages that must be supported are Log_Status and Log_Clear.

Status Logging in Processes

Status logging refers to a defined interface for sending information to a status-logging object. Various properties and methods are created within a BusinessProcess class (BPOs) to support easy status logging. The program must set the property Status_log_Id to the object ID of the status-log object. It can then set the property Status_log_State to true. When true, a log entry is sent when a BPO process is started, a BPO process is ended, and when an error occurs. Additional status lines can be sent by sending the message log_status passing the text to be logged.

The actual interface to the status-log object consists of two public messages: Log_Status and Log_Clear. It is the status-log object's responsibility to do something useful with these messages. The prototype log object provided with Visual DataFlex (found in StatLog.pkg, StatALog.pkg and StatFLog.pkg) writes a log entry consisting of date, time, and comment to a simple table. It is expected that you may wish to expand upon this logging process by extending the table (e.g., adding a user name), its indexes, by moving the log file to another filelist entry, or by expanding the interface (e.g., add ability to review the log, sort by user name). The log object was purposely kept simple. The database status logging class StatusdbLog, does however provide basic multi-user logging.

The StatLog Table Definition

Objects of this class output to a database table named STATLOG. Its definition is listed below. Note that this may be added as any entry within your filelist and that this is a minimum specification for this table. You may wish to add additional fields and indexes. You must create this table and its filelist entry before this object can perform its intended function.

-----------------------------------------------------------------------------
  DATE: 12/10/2004      TIME: 12:45                                  PAGE:  1
  FILE DEFINITION FOR FILE: STATLOG (# 52)
-----------------------------------------------------------------------------
  DRIVER NAME               : DATAFLEX
  FILE ROOT NAME            : StatLog
  USER DISPLAY NAME         : Status Log
  DATAFLEX FILE NAME        : STATLOG
-----------------------------------------------------------------------------
  RECORD LENGTH             : 73        ( USED: 68 )
  MAX NUMBER OF RECORDS     : 10000     ( USED: 0 )
  FILE COMPRESSION          : NONE
  RE-USE DELETED SPACE      : YES
  LOCKING TYPE              : FILE
  HEADER INTEGRITY CHECKING : YES
  TRANSACTION TYPE          : CLIENT ATOMIC
  RECORD IDENTITY INDEX     : 0 ( 0 , 0 )
  FILE LOGIN PARAMETER      :
  SYSTEM FILE               : NO
-----------------------------------------------------------------------------

NUM  FIELD NAME       TYPE SIZE  OFFST IX   RELATES TO FILE.FIELD
---  ---------------  ---- ----- ----- --   ---------------------------------
  1  DATE             DAT      6     1
  2  TIME             ASC      5     4
  3  DESCRIPTION      ASC     60     9

See Also

StatusAsciiLog | BusinessProcess | BasicReport | cReport

Last Edited: December 10, 2004


Properties for StatusdbLog

View property list in alphabetical order

Name | Description
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for StatusdbLog

View event list in alphabetical order

Name | Description
OnNewRecord | Called before the actual save but after the status text and date/time stamp have been moved to the database
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for StatusdbLog

View method list in alphabetical order

Name | Type | Description
Log_Clear | Procedure | Removes all records from the STATLOG file
Log_Status | Procedure | Creates a new record in the status-log file
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: StatusPanel

Properties Events Methods Index of Classes

(Obsolete) Supports a visual object to displayed by long-running processes that may be unattended to report errors that arise in the job

Hierarchy

cObject
---StatusPanel

Library: Windows Application Class Library

Package: OldStatusPanel.pkg

Description

Obsolete

This class is obsolete. It has been replaced with the cProcessStatusPanel class.

Status Panel Changes (as of Visual DataFlex 12.0)

The old external sentinel based status-panel has been replaced by a new internal panel. This panel should be faster and should be much easier to customize. In most cases, the new panel should serve as no change required replacement for the old one. The old status panel is still available, it's just been renamed.

The new Status panel is based on the following hierarchy:

cStatusPanel   (abstract class)
    cProcessStatusPanel
        {object} Status_Panel

The Status_Panel object has the same file name (StatPnl.pkg), object name and interface used by the old sentinel based status panel.

StatPnl.pkg

This creates the standard status_panel object that is used as the default status panel in an application.

The standard for the default status panel object has always been that the package name is StatPnl.pkg and the name of the object is Status_Panel. This has not changed. As of 12.0, there are major changes in the way the status panel operates The sentinel based external status panel used in prior revisions has been replaced with a status panel that is part of the application. This should work much better and faster than the old sentinel based solution. While the way this operates has changed, the interface has not and therefore this should work with most applications.

As of 12.0, we have added a global handle that contains the object ID of this status panel. This variable ghoStatusPanel can be used in place of the object name Status_Panel. This provides a cleaner more robust interface.

Compatibility Note:

Status_Panel Object
When used in the standard way, this new object will require no changes. A developer will only need to change their code if they've modified the sentinel program, which was a difficult thing to do.

If for some reason your application will not work using this as a replacement for the old status panel, you've probably done something special with the old status-panel. If you don't want to figure out how to use the new one and you want to continue using the old one you are going to need to add some code to include the old status panel in your application. Add the following to your project (your src).

Use StatPnl.pkg // Make sure you load the new status panel object first. this is not optional!

Use OldStatPnl.pkg // load the old status panel. Status_Panel is now this old object

If you do this, you will lose access to the new status-panel via Status_Panel. However, you can still access the new object via the ghoStatusPanel handle.

StatusPanel Class
If you are using the old StatusPanel class you will need to make a change. As soon as possible you should change your application so it uses the new cProcessStatusPanel class. In the meantime you can continue to use the StatusPanel class and the newer cProcessStatusPanel and Status_Panel object in the same application.

The only change required to add support to for StatusPanel class is to add a "use OldStatusPanel.pkg" to your source:

Use OldStatusPanel.pkg // adds support for obsolete StatusPanel class

This adds support for the StatusPanel class but it does not create a Status_Panel object based on this class. If you need to add the object as well you want to "use OldStatPnl.pkg" as described above, which will include the StatusPanel class and the Status_Panel object.

Note that prior to 12.0, the StatusPanel class and Status_panel object were created in a single package, StatPnl.pkg. In 12.0, they are now in separate files, OldStatusPanel.pkg (StatusPanel class) and OldStatPnl.pkg (Status_Panel object). In addition, the new status panel code maintains the class and object in separate files, cProcessStatusPanel.pkg (cProcessStatusPanel class) and StatPnl.pkg (Status_Panel object).

You can tell if you will need this change by searching your source and seeing if you create any objects based on the StatusPanel class (i.e., search for "is a Status Panel"). If you find any instances of this, you should add OldStatusPanel.pkg to your application.

To summarize:
1. A new Status Panel class, cProcessStatusPanel has been added. This class replaces the StatusPanel class. It is faster, easier to use, and interface compatible. The global Status_panel object, now uses this new class.
2. If you are using the standard global Status_Panel object in a normal fashion, you should not have to make any changes
3. If you are creating any classes or objects based on StatusPanel, you will need to add "Use OldStatPnl.pkg" to your application.
4. If you must use the old Status_panel global object, you will need to add "Use StatPnl.pkg" followed by "Use OldStatPnl.pkg" to your application.

Class Documentation

StatusPanel is used to support a visual object to be displayed by long-running processes that may be unattended (batch processes) to report errors that arise in the job, the proportion to which the job is complete from time to time, and other information of potential interest to users running such jobs. This class supports the display of "host/sentinel" monitoring.

Syntax

Use OldStatPnl.pkg

An object of this class named Status_panel is instantiated automatically by any program that uses its package. The object's behaviors are controlled entirely by messages sent to it.

Usage
:
Procedure theProcess
    Move (Status_Panel(self)) to StatPnl
    Send Initialize_StatusPanel of StatPnl aCaption aTitle aMessage
    Send Start_StatusPanel of StatPnl
    Repeat
        :   //process batch item(s)
        Send Update_StatusPanel of StatPnl aProgressString
        Get Check_StatusPanel of StatPnl to userCancel
        :
    Until (done or userCancel)
    Send Stop_StatusPanel of StatPnl
    :
End_procedure
:

Of Special Note

The status panel is used to create an interruptible progress dialog to be used during modal processes like report and batch processes. The panel is defined by setting the contents of several displayed areas:

Caption bar | The value in the caption bar
Title | A centered title that appears inside the dialog
Message | A longer message that appears below the title
Action | An area below that message that is used to display progress
Button | A Cancel button that appears below the display

The panel is invoked by running a "sentinel" program that passes data back and forth between the modal process and the status panel. Because the panel and the process are separate processes, the monitored process can run at a very fast speed without the delays imposed by maintaining a display.

All the properties of this class are defined and set in the class. They cannot be changed in programs except by sending messages to the object.

Last Edited: June 8, 2006


Properties for StatusPanel

View property list in alphabetical order

Name | Description
Action_Text | Determines the action text - an area below that message that is used to display progress
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button
Button_Text | Determines the button text - a Cancel button that appears below the display
Caption_Text | Determines the caption text - the value in the caption bar
Message_Text | Determines the message text - a longer message that appears below the title
Status_Default_params |
Status_Params |
Title_Text | Determines the title text - a centered title that appears inside the dialog
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for StatusPanel

View event list in alphabetical order

Name | Description
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for StatusPanel

View method list in alphabetical order

Name | Type | Description
Check_StatusPanel | Function | Returns a status value from the status panel
Initialize_StatusPanel | Procedure | Sets the values of the popup-status-panel elements
Start_StatusPanel | Procedure | Starts the status panel process
Stop_StatusPanel | Procedure | Stops the status popup and restores the current program's normal modality
Update_StatusPanel | Procedure | Places a value in the "action window" of an active status panel
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: SystemMenu

Properties Events Methods Index of Classes

Class used to create system menus

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseActionBar
------------------------DfBasePullDown
---------------------------SystemMenu

Library: Windows Application Class Library

Package:

Description

The SystemMenu class provides a programmable interface to the pulldown menu of system options for a container. The system menu is activated by clicking the system-menu icon of a panel, navigating through the menu bar using the left and right arrows, or by pressing the Alt+spacebar key combination.

This class is an abstract class that is automatically created when an object has its sysmenu_icon property set to true (e.g., a BasicPanel object). As a result, this class is not meant for instantiation.

Of Special Note

The default item list of a system menu is as follows:

Item 0--Restore restores a window to its normal size.
Item 1--Move places window in move mode.
Item 2--Size places window in resize mode.
Item 3--Minimize minimizes (iconizes) the window.
Item 4--Maximize maximizes (zooms) the window.
Item 5--(separator)
Item 6--Close closes a window.
Item 7--(separator)
Item 8--SwitchApp pops up Windows Task Manager.

The message sent by all these (non-separator) items is command. The aux_value of all these (non-separator) items is the DFSYSCMD value that corresponds to the service (see the command message in this class).

This command message is used to send Windows control messages in response to system-menu commands. The valid values for the first parameter are:

DFSYSCMD_RESTORE
DFSYSCMD_MOVE
DFSYSCMD_SIZE
DFSYSCMD_MINIMIZE
DFSYSCMD_MAXIMIZE
DFSYSCMD_CLOSE
DFSYSCMD_SWITCHAPP

As with other pulldown menus, these items can be added to the system menu or deleted from the system menu. This allows you absolute control over the system menu.

This class's properties are unchanged from those of its superclass.

Last Edited: August 8, 2003


Properties for SystemMenu

View property list in alphabetical order

Name | Description
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for SystemMenu

View event list in alphabetical order

Name | Description
Inherited Events from DfBaseActionBar
Initialize_Menu | Sent when the Menubar system is about to be selected
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for SystemMenu

View method list in alphabetical order

Name | Type | Description
Inherited Methods from DfBaseActionBar
Exit_Menu | Procedure |
Redirect_Message | Procedure |
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: TabDialog

Properties Events Methods Index of Classes

Created by creating a TabDialog object and then creating TabPage objects inside it

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBasetabDialog
---------------------------TabDialog_
------------------------------TabDialog
---------------------------------dbTabDialog_

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Tab_Dialog_Mixin

Description

A tab dialog is created by creating a TabDialog object and then creating TabPage objects inside it. Each tab page displays a tab with its name on it within the tab dialog at all times.

The dbTabDialog class is a data-aware class similar to the TabDialog class.

Sample

Object TabDialog1 is A TabDialog
    Set Size to 117 271
    Set Location to 10 15

    Object TabPage1 is a TabPage
        Set Label to "TabPage1"
        :
    End_Object    // TabPage1

    Object TabPage2 is a TabPage
        Set Label to "TabPage2"
        :
    End_Object    // TabPage2

End_Object    // TabDialog1

Syntax

Use windows

Object oObjectName is a TabDialog
    Set Size to height width
    Set Location to row column
    Set Rotate_Mode to RotateMode

    Object oObjectName is a TabPage
        :
    End_Object

    Object oObjectName is a TabPage
        :
    End_Object

End_Object

Of Special Note

The only visual objects that can be placed directly inside a TabDialog are TabPage objects. All other visual objects will be placed inside the TabPage objects.

If there is not room in the tab dialog to fit all of tab-page tabs, the tab dialog will allow the tab-page tabs to be scrolled, or, will create multiple rows of tabs.

Only basic objects (i.e., the non-db... objects such as Form, Edit, Button, Group, etc.) should be placed inside a TabPage. Data-aware objects (dbForm, dbEdit, dbGroup, etc.) must be placed inside a data-aware page, the dbTabPage. Do not place dbTabPage objects inside a TabDialog. Likewise, do not place TabPage objects inside a dbTabDialog.

Shadowing

Setting the enabled_state property to false will disable entry into all tab pages inside the TabDialog object. Individual pages can be disabled by setting the tab page's button_shadow_state to true (the tab cannot be selected and the tab page cannot be displayed) or by setting the page's enabled_state to false (the tab is enabled, the page can be displayed, but it cannot be entered).

Navigation

The rotate_mode property allows you to specify where next navigation should proceed from the last object of a tab page. Modes are supported to allow the focus to leave the TabDialog (RM_None), ring within the tab page (RM_Ring), ring within the tab dialog (RM_Rotate_in_Ring) and to rotate through all tab pages, exiting when the last object of the last page is exited (RM_Rotate).

Last Edited: December 2, 2005


Properties for TabDialog

View property list in alphabetical order

Name | Description
Button_Count | Returns the number of tabs in this object
Current_Tab | Returns the number of the tab in this object that has the focus
Default_Tab | Determines what tab page will be displayed as a default
MultiLine_State | Determines if tabs will wrap across multiple lines
NumberOfRows | Returns the number of rows of tabs that are displayed
pbFlatSeparators | Determines if separators are drawn
pbHotTrack | Determines hot-tracking on the labels of the tab-pages
pbResetPageOnActivate | Determines how a tab dialog should behave when the dialog takes the focus as part of forward keyboard activation
peTabPosition | Determines if positions of the tabs are at the top or the bottom of the tab-dialog
peTabStyle | Determines if tabs are displayed as tabs or buttons
phoImageList | Permits images to be displayed on tab-pages
Pointer_only_State | Determines how tab buttons will respond to the mouse
Rotate_Mode | Governs cursor movement on keyboard navigation when the Next key is pressed in the last object in a tab page
Skip_Button_Mode | Governs the way tab button navigation is done with the keyboard and mouse (when pointer_only_state is True)
Tab_page_Id | Contains the object_ID of the tab_page object associated with each of this object's items
TabWidth_Mode | Makes each tab just wide enough to display its label, all the same width on each line sufficient to fill the width of this object, or all the width of the widest tab in the object
Inherited Properties from TabDialog_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBasetabDialog
Tooltip_State |
Tooltip_Value |
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for TabDialog

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent to the tab-dialog when Beginning_of_panel is sent by a parent
OnDisplay |
OnResize | Fires when the tab-dialog is created and whenever it is resized
Inherited Events from TabDialog_
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for TabDialog

View method list in alphabetical order

Name | Type | Description
Request_Next_Tab | Procedure | Causes the next tab page to be displayed
Request_Previous_Tab | Procedure | Causes the previous tab page to be displayed and take the focus
Request_Switch_To_Tab | Procedure | Displays and activates the requested tab#
Request_Tab_Display | Procedure | Causes the selected tab page to be displayed but does not give the page the focus
Inherited Methods from TabDialog_
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBasetabDialog
Auto_Page | Procedure |
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: TabDialog_

Class: TabDialog_ (Abstract)

Properties Events Methods Index of Classes

Abstract class created by creating a TabDialog object and then creating TabPage objects inside it

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBasetabDialog
---------------------------TabDialog_
------------------------------TabDialog

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Standard_Container_Mixin Standard_Object_Mixin Label_Mixin dfAuto_Locate_Mixin Shadow_Mixin Bitmap_Support_Mixin RGB_Support_Temp_Mixin Help_Mixin

Description

A tab dialog is created by creating a TabDialog object and then creating TabPage objects inside it. Its sub-classes TabDialog, dbTabDialog and dbTabDialogView should be used for sub-classing and instantiation.

Last Edited: July 11, 2006


Properties for TabDialog_

View property list in alphabetical order

Name | Description
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBasetabDialog
Tooltip_State |
Tooltip_Value |
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for TabDialog_

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for TabDialog_

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBasetabDialog
Auto_Page | Procedure |
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: TabPage

Properties Events Methods Index of Classes

Creates a page within a tab-dialog container

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------TabPage

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: Tab_Page_Mixin

Description

TabPage is used to create a page within a tab-dialog container. These objects should always be created directly inside a TabDialog object. A tab page is assigned a label. That label will appear as a tab at the top of the tab dialog. Any number of tab pages may be assigned to a tab dialog. If all tab pages will not fit within the dialog, then a scroll button will appear in the dialog allowing users to select any tab page by scrolling.

The dbTabPage class is a data-aware class similar to the TabPage class.

Sample

Object TabDialog1 is TabDialog
    Set Size to 117 271
    Set Location to 10 15

    Object TabPage1 is a TabPage
        Set Label to "TabPage1"
        Set Status_Help to "Tab Page 1 Status Help"
        Set Tab_ToolTip_Value to "Tab Page 1 tool tip"
        :
    End_Object    // TabPage1

    Object TabPage2 is a TabPage
        Set Label to "Read-Only"
        Set enabled_state to false
        :
    End_Object    // TabPage2

End_Object    // TabDialog1

Syntax

Use windows

Object object_name is a TabDialog
    Set Size to height width
    Set Location to row column
    Set Rotate_mode to RotateMode

    Object object_name is a TabPage
        Set Label to TabButtonLabel
        Set Status_Help to StatusHelpText
        Set Tab_ToolTip_Value to ToolTipText
        Set Button_Shadow_State to true|false
        Set enabled_state to true|false
        :
    End_Object

    Object object_name is a TabPage
        :
    End_Object

End_Object

Of Special Note

TabPage objects should only be placed inside of TabDialog objects. Only basic objects (i.e., the non "db" objects such as Form, Edit, Button, Group, etc.) should be placed inside of a TabPage. Data-aware objects (dbForm, dbEdit, dbGroup, etc.) must be placed inside of data-aware page, the dbTabPage. Do not place dbTabPage objects inside of a TabDialog. Likewise do not place TabPage objects inside of a dbTabDialog.

Auto-Size / Auto-Location

The size and location of a tab page is set automatically and is determined by the size and location of its parent tab-dialog object.

Tab Button Labels

The label displayed by the tab page's tab is set and queried with the label property.

Shadowing

Individual pages can be disabled by setting the tab page's button_shadow_state to true (the tab cannot be selected and the tab page cannot be displayed) or by setting the page's enabled_state to false (the tab is enabled, the page can be displayed but it cannot be entered).

Tool-Tips

Tab Pages support tool-tips. When the mouse is moved over a tab button the tool-tip text for that button is displayed. The text value is stored in the Tab_ToolTip_Value property. The display of a tool-tip is disabled if the text value is blank.

Last Edited: December 2, 2005


Properties for TabPage

View property list in alphabetical order

Name | Description
Button_Shadow_State | Determines if both the page and the button will be shadowed
Label |
pbHighlightTab | Highlights the tab, using the Windows clHighlight color
piImageIndex | The index of the image from the tab-dialog's imagelist
Tab_Button_item | Contains this tab-page's item number
Tab_ToolTip_Value | Sets the text that is displayed as a tool tip for this object's tab in the container tab-dialog object
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for TabPage

View event list in alphabetical order

Name | Description
OnResize | Fires when the tab-page is created and whenever it is resized
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for TabPage

View method list in alphabetical order

Name | Type | Description
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: TextBox

Properties Events Methods Index of Classes

Enables placing static text strings on the display

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseTextbox
---------------------TextBox
------------------------DFTimer

Library: Windows Application Class Library

Package: Windows.pkg

Mixins: RGB_Support_Temp_Mixin Label_Mixin Shadow_Mixin Bitmap_Support_Mixin

Description

Textbox is used to enable placing static text strings on the display. By default, objects of this class are non-focusable objects whose contents are left-justified. These accept no input from users.

Sample

Object oTextBox1 is a TextBox
    Set Location to 15 5
    Set Label to "Text"
End_Object

Object oTextBox2 is a TextBox
    Set Location to 20 30
    Set Label to "Text"
    Set Auto_Size_State to False
    Set Justification_Mode to jMode_center
End_Object

Syntax

Use windows

Object oObjectName is a Textbox
    Set Location to row column
    set Label to text
End_Object

Note

TextBoxes are for display purposes only. The objects will never take the focus.

Auto-Sizing

Text-boxes are sized automatically based on the length of the label text. Auto-sizing can be disabled by setting auto_size_state to false. When using a justification_mode other then jmode_left, you will probably wish to disable auto-sizing.

When using a justification_mode of jmode_center, you have to set auto_size_state to false.

Shadowing

When a TextBox appears within a shadowed container or when the object is explicitly shadowed, the text can either appear shadowed or it can be left unaltered. By default, a textbox is visually shadowed when its parent container is shadowed and is unaltered when the textbox object itself is explicitly shadowed (which is something you would rarely do). This behavior can be modified with the property Label_Shadow_Display_Mode.

When Used as Labels

Although you can use textbox objects to create labels for entry objects, you will usually not need to. Most entry objects (forms, edits, lists, etc.) support a label property that automatically creates its own text label. These labels are sized and located relative their entry object. You will need to create your own textbox objects to present text that is not associated with any one entry object.

Last Edited: December 2, 2005


Properties for TextBox

View property list in alphabetical order

Name | Description
Auto_Size_State | Determines if textbox object will automatically size itself
Bitmap | Displays a bitmap in an object
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Label_Shadow_Display_Mode | Controls under what conditions this object is shadowed
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Inherited Properties from DfBaseTextbox
Justification_Mode | Aligns the text in the control
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for TextBox

View event list in alphabetical order

Name | Description
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for TextBox

View method list in alphabetical order

Name | Type | Description
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ToolPanel

Properties Events Methods Index of Classes

Creates tool panels - panels that are not listed on the Windows task list

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------ToolPanel
---------------------------------SplashScreenPanel

Library: Windows Application Class Library

Package: Windows.pkg

Description

The ToolPanel container class creates panels that are not listed on the Windows task list. It is ideal for creating popup containers that you want to float on the Windows desktop but not appear on the Windows task list. This class can be used to creating non-modal floating panels. If you need to create a popup modal panel you should use its subclass ModalPanel (or the data aware subclass dbModalPanel).

Sample

Object MyPanel is a ToolPanel
    Set Size to 100 150
    Set Label to "My Tool Panel"
    :
End_Object

Syntax

Use windows

Object object_name is a ToolPanel
    set size to height width
    set locate_mode to LocateMode
    set label to title
    :
End_Object

Of Special Note

ToolPanel objects usually used to create floating popup "tool" or helper panels. They are almost always non-modal. If a modal popup object is required you would base the object on the ModalPanel class. ToolPanels are usually closed by sending the close_panel message.

Caption Bar Label

The text that will appear in a panel's caption bar is set with the Label property. Note that this label will not appear in the windows task list. This is the primary difference between a ToolPanel and a BasicPanel.

Resizing a Panel

When an object of this class is resized by users, this object sends the onResize message to itself. This message is supplied with no definition as a "hook" procedure to use when some action, such as resizing child list objects, is desired on resizing of this object.

Locating a Panel

The location of a panel is determined by the properties location and locate_mode. The defaut "smart" locate_mode will be cause the panel to be centered or appear relative to the object that invoked it. This can be changed by changing the locate_mode property or by explicitly setting a location.

Tool-bars, Status-bars, client-area Ids

It is not expected that ToolPanel objects will contain tool-bars, status-bars or a client-area.

Exiting the Application

ToolPanel obejcts do normally not participate in the exit-application verification or notification process.

Last Edited: December 2, 2005


Properties for ToolPanel

View property list in alphabetical order

Name | Description
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ToolPanel

View event list in alphabetical order

Name | Description
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ToolPanel

View method list in alphabetical order

Name | Type | Description
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Close_Panel | Procedure |
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: TrackBar

Properties Events Methods Index of Classes

Enables applications to provide users with a visual control to 'slide' through a range of values

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------Form
---------------------------FormExternalControl
------------------------------TrackBar

Library: Windows Application Class Library

Package: Trckbr.pkg

Mixins: Trackbar_Mixin External_Class_Mixin

Description

TrackBar is used to enable applications to provide users with a visual control to 'slide' through a range of values. The objects have the visual appearance of the type of slider control commonly found on stereo/graphic equalizers. The control can be either horizontal or vertical and can have "tick" marks along either or both sides.

The colors used by TrackBar match those defined by the Windows Setup.

The dbTrackBar class is a data-aware class similar to the TrackBar class.

Sample

Use DFAllEnt.pkg
Use TrckBr.pkg // TrackBar control
Use DFPrgRes.pkg // ProgressBar control

Object oPanel is a Panel
    Set Size To 80 200
    Set Location To 25 25
    Set Object_Color To WinColor_TextFace WinColor_BtnFace
    Set Label To 'TrackBar Test'

    Object oProgress is a ProgressBar
        Set Size     To 20 180
        Set Location To 10 10
    End_Object

    Object oTrackBar is a TrackBar
        Set Size     To 20 180
        Set Location To 40 10

        Procedure OnSetPosition Integer iPosition
            Set Current_Position of oProgress To iPosition
        End_Procedure

    End_Object

End_Object

Start_UI

Syntax

Use TrckBr

Object oObjectName is a TrackBar
    Set Minimum_Position To lowest track value
    Set Maximum_Position To hight track value

    Procedure OnSetPosition
        :
    End_Procedure

End_Object

Of Special Note

All of the methods of this class are events. This means that you are receiving a notification of something that has happened. On most occasions, you will only need to augment OnSetPosition to know that the slider position has changed. If you need greater resolution, OnSliding is sent whenever a user drags the slider, and OnFinishedSliding is sent after an event that caused the slider to move.

Last Edited: November 21, 2004


Properties for TrackBar

View property list in alphabetical order

Name | Description
ControlValue |
Current_Position | Contains the absolute position of the slider
Line_Size | Determines the amount the Current_Position changes whenever users move the slider by use of the arrow keys
Maximum_Position | Maintains the absolute value of the slider when it is slid to its maximum position
Minimum_Position | Maintains the absolute value of the slider when it is slid to its lowest position
Orientation_Mode | Specifies whether the control should be displayed horizontally or vertically
Page_Size | Determines the amount the Current_Position changes whenever users move the slider by use of the PageUp or PageDown keys
pbTooltips | Determines if tooltips should be displayed for this object
Tick_Frequency | Maintains the increment at which to display tick marks
Tick_Orientation | Specifies where the ticks should be placed in relation to the slider
Visible_Tick_State | Specifies whether tick marks are displayed in the control
Inherited Properties from FormExternalControl
Value |
Inherited Properties from Form
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object
Prompt_Object | Specifies the default receiving object for the popup message
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for TrackBar

View event list in alphabetical order

Name | Description
OnFinishedSliding | Sent whenever the slider has stopped moving by either the mouse or keyboard interface
OnGoneToEnd | Sent when a user pressed the End key to take the slider to the end
OnGoneToStart | Sent when a user pressed the Home key to return the slider to the beginning of the track
OnLineDown | Sent when a user presses one of the arrow keys to increment the Current_Position by the value of Line_Size
OnLineUp | Sent when a user presses one of the arrow keys todecrement the Current_Position by the value of Line_Size
OnPageDown | Sent when a user presses the PageDown key to increment the Current_Position by the value of Page_Size
OnPageUp | Sent when a user presses the PageUp key to decrement the Current_Position by the value of Page_Size
OnSetPosition | Sent whenever the value of Current_Position changes
OnSliding | Sent when a user drags the slider with the mouse
Inherited Events from Form
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for TrackBar

View method list in alphabetical order

Name | Type | Description
Inherited Methods from FormExternalControl
ControlValueChanged | Procedure |
RefreshControl | Procedure |
Inherited Methods from Form
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Create_Prompt_Button | Procedure | Creates or removes a prompt button
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Prompt | Procedure | The default message sent by this object's prompt button
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: TreeView

Properties Events Methods Index of Classes

Provides a control that displays a hierarchical list of items, such as the headings in a document, the entries in an index, or the files and directories on a disk

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseListbox
------------------------List
---------------------------AbstractTreeView
------------------------------TreeView

Library: Windows Application Class Library

Package: Dftreevw.pkg

Description

TreeView is used to provide a control that displays a hierarchical list of items, such as the headings in a document, the entries in an index, or the files and directories on a disk. Each item consists of a label and an image, and each item can have a list of subitems associated with it. By clicking an item, users can expand and collapse the associated list of subitems.

Sample

use DfAllEnt.pkg
use DfTreeVw.PKG

Enumeration_List
    Define tiVDF
    Define tiBin
    Define tiLib
    Define tiExamples
    Define tiWines
    Define tiContact
End_Enumeration_List

Object oPanel is a Panel
    Set Size     To 140 240
    Set Location To 20 20
    Set Label    To "TreeView sample"

    Object oTreeView is a TreeView
        Set Size To 100 100
        Set Location To 10 10

        // create an ImageList for the images
        Object oImageList is a cImageList

            Set piMaxImages To 3
            Procedure OnCreate // add the images
                Integer iImage
                Get AddTransparentImage 'Open16.bmp' clFuchsia To iImage
                Get AddTransparentImage 'Select16.bmp' clFuchsia To iImage
                Get AddTransparentImage 'New16.bmp' clFuchsia To iImage
            End_Procedure
        End_Object

        // Now assign the ImageList to the TreeView
        Set ImageListObject To (oImageList(self))

        Procedure OnCreateTree
            Handle hItemRoot hItemChild hItemExamples

            Get AddTreeItem "Visual DataFlex" 0 tiVDF 0 1 To hItemRoot
            Get AddTreeItem    "Bin" hItemRoot tiBin 2 1 To hItemChild
            Get AddTreeItem    "Lib" hItemRoot tiLib 2 1 To hItemChild
            Get AddTreeItem    "Examples" hItemRoot tiExamples 0 1 To hItemExamples
            Get AddTreeItem       "Wines" hItemExamples tiWines 2 1 To hItemChild
            Get AddTreeItem       "Contact" hItemExamples tiContact 2 1 To hItemChild
        End_Procedure

    End_Object

End_Object // oPanel

start_ui

This example creates a cImageList instance that is used to store the images used by this object. This object adds six items during its OnCreateTree event. Each item stores a user-defined value (from the enumerated list of symbols) that can be used to identify each item.

Of Special Note

This class is a wrapper around the Windows Tree View common control.

Its interface is somewhat different from other DataFlex classes. Rather than dealing with an indexed list of items (as you would in, say, the List class), this class identifies each item with a handle. This handle is a unique identifier that Windows supplies. Whenever you address an item, you must refer to it by its handle. In the example above, the returned handle of a parent item is used when creating child items to identify their parent.

Because of the "handle-based" nature of this class, some of properties that would normally be defined as item properties will be treated as handle properties. Instead of passing an item number as the first parameter, a handle is used. Examples of this are ItemData, ItemLabel, and ItemImage.

You add items to the control using the AddTreeItem function and you can also call this function inside the OnCreateTree.

To display bitmap images alongside each item, you need to associate an ImageList object, which you add images into. Each item of this object can have two images: a regular image displayed alongside items and an image that is displayed instead, whenever the item is currently focused (the current item).

Use the OnItemClick event to get a notification when the user clicks an item, or OnItemChanged to know whenever the current item changes.

Important: Note that items in this object are created when the control is paged (activated) and destroyed when the object is unpaged (deactivated). See OnCreateTree for more information on this.

Last Edited: August 12, 2005


Properties for TreeView

View property list in alphabetical order

Name | Description
ChildItem | Returns the handle of the first child item of hItem
CountTreeLevels |
FirstVisibleItem | Returns the handle of the item that is currently displayed at the very top of the control
ItemCount | Returns the total number of items in the control
ItemFullPath | Returns a string representing the "full path" of the item
NextSiblingItem | Returns the item handle for the item that is the next sibling of the hItem-parameter item
NextVisibleItem | Returns the handle of the next visible item in relation to the item passed as a parameter
ParentItem | Returns the handle of the parent of hItem
PreviousSiblingItem | Returns the item handle for the previous sibling of hItem
PreviousVisibleItem | Returns the handle of the previous visible item in relation to the item passed as a parameter
RootItem | Returns the item-handle of the item that is the parent-most item
VisibleItemCount | Returns the number of items that are currently visible in the control
Inherited Properties from AbstractTreeView
CurrentTreeItem | Gets or sets the handle of the item that is currently selected
ExpandedOnceState | Returns a boolean value of true if hItem has been expanded since it was created
ImageListObject | Uses an ImageList control to supply the images that each item displays
ItemChildCount | Getting this property returns whether there are childitems
ItemData | Stores an application-specific value
ItemImage | Gets and sets the index of the regular image in the control's ImageList
ItemLabel | Sets label that is displayed alongside the image
ItemSelectedImage | Gets and sets the index of the selected image in the control's ImageList that you associated with the item
pbCancelEdit | Used in OnBeginLabelEdit and OnEndLabelEdit to cancel the editing of a treeview label
pbFullRowSelect | Enables full-row selection in the treeview
pbHotTracking | automatically highlights an item when the mouse hovers over it
pbShowTooltips | Determines if a tool tip should be displayed when the mouse hovers over a long tip
pbSingleExpand | Determines if item being selected will collapse if it was expanded, or expand if it was collapsed
piBackColor | Controls the color of the background of the treeview
piLineColor | Controls the color of the lines drawn in the treeview
piTextColor | Controls the color of text in the items of the treeview
TreeButtonsState | Determines if button will be displayed
TreeEditLabelsState | Supports in-line editing of the label
TreeIndentWidth | Governs the number of pixels that are used to indent child items from their parent items
TreeLevelDelimeter | Holds the character to use as a delimiter of tree levels
TreeLinesState | Determines if the control draws graphical lines between connecting items
TreeRetainSelState | Determines if item will still visibly indicate that it was the focused item, whenever this object loses the focus
TreeRootLinesState | Specifies whether graphical lines should be drawn to connect "Root Items"
TreeSortedState |
Inherited Properties from List
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | Sets the text for a label or heading for an entry control object
Label_Col_Offset | The horizontal distance from the object to its label
Label_Justification_Mode | The justification mode for the text within this object's label
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property
Label_Row_Offset | The vertical distance from the top edge of the object and its label
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Select_Count |
Select_State |
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Mode | Determines how item-level selections are processed
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for TreeView

View event list in alphabetical order

Name | Description
OnCreateTree | Populates the control with items
Inherited Events from AbstractTreeView
OnBeginDrag | Whenever a user instigates a drag operation, this event is fired
OnBeginLabelEdit | Fired just prior to the user starting in-line editing of the label
OnBeginRDrag | Whenever the user instigates a drag operation, this event is fired
OnDeleteItem | Whenever an item is deleted from the control, this event is fired
OnEndLabelEdit | Fired if the user completes the edit when user performs in-line editing of the label
OnGetDispInfo |
OnItemChanged | Fired whenever the current item has just changed
OnItemChanging | Fired whenever the current item is about to change
OnItemClick | Fired whenever a user clicks an item to make it become the current item
OnItemCollapsed | Fired whenever a parent item has just been collapsed and its children hidden
OnItemCollapsing | Fired whenever a parent item is about to be collapsed
OnItemDblClick | Fired whenever a user double-clicks an item
OnItemEnter | Fired whenever a user presses Enter on an item
OnItemExpanded | Fired whenever a parent item has just been expanded to display its child items
OnItemExpanding | Fired whenever an item is about to be opened
OnItemRClick | Sent when a user clicks on an item
OnItemRDblClick | Sent when a user double-clicks on an item
OnKeyDown |
OnSetDispInfo |
Inherited Events from List
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for TreeView

View method list in alphabetical order

Name | Type | Description
DoCollapseAll | Procedure | Programmatically collapses hItem and all its siblings
DoCollapseItem | Procedure | Programmatically collapses hItem
DoExpandAll | Procedure | Expands the item represented by the hItem parameter and all its children
DoExpandItem | Procedure | Expands hItem
DoMakeItemFirstVisible | Procedure | Forces hItem to be placed at the top of the control
DoMakeItemVisible | Procedure | Forces hItem to become visible
DoReadTree | Procedure | Constructs a simple tree view by loading the values from an external file
ItemExpandedState | Function | Returns a boolean value indicating whether hItem is currently expande
Inherited Methods from AbstractTreeView
AddTreeItem | Function | Adds an entry to the treeview
DoDeleteItem | Procedure | Deletes an item
DoEnumerateTree | Procedure | Recurses the items in the control starting with the item you pass, hItem
DoEnumerateTreeUp | Procedure | Recurses the items in the control starting with the item you pass, hItem
InsertTreeItem | Function |
Inherited Methods from List
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Select_Count | Procedure Set |
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ValidationList

Properties Events Methods Index of Classes

Provides a default interface object for validation tables used as prompt objects

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------DfBasePanel
------------------------DfBasetoolPanel
---------------------------FloatingPanel
------------------------------dbFloatingPanel_
---------------------------------dbFloatingPanel
------------------------------------dbViewFloatingPanel
---------------------------------------dbModalPanel
------------------------------------------ValidationList

Library: Windows Application Class Library

Package: Dfddpklt.pkg

Description

ValidationList is used to provide a default interface object for validation tables used as prompt objects. This is used through field properties in DataDictionary objects.

Usage.

use dfddpklt

Object oObjectName is a ValidationList
End_Object

Argument Explanation

Constant | Meaning
oObjectName | The name of the ValidationList object

Of Special Note

When identified as the prompt object for a field (in a DataDictionary) or an item in a DEO, an object of this class automatically provides a popup list of valid database values, by default from the field (to which the DEO item is attached). The usage shown above is the minimal usage that will provide that and all other default behaviors. Below is the syntax of more-advanced usage:

Object oObjectName is a ValidationList // defaults underlined
    Set Sort_State to {True | False}
    Set Code_Display_mode to {CD_Code_Display_Code |
        CD_Code_Display_Description |
        CD_Code_Display_Both | 1} // 1 = auto assign
    Set Static_State to True| False
    Set Table_Title to title|"" // ""=auto assign
    Set Auto_Size_State to True| False // windows only

    // allows you to create any kind of description you want
    Function Code_Description_Value string description ;
        string sCode returns String
        :
    End_Function

End_Object

Last Edited: February 19, 2004


Properties for ValidationList

View property list in alphabetical order

Name | Description
Auto_Size_State | Determines if object will size itself to accommodate the code_display_mode automatically
Code_Display_Mode | Specifies whether the list will display the choices' codes, descriptions, or both
Sort_State |
Static_State |
Table_Title | The title of the validation list
Inherited Properties from dbModalPanel
button_height | (Obsolete)
button_width | (Obsolete)
List_Object | (Obsolete)
Inherited Properties from dbViewFloatingPanel
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to
Auto_Top_Item_State |
Auto_top_view_State |
DEO_Attach_All_State |
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function
priInitialRowId |
View_Latch_State | Determines if the view's DSO structure will be initialized with the data
Inherited Properties from dbFloatingPanel
DEO_Object |
Inherited Properties from dbFloatingPanel_
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Changed_State | Determines if one or more of the child objects has changed
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
deo_delegate_mode | Controls those requests for which delegate_..._state is set true
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation
Verify_Delete_Msg | Specifies the message to use for delete confirmation
verify_exit_msg | Determines what message is sent during an exiting event
Verify_Save_Msg | Specifies the message to use for save confirmation
Inherited Properties from FloatingPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Client_Id |
Column_Offset | Determines the offset to the invoking item by number of columns
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Statusbar_Id |
Toolbar_Id |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ValidationList

View event list in alphabetical order

Name | Description
Inherited Events from dbViewFloatingPanel
Closing_View |
Opening_View |
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used
Inherited Events from FloatingPanel
OnActivateApp |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnDeactivateApp |
OnKillFocus | Sent whenever the object is about to lose the focus
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ValidationList

View method list in alphabetical order

Name | Type | Description
Code_Description_Value | Function | Enables you to perform any processing on, or even substitution for, the description that displays with or for each code
Inherited Methods from dbModalPanel
Add_Button | Procedure | (Obsolete)
Search | Procedure | (Obsolete)
Inherited Methods from dbViewFloatingPanel
Exit_Application_Check | Function |
Inherited Methods from dbFloatingPanel
Close_Panel | Procedure | Closes the panel or component currently open
Inherited Methods from dbFloatingPanel_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error
Request_Find | Procedure | Finds on specified file using given find_mode and index
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function
Inherited Methods from FloatingPanel
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ValidationTable

Properties Events Methods Index of Classes

Provides a one-column table of validation data for validation lists used with DataDictionary objects.

Hierarchy

cObject
---Array
------ValidationTable
---------DescriptionValidationTable

Library: Common (Windows and Web Application) Class Library

Package: Ddvaltbl.pkg

Description

To provide a one-column table of validation data statically defined within the object itself for validation lists used through the Field_Value_Table field property in DataDictionary objects.

Sample

This sample creates a simple list of Credit Card choices

Use ddValTbl.pkg

Object oCreditCards is a ValidationTable
    Set Table_Title to "Select a Credit Card"
    Procedure Fill_List
        Send Add_Table_Value "American Express"
        Send Add_Table_Value "Diners Club"
        Send Add_Table_Value "Mastercard"
        Send Add_Table_Value "Visa"
    End_Procedure
End_Object

This is a minimal validation object for assignment in DataDictionary objects to database fields with the Field_Value_Table property. It provides only values for insertion into the database. It is the superclass of a hierarchy of more-capable and -complex validation classes, but is usable in its own right in simple, static situations.

If the Validate_State property is set to False, entries are permitted that are not in the list; in its default True state, it requires an entry that matches one of the existing table items. If the Static_State property is set to False, the list will be filled every time the table is activated; in its default True state, the object is loaded with its list only once in each session.

See Also

Using Validation Tables

Last Edited: July 12, 2005


Properties for ValidationTable

View property list in alphabetical order

Name | Description
Allow_Blank_State | Controls whether blank entries are accepted in this object
Main_File | Identifies the data file from which the values are to be drawn to fill this object
Static_State | Determines whether object loads once per session or dynamically.
Table_Title | The title shown in the caption bar of the validation table
Validate_State | Determines whether values are validated against the items contained in the validation table.
Inherited Properties from Array
Item_Count | Returns the number of items in an array object
Value | Sets and Gets an array element's value
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ValidationTable

View event list in alphabetical order

Name | Description
Fill_List | Fills the list of entires in the validation table
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ValidationTable

View method list in alphabetical order

Name | Type | Description
Add_Table_Value | Procedure | Should be sent for each sValue and description you wish to add to your validation table.
Find_Code_Description | Function |
TableData | Function | Returns the validation table's data in a two dimensional variant array
Validate_Value | Function | Determines whether a value is valid or not (is listed in the validation table or not)
Inherited Methods from Array
Delete_Data | Procedure | Deletes all data from the Array object
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: View

Properties Events Methods Index of Classes

Provides a "basic" (non DEO) MDI view

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseContainer
------------------DfBaseDialog
---------------------Container3d
------------------------MdiDialog
---------------------------AppDialog
------------------------------View
---------------------------------cCrystalPreview
---------------------------------dbAppClient_
---------------------------------ReportView

Library: Windows Application Class Library

Package: Dfadlg.pkg

Description

View is used to provide a "basic" (non data entry) MDI view. View may contain basic objects (Container, Group, TabDialog, Form, Grid, Button, etc.) and may never contain data-aware objects (any of the "db" classes). The dbView is used to create DEO views. View objects are MDI (multiple document interface) objects and must be placed inside of a MDI client-area object (ClientArea). View and (dbView) objects are usually saved in their own source files (.vw files) and placed inside of a client-area object with the use command.

The dbView class is a data-aware class similar to the View class.

Sample

// View1.vw
Use dfAllEnt.pkg
:
Activate_View Activate_View1 For oView1

Object oView1 is a View
    Set Label  to "My View1 Label"
    Set Size   to 120 280
    :
End_Object

// View1.vw - deferred view
Use dfAllEnt.pkg
:

Deferred_View Activate_View1 For ;
;
Object oView1 is a View
    Set Label  to "My View1 Label"
    Set Size   to 120 280
    :
CD_End_Object

Syntax

Activate_View Activate_ObjectName for oObjectName

Object oObjectName is a View
    Set Label to text
    Set Size to height length
    :
End_Object

Deferred_View Activate_ObjectName for ;
;
Object oObjectName is a View
    Set Label to text
    Set Size to height length
    :
CD_End_Object

Note

Three levels of programming classes are supported: basic (non-MDI, no support for tool-bars or status-bars), application (App classes - MDI support, basic button-bar and tool-bar support), and high level application.

A proper MDI (Multiple Document Interface) application consists of an MDI Panel object (which contains and supports a menu-bar, a tool bar, a status-bar and a client-area), an MDI client-area object (which contains and support MDI child-dialogs or views) and MDI-Views. The "App" classes (AppPanel, AppClientArea, AppDialog, cToolBar, cStatusBar) provide the needed cooperative support to create an MDI application.

Although complete applications can be written using the "App" classes they are considered to be intermediate level classes. A higher and more powerful level of classes exist and it is expected that most applications will be written using the high level classes (Panel, MenuBar, cToolBar, ClientArea, View, dbView, ReportView). A normal program is structured as follows:

    Panel
        MenuBar
            PopupMenus
            :
        cToolBar
        ClientArea
            :
            Views (View, dbView, ReportView)
            :
        Statusbar

The View is a sub-class of the AppDialog class and is unchanged. Refer to AppDialog for information on this class. The View is non DEO high-level application class.

Activating Views

View are usually activated from the popup menu by sending a custom activate message to the client-area object. The custom message is defined by the command Activate_View or Deferred_View. Views may also be activated by sending the message Activate_view to the object.

Deferred Views

The Deferred_View command is used in conjunction with the CD_end_Object command to defer the creation of the view until it is activated. Deferring views will improve program load time.

Application Exit Behavior

When an application is about the be exited the client-area object will send two messages to each registered view. It send the message get verify_exit_application to each view. If any view returns a non-zero value the application will not be closed.

When the verify_exit_application function is called the default behavior of all View objects is to call the view_changed function. If this function returns a non-zero, a verification message is displayed ("changes exist..") and the user is given the chance to halt the program exit.

If all views allow the application to be closed, the client-area will send the message notify_exit_application to all views. By default this does nothing. It provides a hook to perform any system close down operations. It can not be used to stop the program exit. The program will then be closed.

Last Edited: November 20, 2004


Properties for View

View property list in alphabetical order

Name | Description
Inherited Properties from MdiDialog
Current_Action_Button |
Default_Action_Button | The object handle of the default action button
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated
Inherited Properties from Container3d
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true
Bitmap | Displays a bitmap in an object
Column_Offset | Determines the offset to the invoking item by number of columns
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Label | This is the text that appears within this control
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
Offset_Location |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Row_Offset | Determines the offset to the invoking item by number of rows
Status_Help | Determines the status text that will be displayed when this object takes the focus
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseDialog
Border_Style | Specifies the border style of this object
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button
Mdi_State |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations
View_Mode | Changes the appearance of the DfBaseDialog window
Inherited Properties from DfBaseContainer
GetContainerClientSize |
pbAcceptDropFiles | Determines if the container object supports a file drop event
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontSize | Overrides the default font size of the current font
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Value |
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for View

View event list in alphabetical order

Name | Description
Inherited Events from AppDialog
Notify_Exit_Application | Called when an application is about to be closed
Verify_Exit_Application | Sent by the client area to verify that an application may be exited
Inherited Events from MdiDialog
OnPaint | Sent every time a panel is painted
OnResize | Sent every time a panel is resized
Inherited Events from Container3d
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnKillFocus | Sent whenever the object is about to lose the focus
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseContainer
OnFileDropped | Provides a notification that a file drag and drop operation has occurred
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for View

View method list in alphabetical order

Name | Type | Description
Inherited Methods from AppDialog
Activate_View | Procedure | Activates the view
Inherited Methods from MdiDialog
Close_Panel | Procedure |
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated
Stop_Modal_UI | Procedure | Causes the modal object to deactivate
Inherited Methods from Container3d
Activate_Area | Procedure |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
DoHtmlHelp | Procedure | Launches Compiled HTML Help
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: ViewPopupMenu

Properties Events Methods Index of Classes

Creates popup menu objects that will redirect item messages to the MDI container area object

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseActionBar
------------------------DfBasePullDown
---------------------------PopupMenu
------------------------------ViewPopupMenu

Library: Windows Application Class Library

Package: Dfdeomnu.pkg

Description

ViewPopupMenu creates popup menu objects that will redirect item messages to the MDI container area object. This is used to activate views from a popup menu. View activation messages must be sent to the object that is the parent of the views. That parent object is the container-area object. Since popup menus do not reside in the container-area they must find the container area object (they ask the main panel object for the container area object id) and redirect the message to the container object.

Sample

DFCreate_Menu Main_Menu
    #include File_PM.inc    // file pulldown menu

    DFCreate_Menu "&View" ViewPopupMenu is a ViewPopupMenu
        On_Item "&Customer Entry View\aCtrl+1" Send Activate_Customer
        On_Item "&Sales Person Entry\aCtrl+2" Send Activate_SalesP_Entry
        On_Item "&Vendor Entry\aCtrl+3" Send Activate_Vendor_Entry
        On_Item "&Inventory Entry\aCtrl+4" Send Activate_Invt_Entry
        On_Item "&Order Entry\aCtrl+5" Send Activate_Order_Entry
    End_Pull_down
    Set Status_Help To "Available Views"

    #include Navi_pm.inc    // Naviation pulldown menu
    #include win_PM.inc     // Window of available views
    #include Help_PM.inc    // help pulldown menu
End_Menu

Syntax

Syntax is identical to its PopupMenu superclass.

Of Special Notice

This class is identical to its superclass PopupMenu with one exception. When an explicit destination object is not provided with the menu item, the message is sent to the client area object and not the focus object (the pulldown). This will be used with view and report view popup menus.

Last Edited: July 23, 2003


Properties for ViewPopupMenu

View property list in alphabetical order

Name | Description
Inherited Properties from PopupMenu
Shadow_Status_Help | Specifies the display in the status bar for items of this object that are shadowed
Simple_Status_Help_State |
Status_Help | The status-bar help text for Item item#
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for ViewPopupMenu

View event list in alphabetical order

Name | Description
Inherited Events from PopupMenu
OnChange | Called every time a menu changes
OnInitMenu | Sent when a PopupMenu object is about to be selected
Inherited Events from DfBaseActionBar
Initialize_Menu | Sent when the Menubar system is about to be selected
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for ViewPopupMenu

View method list in alphabetical order

Name | Type | Description
Inherited Methods from PopupMenu
Menu_Status_Help | Function |
Inherited Methods from DfBaseActionBar
Exit_Menu | Procedure |
Redirect_Message | Procedure |
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Down | Procedure | Sends the key kdownarrow message to the object
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Up | Procedure | Sends the key kuparrow to the object
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Help | Procedure | Overridden in the help_system to activate context-sensitive help
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: WideList

Class: WideList (Abstract)

Properties Events Methods Index of Classes

An abstract class defining the common procedures and properties of data-entry classes and dbLists

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList
---------------------------------------DataList_
---------------------------------------PickList_

Library: Windows Application Class Library

Package: Dfwide.pkg

Mixins: DFNavigate_Mixin DFCode_DEO_Mixin

Description

WideList defines the common procedures and properties of data-entry classes and dbLists.

Of Special Note

The WideList class defines the properties, procedures, and functions required by all kinds of data-entry and lists. Its descendent classes include (indirectly) dbList and dbGrid. WideList is not intended for the creation of objects directly (instantiation).

Accelerator Keys

Name | Message Sent | Defining Class
kbegin_of_panel | beginning_of_panel | navigate_mixin
kcancel | request_cancel | navigate_mixin
kdownarrow | down_row | WideList
kend_of_panel | end_of_panel | navigate_mixin
kexit_function | exit_function | navigate_mixin
kprompt | prompt | entry_item_mixin
kswitch | switch | navigate_mixin
kswitch_back | switch_back | navigate_mixin
kswitch_panel | switch_next_group | navigate_mixin
kswitch_panel_back | switch_prior_group | navigate_mixin
kuparrow | up_row | WideList
kzoom | zoom | entry_item_mixin

Last Edited: November 21, 2004


Properties for WideList

View property list in alphabetical order

Name | Description
Inherited Properties from WideList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for WideList

View event list in alphabetical order

Name | Description
Inherited Events from WideList_
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Click | Sent whenever a header has received a mouse click
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
onInitSpin | Augmented to set the minimum and maximum positions for a spinner
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for WideList

View method list in alphabetical order

Name | Type | Description
Close_Panel | Procedure | Closes the panel or component currently open
Default_Prompt | Procedure | (Obsolete)
Prompt_Description | Function | (Obsolete)
Prompt_Description | Procedure | (Obsolete)
Validate_Prompt | Function | (Obsolete)
Inherited Methods from WideList_
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
Up_Row | Procedure | Changes the current item to the prior row, if any, at the same item relative to the beginning of the row
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the current column of the first row
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Data | Procedure | Causes the grid's current item to be set to the current column of the last row
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: WideList_

Class: WideList_ (Abstract)

Properties Events Methods Index of Classes

Abstract class defining the common procedures and properties of data-entry classes and dbLists

This is an abstract class and should never be used by a developer for object instantiation. While a developer could use this class for sub-classing, it is not encouraged.

Hierarchy

cObject
---cUIObject
------DfBaseObject
---------DfBaseWindow
------------DfBaseUIWindow
---------------DfBaseControl
------------------DfBaseList
---------------------DfBaseForm
------------------------DfBaseEntry
---------------------------DfBaseEntryList
------------------------------EntryList
---------------------------------WideList_
------------------------------------WideList

Library: Windows Application Class Library

Package: Dfwide.pkg

Mixins: Wide_List_mixin Nesting_Mixin Navigate_Mixin Server_Mixin Action_Bar_Mixin Entry_Item_Mixin

Description

WideList_ is used to define the common procedures and properties of data-entry classes and dbLists. Its sub-classes dbGrid, dbList, and CodePickList should be used for sub-classing and instantiation.

Last Edited: November 21, 2004


Properties for WideList_

View property list in alphabetical order

Name | Description
Auto_Fill_State | Determines if the object's DDO should perform an auto fill
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy
Deferred_State | Determines if all finds by the object will occur without changing the server's current record
Server | Identifies the object which provides database services to this object
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit
verify_exit_msg | Determines what message is sent during an exiting event
Inherited Properties from EntryList
Current_Col | Returns the number of the column of the list that the cursor currently is located in
Enabled_State | Determines if an object is enabled or disabled
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor
Floating_Menu_Object | Identifies the floating context menu for this object
Help_id | Used to specify an object's context ID
Help_Keyword | Used to specify an object's context keyword
Item_Shadow_State | Determines if an object's item is enabled or disabled
Maximum_Position | Determines the maximum position for a spin button
Minimum_Position | Determines the minimum position for a spin button
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's
peResizeColumn | Determines the method used for resizing columns
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.
Spin_Value |
Status_Help | Sets the text of the help text that appears in the status bar
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty
Inherited Properties from DfBaseEntryList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed.
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form
CurrentCellColor | Sets the background color of the current focus item
CurrentCellTextColor | Sets the text color of the current focus item
CurrentRowColor | Sets the background color of the current row
CurrentRowTextColor | Sets the text color of the current row
GridLine_Mode | Determines how grid lines will be displayed in the grid
Header_Justification_Mode | Determines how text will be justified in list and grid headers
Header_Label | Define text for headers
Header_Visible_State | Determines if the grid header will be visible
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor.
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed
IsColumnVisible | Determine if a particular column is visible
ItemColor | Sets the color of an individual item
ItemTextColor | Sets the text color of an individual item
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor
peDisabledColor | Determines the background color of a disabled cell
peDisabledTextColor | Determines the text color of a disabled cell
peGridLineColor | Determines the color of lines separating grid cells
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider.
Inherited Properties from DfBaseEntry
Autofind_Item |
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with
Bottom_Item | Returns the item number of the last item on the display
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object
Current_Row | Return the row number of the current_item
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object
Item_Entry_Msg | Sent in response to the item_change or the entering message
Item_Exit_Msg | Sent in response to the item_change or the exiting message
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem
Item_Options | Allows you to copy item options or set them in a group
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated
Object_Validation | Controls whether the validate messages have any effect
Prompt_Object | Specifies the default receiving object for the popup message
Row | Returns the row in a grid that a passed item is located in
Row_Count | Returns the number of rows in a dbGrid-class object
Top_Row | Returns the row number of the top row on the display
Valid_Item | Causes the validation of a single item identified by the iItem
Zoom_Object | Sets the destination object_id of the popup message to the specified object
Inherited Properties from DfBaseForm
Form_Button | Allows you to define and place a button within your form
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form
Form_Button_Value | Determines the contents of a form prompt-button
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button
Form_Justification_Mode | Determines how data will be displayed
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field
Form_Mask | Provides the token characters for the mask for item_num
Masked_Value | Returns a Form or grid value with masking character
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed
Inherited Properties from DfBaseList
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus
Aux_Value | Is only used by the system if an object is referenced on the on_item command line
Button_Aspect | A low-level form message that controls the appearance of a form
Changed_State | Set when users change information in the items of the menu
Checkbox_Item_State | Allows any item to become a checkbox-type item
Current_Item | The object that the end user is currently pointing to
Display_Size | Returns the number of windows in the menu
Entry_State | Determines if the items of menu class objects may become data-entry fields
FontSize |
Form_Bitmap | Places a bitmap named sBitmapName into iItem
Form_Border | Sets the border style of a form region
Form_Column | Controls the horizontal placement (column position) of the form display within the object
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics
Form_Extended_Style | Sets the extended-window style of form region
Form_Fontheight | Sets the height of the font in the form display
Form_FontItalics | Determines if the current form's font will be italicized
Form_FontUnderline | Determines if the form's font will be underlined
Form_FontWeight | Sets the Striking weight of form's font
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels
Form_Guiheight | Sets the height of the font in the form display in pixels
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object
Form_Guiwidth | Sets the width of the form item in pixels
Form_Height | Sets the height of the font in the form display in logical units
Form_Option |
Form_Options | Sets or gets all of the form_options for a form region
Form_Row | Controls the vertical placement, in logical units, of the form display within the object
Form_Style | Sets the window style for the form region
Form_Typeface | Sets the form's Typeface
Form_Width | Sets the width of the form item in logical units (usually dialog units)
Form_Window_Handle | Returns the Windows window handle for the form region
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true
Item_Count | A read-only property of menu-class objects
Item_Matching | Searches a menu of items for a matching string value
Line_Size | Returns number of columns of a grid or number windows per line of a menu
Line_Width | Specifies the number of columns and displayable rows in a list
Message | Identifies the message that is sent when users press kenter on the item
Prototype_Object |
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice
Select_Count | Maintains the total number of selected items in the menu
Select_Mode | Determines how item-level selections are processed
Select_State | Each item may be selected by setting the select_state of the item
Shadow_State | Determines if item is enabled (not shadowed)
Top_Item | The item that is first in the display window
Value | Gets and sets the data value for an item
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation
Inherited Properties from DfBaseControl
Border_Style | Specifies the border style of this object
Inherited Properties from DfBaseUIWindow
Mouse_Capture |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages
Inherited Properties from DfBaseWindow
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object
Bitmap | Displays a bitmap in an object
Bitmap_Height | Returns the height of the image contained in the file named by bitmap
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed
Bitmap_Width | Returns the width of the image contained in the file named by bitmap
Client_Size |
Color | Sets the background color of the object
Container_Handle | Returns the Windows window handle of the DataFlex object's container
Extended_Window_Style | Sets the extended window style for the windows object
FontItalics | Determines if current font is to be italicized
FontUnderline | Determines if font will be printed with underscores at the base of the character
FontWeight | Striking weight of font
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object
GuiSize | Determines the size (height and width) of the object expressed in physical pixels
peAnchors | Describes how you want the control to react whenever its container changes size
Physical_FontSize | Specifies the fontsize in pixels
piMaxSize | Determines the limit of the maximum size that a Component can be
piMinSize | Determines the limit of the minimum size that a Component can be
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object
TextColor | Sets the text color of the object
Transparent_State |
Typeface | The typeface of the selected font
Window_Handle | Returns the Windows window handle of the DataFlex object
Window_Style | Sets the window style for the Windows object
Inherited Properties from DfBaseObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control
Inherited Properties from cUIObject
Active_State | Indicates whether or not the object is activated
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)
Block_Mouse_State | Determines whether or not the use of the mouse is restricted
Client_Area_State | Determines if object is a user interface container for children
ContainsFocus | Determines if the container contains the focus
Current_Scope | Returns the object_id of the currently active scoping object
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs
Entry_Msg | Sent whenever the object is about to receive the focus
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number
Error_Text_Available | Determines if Error Text is available for this error number
Exit_Msg | Sent whenever the object is about to lose the focus
Find_Scope | Returns the scoping object of the current object
Focus | Returns the ID of the object that currently has the focus
Focus_Mode | Determines the conditions under which the object will take the focus
Key_Path | Determines the delegation path for on_key key assignments
Last_Child | Returns the object_id of the last focus child of a base_object
Location | Determines the position of the upper left character of the object's window
Module_Name | Assists in the process of locating context-sensitive help information
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level
Next_Scope | Returns the object that is the next_scope object of the current scope
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object
Prior_Level | Returns the object that is the root of this object's level in the focus tree
Prior_Scope | Returns the object that is the prior_scope object of the current scope
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring
RingParent | Returns the object handle of the object that is its ring parent
Scope_Focus | A property of scope objects in the focus tree
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object
Search_Case |
Size | Allows the programmer to affect the size of an object's display window
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement
Visible_State | Determines whether object is visible
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for WideList_

View event list in alphabetical order

Name | Description
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items
Inherited Events from EntryList
Combo_Edit_Changed | Fires when combo item is changed by editing a value
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item
Header_Mouse_Click | Sent whenever a header has received a mouse click
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes
OnCloseUp | Fires when combo form's dropdown list closes
OnDropDown | Fires when combo form's dropdown list drops down
onInitSpin | Augmented to set the minimum and maximum positions for a spinner
OnKillFocus | Sent whenever the object is about to lose the focus
OnMaxText |
OnMouseWheel | An event sent everytime a mouse wheel is clicked
OnSetFocus | Sent whenever windows is about to give this object the focus
Prompt_Callback | Sends a callback event to an object that requested a prompt object
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged
Inherited Events from DfBaseEntryList
Header_Notification | Sent when the header has received a mouse event
Inherited Events from DfBaseEntry
Item_Entry | Sends iMessage to the current object if it is non-zero
Item_Exit | Sends iMessage to the current object if it is non-zero
Refresh | Displays items from some files at the same time as clearing items from other files
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item
Inherited Events from DfBaseList
Item_Change | A programming "hook" to perform an action on change of an item
Key | Augmented to implement the GUI keyboard interface
Inherited Events from DfBaseUIWindow
Command | Sent from external controls
Inherited Events from DfBaseObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse
Form_Button_Notification | A notification of a form button event
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it
Inherited Events from cUIObject
Activating | Sent by the object to itself whenever the object is placed on the screen
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus
Error_Report | Used by the error object to declare errors at the bottom of the screen
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object
OnChildWrapping | Sent any time a wrapping event occurs
Page | Used internally to display the image of an object on the screen
Page_Delete | Used internally to remove the image of an object from the screen
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for WideList_

View method list in alphabetical order

Name | Type | Description
Down | Procedure |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action
Up | Procedure |
Up_Row | Procedure | Changes the current item to the prior row, if any, at the same item relative to the beginning of the row
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result
Zoom | Procedure | Activates zoom object of current item, if any, using popup message
Inherited Methods from EntryList
Activate_Area | Procedure |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item
Activate_Item | Procedure | Activates this object with Item Item# as the current_item
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the current column of the first row
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any
Column | Function | Returns the number of the column that is connected to Item Item#
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask
DoadjustGridWidths | Procedure | Called any time a grid is resized
DoHtmlHelp | Procedure | Launches Compiled HTML Help
DoScrollDown | Procedure | Emulates pressing a spin button down
DoScrollUp | Procedure | Emulates pressing a spin button up
End_of_Data | Procedure | Causes the grid's current item to be set to the current column of the last row
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy
Error_Help | Procedure | (Obsolete)
Extended_Help | Procedure | (Obsolete)
File_Help | Procedure | (Obsolete)
Help | Procedure |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item
Help_For_Help | Procedure | (Obsolete)
Help_Index | Procedure | (Obsolete)
Help_on_topic | Procedure | (Obsolete)
Keys_Help | Procedure | (Obsolete)
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object
Inherited Methods from DfBaseEntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible
Inherited Methods from DfBaseEntry
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg
Inherited Methods from DfBaseForm
Copy | Procedure | Copies the marked block of text to the Clipboard
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object
Delete | Procedure | Deletes the marked block of text
Paste | Procedure | Copies text from the clipboard into the form
Select_All | Procedure |
Undo | Procedure | Will undo the last change in the form
Inherited Methods from DfBaseList
Add_Item | Procedure | Adds an item to the end of a list
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed
Delete_Item | Procedure | Deletes the specified item from the list if it exists
Insert_Item | Procedure | Inserts an item in a list
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one
Select_Count | Procedure Set | Maintains the total number of selected items in the menu
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order
Inherited Methods from DfBaseUIWindow
Release_Mouse_Capture | Procedure |
Inherited Methods from DfBaseWindow
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages
Windows_Message | Procedure | Sends a message to the Windows message queue
Inherited Methods from cUIObject
Activate | Procedure | Gives an object the focus (and adds it to the focus tree)
Activate_Scope | Procedure | Activates objects that are separate tools to the application
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree
Bell | Procedure | Rings the PC bell
Cancel | Procedure | Returns the message_id of itself
confirm | Function | Pops up a "Yes/No" confirmation
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save
Next | Procedure | Moves the focus to the next item or object, as appropriate
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment
Ok | Procedure | Returns the message_id of itself
Page_Object | Procedure | Adds or removes an object
Popup | Procedure | Activates the object as a pop-up
Previous | Procedure | Moves the focus to the previous item or object, as appropriate
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent
Switch | Procedure | Moves the focus to the object returned by the next_object_id function
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


Class: WinReport

Properties Events Methods Index of Classes

(Obsolete) Provides most of the capabilities of the BasicReport class and provides the ability to use WinPrint to provide more-graphical reports

Hierarchy

cObject
---Report
------Report_DS
---------BasicReport
------------WinReport

Library: Windows Application Class Library

Package: Dfwinrpt.pkg

Description

Obsolete

This class is obsolete. It has been replaced with the cWinReport2 class.

The WinReport class is a subclass of BasicReport. This provides most of the capabilities of the BasicReport class and provides the ability to use WinPrint to provide more-graphical reports (different font styles, font weights, font orientations, graphics, etc.). It does not use images for creating reports. Instead, output is specified with the WinPrint command extensions.

To support printing of reports in Windows (proportional) fonts. All reporting functions are supported, including the drawing of pie, bar, and line charts directly from database data. WinReports can be nested. Objects of this class support all types of constraints including parent-file, full access to indexes with multi-level subsection totalling, and access to child-file records by parent-file indexes.

The Constants Interface

The WinReport class uses a number of constants created for use by this class and its subclasses. Those constants are:

  • Page Numbering
  • #pagecount#
  • #subpagecount#
  • #zerosubpagecount#
  • Named Constants
  • Font Attributes
  • Colors
  • Set in Print Dialog/Setup
  • Default Orientation
  • Default Paper Bin
  • Default Paper Size
  • Default Printer Resolution
  • Pages
  • Print to File

The Command Interface

The WinReport class uses a number of commands created for use by this class and its subclasses. Those commands are:

  • DFBeginDiagram
  • DFBeginHeader
  • DFCreateDiagram
  • DFDiagram_Item
  • DFDiagramLabel
  • DFDiagramXLabel
  • DFDiagramYLabel
  • DFEndDiagram
  • DFEndHeader
  • DFFont
  • DFFontSize
  • DFHeaderFrame
  • DFHeaderLineCheck
  • DFHeaderPos
  • DFHeaderWrap
  • DFLineCheck
  • DfTopMargin
  • DfBottomMargin
  • DfLeftMargin
  • DfRightMargin
  • DfSetMargins
  • DFWrite
  • DFWriteBMP
  • DFWriteCol
  • DFWriteDiagram
  • DFWriteEllip
  • DFWriteLine
  • DFWriteLn
  • DFWriteLnCol
  • DFWriteLnPos
  • DFWritePos
  • DFWriteRect
  • DFWriteXYLine
  • Procedure_Section
  • Report_Breaks
  • Report_Data_Set
  • Report_Index
  • Report_Main_File
  • Zero_Subtotals

Sample 1

Object oRpt_W1e is a WinReport
    Report_Main_File Customer

    Set Report_Title to "Printing Customer Names"

    Function Starting_Main_Report Returns Integer
        Integer iRetVal iIdOrderState

        Forward Get Starting_Main_Report to iRetVal

        // We don't know the index order until the report starts. That is
        // why we set ORDERING here in this procedure.
        Delegate Get Id_Order_State to iIdOrderState
        If (iIdOrderState) ;
            Report_Index by Customer.Recnum
        Else ;
            Report_Index by Customer.Customer
    End_Function

    Procedure_Section Page_Top
        DFFont "Arial"   //Using Arial font size 20
        DFFontSize 20

        DFBeginHeader DFPageTop     //Header of type DFPageTop
            DFHeaderPos   HDR_LEFT     //Data in header left justify
            DFHeaderFrame HDR_MARGINS  //Paint frame margin to margin

            //Writeline data at position 3 cm
            DFWritelnPos "Customer Name Listing" 3 (FONT_BOLD)

            //Use font size 16
            DFFontSize 16

            //Write data at posistion 0.5 cm
            DFWritePos   "Cst Id"     0.5 (FONT_ITALIC)

            //Write data at pos 4 cm
            DFWritePos "Name"         4 (FONT_ITALIC)

            //Write data at pos 12 cm
            DFWritePos "Page:"        12 (FONT_ITALIC+FONT_BOLD)

            //Writeln page counter at.
            //#pagecount# MUST be in small letters
            DFWritePos "#pagecount#"  14 (FONT_ITALIC+FONT_BOLD)

        //End header and print header
        DFEndHeader

        //*** Write BMP at pos from margins using curent metrics
        //*** At pos. 1 cm down 11 cm to right from the margin
        //*** Size 4 height 3 width
        DFWriteBMP "LOGO2.BMP" 1 11 4 3

        //DFWriteln ""  //Don't do this in this section!
        //If you do, you will have problems
    End_Procedure

    Procedure_Section Body
        Send Update_Status (String(Customer.Recnum)  ":" *Customer.Customer )

        DFFont "Times New Roman"  //Use font Times New Roman
        DFFontSize 14             //font size 14
        DFLineCheck 20
        //Write date to pos 0.5 cm using italics
        DFWritePos    Customer.Recnum   0.5   (FONT_ITALIC)

        //Writeln dat to pos 4 cm using italics
        DFWritelnPos  Customer.Customer 4     (FONT_ITALIC)
     End_Procedure

    Procedure_Section Page_Bottom
        DFFont "Arial"
        DFFontSize 10

        DFBeginHeader DFPageBottom   //Header of type DFPageBottom
            DFHeaderPos   HDR_CENTER    //Center the data in the header
            DFHeaderFrame HDR_MARGINS   //Frame margin to margin
            DFWrite     "WinRpt1e Sample:  Printed on: " (FONT_ITALIC)

            //Using property in WinReport to set date
            DFWriteln   (RptToday(self)) (FONT_ITALIC)
        DFEndHeader
    End_Procedure

End_Object

Sample 2

// WRPt1.Rpt
Object oCust_Report2 is a WinReport
    Report_Main_File Customer
    Report_Index by Customer.Name

    Set Report_Title to "Printing Customer Names" // Status panel title

    Procedure_Section Page_Top
         DFFont "Arial"   //Using Arial font size 20
         DFFontSize 20

         DFBeginHeader DFPageTop    //Header of type DFPageTop
         DFHeaderPos   HDR_LEFT     //Data in header left justify
         DFHeaderFrame HDR_MARGINS  //Paint frame margin to margin

         //Writeline data at position 3 cm
         DFWritelnPos "Customer Name Listing"  3 (FONT_BOLD)

         //Use font size 16
         DFFontSize 16

         //Write data at position 0.5 cm
         DFWritePos   "Cst Id"    0.5 (FONT_ITALIC)

         //Write data at pos 4 cm
         DFWritePos "Name"         4 (FONT_ITALIC)

         //Write data at pos 12 cm
         DFWritePos "Page:"        12 (FONT_ITALIC+FONT_BOLD)

         //Writeln page counter at.
         //#pagecount# MUST be in small letters
         DFWritePos "#pagecount#"  14 (FONT_ITALIC+FONT_BOLD)
        DFEndHeader
    End_Procedure

    Procedure_Section Body
        Send Update_Status Customer.Name

        DFFont "Times New Roman"  //Use font Times New Roman
        DFFontSize 14             //font size 14
        DFLineCheck 20
        //Write date to pos 0.5 cm using italics
        DFWritePos    Customer.Number  0.5   (FONT_ITALIC)

        //Writeln dat to pos 4 cm using italics
        DFWritelnPos  Customer.Name 4     (FONT_ITALIC)
    End_Procedure

    Procedure_Section Page_Bottom
        DFFont "Arial"
        DFFontSize 10

        DFBeginHeader DFPageBottom   //Header of type DFPageBottom
        DFHeaderPos   HDR_CENTER     //Center the data in the header
        DFHeaderFrame HDR_MARGINS    //Frame margin to margin
        DFWrite     "Win Report Sample:  Printed on: " (FONT_ITALIC)

        //Using property in DFReport to set date
        DFWriteln   (RptToday(Self)) (FONT_ITALIC)
        DFEndHeader
    End_Procedure
End_Object

Within the report view (or panel), the report would be started by creating the following procedure:

Procedure StartReport
        Boolean bToScreen

        Get Print_to_Screen_State to bToScreen
        If (bToScreen) ;
            Set OutPut_Device_Mode to PRINT_TO_WINDOW
        Else ;
            Set OutPut_Device_Mode to PRINT_TO_PRINTER

        Send Run_Report
End_Procedure

Syntax

use dfWinRpt.pkg

Object oObjectName is a WinReport ;
    [main_file mainfileName [by IndexNumber [break var1 [... varN]]]
    [set Server to DDOName]
    Report_Main_File mainfileName
    Report_Index {by | down} {IndexNumber | file.field}
    Report_Breaks var1 [... varN]
    Report_Data_Set data_set

    begin_constraints
        constrain ...
    end_constraints

    procedure_section sectionName
        :
    end_procedure

    procedure_section ...
        :
    end_procedure
end_object

Argument Explanation

Constant | Meaning
oObjectName | The name of the object.
mainfileName | The name of the main database file.
IndexNumber | Identifies the index of mainfileName to use for ordering output.
file.field | Identifies the field of mainfileName whose Main Index is to be used for ordering output.
varN | The variable or expression, a change in the value of which is to trigger a break at Level N.
sectionName | The predefined name of an optional functional section of the object. There may be one section each for any or all of report_header, page_header, page_top, page_title, subHeader_initN, subHeaderN, body, page_total, page_footer, page_bottom, report_footer, filler, subTotalN, and total. N can be 0 through 9.
DDOname | The name of the DataDictionary object through which this object accesses the database. Also the initial value of this object's server property.

Of Special Note

This class does not use images, as it is designed to handle proportional fonts in multiple sizes in a given report. It is also capable of outputting all font attributes, such as bold, italics, etc. It outputs the entire report to memory before any of the report can be viewed.

Objects of this class are not capable of "intelligent" page breaking; the only programmable page-breaking capability in this class is the DFNewPage procedure. "Intelligent" page breaking is handled by the WinPrint DLL. Where you unconditionally desire a page break in your report (as at the triggering of a certain level of section break), using DFNewPage is highly recommended, as it obviates a great deal of computation that otherwise would take place.

A global integer WinPrintID contains the object Id of the WinPrint object in each program that has one. This should be used for faster and easier access to this object. You can use Send message to WinPrintId instead of Send message to (WinPrintObj(self)).

When report objects are nested, all subtotals for all objects are stored in the outer object. This means you don't have to keep track of which object contains each subtotal.

Some things to note about a WinReport object:

  • The overall structure of this object is the same as the BasicReport object. The sections are the same, the processing is the same, the status panel is the same, and the error handling is the same. The main difference is the method of output.
  • Output is defined with a number of special WinPrint commands. These commands are used to define font style, size, orientation, placement. Examples of these commands are DFBeginHeader, DFfEndHeader, DFFonts, DFFontSize and DFWrite.
  • Output can be directed to a printer or to the WinPrint print preview panel. This is controlled by setting the output_device_mode property in the report view. The WinPrint preview panel is very powerful. It allows you to can change paper size, orientation, and printer type. You may view the report on the screen or you may choose to print the report.
  • If a report is interrupted (the status-panel cancel button is pressed) the user is given the choice of stopping the report, canceling the report, or, previewing the report's current progress. This preview process can be very useful when running long reports.

Constants Used By WinReport

The constants described below are available for use in any object in which a use df_print command has been placed.
The following constants are used by WinReport:

  • Page Numbering
  • pagecount
  • subpagecount
  • zerosubpagecount
  • Named Constants
  • Font Attributes
  • Colors
  • Set in Print Dialog/Setup
  • Default Orientation
  • Default Paper Bin
  • Default Paper Size
  • Default Printer Resolution
  • Pages
  • Print to File

Page Numbering

In WinPrint, three keywords used as the first argument (variable) of any of the DFWrite* commands support printing page numbers. It is very important that #pagecount#, #subpagecount# and #zerosubpagecount# are written in lowercase letters and enclosed in quotation marks.

#pagecount#

#pagecount# prints page numbers that increment from the beginning of the report to the end.

DFWriteLn    '#pagecount#' (FONT_DEFAULT)

DFWriteLnCol '#pagecount#' 2              (FONT_DEFAULT)

DFWriteLnPos '#pagecount#' 5              (FONT_DEFAULT)

#subpagecount#

#subpagecount# prints page numbers that increment until a #zerosubpagecount# is executed, at which point they resume incrementing from 1. #subpagecount# would typically be used in Sections pageTop and pageBottom.

DFWriteLn    '#subpagecount#' FONT_DEFAULT

DFWriteLnCol '#subpagecount#' 2              FONT_DEFAULT

DFWriteLnPos '#subpagecount#' 5              FONT_DEFAULT

If you have a report printing multi-page invoices and you want each invoice to start with Page 1, then you should use #subpagecount# and zerosubpagecount#.

#zerosubpagecount#

#zerosubpagecount# zeroes the #subpagecount# counter. You must do a #zerosubpagecount# before you create a new page. #zerosubpagecount# would typically be used in a Section subTotal or subHeader.

DFWrite '#zerosubpagecount#'

Because the numbering of report pages and section pages is done with different arguments, you can have a report whose pages are numbered both ways, if you wish.

Named Constants

Many of the commands in WinPrint use named constants as arguments. Certain arguments can only be one of the named constants. These constants include font attributes, colors, and print dialog/setup flags.

Font Attributes

These named constants, along with all colors, can be used in attributes in DFWrite... statements. When used more than one at a time in a statement, they should be separated by plus (+) signs and all enclosed together by a single pair of parentheses.

FONT_DEFAULT | Font with no attributes
FONT_UNDER | Underline attribute
FONT_BOLD | Bold attribute
FONT_ITALIC | Italic attribute
FONT_STRIKE | Strikeout attribute
FONT_LEFT | Output left-justified to the margin, column, or position.
FONT_CENTER | Output centered on position, in the column, or between the margins.
FONT_RIGHT | Output right-justified to the margin, column, or position.

Colors

These constants provide a convenience for outputting in various standard colors. They can be used with all commands that take color as an argument, including in attributes in DFWrite... statements. With the DFGetDFColor function, you can create any color you desire for output.

RGB_BLACK
RGB_BLUE
RGB_CYAN
RGB_GREEN
RGB_GREY
RGB_MAGENTA
RGB_RED
RGB_WHITE
RGB_YELLOW

Dark colors:
RGB_DBLUE
RGB_DCYAN
RGB_DGREEN
RGB_DGREY
RGB_DMAGENTA
RGB_DRED
RGB_DYELLOW

Set in Print Dialog/Setup

All flags are divided into groups. You can only combine one flag from each group, (e.g., it is invalid to combine both DF_PAPER_A4 and DF_PAPER_A3, because this would be a conflict).

Default Orientation

This group controls the default orientation of the document.

Flag | Description
DF_PORTRAIT | Selects portrait mode.
DF_LANDSCAPE | Selects landscape mode.

Default Paper Bin

This group controls the default paper bin to use. These values are driver dependent. The names of most of these flags are self explanatory.

Flag
DF_BIN_AUTO
DF_BIN_CASSETTE
DF_BIN_ENVELOPE
DF_BIN_ENVMANUAL
DF_BIN_FIRST
DF_BIN_LARGECAPACITY
DF_BIN_LARGEFMT
DF_BIN_LAST
DF_BIN_LOWER
DF_BIN_MANUAL
DF_BIN_MIDDLE
DF_BIN_ONLYONE
DF_BIN_SMALLFMT
DF_BIN_TRACTOR
DF_BIN_UPPER

Default Paper Size

This group controls the default paper size.

Flag | Description
DF_PAPER_10X14 | 10 by 14 inch sheet
DF_PAPER_11X17 | 11 by 17 inch sheet
DF_PAPER_A3 | A3 sheet, 297 by 420 millimeters
DF_PAPER_A4 | A4 Sheet, 210 by 297 millimeters
DF_PAPER_A4SMALL | A4 small sheet, 210 by 297 millimeters
DF_PAPER_A5 | A5 sheet, 148 by 210 millimeters
DF_PAPER_B4 | B4 sheet, 250 by 354 millimeters
DF_PAPER_B5 | B5 sheet, 182 by 257 millimeter paper
DF_PAPER_CSHEET | C Sheet, 17 by 22 inches
DF_PAPER_DSHEET | D Sheet, 22 by 34 inches
DF_PAPER_ENV_10 | #10 Envelope, 4 1/8 by 9 1/2 inches
DF_PAPER_ENV_11 | #11 Envelope, 4 1/2 by 10 3/8 inches
DF_PAPER_ENV_12 | #12 Envelope, 4 3/4 by 11 inches
DF_PAPER_ENV_14 | #14 Envelope, 5 by 11 1/2 inches
DF_PAPER_ENV_9 | #9 Envelope, 3 7/8 by 8 7/8 inches
DF_PAPER_ENV_B4 | B4 Envelope, 250 by 353 millimeters
DF_PAPER_ENV_B5 | B5 Envelope, 176 by 250 millimeters
DF_PAPER_ENV_B6 | B6 Envelope, 176 by 125 millimeters
DF_PAPER_ENV_C3 | C5 Envelope, 162 by 229 millimeters
DF_PAPER_ENV_C4 | C3 Envelope, 324 by 458 millimeters
DF_PAPER_ENV_C5 | C4 Envelope, 229 by 324 millimeters
DF_PAPER_ENV_C6 | C6 Envelope, 114 by 162 millimeters
DF_PAPER_ENV_C65 | C65 Envelope, 114 by 229 millimeters
DF_PAPER_ENV_DL | DL Envelope, 110 by 220 millimeters
DF_PAPER_ENV_ITALY | Italy Envelope, 110 by 230 millimeters
DF_PAPER_ENV_MONARCH | Monarch Envelope, 3 7/8 by 7 1/2 inches
DF_PAPER_ENV_PERSONAL | 6 3/4 Envelope, 3 5/8 by 6 1/2 inches
DF_PAPER_ESHEET | E Sheet, 34 by 44 inches
DF_PAPER_EXECUTIVE | Executive, 7 1/4 by 10 1/2 inches
DF_PAPER_FANFOLD_LGL_GERMAN | German Legal Fanfold, 8 1/2 by 13 inches
DF_PAPER_FANFOLD_STD_GERMAN | German Std Fanfold, 8 1/2 by 12 inches
DF_PAPER_FANFOLD_US | US Std Fanfold, 14 7/8 by 11 inches
DF_PAPER_FOLIO | Folio, 8 1/2 by 13 inch paper
DF_PAPER_LEDGER | Ledger, 17 by 11 inches
DF_PAPER_LEGAL | Legal, 8 1/2 by 14 inches
DF_PAPER_LETTER | Letter, 8 1/2 by 11 inches
DF_PAPER_LETTERSMALL | Letter Small, 8 1/2 by 11 inches
DF_PAPER_NOTE | Note, 8 1/2 by 11 inches
DF_PAPER_QUARTO | Quarto, 215 by 275 millimeter paper
DF_PAPER_STATEMENT | Statement, 5 1/2 by 8 1/2 inches
DF_PAPER_TABLOID | Tabloid, 11 by 17 inches
DF_PAPER_USER | User defined paper size, used in conjunction with DFSetUserDefinedPapersize

Default Printer Resolution

This group controls the default printer resolution. The names of most of these flags are self explanatory.

Flag
DF_RES_DRAFT
DF_RES_HIGH
DF_RES_LOW
DF_RES_MEDIUM

Pages

This group controls the 'Pages' radio button in the Print Dialog.

Flag | Description
DF_NOPAGENUMS | Disables the 'Pages' radio button and associated edit controls.
DF_PAGENUMS | Selects the 'Pages' radio button.

Print to File

This group controls the 'print to file' checkbox in the Print Dialog.

Flag | Description
DF_DISABLEPRINTTOFILE | Disables the 'print to file' checkbox.
DF_HIDEPRINTTOFILE | Hides the 'print to file' checkbox.
DF_PRINTTOFILE | Shows the 'print to file checkbox,' and enables it.

Commands Used by WinReport

The following commands are used by WinReport:

  • DFBeginDiagram
  • DFBeginHeader
  • DFCreateDiagram
  • DFDiagram_Item
  • DFDiagramLabel
  • DFDiagramXLabel
  • DFDiagramYLabel
  • DFEndDiagram
  • DFEndHeader
  • DFFont
  • DFFontSize
  • DFHeaderFrame
  • DFHeaderLineCheck
  • DFHeaderPos
  • DFHeaderWrap
  • DFLineCheck
  • DfTopMargin
  • DfBottomMargin
  • DfLeftMargin
  • DfRightMargin
  • DfSetMargins
  • DFWrite
  • DFWriteBMP
  • DFWriteCol
  • DFWriteDiagram
  • DFWriteEllip
  • DFWriteLine
  • DFWriteLn
  • DFWriteLnCol
  • DFWriteLnPos
  • DFWritePos
  • DFWriteRect
  • DFWriteXYLine
  • Procedure_Section
  • Report_Breaks
  • Report_Data_Set
  • Report_Index
  • Report_Main_File
  • Zero_Subtotals

DFBeginDiagram

Purpose

DFBeginDiagram is used together with other graphic commands to create a chart. DFBeginDiagram is a mix of DFCreateDiagram and DFWriteDiagram.

Syntax

DFBeginDiagram {type} {effect} {vert} {horz} {height} {width}

Argument | Type | Explanation
type constant Diagram Type. Must be one of the following constants

Constant | Meaning
DFGR_BAR | Bar chart
DFGR_LINE | Line chart
DFGR_PIE | Pie chart

effect constant Effect Style. Must be one of the following constants

Constant | Meaning
DFGR_2D | 2-dimensional chart with labels on right
DFGR_3D | 3-dimensional chart with labels on right
DFGR_2DL | 2-dimensional chart with labels on left
DFGR_3DL | 3-dimensional chart with labels on left

vert | number | Location vertical coordinate
horz | number | Location horizontal coordinate
height | number | Height of chart
width | number | Width of chart

It is best to use DFBeginDiagram when you do not have to mix charts within each other. If you have to mix charts within each other or if you have to create a chart before you start to use it, it is better to use DFCreateDiagram and DFWriteDiagram.

All arguments are required. Many of the arguments can be named constants.

DFBeginDiagram    DFGR_BAR  DFGR_2D  DFGR_CURRLINE 3 4 6

DFBeginDiagram    DFGR_PIE  DFGR_3DL 3             3 4 6

DFBeginDiagram    DFGR_LINE DFGR_3D  DFGR_CURRLINE 3 4 6

DFBeginHeader

Purpose

DFBeginHeader starts the definition of section headers and footers in the output.

Syntax

DFBeginHeader {header-type} [{level#}]

Argument | Type | Explanation
Header-type constant Type of Header. Must be one of thefollowing constants

Constant | Meaning
DFReportHeader | Once only, at beginning of report
DFPageTop | Page top
DFPageTitle | Page title
DFPageHeader | Page header
DFSubHeader | Section breaks, levels 1-9
DFSubTotal | Section breaks, levels 1-9
DFTotal | Total
DFPageFooter | Page footer
DFPageTotal | Page total
DFPageBottom | Page bottom
DFReportFooter | Once only, at end of report

level# | integer | Section level number (only used with DFSubHeader or DFSubTotal)

If you use Header Type DFSubHeader or DFSubTotal, level# is required. If you are defining a SubHeader1, the level# is 1, if you are defining a SubTotal2, level# is 2, and so on. In nested reports, level# should be the level of the overall report, not that of the nested report.

Do not nest the definitions of section headers and footers.

DFBeginHeader DFSubHeader 1
    DFHeaderWrap    HDR_NOWRAP
    DFHeaderPos        HDR_LEFT
    DFHeaderFrame    HDR_MARGINS
    DFWritePos        Customer.Recnum   0.5 (FONT_ITALIC +FONT_BOLD +RGB_RED)
    DFWritelnPos    Customer.Customer 2   (FONT_ITALIC +FONT_BOLD)
DFEndHeader

DFCreateDiagram

Purpose

DFCreateDiagram is used to create a chart

Syntax

DFCreateDiagram {type} {effect {height} {width}

Argument | Type | Explanation
type constant Diagran type

Constant | Meaning
DFGR_BAR | Bar chart
DFGR_LINE | Line chart
DFGR_PIE | Pie chart

effect constant Effect type

Constant | Meaning
DFGR_2D | 2-dimensional chart with labels on right
DFGR_3D | 3-dimensional chart with labels on right
DFGR_2DL | 2-dimensional chart with labels on left
DFGR_3DL | 3-dimensional chart with labels on left

height | number | Height of chart
width | number | Width of chart

DFCreateDiagram is used to create a chart so you can fill it with items before you write and position the chart on the page. If you use DFCreateDiagram, you must also use DFWriteDiagram. If you need to nest charts or fill them with items before you write the chart to the page, you should use DFCreateDiagram and DFWriteDiagram. When you use DFCreateDiagram, it is up to you to keep track of the diagram ID, which is used by DFWriteDiagram and DFEndDiagram

Many of the arguments can be named constants.

DFCreateDiagram    DFGR_BAR  DFGR_2D  4 6

DFCreateDiagram    DFGR_PIE  DFGR_3DL 4 6

DFCreateDiagram    DFGR_LINE DFGR_3D  4 6

DFDiagram_Item

Purpose

DFDiagram_Item is used to fill a diagram with data.

Syntax

DFDiagram_Item {value} {label} [{val_disp} [{decimal_places} [{emphasis} [{fill_color} [{border_color} ]]]]]

Argument | Type | Explanation
value | number | Numeric value by which item is proportioned
label | string | Explanatory text for the item
val_disp constant Optional. Determines how the value is displayed

Constant | Meaning
DFGR_NOVAL | Do not display value
DFGR_VAL | Display value
DFGR_PER | Display value as percent of all values

decimal_places | integer | Optional. Number of digits of value to display to the right of the decimal
emphasis constant Optional.

Constant | Meaning
DFGR_IN | depress slice for item
DFGR_OUT | raise slice for item (only valid for pie diagram)

fill_color | constant | Optional. Color of fill
border_color | constant | Optional. Color of border

DFDiagram_Item uses the current diagram ID. If you nest diagrams, it is up to you to keep track of the diagram IDs.

Many of the arguments can be named constants.

DFDiagram_Item 100.34         ""

DFDiagram_Item division.sales "Southeast"   DFGR_NOVAL

DFDiagram_Item 123.45         "Tory"        DFGR_VAL   1 DFGR_OUT

DFDiagram_Item 456.67         defendnt.name DFGR_PER   3 DFGR_IN ;
    RGB_RED RGB_MAGENTA

If you do not specify the color(s), the color(s) will be the default(s) for the class.

DFDiagramLabel

Purpose

DFDiagramLabel is used to set the top label (title) of a chart.

Syntax

DFDiagramLabel {text}

Argument | Type | Explanation
text | string | Content of the label

DFDiagramLabel uses the current diagram. If you nest diagrams, it is up to you to keep track of the diagram ID.

DFDiagramLabel "Top label"

DFDiagramXLabel

Purpose

DFDiagramXLabel is used to set the label for the horizontal axis of a bar or line chart.

Syntax

DFDiagramXLabel {text}

Argument | Type | Explanation
text | string | Content of the label

DFDiagramXLabel uses the current diagram. If you nest diagrams, it is up to you to maintain the desired diagram ID.

DFDiagramXLabel "Fiscal Years"

DFDiagramYLabel

Purpose

DFDiagramYLabel is used to label the vertical axis of a bar or line chart.

Syntax

DFDiagramYLabel {text} {orientation}

Argument | Type | Explanation
text | string | Content of the label
orientation constant Text Orientation

Constant | Meaning
DFGR_HORI | Show text horizontally
DFGR_VERT | Show text vertically (parallel to axis)

DFDiagramYLabel is used to label the vertical axis of a bar or line chart. DFDiagramYLabel uses the current diagram. If you nest diagrams, it is up to you to maintain the desired diagram ID.

DFDiagramYLabel "Income"                 DFGR_HORI

DFDiagramYLabel "Gross National Product" DFGR_VERT

DFEndDiagram

Purpose

DFEndDiagram locks a chart's definition

Syntax

DFEndDiagram

DFEndDiagram locks a chart's definition, which means that the chart cannot take any more items and the chart will be generated and printed to the page. All chart definitions must have a DFEndDiagram. DFEndDiagram acts on the dfCurrent_diagram. If you nest diagrams, it is up to you to maintain the desired diagram ID.

DFEndDiagram

DFEndHeader

Purpose

DFEndHeader ends a section header or footer begun with DFBeginHeader.

Syntax

DFEndHeader

DFBeginHeader DFSubHeader 1
    DFHeaderWrap    HDR_NOWRAP
    DFHeaderPos        HDR_LEFT
    DFHeaderFrame    HDR_MARGINS
    DFWritePos        Customer.Recnum    0.5 (FONT_ITALIC +FONT_BOLD +RGB_RED)
    DFWriteLnPos    Customer.Customer    2   (FONT_ITALIC +FONT_BOLD)
DFEndHeader

DFFont

Purpose

DFFont sets the default font to any valid Windows font.

Syntax

DFFont {fontname}

Argument | Type | Explanation
fontname | string | Any font valid in the Windows installation

DFFont sets the default font to any valid Windows font. The font remains active until you change it to another font with this command.

DFFont    'Arial'

DFFont    'Times New Roman'

DFFontSize

Purpose

DFFontSize sets the font size to any valid size for that font

Syntax

DFFontSize {height} [{width}]

Argument | Type | Explanation
height | number | Height of font in points
width | number | Optional. Width of font in points

DFFontSize sets the font size to any valid size for that font. The size remains active until you change it to another size with this command.

If you only use height, width will be set to the default for that font for that height.

DFFontSize    14

DFFontSize    14 10

DFHeaderFrame

Purpose

DFHeaderFrame sets the frame style of a header or footer section.

Syntax

DFHeaderFrame {style} [{border_width} [{border_color} [{fill_color}]]]

Argument | Type | Explanation
style constant Frame style. Must be one of the following constants.

Constant | Meaning
HDR_FRMSIZE | Fit to data
HDR_MARGINS | Left-margin-to-right-margin
HDR_NOFRAME | No frame

border_width | number | Optional. Width of border (using current metrics)
border_color | number | Optional. Border color
fill_color | consant | Optional. Fill color

DFHeaderFrame may be used only inside a header or footer section begun with dfBeginHeader.

DFBeginHeader DFSubHeader 1
    DFHeaderWrap    HDR_NOWRAP
    DFHeaderPos        HDR_LEFT
    DFHeaderFrame    HDR_MARGINS        0.1 RGB_BLACK                  RGB_CYAN
    DFWritePos        Customer.Recnum    0.5 (FONT_ITALIC +FONT_BOLD)
    DFWriteLnPos    Customer.Customer    2   (FONT_ITALIC +FONT_BOLD)
DFEndHeader

DFHeaderLineCheck

Purpose

DFHeaderLineCheck specifies that the header plus a specified number of lines fits on a page.

Syntax

DFHeaderLineCheck {lines}

Argument | Type | Explanation
lines | integer | Number of lines to check (in addition to the header)

Whenever a header is triggered, it automatically checks the current page to ascertain whether there is room on that page for the whole header. If not, the header will be printed on a new page. DFHeaderLineCheck enables you to specify that this check be performed for the header plus whatever number of lines you feel your program requires for a meaningful beginning of a new section. This command may be used only inside a header section begun with DFBeginHeader.

Number of lines will be checked according the font and size last used.

DFBeginHeader DFSubHeader 1
    DFHeaderLineCheck    4
    DFHeaderPos        HDR_LEFT
    DFHeaderFrame    HDR_MARGINS
    DFWritePos        Customer.Recnum   0.5 (FONT_ITALIC +FONT_BOLD)
    DFWriteLnPos    Customer.Customer 2   (FONT_ITALIC +FONT_BOLD)
DFEndHeader

DFHeaderPos

Purpose

DFHeaderPos positions the section header according to a justification mode

Syntax

DFHeaderPos {justification}

Argument Type Explanation
justification constant Justification mode. Must be one of the following constants

Constant | Meaning
HDR_LEFT | Justify the header or footer to the left margin
HDR_RIGHT | Justify the header or footer to the right margin
HDR_CENTER | Center the header or footer between the margins

DFHeaderPos positions the section header or footer according to the value of justification. DFHeaderPos may be used only inside a header section.

This command may be used only in a header or footer section begun by DFBeginHeader.

DFBeginHeader DFSubHeader 1
    DFHeaderWrap    HDR_NOWRAP
    DFHeaderPos        HDR_LEFT
    DFHeaderFrame    HDR_MARGINS
    DFWritePos        Customer.Recnum   0.5 (FONT_ITALIC +FONT_BOLD)
    DFWriteLnPos    Customer.Customer 2   (FONT_ITALIC +FONT_BOLD)
DFEndHeader

DFHeaderWrap

Purpose

DFHeaderWrap tells a header section to reprint at the top of the new page

Syntax

DFHeaderWrap {wrap}

Argument Type Explanation
wrap constant Wrap mode. Must be one of the following constants.

Constant | Meaning
HDR_NOWRAP | Header is not printed on new pages
HDR_WRAP | Header is printed on new pages

DFHeaderWrap tells a header section to reprint at the top of the new page if a page break occurs within the section's data (before the beginning of the next section). DFHeaderWrap may be used only inside a header section begun with DFBeginHeader, and has no effect in footer-section definitions. By default, headers will not reprint.

DFBeginHeader DFSubHeader 1
    DFHeaderWrap    HDR_NOWRAP
    DFHeaderPos        HDR_LEFT
    DFHeaderFrame    HDR_MARGINS
    DFWritePos        Customer.Recnum    0.5 (FONT_ITALIC +FONT_BOLD)
    DFWriteLnPos    Customer.Customer    2   (FONT_ITALIC +FONT_BOLD)
DFEndHeader

This command may be used only in a header or footer section begun by DFBeginHeader.

DFLineCheck

Purpose

DFLineCheck checks that a given number of lines fit on the page

Syntax

DFLineCheck {lines}

Argument | Type | Explanation
lines | integer | Number of lines to check for

DFLineCheck checks that a given number of lines fit on the page. If not, a page break will be done. It is very useful where the record body has more than one line, to ensure that no record is split by a page break.

Number of lines is checked for the font and size last used in the program.

DFLineCheck 3
DFWriteLnPos Customer.Recnum   2 (FONT_ITALIC +FONT_BOLD)
DFWriteLnPos Customer.Customer 2 (FONT_ITALIC +FONT_BOLD)
DFWriteLnPos Customer.Address  2 (FONT_ITALIC +FONT_BOLD)

The DF MarginCommands

DfLeftMargin

DfTopMargin

DfRightMargin

DfBottomMargin

Send DfSetMargins

Purpose

The DF Margin commands set the margins of your document

Syntax

DFTopMargin {position}
DFBottomMargin {position}
DFLeftMargin {position}
DFRightMargin {position}

Argument | Type | Explanation
position | number | Margin in the current metrics

The DF Margin commands set the margins of your document using the current metrics, specified by the value of dfCurrent_metrics in the WinPrint Global Object. The default metrics is centimeters and all margins are set to 2.53cm as default. 2.53cm equals 1inch. You cannot set the margins for individual pages. The margins you have set will be valid for all pages of the report.

You can set all margins at one time by calling the procedure DFSetMargins in the printer object and passing the values for left, top, right, and bottom in that order.

DFTopMargin            1.25

DFBottomMargin        1.25

Send DFSetMargins of WinprintId nLeft nTop nRight nBottom
Send DFSetMargins of WinprintId 2 1.25 2 1.25

All the position measurements (vert, horz, etc.) of the other commands are taken vertically down from the top margin and horizontally right from the left margin.

DFWrite

Purpose

DFWrite appends data to the current line

Syntax

DFWrite {variable} [{attributes} [{decimal-places}]]

Argument | Type | Explanation
variable | string | A literal, variable, or database field whose value is to be output
attributes | constant | Optional. Font attribute(s) (WinPrint named constants)
decimal_places | integer | Optional. Number of digits to the right of the decimal for numeric values

If you use decimal_places, you must use all preceding arguments. If you use this argument, the output will be displayed with the number of decimal digits specified, right-justified to the page/header.

If you use FONT_LEFT, FONT_CENTER or FONT_RIGHT in attributes, the output will be justified to the page/header.

DFWrite "Balance"           (FONT_ITALIC +FONT_BOLD +RGB_RED)

DFWrite product.description (FONT_DEFAULT)

DFWrite 12345.67            (FONT_ITALIC +RGB_BLUE)           2

DFWriteBMP

Purpose

DFWriteBMP is used to place a bitmap on the page.

Syntax

DFWriteBMP {path\filename} {vert_Location} {horz_Location} {height} {width} [{update_cur_pos}]

Argument | Type | Explanation
path\filename | string | Name and path of bitmap file
vert_Location | number | (upper-left corner) vertical coordinate in the current metrics
horz_Location | number | (upper-left corner) horizontal coordinate in the current metrics
height | number | Height of bitmap in the current metrics
width | number | Width of bitmap in the current metrics
update_cur_pos constant Optional. Determines where current position pointer will be placed

Constant | Meaning
DFGR_SETPOS | Move current position to end of bitmap
DFGR_NOPOS | Leave current position unchanged

Path is only required if the bitmap is not in the same directory as the application.

The vertical and horizontal start positions use current metrics for the position on the page. Height and width of the bitmap also use current metrics.

Position is from the margin.

DFWriteBMP    'UGLYFACE.BMP'    2 10 4 3 DFGR_NOPOS

DFWriteCol

Purpose

DFWriteCol appends data to the current line at the specified column.

Syntax

DFWriteCol {variable} {column} [{attributes} [{decimal-places}]]

Argument | Type | Explanation
variable | string | A literal, variable, or database field whose value is to be output
column | integer | Column to write to
attributes | constant | Optional. Font attribute(s) (WinPrint named constants)
decimal_places | integer | Optional. Number of digits to the right of the decimal for numeric values

The number of columns on the page is specified by Procedure DFNew_page (0 is legal). Columns are numbered ordinally from left to right starting with 1. They are a convenience not only for coding, but for freeing much code of sensitivity to the current metrics setting.

If you use decimal_places, you must use all preceding arguments. If you use this argument, the output will be displayed with the number of decimal digits specified, right-justified in the column.

If you use FONT_LEFT, FONT_CENTER or FONT_RIGHT in attributes, the output will be justified to the column.

DFWriteCol    "String to print" 0 (FONT_ITALIC+FONT_BOLD +RGB_RED)

DFWriteCol    Database.Field    1 (FONT_DEFAULT)

DFWriteCol    12345.67          2 (FONT_ITALIC +RGB_BLUE)          2

DFWriteDiagram

Purpose

DFWriteDiagram is used to position a diagram created with DFCreateDiagram on the page.

Syntax

DFWriteDiagram {vert} {horz}

Argument | Type | Explanation
vert | number | Location (upper-left corner) vertical coordinate in the current metrics
horz | number | Location (upper-left corner) horizontal coordinate in the current metrics

DFWriteDiagram uses the current diagram ID. If you nest diagrams, it is up to you to maintain the desired diagram ID.

DFWriteDiagram    DFGR_CURRLINE 5

DFWriteDiagram    4             6

DFWriteEllip

Purpose

DFWriteEllip writes an ellipse to the page.

Syntax

DFWriteEllip {vert} {horz} {height} {width} [{border_color} [{border-width} [{reprint} [{fill_color} [{update_cur_pos}]]]]]

Argument | Type | Explanation
vert | number | Location (upper-left corner) vertical coordinate in the current metrics
horz | number | Location (upper-left corner) horizontal coordinate in the current metrics
height | number | Height of the ellipse in the current metrics
width | number | Width of the ellipse in the current metrics
border_color | constant | Optional. Border lines color (default black)
border_width | constant | Optional. Width of border lines in the current metrics
reprint constant Optional. Determines if graphic is reprinted in succeeding page

Constant | Meaning
DFGR_NOWRAP | Print once only
DFGR_WRAP | Print on each succeeding page

fill_color | constant | Optional. Fill color (default transparent)
update_cur_pos constant Optional. Determines where current position pointer will be placed

Constant | Meaning
DFGR_SETPOS | Move current position to end of ellipse
DFGR_NOPOS | Leave current position unchanged

Many of the arguments can be named constants. DFGR_RB_MARGIN refers to the full distance between the top and bottom margins or the left and right margins, as appropriate.

DFWriteEllip 2 4 6              4 RGB_BLACK 0.1 DFGR_NOWRAP RGB_RED DFGR_NOPOS

DFWriteEllip 0 0 DFGR_RB_MARGIN DFGR_RB_MARGIN 0.3

DFWriteLine

Purpose

DFWriteLine is used to output a graphic line (rule) to a page.

Syntax

DFWriteLine {vert} {horz} {length} [{orientation} [{color} [{width} [{update_cur_pos}]]]]

Argument | Type | Explanation
vert | number | Location (upper or left end) vertical coordinate in the current metrics
horz | number | Location (upper or left end) horizontal coordinate in the current metrics
length | number | Length of line in the current metrics
orientation constant Optional. Determines if line is horizontal of vertical.

Constant | Meaning
DFGR_HORI | Horizontal line (default)
DFGR_NOPOS | Vertical line

color | constant | Optional. Line color (default black)
width | number | Optional. Width of line in the current metrics
update_cur_pos constant Optional. Determines where current position pointer will be placed

Constant | Meaning
DFGR_SETPOS | Move current position to end of line
DFGR_NOPOS | Leave current position unchanged

DFWriteLine, which is not the same as DFWriteLn, is used to output a line (rule) to a page.

Many of the arguments can be named constants. DFGR_HORI (the default) provides for a horizontal line, while DFGR_VERT provides for a vertical one. DFGR_RB_MARGIN refers to the full distance the top and bottom margins or the left and right margins, as appropriate.

DFWriteLine 2             4 6              DFGR_HORI RGB_RED 0.1 DFGR_NOPOS

DFWriteLine DFGR_CURRLINE 3 DFGR_RB_MARGIN DFGR_VERT

DFWriteLn

Purpose

DFWriteLn writes data to the current output line and begins a new output line.

Syntax

DFWriteLn {variable} [{attributes} [{decimal-places}]]

Argument | Type | Explanation
variable | A literal, variable, or database field whose value is to be output
attributes | Font attribute(s) (WinPrint named constants)
decimal_places | Optional. Number of digits to the right of the decimal for numeric values

If you use decimal_places, you must use all three arguments. If you use this argument, the output will be displayed with the number of decimal digits specified, right-justified to the page/header.

If you use FONT_LEFT, FONT_CENTER or FONT_RIGHT in attributes, the output will be justified to the page/header.

DFWriteln    "End of report" (FONT_ITALIC +FONT_BOLD +RGB_RED)

DFWriteln     visitors.id     (FONT_DEFAULT)

DFWriteln     12345.67        (FONT_ITALIC +RGB_BLUE)            2

DFWriteLnCol

Purpose

DFWriteLnCol writes the data to the specified column and begins a new output line.

Syntax

DFWriteLnCol {variable} {column} [{attributes} [{decimal-places}]]

Argument | Type | Explanation
variable | string | A literal, variable, or database field whose value is to be output
column | integer | Column to write to
attributes | constant | Optional. Font attribute(s) (WinPrint named constants)
decimal_places | integer | Optional. Number of digits to the right of the decimal for numeric values.

DFWritePos writes the data to the specified column and does a line feed. The number of columns on the page is specified by Procedure DFNew_page (0 is legal). Columns are numbered ordinally from left to right starting with 1. They are a convenience not only for coding, but for freeing much code of sensitivity to the current metrics setting.

If you use decimal_places, you must use all preceding arguments. If you use this argument, the output will be displayed with the number of decimal digits specified, right-justified in the column.

If you use FONT_LEFT, FONT_CENTER or FONT_RIGHT in attributes, the output will be justified to the column.

DFWritelnCol    "String to print" 0 (FONT_ITALIC +FONT_BOLD +RGB_RED)

DFWritelnCol    Database.Field    1 (FONT_DEFAULT)

DFWritelnCol    12345.67          2 (FONT_ITALIC +RGB_BLUE)           2

Note: DFWriteCol and DFWriteLnCol cannot be used inside header sections.

DFWriteLnPos

Purpose

DFWriteLnPos appends data to the current line at a specified position from the left margin and begins a new output line.

Syntax

DFWriteLnPos {variable} {position} [{attributes} [{decimal_places} [{MaxLength}]]]

Argument | Type | Explanation
variable | string | A literal, variable, or database field whose value is to be output
position | number | Position to write at in the current metrics
attributes | constant | Optional. Font attribute(s) (WinPrint named constants)
decimal_places | integer | Optional. Number of digits to the right of the decimal for numeric values. Pass -1 for no-decimal places (i.e., a string output).
MaxLength | number | Optional. Determines maximum length of output value using the current system metrics (Inch or Cm)

DFWriteLnPos appends data to the current line at a specified position from the left margin using the current metrics, specified by the value of dfCurrent_metrics in the WinPrint Global Object, and opens the next new line at the left margin.

If you use decimal_places, you must use all preceding arguments. If you use this argument, the output will be displayed with the number of decimal digits specified, right-justified to the position. When using decimals, set the position for the right side of the data.

MaxLength is an optional parameter and if not passed the entire output value will be output. Passing a length of zero (0) will also output the entire string. If you wish to pass the MaxLength parameter you must also pass parameters for Attributes and Decimal_places. Pass -1 for no-decimal places (i.e., a string output). The following commands are the same:

DfWriteLnPos Customer.Name 10
DfWriteLnPos Customer.Name 10 FONT.DEFAULT
DfWriteLnPos Customer.Name 10 FONT.DEFAULT -1
DfWriteLnPos Customer.Name 10 FONT.DEFAULT -1 0

If you use FONT_LEFT, FONT_CENTER or FONT_RIGHT in attributes, the text will be justified to the position.

DFWriteLnPos "Felons at Large" 0.5 (FONT_ITALIC +FONT_BOLD +RGB_RED) -1 10

DFWriteLnPos ammo.caliber      5   (FONT_DEFAULT) -1 5

DFWriteLnPos 12345.67         12.5 (FONT_ITALIC +RGB_BLUE)       2  4

DFWritePos

Purpose

DFWritePos appends data to the current line at a specified position from the left margin.

Syntax

DFWritePos {variable} {position} [{attributes} [{decimal_places} [{MaxLength}]]]

Argument | Type | Explanation
variable | string | A literal, variable, or database field whose value is to be output
position | number | Position to write at in the current metrics
attributes | constant | Optional. Font attribute(s) (WinPrint named constants)
decimal_places | integer | Optional. Number of digits to the right of the decimal for numeric values. Pass -1 for no-decimal places (i.e., a string output).
MaxLength | number | Optional. Determines maximum length of output value using the current system metrics (Inch or Cm)

DfWritePos appends data to the current line at a specified position from the left margin using the current metrics, specified by the value of dfCurrent_metrics in theWinPrint Global Object.

If you use decimal_places, you must use all preceding arguments. If you use this argument, the output will be displayed with the number of decimal digits specified, right-justified to the position. When using decimals, set the position for the right side of the data.

MaxLength is an optional parameter and if not passed the entire output value will be output. Passing a length of zero (0) will also output the entire string. If you wish to pass the MaxLength parameter you must also pass parameters for Attributes and Decimal_places. Pass -1 for no-decimal places (i.e., a string output). The following commands are the same:

DfWritePos Customer.Name 10
DfWritePos Customer.Name 10 FONT.DEFAULT
DfWritePos Customer.Name 10 FONT.DEFAULT -1
DfWritePos Customer.Name 10 FONT.DEFAULT -1 0

If you use FONT_LEFT, FONT_CENTER or FONT_RIGHT in attributes, the text will be justified to the position.

DFWritePos "Prior Convictions"   0.5 (FONT_ITALIC +FONT_BOLD +RGB_RED) -1 10

DFWritePos sentence.length       5   (FONT_DEFAULT)  -1 5

DFWritePos 12345.67             12.5 (FONT_ITALIC +RGB_BLUE)      2  4

DFWriteRect

Purpose

DFWriteRect is used to write a rectangle to the page. DFWriteRect is very useful to place borders around section headers and/or footers.

Syntax

DFWriteRect {vert} {horz} {height} {width} [{line_color} [{line_width} [{reprint} [{fill_color} [{update_cur_pos}]]]]]

Argument | Type | Explanation
vert | number | Location (upper-left corner) vertical coordinate
horz | number | Location (upper-left corner) horizontal coordinate
height | number | Height of rectangle in the current metrics
width | number | Width of rectangle in the current metrics
line_color | constant | Optional. Color of rectangle border lines (default black)
line_width | number | Optional. Width of rectangle border lines in the current metrics
reprint constant Optional. determines if graphic is reprinted on each page.

Constant | Meaning
DFGR_NOWRAP | Print once only
DFGR_WRAP | Print on each succeeding page

fill_color | constant | Optional. Fill color (default transparent)
update_cur_pos constant Optional. Determines where current position pointer will be placed

Constant | Meaning
DFGR_SETPOS | Move current position to end of rectangle
DFGR_NOPOS | Leave current position unchanged

Many of the arguments can be named constants. DFGR_RB_MARGIN refers to the full distance between the top and bottom margins or left and right margins, as appropriate.

DFWriteRect 2 4 6              4              RGB_BLACK 0.1 DFGR_NOWRAP ;
    RGB_RED DFGR_NOPOS

DFWriteRect 0 0 DFGR_RB_MARGIN DFGR_RB_MARGIN RGB_BLACK 0.3

DFWriteXYLine

Purpose

DFWriteXYLine is used to place a line (rule) on the page from one point to another.

Syntax

DFWriteXYLine {vert} {horz} {vert_stop} {horz_stop} [{color} [{width} [{reprint} [{update_cur_pos}]]]]

Argument | Type | Explanation
vert | number | Start location vertical coordinate in the current metrics
horz | number | Start location horizontal coordinate in the current metrics
vert_stop | number | Stop location vertical coordinate in the current metrics
horz_stop | number | Stop location horizontal coordinate in the current metrics
color | constant | Optional. Line color (default black)
width | number | Optional. Width of line in the current metrics
reprintconstant Optional. Determines how line is drawn on pages

Constant | Meaning
DFGR_NOWRAP | Print once only
DFGR_WRAP | Print on each succeeding page

update_cur_posconstant Optional. Determine how current line is affected

Constant | Meaning
DFGR_SETPOS | Move current position to end of line
DFGR_NOPOS | Leave current position unchanged

The line need not be either horizontal or vertical. You cannot use DFGR_CURRLINE with DFWriteXYLine.

Many of the arguments can be named constants. DFGR_RB_MARGIN refers to the full distance between the top and bottom margins or the left and right margins, as appropriate.

DFWriteXYLine    0 0 DFGR_RB_MARGIN DFGR_RB_MARGIN RGB_BLACK    0.1 DFGR_WRAP ;
    DFGR_NOPOS

DFWriteXYLine    1 1 10             15             RGB_BLACK

Procedure_Section

This command defines the start of a procedure section. It is similar to the predecessor Report Macro's section command. The procedure_section command allows you to define a procedure section for your report (header, footer, subheader, body, etc). Since this is a windows report you do not use images as you would with BasicReport

Section_name must be one of the following keywords. Each of these is described above in the section on Procedures:

Page_Top
Report_Header
Page_Header
Page_Title
SubHeader_Init1..n
SubHeader1..n
Body
SubTotal1..n
Total
Page_Total
Page_Footer
Report_Footer
Page_Bottom

The procedure_section exists because it is defined in the BasicReport superclass which needs images. With the Winprint class you can use the Procedure_Section command or a procedure. We recommend you use the procedure. For example, these two examples are actually identical:

Example 1

Procedure_Section SubHeader1
     :
End_Procedure

Procedure_Section Body
     :
End_Procedure

Example 2

Procedure SubHeader1
     :
End_Procedure

Procedure Body
     :
End_Procedure

Report_Breaks

This command defines the breakpoints needed in a report and is the same as using the break parameter in the report object-creation statement. The report_breaks command is the more-flexible approach because it may be used in class construction. In addition, when using the break parameter, you cannot define a break that is a function local to the report object you are creating. This doesn't work:

Object aReport is a basicReport Break (aFunction(self))

This does work:

Object R is a basicReport
    Report_Breaks (F(self)

The breakpoints can be just about anything. They can be a file.field (as in the Report Macro), they can be a variable or a window, or they can be a built-in or a user-defined function.

Report_Breaks (Left(Vndr.Name, 1)) Vndr.Name

Report_Breaks (G_Func(Desktop, Vndr.Id))

Report_Breaks (L_Func(Self, Vndr.Due))

The report_breaks command actually creates a custom function named test_breakpoints. Therefore, when used in a class, the report_breaks command must not be placed in a procedure or function, but should be placed directly inside the class. The following example shows how a basicReport subclass should be created using the various report_???? commands.

Class V_Report is a BasicReport

    Report_Breaks (left(Vndr.name, 1)) Vndr.Name

    Procedure Construct_Object integer iMyImage
        Forward Send Construct_Object iMyImage

        Report_Main_File Vndr
        Report_Index by Vndr.Name
    End_Procedure
    :
End_Class

Report_Data_Set

This command determines which DDO will serve this report object. It does this by setting the server property to the DDO's object ID. The server property may also be set in the report object's creation statement with the using option, or it may be set by setting the server property.

The following examples are all identical:

Object oVndrReport is a BasicReport Using Vndr_DD

Object oVndrReport is a BasicReport
    Report_Data_Set Vndr_DD

Object oVndrReport is a BasicReport
    Set Server to Vndr_DD

Report_Index

This command sets the index of the main_file to be used by the report and the direction the index should be traversed. It does this by setting two properties: ordering and find_down_state. This may also be accomplished by placing this command's parameters in the report-object-creation statement, or by directly setting the properties.

The report_index command is the most-flexible approach because it can be used inside of class construction and it can used with either an index number or with a file.field whose main index should be used.

Examples

Report_Index BY 2

Report_Index DOWN Vndr.Name

Report_Index BY IntVar

If the report_index command is used in a class, remember that it must be placed inside a procedure or function (most likely Procedure construct_object). Also note that this command (and the associated properties) may be used and changed at runtime.

Report_Main_File

This command determines the main file for a report. It does this by simply setting the main_file property to the df_filename's filenumber. This property may also be set by the report object's creation statement with the main_file file_name option, or it may be set by setting the main_file property.

The following examples are all identical:

Object oVndrReport is a BasicReport Main_File Vndr

Object oVndrReport is a BasicReport
    Report_Main_File Vndr

Object oVndrReport is a BasicReport
    Set Main_File to Vndr.File_number

The report_main_file command (or setting the main_file property) are more flexible than the command-line main_file option because they can be used in both object and class definitions.

If the report_main_file command (or a set main_file ... statement) are used in a class, remember that it must be placed inside a procedure or function (most likely Procedure construct_object). Also note that the main_file property may be set and changed at runtime.

Zero_Subtotals

This object does not zero sub-totals before a report is run. This means that if you cancel a report in the middle and restart without leaving the program, the subtotals may be wrong. Zero_subtotals zeros the subtotal accumulators of all image windows named. This command should be executed as part of a report's initialization, possibly in the starting_report function. It is a good idea to zero the subtotal accumulators of any image that uses a subtotal. You can find all subtotals by doing a search of your program for all subtotal commands.

Function Starting_Report Returns Integer
    Zero_SubTotals SubTotal2.2 SubTotal2.3 SubTotal1.2
    Zero_SubTotals VndrTotal VndrDue VndrPaid
End_Function

Last Edited: October 11, 2005


Properties for WinReport

View property list in alphabetical order

Name | Description
AutoNew_Page_State | Determines if a DFNew_Page is sent when the report is started or if new pages are explicitly generated
AutoOutPut_State | Determines if the report is automatically output to the printer or the Previewer when it is complete
Output_Device_Mode | Determines if this object will use this container's output_device_mode
Print_Columns | Determines the number of columns in a report
RptToday | Contains the current date
Inherited Properties from BasicReport
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button
Display_Error_State |
Output_Device | Handles the name of the output device
Report_Caption | Contains the text that will appear in the status panel's caption bar
Report_Message | An additional message area that will appear below the report_title in the status panel
Report_Status_Panel |
Report_Title | A centered title that appears in the status panel
Status_Log_Id | Object ID of status-log object
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs
Inherited Properties from Report_DS
Server | Contains the object ID of this object's server
Inherited Properties from Report
Assigned_Channel |
Cancelled_State | Setting this true will cancel a report
Child_Rpt_State | Set true if the current Report object is nested
Current_Rec | (Obsolete) Contains the record number of the current valid record found
Find_Down_state | Determines if an index should be traversed in forward or reverse order
Find_Mode | Maintains the current finding mode
Footer_Lines | Contains the number of lines in the page_bottom image plus the page_footer image plus the page_total image
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function
Has_Children_Rpt_State | Is set true if other reports are nested inside this report object
Last_Rec | (Obsolete) Contains the record number of the last selected record found
Main_File | Contains the filenumber of the file which the report will use for finding records
Main_Report_Id | Contains the object ID of the outer report
New_Page_State | Set true when a new page is needed
No_Constrained_Find_State | Determines if constrained record finding should be disabled
No_Finding_State | Determines how the Report object will find records
No_PageCheck_State | Set true when the Report object is processing a new page
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found
Num_Breaks | Returns the number of breaks in a report
Ordering | Contains the index number which will be used for finding records
Page_Count | Keeps track of the current page number
Page_End | Determines how many lines on a page are allowed before a page break will occur
Page_End_State | If this property is set true below the forward send statement in the starting_main_report procedure, then the next page_check will cause an end-of-page/new-page sequence
Page_Feed | Used by the formfeed procedure
Page_Footer_Lines | The number of lines in the page_footer image
priCurrentRec | Contains the RowId of the current valid record found
priFoundRec | Contains the RowId of the record found by the find_rec function
priLastRec | Contains the RowId of the last selected record found
Rec_Count | Contains the number of records found for the current report
Refind_for_SubTotal_State | Ensures that the subtotal is processed with the last valid record for that break level
Report_Channel | Determines which output channel will be used for your report output
Report_Footer_Lines | The number of lines in the report_footer image
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing
Sub_Totaling_State | Set true when the Report object is processing subtotals or totals
Inherited Properties from cObject
Child_Count | Returns the number of child objects the object contains
Delegation_Mode | Determines if and how unknown messages are delegated
Name | Returns the full name of the object including parentage
Object_Id | Returns the object handler of the object
Object_Label | Returns the short name of an object
Parent | Returns the parent of an object
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing


Events for WinReport

View event list in alphabetical order

Name | Description
Report_Interrupt | Augmented to support a preview mode
Inherited Events from BasicReport
Ending_Main_Report | Augmented to print/preview the report if AutoOutput_State is set to true
Error_Report | Sent whenever an error is generated
onError | Provided as a hook to handle custom error reporting
Starting_Main_Report | Called only if the current report is an outer report
Inherited Events from Report
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property
Body | Called once for every record selected for the report to provide processing for record data (if any) not used for subheaders and subtotals
Ending_Report | This handler is called at the end of every report
Final_Formfeed |
OnConstrain |
Page_Bottom | The last thing printed on every page
Page_Footer | Printed after page_total on every page except the last page
Page_Header | Called after page_top on every new page except the first
Page_Title | Called on every new page after report_header or page_header
Page_Top | Called first at the top of each new page
Page_Total | Called on every new page and is printed as the first part of a page break at the bottom of each page
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found
Report_Footer | Printed after page_total on the last page of the report
Report_Header | Called only on the first page of the report, after page_top
Selection | Validates a record
Starting_Report | Called at the start of every report
SubHeader_Init1..n | Called for every break level (n) for which you define a SubHeader_init1..n procedure section in your program
SubHeader1..n | Called for every break level (n) for which you define a subHeader procedure section in your program
SubTotal1..n | Called for every break level (n) for which you define a subTotal procedure section in your program
Total | Called once at the end of a report after the final subtotals are output
Inherited Events from cObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions
Destroy_Object | Sent when an object is about to be destroyed
End_Construct_Object | End of object constructor.


Methods for WinReport

View method list in alphabetical order

Name | Type | Description
Add_SubTotal | Procedure | Adds the value of nData to the subtotal for the passed iCounter
Clr_AllSubTotals | Procedure | Zeroes all the subtotal accumulators for the report
Clr_SubTotal | Procedure | Zeroes the subtotal accumulator for the passed iCounter
DFNew_Page | Procedure | Creates a new page with Cols
PrintReport | Procedure |
ShowRuler | Procedure | Displays a ruler in the report
SubTotal | Function | Returns the value of the subtotal for the passed iTotal and zeroes the subtotal accumulator
Sum_SubTotal | Function | Returns the value of the subtotal for the passed iTotal, but does not zero the subtotal accumulator
Inherited Methods from BasicReport
End_Log | Procedure | Sends an end-log message to the log object
Error_Log_Status | Procedure | Called by error_report if status_log_state is true
Log_Status | Procedure | Sends passed message to the log object
Start_Log | Procedure | Sends a start-log message to the log object
Update_Status | Procedure | Send this message to update the action area of the status panel
Inherited Methods from Report_DS
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO
Request_Save | Procedure | If sent, this saves the current record
Inherited Methods from Report
Formfeed | Procedure | Handles formfeeds
Output_ImageNum | Procedure | Outputs the image represented by ImageNum
Run_Report | Procedure | Sends a message to the report object telling it to start the report with internal finding
Start_Report | Function | Augmented to check the server property and if the property is non-zero (and a DSO exists), to establish a client-server link between the report object and the DSO
WriteLn | Procedure | Outputs the string message to the current output channel
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data
Inherited Methods from cObject
Create | Function | Creates an object based on the passed Class Id
Destroy | Procedure |
Exit_Application | Procedure | Starts the process of closing an application
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead


_Classes_WebApp.htm

Web Application Class Hierarchy

View Combined Class Hierarchy View Windows Application Class Hierarchy

   cObject
   ├──Array
   │  ├──cCLIHandler
   │  │  ├──cDB2Handler
   │  │  ├──cMSSQLHandler
   │  │  └──cODBCHandler
   │  ├──cCollection
   │  ├──cDFBtrDrvHandler
   │  ├──cSQLConnection
   │  ├──cSQLHandleManager
   │  ├──cSQLStatement
   │  ├──Set
   │  │  └──Broadcaster
   │  └──ValidationTable
   │     └──DescriptionValidationTable
   │        └──FileValidationTable
   │           └──CodeValidationTable
   ├──BaseData_Set [Abstract]
   │  └──DataSet [Abstract]
   │     └──DataDictionary
   ├──BaseXmlDomImplementation [Abstract]
   ├──BaseXmlDomNamedNodeMap [Abstract]
   │  └──cXMLDOMNamedNodeMap
   ├──BaseXmlDomNode [Abstract]
   │  ├──BaseXmlDomAttribute [Abstract]
   │  │  └──cXMLDOMAttribute
   │  ├──BaseXmlDomCharacterData [Abstract]
   │  │  ├──BaseXmlDomComment [Abstract]
   │  │  │  └──cXMLDOMComment
   │  │  └──BaseXmlDomTextNode [Abstract]
   │  │     ├──BaseXmlDomcDataSection [Abstract]
   │  │     │  └──cXMLDOMCDATASection
   │  │     └──cXMLDOMTextNode
   │  ├──BaseXmlDomDocument [Abstract]
   │  │  └──cXMLDOMDocument
   │  ├──BaseXmlDomDocumentFragment [Abstract]
   │  │  └──cXMLDOMDocumentFragment
   │  ├──BaseXmlDomDocumentType [Abstract]
   │  │  └──cXMLDOMDocumentType
   │  ├──BaseXmlDomElement [Abstract]
   │  │  └──cXMLDOMElement
   │  ├──BaseXmlDomEntity [Abstract]
   │  │  └──cXMLDOMEntity
   │  ├──BaseXmlDomEntityReference [Abstract]
   │  │  └──cXMLDOMEntityReference
   │  ├──BaseXmlDomNotation [Abstract]
   │  │  └──cXMLDOMNotation
   │  ├──BaseXmlDomProcessingInstruction [Abstract]
   │  │  └──cXMLDOMProcessingInstruction
   │  └──cXMLDOMNode
   ├──BaseXmlDomNodeList [Abstract]
   │  └──cXMLDOMNodeList
   ├──BaseXMLDomParseError
   ├──BusinessProcess
   ├──cApplication
   ├──cClientWebService
   ├──cCommandLine
   ├──cCrystal
   ├──cDistributedBusinessProcess [Abstract]
   │  └──cRemoteEntryProcess [Abstract]
   │     └──cInternetSessionBusinessProcess [Abstract]
   │        └──cWebBusinessProcess
   ├──cHtmlHelp
   ├──cImageList
   ├──cIniFile
   ├──cMapiHandler
   ├──cRegistry
   ├──cReport [Abstract]
   │  └──cReportDS [Abstract]
   │     └──cBasicReport [Abstract]
   │        └──cHtmlReport [Abstract]
   │           └──cWebReport
   │              ├──cAutoWebReport
   │              └──cWmlreport
   ├──cTableColumnFetchHelper
   ├──cVersionInfo
   ├──cWebApp
   ├──cWebService
   ├──cWorkspace
   ├──ErrorSystem
   ├──InetTransfer [Abstract]
   │  ├──cBaseHTTPTransfer [Abstract]
   │  │  └──cHttpTransfer
   │  │     └──cXmlHttpTransfer
   │  └──cFTPTransfer
   ├──Mixin
   │  ├──Action_Bar_Mixin
   │  ├──Auto_Locate_Mixin
   │  ├──Auto_Setup_Mixin
   │  ├──Bitmap_Support_Mixin
   │  ├──cCallInterfaceHelper_mixin
   │  ├──cComFont
   │  ├──cComFontEvents
   │  ├──cComPicture
   │  ├──cCrystal_ICRViewerEvents
   │  ├──cCrystalIApplication
   │  ├──cCrystalIArea
   │  ├──cCrystalIAreas
   │  ├──cCrystalIBlobFieldObject
   │  ├──cCrystalIBoxObject
   │  ├──cCrystalIConnectionProperty
   │  ├──cCrystalICRField
   │  ├──cCrystalICRFields
   │  ├──cCrystalICROleObject
   │  ├──cCrystalICrossTabGroup
   │  ├──cCrystalICrossTabGroups
   │  ├──cCrystalICrossTabObject
   │  ├──cCrystalICRVEventInfo
   │  ├──cCrystalICRVParameterPromptRuntimeOM
   │  ├──cCrystalICRVSelectionItem
   │  ├──cCrystalICRVSelectionItems
   │  ├──cCrystalICRVTrackCursorInfo
   │  ├──cCrystalICrystalDataObject
   │  ├──cCrystalICrystalReportSourceRouter
   │  ├──cCrystalICrystalReportViewer11
   │  ├──cCrystalICrystalReportViewerViewInfo
   │  ├──cCrystalICSFontDescription
   │  ├──cCrystalIDatabase
   │  ├──cCrystalIDatabaseFieldDefinition
   │  ├──cCrystalIDatabaseFieldDefinitions
   │  ├──cCrystalIDatabaseTable
   │  ├──cCrystalIDatabaseTables
   │  ├──cCrystalIExportOptions
   │  ├──cCrystalIFieldDefinitions
   │  ├──cCrystalIFieldElement
   │  ├──cCrystalIFieldElements
   │  ├──cCrystalIFieldMappingData
   │  ├──cCrystalIFieldObject
   │  ├──cCrystalIFormattingInfo
   │  ├──cCrystalIFormulaFieldDefinition
   │  ├──cCrystalIFormulaFieldDefinitions
   │  ├──cCrystalIGraphObject
   │  ├──cCrystalIGroupNameFieldDefinition
   │  ├──cCrystalIGroupNameFieldDefinitions
   │  ├──cCrystalILineObject
   │  ├──cCrystalIMapObject
   │  ├──cCrystalINameValuePairs
   │  ├──cCrystalIObjectSummaryFieldDefinitions
   │  ├──cCrystalIOlapGridObject
   │  ├──cCrystalIPage
   │  ├──cCrystalIPageEngine
   │  ├──cCrystalIPageGenerator
   │  ├──cCrystalIPages
   │  ├──cCrystalIParameterFieldDefinition
   │  ├──cCrystalIParameterFieldDefinitions
   │  ├──cCrystalIParameterValue
   │  ├──cCrystalIParameterValueInfo
   │  ├──cCrystalIParameterValueInfos
   │  ├──cCrystalIParameterValues
   │  ├──cCrystalIPrintingStatus
   │  ├──cCrystalIReport
   │  ├──cCrystalIReportAlert
   │  ├──cCrystalIReportAlertInstance
   │  ├──cCrystalIReportAlertInstances
   │  ├──cCrystalIReportAlerts
   │  ├──cCrystalIReportEvent
   │  ├──cCrystalIReportObjects
   │  ├──cCrystalIRunningTotalFieldDefinition
   │  ├──cCrystalIRunningTotalFieldDefinitions
   │  ├──cCrystalISection
   │  ├──cCrystalISectionEvent
   │  ├──cCrystalISections
   │  ├──cCrystalISortField
   │  ├──cCrystalISortFields
   │  ├──cCrystalISpecialVarFieldDefinition
   │  ├──cCrystalISQLExpressionFieldDefinition
   │  ├──cCrystalISQLExpressionFieldDefinitions
   │  ├──cCrystalISubreportLink
   │  ├──cCrystalISubreportLinks
   │  ├──cCrystalISubreportObject
   │  ├──cCrystalISummaryFieldDefinition
   │  ├──cCrystalISummaryFieldDefinitions
   │  ├──cCrystalITableLink
   │  ├──cCrystalITableLinks
   │  ├──cCrystalITableQualifiers
   │  ├──cCrystalITextObject
   │  ├──cEdit_Mixin
   │  ├──Clear_Defaults_Mixin
   │  ├──Code_Description_Mixin
   │  ├──Code_Pick_List_mixin
   │  ├──Combo_Mixin
   │  ├──cXMLDOMCollectionMixin
   │  ├──cXMLDOMMixin
   │  ├──cXMLDOMNodeMixin
   │  ├──Data_List_mixin
   │  ├──DataFile_Help_Mixin
   │  ├──dbItemMixin
   │  ├──DefaultActionButton_Mixin
   │  ├──deo_delegate_mixin
   │  ├──DEO_Dependent_item_mixin
   │  ├──dfAuto_Locate_Mixin
   │  ├──DFCode_DEO_Mixin
   │  ├──DFEntry_Radio_Group_Mixin
   │  ├──DFLabel_Mixin
   │  ├──DFnavigate_mixin
   │  ├──DFRadio_Group_Mixin
   │  ├──Entry_CheckBox_Mixin
   │  ├──Entry_Client_mixin
   │  ├──Entry_Form_DS_mixin
   │  ├──Entry_Item_Mixin
   │  ├──Entry_Shadow_Mixin
   │  ├──Entry_View_Client_mixin
   │  ├──Extended_Deo_dfCombo_mixin
   │  ├──Extended_DEO_Mixin
   │  ├──Extended_DEO_Prompt_Mixin
   │  ├──Extended_Deo_Radio_mixin
   │  ├──Extended_DEO_Spin_Mixin
   │  ├──Extended_Deo_Status_Help_Mixin
   │  ├──External_Class_Mixin
   │  ├──find_edit_mixin
   │  ├──FloatingPopupMenu_Mixin
   │  ├──Help_Mixin
   │  ├──HtmlFormat_mixin
   │  ├──HtmlWrite_mixin
   │  ├──Label_Mixin
   │  ├──list_mixin
   │  ├──Mask_Form_Mixin
   │  ├──Modal_Mixin
   │  ├──Multi_Item_Shadow_Mixin
   │  ├──navigate_mixin
   │  ├──nesting_mixin
   │  ├──Non_Dependent_item_mixin
   │  ├──NonVisual_Container_Mixin
   │  ├──Panel_Mixin
   │  ├──pick_list_mixin
   │  ├──Print_Dialog_Mixin
   │  ├──Prompt_Button_Mixin
   │  ├──RemoteEntryMixin
   │  ├──ReportView_Mixin
   │  ├──RGB_Support_Temp_Mixin
   │  ├──Select_Mixin
   │  ├──Selection_List_DS_mixin
   │  ├──server_mixin
   │  ├──Shadow_Mixin
   │  ├──Single_Item_Navigate_Mixin
   │  ├──SpinForm_Mixin
   │  ├──Standard_Container_Mixin
   │  ├──Standard_Form_Mixin
   │  ├──Standard_Grid_Mixin
   │  ├──Standard_Object_Mixin
   │  ├──Standard_Select_Mixin
   │  ├──StatusHelp_Item_mixin
   │  ├──Tab_DEO_page_Mixin
   │  ├──Tab_Dialog_Mixin
   │  ├──Tab_Page_Mixin
   │  ├──Table_DS_mixin
   │  ├──Text_Window_mixin
   │  ├──TopMostMixin
   │  ├──TrackBar_Mixin
   │  ├──Validate_Mixin
   │  ├──verify_mixin
   │  ├──View_Dependent_item_mixin
   │  ├──Wide_List_mixin
   │  ├──WmlFormat_mixin
   │  └──WmlWrite_mixin
   ├──StatusAsciiLog
   └──StatusdbLog


_Classes_WinApp.htm

Windows Application Class Hierarchy

View Combined Class Hierarchy View Web Application Class Hierarchy

   cObject
   ├──AbstractFileDialog [Abstract]
   │  ├──OpenDialog
   │  └──SaveAsDialog
   ├──Array
   │  ├──cCLIHandler
   │  │  ├──cDB2Handler
   │  │  ├──cMSSQLHandler
   │  │  └──cODBCHandler
   │  ├──cCollection
   │  ├──cDFBtrDrvHandler
   │  ├──cSQLConnection
   │  ├──cSQLHandleManager
   │  ├──cSQLStatement
   │  ├──Set
   │  │  └──Broadcaster
   │  └──ValidationTable
   │     └──DescriptionValidationTable
   │        └──FileValidationTable
   │           └──CodeValidationTable
   ├──BaseData_Set [Abstract]
   │  └──DataSet [Abstract]
   │     └──DataDictionary
   ├──BaseXmlDomImplementation [Abstract]
   ├──BaseXmlDomNamedNodeMap [Abstract]
   │  └──cXMLDOMNamedNodeMap
   ├──BaseXmlDomNode [Abstract]
   │  ├──BaseXmlDomAttribute [Abstract]
   │  │  └──cXMLDOMAttribute
   │  ├──BaseXmlDomCharacterData [Abstract]
   │  │  ├──BaseXmlDomComment [Abstract]
   │  │  │  └──cXMLDOMComment
   │  │  └──BaseXmlDomTextNode [Abstract]
   │  │     ├──BaseXmlDomcDataSection [Abstract]
   │  │     │  └──cXMLDOMCDATASection
   │  │     └──cXMLDOMTextNode
   │  ├──BaseXmlDomDocument [Abstract]
   │  │  └──cXMLDOMDocument
   │  ├──BaseXmlDomDocumentFragment [Abstract]
   │  │  └──cXMLDOMDocumentFragment
   │  ├──BaseXmlDomDocumentType [Abstract]
   │  │  └──cXMLDOMDocumentType
   │  ├──BaseXmlDomElement [Abstract]
   │  │  └──cXMLDOMElement
   │  ├──BaseXmlDomEntity [Abstract]
   │  │  └──cXMLDOMEntity
   │  ├──BaseXmlDomEntityReference [Abstract]
   │  │  └──cXMLDOMEntityReference
   │  ├──BaseXmlDomNotation [Abstract]
   │  │  └──cXMLDOMNotation
   │  ├──BaseXmlDomProcessingInstruction [Abstract]
   │  │  └──cXMLDOMProcessingInstruction
   │  └──cXMLDOMNode
   ├──BaseXmlDomNodeList [Abstract]
   │  └──cXMLDOMNodeList
   ├──BaseXMLDomParseError
   ├──BusinessProcess
   ├──cApplication
   ├──cClientWebService
   ├──cCommandLine
   ├──cCrystal
   ├──cHtmlHelp
   ├──cImageList
   ├──cIniFile
   ├──Cm_Entry_mixin
   ├──Cm_List_Mixin
   ├──Cm_Menu_Mixin
   ├──cMapiHandler
   ├──ColorDialog
   ├──cRegistry
   ├──CrystalReport
   ├──cStatusPane
   ├──cTableColumnFetchHelper
   ├──cToolbarButton
   ├──cUIObject [Abstract]
   │  ├──Cm_Menu [Abstract]
   │  │  └──Cm_Entry [Abstract]
   │  │     └──Prototype_Entry
   │  ├──DfBaseObject [Abstract]
   │  │  └──DfBaseWindow [Abstract]
   │  │     └──DfBaseUIWindow [Abstract]
   │  │        ├──DfBaseContainer [Abstract]
   │  │        │  ├──DfBaseDialog [Abstract]
   │  │        │  │  ├──Container3d
   │  │        │  │  │  ├──BitmapContainer
   │  │        │  │  │  │  └──dbBitmap
   │  │        │  │  │  ├──Container
   │  │        │  │  │  ├──dbContainer3d_ [Abstract]
   │  │        │  │  │  │  └──dbContainer3d
   │  │        │  │  │  │     ├──dbContainer
   │  │        │  │  │  │     ├──dbTabPage
   │  │        │  │  │  │     └──dbTabView_ [Abstract]
   │  │        │  │  │  │        └──dbTabView
   │  │        │  │  │  ├──Dialog
   │  │        │  │  │  ├──MdiDialog [Abstract]
   │  │        │  │  │  │  └──AppDialog [Abstract]
   │  │        │  │  │  │     └──View
   │  │        │  │  │  │        ├──cCrystalPreview
   │  │        │  │  │  │        ├──dbAppClient_ [Abstract]
   │  │        │  │  │  │        │  └──dbAppView_ [Abstract]
   │  │        │  │  │  │        │     └──dbView
   │  │        │  │  │  │        └──ReportView
   │  │        │  │  │  └──TabPage
   │  │        │  │  ├──DfBasemdiclient [Abstract]
   │  │        │  │  │  └──MdiClientArea
   │  │        │  │  │     └──AppClientArea [Abstract]
   │  │        │  │  │        └──ClientArea
   │  │        │  │  └──DfBasePanel [Abstract]
   │  │        │  │     ├──BasicPanel
   │  │        │  │     │  └──AppPanel [Abstract]
   │  │        │  │     │     └──Panel
   │  │        │  │     ├──cDesktop
   │  │        │  │     └──DfBasetoolPanel [Abstract]
   │  │        │  │        ├──CursorShape
   │  │        │  │        └──FloatingPanel [Abstract]
   │  │        │  │           ├──cStatusPanel [Abstract]
   │  │        │  │           │  └──cProcessStatusPanel
   │  │        │  │           ├──dbFloatingPanel_ [Abstract]
   │  │        │  │           │  └──dbFloatingPanel [Abstract]
   │  │        │  │           │     └──dbViewFloatingPanel [Abstract]
   │  │        │  │           │        ├──dbModalPanel
   │  │        │  │           │        │  └──ValidationList
   │  │        │  │           │        └──dbViewToolPanel [Abstract]
   │  │        │  │           ├──ModalPanel
   │  │        │  │           │  ├──AboutDialog
   │  │        │  │           │  └──ReportPanel
   │  │        │  │           └──ToolPanel
   │  │        │  │              └──SplashScreenPanel
   │  │        │  └──DfBaseGroup [Abstract]
   │  │        │     └──Group
   │  │        │        ├──dbGroup_ [Abstract]
   │  │        │        │  └──dbGroup
   │  │        │        └──RadioGroup
   │  │        │           ├──dbRadioGroupDS [Abstract]
   │  │        │           │  └──dbRadioGroup
   │  │        │           │     └──dbRadioContainer
   │  │        │           └──RadioContainer
   │  │        └──DfBaseControl [Abstract]
   │  │           ├──AbstractShapeControl [Abstract]
   │  │           │  └──ShapeControl
   │  │           ├──cWinControl [Abstract]
   │  │           │  ├──cAnimation
   │  │           │  ├──cProgressBar
   │  │           │  ├──cStatusBar
   │  │           │  └──cToolbar
   │  │           ├──DfBaseEdit [Abstract]
   │  │           │  └──Edit
   │  │           │     └──dbEdit_ [Abstract]
   │  │           │        └──dbEditDS [Abstract]
   │  │           │           └──dbEdit
   │  │           ├──DfBaselineControl [Abstract]
   │  │           │  └──LineControl
   │  │           ├──DfBaseList [Abstract]
   │  │           │  ├──DfBaseActionBar [Abstract]
   │  │           │  │  ├──DfBasePullDown [Abstract]
   │  │           │  │  │  ├──DfBaseEditPullDown [Abstract]
   │  │           │  │  │  │  └──FormFloatingPopupMenu
   │  │           │  │  │  │     ├──dbFloatingPopupMenu
   │  │           │  │  │  │     └──FloatingPopupMenu
   │  │           │  │  │  ├──PopupMenu
   │  │           │  │  │  │  ├──DEOPopupMenu
   │  │           │  │  │  │  └──ViewPopupMenu
   │  │           │  │  │  └──SystemMenu
   │  │           │  │  └──MenuBar
   │  │           │  ├──DfBaseButton [Abstract]
   │  │           │  │  ├──DfBaseCheckbox [Abstract]
   │  │           │  │  │  ├──CheckBox
   │  │           │  │  │  └──DfBaseRadioButton [Abstract]
   │  │           │  │  │     └──RadioButton
   │  │           │  │  │        └──Radio
   │  │           │  │  └──DfBasePushButton [Abstract]
   │  │           │  │     └──Button
   │  │           │  ├──DfBaseForm [Abstract]
   │  │           │  │  ├──DfBaseComboBox [Abstract]
   │  │           │  │  │  └──ComboForm
   │  │           │  │  ├──DfBaseEntry [Abstract]
   │  │           │  │  │  ├──DfBaseComboBoxEntry [Abstract]
   │  │           │  │  │  │  └──ComboEntry [Abstract]
   │  │           │  │  │  │     └──dbBasicComboForm_ [Abstract]
   │  │           │  │  │  │        └──dbBasicComboForm [Abstract]
   │  │           │  │  │  │           └──dbDataComboForm [Abstract]
   │  │           │  │  │  │              └──dbComboFormDS [Abstract]
   │  │           │  │  │  │                 ├──dbCodeComboForm
   │  │           │  │  │  │                 └──dbComboFormDD_ [Abstract]
   │  │           │  │  │  │                    └──dbComboForm
   │  │           │  │  │  ├──DfBaseEntryList [Abstract]
   │  │           │  │  │  │  └──EntryList [Abstract]
   │  │           │  │  │  │     └──WideList_ [Abstract]
   │  │           │  │  │  │        └──WideList [Abstract]
   │  │           │  │  │  │           ├──DataList_ [Abstract]
   │  │           │  │  │  │           │  └──DataList [Abstract]
   │  │           │  │  │  │           │     ├──dbGrid_ [Abstract]
   │  │           │  │  │  │           │     │  └──dbGridDS [Abstract]
   │  │           │  │  │  │           │     │     └──dbGridDD [Abstract]
   │  │           │  │  │  │           │     │        └──dbGrid
   │  │           │  │  │  │           │     └──dbList_ [Abstract]
   │  │           │  │  │  │           │        └──dbListDS [Abstract]
   │  │           │  │  │  │           │           └──dbList
   │  │           │  │  │  │           └──PickList_ [Abstract]
   │  │           │  │  │  │              └──PickList [Abstract]
   │  │           │  │  │  │                 └──CodePickList_ [Abstract]
   │  │           │  │  │  │                    └──CodePickList
   │  │           │  │  │  └──Entry
   │  │           │  │  │     └──dbForm_ [Abstract]
   │  │           │  │  │        └──dbFormDS [Abstract]
   │  │           │  │  │           ├──dbCheckBoxDS [Abstract]
   │  │           │  │  │           │  └──dbCheckbox
   │  │           │  │  │           ├──dbForm
   │  │           │  │  │           │  └──dbFormExternalControl [Abstract]
   │  │           │  │  │           │     └──dbTrackBar
   │  │           │  │  │           └──dbSpinFormDS [Abstract]
   │  │           │  │  │              └──dbSpinForm
   │  │           │  │  ├──DfBaseFormList [Abstract]
   │  │           │  │  │  └──Grid
   │  │           │  │  ├──DfBasetabDialog [Abstract]
   │  │           │  │  │  └──TabDialog_ [Abstract]
   │  │           │  │  │     └──TabDialog
   │  │           │  │  │        └──dbTabDialog_ [Abstract]
   │  │           │  │  │           └──dbTabDialog
   │  │           │  │  │              └──dbTabDialogView
   │  │           │  │  └──Form
   │  │           │  │     ├──FormExternalControl [Abstract]
   │  │           │  │     │  └──TrackBar
   │  │           │  │     └──SpinForm
   │  │           │  └──DfBaseListbox [Abstract]
   │  │           │     └──List
   │  │           │        └──AbstractTreeView [Abstract]
   │  │           │           └──TreeView
   │  │           ├──DFBaseRichEdit
   │  │           │  └──cRichEdit
   │  │           │     └──cDbRichEdit_ [Abstract]
   │  │           │        └──cDbRichEditDS_ [Abstract]
   │  │           │           └──cDbRichEdit
   │  │           ├──DfBaseTextbox [Abstract]
   │  │           │  └──TextBox
   │  │           │     └──DFTimer
   │  │           └──DFBaseTextEdit
   │  │              └──cTextEdit
   │  │                 └──cDbTextEdit_ [Abstract]
   │  │                    └──cDbTextEditDS_ [Abstract]
   │  │                       └──cDbTextEdit
   │  └──DfComUIObject [Abstract]
   │     └──DfInPlaceComObject [Abstract]
   │        ├──DfComActiveXControl [Abstract]
   │        │  └──cComActiveXControl
   │        │     ├──cComActiveXEntryControl_ [Abstract]
   │        │     │  └──cComDbActiveXControl_ [Abstract]
   │        │     │     └──cComDbActiveXControl
   │        │     └──cCrystalActiveXReportViewer
   │        └──DFComDocumentObject [Abstract]
   │           └──cComDocumentObject
   ├──cVersionInfo
   ├──cWorkspace
   ├──DfComAutomationObject [Abstract]
   │  └──cComAutomationObject [Abstract]
   │     ├──cComStdFont
   │     ├──cComStdPicture
   │     ├──cCrystal_ICRViewerSelectionEvents
   │     ├──cCrystalApplication
   │     ├──cCrystalArea
   │     ├──cCrystalAreas
   │     ├──cCrystalBlobFieldObject
   │     ├──cCrystalBoxObject
   │     ├──cCrystalConnectionProperties
   │     ├──cCrystalConnectionProperty
   │     ├──cCrystalCRCrystalReportViewerViewInfo
   │     ├──cCrystalCrossTabGroup
   │     ├──cCrystalCrossTabGroups
   │     ├──cCrystalCrossTabObject
   │     ├──cCrystalCRVEventInfo
   │     ├──cCrystalCRVField
   │     ├──cCrystalCRVFields
   │     ├──cCrystalCRVParameterPromptRuntimeOM
   │     ├──cCrystalCRVSelectionItem
   │     ├──cCrystalCRVSelectionItems
   │     ├──cCrystalCRVTrackCursorInfo
   │     ├──cCrystalCrystalComObject
   │     ├──cCrystalCSFontDescription
   │     ├──cCrystalDatabase
   │     ├──cCrystalDatabaseFieldDefinition
   │     ├──cCrystalDatabaseFieldDefinitions
   │     ├──cCrystalDatabaseTable
   │     ├──cCrystalDatabaseTables
   │     ├──cCrystalExportOptions
   │     ├──cCrystalFieldDefinitions
   │     ├──cCrystalFieldElement
   │     ├──cCrystalFieldElements
   │     ├──cCrystalFieldMappingData
   │     ├──cCrystalFieldObject
   │     ├──cCrystalFormattingInfo
   │     ├──cCrystalFormulaFieldDefinition
   │     ├──cCrystalFormulaFieldDefinitions
   │     ├──cCrystalGraphObject
   │     ├──cCrystalGroupNameFieldDefinition
   │     ├──cCrystalGroupNameFieldDefinitions
   │     ├──cCrystalLineObject
   │     ├──cCrystalMapObject
   │     ├──cCrystalObjectSummaryFieldDefinitions
   │     ├──cCrystalOlapGridObject
   │     ├──cCrystalOleObject
   │     ├──cCrystalPage
   │     ├──cCrystalPageEngine
   │     ├──cCrystalPageGenerator
   │     ├──cCrystalPages
   │     ├──cCrystalParameterFieldDefinition
   │     ├──cCrystalParameterFieldDefinitions
   │     ├──cCrystalParameterValue
   │     ├──cCrystalParameterValueInfo
   │     ├──cCrystalParameterValueInfos
   │     ├──cCrystalParameterValues
   │     ├──cCrystalPrintingStatus
   │     ├──cCrystalReport
   │     ├──cCrystalReportAlert
   │     ├──cCrystalReportAlertInstance
   │     ├──cCrystalReportAlertInstances
   │     ├──cCrystalReportAlerts
   │     ├──cCrystalReportObjects
   │     ├──cCrystalReportSourceRouter
   │     ├──cCrystalRunningTotalFieldDefinition
   │     ├──cCrystalRunningTotalFieldDefinitions
   │     ├──cCrystalSection
   │     ├──cCrystalSections
   │     ├──cCrystalSortField
   │     ├──cCrystalSortFields
   │     ├──cCrystalSpecialVarFieldDefinition
   │     ├──cCrystalSQLExpressionFieldDefinition
   │     ├──cCrystalSQLExpressionFieldDefinitions
   │     ├──cCrystalSubreportLink
   │     ├──cCrystalSubreportLinks
   │     ├──cCrystalSubreportObject
   │     ├──cCrystalSummaryFieldDefinition
   │     ├──cCrystalSummaryFieldDefinitions
   │     ├──cCrystalTableLink
   │     ├──cCrystalTableLinks
   │     ├──cCrystalTableQualifiers
   │     └──cCrystalTextObject
   ├──DfFormList_Mixin
   ├──DFListMenu_Mixin
   ├──ErrorSystem
   ├──FontDialog
   ├──HelpSystem
   ├──InetTransfer [Abstract]
   │  ├──cBaseHTTPTransfer [Abstract]
   │  │  └──cHttpTransfer
   │  │     └──cXmlHttpTransfer
   │  └──cFTPTransfer
   ├──Mixin
   │  ├──Action_Bar_Mixin
   │  ├──Auto_Locate_Mixin
   │  ├──Auto_Setup_Mixin
   │  ├──Bitmap_Support_Mixin
   │  ├──cComFont
   │  ├──cComFontEvents
   │  ├──cComPicture
   │  ├──cCrystal_ICRViewerEvents
   │  ├──cCrystalIApplication
   │  ├──cCrystalIArea
   │  ├──cCrystalIAreas
   │  ├──cCrystalIBlobFieldObject
   │  ├──cCrystalIBoxObject
   │  ├──cCrystalIConnectionProperty
   │  ├──cCrystalICRField
   │  ├──cCrystalICRFields
   │  ├──cCrystalICROleObject
   │  ├──cCrystalICrossTabGroup
   │  ├──cCrystalICrossTabGroups
   │  ├──cCrystalICrossTabObject
   │  ├──cCrystalICRVEventInfo
   │  ├──cCrystalICRVParameterPromptRuntimeOM
   │  ├──cCrystalICRVSelectionItem
   │  ├──cCrystalICRVSelectionItems
   │  ├──cCrystalICRVTrackCursorInfo
   │  ├──cCrystalICrystalDataObject
   │  ├──cCrystalICrystalReportSourceRouter
   │  ├──cCrystalICrystalReportViewer11
   │  ├──cCrystalICrystalReportViewerViewInfo
   │  ├──cCrystalICSFontDescription
   │  ├──cCrystalIDatabase
   │  ├──cCrystalIDatabaseFieldDefinition
   │  ├──cCrystalIDatabaseFieldDefinitions
   │  ├──cCrystalIDatabaseTable
   │  ├──cCrystalIDatabaseTables
   │  ├──cCrystalIExportOptions
   │  ├──cCrystalIFieldDefinitions
   │  ├──cCrystalIFieldElement
   │  ├──cCrystalIFieldElements
   │  ├──cCrystalIFieldMappingData
   │  ├──cCrystalIFieldObject
   │  ├──cCrystalIFormattingInfo
   │  ├──cCrystalIFormulaFieldDefinition
   │  ├──cCrystalIFormulaFieldDefinitions
   │  ├──cCrystalIGraphObject
   │  ├──cCrystalIGroupNameFieldDefinition
   │  ├──cCrystalIGroupNameFieldDefinitions
   │  ├──cCrystalILineObject
   │  ├──cCrystalIMapObject
   │  ├──cCrystalINameValuePairs
   │  ├──cCrystalIObjectSummaryFieldDefinitions
   │  ├──cCrystalIOlapGridObject
   │  ├──cCrystalIPage
   │  ├──cCrystalIPageEngine
   │  ├──cCrystalIPageGenerator
   │  ├──cCrystalIPages
   │  ├──cCrystalIParameterFieldDefinition
   │  ├──cCrystalIParameterFieldDefinitions
   │  ├──cCrystalIParameterValue
   │  ├──cCrystalIParameterValueInfo
   │  ├──cCrystalIParameterValueInfos
   │  ├──cCrystalIParameterValues
   │  ├──cCrystalIPrintingStatus
   │  ├──cCrystalIReport
   │  ├──cCrystalIReportAlert
   │  ├──cCrystalIReportAlertInstance
   │  ├──cCrystalIReportAlertInstances
   │  ├──cCrystalIReportAlerts
   │  ├──cCrystalIReportEvent
   │  ├──cCrystalIReportObjects
   │  ├──cCrystalIRunningTotalFieldDefinition
   │  ├──cCrystalIRunningTotalFieldDefinitions
   │  ├──cCrystalISection
   │  ├──cCrystalISectionEvent
   │  ├──cCrystalISections
   │  ├──cCrystalISortField
   │  ├──cCrystalISortFields
   │  ├──cCrystalISpecialVarFieldDefinition
   │  ├──cCrystalISQLExpressionFieldDefinition
   │  ├──cCrystalISQLExpressionFieldDefinitions
   │  ├──cCrystalISubreportLink
   │  ├──cCrystalISubreportLinks
   │  ├──cCrystalISubreportObject
   │  ├──cCrystalISummaryFieldDefinition
   │  ├──cCrystalISummaryFieldDefinitions
   │  ├──cCrystalITableLink
   │  ├──cCrystalITableLinks
   │  ├──cCrystalITableQualifiers
   │  ├──cCrystalITextObject
   │  ├──cEdit_Mixin
   │  ├──Clear_Defaults_Mixin
   │  ├──Code_Description_Mixin
   │  ├──Code_Pick_List_mixin
   │  ├──Combo_Mixin
   │  ├──cXMLDOMCollectionMixin
   │  ├──cXMLDOMMixin
   │  ├──cXMLDOMNodeMixin
   │  ├──Data_List_mixin
   │  ├──DataFile_Help_Mixin
   │  ├──dbItemMixin
   │  ├──DefaultActionButton_Mixin
   │  ├──deo_delegate_mixin
   │  ├──DEO_Dependent_item_mixin
   │  ├──dfAuto_Locate_Mixin
   │  ├──DFCode_DEO_Mixin
   │  ├──DFEntry_Radio_Group_Mixin
   │  ├──DFLabel_Mixin
   │  ├──DFnavigate_mixin
   │  ├──DFRadio_Group_Mixin
   │  ├──Entry_CheckBox_Mixin
   │  ├──Entry_Client_mixin
   │  ├──Entry_Form_DS_mixin
   │  ├──Entry_Item_Mixin
   │  ├──Entry_Shadow_Mixin
   │  ├──Entry_View_Client_mixin
   │  ├──Extended_Deo_dfCombo_mixin
   │  ├──Extended_DEO_Mixin
   │  ├──Extended_DEO_Prompt_Mixin
   │  ├──Extended_Deo_Radio_mixin
   │  ├──Extended_DEO_Spin_Mixin
   │  ├──Extended_Deo_Status_Help_Mixin
   │  ├──External_Class_Mixin
   │  ├──find_edit_mixin
   │  ├──FloatingPopupMenu_Mixin
   │  ├──Help_Mixin
   │  ├──HtmlFormat_mixin
   │  ├──HtmlWrite_mixin
   │  ├──Label_Mixin
   │  ├──list_mixin
   │  ├──Mask_Form_Mixin
   │  ├──Modal_Mixin
   │  ├──Multi_Item_Shadow_Mixin
   │  ├──navigate_mixin
   │  ├──nesting_mixin
   │  ├──Non_Dependent_item_mixin
   │  ├──NonVisual_Container_Mixin
   │  ├──Panel_Mixin
   │  ├──pick_list_mixin
   │  ├──Print_Dialog_Mixin
   │  ├──Prompt_Button_Mixin
   │  ├──ReportView_Mixin
   │  ├──RGB_Support_Temp_Mixin
   │  ├──Select_Mixin
   │  ├──Selection_List_DS_mixin
   │  ├──server_mixin
   │  ├──Shadow_Mixin
   │  ├──Single_Item_Navigate_Mixin
   │  ├──SpinForm_Mixin
   │  ├──Standard_Container_Mixin
   │  ├──Standard_Form_Mixin
   │  ├──Standard_Grid_Mixin
   │  ├──Standard_Object_Mixin
   │  ├──Standard_Select_Mixin
   │  ├──StatusHelp_Item_mixin
   │  ├──Tab_DEO_page_Mixin
   │  ├──Tab_Dialog_Mixin
   │  ├──Tab_Page_Mixin
   │  ├──Table_DS_mixin
   │  ├──Text_Window_mixin
   │  ├──TopMostMixin
   │  ├──TrackBar_Mixin
   │  ├──Validate_Mixin
   │  ├──verify_mixin
   │  ├──View_Dependent_item_mixin
   │  ├──Wide_List_mixin
   │  ├──WmlFormat_mixin
   │  └──WmlWrite_mixin
   ├──PrintDialog
   ├──Report [Abstract]
   │  └──Report_DS [Abstract]
   │     └──BasicReport
   │        ├──cWinReport2
   │        └──WinReport
   ├──StatusAsciiLog
   ├──StatusdbLog
   └──StatusPanel


Events for AboutDialog

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


Methods for AboutDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  | FloatingPanel
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for AboutDialog

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Author | The author name |
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Copyright | The copyright line |
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Logo | The bitmap logo |
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
ProductName | The name of application |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
Version | The version line |
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


AboutDialog [Property Author]

Author - AboutDialog

The author name

Type: Property

Access: Write-Only

Data Type: String

Description

The Author property states the author name. If none provided, this will be blank.

Last Edited: August 18, 2003


AboutDialog [Property Copyright]

Copyright - AboutDialog

The copyright line

Type: Property

Access: Write-Only

Data Type: String

Description

The Copyright property states the copyright line. If none provided, this will be blank.

Last Edited: August 7, 2003


AboutDialog [Property Logo]

Logo - AboutDialog

The bitmap logo

Type: Property

Access: Write-Only

Data Type: String

Description

The Logo property states the bitmap logo. If none provided, the standard VDF bitmap is used.

Last Edited: August 18, 2003


AboutDialog [Property ProductName]

ProductName - AboutDialog

The name of application

Type: Property

Access: Write-Only

Data Type: String

Description

The ProductName property states the name of application. If none provided, it uses caption-bar title.

Last Edited: September 11, 2003


AboutDialog [Property Version]

Version - AboutDialog

The version line

Type: Property

Access: Write-Only

Data Type: String

Description

The Version property states the version line. If none provided, this will be blank.

Last Edited: September 15, 2003


Events for AbstractFileDialog

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


AbstractFileDialog [Function Show_Dialog]

Show_Dialog - AbstractFileDialog

Determines how the dialog box is constructed and behaves

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The function returns true if a user enters a valid file and press the Open button. It returns false if a user presses the Cancel button, terminates the dialog, or an error occurs.

Description

The Show_Dialog function is used to pop up the Open dialog. This object's properties will determine how the dialog box is constructed and behaves.

Last Edited: September 11, 2003


Methods for AbstractFileDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Show_Dialog | Function | Determines how the dialog box is constructed and behaves |


Properties for AbstractFileDialog

View property list in hierarchical order

Name | Description | Defining Class
AllowReadOnly_State | Determines whether users without write access can select files that are read-only or in a read-only folder |
Child_Count | Returns the number of child objects the object contains | cObject
CreatePrompt_State | Determines if a message box will ask users whether they want to create the entered filename, when such filename is not found |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dialog_Caption | Sets this object's caption |
File_Name | Holds the full pathname of the file and can be considered a read-only property |
File_Title | Holds the title of the file (i.e., without path) |
FileMustExist_State | Specifies whether users can enter a file title that doesn't exist |
Filter_Index | Determines which filter you would like this object's Filter combobox to start with |
Filter_String | Holds the descriptions and filters that will be available to users |
HideReadOnly_State | Determines whether the checkbox is hidden |
Initial_Folder | Determines the starting point for this object |
Name | Returns the full name of the object including parentage | cObject
NoChangeDir_State | Restores the current directory to the original directory if the user switched the current directory while searching for files |
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
OverwritePrompt_State | Specifies whether users should be prompted before selecting a file name that already exists |
Parent | Returns the parent of an object | cObject
PathMustExist_State | Specifies whether users can enter a file path that doesn't exist |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
ShowFileTitle_State | Specifies whether the contents of the file_title property should be inserted into the dialog box as a default for selectin |
TickReadOnly_State | Checks/un-checks the Read-only checkbox |


AbstractFileDialog [Property AllowReadOnly_State]

AllowReadOnly_State - AbstractFileDialog

Determines whether users without write access can select files that are read-only or in a read-only folder

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The AllowReadOnly_State property determines whether users without write access can select files that are read-only or in a read-only folder. If this property is false, they will be informed and prompted to select another file.

Default is true.

Last Edited: January 12, 2006


AbstractFileDialog [Property CreatePrompt_State]

CreatePrompt_State - AbstractFileDialog

Determines if a message box will ask users whether they want to create the entered filename, when such filename is not found

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If CreatePrompt_State is true, a message box will ask users whether they want to create the entered filename, when such filename is not found.

In OpenDialog, default is true.
In SaveAsDialog, default is false.

Last Edited: January 12, 2006


AbstractFileDialog [Property Dialog_Caption]

Dialog_Caption - AbstractFileDialog

Sets this object's caption

Type: Property

Access: Read/Write

Data Type: String

Description

The Dialog_Caption property sets this object's caption. Windows will provide a suitable default if you do not set this property.

Last Edited: July 31, 2003


AbstractFileDialog [Property File_Name]

File_Name - AbstractFileDialog

Holds the full pathname of the file and can be considered a read-only property

Type: Property

Access: Read/Write

Data Type: String

Description

The File_Name property is set when users click the Open button to open a file. It holds the full pathname of the file and can be considered a read-only property.

Last Edited: August 18, 2003


AbstractFileDialog [Property File_Title]

File_Title - AbstractFileDialog

Holds the title of the file (i.e., without path)

Type: Property

Access: Read/Write

Data Type: String

Description

The File_Title property is set when users click the Open button to open a file. It holds the title of the file (i.e., without path). The value is maintained between calls and the property ShowFileTitle_State determines whether this object displays this value each time it is displayed.

Last Edited: August 18, 2003


AbstractFileDialog [Property FileMustExist_State]

FileMustExist_State - AbstractFileDialog

Specifies whether users can enter a file title that doesn't exist

Type: Property

Access: Read/Write

Data Type: Boolean

Description

FileMustExist_State specifies whether users can enter a file title that doesn't exist.

In OpenDialog, default is true.
In SaveAsDialog, default is false.

Last Edited: January 12, 2006


AbstractFileDialog [Property Filter_Index]

Filter_Index - AbstractFileDialog

Determines which filter you would like this object's Filter combobox to start with

Type: Property

Access: Read/Write

Data Type: Integer

Description

Set the Filter_Index property to reflect which filter you would like this object's Filter combobox to start with. The default is one, which is the first filter.

Default is 1.

Last Edited: August 18, 2003


AbstractFileDialog [Property Filter_String]

Filter_String - AbstractFileDialog

Holds the descriptions and filters that will be available to users

Type: Property

Access: Read/Write

Data Type: String

Description

The Filter_String property holds the descriptions and filters that will be available to users. The property is constructed in ordered pairs that contain the user description and the file filter to use. The property expects a "|" delimiter between each description/filter. A semi-colon delimiter can be used to provide multiple filters for one description.

Set Filter_String To "Source|*.src|Notes|*.txt|All|*.src;*.txt"

Last Edited: August 18, 2003


AbstractFileDialog [Property HideReadOnly_State]

HideReadOnly_State - AbstractFileDialog

Determines whether the checkbox is hidden

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The dialog contains a checkbox labeled Open as read-only. The HideReadOnly_State property determines whether the checkbox is hidden.

In OpenDialog, default is false.
In SaveAsDialog, default is true.

Last Edited: January 12, 2006


AbstractFileDialog [Property Initial_Folder]

Initial_Folder - AbstractFileDialog

Determines the starting point for this object

Type: Property

Access: Read/Write

Data Type: String

Description

The Initial_Folder property determines the starting point for this object. If no value is assigned, Windows will provide the starting point.

Default is current folder.

Last Edited: August 18, 2003


AbstractFileDialog [Property NoChangeDir_State]

NoChangeDir_State - AbstractFileDialog

Restores the current directory to the original directory if the user switched the current directory while searching for files

Type: Property

Access: Read/Write

Data Type: Boolean

Description

NoChangeDir_State restores the current directory to the original directory if the user switched the current directory while searching for files.

Default is false.

Last Edited: January 12, 2006


AbstractFileDialog [Property OverwritePrompt_State]

OverwritePrompt_State - AbstractFileDialog

Specifies whether users should be prompted before selecting a file name that already exists

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The OverwritePrompt_State property specifies whether users should be prompted before selecting a file name that already exists.

Default is true.

Last Edited: January 12, 2006


AbstractFileDialog [Property PathMustExist_State]

PathMustExist_State - AbstractFileDialog

Specifies whether users can enter a file path that doesn't exist

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The PathMustExist_State property specifies whether users can enter a file path that doesn't exist.

Default is true.

Last Edited: January 12, 2006


AbstractFileDialog [Property ShowFileTitle_State]

ShowFileTitle_State - AbstractFileDialog

Specifies whether the contents of the file_title property should be inserted into the dialog box as a default for selectin

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The ShowFileTitle_State property specifies whether the contents of the file_title property should be inserted into the dialog box as a default for selecting.

In OpenDialog, default is false.
In SaveAsDialog, default is true.

Last Edited: January 12, 2006


AbstractFileDialog [Property TickReadOnly_State]

TickReadOnly_State - AbstractFileDialog

Checks/un-checks the Read-only checkbox

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The TickReadOnly_State property is used to check/un-check the Read-only checkbox; it can be set by the program and is updated automatically if users toggle its state.

Default is false.

Last Edited: January 12, 2006


Events for AbstractShapeControl

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for AbstractShapeControl

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for AbstractShapeControl

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Shape_Back_Color | Maintains the RGB color of the object's background that is visible beyond the boundaries of the GDI object |
Shape_Fill_Color | Maintains the RGB value of the "brush" to use to fill the object |
Shape_Pen_Color | Maintains the RGB color value that the object's pen will use |
Shape_Pen_Style | Specifies the style of pen that Windows will use to draw the object |
Shape_Pen_Width | Maintains the width of the pen to use |
Shape_Style | Determines which GDI object to draw in the container area |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


AbstractShapeControl [Property Shape_Back_Color]

Shape_Back_Color - AbstractShapeControl

Maintains the RGB color of the object's background that is visible beyond the boundaries of the GDI object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Shape_Back_Color property maintains the RGB color of the object's background that is visible beyond the boundaries of the GDI object.

Last Edited: September 11, 2003


AbstractShapeControl [Property Shape_Fill_Color]

Shape_Fill_Color - AbstractShapeControl

Maintains the RGB value of the "brush" to use to fill the object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Shape_Fill_Color property maintains the RGB value of the "brush" to use to fill the object.

Last Edited: September 11, 2003


AbstractShapeControl [Property Shape_Pen_Color]

Shape_Pen_Color - AbstractShapeControl

Maintains the RGB color value that the object's pen will use

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Shape_Pen_Color property maintains the RGB color value that the object's pen will use.

Last Edited: September 11, 2003


AbstractShapeControl [Property Shape_Pen_Style]

Shape_Pen_Style - AbstractShapeControl

Specifies the style of pen that Windows will use to draw the object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Shape_Pen_Style property is used to specify the style of pen that Windows will use to draw the object. PS_NULL means that no pen should be used. PS_INSIDEFRAME is used for pen widths greater than one, and draws the entire pen line within the object.

Default is PS_SOLID.

Last Edited: September 11, 2003


AbstractShapeControl [Property Shape_Pen_Width]

Shape_Pen_Width - AbstractShapeControl

Maintains the width of the pen to use

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Shape_Pen_Width property maintains the width of the pen to use. The value is in logical units, which is equivalent to pixels in the GDI map mode of MM_TEXT, which is the default.

Default is 1.

Last Edited: September 11, 2003


AbstractShapeControl [Property Shape_Style]

Shape_Style - AbstractShapeControl

Determines which GDI object to draw in the container area

Type: Property

Access: Read/Write

Data Type: Integer

Description

Shape_Style determines which GDI object to draw in the container area. shSquare and shCircle draw themselves maintaining the aspect ratio by using an equal size of the smaller dimension. shRectangle and shEllipse utilize the whole container area and stretch themselves appropriately.

Default is shRectangle.

Last Edited: September 11, 2003


AbstractTreeView [Event OnBeginDrag]

OnBeginDrag - AbstractTreeView

Whenever a user instigates a drag operation, this event is fired

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | The handle of the item that the user began the drag operation on

Description

Whenever a user instigates a drag operation, the OnBeginDrag event is fired. Note that the control does not have any drag-and-drop operations built-in, so it is your responsibility to perform the necessary operations using this event to trigger the beginning of the drag. A drag event is presumed to have begun whenever the user clicks and holds down the left mouse button and proceeds to move the mouse with the button still depressed.

Last Edited: September 10, 2003


AbstractTreeView [Event OnBeginLabelEdit]

OnBeginLabelEdit - AbstractTreeView

Fired just prior to the user starting in-line editing of the label

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | The item handle

Description

If a user performs in-line editing of the label (the TreeEditLabelsState property must be true), the OnBeginLabelEdit event will be fired just prior to the user starting the editing.

The developer may cancel an edit by setting the property pbCancelEdit to true.

The existing label value can be obtained by using the ItemLabel method.

Procedure OnBeginLabelEdit Handle hItem
   handle hRoot
   // if we are editing the root, don't allow and declare an error
   Get RootItem to hRoot
   If (hItem=hRoot) begin
       set pbCancelEdit to True
       Error DFERR_OPERATOR "Cannot change the root Label"
   end
End_Procedure

Procedure OnEndLabelEdit Handle hItem String sNewLabel Boolean bWasCanceled
   string sOriginalLabel
   if not bWasCanceled begin
       // get old value of the label
       Get ItemLabel hItem to sOriginalLabel
       // don't allow edit to be blank
       If (sNewLabel="") Begin
            set pbCancelEdit to True
            Error DFERR_OPERATOR "Blank labels not allowed"
       end
       else If (sOriginalLabel=sNewLabel) begin
            // if no change, complain
            Error DFERR_OPERATOR "You did not change anything"
       end
   End
   else begin
      // This really isn't an error, but you get the idea
      Error DFERR_OPERATOR "canceled by User"
   end
End_Procedure

See Also

OnEndLabelEdit | pbCancelEdit | TreeEditLabelsState | ItemLabel

Last Edited: July 30, 2004


AbstractTreeView [Event OnBeginRDrag]

OnBeginRDrag - AbstractTreeView

Whenever the user instigates a drag operation, this event is fired

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | The handle of the item that the user began the drag operation on

Description

Whenever the user instigates a drag operation, the OnBeginRDrag event is fired. Note that the control does not have any drag-and-drop operations built-in, so it is your responsibility to perform the necessary operations using this event to trigger the beginning of the drag. A drag event is presumed to have begun whenever a user clicks and holds down the right mouse button and proceeds to move the mouse with the button still depressed.

Last Edited: September 10, 2003


AbstractTreeView [Event OnDeleteItem]

OnDeleteItem - AbstractTreeView

Whenever an item is deleted from the control, this event is fired

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | The handle of the item to be deleted

Description

Whenever an item is deleted from the control, the OnDeleteItem event is fired. It is received just prior to deletion, to give you the opportunity to perform any related cleanup.

Last Edited: September 10, 2003


AbstractTreeView [Event OnEndLabelEdit]

OnEndLabelEdit - AbstractTreeView

Fired if the user completes the edit when user performs in-line editing of the label

Type: Event

Parameters: Handle hItem String sNewLabel Boolean bWasCanceled

Parameter | Description
hItem | The item handle
sNewLabel | The new label value
bWasCanceled | Returns true if the edit was canceled by the user

Description

If a user performs in-line editing of the label (the TreeEditLabelsState property must be true), the OnEndLabelEdit event will be fired if the user completes the edit.

bWasCanceled determines how the edit was terminated. If True, the user canceled the edit (this is also returned True if no edit was made - this is how windows does it).

If the edit was not canceled by the user, the developer may force a cancel by setting the property pbCancelEdit to true.

The new label value is passed as a parameter. The existing label value can be obtained by using the ItemLabel method.

Procedure OnBeginLabelEdit Handle hItem
   handle hRoot
   // if we are editing the root, don't allow and declare an error
   Get RootItem to hRoot
   If (hItem=hRoot) begin
       set pbCancelEdit to True
       Error DFERR_OPERATOR "Cannot change the root Label"
   end
End_Procedure

Procedure OnEndLabelEdit Handle hItem String sNewLabel Boolean bWasCanceled
   string sOriginalLabel
   if not bWasCanceled begin
       // get old value of the label
       Get ItemLabel hItem to sOriginalLabel
       // don't allow edit to be blank
       If (sNewLabel="") Begin
            set pbCancelEdit to True
            Error DFERR_OPERATOR "Blank labels not allowed"
       end
       else If (sOriginalLabel=sNewLabel) begin
            // if no change, complain
            Error DFERR_OPERATOR "You did not change anything"
       end
   End
   else begin
      // This really isn't an error, but you get the idea
      Error DFERR_OPERATOR "canceled by User"
   end
End_Procedure

See Also

OnBeginLabelEdit | pbCancelEdit | TreeEditLabelsState | ItemLabel

Last Edited: July 30, 2004


AbstractTreeView [Event OnGetDispInfo]

OnGetDispInfo - AbstractTreeView

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | [ToDo: In Progress]

Description

Last Edited: July 30, 2004


AbstractTreeView [Event OnItemChanged]

OnItemChanged - AbstractTreeView

Fired whenever the current item has just changed

Type: Event

Parameters: Handle hItem Handle hItemOld

Parameter | Description
hItem | The item that has become the current item
hItemOld | The item that was the current item

Description

The OnItemChanged event is fired whenever the current item has just changed.

Last Edited: September 10, 2003


AbstractTreeView [Event OnItemChanging]

OnItemChanging - AbstractTreeView

Fired whenever the current item is about to change

Type: Event

Parameters: Handle hItem Handle hItemOld

Parameter | Description
hItem | The item that will become the current item
hItemOld | The item that is the current item, but is about to lose the focus

Description

The OnItemChanging event is fired whenever the current item is about to change.

Last Edited: September 10, 2003


AbstractTreeView [Event OnItemClick]

OnItemClick - AbstractTreeView

Fired whenever a user clicks an item to make it become the current item

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | The item handle

Description

The OnItemClick event is fired whenever a user clicks an item to make it become the current item.

Last Edited: September 10, 2003


AbstractTreeView [Event OnItemCollapsed]

OnItemCollapsed - AbstractTreeView

Fired whenever a parent item has just been collapsed and its children hidden

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | The item handle

Description

The OnItemCollapsed event is fired whenever a parent item has just been collapsed and its children hidden. You can use this event to delete any child items you may have created during OnItemExpanding.

Last Edited: September 10, 2003


AbstractTreeView [Event OnItemCollapsing]

OnItemCollapsing - AbstractTreeView

Fired whenever a parent item is about to be collapsed

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | The item handle

Description

The OnItemCollapsing event is fired whenever a parent item is about to be collapsed.

Last Edited: September 10, 2003


AbstractTreeView [Event OnItemDblClick]

OnItemDblClick - AbstractTreeView

Fired whenever a user double-clicks an item

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | The handle of the item that is double-clicked

Description

The OnItemDblClick event is fired whenever a user double-clicks an item. The item becomes the current item just prior to this event being received.

Last Edited: September 10, 2003


AbstractTreeView [Event OnItemEnter]

OnItemEnter - AbstractTreeView

Fired whenever a user presses Enter on an item

Type: Event

Parameters: No Parameters

Description

The OnItemEnter event is fired whenever a user presses Enter on an item. Use Get CurrentTreeItem to discover which is the current item.

Last Edited: September 10, 2003


AbstractTreeView [Event OnItemExpanded]

OnItemExpanded - AbstractTreeView

Fired whenever a parent item has just been expanded to display its child items

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | The handle of the item that has been expanded

Description

The OnItemExpanded event is fired whenever a parent item has just been expanded to display its child items.

Last Edited: September 10, 2003


AbstractTreeView [Event OnItemExpanding]

OnItemExpanding - AbstractTreeView

Fired whenever an item is about to be opened

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | The handle of the item that is about to be opened

Description

The OnItemExpanding event is fired whenever an item is about to be opened. This event is fired before OnItemExpanded, and can be used as the trigger to create or delete child items.

Last Edited: September 10, 2003


AbstractTreeView [Event OnItemRClick]

OnItemRClick - AbstractTreeView

Sent when a user clicks on an item

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | The item that was clicked

Description

A user has clicked the item represented by hItem with the right mouse button.

Last Edited: September 10, 2003


AbstractTreeView [Event OnItemRDblClick]

OnItemRDblClick - AbstractTreeView

Sent when a user double-clicks on an item

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | The item that was double-clicked

Description

A user has double-clicked the item represented by hItem with the right mouse button.

Last Edited: September 10, 2003


AbstractTreeView [Event OnKeyDown]

OnKeyDown - AbstractTreeView

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


AbstractTreeView [Event OnSetDispInfo]

OnSetDispInfo - AbstractTreeView

Type: Event

Parameters: Handle hItem

Parameter | Description
hItem | [ToDo: In Progress]

Description

Last Edited: July 30, 2004


Events for AbstractTreeView

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginDrag | Whenever a user instigates a drag operation, this event is fired |
OnBeginLabelEdit | Fired just prior to the user starting in-line editing of the label |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | List
OnBeginRDrag | Whenever the user instigates a drag operation, this event is fired |
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | List
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeleteItem | Whenever an item is deleted from the control, this event is fired |
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnEndLabelEdit | Fired if the user completes the edit when user performs in-line editing of the label |
OnGetDispInfo |  |
OnItemChanged | Fired whenever the current item has just changed |
OnItemChanging | Fired whenever the current item is about to change |
OnItemClick | Fired whenever a user clicks an item to make it become the current item |
OnItemCollapsed | Fired whenever a parent item has just been collapsed and its children hidden |
OnItemCollapsing | Fired whenever a parent item is about to be collapsed |
OnItemDblClick | Fired whenever a user double-clicks an item |
OnItemEnter | Fired whenever a user presses Enter on an item |
OnItemExpanded | Fired whenever a parent item has just been expanded to display its child items |
OnItemExpanding | Fired whenever an item is about to be opened |
OnItemRClick | Sent when a user clicks on an item |
OnItemRDblClick | Sent when a user double-clicks on an item |
OnKeyDown |  |
OnKillFocus | Sent whenever the object is about to lose the focus | List
OnSetDispInfo |  |
OnSetFocus | Sent whenever windows is about to give this object the focus | List
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | List
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | List


AbstractTreeView [Function AddTreeItem]

AddTreeItem - AbstractTreeView

Adds an entry to the treeview

Type: Function

Return Data Type: Handle

Parameters: String sValue Handle hParent Integer iItemData Integer iImage Integer iSelImage

Parameter | Description
sValue | The text you want displayed for the item
hParent | The handle of the item that you want as the parent of this item (pass 0 to create an item with no parent - a root item)
iItemData | A user-defined 32-bit integer you want to associate with the item
iImage | The index of an image in the associated ImageList (which you need to create separately) that will be displayed alongside the item whenever it is not the current-item
iSelImage | The index of an image in the associated ImageList that will be displayed alongside the item whenever it is the current item

Return Value

The returned handle of the first item added (the root item) is stored and used as the parent handle in the two subsequent items that are added.

Description

AddTreeItem is used to add a node to a treeview.

Enumeration_List
    Define tiFood
    Define tiCake
    Define tiSteak
End_Enumeration_List

Get AddTreeItem "Food"  0         tiFood  0 1 To hItemRoot
Get AddTreeItem "Cake"  hItemRoot tiCake  2 3 To hItemCake
Get AddTreeItem "Steak" hItemRoot tiSteak 4 5 To hItemSteak

This example creates a root item and adds two children to it. Notice how a symbol is used to associate with the items added. By doing this, we can identify items later (items do not have an index position in the list). We are assuming here that six images have been added into the object's ImageList object (Indexes 0-5). The first image (Index 0) is used for the Food item and the second image is also used for this item, but only when it becomes the current item.

Last Edited: July 30, 2003


AbstractTreeView [Function InsertTreeItem]

InsertTreeItem - AbstractTreeView

Type: Function

Return Data Type: Handle

Parameters: String sValue Handle hParent Handle hInsertAfter Integer iItemData Integer iImage Integer iSelImage

Parameter | Description
sValue | [ToDo: In Progress]
hParent | [ToDo: In Progress]
hInsertAfter | [ToDo: In Progress]
iItemData | [ToDo: In Progress]
iImage | [ToDo: In Progress]
iSelImage | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for AbstractTreeView

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | List
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
AddTreeItem | Function | Adds an entry to the treeview |
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | List
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | List
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoDeleteItem | Procedure | Deletes an item |
DoEnumerateTree | Procedure | Recurses the items in the control starting with the item you pass, hItem |
DoEnumerateTreeUp | Procedure | Recurses the items in the control starting with the item you pass, hItem |
DoHtmlHelp | Procedure | Launches Compiled HTML Help | List
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | List
Error_Help | Procedure | (Obsolete) | List
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | List
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | List
Help | Procedure |  | List
Help_For_Help | Procedure | (Obsolete) | List
Help_Index | Procedure | (Obsolete) | List
Help_on_topic | Procedure | (Obsolete) | List
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
InsertTreeItem | Function |  |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | List
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | List
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | List
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | List
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set |  | List
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | List
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


AbstractTreeView [Procedure DoDeleteItem]

DoDeleteItem - AbstractTreeView

Deletes an item

Type: Procedure

Parameters: Handle hItem

Parameter | Description
hItem | The handle of the item to be deleted

Description

Send the DoDeleteItem message to delete an item. If the item has children, then they too will be deleted.

Last Edited: July 31, 2003


AbstractTreeView [Procedure DoEnumerateTree]

DoEnumerateTree - AbstractTreeView

Recurses the items in the control starting with the item you pass, hItem

Type: Procedure

Parameters: Integer iMsg Handle hItem Integer iRecurseLevel

Parameter | Description
iMsg | The message whose message-id you pass
hItem | The item you pass
iRecurseLevel | The starting level as you want to identify it

Description

DoEnumerateTree is an advanced procudure. It recurses the items in the control starting with the item you pass, hItem. The procedure will traverse all items that are children of the item you pass. It will find the first child and look for its children and its siblings and so on until all child items have been found. For each item that is found, it will send a message to the message whose message-id you pass as the iMsg parameter. You would normally pass zero as the iRecurseLevel, as this represents the starting level as you want to identify it. You can pass any value you want, and it will be incremented for each level of recursion and passed on to the message you have defined. The procedure whose message ID you pass, should take two parameters: a Handle to hold the handle of the item found, and an Integer to hold the recurse level of the item, which will be relative to iRecurseLevel.

This procedure is used internally, but is not defined as Private, as there may be times when it will be very useful.

See Also

DoEnumerateTreeUp

Last Edited: June 23, 2005


AbstractTreeView [Procedure DoEnumerateTreeUp]

DoEnumerateTreeUp - AbstractTreeView

Recurses the items in the control starting with the item you pass, hItem

Type: Procedure

Parameters: Integer iMsg Handle hItem Integer iRecurseLevel

Parameter | Description
iMsg | A message to the object whose message ID you pass
hItem | The item you pass
iRecurseLevel | The starting level as you want to identify it

Description

DoEnumerateTreeUp is an advanced procudure. It recurses the items in the control starting with the item you pass, hItem. The procudure will traverse all items that are children of the item you pass. It will find the first child and look for its children and its siblings and so on until all child items have been found. For each item that is found, it will send a message to the object whose message ID you pass as iMsg. This procudure differs to DoEnumerateTree, in that it searches the tree from the bottom, not the top. You would normally pass zero as the iRecurseLevel, as this represents the starting level as you want to identify it. You can pass any value you want, and it will be incremented for each level of recursion and passed on to the message you have defined. The procudure whose message ID you pass, should take two parameters: a Handle to hold the handle of the item found and an Integer to hold the recurse level of the item, which will be relative to the iRecurseLevel parameter.

This procudure is used internally, but is not defined as Private, as there may be times when it will be very useful.

See Also

DoEnumerateTree

Last Edited: June 22, 2005


Properties for AbstractTreeView

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentTreeItem | Gets or sets the handle of the item that is currently selected |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | List
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
ExpandedOnceState | Returns a boolean value of true if hItem has been expanded since it was created |
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | List
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | List
Help_Keyword | Used to specify an object's context keyword | List
ImageListObject | Uses an ImageList control to supply the images that each item displays |
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled | List
ItemChildCount | Getting this property returns whether there are childitems |
ItemData | Stores an application-specific value |
ItemImage | Gets and sets the index of the regular image in the control's ImageList |
ItemLabel | Sets label that is displayed alongside the image |
ItemSelectedImage | Gets and sets the index of the selected image in the control's ImageList that you associated with the item |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | List
Label_Col_Offset | The horizontal distance from the object to its label | List
Label_Justification_Mode | The justification mode for the text within this object's label | List
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | List
Label_Row_Offset | The vertical distance from the top edge of the object and its label | List
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | List
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbCancelEdit | Used in OnBeginLabelEdit and OnEndLabelEdit to cancel the editing of a treeview label |
pbFullRowSelect | Enables full-row selection in the treeview |
pbHotTracking | automatically highlights an item when the mouse hovers over it |
pbShowTooltips | Determines if a tool tip should be displayed when the mouse hovers over a long tip |
pbSingleExpand | Determines if item being selected will collapse if it was expanded, or expand if it was collapsed |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piBackColor | Controls the color of the background of the treeview |
piLineColor | Controls the color of the lines drawn in the treeview |
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piTextColor | Controls the color of text in the items of the treeview |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | List
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count |  | List
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State |  | List
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | List
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
TreeButtonsState | Determines if button will be displayed |
TreeEditLabelsState | Supports in-line editing of the label |
TreeIndentWidth | Governs the number of pixels that are used to indent child items from their parent items |
TreeLevelDelimeter | Holds the character to use as a delimiter of tree levels |
TreeLinesState | Determines if the control draws graphical lines between connecting items |
TreeRetainSelState | Determines if item will still visibly indicate that it was the focused item, whenever this object loses the focus |
TreeRootLinesState | Specifies whether graphical lines should be drawn to connect "Root Items" |
TreeSortedState |  |
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | List
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


AbstractTreeView [Property CurrentTreeItem]

CurrentTreeItem - AbstractTreeView

Gets or sets the handle of the item that is currently selected

Type: Property

Access: Read/Write

Data Type: Handle

Description

CurrentTreeItem gets or sets the handle of the item that is currently selected. The hItem parameter, this represents the item handle of an existing item to be made the current item. You can change the current item by setting this property. Getting this returns the handle of the item that is currently selected.

Last Edited: June 22, 2005


AbstractTreeView [Property ExpandedOnceState]

ExpandedOnceState - AbstractTreeView

Returns a boolean value of true if hItem has been expanded since it was created

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Handle hItem Integer bNotify

Parameter | Description
hItem | The item handle
bNotify | True if hItem has been expanded, false if not

Description

Each item in the control that has children maintains a flag indicating whether the item has been expanded to display its children. The ExpandedOnceState property returns a boolean value of true if hItem has been expanded since it was created. You can use the ItemChildCount property to determine whether the item has any children.

Last Edited: August 5, 2003


AbstractTreeView [Property ImageListObject]

ImageListObject - AbstractTreeView

Uses an ImageList control to supply the images that each item displays

Type: Property

Access: Read/Write

Data Type: Integer

Description

The ImageListObject object uses a cImageList control to supply the images that each item displays. You will need to create a cImageList control and assign its object ID to this property.

Last Edited: August 18, 2003


AbstractTreeView [Property ItemChildCount]

ItemChildCount - AbstractTreeView

Getting this property returns whether there are childitems

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Handle hItem Integer icChildren

Parameter | Description
hItem | The item handle
icChildren | 0 if no child items exist, 1 if child items do exist

Description

Getting the ItemChildCount property returns whether there are childitems.

Setting this property is an advanced interface method. It is possible to "trick" the control into thinking that an item has child items. By doing this, an item will be displayed as though it had child items (that is, it will have a box with a plus sign next to it). When users click the box to open it, an OnItemExpanding event will be fired. You can use this event to dynamically add items that will then be displayed. If you do not add any items, the box indicating children will disappear.

Last Edited: June 4, 2004


AbstractTreeView [Property ItemData]

ItemData - AbstractTreeView

Stores an application-specific value

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Handle hItem Integer iData

Parameter | Description
hItem | The item handle
iData | The data number

Description

Each item in the control can have a 32-bit integer associated with it. You can use ItemData to store an application-specific value such as a record number or object ID, etc. This property gets and sets the value you associated with the hItem.

Last Edited: August 18, 2003


AbstractTreeView [Property ItemImage]

ItemImage - AbstractTreeView

Gets and sets the index of the regular image in the control's ImageList

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Handle hItem Integer iImage

Parameter | Description
hItem | The item handle
iImage | The zero-based index of the image in the associated ImageList object to be used when hItem is the current item

Description

Each item in the control can have two images associated with it: a regular image for the item, and a different image for whenever the item is the current item. The ItemImage property gets and sets the index of the regular image in the control's cImageList. This may also be set using the Get AddTreeItem method (compare: ItemSelectedImage property).

Last Edited: August 18, 2003


AbstractTreeView [Property ItemLabel]

ItemLabel - AbstractTreeView

Sets label that is displayed alongside the image

Type: Property

Access: Read/Write

Data Type: String

Parameters: Handle hItem String sText

Parameter | Description
hItem | The item handle
sText | A text value that describes the item

Description

Each item in the control has a label that is displayed alongside the image. You can set the label with either the Set ItemLabel or Get AddTreeItem methods.

Last Edited: August 18, 2003


AbstractTreeView [Property ItemSelectedImage]

ItemSelectedImage - AbstractTreeView

Gets and sets the index of the selected image in the control's ImageList that you associated with the item

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Handle hItem Integer iImage

Parameter | Description
hItem | The item handle
iImage | The zero-based index of the image in the associated ImageList object to be used when the item is the current item

Description

Each item in the control can have two images associated with it: a regular image for the item, and a different image for whenever the item is the current item. The ItemSelectedImage property gets and sets the index of the selected image in the control's cImageList that you associated with the item. This may also be set using the Get AddTreeItem method (compare: ItemImage property).

Last Edited: August 18, 2003


AbstractTreeView [Property pbCancelEdit]

pbCancelEdit - AbstractTreeView

Used in OnBeginLabelEdit and OnEndLabelEdit to cancel the editing of a treeview label

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbCancelEdit is used in OnBeginLabelEdit and OnEndLabelEdit to cancel the editing of a treeview label. Before either of these events are called, pbCancelEdit is always set False. If the developer sets this property to True, the edit will be cancelled.

Procedure OnBeginLabelEdit Handle hItem
   handle hRoot
   // if we are editing the root, don't allow and declare an error
   Get RootItem to hRoot
   If (hItem=hRoot) begin
       set pbCancelEdit to True
       Error DFERR_OPERATOR "Cannot change the root Label"
   end
End_Procedure

Procedure OnEndLabelEdit Handle hItem String sNewLabel Boolean bWasCanceled
   string sOriginalLabel
   if not bWasCanceled begin
       // get old value of the label
       Get ItemLabel hItem to sOriginalLabel
       // don't allow edit to be blank
       If (sNewLabel="") Begin
            set pbCancelEdit to True
            Error DFERR_OPERATOR "Blank labels not allowed"
       end
       else If (sOriginalLabel=sNewLabel) begin
            // if no change, complain
            Error DFERR_OPERATOR "You did not change anything"
       end
   End
   else begin
      // This really isn't an error, but you get the idea
      Error DFERR_OPERATOR "canceled by User"
   end
End_Procedure

See Also

OnBeginLabelEdit | OnEndLabelEdit | TreeEditLabelsState | ItemLabel

Last Edited: July 30, 2004


AbstractTreeView [Property pbFullRowSelect]

pbFullRowSelect - AbstractTreeView

Enables full-row selection in the treeview

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbFullRowSelect enables full-row selection in the treeview. The entire row of the selected item is highlighted, and clicking anywhere on an item's row will cause it to be selected.

Note: Setting this property to True causes the TreeLinesState to be set False, as the two styles cannot be used together.

Default is false.

Last Edited: January 12, 2006


AbstractTreeView [Property pbHotTracking]

pbHotTracking - AbstractTreeView

automatically highlights an item when the mouse hovers over it

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbHottracking automatically highlights an item when the mouse hovers over it.

Default is false.

Last Edited: January 12, 2006


AbstractTreeView [Property pbShowTooltips]

pbShowTooltips - AbstractTreeView

Determines if a tool tip should be displayed when the mouse hovers over a long tip

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the mouse hovers over on item that it too wide to be fully visible within the treeview, a tooltip will automatically display the full text of the item. Set the pbShowTooltips property to False, to prevent the tooltip from being shown.

Default is true.

Last Edited: January 12, 2006


AbstractTreeView [Property pbSingleExpand]

pbSingleExpand - AbstractTreeView

Determines if item being selected will collapse if it was expanded, or expand if it was collapsed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the pbSingleExpand is property is set to True, changing the selection will automatically cause the item being selected to collapse if it was expanded, or expand if it was collapsed. The unselected item will collapse. If the user holds the CTRL key down while selecting an item, the item being unselected will not be collapsed.

Default is false.

Last Edited: January 12, 2006


AbstractTreeView [Property piBackColor]

piBackColor - AbstractTreeView

Controls the color of the background of the treeview

Type: Property

Access: Read/Write

Data Type: Integer

Description

piBackColor controls the color of the background of the treeview. Set this property to any valid color. When set to clNone, Windows provides the color automatically.

Default is clNone.

Last Edited: September 11, 2003


AbstractTreeView [Property piLineColor]

piLineColor - AbstractTreeView

Controls the color of the lines drawn in the treeview

Type: Property

Access: Read/Write

Data Type: Integer

Description

piLineColor controls the color of the lines drawn in the treeview. Set this property to any valid color. When set to clDefault, Windows provides the color automatically.

Default is clDefault.

Last Edited: September 11, 2003


AbstractTreeView [Property piTextColor]

piTextColor - AbstractTreeView

Controls the color of text in the items of the treeview

Type: Property

Access: Read/Write

Data Type: Integer

Description

piTextColor controls the color of text in the items of the treeview. Set this property to any valid color. When set to clNone, Windows provides the color automatically.

Default is clNone.

Last Edited: September 11, 2003


AbstractTreeView [Property TreeButtonsState]

TreeButtonsState - AbstractTreeView

Determines if button will be displayed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

For each item that has child items, a small button is displayed that users can use to expand or collapse the child items. The button will display a + symbol, meaning users can expand the tree; if the item is already expanded, the button will display . If you set this property to false, the button will not be displayed, regardless of whether the item has any child items.

Default is true.

Last Edited: January 12, 2006


AbstractTreeView [Property TreeEditLabelsState]

TreeEditLabelsState - AbstractTreeView

Supports in-line editing of the label

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The TreeEditLabelsState object supports in-line editing of the label. The manner that this is initiated is governed by the operating system, but is usually by clicking the item twice without moving the mouse, or clicking an item and pressing F2. Set this property to true to permit the in-line changing of items' labels.

Default is false.

Last Edited: January 12, 2006


AbstractTreeView [Property TreeIndentWidth]

TreeIndentWidth - AbstractTreeView

Governs the number of pixels that are used to indent child items from their parent items

Type: Property

Access: Read/Write

Data Type: Integer

Description

Use the TreeIndentWidth property to govern the number of pixels that are used to indent child items from their parent items. This value is used by all items and cannot be changed once the control becomes visible.

Default is 15 pixels.

Last Edited: September 11, 2003


AbstractTreeView [Property TreeLevelDelimeter]

TreeLevelDelimeter - AbstractTreeView

Holds the character to use as a delimiter of tree levels

Type: Property

Access: Read/Write

Data Type: String

Description

The TreeLevelDelimiter property holds the character to use as a delimiter of tree levels. It is used by the ItemFullPath function and the DoReadTree method.

Default is /.

Last Edited: September 11, 2003


AbstractTreeView [Property TreeLinesState]

TreeLinesState - AbstractTreeView

Determines if the control draws graphical lines between connecting items

Type: Property

Access: Read/Write

Data Type: Boolean

Description

By default, the control draws graphical lines between connecting items (compare TreeRootLinesState property). Set this property to false if you do not want lines drawn.

Note: Setting this property to True causes the pbFullRowSelect to be set False, as the two styles cannot be used together.

Default is true.

Last Edited: January 12, 2006


AbstractTreeView [Property TreeRetainSelState]

TreeRetainSelState - AbstractTreeView

Determines if item will still visibly indicate that it was the focused item, whenever this object loses the focus

Type: Property

Access: Read/Write

Data Type: Boolean

Description

In its default state, whenever this object loses the focus, the currently selected item will lose its focus highlight. By setting this property to true, the current item will still visibly indicate that it was the focused item, whenever this object loses the focus.

Default is false.

Last Edited: January 12, 2006


AbstractTreeView [Property TreeRootLinesState]

TreeRootLinesState - AbstractTreeView

Specifies whether graphical lines should be drawn to connect "Root Items"

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The parent-most items in the this object (that is, items that have no parent), are known as "Root Items". This property specifies whether graphical lines should be drawn to connect these items (compare TreeLinesState property).

Default is true.

Last Edited: January 12, 2006


AbstractTreeView [Property TreeSortedState]

TreeSortedState - AbstractTreeView

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


Events for AppClientArea

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus |  | MdiClientArea
OnSetFocus |  | MdiClientArea
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


AppClientArea [Function Next_Mdi_Dialog]

Next_Mdi_Dialog - AppClientArea

Provides a way to obtain the object ID of all views contained by this container

Type: Function

Return Data Type: Integer

Parameters: Integer FindFirst

Parameter | Description
FindFirst | If True, find the first Mdi dialog. If False, find the next dialog

Return Value

Description

This function provides a way to obtain the object ID of all views contained by this object. If FindFirst is true, the object handle of the first child is returned. If FindFirst is false, the next handle is returned. A zero is returned after the last handle has been processed. Note that child-object handles are returned regardless of whether the object is active.

Function Verify_Exit_application Returns Integer
    Boolean bErr
    Handle hoView
    Get Next_Mdi_Dialog True to hoView // find first
    While (hoView and not(bErr))
        Get Verify_Exit_application of hoView to bErr
        If not bErr begin
            Get Next_Mdi_Dialog False to hoView // find next
        End
    End
    function_return bErr
End_Function

Last Edited: July 30, 2004


Methods for AppClientArea

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Arrange_Icons | Procedure | Arranges the icons for all minimized views contained by this object | DfBasemdiclient
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
Cascade_Windows | Procedure | Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it | DfBasemdiclient
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | MdiClientArea
Error_Help | Procedure | (Obsolete) | MdiClientArea
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | MdiClientArea
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | MdiClientArea
Help | Procedure |  | MdiClientArea
Help_For_Help | Procedure | (Obsolete) | MdiClientArea
Help_Index | Procedure | (Obsolete) | MdiClientArea
Help_on_topic | Procedure | (Obsolete) | MdiClientArea
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | MdiClientArea
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Mdi_Dialog | Function | Provides a way to obtain the object ID of all views contained by this container |
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Next_View | Procedure | Switches the focus to the next view object in this object | DfBasemdiclient
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Switch_Prior_View | Procedure | Switches the focus to the previous view object in this object | DfBasemdiclient
Tile_Windows_Horizontal | Procedure | Arranges this object's views from left to right across the top, and then down to the next line, also so arranged | DfBasemdiclient
Tile_Windows_Vertical | Procedure | Arranges this object's views from top to bottom down the left side, and then right to the next column, also so arranged | DfBasemdiclient
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for AppClientArea

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | MdiClientArea
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | MdiClientArea
Help_Keyword | Used to specify an object's context keyword | MdiClientArea
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | MdiClientArea
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Scroll_Bar_Visible_State | Specifies whether this object is to display a scroll bar (or bars) when the content of the object exceeds this object's same-time display capacity | DfBasemdiclient
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


AppDialog [Event Notify_Exit_Application]

Notify_Exit_Application - AppDialog

Called when an application is about to be closed

Type: Event

Parameters: No Parameters

Description

Notify_exit_application is called when an application is about to be closed. This does nothing by default. It is a notification hook intended for augmentation.

Last Edited: September 10, 2003


AppDialog [Event Verify_Exit_Application]

Verify_Exit_Application - AppDialog

Sent by the client area to verify that an application may be exited

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

If a non-zero value is returned, the program will not be exited.

Description

Verify_exit_application is sent by the client area to verify that an application may be exited.

This checks if the view is changed (by calling view_changed) and if changed, it presents a verification message giving the user the choice to exit the application. This can be augmented to change the verification message or to control exit verification. The following sample will always ask if a view should be closed.

Function Verify_Exit_Application returns integer
    integer iFail
    // confirm returns 1 if NO and 0 if yes
    Get Confirm ("Are you sure you wish to exit " + Label(Self)) to iFail
    Function_Return iFail
End_Function

Last Edited: August 6, 2004


Events for AppDialog

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Exit_Application | Called when an application is about to be closed |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnPaint | Sent every time a panel is painted | MdiDialog
OnResize | Sent every time a panel is resized | MdiDialog
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d
Verify_Exit_Application | Sent by the client area to verify that an application may be exited |


Methods for AppDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Activate_View | Procedure | Activates the view |
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  | MdiDialog
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area | MdiDialog
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | MdiDialog
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | MdiDialog
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


AppDialog [Procedure Activate_View]

Activate_View - AppDialog

Activates the view

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns non-zero if the activation fails.

Description

Activate_View activates a view. If the view is minimized, this message will restore it.

Activate_View Activate_oCustEntry For oCustEntry
Object oCustEntry Is A dbView
    : // contents of view go here
End_Object // oCust_Entry

The Activate_View statement creates a message, Activate_oCustEntry, which activates oCustEntry. To activate this view, you could do the following:

Send Activate_oCustEntry

Last Edited: October 7, 2004


Properties for AppDialog

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | MdiDialog
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | MdiDialog
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | MdiDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


AppPanel [Event Notify_Exit_Application]

Notify_Exit_Application - AppPanel

Received when an application is about to be exited

Type: Event

Parameters: No Parameters

Description

Notify_exit_application is received when an application is about to be exited. This is a notification-the exit-application event will occur. This passes this message on to its client-area object (which in turn will pass this message on to all views).

Last Edited: September 10, 2003


AppPanel [Event Verify_Exit_Application]

Verify_Exit_Application - AppPanel

Called when an exit-application request has been made

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

If a non-zero value is returned, the exit request will be ignored. If any of these returns a non-zero, the application will not be exited.

Description

Verify_exit_application is called when an exit-application request has been made. This sends this message to the client area which, in turn, sends the message to all views.

Last Edited: September 15, 2003


Events for AppPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Exit_Application | Received when an application is about to be exited |
OnActivateApp | Sent when the panel and, therefore, the application is activated | BasicPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | BasicPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp | Sent when this object is deactivated | BasicPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | BasicPanel
OnPaint | Sent every time a panel is painted | BasicPanel
OnResize | Sent every time a panel is resized | BasicPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | BasicPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | BasicPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | BasicPanel
Verify_Exit_Application | Called when an exit-application request has been made |


Methods for AppPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | BasicPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | BasicPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | BasicPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Cascade_Windows | Procedure | Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it |
Close_Panel | Procedure |  | BasicPanel
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | BasicPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | BasicPanel
Error_Help | Procedure | (Obsolete) | BasicPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | BasicPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | BasicPanel
Help | Procedure |  | BasicPanel
Help_For_Help | Procedure | (Obsolete) | BasicPanel
Help_Index | Procedure | (Obsolete) | BasicPanel
Help_on_topic | Procedure | (Obsolete) | BasicPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | BasicPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Minimize_all_Windows | Procedure | Minimizes all views within the client area |
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | BasicPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | BasicPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | BasicPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | BasicPanel
Restore_all_Windows | Procedure | Restores all minimized windows (views) in the client area |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | BasicPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Tile_Windows_Horizontal | Procedure | Horizontally tiles all windows (views) in the client area |
Tile_Windows_Vertical | Procedure | Vertically tiles all windows (views) in the client area |
Toggle_Statusbar | Procedure | Toggles the value of the statusBar_state property |
Toggle_Toolbar | Procedure | Toggles the value of the Toolbar_state property |
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | BasicPanel
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


AppPanel [Procedure Cascade_Windows]

Cascade_Windows - AppPanel

Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it

Type: Procedure

Parameters: No Parameters

Description

The Cascade_windows procedure arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it.

Last Edited: August 5, 2003


AppPanel [Procedure Minimize_all_Windows]

Minimize_all_Windows - AppPanel

Minimizes all views within the client area

Type: Procedure

Parameters: No Parameters

Description

Minimize_all_windows minimizes all views within the client area.

Last Edited: August 18, 2003


AppPanel [Procedure Restore_all_Windows]

Restore_all_Windows - AppPanel

Restores all minimized windows (views) in the client area

Type: Procedure

Parameters: No Parameters

Description

Restore_all_windows restores all minimized windows (views) in the client area.

Last Edited: September 11, 2003


AppPanel [Procedure Tile_Windows_Horizontal]

Tile_Windows_Horizontal - AppPanel

Horizontally tiles all windows (views) in the client area

Type: Procedure

Parameters: No Parameters

Description

Tile_windows_horizontal horizontally tiles all windows (views) in the client area.

Last Edited: September 11, 2003


AppPanel [Procedure Tile_Windows_Vertical]

Tile_Windows_Vertical - AppPanel

Vertically tiles all windows (views) in the client area

Type: Procedure

Parameters: No Parameters

Description

Tile_windows_vertical vertically tiles all windows (views) in the client area.

Last Edited: September 11, 2003


AppPanel [Procedure Toggle_Statusbar]

Toggle_Statusbar - AppPanel

Toggles the value of the statusBar_state property

Type: Procedure

Parameters: No Parameters

Description

If the status bar is currently visible, it will be removed; else, it will displayed. Toggle_statusbar toggles the value of the statusBar_state property.

Last Edited: September 11, 2003


AppPanel [Procedure Toggle_Toolbar]

Toggle_Toolbar - AppPanel

Toggles the value of the Toolbar_state property

Type: Procedure

Parameters: No Parameters

Description

If the tool bar is currently visible, it will be removed; else, it will displayed. Toggle_toolbar toggles the value of the Toolbar_state property.

Last Edited: September 11, 2003


Properties for AppPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Activate_State | Determines whether object will activate automatically after it has been created |
Auto_Arrange_Icons_State | Determines if icons are rearranged each time this object is resized |
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | BasicPanel
Bitmap | Displays a bitmap in an object | BasicPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id | The ID of the panels's client-area object | BasicPanel
Client_Scrollbar_State | Determines if a scroll bar should appear when a contained view's size or placement causes it to exceed the display capacity of its client area |
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | BasicPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | BasicPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | BasicPanel
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | BasicPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | BasicPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | BasicPanel
Help_Keyword | Used to specify an object's context keyword | BasicPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | BasicPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | BasicPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | BasicPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | BasicPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | BasicPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | BasicPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | BasicPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | BasicPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | BasicPanel
Statusbar_Id | The ID of the panel's status-bar object | BasicPanel
StatusBar_State | Determines if object will display a status bar |
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id | The ID of the panel's tool-bar objec | BasicPanel
ToolBar_State | Determines if the object will display its tool bar |
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | BasicPanel
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


AppPanel [Property Auto_Activate_State]

Auto_Activate_State - AppPanel

Determines whether object will activate automatically after it has been created

Type: Property

Access: Read/Write

Data Type: Integer

Description

Normally this object will activate automatically after it has been created. If the Auto_activate_state property is set false, this object does not activate upon creation.

Default is true.

Last Edited: July 30, 2003


AppPanel [Property Auto_Arrange_Icons_State]

Auto_Arrange_Icons_State - AppPanel

Determines if icons are rearranged each time this object is resized

Type: Property

Access: Read/Write

Data Type: Integer

Description

When Auto_arrange_icons_state is true (the default), the icons of minimized views are rearranged each time this object is resized. This ensures that icons always appear at the bottom of the screen. When set false, icons are not moved when this object's size is changed.

Default is false.

Last Edited: July 30, 2003


AppPanel [Property Client_Scrollbar_State]

Client_Scrollbar_State - AppPanel

Determines if a scroll bar should appear when a contained view's size or placement causes it to exceed the display capacity of its client area

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Client_scrollbar_state property determines if a scroll bar should appear when a contained view's size or placement causes it to exceed the display capacity of its client area. This is set by toggle_client_scrollbar_state.

Default is false.

Last Edited: July 30, 2003


AppPanel [Property StatusBar_State]

StatusBar_State - AppPanel

Determines if object will display a status bar

Type: Property

Access: Read/Write

Data Type: Integer

Description

If the Statusbar_state property is set true, this object will display a status bar. If the property is false, this object will not display a status bar. This is set by toggle_statusbar.

Default is true.

Last Edited: September 11, 2003


AppPanel [Property ToolBar_State]

ToolBar_State - AppPanel

Determines if the object will display its tool bar

Type: Property

Access: Read/Write

Data Type: Integer

Description

If the Toolbar_state property is set true, this object will display its tool bar. If the property is false, this object will have no scroll bar. If this object is currently active, the toolbar is added or removed immediately. This is set by toggle_toolbar.

Default is true.

Last Edited: September 11, 2003


Events for Array

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for Array

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Delete_Data | Procedure | Deletes all data from the Array object |
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements |
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order |


Array [Procedure Delete_Data]

Delete_Data - Array

Deletes all data from the Array object

Type: Procedure

Parameters: No Parameters

Description

Delete_Data deletes all data from the Array object. All memory is released back to the system. This message is used when the entire contents of an Array are to be deleted. Note that this message is automatically sent when the object is destroyed.

send delete_data of oMyArray

See Also

delete_item

Last Edited: July 31, 2003


Array [Procedure Delete_Item]

Delete_Item - Array

Removes the specified item from the Array and compacts the remaining elements

Type: Procedure

Parameters: Integer iItem

Parameter | Description
iItem | Item to be deleted

Description

Delete_Item removes the specified item from the Array and compacts the remaining elements. The delete_item message is used when a single item in the Array is to be removed. All items that follow the deleted item will have their item number reduced by 1.

send delete_item of oMyArray 3

See Also

Delete_data

Last Edited: July 31, 2003


Array [Procedure Sort_Items]

Sort_Items - Array

Sorts the items in an array in ascending or descending order

Type: Procedure

Parameters: Integer eDirection

Parameter Description
eDirection

Constant | Meaning
Ascending | array is sorted in ascending order
Descending | array is sorted in descending order

Description

Sort_items sorts the in an array in ascending or descending order. Sorting is case sensitive.

send sort_items of oMyArray Ascending

send sort_items of oMyArray Descending

Last Edited: September 11, 2003


Properties for Array

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Value | Sets and Gets an array element's value |


Array [Property Item_Count]

Item_Count - Array

Returns the number of items in an array object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Item_count returns the number of items in an array object. Arrays with no data (items have never been added or the array has been cleared) will return zero. The item_count property is often used as a loop counter to access each of the Array elements.

procedure Show_values
    integer iIndex iItemCount
    Handle hoArray
    move oMyArray to hoArray
    get item_count of hoArray to iItemCount
    For iIndex from 0 to (iItemCount-1)
        Get value of hoArray iIndex to sValue
        showln 'Array element=' iIndex '  value = ' sValue
    Loop
end_procedure

See Also

value

Last Edited: August 18, 2003


Array [Property Value]

Value - Array

Sets and Gets an array element's value

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iItem String sValue

Parameter | Description
iItem | index into the array (0 based)
sValue | Value of the iItem element

Description

Each element of this object has a defined value. The data value in an array element is set and retrieved with the value message.

Elements are accessed by an index number. The index is zero based (The first value is in item 0; the last value is in item_count -1).

Set Value of oMyArray 3 to "Test Data"

Get Value of oMyArray 3 to sValue
showln 'The value of item 3 is: ' sValue

See Also

item_count | delete_item | delete_data

Last Edited: September 15, 2003


BaseData_Set [Event Attach_Main_File]

Attach_Main_File - BaseData_Set

Performs attach command on main file

Type: Event

Parameters: No Parameters

Description

Attach_Main_File performs an attach. It gets called during save and find operations. An Attach moves related field data from a parent table to the DDO's table. This insures that the relationship values between tables are properly maintained.

Note that this attach is only applied to parent DDOs that are connected to this DDO. If a parent table is related to the DDO's main-file but there is no parent DDO connected to the DDO, no attach will occur.

You can use this procedure to create additional attaches, to cancel all attaches, or to create your own custom attaches. The following sample performs a normal attach except that one of the field's attaches is ignored.

Procedure Attach_Main_File
    String sTempVal

    Move Vndr.Parent_Stat to sTempVal // remember this value

    // the normal attach will attach data from all parent files
    // including an attach into Vndr.Parent_Stat. We want to
    // ignore this attach
    Forward Send Attach_Main_File

    Move sTempVal to Vndr.Parent_State // undo this one attach
End_Procedure  // Attach_Main_File

Note that Attach_Main_File and Relate_Main_File are not true inverses of each other. Relate_Main_File does nothing by default (the relate occurs as part of the find). Attach_Main_File actually performs the attach command. If you do not forward, the message no attach will occur.

When accessing table values you should always access the global file buffers and not the DDO buffers (i.e., use "Move File.Field to var" syntax). See Understanding File Buffers and DDO Field Buffers for more information.

With the BaseData_set class, this attach behavior attaches all open parent files. Normally this is not a desired behavior. The DataDictionary sub-class (the class you will be using) has a different, better behavior. With DDO classes, this attach will only occur if the parent DDO is part of the current DDO structure. This behavior can be altered by setting the property pbDDAttach.

See Also

When to Use the File-Buffer | Defining Data Dictionary Events | Understanding Relates and Attaches

Last Edited: July 12, 2005


BaseData_Set [Event Backout]

Backout - BaseData_Set

Hook for performing operations when editing or deleting a new record

Type: Event

Parameters: No Parameters

Description

The Update and Backout events are used to maintain relational balances between tables. Update is called when a record is being saved or edited. Backout is called when a record is being edited or deleted. Update and Backout is usually used adjust the balances of parent tables. Backout is used to remove the effect of a save while Update is used to add the effect of a save.

The following Update and Backout in a checks Data Dictionary would adjust the balances of its parent, the vndr table.

Procedure Update
    Forward Send Update
    Move (Checks.Total+ Vndr.Total_Paid) to Vndr.Total_Paid
End_Procedure

Procedure Backout
    Forward Send Backout
    Move (Checks.Total - Vndr.Total_Paid) to Vndr.Total_Paid
End_Procedure

When a new record is saved, Update (and not Backout) is called.

When a record is deleted, Backout (and not Update) is called.

When a record is edited, Backout and Update are both called.

The contents of an Update and Backout will almost always be the inverse of each other. If they are not, you should carefully recheck your logic. Whatever Update adds to a balance, Backout should deduct.

It is possible that the Backout and Update might adjust different parent balances during an edit. This would happen if the edit caused the parent record to change. DDOs support this.

Do not make the assumption that Update and Backout events only get sent once during a save. While this is true in cases where parent records are not switched, it will not be true when parent records are switched. The process of maintaining relational integrity when parent records are switched is quite complicated and both events can be called multiple times for the same table (for different records).

If a change in a record should adjust balances in both a parent and a grandparent record (e.g., check detail adjusts checks total, which adjusts vendor total), it is best to let a Data Dictionary only adjust its immediate parents (e.g., check detail's Update would adjust the checks table, check's Update would adjust the vendor table).

This message is always called in a locked state. Do not perform user input in this event.

If an Error is declared, the transaction will be rolled back. Errors must be generated using the Error command. See Error Handling in Transactions for more information.

When accessing table values you should always access the global file buffers and not the DDO buffers (i.e., use "Move File.Field to var" syntax). See Understanding File Buffers and DDO Field Buffers for more information.

See Also

When to Use the File-Buffer | Defining Data Dictionary Events | Creating | Deleting | Update

Last Edited: July 12, 2005


BaseData_Set [Event Clear_Main_File]

Clear_Main_File - BaseData_Set

Performs clear command on main table of this object

Type: Event

Parameters: No Parameters

Description

Clear_Main_File is sent whenever the buffer for the main table of a server must be cleared. It is intended to be overridden or augmented.

Sample

To force a manually related table (see Relate_Main_File) to be cleared when the main table is being cleared. Typically, the Request_Clear_File message should be used for this purpose to insure the refresh of DEOs occurs properly.

Procedure Clear_Main_File
    Forward Send Clear_Main_File

    Send Request_Clear_File Manual1.File_Number
    Send Request_Clear_File Manual2.File_Number
End_Procedure

See Also

When to Use the File-Buffer | Defining Data Dictionary Events

Last Edited: July 12, 2005


BaseData_Set [Event Creating]

Creating - BaseData_Set

Hook for performing operations required when creating a new record

Type: Event

Parameters: No Parameters

Description

Creating is called as part of the save process and is called when a new record is about to be saved. This event's default behavior is to handle auto-incrementing when this is defined in the class with the Define_Auto_Increment command. For this reason, you must make sure to forward the event.

This event can be used to perform any additional processing required for a new record.

Procedure Creating
    Forward send Creating
    Send LogNewRecordData
End_Procedure

This message is always called in a locked state. Do not perform user input in this event.

If an Error is declared, the transaction will be rolled back. Errors must be generated using the Error command. See Error Handling in Transactions for more information.

When accessing table values you should always access the global file buffers and not the DDO buffers (i.e., use "Move File.Field to var" syntax). See Understanding File Buffers and DDO Field Buffers for more information.

See Also

When to Use the File-Buffer | Defining Data Dictionary Events | Backout | Deleting | Update

Last Edited: July 12, 2005


BaseData_Set [Event Delete_Main_File]

Delete_Main_File - BaseData_Set

Performs the actual delete of the record

Type: Event

Parameters: No Parameters

Description

The Delete_Main_File event performs the actual delete of the record. Delete_Main_File is intended for augmentation.

Normally, you will always want to forward-send this message. If the message is not forwarded, the delete to the database will not occur.

This message is always called in a locked state. Do not perform user input in this event.

If an Error is declared, the transaction will be rolled back. Errors must be generated using the Error command. See Handling in Transactions for more information.

When accessing table values you should always access the global file buffers and not the DDO buffers (i.e., use "Move File.Field to var" syntax). See Understanding File Buffers and DDO Field Buffers for more information.

See Also

Defining Data Dictionary Events

Last Edited: July 11, 2005


BaseData_Set [Event Deleting]

Deleting - BaseData_Set

Hook for performing operations when deleting a record

Type: Event

Parameters: No Parameters

Description

Deleting is called during the delete process. It gets sent before the Backout message.

Procedure Deleting
    Forward send Deleting
    Send LogDeletedRecord
End_Procedure

This message is always called in a locked state. Do not perform user input in this event.

If an Error is declared, the transaction will be rolled back. Errors must be generated using the Error command. See Handling in Transactions for more information.

When accessing table values you should always access the global file buffers and not the DDO buffers (i.e., use "Move File.Field to var" syntax). See Understanding File Buffers and DDO Field Buffers for more information.

See Also

When to Use the File-Buffer | Defining Data Dictionary Events | Backout | Creating | Update

Last Edited: July 12, 2005


BaseData_Set [Event New_Current_Record]

New_Current_Record - BaseData_Set

Hook for performing operations during save, delete, and clear operations

Type: Event

Obsolete

Parameters: Integer iOldRecord Integer iNewRecord

Parameter | Description
iOldRecord | The old record number
iNewRecord | The new record number

Description

By default, the New_current_record procedure does nothing. It is received during the save, delete, and clear operations. During a find/relate operation, the "origin" of the find receives this message unconditionally, while the updated (parent) DDOs only receive it if the Current_Record is changing. It is available as a hook by means of which you can do such things as keep track of a key value:

Procedure Construct_Object
    forward send Construct_Object
    set main_file to .....

    Property Integer piOldId 0

End_Procedure  // Construct_Object

Procedure New_Current_Record integer iOldRecord integer iNewRecord
    forward send New_Current_Record iOldRecord iNewRecord
    set piOldId to myTable.Key_Field
End_Procedure

Function Validate_Save returns Integer
    integer iRecnum iOldId iRetVal

    forward get Validate_Save to iRetVal
    if iRetVal ;
        function_return iRetVal

    get Current_Record to iRecnum
    get piOldid to iOldId
    if ((iRecnum <>0) and (myTable.Key_Field <> iOldId)) ;
        send Operation_Not_Allowed 301 // custom error message
End_Function  // Validate_Save

Last Edited: July 11, 2006


BaseData_Set [Event OnNewCurrentRecord]

OnNewCurrentRecord - BaseData_Set

Type: Event

Parameters: RowId riOldRowId RowId riNewRowId

Parameter | Description
riOldRowId | [ToDo: In Progress]
riNewRowId | [ToDo: In Progress]

Description

Last Edited: December 2, 2005


BaseData_Set [Event Relate_Main_File]

Relate_Main_File - BaseData_Set

Does nothing by default. Called after the normal relate on the main table has been executed.

Type: Event

Parameters: No Parameters

Description

Relate_Main_File does nothing by default. It is called after the normal relate on the main table has been executed. It is an event that allows you to perform custom relates after your main record has been found and related.

If you are going to find an additional record in Relate_Main_File, you must notify the DDO that you have found this new record. You do this by sending the Request_Relate message (if the record was found) or Request_Clear_File (if the record was not found). Request_Relate will also perform a relate on the newly found record.

This is particularly true if the DDO is updating the parent-file DDO of the record you have found. The following code finds a "soft" parent record and notifies a DDO of the find.

Procedure Relate_Main_File
    Boolean bMustFind
    Integer iStatus iFile

    Get Main_File to iFile
    Get_Attribute DF_FILE_STATUS of iFile to iStatus

    Forward Send Relate_Main_File

    if (iStatus= DF_FILE_INACTIVE) begin
        Move True to bMustFind
    end
    else If (Vndr.Soft_id <> SoftFile.Soft_id) begin
        Move True to bMustFind
    end

    if bMustFind Begin // relate SoftFile only if required
        Clear SoftFile
        Move Vndr.Soft_ID to SoftFile.Soft_Id
        Find eq SoftFile.Soft_Id
    end

    Get_Attribute DF_FILE_STATUS of SoftFile.File_Number to iStatus
    if (iStatus<>DF_FILE_INACTIVE) begin
        Send Request_Relate SoftFile.File_Number
    end
    else begin
        Send Request_Clear_File SoftFile.File_Number
    end
End_Procedure  // Relate_Main_File

Note the optimization of this procedure. The find in SoftFile is performed only if: (a) the SoftFile record buffer is empty; or (b) the record in the buffer is the wrong one (relating values do not match).

You are strongly encouraged to optimize your finds inside Relate_Main_File. Because DDOs have no way of knowing what this procedure is doing, they have no way of optimizing these finds. Any time a DDO thinks that the custom-related record may be incorrect, it will send Relate_Main_File. It gets sent very often. If you do not optimize your finds (a simple process), you may be slowing down your database operations.

Be aware that Relate_Main_File is not always finding the record that relates to the current record. When parent records are switched, Relate_Main_File will be called during the save process to find a related record(s) for the switched-from and switched-to records. Because of this, CurrentRowId (or the obsolete Current_Record) should not be used in Relate_Main_File procedures. Within Relate_Main_File you should refer to the actual value of the file buffer or the table's RowId (using the GetRowId function). OnNewCurrentRecord can be used to track changes in CurrentRowId.

When accessing table values you should always access the global file buffers and not the DDO buffers (i.e., use "Move File.Field to var" syntax). See Understanding File Buffers and DDO Field Buffers for more information.

See Also

When to Use the File-Buffer | Defining Data Dictionary Events | Understanding Relates and Attaches | Attach_Main_File

Last Edited: July 12, 2005


BaseData_Set [Event Reset_Filemodes_For_Lock]

Reset_Filemodes_For_Lock - BaseData_Set

Temporarily resets the file modes of the Main_File of this object and of any updated DataDictionary objects for a save/delete operation

Type: Event

Parameters: No Parameters

Description

When Smart_Filemode_State is True, the Reset_Filemodes_For_Lock procedure resets the file modes of the Main_File of this object and of any updated DataDictionary objects (DDOs) for a save/delete operation and restores them to their previous state after the operation is complete. Files determined eligible for the save/delete (those relating to the record for which deletion was requested) will have their file modes changed (or not changed) according to the value of the Smart_Filemode_For_Lock property, while those determined ineligible will have theirs changed to the value of Smart_Filemode_For_Lock.

Last Edited: September 11, 2003


BaseData_Set [Event Save_Main_File]

Save_Main_File - BaseData_Set

Saves the main file

Type: Event

Parameters: No Parameters

Description

Save_Main_File saves the main file. You can use Save_Main_File to save additional non-related tables. You can also use Save_Main_File to process additional changes in your table.

Save_Main_File gets called for every table being saved in a DD operation. This method may get called even if there are no changes to save. In such a case, the physical save to the database will not occur even though the event is called.

In this example, we want to record a date-time stamp in every saved record. Since setting a date-time field value might cause an otherwise unchanged record to get saved, we will only change the value if the record is already changed. If the file buffer is changed, we will stamp the record.

Procedure Save_Main_File
    Boolean bChanged
    Integer iFile

    Get Main_File to iFile
    Get_Attribute DF_FILE_CHANGED of iFile to bChanged
    // only stamp the record if it is already changed. This assumes
    // that the functions Crnt_Date and Crnt_Time already exist.
    If (bChanged) Begin // if record is changed at all
        Get Crnt_Date to Vndr.Date_Stamp
        Get Crnt_Time to Vndr.Time_Stamp
    End
    // now do the normal save behavior.
    Forward Send Save_Main_File
End_Procedure

Normally, you will always want to forward-send this message. If the message is not forwarded, the save to the database will not occur.

This message is always called in a locked state. Do not perform user input in this event.

If an Error is declared, the transaction will be rolled back. Errors must be generated using the Error command. See Handling in Transactions for more information.

When accessing table values you should always access the global file buffers and not the DDO buffers (i.e., use "Move File.Field to var" syntax). See Understanding File Buffers and DDO Field Buffers for more information.

See Also

When to Use the File-Buffer | Defining Data Dictionary Events

Last Edited: July 12, 2005


BaseData_Set [Event Update]

Update - BaseData_Set

Hook for performing operations when saving a record

Type: Event

Parameters: No Parameters

Description

The Update and Backout events are used to maintain relational balances between tables. Update is called when a record is being saved or edited. Backout is called when a record is being edited or deleted. Update and Backout is usually used adjust the balances of parent tables. Backout is used to remove the effect of a save while Update is used to add the effect of a save.

The following Update and Backout in a checks Data Dictionary would adjust the balances of its parent, the vndr table.

Procedure Update
    Forward Send Update
    Move (Checks.Total+ Vndr.Total_Paid) to Vndr.Total_Paid
End_Procedure

Procedure Backout
    Forward Send Backout
    Move (Checks.Total - Vndr.Total_Paid) to Vndr.Total_Paid
End_Procedure

When a new record is saved, Update (and not Backout) is called.

When a record is deleted, Backout (and not Update) is called.

When a record is edited, Backout and Update are both called.

The contents of an Update and Backout will almost always be the inverse of each other. If they are not, you should carefully recheck your logic. Whatever Update adds to a balance, Backout should deduct.

It is possible that the Backout and Update might adjust different parent balances during an edit. This would happen if the edit caused the parent record to change. DDOs support this.

Do not make the assumption that Update and Backout events only get sent once during a save. While this is true in cases where parent records are not switched, it will not be true when parent records are switched. The process of maintaining relational integrity when parent records are switched is quite complicated and both events can be called multiple times for the same table (for different records).

If a change in a record should adjust balances in both a parent and a grandparent record (e.g., check detail adjusts checks total, which adjusts vendor total), it is best to let a Data Dictionary only adjust its immediate parents (e.g., check detail's Update would adjust the checks table, check's Update would adjust the vendor table).

This message is always called in a locked state. Do not perform user input in this event.

If an Error is declared, the transaction will be rolled back. Errors must be generated using the Error command. See Error Handling in Transactions for more information.

When accessing table values you should always access the global file buffers and not the DDO buffers (i.e., use "Move File.Field to var" syntax). See Understanding File Buffers and DDO Field Buffers for more information.

See Also

When to Use the File-Buffer | Defining Data Dictionary Events | Creating | Deleting

Last Edited: July 12, 2005


BaseData_Set [Event Validate_Delete]

Validate_Delete - BaseData_Set

Guards execution of delete operation

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Should return zero if deletion is allowed, else should return non-zero or generate an error to prevent deletion. By default, returns zero to allow deletion.

Description

The Validate_Delete function is called right before a delete will occur. The participating tables are locked. Generating an error or returning a non-zero value will stop the delete.

A delete operation will delete the main file and all related descendant-file records (child, grandchild, etc.). It does this to prevent orphans. This only occurs if Cascade_Delete_State is true and there is a child-parent relationship between the tables and the DDO structure is proper.

The Validate_Delete is only sent to the DDO in whose main file the delete is being done. If Validate_Delete is approved, the main-file record and all child-file records will be deleted.

If you are prohibiting cascade deletes, it is vital that you forward the Validate_Delete message. The cascade-delete checking occurs as part of this forwarded behavior:

Function Validate_Delete returns Integer
    Integer iError
    Forward get Validate_Delete to iError
    If (Not(iError)) Begin
        If (Customer.status = 'A') Begin
            Error 306 'Cannot delete active record'
        End
    End
    Function_Return iError
End_Function

The tables of all participating DDOs are locked during Validate_Delete. Therefore, the function should be fast and must never call for user input. The exception to this is the error command. An error generated during the Validate_Delete will be deferred until after the delete has been backed out and the tables have been unlocked.

An error in any of the delete events (Validate_Delete, Deleting, Backout, Delete_Main_File, etc.) starts a transaction rollback. This is a special process. When this happens the remaining code in the function is not executed.

This message is always called in a locked state. Do not perform user input in this event.

If an Error is declared, the transaction will be rolled back. Errors must be generated using the Error command. See Handling in Transactions for more information.

When accessing table values you should always access the global file buffers and not the DDO buffers (i.e., use "Move File.Field to var" syntax). See Understanding File Buffers and DDO Field Buffers for more information.

See Also

When to Use the File-Buffer | Defining Data Dictionary Events

Last Edited: July 12, 2005


BaseData_Set [Event Validate_Delete_No_Cascade]

Validate_Delete_No_Cascade - BaseData_Set

Guards against deleting records with existing child records

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns non-zero if validaiton fails

Description

The Validate_Delete_No_Cascade event guards against deleting records with existing child records. When Cascade_Delete_State is False, Validate_Delete calls this function to check whether any record related to the record for which deletion was requested exists in any file named in an Add_Client_File message for this object. If any does, or if any named file is not open, this function returns true, and calls Operation_Not_Allowed. If all related files are open and none contains a record related to the record for which deletion was requested, this function returns false, allowing the deletion to proceed.

If you wish to employ cascade-delete checking and you have defined your own Validate_Delete function, you must forward Validate_Delete_No_Cascade; otherwise cascade-delete checking will not occur.

Sample

Function Validate_Delete Returns Integer
    Integer iRetVal

    Forward Get Validate_Delete_No_Cascade to iRetVal  // check cascade delete
    If (iRetVal=0) begin  // if ok so far,
        :  //custom checking
    End
    Function_Return iRetVal
End_Function

Last Edited: February 17, 2004


BaseData_Set [Event Validate_Save]

Validate_Save - BaseData_Set

Used to enforce business rules and integrity rules

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Should return 0 if saving is permissible, else non-zero, which prevents saving. By default, returns 0 to allow saving.

Description

Validate_Save is used as final validation of a record before saving it. It is sent to every table in the DDO structure that will participate in the save. It is called when the database is locked and all field values have been updated. You may directly query the value of any file.field buffer and if any value or combination of values is invalid, stop the save by declaring an error or by returning a non-zero value.

The data in the file buffer is exactly what would get saved. The exception to this is that the file buffer attaches have not yet occurred. This means that a child-file buffer may not contain the parent information that will get placed in the file buffer during the Attach_Main_File event. The Attach_Main_File event occurs after the Validate_Save.

The tables of all participating DDOs are locked during Validate_Save. Therefore, the function should be fast and must never call for user input. The exception to this is the error command. An error generated during the Validate_Save will be deferred until after the save has been backed out and the tables have been unlocked.

Typically, a failed Validate_Save will generate an error message, as in the example below.

Function Validate_Save returns Integer
    integer iError
    If (Invt.Qty < 0) Begin
        Error DFERR_OPERATOR 'Insufficient Inventory on hand'
    End
    forward get Validate_Save to iError
    Function_Return iError
End_Function

An error in any of the save events (Validate_Save, Update, Backout, Save_Main_File, etc.) starts a transaction rollback. This is a special process. When this happens the remaining code in the function is not executed.

Because the buffers for all participating tables have been updated, you should not find, clear, delete, or alter any file buffers.

This should not be confused with field validation. Field validation occurs before the database is locked and before the fields are updated to the file buffer. Field validation can be used to handle most validations. Validate_Save is used to handle special validations that can only be checked in a locked and updated state.

This message is always called in a locked state. Do not perform user input in this event.

If an Error is declared, the transaction will be rolled back. Errors must be generated using the Error command. See Handling in Transactions for more information.

When accessing table values you should always access the global file buffers and not the DDO buffers (i.e., use "Move File.Field to var" syntax). See Understanding File Buffers and DDO Field Buffers for more information.

See Also

When to Use the File-Buffer | Defining Data Dictionary Events

Last Edited: July 12, 2005


Events for BaseData_Set

View event list in hierarchical order

Name | Description | Defining Class
Attach_Main_File | Performs attach command on main file |
Backout | Hook for performing operations when editing or deleting a new record |
Clear_Main_File | Performs clear command on main table of this object |
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Creating | Hook for performing operations required when creating a new record |
Delete_Main_File | Performs the actual delete of the record |
Deleting | Hook for performing operations when deleting a record |
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
New_Current_Record | (Obsolete) Hook for performing operations during save, delete, and clear operations |
OnNewCurrentRecord |  |
Relate_Main_File | Does nothing by default. Called after the normal relate on the main table has been executed. |
Reset_Filemodes_For_Lock | Temporarily resets the file modes of the Main_File of this object and of any updated DataDictionary objects for a save/delete operation |
Save_Main_File | Saves the main file |
Update | Hook for performing operations when saving a record |
Validate_Delete | Guards execution of delete operation |
Validate_Delete_No_Cascade | Guards against deleting records with existing child records |
Validate_Save | Used to enforce business rules and integrity rules |


BaseData_Set [Function CurrentRowId]

CurrentRowId - BaseData_Set

Returns the RowId of the current record

Type: Function

Return Data Type: RowId

Parameters: No Parameters

Return Value

Returns the DDOs current record identifier

Description

Syntax

Get CurrentRowId of hoDDO to riRec

CurrentRowId is used to obtain the current record identity (RowId) of a Data Dictionary Object (DDO). This function can be used store a DDO's record identity so that the record can be refound at a later time.

Procedure ProcessInvoices
    RowId riCurrentInvoice

    Get CurrentRowId of oInvoices_DD to riCurrentInvoice
    Send RunInvoiceReport
    // assume that running this report may change the current record of the DDO
    // therefore we will restore the DDO back to the record we started with
    Send FindByRowId of oInvoices_DD Invoices.File_number riCurrentInvoice
End_Procedure  // ProcessInvoices

Note that this function returns a RowId data type and that the variable receiving this value must be a RowId variable.

If the DDO does not contain a current record, a Null RowId value will be returned.

Procedure CheckRecord
    RowId riCurrentInvoice

    Get CurrentRowId of oInvoices_DD to riCurrentInvoice
    If (IsNullRowID(riCurrentInvoice)) begin
         Error DFERR_OPERATOR "There is no Record to Process"
    End
    Else Begin
        Send ProcessRecord riCurrentInvoice
    End
End_Procedure  // CheckRecord

You can also use the HasRecord function to determine if a DDO contains an active record.

See Also

HasRecord | FindByRowId

Last Edited: July 11, 2005


BaseData_Set [Function HasRecord]

HasRecord - BaseData_Set

Determines if the DataDictionary object (DDO) has a current record

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns True, if the DDO has a current record.

Description

Get HasRecord of hoDDO to bHasRecord

HasRecord is used to determine if your DDO has a current record. This can be used to determine if a find operation succeeded (if HasRecord is true), if the DDO buffer did not contain a record prior to the find operation (otherwise, check the Found indicator).

It can also be used to determine if a save will result in a new record save (if HasRecord is false) or an edit of an existing record (if HasRecord is true).

Procedure Refresh integer iMode
    Boolean bHasRecord
    Handle  hoDD

    Forward Send Refresh iMode

    // if record exists, enable the print button.
    Get Server to hoDD
    Get HasRecord of hoDD to bHasRecord
    Set Enabled_State of oPrintBtn to bHasRecord
End_Procedure  // Refresh

If HasRecord is true, the CurrentRowId function will return the value of the RowId. If HasRecord is false, CurrentRowId will contain a null RowId.

Note:
The DDO field buffer may not contain the same record currently loaded in your global file buffer. When working with DDOs you should always refer to the DDO methods HasRecord and CurrentRowId and not use the actual table's status. A file buffer may be synchronized with a DDO by sending the Refind_Records message to the DDO.

Note:
If the DDO buffer already contains a record prior to attempting a find, HasRecord may return True even though the find was unsuccessful, due to the record already in the DDO buffer. In this case, use the Found indicator to check if a find was successful.

See Also

CurrentRowId

Last Edited: September 14, 2005


BaseData_Set [Function Request_Validate]

Request_Validate - BaseData_Set

Request_Validate sends validation messages to all DDO Field's that will participate in the upcoming save

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns zero if all items are valid, else returns a non-zero value.

Description

A DDO save is normally a two-step process. First you send Request_Validate to the DDO to make sure that your data is ready for the save. If your data is valid, you then send Request_Save to the DDO to perform the save.

In some cases, you will use objects such as data-entry object (DEOs) to handle the entire save for you. In other cases, you will need to write custom code to perform the save. In all cases, the save process itself is the same.

The Request_Validate Message

Get Request_Validate of hoDD to bErr

Before a Request_Save is sent to a DDO, the Request_Validate message should be sent to validate that all data is valid for a save. When performing saves with a DEO or using a Web Browser object's high level save, this message is sent for you. If you are performing saves manually within a Batch Process or Web Object, you will need to send this message yourself.

Request_Validate sends validation messages to all DDO Field's that will participate in the upcoming save. If the validation of any field fails, an error is reported and the save will not proceed.

Function SaveCustomer returns Boolean
    Boolean bErr

    Get Request_Validate of oCustomer_DD to bErr
    If Not bErr Begin
       Send Request_Save of oCustomer_DD
       Move (Err) to bErr
    End
    Function_Return bErr
End_Function

It is important that you understand when and how this process occurs.

  • Before a save, every single field in every single DDO that will participate in the save will be validated.
  • This is a pre-save validation.
  • Your database is not locked at this point.
  • If any validation function returns a non-zero value, the Request_Validate will fail and return a non-zero value.
  • An error message will usually be generated when a field validation fails.
  • If DEOs are attached to the DDO, the DDO will attempt to give the focus to the DEO that contains the invalid field data.
  • This field validation is a different process than the actual DDO save validation (Validate_Save), which occurs much later in the save process.

See Also

Save Operations in DDOs

Last Edited: July 11, 2005


BaseData_Set [Function Validate_Constraints]

Validate_Constraints - BaseData_Set

Validates this object's constraints against the record buffer's current content

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns true if the constraints are satisfied, or false if they are not satisfied

Description

The Validate_constraints function validates this object's constraints against the record buffer's current content, returning true if the constraints are satisfied, or false if they are not satisfied. This function is intended to be used within validate_save procedures to verify that records satisfy this object's constraints. Note that most constraints are merely selection criteria and not integrity rules, so use of this function would probably be rare.

Last Edited: September 11, 2003


Methods for BaseData_Set

View method list in hierarchical order

Name | Type | Description | Defining Class
Add_Client_File | Procedure | Adds a table to this object's related-child list |
Add_Server_File | Procedure | Adds a table to this object's related-parent list |
Add_User_Interface | Procedure | Adds the passed in hoDEO to the list of data entry objects (DEOs) for this object |
Attach_Server | Procedure | (Obsolete) Use DDO_Server instead |
Clear | Procedure | Clears all files owned by this object |
Clear_All | Procedure | Clears all files owned by this object and all connected server DataDictionary objects (DDOs) |
Constrain | Procedure | Defines constraint set for this object |
Create | Function | Creates an object based on the passed Class Id | cObject
CurrentRowId | Function | Returns the RowId of the current record |
Destroy | Procedure |  | cObject
Detach_Server | Procedure | Disconnects this object and the specified DataDictionary object (DDO), where this object was the client of that DDO server |
Establish_Find_Direction | Procedure | Initializes the constrained find commands to perform searches using the given parameters |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Find_By_Recnum | Procedure | Finds record in specified table with record number equal to the passed in record number |
FindByRowId | Procedure | Finds record in specified table with record identity equal to the passed RowId and updates the DDO structure |
HasRecord | Function | Determines if the DataDictionary object (DDO) has a current record |
Locate_Next | Procedure | Finds the next logical record using the passed in find mode, file, and index specified in a prior Establish_Find_Direction invocation |
Operation_Not_Allowed | Procedure | Executes the error command with the passed in error number. Intended for augmentation |
Read_By_Recnum | Procedure | Finds record in specified tabile with record number equal to the passed in record number |
ReadByRowId | Procedure | Finds record in specified table with record identity equal to the passed RowId without updating or altering the DDO structure |
Rebuild_Constraints | Procedure | Reconstructs constraints for a DDO |
Refind_Records | Procedure | Checks to see if the record in the File-Buffer is the same as the record in the DDO-Field-Buffer and refinds the record if needed |
Remove_Client_File | Procedure | Removes a table from this object's container-file list |
Remove_Server_File | Procedure | Removes a table from this object's server-file list |
Remove_User_Interface | Procedure | Removes a table from this object's data entry object (DEO)-list |
Request_Assign | Procedure | Causes the Refresh message to be sent to all data entry objects for this object and its client and server DataDictionary objects as appropriate |
Request_Clear_File | Procedure | Performs the Clear command on the specified table of the data-server structure |
Request_Delete | Procedure | esponsible for deleting a record in the DDO for the main_file, updating all parent DDOs (and tables) and possibly deleting all child records |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Entry_Update | Procedure | Sends entry_update to all DEOs of the data set and DEOs of servers of the data set as required to store changes to record buffers |
Request_Find | Procedure | Finds on specified table using given find mode and index |
Request_Read | Procedure | Finds on specified table using given find mode and index |
Request_Relate | Procedure | Performs a relate on the specified table without initializing the done-array |
Request_Save | Procedure | Saves all changes in DEOs attached to this object or to any DDO that is a server of this object directly or indirectly |
Request_Superfind | Procedure | Performs superfind on the designated table by the Main_Index of the designated field and notifies all connected DataDictionary objects (DDOs) of the result |
Request_Validate | Function | Request_Validate sends validation messages to all DDO Field's that will participate in the upcoming save |
Validate_Constraints | Function | Validates this object's constraints against the record buffer's current content |


BaseData_Set [Procedure Add_Client_File]

Add_Client_File - BaseData_Set

Adds a table to this object's related-child list

Type: Procedure

Parameters: Integer iFile

Parameter | Description
iFile | Number of the table to add to this object's related-child list

Description

Send Add_Client_File Orderdtl.File_Number

A Data Dictionary needs to know about its related-from, child tables. By identifying all child tables the Data Dictionary can determine if Data Dictionary objects have been created for all of these children and if those child DDOs are properly connected to the main DDO. The child DDOs will also have a list child tables and these child DDOs can also make the same check to make sure that their child DDOs exist and are properly connected within the structure. This process occurs down the entire database hierarchy.

By propagating this check down an entire Data Dictionary object structure any DDO can tell if it's entire Data Dictionary structure is complete. If the downward structure is not complete, that DDO may be allowed to delete records, as it would not have the proper child DDOs required to cascade delete related child records.

Child table information is also used by the Studio and various wizards to help you write your applications. Therefore it is important that this information is properly maintained in your Data Dictionary class.

You add tables to the related-child list with the Add_Client_File message. You send this message for each required child table.

See Also

Defining Data Dictionary Parent, Child and External Relationships

Last Edited: July 11, 2005


BaseData_Set [Procedure Add_Server_File]

Add_Server_File - BaseData_Set

Adds a table to this object's related-parent list

Type: Procedure

Parameters: Integer iFile

Parameter | Description
iFile | Number of the table to add to this object's related-parent list

Description

Send Add_Server_File Customer.File_Number

A Data Dictionary needs to know about its related-to, parent tables. By identifying all parent tables the Data Dictionary can determine if Data Dictionary objects have been created for all of these parents and if those parent DDOs are properly connected to the main DDO. The Parent DDOs will also have a list parent tables and these parent DDOs can also make the same check to make sure that their Parent DDOs exist and are properly connected within the structure. This process occurs up the entire database hierarchy.

By propagating this check up an entire Data Dictionary object structure any DDO can tell if it's entire Data Dictionary structure is complete. If the structure is not complete, that DDO will not be allowed to save or delete records.

Parent table information is also used by the Studio and various wizards to help you write your applications. Therefore it is important that this information is properly maintained in your Data Dictionary class.

You add tables to the related-parent list with the Add_Server_File message. You send this message for each required parent table.

See Also

Defining Data Dictionary Parent, Child and External Relationships

Last Edited: July 11, 2005


BaseData_Set [Procedure Add_User_Interface]

Add_User_Interface - BaseData_Set

Adds the passed in hoDEO to the list of data entry objects (DEOs) for this object

Type: Procedure

Parameters: Handle hoDEO

Parameter | Description
hoDEO | Object id of the object whose list to add to

Description

Adds specified hoDEO to the set of DEOs attached to this object. Sent by data entry objects (DEOs) upon activation, to attach to their server DataDictionary object (DDO). If the Auto_Fill_State of the specified hoDEO is True, and it is the first auto-fill DEO to be attached to this object, this object changes its Auto_Fill_State to True after storing the original value of the state, so that if the DEO is later detached by use of Remove_User_Interface, the Auto_Fill_State of this object can be restored.

Last Edited: July 11, 2005


BaseData_Set [Procedure Attach_Server]

Attach_Server - BaseData_Set

Use DDO_Server instead

Type: Procedure

Obsolete

Parameters: Handle hoServer

Parameter | Description
hoServer | Object id of the DDO to attach to

Description

This method is obsolete. Use DDO_Server instead.

Establishes a connection between this object and the specified DataDictionary object (DDO), with this object as the client of that DDO.

The DDO attached via Attach_Server becomes a Server of this object. Note that the connection is two-way. Intended to be sent to attach new DDOs as servers of an existing DDO.

Sample

Object DD1 is a Parent_DataDictionary
End_Object  // DD1

Object DD2 is a Child_DataDictionary
End_Object  // DD2

Send Attach_Server of DD2 DD1

Last Edited: December 16, 2004


BaseData_Set [Procedure Clear]

Clear - BaseData_Set

Clears all files owned by this object

Type: Procedure

Parameters: No Parameters

Description

The Clear procedure clears all files owned by this object, including the Main_File, sends Refresh to the data entry objects (DEOs) attached to this object, sets the Changed_State of this object to False and notifies connected DataDictionary objects (DDOs) of the change. This may cause the connected DDOs to clear and/or find, etc. This is sent by DEOs attached to this object.

Clear is not re-entrant. Once a major Data-Dictionary operation (save, find, delete, clear) has begun you cannot start another major operation. The reentrancy restriction applies within DDO structures and across DDO structures.

See Also

Clearing - Clear and Clear All

Last Edited: July 11, 2005


BaseData_Set [Procedure Clear_All]

Clear_All - BaseData_Set

Clears all files owned by this object and all connected server DataDictionary objects (DDOs)

Type: Procedure

Parameters: No Parameters

Description

The Clear_All sends Refresh to notify data entry objects (DEOs). This is sent by DEOs attached to this object.

Clear_All is not re-entrant. Once a major Data-Dictionary operation (save, find, delete, clear) has begun you cannot start another major operation. The reentrancy restriction applies within DDO structures and across DDO structures.

See Also

Clearing - Clear and Clear All

Last Edited: July 11, 2005


BaseData_Set [Procedure Constrain]

Constrain - BaseData_Set

Defines constraint set for this object

Type: Procedure

Parameters: No Parameters

Description

The Constrain procedure defines constraint set for this object, using Constrain_File. It is augmented by OnConstrain, if any.

Last Edited: August 14, 2003


BaseData_Set [Procedure Detach_Server]

Detach_Server - BaseData_Set

Disconnects this object and the specified DataDictionary object (DDO), where this object was the client of that DDO server

Type: Procedure

Parameters: Handle hoServer

Parameter | Description
hoServer | Object id of the DDO to disconnect

Description

The Detach_Server procedure disconnects this object and the specified DataDictionary object (DDO), where this object was the client of that DDO server.

Sample

Object DD1 is a Parent_DataDictionary
End_Object  // DD1

Object DD2 is a Child_DataDictionary
End_Object  // DD2

Send Detach_Server of DD2 DD1

Last Edited: July 31, 2003


BaseData_Set [Procedure Establish_Find_Direction]

Establish_Find_Direction - BaseData_Set

Initializes the constrained find commands to perform searches using the given parameters

Type: Procedure

Parameters: Integer eFindMode Integer iFile integer iIndex

Parameter | Description
eFindMode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
iFile | Number of the table in the current filelist
iIndex | Number of the index to use to perform the find

Description

The Establish_Find_Direction initializes the constrained find commands to perform searches using the given parameters.

Sample

Send Establish_Find_Direction ge Items.File_Number 1

Note:FileName.File_Number is a predefined constant, where FileName should be replaced with the actual table name, as seen in the example above. At compile time, the actual file number from the .FD file for that table is substituted for FileName.File_Number.

Last Edited: December 16, 2004


BaseData_Set [Procedure Find_By_Recnum]

Find_By_Recnum - BaseData_Set

Finds record in specified table with record number equal to the passed in record number

Type: Procedure

Parameters: Integer iFile Integer iRecnum

Parameter | Description
iFile | Number of the table in the current filelist
iRecnum | Record number (RECNUM) of the record to find

Description

Obsolete

This method is obsolete as it can only be used with tables that support recnum. The FindByRowId method should be used in its place.

The Find_By_Recnum procedure finds record in specified table with record number equal to the passed in record number. If it is found, it relates. This sets Found indicator. It then affects the Current_Record of this object, and notifies any connected DataDictionary objects (DDOs) of the change. This is sent by lists and grids to find a record for a particular row.

Sample

This sample would find record number 3 for the Customer table.

Send Find_By_Recnum of Customer_DD Customer.File_Number 3

Find_by_Recnum is not re-entrant. Once a major Data-Dictionary operation (save, find, delete, clear) has begun you cannot start another major operation. The reentrancy restriction applies within DDO structures and across DDO structures.

See Also

Find and Clear Operations in DDOs | FindByRowId

Last Edited: July 11, 2005


BaseData_Set [Procedure FindByRowId]

FindByRowId - BaseData_Set

Finds record in specified table with record identity equal to the passed RowId and updates the DDO structure

Type: Procedure

Parameters: integer iFile RowId riRowId

Parameter | Description
iFile | Number of the table in the current filelist
riRowId | The RowId record identity of the record to find

Description

The FindByRowId procedure finds a record in a specified table with the record identifier equal to the passed RowId. If it is found, a relate occurs and all affected parent and child DDOs are updated. If the find succeeds, the Found indicator is set to True. All DDOs that result in a changed record will receive the OnNewCurrentRecord event.

The first parameter, iFile, may be a table name constant (e.g. Customer.File_Number) or an integer variable representing the table (e.g. (Main_File(Self)) ).
The second parameter, riRowId, must be of type RowId.

This method is normally used to refind a record. Typically you will store the current RowId value of a DDO, perform some operation which may change that record, and refind the original record using FindByRowId. The following examples shows how this is done.

Procedure ProcessInvoices
    RowId riCurrentInvoice

    Get CurrentRowId of oInvoices_DD to riCurrentInvoice
    Send RunInvoiceReport
    // assume that running this report may change the current record of the DDO
    // therefore we will restore the DDO back to the record we started with
    Send FindByRowId of oInvoices_DD Invoices.File_Number riCurrentInvoice
End_Procedure

If the find fails, the DDO will be cleared. You can use the Found global indicator to determine if a find was successful. If you do this, you must test the value immediately after the find as this indicator is volatile and could be changed by subsequent commands. Alternately, you can use the HasRecord function to test if a record exists after the find.

Procedure RefindIt Handle hoDD RowId riRow
    Boolean bFound
    integer iMain

    Get Main_File of hoDD to iMain // find based on main table of passed DD
    Send FindByRowId of hoDD iMain riRow
    Move (Found) to bFound // move the value of the Found indicator to bFound immediately after the find
    :
End_Procedure

// an alternate
Procedure RefindIt Handle hoDD RowId riRow
    Boolean bFound
    integer iMain

    Get Main_File of hoDD to iMain // find based on main table of passed DD
    Send FindByRowId of hoDD iMain riRow
    Get HasRecord of hoDD to bFound
    :
End_Procedure

If you need to find a specific record based on some other known value (e.g.: a customer Id or an order number) you will use the Find or Request_Find methods.

You can refind a record by RowId without changing the DDO's current record with the ReadByRowId method

FindByRowId is not re-entrant. Once a major Data-Dictionary operation (save, find, delete, clear) has begun you cannot start another major operation. The reentrancy restriction applies within DDO structures and across DDO structures.

See Also

Finding - Find, Request_Find and FindByRowId | Find and Clear Operations in DDOs | OnNewCurrentRecord | HasRecord | CurrentRowId | Find | Request_Find | ReadByRowId

Last Edited: July 11, 2005


BaseData_Set [Procedure Locate_Next]

Locate_Next - BaseData_Set

Finds the next logical record using the passed in find mode, file, and index specified in a prior Establish_Find_Direction invocation

Type: Procedure

Parameters: No Parameters

Description

The Locate_Next procedure finds the next logical record using the passed in find mode, file, and index specified in a prior Establish_Find_Direction invocation. It sends Relate_Main_File if it is successful. This does not affect Current_Record of the DataDictionary, nor does it notify other (connected) DataDictionaries of the result.

Last Edited: August 18, 2003


BaseData_Set [Procedure Operation_Not_Allowed]

Operation_Not_Allowed - BaseData_Set

Executes the error command with the passed in error number. Intended for augmentation

Type: Procedure

Parameters: Integer iError

Parameter | Description
iError | Error number to disallow

Description

By default, the Operation_Not_Allowed procedure simply executes the error command with the passed in iErr. You may, however, augment it to substitute other messages for iErr defined in Visual DataFlex, or undefined.

Sample

Procedure Operation_Not_Allowed Integer iError
    If (iError=4140) ;
        Error iError ". Customer has activity."
    Else ;
        Forward Send Operation_Not_Allowed iError
End_Procedure

Last Edited: July 11, 2006


BaseData_Set [Procedure Read_By_Recnum]

Read_By_Recnum - BaseData_Set

Finds record in specified tabile with record number equal to the passed in record number

Type: Procedure

Parameters: Integer iFile Integer iRecnum

Parameter | Description
iFile | Number of tabile in current filelist
iRecnum | Record number of record to find

Description

Obsolete

This method is obsolete as it can only be used with tables that support recnum. The ReadByRowId method should be used in its place.

The Read_By_Recnum procedure finds record in specified table with record number equal to the passed in record number. If it is found, relates. This sets the Found indicator. It does not affect the Current_Record of this object, nor does it notify any connected DataDictionary objects (DDOs) of the change. This is sent by lists and grids to re-find a record for a particular row. Also sent by data entry objects (DEOs) with Deferred_State set to True.

Last Edited: February 16, 2005


BaseData_Set [Procedure ReadByRowId]

ReadByRowId - BaseData_Set

Finds record in specified table with record identity equal to the passed RowId without updating or altering the DDO structure

Type: Procedure

Parameters: integer iFile RowId riRowId

Parameter | Description
iFile | Number of the table in the current filelist
riRowId | The RowId record identity of the record to read

Description

The ReadByRowId procedure finds a record in a specified table with the record identifier equal to the passed RowId. If it is found, a relate occurs. If the find succeeds, the Found indicator is set to True. The DDO structure is not changed by this operation.

DDO Read operations (ReadByRowid and Request_Read) find and relate records without updating the DDO. The global file buffers will contain the newly found record data but the DDO will not latch on to this record and the status of the DDOs in the structure (their current records and their field values) will not change.

DDO Find operations (Find, FindByRowId and Request_Find), do update the DDOs. Normally, you will use find methods. Read operation are used when you want to find records using a DDOs constraint without actually changing the DDO's current status.

The first parameter, iFile, may be a table name constant (e.g. Customer.File_Number) or an integer variable representing the table (e.g. (Main_File(Self)) ).
The second parameter, riRowId, must be of type RowId.

You can use the Found global indicator to determine if a find was successful. If you do this, you must test the value immediately after the find as this indicator is volatile and could be changed by subsequent commands.

Procedure RereadIt Handle hoDD RowId riRow
    Boolean bFound
    integer iMain
    Get Main_File of hoDD to iMain // find based on main file of passed DD
    Send ReadByRowId of hoDD iMain  riCurrentInvoice
    Move (Found) to bFound // move the value of the Found indicator to bFound immediately after the find
    :
End_Procedure

This method is normally used to refind a record and look at the field information (in the global file buffer) without changing the values in your current DDO structure. If you need to read a specific record based on some other known value (e.g.: a customer Id or an order number) you will use the Request_Read method.

See Also

Request_Read | FindByRowId | Find | Request_Find

Last Edited: February 16, 2005


BaseData_Set [Procedure Rebuild_Constraints]

Rebuild_Constraints - BaseData_Set

Reconstructs constraints for a DDO

Type: Procedure

Parameters: No Parameters

Description

The Rebuild_Constraints procedure builds the constraint set for a DDO. It reconstructs constraints for this DD object by sending constrain to it. If the property pbInheritConstraints is false (the default), the contrain message is sent to all DDO servers (parents), recursively, of this object thus ensuring that clients respect the constraints of their servers. The constrain message sends OnConstrain which is the event that you should use to define your constrains using the constraint command.

When a DDO structure first becomes in-use (i.e., when a view is activated) the message rebuild_constraints is sent to all DDOs in the structure. If you wish to change the constraint of a DDO you must send rebuild_constraints to that DDO for the change to take effect.

Property psStateFilter ''
:
Object Customer_DD is a Customer_DataDictionary
    Procedure OnConstrain
        string sFilter
        get psStateFilter to sFilter
        if (sFilter<>"") begin
            constrain customer.state eq sFilter
        end
    end_Procedure
end_object
:
:
Procedure ChangeFilter sNewState
    Set psStateFilter to sNewState
    Send Rebuild_Constraints of Customer_DD
End_procedure

If a change is made in a a filter within a "constrain as" expression (e.g. Constrain Customer as (Customer.State=psStateFilter(self)), the constraint does not need to be rebuilt. Constrain as filters are evaluated each time a record is found and are therefore always up to date.

Rebuild_constraints only rebuilds the constraints for the DDO that receives the message. If you wish to rebuild all constraints in all DDOs you may wish to broadcast the rebuild_constraints message to all DDOs.

Rebuild_constraints will often result in constain commands being executed. The constrain command may change the value of the Found indicator. If you are using the value of Found based on a previous operation, you should be aware that it may get changed.

See Also

OnConstrain | Constrain | pbInheritConstraints

Last Edited: October 9, 2003


BaseData_Set [Procedure Refind_Records]

Refind_Records - BaseData_Set

Checks to see if the record in the File-Buffer is the same as the record in the DDO-Field-Buffer and refinds the record if needed

Type: Procedure

Parameters: No Parameters

Description

If you want to make sure your File-Buffer is synchronized with the DDO-Field-Buffer you can send the message Refind_Records. This checks to see if the record in the File-Buffer is the same as the record in the DDO-Field-Buffer. If it is not, it will re-find the record. This updates the File-Buffer ensuring that the File-Buffer and DDO-Field-Buffer are synchronized. This performs this check for the DDO's Table and all ancestor (parent, grandparent, etc.) DDOs.

The standard method of sending this message is:

Send Refind_Records {of DDO-Object}

For example, you may have a report that runs a batch process in the report's body section which may switch records (the batch process may contain a DDO structure based on the same table). By sending Refind_Records after the process, you can be sure your File-Buffer contains the data for the record in your DDO.

Procedure Body
    string  sFont
    integer iFontSize iStyle
    Handle  hoDD

    Get Server to hoDD // the DDO currently handling the report
    Send Update_Status (String(Customer.Customer_number))

    // this runs a batch process which may find a different customer
    Send CheckForDuplicateCustomers Customer.Customer_number

    // this makes sure that the customer data is correct.
    Send Refind_Records of hoDD

    Move "arial" to sFont
    Move 8 to iFontSize
    Move (font_default) to iStyle

    DfWritePos Customer.Customer_Number       0.8 (iStyle + Font_Right) 0
    DfWritePos Customer.Name                    2 iStyle -1 4.98
    DfWritePos Customer.Address                 7 iStyle -1 4.98
    DfWritePos Customer.City                   12 iStyle -1 3.98
    DfWritePos Customer.State                  15 iStyle -1 0.98
    DfWritePos Customer.Zip                    17 iStyle -1 1.98
End_Procedure  // Body

This example is somewhat contrived - you should rarely need to use Refind_Records.

See Also

Synchronization of File Buffers and DDO-Field-Buffer

Last Edited: July 12, 2005


BaseData_Set [Procedure Remove_Client_File]

Remove_Client_File - BaseData_Set

Removes a table from this object's container-file list

Type: Procedure

Parameters: Integer iFile

Parameter | Description
iFile | Number of table in current filelist

Description

The Remove_Client_File procedure removes a table from this object's container-table list.

Sample

Send Remove_Client_File Orderhea.File_Number

Last Edited: December 16, 2004


BaseData_Set [Procedure Remove_Server_File]

Remove_Server_File - BaseData_Set

Removes a table from this object's server-file list

Type: Procedure

Parameters: Integer iFile

Parameter | Description
iFile | Number of table in current filelist

Description

The Remove_Server_File procedure removes a table from this object's server-table list.

Last Edited: December 16, 2004


BaseData_Set [Procedure Remove_User_Interface]

Remove_User_Interface - BaseData_Set

Removes a table from this object's data entry object (DEO)-list

Type: Procedure

Parameters: Handle hoDEO

Parameter | Description
hoDEO | Object id of object to remove

Description

The Remove_User_Interface procedure removes a data entry object (DEO)-id from this object's DEO-list. If the passed-in object id is not attached to this object, no action occurs. If the removal of the passed-in object id from the set of attached DEOs makes the set empty, this object attempts to set its In_Use_State to False. If the passed-in object id's Auto_Fill_State is True and this object has no other auto-fill DEOs, it will cause Auto_Fill_State of this object to revert to its original value.

Sent by DeActivate procedure of DEOs to disconnect themselves from their server. Opposite of Add_User_Interface.

Last Edited: December 16, 2004


BaseData_Set [Procedure Request_Assign]

Request_Assign - BaseData_Set

Causes the Refresh message to be sent to all data entry objects for this object and its client and server DataDictionary objects as appropriate

Type: Procedure

Parameters: Integer iFile

Parameter | Description
iFile | Number of the table in the current filelist

Description

Send Request_Assign of oCustomer_DD

If you find a record manually (with the Find command) and want to have the DDO "latch onto" and display the current record, you can send the Request_Assign message. Request_Assign will cause the DDO and its parent DDOs to accept the record(s) in the buffer as their current record and refresh all affected DEOs.

Request_Assign should be used with caution. The DDO does not check to see if the records it is accepting are truly related. Because this is a manual process, it makes it your responsibility to make sure that the records in the buffer are reasonable. Before sending Request_Assign, you should make sure that all records in the buffers are proper.

Clear Customer
Move iNum to Customer.Customer_Number
Find EQ Customer by 1
Relate Customer
Send Request_Assign of oCustomer_DD

Often you can use Request_Assign and FindByRowId interchangeably. The following two samples would yield the same result.

Procedure RefindMyFile RowId riRec
    Boolean bOk

    Move (FindByRowId(MyFile.File_Number,riRec)) to bOk
    Relate MyFile
    Send Request_Assign of oMyFile_DD
End_Procedure

or

Procedure RefindMyFile RowId riRec
    Send FindByRowId of oMyFile_DD MyFile.File_Number riRec
End_Procedure

The Request_Assign procedure causes the Refresh message to be sent to all data entry objects (DEOs) for this object and its client and server DataDictionary objects (DDOs) as appropriate. This is to ensure that all data entry objects (DEOs) properly display the record for the current record buffer.

If the current record does not satisfy the constraints, no action occurs (except setting the Found indicator). This procedure sets the Found indicator to True if the record satisfies the constraints; False otherwise.

Request_Assign is not re-entrant. Once a major Data-Dictionary operation (save, find, delete, clear) has begun you cannot start another major operation. The reentrancy restriction applies within DDO structures and across DDO structures.

See Also

Find and Clear Operations in DDOs

Last Edited: July 11, 2005


BaseData_Set [Procedure Request_Clear_File]

Request_Clear_File - BaseData_Set

Performs the Clear command on the specified table of the data-server structure

Type: Procedure

Parameters: Integer iFile

Parameter | Description
iFile | Number of the table in the current filelist

Description

The Request_Clear_File procedure performs the Clear command on the specified table of the data-server structure. It is intended to be used to clear a table and notify this object that the table is actually cleared. This ensures that the refresh of data-entry objects that may occur afterwards will properly clear entry_items for the specified table . (If the Clear command alone is used, the refresh will not clear the entry_items for the specified table). It is intended to be used in an augmentation of the Clear_Main_File procedure to force a manually related table (see the Relate_Main_File message) to be cleared when the main table is being cleared.

Sample

Procedure Clear_Main_File
    // clear_main_file normally
    Forward Send Clear_Main_File

     // also clear "manually" related files
    Send Request_Clear_File Manual1.File_Number
    Send Request_Clear_File Manual2.File_Number
End_Procedure

Last Edited: December 16, 2004


BaseData_Set [Procedure Request_Delete]

Request_Delete - BaseData_Set

esponsible for deleting a record in the DDO for the main_file, updating all parent DDOs (and tables) and possibly deleting all child records

Type: Procedure

Parameters: No Parameters

Description

The Request_Delete message is responsible for deleting a record in the DDO for the main_file, updating all parent DDOs (and tables) and possibly deleting all child records.

Two modes of deleting are supported:

  • A delete will delete all related descendant records.
  • A deletes will not be allowed when child records exist.

The property Cascade_Delete_State controls this message.

Request_Delete is not re-entrant. Once a major Data-Dictionary operation (save, find, delete, clear) has begun you cannot start another major operation. The reentrancy restriction applies within DDO structures and across DDO structures.

See Also

Delete Operations in DDOs

Last Edited: July 11, 2005


BaseData_Set [Procedure Request_Entry_Update]

Request_Entry_Update - BaseData_Set

Sends entry_update to all DEOs of the data set and DEOs of servers of the data set as required to store changes to record buffers

Type: Procedure

Parameters: Integer iFile Integer eUpdate

Parameter | Description
iFile | The file number
eUpdate

Constant | Meaning
0 | Only update changed values (not used)
1 | Update all values (used for finds)
3 | Update for a DDO save

Description

Request_entry_update sends entry_update to all DEOs of the data set and DEOs of servers of the data set as required to store changes to record buffers. This is sent by request_save and item_find.

Last Edited: September 11, 2003


BaseData_Set [Procedure Request_Find]

Request_Find - BaseData_Set

Finds on specified table using given find mode and index

Type: Procedure

Parameters: Integer eFindMode Integer iFile integer iIndex

Parameter | Description
eFindMode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
iFile | Number of the table to perform find operation on
iIndex | Number of table index to use for find operation

Description

The Request_Find procedure finds on specified table using given find mode and index. If find is successful, performs a relate on the table. If the passed in table is the same as this object's Main_File, sends Relate_Main_File. Notifies other connected DataDictionary objects (DDOs) of the result of the find. Sets the Found indicator to reflect the success or failure of the find operation. Sent by DEOs and Item_Find.

If you send this message to a DDO from the program (rather than from a DEO), precede this with Entry_Update 0 1 to make sure the table buffer contains the record you intend to act on.

Sample

This sample will find a record in Data Dictionary Object (DDO) oCustomer_DD with Customer.Id equal to 12, providing that index 1 is a unique index for Customer.Id.

clear Customer
move 12 to Customer.Id
send Request_Find of oCustomer_DD EQ Customer.File_Number 1

Sample

This sample will find the first record in Data Dictionary Object (DDO) oCustomer_DD using index 1. This sample assumes that index 1 is a unique index for Customer.Id.

clear Customer
send Request_Find of oCustomer_DD GE Customer.File_Number 1

Sample

This sample will also find the first record in Data Dictionary Object (DDO) oCustomer_DD using index 1. This sample assumes that index 1 is a unique index for Customer.Id. This code is more readable than that in the sample above since it uses the First_Record constant.

send Request_Find of oCustomer_DD First_Record Customer.File_Number 1

Note:Find mode Next_Record will use the same find direction as the prior Find operation. Using find mode Next_Record must be preceded by a find using one of the other modes, or it will result in an error.

Sample

Procedure FindAll Boolean bFindDown
    Boolean bFound

    If bFindDown begin
        Send Request_Find of Vendor_DD First_Record Vendor.File_number 1
    end
    else begin
        Send Request_Find of Vendor_DD Last_Record Vendor.File_number 1
    end
    Move (Found) to bFound
    While bFound
         Send ProcessThis Record  // not a predefined message
         Send Request_Find of Vendor_DD Next_Record Vendor.File_number 1
         Move (Found) to bFound
   End
End_Procedure  // FindAll

Request_Find is not re-entrant. Once a major Data-Dictionary operation (save, find, delete, clear) has begun you cannot start another major operation. The reentrancy restriction applies within DDO structures and across DDO structures.

See Also

Finding - Find, Request_Find and FindByRowId | Find and Clear Operations in DDOs

Last Edited: September 2, 2005


BaseData_Set [Procedure Request_Read]

Request_Read - BaseData_Set

Finds on specified table using given find mode and index

Type: Procedure

Parameters: Integer eFindMode Integer iFile integer iIndex

Parameter | Description
eFindMode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
iFile | Number of the table to perform find operation on
iIndex | Number of table index to use for find operation

Description

The Request_Read procedure finds on specified table using given find mode and index. If find is successful, performs a relate on the table. If the passed in table is the same as this object's Main_File, sends Relate_Main_File. Notifies other connected DataDictionary objects (DDOs) of the result of the find. Sets the Found indicator to reflect the success or failure of the find operation. Sent by DEOs and Item_Find.

When finding using Request_Read, the DDO does not latch on to the new record. CurrentRowId (Current_Record) and the buffer values do not change. So, you use the Request_Read message when you want to find a record using DD finding logic (constraints, custom relates, etc) but you do not want the DD to get changed. For example, a dbGrid needs to find a record for each row but it only updates the DD one time with the current record. So the dbGrid uses Request_Reads to fill itself and uses Find to latch on to the current record.

If you send this message to a DDO from the program (rather than from a DEO), precede this with Entry_Update 0 1 to make sure the table buffer contains the record you intend to act on.

Note:Find mode Next_Record will use the same find direction as the prior Find operation. Using find mode Next_Record must be preceded by a find using one of the other modes, or it will result in an error.

Last Edited: February 16, 2005


BaseData_Set [Procedure Request_Relate]

Request_Relate - BaseData_Set

Performs a relate on the specified table without initializing the done-array

Type: Procedure

Parameters: Integer iFile

Parameter | Description
iFile | The number of the specified table

Description

The Request_Relate procedure performs a relate on the specified table without initializing the done-array. Intended to be sent within the Relate_Main_File procedure to inform this object that a successful manual relationship has been performed. Sending this message is required so that fields from the target table and its parents will be properly displayed on the data entry objects (DEOs) of this object.

Sample

Class LineItem_DD is a DataDictionary
    :
    Procedure Relate_Main_File    //perform a manual relate to INVT
        Forward Send Relate_Main_File

        Clear Invt
        Move LineItem.Part_Id to invt.part_id
        Find Eq Invt.Part_Id
        If (Found) Send Request_Relate Invt.File_Number
        Else Send Request_Clear_File Invt.File_Number
    End_Procedure  // Relate_Main_File
    :
End_Class

Note that Request_Relate is only sent if the find was successful, and that the target of the manual relationship (a DataDictionary object (DDO) for Invt) must be attached via DDO_Server to the child DDO.

If you send this message to a DDO from the program (rather than from a DEO), precede this with Entry_Update 0 1 to make sure the table buffer contains the record you intend to act on.

Last Edited: December 16, 2004


BaseData_Set [Procedure Request_Save]

Request_Save - BaseData_Set

Saves all changes in DEOs attached to this object or to any DDO that is a server of this object directly or indirectly

Type: Procedure

Parameters: No Parameters

Description

A DDO save is normally a two-step process. First you send Request_Validate to the DDO to make sure that your data is ready for the save. If your data is valid, you then send Request_Save to the DDO to perform the save.

In some cases, you will use objects such as data-entry object (DEOs) to handle the entire save for you. In other cases, you will need to write custom code to perform the save. In all cases, the save process itself is the same.

The Request_Save Message

Send Request_Save of hoDD

When the save operation is performed by a DDO, it saves records into its main table as well as the tables in its parent DDOs. This allows updates in total fields in related tables to be performed as each record in the main table is created or edited. This action can also cause the creation of new records in any of the tables. Any record buffer that was not pointing to an already-existing record will have a new record created.

Function SaveCustomer returns Boolean
    Boolean bErr

    Get Request_Validate of oCustomer_DD to bErr
    If Not bErr Begin
       Send Request_Save of oCustomer_DD
       Move (Err) to bErr
    End

    Function_Return bErr
End_Function

The Request_Save message is responsible for saving new or existing records. When Request_Save is sent to a DDO, it will:

  • Verify that the DDO structure is valid for the save operation.
  • Begin Transaction - From this point on tables are locked (if the database uses table locking) or records are locked as they are found (if the database uses record locking).
  • Re-find all original records. Send Backout to all tables with existing records.
  • If any parent records are switched (i.e., you selected a different parent), save the original records (with backed out data) and re-find the new records.
  • Move all changed data from the DDO-Field buffers to the table file-buffers.
  • Send Creating to all DDOs with new records.
  • Send Update to all participating DDOs.
  • Get Validate_Save of all participating DDOs. If any Validate_Save fails, cancel the operation.
  • If all DDOs validate, attach, and save all records by sending Attach_Main_File and Save_Main_File to every table.
  • End Transaction - either commit changes or roll back changes. Unlock tables.
  • If save was successful, send Refresh all participating DEOs.

Request_Save is not re-entrant. Once a major Data-Dictionary operation (save, find, delete, clear) has begun you cannot start another major operation. The reentrancy restriction applies within DDO structures and across DDO structures.

See Also

Saves - Request_Save | Save Operations in DDOs

Last Edited: July 11, 2005


BaseData_Set [Procedure Request_Superfind]

Request_Superfind - BaseData_Set

Performs superfind on the designated table by the Main_Index of the designated field and notifies all connected DataDictionary objects (DDOs) of the result

Type: Procedure

Parameters: Integer eFindMode Integer iFile integer iField

Parameter | Description
eFindMode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
iFile | Number of the table to perform find operation on
iField | Number of table field to use for find operation

Description

The Request_Superfind procedure performs superfind on the designated table by the Main_Index of the designated field and notifies all connected DataDictionary objects (DDOs) of the result. It sets the Found indicator to reflect the success or failure of the find operation.

In the DataDictionary, dbForm and dbGrid classes, sends of it to a DataDictionary object (DDO) require predefined Indicator Err to be set to False beforehand, in case an error other than "Find past end of table" or "Find prior to beginning of table" is generated by the superfind.

Sample

Send Request_Superfind of Vendor_DD FILE_FIELD OrderHea.Vend_Code

Sample

Send Request_Superfind of Vendor_DD OrderHea.File_Number FIELD APHead.Vend_Code

Sample

Send Request_Superfind of Vendor_DD OrderHea.File_Number 2

Request_Superfind is not re-entrant. Once a major Data-Dictionary operation (save, find, delete, clear) has begun you cannot start another major operation. The reentrancy restriction applies within DDO structures and across DDO structures.

Last Edited: July 11, 2005


Properties for BaseData_Set

View property list in hierarchical order

Name | Description | Defining Class
Can_Delete | Determines if a delete operation of the current record is permitted |
Cascade_Delete_State | Determines how a delete should be affected by the existence of child-file records that relate to the record being deleted |
Changed_State | Determines whether DEOs attached to this object have changed and/or whether a related parent record has changed |
Child_Count | Returns the number of child objects the object contains | cObject
Client_File | Returns the number of the table at the passed-in position in this object's client table list |
Client_File_Count | Returns the number of files in this object's client file list |
Current_Record | The number of the record most recently retrieved from the database |
Data_Set_Client | Returns the object id of the DataDictionary object (DDO) at position iItem in this object's container DDO list |
Data_Set_Client_Count | Returns the number of DataDictionary objects (DDOs) in this object's container DDO list |
Data_Set_Server | Returns the object id of the DataDictionary object (DDO) at position iItem in this object's server DDO list |
Data_Set_Server_Count | Returns the number of DataDictionary objects (DDOs) in this object's server DDO list |
Data_Set_User_Interface | Returns the object id of the data entry object (DEO) at position iItem in this object's user-interface DEO list |
Data_Set_User_Interface_Count | Returns the number of data entry objects (DEOs) in this object's user-interface DEO list |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Entry_Permissive_State | (Obsolete) Determines whether changing of parent record relationships is permitted. |
In_Use_State | Determines whether this object has at least one active user-interface object or one of this object's containers is in use |
Main_File | Identifies the table managed by this Data Dictionary class/object |
Name | Returns the full name of the object including parentage | cObject
No_Delete_State | Determines whether delete operations via this object are permitted |
No_Relate_State | Determines whether relate operations will be executed after find operations by this object |
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Ordering | Specifies the index which should be used for all find operations |
Parent | Returns the parent of an object | cObject
pbAutoFillFromFirst | Allows child DDOs to auto-fill from the last record |
pbInheritConstraints | Determines if a main DDO should inherit its constraints (finding filters) from its parent DDOs |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Read_Only_State | Determines whether save or delete operations will occur in this object's main table |
Server_File | Returns the number of the table at the passed in position in this object's server-file list |
Server_File_Count | Returns the number of table in this object's server-file list |
Should_Save | Can be used to determine if a DDO has changed. |
Should_Save_Row | Determines if a DDO is changed according to dbGrid "row" logic |
Smart_Filemode_For_Lock | Determines the locked file mode setting for tables participating in save or delete operations |
Smart_Filemode_For_No_Lock | Determines the unlocked file mode setting for tables that should not participate in save or delete operations |
Smart_Filemode_State | Governs whether this object can use file-locking optimization for its tables |
Which_Data_Set | Returns object id of object owning specified table |


BaseData_Set [Property Can_Delete]

Can_Delete - BaseData_Set

Determines if a delete operation of the current record is permitted

Type: Property

Access: Read-Only

Data Type: Boolean

Description

The Can_Delete property determines if a delete operation of the current record is permitted. The property respects the Read_Only_State and No_Delete_State of this object.

Returns True if all of the following conditions are True:

  • Main_File >0
  • Current_Record >0
  • This object is in use (In_Use_State is True)
  • This object is not read-only (saves/deletes are permitted)
  • This object is not no-delete (deletes are permitted)

The conditions checked by Can_Delete are used to guard the Request_Delete message in data entry objects (DEOs), so that if Can_Delete returns False, Request_Delete takes no action. This is consistent with the behavior of Request_Save.

Last Edited: August 14, 2003


BaseData_Set [Property Cascade_Delete_State]

Cascade_Delete_State - BaseData_Set

Determines how a delete should be affected by the existence of child-file records that relate to the record being deleted

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set Cascade_Delete_State to True

Cascade_Delete_State specifies how a delete should be affected by the existence of child-file records that relate to the record being deleted.

If Cascade_Delete_State is true, then the child records and all descendant records will be deleted.

If the property is false, the delete will only be allowed if no child records exist.

Both methods ensure that child-file records will never become orphan records.

See Also

Defining Data Dictionary Table Attributes

Last Edited: July 11, 2005


BaseData_Set [Property Changed_State]

Changed_State - BaseData_Set

Determines whether DEOs attached to this object have changed and/or whether a related parent record has changed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Changed_State property is True, one of the data entry objects (DEOs) attached to this object has changed. Set by DEOs.

This property would rarely be set directly. Normally Should_Save should be used to figure out if the DDO structure is changed. Changed_State only looks at changes made to the requsted DDO, where Should_Save tests Changed_State and also checks to see if any of the parent DDO's have their Changed_State set to True.

Last Edited: July 30, 2003


BaseData_Set [Property Client_File]

Client_File - BaseData_Set

Returns the number of the table at the passed-in position in this object's client table list

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iItem Integer iValue

Parameter | Description
iItem | Position of the table in the client list
iValue | Client table number

Description

This property returns the number of the table at the passed-in position in this object's client table list.

Last Edited: December 16, 2004


BaseData_Set [Property Client_File_Count]

Client_File_Count - BaseData_Set

Returns the number of files in this object's client file list

Type: Property

Access: Read-Only

Data Type: Integer

Description

The client_file_count property returns the number of files in this object's client file list.

Last Edited: August 5, 2003


BaseData_Set [Property Current_Record]

Current_Record - BaseData_Set

The number of the record most recently retrieved from the database

Type: Property

Access: Read-Only

Data Type: Integer

Description

Current_Record is the number of the record most recently retrieved from the database. This value becomes zero after a buffer clear, and so is always zero at the time of saving a new record. Edited records, however, retain the value of this property throughout editing.

Important

The Current_Record only works with tables that support a recnum field. As of VDF11, the use of Current_Record is no longer recommended. If you wish to determine the status of a DDO you can use the HasRecord method. If you need the actual record identity of a record you should use CurrentRowId. These messages are are more flexible because they will work with both recnum and non recnum tables.

The following two code segments show a legacy use of Current_Record and how it can be replaced with HasRecord

// legacy method for determining if a record exists
Integer iCurrentRecord
Get Current_record of hoDDO to iCurrentRecord
If (iCurrentRecord>0) begin
     :
end

// Preferred method for determining if a record exists
Boolean bHasRecord
Get HasRecord of hoDDO to bHasRecord
If bHasRecord begin
     :
end

The following two code segments show a legacy use of Current_Record and how it can be replaced with CurrentRowId

// legacy method for working with a record
Integer iCurrentRecord
Get Current_record of hoDDO to iCurrentRecord
Send AddRecordToList iCurrentRecord

// Preferred method for determining if a record exists
RowId riRecord
Get CurrentRowid of hoDDO to riRecord
Send AddRecordToList riRecord

See Also

CurrentRowId | | HasRecord

Last Edited: February 2, 2005


BaseData_Set [Property Data_Set_Client]

Data_Set_Client - BaseData_Set

Returns the object id of the DataDictionary object (DDO) at position iItem in this object's container DDO list

Type: Property

Access: Read-Only

Data Type: Handle

Parameters: Integer iItem Handle hValue

Parameter | Description
iItem | Position of DDO in list
hValue | Handle of the object id that owns iItem

Description

The Data_Set_Client property returns the object id of the DataDictionary object (DDO) at position iItem in this object's container DDO list.

Last Edited: August 18, 2003


BaseData_Set [Property Data_Set_Client_Count]

Data_Set_Client_Count - BaseData_Set

Returns the number of DataDictionary objects (DDOs) in this object's container DDO list

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Data_Set_Client_Count returns the number of DataDictionary objects (DDOs) in this object's container DDO list.

Last Edited: August 5, 2003


BaseData_Set [Property Data_Set_Server]

Data_Set_Server - BaseData_Set

Returns the object id of the DataDictionary object (DDO) at position iItem in this object's server DDO list

Type: Property

Access: Read-Only

Data Type: Handle

Parameters: integer iItem Handle hValue

Parameter | Description
iItem | Position of DDO in list
hValue | Handle of the object id that owns iItem

Description

The Data_Set_Server property returns the object id of the DataDictionary object (DDO) at position iItem in this object's server DDO list.

Last Edited: August 18, 2003


BaseData_Set [Property Data_Set_Server_Count]

Data_Set_Server_Count - BaseData_Set

Returns the number of DataDictionary objects (DDOs) in this object's server DDO list

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Data_Set_Server_Count property returns the number of DataDictionary objects (DDOs) in this object's server DDO list.

Last Edited: August 5, 2003


BaseData_Set [Property Data_Set_User_Interface]

Data_Set_User_Interface - BaseData_Set

Returns the object id of the data entry object (DEO) at position iItem in this object's user-interface DEO list

Type: Property

Access: Read-Only

Data Type: Handle

Parameters: Integer iItem Handle hValue

Parameter | Description
iItem | Position of DEO in list
hValue | Handle of the object id that owns iItem

Description

The Data_Set_User_Interface returns the object id of the data entry object (DEO) at position iItem in this object's user-interface DEO list.

Last Edited: August 18, 2003


BaseData_Set [Property Data_Set_User_Interface_Count]

Data_Set_User_Interface_Count - BaseData_Set

Returns the number of data entry objects (DEOs) in this object's user-interface DEO list

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Data_Set_User_Interface_Count property returns the number of data entry objects (DEOs) in this object's user-interface DEO list.

Last Edited: August 5, 2003


BaseData_Set [Property Entry_Permissive_State]

Entry_Permissive_State - BaseData_Set

Determines whether changing of parent record relationships is permitted.

Type: Property

Obsolete

Access: Read/Write

Data Type: Boolean

Description

If the value of this property is True (the default), changing of parent record relationships is permitted. If the value of this property is False, changing of parent record relationships is not permitted.

For example, suppose we have two files, Parent and Child, where Child relates to Parent. If our database has records Parent-1, Parent-2, and Child-1, where Child-1 relates to Parent-1, we have two possible situations:

1. If Entry_Permissive_State is True, we may find Parent-2 and save the Child-1 record, thus altering the Parent record related to by the Child-1 record from Parent-1 to Parent-2.

2. If Entry_Permissive_State is False, finding Parent-2 would cause the child record buffer to either find a Child record relating to Parent-2 or clear. In effect, if Entry_Permissive_State is False, finds on parent files are treated as superfinds. Since the parent records of this object's Main_File may be owned by its servers, objects of this class respect the Entry_Permissive_State of their clients. If this object is attached to a client whose Entry_Permissive_State is False, all finds on the Main_File of this object become superfinds.

Last Edited: June 23, 2005


BaseData_Set [Property In_Use_State]

In_Use_State - BaseData_Set

Determines whether this object has at least one active user-interface object or one of this object's containers is in use

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The In_Use_State property determines whether this object has at least one active user-interface object or one of this object's containers is in use. Set by Add_User_Interface, Remove_User_Interface, and Activate. Setting the value of this property to True will cause all DDO_Servers of this object to set their In_Use_State(s) to True. Setting the value of this property to False may cause all DDO_Servers of this object to set their In_Use_State(s) to False if this object was their only in-use client. Similarly, this object may refuse to set its In_Use_State to False if one (or more) of its clients is still in use.

Last Edited: August 18, 2003


BaseData_Set [Property Main_File]

Main_File - BaseData_Set

Identifies the table managed by this Data Dictionary class/object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Set Main_File to Customer.File_Number

This identifies the Data Dictionary's table. It must always be set and once set cannot be changed. Setting this property is the minimum requirement of a Data Dictionary.

The most basic Data Dictionary class could be created as follows:

Class cTheMostSimpleCustomer_DD is a DataDictionary

    Procedure Define_Fields
        Forward Send Define_Fields
        set Main_File to MyTable.File_Number
    End_Procedure

End_Class

See Also

Defining Data Dictionary Table Attributes

Last Edited: July 11, 2005


BaseData_Set [Property No_Delete_State]

No_Delete_State - BaseData_Set

Determines whether delete operations via this object are permitted

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set No_Delete_State to True

No_Delete_State disables direct deletes of records. This means that the message Request_Delete sent to this DDO will generate an error and not perform any action.

This message does not affect deletions of records that are part of a cascade delete.

See Also

Defining Data Dictionary Table Attributes

Last Edited: July 11, 2005


BaseData_Set [Property No_Relate_State]

No_Relate_State - BaseData_Set

Determines whether relate operations will be executed after find operations by this object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the No_Relate_State property is True, the relate command will not be executed after any find performed by this object. Certain constraints, i.e., child relates to parent, may not be enforceable if relates do not occur. Note that the Relate_Main_File message will always be sent regardless of the value of No_Relate_State.

Last Edited: September 10, 2003


BaseData_Set [Property Ordering]

Ordering - BaseData_Set

Specifies the index which should be used for all find operations

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Ordering property specifies the index which should be used for all find operations. If this property is greater than or equal to zero, the corresponding index will be used for all find operations. A value of zero indicates that the record number (RECNUM) index should be used.

Sample

This sample gets the Ordering property to variable iIndex.

integer iIndex
get Ordering to iIndex

Sample

This sample sets the Ordering property to Index 2.

set Ordering to 2

Default is -1, which tells the runtime to choose the most-appropriate index based on current constraints.

Last Edited: July 11, 2005


BaseData_Set [Property pbAutoFillFromFirst]

pbAutoFillFromFirst - BaseData_Set

Allows child DDOs to auto-fill from the last record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbAutoFillFromFirst is a DDO property created to allow child DDOs to auto-fill from the first record. This can be used to great advantage and flexibility with the dbGrid/dbList properties Initial_column and pbReverseOrdering.

When a child DDO is related to a parent with a relates-to constraint, the auto_fill_state property of the child DDO determines what it should do when the parent record changes.

If auto_fill_state is set false, the child DDO is cleared when the parent record changes.

If auto_fill_state is set to true, the first valid child is found.

Although auto_fill_state is a DD property you usually don't need to set it explicitly in the DDO. DbGrids will automatically set their DDO's auto_fill_state to true. This is what makes child dbGrids work as they do. When the child DDO auto-finds the first record it notifies the dbGrid that it has a new record. The dbGrid then fills in the rest of records and you see a populated grid.

The property pbAutoFillFromFirst, allows you to determine if the auto-fill record should be the first valid record or the last valid record. The default value for this property is True. This means the first record will be found which is how VDF has always worked. Setting this property to false will force the last record to be found.

This property is most useful when used with a child DDO that has a dbGrid attached to it. It can be used in conjunction with the dbGrid properties Initial_column and pbReverseOrdering (a new property added to 8.2).

For example, setting the DDO's pbAutoFillFromFirst to False and setting the dbGrid's Initial_column property to FILL_FROM_BOTTOM will cause the order entry sample to fill its detail grid from the last record located at the bottom of the grid.

Or, setting a dbGrid's pbReverseOrdering property to True and setting the DDO's pbAutoFillFromFirst property to False would display a grid with the last record presented in the first row and other records displayed in reverse order. This might be useful if your dbGrid is displaying dates which you want displayed with the most recent date displayed first.

Remember that pbAutoFillFromFirst is set inside of the DD object. The properties Initial_column and pbReverseOrdering are set in the dbGrid (or dbList) object.

Default is true.

Last Edited: November 9, 2006


BaseData_Set [Property pbInheritConstraints]

pbInheritConstraints - BaseData_Set

Determines if a main DDO should inherit its constraints (finding filters) from its parent DDOs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Constraints from Parent DDOs are inherited by their Child DDOs. This default behavior may not always be desired and it can be disabled by setting the pbInheritConstraints property to false.

Inheritance of Constraints

Normally a DDO will inherit constraints from its parent DDOs.

A constraint is built or rebuilt when then message Rebuild_Constraints is sent to a DD object. Rebuild_Constraints creates an internal constraint "expression" that contains all of the rules for record filtering for the DDO. Under normal circumstances Rebuild_Constraints does the following:

1. Clear the current constraints for the DDO
2. Send the message Constrain to the DDO. This triggers the OnConstrain event.
3. Execute all constraint commands within the OnConstrain event. Each constraint is added to the DDO's internal constraint expression.
4. After sending OnConstrain, the constrain checks to see if a constrain_file property is non-zero. If so a relates-to constraint is created from the DDO to the file.
5. This process (steps 2 through 4) is then repeated for every parent DDO and this is repeated for every parent in the DDO structure.

When complete, the DDO contains a constraint expression that consists of all constraint commands defined in the main DDO and all constraint commands defined in all parents DDOs. The main DDO inherits all of the constraints of all of its parents (and grandparents, etc.).

When a record is found and parents are related, the constraint expression is run against these records. If any constraint fails, including parent constraints, the record is considered to be invalid. Therefore if a main record is found and one of its parent records contains an invalid constraint, that main record is considered to be invalid.

Most of the time this method works fine. There are times when the inheritance of constraints gets in the way. Consider an order entry system. In a typical system your detail record will relate to an order header and an Inventory parent. Assume you want to limit inventory records to items that are active (e.g., Constrain Invt.Status eq "A"). This would work perfectly for adding new orders. However, if you loaded an old order that now contains detail items for inactive inventory, those detail items will not appear in your list of order lines. This could be confusing.

In such a case, you can stop DDOs from inheriting constraints by setting the pbInheritConstraints property to false. When this happens all of your order lines would appear (because the parent constraint is not used). However, if you tried to select a different or new inventory record the inventory constraint would be enforced (because the constraint for an inventory find is evaluated by the inventory DDO.)

Sample

In this sample, an order DDO structure contains a constraint in the Inventory DDO filtering all records below a certain price. When selecting Invt records only filtered records can be selected. In the Order-detail DDO, constraints are not inherited. Therefore orders will be properly displayed with all detail records - even if the detail points to what is now an invalid Invt parent (we assume it was valid when the order was placed).

    Object oVendor_DD is a Vendor_DataDictionary
    End_Object    // oVendor_DD

    Object oInvt_DD is a Invt_DataDictionary
        Set DDO_Server to oVendor_DD

        Procedure OnConstrain
             constrain invt.Unit_price gt 100
        End_Procedure

    End_Object    // oInvt_DD

    Object oCustomer_DD is a Customer_DataDictionary
    End_Object    // oCustomer_DD

    Object oSalesp_DD is a Salesp_DataDictionary
    End_Object    // oSalesp_DD

    Object oOrderhea_DD is a Orderhea_DataDictionary
        Set DDO_Server to oCustomer_DD
        Set DDO_Server to oSalesp_DD
    End_Object    // oOrderhea_DD

    Object oOrderdtl_DD is a Orderdtl_DataDictionary
        Set DDO_Server to oOrderhea_DD
        Set DDO_Server to oInvt_DD
        Set Constrain_File to Orderhea.File_Number

        // constraints from parent (like Invt) will not be applied
        set pbInheritConstraints to false

    End_Object    // oOrderdtl_DD

    Set Main_DD to oOrderhea_DD
    Set Server to oOrderhea_DD

Placing Parents Constraints in a Child DDO

If you choose not to inherit constraints you can still place parent constraints within a child DDO. You must use the "constrain as" clause to do this. For example, your order detail DDO might contain the following:

Set pbInheritConstraints to False

Procedure OnConstrain
     // The constrain file MUST be the name of DDO's main file
     // but the expression can refer to a parent DDO
     Constrain OrderDtl AS (Invt.Active="A")
End

Some developers may prefer using this technique because it keeps all constraints for a DDO in one place (i.e., you don't have to search the parent DDOs for additional filters.

Note:This is an advanced technique and proper testing is advised. In most cases, changing this property will have no effect on your view.

See Also

OnConstrain | OnConstrain

Last Edited: August 10, 2006


BaseData_Set [Property Read_Only_State]

Read_Only_State - BaseData_Set

Determines whether save or delete operations will occur in this object's main table

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set Read_Only_State to True

Read_Only_State is used to specify that the Data Dictionary cannot be directly used to save or delete records. This means that the messages Request_Save and Request_Delete sent to this DDO will generate an error and not perform an update.

Note that records in a read-only Data Dictionary can be indirectly changed by a save or delete sent to another Data Dictionary within the object structure. For example, if the parent Customer DDO is set to read-only and the main Order Header DDO is not set to read-only, then saves and deletes in Order Header DDO will be allowed to change this Customer data. This is required to maintain database integrity. If you want an entire DDO structure to be read-only you should set all DDOs in the structure to read-only.

Read_Only_State is more likely to be set in a Data Dictionary object and not the class.

See Also

Defining Data Dictionary Table Attributes

Last Edited: January 12, 2006


BaseData_Set [Property Server_File]

Server_File - BaseData_Set

Returns the number of the table at the passed in position in this object's server-file list

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iItem Integer iValue

Parameter | Description
iItem | Position of the table in the server-file list of this object
iValue | Handle of the object id that owns iItem

Description

The Server_File property returns the number of the file at the passed in position in this object's server-file list.

Last Edited: July 11, 2005


BaseData_Set [Property Server_File_Count]

Server_File_Count - BaseData_Set

Returns the number of table in this object's server-file list

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Server_File_Count property returns the number of files in this object's server-file list.

Last Edited: July 11, 2005


BaseData_Set [Property Should_Save]

Should_Save - BaseData_Set

Can be used to determine if a DDO has changed.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Syntax

Get Should_Save of hoDDO to bChanged

Should_Save can be used to determine if a Data Dictionary Object (DDO) has changed. If Should_Save is true, the DDO structure has changed and a save may be needed. Should_Save checks the changed state of a DDO and its parent DDOs. It also checks to see if a parent record has been switched.

There is no set variant of this message. Should_Save is set indirectly through data-input or by other messages such as Set File_Field_Changed_Value, Find, Clear, Request_Save, etc.

Get Should_Save of hoDDO to bChanged

If bChanged begin
    Send Request_Validate of hoDDO to bError
    If (not(bError)) begin
        Send Request_Save of hoDDO
    End
End

By evaluating Should_Save and HasRecord you can determine the major states of any DDO:

 | HasRecord=True | HasRecord=False
Should_Save=True | A changed record exists. A save will edit the existing record. | A new changed record. A save will create a new record.
Should_Save=False | An unchanged record exists. A save is not needed. | A new unchanged record. A save is not needed.

Last Edited: July 11, 2005


BaseData_Set [Property Should_Save_Row]

Should_Save_Row - BaseData_Set

Determines if a DDO is changed according to dbGrid "row" logic

Type: Property

Access: Read-Only

Data Type: Boolean

Description

This is a specialized version of Should_save that is used by dbGrid objects to determine if a row has changed. It will rarely be used by the developer.

See Also

Should_Save

Last Edited: September 11, 2003


BaseData_Set [Property Smart_Filemode_For_Lock]

Smart_Filemode_For_Lock - BaseData_Set

Determines the locked file mode setting for tables participating in save or delete operations

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Smart_Filemode_For_Lock property determines the locked filemode setting for datafiles participating in save or delete operations.

Possible Values:

DF_Filemode_ReadOnly
DF_Filemode_Default
DF_Filemode_Single_User
DF_Filemode_Original

The value of this property is used by Reset_Filemodes_For_Lock as the filemode of database files involved in save or delete operations under lock optimization that are evaluated as eligible to participate in the save. The default value of DF_Filemode_Original leaves unchanged whatever filemode each such file is open as at the time of the save/delete (the property has no effect). If you should desire all such files to be temporarily set to some other filemode for some DataDictionary object(s) (DDOs), you may set this property to that filemode.

Default is DF_Filemode_Original.

Last Edited: July 11, 2005


BaseData_Set [Property Smart_Filemode_For_No_Lock]

Smart_Filemode_For_No_Lock - BaseData_Set

Determines the unlocked file mode setting for tables that should not participate in save or delete operations

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of this property is used by reset_filemodes_for_lock as the filemode of database files involved in save or delete operations under lock optimization that are evaluated as ineligible to participate in the save/delete. The default value of DF_FILEMODE_READONLY leaves the files unlocked, improving both the speed of the save/delete operation and user access to the ineligible files. If you should desire all such files to be temporarily set to some other filemode for some DDO(s), you may set this property to that filemode.

Default is DF_FILEMODE_READONLY.

Last Edited: July 11, 2005


BaseData_Set [Property Smart_Filemode_State]

Smart_Filemode_State - BaseData_Set

Governs whether this object can use file-locking optimization for its tables

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Smart_Filemode_State property governs whether this object can use table-locking optimization for its tables. You should check all views in your existing applications and make sure that there are no unknown tables used in DataDictionary objects (DDOs) in those views. If there are, you can set Smart_Filemode_State to False in the DDOs that utilize unknown tables (which makes all views that use those DDOs operate in non-smart filemode).

Default is True.

Last Edited: December 16, 2004


BaseData_Set [Property Which_Data_Set]

Which_Data_Set - BaseData_Set

Returns object id of object owning specified table

Type: Property

Access: Read-Only

Data Type: Handle

Parameters: Integer iFile Handle hValue

Parameter | Description
iFile | Number of table in current filelist
hValue | Handle of the object id that owns iFile

Description

The Which_Data_Set property returns object id of object owning specified table, or 0 if neither this object nor any of its servers owns the specified table.

Last Edited: December 16, 2004


Events for BaseXmlDomAttribute

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomAttribute

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomAttribute

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psName | Contains the attribute name |
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode
Value | Contains the attribute value |


BaseXmlDomAttribute [Property psName]

psName - BaseXmlDomAttribute

Contains the attribute name

Type: Property

Access: Read-Only

Data Type: String

Description

psName gets and sets the attribute name.

See Also

Value

Last Edited: September 11, 2003


BaseXmlDomAttribute [Property Value]

Value - BaseXmlDomAttribute

Contains the attribute value

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iItem String sValue

Parameter | Description
iItem | [ToDo: In Progress]
sValue | [ToDo: In Progress]

Description

Value gets and sets the value of an attribute

See Also

psName

Last Edited: September 15, 2003


Events for BaseXmlDomcDataSection

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomcDataSection

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomcDataSection

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piLength | Returns the number of characters in the data string | BaseXmlDomCharacterData
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for BaseXmlDomCharacterData

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomCharacterData

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomCharacterData

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piLength | Returns the number of characters in the data string |
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


BaseXmlDomCharacterData [Property piLength]

piLength - BaseXmlDomCharacterData

Returns the number of characters in the data string

Type: Property

Access: Read-Only

Data Type: Integer

Description

piLength returns the number of characters in the data string of the node.

Last Edited: September 11, 2003


Events for BaseXmlDomComment

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomComment

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomComment

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piLength | Returns the number of characters in the data string | BaseXmlDomCharacterData
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for BaseXmlDomDocument

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomDocument

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomDocument

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbAsync | Indicates whether asynchronous download is enabled |
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbPreserveWhiteSpace | Indicates whether whitespace will be preserved in the document |
pbResolveExternals | Contains the external resolution state of the XML parser for this document |
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
pbValidateOnParse | Returns the validation state of the parser |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psURL | Returns the URL of the most recent XML document that contained an error |
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


BaseXmlDomDocument [Property pbAsync]

pbAsync - BaseXmlDomDocument

Indicates whether asynchronous download is enabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbAsync indicates whether asynchronous download is enabled.

Last Edited: February 18, 2004


BaseXmlDomDocument [Property pbPreserveWhiteSpace]

pbPreserveWhiteSpace - BaseXmlDomDocument

Indicates whether whitespace will be preserved in the document

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbPreserveWhiteSpace is a Read/Write property that indicates whether whitespace will be preserved in the document.

Last Edited: September 10, 2003


BaseXmlDomDocument [Property pbResolveExternals]

pbResolveExternals - BaseXmlDomDocument

Contains the external resolution state of the XML parser for this document

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbResolveExternals is a Read/Write property that contains the external resolution state of the XML parser for this document. Externals are namespace, external entity references, and DTD subsets.

Last Edited: September 10, 2003


BaseXmlDomDocument [Property pbValidateOnParse]

pbValidateOnParse - BaseXmlDomDocument

Returns the validation state of the parser

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbValidateOnParse contains the validation state of the parser. When the validation state is set to True, the document is validated against its schema or DTD.

Last Edited: February 16, 2005


BaseXmlDomDocument [Property psURL]

psURL - BaseXmlDomDocument

Returns the URL of the most recent XML document that contained an error

Type: Property

Access: Read-Only

Data Type: String

Description

psURL returns the URL of the most recent XML document that contained an error.

Note that the DomDocument is different (it returns the last loaded URL or "" if a new document)

Last Edited: September 11, 2003


Events for BaseXmlDomDocumentFragment

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomDocumentFragment

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomDocumentFragment

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for BaseXmlDomDocumentType

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomDocumentType

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomDocumentType

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for BaseXmlDomElement

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomElement

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomElement

View property list in hierarchical order

Name | Description | Defining Class
AttributeValue | Gets and sets attributes in an element |
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psTagName | The element name |
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


BaseXmlDomElement [Property AttributeValue]

AttributeValue - BaseXmlDomElement

Gets and sets attributes in an element

Type: Property

Access: Read/Write

Data Type: String

Parameters: String sName String sValue

Parameter | Description
sName | The Attribute Name
sValue | The Attribute Value

Description

AttributeValue is used to get and set attribute data in an element node. An attribute named sName with a value of sValue is set or retrieved.

AttributeValue is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

Last Edited: February 17, 2005


BaseXmlDomElement [Property psTagName]

psTagName - BaseXmlDomElement

The element name

Type: Property

Access: Read-Only

Data Type: String

Description

psTagName is the element name (the name that appears within the tag).

Last Edited: September 11, 2003


Events for BaseXmlDomEntity

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomEntity

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomEntity

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psNotationName |  |
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psPublicId |  |
psSystemId |  |
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


BaseXmlDomEntity [Property psNotationName]

psNotationName - BaseXmlDomEntity

Type: Property

Access: Read-Only

Data Type: String

Description

Last Edited: February 13, 2003


BaseXmlDomEntity [Property psPublicId]

psPublicId - BaseXmlDomEntity

Type: Property

Access: Read-Only

Data Type: String

Description

Last Edited: February 13, 2003


BaseXmlDomEntity [Property psSystemId]

psSystemId - BaseXmlDomEntity

Type: Property

Access: Read-Only

Data Type: String

Description

Last Edited: February 13, 2003


Events for BaseXmlDomEntityReference

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomEntityReference

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomEntityReference

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for BaseXmlDomImplementation

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomImplementation

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomImplementation

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject


Events for BaseXmlDomNamedNodeMap

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


BaseXmlDomNamedNodeMap [Function Reset]

Reset - BaseXmlDomNamedNodeMap

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


Methods for BaseXmlDomNamedNodeMap

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Reset | Function |  |


Properties for BaseXmlDomNamedNodeMap

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject


Events for BaseXmlDomNode

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomNode

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomNode

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes |
pbParsed | Returns true if node has been parsed |
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node |
psBaseName | Returns the node name with the namespace prefix removed |
psNamespaceURI | Returns the URI for the namespace as a string |
psNodeName | Returns a string containing the name that was set at the time the node was created |
psNodeValue | Contains the contents of a node |
psPrefix | Returns the element namespace prefix |
psText | Returns a string that is the textual representation of the node and its descendants |
psXML | Returns the XML representation of the node and its descendant nodes as a string |


BaseXmlDomNode [Property HasChildNodes]

HasChildNodes - BaseXmlDomNode

Indicates whether a node has child nodes

Type: Property

Access: Read-Only

Data Type: Boolean

Description

HasChildNodes indicates whether a node has child nodes. This is a quick way to find out whether a node has children. It always returns 0 for nodes that, by definition, cannot have children: cXmlDomTextNode, cXmlDomComment, cXmlDomCDataSection, cXmlDomProcessingInstruction, cXmlDomNotation

Last Edited: August 18, 2003


BaseXmlDomNode [Property paXML]

paXML - BaseXmlDomNode

Returns an address of the XML representation of the node and its descendant nodes

Type: Property

Access: Read-Only

Data Type: Address

Description

paXML returns the address of the XML representation of the node and its descendant nodes.

This property is used like psXML except that it is the address of the data. Because it is not a string, it can be of any size. This property is typically used in WebApp applications to return large amounts of XML data to an ASP page.

Note:This property allocates memory for the data and it is therefore important that the data be disposed of when you are done. This is done using the Free() function.

There are two ways you can use this property. If you are using the data but not returning it, you must dispose of it. If you are returning the data as an address (function_return returns an address), it is the job of the method receiving the function return to dispose of the data. If the returning function is part of your DataFlex application you must free the data when you no longer need it. If the data is being returned to an ASP page, WebApp will dispose of the data for you.

Example:

Here is an example of the first way:

Procedure WriteXMLDocument string sURL
    Handle hoXML
    Integer bOK
    Address pXML
    Get Create U_cXMLDomDocument To hoXML
    Set psDocumentName of hoXML to sUrl
    set pbAsync of hoXML to False
    Get LoadXmlDocument Of hoXML To bOK
    If bOK begin
        Get paXML of hoXML to pXML
        Send WriteData pXML
        Move (Free(pXML)) to bOk
   end
   Send Destroy of hoXML
End_Procedure

This sample can be used to output any XML document to your ASP page. In fact, the XML document could reside on some other server.

Example:

Here is an example of the second way:

Function OutXML string sURL returns address
    Handle hoXML
    Integer bOK
    Address pXML
    Get Create U_cXMLDomDocument To hoXML
    Set psDocumentName of hoXML to sUrl
    set pbAsync of hoXML to False
    Get LoadXmlDocument Of hoXML To bOK
    If bOK ;
        Get paXML of hoXML to pXML
    Send Destroy of hoXML
    Function_return pXML // let whoever called me, dispose of me.

End_Function

// registered as follows: RegisterInterface get_OutXML "get_OutXml"
//                         "string sURL returns address" "fetch XML document"

In WebApp an ASP page might call this as follows:

<xml ID="XMLIsland">
<%
      sXML = oCustomer.call("get_OutXML", sSomeURL)
      response.write(sXML)
%>
</xml>

Note that there is no need to dispose of the pointer data because WebApp does it for you.

See Also

psXML | SaveXMLDocument | LoadXMLDocument | LoadXML | LoadXMLFromAddress

Last Edited: November 2, 2003


BaseXmlDomNode [Property pbParsed]

pbParsed - BaseXmlDomNode

Returns true if node has been parsed

Type: Property

Access: Read-Only

Data Type: Integer

Description

pbParsed returns true if node and its descendants have been parsed. This is not currently used.

Last Edited: September 10, 2003


BaseXmlDomNode [Property pbSpecified]

pbSpecified - BaseXmlDomNode

Indicates if attribute node is explicitly specified or derived from DTD or Schema

Type: Property

Access: Read-Only

Data Type: Boolean

Description

The pbSpecified property Indicates if node is explicitly specified or derived from a default value in the DTD or Schema. This is usually only used with attributes.

Last Edited: September 10, 2003


BaseXmlDomNode [Property piNodeType]

piNodeType - BaseXmlDomNode

The type of the node

Type: Property

Access: Read-Only

Data Type: Integer

Description

piNodeType is the type of the node (for example, Attribute, Notation, Text, Comment, etc.) The following table is a list of all node types supported:

Node Name Constant | Number Constant | Node Type
NODE_ELEMENT | 1 | Element Node
NODE_ATTRIBUTE | 2 | Attribute node
NODE_TEXT | 3 | Text node
NODE_CDATA_SECTION | 4 | CDATA Section node
NODE_ENTITY_REFERENCE | 5 | Entity Reference Node
NODE_ENTITY | 6 | Entity node
NODE_PROCESSING_INSTRUCTION | 7 | Processing Instruction node
NODE_COMMENT | 8 | Comment node
NODE_DOCUMENT | 9 | Document node
NODE_DOCUMENT_TYPE | 10 | Document Type (DTD) node
NODE_DOCUMENT_FRAGMENT | 11 | Document Fragment node
NODE_NOTATION | 12 | Notation node

Example

Get piNodeType Of hoNode To iType
Showln  "The type of the node is " iType

Last Edited: September 11, 2003


BaseXmlDomNode [Property psBaseName]

psBaseName - BaseXmlDomNode

Returns the node name with the namespace prefix removed

Type: Property

Access: Read-Only

Data Type: String

Description

psBaseName returns the node name with the namespace prefix removed. For example, in a node declared as <myNameSpace:elementName> it would return the element part elementName.

See Also

psPrefix | psNameSpaceURI

Last Edited: September 11, 2003


BaseXmlDomNode [Property psNamespaceURI]

psNamespaceURI - BaseXmlDomNode

Returns the URI for the namespace as a string

Type: Property

Access: Read-Only

Data Type: String

Description

The psNamespaceURI property returns the URI for the namespace as a string. For example, for the namespace declaration xmlns:name="uri" it would return uri.

See Also

psBaseName | psPrefix

Last Edited: September 11, 2003


BaseXmlDomNode [Property psNodeName]

psNodeName - BaseXmlDomNode

Returns a string containing the name that was set at the time the node was created

Type: Property

Access: Read-Only

Data Type: String

Description

psNodeName returns a string containing the name that was set at the time the node was created. The meaning of the node name varies as shown below, depending on the type of node. Some types of nodes (text nodes, cdata-section nodes, comment nodes, document nodes, and document fragment nodes) have non-unique node names assigned by the system.

Constant | Meaning
Element | Tag name
Attribute | Attribute name
Text Nodes | #text
CDATASection Nodes | #cdata-section
EntityReference | Name of entity referenced
Entity | Entity Name
ProcessingInstruction | Target Name
Comment | #comment
Document | #document
DocumentType Node | Document Type Name
DocumentFragment | #document-fragment
Notation | Notation name

Example

Get psNodeName Of hoNode To sName
Showln  "The name of the node is " sName

Last Edited: September 11, 2003


BaseXmlDomNode [Property psNodeValue]

psNodeValue - BaseXmlDomNode

Contains the contents of a node

Type: Property

Access: Read/Write

Data Type: String

Description

psNodeValue contains the contents of a node.

Last Edited: September 11, 2003


BaseXmlDomNode [Property psPrefix]

psPrefix - BaseXmlDomNode

Returns the element namespace prefix

Type: Property

Access: Read-Only

Data Type: String

Description

psPrefix returns the element namespace as a string. For example, in a node declared as <myNameSpace:elementName> it would return myNameSpace.

See Also

psBaseName | psNameSpaceURI

Last Edited: September 11, 2003


BaseXmlDomNode [Property psText]

psText - BaseXmlDomNode

Returns a string that is the textual representation of the node and its descendants

Type: Property

Access: Read/Write

Data Type: String

Description

psText returns a string that is the textual representation of the node and its descendants, including tags and markups.

Last Edited: September 11, 2003


BaseXmlDomNode [Property psXML]

psXML - BaseXmlDomNode

Returns the XML representation of the node and its descendant nodes as a string

Type: Property

Access: Read-Only

Data Type: String

Description

psXML returns the XML representation of the node and its descendant nodes as a string. If you send psXML to your cXMLDomDocument object, the entire XML object will be returned as a string.

Because psXML returns a string, the maximum size of the string is limited by the string argument size. This can be set and determined by using the commands Set_Argument_Size and Get_Argument_Size.

You may also use the paXML property which returns the XML node as a memory address. Because it is not a string, it can be of any size.

Procedure WriteXMLDocument string sURL
    Handle hoXML
    Integer bOK
    String sXML

    Get Create U_cXMLDomDocument To hoXML
    Set psDocumentName of hoXML to sUrl
    set pbAsync of hoXML to False
    Get LoadXmlDocument Of hoXML To bOK
    If bOK begin
        Get psXML of hoXML to sXML
        Send DoSomethingWithXML sXML
   end
End_Procedure

An XML document maybe loaded from a string using the LoadXML method.

An XML document may be loaded from an address using the LoadXMLFromAddress method.

See Also

paXML | SaveXMLDocument | LoadXMLDocument | LoadXML | LoadXMLFromAddress

Last Edited: June 22, 2005


Events for BaseXmlDomNodeList

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


BaseXmlDomNodeList [Function Reset]

Reset - BaseXmlDomNodeList

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


Methods for BaseXmlDomNodeList

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Reset | Function |  |


Properties for BaseXmlDomNodeList

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject


Events for BaseXmlDomNotation

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomNotation

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomNotation

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psPublicId |  |
psSystemId |  |
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


BaseXmlDomNotation [Property psPublicId]

psPublicId - BaseXmlDomNotation

Type: Property

Access: Read-Only

Data Type: String

Description

Last Edited: February 13, 2003


BaseXmlDomNotation [Property psSystemId]

psSystemId - BaseXmlDomNotation

Type: Property

Access: Read-Only

Data Type: String

Description

Last Edited: February 13, 2003


Events for BaseXMLDomParseError

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXMLDomParseError

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXMLDomParseError

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piErrorCode | Returns an error code |
piFilePos | Returns the absolute character position in the file where the error occurred |
piLine | Returns the number of the line in the document that contains the error |
piLinePos | Returns the character position of the error within the line in which it occurred |
psReason | Returns the text description of the source and the reason for the error |
psSrcText | Returns the full text of the line that contains the error, or an empty string if the error cannot be assigned to a specific line |
psURL | Returns the URL of the most recent XML document that contained an error |


BaseXMLDomParseError [Property piErrorCode]

piErrorCode - BaseXMLDomParseError

Returns an error code

Type: Property

Access: Read-Only

Data Type: Integer

Description

piErrorCode returns an error code.

Last Edited: September 11, 2003


BaseXMLDomParseError [Property piFilePos]

piFilePos - BaseXMLDomParseError

Returns the absolute character position in the file where the error occurred

Type: Property

Access: Read-Only

Data Type: Integer

Description

piFilePos returns the absolute character position in the file where the error occurred.

Last Edited: September 11, 2003


BaseXMLDomParseError [Property piLine]

piLine - BaseXMLDomParseError

Returns the number of the line in the document that contains the error

Type: Property

Access: Read-Only

Data Type: Integer

Description

piLine returns the number of the line in the document that contains the error.

Last Edited: September 11, 2003


BaseXMLDomParseError [Property piLinePos]

piLinePos - BaseXMLDomParseError

Returns the character position of the error within the line in which it occurred

Type: Property

Access: Read-Only

Data Type: Integer

Description

piLinePos returns the character position of the error within the line in which it occurred.

Last Edited: September 11, 2003


BaseXMLDomParseError [Property psReason]

psReason - BaseXMLDomParseError

Returns the text description of the source and the reason for the error

Type: Property

Access: Read-Only

Data Type: String

Description

psReason returns the text description of the source and the reason for the error, and can also include the URL of the DTD or SCHEMA and the node within it that that corresponds to the error.

Last Edited: September 11, 2003


BaseXMLDomParseError [Property psSrcText]

psSrcText - BaseXMLDomParseError

Returns the full text of the line that contains the error, or an empty string if the error cannot be assigned to a specific line

Type: Property

Access: Read-Only

Data Type: String

Description

psSrcText returns the full text of the line that contains the error, or an empty string if the error cannot be assigned to a specific line.

Last Edited: September 11, 2003


BaseXMLDomParseError [Property psURL]

psURL - BaseXMLDomParseError

Returns the URL of the most recent XML document that contained an error

Type: Property

Access: Read-Only

Data Type: String

Description

psURL returns the URL of the most recent XML document that contained an error.

Note that the DomDocument is different (it returns the last loaded URL or "" if a new document)

Last Edited: September 11, 2003


Events for BaseXmlDomProcessingInstruction

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomProcessingInstruction

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomProcessingInstruction

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psTarget |  |
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


BaseXmlDomProcessingInstruction [Property psTarget]

psTarget - BaseXmlDomProcessingInstruction

Type: Property

Access: Read-Only

Data Type: String

Description

Last Edited: February 13, 2003


Events for BaseXmlDomTextNode

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for BaseXmlDomTextNode

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for BaseXmlDomTextNode

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piLength | Returns the number of characters in the data string | BaseXmlDomCharacterData
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


BasicPanel [Event Notify_Exit_Application]

Notify_Exit_Application - BasicPanel

Sent when the application is about to be ended

Type: Event

Parameters: No Parameters

Description

The Notify_exit_application message is sent when the application is about to be ended. This is a notification; the application will be ended and you cannot change this. This does nothing by default and is intended for augmentation (and is augmented by subclasses).

Last Edited: September 10, 2003


BasicPanel [Event OnActivateApp]

OnActivateApp - BasicPanel

Sent when the panel and, therefore, the application is activated

Type: Event

Parameters: No Parameters

Description

The OnActivateApp event message is sent when the panel and, therefore, the application is activated. This is a notification and does nothing by default.

Last Edited: September 10, 2003


BasicPanel [Event OnBeginningOfPanel]

OnBeginningOfPanel - BasicPanel

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


BasicPanel [Event OnDeactivateApp]

OnDeactivateApp - BasicPanel

Sent when this object is deactivated

Type: Event

Parameters: No Parameters

Description

The OnDeactivateApp event message is sent when this object is deactivated. This is a notification and does nothing by default. This does not necessarily mean that the application is being exited. This message is called when the focus is moved to another Windows application.

Last Edited: September 10, 2003


BasicPanel [Event OnKillFocus]

OnKillFocus - BasicPanel

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


BasicPanel [Event OnPaint]

OnPaint - BasicPanel

Sent every time a panel is painted

Type: Event

Parameters: No Parameters

Description

The OnPaint event message is sent every time a panel is painted.

Last Edited: September 10, 2003


BasicPanel [Event OnResize]

OnResize - BasicPanel

Sent every time a panel is resized

Type: Event

Parameters: No Parameters

Description

The OnResize event message is sent every time a panel is resized. This message is only sent when the panel is active (paged on the screen). It is also sent when the panel is being paged. This message is most-often used to size and locate child objects when a panel has been paged or resized.

Procedure onResize
    // locate and size child objects relative to the size of the parent
    Broadcast Send Locate_yourself
End_procedure

Last Edited: September 10, 2003


BasicPanel [Event OnSetFocus]

OnSetFocus - BasicPanel

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


BasicPanel [Event Prompt_Callback]

Prompt_Callback - BasicPanel

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


BasicPanel [Event Shadow_Display]

Shadow_Display - BasicPanel

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


BasicPanel [Event Verify_Exit_Application]

Verify_Exit_Application - BasicPanel

Sent when there has been a request made to close the application

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returning a non-zero value will halt this process (the program will continue to run).

Description

The Verify_exit_application message is sent when there has been a request made to close the application. This does nothing by default and is intended for augmentation (and is augmented by subclasses).

Last Edited: September 15, 2003


Events for BasicPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Exit_Application | Sent when the application is about to be ended |
OnActivateApp | Sent when the panel and, therefore, the application is activated |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp | Sent when this object is deactivated |
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus |
OnPaint | Sent every time a panel is painted |
OnResize | Sent every time a panel is resized |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |
Verify_Exit_Application | Sent when there has been a request made to close the application |


BasicPanel [Function Next_Object_Id]

Next_Object_Id - BasicPanel

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


BasicPanel [Function Prior_Object_Id]

Prior_Object_Id - BasicPanel

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for BasicPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated |
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


BasicPanel [Procedure Activate_Area]

Activate_Area - BasicPanel

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


BasicPanel [Procedure Beginning_of_Panel]

Beginning_of_Panel - BasicPanel

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


BasicPanel [Procedure Bottom_of_Panel]

Bottom_of_Panel - BasicPanel

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


BasicPanel [Procedure Close_Panel]

Close_Panel - BasicPanel

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


BasicPanel [Procedure DoHtmlHelp]

DoHtmlHelp - BasicPanel

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


BasicPanel [Procedure End_of_Panel]

End_of_Panel - BasicPanel

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


BasicPanel [Procedure Error_Help]

Error_Help - BasicPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


BasicPanel [Procedure Extended_Help]

Extended_Help - BasicPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


BasicPanel [Procedure File_Help]

File_Help - BasicPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


BasicPanel [Procedure Help]

Help - BasicPanel

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


BasicPanel [Procedure Help_For_Help]

Help_For_Help - BasicPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


BasicPanel [Procedure Help_Index]

Help_Index - BasicPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


BasicPanel [Procedure Help_on_topic]

Help_on_topic - BasicPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


BasicPanel [Procedure Keys_Help]

Keys_Help - BasicPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


BasicPanel [Procedure Popup_Modal]

Popup_Modal - BasicPanel

Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns non-zero if popup failed (this value is normally not used)

Description

The Popup_modal message activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated. This message sets the modal_state property true until this object is deactivated, at which time it is restored to false. This message has no effect on an already-active object.

Send Popup_modal to oCustomerList

Last Edited: September 25, 2003


BasicPanel [Procedure Request_Status_Help]

Request_Status_Help - BasicPanel

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


BasicPanel [Procedure Stop_Modal_UI]

Stop_Modal_UI - BasicPanel

Causes the modal object to deactivate

Type: Procedure

Parameters: No Parameters

Description

When the Stop_modal_ui message is received, the current user interface is terminated. This causes the modal object to deactivate.

Last Edited: September 11, 2003


BasicPanel [Procedure Top_of_Panel]

Top_of_Panel - BasicPanel

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for BasicPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true |
Bitmap | Displays a bitmap in an object |
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id | The ID of the panels's client-area object |
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  |
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program |
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  |
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows |
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Statusbar_Id | The ID of the panel's status-bar object |
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id | The ID of the panel's tool-bar objec |
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


BasicPanel [Property Auto_Locate_State]

Auto_Locate_State - BasicPanel

Locates itself relative to any item that invokes it with a popup message when set true

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_Locate_State property is true, this object will locate itself relative to any item that invokes it with a popup message (i.e., relative to the position of the cursor in another object when the prompt key was pressed). The position at which this object pops up depends on the values of its column_offset and row_offset properties.

This property exists primarily for backwards compatibility. You are encouraged to use the more powerful locate_mode property in its place.

Default is false.

Last Edited: January 12, 2006


BasicPanel [Property Bitmap]

Bitmap - BasicPanel

Displays a bitmap in an object

Type: Property

Access: Read/Write

Data Type: String

Description

The Bitmap message will display a bitmap in an object. In other words, the bitmap becomes the background of the object.
Bitmap_Style determines how and where the bitmap will display in the object.

There are two potential drawbacks to using bitmaps: the amount of storage (on disk) , and the constant memory consumption.

Sample

This sample sets the bitmap to "MyBitmap.bmp".

set Bitmap to "MyBitmap.bmp"

Note:
In order to make a cohesive application, Visual DataFlex must find the .EXE file and the .bmp (bitmap) file, by using DFPATH.

Last Edited: November 24, 2004


BasicPanel [Property Client_Id]

Client_Id - BasicPanel

The ID of the panels's client-area object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Client_id is the ID of the panels's client-area object. Client-area objects are not supported by the BasicPanel so this ID should be zero. They are supported by the subclass AppPanel.

Default is current object.

Last Edited: July 30, 2003


BasicPanel [Property Column_Offset]

Column_Offset - BasicPanel

Determines the offset to the invoking item by number of columns

Type: Property

Access: Read/Write

Data Type: Integer

Description

If this object is located using POPUP_LOCATE logic (or auto_locate_state is true), it will pop up to the right of the invoking item by the number of columns in the Column_Offset property and below it by the number of rows in row_offset. This property may have a negative, as well as positive, value. The offset is stated as a number of characters, these being of an averaged size for the font currently in effect.

Default is 2.

Last Edited: August 5, 2003


BasicPanel [Property Current_Action_Button]

Current_Action_Button - BasicPanel

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


BasicPanel [Property Default_Action_Button]

Default_Action_Button - BasicPanel

The object handle of the default action button

Type: Property

Access: Read/Write

Data Type: Integer

Description

A single button object within a panel/dialog object may be designated as the default-action button. This button is assigned by setting its default_action_button property. This property is not normally set directly. Instead, you will usually set the default_state of the button (which, in turn, will set the Default_action_button property). The following two samples will exhibit the same behavior.

Object OK_bn is a Button
    Set Label to "&Ok"
    Set Location to 115 152
    Set default_state to TRUE
    Procedure OnClick
        Send Save_record
    End_Procedure
End_Object

and:

Object OK_bn is a Button
    Set Label to "&Ok"
    Set Location to 115 152
    Procedure OnClick
        Send Save_record
    End_Procedure
End_Object
Set default_action_button to Ok_bn

See default_state in the button class for more information on default action buttons.

Last Edited: July 31, 2003


BasicPanel [Property Enabled_State]

Enabled_State - BasicPanel

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


BasicPanel [Property Explicit_Shadow_State]

Explicit_Shadow_State - BasicPanel

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


BasicPanel [Property Help_id]

Help_id - BasicPanel

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


BasicPanel [Property Help_Keyword]

Help_Keyword - BasicPanel

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


BasicPanel [Property Item_Shadow_State]

Item_Shadow_State - BasicPanel

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


BasicPanel [Property Label]

Label - BasicPanel

This is the text that appears within this control

Type: Property

Access: Read/Write

Data Type: String

Description

This is the text that appears within this control. It can be set and queried through this property.

When used with the Button class, this sets the text within the button.

When used with the CheckBox class, this sets the text that appears to the right of the checkbox.

When used with the TextBox class, this sets the text that appears inside of the textbox.

When used with containers (Panel, Group, dbGroup), this sets the text that appears in the container.

See Also

Button | CheckBox | TextBox | Panel | Group | dbGroup

Last Edited: August 18, 2003


BasicPanel [Property Locate_Mode]

Locate_Mode - BasicPanel

Provides several flexible methods for auto positioning container panels in your program

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Locate_Mode property provides several flexible methods for auto positioning container panels in your program. The following modes are supported:

Constant | Meaning
NO_LOCATE | No auto-location is performed. The object must be manually located by using the set location message.
POPUP_LOCATE | This causes the object to locate itself relative to the object (and item) that invoked it. It is ideal for locating popup modal objects (like selection-lists). The position at which this object pops up depends on the values of its column_offset and row_offset properties.
CENTER_ON_SCREEN | This causes the container to appear in the center of the screen.
CENTER_ON_PANEL | This causes the container to centered within the current main program panel.
CENTER_ON_PARENT | This causes the container to appear in the center of its parent container.
SMART_LOCATE | This mode "just does the right thing". This message will cause the object to apply the best locating strategy for current conditions. If the object is a modal popup (modal_state is true) and there is an invoking object it will locate relative to the invoking object (popup_locate), else, if the object already has been assigned a location it will use that location. else, if main-panel exists it will center within that panel (center_on_panel), else, it will center itself on the screen (center_on_screen). All panels default to this mode. This causes modal popup panels to locate relative to their parent and modeless panels to appeared centered unless explicitly located.

Default is SMART_LOCATE.

Last Edited: September 10, 2004


BasicPanel [Property Modal_State]

Modal_State - BasicPanel

Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated

Type: Property

Access: Read/Write

Data Type: Boolean

Description

This property is set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, and false when the object popped up by popup_modal is deactivated. When this property is set to true, the following properties are set:

Block_mouse_State | true
Attach_Parent_State | false
Scope_State | true
Ring_State | true
Popup_State | true

When this property is set to false, the following properties are set:

Block_mouse_State | false
Attach_Parent_State | true

Normally you will not set this property to false since this is the default. If you need to alter these individual property settings, you can either augment the modal_state procedure set or you can simply adjust any of the individual properties after you have set the modal_state.

If you wish to toggle an object's modality during runtime, it is suggested that you not set this property. You will need the object in its default modeless state. The object can then be activated non-modally by sending it the activate message and activated modally by sending it the popup_modal message.

Default is false.

Last Edited: January 12, 2006


BasicPanel [Property Object_Shadow_State]

Object_Shadow_State - BasicPanel

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


BasicPanel [Property Offset_Location]

Offset_Location - BasicPanel

Type: Property

Access: Write-Only

Data Type: Integer

Parameters: integer Row# Integer Col#

Parameter | Description
Row# | [ToDo: In Progress]
Col# | [ToDo: In Progress]

Description

Last Edited: July 8, 2003


BasicPanel [Property psHtmlHelpTopic]

psHtmlHelpTopic - BasicPanel

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


BasicPanel [Property Row_Offset]

Row_Offset - BasicPanel

Determines the offset to the invoking item by number of rows

Type: Property

Access: Read/Write

Data Type: Integer

Description

If this object is located using POPUP_LOCATE logic (or auto_locate_state is true), it will pop up to the right of the invoking item by the number of columns in column_offset and below it by the number of rows in the Row_Offset property. This property may have a negative, as well as positive, value. This offset is stated as a number of rows, these being the row height for the font currently in effect.

Default is 1.

Last Edited: September 11, 2003


BasicPanel [Property Status_Help]

Status_Help - BasicPanel

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


BasicPanel [Property Statusbar_Id]

Statusbar_Id - BasicPanel

The ID of the panel's status-bar object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Statusbar_id is the ID of the panel's status-bar object. Status bars are not supported by this class, so object should be zero. Status bars are supported by the subclasses AppPanel and panel.

Last Edited: September 11, 2003


BasicPanel [Property Toolbar_Id]

Toolbar_Id - BasicPanel

The ID of the panel's tool-bar objec

Type: Property

Access: Read/Write

Data Type: Integer

Description

Toolbar_id is the ID of the panel's tool-bar object. Tool bars are not supported by this class, so object should be zero. Tool bars are supported by the subclass AppPanel.

Last Edited: September 11, 2003


BasicPanel [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - BasicPanel

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


BasicReport [Event Ending_Main_Report]

Ending_Main_Report - BasicReport

Augmented to print/preview the report if AutoOutput_State is set to true

Type: Event

Parameters: No Parameters

Description

The Ending_main_report event is augmented to print/preview the report if AutoOutput_State is set to true.

Last Edited: August 5, 2003


BasicReport [Event Error_Report]

Error_Report - BasicReport

Sent whenever an error is generated

Type: Event

Parameters: integer ErrNum integer Err_Line string ErrMsg

Parameter | Description
ErrNum | the error number
Err_Line | the error line
ErrMsg | the error message

Description

When a report is started, the main report (the outermost of a group of nested reports) is assigned as the error object. This means that all errors are sent to this object. The Error_Report message is sent whenever an error is generated. By default, the status panel is removed, the property error_check_state is set true, and the error is then directed to the normal error handler (the object defined as the error object when the report started). If status_log_state is true, errors will be written to the status-log file. If display_error_state is true, the error is directed to the global error-handler object. This sends onError.

Note: Previous versions of Visual DataFlex only required two parameters for this message - the error number and line number was packed in a single complex integer. Three parameters are now required. If you have old code that uses this, it must be changed.

Last Edited: August 5, 2003


BasicReport [Event onError]

onError - BasicReport

Provided as a hook to handle custom error reporting

Type: Event

Parameters: integer ErrNum integer Err_Line string ErrMsg

Parameter | Description
ErrNum | the error number
Err_Line | the error line
ErrMsg | the error message

Description

OnError does nothing by default and is provided as a hook to handle custom error reporting. This message is designed for augmentation and should never be sent. It is sent whenever an error occurs (it is sent by Error_report.).

This message is sent by error_report (which is itself called anytime an error occurs). If you study error_report, you will see that this procedure might have already logged the error in a status log (if status_log_state is true) and might have reported the error in a message box (if display_error_state is true). Often these options will be all that is required and there will be no need to augment this message. If status_log_state is false and display_error_state is false (both of these are the defaults), then no error processing has occurred and you may wish to augment this procedure to handle an error.

Last Edited: June 22, 2005


BasicReport [Event Report_Interrupt]

Report_Interrupt - BasicReport

Called when the status panel's Cancel button has been pressed

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Return a zero value if the report is to continue, or non-zero to stop the report.

Description

Report_interrupt is called when the status panel's Cancel button has been pressed. Normally it displays a message asking the user if they wish to cancel the report. If the user selects Yes, a non-zero value is returned and the report is terminated. If a zero value is returned, the report continues. You may augment this message to present custom choices. The report is suspended at this point.

The property Error_Check_State can be queried from within this function. If it is non-zero, then the interrupt has been caused by an error.

Last Edited: September 11, 2003


BasicReport [Event Starting_Main_Report]

Starting_Main_Report - BasicReport

Called only if the current report is an outer report

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

A non-zero return value will cancel the report.

Description

Starting_main_report is called only if the current report is an outer report (it has no parent report-its child_rpt_state is false). This is a very useful user hook where you can initialize report values and set up your output device and channels.

Last Edited: September 11, 2003


Events for BasicReport

View event list in hierarchical order

Name | Description | Defining Class
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property | Report
Body | Called once for every record selected for the report to provide processing for record data (if any) not used for subheaders and subtotals | Report
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Ending_Main_Report | Augmented to print/preview the report if AutoOutput_State is set to true |
Ending_Report | This handler is called at the end of every report | Report
Error_Report | Sent whenever an error is generated |
Final_Formfeed |  | Report
OnConstrain |  | Report
onError | Provided as a hook to handle custom error reporting |
Page_Bottom | The last thing printed on every page | Report
Page_Footer | Printed after page_total on every page except the last page | Report
Page_Header | Called after page_top on every new page except the first | Report
Page_Title | Called on every new page after report_header or page_header | Report
Page_Top | Called first at the top of each new page | Report
Page_Total | Called on every new page and is printed as the first part of a page break at the bottom of each page | Report
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found | Report
Report_Footer | Printed after page_total on the last page of the report | Report
Report_Header | Called only on the first page of the report, after page_top | Report
Report_Interrupt | Called when the status panel's Cancel button has been pressed |
Selection | Validates a record | Report
Starting_Main_Report | Called only if the current report is an outer report |
Starting_Report | Called at the start of every report | Report
SubHeader_Init1..n | Called for every break level (n) for which you define a SubHeader_init1..n procedure section in your program | Report
SubHeader1..n | Called for every break level (n) for which you define a subHeader procedure section in your program | Report
SubTotal1..n | Called for every break level (n) for which you define a subTotal procedure section in your program | Report
Total | Called once at the end of a report after the final subtotals are output | Report


Methods for BasicReport

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
End_Log | Procedure | Sends an end-log message to the log object |
Error_Log_Status | Procedure | Called by error_report if status_log_state is true |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Formfeed | Procedure | Handles formfeeds | Report
Log_Status | Procedure | Sends passed message to the log object |
Output_ImageNum | Procedure | Outputs the image represented by ImageNum | Report
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO | Report_DS
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Save | Procedure | If sent, this saves the current record | Report_DS
Run_Report | Procedure | Sends a message to the report object telling it to start the report with internal finding | Report
Start_Log | Procedure | Sends a start-log message to the log object |
Start_Report | Function | Augmented to check the server property and if the property is non-zero (and a DSO exists), to establish a client-server link between the report object and the DSO | Report
Update_Status | Procedure | Send this message to update the action area of the status panel |
WriteLn | Procedure | Outputs the string message to the current output channel | Report
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data | Report


BasicReport [Procedure End_Log]

End_Log - BasicReport

Sends an end-log message to the log object

Type: Procedure

Parameters: No Parameters

Description

End_log sends an end-log message to the log object. It calls Log_Status passing status title plus the number of errors encountered. Sent by End_Process. Good for augmentation.

Last Edited: August 5, 2003


BasicReport [Procedure Error_Log_Status]

Error_Log_Status - BasicReport

Called by error_report if status_log_state is true

Type: Procedure

Parameters: integer ErrNum integer Err_Line string ErrMsg

Parameter | Description
ErrNum | the error number
Err_Line | the error line
ErrMsg | the error message

Description

Error_log_status is called by error_report if status_log_state is true. By default it sends the message log_status, passing a string consisting of Error: + Error Number + Error Message. This message can also be sent. For example, you may augment onError to send this message when status_log_state is false.

Procedure onError integer Error_Info String ErrMsg
    send Error_Log_Status Error_info ErrMsg
End_procedure

The variable Error_Info is a complex Integer where hi(Error_info) is the error number and low(error_info) is the error line number.

Last Edited: September 7, 2005


BasicReport [Procedure Log_Status]

Log_Status - BasicReport

Sends passed message to the log object

Type: Procedure

Parameters: String Mess

Parameter | Description
Mess | the message

Description

Log_status sends passed message to the log object. It is good for sending. All status messages go through this procedure here. By default this message finds the object ID of the status-log object, and, if found, sends the same message on to that object.

Because all log messages pass through this procedure, this message can be used to customize or disable any logging process.

Last Edited: August 18, 2003


BasicReport [Procedure Start_Log]

Start_Log - BasicReport

Sends a start-log message to the log object

Type: Procedure

Parameters: No Parameters

Description

The Start_Log procedure sends a start-log message to the log object. It calls Log_Status passing Start process: plus the name of the process (status title). Sent by Start_Process. Good for augmentation.

Last Edited: September 11, 2003


BasicReport [Procedure Update_Status]

Update_Status - BasicReport

Send this message to update the action area of the status panel

Type: Procedure

Parameters: string Val

Parameter | Description
Val | the value

Description

You send the Update_status message to update the action area of the status panel. This will often be sent within the body section of a report.

Procedure_Section Body
    Send Update_Status Customer.Name
    :

Note that the passed value may be as complex as required:

Send Update_Status (Customer.Name *"Order #" *String(Order.Number) )

This is your primary message for updating status-panel progress.

Last Edited: September 11, 2003


Properties for BasicReport

View property list in hierarchical order

Name | Description | Defining Class
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button |
Assigned_Channel |  | Report
Cancelled_State | Setting this true will cancel a report | Report
Child_Count | Returns the number of child objects the object contains | cObject
Child_Rpt_State | Set true if the current Report object is nested | Report
Current_Rec | (Obsolete) Contains the record number of the current valid record found | Report
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Error_State |  |
Find_Down_state | Determines if an index should be traversed in forward or reverse order | Report
Find_Mode | Maintains the current finding mode | Report
Footer_Lines | Contains the number of lines in the page_bottom image plus the page_footer image plus the page_total image | Report
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function | Report
Has_Children_Rpt_State | Is set true if other reports are nested inside this report object | Report
Last_Rec | (Obsolete) Contains the record number of the last selected record found | Report
Main_File | Contains the filenumber of the file which the report will use for finding records | Report
Main_Report_Id | Contains the object ID of the outer report | Report
Name | Returns the full name of the object including parentage | cObject
New_Page_State | Set true when a new page is needed | Report
No_Constrained_Find_State | Determines if constrained record finding should be disabled | Report
No_Finding_State | Determines how the Report object will find records | Report
No_PageCheck_State | Set true when the Report object is processing a new page | Report
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found | Report
Num_Breaks | Returns the number of breaks in a report | Report
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Ordering | Contains the index number which will be used for finding records | Report
Output_Device | Handles the name of the output device |
Page_Count | Keeps track of the current page number | Report
Page_End | Determines how many lines on a page are allowed before a page break will occur | Report
Page_End_State | If this property is set true below the forward send statement in the starting_main_report procedure, then the next page_check will cause an end-of-page/new-page sequence | Report
Page_Feed | Used by the formfeed procedure | Report
Page_Footer_Lines | The number of lines in the page_footer image | Report
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
priCurrentRec | Contains the RowId of the current valid record found | Report
priFoundRec | Contains the RowId of the record found by the find_rec function | Report
priLastRec | Contains the RowId of the last selected record found | Report
Rec_Count | Contains the number of records found for the current report | Report
Refind_for_SubTotal_State | Ensures that the subtotal is processed with the last valid record for that break level | Report
Report_Caption | Contains the text that will appear in the status panel's caption bar |
Report_Channel | Determines which output channel will be used for your report output | Report
Report_Footer_Lines | The number of lines in the report_footer image | Report
Report_Message | An additional message area that will appear below the report_title in the status panel |
Report_Status_Panel |  |
Report_Title | A centered title that appears in the status panel |
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing | Report
Server | Contains the object ID of this object's server | Report_DS
Status_Log_Id | Object ID of status-log object |
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs |
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs |
Sub_Totaling_State | Set true when the Report object is processing subtotals or totals | Report


BasicReport [Property Allow_Cancel_State]

Allow_Cancel_State - BasicReport

Specifies whether the status panel will support a Cancel button

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Allow_Cancel_State specifies whether the status panel will support a Cancel button. When false, the status panel is used only to show progress.

Default is true.

Last Edited: January 12, 2006


BasicReport [Property Display_Error_State]

Display_Error_State - BasicReport

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: August 4, 2006


BasicReport [Property Output_Device]

Output_Device - BasicReport

Handles the name of the output device

Type: Property

Access: Read/Write

Data Type: String

Description

Output_device handles the name of the output device. If the device name is empty (the default) and the report is in a report view or report panel, it will use that container's output_device_name. If this is blank, a default value of WINLST: is used. This means that you often do not need to explicitly set this property. When you set it in the report container, it is automatically acquired by all reports within the container.

Last Edited: September 10, 2003


BasicReport [Property Report_Caption]

Report_Caption - BasicReport

Contains the text that will appear in the status panel's caption bar

Type: Property

Access: Read/Write

Data Type: String

Description

Report_caption contains the text that will appear in the status panel's caption bar. By default, the caption is Printing Report.

Last Edited: September 11, 2003


BasicReport [Property Report_Message]

Report_Message - BasicReport

An additional message area that will appear below the report_title in the status panel

Type: Property

Access: Read/Write

Data Type: String

Description

Report_message is an additional message area that will appear below the report_title in the status panel. This will often be empty.

Last Edited: September 11, 2003


BasicReport [Property Report_Status_Panel]

Report_Status_Panel - BasicReport

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


BasicReport [Property Report_Title]

Report_Title - BasicReport

A centered title that appears in the status panel

Type: Property

Access: Read/Write

Data Type: String

Description

Report_title is a centered title that appears in the status panel. It has no default value.

Last Edited: September 11, 2003


BasicReport [Property Status_Log_Id]

Status_Log_Id - BasicReport

Object ID of status-log object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Status_log_id is the Object ID of status-log object. When Log_Status is sent, it directs the message to status_log_ID. If this ID is zero, status logging will be ignored. (All status logging goes through the message Log_Status. Log_Status checks the value of this property. If non-zero, it sends the message Log_Status to the status-object ID. If zero, it does nothing.)

It is your responsibility to include a status-log object in your program (you can use the one provided in StatLog.pkg as an example) and to assign the status object's ID to this property.

Use StatLog.pkg // creates object named Status_Log
:
:
Object xxxx is a BasicReport
    Set Status_Log_Id to Status_Log
    Set Status_Log_State to TRUE
    :

Last Edited: August 6, 2004


BasicReport [Property Status_Log_State]

Status_Log_State - BasicReport

Determines if automatic status logging will occur when process starts, stops, and when an error occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set Status_Log_State true if you want automatic status logging (to status-log object) to occur when process starts, stops, and when an error occurs.

This property only affects automatic logging (start process, stop process, and error logging). The program can log messages at any time by sending the messages status_log, start_log, stop_log and error_log_status.

Last Edited: January 12, 2006


BasicReport [Property Status_Panel_State]

Status_Panel_State - BasicReport

Enables or disables the status panel that reports the status of the report as it runs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Status_Panel_State enables or disables the status panel that reports the status of the report as it runs.

Default is True

Last Edited: January 12, 2006


Events for BitmapContainer

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d


Methods for BitmapContainer

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Invoke_Select_Bitmap | Procedure | Public message causing bitmap selection dialog to appear and if selected displays the bitmap |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


BitmapContainer [Procedure Invoke_Select_Bitmap]

Invoke_Select_Bitmap - BitmapContainer

Public message causing bitmap selection dialog to appear and if selected displays the bitmap

Type: Procedure

Parameters: No Parameters

Description

Invoke_select_bitmap is a public message causing bitmap selection dialog to appear and if selected displays the bitmap.

Procedure Invoke_Select_Bitmap
    String sFileName
    Get Select_Bitmap to sFileName
    If (sFileName<>"") Begin
        Set Bitmap to sFileName
        Set Changed_State to True
    End
End_Procedure  // Invoke_Select_Bitmap

The method is called from Mouse_Click but is very necessary if you want a dbbitmap to select a picture without the double click method.

Last Edited: August 18, 2003


Properties for BitmapContainer

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Select_Bitmap_State | Determines if users will be able to browse a list of the bitmap files in a directory and select one for display |
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dialog_Caption | Specifies the legend (Select a bitmap file by default) to be displayed at the top of the common open-file dialog that users will interact with |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Initial_Folder | Specifies the path of the directory in which bitmap filenames will be searched for and displayed by the common file-open dialog |
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


BitmapContainer [Property Allow_Select_Bitmap_State]

Allow_Select_Bitmap_State - BitmapContainer

Determines if users will be able to browse a list of the bitmap files in a directory and select one for display

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Allow_select_bitmap_state property is set true, users will be able to browse a list of the bitmap files in a directory and select one for display through this object.

When in BitmapContainer, default is false.
When in dbBitMap, default is true.

Last Edited: January 12, 2006


BitmapContainer [Property Changed_State]

Changed_State - BitmapContainer

Determines if one or more of the child objects has changed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If this flag is true, one or more of the child objects has changed. Augmented to set changed_state of server to true when changed_state of this object is set to true. Also augmented to detach this object from its server when set to false while this object is inactive.

This object will not save when this state is false. When necessary (as when changes are made other than through the keyboard), set this state to true explicitly.

Default is false.

Last Edited: January 12, 2006


BitmapContainer [Property Dialog_Caption]

Dialog_Caption - BitmapContainer

Specifies the legend (Select a bitmap file by default) to be displayed at the top of the common open-file dialog that users will interact with

Type: Property

Access: Read/Write

Data Type: String

Description

The Dialog_caption property specifies the legend (Select a bitmap file by default) to be displayed at the top of the common open-file dialog that users will interact with if the allow_select_bitmap_state property is true.

Default is "Select a bitmap file".

Last Edited: July 31, 2003


BitmapContainer [Property Initial_Folder]

Initial_Folder - BitmapContainer

Specifies the path of the directory in which bitmap filenames will be searched for and displayed by the common file-open dialog

Type: Property

Access: Read/Write

Data Type: String

Description

The Initial_folder property specifies the path of the directory in which bitmap filenames will be searched for and displayed by the common file-open dialog, if enabled.

Default is "".

Last Edited: August 18, 2003


Events for Broadcaster

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for Broadcaster

View method list in hierarchical order

Name | Type | Description | Defining Class
Add_Element | Procedure | Adds an element to the set if the element does not already exist | Set
Create | Function | Creates an object based on the passed Class Id | cObject
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Find_Element | Function | Returns the index of an element in a set or -1 if not found | Set
Remove_Element | Procedure | Removes specified value from the set if present, and compacts remaining values | Set
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array


Properties for Broadcaster

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Value | Sets and Gets an array element's value | Array


BusinessProcess [Event onError]

onError - BusinessProcess

Provided as a hook to handle custom error reporting

Type: Event

Parameters: integer ErrNum integer iErrLine string ErrMsg

Parameter | Description
ErrNum | The error number
iErrLine | The error line
ErrMsg | The error message

Description

This does nothing by default and is provided as a hook to handle custom error reporting. This message is designed for augmentation and should never be sent. It is sent whenever an error occurs (it is sent by Error_report.).

This message is sent by error_report (which is itself called anytime an error occurs). If you study error_report, you will see that this procedure might have already logged the error in a status log (if status_log_state is true) and might have reported the error in a message box (if display_error_state is true). Often these options will be all that is required and there will be no need to augment this message. If status_log_state is false and display_error_state is false (both of these are the defaults), then no error processing has occurred and you may wish to augment this procedure to handle an error.

The OnError event intentionally only passes custom error information. If you wish to obtain the error text of a non-custom error when intercepting OnError, you can use the Error_Text message to get the error text for predefined errors.

Last Edited: June 22, 2005


BusinessProcess [Event OnProcess]

OnProcess - BusinessProcess

Where you put your processing code

Type: Event

Parameters: No Parameters

Description

Create this procedure. This is where you put your processing code. At this point, your status panel (if any) is visible and you are ready to process.

Last Edited: September 10, 2003


BusinessProcess [Event Process_Interrupt]

Process_Interrupt - BusinessProcess

Called by Cancel_Check if a user response is required to determine if a process should be canceled

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Process_Interrupt is called by Cancel_Check if a user response is required to determine if a process should be canceled. It is expected that the function will present some kind of interface object (like a message box) and ask users if they wish to cancel. By default it presents a message box informing user that either the Cancel key was pressed or an error occurred and asking if the process should be halted. It returns non-zero to cancel. To be augmented and not called.

Last Edited: November 23, 2004


Events for BusinessProcess

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
onError | Provided as a hook to handle custom error reporting |
OnProcess | Where you put your processing code |
Process_Interrupt | Called by Cancel_Check if a user response is required to determine if a process should be canceled |


BusinessProcess [Function Cancel_Check]

Cancel_Check - BusinessProcess

Determines whether the process should be interrupted

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns non-zero for a cancel

Description

Get this to determine whether the process should be interrupted. It can be interrupted by the status panel (cancel) or by an error. If a cancel or error condition exists, it figures out what to do by calling process_interrupt. You are expected to call this message, not to augment it. You can call this function anytime you need to determine if the process should be halted.

Procedure onProcess
    :
    Repeat
        :
        // find record and do the process
        :
        Get Cancel_check to StopIt
        If StopIt procedure_Return
        :
    Loop
End_Procedure

Last Edited: July 30, 2003


Methods for BusinessProcess

View method list in hierarchical order

Name | Type | Description | Defining Class
Cancel_Check | Function | Determines whether the process should be interrupted |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoProcess | Procedure | Starts the batch process |
End_Log | Procedure | Sends an end-log message to the log object |
End_Process | Procedure | Ends the batch process |
End_Status | Procedure | Ends the status panel |
Error_Log_Status | Procedure | Called by error_report if status_log_state is true |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Log_Status | Procedure | Sends passed message to log object |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Resume_Status | Procedure | Resumes a status panel that has been stopped |
Start_Log | Procedure | Sends a start-log message to the log object |
Start_Process | Procedure | Starts the batch process |
Update_Status | Procedure | Can be sent to update a status panel's progress |


BusinessProcess [Procedure DoProcess]

DoProcess - BusinessProcess

Starts the batch process

Type: Procedure

Parameters: No Parameters

Description

DoProcess is the primary external interface into this object. This starts the batch process. It calls start_Process, calls onProcess, and calls End_Process. Usually you do not need to augment this. You can augment onProcess.

Last Edited: July 31, 2003


BusinessProcess [Procedure End_Log]

End_Log - BusinessProcess

Sends an end-log message to the log object

Type: Procedure

Parameters: No Parameters

Description

Sends an end-log message to the log object. It calls Log_Status passing status title plus the number of errors encountered. Sent by End_Process. Good for augmentation.

Last Edited: August 5, 2003


BusinessProcess [Procedure End_Process]

End_Process - BusinessProcess

Ends the batch process

Type: Procedure

Parameters: No Parameters

Description

The End_Process procedure ends the batch process. It removes the status panel if required and sends close message to log if required. This procedure is good for augmentation (please forward). This is sent by DoProcess, so you usually do not need to send this message.

Last Edited: August 5, 2003


BusinessProcess [Procedure End_Status]

End_Status - BusinessProcess

Ends the status panel

Type: Procedure

Parameters: No Parameters

Description

The End_Status procedure ends the status panel. It is sent from various places. Anytime you need to do any type of input, you must make sure you end the status panel. It can always be restarted with resume_status.

Last Edited: August 5, 2003


BusinessProcess [Procedure Error_Log_Status]

Error_Log_Status - BusinessProcess

Called by error_report if status_log_state is true

Type: Procedure

Parameters: integer Errnum integer iErrLine string ErrMsg

Parameter | Description
Errnum | The error number
iErrLine | The error line
ErrMsg | The error message

Description

Error_Log_Status is called by error_report if status_log_state is true. By default it sends the message log_status, passing a string consisting of Error: + Error Number + Error Message. This message can also be sent. For example, you may augment onError to send this message when status_log_state is false.

Procedure OnError integer ErrNum integer iErrLine string ErrMsg
    send Error_Log_Status ErrNum iErrLine ErrMsg
End_Procedure  // OnError

Last Edited: June 22, 2005


BusinessProcess [Procedure Log_Status]

Log_Status - BusinessProcess

Sends passed message to log object

Type: Procedure

Parameters: String Mess

Parameter | Description
Mess | The message sent

Description

The Log_Status procedure sends passed message to log object. It is good for sending. All status messages go through this procedure here. By default this message finds the object ID of the status-log object, and, if found, sends the same message on to that object.

Because all log messages pass through this procedure, this message can be used to customize or disable any logging process.

Last Edited: August 18, 2003


BusinessProcess [Procedure Resume_Status]

Resume_Status - BusinessProcess

Resumes a status panel that has been stopped

Type: Procedure

Parameters: No Parameters

Description

The Resume_Status procedure resumes a status panel that has been stopped. For example, the error handler will remove the panel before popping up the error and then put it back up. This will normally not be augmented. It may be sent by the program to remove the status panel (send end_status) temporarily and to then restore it.

Last Edited: September 11, 2003


BusinessProcess [Procedure Start_Log]

Start_Log - BusinessProcess

Sends a start-log message to the log object

Type: Procedure

Parameters: No Parameters

Description

The Start_Log procedure sends a start-log message to the log object. It calls Log_Status passing Start process: plus the name of the process (status title). Sent by Start_Process. Good for augmentation.

Last Edited: September 11, 2003


BusinessProcess [Procedure Start_Process]

Start_Process - BusinessProcess

Starts the batch process

Type: Procedure

Parameters: No Parameters

Description

Start_Process starts the batch process. Intializes and displays the status panel if required. Initializes log if required. Zeros the error_count. Good for augmentation (please forward). This is sent by DoProcess, so you usually do not need to send this message.

Last Edited: September 11, 2003


BusinessProcess [Procedure Update_Status]

Update_Status - BusinessProcess

Can be sent to update a status panel's progress

Type: Procedure

Parameters: string Val

Parameter | Description
Val | the value

Description

Update_Status can be sent to update a status panel's progress. Pass it any displayable characters.

Last Edited: September 11, 2003


Properties for BusinessProcess

View property list in hierarchical order

Name | Description | Defining Class
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button |
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Error_State |  |
Error_Count | Keeps track of errors encountered during process |
main_dd | Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Process_Caption | Caption-bar text for status panel |
Process_Message | Message that appears in status panel |
Process_Title | Title that appears in status panel |
Status_Log_Id | When Log_Status is sent, it directs the message to status_log_ID |
Status_Log_State | Determines if automatic status logging occurs |
Status_Panel_State | Determines if a status panel should be presented |
Status_Params |  |


BusinessProcess [Property Allow_Cancel_State]

Allow_Cancel_State - BusinessProcess

Specifies whether the status panel will support a Cancel button

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Allow_Cancel_State specifies whether the status panel will support a Cancel button. When false, the status panel is used only to show progress.

Default is false.

Last Edited: January 12, 2006


BusinessProcess [Property Display_Error_State]

Display_Error_State - BusinessProcess

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: August 4, 2006


BusinessProcess [Property Error_Count]

Error_Count - BusinessProcess

Keeps track of errors encountered during process

Type: Property

Access: Read/Write

Data Type: Integer

Description

Error_Count keeps track of errors encountered during process. Developers can query this to see how many errors occurred during a process. This is usually not set.

Last Edited: August 5, 2003


BusinessProcess [Property main_dd]

main_dd - BusinessProcess

Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function

Type: Property

Access: Read/Write

Data Type: Handle

Description

The main_dd property identifies the DataDictionary object that controls the database file, the data from which is central to this object's function. The main datadictionary must be one of the DataDictionaries contained within the WBO object.

VDF Code

Set main_dd to (oCustomer_DD(self))
Get main_dd to hDDObjectID

Script Code

<%hDDObjectID= WBO.Call ("get_main_dd")%>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. Sending the appropriate RegisterInterface message does this.

Send RegisterInterface  get_main_dd "get_main_dd" ;
    "sFile iRecord"  "This property retrieves the setting that determines the central DD for the WBO"

Last Edited: August 18, 2003


BusinessProcess [Property Process_Caption]

Process_Caption - BusinessProcess

Caption-bar text for status panel

Type: Property

Access: Read/Write

Data Type: String

Description

Process_Caption is the caption-bar text for status panel (see status-panel docs).

Last Edited: September 11, 2003


BusinessProcess [Property Process_Message]

Process_Message - BusinessProcess

Message that appears in status panel

Type: Property

Access: Read/Write

Data Type: String

Description

Process_Message is the message that appears in status panel (see status-panel docs).

Last Edited: September 11, 2003


BusinessProcess [Property Process_Title]

Process_Title - BusinessProcess

Title that appears in status panel

Type: Property

Access: Read/Write

Data Type: String

Description

Process_Title is the title that appears in status panel (see status-panel docs).

Last Edited: September 11, 2003


BusinessProcess [Property Status_Log_Id]

Status_Log_Id - BusinessProcess

When Log_Status is sent, it directs the message to status_log_ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

Object ID of status-log object. When Log_Status is sent, it directs the message to status_log_ID. If this ID is zero, status logging will be ignored. (All status logging goes through the message Log_Status. Log_Status checks the value of this property. If non-zero, it sends the message Log_Status to the status-object ID. If zero, it does nothing.)

It is your responsibility to include a status-log object in your program (you can use the one provided in StatLog.pkg as an example) and to assign the status object's ID to this property.

Use StatLog.pkg // creates object named Status_Log
:
:
Object xxxx is a BusinessProcess
    Set Status_Log_Id to (Status_Log(Self))
    Set Status_Log_State to TRUE
    :

Last Edited: August 6, 2004


BusinessProcess [Property Status_Log_State]

Status_Log_State - BusinessProcess

Determines if automatic status logging occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set this property true if you want automatic status logging (to status-log object) to occur when process starts, stops, and when an error occurs.

This property only affects automatic logging (start process, stop process, and error logging). The program can log messages at any time by sending the messages log_status, start_log, end_log and error_log_status.

Default is false.

Last Edited: January 12, 2006


BusinessProcess [Property Status_Panel_State]

Status_Panel_State - BusinessProcess

Determines if a status panel should be presented

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Status_Panel_State determines if a status panel should be presented. When true, a panel appears when the process starts and is removed when the process is complete.

Default is true.

Last Edited: January 12, 2006


BusinessProcess [Property Status_Params]

Status_Params - BusinessProcess

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: June 24, 2003


Button [Event OnBeginningOfPanel]

OnBeginningOfPanel - Button

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


Button [Event OnClick]

OnClick - Button

Sent by this object every time it is pressed

Type: Event

Parameters: No Parameters

Description

The OnClick event message is sent by this object every time it is pressed. By default, it has no definition; it is for your use.

Object RButton is a Button
    set location to 10 10
    set label to "&Report"

    Procedure OnClick
        Delegate Send RunReport
    End_Procedure
End_Object

On_Key Key_Alt+Key_R Send KeyAction to RButton

Very often the action of a button will be to send a message to its parent. Although the message will delegate automatically to the parent, it is advisable to explicitly delegate the message within the onClick procedure. This makes your intention clear.

Last Edited: September 10, 2003


Button [Event OnKillFocus]

OnKillFocus - Button

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


Button [Event OnSetFocus]

OnSetFocus - Button

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


Button [Event Prompt_Callback]

Prompt_Callback - Button

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


Button [Event Shadow_Display]

Shadow_Display - Button

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for Button

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnClick | Sent by this object every time it is pressed |
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |


Button [Function Next_Object_Id]

Next_Object_Id - Button

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


Button [Function Prior_Object_Id]

Prior_Object_Id - Button

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for Button

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
KeyAction | Procedure | Sent to a button, usually via an on_key, to perform the same action as when the button is pressed |
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Button [Procedure Activate_Area]

Activate_Area - Button

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Button [Procedure Beginning_of_Panel]

Beginning_of_Panel - Button

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


Button [Procedure Bottom_of_Panel]

Bottom_of_Panel - Button

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


Button [Procedure DoHtmlHelp]

DoHtmlHelp - Button

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


Button [Procedure End_of_Panel]

End_of_Panel - Button

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


Button [Procedure Error_Help]

Error_Help - Button

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Button [Procedure Extended_Help]

Extended_Help - Button

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Button [Procedure File_Help]

File_Help - Button

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Button [Procedure Help]

Help - Button

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Button [Procedure Help_For_Help]

Help_For_Help - Button

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Button [Procedure Help_Index]

Help_Index - Button

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Button [Procedure Help_on_topic]

Help_on_topic - Button

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Button [Procedure KeyAction]

KeyAction - Button

Sent to a button, usually via an on_key, to perform the same action as when the button is pressed

Type: Procedure

Parameters: No Parameters

Description

The KeyAction message can be sent to a button, usually via an on_key, to perform the same action as when the button is pressed. If the button is unavailable (shadowed), no action will occur.

Object OkButton is a Button
    set location to 10 10
    set label to "&Ok"

    Procedure OnClick
        Send Close_Panel
    End_Procedure
End_Object

On_Key Key_Alt+Key_O Send KeyAction to (OkButton(self))

Last Edited: August 18, 2003


Button [Procedure Keys_Help]

Keys_Help - Button

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Button [Procedure Request_Status_Help]

Request_Status_Help - Button

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


Button [Procedure Top_of_Panel]

Top_of_Panel - Button

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for Button

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object |
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentButtonState |  |
Default_State | Determines if the button is designated as the default-action button for its dialog |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
FlatState | Determines if the button will have a flat appearance or 3d appearance |
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
MultiLineState | Allows the text in Label property to wrap onto multiple lines if it cannot be displayed in one line |
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Button [Property Bitmap]

Bitmap - Button

Displays a bitmap in an object

Type: Property

Access: Read/Write

Data Type: String

Description

The Bitmap message will display a bitmap in an object. In other words, the bitmap becomes the background of the object.
Bitmap_Style determines how and where the bitmap will display in the object.

There are two potential drawbacks to using bitmaps: the amount of storage (on disk) , and the constant memory consumption.

Sample

This sample sets the bitmap to "MyBitmap.bmp".

set Bitmap to "MyBitmap.bmp"

Note:
In order to make a cohesive application, Visual DataFlex must find the .EXE file and the .bmp (bitmap) file, by using DFPATH.

Last Edited: November 24, 2004


Button [Property CurrentButtonState]

CurrentButtonState - Button

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


Button [Property Default_State]

Default_State - Button

Determines if the button is designated as the default-action button for its dialog

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When set to true for a button, the button is designated as the default-action button for the dialog that contains it. When the button's dialog has the focus, pressing the Enter key from within any control except another button will cause the default button's click behavior to get executed. Normally this executes the button's onClick message. A default button's border will be highlighted when it is "active" (when pressing Enter from within another object will execute the default button behavior).

Only one button within a dialog may have this property set to true. Setting this to true in one button sets this property to false in all others.

The default button assignment may be changed dynamically. In the following example, the default button is assigned to whatever button last had the focus.

Object OK_bn is a Button
    Set Label to "&Ok"
    Set Location to 115 152
    Set default_state to TRUE // we start with this as the default

    Procedure OnClick
        Send Its_OK
    End_Procedure

    Procedure OnSetFocus
        Set default_state to TRUE
    End_Procedure

End_Object

Object Cancel_bn is a Button
    Set Label to "&Cancel"
    Set Location to 115 152

    Procedure OnClick
        Send close_panel
    End_Procedure

    Procedure OnSetFocus
        Set default_state to TRUE
    End_Procedure
End_Object

When no default-action button is assigned within a dialog, pressing the Enter key from within another object will either do nothing or send the next message. This behavior is determined by the kEnter_Next property within your workspace object.

The button class works cooperatively with its dialog container class to support default-action buttons. See the dialog property default_action_button and the procedure default_action in panel_mixin for more information.

Last Edited: January 12, 2006


Button [Property Enabled_State]

Enabled_State - Button

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


Button [Property Explicit_Shadow_State]

Explicit_Shadow_State - Button

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


Button [Property FlatState]

FlatState - Button

Determines if the button will have a flat appearance or 3d appearance

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The button will have a flat appearance when the FlatState property is set to True. Set this property to False to display the button with a 3d appearance.

Last Edited: January 12, 2006


Button [Property Help_id]

Help_id - Button

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


Button [Property Help_Keyword]

Help_Keyword - Button

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


Button [Property Item_Shadow_State]

Item_Shadow_State - Button

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


Button [Property Label]

Label - Button

This is the text that appears within this control

Type: Property

Access: Read/Write

Data Type: String

Description

This is the text that appears within this control. It can be set and queried through this property.

When used with the Button class, this sets the text within the button.

When used with the CheckBox class, this sets the text that appears to the right of the checkbox.

When used with the TextBox class, this sets the text that appears inside of the textbox.

When used with containers (Panel, Group, dbGroup), this sets the text that appears in the container.

See Also

Button | CheckBox | TextBox | Panel | Group | dbGroup

Last Edited: August 18, 2003


Button [Property MultiLineState]

MultiLineState - Button

Allows the text in Label property to wrap onto multiple lines if it cannot be displayed in one line

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the text in Label property cannot be displayed in one line, it will wrap onto multiple lines, if this property is set True.

Note that when text is displayed in multiple lines, the text is justified to the left edge, not the center.

Last Edited: January 12, 2006


Button [Property Object_Shadow_State]

Object_Shadow_State - Button

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


Button [Property psHtmlHelpTopic]

psHtmlHelpTopic - Button

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


Button [Property Status_Help]

Status_Help - Button

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


Button [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - Button

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


cAnimation [Event OnStart]

OnStart - cAnimation

Sent whenever the animation starts to play

Type: Event

Parameters: No Parameters

Description

The OnStart event is sent whenever the animation starts to play.

Last Edited: September 10, 2003


cAnimation [Event OnStop]

OnStop - cAnimation

Sent whenever the animation stops playing

Type: Event

Parameters: No Parameters

Description

The OnStop event is sent whenever the animation stops playing.

Last Edited: September 10, 2003


Events for cAnimation

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnMouseDoubleClick | Received whenever a mouse button is double-clicked on the control | cWinControl
OnMouseDown | Received whenever a mouse button is pressed on the control | cWinControl
OnMouseMove | Received whenever the mouse cursor moves over a control | cWinControl
OnMouseUp | Received whenever a mouse button is released on the control | cWinControl
OnStart | Sent whenever the animation starts to play |
OnStop | Sent whenever the animation stops playing |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for cAnimation

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoClose | Procedure | Closes the animation file that you have opened |
DoOpen | Procedure | Opens an AVI file |
DoPlay | Procedure | Plays the animation file that you must have already opened |
DoRecreateWindow | Procedure | Recreates a window | cWinControl
DoStop | Procedure | Stops the currently playing animation file |
DoUpdateWindow | Procedure | Updates a window if it needs repainting | cWinControl
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


cAnimation [Procedure DoClose]

DoClose - cAnimation

Closes the animation file that you have opened

Type: Procedure

Parameters: No Parameters

Description

DoClose closes the animation file that you have opened. It sets the pbIsOpen and pbActive properties to False.

Last Edited: July 31, 2003


cAnimation [Procedure DoOpen]

DoOpen - cAnimation

Opens an AVI file

Type: Procedure

Parameters: String sAvi

Parameter | Description
sAvi | The AVI string file that is opened

Description

DoOpen opens an AVI file. If successful, the pbIsOpen property is set to True, otherwise it and pbActive are set to False.

Last Edited: July 31, 2003


cAnimation [Procedure DoPlay]

DoPlay - cAnimation

Plays the animation file that you must have already opened

Type: Procedure

Parameters: Integer iFrameStart Integer iFrameEnd

Parameter | Description
iFrameStart | Start part of the animation that is played
iFrameEnd | End part of the animation that is played

Description

DoPlay plays the animation file that you must have already opened. To discover if an animation file is open, use the pbIsOpen property.

You can optionally provide the iFrameStart and iFrameEnd parameters to play part of the animation. If you do not provide these parameters, the whole animation will be played.

The animation will repeat itself based upon the values of the piRepetitions property, or indefinitely, if it is zero.

Last Edited: July 31, 2003


cAnimation [Procedure DoStop]

DoStop - cAnimation

Stops the currently playing animation file

Type: Procedure

Parameters: No Parameters

Description

DoStop stops the currently playing animation file.

Last Edited: August 5, 2003


Properties for cAnimation

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbActive | Determines if animation file can be played |
pbAutoSize | Determines if animation frame is automatically sized |
pbEnabled | Enables the control to take user input | cWinControl
pbIsOpen | Determines whether the animation file is open |
pbTransparent | Allows you to match an animation's background color to that of the control's Color property, creating a "transparent" background |
pbVisible | Makes a control visible or invisible | cWinControl
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peAnimation | Built-in animation files |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piRepetitions | Determines the number of times that an animation file will repeat, when it is played |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psFileName | Set this property to the name of an animation file on disk that you want to play |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cAnimation [Property pbActive]

pbActive - cAnimation

Determines if animation file can be played

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set the pbActive property to true to start playing an animation file.

Before an animation file can be played, it must be open. There are several ways that you can achieve this:

  • Set the peAnimation property to the name of a built-in animation, such as aviFileCopy

Set peAnimation to aviFileDelete
Set pbActive To True // plays the animation

  • Set the psFileName property to the name of an animation file on disk.

Set psFileName to "c:\Test.avi"
Set pbActive To True // plays the animation

  • Send the DoOpen procedure with the name of an animation file on disk.

Send DoOpen "c:\Test.avi"
Set pbActive To True // plays the animation

If you set this property to True, and the animation cannot be played, it will be reset back to False.

Default is false.

Last Edited: July 12, 2005


cAnimation [Property pbAutoSize]

pbAutoSize - cAnimation

Determines if animation frame is automatically sized

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbAutoSize automatically sizes the control to the size of the animation frame, when set to True. When set to False, the animation will play in the center with the control.

Default is true.

Last Edited: September 10, 2003


cAnimation [Property pbIsOpen]

pbIsOpen - cAnimation

Determines whether the animation file is open

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbIsOpen determines whether the animation file is open. Its value is maintained automatically, and you should not set this in normal circumstances

Default is false.

Last Edited: September 10, 2003


cAnimation [Property pbTransparent]

pbTransparent - cAnimation

Allows you to match an animation's background color to that of the control's Color property, creating a "transparent" background

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbTransparent allows you to match an animation's background color to that of the control's Color property, creating a "transparent" background. The control interprets the upper-left pixel of the first frame as being the animation's background color.

Default is true.

Last Edited: September 10, 2003


cAnimation [Property peAnimation]

peAnimation - cAnimation

Built-in animation files

Type: Property

Access: Read/Write

Data Type: Integer

Description

The cAnimation class provides several built-in animation files for you to use. Set this property to one of the following values:

aviEmptyRecycle, aviFileCopy, aviFileDelete, aviFileFind,
aviFileMove, aviFileRecycle, aviFindComputer, aviSearch

or aviNone, if you do not want to play a built-in animation.

Setting peAnimation to a value other than aviNone will clear the psFileName property.

Set the pbActive property to True, to actually play the animation.

Default is aviNone.

Last Edited: September 10, 2003


cAnimation [Property piRepetitions]

piRepetitions - cAnimation

Determines the number of times that an animation file will repeat, when it is played

Type: Property

Access: Read/Write

Data Type: Integer

Description

piRepetitions determines the number of times that an animation file will repeat, when it is played. Set this property to zero, and the animation will repeat indefinitely.

Default is 0.

Last Edited: September 11, 2003


cAnimation [Property psFileName]

psFileName - cAnimation

Set this property to the name of an animation file on disk that you want to play

Type: Property

Access: Read/Write

Data Type: String

Description

Set the psFileName property to the name of an animation file on disk that you want to play. Setting this property to a non-null value will set the peAnimation property to aviNone.

Default is "".

Last Edited: September 11, 2003


cApplication [Event OnCreate]

OnCreate - cApplication

Use this event to open a Workspace or perform other pre-startup logic

Type: Event

Parameters: No Parameters

Description

The OnCreate event is automatically called by the framework. You can use it to open a Workspace and perform any other pre-startup logic such as reading the commandline (via the phoCommandLine object) or the Widnows registry.

You can also set the value of psAutoOpenWorkspace to open a workspace file other than the standard Config.ws.

Example

This example uses DoOpenWorkspace in the OnCreate event to open the program's workspace

Use cApplication.pkg

Object oApplication is s cApplication

    Procedure OnCreate
        // Open the Workspace
        Send DoOpenWorkspace "Order Entry"
    End_Procedure

End_Object // oApplication

Last Edited: July 26, 2006


Events for cApplication

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Use this event to open a Workspace or perform other pre-startup logic |


cApplication [Function GetApplicationFileName]

GetApplicationFileName - cApplication

Returns the filename of the application

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Returns the name of the application in a format specified by the operating system

Description

The GetApplicationFileName function returns the filename of the application, as passed to the program by Windows.

See Also

GetApplicationName

Last Edited: August 18, 2003


cApplication [Function GetApplicationName]

GetApplicationName - cApplication

Returns filename of the application without any path or extension

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Returns the filename of the application without its path

Description

The GetApplicationName function returns the filename of the application, as passed to the program by Windows, without any path or extension.

See Also

GetApplicationFileName

Last Edited: August 18, 2003


cApplication [Function GetApplicationPath]

GetApplicationPath - cApplication

Returns the path that the program is running in

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Returns the name of the directory that the program is running in

Description

The GetApplicationPath returns the name of the directory that the program is running in.

See Also

GetApplicationFileName | GetApplicationName

Last Edited: August 18, 2003


cApplication [Function ReadBinary]

ReadBinary - cApplication

Reads binary data from the registry

Type: Function

Return Data Type: Boolean

Parameters: String sSubKey String sValueName Address aValueData Integer iDataLength

Parameter | Description
sSubKey | The name of the subkey containing the Value
sValueName | Name of the Value to retrieve
aValueData | Address in memory to copy the data to
iDataLength | Length of the data to copy

Return Value

If the data was read, the function returns True, otherwise it returns False.

Description

Use the ReadBinary function to read binary data that you previously preserved in the Registry. The base key that will be used is that returned by RegistryKeyString and you can specify a further subkey using the sSubKey parameter. The sValueName parameter is the name of the Value to retrieve. The aValueData parameter is the memory address to copy the data to, and iDataLength is the number of bytes that you want reading.

If you attempt to read a non-existent Value, an error will be generated. Before trying to read a Value, you should ensure that it exists using the ValueExists function.

See Also

ReadDword | ReadString | RegistryKeyString | ValueExists

Last Edited: June 22, 2005


cApplication [Function ReadDword]

ReadDword - cApplication

Reads DWord data from the registry

Type: Function

Return Data Type: DWord

Parameters: String sSubKey String sValueName dword dwDefault

Parameter | Description
sSubKey | The name of the Subkey to read the Value from
sValueName | The name of the Value
dwDefault | If the Value could not be read, then the function will return the value you place here

Return Value

Either the value of the Key/Name if it exists, or the dwDefault parameter if it does not.

Description

Use the ReadDword function to read dword data that you previously preserved in the Registry.

The base key that will be used is that returned by RegistryKeyString and you can specify a further subkey using the sSubKey parameter. The sValueName parameter is the name of the Value to retrieve.

If you attempt to read a non-existent Value, no error will be generated, and the value that you pass in the sDefault parameter will be returned. You can check if a Value exists, prior to trying to access it, using the ValueExists function.

See Also

ReadBinary | ReadString | RegistryKeyString | ValueExists

Last Edited: June 22, 2005


cApplication [Function ReadString]

ReadString - cApplication

Reads string data from the registry

Type: Function

Return Data Type: String

Parameters: String sSubKey String sValueName string sDefault

Parameter | Description
sSubKey | The name of the Subkey to read the Value from
sValueName | The name of the Value
sDefault | If the Value could not be read, then the function will return the value you place here

Return Value

The string contained in the Key/Value, if found, or the value of the sDefault parameter, if not.

Description

Use the ReadString function to read string data that you previously preserved in the Registry. The base key that will be used is that returned by RegistryKeyString and you can specify a further subkey using the sSubKey parameter. The sValueName parameter is the name of the Value to retrieve.

If you attempt to read a non-existent Value, no error will be generated, and the value that you pass in the sDefault parameter will be returned. You can check if a Value exists, prior to trying to access it, using the ValueExists function.

See Also

ReadDword | ReadBinary | RegistryKeyString | ValueExists

Last Edited: June 22, 2005


cApplication [Function RegistryKeyString]

RegistryKeyString - cApplication

Returns the name of the Key that will be used to access the registry for user-defined values in the application object

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

A string consisting of the concatenation the values of the psCompany, psProduct, psVersion and psProgram properties together.

Description

The framework calls this function to determine the name of the Key to use when accessing application-specific registry Values in the application object (for example, when using ReadString or WriteBinary).

You can override this function to return a different string to use as the Key name.

See Also

ReadDWord | ReadString | ReadBinary

Last Edited: June 4, 2004


cApplication [Function ValueExists]

ValueExists - cApplication

Tests whether an application-specific registry key/value exists

Type: Function

Return Data Type: Boolean

Parameters: string sSubKey string sValueName

Parameter | Description
sSubKey | The name of an optional subkey
sValueName | The name of the Value to check the existence of

Return Value

True, if the Value exists. If the Value doesn't exist, then False is returned.

Description

Before you attempt to read a value from the Registry, you should ensure that it exists. Use this function to verify that a Value exists before trying to read it.

The base key that will be used is that returned by RegistryKeyString and you can specify a further subkey using the sSubKey parameter. The sValueName parameter is the name of the Value to check for existence.

For example, assume that you wanted to read some preferences (which you had previously written) from the Registry at the start of your program. The "name" value is stored in the base key of your application; the "ShowCustomerView" value is stored under the "Preferences" subkey of your application. This is how you would check and retrieve the data:

Use cApplication.pkg

Object oApplication Is A cApplication

    Procedure OnCreate
        String sName
        Boolean bShowCustomerView

        If (ValueExists(self, "", "Name")) ;
            Get ReadString "" "Name" To sName

        If (ValueExists(self, "Preferences" "ShowCustomerView")) ;
            Get ReadDword "Preferences" "ShowCustomerViews" To bShowCustomerView

        Send DoOpenWorkspace "MyApp"
    End_Procedure

End_Object // oApplication

See Also

RegistryKeyString

Last Edited: June 22, 2005


Methods for cApplication

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoLoadEnvironment | Procedure | Loads size/location information from the registry at startup |
DoOpenWorkspace | Procedure | Opens a Workspace |
DoSaveEnvironment | Procedure | Writes the Program/Views size and location to the registry |
Exit_Application | Procedure | Starts the process of closing an application | cObject
GetApplicationFileName | Function | Returns the filename of the application |
GetApplicationName | Function | Returns filename of the application without any path or extension |
GetApplicationPath | Function | Returns the path that the program is running in |
ReadBinary | Function | Reads binary data from the registry |
ReadDword | Function | Reads DWord data from the registry |
ReadString | Function | Reads string data from the registry |
RegistryKeyString | Function | Returns the name of the Key that will be used to access the registry for user-defined values in the application object |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
ValueExists | Function | Tests whether an application-specific registry key/value exists |
WriteBinary | Procedure | Writes binary data to the registry |
WriteDword | Procedure | Writes DWord data to the registry |
WriteString | Procedure | Writes string data to the registry |


cApplication [Procedure DoLoadEnvironment]

DoLoadEnvironment - cApplication

Loads size/location information from the registry at startup

Type: Procedure

Parameters: Handle hoContainer Boolean bProgram

Parameter | Description
hoContainer | Object-handle of the object to retrieve the size/location for. This can be either a View or Panel (program)
bProgram | True if the hoContainer object is a Program (in which case the visibility of the statusbar and toolbar is also retrieved)

Description

The DoLoadEnvironment procdure is used internally to read the Program and View size/locations from the Registry.

See Also

DoSaveEnvironment

Last Edited: August 5, 2003


cApplication [Procedure DoOpenWorkspace]

DoOpenWorkspace - cApplication

Opens a Workspace

Type: Procedure

Parameters: String sWorkspace

Parameter | Description
sWorkspace | Name of the Workspace

Description

You can use the DoOpenWorkspace procedure inside OnCreate to open a specific Workspace.

This is the order that is used to open the Workspace:

1. If the Workspace name contains a path, then that path is used; otherwise,
2. If the Workspace file is in the same directory that the program is running in, it is used; otherwise,
3. If it is registered, the path the Workspace file is located via its registered location.

If there is an error in opening the Workspace, an error will be generated giving a detailed reason for the failure, and the program will abort.

Use cApplication.pkg

Object oApplication is a cApplication
    Set psCompany To "Data Access Worldwide"
    Set psProduct To "Visual DataFlex 12.0 Examples"
    Set psVersion To "12.0"
    Set psProgram To "Order"

    Procedure OnCreate
        Send DoOpenWorkspace "Order Entry"
    End_Procedure

End_Object // oApplication

Note:In applications that only use a single Workspace and are expected to work without problems, this procedure is fine. However, for programs that need to switch Workspaces or validate Workspaces, etc., a more flexible alternative is to use cWorkspace's OpenWorkspace or OpenWorkspaceFile.

See Also

cWorkspace | OpenWorkspace | OpenWorkspaceFile

Last Edited: July 26, 2006


cApplication [Procedure DoSaveEnvironment]

DoSaveEnvironment - cApplication

Writes the Program/Views size and location to the registry

Type: Procedure

Parameters: Handle hoContainer Boolean bProgram

Parameter | Description
hoContainer | Object-handle of the object to set the size/location for. This can be either a View or Panel (program)
bProgram | True if the hoContainer object is a Program (in which case the visibility of the statusbar and toolbar is also set)

Description

The DoSaveEnvironment procedure is used internally to write the Program and View size/locations to the Registry.

See Also

DoLoadEnvironment

Last Edited: August 5, 2003


cApplication [Procedure WriteBinary]

WriteBinary - cApplication

Writes binary data to the registry

Type: Procedure

Parameters: String sSubKey String sValueName Address aValueData Integer iDataLength

Parameter | Description
sSubKey | The name of the Subkey
sValueName | The name of the Value
aValueData | The memory address of the data to write
iDataLength | The number of bytes to write

Description

Use the WriteBinary procedure to write data that you want preserved in the Registry. The base key that will be used is that returned by RegistryKeyString and you can specify a further subkey using the sSubKey parameter. The aValueData parameter is a pointer to a memory address and iDataLength is the number of bytes that you want to write.

See Also

RegistryKeyString

Last Edited: June 22, 2005


cApplication [Procedure WriteDword]

WriteDword - cApplication

Writes DWord data to the registry

Type: Procedure

Parameters: String sSubKey String sValueName Dword dwValueData

Parameter | Description
sSubKey | The name of the Subkey
sValueName | The name of the Value
dwValueData | the data to write

Description

Use the WriteDword procedure to write data that you want preserved in the Registry. The base key that will be used is that returned by RegistryKeyString and you can specify a further subkey using the sSubKey parameter. The name of the Value will be the sValueName parameter and the dword data that will be written is the sValueData parameter.

See Also

RegistryKeyString

Last Edited: June 22, 2005


cApplication [Procedure WriteString]

WriteString - cApplication

Writes string data to the registry

Type: Procedure

Parameters: String sSubKey String sValueName String sValueData

Parameter | Description
sSubKey | The name of the Subkey
sValueName | The name of the Value
sValueData | The data to write

Description

Use the WriteString procedure to write data that you want preserved in the Registry. The base key that will be used is that returned by RegistryKeyString and you can specify a further subkey using the sSubKey parameter. The name of the Value will be the sValueName parameter and the string data that will be written is the sValueData parameter.

See Also

RegistryKeyString

Last Edited: June 22, 2005


Properties for cApplication

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbEnterKeyAsTabKey | Determines whether the Enter key should act like the Tab key |
pbPreserveEnvironment | Determines whether program information is automatically saved and restored |
peHelpType | Determines which type of help system is used by the program |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phoCommandLine | Holds the object-handle of the embedded cCommandLine object |
phoMainPanel | Holds the object-handle of the program's main panel |
phoVersionInfo | Holds the object-handle of the embedded cVersionInfo object |
phoWorkspace | Holds the object-handle of the embedded cWorkspace object |
psAutoOpenWorkspace | Controls which workspace file is opened by cApplication object in program |
psCompany | The name of the company producing the program |
psHelpFile | Name of the compiled HTML (CHM) helpfile to display |
psProduct | The name of the product |
psProgram | The name of the program |
psVersion | The version of the program |


cApplication [Property pbEnterKeyAsTabKey]

pbEnterKeyAsTabKey - cApplication

Determines whether the Enter key should act like the Tab key

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set the pbEnterKeyAsTabKey property to True if you want the Enter (Return) key to act like the Tab key. That is, pressing Enter will navigate the focus forward throughout your program.

Last Edited: September 10, 2003


cApplication [Property pbPreserveEnvironment]

pbPreserveEnvironment - cApplication

Determines whether program information is automatically saved and restored

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The size, location, view-mode, statusbar and toolbar visibility of Views and Programs are automatically written and read from the Registry at runtime. This results in programs and views starting with the same attributes as when the program was last run.

Set the pbPreserveEnvironment property to True to use the Registry to store the settings. Set it false to prevent the program from automatically accessing the Registry.

Last Edited: September 10, 2003


cApplication [Property peHelpType]

peHelpType - cApplication

Determines which type of help system is used by the program

Type: Property

Access: Read/Write

Data Type: Integer

Description

The framework can work with different help systems. When the help system is invoked, the framework searches for the Help_Id property of the focussed object in the relevant helpfile.

Set the property to one of the following constants:

Constant | Meaning
htNoHelp | No help system is being used. This is the default.
htHtmlHelp | A HTML help system is being used
htWinHelp | A WinHelp help system is being used

Note:In addition to setting this property, you should also set the psHelpFile property to the name of the file containing your help.

See Also

psHelpFile

Last Edited: September 11, 2003


cApplication [Property phoCommandLine]

phoCommandLine - cApplication

Holds the object-handle of the embedded cCommandLine object

Type: Property

Access: Read/Write

Data Type: Handle

Description

An instance of cCommandLine is encapsulated within this class to handle all aspects of the program's command-line arguments. When you need to communicate with this object (to retrieve command-line arguments, for example), use this property to acquire its object handle.

Sample

Get phoCommandLine Of ghoApplication To hoCommandLine
If (hoCommandLine > 0) Begin
    Get CountOfArgs Of hoCommandLine To iArgs
End

Note:Primarily, this is a read-only property. However, if you were to create your own commandline object to replace the internal one, you could assign its object-handle to this property.

See Also

cCommandLine

Last Edited: November 9, 2006


cApplication [Property phoMainPanel]

phoMainPanel - cApplication

Holds the object-handle of the program's main panel

Type: Property

Access: Read/Write

Data Type: Handle

Description

Whenever you create a Panel object in your program, its object-handle is automatically assigned to the phoMainPanel property, which you can then use to access your panel object indirectly (that is, not using its name).

See Also

Panel

Last Edited: September 11, 2003


cApplication [Property phoVersionInfo]

phoVersionInfo - cApplication

Holds the object-handle of the embedded cVersionInfo object

Type: Property

Access: Read/Write

Data Type: Handle

Description

An instance of cVersionInfo is encapsulated within this class to provide access to any Version Information that may be compiled into your program. Use the phoVersionInfo property to retrieve its object handle.

Note:Primarily, this is a read-only property. However, if you were to create your own version information object to replace the internal one, you could assign its object-handle to this property.

See Also

cVersionInfo

Last Edited: September 11, 2003


cApplication [Property phoWorkspace]

phoWorkspace - cApplication

Holds the object-handle of the embedded cWorkspace object

Type: Property

Access: Read/Write

Data Type: Handle

Description

An instance of cWorkspace is encapsulated within this class to handle all aspects of the program's Workspace. When you need to communicate with this object (to obtain information about paths, or open a Workspace, etc.), use the phoWorkspace property to acquire its object handle.

Note:Primarily, this is a read-only property. However, if you were to create your own workspace object to replace the internal one, you could assign its object-handle to this property.

See Also

cWorkspace

Last Edited: September 11, 2003


cApplication [Property psAutoOpenWorkspace]

psAutoOpenWorkspace - cApplication

Controls which workspace file is opened by cApplication object in program

Type: Property

Access: Read/Write

Data Type: String

Description

psAutoOpenworkspace specifies the name of a workspace which will be opened during a cApplication's end_construct_object process. Its default value is "config.ws" which is the normal name for a newly created ws file. This means that any new project created for any new workspace requires no customization of the workspace object. All this is required is:

Object oApplication is a cApplication
End_Object    // oApplication

You completely disable the automatic opening of workspaces by setting the psAutoOpenWorkspace property to "". The following example will not open any workspace.

Object oApplication is a cApplication
    Set psAutoOpenWorkspace to ""
End_Object    // oApplication

If you do this, you will need to write your own code to open the workspace.

Last Edited: August 10, 2006


cApplication [Property psCompany]

psCompany - cApplication

The name of the company producing the program

Type: Property

Access: Read/Write

Data Type: String

Description

The psCompany property provides the name of the company producing the program. Whenever the program needs to access the Registry, it uses a combination of the psCompany, psProduct, psVersion and psProgram properties to determine the key name that should be accessed. The four values are added together to form the key. For example, if:

psCompany = "ABC, Inc"
psProduct = "Payroll"
psVersion = "1.0"
psProgram = "People"

then the key that would be accessed would be:

HKEY_CURRENT_USER\Software\ABC, Inc\Payroll\1.0\People

You should set this property to the name of your company.

Note:If you do not provide a value for this property, then "Data Access Worldwide" will be used.

See Also

psProduct | psVersion | psProgram

Last Edited: September 11, 2003


cApplication [Property psHelpFile]

psHelpFile - cApplication

Name of the compiled HTML (CHM) helpfile to display

Type: Property

Access: Read/Write

Data Type: String

Description

You should set the psHelpFile property to the fully-qualified filename of the Compiled HTML help file that you want your program to display. The type of help system is set with the peHelpType property.

set psHelpFile to "C:\MyApplication\Help\MyHelpFile.chm"

See Also

peHelpType

Last Edited: September 8, 2005


cApplication [Property psProduct]

psProduct - cApplication

The name of the product

Type: Property

Access: Read/Write

Data Type: String

Description

psProduct is the name of the product. Whenever the program needs to access the Registry, it uses a combination of the psCompany, psProduct, psVersion and psProgram properties to determine the key name that should be accessed. The four values are added together to form the key. For example, if:

psCompany = "ABC, Inc"
psProduct = "Payroll"
psVersion = "1.0"
psProgram = "People"

then the key that would be accessed would be:

HKEY_CURRENT_USER\Software\ABC, Inc\Payroll\1.0\People

You should set this property to the name of your product.

Note:If you do not provide a value for this property, "Visual DataFlex Applications" will be used.

See Also

psCompany | psVersion | psProgram

Last Edited: September 11, 2003


cApplication [Property psProgram]

psProgram - cApplication

The name of the program

Type: Property

Access: Read/Write

Data Type: String

Description

psProgram is the name of the program. Whenever the program needs to access the Registry, it uses a combination of the psCompany, psProduct, psVersion and psProgram properties to determine the key name that should be accessed. The four values are added together to form the key. For example, if:

psCompany = "ABC, Inc"
psProduct = "Payroll"
psVersion = "1.0"
psProgram = "People"

then the key that would be accessed would be:

HKEY_CURRENT_USER\Software\ABC, Inc\Payroll\1.0\People

Note:If you do not set this property, it will automatically be set to the name of the compiled program (as returned by GetApplicationName). You should only set this property to a descriptive name of the program if you don't want to use the name of the program.

See Also

psCompany | psProduct | psVersion

Last Edited: September 11, 2003


cApplication [Property psVersion]

psVersion - cApplication

The version of the program

Type: Property

Access: Read/Write

Data Type: String

Description

psVersion is the version of the program. Whenever the program needs to access the Registry, it uses a combination of the psCompany, psProduct, psVersion and psProgram properties to determine the key name that should be accessed. The four values are added together to form the key. For example, if:

psCompany = "ABC, Inc"
psProduct = "Payroll"
psVersion = "1.0"
psProgram = "People"

then the key that would be accessed would be:

HKEY_CURRENT_USER\Software\ABC, Inc\Payroll\1.0\People

You should set this property to the version of your software.

Note:If you do not provide a value for this property, the value "1" will be used.

See Also

psCompany | psProduct | psProgram

Last Edited: September 11, 2003


Events for cAutoWebReport

View event list in hierarchical order

Name | Description | Defining Class
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property | cReport
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Error_Report | Sent whenever an error is generated | cBasicReport
Final_Formfeed |  | cReport
OnBody | Called every time a valid record has been found | cReport
OnConstrain |  | cReport
OnEndingMainReport | User Handler Intended for override | cBasicReport
OnEndingReport | Called at the end of all reports | cReport
onError | Provided as a hook to handle custom error reporting | cBasicReport
OnInitBreakPoints | Determines the number and order of your breakpoints | cWebReport
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables | cReport
OnPageFooter | Printed after OnPageTotal on every page except the last page | cReport
OnPageHeader | Called after OnPageTop on every new page except the first | cReport
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader. | cReport
OnPageTop | Called when printing the top of every report | cReport
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page | cReport
OnReportFooter | Printed after OnPageTotal on the last page of the report | cReport
OnReportHeader | Called only on the first page of the report, after OnPageTop | cReport
OnSelection | Validates a record | cReport
OnStartingMainReport | Called when a report is started | cBasicReport
OnStartingReport | Called when a report is started | cReport
OnSubHeader1..n | Called each time a subheader needs to be printed | cReport
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program | cReport
OnSubTotal1..n | Called when a subtotal needs to be processed | cReport
OnTotal | Called at the end of a report after all final sub-totals have been printed | cReport
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found | cReport
Report_Interrupt | Called when the status panel's Cancel button has been pressed | cBasicReport


cAutoWebReport [Function DoAutoReport]

DoAutoReport - cAutoWebReport

Starts an Auto-Report

Type: Function

Obsolete

Return Data Type: Integer

Parameters: integer iIndex string sHref integer iMax integer iStart

Parameter | Description
iIndex | index or field name to use for report
sHRef | name of other web page to hyperlink each report record to (e.g. details page)
iMax | number of records to display per page
iStart | the starting record id for the next page

Return Value

Description

This message is used to run an auto-report. You pass all the information it needs to run the report. Normally, you will never send this message. Instead you send send the message AutoReport to the cWebBusinessProcess that contains this object.

See Also

AutoReport | cWebBusinessProcess

Last Edited: November 11, 2004


cAutoWebReport [Function DoAutoReport1]

DoAutoReport1 - cAutoWebReport

Type: Function

Return Data Type: String

Parameters: integer iIndex string sHref integer iMax String sStart

Parameter | Description
iIndex | [ToDo: In Progress]
sHref | [ToDo: In Progress]
iMax | [ToDo: In Progress]
sStart | [ToDo: In Progress]

Return Value

Description

Last Edited: November 11, 2004


Methods for cAutoWebReport

View method list in hierarchical order

Name | Type | Description | Defining Class
AddRecordLink | Function | (Obsolete) Creates a cell that contains a link to another web page | cWebReport
AddRowIdLink | Function | Creates a cell that contains a link to another web page | cWebReport
AddSubTotal | Procedure | Adds the passed value to the total maintained in level iCount | cHtmlReport
ClearAllSubTotals | Procedure | Clears all the SubTotal accumulators | cHtmlReport
ClearSubTotal | Procedure | Clears a single Subtotal accumulator | cHtmlReport
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoAutoReport | Function | (Obsolete) Starts an Auto-Report |
DoAutoReport1 | Function |  |
DoRunReport | Function | The main entry point for reportsT | cReport
End_Log | Procedure | Sends an end-log message to the log object | cBasicReport
Error_Log_Status | Procedure | Called by error_report if status_log_state is true | cBasicReport
Exit_Application | Procedure | Starts the process of closing an application | cObject
Formfeed | Procedure | Handles formfeeds | cReport
HtmlAnchor | Function | Adds an Html Anchor | cHtmlReport
HtmlBig | Function | Makes the string big | cHtmlReport
HtmlBlink | Function | Makes the string blink | cHtmlReport
HtmlBold | Function | Makes the string bold | cHtmlReport
HtmlEmph | Function | Makes the string emphasized | cHtmlReport
HtmlFixed | Function | Makes the string fixed width | cHtmlReport
HtmlFontcolor | Function | Sets the strings font color | cHtmlReport
HtmlFontsize | Function | Sets the font size | cHtmlReport
HtmlHeader | Function | Creates a header string of level iHeader | cHtmlReport
HtmlItalics | Function | Makes the string italics | cHtmlReport
HtmlLink | Function | Adds a hyperlink to a string | cHtmlReport
HtmlSmall | Function | Makes the string small | cHtmlReport
HtmlStrike | Function | Overstrikes through the string | cHtmlReport
HtmlStrong | Function | Adds strong emphasis to the string | cHtmlReport
HtmlSub | Function | Makes the string subscript | cHtmlReport
HtmlSup | Function | Makes the string superscript | cHtmlReport
Log_Status | Procedure | Sends passed message to the log object | cBasicReport
Output_ImageNum | Procedure | Outputs the image represented by ImageNum | cReport
RegisterBreakpoint | Procedure | registers a breakpoint function | cWebReport
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO | cReportDS
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Save | Procedure | If sent, this saves the current record | cReportDS
Start_Log | Procedure | Sends a start-log message to the log object | cBasicReport
SubTotal | Function | Returns the appropriate subtotal and clears the subtotal accumulator | cHtmlReport
SumSubTotal | Function | Returns the appropriate subtotal but does not clear the subtotal accumulator | cHtmlReport
Update_Status | Procedure | Send this message to update the action area of the status panel | cBasicReport
WriteHtml | Procedure | Outputs the passed string to the web page and ends the line | cHtmlReport
WriteHtmlBreak | Procedure | Outputs the passed string and ends the line | cHtmlReport
WriteHtmlCell | Procedure | Outputs a table cell containing sData | cHtmlReport
WriteHtmlCellHeader | Procedure | Outputs a table header cell containing sData | cHtmlReport
WriteHtmlHorzLine | Procedure | Outputs a horizontal line to the HTML file | cHtmlReport
WriteHtmlRowBegin | Procedure | Outputs a "begin" row HTML string | cHtmlReport
WriteHtmlRowEnd | Procedure | Outputs an end row html string | cHtmlReport
WriteHtmlTableBegin | Procedure | Outputs a "begin" table html string | cHtmlReport
WriteHtmlTableEnd | Procedure | Outputs an end table html string | cHtmlReport
WriteLn | Procedure | Outputs the string and ends the Line | cHtmlReport
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data | cReport


Properties for cAutoWebReport

View property list in hierarchical order

Name | Description | Defining Class
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button | cBasicReport
Assigned_Channel |  | cReport
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Error_State |  | cBasicReport
Find_Mode | Maintains the current finding mode | cReport
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image | cReport
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function | cReport
Last_Rec | (Obsolete) Contains the record number of the last selected record found | cReport
Main_File | Contains the filenumber of the file which the report will use for finding records | cReport
Name | Returns the full name of the object including parentage | cObject
New_Page_State | Set true when a new page is needed | cReport
No_Constrained_Find_State | Determines if constrained record finding should be disabled | cReport
No_Finding_State | Determines how the cReport object will find records | cReport
No_PageCheck_State | Set true when the cReport object is processing a new page | cReport
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found | cReport
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Output_Device | Handles the name of the output device | cBasicReport
Page_Count | Keeps track of the current page number | cReport
Page_End | Determines how many lines on a page are allowed before a page break will occur | cReport
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence | cReport
Page_Feed | Used by the formfeed procedure | cReport
Page_Footer_Lines | The number of lines in the page_footer image | cReport
Parent | Returns the parent of an object | cObject
pbCanceled | Setting this true will cancel a report | cReport
pbChildReport | Set true if the current cReport object is nested | cReport
pbFindDown | Determines if the report should traverse up or down the index | cReport
pbHasChildReports | Is set true if other reports are nested inside this report object | cReport
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level | cReport
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phMainReport | Contains the object ID of the outer report | cReport
piConstrainFile | Used when creating reports to limit the printing to a single parent record and the related children | cHtmlReport
piConstrainRecord | (Obsolete) Used when creating reports to limit the printing to a single parent record and the related children | cHtmlReport
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found | cReport
piLastRecord | (Obsolete) Holds the record that was processed when a report was halted because the maximum number of records was encountered | cWebReport
piMaxCount | Holds the maximum number of records to print | cWebReport
piMaxCountBreakLevel | Determines what is considered to be a "record" when record counting is used to create partial reports | cWebReport
piNumberBreaks | Returns the number of breaks in a report | cReport
piOrdering | Contains the index number which will be used for finding records | cReport
piRecordCount | Contains the number of records found for the current report | cReport
piStartRecord | (Obsolete) Allows you to create partial reports providing a method for creating web report "pages" | cWebReport
priConstrainRowId | Used when creating reports to limit the printing to a single parent record and the related children | cHtmlReport
priCurrentRec | Contains the RowId of the current valid record found | cReport
priFoundRec | Contains the RowId of the record found by the find_rec function | cReport
priLastRec | Contains the RowId of the last selected record found | cReport
priLastRowId | Holds the RowId of the record that was processed when a report was halted because the maximum number of records was encountered | cWebReport
priStartRowId | Determines the RowId of the first record of a report allowing you to create partial web reports | cWebReport
psHRefName | Holds the full URL of a file (ASP or HTML) to be displayed as part of a "drill down" operation | cWebReport
Report_Caption | Contains the text that will appear in the status panel's caption bar | cBasicReport
Report_Channel | Determines which output channel will be used for your report output | cReport
Report_Footer_Lines | The number of lines in the OnReportFooter image | cReport
Report_Message | An additional message area that will appear below the report_title in the status panel | cBasicReport
Report_Status_Panel |  | cBasicReport
Report_Title | A centered title that appears in the status panel | cBasicReport
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing | cReport
Server | Identifies the object handle that is used as the report object's main data-dictionary object | cReportDS
Status_Log_Id | Object ID of status-log object | cBasicReport
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs | cBasicReport
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs | cBasicReport
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals | cReport


cBaseHTTPTransfer [Event OnDataReceived]

OnDataReceived - cBaseHTTPTransfer

Is triggered several times during a GetRequest, PostRequest and PutRequest when data arrives from RemoteHost

Type: Event

Parameters: string sContentType string sData

Parameter | Description
sContentType | Specifies the content type of sData
sData | Contains the data received from RemoteHost

Description

The OnDataReceived event is triggered several times during a GetRequest, PostRequest and PutRequest when data arrives from RemoteHost. sContentType specifies the content type of sData, for example, "text/html" if sData contains html text. sData contains the data received from RemoteHost.

Note that sData may not contain all data sent from RemoteHost at once, the OnDataReceived event might be triggered several times before all data has been received.

If the SaveAsFile property is non-blank, this event will not be triggered, instead any response will be redirected to the specified file.

Performs nothing by default, intended for augmentation to process data sent by RemoteHost.

Last Edited: September 10, 2003


Events for cBaseHTTPTransfer

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnDataReceived | Is triggered several times during a GetRequest, PostRequest and PutRequest when data arrives from RemoteHost |


cBaseHTTPTransfer [Function AddHeader]

AddHeader - cBaseHTTPTransfer

Adds the HTTP header named sHeaderName with the value sHeaderValue to the HTTP headers

Type: Function

Return Data Type: Integer

Parameters: String sHeaderName String sHeaderValue

Parameter | Description
sHeaderName | The HTTP header
sHeaderValue | The HTTP value

Return Value

Returns True if successful, and False otherwise.

Description

AddHeader adds the HTTP header named sHeaderName with the value sHeaderValue to the HTTP headers. The HTTP headers are automatically sent to RemoteHost during GetRequest, PostRequest and PutRequest.

Last Edited: July 30, 2003


cBaseHTTPTransfer [Function HTTPGetRequest]

HTTPGetRequest - cBaseHTTPTransfer

Performs an HTTP GET request using sFilePath

Type: Function

Return Data Type: Integer

Parameters: String sFilePath

Parameter | Description
sFilePath | The file path used to perform an HTTP GET request

Return Value

Returns True if successful, and False otherwise

Description

The HTTPGetRequest function performs an HTTP GET request using sFilePath. All headers previously added using AddHeader, if any, are also sent as part of the request.

The OnDataReceived event is triggered for any response sent by RemoteHost.

Last Edited: August 18, 2003


cBaseHTTPTransfer [Function HTTPPostAddrRequest]

HTTPPostAddrRequest - cBaseHTTPTransfer

Performs an HTTP POST request

Type: Function

Return Data Type: Integer

Parameters: string sFilePath address aData Integer iDataLength boolean bDataIsFile

Parameter | Description
sFilePath | Path to perform the HTTP POST
aData | Memory address of the data to be posted
iDataLength | Number of bytes to post
bDataIsFile | If False, the value of aData is sent as HTTP POST body. If True, aData is interpreted as a filename and the contents of that file are sent as the POST body instead of the actual value of aData

Return Value

Returns True if successful, and False otherwise

Description

The HTTPPostAddrRequest function performs an HTTP POST request. All headers previously added using AddHeader, if any, are also sent as part of the request.

The OnDataReceived event is triggered for any response sent by RemoteHost.

This function is provided to allow the posting of large amounts of data (i.e., not limited to the maximum length of a DataFlex string). If you do not need to post large amounts of data you can use the simpler string-based function HttpPostRequest.

Sample

The following sample posts an XML document that is passed as an XML node. Since the length could be quite long, we use HttpPostAddrRequest method to do the post.

Function PostXmlNodestring sHost string sFilePath handle hoXmlNode returns Boolean
    address aXmlNode aXml
    integer iVoid iLen
    boolean bOK
    handle hoXml

    // write XML data to memory heap pointed to by aXMLNode
    Get paXml of hoXmlNode to aXmlNode

    // assume data from paXml is always zero terminated
    Move (Length(aXmlNode)) to iLen

    Set psRemoteHost to sHost

    Get AddHeader "CONTENT-TYPE" "text/xml" to bOK

    Get HttpPostAddrRequest sFilePath aXml iLen False to bOK

    Move (Free(aXmlNode)) to iVoid  // free memory

    Function_Return bOk
End_Function

Note:
Note that the cXmlHttpTransfer class already provides the above functionality for you.

Last Edited: August 18, 2003


cBaseHTTPTransfer [Function HTTPputAddrRequest]

HTTPputAddrRequest - cBaseHTTPTransfer

Performs an HTTP PUT request using sFilePath

Type: Function

Return Data Type: Integer

Parameters: string sFilePath address aData Integer iDataLength boolean bDataIsFile

Parameter | Description
sFilePath | path to perform the HTTP PUT
aData | memory address of the data to be posted
iDataLength | number of bytes to post
bDataIsFile | If False, the value of aData is sent as HTTP PUT body. If True, aData is interpreted as a filename, and the contents of that file are sent as the POST body instead of the actual value of aData.

Return Value

Returns True if successful, and False otherwise

Description

The HTTPputAddrRequest function performs an HTTP PUT request using sFilePath. All headers previously added using AddHeader, if any, are also sent as part of the request.

The OnDataReceived event is triggered for any response sent by RemoteHost.

This function is provided to allow the posting of large amounts of data (i.e., not limited to the maximum length of a DataFlex string). If you do not need to post large amounts of data you can use the simpler string-based function HttpPutRequest.

Sample

The following sample posts an XML document that is passed as an XML node. Since the length could be quite long, we use HttpPutAddrRequest method to do the post.

Function PutXmlNode string sHost string sFilePath handle hoXmlNode returns Boolean
    address aXmlNode aXml
    integer iVoid iLen
    boolean bOK
    handle hoXml

    // write XML data to memory heap pointed to by aXMLNode
    Get paXml of hoXmlNode to aXmlNode

    // we assume data from paXml is always zero terminated
    Move (Length(aXmlNode)) to iLen

    Set psRemoteHost to sHost

    Get AddHeader "CONTENT-TYPE" "text/xml" to bOK

    Get HttpPutAddrRequest sFilePath aXml iLen False to bOK

    Move (Free(aXmlNode)) to iVoid  // free memory

    Function_Return bOk
End_Function

Note:
Note that the cXmlHttpTransfer class already provides the above functionality for you.

Last Edited: August 18, 2003


cBaseHTTPTransfer [Function ResponseHeader]

ResponseHeader - cBaseHTTPTransfer

Returns the value for a named http response header

Type: Function

Return Data Type: String

Parameters: String sHeaderName Integer iIndex

Parameter | Description
sHeaderName | sHeaderName is the name of the response header,
iIndex | iIndex is the zero based index of the header in the case where there are multiple headers with the same name, zero otherwise.

Return Value

Description

ResponseHeader is used to get information from an http response header.

Get ResponseHeader of oHttp "content-length" 0 to sContent

Get ResponseHeader of oHttp "status" 0 to sStatus0
Get ResponseHeader of oHttp "status" 1 to sStatus1

Last Edited: April 7, 2004


cBaseHTTPTransfer [Function ResponseStatusCode]

ResponseStatusCode - cBaseHTTPTransfer

Returns the response http status code

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the response http status code

Description

ResponseStatusCode can be used to gain more information about an http transfer. This can be useful when trying to handle transfer failures. The status codes returned are the standard http status codes.

A few of these codes are:

Code | Description
200 | OK
400 | Bad Request
401 | Unauthorized
403 | Forbidden
404 | Not Found
407 | Proxy Authentication Required
408 | Request Timeout
500 | Internal Server Error
501 | Not Implemented
502 | Bad Gateway
503 | Service Unavailable

Consult an http reference for a complete descriptive list of these codes.

Last Edited: April 7, 2004


cBaseHTTPTransfer [Function SelectClientCertificate]

SelectClientCertificate - cBaseHTTPTransfer

Selects a client certificate to be used in an Http request

Type: Function

Return Data Type: Boolean

Parameters: string sCertificateStore String sCertificateSubject

Parameter | Description
sCertificateStore | String naming a system store
sCertificateSubject | Certificate Subject

Return Value

returns True if certificate was properly selected, False if certificate was not found

Description

If a secure SSL site, requires client certification, your Http object must be able to select a client certificate. The SelectClientCertificate allows you to do this.

The SelectClientCertificate function finds the first or next certificate context in a certificate store containing the specified subject name string. It returns True if successful. If function fails you can examine error code with LastErrorCode property.

The first parameter, sCertStore, is a string naming a system store. Some possible values are:

Value | Meaning
MY | A certificate store that holds certificates with associated private keys (Try this first).
CA | Certification authority certificates.
ROOT | Root certificates.
SPC | Software Publisher Certificate.

Most times you will want to use "MY".

The specified store is searched for a certificate containing the subject name sCertSubject. A case-insensitive substring-within-a-string match is performed. The first one that matches the criteria will be selected.

Example

Suppose there is a certificate in "Personal" store whose subject contains word "Test". You will select that certificate with following code:

Boolean bSelected
Integer   iErrCode

Set piRemotePort to rpHttpSSL
Set peTransferFlags to ifSecure
Get SelectClientCertificate "MY" "Test" to bSelected
If not bSelected begin
    Get LastErrorCode to iErrCode
    :
End

A user can manually select a client certificate by setting the pbShowErrorDialog property to True.

See Also

LastErrorCode | pbShowErrorDialog

Last Edited: June 23, 2005


Methods for cBaseHTTPTransfer

View method list in hierarchical order

Name | Type | Description | Defining Class
AddHeader | Function | Adds the HTTP header named sHeaderName with the value sHeaderValue to the HTTP headers |
ClearHeaders | Procedure | Clears all HTTP headers added using AddHeader |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
HTTPGetRequest | Function | Performs an HTTP GET request using sFilePath |
HTTPPostAddrRequest | Function | Performs an HTTP POST request |
HTTPputAddrRequest | Function | Performs an HTTP PUT request using sFilePath |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
ResponseHeader | Function | Returns the value for a named http response header |
ResponseStatusCode | Function | Returns the response http status code |
SelectClientCertificate | Function | Selects a client certificate to be used in an Http request |


cBaseHTTPTransfer [Procedure ClearHeaders]

ClearHeaders - cBaseHTTPTransfer

Clears all HTTP headers added using AddHeader

Type: Procedure

Parameters: No Parameters

Description

ClearHeaders clears all HTTP headers added using AddHeader. Returns True if successful, and False otherwise.

Last Edited: July 30, 2003


Properties for cBaseHTTPTransfer

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
LastErrorCode | Returns the last error code from the HTTP / FTP Transfer | InetTransfer
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbShowErrorDialog | Determines if a popup dialog will appear when a client certificate or usename/password is needed for an Http Request |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peTransferFlags | Various flags that control how file/data should be transferred | InetTransfer
piBufferSize | Specifies the size of the file transfer buffer | InetTransfer
piRemotePort | Specifies the port to connect to on RemoteHost | InetTransfer
psAcceptTypes | Specifies the HTTP content types accepted by the client |
psAgent | Specifies the name of the application | InetTransfer
psPassword | Specifies the password to use to log on | InetTransfer
psProtocolVersion | Specifies the HTTP protocol version |
psProxy | Specifies the name of the Proxy server used, if any | InetTransfer
psRemoteHost | Specifies the hostname or the IP address of the remote server | InetTransfer
psSaveasFile | Saves response from the remote host to the specified file instead of triggering the OnDataReceived event |
psUserName | Specifies the name of the user to log on | InetTransfer
RootHandle | Returns the root HINTERNET handle used for the session | InetTransfer


cBaseHTTPTransfer [Property pbShowErrorDialog]

pbShowErrorDialog - cBaseHTTPTransfer

Determines if a popup dialog will appear when a client certificate or usename/password is needed for an Http Request

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbShowErrorDialog determines if a popup dialog will appear when a client certificate or usename/password is needed for an Http Request. If pbShowErrorDialog is set to True and an Http request fails because Client Certificate is needed or invalid, or username/password authentication is required it will pop up appropriate dialogs allowing the user to enter the required information.

Default Value is False.

The Http class is used primarily to provide access data under program control and, therefore, you want to control these requirements under program control. You may do so using the messages SelectClientCertificate, psUserName, psPassWord, piRemotePort and peTransferFlags.

Last Edited: July 30, 2004


cBaseHTTPTransfer [Property psAcceptTypes]

psAcceptTypes - cBaseHTTPTransfer

Specifies the HTTP content types accepted by the client

Type: Property

Access: Read/Write

Data Type: String

Description

psAcceptTypes specifies the HTTP content types accepted by the client. Several content types can be specified separated with a ',' (comma). For example, "text/html, text/plain", specifies plain text and html text, but no other formats. Wildcards may also be used, for example "text/*" specifies all text formats are accepted.

Default is "text/*".

Last Edited: September 11, 2003


cBaseHTTPTransfer [Property psProtocolVersion]

psProtocolVersion - cBaseHTTPTransfer

Specifies the HTTP protocol version

Type: Property

Access: Read/Write

Data Type: String

Description

psProtocolVersion specifies the HTTP protocol version.

Default is "HTTP/1.0".

Last Edited: September 11, 2003


cBaseHTTPTransfer [Property psSaveasFile]

psSaveasFile - cBaseHTTPTransfer

Saves response from the remote host to the specified file instead of triggering the OnDataReceived event

Type: Property

Access: Read/Write

Data Type: String

Description

Any response from the remote host will be saved to the specified file instead of triggering the OnDataReceived event. If blank, the OnDataReceived event is triggered instead.

Last Edited: September 11, 2003


cBasicReport [Event Error_Report]

Error_Report - cBasicReport

Sent whenever an error is generated

Type: Event

Parameters: integer ErrNum integer Err_Line string ErrMsg

Parameter | Description
ErrNum | the error number
Err_Line | the error line
ErrMsg | the error message

Description

When a report is started, the main report (the outermost of a group of nested reports) is assigned as the error object. This means that all errors are sent to this object. The Error_Report message is sent whenever an error is generated. By default, the status panel is removed, the property error_check_state is set true, and the error is then directed to the normal error handler (the object defined as the error object when the report started). If status_log_state is true, errors will be written to the status-log file. If display_error_state is true, the error is directed to the global error-handler object. This sends onError.

Note: Previous versions of Visual DataFlex only required two parameters for this message - the error number and line number was packed in a single complex integer. Three parameters are now required. If you have old code that uses this, it must be changed.

Last Edited: August 5, 2003


cBasicReport [Event OnEndingMainReport]

OnEndingMainReport - cBasicReport

User Handler Intended for override

Type: Event

Parameters: No Parameters

Description

OnEndingMainReport is a user Handler Intended for override. This is the same as OnEndingReport except this message is only sent to the main (parent) outer report. Nested reports do not send this message. You will rarely need to use this event.

Last Edited: September 10, 2003


cBasicReport [Event onError]

onError - cBasicReport

Provided as a hook to handle custom error reporting

Type: Event

Parameters: integer ErrNum integer Err_Line string ErrMsg

Parameter | Description
ErrNum | the error number
Err_Line | the error line
ErrMsg | the error message

Description

OnError does nothing by default and is provided as a hook to handle custom error reporting. This message is designed for augmentation and should never be sent. It is sent whenever an error occurs (it is sent by Error_report.).

This message is sent by error_report (which is itself called anytime an error occurs). If you study error_report, you will see that this procedure might have already logged the error in a status log (if status_log_state is true) and might have reported the error in a message box (if display_error_state is true). Often these options will be all that is required and there will be no need to augment this message. If status_log_state is false and display_error_state is false (both of these are the defaults), then no error processing has occurred and you may wish to augment this procedure to handle an error.

Last Edited: June 22, 2005


cBasicReport [Event OnStartingMainReport]

OnStartingMainReport - cBasicReport

Called when a report is started

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

If a non-zero value is returned the report will be cancelled.

Description

OnStartingMainReport is called when a report is started. This is the same as OnStartingReport except this message is only sent to the main (parent) outer report.

This message is intended for augmentation. If you do augment this event, make sure you forward the message. Reports will not run properly if the event is cancelled.

You should rarely need to augment this event.

Last Edited: September 10, 2003


cBasicReport [Event Report_Interrupt]

Report_Interrupt - cBasicReport

Called when the status panel's Cancel button has been pressed

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Return a zero value if the report is to continue, or non-zero to stop the report.

Description

Report_interrupt is called when the status panel's Cancel button has been pressed. Normally it displays a message asking the user if they wish to cancel the report. If the user selects Yes, a non-zero value is returned and the report is terminated. If a zero value is returned, the report continues. You may augment this message to present custom choices. The report is suspended at this point.

The property Error_Check_State can be queried from within this function. If it is non-zero, then the interrupt has been caused by an error.

Last Edited: September 11, 2003


Events for cBasicReport

View event list in hierarchical order

Name | Description | Defining Class
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property | cReport
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Error_Report | Sent whenever an error is generated |
Final_Formfeed |  | cReport
OnBody | Called every time a valid record has been found | cReport
OnConstrain |  | cReport
OnEndingMainReport | User Handler Intended for override |
OnEndingReport | Called at the end of all reports | cReport
onError | Provided as a hook to handle custom error reporting |
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables | cReport
OnPageFooter | Printed after OnPageTotal on every page except the last page | cReport
OnPageHeader | Called after OnPageTop on every new page except the first | cReport
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader. | cReport
OnPageTop | Called when printing the top of every report | cReport
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page | cReport
OnReportFooter | Printed after OnPageTotal on the last page of the report | cReport
OnReportHeader | Called only on the first page of the report, after OnPageTop | cReport
OnSelection | Validates a record | cReport
OnStartingMainReport | Called when a report is started |
OnStartingReport | Called when a report is started | cReport
OnSubHeader1..n | Called each time a subheader needs to be printed | cReport
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program | cReport
OnSubTotal1..n | Called when a subtotal needs to be processed | cReport
OnTotal | Called at the end of a report after all final sub-totals have been printed | cReport
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found | cReport
Report_Interrupt | Called when the status panel's Cancel button has been pressed |


Methods for cBasicReport

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoRunReport | Function | The main entry point for reportsT | cReport
End_Log | Procedure | Sends an end-log message to the log object |
Error_Log_Status | Procedure | Called by error_report if status_log_state is true |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Formfeed | Procedure | Handles formfeeds | cReport
Log_Status | Procedure | Sends passed message to the log object |
Output_ImageNum | Procedure | Outputs the image represented by ImageNum | cReport
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO | cReportDS
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Save | Procedure | If sent, this saves the current record | cReportDS
Start_Log | Procedure | Sends a start-log message to the log object |
Update_Status | Procedure | Send this message to update the action area of the status panel |
WriteLn | Procedure | Outputs the string message to the current output channel | cReport
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data | cReport


cBasicReport [Procedure End_Log]

End_Log - cBasicReport

Sends an end-log message to the log object

Type: Procedure

Parameters: No Parameters

Description

End_log sends an end-log message to the log object. It calls Log_Status passing status title plus the number of errors encountered. Sent by End_Process. Good for augmentation.

Last Edited: August 6, 2003


cBasicReport [Procedure Error_Log_Status]

Error_Log_Status - cBasicReport

Called by error_report if status_log_state is true

Type: Procedure

Parameters: integer ErrNum integer Err_Line string ErrMsg

Parameter | Description
ErrNum | the error number
Err_Line | the error line
ErrMsg | the error message

Description

Error_log_status is called by error_report if status_log_state is true. By default it sends the message log_status, passing a string consisting of Error: + Error Number + Error Message. This message can also be sent. For example, you may augment onError to send this message when status_log_state is false.

Procedure onError integer Error_Info String ErrMsg
    send Error_Log_Status Error_info ErrMsg
End_procedure

The variable Error_Info is a complex Integer where hi(Error_info) is the error number and low(error_info) is the error line number.

Last Edited: September 7, 2005


cBasicReport [Procedure Log_Status]

Log_Status - cBasicReport

Sends passed message to the log object

Type: Procedure

Parameters: String Mess

Parameter | Description
Mess | the message

Description

Log_status sends passed message to the log object. It is good for sending. All status messages go through this procedure here. By default this message finds the object ID of the status-log object, and, if found, sends the same message on to that object.

Because all log messages pass through this procedure, this message can be used to customize or disable any logging process.

Last Edited: August 18, 2003


cBasicReport [Procedure Start_Log]

Start_Log - cBasicReport

Sends a start-log message to the log object

Type: Procedure

Parameters: No Parameters

Description

The Start_log procedure sends a start-log message to the log object. It calls Log_Status passing Start process: plus the name of the process (status title). Sent by Start_Process. Good for augmentation.

Last Edited: September 11, 2003


cBasicReport [Procedure Update_Status]

Update_Status - cBasicReport

Send this message to update the action area of the status panel

Type: Procedure

Parameters: string Val

Parameter | Description
Val | the value

Description

You send the Update_status message to update the action area of the status panel. This will often be sent within the body section of a report.

Procedure_Section Body
    Send Update_Status Customer.Name
    :

Note that the passed value may be as complex as required:

Send Update_Status (Customer.Name *"Order #" *String(Order.Number) )

This is your primary message for updating status-panel progress.

Last Edited: August 6, 2003


Properties for cBasicReport

View property list in hierarchical order

Name | Description | Defining Class
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button |
Assigned_Channel |  | cReport
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Error_State |  |
Find_Mode | Maintains the current finding mode | cReport
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image | cReport
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function | cReport
Last_Rec | (Obsolete) Contains the record number of the last selected record found | cReport
Main_File | Contains the filenumber of the file which the report will use for finding records | cReport
Name | Returns the full name of the object including parentage | cObject
New_Page_State | Set true when a new page is needed | cReport
No_Constrained_Find_State | Determines if constrained record finding should be disabled | cReport
No_Finding_State | Determines how the cReport object will find records | cReport
No_PageCheck_State | Set true when the cReport object is processing a new page | cReport
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found | cReport
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Output_Device | Handles the name of the output device |
Page_Count | Keeps track of the current page number | cReport
Page_End | Determines how many lines on a page are allowed before a page break will occur | cReport
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence | cReport
Page_Feed | Used by the formfeed procedure | cReport
Page_Footer_Lines | The number of lines in the page_footer image | cReport
Parent | Returns the parent of an object | cObject
pbCanceled | Setting this true will cancel a report | cReport
pbChildReport | Set true if the current cReport object is nested | cReport
pbFindDown | Determines if the report should traverse up or down the index | cReport
pbHasChildReports | Is set true if other reports are nested inside this report object | cReport
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level | cReport
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phMainReport | Contains the object ID of the outer report | cReport
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found | cReport
piNumberBreaks | Returns the number of breaks in a report | cReport
piOrdering | Contains the index number which will be used for finding records | cReport
piRecordCount | Contains the number of records found for the current report | cReport
priCurrentRec | Contains the RowId of the current valid record found | cReport
priFoundRec | Contains the RowId of the record found by the find_rec function | cReport
priLastRec | Contains the RowId of the last selected record found | cReport
Report_Caption | Contains the text that will appear in the status panel's caption bar |
Report_Channel | Determines which output channel will be used for your report output | cReport
Report_Footer_Lines | The number of lines in the OnReportFooter image | cReport
Report_Message | An additional message area that will appear below the report_title in the status panel |
Report_Status_Panel |  |
Report_Title | A centered title that appears in the status panel |
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing | cReport
Server | Identifies the object handle that is used as the report object's main data-dictionary object | cReportDS
Status_Log_Id | Object ID of status-log object |
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs |
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs |
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals | cReport


cBasicReport [Property Allow_Cancel_State]

Allow_Cancel_State - cBasicReport

Specifies whether the status panel will support a Cancel button

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Allow_Cancel_State specifies whether the status panel will support a Cancel button. When false, the status panel is used only to show progress.

Default is true.

Last Edited: January 12, 2006


cBasicReport [Property Display_Error_State]

Display_Error_State - cBasicReport

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: August 4, 2006


cBasicReport [Property Output_Device]

Output_Device - cBasicReport

Handles the name of the output device

Type: Property

Access: Read/Write

Data Type: String

Description

Output_device handles the name of the output device. If the device name is empty (the default) and the report is in a report view or report panel, it will use that container's output_device_name. If this is blank, a default value of WINLST: is used. This means that you often do not need to explicitly set this property. When you set it in the report container, it is automatically acquired by all reports within the container.

Last Edited: September 10, 2003


cBasicReport [Property Report_Caption]

Report_Caption - cBasicReport

Contains the text that will appear in the status panel's caption bar

Type: Property

Access: Read/Write

Data Type: String

Description

Report_caption contains the text that will appear in the status panel's caption bar. By default, the caption is Printing Report.

Last Edited: September 11, 2003


cBasicReport [Property Report_Message]

Report_Message - cBasicReport

An additional message area that will appear below the report_title in the status panel

Type: Property

Access: Read/Write

Data Type: String

Description

Report_message is an additional message area that will appear below the report_title in the status panel. This will often be empty.

Last Edited: September 11, 2003


cBasicReport [Property Report_Status_Panel]

Report_Status_Panel - cBasicReport

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: July 2, 2003


cBasicReport [Property Report_Title]

Report_Title - cBasicReport

A centered title that appears in the status panel

Type: Property

Access: Read/Write

Data Type: String

Description

Report_title is a centered title that appears in the status panel. It has no default value.

Last Edited: September 11, 2003


cBasicReport [Property Status_Log_Id]

Status_Log_Id - cBasicReport

Object ID of status-log object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Status_log_id is the Object ID of status-log object. When Log_Status is sent, it directs the message to status_log_ID. If this ID is zero, status logging will be ignored. (All status logging goes through the message Log_Status. Log_Status checks the value of this property. If non-zero, it sends the message Log_Status to the status-object ID. If zero, it does nothing.)

It is your responsibility to include a status-log object in your program (you can use the one provided in StatLog.pkg as an example) and to assign the status object's ID to this property.

Use StatLog.pkg // creates object named Status_Log
:
:
Object xxxx is a BasicReport
    Set Status_Log_Id to Status_Log
    Set Status_Log_State to TRUE
    :

Last Edited: August 6, 2004


cBasicReport [Property Status_Log_State]

Status_Log_State - cBasicReport

Determines if automatic status logging will occur when process starts, stops, and when an error occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set Status_Log_State true if you want automatic status logging (to status-log object) to occur when process starts, stops, and when an error occurs.

This property only affects automatic logging (start process, stop process, and error logging). The program can log messages at any time by sending the messages status_log, start_log, stop_log and error_log_status.

Last Edited: January 12, 2006


cBasicReport [Property Status_Panel_State]

Status_Panel_State - cBasicReport

Enables or disables the status panel that reports the status of the report as it runs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Status_panel_state enables or disables the status panel that reports the status of the report as it runs.

Last Edited: January 12, 2006


Events for cClientWebService

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cClientWebService [Function DefineParameter]

DefineParameter - cClientWebService

Defines an operation parameter for a web service operation

Type: Function

Return Data Type: tSoapParamDef

Parameters: integer eDataType integer iMin integer iMax string sName string sNS

Parameter | Description
eDataTypeSOAP Parameter data-type

Constant Meaning
xsString String
xsNumber Number
xsDate Date
xsInteger Integer
xsBigint BigInt
xsReal Real
xsBoolean Boolean
xsTime Time
xsDatetime Datetime
xsFloat Float
xsChar Char
xsUchar UChar
xsShort Short
xsUShort UShort
xsUinteger UInteger
xsUbigint Ubigint
xsCurrency Currency
xsDecimal Decmall
xsAnyType XML parameter without the wrapper
xsXmlElement XML including the wrapper

iMin | Minimum number of occurances of parameter. 0 or 1
iMax | Maximum number of occurances of parameter. 1-C_Unbounded
sName | Parameter SOAP Name
sNS | Parameter SOAP Namespace

Return Value

Description

The DefineParameter function is used to define a request parameter or a return parameter. This is used to define parameters whose data type is fundamental (e.g., Integer, String) or pure XML. Struct parameters are defined using the DefineStructParameter method.

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

Last Edited: January 10, 2006


cClientWebService [Function DefineStructParameter]

DefineStructParameter - cClientWebService

Defines an operation parameter for a web service operation

Type: Function

Return Data Type: tSoapParamDef

Parameters: handle hoStruct integer iMin integer iMax string sName string sNS

Parameter | Description
hoStruct | Pointer to object which defines the struct
iMin | Minimum number of occurances of parameter. 0 or 1
iMax | Maximum number of occurances of parameter. 1-C_Unbounded
sName | Parameter SOAP Name
sNS | Parameter SOAP Namespace

Return Value

Description

The DefineStructParameter function is used to define a request parameter or a return parameter. This is used to define parameters whose data type is a struct. Fundemental Parameters are defined using the DefineParameter method.

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

See Also

DefineParameter

Last Edited: August 3, 2005


cClientWebService [Function DoInvokeService]

DoInvokeService - cClientWebService

Invokes a web service call

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the transfer status (value of peTransferStatus)

Description

DoInvokeService invokes a web-service call. This is done after an operation has been reset and defined.

Possible return values are:

Constant | Meaning
wssOk | Request succeeded
wssHttpRequestFailed | Http request failed
wssBadRequest | Bad or missing data sent
wssInvalidContentType | Invalid contentType received
wssNoData | No data was received
wssNotXml | Received data not in proper XML format
wssNotSoap | Received XML data not in proper Soap format
wssInvalidSoap | Received SOAP data not formatted according to service description
wssSoapFault | Soap Fault Returned

The return value will contain the same value as peTransferStatus.

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

See Also

peTransferStatus

Last Edited: March 25, 2004


cClientWebService [Function ReturnValue]

ReturnValue - cClientWebService

Returns the last web-service class return value in the proper data-type

Type: Function

Obsolete

Return Data Type: String

Parameters: No Parameters

Return Value

The last web-service class return value will be converted to the proper data type and returned

Description

The ReturnValue function returns the last web-service call return value. The value is deserialized and converted to the appopriate data-type.

Get DoInvokeService to eStatus
If (eStatus=wssOK) Begin
    Get ReturnValue to llCustomerXMLListResult
end
Else Begin
    Send LastError
end

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

Last Edited: December 17, 2004


cClientWebService [Function SoapHeaderRequestNode]

SoapHeaderRequestNode - cClientWebService

Returns SOAP header request information that was passed to a web service.

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns object handle of the XML object representing the SOAP request header that was passed in the last web service call.

Description

The SoapHeaderRequestNode provides a low level mechanism for processing SOAP header information. After a web service has been invoked, a developer can call this method to return a handle to an XML document object containing the SOAP header data that was passed to the server. The object handle returned will be a handle to an XML document object (cXMLDomDocument) and represents the entire SOAP header XML node. The root node of this document will be the SOAP

node and each child node should be an element node representing a header.

SOAP request headers are created using the ClearSoapHeaders and AddSoapHeaderNode methods. SoapHeaderRequestNode contains the results of this creation. Note that this method should only be used after the web service has been invoked.

It is the responsibility of the developer to destroy the XML object within the method that uses it.

This method will be rarely used, since the developer normally does not need to know anything about the request headers that they just created.

See Also

ClearSoapHeaders | AddSoapHeaderNode | SoapHeaderRequestNode

Last Edited: November 2, 2006


cClientWebService [Function SoapHeaderResponseNode]

SoapHeaderResponseNode - cClientWebService

Returns SOAP header response information passed from the web service as an XML object.

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns object handle of the XML object representing the SOAP header returned from the web service call. If no SOAP header exists, zero it returned.

Description

The SoapHeaderResponseNode provides a low level mechanism for processing SOAP header information returned from a web service method. It is expected that a developer using this method understands SOAP headers and understands how to work with XML objects.

The object handle returned will be a handle to an XML document object (cXMLDomDocument) and represents the entire SOAP header XML node. The root node of this document will be the SOAP

node and each child node should be an element node representing a header.

If a SOAP Header is not passed to the method, which is the norm, zero is returned.

It is the responsibility of the method to destroy the XML object.
<SOAP-ENV:Header
    xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
   <t:Transaction xmlns:t="some-URI-1">5</t:Transaction>
   <UserId xmlns="some-URI-2">XXX</UserId>
   <RetryCount xmlns="some-URI-2">2</RetryCount>
</SOAP-ENV:Header>

The following example processes all SOAP headers passed back from a web service invocation.

Procedure CallTheService
    Handle hoXml hoRoot hoNode
    String sName sReply
    String sBase sNSURI sValue

    // invoke the service
    Get Value of oRequest to sName
    Get wsSayHello of oWSTestService1 sName to sReply
    Set value of oResponse to sReply

    // process all SOAP response headers
    Get SoapHeaderResponseNode of oWSTestService1 to hoXml
    Set phoHeader to hoXml
    If (hoXml) Begin
        Get DocumentElement of hoXML to hoRoot // this is <Header>
        // process all nodes within the SOAP header
        Get FirstChild of hoRoot to hoNode
        While hoNode
            Get psNamespaceURI of hoNode to sNSURI
            Get psBaseName of hoNode to sBase
            Get psText of hoNode to sValue
            Send ProceessThisHeader sNSURI sBase sValue
            Get NextNode of hoNode to hoNode
        Loop
        Send Destroy of hoXml
    End
End_Procedure

See Also

ClearSoapHeaders | AddSoapHeaderNode | SoapHeaderRequestNode

Last Edited: November 2, 2006


cClientWebService [Function TransferErrorDescription]

TransferErrorDescription - cClientWebService

Returns an error description for the last transfer

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

A string containing the description for the last error

Description

The peTransferStatus property is set after a web-service call. If a transfer error occured (the value is not wssOK), the text for that error may be determined by calling the TransferErrorDescription.

Set pbSuppressLastError of of oWSCustomerService to false
Get wsCustomerName of oWSCustomerService to sName
Get peTransferStatus of oWSCustomerService to eTransferStatus
If (eTransferStatus=wssOK) begin
    Send AddNewName sName
end
else Begin
     // handle soap fault errors in a special way. Report all others as errors
    If (eTransferStatus=wssSoapFault) begin
        Get TransferErrorDescription of oWSCustomerService to sErr
        Send WeHadAFaultError sErr
    end
    else begin
        Send LastError of oWSCustomerService // this will generate an error
    end
end

See Also

psFaultCode | psFaultString | pbSuppressLastError | peTransferStatus | LastError

Last Edited: April 7, 2004


Methods for cClientWebService

View method list in hierarchical order

Name | Type | Description | Defining Class
AddParameter | Procedure | (Obsolete) Adds or sets a Parameter's data-value |
AddSoapHeaderNode | Procedure | Adds a SOAP header node to a method's request. |
ClearSoapHeaders | Procedure | Clears all SOAP request headers. |
Create | Function | Creates an object based on the passed Class Id | cObject
DefineParameter | Function | Defines an operation parameter for a web service operation |
DefineParameter | Procedure | (Obsolete) Sets a parameters data-type, name and schema type name |
DefineReturn | Procedure | (Obsolete) Sets an operation's return data-type, name and schema type name |
DefineStructParameter | Function | Defines an operation parameter for a web service operation |
Destroy | Procedure |  | cObject
DoInvokeService | Function | Invokes a web service call |
Exit_Application | Procedure | Starts the process of closing an application | cObject
LastError | Procedure | Used to manually report an error after a Web Service call |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Reset | Procedure | Resets all object information in preparation for a new web-service call |
ReturnValue | Function | (Obsolete) Returns the last web-service class return value in the proper data-type |
SoapHeaderRequestNode | Function | Returns SOAP header request information that was passed to a web service. |
SoapHeaderResponseNode | Function | Returns SOAP header response information passed from the web service as an XML object. |
TransferErrorDescription | Function | Returns an error description for the last transfer |


cClientWebService [Procedure AddParameter]

AddParameter - cClientWebService

Adds or sets a Parameter's data-value

Type: Procedure

Obsolete

Parameters: integer iParameterNumber string sValue

Parameter | Description
iParameterNumber | Paramter Index (0 is the first parameter)
sValue | Parameter Value

Description

Obsolete

This procedure was used by web clients generated prior to version 11.0. It has been replaced with the DefineParameter function.

AddParameter adds or sets a Parameter's data-value.

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

See Also

DefineParameter-Procedure | DefineParameter-Function

Last Edited: February 2, 2005


cClientWebService [Procedure AddSoapHeaderNode]

AddSoapHeaderNode - cClientWebService

Adds a SOAP header node to a method's request.

Type: Procedure

Parameters: Handle hoNode

Parameter | Description
hoNode | The handle to an XML element node to added as a SOAP header

Description

AddSoapHeaderNode is used to add SOAP headers to a method's SOAP request. This method, along with ClearSoapHeaders, is used to create and manage SOAP request headers. This is a low level mechanism. It is expected that a developer using this method understands SOAP Headers and understands how to work with XML objects.

The handle passed to this method must be a handle to an XML element object (cXMLDomElement). If an element node is not passed, an error will be generated.

Note that you do need to pass the actual SOAP

node -- this is done for you. Instead you pass the element nodes that are the children of the header node. Each time you call AddSoapHeaderNode, you add a new node to the SOAP header.

<SOAP-ENV:Header
    xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<Transaction xmlns="some-URI">5</Transaction>
   <RetryCount xmlns="some-URI">2</RetryCount>
</SOAP-ENV:Header>

The above SOAP header could be created as follows:

Procedure CallTheMethod
    Handle hoXml hoRoot hoNode
    String sName sReply

    // always first clear any existing headers
    Send ClearSoapHeaders of oWSTestService1

    Get Create U_cXmlDomDocument to hoXml
    Get CreateDocumentElementNS of hoXml "some-URI" "Nodes" to hoRoot

    // create and add first SOAP Header
    Get AddElementNS of hoRoot "some-URI" "Transaction" "5" to hoNode
    Send AddSoapHeaderNode of oWSTestService1 hoNode
    Send Destroy of hoNode

    // create and add second SOAP Header
    Get AddElementNS of hoRoot "some-URI" "RetryCount" "2" to hoNode
    Send AddSoapHeaderNode of oWSTestService1 hoNode
    Send Destroy of hoNode

    // destroy the XML object
    Send Destroy of hoXml

    // invoke the service
    Get Value of oRequest to sName
    Get wsSayHello of oWSTestService1 sName to sReply
    Set Value of oResponse to sReply
End_Procedure

Lifespan of SOAP Request Headers

SOAP request headers in a web service client are maintained at the object level and not at the method level. When a header is added, it is added to all web service methods that are called within the object. Once a SOAP header is added, it will be added to all methods until the headers are all cleared using ClearSoapHeaders.

As a general rule, if you are using SOAP request headers in a web service object you should always clear the soap headers and add the new soap headers for each web service invocation.

See Also

ClearSoapHeaders | SoapHeaderRequestNode | SoapHeaderResponseNode

Last Edited: November 2, 2006


cClientWebService [Procedure ClearSoapHeaders]

ClearSoapHeaders - cClientWebService

Clears all SOAP request headers.

Type: Procedure

Parameters: No Parameters

Description

ClearSoapHeaders is use to clear all SOAP request headers. This method, along with AddSoapHeaderNode, is used to create and manage SOAP request headers. This is a low level mechanism. It is expected that a developer using this method understands SOAP Headers and understands how to work with XML objects.

SOAP request headers in a web service client are maintained at the object level and not at the method level. When a header is added, it is added to all web service methods that are called within the object. Once a SOAP header is added, it will be added to all methods until the headers are all cleared using ClearSoapHeaders.

As a general rule, if you are using SOAP request headers in a web service object you should always clear the soap headers and add the new soap headers for each web service invocation.

Procedure CallTheMethod
    Handle hoXml hoRoot
    String sName sReply

    // always first clear any existing headers
    Send ClearSoapHeaders of oWSTestService1

    Get Create U_cXmlDomDocument to hoXml
    Get CreateDocumentElementNS of hoXml "some-URI" "SomeHeader" to hoRoot
    Set psText of hoRoot to "SomeData"
    Send AddSoapHeaderNode of oWSTestService1 hoRoot
    // destroy the XML object
    Send Destroy of hoXml

    // invoke the service
    Get Value of oRequest to sName
    Get wsSayHello of oWSTestService1 sName to sReply
    Set Value of oResponse to sReply
End_Procedure

See Also

AddSoapHeaderNode | SoapHeaderRequestNode | SoapHeaderResponseNode

Last Edited: November 2, 2006


cClientWebService [Procedure DefineParameter]

DefineParameter - cClientWebService

Sets a parameters data-type, name and schema type name

Type: Procedure

Obsolete

Parameters: integer iParameterNumber integer eType string sName string sSchemaType

Parameter | Description
iParameterNumber | Parameter Index (0=First Parameter)
eType | Parameter data-type
sName | Parameter Name
sSchemaType | Parameter Schema Type Name

Description

Obsolete

This procedure was used by web clients generated prior to version 11.0. It has been replaced with the DefineParameter function.

DefineParameter defines for an operation a parameter's return data-type, name and schema type name.

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

See Also

AddParameter | DefineParameter-Function

Last Edited: February 2, 2005


cClientWebService [Procedure DefineReturn]

DefineReturn - cClientWebService

Sets an operation's return data-type, name and schema type name

Type: Procedure

Obsolete

Parameters: integer eType string sname string sSchemaType

Parameter | Description
eType | Return DataType
sname | Return Name
sSchemaType | Return Schema Type Name

Description

Obsolete

This procedure was used by web clients generated prior to version 11.0. It has been replaced with the DefineParameter function.

DefineReturn defines an operation's return data-type, name and schema type name.

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

See Also

DefineParameter-Function

Last Edited: February 2, 2005


cClientWebService [Procedure LastError]

LastError - cClientWebService

Used to manually report an error after a Web Service call

Type: Procedure

Parameters: No Parameters

Description

Normally any web-service call error will result in an error being reported. This can be suppressed by setting the pbSuppressLastError property to True. If you choose to suppress the error, you will want to handle the error reporting yourself. You can check the status of your last web-service call with the peTransferStatus property. You can report any errors by sending the message LastError. If no error occurred, LastError will do nothing.

These two code samples, would do the exact same thing. If an error occurs, an error will be reported:

Set pbSuppressLastError of of oWSCustomerService to true // this is actually the default
Get wsCustomerName of oWSCustomerService to sName  // if an error occurred, it will be reported

Set pbSuppressLastError of of oWSCustomerService to false // do not show an error automatically
Get wsCustomerName of oWSCustomerService to sName  // if an error occurred, it will be reported
Send LastError // if an error occured it will be reported

Normally LastError is used to perform more complicated error handling.

Set pbSuppressLastError of of oWSCustomerService to false
Get wsCustomerName of oWSCustomerService to sName
Get peTransferStatus of oWSCustomerService to eTransferStatus
If (eTransferStatus=wssOK) begin
    Send AddNewName sName
end
else Begin
     // handle soap fault errors in a special way. Report all others as errors
    If (eTransferStatus=wssSoapFault) begin
        Get TransferErrorDescription of oWSCustomerService to sErr
        Send WeHadAFaultError sErr
    end
    else begin
        Send LastError of oWSCustomerService // this will generate an error
    end
end

See Also

peTransferStatus | psFaultCode | psFaultString | peTransferStatus | TransferErrorDescription

Last Edited: April 7, 2004


cClientWebService [Procedure Reset]

Reset - cClientWebService

Resets all object information in preparation for a new web-service call

Type: Procedure

Parameters: No Parameters

Description

Reset resets all object information. This must always be sent before a new web-service request is assembled and called.

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

Last Edited: March 25, 2004


Properties for cClientWebService

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbRequestBare | Determines if the web service's soap request uses a bare style for parameters |
pbResponseBare | Determines if the web service's soap response uses a bare style for parameters |
pbSuppressLastError | Determines if a web-service call error should be reported |
pbValidateResponse | Determines if validation of a SOAP response should be relaxed |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResponseSoapEncoding | Encoding Style for the SOAP response |
peSoapEncoding | Encoding Style for the SOAP request |
peSoapStyle | Soap Style - Document or RPC |
peTransferStatus | Returns the status of the last web-service call |
phoHttp | Contains the handle of the Http object used by the client web-service |
phoSoapClientHelper | Provides a mechanism for connecting any Web Service to a test view |
phoSoapRequest | A handle to an XML document object containing the last SOAP request |
phoSoapResponse | A handle to an XML document object containing the last SOAP Response |
piPort | Determines the port used for a web-service call |
psCertificateStore | Set the Certificate Store string for selecting a client certficate |
psCertificateSubject | Set the Certificate Subject string for selecting a client certficate |
psContentType | Determines the content type for the soap/http request |
psFaultCode | Returns the FaultCode of the last web service call |
psFaultString | Returns the FaultCode of the last web service call |
psMethodRequest | The name of the operation's request |
psMethodResponse | The name of the operation response |
psPassword | Specifies the password to use to log on |
psRequestNSURI | Sets the Request NameSpace URI (targetNameSpace) |
psResponseNSURI | Sets the Response NameSpace URI (targetNameSpace) |
psServiceLocation | Determines the URL location of your web-service |
psSOAPAction | Sets the SOAPAction for the Web-service call |
psUserName | Specifies the name of the user to log on |
psWSDLLocation | Determines the URL location of the WSDL document used to create the class |
psXmlEncoding | Sets the encoding style used for the web-service call |


cClientWebService [Property pbRequestBare]

pbRequestBare - cClientWebService

Determines if the web service's soap request uses a bare style for parameters

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Document style web-services usually use a "wrapped" style when creating a soap response or request. Some services (e.g., .net) allow you to define a bare style where a wrapper element is not included in the soap body. When the Visual DataFlex Client Service Generator encounters such a service it will set the pbResponseBare and pbRequestBare properties to true. This allows the client class to properly serialize and deserialize the data. These request and response properties are usually the same, but it is possible to set these styles individually.

Since the bare vs. wrapped style is determined by the web-service, you should never need to change this.

This property only applies to document style web services. RPC styles always use a wrapped style.

The Web Service Client Generator determines if a style is bare or wrapped by looking at the service's WSDL. If the name attribute within the part element section (which is in the message element section) has a value of "parameters" the document is wrapped (pbResponseBare / pbRequestBare are false). If the name is not "parameters", it is bare. You should note that most part names are set to "parameters" and therefore most services use a wrapped style.

See Also

pbResponseBare

Last Edited: December 17, 2004


cClientWebService [Property pbResponseBare]

pbResponseBare - cClientWebService

Determines if the web service's soap response uses a bare style for parameters

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Document style web-services usually use a "wrapped" style when creating a soap response or request. Some services (e.g., .net) allow you to define a bare style where a wrapper element is not included in the soap body. When the Visual DataFlex Client Service Generator encounters such a service it will set the pbResponseBare and pbRequestBare properties to true. This allows the client class to properly serialize and deserialize the data. These request and response properties are usually the same, but it is possible to set these styles individually.

Since the bare vs. wrapped style is determined by the web-service, you should never need to change this.

This property only applies to document style web services. RPC styles always use a wrapped style.

The Web Service Client Generator determines if a style is bare or wrapped by looking at the service's WSDL. If the name attribute within the part element section (which is in the message element section) has a value of "parameters" the document is wrapped (pbResponseBare / pbRequestBare are false). If the name is not "parameters", it is bare. You should note that most part names are set to "parameters" and therefore most services use a wrapped style.

See Also

pbRequestBare | pbValidateResponse

Last Edited: February 2, 2005


cClientWebService [Property pbSuppressLastError]

pbSuppressLastError - cClientWebService

Determines if a web-service call error should be reported

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Normally any web-service call error will result in an error being reported. This can be suppressed by setting the pbSuppressLastError property to True. If you choose to suppress the error, you will want to handle the error reporting yourself. You can check the status of your last web-service call with the peTransferStatus property. You can report any errors by sending the message LastError.

Set pbSuppressLastError of oWSCustomerService to True
Get wsCustomerName of oWSCustomerService to sName
Get peTransferStatus of oWSCustomerService to eTransferStatus
If (eTransferStatus=wssOK) begin
    Send AddNewName sName
end
else begin
    // Handle soap fault errors in a special way. Report all others as errors.
    if (eTransferStatus=wssSoapFault) begin
        Get TransferErrorDescription of oWSCustomerService to sErr
        Send WeHadAFaultError sErr
    end
    else begin
        Send LastError of oWSCustomerService // this will generate an error
    end
end

See Also

psFaultCode | psFaultString | peTransferStatus | TransferErrorDescription | LastError

Last Edited: February 3, 2005


cClientWebService [Property pbValidateResponse]

pbValidateResponse - cClientWebService

Determines if validation of a SOAP response should be relaxed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Normally a web service's response should be fully validated against the expected result. In some cases, web-services may not properly adhere its service definition (WSDL). The pbValidateResponse relaxes this validation. By default this property is true, which means a full validation is performed. If your web service seems to be returning proper (i.e., usable) data but you are getting a response error, you can try setting this property to false.

This can also be used with pbResponseBare to return the entire SOAP body without performing any validation.

See Also

pbResponseBare

Last Edited: February 2, 2005


cClientWebService [Property peResponseSoapEncoding]

peResponseSoapEncoding - cClientWebService

Encoding Style for the SOAP response

Type: Property

Access: Read/Write

Data Type: Integer

Description

peResponseSoapEncoding determines the response encoding style. Possible values are:

Constant | Meaning
seLiteral | SOAP style Literal encoding
seEncoded | SOAP style Encoded encoding

Note:This message is generated and used inside or your client web service sub-class that was created using the Client Web Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

See Also

peSoapEncoding

Last Edited: September 22, 2005


cClientWebService [Property peSoapEncoding]

peSoapEncoding - cClientWebService

Encoding Style for the SOAP request

Type: Property

Access: Read/Write

Data Type: Integer

Description

peSoapEncoding determines the request encoding style. Possible values are:

Constant | Meaning
seLiteral | SOAP style Literal encoding
seEncoded | SOAP style Encoded encoding

Note:This message is generated and used inside or your client web service sub-class that was created using the Client Web Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

See Also

peResponseSoapEncoding

Last Edited: September 22, 2005


cClientWebService [Property peSoapStyle]

peSoapStyle - cClientWebService

Soap Style - Document or RPC

Type: Property

Access: Read/Write

Data Type: Integer

Description

peSoapStyle determines the SoapStyle. Possible values are

Constant | Meaning
ssDocument | Document Style
ssRPC | RPC Style

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

Last Edited: March 25, 2004


cClientWebService [Property peTransferStatus]

peTransferStatus - cClientWebService

Returns the status of the last web-service call

Type: Property

Access: Read/Write

Data Type: Integer

Description

peTransferStatus returns the status of the last web-service call. You should use this value to determine if your web-service invocation was successful.

The possible return values are:

Constant | Meaning
wssOk | Request succeeded
wssHttpRequestFailed | Http request failed
wssBadRequest | Bad or missing data sent
wssInvalidContentType | Invalid contentType received
wssNoData | No data was received
wssNotXml | Received data not in proper XML format
wssNotSoap | Received XML data not in proper Soap format
wssInvalidSoap | Received SOAP data not formatted according to service description
wssSoapFault | Soap Fault Returned

If a SOAP fault occurs the fault-code is returned in psFaultCode and the fault-description returned in psFaultString.

Normally, a failed web-service request will result in an error message. In this example, we assume that an error will have already been reported and that we are using the status to handle the call after a success or an error.

Get wsCustomerName of oWSCustomerService to sName
Get peTransferStatus of oWSCustomerService to eTransferStatus
If (eTransferStatus=wssOK) begin
    Send AddNewName sName
end
else Begin
    Send TrySomethingElse
end

You can choose to disable automatic error reporting by setting pbSuppressLastError to false. In such a case, you must handle the error report yourself.

Set pbSuppressLastError of of oWSCustomerService to false
Get wsCustomerName of oWSCustomerService to sName
Get peTransferStatus of oWSCustomerService to eTransferStatus
If (eTransferStatus=wssOK) begin
    Send AddNewName sName
end
else Begin
     // handle soap fault errors in a special way. Report all others as errors
    If If (eTransferStatus=wssSoapFault) begin
        Get TransferErrorDescription of oWSCustomerService to sErr
        Send WeHadAFaultError sErr
    end
    else begin
        Send LastError of oWSCustomerService // this will generate an error
    end
end

See Also

psFaultCode | psFaultString | pbSuppressLastError | TransferErrorDescription | LastError

Last Edited: April 7, 2004


cClientWebService [Property phoHttp]

phoHttp - cClientWebService

Contains the handle of the Http object used by the client web-service

Type: Property

Access: Read/Write

Data Type: Handle

Description

All web-service client objects contains an Http object, based on the cHttpTransfer class, to communicate with the server web service. The phoHttp property contains a handle to this object.

Ideally, a developer will never need to access this object. All expected http interface properties that a developer may need to change are defined directly in the cClientWebService class. If properties of the Http object need to be set that cannot be set directly you may use this property to gain access to the http object. Hopefully, this will never be needed.

Last Edited: July 30, 2004


cClientWebService [Property phoSoapClientHelper]

phoSoapClientHelper - cClientWebService

Provides a mechanism for connecting any Web Service to a test view

Type: Property

Access: Read/Write

Data Type: Handle

Description

A special soap client helper view can be used to allow you to see what is happening with a soap request. This helper displays a view that shows you the soap request, the soap response, the transfer (error) status, parameters, the return value and more. This purpose of this view is two-fold - it helps you debug soap client calls and it provides a great way to learn about web-services.

To use this client hlper you must set phoSoapClientHelper to point to this view. Once you've done this, the view will be invoked after an web-service call. Note that until a call is made, you will not see this view.

It is not expected that you would ever use this in a deployed application.

Adding the Helper View to Your Test Component

When a web-client object is created in your view, comment code in this object will provide all of the information needed to use this helper object.

// phoSoapClientHelper
//     Setting this property will pop up a view that provides information
//     about the Soap (xml) data transfer. This can be useful in debugging.
//     If you use this you must make sure you USE the test view at the top
//     of your program/view by adding:   Use WebClientHelper.vw // oClientWSHelper
//Set phoSoapClientHelper to oClientWSHelper

To use this helper you need to:

1. Copy the code: "Use WebClientHelper.vw" and paste it in the top of your component source code.

2. Uncomment the line: Set phoSoapClientHelper to oClientWSHelper

When you do this, every web-service request to this client will cause a helper view to be activated showing you what is happening.

To disable this helper view, add the comment or set phoSoapClientHelper to 0.

Last Edited: March 25, 2004


cClientWebService [Property phoSoapRequest]

phoSoapRequest - cClientWebService

A handle to an XML document object containing the last SOAP request

Type: Property

Access: Read/Write

Data Type: Handle

Description

phoSoapRequest is a handle that points to an XML document object (cXmlDomDocument) representing that last web-service soap request. This should never be changed. The property is provided for testing and debugging purposes.

See Also

phoSoapResponse

Last Edited: February 18, 2005


cClientWebService [Property phoSoapResponse]

phoSoapResponse - cClientWebService

A handle to an XML document object containing the last SOAP Response

Type: Property

Access: Read/Write

Data Type: Handle

Description

phoSoapResponse is a handle that points to an XML document object (cXmlDomDocument) representing that last web-service soap response. This should never be changed. The property is provided for mainly testing and debugging purposes.

In advanced (and hopefully rare) cases, you might need to use this to parse and retreive return data. This document contains the entire soap response (soap:envelope, soap:body, etc.) so it contains all of the data returned to you.

See Also

phoSoapRequest

Last Edited: February 18, 2005


cClientWebService [Property piPort]

piPort - cClientWebService

Determines the port used for a web-service call

Type: Property

Access: Read/Write

Data Type: Integer

Description

piPort determines the port to be used for a web-service call. The default value for this property is 0. When 0 the appropriate default port will be used. When accessing via an regular site that port is rpHttp (80). When accessing over a SSL site (HTTPS) that port is rpHttpSSL (443). If piPort is non-zero, that port number will be used.

You should not directly set this property. If you need to change the port, change the psServiceLocation property. If a port is defined in psServiceLocation, it will take precedence over piPort.

A port is defined in the web-service's WSDL as part of the service's location. This location property is set in the class with the psServiceLocation property. If you wish to change the port, you should change the psServiceLocation value. For example, a normal service using port 80 (rpHttp) will have a line in its client class that look like this:

Set psServiceLocation     to 'http://localhost/daw.examples.order/customertransfer.wso'

If you wished to change the port to 8080, you could change this as follows:

Set psServiceLocation     to 'http://localhost/daw.examples.order:8080/customertransfer.wso'

If this were a temporary change (e.g., for testing) you could add this line to your web-client object in your view.

If your URL uses HTTPS, and a port is not explicitly defined in the URL, port 443 is used.

Set psServiceLocation     to 'https://localhost/daw.examples.order/customertransfer.wso'

Last Edited: July 30, 2004


cClientWebService [Property psCertificateStore]

psCertificateStore - cClientWebService

Set the Certificate Store string for selecting a client certficate

Type: Property

Access: Read/Write

Data Type: String

Description

If a secure (HTTPS) web-service requires that you provide a client certificate you may select the client certificate by setting the psCertificateStore and the psCertificateSubject properties.

Note that this logon information will not be found in the service's WSDL and will therefore not be added automatically to your web-service. You will need to set these properties yourself.

See SelectClientCertificate for more information about client certificates.

Last Edited: July 30, 2004


cClientWebService [Property psCertificateSubject]

psCertificateSubject - cClientWebService

Set the Certificate Subject string for selecting a client certficate

Type: Property

Access: Read/Write

Data Type: String

Description

If a secure (HTTPS) web-service requires that you provide a client certificate you may select the client certificate by setting the psCertificateStore and the psCertficateSubject properties.

Note that this logon information will not be found in the service's WSDL and will therefore not be added automatically to your web-service. You will need to set these properties yourself.

See SelectClientCertificate for more information about client certificates.

Last Edited: July 30, 2004


cClientWebService [Property psContentType]

psContentType - cClientWebService

Determines the content type for the soap/http request

Type: Property

Access: Read/Write

Data Type: String

Description

The default content type for a soap request is "text/xml; charset=UTF-8". Under unusual cicrumstances a soap service may require a different value. SOAP specifications requires the content type to be "text/xml". Requirements for content information (e.g. charset=) may require customization.

Normally, you will never need to change this information.

Last Edited: April 6, 2004


cClientWebService [Property psFaultCode]

psFaultCode - cClientWebService

Returns the FaultCode of the last web service call

Type: Property

Access: Read/Write

Data Type: String

Description

If the last web-service call generated a SOAP fault, the SOAP fault-code will be placed in the psFaultCode property. The SOAP fault description will be found in psFaultString property.

The status of a the last web-service call is stored in the peTransferStatus property. If a SOAP fault occurred the status will be wssSoapFault.

Get wsCustomerName of oWSCustomerService to sName
Get peTransferStatus of oWSCustomerService to eTransferStatus
If (eTransferStatus=wssSoapFault) begin
      get psFaultCode of oWSCustomerService to sFaultCode
      get psFaultString of oWSCustomerService to sFaultString
      Send ReportFaultError sFaultCode sFaultString
end

See Also

psFaultString | peTransferStatus | pbSuppressLastError | TransferErrorDescription | LastError

Last Edited: April 6, 2004


cClientWebService [Property psFaultString]

psFaultString - cClientWebService

Returns the FaultCode of the last web service call

Type: Property

Access: Read/Write

Data Type: String

Description

If the last web-service call generated a SOAP fault, the SOAP fault-description string code will be placed in the psFaultString property. The SOAP fault code will be found in psFaultCode property.

The status of a the last web-service call is stored in the peTransferStatus property. If a SOAP fault occurred the status will be wssSoapFault.

Get wsCustomerName of oWSCustomerService to sName
Get peTransferStatus of oWSCustomerService to eTransferStatus
If (eTransferStatus=wssSoapFault) begin
      get psFaultCode of oWSCustomerService to sFaultCode
      get psFaultString of oWSCustomerService to sFaultString
      Send ReportFaultError sFaultCode sFaultString
end

See Also

psFaultCode | peTransferStatus | pbSuppressLastError | TransferErrorDescription | LastError

Last Edited: April 6, 2004


cClientWebService [Property psMethodRequest]

psMethodRequest - cClientWebService

The name of the operation's request

Type: Property

Access: Read/Write

Data Type: String

Description

psMethodRequest sets the name of the SOAP request operation or method name.

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

See Also

psMethodResponse

Last Edited: March 25, 2004


cClientWebService [Property psMethodResponse]

psMethodResponse - cClientWebService

The name of the operation response

Type: Property

Access: Read/Write

Data Type: String

Description

psMethodResponse sets the nameof the SOAP Operation's response.

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

See Also

psMethodRequest

Last Edited: March 25, 2004


cClientWebService [Property psPassword]

psPassword - cClientWebService

Specifies the password to use to log on

Type: Property

Access: Read/Write

Data Type: String

Description

If a web-service requires that you logon a user name and password may be required. These may be set using the psUserName and psPassword properties.

Note that this logon information will not be found in the service's WSDL and will therefore not be added automatically to your web-service. You will need to set these properties yourself.

See Also

psUserName

Last Edited: July 30, 2004


cClientWebService [Property psRequestNSURI]

psRequestNSURI - cClientWebService

Sets the Request NameSpace URI (targetNameSpace)

Type: Property

Access: Read/Write

Data Type: String

Description

psRequestNSURI sets the Request NameSpace URI (targetNameSpace).

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

See Also

psResponseNSURI

Last Edited: March 25, 2004


cClientWebService [Property psResponseNSURI]

psResponseNSURI - cClientWebService

Sets the Response NameSpace URI (targetNameSpace)

Type: Property

Access: Read/Write

Data Type: String

Description

psResponseNSURI sets the Response NameSpace URI (targetNameSpace).

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

See Also

psRequestNSURI

Last Edited: March 25, 2004


cClientWebService [Property psServiceLocation]

psServiceLocation - cClientWebService

Determines the URL location of your web-service

Type: Property

Access: Read/Write

Data Type: String

Description

psServiceLocation determines the URL location of the web-service. When the client web-service class generator creates a web-service class, this property will be created as part of the class generation. The service location is defined in a service's description (WSDL).

If you need to redirect your web-service call to a different address or port, you can change this property. For example, a normal service using port 80 will have a line in its client class that look like this:

Set psServiceLocation     to 'http://localhost/daw.examples.order/customertransfer.wso'

If you wished to change the address to DataAccess.com and to port to 8080, you could change this as follows:

Set psServiceLocation     to 'http://DataAccess.com/daw.examples.order:8080/customertransfer.wso'

If this were a temporary change (e.g., for testing) you could add this line to your web-client object in your view.

HTTPS/ Secure SSL Sites

Secure HTTPS sites are supported. If your URL contains "HTTPS" the object will recognize that this is an secure site and will change the default port to rpHttpSSL (443) and will set the appropriate transfer flag in the http object.

Set psServiceLocation     to 'https://localhost/daw.examples.order/customertransfer.wso'

When your web-service client is created, this information should be contained in your WSDL and the generated client class will automatically support this.

In some cases a client certificate may be required for a secure site. This information is not stored in the WSDL. The programmer will need to select the certificate by setting the properties psCertificateStore and psCertificateSubject

Last Edited: July 30, 2004


cClientWebService [Property psSOAPAction]

psSOAPAction - cClientWebService

Sets the SOAPAction for the Web-service call

Type: Property

Access: Read/Write

Data Type: String

Description

psSOAPAction set Sets the SOAPAction string which will be sent as part of the SOAP Request.

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

Last Edited: March 25, 2004


cClientWebService [Property psUserName]

psUserName - cClientWebService

Specifies the name of the user to log on

Type: Property

Access: Read/Write

Data Type: String

Description

If a web-service requires that you logon a user name and password may be required. These may be set using the psUserName and psPassword properties.

Note that this logon information will not be found in the service's WSDL and will therefore not be added automatically to your web-service. You will need to set these properties yourself.

See Also

psPassWord

Last Edited: July 30, 2004


cClientWebService [Property psWSDLLocation]

psWSDLLocation - cClientWebService

Determines the URL location of the WSDL document used to create the class

Type: Property

Access: Read/Write

Data Type: String

Description

When the Client Web Service Class Generator uses a WSDL to generate a web-service sub-class, the location of this WSDL document is stored in the psWSDLLocation property This is actually not required as it is never used by the class. This property was provided because it provides useful information to the developer. By looking at the class and this property, the developer can see what WSDL document was used to generate the class.

Last Edited: June 21, 2005


cClientWebService [Property psXmlEncoding]

psXmlEncoding - cClientWebService

Sets the encoding style used for the web-service call

Type: Property

Access: Read/Write

Data Type: String

Description

psXmlEncoding sets the encoding style used for the web-service call. The default is UTF-8

Note:This message is generated and used inside or your client web-service sub-class that was created using the Client Web-Service Class Generator. You should not need to actually use this message when accessing this sub-class in your application. You will only use interfaces like these if you are creating your own classes based on the cClientWebService class. This is considered very advanced usage. If you want to see how this message is used, study the code in the classes generated by the class generator.

Last Edited: March 25, 2004


Events for cCLIHandler

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cCLIHandler [Function CKBuildRevision]

CKBuildRevision - cCLIHandler

Returns the build revision of the Connectivity Kit.

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the build revision of the Connectivity Kit.

Description

Returns the build revision of the Connectivity Kit.

Sample

You can use this function to display the current build revision number of the Connectivity Kit.

Procedure ShowBuildCKRevision String sDRiverID
    Handle hoCLIHandler

    Get Create U_cCLIHandler To hoCLIHandler
    Set psDriverID To sDRiverID
    Showln (CKBuildRevision(hoCLIHandler))
    Send Destroy Of hoCLIHandler
End_Procedure // ShowBuildCKRevision

See Also

CKMinorRevision | CKMajorRevision | CKRevision | CKReleaseRevision

Last Edited: April 22, 2005


cCLIHandler [Function CKMajorRevision]

CKMajorRevision - cCLIHandler

Returns the major revision of the Connectivity Kit.

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the major revision of the Connectivity Kit.

Description

Returns the major revision of the Connectivity Kit.

Sample

You can use this function to display the current major revision number of the Connectivity Kit.

Procedure ShowMajorCKRevision String sDRiverID
    Handle hoCLIHandler

    Get Create U_cCLIHandler To hoCLIHandler
    Set psDriverID To sDRiverID
    Showln (CKMajorRevision(hoCLIHandler))
    Send Destroy Of hoCLIHandler
End_Procedure // ShowMajorCKRevision

See Also

CKMinorRevision | CKRevision | CKBuildRevision | CKReleaseRevision

Last Edited: April 22, 2005


cCLIHandler [Function CKMinorRevision]

CKMinorRevision - cCLIHandler

Returns the minor revision of the Connectivity Kit.

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the minor revision of the Connectivity Kit.

Description

Returns the minor revision of the Connectivity Kit.

Sample

You can use this function to display the current minor revision number of the Connectivity Kit.

Procedure ShowMinorCKRevision String sDRiverID
    Handle hoCLIHandler

    Get Create U_cCLIHandler To hoCLIHandler
    Set psDriverID To sDRiverID
    Showln (CKMinorRevision(hoCLIHandler))
    Send Destroy Of hoCLIHandler
End_Procedure // ShowMinorCKRevision

See Also

CKRevision | CKMajorRevision | CKBuildRevision | CKReleaseRevision

Last Edited: April 22, 2005


cCLIHandler [Function CKReleaseRevision]

CKReleaseRevision - cCLIHandler

Returns the release revision of the Connectivity Kit.

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the release revision of the Connectivity Kit.

Description

Returns the release revision of the Connectivity Kit.

Sample

You can use this function to display the current release revision number of the Connectivity Kit.

Procedure ShowReleaseCKRevision String sDRiverID
    Handle hoCLIHandler

    Get Create U_cCLIHandler To hoCLIHandler
    Set psDriverID To sDRiverID
    Showln (CKReleaseRevision(hoCLIHandler))
    Send Destroy Of hoCLIHandler
End_Procedure // ShowReleaseCKRevision

See Also

CKMinorRevision | CKMajorRevision | CKBuildRevision | CKRevision

Last Edited: April 22, 2005


cCLIHandler [Function CKRevision]

CKRevision - cCLIHandler

Returns the Connectivity Kit revision in the format Major.Minor.Release.Build.

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Returns the Connectivity Kit revision in the format Major.Minor.Release.Build.

Description

Returns the Connectivity Kit revision in the format Major.Minor.Release.Build.

Sample

You can use this function to display the current revision number of the Connectivity Kit.

Procedure ShowCKRevision String sDRiverID
    Handle hoCLIHandler

    Get Create U_cCLIHandler To hoCLIHandler
    Set psDriverID To sDRiverID
    Showln (CKRevision(hoCLIHandler))
    Send Destroy Of hoCLIHandler
End_Procedure // ShowCKRevision

See Also

CKMinorRevision | CKMajorRevision | CKBuildRevision | CKReleaseRevision

Last Edited: April 20, 2005


cCLIHandler [Function CLIDFDateToSQLDate]

CLIDFDateToSQLDate - cCLIHandler

Type: Function

Return Data Type: String

Parameters: String sDRiver Date dDFDate

Parameter | Description
sDRiver | [ToDo: In Progress]
dDFDate | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cCLIHandler [Function CLISQLDateToDFDate]

CLISQLDateToDFDate - cCLIHandler

Type: Function

Return Data Type: Date

Parameters: String sDRiver String sSQLDate

Parameter | Description
sDRiver | [ToDo: In Progress]
sSQLDate | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cCLIHandler [Function ColumnName]

ColumnName - cCLIHandler

Returns the name of the column enumerated at the given position by EnumerateColumns.

Type: Function

Return Data Type: String

Parameters: Integer iIndex

Parameter | Description
iIndex | Position of column in enumeration

Return Value

Returns the name of the column enumerated at the given position by EnumerateColumns.

Description

Returns the name of the column enumerated at the given position by EnumerateColumns.

Last Edited: April 20, 2005


cCLIHandler [Function EnumerateColumns]

EnumerateColumns - cCLIHandler

Enumerates all column names for a given table.

Type: Function

Return Data Type: Integer

Parameters: String sLogin String sTableName

Parameter | Description
sLogin | Login string
sTableName | Name of table to enumerate

Return Value

Returns number of columns enumerated.

Description

Enumerates all column names for a given table.

Last Edited: April 20, 2005


cCLIHandler [Function EnumerateTables]

EnumerateTables - cCLIHandler

Enumerates tables in the given database.

Type: Function

Return Data Type: Integer

Parameters: String sLogin

Parameter | Description
sLogin | Login string

Return Value

Returns number of tables enumerated.

Description

Enumerates tables in the given database. It builds an internal array containing the table name, schema for the table, table type and table comment. It returns the number of tables.

Sample

If we want to show all tables in a Microsoft SQL Server database and for every table all column names, we would program:

Procedure ShowAllTablesAndColumns String sDriver String sLogin
    Handle hoCLIHandler
    Integer iNumTables
    Integer iNumColumns
    Integer iTableCount
    Integer iColumnCount

    Get Create U_cCLIHandler To hoCLIhandler
    If (hoCLIHandler > 0) Begin
        Set psDriverID Of hoCLIHandler To sDriver
        Get EnumerateTables Of hoCLIHandler sLogin To iNumTables
        For iTableCount From 1 To iNumTables
            Show (TableName(hoCLIHandler, iTableCount)) "; "
            Show (SchemaName(hoCLIHandler, iTableCount)) "; "
            Show (TableType(hoCLIHandler, iTableCount)) "; "
            Showln (TableComment(hoCLIHandler, iTableCount))
            Get EnumerateColumns Of hoCLIHandler sLogin ;
                (TableName(hoCLIHandler, iTableCount)) To iNumColumns
            For iColumnCount From 1 To iNumColumns
                Showln " " (ColumnName(hoCLIHandler, iColumnCount))
            Loop
            Showln
        Loop
        Send Destroy Of hoCLIHandler
    End
End_Procedure // ShowAllTablesAndColumns

If you want to use the above procedure for database D on server X with user account Y and password Z it would be called in the following way:

Send ShowAllTablesAndColumns MSSQLDRV_ID ;
    "DRIVER={SQL Server};SERVER=X;UID=Y;PWD=Z;DATABASE=D"

Last Edited: April 22, 2005


cCLIHandler [Function ExtractPartFromRevision]

ExtractPartFromRevision - cCLIHandler

Type: Function

Return Data Type: Integer

Parameters: Integer iPartNum String sRevision

Parameter | Description
iPartNum | [ToDo: In Progress]
sRevision | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cCLIHandler [Function IsMinimalRevision]

IsMinimalRevision - cCLIHandler

Checks if a Connectivity Kit complies with a minimal revision.

Type: Function

Return Data Type: Integer

Parameters: Integer iMajor Integer iMinor Integer iRelease Integer iBuild

Parameter | Description
iMajor | Major revision number
iMinor | Minor revision number
iRelease | Release revision number
iBuild | Build revision number

Return Value

Returns True (1) or False (0).

Description

Checks if a Connectivity Kit complies with a minimal revision.

Sample

You can also check the current Connectivity Kit revision and act upon that information. If, for example, certain functionality only works for version 3.0.0.48 or higher of the MS SQL Connectivity Kit, one could program:

Procedure DoVersionDependentThing
    Handle hoCLIHandler

    Get Create U_cCLIHandler To hoCLIHandler
    Set psDriverID Of hoCLIHandler To "MSSQLDRV"
    If (IsMinimalRevision(hoCLIHandler, 3, 0, 0, 48)) ;
        Send DoMyThing
    Else ;
        Send Stop_Box "Function not supported by this CK"
End_Procedure // DoVersionDependentThing

Last Edited: April 22, 2005


cCLIHandler [Function LastDriverError]

LastDriverError - cCLIHandler

Returns the string value of the last generated driver error.

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Returns the string value of the last generated driver error.

Description

Returns the string value of the last generated driver error.

Error texts generated by SQL Server and other client/server databases are generally larger than those generated by the embedded database. In character mode environments, it happens that the text is larger than the supported maximum error text length. In those cases, you can get the complete error text by using the LastDriverError function.

Sample

To show the last error text, one would program:

Procedure ShowLastSQLErrorText
    Handle hoCLIHandler
    String sLastError

    Get Create U_cCLIHandler To hoCLIHandler
    If (hoCLIHandler > 0) Begin
        Set psDriverID Of hoCLIHandler To MSSQLDRV_ID
        Get LastDriverError Of hoCLIHandler To sLastError
    End
    Send Destroy Of hoCLIHandler
    Showln "ERROR: " sLastError
End_Procedure // ShowLastSQLErrorText

Last Edited: April 22, 2005


cCLIHandler [Function MaxUsers]

MaxUsers - cCLIHandler

Returns the maximum number of users of the Connectivity Kit.

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the maximum number of users of the Connectivity Kit.

Description

Returns the maximum number of users of the Connectivity Kit.

Last Edited: April 20, 2005


cCLIHandler [Function RedirectConnection]

RedirectConnection - cCLIHandler

Type: Function

Return Data Type: Integer

Parameters: String sOldConnection String sNewConnection

Parameter | Description
sOldConnection | [ToDo: In Progress]
sNewConnection | [ToDo: In Progress]

Return Value

Description

Last Edited: June 16, 2006


cCLIHandler [Function RegistrationName]

RegistrationName - cCLIHandler

Returns the registration name of the Connectivity Kit.

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Returns the registration name of the Connectivity Kit.

Description

Returns the registration name of the Connectivity Kit.

Last Edited: April 20, 2005


cCLIHandler [Function RIMValueToText]

RIMValueToText - cCLIHandler

Converts a DF_FILE_GENERATE_RECORD_ID_METHOD attribute value to the corresponding text.

Type: Function

Return Data Type: String

Parameters: Integer iAttrValue

Parameter | Description
iAttrValue | Attribute value to convert

Return Value

Returns text corresponding to DF_FILE_GENERATE_RECORD_ID_METHOD attribute value.

Description

Converts a DF_FILE_GENERATE_RECORD_ID_METHOD attribute value to the corresponding text.

Last Edited: April 22, 2005


cCLIHandler [Function ROValueToText]

ROValueToText - cCLIHandler

Converts a DF_FIELD_READ_ONLY attribute value to the corresponding text.

Type: Function

Return Data Type: String

Parameters: Integer iAttrValue

Parameter | Description
iAttrValue | Attribute value to convert

Return Value

Returns text corresponding to DF_FIELD_READ_ONLY attribute value.

Description

Converts a DF_FIELD_READ_ONLY attribute value to the corresponding text.

Last Edited: April 22, 2005


cCLIHandler [Function SchemaName]

SchemaName - cCLIHandler

Returns the schema of the table enumerated at the given position by EnumerateTables.

Type: Function

Return Data Type: String

Parameters: Integer iIndex

Parameter | Description
iIndex | Position of table in enumeration

Return Value

Returns the schema of the table enumerated at the given position.

Description

Returns the schema of the table enumerated at the given position by EnumerateTables.

Last Edited: April 20, 2005


cCLIHandler [Function SerialNumber]

SerialNumber - cCLIHandler

Returns the Connectivity Kit serial number.

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the Connectivity Kit serial number.

Description

Returns the Connectivity Kit serial number.

Last Edited: April 20, 2005


cCLIHandler [Function TableComment]

TableComment - cCLIHandler

Returns the comment of the table enumerated at the given position by EnumerateTables.

Type: Function

Return Data Type: String

Parameters: Integer iIndex

Parameter | Description
iIndex | Position of table in enumeration

Return Value

Returns the comment of the table enumerated at the given position.

Description

Returns the comment of the table enumerated at the given position by EnumerateTables.

Last Edited: April 20, 2005


cCLIHandler [Function TableName]

TableName - cCLIHandler

Returns the name of the table enumerated at the given position by EnumerateTables.

Type: Function

Return Data Type: String

Parameters: Integer iIndex

Parameter | Description
iIndex | Position of table in enumeration

Return Value

Returns the name of the table enumerated at the given position.

Description

Returns the name of the table enumerated at the given position by EnumerateTables.

Last Edited: April 20, 2005


cCLIHandler [Function TableType]

TableType - cCLIHandler

Returns the type of the table enumerated at the given position by EnumerateTables.

Type: Function

Return Data Type: String

Parameters: Integer iIndex

Parameter | Description
iIndex | Position of table in enumeration

Return Value

Returns the type of the table enumerated at the given position.

Description

Returns the type of the table enumerated at the given position by EnumerateTables.

Last Edited: April 20, 2005


cCLIHandler [Function TextToRIMValue]

TextToRIMValue - cCLIHandler

Converts a record identity text to the DF_FILE_GENERATE_RECORD_ID_METHOD attribute value

Type: Function

Return Data Type: Integer

Parameters: String sText

Parameter | Description
sText | Text to convert

Return Value

Returns DF_FILE_GENERATE_RECORD_ID_METHOD attribute value of record identity text.

Description

Converts a record identity text to the DF_FILE_GENERATE_RECORD_ID_METHOD attribute value

Last Edited: April 22, 2005


cCLIHandler [Function TextToROValue]

TextToROValue - cCLIHandler

Converts a read only text to the DF_FIELD_READ_ONLY attribute value.

Type: Function

Return Data Type: Integer

Parameters: String sText

Parameter | Description
sText | Text to convert

Return Value

Returns DF_FIELD_READ_ONLY attribute value of read only text.

Description

Converts a read only text to the DF_FIELD_READ_ONLY attribute value.

Last Edited: April 22, 2005


Methods for cCLIHandler

View method list in hierarchical order

Name | Type | Description | Defining Class
CKBuildRevision | Function | Returns the build revision of the Connectivity Kit. |
CKMajorRevision | Function | Returns the major revision of the Connectivity Kit. |
CKMinorRevision | Function | Returns the minor revision of the Connectivity Kit. |
CKReleaseRevision | Function | Returns the release revision of the Connectivity Kit. |
CKRevision | Function | Returns the Connectivity Kit revision in the format Major.Minor.Release.Build. |
CLIDFDateToSQLDate | Function |  |
CLISQLDateToDFDate | Function |  |
ColumnName | Function | Returns the name of the column enumerated at the given position by EnumerateColumns. |
Create | Function | Creates an object based on the passed Class Id | cObject
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
DumpStatus | Procedure | Dumps the current status of the Connectivity Kit to an ASCII disk file. |
EnumerateColumns | Function | Enumerates all column names for a given table. |
EnumerateTables | Function | Enumerates tables in the given database. |
Exit_Application | Procedure | Starts the process of closing an application | cObject
ExtractPartFromRevision | Function |  |
IsMinimalRevision | Function | Checks if a Connectivity Kit complies with a minimal revision. |
LastDriverError | Function | Returns the string value of the last generated driver error. |
MaxUsers | Function | Returns the maximum number of users of the Connectivity Kit. |
ReadConfiguration | Procedure | Forces the Connectivity Kit to reread the driver configuration file. |
RedirectConnection | Function |  |
RegistrationName | Function | Returns the registration name of the Connectivity Kit. |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
RIMValueToText | Function | Converts a DF_FILE_GENERATE_RECORD_ID_METHOD attribute value to the corresponding text. |
ROValueToText | Function | Converts a DF_FIELD_READ_ONLY attribute value to the corresponding text. |
SchemaName | Function | Returns the schema of the table enumerated at the given position by EnumerateTables. |
SerialNumber | Function | Returns the Connectivity Kit serial number. |
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array
TableComment | Function | Returns the comment of the table enumerated at the given position by EnumerateTables. |
TableName | Function | Returns the name of the table enumerated at the given position by EnumerateTables. |
TableType | Function | Returns the type of the table enumerated at the given position by EnumerateTables. |
TextToRIMValue | Function | Converts a record identity text to the DF_FILE_GENERATE_RECORD_ID_METHOD attribute value |
TextToROValue | Function | Converts a read only text to the DF_FIELD_READ_ONLY attribute value. |


cCLIHandler [Procedure DumpStatus]

DumpStatus - cCLIHandler

Dumps the current status of the Connectivity Kit to an ASCII disk file.

Type: Procedure

Parameters: String sFileName

Parameter | Description
sFileName | Name of text file to dump status to.

Description

Dumps the current status of the Connectivity Kit to an ASCII disk file.

The DumpStatus procedure expects a disk file name as parameter. If the disk file already exists, the current status will be appended to that disk file.

Procedure ShowStatus
    Handle hoCLI

    Get Create U_cCLIHandler To hoCLI
    Set psDRiverID Of hoCLI To MSSQLDRV_ID
    Send DumpStatus Of hoCLI "c:\status\mssqldump.txt"
    Send Destroy Of hoCLI
End_Procedure // ShowStatus

Last Edited: June 23, 2005


cCLIHandler [Procedure ReadConfiguration]

ReadConfiguration - cCLIHandler

Forces the Connectivity Kit to reread the driver configuration file.

Type: Procedure

Parameters: No Parameters

Description

Forces the Connectivity Kit to reread the driver configuration file.

When this procedure is called, all driver level settings will be set to their default value, then the driver configuration file is read.

Last Edited: April 19, 2005


Properties for cCLIHandler

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psDriverID | The identification of the CLI driver. |
Value | Sets and Gets an array element's value | Array


cCLIHandler [Property psDriverID]

psDriverID - cCLIHandler

The identification of the CLI driver.

Type: Property

Access: Read/Write

Data Type: String

Description

The identification of the CLI driver.

Setting the Driver

When creating an object of the cCLIHandler class you must set the psDriverID property.

This property can have one of these values:

Constant | Meaning
DATAFLEX | Embedded database
DB2_DRV | DB2 Connectivity Kit
DFBTRDRV | Pervasive.SQL Connectivity Kit
MSSQLDRV | Microsoft SQL Connectivity Kit
ODBC_DRV | ODBC Connectivity Kit

In order for the cCLIHandler class to work with the ODBC Connectivity Kit the property should be set to "ODBC_DRV".

Get Create U_cCLIHandler To hoCliHandler
Set psDriverID Of hoCLIHandler To "ODBC_DRV"

In order for the class to work with the Connectivity Kit for SQL Server, the property should be set to "MSSQLDRV".

Get Create U_cCLIHandler To hoCliHandler
Set psDriverID Of hoCLIHandler To "MSSQLDRV"

In order for the class to work with the Connectivity Kit for DB2, the property should be set to "DB2_DRV".

Get Create U_cCLIHandler To hoCliHandler
Set psDriverID Of hoCLIHandler To "DB2_DRV

If you use the cMSSQLHandler, cDB2Handler or cODBCHandler classes (subclasses of cCLIHandler) instead, this property is already set for you.

Last Edited: September 1, 2005


Events for cCollection

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cCollection [Function CountOfObjects]

CountOfObjects - cCollection

Returns the number of objects that are currently in the collection

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the number of objects that are currently in the collection

Description

CountOfObjects returns the number of objects that are currently in the collection.

Last Edited: August 5, 2003


cCollection [Function IndexFromObject]

IndexFromObject - cCollection

Returns the index for the object-handle, ho, in the collection

Type: Function

Return Data Type: Integer

Parameters: Handle ho

Parameter | Description
ho | The object handle

Return Value

The first object-handle in the collection would return zero as its index. If the object-handle is not in the collection, the function returns a value of -1.

Description

IndexFromObject returns the index for the object-handle, ho, in the collection. The index is zero-based, which means that the first object-handle in the collection would return zero as its index. If the object-handle is not in the collection, the function returns a value of -1.

See Also

ObjectFromIndex

Last Edited: August 6, 2004


cCollection [Function IsObjectIn]

IsObjectIn - cCollection

Used to determine if object handle exists in the collection

Type: Function

Return Data Type: Boolean

Parameters: Handle ho

Parameter | Description
ho | The object handle

Return Value

Returns True, if the object-handle is in the collection, otherwise returns zero

Description

The IsObjectIn function is used to determine if object handle exists in the collection. IsObjectIn returns True, if the object-handle, ho, is in the collection, otherwise the function returns zero.

If you need to know the index of the object-handle in the collection, use IndexFromObject.

Last Edited: August 18, 2003


cCollection [Function ObjectFromIndex]

ObjectFromIndex - cCollection

Returns the object-handle at index, iIndex, in the collection

Type: Function

Return Data Type: Handle

Parameters: Integer iIndex

Parameter | Description
iIndex | The object-handle at index

Return Value

If iIndex is beyond the bounds of the collection, the function returns 0.

Description

ObjectFromIndex returns the object-handle at index, iIndex, in the collection.

Use CountOfObjects to determine the number of object-handles in the collection.

Last Edited: September 10, 2003


Methods for cCollection

View method list in hierarchical order

Name | Type | Description | Defining Class
CountOfObjects | Function | Returns the number of objects that are currently in the collection |
Create | Function | Creates an object based on the passed Class Id | cObject
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
DoAppendObject | Procedure | Appends an object-handle, ho, to the end of the collection |
DoInsertObject | Procedure | Inserts an object-handle, ho, into the collection before the hoBefore object-handle |
DoRemoveObject | Procedure | Removes the object-handle, ho, from the collection |
Exit_Application | Procedure | Starts the process of closing an application | cObject
IndexFromObject | Function | Returns the index for the object-handle, ho, in the collection |
IsObjectIn | Function | Used to determine if object handle exists in the collection |
ObjectFromIndex | Function | Returns the object-handle at index, iIndex, in the collection |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array


cCollection [Procedure DoAppendObject]

DoAppendObject - cCollection

Appends an object-handle, ho, to the end of the collection

Type: Procedure

Parameters: Handle ho

Parameter | Description
ho | The object handle

Description

DoAppendObject appends an object-handle, ho, to the end of the collection.

See Also

DoInsertObject

Last Edited: July 31, 2003


cCollection [Procedure DoInsertObject]

DoInsertObject - cCollection

Inserts an object-handle, ho, into the collection before the hoBefore object-handle

Type: Procedure

Parameters: Handle ho Handle hoBefore

Parameter | Description
ho | The object handle to be inserted
hoBefore | The object handle to be inserted before

Description

DoInsertObject inserts an object-handle, ho, into the collection before the hoBefore object-handle.

See Also

DoAppendObject

Last Edited: July 31, 2003


cCollection [Procedure DoRemoveObject]

DoRemoveObject - cCollection

Removes the object-handle, ho, from the collection

Type: Procedure

Parameters: Handle ho

Parameter | Description
ho | The object handle

Description

DoRemoveObject removes the object-handle, ho, from the collection.

Last Edited: July 31, 2003


Properties for cCollection

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbAllowDuplicates | Determines if text within the pane is aligned left, right or centered |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Value | Sets and Gets an array element's value | Array


cCollection [Property pbAllowDuplicates]

pbAllowDuplicates - cCollection

Determines if text within the pane is aligned left, right or centered

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The text within the pane can be aligned left, right or centered. Set the pbAllowDuplicates property to asLeft to align it left, asRight to align it right or asCenter to center it.

Default is false.

Last Edited: September 10, 2003


cComActiveXControl [Event OnBeginningOfPanel]

OnBeginningOfPanel - cComActiveXControl

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


cComActiveXControl [Event OnChange]

OnChange - cComActiveXControl

Can perform a task each time the ActiveX control's 'binded' property is changed

Type: Event

Parameters: No Parameters

Description

You can augment the OnChange event handler to perform a task each time the ActiveX control's 'binded' property is changed.

When an ActiveX control's bindable value is bound to the wrapper object's Value property this event will be trigger each time either property is changed.

See Also

Value | pbBindValue

Last Edited: September 10, 2003


cComActiveXControl [Event OnCreate]

OnCreate - cComActiveXControl

Sent right after a COM object is created

Type: Event

Parameters: No Parameters

Description

The OnCreate event is always sent right after a COM object is created. You should write an OnCreate event handler to initialize the properties of a COM object when it is created.

It is important to understand the difference between when a COM object is created and when its VDF wrapper object is created. This is discussed in detail in the topic COM Object Life Span.

It is always safe to set the properties of a COM object inside of the OnCreate event handler. It is also good practice to always Forward Send OnCreate when augmenting this event handler.

Below is an example of setting the calendar ActiveX control's properties inside the OnCreate event.

Object oCalendar1 is a cComCalendar
    Set Size to 104 223
    Set Location to 3 5

    Embed_ActiveX_Resource
    // The ActiveX properties will be embedded in the control's source code here in binary format.
    End_Embed_ActiveX_Resource

    Procedure OnCreate
        Forward Send OnCreate
        // Set the calendar's date to today's date
        Send ComToday
        // don't show the calendar's title
        Set ComShowTitle To False
    End_Procedure

End_Object    // oCalendar1

Last Edited: August 10, 2006


cComActiveXControl [Event OnKillFocus]

OnKillFocus - cComActiveXControl

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


cComActiveXControl [Event OnSetFocus]

OnSetFocus - cComActiveXControl

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


cComActiveXControl [Event Prompt_Callback]

Prompt_Callback - cComActiveXControl

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


cComActiveXControl [Event Shadow_Display]

Shadow_Display - cComActiveXControl

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Events for cComActiveXControl

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfComUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Key | Augmented to implement the GUI keyboard interface | DfComUIObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange | Can perform a task each time the ActiveX control's 'binded' property is changed |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCreate | Sent right after a COM object is created |
OnKillFocus | Sent whenever the object is about to lose the focus |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display |  |


cComActiveXControl [Function IsComObjectCreated]

IsComObjectCreated - cComActiveXControl

Tests to see if a COM object exists by getting the value of IsComObjectCreated

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

This function returns True, if the COM object has been created indicating that it is safe to access its interface.

Description

You can test to see if a COM object exists by getting the value of IsComObjectCreated.

This is analogous to testing if the pvComObject property is Not Null (created), or Null (released).

The following example demonstrates the use of IsComObjectCreated in the OnClick event of a button object.

Procedure OnClick
    Boolean bIsComObjectCreated

    // test If the calendar ActiveX control currently exists.
    Get IsComObjectCreated of oCalendar1 To bIsComObjectCreated
    If (bIsComObjectCreated) Begin
        // Set the calendar's date to today's date
        Send ComToday of oCalendar1
    End
End_Procedure

Testing IsComObjectCreated is crucial to writing error free COM applications. You should test this value before executing any code that accesses a COM object's interface methods or properties. The exception to this rule is when you access a COM object inside an OnCreate event handler.

Last Edited: August 18, 2003


cComActiveXControl [Function Next_Object_Id]

Next_Object_Id - cComActiveXControl

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


cComActiveXControl [Function Prior_Object_Id]

Prior_Object_Id - cComActiveXControl

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for cComActiveXControl

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfComUIObject
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
ComAddref | Procedure |  | DfInPlaceComObject
ComQueryInterface | Function |  | DfInPlaceComObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object | DfInPlaceComObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
RegisterComEvent | Procedure |  | DfInPlaceComObject
RegisterPropertyChangeEvent | Procedure |  | DfInPlaceComObject
Release_Mouse_Capture | Procedure |  | DfComUIObject
ReleaseComObject | Procedure | Releases ActiveX control associated with this object | DfInPlaceComObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |


cComActiveXControl [Procedure Activate_Area]

Activate_Area - cComActiveXControl

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXControl [Procedure Beginning_of_Panel]

Beginning_of_Panel - cComActiveXControl

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


cComActiveXControl [Procedure Bottom_of_Panel]

Bottom_of_Panel - cComActiveXControl

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


cComActiveXControl [Procedure DoHtmlHelp]

DoHtmlHelp - cComActiveXControl

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


cComActiveXControl [Procedure End_of_Panel]

End_of_Panel - cComActiveXControl

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


cComActiveXControl [Procedure Error_Help]

Error_Help - cComActiveXControl

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComActiveXControl [Procedure Extended_Help]

Extended_Help - cComActiveXControl

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComActiveXControl [Procedure File_Help]

File_Help - cComActiveXControl

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComActiveXControl [Procedure Help]

Help - cComActiveXControl

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


cComActiveXControl [Procedure Help_For_Help]

Help_For_Help - cComActiveXControl

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComActiveXControl [Procedure Help_Index]

Help_Index - cComActiveXControl

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComActiveXControl [Procedure Help_on_topic]

Help_on_topic - cComActiveXControl

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComActiveXControl [Procedure Keys_Help]

Keys_Help - cComActiveXControl

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComActiveXControl [Procedure Request_Status_Help]

Request_Status_Help - cComActiveXControl

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


cComActiveXControl [Procedure Top_of_Panel]

Top_of_Panel - cComActiveXControl

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for cComActiveXControl

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfComUIObject
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfComUIObject
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfComUIObject
Color | Sets the background color of the object | DfComUIObject
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfComUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
ControlValue | Used as a hook to link a property in the ActiveX control with the Value Property |
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfComUIObject
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfComUIObject
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Changed_State |  |
Item_Count |  |
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object |
Label_Col_Offset | The horizontal distance from the object to its label |
Label_Justification_Mode | The justification mode for the text within this object's label |
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property |
Label_Row_Offset | The vertical distance from the top edge of the object and its label |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfComUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Parent | Returns the parent of an object | cObject
pbBindValue | Controls whether an ActiveX's bindable property is bound to the Value property |
peAnchors | Describes how you want the control to react whenever its container changes size | DfComUIObject
peAutoCreate | Manipulates COM Object instantiation | DfInPlaceComObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piMaxSize | Determines the limit of the maximum size that a Component can be | DfComUIObject
piMinSize | Determines the limit of the minimum size that a Component can be | DfComUIObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
psLicenseKey | Contains the license key when ActiveX controls use a run-time license | DfInPlaceComObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfInPlaceComObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfInPlaceComObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Shadow_State | Determines if item is enabled (not shadowed) | DfComUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
TextColor | Sets the text color of the object | DfComUIObject
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value |  |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfComUIObject
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfComUIObject


cComActiveXControl [Property ControlValue]

ControlValue - cComActiveXControl

Used as a hook to link a property in the ActiveX control with the Value Property

Type: Property

Access: Read/Write

Data Type: String

Description

The ControlValue property is used as a hook to link a property in the ActiveX control with the Value property. To do this you'll need to find the messages in the control that Get and Set its data value and create Get ControlValue and Set ControlValue methods. These methods should be written to Get and Set the ActiveX control's 'real value' property.

The name of this 'real value' property is defined by the ActiveX control and could be any name. For example, the Calendar control's real value property happens to be called ComValue so the code that must be created is:

Function ControlValue Returns String
    Function_Return (ComValue(Self))
End_Function

Procedure Set ControlValue String sVal
    Set ComValue to sVal
End_Procedure

This binding is normally done automatically by the COM wrapper class generator when you import an ActiveX control. You would only want to change this If you want to bind to a different ActiveX property, or If the ActiveX control did not publish a bindable property.

Once an ActiveX control's bindable property is bound to the Value property in this way you can Get and Set the Value property at any time during the life span of the wrapper Object regardless of whether it is connected to its ActiveX control. Whenever the ActiveX control is connected to the wrapper, its bindable property will be initialized to the current Value property.

See Also

Value | pbBindValue

Last Edited: July 31, 2003


cComActiveXControl [Property Enabled_State]

Enabled_State - cComActiveXControl

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


cComActiveXControl [Property Explicit_Shadow_State]

Explicit_Shadow_State - cComActiveXControl

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


cComActiveXControl [Property Help_id]

Help_id - cComActiveXControl

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


cComActiveXControl [Property Help_Keyword]

Help_Keyword - cComActiveXControl

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


cComActiveXControl [Property Item_Changed_State]

Item_Changed_State - cComActiveXControl

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | [ToDo: In Progress]
iState | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXControl [Property Item_Count]

Item_Count - cComActiveXControl

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


cComActiveXControl [Property Item_Shadow_State]

Item_Shadow_State - cComActiveXControl

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


cComActiveXControl [Property Label]

Label - cComActiveXControl

Sets the text for a label or heading for an entry control object

Type: Property

Access: Read/Write

Data Type: String

Description

The Label property sets the text for a label or heading for an entry control object (form, edit or list). In most classes, just setting this property is all that is required for the class to present the label in whatever particular way each class does this. In data-aware classes, the value of this property is overridden by label values in the DDO when auto_label_state has been set true.

Object F1 is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "First Name:"
End_object

Last Edited: August 18, 2003


cComActiveXControl [Property Label_Col_Offset]

Label_Col_Offset - cComActiveXControl

The horizontal distance from the object to its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Col_Offset is the horizontal distance from the object to its label. Units represent distance to the left (i.e., labels appear to the left of their object). If the label's justification-mode is left or top (jmode_left, jmode_top) this represents the distance from left edge of the object to the left edge of its label. If the justification-mode is right (jmode_right) this represents the distance from the left edge of the object to the right edge of the label. By default, this is the value of default_label_offset, which is supplied with a value of 60 (this is a global integer which can be changed).

Default is default label offset.

Last Edited: August 18, 2003


cComActiveXControl [Property Label_Justification_Mode]

Label_Justification_Mode - cComActiveXControl

The justification mode for the text within this object's label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Justification_Mode is the justification mode for the text within this object's label.

When the label_justification_mode is changed the row and col offset properties will often need to be changed as well.

The default mode for labels (jmode_left) is stored in the global integer default_label_jmode.

Object LeftForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Left Justify:" // use default column of 60
End_object

Object RightForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Right Justify:"
    Set label_justification_mode to jmode_right
    // set distance between right side of the label and the left side
    // of the object
    Set label_col_offset to 3
End_object

Object TopForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Top Justify:"
    Set label_justification_mode to jmode_top
    // label and object will align vertically
    Set label_col_offset to 0
End_object

Default is JMode Left.

Last Edited: August 18, 2003


cComActiveXControl [Property Label_Offset]

Label_Offset - cComActiveXControl

Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer i1 integer i2

Parameter | Description
i1 | The Row Offset of the Label
i2 | The Column Offset of the Label

Description

The Label_Offset property returns both the label_row_offset and the label_col_offset properties as a single (two-component) property. The Hi() value of the return parameter represents the row offset. The Low() value represents the column offset.

Get Label_Offset of oForm to iOffset
Move (Hi(iOffset))  to iRowOffset
Move (Low(iOffset)) to iColumnOffset

Label_offset is set as a single property passing the row offset and the column offset as two separate parameters.

Set Label_Offset of oForm to iRowOffset iColumnOffset

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

Last Edited: June 22, 2005


cComActiveXControl [Property Label_Row_Offset]

Label_Row_Offset - cComActiveXControl

The vertical distance from the top edge of the object and its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Row_Offset is the vertical distance from the top edge of the object and its label. If the label's justification-mode is jmode_top it represents the vertical distance from the top edge of this object to the bottom edge of its label and larger numbers moves the label up (and away from the object). If the mode is not top it represents the distance from the top edge of the object and the top edge of the label and larger numbers moves the label down. By default, this is zero which is suitable for both form and side labels.

Default is 0.

Last Edited: August 18, 2003


cComActiveXControl [Property Object_Shadow_State]

Object_Shadow_State - cComActiveXControl

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


cComActiveXControl [Property pbBindValue]

pbBindValue - cComActiveXControl

Controls whether an ActiveX's bindable property is bound to the Value property

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The pbBindValue property controls whether an ActiveX's bindable property is bound to the Value property.

Situations may arise where a control is bindable but you do not want to use the control in that manner. In this case, you can just ignore the binding mechanism and everything should work perfectly - you just would not use the get/set Value interface. If for some reason the class binding behavior gets in your way, you can disable all binding and synchronization by setting the property pbBindValue to False (by default it is True). Setting pbBindValue to False severs any connection between the get/set Value message and any of the ActiveX control's interfaces. You will probably never need to change this property.

See Also

Value | ControlValue

Last Edited: September 10, 2003


cComActiveXControl [Property psHtmlHelpTopic]

psHtmlHelpTopic - cComActiveXControl

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


cComActiveXControl [Property Status_Help]

Status_Help - cComActiveXControl

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


cComActiveXControl [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - cComActiveXControl

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


cComActiveXControl [Property Value]

Value - cComActiveXControl

Type: Property

Access: Read/Write

Data Type: String

Parameters: integer iItem string sVal

Parameter | Description
iItem | [ToDo: In Progress]
sVal | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Event Entering]

Entering - cComActiveXEntryControl_

When the focus is to move to a new object, the entering event is sent to the object receiving the focus

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

When the focus is to move to a new object, the entering event is sent to the object receiving the focus. If entering is not overridden, its function is to send the message identified in the value of the entry_msg property. This event is used to perform any pre-processing to the object before it receives the focus. Entering is suitable for defining the entry behavior of object classes, while entry_msg is suitable for object inheritance of entry behavior.

Last Edited: August 5, 2003


cComActiveXEntryControl_ [Event Exiting]

Exiting - cComActiveXEntryControl_

When the focus is to move to a new object, the exiting event is sent to the object losing the focus

Type: Event

Return Data Type: Integer

Parameters: Handle hoDestination

Parameter | Description
hoDestination | the id of the object to which the focus is to move

Return Value

Returning a non zero value from the exiting procedure cancels movement of the focus.

Description

When the focus is to move to a new object, the exiting event is sent to the object losing the focus. If exiting is not overridden, its function is to send the message identified in the value of the exit_msg property. This event is used to perform any post-processing to the object before it loses the focus. hoTo is the id of the object to which the focus is to move, and can be used to provide processing conditional on which object the focus is to move to. Exiting is suitable for defining the exit behavior of object classes, while exit_msg is suitable for object inheritance of exit behavior.

procedure exiting integer obj returns integer
    integer ret_val
    forward get msg_exiting obj to ret_val
    if ret_val procedure_return ret_val
    if (obj <>parent(self)) get custom_validate to ret_val
    procedure_return ret_val
end_procedure

Last Edited: July 11, 2006


cComActiveXEntryControl_ [Event Refresh]

Refresh - cComActiveXEntryControl_

Type: Event

Parameters: integer notifyMode

Parameter | Description
notifyMode | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Events for cComActiveXEntryControl_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfComUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus |
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus |
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Key | Augmented to implement the GUI keyboard interface | DfComUIObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | cComActiveXControl
OnChange | Can perform a task each time the ActiveX control's 'binded' property is changed | cComActiveXControl
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCreate | Sent right after a COM object is created | cComActiveXControl
OnKillFocus | Sent whenever the object is about to lose the focus | cComActiveXControl
OnSetFocus | Sent whenever windows is about to give this object the focus | cComActiveXControl
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | cComActiveXControl
Refresh |  |
Shadow_Display |  | cComActiveXControl


cComActiveXEntryControl_ [Function Validate_Items]

Validate_Items - cComActiveXEntryControl_

Type: Function

Return Data Type: Integer

Parameters: Boolean bNotFindReq

Parameter | Description
bNotFindReq | [ToDo: In Progress]

Return Value

Description

Last Edited: July 11, 2006


Methods for cComActiveXEntryControl_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | cComActiveXControl
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfComUIObject
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | cComActiveXControl
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | cComActiveXControl
Cancel | Procedure | Returns the message_id of itself | cUIObject
ComAddref | Procedure |  | DfInPlaceComObject
ComQueryInterface | Function |  | DfInPlaceComObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object | DfInPlaceComObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | cComActiveXControl
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | cComActiveXControl
Error_Help | Procedure | (Obsolete) | cComActiveXControl
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | cComActiveXControl
File_Help | Procedure | (Obsolete) | cComActiveXControl
Help | Procedure |  | cComActiveXControl
Help_For_Help | Procedure | (Obsolete) | cComActiveXControl
Help_Index | Procedure | (Obsolete) | cComActiveXControl
Help_on_topic | Procedure | (Obsolete) | cComActiveXControl
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComActiveXControl
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | cComActiveXControl
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cComActiveXControl
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cComActiveXControl
RegisterComEvent | Procedure |  | DfInPlaceComObject
RegisterPropertyChangeEvent | Procedure |  | DfInPlaceComObject
Release_Mouse_Capture | Procedure |  | DfComUIObject
ReleaseComObject | Procedure | Releases ActiveX control associated with this object | DfInPlaceComObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | cComActiveXControl
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | cComActiveXControl
Validate_Items | Function |  |


Properties for cComActiveXEntryControl_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfComUIObject
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfComUIObject
Checkbox_Item_State | Any item may become a checkbox-type item when its checkbox_item_state is set to true |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfComUIObject
Color | Sets the background color of the object | DfComUIObject
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfComUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
ControlValue | Used as a hook to link a property in the ActiveX control with the Value Property | cComActiveXControl
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared |
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | cComActiveXControl
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | cComActiveXControl
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
Form_Datatype |  |
Form_Mask |  |
Form_Options |  |
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfComUIObject
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfComUIObject
Help_id | Used to specify an object's context ID | cComActiveXControl
Help_Keyword | Used to specify an object's context keyword | cComActiveXControl
Item_Changed_State |  |
Item_Count |  | cComActiveXControl
Item_Entry_Msg |  |
Item_Exit_Msg |  |
Item_Option |  |
Item_Options |  |
Item_Shadow_State | Determines if an object's item is enabled or disabled | cComActiveXControl
Item_Validate_Msg |  |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | cComActiveXControl
Label_Col_Offset | The horizontal distance from the object to its label | cComActiveXControl
Label_Justification_Mode | The justification mode for the text within this object's label | cComActiveXControl
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | cComActiveXControl
Label_Row_Offset | The vertical distance from the top edge of the object and its label | cComActiveXControl
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfComUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | cComActiveXControl
Parent | Returns the parent of an object | cObject
pbBindValue | Controls whether an ActiveX's bindable property is bound to the Value property | cComActiveXControl
peAnchors | Describes how you want the control to react whenever its container changes size | DfComUIObject
peAutoCreate | Manipulates COM Object instantiation | DfInPlaceComObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phoEntryForm |  |
piMaxSize | Determines the limit of the maximum size that a Component can be | DfComUIObject
piMinSize | Determines the limit of the minimum size that a Component can be | DfComUIObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object |  |
Prototype_Object |  |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | cComActiveXControl
psLicenseKey | Contains the license key when ActiveX controls use a run-time license | DfInPlaceComObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfInPlaceComObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfInPlaceComObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Select_State |  |
Shadow_State | Determines if item is enabled (not shadowed) | DfComUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | cComActiveXControl
TextColor | Sets the text color of the object | DfComUIObject
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | cComActiveXControl
Value |  |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfComUIObject
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfComUIObject
Zoom_Object |  |


cComActiveXEntryControl_ [Property Checkbox_Item_State]

Checkbox_Item_State - cComActiveXEntryControl_

Any item may become a checkbox-type item when its checkbox_item_state is set to true

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iState

Parameter | Description
iItem | The item number
iState | True if item is a checkbox, false if not

Description

Any item may become a checkbox-type item when its checkbox_item_state is set to true. The object's select_mode should be set to one of the modes other than no_select to allow users to select the choice that is desired.

The Select_State message should be used to let the checkbox show as marked/selected or not.

Default is false.

Last Edited: June 23, 2005


cComActiveXEntryControl_ [Property Data_Field]

Data_Field - cComActiveXEntryControl_

Identifies the database field from which data is to be stored, retrieved, and cleared

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iField

Parameter | Description
iItem | The item number
iField | The field number

Description

Each entry_item may have a field in a database file associated with it. The data_field identifies the database field from which data is to be stored, retrieved, and cleared. Data_fields are most often set by the entry_item command.

entry_item customer.name

They may also be set using the data_field message. This may be done if an entry item needs to be set to another field number than the initialized one. Data_field numbers begin with 0 for recnum and count up to the number of fields in the file with which the item is associated. Values outside this range are errors.

set data_field item 0 to 4

get data_field item 0 to var

If the entry_item is not associated with a data field (it is associated with an expression or variable), the value of this property is 0.

Last Edited: August 5, 2003


cComActiveXEntryControl_ [Property Data_File]

Data_File - cComActiveXEntryControl_

Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iFile

Parameter | Description
iItem | The item number
iFile | The file number

Description

Each entry_item may have a field in a database file associated with it. The Data_file property identifies the database file that contains the field from which data is to be stored, retrieved, and cleared. Data_files are most often set by the composition of the entry_item statement itself.

entry_item customer.name

They may also be set using the data_file message. This may be done if an entry item needs to be set to another file than the initialized one.

set data_file item 0 to customer.File_Number

get data_file item 0 to filenumber

If the entry_item is not associated with a data field (it is associated with an expression or variable) the value of this property is 0.

Last Edited: August 5, 2003


cComActiveXEntryControl_ [Property Form_Datatype]

Form_Datatype - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iType

Parameter | Description
iItem | [ToDo: In Progress]
iType | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property Form_Mask]

Form_Mask - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: String

Parameters: integer iItem String sMask

Parameter | Description
iItem | [ToDo: In Progress]
sMask | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property Form_Options]

Form_Options - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iOptions

Parameter | Description
iItem | [ToDo: In Progress]
iOptions | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property Item_Changed_State]

Item_Changed_State - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iState

Parameter | Description
iItem | [ToDo: In Progress]
iState | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property Item_Entry_Msg]

Item_Entry_Msg - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer hMsg

Parameter | Description
iItem | [ToDo: In Progress]
hMsg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property Item_Exit_Msg]

Item_Exit_Msg - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer hMsg

Parameter | Description
iItem | [ToDo: In Progress]
hMsg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property Item_Option]

Item_Option - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iOption integer iState

Parameter | Description
iItem | [ToDo: In Progress]
iOption | [ToDo: In Progress]
iState | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property Item_Options]

Item_Options - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iOptions

Parameter | Description
iItem | [ToDo: In Progress]
iOptions | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property Item_Validate_Msg]

Item_Validate_Msg - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer hMsg

Parameter | Description
iItem | [ToDo: In Progress]
hMsg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property phoEntryForm]

phoEntryForm - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: Handle

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property Prompt_Object]

Prompt_Object - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: Handle

Parameters: Integer iItem Integer hoPrompt

Parameter | Description
iItem | [ToDo: In Progress]
hoPrompt | [ToDo: In Progress]

Description

Last Edited: July 11, 2006


cComActiveXEntryControl_ [Property Prototype_Object]

Prototype_Object - cComActiveXEntryControl_

Type: Property

Access: Read-Only

Data Type: Handle

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property Select_State]

Select_State - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | [ToDo: In Progress]
iState | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property Value]

Value - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: String

Parameters: integer iItem string sValue

Parameter | Description
iItem | [ToDo: In Progress]
sValue | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComActiveXEntryControl_ [Property Zoom_Object]

Zoom_Object - cComActiveXEntryControl_

Type: Property

Access: Read/Write

Data Type: Handle

Parameters: Integer iItem Handle hoPrompt

Parameter | Description
iItem | [ToDo: In Progress]
hoPrompt | [ToDo: In Progress]

Description

Last Edited: July 11, 2006


Events for cComAutomationObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cComAutomationObject [Function AttachActiveObject]

AttachActiveObject - cComAutomationObject

Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns True if a successful attachment to a running COM object is made, otherwise it returns False.

Description

The AttachActiveObject function looks for an active COM object of its class in the system ROT (Running Object Table). If successful the COM object is attached it to the VDF object.

For example when an instance of Word is started, it automatically registers its Application object with the system ROT, so that other Automation Controllers can attach to the same Application object.

You would use this function when you want to ensure that multiple instances of an Automation Controller will attach to only one server.

The below example demonstrates the use of AttachActiveObject to connect to a running instance of MS Word:

Procedure OnClick
    // Click this button to Attach to Word 8 Automation Server.
    Boolean bIsComObjectCreated

    // test If the VDF Wrapper is already connected to Word.
    Get IsComObjectCreated of oWordAutomation To bIsComObjectCreated

    If (Not(bIsComObjectCreated)) Begin
        // now try to attach to a running instance of word...
        Get AttachActiveObject of oWordAutomation To bIsComObjectCreated

        If (Not(bIsComObjectCreated)) Begin
            // If we got here then we have to create our own
            // instance of word.
            Send CreateComObject of oWordAutomation
        End
    End
End_Procedure // OnClick

See Also

CreateComObject | ReleaseComObject

Last Edited: July 30, 2003


cComAutomationObject [Function IsComObjectCreated]

IsComObjectCreated - cComAutomationObject

Tests to see if a COM object exists by getting the value of IsComObjectCreated

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

This function returns True, if the COM object has been created indicating that it is safe to access its interface.

Description

You can test to see if a COM object exists by getting the value of IsComObjectCreated.

This is analogous to testing if the pvComObject property is Not Null (created), or Null (released).

Testing IsComObjectCreated is crucial to writing error free COM applications. You should test this value before executing any code that accesses a COM object's interface methods or properties. The exception to this rule is when you access a COM object inside an OnCreate event handler.

Refer to the CreateComObject method for an example showing the use of IsComObjectCreated.

Last Edited: August 18, 2003


Methods for cComAutomationObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object |
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated |
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cComAutomationObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


Events for cComDbActiveXControl

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfComUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cComActiveXEntryControl_
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | cComDbActiveXControl_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cComActiveXEntryControl_
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Key | Augmented to implement the GUI keyboard interface | DfComUIObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | cComActiveXControl
OnChange | Can perform a task each time the ActiveX control's 'binded' property is changed | cComActiveXControl
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCreate | Sent right after a COM object is created | cComActiveXControl
OnKillFocus | Sent whenever the object is about to lose the focus | cComActiveXControl
OnSetFocus | Sent whenever windows is about to give this object the focus | cComActiveXControl
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | cComActiveXControl
Refresh |  | cComActiveXEntryControl_
Shadow_Display |  | cComActiveXControl


cComDbActiveXControl [Function Prompt_Description]

Prompt_Description - cComDbActiveXControl

Type: Function

Obsolete

Return Data Type: String

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


cComDbActiveXControl [Function Validate_Prompt]

Validate_Prompt - cComDbActiveXControl

Type: Function

Obsolete

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for cComDbActiveXControl

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | cComActiveXControl
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfComUIObject
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | cComDbActiveXControl_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | cComActiveXControl
Bell | Procedure | Rings the PC bell | cUIObject
Bind_Data | Procedure |  |
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | cComActiveXControl
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | cComDbActiveXControl_
Close_Panel | Procedure | Closes the panel or component currently open |
ComAddref | Procedure |  | DfInPlaceComObject
ComQueryInterface | Function |  | DfInPlaceComObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object | DfInPlaceComObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) |
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | cComActiveXControl
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | cComDbActiveXControl_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | cComActiveXControl
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | cComDbActiveXControl_
Error_Help | Procedure | (Obsolete) | cComActiveXControl
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | cComDbActiveXControl_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | cComDbActiveXControl_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | cComDbActiveXControl_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | cComDbActiveXControl_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | cComActiveXControl
File_Help | Procedure | (Obsolete) | cComActiveXControl
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | cComDbActiveXControl_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | cComDbActiveXControl_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | cComDbActiveXControl_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | cComDbActiveXControl_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | cComDbActiveXControl_
Help | Procedure |  | cComActiveXControl
Help_For_Help | Procedure | (Obsolete) | cComActiveXControl
Help_Index | Procedure | (Obsolete) | cComActiveXControl
Help_on_topic | Procedure | (Obsolete) | cComActiveXControl
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComActiveXControl
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | cComActiveXControl
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | cComDbActiveXControl_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cComActiveXControl
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cComActiveXControl
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | cComDbActiveXControl_
Prompt_Description | Function | (Obsolete) |
Prompt_Description | Procedure | (Obsolete) |
RegisterComEvent | Procedure |  | DfInPlaceComObject
RegisterPropertyChangeEvent | Procedure |  | DfInPlaceComObject
Release_Mouse_Capture | Procedure |  | DfComUIObject
ReleaseComObject | Procedure | Releases ActiveX control associated with this object | DfInPlaceComObject
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | cComDbActiveXControl_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | cComDbActiveXControl_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | cComDbActiveXControl_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | cComDbActiveXControl_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | cComDbActiveXControl_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | cComDbActiveXControl_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | cComDbActiveXControl_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | cComActiveXControl
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | cComDbActiveXControl_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | cComDbActiveXControl_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | cComDbActiveXControl_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | cComDbActiveXControl_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | cComActiveXControl
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | cComDbActiveXControl_
Validate_Prompt | Function | (Obsolete) |
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | cComDbActiveXControl_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | cComDbActiveXControl_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | cComDbActiveXControl_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | cComDbActiveXControl_
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | cComDbActiveXControl_


cComDbActiveXControl [Procedure Bind_Data]

Bind_Data - cComDbActiveXControl

Type: Procedure

Parameters: integer iFile Integer iField

Parameter | Description
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComDbActiveXControl [Procedure Close_Panel]

Close_Panel - cComDbActiveXControl

Closes the panel or component currently open

Type: Procedure

Parameters: No Parameters

Description

Closes the panel or component currently open. If the control Close_Panel is sent to is not a panel, the call will be delegated to it's parent.

For example, if a cDbRichEdit control is in a dbView, sending Close_Panel to the cDbRichEdit control will close the dbView.

Sample

This sample causes the dbView control oDbView1 to close when button oCloseButton is clicked.

Object oDbView1 is a dbView
    :
    Object oDbRichEdit1 is a cDbRichEdit
        :
    End_Object  // oDbRichEdit1
    :
    Object oCloseButton is a Button
        :
        Procedure OnClick
            send Close_Panel of oDbRichEdit1
        End_Procedure  // OnClick
        :
    End_Object  // oCloseButton
    :
End_Object  // oDbView1

Last Edited: November 24, 2004


cComDbActiveXControl [Procedure Default_Prompt]

Default_Prompt - cComDbActiveXControl

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComDbActiveXControl [Procedure Prompt_Description]

Prompt_Description - cComDbActiveXControl

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Properties for cComDbActiveXControl

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfComUIObject
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | cComDbActiveXControl_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | cComDbActiveXControl_
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object |
Auto_Save_State | Determines if auto save should be performed | cComDbActiveXControl_
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | cComDbActiveXControl_
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfComUIObject
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | cComDbActiveXControl_
Checkbox_Item_State | Any item may become a checkbox-type item when its checkbox_item_state is set to true | cComActiveXEntryControl_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfComUIObject
Color | Sets the background color of the object | DfComUIObject
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfComUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
ControlValue | Used as a hook to link a property in the ActiveX control with the Value Property | cComActiveXControl
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | cComActiveXEntryControl_
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | cComActiveXEntryControl_
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | cComDbActiveXControl_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | cComDbActiveXControl_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) |
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | cComDbActiveXControl_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | cComActiveXControl
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | cComActiveXControl
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
Form_Datatype |  | cComActiveXEntryControl_
Form_Mask |  | cComActiveXEntryControl_
Form_Options |  | cComActiveXEntryControl_
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfComUIObject
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfComUIObject
Help_id | Used to specify an object's context ID | cComActiveXControl
Help_Keyword | Used to specify an object's context keyword | cComActiveXControl
Item_Changed_State |  | cComActiveXEntryControl_
Item_Count |  | cComActiveXControl
Item_Entry_Msg |  | cComActiveXEntryControl_
Item_Exit_Msg |  | cComActiveXEntryControl_
Item_Option |  | cComActiveXEntryControl_
Item_Options |  | cComActiveXEntryControl_
Item_Shadow_State | Determines if an object's item is enabled or disabled | cComActiveXControl
Item_Validate_Msg |  | cComActiveXEntryControl_
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | cComActiveXControl
Label_Col_Offset | The horizontal distance from the object to its label | cComActiveXControl
Label_Justification_Mode | The justification mode for the text within this object's label | cComActiveXControl
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | cComActiveXControl
Label_Row_Offset | The vertical distance from the top edge of the object and its label | cComActiveXControl
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfComUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | cComActiveXControl
Parent | Returns the parent of an object | cObject
pbBindValue | Controls whether an ActiveX's bindable property is bound to the Value property | cComActiveXControl
peAnchors | Describes how you want the control to react whenever its container changes size | DfComUIObject
peAutoCreate | Manipulates COM Object instantiation | DfInPlaceComObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phoEntryForm |  | cComActiveXEntryControl_
piMaxSize | Determines the limit of the maximum size that a Component can be | DfComUIObject
piMinSize | Determines the limit of the minimum size that a Component can be | DfComUIObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object |  | cComActiveXEntryControl_
Prototype_Object |  | cComActiveXEntryControl_
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | cComActiveXControl
psLicenseKey | Contains the license key when ActiveX controls use a run-time license | DfInPlaceComObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfInPlaceComObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfInPlaceComObject
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | cComDbActiveXControl_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Select_State |  | cComActiveXEntryControl_
Server | Identifies the object which provides database services to this object | cComDbActiveXControl_
Shadow_State | Determines if item is enabled (not shadowed) | DfComUIObject
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | cComDbActiveXControl_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | cComActiveXControl
TextColor | Sets the text color of the object | DfComUIObject
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | cComActiveXControl
Validate_All_Items_State | Determines if all items are being validated | cComDbActiveXControl_
Validate_Mode | Determines how and when object validation occurs | cComDbActiveXControl_
Value |  | cComActiveXEntryControl_
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | cComDbActiveXControl_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | cComDbActiveXControl_
verify_exit_msg | Determines what message is sent during an exiting event | cComDbActiveXControl_
Verify_Save_Msg | Specifies the message to use for save confirmation | cComDbActiveXControl_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfComUIObject
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfComUIObject
Zoom_Object |  | cComActiveXEntryControl_


cComDbActiveXControl [Property Auto_Label_State]

Auto_Label_State - cComDbActiveXControl

Determines if this object will draw label values from the DDO rather than from any label that may be set in this object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_label_state property is set true, this object will draw label values from the DDO rather than from any label that may be set in this object.

When used within single-item objects (forms and edits), the object uses the field's long label name.

When used within multi-item objects (grids), the object uses the field's short label name.

Default is false.

Last Edited: January 12, 2006


cComDbActiveXControl [Property DEO_Control_Object]

DEO_Control_Object - cComDbActiveXControl

Indicates whether the control is a Data Entry Object (DEO)

Type: Property

Access: Read-Only

Data Type: Integer

Description

Any Data Entry Object (DEO) has DEO_Control_Object set true, which means that it is a DEO control object, but not a container.

Any DEO control will also return true for DEO_Object because of delegation (DEO controls must always reside in DEO containers).

See Also

DEO_Object

Last Edited: May 4, 2005


cComDbActiveXControl_ [Event Entry_Defaults]

Entry_Defaults - cComDbActiveXControl_

"Hook" for providing default-setting routines

Type: Event

Parameters: No Parameters

Description

Entry_defaults is a "Hook" for providing default-setting routines. It is sent by clear. You should never send this message. Note that this is not used with data dictionaries.

Last Edited: August 5, 2003


Events for cComDbActiveXControl_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfComUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cComActiveXEntryControl_
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines |
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cComActiveXEntryControl_
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Key | Augmented to implement the GUI keyboard interface | DfComUIObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | cComActiveXControl
OnChange | Can perform a task each time the ActiveX control's 'binded' property is changed | cComActiveXControl
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCreate | Sent right after a COM object is created | cComActiveXControl
OnKillFocus | Sent whenever the object is about to lose the focus | cComActiveXControl
OnSetFocus | Sent whenever windows is about to give this object the focus | cComActiveXControl
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | cComActiveXControl
Refresh |  | cComActiveXEntryControl_
Shadow_Display |  | cComActiveXControl


cComDbActiveXControl_ [Function exec_entry]

exec_entry - cComDbActiveXControl_

Invokes the item_entry_msg of the specified item#, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: integer item#

Parameter | Description
item# | The item number

Return Value

The result of the item_entry_msg of the specified item#

Description

Exec_entry invokes the item_entry_msg of the specified item#, if any, and returns the result.

Last Edited: August 13, 2003


cComDbActiveXControl_ [Function exec_exit]

exec_exit - cComDbActiveXControl_

Invokes the item_exit_msg of the specified item#, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: integer item#

Parameter | Description
item# | The item number

Return Value

The result of the item_entry_msg of the specified item#

Description

Exec_exit invokes the item_exit_msg of the specified item#, if any, and returns the result.

Last Edited: August 13, 2003


cComDbActiveXControl_ [Function exec_validate]

exec_validate - cComDbActiveXControl_

Invokes the item_validate_msg of the specified item#, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: integer item#

Parameter | Description
item# | The item number

Return Value

The result of the item_entry_msg of the specified item#

Description

Exec_validate invokes the item_validate_msg of the specified item#, if any, and returns the result. Performs autofind on value and field of specified item#, if required, using entry_autofind.

Last Edited: August 13, 2003


cComDbActiveXControl_ [Function Validate_Items]

Validate_Items - cComDbActiveXControl_

Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails

Type: Function

Return Data Type: Integer

Parameters: Boolean bNotFindReq

Parameter | Description
bNotFindReq | If true the find required validation is not enforced

Return Value

Returns 0 if all items are valid, or else returns the first invalid item number.

Description

The superclass definition of the Validate_items message is augmented to manipulate the value of validate_items (a property inherited from the entry class) when validate_mode is validate_default, and to give this object the focus in the event validation of any item fails.

Last Edited: July 11, 2006


cComDbActiveXControl_ [Function Verify_Data_Loss]

Verify_Data_Loss - cComDbActiveXControl_

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


cComDbActiveXControl_ [Function Verify_Delete]

Verify_Delete - cComDbActiveXControl_

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


cComDbActiveXControl_ [Function verify_Exit]

verify_Exit - cComDbActiveXControl_

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


cComDbActiveXControl_ [Function Verify_Save]

Verify_Save - cComDbActiveXControl_

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for cComDbActiveXControl_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | cComActiveXControl
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfComUIObject
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | cComActiveXControl
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | cComActiveXControl
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox |
ComAddref | Procedure |  | DfInPlaceComObject
ComQueryInterface | Function |  | DfInPlaceComObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object | DfInPlaceComObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | cComActiveXControl
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | cComActiveXControl
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful |
Error_Help | Procedure | (Obsolete) | cComActiveXControl
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result |
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result |
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | cComActiveXControl
File_Help | Procedure | (Obsolete) | cComActiveXControl
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find |
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find |
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find |
Help | Procedure |  | cComActiveXControl
Help_For_Help | Procedure | (Obsolete) | cComActiveXControl
Help_Index | Procedure | (Obsolete) | cComActiveXControl
Help_on_topic | Procedure | (Obsolete) | cComActiveXControl
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComActiveXControl
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | cComActiveXControl
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation |
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cComActiveXControl
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cComActiveXControl
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message |
RegisterComEvent | Procedure |  | DfInPlaceComObject
RegisterPropertyChangeEvent | Procedure |  | DfInPlaceComObject
Release_Mouse_Capture | Procedure |  | DfComUIObject
ReleaseComObject | Procedure | Releases ActiveX control associated with this object | DfInPlaceComObject
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true |
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true |
Request_Delete | Procedure | Deletes the current record of this object's server, if any |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any |
Request_Save | Procedure | Saves changes to the current record of this object's server, if any |
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | cComActiveXControl
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind |
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind |
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind |
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | cComActiveXControl
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails |
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Zoom | Procedure | Activates zoom object of current item, if any, using popup message |


cComDbActiveXControl_ [Procedure Set CheckBox_Item]

CheckBox_Item - cComDbActiveXControl_

Set after each item of this object that you wish to be a checkbox

Type: Procedure Set

Data Type: String

Parameters: String ItemVal String TrueVal String FalseVal

Parameter | Description
ItemVal | The item that you wish displayed with the checkbox
TrueVal | The database field value for which the item's select_state is to be true
FalseVal | The field value for which the select_state is false

Description

The Checkbox_item message should be set after each item of this object that you wish to be a checkbox. All field values other than TrueVal will set the item's select_state false on entry_display. If FalseVal is omitted, 0 will be used. If TrueVal also is omitted, 1 will be used for that parameter by default.

Last Edited: June 23, 2005


cComDbActiveXControl_ [Procedure Beginning_of_Data]

Beginning_of_Data - cComDbActiveXControl_

Finds and displays the first record of the file specified by the data_file of the current_item of this object

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_data finds and displays the first record of the file specified by the data_file of the current_item of this object. Sent by kbegin_of_data.

Last Edited: August 13, 2003


cComDbActiveXControl_ [Procedure End_of_Data]

End_of_Data - cComDbActiveXControl_

Finds and displays the last record of the file specified by the data_file of the current_item of this object

Type: Procedure

Parameters: No Parameters

Description

End_of_data finds and displays the last record of the file specified by the data_file of the current_item of this object. Sent by kend_of_data.

Last Edited: August 5, 2003


cComDbActiveXControl_ [Procedure Entry_Autofind]

Entry_Autofind - cComDbActiveXControl_

Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful

Type: Procedure

Parameters: Integer eFindMode Integer iItem

Parameter | Description
eFindMode

Constant | Meaning
EQ | Find equal to
GE | Find greater than or equal to

iItem | The item number

Description

Entry_autofind finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful. Augmented to request find of server, if any, using item_find message.

Last Edited: July 11, 2006


cComDbActiveXControl_ [Procedure Exit_Function]

Exit_Function - cComDbActiveXControl_

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


cComDbActiveXControl_ [Procedure Find_First]

Find_First - cComDbActiveXControl_

Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_first finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of beginning_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cComDbActiveXControl_ [Procedure Find_GE]

Find_GE - cComDbActiveXControl_

Performs a find greater than or equal by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_ge performs a find greater than or equal by the data_file and data_field of the current item, using request_find. Sent by kfind.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cComDbActiveXControl_ [Procedure Find_Last]

Find_Last - cComDbActiveXControl_

Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_last finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of end_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cComDbActiveXControl_ [Procedure Find_Next]

Find_Next - cComDbActiveXControl_

Performs a find greater than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_next performs a find greater than by the data_file and data_field of the current item, using request_find. Sent by kfind_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cComDbActiveXControl_ [Procedure Find_Previous]

Find_Previous - cComDbActiveXControl_

Performs a find less than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_previous performs a find less than by the data_file and data_field of the current item, using request_find. Sent by kfind_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cComDbActiveXControl_ [Procedure Next]

Next - cComDbActiveXControl_

Makes validation in validate_on_save_next mode occur regardless of the state of object_validation

Type: Procedure

Parameters: No Parameters

Description

The superclass definition of the Next message is augmented to make validation in validate_on_save_next mode occur regardless of the state of object_validation (a property inherited from the entry superclass).

Last Edited: September 10, 2003


cComDbActiveXControl_ [Procedure Prompt]

Prompt - cComDbActiveXControl_

Activates prompt_object of current item, if any, using popup message

Type: Procedure

Parameters: No Parameters

Description

Prompt activates prompt_object of current item, if any, using popup message. Sent by kprompt.

Last Edited: June 29, 2005


cComDbActiveXControl_ [Procedure Request_Cancel]

Request_Cancel - cComDbActiveXControl_

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


cComDbActiveXControl_ [Procedure Request_Clear]

Request_Clear - cComDbActiveXControl_

Clears items, and changes focus to first item in this object if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear clears items, and changes focus to first item in this object if auto_top_panel_state is true. If clearing may cause loss of user changes to the text, verify_data_loss is used to confirm the action. If this object has a server, clear is requested of the server. This may result in other DEOs clearing in addition to this object. Sent by kclear.

Last Edited: September 11, 2003


cComDbActiveXControl_ [Procedure Request_Clear_All]

Request_Clear_All - cComDbActiveXControl_

Clears items, and changes focus to first item in this object if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear_all clears items, and changes focus to first item in this object if auto_top_panel_state is true. If clearing may cause loss of user changes to the text, verify_data_loss is used to confirm the action. If this object has a server, clear_all is requested of the server. This may result in other DEOs clearing in addition to this object. Sent by kclear_all.

Last Edited: September 11, 2003


cComDbActiveXControl_ [Procedure Request_Delete]

Request_Delete - cComDbActiveXControl_

Deletes the current record of this object's server, if any

Type: Procedure

Parameters: No Parameters

Description

Request_delete deletes the current record of this object's server, if any. If successful and auto_clear_deo_state is true, also clears the items using request_clear. Verify_delete is used to confirm the action. Sent by kdelete_record. Sends can_delete and acts only if that returns true.

Last Edited: September 11, 2003


cComDbActiveXControl_ [Procedure Request_Find]

Request_Find - cComDbActiveXControl_

Finds record using specified mode by requesting item_find from server, if any

Type: Procedure

Parameters: integer mode integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true perform entry update before Find.

Description

Request_find finds record using specified mode by requesting item_find from server, if any. Uses data_file and data_field to determine file and field for find. If this object has no server, no action is taken.

Last Edited: September 11, 2003


cComDbActiveXControl_ [Procedure Request_Save]

Request_Save - cComDbActiveXControl_

Saves changes to the current record of this object's server, if any

Type: Procedure

Parameters: No Parameters

Description

Request_Save saves changes to the current record of this object's server, if any. If successful and auto_clear_deo_state is true, clears items using request_clear. Verify_save is used to confirm the action. Sent by ksave_record.

Last Edited: August 19, 2004


cComDbActiveXControl_ [Procedure Request_Save_No_Clear]

Request_Save_No_Clear - cComDbActiveXControl_

Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state

Type: Procedure

Parameters: No Parameters

Description

Request_save_no_clear saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state.

Last Edited: September 11, 2003


cComDbActiveXControl_ [Procedure Request_Superfind]

Request_Superfind - cComDbActiveXControl_

Superfinds record using specified mode by requesting item_superfind from server, if any

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Request_superfind superfinds record using specified mode by requesting item_superfind from server, if any. Uses data_file and data_field to determine file and field for find. If this object has no server, no action is taken. Sends of request_superfind to a DSO require Predefined Indicator err to be set to false beforehand, in case an error other than Find past end of file or Find prior to beginning of file is generated by the superfind. Sent by DEOs.

Last Edited: September 11, 2003


cComDbActiveXControl_ [Procedure SuperFind]

SuperFind - cComDbActiveXControl_

Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cComDbActiveXControl_ [Procedure SuperFind_Next]

SuperFind_Next - cComDbActiveXControl_

Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_next performs a superfind greater than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cComDbActiveXControl_ [Procedure SuperFind_Previous]

SuperFind_Previous - cComDbActiveXControl_

Performs a superfind less than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_previous performs a superfind less than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cComDbActiveXControl_ [Procedure Zoom]

Zoom - cComDbActiveXControl_

Activates zoom object of current item, if any, using popup message

Type: Procedure

Parameters: No Parameters

Description

Zoom activates zoom object of current item, if any, using popup message. Sent by kzoom.

Last Edited: September 15, 2003


Properties for cComDbActiveXControl_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfComUIObject
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Save_State | Determines if auto save should be performed |
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfComUIObject
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object |
Checkbox_Item_State | Any item may become a checkbox-type item when its checkbox_item_state is set to true | cComActiveXEntryControl_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfComUIObject
Color | Sets the background color of the object | DfComUIObject
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfComUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
ControlValue | Used as a hook to link a property in the ActiveX control with the Value Property | cComActiveXControl
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | cComActiveXEntryControl_
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | cComActiveXEntryControl_
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | cComActiveXControl
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | cComActiveXControl
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
Form_Datatype |  | cComActiveXEntryControl_
Form_Mask |  | cComActiveXEntryControl_
Form_Options |  | cComActiveXEntryControl_
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfComUIObject
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfComUIObject
Help_id | Used to specify an object's context ID | cComActiveXControl
Help_Keyword | Used to specify an object's context keyword | cComActiveXControl
Item_Changed_State |  | cComActiveXEntryControl_
Item_Count |  | cComActiveXControl
Item_Entry_Msg |  | cComActiveXEntryControl_
Item_Exit_Msg |  | cComActiveXEntryControl_
Item_Option |  | cComActiveXEntryControl_
Item_Options |  | cComActiveXEntryControl_
Item_Shadow_State | Determines if an object's item is enabled or disabled | cComActiveXControl
Item_Validate_Msg |  | cComActiveXEntryControl_
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | cComActiveXControl
Label_Col_Offset | The horizontal distance from the object to its label | cComActiveXControl
Label_Justification_Mode | The justification mode for the text within this object's label | cComActiveXControl
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | cComActiveXControl
Label_Row_Offset | The vertical distance from the top edge of the object and its label | cComActiveXControl
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfComUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | cComActiveXControl
Parent | Returns the parent of an object | cObject
pbBindValue | Controls whether an ActiveX's bindable property is bound to the Value property | cComActiveXControl
peAnchors | Describes how you want the control to react whenever its container changes size | DfComUIObject
peAutoCreate | Manipulates COM Object instantiation | DfInPlaceComObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phoEntryForm |  | cComActiveXEntryControl_
piMaxSize | Determines the limit of the maximum size that a Component can be | DfComUIObject
piMinSize | Determines the limit of the minimum size that a Component can be | DfComUIObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object |  | cComActiveXEntryControl_
Prototype_Object |  | cComActiveXEntryControl_
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | cComActiveXControl
psLicenseKey | Contains the license key when ActiveX controls use a run-time license | DfInPlaceComObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfInPlaceComObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfInPlaceComObject
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Select_State |  | cComActiveXEntryControl_
Server | Identifies the object which provides database services to this object |
Shadow_State | Determines if item is enabled (not shadowed) | DfComUIObject
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | cComActiveXControl
TextColor | Sets the text color of the object | DfComUIObject
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | cComActiveXControl
Validate_All_Items_State | Determines if all items are being validated |
Validate_Mode | Determines how and when object validation occurs |
Value |  | cComActiveXEntryControl_
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event |
Verify_Save_Msg | Specifies the message to use for save confirmation |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfComUIObject
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfComUIObject
Zoom_Object |  | cComActiveXEntryControl_


cComDbActiveXControl_ [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - cComDbActiveXControl_

If true, this object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


cComDbActiveXControl_ [Property Auto_Fill_State]

Auto_Fill_State - cComDbActiveXControl_

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


cComDbActiveXControl_ [Property Auto_Save_State]

Auto_Save_State - cComDbActiveXControl_

Determines if auto save should be performed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_save_state property is true, rotation from the last object within this object to the first object within this object will cause this object to save. Intended to be set.

Default is false.

Last Edited: January 12, 2006


cComDbActiveXControl_ [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - cComDbActiveXControl_

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


cComDbActiveXControl_ [Property Changed_Value]

Changed_Value - cComDbActiveXControl_

Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object

Type: Property

Access: Write-Only

Data Type: String

Parameters: integer Item# String Val

Parameter | Description
Item# | The item number
Val | The value of the item

Description

The Changed_value message merely changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object.

Last Edited: July 22, 2003


cComDbActiveXControl_ [Property Default_Value]

Default_Value - cComDbActiveXControl_

Changes the value property of Item item# to value, but leaves its item_changed_state unchanged

Type: Property

Access: Write-Only

Data Type: String

Parameters: integer Item# String Val

Parameter | Description
Item# | The item number
Val | The value of the item

Description

The Default_value message changes the value property of Item item# to value, but leaves its item_changed_state unchanged. This is the message for setting default values.

Last Edited: July 31, 2003


cComDbActiveXControl_ [Property Deferred_State]

Deferred_State - cComDbActiveXControl_

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


cComDbActiveXControl_ [Property deo_delegate_mode]

deo_delegate_mode - cComDbActiveXControl_

Controls those requests for which delegate_..._state is set true

Type: Property

Access: Read/Write

Data Type: Integer

Description

Deo_delegate_mode controls those requests for which delegate_..._state is set true. The default delegate_server mode delegates request messages for objects that are not explicitly using a DDO. Delegate_always delegates regardless of whether a server is declared for the object, and delegate_never never delegates. This behavior may be set globally rather than just for this object by setting a function named default_deo_delegate_mode, and may also be queried with get.

Default is delegate_server.

Last Edited: July 31, 2003


cComDbActiveXControl_ [Property Retain_no_Change_state]

Retain_no_Change_state - cComDbActiveXControl_

Determines if the item_changed_state of items have true or false values

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The default for the Retain_no_change_state property true keeps the item_changed_state of items receiving default values false until and unless they are explicitly changed. If your program needs the item_changed_state of such items to be true, you can provide such behavior by setting this property false.

Default is true.

Last Edited: January 12, 2006


cComDbActiveXControl_ [Property Server]

Server - cComDbActiveXControl_

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


cComDbActiveXControl_ [Property Should_Save]

Should_Save - cComDbActiveXControl_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


cComDbActiveXControl_ [Property Validate_All_Items_State]

Validate_All_Items_State - cComDbActiveXControl_

Determines if all items are being validated

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Validate_all_items_state property is set true when all items are validated in one process, as in a save. It is reset false when one or some other subset of all the items are validated, as in navigation between items.

Default is false.

Last Edited: January 12, 2006


cComDbActiveXControl_ [Property Validate_Mode]

Validate_Mode - cComDbActiveXControl_

Determines how and when object validation occurs

Type: Property

Access: Read/Write

Data Type: Integer

Description

The validate_mode property determines how and when object validation occurs.

Default is VALIDATE_ON_SAVE_NEXT.

Valid modes are:

Mode | Description
VALIDATE_DEFAULT | Obsolete (character-mode only)
VALIDATE_ON_SAVE | Validates are only sent during a save
VALIDATE_ON_SAVE_NEXT | Validates are sent during a save and forward keyboard navigation

Last Edited: August 12, 2005


cComDbActiveXControl_ [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - cComDbActiveXControl_

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


cComDbActiveXControl_ [Property Verify_Delete_Msg]

Verify_Delete_Msg - cComDbActiveXControl_

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


cComDbActiveXControl_ [Property verify_exit_msg]

verify_exit_msg - cComDbActiveXControl_

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


cComDbActiveXControl_ [Property Verify_Save_Msg]

Verify_Save_Msg - cComDbActiveXControl_

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


cComDocumentObject [Event OnBeginningOfPanel]

OnBeginningOfPanel - cComDocumentObject

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


cComDocumentObject [Event OnKillFocus]

OnKillFocus - cComDocumentObject

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


cComDocumentObject [Event OnSetFocus]

OnSetFocus - cComDocumentObject

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


cComDocumentObject [Event Prompt_Callback]

Prompt_Callback - cComDocumentObject

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


cComDocumentObject [Event Shadow_Display]

Shadow_Display - cComDocumentObject

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for cComDocumentObject

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfComUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Key | Augmented to implement the GUI keyboard interface | DfComUIObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCreate |  | DfInPlaceComObject
OnKillFocus | Sent whenever the object is about to lose the focus |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |


cComDocumentObject [Function IsComObjectCreated]

IsComObjectCreated - cComDocumentObject

Tests to see if a COM object exists by getting the value of IsComObjectCreated

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

This function returns True, if the COM object has been created indicating that it is safe to access its interface.

Description

You can test to see if a COM object exists by getting the value of IsComObjectCreated.

This is analogous to testing if the pvComObject property is Not Null (created), or Null (released).

Testing IsComObjectCreated is crucial to writing error free COM applications. You should test this value before executing any code that accesses a COM object's interface methods or properties. The exception to this rule is when you access a COM object inside an OnCreate event handler.

See Also

CreateComObject

Last Edited: August 18, 2003


cComDocumentObject [Function Next_Object_Id]

Next_Object_Id - cComDocumentObject

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


cComDocumentObject [Function Prior_Object_Id]

Prior_Object_Id - cComDocumentObject

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for cComDocumentObject

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfComUIObject
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
ComAddref | Procedure |  | DfInPlaceComObject
ComQueryInterface | Function |  | DfInPlaceComObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object | DfInPlaceComObject
CreateComObjectFromFile | Procedure | Creates a new document and initializes it with data read in from the file passed in the sFile parameter | DFComDocumentObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
RegisterComEvent | Procedure |  | DfInPlaceComObject
RegisterPropertyChangeEvent | Procedure |  | DfInPlaceComObject
Release_Mouse_Capture | Procedure |  | DfComUIObject
ReleaseComObject | Procedure | Releases ActiveX control associated with this object | DfInPlaceComObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
SaveToFile | Procedure |  | DFComDocumentObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |


cComDocumentObject [Procedure Activate_Area]

Activate_Area - cComDocumentObject

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cComDocumentObject [Procedure Beginning_of_Panel]

Beginning_of_Panel - cComDocumentObject

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


cComDocumentObject [Procedure Bottom_of_Panel]

Bottom_of_Panel - cComDocumentObject

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


cComDocumentObject [Procedure DoHtmlHelp]

DoHtmlHelp - cComDocumentObject

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


cComDocumentObject [Procedure End_of_Panel]

End_of_Panel - cComDocumentObject

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


cComDocumentObject [Procedure Error_Help]

Error_Help - cComDocumentObject

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComDocumentObject [Procedure Extended_Help]

Extended_Help - cComDocumentObject

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComDocumentObject [Procedure File_Help]

File_Help - cComDocumentObject

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComDocumentObject [Procedure Help]

Help - cComDocumentObject

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


cComDocumentObject [Procedure Help_For_Help]

Help_For_Help - cComDocumentObject

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComDocumentObject [Procedure Help_Index]

Help_Index - cComDocumentObject

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComDocumentObject [Procedure Help_on_topic]

Help_on_topic - cComDocumentObject

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComDocumentObject [Procedure Keys_Help]

Keys_Help - cComDocumentObject

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cComDocumentObject [Procedure Request_Status_Help]

Request_Status_Help - cComDocumentObject

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


cComDocumentObject [Procedure Top_of_Panel]

Top_of_Panel - cComDocumentObject

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for cComDocumentObject

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfComUIObject
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfComUIObject
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfComUIObject
Color | Sets the background color of the object | DfComUIObject
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfComUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfComUIObject
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfComUIObject
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfComUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfComUIObject
peAutoCreate | Manipulates COM Object instantiation | DfInPlaceComObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piMaxSize | Determines the limit of the maximum size that a Component can be | DfComUIObject
piMinSize | Determines the limit of the minimum size that a Component can be | DfComUIObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
psLicenseKey | Contains the license key when ActiveX controls use a run-time license | DfInPlaceComObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfInPlaceComObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfInPlaceComObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Shadow_State | Determines if item is enabled (not shadowed) | DfComUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
TextColor | Sets the text color of the object | DfComUIObject
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfComUIObject
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfComUIObject


cComDocumentObject [Property Enabled_State]

Enabled_State - cComDocumentObject

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


cComDocumentObject [Property Explicit_Shadow_State]

Explicit_Shadow_State - cComDocumentObject

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


cComDocumentObject [Property Help_id]

Help_id - cComDocumentObject

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


cComDocumentObject [Property Help_Keyword]

Help_Keyword - cComDocumentObject

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


cComDocumentObject [Property Item_Shadow_State]

Item_Shadow_State - cComDocumentObject

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


cComDocumentObject [Property Object_Shadow_State]

Object_Shadow_State - cComDocumentObject

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


cComDocumentObject [Property psHtmlHelpTopic]

psHtmlHelpTopic - cComDocumentObject

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


cComDocumentObject [Property Status_Help]

Status_Help - cComDocumentObject

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


cComDocumentObject [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - cComDocumentObject

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


Events for cCommandLine

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cCommandLine [Function Argument]

Argument - cCommandLine

Returns individual arguments from the program's command-line

Type: Function

Return Data Type: String

Parameters: Integer iIndex

Parameter | Description
iIndex | the index of the argument to retrieve

Return Value

The argument as a string with any quote marks removed.

Description

Use this method to retrieve arguments from the command-line by their index. The index is one-based, meaning that the first argument has an index of one; the second has an index of two, and so on.

To obtain the number of arguments that was passed to the program, use the CountOfArgs method.

See Also

CountOfArgs

Last Edited: July 30, 2003


cCommandLine [Function CountOfArgs]

CountOfArgs - cCommandLine

Returns the number of arguments passed to the program

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The number of arguments passed to the program

Description

The CountofArgs function returns the number of arguments passed to the program. You can use the Argument method to retrieve any argument.

See Also

Argument

Last Edited: August 5, 2003


Methods for cCommandLine

View method list in hierarchical order

Name | Type | Description | Defining Class
Argument | Function | Returns individual arguments from the program's command-line |
CountOfArgs | Function | Returns the number of arguments passed to the program |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCommandLine

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phoArgs | Holds the object-handle of the internal array |


cCommandLine [Property phoArgs]

phoArgs - cCommandLine

Holds the object-handle of the internal array

Type: Property

Access: Read/Write

Data Type: Handle

Description

The cCommandLine object uses an array to hold the arguments of the program's command-line. The phoArgs property holds the object-handle to that array.

Note:You will rarely use this approach to accessing the command-line arguments, as the CountOfArgs and Argument methods provide more convenient access

Last Edited: September 11, 2003


cComStdFont [Event OnComFontChanged]

OnComFontChanged - cComStdFont

Type: Event

Parameters: String llPropertyName

Parameter | Description
llPropertyName | [ToDo: In Progress]

Description

Last Edited: June 27, 2003


Events for cComStdFont

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnComFontChanged |  |
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cComStdFont

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cComStdFont

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComBold | Specifies whether the font is bold |
ComCharset | Specifies the character set of the font |
ComItalic | Specifies whether the font is italic |
ComName | Holds the name of the font family |
ComSize | Holds the point size of the font |
ComStrikethrough | Specifies whether the font displays a strikethrough |
ComUnderline | Specifies whether the font is underlined |
ComWeight | Specifies the weight of the font |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cComStdFont [Property ComBold]

ComBold - cComStdFont

Specifies whether the font is bold

Type: Property

Access: Read/Write

Data Type: Boolean

Description

ComBold specifies whether the font is bold.

Last Edited: July 31, 2003


cComStdFont [Property ComCharset]

ComCharset - cComStdFont

Specifies the character set of the font

Type: Property

Access: Read/Write

Data Type: Short

Description

ComCharset specifies the character set of the font. Can be one of the following constants:

  • OLEANSI_CHARSET
  • OLEDEFAULT_CHARSET
  • OLESYMBOL_CHARSET

Last Edited: August 3, 2005


cComStdFont [Property ComItalic]

ComItalic - cComStdFont

Specifies whether the font is italic

Type: Property

Access: Read/Write

Data Type: Boolean

Description

ComItalic specifies whether the font is italic.

Last Edited: July 31, 2003


cComStdFont [Property ComName]

ComName - cComStdFont

Holds the name of the font family

Type: Property

Access: Read/Write

Data Type: String

Description

The ComName property holds the name of the font family, e.g., "Times New Roman".

Last Edited: July 31, 2003


cComStdFont [Property ComSize]

ComSize - cComStdFont

Holds the point size of the font

Type: Property

Access: Read/Write

Data Type: Number

Description

The ComSize property holds the point size of the font. A number value is passed to allow for fractional point sizes.

Last Edited: July 31, 2003


cComStdFont [Property ComStrikethrough]

ComStrikethrough - cComStdFont

Specifies whether the font displays a strikethrough

Type: Property

Access: Read/Write

Data Type: Boolean

Description

ComStrikethrough specifies whether the font displays a strikethrough.

Last Edited: July 31, 2003


cComStdFont [Property ComUnderline]

ComUnderline - cComStdFont

Specifies whether the font is underlined

Type: Property

Access: Read/Write

Data Type: Boolean

Description

ComUnderline specifies whether the font is underlined.

Last Edited: July 31, 2003


cComStdFont [Property ComWeight]

ComWeight - cComStdFont

Specifies the weight of the font

Type: Property

Access: Read/Write

Data Type: Short

Description

ComWeight specifies the weight of the font.

Last Edited: August 3, 2005


Events for cComStdPicture

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cComStdPicture

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
ComRender | Procedure | Draws the specified portion of the picture contained in this cComStdPicture object |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cComStdPicture [Procedure ComRender]

ComRender - cComStdPicture

Draws the specified portion of the picture contained in this cComStdPicture object

Type: Procedure

Parameters: Integer llhdc Integer llx Integer lly Integer llcx Integer llcy OLE_XPOS_HIMETRIC llxSrc OLE_YPOS_HIMETRIC llySrc OLE_XSIZE_HIMETRIC llcxSrc OLE_YSIZE_HIMETRIC llcySrc Variant llprcWBounds

Parameter | Description
llhdc | Handle of device context on which to render the image
llx | Horizontal position of image in LLhdc
lly | Vertical position of image in LLhdc
llcx | Horizontal dimension of destination rectangle
llcy | Vertical dimension of destination rectangle
llxSrc | Horizontal offset in source picture
llySrc | Vertical offset in source picture
llcxSrc | Amount to copy horizontally in source picture
llcySrc | Amount to copy vertically in source picture
llprcWBounds | Pointer to position of destination for a metafile LLhdc

Description

The ComRender procedure draws the specified portion of the picture contained in this cComStdPicture object. The picture is drawn to the device context specified in LLhdc. The portion of the picture to be drawn is specified using the LLxSrc, LLySrc and LLcxSrc, LLcySrc parameters. The position and size to draw the picture in the destination device context is specified using the LLx, LLy and LLcx, LLcy parameters. The LLprcWBounds parameter is only used if LLhdc is a metafile device context, and in which case it should be a pointer to a rectangle containing the position of the destination within the metafile device context.

Last Edited: July 31, 2003


Properties for cComStdPicture

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComHandle | Returns the Windows GDI handle of the picture |
ComHeight | Returns the height of the picture |
ComHPal | Holds the Windows handle of the palette used by the picture |
ComType | Returns the type of picture contained in the picture object |
ComWidth | Returns the width of the picture |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cComStdPicture [Property ComHandle]

ComHandle - cComStdPicture

Returns the Windows GDI handle of the picture

Type: Property

Access: Read-Only

Data Type: OLE_Handle

Description

The ComHandle property returns the Windows GDI handle of the picture.

Last Edited: July 31, 2003


cComStdPicture [Property ComHeight]

ComHeight - cComStdPicture

Returns the height of the picture

Type: Property

Access: Read-Only

Data Type: OLE_YSize_HiMetric

Description

The ComHeight property returns the height of the picture.

Last Edited: July 31, 2003


cComStdPicture [Property ComHPal]

ComHPal - cComStdPicture

Holds the Windows handle of the palette used by the picture

Type: Property

Access: Read/Write

Data Type: OLE_Handle

Description

The ComHPal property holds the Windows handle of the palette used by the picture.

Last Edited: July 31, 2003


cComStdPicture [Property ComType]

ComType - cComStdPicture

Returns the type of picture contained in the picture object

Type: Property

Access: Read-Only

Data Type: Short

Description

The ComType property returns the type of picture contained in the picture object. Can be one of the following constants:

  • OLEPICTYPE_UNINITIALIZED
  • OLEPICTYPE_NONE
  • OLEPICTYPE_BITMAP
  • OLEPICTYPE_METAFILE
  • OLEPICTYPE_ICON
  • OLEPICTYPE_ENHMETAFILE

Last Edited: August 3, 2005


cComStdPicture [Property ComWidth]

ComWidth - cComStdPicture

Returns the width of the picture

Type: Property

Access: Read-Only

Data Type: OLE_XSize_HiMetric

Description

The ComWidth property returns the width of the picture.

Last Edited: July 31, 2003


cCrystal [Event OnDisplayReport]

OnDisplayReport - cCrystal

An event that is called when a report is about to be displayed to the previewer

Type: Event

Parameters: Handle hoReport

Parameter | Description
hoReport | Handle of report object

Description

OnDisplayReport is called when a report is about to be displayed to the previewer. This does nothing by default and is intended for augmentation. The properties of the previewer can be set during this event. To set the COM properties you will need to get the handle by calling ActiveXReportViewerObject.

peOutputDestination determines which output event, OnPrintReport, OnDisplayReport or OnExportReport is called when a report is run.

Object oMyReport is a cCrystal
    Set psReportName To "wines1.rpt"

    Procedure OnDisplayReport Handle hoReport
        Handle hoPreview hoViewer

        Forward Send OnDisplayReport hoReport

        Get PreviewObject of hoReport to hoPreview
        If (hoPreview) Begin
            // Preview Panel
            Set Label of hoPreview to "Sample Report Output"
            // Preview Com Object
            Get ActiveXReportViewerObject of hoReport to hoViewer
            Set ComDisplayToolbar of hoViewer To True
            Set ComDisplayTabs of hoViewer To False
            Set ComDisplayGroupTree of hoViewer To False
            Set ComEnableGroupTree of hoViewer To False
            Set ComEnablePrintButton of hoViewer To True
            Set ComEnableCloseButton of hoViewer To False
            Set ComEnableRefreshButton of hoViewer To False
            Set ComEnableExportButton of hoViewer To True
            Set ComEnableSearchExpertButton of hoViewer To True
            Set ComEnableHelpButton of hoViewer To False
            Set ComEnableZoomControl of hoViewer To True
            Set ComEnableProgressControl of hoViewer To True
            Set ComEnableSearchControl of hoViewer To True
            Set ComEnableNavigationControls of hoViewer To True
            Set ComEnableDrillDown of hoViewer To False
            Set ComEnableAnimationCtrl of hoViewer To True
            Set ComEnableSelectExpertButton of hoViewer To False
            Set ComLaunchHTTPHyperlinksInNewBrowser of hoViewer To True
        End
    End_Procedure // OnDisplayReport
End_Object // oMyReport

See Also

peOutputDestination | RunReport | OnInitializeReport | OnPrintReport | OnExportReport

Last Edited: September 12, 2005


cCrystal [Event onError]

onError - cCrystal

An event that is called when an error occurs during the running of a Crystal report

Type: Event

Parameters: integer ErrNum integer iErrLine string ErrMsg

Parameter | Description
ErrNum | The error number
iErrLine | The error line
ErrMsg | The error message

Description

OnError is sent when an error occurs while running a Crystal Report. This message does nothing by default and is intended for augmentation. This can be used to log errors.

Procedure OnError integer iErrNum integer iErrLine string ErrMsg
    String sName
    Get psReportName to sName
    Send LogReportErrors sName iErrNum iErrLine ErrMsg
End_Procedure // OnError

See Also

pbCancelIfError | pbHasErrors | Display_Error_State | Error

Last Edited: August 16, 2005


cCrystal [Event OnExportReport]

OnExportReport - cCrystal

An event that is called when a report is about to be exported to a file or application

Type: Event

Parameters: Handle hoReport

Parameter | Description
hoReport | Handle of report object

Description

OnExportReport is called when a report is about to be exported to a file or application. This does nothing by default and is intended for augmentation. The properties of the export object can be set during this method. To set the COM properties you will need to get the handle by calling ExportObject.

peOutputDestination determines which output event, OnPrintReport, OnDisplayReport or OnExportReport is called when a report is run.

Sample

Export as a PDF to MAPI

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"
    Set peOutputDestination to PRINT_TO_FILE

    Procedure OnExportReport Handle hoReport
        Handle hoExport

        Set pbExportPrompt of hoReport to FALSE

        Forward Send OnExportReport hoReport

        Get ExportObject of hoReport to hoExport
        If (hoExport) Begin
            Set ComDestinationType  of hoExport To crEDTEMailMAPI
            Set ComMailToListof hoExport to "someoneelse@hotmail.com"
            Set ComMailSubject of hoExport to "Testing"
            Set ComMailMessage of hoExport to "This is a test"
            Set ComMailBccList of hoExport to "someoneelse@hotmail.com"
            Set ComMailUserName of hoExport to "me@hotmail.com"
            Set ComMailPassword of hoExport to "secret"
            Set ComExportFileName of hoExport To "CustomerList.pdf"
            Set ComFormatType of hoExport To crEFTPortableDocFormat // PDF
        End
    End_Procedure // OnExportReport
End_Object // oCrystalReport

Sample

Export as RTF to a file

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"
    Set peOutputDestination to PRINT_TO_FILE

    Procedure OnExportReport Handle hoReport
        Handle hoExport
        Set pbExportPrompt of hoReport to FALSE
        Forward Send OnExportReport hoReport
        Get ExportObject of hoReport to hoExport
        If (hoExport) Begin
            Set ComDiskFileName of hoExport To "D:\Documents\MyReport.rtf"
            Set ComFormatType of hoExport To crEFTExactRichText // Rich Text
        End
    End_Procedure // OnExportReport
End_Object // oCrystalReport

See Also

peOutputDestination | RunReport | OnInitializeReport | OnPrintReport | OnDisplayReport

Last Edited: August 16, 2005


cCrystal [Event OnInitializeReport]

OnInitializeReport - cCrystal

An event provided to initialize a Crystal Report

Type: Event

Parameters: Handle hoReport

Parameter | Description
hoReport | Handle of report

Description

OnInitializeReport is called when a report is run. This event is intended for augmentation and can be used to set formulas, selection criteria, sort orders, etc. This event is triggered after an instance of the report has been successfully created. The connection is made through the cCrystalReport and the handle of this object is passed as an argument of this event.

Object oCrystalReport1 is a cCrystal
    Set psReportName to "CustLst.rpt"

    Procedure OnInitializeReport Handle hoReport
        String sState

        Forward Send OnInitializeReport hoReport

        Get Value of oForm1 to sState
        Get CrystalString sState to sState
        Set ComRecordSelectionFormula of hoReport to ("{Customer.State}="*sState)
    End_Procedure  // OnInitializeReport

End_Object  // oCrystalReport1

See Also

RunReport | OnDisplayReport | OnPrintReport | OnExportReport

Last Edited: August 16, 2005


cCrystal [Event OnPrintReport]

OnPrintReport - cCrystal

An event that is called when a report is about to be printed

Type: Event

Parameters: Handle hoReport

Parameter | Description
hoReport | Handle of report

Description

OnPrintReport is called when a report is about to be printed. This does nothing by default and is intended for augmentation. The printer properties can be set during this method.

peOutputDestination determines which output event, OnPrintReport, OnDisplayReport or OnExportReport is called when a report is run.

Sample

Send report to a predefined printer.

Object oMyReport is a CrystalReport
    Set psReportName To "wines1.rpt"
    Set peOutputDestination of oMyReport to PRINT_TO_PRINTER

    Procedure OnPrintReport Handle hoReport
        Forward Send OnPrintReport hoReport

        Send ComSelectPrinter of hoReport "winspool" "Lexmark 3320" "LPT1:"
        Set ComPaperOrientation of hoReport to crLandscape
        Set ComPaperSize of hoReport to crPaperLetter
    End_Procedure // OnPrintReport
End_Object // oMyReport

Prompt for printer options

Object oMyReport is a CrystalReport
    Set psReportName To "wines1.rpt"
    Set peOutputDestination of oMyReport to PRINT_TO_PRINTER

    Procedure OnPrintReport Handle hoReport
        Forward Send OnPrintReport hoReport

        Set pbPrinterPrompt of hoReport to TRUE
    End_Procedure // OnPrintReport
End_Object // oMyReport

See Also

peOutputDestination | RunReport | OnInitializeReport | OnExportReport | OnDisplayReport

Last Edited: August 16, 2005


Events for cCrystal

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnDisplayReport | An event that is called when a report is about to be displayed to the previewer |
onError | An event that is called when an error occurs during the running of a Crystal report |
OnExportReport | An event that is called when a report is about to be exported to a file or application |
OnInitializeReport | An event provided to initialize a Crystal Report |
OnPrintReport | An event that is called when a report is about to be printed |


cCrystal [Function ApplicationObject]

ApplicationObject - cCrystal

Returns handle of attached COM Application Object

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns handle of attached COM Application Object.

Description

ApplicationObject creates a cCrystalApplication as a global object which is assigned to ghoCrystalReportServer. A zero is returned indicating failure. This can be used to test if the crystal RDC COM objects are installed.

Note:The creation of this object is handled automatically during RunReport.

Last Edited: August 17, 2005


cCrystal [Function CrystalDate]

CrystalDate - cCrystal

Returns a date as a string formatted for Crystal Reports

Type: Function

Return Data Type: String

Parameters: DateTime dtVal

Parameter | Description
dtVal | DateTime value

Return Value

Returns a date as a string formatted for Crystal Reports

Description

Crystal expects a date as an expression (Date(yyyy,mm,dd)). This function returns a string formatted the way Crystal Reports expects to see it.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "Shipments.rpt"

    Procedure OnInitializeReport Handle hoReport
        String sDate

        Forward Send OnInitializeReport hoReport

        Get Value of oDateForm1 to sDate
        Get CrystalDate sDate to sDate
        Set ComRecordSelectionFormula of hoReport to ("{ShipHd.Ship_Date}>"+ sDate)
    End_Procedure // OnInitializeReport

End_Object // oCrystalReport

See Also

CrystalInteger | CrystalNumber | CrystalString

Last Edited: August 12, 2005


cCrystal [Function CrystalInteger]

CrystalInteger - cCrystal

Returns an integer as a string formatted for Crystal Reports

Type: Function

Return Data Type: String

Parameters: Integer iVal

Parameter | Description
iVal | Integer value

Return Value

Returns an integer as a string formatted for Crystal Reports

Description

Crystal expects an integer without any decimals. This function returns a string formatted the way Crystal Reports expects to see it.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "LowStock.rpt"

    Procedure OnInitializeReport Handle hoReport
        String sVal

        Forward Send OnInitializeReport hoReport

        Get Value of oForm1 to sVal
        Get CrystalInteger sVal to sVal
        Set ComRecordSelectionFormula of hoReport to ("{Inventry.Qty_On_Hand}<"+ sVal)
    End_Procedure // OnInitializeReport

End_Object // oCrystalReport

See Also

CrystalDate | CrystalNumber | CrystalString

Last Edited: August 12, 2005


cCrystal [Function CrystalNumber]

CrystalNumber - cCrystal

Returns a number as a string formatted for Crystal Reports

Type: Function

Return Data Type: String

Parameters: Number nVal

Parameter | Description
nVal | Number value

Return Value

Returns a number as a string formatted for Crystal Reports

Description

Crystal expects a number with a decimal This function returns a string formatted the way Crystal Reports expects to see it.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "LowStock.rpt"

    Procedure OnInitializeReport Handle hoReport
        String sVal

        Forward Send OnInitializeReport hoReport

        Get Value of oForm1 to sVal
        Get CrystalNumber sVal to sVal
        Set ComRecordSelectionFormula of hoReport to ("{Inventry.Qty_On_Hand}<"+ CrystalNumber(SVal))
    End_Procedure // OnInitializeReport

End_Object // oCrystalReport

See Also

CrystalInteger | CrystalDate | CrystalString

Last Edited: August 12, 2005


cCrystal [Function CrystalString]

CrystalString - cCrystal

Returns a string as a string formatted for Crystal Reports

Type: Function

Return Data Type: String

Parameters: String sVal

Parameter | Description
sVal | String value

Return Value

Returns a string as a string formatted for Crystal Reports

Description

Crystal expects a string surrounded by quotes. This function returns a string formatted the way Crystal Reports expects to see it. The string is returned with double quotes unless the original string contains a double quote. If the string contains double quotes but not single quotes, then single quotes will be used. If the string contains both single and double quotes, then the string will be split up and appended with "+" so the final result is the same as the original string when Crystal Reports sees it.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "Orders.rpt"

    Procedure OnInitializeReport Handle hoReport
        String sVal

        Forward Send OnInitializeReport hoReport

        Get Value of oForm1 to sVal
        Get CrystalString sVal to sVal
        Set ComRecordSelectionFormula of hoReport to ("{OrderDtl.Desc} = "+ sVal)
    End_Procedure // OnInitializeReport

End_Object // oCrystalReport

See Also

CrystalInteger | CrystalDate | CrystalNumber

Last Edited: August 12, 2005


cCrystal [Function OpenReport]

OpenReport - cCrystal

Used by RunReport to open a Crystal Report. Returns TRUE if it was successful

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns TRUE if successful.

Description

OpenReport is used by RunReport to open a Crystal Report. It returns TRUE if it was successful. This uses psReportName to determine which report is opened. After opening the report, OnInitializeReport is called.

Normally you will not send this message yourself as you will RunReport to open, run and close the report. This method may be used in advanced situations where you wish to control the entire reporting process.

If the report is successfully opened, a report object (cCrystalReport) will be created and can be accessed using the ReportObject function.

If you use this to open a report, you must also close the report by sending the CloseReport method.

Object oCrystalReport1 is a cCrystal
End_Object

Procedure RunSomeReport String sReport
    Boolean bOk
    Set psReportName of oCrystalReport1 to sReport
    Get OpenReport of oCrystalReport1 to bOk
    If bOK begin
        Get ReportObject of oCrystalReport1 to hoReport
        Send ProcessThisReport hoReport
        Send CloseReport of oCrystalReport1
    End
End_procedure

See Also

RunReport | CloseReport | OutputReport | ReportObject

Last Edited: August 16, 2005


cCrystal [Function ReportObject]

ReportObject - cCrystal

Returns handle of attached COM Crystal Report object

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle of attached COM Crystal Report object.

Description

ReportObject returns a handle of attached COM Crystal Report object. This is the object report object created during the OpenReport based on the phcReportObject and passed as an argument of OnInitializeReport, OnPrintReport, OnExportReport, and OnDisplayReport.

Sample

Object oCrystalReport is a cCrystal

    Procedure DoSomething
        Handle hoReport
        Get ReportObject to hoReport
        If (hoReport) Begin
            // : your code here
        End
    End_Procedure // DoSomeThing

    Procedure OnInitializeReport Handle hoReport
        Send DoSomething
        Forward Send OnInitializeReport hoReport
    End_Procedure // OnInitializeReport

End_Object

Last Edited: August 17, 2005


Methods for cCrystal

View method list in hierarchical order

Name | Type | Description | Defining Class
ApplicationObject | Function | Returns handle of attached COM Application Object |
CloseReport | Procedure | Used by RunReport to close a report |
Create | Function | Creates an object based on the passed Class Id | cObject
CrystalDate | Function | Returns a date as a string formatted for Crystal Reports |
CrystalInteger | Function | Returns an integer as a string formatted for Crystal Reports |
CrystalNumber | Function | Returns a number as a string formatted for Crystal Reports |
CrystalString | Function | Returns a string as a string formatted for Crystal Reports |
Destroy | Procedure |  | cObject
DisplayReport | Procedure | Used by RunReport todisplay a report |
Exit_Application | Procedure | Starts the process of closing an application | cObject
ExportReport | Procedure | Used by RunReport to export a report |
OpenReport | Function | Used by RunReport to open a Crystal Report. Returns TRUE if it was successful |
OutputReport | Procedure | Used by Runreport to output a report to the output destination |
PrintReport | Procedure | Used by RunReport to print a report to the printer |
ReportObject | Function | Returns handle of attached COM Crystal Report object |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Run_Report | Procedure | (Obsolete) This method is obsolete and has been replaced by RunReport |
RunReport | Procedure | Main message used to run a Crystal Report |


cCrystal [Procedure CloseReport]

CloseReport - cCrystal

Used by RunReport to close a report

Type: Procedure

Parameters: No Parameters

Description

CloseReport is called by RunReport when a report is complete. It destroys COM objects created during the report.

You will normally not send this message yourself - RunReport does this for you. This would only be used in advanced cases where you run a report using the OpenReport method.

See Also

RunReport | OpenReport | OutputReport

Last Edited: August 16, 2005


cCrystal [Procedure DisplayReport]

DisplayReport - cCrystal

Used by RunReport todisplay a report

Type: Procedure

Parameters: Handle hoReport

Parameter | Description
hoReport | Handle of report

Description

DisplayReport is called as part of the reporting process when a report needs to be displayed. You will rarely send or augment this method.

This method sends the OnDisplayReport event which you can use to change printer options.

See Also

RunReport | OnDisplayReport

Last Edited: August 16, 2005


cCrystal [Procedure ExportReport]

ExportReport - cCrystal

Used by RunReport to export a report

Type: Procedure

Parameters: Handle hoReport

Parameter | Description
hoReport | Handle of report

Description

ExportReport is called as part of the reporting process when a report needs to be exported. You will rarely send or augment this method.

This method sends the OnExportReport event which you can use to change printer options.

See Also

RunReport | OnExportReport

Last Edited: August 16, 2005


cCrystal [Procedure OutputReport]

OutputReport - cCrystal

Used by Runreport to output a report to the output destination

Type: Procedure

Parameters: No Parameters

Description

OutputReport prints the report to the output destination defined by the property peOutputDestination.

RunReport is usually used to open, output and close a report. You will usually never send this message yourself.

See Also

OpenReport | CloseReport

Last Edited: August 16, 2005


cCrystal [Procedure PrintReport]

PrintReport - cCrystal

Used by RunReport to print a report to the printer

Type: Procedure

Parameters: Handle hoReport

Parameter | Description
hoReport | Handle of report

Description

PrintReport is called as part of the reporting process when a report needs to be sent to a printer. You will rarely send or augment this method.

This method sends the OnPrintReport event which you can use to change printer options.

See Also

RunReport | OnPrintReport

Last Edited: August 16, 2005


cCrystal [Procedure Run_Report]

Run_Report - cCrystal

This method is obsolete and has been replaced by RunReport

Type: Procedure

Obsolete

Parameters: No Parameters

Description

This method is obsolete and has been replaced by RunReport.

Last Edited: August 15, 2005


cCrystal [Procedure RunReport]

RunReport - cCrystal

Main message used to run a Crystal Report

Type: Procedure

Parameters: No Parameters

Description

RunReport is the main message used to run a report.

It opens the report based on psReportName.

It directs the report to the appropriate output destination based on peOutputDestination.

It sends the event OnInitializeReport and depending on the output destination, sends the event OnDisplayReport, OnPrintReport or OnExportReport. Upon completion, the report is closed.

Object oCrystalReport is a cCrystal
    Set psReportName to "CustList.rpt"
    Set peOutPutDestination to PRINT_TO_FILE
End_Object // oCrystalReport

Object oButton1 is a Button
    Procedure OnClick
        Send RunReport of oCrystalReport
    End_Procedure // OnClick
End_Object // oButton1

See Also

OnInitializeReport | OnExportReport | OnPrintReport | OnDisplayReport | cCrystalReport | psReportName | peOutputDestination

Last Edited: August 16, 2005


Properties for cCrystal

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Error_State | Determines whether crystal errors will be sent to the error object |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Output_Destination | (Obsolete) This method is obsolete and has been replaced by peOutputDestination. |
Parent | Returns the parent of an object | cObject
pbAutoLocateDFFiles | Determines whether embedded database or INT files are automatically located |
pbCanceled | Stops a report from running |
pbCancelIfError | Determines if a report should be canceled if an error occurs |
pbHasErrors | Is set to TRUE if an error occurred while printing the report |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peOutputDestination | Indicates the destination of the report |
phcExportObject | Controls the class used for the export object |
phcPreviewObject | Controls the class used for the preview object. |
phcReportObject | Controls the class used for the report and subreport objects |
psReportName | The name of the Crystal report to be run when RunReport is received |
Report_Name | (Obsolete) This method is obsolete and has been replaced by psReportName. |


cCrystal [Property Display_Error_State]

Display_Error_State - cCrystal

Determines whether crystal errors will be sent to the error object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Display_Error_State determines whether crystal errors will be sent to the error object. The default is to display all errors which may not be desired if you are running batch reports. Errors will trigger the OnError Event.

See Also

pbCancelIfError | Error | pbHasErrors | OnError

Last Edited: January 12, 2006


cCrystal [Property Output_Destination]

Output_Destination - cCrystal

This method is obsolete and has been replaced by peOutputDestination.

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

This method is obsolete and has been replaced by peOutputDestination.

Last Edited: August 4, 2005


cCrystal [Property pbAutoLocateDFFiles]

pbAutoLocateDFFiles - cCrystal

Determines whether embedded database or INT files are automatically located

Type: Property

Access: Read/Write

Data Type: Boolean

Description

In Crystal Reports, you have the option of setting the table path or indicating that they are located in the same directory as the report. This presents a limitation as to how you create your program directory structure. Some of that limitation is removed when this property is set to TRUE. Helper methods have been added to automatically locate tables used in a report with the same logic used by your program to open those same tables.

Regardless of the table path used in your Crystal Reports report, each table will be located within the workspace's data path and this location will be used. Distribution of your reports has just gotten much simpler now that you don't have to maintain your data file paths in two locations.

You create a new subfolder to your workspace directory for reports only and add this subfolder to your workspace data path. Since reports and tables are all located within the workspace's data path, reports and data can be separated.

Set a report name to be used. The report will be located within the workspace data path.

Object oCrystalReport1 is a cCrystal
    Set psReportName to "CustLst.rpt"
End_Object

Set a report name to be used with the full path. The report will be opened with the path supplied.

Object oCrystalReport1 is a cCrystal
    Set psReportName to "F:\FreightLine\Reports\CustLst.rpt"
End_Object

Simple workspace - Data and reports share the same directory

Data path= .\Data

Modified workspace - Data and reports have a different directory within the main workspace

Data path= .\Data;.\Reports

Semi-Complicated workspace - Data in Data folder and a subfolder, reports have a different
directory within the main workspace

Data path= .\Data;.\Data\Payroll;.\Reports

Complicated workspace - two workspaces sharing some files and some reports. Data and reports
have a different directory within the main workspace.

Workspace1
Data path= \Data\Company1;.\Data\Common;.\Reports\Company_1;.\Reports\Common

Workspace2
Data path= \Data\Company2;.\Data\Common;.\Reports\Company_2;.\Reports\Common

Last Edited: August 4, 2005


cCrystal [Property pbCanceled]

pbCanceled - cCrystal

Stops a report from running

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbCanceled can be set true by the developer within the cCrystal events to stop a report from running. If you need to stop a report before it is run you will set this property to TRUE. This property has no effect once the report has begun generating.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "Overdue.rpt"

    Procedure OnInitializeReport Handle hoReport
        Date dPastDue
        Handle hoCDO
        Variant[][5] vOverDue
        Integer iInvoiceCount

        Forward Send OnInitializeReport hoReport

        Sysdate4 dPastDue
        Subtract 90 from dPastDue // invoices over 90 days old.
        Get CreateCDO of hoReport "Overdue.ttx" to hoCDO
        If (hoCDO) Begin
            Move 0 to iInvoiceCount
            Clear ARHead
            Move "O" to ARHead.Status
            Move dPastDue to ARHead.Invoice_Date
            Find lt ARHead by Index.3
            if (Found) move (ARHead.Status = "O") to Found
            if (Found) move (ARHead.Invoice_Date < dPastDue) to Found
            While (Found)
                Increment iInvoiceCount
                Move ARHead.Cust_Code to Overdue[iInvoiceCount][1]
                Move ARHead.Invoice# to Overdue[iInvoiceCount][2]
                Move ARHead.Invoice_Date to Overdue[iInvoiceCount][3]
                Move ARHead.Orig_Amt to Overdue[iInvoiceCount][4]
                Move ARHead.Balance to Overdue[iInvoiceCount][5]
                Find lt ARHead by Index.3
                if (Found) move (ARHead.Status = "O") to Found
                if (Found) move (ARHead.Invoice_Date < dPastDue) to Found
            Loop

            If (iInvoiceCount=0) Begin
                Send Info_Box "All open invoices are current."
                Set pbCanceled to TRUE
            End
        End
    End_Procedure // OnInitializeReport
End_Object // oCrystalReport

See Also

ComCancelPrinting | pbCancelIfError

Last Edited: June 26, 2006


cCrystal [Property pbCancelIfError]

pbCancelIfError - cCrystal

Determines if a report should be canceled if an error occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbCancelIfError determines if a report should be canceled when an error occurs. If true, the default, and an error is triggered before the report is sent to its output destination, the report will be canceled.

See Also

pbCanceled | pbHasErrors | OnError | Display_Error_State | Error

Last Edited: August 16, 2005


cCrystal [Property pbHasErrors]

pbHasErrors - cCrystal

Is set to TRUE if an error occurred while printing the report

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbHasErrors is set to TRUE if an error occurred during the creation or output of the report. This property should not be set.

See Also

pbCancelIfError | OnError | Display_Error_State | Error

Last Edited: August 16, 2005


cCrystal [Property peOutputDestination]

peOutputDestination - cCrystal

Indicates the destination of the report

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Output_Destination property indicates the destination of the report. You may select a destination from the table below:

Constant | Meaning
PRINT_TO_PRINTER | Print: Print the report to the printer
PRINT_TO_WINDOW | Display: Displays to a preview window
PRINT_TO_FILE | Export: Exports to a disk file in a specified format

peOutputDestination determines which output event, OnPrintReport, OnDisplayReport or OnExportReport is called when a report is run.

See Also

OnDisplayReport | OnExportReport | OnPrintReport

Last Edited: August 16, 2005


cCrystal [Property phcExportObject]

phcExportObject - cCrystal

Controls the class used for the export object

Type: Property

Access: Read/Write

Data Type: Handle

Description

phcExportObject controls the class used for the export object. The default is U_cCrystalExportOptions.

This is an advanced method intended for use when subclassing. Typically, you will create a subclass of cCrystalExportOptions to default export options or to add a some new functionality. To use your class, you will set this property to "U_{yourclassnamehere}".

See Also

RDC Advanced Programming

Last Edited: September 14, 2005


cCrystal [Property phcPreviewObject]

phcPreviewObject - cCrystal

Controls the class used for the preview object.

Type: Property

Access: Read/Write

Data Type: Handle

Description

phcPreviewObject controls the class used for the preview object. The default is U_cCrystalPreview.

This is an advanced method intended for use when subclassing. Typically, you will create a subclass of cCrystalPreview to default preview options or to add a some new functionality. To use your class, you will set this property to "U_{yourclassnamehere}".

See Also

RDC Advanced Programming

Last Edited: September 14, 2005


cCrystal [Property phcReportObject]

phcReportObject - cCrystal

Controls the class used for the report and subreport objects

Type: Property

Access: Read/Write

Data Type: Handle

Description

phcReportObject controls the class used for the report object and subreport objects. The default is U_cCrystalReport.

This is an advanced method intended for use when subclassing. Typically, you will create a subclass of cCrystalReport to default report options or to add a some new functionality. To use your class, you will set this property to "U_{yourclassnamehere}". Subreports are also based on this same property.

See Also

RDC Advanced Programming

Last Edited: September 14, 2005


cCrystal [Property psReportName]

psReportName - cCrystal

The name of the Crystal report to be run when RunReport is received

Type: Property

Access: Read/Write

Data Type: String

Description

psReportName contains the name of the Crystal Reports report to be run when RunReport is received. If just a file name is used, the report will be located in the workspace's data path. If the full path is included, this will be used to open the report.

Sample

Find report in workspace's data path

Object oCustomerReport is a CrystalReport
    Set psReportName to "CustRpt.rpt"
End_Object  // oCustomerReport

Find report in workspace's data path in a subfolder called "backup"

Object oCustomerReport is a CrystalReport
    Set psReportName to "\backup\CustRpt.rpt"
End_Object  // oCustomerReport

Find report in a specific location

Object oCustomerReport is a CrystalReport
    Set psReportName to "G:\VDF\CustRpt.rpt"
End_Object  // oCustomerReport

Last Edited: August 16, 2005


cCrystal [Property Report_Name]

Report_Name - cCrystal

This method is obsolete and has been replaced by psReportName.

Type: Property

Obsolete

Access: Read/Write

Data Type: String

Description

This method is obsolete and has been replaced by psReportName.

Last Edited: August 4, 2005


Events for cCrystal_ICRViewerSelectionEvents

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystal_ICRViewerSelectionEvents

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
ComSelectionStatusUpdate | Procedure |  |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystal_ICRViewerSelectionEvents [Procedure ComSelectionStatusUpdate]

ComSelectionStatusUpdate - cCrystal_ICRViewerSelectionEvents

Type: Procedure

Parameters: UInteger llSelectionHintFlags

Parameter | Description
llSelectionHintFlags | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerSelectionEvents object, refer to the Crystal RDC Report Viewer Object Model documentation. This link will take you to the Crystal Report Designer Component (RDC) Report Viewer/ActiveX Object Model page, which lists all objects and collections in the Crystal RDC Report Viewer. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystal_ICRViewerSelectionEvents

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalActiveXReportViewer [Event OnComChangeObjectRect]

OnComChangeObjectRect - cCrystalActiveXReportViewer

x,y,width,height in document units (twips).

Type: Event

Parameters: Variant llObjectDescription Integer llx Integer lly Integer llwidth Integer llheight

Parameter | Description
llObjectDescription | Please see Crystal RDC documentation for more information.
llx | Please see Crystal RDC documentation for more information.
lly | Please see Crystal RDC documentation for more information.
llwidth | Please see Crystal RDC documentation for more information.
llheight | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComClicked]

OnComClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Integer llx Integer lly Variant llEventInfo Boolean ByRef llUseDefault

Parameter | Description
llx | Please see Crystal RDC documentation for more information.
lly | Please see Crystal RDC documentation for more information.
llEventInfo | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComCloseButtonClicked]

OnComCloseButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Boolean ByRef llUseDefault

Parameter | Description
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComContextMenu]

OnComContextMenu - cCrystalActiveXReportViewer

x,y are screen coordinates. Set UseDefault to false if you want to display your own menu.

Type: Event

Parameters: Variant llObjectDescription Integer llx Integer lly Boolean ByRef llUseDefault

Parameter | Description
llObjectDescription | Please see Crystal RDC documentation for more information.
llx | Please see Crystal RDC documentation for more information.
lly | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComDblClicked]

OnComDblClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Integer llx Integer lly Variant llEventInfo Boolean ByRef llUseDefault

Parameter | Description
llx | Please see Crystal RDC documentation for more information.
lly | Please see Crystal RDC documentation for more information.
llEventInfo | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComDownloadFinished]

OnComDownloadFinished - cCrystalActiveXReportViewer

Type: Event

Parameters: CRLoadingType llloadingType

Parameter | Description
llloadingType | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComDownloadStarted]

OnComDownloadStarted - cCrystalActiveXReportViewer

Type: Event

Parameters: CRLoadingType llloadingType

Parameter | Description
llloadingType | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComDrillOnGraph]

OnComDrillOnGraph - cCrystalActiveXReportViewer

Type: Event

Parameters: Integer llPageNumber Integer llx Integer lly Boolean ByRef llUseDefault

Parameter | Description
llPageNumber | Please see Crystal RDC documentation for more information.
llx | Please see Crystal RDC documentation for more information.
lly | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComDrillOnGroup]

OnComDrillOnGroup - cCrystalActiveXReportViewer

Type: Event

Parameters: Variant llGroupNameList CRDrillType llDrillType Boolean ByRef llUseDefault

Parameter | Description
llGroupNameList | Please see Crystal RDC documentation for more information.
llDrillType | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComDrillOnSubreport]

OnComDrillOnSubreport - cCrystalActiveXReportViewer

Type: Event

Parameters: Variant llGroupNameList String llSubreportName String llTitle Integer llPageNumber Integer llIndex Boolean ByRef llUseDefault

Parameter | Description
llGroupNameList | Please see Crystal RDC documentation for more information.
llSubreportName | Please see Crystal RDC documentation for more information.
llTitle | Please see Crystal RDC documentation for more information.
llPageNumber | Please see Crystal RDC documentation for more information.
llIndex | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComExportButtonClicked]

OnComExportButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Boolean ByRef llUseDefault

Parameter | Description
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComFirstPageButtonClicked]

OnComFirstPageButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Boolean ByRef llUseDefault

Parameter | Description
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComFocusChanged]

OnComFocusChanged - cCrystalActiveXReportViewer

Type: Event

Parameters: Boolean llhasFocus

Parameter | Description
llhasFocus | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComGoToPageNClicked]

OnComGoToPageNClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Boolean ByRef llUseDefault Short llPageNumber

Parameter | Description
ByRef llUseDefault | Please see Crystal RDC documentation for more information.
llPageNumber | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComGroupTreeButtonClicked]

OnComGroupTreeButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Boolean llVisible

Parameter | Description
llVisible | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComHelpButtonClicked]

OnComHelpButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComLastPageButtonClicked]

OnComLastPageButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Boolean ByRef llUseDefault

Parameter | Description
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComLaunchHyperlink]

OnComLaunchHyperlink - cCrystalActiveXReportViewer

Fired before launching a hyperlink. Set UseDefault to False to avoid launching. Change the hyperlink to redirect elsewhere.

Type: Event

Parameters: String ByRef llHyperlink Boolean ByRef llUseDefault

Parameter | Description
ByRef llHyperlink | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 5, 2005


cCrystalActiveXReportViewer [Event OnComNextPageButtonClicked]

OnComNextPageButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Boolean ByRef llUseDefault

Parameter | Description
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComPrevPageButtonClicked]

OnComPrevPageButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Boolean ByRef llUseDefault

Parameter | Description
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComPrintButtonClicked]

OnComPrintButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Boolean ByRef llUseDefault

Parameter | Description
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComRefreshButtonClicked]

OnComRefreshButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Boolean ByRef llUseDefault

Parameter | Description
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComReportSourceError]

OnComReportSourceError - cCrystalActiveXReportViewer

Type: Event

Parameters: String llerrorMsg Integer llerrorCode Boolean ByRef llUseDefault

Parameter | Description
llerrorMsg | Please see Crystal RDC documentation for more information.
llerrorCode | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComSearchButtonClicked]

OnComSearchButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: String llsearchText Boolean ByRef llUseDefault

Parameter | Description
llsearchText | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalActiveXReportViewer [Event OnComSearchExpertButtonClicked]

OnComSearchExpertButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: Boolean ByRef llUseDefault

Parameter | Description
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComSelectionFormulaBuilt]

OnComSelectionFormulaBuilt - cCrystalActiveXReportViewer

Type: Event

Parameters: String llselctionFormula Boolean ByRef llUseDefault

Parameter | Description
llselctionFormula | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComSelectionFormulaButtonClicked]

OnComSelectionFormulaButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: String ByRef llselctionFormula Boolean ByRef llUseDefault

Parameter | Description
ByRef llselctionFormula | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComShowGroup]

OnComShowGroup - cCrystalActiveXReportViewer

Type: Event

Parameters: Variant llGroupNameList Boolean ByRef llUseDefault

Parameter | Description
llGroupNameList | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComStopButtonClicked]

OnComStopButtonClicked - cCrystalActiveXReportViewer

Type: Event

Parameters: CRLoadingType llloadingType Boolean ByRef llUseDefault

Parameter | Description
llloadingType | Please see Crystal RDC documentation for more information.
ByRef llUseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComViewChanged]

OnComViewChanged - cCrystalActiveXReportViewer

Type: Event

Parameters: Integer lloldViewIndex Integer llnewViewIndex

Parameter | Description
lloldViewIndex | Please see Crystal RDC documentation for more information.
llnewViewIndex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComViewChanging]

OnComViewChanging - cCrystalActiveXReportViewer

Type: Event

Parameters: Integer lloldViewIndex Integer llnewViewIndex

Parameter | Description
lloldViewIndex | Please see Crystal RDC documentation for more information.
llnewViewIndex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComViewClosed]

OnComViewClosed - cCrystalActiveXReportViewer

Fired when a view closes

Type: Event

Parameters: Integer llviewIndex

Parameter | Description
llviewIndex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Event OnComZoomLevelChanged]

OnComZoomLevelChanged - cCrystalActiveXReportViewer

Type: Event

Parameters: Short llZoomLevel

Parameter | Description
llZoomLevel | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystal_ICRViewerEvents object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalActiveXReportViewer

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfComUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Key | Augmented to implement the GUI keyboard interface | DfComUIObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | cComActiveXControl
OnChange | Can perform a task each time the ActiveX control's 'binded' property is changed | cComActiveXControl
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnComChangeObjectRect | x,y,width,height in document units (twips). |
OnComClicked |  |
OnComCloseButtonClicked |  |
OnComContextMenu | x,y are screen coordinates. Set UseDefault to false if you want to display your own menu. |
OnComDblClicked |  |
OnComDownloadFinished |  |
OnComDownloadStarted |  |
OnComDrillOnGraph |  |
OnComDrillOnGroup |  |
OnComDrillOnSubreport |  |
OnComExportButtonClicked |  |
OnComFirstPageButtonClicked |  |
OnComFocusChanged |  |
OnComGoToPageNClicked |  |
OnComGroupTreeButtonClicked |  |
OnComHelpButtonClicked |  |
OnComLastPageButtonClicked |  |
OnComLaunchHyperlink | Fired before launching a hyperlink. Set UseDefault to False to avoid launching. Change the hyperlink to redirect elsewhere. |
OnComNextPageButtonClicked |  |
OnComPrevPageButtonClicked |  |
OnComPrintButtonClicked |  |
OnComRefreshButtonClicked |  |
OnComReportSourceError |  |
OnComSearchButtonClicked |  |
OnComSearchExpertButtonClicked |  |
OnComSelectionFormulaBuilt |  |
OnComSelectionFormulaButtonClicked |  |
OnComShowGroup |  |
OnComStopButtonClicked |  |
OnComViewChanged |  |
OnComViewChanging |  |
OnComViewClosed | Fired when a view closes |
OnComZoomLevelChanged |  |
OnCreate | Sent right after a COM object is created | cComActiveXControl
OnKillFocus | Sent whenever the object is about to lose the focus | cComActiveXControl
OnSetFocus | Sent whenever windows is about to give this object the focus | cComActiveXControl
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | cComActiveXControl
Shadow_Display |  | cComActiveXControl


cCrystalActiveXReportViewer [Function ComGetCurrentPageNumber]

ComGetCurrentPageNumber - cCrystalActiveXReportViewer

GetCurrentPageNumber returns the page number of the report being viewed

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Function ComGetGroup]

ComGetGroup - cCrystalActiveXReportViewer

Get the group path of the current view. The the VT type of the VARIANT to control the type of result: VT_ARRAY | VT_I4 or VT_BSTR

Type: Function

Return Data Type: Variant

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Function ComGetViewName]

ComGetViewName - cCrystalActiveXReportViewer

GetViewName returns the current view's tab name and the current report document's name.

Type: Function

Return Data Type: String

Parameters: String ByRef llpTabName

Parameter | Description
ByRef llpTabName | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Function ComGetViewPath]

ComGetViewPath - cCrystalActiveXReportViewer

GetViewPath returns the path to the current view, given the 1-based index number of the view. Path contains a safe array of strings

Type: Function

Return Data Type: Variant

Parameters: Short llIndex

Parameter | Description
llIndex | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalActiveXReportViewer

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | cComActiveXControl
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfComUIObject
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | cComActiveXControl
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | cComActiveXControl
Cancel | Procedure | Returns the message_id of itself | cUIObject
ComActivateView | Procedure | ActivateView activates a particular view by 1-based index |
ComAddref | Procedure |  | DfInPlaceComObject
ComAddView | Procedure | AddView adds a new view (tab). GroupPath can be a colon-delimited string (Country:State:City), a safe array of strings (Country, State, City), or a safe array of longs (1, 2, 0). |
ComCloseView | Procedure | CloseView closes the view, given the 1-based index number of the view. S_FALSE is returned if the user was prompted to close drill-down or subreport views and elected not to proceed. |
ComGetCurrentPageNumber | Function | GetCurrentPageNumber returns the page number of the report being viewed |
ComGetGroup | Function | Get the group path of the current view. The the VT type of the VARIANT to control the type of result: VT_ARRAY | VT_I4 or VT_BSTR |
ComGetLastPageNumber | Procedure | Get the last page number. The last page number may not have been calculated so it may not be known. For Visual Basic, a Long and a Boolean should be passed, Procedure style. |
ComGetViewName | Function | GetViewName returns the current view's tab name and the current report document's name. |
ComGetViewPath | Function | GetViewPath returns the path to the current view, given the 1-based index number of the view. Path contains a safe array of strings |
ComPrintReport | Procedure | PrintReport initiates printing of the report in the current view |
ComQueryInterface | Function |  | DfInPlaceComObject
ComRefresh | Procedure | Refresh causes the view information to be reloaded and displayed |
ComRefreshEx | Procedure | Refresh the report, optionally causing the server to refresh its data |
ComSearchByFormula | Procedure | Search using the search formula. Search UI is shown if formula is empty. |
ComSearchForText | Procedure | SearchForText allows searching for text across pages of the current view |
ComShowFirstPage | Procedure | ShowFirstPage shows the first page of the current view |
ComShowGroup | Procedure | ShowGroup displays the indicated group in the current view. GroupPath can be a colon-delimited string (Country:State:City), a safe array of strings (Country, State, City), or a safe array of longs (1, 2, 0). |
ComShowLastPage | Procedure | ShowLastPage shows the last page of the current view |
ComShowNextPage | Procedure | ShowNextPage shows the next page of the current view |
ComShowNthPage | Procedure | ShowNthPage shows the desired page of the current view |
ComShowPreviousPage | Procedure | ShowPreviousPage shows the previous page of the current view |
ComViewReport | Procedure | ViewReport |
ComZoom | Procedure | Zoom changes the display of the report. All numbers are percentages except: 1 - fit width, 2 - fit page |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object | DfInPlaceComObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | cComActiveXControl
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | cComActiveXControl
Error_Help | Procedure | (Obsolete) | cComActiveXControl
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | cComActiveXControl
File_Help | Procedure | (Obsolete) | cComActiveXControl
Help | Procedure |  | cComActiveXControl
Help_For_Help | Procedure | (Obsolete) | cComActiveXControl
Help_Index | Procedure | (Obsolete) | cComActiveXControl
Help_on_topic | Procedure | (Obsolete) | cComActiveXControl
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComActiveXControl
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | cComActiveXControl
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cComActiveXControl
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cComActiveXControl
RegisterComEvent | Procedure |  | DfInPlaceComObject
RegisterPropertyChangeEvent | Procedure |  | DfInPlaceComObject
Release_Mouse_Capture | Procedure |  | DfComUIObject
ReleaseComObject | Procedure | Releases ActiveX control associated with this object | DfInPlaceComObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | cComActiveXControl
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | cComActiveXControl


cCrystalActiveXReportViewer [Procedure ComActivateView]

ComActivateView - cCrystalActiveXReportViewer

ActivateView activates a particular view by 1-based index

Type: Procedure

Parameters: Variant llIndex

Parameter | Description
llIndex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComAddView]

ComAddView - cCrystalActiveXReportViewer

AddView adds a new view (tab). GroupPath can be a colon-delimited string (Country:State:City), a safe array of strings (Country, State, City), or a safe array of longs (1, 2, 0).

Type: Procedure

Parameters: Variant llGroupPath

Parameter | Description
llGroupPath | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComCloseView]

ComCloseView - cCrystalActiveXReportViewer

CloseView closes the view, given the 1-based index number of the view. S_FALSE is returned if the user was prompted to close drill-down or subreport views and elected not to proceed.

Type: Procedure

Parameters: Variant llIndex

Parameter | Description
llIndex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComGetLastPageNumber]

ComGetLastPageNumber - cCrystalActiveXReportViewer

Get the last page number. The last page number may not have been calculated so it may not be known. For Visual Basic, a Long and a Boolean should be passed, Procedure style.

Type: Procedure

Parameters: Integer ByRef llpageN Boolean ByRef lllastPageKnown

Parameter | Description
ByRef llpageN | Please see Crystal RDC documentation for more information.
ByRef lllastPageKnown | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComPrintReport]

ComPrintReport - cCrystalActiveXReportViewer

PrintReport initiates printing of the report in the current view

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComRefresh]

ComRefresh - cCrystalActiveXReportViewer

Refresh causes the view information to be reloaded and displayed

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComRefreshEx]

ComRefreshEx - cCrystalActiveXReportViewer

Refresh the report, optionally causing the server to refresh its data

Type: Procedure

Parameters: Boolean llrefreshServerData

Parameter | Description
llrefreshServerData | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComSearchByFormula]

ComSearchByFormula - cCrystalActiveXReportViewer

Search using the search formula. Search UI is shown if formula is empty.

Type: Procedure

Parameters: String llformula

Parameter | Description
llformula | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComSearchForText]

ComSearchForText - cCrystalActiveXReportViewer

SearchForText allows searching for text across pages of the current view

Type: Procedure

Parameters: String llText

Parameter | Description
llText | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComShowFirstPage]

ComShowFirstPage - cCrystalActiveXReportViewer

ShowFirstPage shows the first page of the current view

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComShowGroup]

ComShowGroup - cCrystalActiveXReportViewer

ShowGroup displays the indicated group in the current view. GroupPath can be a colon-delimited string (Country:State:City), a safe array of strings (Country, State, City), or a safe array of longs (1, 2, 0).

Type: Procedure

Parameters: Variant llGroupPath

Parameter | Description
llGroupPath | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComShowLastPage]

ComShowLastPage - cCrystalActiveXReportViewer

ShowLastPage shows the last page of the current view

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComShowNextPage]

ComShowNextPage - cCrystalActiveXReportViewer

ShowNextPage shows the next page of the current view

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComShowNthPage]

ComShowNthPage - cCrystalActiveXReportViewer

ShowNthPage shows the desired page of the current view

Type: Procedure

Parameters: Short llPageNumber

Parameter | Description
llPageNumber | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComShowPreviousPage]

ComShowPreviousPage - cCrystalActiveXReportViewer

ShowPreviousPage shows the previous page of the current view

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComViewReport]

ComViewReport - cCrystalActiveXReportViewer

ViewReport

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Procedure ComZoom]

ComZoom - cCrystalActiveXReportViewer

Zoom changes the display of the report. All numbers are percentages except: 1 - fit width, 2 - fit page

Type: Procedure

Parameters: Short llZoomLevel

Parameter | Description
llZoomLevel | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalActiveXReportViewer

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfComUIObject
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfComUIObject
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfComUIObject
Color | Sets the background color of the object | DfComUIObject
ComActiveViewIndex | ActiveViewIndex returns the 1-based index of the current view (tab) |
ComDisplayBackgroundEdge | Determines if the report is offset from the edge of its view window. |
ComDisplayBorder | DisplayBorder indicates if the viewer has a border |
ComDisplayGroupTree | Determine if the group tree is visible |
ComDisplayTabs | DisplayTabs indicates if the viewer has tabs for navigation between views |
ComDisplayToolbar | Determine if the toolbar is visible |
ComEnableAnimationCtrl | Determine if the animation control is visible |
ComEnableCloseButton | Determine if the close button is visible |
ComEnableDrillDown | Deterimine if drill down is allowed |
ComEnableExportButton | Status of the Export toolbar button |
ComEnableGroupTree | Determine if the group tree is available |
ComEnableHelpButton | Enable the help button on the toolbar |
ComEnableNavigationControls | Determines if the viewer has navigation controls |
ComEnablePopupMenu | Determine if the pop menu is available |
ComEnablePrintButton | Determine if the print button is visible |
ComEnableProgressControl | Determine if the progress control will be shown |
ComEnableRefreshButton | Determine if the Refresh button is visible |
ComEnableSearchControl | Determine if the search control is visible |
ComEnableSearchExpertButton | Status of the Search Expert toolbar button |
ComEnableSelectExpertButton | Determine if the Select Expert button is showing |
ComEnableStopButton | Determines if the viewer has a stop button |
ComEnableToolbar | EnableToolbar indicates if the viewer has a toolbar (shown or hidden) |
ComEnableZoomControl | Determine if the zoom control is visible |
ComIsBusy | IsBusy indicates if the control is busy. |
ComLaunchHTTPHyperlinksInNewBrowser | Launch HTTP Hyperlinks in a new browser |
ComLocaleID | Get the locale ID |
ComReportSource | Get the report source |
ComTrackCursorInfo | Get the TrackCursorInfo object |
ComViewCount | ViewCount returns the current number of views (tabs) |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfComUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
ControlValue | Used as a hook to link a property in the ActiveX control with the Value Property | cComActiveXControl
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | cComActiveXControl
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | cComActiveXControl
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfComUIObject
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfComUIObject
Help_id | Used to specify an object's context ID | cComActiveXControl
Help_Keyword | Used to specify an object's context keyword | cComActiveXControl
Item_Changed_State |  | cComActiveXControl
Item_Count |  | cComActiveXControl
Item_Shadow_State | Determines if an object's item is enabled or disabled | cComActiveXControl
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | cComActiveXControl
Label_Col_Offset | The horizontal distance from the object to its label | cComActiveXControl
Label_Justification_Mode | The justification mode for the text within this object's label | cComActiveXControl
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | cComActiveXControl
Label_Row_Offset | The vertical distance from the top edge of the object and its label | cComActiveXControl
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfComUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | cComActiveXControl
Parent | Returns the parent of an object | cObject
pbBindValue | Controls whether an ActiveX's bindable property is bound to the Value property | cComActiveXControl
peAnchors | Describes how you want the control to react whenever its container changes size | DfComUIObject
peAutoCreate | Manipulates COM Object instantiation | DfInPlaceComObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piMaxSize | Determines the limit of the maximum size that a Component can be | DfComUIObject
piMinSize | Determines the limit of the minimum size that a Component can be | DfComUIObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | cComActiveXControl
psLicenseKey | Contains the license key when ActiveX controls use a run-time license | DfInPlaceComObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfInPlaceComObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfInPlaceComObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Shadow_State | Determines if item is enabled (not shadowed) | DfComUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | cComActiveXControl
TextColor | Sets the text color of the object | DfComUIObject
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | cComActiveXControl
Value |  | cComActiveXControl
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfComUIObject
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfComUIObject


cCrystalActiveXReportViewer [Property ComActiveViewIndex]

ComActiveViewIndex - cCrystalActiveXReportViewer

ActiveViewIndex returns the 1-based index of the current view (tab)

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalActiveXReportViewer [Property ComDisplayBackgroundEdge]

ComDisplayBackgroundEdge - cCrystalActiveXReportViewer

Determines if the report is offset from the edge of its view window.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComDisplayBorder]

ComDisplayBorder - cCrystalActiveXReportViewer

DisplayBorder indicates if the viewer has a border

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComDisplayGroupTree]

ComDisplayGroupTree - cCrystalActiveXReportViewer

Determine if the group tree is visible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComDisplayTabs]

ComDisplayTabs - cCrystalActiveXReportViewer

DisplayTabs indicates if the viewer has tabs for navigation between views

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComDisplayToolbar]

ComDisplayToolbar - cCrystalActiveXReportViewer

Determine if the toolbar is visible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableAnimationCtrl]

ComEnableAnimationCtrl - cCrystalActiveXReportViewer

Determine if the animation control is visible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableCloseButton]

ComEnableCloseButton - cCrystalActiveXReportViewer

Determine if the close button is visible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableDrillDown]

ComEnableDrillDown - cCrystalActiveXReportViewer

Deterimine if drill down is allowed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableExportButton]

ComEnableExportButton - cCrystalActiveXReportViewer

Status of the Export toolbar button

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableGroupTree]

ComEnableGroupTree - cCrystalActiveXReportViewer

Determine if the group tree is available

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableHelpButton]

ComEnableHelpButton - cCrystalActiveXReportViewer

Enable the help button on the toolbar

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableNavigationControls]

ComEnableNavigationControls - cCrystalActiveXReportViewer

Determines if the viewer has navigation controls

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnablePopupMenu]

ComEnablePopupMenu - cCrystalActiveXReportViewer

Determine if the pop menu is available

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnablePrintButton]

ComEnablePrintButton - cCrystalActiveXReportViewer

Determine if the print button is visible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableProgressControl]

ComEnableProgressControl - cCrystalActiveXReportViewer

Determine if the progress control will be shown

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableRefreshButton]

ComEnableRefreshButton - cCrystalActiveXReportViewer

Determine if the Refresh button is visible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableSearchControl]

ComEnableSearchControl - cCrystalActiveXReportViewer

Determine if the search control is visible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableSearchExpertButton]

ComEnableSearchExpertButton - cCrystalActiveXReportViewer

Status of the Search Expert toolbar button

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableSelectExpertButton]

ComEnableSelectExpertButton - cCrystalActiveXReportViewer

Determine if the Select Expert button is showing

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableStopButton]

ComEnableStopButton - cCrystalActiveXReportViewer

Determines if the viewer has a stop button

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableToolbar]

ComEnableToolbar - cCrystalActiveXReportViewer

EnableToolbar indicates if the viewer has a toolbar (shown or hidden)

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComEnableZoomControl]

ComEnableZoomControl - cCrystalActiveXReportViewer

Determine if the zoom control is visible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComIsBusy]

ComIsBusy - cCrystalActiveXReportViewer

IsBusy indicates if the control is busy.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComLaunchHTTPHyperlinksInNewBrowser]

ComLaunchHTTPHyperlinksInNewBrowser - cCrystalActiveXReportViewer

Launch HTTP Hyperlinks in a new browser

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComLocaleID]

ComLocaleID - cCrystalActiveXReportViewer

Get the locale ID

Type: Property

Access: Read/Write

Data Type: UInteger

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComReportSource]

ComReportSource - cCrystalActiveXReportViewer

Get the report source

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComTrackCursorInfo]

ComTrackCursorInfo - cCrystalActiveXReportViewer

Get the TrackCursorInfo object

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalActiveXReportViewer [Property ComViewCount]

ComViewCount - cCrystalActiveXReportViewer

ViewCount returns the current number of views (tabs)

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewer11 object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalApplication

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalApplication [Function ComCanClose]

ComCanClose - cCrystalApplication

Returns whether it is safe to quit the application.

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIApplication object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalApplication [Function ComGetVersion]

ComGetVersion - cCrystalApplication

Gets version number.

Type: Function

Return Data Type: Short

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIApplication object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalApplication [Function ComNewReport]

ComNewReport - cCrystalApplication

Creates an empty report.

Type: Function

Return Data Type: Variant

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIApplication object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalApplication [Function ComOpenReport]

ComOpenReport - cCrystalApplication

Opens a specified report.

Type: Function

Return Data Type: Variant

Parameters: String llpFileName Variant llOpenMethod

Parameter | Description
llpFileName | Please see Crystal RDC documentation for more information.
llOpenMethod | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIApplication object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalApplication

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComCanClose | Function | Returns whether it is safe to quit the application. |
ComGetVersion | Function | Gets version number. |
ComLogOffServer | Procedure | Log off server. |
ComLogOnServer | Procedure | Log on server. |
ComLogOnServerEx | Procedure | Log on server with server type or connect info. |
ComNewReport | Function | Creates an empty report. |
ComOpenReport | Function | Opens a specified report. |
ComQueryInterface | Function |  | DfComAutomationObject
ComRunReportWizard | Procedure | Creates a report with the Report Wizard. |
ComSetMatchLogOnInfo | Procedure | Sets global match log on info option. |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalApplication [Procedure ComLogOffServer]

ComLogOffServer - cCrystalApplication

Log off server.

Type: Procedure

Parameters: String llpDllName String llpServerName Variant llpDatabaseName Variant llpUserID Variant llpPassword

Parameter | Description
llpDllName | Please see Crystal RDC documentation for more information.
llpServerName | Please see Crystal RDC documentation for more information.
llpDatabaseName | Please see Crystal RDC documentation for more information.
llpUserID | Please see Crystal RDC documentation for more information.
llpPassword | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIApplication object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalApplication [Procedure ComLogOnServer]

ComLogOnServer - cCrystalApplication

Log on server.

Type: Procedure

Parameters: String llpDllName String llpServerName Variant llpDatabaseName Variant llpUserID Variant llpPassword

Parameter | Description
llpDllName | Please see Crystal RDC documentation for more information.
llpServerName | Please see Crystal RDC documentation for more information.
llpDatabaseName | Please see Crystal RDC documentation for more information.
llpUserID | Please see Crystal RDC documentation for more information.
llpPassword | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIApplication object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalApplication [Procedure ComLogOnServerEx]

ComLogOnServerEx - cCrystalApplication

Log on server with server type or connect info.

Type: Procedure

Parameters: String llpDllName String llpServerName Variant llpDatabaseName Variant llpUserID Variant llpPassword Variant llpServerType Variant llpConnectionString

Parameter | Description
llpDllName | Please see Crystal RDC documentation for more information.
llpServerName | Please see Crystal RDC documentation for more information.
llpDatabaseName | Please see Crystal RDC documentation for more information.
llpUserID | Please see Crystal RDC documentation for more information.
llpPassword | Please see Crystal RDC documentation for more information.
llpServerType | Please see Crystal RDC documentation for more information.
llpConnectionString | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIApplication object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalApplication [Procedure ComRunReportWizard]

ComRunReportWizard - cCrystalApplication

Creates a report with the Report Wizard.

Type: Procedure

Parameters: Variant llpReport Variant lldataSource

Parameter | Description
llpReport | Please see Crystal RDC documentation for more information.
lldataSource | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIApplication object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalApplication [Procedure ComSetMatchLogOnInfo]

ComSetMatchLogOnInfo - cCrystalApplication

Sets global match log on info option.

Type: Procedure

Parameters: Boolean llbl

Parameter | Description
llbl | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIApplication object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalApplication

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


Events for cCrystalArea

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalArea

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
ComSetInstanceIDField | Procedure | Sets instance ID field. |
ComSetParentIDField | Procedure | Sets parent ID field. |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalArea [Procedure ComSetInstanceIDField]

ComSetInstanceIDField - cCrystalArea

Sets instance ID field.

Type: Procedure

Parameters: Variant llInstanceIDField

Parameter | Description
llInstanceIDField | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Procedure ComSetParentIDField]

ComSetParentIDField - cCrystalArea

Sets parent ID field.

Type: Procedure

Parameters: Variant llParentIDField

Parameter | Description
llParentIDField | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalArea

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComConditionFormula | Gets or sets section conditional formula. |
ComCopiesToPrint | Gets or sets number of copy instance to print. |
ComDetailHeight | Gets mailling label report detail area height (Twips). |
ComDetailWidth | Gets multilple column report detail area width (Twips). |
ComDiscardOtherGroups | Gets or sets discard other groups option. |
ComEnableHierarchicalGroupSorting | Gets or sets group hierarchically flag. |
ComGroupCondition | Gets or sets group condition. |
ComGroupConditionField | Gets or sets group condition field. |
ComGroupIndent | Gets or sets group indent (twips). |
ComGroupNumber | Gets group number for this area if it is a group area. |
ComHideForDrillDown | Gets or sets hide for drill down option. |
ComHorizontalGap | Gets multiple column report horizontal gaps going across page. |
ComInstanceIDField | Gets instance ID field. |
ComKeepGroupTogether | Gets or sets keeping group together option. |
ComKeepTogether | Gets or sets keeping area together option. |
ComKind | Gets area kind. |
ComName | Gets or sets area name. |
ComNewPageAfter | Gets or sets new page after option. |
ComNewPageBefore | Gets or sets new page before option. |
ComNumberOfTopOrBottomNGroups | Gets or sets number of top or bottom groups |
ComParent | Gets parent object(Report). |
ComParentIDField | Gets parent ID field. |
ComPrintAtBottomOfPage | Gets or sets printing at bottom of page option. |
ComRepeatGroupHeader | Gets or sets repeating group header option. |
ComResetPageNumberAfter | Gets or sets reset page number after option. |
ComSections | Gets section collection within the area. |
ComSortDirection | Gets or sets group sort direction. |
ComSpecifiedGroups | Gets or sets the specifed groups |
ComSuppress | Gets or sets area visibility. |
ComTopOrBottomNGroupSortOrder | Gets or set top or bottom n group sort order |
ComTopOrBottomNSortField | Gets or sets top or bottom n sort field. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalArea [Property ComConditionFormula]

ComConditionFormula - cCrystalArea

Gets or sets section conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaName String value

Parameter | Description
llFormulaName | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComCopiesToPrint]

ComCopiesToPrint - cCrystalArea

Gets or sets number of copy instance to print.

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalArea [Property ComDetailHeight]

ComDetailHeight - cCrystalArea

Gets mailling label report detail area height (Twips).

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComDetailWidth]

ComDetailWidth - cCrystalArea

Gets multilple column report detail area width (Twips).

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComDiscardOtherGroups]

ComDiscardOtherGroups - cCrystalArea

Gets or sets discard other groups option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComEnableHierarchicalGroupSorting]

ComEnableHierarchicalGroupSorting - cCrystalArea

Gets or sets group hierarchically flag.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComGroupCondition]

ComGroupCondition - cCrystalArea

Gets or sets group condition.

Type: Property

Access: Read/Write

Data Type: CRGroupCondition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalArea [Property ComGroupConditionField]

ComGroupConditionField - cCrystalArea

Gets or sets group condition field.

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComGroupIndent]

ComGroupIndent - cCrystalArea

Gets or sets group indent (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComGroupNumber]

ComGroupNumber - cCrystalArea

Gets group number for this area if it is a group area.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalArea [Property ComHideForDrillDown]

ComHideForDrillDown - cCrystalArea

Gets or sets hide for drill down option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComHorizontalGap]

ComHorizontalGap - cCrystalArea

Gets multiple column report horizontal gaps going across page.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComInstanceIDField]

ComInstanceIDField - cCrystalArea

Gets instance ID field.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComKeepGroupTogether]

ComKeepGroupTogether - cCrystalArea

Gets or sets keeping group together option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComKeepTogether]

ComKeepTogether - cCrystalArea

Gets or sets keeping area together option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComKind]

ComKind - cCrystalArea

Gets area kind.

Type: Property

Access: Read-Only

Data Type: CRAreaKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalArea [Property ComName]

ComName - cCrystalArea

Gets or sets area name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComNewPageAfter]

ComNewPageAfter - cCrystalArea

Gets or sets new page after option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComNewPageBefore]

ComNewPageBefore - cCrystalArea

Gets or sets new page before option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComNumberOfTopOrBottomNGroups]

ComNumberOfTopOrBottomNGroups - cCrystalArea

Gets or sets number of top or bottom groups

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalArea [Property ComParent]

ComParent - cCrystalArea

Gets parent object(Report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComParentIDField]

ComParentIDField - cCrystalArea

Gets parent ID field.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComPrintAtBottomOfPage]

ComPrintAtBottomOfPage - cCrystalArea

Gets or sets printing at bottom of page option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComRepeatGroupHeader]

ComRepeatGroupHeader - cCrystalArea

Gets or sets repeating group header option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComResetPageNumberAfter]

ComResetPageNumberAfter - cCrystalArea

Gets or sets reset page number after option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComSections]

ComSections - cCrystalArea

Gets section collection within the area.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComSortDirection]

ComSortDirection - cCrystalArea

Gets or sets group sort direction.

Type: Property

Access: Read/Write

Data Type: CRSortDirection

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalArea [Property ComSpecifiedGroups]

ComSpecifiedGroups - cCrystalArea

Gets or sets the specifed groups

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComSuppress]

ComSuppress - cCrystalArea

Gets or sets area visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalArea [Property ComTopOrBottomNGroupSortOrder]

ComTopOrBottomNGroupSortOrder - cCrystalArea

Gets or set top or bottom n group sort order

Type: Property

Access: Read/Write

Data Type: CRTopBottomNGroupSortOrder

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalArea [Property ComTopOrBottomNSortField]

ComTopOrBottomNSortField - cCrystalArea

Gets or sets top or bottom n sort field.

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIArea object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalAreas

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalAreas

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalAreas

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets areas parent.(report) |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalAreas [Property Com_NewEnum]

Com_NewEnum - cCrystalAreas

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIAreas object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalAreas [Property ComCount]

ComCount - cCrystalAreas

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIAreas object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalAreas [Property ComItem]

ComItem - cCrystalAreas

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Variant llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIAreas object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalAreas [Property ComParent]

ComParent - cCrystalAreas

Gets areas parent.(report)

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIAreas object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalBlobFieldObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalBlobFieldObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalBlobFieldObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComBackColor | Gets or sets object background color. |
ComBorderColor | Gets or sets object border color. |
ComBottomCropping | Gets or sets bottom cropping size (twips). |
ComBottomLineStyle | Gets or sets bottom line style. |
ComCloseAtPageBreak | Gets or sets close border on page break. |
ComConditionFormula | Gets or sets conditional formula. |
ComCssClass | Gets or sets CSS class. |
ComField | Gets database field. |
ComHasDropShadow | Gets or sets border drop shadow. |
ComHeight | Gets or sets object height (twips). |
ComHyperlinkText | Gets or sets hyperlink text. |
ComHyperlinkType | Gets or sets hyperlink type. |
ComKeepTogether | Gets or sets keep object together. |
ComKind | Gets report object kind. |
ComLeft | Gets or sets object upper left position (twips). |
ComLeftCropping | Gets or sets left cropping size (twips). |
ComLeftLineStyle | Gets or sets left line style. |
ComName | Gets or sets object name. |
ComParent | Gets object parent (Section). |
ComRightCropping | Gets or sets right cropping size (twips). |
ComRightLineStyle | Gets or sets right line style. |
ComSuppress | Gets or sets object visibility. |
ComTop | Gets or sets object upper top position (twips). |
ComTopCropping | Gets or sets top cropping size (twips). |
ComTopLineStyle | Gets or sets top line style. |
ComWidth | Gets or sets object width (twips). |
ComXScaling | Gets or sets width scaling factor. E.g. 1 means 100%, 2 means 200%, 0.5 means 50%, etc. Range from 0.01 to 100. |
ComYScaling | Gets or sets height scaling factor. E.g. 1 means 100%, 2 means 200%, 0.5 means 50%, etc. Range from 0.01 to 100. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalBlobFieldObject [Property ComBackColor]

ComBackColor - cCrystalBlobFieldObject

Gets or sets object background color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComBorderColor]

ComBorderColor - cCrystalBlobFieldObject

Gets or sets object border color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComBottomCropping]

ComBottomCropping - cCrystalBlobFieldObject

Gets or sets bottom cropping size (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComBottomLineStyle]

ComBottomLineStyle - cCrystalBlobFieldObject

Gets or sets bottom line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalBlobFieldObject [Property ComCloseAtPageBreak]

ComCloseAtPageBreak - cCrystalBlobFieldObject

Gets or sets close border on page break.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComConditionFormula]

ComConditionFormula - cCrystalBlobFieldObject

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaType String value

Parameter | Description
llFormulaType | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComCssClass]

ComCssClass - cCrystalBlobFieldObject

Gets or sets CSS class.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComField]

ComField - cCrystalBlobFieldObject

Gets database field.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComHasDropShadow]

ComHasDropShadow - cCrystalBlobFieldObject

Gets or sets border drop shadow.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComHeight]

ComHeight - cCrystalBlobFieldObject

Gets or sets object height (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComHyperlinkText]

ComHyperlinkText - cCrystalBlobFieldObject

Gets or sets hyperlink text.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComHyperlinkType]

ComHyperlinkType - cCrystalBlobFieldObject

Gets or sets hyperlink type.

Type: Property

Access: Read/Write

Data Type: CRHyperlinkType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalBlobFieldObject [Property ComKeepTogether]

ComKeepTogether - cCrystalBlobFieldObject

Gets or sets keep object together.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComKind]

ComKind - cCrystalBlobFieldObject

Gets report object kind.

Type: Property

Access: Read-Only

Data Type: CRObjectKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalBlobFieldObject [Property ComLeft]

ComLeft - cCrystalBlobFieldObject

Gets or sets object upper left position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComLeftCropping]

ComLeftCropping - cCrystalBlobFieldObject

Gets or sets left cropping size (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComLeftLineStyle]

ComLeftLineStyle - cCrystalBlobFieldObject

Gets or sets left line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalBlobFieldObject [Property ComName]

ComName - cCrystalBlobFieldObject

Gets or sets object name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComParent]

ComParent - cCrystalBlobFieldObject

Gets object parent (Section).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComRightCropping]

ComRightCropping - cCrystalBlobFieldObject

Gets or sets right cropping size (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComRightLineStyle]

ComRightLineStyle - cCrystalBlobFieldObject

Gets or sets right line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalBlobFieldObject [Property ComSuppress]

ComSuppress - cCrystalBlobFieldObject

Gets or sets object visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComTop]

ComTop - cCrystalBlobFieldObject

Gets or sets object upper top position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComTopCropping]

ComTopCropping - cCrystalBlobFieldObject

Gets or sets top cropping size (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComTopLineStyle]

ComTopLineStyle - cCrystalBlobFieldObject

Gets or sets top line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalBlobFieldObject [Property ComWidth]

ComWidth - cCrystalBlobFieldObject

Gets or sets object width (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComXScaling]

ComXScaling - cCrystalBlobFieldObject

Gets or sets width scaling factor. E.g. 1 means 100%, 2 means 200%, 0.5 means 50%, etc. Range from 0.01 to 100.

Type: Property

Access: Read/Write

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBlobFieldObject [Property ComYScaling]

ComYScaling - cCrystalBlobFieldObject

Gets or sets height scaling factor. E.g. 1 means 100%, 2 means 200%, 0.5 means 50%, etc. Range from 0.01 to 100.

Type: Property

Access: Read/Write

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBlobFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalBoxObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalBoxObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalBoxObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComBottom | Gets or sets object lower bottom position (twips). |
ComBottomRightSection | Gets bottom right section. |
ComCloseAtPageBreak | Gets or sets close border on page break. |
ComConditionFormula | Gets or sets conditional formula. |
ComCornerEllipseHeight | Gets or sets corner ellipse height. |
ComCornerEllipseWidth | Gets or sets corner ellipse width. |
ComCssClass | Gets or sets CSS class. |
ComExtendToBottomOfSection | Gets or sets extend to bottom of section option. |
ComFillColor | Gets or sets fill color. |
ComHasDropShadow | Gets or sets border drop shadow. |
ComKind | Gets report object kind. |
ComLeft | Gets or sets object upper left position (twips). |
ComLineColor | Gets or sets line color. |
ComLineStyle | Gets or sets line style. |
ComLineThickness | Gets or sets box line thickness (twips). |
ComName | Gets or sets object name. |
ComParent | Gets object parent (Section). |
ComRight | Gets or sets object lower right position (twips). |
ComSuppress | Gets or sets object visibility. |
ComTop | Gets or sets object upper top position (twips). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalBoxObject [Property ComBottom]

ComBottom - cCrystalBoxObject

Gets or sets object lower bottom position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComBottomRightSection]

ComBottomRightSection - cCrystalBoxObject

Gets bottom right section.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComCloseAtPageBreak]

ComCloseAtPageBreak - cCrystalBoxObject

Gets or sets close border on page break.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComConditionFormula]

ComConditionFormula - cCrystalBoxObject

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaType String value

Parameter | Description
llFormulaType | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComCornerEllipseHeight]

ComCornerEllipseHeight - cCrystalBoxObject

Gets or sets corner ellipse height.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComCornerEllipseWidth]

ComCornerEllipseWidth - cCrystalBoxObject

Gets or sets corner ellipse width.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComCssClass]

ComCssClass - cCrystalBoxObject

Gets or sets CSS class.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComExtendToBottomOfSection]

ComExtendToBottomOfSection - cCrystalBoxObject

Gets or sets extend to bottom of section option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComFillColor]

ComFillColor - cCrystalBoxObject

Gets or sets fill color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComHasDropShadow]

ComHasDropShadow - cCrystalBoxObject

Gets or sets border drop shadow.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComKind]

ComKind - cCrystalBoxObject

Gets report object kind.

Type: Property

Access: Read-Only

Data Type: CRObjectKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalBoxObject [Property ComLeft]

ComLeft - cCrystalBoxObject

Gets or sets object upper left position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComLineColor]

ComLineColor - cCrystalBoxObject

Gets or sets line color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComLineStyle]

ComLineStyle - cCrystalBoxObject

Gets or sets line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalBoxObject [Property ComLineThickness]

ComLineThickness - cCrystalBoxObject

Gets or sets box line thickness (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComName]

ComName - cCrystalBoxObject

Gets or sets object name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComParent]

ComParent - cCrystalBoxObject

Gets object parent (Section).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComRight]

ComRight - cCrystalBoxObject

Gets or sets object lower right position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComSuppress]

ComSuppress - cCrystalBoxObject

Gets or sets object visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalBoxObject [Property ComTop]

ComTop - cCrystalBoxObject

Gets or sets object upper top position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIBoxObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalConnectionProperties

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalConnectionProperties

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Procedure | Adds a name value pair |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Deletes a name value pair |
ComDeleteAll | Procedure | Deletes all name value pairs |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalConnectionProperties [Procedure ComAdd]

ComAdd - cCrystalConnectionProperties

Adds a name value pair

Type: Procedure

Parameters: String llName Variant llValue

Parameter | Description
llName | Please see Crystal RDC documentation for more information.
llValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalINameValuePairs object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalConnectionProperties [Procedure ComDelete]

ComDelete - cCrystalConnectionProperties

Deletes a name value pair

Type: Procedure

Parameters: Variant llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalINameValuePairs object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalConnectionProperties [Procedure ComDeleteAll]

ComDeleteAll - cCrystalConnectionProperties

Deletes all name value pairs

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalINameValuePairs object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalConnectionProperties

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets value by name. |
ComNameIDs | Gets all names in name value pairs |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalConnectionProperties [Property Com_NewEnum]

Com_NewEnum - cCrystalConnectionProperties

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalINameValuePairs object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalConnectionProperties [Property ComCount]

ComCount - cCrystalConnectionProperties

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalINameValuePairs object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalConnectionProperties [Property ComItem]

ComItem - cCrystalConnectionProperties

Gets value by name.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: String llName Variant vValue

Parameter | Description
llName | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalINameValuePairs object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalConnectionProperties [Property ComNameIDs]

ComNameIDs - cCrystalConnectionProperties

Gets all names in name value pairs

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalINameValuePairs object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalConnectionProperty

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalConnectionProperty

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalConnectionProperty

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComChildProperties | Gets the child properties of this property in a hierarchical property structure. |
ComDescription | Gets or sets the connection property description |
ComLocalizedName | Gets or sets the connection property localized name |
ComName | Gets or sets the connection property name |
ComValue | Gets or sets the connection property value |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalConnectionProperty [Property ComChildProperties]

ComChildProperties - cCrystalConnectionProperty

Gets the child properties of this property in a hierarchical property structure.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIConnectionProperty object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalConnectionProperty [Property ComDescription]

ComDescription - cCrystalConnectionProperty

Gets or sets the connection property description

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIConnectionProperty object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalConnectionProperty [Property ComLocalizedName]

ComLocalizedName - cCrystalConnectionProperty

Gets or sets the connection property localized name

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIConnectionProperty object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalConnectionProperty [Property ComName]

ComName - cCrystalConnectionProperty

Gets or sets the connection property name

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIConnectionProperty object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalConnectionProperty [Property ComValue]

ComValue - cCrystalConnectionProperty

Gets or sets the connection property value

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIConnectionProperty object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalCRCrystalReportViewerViewInfo

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalCRCrystalReportViewerViewInfo [Function ComGetGroupPath]

ComGetGroupPath - cCrystalCRCrystalReportViewerViewInfo

VARIANT contains a safe array of integers. vt = VT_I4 | VT_ARRAY

Type: Function

Return Data Type: Integer

Parameters: Variant llpVal

Parameter | Description
llpVal | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewerViewInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 8, 2005


cCrystalCRCrystalReportViewerViewInfo [Function ComGetReportName]

ComGetReportName - cCrystalCRCrystalReportViewerViewInfo

Type: Function

Return Data Type: Integer

Parameters: String ByRef llpName

Parameter | Description
ByRef llpName | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewerViewInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRCrystalReportViewerViewInfo [Function ComGetSubreportName]

ComGetSubreportName - cCrystalCRCrystalReportViewerViewInfo

Type: Function

Return Data Type: Integer

Parameters: String ByRef llpName

Parameter | Description
ByRef llpName | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportViewerViewInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalCRCrystalReportViewerViewInfo

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComGetGroupPath | Function | VARIANT contains a safe array of integers. vt = VT_I4 | VT_ARRAY |
ComGetReportName | Function |  |
ComGetSubreportName | Function |  |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalCRCrystalReportViewerViewInfo

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


Events for cCrystalCrossTabGroup

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalCrossTabGroup

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalCrossTabGroup

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComBackColor | Gets or sets crosstab group's back color. |
ComCondition | Gets or sets crosstab group's condition. |
ComEnableSuppressLabel | Gets or sets crosstab group's enable suppress label. |
ComEnableSuppressSubtotal | Gets or sets crosstab group's enable suppress subtotal. |
ComField | Gets or sets crosstab group's field. |
ComParent | Gets crosstab group's parent. |
ComSortDirection | Gets or sets crosstab group's sort direction. |
ComSpecifiedGroups | Gets or sets the specifed groups from a row or column group in the crosstab |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalCrossTabGroup [Property ComBackColor]

ComBackColor - cCrystalCrossTabGroup

Gets or sets crosstab group's back color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroup object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabGroup [Property ComCondition]

ComCondition - cCrystalCrossTabGroup

Gets or sets crosstab group's condition.

Type: Property

Access: Read/Write

Data Type: CRGroupCondition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroup object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCrossTabGroup [Property ComEnableSuppressLabel]

ComEnableSuppressLabel - cCrystalCrossTabGroup

Gets or sets crosstab group's enable suppress label.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroup object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabGroup [Property ComEnableSuppressSubtotal]

ComEnableSuppressSubtotal - cCrystalCrossTabGroup

Gets or sets crosstab group's enable suppress subtotal.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroup object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabGroup [Property ComField]

ComField - cCrystalCrossTabGroup

Gets or sets crosstab group's field.

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroup object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabGroup [Property ComParent]

ComParent - cCrystalCrossTabGroup

Gets crosstab group's parent.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroup object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabGroup [Property ComSortDirection]

ComSortDirection - cCrystalCrossTabGroup

Gets or sets crosstab group's sort direction.

Type: Property

Access: Read/Write

Data Type: CRSortDirection

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroup object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCrossTabGroup [Property ComSpecifiedGroups]

ComSpecifiedGroups - cCrystalCrossTabGroup

Gets or sets the specifed groups from a row or column group in the crosstab

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroup object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalCrossTabGroups

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalCrossTabGroups [Function ComAdd]

ComAdd - cCrystalCrossTabGroups

Adds a crosstab group

Type: Function

Return Data Type: Variant

Parameters: Variant llField

Parameter | Description
llField | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroups object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalCrossTabGroups

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Function | Adds a crosstab group |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Deletes a crosstab group |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalCrossTabGroups [Procedure ComDelete]

ComDelete - cCrystalCrossTabGroups

Deletes a crosstab group

Type: Procedure

Parameters: Integer llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroups object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalCrossTabGroups

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets crosstab groups count. |
ComItem | Gets crosstab groups item. |
ComParent | Gets crosstab groups' parent (crosstab object). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalCrossTabGroups [Property Com_NewEnum]

Com_NewEnum - cCrystalCrossTabGroups

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroups object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabGroups [Property ComCount]

ComCount - cCrystalCrossTabGroups

Gets crosstab groups count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroups object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabGroups [Property ComItem]

ComItem - cCrystalCrossTabGroups

Gets crosstab groups item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroups object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabGroups [Property ComParent]

ComParent - cCrystalCrossTabGroups

Gets crosstab groups' parent (crosstab object).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabGroups object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalCrossTabObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalCrossTabObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalCrossTabObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComBackColor | Gets or sets object background color. |
ComBorderColor | Gets or sets object border color. |
ComBottomLineStyle | Gets or sets bottom line style. |
ComCloseAtPageBreak | Gets or sets close border on page break. |
ComColumnGrandTotalColor | Gets or sets column grand totals color. |
ComColumnGroups | Gets column groups. |
ComConditionFormula | Gets or sets conditional formula. |
ComCssClass | Gets or sets CSS class. |
ComEnableKeepColumnsTogether | Gets or sets enable keep columns together. |
ComEnableRepeatRowLabels | Gets or sets enable repeat row labels. |
ComEnableShowCellMargins | Gets or sets enable show cell margins. |
ComEnableShowGrid | Gets or sets enable show grid. |
ComEnableSuppressColumnGrandTotals | Gets or sets enable suppress column grand totals. |
ComEnableSuppressEmptyColumns | Gets or sets enable suppress empty columns. |
ComEnableSuppressEmptyRows | Gets or sets enable suppress empty rows. |
ComEnableSuppressRowGrandTotals | Gets or sets enable suppress row grand totals. |
ComHasDropShadow | Gets or sets border drop shadow. |
ComHeight | Gets object height (twips). |
ComHyperlinkText | Gets or sets hyperlink text. |
ComHyperlinkType | Gets or sets hyperlink type. |
ComKeepTogether | Gets or sets keep object together. |
ComKind | Gets report object kind. |
ComLeft | Gets or sets object upper left position (twips). |
ComLeftLineStyle | Gets or sets left line style. |
ComName | Gets or sets object name. |
ComParent | Gets object parent (Section). |
ComRightLineStyle | Gets or sets right line style. |
ComRowGrandTotalColor | Gets or sets row grand totals color. |
ComRowGroups | Gets row groups. |
ComSummaryFields | Gets summary fields. |
ComSuppress | Gets or sets object visibility. |
ComTop | Gets or sets object upper top position (twips). |
ComTopLineStyle | Gets or sets top line style. |
ComWidth | Gets object width (twips). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalCrossTabObject [Property ComBackColor]

ComBackColor - cCrystalCrossTabObject

Gets or sets object background color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComBorderColor]

ComBorderColor - cCrystalCrossTabObject

Gets or sets object border color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComBottomLineStyle]

ComBottomLineStyle - cCrystalCrossTabObject

Gets or sets bottom line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCrossTabObject [Property ComCloseAtPageBreak]

ComCloseAtPageBreak - cCrystalCrossTabObject

Gets or sets close border on page break.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComColumnGrandTotalColor]

ComColumnGrandTotalColor - cCrystalCrossTabObject

Gets or sets column grand totals color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComColumnGroups]

ComColumnGroups - cCrystalCrossTabObject

Gets column groups.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComConditionFormula]

ComConditionFormula - cCrystalCrossTabObject

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaType String value

Parameter | Description
llFormulaType | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComCssClass]

ComCssClass - cCrystalCrossTabObject

Gets or sets CSS class.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComEnableKeepColumnsTogether]

ComEnableKeepColumnsTogether - cCrystalCrossTabObject

Gets or sets enable keep columns together.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComEnableRepeatRowLabels]

ComEnableRepeatRowLabels - cCrystalCrossTabObject

Gets or sets enable repeat row labels.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComEnableShowCellMargins]

ComEnableShowCellMargins - cCrystalCrossTabObject

Gets or sets enable show cell margins.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComEnableShowGrid]

ComEnableShowGrid - cCrystalCrossTabObject

Gets or sets enable show grid.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComEnableSuppressColumnGrandTotals]

ComEnableSuppressColumnGrandTotals - cCrystalCrossTabObject

Gets or sets enable suppress column grand totals.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComEnableSuppressEmptyColumns]

ComEnableSuppressEmptyColumns - cCrystalCrossTabObject

Gets or sets enable suppress empty columns.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComEnableSuppressEmptyRows]

ComEnableSuppressEmptyRows - cCrystalCrossTabObject

Gets or sets enable suppress empty rows.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComEnableSuppressRowGrandTotals]

ComEnableSuppressRowGrandTotals - cCrystalCrossTabObject

Gets or sets enable suppress row grand totals.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComHasDropShadow]

ComHasDropShadow - cCrystalCrossTabObject

Gets or sets border drop shadow.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComHeight]

ComHeight - cCrystalCrossTabObject

Gets object height (twips).

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComHyperlinkText]

ComHyperlinkText - cCrystalCrossTabObject

Gets or sets hyperlink text.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComHyperlinkType]

ComHyperlinkType - cCrystalCrossTabObject

Gets or sets hyperlink type.

Type: Property

Access: Read/Write

Data Type: CRHyperlinkType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCrossTabObject [Property ComKeepTogether]

ComKeepTogether - cCrystalCrossTabObject

Gets or sets keep object together.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComKind]

ComKind - cCrystalCrossTabObject

Gets report object kind.

Type: Property

Access: Read-Only

Data Type: CRObjectKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCrossTabObject [Property ComLeft]

ComLeft - cCrystalCrossTabObject

Gets or sets object upper left position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComLeftLineStyle]

ComLeftLineStyle - cCrystalCrossTabObject

Gets or sets left line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCrossTabObject [Property ComName]

ComName - cCrystalCrossTabObject

Gets or sets object name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComParent]

ComParent - cCrystalCrossTabObject

Gets object parent (Section).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComRightLineStyle]

ComRightLineStyle - cCrystalCrossTabObject

Gets or sets right line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCrossTabObject [Property ComRowGrandTotalColor]

ComRowGrandTotalColor - cCrystalCrossTabObject

Gets or sets row grand totals color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComRowGroups]

ComRowGroups - cCrystalCrossTabObject

Gets row groups.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComSummaryFields]

ComSummaryFields - cCrystalCrossTabObject

Gets summary fields.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComSuppress]

ComSuppress - cCrystalCrossTabObject

Gets or sets object visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComTop]

ComTop - cCrystalCrossTabObject

Gets or sets object upper top position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrossTabObject [Property ComTopLineStyle]

ComTopLineStyle - cCrystalCrossTabObject

Gets or sets top line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCrossTabObject [Property ComWidth]

ComWidth - cCrystalCrossTabObject

Gets object width (twips).

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrossTabObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalCRVEventInfo

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalCRVEventInfo [Function ComGetFields]

ComGetFields - cCrystalCRVEventInfo

Get the fields collection

Type: Function

Return Data Type: Variant

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVEventInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalCRVEventInfo

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComGetFields | Function | Get the fields collection |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalCRVEventInfo

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComCanDrillDown | Indicates if the object is drillable |
ComIndex | Index |
ComParentIndex | Parent's index |
ComText | Object's Text |
ComType | Object type |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalCRVEventInfo [Property ComCanDrillDown]

ComCanDrillDown - cCrystalCRVEventInfo

Indicates if the object is drillable

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVEventInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVEventInfo [Property ComIndex]

ComIndex - cCrystalCRVEventInfo

Index

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVEventInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVEventInfo [Property ComParentIndex]

ComParentIndex - cCrystalCRVEventInfo

Parent's index

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVEventInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVEventInfo [Property ComText]

ComText - cCrystalCRVEventInfo

Object's Text

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVEventInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVEventInfo [Property ComType]

ComType - cCrystalCRVEventInfo

Object type

Type: Property

Access: Read-Only

Data Type: CRObjectType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVEventInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalCRVField

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalCRVField

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalCRVField

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComFieldType | property FieldType |
ComIsRawData | property IsRawData |
ComName | property Name |
ComValue | property Value |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalCRVField [Property ComFieldType]

ComFieldType - cCrystalCRVField

property FieldType

Type: Property

Access: Read-Only

Data Type: CRFieldType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRField object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCRVField [Property ComIsRawData]

ComIsRawData - cCrystalCRVField

property IsRawData

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRField object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVField [Property ComName]

ComName - cCrystalCRVField

property Name

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRField object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVField [Property ComValue]

ComValue - cCrystalCRVField

property Value

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRField object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalCRVFields

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalCRVFields

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalCRVFields

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum | Fields Collection |
ComCount | Number of items in the collection |
ComItem | Item - index is 1-based |
ComSelectedFieldIndex | Index of the selected field |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalCRVFields [Property Com_NewEnum]

Com_NewEnum - cCrystalCRVFields

Fields Collection

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRFields object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVFields [Property ComCount]

ComCount - cCrystalCRVFields

Number of items in the collection

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRFields object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVFields [Property ComItem]

ComItem - cCrystalCRVFields

Item - index is 1-based

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llIndex Variant vValue

Parameter | Description
llIndex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRFields object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVFields [Property ComSelectedFieldIndex]

ComSelectedFieldIndex - cCrystalCRVFields

Index of the selected field

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRFields object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 15, 2005


Events for cCrystalCRVParameterPromptRuntimeOM

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalCRVParameterPromptRuntimeOM

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
ComSubmit | Procedure | submit the form data |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalCRVParameterPromptRuntimeOM [Procedure ComSubmit]

ComSubmit - cCrystalCRVParameterPromptRuntimeOM

submit the form data

Type: Procedure

Parameters: Variant llpVal

Parameter | Description
llpVal | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVParameterPromptRuntimeOM object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalCRVParameterPromptRuntimeOM

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


Events for cCrystalCRVSelectionItem

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalCRVSelectionItem [Function ComGetSectionGroupPath]

ComGetSectionGroupPath - cCrystalCRVSelectionItem

Get Section Group Path

Type: Function

Return Data Type: Integer

Parameters: UInteger ByRef llpSize UInteger ByRef llpVal

Parameter | Description
ByRef llpSize | Please see Crystal RDC documentation for more information.
ByRef llpVal | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItem object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVSelectionItem [Function ComGetViewContext]

ComGetViewContext - cCrystalCRVSelectionItem

Get Section Group Path

Type: Function

Return Data Type: Integer

Parameters: UInteger ByRef llpSize UInteger ByRef llpVal

Parameter | Description
ByRef llpSize | Please see Crystal RDC documentation for more information.
ByRef llpVal | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItem object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVSelectionItem [Function ComPutSectionGroupPath]

ComPutSectionGroupPath - cCrystalCRVSelectionItem

Put Section Group Path

Type: Function

Return Data Type: Integer

Parameters: UInteger llsize UInteger ByRef llnewVal

Parameter | Description
llsize | Please see Crystal RDC documentation for more information.
ByRef llnewVal | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItem object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVSelectionItem [Function ComPutViewContext]

ComPutViewContext - cCrystalCRVSelectionItem

Put Section Group Path

Type: Function

Return Data Type: Integer

Parameters: UInteger llsize UInteger ByRef llnewVal

Parameter | Description
llsize | Please see Crystal RDC documentation for more information.
ByRef llnewVal | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItem object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalCRVSelectionItem

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComGetSectionGroupPath | Function | Get Section Group Path |
ComGetViewContext | Function | Get Section Group Path |
ComPutSectionGroupPath | Function | Put Section Group Path |
ComPutViewContext | Function | Put Section Group Path |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalCRVSelectionItem

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComObjectName | Object Name |
ComObjectPosition | Object Position |
ComObjectType | Object Type |
ComPageNumber | Page Number |
ComSectionGroupNamePath | Group Name Path |
ComSectionName | Section Name |
ComSectionType | Section Type |
ComSelectionUsesViewContext | Selection Uses View Context |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalCRVSelectionItem [Property ComObjectName]

ComObjectName - cCrystalCRVSelectionItem

Object Name

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: String ByRef llpVal Integer iValue

Parameter | Description
ByRef llpVal | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItem object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: December 20, 2005


cCrystalCRVSelectionItem [Property ComObjectPosition]

ComObjectPosition - cCrystalCRVSelectionItem

Object Position

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: tagRECT ByRef llpVal Integer iValue

Parameter | Description
ByRef llpVal | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItem object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: December 20, 2005


cCrystalCRVSelectionItem [Property ComObjectType]

ComObjectType - cCrystalCRVSelectionItem

Object Type

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: CRObjectType ByRef llpVal Integer iValue

Parameter | Description
ByRef llpVal | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItem object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: December 20, 2005


cCrystalCRVSelectionItem [Property ComPageNumber]

ComPageNumber - cCrystalCRVSelectionItem

Page Number

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: UInteger ByRef llpVal Integer iValue

Parameter | Description
ByRef llpVal | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItem object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: December 20, 2005


cCrystalCRVSelectionItem [Property ComSectionGroupNamePath]

ComSectionGroupNamePath - cCrystalCRVSelectionItem

Group Name Path

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: String ByRef llpVal Integer iValue

Parameter | Description
ByRef llpVal | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItem object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: December 20, 2005


cCrystalCRVSelectionItem [Property ComSectionName]

ComSectionName - cCrystalCRVSelectionItem

Section Name

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: String ByRef llpVal Integer iValue

Parameter | Description
ByRef llpVal | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItem object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: December 20, 2005


cCrystalCRVSelectionItem [Property ComSectionType]

ComSectionType - cCrystalCRVSelectionItem

Section Type

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: CRObjectType ByRef llpVal Integer iValue

Parameter | Description
ByRef llpVal | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItem object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: December 20, 2005


cCrystalCRVSelectionItem [Property ComSelectionUsesViewContext]

ComSelectionUsesViewContext - cCrystalCRVSelectionItem

Selection Uses View Context

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer ByRef llpVal Integer iValue

Parameter | Description
ByRef llpVal | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItem object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalCRVSelectionItems

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalCRVSelectionItems [Function ComAddItem]

ComAddItem - cCrystalCRVSelectionItems

Type: Function

Return Data Type: Integer

Parameters: Variant llpVal

Parameter | Description
llpVal | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItems object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalCRVSelectionItems

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddItem | Function |  |
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalCRVSelectionItems

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComCount | Item count |
ComItem | Get an item |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalCRVSelectionItems [Property ComCount]

ComCount - cCrystalCRVSelectionItems

Item count

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: UInteger ByRef llpVal Integer iValue

Parameter | Description
ByRef llpVal | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItems object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCRVSelectionItems [Property ComItem]

ComItem - cCrystalCRVSelectionItems

Get an item

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: UInteger llIndex Variant llpVal Integer iValue

Parameter | Description
llIndex | Please see Crystal RDC documentation for more information.
llpVal | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVSelectionItems object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalCRVTrackCursorInfo

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalCRVTrackCursorInfo

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalCRVTrackCursorInfo

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComDetailAreaCursor | Get the DetailAreaCursor type |
ComDetailAreaFieldCursor | Get the DetailAreaFieldCursor type |
ComGraphCursor | Get the GraphCursor type |
ComGroupAreaCursor | Get the GroupAreaCursor type |
ComGroupAreaFieldCursor | Get the GroupAreaFieldCursor type |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalCRVTrackCursorInfo [Property ComDetailAreaCursor]

ComDetailAreaCursor - cCrystalCRVTrackCursorInfo

Get the DetailAreaCursor type

Type: Property

Access: Read/Write

Data Type: CRTrackCursor

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVTrackCursorInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCRVTrackCursorInfo [Property ComDetailAreaFieldCursor]

ComDetailAreaFieldCursor - cCrystalCRVTrackCursorInfo

Get the DetailAreaFieldCursor type

Type: Property

Access: Read/Write

Data Type: CRTrackCursor

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVTrackCursorInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCRVTrackCursorInfo [Property ComGraphCursor]

ComGraphCursor - cCrystalCRVTrackCursorInfo

Get the GraphCursor type

Type: Property

Access: Read/Write

Data Type: CRTrackCursor

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVTrackCursorInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCRVTrackCursorInfo [Property ComGroupAreaCursor]

ComGroupAreaCursor - cCrystalCRVTrackCursorInfo

Get the GroupAreaCursor type

Type: Property

Access: Read/Write

Data Type: CRTrackCursor

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVTrackCursorInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCRVTrackCursorInfo [Property ComGroupAreaFieldCursor]

ComGroupAreaFieldCursor - cCrystalCRVTrackCursorInfo

Get the GroupAreaFieldCursor type

Type: Property

Access: Read/Write

Data Type: CRTrackCursor

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICRVTrackCursorInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalCrystalComObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalCrystalComObject [Function ComAddField]

ComAddField - cCrystalCrystalComObject

method AddField

Type: Function

Return Data Type: Boolean

Parameters: String llFieldName Variant llFieldType

Parameter | Description
llFieldName | Please see Crystal RDC documentation for more information.
llFieldType | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrystalComObject [Function ComDeleteField]

ComDeleteField - cCrystalCrystalComObject

method DeleteField

Type: Function

Return Data Type: Boolean

Parameters: String llFieldName

Parameter | Description
llFieldName | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrystalComObject [Function ComGetColCount]

ComGetColCount - cCrystalCrystalComObject

method GetColCount

Type: Function

Return Data Type: Short

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCrystalComObject [Function ComGetEOF]

ComGetEOF - cCrystalCrystalComObject

method getEOF

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrystalComObject [Function ComGetFieldData]

ComGetFieldData - cCrystalCrystalComObject

method GetFieldData

Type: Function

Return Data Type: Variant

Parameters: Short llcolumn

Parameter | Description
llcolumn | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrystalComObject [Function ComGetFieldName]

ComGetFieldName - cCrystalCrystalComObject

method GetFieldName

Type: Function

Return Data Type: String

Parameters: Short llcolumn

Parameter | Description
llcolumn | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrystalComObject [Function ComGetFieldType]

ComGetFieldType - cCrystalCrystalComObject

method GetFieldType

Type: Function

Return Data Type: Short

Parameters: Variant llField

Parameter | Description
llField | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalCrystalComObject [Function ComMoveFirst]

ComMoveFirst - cCrystalCrystalComObject

method MoveFirst

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrystalComObject [Function ComMoveNext]

ComMoveNext - cCrystalCrystalComObject

method MoveNext

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrystalComObject [Function ComMoveTo]

ComMoveTo - cCrystalCrystalComObject

method MoveTo

Type: Function

Return Data Type: Boolean

Parameters: Integer llrecordNum

Parameter | Description
llrecordNum | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalCrystalComObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddField | Function | method AddField |
ComAddref | Procedure |  | DfComAutomationObject
ComAddRows | Procedure | method AddRows |
ComDeleteField | Function | method DeleteField |
ComGetColCount | Function | method GetColCount |
ComGetEOF | Function | method getEOF |
ComGetFieldData | Function | method GetFieldData |
ComGetFieldName | Function | method GetFieldName |
ComGetFieldType | Function | method GetFieldType |
ComMoveFirst | Function | method MoveFirst |
ComMoveNext | Function | method MoveNext |
ComMoveTo | Function | method MoveTo |
ComQueryInterface | Function |  | DfComAutomationObject
ComReset | Procedure | method Reset |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalCrystalComObject [Procedure ComAddRows]

ComAddRows - cCrystalCrystalComObject

method AddRows

Type: Procedure

Parameters: Variant llRowData

Parameter | Description
llRowData | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCrystalComObject [Procedure ComReset]

ComReset - cCrystalCrystalComObject

method Reset

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalCrystalComObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComRowCount | property RowCount |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalCrystalComObject [Property ComRowCount]

ComRowCount - cCrystalCrystalComObject

property RowCount

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalDataObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalCSFontDescription

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalCSFontDescription

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalCSFontDescription

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComEffects | Gets or sets effects. |
ComFaceName | Gets or sets face name. |
ComFontType | Gets or sets font type. |
ComMask | Gets or sets mask. |
ComPitchAndFamily | Gets or sets pitchAndFamily. |
ComSize | Gets or sets size. |
ComWeight | Gets or sets weight. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalCSFontDescription [Property ComEffects]

ComEffects - cCrystalCSFontDescription

Gets or sets effects.

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer ByRef llpEffects Integer iValue

Parameter | Description
ByRef llpEffects | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICSFontDescription object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCSFontDescription [Property ComFaceName]

ComFaceName - cCrystalCSFontDescription

Gets or sets face name.

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: String ByRef llpName Integer iValue

Parameter | Description
ByRef llpName | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICSFontDescription object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: December 20, 2005


cCrystalCSFontDescription [Property ComFontType]

ComFontType - cCrystalCSFontDescription

Gets or sets font type.

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer ByRef llpFontType Integer iValue

Parameter | Description
ByRef llpFontType | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICSFontDescription object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCSFontDescription [Property ComMask]

ComMask - cCrystalCSFontDescription

Gets or sets mask.

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer ByRef llpMask Integer iValue

Parameter | Description
ByRef llpMask | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICSFontDescription object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCSFontDescription [Property ComPitchAndFamily]

ComPitchAndFamily - cCrystalCSFontDescription

Gets or sets pitchAndFamily.

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: UChar ByRef llpPitchAndFamily Integer iValue

Parameter | Description
ByRef llpPitchAndFamily | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICSFontDescription object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: December 20, 2005


cCrystalCSFontDescription [Property ComSize]

ComSize - cCrystalCSFontDescription

Gets or sets size.

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer ByRef llpSize Integer iValue

Parameter | Description
ByRef llpSize | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICSFontDescription object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalCSFontDescription [Property ComWeight]

ComWeight - cCrystalCSFontDescription

Gets or sets weight.

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer ByRef llpWeight Integer iValue

Parameter | Description
ByRef llpWeight | Please see Crystal RDC documentation for more information.
iValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICSFontDescription object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalDatabase

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalDatabase

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddADOCommand | Procedure | Add a database table through ADO connection and command. |
ComAddOLEDBSource | Procedure | Add a database table through OLE DB provider. |
ComAddref | Procedure |  | DfComAutomationObject
ComLogOffServer | Procedure | Log off server. |
ComLogOnServer | Procedure | Log on server. |
ComLogOnServerEx | Procedure | Log on server with server type or connect info. |
ComQueryInterface | Function |  | DfComAutomationObject
ComSetDataSource | Procedure | sets specified table data source |
ComVerify | Procedure | Verifies the database. |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalDatabase [Procedure ComAddADOCommand]

ComAddADOCommand - cCrystalDatabase

Add a database table through ADO connection and command.

Type: Procedure

Parameters: Variant llpConnection Variant llpCommand

Parameter | Description
llpConnection | Please see Crystal RDC documentation for more information.
llpCommand | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabase object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabase [Procedure ComAddOLEDBSource]

ComAddOLEDBSource - cCrystalDatabase

Add a database table through OLE DB provider.

Type: Procedure

Parameters: String llpConnectionString String llpTableName

Parameter | Description
llpConnectionString | Please see Crystal RDC documentation for more information.
llpTableName | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabase object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabase [Procedure ComLogOffServer]

ComLogOffServer - cCrystalDatabase

Log off server.

Type: Procedure

Parameters: String llpDllName String llpServerName Variant llpDatabaseName Variant llpUserID Variant llpPassword

Parameter | Description
llpDllName | Please see Crystal RDC documentation for more information.
llpServerName | Please see Crystal RDC documentation for more information.
llpDatabaseName | Please see Crystal RDC documentation for more information.
llpUserID | Please see Crystal RDC documentation for more information.
llpPassword | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabase object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabase [Procedure ComLogOnServer]

ComLogOnServer - cCrystalDatabase

Log on server.

Type: Procedure

Parameters: String llpDllName String llpServerName Variant llpDatabaseName Variant llpUserID Variant llpPassword

Parameter | Description
llpDllName | Please see Crystal RDC documentation for more information.
llpServerName | Please see Crystal RDC documentation for more information.
llpDatabaseName | Please see Crystal RDC documentation for more information.
llpUserID | Please see Crystal RDC documentation for more information.
llpPassword | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabase object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabase [Procedure ComLogOnServerEx]

ComLogOnServerEx - cCrystalDatabase

Log on server with server type or connect info.

Type: Procedure

Parameters: String llpDllName String llpServerName Variant llpDatabaseName Variant llpUserID Variant llpPassword Variant llpServerType Variant llpConnectionString

Parameter | Description
llpDllName | Please see Crystal RDC documentation for more information.
llpServerName | Please see Crystal RDC documentation for more information.
llpDatabaseName | Please see Crystal RDC documentation for more information.
llpUserID | Please see Crystal RDC documentation for more information.
llpPassword | Please see Crystal RDC documentation for more information.
llpServerType | Please see Crystal RDC documentation for more information.
llpConnectionString | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabase object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabase [Procedure ComSetDataSource]

ComSetDataSource - cCrystalDatabase

sets specified table data source

Type: Procedure

Parameters: Variant lldata Variant lldataTag Variant lltableNumber

Parameter | Description
lldata | Please see Crystal RDC documentation for more information.
lldataTag | Please see Crystal RDC documentation for more information.
lltableNumber | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabase object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabase [Procedure ComVerify]

ComVerify - cCrystalDatabase

Verifies the database.

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabase object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalDatabase

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComLinks | Gets database link collection. |
ComParent | Gets database parent (Report). |
ComTables | Gets database table collection. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalDatabase [Property ComLinks]

ComLinks - cCrystalDatabase

Gets database link collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabase object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabase [Property ComParent]

ComParent - cCrystalDatabase

Gets database parent (Report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabase object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabase [Property ComTables]

ComTables - cCrystalDatabase

Gets database table collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabase object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalDatabaseFieldDefinition

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalDatabaseFieldDefinition

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalDatabaseFieldDefinition

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComDatabaseFieldDisplayName | Gets database field display name. |
ComDatabaseFieldName | Gets database field name. |
ComKind | Gets field definition kind. |
ComName | Gets field definition unique formula name. |
ComNextValue | Gets field next value. |
ComNumberOfBytes | Gets field number of bytes. |
ComParent | Gets database field parent (Report). |
ComPreviousValue | Gets field previous value. |
ComTableAliasName | Gets table alias name the field is in. |
ComValue | Gets field value. |
ComValueType | Gets field value type. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalDatabaseFieldDefinition [Property ComDatabaseFieldDisplayName]

ComDatabaseFieldDisplayName - cCrystalDatabaseFieldDefinition

Gets database field display name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseFieldDefinition [Property ComDatabaseFieldName]

ComDatabaseFieldName - cCrystalDatabaseFieldDefinition

Gets database field name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseFieldDefinition [Property ComKind]

ComKind - cCrystalDatabaseFieldDefinition

Gets field definition kind.

Type: Property

Access: Read-Only

Data Type: CRFieldKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalDatabaseFieldDefinition [Property ComName]

ComName - cCrystalDatabaseFieldDefinition

Gets field definition unique formula name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseFieldDefinition [Property ComNextValue]

ComNextValue - cCrystalDatabaseFieldDefinition

Gets field next value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseFieldDefinition [Property ComNumberOfBytes]

ComNumberOfBytes - cCrystalDatabaseFieldDefinition

Gets field number of bytes.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalDatabaseFieldDefinition [Property ComParent]

ComParent - cCrystalDatabaseFieldDefinition

Gets database field parent (Report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseFieldDefinition [Property ComPreviousValue]

ComPreviousValue - cCrystalDatabaseFieldDefinition

Gets field previous value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseFieldDefinition [Property ComTableAliasName]

ComTableAliasName - cCrystalDatabaseFieldDefinition

Gets table alias name the field is in.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseFieldDefinition [Property ComValue]

ComValue - cCrystalDatabaseFieldDefinition

Gets field value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseFieldDefinition [Property ComValueType]

ComValueType - cCrystalDatabaseFieldDefinition

Gets field value type.

Type: Property

Access: Read-Only

Data Type: CRFieldValueType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalDatabaseFieldDefinitions

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalDatabaseFieldDefinitions [Function ComGetItemByName]

ComGetItemByName - cCrystalDatabaseFieldDefinitions

Gets collection item by name index.

Type: Function

Return Data Type: Variant

Parameters: String llName

Parameter | Description
llName | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalDatabaseFieldDefinitions

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComGetItemByName | Function | Gets collection item by name index. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalDatabaseFieldDefinitions

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets database field collection parent (DatabaseTable). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalDatabaseFieldDefinitions [Property Com_NewEnum]

Com_NewEnum - cCrystalDatabaseFieldDefinitions

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseFieldDefinitions [Property ComCount]

ComCount - cCrystalDatabaseFieldDefinitions

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseFieldDefinitions [Property ComItem]

ComItem - cCrystalDatabaseFieldDefinitions

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseFieldDefinitions [Property ComParent]

ComParent - cCrystalDatabaseFieldDefinitions

Gets database field collection parent (DatabaseTable).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalDatabaseTable

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalDatabaseTable [Function ComTestConnectivity]

ComTestConnectivity - cCrystalDatabaseTable

Tests table connectivity.

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalDatabaseTable

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComCheckDifferences | Procedure | Checks table differences. |
ComQueryInterface | Function |  | DfComAutomationObject
ComSetDataSource | Procedure | Sets table data source. |
ComSetTableLocation | Procedure | Sets table location. |
ComTestConnectivity | Function | Tests table connectivity. |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalDatabaseTable [Procedure ComCheckDifferences]

ComCheckDifferences - cCrystalDatabaseTable

Checks table differences.

Type: Procedure

Parameters: Integer ByRef llpDifferences Variant llreserved

Parameter | Description
ByRef llpDifferences | Please see Crystal RDC documentation for more information.
llreserved | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTable [Procedure ComSetDataSource]

ComSetDataSource - cCrystalDatabaseTable

Sets table data source.

Type: Procedure

Parameters: Variant lldata Variant lldataTag

Parameter | Description
lldata | Please see Crystal RDC documentation for more information.
lldataTag | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTable [Procedure ComSetTableLocation]

ComSetTableLocation - cCrystalDatabaseTable

Sets table location.

Type: Procedure

Parameters: String llpLocation String llpSubLocation String llpConnectBufferSting

Parameter | Description
llpLocation | Please see Crystal RDC documentation for more information.
llpSubLocation | Please see Crystal RDC documentation for more information.
llpConnectBufferSting | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalDatabaseTable

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComConnectBufferString | Gets or sets table connection string. |
ComConnectionProperties | Gets the connection log on properties collection of a table. |
ComDatabaseType | Gets table type. |
ComDllName | Gets or sets table driver dll name. |
ComFields | Gets database field definition collection. |
ComLocation | Gets or sets table location. |
ComName | Gets or sets table alias name. |
ComParent | Gets database table parent (Database). |
ComQualifiers | Gets the table's full qualifiers. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalDatabaseTable [Property ComConnectBufferString]

ComConnectBufferString - cCrystalDatabaseTable

Gets or sets table connection string.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTable [Property ComConnectionProperties]

ComConnectionProperties - cCrystalDatabaseTable

Gets the connection log on properties collection of a table.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTable [Property ComDatabaseType]

ComDatabaseType - cCrystalDatabaseTable

Gets table type.

Type: Property

Access: Read-Only

Data Type: CRDatabaseType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalDatabaseTable [Property ComDllName]

ComDllName - cCrystalDatabaseTable

Gets or sets table driver dll name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTable [Property ComFields]

ComFields - cCrystalDatabaseTable

Gets database field definition collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTable [Property ComLocation]

ComLocation - cCrystalDatabaseTable

Gets or sets table location.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTable [Property ComName]

ComName - cCrystalDatabaseTable

Gets or sets table alias name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTable [Property ComParent]

ComParent - cCrystalDatabaseTable

Gets database table parent (Database).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTable [Property ComQualifiers]

ComQualifiers - cCrystalDatabaseTable

Gets the table's full qualifiers.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTable object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalDatabaseTables

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalDatabaseTables

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Procedure | Adds a database table. |
ComAddref | Procedure |  | DfComAutomationObject
ComAddStoredProcedure | Procedure | Adds a stored procedure. |
ComDelete | Procedure | Delete a database table. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalDatabaseTables [Procedure ComAdd]

ComAdd - cCrystalDatabaseTables

Adds a database table.

Type: Procedure

Parameters: String llpLocation Variant llpSubLocation Variant llpConnectInfo Variant lltableType Variant llpDllName Variant llpServerName Variant llpServerType Variant llpDatabaseName Variant llpUserID Variant llpPassword

Parameter | Description
llpLocation | Please see Crystal RDC documentation for more information.
llpSubLocation | Please see Crystal RDC documentation for more information.
llpConnectInfo | Please see Crystal RDC documentation for more information.
lltableType | Please see Crystal RDC documentation for more information.
llpDllName | Please see Crystal RDC documentation for more information.
llpServerName | Please see Crystal RDC documentation for more information.
llpServerType | Please see Crystal RDC documentation for more information.
llpDatabaseName | Please see Crystal RDC documentation for more information.
llpUserID | Please see Crystal RDC documentation for more information.
llpPassword | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTables object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTables [Procedure ComAddStoredProcedure]

ComAddStoredProcedure - cCrystalDatabaseTables

Adds a stored procedure.

Type: Procedure

Parameters: String llpLocation Variant llpSubLocation Variant llpConnectInfo Variant lltableType Variant llpDllName Variant llpServerName Variant llpServerType Variant llpDatabaseName Variant llpUserID Variant llpPassword Variant llparamValueInfos

Parameter | Description
llpLocation | Please see Crystal RDC documentation for more information.
llpSubLocation | Please see Crystal RDC documentation for more information.
llpConnectInfo | Please see Crystal RDC documentation for more information.
lltableType | Please see Crystal RDC documentation for more information.
llpDllName | Please see Crystal RDC documentation for more information.
llpServerName | Please see Crystal RDC documentation for more information.
llpServerType | Please see Crystal RDC documentation for more information.
llpDatabaseName | Please see Crystal RDC documentation for more information.
llpUserID | Please see Crystal RDC documentation for more information.
llpPassword | Please see Crystal RDC documentation for more information.
llparamValueInfos | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTables object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTables [Procedure ComDelete]

ComDelete - cCrystalDatabaseTables

Delete a database table.

Type: Procedure

Parameters: Integer llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTables object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalDatabaseTables

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets database table collection parent (Database). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalDatabaseTables [Property Com_NewEnum]

Com_NewEnum - cCrystalDatabaseTables

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTables object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTables [Property ComCount]

ComCount - cCrystalDatabaseTables

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTables object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTables [Property ComItem]

ComItem - cCrystalDatabaseTables

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTables object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalDatabaseTables [Property ComParent]

ComParent - cCrystalDatabaseTables

Gets database table collection parent (Database).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIDatabaseTables object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalExportOptions

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalExportOptions

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComPromptForExportOptions | Procedure | Prompts for export options. |
ComQueryInterface | Function |  | DfComAutomationObject
ComReset | Procedure | Resets export options. |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalExportOptions [Procedure ComPromptForExportOptions]

ComPromptForExportOptions - cCrystalExportOptions

Prompts for export options.

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Procedure ComReset]

ComReset - cCrystalExportOptions

Resets export options.

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalExportOptions

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComApplicationFileName | Gets or sets destination application file name. |
ComCharFieldDelimiter | Gets or sets char field delimiter. |
ComCharStringDelimiter | Gets or sets char string delimiter. |
ComDestinationDllName | Gets export destination dll name. |
ComDestinationType | Gets or sets export destination type. |
ComDiskFileName | Gets or sets destination disk file name. |
ComExcelAreaGroupNumber | Gets or sets the base area group number if the area type is group area when exporting to Excel. |
ComExcelAreaType | Gets or sets the base area type if not using constant column width when exporting to Excel. |
ComExcelChopPageHeader | Gets or sets export to Excel chop page heaader option. |
ComExcelConstantColumnWidth | Gets or sets the column width when exporting to Excel. |
ComExcelConvertDateToString | Gets or sets export to Excel has converting date values to strings option. |
ComExcelExportAllPages | Gets or sets export to Excel with all pages. |
ComExcelExportImagesInDataOnly | Gets or sets export to Excel including image in data only option. |
ComExcelExportPageAreaPair | Gets or sets export to Excel page header and footer options. |
ComExcelFirstPageNumber | Gets or sets export to Excel for first page number. |
ComExcelLastPageNumber | Gets or sets export to Excel for last page number. |
ComExcelMaintainColumnAlignment | Gets or sets export to Excel column alignment option. |
ComExcelMaintainRelativeObjectPosition | Gets or sets export to Excel maintain relative object position option. |
ComExcelPageBreaks | Gets or sets export to Excel has page break option. |
ComExcelShowGridlines | Gets or sets export to Excel show gridlines option. |
ComExcelTabHasColumnHeadings | Gets or sets exporting to Excel has column headings option. |
ComExcelUseConstantColumnWidth | Gets or sets export to Excel to use constant column width. |
ComExcelUseFormatInDataOnly | Gets or sets export to Excel including object formats and fonts in data only option. |
ComExcelUseTabularFormat | Gets or sets exporting to Excel to use tabular format. |
ComExcelUseWorksheetFunctions | Gets or sets export to Excel to use worksheet functions to represent subtotal fields in the report. |
ComExchangeDestinationType | Gets or sets exchange destination type. |
ComExchangeFolderPath | Gets or sets exchange folder path. |
ComExchangePassword | Sets exchange password. |
ComExchangeProfile | Gets or sets export to Exchange profile. |
ComExportPageBreaks | Gets or sets insert page break option. |
ComFormatDllName | Gets export format dll name. |
ComFormatType | Gets or sets export format type. |
ComHTMLEnableSeparatedPages | Gets or sets export to HTML for separated pages. |
ComHTMLFileName | Gets or sets HTML file name. |
ComHTMLHasPageNavigator | Gets or sets export to HTML to have page navigator. |
ComLotusDominoComments | Gets or sets destination Lotus Domino comments. |
ComLotusDominoDatabaseName | Gets or sets destination Lotus Domino database name. |
ComLotusDominoFormName | Gets or sets destination Lotus Domino form name. |
ComMailBccList | Gets or sets mail Bcc list. |
ComMailCcList | Gets or sets mail cc list. |
ComMailMessage | Gets or sets mail message. |
ComMailPassword | Gets or sets mail user password. |
ComMailSubject | Gets or sets mail subjects. |
ComMailToList | Gets or sets mail to list. |
ComMailUserName | Gets or sets mail user name. |
ComNumberOfLinesPerPage | Gets or sets number of line per page option. |
ComODBCDataSourceName | Gets or sets ODBC data source name. |
ComODBCDataSourcePassword | Sets ODBC data source password. |
ComODBCDataSourceUserID | Gets or sets ODBC data source user ID. |
ComODBCExportTableName | Gets or sets ODBC table name. |
ComParent | Gets export options' parent (IReport) |
ComPDFExportAllPages | Gets or sets export to PDF with all pages. |
ComPDFFirstPageNumber | Gets or sets export to PDF for first page number. |
ComPDFLastPageNumber | Gets or sets export to PDF for last page number. |
ComRTFExportAllPages | Gets or sets export to RTF with all pages. |
ComRTFFirstPageNumber | Gets or sets export to RTF for first page number. |
ComRTFLastPageNumber | Gets or sets export to RTF for last page number. |
ComUseDefaultCharactersPerInch | Gets or sets use default characters per inch option. |
ComUserDefinedCharactersPerInch | Gets or sets user defined characters per inch. |
ComUseReportDateFormat | Gets or sets use report date format option. |
ComUseReportNumberFormat | Gets or sets use report number format option. |
ComWORDWExportAllPages | Gets or sets export to Word with all pages. |
ComWORDWFirstPageNumber | Gets or sets export to Word for first page number. |
ComWORDWLastPageNumber | Gets or sets export to Word for last page number. |
ComXMLAllowMultipleFiles | Gets or sets XML allow multiple files. |
ComXMLFileName | Gets or sets XML file name. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalExportOptions [Property ComApplicationFileName]

ComApplicationFileName - cCrystalExportOptions

Gets or sets destination application file name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComCharFieldDelimiter]

ComCharFieldDelimiter - cCrystalExportOptions

Gets or sets char field delimiter.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComCharStringDelimiter]

ComCharStringDelimiter - cCrystalExportOptions

Gets or sets char string delimiter.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComDestinationDllName]

ComDestinationDllName - cCrystalExportOptions

Gets export destination dll name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComDestinationType]

ComDestinationType - cCrystalExportOptions

Gets or sets export destination type.

Type: Property

Access: Read/Write

Data Type: CRExportDestinationType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalExportOptions [Property ComDiskFileName]

ComDiskFileName - cCrystalExportOptions

Gets or sets destination disk file name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelAreaGroupNumber]

ComExcelAreaGroupNumber - cCrystalExportOptions

Gets or sets the base area group number if the area type is group area when exporting to Excel.

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalExportOptions [Property ComExcelAreaType]

ComExcelAreaType - cCrystalExportOptions

Gets or sets the base area type if not using constant column width when exporting to Excel.

Type: Property

Access: Read/Write

Data Type: CRAreaKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalExportOptions [Property ComExcelChopPageHeader]

ComExcelChopPageHeader - cCrystalExportOptions

Gets or sets export to Excel chop page heaader option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelConstantColumnWidth]

ComExcelConstantColumnWidth - cCrystalExportOptions

Gets or sets the column width when exporting to Excel.

Type: Property

Access: Read/Write

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelConvertDateToString]

ComExcelConvertDateToString - cCrystalExportOptions

Gets or sets export to Excel has converting date values to strings option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelExportAllPages]

ComExcelExportAllPages - cCrystalExportOptions

Gets or sets export to Excel with all pages.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelExportImagesInDataOnly]

ComExcelExportImagesInDataOnly - cCrystalExportOptions

Gets or sets export to Excel including image in data only option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelExportPageAreaPair]

ComExcelExportPageAreaPair - cCrystalExportOptions

Gets or sets export to Excel page header and footer options.

Type: Property

Access: Read/Write

Data Type: CRExcelExportPageAreaPair

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalExportOptions [Property ComExcelFirstPageNumber]

ComExcelFirstPageNumber - cCrystalExportOptions

Gets or sets export to Excel for first page number.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelLastPageNumber]

ComExcelLastPageNumber - cCrystalExportOptions

Gets or sets export to Excel for last page number.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelMaintainColumnAlignment]

ComExcelMaintainColumnAlignment - cCrystalExportOptions

Gets or sets export to Excel column alignment option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelMaintainRelativeObjectPosition]

ComExcelMaintainRelativeObjectPosition - cCrystalExportOptions

Gets or sets export to Excel maintain relative object position option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelPageBreaks]

ComExcelPageBreaks - cCrystalExportOptions

Gets or sets export to Excel has page break option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelShowGridlines]

ComExcelShowGridlines - cCrystalExportOptions

Gets or sets export to Excel show gridlines option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelTabHasColumnHeadings]

ComExcelTabHasColumnHeadings - cCrystalExportOptions

Gets or sets exporting to Excel has column headings option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelUseConstantColumnWidth]

ComExcelUseConstantColumnWidth - cCrystalExportOptions

Gets or sets export to Excel to use constant column width.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelUseFormatInDataOnly]

ComExcelUseFormatInDataOnly - cCrystalExportOptions

Gets or sets export to Excel including object formats and fonts in data only option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelUseTabularFormat]

ComExcelUseTabularFormat - cCrystalExportOptions

Gets or sets exporting to Excel to use tabular format.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExcelUseWorksheetFunctions]

ComExcelUseWorksheetFunctions - cCrystalExportOptions

Gets or sets export to Excel to use worksheet functions to represent subtotal fields in the report.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExchangeDestinationType]

ComExchangeDestinationType - cCrystalExportOptions

Gets or sets exchange destination type.

Type: Property

Access: Read/Write

Data Type: CRExchangeDestinationType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalExportOptions [Property ComExchangeFolderPath]

ComExchangeFolderPath - cCrystalExportOptions

Gets or sets exchange folder path.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExchangePassword]

ComExchangePassword - cCrystalExportOptions

Sets exchange password.

Type: Property

Access: Write-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExchangeProfile]

ComExchangeProfile - cCrystalExportOptions

Gets or sets export to Exchange profile.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComExportPageBreaks]

ComExportPageBreaks - cCrystalExportOptions

Gets or sets insert page break option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComFormatDllName]

ComFormatDllName - cCrystalExportOptions

Gets export format dll name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComFormatType]

ComFormatType - cCrystalExportOptions

Gets or sets export format type.

Type: Property

Access: Read/Write

Data Type: CRExportFormatType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalExportOptions [Property ComHTMLEnableSeparatedPages]

ComHTMLEnableSeparatedPages - cCrystalExportOptions

Gets or sets export to HTML for separated pages.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComHTMLFileName]

ComHTMLFileName - cCrystalExportOptions

Gets or sets HTML file name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComHTMLHasPageNavigator]

ComHTMLHasPageNavigator - cCrystalExportOptions

Gets or sets export to HTML to have page navigator.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComLotusDominoComments]

ComLotusDominoComments - cCrystalExportOptions

Gets or sets destination Lotus Domino comments.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComLotusDominoDatabaseName]

ComLotusDominoDatabaseName - cCrystalExportOptions

Gets or sets destination Lotus Domino database name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComLotusDominoFormName]

ComLotusDominoFormName - cCrystalExportOptions

Gets or sets destination Lotus Domino form name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComMailBccList]

ComMailBccList - cCrystalExportOptions

Gets or sets mail Bcc list.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComMailCcList]

ComMailCcList - cCrystalExportOptions

Gets or sets mail cc list.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComMailMessage]

ComMailMessage - cCrystalExportOptions

Gets or sets mail message.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComMailPassword]

ComMailPassword - cCrystalExportOptions

Gets or sets mail user password.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComMailSubject]

ComMailSubject - cCrystalExportOptions

Gets or sets mail subjects.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComMailToList]

ComMailToList - cCrystalExportOptions

Gets or sets mail to list.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComMailUserName]

ComMailUserName - cCrystalExportOptions

Gets or sets mail user name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComNumberOfLinesPerPage]

ComNumberOfLinesPerPage - cCrystalExportOptions

Gets or sets number of line per page option.

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalExportOptions [Property ComODBCDataSourceName]

ComODBCDataSourceName - cCrystalExportOptions

Gets or sets ODBC data source name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComODBCDataSourcePassword]

ComODBCDataSourcePassword - cCrystalExportOptions

Sets ODBC data source password.

Type: Property

Access: Write-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComODBCDataSourceUserID]

ComODBCDataSourceUserID - cCrystalExportOptions

Gets or sets ODBC data source user ID.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComODBCExportTableName]

ComODBCExportTableName - cCrystalExportOptions

Gets or sets ODBC table name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComParent]

ComParent - cCrystalExportOptions

Gets export options' parent (IReport)

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComPDFExportAllPages]

ComPDFExportAllPages - cCrystalExportOptions

Gets or sets export to PDF with all pages.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComPDFFirstPageNumber]

ComPDFFirstPageNumber - cCrystalExportOptions

Gets or sets export to PDF for first page number.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComPDFLastPageNumber]

ComPDFLastPageNumber - cCrystalExportOptions

Gets or sets export to PDF for last page number.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComRTFExportAllPages]

ComRTFExportAllPages - cCrystalExportOptions

Gets or sets export to RTF with all pages.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComRTFFirstPageNumber]

ComRTFFirstPageNumber - cCrystalExportOptions

Gets or sets export to RTF for first page number.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComRTFLastPageNumber]

ComRTFLastPageNumber - cCrystalExportOptions

Gets or sets export to RTF for last page number.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComUseDefaultCharactersPerInch]

ComUseDefaultCharactersPerInch - cCrystalExportOptions

Gets or sets use default characters per inch option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComUserDefinedCharactersPerInch]

ComUserDefinedCharactersPerInch - cCrystalExportOptions

Gets or sets user defined characters per inch.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComUseReportDateFormat]

ComUseReportDateFormat - cCrystalExportOptions

Gets or sets use report date format option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComUseReportNumberFormat]

ComUseReportNumberFormat - cCrystalExportOptions

Gets or sets use report number format option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComWORDWExportAllPages]

ComWORDWExportAllPages - cCrystalExportOptions

Gets or sets export to Word with all pages.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComWORDWFirstPageNumber]

ComWORDWFirstPageNumber - cCrystalExportOptions

Gets or sets export to Word for first page number.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComWORDWLastPageNumber]

ComWORDWLastPageNumber - cCrystalExportOptions

Gets or sets export to Word for last page number.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComXMLAllowMultipleFiles]

ComXMLAllowMultipleFiles - cCrystalExportOptions

Gets or sets XML allow multiple files.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalExportOptions [Property ComXMLFileName]

ComXMLFileName - cCrystalExportOptions

Gets or sets XML file name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIExportOptions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalFieldDefinitions

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalFieldDefinitions

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Procedure | Adds a field. |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Delete a field. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalFieldDefinitions [Procedure ComAdd]

ComAdd - cCrystalFieldDefinitions

Adds a field.

Type: Procedure

Parameters: Variant llField

Parameter | Description
llField | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldDefinitions [Procedure ComDelete]

ComDelete - cCrystalFieldDefinitions

Delete a field.

Type: Procedure

Parameters: Variant llField

Parameter | Description
llField | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalFieldDefinitions

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets field collection parent (ReportObject). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalFieldDefinitions [Property Com_NewEnum]

Com_NewEnum - cCrystalFieldDefinitions

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldDefinitions [Property ComCount]

ComCount - cCrystalFieldDefinitions

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldDefinitions [Property ComItem]

ComItem - cCrystalFieldDefinitions

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldDefinitions [Property ComParent]

ComParent - cCrystalFieldDefinitions

Gets field collection parent (ReportObject).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalFieldElement

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalFieldElement

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
ComSetLineSpacing | Procedure | Sets line spacing type and line spacing. |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalFieldElement [Procedure ComSetLineSpacing]

ComSetLineSpacing - cCrystalFieldElement

Sets line spacing type and line spacing.

Type: Procedure

Parameters: Real llLineSpacing CRLineSpacingType llLineSpacingType

Parameter | Description
llLineSpacing | Please see Crystal RDC documentation for more information.
llLineSpacingType | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalFieldElement

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComAmPmType | Gets or sets AM/PM type. |
ComAmString | Gets or sets AM string. |
ComBooleanOutputType | Gets or sets boolean output type. |
ComCharacterSpacing | Gets or sets character spacing. |
ComColor | Gets or sets field element color. |
ComConditionFormula | Gets or sets conditional formula. |
ComCurrencyPositionType | Gets or sets currency position type. |
ComCurrencySymbol | Gets or sets currency symbol. |
ComCurrencySymbolType | Gets or sets currency symbol type. |
ComDateCalendarType | Gets or sets date calendar type. |
ComDateEraType | Gets or sets date era type. |
ComDateFirstSeparator | Gets or sets date first separator. |
ComDateOrder | Gets or sets date order. |
ComDatePrefixSeparator | Gets or sets date prefix separator. |
ComDateSecondSeparator | Gets or sets date second separator. |
ComDateSuffixSeparator | Gets or sets date suffix separator. |
ComDateWindowsDefaultType | Gets or sets date windows default type. |
ComDayType | Gets or sets day type. |
ComDecimalPlaces | Gets or sets number decimal places. |
ComDecimalSymbol | Gets or sets decimal symbol. |
ComDisplayReverseSign | Gets or sets reverse sign option. |
ComFieldDefinition | Gets or sets field definition |
ComFirstLineIndent | Gets or sets first line indent. |
ComFont | Gets or sets standard OLE font. |
ComHourMinuteSeparator | Gets or sets hour minute separator. |
ComHourType | Gets or sets hour type. |
ComLeadingDayPosition | Gets or sets leading day position type. |
ComLeadingDaySeparator | Gets or sets leading day separator. |
ComLeadingDayType | Gets or sets leading day type. |
ComLeftIndent | Gets or sets left indent. |
ComLineSpacing | Gets or sets line spacing. |
ComLineSpacingType | Gets or sets line spacing type. |
ComMaxNumberOfLines | Gets or sets max of number of line for string memo field. |
ComMinuteSecondSeparator | Gets or sets minute second separator. |
ComMinuteType | Gets or sets minute type. |
ComMonthType | Gets or sets month type. |
ComNegativeType | Gets or sets number negative type. |
ComParent | Gets parent object(fieldElements). |
ComPmString | Gets or sets PM string. |
ComRightIndent | Gets or sets right indent. |
ComRoundingType | Gets or sets number rounding type. |
ComSecondType | Gets or sets second type. |
ComSuppressIfDuplicated | Gets or sets suppress if duplicated option. |
ComSuppressIfZero | Gets or sets suppress if zero option. |
ComTextFormat | Gets or sets text format option for string memo field. |
ComThousandsSeparators | Gets or sets enable number thousands separators. |
ComThousandSymbol | Gets or sets thousand symbol. |
ComTimeBase | Gets or sets time base. |
ComUseLeadingZero | Gets or sets number uses leading zero option. |
ComUseOneSymbolPerPage | Gets or sets use one symbol per page option. |
ComUseSystemDefaults | Gets or sets use system defaults formatting option. |
ComYearType | Gets or sets year type. |
ComZeroValueString | Gets or sets zero value string for number field format. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalFieldElement [Property ComAmPmType]

ComAmPmType - cCrystalFieldElement

Gets or sets AM/PM type.

Type: Property

Access: Read/Write

Data Type: CRAmPmType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComAmString]

ComAmString - cCrystalFieldElement

Gets or sets AM string.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComBooleanOutputType]

ComBooleanOutputType - cCrystalFieldElement

Gets or sets boolean output type.

Type: Property

Access: Read/Write

Data Type: CRBooleanOutputType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComCharacterSpacing]

ComCharacterSpacing - cCrystalFieldElement

Gets or sets character spacing.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComColor]

ComColor - cCrystalFieldElement

Gets or sets field element color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComConditionFormula]

ComConditionFormula - cCrystalFieldElement

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaType String value

Parameter | Description
llFormulaType | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComCurrencyPositionType]

ComCurrencyPositionType - cCrystalFieldElement

Gets or sets currency position type.

Type: Property

Access: Read/Write

Data Type: CRCurrencyPositionType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComCurrencySymbol]

ComCurrencySymbol - cCrystalFieldElement

Gets or sets currency symbol.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComCurrencySymbolType]

ComCurrencySymbolType - cCrystalFieldElement

Gets or sets currency symbol type.

Type: Property

Access: Read/Write

Data Type: CRCurrencySymbolType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComDateCalendarType]

ComDateCalendarType - cCrystalFieldElement

Gets or sets date calendar type.

Type: Property

Access: Read/Write

Data Type: CRDateCalendarType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComDateEraType]

ComDateEraType - cCrystalFieldElement

Gets or sets date era type.

Type: Property

Access: Read/Write

Data Type: CRDateEraType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComDateFirstSeparator]

ComDateFirstSeparator - cCrystalFieldElement

Gets or sets date first separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComDateOrder]

ComDateOrder - cCrystalFieldElement

Gets or sets date order.

Type: Property

Access: Read/Write

Data Type: CRDateOrder

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComDatePrefixSeparator]

ComDatePrefixSeparator - cCrystalFieldElement

Gets or sets date prefix separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComDateSecondSeparator]

ComDateSecondSeparator - cCrystalFieldElement

Gets or sets date second separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComDateSuffixSeparator]

ComDateSuffixSeparator - cCrystalFieldElement

Gets or sets date suffix separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComDateWindowsDefaultType]

ComDateWindowsDefaultType - cCrystalFieldElement

Gets or sets date windows default type.

Type: Property

Access: Read/Write

Data Type: CRDateWindowsDefaultType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComDayType]

ComDayType - cCrystalFieldElement

Gets or sets day type.

Type: Property

Access: Read/Write

Data Type: CRDayType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComDecimalPlaces]

ComDecimalPlaces - cCrystalFieldElement

Gets or sets number decimal places.

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComDecimalSymbol]

ComDecimalSymbol - cCrystalFieldElement

Gets or sets decimal symbol.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComDisplayReverseSign]

ComDisplayReverseSign - cCrystalFieldElement

Gets or sets reverse sign option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComFieldDefinition]

ComFieldDefinition - cCrystalFieldElement

Gets or sets field definition

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComFirstLineIndent]

ComFirstLineIndent - cCrystalFieldElement

Gets or sets first line indent.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComFont]

ComFont - cCrystalFieldElement

Gets or sets standard OLE font.

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComHourMinuteSeparator]

ComHourMinuteSeparator - cCrystalFieldElement

Gets or sets hour minute separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComHourType]

ComHourType - cCrystalFieldElement

Gets or sets hour type.

Type: Property

Access: Read/Write

Data Type: CRHourType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComLeadingDayPosition]

ComLeadingDayPosition - cCrystalFieldElement

Gets or sets leading day position type.

Type: Property

Access: Read/Write

Data Type: CRLeadingDayPosition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComLeadingDaySeparator]

ComLeadingDaySeparator - cCrystalFieldElement

Gets or sets leading day separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComLeadingDayType]

ComLeadingDayType - cCrystalFieldElement

Gets or sets leading day type.

Type: Property

Access: Read/Write

Data Type: CRLeadingDayType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComLeftIndent]

ComLeftIndent - cCrystalFieldElement

Gets or sets left indent.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComLineSpacing]

ComLineSpacing - cCrystalFieldElement

Gets or sets line spacing.

Type: Property

Access: Read-Only

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComLineSpacingType]

ComLineSpacingType - cCrystalFieldElement

Gets or sets line spacing type.

Type: Property

Access: Read-Only

Data Type: CRLineSpacingType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComMaxNumberOfLines]

ComMaxNumberOfLines - cCrystalFieldElement

Gets or sets max of number of line for string memo field.

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComMinuteSecondSeparator]

ComMinuteSecondSeparator - cCrystalFieldElement

Gets or sets minute second separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComMinuteType]

ComMinuteType - cCrystalFieldElement

Gets or sets minute type.

Type: Property

Access: Read/Write

Data Type: CRMinuteType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComMonthType]

ComMonthType - cCrystalFieldElement

Gets or sets month type.

Type: Property

Access: Read/Write

Data Type: CRMonthType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComNegativeType]

ComNegativeType - cCrystalFieldElement

Gets or sets number negative type.

Type: Property

Access: Read/Write

Data Type: CRNegativeType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComParent]

ComParent - cCrystalFieldElement

Gets parent object(fieldElements).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComPmString]

ComPmString - cCrystalFieldElement

Gets or sets PM string.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComRightIndent]

ComRightIndent - cCrystalFieldElement

Gets or sets right indent.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComRoundingType]

ComRoundingType - cCrystalFieldElement

Gets or sets number rounding type.

Type: Property

Access: Read/Write

Data Type: CRRoundingType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComSecondType]

ComSecondType - cCrystalFieldElement

Gets or sets second type.

Type: Property

Access: Read/Write

Data Type: CRSecondType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComSuppressIfDuplicated]

ComSuppressIfDuplicated - cCrystalFieldElement

Gets or sets suppress if duplicated option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComSuppressIfZero]

ComSuppressIfZero - cCrystalFieldElement

Gets or sets suppress if zero option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComTextFormat]

ComTextFormat - cCrystalFieldElement

Gets or sets text format option for string memo field.

Type: Property

Access: Read/Write

Data Type: CRTextFormat

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComThousandsSeparators]

ComThousandsSeparators - cCrystalFieldElement

Gets or sets enable number thousands separators.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComThousandSymbol]

ComThousandSymbol - cCrystalFieldElement

Gets or sets thousand symbol.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComTimeBase]

ComTimeBase - cCrystalFieldElement

Gets or sets time base.

Type: Property

Access: Read/Write

Data Type: CRTimeBase

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComUseLeadingZero]

ComUseLeadingZero - cCrystalFieldElement

Gets or sets number uses leading zero option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComUseOneSymbolPerPage]

ComUseOneSymbolPerPage - cCrystalFieldElement

Gets or sets use one symbol per page option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComUseSystemDefaults]

ComUseSystemDefaults - cCrystalFieldElement

Gets or sets use system defaults formatting option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElement [Property ComYearType]

ComYearType - cCrystalFieldElement

Gets or sets year type.

Type: Property

Access: Read/Write

Data Type: CRYearType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldElement [Property ComZeroValueString]

ComZeroValueString - cCrystalFieldElement

Gets or sets zero value string for number field format.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElement object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalFieldElements

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalFieldElements

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Procedure | Adds an embedded field element |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Deletes a embedded field element |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalFieldElements [Procedure ComAdd]

ComAdd - cCrystalFieldElements

Adds an embedded field element

Type: Procedure

Parameters: Integer llposition Variant llField

Parameter | Description
llposition | Please see Crystal RDC documentation for more information.
llField | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElements object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElements [Procedure ComDelete]

ComDelete - cCrystalFieldElements

Deletes a embedded field element

Type: Procedure

Parameters: Integer llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElements object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalFieldElements

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets field elements parent.(textObject) |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalFieldElements [Property Com_NewEnum]

Com_NewEnum - cCrystalFieldElements

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElements object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElements [Property ComCount]

ComCount - cCrystalFieldElements

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElements object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElements [Property ComItem]

ComItem - cCrystalFieldElements

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElements object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldElements [Property ComParent]

ComParent - cCrystalFieldElements

Gets field elements parent.(textObject)

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldElements object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalFieldMappingData

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalFieldMappingData

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalFieldMappingData

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComFieldName | Gets or sets field name. |
ComMappingToFieldIndex | Gets or sets the mapping to field's index in the new database's field list. |
ComTableName | Gets or sets field's table name. |
ComValueType | Gets or sets field's value type. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalFieldMappingData [Property ComFieldName]

ComFieldName - cCrystalFieldMappingData

Gets or sets field name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldMappingData object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldMappingData [Property ComMappingToFieldIndex]

ComMappingToFieldIndex - cCrystalFieldMappingData

Gets or sets the mapping to field's index in the new database's field list.

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldMappingData object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldMappingData [Property ComTableName]

ComTableName - cCrystalFieldMappingData

Gets or sets field's table name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldMappingData object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldMappingData [Property ComValueType]

ComValueType - cCrystalFieldMappingData

Gets or sets field's value type.

Type: Property

Access: Read-Only

Data Type: CRFieldValueType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldMappingData object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalFieldObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalFieldObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
ComSetLineSpacing | Procedure | Sets line spacing type and line spacing. |
ComSetUnboundFieldSource | Procedure | Sets unbound field formula text |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalFieldObject [Procedure ComSetLineSpacing]

ComSetLineSpacing - cCrystalFieldObject

Sets line spacing type and line spacing.

Type: Procedure

Parameters: Real llLineSpacing CRLineSpacingType llLineSpacingType

Parameter | Description
llLineSpacing | Please see Crystal RDC documentation for more information.
llLineSpacingType | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Procedure ComSetUnboundFieldSource]

ComSetUnboundFieldSource - cCrystalFieldObject

Sets unbound field formula text

Type: Procedure

Parameters: String llpUnboundFieldSource

Parameter | Description
llpUnboundFieldSource | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalFieldObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComAmPmType | Gets or sets AM/PM type. |
ComAmString | Gets or sets AM string. |
ComBackColor | Gets or sets object background color. |
ComBooleanOutputType | Gets or sets boolean output type. |
ComBorderColor | Gets or sets object border color. |
ComBottomLineStyle | Gets or sets bottom line style. |
ComCanGrow | Gets or sets can grow option. |
ComCharacterSpacing | Gets or sets character spacing. |
ComCloseAtPageBreak | Gets or sets close border on page break. |
ComConditionFormula | Gets or sets conditional formula. |
ComCssClass | Gets or sets CSS class. |
ComCurrencyPositionType | Gets or sets currency position type. |
ComCurrencySymbol | Gets or sets currency symbol. |
ComCurrencySymbolType | Gets or sets currency symbol type. |
ComDateCalendarType | Gets or sets date calendar type. |
ComDateEraType | Gets or sets date era type. |
ComDateFirstSeparator | Gets or sets date first separator. |
ComDateOrder | Gets or sets date order. |
ComDatePrefixSeparator | Gets or sets date prefix separator. |
ComDateSecondSeparator | Gets or sets date second separator. |
ComDateSuffixSeparator | Gets or sets date suffix separator. |
ComDateWindowsDefaultType | Gets or sets date windows default type. |
ComDayType | Gets or sets day type. |
ComDecimalPlaces | Gets or sets number decimal places. |
ComDecimalSymbol | Gets or sets decimal symbol. |
ComDisplayReverseSign | Gets or sets reverse sign option. |
ComEnableTightHorizontal | Gets or sets tight horizontal. |
ComField | Gets field definition. |
ComFirstLineIndent | Gets or sets first line indent. |
ComFont | Gets or sets standard OLE font. |
ComHasDropShadow | Gets or sets border drop shadow. |
ComHeight | Gets or sets object height (twips). |
ComHorAlignment | Gets or sets horizontal alignment. |
ComHourMinuteSeparator | Gets or sets hour minute separator. |
ComHourType | Gets or sets hour type. |
ComHyperlinkText | Gets or sets hyperlink text. |
ComHyperlinkType | Gets or sets hyperlink type. |
ComKeepTogether | Gets or sets keep object together. |
ComKind | Gets report object kind. |
ComLeadingDayPosition | Gets or sets leading day position type. |
ComLeadingDaySeparator | Gets or sets leading day separator. |
ComLeadingDayType | Gets or sets leading day type. |
ComLeft | Gets or sets object upper left position (twips). |
ComLeftIndent | Gets or sets left indent. |
ComLeftLineStyle | Gets or sets left line style. |
ComLineSpacing | Gets or sets line spacing. |
ComLineSpacingType | Gets or sets line spacing type. |
ComMaxNumberOfLines | Gets or sets max of number of line for string memo field. |
ComMinuteSecondSeparator | Gets or sets minute second separator. |
ComMinuteType | Gets or sets minute type. |
ComMonthType | Gets or sets month type. |
ComName | Gets or sets object name. |
ComNegativeType | Gets or sets number negative type. |
ComNextValue | Gets field next value. |
ComParent | Gets object parent (Section). |
ComPmString | Gets or sets PM string. |
ComPreviousValue | Gets field previous value. |
ComRightIndent | Gets or sets right indent. |
ComRightLineStyle | Gets or sets right line style. |
ComRoundingType | Gets or sets number rounding type. |
ComSecondType | Gets or sets second type. |
ComSuppress | Gets or sets object visibility. |
ComSuppressIfDuplicated | Gets or sets suppress if duplicated option. |
ComSuppressIfZero | Gets or sets suppress if zero option. |
ComTextColor | Gets or sets object text color. |
ComTextFormat | Gets or sets text format option for string memo field. |
ComTextRotationAngle | Gets or sets text rotation angle. |
ComThousandsSeparators | Gets or sets enable number thousands separators. |
ComThousandSymbol | Gets or sets thousand symbol. |
ComTimeBase | Gets or sets time base. |
ComTop | Gets or sets object upper top position (twips). |
ComTopLineStyle | Gets or sets top line style. |
ComUseLeadingZero | Gets or sets number uses leading zero option. |
ComUseOneSymbolPerPage | Gets or sets use one symbol per page option. |
ComUseSystemDefaults | Gets or sets use system defaults formatting option. |
ComValue | Gets field value. |
ComWidth | Gets or sets object width (twips). |
ComYearType | Gets or sets year type. |
ComZeroValueString | Gets or sets zero value string for number field format. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalFieldObject [Property ComAmPmType]

ComAmPmType - cCrystalFieldObject

Gets or sets AM/PM type.

Type: Property

Access: Read/Write

Data Type: CRAmPmType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComAmString]

ComAmString - cCrystalFieldObject

Gets or sets AM string.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComBackColor]

ComBackColor - cCrystalFieldObject

Gets or sets object background color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComBooleanOutputType]

ComBooleanOutputType - cCrystalFieldObject

Gets or sets boolean output type.

Type: Property

Access: Read/Write

Data Type: CRBooleanOutputType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComBorderColor]

ComBorderColor - cCrystalFieldObject

Gets or sets object border color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComBottomLineStyle]

ComBottomLineStyle - cCrystalFieldObject

Gets or sets bottom line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComCanGrow]

ComCanGrow - cCrystalFieldObject

Gets or sets can grow option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComCharacterSpacing]

ComCharacterSpacing - cCrystalFieldObject

Gets or sets character spacing.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComCloseAtPageBreak]

ComCloseAtPageBreak - cCrystalFieldObject

Gets or sets close border on page break.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComConditionFormula]

ComConditionFormula - cCrystalFieldObject

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaType String value

Parameter | Description
llFormulaType | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComCssClass]

ComCssClass - cCrystalFieldObject

Gets or sets CSS class.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComCurrencyPositionType]

ComCurrencyPositionType - cCrystalFieldObject

Gets or sets currency position type.

Type: Property

Access: Read/Write

Data Type: CRCurrencyPositionType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComCurrencySymbol]

ComCurrencySymbol - cCrystalFieldObject

Gets or sets currency symbol.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComCurrencySymbolType]

ComCurrencySymbolType - cCrystalFieldObject

Gets or sets currency symbol type.

Type: Property

Access: Read/Write

Data Type: CRCurrencySymbolType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComDateCalendarType]

ComDateCalendarType - cCrystalFieldObject

Gets or sets date calendar type.

Type: Property

Access: Read/Write

Data Type: CRDateCalendarType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComDateEraType]

ComDateEraType - cCrystalFieldObject

Gets or sets date era type.

Type: Property

Access: Read/Write

Data Type: CRDateEraType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComDateFirstSeparator]

ComDateFirstSeparator - cCrystalFieldObject

Gets or sets date first separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComDateOrder]

ComDateOrder - cCrystalFieldObject

Gets or sets date order.

Type: Property

Access: Read/Write

Data Type: CRDateOrder

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComDatePrefixSeparator]

ComDatePrefixSeparator - cCrystalFieldObject

Gets or sets date prefix separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComDateSecondSeparator]

ComDateSecondSeparator - cCrystalFieldObject

Gets or sets date second separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComDateSuffixSeparator]

ComDateSuffixSeparator - cCrystalFieldObject

Gets or sets date suffix separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComDateWindowsDefaultType]

ComDateWindowsDefaultType - cCrystalFieldObject

Gets or sets date windows default type.

Type: Property

Access: Read/Write

Data Type: CRDateWindowsDefaultType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComDayType]

ComDayType - cCrystalFieldObject

Gets or sets day type.

Type: Property

Access: Read/Write

Data Type: CRDayType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComDecimalPlaces]

ComDecimalPlaces - cCrystalFieldObject

Gets or sets number decimal places.

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComDecimalSymbol]

ComDecimalSymbol - cCrystalFieldObject

Gets or sets decimal symbol.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComDisplayReverseSign]

ComDisplayReverseSign - cCrystalFieldObject

Gets or sets reverse sign option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComEnableTightHorizontal]

ComEnableTightHorizontal - cCrystalFieldObject

Gets or sets tight horizontal.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComField]

ComField - cCrystalFieldObject

Gets field definition.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComFirstLineIndent]

ComFirstLineIndent - cCrystalFieldObject

Gets or sets first line indent.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComFont]

ComFont - cCrystalFieldObject

Gets or sets standard OLE font.

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComHasDropShadow]

ComHasDropShadow - cCrystalFieldObject

Gets or sets border drop shadow.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComHeight]

ComHeight - cCrystalFieldObject

Gets or sets object height (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComHorAlignment]

ComHorAlignment - cCrystalFieldObject

Gets or sets horizontal alignment.

Type: Property

Access: Read/Write

Data Type: CRAlignment

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComHourMinuteSeparator]

ComHourMinuteSeparator - cCrystalFieldObject

Gets or sets hour minute separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComHourType]

ComHourType - cCrystalFieldObject

Gets or sets hour type.

Type: Property

Access: Read/Write

Data Type: CRHourType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComHyperlinkText]

ComHyperlinkText - cCrystalFieldObject

Gets or sets hyperlink text.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComHyperlinkType]

ComHyperlinkType - cCrystalFieldObject

Gets or sets hyperlink type.

Type: Property

Access: Read/Write

Data Type: CRHyperlinkType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComKeepTogether]

ComKeepTogether - cCrystalFieldObject

Gets or sets keep object together.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComKind]

ComKind - cCrystalFieldObject

Gets report object kind.

Type: Property

Access: Read-Only

Data Type: CRObjectKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComLeadingDayPosition]

ComLeadingDayPosition - cCrystalFieldObject

Gets or sets leading day position type.

Type: Property

Access: Read/Write

Data Type: CRLeadingDayPosition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComLeadingDaySeparator]

ComLeadingDaySeparator - cCrystalFieldObject

Gets or sets leading day separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComLeadingDayType]

ComLeadingDayType - cCrystalFieldObject

Gets or sets leading day type.

Type: Property

Access: Read/Write

Data Type: CRLeadingDayType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComLeft]

ComLeft - cCrystalFieldObject

Gets or sets object upper left position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComLeftIndent]

ComLeftIndent - cCrystalFieldObject

Gets or sets left indent.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComLeftLineStyle]

ComLeftLineStyle - cCrystalFieldObject

Gets or sets left line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComLineSpacing]

ComLineSpacing - cCrystalFieldObject

Gets or sets line spacing.

Type: Property

Access: Read-Only

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComLineSpacingType]

ComLineSpacingType - cCrystalFieldObject

Gets or sets line spacing type.

Type: Property

Access: Read-Only

Data Type: CRLineSpacingType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComMaxNumberOfLines]

ComMaxNumberOfLines - cCrystalFieldObject

Gets or sets max of number of line for string memo field.

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComMinuteSecondSeparator]

ComMinuteSecondSeparator - cCrystalFieldObject

Gets or sets minute second separator.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComMinuteType]

ComMinuteType - cCrystalFieldObject

Gets or sets minute type.

Type: Property

Access: Read/Write

Data Type: CRMinuteType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComMonthType]

ComMonthType - cCrystalFieldObject

Gets or sets month type.

Type: Property

Access: Read/Write

Data Type: CRMonthType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComName]

ComName - cCrystalFieldObject

Gets or sets object name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComNegativeType]

ComNegativeType - cCrystalFieldObject

Gets or sets number negative type.

Type: Property

Access: Read/Write

Data Type: CRNegativeType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComNextValue]

ComNextValue - cCrystalFieldObject

Gets field next value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComParent]

ComParent - cCrystalFieldObject

Gets object parent (Section).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComPmString]

ComPmString - cCrystalFieldObject

Gets or sets PM string.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComPreviousValue]

ComPreviousValue - cCrystalFieldObject

Gets field previous value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComRightIndent]

ComRightIndent - cCrystalFieldObject

Gets or sets right indent.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComRightLineStyle]

ComRightLineStyle - cCrystalFieldObject

Gets or sets right line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComRoundingType]

ComRoundingType - cCrystalFieldObject

Gets or sets number rounding type.

Type: Property

Access: Read/Write

Data Type: CRRoundingType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComSecondType]

ComSecondType - cCrystalFieldObject

Gets or sets second type.

Type: Property

Access: Read/Write

Data Type: CRSecondType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComSuppress]

ComSuppress - cCrystalFieldObject

Gets or sets object visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComSuppressIfDuplicated]

ComSuppressIfDuplicated - cCrystalFieldObject

Gets or sets suppress if duplicated option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComSuppressIfZero]

ComSuppressIfZero - cCrystalFieldObject

Gets or sets suppress if zero option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComTextColor]

ComTextColor - cCrystalFieldObject

Gets or sets object text color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComTextFormat]

ComTextFormat - cCrystalFieldObject

Gets or sets text format option for string memo field.

Type: Property

Access: Read/Write

Data Type: CRTextFormat

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComTextRotationAngle]

ComTextRotationAngle - cCrystalFieldObject

Gets or sets text rotation angle.

Type: Property

Access: Read/Write

Data Type: CRRotationAngle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComThousandsSeparators]

ComThousandsSeparators - cCrystalFieldObject

Gets or sets enable number thousands separators.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComThousandSymbol]

ComThousandSymbol - cCrystalFieldObject

Gets or sets thousand symbol.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComTimeBase]

ComTimeBase - cCrystalFieldObject

Gets or sets time base.

Type: Property

Access: Read/Write

Data Type: CRTimeBase

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComTop]

ComTop - cCrystalFieldObject

Gets or sets object upper top position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComTopLineStyle]

ComTopLineStyle - cCrystalFieldObject

Gets or sets top line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComUseLeadingZero]

ComUseLeadingZero - cCrystalFieldObject

Gets or sets number uses leading zero option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComUseOneSymbolPerPage]

ComUseOneSymbolPerPage - cCrystalFieldObject

Gets or sets use one symbol per page option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComUseSystemDefaults]

ComUseSystemDefaults - cCrystalFieldObject

Gets or sets use system defaults formatting option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComValue]

ComValue - cCrystalFieldObject

Gets field value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComWidth]

ComWidth - cCrystalFieldObject

Gets or sets object width (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFieldObject [Property ComYearType]

ComYearType - cCrystalFieldObject

Gets or sets year type.

Type: Property

Access: Read/Write

Data Type: CRYearType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFieldObject [Property ComZeroValueString]

ComZeroValueString - cCrystalFieldObject

Gets or sets zero value string for number field format.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFieldObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalFormattingInfo

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalFormattingInfo

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalFormattingInfo

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComIsEndOfGroup | Indicates the current formatting section is end of a group. |
ComIsRepeatedGroupHeader | Indicates the current formatting section is repeated group header. |
ComIsStartOfGroup | Indicates the current formatting section is start of a group. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalFormattingInfo [Property ComIsEndOfGroup]

ComIsEndOfGroup - cCrystalFormattingInfo

Indicates the current formatting section is end of a group.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormattingInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormattingInfo [Property ComIsRepeatedGroupHeader]

ComIsRepeatedGroupHeader - cCrystalFormattingInfo

Indicates the current formatting section is repeated group header.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormattingInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormattingInfo [Property ComIsStartOfGroup]

ComIsStartOfGroup - cCrystalFormattingInfo

Indicates the current formatting section is start of a group.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormattingInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalFormulaFieldDefinition

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalFormulaFieldDefinition

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComCheck | Procedure | Checks formula. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalFormulaFieldDefinition [Procedure ComCheck]

ComCheck - cCrystalFormulaFieldDefinition

Checks formula.

Type: Procedure

Parameters: Boolean ByRef llpBool String ByRef llppErrorString

Parameter | Description
ByRef llpBool | Please see Crystal RDC documentation for more information.
ByRef llppErrorString | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalFormulaFieldDefinition

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComFormulaFieldName | Gets formula field name. |
ComKind | Gets field definition kind. |
ComName | Gets field definition unique formula name. |
ComNextValue | Gets field next value. |
ComNumberOfBytes | Gets field number of bytes. |
ComParent | Gets formula field parent (Report). |
ComPreviousValue | Gets field previous value. |
ComText | Gets or sets formula field text. |
ComValue | Gets field value. |
ComValueType | Gets field value type. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalFormulaFieldDefinition [Property ComFormulaFieldName]

ComFormulaFieldName - cCrystalFormulaFieldDefinition

Gets formula field name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormulaFieldDefinition [Property ComKind]

ComKind - cCrystalFormulaFieldDefinition

Gets field definition kind.

Type: Property

Access: Read-Only

Data Type: CRFieldKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFormulaFieldDefinition [Property ComName]

ComName - cCrystalFormulaFieldDefinition

Gets field definition unique formula name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormulaFieldDefinition [Property ComNextValue]

ComNextValue - cCrystalFormulaFieldDefinition

Gets field next value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormulaFieldDefinition [Property ComNumberOfBytes]

ComNumberOfBytes - cCrystalFormulaFieldDefinition

Gets field number of bytes.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalFormulaFieldDefinition [Property ComParent]

ComParent - cCrystalFormulaFieldDefinition

Gets formula field parent (Report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormulaFieldDefinition [Property ComPreviousValue]

ComPreviousValue - cCrystalFormulaFieldDefinition

Gets field previous value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormulaFieldDefinition [Property ComText]

ComText - cCrystalFormulaFieldDefinition

Gets or sets formula field text.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormulaFieldDefinition [Property ComValue]

ComValue - cCrystalFormulaFieldDefinition

Gets field value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormulaFieldDefinition [Property ComValueType]

ComValueType - cCrystalFormulaFieldDefinition

Gets field value type.

Type: Property

Access: Read-Only

Data Type: CRFieldValueType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalFormulaFieldDefinitions

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalFormulaFieldDefinitions [Function ComAdd]

ComAdd - cCrystalFormulaFieldDefinitions

Add a formula field collection item

Type: Function

Return Data Type: Variant

Parameters: String llFormulaName String llText

Parameter | Description
llFormulaName | Please see Crystal RDC documentation for more information.
llText | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormulaFieldDefinitions [Function ComGetItemByName]

ComGetItemByName - cCrystalFormulaFieldDefinitions

Gets collection item by name index.

Type: Function

Return Data Type: Variant

Parameters: String llName

Parameter | Description
llName | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalFormulaFieldDefinitions

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Function | Add a formula field collection item |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Delete a formula field collection item |
ComGetItemByName | Function | Gets collection item by name index. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalFormulaFieldDefinitions [Procedure ComDelete]

ComDelete - cCrystalFormulaFieldDefinitions

Delete a formula field collection item

Type: Procedure

Parameters: Variant llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalFormulaFieldDefinitions

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets formula field collection parent (Report). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalFormulaFieldDefinitions [Property Com_NewEnum]

Com_NewEnum - cCrystalFormulaFieldDefinitions

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormulaFieldDefinitions [Property ComCount]

ComCount - cCrystalFormulaFieldDefinitions

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormulaFieldDefinitions [Property ComItem]

ComItem - cCrystalFormulaFieldDefinitions

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalFormulaFieldDefinitions [Property ComParent]

ComParent - cCrystalFormulaFieldDefinitions

Gets formula field collection parent (Report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIFormulaFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalGraphObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalGraphObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalGraphObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComAutoRangeData2Axis | Gets or sets auto range option for data2 axis |
ComAutoRangeDataAxis | Gets or sets auto range option for data axis |
ComAutoRangeSeriesAxis | Gets or sets auto range option for series axis |
ComBackColor | Gets or sets object background color. |
ComBarSize | Gets or sets bar size |
ComBorderColor | Gets or sets object border color. |
ComBottomLineStyle | Gets or sets bottom line style. |
ComCloseAtPageBreak | Gets or sets close border on page break. |
ComConditionFields | Gets condition fields. |
ComConditionFieldSortOrder | Gets or sets condition field sort order for detail chart |
ComConditionFormula | Gets or sets conditional formula. |
ComCrossTabObject | Gets crosstab object. |
ComCssClass | Gets or sets CSS class. |
ComData2AxisDivisionMethod | Gets or sets data2 axis division method |
ComData2AxisDivisionNumber | Gets or sets data2 axis division number |
ComData2AxisGridline | Gets or sets data2 axis grid line type |
ComData2AxisNumberFormat | Gets or sets data2 axis number format |
ComData2LabelFont | Gets or sets standard OLE font for chart data2 labels |
ComData2Title | Gets or sets data2 title |
ComData2TitleFont | Gets or sets standard OLE font for chart data2 title |
ComDataAxisDivisionMethod | Gets or sets data axis division method |
ComDataAxisDivisionNumber | Gets or sets data axis division number |
ComDataAxisGridline | Gets or sets data axis grid line type |
ComDataAxisNumberFormat | Gets or sets data axis number format |
ComDataLabelFont | Gets or sets standard OLE font for chart data labels |
ComDataPoint | Gets or sets data points on risers |
ComDataTitle | Gets or sets data title |
ComDataTitleFont | Gets or sets standard OLE font for chart data title |
ComDataType | Gets graph data type |
ComDataValueNumberFormat | Gets or sets data value number format |
ComEnableAutoScaleData2Axis | Gets or sets data2 axis auto-scale |
ComEnableAutoScaleDataAxis | Gets or sets data axis auto-scale |
ComEnableAutoScaleSeriesAxis | Gets or sets series axis auto-scale |
ComEnableForEachRecord | Gets or sets enable for each record. |
ComEnableShowLegend | Gets or sets show legend |
ComEnableSummarizeValues | Gets or sets enable summarize values. |
ComFootNote | Gets or sets footnote |
ComFootnoteFont | Gets or sets standard OLE font for chart footnote |
ComGraphColor | Gets or sets graph color |
ComGraphDirection | Gets or sets graph direction |
ComGraphType | Gets or sets graph type |
ComGroupAxisGridline | Gets or sets group axis grid line type |
ComGroupLabelFont | Gets or sets standard OLE font for chart group labels |
ComGroupsTitle | Gets or sets groups title |
ComGroupTitleFont | Gets or sets standard OLE font for chart group title |
ComHasDropShadow | Gets or sets border drop shadow. |
ComHeight | Gets or sets object height (twips). |
ComHyperlinkText | Gets or sets hyperlink text. |
ComHyperlinkType | Gets or sets hyperlink type. |
ComIsData2TitleByDefault | Gets or sets data2 title default flag |
ComIsDataTitleByDefault | Gets or sets data title default flag |
ComIsFootnoteByDefault | Gets or sets footnote default flag |
ComIsGroupsTitleByDefault | Gets or sets groups title default flag |
ComIsSeriesTitleByDefault | Gets or sets series title default flag |
ComIsSubTitleByDefault | Gets or sets subtitle default flag |
ComIsTitleByDefault | Gets or sets title default flag |
ComIsXAxisTitleByDefault | Gets or sets X-axis title default flag |
ComIsYAxisTitleByDefault | Gets or sets Y-axis title default flag |
ComIsZAxisTitleByDefault | Gets or sets Z-axis title default flag |
ComKeepTogether | Gets or sets keep object together. |
ComKind | Gets report object kind. |
ComLeft | Gets or sets object upper left position (twips). |
ComLeftLineStyle | Gets or sets left line style. |
ComLegendFont | Gets or sets standard OLE font for legend |
ComLegendLayout | Gets or sets pie legend layout |
ComLegendPosition | Gets or sets legend position |
ComMarkerShape | Gets or sets marker shape |
ComMarkerSize | Gets or sets marker size |
ComMaxData2AxisValue | Gets or sets data2-axis max value |
ComMaxDataAxisValue | Gets or sets data-axis max value |
ComMaxSeriesAxisValue | Gets or sets series-axis max value |
ComMinData2AxisValue | Gets or sets data2-axis min value |
ComMinDataAxisValue | Gets or sets data-axis min value |
ComMinSeriesAxisValue | Gets or sets series-axis min value |
ComName | Gets or sets object name. |
ComParent | Gets object parent (Section). |
ComPieSize | Gets or sets pie size |
ComRightLineStyle | Gets or sets right line style. |
ComSeriesAxisDivisionMethod | Gets or sets series axis division method |
ComSeriesAxisDivisionNumber | Gets or sets series axis division number |
ComSeriesAxisGridline | Gets or sets series axis grid line type |
ComSeriesAxisNumberFormat | Gets or sets series axis number format |
ComSeriesLabelFont | Gets or sets standard OLE font for chart series labels |
ComSeriesTitle | Gets or sets series title |
ComSeriesTitleFont | Gets or sets standard OLE font for chart series title |
ComSliceDetachment | Gets or sets slice detachment |
ComSpecifiedGroups | Gets or sets the specifed groups |
ComSubTitle | Gets or sets subtitle |
ComSubTitleFont | Gets or sets standard OLE font for chart subtitle |
ComSummaryFields | Gets summary fields. |
ComSuppress | Gets or sets object visibility. |
ComTitle | Gets or sets title |
ComTitleFont | Gets or sets standard OLE font for chart title |
ComTop | Gets or sets object upper top position (twips). |
ComTopLineStyle | Gets or sets top line style. |
ComViewingAngle | Gets or sets viewing angle |
ComWidth | Gets or sets object width (twips). |
ComXAxisTitle | Gets or sets X-Axis title |
ComY2AxisTitle | Gets or sets Y2-Axis title |
ComYAxisTitle | Gets or sets Y-Axis title |
ComZAxisTitle | Gets or sets Z-Axis title. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalGraphObject [Property ComAutoRangeData2Axis]

ComAutoRangeData2Axis - cCrystalGraphObject

Gets or sets auto range option for data2 axis

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComAutoRangeDataAxis]

ComAutoRangeDataAxis - cCrystalGraphObject

Gets or sets auto range option for data axis

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComAutoRangeSeriesAxis]

ComAutoRangeSeriesAxis - cCrystalGraphObject

Gets or sets auto range option for series axis

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComBackColor]

ComBackColor - cCrystalGraphObject

Gets or sets object background color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComBarSize]

ComBarSize - cCrystalGraphObject

Gets or sets bar size

Type: Property

Access: Read/Write

Data Type: CRBarSize

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComBorderColor]

ComBorderColor - cCrystalGraphObject

Gets or sets object border color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComBottomLineStyle]

ComBottomLineStyle - cCrystalGraphObject

Gets or sets bottom line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComCloseAtPageBreak]

ComCloseAtPageBreak - cCrystalGraphObject

Gets or sets close border on page break.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComConditionFields]

ComConditionFields - cCrystalGraphObject

Gets condition fields.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComConditionFieldSortOrder]

ComConditionFieldSortOrder - cCrystalGraphObject

Gets or sets condition field sort order for detail chart

Type: Property

Access: Read/Write

Data Type: CRSortDirection

Parameters: Integer llindex CRSortDirection value

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComConditionFormula]

ComConditionFormula - cCrystalGraphObject

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaType String value

Parameter | Description
llFormulaType | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComCrossTabObject]

ComCrossTabObject - cCrystalGraphObject

Gets crosstab object.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComCssClass]

ComCssClass - cCrystalGraphObject

Gets or sets CSS class.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComData2AxisDivisionMethod]

ComData2AxisDivisionMethod - cCrystalGraphObject

Gets or sets data2 axis division method

Type: Property

Access: Read/Write

Data Type: CRDivisionMethod

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComData2AxisDivisionNumber]

ComData2AxisDivisionNumber - cCrystalGraphObject

Gets or sets data2 axis division number

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComData2AxisGridline]

ComData2AxisGridline - cCrystalGraphObject

Gets or sets data2 axis grid line type

Type: Property

Access: Read/Write

Data Type: CRGridlineType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComData2AxisNumberFormat]

ComData2AxisNumberFormat - cCrystalGraphObject

Gets or sets data2 axis number format

Type: Property

Access: Read/Write

Data Type: CRNumberFormat

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComData2LabelFont]

ComData2LabelFont - cCrystalGraphObject

Gets or sets standard OLE font for chart data2 labels

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComData2Title]

ComData2Title - cCrystalGraphObject

Gets or sets data2 title

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComData2TitleFont]

ComData2TitleFont - cCrystalGraphObject

Gets or sets standard OLE font for chart data2 title

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComDataAxisDivisionMethod]

ComDataAxisDivisionMethod - cCrystalGraphObject

Gets or sets data axis division method

Type: Property

Access: Read/Write

Data Type: CRDivisionMethod

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComDataAxisDivisionNumber]

ComDataAxisDivisionNumber - cCrystalGraphObject

Gets or sets data axis division number

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComDataAxisGridline]

ComDataAxisGridline - cCrystalGraphObject

Gets or sets data axis grid line type

Type: Property

Access: Read/Write

Data Type: CRGridlineType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComDataAxisNumberFormat]

ComDataAxisNumberFormat - cCrystalGraphObject

Gets or sets data axis number format

Type: Property

Access: Read/Write

Data Type: CRNumberFormat

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComDataLabelFont]

ComDataLabelFont - cCrystalGraphObject

Gets or sets standard OLE font for chart data labels

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComDataPoint]

ComDataPoint - cCrystalGraphObject

Gets or sets data points on risers

Type: Property

Access: Read/Write

Data Type: CRGraphDataPoint

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComDataTitle]

ComDataTitle - cCrystalGraphObject

Gets or sets data title

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComDataTitleFont]

ComDataTitleFont - cCrystalGraphObject

Gets or sets standard OLE font for chart data title

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComDataType]

ComDataType - cCrystalGraphObject

Gets graph data type

Type: Property

Access: Read-Only

Data Type: CRGraphDataType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComDataValueNumberFormat]

ComDataValueNumberFormat - cCrystalGraphObject

Gets or sets data value number format

Type: Property

Access: Read/Write

Data Type: CRNumberFormat

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComEnableAutoScaleData2Axis]

ComEnableAutoScaleData2Axis - cCrystalGraphObject

Gets or sets data2 axis auto-scale

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComEnableAutoScaleDataAxis]

ComEnableAutoScaleDataAxis - cCrystalGraphObject

Gets or sets data axis auto-scale

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComEnableAutoScaleSeriesAxis]

ComEnableAutoScaleSeriesAxis - cCrystalGraphObject

Gets or sets series axis auto-scale

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComEnableForEachRecord]

ComEnableForEachRecord - cCrystalGraphObject

Gets or sets enable for each record.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComEnableShowLegend]

ComEnableShowLegend - cCrystalGraphObject

Gets or sets show legend

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComEnableSummarizeValues]

ComEnableSummarizeValues - cCrystalGraphObject

Gets or sets enable summarize values.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComFootNote]

ComFootNote - cCrystalGraphObject

Gets or sets footnote

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComFootnoteFont]

ComFootnoteFont - cCrystalGraphObject

Gets or sets standard OLE font for chart footnote

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComGraphColor]

ComGraphColor - cCrystalGraphObject

Gets or sets graph color

Type: Property

Access: Read/Write

Data Type: CRGraphColor

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComGraphDirection]

ComGraphDirection - cCrystalGraphObject

Gets or sets graph direction

Type: Property

Access: Read/Write

Data Type: CRGraphDirection

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComGraphType]

ComGraphType - cCrystalGraphObject

Gets or sets graph type

Type: Property

Access: Read/Write

Data Type: CRGraphType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComGroupAxisGridline]

ComGroupAxisGridline - cCrystalGraphObject

Gets or sets group axis grid line type

Type: Property

Access: Read/Write

Data Type: CRGridlineType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComGroupLabelFont]

ComGroupLabelFont - cCrystalGraphObject

Gets or sets standard OLE font for chart group labels

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComGroupsTitle]

ComGroupsTitle - cCrystalGraphObject

Gets or sets groups title

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComGroupTitleFont]

ComGroupTitleFont - cCrystalGraphObject

Gets or sets standard OLE font for chart group title

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComHasDropShadow]

ComHasDropShadow - cCrystalGraphObject

Gets or sets border drop shadow.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComHeight]

ComHeight - cCrystalGraphObject

Gets or sets object height (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComHyperlinkText]

ComHyperlinkText - cCrystalGraphObject

Gets or sets hyperlink text.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComHyperlinkType]

ComHyperlinkType - cCrystalGraphObject

Gets or sets hyperlink type.

Type: Property

Access: Read/Write

Data Type: CRHyperlinkType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComIsData2TitleByDefault]

ComIsData2TitleByDefault - cCrystalGraphObject

Gets or sets data2 title default flag

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComIsDataTitleByDefault]

ComIsDataTitleByDefault - cCrystalGraphObject

Gets or sets data title default flag

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComIsFootnoteByDefault]

ComIsFootnoteByDefault - cCrystalGraphObject

Gets or sets footnote default flag

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComIsGroupsTitleByDefault]

ComIsGroupsTitleByDefault - cCrystalGraphObject

Gets or sets groups title default flag

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComIsSeriesTitleByDefault]

ComIsSeriesTitleByDefault - cCrystalGraphObject

Gets or sets series title default flag

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComIsSubTitleByDefault]

ComIsSubTitleByDefault - cCrystalGraphObject

Gets or sets subtitle default flag

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComIsTitleByDefault]

ComIsTitleByDefault - cCrystalGraphObject

Gets or sets title default flag

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComIsXAxisTitleByDefault]

ComIsXAxisTitleByDefault - cCrystalGraphObject

Gets or sets X-axis title default flag

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComIsYAxisTitleByDefault]

ComIsYAxisTitleByDefault - cCrystalGraphObject

Gets or sets Y-axis title default flag

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComIsZAxisTitleByDefault]

ComIsZAxisTitleByDefault - cCrystalGraphObject

Gets or sets Z-axis title default flag

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComKeepTogether]

ComKeepTogether - cCrystalGraphObject

Gets or sets keep object together.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComKind]

ComKind - cCrystalGraphObject

Gets report object kind.

Type: Property

Access: Read-Only

Data Type: CRObjectKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComLeft]

ComLeft - cCrystalGraphObject

Gets or sets object upper left position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComLeftLineStyle]

ComLeftLineStyle - cCrystalGraphObject

Gets or sets left line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComLegendFont]

ComLegendFont - cCrystalGraphObject

Gets or sets standard OLE font for legend

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComLegendLayout]

ComLegendLayout - cCrystalGraphObject

Gets or sets pie legend layout

Type: Property

Access: Read/Write

Data Type: CRPieLegendLayout

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComLegendPosition]

ComLegendPosition - cCrystalGraphObject

Gets or sets legend position

Type: Property

Access: Read/Write

Data Type: CRLegendPosition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComMarkerShape]

ComMarkerShape - cCrystalGraphObject

Gets or sets marker shape

Type: Property

Access: Read/Write

Data Type: CRMarkerShape

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComMarkerSize]

ComMarkerSize - cCrystalGraphObject

Gets or sets marker size

Type: Property

Access: Read/Write

Data Type: CRMarkerSize

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComMaxData2AxisValue]

ComMaxData2AxisValue - cCrystalGraphObject

Gets or sets data2-axis max value

Type: Property

Access: Read/Write

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComMaxDataAxisValue]

ComMaxDataAxisValue - cCrystalGraphObject

Gets or sets data-axis max value

Type: Property

Access: Read/Write

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComMaxSeriesAxisValue]

ComMaxSeriesAxisValue - cCrystalGraphObject

Gets or sets series-axis max value

Type: Property

Access: Read/Write

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComMinData2AxisValue]

ComMinData2AxisValue - cCrystalGraphObject

Gets or sets data2-axis min value

Type: Property

Access: Read/Write

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComMinDataAxisValue]

ComMinDataAxisValue - cCrystalGraphObject

Gets or sets data-axis min value

Type: Property

Access: Read/Write

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComMinSeriesAxisValue]

ComMinSeriesAxisValue - cCrystalGraphObject

Gets or sets series-axis min value

Type: Property

Access: Read/Write

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComName]

ComName - cCrystalGraphObject

Gets or sets object name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComParent]

ComParent - cCrystalGraphObject

Gets object parent (Section).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComPieSize]

ComPieSize - cCrystalGraphObject

Gets or sets pie size

Type: Property

Access: Read/Write

Data Type: CRPieSize

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComRightLineStyle]

ComRightLineStyle - cCrystalGraphObject

Gets or sets right line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComSeriesAxisDivisionMethod]

ComSeriesAxisDivisionMethod - cCrystalGraphObject

Gets or sets series axis division method

Type: Property

Access: Read/Write

Data Type: CRDivisionMethod

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComSeriesAxisDivisionNumber]

ComSeriesAxisDivisionNumber - cCrystalGraphObject

Gets or sets series axis division number

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComSeriesAxisGridline]

ComSeriesAxisGridline - cCrystalGraphObject

Gets or sets series axis grid line type

Type: Property

Access: Read/Write

Data Type: CRGridlineType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComSeriesAxisNumberFormat]

ComSeriesAxisNumberFormat - cCrystalGraphObject

Gets or sets series axis number format

Type: Property

Access: Read/Write

Data Type: CRNumberFormat

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComSeriesLabelFont]

ComSeriesLabelFont - cCrystalGraphObject

Gets or sets standard OLE font for chart series labels

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComSeriesTitle]

ComSeriesTitle - cCrystalGraphObject

Gets or sets series title

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComSeriesTitleFont]

ComSeriesTitleFont - cCrystalGraphObject

Gets or sets standard OLE font for chart series title

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComSliceDetachment]

ComSliceDetachment - cCrystalGraphObject

Gets or sets slice detachment

Type: Property

Access: Read/Write

Data Type: CRSliceDetachment

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComSpecifiedGroups]

ComSpecifiedGroups - cCrystalGraphObject

Gets or sets the specifed groups

Type: Property

Access: Read/Write

Data Type: Variant

Parameters: Integer llindex Variant value

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComSubTitle]

ComSubTitle - cCrystalGraphObject

Gets or sets subtitle

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComSubTitleFont]

ComSubTitleFont - cCrystalGraphObject

Gets or sets standard OLE font for chart subtitle

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComSummaryFields]

ComSummaryFields - cCrystalGraphObject

Gets summary fields.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComSuppress]

ComSuppress - cCrystalGraphObject

Gets or sets object visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComTitle]

ComTitle - cCrystalGraphObject

Gets or sets title

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComTitleFont]

ComTitleFont - cCrystalGraphObject

Gets or sets standard OLE font for chart title

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComTop]

ComTop - cCrystalGraphObject

Gets or sets object upper top position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComTopLineStyle]

ComTopLineStyle - cCrystalGraphObject

Gets or sets top line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComViewingAngle]

ComViewingAngle - cCrystalGraphObject

Gets or sets viewing angle

Type: Property

Access: Read/Write

Data Type: CRViewingAngle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGraphObject [Property ComWidth]

ComWidth - cCrystalGraphObject

Gets or sets object width (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComXAxisTitle]

ComXAxisTitle - cCrystalGraphObject

Gets or sets X-Axis title

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComY2AxisTitle]

ComY2AxisTitle - cCrystalGraphObject

Gets or sets Y2-Axis title

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComYAxisTitle]

ComYAxisTitle - cCrystalGraphObject

Gets or sets Y-Axis title

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGraphObject [Property ComZAxisTitle]

ComZAxisTitle - cCrystalGraphObject

Gets or sets Z-Axis title.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGraphObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalGroupNameFieldDefinition

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalGroupNameFieldDefinition

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalGroupNameFieldDefinition

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComGroupNameConditionFormula | Gets or sets conditional formula. |
ComGroupNameFieldName | Gets group name field name. |
ComGroupNumber | Gets group number the group name fields represents. |
ComKind | Gets field definition kind. |
ComName | Gets field definition unique formula name. |
ComNextValue | Gets field next value. |
ComNumberOfBytes | Gets field number of bytes. |
ComParent | Gets group name field parent (Report). |
ComPreviousValue | Gets field previous value. |
ComValue | Gets field value. |
ComValueType | Gets field value type. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalGroupNameFieldDefinition [Property ComGroupNameConditionFormula]

ComGroupNameConditionFormula - cCrystalGroupNameFieldDefinition

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGroupNameFieldDefinition [Property ComGroupNameFieldName]

ComGroupNameFieldName - cCrystalGroupNameFieldDefinition

Gets group name field name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGroupNameFieldDefinition [Property ComGroupNumber]

ComGroupNumber - cCrystalGroupNameFieldDefinition

Gets group number the group name fields represents.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGroupNameFieldDefinition [Property ComKind]

ComKind - cCrystalGroupNameFieldDefinition

Gets field definition kind.

Type: Property

Access: Read-Only

Data Type: CRFieldKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGroupNameFieldDefinition [Property ComName]

ComName - cCrystalGroupNameFieldDefinition

Gets field definition unique formula name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGroupNameFieldDefinition [Property ComNextValue]

ComNextValue - cCrystalGroupNameFieldDefinition

Gets field next value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGroupNameFieldDefinition [Property ComNumberOfBytes]

ComNumberOfBytes - cCrystalGroupNameFieldDefinition

Gets field number of bytes.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalGroupNameFieldDefinition [Property ComParent]

ComParent - cCrystalGroupNameFieldDefinition

Gets group name field parent (Report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGroupNameFieldDefinition [Property ComPreviousValue]

ComPreviousValue - cCrystalGroupNameFieldDefinition

Gets field previous value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGroupNameFieldDefinition [Property ComValue]

ComValue - cCrystalGroupNameFieldDefinition

Gets field value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGroupNameFieldDefinition [Property ComValueType]

ComValueType - cCrystalGroupNameFieldDefinition

Gets field value type.

Type: Property

Access: Read-Only

Data Type: CRFieldValueType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalGroupNameFieldDefinitions

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalGroupNameFieldDefinitions

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalGroupNameFieldDefinitions

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets group name field collection parent (report). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalGroupNameFieldDefinitions [Property Com_NewEnum]

Com_NewEnum - cCrystalGroupNameFieldDefinitions

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGroupNameFieldDefinitions [Property ComCount]

ComCount - cCrystalGroupNameFieldDefinitions

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGroupNameFieldDefinitions [Property ComItem]

ComItem - cCrystalGroupNameFieldDefinitions

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalGroupNameFieldDefinitions [Property ComParent]

ComParent - cCrystalGroupNameFieldDefinitions

Gets group name field collection parent (report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIGroupNameFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalLineObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalLineObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalLineObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComBottom | Gets or sets line lower bottom position (twips). |
ComConditionFormula | Gets or sets conditional formula. |
ComCssClass | Gets or sets CSS class. |
ComEndSection | Gets end section. |
ComExtendToBottomOfSection | Gets or sets extend to bottom of section option. |
ComKind | Gets report object kind. |
ComLeft | Gets or sets object upper left position (twips). |
ComLineColor | Gets or sets line color. |
ComLineStyle | Gets or sets line style. |
ComLineThickness | Gets or sets line thickness (twips). |
ComName | Gets or sets object name. |
ComParent | Gets object parent (Section). |
ComRight | Gets or sets line lower right position (twips). |
ComSuppress | Gets or sets object visibility. |
ComTop | Gets or sets object upper top position (twips). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalLineObject [Property ComBottom]

ComBottom - cCrystalLineObject

Gets or sets line lower bottom position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalLineObject [Property ComConditionFormula]

ComConditionFormula - cCrystalLineObject

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaType String value

Parameter | Description
llFormulaType | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalLineObject [Property ComCssClass]

ComCssClass - cCrystalLineObject

Gets or sets CSS class.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalLineObject [Property ComEndSection]

ComEndSection - cCrystalLineObject

Gets end section.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalLineObject [Property ComExtendToBottomOfSection]

ComExtendToBottomOfSection - cCrystalLineObject

Gets or sets extend to bottom of section option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalLineObject [Property ComKind]

ComKind - cCrystalLineObject

Gets report object kind.

Type: Property

Access: Read-Only

Data Type: CRObjectKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalLineObject [Property ComLeft]

ComLeft - cCrystalLineObject

Gets or sets object upper left position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalLineObject [Property ComLineColor]

ComLineColor - cCrystalLineObject

Gets or sets line color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalLineObject [Property ComLineStyle]

ComLineStyle - cCrystalLineObject

Gets or sets line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalLineObject [Property ComLineThickness]

ComLineThickness - cCrystalLineObject

Gets or sets line thickness (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalLineObject [Property ComName]

ComName - cCrystalLineObject

Gets or sets object name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalLineObject [Property ComParent]

ComParent - cCrystalLineObject

Gets object parent (Section).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalLineObject [Property ComRight]

ComRight - cCrystalLineObject

Gets or sets line lower right position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalLineObject [Property ComSuppress]

ComSuppress - cCrystalLineObject

Gets or sets object visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalLineObject [Property ComTop]

ComTop - cCrystalLineObject

Gets or sets object upper top position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalILineObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalMapObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalMapObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalMapObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComBackColor | Gets or sets object background color. |
ComBorderColor | Gets or sets object border color. |
ComBottomLineStyle | Gets or sets bottom line style. |
ComCloseAtPageBreak | Gets or sets close border on page break. |
ComConditionFormula | Gets or sets conditional formula. |
ComCssClass | Gets or sets CSS class. |
ComHasDropShadow | Gets or sets border drop shadow. |
ComHeight | Gets or sets object height (twips). |
ComHyperlinkText | Gets or sets hyperlink text. |
ComHyperlinkType | Gets or sets hyperlink type. |
ComKeepTogether | Gets or sets keep object together. |
ComKind | Gets report object kind. |
ComLeft | Gets or sets object upper left position (twips). |
ComLeftLineStyle | Gets or sets left line style. |
ComName | Gets or sets object name. |
ComParent | Gets object parent (Section). |
ComRightLineStyle | Gets or sets right line style. |
ComSuppress | Gets or sets object visibility. |
ComTop | Gets or sets object upper top position (twips). |
ComTopLineStyle | Gets or sets top line style. |
ComWidth | Gets or sets object width (twips). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalMapObject [Property ComBackColor]

ComBackColor - cCrystalMapObject

Gets or sets object background color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComBorderColor]

ComBorderColor - cCrystalMapObject

Gets or sets object border color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComBottomLineStyle]

ComBottomLineStyle - cCrystalMapObject

Gets or sets bottom line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalMapObject [Property ComCloseAtPageBreak]

ComCloseAtPageBreak - cCrystalMapObject

Gets or sets close border on page break.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComConditionFormula]

ComConditionFormula - cCrystalMapObject

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaType String value

Parameter | Description
llFormulaType | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComCssClass]

ComCssClass - cCrystalMapObject

Gets or sets CSS class.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComHasDropShadow]

ComHasDropShadow - cCrystalMapObject

Gets or sets border drop shadow.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComHeight]

ComHeight - cCrystalMapObject

Gets or sets object height (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComHyperlinkText]

ComHyperlinkText - cCrystalMapObject

Gets or sets hyperlink text.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComHyperlinkType]

ComHyperlinkType - cCrystalMapObject

Gets or sets hyperlink type.

Type: Property

Access: Read/Write

Data Type: CRHyperlinkType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalMapObject [Property ComKeepTogether]

ComKeepTogether - cCrystalMapObject

Gets or sets keep object together.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComKind]

ComKind - cCrystalMapObject

Gets report object kind.

Type: Property

Access: Read-Only

Data Type: CRObjectKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalMapObject [Property ComLeft]

ComLeft - cCrystalMapObject

Gets or sets object upper left position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComLeftLineStyle]

ComLeftLineStyle - cCrystalMapObject

Gets or sets left line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalMapObject [Property ComName]

ComName - cCrystalMapObject

Gets or sets object name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComParent]

ComParent - cCrystalMapObject

Gets object parent (Section).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComRightLineStyle]

ComRightLineStyle - cCrystalMapObject

Gets or sets right line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalMapObject [Property ComSuppress]

ComSuppress - cCrystalMapObject

Gets or sets object visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComTop]

ComTop - cCrystalMapObject

Gets or sets object upper top position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalMapObject [Property ComTopLineStyle]

ComTopLineStyle - cCrystalMapObject

Gets or sets top line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalMapObject [Property ComWidth]

ComWidth - cCrystalMapObject

Gets or sets object width (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIMapObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalObjectSummaryFieldDefinitions

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalObjectSummaryFieldDefinitions

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Procedure | Adds a field. |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Delete a field. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalObjectSummaryFieldDefinitions [Procedure ComAdd]

ComAdd - cCrystalObjectSummaryFieldDefinitions

Adds a field.

Type: Procedure

Parameters: Variant llsummaryField

Parameter | Description
llsummaryField | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIObjectSummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalObjectSummaryFieldDefinitions [Procedure ComDelete]

ComDelete - cCrystalObjectSummaryFieldDefinitions

Delete a field.

Type: Procedure

Parameters: Integer llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIObjectSummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalObjectSummaryFieldDefinitions

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets object summary field collection parent (ReportObject). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalObjectSummaryFieldDefinitions [Property Com_NewEnum]

Com_NewEnum - cCrystalObjectSummaryFieldDefinitions

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIObjectSummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalObjectSummaryFieldDefinitions [Property ComCount]

ComCount - cCrystalObjectSummaryFieldDefinitions

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIObjectSummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalObjectSummaryFieldDefinitions [Property ComItem]

ComItem - cCrystalObjectSummaryFieldDefinitions

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIObjectSummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalObjectSummaryFieldDefinitions [Property ComParent]

ComParent - cCrystalObjectSummaryFieldDefinitions

Gets object summary field collection parent (ReportObject).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIObjectSummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalOlapGridObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalOlapGridObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalOlapGridObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComBackColor | Gets or sets object background color. |
ComBorderColor | Gets or sets object border color. |
ComBottomLineStyle | Gets or sets bottom line style. |
ComCloseAtPageBreak | Gets or sets close border on page break. |
ComConditionFormula | Gets or sets conditional formula. |
ComHasDropShadow | Gets or sets border drop shadow. |
ComHeight | Gets object height (twips). |
ComKeepTogether | Gets or sets keep object together. |
ComKind | Gets report object kind. |
ComLeft | Gets or sets object upper left position (twips). |
ComLeftLineStyle | Gets or sets left line style. |
ComName | Gets or sets object name. |
ComParent | Gets object parent (Section). |
ComRightLineStyle | Gets or sets right line style. |
ComSuppress | Gets or sets object visibility. |
ComTop | Gets or sets object upper top position (twips). |
ComTopLineStyle | Gets or sets top line style. |
ComWidth | Gets object width (twips). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalOlapGridObject [Property ComBackColor]

ComBackColor - cCrystalOlapGridObject

Gets or sets object background color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOlapGridObject [Property ComBorderColor]

ComBorderColor - cCrystalOlapGridObject

Gets or sets object border color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOlapGridObject [Property ComBottomLineStyle]

ComBottomLineStyle - cCrystalOlapGridObject

Gets or sets bottom line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalOlapGridObject [Property ComCloseAtPageBreak]

ComCloseAtPageBreak - cCrystalOlapGridObject

Gets or sets close border on page break.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOlapGridObject [Property ComConditionFormula]

ComConditionFormula - cCrystalOlapGridObject

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaType String value

Parameter | Description
llFormulaType | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOlapGridObject [Property ComHasDropShadow]

ComHasDropShadow - cCrystalOlapGridObject

Gets or sets border drop shadow.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOlapGridObject [Property ComHeight]

ComHeight - cCrystalOlapGridObject

Gets object height (twips).

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOlapGridObject [Property ComKeepTogether]

ComKeepTogether - cCrystalOlapGridObject

Gets or sets keep object together.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOlapGridObject [Property ComKind]

ComKind - cCrystalOlapGridObject

Gets report object kind.

Type: Property

Access: Read-Only

Data Type: CRObjectKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalOlapGridObject [Property ComLeft]

ComLeft - cCrystalOlapGridObject

Gets or sets object upper left position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOlapGridObject [Property ComLeftLineStyle]

ComLeftLineStyle - cCrystalOlapGridObject

Gets or sets left line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalOlapGridObject [Property ComName]

ComName - cCrystalOlapGridObject

Gets or sets object name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOlapGridObject [Property ComParent]

ComParent - cCrystalOlapGridObject

Gets object parent (Section).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOlapGridObject [Property ComRightLineStyle]

ComRightLineStyle - cCrystalOlapGridObject

Gets or sets right line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalOlapGridObject [Property ComSuppress]

ComSuppress - cCrystalOlapGridObject

Gets or sets object visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOlapGridObject [Property ComTop]

ComTop - cCrystalOlapGridObject

Gets or sets object upper top position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOlapGridObject [Property ComTopLineStyle]

ComTopLineStyle - cCrystalOlapGridObject

Gets or sets top line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalOlapGridObject [Property ComWidth]

ComWidth - cCrystalOlapGridObject

Gets object width (twips).

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIOlapGridObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalOleObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalOleObject [Function ComGetLinkSource]

ComGetLinkSource - cCrystalOleObject

Gets linked OLE object path.

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalOleObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComGetLinkSource | Function | Gets linked OLE object path. |
ComQueryInterface | Function |  | DfComAutomationObject
ComSetOleLocation | Procedure | Sets OLE object location |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalOleObject [Procedure ComSetOleLocation]

ComSetOleLocation - cCrystalOleObject

Sets OLE object location

Type: Procedure

Parameters: String llpLocation

Parameter | Description
llpLocation | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalOleObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComBackColor | Gets or sets object background color. |
ComBorderColor | Gets or sets object border color. |
ComBottomCropping | Gets or sets bottom cropping size (twips). |
ComBottomLineStyle | Gets or sets bottom line style. |
ComCloseAtPageBreak | Gets or sets close border on page break. |
ComConditionFormula | Gets or sets conditional formula. |
ComCssClass | Gets or sets CSS class. |
ComFormattedPicture | Gets the specified picture during formatting |
ComHasDropShadow | Gets or sets border drop shadow. |
ComHeight | Gets or sets object height (twips). |
ComHyperlinkText | Gets or sets hyperlink text. |
ComHyperlinkType | Gets or sets hyperlink type. |
ComKeepTogether | Gets or sets keep object together. |
ComKind | Gets report object kind. |
ComLeft | Gets or sets object upper left position (twips). |
ComLeftCropping | Gets or sets left cropping size (twips). |
ComLeftLineStyle | Gets or sets left line style. |
ComName | Gets or sets object name. |
ComParent | Gets object parent (Section). |
ComRightCropping | Gets or sets right cropping size (twips). |
ComRightLineStyle | Gets or sets right line style. |
ComSuppress | Gets or sets object visibility. |
ComTop | Gets or sets object upper top position (twips). |
ComTopCropping | Gets or sets top cropping size (twips). |
ComTopLineStyle | Gets or sets top line style. |
ComWidth | Gets or sets object width (twips). |
ComXScaling | Gets or sets width scaling factor. E.g. 1 means 100%, 2 means 200%, 0.5 means 50%, etc. Range from 0.01 to 100. |
ComYScaling | Gets or sets height scaling factor. E.g. 1 means 100%, 2 means 200%, 0.5 means 50%, etc. Range from 0.01 to 100. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalOleObject [Property ComBackColor]

ComBackColor - cCrystalOleObject

Gets or sets object background color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComBorderColor]

ComBorderColor - cCrystalOleObject

Gets or sets object border color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComBottomCropping]

ComBottomCropping - cCrystalOleObject

Gets or sets bottom cropping size (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComBottomLineStyle]

ComBottomLineStyle - cCrystalOleObject

Gets or sets bottom line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalOleObject [Property ComCloseAtPageBreak]

ComCloseAtPageBreak - cCrystalOleObject

Gets or sets close border on page break.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComConditionFormula]

ComConditionFormula - cCrystalOleObject

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaType String value

Parameter | Description
llFormulaType | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComCssClass]

ComCssClass - cCrystalOleObject

Gets or sets CSS class.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComFormattedPicture]

ComFormattedPicture - cCrystalOleObject

Gets the specified picture during formatting

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComHasDropShadow]

ComHasDropShadow - cCrystalOleObject

Gets or sets border drop shadow.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComHeight]

ComHeight - cCrystalOleObject

Gets or sets object height (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComHyperlinkText]

ComHyperlinkText - cCrystalOleObject

Gets or sets hyperlink text.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComHyperlinkType]

ComHyperlinkType - cCrystalOleObject

Gets or sets hyperlink type.

Type: Property

Access: Read/Write

Data Type: CRHyperlinkType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalOleObject [Property ComKeepTogether]

ComKeepTogether - cCrystalOleObject

Gets or sets keep object together.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComKind]

ComKind - cCrystalOleObject

Gets report object kind.

Type: Property

Access: Read-Only

Data Type: CRObjectKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalOleObject [Property ComLeft]

ComLeft - cCrystalOleObject

Gets or sets object upper left position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComLeftCropping]

ComLeftCropping - cCrystalOleObject

Gets or sets left cropping size (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComLeftLineStyle]

ComLeftLineStyle - cCrystalOleObject

Gets or sets left line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalOleObject [Property ComName]

ComName - cCrystalOleObject

Gets or sets object name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComParent]

ComParent - cCrystalOleObject

Gets object parent (Section).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComRightCropping]

ComRightCropping - cCrystalOleObject

Gets or sets right cropping size (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComRightLineStyle]

ComRightLineStyle - cCrystalOleObject

Gets or sets right line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalOleObject [Property ComSuppress]

ComSuppress - cCrystalOleObject

Gets or sets object visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComTop]

ComTop - cCrystalOleObject

Gets or sets object upper top position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComTopCropping]

ComTopCropping - cCrystalOleObject

Gets or sets top cropping size (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComTopLineStyle]

ComTopLineStyle - cCrystalOleObject

Gets or sets top line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalOleObject [Property ComWidth]

ComWidth - cCrystalOleObject

Gets or sets object width (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComXScaling]

ComXScaling - cCrystalOleObject

Gets or sets width scaling factor. E.g. 1 means 100%, 2 means 200%, 0.5 means 50%, etc. Range from 0.01 to 100.

Type: Property

Access: Read/Write

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalOleObject [Property ComYScaling]

ComYScaling - cCrystalOleObject

Gets or sets height scaling factor. E.g. 1 means 100%, 2 means 200%, 0.5 means 50%, etc. Range from 0.01 to 100.

Type: Property

Access: Read/Write

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICROleObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalPage

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalPage [Function ComRenderEPF]

ComRenderEPF - cCrystalPage

Gets EPF stream.

Type: Function

Return Data Type: Variant

Parameters: CRRenderResultType llresultType

Parameter | Description
llresultType | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPage object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPage [Function ComRenderHTML]

ComRenderHTML - cCrystalPage

Gets HTML stream.

Type: Function

Return Data Type: Variant

Parameters: Boolean llincludeDrillDownLinks CRHTMLPageStyle llpageStyle CRHTMLToolbarStyle lltoolbarStyle String llbaseURL CRRenderResultType llresultType

Parameter | Description
llincludeDrillDownLinks | Please see Crystal RDC documentation for more information.
llpageStyle | Please see Crystal RDC documentation for more information.
lltoolbarStyle | Please see Crystal RDC documentation for more information.
llbaseURL | Please see Crystal RDC documentation for more information.
llresultType | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPage object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalPage

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
ComRenderEPF | Function | Gets EPF stream. |
ComRenderHTML | Function | Gets HTML stream. |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalPage

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComIsLastPage | Returns whether the page is the last page. |
ComIsMissingTotalPageCount | Returns whether the page misses the total page count. |
ComPageNumber | Gets page number. |
ComParent | Gets page's parent (PageGenerator). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalPage [Property ComIsLastPage]

ComIsLastPage - cCrystalPage

Returns whether the page is the last page.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPage object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPage [Property ComIsMissingTotalPageCount]

ComIsMissingTotalPageCount - cCrystalPage

Returns whether the page misses the total page count.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPage object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPage [Property ComPageNumber]

ComPageNumber - cCrystalPage

Gets page number.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPage object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPage [Property ComParent]

ComParent - cCrystalPage

Gets page's parent (PageGenerator).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPage object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalPageEngine

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalPageEngine [Function ComCreatePageGenerator]

ComCreatePageGenerator - cCrystalPageEngine

Creates a page generator object.

Type: Function

Return Data Type: Variant

Parameters: Variant llGroupPath Variant llDrillDownLevel

Parameter | Description
llGroupPath | Please see Crystal RDC documentation for more information.
llDrillDownLevel | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageEngine object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageEngine [Function ComRenderTotallerETF]

ComRenderTotallerETF - cCrystalPageEngine

Gets totaller ETF stream.

Type: Function

Return Data Type: Variant

Parameters: Variant llrootGroupPath Integer llstartingChildNumber Short llpastRootLevels Variant llmaxNodeCount CRRenderResultType llresultType

Parameter | Description
llrootGroupPath | Please see Crystal RDC documentation for more information.
llstartingChildNumber | Please see Crystal RDC documentation for more information.
llpastRootLevels | Please see Crystal RDC documentation for more information.
llmaxNodeCount | Please see Crystal RDC documentation for more information.
llresultType | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageEngine object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageEngine [Function ComRenderTotallerHTML]

ComRenderTotallerHTML - cCrystalPageEngine

Gets totaller HTML stream.

Type: Function

Return Data Type: Variant

Parameters: Variant llrootGroupPath Integer llstartingChildNumber Short llpastRootLevels Variant llmaxNodeCount Variant llopenGroupPath Boolean llincludeDrillDownLinks String llbaseURL CRRenderResultType llresultType

Parameter | Description
llrootGroupPath | Please see Crystal RDC documentation for more information.
llstartingChildNumber | Please see Crystal RDC documentation for more information.
llpastRootLevels | Please see Crystal RDC documentation for more information.
llmaxNodeCount | Please see Crystal RDC documentation for more information.
llopenGroupPath | Please see Crystal RDC documentation for more information.
llincludeDrillDownLinks | Please see Crystal RDC documentation for more information.
llbaseURL | Please see Crystal RDC documentation for more information.
llresultType | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageEngine object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalPageEngine

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComCreatePageGenerator | Function | Creates a page generator object. |
ComQueryInterface | Function |  | DfComAutomationObject
ComRenderTotallerETF | Function | Gets totaller ETF stream. |
ComRenderTotallerHTML | Function | Gets totaller HTML stream. |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalPageEngine

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComImageOptions | Gets or sets EPF image options. |
ComParent | Gets page engine's parent (Report) |
ComPlaceHolderOptions | Gets or sets EPF place holder options. |
ComValueFormatOptions | Gets or sets EPF value format options. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalPageEngine [Property ComImageOptions]

ComImageOptions - cCrystalPageEngine

Gets or sets EPF image options.

Type: Property

Access: Read/Write

Data Type: CRImageType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageEngine object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalPageEngine [Property ComParent]

ComParent - cCrystalPageEngine

Gets page engine's parent (Report)

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageEngine object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageEngine [Property ComPlaceHolderOptions]

ComPlaceHolderOptions - cCrystalPageEngine

Gets or sets EPF place holder options.

Type: Property

Access: Read/Write

Data Type: CRPlaceHolderType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageEngine object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalPageEngine [Property ComValueFormatOptions]

ComValueFormatOptions - cCrystalPageEngine

Gets or sets EPF value format options.

Type: Property

Access: Read/Write

Data Type: CRValueFormatType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageEngine object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalPageGenerator

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalPageGenerator [Function ComCreateSubreportPageGenerator]

ComCreateSubreportPageGenerator - cCrystalPageGenerator

Creates a page generator that contains subreport view context.

Type: Function

Return Data Type: Variant

Parameters: Variant llGroupPath Variant llDrillDownLevel

Parameter | Description
llGroupPath | Please see Crystal RDC documentation for more information.
llDrillDownLevel | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Function ComDrillOnGraph]

ComDrillOnGraph - cCrystalPageGenerator

Gets a page generator for drilling on graph.

Type: Function

Return Data Type: Variant

Parameters: Integer llPageNumber Integer llxOffset Integer llyOffset

Parameter | Description
llPageNumber | Please see Crystal RDC documentation for more information.
llxOffset | Please see Crystal RDC documentation for more information.
llyOffset | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Function ComDrillOnMap]

ComDrillOnMap - cCrystalPageGenerator

Gets a page generator for drilling on a map.

Type: Function

Return Data Type: Variant

Parameters: Integer llPageNumber Integer llxOffset Integer llyOffset

Parameter | Description
llPageNumber | Please see Crystal RDC documentation for more information.
llxOffset | Please see Crystal RDC documentation for more information.
llyOffset | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Function ComDrillOnSubreport]

ComDrillOnSubreport - cCrystalPageGenerator

Gets a page generator for drilling on a out of place subreport.

Type: Function

Return Data Type: Variant

Parameters: Integer llPageNumber Integer llxOffset Integer llyOffset

Parameter | Description
llPageNumber | Please see Crystal RDC documentation for more information.
llxOffset | Please see Crystal RDC documentation for more information.
llyOffset | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Function ComExport]

ComExport - cCrystalPageGenerator

Gets export data stream.

Type: Function

Return Data Type: Variant

Parameters: CRRenderResultType llresultType

Parameter | Description
llresultType | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Function ComFindText]

ComFindText - cCrystalPageGenerator

Searchs for the specified text in the current drill down view, starting with specified page.

Type: Function

Return Data Type: Boolean

Parameters: String llText CRSearchDirection lldirection Variant llpPageNumber

Parameter | Description
llText | Please see Crystal RDC documentation for more information.
lldirection | Please see Crystal RDC documentation for more information.
llpPageNumber | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Function ComGetPageNumberForGroup]

ComGetPageNumberForGroup - cCrystalPageGenerator

Gets page number for the specified group path.

Type: Function

Return Data Type: Integer

Parameters: Variant llGroupPath

Parameter | Description
llGroupPath | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Function ComRenderTotallerETF]

ComRenderTotallerETF - cCrystalPageGenerator

Gets totaller ETF stream.

Type: Function

Return Data Type: Variant

Parameters: Variant llrootGroupPath Integer llstartingChildNumber Short llpastRootLevels Variant llmaxNodeCount CRRenderResultType llresultType

Parameter | Description
llrootGroupPath | Please see Crystal RDC documentation for more information.
llstartingChildNumber | Please see Crystal RDC documentation for more information.
llpastRootLevels | Please see Crystal RDC documentation for more information.
llmaxNodeCount | Please see Crystal RDC documentation for more information.
llresultType | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Function ComRenderTotallerHTML]

ComRenderTotallerHTML - cCrystalPageGenerator

Gets totaller HTML stream.

Type: Function

Return Data Type: Variant

Parameters: Variant llrootGroupPath Integer llstartingChildNumber Short llpastRootLevels Variant llmaxNodeCount Variant llopenGroupPath Boolean llincludeDrillDownLinks String llbaseURL CRRenderResultType llresultType

Parameter | Description
llrootGroupPath | Please see Crystal RDC documentation for more information.
llstartingChildNumber | Please see Crystal RDC documentation for more information.
llpastRootLevels | Please see Crystal RDC documentation for more information.
llmaxNodeCount | Please see Crystal RDC documentation for more information.
llopenGroupPath | Please see Crystal RDC documentation for more information.
llincludeDrillDownLinks | Please see Crystal RDC documentation for more information.
llbaseURL | Please see Crystal RDC documentation for more information.
llresultType | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalPageGenerator

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComCreateSubreportPageGenerator | Function | Creates a page generator that contains subreport view context. |
ComDrillOnGraph | Function | Gets a page generator for drilling on graph. |
ComDrillOnMap | Function | Gets a page generator for drilling on a map. |
ComDrillOnSubreport | Function | Gets a page generator for drilling on a out of place subreport. |
ComExport | Function | Gets export data stream. |
ComFindText | Function | Searchs for the specified text in the current drill down view, starting with specified page. |
ComGetPageNumberForGroup | Function | Gets page number for the specified group path. |
ComQueryInterface | Function |  | DfComAutomationObject
ComRenderTotallerETF | Function | Gets totaller ETF stream. |
ComRenderTotallerHTML | Function | Gets totaller HTML stream. |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalPageGenerator

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComContainingGroupName | Gets contatining group name for out of place subreport view. |
ComContainingGroupPath | Gets containining group path for out of place subreport view. |
ComContainingPageNumber | Gets containing page number for out of place subreport view. |
ComDrillDownLevel | Gets drill down level |
ComGroupName | Get group name for drill down on graph view |
ComGroupPath | Gets group path. |
ComPages | Gets page collection. |
ComParent | Gets page generator's parent (PageEngine). |
ComReportName | Gets report name for drill down on out of place subreport view. |
ComXOffset | Gets object xoffset. |
ComYOffset | Gets object yoffset. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalPageGenerator [Property ComContainingGroupName]

ComContainingGroupName - cCrystalPageGenerator

Gets contatining group name for out of place subreport view.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Property ComContainingGroupPath]

ComContainingGroupPath - cCrystalPageGenerator

Gets containining group path for out of place subreport view.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Property ComContainingPageNumber]

ComContainingPageNumber - cCrystalPageGenerator

Gets containing page number for out of place subreport view.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Property ComDrillDownLevel]

ComDrillDownLevel - cCrystalPageGenerator

Gets drill down level

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalPageGenerator [Property ComGroupName]

ComGroupName - cCrystalPageGenerator

Get group name for drill down on graph view

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Property ComGroupPath]

ComGroupPath - cCrystalPageGenerator

Gets group path.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Property ComPages]

ComPages - cCrystalPageGenerator

Gets page collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Property ComParent]

ComParent - cCrystalPageGenerator

Gets page generator's parent (PageEngine).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Property ComReportName]

ComReportName - cCrystalPageGenerator

Gets report name for drill down on out of place subreport view.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Property ComXOffset]

ComXOffset - cCrystalPageGenerator

Gets object xoffset.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPageGenerator [Property ComYOffset]

ComYOffset - cCrystalPageGenerator

Gets object yoffset.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPageGenerator object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalPages

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalPages

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalPages

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets pages parent(PageGenerator) |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalPages [Property Com_NewEnum]

Com_NewEnum - cCrystalPages

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPages object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPages [Property ComCount]

ComCount - cCrystalPages

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPages object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPages [Property ComItem]

ComItem - cCrystalPages

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPages object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPages [Property ComParent]

ComParent - cCrystalPages

Gets pages parent(PageGenerator)

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPages object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalParameterFieldDefinition

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalParameterFieldDefinition [Function ComGetNthCurrentValue]

ComGetNthCurrentValue - cCrystalParameterFieldDefinition

Gets nth current value.

Type: Function

Return Data Type: Variant

Parameters: Short llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Function ComGetNthDefaultValue]

ComGetNthDefaultValue - cCrystalParameterFieldDefinition

Gets nth default value

Type: Function

Return Data Type: Variant

Parameters: Short llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalParameterFieldDefinition

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddCurrentRange | Procedure | Adds current range. |
ComAddCurrentValue | Procedure | Adds current value. |
ComAddDefaultValue | Procedure | Adds a default value. |
ComAddref | Procedure |  | DfComAutomationObject
ComClearCurrentValueAndRange | Procedure | Clears all the current values and ranges. |
ComDeleteNthDefaultValue | Procedure | Deletes nth default value. |
ComGetNthCurrentRange | Procedure | Gets nth current range. |
ComGetNthCurrentValue | Function | Gets nth current value. |
ComGetNthDefaultValue | Function | Gets nth default value |
ComQueryInterface | Function |  | DfComAutomationObject
ComSetNthDefaultValue | Procedure | Sets nth default value |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalParameterFieldDefinition [Procedure ComAddCurrentRange]

ComAddCurrentRange - cCrystalParameterFieldDefinition

Adds current range.

Type: Procedure

Parameters: Variant llstart Variant llend CRRangeInfo llrangeInfo

Parameter | Description
llstart | Please see Crystal RDC documentation for more information.
llend | Please see Crystal RDC documentation for more information.
llrangeInfo | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Procedure ComAddCurrentValue]

ComAddCurrentValue - cCrystalParameterFieldDefinition

Adds current value.

Type: Procedure

Parameters: Variant llCurrentValue

Parameter | Description
llCurrentValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Procedure ComAddDefaultValue]

ComAddDefaultValue - cCrystalParameterFieldDefinition

Adds a default value.

Type: Procedure

Parameters: Variant llDefaultValue

Parameter | Description
llDefaultValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Procedure ComClearCurrentValueAndRange]

ComClearCurrentValueAndRange - cCrystalParameterFieldDefinition

Clears all the current values and ranges.

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Procedure ComDeleteNthDefaultValue]

ComDeleteNthDefaultValue - cCrystalParameterFieldDefinition

Deletes nth default value.

Type: Procedure

Parameters: Short llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Procedure ComGetNthCurrentRange]

ComGetNthCurrentRange - cCrystalParameterFieldDefinition

Gets nth current range.

Type: Procedure

Parameters: Short llindex Variant llpStart Variant llpEnd CRRangeInfo ByRef llpRangeInfo

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
llpStart | Please see Crystal RDC documentation for more information.
llpEnd | Please see Crystal RDC documentation for more information.
ByRef llpRangeInfo | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Procedure ComSetNthDefaultValue]

ComSetNthDefaultValue - cCrystalParameterFieldDefinition

Sets nth default value

Type: Procedure

Parameters: Short llindex Variant llnthDefaultValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
llnthDefaultValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalParameterFieldDefinition

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComDisallowEditing | Gets or sets disallowing editing option. |
ComDiscreteOrRangeKind | Gets or sets parameter value kind (discrete or range). |
ComEditMask | Gets or sets edit mask for string parameter. |
ComEnableExclusiveGroup | Gets or sets boolean mutuallyExclusiveGroup. |
ComEnableMultipleValues | Gets or sets allowing multiple values. |
ComEnableNullValue | Gets or sets value nullable. |
ComEnableRangeLimit | Gets or sets the option which specifies if this parameter field value should be in the specified range. |
ComEnableShowDescriptionOnly | Gets or sets show description only in pick list option. |
ComEnableSortBasedOnDesc | Gets or sets sort based on description in pick list option. |
ComGroupNumber | Gets or sets boolean group number. |
ComIsCurrentValueSet | Gets whether the current value has been set. |
ComIsDefaultValueSet | Gets whether the default value has been set. |
ComKind | Gets field definition kind. |
ComMaximumValue | Gets or sets maximum value. |
ComMinimumValue | Gets or sets minimum value. |
ComName | Gets field definition unique formula name. |
ComNeedsCurrentValue | Gets whether the parameter field needs current value. |
ComNextValue | Gets field next value. |
ComNthValueDescription | Gets or sets nth value description. |
ComNumberOfBytes | Gets field number of bytes. |
ComNumberOfCurrentRanges | Gets total number of ranges. |
ComNumberOfCurrentValues | Gets total number of current values. |
ComNumberOfDefaultValues | Gets total number of default values. |
ComParameterFieldName | Gets parameter field name. |
ComParameterType | Gets parameter type |
ComParent | Gets parameter field parent (Report). |
ComPicklistSortMethod | Gets or sets sort method in pick list option. |
ComPlaceInGroup | Gets or sets boolean place in group option. |
ComPreviousValue | Gets field previous value. |
ComPrompt | Gets or sets parameter field prompting string. |
ComReportName | Gets the report name the parameter field is in. |
ComValue | Gets field value. |
ComValueType | Gets field value type. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalParameterFieldDefinition [Property ComDisallowEditing]

ComDisallowEditing - cCrystalParameterFieldDefinition

Gets or sets disallowing editing option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComDiscreteOrRangeKind]

ComDiscreteOrRangeKind - cCrystalParameterFieldDefinition

Gets or sets parameter value kind (discrete or range).

Type: Property

Access: Read/Write

Data Type: CRDiscreteOrRangeKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalParameterFieldDefinition [Property ComEditMask]

ComEditMask - cCrystalParameterFieldDefinition

Gets or sets edit mask for string parameter.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComEnableExclusiveGroup]

ComEnableExclusiveGroup - cCrystalParameterFieldDefinition

Gets or sets boolean mutuallyExclusiveGroup.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComEnableMultipleValues]

ComEnableMultipleValues - cCrystalParameterFieldDefinition

Gets or sets allowing multiple values.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComEnableNullValue]

ComEnableNullValue - cCrystalParameterFieldDefinition

Gets or sets value nullable.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComEnableRangeLimit]

ComEnableRangeLimit - cCrystalParameterFieldDefinition

Gets or sets the option which specifies if this parameter field value should be in the specified range.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComEnableShowDescriptionOnly]

ComEnableShowDescriptionOnly - cCrystalParameterFieldDefinition

Gets or sets show description only in pick list option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComEnableSortBasedOnDesc]

ComEnableSortBasedOnDesc - cCrystalParameterFieldDefinition

Gets or sets sort based on description in pick list option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComGroupNumber]

ComGroupNumber - cCrystalParameterFieldDefinition

Gets or sets boolean group number.

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalParameterFieldDefinition [Property ComIsCurrentValueSet]

ComIsCurrentValueSet - cCrystalParameterFieldDefinition

Gets whether the current value has been set.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComIsDefaultValueSet]

ComIsDefaultValueSet - cCrystalParameterFieldDefinition

Gets whether the default value has been set.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComKind]

ComKind - cCrystalParameterFieldDefinition

Gets field definition kind.

Type: Property

Access: Read-Only

Data Type: CRFieldKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalParameterFieldDefinition [Property ComMaximumValue]

ComMaximumValue - cCrystalParameterFieldDefinition

Gets or sets maximum value.

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComMinimumValue]

ComMinimumValue - cCrystalParameterFieldDefinition

Gets or sets minimum value.

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComName]

ComName - cCrystalParameterFieldDefinition

Gets field definition unique formula name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComNeedsCurrentValue]

ComNeedsCurrentValue - cCrystalParameterFieldDefinition

Gets whether the parameter field needs current value.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComNextValue]

ComNextValue - cCrystalParameterFieldDefinition

Gets field next value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComNthValueDescription]

ComNthValueDescription - cCrystalParameterFieldDefinition

Gets or sets nth value description.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Short llindex String value

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComNumberOfBytes]

ComNumberOfBytes - cCrystalParameterFieldDefinition

Gets field number of bytes.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalParameterFieldDefinition [Property ComNumberOfCurrentRanges]

ComNumberOfCurrentRanges - cCrystalParameterFieldDefinition

Gets total number of ranges.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalParameterFieldDefinition [Property ComNumberOfCurrentValues]

ComNumberOfCurrentValues - cCrystalParameterFieldDefinition

Gets total number of current values.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalParameterFieldDefinition [Property ComNumberOfDefaultValues]

ComNumberOfDefaultValues - cCrystalParameterFieldDefinition

Gets total number of default values.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalParameterFieldDefinition [Property ComParameterFieldName]

ComParameterFieldName - cCrystalParameterFieldDefinition

Gets parameter field name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComParameterType]

ComParameterType - cCrystalParameterFieldDefinition

Gets parameter type

Type: Property

Access: Read-Only

Data Type: CRParameterFieldType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalParameterFieldDefinition [Property ComParent]

ComParent - cCrystalParameterFieldDefinition

Gets parameter field parent (Report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComPicklistSortMethod]

ComPicklistSortMethod - cCrystalParameterFieldDefinition

Gets or sets sort method in pick list option.

Type: Property

Access: Read/Write

Data Type: CRParameterPicklistSortMethod

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalParameterFieldDefinition [Property ComPlaceInGroup]

ComPlaceInGroup - cCrystalParameterFieldDefinition

Gets or sets boolean place in group option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComPreviousValue]

ComPreviousValue - cCrystalParameterFieldDefinition

Gets field previous value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComPrompt]

ComPrompt - cCrystalParameterFieldDefinition

Gets or sets parameter field prompting string.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComReportName]

ComReportName - cCrystalParameterFieldDefinition

Gets the report name the parameter field is in.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComValue]

ComValue - cCrystalParameterFieldDefinition

Gets field value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinition [Property ComValueType]

ComValueType - cCrystalParameterFieldDefinition

Gets field value type.

Type: Property

Access: Read-Only

Data Type: CRFieldValueType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalParameterFieldDefinitions

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalParameterFieldDefinitions [Function ComAdd]

ComAdd - cCrystalParameterFieldDefinitions

Add a parameter field collection item

Type: Function

Return Data Type: Variant

Parameters: String llparameterName CRFieldValueType llValueType

Parameter | Description
llparameterName | Please see Crystal RDC documentation for more information.
llValueType | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinitions [Function ComGetItemByName]

ComGetItemByName - cCrystalParameterFieldDefinitions

Gets collection item by name index.

Type: Function

Return Data Type: Variant

Parameters: String llName Variant llSubreportName

Parameter | Description
llName | Please see Crystal RDC documentation for more information.
llSubreportName | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalParameterFieldDefinitions

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Function | Add a parameter field collection item |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Delete a parameter field collection item |
ComGetItemByName | Function | Gets collection item by name index. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalParameterFieldDefinitions [Procedure ComDelete]

ComDelete - cCrystalParameterFieldDefinitions

Delete a parameter field collection item

Type: Procedure

Parameters: Variant llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalParameterFieldDefinitions

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets parameter field collection parent (report). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalParameterFieldDefinitions [Property Com_NewEnum]

Com_NewEnum - cCrystalParameterFieldDefinitions

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinitions [Property ComCount]

ComCount - cCrystalParameterFieldDefinitions

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinitions [Property ComItem]

ComItem - cCrystalParameterFieldDefinitions

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterFieldDefinitions [Property ComParent]

ComParent - cCrystalParameterFieldDefinitions

Gets parameter field collection parent (report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalParameterValue

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalParameterValue

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalParameterValue

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComEndValue | Gets or sets value's end value. |
ComRangeInfo | Gets or sets end value's range info. |
ComRangeValue | Gets or sets end value's range or single value. |
ComStartValue | Gets or sets value's start value. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalParameterValue [Property ComEndValue]

ComEndValue - cCrystalParameterValue

Gets or sets value's end value.

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValue object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterValue [Property ComRangeInfo]

ComRangeInfo - cCrystalParameterValue

Gets or sets end value's range info.

Type: Property

Access: Read/Write

Data Type: CRRangeInfo

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValue object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalParameterValue [Property ComRangeValue]

ComRangeValue - cCrystalParameterValue

Gets or sets end value's range or single value.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValue object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterValue [Property ComStartValue]

ComStartValue - cCrystalParameterValue

Gets or sets value's start value.

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValue object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalParameterValueInfo

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalParameterValueInfo

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalParameterValueInfo

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComParameterName | Gets or sets parameter name. |
ComParameterValues | Gets or sets parameter value collection. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalParameterValueInfo [Property ComParameterName]

ComParameterName - cCrystalParameterValueInfo

Gets or sets parameter name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValueInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterValueInfo [Property ComParameterValues]

ComParameterValues - cCrystalParameterValueInfo

Gets or sets parameter value collection.

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValueInfo object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalParameterValueInfos

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalParameterValueInfos

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Procedure | Adds a value info. |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Delete a value info. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalParameterValueInfos [Procedure ComAdd]

ComAdd - cCrystalParameterValueInfos

Adds a value info.

Type: Procedure

Parameters: Variant llpValueInfo

Parameter | Description
llpValueInfo | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValueInfos object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterValueInfos [Procedure ComDelete]

ComDelete - cCrystalParameterValueInfos

Delete a value info.

Type: Procedure

Parameters: Integer llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValueInfos object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalParameterValueInfos

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets value info count. |
ComItem | Gets a value info. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalParameterValueInfos [Property Com_NewEnum]

Com_NewEnum - cCrystalParameterValueInfos

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValueInfos object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterValueInfos [Property ComCount]

ComCount - cCrystalParameterValueInfos

Gets value info count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValueInfos object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterValueInfos [Property ComItem]

ComItem - cCrystalParameterValueInfos

Gets a value info.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValueInfos object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalParameterValues

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalParameterValues

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Procedure | Adds a parameter value. |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Delete a parameter value. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalParameterValues [Procedure ComAdd]

ComAdd - cCrystalParameterValues

Adds a parameter value.

Type: Procedure

Parameters: Variant llpValue

Parameter | Description
llpValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValues object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterValues [Procedure ComDelete]

ComDelete - cCrystalParameterValues

Delete a parameter value.

Type: Procedure

Parameters: Integer llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValues object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalParameterValues

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets parameter value count. |
ComItem | Gets a parameter value. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalParameterValues [Property Com_NewEnum]

Com_NewEnum - cCrystalParameterValues

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValues object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterValues [Property ComCount]

ComCount - cCrystalParameterValues

Gets parameter value count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValues object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalParameterValues [Property ComItem]

ComItem - cCrystalParameterValues

Gets a parameter value.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIParameterValues object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalPreview

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Exit_Application | Called when an application is about to be closed | AppDialog
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnPaint | Sent every time a panel is painted | MdiDialog
OnResize | Sent every time a panel is resized | MdiDialog
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d
Verify_Exit_Application | Sent by the client area to verify that an application may be exited | AppDialog


Methods for cCrystalPreview

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Activate_View | Procedure | Activates the view | AppDialog
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
AssignViewerDefaults | Procedure | Sets the default COM properties of the cCrystalActiveXReportViewer |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  | MdiDialog
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DisplayReport | Procedure | Attaches a report to COM previewer and activates preview |
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area | MdiDialog
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | MdiDialog
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | MdiDialog
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


cCrystalPreview [Procedure AssignViewerDefaults]

AssignViewerDefaults - cCrystalPreview

Sets the default COM properties of the cCrystalActiveXReportViewer

Type: Procedure

Parameters: handle hoViewer

Parameter | Description
hoViewer | Handle of the viewer object

Description

AssignViewerDefaults sets the default COM properties of the cCrystalActiveXReportViewer. This method is called when the preview is created. This method should be used when subclassing the [CLInk:cCrystalPreview] to change the default COM properties of the cCrystalActiveXReportViewer or the properties of the view.

Last Edited: August 16, 2005


cCrystalPreview [Procedure DisplayReport]

DisplayReport - cCrystalPreview

Attaches a report to COM previewer and activates preview

Type: Procedure

Parameters: Handle hoReport

Parameter | Description
hoReport | Handle of viewer object

Description

DisplayReport attaches a report to COM previewer and activates the preview. This method should be used when subclassing the cCrystalPreview to change the default behavior of the preview.

Last Edited: August 16, 2005


Properties for cCrystalPreview

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | MdiDialog
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | MdiDialog
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | MdiDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phoActiveXReportViewer | Holds the object-handle of the Crystal COM preview object |
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piZoom | Default zoom level for the report |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cCrystalPreview [Property phoActiveXReportViewer]

phoActiveXReportViewer - cCrystalPreview

Holds the object-handle of the Crystal COM preview object

Type: Property

Access: Read/Write

Data Type: Handle

Description

phoActiveXReportViewer holds the object-handle of the Crystal COM preview object. To access this property please use ActiveXReportViewerObject.

See Also

cCrystalActiveXReportViewer

Last Edited: August 16, 2005


cCrystalPreview [Property piZoom]

piZoom - cCrystalPreview

Default zoom level for the report

Type: Property

Access: Read/Write

Data Type: Integer

Description

piZoom contains the default zoom level for a report. A value of 1= fit width, 2 = fit page, all other numbers are a percentage. The default value of this property is 1.

A hook method has been provided for you to use when setting preview options. The event is OnDisplayReport and is located in the class cCrystal.

Sample

Object oMyReport is a Crystal
    Set psReportName To "wines1.rpt"

    Procedure OnDisplayReport Handle hoReport
        Handle hoPreview

        Forward Send OnDisplayReport

        Get PreviewObject of hoReport to hoPreview
        If (hoPreview) Begin
            // Preview Panel
            Set piZoom of hoPreview to 75 // percent
        End
    End_Procedure // OnDisplayReport
End_Object // oMyReport

See Also

cCrystalActiveXReportViewer

Last Edited: August 16, 2005


Events for cCrystalPrintingStatus

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalPrintingStatus

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalPrintingStatus

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComNumberOfPages | Gets total number of pages in the report. |
ComNumberOfRecordPrinted | Gets the number of record printed. |
ComNumberOfRecordRead | Gets the number of record read. |
ComNumberOfRecordSelected | Gets the number of record selected. |
ComParent | Gets printing status's parent (Report) |
ComProgress | Gets the printing progress. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalPrintingStatus [Property ComNumberOfPages]

ComNumberOfPages - cCrystalPrintingStatus

Gets total number of pages in the report.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPrintingStatus object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPrintingStatus [Property ComNumberOfRecordPrinted]

ComNumberOfRecordPrinted - cCrystalPrintingStatus

Gets the number of record printed.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPrintingStatus object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPrintingStatus [Property ComNumberOfRecordRead]

ComNumberOfRecordRead - cCrystalPrintingStatus

Gets the number of record read.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPrintingStatus object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPrintingStatus [Property ComNumberOfRecordSelected]

ComNumberOfRecordSelected - cCrystalPrintingStatus

Gets the number of record selected.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPrintingStatus object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPrintingStatus [Property ComParent]

ComParent - cCrystalPrintingStatus

Gets printing status's parent (Report)

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPrintingStatus object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalPrintingStatus [Property ComProgress]

ComProgress - cCrystalPrintingStatus

Gets the printing progress.

Type: Property

Access: Read-Only

Data Type: CRPrintingProgress

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIPrintingStatus object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalReport [Event OnComAfterFormatPage]

OnComAfterFormatPage - cCrystalReport

Fires this event after formatting a page

Type: Event

Parameters: Integer llPageNumber

Parameter | Description
llPageNumber | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportEvent object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Event OnComBeforeFormatPage]

OnComBeforeFormatPage - cCrystalReport

Fires this event before formatting a page

Type: Event

Parameters: Integer llPageNumber

Parameter | Description
llPageNumber | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportEvent object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Event OnComFieldMapping]

OnComFieldMapping - cCrystalReport

Fires this event if database is changed while verifing database

Type: Event

Parameters: Variant llreportFieldArray Variant lldatabaseFieldArray Boolean ByRef lluseDefault

Parameter | Description
llreportFieldArray | Please see Crystal RDC documentation for more information.
lldatabaseFieldArray | Please see Crystal RDC documentation for more information.
ByRef lluseDefault | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportEvent object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Event OnComNoData]

OnComNoData - cCrystalReport

Fires this event when there is no data

Type: Event

Parameters: Boolean ByRef llpCancel

Parameter | Description
ByRef llpCancel | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportEvent object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalReport

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnComAfterFormatPage | Fires this event after formatting a page |
OnComBeforeFormatPage | Fires this event before formatting a page |
OnComFieldMapping | Fires this event if database is changed while verifing database |
OnComNoData | Fires this event when there is no data |
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalReport [Function ActiveXReportViewerObject]

ActiveXReportViewerObject - cCrystalReport

Returns handle of the ActiveX Report Viewer COM object in which the Crystal Reports report is displayed

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Handle of COM viewer object

Description

ActiveXReportViewerObject returns handle of COM object in which the Crystal Reports report is displayed. You will need this handle if you intend to set the COM properties.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"

    Procedure OnDisplayReport Handle hoReport
        Handle hoViewer

        Forward Send OnDisplayReport hoReport

        Get ActiveXReportViewerObject of hoReport to hoViewer
        Set ComDisplayToolbar of hoViewer To TRUE
        Set ComDisplayBorder of hoViewer To FALSE
        Set ComDisplayTabs of hoViewer To FALSE
        Set ComDisplayBackgroundEdge of hoViewer To TRUE
        Set ComDisplayGroupTree of hoViewer To FALSE
        Set ComEnableGroupTree of hoViewer To FALSE
        Set ComEnableStopButton of hoViewer To FALSE
        Set ComEnablePrintButton of hoViewer To TRUE
        Set ComEnableCloseButton of hoViewer To FALSE
        Set ComEnableRefreshButton of hoViewer To FALSE
        Set ComEnableExportButton of hoViewer To TRUE
        Set ComEnableSearchExpertButton of hoViewer To TRUE
        Set ComEnableHelpButton of hoViewer To FALSE
        Set ComEnableZoomControl of hoViewer To TRUE
        Set ComEnableProgressControl of hoViewer To TRUE
        Set ComEnableSearchControl of hoViewer To TRUE
        Set ComEnableNavigationControls of hoViewer To TRUE
        Set ComEnableDrillDown of hoViewer To FALSE
        Set ComEnableAnimationCtrl of hoViewer To TRUE
        Set ComEnableSelectExpertButton of hoViewer To FALSE
        Set ComEnablePopupMenu of hoViewer To FALSE
        Set ComLaunchHTTPHyperlinksInNewBrowser of hoViewer To  TRUE
    End_Procedure
End_Object

See Also

cCrystalActiveXReportViewer | OnDisplayReport | PreviewObject | AssignPreviewObject

Last Edited: August 19, 2005


cCrystalReport [Function ComGetNextRows]

ComGetNextRows - cCrystalReport

Get Rowset.

Type: Function

Return Data Type: Variant

Parameters: Integer llstartRowN Integer ByRef llpRowN

Parameter | Description
llstartRowN | Please see Crystal RDC documentation for more information.
ByRef llpRowN | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Function ComGetReportVariableValue]

ComGetReportVariableValue - cCrystalReport

Gets a report variable

Type: Function

Return Data Type: Variant

Parameters: String llpName

Parameter | Description
llpName | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Function ComOpenSubreport]

ComOpenSubreport - cCrystalReport

Gets specified subreport.

Type: Function

Return Data Type: Variant

Parameters: String llpSubreportName

Parameter | Description
llpSubreportName | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Function ComPrinterSetupEx]

ComPrinterSetupEx - cCrystalReport

Set up current printer.

Type: Function

Return Data Type: Integer

Parameters: Integer llhWnd

Parameter | Description
llhWnd | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Function CreateCDO]

CreateCDO - cCrystalReport

Returns the handle to a CDO COM object based on a TTX file

Type: Function

Return Data Type: Handle

Parameters: String sFileName

Parameter | Description
sFileName | File name (case sensitive)

Return Value

Returns the handle to a CDO COM object based on the contents of a TTX file.

Description

CreateCDO returns the handle to a CDO COM object based on the contents of a TTX file. You must supply the name of the TTX file which is in the same directory as the Crystal Reports report. You will move your data into a Variant array with the same number of columns as there are fields of the TTX file. When you use the AppendCDOData method, the data passed to the CDO will be formatted with the datatype listed in the TTX file.

CDOs can be a very powerful tool. They are used to pass data that only exists at runtime to a Crystal Reports report. This can be used like a tempfile only there is no maintenance in cleaning up records or files left on the physical drive.

One of the common problems in using a validation table was that it was difficult or impossible to print the data from a validation table in a Crystal Report. This is not only possible, but easy to do. Validation Tables now have a function TableData to return an array of the data which you can pass to the CDO with AppendCDOData.

Sample

Object oCrystalReport1 is a cCrystal
    Set psReportName To "PercentageFilled.rpt"

    Procedure OnInitializeReport Handle hoReport
        Handle  hoCDO
        Integer iItem
        Variant[][3] vData

        Forward Send OnInitializeReport hoReport

        Get CreateCDO of hoReport "Stuff.ttx" to hoCDO
        If (hoCDO) begin
            Direct_input "c:\MyListOfStuff.txt"
            Move 0 to iItem
            While (not(SeqEof))
                Readln vData[iItem][0], vData[iItem][1], vData[iItem][2]
                Increment iItem
            End
            // Add rows to CDO object
            Send AppendCDOData of hoReport hoCDO vData
        End
    End_Procedure // OnIntializeReport
End_Object // oCrystalReport1

See Also

CreateCDO | cCrystalCrystalComObject | AttachCDO | TableData

Last Edited: October 26, 2006


cCrystalReport [Function DatabaseObject]

DatabaseObject - cCrystalReport

Returns handle of cCrystalDatabase COM object assigned to the report.

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns handle of cCrystalDatabase COM object assigned to the report.

Description

DatabaseObject returns handle of cCrystalDatabase COM object assigned to the report.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "CustList.rpt"

    Procedure OnInitializeReport Handle hoReport
        Handle hoDatabase

        Forward Send OnInitializeReport hoReport

        Get DatabaseObject of hoReport to hoDatabase
        If (hoDatabase) Begin
            Send ComLogOnServer of hoDatabase "DllName" "ServerName" "DatabaseName" "UserID" "Password"
        End
    End_Procedure // OnInitializeReport
End_Object // oCrystalReport

Last Edited: August 17, 2005


cCrystalReport [Function ExportObject]

ExportObject - cCrystalReport

Returns handle of COM object for export options

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Handle of COM object for export options

Description

ExportObject returns handle of COM object for the export options.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "CustList.rpt"

    Procedure OnExportReport Handle hoReport
        Handle hoExport

        Forward Send OnExportReport hoReport

        Set pbExportPrompt of hoReport to FALSE
        Get ExportObject of hoReport to hoExport
        Set ComDiskFileName of hoExport To "D:\Documents\MyReport.rtf"
        Set ComFormatType of hoExport To crEFTExactRichText // Rich Text
    End_Procedure // OnExportReport
End_Object // oCrystalReport

See Also

OnExportReport | pbExportPrompt | cCrystalExportOptions

Last Edited: August 16, 2005


cCrystalReport [Function GetParamObjectByName]

GetParamObjectByName - cCrystalReport

Returns handle of the Name Parameter Field Definition COM object

Type: Function

Return Data Type: Handle

Parameters: String sParamName

Parameter | Description
sParamName | Parameter name

Return Value

Handle of COM object or 0

Description

GetParamObjectByName returns handle of the COM object for a parameter with the name it was passed. Once you have this object handle, you will use the COM methods for the cCrystalParameterFieldDefinition. Returns 0 if the object could not be created or was not found in the report.

Last Edited: August 16, 2005


cCrystalReport [Function GetSubReportObjectbyName]

GetSubReportObjectbyName - cCrystalReport

Returns handle of the name Sub-report COM object

Type: Function

Return Data Type: Handle

Parameters: String sReportName

Parameter | Description
sReportName | Report name

Return Value

Handle of COM object or 0

Description

GetSubReportObjectbyName returns handle of the COM object for a subreport with the name it was passed. Once you have this object handle, you will use the COM methods for the cCrystalReport. Returns 0 if the object could not be created or was not found in the report.

Last Edited: August 16, 2005


cCrystalReport [Function GetTableObjectByName]

GetTableObjectByName - cCrystalReport

Returns handle of the named Database Table COM object

Type: Function

Return Data Type: Handle

Parameters: String sTable

Parameter | Description
sTable | Table name

Return Value

Handle of COM object or 0

Description

GetTableObjectByName returns handle of the COM object for a table with the name it was passed. Once you have this object handle, you will use the COM methods for the cCrystalDatabaseTable. Returns 0 if the object could not be created or was not found in the report.

Last Edited: August 16, 2005


cCrystalReport [Function LocateDFFile]

LocateDFFile - cCrystalReport

Set the location of an embedded database (DataFlex) data file (.dat or .int) to the data directory

Type: Function

Return Data Type: Boolean

Parameters: Handle hoDatabaseTable

Parameter | Description
hoDatabaseTable | Handle of table

Return Value

Returns TRUE if successful.

Description

LocateDFFile attempts to locate a table in the report within the workspace's data path. If the table is located, the report's data path for that table is pointed to that location. Returns TRUE if it was successful.

This method is not needed when pbAutoLocateDFFiles is set to TRUE.

See Also

LocateDFFiles | pbAutoLocateDFFiles

Last Edited: August 17, 2005


cCrystalReport [Function LocateDFFiles]

LocateDFFiles - cCrystalReport

Locate all embedded database (DataFlex) files for report and sub-report assign them to the data directory

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns TRUE if successful.

Description

LocateDFFiles attempts to locate all the tables in the report within the workspace's data path. If the tables were located, the report's data path for each table is pointed to the location each table was found. Returns TRUE if it was successful.

This method is not needed when pbAutoLocateDFFiles is set to TRUE.

See Also

LocateDFFile | pbAutoLocateDFFiles

Last Edited: August 17, 2005


cCrystalReport [Function ParamObjects]

ParamObjects - cCrystalReport

Returns an array of object handles attached to all Parameter Field Definition COM objects

Type: Function

Return Data Type: Handle[]

Parameters: No Parameters

Return Value

Array of object handles attached to COM objects

Description

ParamObjects, like the method GetParamObjectByName, handles the creation of the VDF object and attaching it to the COM object. If you do not know the name of the parameter, you can use this method to get an array of object handles of all parameters in the report.

Sample

Object oMyReport is a cCrystal
    Set psReportName To "wines1.rpt"

    Procedure OnInitializeReport Handle hoReport
        Handle[] hoParam

        Forward Send OnInitializeReport hoReport

        Get ParamObjects of hoReport to hoParam
        If (hoParam) Begin
            // :
        End
    End_Procedure // OnInitializeReport
End_Object // oMyReport

See Also

cCrystalParameterFieldDefinition

Last Edited: January 5, 2006


cCrystalReport [Function PreviewObject]

PreviewObject - cCrystalReport

Returns handle of preview object

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Handle of preview object

Description

PreviewObject returns handle of preview object assigned to the report. If no preview object exists, it is created based on the property phcPreviewObject. The preview object contains the COM object used to preview a report.

Sample

Object oMyReport is a cCrystal
    Set psReportName To "wines1.rpt"

    Procedure OnInitializeReport Handle hoReport
        Handle hoPreview

        Forward Send OnInitializeReport hoReport

        Get PreviewObject of hoReport to hoPreview
        If (hoPreview) Begin
            Set Label of hoPreview to "Sample Report Output"
        End
    End_Procedure // OnInitializeReport
End_Object // oMyReport

See Also

phcPreviewObject | cCrystalPreview | AssignPreviewObject

Last Edited: September 12, 2005


cCrystalReport [Function SubReportObjects]

SubReportObjects - cCrystalReport

Returns an array of object handles attached to all Sub-Report COM objects

Type: Function

Return Data Type: Handle[]

Parameters: No Parameters

Return Value

Array of object handles attached to COM objects

Description

SubReportObjects, like the method GetSubreportObjectByName, handles the creation of the VDF object and attaching it to the COM object. If you do not know the name of the subreport, you can use this method to get an array of object handles of all subreports in the report.

Sample

Object oMyReport is a cCrystal
    Set psReportName To "wines1.rpt"

    Procedure OnInitializeReport Handle hoReport
        Handle[] hoSubReport

        Forward Send OnInitializeReport hoReport

        Get SubReportObjects of hoReport to hoSubReport
        If (hoSubReport) Begin
            // :
        End
    End_Procedure // OnInitializeReport
End_Object // oMyReport

Last Edited: January 5, 2006


cCrystalReport [Function TableObjects]

TableObjects - cCrystalReport

Returns an array of object handles attached to Database Table COM objects

Type: Function

Return Data Type: Handle[]

Parameters: No Parameters

Return Value

Array of object handles attached to COM objects

Description

TableObjects, like the method GetTableObjectByName, handles the creation of the VDF object and attaching it to the COM object. If you do not know the name of the table, you can use this method to get an array of object handles of all tables in the report.

Sample

Object oMyReport is a cCrystal
    Set psReportName To "wines1.rpt"

    Procedure OnInitializeReport Handle hoReport
        Handle[] hoTable

        Forward Send OnInitializeReport hoReport

        Get TableObjects of hoReport to hoTable
        If (hoTable) Begin
            // :
        End
    End_Procedure // OnInitializeReport
End_Object // oMyReport

See Also

cCrystalDatabaseTable

Last Edited: January 5, 2006


Methods for cCrystalReport

View method list in hierarchical order

Name | Type | Description | Defining Class
ActiveXReportViewerObject | Function | Returns handle of the ActiveX Report Viewer COM object in which the Crystal Reports report is displayed |
AppendCDOData | Procedure | Adds data from a safe-array to a Crystal Data Object (CDO) |
AppendSortField | Procedure | Adds a field to the Crystal Reports report sort order |
AppendSortFormulaField | Procedure | Adds a formula field to the Crystal Reports report sort order |
AssignFormula | Procedure | Sets the value of a Crystal Reports report formula field |
AssignPreviewObject | Procedure | Sets the object to receive the report output |
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
AttachCDO | Procedure | Attaches an existing CDO to a Crystal Reports report |
ComAddGroup | Procedure | Adds a group. |
ComAddref | Procedure |  | DfComAutomationObject
ComAddReportVariable | Procedure | Adds a report variable |
ComAutoSetUnboundFieldSource | Procedure | Automatically bind unbound fields to database fields. |
ComCancelPrinting | Procedure | Cancels exporting/printing. |
ComDeleteGroup | Procedure | Delete a group |
ComDiscardSavedData | Procedure | Discards report saved data. |
ComExport | Procedure | Exports the report to other formats. |
ComGetNextRows | Function | Get Rowset. |
ComGetReportVariableValue | Function | Gets a report variable |
ComOpenSubreport | Function | Gets specified subreport. |
ComPrinterSetup | Procedure | Set up current printer. |
ComPrinterSetupEx | Function | Set up current printer. |
ComPrintOut | Procedure | Prints the report to printer. |
ComPrintOutEx | Procedure | Prints the report to printer or file. |
ComQueryInterface | Function |  | DfComAutomationObject
ComReadRecords | Procedure | Forces to read in data. |
ComSaveAs | Procedure | Saves the report to another file. |
ComSelectPrinter | Procedure | Selects a printer. |
ComSetDialogParentWindow | Procedure | Sets dialog parent window. |
ComSetReportVariableValue | Procedure | Sets a report variable value |
ComSetUserPaperSize | Procedure | sets customer printer paper size. |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateCDO | Function | Returns the handle to a CDO COM object based on a TTX file |
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
DatabaseObject | Function | Returns handle of cCrystalDatabase COM object assigned to the report. |
DeleteNthSortField | Procedure | Removes a field in the Nth position from the sort order of a Crystal Reports report |
DeleteSortOrder | Procedure | Deletes a field sort order in a Crystal Reports report |
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
ExportObject | Function | Returns handle of COM object for export options |
GetParamObjectByName | Function | Returns handle of the Name Parameter Field Definition COM object |
GetSubReportObjectbyName | Function | Returns handle of the name Sub-report COM object |
GetTableObjectByName | Function | Returns handle of the named Database Table COM object |
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
LocateDFFile | Function | Set the location of an embedded database (DataFlex) data file (.dat or .int) to the data directory |
LocateDFFiles | Function | Locate all embedded database (DataFlex) files for report and sub-report assign them to the data directory |
ParamObjects | Function | Returns an array of object handles attached to all Parameter Field Definition COM objects |
PreviewObject | Function | Returns handle of preview object |
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SubReportObjects | Function | Returns an array of object handles attached to all Sub-Report COM objects |
TableObjects | Function | Returns an array of object handles attached to Database Table COM objects |


cCrystalReport [Procedure AppendCDOData]

AppendCDOData - cCrystalReport

Adds data from a safe-array to a Crystal Data Object (CDO)

Type: Procedure

Parameters: Handle hoCDO Variantiant vCDOData

Parameter | Description
hoCDO | Handle of CDO object
vCDOData | Variant array holding data to add

Description

AppendCDOData converts a safe array to the correct datatypes used by the CDO and adds that data to CDO.

This is a helper method to make working with CDO's easier. Arrays store data in the same type it was passed. CDO's require that the array contain the data in the correct datatype listed in the TTX file. This method will ensure that your data is of the correct type before it is added to the CDO.

Sample

Object oCrystalReport1 is a cCrystal
    Set psReportName To "PercentageFilled.rpt"

    Procedure OnInitializeReport Handle hoReport
        Handle hoCDO
        Integer iItem
        Variant[][3] vData

        Forward Send OnInitializeReport hoReport

        Get CreateCDO of hoReport "Stuff.ttx" to hoCDO
        If (hoCDO) begin
            // : fill array
            // Add rows to CDO object
            Send AppendCDOData of hoReport hoCDO vData
        End
    End_Procedure // OnIntializeReport
End_Object // oCrystalReport1

See Also

CreateCDO | AppendCDOData | cCrystalCrystalComObject | TableData

Last Edited: August 16, 2005


cCrystalReport [Procedure AppendSortField]

AppendSortField - cCrystalReport

Adds a field to the Crystal Reports report sort order

Type: Procedure

Parameters: String sTable String sField crSortDirection SortOrder

Parameter | Description
sTable | Table name
sField | Field name
SortOrderSort order.
Can be one of:

crAscendingOrder | Ascending sort order
crDescendingOrder | Descending sort order
crOriginalOrder | Original sort order
crSpecifiedOrder | Specified sort order

Description

AppendSortField is a helper method which adds a field to the Crystal Reports report sort order. A group sort order is applied to the report before the field sort order is applied.

Sample

Object oMyReport is a Crystal
    Set psReportName To "CustLst.rpt"

    Procedure OnInitializeReport handle hoReport
        Integer iSort

        Forward Send OnInitializeReport hoReport

        Send DeleteSortOrder of hoReport
        Get Current_Radio of oSortOrder to iSort
        If (iSort=0) Begin // Customer Name, Customer Code
            Send AppendSortField of hoReport "Customer" "Name" crAscendingOrder
            Send AppendSortField of hoReport "Customer" "Code" crAscendingOrder
        End
        If (iSort=1) Begin // State, Customer Name, Customer Code
            Send AppendSortField of hoReport "Customer" "State" crAscendingOrder
            Send AppendSortField of hoReport "Customer" "Name" crAscendingOrder
            Send AppendSortField of hoReport "Customer" "Code" crAscendingOrder
        End
    End_Procedure // OnInitializeReport
 End_Object // oMyReport

See Also

AppendSortFormulaField | DeleteNthSortField | DeleteSortOrder | cCrystalSortFields | cCrystalSortField | cCrystalGroupNameFieldDefinitions

Last Edited: August 16, 2005


cCrystalReport [Procedure AppendSortFormulaField]

AppendSortFormulaField - cCrystalReport

Adds a formula field to the Crystal Reports report sort order

Type: Procedure

Parameters: String sFormulaName crSortDirection SortOrder

Parameter | Description
sFormulaName | Formula name
SortOrderSort order.
Can be one of:

crAscendingOrder | Ascending sort order
crDescendingOrder | Descending sort order
crOriginalOrder | Original sort order
crSpecifiedOrder | Specified sort order

Description

AppendSortFormulaField is a helper method which adds a formula field to the Crystal Reports report sort order. A group sort order is applied to the report before the field sort order is applied.

Sample

Object oMyReport is a Crystal
    Set psReportName To "oLabels.rpt"

    Procedure OnInitializeReport handle hoReport
        Integer iSort

        Forward Send OnInitializeReport hoReport

        Send DeleteSortOrder of hoReport
        Send AppendSortFormulaField of hoReport "CSZ" crAscendingOrder
    End_Procedure // OnInitializeReport
 End_Object // oMyReport

See Also

AppendSortField | DeleteNthSortField | DeleteSortOrder | cCrystalSortFields | cCrystalSortField

Last Edited: August 16, 2005


cCrystalReport [Procedure AssignFormula]

AssignFormula - cCrystalReport

Sets the value of a Crystal Reports report formula field

Type: Procedure

Parameters: String sFormulaName String sValue

Parameter | Description
sFormulaName | Formula name
sValue | Formula

Description

AssignFormula sets the value of a Crystal Reports report formula field. In Crystal Reports, formulas are identified by the "@" sign in front of the formula name. If you access a formula by name from VDF, you don't need to supply the "@" sign.

Sample

Object oMyReport is a Crystal
    Set psReportName To "wines1.rpt"

    Procedure OnInitializeReport Handle hoReport
        Forward Send OnInitializeReport hoReport
        // Don't supply the "@" sign with the formula name.
        Send AssignFormula of hoReport "ext_price" "{wines.QUANTITY} * {wines.COST}"
    End_Procedure // OnInitializeReport

End_Object // oMyReport

See Also

cCrystalFormulaFieldDefinitions | cCrystalFormulaFieldDefinition

Last Edited: August 16, 2005


cCrystalReport [Procedure AssignPreviewObject]

AssignPreviewObject - cCrystalReport

Sets the object to receive the report output

Type: Procedure

Parameters: Handle hoPreview

Parameter | Description
hoPreview | Handle of preview object

Description

AssignPreviewObject sets the object to receive the report output when the peOutputDestination is Print_to_Screen. The object assigned to receive the report output must contain the following:

  • The property phoActiveXReportViewer which contains the handle of the cCrystalActiveXReportViewer
  • The message DisplayReport
  • The cCrystalActiveXReportViewer object

Sample

Object oMyReport is a Crystal
    Set psReportName To "wines1.rpt"

    Procedure OnDisplayReport Handle hoReport
        Forward Send OnDisplayReport hoReport
        Send AssignPreviewObject of hoReport (SomeDialog_dg(Self))
    End_Procedure // OnDisplayReport
End_Object // oMyReport

See Also

cCrystalActiveXReportViewer | OnDisplayReport | PreviewObject | ActiveXReportViewerObject

Last Edited: August 19, 2005


cCrystalReport [Procedure AttachCDO]

AttachCDO - cCrystalReport

Attaches an existing CDO to a Crystal Reports report

Type: Procedure

Parameters: String sFileName Handle hoCDO

Parameter | Description
sFileName | File name
hoCDO | Handle of CDO object

Description

AttachCDO attaches an existing CDO to a Crystal Reports report. This is usefull when a CDO is shared by multiple reports. Create the CDO once and attach it to each report.

Sample

Object oMyReport is a Crystal
    Set psReportName To "samplecdo.rpt"

    Procedure OnInitializeReport Handle hoReport
        Forward Send OnInitializeReport hoReport
        Send AttachCDO of hoReport "Terms.ttx" oTermsCDO
    End_Procedure // OnInitializeReport

End_Object // oMyReport

See Also

CreateCDO | AppendCDOData | cCrystalCrystalComObject | TableData

Last Edited: August 16, 2005


cCrystalReport [Procedure ComAddGroup]

ComAddGroup - cCrystalReport

Adds a group.

Type: Procedure

Parameters: Short llGroupNumber Variant llpConditionField CRGroupCondition llCondition CRSortDirection llSortDirection

Parameter | Description
llGroupNumber | Please see Crystal RDC documentation for more information.
llpConditionField | Please see Crystal RDC documentation for more information.
llCondition | Please see Crystal RDC documentation for more information.
llSortDirection | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComAddReportVariable]

ComAddReportVariable - cCrystalReport

Adds a report variable

Type: Procedure

Parameters: CRReportVariableValueType lltype String llpName Integer llarraySize Variant llreserved

Parameter | Description
lltype | Please see Crystal RDC documentation for more information.
llpName | Please see Crystal RDC documentation for more information.
llarraySize | Please see Crystal RDC documentation for more information.
llreserved | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComAutoSetUnboundFieldSource]

ComAutoSetUnboundFieldSource - cCrystalReport

Automatically bind unbound fields to database fields.

Type: Procedure

Parameters: CRBindingMatchType llmatchType Variant llbindSubReports

Parameter | Description
llmatchType | Please see Crystal RDC documentation for more information.
llbindSubReports | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComCancelPrinting]

ComCancelPrinting - cCrystalReport

Cancels exporting/printing.

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComDeleteGroup]

ComDeleteGroup - cCrystalReport

Delete a group

Type: Procedure

Parameters: Short llGroupNumber

Parameter | Description
llGroupNumber | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComDiscardSavedData]

ComDiscardSavedData - cCrystalReport

Discards report saved data.

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComExport]

ComExport - cCrystalReport

Exports the report to other formats.

Type: Procedure

Parameters: Variant llpromptUser

Parameter | Description
llpromptUser | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComPrinterSetup]

ComPrinterSetup - cCrystalReport

Set up current printer.

Type: Procedure

Parameters: Integer llhWnd

Parameter | Description
llhWnd | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComPrintOut]

ComPrintOut - cCrystalReport

Prints the report to printer.

Type: Procedure

Parameters: Variant llpromptUser Variant llnumberOfCopy Variant llcollated Variant llstartPageN Variant llstopPageN

Parameter | Description
llpromptUser | Please see Crystal RDC documentation for more information.
llnumberOfCopy | Please see Crystal RDC documentation for more information.
llcollated | Please see Crystal RDC documentation for more information.
llstartPageN | Please see Crystal RDC documentation for more information.
llstopPageN | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComPrintOutEx]

ComPrintOutEx - cCrystalReport

Prints the report to printer or file.

Type: Procedure

Parameters: Variant llpromptUser Variant llnumberOfCopy Variant llcollated Variant llstartPageN Variant llstopPageN String llprintFileName

Parameter | Description
llpromptUser | Please see Crystal RDC documentation for more information.
llnumberOfCopy | Please see Crystal RDC documentation for more information.
llcollated | Please see Crystal RDC documentation for more information.
llstartPageN | Please see Crystal RDC documentation for more information.
llstopPageN | Please see Crystal RDC documentation for more information.
llprintFileName | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComReadRecords]

ComReadRecords - cCrystalReport

Forces to read in data.

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComSaveAs]

ComSaveAs - cCrystalReport

Saves the report to another file.

Type: Procedure

Parameters: String llpFilePath CRReportFileFormat llfileFormat

Parameter | Description
llpFilePath | Please see Crystal RDC documentation for more information.
llfileFormat | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComSelectPrinter]

ComSelectPrinter - cCrystalReport

Selects a printer.

Type: Procedure

Parameters: String llpDriverName String llpPrinterName String llpPortName

Parameter | Description
llpDriverName | Please see Crystal RDC documentation for more information.
llpPrinterName | Please see Crystal RDC documentation for more information.
llpPortName | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComSetDialogParentWindow]

ComSetDialogParentWindow - cCrystalReport

Sets dialog parent window.

Type: Procedure

Parameters: Integer llhWnd

Parameter | Description
llhWnd | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComSetReportVariableValue]

ComSetReportVariableValue - cCrystalReport

Sets a report variable value

Type: Procedure

Parameters: String llpName Variant llvar

Parameter | Description
llpName | Please see Crystal RDC documentation for more information.
llvar | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure ComSetUserPaperSize]

ComSetUserPaperSize - cCrystalReport

sets customer printer paper size.

Type: Procedure

Parameters: Short lllength Short llWidth

Parameter | Description
lllength | Please see Crystal RDC documentation for more information.
llWidth | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Procedure DeleteNthSortField]

DeleteNthSortField - cCrystalReport

Removes a field in the Nth position from the sort order of a Crystal Reports report

Type: Procedure

Parameters: Integer iSortItem

Parameter | Description
iSortItem | Position of sort order to remove field from

Description

DeleteNthSortField removes a field in the Nth position from the sort order of a Crystal Reports report.

Sample

Object oMyReport is a cCrystal
    Set psReportName To "wines1.rpt"

    Procedure OnInitializeReport handle hoReport
        Handle hoRecordSort
        Integer iSortFields iCounter

        Forward Send OnInitializeReport hoReport

        Get RecordSortObject of hoReport to hoRecordSort

        // Delete all sort fields except for the first,
        // and then add a sort field.
        Get ComCount of hoRecordSort To iSortFields
        Move 2 To iCounter // We want to keep the first sort field
        While iCounter Lt iSortFields
            Send DeleteNthSortField of hoReport iCounter
            Increment iCounter
        End // While iCounter Lt iSortFields

        Send AppendSortField of hoReport "wine" "year" crAscendingOrder
    End_Procedure // OnInitializeReport
 End_Object // oMyReport

See Also

DeleteSortOrder | cCrystalSortFields | cCrystalSortField | cCrystalGroupNameFieldDefinitions | AppendSortField

Last Edited: September 2, 2005


cCrystalReport [Procedure DeleteSortOrder]

DeleteSortOrder - cCrystalReport

Deletes a field sort order in a Crystal Reports report

Type: Procedure

Parameters: No Parameters

Description

DeleteSortOrder deletes a field sort order in a Crystal Reports report.

Sample

Object oMyReport is a Crystal
    Set psReportName To "CustLst.rpt"

    Procedure OnInitializeReport handle hoReport
        Integer iSort

        Forward Send OnInitializeReport hoReport

        Send DeleteSortOrder of hoReport
        Get Current_Radio of oSortOrder to iSort
        If (iSort=0) Begin // Customer Name, Customer Code
            Send AppendSortField of hoReport "Customer" "Name" crAscendingOrder
            Send AppendSortField of hoReport "Customer" "Code" crAscendingOrder
        End
        If (iSort=1) Begin // State, Customer Name, Customer Code
            Send AppendSortField of hoReport "Customer" "State" crAscendingOrder
            Send AppendSortField of hoReport "Customer" "Name" crAscendingOrder
            Send AppendSortField of hoReport "Customer" "Code" crAscendingOrder
        End
    End_Procedure // OnInitializeReport
 End_Object // oMyReport

See Also

DeleteNthSortField | cCrystalSortFields | cCrystalSortField | cCrystalGroupNameFieldDefinitions | AppendSortField

Last Edited: August 16, 2005


Properties for cCrystalReport

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComApplication | Gets application object |
ComApplicationName | Gets or sets application name. |
ComAreas | Gets area collection. |
ComBottomMargin | Gets or sets page bottom margin (twips). |
ComCanPerformGroupingOnServer | Checks whether the report can perform grouping on the server. |
ComCaseInsensitiveSQLData | Gets or sets case insensitive SQL data report option. |
ComConvertDateTimeType | Gets or sets convert date time to date report option. |
ComConvertNullFieldToDefault | Gets or sets convert Null field to default report option. |
ComDatabase | Gets database manager. |
ComDisplayProgressDialog | Enables or disables progress dialog |
ComDriverName | Gets driver name used by the current printer. |
ComEnableAsyncQuery | Gets or sets enable AsyncQuery. |
ComEnableGeneratingDataForHiddenObject | Gets or sets Enable Generating Data For Hidden Object. |
ComEnableParameterPrompting | Enables or disables prompting for parameter field |
ComEnablePerformQueriesAsynchronously | Gets or sets perform queries asynchronously option. |
ComEnableSelectDistinctRecords | Gets or sets select distinct records option. |
ComExportOptions | Gets export options object. |
ComFieldMappingType | Gets or Sets field mapping type. |
ComFormulaFields | Gets formula field definition collection. |
ComFormulaSyntax | Gets or sets report formula syntax. |
ComGroupNameFields | Gets group name field definition collection. |
ComGroupSelectionFormula | Gets or sets group selection formula. |
ComGroupSortFields | Gets group sort field collection. |
ComHasSavedData | Checks whether the report has saved data in memory. |
ComKeywordsInReport | Gets or sets keywords in report. |
ComKind | Gets report kind. |
ComLastGetFormulaSyntax | Gets formula syntax of last formula text returned. |
ComLeftMargin | Gets or sets page left margin (twips). |
ComNeedUpdatePages | Gets whether the user needs to reget pages for display because of the changes in the report. |
ComNumberOfGroup | Gets the number of groups in the report. |
ComPageEngine | Get pageEngine object. |
ComPaperOrientation | Gets or sets current printer paper orientation. |
ComPaperSize | Gets or sets current printer paper size. |
ComPaperSource | Gets or Sets the current printer paper source. |
ComParameterFields | Gets parameter field definition collection. |
ComParent | Gets report parent. (NULL or Main Report) |
ComPerformGroupingOnServer | Gets or sets performing grouping on server option. |
ComPortName | Gets port name used by the current printer. |
ComPrintDate | Gets or sets print date. |
ComPrinterDuplex | Gets or Sets the current printer duplex option. |
ComPrinterName | Gets current printer name. |
ComPrintingStatus | Gets printing status object. |
ComRecordSelectionFormula | Gets or sets record selection formula. |
ComRecordSortFields | Gets reocord sort field collection. |
ComReportAlerts | Gets report alert. |
ComReportAuthor | Gets or sets report author. |
ComReportComments | Gets or sets report comments. |
ComReportFormatStyle | Gets or sets a report format style. |
ComReportSubject | Gets or sets report subject. |
ComReportTemplate | Gets or sets report template. |
ComReportTitle | Gets or sets report title. |
ComRightMargin | Gets or sets page right margin (twips). |
ComRunningTotalFields | Gets running total field collection. |
ComSavePreviewPicture | Gets or sets save preview picture with report option. |
ComSections | Gets section collection within the report. |
ComSQLExpressionFields | Gets SQL expression field collection. |
ComSQLQueryString | Gets or sets SQL query string. |
ComSummaryFields | Gets summary field definition collection. |
ComTopMargin | Gets or sets page top margin (twips). |
ComUseIndexForSpeed | Gets or sets use index for speed report option. |
ComVerifyOnEveryPrint | Gets or sets verify on every print report option. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbExportPrompt | Controls automatic prompting of export options |
pbPrinterCollate | Controls collate property for the printer |
pbPrinterPrompt | Controls automatic prompting of printer setup |
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piPrinterCopies | Number of copies to print |
piPrinterEndPage | Last page to print |
piPrinterStartPage | First page to print |
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
psReportLocation | Contains the full path to the Crystal Reports report |
psSubReportName | For subreport objects only. Contains the name of the subreport opened from main report |
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalReport [Property ComApplication]

ComApplication - cCrystalReport

Gets application object

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 5, 2005


cCrystalReport [Property ComApplicationName]

ComApplicationName - cCrystalReport

Gets or sets application name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComAreas]

ComAreas - cCrystalReport

Gets area collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComBottomMargin]

ComBottomMargin - cCrystalReport

Gets or sets page bottom margin (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComCanPerformGroupingOnServer]

ComCanPerformGroupingOnServer - cCrystalReport

Checks whether the report can perform grouping on the server.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComCaseInsensitiveSQLData]

ComCaseInsensitiveSQLData - cCrystalReport

Gets or sets case insensitive SQL data report option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComConvertDateTimeType]

ComConvertDateTimeType - cCrystalReport

Gets or sets convert date time to date report option.

Type: Property

Access: Read/Write

Data Type: CRConvertDateTimeType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalReport [Property ComConvertNullFieldToDefault]

ComConvertNullFieldToDefault - cCrystalReport

Gets or sets convert Null field to default report option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComDatabase]

ComDatabase - cCrystalReport

Gets database manager.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComDisplayProgressDialog]

ComDisplayProgressDialog - cCrystalReport

Enables or disables progress dialog

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComDriverName]

ComDriverName - cCrystalReport

Gets driver name used by the current printer.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComEnableAsyncQuery]

ComEnableAsyncQuery - cCrystalReport

Gets or sets enable AsyncQuery.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComEnableGeneratingDataForHiddenObject]

ComEnableGeneratingDataForHiddenObject - cCrystalReport

Gets or sets Enable Generating Data For Hidden Object.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComEnableParameterPrompting]

ComEnableParameterPrompting - cCrystalReport

Enables or disables prompting for parameter field

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComEnablePerformQueriesAsynchronously]

ComEnablePerformQueriesAsynchronously - cCrystalReport

Gets or sets perform queries asynchronously option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComEnableSelectDistinctRecords]

ComEnableSelectDistinctRecords - cCrystalReport

Gets or sets select distinct records option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComExportOptions]

ComExportOptions - cCrystalReport

Gets export options object.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComFieldMappingType]

ComFieldMappingType - cCrystalReport

Gets or Sets field mapping type.

Type: Property

Access: Read/Write

Data Type: CRFieldMappingType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalReport [Property ComFormulaFields]

ComFormulaFields - cCrystalReport

Gets formula field definition collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComFormulaSyntax]

ComFormulaSyntax - cCrystalReport

Gets or sets report formula syntax.

Type: Property

Access: Read/Write

Data Type: CRFormulaSyntax

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalReport [Property ComGroupNameFields]

ComGroupNameFields - cCrystalReport

Gets group name field definition collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComGroupSelectionFormula]

ComGroupSelectionFormula - cCrystalReport

Gets or sets group selection formula.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComGroupSortFields]

ComGroupSortFields - cCrystalReport

Gets group sort field collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComHasSavedData]

ComHasSavedData - cCrystalReport

Checks whether the report has saved data in memory.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComKeywordsInReport]

ComKeywordsInReport - cCrystalReport

Gets or sets keywords in report.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComKind]

ComKind - cCrystalReport

Gets report kind.

Type: Property

Access: Read-Only

Data Type: CRReportKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalReport [Property ComLastGetFormulaSyntax]

ComLastGetFormulaSyntax - cCrystalReport

Gets formula syntax of last formula text returned.

Type: Property

Access: Read-Only

Data Type: CRFormulaSyntax

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalReport [Property ComLeftMargin]

ComLeftMargin - cCrystalReport

Gets or sets page left margin (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComNeedUpdatePages]

ComNeedUpdatePages - cCrystalReport

Gets whether the user needs to reget pages for display because of the changes in the report.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComNumberOfGroup]

ComNumberOfGroup - cCrystalReport

Gets the number of groups in the report.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComPageEngine]

ComPageEngine - cCrystalReport

Get pageEngine object.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComPaperOrientation]

ComPaperOrientation - cCrystalReport

Gets or sets current printer paper orientation.

Type: Property

Access: Read/Write

Data Type: CRPaperOrientation

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalReport [Property ComPaperSize]

ComPaperSize - cCrystalReport

Gets or sets current printer paper size.

Type: Property

Access: Read/Write

Data Type: CRPaperSize

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalReport [Property ComPaperSource]

ComPaperSource - cCrystalReport

Gets or Sets the current printer paper source.

Type: Property

Access: Read/Write

Data Type: CRPaperSource

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalReport [Property ComParameterFields]

ComParameterFields - cCrystalReport

Gets parameter field definition collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComParent]

ComParent - cCrystalReport

Gets report parent. (NULL or Main Report)

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComPerformGroupingOnServer]

ComPerformGroupingOnServer - cCrystalReport

Gets or sets performing grouping on server option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComPortName]

ComPortName - cCrystalReport

Gets port name used by the current printer.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComPrintDate]

ComPrintDate - cCrystalReport

Gets or sets print date.

Type: Property

Access: Read/Write

Data Type: DateTime

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComPrinterDuplex]

ComPrinterDuplex - cCrystalReport

Gets or Sets the current printer duplex option.

Type: Property

Access: Read/Write

Data Type: CRPrinterDuplexType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalReport [Property ComPrinterName]

ComPrinterName - cCrystalReport

Gets current printer name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComPrintingStatus]

ComPrintingStatus - cCrystalReport

Gets printing status object.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComRecordSelectionFormula]

ComRecordSelectionFormula - cCrystalReport

Gets or sets record selection formula.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComRecordSortFields]

ComRecordSortFields - cCrystalReport

Gets reocord sort field collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComReportAlerts]

ComReportAlerts - cCrystalReport

Gets report alert.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComReportAuthor]

ComReportAuthor - cCrystalReport

Gets or sets report author.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComReportComments]

ComReportComments - cCrystalReport

Gets or sets report comments.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComReportFormatStyle]

ComReportFormatStyle - cCrystalReport

Gets or sets a report format style.

Type: Property

Access: Read/Write

Data Type: CRReportFormatStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalReport [Property ComReportSubject]

ComReportSubject - cCrystalReport

Gets or sets report subject.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComReportTemplate]

ComReportTemplate - cCrystalReport

Gets or sets report template.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComReportTitle]

ComReportTitle - cCrystalReport

Gets or sets report title.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComRightMargin]

ComRightMargin - cCrystalReport

Gets or sets page right margin (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComRunningTotalFields]

ComRunningTotalFields - cCrystalReport

Gets running total field collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComSavePreviewPicture]

ComSavePreviewPicture - cCrystalReport

Gets or sets save preview picture with report option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComSections]

ComSections - cCrystalReport

Gets section collection within the report.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComSQLExpressionFields]

ComSQLExpressionFields - cCrystalReport

Gets SQL expression field collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComSQLQueryString]

ComSQLQueryString - cCrystalReport

Gets or sets SQL query string.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComSummaryFields]

ComSummaryFields - cCrystalReport

Gets summary field definition collection.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComTopMargin]

ComTopMargin - cCrystalReport

Gets or sets page top margin (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComUseIndexForSpeed]

ComUseIndexForSpeed - cCrystalReport

Gets or sets use index for speed report option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property ComVerifyOnEveryPrint]

ComVerifyOnEveryPrint - cCrystalReport

Gets or sets verify on every print report option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReport object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReport [Property pbExportPrompt]

pbExportPrompt - cCrystalReport

Controls automatic prompting of export options

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbExportPrompt controls automatic prompting of export options. The default is TRUE, always prompt for export options. To export a report without user interaction you will need to supply all the required options.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"

    Procedure OnExportReport Handle hoReport
        Handle hoExport

        Forward Send OnExportReport hoReport

        Set pbExportPrompt of hoReport to FALSE
        Get ExportObject of hoReport to hoExport
        Set ComDiskFileName     of hoExport To "D:\Documents\MyReport.rtf"
        Set ComFormatType       of hoExport To crEFTExactRichText // Rich Text
    End_Procedure // OnExportReport
End_Object // oCrystalReport

See Also

OnExportReport | ExportObject

Last Edited: August 16, 2005


cCrystalReport [Property pbPrinterCollate]

pbPrinterCollate - cCrystalReport

Controls collate property for the printer

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbPrinterCollate controls the collate property for the printer. This has no affect on the Windows default printer settings and only applies to the current print job.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"

    Procedure OnPrintReport Handle hoReport
        Forward Send OnPrintReport hoReport

        Send ComSelectPrinter of hoReport "winspool" "Lexmark 3320" "LPT1:"
        Set ComPaperOrientation of hoReport to crLandscape
        Set ComPaperSize of hoReport to crPaperLetter
        Set piPrinterStartPage of hoReport to 5
        Set piPrinterEndPage of hoReport to 5
        Set piPrinterCopies of hoReport to 2
        Set pbPrinterCollate of hoReport to FALSE
    End_Procedure // OnPrintReport

End_Object // oCrystalReport

See Also

ComSelectPrinter | ComDriverName | ComPaperOrientation | ComPaperSize | ComPaperSource | ComPortName | ComPrinterDuplex | ComPrinterName | ComPrintingStatus | pbPrinterPrompt | piPrinterCopies | piPrinterEndPage | piPrinterStartPage

Last Edited: August 16, 2005


cCrystalReport [Property pbPrinterPrompt]

pbPrinterPrompt - cCrystalReport

Controls automatic prompting of printer setup

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbPrinterPrompt controls automatic prompting of printer setup. The default is FALSE, don't prompt for printer setup. If no setup is used, the Windows default printer will be used.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"

    Procedure OnPrintReport Handle hoReport
        Forward Send OnPrintReport hoReport
        Set pbPrinterPrompt of hoReport to TRUE
    End_Procedure // OnPrintReport
End_Object // oCrystalReport

See Also

ComSelectPrinter | ComDriverName | ComPaperOrientation | ComPaperSize | ComPaperSource | ComPortName | ComPrinterDuplex | ComPrinterName | ComPrintingStatus | piPrinterCopies | piPrinterEndPage | piPrinterStartPage | pbPrinterCollate

Last Edited: August 16, 2005


cCrystalReport [Property piPrinterCopies]

piPrinterCopies - cCrystalReport

Number of copies to print

Type: Property

Access: Read/Write

Data Type: Integer

Description

piPrinterCopies set the number of copies to print. This only applies if the peOutputDestination is Print_to_Printer.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"

    Procedure OnPrintReport Handle hoReport
        Forward Send OnPrintReport hoReport

        Send ComSelectPrinter of hoReport "winspool" "Lexmark 3320" "LPT1:"
        Set ComPaperOrientation of hoReport to crLandscape
        Set ComPaperSize of hoReport to crPaperLetter
        Set piPrinterStartPage of hoReport to 5
        Set piPrinterEndPage of hoReport to 5
        Set piPrinterCopies of hoReport to 2
        Set pbPrinterCollate of hoReport to FALSE
    End_Procedure // OnPrintReport

End_Object // oCrystalReport

See Also

ComSelectPrinter | ComDriverName | ComPaperOrientation | ComPaperSize | ComPaperSource | ComPortName | ComPrinterDuplex | ComPrinterName | ComPrintingStatus | pbPrinterPrompt | piPrinterEndPage | piPrinterStartPage | pbPrinterCollate

Last Edited: August 16, 2005


cCrystalReport [Property piPrinterEndPage]

piPrinterEndPage - cCrystalReport

Last page to print

Type: Property

Access: Read/Write

Data Type: Integer

Description

piPrinterEndPage sets the last page number to print. This only applies if the peOutputDestination is Print_to_Printer. Use 0 (zero) if last page is unknown.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"

    Procedure OnPrintReport Handle hoReport
        Forward Send OnPrintReport hoReport

        Send ComSelectPrinter of hoReport "winspool" "Lexmark 3320" "LPT1:"
        Set ComPaperOrientation of hoReport to crLandscape
        Set ComPaperSize of hoReport to crPaperLetter
        Set piPrinterStartPage of hoReport to 5
        Set piPrinterEndPage of hoReport to 5
        Set piPrinterCopies of hoReport to 2
        Set pbPrinterCollate of hoReport to FALSE
    End_Procedure // OnPrintReport

End_Object // oCrystalReport

See Also

ComSelectPrinter | ComDriverName | ComPaperOrientation | ComPaperSize | ComPaperSource | ComPortName | ComPrinterDuplex | ComPrinterName | ComPrintingStatus | pbPrinterPrompt | piPrinterEndPage | piPrinterStartPage | pbPrinterCollate

Last Edited: August 16, 2005


cCrystalReport [Property piPrinterStartPage]

piPrinterStartPage - cCrystalReport

First page to print

Type: Property

Access: Read/Write

Data Type: Integer

Description

piPrinterStartPage sets the first page number to print. This only applies if the peOutputDestination is Print_to_Printer.

Sample

Object oCrystalReport is a cCrystal
    Set psReportName to "CustLst.rpt"

    Procedure OnPrintReport Handle hoReport
        Forward Send OnPrintReport hoReport

        Send ComSelectPrinter of hoReport "winspool" "Lexmark 3320" "LPT1:"
        Set ComPaperOrientation of hoReport to crLandscape
        Set ComPaperSize of hoReport to crPaperLetter
        Set piPrinterStartPage of hoReport to 5
        Set piPrinterEndPage of hoReport to 5
        Set piPrinterCopies of hoReport to 2
        Set pbPrinterCollate of hoReport to FALSE
    End_Procedure // OnPrintReport

End_Object // oCrystalReport

See Also

ComSelectPrinter | ComDriverName | ComPaperOrientation | ComPaperSize | ComPaperSource | ComPortName | ComPrinterDuplex | ComPrinterName | ComPrintingStatus | pbPrinterPrompt | piPrinterCopies | piPrinterEndPage | pbPrinterCollate

Last Edited: August 16, 2005


cCrystalReport [Property psReportLocation]

psReportLocation - cCrystalReport

Contains the full path to the Crystal Reports report

Type: Property

Access: Read/Write

Data Type: String

Description

psReportLocation is set during OpenReport to the path the report was located in. This is not intended to be set by the developer.

Last Edited: August 16, 2005


cCrystalReport [Property psSubReportName]

psSubReportName - cCrystalReport

For subreport objects only. Contains the name of the subreport opened from main report

Type: Property

Access: Read/Write

Data Type: String

Description

psSubReportName contains the name of the subreport opened from main report. Subreports are of the same class as main reports. When a subreport is opened, the name of the subreport is held by this property. This is not intended to be set by the developer.

Last Edited: August 16, 2005


Events for cCrystalReportAlert

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalReportAlert

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalReportAlert

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComAlertInstances | Gets report alert's instances |
ComConditionFormula | Gets or sets report alert's condition formula |
ComDefaultMessage | Gets or sets report alert's default message |
ComIsEnabled | Gets or sets report alert's enable status |
ComMessageFormula | Gets or sets report alert's message formula |
ComName | Gets or sets report alert's name |
ComParent | Gets report alert's parent (Report) |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalReportAlert [Property ComAlertInstances]

ComAlertInstances - cCrystalReportAlert

Gets report alert's instances

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlert object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlert [Property ComConditionFormula]

ComConditionFormula - cCrystalReportAlert

Gets or sets report alert's condition formula

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlert object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlert [Property ComDefaultMessage]

ComDefaultMessage - cCrystalReportAlert

Gets or sets report alert's default message

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlert object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlert [Property ComIsEnabled]

ComIsEnabled - cCrystalReportAlert

Gets or sets report alert's enable status

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlert object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlert [Property ComMessageFormula]

ComMessageFormula - cCrystalReportAlert

Gets or sets report alert's message formula

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlert object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlert [Property ComName]

ComName - cCrystalReportAlert

Gets or sets report alert's name

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlert object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlert [Property ComParent]

ComParent - cCrystalReportAlert

Gets report alert's parent (Report)

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlert object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalReportAlertInstance

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalReportAlertInstance

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalReportAlertInstance

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComAlertMessage | Gets report alert instance's alert message |
ComParent | Gets report alert instance's parent (IReportAlert) |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalReportAlertInstance [Property ComAlertMessage]

ComAlertMessage - cCrystalReportAlertInstance

Gets report alert instance's alert message

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlertInstance object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlertInstance [Property ComParent]

ComParent - cCrystalReportAlertInstance

Gets report alert instance's parent (IReportAlert)

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlertInstance object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalReportAlertInstances

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalReportAlertInstances

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalReportAlertInstances

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets report alertinstances' parent (IReportAlert). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalReportAlertInstances [Property Com_NewEnum]

Com_NewEnum - cCrystalReportAlertInstances

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlertInstances object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlertInstances [Property ComCount]

ComCount - cCrystalReportAlertInstances

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlertInstances object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlertInstances [Property ComItem]

ComItem - cCrystalReportAlertInstances

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlertInstances object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlertInstances [Property ComParent]

ComParent - cCrystalReportAlertInstances

Gets report alertinstances' parent (IReportAlert).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlertInstances object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalReportAlerts

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalReportAlerts [Function ComAdd]

ComAdd - cCrystalReportAlerts

Adds a report alert

Type: Function

Return Data Type: Variant

Parameters: String llName String llDefaultMessage Boolean llIsEnabled String llConditionFormula String llMessageFormula

Parameter | Description
llName | Please see Crystal RDC documentation for more information.
llDefaultMessage | Please see Crystal RDC documentation for more information.
llIsEnabled | Please see Crystal RDC documentation for more information.
llConditionFormula | Please see Crystal RDC documentation for more information.
llMessageFormula | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlerts object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalReportAlerts

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Function | Adds a report alert |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Deletes a report alert |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalReportAlerts [Procedure ComDelete]

ComDelete - cCrystalReportAlerts

Deletes a report alert

Type: Procedure

Parameters: Variant llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlerts object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalReportAlerts

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets report alerts' parent (Report). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalReportAlerts [Property Com_NewEnum]

Com_NewEnum - cCrystalReportAlerts

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlerts object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlerts [Property ComCount]

ComCount - cCrystalReportAlerts

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlerts object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlerts [Property ComItem]

ComItem - cCrystalReportAlerts

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Variant llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlerts object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportAlerts [Property ComParent]

ComParent - cCrystalReportAlerts

Gets report alerts' parent (Report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportAlerts object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalReportObjects

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalReportObjects

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalReportObjects

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets report object collection parent (section) |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalReportObjects [Property Com_NewEnum]

Com_NewEnum - cCrystalReportObjects

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportObjects object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportObjects [Property ComCount]

ComCount - cCrystalReportObjects

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportObjects object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportObjects [Property ComItem]

ComItem - cCrystalReportObjects

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Variant llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportObjects object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalReportObjects [Property ComParent]

ComParent - cCrystalReportObjects

Gets report object collection parent (section)

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIReportObjects object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalReportSourceRouter

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalReportSourceRouter

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComAddReport | Procedure | method AddReport |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalReportSourceRouter [Procedure ComAddReport]

ComAddReport - cCrystalReportSourceRouter

method AddReport

Type: Procedure

Parameters: Variant llpUnknown

Parameter | Description
llpUnknown | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalICrystalReportSourceRouter object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalReportSourceRouter

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


Events for cCrystalRunningTotalFieldDefinition

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalRunningTotalFieldDefinition

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
ComSetEvaluateConditionField | Procedure | Sets evaluate condition field |
ComSetNoEvaluateCondition | Procedure | Sets to no evaluate condition |
ComSetNoResetCondition | Procedure | Sets to no reset condition |
ComSetResetConditionField | Procedure | Sets reset condition field |
ComSetSecondarySummarizedField | Procedure | Sets secondary summarized field |
ComSetSummarizedField | Procedure | Sets summarized field |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalRunningTotalFieldDefinition [Procedure ComSetEvaluateConditionField]

ComSetEvaluateConditionField - cCrystalRunningTotalFieldDefinition

Sets evaluate condition field

Type: Procedure

Parameters: Variant llpEvaluateConditionField

Parameter | Description
llpEvaluateConditionField | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Procedure ComSetNoEvaluateCondition]

ComSetNoEvaluateCondition - cCrystalRunningTotalFieldDefinition

Sets to no evaluate condition

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Procedure ComSetNoResetCondition]

ComSetNoResetCondition - cCrystalRunningTotalFieldDefinition

Sets to no reset condition

Type: Procedure

Parameters: No Parameters

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Procedure ComSetResetConditionField]

ComSetResetConditionField - cCrystalRunningTotalFieldDefinition

Sets reset condition field

Type: Procedure

Parameters: Variant llpResetConditionField

Parameter | Description
llpResetConditionField | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Procedure ComSetSecondarySummarizedField]

ComSetSecondarySummarizedField - cCrystalRunningTotalFieldDefinition

Sets secondary summarized field

Type: Procedure

Parameters: Variant llsecondarySummariedField

Parameter | Description
llsecondarySummariedField | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Procedure ComSetSummarizedField]

ComSetSummarizedField - cCrystalRunningTotalFieldDefinition

Sets summarized field

Type: Procedure

Parameters: Variant llSummarizedField

Parameter | Description
llSummarizedField | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalRunningTotalFieldDefinition

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComEvaluateCondition | Gets evaluate condition |
ComEvaluateConditionField | Gets evaluate condition field |
ComEvaluateConditionFormula | Gets or sets evaluate condition formula |
ComEvaluateGroupNumber | Gets or sets evaluate group number |
ComHierarchicalSummaryType | Gets or sets summary hierarchical type |
ComKind | Gets field definition kind. |
ComName | Gets field definition unique formula name. |
ComNextValue | Gets field next value. |
ComNumberOfBytes | Gets field number of bytes. |
ComParent | Gets summary field parent (report). |
ComPreviousValue | Gets field previous value. |
ComResetCondition | Gets reset condition |
ComResetConditionField | Gets reset condition field |
ComResetConditionFormula | Gets or sets reset condition formula |
ComResetGroupNumber | Gets or sets reset group number |
ComRunningTotalFieldName | Gets running total field name. |
ComSecondarySummarizedField | Gets secondary summarized field |
ComSummarizedField | Gets summarized field |
ComSummaryOperationParameter | Gets or sets summary operation parameter |
ComSummaryType | Gets or sets summary type |
ComValue | Gets field value. |
ComValueType | Gets field value type. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalRunningTotalFieldDefinition [Property ComEvaluateCondition]

ComEvaluateCondition - cCrystalRunningTotalFieldDefinition

Gets evaluate condition

Type: Property

Access: Read-Only

Data Type: CRRunningTotalCondition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalRunningTotalFieldDefinition [Property ComEvaluateConditionField]

ComEvaluateConditionField - cCrystalRunningTotalFieldDefinition

Gets evaluate condition field

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComEvaluateConditionFormula]

ComEvaluateConditionFormula - cCrystalRunningTotalFieldDefinition

Gets or sets evaluate condition formula

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComEvaluateGroupNumber]

ComEvaluateGroupNumber - cCrystalRunningTotalFieldDefinition

Gets or sets evaluate group number

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalRunningTotalFieldDefinition [Property ComHierarchicalSummaryType]

ComHierarchicalSummaryType - cCrystalRunningTotalFieldDefinition

Gets or sets summary hierarchical type

Type: Property

Access: Read/Write

Data Type: CRHierarchicalSummaryType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalRunningTotalFieldDefinition [Property ComKind]

ComKind - cCrystalRunningTotalFieldDefinition

Gets field definition kind.

Type: Property

Access: Read-Only

Data Type: CRFieldKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalRunningTotalFieldDefinition [Property ComName]

ComName - cCrystalRunningTotalFieldDefinition

Gets field definition unique formula name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComNextValue]

ComNextValue - cCrystalRunningTotalFieldDefinition

Gets field next value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComNumberOfBytes]

ComNumberOfBytes - cCrystalRunningTotalFieldDefinition

Gets field number of bytes.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalRunningTotalFieldDefinition [Property ComParent]

ComParent - cCrystalRunningTotalFieldDefinition

Gets summary field parent (report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComPreviousValue]

ComPreviousValue - cCrystalRunningTotalFieldDefinition

Gets field previous value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComResetCondition]

ComResetCondition - cCrystalRunningTotalFieldDefinition

Gets reset condition

Type: Property

Access: Read-Only

Data Type: CRRunningTotalCondition

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalRunningTotalFieldDefinition [Property ComResetConditionField]

ComResetConditionField - cCrystalRunningTotalFieldDefinition

Gets reset condition field

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComResetConditionFormula]

ComResetConditionFormula - cCrystalRunningTotalFieldDefinition

Gets or sets reset condition formula

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComResetGroupNumber]

ComResetGroupNumber - cCrystalRunningTotalFieldDefinition

Gets or sets reset group number

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalRunningTotalFieldDefinition [Property ComRunningTotalFieldName]

ComRunningTotalFieldName - cCrystalRunningTotalFieldDefinition

Gets running total field name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComSecondarySummarizedField]

ComSecondarySummarizedField - cCrystalRunningTotalFieldDefinition

Gets secondary summarized field

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComSummarizedField]

ComSummarizedField - cCrystalRunningTotalFieldDefinition

Gets summarized field

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComSummaryOperationParameter]

ComSummaryOperationParameter - cCrystalRunningTotalFieldDefinition

Gets or sets summary operation parameter

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComSummaryType]

ComSummaryType - cCrystalRunningTotalFieldDefinition

Gets or sets summary type

Type: Property

Access: Read/Write

Data Type: CRSummaryType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalRunningTotalFieldDefinition [Property ComValue]

ComValue - cCrystalRunningTotalFieldDefinition

Gets field value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinition [Property ComValueType]

ComValueType - cCrystalRunningTotalFieldDefinition

Gets field value type.

Type: Property

Access: Read-Only

Data Type: CRFieldValueType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalRunningTotalFieldDefinitions

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalRunningTotalFieldDefinitions [Function ComAdd]

ComAdd - cCrystalRunningTotalFieldDefinitions

Add a RunningTotal field collection item

Type: Function

Return Data Type: Variant

Parameters: String llrunningTotalName

Parameter | Description
llrunningTotalName | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinitions [Function ComGetItemByName]

ComGetItemByName - cCrystalRunningTotalFieldDefinitions

Gets collection item by name index.

Type: Function

Return Data Type: Variant

Parameters: String llName

Parameter | Description
llName | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalRunningTotalFieldDefinitions

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Function | Add a RunningTotal field collection item |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Delete a RunningTotal field collection item |
ComGetItemByName | Function | Gets collection item by name index. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalRunningTotalFieldDefinitions [Procedure ComDelete]

ComDelete - cCrystalRunningTotalFieldDefinitions

Delete a RunningTotal field collection item

Type: Procedure

Parameters: Variant llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalRunningTotalFieldDefinitions

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets summary field collection parent (report). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalRunningTotalFieldDefinitions [Property Com_NewEnum]

Com_NewEnum - cCrystalRunningTotalFieldDefinitions

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinitions [Property ComCount]

ComCount - cCrystalRunningTotalFieldDefinitions

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinitions [Property ComItem]

ComItem - cCrystalRunningTotalFieldDefinitions

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalRunningTotalFieldDefinitions [Property ComParent]

ComParent - cCrystalRunningTotalFieldDefinitions

Gets summary field collection parent (report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalIRunningTotalFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Event OnComFormat]

OnComFormat - cCrystalSection

Fires this event before starting to format a section

Type: Event

Parameters: Variant llpFormattingInfo

Parameter | Description
llpFormattingInfo | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISectionEvent object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalSection

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnComFormat | Fires this event before starting to format a section |
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalSection [Function ComAddBlobFieldObject]

ComAddBlobFieldObject - cCrystalSection

Adds a blob field object into the section.

Type: Function

Return Data Type: Variant

Parameters: Variant llField Integer llLeft Integer llTop

Parameter | Description
llField | Please see Crystal RDC documentation for more information.
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Function ComAddBoxObject]

ComAddBoxObject - cCrystalSection

Adds a box object into the section.

Type: Function

Return Data Type: Variant

Parameters: Integer llLeft Integer llTop Integer llRight Integer llBottom Variant llpEndSection

Parameter | Description
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.
llRight | Please see Crystal RDC documentation for more information.
llBottom | Please see Crystal RDC documentation for more information.
llpEndSection | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Function ComAddCrossTabObject]

ComAddCrossTabObject - cCrystalSection

Adds a crosstab object into the section.

Type: Function

Return Data Type: Variant

Parameters: Integer llLeft Integer llTop

Parameter | Description
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Function ComAddFieldObject]

ComAddFieldObject - cCrystalSection

Adds a field object into the section.

Type: Function

Return Data Type: Variant

Parameters: Variant llField Integer llLeft Integer llTop

Parameter | Description
llField | Please see Crystal RDC documentation for more information.
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Function ComAddGraphObject]

ComAddGraphObject - cCrystalSection

Adds a graph object into the section.

Type: Function

Return Data Type: Variant

Parameters: CRGraphDataType llgraphDataType Integer llLeft Integer llTop Variant llpCrossTabObject

Parameter | Description
llgraphDataType | Please see Crystal RDC documentation for more information.
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.
llpCrossTabObject | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Function ComAddLineObject]

ComAddLineObject - cCrystalSection

Adds a line object into the section.

Type: Function

Return Data Type: Variant

Parameters: Integer llLeft Integer llTop Integer llRight Integer llBottom Variant llpEndSection

Parameter | Description
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.
llRight | Please see Crystal RDC documentation for more information.
llBottom | Please see Crystal RDC documentation for more information.
llpEndSection | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Function ComAddPictureObject]

ComAddPictureObject - cCrystalSection

Adds a picture field object into the section.

Type: Function

Return Data Type: Variant

Parameters: String llpImageFilePath Integer llLeft Integer llTop

Parameter | Description
llpImageFilePath | Please see Crystal RDC documentation for more information.
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Function ComAddSpecialVarFieldObject]

ComAddSpecialVarFieldObject - cCrystalSection

Adds a special var field object into the section.

Type: Function

Return Data Type: Variant

Parameters: CRSpecialVarType llspecialVarType Integer llLeft Integer llTop

Parameter | Description
llspecialVarType | Please see Crystal RDC documentation for more information.
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Function ComAddSubreportObject]

ComAddSubreportObject - cCrystalSection

Adds a subreport object into the section.

Type: Function

Return Data Type: Variant

Parameters: String llpSubreportName Integer llLeft Integer llTop

Parameter | Description
llpSubreportName | Please see Crystal RDC documentation for more information.
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Function ComAddSummaryFieldObject]

ComAddSummaryFieldObject - cCrystalSection

Adds a summary field object into the section

Type: Function

Return Data Type: Variant

Parameters: Variant llField CRSummaryType llSummaryType Integer llLeft Integer llTop Variant llsecondSummaryFieldOrFactor

Parameter | Description
llField | Please see Crystal RDC documentation for more information.
llSummaryType | Please see Crystal RDC documentation for more information.
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.
llsecondSummaryFieldOrFactor | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Function ComAddTextObject]

ComAddTextObject - cCrystalSection

Adds a text object into the section.

Type: Function

Return Data Type: Variant

Parameters: String llpText Integer llLeft Integer llTop Variant llformatText

Parameter | Description
llpText | Please see Crystal RDC documentation for more information.
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.
llformatText | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Function ComAddUnboundFieldObject]

ComAddUnboundFieldObject - cCrystalSection

Adds an unbound field object into the report.

Type: Function

Return Data Type: Variant

Parameters: CRFieldValueType llValueType Integer llLeft Integer llTop

Parameter | Description
llValueType | Please see Crystal RDC documentation for more information.
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Function ComImportSubreport]

ComImportSubreport - cCrystalSection

Imports a subreport into the section.

Type: Function

Return Data Type: Variant

Parameters: String llsubreportFileName Integer llLeft Integer llTop

Parameter | Description
llsubreportFileName | Please see Crystal RDC documentation for more information.
llLeft | Please see Crystal RDC documentation for more information.
llTop | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalSection

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddBlobFieldObject | Function | Adds a blob field object into the section. |
ComAddBoxObject | Function | Adds a box object into the section. |
ComAddCrossTabObject | Function | Adds a crosstab object into the section. |
ComAddFieldObject | Function | Adds a field object into the section. |
ComAddGraphObject | Function | Adds a graph object into the section. |
ComAddLineObject | Function | Adds a line object into the section. |
ComAddPictureObject | Function | Adds a picture field object into the section. |
ComAddref | Procedure |  | DfComAutomationObject
ComAddSpecialVarFieldObject | Function | Adds a special var field object into the section. |
ComAddSubreportObject | Function | Adds a subreport object into the section. |
ComAddSummaryFieldObject | Function | Adds a summary field object into the section |
ComAddTextObject | Function | Adds a text object into the section. |
ComAddUnboundFieldObject | Function | Adds an unbound field object into the report. |
ComDeleteObject | Procedure | Deletes an object into the section. |
ComImportSubreport | Function | Imports a subreport into the section. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalSection [Procedure ComDeleteObject]

ComDeleteObject - cCrystalSection

Deletes an object into the section.

Type: Procedure

Parameters: Variant llreportObject

Parameter | Description
llreportObject | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalSection

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComBackColor | Gets or sets section background color. |
ComConditionFormula | Gets or sets section conditional formula. |
ComCssClass | Gets or sets CSS class. |
ComHeight | Gets or sets section height (twips). |
ComKeepTogether | Gets or sets keeping section together option. |
ComMinimumHeight | Gets minimum section height (twips). |
ComName | Gets or sets section name. |
ComNewPageAfter | Gets or sets new page after option. |
ComNewPageBefore | Gets or sets new page before option. |
ComNumber | Gets the section index within the report. |
ComParent | Gets the section parent (Report or Area). |
ComPrintAtBottomOfPage | Gets or sets print at bottom of page option. |
ComReportObjects | Gets report object collection within the section. |
ComResetPageNumberAfter | Gets or sets reset page after option. |
ComSuppress | Gets or sets section visibility. |
ComSuppressIfBlank | Gets or sets suppress section if blank option. |
ComUnderlaySection | Gets or sets underlay following section option. |
ComWidth | Gets section width (twips). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalSection [Property ComBackColor]

ComBackColor - cCrystalSection

Gets or sets section background color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComConditionFormula]

ComConditionFormula - cCrystalSection

Gets or sets section conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaName String value

Parameter | Description
llFormulaName | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComCssClass]

ComCssClass - cCrystalSection

Gets or sets CSS class.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComHeight]

ComHeight - cCrystalSection

Gets or sets section height (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComKeepTogether]

ComKeepTogether - cCrystalSection

Gets or sets keeping section together option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComMinimumHeight]

ComMinimumHeight - cCrystalSection

Gets minimum section height (twips).

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComName]

ComName - cCrystalSection

Gets or sets section name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComNewPageAfter]

ComNewPageAfter - cCrystalSection

Gets or sets new page after option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComNewPageBefore]

ComNewPageBefore - cCrystalSection

Gets or sets new page before option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComNumber]

ComNumber - cCrystalSection

Gets the section index within the report.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSection [Property ComParent]

ComParent - cCrystalSection

Gets the section parent (Report or Area).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComPrintAtBottomOfPage]

ComPrintAtBottomOfPage - cCrystalSection

Gets or sets print at bottom of page option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComReportObjects]

ComReportObjects - cCrystalSection

Gets report object collection within the section.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComResetPageNumberAfter]

ComResetPageNumberAfter - cCrystalSection

Gets or sets reset page after option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComSuppress]

ComSuppress - cCrystalSection

Gets or sets section visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComSuppressIfBlank]

ComSuppressIfBlank - cCrystalSection

Gets or sets suppress section if blank option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComUnderlaySection]

ComUnderlaySection - cCrystalSection

Gets or sets underlay following section option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSection [Property ComWidth]

ComWidth - cCrystalSection

Gets section width (twips).

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISection object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalSections

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalSections [Function ComAdd]

ComAdd - cCrystalSections

Adds a section.

Type: Function

Return Data Type: Variant

Parameters: Variant llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISections object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalSections

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Function | Adds a section. |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Delete collection item. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalSections [Procedure ComDelete]

ComDelete - cCrystalSections

Delete collection item.

Type: Procedure

Parameters: Variant llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISections object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalSections

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets section collection parent (report or area). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalSections [Property Com_NewEnum]

Com_NewEnum - cCrystalSections

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISections object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSections [Property ComCount]

ComCount - cCrystalSections

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISections object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSections [Property ComItem]

ComItem - cCrystalSections

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Variant llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISections object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSections [Property ComParent]

ComParent - cCrystalSections

Gets section collection parent (report or area).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISections object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalSortField

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalSortField

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalSortField

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComField | Gets or sets sorting field. |
ComParent | Gets sort field's parent (Report) |
ComSortDirection | Gets or sets sort direction. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalSortField [Property ComField]

ComField - cCrystalSortField

Gets or sets sorting field.

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISortField object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSortField [Property ComParent]

ComParent - cCrystalSortField

Gets sort field's parent (Report)

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISortField object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSortField [Property ComSortDirection]

ComSortDirection - cCrystalSortField

Gets or sets sort direction.

Type: Property

Access: Read/Write

Data Type: CRSortDirection

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISortField object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalSortFields

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalSortFields

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Procedure | Adds a sort field |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Deletes a sort field |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalSortFields [Procedure ComAdd]

ComAdd - cCrystalSortFields

Adds a sort field

Type: Procedure

Parameters: Variant llpFieldDefinition CRSortDirection llSortDirection

Parameter | Description
llpFieldDefinition | Please see Crystal RDC documentation for more information.
llSortDirection | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISortFields object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSortFields [Procedure ComDelete]

ComDelete - cCrystalSortFields

Deletes a sort field

Type: Procedure

Parameters: Integer llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISortFields object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalSortFields

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets sort field collection's parent (Report). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalSortFields [Property Com_NewEnum]

Com_NewEnum - cCrystalSortFields

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISortFields object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSortFields [Property ComCount]

ComCount - cCrystalSortFields

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISortFields object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSortFields [Property ComItem]

ComItem - cCrystalSortFields

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISortFields object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSortFields [Property ComParent]

ComParent - cCrystalSortFields

Gets sort field collection's parent (Report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISortFields object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalSpecialVarFieldDefinition

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalSpecialVarFieldDefinition

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalSpecialVarFieldDefinition

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComKind | Gets field definition kind. |
ComName | Gets field definition unique formula name. |
ComNextValue | Gets field next value. |
ComNumberOfBytes | Gets field number of bytes. |
ComParent | Gets special variable field parent (report). |
ComPreviousValue | Gets field previous value. |
ComSpecialVarType | Gets special variable type. |
ComValue | Gets field value. |
ComValueType | Gets field value type. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalSpecialVarFieldDefinition [Property ComKind]

ComKind - cCrystalSpecialVarFieldDefinition

Gets field definition kind.

Type: Property

Access: Read-Only

Data Type: CRFieldKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISpecialVarFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSpecialVarFieldDefinition [Property ComName]

ComName - cCrystalSpecialVarFieldDefinition

Gets field definition unique formula name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISpecialVarFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSpecialVarFieldDefinition [Property ComNextValue]

ComNextValue - cCrystalSpecialVarFieldDefinition

Gets field next value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISpecialVarFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSpecialVarFieldDefinition [Property ComNumberOfBytes]

ComNumberOfBytes - cCrystalSpecialVarFieldDefinition

Gets field number of bytes.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISpecialVarFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSpecialVarFieldDefinition [Property ComParent]

ComParent - cCrystalSpecialVarFieldDefinition

Gets special variable field parent (report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISpecialVarFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSpecialVarFieldDefinition [Property ComPreviousValue]

ComPreviousValue - cCrystalSpecialVarFieldDefinition

Gets field previous value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISpecialVarFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSpecialVarFieldDefinition [Property ComSpecialVarType]

ComSpecialVarType - cCrystalSpecialVarFieldDefinition

Gets special variable type.

Type: Property

Access: Read-Only

Data Type: CRSpecialVarType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISpecialVarFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSpecialVarFieldDefinition [Property ComValue]

ComValue - cCrystalSpecialVarFieldDefinition

Gets field value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISpecialVarFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSpecialVarFieldDefinition [Property ComValueType]

ComValueType - cCrystalSpecialVarFieldDefinition

Gets field value type.

Type: Property

Access: Read-Only

Data Type: CRFieldValueType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISpecialVarFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalSQLExpressionFieldDefinition

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalSQLExpressionFieldDefinition

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComCheck | Procedure | Checks whether the SQL expression is valid |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalSQLExpressionFieldDefinition [Procedure ComCheck]

ComCheck - cCrystalSQLExpressionFieldDefinition

Checks whether the SQL expression is valid

Type: Procedure

Parameters: Boolean ByRef llpBool String ByRef llppErrorString

Parameter | Description
ByRef llpBool | Please see Crystal RDC documentation for more information.
ByRef llppErrorString | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalSQLExpressionFieldDefinition

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComKind | Gets field definition kind. |
ComName | Gets field definition unique formula name. |
ComNextValue | Gets field next value. |
ComNumberOfBytes | Gets field number of bytes. |
ComParent | Gets summary field parent (report). |
ComPreviousValue | Gets field previous value. |
ComSQLExpressionFieldName | Gets SQL expression field name. |
ComText | Gets or sets SQL expression text. |
ComValue | Gets field value. |
ComValueType | Gets field value type. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalSQLExpressionFieldDefinition [Property ComKind]

ComKind - cCrystalSQLExpressionFieldDefinition

Gets field definition kind.

Type: Property

Access: Read-Only

Data Type: CRFieldKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSQLExpressionFieldDefinition [Property ComName]

ComName - cCrystalSQLExpressionFieldDefinition

Gets field definition unique formula name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSQLExpressionFieldDefinition [Property ComNextValue]

ComNextValue - cCrystalSQLExpressionFieldDefinition

Gets field next value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSQLExpressionFieldDefinition [Property ComNumberOfBytes]

ComNumberOfBytes - cCrystalSQLExpressionFieldDefinition

Gets field number of bytes.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSQLExpressionFieldDefinition [Property ComParent]

ComParent - cCrystalSQLExpressionFieldDefinition

Gets summary field parent (report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSQLExpressionFieldDefinition [Property ComPreviousValue]

ComPreviousValue - cCrystalSQLExpressionFieldDefinition

Gets field previous value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSQLExpressionFieldDefinition [Property ComSQLExpressionFieldName]

ComSQLExpressionFieldName - cCrystalSQLExpressionFieldDefinition

Gets SQL expression field name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSQLExpressionFieldDefinition [Property ComText]

ComText - cCrystalSQLExpressionFieldDefinition

Gets or sets SQL expression text.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSQLExpressionFieldDefinition [Property ComValue]

ComValue - cCrystalSQLExpressionFieldDefinition

Gets field value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSQLExpressionFieldDefinition [Property ComValueType]

ComValueType - cCrystalSQLExpressionFieldDefinition

Gets field value type.

Type: Property

Access: Read-Only

Data Type: CRFieldValueType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalSQLExpressionFieldDefinitions

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalSQLExpressionFieldDefinitions [Function ComAdd]

ComAdd - cCrystalSQLExpressionFieldDefinitions

Add a SQL expression field collection item

Type: Function

Return Data Type: Variant

Parameters: String llSQLExpressionName String llText

Parameter | Description
llSQLExpressionName | Please see Crystal RDC documentation for more information.
llText | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSQLExpressionFieldDefinitions [Function ComGetItemByName]

ComGetItemByName - cCrystalSQLExpressionFieldDefinitions

Gets collection item by name index.

Type: Function

Return Data Type: Variant

Parameters: String llName

Parameter | Description
llName | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalSQLExpressionFieldDefinitions

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Function | Add a SQL expression field collection item |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Delete a SQL expression field collection item |
ComGetItemByName | Function | Gets collection item by name index. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalSQLExpressionFieldDefinitions [Procedure ComDelete]

ComDelete - cCrystalSQLExpressionFieldDefinitions

Delete a SQL expression field collection item

Type: Procedure

Parameters: Variant llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalSQLExpressionFieldDefinitions

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets SQL expression field collection parent (report). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalSQLExpressionFieldDefinitions [Property Com_NewEnum]

Com_NewEnum - cCrystalSQLExpressionFieldDefinitions

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSQLExpressionFieldDefinitions [Property ComCount]

ComCount - cCrystalSQLExpressionFieldDefinitions

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSQLExpressionFieldDefinitions [Property ComItem]

ComItem - cCrystalSQLExpressionFieldDefinitions

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSQLExpressionFieldDefinitions [Property ComParent]

ComParent - cCrystalSQLExpressionFieldDefinitions

Gets SQL expression field collection parent (report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISQLExpressionFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalSubreportLink

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalSubreportLink

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalSubreportLink

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComMainReportField | Gets main report field. |
ComParent | Gets subreport link's parent (Report) |
ComSubreportField | Gets subreport field. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalSubreportLink [Property ComMainReportField]

ComMainReportField - cCrystalSubreportLink

Gets main report field.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportLink object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportLink [Property ComParent]

ComParent - cCrystalSubreportLink

Gets subreport link's parent (Report)

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportLink object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportLink [Property ComSubreportField]

ComSubreportField - cCrystalSubreportLink

Gets subreport field.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportLink object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalSubreportLinks

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalSubreportLinks [Function ComAdd]

ComAdd - cCrystalSubreportLinks

Adds a subreport link

Type: Function

Return Data Type: Variant

Parameters: Variant llMainReportField Variant llSubreportField

Parameter | Description
llMainReportField | Please see Crystal RDC documentation for more information.
llSubreportField | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalSubreportLinks

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Function | Adds a subreport link |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Deletes a subreport link |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalSubreportLinks [Procedure ComDelete]

ComDelete - cCrystalSubreportLinks

Deletes a subreport link

Type: Procedure

Parameters: Integer llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalSubreportLinks

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets subreport link's parent (Report). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalSubreportLinks [Property Com_NewEnum]

Com_NewEnum - cCrystalSubreportLinks

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportLinks [Property ComCount]

ComCount - cCrystalSubreportLinks

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportLinks [Property ComItem]

ComItem - cCrystalSubreportLinks

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportLinks [Property ComParent]

ComParent - cCrystalSubreportLinks

Gets subreport link's parent (Report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalSubreportObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalSubreportObject [Function ComOpenSubreport]

ComOpenSubreport - cCrystalSubreportObject

Opens the subreport object.

Type: Function

Return Data Type: Variant

Parameters: No Parameters

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalSubreportObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComOpenSubreport | Function | Opens the subreport object. |
ComQueryInterface | Function |  | DfComAutomationObject
ComReimportSubreport | Procedure | Reimport subreport object. |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalSubreportObject [Procedure ComReimportSubreport]

ComReimportSubreport - cCrystalSubreportObject

Reimport subreport object.

Type: Procedure

Parameters: Boolean ByRef llpReimported

Parameter | Description
ByRef llpReimported | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalSubreportObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComBackColor | Gets or sets object background color. |
ComBorderColor | Gets or sets object border color. |
ComBottomLineStyle | Gets or sets bottom line style. |
ComCanGrow | Gets or sets can grow option. |
ComCloseAtPageBreak | Gets or sets close border on page break. |
ComConditionFormula | Gets or sets conditional formula. |
ComCssClass | Gets or sets CSS class. |
ComEnableOnDemand | Gets on-demand subreport option. |
ComHasDropShadow | Gets or sets border drop shadow. |
ComHeight | Gets or sets object height (twips). |
ComKeepTogether | Gets or sets keep object together. |
ComKind | Gets report object kind. |
ComLeft | Gets or sets object upper left position (twips). |
ComLeftLineStyle | Gets or sets left line style. |
ComLinks | Gets subreport links. |
ComName | Gets or sets object name. |
ComParent | Gets object parent (Section). |
ComRightLineStyle | Gets or sets right line style. |
ComSubreportName | Gets or sets subreport name. |
ComSuppress | Gets or sets object visibility. |
ComTop | Gets or sets object upper top position (twips). |
ComTopLineStyle | Gets or sets top line style. |
ComWidth | Gets or sets object width (twips). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalSubreportObject [Property ComBackColor]

ComBackColor - cCrystalSubreportObject

Gets or sets object background color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComBorderColor]

ComBorderColor - cCrystalSubreportObject

Gets or sets object border color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComBottomLineStyle]

ComBottomLineStyle - cCrystalSubreportObject

Gets or sets bottom line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSubreportObject [Property ComCanGrow]

ComCanGrow - cCrystalSubreportObject

Gets or sets can grow option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComCloseAtPageBreak]

ComCloseAtPageBreak - cCrystalSubreportObject

Gets or sets close border on page break.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComConditionFormula]

ComConditionFormula - cCrystalSubreportObject

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaType String value

Parameter | Description
llFormulaType | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComCssClass]

ComCssClass - cCrystalSubreportObject

Gets or sets CSS class.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComEnableOnDemand]

ComEnableOnDemand - cCrystalSubreportObject

Gets on-demand subreport option.

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComHasDropShadow]

ComHasDropShadow - cCrystalSubreportObject

Gets or sets border drop shadow.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComHeight]

ComHeight - cCrystalSubreportObject

Gets or sets object height (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComKeepTogether]

ComKeepTogether - cCrystalSubreportObject

Gets or sets keep object together.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComKind]

ComKind - cCrystalSubreportObject

Gets report object kind.

Type: Property

Access: Read-Only

Data Type: CRObjectKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSubreportObject [Property ComLeft]

ComLeft - cCrystalSubreportObject

Gets or sets object upper left position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComLeftLineStyle]

ComLeftLineStyle - cCrystalSubreportObject

Gets or sets left line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSubreportObject [Property ComLinks]

ComLinks - cCrystalSubreportObject

Gets subreport links.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComName]

ComName - cCrystalSubreportObject

Gets or sets object name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComParent]

ComParent - cCrystalSubreportObject

Gets object parent (Section).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComRightLineStyle]

ComRightLineStyle - cCrystalSubreportObject

Gets or sets right line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSubreportObject [Property ComSubreportName]

ComSubreportName - cCrystalSubreportObject

Gets or sets subreport name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComSuppress]

ComSuppress - cCrystalSubreportObject

Gets or sets object visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComTop]

ComTop - cCrystalSubreportObject

Gets or sets object upper top position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSubreportObject [Property ComTopLineStyle]

ComTopLineStyle - cCrystalSubreportObject

Gets or sets top line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSubreportObject [Property ComWidth]

ComWidth - cCrystalSubreportObject

Gets or sets object width (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISubreportObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalSummaryFieldDefinition

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalSummaryFieldDefinition

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
ComSetSecondarySummarizedField | Procedure | Sets secondary summarized field |
ComSetSummarizedField | Procedure | Sets summarized field |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalSummaryFieldDefinition [Procedure ComSetSecondarySummarizedField]

ComSetSecondarySummarizedField - cCrystalSummaryFieldDefinition

Sets secondary summarized field

Type: Procedure

Parameters: Variant llsecondarySummariedField

Parameter | Description
llsecondarySummariedField | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinition [Procedure ComSetSummarizedField]

ComSetSummarizedField - cCrystalSummaryFieldDefinition

Sets summarized field

Type: Procedure

Parameters: Variant llSummarizedField

Parameter | Description
llSummarizedField | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalSummaryFieldDefinition

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComFooterArea | Get the area pair the summary is in. |
ComForCrossTab | Gets for-cross-tab |
ComHeaderArea | Gets the area pair the summary is in |
ComHierarchicalSummaryType | Gets or sets summary hierarchical type |
ComKind | Gets field definition kind. |
ComName | Gets field definition unique formula name. |
ComNextValue | Gets field next value. |
ComNumberOfBytes | Gets field number of bytes. |
ComParent | Gets summary field parent (report). |
ComPreviousValue | Gets field previous value. |
ComSecondarySummarizedField | Gets secondary summarized field |
ComSummarizedField | Gets summarized field |
ComSummaryOperationParameter | Gets or sets summary operation parameter |
ComSummaryType | Gets or sets summary type |
ComValue | Gets field value. |
ComValueType | Gets field value type. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalSummaryFieldDefinition [Property ComFooterArea]

ComFooterArea - cCrystalSummaryFieldDefinition

Get the area pair the summary is in.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinition [Property ComForCrossTab]

ComForCrossTab - cCrystalSummaryFieldDefinition

Gets for-cross-tab

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinition [Property ComHeaderArea]

ComHeaderArea - cCrystalSummaryFieldDefinition

Gets the area pair the summary is in

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinition [Property ComHierarchicalSummaryType]

ComHierarchicalSummaryType - cCrystalSummaryFieldDefinition

Gets or sets summary hierarchical type

Type: Property

Access: Read/Write

Data Type: CRHierarchicalSummaryType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSummaryFieldDefinition [Property ComKind]

ComKind - cCrystalSummaryFieldDefinition

Gets field definition kind.

Type: Property

Access: Read-Only

Data Type: CRFieldKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSummaryFieldDefinition [Property ComName]

ComName - cCrystalSummaryFieldDefinition

Gets field definition unique formula name.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinition [Property ComNextValue]

ComNextValue - cCrystalSummaryFieldDefinition

Gets field next value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinition [Property ComNumberOfBytes]

ComNumberOfBytes - cCrystalSummaryFieldDefinition

Gets field number of bytes.

Type: Property

Access: Read-Only

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSummaryFieldDefinition [Property ComParent]

ComParent - cCrystalSummaryFieldDefinition

Gets summary field parent (report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinition [Property ComPreviousValue]

ComPreviousValue - cCrystalSummaryFieldDefinition

Gets field previous value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinition [Property ComSecondarySummarizedField]

ComSecondarySummarizedField - cCrystalSummaryFieldDefinition

Gets secondary summarized field

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinition [Property ComSummarizedField]

ComSummarizedField - cCrystalSummaryFieldDefinition

Gets summarized field

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinition [Property ComSummaryOperationParameter]

ComSummaryOperationParameter - cCrystalSummaryFieldDefinition

Gets or sets summary operation parameter

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinition [Property ComSummaryType]

ComSummaryType - cCrystalSummaryFieldDefinition

Gets or sets summary type

Type: Property

Access: Read/Write

Data Type: CRSummaryType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalSummaryFieldDefinition [Property ComValue]

ComValue - cCrystalSummaryFieldDefinition

Gets field value.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinition [Property ComValueType]

ComValueType - cCrystalSummaryFieldDefinition

Gets field value type.

Type: Property

Access: Read-Only

Data Type: CRFieldValueType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinition object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


Events for cCrystalSummaryFieldDefinitions

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalSummaryFieldDefinitions [Function ComAdd]

ComAdd - cCrystalSummaryFieldDefinitions

Add a Summary field collection item

Type: Function

Return Data Type: Variant

Parameters: Integer llgroupLevel Variant llField CRSummaryType llSummaryType Variant llsecondSummaryFieldOrFactor

Parameter | Description
llgroupLevel | Please see Crystal RDC documentation for more information.
llField | Please see Crystal RDC documentation for more information.
llSummaryType | Please see Crystal RDC documentation for more information.
llsecondSummaryFieldOrFactor | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalSummaryFieldDefinitions

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Function | Add a Summary field collection item |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Delete a Summary field collection item |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalSummaryFieldDefinitions [Procedure ComDelete]

ComDelete - cCrystalSummaryFieldDefinitions

Delete a Summary field collection item

Type: Procedure

Parameters: Variant llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalSummaryFieldDefinitions

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets summary field collection parent (report). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalSummaryFieldDefinitions [Property Com_NewEnum]

Com_NewEnum - cCrystalSummaryFieldDefinitions

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinitions [Property ComCount]

ComCount - cCrystalSummaryFieldDefinitions

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinitions [Property ComItem]

ComItem - cCrystalSummaryFieldDefinitions

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalSummaryFieldDefinitions [Property ComParent]

ComParent - cCrystalSummaryFieldDefinitions

Gets summary field collection parent (report).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalISummaryFieldDefinitions object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalTableLink

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalTableLink

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalTableLink

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComDestinationFields | Gets table link destination field definitions. |
ComDestinationTable | Gets table link destination table. |
ComJoinType | Gets table link join type. |
ComLookupType | Gets table link lookup type. |
ComParent | Gets table link parent (Database). |
ComSourceFields | Gets table link source field definitions. |
ComSourceTable | Gets table link source table. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalTableLink [Property ComDestinationFields]

ComDestinationFields - cCrystalTableLink

Gets table link destination field definitions.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLink object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTableLink [Property ComDestinationTable]

ComDestinationTable - cCrystalTableLink

Gets table link destination table.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLink object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTableLink [Property ComJoinType]

ComJoinType - cCrystalTableLink

Gets table link join type.

Type: Property

Access: Read-Only

Data Type: CRLinkJoinType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLink object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalTableLink [Property ComLookupType]

ComLookupType - cCrystalTableLink

Gets table link lookup type.

Type: Property

Access: Read-Only

Data Type: CRLinkLookUpType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLink object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalTableLink [Property ComParent]

ComParent - cCrystalTableLink

Gets table link parent (Database).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLink object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTableLink [Property ComSourceFields]

ComSourceFields - cCrystalTableLink

Gets table link source field definitions.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLink object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTableLink [Property ComSourceTable]

ComSourceTable - cCrystalTableLink

Gets table link source table.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLink object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalTableLinks

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


cCrystalTableLinks [Function ComAdd]

ComAdd - cCrystalTableLinks

Adds a database link.

Type: Function

Return Data Type: Variant

Parameters: Variant llpsrcTable Variant llpDestTable Variant llsrcFields Variant lldestFields CRLinkJoinType llJoinType CRLinkLookUpType llLookupType Boolean llPartialMatchEnabled Short llindexInUse

Parameter | Description
llpsrcTable | Please see Crystal RDC documentation for more information.
llpDestTable | Please see Crystal RDC documentation for more information.
llsrcFields | Please see Crystal RDC documentation for more information.
lldestFields | Please see Crystal RDC documentation for more information.
llJoinType | Please see Crystal RDC documentation for more information.
llLookupType | Please see Crystal RDC documentation for more information.
llPartialMatchEnabled | Please see Crystal RDC documentation for more information.
llindexInUse | Please see Crystal RDC documentation for more information.

Return Value

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Methods for cCrystalTableLinks

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAdd | Function | Adds a database link. |
ComAddref | Procedure |  | DfComAutomationObject
ComDelete | Procedure | Delete a table link. |
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalTableLinks [Procedure ComDelete]

ComDelete - cCrystalTableLinks

Delete a table link.

Type: Procedure

Parameters: Integer llindex

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalTableLinks

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets collection count. |
ComItem | Gets collection item. |
ComParent | Gets database links parent (Database). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalTableLinks [Property Com_NewEnum]

Com_NewEnum - cCrystalTableLinks

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTableLinks [Property ComCount]

ComCount - cCrystalTableLinks

Gets collection count.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTableLinks [Property ComItem]

ComItem - cCrystalTableLinks

Gets collection item.

Type: Property

Access: Read-Only

Data Type: Variant

Parameters: Integer llindex Variant vValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
vValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTableLinks [Property ComParent]

ComParent - cCrystalTableLinks

Gets database links parent (Database).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableLinks object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalTableQualifiers

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalTableQualifiers

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cCrystalTableQualifiers

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Com_NewEnum |  |
ComCount | Gets the count of qualifiers. |
ComItem | Gets the qualifier by index. |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalTableQualifiers [Property Com_NewEnum]

Com_NewEnum - cCrystalTableQualifiers

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableQualifiers object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTableQualifiers [Property ComCount]

ComCount - cCrystalTableQualifiers

Gets the count of qualifiers.

Type: Property

Access: Read-Only

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableQualifiers object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTableQualifiers [Property ComItem]

ComItem - cCrystalTableQualifiers

Gets the qualifier by index.

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer llindex String sValue

Parameter | Description
llindex | Please see Crystal RDC documentation for more information.
sValue | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITableQualifiers object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cCrystalTextObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created | DfComAutomationObject


Methods for cCrystalTextObject

View method list in hierarchical order

Name | Type | Description | Defining Class
AttachActiveObject | Function | Looks for an active COM object of its class in the system ROT (Running Object Table) and attaches it to the VDF object | cComAutomationObject
ComAddref | Procedure |  | DfComAutomationObject
ComQueryInterface | Function |  | DfComAutomationObject
ComSetLineSpacing | Procedure | Sets line spacing type and line spacing. |
ComSetText | Procedure | Sets text object text to be the specified text. |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object | DfComAutomationObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsComObjectCreated | Function | Tests to see if a COM object exists by getting the value of IsComObjectCreated | cComAutomationObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. | DfComAutomationObject
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object | DfComAutomationObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cCrystalTextObject [Procedure ComSetLineSpacing]

ComSetLineSpacing - cCrystalTextObject

Sets line spacing type and line spacing.

Type: Procedure

Parameters: Real llLineSpacing CRLineSpacingType llLineSpacingType

Parameter | Description
llLineSpacing | Please see Crystal RDC documentation for more information.
llLineSpacingType | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Procedure ComSetText]

ComSetText - cCrystalTextObject

Sets text object text to be the specified text.

Type: Procedure

Parameters: String llpText

Parameter | Description
llpText | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Properties for cCrystalTextObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
ComBackColor | Gets or sets object background color. |
ComBorderColor | Gets or sets object border color. |
ComBottomLineStyle | Gets or sets bottom line style. |
ComCanGrow | Gets or sets can grow option. |
ComCharacterSpacing | Gets or sets character spacing. |
ComCloseAtPageBreak | Gets or sets close border on page break. |
ComConditionFormula | Gets or sets conditional formula. |
ComCssClass | Gets or sets CSS class. |
ComFieldElements | Gets or sets embedded field elements. |
ComFirstLineIndent | Gets or sets first line indent. |
ComFont | Gets or sets standard OLE font. |
ComHasDropShadow | Gets or sets border drop shadow. |
ComHeight | Gets or sets object height (twips). |
ComHorAlignment | Gets or sets horizontal alignment. |
ComHyperlinkText | Gets or sets hyperlink text. |
ComHyperlinkType | Gets or sets hyperlink type. |
ComKeepTogether | Gets or sets keep object together. |
ComKind | Gets report object kind. |
ComLeft | Gets or sets object upper left position (twips). |
ComLeftIndent | Gets or sets left indent. |
ComLeftLineStyle | Gets or sets left line style. |
ComLineSpacing | Gets line spacing. |
ComLineSpacingType | Gets line spacing type. |
ComMaxNumberOfLines | Gets or sets max of number of line option. |
ComName | Gets or sets object name. |
ComParent | Gets object parent (Section). |
ComRightIndent | Gets or sets right indent. |
ComRightLineStyle | Gets or sets right line style. |
ComSuppress | Gets or sets object visibility. |
ComSuppressIfDuplicated | Gets or sets suppress if duplicated option. |
ComText | Gets whole text string. |
ComTextColor | Gets or sets object text color. |
ComTextRotationAngle | Gets or sets text rotation angle. |
ComTop | Gets or sets object upper top position (twips). |
ComTopLineStyle | Gets or sets top line style. |
ComWidth | Gets or sets object width (twips). |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation | DfComAutomationObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license | DfComAutomationObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfComAutomationObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfComAutomationObject


cCrystalTextObject [Property ComBackColor]

ComBackColor - cCrystalTextObject

Gets or sets object background color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComBorderColor]

ComBorderColor - cCrystalTextObject

Gets or sets object border color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComBottomLineStyle]

ComBottomLineStyle - cCrystalTextObject

Gets or sets bottom line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalTextObject [Property ComCanGrow]

ComCanGrow - cCrystalTextObject

Gets or sets can grow option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComCharacterSpacing]

ComCharacterSpacing - cCrystalTextObject

Gets or sets character spacing.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComCloseAtPageBreak]

ComCloseAtPageBreak - cCrystalTextObject

Gets or sets close border on page break.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComConditionFormula]

ComConditionFormula - cCrystalTextObject

Gets or sets conditional formula.

Type: Property

Access: Read/Write

Data Type: String

Parameters: Variant llFormulaType String value

Parameter | Description
llFormulaType | Please see Crystal RDC documentation for more information.
value | Please see Crystal RDC documentation for more information.

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComCssClass]

ComCssClass - cCrystalTextObject

Gets or sets CSS class.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComFieldElements]

ComFieldElements - cCrystalTextObject

Gets or sets embedded field elements.

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComFirstLineIndent]

ComFirstLineIndent - cCrystalTextObject

Gets or sets first line indent.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComFont]

ComFont - cCrystalTextObject

Gets or sets standard OLE font.

Type: Property

Access: Read/Write

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComHasDropShadow]

ComHasDropShadow - cCrystalTextObject

Gets or sets border drop shadow.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComHeight]

ComHeight - cCrystalTextObject

Gets or sets object height (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComHorAlignment]

ComHorAlignment - cCrystalTextObject

Gets or sets horizontal alignment.

Type: Property

Access: Read/Write

Data Type: CRAlignment

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalTextObject [Property ComHyperlinkText]

ComHyperlinkText - cCrystalTextObject

Gets or sets hyperlink text.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComHyperlinkType]

ComHyperlinkType - cCrystalTextObject

Gets or sets hyperlink type.

Type: Property

Access: Read/Write

Data Type: CRHyperlinkType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalTextObject [Property ComKeepTogether]

ComKeepTogether - cCrystalTextObject

Gets or sets keep object together.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComKind]

ComKind - cCrystalTextObject

Gets report object kind.

Type: Property

Access: Read-Only

Data Type: CRObjectKind

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalTextObject [Property ComLeft]

ComLeft - cCrystalTextObject

Gets or sets object upper left position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComLeftIndent]

ComLeftIndent - cCrystalTextObject

Gets or sets left indent.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComLeftLineStyle]

ComLeftLineStyle - cCrystalTextObject

Gets or sets left line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalTextObject [Property ComLineSpacing]

ComLineSpacing - cCrystalTextObject

Gets line spacing.

Type: Property

Access: Read-Only

Data Type: Real

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComLineSpacingType]

ComLineSpacingType - cCrystalTextObject

Gets line spacing type.

Type: Property

Access: Read-Only

Data Type: CRLineSpacingType

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalTextObject [Property ComMaxNumberOfLines]

ComMaxNumberOfLines - cCrystalTextObject

Gets or sets max of number of line option.

Type: Property

Access: Read/Write

Data Type: Short

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalTextObject [Property ComName]

ComName - cCrystalTextObject

Gets or sets object name.

Type: Property

Access: Read/Write

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComParent]

ComParent - cCrystalTextObject

Gets object parent (Section).

Type: Property

Access: Read-Only

Data Type: Variant

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComRightIndent]

ComRightIndent - cCrystalTextObject

Gets or sets right indent.

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComRightLineStyle]

ComRightLineStyle - cCrystalTextObject

Gets or sets right line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalTextObject [Property ComSuppress]

ComSuppress - cCrystalTextObject

Gets or sets object visibility.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComSuppressIfDuplicated]

ComSuppressIfDuplicated - cCrystalTextObject

Gets or sets suppress if duplicated option.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComText]

ComText - cCrystalTextObject

Gets whole text string.

Type: Property

Access: Read-Only

Data Type: String

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComTextColor]

ComTextColor - cCrystalTextObject

Gets or sets object text color.

Type: Property

Access: Read/Write

Data Type: OLE_Color

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComTextRotationAngle]

ComTextRotationAngle - cCrystalTextObject

Gets or sets text rotation angle.

Type: Property

Access: Read/Write

Data Type: CRRotationAngle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalTextObject [Property ComTop]

ComTop - cCrystalTextObject

Gets or sets object upper top position (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


cCrystalTextObject [Property ComTopLineStyle]

ComTopLineStyle - cCrystalTextObject

Gets or sets top line style.

Type: Property

Access: Read/Write

Data Type: CRLineStyle

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: August 3, 2005


cCrystalTextObject [Property ComWidth]

ComWidth - cCrystalTextObject

Gets or sets object width (twips).

Type: Property

Access: Read/Write

Data Type: Integer

Description

Refer to the cCrystal and cCrystalReport class for more information about using the Crystal Report classes.

For more information about the RDC cCrystalITextObject object, refer to the Crystal RDC documentation. This link will take you to the Crystal Report Designer Component (RDC) Object Model page, which lists all objects and collections in the Crystal RDC. Follow the links on this page for details on specific object, collections, properties and methods.

This is the documentation directly from the Crystal Reports CrystalDevHelp.chm help file. Visual DataFlex interfaces with the Crystal RDC via COM. For your convenience, all classes in the Crystal RDC have an interface from Visual DataFlex and are listed in the Class Reference. In Visual DataFlex, each Crystal RDC object or collection name is prefixed with "cCrystal", each Crystal RDC property or method name is prefixed with "Com", and each event name is prefixed with "OnCom".

Last Edited: June 14, 2005


Events for cDB2Handler

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cDB2Handler [Function DataSources]

DataSources - cDB2Handler

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


Methods for cDB2Handler

View method list in hierarchical order

Name | Type | Description | Defining Class
CKBuildRevision | Function | Returns the build revision of the Connectivity Kit. | cCLIHandler
CKMajorRevision | Function | Returns the major revision of the Connectivity Kit. | cCLIHandler
CKMinorRevision | Function | Returns the minor revision of the Connectivity Kit. | cCLIHandler
CKReleaseRevision | Function | Returns the release revision of the Connectivity Kit. | cCLIHandler
CKRevision | Function | Returns the Connectivity Kit revision in the format Major.Minor.Release.Build. | cCLIHandler
CLIDFDateToSQLDate | Function |  | cCLIHandler
CLISQLDateToDFDate | Function |  | cCLIHandler
ColumnName | Function | Returns the name of the column enumerated at the given position by EnumerateColumns. | cCLIHandler
Create | Function | Creates an object based on the passed Class Id | cObject
DataSources | Function |  |
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
DumpStatus | Procedure | Dumps the current status of the Connectivity Kit to an ASCII disk file. | cCLIHandler
EnumerateColumns | Function | Enumerates all column names for a given table. | cCLIHandler
EnumerateTables | Function | Enumerates tables in the given database. | cCLIHandler
Exit_Application | Procedure | Starts the process of closing an application | cObject
ExtractPartFromRevision | Function |  | cCLIHandler
IsMinimalRevision | Function | Checks if a Connectivity Kit complies with a minimal revision. | cCLIHandler
LastDriverError | Function | Returns the string value of the last generated driver error. | cCLIHandler
MaxUsers | Function | Returns the maximum number of users of the Connectivity Kit. | cCLIHandler
ReadConfiguration | Procedure | Forces the Connectivity Kit to reread the driver configuration file. | cCLIHandler
RedirectConnection | Function |  | cCLIHandler
RegistrationName | Function | Returns the registration name of the Connectivity Kit. | cCLIHandler
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
RIMValueToText | Function | Converts a DF_FILE_GENERATE_RECORD_ID_METHOD attribute value to the corresponding text. | cCLIHandler
ROValueToText | Function | Converts a DF_FIELD_READ_ONLY attribute value to the corresponding text. | cCLIHandler
SchemaName | Function | Returns the schema of the table enumerated at the given position by EnumerateTables. | cCLIHandler
SeedDataSources | Procedure |  |
SerialNumber | Function | Returns the Connectivity Kit serial number. | cCLIHandler
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array
TableComment | Function | Returns the comment of the table enumerated at the given position by EnumerateTables. | cCLIHandler
TableName | Function | Returns the name of the table enumerated at the given position by EnumerateTables. | cCLIHandler
TableType | Function | Returns the type of the table enumerated at the given position by EnumerateTables. | cCLIHandler
TextToRIMValue | Function | Converts a record identity text to the DF_FILE_GENERATE_RECORD_ID_METHOD attribute value | cCLIHandler
TextToROValue | Function | Converts a read only text to the DF_FIELD_READ_ONLY attribute value. | cCLIHandler


cDB2Handler [Procedure SeedDataSources]

SeedDataSources - cDB2Handler

Type: Procedure

Parameters: No Parameters

Description

Last Edited: June 2, 2006


Properties for cDB2Handler

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psDriverID | The identification of the CLI driver. | cCLIHandler
Value | Sets and Gets an array element's value | Array


Events for cDbRichEdit

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | cRichEdit
OnChange | Fires whenever the value of the control is changed | cRichEdit
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | cRichEdit
OnLinkClicked | Fires when hyperlink in text is clicked | DFBaseRichEdit
OnMaxText | Fires when maximum text size is exceeded | cRichEdit
OnSelectionChanged | Fires when selection changes | DFBaseRichEdit
OnSetFocus | Sent whenever windows is about to give this object the focus | cRichEdit
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | cRichEdit
Refresh | Displays items from some files at the same time as clearing items from other files | cDbRichEdit_
Shadow_Display | Fired whenever a change in enabled state occurs | cRichEdit


Methods for cDbRichEdit

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | cRichEdit
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
AppendText | Procedure | Appends text to end of text in control | DFBaseRichEdit
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed | cRichEdit
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control | DFBaseRichEdit
Beginning_of_Line | Procedure | Places the cursor at beginning of current line | DFBaseRichEdit
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | cRichEdit
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | cRichEdit
Cancel | Procedure | Returns the message_id of itself | cUIObject
CharCount | Function | Returns length of RTF stream in the control | DFBaseRichEdit
ClearUndoBuffer | Procedure | Clears undo buffer | DFBaseRichEdit
Close_Panel | Procedure | Closes the panel or component currently open | cDbRichEditDS_
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | cDbRichEditDS_
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Deletes all data in control | DFBaseRichEdit
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | cRichEdit
End_of_Data | Procedure | Places the cursor at end of the text in control | DFBaseRichEdit
End_of_Line | Procedure | Places the cursor at end of current line | DFBaseRichEdit
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | cRichEdit
Error_Help | Procedure | (Obsolete) | cRichEdit
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | cDbRichEdit_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | cRichEdit
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | cRichEdit
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | cDbRichEdit_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | cDbRichEdit_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | cDbRichEdit_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | cDbRichEdit_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | cDbRichEdit_
FindText | Function | Searches for specified text in control | DFBaseRichEdit
FirstCharInLinePos | Function | Returns position of first character in a line | DFBaseRichEdit
FirstVisibleLine | Function | Returns number of first visible line | DFBaseRichEdit
Help | Procedure |  | cRichEdit
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | cDbRichEditDS_
Help_For_Help | Procedure | (Obsolete) | cRichEdit
Help_Index | Procedure | (Obsolete) | cRichEdit
Help_on_topic | Procedure | (Obsolete) | cRichEdit
HideSelection | Procedure | Toggles selection highlighting on or off | DFBaseRichEdit
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | cRichEdit
LastErrorCode | Function | Returns error code for last operation | DFBaseRichEdit
Line | Function | Returns specified line of text | DFBaseRichEdit
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
LineFromChar | Function | Returns number of line that contains specified character position or current line | DFBaseRichEdit
LineLength | Function | Returns number of characters in line | DFBaseRichEdit
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cRichEdit
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cRichEdit
Prompt | Procedure | Cancelled in this class | cDbRichEdit_
Prompt_Description | Function | (Obsolete) | cDbRichEditDS_
Prompt_Description | Procedure | (Obsolete) | cDbRichEditDS_
Read | Procedure | Reads RTF document and displays it in the control | DFBaseRichEdit
Redo | Procedure | Redoes the last operation | DFBaseRichEdit
RedoType | Function | Returns type of redo operation at top of redo queue | DFBaseRichEdit
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements | DFBaseRichEdit
ReplaceSel | Procedure | Replaces selected text with specified text | DFBaseRichEdit
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | cDbRichEdit_
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true | cDbRichEdit_
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true | cDbRichEdit_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | cDbRichEdit_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | cDbRichEdit_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | cDbRichEdit_
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was | cDbRichEdit_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | cRichEdit
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | cDbRichEdit_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls up or down the control using specified scroll mode | DFBaseRichEdit
ScrollCaret | Procedure | Scrolls caret into view | DFBaseRichEdit
ScrollLines | Procedure | Scrolls control vertically for specified number of lines | DFBaseRichEdit
Select_All | Procedure | Selects entire contents of control | DFBaseRichEdit
SelEnd | Function | Returns end of selection | DFBaseRichEdit
SelStart | Function | Returns beginning of selection | DFBaseRichEdit
SelText | Function | Returns selected text | DFBaseRichEdit
SetSel | Procedure | Selects text in given position range | DFBaseRichEdit
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | cDbRichEdit_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | cDbRichEdit_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | cDbRichEdit_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
TextRange | Function | Returns text in given position range | DFBaseRichEdit
ToggleBold | Procedure | Toggles selected text between bold and normal text | cRichEdit
ToggleItalics | Procedure | Toggles selected text between italicized and normal text | cRichEdit
ToggleUnderline | Procedure | Toggles selected text between underlined and normal text | cRichEdit
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | cRichEdit
Undo | Procedure | Undoes the last operation | DFBaseRichEdit
UndoType | Function | Returns type of undo operation at top of undo queue | DFBaseRichEdit
Validate_Items | Function | Returns whether data in the control is valid | cDbRichEditDS_
Validate_Prompt | Function | (Obsolete) | cDbRichEditDS_
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | cDbRichEdit_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | cDbRichEdit_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | cDbRichEdit_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | cDbRichEdit_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes RTF stream content of control to file | DFBaseRichEdit
Zoom | Procedure | Cancelled in this class | cDbRichEdit_


Properties for cDbRichEdit

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | cDbRichEdit_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | cDbRichEdit_
Auto_Label_State | Determines if the control will draw label values from the DataDictionary instead of the Label property |
Auto_Save_State | Determines if auto save should be performed | cDbRichEdit_
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | cDbRichEdit_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Changed_State | Determines whether the content of the control has changed | cRichEdit
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | The field number of the target text field | cDbRichEdit_
Data_File | The file number of target memo field | cDbRichEdit_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | cDbRichEdit_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | cDbRichEdit_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | cRichEdit
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | cRichEdit
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object | cRichEdit
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | cRichEdit
Help_Keyword | Used to specify an object's context keyword | cRichEdit
Item_Count | Created for simulation of entry item | cDbRichEdit_
Item_Shadow_State | Determines if an object's item is enabled or disabled | cRichEdit
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | cRichEdit
Label_Col_Offset | The horizontal distance from the object to its label | cRichEdit
Label_Justification_Mode | The justification mode for the text within this object's label | cRichEdit
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | cRichEdit
Label_Row_Offset | The vertical distance from the top edge of the object and its label | cRichEdit
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of lines in control | DFBaseRichEdit
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | cRichEdit
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
paValue | Sets content of control from memory address or places RTF stream in control into memory address | DFBaseRichEdit
pbAutoUrl | Toggles the ability for the control to automatically detect URLs and add hyperlinks | DFBaseRichEdit
pbBold | Toggles selected text between bold and normal text | DFBaseRichEdit
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard | DFBaseRichEdit
pbCanRedo | Determines whether a redo operation can be performed | DFBaseRichEdit
pbCanUndo | Determines whether an undo operation can be performed | DFBaseRichEdit
pbItalics | Toggles selected text between italicized and normal text | DFBaseRichEdit
pbLink | Toggles selected text between hyperlinked and normal text | DFBaseRichEdit
pbProtect | Toggles selected text between protected and normal text | DFBaseRichEdit
pbStrikeOut | Toggles selected text between strikeout and normal text | DFBaseRichEdit
pbSubScript | Toggles selected text between subcripted and normal text | DFBaseRichEdit
pbSuperScript | Toggles selected text between superscripted and normal text | DFBaseRichEdit
pbUnderline | Toggles selected text between underlined and normal text | DFBaseRichEdit
pbWrap | Determines whether text input will break and wrap to the next line at right margin | DFBaseRichEdit
peAlignment | Sets or returns alignment of selected paragraph or paragraphs | DFBaseRichEdit
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peBullets | Sets or returns bullets or numbering of selected paragraph or paragraphs | DFBaseRichEdit
peBulletStyle | Sets or returns numbering styles of selected paragraph or paragraphs | DFBaseRichEdit
peCharSet | Sets or returns character set of selected text | DFBaseRichEdit
peLineSpacingType | Determines type of line spacing of selected paragraph or paragraphs | DFBaseRichEdit
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
pePitchandFamily | Sets or returns the font pitch and family of selected text | DFBaseRichEdit
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piBulletStart | Sets or returns the starting number of paragraph numbering of selected paragraph or paragraphs | DFBaseRichEdit
piBulletTab | Sets or returns the minimum space between a paragraph bullet or number and the paragraph text of selected paragraph or paragraphs | DFBaseRichEdit
piFontSize | Sets or returns font size of selected text | DFBaseRichEdit
piFontWeight | Sets or returns font weight of selected text | DFBaseRichEdit
piLineSpacing | Determines exact line spacing of selected paragraph or paragraphs | DFBaseRichEdit
piMaxChars | Sets or returns maximum number of characters | DFBaseRichEdit
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piOffsetIndent | Sets or returns indentation of 2nd and subsequent lines, relative to first line, of selected paragraph or paragraphs | DFBaseRichEdit
piParagraphIndent | Sets or returns indentation of selected paragraph or paragraphs | DFBaseRichEdit
piRightMargin | Determines indentation of right side of control's text, relative to the right margin | DFBaseRichEdit
piSpacingAfter | Determines the spacing below selected paragraph or paragraphs | DFBaseRichEdit
piSpacingBefore | Determines the spacing above selected paragraph or paragraphs | DFBaseRichEdit
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | cRichEdit
psTypeFace | Sets or returns font typeface of selected text | DFBaseRichEdit
Read_Only_State | Determines whether users may edit the content of the control | DFBaseRichEdit
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | cDbRichEdit_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | cDbRichEdit_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | cRichEdit
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextBackColor | Sets or returns background color of selected text | DFBaseRichEdit
TextColor | Sets or returns color of selected text | DFBaseRichEdit
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | cRichEdit
Value | Sets or returns content of control | DFBaseRichEdit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | cDbRichEdit_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | cDbRichEdit_
verify_exit_msg | Determines what message is sent during an exiting event | cDbRichEdit_
Verify_Save_Msg | Specifies the message to use for save confirmation | cDbRichEdit_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cDbRichEdit [Property Auto_Label_State]

Auto_Label_State - cDbRichEdit

Determines if the control will draw label values from the DataDictionary instead of the Label property

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If Auto_Label_State is True, the control will draw label values from the DataDictionary Object's short label name for the field of the control, rather than from any Label that may be set in this control.

Sample

This sample turns auto labeling on.

set Auto_Label_State to True

Sample

This sample turns auto labeling off.

set Auto_Label_State to False

Last Edited: January 12, 2006


cDbRichEdit_ [Event Refresh]

Refresh - cDbRichEdit_

Displays items from some files at the same time as clearing items from other files

Type: Event

Parameters: integer notifyMode

Parameter Description
notifyModeThe mode, which signifies the event or operation which generated this refresh message, may be one of the following five:

Constant | Meaning
mode_clear | used only for DEOs attached to the server which was the "origin" of a clear operation, i.e., the DataSet which received the original clear request or message as a result of the user pressing kclear. All other servers send their DEOs the refresh message passing mode_find_or_clear_set.
mode_find_or_clear_set | used for DEOs attached to servers which have found and/or cleared records in response to a user's find-request (kfind, kfind_next, ksuperfind, et al.) or in response to another server's find or clear.
mode_clear_all | used for DEOs attached to any server which participated in a clear_all operation.
mode_delete | used for DEOs attached to any server which performed a successful deletion. DataSets that were merely updated as the result of a deletion use mode_find_or_clear_set.
mode_save | used for DEOs attached to any server involved in a successful save operation.

Description

Refresh displays items from some files at the same time as clearing items from other files. In all cases, refresh will be sent instead of the clear, clear_set, clear_all, display, and entry_display messages in response to a find, clear, clear _all, save, or delete. In some cases, the actions of refresh depend on the (old) messages clear, clear _all, save, and display.

Last Edited: September 11, 2003


Events for cDbRichEdit_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | cRichEdit
OnChange | Fires whenever the value of the control is changed | cRichEdit
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | cRichEdit
OnLinkClicked | Fires when hyperlink in text is clicked | DFBaseRichEdit
OnMaxText | Fires when maximum text size is exceeded | cRichEdit
OnSelectionChanged | Fires when selection changes | DFBaseRichEdit
OnSetFocus | Sent whenever windows is about to give this object the focus | cRichEdit
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | cRichEdit
Refresh | Displays items from some files at the same time as clearing items from other files |
Shadow_Display | Fired whenever a change in enabled state occurs | cRichEdit


cDbRichEdit_ [Function Validate_Items]

Validate_Items - cDbRichEdit_

Returns 0 by default, to indicate that entered text is valid

Type: Function

Return Data Type: Integer

Parameters: Boolean bNotFindReq

Parameter | Description
bNotFindReq | Not used. If false validates all item options; if true validates all item options except findreq.

Return Value

Always returns 0.

Description

Validate_items returns 0 by default, to indicate that entered text is valid. Text fields are always considered valid. Therefore, this function always returns 0. In unusual cases, this maybe overridden to enforce application-specific validations, i.e., size limits, inclusion of key words, etc.

Last Edited: July 11, 2006


cDbRichEdit_ [Function Verify_Data_Loss]

Verify_Data_Loss - cDbRichEdit_

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


cDbRichEdit_ [Function Verify_Delete]

Verify_Delete - cDbRichEdit_

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


cDbRichEdit_ [Function verify_Exit]

verify_Exit - cDbRichEdit_

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


cDbRichEdit_ [Function Verify_Save]

Verify_Save - cDbRichEdit_

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for cDbRichEdit_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | cRichEdit
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
AppendText | Procedure | Appends text to end of text in control | DFBaseRichEdit
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed | cRichEdit
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control | DFBaseRichEdit
Beginning_of_Line | Procedure | Places the cursor at beginning of current line | DFBaseRichEdit
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | cRichEdit
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | cRichEdit
Cancel | Procedure | Returns the message_id of itself | cUIObject
CharCount | Function | Returns length of RTF stream in the control | DFBaseRichEdit
ClearUndoBuffer | Procedure | Clears undo buffer | DFBaseRichEdit
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Deletes all data in control | DFBaseRichEdit
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | cRichEdit
End_of_Data | Procedure | Places the cursor at end of the text in control | DFBaseRichEdit
End_of_Line | Procedure | Places the cursor at end of current line | DFBaseRichEdit
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | cRichEdit
Error_Help | Procedure | (Obsolete) | cRichEdit
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | cRichEdit
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | cRichEdit
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find |
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find |
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find |
FindText | Function | Searches for specified text in control | DFBaseRichEdit
FirstCharInLinePos | Function | Returns position of first character in a line | DFBaseRichEdit
FirstVisibleLine | Function | Returns number of first visible line | DFBaseRichEdit
Help | Procedure |  | cRichEdit
Help_For_Help | Procedure | (Obsolete) | cRichEdit
Help_Index | Procedure | (Obsolete) | cRichEdit
Help_on_topic | Procedure | (Obsolete) | cRichEdit
HideSelection | Procedure | Toggles selection highlighting on or off | DFBaseRichEdit
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | cRichEdit
LastErrorCode | Function | Returns error code for last operation | DFBaseRichEdit
Line | Function | Returns specified line of text | DFBaseRichEdit
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
LineFromChar | Function | Returns number of line that contains specified character position or current line | DFBaseRichEdit
LineLength | Function | Returns number of characters in line | DFBaseRichEdit
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cRichEdit
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cRichEdit
Prompt | Procedure | Cancelled in this class |
Read | Procedure | Reads RTF document and displays it in the control | DFBaseRichEdit
Redo | Procedure | Redoes the last operation | DFBaseRichEdit
RedoType | Function | Returns type of redo operation at top of redo queue | DFBaseRichEdit
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements | DFBaseRichEdit
ReplaceSel | Procedure | Replaces selected text with specified text | DFBaseRichEdit
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Delete | Procedure | Deletes the current record of this object's server, if any |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any |
Request_Save | Procedure | Saves changes to the current record of this object's server, if any |
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | cRichEdit
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls up or down the control using specified scroll mode | DFBaseRichEdit
ScrollCaret | Procedure | Scrolls caret into view | DFBaseRichEdit
ScrollLines | Procedure | Scrolls control vertically for specified number of lines | DFBaseRichEdit
Select_All | Procedure | Selects entire contents of control | DFBaseRichEdit
SelEnd | Function | Returns end of selection | DFBaseRichEdit
SelStart | Function | Returns beginning of selection | DFBaseRichEdit
SelText | Function | Returns selected text | DFBaseRichEdit
SetSel | Procedure | Selects text in given position range | DFBaseRichEdit
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind |
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind |
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind |
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
TextRange | Function | Returns text in given position range | DFBaseRichEdit
ToggleBold | Procedure | Toggles selected text between bold and normal text | cRichEdit
ToggleItalics | Procedure | Toggles selected text between italicized and normal text | cRichEdit
ToggleUnderline | Procedure | Toggles selected text between underlined and normal text | cRichEdit
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | cRichEdit
Undo | Procedure | Undoes the last operation | DFBaseRichEdit
UndoType | Function | Returns type of undo operation at top of undo queue | DFBaseRichEdit
Validate_Items | Function | Returns 0 by default, to indicate that entered text is valid |
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes RTF stream content of control to file | DFBaseRichEdit
Zoom | Procedure | Cancelled in this class |


cDbRichEdit_ [Procedure Exit_Function]

Exit_Function - cDbRichEdit_

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


cDbRichEdit_ [Procedure Find_First]

Find_First - cDbRichEdit_

Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_first finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of beginning_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbRichEdit_ [Procedure Find_GE]

Find_GE - cDbRichEdit_

Performs a find greater than or equal by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_ge performs a find greater than or equal by the data_file and data_field of the current item, using request_find. Sent by kfind.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbRichEdit_ [Procedure Find_Last]

Find_Last - cDbRichEdit_

Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_last finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of end_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbRichEdit_ [Procedure Find_Next]

Find_Next - cDbRichEdit_

Performs a find greater than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_next performs a find greater than by the data_file and data_field of the current item, using request_find. Sent by kfind_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbRichEdit_ [Procedure Find_Previous]

Find_Previous - cDbRichEdit_

Performs a find less than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_previous performs a find less than by the data_file and data_field of the current item, using request_find. Sent by kfind_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbRichEdit_ [Procedure Prompt]

Prompt - cDbRichEdit_

Cancelled in this class

Type: Procedure

Parameters: No Parameters

Description

The Prompt procedure is cancelled in this class.

Last Edited: September 11, 2003


cDbRichEdit_ [Procedure Request_Cancel]

Request_Cancel - cDbRichEdit_

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


cDbRichEdit_ [Procedure Request_Clear]

Request_Clear - cDbRichEdit_

Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause users to lose changes made to the text, verify_data_loss is used to confirm the action. If this object has a server, clear is requested of the server. This may result in other DEOs clearing in addition to this object. Sent by kclear.

Last Edited: September 11, 2003


cDbRichEdit_ [Procedure Request_Clear_All]

Request_Clear_All - cDbRichEdit_

Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear_all clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause the user to lose changes made to the text, verify_data_loss is used to confirm the action. If this object has a server, clear_all is requested of the server. This may result in other DEOs clearing in addition to this object. Sent by kclear_all.

Last Edited: September 11, 2003


cDbRichEdit_ [Procedure Request_Delete]

Request_Delete - cDbRichEdit_

Deletes the current record of this object's server, if any

Type: Procedure

Parameters: No Parameters

Description

Request_delete deletes the current record of this object's server, if any. If successful and auto_clear_deo_state is true, also clears the text area using request_clear. Verify_delete is used to confirm the action. Sent by kdelete_record. Sends can_delete and acts only if true is returned.

Last Edited: September 11, 2003


cDbRichEdit_ [Procedure Request_Find]

Request_Find - cDbRichEdit_

Finds record using specified mode by requesting item_find from server, if any

Type: Procedure

Parameters: integer mode integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true perform entry update before Find.

Description

Request_find finds record using specified mode by requesting item_find from server, if any. Uses data_file and data_field to determine file and field for find. If this object has no server, no action is taken.

Last Edited: September 11, 2003


cDbRichEdit_ [Procedure Request_Save]

Request_Save - cDbRichEdit_

Saves changes to the current record of this object's server, if any

Type: Procedure

Parameters: No Parameters

Description

Request_save saves changes to the current record of this object's server, if any. If successful and auto_clear_deo_state is true, clears text area using request_clear. Verify_save is used to confirm the action. Sent by ksave_record.

Last Edited: September 11, 2003


cDbRichEdit_ [Procedure Request_Save_No_Clear]

Request_Save_No_Clear - cDbRichEdit_

A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was

Type: Procedure

Parameters: No Parameters

Description

Request_save_no_clear is a version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was.

Last Edited: September 11, 2003


cDbRichEdit_ [Procedure Request_Superfind]

Request_Superfind - cDbRichEdit_

Superfinds record using specified mode by requesting item_superfind from server, if any

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Request_superfind superfinds record using specified mode by requesting item_superfind from server, if any. Uses data_file and data_field to determine file and field for find. If this object has no server, no action is taken. Sent by DEOs. Sends of request_superfind to a DataSet require Predefined Indicator err to be set to false beforehand, in case an error other than Find past end of file or Find prior to beginning of file is generated by the superfind.

Last Edited: September 11, 2003


cDbRichEdit_ [Procedure SuperFind]

SuperFind - cDbRichEdit_

Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbRichEdit_ [Procedure SuperFind_Next]

SuperFind_Next - cDbRichEdit_

Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_next performs a superfind greater than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbRichEdit_ [Procedure SuperFind_Previous]

SuperFind_Previous - cDbRichEdit_

Performs a superfind less than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_previous performs a superfind less than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbRichEdit_ [Procedure Zoom]

Zoom - cDbRichEdit_

Cancelled in this class

Type: Procedure

Parameters: No Parameters

Description

The Zoom procedure is cancelled in this class.

Last Edited: September 15, 2003


Properties for cDbRichEdit_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Save_State | Determines if auto save should be performed |
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Changed_State | Determines whether the content of the control has changed | cRichEdit
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | The field number of the target text field |
Data_File | The file number of target memo field |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | cRichEdit
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | cRichEdit
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object | cRichEdit
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | cRichEdit
Help_Keyword | Used to specify an object's context keyword | cRichEdit
Item_Count | Created for simulation of entry item |
Item_Shadow_State | Determines if an object's item is enabled or disabled | cRichEdit
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | cRichEdit
Label_Col_Offset | The horizontal distance from the object to its label | cRichEdit
Label_Justification_Mode | The justification mode for the text within this object's label | cRichEdit
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | cRichEdit
Label_Row_Offset | The vertical distance from the top edge of the object and its label | cRichEdit
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of lines in control | DFBaseRichEdit
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | cRichEdit
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
paValue | Sets content of control from memory address or places RTF stream in control into memory address | DFBaseRichEdit
pbAutoUrl | Toggles the ability for the control to automatically detect URLs and add hyperlinks | DFBaseRichEdit
pbBold | Toggles selected text between bold and normal text | DFBaseRichEdit
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard | DFBaseRichEdit
pbCanRedo | Determines whether a redo operation can be performed | DFBaseRichEdit
pbCanUndo | Determines whether an undo operation can be performed | DFBaseRichEdit
pbItalics | Toggles selected text between italicized and normal text | DFBaseRichEdit
pbLink | Toggles selected text between hyperlinked and normal text | DFBaseRichEdit
pbProtect | Toggles selected text between protected and normal text | DFBaseRichEdit
pbStrikeOut | Toggles selected text between strikeout and normal text | DFBaseRichEdit
pbSubScript | Toggles selected text between subcripted and normal text | DFBaseRichEdit
pbSuperScript | Toggles selected text between superscripted and normal text | DFBaseRichEdit
pbUnderline | Toggles selected text between underlined and normal text | DFBaseRichEdit
pbWrap | Determines whether text input will break and wrap to the next line at right margin | DFBaseRichEdit
peAlignment | Sets or returns alignment of selected paragraph or paragraphs | DFBaseRichEdit
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peBullets | Sets or returns bullets or numbering of selected paragraph or paragraphs | DFBaseRichEdit
peBulletStyle | Sets or returns numbering styles of selected paragraph or paragraphs | DFBaseRichEdit
peCharSet | Sets or returns character set of selected text | DFBaseRichEdit
peLineSpacingType | Determines type of line spacing of selected paragraph or paragraphs | DFBaseRichEdit
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
pePitchandFamily | Sets or returns the font pitch and family of selected text | DFBaseRichEdit
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piBulletStart | Sets or returns the starting number of paragraph numbering of selected paragraph or paragraphs | DFBaseRichEdit
piBulletTab | Sets or returns the minimum space between a paragraph bullet or number and the paragraph text of selected paragraph or paragraphs | DFBaseRichEdit
piFontSize | Sets or returns font size of selected text | DFBaseRichEdit
piFontWeight | Sets or returns font weight of selected text | DFBaseRichEdit
piLineSpacing | Determines exact line spacing of selected paragraph or paragraphs | DFBaseRichEdit
piMaxChars | Sets or returns maximum number of characters | DFBaseRichEdit
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piOffsetIndent | Sets or returns indentation of 2nd and subsequent lines, relative to first line, of selected paragraph or paragraphs | DFBaseRichEdit
piParagraphIndent | Sets or returns indentation of selected paragraph or paragraphs | DFBaseRichEdit
piRightMargin | Determines indentation of right side of control's text, relative to the right margin | DFBaseRichEdit
piSpacingAfter | Determines the spacing below selected paragraph or paragraphs | DFBaseRichEdit
piSpacingBefore | Determines the spacing above selected paragraph or paragraphs | DFBaseRichEdit
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | cRichEdit
psTypeFace | Sets or returns font typeface of selected text | DFBaseRichEdit
Read_Only_State | Determines whether users may edit the content of the control | DFBaseRichEdit
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object |
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | cRichEdit
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextBackColor | Sets or returns background color of selected text | DFBaseRichEdit
TextColor | Sets or returns color of selected text | DFBaseRichEdit
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | cRichEdit
Value | Sets or returns content of control | DFBaseRichEdit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event |
Verify_Save_Msg | Specifies the message to use for save confirmation |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cDbRichEdit_ [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - cDbRichEdit_

If true, this object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


cDbRichEdit_ [Property Auto_Fill_State]

Auto_Fill_State - cDbRichEdit_

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


cDbRichEdit_ [Property Auto_Save_State]

Auto_Save_State - cDbRichEdit_

Determines if auto save should be performed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_save_state property is true, rotation from the last object within this object to the first object within this object will cause this object to save. Intended to be set.

Default is false.

Last Edited: January 12, 2006


cDbRichEdit_ [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - cDbRichEdit_

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


cDbRichEdit_ [Property Data_Field]

Data_Field - cDbRichEdit_

The field number of the target text field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer item# integer newval

Parameter | Description
item# | The item number
newval | The field number

Description

Data_Field determines the field number of target memo field, if any, else 0. Item# will always be 0.

Last Edited: July 31, 2003


cDbRichEdit_ [Property Data_File]

Data_File - cDbRichEdit_

The file number of target memo field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer item# integer newval

Parameter | Description
item# | The item number
newval | The file number

Description

Data_File determines the file number of target memo field, if any, else 0. Item# will always be 0.

Last Edited: August 5, 2003


cDbRichEdit_ [Property Deferred_State]

Deferred_State - cDbRichEdit_

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


cDbRichEdit_ [Property deo_delegate_mode]

deo_delegate_mode - cDbRichEdit_

Controls those requests for which delegate_..._state is set true

Type: Property

Access: Read/Write

Data Type: Integer

Description

Deo_delegate_mode controls those requests for which delegate_..._state is set true. The default delegate_server mode delegates request messages for objects that are not explicitly using a DDO. Delegate_always delegates regardless of whether a server is declared for the object, and delegate_never never delegates. This behavior may be set globally rather than just for this object by setting a function named default_deo_delegate_mode, and may also be queried with get.

Default is delegate_server.

Last Edited: July 31, 2003


cDbRichEdit_ [Property Item_Count]

Item_Count - cDbRichEdit_

Created for simulation of entry item

Type: Property

Access: Read-Only

Data Type: Integer

Description

Item_count returns 1. It is created for simulation of entry item.

Last Edited: August 18, 2003


cDbRichEdit_ [Property Server]

Server - cDbRichEdit_

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


cDbRichEdit_ [Property Should_Save]

Should_Save - cDbRichEdit_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


cDbRichEdit_ [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - cDbRichEdit_

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


cDbRichEdit_ [Property Verify_Delete_Msg]

Verify_Delete_Msg - cDbRichEdit_

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


cDbRichEdit_ [Property verify_exit_msg]

verify_exit_msg - cDbRichEdit_

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


cDbRichEdit_ [Property Verify_Save_Msg]

Verify_Save_Msg - cDbRichEdit_

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


Events for cDbRichEditDS_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | cRichEdit
OnChange | Fires whenever the value of the control is changed | cRichEdit
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | cRichEdit
OnLinkClicked | Fires when hyperlink in text is clicked | DFBaseRichEdit
OnMaxText | Fires when maximum text size is exceeded | cRichEdit
OnSelectionChanged | Fires when selection changes | DFBaseRichEdit
OnSetFocus | Sent whenever windows is about to give this object the focus | cRichEdit
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | cRichEdit
Refresh | Displays items from some files at the same time as clearing items from other files | cDbRichEdit_
Shadow_Display | Fired whenever a change in enabled state occurs | cRichEdit


cDbRichEditDS_ [Function Help_Datafile]

Help_Datafile - cDbRichEditDS_

Returns the filename and fieldname in file.field format that contains help for the current item

Type: Function

Obsolete

Return Data Type: String

Parameters: No Parameters

Return Value

The filename and fieldname in file.field format that contains help for the current item

Description

The Help_datafile function returns the filename and fieldname in file.field format that contains help for the current item.

Last Edited: August 12, 2003


cDbRichEditDS_ [Function Prompt_Description]

Prompt_Description - cDbRichEditDS_

Type: Function

Obsolete

Return Data Type: String

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


cDbRichEditDS_ [Function Validate_Items]

Validate_Items - cDbRichEditDS_

Returns whether data in the control is valid

Type: Function

Return Data Type: Integer

Parameters: Boolean bNotFindReq

Parameter | Description
bNotFindReq | Not used for text fields.

Return Value

Returns 0 if data is valid or a non-zero value if data is not valid.

Description

Returns whether the data in the control is valid.

Sample

This sample calls Validate_Items of control oDbRichEdit1. An error will be displayed in a message box if validation fails. For example, if the text in the control exceeds the size of the database table field the control is attached to, you will see Error 4424: Text too large for database field.

Procedure ValidateTextField
    integer iValid

    get Validate_Items of oDbRichEdit1 True to iValid
End_Procedure  // ValidateTextField

Last Edited: July 11, 2006


cDbRichEditDS_ [Function Validate_Prompt]

Validate_Prompt - cDbRichEditDS_

Type: Function

Obsolete

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for cDbRichEditDS_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | cRichEdit
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
AppendText | Procedure | Appends text to end of text in control | DFBaseRichEdit
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed | cRichEdit
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control | DFBaseRichEdit
Beginning_of_Line | Procedure | Places the cursor at beginning of current line | DFBaseRichEdit
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | cRichEdit
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | cRichEdit
Cancel | Procedure | Returns the message_id of itself | cUIObject
CharCount | Function | Returns length of RTF stream in the control | DFBaseRichEdit
ClearUndoBuffer | Procedure | Clears undo buffer | DFBaseRichEdit
Close_Panel | Procedure | Closes the panel or component currently open |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) |
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Deletes all data in control | DFBaseRichEdit
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | cRichEdit
End_of_Data | Procedure | Places the cursor at end of the text in control | DFBaseRichEdit
End_of_Line | Procedure | Places the cursor at end of current line | DFBaseRichEdit
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | cRichEdit
Error_Help | Procedure | (Obsolete) | cRichEdit
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | cDbRichEdit_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | cRichEdit
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | cRichEdit
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | cDbRichEdit_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | cDbRichEdit_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | cDbRichEdit_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | cDbRichEdit_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | cDbRichEdit_
FindText | Function | Searches for specified text in control | DFBaseRichEdit
FirstCharInLinePos | Function | Returns position of first character in a line | DFBaseRichEdit
FirstVisibleLine | Function | Returns number of first visible line | DFBaseRichEdit
Help | Procedure |  | cRichEdit
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item |
Help_For_Help | Procedure | (Obsolete) | cRichEdit
Help_Index | Procedure | (Obsolete) | cRichEdit
Help_on_topic | Procedure | (Obsolete) | cRichEdit
HideSelection | Procedure | Toggles selection highlighting on or off | DFBaseRichEdit
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | cRichEdit
LastErrorCode | Function | Returns error code for last operation | DFBaseRichEdit
Line | Function | Returns specified line of text | DFBaseRichEdit
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
LineFromChar | Function | Returns number of line that contains specified character position or current line | DFBaseRichEdit
LineLength | Function | Returns number of characters in line | DFBaseRichEdit
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cRichEdit
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cRichEdit
Prompt | Procedure | Cancelled in this class | cDbRichEdit_
Prompt_Description | Function | (Obsolete) |
Prompt_Description | Procedure | (Obsolete) |
Read | Procedure | Reads RTF document and displays it in the control | DFBaseRichEdit
Redo | Procedure | Redoes the last operation | DFBaseRichEdit
RedoType | Function | Returns type of redo operation at top of redo queue | DFBaseRichEdit
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements | DFBaseRichEdit
ReplaceSel | Procedure | Replaces selected text with specified text | DFBaseRichEdit
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | cDbRichEdit_
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true | cDbRichEdit_
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true | cDbRichEdit_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | cDbRichEdit_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | cDbRichEdit_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | cDbRichEdit_
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was | cDbRichEdit_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | cRichEdit
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | cDbRichEdit_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls up or down the control using specified scroll mode | DFBaseRichEdit
ScrollCaret | Procedure | Scrolls caret into view | DFBaseRichEdit
ScrollLines | Procedure | Scrolls control vertically for specified number of lines | DFBaseRichEdit
Select_All | Procedure | Selects entire contents of control | DFBaseRichEdit
SelEnd | Function | Returns end of selection | DFBaseRichEdit
SelStart | Function | Returns beginning of selection | DFBaseRichEdit
SelText | Function | Returns selected text | DFBaseRichEdit
SetSel | Procedure | Selects text in given position range | DFBaseRichEdit
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | cDbRichEdit_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | cDbRichEdit_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | cDbRichEdit_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
TextRange | Function | Returns text in given position range | DFBaseRichEdit
ToggleBold | Procedure | Toggles selected text between bold and normal text | cRichEdit
ToggleItalics | Procedure | Toggles selected text between italicized and normal text | cRichEdit
ToggleUnderline | Procedure | Toggles selected text between underlined and normal text | cRichEdit
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | cRichEdit
Undo | Procedure | Undoes the last operation | DFBaseRichEdit
UndoType | Function | Returns type of undo operation at top of undo queue | DFBaseRichEdit
Validate_Items | Function | Returns whether data in the control is valid |
Validate_Prompt | Function | (Obsolete) |
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | cDbRichEdit_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | cDbRichEdit_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | cDbRichEdit_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | cDbRichEdit_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes RTF stream content of control to file | DFBaseRichEdit
Zoom | Procedure | Cancelled in this class | cDbRichEdit_


cDbRichEditDS_ [Procedure Close_Panel]

Close_Panel - cDbRichEditDS_

Closes the panel or component currently open

Type: Procedure

Parameters: No Parameters

Description

Closes the panel or component currently open. If the control Close_Panel is sent to is not a panel, the call will be delegated to it's parent.

For example, if a cDbRichEdit control is in a dbView, sending Close_Panel to the cDbRichEdit control will close the dbView.

Sample

This sample causes the dbView control oDbView1 to close when button oCloseButton is clicked.

Object oDbView1 is a dbView
    :
    Object oDbRichEdit1 is a cDbRichEdit
        :
    End_Object  // oDbRichEdit1
    :
    Object oCloseButton is a Button
        :
        Procedure OnClick
            send Close_Panel of oDbRichEdit1
        End_Procedure  // OnClick
        :
    End_Object  // oCloseButton
    :
End_Object  // oDbView1

Last Edited: November 24, 2004


cDbRichEditDS_ [Procedure Default_Prompt]

Default_Prompt - cDbRichEditDS_

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cDbRichEditDS_ [Procedure Prompt_Description]

Prompt_Description - cDbRichEditDS_

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Properties for cDbRichEditDS_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | cDbRichEdit_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | cDbRichEdit_
Auto_Save_State | Determines if auto save should be performed | cDbRichEdit_
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | cDbRichEdit_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Changed_State | Determines whether the content of the control has changed | cRichEdit
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | The field number of the target text field | cDbRichEdit_
Data_File | The file number of target memo field | cDbRichEdit_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | cDbRichEdit_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | cDbRichEdit_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | cRichEdit
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | cRichEdit
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object | cRichEdit
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | cRichEdit
Help_Keyword | Used to specify an object's context keyword | cRichEdit
Item_Count | Created for simulation of entry item | cDbRichEdit_
Item_Shadow_State | Determines if an object's item is enabled or disabled | cRichEdit
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | cRichEdit
Label_Col_Offset | The horizontal distance from the object to its label | cRichEdit
Label_Justification_Mode | The justification mode for the text within this object's label | cRichEdit
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | cRichEdit
Label_Row_Offset | The vertical distance from the top edge of the object and its label | cRichEdit
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of lines in control | DFBaseRichEdit
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | cRichEdit
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
paValue | Sets content of control from memory address or places RTF stream in control into memory address | DFBaseRichEdit
pbAutoUrl | Toggles the ability for the control to automatically detect URLs and add hyperlinks | DFBaseRichEdit
pbBold | Toggles selected text between bold and normal text | DFBaseRichEdit
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard | DFBaseRichEdit
pbCanRedo | Determines whether a redo operation can be performed | DFBaseRichEdit
pbCanUndo | Determines whether an undo operation can be performed | DFBaseRichEdit
pbItalics | Toggles selected text between italicized and normal text | DFBaseRichEdit
pbLink | Toggles selected text between hyperlinked and normal text | DFBaseRichEdit
pbProtect | Toggles selected text between protected and normal text | DFBaseRichEdit
pbStrikeOut | Toggles selected text between strikeout and normal text | DFBaseRichEdit
pbSubScript | Toggles selected text between subcripted and normal text | DFBaseRichEdit
pbSuperScript | Toggles selected text between superscripted and normal text | DFBaseRichEdit
pbUnderline | Toggles selected text between underlined and normal text | DFBaseRichEdit
pbWrap | Determines whether text input will break and wrap to the next line at right margin | DFBaseRichEdit
peAlignment | Sets or returns alignment of selected paragraph or paragraphs | DFBaseRichEdit
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peBullets | Sets or returns bullets or numbering of selected paragraph or paragraphs | DFBaseRichEdit
peBulletStyle | Sets or returns numbering styles of selected paragraph or paragraphs | DFBaseRichEdit
peCharSet | Sets or returns character set of selected text | DFBaseRichEdit
peLineSpacingType | Determines type of line spacing of selected paragraph or paragraphs | DFBaseRichEdit
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
pePitchandFamily | Sets or returns the font pitch and family of selected text | DFBaseRichEdit
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piBulletStart | Sets or returns the starting number of paragraph numbering of selected paragraph or paragraphs | DFBaseRichEdit
piBulletTab | Sets or returns the minimum space between a paragraph bullet or number and the paragraph text of selected paragraph or paragraphs | DFBaseRichEdit
piFontSize | Sets or returns font size of selected text | DFBaseRichEdit
piFontWeight | Sets or returns font weight of selected text | DFBaseRichEdit
piLineSpacing | Determines exact line spacing of selected paragraph or paragraphs | DFBaseRichEdit
piMaxChars | Sets or returns maximum number of characters | DFBaseRichEdit
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piOffsetIndent | Sets or returns indentation of 2nd and subsequent lines, relative to first line, of selected paragraph or paragraphs | DFBaseRichEdit
piParagraphIndent | Sets or returns indentation of selected paragraph or paragraphs | DFBaseRichEdit
piRightMargin | Determines indentation of right side of control's text, relative to the right margin | DFBaseRichEdit
piSpacingAfter | Determines the spacing below selected paragraph or paragraphs | DFBaseRichEdit
piSpacingBefore | Determines the spacing above selected paragraph or paragraphs | DFBaseRichEdit
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | cRichEdit
psTypeFace | Sets or returns font typeface of selected text | DFBaseRichEdit
Read_Only_State | Determines whether users may edit the content of the control | DFBaseRichEdit
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | cDbRichEdit_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | cDbRichEdit_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | cRichEdit
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextBackColor | Sets or returns background color of selected text | DFBaseRichEdit
TextColor | Sets or returns color of selected text | DFBaseRichEdit
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | cRichEdit
Value | Sets or returns content of control | DFBaseRichEdit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | cDbRichEdit_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | cDbRichEdit_
verify_exit_msg | Determines what message is sent during an exiting event | cDbRichEdit_
Verify_Save_Msg | Specifies the message to use for save confirmation | cDbRichEdit_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Events for cDbTextEdit

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | cTextEdit
OnChange | Fires whenever the value of the control is changed | cTextEdit
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | cTextEdit
OnMaxText | Fires when maximum text size is exceeded | cTextEdit
OnSelectionChanged | Fires when selection changes | DFBaseTextEdit
OnSetFocus | Sent whenever windows is about to give this object the focus | cTextEdit
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | cTextEdit
Refresh | Displays items from some files at the same time as clearing items from other files | cDbTextEdit_
Shadow_Display | Fired whenever a change in enabled state occurs | cTextEdit


Methods for cDbTextEdit

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | cTextEdit
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
AppendText | Procedure | Appends text to end of text in control | DFBaseTextEdit
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed | cTextEdit
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control | DFBaseTextEdit
Beginning_of_Line | Procedure | Places the cursor at beginning of current line | DFBaseTextEdit
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | cTextEdit
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | cTextEdit
Cancel | Procedure | Returns the message_id of itself | cUIObject
CharCount | Function | Returns the number of characters in the control | DFBaseTextEdit
ClearUndoBuffer | Procedure | Clears undo buffer | DFBaseTextEdit
Close_Panel | Procedure | Closes the panel or component currently open | cDbTextEditDS_
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | cDbTextEditDS_
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Deletes all data in control | DFBaseTextEdit
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | cTextEdit
End_of_Data | Procedure | Places the cursor at end of the text in control | DFBaseTextEdit
End_of_Line | Procedure | Places the cursor at end of current line | DFBaseTextEdit
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | cTextEdit
Error_Help | Procedure | (Obsolete) | cTextEdit
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | cDbTextEdit_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | cTextEdit
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | cTextEdit
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | cDbTextEdit_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | cDbTextEdit_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | cDbTextEdit_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | cDbTextEdit_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | cDbTextEdit_
FindText | Function | Searches for specified text in control | DFBaseTextEdit
FirstCharInLinePos | Function | Returns position of first character in a line | DFBaseTextEdit
FirstVisibleLine | Function | Returns number of first visible line | DFBaseTextEdit
Help | Procedure |  | cTextEdit
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | cDbTextEditDS_
Help_For_Help | Procedure | (Obsolete) | cTextEdit
Help_Index | Procedure | (Obsolete) | cTextEdit
Help_on_topic | Procedure | (Obsolete) | cTextEdit
HideSelection | Procedure | Toggles selection highlighting on or off | DFBaseTextEdit
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | cTextEdit
LastErrorCode | Function | Returns error code for last operation | DFBaseTextEdit
Line | Function | Returns specified line of text | DFBaseTextEdit
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
LineFromChar | Function | Returns number of line that contains specified character position or current line | DFBaseTextEdit
LineLength | Function | Returns number of characters in line | DFBaseTextEdit
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cTextEdit
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cTextEdit
Prompt | Procedure | Cancelled in this class | cDbTextEdit_
Prompt_Description | Function | (Obsolete) | cDbTextEditDS_
Prompt_Description | Procedure | (Obsolete) | cDbTextEditDS_
Read | Procedure | Reads text file and displays it in the control | DFBaseTextEdit
Redo | Procedure | Redoes the last operation | DFBaseTextEdit
RedoType | Function | Returns type of redo operation at top of redo queue | DFBaseTextEdit
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements | DFBaseTextEdit
ReplaceSel | Procedure | Replaces selected text with specified text | DFBaseTextEdit
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | cDbTextEdit_
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true | cDbTextEdit_
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true | cDbTextEdit_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | cDbTextEdit_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | cDbTextEdit_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | cDbTextEdit_
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was | cDbTextEdit_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | cTextEdit
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | cDbTextEdit_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls up or down the control using specified scroll mode | DFBaseTextEdit
ScrollCaret | Procedure | Scrolls caret into view | DFBaseTextEdit
ScrollLines | Procedure | Scrolls control vertically for specified number of lines | DFBaseTextEdit
Select_All | Procedure | Selects entire contents of control | DFBaseTextEdit
SelEnd | Function | Returns end of selection | DFBaseTextEdit
SelStart | Function | Returns beginning position of selection | DFBaseTextEdit
SelText | Function | Returns selected text | DFBaseTextEdit
SetSel | Procedure | Selects text in given position range | DFBaseTextEdit
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | cDbTextEdit_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | cDbTextEdit_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | cDbTextEdit_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
TextRange | Function | Returns text in given position range | DFBaseTextEdit
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | cTextEdit
Undo | Procedure | Undoes the last operation | DFBaseTextEdit
UndoType | Function | Returns type of undo operation at top of undo queue | DFBaseTextEdit
Validate_Items | Function | Checks the number of characters in the control (using CharCount) against the size of the column in the table. | cDbTextEditDS_
Validate_Prompt | Function | (Obsolete) | cDbTextEditDS_
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | cDbTextEdit_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | cDbTextEdit_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | cDbTextEdit_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | cDbTextEdit_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes text file content of control to file | DFBaseTextEdit
Zoom | Procedure | Cancelled in this class | cDbTextEdit_


Properties for cDbTextEdit

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | cDbTextEdit_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | cDbTextEdit_
Auto_Label_State | Determines if the control will draw label values from the DataDictionary instead of the Label property |
Auto_Save_State | Determines if auto save should be performed | cDbTextEdit_
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | cDbTextEdit_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Changed_State | Determines whether the content of the control has changed | cTextEdit
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | The field number of the target text field | cDbTextEdit_
Data_File | The file number of target memo field | cDbTextEdit_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | cDbTextEdit_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | cDbTextEdit_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | cTextEdit
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | cTextEdit
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object | cTextEdit
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | cTextEdit
Help_Keyword | Used to specify an object's context keyword | cTextEdit
Item_Count | Created for simulation of entry item | cDbTextEdit_
Item_Shadow_State | Determines if an object's item is enabled or disabled | cTextEdit
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | cTextEdit
Label_Col_Offset | The horizontal distance from the object to its label | cTextEdit
Label_Justification_Mode | The justification mode for the text within this object's label | cTextEdit
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | cTextEdit
Label_Row_Offset | The vertical distance from the top edge of the object and its label | cTextEdit
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of lines in control | DFBaseTextEdit
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | cTextEdit
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
paValue | Sets content of control from memory address or places text in control into memory address | DFBaseTextEdit
pbBold | Toggles all text in control between bold and normal text | DFBaseTextEdit
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard | DFBaseTextEdit
pbCanRedo | Determines whether a redo operation can be performed | DFBaseTextEdit
pbCanUndo | Determines whether an undo operation can be performed | DFBaseTextEdit
pbItalics | Toggles all text in control between italic and normal text | DFBaseTextEdit
pbWrap | Determines whether text input will break and wrap to the next line at right margin | DFBaseTextEdit
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piFontSize | Sets or returns font size of all text in control | DFBaseTextEdit
piFontWeight | Sets or returns font weight of all text in control | DFBaseTextEdit
piMaxChars | Sets or returns maximum number of visible characters | DFBaseTextEdit
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piRightMargin | Determines indentation of right side of control's text, relative to the right margin | DFBaseTextEdit
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | cTextEdit
psTypeFace | Sets or returns font typeface of all text in control | DFBaseTextEdit
Read_Only_State | Determines whether users may edit the content of the control | DFBaseTextEdit
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | cDbTextEdit_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | cDbTextEdit_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | cTextEdit
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | cTextEdit
Value | Sets or returns content of control | DFBaseTextEdit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | cDbTextEdit_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | cDbTextEdit_
verify_exit_msg | Determines what message is sent during an exiting event | cDbTextEdit_
Verify_Save_Msg | Specifies the message to use for save confirmation | cDbTextEdit_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cDbTextEdit [Property Auto_Label_State]

Auto_Label_State - cDbTextEdit

Determines if the control will draw label values from the DataDictionary instead of the Label property

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If Auto_Label_State is True, the control will draw label values from the DataDictionary Object's short label name for the field of the control, rather than from any Label that may be set in this control.

Sample

This sample turns auto labeling on.

set Auto_Label_State to True

Sample

This sample turns auto labeling off.

set Auto_Label_State to False

Last Edited: January 12, 2006


cDbTextEdit_ [Event Refresh]

Refresh - cDbTextEdit_

Displays items from some files at the same time as clearing items from other files

Type: Event

Parameters: integer notifyMode

Parameter Description
notifyModeThe mode, which signifies the event or operation which generated this refresh message, may be one of the following five:

Constant | Meaning
mode_clear | used only for DEOs attached to the server which was the "origin" of a clear operation, i.e., the DataSet which received the original clear request or message as a result of the user pressing kclear. All other servers send their DEOs the refresh message passing mode_find_or_clear_set.
mode_find_or_clear_set | used for DEOs attached to servers which have found and/or cleared records in response to a user's find-request (kfind, kfind_next, ksuperfind, et al.) or in response to another server's find or clear.
mode_clear_all | used for DEOs attached to any server which participated in a clear_all operation.
mode_delete | used for DEOs attached to any server which performed a successful deletion. DataSets that were merely updated as the result of a deletion use mode_find_or_clear_set.
mode_save | used for DEOs attached to any server involved in a successful save operation.

Description

Refresh displays items from some files at the same time as clearing items from other files. In all cases, refresh will be sent instead of the clear, clear_set, clear_all, display, and entry_display messages in response to a find, clear, clear _all, save, or delete. In some cases, the actions of refresh depend on the (old) messages clear, clear _all, save, and display.

Last Edited: September 11, 2003


Events for cDbTextEdit_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | cTextEdit
OnChange | Fires whenever the value of the control is changed | cTextEdit
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | cTextEdit
OnMaxText | Fires when maximum text size is exceeded | cTextEdit
OnSelectionChanged | Fires when selection changes | DFBaseTextEdit
OnSetFocus | Sent whenever windows is about to give this object the focus | cTextEdit
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | cTextEdit
Refresh | Displays items from some files at the same time as clearing items from other files |
Shadow_Display | Fired whenever a change in enabled state occurs | cTextEdit


cDbTextEdit_ [Function Validate_Items]

Validate_Items - cDbTextEdit_

Returns 0 by default, to indicate that entered text is valid

Type: Function

Return Data Type: Integer

Parameters: Boolean bNotFindReq

Parameter | Description
bNotFindReq | Not used. If false validates all item options; if true validates all item options except findreq.

Return Value

Always returns 0.

Description

Validate_items returns 0 by default, to indicate that entered text is valid. Text fields are always considered valid. Therefore, this function always returns 0. In unusual cases, this maybe overridden to enforce application-specific validations, i.e., size limits, inclusion of key words, etc.

Last Edited: July 11, 2006


cDbTextEdit_ [Function Verify_Data_Loss]

Verify_Data_Loss - cDbTextEdit_

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


cDbTextEdit_ [Function Verify_Delete]

Verify_Delete - cDbTextEdit_

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


cDbTextEdit_ [Function verify_Exit]

verify_Exit - cDbTextEdit_

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


cDbTextEdit_ [Function Verify_Save]

Verify_Save - cDbTextEdit_

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for cDbTextEdit_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | cTextEdit
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
AppendText | Procedure | Appends text to end of text in control | DFBaseTextEdit
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed | cTextEdit
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control | DFBaseTextEdit
Beginning_of_Line | Procedure | Places the cursor at beginning of current line | DFBaseTextEdit
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | cTextEdit
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | cTextEdit
Cancel | Procedure | Returns the message_id of itself | cUIObject
CharCount | Function | Returns the number of characters in the control | DFBaseTextEdit
ClearUndoBuffer | Procedure | Clears undo buffer | DFBaseTextEdit
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Deletes all data in control | DFBaseTextEdit
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | cTextEdit
End_of_Data | Procedure | Places the cursor at end of the text in control | DFBaseTextEdit
End_of_Line | Procedure | Places the cursor at end of current line | DFBaseTextEdit
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | cTextEdit
Error_Help | Procedure | (Obsolete) | cTextEdit
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | cTextEdit
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | cTextEdit
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find |
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find |
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find |
FindText | Function | Searches for specified text in control | DFBaseTextEdit
FirstCharInLinePos | Function | Returns position of first character in a line | DFBaseTextEdit
FirstVisibleLine | Function | Returns number of first visible line | DFBaseTextEdit
Help | Procedure |  | cTextEdit
Help_For_Help | Procedure | (Obsolete) | cTextEdit
Help_Index | Procedure | (Obsolete) | cTextEdit
Help_on_topic | Procedure | (Obsolete) | cTextEdit
HideSelection | Procedure | Toggles selection highlighting on or off | DFBaseTextEdit
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | cTextEdit
LastErrorCode | Function | Returns error code for last operation | DFBaseTextEdit
Line | Function | Returns specified line of text | DFBaseTextEdit
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
LineFromChar | Function | Returns number of line that contains specified character position or current line | DFBaseTextEdit
LineLength | Function | Returns number of characters in line | DFBaseTextEdit
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cTextEdit
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cTextEdit
Prompt | Procedure | Cancelled in this class |
Read | Procedure | Reads text file and displays it in the control | DFBaseTextEdit
Redo | Procedure | Redoes the last operation | DFBaseTextEdit
RedoType | Function | Returns type of redo operation at top of redo queue | DFBaseTextEdit
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements | DFBaseTextEdit
ReplaceSel | Procedure | Replaces selected text with specified text | DFBaseTextEdit
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Delete | Procedure | Deletes the current record of this object's server, if any |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any |
Request_Save | Procedure | Saves changes to the current record of this object's server, if any |
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | cTextEdit
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls up or down the control using specified scroll mode | DFBaseTextEdit
ScrollCaret | Procedure | Scrolls caret into view | DFBaseTextEdit
ScrollLines | Procedure | Scrolls control vertically for specified number of lines | DFBaseTextEdit
Select_All | Procedure | Selects entire contents of control | DFBaseTextEdit
SelEnd | Function | Returns end of selection | DFBaseTextEdit
SelStart | Function | Returns beginning position of selection | DFBaseTextEdit
SelText | Function | Returns selected text | DFBaseTextEdit
SetSel | Procedure | Selects text in given position range | DFBaseTextEdit
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind |
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind |
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind |
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
TextRange | Function | Returns text in given position range | DFBaseTextEdit
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | cTextEdit
Undo | Procedure | Undoes the last operation | DFBaseTextEdit
UndoType | Function | Returns type of undo operation at top of undo queue | DFBaseTextEdit
Validate_Items | Function | Returns 0 by default, to indicate that entered text is valid |
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes text file content of control to file | DFBaseTextEdit
Zoom | Procedure | Cancelled in this class |


cDbTextEdit_ [Procedure Exit_Function]

Exit_Function - cDbTextEdit_

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


cDbTextEdit_ [Procedure Find_First]

Find_First - cDbTextEdit_

Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_first finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of beginning_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbTextEdit_ [Procedure Find_GE]

Find_GE - cDbTextEdit_

Performs a find greater than or equal by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_ge performs a find greater than or equal by the data_file and data_field of the current item, using request_find. Sent by kfind.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbTextEdit_ [Procedure Find_Last]

Find_Last - cDbTextEdit_

Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_last finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of end_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbTextEdit_ [Procedure Find_Next]

Find_Next - cDbTextEdit_

Performs a find greater than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_next performs a find greater than by the data_file and data_field of the current item, using request_find. Sent by kfind_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbTextEdit_ [Procedure Find_Previous]

Find_Previous - cDbTextEdit_

Performs a find less than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_previous performs a find less than by the data_file and data_field of the current item, using request_find. Sent by kfind_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbTextEdit_ [Procedure Prompt]

Prompt - cDbTextEdit_

Cancelled in this class

Type: Procedure

Parameters: No Parameters

Description

The Prompt procedure is cancelled in this class.

Last Edited: September 11, 2003


cDbTextEdit_ [Procedure Request_Cancel]

Request_Cancel - cDbTextEdit_

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


cDbTextEdit_ [Procedure Request_Clear]

Request_Clear - cDbTextEdit_

Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause users to lose changes made to the text, verify_data_loss is used to confirm the action. If this object has a server, clear is requested of the server. This may result in other DEOs clearing in addition to this object. Sent by kclear.

Last Edited: September 11, 2003


cDbTextEdit_ [Procedure Request_Clear_All]

Request_Clear_All - cDbTextEdit_

Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear_all clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause the user to lose changes made to the text, verify_data_loss is used to confirm the action. If this object has a server, clear_all is requested of the server. This may result in other DEOs clearing in addition to this object. Sent by kclear_all.

Last Edited: September 11, 2003


cDbTextEdit_ [Procedure Request_Delete]

Request_Delete - cDbTextEdit_

Deletes the current record of this object's server, if any

Type: Procedure

Parameters: No Parameters

Description

Request_delete deletes the current record of this object's server, if any. If successful and auto_clear_deo_state is true, also clears the text area using request_clear. Verify_delete is used to confirm the action. Sent by kdelete_record. Sends can_delete and acts only if true is returned.

Last Edited: September 11, 2003


cDbTextEdit_ [Procedure Request_Find]

Request_Find - cDbTextEdit_

Finds record using specified mode by requesting item_find from server, if any

Type: Procedure

Parameters: integer mode integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true perform entry update before Find.

Description

Request_find finds record using specified mode by requesting item_find from server, if any. Uses data_file and data_field to determine file and field for find. If this object has no server, no action is taken.

Last Edited: September 11, 2003


cDbTextEdit_ [Procedure Request_Save]

Request_Save - cDbTextEdit_

Saves changes to the current record of this object's server, if any

Type: Procedure

Parameters: No Parameters

Description

Request_save saves changes to the current record of this object's server, if any. If successful and auto_clear_deo_state is true, clears text area using request_clear. Verify_save is used to confirm the action. Sent by ksave_record.

Last Edited: September 11, 2003


cDbTextEdit_ [Procedure Request_Save_No_Clear]

Request_Save_No_Clear - cDbTextEdit_

A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was

Type: Procedure

Parameters: No Parameters

Description

Request_save_no_clear is a version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was.

Last Edited: September 11, 2003


cDbTextEdit_ [Procedure Request_Superfind]

Request_Superfind - cDbTextEdit_

Superfinds record using specified mode by requesting item_superfind from server, if any

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Request_superfind superfinds record using specified mode by requesting item_superfind from server, if any. Uses data_file and data_field to determine file and field for find. If this object has no server, no action is taken. Sent by DEOs. Sends of request_superfind to a DataSet require Predefined Indicator err to be set to false beforehand, in case an error other than Find past end of file or Find prior to beginning of file is generated by the superfind.

Last Edited: September 11, 2003


cDbTextEdit_ [Procedure SuperFind]

SuperFind - cDbTextEdit_

Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbTextEdit_ [Procedure SuperFind_Next]

SuperFind_Next - cDbTextEdit_

Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_next performs a superfind greater than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbTextEdit_ [Procedure SuperFind_Previous]

SuperFind_Previous - cDbTextEdit_

Performs a superfind less than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_previous performs a superfind less than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


cDbTextEdit_ [Procedure Zoom]

Zoom - cDbTextEdit_

Cancelled in this class

Type: Procedure

Parameters: No Parameters

Description

The Zoom procedure is cancelled in this class.

Last Edited: September 15, 2003


Properties for cDbTextEdit_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Save_State | Determines if auto save should be performed |
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Changed_State | Determines whether the content of the control has changed | cTextEdit
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | The field number of the target text field |
Data_File | The file number of target memo field |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | cTextEdit
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | cTextEdit
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object | cTextEdit
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | cTextEdit
Help_Keyword | Used to specify an object's context keyword | cTextEdit
Item_Count | Created for simulation of entry item |
Item_Shadow_State | Determines if an object's item is enabled or disabled | cTextEdit
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | cTextEdit
Label_Col_Offset | The horizontal distance from the object to its label | cTextEdit
Label_Justification_Mode | The justification mode for the text within this object's label | cTextEdit
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | cTextEdit
Label_Row_Offset | The vertical distance from the top edge of the object and its label | cTextEdit
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of lines in control | DFBaseTextEdit
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | cTextEdit
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
paValue | Sets content of control from memory address or places text in control into memory address | DFBaseTextEdit
pbBold | Toggles all text in control between bold and normal text | DFBaseTextEdit
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard | DFBaseTextEdit
pbCanRedo | Determines whether a redo operation can be performed | DFBaseTextEdit
pbCanUndo | Determines whether an undo operation can be performed | DFBaseTextEdit
pbItalics | Toggles all text in control between italic and normal text | DFBaseTextEdit
pbWrap | Determines whether text input will break and wrap to the next line at right margin | DFBaseTextEdit
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piFontSize | Sets or returns font size of all text in control | DFBaseTextEdit
piFontWeight | Sets or returns font weight of all text in control | DFBaseTextEdit
piMaxChars | Sets or returns maximum number of visible characters | DFBaseTextEdit
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piRightMargin | Determines indentation of right side of control's text, relative to the right margin | DFBaseTextEdit
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | cTextEdit
psTypeFace | Sets or returns font typeface of all text in control | DFBaseTextEdit
Read_Only_State | Determines whether users may edit the content of the control | DFBaseTextEdit
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object |
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | cTextEdit
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | cTextEdit
Value | Sets or returns content of control | DFBaseTextEdit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event |
Verify_Save_Msg | Specifies the message to use for save confirmation |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cDbTextEdit_ [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - cDbTextEdit_

If true, this object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


cDbTextEdit_ [Property Auto_Fill_State]

Auto_Fill_State - cDbTextEdit_

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


cDbTextEdit_ [Property Auto_Save_State]

Auto_Save_State - cDbTextEdit_

Determines if auto save should be performed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_save_state property is true, rotation from the last object within this object to the first object within this object will cause this object to save. Intended to be set.

Default is false.

Last Edited: January 12, 2006


cDbTextEdit_ [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - cDbTextEdit_

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


cDbTextEdit_ [Property Data_Field]

Data_Field - cDbTextEdit_

The field number of the target text field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer item# integer newval

Parameter | Description
item# | The item number
newval | The field number

Description

Data_Field determines the field number of target memo field, if any, else 0. Item# will always be 0.

Last Edited: July 31, 2003


cDbTextEdit_ [Property Data_File]

Data_File - cDbTextEdit_

The file number of target memo field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer item# integer newval

Parameter | Description
item# | The item number
newval | The file number

Description

Data_File determines the file number of target memo field, if any, else 0. Item# will always be 0.

Last Edited: August 5, 2003


cDbTextEdit_ [Property Deferred_State]

Deferred_State - cDbTextEdit_

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


cDbTextEdit_ [Property deo_delegate_mode]

deo_delegate_mode - cDbTextEdit_

Controls those requests for which delegate_..._state is set true

Type: Property

Access: Read/Write

Data Type: Integer

Description

Deo_delegate_mode controls those requests for which delegate_..._state is set true. The default delegate_server mode delegates request messages for objects that are not explicitly using a DDO. Delegate_always delegates regardless of whether a server is declared for the object, and delegate_never never delegates. This behavior may be set globally rather than just for this object by setting a function named default_deo_delegate_mode, and may also be queried with get.

Default is delegate_server.

Last Edited: July 31, 2003


cDbTextEdit_ [Property Item_Count]

Item_Count - cDbTextEdit_

Created for simulation of entry item

Type: Property

Access: Read-Only

Data Type: Integer

Description

Item_count returns 1. It is created for simulation of entry item.

Last Edited: August 18, 2003


cDbTextEdit_ [Property Server]

Server - cDbTextEdit_

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


cDbTextEdit_ [Property Should_Save]

Should_Save - cDbTextEdit_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


cDbTextEdit_ [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - cDbTextEdit_

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


cDbTextEdit_ [Property Verify_Delete_Msg]

Verify_Delete_Msg - cDbTextEdit_

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


cDbTextEdit_ [Property verify_exit_msg]

verify_exit_msg - cDbTextEdit_

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


cDbTextEdit_ [Property Verify_Save_Msg]

Verify_Save_Msg - cDbTextEdit_

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


Events for cDbTextEditDS_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | cTextEdit
OnChange | Fires whenever the value of the control is changed | cTextEdit
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | cTextEdit
OnMaxText | Fires when maximum text size is exceeded | cTextEdit
OnSelectionChanged | Fires when selection changes | DFBaseTextEdit
OnSetFocus | Sent whenever windows is about to give this object the focus | cTextEdit
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | cTextEdit
Refresh | Displays items from some files at the same time as clearing items from other files | cDbTextEdit_
Shadow_Display | Fired whenever a change in enabled state occurs | cTextEdit


cDbTextEditDS_ [Function Help_Datafile]

Help_Datafile - cDbTextEditDS_

Returns the filename and fieldname in file.field format that contains help for the current item

Type: Function

Obsolete

Return Data Type: String

Parameters: No Parameters

Return Value

The filename and fieldname in file.field format that contains help for the current item

Description

The Help_datafile function returns the filename and fieldname in file.field format that contains help for the current item.

Last Edited: August 12, 2003


cDbTextEditDS_ [Function Prompt_Description]

Prompt_Description - cDbTextEditDS_

Type: Function

Obsolete

Return Data Type: String

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


cDbTextEditDS_ [Function Validate_Items]

Validate_Items - cDbTextEditDS_

Checks the number of characters in the control (using CharCount) against the size of the column in the table.

Type: Function

Return Data Type: Integer

Parameters: Boolean bNotFindReq

Parameter | Description
bNotFindReq | [ToDo: In Progress]

Return Value

Description

The function checks the number of characters in the control (using CharCount) against the size of the column in the table. The size of a table.column can be queried via the attribute DF_FIELD_LENGTH. This is done inside the function. If the current size exceeds the defined size, error DFERR_TEXT_TOO_LARGE_FOR_FIELD is reported to the operator.

Last Edited: July 11, 2006


cDbTextEditDS_ [Function Validate_Prompt]

Validate_Prompt - cDbTextEditDS_

Type: Function

Obsolete

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for cDbTextEditDS_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | cTextEdit
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
AppendText | Procedure | Appends text to end of text in control | DFBaseTextEdit
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed | cTextEdit
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control | DFBaseTextEdit
Beginning_of_Line | Procedure | Places the cursor at beginning of current line | DFBaseTextEdit
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | cTextEdit
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | cTextEdit
Cancel | Procedure | Returns the message_id of itself | cUIObject
CharCount | Function | Returns the number of characters in the control | DFBaseTextEdit
ClearUndoBuffer | Procedure | Clears undo buffer | DFBaseTextEdit
Close_Panel | Procedure | Closes the panel or component currently open |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) |
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Deletes all data in control | DFBaseTextEdit
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | cTextEdit
End_of_Data | Procedure | Places the cursor at end of the text in control | DFBaseTextEdit
End_of_Line | Procedure | Places the cursor at end of current line | DFBaseTextEdit
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | cTextEdit
Error_Help | Procedure | (Obsolete) | cTextEdit
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | cDbTextEdit_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | cTextEdit
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | cTextEdit
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | cDbTextEdit_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | cDbTextEdit_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | cDbTextEdit_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | cDbTextEdit_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | cDbTextEdit_
FindText | Function | Searches for specified text in control | DFBaseTextEdit
FirstCharInLinePos | Function | Returns position of first character in a line | DFBaseTextEdit
FirstVisibleLine | Function | Returns number of first visible line | DFBaseTextEdit
Help | Procedure |  | cTextEdit
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item |
Help_For_Help | Procedure | (Obsolete) | cTextEdit
Help_Index | Procedure | (Obsolete) | cTextEdit
Help_on_topic | Procedure | (Obsolete) | cTextEdit
HideSelection | Procedure | Toggles selection highlighting on or off | DFBaseTextEdit
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | cTextEdit
LastErrorCode | Function | Returns error code for last operation | DFBaseTextEdit
Line | Function | Returns specified line of text | DFBaseTextEdit
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
LineFromChar | Function | Returns number of line that contains specified character position or current line | DFBaseTextEdit
LineLength | Function | Returns number of characters in line | DFBaseTextEdit
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cTextEdit
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cTextEdit
Prompt | Procedure | Cancelled in this class | cDbTextEdit_
Prompt_Description | Function | (Obsolete) |
Prompt_Description | Procedure | (Obsolete) |
Read | Procedure | Reads text file and displays it in the control | DFBaseTextEdit
Redo | Procedure | Redoes the last operation | DFBaseTextEdit
RedoType | Function | Returns type of redo operation at top of redo queue | DFBaseTextEdit
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements | DFBaseTextEdit
ReplaceSel | Procedure | Replaces selected text with specified text | DFBaseTextEdit
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | cDbTextEdit_
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true | cDbTextEdit_
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true | cDbTextEdit_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | cDbTextEdit_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | cDbTextEdit_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | cDbTextEdit_
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was | cDbTextEdit_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | cTextEdit
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | cDbTextEdit_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls up or down the control using specified scroll mode | DFBaseTextEdit
ScrollCaret | Procedure | Scrolls caret into view | DFBaseTextEdit
ScrollLines | Procedure | Scrolls control vertically for specified number of lines | DFBaseTextEdit
Select_All | Procedure | Selects entire contents of control | DFBaseTextEdit
SelEnd | Function | Returns end of selection | DFBaseTextEdit
SelStart | Function | Returns beginning position of selection | DFBaseTextEdit
SelText | Function | Returns selected text | DFBaseTextEdit
SetSel | Procedure | Selects text in given position range | DFBaseTextEdit
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | cDbTextEdit_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | cDbTextEdit_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | cDbTextEdit_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
TextRange | Function | Returns text in given position range | DFBaseTextEdit
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | cTextEdit
Undo | Procedure | Undoes the last operation | DFBaseTextEdit
UndoType | Function | Returns type of undo operation at top of undo queue | DFBaseTextEdit
Validate_Items | Function | Checks the number of characters in the control (using CharCount) against the size of the column in the table. |
Validate_Prompt | Function | (Obsolete) |
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | cDbTextEdit_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | cDbTextEdit_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | cDbTextEdit_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | cDbTextEdit_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes text file content of control to file | DFBaseTextEdit
Zoom | Procedure | Cancelled in this class | cDbTextEdit_


cDbTextEditDS_ [Procedure Close_Panel]

Close_Panel - cDbTextEditDS_

Closes the panel or component currently open

Type: Procedure

Parameters: No Parameters

Description

Closes the panel or component currently open. If the control Close_Panel is sent to is not a panel, the call will be delegated to it's parent.

For example, if a cDbRichEdit control is in a dbView, sending Close_Panel to the cDbRichEdit control will close the dbView.

Sample

This sample causes the dbView control oDbView1 to close when button oCloseButton is clicked.

Object oDbView1 is a dbView
    :
    Object oDbRichEdit1 is a cDbRichEdit
        :
    End_Object  // oDbRichEdit1
    :
    Object oCloseButton is a Button
        :
        Procedure OnClick
            send Close_Panel of oDbRichEdit1
        End_Procedure  // OnClick
        :
    End_Object  // oCloseButton
    :
End_Object  // oDbView1

Last Edited: November 24, 2004


cDbTextEditDS_ [Procedure Default_Prompt]

Default_Prompt - cDbTextEditDS_

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cDbTextEditDS_ [Procedure Prompt_Description]

Prompt_Description - cDbTextEditDS_

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Properties for cDbTextEditDS_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | cDbTextEdit_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | cDbTextEdit_
Auto_Save_State | Determines if auto save should be performed | cDbTextEdit_
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | cDbTextEdit_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Changed_State | Determines whether the content of the control has changed | cTextEdit
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | The field number of the target text field | cDbTextEdit_
Data_File | The file number of target memo field | cDbTextEdit_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | cDbTextEdit_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | cDbTextEdit_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | cTextEdit
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | cTextEdit
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object | cTextEdit
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | cTextEdit
Help_Keyword | Used to specify an object's context keyword | cTextEdit
Item_Count | Created for simulation of entry item | cDbTextEdit_
Item_Shadow_State | Determines if an object's item is enabled or disabled | cTextEdit
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | cTextEdit
Label_Col_Offset | The horizontal distance from the object to its label | cTextEdit
Label_Justification_Mode | The justification mode for the text within this object's label | cTextEdit
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | cTextEdit
Label_Row_Offset | The vertical distance from the top edge of the object and its label | cTextEdit
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of lines in control | DFBaseTextEdit
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | cTextEdit
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
paValue | Sets content of control from memory address or places text in control into memory address | DFBaseTextEdit
pbBold | Toggles all text in control between bold and normal text | DFBaseTextEdit
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard | DFBaseTextEdit
pbCanRedo | Determines whether a redo operation can be performed | DFBaseTextEdit
pbCanUndo | Determines whether an undo operation can be performed | DFBaseTextEdit
pbItalics | Toggles all text in control between italic and normal text | DFBaseTextEdit
pbWrap | Determines whether text input will break and wrap to the next line at right margin | DFBaseTextEdit
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piFontSize | Sets or returns font size of all text in control | DFBaseTextEdit
piFontWeight | Sets or returns font weight of all text in control | DFBaseTextEdit
piMaxChars | Sets or returns maximum number of visible characters | DFBaseTextEdit
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piRightMargin | Determines indentation of right side of control's text, relative to the right margin | DFBaseTextEdit
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | cTextEdit
psTypeFace | Sets or returns font typeface of all text in control | DFBaseTextEdit
Read_Only_State | Determines whether users may edit the content of the control | DFBaseTextEdit
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | cDbTextEdit_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | cDbTextEdit_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | cTextEdit
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | cTextEdit
Value | Sets or returns content of control | DFBaseTextEdit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | cDbTextEdit_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | cDbTextEdit_
verify_exit_msg | Determines what message is sent during an exiting event | cDbTextEdit_
Verify_Save_Msg | Specifies the message to use for save confirmation | cDbTextEdit_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cDesktop [Event OnSentinelDataChange]

OnSentinelDataChange - cDesktop

Type: Event

Parameters: Integer iStart Integer iLength

Parameter | Description
iStart | [ToDo: In Progress]
iLength | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Events for cDesktop

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnSentinelDataChange |  |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


cDesktop [Function ComActiveObject]

ComActiveObject - cDesktop

Returns Variant containing an IUnknown* to an active COM object matching the passed program ID

Type: Function

Return Data Type: Variant

Parameters: String sProgId

Parameter | Description
sProgId | COM object program ID string

Return Value

Returns a Variant containing an IUnknown* to an active COM object matching the program ID passed in the sProgID parameter.

Description

ComActiveObject returns a Variant containing an IUnknown* to an active COM object matching the program ID passed in the sProgID parameter. The function searches the system running object table (ROT).

You can use this function to test if the ROT has a active object for a given program ID as shown in the following example:

Procedure Test
    String sProgId
    Variant vComObject

    // initialize the Variant to null com Object
    Move (NullComObject()) To vComObject
    Move "{83B0E442-D4EE-11D4-BEDF-BAB7F1EEA455}" To sProgId

    Get ComActiveObject of Desktop sProgId To vComObject

    If (IsNullComObject(vComObject)) ;
        Showln "Program ID Not in ROT"
    Else ;
        Showln "Program ID found in ROT"
End_Procedure  // Test

Note that this is a function of the cDestkop class and therefore of the Desktop object. You can send this message directly to the desktop object (as shown in the above example) or you could just send the message to your current object and allow the message to be resolved via delegation

See Also

psProgID | AttachActiveObject

Last Edited: June 21, 2005


cDesktop [Function ComLoadPicture]

ComLoadPicture - cDesktop

Type: Function

Return Data Type: Variant

Parameters: String sFilename

Parameter | Description
sFilename | The filename of the picture to load

Return Value

Description

The return value of ComLoadPicture is a Variant value containing a Com object.

Last Edited: February 17, 2004


cDesktop [Function CreateSQLmanager]

CreateSQLmanager - cDesktop

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


cDesktop [Function HostData]

HostData - cDesktop

Type: Function

Return Data Type: String

Parameters: Integer iStart Integer iLength

Parameter | Description
iStart | [ToDo: In Progress]
iLength | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


cDesktop [Function Network_User_Name]

Network_User_Name - cDesktop

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


cDesktop [Function SentinelData]

SentinelData - cDesktop

Type: Function

Return Data Type: String

Parameters: Integer iStart Integer iLength

Parameter | Description
iStart | [ToDo: In Progress]
iLength | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for cDesktop

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
ComActiveObject | Function | Returns Variant containing an IUnknown* to an active COM object matching the passed program ID |
ComLoadPicture | Function |  |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateSQLmanager | Function |  |
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure |  |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure |  |
HostData | Function |  |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Network_User_Name | Function |  |
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
SentinelData | Function |  |
SentinelData | Procedure Set |  |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


cDesktop [Procedure Set SentinelData]

SentinelData - cDesktop

Type: Procedure Set

Data Type: Integer

Parameters: string sText integer iStart Integer iLength

Parameter | Description
sText | [ToDo: In Progress]
iStart | [ToDo: In Progress]
iLength | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cDesktop [Procedure Exit_Application]

Exit_Application - cDesktop

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


cDesktop [Procedure Help]

Help - cDesktop

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Properties for cDesktop

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Exit_System_Confirmation |  |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_Window |  |
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Sentinel_Program |  |
Sentinel_Return_Value |  |
Sentinelwindow |  |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Start_Sentinel_Program |  |
Stop_Sentinel_Program |  |
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cDesktop [Property Exit_System_Confirmation]

Exit_System_Confirmation - cDesktop

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Last Edited: February 13, 2003


cDesktop [Property Main_Window]

Main_Window - cDesktop

Type: Property

Access: Read/Write

Data Type: Handle

Description

Last Edited: February 13, 2003


cDesktop [Property Sentinel_Program]

Sentinel_Program - cDesktop

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


cDesktop [Property Sentinel_Return_Value]

Sentinel_Return_Value - cDesktop

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


cDesktop [Property Sentinelwindow]

Sentinelwindow - cDesktop

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


cDesktop [Property Start_Sentinel_Program]

Start_Sentinel_Program - cDesktop

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


cDesktop [Property Stop_Sentinel_Program]

Stop_Sentinel_Program - cDesktop

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


Events for cDFBtrDrvHandler

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cDFBtrDrvHandler [Function CKBuildRevision]

CKBuildRevision - cDFBtrDrvHandler

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


cDFBtrDrvHandler [Function CKMajorRevision]

CKMajorRevision - cDFBtrDrvHandler

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


cDFBtrDrvHandler [Function CKMinorRevision]

CKMinorRevision - cDFBtrDrvHandler

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


cDFBtrDrvHandler [Function CKReleaseRevision]

CKReleaseRevision - cDFBtrDrvHandler

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


cDFBtrDrvHandler [Function CKRevision]

CKRevision - cDFBtrDrvHandler

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


cDFBtrDrvHandler [Function CkUsesUri]

CkUsesUri - cDFBtrDrvHandler

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


cDFBtrDrvHandler [Function ExtractPartFromRevision]

ExtractPartFromRevision - cDFBtrDrvHandler

Type: Function

Return Data Type: Integer

Parameters: Integer iPartNum String sRevision

Parameter | Description
iPartNum | [ToDo: In Progress]
sRevision | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cDFBtrDrvHandler [Function IsMinimalRevision]

IsMinimalRevision - cDFBtrDrvHandler

Type: Function

Return Data Type: Integer

Parameters: Integer iMajor Integer iMinor Integer iRelease Integer iBuild

Parameter | Description
iMajor | [ToDo: In Progress]
iMinor | [ToDo: In Progress]
iRelease | [ToDo: In Progress]
iBuild | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cDFBtrDrvHandler [Function PSQLLocalEngineVersionInfo]

PSQLLocalEngineVersionInfo - cDFBtrDrvHandler

Type: Function

Return Data Type: String

Parameters: Integer iFileNum

Parameter | Description
iFileNum | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cDFBtrDrvHandler [Function PSQLRequesterVersionInfo]

PSQLRequesterVersionInfo - cDFBtrDrvHandler

Type: Function

Return Data Type: String

Parameters: Integer iFileNum

Parameter | Description
iFileNum | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cDFBtrDrvHandler [Function PSQLServerEngineVersionInfo]

PSQLServerEngineVersionInfo - cDFBtrDrvHandler

Type: Function

Return Data Type: String

Parameters: Integer iFileNum

Parameter | Description
iFileNum | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


Methods for cDFBtrDrvHandler

View method list in hierarchical order

Name | Type | Description | Defining Class
CKBuildRevision | Function |  |
CKMajorRevision | Function |  |
CKMinorRevision | Function |  |
CKReleaseRevision | Function |  |
CKRevision | Function |  |
CkUsesUri | Function |  |
Create | Function | Creates an object based on the passed Class Id | cObject
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
ExtractPartFromRevision | Function |  |
IsMinimalRevision | Function |  |
PSQLLocalEngineVersionInfo | Function |  |
PSQLRequesterVersionInfo | Function |  |
PSQLServerEngineVersionInfo | Function |  |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array


Properties for cDFBtrDrvHandler

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psDriverID |  |
Value | Sets and Gets an array element's value | Array


cDFBtrDrvHandler [Property psDriverID]

psDriverID - cDFBtrDrvHandler

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: June 2, 2006


cDistributedBusinessProcess [Event OnAttachProcess]

OnAttachProcess - cDistributedBusinessProcess

When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object

Type: Event

Parameters: No Parameters

Description

When process pooling is used, the OnAttachProcess event is sent to every WBO object and finally to the parent WebApp object. By default it does nothing but it can be used to perform any initialization for the newly attached process.

Last Edited: September 10, 2003


cDistributedBusinessProcess [Event OnDetachProcess]

OnDetachProcess - cDistributedBusinessProcess

When process pooling is used, this event is sent first to the WebApp object and then to every WBO object

Type: Event

Parameters: No Parameters

Description

When process pooling is used, the OnDetachProcess event is sent first to the WebApp object and then to every WBO object. By default it does nothing but it can be used to perform any de-initialization for the process that is being detached. Use this to reset any properties that you do not want shared by all users. It does nothing by default and is for augmentation.

Note that the detach process automatically clears all DDOs in all WBos and clears all open tables (in case there are files that are opened that are not used by DDOs). This is done for security reasons to make sure that the next person attaching to the process does not have access to the records used by the previous user.

Last Edited: December 16, 2004


Events for cDistributedBusinessProcess

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnAttachProcess | When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object |
OnDetachProcess | When process pooling is used, this event is sent first to the WebApp object and then to every WBO object |


cDistributedBusinessProcess [Function ErrorCount]

ErrorCount - cDistributedBusinessProcess

Returns the number of errors in the current error queue

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

ErrorCount returns the number of errors in the current error queue.

During some processes, Errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

Note: This is an abstract interface which does nothing at this level. It is expected that this message will be augmented in subclasses to provide the required functionality.

See Also

ErrorCount

Last Edited: August 5, 2003


cDistributedBusinessProcess [Function MapFileNametoDD]

MapFileNametoDD - cDistributedBusinessProcess

Type: Function

Return Data Type: Integer

Parameters: string sFilename integer bCanUseMain

Parameter | Description
sFilename | [ToDo: In Progress]
bCanUseMain | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cDistributedBusinessProcess [Function MaptoFieldNumber]

MaptoFieldNumber - cDistributedBusinessProcess

Type: Function

Return Data Type: Integer

Parameters: Integer iFile string sFieldName

Parameter | Description
iFile | [ToDo: In Progress]
sFieldName | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cDistributedBusinessProcess [Function MaptoFileNumber]

MaptoFileNumber - cDistributedBusinessProcess

Type: Function

Return Data Type: Integer

Parameters: string sFileName string sFieldName

Parameter | Description
sFileName | [ToDo: In Progress]
sFieldName | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cDistributedBusinessProcess [Function Search_Field_Name]

Search_Field_Name - cDistributedBusinessProcess

Type: Function

Return Data Type: Integer

Parameters: integer iFile string sFieldName

Parameter | Description
iFile | [ToDo: In Progress]
sFieldName | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cDistributedBusinessProcess [Function Search_File_Name]

Search_File_Name - cDistributedBusinessProcess

Type: Function

Return Data Type: Integer

Parameters: string sFileName

Parameter | Description
sFileName | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


Methods for cDistributedBusinessProcess

View method list in hierarchical order

Name | Type | Description | Defining Class
ClearErrors | Procedure | Clears the error queue |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
ErrorCount | Function | Returns the number of errors in the current error queue |
ErrorQueueEnd | Procedure | Ends an error queue process |
ErrorQueueStart | Procedure | Starts an error queue process |
Exit_Application | Procedure | Starts the process of closing an application | cObject
LogEvent | Procedure | Logs an event to the Web Application's event log |
MapFileNametoDD | Function |  |
MaptoFieldNumber | Function |  |
MaptoFileNumber | Function |  |
ReportAllErrors | Procedure | Generates a list of all errors that have occurred since this error queue was last cleared |
ReportErrorItem | Procedure | Displays the error for iItem in the error queue |
ReportLastError | Procedure | Displays the last error in the error queue |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
RequestFileFieldValues | Procedure |  |
RequestFileRecords | Procedure |  |
Search_Field_Name | Function |  |
Search_File_Name | Function |  |


cDistributedBusinessProcess [Procedure ClearErrors]

ClearErrors - cDistributedBusinessProcess

Clears the error queue

Type: Procedure

Parameters: No Parameters

Description

This clears the error queue. During some processes, errors are placed in an error queue. These queued errors are then processed at a later time. After the errors are processed, you may clear the error queue by sending the ClearErrors message. Note that the error queue is also cleared when you send the ErrorQueueStart message.

See Error Handling Messages for more on queued errors.

Note: This is an abstract interface which does nothing at this level. It is expected that this message will be augmented in subclasses to provide the required functionality.

Last Edited: August 18, 2003


cDistributedBusinessProcess [Procedure ErrorQueueEnd]

ErrorQueueEnd - cDistributedBusinessProcess

Ends an error queue process

Type: Procedure

Parameters: No Parameters

Description

ErrorQueueEnd ends an error queue process. The pbQueueErrors property is set to false. This does not clear the existing error queue.

During some processes Errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

Note: This is an abstract interface which does nothing at this level. It is expected that this message will be augmented in subclasses to provide the required functionality.

Last Edited: August 5, 2003


cDistributedBusinessProcess [Procedure ErrorQueueStart]

ErrorQueueStart - cDistributedBusinessProcess

Starts an error queue process

Type: Procedure

Parameters: No Parameters

Description

ErrorQueueStart starts an error queue process. All errors in the error queue are cleared and the pbQueueErrors property is set to true. Once this message is started, all errors will be added to the error queue. All errors in the queue can then be displayed by sending the ReportAllErrors message. Errors will be queued until the ErrorQueueEnd message is sent.

During some processes Errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

Note: This is an abstract interface which does nothing at this level. It is expected that this message will be augmented in subclasses to provide the required functionality.

Last Edited: August 5, 2003


cDistributedBusinessProcess [Procedure LogEvent]

LogEvent - cDistributedBusinessProcess

Logs an event to the Web Application's event log

Type: Procedure

Parameters: Integer iEventType String lpszEvent

Parameter | Description
iEventType | type of event to log
lpszEvent | event name that is being logged

Description

LogEvent logs an event to the Web Application's event log. This is often used to log any type of non-error system activity. Events can be viewed using the DataFlex WebApp Server Administration tool.

You should use this message to log any type of non-error activity to the error log. Errors should be added to the event log using the LogErrorEvent message. This message will generate an error and log the error to the event log. Most unexpected errors (program errors, syntax errors, etc.) are automatically placed in the event log without any special programming on your part.

See Error Handling Messages for more on queued errors.

Note: This is an abstract interface which does nothing at this level. It is expected that this message will be augmented in subclasses to provide the required functionality.

Last Edited: August 18, 2003


cDistributedBusinessProcess [Procedure ReportAllErrors]

ReportAllErrors - cDistributedBusinessProcess

Generates a list of all errors that have occurred since this error queue was last cleared

Type: Procedure

Parameters: string sHdr

Parameter | Description
sHdr | The title of report

Description

ReportAllErrors generates a list of all errors that have occurred since this error queue was last cleared. All errors are output in HTML format and are sent to the current HTML page. If a title parameter is provided it will be displayed.

During some processes, Errors are placed in an error queue. These queued errors are then processed at a later time. ReportAllErrors will report the errors in the queue since it was last cleared. The error queue may be cleared by sending the ClearErrors message. Or, it can be cleared when you send the ErrorQueueStart message.

See Error Handling Messages for more on queued errors.

Note: This is an abstract interface which does nothing at this level. It is expected that this message will be augmented in subclasses to provide the required functionality.

Last Edited: June 23, 2005


cDistributedBusinessProcess [Procedure ReportErrorItem]

ReportErrorItem - cDistributedBusinessProcess

Displays the error for iItem in the error queue

Type: Procedure

Parameters: No Parameters

Description

ReportErrorItem displays the error for iItem in the error queue. The error output is sent to the HTML page. This can be used in conjunction with ErrorCount to display all errors.

See Error Handling Messages for more on queued errors.

Note: This is an abstract interface which does nothing at this level. It is expected that this message will be augmented in subclasses to provide the required functionality.

Last Edited: September 11, 2003


cDistributedBusinessProcess [Procedure ReportLastError]

ReportLastError - cDistributedBusinessProcess

Displays the last error in the error queue

Type: Procedure

Parameters: Integer bClearError

Parameter | Description
bClearError | determines whether to remove the error from the queue

Description

ReportLastError displays the last error in the error queue. The error output is sent to the HTML page. If bClearError is set to true, this error will be removed from the queue.

During some processes, errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

Note: This is an abstract interface which does nothing at this level. It is expected that this message will be augmented in subclasses to provide the required functionality.

Last Edited: September 11, 2003


cDistributedBusinessProcess [Procedure RequestFileFieldValues]

RequestFileFieldValues - cDistributedBusinessProcess

Type: Procedure

Parameters: No Parameters

Description

Last Edited: July 2, 2003


cDistributedBusinessProcess [Procedure RequestFileRecords]

RequestFileRecords - cDistributedBusinessProcess

Type: Procedure

Parameters: No Parameters

Description

Last Edited: August 5, 2003


Properties for cDistributedBusinessProcess

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Main_dd | Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbClearDDOsOnDetach |  |
pbShowEntryError |  |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject


cDistributedBusinessProcess [Property Main_dd]

Main_dd - cDistributedBusinessProcess

Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function

Type: Property

Access: Read/Write

Data Type: Handle

Description

The Main_dd property identifies the DataDictionary object that controls the database file, the data from which is central to this object's function. The main datadictionary must be one of the DataDictionaries contained within the WBO object.

VDF Code

Set Main_dd to oCustomer_DD
:
Get Main_dd to hoDDObjectID

Script Code

<%hDDObjectID= WBO.Call ("get_Main_dd")%>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. Sending the appropriate RegisterInterface message does this.

Send RegisterInterface  get_Main_dd "get_Main_dd" ;
    "sFile iRecord"  "This property retrieves the setting that determines the central DD for the WBO"

Last Edited: March 24, 2004


cDistributedBusinessProcess [Property pbClearDDOsOnDetach]

pbClearDDOsOnDetach - cDistributedBusinessProcess

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: March 24, 2004


cDistributedBusinessProcess [Property pbShowEntryError]

pbShowEntryError - cDistributedBusinessProcess

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 16, 2006


cFTPTransfer [Event OnDirectoryList]

OnDirectoryList - cFTPTransfer

Triggered by the DirectoryList procedure for every file/directory found matching the given search pattern

Type: Event

Parameters: String sFileNamer Integer iFileSize Integer iAttributes

Parameter | Description
sFileNamer | File Name
iFileSize | File Size
iAttributes | File Attributes

Description

The OnDirectoryList event is triggered by the DirectoryList procedure for every file/directory found matching the given search pattern.

Performs nothing by default, intended for augmentation

Last Edited: September 25, 2003


cFTPTransfer [Event OnTransferStatus]

OnTransferStatus - cFTPTransfer

Triggered several times during a file transfer, every time a chunk of BufferSize bytes has been transferred

Type: Event

Parameters: Integer iBytes Integer iFileSize

Parameter | Description
iBytes | Specifies how many bytes currently have been transferred
iFileSize | Specifies the total file size in bytes

Description

The OnTransferStatus event is triggered several times during a file transfer, every time a chunk of BufferSize bytes has been transferred. iBytesTransferred specifies how many bytes currently have been transferred, and iFileSize specifies the total file size in bytes.

Performs nothing by default, intended for augmentation to indicate file transfer status.

Last Edited: September 10, 2003


Events for cFTPTransfer

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnDirectoryList | Triggered by the DirectoryList procedure for every file/directory found matching the given search pattern |
OnTransferStatus | Triggered several times during a file transfer, every time a chunk of BufferSize bytes has been transferred |


cFTPTransfer [Function ChangeDirectory]

ChangeDirectory - cFTPTransfer

Changes the current working directory on RemoteHost to sNewDir

Type: Function

Return Data Type: Integer

Parameters: String sDirectory

Parameter | Description
sDirectory | changes the current working directory on RemoteHost to sNewDir

Return Value

Returns True if successful, False otherwise

Description

ChangeDirectory changes the current working directory on RemoteHost to sNewDir.

Last Edited: August 18, 2003


cFTPTransfer [Function Connect]

Connect - cFTPTransfer

Establishes an FTP connection with RemoteHost

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns True if successful, False otherwise.

Description

The Connect function establishes an FTP connection with RemoteHost.

Last Edited: July 31, 2003


cFTPTransfer [Function CreateFTPdirectory]

CreateFTPdirectory - cFTPTransfer

Creates the directory sNewDir on RemoteHost

Type: Function

Return Data Type: Integer

Parameters: String sDirectory

Parameter | Description
sDirectory | Creates the directory sNewDir on RemoteHost

Return Value

Returns True if successful, and False otherwise.

Description

CreateFtpDirectory creates the directory sNewDir on RemoteHost.

Last Edited: July 31, 2003


cFTPTransfer [Function CurrentDirectory]

CurrentDirectory - cFTPTransfer

Returns the current working directory on RemoteHost

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Returns the current working directory on RemoteHost

Description

CurrentDirectory returns the current working directory on RemoteHost.

Last Edited: July 31, 2003


cFTPTransfer [Function DeleteFTPFile]

DeleteFTPFile - cFTPTransfer

Deletes the file sName on RemoteHost

Type: Function

Return Data Type: Integer

Parameters: String sName

Parameter | Description
sName | The name of the file to be deleted

Return Value

Returns True if successful, and False otherwise.

Description

DeleteFtpFile deletes the file sName on RemoteHost.

Last Edited: July 31, 2003


cFTPTransfer [Function Disconnect]

Disconnect - cFTPTransfer

Disconnects an established FTP connection with RemoteHost

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns True if successful, False otherwise.

Description

The Disconnect function disconnects an established FTP connection with RemoteHost.

Last Edited: July 31, 2003


cFTPTransfer [Function DownloadFile]

DownloadFile - cFTPTransfer

Downloads the file sRemoteFile from RemoteHost and saves it locally as sLocalFile

Type: Function

Return Data Type: Integer

Parameters: String sRemoteFile String sLocalFile

Parameter | Description
sRemoteFile | file downlaoded from RemoteHost
sLocalFile | this is what the downlaoded file is saved as

Return Value

Returns True if successful, False otherwise.

Description

DownloadFile downloads the file sRemoteFile from RemoteHost and saves it locally as sLocalFile.

The file is transferred with BufferSize bytes at the time, and the OnTransferStatus event is triggered after each chunk is transferred.

Last Edited: August 5, 2003


cFTPTransfer [Function FileAttributes]

FileAttributes - cFTPTransfer

Returns the file attributes of the file sFilename on RemoteHost

Type: Function

Return Data Type: Integer

Parameters: String sFileName

Parameter | Description
sFileName | The name of the file attributes to be returned

Return Value

Returns the file attributes of the file on RemoteHost

Description

The FileAttributes function returns the file attributes of the file sFilename on RemoteHost, can be one or more of the following values:

faArchive
faCompressed
faDirectory
faEncrypted
faHidden
faNormal
faOffline
faReadOnly
faReparsePoint
faSparseFile
faSystem
faTemporary

Last Edited: August 18, 2003


cFTPTransfer [Function FileSize]

FileSize - cFTPTransfer

Returns the size of the file sFilename on RemoteHost in bytes

Type: Function

Return Data Type: Integer

Parameters: String sFileName

Parameter | Description
sFileName | The name of the file to be returned in bytes

Return Value

Returns the size of the file sFilename on RemoteHost in bytes

Description

FileSize returns the size of the file sFilename on RemoteHost in bytes.

Last Edited: August 18, 2003


cFTPTransfer [Function FindFirstFTPFile]

FindFirstFTPFile - cFTPTransfer

Type: Function

Return Data Type: String

Parameters: String sName

Parameter | Description
sName | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


cFTPTransfer [Function FindNextFTPFile]

FindNextFTPFile - cFTPTransfer

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


cFTPTransfer [Function FTPFileExist]

FTPFileExist - cFTPTransfer

Returns true if sFile exist on the remote host, and false otherwise

Type: Function

Return Data Type: Boolean

Parameters: String sFile

Parameter | Description
sFile | name of the file

Return Value

Returns true if sFile exist on the remote host, and false otherwise

Description

FtpFileExist returns true if sFile exist on the remote host, and false otherwise.

Last Edited: August 18, 2003


cFTPTransfer [Function RemoveFTPdirectory]

RemoveFTPdirectory - cFTPTransfer

Removes the directory sDirectory on RemoteHost

Type: Function

Return Data Type: Integer

Parameters: String sDirectory

Parameter | Description
sDirectory | The name of the directory to be removed

Return Value

Returns True if successful, and False otherwise.

Description

RemoveFtpDirectory removes the directory sDirectory on RemoteHost.

Last Edited: September 11, 2003


cFTPTransfer [Function RenameFTPFile]

RenameFTPFile - cFTPTransfer

Renames the file sExistingName on RemoteHost to sNewName

Type: Function

Return Data Type: Integer

Parameters: String sExistingName String sNewName

Parameter | Description
sExistingName | The name of the existing file
sNewName | The name of the renamed file

Return Value

Returns True if successful, and False otherwise.

Description

RenameFtpFile renames the file sExistingName on RemoteHost to sNewName.

Last Edited: September 11, 2003


cFTPTransfer [Function UploadFile]

UploadFile - cFTPTransfer

Uploads the file sLocalFile to RemoteHost and stores it using the filename sRemoteFile

Type: Function

Return Data Type: Integer

Parameters: String sLocalFile String sRemoteFile

Parameter | Description
sLocalFile | The name of the uploaded file
sRemoteFile | The name of the stored file

Return Value

Description

UploadFile uploads the file sLocalFile to RemoteHost and stores it using the filename sRemoteFile. Returns True if successful, False otherwise.

The file is transferred with BufferSize bytes at the time, and the OnTransferStatus event is triggered after each chunk is transferred.

Last Edited: September 11, 2003


Methods for cFTPTransfer

View method list in hierarchical order

Name | Type | Description | Defining Class
CancelTransfer | Procedure | Aborts the current file transfer operation |
ChangeDirectory | Function | Changes the current working directory on RemoteHost to sNewDir |
Connect | Function | Establishes an FTP connection with RemoteHost |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateFTPdirectory | Function | Creates the directory sNewDir on RemoteHost |
CurrentDirectory | Function | Returns the current working directory on RemoteHost |
DeleteFTPFile | Function | Deletes the file sName on RemoteHost |
Destroy | Procedure |  | cObject
Directorylist | Procedure | Performs a directory list on the remote host, and triggers the OnDirectoryList event for every file/directory found matching the pattern sPattern |
Disconnect | Function | Disconnects an established FTP connection with RemoteHost |
DownloadFile | Function | Downloads the file sRemoteFile from RemoteHost and saves it locally as sLocalFile |
EndFTPFileFind | Procedure |  |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FileAttributes | Function | Returns the file attributes of the file sFilename on RemoteHost |
FileSize | Function | Returns the size of the file sFilename on RemoteHost in bytes |
FindFirstFTPFile | Function |  |
FindNextFTPFile | Function |  |
FTPFileExist | Function | Returns true if sFile exist on the remote host, and false otherwise |
RemoveFTPdirectory | Function | Removes the directory sDirectory on RemoteHost |
RenameFTPFile | Function | Renames the file sExistingName on RemoteHost to sNewName |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
UploadFile | Function | Uploads the file sLocalFile to RemoteHost and stores it using the filename sRemoteFile |


cFTPTransfer [Procedure CancelTransfer]

CancelTransfer - cFTPTransfer

Aborts the current file transfer operation

Type: Procedure

Parameters: No Parameters

Description

CancelTransfer aborts the current file transfer operation.

Last Edited: July 30, 2003


cFTPTransfer [Procedure Directorylist]

Directorylist - cFTPTransfer

Performs a directory list on the remote host, and triggers the OnDirectoryList event for every file/directory found matching the pattern sPattern

Type: Procedure

Parameters: String sPattern

Parameter | Description
sPattern | file/directory found matching the pattern in the directory list

Description

DirectoryList performs a directory list on the remote host, and triggers the OnDirectoryList event for every file/directory found matching the pattern sPattern. If sPattern is blank, all files/directories are found, e.g. equivalent to perform a directory list using the * wildcard.

Last Edited: July 31, 2003


cFTPTransfer [Procedure EndFTPFileFind]

EndFTPFileFind - cFTPTransfer

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Properties for cFTPTransfer

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Connectionhandle | Returns the HINTERNET handle associated with the current established the connection |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
LastErrorCode | Returns the last error code from the HTTP / FTP Transfer | InetTransfer
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbPassiveMode | Specifies whether to connect to the FTP server RemoteHost using passive mode |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peTransferFlags | Various flags that control how file/data should be transferred | InetTransfer
peTransferType | Specifies whether the file should be transferred as ASCII or Binary |
piBufferSize | Specifies the size of the file transfer buffer | InetTransfer
piRemotePort | Specifies the port to connect to on RemoteHost | InetTransfer
psAgent | Specifies the name of the application | InetTransfer
psPassword | Specifies the password to use to log on | InetTransfer
psProxy | Specifies the name of the Proxy server used, if any | InetTransfer
psRemoteHost | Specifies the hostname or the IP address of the remote server | InetTransfer
psUserName | Specifies the name of the user to log on | InetTransfer
RootHandle | Returns the root HINTERNET handle used for the session | InetTransfer


cFTPTransfer [Property Connectionhandle]

Connectionhandle - cFTPTransfer

Returns the HINTERNET handle associated with the current established the connection

Type: Property

Access: Read-Only

Data Type: Handle

Description

ConnectionHandle returns the HINTERNET handle associated with the current established the connection. You will not normally need to use this property, but it is provided so that you can access the low-level Windows API, if you need to.

Last Edited: July 31, 2003


cFTPTransfer [Property pbPassiveMode]

pbPassiveMode - cFTPTransfer

Specifies whether to connect to the FTP server RemoteHost using passive mode

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbPassiveMode specifies whether to connect to the FTP server RemoteHost using passive mode. Passive mode is sometimes needed if you are behind a firewall.

Default is false.

Last Edited: January 16, 2006


cFTPTransfer [Property peTransferType]

peTransferType - cFTPTransfer

Specifies whether the file should be transferred as ASCII or Binary

Type: Property

Access: Read/Write

Data Type: Integer

Description

peTransferType specifies whether the file should be transferred as ASCII or Binary. Can be either ttAscii or ttBinary.

Default is ttBinary.

Last Edited: September 11, 2003


CheckBox [Event OnBeginningOfPanel]

OnBeginningOfPanel - CheckBox

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


CheckBox [Event OnChange]

OnChange - CheckBox

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


CheckBox [Event OnKillFocus]

OnKillFocus - CheckBox

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


CheckBox [Event OnSetFocus]

OnSetFocus - CheckBox

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


CheckBox [Event Prompt_Callback]

Prompt_Callback - CheckBox

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


CheckBox [Event Shadow_Display]

Shadow_Display - CheckBox

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for CheckBox

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange |  |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |


CheckBox [Function Next_Object_Id]

Next_Object_Id - CheckBox

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


CheckBox [Function Prior_Object_Id]

Prior_Object_Id - CheckBox

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for CheckBox

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


CheckBox [Procedure Activate_Area]

Activate_Area - CheckBox

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


CheckBox [Procedure Beginning_of_Panel]

Beginning_of_Panel - CheckBox

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


CheckBox [Procedure Bottom_of_Panel]

Bottom_of_Panel - CheckBox

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


CheckBox [Procedure DoHtmlHelp]

DoHtmlHelp - CheckBox

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


CheckBox [Procedure End_of_Panel]

End_of_Panel - CheckBox

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


CheckBox [Procedure Error_Help]

Error_Help - CheckBox

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


CheckBox [Procedure Extended_Help]

Extended_Help - CheckBox

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


CheckBox [Procedure File_Help]

File_Help - CheckBox

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


CheckBox [Procedure Help]

Help - CheckBox

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


CheckBox [Procedure Help_For_Help]

Help_For_Help - CheckBox

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


CheckBox [Procedure Help_Index]

Help_Index - CheckBox

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


CheckBox [Procedure Help_on_topic]

Help_on_topic - CheckBox

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


CheckBox [Procedure Keys_Help]

Keys_Help - CheckBox

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


CheckBox [Procedure Request_Status_Help]

Request_Status_Help - CheckBox

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


CheckBox [Procedure Top_of_Panel]

Top_of_Panel - CheckBox

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for CheckBox

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
AlignmentMode | Determines if the Label property will be displayed on the left or right of the checkbox icon |
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Size_State | Determines if object will be resized to the length of the label text |
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object |
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Checked_State | Reflects whether this object is checked |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label |  |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


CheckBox [Property AlignmentMode]

AlignmentMode - CheckBox

Determines if the Label property will be displayed on the left or right of the checkbox icon

Type: Property

Access: Read/Write

Data Type: Integer

Description

AlignmentMode determines if the text of the Label property will be displayed on the left or right of the checkbox icon.

Constant | Meaning
taRightJustify | Displays the text to the right of the checkbox
taLeftJustify | Displays the text to the left of the checkbox

Default is taRightJustify.

Last Edited: July 30, 2003


CheckBox [Property Auto_Size_State]

Auto_Size_State - CheckBox

Determines if object will be resized to the length of the label text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If this property is set true, this object will size itself according to the length of the label text.

When set false, it will not.

See Also

CheckBox | Radio

Last Edited: January 12, 2006


CheckBox [Property Bitmap]

Bitmap - CheckBox

Displays a bitmap in an object

Type: Property

Access: Read/Write

Data Type: String

Description

The Bitmap message will display a bitmap in an object. In other words, the bitmap becomes the background of the object.
Bitmap_Style determines how and where the bitmap will display in the object.

There are two potential drawbacks to using bitmaps: the amount of storage (on disk) , and the constant memory consumption.

Sample

This sample sets the bitmap to "MyBitmap.bmp".

set Bitmap to "MyBitmap.bmp"

Note:
In order to make a cohesive application, Visual DataFlex must find the .EXE file and the .bmp (bitmap) file, by using DFPATH.

Last Edited: November 24, 2004


CheckBox [Property Checked_State]

Checked_State - CheckBox

Reflects whether this object is checked

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Checked_State property reflects whether this object is checked. You may set and get this property.

See Also

CheckBox | Radio

Last Edited: January 12, 2006


CheckBox [Property Enabled_State]

Enabled_State - CheckBox

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


CheckBox [Property Explicit_Shadow_State]

Explicit_Shadow_State - CheckBox

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


CheckBox [Property Help_id]

Help_id - CheckBox

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


CheckBox [Property Help_Keyword]

Help_Keyword - CheckBox

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


CheckBox [Property Item_Shadow_State]

Item_Shadow_State - CheckBox

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


CheckBox [Property Label]

Label - CheckBox

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


CheckBox [Property Object_Shadow_State]

Object_Shadow_State - CheckBox

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


CheckBox [Property psHtmlHelpTopic]

psHtmlHelpTopic - CheckBox

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


CheckBox [Property Status_Help]

Status_Help - CheckBox

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


CheckBox [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - CheckBox

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


Events for cHtmlHelp

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for cHtmlHelp

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoDisplayIndex | Procedure | Selects the Index tab of the helpfile |
DoDisplayIndexString | Procedure | Selects a keyword in the Index |
DoDisplayKeyword | Procedure | Selects a keyword in the Index and displays the related Topic |
DoDisplayTOC | Procedure | Displays the Table of Contents |
DoDisplayTopic | Procedure | Displays a Topic |
DoShowMapId | Procedure | Displays a Topic based upon its Map-ID |
DoSyncToc | Procedure | Synchronizes the Table of Contents |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cHtmlHelp [Procedure DoDisplayIndex]

DoDisplayIndex - cHtmlHelp

Selects the Index tab of the helpfile

Type: Procedure

Parameters: No Parameters

Description

The DoDisplayIndex procedure opens the helpfile and displays the Index tab of the helpfile.

Note: Before sending this method, you must set the psHelpFile property to the name of the helpfile.

Last Edited: August 18, 2003


cHtmlHelp [Procedure DoDisplayIndexString]

DoDisplayIndexString - cHtmlHelp

Selects a keyword in the Index

Type: Procedure

Parameters: String sIndex

Parameter | Description
sIndex | The keyword in the index to select

Description

The DoDisplayIndexString procedure opens the helpfile, selects the Index tab and highlights the keyword in the list.

If you wish to display the topic related to the keyword, use the DoDisplayKeyword procedure instead.

Note: Before sending this method, you must set the psHelpFile property to the name of the helpfile.

Last Edited: August 18, 2003


cHtmlHelp [Procedure DoDisplayKeyword]

DoDisplayKeyword - cHtmlHelp

Selects a keyword in the Index and displays the related Topic

Type: Procedure

Parameters: String sKeyword

Parameter | Description
sKeyword | The keyword in the index to select

Description

The DoDisplayKeyword procedure opens the helpfile, selects the Index tab, highlights the keyword in the list and displays the related Topic.

If you wish to only select a keyword in the Index without displaying the topic, use the DoDisplayIndexString procedure instead.

Note: Before sending this method, you must set the psHelpFile property to the name of the helpfile.

Last Edited: August 18, 2003


cHtmlHelp [Procedure DoDisplayTOC]

DoDisplayTOC - cHtmlHelp

Displays the Table of Contents

Type: Procedure

Parameters: No Parameters

Description

The DoDisplayTOC procedure opens the helpfile and displays the Table of Contents (TOC) tab.

Note: Before sending this method, you must set the psHelpFile property to the name of the helpfile.

Last Edited: August 18, 2003


cHtmlHelp [Procedure DoDisplayTopic]

DoDisplayTopic - cHtmlHelp

Displays a Topic

Type: Procedure

Parameters: String sTopic

Parameter | Description
sTopic | The filename, including extension, of the topic to display

Description

The DoDisplayTopic procedure opens the helpfile and displays a topic.

To synchronize and display the Table of Contents, send the DoDisplayTOC afterwards, as in this example:

Object oMyHelp is a cHtmlHelp
   Set psHelpFile To "c:\MyApp\Help\Help.chm"
   Send DoDisplayTopic "New_Accounts.htm"
   Send DoDisplayTOC
End_Object

Note: Before sending this method, you must set the psHelpFile property to the name of the helpfile.

Last Edited: August 18, 2003


cHtmlHelp [Procedure DoShowMapId]

DoShowMapId - cHtmlHelp

Displays a Topic based upon its Map-ID

Type: Procedure

Parameters: Integer iMapID

Parameter | Description
iMapID | The MAP-ID constant representing the topic to display

Description

The DoShowMapId procedure opens the helpfile and displays a Topic based upon its MAP-ID.

A MAP-ID is typically generated in legacy WinHelp help systems. When those systems are converted to HTML, this procedure permits you to still reference the topics in a similar fashion.

Note: Before sending this method, you must set the psHelpFile property to the name of the helpfile.

Last Edited: August 18, 2003


cHtmlHelp [Procedure DoSyncToc]

DoSyncToc - cHtmlHelp

Synchronizes the Table of Contents

Type: Procedure

Parameters: No Parameters

Description

The DoSyncTOC procedure synchronizes the Table of Contents (TOC) with the current Topic being displayed. It will not switch to the TOC tab, if it is not selected. To display the TOC tab, use the DoDisplayTOC procedure.

The HTML help system supports a feature which automatically synchronizes the TOC with Topics. If the help system was compiled with this feature enabled, you will not need to use this method.

Note: Before sending this method, you must set the psHelpFile property to the name of the helpfile.

Last Edited: August 18, 2003


Properties for cHtmlHelp

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbAlwaysOnTop | Determines whether the help file is always on top of the application |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phoOwner | Owner of the Help file |
psHelpFile | Name of the compiled HTML (CHM) helpfile to display |


cHtmlHelp [Property pbAlwaysOnTop]

pbAlwaysOnTop - cHtmlHelp

Determines whether the help file is always on top of the application

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Determines whether the help file is always on top of the application

Last Edited: September 8, 2005


cHtmlHelp [Property phoOwner]

phoOwner - cHtmlHelp

Owner of the Help file

Type: Property

Access: Read/Write

Data Type: Handle

Description

The phoOwner property contains the object-handle of your program's main window. This property needs to be set so that the HTML help window will know which program owns it (when that program closes, the helpfile will be automatically closed, too).

Note:Typically, you do not set this property explicitly, as it will try to set itself automatically by querying the main window of the application object.

Last Edited: August 6, 2004


cHtmlHelp [Property psHelpFile]

psHelpFile - cHtmlHelp

Name of the compiled HTML (CHM) helpfile to display

Type: Property

Access: Read/Write

Data Type: String

Description

You should set the psHelpFile property to the fully-qualified filename of the Compiled HTML (CHM) help file that you want your program to display.

Note: You will normally never set this property in this object. If you do not set this property explicitly, the class will use the helpfile designated in the application object's psHelpFile property. Using the cApplication object is the preferred technique.

Last Edited: September 8, 2005


Events for cHtmlReport

View event list in hierarchical order

Name | Description | Defining Class
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property | cReport
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Error_Report | Sent whenever an error is generated | cBasicReport
Final_Formfeed |  | cReport
OnBody | Called every time a valid record has been found | cReport
OnConstrain |  | cReport
OnEndingMainReport | User Handler Intended for override | cBasicReport
OnEndingReport | Called at the end of all reports | cReport
onError | Provided as a hook to handle custom error reporting | cBasicReport
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables | cReport
OnPageFooter | Printed after OnPageTotal on every page except the last page | cReport
OnPageHeader | Called after OnPageTop on every new page except the first | cReport
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader. | cReport
OnPageTop | Called when printing the top of every report | cReport
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page | cReport
OnReportFooter | Printed after OnPageTotal on the last page of the report | cReport
OnReportHeader | Called only on the first page of the report, after OnPageTop | cReport
OnSelection | Validates a record | cReport
OnStartingMainReport | Called when a report is started | cBasicReport
OnStartingReport | Called when a report is started | cReport
OnSubHeader1..n | Called each time a subheader needs to be printed | cReport
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program | cReport
OnSubTotal1..n | Called when a subtotal needs to be processed | cReport
OnTotal | Called at the end of a report after all final sub-totals have been printed | cReport
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found | cReport
Report_Interrupt | Called when the status panel's Cancel button has been pressed | cBasicReport


cHtmlReport [Function HtmlAnchor]

HtmlAnchor - cHtmlReport

Adds an Html Anchor

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlAnchor adds an Html Anchor. It is equivalent to:

<a>sData</a>

VDF Code

String sData sVar
Get HtmlAnchor sData to sVar
Send WriteHtml (HtmlAnchor(Self,sData))

Script Code

<a>sData</a>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlBig]

HtmlBig - cHtmlReport

Makes the string big

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlBig makes the string big. The HTML equivalent of:

<big>sData</big>

VDF Code

String sData sVar
Get HtmlBig sData to sVar
Send WriteHtml (HtmlBig(Self,sData))

Script Code

<big>sData</big>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlBlink]

HtmlBlink - cHtmlReport

Makes the string blink

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlBlink makes the string blink. The HTML equivalent of:

<blink>sData</blink>

VDF Code

String sData sVar
Get HtmlBlink sData to sVar
Send WriteHtml (HtmlBlink(Self,sData))

Script Code

<blink>sData</blink>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlBold]

HtmlBold - cHtmlReport

Makes the string bold

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlBold makes the string bold. The HTML equivalent of:

<b>sData</b>

VDF Code

String sData sVar
Get HtmlBold sData to sVar
Send WriteHtml (HtmlBold(Self,sData))

Script Code

<b>sData</b>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlEmph]

HtmlEmph - cHtmlReport

Makes the string emphasized

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlEmph makes the string emphasized. The HTML equivalent of:

<em>sData</em>

VDF Code

String sData sVar
Get HtmlEmph sData to sVar
Send WriteHtml (HtmlEmph(Self,sData))

Script Code

<em>sData</em>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlFixed]

HtmlFixed - cHtmlReport

Makes the string fixed width

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlFixed makes the string fixed width. The HTML equivalent of:

<tt>sData</tt>

VDF Code

String sData sVar
Get HtmlFixed sData to sVar
Send WriteHtml (HtmlFixed(Self,sData))

Script Code

<tt>sData</tt>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlFontcolor]

HtmlFontcolor - cHtmlReport

Sets the strings font color

Type: Function

Return Data Type: String

Parameters: string sFontClr

Parameter | Description
sFontClr | font color to use

Return Value

Returns formatted Html string

Description

HtmlFontColor sets the strings font color. The HTML equivalent of:

<font color=sColor>

VDF Code

String sColor sVar
Get HtmlFontColor sColor to sVar
Send WriteHtml (HtmlFontColor(Self,sColor))

Script Code

<font color=<I>sColor>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlFontsize]

HtmlFontsize - cHtmlReport

Sets the font size

Type: Function

Return Data Type: String

Parameters: integer iSize

Parameter | Description
iSize | font size to use

Return Value

Returns formatted Html string

Description

HtmlFontSize sets the font size. The HTML equivalent of:

<font size=iSize>

VDF Code

Integer iSizeString sVar
Get HtmlFontSize iSize to sVar
Send WriteHtml (HtmlFontSize(Self,iSize))

Script Code

<font size=iSize>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlHeader]

HtmlHeader - cHtmlReport

Creates a header string of level iHeader

Type: Function

Return Data Type: String

Parameters: integer iHeader string sDat

Parameter | Description
iHeader | number or level of header to create
sDat | data to place in header

Return Value

Returns formatted Html string

Description

HtmlHeader creates a header string of level iHeader. The HTML equivalent of:

<hn>sData</hn>

where n is the header number passed as iHeaderNum.

VDF Code

Integer iHeaderNum
String sData sVar
Get HtmlHeader iHeaderNum sData to sVar
Send WriteHtml (HtmlHeader(Self,iHeaderNum,sData))

Script Code

<h1>sData</h1>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlItalics]

HtmlItalics - cHtmlReport

Makes the string italics

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlItalics makes the string italics. The HTML equivalent of:

<i>sData</i>

VDF Code

String sData sVar
Get HtmlItalics sData to sVar
Send WriteHtml (HtmlItalics(Self,sData))

Script Code

<i>sData</i>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlLink]

HtmlLink - cHtmlReport

Adds a hyperlink to a string

Type: Function

Return Data Type: String

Parameters: string sURL string sDat

Parameter | Description
sURL | URL for link
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlLink adds a hyperlink (sURL) to a string (sDat). The HTML equivalent of:

<a href=sURL>sData</a>

VDF Code

String sData sVar
Get HtmlLink sURL sData to sVar
Send WriteHtml (HtmlLink(Self,sURL,sData))

Script Code

<a href=sURL>sData</a>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlSmall]

HtmlSmall - cHtmlReport

Makes the string small

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlSmall makes the string small. The HTML equivalent of:

<small>sData</small>

VDF Code

String sData sVar
Get HtmlSmall sData to sVar
Send WriteHtml (HtmlSmall(Self,sData))

Script Code

<small>sData</small>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlStrike]

HtmlStrike - cHtmlReport

Overstrikes through the string

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlStrike overstrikes through the string. The HTML equivalent of:

<strike>sData</strike>

VDF Code

String sData sVar
Get HtmlStrike sData to sVar
Send WriteHtml (HtmlStrike(Self,sData))

Script Code

<strike>sDat</strike>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlStrong]

HtmlStrong - cHtmlReport

Adds strong emphasis to the string

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlStrong adds strong emphasis (usually appears as bold) to the string. The HTML equivalent of:

<strong>sData</strong>

VDF Code

String sData sVar
Get HtmlStrong sData to sVar
Send WriteHtml (HtmlStrong(Self,sData))

Script Code

<strong>sData</strong>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlSub]

HtmlSub - cHtmlReport

Makes the string subscript

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlSub makes the string subscript. The HTML equivalent of:

<sub>sData</sub>

VDF Code

String sData sVar
Get HtmlSub sData to sVar
Send WriteHtml (HtmlSub(Self,sData))

Script Code

<sub>sData</sub>

Last Edited: August 18, 2003


cHtmlReport [Function HtmlSup]

HtmlSup - cHtmlReport

Makes the string superscript

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlSup makes the string superscript. The HTML equivalent of:

<sup>sData</sup>

VDF Code

String sData sVar
Get HtmlSup sData to sVar
Send WriteHtml (HtmlSup(Self,sData))

Script Code

<sup>sData</sup>

Last Edited: August 18, 2003


cHtmlReport [Function SubTotal]

SubTotal - cHtmlReport

Returns the appropriate subtotal and clears the subtotal accumulator

Type: Function

Return Data Type: Number

Parameters: Integer iTotal

Parameter | Description
iTotal | the subtotal accumulator level

Return Value

Returns the appropriate subtotal and clears the subtotal accumulator

Description

SubTotal returns the appropriate subtotal and clears the subtotal accumulator. If you do not wish to clear the subtotal use the SumSubTotal function.

Report objects contain sub-total accumulators. These are used to keep track of running totals within a report. Typically, a sub-total is accumulated within the body of a report. During a break the sub-total the subtotal may be printed. Usually when the total is printed, its total is cleared. Sometimes, before clearing the total, this sub-total will be added to yet another accumulated total (perhaps the total of all sub-totals).

You must keep track of which accumulator level is assigned to which total. Each accumulator is assigned a level. You may define an unlimited number of accumulation totals.

The SubTotal message returns the total value for the passed accumulation level and clears that accumulator level. Typically, when you display a sub-total in a sub-total section, you want to display that total and then zero the counter so that it may be used for the records in the next break level.

The example below will get the amount in the 2nd running subtotal accumulator and add it to nAmt. It will then clear the running total in the 2nd accumulator.

Get SubTotal 2 to nAmt

The message will often be used within a sub-total section.

Procedure OnSubTotal1
    Number nTotal
    Send WriteHtmlCell "Running Total" 'colspan="4" bgColor="Silver"'
    Get SubTotal 1 to nTotal
     Send WriteHtmlCell (FormatNumber(nTotal,2)) 'bgColor="Silver" align="right" '
     Send WriteHtmlCell "" 'colspan="2" bgColor="Silver"'
     Send WriteHtmlTableEnd
End_Procedure // OnSubTotal1

See Also

ClearSubTotal | ClearAllSubTotals | AddSubTotal | SumSubTotal

Last Edited: September 11, 2003


cHtmlReport [Function SumSubTotal]

SumSubTotal - cHtmlReport

Returns the appropriate subtotal but does not clear the subtotal accumulator

Type: Function

Return Data Type: Number

Parameters: Integer iTotal

Parameter | Description
iTotal | number of subtotal to return

Return Value

Returns the appropriate subtotal but does not clear the subtotal accumulator

Description

SumSubTotal returns the appropriate subtotal but does not clear the subtotal accumulator. If you wish to clear the subtotal use the SubTotal function.

Report objects contain subtotal accumulators. These are used to keep track of running totals within a report. Typically, a sub-total is accumulated within the body of a report. During a break the sub-total the subtotal may be printed. Usually when the total is printed, its total is cleared. Sometimes, before clearing the total, this sub-total will be added to yet another accumulated total (perhaps the total of all sub-totals).

You must keep track of which accumulator level is assigned to which total. Each accumulator is assigned a level. You may define an unlimited number of accumulation totals.

The SumSubTotal message returns the total value for the passed accumulation level.

The example below will get the amount in the 2nd running subtotal accumulator and add it to nAmt.

Get SumSubTotal 2 to nAmt

This function does not zero the current accumulator total. Often you will want to clear this total. The SubTotal function should be used for this purpose.

The message will often be used within a sub-total section.

Procedure OnSubTotal1
     Number nTotal
    Send WriteHtmlCell "Running Total" 'colspan="4" bgColor="Silver"'
    Get SumSubTotal 1 to nTotal
     Send WriteHtmlCell (FormatNumber(nTotal,2)) 'bgColor="Silver" align="right" '
     Send WriteHtmlCell "" 'colspan="2" bgColor="Silver"'
     Send WriteHtmlTableEnd
End_Procedure // OnSubTotal1

See Also

ClearSubTotal | ClearAllSubTotals | AddSubTotal | SubTotal

Last Edited: September 11, 2003


Methods for cHtmlReport

View method list in hierarchical order

Name | Type | Description | Defining Class
AddSubTotal | Procedure | Adds the passed value to the total maintained in level iCount |
ClearAllSubTotals | Procedure | Clears all the SubTotal accumulators |
ClearSubTotal | Procedure | Clears a single Subtotal accumulator |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoRunReport | Function | The main entry point for reportsT | cReport
End_Log | Procedure | Sends an end-log message to the log object | cBasicReport
Error_Log_Status | Procedure | Called by error_report if status_log_state is true | cBasicReport
Exit_Application | Procedure | Starts the process of closing an application | cObject
Formfeed | Procedure | Handles formfeeds | cReport
HtmlAnchor | Function | Adds an Html Anchor |
HtmlBig | Function | Makes the string big |
HtmlBlink | Function | Makes the string blink |
HtmlBold | Function | Makes the string bold |
HtmlEmph | Function | Makes the string emphasized |
HtmlFixed | Function | Makes the string fixed width |
HtmlFontcolor | Function | Sets the strings font color |
HtmlFontsize | Function | Sets the font size |
HtmlHeader | Function | Creates a header string of level iHeader |
HtmlItalics | Function | Makes the string italics |
HtmlLink | Function | Adds a hyperlink to a string |
HtmlSmall | Function | Makes the string small |
HtmlStrike | Function | Overstrikes through the string |
HtmlStrong | Function | Adds strong emphasis to the string |
HtmlSub | Function | Makes the string subscript |
HtmlSup | Function | Makes the string superscript |
Log_Status | Procedure | Sends passed message to the log object | cBasicReport
Output_ImageNum | Procedure | Outputs the image represented by ImageNum | cReport
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO | cReportDS
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Save | Procedure | If sent, this saves the current record | cReportDS
Start_Log | Procedure | Sends a start-log message to the log object | cBasicReport
SubTotal | Function | Returns the appropriate subtotal and clears the subtotal accumulator |
SumSubTotal | Function | Returns the appropriate subtotal but does not clear the subtotal accumulator |
Update_Status | Procedure | Send this message to update the action area of the status panel | cBasicReport
WriteHtml | Procedure | Outputs the passed string to the web page and ends the line |
WriteHtmlBreak | Procedure | Outputs the passed string and ends the line |
WriteHtmlCell | Procedure | Outputs a table cell containing sData |
WriteHtmlCellHeader | Procedure | Outputs a table header cell containing sData |
WriteHtmlHorzLine | Procedure | Outputs a horizontal line to the HTML file |
WriteHtmlRowBegin | Procedure | Outputs a "begin" row HTML string |
WriteHtmlRowEnd | Procedure | Outputs an end row html string |
WriteHtmlTableBegin | Procedure | Outputs a "begin" table html string |
WriteHtmlTableEnd | Procedure | Outputs an end table html string |
WriteLn | Procedure | Outputs the string and ends the Line |
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data | cReport


cHtmlReport [Procedure AddSubTotal]

AddSubTotal - cHtmlReport

Adds the passed value to the total maintained in level iCount

Type: Procedure

Parameters: Integer iCounter Number nData

Parameter | Description
iCounter | number of subtotal to add
nData | data to subtotal (can be a variable or a table.field)

Description

Report objects contain sub-total accumulators. These are used to keep track of running totals within a report. Typically a sub-total is accumulated within the body of a report. During a break the sub-total the subtotal may be printed. Usually when the total is printed its total is cleared. Sometimes, before clearing the total, this sub-total will be added to yet another accumulated total (perhaps the total of all sub-totals).

You must keep track of which accumulator level is assigned to which total. Each accumulator is assigned a level. You may define an unlimited number of accumulation totals.

The AddSubTotal message adds the passed value (nData) to the total maintained in level iCounter.

The example below will add the amount of nExtAmt to the 2nd running subtotal accumulator.

Send AddSubTotal 2 nExtAmt

Most typically, you will see this message used within an OnBody event.

Procedure OnBody
     String sText
    Send WriteHtmlRowBegin
        Send WriteHtmlCell (FormatNumber(Orderhea.Order_Number,0)) 'Align="right"'
        Send WriteHtmlCell (FormatNumber(Customer.Customer_Number,0)) 'Align="right"'
        Send WriteHtmlCell (HtmlEncode(Orderhea.Order_Date)) 'Align="left"'
        Send WriteHtmlCell (HtmlEncode(Orderhea.Terms)) 'Align="left"'
        Send WriteHtmlCell (FormatNumber(Orderhea.Order_Total,2)) 'Align="right"'
        Send WriteHtmlCell (HtmlEncode(Salesp.Id)) 'Align="left"'
        Send WriteHtmlCell (HtmlEncode(Orderhea.Ordered_By)) 'Align="left"'
    Send WriteHtmlRowEnd
    Send AddSubTotal 1 Orderhea.Order_Total //  Subtotal of field
End_Procedure // OnBody

The message can also be used to add a sub-total to another sub-total level.

Procedure OnSubTotal1
    Number nTotal
    Send WriteHtmlCell "" 'colspan="4" bgColor="Silver"'
    Get SubTotal 1 to nTotal // this also clears the acc. Level
     Send WriteHtmlCell (FormatNumber(nTotal,2)) 'bgColor="Silver" align="right" '
     Send WriteHtmlCell "" 'colspan="2" bgColor="Silver"'
     Send WriteHtmlTableEnd
    Send AddSubTotal 2 nTotal //  total of all sub-totals
End_Procedure // OnSubTotal1

See Also

ClearSubTotal | ClearAllSubTotals | SubTotal | SumSubTotal

Last Edited: July 30, 2003


cHtmlReport [Procedure ClearAllSubTotals]

ClearAllSubTotals - cHtmlReport

Clears all the SubTotal accumulators

Type: Procedure

Parameters: No Parameters

Description

ClearAllSubTotals clears all the SubTotal accumulators. To clear a single subtotal use the ClearSubTotal message.

When a new report is started, the object sends this message as part of its initialization. Therefore, you should rarely need to send this message.

See Also

ClearSubTotal | AddSubTotal | SubTotal | SumSubTotal

Last Edited: July 30, 2003


cHtmlReport [Procedure ClearSubTotal]

ClearSubTotal - cHtmlReport

Clears a single Subtotal accumulator

Type: Procedure

Parameters: Integer iCounter

Parameter | Description
iCounter | number of subtotal to clear

Description

ClearSubTotal clears a single Subtotal accumulator.

Send ClearSubTotal 1

Normally, this is not used. The AddSubTotal function moves an accumulator level to a variable and then clears the accumulator all in a single step.

See Also

ClearAllSubTotals | AddSubTotal | SubTotal | SumSubTotal

Last Edited: July 30, 2003


cHtmlReport [Procedure WriteHtml]

WriteHtml - cHtmlReport

Outputs the passed string to the web page and ends the line

Type: Procedure

Parameters: String WrStr

Parameter | Description
WrStr | the string value to be output

Description

WriteHtml outputs the passed string to the web page and ends the line. When passing strings you will probably first want to encode the HTML string, so special characters will not be read as HTML characters.

Typical output message might look like:

Send WriteHtml (HtmlEncode(Customer.Name))

Remember that HtmlEncode is a global method - it does not require an object parameter.

This outputs the passed string to the HTML file. The text is passed unfiltered to the HTML page (unless the HtmlEncode function is used). All of the other WBO HTML messages use this message to output HTML. You may use this to generate any type of valid HTML output you want.

Note:The text is not processed in any way. If the string contains valid HTML formatting characters (i.e., ), they will be interpreted by your browser as formatting commands. If your text contains characters that should not be "misunderstood" by HTML, you should encode them using the HTMLEncode function.

With the exception of the WriteHtmlPlainText message, all of the other WriteHtmlxxx messages eventually send this message.

VDF Code

Send WriteHtml (HTMLEncode(Customer.Name))
Send WriteHtml ("<strong>" + HTMLEncode(Customer.Notes) + "</strong>")

Script Code

None

Last Edited: June 23, 2005


cHtmlReport [Procedure WriteHtmlBreak]

WriteHtmlBreak - cHtmlReport

Outputs the passed string and ends the line

Type: Procedure

Parameters: String sHtml

Parameter | Description
sHtml | data to output

Description

WriteHtmlBreak outputs the string and then generates a line break (creates a new line). The HTML equivalent of:

sData <br/>

VDF Code

Send WriteHtmlBreak sData

Script Code

sData <br/>

Last Edited: September 15, 2003


cHtmlReport [Procedure WriteHtmlCell]

WriteHtmlCell - cHtmlReport

Outputs a table cell containing sData

Type: Procedure

Parameters: String sData String sAlign

Parameter | Description
sData | data to place in the table cell
sAlign | horizontal alignment to use for table cell

Description

WriteHtmlCell outputs a table cell containing sData. If a second parameter is passed, it is used to format the cell. If it is not passed the format will default to align=center, valign=top. The HTML equivalent of the message would be:

<td align="center">sData</td>

VDF Code

Send WriteHtmlCell sData
Send WriteHtmlCell sData sAlign
// The following two lines are equivalent:
Send WriteHtmlCell (HtmlEncode(Cust.Name))
Send WriteHtml ('<td align="center" valign="top">' + HtmlEncode(Cust.Name) + '</td>')
// The following two lines are also equivalent:
Send WriteHtmlCell (HtmlEncode(Cust.Name), 'align="Left"')
Send WriteHtml ('<td align="Left">' + HtmlEncode(Cust.Name) + '</td>')

Script Code

<td align= "center">sData</td>

Last Edited: September 15, 2003


cHtmlReport [Procedure WriteHtmlCellHeader]

WriteHtmlCellHeader - cHtmlReport

Outputs a table header cell containing sData

Type: Procedure

Parameters: String sData string sAlign

Parameter | Description
sData | data to place in the table cell. If empty, a non-breaking space HTML character will be placed in the data part of the cell header.
sAlign | horizontal alignment to use for table cell

Description

WriteHtmlCellHeader outputs a table header cell containing sData. If a second parameter is passed, it is used to format the cell. The default format is align=center, valign=top. The HTML equivalent of the message would be:

<th align="center" valign="top">sData</th>

VDF Code

Send WriteHtmlCellHeader sData
Send WriteHtmlCellHeader sData sAlign
//The following two lines are equivalent:
Send WriteHtmlCellHeader ("Name")
Send WriteHtml ('<th align="center" valign="top">' + "Name" + '</th>')
//The following two lines are also equivalent:
Send WriteHtmlCellHeader "Name" 'align="Left"'
Send WriteHtml ('<th align="Left">' + "Name" + '</th>')

Script Code

<th align="center" valign="top">sData</th>

Last Edited: June 21, 2005


cHtmlReport [Procedure WriteHtmlHorzLine]

WriteHtmlHorzLine - cHtmlReport

Outputs a horizontal line to the HTML file

Type: Procedure

Parameters: No Parameters

Description

WriteHtmlHorzLine outputs a horizontal line to the HTML file. The HTML equivalent of:

<hr>

VDF Code

Send WriteHtmlHorzLine

Script Code

<hr>

Last Edited: September 15, 2003


cHtmlReport [Procedure WriteHtmlRowBegin]

WriteHtmlRowBegin - cHtmlReport

Outputs a "begin" row HTML string

Type: Procedure

Parameters: No Parameters

Description

WriteHtmlRowBegin outputs a "begin" row HTML string. The HTML equivalent of:

<tr>

VDF Code

Send WriteHtmlRowBegin

Script Code

<tr>

Last Edited: September 15, 2003


cHtmlReport [Procedure WriteHtmlRowEnd]

WriteHtmlRowEnd - cHtmlReport

Outputs an end row html string

Type: Procedure

Parameters: No Parameters

Description

WriteHtmlRowEnd outputs an end row html string. The HTML equivalent of:

</tr>

VDF Code

Send WriteHtmlRowEnd

Script Code

</tr>

Last Edited: September 15, 2003


cHtmlReport [Procedure WriteHtmlTableBegin]

WriteHtmlTableBegin - cHtmlReport

Outputs a "begin" table html string

Type: Procedure

Parameters: String sParams string sPer

Parameter | Description
sParams | additional parameters to use with the tag; if omitted, 'border="1" width="99%"' will be added to the tag.
sPer | Optional percentage table width (rarely used)

Description

If you pass zero arguments to this method, the result will be

If you pass one argument to this method, the result will be
<table {value of argument1}>

For example, when the one argument is

'border="2"'

, the result will be

<table border="2">

If you pass two arguments to this method, the result will be that the value of the second argument will be used to set the width of the table as a percentage. Pass in the value only a number, the method will add 'width="' and '%"'.

If you write:

Send WriteHtmlTableBegin 2 50

, the result will be

<table border="2" width="50%">

So, if two arguments are passed the first argument should be ONLY the value for the border part of the tag and the second argument the value for the width part of the tag.

WriteHtmlTableBegin outputs a "begin" table html string. The HTML equivalent of:

<table border="1" width="99%">

The following two lines are equivalent:

Send WriteHtmlTableBegin
Send WriteHtml ('<table border="1" width="99%">')

The following two lines are equivalent:

Send WriteWmlTableBegin 'border="0" background="MyImg.gif"'
Send WriteWml '<table border="0" background="MyImg.gif">'

VDF Code

Send WriteHtmlTableBegin sParams

Script Code

<table>

Last Edited: September 2, 2005


cHtmlReport [Procedure WriteHtmlTableEnd]

WriteHtmlTableEnd - cHtmlReport

Outputs an end table html string

Type: Procedure

Parameters: No Parameters

Description

WriteHtmlTableEnd outputs an end table html string. The HTML equivalent of:

</table>

VDF Code

Send WriteHtmlTableEnd

Script Code

</table>

Last Edited: September 15, 2003


cHtmlReport [Procedure WriteLn]

WriteLn - cHtmlReport

Outputs the string and ends the Line

Type: Procedure

Parameters: String WrStr

Parameter | Description
WrStr | String to be output

Description

Writeln outputs the string and then generates a line break (creates a new line). The HTML/WML equivalent of:

sData <br/>

VDF Code

Send Writeln sData

Script Code

sData <br/>

This method is the same as WriteHtmlBreak in cWebReport and cWmlReport

Last Edited: September 15, 2003


Properties for cHtmlReport

View property list in hierarchical order

Name | Description | Defining Class
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button | cBasicReport
Assigned_Channel |  | cReport
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Error_State |  | cBasicReport
Find_Mode | Maintains the current finding mode | cReport
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image | cReport
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function | cReport
Last_Rec | (Obsolete) Contains the record number of the last selected record found | cReport
Main_File | Contains the filenumber of the file which the report will use for finding records | cReport
Name | Returns the full name of the object including parentage | cObject
New_Page_State | Set true when a new page is needed | cReport
No_Constrained_Find_State | Determines if constrained record finding should be disabled | cReport
No_Finding_State | Determines how the cReport object will find records | cReport
No_PageCheck_State | Set true when the cReport object is processing a new page | cReport
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found | cReport
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Output_Device | Handles the name of the output device | cBasicReport
Page_Count | Keeps track of the current page number | cReport
Page_End | Determines how many lines on a page are allowed before a page break will occur | cReport
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence | cReport
Page_Feed | Used by the formfeed procedure | cReport
Page_Footer_Lines | The number of lines in the page_footer image | cReport
Parent | Returns the parent of an object | cObject
pbCanceled | Setting this true will cancel a report | cReport
pbChildReport | Set true if the current cReport object is nested | cReport
pbFindDown | Determines if the report should traverse up or down the index | cReport
pbHasChildReports | Is set true if other reports are nested inside this report object | cReport
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level | cReport
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phMainReport | Contains the object ID of the outer report | cReport
piConstrainFile | Used when creating reports to limit the printing to a single parent record and the related children |
piConstrainRecord | (Obsolete) Used when creating reports to limit the printing to a single parent record and the related children |
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found | cReport
piNumberBreaks | Returns the number of breaks in a report | cReport
piOrdering | Contains the index number which will be used for finding records | cReport
piRecordCount | Contains the number of records found for the current report | cReport
priConstrainRowId | Used when creating reports to limit the printing to a single parent record and the related children |
priCurrentRec | Contains the RowId of the current valid record found | cReport
priFoundRec | Contains the RowId of the record found by the find_rec function | cReport
priLastRec | Contains the RowId of the last selected record found | cReport
Report_Caption | Contains the text that will appear in the status panel's caption bar | cBasicReport
Report_Channel | Determines which output channel will be used for your report output | cReport
Report_Footer_Lines | The number of lines in the OnReportFooter image | cReport
Report_Message | An additional message area that will appear below the report_title in the status panel | cBasicReport
Report_Status_Panel |  | cBasicReport
Report_Title | A centered title that appears in the status panel | cBasicReport
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing | cReport
Server | Identifies the object handle that is used as the report object's main data-dictionary object | cReportDS
Status_Log_Id | Object ID of status-log object | cBasicReport
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs | cBasicReport
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs | cBasicReport
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals | cReport


cHtmlReport [Property piConstrainFile]

piConstrainFile - cHtmlReport

Used when creating reports to limit the printing to a single parent record and the related children

Type: Property

Access: Read/Write

Data Type: Integer

Description

piConstrainFile is used when creating reports to limit the printing to a single parent record and the related children (like drill down parent-child reports). The WebReport object provides two properties that automates this process: piConstrainFile and priConstrainRowId.

Example

Set piConstrainFile to Customer.File_Number
Get piConstrainFile to iFile

See the Reporting section for more details.

Object oReport Is A cWebReport
       Set piOrdering to 2 // Customer x Order number
       Set piConstrainFile to Customer.File_Number
       Set priConstrainRowId to (NullRowID()) // this will get set for each report

See Also

priConstrainRowid

Last Edited: February 17, 2005


cHtmlReport [Property piConstrainRecord]

piConstrainRecord - cHtmlReport

Used when creating reports to limit the printing to a single parent record and the related children

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Obsolete

This property has been replaced by priConstrainRowId.

piConstrainRecord is used when creating reports to limit the printing to a single parent record and the related children (like drill down parent-child reports). The WebRepot object provides two properties that automates this process: piConstrainFile and piConstrainRecord.

If you set piConstrainRecord property to 0. It will disable the constraint relationship between the parent and child file.

Set piConstrainRecord to 0

Get piConstrainRecord to iConFile

See Also

priConstrainRowId

Last Edited: February 2, 2005


cHtmlReport [Property priConstrainRowId]

priConstrainRowId - cHtmlReport

Used when creating reports to limit the printing to a single parent record and the related children

Type: Property

Access: Read/Write

Data Type: RowId

Description

priConstrainRowId is used when creating reports to limit the printing to a single parent record and the related children (like drill down parent-child reports). The WebReport object provides two properties that automates this process: piConstrainFile and priConstrainRowId. priConstrainRowId contains the RowId of the parent (the constraining) record.

If you set priConstrainRowIdproperty to null. It will disable the constraint relationship between the parent and child file.

Set priConstrainRowId to (NullRowId())

Get priConstrainRowId to riConFile

If this constraint is set from an ASP page, the RowId will be passed in as a serialized string which can be converted to RowId by using the DeserializeRowId function.

Procedure SetConstraints integer iFile string sRowId
    Set piConstraintFile to iFile
    Set priConstrainRowId to (DeserializeRowId(sRowId))
end_Procedure

See Also

piConstrainFile

Last Edited: January 19, 2006


Events for cHttpTransfer

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnDataReceived | Is triggered several times during a GetRequest, PostRequest and PutRequest when data arrives from RemoteHost | cBaseHTTPTransfer


cHttpTransfer [Function HttpPostRequest]

HttpPostRequest - cHttpTransfer

Performs an HTTP POST request using sFilePath

Type: Function

Return Data Type: Integer

Parameters: String sFilePath String sData Integer bDataIsFile

Parameter | Description
sFilePath | Path to perform the HTTP POST
sData | Memory address of the data to be posted
bDataIsFile | If false, the value of sData is sent as HTTP POST body. If true, sData is interpreted as a filename, and the contents of that file are sent as the POST body instead of the actual value of sData

Return Value

Returns True if successful, and False otherwise

Description

HttpPostRequest performs an HTTP POST request using sFilePath. If bDataIsFile is False, the value of sData is sent as HTTP POST body. If bDataIsFile is True, sData is interpreted as a filename, and the contents of that file are sent as the POST body instead of the actual value of sData. All headers previously added using AddHeader, if any, are also sent as part of the request.

The OnDataReceived event is triggered for any response sent by RemoteHost.

Last Edited: August 18, 2003


cHttpTransfer [Function HttpPutRequest]

HttpPutRequest - cHttpTransfer

Performs an HTTP PUT request using sFilePath

Type: Function

Return Data Type: Integer

Parameters: String sFilePath String sData Integer bDataIsFile

Parameter | Description
sFilePath | path to perform the HTTP PUT
sData | memory address of the data to be posted
bDataIsFile | If false, the value of sData is sent as HTTP PUT body. If true, sData is interpreted as a filename, and the contents of that file are sent as the PUT body instead of the actual value of sData.

Return Value

Returns True if successful, and False otherwise

Description

HttpPutRequest performs an HTTP PUT request using sFilePath. If bDataIsFile is False, the value of sData is sent as HTTP PUT body. If bDataIsFile is True, sData is interpreted as a filename, and the contents of that file are sent as the PUT body instead of the actual value of sData. All headers previously added using AddHeader, if any, are also sent as part of the request.

The OnDataReceived event is triggered for any response sent by RemoteHost.

Last Edited: August 18, 2003


Methods for cHttpTransfer

View method list in hierarchical order

Name | Type | Description | Defining Class
AddHeader | Function | Adds the HTTP header named sHeaderName with the value sHeaderValue to the HTTP headers | cBaseHTTPTransfer
ClearHeaders | Procedure | Clears all HTTP headers added using AddHeader | cBaseHTTPTransfer
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
HTTPGetRequest | Function | Performs an HTTP GET request using sFilePath | cBaseHTTPTransfer
HTTPPostAddrRequest | Function | Performs an HTTP POST request | cBaseHTTPTransfer
HttpPostRequest | Function | Performs an HTTP POST request using sFilePath |
HTTPputAddrRequest | Function | Performs an HTTP PUT request using sFilePath | cBaseHTTPTransfer
HttpPutRequest | Function | Performs an HTTP PUT request using sFilePath |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
ResponseHeader | Function | Returns the value for a named http response header | cBaseHTTPTransfer
ResponseStatusCode | Function | Returns the response http status code | cBaseHTTPTransfer
SelectClientCertificate | Function | Selects a client certificate to be used in an Http request | cBaseHTTPTransfer


Properties for cHttpTransfer

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
LastErrorCode | Returns the last error code from the HTTP / FTP Transfer | InetTransfer
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbShowErrorDialog | Determines if a popup dialog will appear when a client certificate or usename/password is needed for an Http Request | cBaseHTTPTransfer
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peTransferFlags | Various flags that control how file/data should be transferred | InetTransfer
piBufferSize | Specifies the size of the file transfer buffer | InetTransfer
piRemotePort | Specifies the port to connect to on RemoteHost | InetTransfer
psAcceptTypes | Specifies the HTTP content types accepted by the client | cBaseHTTPTransfer
psAgent | Specifies the name of the application | InetTransfer
psPassword | Specifies the password to use to log on | InetTransfer
psProtocolVersion | Specifies the HTTP protocol version | cBaseHTTPTransfer
psProxy | Specifies the name of the Proxy server used, if any | InetTransfer
psRemoteHost | Specifies the hostname or the IP address of the remote server | InetTransfer
psSaveasFile | Saves response from the remote host to the specified file instead of triggering the OnDataReceived event | cBaseHTTPTransfer
psUserName | Specifies the name of the user to log on | InetTransfer
RootHandle | Returns the root HINTERNET handle used for the session | InetTransfer


cImageList [Event OnCreate]

OnCreate - cImageList

Called when the imagelist is ready to accept images to be added

Type: Event

Parameters: No Parameters

Description

The OnCreate event is called when the imagelist is ready to accept images to be added.

You add images using the AddTransparentImage and AddImage functions.

Advanced note

The phImagelist property will be valid, if you need to access the low-level Windows API interface into the imagelist.

Last Edited: September 10, 2003


Events for cImageList

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Called when the imagelist is ready to accept images to be added |


cImageList [Function AddImage]

AddImage - cImageList

Adds images into the imagelist during the OnCreate event

Type: Function

Return Data Type: Integer

Parameters: String sImage

Parameter | Description
sImage | The name of a bitmap file. It can be a fully-qualified name or the name of a file that can be found in the program's Workspace.

Return Value

The return value is the index of the image that was added. If multiple images are added, then the index of the first image is returned. If the image could not be added, -1 is returned.

Description

Call the AddImage function during the OnCreate event to add images into the imagelist. If you want to add an image that can be displayed transparently, use the AddTransparentImage instead.

Last Edited: July 30, 2003


cImageList [Function AddTransparentImage]

AddTransparentImage - cImageList

Adds transparent images into the imagelist during the OnCreate event

Type: Function

Return Data Type: Integer

Parameters: String sImage Integer iTransparentColor

Parameter | Description
sImage | The name of a bitmap file. It can be a fully-qualified name or the name of a file that can be found in the program's Workspace.
iTransparentColor | The color that will be replaced with the underlying control's background color when the image is displayed. If the piBackColor property does not contain clNone, then the iTransparentColor color will be replaced with the color of piBackColor instead.

Return Value

The return value is the index of the image that was added. If multiple images are added, then the index of the first image is returned. If the image could not be added, -1 is returned.

Description

Call the AddTransparentImage function during the OnCreate event to add transparent images into the imagelist.

Last Edited: July 30, 2003


cImageList [Function ImageCount]

ImageCount - cImageList

Returns the number of images in the imagelist

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The number of images in the imagelist

Description

ImageCount returns the number of images in the imagelist.

Last Edited: August 18, 2003


Methods for cImageList

View method list in hierarchical order

Name | Type | Description | Defining Class
AddImage | Function | Adds images into the imagelist during the OnCreate event |
AddTransparentImage | Function | Adds transparent images into the imagelist during the OnCreate event |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
ImageCount | Function | Returns the number of images in the imagelist |
RemoveAllImages | Procedure | Removes all the images in the Imagelist |
RemoveImage | Procedure | Removes an image from the imagelist |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cImageList [Procedure RemoveAllImages]

RemoveAllImages - cImageList

Removes all the images in the Imagelist

Type: Procedure

Parameters: No Parameters

Description

RemoveAllImages removes all the images in the Imagelist.

Last Edited: September 11, 2003


cImageList [Procedure RemoveImage]

RemoveImage - cImageList

Removes an image from the imagelist

Type: Procedure

Parameters: Integer iIndex

Parameter | Description
iIndex | The index of the image to remove

Description

RemoveImage removes an image from the imagelist. The first image in the imagelist has an index of zero, the next has an index of one, and so on.

Last Edited: September 11, 2003


Properties for cImageList

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phImageList | Contains the handle that Windows uses to communicate with the imagelist |
piBackColor | Sets the background color of the images |
piImageHeight | Specifies the height, in pixels, of each imag |
piImageWidth | Specifies the width, in pixels, of each image |
piMaxImages | Determines the maximum number of images that will be held in the imagelist |


cImageList [Property phImageList]

phImageList - cImageList

Contains the handle that Windows uses to communicate with the imagelist

Type: Property

Access: Read/Write

Data Type: Handle

Description

Once the imagelist has been created, the phImageList property will contain the handle that Windows uses to communicate with the imagelist.

This property is set internally prior to the OnCreate event being called.

You will not typically use this property, but it will be useful if you want to communicate via the Windows API to the imagelist.

Last Edited: September 11, 2003


cImageList [Property piBackColor]

piBackColor - cImageList

Sets the background color of the images

Type: Property

Access: Read/Write

Data Type: Integer

Description

piBackColor sets the background color of the images. If you leave this at the default value, the images will be added transparently. If you do not want transparent images, and require a fixed background color, you can set this property to valid RGB color.

Setting this property to a fixed color provides a small degree of optimization in the drawing, at the expense of flexibility as the background color must be known in advance.

Default is clNone.

Last Edited: September 11, 2003


cImageList [Property piImageHeight]

piImageHeight - cImageList

Specifies the height, in pixels, of each imag

Type: Property

Access: Read/Write

Data Type: Integer

Description

Every image in an imagelist must be the same size. The piImageHeight property specifies the height, in pixels, of each image.

You may not change the size of images once you have added images into the imagelist.

Default is 16.

Last Edited: September 11, 2003


cImageList [Property piImageWidth]

piImageWidth - cImageList

Specifies the width, in pixels, of each image

Type: Property

Access: Read/Write

Data Type: Integer

Description

Every image in an imagelist must be the same size. The piImageWidth property specifies the width, in pixels, of each image.

You may not change the size of images once you have added images into the imagelist.

Default is 16.

Last Edited: September 11, 2003


cImageList [Property piMaxImages]

piMaxImages - cImageList

Determines the maximum number of images that will be held in the imagelist

Type: Property

Access: Read/Write

Data Type: Integer

Description

Set the piMaxImages property to the maximum number of images that will be held in the imagelist.

Last Edited: September 11, 2003


Events for cIniFile

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cIniFile [Function KeyExists]

KeyExists - cIniFile

Determines whether a Key exists in a Section of an INI file

Type: Function

Return Data Type: Boolean

Parameters: String sSection String sKey

Parameter | Description
sSection | The name of the Section containing the Key
sKey | The name of the Key

Return Value

A Boolean value of True, if the sKey Key exists in the sSection Section; otherwise False is returned.

Description

Use the KeyExists method to determine if a Key exists before accessing it.

You must set the psFileName property to the name of the INI file before you can access it.

To see an example of how to use KeyExists, see the sample in cIniFile.

See Also

SectionExists

Last Edited: August 18, 2003


cIniFile [Function ReadString]

ReadString - cIniFile

Reads a string from an INI file

Type: Function

Return Data Type: String

Parameters: String sSection String sKey String sDefault

Parameter | Description
sSection | The name of an existing Section.
sKey | The name of an existing Key.
sDefault | The value you want returning if the Section or Key don't exist.

Return Value

The string stored in the Section/Key.

Description

To read a string from an INI file, you must provide the name of the Section and the name of the Key along with a default that you want returning if the Section/Key deosn't exist. Before reading a string (or performing any operation on the contents of an INI file) you must set the psFileName property.

To check whether a Section or Key exists, use SectionExists and KeyExists respectively

To see an example of using ReadString, see the sample in cIniFile

See Also

WriteString

Last Edited: September 11, 2003


cIniFile [Function SectionExists]

SectionExists - cIniFile

Indicates whether a Section exists in an INI file

Type: Function

Return Data Type: Boolean

Parameters: String sSection

Parameter | Description
sSection | The name of the Section to test the existence of

Return Value

Returns True if section exists, False if section does not exist

Description

You use the SectionExists function to determine whether a Section name already exists in an INI file. To discover whether a Key exists, use KeyExists.

Before testing whether a Section exists, you must first set the psFileName property to the name of the INI file.

To see an example of SectionExists, see the sample for ReadSection.

See Also

KeyExists | ReadSection

Last Edited: September 25, 2003


Methods for cIniFile

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
DeleteKey | Procedure | Deletes a Key from a Section of an INI file |
DeleteSection | Procedure | Deletes an entire Section from an INI file |
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
KeyExists | Function | Determines whether a Key exists in a Section of an INI file |
ReadSection | Procedure | Obtains a list of Key names with an INI file Section |
ReadSections | Procedure | Obtains a list of Sections names within an INI file |
ReadString | Function | Reads a string from an INI file |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SectionExists | Function | Indicates whether a Section exists in an INI file |
WriteString | Procedure | Writes a string value into an INI file |


cIniFile [Procedure DeleteKey]

DeleteKey - cIniFile

Deletes a Key from a Section of an INI file

Type: Procedure

Parameters: String sSection String sKey

Parameter | Description
sSection | The name of the Section containing the Key
sKey | The name of the Key

Description

Use the DeleteKey method to delete a Key from a Section of an INI file.

Before deleting a Key, set the psFileName property to the name of the INI file.

To test whether a Key exists, use the KeyExists method.

See Also

DeleteSection | KeyExists

Last Edited: August 18, 2003


cIniFile [Procedure DeleteSection]

DeleteSection - cIniFile

Deletes an entire Section from an INI file

Type: Procedure

Parameters: String sSection

Parameter | Description
sSection | The name of the Section to delete

Description

Use the DeleteSection method to delete a Section and all its Keys from an INI file.

Before deleting a Section, set the psFileName property to the name of the INI file.

To test whether a Section exists, use the SectionExists method.

See Also

DeleteKey | SectionExists

Last Edited: August 18, 2003


cIniFile [Procedure ReadSection]

ReadSection - cIniFile

Obtains a list of Key names with an INI file Section

Type: Procedure

Parameters: String sSection Handle hoArray

Parameter | Description
sSection | The name of the section.
hoArray | The object-handle of an Array instance that will store the list of Key names.

Description

The ReadSection method retrieves the names of all Keys for a given Section. You pass the name of a Section and an object-handle of an Array. When the method returns, the Array object is populated with the names of the Keys.

Before using ReadSection, you must set the psFileName property to the name of the INI file.

You can obtain a list of all Section names using ReadSections.

Sample

In this sample, we test whether a Section called "Drivers" exists, and if it does we display all its Keys.

Procedure ShowKeys
    Handle hoIniFile hoDrivers
    Integer iDriver

    // create a cIniFile object...
    Get Create U_cIniFile To hoIniFile
    // create an array to store the list of drivers...
    Get Create U_Array To hoDrivers

    Set psFileName of hoIniFile To "c:\Windows\System.ini"
    If (SectionExists(hoIniFile, "Drivers")) Begin
        Send ReadSection of hoIniFile "Drivers" hoDrivers

        For iDriver from 0 To (Item_Count(hoDrivers) -1)
            Showln iDriver " = " (Value(hoDrivers, iDriver))
        Loop
    End
    Else ShowLn "Drivers Section does NOT exist"

    // destroy the cIniFile object we just created...
    Send Destroy of hoIniFile
    // destroy the Array object we just created...
    Send Destroy of hoDrivers
End_Procedure

See Also

SectionExists | ReadSections

Last Edited: September 11, 2003


cIniFile [Procedure ReadSections]

ReadSections - cIniFile

Obtains a list of Sections names within an INI file

Type: Procedure

Parameters: Handle hoArray

Parameter | Description
hoArray | The object-handle of an Array instance that will be populated with the Section names.

Description

The ReadSections method retrieves the names of all Sections within an INI file. You pass an object-handle of an Array. When the method returns, the Array object is populated with the names of the Sections.

Before using ReadSections, you must set the psFileName property to the name of the INI file.

You can obtain a list of all Key names within a single Section using ReadSection.

Sample

In this sample, we display all the Section names within an INI file.

Procedure ShowSections
    Handle hoIniFile hoSections
    Integer iSection

    // create a cIniFile object...
    Get Create U_cIniFile To hoIniFile
    // create an array to store the list of drivers...
    Get Create U_Array To hoSections

    Set psFileName of hoIniFile To "c:\Windows\System.ini"
    // populate an array with the Section names...
    Send ReadSections of hoIniFile hoSections

    // show the Section names...
    For iSection from 0 To (Item_Count(hoSections) -1)
        Showln iSection " = " (Value(hoSections, iSection))
    Loop

    // destroy the cIniFile object we just created...
    Send Destroy of hoIniFile
    // destroy the Array object we just created...
    Send Destroy of hoSections
End_Procedure

See Also

ReadSection | psFileName

Last Edited: September 11, 2003


cIniFile [Procedure WriteString]

WriteString - cIniFile

Writes a string value into an INI file

Type: Procedure

Parameters: String sSection String sKey String sValue

Parameter | Description
sSection | The name of the Section. If the Section doesn't already exist, it will be created.
sKey | The name of the Key. If the Key doesn't already exist, it will be created.
sValue | the data that you want to write into the INI file.

Description

The WriteString procedure writes a string value into an INI file. To write a string into an INI file, you must provide the name of the Section and the name of the Key. Before writing a string (or performing any operation on the contents of an INI file) you must set the psFileName property.

To see an example of using WriteString, see the sample in cIniFile

See Also

ReadString

Last Edited: September 15, 2003


Properties for cIniFile

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psFileName | The filename of the INI file |


cIniFile [Property psFileName]

psFileName - cIniFile

The filename of the INI file

Type: Property

Access: Read/Write

Data Type: String

Description

You must set the psFileName property before you can access an INI file. The filename must be fully-qualified, meaning it must contain a path.

Sample

In this sample, an internet address is read from a Key named "Support" in a Section called "URLs". The INI file is called "App.ini" and located in the same directory as the application.

Function GetURL Returns String
    Handle hoIniFile
    String sUrlSupport

    Get Create U_cIniFile To hoIniFile // create a cIniFile object
    Set psFileName of hoIniFile To (GetApplicationPath(ghoApplication) +"\App.ini")
    Get ReadString of hoIniFile  "URLs" "Support" "" To sUrlSupport
    Send Destroy of hoIniFile // destroy the object we just created
    Function_Return sUrlSupport
End_Function

Note:To acquire the directory name that your application is running in, this sample assumes your program is using an application object (an instance of cApplication)

Last Edited: September 11, 2003


Events for cInternetSessionBusinessProcess

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnAttachProcess | When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object | cDistributedBusinessProcess
OnDetachProcess | When process pooling is used, this event is sent first to the WebApp object and then to every WBO object | cDistributedBusinessProcess
OnReportClearStatus | After a clear operation, augments point to handle whatever additional processing is required | cRemoteEntryProcess
OnReportDeleteStatus | After a delete operation, augmentats point to handle whatever additional processing is required | cRemoteEntryProcess
OnReportFindStatus | After a find operation, augments point to handle whatever additional processing is required | cRemoteEntryProcess
OnReportSaveStatus | After a save operation, augments point to handle whatever additional processing is required | cRemoteEntryProcess
OnReportValidateStatus | After an update operation, augments point to handle whatever additional processing is required | cRemoteEntryProcess


cInternetSessionBusinessProcess [Function Cookie]

Cookie - cInternetSessionBusinessProcess

Type: Function

Return Data Type: String

Parameters: String sCookieName String sCookieKeyName

Parameter | Description
sCookieName | [ToDo: In Progress]
sCookieKeyName | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cInternetSessionBusinessProcess [Function DDCurrentValue]

DDCurrentValue - cInternetSessionBusinessProcess

Type: Function

Return Data Type: String

Parameters: Integer hMain Integer iFile Integer iField

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cInternetSessionBusinessProcess [Function DDHndValue]

DDHndValue - cInternetSessionBusinessProcess

Called within an ASP file by using the DDValue message

Type: Function

Return Data Type: String

Parameters: Integer hMain Integer iFile Integer iField Integer iOption String sParam

Parameter | Description
hMain | contains the object ID of the main DDO in the process (for example, the file that a save or delete is based on)
iFile | number of the table in the current filelist
iField | number of the field in table iFile
iOption | determines what type of Data (or DataDictionary field information) should be returned. The most common use is to pass iOption as zero, which requests the DataDictionary's current-field value in an HTML input form. Normally called while ASP is generating an HTML output page. See the cWebBusinessProcess class for all available iOptions.
sParam | additional parameter that can be used to pass extra information for certain iOption types

Return Value

The return value can be directly embedded into HTML text, as an input form value (its most common use), or returned to a VBScript or Java Script function

Description

The name of this message has changed from WebApp 2.x, where it was DDValue, to distinguish it from the more frequently used DDValue function of the same name. More often than not, DDValue is the function you will want to use, rather than DDHndValue.

The DDHndValue message is called within an ASP file by using the DDValue message. You will rarely send this message from a WBO (although it is permitted). It is more likely that you will augment this message to provide additional data-dictionary field information to your ASP script. When encountered, this function will call the WBO function DDValue passing the file and field value as separate parameters.

If you create your own custom iOption types, you are encouraged to use iOption for values above 1000 (Data Access reserves the first 1000 values).

Note: If iOption and sParam are not passed, the default value of iOption=0 and sParam="" is passed to the DataFlex WBO. Other values for iOption and sParam must be defined and coded in your DataFlex WBO.

Sample 1

By default, this function returns the current value of a field. No augmentation is required. An ASP file could call this function as follows:

<td><input type="text" size="13" name="Cust0100__Custnr"
    Value="<% WBO.DDValue("Cust0100.Custnr",0,"")%>">
</td>

The iOption value of zero and the sParam value of " " are the default so they may be omitted, allowing a simpler syntax for this commonly used function.

<td><input type="text" size="13" name="Cust0100__Custnr"
   Value="<% WBO.DDValue("Cust0100.Custnr")%>">
</td>

Sample 2

The next sample returns a field's description value. This could be used when field data has an associated validation-table description associated with it. The following would be added to your WebBusinessProcess object.

Function DDhndValue integer hMain integer iFile integer iField integer iOption string sParam Returns string
    string sValue
    If iOption eq 1010 Begin // 1010 custom defined for us
        Get File_Field_Current_Description of hMain iFile iField to sValue
         // you should always encode your data so that special HTML values like
        //"<" and ">" are converted to their HTML replacements!
        Get HTMLEncode sValue to sValue
    End
    Else ;
        Forward get ddValue hMain iFile iField iOption sParam to sValue
    Function_return sValue
End_Function

This could be called from your ASP file as follows:

<p>
Current field description is <%=WBO.DDValue("Cust.Status",1010)%>.
</p>

Sample 3

The next sample will check if the passed sParam value is the same as the current field value. If it is, it will return the string "Open" if it is not, it will return "Closed."

Function DDhndValue integer hMain integer iFile integer iField integer iOption string sParam Returns string
    string sValue
    If iOption eq 2000 Begin // 2000 custom defined for us
        Get File_Field_Current_Value of hMain iFile iField to sValue
         If sValue eq sParam Move "Open" to sValue
            Else move "Closed" to sValue
        End
        Else ;
            Forward get ddValue hMain iFile iField iOption sParam to sValue
   Function_return sValue
End_Function

This could be called from your ASP file as follows:

<p>
The current customer's status is <%=Test_WBO.DDValue("Cust.Status",2000,"A")%>.
</p>

It could also be called in a WBO as follows:

Since the DDValue is used mainly in the ASP side, the message options will be described from an ASP standpoint. A number of option values are supported with DDValue. In the documentation we will refer to these options by their symbolic name and not the option number (e.g., DDLONGLABEL instead of 2). You can use the symbolic names within your ASP files but make sure that you first define constant replacements for these values. These constants are defined in a file named DDValue_Constants.inc, which must be placed in your AppHtml directory. This file is included in an ASP file by adding the following line to the top of your ASP file:

<!--#INCLUDE FILE="DDValue_Constants.inc" -->

Last Edited: July 11, 2006


cInternetSessionBusinessProcess [Function DDValue]

DDValue - cInternetSessionBusinessProcess

Returns the value of a file.field from the DataDictionary in a specified form

Type: Function

Return Data Type: String

Parameters: String sFileField Integer iOpt String sPrm

Parameter | Description
sFileField | table.field to access
iOpt | options to pass to ddValue, see cWebBusinessProcess class for possible options
sPrm | additional parameters

Return Value

Returns the value of a file.field from the DataDictionary in a specified form

Description

ddValue returns the value of a file.field from the DataDictionary in a specified form.

The option parameter and the extra string parameter can be used to pass additional information to WBO object. For example, if a "1" were passed as the option instead of a "0", Visual DataFlex could use that to return some other data dictionary value for that file and field - perhaps the field's label. The current cWebBusinessProcess class does not support this. It only understands the "0" option and it always returns the field's current value. The class was constructed to easily allow for a sub class to be created that could process different option values.

The DDValue function is most often used in ASP code. Some functionality of the DDValue function can also be used in Visual DataFlex code inside a WebBusinessProcess (WBO). For more information on this functionality, please see the cWebBusinessProcess Class.

Format

Get ddValue sFileField {iOpt} {sParams} to sValue

Example

Here is an example of using the ddValue function in VDF code in a WBO.

Function ChangeOrderDtl Integer iOrderNo Integer iDetailNo Integer iQty Returns Integer
    Integer iTmpQty
    Boolean bOk

    Get ddClear "OrderDtl" to bOK
    Send SetDDValue "Orderdtl.Order_Number"  iOrderNo
    Send SetDDValue "Orderdtl.Detail_Number" iDetailNo
    Get ddFind "Orderdtl" 1 EQ to bOk
    If (bOk) Begin
        Get ddValue "Orderdtl.Qty_Ordered" to iTmpQty
        Move (iTmpQty + iQty) to iTmpQty
        Send SetddValue "Orderdtl.Qty_Ordered" iTmpQty
        Get ddSave "Orderdtl" to bOK // does a save and validate
    End

     Function_Return (bOK=0) // if error return True
End_Function //  IncOrderDtl

To see how to use ddValue in ASP, please see the section titled ddValue Function in the Creating Active Server Pages (ASP) online help book.

See Also

ddValueEncode | cWebBusinessProcess | DDValue function

Last Edited: June 21, 2005


cInternetSessionBusinessProcess [Function DDValueEncode]

DDValueEncode - cInternetSessionBusinessProcess

Returns the value of a file.field from the DataDictionary in HTMLEncoded form

Type: Function

Return Data Type: String

Parameters: String sFileField Integer iOpt String sPrm

Parameter | Description
sFileField | table.field to access
iOpt | options to pass to ddValue, see cWebBusinessProcess class for possible options
sPrm | additional parameters

Return Value

Returns the value of a file.field from the DataDictionary in a specified form

Description

ddValueEncode returns the value of a file.field from the DataDictionary in HTMLEncoded form.
Same as ddValue, but performs HtmlEncode on the value as well. The characters that it checks for are &<>" and characters 10 and 13.

The option parameter and the extra string parameter can be used to pass additional information to WBO object. For example, if a "1" were passed as the option instead of a "0", Visual DataFlex could use that to return some other data dictionary value for that file and field - perhaps the field's label. The current cWebBusinessProcess class does not support this. It only understands the "0" option and it always returns the field's current value. The class was constructed to easily allow for a sub class to be created that could process different option values.

The DDValue function is most often used in ASP code. Some functionality of the DDValue function can also be used in Visual DataFlex code inside a WebBusinessProcess (WBO). For more information on this functionality, please see the cWebBusinessProcess Class.

Format

Get ddValueEncode sFileField {iOpt} {sParams} to sValue

The following 2 code examples produce identical results:

Example 1

Get ddValue "Invt.Description"  to sDescription
Send WriteHtml (HtmlEncode(sDescription))

Example 2

Get ddValueEncode "Invt.Description" to sDescription
Send WriteHtml sDescription

See Also

ddValue | cWebBusinessProcess | DDValue function

Last Edited: August 5, 2005


cInternetSessionBusinessProcess [Function DoGetHtmlFormValue]

DoGetHtmlFormValue - cInternetSessionBusinessProcess

Obtains the value of any posted HTML form value

Type: Function

Return Data Type: String

Parameters: String sFormName

Parameter | Description
sFormName | the name of the HTML form to access

Return Value

Returns the value from the input form name as a string

Description

DoGetHtmlFormValue can be used to obtain the value of any posted HTML form value. The value from the input form named sFormName will be returned as a string. For example, a report might use this to obtain the selection parameters from the posted HTML file.

Procedure SetQuerySelections
    string sLow sHigh
    handle hoDD

    Get Main_DD to hoDD
    Get DoGetHTMLFormValue "Sel_Ge_Custnr" to sLow
    Get DoGetHTMLFormValue "Sel_Le_Custnr" to sHigh
    Set pStartCUSTNR of hoDD to sLow
    Set pStopCUSTNR of hoDD to sHigh
End_Procedure

Procedure MyProcess Integer iParam String sParam
    integer iServer#
    string sText
    handle hoDD

    Get Main_DD to hoDD
    Send SetQuerySelections
    Send Rebuild_Constraints of hoDD
End_Procedure

The above example assumes that the HTML data was posted from forms named Sel_Ge_CUSTNR and Sel_Le_CUSTNR as follows:

<td align="right"><em>Select Custnr From</em></td>
<td><input type="text" size="13" name="Sel_Ge_Custnr"></td>
<td align="right"><em>Select Custnr To</em></td>
<td><input type="text" size="13" name="Sel_Le_Custnr"></td>

To retrieve variable values see DoGetHtmlQueryString.

VDF Code

Get DoGetHTMLFormValue "Selection_Start" to sStartVal

Last Edited: September 2, 2005


cInternetSessionBusinessProcess [Function DoGetHtmlQueryString]

DoGetHtmlQueryString - cInternetSessionBusinessProcess

Obtains the value of any ASP variables

Type: Function

Return Data Type: String

Parameters: String lpszVariable

Parameter | Description
lpszVariable | query string variable to retrieve value of

Return Value

Returns the value of the variable name as a string

Description

DoGetHtmlQueryString can be used to obtain the value of any ASP variables. The value from the variable name named lpszVariable will be returned as a string. This can also be used to get the value passed to the right of a URL following a "?".

To retrieve form values see DoGetHtmlFormValue.

VDF Code

String sQueryString sValue
Get DoGetHTMLQueryString sQueryString to sValue

Last Edited: July 31, 2003


cInternetSessionBusinessProcess [Function ErrorCount]

ErrorCount - cInternetSessionBusinessProcess

Returns the number of errors in the current error queue

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the number of errors in the current error queue

Description

ErrorCount returns the number of errors in the current error queue.

During some processes, Errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

VDF Code

Get ErrorCount to iCount

Script Code

<% iCount=WBO.Call "get_ErrorCount"%>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the RegisterInterface message or by sending the RegisterFullErrorInterface message.

To register ErrorCount send one of the following:

Send RegisterInterface  msg_ErrorCount r "msg_ErrorCount" ;
    "sFile iRecord"  "This will display the number of error messages in the error queue"

Send RegisterFullErrorInterface

Last Edited: August 5, 2003


cInternetSessionBusinessProcess [Function ErrorMessage]

ErrorMessage - cInternetSessionBusinessProcess

Returns an HTML formatted error message for item iItem in the error queue

Type: Function

Return Data Type: String

Parameters: Integer iItem

Parameter | Description
iItem | message number to generate error for

Return Value

Returns an HTML formatted error message for item iItem in the error queue

Description

ErrorMessage returns an HTML formatted error message for item iItem in the error queue. This can be used within VDF and within your ASP file to generate custom error output.

During some processes, Errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

<Script Language="VBSCRIPT" RunAt="Server">
Sub ShowErrors
    Errs = WBO.Call ("get_ErrorCount")
    If Errs > 0 Then
        Response.write ( "<hr>")
        Response.write ("We have some Errors<br>")
        For I = 0 to Errs-1
            ErrMess = WBO.Call "get_ErrorMessage", i
            Response.write ("Error: "+ErrMess+"<hr>")
        Next
    End if
End Sub
</Script>

VDF Code

Get ErrorMessage iErrNo to sHtmlVar

Script Code

<% sErrorVar=WBO.Call ("get_ErrorMessage", "iErrNo")%>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the RegisterInterface message or by sending the RegisterFullErrorInterface message.

To register ErrorMessage send one of the following:

Send RegisterInterface  msg_ErrorMessage "msg_ErrorMessage" ;
    "sFile iRecord"  "This will display the number of error messages in the error queue"

Send RegisterFullErrorInterface

Last Edited: August 5, 2003


cInternetSessionBusinessProcess [Function FileFieldErrorItem]

FileFieldErrorItem - cInternetSessionBusinessProcess

Checks the error queue for an error associated with the passed file and field

Type: Function

Return Data Type: Integer

Parameters: Integer iFile Integer iField

Parameter | Description
iFile | number of the table in the current filelist
iField | number of the field in table iFile

Return Value

If an error exists, its item number is returned. If no error exists, -1 is returned.

Description

FileFieldErrorItem checks the error queue for an error associated with the passed file and field.

This provides a mechanism for checking if a process, such as a save validation, generates an error for a specific file and field.

Normally this function is not used. In ASP, the developer would use the DDFieldError DDValue option.

During some processes, Errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

VDF Code

Get (FileFieldErrorItem iFile iField) to iItem

Script Code

<% iRetVal = WBO.Call "get_FileFieldErrorItem" "iFile" "iField" %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message.
To register the FileFieldErrorItem send the following:

Send RegisterInterface  get_FileFieldErrorItem "get_FileFieldErrorItem" ;
    "sFile iRecord"  ;
"This checks the error queue for an error associated with passed file and field "

Last Edited: August 18, 2003


cInternetSessionBusinessProcess [Function isFieldChanged]

isFieldChanged - cInternetSessionBusinessProcess

Type: Function

Return Data Type: Integer

Parameters: String sFile String sField

Parameter | Description
sFile | [ToDo: In Progress]
sField | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cInternetSessionBusinessProcess [Function Search_Field_Name]

Search_Field_Name - cInternetSessionBusinessProcess

Type: Function

Return Data Type: Integer

Parameters: Integer iFile String sFieldName

Parameter | Description
iFile | [ToDo: In Progress]
sFieldName | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cInternetSessionBusinessProcess [Function Search_File_Name]

Search_File_Name - cInternetSessionBusinessProcess

Type: Function

Return Data Type: Integer

Parameters: String sFileName

Parameter | Description
sFileName | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cInternetSessionBusinessProcess [Function ServerVariable]

ServerVariable - cInternetSessionBusinessProcess

Type: Function

Return Data Type: String

Parameters: String sVariableName

Parameter | Description
sVariableName | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


Methods for cInternetSessionBusinessProcess

View method list in hierarchical order

Name | Type | Description | Defining Class
ClearConfirmation | Function |  | cRemoteEntryProcess
ClearErrors | Procedure | Clears the error queue |
Cookie | Function |  |
Cookie | Procedure Set |  |
CookieAttribute | Procedure Set |  |
Create | Function | Creates an object based on the passed Class Id | cObject
DDCurrentValue | Function |  |
DDHndValue | Function | Called within an ASP file by using the DDValue message |
DDValue | Function | Returns the value of a file.field from the DataDictionary in a specified form |
DDValueEncode | Function | Returns the value of a file.field from the DataDictionary in HTMLEncoded form |
DeleteConfirmation | Function |  | cRemoteEntryProcess
Destroy | Procedure |  | cObject
DoGetHtmlFormValue | Function | Obtains the value of any posted HTML form value |
DoGetHtmlQueryString | Function | Obtains the value of any ASP variables |
DoRequestClear | Function | Generates a remote clear process | cRemoteEntryProcess
DoRequestDDUpdate | Function | Provides another way to build the WBO's data dictionary structure based on information passed from the browser | cRemoteEntryProcess
DoRequestDelete | Function | Generates a remote delete process | cRemoteEntryProcess
DoRequestFind | Function | Performs a field find for the passed file name, field name and find mode | cRemoteEntryProcess
DoRequestSave | Function | Generates a remote save process | cRemoteEntryProcess
ErrorCount | Function | Returns the number of errors in the current error queue |
ErrorMessage | Function | Returns an HTML formatted error message for item iItem in the error queue |
ErrorQueueEnd | Procedure | Ends an error queue process |
ErrorQueueStart | Procedure | Starts an error queue process |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FileFieldErrorItem | Function | Checks the error queue for an error associated with the passed file and field |
isFieldChanged | Function |  |
LogErrorEvent | Procedure | Logs an error event |
LogEvent | Procedure | Logs an event to the Web Application's event log |
MapFileNametoDD | Function |  | cDistributedBusinessProcess
MaptoFieldNumber | Function |  | cDistributedBusinessProcess
MaptoFileNumber | Function |  | cDistributedBusinessProcess
RegisterInterface | Procedure | Registers a message (property, function, procedure) and make it available as a Call message within an ASP page |
RegisterStandardInterface | Procedure |  |
RemoveInterface | Procedure | When sent, removes any message from the Call interface |
ReportAllErrors | Procedure | Generates a list of all errors that have occurred since this error queue was last cleared |
ReportErrorItem | Procedure | Displays the error for iItem in the error queue |
ReportLastError | Procedure | Displays the last error in the error queue |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
RequestFileFieldValues | Procedure |  | cDistributedBusinessProcess
RequestFileRecords | Procedure |  | cDistributedBusinessProcess
SaveConfirmation | Function |  | cRemoteEntryProcess
Search_Field_Name | Function |  |
Search_File_Name | Function |  |
ServerVariable | Function |  |
SetChangedFields | Procedure |  |
SetDDCurrentValue | Procedure |  |
SetDDHndValue | Procedure |  |
SetDDValue | Procedure | Directly sets the value of a file.field in the DataDictionary buffer |


cInternetSessionBusinessProcess [Procedure Set Cookie]

Cookie - cInternetSessionBusinessProcess

Type: Procedure Set

Data Type: String

Parameters: String sCookieName String sCookieKeyName String sValue

Parameter | Description
sCookieName | [ToDo: In Progress]
sCookieKeyName | [ToDo: In Progress]
sValue | [ToDo: In Progress]

Description

Last Edited: July 2, 2003


cInternetSessionBusinessProcess [Procedure Set CookieAttribute]

CookieAttribute - cInternetSessionBusinessProcess

Type: Procedure Set

Data Type: Boolean

Parameters: String sCookieName Date dExpires String sDomain String sPath Boolean bSecure

Parameter | Description
sCookieName | [ToDo: In Progress]
dExpires | [ToDo: In Progress]
sDomain | [ToDo: In Progress]
sPath | [ToDo: In Progress]
bSecure | [ToDo: In Progress]

Description

Last Edited: July 2, 2003


cInternetSessionBusinessProcess [Procedure ClearErrors]

ClearErrors - cInternetSessionBusinessProcess

Clears the error queue

Type: Procedure

Parameters: No Parameters

Description

This clears the error queue. During some processes, errors are placed in an error queue. These queued errors are then processed at a later time. After the errors are processed, you may clear the error queue by sending the ClearErrors message. Note that the error queue is also cleared when you send the ErrorQueueStart message.

See Error Handling Messages for more on queued errors.

VDF Code

Send ClearErrors

Script Code

<% WBO.Call "msg_ClearErrors" %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message or by sending the RegisterBasicErrorInterface, RegisterFullErrorInterface, or RegisterStandardInterface message.
To register the ClearErrors send one of the following:

Send RegisterInterface  msg_ClearErrors "msg_ClearErrors" ;
    "sFile iRecord"  "This will clear the error queue"

Send RegisterBasicInterface

Send RegisterFullErrorInterface

Send RegisterStandardInterface

Last Edited: March 25, 2004


cInternetSessionBusinessProcess [Procedure ErrorQueueEnd]

ErrorQueueEnd - cInternetSessionBusinessProcess

Ends an error queue process

Type: Procedure

Parameters: No Parameters

Description

ErrorQueueEnd ends an error queue process. The pbQueueErrors property is set to false. This does not clear the existing error queue.

During some processes Errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

If you want to queue errors,you must code this yourself:

Procedure MyProcess integer iParam string sParam
    :
    Send ErrorQueueStart
    :
    : do the process
    :
    Get ErrorCount to iErrs // any errors
    If iErrs Send ReportAllErrors "Errors encountered during Process"
    Send ErrorQueueEndEnd_Procedure

VDF Code

Send ErrorQueueEnd

Script Code

This can be used at any point to report DataFlex errors to HTML.

<% WO.Call "msg_ErrorQueueEnd" %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message or by sending the RegisterFullErrorInterface, RegisterStandardInterface, or RegisterBasicErrorInterface message.

To register ErrorQueueEnd send one of the following:

Send RegisterInterface  msg_ ErrorQueueEnd "msg_ ErrorQueueEnd" ;
    "sFile iRecord"  "This will end the reporting of the errors in the error queue"

Send RegisterBasicInterface

Send RegisterFullErrorInterface

Send RegisterStandardInterface

Last Edited: August 5, 2003


cInternetSessionBusinessProcess [Procedure ErrorQueueStart]

ErrorQueueStart - cInternetSessionBusinessProcess

Starts an error queue process

Type: Procedure

Parameters: No Parameters

Description

ErrorQueueStart starts an error queue process. All errors in the error queue are cleared and the pbQueueErrors property is set to true. Once this message is started, all errors will be added to the error queue. All errors in the queue can then be displayed by sending the ReportAllErrors message. Errors will be queued until the ErrorQueueEnd message is sent.

During some processes Errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

The VDF functions, DoRequestClear, DoRequestSave, DoRequestFind and DoRequestDelete all handle error queues automatically. When the process starts, the ErrorQueueStart message is sent. When the process is finished, all errors are reported (if ErrorReport_State is true), and the ErrorQueueEnd message is sent.

If you want to queue errors, you must code this yourself:

Procedure DoProcess integer iParam string sParam
    :
    Send ErrorQueueStart
    :
    : do the process
    :
    Get ErrorCount to iErrs // any errors
    If iErrs Send ReportAllErrors "Errors encountered during Process"
    Send ErrorQueueEnd
End_Procedure

VDF Code

Send ErrorQueueStart

Script Code

This can be used at any point to report DataFlex errors to HTML.

<% WBO.Call "msg_ErrorQueueStart" %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message or by sending the RegisterFullErrorInterface, RegisterBasicErrorInterface, or RegisterStandardInterface message.

To register ErrorQueueStart send one of the following:

Send RegisterInterface  msg_ ErrorQueueStart "msg_ ErrorQueueStart" ;
    "sFile iRecord"  "This will start the reporting of the errors in the error queue"

Send RegisterBasicErrorInterface

Send RegisterFullErrorInterface

Send RegisterStandardInterface

Last Edited: August 5, 2003


cInternetSessionBusinessProcess [Procedure LogErrorEvent]

LogErrorEvent - cInternetSessionBusinessProcess

Logs an error event

Type: Procedure

Parameters: Integer iErr String sText

Parameter | Description
iErr | type of event to log
sText | event name that is being logged

Description

LogErrorEvent logs an error event. An error event generates a normal error and explicitly logs this error to the Web Application's event log. Events can be viewed using the DataFlex WebApp Server Administration tool.

Most unexpected errors (program errors, syntax errors, etc.) are already automatically placed in the event log without any special programming on your part. This message should be used when you are sure the error should be added to the event log. If you are not logging an error event, do not use this message - use the LogEvent message.

See Error Handling Messages for more on queued errors.

VDF Code

Send LogErrorEvent iEventType sEvent

Script Code

<% WBO.Call "msg_LogErrorEvent", iEventType, sEvent %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message or by sending the RegisterFullErrorInterface message.

To register LogErrorEvent send one of the following:

Send RegisterInterface msg_LogErrorEvent "msg_LogErrorEvent" ;
    "sFile iRecord"  "This will log the event into the event log and generates a normal error "

Send RegisterFullErrorInterface

Last Edited: August 18, 2003


cInternetSessionBusinessProcess [Procedure LogEvent]

LogEvent - cInternetSessionBusinessProcess

Logs an event to the Web Application's event log

Type: Procedure

Parameters: Integer iEventType String lpszEvent

Parameter | Description
iEventType | type of event to log
lpszEvent | event name that is being logged

Description

LogEvent logs an event to the Web Application's event log. This is often used to log any type of non-error system activity. Events can be viewed using the DataFlex WebApp Server Administration tool.

You should use this message to log any type of non-error activity to the error log. Errors should be added to the event log using the LogErrorEvent message. This message will generate an error and log the error to the event log. Most unexpected errors (program errors, syntax errors, etc.) are automatically placed in the event log without any special programming on your part.

See Error Handling Messages for more on queued errors.

VDF Code

Send LogEvent iEventType sEvent

Script Code

<% WBO.Call "msg_LogEvent", iEventType, sEvent %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the RegisterInterface message..

To register LogEvent send the following:

Send RegisterInterface  msg_LogEvent "msg_LogEvent" ;
    "sFile iRecord"  "This will log the event into the event log"

Last Edited: August 18, 2003


cInternetSessionBusinessProcess [Procedure RegisterInterface]

RegisterInterface - cInternetSessionBusinessProcess

Registers a message (property, function, procedure) and make it available as a Call message within an ASP page

Type: Procedure

Parameters: Integer iMsg String sMsgName String sParams String sComment

Parameter | Description
iMsg | id of message to register, usually message name preceded by "get_" (function) or "msg_" (procedure)
sMsgName | name of the message, in quotes, usually message name preceded by "get_" (function) or "msg_" (procedure)
sParams | arguments to the message, preceded by each argument's type; should be the same as message declaration
sComment | message description; brief summary of what message does

Description

The RegisterInterface message is used to register a message (property, function, procedure) and make it available as a Call message within an ASP page.

Four parameters are required:

iMsgNumber

This is the message number. Normally this is passed as the message name preceded by get_ (for functions and retrieving properties), set_ (for setting properties) or msg_ (for procedures). For example:

get_SomeProperty or get_SomeFuntion
set_SomeProperty
msg_SomeProcedure

sMsgName

This is the name of the message that will be used in the ASP page. Normally you should make this the same name as the property (just put quotes around the property name).

"get_SomeProperty" or "get_SomeFunction"
"set_SomeProperty"
"msg_SomeProcedure"

sParams

This records the list of parameters used by the message. This is not required and is used for documentation purposes.

sComment

This records a description of the message. This is not required and is used for documentation purposes.

All Call messages must be registered before they can be used (unless you set the UseOpenEvalInterface_state property to true). For example, if you wanted to expose the get_FindByRecId message you would register it as follows:

Object SalesP_WBO is a WebBusinessProcess
    Object Salesp_DD is a Salesp_DataDictionary
        Send DefineAllExtendedFields
    End_Object  // Salesp_DD
    Set phMainDD to (Salesp_DD(Self))
    Send RegisterInterface get_DoRequestFindbyRecId ;
        "get_DoRequestFindbyRecId" "sFile iRecord" ;
        "Find by recnum for the passed file and record"
End_Object  // SalesP_WBO

Instead of needing to create a RegisterInterface message for each message you plan to register some messages have been combined into interface procedures allowing you to register a single set of interfaces at one time. Those predefined interface messages are:

Send RegisterStandardInterface
Send RegisterBasicErrorInterface
Send RegisterFullErrorInterface
Send RegisterDebugInterface
Send RegisterAutoEntryInterface

Typically, you will want to register the standard interface.

Object SalesP_WBO is a WebBusinessProcess
    Object Salesp_DD is a Salesp_DataDictionary
        Send DefineAllExtendedFields
    End_Object  // Salesp_DD
    Set phMainDD to (Salesp_DD(Self))
    Send RegisterStandardInterface
End_Object  // SalesP_WBO

If the same message is registered more than once, only the first registration is applied.

VDF Code

Send RegisterInterface get_DoRequestFindbyRecId ;
    "get_DoRequestFindbyRecId" "sFile iRecord" ;
    "Find by RecId (recnum) for the passed file and record"

Note:
This message has changed from WebApp revision 2.x. If you do not change the format of your message from the old format, you will get errors when run your application and these messages are sent.

The old format looked like this:
- Send RegisterInterface msg_SetHRefName "msg_SetHRefName" "sName" "Name to link for drill down report"
- Send RegisterInterface get_RunCustomerReport "get_RunCustomerReport" "iIndex iStart iMax" "Run report"

The new format looks like this:
- Send RegisterInterface msg_SetHRefName "msg_SetHRefName" "String sName" "Name to link for drill down report"
- Send RegisterInterface get_RunCustomerReport "get_RunCustomerReport" "Integer iIndex Integer iStart Integer iMax Returns integer" "Run report"

There are two ways to change your old message format to the new one:

Preferred:
Just load every WBO in the Studio and it will convert it for you.
Less Preferred:
Take your existing WBOs and search for all "Send RegisterInterface" and change this to "Send RegisterSimpleInterface".
As you have time, change these. The problem with this method is that the Studio will no longer automatically handle conversions for you if you change the message name.

Last Edited: November 21, 2004


cInternetSessionBusinessProcess [Procedure RegisterStandardInterface]

RegisterStandardInterface - cInternetSessionBusinessProcess

Type: Procedure

Parameters: No Parameters

Description

Last Edited: March 25, 2004


cInternetSessionBusinessProcess [Procedure RemoveInterface]

RemoveInterface - cInternetSessionBusinessProcess

When sent, removes any message from the Call interface

Type: Procedure

Parameters: Integer iMsg

Parameter | Description
iMsg | number of message to remove from registered interface for a WBO

Description

You can remove any message from the Call interface by sending the RemoveInterface message. This makes it easy to remove messages that were added as part of standard interface inclusions.

For example, you may want to include all messages from RegisterStandardInterface except Get_AutoReport. This could be removed as follows:

Object SalesP_WBO is a WebBusinessProcess
    Object Salesp_DD is a Salesp_DataDictionary
        Send DefineAllExtendedFields
    End_Object  // Salesp_DD
    Set phMainDD to (Salesp_DD(Self))
     Send RegisterStandardInterface
     Send RemoveInterface Get_AutoReport
End_Object  // SalesP_WBO

VDF Code

Send RemoveInterface iMsgNumber

Last Edited: September 11, 2003


cInternetSessionBusinessProcess [Procedure ReportAllErrors]

ReportAllErrors - cInternetSessionBusinessProcess

Generates a list of all errors that have occurred since this error queue was last cleared

Type: Procedure

Parameters: String sHdr

Parameter | Description
sHdr | The title of report

Description

ReportAllErrors generates a list of all errors that have occurred since this error queue was last cleared. All errors are output in HTML format and are sent to the current HTML page. If a title parameter is provided it will be displayed.

During some processes, Errors are placed in an error queue. These queued errors are then processed at a later time. ReportAllErrors will report the errors in the queue since it was last cleared. The error queue may be cleared by sending the ClearErrors message. Or, it can be cleared when you send the ErrorQueueStart message.

See Error Handling Messages for more on queued errors.

VDF Code

Send ReportAllErrors "All Errors in the Queue"

Script Code

This can be used at any point to report DataFlex errors to HTML.

<% WBO.Call "msg_ReportAllErrors", "All Errors so far" %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message or by sending the RegisterFullErrorInterface or RegisterBasicErrorInterface message.

To register ReportAllErrors send one of the following:

Send RegisterInterface  msg_ReportAllErrors "msg_ReportAllErrors " ;
    "sFile iRecord"  "This will report all the errors in the queue"

Send RegisterBasicErrorInterface

Send RegisterFullErrorInterface

Send RegisterStandardInterface

Last Edited: July 11, 2006


cInternetSessionBusinessProcess [Procedure ReportErrorItem]

ReportErrorItem - cInternetSessionBusinessProcess

Displays the error for iItem in the error queue

Type: Procedure

Parameters: No Parameters

Description

ReportErrorItem displays the error for iItem in the error queue. The error output is sent to the HTML page. This can be used in conjunction with ErrorCount to display all errors.

See Error Handling Messages for more on queued errors.

integer iErrs iloop
Get ItemCount to iErrs
If iErrs Begin
    Send WriteHtml "<hr>"
    Send WriteHtml "We have some Errors<br>"
    Decrement iErrs
    For iloop from 0 to iErrs
    Send ReportErrorItem iloop
    Loop
    Send WriteHtml "<hr>"
End

You can do a similar type of process within your ASP file.

<Script Language="VBSCRIPT" RunAt="Server">
Sub ShowErrors
    Errs = WBO.Call ("get_ErrorCount")
    If Errs > 0 Then
        Response.write ( "<hr>")
        Response.write ("We have some Errors<br>")
        For illop from 0 to (iErrs-1)
        WBO.Call "msg_ReportErrorItem", iloop
        Next
    End if
End Sub
</Script>

During some processes, errors are placed in an error queue. These queued errors are then processed at a later time.

VDF Code

Send ReportErrorItem

Script Code

<% WBO.Call "msg_ReportErrorItem", 2 %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the RegisterInterface message or by sending the RegisterFullErrorInterface message.

To register the ReportErrorItem send one of the following:

Send RegisterInterface  msg_ReportErrorItem "msg_ReportErrorItem" ;
    "sFile iRecord"  "This will display the iItem error message in the error queue"

Send RegisterFullErrorInterface

Last Edited: June 2, 2006


cInternetSessionBusinessProcess [Procedure ReportLastError]

ReportLastError - cInternetSessionBusinessProcess

Displays the last error in the error queue

Type: Procedure

Parameters: Integer bClearError

Parameter | Description
bClearError | determines whether to remove the error from the queue

Description

ReportLastError displays the last error in the error queue. The error output is sent to the HTML page. If bClearError is set to true, this error will be removed from the queue.

During some processes, errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

VDF Code

Send ReportLastError true

Script Code

<% WBO.Call "msg_ReportLastError", 1 %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the RegisterInterface message or by sending the RegisterFullErrorInterface message.

To register the ReportLastError send one of the following:

Send RegisterInterface  msg_ReportLastError "msg_ ReportLastError " ;
    "sFile iRecord"  "This will print the last error in the error queue"

Send RegisterFullErrorInterface

Last Edited: September 11, 2003


cInternetSessionBusinessProcess [Procedure SetChangedFields]

SetChangedFields - cInternetSessionBusinessProcess

Type: Procedure

Parameters: No Parameters

Description

Last Edited: July 2, 2003


cInternetSessionBusinessProcess [Procedure SetDDCurrentValue]

SetDDCurrentValue - cInternetSessionBusinessProcess

Type: Procedure

Parameters: Integer hMain Integer iFile Integer iField String sValue

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]
sValue | [ToDo: In Progress]

Description

Last Edited: July 2, 2003


cInternetSessionBusinessProcess [Procedure SetDDHndValue]

SetDDHndValue - cInternetSessionBusinessProcess

Type: Procedure

Parameters: Integer hMain Integer iFile Integer iField Integer iOption String sValue

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]
iOption | [ToDo: In Progress]
sValue | [ToDo: In Progress]

Description

Last Edited: July 2, 2003


cInternetSessionBusinessProcess [Procedure SetDDValue]

SetDDValue - cInternetSessionBusinessProcess

Directly sets the value of a file.field in the DataDictionary buffer

Type: Procedure

Parameters: String sFileField String sValue

Parameter | Description
sFileField | table.field to access
sValue | value to set sFileField to

Description

SetDDValue directly sets the value of a file.field in the DataDictionary buffer.

Example

// changes customer first and last name and saves customer record
Function ChangeCustomerName string sFirst string sLast returns Boolean
    Boolean bOk
    Send SetDDValue "Customer.First"  sFirst
    Send SetDDValue "Customer.Last"  sLast
    Get ddSave "Customer" to bOk  // does a save and validate
    function_return bOk
End_Function  // ChangeCustomerName

Last Edited: September 11, 2003


Properties for cInternetSessionBusinessProcess

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Main_dd | Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function | cDistributedBusinessProcess
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbAllErrorstoEventLog | Determines if errors will be placed in the event log |
pbAllErrorsToHtml | Determines if non-queued errors are sent |
pbAllErrorstoLocal | Determines if errors are directed to the standard VDF error handler |
pbAllowClear | Determines whether the WBO object will support the Clear operation | cRemoteEntryProcess
pbAllowDDUpdate | Determines whether the WBO object will support update operations to the DataDictionary | cRemoteEntryProcess
pbAllowDelete | Determines whether the WBO object will support the Delete operation | cRemoteEntryProcess
pbAllowFind | Determines whether the WBO object will support the Find operation | cRemoteEntryProcess
pbAllowSaveEdit | Determines whether the WBO object will support an edit Save operation | cRemoteEntryProcess
pbAllowSaveNew | Determines whether the WBO object will support a new Save operation | cRemoteEntryProcess
pbClearAfterSave | Determines what should happen after a successful save | cRemoteEntryProcess
pbClearDDOsOnDetach |  | cDistributedBusinessProcess
pbQueueErrors | Determines where errors are placed |
pbReportErrors | Suppresses the automatic generation of errors when set false | cRemoteEntryProcess
pbShowEntryError |  | cDistributedBusinessProcess
pbUseOpenEvalInterface | Determines if the Call interface should allow access to all WBO messages |
pbVerboseErrors | Determines how much information is presented when an HTML error is displayed |
peFieldMultiUser | Determines if the data submitted by a web application browser should report changes at the field level | cRemoteEntryProcess
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phREO_MainDD |  | cRemoteEntryProcess
piREO_OperationStatus |  | cRemoteEntryProcess
psDescription | Adds a description to the WBO object |


cInternetSessionBusinessProcess [Property pbAllErrorstoEventLog]

pbAllErrorstoEventLog - cInternetSessionBusinessProcess

Determines if errors will be placed in the event log

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When true, all errors will be placed in the event log. When false only errors that are explicitly sent to the event log (via LogErrorEvent or a non-queued error) appear in the log.

During some processes Errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

VDF Code

Set pbAllErrorsToEventLog to true
Get pbAllErrorsToEventLog to iState

Script Code

<% WBO.Call "set_pbAllErrorsToEventLog", 1 %>
<% iState=WBO.Call ("get_pbAllErrorsToEventLog") %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message or by sending the RegisterStandardInterface message.

To register pbAllErrorsToEventLog send one of the following:

Send RegisterInterface set_pbAllErrorsToEventLog "set_pbAllErrorsToEventLog" ;
    "sFile iRecord"  "This will determine if queued errors are logged "

Send RegisterDebugInterface

Send RegisterInterface get_pbAllErrorsToEventLog "get_pbAllErrorsToEventLog" ;
    "sFile iRecord" "This will retrieve the setting that determine if queued errors are logged "

Last Edited: January 16, 2006


cInternetSessionBusinessProcess [Property pbAllErrorsToHtml]

pbAllErrorsToHtml - cInternetSessionBusinessProcess

Determines if non-queued errors are sent

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Normally, non-queued errors (i.e., unexpected errors that would be generated on request messages like request_save & request_delete) are immediately reported back to the HTML file. The advantage being, that the developer will immediately see these errors and will be able to correct them before publishing the page. The disadvantage is that system errors (i.e., syntax errors) may appear in a published page - these errors will be meaningless to a user of the web page.

If this property is set to false, non-queued errors will not be sent to the browser. Queued errors are still sent to the browser under the assumption that the developer is controlling this as part of their HTML display process.

If you set this property to false, be careful. Program errors may be occurring that you do not know about. Make sure you check for these errors in your event log. It is advisable not to change this property and to make sure that your program is properly debugged before publishing it to the web.

If you do set this property to false then you also should be creating custom error messages and show errors next to the field that actually generate the error.

Note:This property is global to the entire web application. So, ensure that you set it to the same value (True of False) in all WBOs.

During some processes Errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

VDF Code

Set pbAllErrorsToHtml to false
Get pbAllErrorsToHtml to iState

Script Code

<% WBO.Call "set_pbAllErrorsToHtml, "false""%>
<% iMode=WBO.Call ("get_pbAllErrorsToHtml")%>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message or by sending the RegisterStandardInterface message.

To register pbAllErrorsToHtml send one of the following:

Send RegisterInterface set_pbAllErrorsToHtml "set_pbAllErrorsToHtml " ;
    "sFile iRecord"  "This will determine if non-queued errors will be sent to the browser "

Send RegisterDebuggingInterface

Send RegisterInterface get_pbAllErrorsToHtml "get_pbAllErrorsToHtml " ;
    "sFile iRecord"  "This will retrieve the setting that determine if non-queued errors will be sent to the browser "

Last Edited: January 16, 2006


cInternetSessionBusinessProcess [Property pbAllErrorstoLocal]

pbAllErrorstoLocal - cInternetSessionBusinessProcess

Determines if errors are directed to the standard VDF error handler

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If true, all errors are directed to the standard VDF error handler. This means they will appear as a message box on the server console and will wait for you to "OK" the message. Normally this is not desired, but it can be useful when you are debugging from the NT console. Errors are displayed when they occur (they are never queued).

Note: If you set this property and you do not have access to the NT console actually running your programs an error will cause your program to hang. It will actually be running, but it will be waiting for someone to press the "OK" button in the error message panel.

During some processes Errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

VDF Code

Set pbAllErrorsToLocal to true
Get pbAllErrorsToLocal to iState

Script Code

<% WBO.Call "set_pbAllErrorsToLocal" "true"%>
<% iState=WBO.Call ("get_pbAllErrorsToLocal")%>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message or by sending the RegisterStandardInterface message.

To register the pbAllErrorsToLocal send one of the following:

Send RegisterInterface set_pbAllErrorsToLocal "set_pbAllErrorsToLocal" ;
    "sFile iRecord"  "This will determine if errors are directed to the standard VDF error handle"

Send RegisterDebuggingInterface

Send RegisterInterface get_pbAllErrorsToLocal "get_pbAllErrorsToLocal" ;
    "sFile iRecord"  "This will retrieve the setting that determine if errors are directed to the standard VDF error handle"

Last Edited: January 16, 2006


cInternetSessionBusinessProcess [Property pbQueueErrors]

pbQueueErrors - cInternetSessionBusinessProcess

Determines where errors are placed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When set to true, errors are placed in an error queue and are not directly reported. This property should not be set directly. It should be controlled with the messages ErrorQueueStart and ErrorQueueEnd. For the standard processes (Save, Delete, Clear, and Find), the error queues will be started and stopped automatically.

See Error Handling Messages for more on queued errors.

VDF Code

Get pbQueueErrors to iMode

Script Code

<% iMode=WBO.Call "get_pbQueueErrors" %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message.

To register pbQueueErrors send:

Send RegisterInterface  get_pbReportErrors "get_pbReportErrors " ;
    "sFile iRecord"  "This will retrieve the setting that determines if errors are directly reported"

Last Edited: January 16, 2006


cInternetSessionBusinessProcess [Property pbUseOpenEvalInterface]

pbUseOpenEvalInterface - cInternetSessionBusinessProcess

Determines if the Call interface should allow access to all WBO messages

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The pbUseOpenEvalInterface property determines if the Call interface should allow access to all WBO messages. By default this is disabled (bState is false).

Normally, the Call requires that you register all messages to be used externally in script code. This allows the WBO designer to carefully control all external access to the WBO object.

The pbUseOpenEvalInterface allows you to bypass the formal interface and to access any message (property, function, procedure) that happens to be defined within your WBO. You should avoid setting this property to true. This open access method has been provided for two reasons:

* Enabling open access may be useful during design, prototyping and testing phases.

* Old WebApp programs only supported this open mode so this is provided for backwards compatibility (although we strongly encourage you to change your old programs and formally register the interfaces).

If you are planning on using this open interface, you must make sure that your program is compiled with symbols since message names are resolved using the Eval command. If you are not using an open interface (the suggested method) you can strip the symbols from your VDF application.

Call interfaces are registered by sending the RegisterInterface message.

VDF Code

Set pbUseOpenEvalInterface to True
Get pbUseOpenEvalInterface to iState

Last Edited: January 16, 2006


cInternetSessionBusinessProcess [Property pbVerboseErrors]

pbVerboseErrors - cInternetSessionBusinessProcess

Determines how much information is presented when an HTML error is displayed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbVerboseErrors determines how much information is presented when an HTML error is displayed. When false, a descriptive error is displayed. This information will be helpful to a user of your web program (i.e., a description of a validation error). When set to true, additional debug information is provided, that will be useful to a programmer debugging a problem. When true, the same error message is displayed along with the VDF Error number, line number, file and field number.

During some processes Errors are placed in an error queue. These queued errors are then processed at a later time.

See Error Handling Messages for more on queued errors.

VDF Code

Set pbVerboseErrors to true
Get pbVerboseErrros to iState

Script Code

<% WBO.Call "set_pbVerboseErrros" 1 %>
<% iMode=WBO.Call ("get_pbVerboseErrros") %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message or by sending the RegisterDebugInterface message.

To register pbVerboseErrrors send one of the following:

Send RegisterInterface set_pbVerboseErrros "set_pbVerboseErrros" ;
    "sFile iRecord"  "This will determine how much error information is displayed "

Send RegisterDebuggingInterface

Send RegisterInterface get_pbVerboseErrros "get_pbVerboseErrros" ;
    "sFile iRecord"  "This will retrieve the setting that determines how much error information is displayed "

Last Edited: January 16, 2006


cInternetSessionBusinessProcess [Property psDescription]

psDescription - cInternetSessionBusinessProcess

Adds a description to the WBO object

Type: Property

Access: Read/Write

Data Type: String

Description

The psDescription property is used to add a description to the WBO object. The WebApp object uses this information when it gathers information about its WBOs. This is used for documentation purposes.

VDF Code

Set psDescription to "This describes this WBO"
Get psDescription to sDesc

Last Edited: September 11, 2003


Visual DataFlex Windows Application and Web Application Class Library (Public Classes)

Show All Classes Windows Application Library Web Application Library

A

AboutDialog | Used to create an About Dialog in an application
Array | Used to create a collection of values which are stored and accessed via item numbers

B

BaseXMLDomParseError | Provides support reporting parsing errors in an XML document
BasicPanel | Provides a top-level window for applications that is independent of all other windows
BasicReport | Supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it
BitmapContainer | Provides a means for enabling users to select bitmap graphic files to display in programs
Broadcaster | Provides grouping and message-relaying services for a set of objects
BusinessProcess | Contains and executes the statements to perform a batch process on an application's database tables
Button | To create visual representations of keys or buttons that, when pressed by users, produce a specific action with an immediate response

C

cAnimation | Displays an AVI animation clip
cApplication | Encapsulates methods and properties that are essential to the running of your application
cAutoWebReport | Used to create quick prototype reports based around the main file of a cWebBusinessProcess object
cClientWebService | The base class for all client web-services
cCLIHandler | Implements functionality common for the CLI based Connectivity Kits (SQL Server, DB2 and ODBC)
cCollection | Maintains a collection of object-handles
cComActiveXControl | Generates wrapper classes for imported ActiveX controls
cComDbActiveXControl | Generates data-aware wrapper classes for imported ActiveX controls
cComDocumentObject | Generates wrapper classes for imported Embedded Document objects
cCommandLine | Encapsulates access to the command-line of the running program
cComStdFont | OLE conventions implement fonts as Automation objects that contain the properties of the font
cComStdPicture | OLE conventions implement pictures as Automation objects that contain the properties of the picture
cCrystal | Enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports
cCrystal_ICRViewerSelectionEvents | In Progress...
cCrystalActiveXReportViewer | COM object used to access the ActiveXReportViewer object in the Crystal RDC object model
cCrystalApplication | COM object used to access the Application object in the Crystal RDC object model
cCrystalArea | COM object used to access the Area object in the Crystal RDC object model
cCrystalAreas | COM object used to access the Areas object in the Crystal RDC object model
cCrystalBlobFieldObject | COM object used to access the BlobFieldObject object in the Crystal RDC object model
cCrystalBoxObject | COM object used to access the BoxObject object in the Crystal RDC object model
cCrystalConnectionProperties | COM object used to access the ConnectionProperties object in the Crystal RDC object model
cCrystalConnectionProperty | COM object used to access the ConnectionProperty object in the Crystal RDC object model
cCrystalCRCrystalReportViewerViewInfo | COM object used to access the CRCrystalReportViewerViewInfo object in the Crystal RDC object model
cCrystalCrossTabGroup | COM object used to access the CrossTabGroup object in the Crystal RDC object model
cCrystalCrossTabGroups | COM object used to access the CrossTabGroups object in the Crystal RDC object model
cCrystalCrossTabObject | COM object used to access the CrossTabObject object in the Crystal RDC object model
cCrystalCRVEventInfo | COM object used to access the CRVEventInfo object in the Crystal RDC object model
cCrystalCRVField | COM object used to access the CRVField object in the Crystal RDC object model
cCrystalCRVFields | COM object used to access the CRVFields object in the Crystal RDC object model
cCrystalCRVParameterPromptRuntimeOM | COM object used to access the CRVParameterPromptRuntimeOM object in the Crystal RDC object model
cCrystalCRVSelectionItem | COM object used to access the CRVSelectionItem object in the Crystal RDC object model
cCrystalCRVSelectionItems | COM object used to access the CRVSelectionItems object in the Crystal RDC object model
cCrystalCRVTrackCursorInfo | COM object used to access the CRVTrackCursorInfo object in the Crystal RDC object model
cCrystalCrystalComObject | COM object used to access the CrystalComObject object in the Crystal RDC object model
cCrystalCSFontDescription | COM object used to access the CSFontDescription object in the Crystal RDC object model
cCrystalDatabase | COM object used to access the Database object in the Crystal RDC object model
cCrystalDatabaseFieldDefinition | COM object used to access the DatabaseFieldDefinition object in the Crystal RDC object model
cCrystalDatabaseFieldDefinitions | COM object used to access the DatabaseFieldDefinitions object in the Crystal RDC object model
cCrystalDatabaseTable | COM object used to access the DatabaseTable object in the Crystal RDC object model
cCrystalDatabaseTables | COM object used to access the DatabaseTables object in the Crystal RDC object model
cCrystalExportOptions | COM object used to access the ExportOptions object in the Crystal RDC object model
cCrystalFieldDefinitions | COM object used to access the FieldDefinitions object in the Crystal RDC object model
cCrystalFieldElement | COM object used to access the FieldElement object in the Crystal RDC object model
cCrystalFieldElements | COM object used to access the FieldElements object in the Crystal RDC object model
cCrystalFieldMappingData | COM object used to access the FieldMappingData object in the Crystal RDC object model
cCrystalFieldObject | COM object used to access the FieldObject object in the Crystal RDC object model
cCrystalFormattingInfo | COM object used to access the FormattingInfo object in the Crystal RDC object model
cCrystalFormulaFieldDefinition | COM object used to access the FormulaFieldDefinition object in the Crystal RDC object model
cCrystalFormulaFieldDefinitions | COM object used to access the FormulaFieldDefinitions object in the Crystal RDC object model
cCrystalGraphObject | COM object used to access the GraphObject object in the Crystal RDC object model
cCrystalGroupNameFieldDefinition | COM object used to access the GroupNameFieldDefinition object in the Crystal RDC object model
cCrystalGroupNameFieldDefinitions | COM object used to access the GroupNameFieldDefinitions object in the Crystal RDC object model
cCrystalLineObject | COM object used to access the LineObject object in the Crystal RDC object model
cCrystalMapObject | COM object used to access the MapObject object in the Crystal RDC object model
cCrystalObjectSummaryFieldDefinitions | COM object used to access the ObjectSummaryFieldDefinitions object in the Crystal RDC object model
cCrystalOlapGridObject | COM object used to access the OlapGridObject object in the Crystal RDC object model
cCrystalOleObject | COM object used to access the OleObject object in the Crystal RDC object model
cCrystalPage | COM object used to access the Page object in the Crystal RDC object model
cCrystalPageEngine | COM object used to access the PageEngine object in the Crystal RDC object model
cCrystalPageGenerator | COM object used to access the PageGenerator object in the Crystal RDC object model
cCrystalPages | COM object used to access the Pages object in the Crystal RDC object model
cCrystalParameterFieldDefinition | COM object used to access the ParameterFieldDefinition object in the Crystal RDC object model
cCrystalParameterFieldDefinitions | COM object used to access the ParameterFieldDefinitions object in the Crystal RDC object model
cCrystalParameterValue | COM object used to access the ParameterValue object in the Crystal RDC object model
cCrystalParameterValueInfo | COM object used to access the ParameterValueInfo object in the Crystal RDC object model
cCrystalParameterValueInfos | COM object used to access the ParameterValueInfos object in the Crystal RDC object model
cCrystalParameterValues | COM object used to access the ParameterValues object in the Crystal RDC object model
cCrystalPreview | This class acts as a container for the Crystal COM object which the Crystal Reports report is displayed within
cCrystalPrintingStatus | COM object used to access the PrintingStatus object in the Crystal RDC object model
cCrystalReport | Provides a COM connection to a Crystal Reports report
cCrystalReportAlert | COM object used to access the ReportAlert object in the Crystal RDC object model
cCrystalReportAlertInstance | COM object used to access the ReportAlertInstance object in the Crystal RDC object model
cCrystalReportAlertInstances | COM object used to access the ReportAlertInstances object in the Crystal RDC object model
cCrystalReportAlerts | COM object used to access the ReportAlerts object in the Crystal RDC object model
cCrystalReportObjects | COM object used to access the ReportObjects object in the Crystal RDC object model
cCrystalReportSourceRouter | COM object used to access the ReportSourceRouter object in the Crystal RDC object model
cCrystalRunningTotalFieldDefinition | COM object used to access the RunningTotalFieldDefinition object in the Crystal RDC object model
cCrystalRunningTotalFieldDefinitions | COM object used to access the RunningTotalFieldDefinitions object in the Crystal RDC object model
cCrystalSection | COM object used to access the Section object in the Crystal RDC object model
cCrystalSections | COM object used to access the Sections object in the Crystal RDC object model
cCrystalSortField | COM object used to access the SortField object in the Crystal RDC object model
cCrystalSortFields | COM object used to access the SortFields object in the Crystal RDC object model
cCrystalSpecialVarFieldDefinition | COM object used to access the SpecialVarFieldDefinition object in the Crystal RDC object model
cCrystalSQLExpressionFieldDefinition | COM object used to access the SQLExpressionFieldDefinition object in the Crystal RDC object model
cCrystalSQLExpressionFieldDefinitions | COM object used to access the SQLExpressionFieldDefinitions object in the Crystal RDC object model
cCrystalSubreportLink | COM object used to access the SubreportLink object in the Crystal RDC object model
cCrystalSubreportLinks | COM object used to access the SubreportLinks object in the Crystal RDC object model
cCrystalSubreportObject | COM object used to access the SubreportObject object in the Crystal RDC object model
cCrystalSummaryFieldDefinition | COM object used to access the SummaryFieldDefinition object in the Crystal RDC object model
cCrystalSummaryFieldDefinitions | COM object used to access the SummaryFieldDefinitions object in the Crystal RDC object model
cCrystalTableLink | COM object used to access the TableLink object in the Crystal RDC object model
cCrystalTableLinks | COM object used to access the TableLinks object in the Crystal RDC object model
cCrystalTableQualifiers | COM object used to access the TableQualifiers object in the Crystal RDC object model
cCrystalTextObject | COM object used to access the TextObject object in the Crystal RDC object model
cDB2Handler | Implements functionality specific to DB2.
cDbRichEdit | Allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table
cDbTextEdit | Allows the user to enter and edit text connected to a column in a database table
cDesktop | Used to create the desktop object which contains all other objects within an application
cDFBtrDrvHandler | In Progress...
cFTPTransfer | Implements FTP client-side operations
CheckBox | To enable users to select items (or options) in applications
cHtmlHelp | Used to provide access to an HTML-based help system
cHttpTransfer | Implements HTTP client-side operations
cImageList | A collection of images of the same size, each of which can be referred to by its index
cIniFile | Provides access to Windows INI (configuration) files
ClientArea | Provides an area on the screen to contain all of an application's views
cMapiHandler | Consists of functions for sending mail, reading received mail and sending documents
cMSSQLHandler | Implements functionality specific to SQL Server.
cObject | The fundamental class from which all classes are derived
cODBCHandler | Implements functionality specific to ODBC.
CodePickList | Allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets
CodeValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
ColorDialog | Provides an interface to the Windows standard Color dialog
ComboForm | Combines the functionality of the form class with that of a standard Windows drop-down list
Container | Creates non-visual container objects
Container3d | This class creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional (3-D) appearance.
cProcessStatusPanel | Supports a visual object to displayed by long-running processes that may be unattended to report errors that arise in the job
cProgressBar | Indicates the progress within a range
cRegistry | Provides access to the Windows system Registry
cRichEdit | Allows the user to enter and edit RTF (rich-text format) text
CrystalReport | Enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports
cSQLConnection | Handles all Embedded SQL operations for one connection.
cSQLHandleManager | Base entry point for all Embedded SQL operations.
cSQLStatement | Handles all Embedded SQL operation for one statement. The statement is the most used entity in any SQL environment.
cStatusBar | A control, usually placed at the bottom of a window, that is divided into "panes"
cStatusPane | Represents a single pane of a cStatusBar
cTableColumnFetchHelper | Allows creation of a helper object that makes it easy to enable or disable Selected Column Fetching (SCF) for a large number of tables.
cTextEdit | Allows the user to enter and edit text
cToolbar | A control, usually placed at the top of a window, that contains buttons which act as shortcuts to frequently used functionality
cToolbarButton | Each instance represents a single button of a toolbar
CursorShape | Enables programs to change the appearance of the Windows cursor for any of various purposes
cVersionInfo | Contains information relating to the application's embedded Version Information resources
cWebApp | Creates a web application wrapper object, which is used to contain all Web Browser Objects (WBOs) and Web Service Objects (WSOs)
cWebBusinessProcess | Creates Web Browser Process objects - the basic component of all Browser based Web Applications
cWebReport | Creates HTML reports to be used with WebApp Server
cWebService | Creates Web Service Objects - the basic component of all web-service based Web Applications
cWinReport2 | Provides most of the capabilities of the BasicReport class and provides the ability to use WinPrint2 to provide more-graphical reports
cWmlreport | A subclass of sWebReport that is customized for WML reports
cWorkspace | Encapsulates access to a Workspace file to set the program's filelist and DFPATH
cXMLDOMAttribute | XML class for handling an attribute node
cXMLDOMCDATASection | XML class for handling CDATA Section nodes
cXMLDOMComment | XML class for handling Comment nodes
cXMLDOMDocument | Provides the Interface to the root node of an XML document
cXMLDOMDocumentFragment | XML class for handling Document Fragments
cXMLDOMDocumentType | Contains information associated with the document type declaration
cXMLDOMElement | XML class for handling an element node
cXMLDOMEntity | XML class for handling an Entity node
cXMLDOMEntityReference | XML class for handling Entity Reference nodes
cXMLDOMNamedNodeMap | XML class for handling Named Node map (collections of attributes)
cXMLDOMNode | Creates a generic XML DOM Node object
cXMLDOMNodeList | Supports iteration through the node collection
cXMLDOMNotation | XML class for handling a Notation node
cXMLDOMProcessingInstruction | XML class for handling Processing Instruction (PI) nodes
cXMLDOMTextNode | XML class for handling a text node
cXmlHttpTransfer | Provides an easy mechanism for sending and receiving XML documents via Http.

D

DataDictionary | This class provides the main method for accessing databases in Visual DataFlex programs.
dbBitmap | Provides for automatic display of bitmap graphics by addressing a database field with an entry_display message
dbCheckbox | To combine the functionality of dbForm and CheckBox allowing a data-entry element to be represented in a checkbox format
dbCodeComboForm | Provides combo objects that automatically use a central codes database file such as CODEMAST
dbComboForm | Provides general-purpose comboform DEOs
dbContainer | Groups together data-entry objects within an invisible container
dbContainer3d | Creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional appearance
dbEdit | (Obsolete) Supports data entry for memo fields or sequential ASCII files from DEOs
dbFloatingPopupMenu | Creates standard data-aware (DEO) floating popup menus
dbForm | To support data entry through an entry_item to one field of one logical record at a time
dbGrid | Enables users to view and edit a scrolling, multi-column list of field values from a database file
dbGroup | Creates visual group container objects and by default, provides a gray background with a rectangular 3 D line border with a text label embedded in the top left edge
dbList | Enables users to select one or more values from a list of choices
dbModalPanel | Provides a modal container for selection lists (dblist) and other DEOs
dbRadioContainer | Provides all of the functionality of a dbRadioGroup within an invisible container
dbRadioGroup | Groups multiple radio objects in a visible object, providing selection of no more than one at a time
dbSpinForm | Provides an entry form that users can edit that contains an integer or date that can be driven through a range with buttons
dbTabDialog | Contains and provides coordinated access to dbTabPage objects
dbTabDialogView | Contains and provides coordinated access to dbTabView objects
dbTabPage | Used when all of the pages in a view share the same DDO structure
dbTabView | Used when each tab-page will contain a stand-alone view with its own DDO structure
dbTrackBar | Enables applications to provide users with a data aware visual control to 'slide' through a range of values
dbView | Creates view objects
DEOPopupMenu | Creates pulldown objects that disables messages not sent to DEOs
DescriptionValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
DFBaseRichEdit | In Progress...
DFBaseTextEdit | In Progress...
DFTimer | DFTimer objects can be used to trigger an event after a certain amount of time has passed.
Dialog | Creates non-MDI-child dialog objects

E

Edit | (Obsolete) Allows users to enter multiple lines of text
Entry | The basis of more-sophisticated data-entry classes,
ErrorSystem | Supports Visual DataFlex's interactive interface for all errors generated in a program

F

FileValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
FloatingPopupMenu | Creates standard floating popup menus (context menus)
FontDialog | Permits users to select fonts
Form | To display and accept keyboard input
FormFloatingPopupMenu | Creates standard floating popup menus for Windows forms (context menus)

G

Grid | A basic class which should be used for creating multi-row, multi-column entry lists
Group | To create visual group container objects with (by default) a gray background with a rectangular 3 D line border with a text label embedded in the top left edge

H

HelpSystem Used to create help object for a Windows Help Files

L

LineControl | Creates divider lines on a container most-often to create a 3 D horizontal dividing line
List | Manipulates dynamic lists of information

M

MdiClientArea | Provides low-level support for an MDI-style client area
MenuBar | Provides the capabilities of a standard GUI menu bar
Mixin | Provides a method for mixing additional skills into a class
ModalPanel | Creates modal popup panels

O

OpenDialog Provides access to the Windows file-open dialog

P

Panel | Provides a top-level window for applications that is independent of all other windows
PopupMenu | Displayed whenever a choice is made from a menu bar and from certain choices made from an already-displayed popup menu
PrintDialog | A wrapper for the Windows Print dialog box used by the CrystalReport class
Prototype_Entry | Helper Class used by DEO Grid classes (dbGrids and dbLists) to define row information

R

Radio | Provides visual selection icons that are used in groups exclusively within radio containers
RadioButton | An intermediate that provides support for stand-alone radio buttons
RadioContainer | Groups multiple Radio objects in a non-visible object, providing selection of no more than one at a tim
RadioGroup | Groups multiple Radio objects in a visible group object, providing selection of no more than one at a time, and navigation among the objects
ReportPanel | Provides a modal popup user interface for running reports
ReportView | Provides a non-modal user interface selected from a menu choice for running reports

S

SaveAsDialog | Provides access to the Windows file-save dialog
Set | Assembles and maintains a set of unique values
ShapeControl | Demonstrates Visual DataFlex communicating with the Windows API
SpinForm | Adds a spin button to a Form
SplashScreenPanel | Provides a way to display a splash screen in your application
StatusAsciiLog | Used for logging status and error reports from unattended (batch) processes to an ascii file
StatusdbLog | Used for logging status and error reports from unattended (batch) processes to a database file
StatusPanel | (Obsolete) Supports a visual object to displayed by long-running processes that may be unattended to report errors that arise in the job
SystemMenu | Class used to create system menus

T

TabDialog | Created by creating a TabDialog object and then creating TabPage objects inside it
TabPage | Creates a page within a tab-dialog container
TextBox | Enables placing static text strings on the display
ToolPanel | Creates tool panels - panels that are not listed on the Windows task list
TrackBar | Enables applications to provide users with a visual control to 'slide' through a range of values
TreeView | Provides a control that displays a hierarchical list of items, such as the headings in a document, the entries in an index, or the files and directories on a disk

V

ValidationList | Provides a default interface object for validation tables used as prompt objects
ValidationTable | Provides a one-column table of validation data for validation lists used with DataDictionary objects.
View | Provides a "basic" (non DEO) MDI view
ViewPopupMenu | Creates popup menu objects that will redirect item messages to the MDI container area object

W

WinReport (Obsolete) Provides most of the capabilities of the BasicReport class and provides the ability to use WinPrint to provide more-graphical reports


Visual DataFlex Web Application Class Library (Public Classes)

Show All Classes Combined Application Library Windows Application Library

A

Array Used to create a collection of values which are stored and accessed via item numbers

B

BaseXMLDomParseError | Provides support reporting parsing errors in an XML document
Broadcaster | Provides grouping and message-relaying services for a set of objects
BusinessProcess | Contains and executes the statements to perform a batch process on an application's database tables

C

cApplication | Encapsulates methods and properties that are essential to the running of your application
cAutoWebReport | Used to create quick prototype reports based around the main file of a cWebBusinessProcess object
cClientWebService | The base class for all client web-services
cCLIHandler | Implements functionality common for the CLI based Connectivity Kits (SQL Server, DB2 and ODBC)
cCollection | Maintains a collection of object-handles
cCommandLine | Encapsulates access to the command-line of the running program
cComStdFont | OLE conventions implement fonts as Automation objects that contain the properties of the font
cComStdPicture | OLE conventions implement pictures as Automation objects that contain the properties of the picture
cCrystal | Enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports
cCrystal_ICRViewerSelectionEvents | In Progress...
cCrystalApplication | COM object used to access the Application object in the Crystal RDC object model
cCrystalArea | COM object used to access the Area object in the Crystal RDC object model
cCrystalAreas | COM object used to access the Areas object in the Crystal RDC object model
cCrystalBlobFieldObject | COM object used to access the BlobFieldObject object in the Crystal RDC object model
cCrystalBoxObject | COM object used to access the BoxObject object in the Crystal RDC object model
cCrystalConnectionProperties | COM object used to access the ConnectionProperties object in the Crystal RDC object model
cCrystalConnectionProperty | COM object used to access the ConnectionProperty object in the Crystal RDC object model
cCrystalCRCrystalReportViewerViewInfo | COM object used to access the CRCrystalReportViewerViewInfo object in the Crystal RDC object model
cCrystalCrossTabGroup | COM object used to access the CrossTabGroup object in the Crystal RDC object model
cCrystalCrossTabGroups | COM object used to access the CrossTabGroups object in the Crystal RDC object model
cCrystalCrossTabObject | COM object used to access the CrossTabObject object in the Crystal RDC object model
cCrystalCRVEventInfo | COM object used to access the CRVEventInfo object in the Crystal RDC object model
cCrystalCRVField | COM object used to access the CRVField object in the Crystal RDC object model
cCrystalCRVFields | COM object used to access the CRVFields object in the Crystal RDC object model
cCrystalCRVParameterPromptRuntimeOM | COM object used to access the CRVParameterPromptRuntimeOM object in the Crystal RDC object model
cCrystalCRVSelectionItem | COM object used to access the CRVSelectionItem object in the Crystal RDC object model
cCrystalCRVSelectionItems | COM object used to access the CRVSelectionItems object in the Crystal RDC object model
cCrystalCRVTrackCursorInfo | COM object used to access the CRVTrackCursorInfo object in the Crystal RDC object model
cCrystalCrystalComObject | COM object used to access the CrystalComObject object in the Crystal RDC object model
cCrystalCSFontDescription | COM object used to access the CSFontDescription object in the Crystal RDC object model
cCrystalDatabase | COM object used to access the Database object in the Crystal RDC object model
cCrystalDatabaseFieldDefinition | COM object used to access the DatabaseFieldDefinition object in the Crystal RDC object model
cCrystalDatabaseFieldDefinitions | COM object used to access the DatabaseFieldDefinitions object in the Crystal RDC object model
cCrystalDatabaseTable | COM object used to access the DatabaseTable object in the Crystal RDC object model
cCrystalDatabaseTables | COM object used to access the DatabaseTables object in the Crystal RDC object model
cCrystalExportOptions | COM object used to access the ExportOptions object in the Crystal RDC object model
cCrystalFieldDefinitions | COM object used to access the FieldDefinitions object in the Crystal RDC object model
cCrystalFieldElement | COM object used to access the FieldElement object in the Crystal RDC object model
cCrystalFieldElements | COM object used to access the FieldElements object in the Crystal RDC object model
cCrystalFieldMappingData | COM object used to access the FieldMappingData object in the Crystal RDC object model
cCrystalFieldObject | COM object used to access the FieldObject object in the Crystal RDC object model
cCrystalFormattingInfo | COM object used to access the FormattingInfo object in the Crystal RDC object model
cCrystalFormulaFieldDefinition | COM object used to access the FormulaFieldDefinition object in the Crystal RDC object model
cCrystalFormulaFieldDefinitions | COM object used to access the FormulaFieldDefinitions object in the Crystal RDC object model
cCrystalGraphObject | COM object used to access the GraphObject object in the Crystal RDC object model
cCrystalGroupNameFieldDefinition | COM object used to access the GroupNameFieldDefinition object in the Crystal RDC object model
cCrystalGroupNameFieldDefinitions | COM object used to access the GroupNameFieldDefinitions object in the Crystal RDC object model
cCrystalLineObject | COM object used to access the LineObject object in the Crystal RDC object model
cCrystalMapObject | COM object used to access the MapObject object in the Crystal RDC object model
cCrystalObjectSummaryFieldDefinitions | COM object used to access the ObjectSummaryFieldDefinitions object in the Crystal RDC object model
cCrystalOlapGridObject | COM object used to access the OlapGridObject object in the Crystal RDC object model
cCrystalOleObject | COM object used to access the OleObject object in the Crystal RDC object model
cCrystalPage | COM object used to access the Page object in the Crystal RDC object model
cCrystalPageEngine | COM object used to access the PageEngine object in the Crystal RDC object model
cCrystalPageGenerator | COM object used to access the PageGenerator object in the Crystal RDC object model
cCrystalPages | COM object used to access the Pages object in the Crystal RDC object model
cCrystalParameterFieldDefinition | COM object used to access the ParameterFieldDefinition object in the Crystal RDC object model
cCrystalParameterFieldDefinitions | COM object used to access the ParameterFieldDefinitions object in the Crystal RDC object model
cCrystalParameterValue | COM object used to access the ParameterValue object in the Crystal RDC object model
cCrystalParameterValueInfo | COM object used to access the ParameterValueInfo object in the Crystal RDC object model
cCrystalParameterValueInfos | COM object used to access the ParameterValueInfos object in the Crystal RDC object model
cCrystalParameterValues | COM object used to access the ParameterValues object in the Crystal RDC object model
cCrystalPrintingStatus | COM object used to access the PrintingStatus object in the Crystal RDC object model
cCrystalReport | Provides a COM connection to a Crystal Reports report
cCrystalReportAlert | COM object used to access the ReportAlert object in the Crystal RDC object model
cCrystalReportAlertInstance | COM object used to access the ReportAlertInstance object in the Crystal RDC object model
cCrystalReportAlertInstances | COM object used to access the ReportAlertInstances object in the Crystal RDC object model
cCrystalReportAlerts | COM object used to access the ReportAlerts object in the Crystal RDC object model
cCrystalReportObjects | COM object used to access the ReportObjects object in the Crystal RDC object model
cCrystalReportSourceRouter | COM object used to access the ReportSourceRouter object in the Crystal RDC object model
cCrystalRunningTotalFieldDefinition | COM object used to access the RunningTotalFieldDefinition object in the Crystal RDC object model
cCrystalRunningTotalFieldDefinitions | COM object used to access the RunningTotalFieldDefinitions object in the Crystal RDC object model
cCrystalSection | COM object used to access the Section object in the Crystal RDC object model
cCrystalSections | COM object used to access the Sections object in the Crystal RDC object model
cCrystalSortField | COM object used to access the SortField object in the Crystal RDC object model
cCrystalSortFields | COM object used to access the SortFields object in the Crystal RDC object model
cCrystalSpecialVarFieldDefinition | COM object used to access the SpecialVarFieldDefinition object in the Crystal RDC object model
cCrystalSQLExpressionFieldDefinition | COM object used to access the SQLExpressionFieldDefinition object in the Crystal RDC object model
cCrystalSQLExpressionFieldDefinitions | COM object used to access the SQLExpressionFieldDefinitions object in the Crystal RDC object model
cCrystalSubreportLink | COM object used to access the SubreportLink object in the Crystal RDC object model
cCrystalSubreportLinks | COM object used to access the SubreportLinks object in the Crystal RDC object model
cCrystalSubreportObject | COM object used to access the SubreportObject object in the Crystal RDC object model
cCrystalSummaryFieldDefinition | COM object used to access the SummaryFieldDefinition object in the Crystal RDC object model
cCrystalSummaryFieldDefinitions | COM object used to access the SummaryFieldDefinitions object in the Crystal RDC object model
cCrystalTableLink | COM object used to access the TableLink object in the Crystal RDC object model
cCrystalTableLinks | COM object used to access the TableLinks object in the Crystal RDC object model
cCrystalTableQualifiers | COM object used to access the TableQualifiers object in the Crystal RDC object model
cCrystalTextObject | COM object used to access the TextObject object in the Crystal RDC object model
cDB2Handler | Implements functionality specific to DB2.
cDesktop | Used to create the desktop object which contains all other objects within an application
cDFBtrDrvHandler | In Progress...
cFTPTransfer | Implements FTP client-side operations
cHtmlHelp | Used to provide access to an HTML-based help system
cHttpTransfer | Implements HTTP client-side operations
cImageList | A collection of images of the same size, each of which can be referred to by its index
cIniFile | Provides access to Windows INI (configuration) files
cMapiHandler | Consists of functions for sending mail, reading received mail and sending documents
cMSSQLHandler | Implements functionality specific to SQL Server.
cObject | The fundamental class from which all classes are derived
cODBCHandler | Implements functionality specific to ODBC.
CodeValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
cRegistry | Provides access to the Windows system Registry
cSQLConnection | Handles all Embedded SQL operations for one connection.
cSQLHandleManager | Base entry point for all Embedded SQL operations.
cSQLStatement | Handles all Embedded SQL operation for one statement. The statement is the most used entity in any SQL environment.
cTableColumnFetchHelper | Allows creation of a helper object that makes it easy to enable or disable Selected Column Fetching (SCF) for a large number of tables.
cVersionInfo | Contains information relating to the application's embedded Version Information resources
cWebApp | Creates a web application wrapper object, which is used to contain all Web Browser Objects (WBOs) and Web Service Objects (WSOs)
cWebBusinessProcess | Creates Web Browser Process objects - the basic component of all Browser based Web Applications
cWebReport | Creates HTML reports to be used with WebApp Server
cWebService | Creates Web Service Objects - the basic component of all web-service based Web Applications
cWmlreport | A subclass of sWebReport that is customized for WML reports
cWorkspace | Encapsulates access to a Workspace file to set the program's filelist and DFPATH
cXMLDOMAttribute | XML class for handling an attribute node
cXMLDOMCDATASection | XML class for handling CDATA Section nodes
cXMLDOMComment | XML class for handling Comment nodes
cXMLDOMDocument | Provides the Interface to the root node of an XML document
cXMLDOMDocumentFragment | XML class for handling Document Fragments
cXMLDOMDocumentType | Contains information associated with the document type declaration
cXMLDOMElement | XML class for handling an element node
cXMLDOMEntity | XML class for handling an Entity node
cXMLDOMEntityReference | XML class for handling Entity Reference nodes
cXMLDOMNamedNodeMap | XML class for handling Named Node map (collections of attributes)
cXMLDOMNode | Creates a generic XML DOM Node object
cXMLDOMNodeList | Supports iteration through the node collection
cXMLDOMNotation | XML class for handling a Notation node
cXMLDOMProcessingInstruction | XML class for handling Processing Instruction (PI) nodes
cXMLDOMTextNode | XML class for handling a text node
cXmlHttpTransfer | Provides an easy mechanism for sending and receiving XML documents via Http.

D

DataDictionary | This class provides the main method for accessing databases in Visual DataFlex programs.
DescriptionValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.

E

ErrorSystem Supports Visual DataFlex's interactive interface for all errors generated in a program

F

FileValidationTable Provides a two-column table of validation data for validation lists used with DataDictionary objects.

M

Mixin Provides a method for mixing additional skills into a class

S

Set | Assembles and maintains a set of unique values
StatusAsciiLog | Used for logging status and error reports from unattended (batch) processes to an ascii file
StatusdbLog | Used for logging status and error reports from unattended (batch) processes to a database file

V

ValidationTable Provides a one-column table of validation data for validation lists used with DataDictionary objects.


Visual DataFlex Windows Application Class Library (Public Classes)

Show All Classes Combined Application Library Web Application Library

A

AboutDialog | Used to create an About Dialog in an application
Array | Used to create a collection of values which are stored and accessed via item numbers

B

BaseXMLDomParseError | Provides support reporting parsing errors in an XML document
BasicPanel | Provides a top-level window for applications that is independent of all other windows
BasicReport | Supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it
BitmapContainer | Provides a means for enabling users to select bitmap graphic files to display in programs
Broadcaster | Provides grouping and message-relaying services for a set of objects
BusinessProcess | Contains and executes the statements to perform a batch process on an application's database tables
Button | To create visual representations of keys or buttons that, when pressed by users, produce a specific action with an immediate response

C

cAnimation | Displays an AVI animation clip
cApplication | Encapsulates methods and properties that are essential to the running of your application
cClientWebService | The base class for all client web-services
cCLIHandler | Implements functionality common for the CLI based Connectivity Kits (SQL Server, DB2 and ODBC)
cCollection | Maintains a collection of object-handles
cComActiveXControl | Generates wrapper classes for imported ActiveX controls
cComDbActiveXControl | Generates data-aware wrapper classes for imported ActiveX controls
cComDocumentObject | Generates wrapper classes for imported Embedded Document objects
cCommandLine | Encapsulates access to the command-line of the running program
cComStdFont | OLE conventions implement fonts as Automation objects that contain the properties of the font
cComStdPicture | OLE conventions implement pictures as Automation objects that contain the properties of the picture
cCrystal | Enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports
cCrystal_ICRViewerSelectionEvents | In Progress...
cCrystalActiveXReportViewer | COM object used to access the ActiveXReportViewer object in the Crystal RDC object model
cCrystalApplication | COM object used to access the Application object in the Crystal RDC object model
cCrystalArea | COM object used to access the Area object in the Crystal RDC object model
cCrystalAreas | COM object used to access the Areas object in the Crystal RDC object model
cCrystalBlobFieldObject | COM object used to access the BlobFieldObject object in the Crystal RDC object model
cCrystalBoxObject | COM object used to access the BoxObject object in the Crystal RDC object model
cCrystalConnectionProperties | COM object used to access the ConnectionProperties object in the Crystal RDC object model
cCrystalConnectionProperty | COM object used to access the ConnectionProperty object in the Crystal RDC object model
cCrystalCRCrystalReportViewerViewInfo | COM object used to access the CRCrystalReportViewerViewInfo object in the Crystal RDC object model
cCrystalCrossTabGroup | COM object used to access the CrossTabGroup object in the Crystal RDC object model
cCrystalCrossTabGroups | COM object used to access the CrossTabGroups object in the Crystal RDC object model
cCrystalCrossTabObject | COM object used to access the CrossTabObject object in the Crystal RDC object model
cCrystalCRVEventInfo | COM object used to access the CRVEventInfo object in the Crystal RDC object model
cCrystalCRVField | COM object used to access the CRVField object in the Crystal RDC object model
cCrystalCRVFields | COM object used to access the CRVFields object in the Crystal RDC object model
cCrystalCRVParameterPromptRuntimeOM | COM object used to access the CRVParameterPromptRuntimeOM object in the Crystal RDC object model
cCrystalCRVSelectionItem | COM object used to access the CRVSelectionItem object in the Crystal RDC object model
cCrystalCRVSelectionItems | COM object used to access the CRVSelectionItems object in the Crystal RDC object model
cCrystalCRVTrackCursorInfo | COM object used to access the CRVTrackCursorInfo object in the Crystal RDC object model
cCrystalCrystalComObject | COM object used to access the CrystalComObject object in the Crystal RDC object model
cCrystalCSFontDescription | COM object used to access the CSFontDescription object in the Crystal RDC object model
cCrystalDatabase | COM object used to access the Database object in the Crystal RDC object model
cCrystalDatabaseFieldDefinition | COM object used to access the DatabaseFieldDefinition object in the Crystal RDC object model
cCrystalDatabaseFieldDefinitions | COM object used to access the DatabaseFieldDefinitions object in the Crystal RDC object model
cCrystalDatabaseTable | COM object used to access the DatabaseTable object in the Crystal RDC object model
cCrystalDatabaseTables | COM object used to access the DatabaseTables object in the Crystal RDC object model
cCrystalExportOptions | COM object used to access the ExportOptions object in the Crystal RDC object model
cCrystalFieldDefinitions | COM object used to access the FieldDefinitions object in the Crystal RDC object model
cCrystalFieldElement | COM object used to access the FieldElement object in the Crystal RDC object model
cCrystalFieldElements | COM object used to access the FieldElements object in the Crystal RDC object model
cCrystalFieldMappingData | COM object used to access the FieldMappingData object in the Crystal RDC object model
cCrystalFieldObject | COM object used to access the FieldObject object in the Crystal RDC object model
cCrystalFormattingInfo | COM object used to access the FormattingInfo object in the Crystal RDC object model
cCrystalFormulaFieldDefinition | COM object used to access the FormulaFieldDefinition object in the Crystal RDC object model
cCrystalFormulaFieldDefinitions | COM object used to access the FormulaFieldDefinitions object in the Crystal RDC object model
cCrystalGraphObject | COM object used to access the GraphObject object in the Crystal RDC object model
cCrystalGroupNameFieldDefinition | COM object used to access the GroupNameFieldDefinition object in the Crystal RDC object model
cCrystalGroupNameFieldDefinitions | COM object used to access the GroupNameFieldDefinitions object in the Crystal RDC object model
cCrystalLineObject | COM object used to access the LineObject object in the Crystal RDC object model
cCrystalMapObject | COM object used to access the MapObject object in the Crystal RDC object model
cCrystalObjectSummaryFieldDefinitions | COM object used to access the ObjectSummaryFieldDefinitions object in the Crystal RDC object model
cCrystalOlapGridObject | COM object used to access the OlapGridObject object in the Crystal RDC object model
cCrystalOleObject | COM object used to access the OleObject object in the Crystal RDC object model
cCrystalPage | COM object used to access the Page object in the Crystal RDC object model
cCrystalPageEngine | COM object used to access the PageEngine object in the Crystal RDC object model
cCrystalPageGenerator | COM object used to access the PageGenerator object in the Crystal RDC object model
cCrystalPages | COM object used to access the Pages object in the Crystal RDC object model
cCrystalParameterFieldDefinition | COM object used to access the ParameterFieldDefinition object in the Crystal RDC object model
cCrystalParameterFieldDefinitions | COM object used to access the ParameterFieldDefinitions object in the Crystal RDC object model
cCrystalParameterValue | COM object used to access the ParameterValue object in the Crystal RDC object model
cCrystalParameterValueInfo | COM object used to access the ParameterValueInfo object in the Crystal RDC object model
cCrystalParameterValueInfos | COM object used to access the ParameterValueInfos object in the Crystal RDC object model
cCrystalParameterValues | COM object used to access the ParameterValues object in the Crystal RDC object model
cCrystalPreview | This class acts as a container for the Crystal COM object which the Crystal Reports report is displayed within
cCrystalPrintingStatus | COM object used to access the PrintingStatus object in the Crystal RDC object model
cCrystalReport | Provides a COM connection to a Crystal Reports report
cCrystalReportAlert | COM object used to access the ReportAlert object in the Crystal RDC object model
cCrystalReportAlertInstance | COM object used to access the ReportAlertInstance object in the Crystal RDC object model
cCrystalReportAlertInstances | COM object used to access the ReportAlertInstances object in the Crystal RDC object model
cCrystalReportAlerts | COM object used to access the ReportAlerts object in the Crystal RDC object model
cCrystalReportObjects | COM object used to access the ReportObjects object in the Crystal RDC object model
cCrystalReportSourceRouter | COM object used to access the ReportSourceRouter object in the Crystal RDC object model
cCrystalRunningTotalFieldDefinition | COM object used to access the RunningTotalFieldDefinition object in the Crystal RDC object model
cCrystalRunningTotalFieldDefinitions | COM object used to access the RunningTotalFieldDefinitions object in the Crystal RDC object model
cCrystalSection | COM object used to access the Section object in the Crystal RDC object model
cCrystalSections | COM object used to access the Sections object in the Crystal RDC object model
cCrystalSortField | COM object used to access the SortField object in the Crystal RDC object model
cCrystalSortFields | COM object used to access the SortFields object in the Crystal RDC object model
cCrystalSpecialVarFieldDefinition | COM object used to access the SpecialVarFieldDefinition object in the Crystal RDC object model
cCrystalSQLExpressionFieldDefinition | COM object used to access the SQLExpressionFieldDefinition object in the Crystal RDC object model
cCrystalSQLExpressionFieldDefinitions | COM object used to access the SQLExpressionFieldDefinitions object in the Crystal RDC object model
cCrystalSubreportLink | COM object used to access the SubreportLink object in the Crystal RDC object model
cCrystalSubreportLinks | COM object used to access the SubreportLinks object in the Crystal RDC object model
cCrystalSubreportObject | COM object used to access the SubreportObject object in the Crystal RDC object model
cCrystalSummaryFieldDefinition | COM object used to access the SummaryFieldDefinition object in the Crystal RDC object model
cCrystalSummaryFieldDefinitions | COM object used to access the SummaryFieldDefinitions object in the Crystal RDC object model
cCrystalTableLink | COM object used to access the TableLink object in the Crystal RDC object model
cCrystalTableLinks | COM object used to access the TableLinks object in the Crystal RDC object model
cCrystalTableQualifiers | COM object used to access the TableQualifiers object in the Crystal RDC object model
cCrystalTextObject | COM object used to access the TextObject object in the Crystal RDC object model
cDB2Handler | Implements functionality specific to DB2.
cDbRichEdit | Allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table
cDbTextEdit | Allows the user to enter and edit text connected to a column in a database table
cDesktop | Used to create the desktop object which contains all other objects within an application
cDFBtrDrvHandler | In Progress...
cFTPTransfer | Implements FTP client-side operations
CheckBox | To enable users to select items (or options) in applications
cHtmlHelp | Used to provide access to an HTML-based help system
cHttpTransfer | Implements HTTP client-side operations
cImageList | A collection of images of the same size, each of which can be referred to by its index
cIniFile | Provides access to Windows INI (configuration) files
ClientArea | Provides an area on the screen to contain all of an application's views
cMapiHandler | Consists of functions for sending mail, reading received mail and sending documents
cMSSQLHandler | Implements functionality specific to SQL Server.
cObject | The fundamental class from which all classes are derived
cODBCHandler | Implements functionality specific to ODBC.
CodePickList | Allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets
CodeValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
ColorDialog | Provides an interface to the Windows standard Color dialog
ComboForm | Combines the functionality of the form class with that of a standard Windows drop-down list
Container | Creates non-visual container objects
Container3d | This class creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional (3-D) appearance.
cProcessStatusPanel | Supports a visual object to displayed by long-running processes that may be unattended to report errors that arise in the job
cProgressBar | Indicates the progress within a range
cRegistry | Provides access to the Windows system Registry
cRichEdit | Allows the user to enter and edit RTF (rich-text format) text
CrystalReport | Enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports
cSQLConnection | Handles all Embedded SQL operations for one connection.
cSQLHandleManager | Base entry point for all Embedded SQL operations.
cSQLStatement | Handles all Embedded SQL operation for one statement. The statement is the most used entity in any SQL environment.
cStatusBar | A control, usually placed at the bottom of a window, that is divided into "panes"
cStatusPane | Represents a single pane of a cStatusBar
cTableColumnFetchHelper | Allows creation of a helper object that makes it easy to enable or disable Selected Column Fetching (SCF) for a large number of tables.
cTextEdit | Allows the user to enter and edit text
cToolbar | A control, usually placed at the top of a window, that contains buttons which act as shortcuts to frequently used functionality
cToolbarButton | Each instance represents a single button of a toolbar
CursorShape | Enables programs to change the appearance of the Windows cursor for any of various purposes
cVersionInfo | Contains information relating to the application's embedded Version Information resources
cWinReport2 | Provides most of the capabilities of the BasicReport class and provides the ability to use WinPrint2 to provide more-graphical reports
cWorkspace | Encapsulates access to a Workspace file to set the program's filelist and DFPATH
cXMLDOMAttribute | XML class for handling an attribute node
cXMLDOMCDATASection | XML class for handling CDATA Section nodes
cXMLDOMComment | XML class for handling Comment nodes
cXMLDOMDocument | Provides the Interface to the root node of an XML document
cXMLDOMDocumentFragment | XML class for handling Document Fragments
cXMLDOMDocumentType | Contains information associated with the document type declaration
cXMLDOMElement | XML class for handling an element node
cXMLDOMEntity | XML class for handling an Entity node
cXMLDOMEntityReference | XML class for handling Entity Reference nodes
cXMLDOMNamedNodeMap | XML class for handling Named Node map (collections of attributes)
cXMLDOMNode | Creates a generic XML DOM Node object
cXMLDOMNodeList | Supports iteration through the node collection
cXMLDOMNotation | XML class for handling a Notation node
cXMLDOMProcessingInstruction | XML class for handling Processing Instruction (PI) nodes
cXMLDOMTextNode | XML class for handling a text node
cXmlHttpTransfer | Provides an easy mechanism for sending and receiving XML documents via Http.

D

DataDictionary | This class provides the main method for accessing databases in Visual DataFlex programs.
dbBitmap | Provides for automatic display of bitmap graphics by addressing a database field with an entry_display message
dbCheckbox | To combine the functionality of dbForm and CheckBox allowing a data-entry element to be represented in a checkbox format
dbCodeComboForm | Provides combo objects that automatically use a central codes database file such as CODEMAST
dbComboForm | Provides general-purpose comboform DEOs
dbContainer | Groups together data-entry objects within an invisible container
dbContainer3d | Creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional appearance
dbEdit | (Obsolete) Supports data entry for memo fields or sequential ASCII files from DEOs
dbFloatingPopupMenu | Creates standard data-aware (DEO) floating popup menus
dbForm | To support data entry through an entry_item to one field of one logical record at a time
dbGrid | Enables users to view and edit a scrolling, multi-column list of field values from a database file
dbGroup | Creates visual group container objects and by default, provides a gray background with a rectangular 3 D line border with a text label embedded in the top left edge
dbList | Enables users to select one or more values from a list of choices
dbModalPanel | Provides a modal container for selection lists (dblist) and other DEOs
dbRadioContainer | Provides all of the functionality of a dbRadioGroup within an invisible container
dbRadioGroup | Groups multiple radio objects in a visible object, providing selection of no more than one at a time
dbSpinForm | Provides an entry form that users can edit that contains an integer or date that can be driven through a range with buttons
dbTabDialog | Contains and provides coordinated access to dbTabPage objects
dbTabDialogView | Contains and provides coordinated access to dbTabView objects
dbTabPage | Used when all of the pages in a view share the same DDO structure
dbTabView | Used when each tab-page will contain a stand-alone view with its own DDO structure
dbTrackBar | Enables applications to provide users with a data aware visual control to 'slide' through a range of values
dbView | Creates view objects
DEOPopupMenu | Creates pulldown objects that disables messages not sent to DEOs
DescriptionValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
DFBaseRichEdit | In Progress...
DFBaseTextEdit | In Progress...
DFTimer | DFTimer objects can be used to trigger an event after a certain amount of time has passed.
Dialog | Creates non-MDI-child dialog objects

E

Edit | (Obsolete) Allows users to enter multiple lines of text
Entry | The basis of more-sophisticated data-entry classes,
ErrorSystem | Supports Visual DataFlex's interactive interface for all errors generated in a program

F

FileValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
FloatingPopupMenu | Creates standard floating popup menus (context menus)
FontDialog | Permits users to select fonts
Form | To display and accept keyboard input
FormFloatingPopupMenu | Creates standard floating popup menus for Windows forms (context menus)

G

Grid | A basic class which should be used for creating multi-row, multi-column entry lists
Group | To create visual group container objects with (by default) a gray background with a rectangular 3 D line border with a text label embedded in the top left edge

H

HelpSystem Used to create help object for a Windows Help Files

L

LineControl | Creates divider lines on a container most-often to create a 3 D horizontal dividing line
List | Manipulates dynamic lists of information

M

MdiClientArea | Provides low-level support for an MDI-style client area
MenuBar | Provides the capabilities of a standard GUI menu bar
Mixin | Provides a method for mixing additional skills into a class
ModalPanel | Creates modal popup panels

O

OpenDialog Provides access to the Windows file-open dialog

P

Panel | Provides a top-level window for applications that is independent of all other windows
PopupMenu | Displayed whenever a choice is made from a menu bar and from certain choices made from an already-displayed popup menu
PrintDialog | A wrapper for the Windows Print dialog box used by the CrystalReport class
Prototype_Entry | Helper Class used by DEO Grid classes (dbGrids and dbLists) to define row information

R

Radio | Provides visual selection icons that are used in groups exclusively within radio containers
RadioButton | An intermediate that provides support for stand-alone radio buttons
RadioContainer | Groups multiple Radio objects in a non-visible object, providing selection of no more than one at a tim
RadioGroup | Groups multiple Radio objects in a visible group object, providing selection of no more than one at a time, and navigation among the objects
ReportPanel | Provides a modal popup user interface for running reports
ReportView | Provides a non-modal user interface selected from a menu choice for running reports

S

SaveAsDialog | Provides access to the Windows file-save dialog
Set | Assembles and maintains a set of unique values
ShapeControl | Demonstrates Visual DataFlex communicating with the Windows API
SpinForm | Adds a spin button to a Form
SplashScreenPanel | Provides a way to display a splash screen in your application
StatusAsciiLog | Used for logging status and error reports from unattended (batch) processes to an ascii file
StatusdbLog | Used for logging status and error reports from unattended (batch) processes to a database file
StatusPanel | (Obsolete) Supports a visual object to displayed by long-running processes that may be unattended to report errors that arise in the job
SystemMenu | Class used to create system menus

T

TabDialog | Created by creating a TabDialog object and then creating TabPage objects inside it
TabPage | Creates a page within a tab-dialog container
TextBox | Enables placing static text strings on the display
ToolPanel | Creates tool panels - panels that are not listed on the Windows task list
TrackBar | Enables applications to provide users with a visual control to 'slide' through a range of values
TreeView | Provides a control that displays a hierarchical list of items, such as the headings in a document, the entries in an index, or the files and directories on a disk

V

ValidationList | Provides a default interface object for validation tables used as prompt objects
ValidationTable | Provides a one-column table of validation data for validation lists used with DataDictionary objects.
View | Provides a "basic" (non DEO) MDI view
ViewPopupMenu | Creates popup menu objects that will redirect item messages to the MDI container area object

W

WinReport (Obsolete) Provides most of the capabilities of the BasicReport class and provides the ability to use WinPrint to provide more-graphical reports


Visual DataFlex Web Application Class Library

Show Only Public Classes Combined Application Library Windows Application Library

A

Array Used to create a collection of values which are stored and accessed via item numbers

B

BaseData_Set | Abstract class providing methods for accessing databases in a program (Abstract)
BaseXmlDomAttribute | Abstract XML class for handling an attribute node (Abstract)
BaseXmlDomcDataSection | Abstract XML class for handling cDataSection nodes (Abstract)
BaseXmlDomCharacterData | Abstract XML class for handling character/text nodes (Abstract)
BaseXmlDomComment | Abstract XML class for handling comment nodes (Abstract)
BaseXmlDomDocument | Abstract XML class for handling an XML document (Abstract)
BaseXmlDomDocumentFragment | Abstract XML class for handling an XML document fragment (Abstract)
BaseXmlDomDocumentType | Abstract XML class for handling Document Type (DTD) nodes (Abstract)
BaseXmlDomElement | Abstract XML class for handling element nodes (Abstract)
BaseXmlDomEntity | Abstract XML class for handling Entity nodes (Abstract)
BaseXmlDomEntityReference | Abstract XML class for handling Entity Reference nodes (Abstract)
BaseXmlDomImplementation | Abstract XML class for handling Implementation nodes (Abstract)
BaseXmlDomNamedNodeMap | Abstract XML class for handling named node map nodes (Abstract)
BaseXmlDomNode | The ultimate XML abstract superclass designed to handle all XML node types (Abstract)
BaseXmlDomNodeList | Abstract XML class for handling node lists (Abstract)
BaseXmlDomNotation | Abstract XML class for handling notation nodes (Abstract)
BaseXMLDomParseError | Provides support reporting parsing errors in an XML document
BaseXmlDomProcessingInstruction | Abstract XML class for handling Processing Instructions (PIs) nodes (Abstract)
BaseXmlDomTextNode | Abstract XML class for handling text nodes (Abstract)
Broadcaster | Provides grouping and message-relaying services for a set of objects
BusinessProcess | Contains and executes the statements to perform a batch process on an application's database tables

C

cApplication | Encapsulates methods and properties that are essential to the running of your application
cAutoWebReport | Used to create quick prototype reports based around the main file of a cWebBusinessProcess object
cBaseHTTPTransfer | Abstract class for handling HTTP transfers (Abstract)
cBasicReport | Abstract Basic Reporting class (Abstract)
cClientWebService | The base class for all client web-services
cCLIHandler | Implements functionality common for the CLI based Connectivity Kits (SQL Server, DB2 and ODBC)
cCollection | Maintains a collection of object-handles
cComAutomationObject | Generates wrapper classes for imported OLE Automation Objects (Abstract)
cCommandLine | Encapsulates access to the command-line of the running program
cComStdFont | OLE conventions implement fonts as Automation objects that contain the properties of the font
cComStdPicture | OLE conventions implement pictures as Automation objects that contain the properties of the picture
cCrystal | Enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports
cCrystal_ICRViewerSelectionEvents | In Progress...
cCrystalApplication | COM object used to access the Application object in the Crystal RDC object model
cCrystalArea | COM object used to access the Area object in the Crystal RDC object model
cCrystalAreas | COM object used to access the Areas object in the Crystal RDC object model
cCrystalBlobFieldObject | COM object used to access the BlobFieldObject object in the Crystal RDC object model
cCrystalBoxObject | COM object used to access the BoxObject object in the Crystal RDC object model
cCrystalConnectionProperties | COM object used to access the ConnectionProperties object in the Crystal RDC object model
cCrystalConnectionProperty | COM object used to access the ConnectionProperty object in the Crystal RDC object model
cCrystalCRCrystalReportViewerViewInfo | COM object used to access the CRCrystalReportViewerViewInfo object in the Crystal RDC object model
cCrystalCrossTabGroup | COM object used to access the CrossTabGroup object in the Crystal RDC object model
cCrystalCrossTabGroups | COM object used to access the CrossTabGroups object in the Crystal RDC object model
cCrystalCrossTabObject | COM object used to access the CrossTabObject object in the Crystal RDC object model
cCrystalCRVEventInfo | COM object used to access the CRVEventInfo object in the Crystal RDC object model
cCrystalCRVField | COM object used to access the CRVField object in the Crystal RDC object model
cCrystalCRVFields | COM object used to access the CRVFields object in the Crystal RDC object model
cCrystalCRVParameterPromptRuntimeOM | COM object used to access the CRVParameterPromptRuntimeOM object in the Crystal RDC object model
cCrystalCRVSelectionItem | COM object used to access the CRVSelectionItem object in the Crystal RDC object model
cCrystalCRVSelectionItems | COM object used to access the CRVSelectionItems object in the Crystal RDC object model
cCrystalCRVTrackCursorInfo | COM object used to access the CRVTrackCursorInfo object in the Crystal RDC object model
cCrystalCrystalComObject | COM object used to access the CrystalComObject object in the Crystal RDC object model
cCrystalCSFontDescription | COM object used to access the CSFontDescription object in the Crystal RDC object model
cCrystalDatabase | COM object used to access the Database object in the Crystal RDC object model
cCrystalDatabaseFieldDefinition | COM object used to access the DatabaseFieldDefinition object in the Crystal RDC object model
cCrystalDatabaseFieldDefinitions | COM object used to access the DatabaseFieldDefinitions object in the Crystal RDC object model
cCrystalDatabaseTable | COM object used to access the DatabaseTable object in the Crystal RDC object model
cCrystalDatabaseTables | COM object used to access the DatabaseTables object in the Crystal RDC object model
cCrystalExportOptions | COM object used to access the ExportOptions object in the Crystal RDC object model
cCrystalFieldDefinitions | COM object used to access the FieldDefinitions object in the Crystal RDC object model
cCrystalFieldElement | COM object used to access the FieldElement object in the Crystal RDC object model
cCrystalFieldElements | COM object used to access the FieldElements object in the Crystal RDC object model
cCrystalFieldMappingData | COM object used to access the FieldMappingData object in the Crystal RDC object model
cCrystalFieldObject | COM object used to access the FieldObject object in the Crystal RDC object model
cCrystalFormattingInfo | COM object used to access the FormattingInfo object in the Crystal RDC object model
cCrystalFormulaFieldDefinition | COM object used to access the FormulaFieldDefinition object in the Crystal RDC object model
cCrystalFormulaFieldDefinitions | COM object used to access the FormulaFieldDefinitions object in the Crystal RDC object model
cCrystalGraphObject | COM object used to access the GraphObject object in the Crystal RDC object model
cCrystalGroupNameFieldDefinition | COM object used to access the GroupNameFieldDefinition object in the Crystal RDC object model
cCrystalGroupNameFieldDefinitions | COM object used to access the GroupNameFieldDefinitions object in the Crystal RDC object model
cCrystalLineObject | COM object used to access the LineObject object in the Crystal RDC object model
cCrystalMapObject | COM object used to access the MapObject object in the Crystal RDC object model
cCrystalObjectSummaryFieldDefinitions | COM object used to access the ObjectSummaryFieldDefinitions object in the Crystal RDC object model
cCrystalOlapGridObject | COM object used to access the OlapGridObject object in the Crystal RDC object model
cCrystalOleObject | COM object used to access the OleObject object in the Crystal RDC object model
cCrystalPage | COM object used to access the Page object in the Crystal RDC object model
cCrystalPageEngine | COM object used to access the PageEngine object in the Crystal RDC object model
cCrystalPageGenerator | COM object used to access the PageGenerator object in the Crystal RDC object model
cCrystalPages | COM object used to access the Pages object in the Crystal RDC object model
cCrystalParameterFieldDefinition | COM object used to access the ParameterFieldDefinition object in the Crystal RDC object model
cCrystalParameterFieldDefinitions | COM object used to access the ParameterFieldDefinitions object in the Crystal RDC object model
cCrystalParameterValue | COM object used to access the ParameterValue object in the Crystal RDC object model
cCrystalParameterValueInfo | COM object used to access the ParameterValueInfo object in the Crystal RDC object model
cCrystalParameterValueInfos | COM object used to access the ParameterValueInfos object in the Crystal RDC object model
cCrystalParameterValues | COM object used to access the ParameterValues object in the Crystal RDC object model
cCrystalPrintingStatus | COM object used to access the PrintingStatus object in the Crystal RDC object model
cCrystalReport | Provides a COM connection to a Crystal Reports report
cCrystalReportAlert | COM object used to access the ReportAlert object in the Crystal RDC object model
cCrystalReportAlertInstance | COM object used to access the ReportAlertInstance object in the Crystal RDC object model
cCrystalReportAlertInstances | COM object used to access the ReportAlertInstances object in the Crystal RDC object model
cCrystalReportAlerts | COM object used to access the ReportAlerts object in the Crystal RDC object model
cCrystalReportObjects | COM object used to access the ReportObjects object in the Crystal RDC object model
cCrystalReportSourceRouter | COM object used to access the ReportSourceRouter object in the Crystal RDC object model
cCrystalRunningTotalFieldDefinition | COM object used to access the RunningTotalFieldDefinition object in the Crystal RDC object model
cCrystalRunningTotalFieldDefinitions | COM object used to access the RunningTotalFieldDefinitions object in the Crystal RDC object model
cCrystalSection | COM object used to access the Section object in the Crystal RDC object model
cCrystalSections | COM object used to access the Sections object in the Crystal RDC object model
cCrystalSortField | COM object used to access the SortField object in the Crystal RDC object model
cCrystalSortFields | COM object used to access the SortFields object in the Crystal RDC object model
cCrystalSpecialVarFieldDefinition | COM object used to access the SpecialVarFieldDefinition object in the Crystal RDC object model
cCrystalSQLExpressionFieldDefinition | COM object used to access the SQLExpressionFieldDefinition object in the Crystal RDC object model
cCrystalSQLExpressionFieldDefinitions | COM object used to access the SQLExpressionFieldDefinitions object in the Crystal RDC object model
cCrystalSubreportLink | COM object used to access the SubreportLink object in the Crystal RDC object model
cCrystalSubreportLinks | COM object used to access the SubreportLinks object in the Crystal RDC object model
cCrystalSubreportObject | COM object used to access the SubreportObject object in the Crystal RDC object model
cCrystalSummaryFieldDefinition | COM object used to access the SummaryFieldDefinition object in the Crystal RDC object model
cCrystalSummaryFieldDefinitions | COM object used to access the SummaryFieldDefinitions object in the Crystal RDC object model
cCrystalTableLink | COM object used to access the TableLink object in the Crystal RDC object model
cCrystalTableLinks | COM object used to access the TableLinks object in the Crystal RDC object model
cCrystalTableQualifiers | COM object used to access the TableQualifiers object in the Crystal RDC object model
cCrystalTextObject | COM object used to access the TextObject object in the Crystal RDC object model
cDB2Handler | Implements functionality specific to DB2.
cDesktop | Used to create the desktop object which contains all other objects within an application
cDFBtrDrvHandler | In Progress...
cDistributedBusinessProcess | Abstract class used to create Web Browser Process objects (Abstract)
cFTPTransfer | Implements FTP client-side operations
cHtmlHelp | Used to provide access to an HTML-based help system
cHtmlReport | Abstract class that creates HTML reports (Abstract)
cHttpTransfer | Implements HTTP client-side operations
cImageList | A collection of images of the same size, each of which can be referred to by its index
cIniFile | Provides access to Windows INI (configuration) files
cInternetSessionBusinessProcess | Abstract class used to create Web Browser Process objects (Abstract)
cMapiHandler | Consists of functions for sending mail, reading received mail and sending documents
cMSSQLHandler | Implements functionality specific to SQL Server.
cObject | The fundamental class from which all classes are derived
cODBCHandler | Implements functionality specific to ODBC.
CodeValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
cRegistry | Provides access to the Windows system Registry
cRemoteEntryProcess | Abstract class used to create Web Browser Process objects (Abstract)
cReport | Abstract low level Report Class (Abstract)
cReportDS | Abstract Reporting with a DDO support layerclass (Abstract)
cSQLConnection | Handles all Embedded SQL operations for one connection.
cSQLHandleManager | Base entry point for all Embedded SQL operations.
cSQLStatement | Handles all Embedded SQL operation for one statement. The statement is the most used entity in any SQL environment.
cTableColumnFetchHelper | Allows creation of a helper object that makes it easy to enable or disable Selected Column Fetching (SCF) for a large number of tables.
cVersionInfo | Contains information relating to the application's embedded Version Information resources
cWebApp | Creates a web application wrapper object, which is used to contain all Web Browser Objects (WBOs) and Web Service Objects (WSOs)
cWebBusinessProcess | Creates Web Browser Process objects - the basic component of all Browser based Web Applications
cWebReport | Creates HTML reports to be used with WebApp Server
cWebService | Creates Web Service Objects - the basic component of all web-service based Web Applications
cWmlreport | A subclass of sWebReport that is customized for WML reports
cWorkspace | Encapsulates access to a Workspace file to set the program's filelist and DFPATH
cXMLDOMAttribute | XML class for handling an attribute node
cXMLDOMCDATASection | XML class for handling CDATA Section nodes
cXMLDOMComment | XML class for handling Comment nodes
cXMLDOMDocument | Provides the Interface to the root node of an XML document
cXMLDOMDocumentFragment | XML class for handling Document Fragments
cXMLDOMDocumentType | Contains information associated with the document type declaration
cXMLDOMElement | XML class for handling an element node
cXMLDOMEntity | XML class for handling an Entity node
cXMLDOMEntityReference | XML class for handling Entity Reference nodes
cXMLDOMNamedNodeMap | XML class for handling Named Node map (collections of attributes)
cXMLDOMNode | Creates a generic XML DOM Node object
cXMLDOMNodeList | Supports iteration through the node collection
cXMLDOMNotation | XML class for handling a Notation node
cXMLDOMProcessingInstruction | XML class for handling Processing Instruction (PI) nodes
cXMLDOMTextNode | XML class for handling a text node
cXmlHttpTransfer | Provides an easy mechanism for sending and receiving XML documents via Http.

D

DataDictionary | This class provides the main method for accessing databases in Visual DataFlex programs.
DataSet | Abstract class providing methods for accessing databases in a program (Abstract)
DescriptionValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.

E

ErrorSystem Supports Visual DataFlex's interactive interface for all errors generated in a program

F

FileValidationTable Provides a two-column table of validation data for validation lists used with DataDictionary objects.

I

InetTransfer Abstract class for handling HTTP and FTP transfers (Abstract)

M

Mixin Provides a method for mixing additional skills into a class

S

Set | Assembles and maintains a set of unique values
StatusAsciiLog | Used for logging status and error reports from unattended (batch) processes to an ascii file
StatusdbLog | Used for logging status and error reports from unattended (batch) processes to a database file

V

ValidationTable Provides a one-column table of validation data for validation lists used with DataDictionary objects.


Visual DataFlex Windows Application Class Library

Show Only Public Classes Combined Application Library Web Application Library

A

AboutDialog | Used to create an About Dialog in an application
AbstractFileDialog | Abstract class used to provide access to the Windows file dialog (Abstract)
AbstractShapeControl | Abstract class used to demonstrate Visual DataFlex communicating with the Windows API (Abstract)
AbstractTreeView | Abstract low level TreeView Class (Abstract)
AppClientArea | Provides a client area to contain all of an application's views (MDI child dialogs) (Abstract)
AppDialog | Extends the MDIDialog class to provide support with a level consistent with the App... classes (Abstract)
AppPanel | Provides a top-level window for applications that is independent of all other windows (Abstract)
Array | Used to create a collection of values which are stored and accessed via item numbers

B

BaseData_Set | Abstract class providing methods for accessing databases in a program (Abstract)
BaseXmlDomAttribute | Abstract XML class for handling an attribute node (Abstract)
BaseXmlDomcDataSection | Abstract XML class for handling cDataSection nodes (Abstract)
BaseXmlDomCharacterData | Abstract XML class for handling character/text nodes (Abstract)
BaseXmlDomComment | Abstract XML class for handling comment nodes (Abstract)
BaseXmlDomDocument | Abstract XML class for handling an XML document (Abstract)
BaseXmlDomDocumentFragment | Abstract XML class for handling an XML document fragment (Abstract)
BaseXmlDomDocumentType | Abstract XML class for handling Document Type (DTD) nodes (Abstract)
BaseXmlDomElement | Abstract XML class for handling element nodes (Abstract)
BaseXmlDomEntity | Abstract XML class for handling Entity nodes (Abstract)
BaseXmlDomEntityReference | Abstract XML class for handling Entity Reference nodes (Abstract)
BaseXmlDomImplementation | Abstract XML class for handling Implementation nodes (Abstract)
BaseXmlDomNamedNodeMap | Abstract XML class for handling named node map nodes (Abstract)
BaseXmlDomNode | The ultimate XML abstract superclass designed to handle all XML node types (Abstract)
BaseXmlDomNodeList | Abstract XML class for handling node lists (Abstract)
BaseXmlDomNotation | Abstract XML class for handling notation nodes (Abstract)
BaseXMLDomParseError | Provides support reporting parsing errors in an XML document
BaseXmlDomProcessingInstruction | Abstract XML class for handling Processing Instructions (PIs) nodes (Abstract)
BaseXmlDomTextNode | Abstract XML class for handling text nodes (Abstract)
BasicPanel | Provides a top-level window for applications that is independent of all other windows
BasicReport | Supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it
BitmapContainer | Provides a means for enabling users to select bitmap graphic files to display in programs
Broadcaster | Provides grouping and message-relaying services for a set of objects
BusinessProcess | Contains and executes the statements to perform a batch process on an application's database tables
Button | To create visual representations of keys or buttons that, when pressed by users, produce a specific action with an immediate response

C

cAnimation | Displays an AVI animation clip
cApplication | Encapsulates methods and properties that are essential to the running of your application
cBaseHTTPTransfer | Abstract class for handling HTTP transfers (Abstract)
cClientWebService | The base class for all client web-services
cCLIHandler | Implements functionality common for the CLI based Connectivity Kits (SQL Server, DB2 and ODBC)
cCollection | Maintains a collection of object-handles
cComActiveXControl | Generates wrapper classes for imported ActiveX controls
cComActiveXEntryControl_ | Abstract class for creating DDO aware Active X controls (Abstract)
cComAutomationObject | Generates wrapper classes for imported OLE Automation Objects (Abstract)
cComDbActiveXControl | Generates data-aware wrapper classes for imported ActiveX controls
cComDbActiveXControl_ | Abstract class for creating DDO aware Active X controls (Abstract)
cComDocumentObject | Generates wrapper classes for imported Embedded Document objects
cCommandLine | Encapsulates access to the command-line of the running program
cComStdFont | OLE conventions implement fonts as Automation objects that contain the properties of the font
cComStdPicture | OLE conventions implement pictures as Automation objects that contain the properties of the picture
cCrystal | Enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports
cCrystal_ICRViewerSelectionEvents | In Progress...
cCrystalActiveXReportViewer | COM object used to access the ActiveXReportViewer object in the Crystal RDC object model
cCrystalApplication | COM object used to access the Application object in the Crystal RDC object model
cCrystalArea | COM object used to access the Area object in the Crystal RDC object model
cCrystalAreas | COM object used to access the Areas object in the Crystal RDC object model
cCrystalBlobFieldObject | COM object used to access the BlobFieldObject object in the Crystal RDC object model
cCrystalBoxObject | COM object used to access the BoxObject object in the Crystal RDC object model
cCrystalConnectionProperties | COM object used to access the ConnectionProperties object in the Crystal RDC object model
cCrystalConnectionProperty | COM object used to access the ConnectionProperty object in the Crystal RDC object model
cCrystalCRCrystalReportViewerViewInfo | COM object used to access the CRCrystalReportViewerViewInfo object in the Crystal RDC object model
cCrystalCrossTabGroup | COM object used to access the CrossTabGroup object in the Crystal RDC object model
cCrystalCrossTabGroups | COM object used to access the CrossTabGroups object in the Crystal RDC object model
cCrystalCrossTabObject | COM object used to access the CrossTabObject object in the Crystal RDC object model
cCrystalCRVEventInfo | COM object used to access the CRVEventInfo object in the Crystal RDC object model
cCrystalCRVField | COM object used to access the CRVField object in the Crystal RDC object model
cCrystalCRVFields | COM object used to access the CRVFields object in the Crystal RDC object model
cCrystalCRVParameterPromptRuntimeOM | COM object used to access the CRVParameterPromptRuntimeOM object in the Crystal RDC object model
cCrystalCRVSelectionItem | COM object used to access the CRVSelectionItem object in the Crystal RDC object model
cCrystalCRVSelectionItems | COM object used to access the CRVSelectionItems object in the Crystal RDC object model
cCrystalCRVTrackCursorInfo | COM object used to access the CRVTrackCursorInfo object in the Crystal RDC object model
cCrystalCrystalComObject | COM object used to access the CrystalComObject object in the Crystal RDC object model
cCrystalCSFontDescription | COM object used to access the CSFontDescription object in the Crystal RDC object model
cCrystalDatabase | COM object used to access the Database object in the Crystal RDC object model
cCrystalDatabaseFieldDefinition | COM object used to access the DatabaseFieldDefinition object in the Crystal RDC object model
cCrystalDatabaseFieldDefinitions | COM object used to access the DatabaseFieldDefinitions object in the Crystal RDC object model
cCrystalDatabaseTable | COM object used to access the DatabaseTable object in the Crystal RDC object model
cCrystalDatabaseTables | COM object used to access the DatabaseTables object in the Crystal RDC object model
cCrystalExportOptions | COM object used to access the ExportOptions object in the Crystal RDC object model
cCrystalFieldDefinitions | COM object used to access the FieldDefinitions object in the Crystal RDC object model
cCrystalFieldElement | COM object used to access the FieldElement object in the Crystal RDC object model
cCrystalFieldElements | COM object used to access the FieldElements object in the Crystal RDC object model
cCrystalFieldMappingData | COM object used to access the FieldMappingData object in the Crystal RDC object model
cCrystalFieldObject | COM object used to access the FieldObject object in the Crystal RDC object model
cCrystalFormattingInfo | COM object used to access the FormattingInfo object in the Crystal RDC object model
cCrystalFormulaFieldDefinition | COM object used to access the FormulaFieldDefinition object in the Crystal RDC object model
cCrystalFormulaFieldDefinitions | COM object used to access the FormulaFieldDefinitions object in the Crystal RDC object model
cCrystalGraphObject | COM object used to access the GraphObject object in the Crystal RDC object model
cCrystalGroupNameFieldDefinition | COM object used to access the GroupNameFieldDefinition object in the Crystal RDC object model
cCrystalGroupNameFieldDefinitions | COM object used to access the GroupNameFieldDefinitions object in the Crystal RDC object model
cCrystalLineObject | COM object used to access the LineObject object in the Crystal RDC object model
cCrystalMapObject | COM object used to access the MapObject object in the Crystal RDC object model
cCrystalObjectSummaryFieldDefinitions | COM object used to access the ObjectSummaryFieldDefinitions object in the Crystal RDC object model
cCrystalOlapGridObject | COM object used to access the OlapGridObject object in the Crystal RDC object model
cCrystalOleObject | COM object used to access the OleObject object in the Crystal RDC object model
cCrystalPage | COM object used to access the Page object in the Crystal RDC object model
cCrystalPageEngine | COM object used to access the PageEngine object in the Crystal RDC object model
cCrystalPageGenerator | COM object used to access the PageGenerator object in the Crystal RDC object model
cCrystalPages | COM object used to access the Pages object in the Crystal RDC object model
cCrystalParameterFieldDefinition | COM object used to access the ParameterFieldDefinition object in the Crystal RDC object model
cCrystalParameterFieldDefinitions | COM object used to access the ParameterFieldDefinitions object in the Crystal RDC object model
cCrystalParameterValue | COM object used to access the ParameterValue object in the Crystal RDC object model
cCrystalParameterValueInfo | COM object used to access the ParameterValueInfo object in the Crystal RDC object model
cCrystalParameterValueInfos | COM object used to access the ParameterValueInfos object in the Crystal RDC object model
cCrystalParameterValues | COM object used to access the ParameterValues object in the Crystal RDC object model
cCrystalPreview | This class acts as a container for the Crystal COM object which the Crystal Reports report is displayed within
cCrystalPrintingStatus | COM object used to access the PrintingStatus object in the Crystal RDC object model
cCrystalReport | Provides a COM connection to a Crystal Reports report
cCrystalReportAlert | COM object used to access the ReportAlert object in the Crystal RDC object model
cCrystalReportAlertInstance | COM object used to access the ReportAlertInstance object in the Crystal RDC object model
cCrystalReportAlertInstances | COM object used to access the ReportAlertInstances object in the Crystal RDC object model
cCrystalReportAlerts | COM object used to access the ReportAlerts object in the Crystal RDC object model
cCrystalReportObjects | COM object used to access the ReportObjects object in the Crystal RDC object model
cCrystalReportSourceRouter | COM object used to access the ReportSourceRouter object in the Crystal RDC object model
cCrystalRunningTotalFieldDefinition | COM object used to access the RunningTotalFieldDefinition object in the Crystal RDC object model
cCrystalRunningTotalFieldDefinitions | COM object used to access the RunningTotalFieldDefinitions object in the Crystal RDC object model
cCrystalSection | COM object used to access the Section object in the Crystal RDC object model
cCrystalSections | COM object used to access the Sections object in the Crystal RDC object model
cCrystalSortField | COM object used to access the SortField object in the Crystal RDC object model
cCrystalSortFields | COM object used to access the SortFields object in the Crystal RDC object model
cCrystalSpecialVarFieldDefinition | COM object used to access the SpecialVarFieldDefinition object in the Crystal RDC object model
cCrystalSQLExpressionFieldDefinition | COM object used to access the SQLExpressionFieldDefinition object in the Crystal RDC object model
cCrystalSQLExpressionFieldDefinitions | COM object used to access the SQLExpressionFieldDefinitions object in the Crystal RDC object model
cCrystalSubreportLink | COM object used to access the SubreportLink object in the Crystal RDC object model
cCrystalSubreportLinks | COM object used to access the SubreportLinks object in the Crystal RDC object model
cCrystalSubreportObject | COM object used to access the SubreportObject object in the Crystal RDC object model
cCrystalSummaryFieldDefinition | COM object used to access the SummaryFieldDefinition object in the Crystal RDC object model
cCrystalSummaryFieldDefinitions | COM object used to access the SummaryFieldDefinitions object in the Crystal RDC object model
cCrystalTableLink | COM object used to access the TableLink object in the Crystal RDC object model
cCrystalTableLinks | COM object used to access the TableLinks object in the Crystal RDC object model
cCrystalTableQualifiers | COM object used to access the TableQualifiers object in the Crystal RDC object model
cCrystalTextObject | COM object used to access the TextObject object in the Crystal RDC object model
cDB2Handler | Implements functionality specific to DB2.
cDbRichEdit | Allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table
cDbRichEdit_ | Allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table (Abstract)
cDbRichEditDS_ | Allows the user to enter and edit RTF (rich-text format) text connected to a column in a database table (Abstract)
cDbTextEdit | Allows the user to enter and edit text connected to a column in a database table
cDbTextEdit_ | Allows the user to enter and edit text connected to a column in a database table (Abstract)
cDbTextEditDS_ | Allows the user to enter and edit text connected to a column in a database table (Abstract)
cDesktop | Used to create the desktop object which contains all other objects within an application
cDFBtrDrvHandler | In Progress...
cFTPTransfer | Implements FTP client-side operations
CheckBox | To enable users to select items (or options) in applications
cHtmlHelp | Used to provide access to an HTML-based help system
cHttpTransfer | Implements HTTP client-side operations
cImageList | A collection of images of the same size, each of which can be referred to by its index
cIniFile | Provides access to Windows INI (configuration) files
ClientArea | Provides an area on the screen to contain all of an application's views
Cm_Entry | Abstract class that provides Entry class capabilities to the prototype_entry class (Abstract)
Cm_Menu | Abstract class that provides Menu class capabilities to the prototype_entry class (Abstract)
cMapiHandler | Consists of functions for sending mail, reading received mail and sending documents
cMSSQLHandler | Implements functionality specific to SQL Server.
cObject | The fundamental class from which all classes are derived
cODBCHandler | Implements functionality specific to ODBC.
CodePickList | Allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets
CodePickList_ | Abstract class that allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets (Abstract)
CodeValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
ColorDialog | Provides an interface to the Windows standard Color dialog
ComboEntry | Combines the capabilities of the Entry and ComboForm classes in a single class (Abstract)
ComboForm | Combines the functionality of the form class with that of a standard Windows drop-down list
Container | Creates non-visual container objects
Container3d | This class creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional (3-D) appearance.
cProcessStatusPanel | Supports a visual object to displayed by long-running processes that may be unattended to report errors that arise in the job
cProgressBar | Indicates the progress within a range
cRegistry | Provides access to the Windows system Registry
cRichEdit | Allows the user to enter and edit RTF (rich-text format) text
CrystalReport | Enables integration with predefined Crystal Report reports in Visual DataFlex programs in order to launch and interact with Crystal Report reports
cSQLConnection | Handles all Embedded SQL operations for one connection.
cSQLHandleManager | Base entry point for all Embedded SQL operations.
cSQLStatement | Handles all Embedded SQL operation for one statement. The statement is the most used entity in any SQL environment.
cStatusBar | A control, usually placed at the bottom of a window, that is divided into "panes"
cStatusPane | Represents a single pane of a cStatusBar
cStatusPanel | Abstract class that can be used to create status panels (Abstract)
cTableColumnFetchHelper | Allows creation of a helper object that makes it easy to enable or disable Selected Column Fetching (SCF) for a large number of tables.
cTextEdit | Allows the user to enter and edit text
cToolbar | A control, usually placed at the top of a window, that contains buttons which act as shortcuts to frequently used functionality
cToolbarButton | Each instance represents a single button of a toolbar
cUIObject | An abstract class that provides the standard capabilities of a user interface object (Abstract)
CursorShape | Enables programs to change the appearance of the Windows cursor for any of various purposes
cVersionInfo | Contains information relating to the application's embedded Version Information resources
cWinControl | Provides a base class to use when subclassing a Windows control (Abstract)
cWinReport2 | Provides most of the capabilities of the BasicReport class and provides the ability to use WinPrint2 to provide more-graphical reports
cWorkspace | Encapsulates access to a Workspace file to set the program's filelist and DFPATH
cXMLDOMAttribute | XML class for handling an attribute node
cXMLDOMCDATASection | XML class for handling CDATA Section nodes
cXMLDOMComment | XML class for handling Comment nodes
cXMLDOMDocument | Provides the Interface to the root node of an XML document
cXMLDOMDocumentFragment | XML class for handling Document Fragments
cXMLDOMDocumentType | Contains information associated with the document type declaration
cXMLDOMElement | XML class for handling an element node
cXMLDOMEntity | XML class for handling an Entity node
cXMLDOMEntityReference | XML class for handling Entity Reference nodes
cXMLDOMNamedNodeMap | XML class for handling Named Node map (collections of attributes)
cXMLDOMNode | Creates a generic XML DOM Node object
cXMLDOMNodeList | Supports iteration through the node collection
cXMLDOMNotation | XML class for handling a Notation node
cXMLDOMProcessingInstruction | XML class for handling Processing Instruction (PI) nodes
cXMLDOMTextNode | XML class for handling a text node
cXmlHttpTransfer | Provides an easy mechanism for sending and receiving XML documents via Http.

D

DataDictionary | This class provides the main method for accessing databases in Visual DataFlex programs.
DataList | Implements the behavior common to virtual scrolling lists and provides an interface to a DSO to support virtual list viewing (Abstract)
DataList_ | Abstract class that implements the behavior common to virtual scrolling lists (Abstract)
DataSet | Abstract class providing methods for accessing databases in a program (Abstract)
dbAppClient_ | Abstract class that creates view objects (Abstract)
dbAppView_ | Abstract class that creates view objects (Abstract)
dbBasicComboForm | Combines the capabilities of the ComboEntry class and the dbForm class (Abstract)
dbBasicComboForm_ | Abstract class that combines the capabilities of the ComboEntry class and the dbForm class (Abstract)
dbBitmap | Provides for automatic display of bitmap graphics by addressing a database field with an entry_display message
dbCheckbox | To combine the functionality of dbForm and CheckBox allowing a data-entry element to be represented in a checkbox format
dbCheckBoxDS | Abstract class that combines the functionality of dbForm and CheckBox allowing a data-entry element to be represented in a checkbox format (Abstract)
dbCodeComboForm | Provides combo objects that automatically use a central codes database file such as CODEMAST
dbComboForm | Provides general-purpose comboform DEOs
dbComboFormDD_ | Abstract class providing general-purpose comboform DEOs (Abstract)
dbComboFormDS | Abstract class providing combo objects that automatically use a central codes database file (Abstract)
dbContainer | Groups together data-entry objects within an invisible container
dbContainer3d | Creates visual container objects and by default, provides a gray background with a raised border having a three-dimensional appearance
dbContainer3d_ | Abstract class creating visual container objects and by default, providing a gray background with a raised border having a three-dimensional appearance (Abstract)
dbDataComboForm | Extends the functionality of the dbBasicComboForm to support the separation of description and database values (Abstract)
dbEdit | (Obsolete) Supports data entry for memo fields or sequential ASCII files from DEOs
dbEdit_ | (Obsolete) Abstract class that supports data entry for memo fields or sequential ASCII files from DEOs (Abstract)
dbEditDS | (Obsolete) Abstract class that supports data entry for memo fields or sequential ASCII files from DEOs (Abstract)
dbFloatingPanel | In Progress...
dbFloatingPanel_ | In Progress...
dbFloatingPopupMenu | Creates standard data-aware (DEO) floating popup menus
dbForm | To support data entry through an entry_item to one field of one logical record at a time
dbForm_ | Abstract class that supports data entry through an entry_item to one field of one logical record at a time (Abstract)
dbFormDS | Abstract class that supports data entry through an entry_item to one field of one logical record at a time (Abstract)
dbFormExternalControl | Abstract class that enables applications to provide users with a data aware visual control to 'slide' through a range of values (Abstract)
dbGrid | Enables users to view and edit a scrolling, multi-column list of field values from a database file
dbGrid_ | Abstract class that enables users to view and edit a scrolling, multi-column list of field values from a database file (Abstract)
dbGridDD | In Progress...
dbGridDS | Abstract class that enables users to view and edit a scrolling, multi-column list of field values from a database file (Abstract)
dbGroup | Creates visual group container objects and by default, provides a gray background with a rectangular 3 D line border with a text label embedded in the top left edge
dbGroup_ | Abstract class that creates visual group container objects and by default, provides a gray background with a rectangular 3 D line border with a text label embedded in the top left edge (Abstract)
dbList | Enables users to select one or more values from a list of choices
dbList_ | Abstract class enabling users to select one or more values from a list of choices (Abstract)
dbListDS | Abstract class enabling users to select one or more values from a list of choices (Abstract)
dbModalPanel | Provides a modal container for selection lists (dblist) and other DEOs
dbRadioContainer | Provides all of the functionality of a dbRadioGroup within an invisible container
dbRadioGroup | Groups multiple radio objects in a visible object, providing selection of no more than one at a time
dbRadioGroupDS | Abstract class that groups multiple radio objects in a visible object, providing selection of no more than one at a time (Abstract)
dbSpinForm | Provides an entry form that users can edit that contains an integer or date that can be driven through a range with buttons
dbSpinFormDS | Abstract class that provides an entry form that users can edit that contains an integer or date that can be driven through a range with buttons (Abstract)
dbTabDialog | Contains and provides coordinated access to dbTabPage objects
dbTabDialog_ | Abstract class that contains and provides coordinated access to dbTabPage objects (Abstract)
dbTabDialogView | Contains and provides coordinated access to dbTabView objects
dbTabPage | Used when all of the pages in a view share the same DDO structure
dbTabView | Used when each tab-page will contain a stand-alone view with its own DDO structure
dbTabView_ | Abstract class used when each tab-page will contain a stand-alone view with its own DDO structure (Abstract)
dbTrackBar | Enables applications to provide users with a data aware visual control to 'slide' through a range of values
dbView | Creates view objects
dbViewFloatingPanel | In Progress...
dbViewToolPanel | Abstract class that provides a modal container for selection lists (dblist) and other DEOs (Abstract)
DEOPopupMenu | Creates pulldown objects that disables messages not sent to DEOs
DescriptionValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
DfBaseActionBar | Abstract class that provides the capabilities of a standard GUI menu bar (Abstract)
DfBaseButton | An abstract class used for defining all button classes (Abstract)
DfBaseCheckbox | Abstract class that enables users to select items (or options) in applications (Abstract)
DfBaseComboBox | Abstract class that combines the functionality of the form class with that of a standard Windows drop-down list (Abstract)
DfBaseComboBoxEntry | Abstract class thta combines the capabilities of the Entry and ComboForm classes in a single class (Abstract)
DfBaseContainer | An abstract class for defining GUI containers (Abstract)
DfBaseControl | An abstract class for defining GUI controls (Abstract)
DfBaseDialog | A container class that manages the controls that are placed in its scope (Abstract)
DfBaseEdit | (Obsolete) Abstract class that allows users to enter multiple lines of text (Abstract)
DfBaseEditPullDown | Abstract class that creates standard floating popup menus (Abstract)
DfBaseEntry | Allows the retrieval, display and storage of information between a database field and a form (Abstract)
DfBaseEntryList | Abstract class suitable for "table" style data entry (Abstract)
DfBaseForm | DfBaseForm is a superclass for classes supporting form data entry (Abstract)
DfBaseFormList | Abstract class which should be used for creating multi-row, multi-column entry lists (Abstract)
DfBaseGroup | Abstract class creating visual group container objects with a gray background with a rectangular 3 D line border with a text label embedded in the top left edge (Abstract)
DfBaselineControl | Abstract class that creates divider lines on a container most-often to create a 3 D horizontal dividing line (Abstract)
DfBaseList | An intermediate class that is used as the basis for all "item- and form-based" classes (Abstract)
DfBaseListbox | Abstract low level List Class (Abstract)
DfBasemdiclient | Abstract class providing low-level support for an MDI-style client area (Abstract)
DfBaseObject | Provides a level of abstraction that separates the basic object support from the GUI support (Abstract)
DfBasePanel | Provides a top-level window for applications that is independent of all other windows (Abstract)
DfBasePullDown | Abstract class that creates standard floating popup menus (Abstract)
DfBasePushButton | Abstract class creating visual representations of keys or buttons that, when pressed by users, produce a specific action with an immediate response (Abstract)
DfBaseRadioButton | Abstract class that provides support for stand-alone radio buttons (Abstract)
DFBaseRichEdit | In Progress...
DfBasetabDialog | Abstract class used for TabDialogs (Abstract)
DfBaseTextbox | Abstract class that enables placing static text strings on the display (Abstract)
DFBaseTextEdit | In Progress...
DfBasetoolPanel | Abstract class that creates tool panels - panels that are not listed on the Windows task list (Abstract)
DfBaseUIWindow | Adds a layer of support for user interaction to DfBaseWindow (Abstract)
DfBaseWindow | Specifies a layer of presentation support for GUI objects (Abstract)
DfComActiveXControl | Abstract class which provides support forwrapping of Active X controls (Abstract)
DfComAutomationObject | Abstract class for imported OLE Automation Objects (Abstract)
DFComDocumentObject | Abstract class which provides support for embedded document objects (Abstract)
DfComUIObject | Abstract class which provides standard UI interfaces for Com Objects (Abstract)
DfInPlaceComObject | Abstract class which provides standard COM interfaces for Com Objects (Abstract)
DFTimer | DFTimer objects can be used to trigger an event after a certain amount of time has passed.
Dialog | Creates non-MDI-child dialog objects

E

Edit | (Obsolete) Allows users to enter multiple lines of text
Entry | The basis of more-sophisticated data-entry classes,
EntryList | An abstract class suitable for "table" style data entry (Abstract)
ErrorSystem | Supports Visual DataFlex's interactive interface for all errors generated in a program

F

FileValidationTable | Provides a two-column table of validation data for validation lists used with DataDictionary objects.
FloatingPanel | In Progress...
FloatingPopupMenu | Creates standard floating popup menus (context menus)
FontDialog | Permits users to select fonts
Form | To display and accept keyboard input
FormExternalControl | Abstract class enabling applications to provide users with a visual control to 'slide' through a range of values (Abstract)
FormFloatingPopupMenu | Creates standard floating popup menus for Windows forms (context menus)

G

Grid | A basic class which should be used for creating multi-row, multi-column entry lists
Group | To create visual group container objects with (by default) a gray background with a rectangular 3 D line border with a text label embedded in the top left edge

H

HelpSystem Used to create help object for a Windows Help Files

I

InetTransfer Abstract class for handling HTTP and FTP transfers (Abstract)

L

LineControl | Creates divider lines on a container most-often to create a 3 D horizontal dividing line
List | Manipulates dynamic lists of information

M

MdiClientArea | Provides low-level support for an MDI-style client area
MdiDialog | Creates MDI child dialog objects for use inside a MDI client-area object (Abstract)
MenuBar | Provides the capabilities of a standard GUI menu bar
Mixin | Provides a method for mixing additional skills into a class
ModalPanel | Creates modal popup panels

O

OpenDialog Provides access to the Windows file-open dialog

P

Panel | Provides a top-level window for applications that is independent of all other windows
PickList | Abstract class that allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets (Abstract)
PickList_ | Abstract class that allows selection of one or more values from a list of static choices for insertion into database records by a code for each choice in programs handling the database through DataSets (Abstract)
PopupMenu | Displayed whenever a choice is made from a menu bar and from certain choices made from an already-displayed popup menu
PrintDialog | A wrapper for the Windows Print dialog box used by the CrystalReport class
Prototype_Entry | Helper Class used by DEO Grid classes (dbGrids and dbLists) to define row information

R

Radio | Provides visual selection icons that are used in groups exclusively within radio containers
RadioButton | An intermediate that provides support for stand-alone radio buttons
RadioContainer | Groups multiple Radio objects in a non-visible object, providing selection of no more than one at a tim
RadioGroup | Groups multiple Radio objects in a visible group object, providing selection of no more than one at a time, and navigation among the objects
Report | Abstract class that supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it (Abstract)
Report_DS | Abstract class that supports creation of hierarchies of objects that can output data from the database or change large numbers of records in it (Abstract)
ReportPanel | Provides a modal popup user interface for running reports
ReportView | Provides a non-modal user interface selected from a menu choice for running reports

S

SaveAsDialog | Provides access to the Windows file-save dialog
Set | Assembles and maintains a set of unique values
ShapeControl | Demonstrates Visual DataFlex communicating with the Windows API
SpinForm | Adds a spin button to a Form
SplashScreenPanel | Provides a way to display a splash screen in your application
StatusAsciiLog | Used for logging status and error reports from unattended (batch) processes to an ascii file
StatusdbLog | Used for logging status and error reports from unattended (batch) processes to a database file
StatusPanel | (Obsolete) Supports a visual object to displayed by long-running processes that may be unattended to report errors that arise in the job
SystemMenu | Class used to create system menus

T

TabDialog | Created by creating a TabDialog object and then creating TabPage objects inside it
TabDialog_ | Abstract class created by creating a TabDialog object and then creating TabPage objects inside it (Abstract)
TabPage | Creates a page within a tab-dialog container
TextBox | Enables placing static text strings on the display
ToolPanel | Creates tool panels - panels that are not listed on the Windows task list
TrackBar | Enables applications to provide users with a visual control to 'slide' through a range of values
TreeView | Provides a control that displays a hierarchical list of items, such as the headings in a document, the entries in an index, or the files and directories on a disk

V

ValidationList | Provides a default interface object for validation tables used as prompt objects
ValidationTable | Provides a one-column table of validation data for validation lists used with DataDictionary objects.
View | Provides a "basic" (non DEO) MDI view
ViewPopupMenu | Creates popup menu objects that will redirect item messages to the MDI container area object

W

WideList | An abstract class defining the common procedures and properties of data-entry classes and dbLists (Abstract)
WideList_ | Abstract class defining the common procedures and properties of data-entry classes and dbLists (Abstract)
WinReport | (Obsolete) Provides most of the capabilities of the BasicReport class and provides the ability to use WinPrint to provide more-graphical reports


Events for ClientArea

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus |  | MdiClientArea
OnSetFocus |  | MdiClientArea
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for ClientArea

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Arrange_Icons | Procedure | Arranges the icons for all minimized views contained by this object | DfBasemdiclient
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
Cascade_Windows | Procedure | Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it | DfBasemdiclient
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | MdiClientArea
Error_Help | Procedure | (Obsolete) | MdiClientArea
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | MdiClientArea
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | MdiClientArea
Help | Procedure |  | MdiClientArea
Help_For_Help | Procedure | (Obsolete) | MdiClientArea
Help_Index | Procedure | (Obsolete) | MdiClientArea
Help_on_topic | Procedure | (Obsolete) | MdiClientArea
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | MdiClientArea
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Mdi_Dialog | Function | Provides a way to obtain the object ID of all views contained by this container | AppClientArea
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Next_View | Procedure | Switches the focus to the next view object in this object | DfBasemdiclient
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Switch_Prior_View | Procedure | Switches the focus to the previous view object in this object | DfBasemdiclient
Tile_Windows_Horizontal | Procedure | Arranges this object's views from left to right across the top, and then down to the next line, also so arranged | DfBasemdiclient
Tile_Windows_Vertical | Procedure | Arranges this object's views from top to bottom down the left side, and then right to the next column, also so arranged | DfBasemdiclient
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for ClientArea

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | MdiClientArea
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | MdiClientArea
Help_Keyword | Used to specify an object's context keyword | MdiClientArea
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | MdiClientArea
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Scroll_Bar_Visible_State | Specifies whether this object is to display a scroll bar (or bars) when the content of the object exceeds this object's same-time display capacity | DfBasemdiclient
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Cm_Entry [Event Item_Entry]

Item_Entry - Cm_Entry

Sends iMessage to the current object if it is non-zero

Type: Event

Return Data Type: Integer

Parameters: Integer iMessage Integer iItem

Parameter | Description
iMessage | The Message id (e.g. get_IsEntryOk)
iItem | The entering item number

Return Value

Returns 0 if entry is ok, non-zero if entry should not be allowed

Description

The Item_Entry message sends iMessage to the current object if it is non-zero. This is an intermediate message sent during item change so that the program can intercept the change before it actually takes place. For example, you might check iMessage and if it is zero, substitute a generic message:

function item_entry integer entry_msg integer item_number returns integer
    integer ret_val
    if entry_msg eq 0 move generic_msg to entry_msg
    forward get item_entry entry_msg item_number to ret_val
    function_return ret_val
end_function

Last Edited: August 6, 2004


Cm_Entry [Event Item_Exit]

Item_Exit - Cm_Entry

Sends iMessage to the current object if it is non-zero

Type: Event

Return Data Type: Integer

Parameters: Integer iMessage Integer iItem

Parameter | Description
iMessage | The Message id (e.g. get_IsExitOk)
iItem | The exiting item number

Return Value

Returns 0 if exiting is ok, non-zero if exiting should not be allowed

Description

The Item_exit message sends iMessage to the current object if it is non-zero. This is an intermediate message sent during item change so that the program can intercept the change before it actually takes place. For example, you might check the iMessage parameter and if it is zero, substitute a generic message:

function item_exit integer exit_msg integer item_number returns integer
    integer ret_val
    if exit_msg eq 0 move generic_msg to exit_msg
    forward get item_exit exit_msg item_number to ret_val
    function_return ret_val
end_function

Last Edited: August 6, 2004


Cm_Entry [Event Refresh]

Refresh - Cm_Entry

Displays items from some files at the same time as clearing items from other files

Type: Event

Parameters: Integer notifyMode

Parameter Description
notifyModeThe mode, which signifies the event or operation which generated this refresh message, may be one of the following:

Constant | Meaning
mode_clear | used only for DEOs attached to the DSO that was the "origin" of a clear operation, i.e., the DSO that received the original clear request or message as a result of the user pressing kclear. All other DSOs send their DEOs the refresh message passing mode_find_or_clear_set.
mode_find_or_clear_set | used for DEOs attached to DataSets which have found and/or cleared records in response to a user's find-request (kfind, kfind_next, ksuperfind, et al.) or in response to another DSO's find or clear.
mode_clear_all | used for DEOs attached to any DSO that participated in a clear_all operation.
mode_delete | used for DEOs attached to any DSO that performed a successful deletion. DSOs that were merely updated as the result of a deletion use mode_find_or_clear_set.
mode_save | used for DEOs attached to any DSO involved in a successful save operation.

Description

Refresh displays items from some files at the same time as clearing items from other files.

This is a good message for augmentation. All changes in DSO activity are filtered through this message. When augmenting, you will almost always want to forward send the message.

// If order record exists, disallow entry in customer window.
Procedure Refresh Integer mode
    Integer Srvr# Crnt
    Get Server to Srvr#                 // get the ddo
    Get Current_Record of Srvr# to Crnt // get record in ddo
    // Make displayonly if Crnt is non-zero
    set enabled_state to (crnt =0)
    Forward Send Refresh mode          // do normal refrsh
End_Procedure

Last Edited: July 11, 2006


Cm_Entry [Event Wrapping]

Wrapping - Cm_Entry

Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

The Wrapping message is meant to be overridden. The message is sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item.

procedure wrapping
    send save_some_data
end_procedure

Last Edited: September 15, 2003


Events for Cm_Entry

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Item_Change | A programming "hook" to perform an action on change of an item | Cm_Menu
Item_Entry | Sends iMessage to the current object if it is non-zero |
Item_Exit | Sends iMessage to the current object if it is non-zero |
Key | Augmented to implement the GUI keyboard interface | Cm_Menu
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Refresh | Displays items from some files at the same time as clearing items from other files |
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item |


Cm_Entry [Function Validate_Items]

Validate_Items - Cm_Entry

Validates all items and sends each entry_item's Item_Validate_msg

Type: Function

Return Data Type: Integer

Parameters: Boolean bNotFindReq

Parameter | Description
bNotFindReq | If true, all item options are validated except findreq. If false, all item options are validated.

Return Value

Returns 0 if all items are valid, or else retrurns the first invalid item number.

Description

The Validate_Items function validates all items and sends each entry_item's Item_Validate_msg. If any item fails to validate, validation testing stops, the object's current item is set to the item that failed the test, and that same item number is returned. If all items pass validation, zero is returned.

if not (Validate_Items(Self, 1)) send Save_Some_Data

In this example, all options specified on all entry items of the current object except findreq are validated to control sending Message save_some_data.

Last Edited: August 6, 2004


Methods for Cm_Entry

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | Cm_Menu
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | Cm_Menu
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window |
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall |
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall |
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it |
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | Cm_Menu
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | Cm_Menu
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | Cm_Menu
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg |


Cm_Entry [Procedure Entry_Autofind]

Entry_Autofind - Cm_Entry

Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window

Type: Procedure

Parameters: Integer eFindMode

Parameter Description
eFindMode

Constant | Meaning
EQ | Find equal to
GE | Find greater than or equal to

Description

When an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window, the entry_autofind message is sent. If the autofind is successful, then the data is displayed by the entry_display message, otherwise the find error condition is cleared and the message returns. Although this message would rarely be coded in an application with the send command, it may be augmented to place information in the record buffer prior to the find, or to display the information in a custom way (or not at all).

procedure entry_autofind integer find_mode
    move user_name to transaction.created_by
    forward send entry_autofind find_mode
end_procedure

Last Edited: August 5, 2003


Cm_Entry [Procedure Entry_Clear]

Entry_Clear - Cm_Entry

Clears all data-entry windows that are not controlled by a retain or retainall

Type: Procedure

Parameters: Boolean bClearedFiles

Parameter | Description
bClearedFiles | If true, only items for files which have been cleared in the current DDO operation will be affected

Description

The entry_clear message will clear all data-entry windows that are not controlled by a retain or retainall. If the item is cleared, the value is set to blanks and the changed_state is set to false. If the item is retained, its value will remain unchanged, and its item_changed_state set to true. This is done to ensure that the data will be moved into the record buffer on subsequent entry_update messages.

Last Edited: August 13, 2003


Cm_Entry [Procedure Entry_Clear_All]

Entry_Clear_All - Cm_Entry

Clears all data entry windows that are not marked as retainall

Type: Procedure

Parameters: Boolean bClearedFiles

Parameter | Description
bClearedFiles | If true, only items for files which have been cleared in the current DDO operation will be affected

Description

The entry_clear_all message will clear all data entry windows that are not marked as retainall. When the item is cleared, the value is set to blanks and the changed_state is set to false. If the item is retained, its value will remain unchanged, and its item_changed_state is set to true. This is done to ensure that the data will be moved into the record buffer on subsequent entry_update messages.

Last Edited: August 5, 2003


Cm_Entry [Procedure Entry_Display]

Entry_Display - Cm_Entry

Displays data from the data_file and data_field to every entry_item connected to it

Type: Procedure

Parameters: Integer iFile Boolean bDoAll

Parameter | Description
iFile | The file number
bDoAll | If true, all data is moved regardless of the items' item_changed_state

Description

Entry_display displays data from the data_file and data_field to every entry_item connected to it. If iFile is non-zero, the display is done only if iFile is the data_file or bDoAll is true. If iFile is zero and the data_file is included in the current data-set action, the display is done regardless of the value of bDoAll. Every item displayed by this message will have its item_changed_state set to false. Any displayed item whose checkbox_item_state is true will have its select_state set in accordance with the value of the field it is associated with.

Last Edited: October 6, 2004


Cm_Entry [Procedure Entry_Update]

Entry_Update - Cm_Entry

Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number

Type: Procedure

Parameters: Integer iFile Boolean bDoAll

Parameter | Description
iFile | The file number
bDoAll | If true, all data is moved regardless of the items' item_changed_state

Description

The entry_update message moves data from all entry items of an object whose data_file is equal to iFile and whose item_changed_state is true, to the record buffer of iFile. If iFile is 0, data is moved from all items regardless of their data_file, and if bDoAll is true, all data is moved regardless of the items' item_changed_state. This message is used by the dfBaseEntry packages.

send entry_update to (aform(self)) cust_file false

The data-entry system uses the entry_update message just prior to the entry_find. The update is performed by moving the values of all of the fields for the specified file to the record buffer. This is done by setting the value of the bDoAll parameter to true.

Last Edited: August 5, 2003


Properties for Cm_Entry

View property list in hierarchical order

Name | Description | Defining Class
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | Cm_Menu
Autofind_Item |  |
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | Cm_Menu
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with |
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Bottom_Item | Returns the item number of the last item on the display |
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object |
Changed_State | Set when users change information in the items of the menu | Cm_Menu
Checkbox_Item_State | Allows any item to become a checkbox-type item | Cm_Menu
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | Cm_Menu
Current_Row | Return the row number of the current_item |
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared |
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | Cm_Menu
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | Cm_Menu
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | Cm_Menu
Item_Count | A read-only property of menu-class objects | Cm_Menu
Item_Entry_Msg | Sent in response to the item_change or the entering message |
Item_Exit_Msg | Sent in response to the item_change or the exiting message |
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with |
Item_Matching | Searches a menu of items for a matching string value | Cm_Menu
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem |
Item_Options | Allows you to copy item options or set them in a group |
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | Cm_Menu
Line_Width | Specifies the number of columns and displayable rows in a list | Cm_Menu
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | Cm_Menu
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Validation | Controls whether the validate messages have any effect |
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message |
Prototype_Object |  | Cm_Menu
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in |
Row_Count | Returns the number of rows in a dbGrid-class object |
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | Cm_Menu
Select_Count | Maintains the total number of selected items in the menu | Cm_Menu
Select_Mode | Determines how item-level selections are processed | Cm_Menu
Select_State | Each item may be selected by setting the select_state of the item | Cm_Menu
Shadow_State | Determines if item is enabled (not shadowed) | Cm_Menu
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Top_Item | The item that is first in the display window | Cm_Menu
Top_Row | Returns the row number of the top row on the display |
Valid_Item | Causes the validation of a single item identified by the iItem |
Value | Gets and sets the data value for an item | Cm_Menu
Visible_State | Determines whether object is visible | cUIObject
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | Cm_Menu
Zoom_Object | Sets the destination object_id of the popup message to the specified object |


Cm_Entry [Property Autofind_Item]

Autofind_Item - Cm_Entry

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


Cm_Entry [Property Base_Item]

Base_Item - Cm_Entry

Defines the starting item number that the DfBaseEntry messages are to work with

Type: Property

Access: Read/Write

Data Type: Integer

Description

The base_item property (along with item_limit) is used to limit the scope of the standard entry-item manipulation messages. The base_item defines the starting item number that the DfBaseEntry messages are to work with. The messages affected are: entry_display, entry_update, entry_clear, item_change, validate_items. If the property is not set, the item set begins with the first item. The base_item along with the item_limit property are used to limit the scope of the standard entry messages.

This message is of no little use to single item entry objects (its value will always be 0). This message is used in the dbGrid class to define the current_row.

Last Edited: July 30, 2003


Cm_Entry [Property Bottom_Item]

Bottom_Item - Cm_Entry

Returns the item number of the last item on the display

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Bottom_item property returns the item number of the last item on the display. This property is used by dbGrid-class objects. It is of little use in single-item entry objects.

Last Edited: July 30, 2003


Cm_Entry [Property Bottom_Row]

Bottom_Row - Cm_Entry

Returns the number of the bottom row on the display of a dbGrid-class object

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Bottom_row property returns the number of the bottom row on the display of a dbGrid-class object. The item_limit of the grid must be set for this message to work.

Last Edited: July 30, 2003


Cm_Entry [Property Current_Row]

Current_Row - Cm_Entry

Return the row number of the current_item

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Current_row property is used with dbGrid-class objects to return the row number of the current_item. The item_limit must be set for this message to work.

Last Edited: August 13, 2003


Cm_Entry [Property Data_Field]

Data_Field - Cm_Entry

Identifies the database field from which data is to be stored, retrieved, and cleared

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iField

Parameter | Description
iItem | The item number
iField | The field number

Description

Each entry_item may have a field in a database file associated with it. The data_field identifies the database field from which data is to be stored, retrieved, and cleared. Data_fields are most often set by the entry_item command.

entry_item customer.name

They may also be set using the data_field message. This may be done if an entry item needs to be set to another field number than the initialized one. Data_field numbers begin with 0 for recnum and count up to the number of fields in the file with which the item is associated. Values outside this range are errors.

set data_field item 0 to 4

get data_field item 0 to var

If the entry_item is not associated with a data field (it is associated with an expression or variable), the value of this property is 0.

Last Edited: July 31, 2003


Cm_Entry [Property Data_File]

Data_File - Cm_Entry

Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iFile

Parameter | Description
iItem | The item number
iFile | The file number

Description

Each entry_item may have a field in a database file associated with it. The Data_file property identifies the database file that contains the field from which data is to be stored, retrieved, and cleared. Data_files are most often set by the composition of the entry_item statement itself.

entry_item customer.name

They may also be set using the data_file message. This may be done if an entry item needs to be set to another file than the initialized one.

set data_file item 0 to customer.File_Number

get data_file item 0 to filenumber

If the entry_item is not associated with a data field (it is associated with an expression or variable) the value of this property is 0.

Last Edited: August 5, 2003


Cm_Entry [Property Displayable_Rows]

Displayable_Rows - Cm_Entry

Returns the number of rows that are visible in the display of a dbGrid-class object

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Displayable_Rows property returns the number of rows that are visible in the display of a dbGrid-class object. The item_limit of the object must be set for this message to work.

Last Edited: October 6, 2004


Cm_Entry [Property Item_Entry_Msg]

Item_Entry_Msg - Cm_Entry

Sent in response to the item_change or the entering message

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iMessage

Parameter | Description
iItem | The item number
iMessage | The message number

Description

The entry_item has a message which is sent every time the item is entered by a user. The Item_entry_msg message is sent in response to the item_change or the Entering message. The value of this property is sent as a parameter to the item_entry function. You may override the function with custom entry processing of the item.

set item_entry_msg item 0 to msg_set_up_data

Last Edited: September 25, 2003


Cm_Entry [Property Item_Exit_Msg]

Item_Exit_Msg - Cm_Entry

Sent in response to the item_change or the exiting message

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iMessage

Parameter | Description
iItem | The item number
iMessage | The message number

Description

Each entry_item has a message which is sent every time the item is exited by the user. The Item_exit_msg message is sent in response to the item_change or the exiting message. The item_exit_msg property is sent as a parameter to the item_exit function. You may override the function with custom exit processing of the item.

set item_exit_msg item 0 to msg_exiting_field

Last Edited: September 25, 2003


Cm_Entry [Property Item_Limit]

Item_Limit - Cm_Entry

Defines the number of entry items in the group that the entry messages are to work with

Type: Property

Access: Read/Write

Data Type: Integer

Description

The item_limit property (along with base_item) are used to limit the scope of the standard entry-item-manipulation messages. The item_limit defines the number of entry items in the group that the entry messages are to work with. The messages affected are: entry_display, entry_update, entry_clear, item_change, and validate_items. If the property is not set, the total number of items is used. This property is of little use in single item entry objects. This property is used by dbGrid class objects to limit the scope of the data entry messages to the "current row".

When in the WideList class, default is 1.

Last Edited: August 18, 2003


Cm_Entry [Property Item_Option]

Item_Option - Cm_Entry

Allows you to query or change the skipfound format option on the entry_item command line for Item iItem

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Integer eOption boolean bEnable

Parameter | Description
iItem | The item number
eOption | The entry option
bEnable | True to enable, false to disable

Description

The Item_option property allows you to query or change the skipfound format option on the entry_item command line for Item iItem. The option setting is returned as a boolean value. The option is set or turned off by setting a boolean value in the property.

set item_option item 0 to skipfound true

if (item_option(self, 0, skipfound)) send check_status

Default is false.

Last Edited: August 18, 2003


Cm_Entry [Property Item_Options]

Item_Options - Cm_Entry

Allows you to copy item options or set them in a group

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iOptions

Parameter | Description
iItem | The item number
iOptions | The option number

Description

The Item_options property is the combination of all of the item_options. The message is provided to allow you to copy item options or set them in a group. The top 16 bits of the item options are for internal use and should not be changed by users. When you set item_options, you will usually wish to set field_options as well.

Get item_options item 0 to opts
set item_options of (scanner(self)) item 0 to opts
set field_options of (scanner(self)) item 0 to opts

In this example, the item_options of the current item of Object scanner are set to those of the first item of the current object.

To query, or get, the item_options of an item, use the individual item_option messages documented in this class.

Last Edited: August 18, 2003


Cm_Entry [Property Item_Validate_Msg]

Item_Validate_Msg - Cm_Entry

Sent in response to the item_change or the exiting message, every time the item is validated

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iMessage

Parameter | Description
iItem | The item number
iMessage | The message number

Description

Each entry_item has a message which is sent every time the item is validated. This message is sent in response to the item_change or the exiting message. You may override the property with custom validation processing of the item.

set item_validate_msg item 0 to validate_price_msg

Last Edited: January 12, 2006


Cm_Entry [Property Object_Validation]

Object_Validation - Cm_Entry

Controls whether the validate messages have any effect

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The object_validation property controls whether the validate messages have any effect. This is useful when a program needs to change the current_item and to disable the validation process that would occur when the item change takes place.

set object_validation to false

Default is true.

Last Edited: September 10, 2003


Cm_Entry [Property Prompt_Object]

Prompt_Object - Cm_Entry

Specifies the default receiving object for the popup message

Type: Property

Access: Read/Write

Data Type: Handle

Parameters: Integer iItem Handle hoPrompt

Parameter | Description
iItem | The item number
hoPrompt | Handle of the prompt object

Description

The Prompt_object property specifies the default receiving object for the popup message. By default, the property is not used in objects of this class, but is used in many of its subclasses, such as dbForm. Only single-item prompt objects are supported.

Last Edited: September 11, 2003


Cm_Entry [Property Row]

Row - Cm_Entry

Returns the row in a grid that a passed item is located in

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iItem Integer iValue

Parameter | Description
iItem | The item number
iValue | The row in a grid that the past iItem is located in

Description

The Row property returns the Row in a grid that a passed item is located in. The object's item_limit must be set to the number of items in a Row for this function to return a result. This message is used by the dbGrid class, and may be used by all rectangular types of dfBaseEntry objects.

integer iOldItem iNewItem
if (Row(Self,iOldItem)<>Row(Self,iNewItem)) ;
    send Save_Row (Row(Self,iOldItem))

The above code fragment checks to see if the user has changed Rows and if so, automatically saves the Row being exited.

Last Edited: August 6, 2004


Cm_Entry [Property Row_Count]

Row_Count - Cm_Entry

Returns the number of rows in a dbGrid-class object

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Row_Count property returns the number of rows in a dbGrid-class object. The item_limit must be set to the number of items in a row for this message to work.

The property returns the current number of rows filled with data. So if the number of visible rows (which you can query with Displayable_Rows) is 5 and you can see 4 rows filled with data the Row_Count property returns 4. If the table contains more than 5 records, so that all rows in the dbGrid are filled, Row_Count will be equal to Displayable_Rows.

integer i iCount
get Row_Count to iCount
decrement iCount
For i From 0 to iCount
    :
Loop

Last Edited: June 4, 2004


Cm_Entry [Property Top_Row]

Top_Row - Cm_Entry

Returns the row number of the top row on the display

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Top_row property returns the row number of the top row on the display. This message is used in dbGrid-class objects. The item_limit must be set for this message to work.

if (top_row(self) <>0) send scroll upward_direction 1

Last Edited: September 11, 2003


Cm_Entry [Property Valid_Item]

Valid_Item - Cm_Entry

Causes the validation of a single item identified by the iItem

Type: Property

Access: Read-Only

Data Type: Boolean

Parameters: Integer iItem Boolean bValue

Parameter | Description
iItem | The item number
bValue | 0 if valid, non 0 if invalid

Description

The Valid_item property will cause the validation of a single item identified by the iItem. The return value of the function is the result of the validation process (0 if valid).

if (valid_item(Self, current)) send bell

Last Edited: August 6, 2004


Cm_Entry [Property Zoom_Object]

Zoom_Object - Cm_Entry

Sets the destination object_id of the popup message to the specified object

Type: Property

Access: Read/Write

Data Type: Handle

Parameters: Integer iItem Handle hoPrompt

Parameter | Description
iItem | The item number
hoPrompt | Handle of the zoom object

Description

The zoom object property is used to set the destination object_id of the popup message to the specified object. By default, the property is not used in the base data-entry object, but is provided for use in higher-level classes, such as dbForm.

Last Edited: August 4, 2006


Cm_Menu [Event Item_Change]

Item_Change - Cm_Menu

A programming "hook" to perform an action on change of an item

Type: Event

Return Data Type: Integer

Parameters: Integer iFromItem Integer iToItem

Parameter | Description
iFromItem | Item to change from
iToItem | Item to change to

Return Value

Returns the whatever the item has changed to

Description

The Item_Change event is triggered each time the current item has changed. By default, the message will cause auto_select-mode objects to track the selected item along with the Current_Item. The message is provided as a programming "hook" to perform an action on change of an item.

Procedure Item_Change integer iFromItem integer iToItem returns integer
    integer iRetVal

    if (Validate(Self,iFromItem) <> 0) begin
        send Bell
        procedure_return iFromItem
    end
    forward get msg_Item_Change iFromItem iToItem to iRetVal
    Procedure_Return iRetVal
End_Procedure  // Item_Change

Last Edited: February 16, 2005


Cm_Menu [Event Key]

Key - Cm_Menu

Augmented to implement the GUI keyboard interface

Type: Event

Return Data Type: Integer

Parameters: Integer iKeyValue

Parameter | Description
iKeyValue | The key value

Return Value

Returns a Key value

Description

The Key message is augmented to implement the GUI keyboard interface.

You can augment this message to intercept keystrokes by the user and act on them.
You can also overwrite or intercept this message to disallow keyboard input or to ignore certain keyboard input.

Sample

This sample overwrites this message to disallow all keyboard input in the current object or class.

Procedure Key Integer iKeyVal
End_Procedure  // Key

Sample

This sample augments this message to disallow all keyboard of digits 0-9 in the current object or class.

Procedure Key Integer iKeyVal
    // 48 = '0', 57 = '9'
    if ((iKeyVal<48) and (iKeyVal>57)) ;
        forward send Key IKeyVal
End_Procedure  // Key

See Also

KeyAction

Last Edited: August 16, 2004


Events for Cm_Menu

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Item_Change | A programming "hook" to perform an action on change of an item |
Key | Augmented to implement the GUI keyboard interface |
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for Cm_Menu

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed |
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change |
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Select_Count | Procedure Set | Maintains the total number of selected items in the menu |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object |


Cm_Menu [Procedure Set New_Item]

New_Item - Cm_Menu

Sets the current_item without triggering the code that may be associated with item_change

Type: Procedure Set

Data Type: Integer

Parameters: Integer iItem

Parameter | Description
iItem | The item to be set

Description

The New_item message is the same as set current_item, except that item_change is not sent. This message is used when you want to set the current_item without triggering the code that may be associated with item_change.

set new_item to (current_item(self)  1)

Last Edited: September 10, 2003


Cm_Menu [Procedure Set Select_Count]

Select_Count - Cm_Menu

Maintains the total number of selected items in the menu

Type: Procedure Set

Data Type: Integer

Parameters: Integer iCount

Parameter | Description
iCount | Menu number

Description

The select_count property maintains the total number of selected items in the menu. As items are selected or deselected, the select_count property is updated. If the select_count property is set, it will affect all the items in the object. If the count parameter is true, all items (except shadowed / disabled items) will be selected. If the count parameter is false, then all items will be deselected. The select_count property is typically used with multi_select menus and lists. The user may select zero, one, or many items from the menu, and then submit the list. Use the select_count property to determine if users have selected any items, and if so how many.

Sample

The sample code below can be used in a button.

Object oChangeSelectAllButton is a Button
    Set Location To 100 100
    Set Label To "Select All"

    Procedure OnClick
        Get Select_Count of oList1 To iSelectedItems
        If (iSelectedItems > 0) Begin
            Set Select_Count of oList1 To 0
            Set Label To "Select All"
        End
        Else Begin
            Set Select_Count of oList1 To 1
            Set Label To "Deselect All"
        End
    End_Procedure // OnClick
End_Object // oChangeSelectAllButton

Last Edited: September 22, 2005


Cm_Menu [Procedure Delete_Data]

Delete_Data - Cm_Menu

Painted to update the screen after all items in the list are destroyed

Type: Procedure

Parameters: No Parameters

Description

All items in the list are destroyed, and the memory taken up by their data is returned back to the system. The object is then painted to update the screen.

send delete_data of (my_list(self))

Last Edited: February 17, 2004


Cm_Menu [Procedure Down]

Down - Cm_Menu

Sends the key kdownarrow message to the object

Type: Procedure

Parameters: No Parameters

Description

The Down message sends the key kdownarrow message to the object. This will reset the current item to the new item.

send down to (amenu(self))

Last Edited: August 5, 2003


Cm_Menu [Procedure Up]

Up - Cm_Menu

Sends the key kuparrow to the object

Type: Procedure

Parameters: No Parameters

Description

The Up message sends the key kuparrow to the object. The object will set current_item to the proper item above the current one.

send up to (amenu(self))

Last Edited: September 11, 2003


Properties for Cm_Menu

View property list in hierarchical order

Name | Description | Defining Class
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus |
Aux_Value | Is only used by the system if an object is referenced on the on_item command line |
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Changed_State | Set when users change information in the items of the menu |
Checkbox_Item_State | Allows any item to become a checkbox-type item |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to |
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields |
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true |
Item_Count | A read-only property of menu-class objects |
Item_Matching | Searches a menu of items for a matching string value |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu |
Line_Width | Specifies the number of columns and displayable rows in a list |
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice |
Select_Count | Maintains the total number of selected items in the menu |
Select_Mode | Determines how item-level selections are processed |
Select_State | Each item may be selected by setting the select_state of the item |
Shadow_State | Determines if item is enabled (not shadowed) |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Top_Item | The item that is first in the display window |
Value | Gets and sets the data value for an item |
Visible_State | Determines whether object is visible | cUIObject
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation |


Cm_Menu [Property Auto_Top_Item_State]

Auto_Top_Item_State - Cm_Menu

Determines if the current_item is set to the top_item when the object takes the focus

Type: Property

Access: Read/Write

Data Type: Boolean

Description

By default, when a menu class object takes the focus, it will set the current_item to the top_item of the menu. This action is controlled by the state of the auto_top_item_state property. If the state is set to false, the current_item will not be reset by the system.

set auto_top_item_state to false

Default is true.

When in the EntryList class, default is false.

Last Edited: July 30, 2003


Cm_Menu [Property Aux_Value]

Aux_Value - Cm_Menu

Is only used by the system if an object is referenced on the on_item command line

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iValue

Parameter | Description
iItem | The item number
iValue | Integer value

Description

Each item has a property which is often used by the system to contain the object_id of the object to send the item's message to. The Aux_Value property is only used by the system if an object is referenced on the on_item command line. If no object is referenced, the message will be directed to the current object regardless of the value of this property.

If this property is not so used to hold an object reference in an on_item command, you may use it to store any integer value you might wish to have associated with the item.

set aux_value to (special_value(self))

on_item "test" send do_test to desktop
:
set aux_value to (anotherobject(self))

Last Edited: July 30, 2003


Cm_Menu [Property Changed_State]

Changed_State - Cm_Menu

Set when users change information in the items of the menu

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The changed_state of an object is set when users change information in the items of the menu. Users may change an item by performing data entry with the entry message, or changing its select_state with the kspace key. If the changed_state of the object is set true, then the item_changed_state of all the items of the object will be set true. This does not hold for setting the object's changed_state false.

set changed_state to false

get changed_state of (amenu(self)) to var

if changed_state send save_data

The object will not save when this state is false. When necessary (as when changes are made other than through the keyboard), set this state to true explicitly.

Default is false.

Last Edited: July 30, 2003


Cm_Menu [Property Checkbox_Item_State]

Checkbox_Item_State - Cm_Menu

Allows any item to become a checkbox-type item

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Boolean bCheckBox

Parameter | Description
iItem | The item number
bCheckBox | True if item is a checkbox, false if not

Description

Any item may become a checkbox-type item when its checkbox_item_state is set to true. The object's select_mode should be set to one of the modes other than no_select to allow users to select the choice that is desired.

The Select_State message should be used to let the checkbox show as marked/selected or not.

Default is false.

Sample code to create a grid with two columns and set the first column as a checkbox column:

Object oSelectGrid is a Grid
    Set CurrentCellColor to clYellow
    Set CurrentRowColor to clLime

    Set Size to 102 285
    Set Location to 5 5

    Set Resize_Column_state to FALSE
    Set Highlight_Row_state to TRUE

    Set Line_Width to 2 0
    Set Form_Width    item 0 to 15
    Set Header_Label  item 0 to ""
    Set Form_Width    item 1 to 262
    Set Header_Label  item 1 to "Bitmaps"

    Set Select_Mode To Multi_Select

    Procedure Activating
        Forward Send Activating
        Send DoLoadDirectory
    End_Procedure // DoLoadDirectory

    Procedure Select_Toggling Integer iItem Integer iState
        integer iColumns

        get Line_Size to iColumns
        if (iItem = Current) Begin
            Get Current_Item To iItem
        End
        If (Mod (iItem, iColumns) = 0) Begin
            Forward Send Select_Toggling iItem iState
        End
        Else Begin
            Forward Send Select_Toggling (Integer (iItem / iColumns) * iColumns) iState
        End
    End_Procedure // Select_Toggling

    Procedure DoLoadDirectory
        string sDirEntry
        integer iChannel

        move (Seq_New_Channel()) To iChannel
        if (iChannel >= 0) Begin
            Direct_Input Channel iChannel "DIR:C:\Program Files\Visual DataFlex 11.0\Bitmaps\*.bmp"
            while (not(SeqEOF))
               Readln Channel iChannel sDirEntry
               If ( (Not(SeqEOF)) And (Left (sDirEntry, 1) <> "[")) Begin
                  Send Add_Item Msg_None ""
                  Set Checkbox_Item_State (Item_Count (Self) - 1) To True
                  Send Add_Item Msg_None sDirEntry
                  Set Entry_State (Item_Count (Self) - 1) To False
               End
            loop
            Close_Input Channel iChannel
            Send Seq_Release_Channel iChannel
        end

        Set Dynamic_Update_State To True
    End_Procedure // DoLoadDirectory

End_Object    // oSelectGrid

Last Edited: August 10, 2006


Cm_Menu [Property Current_Item]

Current_Item - Cm_Menu

The object that the end user is currently pointing to

Type: Property

Access: Read/Write

Data Type: Integer

Description

The current_item of an object is the object that the end user is currently pointing to. Each menu has a current item at all times. The constant current is a shorthand way of identifying the current item. When users move from one item to the next, the interface will send the set current_item message to the focus. If the object needs to scroll, the screen will be updated immediately. The message item_change is also triggered by this event.

set Current_Item to 5

if (Current_Item = 7) ;
    set Current_Item to 0

Last Edited: June 20, 2005


Cm_Menu [Property Display_Size]

Display_Size - Cm_Menu

Returns the number of windows in the menu

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Display_size property returns the number of windows in the menu. This message is often used when the programmer needs to exercise a greater level of control over the interface. The display_size is often used to determine information such as the number of rows in a table-like object.

if (display_size(amenu)) eq 1 set special_case to true

Last Edited: July 31, 2003


Cm_Menu [Property Entry_State]

Entry_State - Cm_Menu

Determines if the items of menu class objects may become data-entry fields

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Boolean bAllowed

Parameter | Description
iItem | The item number
bAllowed | True if data can be entered into the item, false if not

Description

The items of menu class objects may become data-entry fields if their entry_state is set to true. When the selection cursor rests on a non-shadowed entry item, the system will gather input. If the item is shadowed, data entry is not allowed into the item.

Procedure DoAddReadOnlyItem String sText
    Send Add_Item Msg_None sText
    Set Entry_State Item (Item_Count (Self) - 1) To False
End_Procedure // DoAddReadOnlyItem

Default is false.

Last Edited: August 18, 2003


Cm_Menu [Property Item_Changed_State]

Item_Changed_State - Cm_Menu

Data entry to, or selection of, an item causes its item_changed_state property to become true

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Integer bChanged

Parameter | Description
iItem | The item number
bChanged | True if item changed, false if not

Description

Data entry to, or selection of, an item causes its item_changed_state property to become true. The program should not control any actions by use of this property. The value of this property may be inverted (regardless of its initial value) by setting it to toggle_state.

Last Edited: December 20, 2005


Cm_Menu [Property Item_Count]

Item_Count - Cm_Menu

A read-only property of menu-class objects

Type: Property

Access: Read-Only

Data Type: Integer

Description

The item_count property is a read-only property of menu-class objects. The property returns the total number of items owned by the object.

if (item_count(self)) gt 0 send fill_values

Move (item_count(self)-1) to count
for i from 0 to count
    :
loop

Last Edited: August 18, 2003


Cm_Menu [Property Item_Matching]

Item_Matching - Cm_Menu

Searches a menu of items for a matching string value

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: String sMatch Integer iItem Integer iValue

Parameter | Description
sMatch | The match string
iItem | Search start and returned matching item
iValue | 0 if found, 1 if not found

Description

The item_matching message searches a menu of items for a matching string value. By default, the search is not case sensitive. You may make the search case_sensitive by setting Search_Case to True.

The search begins at iItem and returns the item number of the first matching item. If the item was not found, then the message returns 1. The search string may include the ? and * wildcard characters. Literal asterisks (*) and question marks (?) may be found by preceding the characters with a tilde (~). You may add 1 to the returned iItem value to continue the search for the next occurrence. This message may not be used as a function in an expression since the return value is placed in the iItem parameter. This message is sent by the key message each time the object needs to perform an incremental search.

Procedure Test
    integer iItem

    get item_matching "FIND_ME" to iItem
    if (iItem =  -1) ;
        send Bell
    else ;
        set Current_Item to iItem
End_Procedure  // Test

Because the number of the item that matches is returned to the iItem parameter that is passed, iItem must be a variable (may not be a literal number). For example, to augment this message, the following technique should be used:

function item_matching string match_string integer item_number
    integer match_item
    move item_number to match_item
    get item_matching match_string to match_item
    :
    function_return match_item
end_function

Augmenting item_matching will not work for menu-based classes that handle databases (data-entry objects, or DEOs). In order to invoke case insensitivity in DEO lists (selection_list, table) you may either add a capslock format option to the entry_item command for the search field(s) or use a case-insensitive index.

Last Edited: June 21, 2006


Cm_Menu [Property Line_Size]

Line_Size - Cm_Menu

Returns number of columns of a grid or number windows per line of a menu

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Line_size property returns the number of columns of a grid object or the number of windows per line of a menu object.

In menus, this width is used along with the display_size to determine the number of rows of a rectangular area of windows.

Sample

This sample shows how to obtain the number of columns in a Grid.

Procedure DoSomething
    integer iColumns

    get Line_Size to iColumns

    :
End_Procedure  // DoSomething

Sample

Sample for a menu object.

get line_size of (abox(self)) to width

Last Edited: December 8, 2004


Cm_Menu [Property Line_Width]

Line_Width - Cm_Menu

Specifies the number of columns and displayable rows in a list

Type: Property

Access: Write-Only

Data Type: Integer

Parameters: Integer iColumns Integer iRows

Parameter | Description
iColumns | The number of columns
iRows | The number of rows

Description

Line_width specifies the number of columns and displayable rows in a list. The first value represents the number of columns and by default creates a single-column list. The second value should almost always be set to 0. This instructs the list to calculate the number of displayable rows based on the size of the object.

Last Edited: October 6, 2004


Cm_Menu [Property Message]

Message - Cm_Menu

Identifies the message that is sent when users press kenter on the item

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iMessage

Parameter | Description
iItem | The item number
iMessage | The message ID

Description

The Message property identifies the message that is sent when users press kenter on the item. Each item has a message property. The message will be sent to the current object. If that object does not understand the message, the system will use the normal delegation rules to delegate the message to another object.

set message item 3 to msg_none

Normally the message property of an item is set by the on_item command or the add_item and insert_item messages. The message property is usually used to get the ID of the message and send it as a parameter to another message.

send process (message(self,current))

Last Edited: August 18, 2003


Cm_Menu [Property Prototype_Object]

Prototype_Object - Cm_Menu

Type: Property

Access: Read-Only

Data Type: Handle

Description

Last Edited: February 13, 2003


Cm_Menu [Property Search_Mode]

Search_Mode - Cm_Menu

Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice

Type: Property

Access: Read/Write

Data Type: Integer

Description

The search_mode property determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice. By default, menu class objects are set to capital search. This type of search moves the cursor to the first choice beyond the cursor position in which the input letter is present in uppercase. Examples include the F in File and the X in eXit. Only the first capital letter in the choice content is respected. The search is insensitive to the case of the letter input. Capital letter search is not supported for virtual lists except within the current display page.

First_character search moves the cursor to the next choice beyond the cursor whose content begins with the input character. The search is case-insensitive in all respects. Starting from the top of a list made up of File, forMat, and eXit, repeated pressing of F or f would place the cursor first on File, then on forMat, and never on eXit. In a list of choices made up exclusively of capital letters, there is no difference between first_character and capital search modes. A first character search mechanism is available for virtual lists, with one exception: pressing the key for the same character repeatedly does not advance to the next item with the same first character for virtual lists (it does for non-virtual lists). This is a known limitation.

The incremental search mode moves the cursor to the next choice whose beginning characters match the sequence of characters input by users since the cursor entered the list. Unless the item the cursor is on already matches, each character entered moves the cursor to the next item whose beginning characters match, if any. Pressing backspace removes the last character typed and moves the cursor back to the previous choice that it was on. The incremental search mechanism permits incremental searching on parent files of the main file of the list.

No_search causes the object to ignore all alphanumeric keys and respond to standard navigation keys only.

set search_mode to no_search

if search_mode eq capital send find_key

Default is capital.

Last Edited: September 11, 2003


Cm_Menu [Property Select_Count]

Select_Count - Cm_Menu

Maintains the total number of selected items in the menu

Type: Property

Access: Read-Only

Data Type: Integer

Description

The select_count property maintains the total number of selected items in the menu. As items are selected or deselected the select_count property is updated.

The select_count property is typically used with multi_select menus and lists. The user may select zero, one, or multiple items and the program can process them. To select more than one item, the Select_Mode property should be set to Multi_Select. Use the select_count property to determine if users have selected any items and if so, how many.

Sample

Get Select_Count To iSelectedItems
If (iSelectedItems > 0) Begin
    Get Item_Count To iItems
    Decrement iItems
    While (iItems >= 0)
        Get Select_State Item iItems To bSelected
        If (bSelected) Begin
            // Do whatever you want to do with the selected item
        End
        Decrement iItems
    Loop
End

Last Edited: March 17, 2006


Cm_Menu [Property Select_Mode]

Select_Mode - Cm_Menu

Determines how item-level selections are processed

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Select_Mode of the object is used to determine how item-level selections are processed.

Constant | Meaning
No_Select | This mode will disable the user-driven selection key, kspace
Single_Select | Used when none or a single selection is allowed. As the user selects items in the menu, any item previously selected will be reset.
Auto_Select | Similar to Single_Select, but the Current_Item is always selected
Multi_Select | Allows the operator to select zero, one, or many items in the menu. The number of selected items is maintained by the select_count property.

set Select_Mode of oMultiMenu to Multi_Select

The default mode is No_Select.

Last Edited: September 22, 2005


Cm_Menu [Property Select_State]

Select_State - Cm_Menu

Each item may be selected by setting the select_state of the item

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Integer bSelected

Parameter | Description
iItem | The item number
bSelected | Determines if the item is selected (true) or not selected (false)

Description

Each item may be selected by setting the select_state of the item. The user sets this state by pressing the kspace key when on a menu which has its select_mode set to other than no_select. Shadowed items may not be selected. If the list is single_select, then only one item may be selected at a time. Select_Count is automatically updated by setting the select_state of an item. If the item is on the screen, the display will immediately reflect the change in state of the item.

integer iCurrent
get Current_Item to iCurrent
set Select_State of oChoices iCurrent to True

if (Select_State(Self, iCurrent)) send Process_Item

The value of this property may be inverted, regardless of its initial value, by setting it to toggle_state.

Default is false.

Last Edited: December 20, 2005


Cm_Menu [Property Shadow_State]

Shadow_State - Cm_Menu

Determines if item is enabled (not shadowed)

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Boolean bShadowed

Parameter | Description
iItem | The item number
bShadowed | True if disable/shadowed, false if enabled/not shadowed

Description

Shadowing an item affects both its appearance and its functionality. A shadowed item will be displayed in the shadowed color (defined by the desktop or its palette). If a user places the selection cursor on a shadowed item, the item will not respond to the kenter key or any mouse action.

set shadow_state 4 to true

if (shadow_state(Self, current)) send ignore_item

Default is false.

Last Edited: August 6, 2004


Cm_Menu [Property Top_Item]

Top_Item - Cm_Menu

The item that is first in the display window

Type: Property

Access: Read/Write

Data Type: Integer

Description

The top_item of a menu class object is the item that is first in the display window. That item may change through scrolling or direct navigation, i.e., incremental search. If the programmer sets the top_item, then the list will adjust itself to display the new item selected at the top of the list. If the selected item is outside the range of valid item numbers, then the operation is ignored. If the operation results in the current_item being moved off the screen, then the current_item is set to the top_item.

set top_item to (current_item(self)  5)

if top_item gt 10 send list_full

Last Edited: September 11, 2003


Cm_Menu [Property Value]

Value - Cm_Menu

Gets and sets the data value for an item

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iItem String sValue

Parameter | Description
iItem | The item number
sValue | Data value

Description

Each item and entry item has a value. The value is displayed when the object is painted and the item is in the visible portion of the screen. The value is stored as a string. If the item_number is out of range, the operation is ignored. The screen is updated to reflect the new value of the item.

set value to "Compile program"

set value to customer.purchases

set value of oMenu 4 to "Number 4"

if (value(Self,Current) = "TEST") send testing

The section below applies only to list-based classes

Each cell in a grid is an item. A grid can have 0 to many items. Item references start with 0. The form_datatype and form_mask properties set the type of the value (number, string, integer etc). The form_margin property determines the number of characters a user can enter in the cell. Before an item can be referenced it needs to be created.

Samples:

If a grid has 3 columns and you want to add the following information (stored in an array of structs):

"ABC", "ABC Corp", 100000
"DEF", "DEF Corp", 200000
"XYZ", "XYZ Corp", 400000

You can use:

    Procedure DoFillGrid tsCustomer[] sCustomer
        Integer iCustomers iCustomer

        Move (SizeOfArray (sCustomer)) To iCustomers
        Decrement iCustomers
          For iCustomer From 0 To iCustomers
            Send Add_Item Msg_None sCustomer[iCustomer].Code
            Send Add_Item Msg_None sCustomer[iCustomer].Name
            Send Add_Item Msg_None sCustomer[iCustomer].Budget
          Loop
    End_Procedure

The array of customer information is passed to the procedure with:

    Send DoFillGrid sCustomer

Getting the name of the second customer can be done with:

    Get Value Item 4 To sCustomerName

Or

    Get Value Item (iCustomer * 3 + 1) To sCustomerName

Last Edited: September 2, 2005


Cm_Menu [Property Wrap_State]

Wrap_State - Cm_Menu

Controls the action of the cursor control keys and search_mode ranges during item navigation

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The wrap_state controls the action of the cursor control keys and search_mode ranges during item navigation. If the wrap_state is set true, then when a(n arrow) key is pressed to move the cursor beyond the end or beginning of the list, the cursor will move to the item on the opposite end of the list. When a search_mode is in effect, the range of the search is extended beyond the end of the list to "wrap" back around to the beginning of the list if a qualifying item is not found.

set wrap_state of (amenu(self)) to true

Default is false.

Last Edited: September 15, 2003


Events for cMapiHandler

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cMapiHandler [Function AddressBook]

AddressBook - cMapiHandler

Used to browse / select an entry from the Addressbook

Type: Function

Return Data Type: Integer

Parameters: String sDialogCaption

Parameter | Description
sDialogCaption | Text to display in the caption bar of the opened addressbook panel

Return Value

Returns zero if successful, otherwise returns a non-zero error code.

Description

This function is used to browse / select an entry from the Addressbook. It calls the MAPIAddress function.

This function returns one of the following error codes if not successful:

Error code | Meaning
1 | The user canceled one of the dialog boxes. The name was not resolved.
2 | One or more unspecified errors occurred. No message was sent.
3 | There was no default logon, and the user failed to log on successfully when the logon dialog box was displayed. No message was sent.
5 | There was insufficient memory to proceed. No message was sent.
19 | An invalid session handle was used for the lhSession parameter. No list of recipient entries was returned.
24 | The value of the nEditFields parameter was outside the range of 0 through 4. No list of recipient entries was returned.
25 | One or more of the recipients in the address list was not valid. No list of recipient entries was returned.
26 | The operation was not supported by the underlying messaging system.

Example

Get AddressBook Of oMapiSession "Select one or more receivers" To iRetval

Last Edited: July 30, 2003


cMapiHandler [Function AddresseeDetails]

AddresseeDetails - cMapiHandler

Displays a dialog box containing the details of a selected address list entry

Type: Function

Return Data Type: Integer

Parameters: String sEntryId Integer iLength

Parameter | Description
sEntryId | A variable that holds a pointer to an internal pointer for the address list entry. A sample can be found in readmail.dg where you can get the detail information for a recipient belonging to a particular message. Right-click on a message recipient and select details
iLength | The length of the sEntryId variable. The value should come from stored information returned by the ResolveName function.

Return Value

Returns zero if successful, otherwise returns a non-zero error code.

Description

The AddresseeDetails function displays a dialog box containing the details of a selected address list entry.

This function returns one of the following error codes if not successful:

Error code | Explanation
1 | The user canceled either the logon dialog box or the details dialog box.
2 | One or more unspecified errors occurred. No dialog box was displayed.
3 | There was no default logon, and the user failed to log on successfully when the logon dialog box was displayed. No dialog box was displayed.
5 | There was insufficient memory to proceed. No dialog box was displayed.
21 | The dialog box could not be displayed because the ulEIDSize member of the structure pointed to by the lpRecips parameter was zero.
25 | The recipient specified in the lpRecip parameter was unknown or the recipient had an invalid ulEIDSize value. No dialog box was displayed.
26 | The operation was not supported by the underlying messaging system.

Example

Get AddresseeDetails Of oMapiSession sEntryId iLength To iRetval

Last Edited: July 30, 2003


cMapiHandler [Function AttachmentFileName]

AttachmentFileName - cMapiHandler

Returns the N-th attachment filename

Type: Function

Return Data Type: String

Parameters: Integer iAttachment

Parameter | Description
iAttachment | The N-th attachment of the message

Return Value

Filename of the N-th attachment

Description

The AttachmentFileName function returns the N-th attachment filename. The value of N must be passed via iAttachment.

Example

Get piMessageFileCount Of oMapiSession To iAttachments
For iCounter From 1 To iAttachments
   Get AttachmentFileName Of oMapiSession iCounter To sAttachFile

Last Edited: July 30, 2003


cMapiHandler [Function AttachmentPathName]

AttachmentPathName - cMapiHandler

Returns the N-th attachment pathname

Type: Function

Return Data Type: String

Parameters: Integer iAttachment

Parameter | Description
iAttachment | The N-th attachment of the message

Return Value

Pathname of the N-th attachment

Description

The AttachmentPathName function returns the N-th attachment pathname. The value of N must be passed via iAttachment.

Example

Get piMessageFileCount Of oMapiSession To iAttachments
For iCounter From 1 To iAttachments
   Get AttachmentPathName Of oMapiSession iCounter To sAttachPath

Last Edited: July 30, 2003


cMapiHandler [Function DeleteMail]

DeleteMail - cMapiHandler

Deletes a message from the message base

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns an error code (2, 5, 17, or 19) if not successful

Description

The DeleteMail function is used to delete a message from the message base. The message information should be present (found) before. This means that the properties of this class are filled with all message information. Use with great care because deleted messages are not retrievable.

This function returns one of the following error codes if not successful:

Error code | Explanation
2 | One or more unspecified errors occurred while sending the message. It is not known if the message was sent.
5 | There was insufficient memory to proceed.
17 | An invalid message identifier was passed in the lpszMessageID parameter. No message was deleted.
19 | An invalid session handle was passed in the lhSession parameter No message was deleted.

Example

Get DeleteMail Of oMapiSession To iRetval

It is a good usage when you use:

Send RereadMessage To oMapiSession

Note: Before invoking the DeleteMail message, verify that the correct information is present.

Last Edited: August 18, 2003


cMapiHandler [Function FindNext]

FindNext - cMapiHandler

Finds either the first or the next message in the queue

Type: Function

Return Data Type: String

Parameters: String sSeedMessageId Integer iFlags

Parameter | Description
sSeedMessageId | Previous message id to continue search on
iFlags Flags can be iOr'ed

Constant | Meaning
MAPI_GUARANTEE_FIFO | The message identifiers returned should be in the order of time received. MAPIFindNext calls can take longer if this flag is set. Some implementations cannot honor this request and return the MAPI_E_NOT_SUPPORTED (26) value.
MAPI_LONG_MSGID | The returned message identifier can be as long as 512 characters. If this flag is set, the lpszMessageID parameter must be large enough to accommodate 512 characters. Older versions of MAPI supported smaller message identifiers (64 bytes) and did not include this flag. MAPIFindNext will succeed without this flag set as long as lpszMessageID is large enough to hold the message identifier. If lpszMessageID cannot hold the message identifier, MAPIFindNext will fail.
MAPI_UNREAD_ONLY | Only unread messages of the specified type should be enumerated.If this flag is not set, MAPIFindNext can return any message of the specified type.

Return Value

Returns an error codes if not successful

Description

The FindNext method will find either the first or the next message in the queue. When sSeedMessageId is empty it will find the first message else the next message to sSeedMessageId is found. The found sSeedMessageId is returned or empty when an error was found or the end of the queue is reached.

This function returns one of the following error codes if not successful:

Error code | Meaning
2 | The flFlags parameter is invalid or one or more unspecified errors occurred.
5 | There was insufficient memory to proceed. The session was not terminated.
16 | A matching message could not be found.
17 | An invalid message identifier was passed in the lpszSeedMessageID parameter. No message was found.
19 | An invalid session handle was used for the lhSession parameter. The session was not terminated.

Example

Get FindNext Of oMapiSession sMessageId iFindNextFlags To sMessageId

Last Edited: August 18, 2003


cMapiHandler [Function FindNextFlags]

FindNextFlags - cMapiHandler

Returns the result of the properties valid for FindNext operation by composing a value based on the status properties pbGuaranteeFifo, pbLongMsgId and pbUnreadOnly

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the numeric result

Description

The FindNextFlags function returns the result of the properties valid for FindNext operation by composing a value based on the status properties pbGuaranteeFifo, pbLongMsgId and pbUnreadOnly.

Example

Get FindNextFlags Of oMapiSession To iFindNextFlags

Last Edited: August 18, 2003


cMapiHandler [Function Logoff]

Logoff - cMapiHandler

Disconnects the DataFlex application from the MAPI system

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns an error codes if not successful

Description

Logoff disconnects the DataFlex application from the MAPI system. When the mapisessionid (stored in the property phSessionID - contains a sessionid) the MAPI DLL call to disconnect is invoked. On error a stop box with the error code is shown.

This function returns one of the following error codes if not successful:

Error code | Meaning
2 | The flFlags parameter is invalid or one or more unspecified errors occurred.
5 | There was insufficient memory to proceed. The session was not terminated.
19 | An invalid session handle was used for the lhSession parameter. The session was not terminated.

Example

Get Logoff Of oMapiSession To iRetval

Last Edited: August 18, 2003


cMapiHandler [Function Logon]

Logon - cMapiHandler

Makes a connection between DataFlex and MAPI using either the passed username and password or the values from the properties psUserName and psPassword

Type: Function

Return Data Type: Integer

Parameters: String sProfileName String sPassWord Integer iFlags

Parameter | Description
sProfileName | This parameter - also known as profile name - is needed when the MAPI connection needs a username and password. Not always required.
sPassWord | The password of the username, not encrypted.
iFlags One of the following values:

Constant | Meaning
MAPI_FORCE_DOWNLOAD | An attempt should be made to download all of the user's messages before returning. If the MAPI_FORCE_DOWNLOAD flag is not set, messages can be downloaded in the background after the function call returns.
MAPI_NEW_SESSION | An attempt should be made to create a new session rather than acquire the environment's shared session. If the MAPI_NEW_SESSION flag is not set, MAPILogon uses an existing shared session.
MAPI_LOGON_UI | A logon dialog box should be displayed to prompt the user for logon information. If the user needs to provide a password and profile name to enable a successful logon, MAPI_LOGON_UI must be set.
MAPI_PASSWORD_UI | MAPILogon should only prompt for a password and not allow the user to change the profile name. Either MAPI_PASSWORD_UI or MAPI_LOGON_UI should not be set, since the intent is to select between two different dialog boxes for logon.

Return Value

Returns an error codes if not successful

Description

Logon makes a connection between DataFlex and MAPI using either the passed username and password or the values from the properties psUserName and psPassword. When the parameters are passed as empty strings the values from the properties are taken. The result of the action will be reflected in a session id that will be stored in the property phSessionID.

This function returns one of the following error codes if not successful:

Error code | Meaning
1 | The user canceled the logon dialog box. No session handle was returned.
2 | The flFlags parameter is invalid or one or more unspecified errors occurred.
3 | There was no default logon, and the user failed to log on successfully when the logon dialog box was displayed. No session handle was returned.
5 | There was insufficient memory to proceed. The session was not terminated.
8 | The user had too many sessions open simultaneously. No session handle was returned.

Example

Get Logon Of oMapiSession sUserName sPassword iFlags To iRetval

Last Edited: August 18, 2003


cMapiHandler [Function ReadMail]

ReadMail - cMapiHandler

Reads the mail message, addressed by, the passed message id and flags and returns the status of the action

Type: Function

Return Data Type: Integer

Parameters: String sMessageId Integer iFlags

Parameter | Description
sMessageId | Message id of to be read message
iFlags Flags can be iOr'ed

Constant | Meaning
MAPI_BODY_AS_FILE | MAPIReadMail should write the message text to a temporary file and add it as the first attachment in the attachment list.
MAPI_ENVELOPE_ONLY | MAPIReadMail should read the message header only. File attachments are not copied to temporary files, and neither temporary file names nor message text is written. Setting this flag enhances performance.
MAPI_PEEK | MAPIReadMail does not mark the message as read. Marking a message as read affects its appearance in the user interface and generates a read receipt. If the messaging system does not support this flag, MAPIReadMail always marks the message as read.If MAPIReadMail encounters an error, it leaves the message unread.
MAPI_SUPPRESS_ATTACH | MAPIReadMail should not copy file attachments but should write message text into the MapiMessage structure. MAPIReadMail ignores this flag if the calling application has set the MAPI_ENVELOPE_ONLY flag. Setting the MAPI_SUPPRESS_ATTACH flag enhances performance.

Return Value

Returns an error codes if not successful

Description

The ReadMail function reads the mail message, addressed by, the passed message id and flags and returns the status of the action. The message contents will be placed in the properties and child objects of the oMapiHandler object.

This function returns one of the following error codes if not successful:

Error code | Meaning
2 | The flFlags parameter is invalid or one or more unspecified errors occurred.
4 | An attachment could not be written to a temporary file because there was not enough space on the disk.
5 | There was insufficient memory to proceed. No session handle was returned.
9 | There were too many file attachments in the message. The message could not be read.
10 | There were too many recipients of the message. The message could not be read.
13 | An attachment could not be written to a temporary file. Check directory permissions.
17 | An invalid message identifier was passed in the lpszSeedMessageID parameter. No message was found.
19 | An invalid session handle was used for the lhSession parameter. The session was not terminated.

Example

Get ReadMail Of oMapiSession sMessageId iReadMailFlags To iStatus

Last Edited: September 11, 2003


cMapiHandler [Function ReadMailFlags]

ReadMailFlags - cMapiHandler

Returns the result of the properties valid for ReadMail operation

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the numeric result.

Description

The ReadMailFlags function returns the result of the properties valid for ReadMail operation. It composes a value based on the status properties pbPeek, pbEnvelopeOnly, pbBodyAsFile and pbSuppressAttach.

Example

Get ReadMailFlags Of oMapiSession To iReadMailFlags

Last Edited: September 11, 2003


cMapiHandler [Function RecipientAddress]

RecipientAddress - cMapiHandler

Returns the N-th recipient address

Type: Function

Return Data Type: String

Parameters: Integer iRecipient

Parameter | Description
iRecipient | The N-th recipient of the message

Return Value

The address of the N-th recipient

Description

The RecipientAddress function returns the N-th recipient address. The value of N must be passed via iRecipient.

Example

Get piMessageRecipCount Of oMapiSession To iRecipCount
For iCounter From 1 To iRecipCount
   Get RecipientAddress Of oMapiSession iCounter To sRecipientAddress

Last Edited: September 11, 2003


cMapiHandler [Function RecipientEntryId]

RecipientEntryId - cMapiHandler

Returns the N-th recipient ID

Type: Function

Return Data Type: String

Parameters: Integer iRecipient

Parameter | Description
iRecipient | The N-th recipient entry id of the message

Return Value

The entry-id of the N-th recipient

Description

The RecipientEntryId function returns the N-th recipient ID. The value of N must be passed via iRecipient. The value is needed for MapiDetails.

Example

Get piMessageRecipCount Of oMapiSession To iRecipCount
For iCounter From 1 To iRecipCount
   Get RecipientEntryId Of oMapiSession iCounter To sEntryId

Last Edited: September 11, 2003


cMapiHandler [Function RecipientEntryIdLength]

RecipientEntryIdLength - cMapiHandler

Type: Function

Return Data Type: String

Parameters: Integer iRecipient

Parameter | Description
iRecipient | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


cMapiHandler [Function RecipientName]

RecipientName - cMapiHandler

Returns the N-th recipient name

Type: Function

Return Data Type: String

Parameters: Integer iRecipient

Parameter | Description
iRecipient | The N-th recipient of the message

Return Value

The name of the N-th recipient

Description

The RecipientName function returns the N-th recipient name. The value of N must be passed via iRecipient.

Example

Get piMessageRecipCount Of oMapiSession To iRecipCount
For iCounter From 1 To iRecipCount
   Get RecipientName Of oMapiSession iCounter To sRecipientName

Last Edited: September 11, 2003


cMapiHandler [Function ResolveName]

ResolveName - cMapiHandler

Transforms a message recipient's name as entered by a user to an unambiguous address list entry

Type: Function

Return Data Type: Integer

Parameters: String sToBeResolvedName Integer iFlags

Parameter | Description
sToBeResolvedName | To be resolved name
iFlags Flags can be iOr'ed

Constant | Meaning
MAPI_AB_NOMODIFY | The caller is requesting that the dialog box be read-only, prohibiting changes. MAPIResolveName ignores this flag if MAPI_DIALOG is not set.
MAPI_DIALOG | A dialog box should be displayed for name resolution. If this flag is not set and the name cannot be resolved, MAPIResolveName returns the MAPI_E_AMBIGUOUS_RECIPIENT value.
MAPI_LOGON_UI | A dialog box should be displayed to prompt the user to log on if required. When the MAPI_LOGON_UI flag is not set, the client application does not display a logon dialog box and returns an error value if the user is not logged on.
MAPI_NEW_SESSION | An attempt should be made to create a new session rather than acquire the environment's shared session. If the MAPI_NEW_SESSION flag is not set, MAPIResolveName uses an existing shared session.

Return Value

Returns an error codes if not successful

Description

The ResolveName function transforms a message recipient's name as entered by a user to an unambiguous address list entry. It is used to verify if an email address that can be found in the address book.

This function returns one of the following error codes if not successful:

Error Code | Meaning
1 | The user canceled one of the dialog boxes. The name was not resolved.
2 | One or more unspecified errors occurred. No message was sent.
3 | There was no default logon, and the user failed to log on successfully when the logon dialog box was displayed. No message was sent.
5 | There was insufficient memory to proceed. No message was sent.
14 | The recipient could not be resolved to any address. The recipient might not exist or might be unknown.
21 | The recipient requested has not been or could not be resolved to a unique address list entry.
26 | The operation was not supported by the underlying messaging system.

Example

Get ResolveName Of oMapiSession sName iFlags To iRetval

Last Edited: August 4, 2004


cMapiHandler [Function SendDocuments]

SendDocuments - cMapiHandler

Opens a message dialog in which the user can enter/specify receivers of the document(s) and can specify a body text

Type: Function

Return Data Type: Integer

Parameters: String sDelimChar String sFullPaths String sPathNames

Parameter | Description
sDelimChar | The character used to separate the filenames and pathnames when used multiple documents. Usually a semi-colon.
sFullPaths | The files (documents) to send. The filename is without the path.
sPathNames | The file paths to the documents to send. The filename is also part of the pathname.

Return Value

Returns an error code if not successful

Description

The SendDocuments function will open a message dialog in which the user can enter/specify receivers of the document(s) and can specify a body text. The function is easier to use than composing a new message from the programming language but requires user interaction.

The SendDocuments function sends a standard message with one or more attached files and a cover note. The cover note is a dialog box that allows the user to enter a list of recipients and an optional message. SendDocuments differs from the SendMail function in that it allows less flexibility in message generation.

This function returns one of the following error codes if not successful:

Error code | Explanation
1 | The user canceled one of the dialog boxes. No message was sent.
2 | One or more unspecified errors occurred while sending the message. It is not known if the message was sent.
3 | There was no default logon, and the user failed to log on successfully when the logon dialog box was displayed. No message was sent.
5 | There was insufficient memory to proceed.
12 | One or more files in the lpszFilePaths parameter could not be located. No message was sent.
13 | An attachment could not be written to a temporary file. Check directory permissions.

Example

integer iRetVal
Get SendDocuments Of oMapiSession sSeparator sPathNames sFileNames To iRetval

Last Edited: February 18, 2004


cMapiHandler [Function SendMail]

SendMail - cMapiHandler

Sends a message

Type: Function

Return Data Type: Integer

Parameters: Integer iFlags Boolean bSendDirect

Parameter | Description
iFlags Flags can be iOr'ed

Constant | Meaning
MAPI_DIALOG | A dialog box should be displayed to prompt the user for recipients and other sending options. When MAPI_DIALOG is not set, at least one recipient must be specified.
MAPI_LOGON_UI | A dialog box should be displayed to prompt the user to log on if required. When the MAPI_LOGON_UI flag is not set, the client application does not display a logon dialog box and returns an error value if the user is not logged on. MAPISendMail ignores this flag if the lpszMessageID parameter is empty.
MAPI_NEW_SESSION | An attempt should be made to create a new session rather than acquire the environment's shared session. If the MAPI_NEW_SESSION flag is not set, MAPISendMail uses an existing shared session.

bSendDirect | When TRUE the message is sent, when false it is saved to be sent later.

Return Value

Returns an error code if not successful

Description

The SendMail function sends a message. This function differs from the SendDocuments function in that it allows greater flexibility in message generation. The message is created from the values in the properties.

This function returns one of the following error codes if not successful:

Error code | Meaning
1 | The user canceled one of the dialog boxes. No message was sent.
2 | One or more unspecified errors occurred. No message was sent.
3 | There was no default logon, and the user failed to log on successfully when the logon dialog box was displayed. No message was sent.
5 | There was insufficient memory to proceed. No message was sent.
9 | There were too many file attachments. No message was sent.
10 | There were too many recipients. No message was sent.
11 | The specified attachment was not found. No message was sent.
12 | The specified attachment could not be opened. No message was sent.
14 | A recipient did not appear in the address list. No message was sent.
18 | The text in the message was too large. No message was sent.
21 | A recipient matched more than one of the recipient descriptor structures and MAPI_DIALOG was not set. No message was sent.
25 | One or more recipients were invalid or did not resolve to any address

Example

Get SendMail Of oMapiSession iFlags bSendDirect To iRetval

Last Edited: November 9, 2006


Methods for cMapiHandler

View method list in hierarchical order

Name | Type | Description | Defining Class
AddressBook | Function | Used to browse / select an entry from the Addressbook |
AddresseeDetails | Function | Displays a dialog box containing the details of a selected address list entry |
AttachmentFileName | Function | Returns the N-th attachment filename |
AttachmentPathName | Function | Returns the N-th attachment pathname |
Create | Function | Creates an object based on the passed Class Id | cObject
DeleteMail | Function | Deletes a message from the message base |
Destroy | Procedure |  | cObject
DoAddAttachment | Procedure | Adds an attachment to the list |
DoAddReceiver | Procedure | Stores the name, address and type in the child object called "oReceiversArray" |
DoClearAttachmentsList | Procedure | Sends Delete_Data message to "oAttachmentsArray" child object, erasing the list of message attachments |
DoClearReceiversList | Procedure | Sends Delete_Data message to "oReceiversArray" child object, erasing the list of message receivers |
DoClearRecipientsList | Procedure | Sends Delete_Data message to "oRecipientsArray" child object, erasing the list of message recipients |
DoInit | Procedure | Initializes the cMapiHandler object and prepares for composing a new message |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNext | Function | Finds either the first or the next message in the queue |
FindNextFlags | Function | Returns the result of the properties valid for FindNext operation by composing a value based on the status properties pbGuaranteeFifo, pbLongMsgId and pbUnreadOnly |
Logoff | Function | Disconnects the DataFlex application from the MAPI system |
Logon | Function | Makes a connection between DataFlex and MAPI using either the passed username and password or the values from the properties psUserName and psPassword |
ReadMail | Function | Reads the mail message, addressed by, the passed message id and flags and returns the status of the action |
ReadMailFlags | Function | Returns the result of the properties valid for ReadMail operation |
RecipientAddress | Function | Returns the N-th recipient address |
RecipientEntryId | Function | Returns the N-th recipient ID |
RecipientEntryIdLength | Function |  |
RecipientName | Function | Returns the N-th recipient name |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
ResolveName | Function | Transforms a message recipient's name as entered by a user to an unambiguous address list entry |
SendDocuments | Function | Opens a message dialog in which the user can enter/specify receivers of the document(s) and can specify a body text |
SendMail | Function | Sends a message |


cMapiHandler [Procedure DoAddAttachment]

DoAddAttachment - cMapiHandler

Adds an attachment to the list

Type: Procedure

Parameters: String sPathName String sFileName

Parameter | Description
sPathName | Contains the path plus the filename to the enclosure
sFileName | Contains the filename of the enclosure

Description

The DoAddAttachment procedure can be used to add an attachment to the list. Each time two items in the child object "oAttachmentsArray" will be created. One with the path name and one with the file name. A MAPI message can have multiple enclosures and this message adds the attachments to the internal list of attachments.

Example

Send DoAddAttachment To oMapiSession (sFilePath - sFileName) sFileName

Last Edited: July 31, 2003


cMapiHandler [Procedure DoAddReceiver]

DoAddReceiver - cMapiHandler

Stores the name, address and type in the child object called "oReceiversArray"

Type: Procedure

Parameters: Integer iRecipClass String sName String sAddress String sEntryID Integer iLength

Parameter | Description
iRecipClass | This is MAPI_TO, MAPI_CC or MAPI_BCC. In an end user environment you can use the AddresseeType dialog to select the right value.
sName | The name of the recipient (e.g., "John Smith")
sAddress | The address of the recipient (e.g., smtp:someone@somehost.com)
sEntryID | Internal representation of the receiver-id
iLength | Length of the sEntryId value

Description

DoAddReceiver stores the name, address and type in the child object called "oReceiversArray". The information is used when sending a MAPI message. Adds a recipient to the list of recipients with name, address and type of recipient specified.

Example

Send DoAddReceiver To oMapiSession iReceiverType sReceiverName sReceiverAddress sEntryID iLength

Last Edited: October 6, 2004


cMapiHandler [Procedure DoClearAttachmentsList]

DoClearAttachmentsList - cMapiHandler

Sends Delete_Data message to "oAttachmentsArray" child object, erasing the list of message attachments

Type: Procedure

Parameters: No Parameters

Description

DoClearAttachmentsList sends Delete_Data message to "oAttachmentsArray" child object, erasing the list of message attachments.

Example

Send DoClearAttachmentsList

Last Edited: July 31, 2003


cMapiHandler [Procedure DoClearReceiversList]

DoClearReceiversList - cMapiHandler

Sends Delete_Data message to "oReceiversArray" child object, erasing the list of message receivers

Type: Procedure

Parameters: No Parameters

Description

DoClearReceiversList sends Delete_Data message to "oReceiversArray" child object, erasing the list of message receivers.

Example

Send DoClearReceiversList

Last Edited: July 31, 2003


cMapiHandler [Procedure DoClearRecipientsList]

DoClearRecipientsList - cMapiHandler

Sends Delete_Data message to "oRecipientsArray" child object, erasing the list of message recipients

Type: Procedure

Parameters: No Parameters

Description

DoClearRecipientsList sends Delete_Data message to "oRecipientsArray" child object, erasing the list of message recipients.

Example

Send DoClearRecipientsList

Last Edited: July 31, 2003


cMapiHandler [Procedure DoInit]

DoInit - cMapiHandler

Initializes the cMapiHandler object and prepares for composing a new message

Type: Procedure

Parameters: No Parameters

Description

The DoInit procedure will initialize the cMapiHandler object and prepare for composing a new message. It erase the array objects and initializes the properties.

Example

Send DoInit To oMapiSession

Last Edited: July 31, 2003


Properties for cMapiHandler

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbBodyAsFile | Flag to store the message as file attachment |
pbEnvelopeOnly | Flag to tell if only the header should be returned or not |
pbGuaranteeFiFo | Flag to tell if messages from mapi must be sorted in date time order |
pbLongMsgId | Flag to tell using a long message-id or a short one |
pbMapiMessageReturnRequest | Contains a true/false value whether a return receipt is requested or not |
pbPeek | Flag to tell whether MapiReadMail should flag an unread message as been read |
pbReportErrors | Determines if MAPI errors should be reported directly |
pbSuppressAttach | Flag to tell whether the attachments should be written out to disk or not |
pbUnreadOnly | Flag to tell if only unread messages must be returned or not |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phSessionID | Contains the handle returned on logon to the MAPI system |
piMessageFileCount | Contains the number of enclosures that were found by the MapiReadMail method |
piMessageFlags | Contains the flags returned by MapiReadMail |
piMessageRecipCount | Contains the number of recipients that were found by the MapiReadMail method |
piResolvedEntryIDLength | Contains the length of the entry-id |
psFindNextMessageType | Message class to search with |
psMessageConversationId | The conversation thread to which the message belongs |
psMessageDateReceived | The date and time when the message was received according to MAPI and returned by MapiReadMail |
psMessageId |  |
psMessageSenderAddress | Allows the MapiReadMail to return the senderaddress |
psMessageSenderName | Allows the MapiReadMail to return the sendername |
psMessageSubject | Allows MapiReadMail to return the subject of the read message |
psMessageText | Allows MapiReadMail to return the full message text |
psMessageType | The messagetype returned by MapiReadMail |
psPassword | Password to use for connecting to MAPI on logon |
psResolvedAddress |  |
psResolvedEntryID | Contains the entry-id for the resolved name |
psResolvedName | Contains the returned name value |
psUserName | Username to use for connecting to MAPI on logon |


cMapiHandler [Property pbBodyAsFile]

pbBodyAsFile - cMapiHandler

Flag to store the message as file attachment

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbBodyAsFile is the flag to store the message as file attachment.

Default is false.

Last Edited: July 29, 2004


cMapiHandler [Property pbEnvelopeOnly]

pbEnvelopeOnly - cMapiHandler

Flag to tell if only the header should be returned or not

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbEnvelopeOnly is the flag to tell if only the header should be returned or not. Only header is faster. Default is only the header. Normally true for scanning mail and false for reading-displaying mail.

Default is true.

Last Edited: July 29, 2004


cMapiHandler [Property pbGuaranteeFiFo]

pbGuaranteeFiFo - cMapiHandler

Flag to tell if messages from mapi must be sorted in date time order

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbGuaranteeFiFo is the flag to tell if messages from mapi must be sorted in date time order.

FiFo = FirstInFirstOut

Default is true.

Last Edited: July 29, 2004


cMapiHandler [Property pbLongMsgId]

pbLongMsgId - cMapiHandler

Flag to tell using a long message-id or a short one

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbLongMsgId is the flag to tell using a long message-id or a short one. Preferable is True.

Default is true.

Last Edited: July 29, 2004


cMapiHandler [Property pbMapiMessageReturnRequest]

pbMapiMessageReturnRequest - cMapiHandler

Contains a true/false value whether a return receipt is requested or not

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbMessageReturnRequest contains a true/false value whether a return receipt is requested or not.

Default is false.

Last Edited: July 29, 2004


cMapiHandler [Property pbPeek]

pbPeek - cMapiHandler

Flag to tell whether MapiReadMail should flag an unread message as been read

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbPeek is the flag to tell whether MapiReadMail should flag an unread message as been read.

Default is true.

Last Edited: July 29, 2004


cMapiHandler [Property pbReportErrors]

pbReportErrors - cMapiHandler

Determines if MAPI errors should be reported directly

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbReportErrors determines if MAPI errors should be reported reported as an error message.

Default is false.

Last Edited: July 29, 2004


cMapiHandler [Property pbSuppressAttach]

pbSuppressAttach - cMapiHandler

Flag to tell whether the attachments should be written out to disk or not

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbSuppressAttach is the flag to tell whether the attachments should be written out to disk or not. Normally false for scanning mail and true for real reading (for display).

Default is true.

Last Edited: July 29, 2004


cMapiHandler [Property pbUnreadOnly]

pbUnreadOnly - cMapiHandler

Flag to tell if only unread messages must be returned or not

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbUnreadOnly is the flag to tell if only unread messages must be returned or not.

Default is false.

Last Edited: July 29, 2004


cMapiHandler [Property phSessionID]

phSessionID - cMapiHandler

Contains the handle returned on logon to the MAPI system

Type: Property

Access: Read/Write

Data Type: Handle

Description

The phSessionID property contains the handle returned on logon to the MAPI system. When it is 0 there is no connection.

Default is 0.

Last Edited: September 11, 2003


cMapiHandler [Property piMessageFileCount]

piMessageFileCount - cMapiHandler

Contains the number of enclosures that were found by the MapiReadMail method

Type: Property

Access: Read/Write

Data Type: Integer

Description

piMessageFileCount contains the number of enclosures that were found by the MapiReadMail method.

Default is 0.

Last Edited: September 11, 2003


cMapiHandler [Property piMessageFlags]

piMessageFlags - cMapiHandler

Contains the flags returned by MapiReadMail

Type: Property

Access: Read/Write

Data Type: Integer

Description

piMessageFlags contains the flags returned by MapiReadMail.

Default is 0.

Last Edited: September 11, 2003


cMapiHandler [Property piMessageRecipCount]

piMessageRecipCount - cMapiHandler

Contains the number of recipients that were found by the MapiReadMail method

Type: Property

Access: Read/Write

Data Type: Integer

Description

piMessageRecipCount contains the number of recipients that were found by the MapiReadMail method.

Default is 0.

Last Edited: September 11, 2003


cMapiHandler [Property piResolvedEntryIDLength]

piResolvedEntryIDLength - cMapiHandler

Contains the length of the entry-id

Type: Property

Access: Read/Write

Data Type: Integer

Description

piResolvedEntryIDLength is used by MapiResolveName for storage. It contains the length of the entry-id.

Default is 0.

Last Edited: September 11, 2003


cMapiHandler [Property psFindNextMessageType]

psFindNextMessageType - cMapiHandler

Message class to search with

Type: Property

Access: Read/Write

Data Type: String

Description

psFindNextMessageType is the message class to search with. To find an interpersonal message (IPM), this should be blank. Messaging systems whose only supported message class is IPM can ignore this parameter.

Last Edited: September 11, 2003


cMapiHandler [Property psMessageConversationId]

psMessageConversationId - cMapiHandler

The conversation thread to which the message belongs

Type: Property

Access: Read/Write

Data Type: String

Description

psMessageConversationId is the conversation thread to which the message belongs.

Last Edited: September 11, 2003


cMapiHandler [Property psMessageDateReceived]

psMessageDateReceived - cMapiHandler

The date and time when the message was received according to MAPI and returned by MapiReadMail

Type: Property

Access: Read/Write

Data Type: String

Description

psMessageDateReceived is the date and time when the message was received according to MAPI and returned by MapiReadMail. The format is YYYY/MM/DD HH:MM, using a 24-hour clock.

Last Edited: September 11, 2003


cMapiHandler [Property psMessageId]

psMessageId - cMapiHandler

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


cMapiHandler [Property psMessageSenderAddress]

psMessageSenderAddress - cMapiHandler

Allows the MapiReadMail to return the senderaddress

Type: Property

Access: Read/Write

Data Type: String

Description

The MapiReadMail returns the senderaddress (e.g., someone@somehost.com) in the psMessageSenderAddress property.

Last Edited: September 11, 2003


cMapiHandler [Property psMessageSenderName]

psMessageSenderName - cMapiHandler

Allows the MapiReadMail to return the sendername

Type: Property

Access: Read/Write

Data Type: String

Description

The MapiReadMail returns the sendername (e.g., Vincent Oorsprong) in the psMessageSenderName property.

Last Edited: September 11, 2003


cMapiHandler [Property psMessageSubject]

psMessageSubject - cMapiHandler

Allows MapiReadMail to return the subject of the read message

Type: Property

Access: Read/Write

Data Type: String

Description

MapiReadMail returns the subject of the read message in the psMessageSubject property. When it is empty there is no subject. It is also used for a new message compose.

Last Edited: September 11, 2003


cMapiHandler [Property psMessageText]

psMessageText - cMapiHandler

Allows MapiReadMail to return the full message text

Type: Property

Access: Read/Write

Data Type: String

Description

MapiReadMail returns the full message text in the psMessageText property. It is also used to store the messagetext for outgoing messages.

Last Edited: September 11, 2003


cMapiHandler [Property psMessageType]

psMessageType - cMapiHandler

The messagetype returned by MapiReadMail

Type: Property

Access: Read/Write

Data Type: String

Description

psMessageType is the messagetype returned by MapiReadMail.

Last Edited: September 11, 2003


cMapiHandler [Property psPassword]

psPassword - cMapiHandler

Password to use for connecting to MAPI on logon

Type: Property

Access: Read/Write

Data Type: String

Description

psPassword is the password to use for connecting to MAPI on logon.

Last Edited: September 11, 2003


cMapiHandler [Property psResolvedAddress]

psResolvedAddress - cMapiHandler

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


cMapiHandler [Property psResolvedEntryID]

psResolvedEntryID - cMapiHandler

Contains the entry-id for the resolved name

Type: Property

Access: Read/Write

Data Type: String

Description

psResolvedEntryID is used by MapiResolveName for storage. It contains the entry-id for the resolved name.

Last Edited: September 11, 2003


cMapiHandler [Property psResolvedName]

psResolvedName - cMapiHandler

Contains the returned name value

Type: Property

Access: Read/Write

Data Type: String

Description

psResolvedName is used by MapiResolveName for storage. It contains the returned name value.

Last Edited: September 11, 2003


cMapiHandler [Property psUserName]

psUserName - cMapiHandler

Username to use for connecting to MAPI on logon

Type: Property

Access: Read/Write

Data Type: String

Description

psUserName is the username to use for connecting to MAPI on logon.

Last Edited: September 11, 2003


Events for cMSSQLHandler

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cMSSQLHandler [Function BrowseConnect]

BrowseConnect - cMSSQLHandler

Type: Function

Return Data Type: String

Parameters: String sInConnStr

Parameter | Description
sInConnStr | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cMSSQLHandler [Function EnumerateDatabases]

EnumerateDatabases - cMSSQLHandler

Type: Function

Return Data Type: Integer

Parameters: String sServer String sUser String sPassWord

Parameter | Description
sServer | [ToDo: In Progress]
sUser | [ToDo: In Progress]
sPassWord | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cMSSQLHandler [Function EnumerateServers]

EnumerateServers - cMSSQLHandler

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


cMSSQLHandler [Function ExtractList]

ExtractList - cMSSQLHandler

Type: Function

Return Data Type: Integer

Parameters: String sOutConnStr Integer hoStore

Parameter | Description
sOutConnStr | [ToDo: In Progress]
hoStore | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


Methods for cMSSQLHandler

View method list in hierarchical order

Name | Type | Description | Defining Class
BrowseConnect | Function |  |
CKBuildRevision | Function | Returns the build revision of the Connectivity Kit. | cCLIHandler
CKMajorRevision | Function | Returns the major revision of the Connectivity Kit. | cCLIHandler
CKMinorRevision | Function | Returns the minor revision of the Connectivity Kit. | cCLIHandler
CKReleaseRevision | Function | Returns the release revision of the Connectivity Kit. | cCLIHandler
CKRevision | Function | Returns the Connectivity Kit revision in the format Major.Minor.Release.Build. | cCLIHandler
CLIDFDateToSQLDate | Function |  | cCLIHandler
CLISQLDateToDFDate | Function |  | cCLIHandler
ColumnName | Function | Returns the name of the column enumerated at the given position by EnumerateColumns. | cCLIHandler
Create | Function | Creates an object based on the passed Class Id | cObject
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
DumpStatus | Procedure | Dumps the current status of the Connectivity Kit to an ASCII disk file. | cCLIHandler
EnumerateColumns | Function | Enumerates all column names for a given table. | cCLIHandler
EnumerateDatabases | Function |  |
EnumerateServers | Function |  |
EnumerateTables | Function | Enumerates tables in the given database. | cCLIHandler
Exit_Application | Procedure | Starts the process of closing an application | cObject
ExtractList | Function |  |
ExtractPartFromRevision | Function |  | cCLIHandler
IsMinimalRevision | Function | Checks if a Connectivity Kit complies with a minimal revision. | cCLIHandler
LastDriverError | Function | Returns the string value of the last generated driver error. | cCLIHandler
MaxUsers | Function | Returns the maximum number of users of the Connectivity Kit. | cCLIHandler
ReadConfiguration | Procedure | Forces the Connectivity Kit to reread the driver configuration file. | cCLIHandler
RedirectConnection | Function |  | cCLIHandler
RegistrationName | Function | Returns the registration name of the Connectivity Kit. | cCLIHandler
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
RIMValueToText | Function | Converts a DF_FILE_GENERATE_RECORD_ID_METHOD attribute value to the corresponding text. | cCLIHandler
ROValueToText | Function | Converts a DF_FIELD_READ_ONLY attribute value to the corresponding text. | cCLIHandler
SchemaName | Function | Returns the schema of the table enumerated at the given position by EnumerateTables. | cCLIHandler
SerialNumber | Function | Returns the Connectivity Kit serial number. | cCLIHandler
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array
TableComment | Function | Returns the comment of the table enumerated at the given position by EnumerateTables. | cCLIHandler
TableName | Function | Returns the name of the table enumerated at the given position by EnumerateTables. | cCLIHandler
TableType | Function | Returns the type of the table enumerated at the given position by EnumerateTables. | cCLIHandler
TextToRIMValue | Function | Converts a record identity text to the DF_FILE_GENERATE_RECORD_ID_METHOD attribute value | cCLIHandler
TextToROValue | Function | Converts a read only text to the DF_FIELD_READ_ONLY attribute value. | cCLIHandler


Properties for cMSSQLHandler

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psDriverID | The identification of the CLI driver. | cCLIHandler
Value | Sets and Gets an array element's value | Array


cObject [Event Construct_Object]

Construct_Object - cObject

Object constructor. Initializes the object during object creation in class definitions

Type: Event

Parameters: No Parameters

Description

This is the object constructor method. In a sub-class, Construct_object is used to:

1. Create New Properties
2. Assign Property values
3. Create child-objects

Construct_object is called at the start of object construction. End_construct_object is called at the end of class construction.

If you create a Construct_object method in a sub-class, you must forward send the message in the top of that method.

You may not define Construct_object inside of an object. It can only be defined within classes.

A new class declaration should follows this general form:

Class NewClassName is a SuperClassName

    // Construct_Object: Object constructor.
    Procedure Construct_Object

        // you MUST always forward send this message
        Forward Send Construct_Object

        // Define new properties: Property {Type} {pxName} {initial_value}
        :

        // Create child objects
        :

        // Set property values:
        :

    End_Procedure  // Construct_Object

    // Create and augment procedure and functions
    :

    Procedure End_Construct_Object

        //  change any properties or call methods before finalizing the object
        :

        // always forward send
        Forward send End _Construct_Object
    End_Procedure

End_Class // NewClassName

Object instantiation should follow this general form:

Object oObjectName is a cNewClassName
End_Object  // oObjectName

or

Get Create U_cNewClassName to hoNewObjectID

Here is an example of a new class called cRedForm, which is a standard Form with red text.

Class cRedForm is a Form
    Procedure Construct_Object
        forward send Construct_Object

        set TextColor to clRed
    End_Procedure  // Construct_Object
End_Class  // cRedForm

Here is an example of an object instantiated from the cRedForm class.

Object oMyRedForm is a cRedForm
End_Object // oMyRedForm

Note: Although Construct_Object and End_Construct_Object are not documented in subclasses of cObject, these two constructor methods are always part of the expected interface. They are an essential part of creating any subclass. Technically, these methods are constructors and not events - but they are documented here as events

See Also

End_construct_object

Last Edited: November 2, 2003


cObject [Event Destroy_Object]

Destroy_Object - cObject

Sent when an object is about to be destroyed

Type: Event

Parameters: No Parameters

Description

The Destroy_Object event is sent to an object when it is about to be destroyed. It can be used to handle any additional processing required to destroy the object.

  • This event destroys the object so it must be forwarded. Not forwarding the message will not destroy the object, will create an unstable environment and is in all cases considered to be an error.
  • You should never send this message. It should only be used for augmentation.
  • Normally, any augmentations applied to this event will occur before you forward the method (after the forward the object no longer exists).

Procedure Destroy_object
    Send DoWriteContentsToFile
    Forward send destroy_object // must be sent
End_Procedure

Note:Prior versions of DataFlex would use this method as a procedure and not an event. In other words, the message was used for sending and not just for augmentation. This usage is obsolete.

See Also

create | destroy

Last Edited: July 31, 2003


cObject [Event End_Construct_Object]

End_Construct_Object - cObject

End of object constructor.

Type: Event

Parameters: No Parameters

Description

This message is sent during the end of object construction. It allows object initialization to be performed based on the status of the nearly completed object.

This message is normally only defined in class definitions; in object definitions, the same results can be achieved by performing the same initialization immediately before the End_Object comand (outside of any methods).

Construct_object is called at the start of object construction. End_construct_object is called at the end of class construction.

You must always forward send End_construct_object, usually at the end of the method.

A new class declaration should follows this general form:

Class NewClassName is a SuperClassName

    // Construct_Object: Object constructor.
    Procedure Construct_Object

        // you MUST always forward send this message
        Forward Send Construct_Object

        // Define new properties: Property {Type} {pxName} {initial_value}
        :

        // Create child objects
        :

        // Set property values:
        :

    End_Procedure  // Construct_Object

    // Create and augment procedure and functions
    :

    Procedure End_Construct_Object

        //  change any properties or call methods before finalizing the object
        :

        // always forward send
        Forward send End _Construct_Object
    End_Procedure

End_Class // NewClassName

Object instantiation should follow this general form:

Object oObjectName is a cNewClassName
End_Object  // oObjectName

or

Get Create U_cNewClassName to hoNewObjectID

Note: Although Construct_Object and End_Construct_Object are not documented in subclasses of cObject, these two constructor methods are always part of the expected interface. They are an essential part of creating any subclass. Technically, these methods are constructors and not events - but they are documented here as events

See Also

Construct_Object

Last Edited: December 16, 2004


Events for cObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions |
Destroy_Object | Sent when an object is about to be destroyed |
End_Construct_Object | End of object constructor. |


cObject [Function Create]

Create - cObject

Creates an object based on the passed Class Id

Type: Function

Return Data Type: Handle

Parameters: integer iClassId

Parameter | Description
iClassId | The Class ID of the object to be created. Usually in the format of U_ClassName

Return Value

The object handle of the newly created object is returned.

Description

The Create function is used to dynamically create objects. It creates an object based on the passed iClassId. Often this class id is passed as a constant consisting of the symbol "U_" followed by the class name. When a class is created, an integer class Id symbol is defined as U_ClassName where ClassName is the name of the class. This ID is most often used to create the object. The object that receives the message becomes the parent object. For example, an array object could be created as follows:

Get Create U_Array to hoID

An object created using the Create message does not have a meaningful name, and it should be accessed using its object handle. For example:

Procedure ProcessList
    Handle hoID
    Integer i
    Get Create U_Array to hoID
    For i from 0 to 100
        Set Value of hoID item i to "Test Data"
    Loop
    Send PrintData hoID
    Send Destroy of hoID
End_procedure

Objects created using the Create function are often destroyed using the Destroy message.

See Also

Destroy

Last Edited: July 31, 2003


Methods for cObject

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id |
Destroy | Procedure |  |
Exit_Application | Procedure | Starts the process of closing an application |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead |


cObject [Procedure Destroy]

Destroy - cObject

Type: Procedure

Parameters: No Parameters

Description

Last Edited: December 19, 2005


cObject [Procedure Exit_Application]

Exit_Application - cObject

Starts the process of closing an application

Type: Procedure

Parameters: No Parameters

Description

The Exit_Application message is used to abort the program. The default behavior of exit_application is to delegate this message until the desktop is reached. The desktop object actually handles the process of confirming that an application should be terminated and closing the program. See the cDesktop messages Exit_application and Exit_System_Confirmation for more on this.

if bFatalError send exit_application

Last Edited: August 5, 2003


cObject [Procedure Request_Destroy_Object]

Request_Destroy_Object - cObject

Use the Destroy method instead

Type: Procedure

Obsolete

Parameters: No Parameters

Description

This method is used to destroy an object and all of its children. It is obsolete and should be replaced with the Destroy method.

See Also

Destroy

Last Edited: December 16, 2004


Properties for cObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains |
Delegation_Mode | Determines if and how unknown messages are delegated |
Name | Returns the full name of the object including parentage |
Object_Id | Returns the object handler of the object |
Object_Label | Returns the short name of an object |
Parent | Returns the parent of an object |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing |


cObject [Property Child_Count]

Child_Count - cObject

Returns the number of child objects the object contains

Type: Property

Access: Read-Only

Data Type: Integer

Description

Child_Count returns the number of child objects the object contains. The child_count may be used to determine if an object has children.

get child_count of iChildren
if (iChildren) Send DoHandleChildren

Last Edited: July 30, 2003


cObject [Property Delegation_Mode]

Delegation_Mode - cObject

Determines if and how unknown messages are delegated

Type: Property

Access: Read/Write

Data Type: Integer

Description

The delegation_mode of an object determines the method by which unknown messages are handled. When a message is not understood by an object (i.e., the message is not defined in the object or within the object's class structure) , the delegation_mode determines how this is handled. The following modes are supported:

Constant | Meaning
Delegate_to_Parent | Delegate_to_parent causes the message to be sent to the parent of the object. This is the default mode for all classes except Array.
No_delegation | The no_delegation mode results in an error.
No_delegate_or_error | The no_delegate_or_error mode causes the message to be ignored.The object will, in effect, ignore all messages that it does not understand. This is the default mode of the Array class.
Return_invalid_message | The return_invalid_message mode returns the integer value of the unknown message_id. This is rarely used.
Delegate_prior_level | The delegate_prior_level mode causes unknown messages to be sent up the focus tree. This is rarely used.

The most common delegation mode settings are delegate_to_parent and no_delegation.

// disable delegation...we want to see our errors right away!
set delegation_mode to no_delegation

// restore normal delegation, if needed
get delegation_mode to eDelgate
If (eDelegate<>delegate_to_parent)  Begin
     set delegation_mode to delegate_to_parent
end

You will normally not want disable delegation and disable errors. When invalid methods are sent to an object with this mode set, you will receive no notification that the message was not understood. Usually this is not desired and it is quite difficult to debug. The Array class does this for historical reasons.

set delegation_mode to no_delegate_or_error // you rarely will use this

Last Edited: July 31, 2003


cObject [Property Name]

Name - cObject

Returns the full name of the object including parentage

Type: Property

Access: Read-Only

Data Type: String

Description

Name returns the full name (including parentage) of the object. Each part of the name is separated by a period. This method is often useful when debugging an application.

Get Focus of Desktop to hoFocus
Get Name of hoFocus to sName
showln "The focus is currently at " sName

See Also

object_label

Last Edited: September 10, 2003


cObject [Property Object_Id]

Object_Id - cObject

Returns the object handler of the object

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Object_Id property returns the object handle identifier of the object.

Normally you will not use this since it essentially returns itself. It returns the object handle of the passed object handle. You can accomplish the same thing by simply using the object's name or handle. For example, these two samples will do the same thing:

// move ID of oMyObjectName to hoID, the easy way
Move oMyObjectName to hoID

// move ID of oMyObjectName to hoID, the hard way
Get Object_Id of oMyObjectName to hoID

This property is really only ever used to determine if an object still exists. If an object has been created. If an object has been created and destroyed, you can test if the object still exists by getting the object_id. If the value returned is non-zero, it exists.

Procedure DoTest
     Handle hoArray hoID

     Create U_Array of hoArray
     Get Object_Id of hoArray to hoID // will return hoArray - object exists
     Send Destroy of hoArray
     Get Object_Id of hoArray to hoID // will return 0 - object does not exist
End_Procedure

Last Edited: February 17, 2004


cObject [Property Object_Label]

Object_Label - cObject

Returns the short name of an object

Type: Property

Access: Read-Only

Data Type: String

Description

Object_Label returns the short name of the object. The short name consists of the name used to create the object and does not include parent names.

This method is often useful when debugging an application.

Object oMyName is a cObject
end_object
Get object_label of oMyName to sName
showln "The short name is " sName // this should show "The short name is OMYNAME"

This method is often useful when debugging an application.

Get Focus of Desktop to hoFocus
Get object_label of hoFocus to sName
showln "The focus is currently at " sName

See Also

Name

Last Edited: September 10, 2003


cObject [Property Parent]

Parent - cObject

Returns the parent of an object

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Parent property returns parent object handle of an object.

Get Parent to hoParent
send SomeMessage of hoParent

Send SomeOtherMessage of (Parent(self)) sSomeParam

Last Edited: September 10, 2003


cObject [Property peNeighborhood]

peNeighborhood - cObject

Determines how an object and its descendents participate in object neighborhood referencing

Type: Property

Access: Read/Write

Data Type: Integer

Description

The peNeighborhood property determines how an object and its descendents should participate in object neighborhood referencing. Three modes are supported:

Constant | Meaning
nhPrivate | The object defines a private neighborhood. All descendant objects are private and will not support neighborhood referencing. This is the default for all non-visual objects and all visual controls.
nhPublic | The object defines a public Neighborhood. It maintains a list of all of its descendents. When an object name is requested of this object either directly or via object access name delegation it will search its list to see if the object exists. This is the default mode for visual "panel" objects such as views, panels and modal panels.
nhNo | This mode indicates that this object does not define a neighborhood either public or private. Instead it allows its descendents (all objects within this object) to ignore this object and check with its parent to see what its neighborhood status might be. This is the default mode for visual grouping containers .

The Purpose of Object Neigborhoods

The purpose of object neighborhoods is to make it easier for objects to communicate with each other. Objects within a neighborhood can talk to other objects within the neighborhood by the first name (their simple object name: object_label ) without needing to worry about where those objects are located.

Object Neighborhoods make it easier to manage visual objects within views. In a view, visual controls are often nested inside containers for appearance purposes only. As you design an application you may decide that it looks better to place several objects within dbGroups and that it then looks better to place those groups within a dbContainer3d. The Studio makes it very easy to make these kinds of changes. However, every time you move these objects around and put them in different containers you change the way those objects are referenced from other objects within the view. This creates the need to generate complex object reference statements and it may require code change every time you move objects around. This results in code that looks like this:

Get SortOrder of (oSortOrder(oSortParamsGroup(oSetUpContainer(oTabPageReport(oTabDialog))))) to iOrder

And, if you decide to move your oSortOrder object somewhere else in the view, you need to start all over.

With neighborhoods all objects in the view are registered with the view and all objects within the view are visible to all other objects within the view. The same object placed anywhere within the view is now coded as:

Get SortOrder of oSortOrder to iOrder

Object Neigborhoods with different classes

Normally, object neighborhoods are only needed with visual objects. This allows you to nest objects for visual purposes without worrying about how this changes object access. Object neighborhoods "flatten" the object structure of visual controls making it possible for all visible controls to see each other. Objects will still properly encapsulate (hide) non-visual and class-based objects that are clearly not meant to be public. This allows easy access to the objects you want easy access to while still writing properly encapsulated applications. You do not want to use neighborhoods with non-visual objects as their use would only encourage impoper encapsulation.

Views and modal panels are defined as public neighborhoods (View, dbView, ModalPanel, dbModalPanel, dbTabView, etc.). You should be able to use object neighborhoods with all visual objects within these views and panels.

All of other visual containers (Container3d, dbContainer3d, Group, dbGroup, TabDialog, dbTabDialog, TabPage, dbTabPage, etc.) set their peNeighborhood mode to nhNo which causes references to pass through them. This is what flattens the access structure.

All visual controls (Form, dbForm, Grid, dbGrid, etc.) and non-visual controls (cObject, Array, BusinessProcess, etc.) are set their peNeighborhood to nhPrivate which keeps all of their children private.

Objects that are not part of neighborhoods are still referenced using normal object access referencing (check if name exists as a child, if not delegate to parent and repeat search, repeat until object is found).

Note:The peNeighborhood property is already set appropriately for each class in the framework. These modes are set to provide the best mix of proper encapsulation, ease of visual design and ease of object access. You should never need to change this property in any class. Before you change this mode you should review your object structure and see if you can solve your problem by restructuring your objects.

Last Edited: February 18, 2004


Events for cODBCHandler

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cODBCHandler [Function DataSources]

DataSources - cODBCHandler

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


Methods for cODBCHandler

View method list in hierarchical order

Name | Type | Description | Defining Class
CKBuildRevision | Function | Returns the build revision of the Connectivity Kit. | cCLIHandler
CKMajorRevision | Function | Returns the major revision of the Connectivity Kit. | cCLIHandler
CKMinorRevision | Function | Returns the minor revision of the Connectivity Kit. | cCLIHandler
CKReleaseRevision | Function | Returns the release revision of the Connectivity Kit. | cCLIHandler
CKRevision | Function | Returns the Connectivity Kit revision in the format Major.Minor.Release.Build. | cCLIHandler
CLIDFDateToSQLDate | Function |  | cCLIHandler
CLISQLDateToDFDate | Function |  | cCLIHandler
ColumnName | Function | Returns the name of the column enumerated at the given position by EnumerateColumns. | cCLIHandler
Create | Function | Creates an object based on the passed Class Id | cObject
DataSources | Function |  |
DataSourceType | Procedure Set |  |
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
DumpStatus | Procedure | Dumps the current status of the Connectivity Kit to an ASCII disk file. | cCLIHandler
EnumerateColumns | Function | Enumerates all column names for a given table. | cCLIHandler
EnumerateTables | Function | Enumerates tables in the given database. | cCLIHandler
Exit_Application | Procedure | Starts the process of closing an application | cObject
ExtractPartFromRevision | Function |  | cCLIHandler
IsMinimalRevision | Function | Checks if a Connectivity Kit complies with a minimal revision. | cCLIHandler
LastDriverError | Function | Returns the string value of the last generated driver error. | cCLIHandler
MaxUsers | Function | Returns the maximum number of users of the Connectivity Kit. | cCLIHandler
ReadConfiguration | Procedure | Forces the Connectivity Kit to reread the driver configuration file. | cCLIHandler
RedirectConnection | Function |  | cCLIHandler
RegistrationName | Function | Returns the registration name of the Connectivity Kit. | cCLIHandler
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
RIMValueToText | Function | Converts a DF_FILE_GENERATE_RECORD_ID_METHOD attribute value to the corresponding text. | cCLIHandler
ROValueToText | Function | Converts a DF_FIELD_READ_ONLY attribute value to the corresponding text. | cCLIHandler
SchemaName | Function | Returns the schema of the table enumerated at the given position by EnumerateTables. | cCLIHandler
SerialNumber | Function | Returns the Connectivity Kit serial number. | cCLIHandler
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array
TableComment | Function | Returns the comment of the table enumerated at the given position by EnumerateTables. | cCLIHandler
TableName | Function | Returns the name of the table enumerated at the given position by EnumerateTables. | cCLIHandler
TableType | Function | Returns the type of the table enumerated at the given position by EnumerateTables. | cCLIHandler
TextToRIMValue | Function | Converts a record identity text to the DF_FILE_GENERATE_RECORD_ID_METHOD attribute value | cCLIHandler
TextToROValue | Function | Converts a read only text to the DF_FIELD_READ_ONLY attribute value. | cCLIHandler


cODBCHandler [Procedure Set DataSourceType]

DataSourceType - cODBCHandler

Type: Procedure Set

Data Type: Integer

Parameters: Integer iNewType

Parameter | Description
iNewType | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


Properties for cODBCHandler

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psDriverID | The identification of the CLI driver. | cCLIHandler
Value | Sets and Gets an array element's value | Array


Events for CodePickList

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Fill_List |  | PickList_
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click | Sent whenever a header has received a mouse click | EntryList
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List |  | PickList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click |  | PickList
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | EntryList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin | Augmented to set the minimum and maximum positions for a spinner | EntryList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for CodePickList

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the first enterable column of the first row | PickList_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Deactivates this object | PickList_
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Causes the grid's current item to be set to the last enterable column of the last row | PickList_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
first_selected_item | Function |  | PickList_
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Init_Selected_Item | Procedure | Sets enumeration_counter to zero | PickList_
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_Value_Out | Procedure | Overridden to set the value of the current item of the invoking object to the code value of the current item of this object upon selection, and then to send display_description to the invoking object | PickList_
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
next_selection | Function | Returns identifier of next selected item | PickList_
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Oks a list selection | PickList_
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines | EntryList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure | Changes the current item to the prior row, if any, at the same item relative to the beginning of the row | WideList_
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Validate_Prompt | Function | (Obsolete) | WideList
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


Properties for CodePickList

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Blank_State | Determines if item validation will accept a blank window as a valid entry for the item | CodePickList_
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
CustomScrollState | Determines changing scroll bar behaviors | PickList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Item | Defines which item in the code pick list is inserted into the invoking object item by the default_prompt message | CodePickList_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Description_Item_Offset | Defines the number of items sequentially after the invoking item the description is returned to when export_description_state is true | CodePickList_
Description_Offset | Defines the position in the value of the code-pick-list item at and to the right of which the description will be copied from when export_description_state is true | CodePickList_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Message | Sets the text of the message displayed when validation fails | CodePickList_
Error_Number | Sets the number of the error that will be returned when validation fails | CodePickList_
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Export_Description_State | Determines if the code pick list returns the value of the selected item to the first item of the invoking object following the item from which the code pick list was invoked | CodePickList_
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational | PickList_
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Invoking_Object_ID | Identifies the object which activated this object | PickList_
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Match_Length | Sets the number of character that must be typed into the invoking item to satisfy the requirements for a match with a value of an item in this object | CodePickList_
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent | PickList_
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Original_Selection | Identifies the item that was selected when this object was originally activated | PickList_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | (Obsolete) | PickList_
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
ScrollOnThumbTrackState |  | PickList
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | CodePickList_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
ThumbScrollState |  | PickList
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


Events for CodePickList_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Fill_List |  | PickList_
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click | Sent whenever a header has received a mouse click | EntryList
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List |  | PickList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click |  | PickList
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | EntryList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin | Augmented to set the minimum and maximum positions for a spinner | EntryList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for CodePickList_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the first enterable column of the first row | PickList_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Deactivates this object | PickList_
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Causes the grid's current item to be set to the last enterable column of the last row | PickList_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
first_selected_item | Function |  | PickList_
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Init_Selected_Item | Procedure | Sets enumeration_counter to zero | PickList_
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_Value_Out | Procedure | Overridden to set the value of the current item of the invoking object to the code value of the current item of this object upon selection, and then to send display_description to the invoking object | PickList_
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
next_selection | Function | Returns identifier of next selected item | PickList_
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Oks a list selection | PickList_
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines | EntryList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure | Changes the current item to the prior row, if any, at the same item relative to the beginning of the row | WideList_
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Validate_Prompt | Function | (Obsolete) | WideList
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


Properties for CodePickList_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Blank_State | Determines if item validation will accept a blank window as a valid entry for the item |
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
CustomScrollState | Determines changing scroll bar behaviors | PickList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Item | Defines which item in the code pick list is inserted into the invoking object item by the default_prompt message |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Description_Item_Offset | Defines the number of items sequentially after the invoking item the description is returned to when export_description_state is true |
Description_Offset | Defines the position in the value of the code-pick-list item at and to the right of which the description will be copied from when export_description_state is true |
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Message | Sets the text of the message displayed when validation fails |
Error_Number | Sets the number of the error that will be returned when validation fails |
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Export_Description_State | Determines if the code pick list returns the value of the selected item to the first item of the invoking object following the item from which the code pick list was invoked |
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational | PickList_
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Invoking_Object_ID | Identifies the object which activated this object | PickList_
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Match_Length | Sets the number of character that must be typed into the invoking item to satisfy the requirements for a match with a value of an item in this object |
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent | PickList_
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Original_Selection | Identifies the item that was selected when this object was originally activated | PickList_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | (Obsolete) | PickList_
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
ScrollOnThumbTrackState |  | PickList
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
ThumbScrollState |  | PickList
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


CodePickList_ [Property Allow_Blank_State]

Allow_Blank_State - CodePickList_

Determines if item validation will accept a blank window as a valid entry for the item

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Allow_blank_state property is true, item validation will accept a blank window as a valid entry for the item. If it is false, validation will reject such a value.

Default is false.

Last Edited: January 12, 2006


CodePickList_ [Property Default_Item]

Default_Item - CodePickList_

Defines which item in the code pick list is inserted into the invoking object item by the default_prompt message

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the Default_item property defines which item in the code pick list is inserted into the invoking object item by the default_prompt message. Zero (0) is the first item in the list; if you do not desire any default value to be inserted, the invoking item should not use MSG_default_prompt in its ientry option.

Default is 0.

Last Edited: July 31, 2003


CodePickList_ [Property Description_Item_Offset]

Description_Item_Offset - CodePickList_

Defines the number of items sequentially after the invoking item the description is returned to when export_description_state is true

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Description_item_offset property defines the number of items sequentially after the invoking item the description is returned to when export_description_state is true. Typically, the invoking item in such cases is the one receiving the code (as distinguished from the description). Zero (0) would not make sense as a value of this property; it would designate the invoking item itself.

Default is 1.

Last Edited: July 31, 2003


CodePickList_ [Property Description_Offset]

Description_Offset - CodePickList_

Defines the position in the value of the code-pick-list item at and to the right of which the description will be copied from when export_description_state is true

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Description_offset property defines the position in the value of the code-pick-list item at and to the right of which the description will be copied from when export_description_state is true. Zero (0) defines the entire value; one (1) defines the value less the first character, and so on.

Default is 0.

Last Edited: July 31, 2003


CodePickList_ [Property Error_Message]

Error_Message - CodePickList_

Sets the text of the message displayed when validation fails

Type: Property

Access: Read/Write

Data Type: String

Description

The value of the Error_message property sets the text of the message displayed when validation fails. If the value of this property is empty ("") and the error_number property is a number defined in the error file flexerrs.dat, the text defined in that file for the error of that number will be displayed.

Default is ". Press F4 to see Valid options".

Last Edited: August 5, 2003


CodePickList_ [Property Error_Number]

Error_Number - CodePickList_

Sets the number of the error that will be returned when validation fails

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the Error_number property sets the number of the error that will be returned when validation fails. If the number is one defined in the error file flexerrs.dat and the error_message property is empty, the text defined in that file for the error of that number will be displayed.

Default is 15.

Last Edited: August 5, 2003


CodePickList_ [Property Export_Description_State]

Export_Description_State - CodePickList_

Determines if the code pick list returns the value of the selected item to the first item of the invoking object following the item from which the code pick list was invoked

Type: Property

Access: Read/Write

Data Type: Integer

Description

If the value of the Export_description_state property is true, the code pick list returns the value of the selected item to the first item of the invoking object following the item from which the code pick list was invoked. The description_offset property may be used to designate a trailing substring of the item value to be so handled, and the description_item_offset property may be set to designate an item of the invoking object to receive the description other than the item following the invoking item.

Default is false.

Last Edited: August 5, 2003


CodePickList_ [Property Match_Length]

Match_Length - CodePickList_

Sets the number of character that must be typed into the invoking item to satisfy the requirements for a match with a value of an item in this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the Match_Length property sets the number of character that must be typed into the invoking item to satisfy the requirements for a match with a value of an item in this object. The default (-1) provides behaviors that are sensitive to the values of Export_Description_State and Description_Offset, and are suitable for most purposes. If this property is zero (0) or one (1), a single (the initial) character satisfies a match. If you set the property above 1, that number or more of the leading characters must match to validate.

Last Edited: August 6, 2004


CodePickList_ [Property Should_Save]

Should_Save - CodePickList_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DSO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: August 12, 2005


Events for CodeValidationTable

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Fill_List | Fills the list of entires in the validation table | ValidationTable


Methods for CodeValidationTable

View method list in hierarchical order

Name | Type | Description | Defining Class
Add_Table_Value | Procedure | Should be sent for each sDescription and sValue you wish to add to your validation table | DescriptionValidationTable
Create | Function | Creates an object based on the passed Class Id | cObject
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Find_Code_Description | Function |  | ValidationTable
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array
TableData | Function | Returns the validation table's data in a two dimensional variant array | ValidationTable
Validate_Value | Function | Determines whether a value is valid or not (is listed in the validation table or not) | ValidationTable


Properties for CodeValidationTable

View property list in hierarchical order

Name | Description | Defining Class
Allow_Blank_State | Controls whether blank entries are accepted in this object | ValidationTable
Child_Count | Returns the number of child objects the object contains | cObject
Code_Field | The database field from which the values are to be drawn for validation and insertion into the database | FileValidationTable
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Description_Field | Identifies the field from which the descriptions are to be drawn for validation and insertion into the database | FileValidationTable
Item_Count | Returns the number of items in an array object | Array
Main_File | Identifies the data file from which the values are to be drawn to fill this object | ValidationTable
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Ordering | Identifies the index to be used for ordering values in this object. | FileValidationTable
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Static_State | Determines whether object loads once per session or dynamically. | ValidationTable
Table_Title | The title shown in the caption bar of the validation table | ValidationTable
Type_Field | Identifies the field in the CodeMast data file that contains the type values to be used for the validation table | FileValidationTable
Type_Value | Sets the value in the Type_Field by which records for validation are selected | FileValidationTable
Validate_State | Determines whether values are validated against the items contained in the validation table. | ValidationTable
Value | Sets and Gets an array element's value | Array


Events for ColorDialog

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


ColorDialog [Function Show_Dialog]

Show_Dialog - ColorDialog

Determines how the color dialog box is constructed and behaves

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

The function returns true if users select a valid color and press the OK button. It returns false if users press the Cancel button, terminates the dialog, or an error occurs.

Description

The Show_Dialog function is used to pop up the color dialog. The object's properties will determine how the dialog box is constructed and behaves.

Last Edited: September 11, 2003


Methods for ColorDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
AssignCustomColors | Procedure | Facilitates the copying of custom-color arrays between instances |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Show_Dialog | Function | Determines how the color dialog box is constructed and behaves |


ColorDialog [Procedure AssignCustomColors]

AssignCustomColors - ColorDialog

Facilitates the copying of custom-color arrays between instances

Type: Procedure

Parameters: Handle hoSourceColorDialog

Parameter | Description
hoSourceColorDialog | The object handle of the source color dialog

Description

The AssignCustomColors message is provided to facilitate the copying of custom-color arrays between instances. The hoSourceColorDialog parameter should be the object id of another ColorDialog instance; if it is not, then it should respond to the item-based Value message, that is, this message will send 16 requests to the hoSourceColorDialog object: Get Value Item [0..15] of iObjId.

Last Edited: June 23, 2005


Properties for ColorDialog

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Custom_Color | Contains the RGB value of any of the custom colors |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
FullOpen_State | Determines whether the dialog box should show both color sections upon initialization |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
PreventFullOpen_State | Determines if users are prevented from displaying the custom-colors section of the dialog box |
SelectedColor | Holds the color that will be used as the default when the dialog box is displayed |
SelectedColor_State | Determines if the dialog will initialize with the value of the SelectedColor property as its default color |


ColorDialog [Property Custom_Color]

Custom_Color - ColorDialog

Contains the RGB value of any of the custom colors

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer rgbColor

Parameter | Description
iItem | The custom color index
rgbColor | The RGB Color for iItem

Description

Thes Custom_Color property contains the RGB value of any of the custom colors. The property is zero-based, so iItem values range from 0-15. The custom colors can also be set by users through the dialog interface (provided the PreventFullOpen_State property is false).

Last Edited: July 31, 2003


ColorDialog [Property FullOpen_State]

FullOpen_State - ColorDialog

Determines whether the dialog box should show both color sections upon initialization

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The color dialog is defined in two sections. The first section shows standard colors and the other section lets users select custom colors. The FullOpen_State property determines whether the dialog box should (true) show both sections upon initialization. If false, only the standard-colors dialog is shown.

Default is true.

Last Edited: August 18, 2003


ColorDialog [Property PreventFullOpen_State]

PreventFullOpen_State - ColorDialog

Determines if users are prevented from displaying the custom-colors section of the dialog box

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the PreventFullOpen_State property is true, users are prevented from displaying the custom-colors section of the dialog box.

Default is false.

Last Edited: September 11, 2003


ColorDialog [Property SelectedColor]

SelectedColor - ColorDialog

Holds the color that will be used as the default when the dialog box is displayed

Type: Property

Access: Read/Write

Data Type: Integer

Description

The SelectedColor property holds the color that will be used as the default when the dialog box is displayed (assuming SelectedColor_State is true). The property is automatically modified to reflect the color the user selected. The functions R_From_RGB(), G_From_RGB() and B_From_RGB() can be used to retrieve the r, g, and b color components respectively. The property can either be set directly to an integer (or a hex number, such as $0000FF for full-intensity red) or with the RGB() function: Set SelectedColor To (RGB(255,0,0)).

Last Edited: September 11, 2003


ColorDialog [Property SelectedColor_State]

SelectedColor_State - ColorDialog

Determines if the dialog will initialize with the value of the SelectedColor property as its default color

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the SelectedColor_State property is true, the dialog will initialize with the value of the SelectedColor property as its default color.

Default is true.

Last Edited: September 11, 2003


ComboEntry [Event Combo_Edit_Changed]

Combo_Edit_Changed - ComboEntry

Sets the item_changed_state of this object's item true

Type: Event

Parameters: No Parameters

Description

The Combo_edit_changed procedure sets the item_changed_state of this object's item true. It is received when a user edits the value in the combo object's display.

Last Edited: July 31, 2003


ComboEntry [Event Combo_Fill_List]

Combo_Fill_List - ComboEntry

Called when the combo list is to be filled

Type: Event

Parameters: No Parameters

Description

The Combo_fill_list message is called when the combo list is to be filled. By default, it does nothing. You must supply the code to fill the combo list. This procedure will usually consist of one or more combo_add_item messages.

Procedure Combo_Fill_List
    Send Combo_Delete_Data
    Send Combo_Add_Item "Research"
    Send Combo_Add"Item "Accounting"
    Send Combo_Add_Item "Support"
    Send Combo_Add_Item "Marketing"
End_Procedure

Procedure Combo_Fill_List
    Send Combo_Delete_Data
    Clear MyFile
    Find gt MyFile by 1
    While (found)
        Send Combo_Add_Item MyFile.Code
        Find gt MyFile by 1
    End
End_Procedure

See Also

Combo_Add_Item | Combo_Delete_Data | Combo_Item_Count | Combo_value | Combo_Insert_Item | Combo_Delete_Item | Combo_Item_Matching | Validate_Combo_Value | Add_Form_to_List

Last Edited: November 19, 2004


ComboEntry [Event Combo_Item_Changed]

Combo_Item_Changed - ComboEntry

Sets the item_changed_state of this object's item true and sends the onChange message

Type: Event

Parameters: No Parameters

Description

The Combo_item_changed event sets the item_changed_state of this object's item true and sends the onChange message. It is received when a user scrolls the combo list from its initial displayed choice.

Last Edited: July 31, 2003


ComboEntry [Event OnBeginningOfPanel]

OnBeginningOfPanel - ComboEntry

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


ComboEntry [Event OnChange]

OnChange - ComboEntry

Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message

Type: Event

Parameters: No Parameters

Description

The OnChange event message is sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message. This is a notification. It does nothing by default and is intended for augmentation.

Note:The OnChange event should not be used to change focus or to alter the value of controls such as Form or ComboForm.

This event is created to respond to a data change event and not to trigger other data changes. If you want to respond to a change in a combo based on a user selection, it is suggested you augment other procedures such as Combo_Item_Changed and Combo_Edit_Changed.

See Also

Form

Last Edited: February 18, 2004


ComboEntry [Event OnCloseUp]

OnCloseUp - ComboEntry

Called when a drop-down list closes

Type: Event

Parameters: No Parameters

Description

The OnCloseUp event message is called when a drop-down list closes. It is a notification and is intended for augmentation.

Last Edited: September 10, 2003


ComboEntry [Event OnDropDown]

OnDropDown - ComboEntry

Called when a drop-down list opens

Type: Event

Parameters: No Parameters

Description

The OnDropDown event message is called when a drop-down list opens. It is a notification and is intended for augmentation.

Last Edited: September 10, 2003


ComboEntry [Event OnDropKey]

OnDropKey - ComboEntry

Type: Event

Return Data Type: Boolean

Parameters: integer iVKey boolean bIsAccelerator

Parameter | Description
iVKey | [ToDo: In Progress]
bIsAccelerator | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


ComboEntry [Event OnKillFocus]

OnKillFocus - ComboEntry

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


ComboEntry [Event OnMaxText]

OnMaxText - ComboEntry

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


ComboEntry [Event OnSetFocus]

OnSetFocus - ComboEntry

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


ComboEntry [Event Prompt_Callback]

Prompt_Callback - ComboEntry

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


ComboEntry [Event Shadow_Display]

Shadow_Display - ComboEntry

Creates the proper shadowed or unshadowed appearance for this object and its label

Type: Event

Parameters: No Parameters

Description

The Shadow_Display message is called whenever the object's enabled_state is changed. It is responsible for creating the proper shadowed or unshadowed appearance for this object and its label.

See Also

Form

Last Edited: September 11, 2003


Events for ComboEntry

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Sets the item_changed_state of this object's item true |
Combo_Fill_List | Called when the combo list is to be filled |
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message |
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Called when a drop-down list closes |
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Called when a drop-down list opens |
OnDropKey |  |
OnKillFocus | Sent whenever the object is about to lose the focus |
OnMaxText |  |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label |
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


ComboEntry [Function Combo_Item_Matching]

Combo_Item_Matching - ComboEntry

Returns the number of the combo item whose value matches sText

Type: Function

Return Data Type: Integer

Parameters: String sText

Parameter | Description
sText | The value to be searched for in the combo list

Return Value

If no combo item in the object has such a value, -1 is returned (0 is the number of the first combo item).

Description

The Combo_item_matching function returns the number of the combo item whose value matches sText. This is the message you will want to use to determine if an item in the internal list matches your form sText. This finds the item position in the internal list and not the Windows list. If the Windows list is sorted, these positions will be different.

This function checks to see if a value is in the combo-list

Function IsValueInList string sValue Returns Boolean
    integer iPos
    Get Combo_Item_Matching sValue to iPos // find the value in the list
    Function_return (iPos>=0)
End_function

This function removes a value from the combo list and returns true if the item existed:

Function RemoveValue string sValue Returns Boolean
    integer iPos
    Get Combo_Item_Matching sValue to iPos // find the value in the list
    If (iPos>=0) Begin
         Send Combo_Delete_Item iPos
    End
    Function_return (iPos>=0)
End_function

Combo_Item_Matching can be used to match and find your current value with the value in your list. This sample assumes that you have an additional array of records that are added (and therefore ordered) the same as you data-list. This function returns the record for the current value in your combo form.

Function CurrentComboRecord returns integer
    string sValue
    integer iRecord iPos
    Get Value to sValue // the value of the combo-form
    Get Combo_Item_Matching sValue to iPos // find the value in the list
    If (iPos=-1) Begin
        Move -1 to iRecord  // not found, no record...return -1
    End
    Else Begin
       Get Value of oRecords iPos to iRecord // record id from the record array object
    End
    Function_return iRecord
End_function

See Also

Combo_add_item | Combo_Insert_Item | Combo_Delete_Item | Combo_Item_Count | Combo_value | Validate_Combo_Value | Add_Form_to_List

Last Edited: October 23, 2003


ComboEntry [Function Help_Datafile]

Help_Datafile - ComboEntry

Returns the filename and fieldname in file.field format that contains help for the current item

Type: Function

Obsolete

Return Data Type: String

Parameters: No Parameters

Return Value

The filename and fieldname in file.field format that contains help for the current item

Description

The Help_datafile function returns the filename and fieldname in file.field format that contains help for the current item.

Last Edited: August 12, 2003


ComboEntry [Function Next_Object_Id]

Next_Object_Id - ComboEntry

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


ComboEntry [Function Prior_Object_Id]

Prior_Object_Id - ComboEntry

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


ComboEntry [Function Validate_Combo_Value]

Validate_Combo_Value - ComboEntry

Determines if a combo form's value is valid

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns 0 when the value in this object's window matches that of one of the combo items in the internal list, and non-zero when it does not

Description

The Validate_combo_value function returns 0 when the value in this object's window matches that of one of the combo items in the internal list, and non-zero when it does not. It can be used for simple validations. This respects allow_blank_state and will allow blank form values when true.

This would be used with entry_state is set true (when false the value should always be valid).

Get Validate_combo_Value of oComboForm to bErr
If bErr Begin
    Error DFERR_OPERATOR_ERROR "Please enter a valid combo value"
End

See Also

allow_blank_state | (entry_state

Last Edited: October 23, 2003


Methods for ComboEntry

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist |
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
Combo_Add_Item | Procedure | Adds an item to the combo list |
Combo_Delete_Data | Procedure | Deletes all this object's items |
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object |
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list |
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask |
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask |
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Combo_Value | Function | Determines if a combo form's value is valid |
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


ComboEntry [Procedure Set Currency_Mask]

Currency_Mask - ComboEntry

Provides an easy method for creating a currency mask

Type: Procedure Set

Data Type: String

Parameters: Integer item# Integer LeftDigit Integer RightDigit String DfltMask

Parameter | Description
item# | The item number
LeftDigit | Digits to the left of the decimal separator
RightDigit | Digits to the right of the decimal separator
DfltMask | The mask string to be applied. Optional and normally not passed

Description

This provides an easy method for creating a currency mask. The message is passed the number of digits to the left and right of the decimal separator and an optional template mask. This message will construct a mask, set the object's form_mask to this mask and set the object's form_datatype to mask_current_window.

Normally the template is not passed and the default currency template default_currency_mask is used. Default_currency_mask is a global string (which you may change) which contains the default currency template. Its default value is $,*;($,*), where $ represents the local Windows setting for the currency symbol. If template is passed, it should, at minimum, contain an asterisk. When the mask is constructed, the asterisk is expanded to contain the proper number of left and right digits.

Setting of this property makes it unnecessary to actually set the object's form_datatype to mask_currency_window.

If the object is based on Form or Entry, item# will always be zero.

Set currency_mask 0 to 6 2

Set currency_mask 0 to 8 2 "$,*;$,* "

See Also

Form | Numeric_mask

Last Edited: January 12, 2006


ComboEntry [Procedure Set Numeric_Mask]

Numeric_Mask - ComboEntry

Provides an easy method for creating a numeric mask

Type: Procedure Set

Data Type: String

Parameters: Integer item# Integer LeftDigit Integer RightDigit String DfltMask

Parameter | Description
item# | The item number
LeftDigit | Digits to the left of the decimal separator
RightDigit | Digits to the right of the decimal separator
DfltMask | The mask string to be applied. Optional and normally not passed

Description

This provides an easy method for creating a numeric mask. The message is passed the number of digits to the left and right of the decimal separator and an optional template mask. This message will construct a mask, set the object's form_mask to this mask and set the object's form_datatype to mask_numeric_window.

Normally the template is not passed and the default currency template default_numeric_mask is used. Default_Numeric_mask is a global string (which you may change) which contains the default numeric template. Its default value is "*". If template is passed it should, at minimum, contain an asterisk. When the mask is constructed, the asterisk is expanded to contain the proper number of left and right digits.

Setting of this property makes it unnecessary to actually set the object's form_datatype to mask_numeric_window.

If the object is based on Form or Entry, item# will always be zero.

Set numeric_mask 0 to 4 4

Set numeric_mask 0 to 6 0 "*%"

See Also

Form | Currency_Mask

Last Edited: January 12, 2006


ComboEntry [Procedure Activate_Area]

Activate_Area - ComboEntry

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


ComboEntry [Procedure Add_Form_To_List]

Add_Form_To_List - ComboEntry

Adds the current form value to the combo list if it does not already exist

Type: Procedure

Parameters: No Parameters

Description

The Add_form_to_list message adds the current form value to the combo list if it does not already exist. This would only be used with editable combo lists (entry_state is true). This provides an easy mechanism for adding new values to your combo list.

// when exiting add current value to list, unless it already exists
Procedure Exiting
    string sValue
    forward send exiting
    Get Value to sValue
    If (sValue<>"") begin
        Send Add_form_to_list
    end
End_procedure

See Also

entry_state | Combo_Add_Item | Combo_Insert_Item | Combo_Delete_Item | Combo_Item_Matching | Validate_Combo_Value | Combo_Item_Count | Combo_value

Last Edited: October 23, 2003


ComboEntry [Procedure Beginning_of_Panel]

Beginning_of_Panel - ComboEntry

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


ComboEntry [Procedure Bottom_of_Panel]

Bottom_of_Panel - ComboEntry

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


ComboEntry [Procedure Combo_Add_Item]

Combo_Add_Item - ComboEntry

Adds an item to the combo list

Type: Procedure

Parameters: string sValue

Parameter | Description
sValue | The value to be added to the combo list

Description

When this message is received, a choice is added to this object's list of choices with the value of sValue. This is most often used within the combo_fill_list procedure.

This sample fills a list and sets the default value to a fixed value

Procedure Combo_fill_list
    Send  Combo_Delete_Data // just in case the list is not empty
    Send Combo_Add_item "first"
    Send Combo_Add_item "second"
    Send Combo_Add_item "third"
    // set default to a value
    Set Value to "second"
End_procedure

This sample fills a list and sets the default value to whatever is the first value

Procedure Combo_fill_list
    string sValue
    Send  Combo_Delete_Data
    Send Combo_Add_item "first"
    Send Combo_Add_item "second"
    Send Combo_Add_item "third"
    // set default to whatever the first value happens to be
    Get Combo_value 0 to sValue
    Set Value to sValue
End_procedure

Note:This represents the item position in the internal list and not the Windows list. If the Windows list is sorted, these positions will be different.

See Also

Combo_fill_list | Combo_Item_Count | Combo_value | Combo_Insert_Item | Combo_Delete_Item | Combo_Item_Matching | Validate_Combo_Value | Add_Form_to_List

Last Edited: October 23, 2003


ComboEntry [Procedure Combo_Delete_Data]

Combo_Delete_Data - ComboEntry

Deletes all this object's items

Type: Procedure

Parameters: No Parameters

Description

The Combo_delete_data procedure deletes all this object's items.

Procedure Combo_Fill_List
    Send Combo_Delete_Data
    Send Combo_Add_Item "Research"
    Send Combo_Add_Item "Accounting"
    Send Combo_Add_Item "Support"
    Send Combo_Add_Item "Marketing"
End_Procedure

Last Edited: December 7, 2004


ComboEntry [Procedure Combo_Delete_Item]

Combo_Delete_Item - ComboEntry

Removes a Combo item from the list of values in a combo object

Type: Procedure

Parameters: Integer iItem

Parameter | Description
iItem | The item number

Description

The Combo_delete_item procedure removes a Combo item from the list of values in a combo object

You should use the Combo_Item_matching function to determine the position of a value in your data-list

This function removes a value from the combo list and returns true if the item existed:

Function RemoveValue string sValue Returns Boolean
    integer iPos
    Get Combo_Item_Matching sValue to iPos // find the value in the list
    If (iPos>=0) Begin
         Send Combo_Delete_Item iPos
    End
    Function_return (iPos>=0)
End_function

Note:This represents the item position in the internal list and not the Windows list. If the Windows list is sorted, these positions will be different.

See Also

Combo_Item_Matching | | Combo_add_item | Combo_Insert_Item | Combo_Item_Count | Combo_Value | Validate_Combo_Value | Add_Form_to_List

Last Edited: October 23, 2003


ComboEntry [Procedure Combo_Insert_Item]

Combo_Insert_Item - ComboEntry

Inserts a combo item in a combo object's list

Type: Procedure

Parameters: Integer iItem string sValue

Parameter | Description
iItem | The item number
sValue | The value of the item to be inserted in the combo list

Description

The Combo_insert_item procedure inserts a combo item to this object's list in the position of iItem with a value of sValue.

This example, checks to see if the value "second" exists in the combo list. If it does not it inserts it before the value "third".

Procedure AddSecond
    Integer iPos
    // see if "second" already exists
    Get Combo_Item_Matching "second" to iPos
    // if it does not exist add it
    If (iPos=-1) Begin
        Get Combo_Item_Matching "third" to iPos
        If (iPos>-1) Begin // only insert if we can find "third"
            Send Combo_insert_item iPos "second"
        end
    end
end_procedure

Note:This represents the item position in the internal list and not the Windows list. If the Windows list is sorted, these positions will be different.

See Also

Combo_Add_Item | Combo_fill_list | Combo_Item_Count | Combo_value | Combo_Delete_Item | Combo_Item_Matching | Validate_Combo_Value | Add_Form_to_List

Last Edited: October 23, 2003


ComboEntry [Procedure DoHtmlHelp]

DoHtmlHelp - ComboEntry

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


ComboEntry [Procedure End_of_Panel]

End_of_Panel - ComboEntry

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


ComboEntry [Procedure Error_Help]

Error_Help - ComboEntry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboEntry [Procedure Extended_Help]

Extended_Help - ComboEntry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboEntry [Procedure File_Help]

File_Help - ComboEntry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboEntry [Procedure Help]

Help - ComboEntry

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


ComboEntry [Procedure Help_For_Help]

Help_For_Help - ComboEntry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboEntry [Procedure Help_Index]

Help_Index - ComboEntry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboEntry [Procedure Help_on_topic]

Help_on_topic - ComboEntry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboEntry [Procedure Keys_Help]

Keys_Help - ComboEntry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboEntry [Procedure Request_Status_Help]

Request_Status_Help - ComboEntry

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


ComboEntry [Procedure Top_of_Panel]

Top_of_Panel - ComboEntry

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for ComboEntry

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Blank_State | Determines if a blank value is valid |
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case |
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Combo_Data_Object | Specifies the object ID of the internal l combo object | DfBaseComboBoxEntry
Combo_Item_Count | Returns the number of choices in the combo object's list |
Combo_Sort_State | Determines if the object will sort its visual list |
Combo_Value | Specifies the value of an item in the combo objects data-list |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object |
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object |
Label_Col_Offset | The horizontal distance from the object to its label |
Label_Justification_Mode | The justification mode for the text within this object's label |
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property |
Label_Row_Offset | The vertical distance from the top edge of the object and its label |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
ListRowCount | Determines the number of rows in a combo form |
ListWidth | Detrmines the width of a combo's drop down list |
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


ComboEntry [Property Allow_Blank_State]

Allow_Blank_State - ComboEntry

Determines if a blank value is valid

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If you set the Allow_blank_state property true, validate_combo_value will approve the selection and insertion of blank values through this object. By default, it does not allow this.

Default is false.

Last Edited: January 12, 2006


ComboEntry [Property Capslock_State]

Capslock_State - ComboEntry

Determines if all text entered to this object from the keyboard will be converted to upper case

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Capslock_State property is set true, all text entered to this object from the keyboard will be converted to upper case. Values set to this object by the program will not be affected by this property. This property cannot be changed while this object is active; for a change made while the program is running to take effect, the object must be (deactivated and) activated after this property has been set to the desired value.

Last Edited: January 12, 2006


ComboEntry [Property Combo_Item_Count]

Combo_Item_Count - ComboEntry

Returns the number of choices in the combo object's list

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Combo_item_count property returns the number of items in the combo object's list.

This sample shows all items in a combo list.

Procedure ShowAllValues
    string  sCurrent
    string  sValue
    integer i iItems
    Boolean bIsCurrent
    Get Value to sCurrent //  the current value of the combo form
    Get Combo_item_count to iItems
    For i from 0 to (iItems-1)
        Get Combo_value i to sValue // the value of each item in the form
        Move (sCurrent=sValue) to bIsCurrent
        Send ShowList i sValue bIsCurrent
    Loop
End_procedure

Note:This represents the item position in the internal list and not the Windows list. If the Windows list is sorted, these positions will be different.

See Also

Combo_value | Combo_add_item | Combo_Insert_Item | Combo_Delete_Item | Combo_Item_Matching | Validate_Combo_Value | Add_Form_to_List

Last Edited: October 23, 2003


ComboEntry [Property Combo_Sort_State]

Combo_Sort_State - ComboEntry

Determines if the object will sort its visual list

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If you set the Combo_sort_state property false, this object will not sort its visual list. When sorted, the visual list and the internal list will not be in the same order.

Default is true.

Last Edited: January 12, 2006


ComboEntry [Property Combo_Value]

Combo_Value - ComboEntry

Specifies the value of an item in the combo objects data-list

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer item# String sValue

Parameter | Description
item# | The item number
sValue | The value of the item number

Description

The Combo_value property gets and sets the value of an item in a combo data-list.

This sample shows all items in a combo list.

Procedure ShowAllValues
    string  sCurrent
    string  sValue
    integer i iItems
    Boolean bIsCurrent
    Get Value to sCurrent //  the current value of the combo form
    Get Combo_item_count to iItems
    For i from 0 to (iItems-1)
        Get Combo_value i to sValue // the value of each item in the form
        Move (sCurrent=sValue) to bIsCurrent
        Send ShowList i sValue bIsCurrent
    Loop
End_procedure

You can use combo_value to set the value of a combo-form to an item in your list. This sets your form value to the last item in your combo list

Get Item_count to iItems
Get Combo_Value (iItems-1) to sValue
Set Value to sValue

Note:This represents the item position in the internal list and not the Windows list. If the Windows list is sorted, these positions will be different.

See Also

Combo_Item_Count | Combo_add_item | Combo_Insert_Item | Combo_Delete_Item | Combo_Item_Matching | Validate_Combo_Value | Add_Form_to_List

Last Edited: October 23, 2003


ComboEntry [Property Enabled_State]

Enabled_State - ComboEntry

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


ComboEntry [Property Explicit_Shadow_State]

Explicit_Shadow_State - ComboEntry

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


ComboEntry [Property Floating_Menu_Object]

Floating_Menu_Object - ComboEntry

Identifies the floating context menu for this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Floating_Menu_Object property identifies the floating menu for this object. The default setting will provide a standard edit context menu. You may create your own custom floating menus and assign them to objects by setting this property. You may also disable a floating menu by setting this property to zero.

See Also

Form

Last Edited: November 22, 2004


ComboEntry [Property Help_id]

Help_id - ComboEntry

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


ComboEntry [Property Help_Keyword]

Help_Keyword - ComboEntry

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


ComboEntry [Property Item_Shadow_State]

Item_Shadow_State - ComboEntry

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


ComboEntry [Property Label]

Label - ComboEntry

Sets the text for a label or heading for an entry control object

Type: Property

Access: Read/Write

Data Type: String

Description

The Label property sets the text for a label or heading for an entry control object (form, edit or list). In most classes, just setting this property is all that is required for the class to present the label in whatever particular way each class does this. In data-aware classes, the value of this property is overridden by label values in the DDO when auto_label_state has been set true.

Object F1 is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "First Name:"
End_object

Last Edited: August 18, 2003


ComboEntry [Property Label_Col_Offset]

Label_Col_Offset - ComboEntry

The horizontal distance from the object to its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Col_Offset is the horizontal distance from the object to its label. Units represent distance to the left (i.e., labels appear to the left of their object). If the label's justification-mode is left or top (jmode_left, jmode_top) this represents the distance from left edge of the object to the left edge of its label. If the justification-mode is right (jmode_right) this represents the distance from the left edge of the object to the right edge of the label. By default, this is the value of default_label_offset, which is supplied with a value of 60 (this is a global integer which can be changed).

Default is default label offset.

Last Edited: August 18, 2003


ComboEntry [Property Label_Justification_Mode]

Label_Justification_Mode - ComboEntry

The justification mode for the text within this object's label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Justification_Mode is the justification mode for the text within this object's label.

When the label_justification_mode is changed the row and col offset properties will often need to be changed as well.

The default mode for labels (jmode_left) is stored in the global integer default_label_jmode.

Object LeftForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Left Justify:" // use default column of 60
End_object

Object RightForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Right Justify:"
    Set label_justification_mode to jmode_right
    // set distance between right side of the label and the left side
    // of the object
    Set label_col_offset to 3
End_object

Object TopForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Top Justify:"
    Set label_justification_mode to jmode_top
    // label and object will align vertically
    Set label_col_offset to 0
End_object

Default is JMode Left.

Last Edited: August 18, 2003


ComboEntry [Property Label_Offset]

Label_Offset - ComboEntry

Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer i1 integer i2

Parameter | Description
i1 | The Row Offset of the Label
i2 | The Column Offset of the Label

Description

The Label_Offset property returns both the label_row_offset and the label_col_offset properties as a single (two-component) property. The Hi() value of the return parameter represents the row offset. The Low() value represents the column offset.

Get Label_Offset of oForm to iOffset
Move (Hi(iOffset))  to iRowOffset
Move (Low(iOffset)) to iColumnOffset

Label_offset is set as a single property passing the row offset and the column offset as two separate parameters.

Set Label_Offset of oForm to iRowOffset iColumnOffset

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

Last Edited: June 22, 2005


ComboEntry [Property Label_Row_Offset]

Label_Row_Offset - ComboEntry

The vertical distance from the top edge of the object and its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Row_Offset is the vertical distance from the top edge of the object and its label. If the label's justification-mode is jmode_top it represents the vertical distance from the top edge of this object to the bottom edge of its label and larger numbers moves the label up (and away from the object). If the mode is not top it represents the distance from the top edge of the object and the top edge of the label and larger numbers moves the label down. By default, this is zero which is suitable for both form and side labels.

Default is 0.

Last Edited: August 18, 2003


ComboEntry [Property ListRowCount]

ListRowCount - ComboEntry

Determines the number of rows in a combo form

Type: Property

Access: Read/Write

Data Type: Integer

Description

ListRowCount determines the maximum number of rows that should be visible in a combo-list. When the the items in a combo list exceed this maximum, the list scrolls.

The default value is 10.

Set ListRowCount to 4 // never allow more than four rows to be visible

Note:Prior to release 9.1, the default value of ListRowCount was 0. When set to 0, the combo-list sets the value to around 10 rows. Setting the value to 0, is supported only for legacy purposes and should be avoided.

See Also

ListWidth

Last Edited: November 13, 2003


ComboEntry [Property ListWidth]

ListWidth - ComboEntry

Detrmines the width of a combo's drop down list

Type: Property

Access: Read/Write

Data Type: Integer

Description

ListWidth determines the width of a combo's drop down list in pixels. When set to 0 (the default) the width will be the same as form combo's form width.

Set ListWidth to 100

See Also

ListRowCount

Last Edited: October 23, 2003


ComboEntry [Property Object_Shadow_State]

Object_Shadow_State - ComboEntry

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


ComboEntry [Property psHtmlHelpTopic]

psHtmlHelpTopic - ComboEntry

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


ComboEntry [Property Status_Help]

Status_Help - ComboEntry

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


ComboEntry [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - ComboEntry

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


ComboForm [Event Combo_Edit_Changed]

Combo_Edit_Changed - ComboForm

Sets the item_changed_state of this object's item true

Type: Event

Parameters: No Parameters

Description

The Combo_edit_changed procedure sets the item_changed_state of this object's item true. It is received when a user edits the value in the combo object's display.

Last Edited: July 31, 2003


ComboForm [Event Combo_Fill_List]

Combo_Fill_List - ComboForm

Called when the combo list is to be filled

Type: Event

Parameters: No Parameters

Description

The Combo_fill_list message is called when the combo list is to be filled. By default, it does nothing. You must supply the code to fill the combo list. This procedure will usually consist of one or more combo_add_item messages.

Procedure Combo_Fill_List
    Send Combo_Delete_Data
    Send Combo_Add_Item "Research"
    Send Combo_Add"Item "Accounting"
    Send Combo_Add_Item "Support"
    Send Combo_Add_Item "Marketing"
End_Procedure

Procedure Combo_Fill_List
    Send Combo_Delete_Data
    Clear MyFile
    Find gt MyFile by 1
    While (found)
        Send Combo_Add_Item MyFile.Code
        Find gt MyFile by 1
    End
End_Procedure

See Also

Combo_Add_Item | Combo_Delete_Data | Combo_Item_Count | Combo_value | Combo_Insert_Item | Combo_Delete_Item | Combo_Item_Matching | Validate_Combo_Value | Add_Form_to_List

Last Edited: November 19, 2004


ComboForm [Event Combo_Item_Changed]

Combo_Item_Changed - ComboForm

Sets the item_changed_state of this object's item true and sends the onChange message

Type: Event

Parameters: No Parameters

Description

The Combo_item_changed event sets the item_changed_state of this object's item true and sends the onChange message. It is received when a user scrolls the combo list from its initial displayed choice.

Last Edited: July 31, 2003


ComboForm [Event OnBeginningOfPanel]

OnBeginningOfPanel - ComboForm

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


ComboForm [Event OnChange]

OnChange - ComboForm

Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message

Type: Event

Parameters: No Parameters

Description

The OnChange event message is sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message. This is a notification. It does nothing by default and is intended for augmentation.

Note:The OnChange event should not be used to change focus or to alter the value of controls such as Form or ComboForm.

This event is created to respond to a data change event and not to trigger other data changes. If you want to respond to a change in a combo based on a user selection, it is suggested you augment other procedures such as Combo_Item_Changed and Combo_Edit_Changed.

See Also

Form

Last Edited: February 18, 2004


ComboForm [Event OnCloseUp]

OnCloseUp - ComboForm

Called when a drop-down list closes

Type: Event

Parameters: No Parameters

Description

The OnCloseUp event message is called when a drop-down list closes. It is a notification and is intended for augmentation.

Last Edited: September 10, 2003


ComboForm [Event OnDropDown]

OnDropDown - ComboForm

Called when a drop-down list opens

Type: Event

Parameters: No Parameters

Description

The OnDropDown event message is called when a drop-down list opens. It is a notification and is intended for augmentation.

Last Edited: September 10, 2003


ComboForm [Event OnDropKey]

OnDropKey - ComboForm

Type: Event

Return Data Type: Boolean

Parameters: integer iVKey boolean bIsAccelerator

Parameter | Description
iVKey | [ToDo: In Progress]
bIsAccelerator | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


ComboForm [Event OnKillFocus]

OnKillFocus - ComboForm

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


ComboForm [Event OnMaxText]

OnMaxText - ComboForm

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


ComboForm [Event OnSetFocus]

OnSetFocus - ComboForm

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


ComboForm [Event Prompt_Callback]

Prompt_Callback - ComboForm

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


ComboForm [Event Shadow_Display]

Shadow_Display - ComboForm

Creates the proper shadowed or unshadowed appearance for this object and its label

Type: Event

Parameters: No Parameters

Description

The Shadow_Display message is called whenever the object's enabled_state is changed. It is responsible for creating the proper shadowed or unshadowed appearance for this object and its label.

See Also

Form

Last Edited: September 11, 2003


Events for ComboForm

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Sets the item_changed_state of this object's item true |
Combo_Fill_List | Called when the combo list is to be filled |
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message |
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Called when a drop-down list closes |
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Called when a drop-down list opens |
OnDropKey |  |
OnKillFocus | Sent whenever the object is about to lose the focus |
OnMaxText |  |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label |


ComboForm [Function Combo_Item_Matching]

Combo_Item_Matching - ComboForm

Returns the number of the combo item whose value matches sText

Type: Function

Return Data Type: Integer

Parameters: String sText

Parameter | Description
sText | The value to be searched for in the combo list

Return Value

If no combo item in the object has such a value, -1 is returned (0 is the number of the first combo item).

Description

The Combo_item_matching function returns the number of the combo item whose value matches sText. This is the message you will want to use to determine if an item in the internal list matches your form sText. This finds the item position in the internal list and not the Windows list. If the Windows list is sorted, these positions will be different.

This function checks to see if a value is in the combo-list

Function IsValueInList string sValue Returns Boolean
    integer iPos
    Get Combo_Item_Matching sValue to iPos // find the value in the list
    Function_return (iPos>=0)
End_function

This function removes a value from the combo list and returns true if the item existed:

Function RemoveValue string sValue Returns Boolean
    integer iPos
    Get Combo_Item_Matching sValue to iPos // find the value in the list
    If (iPos>=0) Begin
         Send Combo_Delete_Item iPos
    End
    Function_return (iPos>=0)
End_function

Combo_Item_Matching can be used to match and find your current value with the value in your list. This sample assumes that you have an additional array of records that are added (and therefore ordered) the same as you data-list. This function returns the record for the current value in your combo form.

Function CurrentComboRecord returns integer
    string sValue
    integer iRecord iPos
    Get Value to sValue // the value of the combo-form
    Get Combo_Item_Matching sValue to iPos // find the value in the list
    If (iPos=-1) Begin
        Move -1 to iRecord  // not found, no record...return -1
    End
    Else Begin
       Get Value of oRecords iPos to iRecord // record id from the record array object
    End
    Function_return iRecord
End_function

See Also

Combo_add_item | Combo_Insert_Item | Combo_Delete_Item | Combo_Item_Count | Combo_value | Validate_Combo_Value | Add_Form_to_List

Last Edited: October 23, 2003


ComboForm [Function Next_Object_Id]

Next_Object_Id - ComboForm

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


ComboForm [Function Prior_Object_Id]

Prior_Object_Id - ComboForm

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


ComboForm [Function Validate_Combo_Value]

Validate_Combo_Value - ComboForm

Determines if a combo form's value is valid

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns 0 when the value in this object's window matches that of one of the combo items in the internal list, and non-zero when it does not

Description

The Validate_combo_value function returns 0 when the value in this object's window matches that of one of the combo items in the internal list, and non-zero when it does not. It can be used for simple validations. This respects allow_blank_state and will allow blank form values when true.

This would be used with entry_state is set true (when false the value should always be valid).

Get Validate_combo_Value of oComboForm to bErr
If bErr Begin
    Error DFERR_OPERATOR_ERROR "Please enter a valid combo value"
End

See Also

allow_blank_state | (entry_state

Last Edited: October 23, 2003


Methods for ComboForm

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist |
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
Combo_Add_Item | Procedure | Adds an item to the combo list |
Combo_Delete_Data | Procedure | Deletes all this object's items |
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object |
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list |
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask |
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask |
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Combo_Value | Function | Determines if a combo form's value is valid |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


ComboForm [Procedure Set Currency_Mask]

Currency_Mask - ComboForm

Provides an easy method for creating a currency mask

Type: Procedure Set

Data Type: String

Parameters: Integer item# Integer LeftDigit Integer RightDigit String DfltMask

Parameter | Description
item# | The item number
LeftDigit | Digits to the left of the decimal separator
RightDigit | Digits to the right of the decimal separator
DfltMask | The mask string to be applied. Optional and normally not passed

Description

This provides an easy method for creating a currency mask. The message is passed the number of digits to the left and right of the decimal separator and an optional template mask. This message will construct a mask, set the object's form_mask to this mask and set the object's form_datatype to mask_current_window.

Normally the template is not passed and the default currency template default_currency_mask is used. Default_currency_mask is a global string (which you may change) which contains the default currency template. Its default value is $,*;($,*), where $ represents the local Windows setting for the currency symbol. If template is passed, it should, at minimum, contain an asterisk. When the mask is constructed, the asterisk is expanded to contain the proper number of left and right digits.

Setting of this property makes it unnecessary to actually set the object's form_datatype to mask_currency_window.

If the object is based on Form or Entry, item# will always be zero.

Set currency_mask 0 to 6 2

Set currency_mask 0 to 8 2 "$,*;$,* "

See Also

Form | Numeric_mask

Last Edited: January 12, 2006


ComboForm [Procedure Set Numeric_Mask]

Numeric_Mask - ComboForm

Provides an easy method for creating a numeric mask

Type: Procedure Set

Data Type: String

Parameters: Integer item# Integer LeftDigit Integer RightDigit String DfltMask

Parameter | Description
item# | The item number
LeftDigit | Digits to the left of the decimal separator
RightDigit | Digits to the right of the decimal separator
DfltMask | The mask string to be applied. Optional and normally not passed

Description

This provides an easy method for creating a numeric mask. The message is passed the number of digits to the left and right of the decimal separator and an optional template mask. This message will construct a mask, set the object's form_mask to this mask and set the object's form_datatype to mask_numeric_window.

Normally the template is not passed and the default currency template default_numeric_mask is used. Default_Numeric_mask is a global string (which you may change) which contains the default numeric template. Its default value is "*". If template is passed it should, at minimum, contain an asterisk. When the mask is constructed, the asterisk is expanded to contain the proper number of left and right digits.

Setting of this property makes it unnecessary to actually set the object's form_datatype to mask_numeric_window.

If the object is based on Form or Entry, item# will always be zero.

Set numeric_mask 0 to 4 4

Set numeric_mask 0 to 6 0 "*%"

See Also

Form | Currency_Mask

Last Edited: January 12, 2006


ComboForm [Procedure Activate_Area]

Activate_Area - ComboForm

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


ComboForm [Procedure Add_Form_To_List]

Add_Form_To_List - ComboForm

Adds the current form value to the combo list if it does not already exist

Type: Procedure

Parameters: No Parameters

Description

The Add_form_to_list message adds the current form value to the combo list if it does not already exist. This would only be used with editable combo lists (entry_state is true). This provides an easy mechanism for adding new values to your combo list.

// when exiting add current value to list, unless it already exists
Procedure Exiting
    string sValue
    forward send exiting
    Get Value to sValue
    If (sValue<>"") begin
        Send Add_form_to_list
    end
End_procedure

See Also

entry_state | Combo_Add_Item | Combo_Insert_Item | Combo_Delete_Item | Combo_Item_Matching | Validate_Combo_Value | Combo_Item_Count | Combo_value

Last Edited: October 23, 2003


ComboForm [Procedure Beginning_of_Panel]

Beginning_of_Panel - ComboForm

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


ComboForm [Procedure Bottom_of_Panel]

Bottom_of_Panel - ComboForm

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


ComboForm [Procedure Combo_Add_Item]

Combo_Add_Item - ComboForm

Adds an item to the combo list

Type: Procedure

Parameters: string sValue

Parameter | Description
sValue | The value to be added to the combo list

Description

When this message is received, a choice is added to this object's list of choices with the value of sValue. This is most often used within the combo_fill_list procedure.

This sample fills a list and sets the default value to a fixed value

Procedure Combo_fill_list
    Send  Combo_Delete_Data // just in case the list is not empty
    Send Combo_Add_item "first"
    Send Combo_Add_item "second"
    Send Combo_Add_item "third"
    // set default to a value
    Set Value to "second"
End_procedure

This sample fills a list and sets the default value to whatever is the first value

Procedure Combo_fill_list
    string sValue
    Send  Combo_Delete_Data
    Send Combo_Add_item "first"
    Send Combo_Add_item "second"
    Send Combo_Add_item "third"
    // set default to whatever the first value happens to be
    Get Combo_value 0 to sValue
    Set Value to sValue
End_procedure

Note:This represents the item position in the internal list and not the Windows list. If the Windows list is sorted, these positions will be different.

See Also

Combo_fill_list | Combo_Item_Count | Combo_value | Combo_Insert_Item | Combo_Delete_Item | Combo_Item_Matching | Validate_Combo_Value | Add_Form_to_List

Last Edited: October 23, 2003


ComboForm [Procedure Combo_Delete_Data]

Combo_Delete_Data - ComboForm

Deletes all this object's items

Type: Procedure

Parameters: No Parameters

Description

The Combo_delete_data procedure deletes all this object's items.

Procedure Combo_Fill_List
    Send Combo_Delete_Data
    Send Combo_Add_Item "Research"
    Send Combo_Add_Item "Accounting"
    Send Combo_Add_Item "Support"
    Send Combo_Add_Item "Marketing"
End_Procedure

Last Edited: December 7, 2004


ComboForm [Procedure Combo_Delete_Item]

Combo_Delete_Item - ComboForm

Removes a Combo item from the list of values in a combo object

Type: Procedure

Parameters: Integer iItem

Parameter | Description
iItem | The item number

Description

The Combo_delete_item procedure removes a Combo item from the list of values in a combo object

You should use the Combo_Item_matching function to determine the position of a value in your data-list

This function removes a value from the combo list and returns true if the item existed:

Function RemoveValue string sValue Returns Boolean
    integer iPos
    Get Combo_Item_Matching sValue to iPos // find the value in the list
    If (iPos>=0) Begin
         Send Combo_Delete_Item iPos
    End
    Function_return (iPos>=0)
End_function

Note:This represents the item position in the internal list and not the Windows list. If the Windows list is sorted, these positions will be different.

See Also

Combo_Item_Matching | | Combo_add_item | Combo_Insert_Item | Combo_Item_Count | Combo_Value | Validate_Combo_Value | Add_Form_to_List

Last Edited: October 23, 2003


ComboForm [Procedure Combo_Insert_Item]

Combo_Insert_Item - ComboForm

Inserts a combo item in a combo object's list

Type: Procedure

Parameters: Integer iItem string sValue

Parameter | Description
iItem | The item number
sValue | The value of the item to be inserted in the combo list

Description

The Combo_insert_item procedure inserts a combo item to this object's list in the position of iItem with a value of sValue.

This example, checks to see if the value "second" exists in the combo list. If it does not it inserts it before the value "third".

Procedure AddSecond
    Integer iPos
    // see if "second" already exists
    Get Combo_Item_Matching "second" to iPos
    // if it does not exist add it
    If (iPos=-1) Begin
        Get Combo_Item_Matching "third" to iPos
        If (iPos>-1) Begin // only insert if we can find "third"
            Send Combo_insert_item iPos "second"
        end
    end
end_procedure

Note:This represents the item position in the internal list and not the Windows list. If the Windows list is sorted, these positions will be different.

See Also

Combo_Add_Item | Combo_fill_list | Combo_Item_Count | Combo_value | Combo_Delete_Item | Combo_Item_Matching | Validate_Combo_Value | Add_Form_to_List

Last Edited: October 23, 2003


ComboForm [Procedure DoHtmlHelp]

DoHtmlHelp - ComboForm

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


ComboForm [Procedure End_of_Panel]

End_of_Panel - ComboForm

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


ComboForm [Procedure Error_Help]

Error_Help - ComboForm

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboForm [Procedure Extended_Help]

Extended_Help - ComboForm

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboForm [Procedure File_Help]

File_Help - ComboForm

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboForm [Procedure Help]

Help - ComboForm

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


ComboForm [Procedure Help_For_Help]

Help_For_Help - ComboForm

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboForm [Procedure Help_Index]

Help_Index - ComboForm

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboForm [Procedure Help_on_topic]

Help_on_topic - ComboForm

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboForm [Procedure Keys_Help]

Keys_Help - ComboForm

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


ComboForm [Procedure Request_Status_Help]

Request_Status_Help - ComboForm

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


ComboForm [Procedure Top_of_Panel]

Top_of_Panel - ComboForm

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for ComboForm

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Blank_State | Determines if a blank value is valid |
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case |
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Combo_Data_Object | Specifies the object ID of the internal l combo object | DfBaseComboBox
Combo_Item_Count | Returns the number of choices in the combo object's list |
Combo_Sort_State | Determines if the object will sort its visual list |
Combo_Value | Specifies the value of an item in the combo objects data-list |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object |
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object |
Label_Col_Offset | The horizontal distance from the object to its label |
Label_Justification_Mode | The justification mode for the text within this object's label |
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property |
Label_Row_Offset | The vertical distance from the top edge of the object and its label |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
ListRowCount | Determines the number of rows in a combo form |
ListWidth | Detrmines the width of a combo's drop down list |
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


ComboForm [Property Allow_Blank_State]

Allow_Blank_State - ComboForm

Determines if a blank value is valid

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If you set the Allow_blank_state property true, validate_combo_value will approve the selection and insertion of blank values through this object. By default, it does not allow this.

Default is false.

Last Edited: January 12, 2006


ComboForm [Property Capslock_State]

Capslock_State - ComboForm

Determines if all text entered to this object from the keyboard will be converted to upper case

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Capslock_State property is set true, all text entered to this object from the keyboard will be converted to upper case. Values set to this object by the program will not be affected by this property. This property cannot be changed while this object is active; for a change made while the program is running to take effect, the object must be (deactivated and) activated after this property has been set to the desired value.

Last Edited: January 12, 2006


ComboForm [Property Combo_Item_Count]

Combo_Item_Count - ComboForm

Returns the number of choices in the combo object's list

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Combo_item_count property returns the number of items in the combo object's list.

This sample shows all items in a combo list.

Procedure ShowAllValues
    string  sCurrent
    string  sValue
    integer i iItems
    Boolean bIsCurrent
    Get Value to sCurrent //  the current value of the combo form
    Get Combo_item_count to iItems
    For i from 0 to (iItems-1)
        Get Combo_value i to sValue // the value of each item in the form
        Move (sCurrent=sValue) to bIsCurrent
        Send ShowList i sValue bIsCurrent
    Loop
End_procedure

Note:This represents the item position in the internal list and not the Windows list. If the Windows list is sorted, these positions will be different.

See Also

Combo_value | Combo_add_item | Combo_Insert_Item | Combo_Delete_Item | Combo_Item_Matching | Validate_Combo_Value | Add_Form_to_List

Last Edited: October 23, 2003


ComboForm [Property Combo_Sort_State]

Combo_Sort_State - ComboForm

Determines if the object will sort its visual list

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If you set the Combo_sort_state property false, this object will not sort its visual list. When sorted, the visual list and the internal list will not be in the same order.

Default is true.

Last Edited: January 12, 2006


ComboForm [Property Combo_Value]

Combo_Value - ComboForm

Specifies the value of an item in the combo objects data-list

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer item# String sValue

Parameter | Description
item# | The item number
sValue | The value of the item number

Description

The Combo_value property gets and sets the value of an item in a combo data-list.

This sample shows all items in a combo list.

Procedure ShowAllValues
    string  sCurrent
    string  sValue
    integer i iItems
    Boolean bIsCurrent
    Get Value to sCurrent //  the current value of the combo form
    Get Combo_item_count to iItems
    For i from 0 to (iItems-1)
        Get Combo_value i to sValue // the value of each item in the form
        Move (sCurrent=sValue) to bIsCurrent
        Send ShowList i sValue bIsCurrent
    Loop
End_procedure

You can use combo_value to set the value of a combo-form to an item in your list. This sets your form value to the last item in your combo list

Get Item_count to iItems
Get Combo_Value (iItems-1) to sValue
Set Value to sValue

Note:This represents the item position in the internal list and not the Windows list. If the Windows list is sorted, these positions will be different.

See Also

Combo_Item_Count | Combo_add_item | Combo_Insert_Item | Combo_Delete_Item | Combo_Item_Matching | Validate_Combo_Value | Add_Form_to_List

Last Edited: October 23, 2003


ComboForm [Property Enabled_State]

Enabled_State - ComboForm

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


ComboForm [Property Explicit_Shadow_State]

Explicit_Shadow_State - ComboForm

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


ComboForm [Property Floating_Menu_Object]

Floating_Menu_Object - ComboForm

Identifies the floating context menu for this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Floating_Menu_Object property identifies the floating menu for this object. The default setting will provide a standard edit context menu. You may create your own custom floating menus and assign them to objects by setting this property. You may also disable a floating menu by setting this property to zero.

See Also

Form

Last Edited: November 22, 2004


ComboForm [Property Help_id]

Help_id - ComboForm

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


ComboForm [Property Help_Keyword]

Help_Keyword - ComboForm

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


ComboForm [Property Item_Shadow_State]

Item_Shadow_State - ComboForm

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


ComboForm [Property Label]

Label - ComboForm

Sets the text for a label or heading for an entry control object

Type: Property

Access: Read/Write

Data Type: String

Description

The Label property sets the text for a label or heading for an entry control object (form, edit or list). In most classes, just setting this property is all that is required for the class to present the label in whatever particular way each class does this. In data-aware classes, the value of this property is overridden by label values in the DDO when auto_label_state has been set true.

Object F1 is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "First Name:"
End_object

Last Edited: August 18, 2003


ComboForm [Property Label_Col_Offset]

Label_Col_Offset - ComboForm

The horizontal distance from the object to its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Col_Offset is the horizontal distance from the object to its label. Units represent distance to the left (i.e., labels appear to the left of their object). If the label's justification-mode is left or top (jmode_left, jmode_top) this represents the distance from left edge of the object to the left edge of its label. If the justification-mode is right (jmode_right) this represents the distance from the left edge of the object to the right edge of the label. By default, this is the value of default_label_offset, which is supplied with a value of 60 (this is a global integer which can be changed).

Default is default label offset.

Last Edited: August 18, 2003


ComboForm [Property Label_Justification_Mode]

Label_Justification_Mode - ComboForm

The justification mode for the text within this object's label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Justification_Mode is the justification mode for the text within this object's label.

When the label_justification_mode is changed the row and col offset properties will often need to be changed as well.

The default mode for labels (jmode_left) is stored in the global integer default_label_jmode.

Object LeftForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Left Justify:" // use default column of 60
End_object

Object RightForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Right Justify:"
    Set label_justification_mode to jmode_right
    // set distance between right side of the label and the left side
    // of the object
    Set label_col_offset to 3
End_object

Object TopForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Top Justify:"
    Set label_justification_mode to jmode_top
    // label and object will align vertically
    Set label_col_offset to 0
End_object

Default is JMode Left.

Last Edited: August 18, 2003


ComboForm [Property Label_Offset]

Label_Offset - ComboForm

Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer i1 integer i2

Parameter | Description
i1 | The Row Offset of the Label
i2 | The Column Offset of the Label

Description

The Label_Offset property returns both the label_row_offset and the label_col_offset properties as a single (two-component) property. The Hi() value of the return parameter represents the row offset. The Low() value represents the column offset.

Get Label_Offset of oForm to iOffset
Move (Hi(iOffset))  to iRowOffset
Move (Low(iOffset)) to iColumnOffset

Label_offset is set as a single property passing the row offset and the column offset as two separate parameters.

Set Label_Offset of oForm to iRowOffset iColumnOffset

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

Last Edited: June 22, 2005


ComboForm [Property Label_Row_Offset]

Label_Row_Offset - ComboForm

The vertical distance from the top edge of the object and its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Row_Offset is the vertical distance from the top edge of the object and its label. If the label's justification-mode is jmode_top it represents the vertical distance from the top edge of this object to the bottom edge of its label and larger numbers moves the label up (and away from the object). If the mode is not top it represents the distance from the top edge of the object and the top edge of the label and larger numbers moves the label down. By default, this is zero which is suitable for both form and side labels.

Default is 0.

Last Edited: August 18, 2003


ComboForm [Property ListRowCount]

ListRowCount - ComboForm

Determines the number of rows in a combo form

Type: Property

Access: Read/Write

Data Type: Integer

Description

ListRowCount determines the maximum number of rows that should be visible in a combo-list. When the the items in a combo list exceed this maximum, the list scrolls.

The default value is 10.

Set ListRowCount to 4 // never allow more than four rows to be visible

Note:Prior to release 9.1, the default value of ListRowCount was 0. When set to 0, the combo-list sets the value to around 10 rows. Setting the value to 0, is supported only for legacy purposes and should be avoided.

See Also

ListWidth

Last Edited: November 13, 2003


ComboForm [Property ListWidth]

ListWidth - ComboForm

Detrmines the width of a combo's drop down list

Type: Property

Access: Read/Write

Data Type: Integer

Description

ListWidth determines the width of a combo's drop down list in pixels. When set to 0 (the default) the width will be the same as form combo's form width.

Set ListWidth to 100

See Also

ListRowCount

Last Edited: October 23, 2003


ComboForm [Property Object_Shadow_State]

Object_Shadow_State - ComboForm

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


ComboForm [Property psHtmlHelpTopic]

psHtmlHelpTopic - ComboForm

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


ComboForm [Property Status_Help]

Status_Help - ComboForm

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


ComboForm [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - ComboForm

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


Container3d [Event OnBeginningOfPanel]

OnBeginningOfPanel - Container3d

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


Container3d [Event OnKillFocus]

OnKillFocus - Container3d

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


Container3d [Event OnSetFocus]

OnSetFocus - Container3d

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


Container3d [Event Prompt_Callback]

Prompt_Callback - Container3d

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


Container3d [Event Shadow_Display]

Shadow_Display - Container3d

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for Container3d

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |


Container3d [Function Next_Object_Id]

Next_Object_Id - Container3d

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


Container3d [Function Prior_Object_Id]

Prior_Object_Id - Container3d

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for Container3d

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Container3d [Procedure Activate_Area]

Activate_Area - Container3d

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Container3d [Procedure Beginning_of_Panel]

Beginning_of_Panel - Container3d

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


Container3d [Procedure Bottom_of_Panel]

Bottom_of_Panel - Container3d

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


Container3d [Procedure DoHtmlHelp]

DoHtmlHelp - Container3d

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


Container3d [Procedure End_of_Panel]

End_of_Panel - Container3d

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


Container3d [Procedure Error_Help]

Error_Help - Container3d

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Container3d [Procedure Extended_Help]

Extended_Help - Container3d

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Container3d [Procedure File_Help]

File_Help - Container3d

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Container3d [Procedure Help]

Help - Container3d

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Container3d [Procedure Help_For_Help]

Help_For_Help - Container3d

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Container3d [Procedure Help_Index]

Help_Index - Container3d

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Container3d [Procedure Help_on_topic]

Help_on_topic - Container3d

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Container3d [Procedure Keys_Help]

Keys_Help - Container3d

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Container3d [Procedure Request_Status_Help]

Request_Status_Help - Container3d

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


Container3d [Procedure Top_of_Panel]

Top_of_Panel - Container3d

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for Container3d

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true |
Bitmap | Displays a bitmap in an object |
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program |
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  |
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows |
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Container3d [Property Auto_Locate_State]

Auto_Locate_State - Container3d

Locates itself relative to any item that invokes it with a popup message when set true

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_Locate_State property is true, this object will locate itself relative to any item that invokes it with a popup message (i.e., relative to the position of the cursor in another object when the prompt key was pressed). The position at which this object pops up depends on the values of its column_offset and row_offset properties.

This property exists primarily for backwards compatibility. You are encouraged to use the more powerful locate_mode property in its place.

Default is false.

Last Edited: January 12, 2006


Container3d [Property Bitmap]

Bitmap - Container3d

Displays a bitmap in an object

Type: Property

Access: Read/Write

Data Type: String

Description

The Bitmap message will display a bitmap in an object. In other words, the bitmap becomes the background of the object.
Bitmap_Style determines how and where the bitmap will display in the object.

There are two potential drawbacks to using bitmaps: the amount of storage (on disk) , and the constant memory consumption.

Sample

This sample sets the bitmap to "MyBitmap.bmp".

set Bitmap to "MyBitmap.bmp"

Note:
In order to make a cohesive application, Visual DataFlex must find the .EXE file and the .bmp (bitmap) file, by using DFPATH.

Last Edited: November 24, 2004


Container3d [Property Column_Offset]

Column_Offset - Container3d

Determines the offset to the invoking item by number of columns

Type: Property

Access: Read/Write

Data Type: Integer

Description

If this object is located using POPUP_LOCATE logic (or auto_locate_state is true), it will pop up to the right of the invoking item by the number of columns in the Column_Offset property and below it by the number of rows in row_offset. This property may have a negative, as well as positive, value. The offset is stated as a number of characters, these being of an averaged size for the font currently in effect.

Default is 2.

Last Edited: August 5, 2003


Container3d [Property Enabled_State]

Enabled_State - Container3d

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


Container3d [Property Explicit_Shadow_State]

Explicit_Shadow_State - Container3d

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


Container3d [Property Help_id]

Help_id - Container3d

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


Container3d [Property Help_Keyword]

Help_Keyword - Container3d

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


Container3d [Property Item_Shadow_State]

Item_Shadow_State - Container3d

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


Container3d [Property Label]

Label - Container3d

This is the text that appears within this control

Type: Property

Access: Read/Write

Data Type: String

Description

This is the text that appears within this control. It can be set and queried through this property.

When used with the Button class, this sets the text within the button.

When used with the CheckBox class, this sets the text that appears to the right of the checkbox.

When used with the TextBox class, this sets the text that appears inside of the textbox.

When used with containers (Panel, Group, dbGroup), this sets the text that appears in the container.

See Also

Button | CheckBox | TextBox | Panel | Group | dbGroup

Last Edited: August 18, 2003


Container3d [Property Locate_Mode]

Locate_Mode - Container3d

Provides several flexible methods for auto positioning container panels in your program

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Locate_Mode property provides several flexible methods for auto positioning container panels in your program. The following modes are supported:

Constant | Meaning
NO_LOCATE | No auto-location is performed. The object must be manually located by using the set location message.
POPUP_LOCATE | This causes the object to locate itself relative to the object (and item) that invoked it. It is ideal for locating popup modal objects (like selection-lists). The position at which this object pops up depends on the values of its column_offset and row_offset properties.
CENTER_ON_SCREEN | This causes the container to appear in the center of the screen.
CENTER_ON_PANEL | This causes the container to centered within the current main program panel.
CENTER_ON_PARENT | This causes the container to appear in the center of its parent container.
SMART_LOCATE | This mode "just does the right thing". This message will cause the object to apply the best locating strategy for current conditions. If the object is a modal popup (modal_state is true) and there is an invoking object it will locate relative to the invoking object (popup_locate), else, if the object already has been assigned a location it will use that location. else, if main-panel exists it will center within that panel (center_on_panel), else, it will center itself on the screen (center_on_screen). All panels default to this mode. This causes modal popup panels to locate relative to their parent and modeless panels to appeared centered unless explicitly located.

Default is SMART_LOCATE.

Last Edited: September 10, 2004


Container3d [Property Object_Shadow_State]

Object_Shadow_State - Container3d

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


Container3d [Property Offset_Location]

Offset_Location - Container3d

Type: Property

Access: Write-Only

Data Type: Integer

Parameters: integer Row# Integer Col#

Parameter | Description
Row# | [ToDo: In Progress]
Col# | [ToDo: In Progress]

Description

Last Edited: July 8, 2003


Container3d [Property psHtmlHelpTopic]

psHtmlHelpTopic - Container3d

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


Container3d [Property Row_Offset]

Row_Offset - Container3d

Determines the offset to the invoking item by number of rows

Type: Property

Access: Read/Write

Data Type: Integer

Description

If this object is located using POPUP_LOCATE logic (or auto_locate_state is true), it will pop up to the right of the invoking item by the number of columns in column_offset and below it by the number of rows in the Row_Offset property. This property may have a negative, as well as positive, value. This offset is stated as a number of rows, these being the row height for the font currently in effect.

Default is 1.

Last Edited: September 11, 2003


Container3d [Property Status_Help]

Status_Help - Container3d

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


Container3d [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - Container3d

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


Events for Container

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d


Methods for Container

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for Container

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Events for cProcessStatusPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


cProcessStatusPanel [Function Check_StatusPanel]

Check_StatusPanel - cProcessStatusPanel

Returns a status value from the status panel, usually used to determine whether the user wants to cancel (abort) a process.

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Normally, a non-zero return value means that the process has been canceled.

Description

Check_StatusPanel returns a status value from the status panel, usually used to determine whether the user wants to cancel (abort) a process.

This typically needs to be used in conjunction with allow_cancel_state set to True to allow the user to click on a Cancel button.

Last Edited: June 16, 2006


Methods for cProcessStatusPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure |  | cStatusPanel
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Check_StatusPanel | Function | Returns a status value from the status panel, usually used to determine whether the user wants to cancel (abort) a process. |
close_panel | Procedure |  |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure |  | cStatusPanel
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
EnableCancelButton | Procedure | Called when status panel is activated passing whether a Cancel button should appear |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Initialize_StatusPanel | Procedure | Sets the values of the popup-status-panel elements |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
ProcessEvents | Procedure |  | cStatusPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Start_StatusPanel | Procedure | Starts the status panel process |
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_StatusPanel | Procedure | Stops the status popup and restores the current program's normal modality |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Update_StatusPanel | Procedure | Places a value in the "action window" of an active status panel |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


cProcessStatusPanel [Procedure close_panel]

close_panel - cProcessStatusPanel

Type: Procedure

Parameters: No Parameters

Description

Last Edited: December 2, 2005


cProcessStatusPanel [Procedure EnableCancelButton]

EnableCancelButton - cProcessStatusPanel

Called when status panel is activated passing whether a Cancel button should appear

Type: Procedure

Parameters: Boolean bEnable

Parameter | Description
bEnable | [ToDo: In Progress]

Description

Last Edited: June 8, 2006


cProcessStatusPanel [Procedure Initialize_StatusPanel]

Initialize_StatusPanel - cProcessStatusPanel

Sets the values of the popup-status-panel elements

Type: Procedure

Parameters: String sCaption String sTitle String sMessage

Parameter | Description
sCaption | The content of the caption bar
sTitle | A centered title that appears in the dialog
sMessage | A longer message that can appear below the title

Description

Initialize_StatusPanel sets the values of the popup-status-panel elements sCaption, sTitle, sMessage, and sParams.

This should be done before the status panel is activated. This data should be considered static. Once the status panel has popped up, these characteristics will not change.

Note: If the strings are very long, they may not all fit within a single command line. You can also set these values individually by setting Caption_Text, Title_Text and Message_Text.

The image below shows where the text in each parameter will display.

Last Edited: June 19, 2006


cProcessStatusPanel [Procedure Start_StatusPanel]

Start_StatusPanel - cProcessStatusPanel

Starts the status panel process

Type: Procedure

Parameters: No Parameters

Description

Start_StatusPanel starts the status panel process.

Last Edited: June 2, 2006


cProcessStatusPanel [Procedure Stop_StatusPanel]

Stop_StatusPanel - cProcessStatusPanel

Stops the status popup and restores the current program's normal modality

Type: Procedure

Parameters: No Parameters

Description

Stop_StatusPanel stops the status popup and restores the current program's normal modality. This must be sent at the end of the process.

Last Edited: June 2, 2006


cProcessStatusPanel [Procedure Update_StatusPanel]

Update_StatusPanel - cProcessStatusPanel

Places a value in the "action window" of an active status panel

Type: Procedure

Parameters: String sAction

Parameter | Description
sAction | The text to display

Description

Update_StatusPanel places a value in the "action window" of an active status panel. This is where the progress information is added. Each sAction replaces the one that was sent before it.

Send Update_StatusPanel of ghoStatusPanel (string(iLoopCounter) + " records processed")

The image below shows where the text set by Update_StatusPanel (Action_Text) will display in the running status panel.

Last Edited: June 19, 2006


Properties for cProcessStatusPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Action_Text | Determines the action text - an area below that message that is used to display progress |
Active_State | Indicates whether or not the object is activated | cUIObject
allow_cancel_state | Specifies whether the status panel will support a Cancel button |
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Button_Text | Determines the button text of a Cancel button that appears below the display |
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Caption_Text | Determines the caption text - the value in the caption bar |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Message_Text | Determines the message text - a longer message that appears below the title |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Title_Text | Determines the title text - a centered title that appears inside the dialog |
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cProcessStatusPanel [Property Action_Text]

Action_Text - cProcessStatusPanel

Determines the action text - an area below that message that is used to display progress

Type: Property

Access: Read/Write

Data Type: String

Description

This display value is normally changed, at regular intervals, via the Update_StatusPanel message.

The image below shows where the Action_Text will display in the running status panel.

Last Edited: June 19, 2006


cProcessStatusPanel [Property allow_cancel_state]

allow_cancel_state - cProcessStatusPanel

Specifies whether the status panel will support a Cancel button

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Allow_Cancel_State specifies whether the status panel will support a Cancel button. When false, the status panel is used only to show progress.

The image below shows where the Cancel button will display in the running status panel.

Last Edited: June 19, 2006


cProcessStatusPanel [Property Button_Text]

Button_Text - cProcessStatusPanel

Determines the button text of a Cancel button that appears below the display

Type: Property

Access: Read/Write

Data Type: String

Description

Determines the button text of a Cancel button that appears below the display. This display value is not normally changed after the object is initialized, but it can be.

Last Edited: June 2, 2006


cProcessStatusPanel [Property Caption_Text]

Caption_Text - cProcessStatusPanel

Determines the caption text - the value in the caption bar

Type: Property

Access: Read/Write

Data Type: String

Description

The Caption_Text property determines the caption text - the value on the caption bar.

This display value is normally set via Initialize_StatusPanel and not normally changed after the object is initialized, but it can be.

The image below shows where the Caption_Text will display in the running status panel.

Last Edited: June 19, 2006


cProcessStatusPanel [Property Message_Text]

Message_Text - cProcessStatusPanel

Determines the message text - a longer message that appears below the title

Type: Property

Access: Read/Write

Data Type: String

Description

This display value is normally set via Initialize_StatusPanel and not normally changed after the object is initialized, but it can be.

The image below shows where the Message_Text will display in the running status panel.

Last Edited: June 19, 2006


cProcessStatusPanel [Property Title_Text]

Title_Text - cProcessStatusPanel

Determines the title text - a centered title that appears inside the dialog

Type: Property

Access: Read/Write

Data Type: String

Description

This display value is normally set via Initialize_StatusPanel and not normally changed after the object is initialized, but it can be.

The image below shows where the Title_Text will display in the running status panel.

Last Edited: June 19, 2006


Events for cProgressBar

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnMouseDoubleClick | Received whenever a mouse button is double-clicked on the control | cWinControl
OnMouseDown | Received whenever a mouse button is pressed on the control | cWinControl
OnMouseMove | Received whenever the mouse cursor moves over a control | cWinControl
OnMouseUp | Received whenever a mouse button is released on the control | cWinControl
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for cProgressBar

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoAdvance | Procedure | Advances the progress bar by the amount stored in piAdvanceBy |
DoAdvanceBy | Procedure | Advances the progress bar by an explicit amount |
DoRecreateWindow | Procedure | Recreates a window | cWinControl
DoUpdateWindow | Procedure | Updates a window if it needs repainting | cWinControl
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


cProgressBar [Procedure DoAdvance]

DoAdvance - cProgressBar

Advances the progress bar by the amount stored in piAdvanceBy

Type: Procedure

Parameters: No Parameters

Description

Use the DoAdvance procedure to advance the progress bar. The piPosition property will be incremented by the value stored in the piAdvanceBy property and the bar will be redrawn to reflect the change to piPosition.

Compare to the DoAdvanceBy method that increments piPosition by an explicit amount.

See Also

piPosition | piAdvanceBy | DoAdvanceBy

Last Edited: July 31, 2003


cProgressBar [Procedure DoAdvanceBy]

DoAdvanceBy - cProgressBar

Advances the progress bar by an explicit amount

Type: Procedure

Parameters: Integer iAdvanceBy

Parameter | Description
iAdvanceBy | The amount to advance the progress bar (and thus piPosition) by.

Description

Use the DoAdvanceBy propcdure to advance the progress bar by an explicit amount. The piPosition property will be incremented by the iAdvanceBy parameter and the bar will be redrawn to reflect the change to piPosition.

Compare the DoAdvance method that increments piPosition by the amount stored in the piAdvanceBy property.

See Also

piPosition | piAdvanceBy | DoAdvance

Last Edited: July 31, 2003


Properties for cProgressBar

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbEnabled | Enables the control to take user input | cWinControl
pbSmooth | Determines whether the progress bar will be drawn as a smooth, contiguous bar or a segmented bar |
pbVertical | Determines whether to display the progress bar vertically or horizontally |
pbVisible | Makes a control visible or invisible | cWinControl
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piAdvanceBy | Stores the amount that the progress bar will increment by each time it is advanced |
piBackColor | The background color of the progress bar |
piBarColor | The color of the progress bar |
piMaximum | The value that represents 100 percent of the range the progress bar covers |
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinimum | Maintains the value that represents zero percent of the range the progress bar covers |
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piPosition | The current position of the progress within the progress bar |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cProgressBar [Property pbSmooth]

pbSmooth - cProgressBar

Determines whether the progress bar will be drawn as a smooth, contiguous bar or a segmented bar

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Progress within the progressbar can be displayed segmented or contiguous. Set pbSmooth to True to draw the progress as a smooth, contiguous bar. Set pbSmooth to False to draw the progress bar as a segmented bar.

Last Edited: September 10, 2003


cProgressBar [Property pbVertical]

pbVertical - cProgressBar

Determines whether to display the progress bar vertically or horizontally

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Progress bars can be displayed vertically or horizontally . Set pbVertical to True to display the progress bar vertically. Set pbVertical to False to display the progress bar horizontally.

Last Edited: September 10, 2003


cProgressBar [Property piAdvanceBy]

piAdvanceBy - cProgressBar

Stores the amount that the progress bar will increment by each time it is advanced

Type: Property

Access: Read/Write

Data Type: Integer

Description

The piAdvanceBy property stores the amount that piPosition will increment by when the DoAdvance method is sent.

See Also

DoAdvance

Last Edited: September 11, 2003


cProgressBar [Property piBackColor]

piBackColor - cProgressBar

The background color of the progress bar

Type: Property

Access: Read/Write

Data Type: Integer

Description

piBackColor is the background color behind the progress bar. You can set this property to any valid color. If you set it to clDefault, Windows will provide the color for you using the Windows system settings.

Last Edited: September 11, 2003


cProgressBar [Property piBarColor]

piBarColor - cProgressBar

The color of the progress bar

Type: Property

Access: Read/Write

Data Type: Integer

Description

piBarColor is the color of the progress bar. You can set this property to any valid color. If you set it to clDefault, Windows will provide the color for you using the Windows system settings.

Last Edited: September 11, 2003


cProgressBar [Property piMaximum]

piMaximum - cProgressBar

The value that represents 100 percent of the range the progress bar covers

Type: Property

Access: Read/Write

Data Type: Integer

Description

piMaximum is the value that represents 100 percent of the range the progress bar covers. Set to any valid integer, but more than piMinimum.

See Also

piMinimum | piPosition

Last Edited: September 11, 2003


cProgressBar [Property piMinimum]

piMinimum - cProgressBar

Maintains the value that represents zero percent of the range the progress bar covers

Type: Property

Access: Read/Write

Data Type: Integer

Description

piMinimum maintains the value that represents zero percent of the range the progress bar covers. Set to any valid integer, but less than piMaximum. Setting this property automatically sets the piPosition property to the same value.

See Also

piMaximum | piPosition

Last Edited: September 11, 2003


cProgressBar [Property piPosition]

piPosition - cProgressBar

The current position of the progress within the progress bar

Type: Property

Access: Read/Write

Data Type: Integer

Description

piPosition is the current position of the progress within the progress bar. When you set this value, the progress bar will redraw the bar to reflect the change.

See Also

piMinimum | piMaximum

Last Edited: September 11, 2003


Events for cRegistry

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cRegistry [Function CountOfSubkeys]

CountOfSubkeys - cRegistry

Returns the number of Subkeys for the Key that is currently open

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The number of SubKeys in the Key

Description

Use the CountOfSubkeys function to determine how many SubKeys a Key has. You must have opened a Key before invoking this method.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoShowCountOfSubkeys
        Boolean bOpened

        // Open the Key...
        Get OpenKey "Software\Data Access Worldwide" To bOpened
        If bOpened Begin
            Showln 'Count=' (CountOfSubkeys(self))
            Send CloseKey // must close all open Keys
        End
    End_Procedure

End_Object

Send DoShowCountOfSubkeys of oRegistry

See Also

CountOfValues

Last Edited: July 31, 2003


cRegistry [Function CountOfValues]

CountOfValues - cRegistry

Returns the number of Values that exist for the Key that is currently open

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The number of Values in the Key

Description

Use the CountOfValues function to determine how many Values exist within the Key that you have open.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoShowCountOfValues
        Boolean bOpened

        // Open the Key...
        Get OpenKey "Software\Microsoft\Notepad" To bOpened
        If bOpened Begin
            Showln 'Count=' (CountOfValues(self))
            Send CloseKey // must close all open Keys
        End
    End_Procedure

End_Object

Send DoShowCountOfValues of oRegistry

See Also

CountOfSubKeys

Last Edited: July 31, 2003


cRegistry [Function CreateKey]

CreateKey - cRegistry

Adds a new Key to the Registry

Type: Function

Return Data Type: Integer

Parameters: string sKeyName

Parameter | Description
sKeyName | The name of the Key to create.

Return Value

Returns a value of zero if the Key is created successfully. If the Key is not created, the return value will be the error code returned by Windows

Description

CreateKey adds a new Key to the Registry . Attempting to create a key that already exists has no effect and does not produce an error.

When CreateKey creates a Key, it uses the pfAccessRights property to specify its access.

A Key created by CreateKey has no Values. To set the Key's Values, use the WriteDword, WriteBinary and WriteString methods.

See Also

OpenKey | pfAccessRights

Last Edited: July 31, 2003


cRegistry [Function DeleteKey]

DeleteKey - cRegistry

Deletes a Key from the Registry

Type: Function

Return Data Type: Boolean

Parameters: String sKeyName

Parameter | Description
sKeyName | The name of the Key to delete

Return Value

If the Key was successfully deleted, then the function returns True, otherwise, it returns False.

Description

The DeleteKey function deletes a Key and all descendant Subkeys and Values.

See Also

DeleteValue

Last Edited: August 18, 2003


cRegistry [Function DeleteValue]

DeleteValue - cRegistry

Deletes a Value from a Key in the Registry

Type: Function

Return Data Type: Boolean

Parameters: String sValueName

Parameter | Description
sValueName | The name of the Value to delete

Return Value

If the Value is deleted, the function will return True, otherwise it will return False.

Description

You use DeleteValue to delete a Value from the Key that is already open. If you do not have the Key open, you must open it before deleting any Values within it.

See Also

DeleteKey | OpenKey

Last Edited: August 18, 2003


cRegistry [Function GetSubkeys]

GetSubkeys - cRegistry

Retrieves the names of all Subkeys belonging to the open Key

Type: Function

Return Data Type: Integer

Parameters: Handle hoArray

Parameter | Description
hoArray | An object-handle of an Array-based object to receive the names of the SubKeys

Return Value

The return value is the number of Subkeys that were added to the array

Description

The GetSubkeys function populates an array with the names of the the Subkeys of the Key that is presently open. You pass the handle of an array-based object that you want the names appended to. Upon returning from the method, each Subkey name is stored in individual items in the array. The array is not cleared before the names are appended.

Sample

In this sample, the names of all subkeys belonging to the "SOFTWARE\Data Access Worldwide" Key are displayed. First the Key is opened, and then an Array object is created to store the names. The object-handle of this array is passed to GetSubKeys, which returns the number of Subkeys that was added to the array. The contents of the array are then displayed, before finally deleting the array object that we created.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoShowSubkeys
        Boolean bOpened
        Handle hoArray
        Integer iSubkey iNumSubkeys

        // Open the Key...
        Get OpenKey "Software\Data Access Worldwide" To bOpened
        If bOpened Begin
            // create an array to store the names...
            Get Create U_Array To hoArray

            Get GetSubkeys hoArray To iNumSubkeys
            Showln 'Number of Subkeys =' iNumSubkeys

            For iSubkey from 0 To (iNumSubkeys -1)
                Showln iSubkey ' ' (Value(hoArray, iSubkey))
            Loop

            // destroy the array, as it is not needed anymore...
            Send Destroy of hoArray

            Send CloseKey // must close all open Keys
        End
    End_Procedure

End_Object

Send DoShowSubkeys of oRegistry

See Also

GetValues | OpenKey

Last Edited: August 18, 2003


cRegistry [Function GetValues]

GetValues - cRegistry

Retrieves the names of all Values belonging to the open Key

Type: Function

Return Data Type: Integer

Parameters: Handle hoArray

Parameter | Description
hoArray | An object-handle of an Array-based object to receive the names of the Values

Return Value

The return value is the number of Values that were added to the array

Description

The GetValues function populates an array with the names of the Values of the Key that is presently open. You pass the handle of an array-based object that you want the names appended to. Upon returning from the method, each Value name is stored in individual items in the array. The array is not cleared before the names are appended.

Sample

In this sample, the names of all Values belonging to the "Software\Microsoft\Internet Explorer" Key are displayed. First the Key is opened, and then an Array object is created to store the names. The object-handle of this array is passed to GetValues, which returns the number of Values that was added to the array. The contents of the array are then displayed, before finally deleting the array object that we created.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoShowValues
        Boolean bOpened
        Handle hoArray
        Integer iValue iNumValues

        // Open the Key...
        Get OpenKey "Software\Microsoft\Internet Explorer" To bOpened
        If bOpened Begin
            // create an array to store the names...
            Get Create U_Array To hoArray

            Get GetValues hoArray To iNumValues
            Showln 'Number of Values =' iNumValues

            For iValue from 0 To (iNumValues -1)
                Showln iValue ' ' (Value(hoArray, iValue))
            Loop

            // destroy the array, as it is not needed anymore...
            Send Destroy of hoArray

            Send CloseKey // must close all open Keys
        End

    End_Procedure

End_Object

Send DoShowValues of oRegistry

See Also

GetSubkeys

Last Edited: August 18, 2003


cRegistry [Function KeyExists]

KeyExists - cRegistry

Determines whether a Key exists

Type: Function

Return Data Type: Boolean

Parameters: String sKeyName

Parameter | Description
sKeyName | The name of the Key to check the existence of.

Return Value

Returns true if the Key exists, returns false if the key does not exist.

Description

Use the KeyExists function to determine whether a Key exists before attempting to access it.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoShowIfDacKeyExists
        Boolean bExists

        // We need to change the default of phRootKey...
        Set phRootKey To HKEY_LOCAL_MACHINE

        Get KeyExists "SOFTWARE\Data Access Corporation" To bExists
        If bExists Showln "The Key exists (in HKEY_LOCAL_MACHINE)"
        Else Showln "No, sorry, that Key does not exist"

    End_Procedure

End_Object

Send DoShowIfDacKeyExists of oRegistry

Last Edited: August 18, 2003


cRegistry [Function LongestDataLength]

LongestDataLength - cRegistry

Returns the length of the longest data in all Values for the currently open Key

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the number of bytes in the longest Data item in the Key

Description

The LongestDataLength function returns the length of the longest data in all Values for the currently open Key. Use LongestDataLength when you need to know the maximum size of all of the Key's Values. This is typically only used when you need to make low-level Windows API calls.

See Also

LongestValueLength | LongestSubkeyLength

Last Edited: August 18, 2003


cRegistry [Function LongestSubkeyLength]

LongestSubkeyLength - cRegistry

Returns the length of the longest Subkey name for the currently open Key

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the number of bytes in the longest name of the Subkeys for the Key.

Description

The LongestSubkeyLength function returns the length of the longest Subkey name for the currently open Key. Use LongestSubkeyLength when you need to know the maximum length of all of the Subkey names. This is typically only used when you need to make low-level Windows API calls.

See Also

LongestDataLength | LongestValueLength

Last Edited: August 18, 2003


cRegistry [Function LongestValueLength]

LongestValueLength - cRegistry

Returns the length of the longest Value name for the currently open Key

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Rerursn the number of bytes in the longest name of all the Values in the open Key

Description

The LongestValueLength function returns the length of the longest Value name for the currently open Key. Use LongestValueLength when you need to know how many characters the longest Value name has. This is typically only used when you need to make low-level Windows API calls.

See Also

LongestDataLength | LongestSubkeyLength

Last Edited: August 18, 2003


cRegistry [Function OpenKey]

OpenKey - cRegistry

Opens a Registry Key for access

Type: Function

Return Data Type: Boolean

Parameters: string sKeyName

Parameter | Description
sKeyName | The name of the Key to open.

Return Value

OpenKey returns True if the key is successfully opened. OpenKey returns False if the Key could not be opened.

Description

The Key is opened with the security access specified by the pfAccessRights property. The phRootKey property determines the root branch of the Registry that will be used.

The Key needs to exist before it can be opened. You can check to see if the Key exists by using the KeyExists function.

Note:If the Key is successfully opened, the phCurrentKey property is set to the handle provided by Windows. You can use this property if you need to make low-level calls to the Windows API.

Sample

This sample opens a Key to learn how many Subkeys it has.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoShowCountOfSubkeys
        Boolean bOpened

        // Open the Key...
        Get OpenKey "Software\Data Access Worldwide" To bOpened
        If bOpened Begin
            Showln 'Count=' (CountOfSubkeys(self))
            Send CloseKey // must close all open Keys
        End
    End_Procedure

End_Object

Send DoShowCountOfSubkeys of oRegistry

See Also

CreateKey | CloseKey

Last Edited: September 10, 2003


cRegistry [Function ReadBinary]

ReadBinary - cRegistry

Reads a binary Value from the currently open Key

Type: Function

Return Data Type: Boolean

Parameters: String sValueName Address aValueData Integer iDataLength

Parameter | Description
sValueName | The name of the Value to read data from
aValueData | Address of the variable to receive the data into
iDataLength | The number of bytes to read

Return Value

If the data is successfully read, then the function returns True, otherwise it returns False.

Description

Use ReadBinary to read binary data from a Value.

Note:The reading and writing of binary data is a fairly advanced feature that will not be used very often. Usually, it is for storing the contents of structures, so that they can be written and read in single steps.

Sample

This samplee uses the Windows API function, SetWindowPlacement, to simultaneously set the size and location of a Window that was previously returned by a call to GetWindowPlacement. Both of these functions require a structure of type tWindowPlacement. By using WriteBinary and ReadBinary, we are able to store, and then retrieve, the whole structure very easily in a single step. Note that it would have also been possible to write the individual fields as Dword Values, but this would have required many more writes and reads, in addition to detailed knowledge of the structure.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoReadBinary
        Boolean bSuccess
        String sWindowPlacement
        String sKey
        Address aWindowPlacement
        Handle hWnd

        // Assume that oPanel is the name of the program's Panel object...
        Get Window_Handle of oPanel To hWnd

        // Assume this to be the Key to open to reetrieve the window Placement...
        Move "Software\Data Access Worldwide\Examples\Contact\8.0;
                    \Contact\Windows\Contacts" To sKey

        Get OpenKey  sKey To bSuccess
        If bSuccess Begin
            // Prepare a structure of type tWindowPlacement...
            ZeroType tWindowPlacement To sWindowPlacement

            // and get its memory address...
            Move (AddressOf(sWindowPlacement)) To aWindowPlacement

            // read the binary data and store it at the address of the structure...
            Get ReadBinary "Placement" ;
                aWindowPlacement tWindowPlacement_size To bSuccess

            // if the data was read successfully, then we can use it...
            If bSuccess Move (SetWindowPlacement(hWnd, aWindowPlacement)) To bSuccess

            // must close Keys that we open...
            Send CloseKey
        End
    End_Procedure

End_Object

Send DoReadBinary of oRegistry

See Also

WriteBinary | ReadDword | ReadString

Last Edited: September 11, 2003


cRegistry [Function ReadDword]

ReadDword - cRegistry

Use ReadDword to read a Dword Value from the currently open Key

Type: Function

Return Data Type: DWord

Parameters: String sValueName

Parameter | Description
sValueName | The name of the Value to read data from

Return Value

The DWord data from the named Value. A Dword is an unsigned 32-bit integer.

Description

Use the ReadDword method to read Dword data from a Value in the open Key. The Value must already exist, and you can use the ValueExists method to verify this.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoReadDword
        Boolean bOpened
        Integer iShowTips
        String sKey sValue

        Move "SOFTWARE\Microsoft\IISPersonal" To sKey
        Move "ShowTips" To sValue

        Get OpenKey sKey To bOpened
        If bOpened Begin
            If (ValueExists(self, sValue)) Begin
                Get ReadDword sValue To iShowTips
                Showln sValue '=' iShowTips
            End

            // must close Keys that we open...
            Send CloseKey
        End
        Else ShowLn 'Could not open Key'
    End_Procedure

End_Object

Send DoReadDword of oRegistry

See Also

WriteDword | ReadBinary | ReadString

Last Edited: September 11, 2003


cRegistry [Function ReadString]

ReadString - cRegistry

Read a string from a Key in the Registry

Type: Function

Return Data Type: String

Parameters: String sValueName

Parameter | Description
sValueName | The name of the Value to read data from

Return Value

A string repersenting the data held in the queried Value.

Description

Use ReadString to read a String Value from the currently open Key. The Value must already exist, and you can use the ValueExists function to verify this.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoReadString
        Boolean bOpened
        String sKey sValue sDirectory

        Move "SOFTWARE\Microsoft\MediaPlayer" To sKey
        Move "Installation Directory" To sValue

        // Set the root key to LOCAL_MACHINE...
        Set phRootKey To HKEY_LOCAL_MACHINE

        Get OpenKey sKey To bOpened

        If bOpened Begin
            If (ValueExists(self, sValue)) Begin
                Get ReadString sValue To sDirectory
                Showln sValue ' = ' sDirectory
            End
            Else Showln "Value does not exist"

            // must close Keys that we open...
            Send CloseKey
        End

        Else ShowLn 'Could not open Key'
    End_Procedure

End_Object

Send DoReadString of oRegistry

See Also

WriteString | ReadDword | ReadBinary

Last Edited: September 11, 2003


cRegistry [Function ValueExists]

ValueExists - cRegistry

Tests whether a named Value exists in the open Key

Type: Function

Return Data Type: Boolean

Parameters: String sValueName

Parameter | Description
sValueName | The name of the Value to read data from

Return Value

ValueExists returns True if the named Value exists. If the Value does not exist, then it returns False.

Description

Use the ValueExists function to verify that a Value of the currently open Key exists before trying to access it.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoShowIfValueExists
        Boolean bOpened
        String sKey sValue

        Move "SOFTWARE\Microsoft\MediaPlayer" To sKey
        Move "Installation Directory" To sValue

        // Set the root key to LOCAL_MACHINE...
        Set phRootKey To HKEY_LOCAL_MACHINE

        Get OpenKey sKey To bOpened
        If bOpened Begin
            If (ValueExists(self, sValue)) Begin
                Showln "Value exists"
            End
            Else Showln "Value does not exist"

            // must close Keys that we open...
            Send CloseKey
        End
    End_Procedure

End_Object

Send DoShowIfValueExists of oRegistry

See Also

ValueType | ValueLength

Last Edited: September 15, 2003


cRegistry [Function ValueLength]

ValueLength - cRegistry

Returns the length of the data for a named Value of the currently open Key

Type: Function

Return Data Type: Integer

Parameters: String sValueName

Parameter | Description
sValueName | The name of the Value to obtain the size of the data from

Return Value

The number of bytes of data held in the Value.

Description

Use ValueLength to determine the number of bytes stored for a specific Value.

A common reason to need to know the data length is when you need to dynamically allocate memory for loading binary data, as this example shows.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoShowValueDataLength
        Boolean bSuccess
        String sKey sWindowPlacement
        Integer iDataLength
        Address aWindowPlacement

        Move "Software\Data Access Worldwide\Examples\Contact\8.0;
            \Contact\Windows\Contacts" To sKey

        Get OpenKey sKey To bSuccess
        If bSuccess Begin
            Get ValueLength "Placement" To iDataLength
            Showln "Data length=" iDataLength

            // Prepare memory to read the binary data into...
            ZeroString iDataLength To sWindowPlacement

            // and get its memory address...
            Move (AddressOf(sWindowPlacement)) To aWindowPlacement

            // read the binary data and store it at the address of the string...
            Get ReadBinary "Placement" aWindowPlacement iDataLength To bSuccess

            // must close Keys that we open...
            Send CloseKey
        End
        Else Showln 'Cannot open Key'
    End_Procedure

End_Object

Send DoShowValueDataLength of oRegistry

See Also

ValueType | ValueExists

Last Edited: September 15, 2003


cRegistry [Function ValueType]

ValueType - cRegistry

Returns the data type for the named Value of the currently open Key

Type: Function

Return Data Type: Integer

Parameters: String sValueName

Parameter | Description
sValueName | The name of the Value to obtain the type of the data from

Return Value

Returns an integer (constant).

Description

Use the ValueType method to determine the data-type of an existing Value in the Key that you currently have open.

The return value can be one of the following constants:

Constant | Meaning
rdString | Indicates that the registry type is a string
rdDword | Indicates that the registry type is a 32-bit number
rdBinary | Indicates that the registry type is a binary value
rdUnknown | Indicates that the registry type is unknown

Sample

This sample enumerates all the Values of a Key and shows their data type.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoShowDataTypes
        Boolean bOpened
        Handle hoArray
        Integer iValue iNumValues
        String sValueName
        Integer eType

        // Open the Key...
        Get OpenKey "Software\MyCompany\MyProduct" To bOpened
        If bOpened Begin
            // create an array to store the names...
            Get Create U_Array To hoArray

            Get GetValues hoArray To iNumValues
            Showln 'Number of Values =' iNumValues

            For iValue from 1 To iNumValues
                Get Value of hoArray (iValue -1) To sValueName
                Show '(' iValue ') "' sValueName '" has a Data Type of: '

                Get ValueType sValueName To eType
                If (eType = rdString) Showln "String"
                Else If (eType = rdDword)   Showln "DWord"
                Else If (eType = rdBinary)  Showln "Binary"
                Else If (eType = rdUnknown) Showln "Unknown"
            Loop

            // destroy the array, as it is not needed anymore...
            Send Destroy of hoArray

            Send CloseKey // must close all open Keys
        End

    End_Procedure

End_Object

Send DoShowDataTypes of oRegistry

See Also

ValueLength | ValueExists | OpenKey

Last Edited: April 28, 2005


Methods for cRegistry

View method list in hierarchical order

Name | Type | Description | Defining Class
CloseKey | Procedure | Closes a Registry Key |
CountOfSubkeys | Function | Returns the number of Subkeys for the Key that is currently open |
CountOfValues | Function | Returns the number of Values that exist for the Key that is currently open |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateKey | Function | Adds a new Key to the Registry |
DeleteKey | Function | Deletes a Key from the Registry |
DeleteValue | Function | Deletes a Value from a Key in the Registry |
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
GetSubkeys | Function | Retrieves the names of all Subkeys belonging to the open Key |
GetValues | Function | Retrieves the names of all Values belonging to the open Key |
KeyExists | Function | Determines whether a Key exists |
LongestDataLength | Function | Returns the length of the longest data in all Values for the currently open Key |
LongestSubkeyLength | Function | Returns the length of the longest Subkey name for the currently open Key |
LongestValueLength | Function | Returns the length of the longest Value name for the currently open Key |
OpenKey | Function | Opens a Registry Key for access |
ReadBinary | Function | Reads a binary Value from the currently open Key |
ReadDword | Function | Use ReadDword to read a Dword Value from the currently open Key |
ReadString | Function | Read a string from a Key in the Registry |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
ValueExists | Function | Tests whether a named Value exists in the open Key |
ValueLength | Function | Returns the length of the data for a named Value of the currently open Key |
ValueType | Function | Returns the data type for the named Value of the currently open Key |
WriteBinary | Procedure | Writes a Binary Value into the currently open Key of the Registry |
WriteDword | Procedure | Writes Dword data to the Registry |
WriteString | Procedure | Writes a string into the Registry |


cRegistry [Procedure CloseKey]

CloseKey - cRegistry

Closes a Registry Key

Type: Procedure

Parameters: No Parameters

Description

The CloseKey procedure closes a Key that you have opened with either OpenKey or CreateKey.

Send the CloseKey method to commit all pending writes to the currently open Key and close it. You should not keep Keys open any longer than necessary; so close them at the earliest opportunity.

Note:Calling CloseKey when there is no Key open has no effect and does not produce an error.

See Also

pbLazyWrite | OpenKey | CreateKey

Last Edited: July 30, 2003


cRegistry [Procedure WriteBinary]

WriteBinary - cRegistry

Writes a Binary Value into the currently open Key of the Registry

Type: Procedure

Parameters: String sValueName Address aValueData Integer iDataLength

Parameter | Description
sValueName | The name of the Value to write data to
aValueData | Adddress of the variable to write
iDataLength | The number of bytes to write

Description

Use the WriteBinary procedure to write a Binary Value into the currently open Key. If the Value does not exist, then it will be created.

When writing binary data, you need to store the data initially into a variable and then pass its address along with its length to the WriteBinary function. To get the memory address of a variable, use the AddressOf global function.

Sample

In this example, a password is written in binary form to the Registry. The binary form merely consists of storing each character's ASCII code, which prevents its value from being human-readable.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoWriteBinary
        Integer iError
        String sPassword

        Move "LetMeIn" To sPassword

        // Open the Key...
        Get CreateKey "Software\MyCompany\MyProduct" To iError
        If (iError =0) Begin
            Send WriteBinary "Password" (AddressOf(sPassword)) (Length(sPassword))
            Send CloseKey // must close all open Keys
        End
    End_Procedure

End_Object

Send DoWriteDword of oRegistry

Note:This encryption algorithm is provided only to illustrate how to write a binary value - if you want to encrypt data, you should use a more robust system than this.

See Also

ReadBinary | WriteString | WriteDword

Last Edited: September 15, 2003


cRegistry [Procedure WriteDword]

WriteDword - cRegistry

Writes Dword data to the Registry

Type: Procedure

Parameters: String sValue DWord dwValueData

Parameter | Description
sValue | The name of the Value to read data from. If this parameter is an empty string, then the dwValueData will be written to the "default" Value.
dwValueData | The Dword (32-bit unsigned integer) data to write.

Description

Use WriteDword to store Dword data in a Value of the open Key. If the Value does not exist, then it will be created.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoWriteDword
        Integer iError

        // Open the Key...
        Get CreateKey "Software\MyCompany\MyProduct" To iError
        If (iError =0) Begin
            Send WriteDword "NumUsers" 8
            Send CloseKey // must close all open Keys
        End
    End_Procedure

End_Object

Send DoWriteDword of oRegistry

See Also

ReadDword | WriteBinary | WriteString

Last Edited: June 23, 2005


cRegistry [Procedure WriteString]

WriteString - cRegistry

Writes a string into the Registry

Type: Procedure

Parameters: String sValue String sValueData

Parameter | Description
sValue | The name of the Value to write to. If this parameter is an empty string, then the contents of sValueData will be written to the "default" Value
sValueData | The data to write

Description

Use WriteString to write a String Value into the currently open Key. If the Value does not exist, then it will be created.

Use cRegistry.pkg

Object oRegistry is a cRegistry

    Procedure DoWriteString
        Integer iError

        // Open the Key...
        Get CreateKey "Software\MyCompany\MyProduct" To iError
        If (iError =0) Begin
            Send WriteString "RegisteredTo" "A User"
            Send CloseKey // must close all open Keys
        End
    End_Procedure

End_Object

Send DoWriteString of oRegistry

See Also

ReadString | WriteBinary | WriteDword

Last Edited: June 23, 2005


Properties for cRegistry

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbLazyWrite | Determines when Windows flushes any writes to the Registry |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
pfAccessRights | Specifies the level of access when opening and creating Keys |
phCurrentKey | The Windows handle of the Key |
phRootKey | Specifies the root branch of the Registry to use |


cRegistry [Property pbLazyWrite]

pbLazyWrite - cRegistry

Determines when Windows flushes any writes to the Registry

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The pbLazyWrite property determines when Windows flushes any writes to the Registry. For performance reasons, Windows only commits any writes when you close the Key. Furthermore, it may even defer the writing until after that. If you really need the changes written out when the Key is closed, set this property to False

See Also

WriteDword | WriteString | WriteBinary | CloseKey

Last Edited: September 10, 2003


cRegistry [Property pfAccessRights]

pfAccessRights - cRegistry

Specifies the level of access when opening and creating Keys

Type: Property

Access: Read/Write

Data Type: UInteger

Description

Use pfAccessRights to specify the type of access to use when opening and creating Keys. As OpenKey and CreateKey use this property, it is important to set it before calling either of these functions.

The value of pfAccessRights is a set of flags that may be combined together. Each flag indicates a type of permission. Set a value that grants sufficient permission to allow the desired actions while not exceeding the anticipated access level of the system that will run the application. The following table lists the flags that can be included:

Constant | Meaning
KEY_ALL_ACCESS | A convenient combination of KEY_READ, KEY_WRITE, and KEY_CREATE_LINK
KEY_READ | A convenient combination of KEY_QUERY_VALUE, KEY_ENUMERATE_SUB_KEYS, and KEY_NOTIFY
KEY_WRITE | A convenient combination of KEY_SET_VALUE and KEY_CREATE_SUB_KEY
KEY_QUERY_VALUE | Permission to query Subkey data
KEY_ENUMERATE_SUB_KEYS | Permission to enumerate Subkeys
KEY_NOTIFY | Permission for change notification
KEY_SET_VALUE | Permission to set Subkey data
KEY_CREATE_SUB_KEY | Permission to create Subkeys
KEY_CREATE_LINK | Permission to create a symbolic link
KEY_EXECUTE | Permission for read access

The default, KEY_ALL_ACCESS, grants full permissions to the Key. However, for operations that are completely read-only, you may want to set the property to KEY_READ, for example. Remember, it is possible that the Key, if not created by you, for example, may not grant you permission to access it to write, which is why you would set it to KEY_READ.

See Also

OpenKey | CreateKey

Last Edited: September 11, 2003


cRegistry [Property phCurrentKey]

phCurrentKey - cRegistry

The Windows handle of the Key

Type: Property

Access: Read/Write

Data Type: Handle

Description

Whenever you open or create a Key, Windows assigns it a unique handle that is used for low-level access to the Windows API. You can use this handle if you wish to make any low-level calls yourself.

If phCurrentKey is zero, then you know that no Key is open; otherwise, a Key is open and this property contains its Windows-assigned handle.

Last Edited: September 11, 2003


cRegistry [Property phRootKey]

phRootKey - cRegistry

Specifies the root branch of the Registry to use

Type: Property

Access: Read/Write

Data Type: Handle

Description

The phRootKey property specifies which hierarchical branch of the Registry that all future OpenKey, CreateKey and KeyExists methods should refer to.

You can set this property to any of the following constants:

HKEY_CLASSES_ROOT
HKEY_CURRENT_USER
HKEY_LOCAL_MACHINE
HKEY_USERS
HKEY_PERFORMANCE_DATA
HKEY_CURRENT_CONFIG
HKEY_DYN_DATA

The default root Key is HKEY_CURRENT_USER, which is the branch of the Registry that is specific to the user currently logged in. When your application writes to the Registry, it typically writes to this branch.

Last Edited: September 11, 2003


cRemoteEntryProcess [Event OnReportClearStatus]

OnReportClearStatus - cRemoteEntryProcess

After a clear operation, augments point to handle whatever additional processing is required

Type: Event

Parameters: integer iClearStat integer hClearDD

Parameter | Description
iClearStat

Constant | Meaning
ps_ClearOk | A clear occurred
ps_ClearAllOk | A clear all occurred
ps_ClearNotConfirmed | Clear not approved from user confirmation (for future use)
ps_ClearError | Some kind of error occurred, errors are logged

hClearDD | hDD handle of DataDictionary object

Description

After a clear operation, this message is provided as an augmentation point to handle whatever additional processing is required. It passes the current clear status and the object ID of the DDO that performed the clear. By default, this messages checks if any errors occurred and if the ReportErrors_State is True. If both conditions are met, it sends the message ReportAllErrors causing all errors to be displayed in HTML format. You can augment this to perform other tasks.

The procedure is for augmentation, it should never be sent.

Last Edited: September 10, 2003


cRemoteEntryProcess [Event OnReportDeleteStatus]

OnReportDeleteStatus - cRemoteEntryProcess

After a delete operation, augmentats point to handle whatever additional processing is required

Type: Event

Parameters: integer iDeleteStat integer hDeleteDD

Parameter | Description
iDeleteStat

Constant | Meaning
ps_DeleteOk | Record successfully deleted
ps_DeleteNoRec | No record in DDO to delete
ps_DeleteNotConfirmed | Delete not approved from user confirmation (for future use)
ps_DeleteError | Some kind of error occurred, errors are logged

hDeleteDD | handle of DataDictionary object

Description

After a delete operation, this message is provided as an augmentation point to handle whatever additional processing is required. It passes the current delete status and the object Id of the DDO that performed the delete. By default, this messages checks if any errors occurred and if the ReportErrors_State is True. If both conditions are met, it sends the message ReportAllErrors causing all errors to be displayed in HTML format. You can augment this to perform other tasks.

The procedure is for augmentation, it should never be sent.

Last Edited: September 10, 2003


cRemoteEntryProcess [Event OnReportFindStatus]

OnReportFindStatus - cRemoteEntryProcess

After a find operation, augments point to handle whatever additional processing is required

Type: Event

Parameters: integer iFindStat integer hDD

Parameter | Description
iFindStat

Constant | Meaning
ps_FindOk | Find operation was successfully found
ps_FindError | Some kind of error occurred. errors are logged

hDD | handle of DataDictionary object

Description

After a find operation, this message is provided as an augmentation point to handle whatever additional processing is required. It passes the current find status and the object ID of the DDO that performed the find. By default, this messages checks if any errors occurred and if the ReportErrors_State is True. If both conditions are met, it sends the message ReportAllErrors causing all errors to be displayed in HTML format. You can augment this to perform other tasks.

The procedure is for augmentation, it should never be sent.

Last Edited: September 10, 2003


cRemoteEntryProcess [Event OnReportSaveStatus]

OnReportSaveStatus - cRemoteEntryProcess

After a save operation, augments point to handle whatever additional processing is required

Type: Event

Parameters: integer iSaveStat integer hSaveDD

Parameter | Description
iSaveStat

Constant | Meaning
ps_SaveNoChange | No errors, but nothing to do
ps_SaveNewRecord | A new record was saved
ps_SaveOldRecord | An old Record was altered
ps_SaveNotConfirmed | Save not approved from user confirmation (for future use)
ps_SaveError | Some kind of error occurred, errors are logged

hSaveDD | handle of DataDictionary object

Description

After a save operation, this message is provided as an augmentation point to handle whatever additional processing is required. It passes the current save status and the object ID of the DDO that performed the save. By default, this messages checks if any errors occurred and if the ReportErrors_State is True. If both conditions are met, it sends the message ReportAllErrors causing all errors to be displayed in HTML format. You can augment this to perform other tasks. For example, you may want to output additional HTML information after a successful save (such as the new record ID).

The procedure is for augmentation, it should never be sent.

Note: This procedure is called after the save but before the DDO is cleared (if pbClearAfterSave is set to true). This allows you to display information about the newly saved record before the record is cleared.

Example

Procedure OnReportSaveStatus integer iSaveStat integer hSaveDD
    string sMess sId
    // Forward, this will display any errors
    Forward Send OnReportSaveStatus iSaveStat hSaveDD
    // If no errors and a new record save, let's inform the user about it.
    // We are assuming that hSaveDD is customer_dd. If the same WBO
    // supports saves to multiple DDOs we would need to test that we are
    // saving to the proper DDO.
    If (iSaveStat=PS_SaveNewRecord) begin
        // get the current DDO customer id value
        Get Field_Current_Value of hSaveDD Field Customer.ID to sID
        Get HtmlEncode sId to sID
        Move ("A NEW Customer has been created. The new ID is:" * sID) to sMess
        Send WriteHtml sMess
    end
End_Procedure

Last Edited: August 6, 2004


cRemoteEntryProcess [Event OnReportValidateStatus]

OnReportValidateStatus - cRemoteEntryProcess

After an update operation, augments point to handle whatever additional processing is required

Type: Event

Parameters: integer iValStat integer hValDD

Parameter | Description
iValStat

Constant | Meaning
0 | No error
1 | Error occurred

hValDD | handle of DataDictionary object

Description

After an update operation (RequestDDUpdate), this message is provided as an augmentation point to handle whatever additional processing is required. It passes the current operation's error status - 0=no error, 1=errors occurred. By default, this messages checks if any errors occurred and if the ReportErrors_State is True. If both conditions are met, it sends the message ReportAllErrors causing all errors to be displayed in HTML format. You can augment this to perform other tasks.

The procedure is for augmentation, it should never be sent.

Last Edited: September 10, 2003


Events for cRemoteEntryProcess

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnAttachProcess | When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object | cDistributedBusinessProcess
OnDetachProcess | When process pooling is used, this event is sent first to the WebApp object and then to every WBO object | cDistributedBusinessProcess
OnReportClearStatus | After a clear operation, augments point to handle whatever additional processing is required |
OnReportDeleteStatus | After a delete operation, augmentats point to handle whatever additional processing is required |
OnReportFindStatus | After a find operation, augments point to handle whatever additional processing is required |
OnReportSaveStatus | After a save operation, augments point to handle whatever additional processing is required |
OnReportValidateStatus | After an update operation, augments point to handle whatever additional processing is required |


cRemoteEntryProcess [Function ClearConfirmation]

ClearConfirmation - cRemoteEntryProcess

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: July 2, 2003


cRemoteEntryProcess [Function DeleteConfirmation]

DeleteConfirmation - cRemoteEntryProcess

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: July 2, 2003


cRemoteEntryProcess [Function DoRequestClear]

DoRequestClear - cRemoteEntryProcess

Generates a remote clear process

Type: Function

Return Data Type: Integer

Parameters: String sFileName Integer bClearAll

Parameter | Description
sFileName | The table to perform clear on
bClearAll | Determines whether the clear should propagate to related (ancestor) tables

Return Value

If an error occurs, a non-zero value is returned.

Description

DoRequestClear generates a remote clear process. The save will be based on the DDO that has sFileName as its main-file. Note that a filename string and not a file number is passed. The second parameter bClearAll determines if a DD clear or Clear_All should be performed.

This function is initiated by the ASP file with the RequestClear function. This message will usually not be sent by the developer.

After the clear operation, the ASP file will usually build an HTML page using the newly cleared data in the DDOs. Note that this process is different from simply clearing the input forms in an HTML page. The DDOs are cleared obeying the DD rules (i.e., setting default values), and the HTML page is then built with the results of the DD operation.

Make sure you understand the difference between a clear and a clear-all operation. A clear-all clears all DDOs with a DDO structure. A clear only clears up the structure until a constraint is encountered.

See Public Event Interface for more information on ComWBO to WBO interface.

Last Edited: July 31, 2003


cRemoteEntryProcess [Function DoRequestDDUpdate]

DoRequestDDUpdate - cRemoteEntryProcess

Provides another way to build the WBO's data dictionary structure based on information passed from the browser

Type: Function

Return Data Type: Integer

Parameters: String sFileName integer bShowErrors integer iExtra

Parameter | Description
sFileName | table to request DD update for
bShowErrors | toggles whether error will be displayed or not
iExtra | Currently not used. Pass 0

Return Value

The ASP script performs a validation and returns the result

Description

The function DoRequestDDUpdate provides another way to build the WBO's data dictionary structure based on information passed from the browser. It refinds all records, updates all fields, and performs a field validation on all fields in the DDO structures. When complete, your DD structures are up to data and you know if your data is valid.

Remember that Internet applications should be stateless. When an asp page is "called" (its URL is selected via a post or get) the page's WBO objects do not contain any current DDO information. This information must provided by the browser and loaded into the WBO.

In a typical application this information is loaded when one of the request messages is executed (e.g. RequestSave, RequestDelete, RequestClear, RequestFind). One of these methods should be executed before you attempt to use any field-data in your ASP page. In other words, you should not use ddValue until the DDO structure has been properly rebuilt.

If bShowErrors is set to 0, validation errors will not be displayed back to the browser (this is how the method is normally used). If set to 1, all validation errors are reported back to your HTML page.

Within an ASP page, this function will be used by the Call method. It serves two purposes. It updates all of your DDOs so you can reliably use the ddValue function to obtain information about your DDOs within the ASP page, and it lets you know if your current DDO is valid.

The following ASP script performs a validation and returns the result. This assumes that there is a submit button named "validate".

if Request("validate")<>"" then
     err = SalesP_WBO.Call("get_DoRequestDDUpdate","SalesP",0)
    if Err = 0 then
       Response.Write("<center> <h4>Current data is Valid</h4> </center>")
    else
       Response.Write("<center> <h4>Current data is not valid</h4> </center>")
    end if
end if

If you have enabled your ASP page to show field validations along with other field data (see the DDFIELDERROR option for ddValue) the invalid fields would display the appropriate error messages.

This technique can also be used to partially validate a page. Let's assume that before moving to a second page, you first want to make sure that all of the fields in the first page are valid. Your submit code might look something like this:

if Request("next")<>"" then
    CurrentPage =2
    err = Customer_WBO.Call("get_DoRequestDDUpdate","Customer",0)
    if err then
      ' we know we have an error. Is the error one of the fields on this page. If so, we
      ' will stay on page 1, else go to page 2. DDFIELDERROR will return either a blank for
      ' each field (we must test them manually) or an error message.
      FErr = Customer_WBO.DDValue("Customer.Customer_Number",DDFIELDERROR)
      if FErr = "" then FErr = Customer_WBO.DDValue("Customer.Name",DDFIELDERROR)
      if FErr = "" then FErr = Customer_WBO.DDValue("Customer.Phone_Number",DDFIELDERROR)
      if FErr <>"" then
        CurrentPage=1
        Response.write("<strong>Errors exist on this page which must be corrected</strong>")
      end if
    end if
end if

You only need to use this function if your ASP page does not already contain script that executes one of the other Request messages (RequestSave, RequestDelete, RequestClear, or RequestFind). All of these methods properly build your DDO data. You would only need to use the DoRequestDDUpdate function if one of these other request messages has not already executed.

Last Edited: September 25, 2003


cRemoteEntryProcess [Function DoRequestDelete]

DoRequestDelete - cRemoteEntryProcess

Generates a remote delete process

Type: Function

Return Data Type: Integer

Parameters: String sFileName

Parameter | Description
sFileName | The table to perform delete on

Return Value

If an error occurs, a non-zero value is returned.

Description

DoRequestDelete generates a remote delete process. The delete will be based on the DDO that has sFileName as its main-file. Note that a filename string and not a file number is passed.

This function is initiated by the ASP file with the RequestDelete function. This message will usually not be sent by the developer.

All of the information required to perform the delete is obtained from the remote ASP file. The WBO will send messages to the ASP file retrieving all records and changed record data. This supports a full DDO based delete operation including the possible cascade deletion of child records (if enabled with the DD cascade_delete_state property).

Full structure, file, and field validation occurs before the delete. If any error occurs, the delete is canceled, the entire transaction is rolled back and all errors are reported back to the browser in HTML format. If the delete operation is successful, the DDO will be cleared. If the operation failed, the DDO buffers will remain unchanged.

After the delete operation, the ASP file will usually build an HTML page using the newly cleared data in the DDOs or if the delete failed, the current data in the DDO.

See Public Event Interface for more information on ComWBO to WBO interface.

Last Edited: August 13, 2003


cRemoteEntryProcess [Function DoRequestFind]

DoRequestFind - cRemoteEntryProcess

Performs a field find for the passed file name, field name and find mode

Type: Function

Return Data Type: Integer

Parameters: String sFileName String sFieldName Integer iFindMode

Parameter | Description
sFileName | The name of table to find in
sFieldName | The name of field to find in
iFindMode | The mode to use for find operation

Return Value

If an error occurs, a non-zero value is returned.

Description

DoRequestFind performs a field find for the passed file name, field name and find mode. File name and field names are passed as strings. Find mode will be one of the standard DataFlex find modes: LT (0), LE (1), EQ (2), GE (3), GT (4), FIRST_RECORD (6), and LAST_RECORD (7). The index for the find will be based on the fields main-index. If no main-index exists for the passed field, an error will be reported. This find operation is identical to a standard DataFlex DEO field find.

This function is initiated by the ASP file with the RequestFind function. This message will usually not be sent by the developer.

All of the information required to perform the save is obtained from the remote ASP file. Before the find occurs, the WBO will send messages to the ASP file retrieving all records and changed record data. If the find succeeds, the DDO file buffer will contain the newly found records. Normally the ASP file will build an HTML page using the newly found data in the DDOs.

See Public Event Interface for more information on ComWBO to WBO interface.

Last Edited: August 5, 2003


cRemoteEntryProcess [Function DoRequestSave]

DoRequestSave - cRemoteEntryProcess

Generates a remote save process

Type: Function

Return Data Type: Integer

Parameters: String sFileName

Parameter | Description
sFileName | name of table to save

Return Value

If an error occurs, a non-zero value is returned.

Description

This generates a remote save process. The save will be based on the DDO that has sFileName as its main file. Note that a filename string and not a file number is passed.

This function is initiated by the ASP file with the RequestSave function. This message will usually not be sent within VDF by the developer.

All of the information required to perform the save is obtained from the remote ASP file. The WBO will send messages to the ASP file, retrieving all records and changed record data. Full structure, file, and field validation occurs before the save. If any error occurs, the save is canceled, the save transaction is rolled back and all errors are reported back to the browser in HTML format.

The WBO property pbClearAfterSave determines if the DD should be cleared after a save. Since the ASP file normally builds the next HTML page with the data in the DDO that exists after the save, this property will determine if the next browser page will contain the newly saved record or a cleared record.

See Public Event Interface for more information on ComWBO to WBO interface.

Last Edited: August 5, 2003


cRemoteEntryProcess [Function SaveConfirmation]

SaveConfirmation - cRemoteEntryProcess

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: July 2, 2003


Methods for cRemoteEntryProcess

View method list in hierarchical order

Name | Type | Description | Defining Class
ClearConfirmation | Function |  |
ClearErrors | Procedure | Clears the error queue | cDistributedBusinessProcess
Create | Function | Creates an object based on the passed Class Id | cObject
DeleteConfirmation | Function |  |
Destroy | Procedure |  | cObject
DoRequestClear | Function | Generates a remote clear process |
DoRequestDDUpdate | Function | Provides another way to build the WBO's data dictionary structure based on information passed from the browser |
DoRequestDelete | Function | Generates a remote delete process |
DoRequestFind | Function | Performs a field find for the passed file name, field name and find mode |
DoRequestSave | Function | Generates a remote save process |
ErrorCount | Function | Returns the number of errors in the current error queue | cDistributedBusinessProcess
ErrorQueueEnd | Procedure | Ends an error queue process | cDistributedBusinessProcess
ErrorQueueStart | Procedure | Starts an error queue process | cDistributedBusinessProcess
Exit_Application | Procedure | Starts the process of closing an application | cObject
LogEvent | Procedure | Logs an event to the Web Application's event log | cDistributedBusinessProcess
MapFileNametoDD | Function |  | cDistributedBusinessProcess
MaptoFieldNumber | Function |  | cDistributedBusinessProcess
MaptoFileNumber | Function |  | cDistributedBusinessProcess
ReportAllErrors | Procedure | Generates a list of all errors that have occurred since this error queue was last cleared | cDistributedBusinessProcess
ReportErrorItem | Procedure | Displays the error for iItem in the error queue | cDistributedBusinessProcess
ReportLastError | Procedure | Displays the last error in the error queue | cDistributedBusinessProcess
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
RequestFileFieldValues | Procedure |  | cDistributedBusinessProcess
RequestFileRecords | Procedure |  | cDistributedBusinessProcess
SaveConfirmation | Function |  |
Search_Field_Name | Function |  | cDistributedBusinessProcess
Search_File_Name | Function |  | cDistributedBusinessProcess


Properties for cRemoteEntryProcess

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Main_dd | Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function | cDistributedBusinessProcess
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbAllowClear | Determines whether the WBO object will support the Clear operation |
pbAllowDDUpdate | Determines whether the WBO object will support update operations to the DataDictionary |
pbAllowDelete | Determines whether the WBO object will support the Delete operation |
pbAllowFind | Determines whether the WBO object will support the Find operation |
pbAllowSaveEdit | Determines whether the WBO object will support an edit Save operation |
pbAllowSaveNew | Determines whether the WBO object will support a new Save operation |
pbClearAfterSave | Determines what should happen after a successful save |
pbClearDDOsOnDetach |  | cDistributedBusinessProcess
pbReportErrors | Suppresses the automatic generation of errors when set false |
pbShowEntryError |  | cDistributedBusinessProcess
peFieldMultiUser | Determines if the data submitted by a web application browser should report changes at the field level |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phREO_MainDD |  |
piREO_OperationStatus |  |


cRemoteEntryProcess [Property pbAllowClear]

pbAllowClear - cRemoteEntryProcess

Determines whether the WBO object will support the Clear operation

Type: Property

Access: Read/Write

Data Type: Boolean

Description

This property determines whether the WBO object will support the Clear operation. It is called from an ASP script using the method RequestClear. In some applications this may represent a security threat. By setting this property to false you are, in essence, protecting your DataFlex WBO from your ASP page designer. When disabled, sending the message from ASP to the WBO will do nothing.

VDF Code

Set pbAllowClear to bState
Get pbAllowClear to bState

Last Edited: January 16, 2006


cRemoteEntryProcess [Property pbAllowDDUpdate]

pbAllowDDUpdate - cRemoteEntryProcess

Determines whether the WBO object will support update operations to the DataDictionary

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If this property is set to false it will disable DoRequestDDUpdate. It is used to increase security in WBOs.

This property determines whether the WBO object will support update operations to the DataDictionary. It is called from an ASP script using the method DoRequestDDUpdate. In some applications this may represent a security threat. By setting this property to false you are, in essence, protecting your DataFlex WBO from your ASP page designer. When disabled, sending the message from ASP to the WBO will do nothing. This only effects the main file of the WBO. Parent records change as needed.

VDF Code

Set pbAllowDDUpdate to false
Get pbAllowDDUpdate to bState

See Also

DoRequestDDUpdate

Last Edited: January 16, 2006


cRemoteEntryProcess [Property pbAllowDelete]

pbAllowDelete - cRemoteEntryProcess

Determines whether the WBO object will support the Delete operation

Type: Property

Access: Read/Write

Data Type: Boolean

Description

This property determines whether the WBO object will support the Delete operation. It is called from an ASP script using the method RequestDelete. In some applications this may represent a security threat. By setting this property to false you are, in essence, protecting your DataFlex WBO from your ASP page designer. When disabled, sending the message from ASP to the WBO will do nothing.

VDF Code

Set pbAllowDelete to bState
Get pbAllowDelete to bState

Last Edited: January 16, 2006


cRemoteEntryProcess [Property pbAllowFind]

pbAllowFind - cRemoteEntryProcess

Determines whether the WBO object will support the Find operation

Type: Property

Access: Read/Write

Data Type: Boolean

Description

This property determines whether the WBO object will support the Find operation. It is called from an ASP script using the method RequestFind. In some applications this may represent a security threat. By setting this property to false you are, in essence, protecting your DataFlex WBO from your ASP page designer. When disabled, sending the message from ASP to the WBO will do nothing.

VDF Code

Set pbAllowFind to bState
Get pbAllowFind to bState

Last Edited: January 16, 2006


cRemoteEntryProcess [Property pbAllowSaveEdit]

pbAllowSaveEdit - cRemoteEntryProcess

Determines whether the WBO object will support an edit Save operation

Type: Property

Access: Read/Write

Data Type: Boolean

Description

This property determines whether the WBO object will support an edit Save operation. It is called from an ASP script using the method RequestSave. In some applications this may represent a security threat. By setting this property to false you are, in essence, protecting your DataFlex WBO from your ASP page designer. When disabled, sending the message from ASP to the WBO will do nothing. This only effects the main file of the saves. Parent records change as needed.

VDF Code

Set pbAllowSaveEdit to bState
Get pbAllowSaveEdit to bState

See Also

pbAllowSaveNew

Last Edited: January 16, 2006


cRemoteEntryProcess [Property pbAllowSaveNew]

pbAllowSaveNew - cRemoteEntryProcess

Determines whether the WBO object will support a new Save operation

Type: Property

Access: Read/Write

Data Type: Boolean

Description

This property determines whether the WBO object will support a new Save operation. It is called from an ASP script using the method RequestSave. In some applications this may represent a security threat. By setting this property to false you are, in essence, protecting your DataFlex WBO from your ASP page designer. When disabled, sending the message from ASP to the WBO will do nothing. This only affects the main file for saving operations. Parent records change as needed.

VDF Code

Set pbAllowSaveNew to false
Get pbAllowSaveNew to bState

See Also

pbAllowSaveEdit

Last Edited: January 16, 2006


cRemoteEntryProcess [Property pbClearAfterSave]

pbClearAfterSave - cRemoteEntryProcess

Determines what should happen after a successful save

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The pbClearAfterSave property determines what should happen after a successful save (DoRequestSave). If true, the default DDOs will be cleared (after a save). If false, the DDO will contain the newly saved record data. This will determine how the HTML that is built (after the save) will be displayed. If a Clear is performed, the HTML page will appear empty, ready for you to add a record. If a clear is not performed, the HTML will contain the data from the newly saved record.

VDF Code

Set pbClearAfterSave to false
Get pbClearAfterSave to iState

Script Code

<% WBO.Call "get_pbClearAfterSave "%>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message or by sending the RegisterStandardInterface message.

To register pbClearAfterSave send one of the following:

Send RegisterInterface  set_pbClearAfterSave "set_pbClearAfterSave" ;
    "sFile iRecord"  "This will determine if a clear should happen after a save"

Send RegisterStandardInterface

Send RegisterInterface  get_pbClearAfterSave "get_pbClearAfterSave" ;
    "sFile iRecord"  "This will retrieve the setting that determines if a clear should happen after a save"

Last Edited: January 16, 2006


cRemoteEntryProcess [Property pbReportErrors]

pbReportErrors - cRemoteEntryProcess

Suppresses the automatic generation of errors when set false

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If errors occur during a Request_Save, Request_Delete, Clear or Request_Find, those errors will be automatically reported in your HTML file. Under special circumstances, you may want to suppress the automatic generation of these errors. You may accomplish this by setting the pbReportErrors property to false. In such a case, you will probably want to handle the errors using custom ASP script code. Within your ASP script, you would need to check the error return value of your request function and then retrieve and display your errors using the Call message. You would use Call to send various error retrieval messages to your VDF WBO (i.e., Get_ErrorCount, Get_ErrorMessage).

See Error Handling Messages for more on queued errors.

VDF Code

Set pbReportErrors to false
Get pbReportErrors to iMode

Script Code

<% WBO.Call "set_pbReportErrors", 0 %>
<% iMode=WBO.Call ("get_pbReportErrors") %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message or by sending the RegisterStandardInterface message.

To register the pbReportErrors send one of the following:

Send RegisterInterface  set_pbReportErrors "set_pbReportErrors " ;
    "sFile iRecord"  "This will determine if errors are reported"

Send RegisterStandardInterface

Send RegisterInterface  get_pbReportErrors "get_pbReportErrors " ;
    "sFile iRecord"  "This will retrieve the setting that determines if errors are reported"

See Also

ErrorCount | ErrorMessage

Last Edited: January 16, 2006


cRemoteEntryProcess [Property peFieldMultiUser]

peFieldMultiUser - cRemoteEntryProcess

Determines if the data submitted by a web application browser should report changes at the field level

Type: Property

Access: Read/Write

Data Type: Integer

Description

When data is submitted from the browser, no information is provided to indicate if a submitted value has been changed. So normally, the WBO assumes that all data submitted from the browser represents changed data. In very rare cases, this could result in data getting changed.

Consider the following situation; Two users are looking at the same record on their browser, one user makes a change in the field "Address 1' and presses save and the second user immediately makes a change in "Address 2" and presses save. In this case, the change the first user made in Address1 will appear to be lost. When user 2 processed his change in address2 he also processed a change for Address1. The WBO assumed that all of the changes that were submitted by user 2 represented changed data. So it changed Address1 back to its original value.

If you want, you can configure your program to support multi-user data changes down to the field level. The WBO provides an interface for recognizing changed data. This requires the addition of special client JavaScript and requires that the user'
s browser properly support this script code (most browsers do). If you wish to support this you can change the value of FieldMultiUserMode. Three mode value are supported.

IMode Constants

Constant | Meaning
C_fmuNone (0) | Don't use field level changed state checking (default). By default this mode is 0, which means that field level change is not detected. In this mode the WBO assumes that all data submitted from browser represents changed data. In most cases, this mode will provide all the protection required (see explanation below).
C_fmuRequired (1) | Field level change state checking is required.If you change this to 1, field level checking will be required. If your ASP code or your browser does not properly support this capability, you will not be allowed to save your data. When properly supported, the WBO will only update field that are actually changed.
C_fmuDesired (2) | If available, use field level change state checking.This instructs the WBO to use field level checking, if the ASP code and the browser has provided the information needed to support this feature. This property setting in no way affects multi-user integrity. Integrity is maintained in all modes. You will normally not need to change this setting for the following reasons: The multi-user integrity of relational balances (e.g., a customer's total activity balance) is always maintained. This never applies to new records (because two users can't work on the same new record at the same time).

Note: In VDF Code you may use the iMode or the Constants, but in the Script Code you should use the iMode.

The chance of two users ever editing the same record is usually quite small.
While there is a better chance that two users will be accessing the same parent record, these parent records rarely allow their values to be changed anyway. Normally, the DataDictionary provides protection against changing parent fields.

VDF Code

Set peFieldMultiUser to C_fmuRequired
Get peFieldMultiUser to iMode

Script Code

<% WBO.Call "set_peFieldMultiUser" "2" %>
<% iMode= WBO.Call ("get_peFieldMultiUser") %>

Note: In VDF Code the Constant "C_fmuRequired" was used, but in the Script Code the iMode 2 was used.

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message.

To register peFieldMultiUser send one of the following:

Send RegisterInterface  set_ peFieldMultiUser "set_ peFieldMultiUser" ;
    "sFile iRecord"  "This will determine how Multi-user operations will function"

Send RegisterStandardInterface

Send RegisterInterface  get_ peFieldMultiUser "get_ peFieldMultiUser" ;
    "sFile iRecord"  "This will retrieve the setting that determines how Multi-user operations will function"

Last Edited: September 25, 2003


cRemoteEntryProcess [Property phREO_MainDD]

phREO_MainDD - cRemoteEntryProcess

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: July 2, 2003


cRemoteEntryProcess [Property piREO_OperationStatus]

piREO_OperationStatus - cRemoteEntryProcess

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: July 2, 2003


cReport [Event Assign_Report_Channel]

Assign_Report_Channel - cReport

Makes the current output channel the channel number represented by the report_channel property

Type: Event

Parameters: No Parameters

Description

Assign_report_channel makes the current output channel the channel number represented by the report_channel property. If the property is -1, then no action is taken. This is called anytime a report is entered and ensures that the proper channel is active at output time. In addition, setting the report_channel sets the linecount integer to the current value for that channel.

Last Edited: August 10, 2004


cReport [Event Final_Formfeed]

Final_Formfeed - cReport

Type: Event

Parameters: No Parameters

Description

Last Edited: July 2, 2003


cReport [Event OnBody]

OnBody - cReport

Called every time a valid record has been found

Type: Event

Parameters: No Parameters

Description

The OnBody event is called every time a valid record has been found. It is expected that you will add the required code to display desired information about this record. Normally, you will output an Html row of information.

Procedure OnBody
     String sText
    Send WriteHtmlRowBegin
        Get AddRecordLink (FormatNumber(Customer.Customer_Number,0)) to sText
        Send WriteHtmlCell sText 'Class="Data" Align="right"'
        Send WriteHtmlCell (HtmlEncode(Customer.Name)) 'Class="Data" Align="left"'
        Send WriteHtmlCell (HtmlEncode(Customer.Address)) 'Class="Data" Align="left"'
        Send WriteHtmlCell (HtmlEncode(Customer.City)) 'Class="Data" Align="left"'
        Send WriteHtmlCell (HtmlEncode(Customer.State)) 'Class="Data" Align="left"'
        Send WriteHtmlCell (HtmlEncode(Customer.Zip)) 'Class="Data" Align="left"'
    Send WriteHtmlRowEnd
End_Procedure // OnBody

Last Edited: September 10, 2003


cReport [Event OnConstrain]

OnConstrain - cReport

Type: Event

Parameters: No Parameters

Description

Last Edited: July 2, 2003


cReport [Event OnEndingMainReport]

OnEndingMainReport - cReport

Sent by the report object only if the current report is the outer report (it has no parent-its pbChildReport is false)

Type: Event

Parameters: No Parameters

Description

OnEndingMainReport does nothing by default, and is intended for override. This message is sent by the report object only if the current report is the outer report (it has no parent-its pbChildReport is false). If you wish to know under what condition the report was ended, query to PbCanceled property in this event.

Last Edited: September 10, 2003


cReport [Event OnEndingReport]

OnEndingReport - cReport

Called at the end of all reports

Type: Event

Parameters: No Parameters

Description

OnEndingReport is called at the end of all reports. It does nothing and is designed for augmentation. If the report is nested this is called every time a nested report is ended. It is used to process any report closing tasks.

You will rarely use this event.

See Also

OnEndingMainReport

Last Edited: September 10, 2003


cReport [Event OnPageBottom]

OnPageBottom - cReport

Called at the end of your report and should be used to display any final totals and to end any tables

Type: Event

Parameters: No Parameters

Description

OnPageBottom is called at the end of your report and should be used to display any final totals and to end any tables. In an Html report, the end of the report is also the end of the page.

If you created an html table in OnPageTop you will probably need to end that table in OnPageBottom as follows:

Procedure OnPageBottom
    Send WriteHtmlTableEnd
End_Procedure

This event can also be used to print any final report totals.

Procedure OnPageBottom
    Number nTot
    Send WriteHtmlCell ""   'colspan="4" bgColor="Silver" '
    Get SubTotal 1 to nTot
    Send WriteHtmlCell (FormatCurrency(nTot,2)) 'bgColor="Silver" align="right" '
    Send WriteHtmlTableEnd
End_Procedure

OnPageTop thru OnPageBottom get used by the outermost report object only. All other objects delegate messages to this ultimate parent. Creating these procedures in child reports will have no effect.

Last Edited: September 10, 2003


cReport [Event OnPageFooter]

OnPageFooter - cReport

Printed after OnPageTotal on every page except the last page

Type: Event

Parameters: No Parameters

Description

OnPageFooter is printed after OnPageTotal on every page except the last page.

Last Edited: September 10, 2003


cReport [Event OnPageHeader]

OnPageHeader - cReport

Called after OnPageTop on every new page except the first

Type: Event

Parameters: No Parameters

Description

OnPageHeader is called after OnPageTop on every new page except the first.

Last Edited: September 10, 2003


cReport [Event OnPageTitle]

OnPageTitle - cReport

Called on every new page after OnReportHeader or OnPageHeader.

Type: Event

Parameters: No Parameters

Description

OnPageTitle is called on every new page after OnReportHeader or OnPageHeader.

Last Edited: September 10, 2003


cReport [Event OnPageTop]

OnPageTop - cReport

Called when printing the top of every report

Type: Event

Parameters: No Parameters

Description

OnPageTop is called when printing the top of every report. In an HTML report, the entire report is considered a page.

This event is often used to start an Html table, which will be used to define the report and to create a header row for that table. In such a case, the table will be ended in the event OnPageBottom.

Procedure OnPageTop
     Send WriteHtmlTableBegin 'border="0" width="99%" Class="ReportTable"'
    Send WriteHtmlRowBegin
        Send WriteHtmlCellHeader 'Number' 'Class="Header" Align="right"'
        Send WriteHtmlCellHeader 'Customer Name' 'Class="Header" Align="left"'
        Send WriteHtmlCellHeader 'Address' 'Class="Header" Align="left"'
        Send WriteHtmlCellHeader 'City' 'Class="Header" Align="left"'
        Send WriteHtmlCellHeader 'St.' 'Class="Header" Align="left"'
        Send WriteHtmlCellHeader 'Zip' 'Class="Header" Align="left"'
    Send WriteHtmlRowEnd
End_Procedure // OnPageTop

OnPageTop thru OnPageBottom get used by the outermost report object only. All other objects delegate messages to this ultimate parent. Creating these procedures in child reports will have no effect.

Last Edited: September 10, 2003


cReport [Event OnPageTotal]

OnPageTotal - cReport

Called on every new page and is printed as the first part of a page break at the bottom of each page

Type: Event

Parameters: No Parameters

Description

OnPageTotal is called on every new page and is printed as the first part of a page break at the bottom of each page.

Last Edited: September 10, 2003


cReport [Event OnReportFooter]

OnReportFooter - cReport

Printed after OnPageTotal on the last page of the report

Type: Event

Parameters: No Parameters

Description

OnReportFooter is printed after OnPageTotal on the last page of the report.

Last Edited: September 10, 2003


cReport [Event OnReportHeader]

OnReportHeader - cReport

Called only on the first page of the report, after OnPageTop

Type: Event

Parameters: No Parameters

Description

OnReportHeader is called only on the first page of the report, after OnPageTop.

Send Run_Report to (Vndr_Report(self))

Last Edited: September 10, 2003


cReport [Event OnSelection]

OnSelection - cReport

Validates a record

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns RPT_OK, RPT_END, RPT_NOT_SELECT or RPT_CANCEL

Description

The OnSelection function is used to validate a record. It is intended for override.

The function should return an integer rpt_status value where:

Constant | Meaning
RPT_OK (0) | The record is valid.
RPT_END (1) | The record represents the end of the file.
RPT_NOT_SELECT (2) | The record is not valid, but is not at the end of the file.
RPT_CANCEL (3) | Cancel a report. This would be an unusual return value.

If you are using constrained finding, you will usually not override the handler. Your selection will be within the OnConstrain procedure. If you are not using constrained finding, you must use this handler to handle your custom constraints.

There is an advantage in using the selection function in conjunction with constrained finds in that an invalid record that is processed through the selection handler is tested for a keypress interrupt and can therefore be interrupted. A constrained find will not return any control to the report object until a valid record or no record is found. Depending on your constraint, this could "tie up" your machine for a long time. The advantage of constraints is that the finding is much faster.

As an example, the following could take a long time to process in a very large database. In the first example, the processing would be faster but the machine would appear to be locked up until a record is found:

Procedure OnConstrain
    Constrain Vndr.Id GT 'J' // this is fast
    Constrain as (Mid(Vndr.Name, 2, 3) ="zz") // this is slow
End_Procedure  // OnConstrain

In the second example, the report would take longer, but it could be interrupted at any time with a keypress.

Procedure OnConstrain
    Constrain Vndr.Id GT 'J' // this is fast
End_Procedure  // OnConstrain
Function OnSelection returns Integer
    If (Mid(Vndr.Name, 2, 3) ="zz" Function_return RPT_OK
    Else Function_return RPT_NOT_SELECT
End_Function  // OnSelection

Last Edited: September 25, 2003


cReport [Event OnStartingMainReport]

OnStartingMainReport - cReport

Called when a report is started

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

If a non-zero value is returned the report will be cancelled.

Description

OnStartingMainReport is called when a report is started. This is the same as OnStartingReport except this message is only sent to the main (parent) outer report.

This message is intended for augmentation. If you do augment this event, make sure you forward the message. Reports will not run properly if the event is cancelled.

You should rarely need to augment this event.

Last Edited: September 10, 2003


cReport [Event OnStartingReport]

OnStartingReport - cReport

Called when a report is started

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

If a non-zero value is returned the report will be cancelled

Description

OnStartingReport is called when a report is started. This is the same as OnStartingMainReport except this message is sent to all reported (outer and inner reports).

This message is intended for augmentation.

You should rarely need to augment this event.

Last Edited: September 10, 2003


cReport [Event OnSubHeader1..n]

OnSubHeader1..n - cReport

Called each time a subheader needs to be printed

Type: Event

Parameters: No Parameters

Description

OnSubHeader1..n is called each time a subheader needs to be printed. A sub-header is printed when a break occurs. The sub-header level (1 to 9) is determined by the message name (e.g. OnSubHeader1).

Procedure OnSubHeader1
    String sHtml
    Send WriteHtmlRowBegin
    Get HtmlBig ("Customer Directory:" * uppercase(Left(customer.name,1))) to sHtml
    Send WriteHtmlCell ("<br>"+sHtml+"<br>") 'COLSPAN=3 bgcolor="yellow"')
    Send WriteHtmlRowEnd
    Send WriteHtmlRowBegin
    Send WriteHtmlCellHeader "Number"            'bgcolor="Aqua"'
    Send WriteHtmlCellHeader "Customer Name"     'bgcolor="Aqua"'
    Send WriteHtmlCellHeader "Comments"          'bgcolor="Aqua"'
    Send WriteHtmlRowEnd
End_Procedure

Breakpoints are set using the OnInitBreakpoints and RegisterBreakpoint messages.

See Also

OnInitBreakpoints | RegisterBreakpoint | OnSubTotal1..n

Last Edited: September 10, 2003


cReport [Event OnSubHeaderInit1..n]

OnSubHeaderInit1..n - cReport

Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program

Type: Event

Parameters: No Parameters

Description

These procedures are called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program. It is not called during the repaging of a subheader. For this reason, it is the appropriate place only for one-time subheader initialization code.

Last Edited: September 10, 2003


cReport [Event OnSubTotal1..n]

OnSubTotal1..n - cReport

Called when a subtotal needs to be processed

Type: Event

Parameters: No Parameters

Description

OnSubTotal1..n is called when a subtotal needs to be processed. It is expected that you will create a method for each level of breakpoint you are supporting within a report. The sub-total level (1 to 9) is determined by the message name (e.g. OnSubTotal1).

Breakpoints are set using the OnInitBreakpoints and RegisterBreakpoint messages.

Example

Procedure OnSubTotal1
     Number nTotal
     Send WriteHtmlCell ""   'colspan="4" bgColor="Silver" align="right" '
     Get SubTotal 1 to nTotal
     Send WriteHtmlCell (FormatNumber(nTotal,2)) 'bgColor="Silver" align="right" '
     Send WriteHtmlTableEnd
End_Procedure  // OnSubTotal1

See Also

OnSubHeader1..n

Last Edited: September 10, 2003


cReport [Event OnTotal]

OnTotal - cReport

Called at the end of a report after all final sub-totals have been printed

Type: Event

Parameters: No Parameters

Description

OnTotal is called at the end of a report after all final sub-totals have been printed. It can be used to print any remaining totals.

Procedure OnTotal
End_Procedure

Normally, you will not need to augment this event. Totals can usually be more easily displayed in OnPageBottom (which is called right after OnTotal).

Last Edited: September 10, 2003


cReport [Event Relate_Main_File]

Relate_Main_File - cReport

Called during find_rec and read_by_recnum if a record has been found

Type: Event

Parameters: No Parameters

Description

Relate_main_file is called during find_rec and read_by_recnum if a record has been found. This does nothing by default, and is intended for override. It is called regardless of the value of no_relate_state.

Last Edited: September 11, 2003


Events for cReport

View event list in hierarchical order

Name | Description | Defining Class
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property |
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Final_Formfeed |  |
OnBody | Called every time a valid record has been found |
OnConstrain |  |
OnEndingMainReport | Sent by the report object only if the current report is the outer report (it has no parent-its pbChildReport is false) |
OnEndingReport | Called at the end of all reports |
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables |
OnPageFooter | Printed after OnPageTotal on every page except the last page |
OnPageHeader | Called after OnPageTop on every new page except the first |
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader. |
OnPageTop | Called when printing the top of every report |
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page |
OnReportFooter | Printed after OnPageTotal on the last page of the report |
OnReportHeader | Called only on the first page of the report, after OnPageTop |
OnSelection | Validates a record |
OnStartingMainReport | Called when a report is started |
OnStartingReport | Called when a report is started |
OnSubHeader1..n | Called each time a subheader needs to be printed |
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program |
OnSubTotal1..n | Called when a subtotal needs to be processed |
OnTotal | Called at the end of a report after all final sub-totals have been printed |
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found |


cReport [Function DoRunReport]

DoRunReport - cReport

The main entry point for reportsT

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns a report status value of RPT_END (1) if the report ended normally and RPT_CANCEL (3) if the report was canceled.

Description

The DoRunReport is the main entry point for reports. Calling this function runs the report.

Within any report object, you will usually create a custom method to start a report. This method will call DoRunReport.

Below is an example of a typical function, which will run a report.

Function RunCustomerReport integer iIndex integer iStart integer iMax Returns Integer
        Integer iEnd iStat
        Set piOrdering           to iIndex
        Set piMaxCount           to iMax
        Set piMaxCountBreakLevel to 0
        Set piStartRecord        to iStart
        Get DoRunReport          to iStat
        Get piLastRecord         to iEnd
        Function_Return iEnd
End_Function // RunCustomerReport

Last Edited: August 5, 2003


Methods for cReport

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoRunReport | Function | The main entry point for reportsT |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Formfeed | Procedure | Handles formfeeds |
Output_ImageNum | Procedure | Outputs the image represented by ImageNum |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
WriteLn | Procedure | Outputs the string message to the current output channel |
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data |


cReport [Procedure Formfeed]

Formfeed - cReport

Handles formfeeds

Type: Procedure

Parameters: No Parameters

Description

Formfeed handles formfeeds. It increments the page_count property, zeros the linecount integer, and executes a formfeed command based on the value of the page_feed property. This is a useful procedure to augment or override to handle UI-based formfeeds. If you do override this procedure, it is your responsibility to see that linecount is zeroed, that page_count is incremented, and that a formfeed occurs.

Do not get confused between the formfeed command and the procedure of the same name. The Report Package handles a formfeed by sending the formfeed message (this calls the formfeed procedure). The formfeed procedure executes the formfeed command and does other things.

Last Edited: August 18, 2003


cReport [Procedure Output_ImageNum]

Output_ImageNum - cReport

Outputs the image represented by ImageNum

Type: Procedure

Parameters: Integer ImageNum

Parameter | Description
ImageNum | the image number

Description

Output_imagenum outputs the image represented by ImageNum.

Last Edited: September 25, 2003


cReport [Procedure WriteLn]

WriteLn - cReport

Outputs the string message to the current output channel

Type: Procedure

Parameters: String WrStr

Parameter | Description
WrStr | the string

Description

Writeln outputs the string message to the current output channel.

Note: All output in a report object is eventually funnelled to three procedures: output_imagenum, writeln, and formfeed. By controlling these three procedures, you can exercise extensive control over the report's output.

Assume you actually wish a report to be sent to three output channels at the same time (Channels 1, 2, and 3). Assume that the report_channel property is set to 1:

Procedure FormFeed
    Forward Send FormFeed // ff to channel 1
    Direct_outPut Channel 2// ff to ch 2
    Formfeed
    Direct_output Channel 3// ff to ch 3
    Formfeed
    Direct_Output Channel 1// restore channel 1
End_Procedure

Procedure WriteLn String S
    Writeln S// to channel 1
    Direct_output Channel 2// to ch 2
    Writeln S
    Direct_output Channel 3// to ch 3
    Writeln S
    Direct_Output Channel 1// restore channel 1
End_Procedure

Procedure OutPut_ImageNum Integer i
    Output_imageNum i // to channel 1
    Direct_outPut Channel 2// to ch 2
    Output_ImageNum i
    Direct_output Channel 3// to ch 3
    Output_imageNum i
    Direct_Output Channel 1// restore channel 1
End_Procedure

Last Edited: September 15, 2003


cReport [Procedure Writeln_PageCheck]

Writeln_PageCheck - cReport

Allows you to output to your report with non-image data

Type: Procedure

Parameters: String WrStr Integer Lines

Parameter | Description
WrStr | the string
Lines | the lines

Description

Writeln_pageCheck allows you to output to your report with non-image data. First, this procedure checks to determine whether lines lines remain available for output on the current page, and a pagebreak is handled as needed. Then message is output.

Unlike the output_pagecheck and output_wrap_pagecheck procedures, there is no command for sending the writeln_pagecheck message.

This message is very potent. It frees you of the requirement of always needing an image for report output.

The following example would output a warning message each time a customer's balance due exceeds 1,000:

Procedure_Section Body as CustBody
    forward send body
    Print Customer.Id
    Print Customer.Name
    Print Customer.Due
    OutPut_PageCheck // regular image output
// check if due is too much
    if Customer.Due gt 1000 ;
    send WriteLn_PageCheck '*** Balance too high ***'
End_Procedure

Last Edited: August 6, 2003


Properties for cReport

View property list in hierarchical order

Name | Description | Defining Class
Assigned_Channel |  |
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Find_Mode | Maintains the current finding mode |
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image |
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function |
Last_Rec | (Obsolete) Contains the record number of the last selected record found |
Main_File | Contains the filenumber of the file which the report will use for finding records |
Name | Returns the full name of the object including parentage | cObject
New_Page_State | Set true when a new page is needed |
No_Constrained_Find_State | Determines if constrained record finding should be disabled |
No_Finding_State | Determines how the cReport object will find records |
No_PageCheck_State | Set true when the cReport object is processing a new page |
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found |
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Page_Count | Keeps track of the current page number |
Page_End | Determines how many lines on a page are allowed before a page break will occur |
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence |
Page_Feed | Used by the formfeed procedure |
Page_Footer_Lines | The number of lines in the page_footer image |
Parent | Returns the parent of an object | cObject
pbCanceled | Setting this true will cancel a report |
pbChildReport | Set true if the current cReport object is nested |
pbFindDown | Determines if the report should traverse up or down the index |
pbHasChildReports | Is set true if other reports are nested inside this report object |
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phMainReport | Contains the object ID of the outer report |
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found |
piNumberBreaks | Returns the number of breaks in a report |
piOrdering | Contains the index number which will be used for finding records |
piRecordCount | Contains the number of records found for the current report |
priCurrentRec | Contains the RowId of the current valid record found |
priFoundRec | Contains the RowId of the record found by the find_rec function |
priLastRec | Contains the RowId of the last selected record found |
Report_Channel | Determines which output channel will be used for your report output |
Report_Footer_Lines | The number of lines in the OnReportFooter image |
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing |
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals |


cReport [Property Assigned_Channel]

Assigned_Channel - cReport

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: July 2, 2003


cReport [Property Find_Mode]

Find_Mode - cReport

Maintains the current finding mode

Type: Property

Access: Read/Write

Data Type: Integer

Description

Find_mode maintains the current finding mode, where 0 = lt, 1 = le, 3 = ge, and 4 = gt. It is maintained by the find_init procedure and the find_rec function. It is only maintained if no_finding_state is false and no_constrained_find_state is true. When in constrained finding mode (the default), these properties do not need to be maintained.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: December 6, 2004


cReport [Property Footer_Lines]

Footer_Lines - cReport

Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image

Type: Property

Access: Read/Write

Data Type: Integer

Description

Footer_lines contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image. See the handle_footer procedure to see how the footer_lines, report_footer_lines, and page_footer_lines properties are used.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: December 6, 2004


cReport [Property Found_Rec]

Found_Rec - cReport

Contains the record number of the record found by the find_rec function

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Obsolete

This method is obsolete and has been replaced by priFoundRec.

Found_rec contains the record number of the record found by the find_rec function. If no_finding_state is true, this property is not maintained.

See Also

priFoundRec

Last Edited: February 2, 2005


cReport [Property Last_Rec]

Last_Rec - cReport

Contains the record number of the last selected record found

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Obsolete

This method is obsolete and has been replaced by priLastRec.

Last_rec contains the record number of the last selected record found. This is tracked so that a previous record can be retrieved for subtotal processing.

See Also

priLastRec

Last Edited: February 2, 2005


cReport [Property Main_File]

Main_File - cReport

Contains the filenumber of the file which the report will use for finding records

Type: Property

Access: Read/Write

Data Type: Integer

Description

Main_file contains the filenumber of the file which the report will use for finding records. This can be set with the report_main_file command or the main_file command-line option in the report-object definition.

Last Edited: August 18, 2003


cReport [Property New_Page_State]

New_Page_State - cReport

Set true when a new page is needed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

New_page_state is set true when a new page is needed. This property is automatically set true at the start of a report and after a page break.

Last Edited: January 12, 2006


cReport [Property No_Constrained_Find_State]

No_Constrained_Find_State - cReport

Determines if constrained record finding should be disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Normally a report uses constraints to handle all record initializing, finding, and selection. Occasionally, the automatic constraints can work against you. In such a case, you can set the no_constrained_find_state to true. When it is true, it is up to you to program the file-buffer initialization (use either Function OnStartingReport or Procedure find_init) and record selection (use Function selection). This property must be manually set.

Last Edited: January 12, 2006


cReport [Property No_Finding_State]

No_Finding_State - cReport

Determines how the cReport object will find records

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If set to true, then the cReport object will not find records internally. Instead, the report object will expect to be called each time a record (or item) needs to be output. Normally when this is needed, you will not define a main_file for the report (there is no need to). In fact, if after a report object is created the object's main_file property is zero, then the no_finding_state will automatically be set to true.

Last Edited: January 12, 2006


cReport [Property No_PageCheck_State]

No_PageCheck_State - cReport

Set true when the cReport object is processing a new page

Type: Property

Access: Read/Write

Data Type: Boolean

Description

No_page_check_state is set true when the cReport object is processing a new page (a new page or reprinting subheaders). When true, the output_pagecheck, output_wrap_pagecheck, and writeln_pagecheck procedures do not perform a page check.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: January 12, 2006


cReport [Property No_Relate_State]

No_Relate_State - cReport

Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found

Type: Property

Access: Read/Write

Data Type: Boolean

Description

No_relate_state is only used when no_constrained_find_state is true. When no_relate_state is true, relates are not automatically performed and it is up to you to make sure the records that you need related are found. The manual relates will be handled in the relate_main_file procedure.

This property has no effect on regular constrained finding. If you wish to control relates with constrained finds, you may wish to use the set_relate command.

Last Edited: January 12, 2006


cReport [Property Page_Count]

Page_Count - cReport

Keeps track of the current page number

Type: Property

Access: Read/Write

Data Type: Integer

Description

Page_count keeps track of the current page number. A report object automatically sets this to 1 when a report is started. In nested reports, only the page_count value of the outermost parent report is used.

Last Edited: September 10, 2003


cReport [Property Page_End]

Page_End - cReport

Determines how many lines on a page are allowed before a page break will occur

Type: Property

Access: Read/Write

Data Type: Integer

Description

Page_end determines how many lines on a page are allowed before a page break will occur. In nested reports, only the Page_End value of the outermost parent report is used.

Last Edited: September 10, 2003


cReport [Property Page_End_State]

Page_End_State - cReport

If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If Page_end_state is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check (normally executed as part of an output_pagecheck) will cause an end-of-page/new-page sequence. Although the report object never sets this property to true, it does reset it to false after a page break.

You can set page_end_state to true if you wish to force a page break. Often you will want a page break to be executed at the end of a subtotal section. Setting this property to true after the last image in a section has been output will inform the report to break a page before any images or lines are printed.

Last Edited: January 12, 2006


cReport [Property Page_Feed]

Page_Feed - cReport

Used by the formfeed procedure

Type: Property

Access: Read/Write

Data Type: Integer

Description

Page_feed is used by the formfeed procedure. The formfeed procedure looks at the page_feed property to determine how to handle a formfeed. Look at Procedure formfeed to understand how it uses the formfeed command. Set this property below the forward get statement in the OnStartingMainReport function.

If page_feed is: |  |
1 ~32767 | Linefeed Mode | Output linefeed characters until linecount equals page_feed
0 | Hardware Formfeed Mode | Output a formfeed character (ASCII 12)
1 | Full-screen Mode | Output the number of lines in Predefined Variable screenend, then display a message on the screen to press a key to continue and pause until the user does so.
2 | Custom Mode | Do nothing. This is what you would use if you are printing to the screen and you want to create your own UI end-of-screen handler inside the formfeed procedure.

In nested reports, only the page_feed value of the outermost parent report is used.

Last Edited: August 6, 2003


cReport [Property Page_Footer_Lines]

Page_Footer_Lines - cReport

The number of lines in the page_footer image

Type: Property

Access: Read/Write

Data Type: Integer

Description

Page_footer_lines is the number of lines in the OnPageFooter image.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: December 6, 2004


cReport [Property pbCanceled]

pbCanceled - cReport

Setting this true will cancel a report

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbCanceled is set to true when a report has been cancelled. Setting this true will cancel a report. You can query the property to find out if a report was ended normally or was cancelled. This is particularly useful in the OnEndingReport and OnEndingMainReport procedures.

Last Edited: January 16, 2006


cReport [Property pbChildReport]

pbChildReport - cReport

Set true if the current cReport object is nested

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbChildReport is set true if the current cReport object is nested (the current report has a parent report). If pbChildReport is false, then the report object is the main (or only) report.

Last Edited: January 16, 2006


cReport [Property pbFindDown]

pbFindDown - cReport

Determines if the report should traverse up or down the index

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The pbFindDown property determines if the report should traverse up or down the index. When set to false, the default, records are found in normal order (low to high). If set to true, records are found in the reverse order.

Set pbFindDown to true

Get pbfindDown to iMode

Default is false.

Last Edited: January 16, 2006


cReport [Property pbHasChildReports]

pbHasChildReports - cReport

Is set true if other reports are nested inside this report object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbHasChildReports is set true if other reports are nested inside this report object.

Last Edited: January 16, 2006


cReport [Property pbRefindForSubTotal]

pbRefindForSubTotal - cReport

Ensures that the subtotal is processed with the last valid record for that break level

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbRefindForSubTotal is for advanced use. Normally before a subtotal is printed, the report object refinds the previous record and its related records. This ensures that the subtotal is processed with the last valid record for that break level. When this process is completed, the new record is re-found. In reports having many subtotals, this process can slow down the reporting a small amount and where you have subtotals none of whose sections uses any data from the last record in the group. You may disable this re-finding process by setting this property to false.

Set pbRefindForSubTotal to false

Default is true.

Last Edited: January 16, 2006


cReport [Property phMainReport]

phMainReport - cReport

Contains the object ID of the outer report

Type: Property

Access: Read/Write

Data Type: Integer

Description

phMainReport contains the object ID of the outer report. This should never be set. All objects including the outer report object have this ID.

Upon occasion, you need to get at a property that was set only in the outer main report. If the property is unique to the outer object (meaning that you created a custom property for this one outer object), you will be able to access this property from all child objects through a simple get or set (delegation will find the property). If the property also exists in the child reports (which happens when all reports are based on the same subclass), this will not work. A get or set will find the current child object's property. By using the phMainReport property, you can directly get at the outer main report.

The following procedure finds the object ID of the main outer report and gets a property of this object and sends it a message.

Procedure Something Integer Val
    Integer Obj#
    Get Main_report_Id to Obj#
    Get Some_parent_property of Obj# to Val
    Send Some_Parent_Message to Obj#
End_Procedure

Last Edited: August 6, 2004


cReport [Property piCurrentRecord]

piCurrentRecord - cReport

Contains the record number of the current valid record found

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Obsolete

This method is obsolete and has been replaced by priCurrentRec.

piCurrentRecord contains the record number of the current valid record found. Normally found_rec and piCurrentRecord will be the same. In situations where you use the selection function to filter records, the piCurrentRecord will be the current valid record found and found_rec will be the current record found. If no_finding_state is true then this property is not maintained.

See Also

priCurrentRec

Last Edited: February 2, 2005


cReport [Property piNumberBreaks]

piNumberBreaks - cReport

Returns the number of breaks in a report

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 2, 2005


cReport [Property piOrdering]

piOrdering - cReport

Contains the index number which will be used for finding records

Type: Property

Access: Read/Write

Data Type: Integer

Description

The piOrdering property contains the index number which will be used for finding records. A value of -1 tells the runtime to choose the most-appropriate index based on current constraints. You are advised to always set an explicit ordering for your report.

If your report has a fixed order the piOrdering property can be set as part of the object's creation.

Object oMyreport is a cWebReport
    Set piOrdering to 4
    :

You may also dynamically assign a report's order. To do this you must set the piOrdering before you start running the report. For example a WebReport may contain the following custom function:

Function RunCustomerReport integer iIndex returns integer
    Integer iStat
    Set piOrdering to iIndex
    Get DoRunReport to iStat
    Function_return iStat
End_function

Default is -1.

Last Edited: September 11, 2003


cReport [Property piRecordCount]

piRecordCount - cReport

Contains the number of records found for the current report

Type: Property

Access: Read/Write

Data Type: Integer

Description

piRecordCount contains the number of records found for the current report.

Last Edited: September 11, 2003


cReport [Property priCurrentRec]

priCurrentRec - cReport

Contains the RowId of the current valid record found

Type: Property

Access: Read/Write

Data Type: RowId

Description

priCurrentRec contains the RowId of the current valid record found. Normally priFoundRec and priCurrentRec will be the same. In situations where you use the selection function to filter records, the priCurrentRec will be the current valid record found and priFoundRec will be the current record found. If no_finding_state is true then this property is not maintained.

See Also

priFoundRec

Last Edited: February 2, 2005


cReport [Property priFoundRec]

priFoundRec - cReport

Contains the RowId of the record found by the find_rec function

Type: Property

Access: Read/Write

Data Type: RowId

Description

priFoundRec contains the rRowId of the record found by the find_rec function. If no_finding_state is true, this property is not maintained.

See Also

priCurrentRec

Last Edited: February 2, 2005


cReport [Property priLastRec]

priLastRec - cReport

Contains the RowId of the last selected record found

Type: Property

Access: Read/Write

Data Type: RowId

Description

priLastRowId contains the RowId of the last selected record found. This is tracked so that a previous record can be retrieved for subtotal processing.

Last Edited: February 2, 2005


cReport [Property Report_Channel]

Report_Channel - cReport

Determines which output channel will be used for your report output

Type: Property

Access: Read/Write

Data Type: Integer

Description

Report_channel determines which output channel will be used for your report output. If the value is 1 (the default), then no channel reassignment occurs and whatever channel is current is used. In nested reports, only the report_channel value of the outermost parent report is used.

Default is 1.

Last Edited: August 6, 2003


cReport [Property Report_Footer_Lines]

Report_Footer_Lines - cReport

The number of lines in the OnReportFooter image

Type: Property

Access: Read/Write

Data Type: Integer

Description

Report_footer_lines is the number of lines in the OnReportFooter image.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: December 6, 2004


cReport [Property Rpt_Ttl_Level]

Rpt_Ttl_Level - cReport

Keeps track of the current sub-total level during subtotal processing

Type: Property

Access: Read/Write

Data Type: Integer

Description

Rpt_ttl_level keeps track of the current sub-total level during subtotal processing.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: December 6, 2004


cReport [Property Sub_Totaling_State]

Sub_Totaling_State - cReport

Set true when the cReport object is processing subtotals or totals

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Sub_totaling_state is set true when the cReport object is processing subtotals or totals.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid valueare unpredictable.

Last Edited: January 12, 2006


Events for cReportDS

View event list in hierarchical order

Name | Description | Defining Class
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property | cReport
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Final_Formfeed |  | cReport
OnBody | Called every time a valid record has been found | cReport
OnConstrain |  | cReport
OnEndingMainReport | Sent by the report object only if the current report is the outer report (it has no parent-its pbChildReport is false) | cReport
OnEndingReport | Called at the end of all reports | cReport
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables | cReport
OnPageFooter | Printed after OnPageTotal on every page except the last page | cReport
OnPageHeader | Called after OnPageTop on every new page except the first | cReport
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader. | cReport
OnPageTop | Called when printing the top of every report | cReport
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page | cReport
OnReportFooter | Printed after OnPageTotal on the last page of the report | cReport
OnReportHeader | Called only on the first page of the report, after OnPageTop | cReport
OnSelection | Validates a record | cReport
OnStartingMainReport | Called when a report is started | cReport
OnStartingReport | Called when a report is started | cReport
OnSubHeader1..n | Called each time a subheader needs to be printed | cReport
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program | cReport
OnSubTotal1..n | Called when a subtotal needs to be processed | cReport
OnTotal | Called at the end of a report after all final sub-totals have been printed | cReport
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found | cReport


Methods for cReportDS

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoRunReport | Function | The main entry point for reportsT | cReport
Exit_Application | Procedure | Starts the process of closing an application | cObject
Formfeed | Procedure | Handles formfeeds | cReport
Output_ImageNum | Procedure | Outputs the image represented by ImageNum | cReport
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Save | Procedure | If sent, this saves the current record |
WriteLn | Procedure | Outputs the string message to the current output channel | cReport
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data | cReport


cReportDS [Procedure Request_Delete]

Request_Delete - cReportDS

If sent (usually in the body) this will delete the current record through the DDO

Type: Procedure

Parameters: No Parameters

Description

If Request_delete is sent (usually in the body) this will delete the current record through the DDO. After the delete, the record remains unchanged in the buffer (including the recnum). All parent files are properly updated and all multi user requirements are met. If the DDO has a child DDO connected to it, all child records will also get automatically deleted.

Last Edited: September 11, 2003


cReportDS [Procedure Request_Save]

Request_Save - cReportDS

If sent, this saves the current record

Type: Procedure

Parameters: No Parameters

Description

If Request_save is sent, this saves the current record. This is usually sent in a body procedure section. Use the entry_update message to make the changes during the save process. All parent files are properly modified. Sends request_validate.

Last Edited: September 11, 2003


Properties for cReportDS

View property list in hierarchical order

Name | Description | Defining Class
Assigned_Channel |  | cReport
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Find_Mode | Maintains the current finding mode | cReport
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image | cReport
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function | cReport
Last_Rec | (Obsolete) Contains the record number of the last selected record found | cReport
Main_File | Contains the filenumber of the file which the report will use for finding records | cReport
Name | Returns the full name of the object including parentage | cObject
New_Page_State | Set true when a new page is needed | cReport
No_Constrained_Find_State | Determines if constrained record finding should be disabled | cReport
No_Finding_State | Determines how the cReport object will find records | cReport
No_PageCheck_State | Set true when the cReport object is processing a new page | cReport
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found | cReport
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Page_Count | Keeps track of the current page number | cReport
Page_End | Determines how many lines on a page are allowed before a page break will occur | cReport
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence | cReport
Page_Feed | Used by the formfeed procedure | cReport
Page_Footer_Lines | The number of lines in the page_footer image | cReport
Parent | Returns the parent of an object | cObject
pbCanceled | Setting this true will cancel a report | cReport
pbChildReport | Set true if the current cReport object is nested | cReport
pbFindDown | Determines if the report should traverse up or down the index | cReport
pbHasChildReports | Is set true if other reports are nested inside this report object | cReport
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level | cReport
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phMainReport | Contains the object ID of the outer report | cReport
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found | cReport
piNumberBreaks | Returns the number of breaks in a report | cReport
piOrdering | Contains the index number which will be used for finding records | cReport
piRecordCount | Contains the number of records found for the current report | cReport
priCurrentRec | Contains the RowId of the current valid record found | cReport
priFoundRec | Contains the RowId of the record found by the find_rec function | cReport
priLastRec | Contains the RowId of the last selected record found | cReport
Report_Channel | Determines which output channel will be used for your report output | cReport
Report_Footer_Lines | The number of lines in the OnReportFooter image | cReport
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing | cReport
Server | Identifies the object handle that is used as the report object's main data-dictionary object |
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals | cReport


cReportDS [Property Server]

Server - cReportDS

Identifies the object handle that is used as the report object's main data-dictionary object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object handle that is used as the report object's main data-dictionary object. If the value is zero, this object is not using a DDO - this is probably an error situation.

Normally this property will not be explicitly set. When not set the server is assigned to the main DDO (phMainDD) of its parent, the WBO. You will rarely need to change this. Although you will rarely set this property you will frequently get and use its value.

Procedure OnBody
    Handle hDD
    Get Server to hDD // the main DD for this report
    Get File_Field_Current_Value of hDD FILE_FIELD SalesP.Name to sVal
    :
End_Procedure

Last Edited: September 11, 2003


cRichEdit [Event OnBeginningOfPanel]

OnBeginningOfPanel - cRichEdit

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


cRichEdit [Event OnChange]

OnChange - cRichEdit

Fires whenever the value of the control is changed

Type: Event

Parameters: No Parameters

Description

Fires whenever the value of the control is changed, either by the user (a keypress or mouse event) or by a programmatic function that emulates user input.

OnChange is a good place to toggle things that are related to user input, such as toggling the state of toolbar buttons.

Note:
The OnChange event should not be used to change focus. If you want to respond to a change in a combo based on a user selection, it is suggested you augment other procedures such as OnLinkClicked.

Sample

This sample determines whether undo and redo operations can be performed during the current state of the control and set the pbEnabled property of toolbar buttons (class cToolbarButton) in response.

Procedure OnChange
    if (pbCanUndo(Self) = True) ;
        set pbEnabled of (oUndo(oToolbar(Self))) to True
    else ;
        set pbEnabled of (oUndo(oToolbar(Self))) to False

    if (pbCanRedo(Self) = True) ;
        set pbEnabled of (oRedo(oToolbar(Self))) to True
    else ;
        set pbEnabled of (oRedo(oToolbar(Self))) to False
End_Procedure  // OnChange

Last Edited: November 22, 2004


cRichEdit [Event OnKillFocus]

OnKillFocus - cRichEdit

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


cRichEdit [Event OnMaxText]

OnMaxText - cRichEdit

Fires when maximum text size is exceeded

Type: Event

Parameters: No Parameters

Description

Fires when the maximum text size the control can contain is exceeded.

The default maximum number of characters for the control is 64 KB (65536 bytes or characters).
piMaxChars sets or returns maximum number of characters.

Note:
piMaxChars determines the maximum number of visible characters the user can enter into the control. However, when getting the value or saving the value to a database field, the value will contain additional non-visible characters. Each time the user presses Enter or Shift+Enter to break the line, this will be counted as a single visible character, but the value will contain 2 characters, a linefeed character (ASCII 10) followed by a carriage return character (ASCII 13).

Sample

This sample displays a message box with a warning to the user when the maximum text size is exceeded.

Procedure OnMaxText
    send Stop_Box "You have exceeded that maximum text this control can hold." "Warning"
End_Procedure  // OnMaxText

Last Edited: December 16, 2004


cRichEdit [Event OnSetFocus]

OnSetFocus - cRichEdit

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


cRichEdit [Event Prompt_Callback]

Prompt_Callback - cRichEdit

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


cRichEdit [Event Shadow_Display]

Shadow_Display - cRichEdit

Fired whenever a change in enabled state occurs

Type: Event

Parameters: No Parameters

Description

The Shadow_display event is fired whenever a change in enabled_state occurs. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current enabled condition of the object by querying the Enabled_State property and in more-unusual conditions, the implicit_shadow_state and Explicit_Shadow_State properties.

Last Edited: November 22, 2004


Events for cRichEdit

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange | Fires whenever the value of the control is changed |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus |
OnLinkClicked | Fires when hyperlink in text is clicked | DFBaseRichEdit
OnMaxText | Fires when maximum text size is exceeded |
OnSelectionChanged | Fires when selection changes | DFBaseRichEdit
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Fired whenever a change in enabled state occurs |


cRichEdit [Function Next_Object_Id]

Next_Object_Id - cRichEdit

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


cRichEdit [Function Prior_Object_Id]

Prior_Object_Id - cRichEdit

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for cRichEdit

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
AppendText | Procedure | Appends text to end of text in control | DFBaseRichEdit
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed |
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control | DFBaseRichEdit
Beginning_of_Line | Procedure | Places the cursor at beginning of current line | DFBaseRichEdit
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
CharCount | Function | Returns length of RTF stream in the control | DFBaseRichEdit
ClearUndoBuffer | Procedure | Clears undo buffer | DFBaseRichEdit
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Deletes all data in control | DFBaseRichEdit
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
End_of_Data | Procedure | Places the cursor at end of the text in control | DFBaseRichEdit
End_of_Line | Procedure | Places the cursor at end of current line | DFBaseRichEdit
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
FindText | Function | Searches for specified text in control | DFBaseRichEdit
FirstCharInLinePos | Function | Returns position of first character in a line | DFBaseRichEdit
FirstVisibleLine | Function | Returns number of first visible line | DFBaseRichEdit
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
HideSelection | Procedure | Toggles selection highlighting on or off | DFBaseRichEdit
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
LastErrorCode | Function | Returns error code for last operation | DFBaseRichEdit
Line | Function | Returns specified line of text | DFBaseRichEdit
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
LineFromChar | Function | Returns number of line that contains specified character position or current line | DFBaseRichEdit
LineLength | Function | Returns number of characters in line | DFBaseRichEdit
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Read | Procedure | Reads RTF document and displays it in the control | DFBaseRichEdit
Redo | Procedure | Redoes the last operation | DFBaseRichEdit
RedoType | Function | Returns type of redo operation at top of redo queue | DFBaseRichEdit
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements | DFBaseRichEdit
ReplaceSel | Procedure | Replaces selected text with specified text | DFBaseRichEdit
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls up or down the control using specified scroll mode | DFBaseRichEdit
ScrollCaret | Procedure | Scrolls caret into view | DFBaseRichEdit
ScrollLines | Procedure | Scrolls control vertically for specified number of lines | DFBaseRichEdit
Select_All | Procedure | Selects entire contents of control | DFBaseRichEdit
SelEnd | Function | Returns end of selection | DFBaseRichEdit
SelStart | Function | Returns beginning of selection | DFBaseRichEdit
SelText | Function | Returns selected text | DFBaseRichEdit
SetSel | Procedure | Selects text in given position range | DFBaseRichEdit
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
TextRange | Function | Returns text in given position range | DFBaseRichEdit
ToggleBold | Procedure | Toggles selected text between bold and normal text |
ToggleItalics | Procedure | Toggles selected text between italicized and normal text |
ToggleUnderline | Procedure | Toggles selected text between underlined and normal text |
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Undo | Procedure | Undoes the last operation | DFBaseRichEdit
UndoType | Function | Returns type of undo operation at top of undo queue | DFBaseRichEdit
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes RTF stream content of control to file | DFBaseRichEdit


cRichEdit [Procedure Activate_Area]

Activate_Area - cRichEdit

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cRichEdit [Procedure AppendTextLn]

AppendTextLn - cRichEdit

Appends text to end of text in control, followed by a line feed

Type: Procedure

Parameters: string sText

Parameter | Description
sText | Text to append to control text

Description

This method is identical to AppendText, except that it adds a line feed character (ASCII 10) after appending the text in sText.

Last Edited: April 25, 2005


cRichEdit [Procedure Beginning_of_Panel]

Beginning_of_Panel - cRichEdit

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


cRichEdit [Procedure Bottom_of_Panel]

Bottom_of_Panel - cRichEdit

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


cRichEdit [Procedure DoHtmlHelp]

DoHtmlHelp - cRichEdit

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


cRichEdit [Procedure End_of_Panel]

End_of_Panel - cRichEdit

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


cRichEdit [Procedure Error_Help]

Error_Help - cRichEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cRichEdit [Procedure Extended_Help]

Extended_Help - cRichEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cRichEdit [Procedure File_Help]

File_Help - cRichEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cRichEdit [Procedure Help]

Help - cRichEdit

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


cRichEdit [Procedure Help_For_Help]

Help_For_Help - cRichEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cRichEdit [Procedure Help_Index]

Help_Index - cRichEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cRichEdit [Procedure Help_on_topic]

Help_on_topic - cRichEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cRichEdit [Procedure Keys_Help]

Keys_Help - cRichEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cRichEdit [Procedure Request_Status_Help]

Request_Status_Help - cRichEdit

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


cRichEdit [Procedure ToggleBold]

ToggleBold - cRichEdit

Toggles selected text between bold and normal text

Type: Procedure

Parameters: No Parameters

Description

Toggles selected text between bold and normal text.

This message is provided to allow toggling of selected text between bold and normal (non-bold) text. It toggles pbBold between True and False. It is fired via the predefined shortcut key Ctrl+B.

You can use the message to fire toggling of the selected text between bold and normal text, for example, by calling it from a toolbar button.

Sample

This sample toggles the selected text of control oRichEdit1 between bold and normal text.

send ToggleBold of oRichEdit1

Last Edited: December 2, 2004


cRichEdit [Procedure ToggleItalics]

ToggleItalics - cRichEdit

Toggles selected text between italicized and normal text

Type: Procedure

Parameters: No Parameters

Description

Toggles selected text between italicized and normal text.

This message is provided to allow toggling of selected text between italicized and normal (non-italicized ) text. It toggles pbItalics between True and False. It is fired via the predefined shortcut key Ctrl+I.

You can use the message to fire toggling of the selected text between italicized and normal text, for example, by calling it from a toolbar button.

Sample

This sample toggles the selected text of control oRichEdit1 between italicized and normal text.

send ToggleItalics of oRichEdit1

Last Edited: December 2, 2004


cRichEdit [Procedure ToggleUnderline]

ToggleUnderline - cRichEdit

Toggles selected text between underlined and normal text

Type: Procedure

Parameters: No Parameters

Description

Toggles selected text between underlined and normal text.

This message is provided to allow toggling of selected text between underlined and normal (non-underlined) text. It toggles pbUnderline between True and False. It is fired via the predefined shortcut key Ctrl+U.

You can use the message to fire toggling of the selected text between underlined and normal text, for example, by calling it from a toolbar button.

Sample

This sample toggles the selected text of control oRichEdit1 between underlined and normal text.

send ToggleUnderline of oRichEdit1

Last Edited: December 2, 2004


cRichEdit [Procedure Top_of_Panel]

Top_of_Panel - cRichEdit

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for cRichEdit

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Changed_State | Determines whether the content of the control has changed |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object |
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object |
Label_Col_Offset | The horizontal distance from the object to its label |
Label_Justification_Mode | The justification mode for the text within this object's label |
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property |
Label_Row_Offset | The vertical distance from the top edge of the object and its label |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of lines in control | DFBaseRichEdit
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
paValue | Sets content of control from memory address or places RTF stream in control into memory address | DFBaseRichEdit
pbAutoUrl | Toggles the ability for the control to automatically detect URLs and add hyperlinks | DFBaseRichEdit
pbBold | Toggles selected text between bold and normal text | DFBaseRichEdit
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard | DFBaseRichEdit
pbCanRedo | Determines whether a redo operation can be performed | DFBaseRichEdit
pbCanUndo | Determines whether an undo operation can be performed | DFBaseRichEdit
pbItalics | Toggles selected text between italicized and normal text | DFBaseRichEdit
pbLink | Toggles selected text between hyperlinked and normal text | DFBaseRichEdit
pbProtect | Toggles selected text between protected and normal text | DFBaseRichEdit
pbStrikeOut | Toggles selected text between strikeout and normal text | DFBaseRichEdit
pbSubScript | Toggles selected text between subcripted and normal text | DFBaseRichEdit
pbSuperScript | Toggles selected text between superscripted and normal text | DFBaseRichEdit
pbUnderline | Toggles selected text between underlined and normal text | DFBaseRichEdit
pbWrap | Determines whether text input will break and wrap to the next line at right margin | DFBaseRichEdit
peAlignment | Sets or returns alignment of selected paragraph or paragraphs | DFBaseRichEdit
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peBullets | Sets or returns bullets or numbering of selected paragraph or paragraphs | DFBaseRichEdit
peBulletStyle | Sets or returns numbering styles of selected paragraph or paragraphs | DFBaseRichEdit
peCharSet | Sets or returns character set of selected text | DFBaseRichEdit
peLineSpacingType | Determines type of line spacing of selected paragraph or paragraphs | DFBaseRichEdit
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
pePitchandFamily | Sets or returns the font pitch and family of selected text | DFBaseRichEdit
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piBulletStart | Sets or returns the starting number of paragraph numbering of selected paragraph or paragraphs | DFBaseRichEdit
piBulletTab | Sets or returns the minimum space between a paragraph bullet or number and the paragraph text of selected paragraph or paragraphs | DFBaseRichEdit
piFontSize | Sets or returns font size of selected text | DFBaseRichEdit
piFontWeight | Sets or returns font weight of selected text | DFBaseRichEdit
piLineSpacing | Determines exact line spacing of selected paragraph or paragraphs | DFBaseRichEdit
piMaxChars | Sets or returns maximum number of characters | DFBaseRichEdit
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piOffsetIndent | Sets or returns indentation of 2nd and subsequent lines, relative to first line, of selected paragraph or paragraphs | DFBaseRichEdit
piParagraphIndent | Sets or returns indentation of selected paragraph or paragraphs | DFBaseRichEdit
piRightMargin | Determines indentation of right side of control's text, relative to the right margin | DFBaseRichEdit
piSpacingAfter | Determines the spacing below selected paragraph or paragraphs | DFBaseRichEdit
piSpacingBefore | Determines the spacing above selected paragraph or paragraphs | DFBaseRichEdit
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
psTypeFace | Sets or returns font typeface of selected text | DFBaseRichEdit
Read_Only_State | Determines whether users may edit the content of the control | DFBaseRichEdit
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextBackColor | Sets or returns background color of selected text | DFBaseRichEdit
TextColor | Sets or returns color of selected text | DFBaseRichEdit
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value | Sets or returns content of control | DFBaseRichEdit
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cRichEdit [Property Changed_State]

Changed_State - cRichEdit

Determines whether the content of the control has changed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Changed_State is toggled to True when the content of the control changes.

Sample

This sample checks to see whether the content of the oRichEdit1 control has changed, and if so, displays a message box to the user.

Procedure CheckForChanges
    boolean bChanged

    get Changed_State of oRichEdit1 to bChanged

    if (bChanged = True) ;
        send Info_Box "The content of the control has changed"
End_Procedure  // CheckForChanges

Last Edited: November 23, 2004


cRichEdit [Property Enabled_State]

Enabled_State - cRichEdit

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


cRichEdit [Property Explicit_Shadow_State]

Explicit_Shadow_State - cRichEdit

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


cRichEdit [Property Floating_Menu_Object]

Floating_Menu_Object - cRichEdit

Identifies the floating popup menu (context menu) for this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Floating_Menu_Object property identifies the floating popup menu (context menu) for this object. The default setting will provide a standard edit context menu. You may create your own custom floating menus and assign them to objects by setting this property. You may also disable a floating menu by setting this property to zero.

Sample

This sample creates a custom context menu from class FloatingPopupMenu, then sets the Floating_Menu_Object property to the FloatingPopupMenu object name.

Object oCustomMenu is a FloatingPopupMenu
    Send Add_Item msg_DoUndo "&Undo"
    Send Add_Item msg_DoRedo "&Redo"
    Send Add_Item msg_None "" // create a spacer
    Send Add_Item msg_Cut "Cu&t"
    Send Add_Item msg_Copy "&Copy"
    Send Add_Item msg_Paste "&Paste"
    Send Add_Item msg_None "" // create a spacer
    Send Add_Item msg_Select_All "Select &All"

    Procedure Popup
        integer iFocus iItemCount
        boolean bChanged

        Get Focus to iFocus // the object that called us
        Get Changed_State of iFocus to bChanged
        Get Item_Count to iItemCount // exit is the last item
        // if changed, shadow exit option
        Set Shadow_State (iItemCount - 1) to bChanged

        forward send Popup
    End_Procedure  // Popup
End_Object  // oCustomMenu

set Floating_Menu_Object to oCustomMenu

Last Edited: November 22, 2004


cRichEdit [Property Help_id]

Help_id - cRichEdit

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


cRichEdit [Property Help_Keyword]

Help_Keyword - cRichEdit

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


cRichEdit [Property Item_Shadow_State]

Item_Shadow_State - cRichEdit

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


cRichEdit [Property Label]

Label - cRichEdit

Sets the text for a label or heading for an entry control object

Type: Property

Access: Read/Write

Data Type: String

Description

The Label property sets the text for a label or heading for an entry control object (form, edit or list). In most classes, just setting this property is all that is required for the class to present the label in whatever particular way each class does this. In data-aware classes, the value of this property is overridden by label values in the DDO when auto_label_state has been set true.

Object F1 is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "First Name:"
End_object

Last Edited: August 18, 2003


cRichEdit [Property Label_Col_Offset]

Label_Col_Offset - cRichEdit

The horizontal distance from the object to its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Col_Offset is the horizontal distance from the object to its label. Units represent distance to the left (i.e., labels appear to the left of their object). If the label's justification-mode is left or top (jmode_left, jmode_top) this represents the distance from left edge of the object to the left edge of its label. If the justification-mode is right (jmode_right) this represents the distance from the left edge of the object to the right edge of the label. By default, this is the value of default_label_offset, which is supplied with a value of 60 (this is a global integer which can be changed).

Default is default label offset.

Last Edited: August 18, 2003


cRichEdit [Property Label_Justification_Mode]

Label_Justification_Mode - cRichEdit

The justification mode for the text within this object's label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Justification_Mode is the justification mode for the text within this object's label.

When the label_justification_mode is changed the row and col offset properties will often need to be changed as well.

The default mode for labels (jmode_left) is stored in the global integer default_label_jmode.

Object LeftForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Left Justify:" // use default column of 60
End_object

Object RightForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Right Justify:"
    Set label_justification_mode to jmode_right
    // set distance between right side of the label and the left side
    // of the object
    Set label_col_offset to 3
End_object

Object TopForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Top Justify:"
    Set label_justification_mode to jmode_top
    // label and object will align vertically
    Set label_col_offset to 0
End_object

Default is JMode Left.

Last Edited: August 18, 2003


cRichEdit [Property Label_Offset]

Label_Offset - cRichEdit

Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer i1 integer i2

Parameter | Description
i1 | The Row Offset of the Label
i2 | The Column Offset of the Label

Description

The Label_Offset property returns both the label_row_offset and the label_col_offset properties as a single (two-component) property. The Hi() value of the return parameter represents the row offset. The Low() value represents the column offset.

Get Label_Offset of oForm to iOffset
Move (Hi(iOffset))  to iRowOffset
Move (Low(iOffset)) to iColumnOffset

Label_offset is set as a single property passing the row offset and the column offset as two separate parameters.

Set Label_Offset of oForm to iRowOffset iColumnOffset

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

Last Edited: June 22, 2005


cRichEdit [Property Label_Row_Offset]

Label_Row_Offset - cRichEdit

The vertical distance from the top edge of the object and its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Row_Offset is the vertical distance from the top edge of the object and its label. If the label's justification-mode is jmode_top it represents the vertical distance from the top edge of this object to the bottom edge of its label and larger numbers moves the label up (and away from the object). If the mode is not top it represents the distance from the top edge of the object and the top edge of the label and larger numbers moves the label down. By default, this is zero which is suitable for both form and side labels.

Default is 0.

Last Edited: August 18, 2003


cRichEdit [Property Object_Shadow_State]

Object_Shadow_State - cRichEdit

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


cRichEdit [Property psHtmlHelpTopic]

psHtmlHelpTopic - cRichEdit

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


cRichEdit [Property Status_Help]

Status_Help - cRichEdit

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


cRichEdit [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - cRichEdit

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


CrystalReport [Event OnDeInitializeReport]

OnDeInitializeReport - CrystalReport

A hook message sent by the Close_report procedure

Type: Event

Parameters: No Parameters

Description

OnDeInitializeReport is a hook message sent by the CloseReport procedure. You may use this event to clean up after the report. This event is intended for augmentation; it has no action by default.

Last Edited: February 18, 2004


CrystalReport [Event OnInitializeReport]

OnInitializeReport - CrystalReport

A hook message sent by the Open_report procedure

Type: Event

Parameters: No Parameters

Description

OnInitializeReport is a hook message sent by the OpenReport procedure. You may use this procedure to set selection values, print options, etc. This procedure is intended for augmentation; it has no action by default.

Last Edited: August 4, 2004


CrystalReport [Event OnStartPrinting]

OnStartPrinting - CrystalReport

A hook message sent just before starting a print job

Type: Event

Parameters: No Parameters

Description

OnStartPrinting is a hook message sent just before starting a print job. It is sent by the RunCrystalReport procedure. You may use this procedure to trigger screen display (hour glass, series of graphics, etc.) to confirm that a print job is in progress. This procedure is intended for augmentation; it has no action by default.

Last Edited: August 4, 2004


CrystalReport [Event OnStopPrinting]

OnStopPrinting - CrystalReport

A hook message sent after completion of a print job

Type: Event

Parameters: No Parameters

Description

OnStopPrinting is a hook message sent after completion of a print job. It is sent by the RunCrystalReport procedure. You may use this procedure to stop screen display started by the OnStartReport procedure or to find out whether a job was successfully completed using the JobStatus function. This procedure is intended for augmentation; it has no action by default.

Last Edited: August 4, 2004


Events for CrystalReport

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnDeInitializeReport | A hook message sent by the Close_report procedure |
OnInitializeReport | A hook message sent by the Open_report procedure |
OnStartPrinting | A hook message sent just before starting a print job |
OnStopPrinting | A hook message sent after completion of a print job |


CrystalReport [Function CheckFormula]

CheckFormula - CrystalReport

Checks if the contents of a formula are valid

Type: Function

Return Data Type: Integer

Parameters: String sFormulaName

Parameter | Description
sFormulaName | The name of the formula.

Return Value

Returns non-zero if formula is valid. Returns 0 if formula is not valid.

Description

CheckFormula checks if the contents of a formula are valid.

Procedure ChangeSeltxt String sNewFormula
    String sOriginalFormula
    Integer FormulaValid

    Get Formula "SelTxt" To sOriginalFormula
    Set Formula "SelTxt" To sNewFormula
    Get CheckFormula "SelTxt" To iFormulaValid
    If (Not(iFormulaValid)) ;
        Set Formula "SelTxt" To sOriginalFormula
End_Procedure // ChangeSelTxt

Last Edited: August 16, 2004


CrystalReport [Function CheckGroupSelectionFormula]

CheckGroupSelectionFormula - CrystalReport

Checks if the contents of the group-selection formula are valid

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

returns non-zero if formula is valud. retursn 0 if formula is not valid

Description

CheckGroupSelectionFormula checks if the contents of the group-selection formula are valid.

Procedure ChangeGroupSelFormula String sNewFormula
    String sOriginalFormula
    Integer iFormulaValid

    Get GroupSelectionFormula To sOriginalFormula
    Set GroupSelectionFormula To sNewFormula
    Get CheckGroupSelectionFormula To iFormulaValid
    If (Not(iFormulaValid)) ;
        Set GroupSelectionFormula To sOriginalFormula
End_Procedure // ChangeGroupSelFormula

Last Edited: August 4, 2004


CrystalReport [Function CheckSelectionFormula]

CheckSelectionFormula - CrystalReport

Checks if the contents of the selection formula are valid

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

returns non-zero if formula is valud. retursn 0 if formula is not valid

Description

CheckSelectionFormula checks if the contents of the selection formula are valid.

Procedure ChangeSelFormula String sNewFormula
    String sOriginalFormula
    Integer iFormulaValid

    Get SelectionFormula To sOriginalFormula
    Set SelectionFormula To sNewFormula
    Get CheckSelectionFormula To iFormulaValid
    If (Not(iFormulaValid)) ;
        Set SelectionFormula To sOriginalFormula
End_Procedure // ChangeSelFormula

Last Edited: August 4, 2004


CrystalReport [Function CrystalDate]

CrystalDate - CrystalReport

Converts date to Crystal format

Type: Function

Return Data Type: String

Parameters: Date dVal

Parameter | Description
dVal | The date value

Return Value

Description

When dealing with the Crystal Reports API, it is necessary to convert Visual DataFlex data types before calling any of the API functions.

Sample

Object CrystalCompetitivePricingReport Is A CrystalReport
    Set Report_Name To "Pricing.rpt"
    Set Report_View_Id To (Parent(Self))

    Procedure OnInitializeReport
        Date dCutOff
        Get Value of oCutOffDate To dCutOff
        Set Formula "CutOffDate" To (CrystalDate(Self,dCutOff))
        Set Output_Destination To CRW_PRINT_TO_WINDOW
    End_Procedure // OnInitializeReport

End_Object // CrystalCompetitivePricingReport

Last Edited: February 18, 2004


CrystalReport [Function CrystalInteger]

CrystalInteger - CrystalReport

Converts integer to CrystalInteger format

Type: Function

Return Data Type: String

Parameters: Integer iVal

Parameter | Description
iVal | The integer value

Return Value

Description

When dealing with the Crystal Reports API, it is necessary to convert Visual DataFlex data types before calling any of the API functions.

Last Edited: February 18, 2004


CrystalReport [Function CrystalNumber]

CrystalNumber - CrystalReport

Converts number to CrystalNumber format

Type: Function

Return Data Type: String

Parameters: Number nVal

Parameter | Description
nVal | The number value

Return Value

Description

When dealing with the Crystal Reports API, it is necessary to convert Visual DataFlex data types before calling any of the API functions.

Last Edited: February 18, 2004


CrystalReport [Function CrystalString]

CrystalString - CrystalReport

Converts string to CrystalString format

Type: Function

Return Data Type: String

Parameters: String sVal

Parameter | Description
sVal | The string value

Return Value

Description

When dealing with the Crystal Reports API, it is necessary to convert Visual DataFlex data types before calling any of the API functions.

Last Edited: February 18, 2004


CrystalReport [Function ExportOptions]

ExportOptions - CrystalReport

Used to present a series of dialog boxes that retrieve export options from users

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns a result integer (not used)

Description

ExportOptions can be used to present a series of dialog boxes that retrieve export options from users. It will set up this object's properties according to the selection users make in the dialog boxes.

After calling this function, the following properties can be changed:

ExportFormatType

Output_Destination

UseReportNumberFormat_State

UseReportDateFormat_State

StringDelimiter

FieldDelimiter

ExportFileName

ToList

CCList

SubjectText

MessageText

Last Edited: September 25, 2003


CrystalReport [Function Full_Report_Name]

Full_Report_Name - CrystalReport

Determines the full name of the report

Type: Function

Return Data Type: String

Parameters: String RptName

Parameter | Description
RptName | The name of the report

Return Value

If the passed report name already contains directory separators or the drive separator (":"), it will be returned unchanged. Otherwise, the report directory of the current workspace is prefixed to the report name.

Description

Full_Report_Name will determine the full name of the report.

Last Edited: August 18, 2003


CrystalReport [Function JobStatus]

JobStatus - CrystalReport

Evaluates the status of a print job

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns a Job Status value

Description

The JobStatus function evaluates the status of a print job. You can use this function in a number of programming situations, for example to trigger error messages, i.e., when a print job fails (due to insufficient memory, insufficient disk space, etc.) or, to trigger screen displays (hourglass, series of graphics, etc.) that confirm to the user that work is in progress or to find out whether a job was cancelled by the user after PEStartPrintJob returns. Following is a list of possible return values:

Constant | Meaning
1 | OpenEngine or OpenPrintJob have not been called successfully
PE_JOBNOTSTARTED | The print job hasn't started yet
PE_JOBINPROGRESS | The print job is in progress
PE_JOBFAILED | The print job has failed
PE_JOBCANCELLED | The print job has been canceled by the user

Last Edited: September 25, 2003


CrystalReport [Function NthTableLogOnDatabaseName]

NthTableLogOnDatabaseName - CrystalReport

The name of the table within the server

Type: Function

Return Data Type: String

Parameters: Integer iTableN

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).

Return Value

Description

NthTableLogOnDatabaseName is the name of the table within the server.

See Also

NthTableLogOnServerName

Last Edited: August 4, 2004


CrystalReport [Function NthTableLogOnPassword]

NthTableLogOnPassword - CrystalReport

The password of the user on the server

Type: Function

Return Data Type: String

Parameters: Integer iTableN

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).

Return Value

Description

NthTableLogOnPassword is the password of the user on the server.

See Also

NthTableLogOnServerName | NthTableLogOnUserID

Last Edited: August 4, 2004


CrystalReport [Function NthTableLogOnServerName]

NthTableLogOnServerName - CrystalReport

The logon name for the server

Type: Function

Return Data Type: String

Parameters: Integer iTableN

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).

Return Value

Description

NthTableLogOnServerName is the logon name for the server. The contents of the server name depend on the type of the database file; for an ODBC database, this is the DSN (Data Source Name).

Last Edited: September 10, 2003


CrystalReport [Function NthTableLogOnUserID]

NthTableLogOnUserID - CrystalReport

The user ID on the server

Type: Function

Return Data Type: String

Parameters: Integer iTableN

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).

Return Value

Description

NthTableLogOnUserID is the user ID on the server.

See Also

NthTableLogOnServerName

Last Edited: September 10, 2003


CrystalReport [Function NthTableSessionHandle]

NthTableSessionHandle - CrystalReport

Specifies the handle to Microsoft Access Tables sessions

Type: Function

Return Data Type: Integer

Parameters: Integer iTableN

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).

Return Value

Description

Microsoft Access Tables only. Many Access database tables require that a session be opened before the table can be used. This property specifies the handle to such a session.

Last Edited: August 4, 2004


CrystalReport [Function NthTableSessionPassword]

NthTableSessionPassword - CrystalReport

Specifies the password for Micrisoft Access Tables only session

Type: Function

Return Data Type: String

Parameters: Integer iTableN

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).

Return Value

Description

Microsoft Access Tables only. Many Access database tables require that a session be opened before the table can be used. This property specifies the password for such a session.

Last Edited: August 4, 2004


CrystalReport [Function NthTableSessionUserID]

NthTableSessionUserID - CrystalReport

Specifies the user ID for Microsoft Access Tables

Type: Function

Return Data Type: String

Parameters: Integer iTableN

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).

Return Value

Description

Microsoft Access Tables only. Many Access database tables require that a session be opened before the table can be used. This property specifies the user ID for such a session.

Last Edited: August 4, 2004


CrystalReport [Function PrinterDEVMODE]

PrinterDEVMODE - CrystalReport

Returns the DEVMODE structure

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Returns the DEVMODE structure

Description

PrinterDevMode returns the DEVMODE structure. This structure can be used to ascertain which printer options have been specified with the report. Refer to the Windows API documentation for further information.

Last Edited: September 11, 2003


CrystalReport [Function Report_Base_File_Name]

Report_Base_File_Name - CrystalReport

Removes the directory information from the name passed and returns that name

Type: Function

Return Data Type: String

Parameters: String sIn

Parameter | Description
sIn | The Full Filename

Return Value

Returns the base file name (removing all directory information)

Description

Report_Base_File_Name removes the directory information from the name passed and returns that name.

Last Edited: September 25, 2003


CrystalReport [Function TestNthTableConnectivity]

TestNthTableConnectivity - CrystalReport

Tests if a connection to the database file can be made

Type: Function

Return Data Type: Integer

Parameters: Integer iTableN

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).

Return Value

Returns 0 if table cannot be connected

Description

TestNthTableConnectivity tests if a connection to the database file can be made. This function may require a significant amount of time to complete, since it will first open a user session (if required), then log on to the database server (if required), and then open the appropriate database table (to test that it exists). It does not read any data, and closes the table immediately once successful. Logging off is performed when the print job is closed.

Last Edited: September 25, 2003


Methods for CrystalReport

View method list in hierarchical order

Name | Type | Description | Defining Class
AddGroupSortField | Procedure | Adds a field to the group sort order of the report |
AddSortField | Procedure | Adds a field to the sort order of the report |
CancelPrintJob | Procedure | Used to cancel a print job in progress |
CheckFormula | Function | Checks if the contents of a formula are valid |
CheckGroupSelectionFormula | Function | Checks if the contents of the group-selection formula are valid |
CheckSelectionFormula | Function | Checks if the contents of the selection formula are valid |
ClosePrintEngine | Procedure | Closes the print engine |
CloseReport | Procedure | Sends the OnDeInitializeReport hook message, and closes the report |
CloseWindow | Procedure | Closes the Preview window |
Create | Function | Creates an object based on the passed Class Id | cObject
CrystalDate | Function | Converts date to Crystal format |
CrystalInteger | Function | Converts integer to CrystalInteger format |
CrystalNumber | Function | Converts number to CrystalNumber format |
CrystalString | Function | Converts string to CrystalString format |
DeleteNthGroupSortField | Procedure | Deletes the Nth group-sort field of the current sort order of the report |
DeleteNthSortField | Procedure | Deletes the Nth sort field of the current sort order of the report |
Destroy | Procedure |  | cObject
DoWinQLReport | Procedure | (Obsolete) Obsolete. Use RunCrystalReport instead. |
Exit_Application | Procedure | Starts the process of closing an application | cObject
ExportOptions | Function | Used to present a series of dialog boxes that retrieve export options from users |
ExportPrintWindow | Procedure | Exports the report currently in the preview window |
ExportWindowToDisk | Procedure |  |
ExportWindowToMail | Procedure |  |
Font | Procedure Set | Sets the font for field and/or text characters in the report section(s) specified |
Full_Report_Name | Function | Determines the full name of the report |
JobStatus | Function | Evaluates the status of a print job |
LogOffServer | Procedure | Logs off the specified server |
LogOnServer | Procedure | Logs on to the specified server |
NextPrintWindowMagnification | Procedure | Changes the Preview-window magnification to the next magnification level in order |
NthTableLogOnDatabaseName | Function | The name of the table within the server |
NthTableLogOnDatabaseName | Procedure Set | Sets the NthTableLogOnDatabaseName table name |
NthTableLogOnPassword | Function | The password of the user on the server |
NthTableLogOnPassword | Procedure Set | Sets the password of the user on the server |
NthTableLogOnServerName | Function | The logon name for the server |
NthTableLogOnServerName | Procedure Set | Sets the logon name for the server |
NthTableLogOnUserID | Function | The user ID on the server |
NthTableLogOnUserID | Procedure Set | Sets the user ID on the server |
NthTableSessionHandle | Function | Specifies the handle to Microsoft Access Tables sessions |
NthTableSessionHandle | Procedure | Sets the handle to Microsoft Access Tables sessions |
NthTableSessionPassword | Function | Specifies the password for Micrisoft Access Tables only session |
NthTableSessionPassword | Procedure Set | Sets the password for Micrisoft Access Tables only session |
NthTableSessionUserID | Function | Specifies the user ID for Microsoft Access Tables |
NthTableSessionUserID | Procedure Set | Sets the user ID for Microsoft Access Tables |
OpenPrintEngine | Procedure | Opens the print engine |
OpenReport | Procedure | Open the report and send the OnInitializeReport hook |
OutputToPrinter | Procedure | Print the report to a printer |
OutputToWindow | Procedure | Prints the report to a Preview window |
PrinterDEVMODE | Function | Returns the DEVMODE structure |
PrintReportToPrinter | Procedure | (Obsolete) Prints the report, identified with the sReportName parameter, to the printer |
PrintReportToWindow | Procedure | (Obsolete) |
PrintWindow | Procedure | Prints the report displayed in the Preview window |
Report_Base_File_Name | Function | Removes the directory information from the name passed and returns that name |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Run_Report | Procedure | Runs the report |
RunCrystalReport | Procedure | Runs the CrystalReport report as defined in its properties |
SelectAndPrintWindow | Procedure |  |
SelectAndSetFont | Procedure |  |
SelectAndSetPrinter | Procedure |  |
SelectPrinter | Procedure | Specifies a printer other than the default printer as a print destination |
ShowFirstPage | Procedure | Shows the first page in the preview window |
ShowLastPage | Procedure | Shows the last page in the preview window |
ShowNextPage | Procedure | Shows the next page in the preview window |
ShowPreviousPage | Procedure | Shows the previous page in the preview window |
TestNthTableConnectivity | Function | Tests if a connection to the database file can be made |


CrystalReport [Procedure Set Font]

Font - CrystalReport

Sets the font for field and/or text characters in the report section(s) specified

Type: Procedure Set

Data Type: Integer

Parameters: Integer iSection Integer iScope String sFaceName Integer iFamily Integer iPitch Integer iCharSet Integer iSize Integer iItalic Integer iUnder Integer iStrike Integer iWeight

Parameter | Description
iSection | The section identifier
iScope | Does font selected to apply to fields, to text, or to both
sFaceName | Actual face name of the font
iFamily | The font family
iPitch | The font pitch
iCharSet | The character set
iSize | The desired point size for the selected font
iItalic | Specifies if Font is Italicized
iUnder | Specifies if Font is Underlined
iStrike | Specifies if Font should be strick out
iWeight | The Font Weight

Description

Font sets the font for field and/or text characters in the report section(s) specified. The values used by the parameters are:

iSectionCode

The section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections.
PE_HEADERSECTION | The Page-Header section.
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section.
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section.
PE_FOOTERSECTION | The Page-Footer section.

iScope

Specifies whether the font selected is to apply to fields, to text, or to both. To specify both fields and text, use the ior operator. Use:

Constant | Meaning
PE_FIELDS | Sets the default font for all field values in the report section specified.
PE_TEXT | Sets the default font for all text (that has not been entered as a field value) in the report section specified.

sFaceName

Specifies the actual face name of the font you want to use. The face name you pass typically comes from a font dialog box. Example: Times New Roman.

iFamily

Specifies the font family for the font you want to use. Use one of the following constant values:

Constant | Meaning
FF_DONTCARE | No font family, or family doesn't matter.
FF_ROMAN | Variable-pitch font with serifs.
FF_SWISS | Fixed-pitch font without serifs.
FF_MODERN | Fixed-pitch font, with or without serifs.
FF_SCRIPT | Handwriting-like font.
FF_DECORATIVE | Fancy display font.

iPitch

Specifies the font pitch you wish to use. Use 0 if you wish to retain the current default.

DEFAULT_PITCH
FIXED_PITCH
VARIABLE_PITCH

iCharSet

Specifies the character set you wish to use. Use 0 if you wish to retain the current default.

ANSI_CHARSET
DEFAULT_CHARSET
SYMBOL_CHARSET
SHIFTJIS_CHARSET
HANGUL_CHARSET
CHINESEBIG5_CHARSET
OEM_CHARSET

iSize

Specifies the desired point size for the selected font. Use 0 for no change.

iItalic

Specifies whether the font selected should be italicized.

iUnder

Specifies whether the font selected should be underlined.

iStrike

Specifies whether the font selected should be struck out.

iWeight

Specifies the weight of the font. Use 0 if you wish to retain the current default.

FW_DONTCARE
FW_THIN
FW_EXTRALIGHT
FW_LIGHT
FW_NORMAL
FW_MEDIUM
FW_SEMIBOLD
FW_BOLD
FW_EXTRABOLD
FW_HEAVY
FW_ULTRALIGHT
FW_REGULAR
FW_DEMIBOLD
FW_ULTRABOLD
FW_BLACK

The Font procedure sets the font for field and/or text characters in the report section(s) specified. This procedure is automatically called from the SelectAndSetFont procedure.

Last Edited: August 4, 2004


CrystalReport [Procedure Set NthTableLogOnDatabaseName]

NthTableLogOnDatabaseName - CrystalReport

Sets the NthTableLogOnDatabaseName table name

Type: Procedure Set

Data Type: Integer

Parameters: Integer iTableN String sDatabaseName Integer iPropagateAcrossTables

Parameter | Description
iTableN | the number of the database file. Database-file numbers start at 0 (zero).
sDatabaseName | The Database Name
iPropagateAcrossTables | Should action propagate across tables

Description

NthTableLogOnDatabaseName sets the name of the table within the server.

Last Edited: September 25, 2003


CrystalReport [Procedure Set NthTableLogOnPassword]

NthTableLogOnPassword - CrystalReport

Sets the password of the user on the server

Type: Procedure Set

Data Type: Integer

Parameters: Integer iTableN String sPassword Integer iPropagateAcrossTables

Parameter | Description
iTableN | the number of the database file. Database-file numbers start at 0 (zero).
sPassword | Password
iPropagateAcrossTables | Should action propagate across tables

Description

NthTableLogOnPassword sets the password of the user on the server.

Last Edited: September 25, 2003


CrystalReport [Procedure Set NthTableLogOnServerName]

NthTableLogOnServerName - CrystalReport

Sets the logon name for the server

Type: Procedure Set

Data Type: Integer

Parameters: Integer iTableN String sServerName Integer iPropagateAcrossTables

Parameter | Description
iTableN | the number of the database file. Database-file numbers start at 0 (zero).
sServerName | The Server name
iPropagateAcrossTables | Should action propagate across tables

Description

NthTableLogOnServerName sets the logon name for the server.

Last Edited: September 25, 2003


CrystalReport [Procedure Set NthTableLogOnUserID]

NthTableLogOnUserID - CrystalReport

Sets the user ID on the server

Type: Procedure Set

Data Type: Integer

Parameters: Integer iTableN String sUserID Integer iPropagateAcrossTables

Parameter | Description
iTableN | the number of the database file. Database-file numbers start at 0 (zero).
sUserID | The user id
iPropagateAcrossTables | Should action propagate across tables

Description

NthTableLogOnUserID sets the user ID on the server.

Last Edited: September 25, 2003


CrystalReport [Procedure Set NthTableSessionPassword]

NthTableSessionPassword - CrystalReport

Sets the password for Micrisoft Access Tables only session

Type: Procedure Set

Data Type: Integer

Parameters: Integer iTableN String sPassword Integer iPropagateAcrossTables

Parameter | Description
iTableN | the number of the database file. Database-file numbers start at 0 (zero).
sPassword | the password to set
iPropagateAcrossTables | Should action propagate across tables

Description

NthTableSessionPassword sets the password for Microsoft Access Tables only session.

Last Edited: August 4, 2004


CrystalReport [Procedure Set NthTableSessionUserID]

NthTableSessionUserID - CrystalReport

Sets the user ID for Microsoft Access Tables

Type: Procedure Set

Data Type: Integer

Parameters: Integer iTableN String sUserID Integer iPropagateAcrossTables

Parameter | Description
iTableN | the number of the database file. Database-file numbers start at 0 (zero).
sUserID | the user id
iPropagateAcrossTables | Should action propagate across tables

Description

NthTableSessionUserID sets the user ID for Microsoft Access Tables.

Last Edited: September 25, 2003


CrystalReport [Procedure AddGroupSortField]

AddGroupSortField - CrystalReport

Adds a field to the group sort order of the report

Type: Procedure

Parameters: String sName Integer iDirection

Parameter | Description
sName | The name of the sort field to add.
iDirection | The direction of the sort field. Direction can be either PE_SF_ASCENDING or PE_SF_DESCENDING.

Description

AddGroupSortField adds a field to the group sort order of the report.

Procedure OnStartPrinting
    Integer iNumSortFields iCurSortField

    //*** Delete old sort order
    Get NGroupSortFields To iNumSortFields
    For iCurSortField From 0 To (iNumSortFields-1)
        Send DeleteNthGroupSortField 0
    Loop

    //*** Set up new sort order
    Send AddGroupSortField "{Customer.Name}" PE_SF_ASCENDING
End_Procedure // OnStartPrinting

Last Edited: August 4, 2004


CrystalReport [Procedure AddSortField]

AddSortField - CrystalReport

Adds a field to the sort order of the report

Type: Procedure

Parameters: String sName Integer iDirection

Parameter | Description
sName | The name of the sort field to add.
iDirection | The direction of the sort field. Direction can be either PE_SF_ASCENDING or PE_SF_DESCENDING.

Description

AddSortField adds a field to the sort order of the report.

Procedure OnStartPrinting
    Integer iNumSortFields iCurSortField

    //*** Delete old sort order
    Get NSortFields To iNumSortFields
    For iCurSortField From 0 To (iNumSortFields-1)
        Send DeleteNthSortField 0
    Loop

    //*** Setup new sort order
    Send AddSortField "{Customer.Name}" PE_SF_ASCENDING
End_Procedure // OnStartPrinting

Last Edited: August 4, 2004


CrystalReport [Procedure CancelPrintJob]

CancelPrintJob - CrystalReport

Used to cancel a print job in progress

Type: Procedure

Parameters: No Parameters

Description

The CancelPrintJob procedure can be used to cancel a print job in progress.

Last Edited: July 30, 2003


CrystalReport [Procedure ClosePrintEngine]

ClosePrintEngine - CrystalReport

Closes the print engine

Type: Procedure

Parameters: No Parameters

Description

The ClosePrintEngine closes the print engine. The procedure will administrate its release of the print engine so that closing the engine can be handled correctly. This procedure is typically sent when accessing reports at a low level.

Object oCrystalReport is a CrystalReport
    Procedure LowLevelJobHandling
        Send OpenPrintEngine
        Send OpenPrintJob "CustRpt.rpt"
        Send OutputToWindow "Low Level" 0 0 500 500 0 0
        Send PrintWindow
        Send ClosePrintJob
        Send ClosePrintEngine
    End_Procedure // LowLevelJobHandling
End_Object // oCrystalReport

Last Edited: August 4, 2004


CrystalReport [Procedure CloseReport]

CloseReport - CrystalReport

Sends the OnDeInitializeReport hook message, and closes the report

Type: Procedure

Parameters: No Parameters

Description

CloseReport sends the OnDeInitializeReport hook message, and closes the report. This procedure is usually sent in a procedure when manipulating the properties dynamically. Usually it is in a:

Send OpenReport
Send RunCrystalReport
Send CloseReport

structured piece of code. The report will be manipulated in some way between the OpenReport and RunCrystalReport call. If there is no need to manipulate the report, you should use the Run_Report procedure, which will automatically call the three procedures mentioned above.

Last Edited: August 4, 2004


CrystalReport [Procedure CloseWindow]

CloseWindow - CrystalReport

Closes the Preview window

Type: Procedure

Parameters: No Parameters

Description

CloseWindow closes the Preview window. This procedure can be used to enable users to review the report in the print window and then to close the window (in response to a user event).

Object oCrystalReport is a CrystalReport
    Procedure LowLevelJobHandling
        Send OpenPrintEngine
        Send OpenPrintJob "CustRpt.rpt"
        Send OutputToWindow "Low Level" 0 0 500 500 0 0
        Send PrintWindow
        Send ClosePrintJob
        Send ClosePrintEngine
    End_Procedure // LowLevelJobHandling
End_Object // oCrystalReport

Last Edited: August 4, 2004


CrystalReport [Procedure DeleteNthGroupSortField]

DeleteNthGroupSortField - CrystalReport

Deletes the Nth group-sort field of the current sort order of the report

Type: Procedure

Parameters: Integer iSortFieldN

Parameter | Description
iSortFieldN | The sort field number.

Description

DeleteNthGroupSortField deletes the Nth group-sort field of the current sort order of the report. Sort fields are accessed by number and this numbering is zero-based. Thus the first sort field has number 0 (zero).

Procedure OnStartPrinting
    Integer iNumSortFields iCurSortField

    //*** Delete old sort order
    Get NGroupSortFields To iNumSortFields
    For iCurSortField From 0 To (iNumSortFields-1)
        Send DeleteNthGroupSortField 0
    Loop

    //*** Setup new sort order
    Send AddGroupSortField "{Customer.Name}" PE_SF_ASCENDING
End_Procedure // OnStartPrinting

Last Edited: August 4, 2004


CrystalReport [Procedure DeleteNthSortField]

DeleteNthSortField - CrystalReport

Deletes the Nth sort field of the current sort order of the report

Type: Procedure

Parameters: Integer iSortFieldN

Parameter | Description
iSortFieldN | The sort field number.

Description

DeleteNthSortField deletes the Nth sort field of the current sort order of the report. Sort fields are accessed by number and this numbering is zero-based. Thus the first sort field has number 0 (zero).

Procedure OnStartPrinting
    Integer iNumSortFields iCurSortField

    //*** Delete old sort order
    Get NSortFields To iNumSortFields
    For iCurSortField From 0 To (iNumSortFields-1)
        Send DeleteNthSortField 0
    Loop

    //*** Setup new sort order
   Send AddSortField "{Customer.Name}" PE_SF_ASCENDING
End_Procedure // OnStartPrinting

Last Edited: August 4, 2004


CrystalReport [Procedure DoWinQLReport]

DoWinQLReport - CrystalReport

Obsolete. Use RunCrystalReport instead.

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Obsolete. Use RunCrystalReport instead.

Last Edited: August 4, 2004


CrystalReport [Procedure ExportPrintWindow]

ExportPrintWindow - CrystalReport

Exports the report currently in the preview window

Type: Procedure

Parameters: Integer iToMail

Parameter | Description
iToMail | Indicates if the report must be exported to e-mail.

Description

ExportPrintWindow exports the report currently in the preview window. This procedure is typically used in combination with the ParentWindowHandle and the ShowPrintControls properties. These allow you to display the CrystalReport preview window in a Visual DataFlex object. This procedure can be used to manipulate the contents of the preview window in such a setup.

Last Edited: August 4, 2004


CrystalReport [Procedure ExportWindowToDisk]

ExportWindowToDisk - CrystalReport

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


CrystalReport [Procedure ExportWindowToMail]

ExportWindowToMail - CrystalReport

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


CrystalReport [Procedure LogOffServer]

LogOffServer - CrystalReport

Logs off the specified server

Type: Procedure

Parameters: String sDLLName String sServerName String sDatabaseName String sUserID String sPassword

Parameter | Description
sDLLName | Specifies the name of the CrystalReport DLL for the server or password-protected non-SQL table you want to log onto, which can be retrieved using NthTableDLLName.
sServerName | Specifies the logon name for the server used to create the report.
sDatabaseName | Specifies the logon name for the database used to create the report.
sUserID | Specifies the user ID necessary to log on to the server.
sPassword | Specifies the password necessary to log on to the server.

Description

LogOffServer logs off the specified server. If the server in question is an SQL server, the SQL option of CrystalReport is required. This means you must be using an edition of Crystal Reports that supports accessing SQL databases.

Last Edited: June 21, 2005


CrystalReport [Procedure LogOnServer]

LogOnServer - CrystalReport

Logs on to the specified server

Type: Procedure

Parameters: String sDLLName String sServerName String sDatabaseName String sUserID String sPassword

Parameter | Description
sDLLName | Specifies the name of the CrystalReport DLL for the server or password-protected non-SQL table you want to log onto, which can be retrieved using NthTableDLLName.
sServerName | Specifies the logon name for the server used to create the report.
sDatabaseName | Specifies the logon name for the database used to create the report.
sUserID | Specifies the user ID necessary to log on to the server.
sPassword | Specifies the password necessary to log on to the server.

Description

LogOnServer logs on to the specified server. If the server in question is an SQL server, the SQL option of Crystal Reports is required. This means you must be using an edition of Crystal Reports that supports accessing SQL databases.

This method is easier to call than the NthTableLogOn properties and it can be called at any time. You must know the database DLL name to make this call.

Sample

This sample sets the logon parameters. server, database, username and password should be replaced with the actual parameters for your database.

Procedure OnInitializeReport
      Send LogOnServer "p2sodbc.dll" "server" "database" "username" "password"
End_Procedure // OnInitializeReport

If you are not sure what the DLL name is or what logon information to use, you can get those from the report itself:

1. From the Designer, open your report

2. Select Database \ Convert Database Driver
Here you will find the name of the DLL being used. The name displayed has a D as the second character but the DLL name will have a 2 instead of a D - only 16-bit DLLs have their file name using D. e.g.: If pdsodbc.dll is displayed, the name of the file you will need to inform is p2sodbc.dll

3. Select Database \ Set Location
From here you can get the logon information.

Note:
The report against a DB2 database can be built using the ODBC Driver (p2sodbc.dll, displayed as pdsodbc.dll ) or the DB2 Native Driver (p2sdb2.dll, displayed as pdsdb2.dll). They will both need the same logon information to be provided.

Note:
If the error message "Cannot open SQL server" is displayed, the logon was not successful. Check your logon information and the command used.

Last Edited: September 26, 2005


CrystalReport [Procedure NextPrintWindowMagnification]

NextPrintWindowMagnification - CrystalReport

Changes the Preview-window magnification to the next magnification level in order

Type: Procedure

Parameters: No Parameters

Description

NextPrintWindowMagnification changes the Preview-window magnification to the next magnification level in order. Use this procedure to cycle through the three levels of Preview-window magnification whenever the report has been printed to a Preview window. The three levels of magnification are: Full Page, Fit One Side, and Fit Both Sides.

Last Edited: September 10, 2003


CrystalReport [Procedure NthTableSessionHandle]

NthTableSessionHandle - CrystalReport

Sets the handle to Microsoft Access Tables sessions

Type: Procedure

Parameters: Integer iTableN Integer iHandle Integer iPropagateAcrossTables

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).
iHandle | The handle to set
iPropagateAcrossTables | Should action propagate across tables?

Description

NthTableSessionHandle sets the handle to Microsoft Access Tables sessions.

Last Edited: August 4, 2004


CrystalReport [Procedure OpenPrintEngine]

OpenPrintEngine - CrystalReport

Opens the print engine

Type: Procedure

Parameters: No Parameters

Description

OpenPrintEngine opens the print engine. The procedure will administrate its use of the print engine so closing the engine can be handles correctly. This procedure is typically sent when accessing reports in a low level way.

Object oCrystalReport is a CrystalReport
    Procedure LowLevelJobHandling
        Send OpenPrintEngine
        Send OpenPrintJob "CustRpt.rpt"
        Send OutputToWindow "Low Level" 0 0 500 500 0 0
        Send PrintWindow
        Send ClosePrintJob
        Send ClosePrintEngine
    End_procedure // LowLevelJobHandling
End_object // oCrystalReport

Last Edited: August 4, 2004


CrystalReport [Procedure OpenReport]

OpenReport - CrystalReport

Open the report and send the OnInitializeReport hook

Type: Procedure

Parameters: String sReportName

Parameter | Description
sReportName | The name of the report to run.

Description

OpenReport opens the report and sends the OnInitializeReport hook. The ReportName parameter is optional. If it is not supplied, the report stored in the Report_Name property will be used. This procedure is usually sent in a procedure when manipulating the properties dynamically. Usually it is in a:

Send OpenReport
Send RunCrystalReport
Send CloseReport

structured piece of code. The report will be manipulated in some way between the OpenReport and RunCrystalReport call. If there is no need to manipulate the report, you should use the Run_Report procedure, which will automatically call the three procedures mentioned above.

Last Edited: August 16, 2005


CrystalReport [Procedure OutputToPrinter]

OutputToPrinter - CrystalReport

Print the report to a printer

Type: Procedure

Parameters: Integer iCopies

Parameter | Description
iCopies | The number of copies to print.

Description

OutputToPrinter prints the report to a printer. This procedure is automatically sent when using the RunCrystalReport procedure and the Output_Destination property is set to CRW_PRINT_TO_PRINTER.

Procedure PrintCustlstToPrinter
    Set Report_Name To "custlst.rpt"
    Send OpenReport
    Send OutputToPrinter 1
    Send CloseReport
End_Procedure // PrintCustlstToPrinter

Last Edited: August 4, 2004


CrystalReport [Procedure OutputToWindow]

OutputToWindow - CrystalReport

Prints the report to a Preview window

Type: Procedure

Parameters: String sTitle Integer iLeft Integer iTop Integer iWidth Integer iHeight Integer iStyle Handle hParent

Parameter | Description
sTitle | The title of the window that shows the report.
iLeft | The position at which you want the left edge of the window to appear.
iTop | The position at which you want the top edge of the window to appear.
iWidth | The width of the window in pixels.
iHeight | The height of the window in pixels.
iStyle | The style of the window. See the WindowStyle property for a discussion of window styles.
hParent | Specifies the window handle for the parent window to be used for the print window.

Description

OutputToWindow prints the report to a Preview window. This procedure is automatically sent when using the RunCrystalReport procedure and the Output_Destination property is set to CRW_PRINT_TO_WINDOW.

Procedure PrintCustlstToWindow
    Set Report_Name To "custlst.rpt"
    Send OpenReport
    Send OutputToWindow "Sample" 0 0 500 500 0 0
    Send CloseReport
End_procedure // PrintCustlstToWindow

Last Edited: August 4, 2004


CrystalReport [Procedure PrintReportToPrinter]

PrintReportToPrinter - CrystalReport

Prints the report, identified with the sReportName parameter, to the printer

Type: Procedure

Obsolete

Parameters: String sReportName

Parameter | Description
sReportName | The name of the report to run.

Description

The PrintReportToPrinter procedure prints the report, identified with the sReportName parameter, to the printer. This procedure is obsolete; you should use the OutputToPrinter procedure instead. This procedure is supplied for compatibility with prior versions of this class.

Last Edited: August 4, 2004


CrystalReport [Procedure PrintReportToWindow]

PrintReportToWindow - CrystalReport

Type: Procedure

Obsolete

Parameters: String sReportName String sTitle Integer iLeft Integer iTop Integer iWidth Integer iHeight Integer iStyle Handle hParent

Parameter | Description
sReportName | The name of the report to run.
sTitle | The title of the window that shows the report.
iLeft | The position at which you want the left edge of the window to appear.
iTop | The position at which you want the top edge of the window to appear.
iWidth | The width of the window in pixels.
iHeight | The height of the window in pixels.
iStyle | The style of the window. See the WindowStyle property for a discussion of window styles.
hParent | Specifies the window handle for the parent window to be used for the print window.

Description

Last Edited: August 4, 2004


CrystalReport [Procedure PrintWindow]

PrintWindow - CrystalReport

Prints the report displayed in the Preview window

Type: Procedure

Parameters: No Parameters

Description

PrintWindow prints the report displayed in the Preview window. The report needs to be set up before this procedure can be called. The print job must be opened before this procedure can be called.

Object oCrystalReport is a CrystalReport
    Procedure LowLevelJobHandling
        Send OpenPrintEngine
        Send OpenPrintJob "CustRpt.rpt"
        Send OutputToWindow "Low Level" 0 0 500 500 0 0
        Send PrintWindow
        Send ClosePrintJob
        Send ClosePrintEngine
    End_Procedure // LowLevelJobHandling
End_Object // oCrystalReport

Last Edited: August 4, 2004


CrystalReport [Procedure Run_Report]

Run_Report - CrystalReport

Runs the report

Type: Procedure

Parameters: String sReportName

Parameter | Description
sReportName | The name of the report to run.

Description

Run_Report runs the report. The sReportName parameter is optional. If it is not supplied, the report stored in the Report_Name property will be used. This procedure will run the report based on the property settings which control the destination and look of a report. Internally it will call:

Send OpenReport
Send RunCrystalReport
Send CloseReport

This procedure is the preferred way to run a CrystalReport report.

Last Edited: August 4, 2004


CrystalReport [Procedure RunCrystalReport]

RunCrystalReport - CrystalReport

Runs the CrystalReport report as defined in its properties

Type: Procedure

Parameters: No Parameters

Description

RunCrystalReport runs the CrystalReport report as defined in the report object properties. This procedure is usually sent in a procedure when manipulating the properties dynamically. Usually it is in a:

Send OpenReport
Send RunCrystalReport
Send CloseReport

structured piece of code. The report will be manipulated in some way between the OpenReport and RunCrystalReport call. If there is no need to manipulate the report, you should use the Run_Report procedure, which will automatically call the three procedures mentioned above.

The hook messages OnStartPrinting and OnStopPrinting are sent from this procedure.

Last Edited: August 4, 2004


CrystalReport [Procedure SelectAndPrintWindow]

SelectAndPrintWindow - CrystalReport

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


CrystalReport [Procedure SelectAndSetFont]

SelectAndSetFont - CrystalReport

Type: Procedure

Parameters: Integer iSection Integer iScope

Parameter | Description
iSection | [ToDo: In Progress]
iScope | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


CrystalReport [Procedure SelectAndSetPrinter]

SelectAndSetPrinter - CrystalReport

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


CrystalReport [Procedure SelectPrinter]

SelectPrinter - CrystalReport

Specifies a printer other than the default printer as a print destination

Type: Procedure

Parameters: String sDriver String sPrinter String sPort String sDEVMODE

Parameter | Description
sDriver | Contains the name of the printer driver for the selected printer.
sPrinter | Contains the printer name for the selected printer.
sPort | Contains the port name for the port to which the selected printer is attached.
sDEVMODE | Specifies the pointer to the DEVMODE structure. Refer to the Windows API documentation for further information.

Description

SelectPrinter specifies a printer other than the default printer as a print destination. This procedure is used by the SelectAndSetPrinter procedure. You may use this procedure to select a printer without displaying the Windows common print dialog box.

Last Edited: September 11, 2003


CrystalReport [Procedure ShowFirstPage]

ShowFirstPage - CrystalReport

Shows the first page in the preview window

Type: Procedure

Parameters: No Parameters

Description

ShowFirstPage shows the first page in the preview window. This procedure is typically used in combination with the ParentWindowHandle and the ShowPrintControls properties. These allow you to display the CrystalReport preview window in a Visual DataFlex object. This procedure can be used to manipulate the contents of the preview window in such a setup.

Last Edited: August 4, 2004


CrystalReport [Procedure ShowLastPage]

ShowLastPage - CrystalReport

Shows the last page in the preview window

Type: Procedure

Parameters: No Parameters

Description

ShowLastPage shows the last page in the preview window. This procedure is typically used in combination with the ParentWindowHandle and the ShowPrintControls properties. These allow you to display the CrystalReport preview window in a Visual DataFlex object. This procedure can be used to manipulate the contents of the preview window in such a setup.

Last Edited: August 4, 2004


CrystalReport [Procedure ShowNextPage]

ShowNextPage - CrystalReport

Shows the next page in the preview window

Type: Procedure

Parameters: No Parameters

Description

ShowNextPage shows the next page in the preview window. This procedure is typically used in combination with the ParentWindowHandle and the ShowPrintControls properties. These allow you to display the CrystalReport preview window in a Visual DataFlex object. This procedure can be used to manipulate the contents of the preview window in such a setup.

Last Edited: August 4, 2004


CrystalReport [Procedure ShowPreviousPage]

ShowPreviousPage - CrystalReport

Shows the previous page in the preview window

Type: Procedure

Parameters: No Parameters

Description

ShowpreviousPage shows the previous page in the preview window. This procedure is typically used in combination with the ParentWindowHandle and the ShowPrintControls properties. These allow you to display the CrystalReport preview window in a Visual DataFlex object. This procedure can be used to manipulate the contents of the preview window in such a setup.

Last Edited: August 4, 2004


Properties for CrystalReport

View property list in hierarchical order

Name | Description | Defining Class
BottomMargin | Sets the bottom page margin in twips |
CCList | Contains the "CC" list for the e-mail message |
Child_Count | Returns the number of child objects the object contains | cObject
Collation | Specifies how copies of the report, when printing multiple copies, must be collated |
Copies | Specifies the number of copies you want Crystal Reports to print when printing to a printer |
CurrentDataPath | Returns the location of the current workspace's data directory |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DiscardSavedData_State | Forces the print engine to retrieve new data when the report is printed |
DisplayPageN | Returns the number of the currently displayed page |
DLLVersion | Retrieves the version number of the print engine DLL |
EngineVersion | Returns the version of the print engine |
ExportFileName | Contains the file name under which the report output is to be saved |
ExportFormatType | Specifies the format you want when printing to a file or MAPI |
FieldDelimiter | Specifies the string you want to use to separate the fields in the character-separated values format |
Formula | The name of the formula |
FunctionGeneratedError_State | Reflects whether the last call to a procedure or function generated an error |
GraphColGroupN | The group number in the report that is used to create the values in the columns of the graph |
GraphDirection | The direction of the graph |
GraphFontFaceName | Specifies the font for all text and values in the entire graph |
GraphFootNote | The footnote text that will appear under the graph |
GraphGroupsTitle | The title of the groups which are being graphed |
GraphMaxValue | The maximum value that will appear in the graph |
GraphMinValue | The minimum value that will appear in the graph |
GraphRowGroupN | The group number in the report that is used to create the values in the rows of the graph |
GraphSeriesTitle | The title of the series which is being graphed |
GraphShowDataValue | Specifies whether to display the numerical value associated with each riser on the chart |
GraphShowGridLine | Specifies whether or not to display grid lines on the graph |
GraphShowLegend | Specifies whether to display the graph legend |
GraphSubTitle | The subtitle text that will appear directly under the main title |
GraphSummarizedFieldN | The summary field in the report that is used to set the values of the risers in the graph |
GraphTitle | The main title text that will appear above the graph |
GraphType | The type used for the specified graph in the specified section |
GraphVerticalBars | Specifies whether to display the bars in a bar graph vertically or horizontally |
GraphXAxisTitle | The title text that will appear for the X axis |
GraphYAxisTitle | The title text that will appear for the Y axis |
GraphZAxisTitle | The title text that will appear for the Z axis |
GroupCondition | The condition for a given group section in the report |
GroupField | The field name for a given group section in the report |
GroupSelectionFormula | Holds the group-selection formula of the report |
GroupSortDirection | The sort direction for a given group section in the report |
HTMLFileName |  |
IsPrintJobFinished | Monitors the print job to see if it is finished or still in progress |
KeepTogether | Specifies whether or not the program is to keep all lines of the section together |
LatestPageN | Returns the number of the last page that is currently available |
LeftMargin | The left page margin in twips |
LineAscent | The line ascent for the specified section in twips |
LineHeight | The line height for the specified section in twips |
MessageText | Specifies the string you want to appear as the body of your E-mail or FAX message |
MinimumSectionHeight | The minimum section height for the specified section in twips |
Name | Returns the full name of the object including parentage | cObject
NDetailCopies | The number of copies to be printed of the Details section |
NewPageAfter | Specifies whether the program is to insert a page break after the section is printed |
NewPageBefore | Specifies whether the program is to insert a page break before the section is printed |
NFormulas | The number of formulas defined in the report |
NGroups | The number of groups in the report |
NGroupSortFields | Returns the number of group-sort fields defined in the report |
NLinesInSection | The number of lines in the specified report section |
NParams | The number of parameters used in the stored procedure of the report |
NReportCopies | Specifies the number of copies to print |
NSortFields | Returns the number of sort fields defined in the report |
NTables | The number of tables in the report |
NthFormulaName | The name of the Nth formula |
NthFormulaText | The contents of the Nth formula |
NthGroupSortFieldDirection | The number of the sort field |
NthGroupSortFieldName | The number of the sort field |
NthParam | The value of the parameter of the stored procedure |
NthSortFieldDirection | The sort direction of the Nth sort field |
NthSortFieldName | The name of the Nth sort field |
NthTableDBType | The type of the database file of interest |
NthTableDescriptiveName | The name of the database file of interest |
NthTableDLLName | The name of the appropriate database DLL for the database file of interest |
NthTableLocation | The location of a specified database file |
NumRecordsPrinted | Returns the number of records actually printed |
NumRecordsRead | Returns the number of records actually processed |
NumRecordsSelected | Returns the number of records selected for inclusion in the report out of the total number of records read |
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Output_Destination | Indicates the destination of the report |
Parent | Returns the parent of an object | cObject
ParentWindowHandle | Specifies the handle to the parent window if the Preview window is a child of that window |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
PreviewWindow_Id |  |
PrintAtBottomOfPage | Specifies whether the program is to cause each group value to print only at the bottom of a page or to have the values print in their normal positions |
PrintDate | The print date of the report |
PrintEnded | Returns whether the printing process is completed |
PrinterDriver | Obtains information about the printer driver |
PrinterName | Obtains information about the printer name |
PrinterPort | Obtains information about the printer port |
Report_Data_Path | Controls the pathnames of the tables used by the loaded report |
Report_Name | Determines if the report defined in the named file will be run when Run_Report is received |
Report_View_Id | Contains the object ID of the parent report view/panel |
ReportTitle | Holds the title string that is to appear on the title bar of the report when the report prints to a Preview window |
ResetPageNAfter | Specifies whether or not the program is to reset the page number to one (1) for the following page, after it prints a group total |
RightMargin | The right page margin in twips |
Selection_Formula | Obsolete -- provided for backward compatibility reasons. |
SelectionFormula | Holds the selection formula of the report |
ShowPrintControls | Indicates whether the print controls on the preview window are displayed |
SQLQuery | Holds the string containing the SQL query generated by the report |
StartPageN | Returns the number of the starting page |
StopPageN | The stopping page number of the report |
StringDelimiter | Specifies the character you want to use to enclose alphanumeric field data in the character-separated values format |
SubjectText | Specifies the string you want to appear as the subject line in the e-mail or FAX message |
SuppressBlankLines | Specifies whether the program is to eliminate lines from your report that are blank due to fields being suppressed |
ToList | Contains the To list to which you want your e-mail message directed |
TopMargin | The top page margin in twips |
UseReportDateFormat_State | Indicates whether the program should save dates in the same format (MDY, DMY, etc.) that you used in the report |
UseReportNumberFormat_State | Indicates whether the program should save numbers in the same format (decimal places, negatives, etc.) that you have used in the report |
Visible | Specifies whether the selected section is to be visible |
WindowHandle | Returns the Preview window handle |
WindowHeight | Specifies the height of the Preview window, in twips |
WindowLeftCoordinate | Specifies the x coordinate of the upper left corner of the Preview window, in twips |
WindowStyle | Specifies the style of the window being created |
WindowTitle | Contains the title you want to appear in the Preview window title bar when printing to a preview window |
WindowTopCoordinate | Specifies the y coordinate of the upper left corner of the Preview window, in twips |
WindowWidth | Specifies the width of the Preview window, in twips |
ZoomPreviewWindow | Sets the magnification level |


CrystalReport [Property BottomMargin]

BottomMargin - CrystalReport

Sets the bottom page margin in twips

Type: Property

Access: Read/Write

Data Type: Integer

Description

BottomMargin sets the bottom page margin, in twips. A twip is 1/1440th of an inch, or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200.

Last Edited: July 30, 2003


CrystalReport [Property CCList]

CCList - CrystalReport

Contains the "CC" list for the e-mail message

Type: Property

Access: Read/Write

Data Type: String

Description

The CCList contains the "CC" list for the e-mail message. Multiple addresses should be separated by a semicolon. You may supply a FAX number with this property using the FAX: prefix. Refer to the Microsoft Win32 SDK for further details and a complete list of possible address types. If you supply a FAX address here, be sure that you choose a format type that is supported by your software. That means that you must have an associated program for the format type you select.

The following sample will only work if you have Word for Windows installed on your machine.

Object oCustomerReport is a CrystalReport
    Set Report_Name To "CustRpt.rpt"
    Set Output_Destination To CRW_PRINT_TO_MAPI
    Set ExportFormatType   To CRW_WordWinType
    Set ToList To "FAX:099-33445566"
    Set CCList To "somebody@somewhere.com"
    Set ExportFileName To "CustRpt.doc"
    Set SubjectText To "Customer list"
    Set MessageText To "This is our latest customer list"

    Send Run_Report
End_Object // oCustomerReport

Last Edited: August 4, 2004


CrystalReport [Property Collation]

Collation - CrystalReport

Specifies how copies of the report, when printing multiple copies, must be collated

Type: Property

Access: Read/Write

Data Type: Integer

Description

Collation specifies how copies of the report, when printing multiple copies, must be collated. Use this property together with the NReportCopies property. Possible values are:

Constant | Meaning
PE_UNCOLLATED | Prints multiple copies of a multi-page report uncollated (Page order = 1,1,1, 2,2,2, 3,3,3, etc.)
PE_COLLATED | Prints multiple copies of a multi-page report collated (Page order = 1,2,3 ,... 1,2,3 ,... etc.)
PE_DEFAULTCOLLATION | Prints multiple copies of a multi-page report using the collation settings as specified in the report definition

Last Edited: July 30, 2003


CrystalReport [Property Copies]

Copies - CrystalReport

Specifies the number of copies you want Crystal Reports to print when printing to a printer

Type: Property

Access: Read/Write

Data Type: Integer

Description

With the Copies property, you can specify the number of copies you want Crystal Reports to print when printing to a printer.

The code to set up Crystal Reports so it prints 5 times to the printer, would be:

Object oCustomerReport is a CrystalReport
    Set Report_Name To "CustRpt.rpt"
    Set Output_Destination To CRW_PRINT_TO_PRINTER
    Set Copies To 5
End_Object  // oCustomerReport

Last Edited: August 4, 2004


CrystalReport [Property CurrentDataPath]

CurrentDataPath - CrystalReport

Returns the location of the current workspace's data directory

Type: Property

Access: Read-Only

Data Type: String

Description

The CurrentDataPath returns the location of the current workspace's data directory. Normally this is the directory that will contain your Crystal Reports report definition and your data. When creating a Crystal Reports report, we make the following recommendations:

  • Use Runtime Workspaces. This is the default behavior for a Studio-created VDF program.
  • Place your Crystal Report reports in the workspace's Data directory (e.g., \VDF\Orders\Data).
  • When you create your Crystal Report reports, specify the locations of your tables to be the Same as Report. This option is set from the Database, Set Location. menu choice. This instructs Crystal Reports to look for the tables in the same directory as the Crystal Reports report definition.

If the above steps are followed, VDF will locate reports and tables automatically.

This property is not needed to locate report definitions or tables (as noted above, this is automatic). This property can be useful when manually searching for report-definition files. The following example will load an open-file dialog. By default, it will look for .RPT files located in the workspace's Data directory.

Procedure Start_Prompt
    Boolean bSelected
    String sSelectedFile sDataFolder

    Get CurrentDataPath of oReport to sDataFolder
    // create a save as dialog
    Object oNewDialog is an Opendialog
        // set up title
        Set Dialog_Caption To "Select Crystal Reports report"
        Set Filter_String To "CrystalReport (*.rpt)|*.rpt|All Files|*.*"
        Set HideReadOnly_State To True
        Set ShowFileTitle_State To True
        Set Initial_Folder to sDataFolder
    End_Object // oNewDialog

    // start the save-as dialog
    Get Show_Dialog Of oNewDialog To bSelected
    If (bSelected) Begin
        Get File_Name Of oNewDialog To SelectedFile
        Set Value 0 To SelectedFile
    End

    //*** Destroy the save-as dialog
    Send Request_Destroy_Object of oNewDialog
End_Procedure // Start_Prompt

If your program is not using a runtime workspace, a blank value will be returned. If your program has set the ReportDir registry data value, that value will be returned. Both of these techniques are now obsolete and should not be used.

Last Edited: December 16, 2004


CrystalReport [Property DiscardSavedData_State]

DiscardSavedData_State - CrystalReport

Forces the print engine to retrieve new data when the report is printed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The DiscardSavedData_State property may be used to force the print engine to retrieve new data when the report is printed. If no data has been saved with the report, this property has no effect.

The following sample code sets the object so that it will use saved data with the report.

Object oCustomerReport is a CrystalReport
    Set Report_Name        To "CustRpt.rpt"
    Set DiscardSavedData_State To False
End_Object  // oCustomerReport

Last Edited: August 4, 2004


CrystalReport [Property DisplayPageN]

DisplayPageN - CrystalReport

Returns the number of the currently displayed page

Type: Property

Access: Read-Only

Data Type: Integer

Description

The DisplayPageN property returns the number of the currently displayed page.

Last Edited: July 31, 2003


CrystalReport [Property DLLVersion]

DLLVersion - CrystalReport

Retrieves the version number of the print engine DLL

Type: Property

Access: Read-Only

Data Type: Number

Description

The DLLVersion property may be used to retrieve the version number of the print engine DLL. This property can be handy as a safeguard for users who have more than one version of the print engine installed on their computer.

Last Edited: July 31, 2003


CrystalReport [Property EngineVersion]

EngineVersion - CrystalReport

Returns the version of the print engine

Type: Property

Access: Read-Only

Data Type: Number

Description

The EngineVersion property returns the version of the print engine.

Last Edited: August 5, 2003


CrystalReport [Property ExportFileName]

ExportFileName - CrystalReport

Contains the file name under which the report output is to be saved

Type: Property

Access: Read/Write

Data Type: String

Description

The ExportFileName property contains the file name under which the report output is to be saved. The following code will set up the object to export to Word format.

Object oCustomerReport is a CrystalReport
    Set Report_Name To "CustRpt.rpt"
    Set Output_Destination To CRW_PRINT_TO_FILE
    Set ExportFileName To "CustRpt.doc"
    Set ExportFormatType To CRW_WordWinType
End_Object // oCustomerReport

Last Edited: August 4, 2004


CrystalReport [Property ExportFormatType]

ExportFormatType - CrystalReport

Specifies the format you want when printing to a file or MAPI

Type: Property

Access: Read/Write

Data Type: Integer

Description

The ExportFormatType property specifies the format you want when printing to a file or MAPI. You may select a type from the table below:

Constant | Meaning
CRW_CrystalReportType | CrystalReport format.
CRW_DIFType | Data Interchange format, you may secify whether the program should save numbers and dates in the same format (decimal places, negatives, MDY, DMY, etc.) that you have used in the report by setting the UseReportNumberFormat_State and UseReportDateFormat_State properties.
CRW_WordWinType | Word for Windows type. Using this format type requires that you set Output_Destination to CRW_Print_To_File and ExportFileName to a valid Microsoft Word file name.
CRW_AcrobatType | Adobe Portable Document Format (PDF) type. Using this format type requires that you set Output_Destination to CRW_Print_To_File and ExportFileName to a valid PDF file name.
CRW_RecordType | Record style (column of values).
CRW_RichTextFormatType | Rich text format (RTF) file type.
CRW_CommaSeparatedType | Comma-separated. You may secify whether or not the program should save numbers and dates in the same format decimal places, negatives, MDY, DMY, etc.) that you have used in the report by setting the UseReportNumberFormat_State and UseReportDateFormat_State properties.
CRW_TabSeparatedType | Tab-separated. You may specify whether the program should save numbers and dates in the same format (decimal places, negatives, MDY, DMY, etc.) that you have used in the report by setting the UseReportNumberFormat_State and UseReportDateFormat_State properties.
CRW_CharSeparatedType | Character-delimited. You may specify whether the program should save numbers and dates in the same format decimal places, negatives, MDY, DMY, etc.) that you have used in the report by setting the UseReportNumberFormat_State and UseReportDateFormat_State properties. You may also specify the field and string delimiters by setting the FieldDelimiter and StringDelimiter properties.
CRW_TextType | Text (ASCII).
CRW_TabbedTextType | Tab-separated text.
CRW_LotusWksType | Lotus 1-2-3 (WKS)
CRW_LotusWk1Type | Lotus 1-2-3 (WK1)
CRW_LotusWk2Type | Lotus 1-2-3 (WK2)
CRW_Xls2Type | Excel 2.1
CRW_Xls3Type | Excel 3.0
CRW_Xls4Type | Excel 4.0
CRW_Xls5Type | Excel 5.0

The default export format is set to CRW_CrystalReportType.

The following code will set up the object to export to Word format.

Object oCustomerReport is a CrystalReport
    Set Report_Name To "CustRpt.rpt"
    Set Output_Destination To CRW_PRINT_TO_FILE
    Set ExportFileName To "CustRpt.doc"
    Set ExportFormatType To CRW_WordWinType
End_Object // oCustomerReport

The following code will set up the object to export to PDF format.

Object oCustomerReport is a CrystalReport
    Set Report_Name To "CustRpt.rpt"
    Set Output_Destination To CRW_PRINT_TO_FILE
    Set ExportFileName To "CustRpt.pdf"
    Set ExportFormatType To CRW_AcrobatType
End_Object // oCustomerReport

Last Edited: August 4, 2004


CrystalReport [Property FieldDelimiter]

FieldDelimiter - CrystalReport

Specifies the string you want to use to separate the fields in the character-separated values format

Type: Property

Access: Read/Write

Data Type: String

Description

The FieldDelimiler specifies the string you want to use to separate the fields in the character-separated values format. Your string may be up to 16 characters long; if you supply more than 16 characters, only the first 16 are used as a field delimiter. All other characters are ignored.

Default value is ";" (semicolon).

See Also

ExportFormatType

Last Edited: August 18, 2003


CrystalReport [Property Formula]

Formula - CrystalReport

The name of the formula

Type: Property

Access: Read/Write

Data Type: String

Parameters: String sFormulaName String sFormulaText

Parameter | Description
sFormulaName | The Formula Name
sFormulaText | The Formula string

Description

The Formula property is the name of the formula.

You can manipulate the contents of an existing formula in the report by this property. The formula is identified by its name. In Crystal Reports, formula names have a prefix of @. You do not need to supply this prefix when identifying the formula in this object.

Procedure AdjustSeltxtFormula String sSelection
    If (sSelection = "") ;
        Set Formula "SelTxt" To ('"' +"NONE" +'"')
    Else ;
        Set Formula "SelTxt" To ('"' +(Replaces('"', sSelection, "")) +'"')
End_Procedure // AdjustSeltxtFormula

Last Edited: August 4, 2004


CrystalReport [Property FunctionGeneratedError_State]

FunctionGeneratedError_State - CrystalReport

Reflects whether the last call to a procedure or function generated an error

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The FunctionGeneratedError_State property reflects whether the last call to a procedure or function generated an error. This property may be used to decide if a process should continue after an essential call to a procedure or function.

Object oCustomerReport is a CrystalReport
    Set Report_Name To "CustRpt.rpt"
    Set Output_Destination To CRW_PRINT_TO_PRINTER

    Procedure PrintTheReport
        Integer iAnswer

        Repeat
            Send RunReport
            If (FunctionGeneratedError_State(Self)) ;
                Get YesNo_Box "Something went wrong. Try again?" To iAnswer
            Else ;
                Move MBR_NO To iAnswer
        Until (iAnswer = MBR_NO)
    End_procedure // PrintTheReport

End_Object // oCustomerReport

Send PrintTheReport of oCustomerReport

Last Edited: August 4, 2004


CrystalReport [Property GraphColGroupN]

GraphColGroupN - CrystalReport

The group number in the report that is used to create the values in the columns of the graph

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iGraphN Integer iColGroupN

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section.

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered first from top to bottom, then from left to right if they have the same top.
iColGroupN | The group number in the report that is used to create the values in the columns of the graph

Description

The GraphColGroupN property is the group number in the report that is used to create the values in the columns of the graph.

Last Edited: August 4, 2004


CrystalReport [Property GraphDirection]

GraphDirection - CrystalReport

The direction of the graph

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iGraphN Integer iDirection

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections.
PE_HEADERSECTION | The Page-Header section.
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section.
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section.
PE_FOOTERSECTION | The Page-Footer section.

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
iDirection | The direction of the graph

Description

The GraphDirection property is the direction of the graph. For normal group/total report, the direction, is always PE_GRAPH_COLS_ONLY. For cross-tab reports, any of the following constant values can be used:

Constant | Meaning
PE_GRAPH_ROWS_ONLY | Use only row values in graph.
PE_GRAPH_COLS_ONLY | Use only column values in graph.
PE_GRAPH_MIXED_ROW_COL | Graph by row values, then by column values.
PE_GRAPH_MIXED_COL_ROW | Graph by column values, then by row values.
PE_GRAPH_UNKNOWN_DIRECTION | The direction of the graph is unknown.

Last Edited: August 4, 2004


CrystalReport [Property GraphFontFaceName]

GraphFontFaceName - CrystalReport

Specifies the font for all text and values in the entire graph

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iSectionCode Integer iGraphN String sFontFaceName

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
sFontFaceName | Specifies the font for all text and values in the entire graph

Description

The GraphFontFaceName property specifies the font for all text and values in the entire graph.

Last Edited: August 4, 2004


CrystalReport [Property GraphFootNote]

GraphFootNote - CrystalReport

The footnote text that will appear under the graph

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iSectionCode Integer iGraphN String sFootNote

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
sFootNote | The footnote text that will appear under the graph

Description

The GraphFootNote property is the footnote text that will appear under the graph.

Last Edited: August 4, 2004


CrystalReport [Property GraphGroupsTitle]

GraphGroupsTitle - CrystalReport

The title of the groups which are being graphed

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iSectionCode Integer iGraphN String sGroupsTitle

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
sGroupsTitle | The title of the groups which are being graphed

Description

The GraphGroupsTitile property is the title of the groups which are being graphed.

Last Edited: August 4, 2004


CrystalReport [Property GraphMaxValue]

GraphMaxValue - CrystalReport

The maximum value that will appear in the graph

Type: Property

Access: Read/Write

Data Type: Real

Parameters: Integer iSectionCode Integer iGraphN Real rMaxValue

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
rMaxValue | The maximum value that will appear in the graph. Any graph values above this value are not charted

Description

The GraphMaxValue property is the maximum value that will appear in the graph. Any graph values above this value are not charted.

Last Edited: August 4, 2004


CrystalReport [Property GraphMinValue]

GraphMinValue - CrystalReport

The minimum value that will appear in the graph

Type: Property

Access: Read/Write

Data Type: Real

Parameters: Integer iSectionCode Integer iGraphN Real rMinValue

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
rMinValue | The minimum value that will appear in the graph. Any graph values below this value are not charted.

Description

The GraphMinValue property is the minimum value that will appear in the graph. Any graph values below this value are not charted.

Last Edited: August 4, 2004


CrystalReport [Property GraphRowGroupN]

GraphRowGroupN - CrystalReport

The group number in the report that is used to create the values in the rows of the graph

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iGraphN Integer iRowGroupN

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
iRowGroupN | The group number in the report that is used to create the values in the rows of the graph.

Description

The GraphRowGroupN property is the group number in the report that is used to create the values in the rows of the graph.

Last Edited: August 4, 2004


CrystalReport [Property GraphSeriesTitle]

GraphSeriesTitle - CrystalReport

The title of the series which is being graphed

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iSectionCode Integer iGraphN String sSeriesTitle

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
sSeriesTitle | The title of the series which is being graphed

Description

The GraphSeriesTitle property is the title of the series which is being graphed.

Last Edited: August 4, 2004


CrystalReport [Property GraphShowDataValue]

GraphShowDataValue - CrystalReport

Specifies whether to display the numerical value associated with each riser on the chart

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iGraphN Integer iShowDataValue

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group ooter can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
iShowDataValue | Specifies whether to display the numerical value associated with each riser on the chart. If set to TRUE (1), a value appears in the graph for each riser.

Description

The GraphShowDataValue property specifies whether to display the numerical value associated with each riser on the chart. If set to TRUE (1), a value appears in the graph for each riser.

Last Edited: August 4, 2004


CrystalReport [Property GraphShowGridLine]

GraphShowGridLine - CrystalReport

Specifies whether or not to display grid lines on the graph

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iGraphN Integer iShowGridLine

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
iShowGridLine | Specifies whether or not to display grid lines on the graph.

Description

The GraphShowGridLine property specifies whether or not to display grid lines on the graph.

Last Edited: August 4, 2004


CrystalReport [Property GraphShowLegend]

GraphShowLegend - CrystalReport

Specifies whether to display the graph legend

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iGraphN Integer iShowLegend

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
iShowLegend | Specifies whether to display the graph legend.

Description

The GraphShowLegend property specifies whether to display the graph legend.

Last Edited: August 4, 2004


CrystalReport [Property GraphSubTitle]

GraphSubTitle - CrystalReport

The subtitle text that will appear directly under the main title

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iSectionCode Integer iGraphN String sSubTitle

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
sSubTitle | The subtitle text that will appear directly under the main title.

Description

The GraphSubTitle property is the subtitle text that will appear directly under the main title.

Last Edited: August 4, 2004


CrystalReport [Property GraphSummarizedFieldN]

GraphSummarizedFieldN - CrystalReport

The summary field in the report that is used to set the values of the risers in the graph

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iGraphN Integer iSummarizedFieldN

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
iSummarizedFieldN | The summary field in the report that is used to set the values of the risers in the graph. Summary fields are numbered in order of their creation.

Description

The GraphSummarizedFieldN property is the summary field in the report that is used to set the values of the risers in the graph. Summary fields are numbered in order of their creation.

Last Edited: August 4, 2004


CrystalReport [Property GraphTitle]

GraphTitle - CrystalReport

The main title text that will appear above the graph

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iSectionCode Integer iGraphN String sTitle

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section.
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section.
PE_FOOTERSECTION | The Page-Footer section.

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
sTitle | The main title text that will appear above the graph.

Description

The GraphTitle property is the main title text that will appear above the graph.

Last Edited: August 4, 2004


CrystalReport [Property GraphType]

GraphType - CrystalReport

The type used for the specified graph in the specified section

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iGraphN Integer iGraphType

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
iGraphType | The type of specified graph in the section

Description

The GraphType property is the type used for the specified graph in the specified section. Types can be:

Constant | Meaning
PE_SIDE_BY_SIDE_BAR_GRAPH | Side-by-Side bar graph
PE_STACKED_BAR_GRAPH | Stacked bar graph
PE_PERCENT_BAR_GRAPH | Percent bar graph
PE_FAKED_3D_SIDE_BY_SIDE_BAR_GRAPH | 3-D Side-by-Side bar graph
PE_FAKED_3D_STACKED_BAR_GRAPH | 3-D Stacked bar graph
PE_FAKED_3D_PERCENT_BAR_GRAPH | 3-D Percent bar graph
PE_PIE_GRAPH | Pie graph
PE_MULTIPLE_PIE_GRAPH | Multiple Pie graph
PE_PROPORTIONAL_MULTI_PIE_GRAPH | Weighted Pie graph
PE_LINE_GRAPH | Line graph
PE_AREA_GRAPH | Area graph
PE_THREED_BAR_GRAPH | 3-D bar graph
PE_USER_DEFINED_GRAPH | User-Defined graph type
PE_UNKNOWN_TYPE_GRAPH | Unknown graph type

Last Edited: August 4, 2004


CrystalReport [Property GraphVerticalBars]

GraphVerticalBars - CrystalReport

Specifies whether to display the bars in a bar graph vertically or horizontally

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iGraphN Integer iVerticalBars

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
iVerticalBars | Specifies whether to display the bars in a bar graph vertically or horizontally.

Description

The GraphVerticalBars property specifies whether to display the bars in a bar graph vertically or horizontally.

Last Edited: August 4, 2004


CrystalReport [Property GraphXAxisTitle]

GraphXAxisTitle - CrystalReport

The title text that will appear for the X axis

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iSectionCode Integer iGraphN String sXAxisTitle

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
sXAxisTitle | The title text that will appear for the X axis. Not valid for Pie graphs.

Description

The GraphXAxisTitle property is the title text that will appear for the X axis. It is not valid for Pie graphs.

Last Edited: August 4, 2004


CrystalReport [Property GraphYAxisTitle]

GraphYAxisTitle - CrystalReport

The title text that will appear for the Y axis

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iSectionCode Integer iGraphN String sYAxisTitle

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | [Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
sYAxisTitle | The title text that will appear for the Y axis. Not valid for Pie graphs.

Description

The GraphYAxisTitle property is the title text that will appear for the Y axis. It is not valid for Pie graphs.

Last Edited: August 4, 2004


CrystalReport [Property GraphZAxisTitle]

GraphZAxisTitle - CrystalReport

The title text that will appear for the Z axis

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iSectionCode Integer iGraphN String sZAxisTitle

Parameter | Description
iSectionCodeThe section identifier. Section identifiers can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iGraphN | Specifies which graph within the section you are changing. This value is 0-indexed. Within a section, graphs are numbered from top to bottom, first, then from left to right if they have the same top.
sZAxisTitle | The title text that will appear for the Z axis. This value is only valid for 3-D graphs.

Description

The GraphZAxisTitle property is the title text that will appear for the Z axis. This value is only valid for 3-D graphs.

Last Edited: August 4, 2004


CrystalReport [Property GroupCondition]

GroupCondition - CrystalReport

The condition for a given group section in the report

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iCondition

Parameter | Description
iSectionCodeThe section identifier. iSectionCode must be:

Constant | Meaning
PE_GROUPHEADER | The Group-Header section. There can be multiple group header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.

iCondition | The condition for a given group section in the report.

Description

The GroupCondition property is the condition for a given group section in the report.

Last Edited: August 18, 2003


CrystalReport [Property GroupField]

GroupField - CrystalReport

The field name for a given group section in the report

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iSectionCode String sField

Parameter | Description
iSectionCodeThe section identifier. iSectionCode must be:

Constant | Meaning
PE_GROUPHEADER | The Group-Header section. There can be multiple group header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.

sField | The field name for a given group section in the report.

Description

The GroupField property is the field name for a given group section in the report.

Last Edited: August 18, 2003


CrystalReport [Property GroupSelectionFormula]

GroupSelectionFormula - CrystalReport

Holds the group-selection formula of the report

Type: Property

Access: Read/Write

Data Type: String

Description

The GroupSelectionFormula property holds the group-selection formula of the report. You can use this property to overwrite or expand existing selections.

Procedure OnStartPrinting
    String sStartCust sEndCust sSelection

    // setup the selection formula
    Move "" To sSelection
    Get StartCustomer To sStartCust
    Get EndCustomer To sEndCust

    If (Trim(sStartCust) <> "") ;
        Append Selection "{Customer.Name} >=" '"' (Trim(sStartCust)) '"'
    If (Trim(sEndCust) <> "") ;
        Append Selection (If(Selection <> "", " and ", "")) ;
            "{Customer.Name} <=" '"' (Trim(sEndCust)) '"'

    Set GroupSelectionFormula To sSelection
End_Procedure // OnStartPrinting

Last Edited: August 4, 2004


CrystalReport [Property GroupSortDirection]

GroupSortDirection - CrystalReport

The sort direction for a given group section in the report

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iSortDirection

Parameter | Description
iSectionCodeThe section identifier. iSectionCode must be:

Constant | Meaning
PE_GROUPHEADER | The Group-Header section. There can be multiple group header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.

iSortDirection | The sort direction for a given group section in the report.

Description

The GroupSortDirection property is the sort direction for a given group section in the report.

Last Edited: August 18, 2003


CrystalReport [Property HTMLFileName]

HTMLFileName - CrystalReport

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


CrystalReport [Property IsPrintJobFinished]

IsPrintJobFinished - CrystalReport

Monitors the print job to see if it is finished or still in progress

Type: Property

Access: Read-Only

Data Type: Integer

Description

The IsPrintJobFinished property monitors the print job to see if it is finished or still in progress. You can use this property any time you have a call that is sensitive to whether a print job has been finished.

Last Edited: August 18, 2003


CrystalReport [Property KeepTogether]

KeepTogether - CrystalReport

Specifies whether or not the program is to keep all lines of the section together

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iKeepTogether

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iKeepTogether | Specifies whether or not the program is to keep all lines of the section together, either on the current page (if there is room) or on the next (if not).

Description

The KeepTogether property specifies whether or not the program is to keep all lines of the section together, either on the current page (if there is room) or on the next (if not).

Last Edited: August 4, 2004


CrystalReport [Property LatestPageN]

LatestPageN - CrystalReport

Returns the number of the last page that is currently available

Type: Property

Access: Read-Only

Data Type: Integer

Description

LatestPageN returns the number of the last page that is currently available. Once printing is complete, this value is the number of the last page.

Last Edited: August 18, 2003


CrystalReport [Property LeftMargin]

LeftMargin - CrystalReport

The left page margin in twips

Type: Property

Access: Read/Write

Data Type: Integer

Description

LeftMargin contains the left page margin in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200.

Last Edited: August 18, 2003


CrystalReport [Property LineAscent]

LineAscent - CrystalReport

The line ascent for the specified section in twips

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iLineN Integer iAscent

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iLineN | The line ascent for the specified section in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200. This is typically used when printing to preprinted forms.
iAscent | Ascent is the distance from the top of the allotted line space (line height) to the baseline of the font. The ascent parameter is used to specify the position of the baseline if you specify an oversized or undersized line height. If you set ascent to 0, the program puts the baseline at the top of the space; if you set ascent to the same value as height, the program sets

Description

LineAscent contains the line ascent for the specified section in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200. This is typically used when printing to preprinted forms.

Ascent is the distance from the top of the allotted line space (line height) to the baseline of the font. The ascent parameter is used to specify the position of the baseline if you specify an oversized or undersized line height. If you set ascent to 0, the program puts the baseline at the top of the space; if you set ascent to the same value as height, the program sets the baseline at the bottom of the space. For any other baseline, specify the ascent in twips.

Last Edited: August 4, 2004


CrystalReport [Property LineHeight]

LineHeight - CrystalReport

The line height for the specified section in twips

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iLineN Integer iHeight

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iLineN | The line number
iHeight | The line height for the specified section in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200. This is typically used when printing to preprinted forms.

Description

LineHeight contains the line height for the specified section in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200. This is typically used when printing to preprinted forms.

Last Edited: August 4, 2004


CrystalReport [Property MessageText]

MessageText - CrystalReport

Specifies the string you want to appear as the body of your E-mail or FAX message

Type: Property

Access: Read/Write

Data Type: String

Description

MessageText specifies the string you want to appear as the body of your E-mail or FAX message.

The following sample will only work if you have Word for Windows installed on your machine.

Object oCustomerReport is a CrystalReport
    Set Report_Name To "CustRpt.rpt"
    Set Output_Destination To CRW_PRINT_TO_MAPI
    Set ExportFormatType To CRW_WordWinType
    Set ToList To "FAX:099-33445566"
    Set ExportFileName To "CustRpt.doc"
    Set SubjectText To "Customer list"
    Set MessageText To "This is our latest customer list"

    Send Run_Report
End_Object // oCustomerReport

Last Edited: August 4, 2004


CrystalReport [Property MinimumSectionHeight]

MinimumSectionHeight - CrystalReport

The minimum section height for the specified section in twips

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iMimimumHeight

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iMimimumHeight | The minimum section height for the specified section in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200. This is typically used when printing to preprinted forms.

Description

The MinimumSectionHeight contains the minimum section height for the specified section in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200. This is typically used when printing to preprinted forms.

Last Edited: August 18, 2003


CrystalReport [Property NDetailCopies]

NDetailCopies - CrystalReport

The number of copies to be printed of the Details section

Type: Property

Access: Read/Write

Data Type: Integer

Description

NDetailCopies is the number of copies to be printed of the Details section. You can use this property to print multiple copies of labels for a customer, multiple copies of a purchase order, or multiple copies of anything set up in the Details section of your report.

Last Edited: September 10, 2003


CrystalReport [Property NewPageAfter]

NewPageAfter - CrystalReport

Specifies whether the program is to insert a page break after the section is printed

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iNewPageAfter

Parameter | Description
iSectionCodeThe section identifier. ISectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iNewPageAfter | Specifies whether the program is to insert a page break after the section is printed.

Description

NewPageAfter specifies whether the program is to insert a page break after the section is printed.

Last Edited: September 10, 2003


CrystalReport [Property NewPageBefore]

NewPageBefore - CrystalReport

Specifies whether the program is to insert a page break before the section is printed

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iNewPageBefore

Parameter | Description
iSectionCodeThe section identifier. ISectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iNewPageBefore | Specifies whether the program is to insert a page break before the section is printed.

Description

NewPageBefore specifies whether the program is to insert a page break before the section is printed.

Last Edited: September 10, 2003


CrystalReport [Property NFormulas]

NFormulas - CrystalReport

The number of formulas defined in the report

Type: Property

Access: Read-Only

Data Type: Integer

Description

NFormulas is the number of formulas defined in the report.

Procedure ReadReport
    String sCurFormName sCurFormContents
    Integer iNumFormulas iCount

    // set up report name
    Set Report_Name To "CustRpt.rpt"
    Send OpenReport

    // show formulas
    Get NFormulas To iNumFormulas
    For iCount From 0 To (NumFormulas  1)
        Get NthFormulaName iCount To sCurFormName
        Get NthFormulaText iCount To sCurFormContents
        Showln "formula " iCount ": " sCurFormName " = " sCurFormContents
    Loop

    // close the report
    Send CloseReport
End_Procedure // ReadReport

Last Edited: August 4, 2004


CrystalReport [Property NGroups]

NGroups - CrystalReport

The number of groups in the report

Type: Property

Access: Read-Only

Data Type: Integer

Description

NGroups is the number of groups in the report.

Last Edited: September 10, 2003


CrystalReport [Property NGroupSortFields]

NGroupSortFields - CrystalReport

Returns the number of group-sort fields defined in the report

Type: Property

Access: Read-Only

Data Type: Integer

Description

The NGroupSortFields property returns the number of group-sort fields defined in the report.

Procedure OnStartPrinting
    Integer iNumSortFields iCurSortField

    //*** Delete old sort order
    Get NGroupSortFields To iNumSortFields
    For iCurSortField From 0 To (iNumSortFields-1)
        Send DeleteNthSortField 0
    Loop

    //*** Set up new sort order
    Send AddGroupSortField "{Customer.Name}" PE_SF_ASCENDING
End_Procedure // OnStartPrinting

Last Edited: August 4, 2004


CrystalReport [Property NLinesInSection]

NLinesInSection - CrystalReport

The number of lines in the specified report section

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iSectionCode Integer iValue

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iValue | The lines in the specified section

Description

NLinesInSection is the number of lines in the specified report section. This property can also be used to ascertain whether a given section exists. A section exists if the number of lines in that section is greater than 0 (zero).

Last Edited: September 10, 2003


CrystalReport [Property NParams]

NParams - CrystalReport

The number of parameters used in the stored procedure of the report

Type: Property

Access: Read-Only

Data Type: Integer

Description

NParams is the number of parameters used in the stored procedure of the report.

Last Edited: September 10, 2003


CrystalReport [Property NReportCopies]

NReportCopies - CrystalReport

Specifies the number of copies to print

Type: Property

Access: Read/Write

Data Type: Integer

Description

NReportCopies specifies the number of copies to print. Use this property together with the Collate property to define the order in which the reports are printed.

Last Edited: September 10, 2003


CrystalReport [Property NSortFields]

NSortFields - CrystalReport

Returns the number of sort fields defined in the report

Type: Property

Access: Read-Only

Data Type: Integer

Description

The NSortFields property returns the number of sort fields defined in the report.

Procedure OnStartPrinting
    Integer iNumSortFields iCurSortField

    //*** Delete old sort order
    Get NSortFields To iNumSortFields
    For iCurSortField From 0 To (iNumSortFields-1)
        Send DeleteNthSortField 0
    Loop

    //*** Set up new sort order
    Send AddSortField "{Customer.Name}" PE_SF_ASCENDING
End_Procedure // OnStartPrinting

Last Edited: August 4, 2004


CrystalReport [Property NTables]

NTables - CrystalReport

The number of tables in the report

Type: Property

Access: Read-Only

Data Type: Integer

Description

NTables is the number of tables in the report.

Last Edited: September 10, 2003


CrystalReport [Property NthFormulaName]

NthFormulaName - CrystalReport

The name of the Nth formula

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iFormulaN String sValue

Parameter | Description
iFormulaN | The number of the formula
sValue | The formula name

Description

NthFormulaName is the name of the Nth formula. Formulas can be accessed by number and this numbering is zero-based. Thus, the first formula has number 0 (zero).

Procedure ReadReport
    String sCurFormName sCurFormContents
    Integer iNumFormulas iCount

    // set up report name
    Set Report_Name To "CustRpt.rpt"
    Send OpenReport

    // show formulas
    Get NFormulas To iNumFormulas
    For iCount From 0 To (NumFormulas  1)
        Get NthFormulaName iCount To sCurFormName
        Get NthFormulaText iCount To sCurFormContents
        Showln "formula " iCount ": " sCurFormName " = " sCurFormContents
    Loop

    // close the report
    Send CloseReport
End_Procedure // ReadReport

Last Edited: August 4, 2004


CrystalReport [Property NthFormulaText]

NthFormulaText - CrystalReport

The contents of the Nth formula

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iFormulaN String sValue

Parameter | Description
iFormulaN | The number of the formula
sValue | The formula text

Description

NthFormulaText is the contents of the Nth formula. Formulas can be accessed by number and this numbering is zero-based. Thus, the first formula has number 0 (zero).

Procedure ReadReport
    String sCurFormName sCurFormContents
    Integer iNumFormulas iCount

    // set up report name
    Set Report_Name To "CustRpt.rpt"
    Send OpenReport

    // show formulas
    Get NFormulas To iNumFormulas
    For iCount From 0 To (NumFormulas  1)
        Get NthFormulaName iCount To sCurFormName
        Get NthFormulaText iCount To sCurFormContents
        Showln "formula " iCount ": " sCurFormName " = " sCurFormContents
    Loop

    // close the report
    Send CloseReport
End_Procedure // ReadReport

Last Edited: August 4, 2004


CrystalReport [Property NthGroupSortFieldDirection]

NthGroupSortFieldDirection - CrystalReport

The number of the sort field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSortFieldN Integer iDirection

Parameter | Description
iSortFieldN | The number of the sort field
iDirection | The sort direction of the Nth-group sort field. Sort fields are accessed by number and this numbering is zero-based.

Description

NthGroupSortFieldDirection is the number of the sort field.

The sort direction of the Nth-group sort field. Sort fields are accessed by number and this numbering is zero-based. Thus, the first sort field has number 0 (zero). Sort direction can be either PE_SF_ASCENDING or PE_SF_DESCENDING. You can set the direction of a sort field by setting this property. Normally this would be done in the AddSortField procedure.

Procedure ReadReport
    String sCurSortField
    Integer iCurSortDirection iNumSortFields iCount

    Set Report_Name To "CustRpt.rpt"
    Send OpenReport
    Get NGroupSortFields To iNumSortFields
    For Count From 0 To (iNumSortFields -1)
        Get NthGroupSortFieldName iCount To sCurSortField
        Get NthGroupSortFieldDirection iCount To iCurSortDirection
        if (iCurSortDirection=PE_SF_ASCENDING) ;
            send Info_Box ("Group sort direction for field "+string(iCount)+": "+sCurSortField) "Ascending"
        else if (iCurSortDirection=PE_SF_DESCENDING) ;
            send Info_Box ("Group sort direction for field "+string(iCount)+": "+sCurSortField) "Descending"
    Loop
    Send CloseReport
End_Procedure // ReadReport

See Also

Info_Box

Last Edited: November 23, 2004


CrystalReport [Property NthGroupSortFieldName]

NthGroupSortFieldName - CrystalReport

The number of the sort field

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iSortFieldN String sName

Parameter | Description
iSortFieldN | The number of the sort field
sName | The name of the Nth-group sort field. Sort fields are accessed by number and this numbering is zero-based

Description

The NthGroupSortFieldName is the number of the sort field.

The name of the Nth-group sort field. Sort fields are accessed by number and this numbering is zero-based. Thus, the first sort field has number 0 (zero). You can set the name of a sort field by setting this property. Normally this would be done in the AddSortField procedure.

Procedure ReadReport
    String sCurSortField
    Integer iCurSortDirection iNumSortFields iCount

    Set Report_Name To "CustRpt.rpt"
    Send OpenReport
    Get NSortFields To iNumSortFields
    For Count From 0 To (iNumSortFields -1)
        Get NthSortFieldName iCount To sCurSortField
        Get NthSortFieldDirection iCount To iCurSortDirection
        if (iCurSortDirection=PE_SF_ASCENDING) ;
            send Info_Box ("Sort direction for field "+string(iCount)+": "+sCurSortField) "Ascending"
        else if (iCurSortDirection=PE_SF_DESCENDING) ;
            send Info_Box ("Sort direction for field "+string(iCount)+": "+sCurSortField) "Descending"
    Loop
    Send CloseReport
End_Procedure // ReadReport

See Also

Info_Box

Last Edited: November 23, 2004


CrystalReport [Property NthParam]

NthParam - CrystalReport

The value of the parameter of the stored procedure

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iParamN String sParamValue

Parameter | Description
iParamN | The number of the parameter. Parameters start at 0 (zero).
sParamValue | The value of the parameter of the stored procedure.

Description

NthParam is the value of the parameter of the stored procedure.

Last Edited: September 10, 2003


CrystalReport [Property NthSortFieldDirection]

NthSortFieldDirection - CrystalReport

The sort direction of the Nth sort field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSortFieldN Integer iDirection

Parameter | Description
iSortFieldN | The number of the sort field
iDirection | The sort direction of the Nth sort field. Sort fields are accessed by number and this numbering is zero-based

Description

NthSortFieldDirection is the sort direction of the Nth sort field. Sort fields are accessed by number and this numbering is zero-based. Thus the first sort field has number 0 (zero). Sort direction can be either PE_SF_ASCENDING or PE_SF_DESCENDING. You can set the direction of a sort field by setting this property. Normally this would be done in the AddSortField procedure.

Procedure ReadReport
    String sCurSortField
    Integer iCurSortDirection iNumSortFields iCount

    Set Report_Name To "CustRpt.rpt"
    Send OpenReport
    Get NSortFields To iNumSortFields
    For Count From 0 To (iNumSortFields -1)
        Get NthSortFieldName iCount To sCurSortField
        Get NthSortFieldDirection iCount To iCurSortDirection
        if (iCurSortDirection=PE_SF_ASCENDING) ;
            send Info_Box ("Sort direction for field "+string(iCount)+": "+sCurSortField) "Ascending"
        else if (iCurSortDirection=PE_SF_DESCENDING) ;
            send Info_Box ("Sort direction for field "+string(iCount)+": "+sCurSortField) "Descending"
    Loop
    Send CloseReport
End_Procedure // ReadReport

See Also

Info_Box

Last Edited: November 23, 2004


CrystalReport [Property NthSortFieldName]

NthSortFieldName - CrystalReport

The name of the Nth sort field

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iSortFieldN String sName

Parameter | Description
iSortFieldN | The number of the sort field.
sName | The name of the Nth sort field. Sort fields are accessed by number and this numbering is zero-based.

Description

NthSortFieldName is the name of the Nth sort field. Sort fields are accessed by number and this numbering is zero-based. Thus, the first sort field has number 0 (zero). You can set the name of a sort field by setting this property. Normally this would be done in the AddSortField procedure.

Procedure ReadReport
    String sCurSortField
    Integer iCurSortDirection iNumSortFields iCount

    Set Report_Name To "CustRpt.rpt"
    Send OpenReport
    Get NSortFields To iNumSortFields
    For Count From 0 To (iNumSortFields -1)
        Get NthSortFieldName iCount To sCurSortField
        Get NthSortFieldDirection iCount To iCurSortDirection
        if (iCurSortDirection=PE_SF_ASCENDING) ;
            send Info_Box ("Sort direction for field "+string(iCount)+": "+sCurSortField) "Ascending"
        else if (iCurSortDirection=PE_SF_DESCENDING) ;
            send Info_Box ("Sort direction for field "+string(iCount)+": "+sCurSortField) "Descending"
    Loop
    Send CloseReport
End_Procedure // ReadReport

See Also

Info_Box

Last Edited: November 23, 2004


CrystalReport [Property NthTableDBType]

NthTableDBType - CrystalReport

The type of the database file of interest

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iTableN Integer iValue

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).
iValue | The type of database file

Description

NthTableDBType is the type of the database file of interest. Type can be

Constant | Meaning
PE_DT_STANDARD | The type for standard, non-SQL databases
PE_DT_SQL | The type for SQL databases

Last Edited: September 10, 2003


CrystalReport [Property NthTableDescriptiveName]

NthTableDescriptiveName - CrystalReport

The name of the database file of interest

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iTableN String sValue

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).
sValue | The table descriptive name

Description

NthTableDescriptiveName is the name of the database file of interest.

Last Edited: September 10, 2003


CrystalReport [Property NthTableDLLName]

NthTableDLLName - CrystalReport

The name of the appropriate database DLL for the database file of interest

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iTableN String sValue

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).
sValue | The name of the database DLL

Description

NthTableDLLName is the name of the appropriate database DLL for the database file of interest.

Last Edited: September 10, 2003


CrystalReport [Property NthTableLocation]

NthTableLocation - CrystalReport

The location of a specified database file

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iTableN String sLocation

Parameter | Description
iTableN | The number of the database file. Database-file numbers start at 0 (zero).
sLocation | The location of a specified database file. This property is typically used in combination with the NTables function to reset locations of database files in existing reports when the database files are moved or the report is copied to another machine where the database files are in a different location.

Description

NthTableLocation is the location of a specified database file. This property is typically used in combination with the NTables function to reset locations of database files in existing reports when the database files are moved or the report is copied to another machine where the database files are in a different location.

The property is database-dependent and must be formatted correctly for the expected database, for example:

Embedded (DataFlex) database: "C:\VDF\MyWorkSpace\Data\Customer.dat"
Microsoft SQL Server: "publications.dbo.authors"

Last Edited: August 4, 2004


CrystalReport [Property NumRecordsPrinted]

NumRecordsPrinted - CrystalReport

Returns the number of records actually printed

Type: Property

Access: Read-Only

Data Type: Integer

Description

The NumRecordsPrinted property returns the number of records actually printed.

Last Edited: September 10, 2003


CrystalReport [Property NumRecordsRead]

NumRecordsRead - CrystalReport

Returns the number of records actually processed

Type: Property

Access: Read-Only

Data Type: Integer

Description

The NumRecordsRead property returns the number of records actually processed.

Last Edited: September 10, 2003


CrystalReport [Property NumRecordsSelected]

NumRecordsSelected - CrystalReport

Returns the number of records selected for inclusion in the report out of the total number of records read

Type: Property

Access: Read-Only

Data Type: Integer

Description

The NumRecordsSelected property returns the number of records selected for inclusion in the report out of the total number of records read.

Last Edited: September 10, 2003


CrystalReport [Property Output_Destination]

Output_Destination - CrystalReport

Indicates the destination of the report

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Output_Destination property indicates the destination of the report. You may select a destination from the table below:

Constant | Meaning
CRW_PRINT_TO_UNDEFINED | If the value of this property is PRINT_TO_UNDEFINED (the default) and this will use this container's output_device_mode. If this is undefined, output will be to the printer (Send DFPrint).
CRW_PRINT_TO_PRINTER | Print the report to the printer
CRW_PRINT_TO_WINDOW | Print to a preview window
CRW_PRINT_TO_FILE | Print to a disk file in a specified format
CRW_PRINT_TO_MAPI | E-mail or fax a report

Last Edited: August 4, 2004


CrystalReport [Property ParentWindowHandle]

ParentWindowHandle - CrystalReport

Specifies the handle to the parent window if the Preview window is a child of that window

Type: Property

Access: Read/Write

Data Type: Handle

Description

ParentWindowHandle specifies the handle to the parent window if the Preview window is a child of that window.

If this property is null, the print window is a top-level window (i.e., not a child of any other window). For a top-level print window, the top left corner is relative to the origin of the screen. WindowLeftCoordinate and WindowTopCoordinate can be CW_DEFAULT to put the window at a default location. WindowWidth and WindowHeight can also be CW_DEFAULT to give the window a default size.

If this property is the handle of an MDI frame window, the print window is an MDI child window. For an MDI child print window, the top left corner is relative to the origin of the frame window's client area. WindowLeftCoordinate and WindowTopCoordinate can be CW_USEDEFAULT to put the window at a default location. WindowWidth and WindowHeight can also be CW_DEFAULT to give the window a default size.

If this property is the handle of some other window, the print window is a child of that window. For a child print window, the top left corner is relative to the origin of the parent window's client area. If the print window is a top-level window or an MDI child window and WindowStyle is 0, a style of (WS_VISIBLE ior WS_THICKFRAME ior WS_SYSMENU ior WS_MAXIMIZEBOX ior WS_MINIMIZEBOX) is used instead.

Last Edited: August 4, 2004


CrystalReport [Property PreviewWindow_Id]

PreviewWindow_Id - CrystalReport

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


CrystalReport [Property PrintAtBottomOfPage]

PrintAtBottomOfPage - CrystalReport

Specifies whether the program is to cause each group value to print only at the bottom of a page or to have the values print in their normal positions

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iPrintAtBottomOfPage

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iPrintAtBottomOfPage | Specifies whether the program is to cause each group value to print only at the bottom of a page or to have the values print in their normal positions.

Description

PrintAtBottomOfPage specifies whether the program is to cause each group value to print only at the bottom of a page or to have the values print in their normal positions.

Last Edited: September 11, 2003


CrystalReport [Property PrintDate]

PrintDate - CrystalReport

The print date of the report

Type: Property

Access: Read/Write

Data Type: Date

Description

PrintDate is the print date of the report.

Last Edited: September 11, 2003


CrystalReport [Property PrintEnded]

PrintEnded - CrystalReport

Returns whether the printing process is completed

Type: Property

Access: Read-Only

Data Type: Integer

Description

The PrintEnded property returns whether the printing process is completed. TRUE indicates that this process is completed; FALSE indicates that is not yet complete.

Last Edited: September 11, 2003


CrystalReport [Property PrinterDriver]

PrinterDriver - CrystalReport

Obtains information about the printer driver

Type: Property

Access: Read-Only

Data Type: String

Description

If you need to know which driver has been specified with the report, use PrinterDriver to obtain information about the printer driver. If a non-default printer is specified in the report, its driver name is returned, otherwise an empty string. This can be useful to ascertain whether the user has access to the driver specified in the report and to choose another driver if not.

Last Edited: September 11, 2003


CrystalReport [Property PrinterName]

PrinterName - CrystalReport

Obtains information about the printer name

Type: Property

Access: Read-Only

Data Type: String

Description

If you need to know which printer has been specified with the report, use PrinterName to obtain information about the printer name. If a non-default printer is specified in the report its name is returned, an empty string otherwise. This can be useful to ascertain whether the user has access to the printer specified in the report and to choose another printer if not.

Last Edited: September 11, 2003


CrystalReport [Property PrinterPort]

PrinterPort - CrystalReport

Obtains information about the printer port

Type: Property

Access: Read-Only

Data Type: String

Description

If you need to know which port has been specified with the report, use PrinterPort to obtain information about the printer port. If a non-default printer is specified in the report its port name is returned, an empty string otherwise. This can be useful to acertain whether the user has access to the printer port specified in the report and to choose another port if not.

Last Edited: September 11, 2003


CrystalReport [Property Report_Data_Path]

Report_Data_Path - CrystalReport

Controls the pathnames of the tables used by the loaded report

Type: Property

Access: Read/Write

Data Type: String

Description

The Report_Data_Path property controls the pathnames of the tables used by the loaded report. Just before the report is executed, it will replace all pathnames (all characters of a file's location before the last '\') with the path given here. This can be used when reports must be able to run in different data directories, etc.

If the property holds an empty string, the location of the files in the Crystal Reports report will not be changed. If the property holds any string other than non-empty, the string will be interpreted as a path, and the location of all files in the Crystal Reports report will be changed to the path in this property

Last Edited: December 16, 2004


CrystalReport [Property Report_Name]

Report_Name - CrystalReport

Determines if the report defined in the named file will be run when Run_Report is received

Type: Property

Access: Read/Write

Data Type: String

Description

If the Report_Name property is set, the report defined in the named file will be run when Run_Report is received. This means that a CrystalReport report object can be as simple as the following:

Object oCustomerReport is a CrystalReport
    Set Report_Name to "CustRpt.rpt"
End_Object  // oCustomerReport

The only thing left to do to get the report to run is to send Run_Report of the object.

Last Edited: August 4, 2004


CrystalReport [Property Report_View_Id]

Report_View_Id - CrystalReport

Contains the object ID of the parent report view/panel

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Report_View_Id property contains the object ID of the parent report view/panel. The report object uses this to determine if it is placed inside a report view. If the ID is zero, it is not. Normally this will not be needed by developers. If you are setting up the CrystalReport object inside a ReportView object, you can set this property so it holds the address of the ReportView object. In that case, the default Destination of reports will be copied from the ReportView object.

The property can be set as in the following sample code. This is an excerpt from the "Standard Customer Listing (Crystal)" report from the "Order Entry Sample Application".

Object oCustomerRV is a ReportView
        :
    Object oCustCrystalReport Is A CrystalReport
        Set Report_Name To "CustLst.rpt"
        Set Report_View_Id To (Parent(Self))
          :
    End_Object  // oCustCrystalReport
End_Object  // oCustomerRV

Last Edited: August 4, 2004


CrystalReport [Property ReportTitle]

ReportTitle - CrystalReport

Holds the title string that is to appear on the title bar of the report when the report prints to a Preview window

Type: Property

Access: Read/Write

Data Type: String

Description

The ReportTitle property holds the title string that is to appear on the title bar of the report when the report prints to a Preview window.

Last Edited: August 4, 2004


CrystalReport [Property ResetPageNAfter]

ResetPageNAfter - CrystalReport

Specifies whether or not the program is to reset the page number to one (1) for the following page, after it prints a group total

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iResetPageNAfter

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iResetPageNAfter | Specifies whether or not the program is to reset the page number to one (1) for the following page, after it prints a group total.

Description

ResetPageNAfter specifies whether or not the program is to reset the page number to one (1) for the following page, after it prints a group total.

Last Edited: September 11, 2003


CrystalReport [Property RightMargin]

RightMargin - CrystalReport

The right page margin in twips

Type: Property

Access: Read/Write

Data Type: Integer

Description

The RightMargin property contains the right page margin in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200.

Last Edited: September 11, 2003


CrystalReport [Property Selection_Formula]

Selection_Formula - CrystalReport

Obsolete -- provided for backward compatibility reasons.

Type: Property

Access: Write-Only

Data Type: String

Description

Obsolete. Procedure provided for backward compatibility reasons. Use SelectionFormula instead.

Last Edited: August 4, 2004


CrystalReport [Property SelectionFormula]

SelectionFormula - CrystalReport

Holds the selection formula of the report

Type: Property

Access: Read/Write

Data Type: String

Description

The SelectionFormula property holds the selection formula of the report. You can use this property to override or extend existing selections.

Procedure OnStartPrinting
    String sStartCust sEndCust sSelection

    // setup the selection formula
    Move "" To sSelection
    Get StartCustomer To sStartCust
    Get EndCustomer To sEndCust

    If (Trim(sStartCust) <> "") ;
        Append Selection "{Customer.Name} >=" '"' (Trim(sStartCust)) '"'
    If (Trim(sEndCust) <> "") ;
        Append Selection (If(Selection <> "", " and ", "")) ;
            "{Customer.Name} <=" '"' (Trim(sEndCust)) '"'

    Set SelectionFormula To sSelection
End_Procedure // OnStartPrinting

Last Edited: August 4, 2004


CrystalReport [Property ShowPrintControls]

ShowPrintControls - CrystalReport

Indicates whether the print controls on the preview window are displayed

Type: Property

Access: Read/Write

Data Type: Integer

Description

ShowPrintControls indicates whether the print controls on the preview window are displayed.

Last Edited: September 11, 2003


CrystalReport [Property SQLQuery]

SQLQuery - CrystalReport

Holds the string containing the SQL query generated by the report

Type: Property

Access: Read/Write

Data Type: String

Description

The SQLQuery property holds the string containing the SQL query generated by the report.

Last Edited: September 11, 2003


CrystalReport [Property StartPageN]

StartPageN - CrystalReport

Returns the number of the starting page

Type: Property

Access: Read/Write

Data Type: Integer

Description

StartPageN returns the number of the starting page. The value will normally be 1, but you can specify something else using SetPrintOptions.

Last Edited: September 11, 2003


CrystalReport [Property StopPageN]

StopPageN - CrystalReport

The stopping page number of the report

Type: Property

Access: Read/Write

Data Type: Integer

Description

StopPageN is the stopping page number of the report. This property can be used if you want to print part of the report. To achieve this use this property together with the StartPageN property. Page numbers are 1-origin, so the first page has number 1. A value of 0 (zero) will retain the existing setting.

Last Edited: September 11, 2003


CrystalReport [Property StringDelimiter]

StringDelimiter - CrystalReport

Specifies the character you want to use to enclose alphanumeric field data in the character-separated values format

Type: Property

Access: Read/Write

Data Type: String

Description

The StringDelimiter property specifies the character you want to use to enclose alphanumeric field data in the character-separated values format. You can use whatever character you wish. If you supply more than one character, only the first character of the string is used as a string delimiter. All other characters are ignored. The default value is "'" (an apostrophe).

See Also

ExportFormatType

Last Edited: September 11, 2003


CrystalReport [Property SubjectText]

SubjectText - CrystalReport

Specifies the string you want to appear as the subject line in the e-mail or FAX message

Type: Property

Access: Read/Write

Data Type: String

Description

SubjectText specifies the string you want to appear as the subject line in the e-mail or FAX message.

The following sample will only work if you have Word for Windows installed on your machine.

Object oCustomerReport is a CrystalReport
    Set Report_Name To "CustRpt.rpt"
    Set Output_Destination To CRW_PRINT_TO_MAPI
    Set ExportFormatType To CRW_WordWinType
    Set ToList To "FAX:099-33445566"
    Set ExportFileName To "CustRpt.doc"
    Set SubjectText To "Customer list"
    Set MessageText To "This is our latest customer list"

    Send Run_Report
End_Object // oCustomerReport

Last Edited: August 4, 2004


CrystalReport [Property SuppressBlankLines]

SuppressBlankLines - CrystalReport

Specifies whether the program is to eliminate lines from your report that are blank due to fields being suppressed

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iSuppressBlankLines

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iSuppressBlankLines | Specifies whether the program is to eliminate lines from your report that are blank due to fields being suppressed (zeros, duplicates, and hidden fields).

Description

SuppressBlankLines specifies whether the program is to eliminate lines from your report that are blank due to fields being suppressed (zeros, duplicates, and hidden fields).

Last Edited: September 11, 2003


CrystalReport [Property ToList]

ToList - CrystalReport

Contains the To list to which you want your e-mail message directed

Type: Property

Access: Read/Write

Data Type: String

Description

ToList contains the To list to which you want your e-mail message directed. Multiple addresses should be separated by a semicolon. You may supply a FAX number with this property using the FAX: prefix. Refer to the MicroSoft Win32 SDK for further details and a complete list of possible address types. If you supply a FAX address here be sure that you choose a format type that is supported by your software. That means that you must have an associating program for the format type you select.

If this property is not set, users will be prompted to supply the address information before the report is exported to MAPI.

The following sample will only work if you have Word for Windows installed on your machine.

Object oCustomerReport is a CrystalReport
    Set Report_Name To "CustRpt.rpt"
    Set Output_Destination To CRW_PRINT_TO_MAPI
    Set ExportFormatType To CRW_WordWinType
    Set ToList To "FAX:099-33445566"
    Set ExportFileName To "CustRpt.doc"
    Set SubjectText To "Customer list"
    Set MessageText To "This is our latest customer list"

    Send Run_Report
End_Object // oCustomerReport

Last Edited: August 4, 2004


CrystalReport [Property TopMargin]

TopMargin - CrystalReport

The top page margin in twips

Type: Property

Access: Read/Write

Data Type: Integer

Description

TopMargin contains the top page margin in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200.

Last Edited: September 11, 2003


CrystalReport [Property UseReportDateFormat_State]

UseReportDateFormat_State - CrystalReport

Indicates whether the program should save dates in the same format (MDY, DMY, etc.) that you used in the report

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The UseReportDateFormat_State property indicates whether the program should save dates in the same format (MDY, DMY, etc.) that you used in the report. Pass true if you want the program to use the same format as used in the report, false if you want dates saved in a format that has been optimized for the file format you have selected. This property is not available for all format types. Format types that don't support this property simply ignore it. The default value is false. See ExportFormatType property for a description of the format types.

Last Edited: September 11, 2003


CrystalReport [Property UseReportNumberFormat_State]

UseReportNumberFormat_State - CrystalReport

Indicates whether the program should save numbers in the same format (decimal places, negatives, etc.) that you have used in the report

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The UseReportNumberFormat_State property indicates whether the program should save numbers in the same format (decimal places, negatives, etc.) that you have used in the report. Pass true if you want the program to use the same format used in the report, false if you want the number saved in a format that has been optimized for the file format you have selected. This property is not available for all format types. Format types that don't support this property simply ignore it. The default value is false. See ExportFormatType property for a description of the format types.

Last Edited: September 11, 2003


CrystalReport [Property Visible]

Visible - CrystalReport

Specifies whether the selected section is to be visible

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iSectionCode Integer iVisible

Parameter | Description
iSectionCodeThe section identifier. iSectionCode can be:

Constant | Meaning
PE_ALLSECTIONS | All sections
PE_HEADERSECTION | The Page-Header section
PE_GROUPHEADER | The Group-Header section. There can be multiple group-header sections in a given report. When this is the case, the first group header can be identified by PE_GROUPHEADER, the second by PE_GROUPHEADER + 1, et cetera.
PE_DETAILSSECTION | The Details section
PE_GROUPFOOTER | The Group-Footer section. There can be multiple group-footer sections in a given report. When this is the case, the first group footer can be identified by PE_GROUPFOOTER, the second by PE_GROUPFOOTER + 1, et cetera.
PE_GRANDTOTALSECTION | The Grand-Total section
PE_FOOTERSECTION | The Page-Footer section

iVisible | Specifies whether the selected section is to be visible.

Description

The Visible property specifies whether the selected section is to be visible.

Last Edited: September 15, 2003


CrystalReport [Property WindowHandle]

WindowHandle - CrystalReport

Returns the Preview window handle

Type: Property

Access: Read-Only

Data Type: Handle

Description

WindowHandle returns the Preview window handle.

Last Edited: September 15, 2003


CrystalReport [Property WindowHeight]

WindowHeight - CrystalReport

Specifies the height of the Preview window, in twips

Type: Property

Access: Read/Write

Data Type: Integer

Description

WindowHeight specifies the height of the Preview window, in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200. The default value of the property is 480.

Last Edited: September 15, 2003


CrystalReport [Property WindowLeftCoordinate]

WindowLeftCoordinate - CrystalReport

Specifies the x coordinate of the upper left corner of the Preview window, in twips

Type: Property

Access: Read/Write

Data Type: Integer

Description

The WindowLeftCoordinate property specifies the x coordinate of the upper left corner of the Preview window, in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200. For a top-level print window, the top left corner is relative to the origin of the screen. For an MDI child print window, the top left corner is relative to the origin of the frame window's client area. For a child print window, the top left corner is relative to the origin of the parent window's client area.

Last Edited: September 15, 2003


CrystalReport [Property WindowStyle]

WindowStyle - CrystalReport

Specifies the style of the window being created

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the style of the window being created. Style settings can be combined by using the bitwise ior operator.

You can specify any of the following window styles:

Constant | Meaning
CW_DEFAULT | Assign the child window the default horizontal and vertical position, and the default height and width
WS_BORDER | Make a window that includes a border
WS_CAPTION | Make a window that includes a title bar
WS_CLIPCHILDREN | Exclude the area occupied by child windows when drawing inside the parent window
WS_CLIPSIBLINGS | Clip child windows with respect to one another
WS_DISABLED | Make a window that is disabled when it first appears
WS_DLGFRAME | Make a window that has a double border but no title
WS_HSCROLL | Make a window that includes a horizontal scroll bar
WS_MAXIMIZE | Make a window of maximum size
WS_MAXIMIZEBOX | Include the maximize box
WS_MINIMIZE | Make a window of minimum size
WS_MINIMIZEBOX | Include the minimize box
WS_SYSMENU | Include the system menu box
WS_THICKFRAME | Include the thick frame that can be used to size the window
WS_VISIBLE | Make a window that is visible when it first appears (for overlapping and pop-up windows)
WS_VSCROLL | Make a window that includes a vertical scroll bar

If no style is specified, the default style (WS_VISIBLE ior WS_THICKFRAME ior WS_SYSMENU ior WS_MAXIMIZEBOX ior WS_MINIMIZEBOX) will be used.

See Also

ZoomPreviewWindow

Last Edited: November 24, 2004


CrystalReport [Property WindowTitle]

WindowTitle - CrystalReport

Contains the title you want to appear in the Preview window title bar when printing to a preview window

Type: Property

Access: Read/Write

Data Type: String

Description

The WindowTitle property contains the title you want to appear in the Preview window title bar when printing to a preview window. Of course, the window title will only be applied when actually printing to a window (the default destination, see Output_Destination property). If no value is set for this property, the output window's title bar will be set to the value of ReportTitle. Normally, you will use the ReportTitle property for setting report names.

Sample

Object oCustomerReport is a CrystalReport
    Set Report_Name    To "Custlst.rpt"
    Set ReportTitle    To "Customer list"
    // <or>
    // Set WindowTitle To "Customer list"
End_Object // oCustomerReport

Last Edited: November 24, 2004


CrystalReport [Property WindowTopCoordinate]

WindowTopCoordinate - CrystalReport

Specifies the y coordinate of the upper left corner of the Preview window, in twips

Type: Property

Access: Read/Write

Data Type: Integer

Description

WindowTopCoordinate specifies the y coordinate of the upper left corner of the Preview window, in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200. For a top-level print window, the top left corner is relative to the origin of the screen. For an MDI child print window, the top left corner is relative to the origin of the frame windows client area. For a child print window, the top left corner is relative to the origin of the parent windows client area.

Last Edited: September 15, 2003


CrystalReport [Property WindowWidth]

WindowWidth - CrystalReport

Specifies the width of the Preview window, in twips

Type: Property

Access: Read/Write

Data Type: Integer

Description

WindowWidth specifies the width of the Preview window, in twips. A twip is 1/1440th of an inch or 1/20th of a point. To specify a width of 5", for example, you would pass a value of 7200. The default value for the property is 640.

Last Edited: September 15, 2003


CrystalReport [Property ZoomPreviewWindow]

ZoomPreviewWindow - CrystalReport

Sets the magnification level

Type: Property

Access: Write-Only

Data Type: Integer

Description

The ZoomPreviewWindow specifies the Preview window's maginfication level.

Levels can be:

Constant | Meaning
PE_ZOOM_FULL_SIZE | Full Page
PE_ZOOM_SIZE_FIT_ONE_SIDE | Fit One Side
PE_ZOOM_SIZE_FIT_BOTH_SIDES | Fit Both Sides

Sample

Set ZoomPreviewWindow To PE_ZOOM_FULL_SIZE

ZoomPreviewWindow can also be set to a magnification percentage (e.g. 75, 100, 150, etc.)

Sample

Set ZoomPreviewWindow To 150

The ZoomPreviewWindow property can only be set when the preview window is visible. You can augment Procedure OutputToWindow to set this property.

Sample

Procedure OutputToWindow String sTitle Integer iLeft Integer iTop Integer iWidth ;
    Integer iHeight Integer iStyle Handle hParent

    forward send OutputToWindow sTitle iLeft iTop iWidth iHeight iStyle hParent

    Set ZoomPreviewWindow To PE_ZOOM_FULL_SIZE
End_Procedure  // OutputToWindow

Use WindowStyle to set the size and style of the Preview window.

See Also

WindowStyle

Last Edited: December 6, 2004


Events for cSQLConnection

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cSQLConnection [Function CreateHandle]

CreateHandle - cSQLConnection

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


cSQLConnection [Function SQLConnect]

SQLConnect - cSQLConnection

Type: Function

Return Data Type: Integer

Parameters: string sDrvrID String sConnect

Parameter | Description
sDrvrID | [ToDo: In Progress]
sConnect | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cSQLConnection [Function SQLFileConnect]

SQLFileConnect - cSQLConnection

Type: Function

Return Data Type: Integer

Parameters: Integer iFileNum

Parameter | Description
iFileNum | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cSQLConnection [Function SQLOpen]

SQLOpen - cSQLConnection

Open a statement handle.

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns handle of statement.

Description

This function will open a statement handle in the connection. It will create a DataFlex statement handle object and call the Connectivity Kit's open function. If the statement handle could be opened, the Connectivity Kit's handle information is stored. The function returns the object handle to the DataFlex statement object.

Sample

Handle hoSQLMngr
Handle hdbc hstmt

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Get SQLFileConnect Of hoSQLMnGet SQLOpen Of hdbc To hstmt
Get SQLOpen Of hdbc To hstmt

Last Edited: April 20, 2005


Methods for cSQLConnection

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
CreateHandle | Function |  |
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
FreeHandle | Procedure |  |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array
SQLConnect | Function |  |
SQLDisconnect | Procedure | Disconnect from the database and free the connection object. |
SQLFileConnect | Function |  |
SQLOpen | Function | Open a statement handle. |
StoreHandleInfo | Procedure |  |


cSQLConnection [Procedure FreeHandle]

FreeHandle - cSQLConnection

Type: Procedure

Parameters: No Parameters

Description

Last Edited: June 2, 2006


cSQLConnection [Procedure SQLDisconnect]

SQLDisconnect - cSQLConnection

Disconnect from the database and free the connection object.

Type: Procedure

Parameters: No Parameters

Description

This procedure will call the Connectivity Kit's disconnect function and free the DataFlex connection object.

Sample

Handle hoSQLMngr
Handle hdbc

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc
Send DoSomeEmbeddedSQLStuff hdbc

Last Edited: April 19, 2005


cSQLConnection [Procedure StoreHandleInfo]

StoreHandleInfo - cSQLConnection

Type: Procedure

Parameters: Integer iCLIHandle String sDrvrId Integer iParentHandle

Parameter | Description
iCLIHandle | [ToDo: In Progress]
sDrvrId | [ToDo: In Progress]
iParentHandle | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


Properties for cSQLConnection

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phCLIHandle |  |
piBindFile | The default file to bind statement results to. |
psDriverID |  |
Value | Sets and Gets an array element's value | Array


cSQLConnection [Property phCLIHandle]

phCLIHandle - cSQLConnection

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: June 2, 2006


cSQLConnection [Property piBindFile]

piBindFile - cSQLConnection

The default file to bind statement results to.

Type: Property

Access: Read/Write

Data Type: Integer

Description

The piBindFile property stores the default file buffer to use for statements created in this connection. It should be set to a file number. If the connection is created by sending the message SQLFileConnect, the property will automatically be set.

When statement objects are created, the value of this property will automatically be passed to that statement object's piBindFile property.

Sample

The code sample uses two different ways to set the piBindFile property to the Customer file number. One is by using a "normal" connect and explicitly setting the property. The other is by using SQLFileConnect implicitly setting this property.

Handle hoSQLMngr
Handle hdbc

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Send SQLSetConnect Of hoSQLMngr "MSSQLDRV" "SERVER=(local)"
Get SQLConnect Of hoSQLMngr "" "" To hdbc
Set piBindFile Of hdbc To Customer.File_number
Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc

Last Edited: April 21, 2005


cSQLConnection [Property psDriverID]

psDriverID - cSQLConnection

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: June 2, 2006


Events for cSQLHandleManager

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cSQLHandleManager [Function CreateHandle]

CreateHandle - cSQLHandleManager

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


cSQLHandleManager [Function SQLConnect]

SQLConnect - cSQLHandleManager

Creates a connection and returns the handle to the connection.

Type: Function

Return Data Type: Integer

Parameters: String sDrvrID String sConnect

Parameter | Description
sDrvrIDDriver Id

Can be:

Constant | Meaning
DATAFLEX | Embedded database
DB2_DRV | DB2 Connectivity Kit
DFBTRDRV | Pervasive.SQL Connectivity Kit
MSSQLDRV | Microsoft SQL Connectivity Kit
ODBC_DRV | ODBC Connectivity Kit

sConnect | Connection string

Return Value

Returns the handle to the connection.

Description

The SQLConnect function creates a connection; it returns the handle to the connection. If the connection cannot be established, 0 (zero) will be returned.

The driver and connection string to use must be passed as parameter to the function. Alternatively, you can pass two empty strings, which will use the defaults established through the SQLSetConnect message. The defaults are only used if both parameters are empty strings!

Sample

This sample uses one cSQLHandleManager object to connect through DB2 Connectivity Kit and through the SQL Server Connectivity Kit.

Handle hoSQLMngr
Handle hdbcSQL hdbcDb2

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Send SQLSetConnect Of hoSQLMngr "MSSQLDRV"
Get SQLConnect Of hoSQLMngr "" "" To hdbcSQL
Get SQLConnect Of hoSQLMngr "" "" To hdbcSQL
Get SQLConnect Of hoSQLMngr "DB2_DRV" "DSN=MyServer" To hdbcDb2

Last Edited: September 1, 2005


cSQLHandleManager [Function SQLFileConnect]

SQLFileConnect - cSQLHandleManager

Returns a handle to the same connection of the table opened under the number passed in iFileNum.

Type: Function

Return Data Type: Integer

Parameters: Integer iFileNum

Parameter | Description
iFileNum | Table number to connect to

Return Value

Returns the handle to the connection.

Description

The SQLFileConnect function will return a handle to the same connection of the table opened under the number passed in iFileNum. The table must be accessed through one of the Connectivity Kits that support Embedded SQL.

Sample

If, for example, we are using the order entry sample data converted to one of the Connectivity Kits that supports Embedded SQL, we can use the following code to get a connection handle:

Handle hoSQLMngr
Handle hdbc

Object oSQLManager Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object // oSQLManager

Open Customer Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc

Last Edited: April 20, 2005


Methods for cSQLHandleManager

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
CreateHandle | Function |  |
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array
SQLConnect | Function | Creates a connection and returns the handle to the connection. |
SQLFileConnect | Function | Returns a handle to the same connection of the table opened under the number passed in iFileNum. |
SQLSetConnect | Procedure | Can be used to set up a default driver and connection for subsequent SQLConnect function calls. |


cSQLHandleManager [Procedure SQLSetConnect]

SQLSetConnect - cSQLHandleManager

Can be used to set up a default driver and connection for subsequent SQLConnect function calls.

Type: Procedure

Parameters: String sDriver String sConnect

Parameter | Description
sDriverDriver Id

Can be:

Constant | Meaning
DATAFLEX | Embedded database
DB2_DRV | DB2 Connectivity Kit
DFBTRDRV | Pervasive.SQL Connectivity Kit
MSSQLDRV | Microsoft SQL Connectivity Kit
ODBC_DRV | ODBC Connectivity Kit

sConnect | Connection string

Description

The procedure can be used to set up a default driver and connection for subsequent SQLConnect function calls. See SQLConnect for a discussion of when the defaults are used.

Sample

If, for example, we want to create two managers, one for DB2 and one for SQL Server, we could use the following code:

Handle hoDB2Mngr hoMSSQLMngr
Handle hdbcDB2 hdbcMSSQL

Object oDB2Handler Is A cSQLHandleManager
    Move Self To hoDB2Mngr
End_Object // oDB2Handler

Object oMSSQLhandler Is A cSQLHandlemanager
    Move Self To hoMSSQLMngr
End_Object // oMSSQLHandler

Send SQLSetConnect Of hoDB2Mngr "DB2_DRV" "DSN=MyServer"
Send SQLSetConnect Of hoMSSQLMngr "MSSQLDRV" "SERVER=(local)"
Get SQLConnect Of hoDB2Mngr "" "" To hdbcDB2
Get SQLConnect Of hoMSSQLMngr "" "" To hdbcMSSQL

Last Edited: September 1, 2005


Properties for cSQLHandleManager

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psDefaultConnection |  |
psDefaultDriver |  |
Value | Sets and Gets an array element's value | Array


cSQLHandleManager [Property psDefaultConnection]

psDefaultConnection - cSQLHandleManager

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: June 2, 2006


cSQLHandleManager [Property psDefaultDriver]

psDefaultDriver - cSQLHandleManager

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: June 2, 2006


Events for cSQLStatement

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cSQLStatement [Function DFDateToSQLDate]

DFDateToSQLDate - cSQLStatement

Type: Function

Return Data Type: String

Parameters: Date dDFDate

Parameter | Description
dDFDate | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cSQLStatement [Function RemoveComponentIdentifier]

RemoveComponentIdentifier - cSQLStatement

Can be used to remove a component identifier from an informational message obtained by calling SQLGetMessage.

Type: Function

Return Data Type: String

Parameters: String sDiagMessage

Parameter | Description
sDiagMessage | Message

Return Value

This function returns the diagnostic message with the component identifier removed.

Description

The RemoveConponentIdentifer function can be used to remove a component identifier from an informational message obtained by calling SQLGetMessage. Informational messages, as error messages, start with a component identifier. For an example of using this function, see the sample on SQLGetMessage.

Last Edited: April 20, 2005


cSQLStatement [Function SQLColAttribute]

SQLColAttribute - cSQLStatement

Returns a column attribute.

Type: Function

Return Data Type: String

Parameters: Integer iCol Integer iAttribId

Parameter | Description
iCol | Column to return attribute from
iAttribId | Attribute id to return

Return Value

Returns a column attribute.

Description

The SQLColAttribute message allows the programmer to get column attributes. The following attributes are supported:

Attribute | Description
SIZE | The size of the column. This attribute returns the size of a column including possible decimal places.
PRECISION | The precision of the column. This attribute defines the number of decimal places for columns that have decimals defined.
LABEL | The label of the column in the result set.
BASECOLUMNNAME | The name of the column in the base table if any.
BASETABLENAME | The name of the base table if any. Some backends do not support this attribute. Others only under certain conditions. In Microsoft SQL Server, for example, the attribute is supported except when the statement has multiple result sets .
SQLTYPE | The SQL type identifier of the column.
NULLABLE | A Boolean indicating if the column accepts null values or not.
DFTYPE | The DataFlex type of the column. This attribute will map the SQL type identifier to a DataFlex type.

The attributes described above can be accessed through predefined constants. These constants have the SQLCOLATTRIB_ prefix. So to get the label of column 1 one would program:

Get SQLColAttribute of hstmt 1 SQLCOLATTRIB_LABEL To sLabel

For the SQL type, a number of constants have also been defined. These are:
SQL_UNKNOWN_TYPE, SQL_CHAR, SQL_NUMERIC, SQL_DECIMAL, SQL_INTEGER, SQL_SMALLINT, SQL_FLOAT, SQL_REAL, SQL_DOUBLE, SQL_DATETIME, SQL_VARCHAR, SQL_TYPE_DATE, SQL_TYPE_TIME, SQL_TYPE_TIMESTAMP, SQL_DATE, SQL_INTERVAL, SQL_TIME, SQL_TIMESTAMP, SQL_LONGVARCHAR, SQL_BINARY, SQL_VARBINARY, SQL_LONGVARBINARY, SQL_BIGINT, SQL_TINYINT, SQL_BIT, SQL_GUID.

Sample

Handle hoSQLMngr
Handle hdbc hstmt
Integer iFetchResult
Integer iNumCols iCol
String sColumn sColumnName

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Open Customer
Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc
Get SQLOpen Of hdbc To hstmt
Send SQLExecDirect Of hstmt "select * from customer"
Get SQLStmtAttribute Of hstmt SQLSTMTATTRIB_COLUMNCOUNT To iNumCols
For iCol From 1 To iNumCols
    Get SQLColAtrribute Of hstmt iCol SQLCOLATTRIB_LABEL To sColumnName
    Show sColumnName
    If (iCol < iNumCols) ;
        Show ", "
Loop
Repeat
    Get SQLFetch Of hstmt To iFetchResult
    If (iFetchResult <> 0) Begin
        For iCol From 1 To iNumCols
            Get SQLColumnValue Of hstmt iCol To sColumn
            Show sColumn
            If (iCol < iNumCols) ;
                Show ", "
        Loop
        Showln
    End
Until (iFetchResult = 0)

Send SQLClose Of hstmt
Send SQLDisconnect Of hdbc

Last Edited: April 20, 2005


cSQLStatement [Function SQLColumnMap]

SQLColumnMap - cSQLStatement

Returns a column number for a name.

Type: Function

Return Data Type: Integer

Parameters: String sColname

Parameter | Description
sColname | Name of column to map

Return Value

Returns a column number for a name.

Description

Returns the column number of the column with the passed name. Column numbers are one based. If no column with the passed name exists, 0 (zero) is returned.

Sample

Handle hoSQLMngr
Handle hdbc hstmt
Integer iFetchResult
Integer iColNum

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Open Customer
Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc
Get SQLOpen Of hdbc To hstmt
Send SQLExecDirect Of hstmt "select * from customer"
Repeat
    Get SQLFetch Of hstmt To iFetchResult
    If (iFetchResult <> 0) Begin
        Get SQLColumnMap Of hstmt "City" To iColNum
        If (iColNum <> 0) ;
            Showln "The city column has number: " iColNum
        Else ;
            Showln "No city columns exists"
    End
Until (iFetchResult = 0)

Send SQLClose Of hstmt
Send SQLDisconnect Of hdbc

Last Edited: April 20, 2005


cSQLStatement [Function SQLColumnValue]

SQLColumnValue - cSQLStatement

Get a column value.

Type: Function

Return Data Type: String

Parameters: Integer iCol

Parameter | Description
iCol | Number of the column the value of which to get

Return Value

Returns a column value.

Description

Returns the value of the specified column. The column number must be passed. Column numbers are one based. If an invalid column number is passed, an error will be generated.

Sample

Handle hoSQLMngr
Handle hdbc hstmt
Integer iFetchResult
String sName sState

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Open Customer
Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc
Get SQLOpen Of hdbc To hstmt
Send SQLExecDirect Of hstmt "select name, state from customer"
Repeat
    Get SQLFetch Of hstmt To iFetchResult
    If (iFetchResult <> 0) Begin
        Get SQLColumnValue Of hstmt 1 To sName
        Get SQLColumnValue Of hstmt 2 To sState
        Showln sName ", " sState
    End
Until (iFetchResult = 0)

Send SQLClose Of hstmt
Send SQLDisconnect Of hdbc

Last Edited: April 20, 2005


cSQLStatement [Function SQLDateToDFDate]

SQLDateToDFDate - cSQLStatement

Type: Function

Return Data Type: String

Parameters: String sSQLDate

Parameter | Description
sSQLDate | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cSQLStatement [Function SQLFetch]

SQLFetch - cSQLStatement

Fetch the next row of the statement's result set.

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the next row of the statement's result set.

Description

The SQLFetch function is used to retrieve the next row from the statement result set (if any). The SQLFetch function returns zero if there are no more rows, a non-zero value otherwise. The Connectivity Kit will store the column values of the retrieved row in its column buffers. These values can be retrieved individually by using the SQLColumnValue message.

Sample

Handle hoSQLMngr
Handle hdbc hstmt
Integer iFetchResult

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Open Customer
Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc
Get SQLOpen Of hdbc To hstmt
Send SQLExecDirect Of hstmt "select * from customer"
Repeat
    Get SQLFetch Of hstmt To iFetchResult
    If (iFetchResult <> 0) ;
        Send ProcessRow hstmt
Until (iFetchResult = 0)

Send SQLClose Of hstmt
Send SQLDisconnect Of hdbc

Last Edited: April 20, 2005


cSQLStatement [Function SQLGetArgument]

SQLGetArgument - cSQLStatement

Get a stored procedure argument.

Type: Function

Return Data Type: String

Parameters: Integer iArgnum

Parameter | Description
iArgnum | Argument number

Return Value

The out arguments will be returned as a result set. If the argument you are trying to get does not exist, i.e. it was not reported by the backend as an argument, no error will be generated and the argument will be returned as an empty string.

Description

Get an argument from a stored procedure or stored function. This message is intended to retrieve the out or in/out arguments for a stored procedure or stored function. If the argument you are trying to get does not exist, i.e. it was not reported by the backend as an argument, no error will be generated and the argument will be returned as an empty string.

The out arguments will be returned as a result set. Check your database documentation to see when the result set is returned. Some backends return arguments as the first result set, others as the last result set. Microsoft SQL Server 7.0, for example, returns the arguments as the last result set. See SQLNextResultSet for information on how to switch to another result set.

Last Edited: April 20, 2005


cSQLStatement [Function SQLGetData]

SQLGetData - cSQLStatement

Get data of a column.

Type: Function

Return Data Type: String

Parameters: Integer iCol Integer iLen

Parameter | Description
iCol | Column to get data from
iLen | Length of data to get

Return Value

Returns data from a column.

Description

Get the value of a column. SQLGetData is intended to get column data in chunks. If a statement selects a large object column, BLOB, CLOB, it is impossible to get the data of that column in one call. Normally the exact size of the column is not known upfront and it can grow to very big proportions (4 Gb in some backends). In such cases, you can use SQLGetData to get the column value piece by piece.

The function will fill the global integer status variable SQLResult when the last chunk of data is retrieved. It will return the chunk of data that was retrieved.

Sample

This code sample shows how to use SQLGetData to get a column's data in chunks of 1 KB.

Handle hoSQLMngr
Handle hdbc hstmt
Integer iFetchResult
String sChunk

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc
Get SQLOpen Of hdbc To hstmt
Send SQLExecDirect Of hstmt "select photograph from employee"
Repeat
    Get SQLFetch Of hstmt To iFetchResult
    If (iFetchResult <> 0) Begin
    Repeat
        Send SQLGetData Of hstmt 1 1024 To sChunk
        Send HandlePictureChunk To hoPicturehandler sChunk
    Until (SQLResult <> SQLSuccess)
Until (iFetchResult = 0)

Send SQLClose Of hstmt
Send SQLDisconnect Of hdbc

Last Edited: April 20, 2005


cSQLStatement [Function SQLGetMessage]

SQLGetMessage - cSQLStatement

Get informational messages (if any).

Type: Function

Return Data Type: String

Parameters: Integer iMessageNum

Parameter | Description
iMessageNum | Message number

Return Value

Returns informational message (if any).

Description

Some statements generate additional informational messages. These messages are stored when the statements execute. You can get the messages by calling SQLGetMessage. To determine the number of messages you can use the statement attribute SQLSTMTATTRIB_NUMMESSAGES (see SQLStmtAttribute).

Sample

The example below (for SQL Server) executes the statement "RESTORE VERIFYONLY"

Procedure RestoreVerify
    Handle hoSQL
    Handle hdbc
    Handle hstmt
    String sMessage
    Integer iNumMessages
    Integer iCount

    Get Create U_cSQLHandleManager To hoSQL
    If (hoSQL <> 0) Begin
        Get SQLConnect Of hoSQL "MSSQLDRV" ;
            "SERVER=(local);Trusted_Connection=yes;DATABASE=Sample" ;
                To hdbc
        If (hdbc <> 0) Begin
            Get SQLOpen Of hdbc To hstmt
            If (hstmt <> 0) Begin
                Send SQLExecDirect Of hstmt ;
                    "Restore verifyonly from disk = 'C:\BCKUP\SampleBckup' with File = 1"
                Get SQLStmtAttribute of hstmt ;
                    SQLSTMTATTRIB_NUMMESSAGES To iNumMessages
                For iCount From 1 To iNumMessages
                    Get SQLGetMessage Of hstmt iCount To sMessage
                    Showln "Message = " ;
                        (RemoveComponentIdentifier(hstmt, sMessage))
                Loop
                Send SQLClose Of hstmt
            End
            Send SQLDisconnect Of hdbc
        End
        Send Destroy Of hoSQL
    End
End_Procedure // RestoreVerify

Last Edited: April 20, 2005


cSQLStatement [Function SQLGetNextArgument]

SQLGetNextArgument - cSQLStatement

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


cSQLStatement [Function SQLNextColumn]

SQLNextColumn - cSQLStatement

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Description

Last Edited: June 2, 2006


cSQLStatement [Function SQLNextResultSet]

SQLNextResultSet - cSQLStatement

Switch to the next result set of a batch or stored procedure.

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The function will return 0 if there are no more result sets, a non zero value otherwise.

Description

Switch to the next result set in a batch of statements or a stored procedure/function that returns multiple result sets. The function will return 0 if there are no more result sets, a non zero value otherwise.

See the sp_help sample application in Chapter 3 - Embedded SQL in DataFlex for a sample on calling a stored function that has multiple result sets.

Last Edited: April 20, 2005


cSQLStatement [Function SQLPrivateColAttribute]

SQLPrivateColAttribute - cSQLStatement

Type: Function

Return Data Type: String

Parameters: Integer iCol Integer iAttribId Integer ihdbc String sDrvrId Integer ihstmt

Parameter | Description
iCol | [ToDo: In Progress]
iAttribId | [ToDo: In Progress]
ihdbc | [ToDo: In Progress]
sDrvrId | [ToDo: In Progress]
ihstmt | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cSQLStatement [Function SQLPrivateColumnIsLegal]

SQLPrivateColumnIsLegal - cSQLStatement

Type: Function

Return Data Type: Integer

Parameters: Integer ihdbc String sDrvrId Integer ihstmt Integer iCol

Parameter | Description
ihdbc | [ToDo: In Progress]
sDrvrId | [ToDo: In Progress]
ihstmt | [ToDo: In Progress]
iCol | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cSQLStatement [Function SQLPrivateColumnValue]

SQLPrivateColumnValue - cSQLStatement

Type: Function

Return Data Type: String

Parameters: Integer iCol Integer ihdbc String sDrvrId Integer ihstmt

Parameter | Description
iCol | [ToDo: In Progress]
ihdbc | [ToDo: In Progress]
sDrvrId | [ToDo: In Progress]
ihstmt | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cSQLStatement [Function SQLPrivateStmtAttribute]

SQLPrivateStmtAttribute - cSQLStatement

Type: Function

Return Data Type: String

Parameters: Integer iAttribId Integer ihdbc String sDrvrId Integer ihstmt

Parameter | Description
iAttribId | [ToDo: In Progress]
ihdbc | [ToDo: In Progress]
sDrvrId | [ToDo: In Progress]
ihstmt | [ToDo: In Progress]

Return Value

Description

Last Edited: June 2, 2006


cSQLStatement [Function SQLReturnValue]

SQLReturnValue - cSQLStatement

Get a stored function return value.

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

This function retrieves the return value of a stored function. If the module you are calling does not have a return value, i.e. it is a procedure, no error will be generated and the return value will be returned as an empty string.

Description

This function retrieves the return value of a stored function. Return values are commonly used to indicate success or failure of a stored function. If the module you are calling does not have a return value, i.e. it is a procedure, no error will be generated and the return value will be returned as an empty string.

See the sp_help sample application in Chapter 3 - Embedded SQL in DataFlex for a sample on calling a stored function.

Last Edited: April 20, 2005


cSQLStatement [Function SQLStmtAttribute]

SQLStmtAttribute - cSQLStatement

Returns a statement attribute.

Type: Function

Return Data Type: String

Parameters: Integer iAttribId

Parameter | Description
iAttribId | Attribute id to return

Return Value

Returns a statement attribute.

Description

Returns the specified statement attribute.

Attribute | Description
COLUMNCOUNT | The number of columns in the result set of the statement.
ROWCOUNT | The number of rows in the result of the statement. For update, delete or insert statement this attribute returns the number of rows affected by the statement.
ROWCOUNT_TYPEThe accuracy of the rowcount attribute. This attribute can be:

Constant | Meaning
1 | The rowcount returns the exact number of rows
0 | The rowcount does not return a meaningfull value
-1 | The rowcount is approximate
The rowcount type depends on the type of cursor used for the Embedded SQL statement. Some backends will automatically adjust cursor types. SQL Server for example does not support all cursor types to use certain statements. If a statement is issued for a non-supported cursor type, the cursor type will be adjusted.

NUMMESSAGES | The number of informational messages of the statement. You can get the messages by calling SQLGetMessage.

The attributes described above can be accessed through predefined constants. These constants have the SQLSTMTATTRIB_ prefix. So to get the number of columns of a statement, one would program:

Get SQLStmtAttribute Of hstmt SQLSTMTATTRIB_COLUMNCOUNT ;
    To iNumColumns

Sample

A full source example of getting the column count of a select statement is:

Handle hoSQLMngr
Handle hdbc hstmt
Integer iFetchResult
Integer iNumCols iCol
String sColumn

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Open Customer
Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc
Get SQLOpen Of hdbc To hstmt
Send SQLExecDirect Of hstmt "select * from customer" Get SQLStmtAttribute Of hstmt SQLSTMTATTRIB_COLUMNCOUNT To iNumCols
Repeat
    Get SQLFetch Of hstmt To iFetchResult
    If (iFetchResult <> 0) Begin
        For iCol From 1 To iNumCols
            Get SQLColumnValue Of hstmt iCol To sColumn
            Show sColumn
            If (iCol < iNumCols) ;
                Show ", "
        Loop
        Showln
    End
Until (iFetchResult = 0)

Send SQLClose Of hstmt
Send SQLDisconnect Of hdbc

Last Edited: April 20, 2005


Methods for cSQLStatement

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
DFDateToSQLDate | Function |  |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FreeHandle | Procedure |  |
HandleError | Procedure |  |
RemoveComponentIdentifier | Function | Can be used to remove a component identifier from an informational message obtained by calling SQLGetMessage. |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array
SQLBindFile | Procedure | Add a file to the list of files bound to the statement result. |
SQLCall | Procedure | Call a stored procedure. |
SQLClose | Procedure | Close the statement handle and free the DataFlex statement handle object. |
SQLColAttribute | Function | Returns a column attribute. |
SQLColumnMap | Function | Returns a column number for a name. |
SQLColumnValue | Function | Get a column value. |
SQLDateToDFDate | Function |  |
SQLExecDirect | Procedure | This procedure combines the SQLPrepare and SQLExecute. |
SQLExecute | Procedure | Execute the prepared statement. |
SQLFetch | Function | Fetch the next row of the statement's result set. |
SQLFetchActivatesBuffer | Procedure | Connect or disconnect a file buffer to a statement result set. |
SQLGetArgument | Function | Get a stored procedure argument. |
SQLGetData | Function | Get data of a column. |
SQLGetMessage | Function | Get informational messages (if any). |
SQLGetNextArgument | Function |  |
SQLIllegalAttribute | Procedure |  |
SQLNextColumn | Function |  |
SQLNextResultSet | Function | Switch to the next result set of a batch or stored procedure. |
SQLPrepare | Procedure | Prepare a statement that is passed for execution. |
SQLPrivateColAttribute | Function |  |
SQLPrivateColumnIsLegal | Function |  |
SQLPrivateColumnValue | Function |  |
SQLPrivateStmtAttribute | Function |  |
SQLReturnValue | Function | Get a stored function return value. |
SQLSetArgument | Procedure | Setup a stored procedure argument so it can be passed. |
SQLSetNextArgument | Procedure |  |
SQLSetProcedureName | Procedure | Setup a stored procedure name so it can be called. |
SQLStmtAttribute | Function | Returns a statement attribute. |
StmtError | Procedure |  |
StoreHandleInfo | Procedure |  |


cSQLStatement [Procedure FreeHandle]

FreeHandle - cSQLStatement

Type: Procedure

Parameters: No Parameters

Description

Last Edited: June 2, 2006


cSQLStatement [Procedure HandleError]

HandleError - cSQLStatement

Type: Procedure

Parameters: Integer ihstmt Integer ihdbc String sDrvrId String sOriginMsg

Parameter | Description
ihstmt | [ToDo: In Progress]
ihdbc | [ToDo: In Progress]
sDrvrId | [ToDo: In Progress]
sOriginMsg | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


cSQLStatement [Procedure SQLBindFile]

SQLBindFile - cSQLStatement

Add a file to the list of files bound to the statement result.

Type: Procedure

Parameters: Integer iFileNum

Parameter | Description
iFileNum | The number of the table to bind

Description

Binds a file buffer to a fetched row. This message is sent after the SQLFetch function to place the columns values in a file buffer. The buffer's status will not be updated by the SQLBindFile procedure. Whether the buffer's status is updated depends on the SQLFetchActivatesBuffer message calls.

It is not possible to bind a buffer of a different type than the Connectivity Kit in use. You cannot use SQLBindFile to bind a result set row of a SQL Server statement to a DataFlex file buffer. In that case, use the SQLColumnValue message.

If the file number that is passed is 0 (zero), the piBindFile property of the cSQLStatement object will be used for binding. If that property is not set, an error will be generated.

Sample

This code sample shows two ways to use SQLBindFile. One is by passing no file number; the other is by passing an explicit file number.

Handle hoSQLMngr
Handle hdbc hstmt
Integer iFetchResult

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Open Customer
Open Vendor
Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc

//*** First sample
Showln ">> List Customers <<"
Get SQLOpen Of hdbc To hstmt
Send SQLExecDirect Of hstmt "select * from customer"
Repeat
    Get SQLFetch Of hstmt To iFetchResult
    If (iFetchResult <> 0) Begin
        Send SQLBindFile Of hstmt 0
        Showln Customer.Name ", " Customer.State
    End
Until (iFetchResult = 0)

Send SQLClose Of hstmt
Showln

//*** Second sample
Showln ">> List Vendors <<"
Get SQLOpen Of hdbc To hstmt
Send SQLExecDirect Of hstmt "select * from vendor"
Repeat
    Get SQLFetch Of hstmt To iFetchResult
    If (iFetchResult <> 0) Begin
        Send SQLBindFile Of hstmt Vendor.File_number
        Showln Vendor.Name ", " Vendor.State
    End
Until (iFetchResult = 0)

Send SQLClose Of hstmt
Send SQLDisconnect Of hdbc

Last Edited: April 20, 2005


cSQLStatement [Procedure SQLCall]

SQLCall - cSQLStatement

Call a stored procedure.

Type: Procedure

Parameters: No Parameters

Description

Call a stored procedure or stored function. The procedure specifics must have been setup by calls to the SQLSetProcedureName and SQLSetArgument messages.

See the sp_help sample application in Chapter 3 - Embedded SQL in DataFlex for a sample on calling a stored function.

Last Edited: April 20, 2005


cSQLStatement [Procedure SQLClose]

SQLClose - cSQLStatement

Close the statement handle and free the DataFlex statement handle object.

Type: Procedure

Parameters: No Parameters

Description

This procedure will call the Connectivity Kit's close function and free the DataFlex statement object.

Sample

Handle hoSQLMngr
Handle hdbc hstmt

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Open Customer
Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc
Get SQLOpen Of hdbc To hstmt
Send DoSomeEmbeddedSQLStuff hstmt
Send SQLClose Of hstmt
Send SQLDisconnect Of hdbc

Last Edited: April 19, 2005


cSQLStatement [Procedure SQLExecDirect]

SQLExecDirect - cSQLStatement

This procedure combines the SQLPrepare and SQLExecute.

Type: Procedure

Parameters: String sStatement

Parameter | Description
sStatement | SQL statement to execute

Description

Execute the passed statement. Direct execution is intended for statements that are only executed once. If you need to execute a statement more than once, use the SQLPrepare, SQLExecute messages.

Sample

Handle hoSQLMngr
Handle hdbc hstmt

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Open Customer
Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc
Get SQLOpen Of hdbc To hstmt
Send SQLExecDirect Of hstmt "delete from customer"
Send SQLClose Of hstmt
Send SQLDisconnect Of hdbc

Last Edited: April 22, 2005


cSQLStatement [Procedure SQLExecute]

SQLExecute - cSQLStatement

Execute the prepared statement.

Type: Procedure

Parameters: No Parameters

Description

The SQLExecute procedure executes a prepared statement. Prepared execution is an efficient way to execute a query more than once. Preparing a statement will create the statement's access plan. Calling SQLExecute will execute the prepared statement. Prepared execution is faster than direct execution for statements executed more than once, primarily because the access plan is only created once.

Sample

Handle hoSQLMngr
Handle hsbc hstmt

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Open Customer
Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc
Get SQLOpen Of hdbc To hstmt
Send SQLPrepare Of hstmt "delete from customer"
Send SQLExecute Of hstmt
Send SQLClose Of hstmt
Send SQLDisconnect Of hdbc

Last Edited: April 19, 2005


cSQLStatement [Procedure SQLFetchActivatesBuffer]

SQLFetchActivatesBuffer - cSQLStatement

Connect or disconnect a file buffer to a statement result set.

Type: Procedure

Parameters: Integer iFileNum Integer bState

Parameter | Description
iFileNum | Table whose file buffer to connect to
bState | Buffer state

Description

If bState is true, the message will setup a buffer so its DF_FILE_STATUS file attribute is set to DF_FILE_ACTIVE when the SQLFetch message is called for this statement. This message only handles the status of the buffer; to bind a buffer to a statement you must use SQLBindFile.

If bState is false, the status of the buffer will no longer be set when SQLFetch is called. The binding that may exist will not be removed. To bind a buffer to a statement use SQLBindFile.

Setting up a buffer to be activated in this way will interfere with internal Connectivity Kit optimization logic. Make sure to switch off the behavior as soon as it is no longer needed.

There is no check if the statement contains columns of the buffer in question! It is not possible to bind a buffer of a different type than the Connectivity Kit in use. You cannot use SQLFetchActivatesBuffer to activate a DataFlex buffer from a SQL Server statement.

Last Edited: April 22, 2005


cSQLStatement [Procedure SQLIllegalAttribute]

SQLIllegalAttribute - cSQLStatement

Type: Procedure

Parameters: String sErrText String sOriginMsg

Parameter | Description
sErrText | [ToDo: In Progress]
sOriginMsg | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


cSQLStatement [Procedure SQLPrepare]

SQLPrepare - cSQLStatement

Prepare a statement that is passed for execution.

Type: Procedure

Parameters: String sStatement

Parameter | Description
sStatement | Statement to prepare

Description

Prepare the passed statement for execution. Prepared execution is an efficient way to execute a query more than once. Preparing a statement will create the statement's access plan. Calling SQLExecute will execute the prepared statement. Prepared execution is faster than direct execution for statements executed more than once, primarily because the access plan is created only once.

Sample

Handle hoSQLMngr
Handle hdbc hstmt hstmt2
integer iFetchResult
string sName sState sCrLim sBal

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Open Customer
Get SQLFileConnect Of hoSQLMngr Customer.File_number To hdbc
Get SQLOpen Of hDbc To hStmt
Send SQLPrepare Of hstmt "select name, state, credit_limit, balance from Customer"
Send SQLExecute Of hstmt
Showln ">> Customer Before Update <<"
Repeat
    Get SQLFetch Of hstmt To iFetchResult
    If (iFetchResult <> 0) Begin
        Get SQLColumnValue Of hstmt 1 To sName
        Get SQLColumnValue Of hstmt 2 To sState
        Get SQLColumnValue Of hstmt 3 To sCrLim
        Get SQLColumnValue Of hstmt 3 To sBal
        Showln sName ", " sState ", " sCrLim ", " sBal
    End
Until (iFetchResult = 0)

Showln
Get SQLOpen Of hdbc To hstmt2
Send SQLExecDirect To hstmt2 "update customer set credit_limit=5000 where state='CA' and purchases > 1000"
Send SQLExecute Of hstmt
Showln ">> Customer After Update <<"
Repeat
    Get SQLFetch Of hstmt To iFetchResult
    If (iFetchResult <> 0) Begin
        Get SQLColumnValue Of hstmt 1 To sName
        Get SQLColumnValue Of hstmt 2 To sState
        Get SQLColumnValue Of hstmt 3 To sCrLim
        Get SQLColumnValue Of hstmt 3 To sBal
        Showln sName ", " sState ", " sCrLim ", " sBal
    End
Until (iFetchResult = 0)

Send SQLClose Of hstmt
Send SQLDisconnect Of hdbc

Last Edited: April 19, 2005


cSQLStatement [Procedure SQLSetArgument]

SQLSetArgument - cSQLStatement

Setup a stored procedure argument so it can be passed.

Type: Procedure

Parameters: Integer iArgnum String sArgument

Parameter | Description
iArgnum | Argument number
sArgument | Argument name

Description

Set up an argument to pass to a stored procedure or stored function. This message is intended to setup the in or in/out arguments for a stored procedure or stored function. Before you can call this message you must call the SQLSetProcedureName message.

If the argument you are trying to set does not exist, i.e. it was not reported by the backend as an argument, no error will be generated and the argument will be ignored.

See the sp_help sample application in Chapter 3 - Embedded SQL in DataFlex for a sample on calling a stored function.

Last Edited: April 20, 2005


cSQLStatement [Procedure SQLSetNextArgument]

SQLSetNextArgument - cSQLStatement

Type: Procedure

Parameters: String sArgument

Parameter | Description
sArgument | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


cSQLStatement [Procedure SQLSetProcedureName]

SQLSetProcedureName - cSQLStatement

Setup a stored procedure name so it can be called.

Type: Procedure

Parameters: String sProcName String sSchemaArg

Parameter | Description
sProcName | Stored procedure name
sSchemaArg | Schema name

Description

Set up the name of a stored procedure or stored function to call. Internally the Connectivity Kit will check the procedure definition on the backend database. It will allocate the room to store the arguments and return value, if any.

If the procedure is defined for a particular schema, you can optionally pass the schema name as the second parameter.
See the sp_help sample application in Chapter 3 - Embedded SQL in DataFlex for a sample on calling a stored function.

Last Edited: April 20, 2005


cSQLStatement [Procedure StmtError]

StmtError - cSQLStatement

Type: Procedure

Parameters: Integer iErrNum String sErrText String sOriginMsg

Parameter | Description
iErrNum | [ToDo: In Progress]
sErrText | [ToDo: In Progress]
sOriginMsg | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


cSQLStatement [Procedure StoreHandleInfo]

StoreHandleInfo - cSQLStatement

Type: Procedure

Parameters: Integer iCLIHandle String sDrvrId Integer iParentHandle

Parameter | Description
iCLIHandle | [ToDo: In Progress]
sDrvrId | [ToDo: In Progress]
iParentHandle | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


Properties for cSQLStatement

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phCLIHandle |  |
phStmtConnection |  |
piBindFile | The default file for file-fetch operations. |
piLastArgument |  |
piLastColumn |  |
psDriverID |  |
Value | Sets and Gets an array element's value | Array


cSQLStatement [Property phCLIHandle]

phCLIHandle - cSQLStatement

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: June 2, 2006


cSQLStatement [Property phStmtConnection]

phStmtConnection - cSQLStatement

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: June 2, 2006


cSQLStatement [Property piBindFile]

piBindFile - cSQLStatement

The default file for file-fetch operations.

Type: Property

Access: Read/Write

Data Type: Integer

Description

The piBindFile property stores the default file buffer to use for this statement's file-fetch operations. It should be set to a file number. Whenever the SQLBindFile message is called and the passed file number is 0 (zero), this property will be used.

Sample

The code sample uses three different ways to set the piBindFile property to the Customer file number. One is by using a "normal" connect and explicitly setting the property. The other is by using SQLFileConnect implicitly setting the property.
The first two ways set the property at connection level. This implicitly sets the property for all statements that are created for that connection. The last sample sets the property explicitly for one statement.

Handle hoSQLMngr
Handle hdbc hstmt

Object oSQLHandler Is A cSQLHandleManager
    Move Self To hoSQLMngr
End_Object

Send SQLSetConnect Of hoSQLMngr "MSSQLDRV" "SERVER=(local)"
Get SQLConnect Of hoSQLMngr "" "" To hdbc
Set piBindFile Of hdbc To Customer.File_number
Get SQLFileConnect Of hoSQLMngr Customer.File_Number To hdbc
Get SQLOpen Of hdbc To hstmt Set piBindFile Of hstmt To Customer.File_Number

Last Edited: April 19, 2005


cSQLStatement [Property piLastArgument]

piLastArgument - cSQLStatement

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: June 2, 2006


cSQLStatement [Property piLastColumn]

piLastColumn - cSQLStatement

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: June 2, 2006


cSQLStatement [Property psDriverID]

psDriverID - cSQLStatement

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: June 2, 2006


cStatusBar [Event OnClick]

OnClick - cStatusBar

Received whenever the mouse's left button is clicked in the statusbar

Type: Event

Parameters: No Parameters

Description

The OnClick event is received whenever the mouse's left button is clicked in the statusbar. Note that if the click occurs in one of the panes, then the pane will receive the event, not the statusbar. Consequently, this event is rarely received, as the panes typically cover most of the statusbar.

Note: You can also use the cWinControl's OnMouseDown, OnMouseUp, OnMouseDoubleClick and OnMouseMove mouse messages.

Last Edited: September 10, 2003


cStatusBar [Event OnDoubleClick]

OnDoubleClick - cStatusBar

Received whenever the mouse's left button is double-clicked in the statusbar

Type: Event

Parameters: No Parameters

Description

The OnDoubleClick event is received whenever the mouse's left button is double-clicked in the statusbar. Note that if the double-click occurs in one of the panes, then the pane will receive the event, not the statusbar. Consequently, this event is rarely received, as the panes typically cover most of the statusbar.

Note: You can also use the cWinControl's OnMouseDown, OnMouseUp, OnMouseDoubleClick and OnMouseMove mouse messages.

Last Edited: September 10, 2003


cStatusBar [Event OnDoubleRightClick]

OnDoubleRightClick - cStatusBar

Received whenever the mouse's right button is double-clicked in the statusbar

Type: Event

Parameters: No Parameters

Description

The OnDoubleRightClick event is received whenever the mouse's right button is double-clicked in the statusbar. Note that if the double-click occurs in one of the panes, then the pane will receive the event, not the statusbar. Consequently, this event is rarely received, as the panes typically cover most of the statusbar.

Note: You can also use the cWinControl's OnMouseDown, OnMouseUp, OnMouseDoubleClick and OnMouseMove mouse messages.

Last Edited: September 10, 2003


cStatusBar [Event OnRightClick]

OnRightClick - cStatusBar

Received whenever the mouse's right button is clicked in the statusbar

Type: Event

Parameters: No Parameters

Description

The OnRightClick event is received whenever the mouse's right button is clicked in the statusbar. Note that if the click occurs in one of the panes, then the pane will receive the event, not the statusbar. Consequently, this event is rarely received, as the panes typically cover most of the statusbar.

Note: You can also use the cWinControl's OnMouseDown, OnMouseUp, OnMouseDoubleClick and OnMouseMove mouse messages.

Last Edited: September 10, 2003


cStatusBar [Event OnSimpleModeChange]

OnSimpleModeChange - cStatusBar

Received whenever the statusbar changes between the modes of Simple or Panes

Type: Event

Parameters: No Parameters

Description

The OnSimpleModeChange event is received whenever the statusbar changes between the modes of Simple or Panes. To determine which mode the statusbar is in, use the pbSimple property.

Last Edited: September 10, 2003


Events for cStatusBar

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnClick | Received whenever the mouse's left button is clicked in the statusbar |
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDoubleClick | Received whenever the mouse's left button is double-clicked in the statusbar |
OnDoubleRightClick | Received whenever the mouse's right button is double-clicked in the statusbar |
OnMouseDoubleClick | Received whenever a mouse button is double-clicked on the control | cWinControl
OnMouseDown | Received whenever a mouse button is pressed on the control | cWinControl
OnMouseMove | Received whenever the mouse cursor moves over a control | cWinControl
OnMouseUp | Received whenever a mouse button is released on the control | cWinControl
OnRightClick | Received whenever the mouse's right button is clicked in the statusbar |
OnSimpleModeChange | Received whenever the statusbar changes between the modes of Simple or Panes |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


cStatusBar [Function NumberOfPanes]

NumberOfPanes - cStatusBar

Returns the number of panes (that is, cStatusPane objects) that are in the statusbar

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The number of panes that are in the statusbar

Description

The NumberOfPanes function returns the number of panes (that is, cStatusPane objects) that are in the statusbar.

Although each pane is an object, it is described in the internal cCollection object, which you can access through the phoPanes property. This allows you to reference each object via its index.

This sample shows how to enumerate the panes and show the psLabel of each:

Get NumberOfPanes To icPane
For iPane from 0 To (icPane -1)
    Get ObjectFromIndex of (phoPanes(self)) iPane To hoPane
    Get psLabel of hoPane To sLabel
    ShowLn `Pane ` iPane ` has a label of: ` sLabel
Loop

Last Edited: September 10, 2003


cStatusBar [Function PaneTextWidth]

PaneTextWidth - cStatusBar

Returns the width, in pixels, of the string, sText

Type: Function

Return Data Type: Integer

Parameters: String sText

Parameter | Description
sText | The string

Return Value

The width, in pixels, of the string, sText

Description

PaneTextWidth returns the width, in pixels, of the string, sText. You can then use this to set the piWidth of a panel.

You can only use this function when the statusbar has had its window created. Therefore, you should check the Window_Handle property before you use this.

Last Edited: September 10, 2003


Methods for cStatusBar

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoRecreateWindow | Procedure | Recreates a window | cWinControl
DoUpdateWindow | Procedure | Updates a window if it needs repainting | cWinControl
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
NumberOfPanes | Function | Returns the number of panes (that is, cStatusPane objects) that are in the statusbar |
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
PaneTextWidth | Function | Returns the width, in pixels, of the string, sText |
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for cStatusBar

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbEnabled | Enables the control to take user input | cWinControl
pbInMdiPanel | Determines if the statusbar will communicate with the MDI-panel |
pbSimple | Determines if statusbar shows its panes and the text/icon within them |
pbSizeGrip | Determines if Grip is shown or hidden |
pbTooltips |  |
pbVisible | Makes a control visible or invisible | cWinControl
peAlign | Determines how the statusbar is aligned within the parent object |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phoPanes | Stores the object-handle of the internal cCollection object that holds the object-handles of the child cStatusPane objects |
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piBackColor | Sets the background color of the statusbar |
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piStatusHelpPaneIndex | Determines which pane should show this status-help |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psSimpleValue | Stores the string that will be displayed when the statusbar is in simple mode |
psStatusHelp |  |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cStatusBar [Property pbInMdiPanel]

pbInMdiPanel - cStatusBar

Determines if the statusbar will communicate with the MDI-panel

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the pbInMdiPanel property is True, the statusbar will communicate with the MDI-panel (Panel class, for example) to ensure that the panel's Client-Area is set automatically.

The only time you will need to change this property is when you want to use a statusbar in a non-MDI panel, such as a ToolPanel, in which case, you should set it to False.

Default is true.

Last Edited: September 10, 2003


cStatusBar [Property pbSimple]

pbSimple - cStatusBar

Determines if statusbar shows its panes and the text/icon within them

Type: Property

Access: Read/Write

Data Type: Boolean

Description

By default, the statusbar shows its panes and the text/icon within them. You can use the pbSimple property to switch to simple mode. When pbSimple is True, the statusbar only shows a single string and hides its panes and when it is False, it will display the panes again and hide the single string.

This example switches to simple mode, displays a string while it performs an action, then displays the panes again:

Set psSimpleValue To "Working. Please wait."
Set pbSimple To True // hides the panes
// perform action that requires the message to be displayed
// Set pbSimple To False // the panes will be displayed

Default is false.

Last Edited: September 10, 2003


cStatusBar [Property pbSizeGrip]

pbSizeGrip - cStatusBar

Determines if Grip is shown or hidden

Type: Property

Access: Read/Write

Data Type: Boolean

Description

By default, the Statusbar can display a Grip at the bottom right corner that acts as a visual indication that the object containing the statusbar can be resized. Set this property to False to hide the Grip.

Default is true.

Last Edited: September 10, 2003


cStatusBar [Property pbTooltips]

pbTooltips - cStatusBar

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: August 7, 2003


cStatusBar [Property peAlign]

peAlign - cStatusBar

Determines how the statusbar is aligned within the parent object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The peAlign property determines how the statusbar is aligned within the parent object. By default, a statusbar is aligned to the bottom of the parent window and is automatically sized and aligned whenever the size of the parent window changes.

Set this property to alNone to prevent the automatic sizing and alignment. When set to alNone, you will be responsible for setting the size and location of the statusbar yourself.

Default is alBottom.

Last Edited: September 10, 2003


cStatusBar [Property phoPanes]

phoPanes - cStatusBar

Stores the object-handle of the internal cCollection object that holds the object-handles of the child cStatusPane objects

Type: Property

Access: Read/Write

Data Type: Handle

Description

phoPanes stores the object-handle of the internal cCollection object that holds the object-handles of the child cStatusPane objects.

As you create or destroy cStatusPane objects, the cStatusBar maintains the list in an internal cCollection object. The phoPanes property is set automatically, but you can read it if you want to traverse the list of panes. For example, this is how you might display the labels of all the panes:

Get NumberOfPanes To icPane
For iPane from 0 To (icPane -1)
    Get ObjectFromIndex of (phoPanes(self)) iPane To hoPane
    Get psLabel of hoPane To sLabel
    ShowLn `Pane ` iPane ` has a label of: ` sLabel
Loop

Last Edited: September 11, 2003


cStatusBar [Property piBackColor]

piBackColor - cStatusBar

Sets the background color of the statusbar

Type: Property

Access: Read/Write

Data Type: Integer

Description

piBackColor sets the background color of the statusbar. By default, this is clDefault, which means that Windows will automatically determine the color for you, based on the current Windows color configuration.

You can set this property to any RGB color or to any standard color symbol, such as clLtGray or clRed, etc. You cannot, however, set the color to a Windows' System Color such as clBtnFace.

Note that while the color of the statusbar respects this property, the Grip does not. This means that if the pbSizeGrip is True, the Grip may have a different color than the statusbar.

Default is clDefault.

Last Edited: September 11, 2003


cStatusBar [Property piStatusHelpPaneIndex]

piStatusHelpPaneIndex - cStatusBar

Determines which pane should show this status-help

Type: Property

Access: Read/Write

Data Type: Integer

Description

As the user navigates the focus between controls, the control's Status_Help property is automatically displayed in the statusbar. The piStatusHelpPaneIndex property determines which pane should show this status-help.

The property takes the zero-based index of the pane, not its object-handle. By default, the property is zero, which is the first pane.

Status-help is only shown in the statusbar if the pbInMdiPanel property is True.

Default is 0.

Last Edited: September 11, 2003


cStatusBar [Property psSimpleValue]

psSimpleValue - cStatusBar

Stores the string that will be displayed when the statusbar is in simple mode

Type: Property

Access: Read/Write

Data Type: String

Description

psSimpleValue stores the string that will be displayed when the statusbar is in simple mode.

Default is "".

See Also

pbSimple

Last Edited: September 11, 2003


cStatusBar [Property psStatusHelp]

psStatusHelp - cStatusBar

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


cStatusPane [Event OnClick]

OnClick - cStatusPane

Received whenever the mouse's left button is clicked in the pane

Type: Event

Parameters: No Parameters

Description

The OnClick event is received whenever the mouse's left button is clicked in the pane. However, this event can be redirected by setting the phmOnClick property to a different message-handle.

Note: You can also use the cWinControl's OnMouseDown, OnMouseUp, OnMouseDoubleClick and OnMouseMove mouse messages in the statusbar.

Last Edited: September 10, 2003


cStatusPane [Event OnDoubleClick]

OnDoubleClick - cStatusPane

Received whenever the mouse's left button is double-clicked in the pane

Type: Event

Parameters: No Parameters

Description

The OnDoubleClick event is received whenever the mouse's left button is double-clicked in the pane. However, this event can be redirected by setting the phmOnDoubleClick property to a different message-handle.

Note: You can also use the cWinControl's OnMouseDown, OnMouseUp, OnMouseDoubleClick and OnMouseMove mouse messages in the statusbar.

Last Edited: September 10, 2003


cStatusPane [Event OnDoubleRightClick]

OnDoubleRightClick - cStatusPane

Received whenever the mouse's right button is double-clicked in the pane

Type: Event

Parameters: No Parameters

Description

The OnDoubleRightClick event is received whenever the mouse's right button is double-clicked in the pane. However, this event can be redirected by setting the phmOnDoubleRightClick property to a different message-handle.

Note: You can also use the cWinControl's OnMouseDown, OnMouseUp, OnMouseDoubleClick and OnMouseMove mouse messages in the statusbar.

Last Edited: September 10, 2003


cStatusPane [Event OnRightClick]

OnRightClick - cStatusPane

Received whenever the mouse's right button is clicked in the pane

Type: Event

Parameters: No Parameters

Description

The OnRightClick event is received whenever the mouse's right button is clicked in the pane. However, this event can be redirected by setting the phmOnRightClick property to a different message-handle.

Note: You can also use the cWinControl's OnMouseDown, OnMouseUp, OnMouseDoubleClick and OnMouseMove mouse messages in the statusbar.

Last Edited: September 10, 2003


Events for cStatusPane

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnClick | Received whenever the mouse's left button is clicked in the pane |
OnDoubleClick | Received whenever the mouse's left button is double-clicked in the pane |
OnDoubleRightClick | Received whenever the mouse's right button is double-clicked in the pane |
OnRightClick | Received whenever the mouse's right button is clicked in the pane |


Methods for cStatusPane

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cStatusPane

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAlignment | Determines how the text is aligned |
peBevel | Determines where the beveled edge is drawn |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phIcon | Stores the window handle of an icon that is loaded into memory |
phmOnClick | Stores the method-handle of the event to send whenever the pane is clicked |
phmOnDoubleClick | Stores the method-handle of the event to send whenever the pane is double-clicked with the left mouse button |
phmOnDoubleRightClick | Stores the method-handle of the event to send whenever the pane is double-clicked with the right mouse button |
phmOnRightClick | Stores the method-handle of the event to send whenever the pane is clicked with the right mouse button |
piWidth | Determines the width of the pane |
psIcon | Determines whether pane is displayed as an Icon or a string |
psLabel | Contains the text that you want to display in a pane |
psToolTip |  |


cStatusPane [Property peAlignment]

peAlignment - cStatusPane

Determines how the text is aligned

Type: Property

Access: Read/Write

Data Type: String

Description

The text within the pane can be aligned left, right or centered. Set the peAlignment property to asLeft to align it left, asRight to align it right or asCenter to center it.

Default is "asLeft".

Last Edited: September 10, 2003


cStatusPane [Property peBevel]

peBevel - cStatusPane

Determines where the beveled edge is drawn

Type: Property

Access: Read/Write

Data Type: Integer

Description

Each pane can be displayed with a beveled edge drawn around it. Set the peBevel property to bsLowered to draw it lowered, to bsRaised to draw it raised or bsNone if you do not want a bevel drawn.

Default is bsLowered.

Last Edited: September 11, 2003


cStatusPane [Property phIcon]

phIcon - cStatusPane

Stores the window handle of an icon that is loaded into memory

Type: Property

Access: Read/Write

Data Type: Handle

Description

When an icon is loaded into memory (by setting the psIcon property), its Windows' handle is stored in the phIcon property. It is unlikely that you will ever need to use this property, but if you want to override the default icon-handling logic, you can set this yourself. You will need to have a deep understanding of the Windows' API to successfully manage this property yourself.

Note:This is for advanced use only

Last Edited: September 25, 2003


cStatusPane [Property phmOnClick]

phmOnClick - cStatusPane

Stores the method-handle of the event to send whenever the pane is clicked

Type: Property

Access: Read/Write

Data Type: Handle

Description

phmOnClick stores the method-handle of the event to send whenever the pane is clicked. By default, this is msg_OnClick, which means that the OnClick message will be sent.

You can change this property to create a Shared Handler to redirect the event.

Default is msg_OnClick.

Last Edited: September 11, 2003


cStatusPane [Property phmOnDoubleClick]

phmOnDoubleClick - cStatusPane

Stores the method-handle of the event to send whenever the pane is double-clicked with the left mouse button

Type: Property

Access: Read/Write

Data Type: Handle

Description

phmOnDoubleClick stores the method-handle of the event to send whenever the pane is double-clicked with the left mouse button. By default, this is msg_OnDoubleClick, which means that the OnDoubleClick message will be sent.

You can change this property to create a Shared Handler to redirect the event.

Default is msg_OnDoubleClick.

Last Edited: September 11, 2003


cStatusPane [Property phmOnDoubleRightClick]

phmOnDoubleRightClick - cStatusPane

Stores the method-handle of the event to send whenever the pane is double-clicked with the right mouse button

Type: Property

Access: Read/Write

Data Type: Handle

Description

phmOnDoubleRightClick stores the method-handle of the event to send whenever the pane is double-clicked with the right mouse button. By default, this is msg_OnDoubleRightClick, which means that the OnDoubleRightClick message will be sent.

You can change this property to create a Shared Handler to redirect the event.

Default is msg_OnDoubleRightClick.

Last Edited: September 11, 2003


cStatusPane [Property phmOnRightClick]

phmOnRightClick - cStatusPane

Stores the method-handle of the event to send whenever the pane is clicked with the right mouse button

Type: Property

Access: Read/Write

Data Type: Handle

Description

phmOnRightClick stores the method-handle of the event to send whenever the pane is clicked with the right mouse button. By default, this is msg_OnRightClick, which means that the OnRightClick message will be sent.

You can change this property to create a Shared Handler to redirect the event.

Default is msg_OnRightClick.

Last Edited: September 11, 2003


cStatusPane [Property piWidth]

piWidth - cStatusPane

Determines the width of the pane

Type: Property

Access: Read/Write

Data Type: Integer

Description

piWidth determines the width of the pane. The width is expressed in pixels, not logical units.

You can use the cStatusbar's PaneTextWidth function to determine the width the width of a string, if necessary, but remember to add room for any bevel.

Last Edited: September 11, 2003


cStatusPane [Property psIcon]

psIcon - cStatusPane

Determines whether pane is displayed as an Icon or a string

Type: Property

Access: Read/Write

Data Type: String

Description

Each pane can display either an Icon or a string. To display an icon, set the psIcon property to the name of an icon file (for example, MyIcon.ico). The psIcon property takes precedence over the psLabel property, so if you want to show a string after showing an icon, you will need to set psIcon to null and then psLabel to the string that you want to display.

Last Edited: September 11, 2003


cStatusPane [Property psLabel]

psLabel - cStatusPane

Contains the text that you want to display in a pane

Type: Property

Access: Read/Write

Data Type: String

Description

The psLabel property contains the text that you want to display in a pane.

Use the peAlignment property to align this text within the pane.

Last Edited: September 11, 2003


cStatusPane [Property psToolTip]

psToolTip - cStatusPane

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: August 7, 2003


Events for cStatusPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


Methods for cStatusPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure |  |
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
close_panel | Procedure |  |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure |  |
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
ProcessEvents | Procedure |  |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


cStatusPanel [Procedure Activate]

Activate - cStatusPanel

Type: Procedure

Parameters: No Parameters

Description

Last Edited: December 2, 2005


cStatusPanel [Procedure close_panel]

close_panel - cStatusPanel

Type: Procedure

Parameters: No Parameters

Description

Last Edited: December 2, 2005


cStatusPanel [Procedure Deactivate]

Deactivate - cStatusPanel

Type: Procedure

Parameters: Integer eDeactivateScope

Parameter | Description
eDeactivateScope | [ToDo: In Progress]

Description

Last Edited: July 11, 2006


cStatusPanel [Procedure ProcessEvents]

ProcessEvents - cStatusPanel

Type: Procedure

Parameters: No Parameters

Description

Last Edited: December 2, 2005


Properties for cStatusPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Events for cTableColumnFetchHelper

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cTableColumnFetchHelper [Function IsTableIn]

IsTableIn - cTableColumnFetchHelper

Determines if iTable is added to this object's list of tables.

Type: Function

Return Data Type: Boolean

Parameters: integer iTable

Parameter | Description
iTable | Number of the table to to check.

Return Value

Description

Determines if iTable is added to this object's list of tables. You use this when you've set pbUseAllTables to False.

Boolean bIsIn
Get IsTableIn of oFetchHelper Customer.File_Number to bIsIn

Last Edited: April 21, 2005


cTableColumnFetchHelper [Function TableCount]

TableCount - cTableColumnFetchHelper

Returns the number of tables in the object's table list.

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the number of tables in the object's table list.

Description

Returns the number of tables in the object's table list. You use this when you've set pbUseAllTables to False.

Get TableCount of oFetchHelper to iCount
For iIndex from 0 to (iCount-1)
Get TableHandle of oFetchHelper iIndex to iTable
:
Loop

Last Edited: April 21, 2005


cTableColumnFetchHelper [Function TableHandle]

TableHandle - cTableColumnFetchHelper

Returns the table handle (file number) for the table that is stored in index position iIndex.

Type: Function

Return Data Type: Integer

Parameters: integer iIndex

Parameter | Description
iIndex | Position of the table handle to return.

Return Value

Returns the table handle (file number) for the table that is stored in index position iIndex.

Description

Returns the table handle (file number) for the table that is stored in index position iIndex.

The index count is zero based:

Get TableCount of oFetchHelper to iCount
For iIndex from 0 to (iCount-1)
Get TableHandle of oFetchHelper iIndex to iTable
:
Loop

Last Edited: April 21, 2005


Methods for cTableColumnFetchHelper

View method list in hierarchical order

Name | Type | Description | Defining Class
AddTable | Procedure | This adds iTable to the object's list of tables. |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DisableAllColumnFetching | Procedure | Disables the fetching of all columns in all tables. |
DisableAllTextColumnFetching | Procedure | Disables the fetching of all text columns in all tables. |
EnableAllColumnFetching | Procedure | Enables the fetching of all columns in all tables. |
Exit_Application | Procedure | Starts the process of closing an application | cObject
IsTableIn | Function | Determines if iTable is added to this object's list of tables. |
RemoveTable | Procedure | Removes iTable from the object's list of tables. |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetAllTableColumnFetching | Procedure |  |
SetColumns | Procedure |  |
SetFetchAllColumns | Procedure | This sets the DF_FILE_FETCH_ALL_COLUMNS attribute for all tables to the value of bFetchAll. |
TableCount | Function | Returns the number of tables in the object's table list. |
TableHandle | Function | Returns the table handle (file number) for the table that is stored in index position iIndex. |


cTableColumnFetchHelper [Procedure AddTable]

AddTable - cTableColumnFetchHelper

This adds iTable to the object's list of tables.

Type: Procedure

Parameters: integer iTable

Parameter | Description
iTable | Number of the table to add to the list.

Description

This adds iTable to the object's list of tables. You use this when you have set pbUseAllTables to False.

Object oOrderFetcher is a cTableColumnFetchHelper
    Set pbUseAllTables to False

    Send AddTable Customer.File_Number
    Send AddTable OrderHea.File_Number
    Send AddTable OrderDtl.File_Number
    Send AddTable Vendor.File_Number
    Send AddTable Invt.File_Number
    Send AddTable Salesp.File_Number
End_Object  // oOrderFetcher

Last Edited: April 21, 2005


cTableColumnFetchHelper [Procedure DisableAllColumnFetching]

DisableAllColumnFetching - cTableColumnFetchHelper

Disables the fetching of all columns in all tables.

Type: Procedure

Parameters: No Parameters

Description

This disables the fetching of all columns in all tables. After you've set this you will always want to explicitly select some columns in tables for fetching.

Send DisableAllColumnFetching of oFetchHelper
Send PrepareColumns // just enable the columns you want
Send DoSomeProcess // run the process
Send EnableAllColumnFetching of oFetchHelper

When pbUseAllTables is true, all open tables are affected by this operation. When this property is false, only the tables added to this object's list are affected.

This message should be sent after files are opened.

Last Edited: April 21, 2005


cTableColumnFetchHelper [Procedure DisableAllTextColumnFetching]

DisableAllTextColumnFetching - cTableColumnFetchHelper

Disables the fetching of all text columns in all tables.

Type: Procedure

Parameters: No Parameters

Description

This disables the fetching of all text columns in all tables. This provides a quick and easy way to disable text column fetching in parts of your application. Turning off text field fetching can often speed up operations (assuming the operation does not need to use the field). This is often used in conjunction with the EnableAllColumnFetching method.

Send DisableAllTextColumnFetching of oFetchHelper
:
: // run some process that does not need text fields
:
Send EnableAllColumnFetching of oFetchHelper

When pbUseAllTables is true, all open tables are affected by this operation. When this property is false, only the tables added to this object's list are affected.

This message should be sent after files are opened.

Last Edited: April 21, 2005


cTableColumnFetchHelper [Procedure EnableAllColumnFetching]

EnableAllColumnFetching - cTableColumnFetchHelper

Enables the fetching of all columns in all tables.

Type: Procedure

Parameters: No Parameters

Description

This enables the fetching of all columns in all tables. This provides a quick and easy way to make sure that all columns in tables are "fetchable". This returns the tables to their default state which is: 1) DF_FILE_FETCH_ALL_COLUMNS is true and 2) DF_FIELD_FETCH_STATE is true for every column. This is often used in conjunction with the DisableAllTextColumnFetching method.

Send DisableAllTextColumnFetching of oFetchHelper
:
: // run some process that does not need text fields
:
Send EnableAllColumnFetching of oFetchHelper

When pbUseAllTables is true, all open tables are affected by this operation. When this property is false, only the tables added to this object's list are affected.

This message should be sent after files are opened.

Last Edited: April 22, 2005


cTableColumnFetchHelper [Procedure RemoveTable]

RemoveTable - cTableColumnFetchHelper

Removes iTable from the object's list of tables.

Type: Procedure

Parameters: integer iTable

Parameter | Description
iTable | Number of table to remove from list.

Description

Removes iTable from the object's list of tables. If the table is not in the list, nothing happens. You use this when you've set pbUseAllTables to False.

Last Edited: April 21, 2005


cTableColumnFetchHelper [Procedure SetAllTableColumnFetching]

SetAllTableColumnFetching - cTableColumnFetchHelper

Type: Procedure

Parameters: integer eMode

Parameter | Description
eMode | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


cTableColumnFetchHelper [Procedure SetColumns]

SetColumns - cTableColumnFetchHelper

Type: Procedure

Parameters: integer iTable integer eMode

Parameter | Description
iTable | [ToDo: In Progress]
eMode | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


cTableColumnFetchHelper [Procedure SetFetchAllColumns]

SetFetchAllColumns - cTableColumnFetchHelper

This sets the DF_FILE_FETCH_ALL_COLUMNS attribute for all tables to the value of bFetchAll.

Type: Procedure

Parameters: boolean bFetchAll

Parameter | Description
bFetchAll | Boolean value that DF_FILE_FETCH_ALL_COLUMNS should be set to

Description

This sets the DF_FILE_FETCH_ALL_COLUMNS attribute for all tables to the value of bFetchAll.

// First you carefully set the columns you want to be
// selectively fetched when all selected fetching is used.
Send SetColumnsToFetch
// this allows selected fetching
Send SetFetchAllColumns of oFetchHelper to False
:
:
// this enables all fetching
Send SetFetchAllColumns of oFetchHelper to True
:
:
// this again allows selected fetching use the same
// selected columns defined above
Send SetFetchAllColumns of oFetchHelper to False

When pbUseAllTables is true, all open tables are affected by this operation. When this property is false, only the tables added to this object's list are affected.

This message should be sent after files are opened.

Last Edited: April 21, 2005


Properties for cTableColumnFetchHelper

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbUseAllTables | Determines if all open tables should be operated on, or the object contains a list of tables that should be used instead. |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phoFiles |  |


cTableColumnFetchHelper [Property pbUseAllTables]

pbUseAllTables - cTableColumnFetchHelper

Determines if all open tables should be operated on, or the object contains a list of tables that should be used instead.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

This determines if all open tables should be operated on, or the object contains a list of tables that should be used instead. Normally, you will operate on all open files and you will, therefore, not need to change this property.

If this property is set false, you will need to create a list of files that this fetch helper object will use. Use the AddTable method to do this.

Object oOrderFetcher is a cTableColumnFetchHelper
    Set pbUseAllTables to False

    Send AddTable Customer.File_Number
    Send AddTable OrderHea.File_Number
    Send AddTable OrderDtl.File_Number
    Send AddTable Vendor.File_Number
    Send AddTable Invt.File_Number
    Send AddTable Salesp.File_Number
End_Object  // oOrderFetcher

Last Edited: April 21, 2005


cTableColumnFetchHelper [Property phoFiles]

phoFiles - cTableColumnFetchHelper

Type: Property

Access: Read/Write

Data Type: Handle

Description

Last Edited: June 2, 2006


cTextEdit [Event OnBeginningOfPanel]

OnBeginningOfPanel - cTextEdit

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


cTextEdit [Event OnChange]

OnChange - cTextEdit

Fires whenever the value of the control is changed

Type: Event

Parameters: No Parameters

Description

Fires whenever the value of the control is changed, either by the user (a keypress or mouse event) or by a programmatic function that emulates user input.

OnChange is a good place to toggle things that are related to user input, such as toggling the state of toolbar buttons.

Note:
The OnChange event should not be used to change focus. If you want to respond to a change in a combo based on a user selection, it is suggested you augment other procedures such as OnLinkClicked.

Sample

This sample determines whether undo and redo operations can be performed during the current state of the control and set the pbEnabled property of toolbar buttons (class cToolbarButton) in response.

Procedure OnChange
    if (pbCanUndo(Self) = True) ;
        set pbEnabled of (oUndo(oToolbar(Self))) to True
    else ;
        set pbEnabled of (oUndo(oToolbar(Self))) to False

    if (pbCanRedo(Self) = True) ;
        set pbEnabled of (oRedo(oToolbar(Self))) to True
    else ;
        set pbEnabled of (oRedo(oToolbar(Self))) to False
End_Procedure  // OnChange

Last Edited: November 22, 2004


cTextEdit [Event OnKillFocus]

OnKillFocus - cTextEdit

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


cTextEdit [Event OnMaxText]

OnMaxText - cTextEdit

Fires when maximum text size is exceeded

Type: Event

Parameters: No Parameters

Description

Fires when the maximum text size the control can contain is exceeded.

The default maximum number of characters for the control is 64 KB (65536 bytes or characters).
piMaxChars sets or returns maximum number of characters.

Note:
piMaxChars determines the maximum number of visible characters the user can enter into the control. However, when getting the value or saving the value to a database field, the value will contain additional non-visible characters. Each time the user presses Enter or Shift+Enter to break the line, this will be counted as a single visible character, but the value will contain 2 characters, a linefeed character (ASCII 10) followed by a carriage return character (ASCII 13).

Sample

This sample displays a message box with a warning to the user when the maximum text size is exceeded.

Procedure OnMaxText
    send Stop_Box "You have exceeded that maximum text this control can hold." "Warning"
End_Procedure  // OnMaxText

Last Edited: December 16, 2004


cTextEdit [Event OnSetFocus]

OnSetFocus - cTextEdit

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


cTextEdit [Event Prompt_Callback]

Prompt_Callback - cTextEdit

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


cTextEdit [Event Shadow_Display]

Shadow_Display - cTextEdit

Fired whenever a change in enabled state occurs

Type: Event

Parameters: No Parameters

Description

The Shadow_display event is fired whenever a change in enabled_state occurs. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current enabled condition of the object by querying the Enabled_State property and in more-unusual conditions, the implicit_shadow_state and Explicit_Shadow_State properties.

Last Edited: November 22, 2004


Events for cTextEdit

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange | Fires whenever the value of the control is changed |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus |
OnMaxText | Fires when maximum text size is exceeded |
OnSelectionChanged | Fires when selection changes | DFBaseTextEdit
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Fired whenever a change in enabled state occurs |


cTextEdit [Function Next_Object_Id]

Next_Object_Id - cTextEdit

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


cTextEdit [Function Prior_Object_Id]

Prior_Object_Id - cTextEdit

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for cTextEdit

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
AppendText | Procedure | Appends text to end of text in control | DFBaseTextEdit
AppendTextLn | Procedure | Appends text to end of text in control, followed by a line feed |
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control | DFBaseTextEdit
Beginning_of_Line | Procedure | Places the cursor at beginning of current line | DFBaseTextEdit
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
CharCount | Function | Returns the number of characters in the control | DFBaseTextEdit
ClearUndoBuffer | Procedure | Clears undo buffer | DFBaseTextEdit
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Deletes all data in control | DFBaseTextEdit
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
End_of_Data | Procedure | Places the cursor at end of the text in control | DFBaseTextEdit
End_of_Line | Procedure | Places the cursor at end of current line | DFBaseTextEdit
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
FindText | Function | Searches for specified text in control | DFBaseTextEdit
FirstCharInLinePos | Function | Returns position of first character in a line | DFBaseTextEdit
FirstVisibleLine | Function | Returns number of first visible line | DFBaseTextEdit
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
HideSelection | Procedure | Toggles selection highlighting on or off | DFBaseTextEdit
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
LastErrorCode | Function | Returns error code for last operation | DFBaseTextEdit
Line | Function | Returns specified line of text | DFBaseTextEdit
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
LineFromChar | Function | Returns number of line that contains specified character position or current line | DFBaseTextEdit
LineLength | Function | Returns number of characters in line | DFBaseTextEdit
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Read | Procedure | Reads text file and displays it in the control | DFBaseTextEdit
Redo | Procedure | Redoes the last operation | DFBaseTextEdit
RedoType | Function | Returns type of redo operation at top of redo queue | DFBaseTextEdit
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements | DFBaseTextEdit
ReplaceSel | Procedure | Replaces selected text with specified text | DFBaseTextEdit
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls up or down the control using specified scroll mode | DFBaseTextEdit
ScrollCaret | Procedure | Scrolls caret into view | DFBaseTextEdit
ScrollLines | Procedure | Scrolls control vertically for specified number of lines | DFBaseTextEdit
Select_All | Procedure | Selects entire contents of control | DFBaseTextEdit
SelEnd | Function | Returns end of selection | DFBaseTextEdit
SelStart | Function | Returns beginning position of selection | DFBaseTextEdit
SelText | Function | Returns selected text | DFBaseTextEdit
SetSel | Procedure | Selects text in given position range | DFBaseTextEdit
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
TextRange | Function | Returns text in given position range | DFBaseTextEdit
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Undo | Procedure | Undoes the last operation | DFBaseTextEdit
UndoType | Function | Returns type of undo operation at top of undo queue | DFBaseTextEdit
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes text file content of control to file | DFBaseTextEdit


cTextEdit [Procedure Activate_Area]

Activate_Area - cTextEdit

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


cTextEdit [Procedure AppendTextLn]

AppendTextLn - cTextEdit

Appends text to end of text in control, followed by a line feed

Type: Procedure

Parameters: string sText

Parameter | Description
sText | Text to append to control text

Description

This method is identical to AppendText, except that it adds a line feed character (ASCII 10) after appending the text in sText.

Last Edited: April 25, 2005


cTextEdit [Procedure Beginning_of_Panel]

Beginning_of_Panel - cTextEdit

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


cTextEdit [Procedure Bottom_of_Panel]

Bottom_of_Panel - cTextEdit

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


cTextEdit [Procedure DoHtmlHelp]

DoHtmlHelp - cTextEdit

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


cTextEdit [Procedure End_of_Panel]

End_of_Panel - cTextEdit

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


cTextEdit [Procedure Error_Help]

Error_Help - cTextEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cTextEdit [Procedure Extended_Help]

Extended_Help - cTextEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cTextEdit [Procedure File_Help]

File_Help - cTextEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cTextEdit [Procedure Help]

Help - cTextEdit

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


cTextEdit [Procedure Help_For_Help]

Help_For_Help - cTextEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cTextEdit [Procedure Help_Index]

Help_Index - cTextEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cTextEdit [Procedure Help_on_topic]

Help_on_topic - cTextEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cTextEdit [Procedure Keys_Help]

Keys_Help - cTextEdit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


cTextEdit [Procedure Request_Status_Help]

Request_Status_Help - cTextEdit

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


cTextEdit [Procedure Top_of_Panel]

Top_of_Panel - cTextEdit

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for cTextEdit

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Changed_State | Determines whether the content of the control has changed |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating popup menu (context menu) for this object |
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object |
Label_Col_Offset | The horizontal distance from the object to its label |
Label_Justification_Mode | The justification mode for the text within this object's label |
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property |
Label_Row_Offset | The vertical distance from the top edge of the object and its label |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of lines in control | DFBaseTextEdit
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
paValue | Sets content of control from memory address or places text in control into memory address | DFBaseTextEdit
pbBold | Toggles all text in control between bold and normal text | DFBaseTextEdit
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard | DFBaseTextEdit
pbCanRedo | Determines whether a redo operation can be performed | DFBaseTextEdit
pbCanUndo | Determines whether an undo operation can be performed | DFBaseTextEdit
pbItalics | Toggles all text in control between italic and normal text | DFBaseTextEdit
pbWrap | Determines whether text input will break and wrap to the next line at right margin | DFBaseTextEdit
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piFontSize | Sets or returns font size of all text in control | DFBaseTextEdit
piFontWeight | Sets or returns font weight of all text in control | DFBaseTextEdit
piMaxChars | Sets or returns maximum number of visible characters | DFBaseTextEdit
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piRightMargin | Determines indentation of right side of control's text, relative to the right margin | DFBaseTextEdit
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
psTypeFace | Sets or returns font typeface of all text in control | DFBaseTextEdit
Read_Only_State | Determines whether users may edit the content of the control | DFBaseTextEdit
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value | Sets or returns content of control | DFBaseTextEdit
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cTextEdit [Property Changed_State]

Changed_State - cTextEdit

Determines whether the content of the control has changed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Changed_State is toggled to True when the content of the control changes.

Sample

This sample checks to see whether the content of the oRichEdit1 control has changed, and if so, displays a message box to the user.

Procedure CheckForChanges
    boolean bChanged

    get Changed_State of oRichEdit1 to bChanged

    if (bChanged = True) ;
        send Info_Box "The content of the control has changed"
End_Procedure  // CheckForChanges

Last Edited: November 23, 2004


cTextEdit [Property Enabled_State]

Enabled_State - cTextEdit

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


cTextEdit [Property Explicit_Shadow_State]

Explicit_Shadow_State - cTextEdit

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


cTextEdit [Property Floating_Menu_Object]

Floating_Menu_Object - cTextEdit

Identifies the floating popup menu (context menu) for this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Floating_Menu_Object property identifies the floating popup menu (context menu) for this object. The default setting will provide a standard edit context menu. You may create your own custom floating menus and assign them to objects by setting this property. You may also disable a floating menu by setting this property to zero.

Sample

This sample creates a custom context menu from class FloatingPopupMenu, then sets the Floating_Menu_Object property to the FloatingPopupMenu object name.

Object oCustomMenu is a FloatingPopupMenu
    Send Add_Item msg_DoUndo "&Undo"
    Send Add_Item msg_DoRedo "&Redo"
    Send Add_Item msg_None "" // create a spacer
    Send Add_Item msg_Cut "Cu&t"
    Send Add_Item msg_Copy "&Copy"
    Send Add_Item msg_Paste "&Paste"
    Send Add_Item msg_None "" // create a spacer
    Send Add_Item msg_Select_All "Select &All"

    Procedure Popup
        integer iFocus iItemCount
        boolean bChanged

        Get Focus to iFocus // the object that called us
        Get Changed_State of iFocus to bChanged
        Get Item_Count to iItemCount // exit is the last item
        // if changed, shadow exit option
        Set Shadow_State (iItemCount - 1) to bChanged

        forward send Popup
    End_Procedure  // Popup
End_Object  // oCustomMenu

set Floating_Menu_Object to oCustomMenu

Last Edited: November 22, 2004


cTextEdit [Property Help_id]

Help_id - cTextEdit

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


cTextEdit [Property Help_Keyword]

Help_Keyword - cTextEdit

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


cTextEdit [Property Item_Shadow_State]

Item_Shadow_State - cTextEdit

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


cTextEdit [Property Label]

Label - cTextEdit

Sets the text for a label or heading for an entry control object

Type: Property

Access: Read/Write

Data Type: String

Description

The Label property sets the text for a label or heading for an entry control object (form, edit or list). In most classes, just setting this property is all that is required for the class to present the label in whatever particular way each class does this. In data-aware classes, the value of this property is overridden by label values in the DDO when auto_label_state has been set true.

Object F1 is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "First Name:"
End_object

Last Edited: August 18, 2003


cTextEdit [Property Label_Col_Offset]

Label_Col_Offset - cTextEdit

The horizontal distance from the object to its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Col_Offset is the horizontal distance from the object to its label. Units represent distance to the left (i.e., labels appear to the left of their object). If the label's justification-mode is left or top (jmode_left, jmode_top) this represents the distance from left edge of the object to the left edge of its label. If the justification-mode is right (jmode_right) this represents the distance from the left edge of the object to the right edge of the label. By default, this is the value of default_label_offset, which is supplied with a value of 60 (this is a global integer which can be changed).

Default is default label offset.

Last Edited: August 18, 2003


cTextEdit [Property Label_Justification_Mode]

Label_Justification_Mode - cTextEdit

The justification mode for the text within this object's label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Justification_Mode is the justification mode for the text within this object's label.

When the label_justification_mode is changed the row and col offset properties will often need to be changed as well.

The default mode for labels (jmode_left) is stored in the global integer default_label_jmode.

Object LeftForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Left Justify:" // use default column of 60
End_object

Object RightForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Right Justify:"
    Set label_justification_mode to jmode_right
    // set distance between right side of the label and the left side
    // of the object
    Set label_col_offset to 3
End_object

Object TopForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Top Justify:"
    Set label_justification_mode to jmode_top
    // label and object will align vertically
    Set label_col_offset to 0
End_object

Default is JMode Left.

Last Edited: August 18, 2003


cTextEdit [Property Label_Offset]

Label_Offset - cTextEdit

Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer i1 integer i2

Parameter | Description
i1 | The Row Offset of the Label
i2 | The Column Offset of the Label

Description

The Label_Offset property returns both the label_row_offset and the label_col_offset properties as a single (two-component) property. The Hi() value of the return parameter represents the row offset. The Low() value represents the column offset.

Get Label_Offset of oForm to iOffset
Move (Hi(iOffset))  to iRowOffset
Move (Low(iOffset)) to iColumnOffset

Label_offset is set as a single property passing the row offset and the column offset as two separate parameters.

Set Label_Offset of oForm to iRowOffset iColumnOffset

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

Last Edited: June 22, 2005


cTextEdit [Property Label_Row_Offset]

Label_Row_Offset - cTextEdit

The vertical distance from the top edge of the object and its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Row_Offset is the vertical distance from the top edge of the object and its label. If the label's justification-mode is jmode_top it represents the vertical distance from the top edge of this object to the bottom edge of its label and larger numbers moves the label up (and away from the object). If the mode is not top it represents the distance from the top edge of the object and the top edge of the label and larger numbers moves the label down. By default, this is zero which is suitable for both form and side labels.

Default is 0.

Last Edited: August 18, 2003


cTextEdit [Property Object_Shadow_State]

Object_Shadow_State - cTextEdit

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


cTextEdit [Property psHtmlHelpTopic]

psHtmlHelpTopic - cTextEdit

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


cTextEdit [Property Status_Help]

Status_Help - cTextEdit

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


cTextEdit [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - cTextEdit

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


cToolbar [Event OnRightClick]

OnRightClick - cToolbar

Received whenever the mouse's right button is clicked in the toolbar

Type: Event

Parameters: Integer x Integer y Integer dwHitInfo

Parameter | Description
x | The x-coordinate that the mouse button was clicked on
y | The y-coordinate that the mouse button was clicked on
dwHitInfo | Hit Information (private)

Description

This event is received whenever the mouse's right button is clicked in the toolbar. Note that if the click occurs in one of the buttons, then the button will receive the event, not the toolbar.

Note that both of the parameters, x and y, are expressed in screen coordinates, not client coordinates.

Note: You can also use the cWinControl's OnMouseDown, OnMouseUp, OnMouseDoubleClick and OnMouseMove mouse messages.

Last Edited: September 25, 2003


Events for cToolbar

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnMouseDoubleClick | Received whenever a mouse button is double-clicked on the control | cWinControl
OnMouseDown | Received whenever a mouse button is pressed on the control | cWinControl
OnMouseMove | Received whenever the mouse cursor moves over a control | cWinControl
OnMouseUp | Received whenever a mouse button is released on the control | cWinControl
OnRightClick | Received whenever the mouse's right button is clicked in the toolbar |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


cToolbar [Function NumberOfButtons]

NumberOfButtons - cToolbar

Returns the number of buttons that are in the toolbar

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The number of buttons that are in the toolbar

Description

The NumberOfButtons function returns the number of buttons (that is, cToolbarButton objects) that are in the toolbar.

Although each button is an object, it is described in the internal cCollection object, which you can access through the phoButtons property. This allows you to reference each object via its index.

This sample shows how to enumerate the buttons and show the psLabel of each:

Get NumberOfButtons To icButton
For iButton from 0 To (icButton -1)
    Get ObjectFromIndex of (phoButtons(self)) iButton To hoButton
    Get psLabel of hoButton To sLabel
    ShowLn `Button ` iButton ` has a label of: ` sLabel
Loop

Last Edited: September 10, 2003


Methods for cToolbar

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoRecreateWindow | Procedure | Recreates a window | cWinControl
DoResize | Procedure | Sent internally if the toolbar is part of an MDI pane to automatically set its size and align it the parent's window |
DoSendToDeoFocus | Procedure | Redirects a message, hmMessage, to the focused control |
DoSendToFocus | Procedure | Redirects a message, hmMessage, to the focused control |
DoUpdateWindow | Procedure | Updates a window if it needs repainting | cWinControl
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
NumberOfButtons | Function | Returns the number of buttons that are in the toolbar |
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


cToolbar [Procedure DoResize]

DoResize - cToolbar

Sent internally if the toolbar is part of an MDI pane to automatically set its size and align it the parent's window

Type: Procedure

Parameters: No Parameters

Description

The DoResize message is sent internally if the toolbar is part of an MDI panel (that is, its pbInMdiPanel property is True), to automatically set its size and align it the parent's window.

If the pbInMdiPanel property is False, and you have set the peAlign property to alTop, you should send this message to align the toolbar to the top of the parent window.

Last Edited: August 18, 2003


cToolbar [Procedure DoSendToDeoFocus]

DoSendToDeoFocus - cToolbar

Redirects a message, hmMessage, to the focused control

Type: Procedure

Parameters: Handle hmMessage

Parameter | Description
hmMessage | The message that is redirected

Description

Use the DoSendToDeoFocus procedure to redirect a message, hmMessage, to the focused control, but only if the focused control is a child of a data-aware container. This is typically sent from the toolbar's buttons. For example, this is how the OnClick event for a "find first record" button might be programmed:

Procedure OnClick
    Delegate Send DoSendToDeoFocus msg_beginning_of_data
End_Procedure

See Also

DoSendToFocus

Last Edited: August 5, 2003


cToolbar [Procedure DoSendToFocus]

DoSendToFocus - cToolbar

Redirects a message, hmMessage, to the focused control

Type: Procedure

Parameters: Handle hmMessage

Parameter | Description
hmMessage | The message that is redirected

Description

Use the DoSendToFocus procedure to redirect a message, hmMessage, to the focused control. This is typically sent from the toolbar's buttons.

See Also

DoSendToDeoFocus

Last Edited: August 5, 2003


Properties for cToolbar

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbEnabled | Enables the control to take user input | cWinControl
pbFlat | Determines if buttons are displayed flat or raised |
pbInMdiPanel | Determines if the toolbar will communicate with the MDI-panel |
pbList | Determines if the button's label is displayed underneath the image or to the right of it |
pbNoDivider | Determines if the toolbar is drawn with a dividing graphical line above it |
pbShowLabels | Determines if labels are actually shown. |
pbTooltips | Decides whether to show the tooltips or not |
pbVisible | Makes a control visible or invisible | cWinControl
pbWrapable | Determines if the toolbar wraps its buttons onto multiple lines or clips the toolbar, so that the buttons are not visible |
peAlign | Determines how the toolbar is aligned within the parent object |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phoButtons | Stores the object-handle of the internal cCollection object that holds the object-handles of the child cToolbarButton objects |
phoImageList | Provides images for the buttons on the toolbar |
phoImageListDisabled | Disables images for the buttons on the toolbar |
phoImageListHot | Provides hot images for the buttons on the toolbar |
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piBorderHorz | Creates a blank area between the edge of the button and the button's image and/or text |
piBorderVert | Creates a blank area between the edge of the button and the button's image and/or text |
piButtonHeight | Sets a button's height explicitly |
piButtonWidth | Sets a button's width explicitly |
piButtonWidthMax | Defines the maximum width, expressed in pixels, that each button can be |
piButtonWidthMin | Defines the minimum width, expressed in pixels, that each button must be |
piIndent | Determines the number of pixels to use as an indent on the toolbar |
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piTextRowsMax | Determine the maximum number of rows that can be created |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psDisabledSuffix | Determines what you can append when the button is disabled |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cToolbar [Property pbFlat]

pbFlat - cToolbar

Determines if buttons are displayed flat or raised

Type: Property

Access: Read/Write

Data Type: Integer

Description

Buttons can be displayed as either flat or raised. If you want the buttons to be flat, and have no border, set the pbFlat property to True. If you wan the buttons to have a raised border, set this property to False.

Although flat buttons have no border, a raised border is temporarily displayed when the mouse cursor enters within the bounds of a button.

Default is true.

Last Edited: September 10, 2003


cToolbar [Property pbInMdiPanel]

pbInMdiPanel - cToolbar

Determines if the toolbar will communicate with the MDI-panel

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the pbInMdiPanel property is True, the toolbar will communicate with the MDI-panel (Panel class, for example) to ensure that the panel's Client-Area is set automatically.

The only time you will need to change this property is when you want to use a toolbar in a non-MDI panel, such as a ToolPanel, in which case, you should set it to False.

Default is true.

Last Edited: September 10, 2003


cToolbar [Property pbList]

pbList - cToolbar

Determines if the button's label is displayed underneath the image or to the right of it

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The toolbar can display the button's label underneath the image or to the right of it. Set the pbList property To True, if you want the label to the right of the image, or set it to False, if you want the label underneath the image.

Default is false.

Last Edited: September 10, 2003


cToolbar [Property pbNoDivider]

pbNoDivider - cToolbar

Determines if the toolbar is drawn with a dividing graphical line above it

Type: Property

Access: Read/Write

Data Type: Boolean

Description

By default, the toolbar is drawn with a dividing graphical line above it. This is useful when it is used below a menu, in a MDI program, for example, to visually separate the two controls. Whenever a toolbar is used elsewhere, it may be more appropriate to draw the toolbar without this graphical line. Set the pbNoDivider property to False to draw the line and to True, if you do not want the divider drawn.

Default is false.

Last Edited: September 10, 2003


cToolbar [Property pbShowLabels]

pbShowLabels - cToolbar

Determines if labels are actually shown.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Although each button has a psLabel property that stores the text to display on each button, you need to set the toolbar's pbShowLabels to True, to actually show the labels.

Note: This is a design-time only property, meaning that you can only set it during the object-construction and cannot change it once the toolbar has been created, without manually destroying and creating the toolbar again.

Default is false.

Last Edited: September 10, 2003


cToolbar [Property pbTooltips]

pbTooltips - cToolbar

Decides whether to show the tooltips or not

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Each button has a psTooltip property that stores the text to display as a tooltip whenever the mouse hovers over a button. You can use the toolbar's pbTooltips property to decide whether to show the tooltips or not. Set pbTooltips to True, to display the buttons' tooltips, or to False, to not show any tooltips.

Default is true.

Last Edited: September 10, 2003


cToolbar [Property pbWrapable]

pbWrapable - cToolbar

Determines if the toolbar wraps its buttons onto multiple lines or clips the toolbar, so that the buttons are not visible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the toolbar is too narrow to display all the buttons, you can either allow the toolbar to wrap its buttons onto multiple lines or clip the toolbar, so that the buttons are not visible. Set the pbWrapable property to True, to wrap the buttons onto multiple rows, or set it to False to clip the toolbar and not show the buttons beyond the width of the toolbar. You can programmatically force a button onto the next row by setting a button's pbWrap property.

Default is false.

Last Edited: September 10, 2003


cToolbar [Property peAlign]

peAlign - cToolbar

Determines how the toolbar is aligned within the parent object

Type: Property

Access: Read/Write

Data Type: Integer

Description

peAlign determines how the toolbar is aligned within the parent object. By default, a toolbar is aligned to the topof the parent window and is automatically sized and aligned whenever the size of the parent window changes.

Set this property to alNone to prevent the automatic sizing and alignment. When set to alNone, you will be responsible for setting the size and location of the toolbar yourself.

Default is alTop.

Last Edited: September 10, 2003


cToolbar [Property phoButtons]

phoButtons - cToolbar

Stores the object-handle of the internal cCollection object that holds the object-handles of the child cToolbarButton objects

Type: Property

Access: Read/Write

Data Type: Handle

Description

phoButtons stores the object-handle of the internal cCollection object that holds the object-handles of the child cToolbarButton objects.

As you create or destroy cToolbarButton objects, the cToolBar maintains the list in an internal cCollection object. The phoButtons property is set automatically, but you can read it if you want to traverse the list of buttons. For example, this is how you might display the labels of all the buttons:

Get NumberOfButtons To icButton
For iButton from 0 To (icButton -1)
    Get ObjectFromIndex of (phoButtons(self)) iButton To hoButton
    Get psLabel of hoButton To sLabel
    ShowLn `Button ` iButton ` has a label of: ` sLabel
Loop

Default is 24.

Last Edited: September 11, 2003


cToolbar [Property phoImageList]

phoImageList - cToolbar

Provides images for the buttons on the toolbar

Type: Property

Access: Read/Write

Data Type: Handle

Description

Set the phoImageList property to the object-handle of a cImageList-derived imagelist, to provide images for the buttons on the toolbar.

See Also

phoImageListDisabled | phoImageListHot

Last Edited: September 11, 2003


cToolbar [Property phoImageListDisabled]

phoImageListDisabled - cToolbar

Disables images for the buttons on the toolbar

Type: Property

Access: Read/Write

Data Type: Handle

Description

Set the phoImageListDisabled property to the object-handle of a cImageList-derived imagelist, to provide disabled images for the buttons on the toolbar. That is, images that will be displayed if the button's pbEnabled property is False. If you do not set this property, the toolbar will attempt to "gray" the images automatically.

See Also

phoImageList | phoImageListHot

Last Edited: September 11, 2003


cToolbar [Property phoImageListHot]

phoImageListHot - cToolbar

Provides hot images for the buttons on the toolbar

Type: Property

Access: Read/Write

Data Type: Handle

Description

Set the phoImageListHot property to the object-handle of a cImageList-derived imagelist, to provide hot images for the buttons on the toolbar. Hot images are images that are displayed when the mouse cursor moves within the bounds of a toolbar button that has its pbFlat property set to True. If the button has the pbFlat property set to False, then hot images are displayed when the button is pressed. If you do not set this property, the toolbar will not change the images when the mouse hovers over the toolbar's buttons.

See Also

phoImageList | phoImageListDisabled

Last Edited: September 11, 2003


cToolbar [Property piBorderHorz]

piBorderHorz - cToolbar

Creates a blank area between the edge of the button and the button's image and/or text

Type: Property

Access: Read/Write

Data Type: Integer

Description

piBorderHorz creates a blank area between the edge of the button and the button's image and/or text. The value is applied to both the right and left of the button. This is only used for buttons that have their pbAutoSize property set to True.

Default is 7.

Last Edited: September 11, 2003


cToolbar [Property piBorderVert]

piBorderVert - cToolbar

Creates a blank area between the edge of the button and the button's image and/or text

Type: Property

Access: Read/Write

Data Type: Integer

Description

piBorderVert creates a blank area between the edge of the button and the button's image and/or text. The value is applied to both the top and bottom of the button. This is only used for buttons that have their pbAutoSize property set to True.

Default is 6.

Last Edited: September 11, 2003


cToolbar [Property piButtonHeight]

piButtonHeight - cToolbar

Sets a button's height explicitly

Type: Property

Access: Read/Write

Data Type: Integer

Description

Usually a button's height is determined automatically by the size of the image and/or label. However, you can set the height explicitly with the piButtonHeight property, and it will override the built-in sizing.

Default is 22.

Last Edited: September 11, 2003


cToolbar [Property piButtonWidth]

piButtonWidth - cToolbar

Sets a button's width explicitly

Type: Property

Access: Read/Write

Data Type: Integer

Description

Usually a button's width is determined automatically by the size of the image and/or label. However, you can set the width explicitly with the piButtonWidth property, and it will override the built-in sizing.

Default is 24.

Last Edited: September 11, 2003


cToolbar [Property piButtonWidthMax]

piButtonWidthMax - cToolbar

Defines the maximum width, expressed in pixels, that each button can be

Type: Property

Access: Read/Write

Data Type: Integer

Description

piButtonWidthMax defines the maximum width, expressed in pixels, that each button can be. Typically, all buttons have the same width, and this property allows you to determine what the maximum must be.

If a button's label is too wide to fit in this button size, the text will wrap onto multiple lines, as determined by the piTextRowsMax property.

Note: Normally all buttons have the same width. However, if either the pbList or a button's pbAutoSize property is True, then each button can have a different width.

Default is -1.

Last Edited: September 11, 2003


cToolbar [Property piButtonWidthMin]

piButtonWidthMin - cToolbar

Defines the minimum width, expressed in pixels, that each button must be

Type: Property

Access: Read/Write

Data Type: Integer

Description

piButtonWidthMin defines the minimum width, expressed in pixels, that each button must be. Typically, all buttons have the same width, and this property allows you to determine what the minimum must be.

Note: Normally all buttons have the same width. However, if either the pbList or a button's pbAutoSize property is True, then each button can have a different width.

Default is -1.

Last Edited: September 11, 2003


cToolbar [Property piIndent]

piIndent - cToolbar

Determines the number of pixels to use as an indent on the toolbar

Type: Property

Access: Read/Write

Data Type: Integer

Description

piIndent determines the number of pixels to use as an indent on the toolbar. So, for example, setting this property to 20, will result in the first button being placed at the 21st pixel. If the toolbar has buttons wrapped onto multiple rows, each row will use this indent, not just the first.

Default is 0.

Last Edited: September 11, 2003


cToolbar [Property piTextRowsMax]

piTextRowsMax - cToolbar

Determine the maximum number of rows that can be created

Type: Property

Access: Read/Write

Data Type: Integer

Description

When the text in the button's psLabel property is too wide to fit in the width of a button, it can wrap onto multiple lines. Use the piTextRowsMax property to determine the maximum number of rows that can be created. If the text is still too wide, ellipses (.) will be displayed at the end of the text to show that the string is not completely visible.

Default is 1.

Last Edited: September 11, 2003


cToolbar [Property psDisabledSuffix]

psDisabledSuffix - cToolbar

Determines what you can append when the button is disabled

Type: Property

Access: Read/Write

Data Type: String

Description

If a button is disabled (that is, it has its pbEnabled property set to False), you can append this string to the tooltip automatically. So, for example, if the psTooltip for a button was "Display Customer", and the button was disabled, the tooltip would be displayed as "Display Customer (unavailable)", if you had not modified this property from its default. If you do not wish to append anything when a button is disabled, simply set this property to null.

Default is " (unavailable)".

Last Edited: September 11, 2003


cToolbarButton [Event OnClick]

OnClick - cToolbarButton

Received whenever the mouse's left button is clicked in the button

Type: Event

Parameters: No Parameters

Description

The OnClick event is received whenever the mouse's left button is clicked in the button. However, this event can be redirected by setting the phmOnClick property to a different message-handle.

Note: You can also use the cWinControl's OnMouseDown, OnMouseUp and OnMouseDoubleClick mouse messages in the toolbar.

Last Edited: September 10, 2003


cToolbarButton [Event OnDropDown]

OnDropDown - cToolbarButton

Received whenever the drop-down arrow is clicked on a button with the peStyle property set to bsDropDown

Type: Event

Parameters: No Parameters

Description

The OnDropDown event is received whenever the drop-down arrow is clicked on a button with the peStyle property set to bsDropDown. However, this event can be redirected by setting the phmOnDropDown property to a different message-handle.

Last Edited: September 10, 2003


cToolbarButton [Event OnHideHint]

OnHideHint - cToolbarButton

Received whenever the toolbar is about to hide the tooltip/statushelp hints for a button

Type: Event

Parameters: No Parameters

Description

The OnHideHint event is received whenever the toolbar is about to hide the tooltip/statushelp hints for a button.

Last Edited: September 10, 2003


cToolbarButton [Event OnHotItemEntering]

OnHotItemEntering - cToolbarButton

Received whenever the mouse cursor enters the bounds of the button

Type: Event

Return Data Type: Integer

Parameters: handle hoButtonLeaving

Parameter | Description
hoButtonLeaving | The object-handle of the button that was previously hot, or zero, if no button was hot

Return Value

You can return a value of 1 from this procedure, to prevent the button from becoming hot.

Description

The OnHotItemEntering event is received whenever the mouse cursor enters the bounds of the button. At this time, the button is referred to as hot and the hot image will be displayed (if you had set the phoImageListHot property). However, this event can be redirected by setting the phmOnHotItemEntering property to a different message-handle.

Note: You can also use the cWinControl's OnMouseMove mouse message in the toolbar.

Sample

Procedure OnHotItemEntering Integer hoButtonLeaving Returns Integer
    ShowLn 'Entering ' (Name(self)) ;
    ' Leaving ' (If(hoButtonLeaving, Name(hoButtonLeaving), "None"))
End_Procedure

Last Edited: September 10, 2003


cToolbarButton [Event OnHotItemLeaving]

OnHotItemLeaving - cToolbarButton

Received whenever the mouse cursor leaves the bounds of the button

Type: Event

Parameters: Handle hoButtonEntering

Parameter | Description
hoButtonEntering | The object-handle of the button that the mouse cursor is entering (that is, becoming hot) , or zero, if no other button is becoming hot

Description

The OnHotItemLeaving event is received whenever the mouse cursor leaves the bounds of the button. However, this event can be redirected by setting the phmOnHotItemLeaving property to a different message-handle.

Note: You can also use the cWinControl's OnMouseMove mouse message in the toolbar.

Sample

Procedure OnHotItemLeaving Integer hoButtonEntering
Showln 'Leaving ' (Name(self)) ' Entering ' ;
(If(hoButtonEntering, Name(hoButtonEntering), "None"))
End_Procedure

Last Edited: September 10, 2003


cToolbarButton [Event OnRightClick]

OnRightClick - cToolbarButton

Received whenever the mouse's right button is clicked in the button

Type: Event

Parameters: Integer x Integer y

Parameter | Description
x | The x-coordinate that the mouse button was clicked on
y | The y-coordinate that the mouse button was clicked on

Description

The OnRightClick event is received whenever the mouse's right button is clicked in the button. However, this event can be redirected by setting the phmOnRightClick property to a different message-handle.

Note: You can also use the cWinControl's OnMouseDown, OnMouseUp and OnMouseDoubleClick mouse messages in the toolbar.

Last Edited: September 10, 2003


cToolbarButton [Event OnShowHint]

OnShowHint - cToolbarButton

Received whenever the toolbar is about to show the tooltip/statushelp hints for a button

Type: Event

Parameters: No Parameters

Description

The OnShowHint event is received whenever the toolbar is about to show the tooltip/statushelp hints for a button. You can augment this event to modify the psTooltip and psStatusHelp properties.

Last Edited: September 10, 2003


Events for cToolbarButton

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnClick | Received whenever the mouse's left button is clicked in the button |
OnDropDown | Received whenever the drop-down arrow is clicked on a button with the peStyle property set to bsDropDown |
OnHideHint | Received whenever the toolbar is about to hide the tooltip/statushelp hints for a button |
OnHotItemEntering | Received whenever the mouse cursor enters the bounds of the button |
OnHotItemLeaving | Received whenever the mouse cursor leaves the bounds of the button |
OnRightClick | Received whenever the mouse's right button is clicked in the button |
OnShowHint | Received whenever the toolbar is about to show the tooltip/statushelp hints for a button |


Methods for cToolbarButton

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for cToolbarButton

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbAutoSize | Allows you to create buttons with variable width |
pbChecked | Programmatically checks/unchecks a button with a peStyle of bsCheck |
pbEnabled | Enables or disables a button |
pbGrouped | Creates groups of buttons |
pbIndeterminate | Has no predetermined meaning and you are free to implement your own application-logic |
pbPressed | Programmatically sets the pressed/released state of a button |
pbVisible | Determines whether the button is visible in the toolbar |
pbWrap | Determines if next button wil wrap |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peStyle | Changes the style of a button |
phmOnClick | Stores the method-handle of the event to send whenever the button is clicked |
phmOnDropDown | Stores the method-handle of the event to send whenever the drop-down element of a button with the peStyle property set to bsDropDown is clicked |
phmOnHotItemEntering | Stores the method-handle of the event to send whenever the mouse cursor enters the bounds of the button |
phmOnHotItemLeaving | Stores the method-handle of the event to send whenever the mouse cursor leaves the bounds of the button |
phmOnRightClick | Stores the method-handle of the event to send whenever the button is clicked with the right mouse button |
piImage | Set this property to the index of an image in an imagelist |
psLabel | Determines the text that will be displayed as the label |
psStatusHelp | Displayed in the panel's statusbar, whenever the tooltip is displayed |
psTooltip | Determines text that is displayed whenever a tooltip is displayed |


cToolbarButton [Property pbAutoSize]

pbAutoSize - cToolbarButton

Allows you to create buttons with variable width

Type: Property

Access: Read/Write

Data Type: Boolean

Description

By setting the pbAutoSize property to True, the width of the button will be calculated from the size of the label. This allows you to create buttons with variable width, and is typically used when the toolbar's pbList property is True.

Default is true.

Last Edited: September 10, 2003


cToolbarButton [Property pbChecked]

pbChecked - cToolbarButton

Programmatically checks/unchecks a button with a peStyle of bsCheck

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Use the pbChecked property to programmatically check/uncheck a button with a peStyle of bsCheck.

Default is false.

Last Edited: September 10, 2003


cToolbarButton [Property pbEnabled]

pbEnabled - cToolbarButton

Enables or disables a button

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Use the pbEnabled property to enable or disable a button. When a button is disabled, it is unable to receive user-input, and it has its image grayed (unless you have set the toolbar's phoImageListDisabled property, to display custom disabled images)

Default is true.

Last Edited: September 10, 2003


cToolbarButton [Property pbGrouped]

pbGrouped - cToolbarButton

Creates groups of buttons

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Use the pbGrouped property to create groups of buttons. This is most commonly used to create radiogroups, where only one button of a group can be pressed at any time. To create a radiogroup, set all buttons in the group to have their pbGrouped property to True and their peStyle set to bsCheck.

Another use for groups is to ensure that all buttons is a group are wrapped onto a new row together, if the toolbar's pbWrapable property is True and it needs to create new rows.

Default is false.

Last Edited: September 10, 2003


cToolbarButton [Property pbIndeterminate]

pbIndeterminate - cToolbarButton

Has no predetermined meaning and you are free to implement your own application-logic

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The pbIndeterminate property has no predetermined meaning, and you are free to implement your own application-logic.

Default is false.

Last Edited: September 10, 2003


cToolbarButton [Property pbPressed]

pbPressed - cToolbarButton

Programmatically sets the pressed/released state of a button

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set the pbPressed property to programmatically set the pressed/released state of a button. Read this property to determine whether a button is pressed or released.

Default is false.

Last Edited: September 10, 2003


cToolbarButton [Property pbVisible]

pbVisible - cToolbarButton

Determines whether the button is visible in the toolbar

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbVisible determines whether the button is visible in the toolbar. Set pbVisible to True to display the button, and False to hide it.

Default is true.

Last Edited: September 10, 2003


cToolbarButton [Property pbWrap]

pbWrap - cToolbarButton

Determines if next button wil wrap

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Setting pbWrap to True will ensure that the button is the last one on a row, by placing the next button on a new row.

Setting this to True will wrap the next button, even if the toolbar's pbWrapable is False.

The button must have its pbEnabled property set to True, for this to have affect.

Default is false.

Last Edited: September 10, 2003


cToolbarButton [Property peStyle]

peStyle - cToolbarButton

Changes the style of a button

Type: Property

Access: Read/Write

Data Type: Integer

Description

Use the peStyle property to change the style of a button. The following constants can be used:

Constant | Meaning
bsButton | a regular button
bsSeparator | appears as a gap between two other buttons. When a button has this style, it cannot accept user-input.
bsCheck | allows the button to be used like a checkbox. That is, when pressed the first time, it stays pressed down. The next time it is pressed, it is released back up, and so on. When used with the pbGrouped property, the button acts like a radio in a radiogroup. That is, only one button in the group can be pressed and all others are automatically released.
bsDropDown | effectively creates two buttons in one. The button has a drop-down arrow placed adjacent, which can be clicked independently. When the button is clicked, the OnClick event is received and when the drop-down arrow is clicked, the OnDropDown event is sent.

Default is bsButton.

Last Edited: September 11, 2003


cToolbarButton [Property phmOnClick]

phmOnClick - cToolbarButton

Stores the method-handle of the event to send whenever the button is clicked

Type: Property

Access: Read/Write

Data Type: Integer

Description

phmOnClick stores the method-handle of the event to send whenever the button is clicked. By default, this is msg_OnClick, which means that the OnClick message will be sent.

You can change this property to create a Shared Handler to redirect the event.

Default is msg_OnClick.

Last Edited: September 11, 2003


cToolbarButton [Property phmOnDropDown]

phmOnDropDown - cToolbarButton

Stores the method-handle of the event to send whenever the drop-down element of a button with the peStyle property set to bsDropDown is clicked

Type: Property

Access: Read/Write

Data Type: Integer

Description

phmOnDropDown stores the method-handle of the event to send whenever the drop-down element of a button with the peStyle property set to bsDropDown is clicked. By default, this is msg_OnDropDown, which means that the OnDropDown message will be sent.

You can change this property to create a Shared Handler to redirect the event.

Default is msg_OnDropDown.

Last Edited: September 11, 2003


cToolbarButton [Property phmOnHotItemEntering]

phmOnHotItemEntering - cToolbarButton

Stores the method-handle of the event to send whenever the mouse cursor enters the bounds of the button

Type: Property

Access: Read/Write

Data Type: Integer

Description

phmOnHotItemEntering stores the method-handle of the event to send whenever the mouse cursor enters the bounds of the button. By default, this is msg_OnHotItemEntering, which means that the OnHotItemEntering message will be sent.

You can change this property to create a Shared Handler to redirect the event.

Default is msg_OnHotItemEntering.

Last Edited: September 11, 2003


cToolbarButton [Property phmOnHotItemLeaving]

phmOnHotItemLeaving - cToolbarButton

Stores the method-handle of the event to send whenever the mouse cursor leaves the bounds of the button

Type: Property

Access: Read/Write

Data Type: Integer

Description

phmOnHotItemLeaving stores the method-handle of the event to send whenever the mouse cursor leaves the bounds of the button. By default, this is msg_OnHotItemLeaving, which means that the OnHotItemLeaving message will be sent.

You can change this property to create a Shared Handler to redirect the event.

Default is msg_OnHotItemLeaving.

Last Edited: September 11, 2003


cToolbarButton [Property phmOnRightClick]

phmOnRightClick - cToolbarButton

Stores the method-handle of the event to send whenever the button is clicked with the right mouse button

Type: Property

Access: Read/Write

Data Type: Integer

Description

phmOnRightClick stores the method-handle of the event to send whenever the button is clicked with the right mouse button. By default, this is msg_OnRightClick, which means that the OnRightClick message will be sent.

You can change this property to create a Shared Handler to redirect the event.

Default is msg_OnRightClick.

Last Edited: September 11, 2003


cToolbarButton [Property piImage]

piImage - cToolbarButton

Set this property to the index of an image in an imagelist

Type: Property

Access: Read/Write

Data Type: Integer

Description

Set the piImage property to the index of an image in an imagelist. The toolbar can have three imagelists (set with phoImageList, phoImageListDisabled and phoImageListHot), but the indexes within them must be synchronized. So, for example, if you set the piImage to 3, this means that the fourth image (they are zero-based) in each imagelist will be displayed as appropriate.

If you do not want an image to be displayed on a button, set this property to iiNoImage. This can be useful in toolbars that have their pbList property set to True.

Default is 0.

Last Edited: September 11, 2003


cToolbarButton [Property psLabel]

psLabel - cToolbarButton

Determines the text that will be displayed as the label

Type: Property

Access: Read/Write

Data Type: String

Description

A button can have a text label displayed on it as well as an image. Set the psLabel property to the text that you want displayed as the label. The pbList property determines whether the label is displayed adjacent or beneath the image.

You must set the toolbar's pbShowLabels property to True, to display the labels.

Default is "".

Last Edited: September 11, 2003


cToolbarButton [Property psStatusHelp]

psStatusHelp - cToolbarButton

Displayed in the panel's statusbar, whenever the tooltip is displayed

Type: Property

Access: Read/Write

Data Type: String

Description

If the button's toolbar is part of an MDI panel (that is, the toolbar's pbInMdiPanel property is True), this string will be displayed in the panel's statusbar, whenever the tooltip is displayed. Typically, the status-help provides a more detailed description of the tooltip. For example, the psTooltip property might be set to "Cut", but the psStatusHelp property be set to "Cuts the selected text and places it in the Clipboard."

Default is "".

Last Edited: September 11, 2003


cToolbarButton [Property psTooltip]

psTooltip - cToolbarButton

Determines text that is displayed whenever a tooltip is displayed

Type: Property

Access: Read/Write

Data Type: String

Description

When the mouse cursor hovers over a button for a short while, a tooltip will be displayed. Set the psTooltip property to the text that you want displayed whenever a tooltip is displayed. You can create multi-line tooltips by embedding a "\n" in the text, to force a newline.

If you want dynamic tooltips for the button, you can augment the OnShowHint event, to modify this property before it is displayed.

Default is "".

Last Edited: September 11, 2003


cUIObject [Event Activating]

Activating - cUIObject

Sent by the object to itself whenever the object is placed on the screen

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Should always return zero

Description

The Activating event is sent by the object to itself whenever the object is placed on the screen. By default, the message does nothing and is designed for you to override the message and add any setup processing that the object may require before it is placed on the screen.

Last Edited: July 30, 2003


cUIObject [Event Deactivating]

Deactivating - cUIObject

Sent to the object when it is being removed from the focus tree as the result of a release_focus message

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns non zero value to prevent deactivation from occuring

Description

The Deactivating event is sent to the object when it is being removed from the focus tree as the result of a release_focus message. A procedure_return of a non zero value prevents the deactivation from occurring. The event is provided so that objects may perform specific actions prior to deactivating.

procedure deactivating
    forward send deactivating
    if (changed_state(self)) send save_it_all
end_procedure

Last Edited: August 18, 2003


cUIObject [Event Entering]

Entering - cUIObject

When the focus is to move to a new object, the entering event is sent to the object receiving the focus

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returning a non zero value from the entering procedure cancels movement of the focus.

Description

When the focus is to move to a new object, the entering event is sent to the object receiving the focus. If entering is not overridden, its function is to send the message identified in the value of the entry_msg property. This event is used to perform any pre-processing to the object before it receives the focus. Entering is suitable for defining the entry behavior of object classes, while entry_msg is suitable for object inheritance of entry behavior.

Last Edited: August 5, 2003


cUIObject [Event Entering_Scope]

Entering_Scope - cUIObject

Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Return non-zero if scope entering is not allowed.

Description

The Entering_Scope event is sent to the object if its scope_state is true, and one of the objects within its scope takes the focus. The event is provided to allow the object to initialize prior to the user being allowed to enter data.

Procedure Entering_Scope returns Integer
    integer iFail

    Forward Get msg_Entering_Scope to iFail

    If (not(iFail)) begin
        Send InitializeNewScope
    end
    Procedure_Return iFail
End_Procedure  // Entering_Scope

Last Edited: June 21, 2005


cUIObject [Event Error_Report]

Error_Report - cUIObject

Used by the error object to declare errors at the bottom of the screen

Type: Event

Parameters: integer iErrorNumber integer iErrorLine string sErrorText

Parameter | Description
iErrorNumber | the error number
iErrorLine | the line number where the error occurred
sErrorText | additional error text information

Description

The Error_Report procedure is used by the error object to declare errors at the bottom of the screen.

Last Edited: August 6, 2004


cUIObject [Event Exiting]

Exiting - cUIObject

When the focus is to move to a new object, the exiting event is sent to the object losing the focus

Type: Event

Return Data Type: Integer

Parameters: Handle hoDestination

Parameter | Description
hoDestination | the id of the object to which the focus is to move

Return Value

Returning a non zero value from the exiting procedure cancels movement of the focus.

Description

When the focus is to move to a new object, the exiting event is sent to the object losing the focus. If exiting is not overridden, its function is to send the message identified in the value of the exit_msg property. This event is used to perform any post-processing to the object before it loses the focus. hoDestination is the id of the object to which the focus is to move, and can be used to provide processing conditional on which object the focus is to move to. Exiting is suitable for defining the exit behavior of object classes, while exit_msg is suitable for object inheritance of exit behavior.

procedure exiting integer obj returns integer
    integer ret_val
    forward get msg_exiting obj to ret_val
    if ret_val procedure_return ret_val
    if (obj <>parent(self)) get custom_validate to ret_val
    procedure_return ret_val
end_procedure

Last Edited: August 6, 2004


cUIObject [Event Exiting_Scope]

Exiting_Scope - cUIObject

Sent whenever the focus is moving to an object that is outside the current scope

Type: Event

Return Data Type: Integer

Parameters: Handle hoNewScope

Parameter | Description
hoNewScope | the object handle of the scope object to which the focus is to move

Return Value

Returns non-zero if scope-exiting failed

Description

The Exiting_scope event is sent whenever the focus is moving to an object that is outside the current scope. The message is provided to allow the program to perform any post-processing of scopes.

procedure exiting_scope integer hoNewScope
    integer iFail
    Forward Get MSG_exiting_scope hoNewScope to iFail
    If (not(iFail)) Begin
        Send SaveScopeData
    end
    Procedure_Return iFail
end_procedure

Last Edited: September 25, 2003


cUIObject [Event Mouse_Click]

Mouse_Click - cUIObject

Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object

Type: Event

Parameters: Integer iWindowNumber Integer iPosition

Parameter | Description
iWindowNumber | the window item (1 based)
iPosition | the position within the window

Description

Mouse_Click is sent whenever the first mouse button is double clicked on an item or in the edit window of the object. The parameters indicate the position of the mouse cursor within the object. The mouse messages perform no action in the definition of cUIObject; their actions are always defined in higher-level classes.

Note:iWindowNumber is 1-based and not 0-based.

Last Edited: February 22, 2005


cUIObject [Event Mouse_Click2]

Mouse_Click2 - cUIObject

Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object

Type: Event

Parameters: Integer iWindowNumber Integer iPosition

Parameter | Description
iWindowNumber | the window item (1 based)
iPosition | the position within the window

Description

Mouse_Click2 is sent whenever the second mouse button is double clicked on an item or in the edit window of the object. The parameters indicate the position of the mouse cursor within the object. The mouse messages perform no action in the definition of cUIObject; their actions are always defined in higher-level classes.

Note:iWindowNumber is 1-based and not 0-based.

Last Edited: February 22, 2005


cUIObject [Event Mouse_Down]

Mouse_Down - cUIObject

Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object

Type: Event

Parameters: Integer iWindowNumber Integer iPosition

Parameter | Description
iWindowNumber | the window item (1 based)
iPosition | the position within the window

Description

Mouse_Down is sent whenever the first mouse button is pressed down while on an item or in the edit window of the object. The parameters indicate the position of the mouse cursor within the object. The mouse messages perform no action in the definition of cUIObject; their actions are always defined in higher-level classes.

Muse_Down can be augmented to do something when the mouse button is clicked when the user is in a specific object.

Sample

This sample will first complete the Mouse_Down event as defined in the superclass (via forward send) and then fire the DoSomething method of object oMyObject.

Procedure Mouse_Down integer iWindowNumber integer iPosition
    forward send Mouse_Down iWindowNumber iPosition
    send DoSomething of oMyObject
End_Procedure  // Mouse_Down

Note:iWindowNumber is 1-based and not 0-based.

Last Edited: February 22, 2005


cUIObject [Event Mouse_Down2]

Mouse_Down2 - cUIObject

Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object

Type: Event

Parameters: Integer iWindowNumber Integer iPosition

Parameter | Description
iWindowNumber | the window item (1 based)
iPosition | the position within the window

Description

Mouse_Down2 is sent whenever the second mouse button is pressed down while on an item or in the edit window of the object. The parameters indicate the position of the mouse cursor within the object. The mouse messages perform no action in the definition of cUIObject; their actions are always defined in higher-level classes.

Note:iWindowNumber is 1-based and not 0-based.

Last Edited: February 22, 2005


cUIObject [Event Mouse_Drag]

Mouse_Drag - cUIObject

Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next

Type: Event

Parameters: Integer iWindowNumber Integer iPosition

Parameter | Description
iWindowNumber | the window item (1 based)
iPosition | the position within the window

Description

Mouse_Drag is sent whenever the first mouse button is being held down while users drag the mouse cursor from one item or edit line of the object to the next. The parameters indicate the position of the mouse cursor within the object. The mouse messages perform no action in the definition of cUIObject; their actions are always defined in higher-level classes.

Note:iWindowNumber is 1-based and not 0-based.

Last Edited: February 22, 2005


cUIObject [Event Mouse_Drag2]

Mouse_Drag2 - cUIObject

Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next

Type: Event

Parameters: Integer iWindowNumber Integer iPosition

Parameter | Description
iWindowNumber | the window item (1 based)
iPosition | the position within the window

Description

Mouse_Drag2 is sent whenever the second mouse button is being held down while users drag the mouse cursor from one item or edit line of the object to the next. The parameters indicate the position of the mouse cursor within the object. The mouse messages perform no action in the definition of cUIObject; their actions are always defined in higher-level classes.

Note:iWindowNumber is 1-based and not 0-based.

Last Edited: February 22, 2005


cUIObject [Event Mouse_Up]

Mouse_Up - cUIObject

Sent whenever the first button of the mouse is released while on an item is in the edit window of the object

Type: Event

Parameters: Integer iWindowNumber Integer iPosition

Parameter | Description
iWindowNumber | the window item (1 based)
iPosition | the position within the window

Description

Mouse_Up is sent whenever the first mouse button is released while on an item is in the edit window of the object. The parameters indicate the position of the mouse cursor within the object. The mouse messages perform no action in the definition of cUIObject; their actions are always defined in higher-level classes.

Note:iWindowNumber is 1-based and not 0-based.

Last Edited: February 22, 2005


cUIObject [Event Mouse_Up2]

Mouse_Up2 - cUIObject

Sent whenever the second button of the mouse is released while on an item is in the edit window of the object

Type: Event

Parameters: Integer iWindowNumber Integer iPosition

Parameter | Description
iWindowNumber | the window item (1 based)
iPosition | the position within the window

Description

Mouse_Up2 is sent whenever the second mouse button is released while on an item is in the edit window of the object. The parameters indicate the position of the mouse cursor within the object. The mouse messages perform no action in the definition of cUIObject; their actions are always defined in higher-level classes.

Note:iWindowNumber is 1-based and not 0-based.

Last Edited: February 22, 2005


cUIObject [Event OnChildWrapping]

OnChildWrapping - cUIObject

Sent any time a wrapping event occurs

Type: Event

Return Data Type: Handle

Parameters: handle hoDestination boolean bDown

Parameter | Description
hoDestination | Handle of destination object
bDown | Indicates wrapping direction. True=last to first, False=first to last

Return Value

Returns the handle of the object to navigate to. If 0, navigation is stopped.

Description

The OnChildWrapping message is sent any time a wrapping event occurs. A wrapping event occurs when navigation would "ring" either from last object to first object or first object to last object. When this occurs the OnChildWrapping event is sent to the owner of the ring (the container object that has ring_state set to true) passing the destination object and a boolean indicating if the ring is moving from last to first (bDown=True) or last to first (false).

The message must return the object handle ID of the object to navigate to. Often this will be hoDestination, the object that was passed. If zero is returned, the navigation event should not take place. By default the runtime returns the passed object.

By default, this changes nothing. If you return a 0, navigation is stopped and no change takes place. If you return any other value navigation will continue from that object. Tab-dialogs use this extensively to handle all of the custom navigations required.

You should never send this message yourself. It may be augmented. If do you augment this message never use it to change the focus.

This event is called whenever the old message child_wrapping is sent but it is more flexible.

Last Edited: July 11, 2006


cUIObject [Event Page]

Page - cUIObject

Used internally to display the image of an object on the screen

Type: Event

Parameters: Integer iPageObject

Parameter | Description
iPageObject | determines if object is being paged or unpaged

Description

Page is used internally to display the image of an object on the screen.

Last Edited: July 11, 2006


cUIObject [Event Page_Delete]

Page_Delete - cUIObject

Used internally to remove the image of an object from the screen

Type: Event

Parameters: No Parameters

Description

Page_delete is used internally to remove the image of an object from the screen.

Last Edited: September 10, 2003


Events for cUIObject

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen |
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message |
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus |
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus |
Error_Report | Used by the error object to declare errors at the bottom of the screen |
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus |
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope |
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object |
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object |
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object |
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object |
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next |
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next |
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object |
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object |
OnChildWrapping | Sent any time a wrapping event occurs |
Page | Used internally to display the image of an object on the screen |
Page_Delete | Used internally to remove the image of an object from the screen |


cUIObject [Function confirm]

confirm - cUIObject

Pops up a "Yes/No" confirmation

Type: Function

Return Data Type: Integer

Parameters: String item_name

Parameter | Description
item_name | The question to be presented

Return Value

Returns 0 if the response is yes, 1 if the response is no.

Description

The Confirm function can be used to pop up a "Yes/No" confirmation. When called, it pops up a Windows Yes/No message box. The message-box caption will be Confirm and it will present the passed question, allowing users to select the Yes or No button. The syntax for using the function is as follows:

Get Confirm QuestionString to ReturnValue

This can be used at any point in your program and provides a very easy method to ask a "Yes/No" question. For example:

Procedure Run_Report
    integer iFail

    Get Confirm "Print Aged Balance Report Now?" to iFail
    If not (iFail) ;
        Send Start_Report of oAgedTeport
End_Procedure

The confirm package is defined in the DFCONFRM.PKG and is automatically included in DFALLENT.PKG. You do not need to explicitly "use" it. This means that confirm and message box support are "built right in there" as a resource.

User Confirmations and Queries Overview

Most of the time, your program runs in a non-modal state. Users may choose to navigate and enter data in the order of their choosing. There are times when you need the program to stop this user-driven system, pop up a dialog panel, ask a question, and based on the answer, take an action. There are several ways to create and use modal popup objects. If you need to ask a (Yes/No" question, you should use the Confirm package, which is documented in this section. If you require a different response (e.g., Yes/No/Cancel), or you need a series of responses, you could use the message box, or you could create your own modal panel.

Other Confirmation Messages

There are specialized versions of the Confirm message that are used to handle specific data entry requirements. Those messages are Save_Confirmation, Delete_Confirmation, Line_Save_Confirmation, Line_Delete_Confirmation, Data_Loss_Confirmation, Exit_Loss_Confirmation, and No_Confirmation.

Sending Confirmations Automatically

DEOs send confirmation messages during important data-entry operations (saves, deletes, clears, exiting). This gives the program a chance to secure confirmation of critical operations from users. Each DEO class has properties that determine what confirmation message is sent for each of these operations.

These messages are usually functions. If the function returns a zero value, the confirmation passed. If it returns a non-zero value, the confirmation failed. You can use these confirmation functions to pop up a confirmation dialog box asking a particular question (e.g., Save this Record?). The popup confirmation is a standard windows message box which allows the user to respond by pressing Yes or No. After a response, the confirmation panel will disappear and the function will return a zero (yes) or non-zero (no) value according to the response from the operator.

The DfConfrm.pkg package creates objects to provide such capabilities. It also creates a number of functions that allow you to use these objects. This includes a general-purpose confirmation function (where you pass the question to be asked) and a series of pre-defined confirmation functions.

A DEO needs to know what verification message it should send during a save, delete, clear and exit. Each DEO has properties that contain the message number to be sent for the appropriate verification. These verification properties are verify_save_msg, verify_delete_msg, verify_data_loss_msg and verify_exit_msg. If the values of one of these properties is zero, the DEO will delegate and use the message definition in its parent DEO. If the parent's property value is zero (and all of its DEO ancestors are also zero), no message will be sent.

All you need to do is to assign the appropriate function messages in DfConfrm.pkg to the appropriate DEO-verify message. The function messages available are listed below.

Sending Confirmations Manually

You can send confirmation messages manually. This is useful if you need to send these messages under conditions that your DEO does not normally handle. Below is an example of directly calling a DEO function. In this example, we want the standard save message (Save this Record?) to only be sent when a new record is saved. When an edited record is saved, we want the save to proceed without confirmation. We would augment the DEO's request_save procedure to handle this.

// This assumes that this DEO's Verify_Save_Msg is set to no_confirmation.
//
Procedure Request_Save
    boolean bHasRec bChanged
    integer iStat iServer

    // get current record in server. If 0, it is new.
    get Server to iServer // the DDO we are using
    get HasRecord of hoSrvr to bHasRec
    get Should_Save to bChanged // is the DDO changed?
    // if a new record and there are changes confirm the save.
    if ( not(bHasRec) AND not(bChanged) ) begin  // no rec
        get Save_Confirmation to iStat // OK=0
        if (iStat) Procedure_Return      // non-zero=TRUE=not OK, exit
    end
    // Normal save will not perform a confirmation
    forward send Request_Save
End_Procedure  // Request_Save

The Confirm Function with DEOs

You can send custom confirmation prompts by using the confirm function. It requires that you pass it the prompt to be displayed. The following example shows how you could use the confirm function to make the above example prompt, Save this NEW record?

Procedure Request_Save
    boolean bHasRec bChanged
    integer iStat iServer

    Get Server to iServer
    get HasRecord of hoSrvr to bHasRec
    Get Should_Save to bChanged
    // if a new record and there are changes confirm the save.
    if ( not(bHasRec) AND not(bChanged) ) begin  // no rec
        get Confirm "Save this NEW record?" to iStat // OK=0
        if (iStat) Procedure_Return      // non-zero=TRUE=not OK, exit
    end
    forward send Request_Save
End_Procedure  // Request_Save

You can also use the confirm message to create custom confirmations for a DEO or new confirmations for all DEOs. If we wanted to change an entry form's save prompt to Save this Order?, we would augment the verify_save procedure in the entry-form object:

Set verify_save_msg to GET_Verify_Save // normal save hook

// Create custom Verify_Save for this ONE object.
Function Verify_Save Returns Integer
    integer iRetVal

    get Confirm "Save this Order?" to iRetVal
    function_return iRetVal
    // Here is an alternate method that would combine the above
    // three commands into a single command.
    //
    // function_return (Confirm(Self,"Save this Order?"))
    //
End_Function

When we create a verify_save function in a DEO, we are changing the behavior of the one DEO. We could also use confirm to create a new confirm message that all objects could use. We would do this by creating the new function FOR BaseClass (which really means for all classes). We would then assign a DEO's verify message to that new function. The following would allow us to create a "California-style" save message:

Function Verify_Save_California_Style FOR BasClass returns integer
    integer iNoWayDude

    Get Confirm "Save this record, Dude?" to iNoWayDude
    function_return iNoWayDude
End_Function

Your DEO would use this prompt by placing the following in your DEO:

Set verify_Save_Msg to get_Verify_Save_California_Style

Using the Confirm Package

It is very easy to hook DEOs into confirmation messages. Your program must first include the DfConfrm object package (which is included, by default, in DFAllent.pkg). Each DEO should contain code that looks like the following:

Set Verify_Save_msg to get_Save_Confirmation
Set Verify_Delete_msg to get_Delete_Confirmation
Set Verify_Data_Loss_msg to get_Data_Loss_Confirmation
Set Verify_Exit_msg to get_Exit_Loss_Confirmation

By default the dbView class defines the above confirmations as their default. The dbGrid class changes the save confirmation (to disable the confirmation -get_no_confirmation) and the delete confirmation (to ask for a line delete confirmation -get_line_delete_confirmation). You would only need to change a class or object if you needed to change these defaults.

You are encouraged to create your own confirm package. This could contain different or additional prompts. You might also want to create your own custom DEO subclasses that contain the prompts that you always want to appear in your programs. The following example would create a custom dbView subclass that always verifies saves, deletes, and clears, but does not verify, exits:

Class dbView_xyz is a dbView

    Procedure Construct_Object
        forward send Construct_Object

        Set Verify_Save_msg to get_Save_Confirmation
        Set Verify_Delete_msg to get_Delete_Confirmation
        Set Verify_Data_Loss_msg to get_Data_Loss_Confirmation
        Set Verify_Exit_msg to get_Exit_Loss_Confirmation
    End_Procedure  // Construct_Object

End_Class  // dbView_xyz

When your confirm logic is placed in subclasses that all objects use, your programs will no longer need to set the properties in each DEO and you will be assured that all of your DEOs will behave consistently. This will also make it very easy to add more-sophisticated verification capabilities to all of your objects. It shouldn't be too hard to create classes that allow confirmations to be turned on and off at the user level.

See Also

Save_Confirmation | Delete_Confirmation | Line_Save_Confirmation | Line_Delete_Confirmation | Data_Loss_Confirmation | Exit_Loss_Confirmation | No_Confirmation

Last Edited: August 17, 2005


cUIObject [Function Data_Loss_Confirmation]

Data_Loss_Confirmation - cUIObject

Pops up a "Yes/No" confirmation for data loss

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns 0 if the confirmation is approved, returns non_zero if the process should be halted

Description

Prompts: Abandon Changes?

DEO usage

Set Verify_Data_Loss_Msg to GET_Data_Loss_Confirmation

This message only gets sent when a clear or clear all would result in the loss of data.

For a full explanation of the Data_Loss_Confirmation function, see the Confirm function.

See Also

Confirm

Last Edited: August 12, 2003


cUIObject [Function Delete_Confirmation]

Delete_Confirmation - cUIObject

Pops up a "Yes/No" confirmation for a delete

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns 0 if the confirmation is approved, returns non_zero if the process should be halted

Description

Prompts: Delete this Record?

DEO usage

Set Verify_Delete_Msg to GET_Delete_Confirmation

This will most often be used with entry forms and editors that are children of entry forms.

For a full explanation of the Delete_Confirmation function, see the Confirm function.

See Also

Confirm

Last Edited: August 12, 2003


cUIObject [Function Exit_Loss_Confirmation]

Exit_Loss_Confirmation - cUIObject

Pops up a "Yes/No" confirmation for exit loss

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns 0 if the confirmation is approved, returns non_zero if the process should be halted

Description

Prompts: Changes Exist. Exit this window?

DEO usage

Set verify_exit_msg to GET_Exit_Loss_Confirmation

This message is sent whenever you close (deactivate) a DEO view and there are changes in the view.

For a full explanation of the Exit_Loss_Confirmation function, see the Confirm function.

See Also

Confirm

Last Edited: August 12, 2003


cUIObject [Function Line_delete_confirmation]

Line_delete_confirmation - cUIObject

Pops up a "Yes/No" confirmation for a line delete

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns 0 if the confirmation is approved, returns non_zero if the process should be halted

Description

Prompts: Delete this Line?

DEO usage

Set Verify_Delete_Msg to GET_Line_Delete_Confirmation

This would be used with grids and editors that are children of grids.

For a full explanation of the Line_delete_confirmation function, see the Confirm function.

See Also

Confirm

Last Edited: August 18, 2003


cUIObject [Function Line_save_confirmation]

Line_save_confirmation - cUIObject

Pops up a "Yes/No" confirmation for a line save

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns 0 if the confirmation is approved, returns non_zero if the process should be halted

Description

Prompts: Save this Line?

DEO usage

Set Verify_Save_Msg to GET_Line_Save_Confirmation

This would be used with grids and editors that are children of grids.

For a full explanation of the Line_save_confirmation function, see the Confirm function.

See Also

Confirm

Last Edited: August 18, 2003


cUIObject [Function Next_Object_Id]

Next_Object_Id - cUIObject

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Handle

Parameters: Boolean bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

function next_object_id integer skip_down returns integer
    integer new_obj
    move Self to new_obj
    repeat
        forward get next_object_id of new_obj skip_down to new_obj
    until (ok_to_enter(new_obj))
    function_return new_obj
end_function

In the above example, the function is augmented to switch to objects that satisfy the condition ok_to_enter message. This will cause invalid objects to be skipped in the standard navigation scheme.

Last Edited: August 6, 2004


cUIObject [Function No_Confirmation]

No_Confirmation - cUIObject

Pops up a "Yes/No" confirmation for no confirmation

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns 0 if the confirmation is approved, returns non_zero if the process should be halted

Description

The No_Confirmation function pops up a "Yes/No" confirmation for no confirmation.

DEO usage

Set Verify_operation_Msg to GET_No_Confirmation

Defeats delegation to parent. If a confirmation function is not assigned to a DEO's verify property, the DEO will use the message from its parent DEO. For example, a text_edit DEO will use the same verifications that its parent entry form uses. Normally, this is good. The no_confirmation message tells the DEO to not use a confirmation prompt and not to use its parent's prompt. This is often needed with the parent-entry-form / child-grid-DEO structure. You want a save confirmation for the entry form and no confirmation for the grid. If you don't assign the grid a verify_save_msg, it will use its parent's entry-form message. You must set the grid's verify message to GET_No_Confirmation.

For a full explanation of the No_Confirmation function, see the Confirm function.

See Also

Confirm

Last Edited: September 10, 2003


cUIObject [Function Prior_Object_Id]

Prior_Object_Id - cUIObject

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Handle

Parameters: Boolean bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object_id of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

function prior_object_id integer skip_down returns integer
    integer new_obj
    move Self to new_obj
    repeat
        forward get prior_object_id of new_obj skip_down to new_obj
    until (ok_to_enter(new_obj))
    function_return new_obj
end_function

In the above example, the function is augmented to switch to objects that satisfy the condition ok_to_enter message. This will cause invalid objects to be skipped in the standard navigation scheme.

Last Edited: August 6, 2004


cUIObject [Function Save_Confirmation]

Save_Confirmation - cUIObject

Pops up a "Yes/No" confirmation for a save

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns 0 if the confirmation is approved, returns non_zero if the process should be halted

Description

The Save_Confirmation function pops up a "Yes/No" confirmation for a save.

Prompts: Save this Record?

DEO usage

Set Verify_Save_Msg to GET_Save_Confirmation

This will most often be used with entry forms and editors that are children of entry forms. Note that when you set the confirmation messages, you need to add the GET_ prefix. Had the function been a procedure, you would have needed the MSG_ prefix.

For a full explanation of the Save_Confirmation function, see the Confirm function.

See Also

Confirm

Last Edited: September 11, 2003


Methods for cUIObject

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) |
Activate_Scope | Procedure | Activates objects that are separate tools to the application |
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree |
Bell | Procedure | Rings the PC bell |
Cancel | Procedure | Returns the message_id of itself |
confirm | Function | Pops up a "Yes/No" confirmation |
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss |
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message |
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete |
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss |
Help | Procedure | Overridden in the help_system to activate context-sensitive help |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete |
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save |
Next | Procedure | Moves the focus to the next item or object, as appropriate |
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation |
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment |
Ok | Procedure | Returns the message_id of itself |
Page_Object | Procedure | Adds or removes an object |
Popup | Procedure | Activates the object as a pop-up |
Previous | Procedure | Moves the focus to the previous item or object, as appropriate |
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent |
Switch | Procedure | Moves the focus to the object returned by the next_object_id function |
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function |
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object |
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope |
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object |
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope |


cUIObject [Procedure Set Item]

Item - cUIObject

Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items

Type: Procedure Set

Data Type: Integer

Parameters: Integer iPosition

Parameter | Description
iPosition | True to go to first item, false to go to last item

Description

The Item message is used to change the current item to the first or last data item (depending on the value of last) in the displayed range of items. The current_item will be set to the first item that the user may interact with. This message is used when the next message causes the switch message to be called and the new item needs to be set. This message is typically not sent by application code.

Last Edited: August 18, 2003


cUIObject [Procedure Activate]

Activate - cUIObject

Gives an object the focus (and adds it to the focus tree)

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns zero if object was successfully activated.

Description

The Activate message adds the object into the focus tree (by sending add_focus), and gives the object the focus. If the object is already active, then the focus is changed, and add_focus is not sent. If the message is received by an object that has its client_area_state property set to true, the message is "translated" to the activate_group message.

send Activate of oMenu

integer iRetVal
get msg_Activate of oSomeObject to iRetVal

If the object cannot be activated, a non-zero value is returned according to the following error conditions:

Constant | Meaning
error_entering | Msg_entering returned a non zero value
error_exiting | Msg_exiting (of the current focus) returned a non zero value
error_activating | Msg_activating returned a non zero value
error_cant_accept_focus | The focus_mode of the object is no_activate or, if the object being activated to the focus tree has its client_area_state set to true, and none of its child objects are focusable
error_cant_create_tree | The object cannot be added to focus tree (probably due to lack of available memory)
error_add_to_inactive_object | The object was not yet active, and the base_object for its add_focus is not active
error_no_focusable_children | If the object being added to the focus tree has its client_area_state set to true, and none of its child objects could be added to the focus tree

Last Edited: December 13, 2004


cUIObject [Procedure Activate_Scope]

Activate_Scope - cUIObject

Activates objects that are separate tools to the application

Type: Procedure

Parameters: No Parameters

Description

The Activate_scope message is used to activate objects that are separate tools to the application. The message sets the scope_state and the attach_parent_state of the object. Then the object is activated. This message will create a scope in the system that will have a known place in the focus tree. It is provided as a convenience for those situations where this combination of events is necessary.

send activate_scope of (customer_popup(self))

Last Edited: August 19, 2004


cUIObject [Procedure Add_Focus]

Add_Focus - cUIObject

Adds the object into the focus tree at the next_level of the hoParent in the focus tree

Type: Procedure

Return Data Type: Integer

Parameters: Handle hoParent

Parameter | Description
hoParent | object handle of focus parent

Return Value

Returns zero if object was successfully added to the focus tree.

Description

The Add_focus message adds the object into the focus tree at the next_level of the hoParent in the focus tree. If the hoParent is not active, the message is terminated and returns a non-zero value (see below). This message is used to construct the focus tree in a predefined structure. The activate message uses this message to either add the object to the next level of the current focus or the next level of the parent of the object, depending on the value of the attach_parent_state property.

get msg_Add_Focus oCustomerEntry to iRetVal

If the object cannot be added to the focus tree, a non-zero value is returned according to the following error conditions:

1 | error_activating | msg_Activating returned a non zero value
5 | error_cant_accept_focus | The focus_mode of the object is no_activate
6 | error_cant_create_tree | The object cannot be added to focus tree (probably due to lack of available memory)
7 | error_add_to_inactive_object | The hoParent is not active
8 | error_no_focusable_children | If the object being added to the focus tree has its client_area_state set to true, and none of its child objects could be added to the focus tree

Last Edited: February 16, 2005


cUIObject [Procedure Bell]

Bell - cUIObject

Rings the PC bell

Type: Procedure

Parameters: No Parameters

Description

Rings the PC bell

Sample

This sample rings the PC's bell

send Bell

Last Edited: November 24, 2004


cUIObject [Procedure Cancel]

Cancel - cUIObject

Returns the message_id of itself

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Return value is msg_cancel

Description

The cancel message returns the message_id of itself. This message is used to terminate the current level of a start_ui or ui_accept with a return value of msg_cancel. An application may use the return value from a ui_accept to inquire as to the reason for termination.

ui_accept object to ret_val
if ret_val eq msg_cancel send operation_aborted

Last Edited: July 30, 2003


cUIObject [Procedure Deactivate]

Deactivate - cUIObject

Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message

Type: Procedure

Return Data Type: Integer

Parameters: Integer eDeactivateScope

Parameter Description
eDeactivateScopeMode which determines which object is deactivated. Modes can be:

Constant | Meaning
Popup_Type | Searches for Object with popup_state set to true
Scope_Type | Searches for Object with scope_state set to true
Area_Type | Searches for Object with scope_state or popup_state set to true

Return Value

If the deactivate operation is not successful, returns a non-zero value according to the error conditions

Description

The Deactivate message removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivating message. If received by an object that has its client_area_state property set to true, the message is "translated" to the deactivate_group message. If the receiver has objects in its next_level in the focus tree, those objects are deactivated before the current object.

The search_mode parameter determines what object will actually be deactivated. If this parameter is omitted, or equals zero (0), the receiver of the message is deactivated. However, if search_mode is non-zero, the focus tree is searched "upward" (through prior_levels) for an object to deactivate based on the eDeactivateScope.

get msg_Deactivate of (oMenu(Self)) to iRetVal
get msg_Deactivate Area_Type to iRetVal

If the deactivate operation is not successful, a non-zero value is returned according to the following error conditions:

1 | error_entering | msg_Entering (of new focus) returned a non zero value
2 | error_exiting | msg_Exiting returned a non zero value or one the objects in the next_level of the object refused to deactivate
4 | error_deactivating | msg_Deactivating returned a non zero value

Last Edited: July 11, 2006


cUIObject [Procedure Help]

Help - cUIObject

Overridden in the help_system to activate context-sensitive help

Type: Procedure

Parameters: No Parameters

Description

By default, this message does nothing. It is overridden in the help_system to activate context-sensitive help. Usually this message is placed on an accelerator key. See the HelpSystem class reference for more information on the help message.

on_key khelp send help
:
get help_name to context
append context '.' (current_item(self))

See Also

HelpSystem

Last Edited: August 18, 2003


cUIObject [Procedure Next]

Next - cUIObject

Moves the focus to the next item or object, as appropriate

Type: Procedure

Parameters: No Parameters

Description

The next navigation message moves the focus to the next item or object, as appropriate. If the object has items and the local_rotate_state property of the object is set to true, the current item is changed to the next item. If the local_rotate_state is false or the current_item is the last item, then the focus is moved to the next object using the switch message. This message is typically placed on accelerator-key and entry items.

on_key enter send next
on_item "press me" send next

Last Edited: September 10, 2003


cUIObject [Procedure None]

None - cUIObject

Does nothing - used by on_key and commands to stop a key assignment

Type: Procedure

Parameters: No Parameters

Description

This message is always used to make a on_key assignment or an add_item message do nothing.

The following example cancels an on_key assignment making the key do nothing:

On_Key Key_Ctrl + Key_A send None

It is also used within add_item and insert_item messages to add an item to a menu or list that does nothing

Send Add_Item Msg_None ''

Note that using this with an on_Key command causes the key to do nothing. It does not cause it to revert back to its default behavior. To do this, you use the keyword Default_Key

On_Key kPrompt Send Default_Key

Last Edited: February 17, 2005


cUIObject [Procedure Ok]

Ok - cUIObject

Returns the message_id of itself

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the message_id of itself

Description

The Ok message returns the message_id of itself. It is used on items and accelerator key definitions to terminate the current level of start_ui or ui_accept, returning a integer value of msg_ok.

on_item "OK" send ok
:
ui_accept amenu to ret_val
if ret_val eq msg_ok send process_panel

Last Edited: September 10, 2003


cUIObject [Procedure Page_Object]

Page_Object - cUIObject

Adds or removes an object

Type: Procedure

Parameters: Boolean bPage

Parameter | Description
bPage | determines if object is being paged or unpaged

Description

If state is true, the Page_object message causes the image of the object to display on the screen (without adding the object to the focus tree). Page_object true is sent during the normal activation of the object. If state is false, this message causes the image of the object to be removed from the screen, revealing the images of the other active objects (if any). Page_object false is sent during the normal deactivation of the object.

If an object is needed to be on the screen, but not participate in the focus tree (navigation) of the application, it will be shown with the page_object message. Objects of this type often include messages, titles, borders and backgrounds.

send page_object to (information_message(self)) true

Last Edited: September 10, 2003


cUIObject [Procedure Popup]

Popup - cUIObject

Activates the object as a pop-up

Type: Procedure

Parameters: No Parameters

Description

The Popup message activates the object as a pop-up: if the popup_state property of the object is true, the focus_mode property of the object is set to focusable, then the activate message is sent. Upon deactivation, the focus_mode property of the object is reset to no_activate. Pop-up type objects are not affected by the automatic activation of client class objects. The pop-up must be explicitly activated with the special popup message. This message is typically used in zoom and prompt type objects.

on_key kzoom send popup to (azoom(self))

Last Edited: September 11, 2003


cUIObject [Procedure Previous]

Previous - cUIObject

Moves the focus to the previous item or object, as appropriate

Type: Procedure

Parameters: No Parameters

Description

The Previous navigation message moves the focus to the previous item or object, as appropriate: if the object has items and the local_rotate_state property of the object is set to true, the current item is changed to the previous item. Otherwise the focus is moved to the prior object in the focus tree.

on_key kprevious send previous

Last Edited: September 11, 2003


cUIObject [Procedure Stop_UI]

Stop_UI - cUIObject

Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

The stop_ui message is used to terminate a popup_modal message and return execution to the next line after the one on which this message was sent. The message returns 1 to the caller. The message is used on items and accelerator-key definitions.

on_key kexit send stop_ui

Last Edited: September 11, 2003


cUIObject [Procedure Switch]

Switch - cUIObject

Moves the focus to the object returned by the next_object_id function

Type: Procedure

Parameters: No Parameters

Description

The Switch navigation message moves the focus to the object returned by the next_object_id function. The focus will move to the next focusable object either at the next_level, the next_focus, or the next_focus of the prior_level. The message is typically placed on an accelerator key. The message is also sent by the next message if it needs to change objects.

on_key kswitch send switch

Last Edited: September 11, 2003


cUIObject [Procedure Switch_Back]

Switch_Back - cUIObject

Moves the focus to the object returned by the prior_object_id function

Type: Procedure

Parameters: No Parameters

Description

The Switch_Back navigation message moves the focus to the object returned by the prior_object_id function. The focus will move to the next focusable object either at the prior_focus or the last child of the lowest level of this object. The message is typically placed on an accelerator key. The message is also sent by the previous message if it needs to change objects.

on_key kswitch_back send switch_back

Last Edited: September 11, 2003


cUIObject [Procedure Switch_Next_Group]

Switch_Next_Group - cUIObject

Moves the focus to the first object in the next_level of the next_object of the prior_level of this object

Type: Procedure

Parameters: No Parameters

Description

The Switch_Next_Group navigation message moves the focus to the first object in the next_level of the next_object of the prior_level of this object. If the objects in the current level are treated as a group, then the next set of objects at the same level is the next group.

on_key kswitch send switch_next_group

Last Edited: September 11, 2003


cUIObject [Procedure Switch_Next_Scope]

Switch_Next_Scope - cUIObject

Moves the focus to the scope focus of the next scope

Type: Procedure

Parameters: No Parameters

Description

The Switch_Next_Scope message moves the focus to the scope focus of the next scope.

send switch_next_scope

Last Edited: September 11, 2003


cUIObject [Procedure Switch_Prior_Group]

Switch_Prior_Group - cUIObject

Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object

Type: Procedure

Parameters: No Parameters

Description

The Switch_Prior_Group message moves the focus to the last object in the prior_level of the prior_object of the next_level of this object. If the objects in the current_level are treated as a group, then the previous set of objects at the same level is the prior group.

on_key kswitch_back send switch_prior_group

Last Edited: September 11, 2003


cUIObject [Procedure Switch_Prior_Scope]

Switch_Prior_Scope - cUIObject

Moves the focus to the scope focus of the prior_scope

Type: Procedure

Parameters: No Parameters

Description

The Switch_Prior_Scope message moves the focus to the scope focus of the prior_scope.

send switch_prior_scope

Last Edited: September 11, 2003


Properties for cUIObject

View property list in hierarchical order

Name | Description | Defining Class
Active_State | Indicates whether or not the object is activated |
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) |
Block_Mouse_State | Determines whether or not the use of the mouse is restricted |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children |
ContainsFocus | Determines if the container contains the focus |
Current_Scope | Returns the object_id of the currently active scoping object |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs |
Entry_Msg | Sent whenever the object is about to receive the focus |
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number |
Error_Text_Available | Determines if Error Text is available for this error number |
Exit_Msg | Sent whenever the object is about to lose the focus |
Find_Scope | Returns the scoping object of the current object |
Focus | Returns the ID of the object that currently has the focus |
Focus_Mode | Determines the conditions under which the object will take the focus |
Key_Path | Determines the delegation path for on_key key assignments |
Last_Child | Returns the object_id of the last focus child of a base_object |
Location | Determines the position of the upper left character of the object's window |
Module_Name | Assists in the process of locating context-sensitive help information |
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object |
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level |
Next_Scope | Returns the object that is the next_scope object of the current scope |
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message |
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object |
Prior_Level | Returns the object that is the root of this object's level in the focus tree |
Prior_Scope | Returns the object that is the prior_scope object of the current scope |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring |
RingParent | Returns the object handle of the object that is its ring parent |
Scope_Focus | A property of scope objects in the focus tree |
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object |
Search_Case |  |
Size | Allows the programmer to affect the size of an object's display window |
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement |
Visible_State | Determines whether object is visible |


cUIObject [Property Active_State]

Active_State - cUIObject

Indicates whether or not the object is activated

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Active_state function indicates whether or not the object is activated (in the focus tree).

if (active_state(self)) send deactivate

Last Edited: July 30, 2003


cUIObject [Property Attach_Parent_State]

Attach_Parent_State - cUIObject

Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true)

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Attach_parent_state property determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true). The attach_parent_state handles several standard situations where attachments to the focus tree need to be to the object's parent. If the object's parent is not active, then the property has no effect. If a more-exact method of attachment is required, then the add_focus message should be used.

set attach_parent_state to true

Last Edited: July 30, 2003


cUIObject [Property Block_Mouse_State]

Block_Mouse_State - cUIObject

Determines whether or not the use of the mouse is restricted

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Block_mouse_state property determines whether or not the use of the mouse is restricted to: (1) this object; and (2) objects that are in the focus tree at the next_level of this object and beyond. It is sometimes necessary to restrict the use of the mouse to a series of objects, typically descended from a common focus parent. The block_mouse_state will terminate the checking for a valid object if it finds an object with the block_mouse_state set to true. Modal dialogs are most often used in this manner.

set block_mouse_state to true

Last Edited: July 30, 2003


cUIObject [Property Client_Area_State]

Client_Area_State - cUIObject

Determines if object is a user interface container for children

Type: Property

Access: Read/Write

Data Type: Boolean

Description

A special mode of user interface objects will become a container for children. If an object is a container, activate, deactivate, and add_focus messages transform into activate_group, deactivate_group, and add_group messages and the first focusable child of the client becomes the focus. If the ring_state of the object is true, the children are placed in a ring in the focus tree. Any object may be a container, but typically objects of the client class are used. A container object is never the focus itself - it always passes the focus on to one of its children.

set client_area_state to true

Last Edited: July 30, 2003


cUIObject [Property ContainsFocus]

ContainsFocus - cUIObject

Determines if the container contains the focus

Type: Property

Access: Read-Only

Data Type: Boolean

Description

The ContainsFocus property returns true if the object or one of its descendents contains the focus.

This method is used by VDF to control navigation logic and will probably not be used by developers. If used this would most often be sent to a container object to determine if the container contains the focus.

Last Edited: July 31, 2003


cUIObject [Property Current_Scope]

Current_Scope - cUIObject

Returns the object_id of the currently active scoping object

Type: Property

Access: Read/Write

Data Type: Handle

Description

The Current_scope property returns the object_id of the currently active scoping object. Setting this property causes the focus to move to the scope focus of the specified scope. If there are no scopes set in the program, the current_scope is the desktop. To set the current_scope, the object_id must name a currently active object that has its scope_state property set to true.

if (focus(desktop) = (current_scope(desktop)) send found_scope

set current_scope to zoom_panel

Last Edited: July 31, 2003


cUIObject [Property Dynamic_Update_State]

Dynamic_Update_State - cUIObject

Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Dynamic_update_state property determines whether or not the image of an object that can be seen will be updated when a change to the object occurs. Each time the data in the visible portion of an object changes, the object will update the screen image of that object. There are often times when mass changes are being performed on the object that this automatic update becomes a problem. The programmer may change the update status of the object during the update process.

procedure do_a lot
    integer old_state
    get dynamic_update_state to old_state
    set dynamic_update_state to false
    send change_object_a lot
    set dynamic_update_state to old_state
end_procedure

When an object's dynamic_update_state is set to true, it will send itself a paint message to ensure that the display correctly reflects the data maintained by the object.

Default is true.

Last Edited: August 6, 2004


cUIObject [Property Entry_Msg]

Entry_Msg - cUIObject

Sent whenever the object is about to receive the focus

Type: Property

Access: Read/Write

Data Type: Integer

Description

The message defined by the Entry_msg property is sent whenever the object is about to receive the focus. The default for this property is zero (0). If the property is anything else, then it is a message that is sent to the object about to receive the focus. If you do not want an object to receive the focus, the function or procedure to which this property is set should contain a function_return n or procedure_return n command, where n is a value other than zero.

Often this message is used to set up an object prior to data entry. For example, an object may be instructed to fill itself with data before the user may interact with it. The entry message is also used to verify whether the user may enter the object.

set entry_msg to msg_set_up_object

Several objects as a group may all share a common entry message. Delegation to the parent of the objects in the group (often a client) may then allow the objects to use the same code no matter which object has been entered. When common entry behavior for a class is desired, the entering message may be used.

When in WideList class, default is msg initilize list.

Default is 0.

Last Edited: August 5, 2003


cUIObject [Property Error_Text]

Error_Text - cUIObject

Gets the text from FLEXERRS.DAT that corresponds to the passed error number

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iErrorNumber String sValue

Parameter | Description
iErrorNumber | The Error Number
sValue | The Error Text

Description

The Error_text property gets the text from FLEXERRS.DAT that corresponds to the passed error number.

Last Edited: August 8, 2003


cUIObject [Property Error_Text_Available]

Error_Text_Available - cUIObject

Determines if Error Text is available for this error number

Type: Property

Access: Read-Only

Data Type: Boolean

Parameters: Integer iErrorNumber Boolean bValue

Parameter | Description
iErrorNumber | The Error Number
bValue | Boolean returns true if error text exists for error number

Description

Error_text_available determines if Error Text exists for the iErrorNumber. If true, the Error_text function can be used to obtain this text from the error datafile.

Last Edited: August 18, 2003


cUIObject [Property Exit_Msg]

Exit_Msg - cUIObject

Sent whenever the object is about to lose the focus

Type: Property

Access: Read/Write

Data Type: Integer

Description

The message defined by the Exit_msg property is sent whenever the object is about to lose the focus. The default for this property is zero (0). If the property is anything else, then it is used as a message that is sent to the current focus. If you do not want an object to lose the focus, the function or procedure to which this property is set should contain a function_return n or procedure_return n command, where n is a value other than zero.

Often this function is used to validate the data that a user entered into an object. If the user has entered invalid data, the programmer may return a nonzero value. The message is also used to move any changes that the user made to variables or record buffers.

set exit_msg to get_verify_object_data

Several objects as a group may all share a common exit message. Delegation to the parent of the objects in the group (often a client) may then allow the objects to use the same code no matter which object has been exited. When common exiting behavior for a class is desired, the exiting message may be used.

Default is 0.

Last Edited: August 5, 2003


cUIObject [Property Find_Scope]

Find_Scope - cUIObject

Returns the scoping object of the current object

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Find_scope property returns the scoping object of the current object. This is useful when a program needs to identify the object that holds its scope_focus property. The search for the prior scope begins at the prior level of the current object.

send ping to (scope_focus(find_scope(self)))

Last Edited: August 18, 2003


cUIObject [Property Focus]

Focus - cUIObject

Returns the ID of the object that currently has the focus

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Focus property returns the ID of the object that currently has the focus. This property may be used anywhere an object_id is called for. This property is used in object-independent procedures, where the procedure is designed to act upon the focus. The desktop object has a property called focus, being the ID of the object that has the focus.

send Save_Yourself of (Focus(Desktop))

send Copy_Items of source_obj 0 (Focus(Desktop)) 0 10

if (Focus(Desktop)=Self) send DeActivate

Last Edited: August 6, 2004


cUIObject [Property Focus_Mode]

Focus_Mode - cUIObject

Determines the conditions under which the object will take the focus

Type: Property

Access: Read/Write

Data Type: Integer

Description

The focus_mode property determines the conditions under which the object will take the focus.

When set to focusable, the default, the object will accept the focus whenever it receives the activate message. Most objects in an application are set this way and will respond normally to the activate message.

set focus_mode to focusable

When set to nonfocusable, the object will only take the focus when activated as part of a group (when activate_group) is sent. After being activated during the group activation, the object will then refuse to accept the focus. This mode is typically used for objects that need to be placed on the screen but are never allowed to become the focus. Object classes such as titles and information messages are activated in this way. Note that if the object is activated directly (not through an activate_group), it will refuse the focus. Because of this structure, these objects are typically children of container class objects such as clients.

set focus_mode to nonfocusable

When set to no_activate, the object will always refuse to accept the focus, unless the popup_state is true and the object is activated, the child object should refuse to be activated even though its parent is a client (see nonfocusable). Objects of this type are usually pop-up type objects and are activated by the special popup message.

set focus_mode to no_activate

Note: The Pointer_only option is not supported under Windows.

Last Edited: August 18, 2003


cUIObject [Property Key_Path]

Key_Path - cUIObject

Determines the delegation path for on_key key assignments

Type: Property

Access: Read/Write

Data Type: Handle

Description

The property Key_path determines where an object should look for key definitions(on_key Xxxx) after it has searched the current object. If the value is 0, the search should delegate and look at the parent. This is normal default behavior for non-modal objects. If the value is non-zero, that value is an object handle and the search should move to that object. This is used by modal panels to stop key-path delegation to a parent and to instead go directly to the desktop and is done as follows:

set Key_path to Desktop                // set to desktop (skipping all objects)

The Key_path property is set automatically by the packages and should rarely be changed.

Non Modal objects set key_path to 0, which causes the object to delegate key assignments to their parent.

A modal object sets key_path to Desktop, which causes the object to delegates its key assignment to the desktop object.

Therefore, if an On_key is defined at the desktop, all objects will use it. If you do not want modal objects to use certain keys you should move those on_key commands up into the panel object. This way all non-modal views will inherit these keys but modal panels will not.

If you set Key_path to some value other than 0 or Desktop, the packages will not change this value. You will rarely want to make such a change.

Last Edited: August 18, 2003


cUIObject [Property Last_Child]

Last_Child - cUIObject

Returns the object_id of the last focus child of a base_object

Type: Property

Access: Read-Only

Data Type: Handle

Description

The last_child property returns the object_id of the last focus child of a base_object.

if (focus(desktop) =last_child(parent(focus(desktop)))) ;
    show "focus is in its parent's last child"

Last Edited: August 18, 2003


cUIObject [Property Location]

Location - cUIObject

Determines the position of the upper left character of the object's window

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iRowPos Integer iColPos

Parameter | Description
iRowPos | the row position
iColPos | the column position

Description

The location property determines the position of the upper left character of the object's window. An object's location is set relative to its parent container's location. An object on the desktop is located relative to your computer screen.

set Location to 2 0

Procedure Example
    if (low(Location(iObject)) > 0) ;
        set Location to (hi(Location(iObject)) (low(Location(iObject)-1)
End_Procedure  // Example

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

The property is set as follows:

Set Location to iRowPos iColPos

The property is retreived and unpacked as follows:

Get Location to cxyValue
Move (hi(cxyValue)) to iRowPos
Move (Low(cxyValue)) to iColPos

Last Edited: June 23, 2005


cUIObject [Property Module_Name]

Module_Name - cUIObject

Assists in the process of locating context-sensitive help information

Type: Property

Access: Read/Write

Data Type: String

Description

The Visual DataFlex help system relies on two global properties, application_name and module_name to assist in the process of locating context-sensitive help information. The Module_Name defaults to the name of the program (stored in the .EXE file).

Last Edited: February 16, 2005


cUIObject [Property Next_Focus]

Next_Focus - cUIObject

Returns the object that is positioned in the focus tree as the next object at the same level as this object

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Next_focus function returns the object that is positioned in the focus tree as the next object at the same level as this object. If the object is not a ring and there is not a next level, then the function will return zero. If the object is not active it will also return zero. The next object may not be focusable, and the user should check the focus_mode of the returned object to ensure that it is acceptable.

if (focus_mode(next_focus(focus(desktop)))) send switch

Last Edited: September 10, 2003


cUIObject [Property Next_Level]

Next_Level - cUIObject

Returns the object that is positioned in the focus tree as the first object in the next level

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Next_level property returns the object that is positioned in the focus tree as the first object in the next level. If there is not a next level or the object is not active, the property returns zero. The iNextLevelel object may not be focusable, and the user should check the focus_mode of the returned object to ensure that it is acceptable.

Sample

Function FindTerminalNode handle hoObject returns Handle
    integer iNextLevel

    repeat
        get iNextLevel of hoObject to iNextLevel
        if (iNextLevel <> 0) ;
            move iNextLevel to hoObject
    until (iNextLevel = 0)

    function_return hoObject
End_Function  // FindTerminalNode

Last Edited: June 20, 2005


cUIObject [Property Next_Scope]

Next_Scope - cUIObject

Returns the object that is the next_scope object of the current scope

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Next_scope property returns the object that is the next_scope object of the current scope. If there is not a next scope, the property returns zero.

send activate to (next_scope(desktop))

The next_scope is a property of the desktop, and is determined by the order that the scope objects are activated. As users navigate between the scopes, the scope order is modified.

Last Edited: September 10, 2003


cUIObject [Property Popup_State]

Popup_State - cUIObject

Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Popup_state property determines whether the object should respond to the activate message normally, or wait until the object receives the popup message. If the state is true, the message will set the focus mode of the object to no_activate. If the popup_state is true, then the popup message will set the focus_mode of the object to focusable and then perform a normal activate.

set popup_state of (selection_popup(self)) to true

Popup-type objects are designed to be activated by a special message. They do not respond to the normal activate message, since this message is often broadcast to all children of a client object. The popup object needs to ignore standard activates, and respond to the specialized popup activation message.

Last Edited: September 11, 2003


cUIObject [Property Prior_Focus]

Prior_Focus - cUIObject

Returns the object that is positioned in the focus tree as the prior object at the same level as this object

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Prior_focus property returns the object that is positioned in the focus tree as the prior object at the same level as this object. If the object is not in a ring and there is not a prior_focus, the function returns zero.

Sample

Procedure Example
    handle hoPriorFocus

    Get Prior_Focus To hoPriorFocus
    Showln "Prior focus: " (Name (hoPriorFocus)) ' (' hoPriorFocus ')'
End_Procedure  // Example

Last Edited: June 20, 2005


cUIObject [Property Prior_Level]

Prior_Level - cUIObject

Returns the object that is the root of this object's level in the focus tree

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Prior_level property returns the object that is the root of this object's level in the focus tree.

send save_data to (prior_level(self))

Last Edited: September 11, 2003


cUIObject [Property Prior_Scope]

Prior_Scope - cUIObject

Returns the object that is the prior_scope object of the current scope

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Prior_scope property returns the object that is the prior_scope object of the current scope.

send activate to (prior_scope(desktop))

Last Edited: September 11, 2003


cUIObject [Property Ring_State]

Ring_State - cUIObject

Determines whether or not the objects added into the next level of this object are to act as a ring

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Ring_state property determines whether or not the objects added into the next level (in the focus tree) of this object are to act as a ring, with the first and last objects in the level wrapping to one another. The objects at the end of the ring will have their prior and next focus set to point at each other. The normal navigation path will remain within the ring of objects.

set ring_state of (a_client(self)) to true

The standard navigation messages switch and switch_back use this arrangement of the focus tree to cause a circular data entry procedure. Container class objects have this property set to true by default, as do other classes whose object creation line includes the ring option (where supported).

Last Edited: September 11, 2003


cUIObject [Property RingParent]

RingParent - cUIObject

Returns the object handle of the object that is its ring parent

Type: Property

Access: Read-Only

Data Type: Boolean

Description

The RingParent property returns the object handle of the object that is its ring parent - this will be a parent or some ancestor whose ring_state is set to true. If 0 is returned, there is no ring parent.

This property is used by VDF to control navigation logic and will probably not be used by developers.

Last Edited: September 11, 2003


cUIObject [Property Scope_Focus]

Scope_Focus - cUIObject

A property of scope objects in the focus tree

Type: Property

Access: Read-Only

Data Type: Handle

Description

The scope_focus is a property of scope objects in the focus tree. Each time a new scope is activated, the scope object keeps track of the object within that scope that has the focus. When a user navigates between scopes, the focus is first changed to the scope_focus, and then (possibly) the object that the user requested. This mechanism exists so that the proper entry and exit messages are sent to objects within the same scope.

send validate_data to (scope_focus(self))

Last Edited: September 11, 2003


cUIObject [Property Scope_State]

Scope_State - cUIObject

Determines whether the objects at the next level of this object and beyond, are to be scoped by this object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Scope_state property determines whether the objects at the next level (in the focus tree) of this object and beyond, are to be scoped by this object. The scope_state is set to true on "tool" type objects to defeat the Entry_Msg and Exit_Msg messages as the focus is moved between scopes. See the UIMS Handbook for an in-depth discussion of the scope_state and uses for this property.

set Scope_State to True

Last Edited: June 20, 2005


cUIObject [Property Search_Case]

Search_Case - cUIObject

Type: Property

Access: Read/Write

Data Type: Boolean

Description

This property determines whether or not searches performed via item_matching are case-sensitive of case-insensitive. If search_case is True, all incremental searches and finds are performed in case-sensitive manner.

By default, this property is False, allowing case-insensitive searches.

Note:
This is a global property and affects the operation of all objects.

Last Edited: June 21, 2006


cUIObject [Property Size]

Size - cUIObject

Allows the programmer to affect the size of an object's display window

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iHeight Integer iWidth

Parameter | Description
iHeight | the height of the object
iWidth | the width of the object

Description

The size property allows the programmer to affect the size of an object's display window. If the object is active, then the message is allowed to change the size of the window to the dimensions specified. If the object is not active the set size message is ignored, since the object does not have a window to size.

Objects that are inactive may have their size returned. The size of an inactive object is determined by the dimensions of the object's image. If the object is active and has been resized with the size message, the function returns the window dimensions.

Objects that exist on a shared page will return the size of the image that they are assigned to.

All dynamic classes (Edit and Vconsole) maintain the size property separately and are not bound by the active window concept. The programmer may change the size of these objects at any time.

set Size of oButton to 10 20

This is a Complex Property

When this property is set, two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

The property is set as follows:

Set Size to iHeight iWidth

The property is retreived and unpacked as follows:

Get Size to cxyValue
Move (Hi(cxyValue)) to iHeight
Move (Low(cxyValue)) to iWidth

Last Edited: June 23, 2005


cUIObject [Property Skip_State]

Skip_State - cUIObject

Determines whether or not the switch and switch_back messages skip over this object during focus movement

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Skip_state property determines whether or not the switch and switch_back messages skip over this object during focus movement. By default, this is set to false, allowing an object to take focus (assuming its focus_mode property is set to focusable). This property is set to true in menu bars to keep the menu bar from being part of the normal focus rotation.

set skip_state of oForm to true

Last Edited: September 11, 2003


cUIObject [Property Visible_State]

Visible_State - cUIObject

Determines whether object is visible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Visible_State attribute by default is set true. To cause an object to not be displayed, or to disappear, but still be in the focus tree, set this property to false. If the object is currently in the focus list when this property is set, the change will immediately be reflected on the screen. It is not recommended that an object that may become the focus be set invisible, since the end user will not know where they are.

set Visible_State to True

It is adviseable to set the skip_state or the enabled_state for objects when setting visible_state to false dynamically, to avoid the focus from going to an invisible object. When doing so, set skip_state to true or enabled_state to false.

Last Edited: June 20, 2005


Events for CursorShape

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for CursorShape

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Cursor_Ready | Procedure |  |
Cursor_Wait | Procedure |  |
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


CursorShape [Procedure Cursor_Ready]

Cursor_Ready - CursorShape

Type: Procedure

Parameters: No Parameters

Description

This procedure changes the shape of the mouse cursor to the standard (or whatever the Windows assigned cursor is for the "Normal Select") mouse pointer. Send this method to the predefined Cursor_Control object in Visual DataFlex applications.

Sample

send Cursor_Ready of Cursor_Control

Last Edited: August 19, 2004


CursorShape [Procedure Cursor_Wait]

Cursor_Wait - CursorShape

Type: Procedure

Parameters: No Parameters

Description

This procedure changes the shape of the mouse cursor to an hourglass (or whatever the Windows assigned cursor is for the "Busy") mouse pointer. Send this method to the predefined Cursor_Control object in Visual DataFlex applications.

Sample

send Cursor_Wait of Cursor_Control

Last Edited: August 19, 2004


Properties for CursorShape

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
ClassCursorHandle | Saves the original cursor_type of the class of the current object so that it can be restored when the object receives a set cursor to 0 message |
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Cursor | Sets the cursor to the passed cursor_type |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


CursorShape [Property ClassCursorHandle]

ClassCursorHandle - CursorShape

Saves the original cursor_type of the class of the current object so that it can be restored when the object receives a set cursor to 0 message

Type: Property

Access: Read/Write

Data Type: Integer

Description

The ClassCursorHandle property is used to save the original cursor_type of the class of the current object so that it can be restored when the object receives a set cursor to 0 message. See the cursor property for a list of cursor_types.

Last Edited: July 30, 2003


CursorShape [Property Cursor]

Cursor - CursorShape

Sets the cursor to the passed cursor_type

Type: Property

Access: Write-Only

Data Type: Integer

Description

The Cursor property sets the cursor to the passed cursor_type. If the property is set to zero, the cursor reverts to the original default cursor_type for the class stored in ClassCursorHandle.

Cursor_types:

Constant | Meaning
IDC_ARROW | Typical Windows arrow pointer
IDC_IBEAM | Typical Windows edit pointer (I-beam)
IDC_WAIT | Typical Windows wait pointer (hourglass)
IDC_CROSS | Typical Windows paint pointer (crosshairs)
IDC_UPARROW | Up-arrow pointer
IDC_ICON | Null cursor (obsolete: use IDC_ARROW)
IDC_SIZE | A rectangle with a smaller rectangle in the lower right corner (obsolete: use IDC_SIZEALL)
IDC_SIZENWSE | Diagonal resizing cursor lower-right-upper-left
IDC_SIZENESW | Diagonal resizing cursor lower-left-upper-right
IDC_SIZEWE | Horizontal resizing cursor
IDC_SIZENS | Vertical resizing cursor
IDC_SIZEALL | Four-pointed arrow pointing north, south, east, and west
IDC_NO | Slashed circle
IDC_APPSTARTING | Standard arrow and small hourglass
IDC_HAND | Hand
IDC_HELP | Arrow and question mark

Last Edited: January 31, 2005


Events for cVersionInfo

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for cVersionInfo

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoCreate | Procedure | Reads the version information from a named application |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cVersionInfo [Procedure DoCreate]

DoCreate - cVersionInfo

Reads the version information from a named application

Type: Procedure

Parameters: String sFileName

Parameter | Description
sFileName | Fully-qualified filename of the application to read the version information from

Description

The DoCreate procedure reads the version information from a named application. Typically, this message is not instantiated explicitly, as it is primarily used by the cApplication class to provide version information about the current application, so you do not need to send this message. However, if you want to read version information about a different application, then you will need to send this message explicitly with the filename of the application you want to retrieve version information about.

Sample

This example shows how to retrieve version information about your application's associated VdfVm9.dll:

Procedure DoShowVersionInfo
    Handle hoVersionInfo hoRegistry
    Boolean bIncluded bKeyOpened
    String sRegKey sRootDir
    Integer iVersionMajor iVersionMinor iVersionRelease iVersionBuild

    Get Create U_cVersionInfo To hoVersionInfo
    If (hoVersionInfo > 0) Begin
        Get Create U_cRegistry To hoRegistry
        If (hoRegistry > 0) Begin
            Set phRootKey Of hoRegistry To HKEY_LOCAL_MACHINE

            Move ("Software\Data Access Worldwide\Visual DataFlex\" + Sysconf (SYSCONF_DATAFLEX_REV) + "\Defaults") To sRegKey
            Get OpenKey Of hoRegistry sRegKey To bKeyOpened
            If (bKeyOpened) Begin
                Get ReadString Of hoRegistry "VDFRootDir" To sRootDir
                If (sRootDir <> "") Begin
                    If (Right (sRootDir, 1) <> SysConf (SYSCONF_DIR_SEPARATOR)) Begin
                        Move (sRootDir + SysConf (SYSCONF_DIR_SEPARATOR)) To sRootDir
                    End
                    Move (sRootDir + "Bin") To sRootDir
                End
            End

            Send Destroy Of hoRegistry
        End

        Send DoCreate of hoVersionInfo (sRootDir + "Studio.Exe")
        Get pbIncluded of hoVersionInfo To bIncluded
        If (bIncluded) Begin
            Get piVersionMajor Of hoVersionInfo To iVersionMajor
            Get piVersionMinor Of hoVersionInfo To iVersionMinor
            Get piVersionRelease Of hoVersionInfo To iVersionRelease
            Get piVersionBuild Of hoVersionInfo To iVersionBuild
            Send Info_Box (SFormat ("%1.%2.%3.%4", iVersionMajor, iVersionMinor, iVersionRelease, iVersionBuild))
        End
        Else Begin
            Send Info_Box "Sorry, Version Info was not embedded in Studio.Exe"
        End

        Send Destroy of hoVersionInfo // destroy the object
    End
End_Procedure

See Also

cApplication

Last Edited: November 9, 2006


Properties for cVersionInfo

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbIncluded | Indicates whether Version Information resources have been included in the application |
pbPrivateBuild | Indicates whether the application is marked as being a "Private Build" |
pbSpecialBuild | Indicates whether the application is marked as being a "Special Build" |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piVersionBuild | Retrieves the "build" part of the build number |
piVersionMajor | Retrieves the "major" part of the build number |
piVersionMinor | Retrieves the "minor" part of the build number |
piVersionRelease | Retrieves the "release" part of the build number |


cVersionInfo [Property pbIncluded]

pbIncluded - cVersionInfo

Indicates whether Version Information resources have been included in the application

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Use the pbIncluded property to test whether the application has Version Information embedded as a resource.

This property will return True if Version Information was embedded, or it will return False otherwise

Last Edited: September 10, 2003


cVersionInfo [Property pbPrivateBuild]

pbPrivateBuild - cVersionInfo

Indicates whether the application is marked as being a "Private Build"

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When Resources were linked into the application, one of the flags was "Private Build". The meaning of this flag has no specific meaning and is completely determined by the developer of the application.

The pbPrivateBuild property will return True if the application was marked as being a "Private Build", or it will return False otherwise.

You cannot retrieve the text strings that come along with these property settings. You can only find out that information has been set. Special and Private build strings can be embedded in your EXE file via the .cfg file which you edit in the Visual DataFlex Studio, in the dialog labeled "Application properties for ". The tab page labeled Version lets you enter the text strings and set the check boxes for Special and/or Private build, so that the information from the CFG file is added to the EXE file.

The text strings are usually used to make a version of your application that is only meant for one person or organization (hence the Private) and should be kept confidential, not to be distributed. If you add the name of the receiver of this EXE in the text string, you can always trace back who distributed this private build. Special build is often a bit looser and can be used, for example, to make a trade show build. This way you can trace back where the application someone has came from.

See Also

pbSpecialBuild

Last Edited: February 17, 2005


cVersionInfo [Property pbSpecialBuild]

pbSpecialBuild - cVersionInfo

Indicates whether the application is marked as being a "Special Build"

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When Resources were linked into the application, one of the flags was "Special Build". The meaning of this flag has no specific meaning and is completely determined by the developer of the application.

The pbSpecialBuild property will return True if the application was marked as being a "Special Build", or it will return False

See Also

pbPrivateBuild

Last Edited: September 10, 2003


cVersionInfo [Property piVersionBuild]

piVersionBuild - cVersionInfo

Retrieves the "build" part of the build number

Type: Property

Access: Read/Write

Data Type: Integer

Description

The piVersionBuild property retrieves the "build" part of the build number. The version number consists of four discrete values: major, minor, release and build. Typically, the compiler automatically increments the build value, and the other three values are application-specific.

Before retrieving any of the version numbers, ensure that the application actually has version information by checking the pbIncluded property

See Also

pbIncluded | piVersionMajor | piVersionMinor | piVersionRelease

Last Edited: September 11, 2003


cVersionInfo [Property piVersionMajor]

piVersionMajor - cVersionInfo

Retrieves the "major" part of the build number

Type: Property

Access: Read/Write

Data Type: Integer

Description

The piVersionMajor property retrieves the "major" part of the build number. The version number consists of four discrete values: major, minor, release and build. Typically, the compiler automatically increments the build value, and the other three values are application-specific.

Before retrieving any of the version numbers, ensure that the application actually has version information by checking the pbIncluded property.

See Also

pbIncluded | piVersionMinor | piVersionRelease | piVersionBuild

Last Edited: September 11, 2003


cVersionInfo [Property piVersionMinor]

piVersionMinor - cVersionInfo

Retrieves the "minor" part of the build number

Type: Property

Access: Read/Write

Data Type: Integer

Description

The piVersionMinor property retrieves the "minor" part of the build number. The version number consists of four discrete values: major, minor, release and build. Typically, the compiler automatically increments the build value, and the other three values are application-specific.

Before retrieving any of the version numbers, ensure that the application actually has version information by checking the pbIncluded property.

See Also

pbIncluded | piVersionMajor | piVersionRelease | piVersionBuild

Last Edited: September 11, 2003


cVersionInfo [Property piVersionRelease]

piVersionRelease - cVersionInfo

Retrieves the "release" part of the build number

Type: Property

Access: Read/Write

Data Type: Integer

Description

The piVersionRelease property retrieves the "release" part of the build number. The version number consists of four discrete values: major, minor, release and build. Typically, the compiler automatically increments the build value, and the other three values are application-specific.

Before retrieving any of the version numbers, ensure that the application actually has version information by checking the pbIncluded property.

See Also

pbIncluded | piVersionMajor | piVersionMinor | piVersionBuild

Last Edited: September 11, 2003


cWebApp [Event OnAttachProcess]

OnAttachProcess - cWebApp

When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object

Type: Event

Parameters: No Parameters

Description

When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object. By default it does nothing but it can be used to perform any initialization for the newly attached process.

Last Edited: September 10, 2003


cWebApp [Event OnDetachProcess]

OnDetachProcess - cWebApp

When process pooling is used, this event is sent first to the WebApp object and then to every WBO object

Type: Event

Parameters: No Parameters

Description

When process pooling is used, this event is sent first to the WebApp object and then to every WBO object. By default it does nothing but it can be used to perform any de-initialization for the process that is being detached. Use this to reset any properties that you do not want shared by all users. It does nothing by default and is for augmentation.

Note that the detach process automatically clears all DDOs in all WBOs and clears all open tables (in case there are files that are opened that are not used by DDOs). This is done for security reasons to make sure that the next person attaching to the process does not have access to the records used by the previous user.

Last Edited: December 16, 2004


Events for cWebApp

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnAttachProcess | When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object |
OnDetachProcess | When process pooling is used, this event is sent first to the WebApp object and then to every WBO object |


Methods for cWebApp

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoDetachAllTables | Procedure |  |
DoInterfaceReport | Procedure |  |
EnumerateWBOs | Procedure |  |
EnumerateWSOs | Procedure |  |
Exit_Application | Procedure | Starts the process of closing an application | cObject
IgnoreError | Procedure |  |
LogEvent | Procedure |  |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
StartWebApp | Procedure |  |
TrapAllErrors | Procedure |  |
TrapError | Procedure |  |


cWebApp [Procedure DoDetachAllTables]

DoDetachAllTables - cWebApp

Type: Procedure

Parameters: No Parameters

Description

Last Edited: July 2, 2003


cWebApp [Procedure DoInterfaceReport]

DoInterfaceReport - cWebApp

Type: Procedure

Parameters: No Parameters

Description

Last Edited: July 2, 2003


cWebApp [Procedure EnumerateWBOs]

EnumerateWBOs - cWebApp

Type: Procedure

Parameters: integer iMsg string sParam1 string sParam2 string sParam3

Parameter | Description
iMsg | [ToDo: In Progress]
sParam1 | [ToDo: In Progress]
sParam2 | [ToDo: In Progress]
sParam3 | [ToDo: In Progress]

Description

Last Edited: July 2, 2003


cWebApp [Procedure EnumerateWSOs]

EnumerateWSOs - cWebApp

Type: Procedure

Parameters: integer iMsg string sParam1 string sParam2 string sParam3

Parameter | Description
iMsg | [ToDo: In Progress]
sParam1 | [ToDo: In Progress]
sParam2 | [ToDo: In Progress]
sParam3 | [ToDo: In Progress]

Description

Last Edited: March 24, 2004


cWebApp [Procedure IgnoreError]

IgnoreError - cWebApp

Type: Procedure

Parameters: integer iError

Parameter | Description
iError | [ToDo: In Progress]

Description

Last Edited: July 2, 2003


cWebApp [Procedure LogEvent]

LogEvent - cWebApp

Type: Procedure

Parameters: Integer iEventType String lpszEvent

Parameter | Description
iEventType | [ToDo: In Progress]
lpszEvent | [ToDo: In Progress]

Description

Last Edited: July 2, 2003


cWebApp [Procedure StartWebApp]

StartWebApp - cWebApp

Type: Procedure

Parameters: No Parameters

Description

Last Edited: July 2, 2003


cWebApp [Procedure TrapAllErrors]

TrapAllErrors - cWebApp

Type: Procedure

Parameters: No Parameters

Description

Last Edited: July 2, 2003


cWebApp [Procedure TrapError]

TrapError - cWebApp

Type: Procedure

Parameters: integer iError

Parameter | Description
iError | [ToDo: In Progress]

Description

Last Edited: July 2, 2003


Properties for cWebApp

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAttachStatus |  |
peHtmlOutput | Redirects Html output while debugging a program |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
WBOCount |  |
WBOHandle |  |
WSOCount |  |
WSOHandle |  |


cWebApp [Property peAttachStatus]

peAttachStatus - cWebApp

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: July 2, 2003


cWebApp [Property peHtmlOutput]

peHtmlOutput - cWebApp

Redirects Html output while debugging a program

Type: Property

Access: Read/Write

Data Type: Integer

Description

The peHtmlOutput property is used to redirect Html output while debugging a program. It allows you to redirect the WriteHtml message to output devices other than your browser. This can be particularly useful when debugging reports.

Arguments

This property supports the following modes:

Constant | Meaning
C_hoNormal(1) | Directs output to your browser, this is the default.
C_hoFile(2) | Directs output to a text file named "WebApp Html Out.txt".
C_hoConsole(4) | Directs output to the VDF Showln console.

Three output modes are supported. Within your VDF code either the Mode# or the Mode constant can be used. If you use this property in Script code, only the Mode# will be available.

The following example will direct output to the console:

Set peHtmlOutput to C_hoConsole

Although a single output mode will usually be selected, you may OR these values together to support multiple output devices. The following example directs output to the console and to the file:

Set peHtmlOutput to (C_hoConsole IOR C_hoFile)

The File output mode assumes that you are debugging in a single user situation. You would not want multiple users writing to the same Text file.
IMPORTANT! Only use this message for debugging. Do not attempt to use this redirection in a deployed program.
This message will be used frequently to debug your programs without needing to run them over the internet to your browser. This can be used to debug any message within a WBO. This lets you test your programs one message at a time. It will often be used to debug reports. For example, the following code added to the end of your WebApp.src file will let you run and test a report. Then, compile your program and run it directly, by clicking on the EXE file from the Windows Explorer.

// This is a sample of how to create a test button
// You may always want to test your reports this way.
Object oTestBn is a Button
    set location to 72 5
    set label to "Test Report"
    Procedure OnClick
        Integer iVal
        set peHtmlOutput to C_hoConsole
        get RunOrderDtlReport of oOrderDtlReport 1 to iVal
        set peHtmlOutput to C_hoNormal
    End_Procedure
End_Object

If you are using the full Visual DataFlex development system, this technique provides a huge advantage by allowing you to run this program using the VDF Debugger to uncover runtime errors.
This property is defined in the cWebApp class. It can be set within WBO objects and the message will delegate to the WBO's parent object (based on the cWebApp class) and be properly set.

Last Edited: August 18, 2005


cWebApp [Property WBOCount]

WBOCount - cWebApp

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: July 2, 2003


cWebApp [Property WBOHandle]

WBOHandle - cWebApp

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iItem Integer iValue

Parameter | Description
iItem | [ToDo: In Progress]
iValue | [ToDo: In Progress]

Description

Last Edited: July 2, 2003


cWebApp [Property WSOCount]

WSOCount - cWebApp

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: March 24, 2004


cWebApp [Property WSOHandle]

WSOHandle - cWebApp

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iItem Integer iValue

Parameter | Description
iItem | [ToDo: In Progress]
iValue | [ToDo: In Progress]

Description

Last Edited: March 24, 2004


Events for cWebBusinessProcess

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnAttachProcess | When process pooling is used, this event is sent to every WBO object and finally to the parent WebApp object | cDistributedBusinessProcess
OnDetachProcess | When process pooling is used, this event is sent first to the WebApp object and then to every WBO object | cDistributedBusinessProcess
OnReportClearStatus | After a clear operation, augments point to handle whatever additional processing is required | cRemoteEntryProcess
OnReportDeleteStatus | After a delete operation, augmentats point to handle whatever additional processing is required | cRemoteEntryProcess
OnReportFindStatus | After a find operation, augments point to handle whatever additional processing is required | cRemoteEntryProcess
OnReportSaveStatus | After a save operation, augments point to handle whatever additional processing is required | cRemoteEntryProcess
OnReportValidateStatus | After an update operation, augments point to handle whatever additional processing is required | cRemoteEntryProcess


cWebBusinessProcess [Function AutoEntry]

AutoEntry - cWebBusinessProcess

Creates a label and an input control for each field in the passed file name

Type: Function

Return Data Type: Integer

Parameters: string sFileName

Parameter | Description
sFileName | table to use for entry page

Return Value

A non-zero return value indicates an error occurred.

Description

The AutoEntry function creates a label and an input control for each field in the passed file name. Controls are not created for overlap and binary fields. The control type is determined by the DD's field information. A hidden recnum field is also created. The controls are written out in HTML format using the WriteHtml message.

You may not be able to save data with an AutoEntry web page. If the file has required parents, and fields are not created to find those parents - you will receive a validation error when you attempt to save the record.

Note that a file name (sFileName) and not a file number is passed. There must be an associated data dictionary for the passed file name.
Two sets of properties give you a bit of control over the appearance of your labels and forms. It is expected that each label and form will be displayed in an HTML table. You can set properties to determine the format of the label cell (psAutoEntryLabelStart and psAutoEntryLabelEnd) and the input cell (psAutoEntryDataStart and psAutoEntryDataEnd). By default labels are right aligned and emphasized. Form cells have no special attributes. They are defined in DataFlex as follows:

Property string psAutoEntryLabelStart '<td align="right"><em>'
Property string psAutoEntryLabelEnd   '</em></td>'
Property string psAutoEntryDataStart  '<td>'
Property string psAutoEntryDataEnd    '</td>'

The following example shows how you can change the display characteristics and then build an auto entry form. In this case we will make the labels left justified (the HTML default), strong and small for every field (that is not a binary or text) in the SalesP database table.

<%
WBO.Call "set_psAutoEntryLabelStart", "<td><strong><small>"
WBO.Call "set_psAutoEntryLabelEnd",  "</small></strong></td>"
WBO.Call "get_AutoEntry","SalesP"
%>

Since you will have no control over the order of the fields displayed, you may find this function to be of limited use for application deployment. It can be very useful for prototyping.

Script Code

WBO.Call "get_AutoEntry", "Customer"

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the RegisterInterface message.

To register AutoEntry send one of the following:

Send RegisterInterface msg_AutoEntry "AutoEntry";
    "sFileiRecord" ;
    "creates a label and an input control for each field in the passed file name"

Send RegisterAutoEntryInterface

Last Edited: July 30, 2003


cWebBusinessProcess [Function AutoReport]

AutoReport - cWebBusinessProcess

Generates a report for the passed filename, using the passed index with support for hypertext links to another web page

Type: Function

Return Data Type: Integer

Parameters: string sFileName string iIndex string sHRef integer iMax integer iStart

Parameter | Description
sFileName | table to report on
iIndex | index or field name to use for report
sHRef | name of other web page to hyperlink each report record to (e.g. details page)
iMax | number of records to display per page
iStart | the starting record id for the next page

Return Value

Returns zero if report is complete, otherwise returns the record id of the next record to be processed

Description

Auto report generates a report for the passed filename, using the passed index with support for hypertext links to another web page. All fields in a file (except overlap and binary) are displayed as a single row in a table.

The passed file name (not file number) must have an associated data dictionary.

The Index can be passed as either an index number or a field name. If a field name is passed, the field's primary index will be used to order the report. If no index is passed, index 1 will be used.

sHRef is a string that contains the name of an ASP or HTML file (e.g., "SalesEntry.asp"). If passed, the first column in each row will contain a hyper link reference to this file name. The link will also pass the current record number in the format FileName__RecId=Record. Where FileName is the name of the passed file and Record is the row's record. This is passed to the linked program via the QueryString. The sample programs in WebOrder contain logic that can check if a record has been passed to it via the QueryString. If it is, the record is found and the data displayed. This gives the auto report the ability to zoom to any record in the report.

WBO.Call "get_autoreport","SalesP", 1,"S1.asp 25"

Since you have no control over the format of an auto-report, you may find it to be of limited use in a deployed application. It is a very useful prototyping tool and it demonstrates some effective programming techniques.

Script Code

WBO.Call "Get_autoreport","SalesP",1,"S1.asp 25"

Registering Messages in the WBO

The AutoReport message is self-registering. If you create an AutoReport within a WBO the report will register itself within the WBO automatically.

Last Edited: July 30, 2003


cWebBusinessProcess [Function CreateFindIndexCombo]

CreateFindIndexCombo - cWebBusinessProcess

Creates a control that lists all available indexes for a table

Type: Function

Return Data Type: String

Parameters: string sComboName string sfileName integer iDfltIndex

Parameter | Description
sComboName | name to be used by the HTML control
sfileName | name of table passed
iDfltIndex | name of the field to be set as the default index

Return Value

Returns a string containing a properly marked up HTML combo control

Description

CreateFindIndexCombo is a rather specialized function, which creates a control that lists all available indexes for a table. Each field in the passed file name is checked. If it has an associated index and the field is not an overlap field the field is added to the combo list.

This control is used by the WebOrder sample to allow users to select a find and list index. Refer to the sample to see how this is used. This code segment creates the find buttons (<<, <, =, >, >>), list button and the find index combo control.

<p>
Find
 <input TYPE="SUBMIT" VALUE="<<" NAME="findfirst">
 <input TYPE="SUBMIT" VALUE="<" NAME="findprev">
 <input TYPE="SUBMIT" VALUE="=" NAME="find">
 <input TYPE="SUBMIT" VALUE=">" NAME="Findnext">
 <input TYPE="SUBMIT" VALUE=">>" NAME="findlast">
or
<input type="submit" name="list" value="List">
 by
 <% WBO.Call "get_CreateFindIndexCombo", "FindIndex", "SalesP", Indx %>
</p>

Example

<% bErr = WBO.Call("get_CreateFindIndexCombo", sComboName, FileName, DefaultIndex) %>

Last Edited: December 16, 2004


cWebBusinessProcess [Function DDAutoControl]

DDAutoControl - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField string sParams

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]
sParams | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function ddClear]

ddClear - cWebBusinessProcess

Clears the DataDictionary buffer

Type: Function

Return Data Type: Integer

Parameters: string sFile

Parameter | Description
sFile | table to perform clear on

Return Value

Returns non-zero if clear was successful, 0 if Error

Description

ddClear clears the DataDictionary buffer.

Example

Get ddClear sFile to bOk

Example

Get ddClear "Customer" to bOk

Last Edited: September 25, 2003


cWebBusinessProcess [Function DDComboControl]

DDComboControl - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField string sParams

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]
sParams | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function DDComboOptions]

DDComboOptions - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function ddDelete]

ddDelete - cWebBusinessProcess

Deletes current record in the DataDictionary buffer

Type: Function

Return Data Type: Integer

Parameters: string sFile

Parameter | Description
sFile | table to perform delete in

Return Value

Returns non-zero if delete was successful, 0 if Error

Description

ddDelete deletes current record in the DataDictionary buffer.

Example

Get ddDelete sFile to bOk

Example

Get ddDelete "Customer" to bOk

Last Edited: September 25, 2003


cWebBusinessProcess [Function DDEditControl]

DDEditControl - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField string sParams

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]
sParams | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function DDFieldErr]

DDFieldErr - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField integer bShort

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]
bShort | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function ddFind]

ddFind - cWebBusinessProcess

Finds a record and places it in the DataDictionary buffer

Type: Function

Return Data Type: Integer

Parameters: string sFileName string sFieldName Integer iFindMode

Parameter | Description
sFileName | table to perform find in
sFieldName | finds by index if an index number is passed or by field if field name is passed
iFindMode | mode to perform find by: first,lt,le,eq,ge,gt,last

Return Value

Returns non-zero if record was found, 0 if not found

Description

ddFind finds a record and places it in the DataDictionary buffer.

Example

// function to find customer by customer.id
Function FindCustomerById integer iCustId returns Boolean
    Boolean bOk
    Get ddClear "Customer" to bOk
    Send SetDDValue "Customer.Id"  iCustId
    Get ddFind "Customer" 1 EQ to bOk  // find EQ using Index.1
    function_return bOk
End_Function  // FindCustomerById

Last Edited: September 25, 2003


cWebBusinessProcess [Function ddFindbyRecId]

ddFindbyRecId - cWebBusinessProcess

Finds a record using passed record id (RECNUM) and places it in the DataDictionary buffer

Type: Function

Return Data Type: Integer

Parameters: string sfileName String sRec

Parameter | Description
sfileName | table to perform find in
sRec | record id (RECNUM) of record to find

Return Value

Returns non-zero if record was found, 0 if not found

Description

ddFindbyRecId finds a record using passed record id (RECNUM) and places it in the DataDictionary buffer.

Example

// function to find customer by record id
Function FindCustomerByRecId integer iCustRecId returns Boolean
    Boolean bOk
    Get ddClear "Customer" to bOk
    Get ddFindByRecId "Customer" iCutRecId to bOk
    function_return bOk
End_Function  // FindCustomerByRecId

Last Edited: September 25, 2003


cWebBusinessProcess [Function ddFindbyRowId]

ddFindbyRowId - cWebBusinessProcess

Type: Function

Return Data Type: Integer

Parameters: string sfileName string sSerializedRowId

Parameter | Description
sfileName | [ToDo: In Progress]
sSerializedRowId | [ToDo: In Progress]

Return Value

Description

Last Edited: November 11, 2004


cWebBusinessProcess [Function ddFindFirst]

ddFindFirst - cWebBusinessProcess

Finds first record and places it in the DataDictionary buffer

Type: Function

Return Data Type: Integer

Parameters: string sFile string sField

Parameter | Description
sFile | table to perform find in
sField | finds by index if an index number is passed or by field if field name is passed

Return Value

Returns non-zero if record was found, 0 if not found

Description

ddFindFirst finds first record and places it in the DataDictionary buffer.

Example

// function to find first customer using passed in index
Function FindFirstCustomer integer iIndex returns Boolean
    Boolean bOk
    Get ddClear "Customer" to bOk
    Get ddFindFirst "Customer" iIndex to bOk
    function_return bOk
End_Function  // FindFirstCustomer

Last Edited: September 25, 2003


cWebBusinessProcess [Function ddFindLast]

ddFindLast - cWebBusinessProcess

Finds last record and places it in the DataDictionary buffer

Type: Function

Return Data Type: Integer

Parameters: string sFile string sField

Parameter | Description
sFile | table to perform find in
sField | finds by index if an index number is passed or by field if field name is passed

Return Value

Returns non-zero if record was found, 0 if not found

Description

ddFindLast finds last record and places it in the DataDictionary buffer.

Example

// function to find last customer using passed in index
Function FindLastCustomer integer iIndex returns Boolean
    Boolean bOk
    Get ddClear "Customer" to bOk
    Get ddFindLast "Customer" iIndex to bOk
    function_return bOk
End_Function  // FindLastCustomer

Last Edited: September 25, 2003


cWebBusinessProcess [Function ddFindNext]

ddFindNext - cWebBusinessProcess

Finds next record and places it in DataDictionary buffer

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns non-zero if record was found, 0 if not found

Description

ddFindNext finds next record and places it in DataDictionary buffer. Must be "primed" using ddFind, ddFindFirst or ddFindLast.

Example

// function to find next customer by customer.id
Function FindNextCustomerById integer iCustId returns Boolean
    Boolean bOk
    // find current record to "prime" for ddFindNext
    Get ddClear "Customer" to bOk
    Send SetDDValue "Customer.Id"  iCustId
    Get ddFind "Customer" 1 EQ to bOk  // find EQ using Index.1
    // now, find the next record
    Get ddFindNext to bOk
    function_return bOk
End_Function  // FindNextCustomerById

Last Edited: September 25, 2003


cWebBusinessProcess [Function ddFindPrev]

ddFindPrev - cWebBusinessProcess

Finds previous record and places it in DataDictionary buffer

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns non-zero if record was found, 0 if not found

Description

ddFindPrev finds previous record and places it in DataDictionary buffer. Must be "primed" using ddFind, ddFindFirst or ddFindLast.

Example

// function to find previous customer by customer.id
Function FindPrevCustomerById integer iCustId returns Boolean
    Boolean bOk
    // find current record to "prime" for ddFindNext
    Get ddClear "Customer" to bOk
    Send SetDDValue "Customer.Id"  iCustId
    Get ddFind "Customer" 1 EQ to bOk  // find EQ using Index.1
    // now, find the previous record
    Get ddFindPrev to bOk
    function_return bOk
End_Function  // FindPrevCustomerById

Last Edited: September 25, 2003


cWebBusinessProcess [Function DDFormControl]

DDFormControl - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField string sParams

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]
sParams | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function DDHndValue]

DDHndValue - cWebBusinessProcess

Called within an ASP file by using the DDValue message

Type: Function

Return Data Type: String

Parameters: Integer hMain Integer iFile Integer iField Integer iOption String sParam

Parameter | Description
hMain | contains the object ID of the main DDO in the process (for example, the file that a save or delete is based on)
iFile | number of the table in the current filelist
iField | number of the field in table iFile
iOption | determines what type of Data (or DataDictionary field information) should be returned. The most common use is to pass iOption as zero, which requests the DataDictionary's current-field value in an HTML input form. Normally called while ASP is generating an HTML output page. See the cWebBusinessProcess class for all available iOptions.
sParam | additional parameter that can be used to pass extra information for certain iOption types

Return Value

The return value can be directly embedded into HTML text, as an input form value (its most common use), or returned to a VBScript or Java Script function

Description

The name of this message has changed from WebApp 2.x, where it was DDValue, to distinguish it from the more frequently used DDValue function of the same name. More often than not, DDValue is the function you will want to use, rather than DDHndValue.

The DDHndValue message is called within an ASP file by using the DDValue message. You will rarely send this message from a WBO (although it is permitted). It is more likely that you will augment this message to provide additional data-dictionary field information to your ASP script. When encountered, this function will call the WBO function DDValue passing the file and field value as separate parameters.

If you create your own custom iOption types, you are encouraged to use iOption for values above 1000 (Data Access reserves the first 1000 values).

Note: If iOption and sParam are not passed, the default value of iOption=0 and sParam="" is passed to the DataFlex WBO. Other values for iOption and sParam must be defined and coded in your DataFlex WBO.

Sample 1

By default, this function returns the current value of a field. No augmentation is required. An ASP file could call this function as follows:

<td><input type="text" size="13" name="Cust0100__Custnr"
    Value="<% WBO.DDValue("Cust0100.Custnr",0,"")%>">
</td>

The iOption value of zero and the sParam value of " " are the default so they may be omitted, allowing a simpler syntax for this commonly used function.

<td><input type="text" size="13" name="Cust0100__Custnr"
   Value="<% WBO.DDValue("Cust0100.Custnr")%>">
</td>

Sample 2

The next sample returns a field's description value. This could be used when field data has an associated validation-table description associated with it. The following would be added to your WebBusinessProcess object.

Function DDhndValue integer hMain integer iFile integer iField integer iOption string sParam Returns string
    string sValue
    If iOption eq 1010 Begin // 1010 custom defined for us
        Get File_Field_Current_Description of hMain iFile iField to sValue
         // you should always encode your data so that special HTML values like
        //"<" and ">" are converted to their HTML replacements!
        Get HTMLEncode sValue to sValue
    End
    Else ;
        Forward get ddValue hMain iFile iField iOption sParam to sValue
    Function_return sValue
End_Function

This could be called from your ASP file as follows:

<p>
Current field description is <%=WBO.DDValue("Cust.Status",1010)%>.
</p>

Sample 3

The next sample will check if the passed sParam value is the same as the current field value. If it is, it will return the string "Open" if it is not, it will return "Closed."

Function DDhndValue integer hMain integer iFile integer iField integer iOption string sParam Returns string
    string sValue
    If iOption eq 2000 Begin // 2000 custom defined for us
        Get File_Field_Current_Value of hMain iFile iField to sValue
         If sValue eq sParam Move "Open" to sValue
            Else move "Closed" to sValue
        End
        Else ;
            Forward get ddValue hMain iFile iField iOption sParam to sValue
   Function_return sValue
End_Function

This could be called from your ASP file as follows:

<p>
The current customer's status is <%=Test_WBO.DDValue("Cust.Status",2000,"A")%>.
</p>

It could also be called in a WBO as follows:

Since the DDValue is used mainly in the ASP side, the message options will be described from an ASP standpoint. A number of option values are supported with DDValue. In the documentation we will refer to these options by their symbolic name and not the option number (e.g., DDLONGLABEL instead of 2). You can use the symbolic names within your ASP files but make sure that you first define constant replacements for these values. These constants are defined in a file named DDValue_Constants.inc, which must be placed in your AppHtml directory. This file is included in an ASP file by adding the following line to the top of your ASP file:

<!--#INCLUDE FILE="DDValue_Constants.inc" -->

Last Edited: July 11, 2006


cWebBusinessProcess [Function DDParentComboControl]

DDParentComboControl - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField string sParams

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]
sParams | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function DDRadioControl]

DDRadioControl - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField string sParams

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]
sParams | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function DDReadOnlyHTML]

DDReadOnlyHTML - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function DDRecsOptions]

DDRecsOptions - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function DDRowIdsOptions]

DDRowIdsOptions - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]

Return Value

Description

Last Edited: November 11, 2004


cWebBusinessProcess [Function ddSave]

ddSave - cWebBusinessProcess

Performs a data validation and, once validated, saves a record using the current information in the DataDictionary buffer

Type: Function

Return Data Type: Integer

Parameters: string sFile

Parameter | Description
sFile | table to perform save on

Return Value

Returns non-zero if save was successful, 0 if Error

Description

ddSave performs a data validation and, once validated, saves a record using the current information in the DataDictionary buffer.

Example

// save data in customer file
Function SaveCustomer returns Boolean
    Boolean bOk
    get ddSave "Customer" to bOk
    function_return bOk
End_Function  // SaveCustomer

Last Edited: September 25, 2003


cWebBusinessProcess [Function DDTitleHTML]

DDTitleHTML - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function ddValidate]

ddValidate - cWebBusinessProcess

Validates all fields using current data in the DataDictionary buffer

Type: Function

Return Data Type: Integer

Parameters: string sFile

Parameter | Description
sFile | table to perform Validtion on

Return Value

Returns non-zero if Validation was successful, 0 if Error

Description

ddValidate validates all fields using current data in the DataDictionary buffer.

Example

// validate data in Customer DD and save if validation is ok
Function SaveCustomer returns Boolean
    Boolean bOk
    get ddValidate "Customer" to bOk
    if (bOk<>0) ;
        get ddSave "Customer" to bOk
    function_return bOk
End_Function  // SaveCustomer

Last Edited: September 25, 2003


cWebBusinessProcess [Function DDWMLInputControl]

DDWMLInputControl - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField string sParams

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]
sParams | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function DoRequestFindbyRecId]

DoRequestFindbyRecId - cWebBusinessProcess

Performs a find by Record ID for the passed file name and record number

Type: Function

Return Data Type: Integer

Parameters: string sfileName String sRec

Parameter | Description
sfileName | The name of table to find in
sRec | The record id (RECNUM) to find

Return Value

A non-zero return value indicates that the record was not found or that an error occurred.

Description

The DoRequestFindbyRecId function performs a find by Record ID (recnum in some database tables) for the passed file name and record number.

Note that a file name and not a file number is passed. There must be an associated data dictionary for the passed file name.

<% WBO.Call "get_DoRequestFindbyRecId", FileName, RecordNumber %>
<% bNotFound = WBO.Call("get_DoRequestFindbyRecId", FileName, RecordNumber) %>

Last Edited: August 5, 2003


cWebBusinessProcess [Function DoRequestFindbyRowId]

DoRequestFindbyRowId - cWebBusinessProcess

Type: Function

Return Data Type: Integer

Parameters: string sfileName String sRec

Parameter | Description
sfileName | [ToDo: In Progress]
sRec | [ToDo: In Progress]

Return Value

Description

Last Edited: November 11, 2004


cWebBusinessProcess [Function Html_Ctrl_Name]

Html_Ctrl_Name - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer iFile integer iField

Parameter | Description
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function Html_Ctrl_RowId_Name]

Html_Ctrl_RowId_Name - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer iFile

Parameter | Description
iFile | [ToDo: In Progress]

Return Value

Description

Last Edited: November 11, 2004


cWebBusinessProcess [Function HtmlAnchor]

HtmlAnchor - cWebBusinessProcess

Adds an Html Anchor

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlAnchor adds an Html Anchor. It is equivalent to:

<a>sData</a>

VDF Code

String sData sVar
Get HtmlAnchor sData to sVar
Send WriteHtml (HtmlAnchor(Self,sData))

Script Code

<a>sData</a>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlBig]

HtmlBig - cWebBusinessProcess

Makes the string big

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlBig makes the string big. The HTML equivalent of:

<big>sData</big>

VDF Code

String sData sVar
Get HtmlBig sData to sVar
Send WriteHtml (HtmlBig(Self,sData))

Script Code

<big>sData</big>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlBlink]

HtmlBlink - cWebBusinessProcess

Makes the string blink

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlBlink makes the string blink. The HTML equivalent of:

<blink>sData</blink>

VDF Code

String sData sVar
Get HtmlBlink sData to sVar
Send WriteHtml (HtmlBlink(Self,sData))

Script Code

<blink>sData</blink>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlBold]

HtmlBold - cWebBusinessProcess

Makes the string bold

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlBold makes the string bold. The HTML equivalent of:

<b>sData</b>

VDF Code

String sData sVar
Get HtmlBold sData to sVar
Send WriteHtml (HtmlBold(Self,sData))

Script Code

<b>sData</b>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlEmph]

HtmlEmph - cWebBusinessProcess

Makes the string emphasized

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlEmph makes the string emphasized. The HTML equivalent of:

<em>sData</em>

VDF Code

String sData sVar
Get HtmlEmph sData to sVar
Send WriteHtml (HtmlEmph(Self,sData))

Script Code

<em>sData</em>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlFixed]

HtmlFixed - cWebBusinessProcess

Makes the string fixed width

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlFixed makes the string fixed width. The HTML equivalent of:

<tt>sData</tt>

VDF Code

String sData sVar
Get HtmlFixed sData to sVar
Send WriteHtml (HtmlFixed(Self,sData))

Script Code

<tt>sData</tt>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlFontcolor]

HtmlFontcolor - cWebBusinessProcess

Sets the strings font color

Type: Function

Return Data Type: String

Parameters: string sFontClr

Parameter | Description
sFontClr | font color to use

Return Value

Returns formatted Html string

Description

HtmlFontColor sets the strings font color. The HTML equivalent of:

<font color=sColor>

VDF Code

String sColor sVar
Get HtmlFontColor sColor to sVar
Send WriteHtml (HtmlFontColor(Self,sColor))

Script Code

<font color=<I>sColor>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlFontsize]

HtmlFontsize - cWebBusinessProcess

Sets the font size

Type: Function

Return Data Type: String

Parameters: integer iSize

Parameter | Description
iSize | font size to use

Return Value

Returns formatted Html string

Description

HtmlFontSize sets the font size. The HTML equivalent of:

<font size=iSize>

VDF Code

Integer iSizeString sVar
Get HtmlFontSize iSize to sVar
Send WriteHtml (HtmlFontSize(Self,iSize))

Script Code

<font size=iSize>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlHeader]

HtmlHeader - cWebBusinessProcess

Creates a header string of level iHeader

Type: Function

Return Data Type: String

Parameters: integer iHeader string sDat

Parameter | Description
iHeader | number or level of header to create
sDat | data to place in header

Return Value

Returns formatted Html string

Description

HtmlHeader creates a header string of level iHeader. The HTML equivalent of:

<hn>sData</hn>

where n is the header number passed as iHeaderNum.

VDF Code

Integer iHeaderNum
String sData sVar
Get HtmlHeader iHeaderNum sData to sVar
Send WriteHtml (HtmlHeader(Self,iHeaderNum,sData))

Script Code

<h1>sData</h1>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlItalics]

HtmlItalics - cWebBusinessProcess

Makes the string italics

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlItalics makes the string italics. The HTML equivalent of:

<i>sData</i>

VDF Code

String sData sVar
Get HtmlItalics sData to sVar
Send WriteHtml (HtmlItalics(Self,sData))

Script Code

<i>sData</i>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlLink]

HtmlLink - cWebBusinessProcess

Adds a hyperlink to a string

Type: Function

Return Data Type: String

Parameters: string sURL string sDat

Parameter | Description
sURL | URL for link
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlLink adds a hyperlink (sURL) to a string (sDat). The HTML equivalent of:

<a href=sURL>sData</a>

VDF Code

String sData sVar
Get HtmlLink sURL sData to sVar
Send WriteHtml (HtmlLink(Self,sURL,sData))

Script Code

<a href=sURL>sData</a>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlSmall]

HtmlSmall - cWebBusinessProcess

Makes the string small

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlSmall makes the string small. The HTML equivalent of:

<small>sData</small>

VDF Code

String sData sVar
Get HtmlSmall sData to sVar
Send WriteHtml (HtmlSmall(Self,sData))

Script Code

<small>sData</small>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlStrike]

HtmlStrike - cWebBusinessProcess

Overstrikes through the string

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlStrike overstrikes through the string. The HTML equivalent of:

<strike>sData</strike>

VDF Code

String sData sVar
Get HtmlStrike sData to sVar
Send WriteHtml (HtmlStrike(Self,sData))

Script Code

<strike>sDat</strike>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlStrong]

HtmlStrong - cWebBusinessProcess

Adds strong emphasis to the string

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlStrong adds strong emphasis (usually appears as bold) to the string. The HTML equivalent of:

<strong>sData</strong>

VDF Code

String sData sVar
Get HtmlStrong sData to sVar
Send WriteHtml (HtmlStrong(Self,sData))

Script Code

<strong>sData</strong>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlSub]

HtmlSub - cWebBusinessProcess

Makes the string subscript

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlSub makes the string subscript. The HTML equivalent of:

<sub>sData</sub>

VDF Code

String sData sVar
Get HtmlSub sData to sVar
Send WriteHtml (HtmlSub(Self,sData))

Script Code

<sub>sData</sub>

Last Edited: August 18, 2003


cWebBusinessProcess [Function HtmlSup]

HtmlSup - cWebBusinessProcess

Makes the string superscript

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Html string

Description

HtmlSup makes the string superscript. The HTML equivalent of:

<sup>sData</sup>

VDF Code

String sData sVar
Get HtmlSup sData to sVar
Send WriteHtml (HtmlSup(Self,sData))

Script Code

<sup>sData</sup>

Last Edited: August 18, 2003


cWebBusinessProcess [Function IndexMainField]

IndexMainField - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: string sfileName integer iIndex

Parameter | Description
sfileName | [ToDo: In Progress]
iIndex | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function ValTbl_ItemData]

ValTbl_ItemData - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField integer iItem

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]
iItem | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function ValTbl_ItemDesc]

ValTbl_ItemDesc - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: integer hMain integer iFile integer iField integer iItem

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]
iItem | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function ValTbl_Items]

ValTbl_Items - cWebBusinessProcess

Type: Function

Return Data Type: Integer

Parameters: integer hMain integer iFile integer iField

Parameter | Description
hMain | [ToDo: In Progress]
iFile | [ToDo: In Progress]
iField | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function WmlAnchor]

WmlAnchor - cWebBusinessProcess

Adds an Wml Anchor

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

This adds an Wml Anchor.

The WML equivalent of:

<a>sData</a>

VDF Code

String sData sVar
Get WmlAnchor sData to sVar
Send WriteWml (WmlAnchor(Self,sData))

Script Code

<a>sData</a>

Last Edited: September 15, 2003


cWebBusinessProcess [Function WmlBig]

WmlBig - cWebBusinessProcess

Makes the string big

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

WmlBig makes the string big. The WML equivalent of:

<big>sData</big>

VDF Code

String sData sVar
Get WmlBig sData to sVar
Send WriteWml (WmlBig(Self,sData))

Script Code

<big>sData</big>

Last Edited: September 15, 2003


cWebBusinessProcess [Function WmlBold]

WmlBold - cWebBusinessProcess

Makes the string bold

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

WmlBold makes the string bold. The WML equivalent of:

<b>sData</b>

VDF Code

String sData sVar
Get WmlBold sData to sVar
Send WriteWml (WmlBold(Self,sData))

Script Code

<b>sData</b>

Last Edited: September 15, 2003


cWebBusinessProcess [Function WmlCreateFindIndexSelect]

WmlCreateFindIndexSelect - cWebBusinessProcess

Type: Function

Return Data Type: String

Parameters: string sComboName string sfileName integer iDfltIndex

Parameter | Description
sComboName | [ToDo: In Progress]
sfileName | [ToDo: In Progress]
iDfltIndex | [ToDo: In Progress]

Return Value

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Function WmlEm]

WmlEm - cWebBusinessProcess

Makes the string emphasized

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

WmlEm makes the string emphasized. The WML equivalent of:

<em>sData</em>

VDF Code

String sData sVar
Get WmlEm sData to sVar
Send WriteWml (WmlEm(Self,sData))

Script Code

<em>sData</em>

Last Edited: September 15, 2003


cWebBusinessProcess [Function WmlItalics]

WmlItalics - cWebBusinessProcess

Makes the string italics

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

WmlItalics makes the string italics. The WML equivalent of:

<i>sData</i>

VDF Code

String sData sVar
Get WmlItalics sData to sVar
Send WriteWml (WmlItalics(Self,sData))

Script Code

<i>sData</i>

Last Edited: September 15, 2003


cWebBusinessProcess [Function WmlLink]

WmlLink - cWebBusinessProcess

Adds a hyperlink (sURL) to a string (sDat)

Type: Function

Return Data Type: String

Parameters: string sURL string sDat string sTitle

Parameter | Description
sURL | the URL of the hyperlink
sDat | text displayed for the link
sTitle | link title (optional)

Return Value

Returns formatted Wml string

Description

WmlLink adds a hyperlink (sURL) to a string (sDat). The WML equivalent of:

<a href=sURL title=sTitle>sData</a>

VDF Code

String sData sVar sTitle
Get WmlLink sURL sData sTitle to sVar
Send WriteWml (WmlLink(Self,sURL,sData,sTitle))

Script Code

<a href=sURL>sData</a>

or

<a href=sURL title=sTitle>sData</a>

Last Edited: September 15, 2003


cWebBusinessProcess [Function WmlSmall]

WmlSmall - cWebBusinessProcess

Makes the string small

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

WmlSmall makes the string small. The WML equivalent of:

<small>sData</small>

VDF Code

String sData sVar
Get WmlSmall sData to sVar
Send WriteWml (WmlSmall(Self,sData))

Script Code

<small>sData</small>

Last Edited: September 15, 2003


cWebBusinessProcess [Function WmlStrong]

WmlStrong - cWebBusinessProcess

Adds strong emphasis (usually appears as bold) to the string

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

WmlStrong adds strong emphasis (usually appears as bold) to the string. The WML equivalent of:

<strong>sData</strong>

VDF Code

String sData sVar
Get WmlStrong sData to sVar
Send WriteWml (WmlStrong(Self,sData))

Script Code

<strong>sData</strong>

Last Edited: September 15, 2003


Methods for cWebBusinessProcess

View method list in hierarchical order

Name | Type | Description | Defining Class
AutoEntry | Function | Creates a label and an input control for each field in the passed file name |
AutoReport | Function | Generates a report for the passed filename, using the passed index with support for hypertext links to another web page |
ClearConfirmation | Function |  | cRemoteEntryProcess
ClearErrors | Procedure | Clears the error queue | cInternetSessionBusinessProcess
Cookie | Function |  | cInternetSessionBusinessProcess
Cookie | Procedure Set |  | cInternetSessionBusinessProcess
CookieAttribute | Procedure Set |  | cInternetSessionBusinessProcess
Create | Function | Creates an object based on the passed Class Id | cObject
CreateFindIndexCombo | Function | Creates a control that lists all available indexes for a table |
DDAutoControl | Function |  |
ddClear | Function | Clears the DataDictionary buffer |
DDComboControl | Function |  |
DDComboOptions | Function |  |
DDCurrentValue | Function |  | cInternetSessionBusinessProcess
ddDelete | Function | Deletes current record in the DataDictionary buffer |
DDEditControl | Function |  |
DDFieldErr | Function |  |
ddFind | Function | Finds a record and places it in the DataDictionary buffer |
ddFindbyRecId | Function | Finds a record using passed record id (RECNUM) and places it in the DataDictionary buffer |
ddFindbyRowId | Function |  |
ddFindFirst | Function | Finds first record and places it in the DataDictionary buffer |
ddFindLast | Function | Finds last record and places it in the DataDictionary buffer |
ddFindNext | Function | Finds next record and places it in DataDictionary buffer |
ddFindPrev | Function | Finds previous record and places it in DataDictionary buffer |
DDFormControl | Function |  |
DDHndValue | Function | Called within an ASP file by using the DDValue message |
DDParentComboControl | Function |  |
DDRadioControl | Function |  |
DDReadOnlyHTML | Function |  |
DDRecsOptions | Function |  |
DDRowIdsOptions | Function |  |
ddSave | Function | Performs a data validation and, once validated, saves a record using the current information in the DataDictionary buffer |
DDTitleHTML | Function |  |
ddValidate | Function | Validates all fields using current data in the DataDictionary buffer |
DDValue | Function | Returns the value of a file.field from the DataDictionary in a specified form | cInternetSessionBusinessProcess
DDValueEncode | Function | Returns the value of a file.field from the DataDictionary in HTMLEncoded form | cInternetSessionBusinessProcess
DDWMLInputControl | Function |  |
DeleteConfirmation | Function |  | cRemoteEntryProcess
Destroy | Procedure |  | cObject
DoGetHtmlFormValue | Function | Obtains the value of any posted HTML form value | cInternetSessionBusinessProcess
DoGetHtmlQueryString | Function | Obtains the value of any ASP variables | cInternetSessionBusinessProcess
DoRequestClear | Function | Generates a remote clear process | cRemoteEntryProcess
DoRequestDDUpdate | Function | Provides another way to build the WBO's data dictionary structure based on information passed from the browser | cRemoteEntryProcess
DoRequestDelete | Function | Generates a remote delete process | cRemoteEntryProcess
DoRequestFind | Function | Performs a field find for the passed file name, field name and find mode | cRemoteEntryProcess
DoRequestFindbyRecId | Function | Performs a find by Record ID for the passed file name and record number |
DoRequestFindbyRowId | Function |  |
DoRequestSave | Function | Generates a remote save process | cRemoteEntryProcess
ErrorCount | Function | Returns the number of errors in the current error queue | cInternetSessionBusinessProcess
ErrorMessage | Function | Returns an HTML formatted error message for item iItem in the error queue | cInternetSessionBusinessProcess
ErrorQueueEnd | Procedure | Ends an error queue process | cInternetSessionBusinessProcess
ErrorQueueStart | Procedure | Starts an error queue process | cInternetSessionBusinessProcess
Exit_Application | Procedure | Starts the process of closing an application | cObject
FileFieldErrorItem | Function | Checks the error queue for an error associated with the passed file and field | cInternetSessionBusinessProcess
Html_Ctrl_Name | Function |  |
Html_Ctrl_RowId_Name | Function |  |
HtmlAnchor | Function | Adds an Html Anchor |
HtmlBig | Function | Makes the string big |
HtmlBlink | Function | Makes the string blink |
HtmlBold | Function | Makes the string bold |
HtmlEmph | Function | Makes the string emphasized |
HtmlFixed | Function | Makes the string fixed width |
HtmlFontcolor | Function | Sets the strings font color |
HtmlFontsize | Function | Sets the font size |
HtmlHeader | Function | Creates a header string of level iHeader |
HtmlItalics | Function | Makes the string italics |
HtmlLink | Function | Adds a hyperlink to a string |
HtmlSmall | Function | Makes the string small |
HtmlStrike | Function | Overstrikes through the string |
HtmlStrong | Function | Adds strong emphasis to the string |
HtmlSub | Function | Makes the string subscript |
HtmlSup | Function | Makes the string superscript |
IndexMainField | Function |  |
isFieldChanged | Function |  | cInternetSessionBusinessProcess
LogErrorEvent | Procedure | Logs an error event | cInternetSessionBusinessProcess
LogEvent | Procedure | Logs an event to the Web Application's event log | cInternetSessionBusinessProcess
MapFileNametoDD | Function |  | cDistributedBusinessProcess
MaptoFieldNumber | Function |  | cDistributedBusinessProcess
MaptoFileNumber | Function |  | cDistributedBusinessProcess
RegisterAutoEntryInterface | Procedure | Provides ASP support for the AutoEntry function |
RegisterBasicErrorInterface | Procedure | Adds messages that are often needed when creating ASP pages, that require special error handling within the ASP page |
RegisterDDInterface | Procedure |  |
RegisterDebugInterface | Procedure | Adds messages that are often needed when debugging programs |
RegisterFullErrorInterface | Procedure | Adds messages that are often needed when creating complex ASP pages, that require full information about errors within a WBO process |
RegisterInterface | Procedure | Registers a message (property, function, procedure) and make it available as a Call message within an ASP page | cInternetSessionBusinessProcess
RegisterStandardInterface | Procedure | The Call messages that are often needed for a normal program |
RemoveInterface | Procedure | When sent, removes any message from the Call interface | cInternetSessionBusinessProcess
ReportAllErrors | Procedure | Generates a list of all errors that have occurred since this error queue was last cleared | cInternetSessionBusinessProcess
ReportErrorItem | Procedure | Displays the error for iItem in the error queue | cInternetSessionBusinessProcess
ReportLastError | Procedure | Displays the last error in the error queue | cInternetSessionBusinessProcess
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
RequestFileFieldValues | Procedure |  | cDistributedBusinessProcess
RequestFileRecords | Procedure |  | cDistributedBusinessProcess
SaveConfirmation | Function |  | cRemoteEntryProcess
Search_Field_Name | Function |  | cInternetSessionBusinessProcess
Search_File_Name | Function |  | cInternetSessionBusinessProcess
ServerVariable | Function |  | cInternetSessionBusinessProcess
SetChangedFields | Procedure |  | cInternetSessionBusinessProcess
SetDDCurrentValue | Procedure |  | cInternetSessionBusinessProcess
SetDDHndValue | Procedure |  | cInternetSessionBusinessProcess
SetDDValue | Procedure | Directly sets the value of a file.field in the DataDictionary buffer | cInternetSessionBusinessProcess
ValTbl_ItemData | Function |  |
ValTbl_ItemDesc | Function |  |
ValTbl_Items | Function |  |
WmlAnchor | Function | Adds an Wml Anchor |
WmlBig | Function | Makes the string big |
WmlBold | Function | Makes the string bold |
WmlCreateFindIndexSelect | Function |  |
WmlEm | Function | Makes the string emphasized |
WmlItalics | Function | Makes the string italics |
WmlLink | Function | Adds a hyperlink (sURL) to a string (sDat) |
WmlSmall | Function | Makes the string small |
WmlStrong | Function | Adds strong emphasis (usually appears as bold) to the string |
WriteData | Procedure | Like WriteHtml except it is used to output data by an address pointer |
WriteHtml | Procedure | Outputs the passed string to the web page and ends the line |
WriteHtmlBreak | Procedure | Outputs the passed string and ends the line |
WriteHtmlCell | Procedure | Outputs a table cell containing sData |
WriteHtmlCellHeader | Procedure | Outputs a table header cell containing sData |
WriteHtmlHorzLine | Procedure | Outputs a horizontal line to the HTML file |
WriteHtmlPlainText | Procedure | Encodes and then outputs the passed text to the HTML file |
WriteHtmlRowBegin | Procedure | Outputs a "begin" row HTML string |
WriteHtmlRowEnd | Procedure | Outputs an end row html string |
WriteHtmlTableBegin | Procedure | Outputs a "begin" table html string |
WriteHtmlTableEnd | Procedure | Outputs an end table html string |
WriteWml | Procedure | Outputs the passed string to the web page and ends the line |
WriteWmlBreak | Procedure | Outputs the passed string and ends the line |
WriteWmlCell | Procedure | Outputs a table cell containing sData |
WriteWmlDataBegin | Procedure | Outputs a begin table data WML string |
WriteWmlDataEnd | Procedure | Outputs an end table data WML string |
WriteWmlImg | Procedure | Adds a WML image |
WriteWmlRowBegin | Procedure | Outputs a "begin" row WML string |
WriteWmlRowEnd | Procedure | Outputs an end row WML string |
WriteWmlTableBegin | Procedure | Outputs a "begin" table html string |
WriteWmlTableEnd | Procedure | Outputs an end table wml string |


cWebBusinessProcess [Procedure RegisterAutoEntryInterface]

RegisterAutoEntryInterface - cWebBusinessProcess

Provides ASP support for the AutoEntry function

Type: Procedure

Parameters: No Parameters

Description

RegisterAutoEntryInterface provides ASP support for the AutoEntry function. The AutoEntry function creates an entire entry page for all fields in a file. This is useful for debugging, but would rarely be used in deployed applications. If you wish to use auto entry, you can register all auto-entry related messages with the above message. It registers the following messages.

set_psAutoEntryLabelStart
set_psAutoEntryLabelEnd
set_psAutoEntryDataStart
set_psAutoEntryDataEnd
get_AutoEntry

VDF Code

Send RegisterAutoEntryInterface

Last Edited: September 11, 2003


cWebBusinessProcess [Procedure RegisterBasicErrorInterface]

RegisterBasicErrorInterface - cWebBusinessProcess

Adds messages that are often needed when creating ASP pages, that require special error handling within the ASP page

Type: Procedure

Parameters: No Parameters

Description

RegisterBasicErrorInterface adds messages that are often needed when creating ASP pages, that require special error handling within the ASP page. Sending this message will add the following messages to the Call interface.

msg_ErrorQueueStart
msg_ErrorQueueEnd
msg_ClearErrors
msg_ReportAllErrors

VDF Code

Send RegisterBasicErrorInterface

Last Edited: September 11, 2003


cWebBusinessProcess [Procedure RegisterDDInterface]

RegisterDDInterface - cWebBusinessProcess

Type: Procedure

Parameters: No Parameters

Description

Last Edited: July 2, 2003


cWebBusinessProcess [Procedure RegisterDebugInterface]

RegisterDebugInterface - cWebBusinessProcess

Adds messages that are often needed when debugging programs

Type: Procedure

Parameters: No Parameters

Description

RegisterDebugInterface adds messages that are often needed when debugging programs. Sending this message will add the following messages to the Call interface.

set_pbVerboseErrors
set_pbAllErrorstoEventLog
set_pbAllErrorstoLocal
set_pbAllErrorsToHtml
set_peHtmlOutput

VDF Code

Send RegisterDebugInterface

Last Edited: September 11, 2003


cWebBusinessProcess [Procedure RegisterFullErrorInterface]

RegisterFullErrorInterface - cWebBusinessProcess

Adds messages that are often needed when creating complex ASP pages, that require full information about errors within a WBO process

Type: Procedure

Parameters: No Parameters

Description

RegisterFullErrorInterface adds messages that are often needed when creating complex ASP pages, that require full information about errors within a WBO process. Sending this message will add the following messages to the Call interface.

msg_ErrorQueueStart
msg_ErrorQueueEnd
msg_ClearErrors
msg_ReportAllErrors
msg_ReportLastError
get_ErrorCount
msg_ReportErrorItem
get_ErrorMessage
msg_LogErrorEvent

VDF Code

Send RegisterFullErrorInterface

Last Edited: September 11, 2003


cWebBusinessProcess [Procedure RegisterStandardInterface]

RegisterStandardInterface - cWebBusinessProcess

The Call messages that are often needed for a normal program

Type: Procedure

Parameters: No Parameters

Description

These are the Call messages that are often needed for a normal program. Sending this message will add the following messages to the Call interface.

set_pbReportErrors
set_pbClearAfterSave
get_CreateFindIndexCombo
get_peFieldMultiUser
msg_ErrorQueueStart
msg_ErrorQueueEnd
msg_ClearErrors
msg_ReportAllErrors

VDF Code

Send RegisterStandardInterface

Last Edited: September 11, 2003


cWebBusinessProcess [Procedure WriteData]

WriteData - cWebBusinessProcess

Like WriteHtml except it is used to output data by an address pointer

Type: Procedure

Parameters: address pData

Parameter | Description
pData | pointer to address of data to access

Description

The WriteData message is like WriteHtml except it is used to output data by an address pointer. This allows output of long data and is designed to be used with XML output.

Example

Get paXML of hoXML to pXML  // returns XML document via a pointer - can be real big
Send WriteData pXML               // output document to ASP by pointer
Move (Free(pXML)) to bOk        // when done, you MUST dispose of the memory yourself!!!

Last Edited: September 1, 2004


cWebBusinessProcess [Procedure WriteHtml]

WriteHtml - cWebBusinessProcess

Outputs the passed string to the web page and ends the line

Type: Procedure

Parameters: string sHtml

Parameter | Description
sHtml | data string to write to browser

Description

WriteHtml outputs the passed string to the web page and ends the line. When passing strings you will probably first want to encode the Html string, so special characters will not be read as HTML characters.

Typical output message might look like:

Send WriteHtml (HtmlEncode(Customer.Name))

Remember that HtmlEncode is a global method - it does not require an object parameter.

This outputs the passed string to the HTML file. The text is passed unfiltered to the HTML page (unless the HtmlEncode function is used). All of the other WBO HTML messages use this message to output HTML. You may use this to generate any type of valid HTML output you want.

Note: The text is not processed in any way. If the string contains valid HTML formatting characters (i.e., ), they will be interpreted by your browser as formatting commands. If your text contains characters that should not be "misunderstood" by HTML, you should encode them using the HtmlEncode function.

With the exception of the WriteHtmlPlainText message, all of the other WriteHtmlxxx messages eventually send this message.

VDF Code

Send WriteHtml (HTMLEncode(Customer.Name))
Send WriteHtml ("<strong>" + HTMLEncode(Customer.Notes) + "</strong>")

Last Edited: June 23, 2005


cWebBusinessProcess [Procedure WriteHtmlBreak]

WriteHtmlBreak - cWebBusinessProcess

Outputs the passed string and ends the line

Type: Procedure

Parameters: String sHtml

Parameter | Description
sHtml | data to output

Description

WriteHtmlBreak outputs the string and then generates a line break (creates a new line). The HTML equivalent of:

sData <br/>

VDF Code

Send WriteHtmlBreak sData

Script Code

sData <br/>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteHtmlCell]

WriteHtmlCell - cWebBusinessProcess

Outputs a table cell containing sData

Type: Procedure

Parameters: String sData String sAlign

Parameter | Description
sData | data to place in the table cell
sAlign | horizontal alignment to use for table cell

Description

WriteHtmlCell outputs a table cell containing sData. If a second parameter is passed, it is used to format the cell. If it is not passed the format will default to align=center, valign=top. The HTML equivalent of the message would be:

<td align="center">sData</td>

VDF Code

Send WriteHtmlCell sData
Send WriteHtmlCell sData sAlign
// The following two lines are equivalent:
Send WriteHtmlCell (HtmlEncode(Cust.Name))
Send WriteHtml ('<td align="center" valign="top">' + HtmlEncode(Cust.Name) + '</td>')
// The following two lines are also equivalent:
Send WriteHtmlCell (HtmlEncode(Cust.Name), 'align="Left"')
Send WriteHtml ('<td align="Left">' + HtmlEncode(Cust.Name) + '</td>')

Script Code

<td align= "center">sData</td>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteHtmlCellHeader]

WriteHtmlCellHeader - cWebBusinessProcess

Outputs a table header cell containing sData

Type: Procedure

Parameters: String sData string sAlign

Parameter | Description
sData | data to place in the table cell. If empty, a non-breaking space HTML character will be placed in the data part of the cell header.
sAlign | horizontal alignment to use for table cell

Description

WriteHtmlCellHeader outputs a table header cell containing sData. If a second parameter is passed, it is used to format the cell. The default format is align=center, valign=top. The HTML equivalent of the message would be:

<th align="center" valign="top">sData</th>

VDF Code

Send WriteHtmlCellHeader sData
Send WriteHtmlCellHeader sData sAlign
//The following two lines are equivalent:
Send WriteHtmlCellHeader ("Name")
Send WriteHtml ('<th align="center" valign="top">' + "Name" + '</th>')
//The following two lines are also equivalent:
Send WriteHtmlCellHeader "Name" 'align="Left"'
Send WriteHtml ('<th align="Left">' + "Name" + '</th>')

Script Code

<th align="center" valign="top">sData</th>

Last Edited: June 21, 2005


cWebBusinessProcess [Procedure WriteHtmlHorzLine]

WriteHtmlHorzLine - cWebBusinessProcess

Outputs a horizontal line to the HTML file

Type: Procedure

Parameters: No Parameters

Description

WriteHtmlHorzLine outputs a horizontal line to the HTML file. The HTML equivalent of:

<hr>

VDF Code

Send WriteHtmlHorzLine

Script Code

<hr>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteHtmlPlainText]

WriteHtmlPlainText - cWebBusinessProcess

Encodes and then outputs the passed text to the HTML file

Type: Procedure

Parameters: string sTxt

Parameter | Description
sTxt | [ToDo: In Progress]

Description

WriteHtmlPlainText encodes and then outputs the passed text to the HTML file. The text is encoded so that all special HTML characters (e.g, "<", ">") are converted to their proper HTML replacements (i.e., "<" ">";).

The following text will be encoded and output properly to HTML.

Send WriteHtmlPlainText Customer.Name

Be careful how you use this. The following message would probably not yield the desired results.

Send WriteHtmlPlainText ("<b>" + Customer.Notes + "</b>")

Rather than displaying the text in bold you would see the text displayed exactly as it was sent (you would see the <b> and the </b>) . To get the desired results you could do one of the following:

Send WriteHTML ("<b>" + HTMLEncode(Customer.Notes) + "</b>")

Or:

Send WriteHtml      "<b>"
Send WriteHtmlPlainText Customer.Notes
Send WriteHtml      "<b>"

VDF Code

Send WriteHtmlPlainText Customer.Name

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteHtmlRowBegin]

WriteHtmlRowBegin - cWebBusinessProcess

Outputs a "begin" row HTML string

Type: Procedure

Parameters: No Parameters

Description

WriteHtmlRowBegin outputs a "begin" row HTML string. The HTML equivalent of:

<tr>

VDF Code

Send WriteHtmlRowBegin

Script Code

<tr>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteHtmlRowEnd]

WriteHtmlRowEnd - cWebBusinessProcess

Outputs an end row html string

Type: Procedure

Parameters: No Parameters

Description

WriteHtmlRowEnd outputs an end row html string. The HTML equivalent of:

</tr>

VDF Code

Send WriteHtmlRowEnd

Script Code

</tr>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteHtmlTableBegin]

WriteHtmlTableBegin - cWebBusinessProcess

Outputs a "begin" table html string

Type: Procedure

Parameters: String sParams string sPer

Parameter | Description
sParams | additional parameters to use with the tag; if omitted, 'border="1" width="99%"' will be added to the tag.
sPer | Optional percentage table width (rarely used)

Description

If you pass zero arguments to this method, the result will be

If you pass one argument to this method, the result will be
<table {value of argument1}>

For example, when the one argument is

'border="2"'

, the result will be

<table border="2">

If you pass two arguments to this method, the result will be that the value of the second argument will be used to set the width of the table as a percentage. Pass in the value only a number, the method will add 'width="' and '%"'.

If you write:

Send WriteHtmlTableBegin 2 50

, the result will be

<table border="2" width="50%">

So, if two arguments are passed the first argument should be ONLY the value for the border part of the tag and the second argument the value for the width part of the tag.

WriteHtmlTableBegin outputs a "begin" table html string. The HTML equivalent of:

<table border="1" width="99%">

The following two lines are equivalent:

Send WriteHtmlTableBegin
Send WriteHtml ('<table border="1" width="99%">')

The following two lines are equivalent:

Send WriteWmlTableBegin 'border="0" background="MyImg.gif"'
Send WriteWml '<table border="0" background="MyImg.gif">'

VDF Code

Send WriteHtmlTableBegin sParams

Script Code

<table>

Last Edited: September 2, 2005


cWebBusinessProcess [Procedure WriteHtmlTableEnd]

WriteHtmlTableEnd - cWebBusinessProcess

Outputs an end table html string

Type: Procedure

Parameters: No Parameters

Description

WriteHtmlTableEnd outputs an end table html string. The HTML equivalent of:

</table>

VDF Code

Send WriteHtmlTableEnd

Script Code

</table>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteWml]

WriteWml - cWebBusinessProcess

Outputs the passed string to the web page and ends the line

Type: Procedure

Parameters: String sWml

Parameter | Description
sWml | data string to write to Wml browser

Description

WriteWml outputs the passed string to the web page and ends the line. When passing strings you will probably first want to encode the Wml string, so special characters will not be read as WML characters.

This method maintains the piWmlLength property.

Typical output message might look like:

Send WriteWml (WmlEncode(Customer.Name))

Remember that HtmlEncode is a global method - it does not require an object parameter.

This outputs the passed string to the WML file. The text is passed unfiltered to the WML page (unless the HtmlEncode function is used). All of the other WBO WML messages use this message to output WML. You may use this to generate any type of valid WML output you want.

Note:The text is not processed in any way. If the string contains valid WML formatting characters (i.e., the Bold tag), they will be interpreted by your browser as formatting commands. If your text contains characters that should not be "misunderstood" by WML, you should encode them using the WMLEncode function.

With the exception of the WriteHtmlPlainText message, all of the other WriteHtmlxxx messages eventually send this message.

VDF Code

Send WriteWml (WmlEncode(Customer.Name))
Send WriteWml ("<strong>" + WmlEncode(Customer.Notes) + "</strong>")

Script Code

None

Last Edited: June 23, 2005


cWebBusinessProcess [Procedure WriteWmlBreak]

WriteWmlBreak - cWebBusinessProcess

Outputs the passed string and ends the line

Type: Procedure

Parameters: String sWml

Parameter | Description
sWml | data string to write to Wml browser

Description

WriteWmlBreak outputs the string and then generates a line break (creates a new line). The WML equivalent of:

("<br/>")

VDF Code

Send WriteWmlBreak sStr

Script Code

sStr <br/>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteWmlCell]

WriteWmlCell - cWebBusinessProcess

Outputs a table cell containing sData

Type: Procedure

Parameters: string sData

Parameter | Description
sData | data to place in the table cell

Description

WriteWmlCell outputs a table cell containing sData. The WML equivalent of the message would be:

<td>sData</td>

VDF Code Examples

Send WriteWmlCell sData
Send WriteWmlCell (WmlEncode(Cust.Name))

Script Code

<td>sData</td>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteWmlDataBegin]

WriteWmlDataBegin - cWebBusinessProcess

Outputs a begin table data WML string

Type: Procedure

Parameters: No Parameters

Description

WriteWmlDataBegin outputs a begin table data WML string. The WML equivalent of:

<td>

VDF Code

Send WriteWmlDataBegin

Script Code

<td>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteWmlDataEnd]

WriteWmlDataEnd - cWebBusinessProcess

Outputs an end table data WML string

Type: Procedure

Parameters: No Parameters

Description

WriteWmlDataEnd outputs an end table data WML string. The WML equivalent of:

</td>

VDF Code

Send WriteWmlDataEnd

Script Code

</td>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteWmlImg]

WriteWmlImg - cWebBusinessProcess

Adds a WML image

Type: Procedure

Parameters: String sAlt String sSrc String sExtra

Parameter | Description
sAlt | value for alt= option of IMG tag
sSrc | value for src= option of IMG tag
sExtra | value for optional extra portion of IMG tag

Description

WriteWmlImg adds a WML image. The WML equivalent of:

<img alt=sAlt src=sSrc sExtra/>

VDF Code

String sAlt sSrc sExtra
Send WriteWmlImg sAlt sSrc sExtra

Script Code

<img alt=sAlt src=sSrc sExtra/>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteWmlRowBegin]

WriteWmlRowBegin - cWebBusinessProcess

Outputs a "begin" row WML string

Type: Procedure

Parameters: No Parameters

Description

WriteWmlRowBegin outputs a "begin" row WML string. The WML equivalent of:

<tr>

VDF Code

Send WriteWmlRowBegin

Script Code

<tr>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteWmlRowEnd]

WriteWmlRowEnd - cWebBusinessProcess

Outputs an end row WML string

Type: Procedure

Parameters: No Parameters

Description

WriteWmlRowEnd outputs an end row WML string. The WML equivalent of:

</tr>

VDF Code

Send WriteWmlRowEnd

Script Code

</tr>

Last Edited: September 15, 2003


cWebBusinessProcess [Procedure WriteWmlTableBegin]

WriteWmlTableBegin - cWebBusinessProcess

Outputs a "begin" table html string

Type: Procedure

Parameters: String sParams string sPer

Parameter | Description
sParams | additional parameters to use with the tag
sPer | Optional percentage table width (rarely used)

Description

WriteWmlTableBegin outputs a "begin" table html string. The WML equivalent of:

<table border="1" width="99%">

The following two lines are equivalent:

Send WriteWmlTableBegin
Send WriteWml ('<table border="1" width="99%">')

The following two lines are equivalent:

Send WriteWmlTableBegin 'border="0" background="MyImg.gif"''
Send WriteWml '<table border="0" background="MyImg.gif"'>'

VDF Code

Send WriteWmlTableBegin sParams

Script Code

</table>

Last Edited: September 18, 2003


cWebBusinessProcess [Procedure WriteWmlTableEnd]

WriteWmlTableEnd - cWebBusinessProcess

Outputs an end table wml string

Type: Procedure

Parameters: No Parameters

Description

WriteWmlTableEnd outputs an end table wml string. The WML equivalent of:

</table>

VDF Code

Send WriteWmlTableEnd

Script Code

</table>

Last Edited: September 15, 2003


Properties for cWebBusinessProcess

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Main_dd | Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function | cDistributedBusinessProcess
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbAllErrorstoEventLog | Determines if errors will be placed in the event log | cInternetSessionBusinessProcess
pbAllErrorsToHtml | Determines if non-queued errors are sent | cInternetSessionBusinessProcess
pbAllErrorstoLocal | Determines if errors are directed to the standard VDF error handler | cInternetSessionBusinessProcess
pbAllowClear | Determines whether the WBO object will support the Clear operation | cRemoteEntryProcess
pbAllowDDUpdate | Determines whether the WBO object will support update operations to the DataDictionary | cRemoteEntryProcess
pbAllowDelete | Determines whether the WBO object will support the Delete operation | cRemoteEntryProcess
pbAllowFind | Determines whether the WBO object will support the Find operation | cRemoteEntryProcess
pbAllowSaveEdit | Determines whether the WBO object will support an edit Save operation | cRemoteEntryProcess
pbAllowSaveNew | Determines whether the WBO object will support a new Save operation | cRemoteEntryProcess
pbClearAfterSave | Determines what should happen after a successful save | cRemoteEntryProcess
pbClearDDOsOnDetach |  | cDistributedBusinessProcess
pbQueueErrors | Determines where errors are placed | cInternetSessionBusinessProcess
pbReportErrors | Suppresses the automatic generation of errors when set false | cRemoteEntryProcess
pbShowEntryError |  | cDistributedBusinessProcess
pbUseOpenEvalInterface | Determines if the Call interface should allow access to all WBO messages | cInternetSessionBusinessProcess
pbVerboseErrors | Determines how much information is presented when an HTML error is displayed | cInternetSessionBusinessProcess
peFieldMultiUser | Determines if the data submitted by a web application browser should report changes at the field level | cRemoteEntryProcess
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phREO_MainDD |  | cRemoteEntryProcess
piREO_OperationStatus |  | cRemoteEntryProcess
psAutoEntryDataEnd | Determines the appearance of the end of the entry data that are created by the AutoEntry message |
psAutoEntryDataStart | Determines the appearance of the start of the entry data that are created by the AutoEntry message |
psAutoEntryLabelEnd | Determines the appearance of the end of the entry labels that are created by the AutoEntry message |
psAutoEntryLabelStart | Determines the appearance of the start of the entry labels that are created by the AutoEntry message |
psDescription | Adds a description to the WBO object | cInternetSessionBusinessProcess


cWebBusinessProcess [Property psAutoEntryDataEnd]

psAutoEntryDataEnd - cWebBusinessProcess

Determines the appearance of the end of the entry data that are created by the AutoEntry message

Type: Property

Access: Read/Write

Data Type: String

Description

The psAutoEntryDataEnd property determines the appearance of the end of the entry data that are created by the AutoEntry message.

Last Edited: September 11, 2003


cWebBusinessProcess [Property psAutoEntryDataStart]

psAutoEntryDataStart - cWebBusinessProcess

Determines the appearance of the start of the entry data that are created by the AutoEntry message

Type: Property

Access: Read/Write

Data Type: String

Description

The psAutoEntryDataStart property determines the appearance of the start of the entry data that are created by the AutoEntry message.

Last Edited: September 11, 2003


cWebBusinessProcess [Property psAutoEntryLabelEnd]

psAutoEntryLabelEnd - cWebBusinessProcess

Determines the appearance of the end of the entry labels that are created by the AutoEntry message

Type: Property

Access: Read/Write

Data Type: String

Description

The psAutoEntryLabelEnd property determines the appearance of the end of the entry labels that are created by the AutoEntry message.

Last Edited: September 11, 2003


cWebBusinessProcess [Property psAutoEntryLabelStart]

psAutoEntryLabelStart - cWebBusinessProcess

Determines the appearance of the start of the entry labels that are created by the AutoEntry message

Type: Property

Access: Read/Write

Data Type: String

Description

The psAutoEntryLabelStart property determines the appearance of the start of the entry labels that are created by the AutoEntry message.

Two sets of properties (psAutoEntryLabelStart/psAutoEntryLabelEnd and psAutoEntryDataStart/psAutoEntryDataEnd) give you some control over the appearance of your labels and forms. It is expected that each label and form will be displayed in an HTML table.

You can set properties to determine the format of the label cell (psAutoEntryLabelStart and psAutoEntryLabelEnd) and the input cell (psAutoEntryDataStart and psAutoEntryDataEnd). By default, labels are right aligned and emphasized. Form cells have no special attributes. They are defined in Visual DataFlex as follows:

Property string psAutoEntryLabelStart '<td align="right"><em>'
Property string psAutoEntryLabelEnd   '</em></td>'
Property string psAutoEntryDataStart  '<td>'
Property string psAutoEntryDataEnd    '</td>'

The following example, shows how you can change the display characteristics and then build an auto entry form. In this case we will make the labels left justified (the HTML default), strong and small for every field (that is not a binary or text) in the SalesP database table.

<% WBO.Call "set_psAutoEntryLabelStart", "<td><strong><small>"
   WBO.Call "set_psAutoEntryLabelEnd",  "</small></strong></td>"
   WBO.Call "get_AutoEntry","SalesP" %>

VDF Code

Set psAutoEntryLabelStart to ""
Get psAutoEntryLabelStart to sLabelStartDesc

Script Code

<% WBO.Call "set_psAutoEntryLabelStart" %>
<% sLabelStartDesc=WBO.Call ("get_psAutoEntryLabelStart") %>

Registering Messages in the WBO

Before this message can be used within your script code, it must be registered within your WBO. This is done by sending the appropriate RegisterInterface message or by sending the RegisterStandardInterface message.

To register psAutoEntryLabelStart send one of the following:

Send RegisterInterface set_psAutoEntryLabelStart "set_ psAutoEntryLabelStart" ;
    "sFile iRecord";  "This will determine the appearance of the entry label start used  by the AutoEntry message "

Send RegisterAutoEntryInterface

Send RegisterInterface get_psAutoEntryLabelStart "get_ psAutoEntryLabelStart" ;
    "sFile iRecord";  "This will retrieve the setting that determine the appearance of the entry label start used  by the AutoEntry message "

Last Edited: September 11, 2003


cWebReport [Event OnInitBreakPoints]

OnInitBreakPoints - cWebReport

Determines the number and order of your breakpoints

Type: Event

Parameters: No Parameters

Description

OnInitBreakpoints determines the number and order of your breakpoints. It is called when a report is started and should be used to define and intitialize your breakpoints. You are expected to provide a list of all breakpoint methods by adding the message RegisterBreakpoint.

For example, if your report contained a single breakpoint on Customer.Name your report would need the following code.

// The breakpoint function must return the value to be tested for a break
Function Break1 returns String
    Function_Return Customer.Name
End_Function
// We must register all breakpoints for this report
Procedure OnInitBreakpoints
    Send RegisterBreakpoint get_Break1 // Function Break must be defined
End_Procedure

When you assign breakpoints, you must make sure that the breakpoints are ordered in the same order as your index. The above example assumes that you are listing records in customer name order. If you were not, report would appear to break at random times.

You can assign multiple breakpoints within a report. It is expected that your report's order will be proper for the levels of breakpoints you create. When a break is encountered, a "break" event occurs. The current break level is closed by sending the event OnSubTotalx where x is numerical breakpoint level. The first level is 1 (and not 0). The following example shows an order detail report with three levels of breakpoint; customer number, order number, detail number. It is assumed that the index be used will be: OrderDtl.Customer_Number x OrderDtl.Order_Number x OrderDtl.Dtl_Number.

// The breakpoint functions must return the value to be tested for a break
Function Break1 returns String
    Function_Return OrderDtl.Customer_Number
End_Function
Function Break2 returns String
    Function_Return OrderDtl.Order_Number
End_Function
Function Break3 returns String
    Function_Return OrderDtl.Dtl_Number
End_Function
// We must register all breakpoints for this report
Procedure OnInitBreakpoints
    Send RegisterBreakpoint get_Break1
    Send RegisterBreakpoint get_Break2
    Send RegisterBreakpoint get_Break3
End_Procedure

You can also create breakpoints on calculated values. The next example has two breakpoints. The highest breakpoint will be based on the first letter of the name, the inner level will be based on the actual name. This allows us to have two heading levels - First letter of name, and the name.

// The breakpoint functions must return the value to be tested for a break
Function Break1 returns String
    String sCh
    Move (uppercase(left(Customer.Name,1))) to sCh
    Function_Return sCh
End_Function
Function Break2 returns String
    Function_Return Customer.Name
End_Function
// We must register all breakpoints for this report
Procedure OnInitBreakpoints
    Send RegisterBreakpoint get_Break1
    Send RegisterBreakpoint get_Break2
End_Procedure

As an advanced technique, breakpoints can be determined at runtime. In the following example, the report will only break on customer.name if the chosen index is correct.

Procedure OnInitBreakpoints
    Integer iOrdering
    Get piOrdering to iOrdering // index order
    If (iOrdering=2) begin // index 2 is customer name order
      Send RegisterBreakpoint get_Break1
    End
End_Procedure

See Also

RegisterBreakpoint | OnSubHeader1..n | OnSubTotal1..n

Last Edited: September 10, 2003


Events for cWebReport

View event list in hierarchical order

Name | Description | Defining Class
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property | cReport
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Error_Report | Sent whenever an error is generated | cBasicReport
Final_Formfeed |  | cReport
OnBody | Called every time a valid record has been found | cReport
OnConstrain |  | cReport
OnEndingMainReport | User Handler Intended for override | cBasicReport
OnEndingReport | Called at the end of all reports | cReport
onError | Provided as a hook to handle custom error reporting | cBasicReport
OnInitBreakPoints | Determines the number and order of your breakpoints |
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables | cReport
OnPageFooter | Printed after OnPageTotal on every page except the last page | cReport
OnPageHeader | Called after OnPageTop on every new page except the first | cReport
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader. | cReport
OnPageTop | Called when printing the top of every report | cReport
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page | cReport
OnReportFooter | Printed after OnPageTotal on the last page of the report | cReport
OnReportHeader | Called only on the first page of the report, after OnPageTop | cReport
OnSelection | Validates a record | cReport
OnStartingMainReport | Called when a report is started | cBasicReport
OnStartingReport | Called when a report is started | cReport
OnSubHeader1..n | Called each time a subheader needs to be printed | cReport
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program | cReport
OnSubTotal1..n | Called when a subtotal needs to be processed | cReport
OnTotal | Called at the end of a report after all final sub-totals have been printed | cReport
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found | cReport
Report_Interrupt | Called when the status panel's Cancel button has been pressed | cBasicReport


cWebReport [Function AddRecordLink]

AddRecordLink - cWebReport

Creates a cell that contains a link to another web page

Type: Function

Obsolete

Return Data Type: String

Parameters: string sValue

Parameter | Description
sValue | the text displayed in the link

Return Value

Returns a fully formatted HTML anchor tag that displays this data and contains a link to another page.

Description

Obsolete

This method is obsolete. Use AddRowidLink.

AddRecordLink makes it easy to create a cell that contains a link to another web page. This allows you to create drill down reports, reports that link to a zoom page and reports that link back to a data entry page.

This function is passed a data sValue and it returns a fully formatted HTML anchor tag that displays this data and contains a link to another page.

The link consists of a URL address which is defined in the property psHRefName; and a Record Id link which is defined as "RecID=xx" where xx is the current record's record id (recnum).

For example, assume you need to create a link to a page named "MyZoomPage.asp" and that you want to pass it a record id in the format of "RecId=xx". So the entire URL must be "MyZoomPage.asp?RecId=xx". You wish to assign the link to customer name. You could do this manually as follows:

Move Customer.Name to sName
Move Customer.recnum to sRec
Move "MyZoomPage.asp" to sRefName
Move (sRefName - "?RecId=" - sRec ) to sUrl
Get HtmlLink sUrl (HtmlEncode(sName)) to sValue
Send WriteHtmlCell sValue 'Class="Data" Align="right"'

If you use this function and the psHRefName property this can be accomplished as follows:

1. Before you start the report set the psHRefName as follows:

Set psHRefName of oReport to "MyZoomPage.asp"

2. Within your body section create the following code:

Get AddRecordLink (HtmlEncode(Customer.Name)) to sText
Send WriteHtmlCell sText 'Class="Data" Align="right"'

If you need to pass additional information in your URL you can do so by adding the information to the psHRefName property. For example, if you wanted to add the additional information Operation=1 to you URL you could do this by setting your psHRefName property to:

Set psHRefName to "MyZoomPage.asp?Operation=1"

The AddRecordLink would return the following URL:

MyZoomPage.asp?Operation=1&RecId=xx

See Also

AddRowidLink | psHRefName | HtmlLink

Last Edited: February 2, 2005


cWebReport [Function AddRowIdLink]

AddRowIdLink - cWebReport

Creates a cell that contains a link to another web page

Type: Function

Return Data Type: String

Parameters: string sValue

Parameter | Description
sValue | the text displayed in the link

Return Value

Description

AddRowIdLink makes it easy to create a cell that contains a link to another web page. This allows you to create drill down reports, reports that link to a zoom page and reports that link back to a data entry page.

This function is passed a data sValue and it returns a fully formatted HTML anchor tag that displays this data and contains a link to another page.

The link consists of a URL address which is defined in the property psHRefName; and a Record Id link which is defined as "RowId=xx" where xx is the current record's serialized RowId.

For example, assume you need to create a link to a page named "MyZoomPage.asp" and that you want to pass it a record id in the format of "RowId=xx". So the entire URL must be "MyZoomPage.asp?RowId=xx". You wish to assign the link to customer name. You could do this manually as follows:

string sName sRowId sRefName sUrl sValue
rowId sRowId
Move Customer.Name to sName
Move (GetRowId(Customer.file_number)) to riRowId
Move (SerializeRowid(riRowId)) to sRowId
Move "MyZoomPage.asp" to sRefName
Move (sRefName - "?RowId=" - sRowId ) to sUrl
Get HtmlLink sUrl (HtmlEncode(sName)) to sValue
Send WriteHtmlCell sValue 'Class="Data" Align="right"'

If you use this function and the psHRefName property this can be accomplished as follows:

1. Before you start the report set the psHRefName as follows:

Set psHRefName of oReport to "MyZoomPage.asp"

2. Within your body section create the following code:

Get AddRowIdLink (HtmlEncode(Customer.Name)) to sText
Send WriteHtmlCell sText 'Class="Data" Align="right"'

If you need to pass additional information in your URL you can do so by adding the information to the psHRefName property. For example, if you wanted to add the additional information Operation=1 to you URL you could do this by setting your psHRefName property to:

Set psHRefName to "MyZoomPage.asp?Operation=1"

The AddRecordLink would return the following URL:

MyZoomPage.asp?Operation=1&RowId=xx

See Also

psHRefName | HtmlLink

Last Edited: February 2, 2005


Methods for cWebReport

View method list in hierarchical order

Name | Type | Description | Defining Class
AddRecordLink | Function | (Obsolete) Creates a cell that contains a link to another web page |
AddRowIdLink | Function | Creates a cell that contains a link to another web page |
AddSubTotal | Procedure | Adds the passed value to the total maintained in level iCount | cHtmlReport
ClearAllSubTotals | Procedure | Clears all the SubTotal accumulators | cHtmlReport
ClearSubTotal | Procedure | Clears a single Subtotal accumulator | cHtmlReport
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoRunReport | Function | The main entry point for reportsT | cReport
End_Log | Procedure | Sends an end-log message to the log object | cBasicReport
Error_Log_Status | Procedure | Called by error_report if status_log_state is true | cBasicReport
Exit_Application | Procedure | Starts the process of closing an application | cObject
Formfeed | Procedure | Handles formfeeds | cReport
HtmlAnchor | Function | Adds an Html Anchor | cHtmlReport
HtmlBig | Function | Makes the string big | cHtmlReport
HtmlBlink | Function | Makes the string blink | cHtmlReport
HtmlBold | Function | Makes the string bold | cHtmlReport
HtmlEmph | Function | Makes the string emphasized | cHtmlReport
HtmlFixed | Function | Makes the string fixed width | cHtmlReport
HtmlFontcolor | Function | Sets the strings font color | cHtmlReport
HtmlFontsize | Function | Sets the font size | cHtmlReport
HtmlHeader | Function | Creates a header string of level iHeader | cHtmlReport
HtmlItalics | Function | Makes the string italics | cHtmlReport
HtmlLink | Function | Adds a hyperlink to a string | cHtmlReport
HtmlSmall | Function | Makes the string small | cHtmlReport
HtmlStrike | Function | Overstrikes through the string | cHtmlReport
HtmlStrong | Function | Adds strong emphasis to the string | cHtmlReport
HtmlSub | Function | Makes the string subscript | cHtmlReport
HtmlSup | Function | Makes the string superscript | cHtmlReport
Log_Status | Procedure | Sends passed message to the log object | cBasicReport
Output_ImageNum | Procedure | Outputs the image represented by ImageNum | cReport
RegisterBreakpoint | Procedure | registers a breakpoint function |
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO | cReportDS
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Save | Procedure | If sent, this saves the current record | cReportDS
Start_Log | Procedure | Sends a start-log message to the log object | cBasicReport
SubTotal | Function | Returns the appropriate subtotal and clears the subtotal accumulator | cHtmlReport
SumSubTotal | Function | Returns the appropriate subtotal but does not clear the subtotal accumulator | cHtmlReport
Update_Status | Procedure | Send this message to update the action area of the status panel | cBasicReport
WriteHtml | Procedure | Outputs the passed string to the web page and ends the line | cHtmlReport
WriteHtmlBreak | Procedure | Outputs the passed string and ends the line | cHtmlReport
WriteHtmlCell | Procedure | Outputs a table cell containing sData | cHtmlReport
WriteHtmlCellHeader | Procedure | Outputs a table header cell containing sData | cHtmlReport
WriteHtmlHorzLine | Procedure | Outputs a horizontal line to the HTML file | cHtmlReport
WriteHtmlRowBegin | Procedure | Outputs a "begin" row HTML string | cHtmlReport
WriteHtmlRowEnd | Procedure | Outputs an end row html string | cHtmlReport
WriteHtmlTableBegin | Procedure | Outputs a "begin" table html string | cHtmlReport
WriteHtmlTableEnd | Procedure | Outputs an end table html string | cHtmlReport
WriteLn | Procedure | Outputs the string and ends the Line | cHtmlReport
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data | cReport


cWebReport [Procedure RegisterBreakpoint]

RegisterBreakpoint - cWebReport

registers a breakpoint function

Type: Procedure

Parameters: integer hmMsg

Parameter | Description
hmMsg | the name of the breakpoint function that will return a breakpoint test value

Description

RegisterBreakpoint registers a breakpoint function. This method should only be sent within the OnInitBreakpoints event handler. When the event OnInitBreakpoints occurs, all breakpoint must be defined for the object. A breakpoint is defined by sending the RegisterBreakpoint message. The parameter, hmMsg, must be the name of the breakpoint function that will return a breakpoint test value. When the report object tests a record for a break, it calls this function and checks the value returned by this function with the previous value returned for the previous record. If they are different a break occurs.

To create breakpoints you must:

1. Create a function for each breakpoint. This function must return the value, which should be tested for change.

// The breakpoint function must return the value to be tested for a break
Function Break1 returns String
    Function_Return Customer.Name
End_Function

2. Register this function within OnInitBreakpoints using the Send RegisterBreakpoint message.

// We must register all breakpoints for this report
Procedure OnInitBreakpoints
    Send RegisterBreakpoint get_Break1
End_Procedure

Note that the message to be registered will always be a function. Therefore it must always be prefaced with "get_". In the above example, the function Break1 is registered with the name "get_Break1". Also, you should always register your breakpoint functions after they have been defined in your code. If you fail to do this, you may receive a compiler forward reference error.

You do not have to use the names "Break" for your function name. This is done to provide an easy method for keeping track of breakpoint orders. This makes it easy to align these functions with the OnSubHeader and OnSubTotal events, which require a break number.

When you assign breakpoints, you must make sure that the breakpoints are ordered in the same order as your index. The above example assumes that you are listing records in customer name order. If you were not, the report would appear to break at random times.

You can assign multiple breakpoints within a report. It is expected that your report's order will be proper for the levels of breakpoints you create. When a break is encountered, a "break" event occurs. The current break level is closed by sending the event OnSubTotalx where x is numerical breakpoint level. The first level is 1 (and not 0). The following example shows an order detail report with three levels of breakpoint; customer number, order number, detail number. It is assumed that the index used will be: OrderDtl.Customer_Number x OrderDtl.Order_Number x OrderDtl.Dtl_Number.

// The breakpoint functions must return the value to be tested for a break
Function Break1 returns String
    Function_Return OrderDtl.Customer_Number
End_Function
Function Break2 returns String
    Function_Return OrderDtl.Order_Number
End_Function
Function Break3 returns String
    Function_Return OrderDtl.Dtl_Number
End_Function
// We must register all breakpoints for this report
Procedure OnInitBreakpoints
    Send RegisterBreakpoint get_Break1
    Send RegisterBreakpoint get_Break2
    Send RegisterBreakpoint get_Break3
End_Procedure

You can also create breakpoints on calculated values. The next example has two breakpoints. The highest breakpoint will be based on the first letter of the name, the inner level will be based on the actual name. This allows us to have two heading levels - First letter of name, and the name.

// The breakpoint functions must return the value to be tested for a break
Function Break1 returns String
    String sCh
    Move (uppercase(left(Customer.Name,1))) to sCh
    Function_Return sCh
End_Function
Function Break2 returns String
    Function_Return Customer.Name
End_Function
// We must register all breakpoints for this report
Procedure OnInitBreakpoints
    Send RegisterBreakpoint get_Break1
    Send RegisterBreakpoint get_Break2
End_Procedure

As an advanced technique, breakpoints can be determined at runtime. In the following example, the report will only break on customer.name if the chosen index is correct.

Procedure OnInitBreakpoints
    Integer iOrdering
    Get piOrdering to iOrdering // index order
    If (iOrdering=2) begin // index 2 is customer name order
        Send RegisterBreakpoint get_Break1
    End
End_Procedure

See Also

OnInitBreakpoints

Last Edited: September 11, 2003


Properties for cWebReport

View property list in hierarchical order

Name | Description | Defining Class
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button | cBasicReport
Assigned_Channel |  | cReport
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Error_State |  | cBasicReport
Find_Mode | Maintains the current finding mode | cReport
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image | cReport
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function | cReport
Last_Rec | (Obsolete) Contains the record number of the last selected record found | cReport
Main_File | Contains the filenumber of the file which the report will use for finding records | cReport
Name | Returns the full name of the object including parentage | cObject
New_Page_State | Set true when a new page is needed | cReport
No_Constrained_Find_State | Determines if constrained record finding should be disabled | cReport
No_Finding_State | Determines how the cReport object will find records | cReport
No_PageCheck_State | Set true when the cReport object is processing a new page | cReport
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found | cReport
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Output_Device | Handles the name of the output device | cBasicReport
Page_Count | Keeps track of the current page number | cReport
Page_End | Determines how many lines on a page are allowed before a page break will occur | cReport
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence | cReport
Page_Feed | Used by the formfeed procedure | cReport
Page_Footer_Lines | The number of lines in the page_footer image | cReport
Parent | Returns the parent of an object | cObject
pbCanceled | Setting this true will cancel a report | cReport
pbChildReport | Set true if the current cReport object is nested | cReport
pbFindDown | Determines if the report should traverse up or down the index | cReport
pbHasChildReports | Is set true if other reports are nested inside this report object | cReport
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level | cReport
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phMainReport | Contains the object ID of the outer report | cReport
piConstrainFile | Used when creating reports to limit the printing to a single parent record and the related children | cHtmlReport
piConstrainRecord | (Obsolete) Used when creating reports to limit the printing to a single parent record and the related children | cHtmlReport
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found | cReport
piLastRecord | (Obsolete) Holds the record that was processed when a report was halted because the maximum number of records was encountered |
piMaxCount | Holds the maximum number of records to print |
piMaxCountBreakLevel | Determines what is considered to be a "record" when record counting is used to create partial reports |
piNumberBreaks | Returns the number of breaks in a report | cReport
piOrdering | Contains the index number which will be used for finding records | cReport
piRecordCount | Contains the number of records found for the current report | cReport
piStartRecord | (Obsolete) Allows you to create partial reports providing a method for creating web report "pages" |
priConstrainRowId | Used when creating reports to limit the printing to a single parent record and the related children | cHtmlReport
priCurrentRec | Contains the RowId of the current valid record found | cReport
priFoundRec | Contains the RowId of the record found by the find_rec function | cReport
priLastRec | Contains the RowId of the last selected record found | cReport
priLastRowId | Holds the RowId of the record that was processed when a report was halted because the maximum number of records was encountered |
priStartRowId | Determines the RowId of the first record of a report allowing you to create partial web reports |
psHRefName | Holds the full URL of a file (ASP or HTML) to be displayed as part of a "drill down" operation |
Report_Caption | Contains the text that will appear in the status panel's caption bar | cBasicReport
Report_Channel | Determines which output channel will be used for your report output | cReport
Report_Footer_Lines | The number of lines in the OnReportFooter image | cReport
Report_Message | An additional message area that will appear below the report_title in the status panel | cBasicReport
Report_Status_Panel |  | cBasicReport
Report_Title | A centered title that appears in the status panel | cBasicReport
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing | cReport
Server | Identifies the object handle that is used as the report object's main data-dictionary object | cReportDS
Status_Log_Id | Object ID of status-log object | cBasicReport
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs | cBasicReport
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs | cBasicReport
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals | cReport


cWebReport [Property piLastRecord]

piLastRecord - cWebReport

Holds the record that was processed when a report was halted because the maximum number of records was encountered

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Obsolete

This property has been replaced by priLastRowId.

piLastRecord holds the record that was processed when a report was halted because the maximum number of records was encountered. This property is used with piStartRecord, piMaxCount and piMaxCountBreakLevel to create partial web reports.

You should never set this property.

After a report has finished you will get this property to determine if the report processed all records (if piLastRecord is 0) or what the next record of a continued report should be (if piLastRecord is greater than 0).

Get piLastRecord to iLastRecord

The following custom function shows how this property is used to run a partial report. The property piStartRecord, which is passed, determines what record to start with. The property piMaxCount, which is also passed, determines the maximum number of records to display in this partial report. When the report is finished, the function will return the property piLastRecord. This property contains the next record to read if the report was to be continued.

Function RunCustomerReport integer iIndex integer iStart integer iMax Returns Integer
    Integer iEnd iStat
    Set piOrdering           to iIndex
    Set piMaxCount           to iMax
    Set piMaxCountBreakLevel to 0 // count each body record
    Set piStartRecord        to iStart
    Get DoRunReport          to iStat
    Get piLastRecord         to iEnd
    Function_return iEnd
End_Function // RunCustomerReport

Normally the value of piLastrecord is returned to your your ASP page. Using this information the ASP script can then determine if a next button or link should be placed on the page and if selected it can use this value to pass to the ASP page to start the next "page" of the report.

See Also

priLastRowId | piStartRecord | piMaxCount | piMaxCountBreakLevel

Last Edited: February 2, 2005


cWebReport [Property piMaxCount]

piMaxCount - cWebReport

Holds the maximum number of records to print

Type: Property

Access: Read/Write

Data Type: Integer

Description

piMaxCount holds the maximum number of records to print. This property is used with piStartRecord, piLastRecord and piMaxCountBreakLevel to create partial web reports. You will set this property but rarely need to get it.

The property piMaxCountBreakLevel can be used to determine what level should be used for "record" counting. This provides a mechanism for never breaking in the middle of a breakpoint section.

The following custom function shows how this property is used to run a partial report. The property piStartRecord, which is passed, determines what record to start with. The property piMaxCount, which is also passed, determines the maximum number of records to display in this partial report. When the report is finished, the function will return the property piLastRecord. This property contains the next record to read if the report was to be continued.

Function RunCustomerReport integer iIndex integer iStart integer iMax Returns Integer
    Integer iEnd iStat
    Set piOrdering           to iIndex
    Set piMaxCount           to iMax
    Set piMaxCountBreakLevel to 0 // count each body record
    Set piStartRecord        to iStart
    Get DoRunReport          to iStat
    Get piLastRecord         to iEnd    Function_return iEnd
End_Function // RunCustomerReport

Normally the value of piMaxCount is passed from your ASP page. The first time the report is run it is passed 0. Each additional "page" of the report uses the piLastRecord return value as the start of the next page. This process continues until piLastRecord is 0 - indicating the end of the report.

See Also

piStartRecord | piLastRecord | piMaxCountBreakLevel

Last Edited: September 11, 2003


cWebReport [Property piMaxCountBreakLevel]

piMaxCountBreakLevel - cWebReport

Determines what is considered to be a "record" when record counting is used to create partial reports

Type: Property

Access: Read/Write

Data Type: Integer

Description

When record counting is used to create partial reports, the piMaxCountBreakLevel property determines what is considered to be a "record". When creating partial reports you will often only wish to stop the report at the end of a break section. For example, if you are displaying all orders for a customer your report should probably never stop in the middle of a customer section. So instead of checking to see how many "order" lines have been read, you would wish to see how many customers have been read.

If piMaxCountBreakLevel is 0, piMaxCount is compared against the number of valid records (i.e., each record sent to the OnBody section). If piMaxCountBreakLevel is 1 or greater, piMaxCount is compared to the number of breaks encountered at that breakpoint level. If, for example, piMaxCountBreakLevel is 1, piMaxCount would be checking the number of times the OnSubHeader1 section was called.

See Also

piStartRecord | piLastRecord | piMaxCount

Last Edited: September 11, 2003


cWebReport [Property piStartRecord]

piStartRecord - cWebReport

Allows you to create partial reports providing a method for creating web report "pages"

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Obsolete

This property has been replaced by priStartRowId.

The piStartRecord property allows you to create partial reports providing a method for creating web report "pages". By setting properties that determine a report's starting record ID and a maximum number of records a report can be created as a series smaller sub-reports (pages). On the Internet, this assures that a report user's report request will not be too big.

Setting this property determines which record should be used for the first record in the report. If the value of this property is 0, the report will start at the first valid record.

This property should be set before a report is started.

Set piStartRecord to iStartID

The following custom function shows how this property is used to run a partial report. The property piStartRecord, which is passed, determines what record to start with. The property piMaxCount, which is also passed, determines the maximum number of records to display in this partial report. When the report is finished, the function will return the property piLastRecord. This property contains the next record to read if the report was to be continued.

Function RunCustomerReport integer iIndex integer iStart integer iMax Returns Integer
    Integer iEnd iStat
    Set piOrdering           to iIndex
    Set piMaxCount           to iMax
    Set piMaxCountBreakLevel to 0
    Set piStartRecord        to iStart
    Get DoRunReport          to iStat
    Get piLastRecord         to iEnd
    Function_return iEnd
End_Function // RunCustomerReport

Normally the value of piStartRecord is passed from your ASP page. The first time the report is run it is passed 0. Each additional "page" of the report uses the piLastRecord return value as the start of the next page. This process continues until piLastRecord is 0 - indicating the end of the report.

See Also

priStartRowId | piMaxCount | piLastRecord | piMaxCountBreakLevel

Last Edited: February 2, 2005


cWebReport [Property priLastRowId]

priLastRowId - cWebReport

Holds the RowId of the record that was processed when a report was halted because the maximum number of records was encountered

Type: Property

Access: Read/Write

Data Type: RowId

Description

priLastRowId holds the RowId of the record that was processed when a report was halted because the maximum number of records was encountered. This property is used with priStartRowId, piMaxCount and piMaxCountBreakLevel to create partial web reports.

You should never set this property.

After a report has finished you will get this property to determine if the report processed all records (if priLastRowId is a null RowId) or what the next record of a continued report should be.

RowId riLastRowId
Get priLastRowId to riLastRowId

The following custom function shows how this property is used to run a partial report. The property piStartRowId, which is passed, determines what record to start with. The property piMaxCount, which is also passed, determines the maximum number of records to display in this partial report. When the report is finished, the function will return the property piLastRecord. This property contains the next record to read if the report was to be continued.

Function RunCustomerReport integer iIndex RowId riStart integer iMax Returns RowId
    RowId riEnd
    Integer  iStat
    Set piOrdering           to iIndex
    Set piMaxCount           to iMax
    Set piMaxCountBreakLevel to 0 // count each body record
    Set piStartRowId         to riStart
    Get DoRunReport          to iStat
    Get piLastRowId          to riEnd
    Function_return riEnd
End_Function // RunCustomerReport

Normally the value of piLastrecord is returned to your your ASP page. Using this information the ASP script can then determine if a next button or link should be placed on the page and if selected it can use this value to pass to the ASP page to start the next "page" of the report.

When a RowId is returned to the ASP page it must first be serialized so that it can be represented on the page. When a RowId is passed from a web page, it must be deserialized and placed back in a RowId variable.

Function RunReport integer iIndex string sStart integer iMax Returns string
    RowId riLast riStart
    String  sLast
    Move (DeserializeRowId(sStart)) to riStart
    Get RunCustomerReport of oReport iIndex riStart iMax to riLast
    Move (SerializeRowId(riLast)) to sLast
    Function_return sLast
End_Function

Note that a Null rowId is serialized as an empty string. You can test for this empty string in your ASP script code.

<h3>Customer Information Drill Down Report</h3>

<%
    Index      = request("Index")           ' The last selected Index number
    StartRowId = request("Start")
    SelStart1  = request("SelStart1")
    SelStop1   = request("SelStop1")

    oCustomerReport.call "msg_SetHRefName", ZoomUrl
    oCustomerReport.call "msg_SetCustomer_Number", SelStart1, SelStop1

    EndRowId = oCustomerReport.call("get_RunReport", Index, StartRowId, MaxRecs)
%>

<% If StartRowId <>"" then %>
<A HREF="#" onClick="history.go(-1);return false;">Previous Page</A>
<% end if %>

<% If EndRowId <>"" then %>
<A HREF="CustomerReport.asp?RunReport=1&Start=<%=EndRowId%>&Index=<%=Index%>&SelStart1=<%=SelStart1%>&SelStop1=<%=SelStop1%>">Next Page</A>
<% end if %>

See Also

priStartRowId | piMaxCount | piMaxCountBreakLevel

Last Edited: February 2, 2005


cWebReport [Property priStartRowId]

priStartRowId - cWebReport

Determines the RowId of the first record of a report allowing you to create partial web reports

Type: Property

Access: Read/Write

Data Type: RowId

Description

The piStartRecord property allows you to create partial reports providing a method for creating web report "pages". By setting properties that determine a report's starting record RowId and a maximum number of records a report can be created as a series smaller sub-reports (pages). On the Internet, this assures that a report user's report request will not be too big.

Setting this property determines which record should be used for the first record in the report. If the value of this property is null (IsNullRowId()), the report will start at the first valid record.

This property should be set before a report is started.

Set piStartRowId to StartID

The following custom function shows how this property is used to run a partial report. The property piStartRowId, which is passed, determines what record to start with. The property piMaxCount, which is also passed, determines the maximum number of records to display in this partial report. When the report is finished, the function will return the property piLastRecord. This property contains the next record to read if the report was to be continued.

Function RunCustomerReport integer iIndex RowId riStart integer iMax Returns RowId
    RowId riEnd
    Integer  iStat
    Set piOrdering           to iIndex
    Set piMaxCount           to iMax
    Set piMaxCountBreakLevel to 0 // count each body record
    Set piStartRowId         to riStart
    Get DoRunReport          to iStat
    Get piLastRowId          to riEnd
    Function_return riEnd
End_Function // RunCustomerReport

Normally the value of piLastrecord is returned to your your ASP page. Using this information the ASP script can then determine if a next button or link should be placed on the page and if selected it can use this value to pass to the ASP page to start the next "page" of the report.

When a RowId is returned to the ASP page it must first be serialized so that it can be represented on the page. When a RowId is passed from a web page, it must be deserialized and placed back in a RowId variable.

Function RunReport integer iIndex string sStart integer iMax Returns string
    RowId riLast riStart
    String  sLast
    Move (DeserializeRowId(sStart)) to riStart
    Get RunCustomerReport of oReport iIndex riStart iMax to riLast
    Move (SerializeRowId(riLast)) to sLast
    Function_return sLast
End_Function

Note that a Null rowId is serialized as an empty string. You can test for this empty string in your ASP script code.

<h3>Customer Information Drill Down Report</h3>

<%
    Index      = request("Index")           ' The last selected Index number
    StartRowId = request("Start")
    SelStart1  = request("SelStart1")
    SelStop1   = request("SelStop1")

    oCustomerReport.call "msg_SetHRefName", ZoomUrl
    oCustomerReport.call "msg_SetCustomer_Number", SelStart1, SelStop1

    EndRowId = oCustomerReport.call("get_RunReport", Index, StartRowId, MaxRecs)
%>

<% If StartRowId <>"" then %>
<A HREF="#" onClick="history.go(-1);return false;">Previous Page</A>
<% end if %>

<% If EndRowId <>"" then %>
<A HREF="CustomerReport.asp?RunReport=1&Start=<%=EndRowId%>&Index=<%=Index%>&SelStart1=<%=SelStart1%>&SelStop1=<%=SelStop1%>">Next Page</A>
<% end if %>

See Also

priLastRowId | piMaxCount | piMaxCountBreakLevel

Last Edited: February 2, 2005


cWebReport [Property psHRefName]

psHRefName - cWebReport

Holds the full URL of a file (ASP or HTML) to be displayed as part of a "drill down" operation

Type: Property

Access: Read/Write

Data Type: String

Description

The psHRefName string property holds the full URL of a file (ASP or HTML) to be displayed as part of a "drill down" operation. This property is used by the message get AddRecordLink to create an HTML anchor tag that contains the name of the URL and the row's record ID passed in the format of "URLName?RecID=###" where URLName is the value of the psHRefName property.

This property is often set from the WBO object where the WBO message that sets this value is called from the ASP page.

// this procedure is in a WBO which contains a report named oReport
Procedure SetHRefName string sName
Set psHRefname of oReport to sName
End_Procedure // SetHRefName

<% ` above WBO method is called from an ASP page %>
<% oCustomerReport.call "msg_SetHRefName", ZoomUrl %>

Last Edited: September 11, 2003


Events for cWebService

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cWebService [Function SoapHeaderRequestNode]

SoapHeaderRequestNode - cWebService

Returns SOAP header information passed to the web service as an XML object.

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle of the XML object representing the SOAP header, zero if no SOAP header exists.

Description

The SoapHeaderRequestNode provides a low level mechanism for processing SOAP header information passed to the web service method. It is expected that a developer using this method understands SOAP headers and understands how to work with XML objects.

The object handle returned will be a handle to an XML document object (cXMLDomDocument) and represents the entire SOAP header XML node. The root node of this document will be the SOAP

node and each child node should be an element node representing a header.

If a SOAP Header is not passed to the method, which is the norm, zero is returned.

It is the responsibility of the developer to destroy the XML object within the method that uses it.
<SOAP-ENV:Header
    xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
   <t:Transaction xmlns:t="some-URI">5</t:Transaction>
</SOAP-ENV:Header>

The above SOAP header could be processed as follows:

Function SayHello String sName Returns String
    String sReturn
    Handle hoXml hoRoot hoNode
    String sId
    Boolean bIsId

    // get request headers
    Get SoapHeaderRequestNode to hoXml
    If (hoXml) Begin
       Get DocumentElement of hoXML to hoRoot // should be SOAP <Header>
       Get FirstChild of hoRoot to hoNode
       // process all headers nodes
       While (hoNode)
            Get IsElementNS of hoNode "some-URI" "Transaction" to bIsId
            If bIsId Begin
                Get pstext of hoNode to sId
            End
            Get NextNode of hoNode to hoNode
        Loop
        // when done, destroy the XML object
        Send Destroy of hoXml
    End
    If (sId<>"5") Begin
        Function_Return ""
    End

    Move ("Hello, "+sName) to sReturn

    Function_Return sReturn
End_Function

A SOAP response header can be returned from a web service method by using the AddSoapHeaderNode method.

See Also

AddSoapHeaderNode

Last Edited: November 2, 2006


Methods for cWebService

View method list in hierarchical order

Name | Type | Description | Defining Class
AddSoapHeaderNode | Procedure | Adds a SOAP header node to a method's SOAP response. |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
LogErrorEvent | Procedure | Logs an error event |
LogEvent | Procedure | Logs an event to the Web Application's event log |
RegisterInterface | Procedure | Registers a message (property, function, procedure) and make it available as a Call message within an ASP page |
RegisterStandardInterface | Procedure |  |
RemoveInterface | Procedure | When sent, removes any message from the Call interface |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SoapHeaderRequestNode | Function | Returns SOAP header information passed to the web service as an XML object. |
WebServiceException | Procedure | Used to generate a web service exception (soap fault) |


cWebService [Procedure AddSoapHeaderNode]

AddSoapHeaderNode - cWebService

Adds a SOAP header node to a method's SOAP response.

Type: Procedure

Parameters: Handle hoNode

Parameter | Description
hoNode | The handle to an XML element node to be added as a SOAP Header.

Description

AddSoapHeaderNode is used to add SOAP headers to a method's SOAP response. This is a low level mechanism. It is expected that a developer using this method understands SOAP headers and understands how to work with XML objects.

The handle passed to this method must be a handle to an XML element object (cXMLDomElement). If an element node is not passed, an error will be generated.

Note that you do need to pass the actual SOAP

node, as the service does this for you. Instead, you pass the element nodes that are the children of the header node. Each time you call AddSoapHeaderNode, you add a new node to the SOAP header.

<SOAP-ENV:Header
    xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
   <Transaction xmlns="some-URI">5</Transaction>
</SOAP-ENV:Header>

The above SOAP header could be created as follows:

Get Create U_cXmlDomDocument to hoXml
Get CreateDocumentElementNS of hoXml "some-URI" "Transaction" to hoRoot
Set psText of hoRoot to "5"
Send AddSoapHeaderNode hoRoot
Send Destroy of hoXml

SOAP request headers may be processed by using the SoapHeaderRequestNode method.

The following example demonstrates how to get all requested SOAP headers and return them as response SOAP headers.

Get SoapHeaderRequestNode to hoXml  // get the SOAP request header
If (hoXml) Begin
    Get DocumentElement of hoXML to hoRoot // this will be <header>
    // Get all SOAP request child nodes
    Get FirstChild of hoRoot to hoNode
    While hoNode
        Send AddSoapHeaderNode hoNode  // Add to response header
        Get NextNode of hoNode to hoNode
    Loop
    Send Destroy of hoXml
End

See Also

SoapHeaderRequestNode

Last Edited: November 2, 2006


cWebService [Procedure LogErrorEvent]

LogErrorEvent - cWebService

Logs an error event

Type: Procedure

Parameters: Integer iErr String sText

Parameter | Description
iErr | type of event to log
sText | event name that is being logged

Description

LogErrorEvent logs an error event. An error event generates a normal error and explicitly logs this error to the Web Application's event log. Events can be viewed using the DataFlex WebApp Server Administration tool.

Most unexpected errors (program errors, syntax errors, etc.) are already automatically placed in the event log without any special programming on your part. This message should be used when you are sure the error should be added to the event log. If you are not logging an error event, do not use this message - use the LogEvent message.

Code

Send LogErrorEvent iEventType sEvent

Last Edited: March 24, 2004


cWebService [Procedure LogEvent]

LogEvent - cWebService

Logs an event to the Web Application's event log

Type: Procedure

Parameters: Integer iEventType String lpszEvent

Parameter | Description
iEventType | type of event to log
lpszEvent | event name that is being logged

Description

LogEvent logs an event to the Web Application's event log. This is often used to log any type of non-error system activity. Events can be viewed using the DataFlex WebApp Server Administration tool.

You should use this message to log any type of non-error activity to the error log. Errors should be added to the event log using the LogErrorEvent message. This message will generate an error and log the error to the event log. Most unexpected errors (program errors, syntax errors, etc.) are automatically placed in the event log without any special programming on your part.

Code

Send LogEvent iEventType sEvent

Last Edited: March 24, 2004


cWebService [Procedure RegisterInterface]

RegisterInterface - cWebService

Registers a message (property, function, procedure) and make it available as a Call message within an ASP page

Type: Procedure

Parameters: Integer iMsg String sMsgName String sParams String sComment

Parameter | Description
iMsg | id of message to register, usually message name preceded by "get_" (function) or "msg_" (procedure)
sMsgName | name of the message, in quotes, usually message name preceded by "get_" (function) or "msg_" (procedure)
sParams | arguments to the message, preceded by each argument's type; should be the same as message declaration
sComment | message description; brief summary of what message does

Description

The RegisterInterface message is used to register a message (property, function, procedure) and make it available as a Call message within an ASP page.

Four parameters are required:

iMsgNumber

This is the message number. Normally this is passed as the message name preceded by get_ (for functions and retrieving properties), set_ (for setting properties) or msg_ (for procedures). For example:

get_SomeProperty or get_SomeFuntion
set_SomeProperty
msg_SomeProcedure

sMsgName

This is the name of the message that will be used in the ASP page. Normally you should make this the same name as the property (just put quotes around the property name).

"get_SomeProperty" or "get_SomeFunction"
"set_SomeProperty"
"msg_SomeProcedure"

sParams

This records the list of parameters used by the message. This is not required and is used for documentation purposes.

sComment

This records a description of the message. This is not required and is used for documentation purposes.

All Call messages must be registered before they can be used (unless you set the UseOpenEvalInterface_state property to true). For example, if you wanted to expose the get_FindByRecId message you would register it as follows:

Object SalesP_WBO is a WebBusinessProcess
    Object Salesp_DD is a Salesp_DataDictionary
        Send DefineAllExtendedFields
    End_Object  // Salesp_DD
    Set phMainDD to (Salesp_DD(Self))
    Send RegisterInterface get_DoRequestFindbyRecId ;
        "get_DoRequestFindbyRecId" "sFile iRecord" ;
        "Find by recnum for the passed file and record"
End_Object  // SalesP_WBO

Instead of needing to create a RegisterInterface message for each message you plan to register some messages have been combined into interface procedures allowing you to register a single set of interfaces at one time. Those predefined interface messages are:

Send RegisterStandardInterface
Send RegisterBasicErrorInterface
Send RegisterFullErrorInterface
Send RegisterDebugInterface
Send RegisterAutoEntryInterface

Typically, you will want to register the standard interface.

Object SalesP_WBO is a WebBusinessProcess
    Object Salesp_DD is a Salesp_DataDictionary
        Send DefineAllExtendedFields
    End_Object  // Salesp_DD
    Set phMainDD to (Salesp_DD(Self))
    Send RegisterStandardInterface
End_Object  // SalesP_WBO

If the same message is registered more than once, only the first registration is applied.

VDF Code

Send RegisterInterface get_DoRequestFindbyRecId ;
    "get_DoRequestFindbyRecId" "sFile iRecord" ;
    "Find by RecId (recnum) for the passed file and record"

Note:
This message has changed from WebApp revision 2.x. If you do not change the format of your message from the old format, you will get errors when run your application and these messages are sent.

The old format looked like this:
- Send RegisterInterface msg_SetHRefName "msg_SetHRefName" "sName" "Name to link for drill down report"
- Send RegisterInterface get_RunCustomerReport "get_RunCustomerReport" "iIndex iStart iMax" "Run report"

The new format looks like this:
- Send RegisterInterface msg_SetHRefName "msg_SetHRefName" "String sName" "Name to link for drill down report"
- Send RegisterInterface get_RunCustomerReport "get_RunCustomerReport" "Integer iIndex Integer iStart Integer iMax Returns integer" "Run report"

There are two ways to change your old message format to the new one:

Preferred:
Just load every WBO in the Studio and it will convert it for you.
Less Preferred:
Take your existing WBOs and search for all "Send RegisterInterface" and change this to "Send RegisterSimpleInterface".
As you have time, change these. The problem with this method is that the Studio will no longer automatically handle conversions for you if you change the message name.

Last Edited: November 21, 2004


cWebService [Procedure RegisterStandardInterface]

RegisterStandardInterface - cWebService

Type: Procedure

Parameters: No Parameters

Description

Last Edited: March 25, 2004


cWebService [Procedure RemoveInterface]

RemoveInterface - cWebService

When sent, removes any message from the Call interface

Type: Procedure

Parameters: Integer iMsg

Parameter | Description
iMsg | number of message to remove from registered interface for a WBO

Description

You can remove any message from the Call interface by sending the RemoveInterface message. This makes it easy to remove messages that were added as part of standard interface inclusions.

For example, you may want to include all messages from RegisterStandardInterface except Get_AutoReport. This could be removed as follows:

Object SalesP_WBO is a WebBusinessProcess
    Object Salesp_DD is a Salesp_DataDictionary
        Send DefineAllExtendedFields
    End_Object  // Salesp_DD
    Set phMainDD to (Salesp_DD(Self))
     Send RegisterStandardInterface
     Send RemoveInterface Get_AutoReport
End_Object  // SalesP_WBO

VDF Code

Send RemoveInterface iMsgNumber

Last Edited: September 11, 2003


cWebService [Procedure WebServiceException]

WebServiceException - cWebService

Used to generate a web service exception (soap fault)

Type: Procedure

Parameters: string sError

Parameter | Description
sError | Error Description

Description

WebServiceException provides a method for rasing an exception in a web service function. The message takes one parameter, a string description of the exception. The message causes the soap response to return a soap fault. The faultcode will be "soap:Server" and the faultdescription will contain the the value passed in sError.

After sending the messages you should always end your operation by exiting the function.

The following web-service operation (function) returns a greeting string based on a passed name. If the name is empty, an exception will be raised.

Function SayHello String sName Returns String
    String sReturn

    // if sName is empty, raise an exception
    If (trim(sName)="") begin
        Send WebServiceException "Blank names are not allowed"
        function_return // always return after exception.
    end

    Move ("Hello, "+sName) to sReturn
    Function_Return sReturn
End_Function

Last Edited: December 6, 2004


Properties for cWebService

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Main_dd | Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbAllErrorstoEventLog | Determines if errors will be placed in the event log |
pbAllErrorstoLocal | Determines if errors are directed to the standard VDF error handler |
pbDocumentStyle | Determines if a Web Service should use Document or RPC style |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psDescription | Provides a short description of a web-service |
psDocumentation | Provides documentation for a Web-service that is added to the WSDL document |
psServiceName | Determines the service name |
psServiceTitle | Provides a Title for your web-service |
psServiceURI | Determines the TargetNamespace URI for your web-service |


cWebService [Property Main_dd]

Main_dd - cWebService

Identifies the DataDictionary object that controls the database file, the data from which is central to this object's function

Type: Property

Access: Read/Write

Data Type: Handle

Description

The Main_dd property identifies the DataDictionary object that controls the database file, the data from which is central to this object's function. The main datadictionary must be one of the DataDictionaries contained within the WBO object.

Code

Set Main_dd to oCustomer_DD
:
Get Main_dd to hoDDObjectID

Last Edited: March 24, 2004


cWebService [Property pbAllErrorstoEventLog]

pbAllErrorstoEventLog - cWebService

Determines if errors will be placed in the event log

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When true, all errors will be placed in the event log. When false only errors that are explicitly sent to the event log (via LogErrorEvent or a non-queued error) appear in the log.

During some processes Errors are placed in an error queue. These queued errors are then processed at a later time.

Code

Set pbAllErrorsToEventLog to true
:
Get pbAllErrorsToEventLog to iState

Last Edited: January 16, 2006


cWebService [Property pbAllErrorstoLocal]

pbAllErrorstoLocal - cWebService

Determines if errors are directed to the standard VDF error handler

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If true, all errors are directed to the standard VDF error handler. This means they will appear as a message box on the server console and will wait for you to "OK" the message. Normally this is not desired, but it can be useful when you are debugging from the NT console. Errors are displayed when they occur (they are never queued).

Note: If you set this property and you do not have access to the server console actually running your programs an error will cause your program to hang. It will actually be running, but it will be waiting for someone to press the "OK" button in the error message panel.

Code

Set pbAllErrorsToLocal to true
:
Get pbAllErrorsToLocal to iState

Last Edited: January 16, 2006


cWebService [Property pbDocumentStyle]

pbDocumentStyle - cWebService

Determines if a Web Service should use Document or RPC style

Type: Property

Access: Read/Write

Data Type: Boolean

Description

A web-service's style can be Document or RPC. The default for web services is document (pbDocumentStyle=True).

We recommend that you always create document style web-services as it is the more flexible and better defined SOAP style. Anything you can do with RPC style, you can do with Document style. You may wish to make a service RPC if your web-service client is old and therefore is not able to handle document style services.

Note:When pbDocumentStyle is to false (RPC) the web service cannot use struct, array or XmlHandle data types.

Note:Do not confuse the SOAP terms document and RPC with the conceptual terms document and RPC (remote procedure call). Although most web-services are accessed as remote procedures you can use the Document style to access these remote procedures. The RPC SOAP Style is an older style than Document Style. Both styles can be used to access remote procedures.

Last Edited: February 2, 2005


cWebService [Property psDescription]

psDescription - cWebService

Provides a short description of a web-service

Type: Property

Access: Read/Write

Data Type: String

Description

psDescription provides a short decsription of a web-service. This description is private in that it is not exported to the web-service's service description (WSDL). Use the psDocumentation method to create a service description that is added to the WSDL.

Last Edited: March 24, 2004


cWebService [Property psDocumentation]

psDocumentation - cWebService

Provides documentation for a Web-service that is added to the WSDL document

Type: Property

Access: Read/Write

Data Type: String

Description

psDocumentation is used create a string that documents your web service. The documentation will appear in your web-service's description (WSDL) and will therefore be seen by clients using this service. Every web-service should contain documentation.

Because psDocumenation may be long, this property is not exposed in the Studio's Property panel. Instead the code appears directly in your WSO and is coded in a format that makes it easy to create a long string (i.e., easy to create complete documentation). When a WSO object is created within the studio, the following text will appear inside the object.

//------------------------------------------------------------------------------------
// psDocumentation provides high level documentation of your web service. Clients using
// this service will see and use this documentation.
//------------------------------------------------------------------------------------
Set psDocumentation to ;
    ("Visual DataFlex Web Service .... " +;
      " ... " +  ;
      "documentation")

This code is formatted in this way to demonstrate how a long string can be created over multiple lines. This is done by breaking the string into multi-line parts and using the "+;" to connect these parts over multiple lines. For example, you may wish set this property as follows:

//------------------------------------------------------------------------------------
// psDocumentation provides high level documentation of your web service. Clients using
// this service will see and use this documentation.
//------------------------------------------------------------------------------------
Set psDocumentation to ;
    ("This service tracks the order status for the XYZ company. Serveral different operations are provided " +;
     "which allow you pass in your customer ID and an order number. Depending on the operation you will " +  ;
     "be returned an order shipping date, shipping method or order total. You must be a customer with a " +;
     "valid ID to use this service. If you do not know your ID, call us at 1-800-555-12345" )

Of course, you can also create a simple single line of documentation:

Set psDocumentation to "This does stuff"

Last Edited: March 24, 2004


cWebService [Property psServiceName]

psServiceName - cWebService

Determines the service name

Type: Property

Access: Read/Write

Data Type: String

Description

The psServiceName property determines the name of your service. This name uniquely identifies the service within your application and is used by clients to access the service.

For example, if the name of your service was "HelloService" in an application whose virtual directory was http://localhost/MyApplication the service would be accessed with the URL http://localhost/MyApplication/HelloService.wso. The name is set with the psServiceName property in the Studio's property page. The default name is tempService, which you will want to change this.

The psServiceName also determins the WSDL's service name. This name is usually used by web-service clients to provide a class name for the service. For example, when Visual DataFlex creates a client web-service class based on a WSDL it will thake this service name and create a class name by adding the prefix "cWS" so that "HelloService" will become "cWSHelloService".

Important: You must remember to set this property. If you do not, the name will remain TempService. If you create multiple web-service objects in an application all of your services will have the same name. When this happens you will only be able to access one service.

Last Edited: April 7, 2004


cWebService [Property psServiceTitle]

psServiceTitle - cWebService

Provides a Title for your web-service

Type: Property

Access: Read/Write

Data Type: String

Description

psServiceTitle provides a title for you web-service. It is currently not used by the service desctiption (WSDL). There is little need to change this property value.

Last Edited: March 24, 2004


cWebService [Property psServiceURI]

psServiceURI - cWebService

Determines the TargetNamespace URI for your web-service

Type: Property

Access: Read/Write

Data Type: String

Description

A web service must define a TargetNamespace URI. This is supposed to be a unique identifier that keeps all parts of your web-service unique. This URI can be named whatever you want but most often this Namespace consists of your company's web address suffixed with additonal information to keep your various web-services unique. e.g. http://www.dataaccess.com/Test/CustomerList

Note that the psServiceURI does not have to point to an actual web-address, it is just supposed to be a unqiue name.

The default setting for this is http://tempuri.org/. This name will work fine for testing but it is strongly suggested that you change this before you actually publish a web-service.

Last Edited: February 17, 2005


cWinControl [Event OnMouseDoubleClick]

OnMouseDoubleClick - cWinControl

Received whenever a mouse button is double-clicked on the control

Type: Event

Parameters: Integer eButton Integer x Integer y Integer fKeys

Parameter | Description
eButtonthe mouse button that was pressed. It will be one of the following constants:

Constant | Meaning
mbLeft | the left mouse button
mbMiddle | the middle mouse button
mbRight | the right mouse button
mbX1 | the X1 button (Windows 2000 specific)
mbX2 | the X2 button (Windows 2000 specific)

x | Specifies the x-coordinate of the cursor. The coordinate is relative to the upper-left corner of the client area.
y | Specifies the y-coordinate of the cursor. The coordinate is relative to the upper-left corner of the client area.
fKeysthe keys that were pressed when the mouse button was pressed. It will be one or more of the following constants:

Constant | Meaning
mkLeft | the left mouse button
mkMiddle | the middle mouse button
mkRight | the right mouse button
mkX1 | the X1 mouse button
mkX2 | the X2 mouse button
mkShift | the Shift key
mkControl | the Control key

Description

Whenever a user double-clicks on a control, it will recieve an OnMouseDoubleClickevent.

Note:Mouse messages are sent to the window beneath the cursor, unless it is captured, in which case the captured window will receive the mouse messages.

This sample shows how to extract the information from the eButton and fKeys parameters:

Procedure OnMouseDoubleClick Integer eButton Integer x Integer y Integer fKeys
    Integer bShiftKey bControlKey bLeftButton bRightButton
    String sButton

    Move (IsFlagIn(mkShift, fKeys))   To bShiftKey
    Move (IsFlagIn(mkControl, fKeys)) To bControlKey
    Move (IsFlagIn(mkLeft, fKeys))    To bLeftButton
    Move (IsFlagIn(mkRight, fKeys))   To bRightButton

    If (eButton = mbLeft) Move 'Left Button' To sButton
    If (eButton = mbRight) Move 'Right Button' To sButton

    Showln 'OnMouseDoubleClick ' sButton ' ' x ' ' y ;
      'shift=' bShiftKey ' ctrl=' bControlKey ;
      'left=' bLeftButton ' right=' bRightButton
End_Procedure

See Also

Mouse_Click | OnMouseDown | OnMouseMove | OnMouseUp

Last Edited: September 10, 2003


cWinControl [Event OnMouseDown]

OnMouseDown - cWinControl

Received whenever a mouse button is pressed on the control

Type: Event

Parameters: Integer eButton Integer x Integer y Integer fKeys

Parameter | Description
eButtonthe mouse button that was pressed. It will be one of the following constants:

Constant | Meaning
mbLeft | the left mouse button
mbMiddle | the middle mouse button
mbRight | the right mouse button
mbX1 | the X1 button (Windows 2000 specific)
mbX2 | the X2 button (Windows 2000 specific)

x | Specifies the x-coordinate of the cursor. The coordinate is relative to the upper-left corner of the client area.
y | Specifies the y-coordinate of the cursor. The coordinate is relative to the upper-left corner of the client area.
fKeysthe keys that were pressed when the mouse button was pressed. It will be one or more of the following constants:

Constant | Meaning
mkLeft | the left mouse button
mkMiddle | the middle mouse button
mkRight | the right mouse button
mkX1 | the X1 mouse button
mkX2 | the X2 mouse button
mkShift | the Shift key
mkControl | the Control key

Description

Whenever a user clicks on a control, it will recieve an OnMouseDown event.

Note:Mouse messages are sent to the window beneath the cursor, unless it is captured, in which case the captured window will receive the mouse messages.

This sample shows how to extract the information from the eButton and fKeys parameters:

Procedure OnMouseDown Integer eButton Integer x Integer y Integer fKeys
    Integer bShiftKey bControlKey bLeftButton bRightButton
    String sButton

    Move (IsFlagIn(mkShift, fKeys))   To bShiftKey
    Move (IsFlagIn(mkControl, fKeys)) To bControlKey
    Move (IsFlagIn(mkLeft, fKeys))    To bLeftButton
    Move (IsFlagIn(mkRight, fKeys))   To bRightButton

    If (eButton = mbLeft) Move 'Left Button' To sButton
    If (eButton = mbRight) Move 'Right Button' To sButton

    Showln 'OnMouseDown ' sButton ' ' x ' ' y ;
      'shift=' bShiftKey ' ctrl=' bControlKey ;
      'left=' bLeftButton ' right=' bRightButton
End_Procedure

See Also

OnMouseDoubleClick | OnMouseMove | OnMouseUp

Last Edited: September 10, 2003


cWinControl [Event OnMouseMove]

OnMouseMove - cWinControl

Received whenever the mouse cursor moves over a control

Type: Event

Parameters: Integer x Integer y Integer fKeys

Parameter | Description
x | Specifies the x-coordinate of the cursor. The coordinate is relative to the upper-left corner of the client area.
y | Specifies the y-coordinate of the cursor. The coordinate is relative to the upper-left corner of the client area.
fKeysthe keys that were pressed when the mouse button was pressed. It will be one or more of the following constants:

Constant | Meaning
mkLeft | the left mouse button
mkMiddle | the middle mouse button
mkRight | the right mouse button
mkX1 | the X1 mouse button
mkX2 | the X2 mouse button
mkShift | the Shift key
mkControl | the Control key

Description

Whenever a user moves the mouse cursor over the client-area of a control, it will recieve an OnMouseMove event.

Note:Mouse messages are sent to the window beneath the cursor, unless it is captured, in which case the captured window will receive the mouse messages.

This sample shows how to extract the information from the eButton and fKeys parameters:

Procedure OnMouseMove Integer x Integer y Integer fKeys
    Integer bShiftKey bControlKey bLeftButton bRightButton

    Move (IsFlagIn(mkShift, fKeys))   To bShiftKey
    Move (IsFlagIn(mkControl, fKeys)) To bControlKey
    Move (IsFlagIn(mkLeft, fKeys))    To bLeftButton
    Move (IsFlagIn(mkRight, fKeys))   To bRightButton

    Showln 'OnMouseMove ' x ' ' y ;
      'shift=' bShiftKey ' ctrl=' bControlKey ;
      'left=' bLeftButton ' right=' bRightButton
End_Procedure

See Also

OnMouseDoubleClick | OnMouseDown | OnMouseUp

Last Edited: September 10, 2003


cWinControl [Event OnMouseUp]

OnMouseUp - cWinControl

Received whenever a mouse button is released on the control

Type: Event

Parameters: Integer eButton Integer x Integer y Integer fKeys

Parameter | Description
eButtonthe mouse button that was pressed. It will be one of the following constants:

Constant | Meaning
mbLeft | the left mouse button
mbMiddle | the middle mouse button
mbRight | the right mouse button
mbX1 | the X1 button (Windows 2000 specific)
mbX2 | the X2 button (Windows 2000 specific)

x | Specifies the x-coordinate of the cursor. The coordinate is relative to the upper-left corner of the client area.
y | Specifies the y-coordinate of the cursor. The coordinate is relative to the upper-left corner of the client area.
fKeysthe keys that were pressed when the mouse button was pressed. It will be one or more of the following constants:

Constant | Meaning
mkLeft | the left mouse button
mkMiddle | the middle mouse button
mkRight | the right mouse button
mkX1 | the X1 mouse button
mkX2 | the X2 mouse button
mkShift | the Shift key
mkControl | the Control key

Description

Whenever a user releases a mouse button, it will recieve an OnMouseUp event.

Note:Mouse messages are sent to the window beneath the cursor, unless it is captured, in which case the captured window will receive the mouse messages.

This sample shows how to extract the information from the eButton and fKeys parameters:

Procedure OnMouseUp Integer eButton Integer x Integer y Integer fKeys
    Integer bShiftKey bControlKey bLeftButton bRightButton
    String sButton

    Move (IsFlagIn(mkShift, fKeys))   To bShiftKey
    Move (IsFlagIn(mkControl, fKeys)) To bControlKey
    Move (IsFlagIn(mkLeft, fKeys))    To bLeftButton
    Move (IsFlagIn(mkRight, fKeys))   To bRightButton

    If (eButton = mbLeft) Move 'Left Button' To sButton
    If (eButton = mbRight) Move 'Right Button' To sButton

    Showln 'OnMouseUp ' sButton ' ' x ' ' y ;
      'shift=' bShiftKey ' ctrl=' bControlKey ;
      'left=' bLeftButton ' right=' bRightButton
End_Procedure

See Also

OnMouseDoubleClick | OnMouseMove | OnMouseDown

Last Edited: September 10, 2003


Events for cWinControl

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnMouseDoubleClick | Received whenever a mouse button is double-clicked on the control |
OnMouseDown | Received whenever a mouse button is pressed on the control |
OnMouseMove | Received whenever the mouse cursor moves over a control |
OnMouseUp | Received whenever a mouse button is released on the control |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for cWinControl

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoRecreateWindow | Procedure | Recreates a window |
DoUpdateWindow | Procedure | Updates a window if it needs repainting |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


cWinControl [Procedure DoRecreateWindow]

DoRecreateWindow - cWinControl

Recreates a window

Type: Procedure

Parameters: No Parameters

Description

Send the DoRecreateWindow message to destroy the window and build it again. This is an advanced procedure and you should only need to send this when you have changed window-styles that Windows requires to rebuild the control for. For example, if you were to build a Windows' progressbar, you cannot dynamically change the way the bar is drawn between smooth and segmented. So, you would need to change the window-style and send this method.

Last Edited: July 31, 2003


cWinControl [Procedure DoUpdateWindow]

DoUpdateWindow - cWinControl

Updates a window if it needs repainting

Type: Procedure

Parameters: No Parameters

Description

Send the DoUpdateWindow message when you want Windows to display the control immediately to reflect any visual changes made since the last time the controls was displayed.

Note:For performance reasons, Windows only updates controls when it is idle (that is, not processing user-messages). However, there are times--during tight loops, for example--when you would want the control to display the changes that you are making. In these circumstances, send the DoUpdateWindow message and Windows will repaint the control immediately.

Last Edited: August 5, 2003


Properties for cWinControl

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbEnabled | Enables the control to take user input |
pbVisible | Makes a control visible or invisible |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


cWinControl [Property pbEnabled]

pbEnabled - cWinControl

Enables the control to take user input

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set the pbEnabled property to True to enable the control to accept user input. The visual result of setting the pbEnabled to False varies from control to control. In some cases, for example the button, the text will be grayed, but in others, there will be no difference.

Last Edited: September 10, 2003


cWinControl [Property pbVisible]

pbVisible - cWinControl

Makes a control visible or invisible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set pbVisible to False to hide a control (that is, make it invisible), or True to make it visible

See Also

Visible_State

Last Edited: September 10, 2003


Events for cWinReport2

View event list in hierarchical order

Name | Description | Defining Class
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property | Report
Body | Called once for every record selected for the report to provide processing for record data (if any) not used for subheaders and subtotals | Report
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Ending_Main_Report | Augmented to print/preview the report if AutoOutput_State is set to true | BasicReport
Ending_Report | This handler is called at the end of every report | Report
Error_Report | Sent whenever an error is generated | BasicReport
Final_Formfeed |  | Report
OnConstrain |  | Report
onError | Provided as a hook to handle custom error reporting | BasicReport
Page_Bottom | The last thing printed on every page | Report
Page_Footer | Printed after page_total on every page except the last page | Report
Page_Header | Called after page_top on every new page except the first | Report
Page_Title | Called on every new page after report_header or page_header | Report
Page_Top | Called first at the top of each new page | Report
Page_Total | Called on every new page and is printed as the first part of a page break at the bottom of each page | Report
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found | Report
Report_Footer | Printed after page_total on the last page of the report | Report
Report_Header | Called only on the first page of the report, after page_top | Report
Report_Interrupt | Called when the status panel's Cancel button has been pressed | BasicReport
Selection | Validates a record | Report
Starting_Main_Report | Called only if the current report is an outer report | BasicReport
Starting_Report | Called at the start of every report | Report
SubHeader_Init1..n | Called for every break level (n) for which you define a SubHeader_init1..n procedure section in your program | Report
SubHeader1..n | Called for every break level (n) for which you define a subHeader procedure section in your program | Report
SubTotal1..n | Called for every break level (n) for which you define a subTotal procedure section in your program | Report
Total | Called once at the end of a report after the final subtotals are output | Report


cWinReport2 [Function ArePrintersInstalled]

ArePrintersInstalled - cWinReport2

Returns true if printers are installed

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns true if printers are installed

Description

Returns true if printers are installed. A least one printer must be installed before a winprint report can be run. The report object checks for this condition and reports an error if no printers are installed. This message is provided to allow developers further custom control over this process.

Last Edited: December 21, 2004


cWinReport2 [Function DFGetCurrentDevice]

DFGetCurrentDevice - cWinReport2

Returns the name of the current print device

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Returns the full location/name of the current print device

Description

DFGetCurrentDevice returns the location and name of the current print device.

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFSetDevice

Last Edited: May 13, 2004


cWinReport2 [Function DFGetDFColor]

DFGetDFColor - cWinReport2

Converts individual R(ed), G(reen), B(lue) values into a WinPrint2 color value.

Type: Function

Return Data Type: Integer

Parameters: integer iRed integer iGreen integer iBlue

Parameter | Description
iRed | Red value
iGreen | Green value
iBlue | Blue value

Return Value

Returns a WinPrint2 RGB color value

Description

WinPrint2 provides a number of standard color constants that can be used in a report. Those constants are:

Regular colors | Dark colors
RGB_BLACK |
RGB_WHITE |
RGB_BLUE | RGB_DBLUE
RGB_CYAN | RGB_DCYAN
RGB_GREEN | RGB_DGREEN
RGB_GREY | RGB_DGREY
RGB_MAGENTA | RGB_DMAGENTA
RGB_RED | RGB_DRED
RGB_YELLOW | RGB_DYELLOW

With the DFGetDFColor function, you can create any color you desire for output. You pass separate values for Red, Green and Blue and a single WinPrint2 color value is returned.

Procedure SubHeader1
    integer iClr
    DFFont "Arial" //  Use Arial
    DFFontSize 8
    Get DFGetDFColor of winprintId  242 242 242 to iClr

    DFBeginHeader DFSubHeader 1 // customer sub-header
        DFHeaderFrame hdr_Margins 0.01 rgb_dGrey iClr
        DFHeaderPos   HDR_LEFT
        DFHeaderWrap HDR_WRAP
        DFHeaderLineCheck 10

        DFWritePos    "Customer Number"         0.10  (FONT_BOLD+RGB_DBLUE)
        DFWritelnPos  Customer.CUSTOMER_NUMBER    4.0
        DFWritePos    "Name"                    0.10  (FONT_BOLD+RGB_DBLUE)
        DFWritelnPos  Customer.NAME               4.0   (FONT_DEFAULT)
        DFWritePos    "Address"                 0.10  (FONT_BOLD+RGB_DBLUE)
        DFWritelnPos  Customer.ADDRESS            4.0   (FONT_DEFAULT)
        DFWritePos    "City"                    0.10  (FONT_BOLD+RGB_DBLUE)
        DFWritelnPos  Customer.CITY               4.0   (FONT_DEFAULT)
        DFWritePos    "State"                   0.10  (FONT_BOLD+RGB_DBLUE)
        DFWritelnPos  Customer.STATE              4.0   (FONT_DEFAULT)
        DFWritePos    "Zip"                     0.10  (FONT_BOLD+RGB_DBLUE)
        DFWritelnPos  Customer.ZIP                4.0   (FONT_DEFAULT)
    DFEndHeader
End_Procedure

You can also use the RGBToWPColor function to convert a standard RGB color to a WinPrint2 color.

See Also

RGBToWPColor

Last Edited: May 13, 2004


cWinReport2 [Function DFGetEnablePrintFromPreview]

DFGetEnablePrintFromPreview - cWinReport2

Determines is printing is allowed within the WinPrint2 report viewer

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns True if printing is allowed from the viewer, false if printing is not allowed

Description

DFGetEnablePrintFromPreview can be used to determine if printing is allowed from within the report viewer. When a report is started, the report object always enables printing from the viewer and, therefore, this function usually returns true. This capability may be disabled by sending the DFSetEnablePrintFromPreview.

When disabled, the print button in the viewer will appear as a disabled button.

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFSetEnablePrintFromPreview

Last Edited: May 17, 2004


cWinReport2 [Function DFGetLandscape]

DFGetLandscape - cWinReport2

Determines if a report page orientation should be Landscape or Portrait

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns True if output orientation is Landscape, false if portrait

Description

The DFGetLandscape function returns true if the report's orientation is landscape. You must specify a report's orientation before running a report. This can be done by the user using the printer set up dialog or this can be set by the developer using the DFSetLandscape message.

Function Starting_Main_Report Returns Integer
    Boolean bErr bLandscape
    Get DFGetLandscape to bLandscape
    If not bLandscape begin
        Error DFERR_OPERATOR "Report cannot be printed in portrait mode. Please change"
    end
    else begin
        Send DFSetMetrics wpm_cm
        Send DFSetmargins 1 1 1 1
        Forward Get Starting_Main_Report to bErr
    end
    Function_return bErr
End_Function // Starting_Main_Report

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFSetLandscape

Last Edited: May 13, 2004


cWinReport2 [Function DFGetMetrics]

DFGetMetrics - cWinReport2

Returns the metrics used by the report

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns metrics value of

Constant | Meaning
wpm_cm | centimeters
wpm_inch | inches

Description

DFGetMetrics returns the metrics, centimeters or inches, used by the report.

integer eMetrics
Get DFGetMetrics to eMetrics

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFSetMetrics

Last Edited: May 13, 2004


cWinReport2 [Function DFGetPrintDlgInPreview]

DFGetPrintDlgInPreview - cWinReport2

Determines if the print job dialog will appear when the viewer's print button is pressed

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns True if print job dialog will appear when the print button is pressed, false if the dialog is suppressed

Description

DFGetPrintDlgInPreview allows the developer to detemine if the print job dialog will appear when the print buttom is selected from the WinPrint2 viewer. When a report is started, the report object always enables the print job dialog. This capability may be disabled by sending the DFSetEnablePrintFromPreview message.

The Print Job dialog allows you to set a report's page range, number of copies, and collation. It is usually invoked after a report has been generated before printing. This dialog will appear from the report viewer unless the feature is disabled using the DFSetPrintDlgInPreview message. It can be invoked when printing manually using the DFPrint message which will invoke the dialog, print the report and then clear the report document. It can be invoked by itself with the DFPrintDialog message.

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFSetPrintDlgInPreview | | DFGetEnablePrintFromPreview | DFSetEnablePrintFromPreview | DFPrint | DFPrintDialog

Last Edited: May 17, 2004


cWinReport2 [Function DFGetPrinterBin]

DFGetPrinterBin - cWinReport2

Determines the bin source for a report

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns bin source for report

Description

DFGetPrinterBin returns the bin source used by the current report. It will return one of the following values:

DF_BIN_AUTO
DF_BIN_LOWER
DF_BIN_CASSETTE
DF_BIN_MANUAL
DF_BIN_ENVELOPE
DF_BIN_MIDDLE
DF_BIN_ENVMANUAL
DF_BIN_ONLYONE
DF_BIN_FIRST
DF_BIN_SMALLFMT
DF_BIN_LARGECAPACITY
DF_BIN_TRACTOR
DF_BIN_LARGEFMT
DF_BIN_UPPER
DF_BIN_LAST

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFSetPrinterBin

Last Edited: May 13, 2004


cWinReport2 [Function DFGetPrinterPaper]

DFGetPrinterPaper - cWinReport2

Determines the paper type/size used in a report

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns a paper type/size value

Description

DFGetPrinterPaper returns the paper size used in a report. It will be one of the following values.

DF_PAPER_LETTER
DF_PAPER_LETTERSMALL
DF_PAPER_TABLOID
DF_PAPER_LEDGER
DF_PAPER_LEGAL
DF_PAPER_STATEMENT
DF_PAPER_EXECUTIVE
DF_PAPER_A3
DF_PAPER_A4
DF_PAPER_A4SMALL
DF_PAPER_A5
DF_PAPER_B4
DF_PAPER_B5
DF_PAPER_FOLIO
DF_PAPER_QUARTO
DF_PAPER_10X14
DF_PAPER_11X17
DF_PAPER_NOTE
DF_PAPER_ENV_9
DF_PAPER_ENV_10
DF_PAPER_ENV_11
DF_PAPER_ENV_12
DF_PAPER_ENV_14
DF_PAPER_CSHEET
DF_PAPER_DSHEET
DF_PAPER_ESHEET
DF_PAPER_ENV_DL
DF_PAPER_ENV_C3
DF_PAPER_ENV_C4
DF_PAPER_ENV_C5
DF_PAPER_ENV_C6
DF_PAPER_ENV_C65
DF_PAPER_ENV_B4
DF_PAPER_ENV_B5
DF_PAPER_ENV_B6
DF_PAPER_ENV_ITALY
DF_PAPER_ENV_MONARCH
DF_PAPER_ENV_PERSONAL
DF_PAPER_FANFOLD_US
DF_PAPER_FANFOLD_STD_GERMAN
DF_PAPER_FANFOLD_LGL_GERMAN
DF_PAPER_LAST
DF_PAPER_USER

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

Last Edited: May 13, 2004


cWinReport2 [Function DFGetPrinterResolution]

DFGetPrinterResolution - cWinReport2

Determines the printer resolution used in a report

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns a printer resolution mode

Description

DFGetPrinterResolution returns the printer resolution used in a report. It will be one of the following resolution modes:

DF_RES_HIGH
DF_RES_MEDIUM
DF_RES_LOW
DF_RES_DRAFT

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFSetPrinterResolution

Last Edited: May 13, 2004


cWinReport2 [Function DFGetUserDefinedLength]

DFGetUserDefinedLength - cWinReport2

Returns the length for user defined paper

Type: Function

Return Data Type: Number

Parameters: No Parameters

Return Value

Returns the paper length in the current metrics

Description

DFGetUserDefinedLength returns the width of user defined paper.

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFGetUserDefinedWidth | DFSetUserDefinedPapersize

Last Edited: May 13, 2004


cWinReport2 [Function DFGetUserDefinedWidth]

DFGetUserDefinedWidth - cWinReport2

Returns the width for user defined paper

Type: Function

Return Data Type: Number

Parameters: No Parameters

Return Value

Returns the paper width in the current metrics

Description

DFGetUserDefinedWidth returns the width of user defined paper.

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFGetUserDefinedLength | DFSetUserDefinedPapersize

Last Edited: May 13, 2004


cWinReport2 [Function DFPrintSetupDialog]

DFPrintSetupDialog - cWinReport2

Invokes the the Printer Setup Dialog allowing the user to select a printer

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns True of the selection was OKed, False if the dialog was canceled

Description

DFPrintSetupDialog invokes the printer setup dialog. The dialog allows you to select a printer and printer characteristics such as paper size, paper bin, report orientation, etc.

Object oSetupButton is a Button
    Set Label to "Printer Setup"
    Set Location to 7 120

    Procedure OnClick
        Boolean bOk
        Get DFPrintSetupDialog of oOrders to bOk
    End_Procedure

End_Object    // oSetupButton

The return value indicates if the dialog page is OKed (True) or canceled (False). This can be useful if you are printing directly to the printer and you need to invoke the print setup dialog before the report is run. In such a case, canceling the dialog should cancel the report job.

Object oPrintButton is a Button
    Set Label to "Print to Printer"
    Set Location to 7 120

    Procedure OnClick
        Boolean bOk
        Get DFPrintSetupDialog of oOrders to bOk // if bOk=false, cancel
        If bOk begin
            Send DFPrintDoc // print directly to the printer
        end
    End_Procedure

End_Object    // oSetupButton

The printer must be setup before the report is run. If you attempt to invoke the print dialog while a report is active, either the dialog must be ignored or the report must be cleared. If the dialog is invoked while the report viewer is active, an error will be declared. If the dialog is invoked when the report is completed but the viewer is not active (this should be rare), the current report is cleared and the dialog is presented. You can always manually clear a report before invoking the printer setup dialog by sending the DfClearDoc message.

Object oSetupButton is a Button
    Set Label to "Printer Setup"
    Set Location to 7 120

    Procedure OnClick
        Boolean bOk
        // make sure we are always allowed to use the dialog
        Send DFClearDoc of oOrdersReport
        Get DFPrintSetupDialog of oOrdersReportto bOk
    End_Procedure

End_Object    // oSetupButton

See Also

DfClearDoc | IsViewerActive | DocumentStatus

Last Edited: August 10, 2006


cWinReport2 [Function DocumentStatus]

DocumentStatus - cWinReport2

Returns the status of a report

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns the report's status

Description

DocumentStatus returns the current state of a report and will be one of the following:

Constant | Meaning
dsNotStarted | The document is cleared or has never been started.
dsStarted | The document has been created, but is not finished. The report is still in progress.
dsFinished | The document is completed, and is currently valid for viewing or printing.

This function along with the IsViewerActive function can be used to determine the exact state of a WinPrint2 report. Note that these modes may not be reporting the value of the report returning the message. It returns that state of the global WinPrint2 object.

Note that this reports the status of the global WinPrint2 object (the report engine) and not the status of any individual report object. Since only one report can be in progress (dsStarted or dsFinished) at one time, it is reporting the status of the current or last report run.

Last Edited: May 13, 2004


cWinReport2 [Function IsViewerActive]

IsViewerActive - cWinReport2

Returns true of the Winprint2 viewer is actve

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Returns true, if report viewer is active

Description

The IsViewerActive function returns true if the WinPrint2 report is active (i.e., it is paged). This can be used to control the report viewer within a program.

// if report viewer is active clear the report (which will also close the viewer)
Get IsViewerActive of oReport to bActive
If bActive begin
    Send DFClearDoc of oReport
end

Note that an active viewer may not be showing a view of the current report. This viewer is global. If the viewer is active, any report in the application could have generated this report and any report will return True for this function.

See Also

DocumentStatus

Last Edited: May 13, 2004


cWinReport2 [Function RGBToWPColor]

RGBToWPColor - cWinReport2

Converts a standard RGB color to a Winprint RGB color value

Type: Function

Return Data Type: Integer

Parameters: integer iRgb

Parameter | Description
iRgb | Standard RGB color value

Return Value

Returns a WinPrint2 color value

Description

The RGB values used by WinPrint2 are different than the RGB color values used by the rest of Visual DataFlex (which uses standard RGB values). You can convert a standard RGB value to a WinPrint value by calling this function.

Procedure Page_Title
    integer iColor iForeColor

    Get RgbToWPColor clTeal  to iColor
    Get RgbToWPColor clOlive to iForeColor
    DFFont "Arial"
    DFFontSize 14
    DFBeginHeader DFPageTitle
        DFHeaderFrame HDR_MARGINs 0.01 iColor iColor
        DFHEADERPOS HDR_LEFT
        DFWritelnPos "Orders by Customer Report" 0.10 (FONT_BOLD+iForeColor)
    DFEndHeader
End_Procedure

The DFGetDFColor can be used to convert individual R(ed), G(reen), B(lue) values into a WinPrint2 color value.

The Visual DataFlex Constants are defined in rgb.pkg

See Also

DFGetDFColor

Last Edited: October 6, 2004


cWinReport2 [Function SubTotal]

SubTotal - cWinReport2

Returns the appropriate subtotal and clears the subtotal accumulator

Type: Function

Return Data Type: Number

Parameters: Integer iTotal

Parameter | Description
iTotal | the subtotal accumulator level

Return Value

Returns the appropriate subtotal and clears the subtotal accumulator

Description

The Subtotal function returns the value of the subtotal for the passed iTotal and zeroes the subtotal accumulator. The value for iTotal should be assigned by the developer. In a complex report, you may choose to name the iTotal values you wish to use with mnemonics that identify the columns or fields being subtotalled.

Procedure SubTotal1 // order total
    Number nAmount

    Get SubTotal 1 to nAmount
    Send Add_SubTotal 2 nAmount // subtotal 2 is customer total

    DFFont "Arial"
    DFFontSize 8
    DFBeginHeader DFSubTotal 1
        DFHEADERPOS HDR_LEFT
        DFHEADERFRAME HDR_Margins 0.01 rgb_dGrey rgb_Grey
        DFWritePos   "Order Total:"  12.00  (FONT_BOLD+RGB_DBLUE+FONT_RIGHT)
        DFWritelnPos nAmount         14.1   (FONT_RIGHT) 2
    DFEndHeader

End_Procedure

See Also

Add_SubTotal | Sum_SubTotal | Clr_SubTotal | Clr_AllSubtotals

Last Edited: May 11, 2004


cWinReport2 [Function Sum_SubTotal]

Sum_SubTotal - cWinReport2

Returns the value of the subtotal for the passed iTotal, but does not zero the subtotal accumulator

Type: Function

Return Data Type: Number

Parameters: Integer iTotal

Parameter | Description
iTotal | A developer defined subtotal index

Return Value

Returns the value of the subtotal for the passed iTotal

Description

The Sum_subtotal function returns the value of the subtotal for the passed iTotal, but does not zero the subtotal accumulator.The value for iTotal should be assigned by the developer. In a complex report, you may choose to name the iTotal values you wish to use with mnemonics that identify the columns or fields being subtotalled.

Procedure SubTotal1 // order total
    Number nAmount

    Get Sum_SubTotal 1 to nAmount // get total but do not clear it

    DFFont "Arial"
    DFFontSize 8
    DFBeginHeader DFSubTotal 1
        DFHEADERPOS HDR_LEFT
        DFHEADERFRAME HDR_Margins 0.01 rgb_dGrey rgb_Grey
        DFWritePos   "Running Total:"  12.00  (FONT_BOLD+RGB_DBLUE+FONT_RIGHT)
        DFWritelnPos nAmount         14.1   (FONT_RIGHT) 2
    DFEndHeader

End_Procedure

Normally you will use the SubTotal message to get sub-totals. It returns the sub-total and clears the subtotal accumulator

See Also

SubTotal | Add_SubTotal | Clr_SubTotal | Clr_AllSubtotals

Last Edited: May 11, 2004


Methods for cWinReport2

View method list in hierarchical order

Name | Type | Description | Defining Class
Add_SubTotal | Procedure | Adds the value of nData to the subtotal for the passed iCounter |
ArePrintersInstalled | Function | Returns true if printers are installed |
Clr_AllSubTotals | Procedure | Zeroes all the subtotal accumulators for the report |
Clr_SubTotal | Procedure | Zeroes the subtotal accumulator for the passed iCounter |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DfClearDoc | Procedure | DFClearDoc clears the generated report |
DFClearPrinter | Procedure | Clears the printer data channel and the printer settings |
DfClosePreview | Procedure | Closes the report viewer |
DfEndDocument | Procedure | Specifies that a report is complete |
DFGetCurrentDevice | Function | Returns the name of the current print device |
DFGetDFColor | Function | Converts individual R(ed), G(reen), B(lue) values into a WinPrint2 color value. |
DFGetEnablePrintFromPreview | Function | Determines is printing is allowed within the WinPrint2 report viewer |
DFGetLandscape | Function | Determines if a report page orientation should be Landscape or Portrait |
DFGetMetrics | Function | Returns the metrics used by the report |
DFGetPrintDlgInPreview | Function | Determines if the print job dialog will appear when the viewer's print button is pressed |
DFGetPrinterBin | Function | Determines the bin source for a report |
DFGetPrinterPaper | Function | Determines the paper type/size used in a report |
DFGetPrinterResolution | Function | Determines the printer resolution used in a report |
DFGetUserDefinedLength | Function | Returns the length for user defined paper |
DFGetUserDefinedWidth | Function | Returns the width for user defined paper |
DFNew_Page | Procedure | Outputs a new page |
DFPreview | Procedure | Opens the printer viewer |
DFPreviewNoWait | Procedure | Opens the printer viewer as a modeless viewer |
DFPreviewWait | Procedure | Opens the printer viewer as a modal viewer |
DFPrint | Procedure | Invokes the printer job dialog and prints the document using current settings in the print setup |
DFPrintDialog | Procedure | Invokes the WinPrint2 Print Job Dialog |
DFPrintDoc | Procedure | Prints the document without invoking the Print Job Dialog |
DFPrinterBinFirstPage | Procedure | Allows you to set a different printer bin for report's first page |
DFPrintSetup | Procedure | (Obsolete) |
DFPrintSetupDialog | Function | Invokes the the Printer Setup Dialog allowing the user to select a printer |
DFSetDevice | Procedure | Sets the location and name of the print device |
DFSetEnablePrintFromPreview | Procedure | Determines if WinPrint2 viewer allows printing |
DFSetLandscape | Procedure | Sets a report's orientation to Landscape or Portrait |
DFSetMargins | Procedure | Sets Left, Top, Right and Bottom Margins for a report |
DFSetMetrics | Procedure | Sets a report's metrics to centimeters or Inches |
DFSetNumberOfCopies | Procedure | Sets the number of copies to printed |
DFSetPrintDlgInPreview | Procedure | Determines if the print job dialog will appear when printing is selected from the WinPrint2 viewer |
DFSetPrinterBin | Procedure | Sets the printer bin to be used in a report |
DFSetPrinterPaper | Procedure | Sets the paper type/size for a report |
DFSetPrinterResolution | Procedure | Sets the printer resolution used in a report |
DFSetTopBottom | Procedure | Sets the top and bottom margins used by the Page_Top and Page_Bottom sections |
DFSetUserDefinedPapersize | Procedure | Sets the length and width of a user defined papersize |
DocumentStatus | Function | Returns the status of a report |
End_Log | Procedure | Sends an end-log message to the log object | BasicReport
EndMultiReport | Procedure | Ends a linked multi-report |
Error_Log_Status | Procedure | Called by error_report if status_log_state is true | BasicReport
Exit_Application | Procedure | Starts the process of closing an application | cObject
Formfeed | Procedure | Handles formfeeds | Report
IsViewerActive | Function | Returns true of the Winprint2 viewer is actve |
Log_Status | Procedure | Sends passed message to the log object | BasicReport
Output_ImageNum | Procedure | Outputs the image represented by ImageNum | Report
PrintReport | Procedure | Outputs the current report to printer or viewer based on output_device_mode |
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO | Report_DS
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Save | Procedure | If sent, this saves the current record | Report_DS
RGBToWPColor | Function | Converts a standard RGB color to a Winprint RGB color value |
Run_Report | Procedure | Sends a message to the report object telling it to start the report with internal finding | Report
ShowRuler | Procedure | Displays a ruler in the report |
Start_Log | Procedure | Sends a start-log message to the log object | BasicReport
Start_Report | Function | Augmented to check the server property and if the property is non-zero (and a DSO exists), to establish a client-server link between the report object and the DSO | Report
SubTotal | Function | Returns the appropriate subtotal and clears the subtotal accumulator |
Sum_SubTotal | Function | Returns the value of the subtotal for the passed iTotal, but does not zero the subtotal accumulator |
Update_Status | Procedure | Updates a report's status in the report viewer |
WriteLn | Procedure | Outputs the string message to the current output channel | Report
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data | Report


cWinReport2 [Procedure Add_SubTotal]

Add_SubTotal - cWinReport2

Adds the value of nData to the subtotal for the passed iCounter

Type: Procedure

Parameters: Integer iCounter Number nData

Parameter | Description
iCounter | A developer defined subtotal index
nData | The value to be added to the subtotal

Description

The Add_subtotal procedure adds the value of nData to the subtotal for the passed iCounter. The value for iCounter should be assigned by the developer. In a complex report, you may choose to name the iCounter values you wish to use with mnemonics that identify the columns or fields being subtotalled.

Procedure Body // order detail body

    DFFont "Arial"
    DFFontSize 8

    DFWritePos    Invt.ITEM_ID                0.1     (FONT_DEFAULT)            -1 2.24
    DFWritePos    Invt.DESCRIPTION            2.36    (FONT_DEFAULT)            -1 4.77
    DFWritePos    Orderdtl.QTY_ORDERED        9.5     (FONT_DEFAULT+FONT_RIGHT)  0 1.87
    DFWritePos    Orderdtl.PRICE              11.22   (FONT_DEFAULT+FONT_RIGHT)  2 1.22
    DFWritePos    Orderdtl.EXTENDED_PRICE     14.1    (FONT_DEFAULT+FONT_RIGHT)  2 2.38
    DFWriteln

    Send Add_SubTotal 1 (Orderdtl.EXTENDED_PRICE) // sub-total1 is order total

End_Procedure

Procedure SubTotal1 // order total
    Number nAmount

    Get SubTotal 1 to nAmount
    Send Add_SubTotal 2 nAmount // subtotal 2 is customer total

    DFFont "Arial"
    DFFontSize 8
    DFBeginHeader DFSubTotal 1
        DFHEADERPOS HDR_LEFT
        DFHEADERFRAME HDR_Margins 0.01 rgb_dGrey rgb_Grey
        DFWritePos   "Order Total:"  12.00  (FONT_BOLD+RGB_DBLUE+FONT_RIGHT)
        DFWritelnPos nAmount         14.1   (FONT_RIGHT) 2
    DFEndHeader

End_Procedure

See Also

SubTotal | | Sum_SubTotal | Clr_SubTotal | Clr_AllSubtotals

Last Edited: May 11, 2004


cWinReport2 [Procedure Clr_AllSubTotals]

Clr_AllSubTotals - cWinReport2

Zeroes all the subtotal accumulators for the report

Type: Procedure

Parameters: No Parameters

Description

The Clr_AllSubtotals procedure zeroes all the subtotal accumulators for the report.

Every time a new report is started, this message is sent to clear all totals. You should rarely need to send this message manually.

See Also

SubTotal | Sum_SubTotal | Add_SubTotal | Clr_Subtotal

Last Edited: May 11, 2004


cWinReport2 [Procedure Clr_SubTotal]

Clr_SubTotal - cWinReport2

Zeroes the subtotal accumulator for the passed iCounter

Type: Procedure

Parameters: Integer iCounter

Parameter | Description
iCounter | A developer defined subtotal index

Description

The Clr_subtotal procedure zeroes the subtotal accumulator for the passed iCounter. The value for iCounter should be assigned by the developer. In a complex report, you may choose to name the iCounter values you wish to use with mnemonics that identify the columns or fields being subtotalled.

Procedure SubTotal1 // order total
    Number nAmount

    Get Sum_SubTotal 1 to nAmount // get total but do not clear it
    Send Clr_SubTotal 1 // clear the accumulator

    DFFont "Arial"
    DFFontSize 8
    DFBeginHeader DFSubTotal 1
        DFHEADERPOS HDR_LEFT
        DFHEADERFRAME HDR_Margins 0.01 rgb_dGrey rgb_Grey
        DFWritePos   "Running Total:"  12.00  (FONT_BOLD+RGB_DBLUE+FONT_RIGHT)
        DFWritelnPos nAmount         14.1   (FONT_RIGHT) 2
    DFEndHeader

End_Procedure

Note that the above example could have used SubTotal to return the total and zero the accumulator in a single step.

See Also

SubTotal | Sum_SubTotal | Add_SubTotal | Clr_AllSubtotals

Last Edited: May 11, 2004


cWinReport2 [Procedure DfClearDoc]

DfClearDoc - cWinReport2

DFClearDoc clears the generated report

Type: Procedure

Parameters: No Parameters

Description

DFClearDoc clears the generated report document in memory, but leaves the printer settings unchanged. If the report viewer is active it will be closed.

DFClearDoc is always sent before a new report is generated. It is also sent when you close a ReportView object. If you are done with a report, you may wish to send this message to free resources on your computer.

Last Edited: May 12, 2004


cWinReport2 [Procedure DFClearPrinter]

DFClearPrinter - cWinReport2

Clears the printer data channel and the printer settings

Type: Procedure

Parameters: No Parameters

Description

DFClearPrinter will clear the printer data channel and the printer settings. The printer will be set to the default printer in your system.

Last Edited: May 12, 2004


cWinReport2 [Procedure DfClosePreview]

DfClosePreview - cWinReport2

Closes the report viewer

Type: Procedure

Parameters: No Parameters

Description

DfClosePreview closes the report viewer. It does not clear the report document (use DfClearDoc for that). The report viewer can be re-opened using the DfPreview message.

You can determine if a report viewer is active by checking the IsViewerActive message.

See Also

DfClearDoc | DfPreview | IsViewerActive

Last Edited: May 12, 2004


cWinReport2 [Procedure DfEndDocument]

DfEndDocument - cWinReport2

Specifies that a report is complete

Type: Procedure

Parameters: No Parameters

Description

DfEndDocument changes a report's mode from started (dsStarted) to finished (dsFinished). Typically the report object handles this change of mode for you and should not send the message yourself.

Last Edited: May 12, 2004


cWinReport2 [Procedure DFNew_Page]

DFNew_Page - cWinReport2

Outputs a new page

Type: Procedure

Parameters: Integer Cols

Parameter | Description
Cols | Not used in Winprint2 (The number of columns for the page (optional))

Description

The DFNew_page procedure creates a new page. When a new page is printed, page headers or footers will be printed automatically. If you have set DFSubHeaders or DFSubTotals to wrap (reprint), they will also be printed on the new page. Normally SubHeaders are set to wrap and SubTotals are set to no wrap.

Procedure SubTotal1 // customer total
    number nAmount
    integer iClr
    Boolean bBreak

    get SubTotal 2 to nAmount
    send Add_SubTotal 3 nAmount // subtotal 3 is total of all

    //Get DFGetDFColor of winprintId  242 242 242 to iClr // doesn't work YET
    Move -218959360 to iClr

    DFFont "Arial" //  Use Arial
    DFFontSize 8
    DFBeginHeader DFSubTotal 1
        DFHEADERPOS HDR_LEFT
        DFHeaderFrame HDR_Margins 0.01 RGB_DGREY iClr
        DFHeaderMargin HM_BottomOuter 0.16

        DFWritePos   "Customer Total:"  12.00 (FONT_BOLD+RGB_DBLUE+FONT_RIGHT)
        DFWritelnPos nAmount 14.1              (FONT_RIGHT+FONT_Bold) 2 0
    DFEndHeader
    Get pbOnePagePerCust to bBreak
    if bBreak begin
        send DFNew_Page
    end
End_Procedure

Note:The columns is provided for backwards compatibility with WinPrint1. It is not used in Winprint2 and should be omitted.

Last Edited: August 12, 2005


cWinReport2 [Procedure DFPreview]

DFPreview - cWinReport2

Opens the printer viewer

Type: Procedure

Parameters: No Parameters

Description

DFPreview opens the printer viewer with your document. You can use this to re-open the report viewer if it has been closed. Normally, the report object handles all of this for you and you should never need to send this message. Setting the object's output_device_mode to PRINT_TO_WINDOW will cause the report viewer to be available as your report is generated.

Last Edited: May 12, 2004


cWinReport2 [Procedure DFPreviewNoWait]

DFPreviewNoWait - cWinReport2

Opens the printer viewer as a modeless viewer

Type: Procedure

Parameters: No Parameters

Description

DFPreviewNoWait opens the printer viewer with your document. You can use this to re-open the report viewer if it has been closed. Normally, the report object handles all of this for you and you should never need to send this message. Setting the object's output_device_mode to PRINT_TO_WINDOW will cause the report viewer to be available as your report is generated.

Last Edited: May 12, 2004


cWinReport2 [Procedure DFPreviewWait]

DFPreviewWait - cWinReport2

Opens the printer viewer as a modal viewer

Type: Procedure

Parameters: No Parameters

Description

DFPreviewWait opens the printer viewer with your document. It opens this as a modal viewer which provides a less flexible way of viewing a report.

You can use DFPreview and DFPreviewNoWait to use the viewer in a modeless state.

See Also

DFPreview | DFPreviewNoWait

Last Edited: May 12, 2004


cWinReport2 [Procedure DFPrint]

DFPrint - cWinReport2

Invokes the printer job dialog and prints the document using current settings in the print setup

Type: Procedure

Parameters: No Parameters

Description

DFPrint invokes the print job dialog, prints the current generated report, and then clears the report document This should be sent after a report is completed.

These two samples do the same thing.

Procedure PrintGeneratedReport
    Integer bOk
    Get DFPrintDialog To bOk
    If bOk Begin
        Send DFPrintDoc
        Send DFClearDoc
    End
End_Procedure

Procedure PrintGeneratedReport
    Send DFPrint
End_Procedure

When using the report object, you will usually not need to write this kind of code. The report object's output_device_mode handles report output. If it is set to PRINT_TO_PRINTER, the print job dialog will be presented when the report is generated and ready to be printed. If the mode is PRINT_TO_PRINTER_NO_DIALOG, the Print Job Dialog is suppressed.

If the report is generated to the viewer (output_device mode is PRINT_TO_WINDOW or DEFERRED_PRINT_TO_WINDOW), the Print Job Dialog will be invoked when you select the viewer's print button.

The Print Job Dialog can be invoked directly using the DFPrintDialog message.

You can print a report without invoking the print job dialog be sending the DFPrintDoc message.

See Also

output_device_mode | DFPrintDoc | DFPrintDialog | DFClearDoc

Last Edited: May 18, 2004


cWinReport2 [Procedure DFPrintDialog]

DFPrintDialog - cWinReport2

Invokes the WinPrint2 Print Job Dialog

Type: Procedure

Parameters: No Parameters

Description

DFPrintDialog invokes the the Print Job Dialog. The Print Job dialog allows you to set a report's page range, number of copies, and collation. It is usually invoked after a report has been generated before printing. It can be invoked manually by with the DFPrintDialog message. It is also invoked using the DFPrint message which will invoke the dialog, print the report and then clear the report document.

These two samples do the same thing.

Procedure PrintGeneratedReport
    Integer bOk
    Get DFPrintDialog To bOk
    If bOk Begin
        Send DFPrintDoc
        Send DFClearDoc
    End
End_Procedure

Procedure PrintGeneratedReport
    Send DFPrint
End_Procedure

When using the report object, you will usually not need to write this kind of code. The report object's output_device_mode handles report output. If it is set to PRINT_TO_PRINTER, the print job dialog will be presented when the report is generated and ready to be printed. If the mode is PRINT_TO_PRINTER_NO_DIALOG, the Print Job Dialog is suppressed.

If the report is generated to the viewer (output_device mode is PRINT_TO_WINDOW or DEFERRED_PRINT_TO_WINDOW), the Print Job Dialog will be invoked when you select the viewer's print button.

See Also

output_device_mode | DFPrint | DFSetPrintDlgInPreview | DFSetPrintDlgInPreview | DFGetEnablePrintFromPreview | DFSetEnablePrintFromPreview

Last Edited: May 18, 2004


cWinReport2 [Procedure DFPrintDoc]

DFPrintDoc - cWinReport2

Prints the document without invoking the Print Job Dialog

Type: Procedure

Parameters: No Parameters

Description

DFPrintDoc prints the current generated report without invoking the Print Job Dialog. This should be sent after a report is completed. This allows you to print a report directly from your application without having to use the report viewer.

You will not normally use this message. Instead, set the report object's Output_device_mode to PRINT_TO_PRINTER_NO_DIALOG before starting your report.

If you wish to invoke the Print Job Dialog you can use the message DFPrintDialog or the DFPrint message.

See Also

Output_device_mode | DfPrint | DfPrintDialog

Last Edited: May 18, 2004


cWinReport2 [Procedure DFPrinterBinFirstPage]

DFPrinterBinFirstPage - cWinReport2

Allows you to set a different printer bin for report's first page

Type: Procedure

Parameters: integer eBinType

Parameter Description
eBinTypePrinter Bin Source. Should be one of the following values

DF_BIN_AUTO
DF_BIN_LOWER
DF_BIN_CASSETTE
DF_BIN_MANUAL
DF_BIN_ENVELOPE
DF_BIN_MIDDLE
DF_BIN_ENVMANUAL
DF_BIN_ONLYONE
DF_BIN_FIRST
DF_BIN_SMALLFMT
DF_BIN_LARGECAPACITY
DF_BIN_TRACTOR
DF_BIN_LARGEFMT
DF_BIN_UPPER
DF_BIN_LAST

Description

DFPrinterBinFirstPagesets the printer bin to used for the first page in a report. This method is normally sent inside of Starting_Main_Report

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Send DFSetMetrics wpm_cm
    Send DFSetmargins 1 1 1 1
    Send DFSetLandscape true
    Send DFSetPrinterBin DF_BIN_LOWER
    Send DFPrinterBinFirstPage DF_BIN_MIDDLE
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages, including this message, set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

Last Edited: May 13, 2004


cWinReport2 [Procedure DFPrintSetup]

DFPrintSetup - cWinReport2

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: April 14, 2004


cWinReport2 [Procedure DFSetDevice]

DFSetDevice - cWinReport2

Sets the location and name of the print device

Type: Procedure

Parameters: string sPrinterName

Parameter | Description
sPrinterName | The location and name of the current printer

Description

DFSetDevice sets print device. This method is normally sent inside of Starting_Main_Report

Function Starting_Main_Report Returns Integer
    Boolean bErr
    String sMyPrinter
    Get psMyPrinter to sMyPrinter
    Send DfSetDevice sMyPrinter
    Send DFSetMetrics wpm_inch
    Send DFSetmargins 1 1 1 1
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFGetCurrentDevice

Last Edited: May 13, 2004


cWinReport2 [Procedure DFSetEnablePrintFromPreview]

DFSetEnablePrintFromPreview - cWinReport2

Determines if WinPrint2 viewer allows printing

Type: Procedure

Parameters: boolean bEnablePrint

Parameter | Description
bEnablePrint | If true, printing from viewer is allowed. If false, printing from viewer is not allowed

Description

When a report is started, the report object always enables printing from the viewer. This capability may be disabled by sending the DFSetEnablePrintFromPreview. This message should be sent from inside of the starting_main_report event.

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Send DFSetMetrics wpm_cm
    Send DFSetmargins 1 1 1 1
    Send DFSetEnablePrintFromPreview False // disable printing from the viewer.
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

When disabled, the print button in the viewer will appear as a disabled button.

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DfGetEnablePrintFromPreview

Last Edited: May 17, 2004


cWinReport2 [Procedure DFSetLandscape]

DFSetLandscape - cWinReport2

Sets a report's orientation to Landscape or Portrait

Type: Procedure

Parameters: boolean bIsLandscape

Parameter | Description
bIsLandscape | True if orientation is Landscape, false if Portrait

Description

The DFSetLandscape method is used to explicitlly set a report's orientation. You must specify a report's orientation before running a report. This can be done by the user using the printer set up dialog or this can be set by the developer using the DFSetLandscape message.

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Send DFSetMetrics wpm_cm
    Send DFSetmargins 1 1 1 1
    Send DFSetLandscape true // forice page orientation
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFGetLandscape

Last Edited: May 13, 2004


cWinReport2 [Procedure DFSetMargins]

DFSetMargins - cWinReport2

Sets Left, Top, Right and Bottom Margins for a report

Type: Procedure

Parameters: number nLeft number nTop number nRight number nBottom

Parameter | Description
nLeft | Left Margin
nTop | Top Margin
nRight | Right Margin
nBottom | Bottom Margin

Description

DFSetMargins sets margins in your report using the report's current metrics. This method is normally sent inside of Starting_Main_Report

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Send DFSetMetrics wpm_cm
    Send DFSetmargins 1 1 1 1
    Send DFSetLandscape true
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

Setting any value to 0, tells the report to use the physical page margin as specified by the printer. If you specify a margin value that is less than the physical margin value, the physical page margin is used (i.e., same as using 0).

The left and right margins are used for all sections of a report. The top and bottom margins apply to all sections except Page_Top and Page_Bottom. Page_Top and Page_Bottom sections use the actual physical top and bottom page margins for whatever printer is selected. Page_Top and Page_Bottom margins can be set using the DFSetTopBottom message.

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFSetTopBottom | DFSetMetrics

Last Edited: May 13, 2004


cWinReport2 [Procedure DFSetMetrics]

DFSetMetrics - cWinReport2

Sets a report's metrics to centimeters or Inches

Type: Procedure

Parameters: integer eType

Parameter Description
eType

Constant | Meaning
wpm_cm | centimeters
wpm_inch | inches

Description

Before running a report you must specify if the report will use Inches or Centimeters for its metrics. This method is normally sent inside of Starting_Main_Report

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Send DFSetMetrics wpm_cm
    Send DFSetmargins 1 1 1 1
    Send DFSetLandscape true
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

Note:The string values "INCH" and "CM" can also be used to set the metrics. This is considered to be an obsolete technique and is provided only for backwards compatibilty.

See Also

DFGetMetrics

Last Edited: May 13, 2004


cWinReport2 [Procedure DFSetNumberOfCopies]

DFSetNumberOfCopies - cWinReport2

Sets the number of copies to printed

Type: Procedure

Parameters: integer iCopies

Parameter | Description
iCopies | Number of copies to printed

Description

DFSetNumberOfCopies determines the number of copies to printed. This method is normally sent inside of Starting_Main_Report

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Send DFSetMetrics wpm_cm
    Send DFSetmargins 1 1 1 1
    Send DFSetLandscape true
    Send DFSetNumberOfCopies 3
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

If a report is printed from the viewer, the number of copies can be set by the user within the print job dialog.

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

Last Edited: May 13, 2004


cWinReport2 [Procedure DFSetPrintDlgInPreview]

DFSetPrintDlgInPreview - cWinReport2

Determines if the print job dialog will appear when printing is selected from the WinPrint2 viewer

Type: Procedure

Parameters: boolean bShowDialog

Parameter | Description
bShowDialog | True if print job dialog should appear, false if dialog will not appear

Description

DFSetPrintDlgInPreview allows the developer to control if the print job dialog will appear when the print buttom is selected from the WinPrint2 viewer. When a report is started, the report object always enables the print job dialog. This capability may be disabled by sending the DFSetEnablePrintFromPreview message. This message should be sent from inside of the starting_main_report event.

The Print Job dialog allows you to set a report's page range, number of copies, and collation. It is usually invoked after a report has been generated before printing. This dialog will appear from the report viewer unless the feature is disabled using the DFSetPrintDlgInPreview message. It can be invoked when printing manually using the DFPrint message which will invoke the dialog, print the report and then clear the report document. It can be invoked by itself with the DFPrintDialog message.

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Send DFSetMetrics wpm_cm
    Send DFSetmargins 1 1 1 1
    Send DFSetPrintDlgInPreview  False // Don't show the print job dialog when you select print from the viewer
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFGetPrintDlgInPreview | DFGetEnablePrintFromPreview | DFSetEnablePrintFromPreview | DFPrint | DFPrintDialog

Last Edited: May 17, 2004


cWinReport2 [Procedure DFSetPrinterBin]

DFSetPrinterBin - cWinReport2

Sets the printer bin to be used in a report

Type: Procedure

Parameters: integer eBinType

Parameter Description
eBinTypePrinter Bin Source. Should be one of the following values

DF_BIN_AUTO
DF_BIN_LOWER
DF_BIN_CASSETTE
DF_BIN_MANUAL
DF_BIN_ENVELOPE
DF_BIN_MIDDLE
DF_BIN_ENVMANUAL
DF_BIN_ONLYONE
DF_BIN_FIRST
DF_BIN_SMALLFMT
DF_BIN_LARGECAPACITY
DF_BIN_TRACTOR
DF_BIN_LARGEFMT
DF_BIN_UPPER
DF_BIN_LAST

Description

DFSetPrinterBin sets the printer bin used in a report. This method is normally sent inside of Starting_Main_Report

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Send DFSetMetrics wpm_cm
    Send DFSetmargins 1 1 1 1
    Send DFSetLandscape true
    Send DFSetPrinterBin DF_BIN_LOWER
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFPrinterBinFirstPage

Last Edited: May 13, 2004


cWinReport2 [Procedure DFSetPrinterPaper]

DFSetPrinterPaper - cWinReport2

Sets the paper type/size for a report

Type: Procedure

Parameters: integer ePaperType

Parameter Description
ePaperTypePaper Type/Size must be one of the following:

DF_PAPER_LETTER
DF_PAPER_LETTERSMALL
DF_PAPER_TABLOID
DF_PAPER_LEDGER
DF_PAPER_LEGAL
DF_PAPER_STATEMENT
DF_PAPER_EXECUTIVE
DF_PAPER_A3
DF_PAPER_A4
DF_PAPER_A4SMALL
DF_PAPER_A5
DF_PAPER_B4
DF_PAPER_B5
DF_PAPER_FOLIO
DF_PAPER_QUARTO
DF_PAPER_10X14
DF_PAPER_11X17
DF_PAPER_NOTE
DF_PAPER_ENV_9
DF_PAPER_ENV_10
DF_PAPER_ENV_11
DF_PAPER_ENV_12
DF_PAPER_ENV_14
DF_PAPER_CSHEET
DF_PAPER_DSHEET
DF_PAPER_ESHEET
DF_PAPER_ENV_DL
DF_PAPER_ENV_C3
DF_PAPER_ENV_C4
DF_PAPER_ENV_C5
DF_PAPER_ENV_C6
DF_PAPER_ENV_C65
DF_PAPER_ENV_B4
DF_PAPER_ENV_B5
DF_PAPER_ENV_B6
DF_PAPER_ENV_ITALY
DF_PAPER_ENV_MONARCH
DF_PAPER_ENV_PERSONAL
DF_PAPER_FANFOLD_US
DF_PAPER_FANFOLD_STD_GERMAN
DF_PAPER_FANFOLD_LGL_GERMAN
DF_PAPER_LAST
DF_PAPER_USER

Description

DFSetPrinterPaper determines the type/size of paper to be used in a report. This method is normally sent inside of Starting_Main_Report

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Send DFSetMetrics wpm_cm
    Send DFSetmargins 1 1 1 1
    Send DFSetLandscape true
    Send DFSetPrinterPaper DF_PAPER_A4
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFGetPrinterPaper

Last Edited: May 13, 2004


cWinReport2 [Procedure DFSetPrinterResolution]

DFSetPrinterResolution - cWinReport2

Sets the printer resolution used in a report

Type: Procedure

Parameters: integer eResType

Parameter Description
eResTypeThe resolution mode. Must be one of the following modes:

DF_RES_HIGH
DF_RES_MEDIUM
DF_RES_LOW
DF_RES_DRAFT

Description

DFSetPrinterResolution determines the printer resolution to be used in a report. This method is normally sent inside of Starting_Main_Report

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Send DFSetMetrics wpm_cm
    Send DFSetmargins 1 1 1 1
    Send DFSetLandscape true
    Send DFSetPrinterResolution DF_RES_MEDIUM
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFGetPrinterResolution

Last Edited: May 13, 2004


cWinReport2 [Procedure DFSetTopBottom]

DFSetTopBottom - cWinReport2

Sets the top and bottom margins used by the Page_Top and Page_Bottom sections

Type: Procedure

Parameters: number nTop number nBottom Boolean bAllPages

Parameter | Description
nTop | Top Margin
nBottom | Bottom Margin
bAllPages | Apply to all pages (or only to first/last)

Description

DFSetTopBottom sets the top margin for Page_Top and the bottom margin for Page_Bottom. If these margins are not set the absolute page margin as determined by the selected printer is used.

The pAllPages parameter is used to determine if the margin setting should be applied to all pages (the default) or just the first page (for page_top) and that last page (for page_bottom).

The left/right margins, and top/bottom margins for all other sections are set using the DFSetMargins message.

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Send DFSetMetrics wpm_cm
    Send DFSetmargins 1 2 1 3
    Send DFSetTopBottom  1 1
    Send DFSetLandscape true
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFSetMargins

Last Edited: May 13, 2004


cWinReport2 [Procedure DFSetUserDefinedPapersize]

DFSetUserDefinedPapersize - cWinReport2

Sets the length and width of a user defined papersize

Type: Procedure

Parameters: number nLength number nWidth

Parameter | Description
nLength | Length of paper
nWidth | Width of paper

Description

DFSetUserDefinedPapersize sets a paper size width and length using the current metrics. This is used when the paper size (DFSetPrinterPaper) is set to DF_PAPER_USER. This method is normally sent inside of Starting_Main_Report

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Send DFSetMetrics wpm_inch
    Send DFSetmargins 1 1 1 1
    Send DFSetLandscape true
    Send DFSetPrinterPaper DF_PAPER_USER
    Send DFSetUserDefinedPaperSize 12 8.5
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

The DFGet and DFSet messages and the WinPrint2 global object.

All of the cWinReport2 DFGet... and DFSet... messages set the state of the global WinPrint2 report object (the WinPrint2 report engine). It is not setting the state of the report object (i.e., these methods are not setting report object properties). Since many reports in an application will use the global WinPrint2 object, you must set and get the state of this object when your report object has control of it. The best place to do this is inside of the Starting_main_report event.

See Also

DFSetPrinterPaper | DFGetUserDefinedLength | DFGetUserDefinedWidth

Last Edited: May 13, 2004


cWinReport2 [Procedure EndMultiReport]

EndMultiReport - cWinReport2

Ends a linked multi-report

Type: Procedure

Parameters: No Parameters

Description

Normally, a report object represents a single report. The report object may contain nested child reports but the outer report represents a single report that is printed or viewed as a single report. A method exists that allows the developer to create linked multi-reports. A multi-report lets you run a number of reports and have them represented as a single report - the report will appear in the viewer as a single report and the report will be printed as a single report job.

You create a multi-report by setting the pbMultiReports property to true, for all reports to be linked. The default value of this property is false. Setting this property to true, tells the report objects that they are part of a larger report and that a report should not be considered completed when it ends.

After the last report has been generated you must explicitly inform the report engine that the report is complete. You do this by sending the EndMultiReport to the last report. You must remember to send this message when the final report is completed.

Before starting a subsequent report (report 2, report 3, etc.) you should always check to make sure that the previous report was not canceled. You do this by checking the report's cancelled_state property. If a report is canceled, you will not need to send the EndMultiReport message.

When pbMultiReports is true, the AutoNew_Page_State determines how page breaks are handled on the subsequent linked reports (i.e., the reports that occur after the first report). If AutoNew_Page_state is true, the default, the linked report will be start on a new page. If false, the new report is printed on the same page as the previous report.

Object oMyReport1 is a cWinReport2
    :
    Set pbMultiReports to True
    :
End_object

Object oMyReport2 is a cWinReport2
    :
    Set pbMultiReports to True
    Set AutoNew_Page_State to True // new page when this report starts
    :
End_object

Object oMyReport3 is a cWinReport2
    :
    Set pbMultiReports to True
    Set AutoNew_Page_State to False // new page is not generated when this report starts
    :
End_object

Function RunMyReport returns boolean
    boolean bCancel
    Send Run_Reports of oMyReport1
    Get Cancelled_state of oMyReport1 to bCancel
    // if report 1 not canceled, run the next report
    If not bCancel begin
        Send Run_Reports of oMyReport2
        Get Cancelled_state of oMyReport2 to bCancel
        // if report 2 not canceled, run the next report
        If not bCancel begin
            Send Run_Reports of oMyReport3
            Get Cancelled_state of oMyReport3 to bCancel
            If not bCancel begin
                Send EndMultiReport of oMyReport3
            end
        end
    end
    function_return bCancel
End_Function

See Also

pbMultiReports | AutoNew_Page_State | Cancelled_State

Last Edited: May 11, 2004


cWinReport2 [Procedure PrintReport]

PrintReport - cWinReport2

Outputs the current report to printer or viewer based on output_device_mode

Type: Procedure

Parameters: No Parameters

Description

PrintReport outputs the current report to printer or viewer based on output_device_mode.

If output_device_mode is PRINT_TO_WINDOW or DEFERRED_PRINT_TO_WINDOW the viewer is invoked.

If the mode is PRINT_TO_PRINTER_NO_DIALOG the report is sent the the printer without invoking the print job dialog.

If the mode is PRINT_TO_PRINTER, the report is sent to the printer after invoking the print job dialog.

When a report is completed, the report object will send this message, causing your report to be printed or viewed as needed.

You should only send this message after a report is completed. Usually the report object will handle this process for you.

See Also

output_device_mode

Last Edited: May 12, 2004


cWinReport2 [Procedure ShowRuler]

ShowRuler - cWinReport2

Displays a ruler in the report

Type: Procedure

Parameters: No Parameters

Description

When sent, the ShowRuler message displays a ruler in the report. This can be used for design and debugging. It gives you a ruler that you can use to determine where to place fields and labels.

Procedure Body
    Send ShowRuler // show a ruler for lining up fields

Last Edited: May 11, 2004


cWinReport2 [Procedure Update_Status]

Update_Status - cWinReport2

Updates a report's status in the report viewer

Type: Procedure

Parameters: String Val

Parameter | Description
Val | Status text to be displayed in the viewer

Description

The update_status message is augmented in this class to direct the status update string to the report viewer. The status area in the WinPrint2 report viewer is the status panel at the bottom of the viewer.

If the report viewer is not being used (e.g., a direct report to printer) the message will be forwarded causing the status panel to be updated.

Note:Placing the Update_status message in the Body procedure may create an update that occurs too frequently making the status line hard to read and slowing down the report generation. Often the status update is best performed in a sub-header. Alternately, you could write code so that the status update within the body does not occur with every record.

Last Edited: July 11, 2006


Properties for cWinReport2

View property list in hierarchical order

Name | Description | Defining Class
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button | BasicReport
Assigned_Channel |  | Report
AutoNew_Page_State | Determines if a new page is generated when a multi-report starts the next report |
AutoOutPut_State | Determines if the report is automatically output to the printer or the Previewer when it is complete |
Cancelled_State | Setting this true will cancel a report | Report
Child_Count | Returns the number of child objects the object contains | cObject
Child_Rpt_State | Set true if the current Report object is nested | Report
Current_Rec | (Obsolete) Contains the record number of the current valid record found | Report
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Error_State |  | BasicReport
Find_Down_state | Determines if an index should be traversed in forward or reverse order | Report
Find_Mode | Maintains the current finding mode | Report
Footer_Lines | Contains the number of lines in the page_bottom image plus the page_footer image plus the page_total image | Report
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function | Report
Has_Children_Rpt_State | Is set true if other reports are nested inside this report object | Report
Last_Rec | (Obsolete) Contains the record number of the last selected record found | Report
Main_File | Contains the filenumber of the file which the report will use for finding records | Report
Main_Report_Id | Contains the object ID of the outer report | Report
Name | Returns the full name of the object including parentage | cObject
New_Page_State | Set true when a new page is needed | Report
No_Constrained_Find_State | Determines if constrained record finding should be disabled | Report
No_Finding_State | Determines how the Report object will find records | Report
No_PageCheck_State | Set true when the Report object is processing a new page | Report
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found | Report
Num_Breaks | Returns the number of breaks in a report | Report
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Ordering | Contains the index number which will be used for finding records | Report
Output_Device | Handles the name of the output device | BasicReport
Output_Device_Mode | Determines how the report is output |
Page_Count | Keeps track of the current page number | Report
Page_End | Determines how many lines on a page are allowed before a page break will occur | Report
Page_End_State | If this property is set true below the forward send statement in the starting_main_report procedure, then the next page_check will cause an end-of-page/new-page sequence | Report
Page_Feed | Used by the formfeed procedure | Report
Page_Footer_Lines | The number of lines in the page_footer image | Report
Parent | Returns the parent of an object | cObject
pbMultiReports | Provides a mechanism for linking multiple report objects to create a single report |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phoWinPrint | Contains the handle of the Winprint2 global print object |
priCurrentRec | Contains the RowId of the current valid record found | Report
priFoundRec | Contains the RowId of the record found by the find_rec function | Report
priLastRec | Contains the RowId of the last selected record found | Report
Rec_Count | Contains the number of records found for the current report | Report
Refind_for_SubTotal_State | Ensures that the subtotal is processed with the last valid record for that break level | Report
Report_Caption | Contains the text that will appear in the status panel's caption bar | BasicReport
Report_Channel | Determines which output channel will be used for your report output | Report
Report_Footer_Lines | The number of lines in the report_footer image | Report
Report_Message | An additional message area that will appear below the report_title in the status panel | BasicReport
Report_Status_Panel |  | BasicReport
Report_Title | A centered title that appears in the status panel | BasicReport
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing | Report
Server | Contains the object ID of this object's server | Report_DS
Status_Log_Id | Object ID of status-log object | BasicReport
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs | BasicReport
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs | BasicReport
Sub_Totaling_State | Set true when the Report object is processing subtotals or totals | Report


cWinReport2 [Property AutoNew_Page_State]

AutoNew_Page_State - cWinReport2

Determines if a new page is generated when a multi-report starts the next report

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The pbMultiReports property allows you to link multiple reports allowing a user to view or print the multiple reports as a single instance. When pbMultiReports is true, the AutoNew_Page_State determines how page breaks are handled on the linked reports (i.e., the reports that occur after the first report). If AutoNew_Page_state is true, the default, the linked report will be start on a new page. If false, the new report is printed on the same page as the previous report.

Set pbMultiReports to True
Set AutoNew_Page_state to false

If pbMultiReports is false or this report is the first report in a series of linked reports, AutoNew_Page_State has no effect and a new page is always printed.

A new page is generated using the DFNew_Page message. This message can sent manually to force a new page.

See Also

pbMultiReports | DFNew_Page

Last Edited: May 11, 2004


cWinReport2 [Property AutoOutPut_State]

AutoOutPut_State - cWinReport2

Determines if the report is automatically output to the printer or the Previewer when it is complete

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If Auto_output_state is true (the default), the report is automatically output to the printer or the Previewer when it is complete. It uses the value of Property output_device_mode to determine if it should do a DFPrint (mode= PRINT_TO_PRINTER) or a DFPreview (mode = PRINT_TO_WINDOW).

If this property is set false, then no auto-print occurs and you have to send DFPrint or DFPreview at the end of the report.

Default is true.

Last Edited: April 14, 2004


cWinReport2 [Property Output_Device_Mode]

Output_Device_Mode - cWinReport2

Determines how the report is output

Type: Property

Access: Read/Write

Data Type: Integer

Description

Output_device_mode determines how a report should be output. The following modes are supported:

Constant | Meaning
PRINT_TO_WINDOW | Output is sent to the Winprint Viewer. As the report is printed, the report can be viewed in the viewer.
PRINT_TO_PRINTER | Output is sent directly to the printer.
PRINT_TO_UNDEFINED | The report does not specify output - the parent ReportView's Output_device_mode will determine the mode.
PRINT_TO_PRINTER_NO_DIALOG | Output directly to the printer without showing the print job dialog.
DEFERRED_PRINT_TO_WINDOW | Output is sent to the viewer, however the viewer is not displayed until the report is finished.

If the value of the Output_device_mode property is PRINT_TO_UNDEFINED, the default, and this object is in a report view or report panel, it will use this container's output_device_mode which defaults to PRINT_TO_WINDOW. If there is no report view, PRINT_TO_WINDOW will be used.

Normally, PRINT_TO_WINDOW is the mode of choice. It allows you to see the report in the viewer and it allows you to view the report as it is being generated.

If this mode is set, it should be set before the report run. If it is set within Starting_main_report it must be set before the message is forwarded.

Function Starting_Main_Report Returns Integer
    Boolean bErr
    Set Output_device_mode to PRINT_TO_WINDOW
    Send DFSetMetrics wpm_cm
    Send DFSetmargins 1 1 1 1
    Forward Get Starting_Main_Report to bErr
    Function_return bErr
End_Function // Starting_Main_Report

Last Edited: May 18, 2004


cWinReport2 [Property pbMultiReports]

pbMultiReports - cWinReport2

Provides a mechanism for linking multiple report objects to create a single report

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Normally, a report object represents a single report. The report object may contain nested child reports but the outer report represents a single report that is printed or viewed as a single report. A method exists that allows the developer to create linked multi-reports. A multi-report lets you run a number of reports and have them represented as a single report - the report will appear in the viewer as a single report and the report will be printed as a single report job.

You create a multi-report by setting the pbMultiReports property to true, for all reports to be linked. The default value of this property is false. Setting this property to true, tells the report objects that they are part of a larger report and that a report should not be considered completed when it ends.

After the last report has been generated you must explicitly inform the report engine that the report is complete. You do this by sending the EndMultiReport to the last report. You must remember to send this message when the final report is completed.

Before starting a subsequent report (report 2, report 3, etc.) you should always check to make sure that the previous report was not canceled. You do this by checking the report's cancelled_state property. If a report is canceled, you will not need to send the EndMultiReport message.

When pbMultiReports is true, the AutoNew_Page_State determines how page breaks are handled on the subsequent linked reports (i.e., the reports that occur after the first report). If AutoNew_Page_state is true, the default, the linked report will be start on a new page. If false, the new report is printed on the same page as the previous report.

Object oMyReport1 is a cWinReport2
    :
    Set pbMultiReports to True
    :
End_object

Object oMyReport2 is a cWinReport2
    :
    Set pbMultiReports to True
    Set AutoNew_Page_State to True // new page when this report starts
    :
End_object

Object oMyReport3 is a cWinReport2
    :
    Set pbMultiReports to True
    Set AutoNew_Page_State to False // new page is not generated when this report starts
    :
End_object

Function RunMyReport returns boolean
    boolean bCancel
    Send Run_Reports of oMyReport1
    Get Cancelled_state of oMyReport1 to bCancel
    // if report 1 not canceled, run the next report
    If not bCancel begin
        Send Run_Reports of oMyReport2
        Get Cancelled_state of oMyReport2 to bCancel
        // if report 2 not canceled, run the next report
        If not bCancel begin
            Send Run_Reports of oMyReport3
            Get Cancelled_state of oMyReport3 to bCancel
            If not bCancel begin
                Send EndMultiReport of oMyReport3
            end
        end
    end
    function_return bCancel
End_Function

See Also

EndMultiReport | AutoNew_Page_State | Cancelled_State

Last Edited: May 11, 2004


cWinReport2 [Property phoWinPrint]

phoWinPrint - cWinReport2

Contains the handle of the Winprint2 global print object

Type: Property

Access: Read/Write

Data Type: Handle

Description

phoWinPrint contains the handle of the WinPrint2 global print object. This handle is used by the report object to communicate with WinPrint2 print engine. It is a goal of the cWinReport2 object to provide all interfaces needed to run a report. Therefore, there should never be a need for a developer to access this handle.

Last Edited: May 13, 2004


Events for cWmlreport

View event list in hierarchical order

Name | Description | Defining Class
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property | cReport
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Error_Report | Sent whenever an error is generated | cBasicReport
Final_Formfeed |  | cReport
OnBody | Called every time a valid record has been found | cReport
OnConstrain |  | cReport
OnEndingMainReport | User Handler Intended for override | cBasicReport
OnEndingReport | Called at the end of all reports | cReport
onError | Provided as a hook to handle custom error reporting | cBasicReport
OnInitBreakPoints | Determines the number and order of your breakpoints | cWebReport
OnPageBottom | Called at the end of your report and should be used to display any final totals and to end any tables | cReport
OnPageFooter | Printed after OnPageTotal on every page except the last page | cReport
OnPageHeader | Called after OnPageTop on every new page except the first | cReport
OnPageTitle | Called on every new page after OnReportHeader or OnPageHeader. | cReport
OnPageTop | Called when printing the top of every report | cReport
OnPageTotal | Called on every new page and is printed as the first part of a page break at the bottom of each page | cReport
OnReportFooter | Printed after OnPageTotal on the last page of the report | cReport
OnReportHeader | Called only on the first page of the report, after OnPageTop | cReport
OnSelection | Validates a record | cReport
OnStartingMainReport | Called when a report is started | cBasicReport
OnStartingReport | Called when a report is started | cReport
OnSubHeader1..n | Called each time a subheader needs to be printed | cReport
OnSubHeaderInit1..n | Called for every break level (n) for which you define a OnSubHeader_init1..n procedure section in your program | cReport
OnSubTotal1..n | Called when a subtotal needs to be processed | cReport
OnTotal | Called at the end of a report after all final sub-totals have been printed | cReport
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found | cReport
Report_Interrupt | Called when the status panel's Cancel button has been pressed | cBasicReport


cWmlreport [Function AddWmlRecordLink]

AddWmlRecordLink - cWmlreport

Creates a cell that contains a link to another web page

Type: Function

Obsolete

Return Data Type: String

Parameters: string sValue string sTitle

Parameter | Description
sValue | content of the link; required
sTitle | the text displayed in the link

Return Value

Returns a fully formatted WML anchor tag that displays this data and contains a link to another page.

Description

Obsolete

This method is obsolete. Use AddWmlRowidLink.

AddWmlRecordLink makes it easy to create a cell that contains a link to another web page. This allows you to create drill down reports, reports that link to a zoom page and reports that link back to a data entry page.

This function is passed a data sValue and it returns a fully formatted WML anchor tag that displays this data and contains a link to another page.

The link consists of a URL address which is defined in the property psHRefName; and a Record Id link which is defined as "RecID=xx" where xx is the current record's record id (recnum).

The URL (the link) is created by using the psHRefame property as the URL followed by a querystring of "?RecId="

For example, assume you need to create a link to a page named "MyZoomPage.asp" and that you want to pass it a record id in the format of "RecId=xx". So the entire URL must be "MyZoomPage.asp?RecId=xx". You wish to assign the link to customer name. You could do this manually as follows:

Move Customer.Name to sName
Move Customer.recnum to sRec
Move "MyZoomPage.asp" to sRefName
Move (sRefName - "?RecId=" - sRec ) to sUrl
Get HtmlLink sUrl (HtmlEncode(sName)) to sValue
Send WriteHtmlCell sValue 'Class="Data" Align="right"'

If you use this function and the psHRefName property this can be accomplished as follows:

1. Before you start the report set the psHRefName as follows:

Set psHRefName of oReport to "MyZoomPage.asp"

2. Within your body section create the following code:

Get AddRecordLink (HtmlEncode(Customer.Name)) to sText
Send WriteHtmlCell sText 'Class="Data" Align="right"'

If you need to pass additional information in your URL you can do so by adding the information to the psHRefName property. For example, if you wanted to add the additional information Operation=1 to you URL you could do this by setting your psHRefName property to:

Set psHRefName to "MyZoomPage.asp?Operation=1"

The AddRecordLink would return the following URL:

MyZoomPage.asp?Operation=1&RecId=xx

See Also

AddWmlRowidLink | psHRefName | HtmlLink | AddRecordLink

Last Edited: February 2, 2005


cWmlreport [Function AddWmlRowIdLink]

AddWmlRowIdLink - cWmlreport

Creates a cell that contains a link to another web page

Type: Function

Return Data Type: String

Parameters: string sValue string sTitle

Parameter | Description
sValue | content of the link; required
sTitle | the text displayed in the link

Return Value

Description

AddWmlRowIdLink makes it easy to create a cell that contains a link to another web page. This allows you to create drill down reports, reports that link to a zoom page and reports that link back to a data entry page.

This function is passed a data sValue and it returns a fully formatted WML anchor tag that displays this data and contains a link to another page.

See Also

psHRefName | HtmlLink | AddRecordLink

Last Edited: February 2, 2005


cWmlreport [Function WmlAnchor]

WmlAnchor - cWmlreport

Adds an Wml Anchor

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

This adds an Wml Anchor.

The WML equivalent of:

<a>sData</a>

VDF Code

String sData sVar
Get WmlAnchor sData to sVar
Send WriteWml (WmlAnchor(Self,sData))

Script Code

<a>sData</a>

Last Edited: September 15, 2003


cWmlreport [Function WmlBig]

WmlBig - cWmlreport

Makes the string big

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

WmlBig makes the string big. The WML equivalent of:

<big>sData</big>

VDF Code

String sData sVar
Get WmlBig sData to sVar
Send WriteWml (WmlBig(Self,sData))

Script Code

<big>sData</big>

Last Edited: September 15, 2003


cWmlreport [Function WmlBold]

WmlBold - cWmlreport

Makes the string bold

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

WmlBold makes the string bold. The WML equivalent of:

<b>sData</b>

VDF Code

String sData sVar
Get WmlBold sData to sVar
Send WriteWml (WmlBold(Self,sData))

Script Code

<b>sData</b>

Last Edited: September 15, 2003


cWmlreport [Function WmlEm]

WmlEm - cWmlreport

Makes the string emphasized

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

WmlEm makes the string emphasized. The WML equivalent of:

<em>sData</em>

VDF Code

String sData sVar
Get WmlEm sData to sVar
Send WriteWml (WmlEm(Self,sData))

Script Code

<em>sData</em>

Last Edited: September 15, 2003


cWmlreport [Function WmlItalics]

WmlItalics - cWmlreport

Makes the string italics

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

WmlItalics makes the string italics. The WML equivalent of:

<i>sData</i>

VDF Code

String sData sVar
Get WmlItalics sData to sVar
Send WriteWml (WmlItalics(Self,sData))

Script Code

<i>sData</i>

Last Edited: September 15, 2003


cWmlreport [Function WmlLink]

WmlLink - cWmlreport

Adds a hyperlink (sURL) to a string (sDat)

Type: Function

Return Data Type: String

Parameters: string sURL string sDat string sTitle

Parameter | Description
sURL | the URL of the hyperlink
sDat | text displayed for the link
sTitle | link title (optional)

Return Value

Returns formatted Wml string

Description

WmlLink adds a hyperlink (sURL) to a string (sDat). The WML equivalent of:

<a href=sURL title=sTitle>sData</a>

VDF Code

String sData sVar sTitle
Get WmlLink sURL sData sTitle to sVar
Send WriteWml (WmlLink(Self,sURL,sData,sTitle))

Script Code

<a href=sURL>sData</a>

or

<a href=sURL title=sTitle>sData</a>

Last Edited: September 15, 2003


cWmlreport [Function WmlSmall]

WmlSmall - cWmlreport

Makes the string small

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

WmlSmall makes the string small. The WML equivalent of:

<small>sData</small>

VDF Code

String sData sVar
Get WmlSmall sData to sVar
Send WriteWml (WmlSmall(Self,sData))

Script Code

<small>sData</small>

Last Edited: September 15, 2003


cWmlreport [Function WmlStrong]

WmlStrong - cWmlreport

Adds strong emphasis (usually appears as bold) to the string

Type: Function

Return Data Type: String

Parameters: string sDat

Parameter | Description
sDat | data to use with this message

Return Value

Returns formatted Wml string

Description

WmlStrong adds strong emphasis (usually appears as bold) to the string. The WML equivalent of:

<strong>sData</strong>

VDF Code

String sData sVar
Get WmlStrong sData to sVar
Send WriteWml (WmlStrong(Self,sData))

Script Code

<strong>sData</strong>

Last Edited: September 15, 2003


Methods for cWmlreport

View method list in hierarchical order

Name | Type | Description | Defining Class
AddRecordLink | Function | (Obsolete) Creates a cell that contains a link to another web page | cWebReport
AddRowIdLink | Function | Creates a cell that contains a link to another web page | cWebReport
AddSubTotal | Procedure | Adds the passed value to the total maintained in level iCount | cHtmlReport
AddWmlRecordLink | Function | (Obsolete) Creates a cell that contains a link to another web page |
AddWmlRowIdLink | Function | Creates a cell that contains a link to another web page |
ClearAllSubTotals | Procedure | Clears all the SubTotal accumulators | cHtmlReport
ClearSubTotal | Procedure | Clears a single Subtotal accumulator | cHtmlReport
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoRunReport | Function | The main entry point for reportsT | cReport
End_Log | Procedure | Sends an end-log message to the log object | cBasicReport
Error_Log_Status | Procedure | Called by error_report if status_log_state is true | cBasicReport
Exit_Application | Procedure | Starts the process of closing an application | cObject
Formfeed | Procedure | Handles formfeeds | cReport
HtmlAnchor | Function | Adds an Html Anchor | cHtmlReport
HtmlBig | Function | Makes the string big | cHtmlReport
HtmlBlink | Function | Makes the string blink | cHtmlReport
HtmlBold | Function | Makes the string bold | cHtmlReport
HtmlEmph | Function | Makes the string emphasized | cHtmlReport
HtmlFixed | Function | Makes the string fixed width | cHtmlReport
HtmlFontcolor | Function | Sets the strings font color | cHtmlReport
HtmlFontsize | Function | Sets the font size | cHtmlReport
HtmlHeader | Function | Creates a header string of level iHeader | cHtmlReport
HtmlItalics | Function | Makes the string italics | cHtmlReport
HtmlLink | Function | Adds a hyperlink to a string | cHtmlReport
HtmlSmall | Function | Makes the string small | cHtmlReport
HtmlStrike | Function | Overstrikes through the string | cHtmlReport
HtmlStrong | Function | Adds strong emphasis to the string | cHtmlReport
HtmlSub | Function | Makes the string subscript | cHtmlReport
HtmlSup | Function | Makes the string superscript | cHtmlReport
Log_Status | Procedure | Sends passed message to the log object | cBasicReport
Output_ImageNum | Procedure | Outputs the image represented by ImageNum | cReport
RegisterBreakpoint | Procedure | registers a breakpoint function | cWebReport
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO | cReportDS
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Save | Procedure | If sent, this saves the current record | cReportDS
Start_Log | Procedure | Sends a start-log message to the log object | cBasicReport
SubTotal | Function | Returns the appropriate subtotal and clears the subtotal accumulator | cHtmlReport
SumSubTotal | Function | Returns the appropriate subtotal but does not clear the subtotal accumulator | cHtmlReport
Update_Status | Procedure | Send this message to update the action area of the status panel | cBasicReport
WmlAnchor | Function | Adds an Wml Anchor |
WmlBig | Function | Makes the string big |
WmlBold | Function | Makes the string bold |
WmlEm | Function | Makes the string emphasized |
WmlItalics | Function | Makes the string italics |
WmlLink | Function | Adds a hyperlink (sURL) to a string (sDat) |
WmlSmall | Function | Makes the string small |
WmlStrong | Function | Adds strong emphasis (usually appears as bold) to the string |
WriteHtml | Procedure | Outputs the passed string to the web page and ends the line | cHtmlReport
WriteHtmlBreak | Procedure | Outputs the passed string and ends the line | cHtmlReport
WriteHtmlCell | Procedure | Outputs a table cell containing sData | cHtmlReport
WriteHtmlCellHeader | Procedure | Outputs a table header cell containing sData | cHtmlReport
WriteHtmlHorzLine | Procedure | Outputs a horizontal line to the HTML file | cHtmlReport
WriteHtmlRowBegin | Procedure | Outputs a "begin" row HTML string | cHtmlReport
WriteHtmlRowEnd | Procedure | Outputs an end row html string | cHtmlReport
WriteHtmlTableBegin | Procedure | Outputs a "begin" table html string | cHtmlReport
WriteHtmlTableEnd | Procedure | Outputs an end table html string | cHtmlReport
WriteLn | Procedure | Outputs the string and ends the Line | cHtmlReport
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data | cReport
WriteWml | Procedure | Outputs the passed string to the web page and ends the line |
WriteWmlBreak | Procedure | Outputs the passed string and ends the line |
WriteWmlCell | Procedure | Outputs a table cell containing sData |
WriteWmlDataBegin | Procedure | Outputs a begin table data WML string |
WriteWmlDataEnd | Procedure | Outputs an end table data WML string |
WriteWmlImg | Procedure | Adds a WML image |
WriteWmlRowBegin | Procedure | Outputs a "begin" row WML string |
WriteWmlRowEnd | Procedure | Outputs an end row WML string |
WriteWmlTableBegin | Procedure | Outputs a "begin" table html string |
WriteWmlTableEnd | Procedure | Outputs an end table wml string |


cWmlreport [Procedure WriteWml]

WriteWml - cWmlreport

Outputs the passed string to the web page and ends the line

Type: Procedure

Parameters: string sVal

Parameter | Description
sVal | the value of the string

Description

WriteWml outputs the passed string to the web page and ends the line. When passing strings you will probably first want to encode the Wml string, so special characters will not be read as WML characters.

This method maintains the piWmlLength property.

Typical output message might look like:

Send WriteWml (WmlEncode(Customer.Name))

Remember that HtmlEncode is a global method - it does not require an object parameter.

This outputs the passed string to the WML file. The text is passed unfiltered to the WML page (unless the HtmlEncode function is used). All of the other WBO WML messages use this message to output WML. You may use this to generate any type of valid WML output you want.

Note:The text is not processed in any way. If the string contains valid WML formatting characters (i.e., the Bold tag), they will be interpreted by your browser as formatting commands. If your text contains characters that should not be "misunderstood" by WML, you should encode them using the WMLEncode function.

With the exception of the WriteHtmlPlainText message, all of the other WriteHtmlxxx messages eventually send this message.

VDF Code

Send WriteWml (WmlEncode(Customer.Name))
Send WriteWml ("<strong>" + WmlEncode(Customer.Notes) + "</strong>")

Script Code

None

Last Edited: June 23, 2005


cWmlreport [Procedure WriteWmlBreak]

WriteWmlBreak - cWmlreport

Outputs the passed string and ends the line

Type: Procedure

Parameters: String sWml

Parameter | Description
sWml | data string to write to Wml browser

Description

WriteWmlBreak outputs the string and then generates a line break (creates a new line). The WML equivalent of:

("<br/>")

VDF Code

Send WriteWmlBreak sStr

Script Code

sStr <br/>

Last Edited: September 15, 2003


cWmlreport [Procedure WriteWmlCell]

WriteWmlCell - cWmlreport

Outputs a table cell containing sData

Type: Procedure

Parameters: string sData

Parameter | Description
sData | data to place in the table cell

Description

WriteWmlCell outputs a table cell containing sData. The WML equivalent of the message would be:

<td>sData</td>

VDF Code Examples

Send WriteWmlCell sData
Send WriteWmlCell (WmlEncode(Cust.Name))

Script Code

<td>sData</td>

Last Edited: September 15, 2003


cWmlreport [Procedure WriteWmlDataBegin]

WriteWmlDataBegin - cWmlreport

Outputs a begin table data WML string

Type: Procedure

Parameters: No Parameters

Description

WriteWmlDataBegin outputs a begin table data WML string. The WML equivalent of:

<td>

VDF Code

Send WriteWmlDataBegin

Script Code

<td>

Last Edited: September 15, 2003


cWmlreport [Procedure WriteWmlDataEnd]

WriteWmlDataEnd - cWmlreport

Outputs an end table data WML string

Type: Procedure

Parameters: No Parameters

Description

WriteWmlDataEnd outputs an end table data WML string. The WML equivalent of:

</td>

VDF Code

Send WriteWmlDataEnd

Script Code

</td>

Last Edited: September 15, 2003


cWmlreport [Procedure WriteWmlImg]

WriteWmlImg - cWmlreport

Adds a WML image

Type: Procedure

Parameters: String sAlt String sSrc String sExtra

Parameter | Description
sAlt | value for alt= option of IMG tag
sSrc | value for src= option of IMG tag
sExtra | value for optional extra portion of IMG tag

Description

WriteWmlImg adds a WML image. The WML equivalent of:

<img alt=sAlt src=sSrc sExtra/>

VDF Code

String sAlt sSrc sExtra
Send WriteWmlImg sAlt sSrc sExtra

Script Code

<img alt=sAlt src=sSrc sExtra/>

Last Edited: September 15, 2003


cWmlreport [Procedure WriteWmlRowBegin]

WriteWmlRowBegin - cWmlreport

Outputs a "begin" row WML string

Type: Procedure

Parameters: No Parameters

Description

WriteWmlRowBegin outputs a "begin" row WML string. The WML equivalent of:

<tr>

VDF Code

Send WriteWmlRowBegin

Script Code

<tr>

Last Edited: September 15, 2003


cWmlreport [Procedure WriteWmlRowEnd]

WriteWmlRowEnd - cWmlreport

Outputs an end row WML string

Type: Procedure

Parameters: No Parameters

Description

WriteWmlRowEnd outputs an end row WML string. The WML equivalent of:

</tr>

VDF Code

Send WriteWmlRowEnd

Script Code

</tr>

Last Edited: September 15, 2003


cWmlreport [Procedure WriteWmlTableBegin]

WriteWmlTableBegin - cWmlreport

Outputs a "begin" table html string

Type: Procedure

Parameters: String sParams string sPer

Parameter | Description
sParams | additional parameters to use with the tag
sPer | Optional percentage table width (rarely used)

Description

WriteWmlTableBegin outputs a "begin" table html string. The WML equivalent of:

<table border="1" width="99%">

The following two lines are equivalent:

Send WriteWmlTableBegin
Send WriteWml ('<table border="1" width="99%">')

The following two lines are equivalent:

Send WriteWmlTableBegin 'border="0" background="MyImg.gif"''
Send WriteWml '<table border="0" background="MyImg.gif"'>'

VDF Code

Send WriteWmlTableBegin sParams

Script Code

</table>

Last Edited: September 18, 2003


cWmlreport [Procedure WriteWmlTableEnd]

WriteWmlTableEnd - cWmlreport

Outputs an end table wml string

Type: Procedure

Parameters: No Parameters

Description

WriteWmlTableEnd outputs an end table wml string. The WML equivalent of:

</table>

VDF Code

Send WriteWmlTableEnd

Script Code

</table>

Last Edited: September 15, 2003


Properties for cWmlreport

View property list in hierarchical order

Name | Description | Defining Class
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button | cBasicReport
Assigned_Channel |  | cReport
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Error_State |  | cBasicReport
Find_Mode | Maintains the current finding mode | cReport
Footer_Lines | Contains the number of lines in the OnPageBottom image plus the OnPageFooter image plus the OnPageTotal image | cReport
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function | cReport
Last_Rec | (Obsolete) Contains the record number of the last selected record found | cReport
Main_File | Contains the filenumber of the file which the report will use for finding records | cReport
Name | Returns the full name of the object including parentage | cObject
New_Page_State | Set true when a new page is needed | cReport
No_Constrained_Find_State | Determines if constrained record finding should be disabled | cReport
No_Finding_State | Determines how the cReport object will find records | cReport
No_PageCheck_State | Set true when the cReport object is processing a new page | cReport
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found | cReport
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Output_Device | Handles the name of the output device | cBasicReport
Page_Count | Keeps track of the current page number | cReport
Page_End | Determines how many lines on a page are allowed before a page break will occur | cReport
Page_End_State | If this property is set true below the forward send statement in the OnStartingMainReport procedure, then the next page_check will cause an end-of-page/new-page sequence | cReport
Page_Feed | Used by the formfeed procedure | cReport
Page_Footer_Lines | The number of lines in the page_footer image | cReport
Parent | Returns the parent of an object | cObject
pbCanceled | Setting this true will cancel a report | cReport
pbChildReport | Set true if the current cReport object is nested | cReport
pbFindDown | Determines if the report should traverse up or down the index | cReport
pbHasChildReports | Is set true if other reports are nested inside this report object | cReport
pbRefindForSubTotal | Ensures that the subtotal is processed with the last valid record for that break level | cReport
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
phMainReport | Contains the object ID of the outer report | cReport
piConstrainFile | Used when creating reports to limit the printing to a single parent record and the related children | cHtmlReport
piConstrainRecord | (Obsolete) Used when creating reports to limit the printing to a single parent record and the related children | cHtmlReport
piCurrentRecord | (Obsolete) Contains the record number of the current valid record found | cReport
piItemsPerCard | Determines the number of items allowed per WML card |
piLastRecord | (Obsolete) Holds the record that was processed when a report was halted because the maximum number of records was encountered | cWebReport
piMaxCount | Holds the maximum number of records to print | cWebReport
piMaxCountBreakLevel | Determines what is considered to be a "record" when record counting is used to create partial reports | cWebReport
piNumberBreaks | Returns the number of breaks in a report | cReport
piOrdering | Contains the index number which will be used for finding records | cReport
piRecordCount | Contains the number of records found for the current report | cReport
piStartRecord | (Obsolete) Allows you to create partial reports providing a method for creating web report "pages" | cWebReport
piWmlLength | Contains the current length of WML output at the start of a new record |
piWmlMaxLength | Determines the maximum suggested length for output |
priConstrainRowId | Used when creating reports to limit the printing to a single parent record and the related children | cHtmlReport
priCurrentRec | Contains the RowId of the current valid record found | cReport
priFoundRec | Contains the RowId of the record found by the find_rec function | cReport
priLastRec | Contains the RowId of the last selected record found | cReport
priLastRowId | Holds the RowId of the record that was processed when a report was halted because the maximum number of records was encountered | cWebReport
priStartRowId | Determines the RowId of the first record of a report allowing you to create partial web reports | cWebReport
psHRefName | Holds the full URL of a file (ASP or HTML) to be displayed as part of a "drill down" operation | cWebReport
Report_Caption | Contains the text that will appear in the status panel's caption bar | cBasicReport
Report_Channel | Determines which output channel will be used for your report output | cReport
Report_Footer_Lines | The number of lines in the OnReportFooter image | cReport
Report_Message | An additional message area that will appear below the report_title in the status panel | cBasicReport
Report_Status_Panel |  | cBasicReport
Report_Title | A centered title that appears in the status panel | cBasicReport
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing | cReport
Server | Identifies the object handle that is used as the report object's main data-dictionary object | cReportDS
Status_Log_Id | Object ID of status-log object | cBasicReport
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs | cBasicReport
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs | cBasicReport
Sub_Totaling_State | Set true when the cReport object is processing subtotals or totals | cReport


cWmlreport [Property piItemsPerCard]

piItemsPerCard - cWmlreport

Determines the number of items allowed per WML card

Type: Property

Access: Read/Write

Data Type: Integer

Description

The piItemsPerCard property determines the number of items allowed per WML card.

BreakPoints:
The limited size of a WML deck makes it unlikely that you would create reports with many or possibly even any breakpoint levels.

If you set piItemsPerCard, a single breakpoint is created for you and is called each time the card reaches the maximum number of items. The breakpoint calls OnSubHeader1..n and OnSubTotal1..n. You will be expected to put any special code that deals with creating new cards in these events. If you set piItemsPerCard to a non-zero value, it is not expected that you will create any other breakpoints -- you get the one automatic breakpoint and that is it. If the value of piItemsPerCard is zero, you can create breakpoints exactly like you would in a cWebReport.

This property should be set in the cWmlReport object.

Last Edited: September 11, 2003


cWmlreport [Property piWmlLength]

piWmlLength - cWmlreport

Contains the current length of WML output at the start of a new record

Type: Property

Access: Read/Write

Data Type: Integer

Description

piWmlLength contains the current length of WML output at the start of a new record.

This property is a read-only property.

This property can be used to check how many characters have been output by the report. It is maintained by procedure WriteWML.

Last Edited: September 11, 2003


cWmlreport [Property piWmlMaxLength]

piWmlMaxLength - cWmlreport

Determines the maximum suggested length for output

Type: Property

Access: Read/Write

Data Type: Integer

Description

piWmlMaxLength determines the maximum suggested length for output. If set to 0, there is no limit.

This property should be set in the cWmlReport object.

Last Edited: September 11, 2003


Events for cWorkspace

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cWorkspace [Function CountOfPaths]

CountOfPaths - cWorkspace

Returns the number of paths present in a string of paths

Type: Function

Return Data Type: Integer

Parameters: String sPaths

Parameter | Description
sPaths | a semi-colon delimited string containing one or more paths

Return Value

Returns the number of paths.

Description

CountOfPaths returns the number of paths present in a string of paths. Paths are delimited by semi-colons. So, for example, if sPaths contained "..\AppSrc;c:\", then CountOfPaths would return 2.

Once you know the number of paths, you can enumerate through them using PathAtIndex.

See Also

PathAtIndex

Last Edited: July 31, 2003


cWorkspace [Function GetWorkspaceFileName]

GetWorkspaceFileName - cWorkspace

Returns the name of the physical Workspace file for a Workspace name

Type: Function

Return Data Type: String

Parameters: String sWorkspace

Parameter | Description
sWorkspace | Name of the Workspace to retrieve the file-name of

Return Value

Returns the name of the physical Workspace file for a Workspace name

Description

The GetWorkspaceFileName function returns the name of the physical Workspace file for a Workspace name. The sWorkspace parameter is the name of a Workspace that must be registered in the global Workspace list.

Last Edited: June 23, 2005


cWorkspace [Function IsRegistered]

IsRegistered - cWorkspace

Determines whether a Workspace is registered

Type: Function

Return Data Type: Boolean

Parameters: String sWorkspace

Parameter | Description
sWorkspace | Name of the Workspace

Return Value

If the Workspace is registered, then the function returns True, otherwise it returns False

Description

The IsRegistered function searches the global list of Workspaces to see if the Workspace is registered.

Last Edited: August 18, 2003


cWorkspace [Function OpenWorkspace]

OpenWorkspace - cWorkspace

Opens a registered Workspace

Type: Function

Return Data Type: Integer

Parameters: String sWorkspace

Parameter | Description
sWorkspace | Name of the Workspace to open

Return Value

A contant (described below) indicating success or failure

Description

The OpenWorkspace function opens a registered Workspace. The sWorkspace parameter represents the name of the Workspace, which must exist in the global list of registered Workspaces. If you want to open a Workspace that is not registered, use OpenWorkspaceFile instead (or use the cApplication's DoOpenWorkspace method).
The return value is one of the following constants:

Constant | Meaning
wsWorkspaceOpened | The Workspace was opened ok
wsWorkspaceNotFound | The named Workspace was not found in the global list of registered Workspaces.
wsWorkspaceFileNotFound | The file describing the Workspace(*.WS) was not found
wsDataPathEmpty | The DataPath entry was empty
wsFileListEmpty | The FileList entry was empty
wsFileListNotExist | The FileList.cfg file could not be found

If the return value is not wsWorkspaceOpened, you can retrieve a description of the error by calling OpenWorkspaceErrorMessage and passing it the error code.

In this example, the program attempts to open a Workspace named "ABC, Inc.Accounts". If it fails, it informs the user why and aborts:

Object oApplication is a cApplication

    Procedure OnCreate
        Handle hoWorkspace
        Integer eOpened
        String sError

        Get phoWorkspace To hoWorkspace

        Get OpenWorkspace of hoWorkspace "ABC, Inc.Accounts" To eOpened
        If (eOpened <> wsWorkspaceOpened) Begin
            Get OpenWorkspaceErrorMessage of hoWorkspace eOpened To sError
            Send Stop_Box sError "Error Opening Workspace"
            Abort
        End

    End_Procedure  // OnCreate

End_Object  // oApplication

Note:

See Also

DoOpenWorkspace | OpenWorkspaceFile | OpenWorkspaceErrorMessage

Last Edited: June 23, 2005


cWorkspace [Function OpenWorkspaceErrorMessage]

OpenWorkspaceErrorMessage - cWorkspace

Returns a description for an error code that was returned opening a Workspace

Type: Function

Return Data Type: String

Parameters: Integer eErrorCode

Parameter | Description
eErrorCode | an error-code constant that you want the natural-language description of

Return Value

A natural-langage description of the error.

Description

OpenWorkspaceErrorMessage returns a natural-language description for an error code that was returned opening a Workspace, which is useful for giving users detailed reasons for the failure.

For example, if you passed wsWorkspaceNotFound as the eErrorCode parameter, then the return might be something similar to "The Workspace name was not found in the list of registered Workspaces."

Note:If you use cApplication's DoOpenWorkspace, then that method will automatically show the error translation before aborting.

In this example, an attempt is made to open a Workspace; if it fails, the error code is translated to a meaningful description and displayed:

Object oApplication is a cApplication

    Procedure OnCreate
        Handle hoWorkspace
        Integer eOpened
        String sError

        Get phoWorkspace To hoWorkspace

        Get OpenWorkspace of hoWorkspace "ABC, Inc.Accounts" To eOpened
        If (eOpened <> wsWorkspaceOpened) Begin
            Get OpenWorkspaceErrorMessage of hoWorkspace eOpened To sError
            Send Stop_Box sError "Error Opening Workspace"
            Abort
        End
    End_Procedure  // OnCreate

End_Object  // oApplication

See Also

DoOpenWorkspace

Last Edited: June 23, 2005


cWorkspace [Function OpenWorkspaceFile]

OpenWorkspaceFile - cWorkspace

Opens a Workspace using its filename

Type: Function

Return Data Type: Integer

Parameters: String sWorkspaceFile

Parameter | Description
sWorkspaceFile | Name of the Workspace file

Return Value

A contant (described below) indicating success or failure

Description

The OpenWorkspaceFile function opens a Workspace by directly reading the file that describes it. If you want to open a Workspace that is registered, use OpenWorkspace instead.

The name of the Workspace file can optionally contain its extension (*.ws) and it can be qualified or non-qualified. If the name is non-qualified, then the class will look in the directory that the program started in for the file; if the name is qualified (that is, it contains a path in addition to a name), then it will look in that path for the file.

The return value is one of the following constants:

Constant | Meaning
wsWorkspaceOpened | The Workspace was opened ok
wsWorkspaceFileNotFound | The file describing the Workspace(*.WS) was not found
wsDataPathEmpty | The DataPath entry was empty
wsFileListEmpty | The FileList entry was empty
wsFileListNotExist | The FileList.cfg file could not be found

If the return value is not wsWorkspaceOpened, you can retrieve a description of the error by calling OpenWorkspaceErrorMessage and passing it the error code.

In this example, the program attempts to open a Workspace file named "ABC, Inc.Accounts.ws". If it fails, it informs the user why and aborts:

Object oApplication is a cApplication

    Procedure OnCreate
        Handle hoWorkspace
        Integer eOpened
        String sError

        Get phoWorkspace To hoWorkspace

        Get OpenWorkspaceFile of hoWorkspace "ABC, Inc.Accounts" To eOpened
        If (eOpened <> wsWorkspaceOpened) Begin
            Get OpenWorkspaceErrorMessage of hoWorkspace eOpened To sError
            Send Stop_Box sError "Error Opening Workspace"
            Abort
        End

    End_Procedure  // OnCreate

End_Object  // oApplication

Note:If DoOpenWorkspaceFile (and thus DoOpenWorkspace) is executed twice or more, all tables in the application are closed and should be reopened using custom code. Do not forget in these cases to apply any other attributes to the tabls being opened, such as manual relationships (using Set_Relate) or master/alias table attrbutes (using Set_Attribute DF_File_Alias). Such attributes are lost when tables are closed.

See Also

OpenWorkspace

Last Edited: February 16, 2005


cWorkspace [Function PathAtIndex]

PathAtIndex - cWorkspace

Returns a single path from a string containing multiple delimited paths

Type: Function

Return Data Type: String

Parameters: String sPaths Integer iIndex

Parameter | Description
sPaths | A string containing multiple paths
iIndex | One-based index of the path to retrieve

Return Value

A single path from the string of paths.

Description

The PathAtIndex function is used to return a single path from a string containing multiple semi-colon delimited paths.

Use CountOfPaths to retrieve the number of paths in a string and use this function to retrieve them individually.

This example shows the paths contained in psDfPath after opening a Workspace:

Object oApplication is a cApplication

    Procedure OnCreate
        Handle hoWorkspace
        Integer eOpened iPath iNumPaths
        String sError sDfPath sPath

        Get phoWorkspace To hoWorkspace

        Get OpenWorkspace of hoWorkspace "ABC, Inc.Accounts" To eOpened
        If (eOpened = wsWorkspaceOpened) Begin
            Get psDfPath of hoWorkspace To sDfPath
            Get CountOfPaths of hoWorkspace sDfPath To iNumPaths

            For iPath from 1 To iNumPaths
                Get PathAtIndex of hoWorkspace sDfPath iPath To sPath
                Showln iPath ": " sPath
            Loop
        End
        Else Begin // Workspace not opened
            Get OpenWorkspaceErrorMessage of hoWorkspace eOpened To sError
            Send Stop_Box sError "Error Opening Workspace"
            Abort
        End

    End_Procedure

End_Object

Another typical use of this function is to return the first path of one of the properties that contains multiple paths. In this example, if you wanted to set the Initial_Folder property of an OpenDialog to the first bitmap path, this is what you would do:

// Assumes you have an open Workspace and a OpenDialog instance called oOpenDialog

Get phoWorkspace of ghoApplication To hoWorkspace
Get psBitmapPath of hoWorkspace To sBitmapPath
Get PathAtIndex of hoWorkspace sBitmapPath 1 To sPath
Set Initial_Folder of oOpenDialog To sPath

See Also

CountOfPaths

Last Edited: September 10, 2003


Methods for cWorkspace

View method list in hierarchical order

Name | Type | Description | Defining Class
CountOfPaths | Function | Returns the number of paths present in a string of paths |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DoAssignPaths | Procedure | Automatically called when a Workspace is opened to set the psDfPath property |
DoClearPaths | Procedure | Clears all properties associated with opening a new Workspace |
DoSetPaths | Procedure | Automatically sets the Filelist and Dfpath for the program, when a Workspace is opened |
EnumerateWorkspaceData | Procedure | Sends information about the current Workspace to another object |
Exit_Application | Procedure | Starts the process of closing an application | cObject
GetWorkspaceFileName | Function | Returns the name of the physical Workspace file for a Workspace name |
IsRegistered | Function | Determines whether a Workspace is registered |
OpenWorkspace | Function | Opens a registered Workspace |
OpenWorkspaceErrorMessage | Function | Returns a description for an error code that was returned opening a Workspace |
OpenWorkspaceFile | Function | Opens a Workspace using its filename |
PathAtIndex | Function | Returns a single path from a string containing multiple delimited paths |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


cWorkspace [Procedure DoAssignPaths]

DoAssignPaths - cWorkspace

Automatically called when a Workspace is opened to set the psDfPath property

Type: Procedure

Parameters: No Parameters

Description

The DoAssignPaths procedure concatenates the following properties, in order, to set the psDfPath property:

psDataPath, psBitmapPath, psHelpPath, psProgramPath, psSystemDfPath.

Last Edited: July 31, 2003


cWorkspace [Procedure DoClearPaths]

DoClearPaths - cWorkspace

Clears all properties associated with opening a new Workspace

Type: Procedure

Parameters: No Parameters

Description

Use the DoClearPaths procedure to clear the values of all properties associated with opening a new Workspace. You should call this procedure before opening a new Workspace, if you already have one open, otherwise the properties will not be populated with the paths of the Workspace being opened. Remember, the properties are only set if, when opening a new Workspace, the properties don't have values already stored in them.

If you choose not to send this procedure when opening a new Workspace, any values already in the properties will not be overwritten by the values from the Workspace file. This can provide great flexibility in how Workspace paths are constructed within the class.

Last Edited: July 31, 2003


cWorkspace [Procedure DoSetPaths]

DoSetPaths - cWorkspace

Automatically sets the Filelist and Dfpath for the program, when a Workspace is opened

Type: Procedure

Parameters: No Parameters

Description

The DoSetPaths procedure automatically sets the Filelist and Dfpath for the program, when a Workspace is opened. The Filelist is the list of data tables that your programs use, and Dfpath is a list of paths that the runtime will use to find files.

The Filelist is set by setting the Attribute DF_FILELIST_NAME to the value of psFileList. The Dfpath is set by setting the Attribute DF_OPEN_PATH to the value of psDfPath.

Last Edited: August 5, 2003


cWorkspace [Procedure EnumerateWorkspaceData]

EnumerateWorkspaceData - cWorkspace

Sends information about the current Workspace to another object

Type: Procedure

Parameters: Handle hoCallBack Handle hmGeneric

Parameter | Description
hoCallBack | Object handle of an object that you want the information sent to
hmGeneric | Message handle of a message that you want to send

Description

EnumerateWorkspaceData sends information about the current Workspace to another object. This procedure is used internally by the AboutDialog class to provide information about the Workspace to the "About" box of your program.

Last Edited: August 13, 2003


Properties for cWorkspace

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psAppHtmlPath | Contains the path(s) of the Workspace used to store HTML and associated files |
psAppSrcPath | Contains the path(s) of the Workspace used to store the application source code |
psBitmapPath | Contains the path(s) of the Workspace used to store the bitmaps (and other media) |
psDataPath | Contains the path(s) of the Workspace used to store the application's tables |
psDdSrcPath | Contains the path(s) of the Workspace used to store the Data-Dictionaries and related files |
psDescription | Contains the description of the Workspace |
psDfPath | A string of all the paths that will constitute the program's DFPATH |
psFileList | Contains the path and name of the Filelist.cfg that your program should use |
psHelpPath | Contains the path(s) of the Workspace used to store the help-related files |
psHome | Contains the path that the Workspace should use as its "home" |
psIdeSrcPath | Contains the path(s) of the Workspace used to store the code that the Studio uses during development. |
psProgramPath | Contains the path(s) of the Workspace used to store the compiled programs. |
psSystemDfPath | A string of the paths that are used in every Workspace for finding files at runtime |
psSystemMakePath | A string of the paths that are used in every Workspace for finding files at compile-time |
psWorkspaceName | The name of the current open Workspace |
psWorkspaceWSFile | Contains the full path name of the workspace (.ws) file |


cWorkspace [Property psAppHtmlPath]

psAppHtmlPath - cWorkspace

Contains the path(s) of the Workspace used to store HTML and associated files

Type: Property

Access: Read/Write

Data Type: String

Description

The psAppHtmlPath property will not have a value until a Workspace has been opened (using, for example, the OpenWorkspace or OpenWorkspaceFile functions). You can also set this property before opening a Workspace. When you do, this property will not be modified during the opening of a Workspace.

The value of this property corresponds to the AppHtmlPath entry in the Workspace file; however, it differs in that while the entry in the Workspace file can contain relative paths, this property will always contain the paths fully qualified.

You can discover how many paths are contained in this property by using the CountOfPaths function, and you can retrieve an individual path by using the PathAtIndex function.

Last Edited: September 11, 2003


cWorkspace [Property psAppSrcPath]

psAppSrcPath - cWorkspace

Contains the path(s) of the Workspace used to store the application source code

Type: Property

Access: Read/Write

Data Type: String

Description

The psAppSrcPath property will not have a value until a Workspace has been opened (using, for example, the OpenWorkspace or OpenWorkspaceFile functions). You can also set this property before opening a Workspace. When you do, this property will not be modified during the opening of a Workspace.

The value of this property corresponds to the AppSrcPath entry in the Workspace file; however, it differs in that while the entry in the Workspace file can contain relative paths, this property will always contain the paths fully qualified.

You can discover how many paths are contained in this property by using the CountOfPaths function, and you can retrieve an individual path by using the PathAtIndex function.

Last Edited: September 11, 2003


cWorkspace [Property psBitmapPath]

psBitmapPath - cWorkspace

Contains the path(s) of the Workspace used to store the bitmaps (and other media)

Type: Property

Access: Read/Write

Data Type: String

Description

The psBitmapPath property will not have a value until a Workspace has been opened (using, for example, the OpenWorkspace or OpenWorkspaceFile functions). You can also set this property before opening a Workspace. When you do, this property will not be modified during the opening of a Workspace.

The value of this property corresponds to the BitmapPath entry in the Workspace file; however, it differs in that while the entry in the Workspace file can contain relative paths, this property will always contain the paths fully qualified.

You can discover how many paths are contained in this property by using the CountOfPaths function, and you can retrieve an individual path by using the PathAtIndex function.

Last Edited: September 11, 2003


cWorkspace [Property psDataPath]

psDataPath - cWorkspace

Contains the path(s) of the Workspace used to store the application's tables

Type: Property

Access: Read/Write

Data Type: String

Description

The psDataPath property will not have a value until a Workspace has been opened (using, for example, the OpenWorkspace or OpenWorkspaceFile functions). You can also set this property before opening a Workspace. When you do, this property will not be modified during the opening of a Workspace.

The value of this property corresponds to the DataPath entry in the Workspace file; however, it differs in that while the entry in the Workspace file can contain relative paths, this property will always contain the paths fully qualified.

You can discover how many paths are contained in this property by using the CountOfPaths function, and you can retrieve an individual path by using the PathAtIndex function.

Last Edited: December 16, 2004


cWorkspace [Property psDdSrcPath]

psDdSrcPath - cWorkspace

Contains the path(s) of the Workspace used to store the Data-Dictionaries and related files

Type: Property

Access: Read/Write

Data Type: String

Description

The psDdSrcPath property will not have a value until a Workspace has been opened (using, for example, the OpenWorkspace or OpenWorkspaceFile functions). You can also set this property before opening a Workspace. When you do, this property will not be modified during the opening of a Workspace.

The value of this property corresponds to the DdSrcPath entry in the Workspace file; however, it differs in that while the entry in the Workspace file can contain relative paths, this property will always contain the paths fully qualified.

You can discover how many paths are contained in this property by using the CountOfPaths function, and you can retrieve an individual path by using the PathAtIndex function.

Last Edited: September 11, 2003


cWorkspace [Property psDescription]

psDescription - cWorkspace

Contains the description of the Workspace

Type: Property

Access: Read/Write

Data Type: String

Description

The psDescription property will not have a value until a Workspace has been opened (using, for example, the OpenWorkspace or OpenWorkspaceFile functions). You can also set this property before opening a Workspace. When you do, this property will not be modified during the opening of a Workspace.

The value of this property corresponds to the Description entry in the Workspace file.

Last Edited: September 11, 2003


cWorkspace [Property psDfPath]

psDfPath - cWorkspace

A string of all the paths that will constitute the program's DFPATH

Type: Property

Access: Read/Write

Data Type: String

Description

The psDfPath property contains a semi-colon delimited string of all the paths that will constitute the program's DFPATH (the paths that will be searched for files at runtime). This property is automatically set during the DoAssignPaths method and used during the DoSetPaths method.

Last Edited: September 11, 2003


cWorkspace [Property psFileList]

psFileList - cWorkspace

Contains the path and name of the Filelist.cfg that your program should use

Type: Property

Access: Read/Write

Data Type: String

Description

The psFileList property will not have a value until a Workspace has been opened (using, for example, the OpenWorkspace or OpenWorkspaceFile functions). You can also set this property before opening a Workspace. When you do, this property will not be modified during the opening of a Workspace.

The value of this property corresponds to the FileList entry in the Workspace file; however, it differs in that while the entry in the Workspace file can contain a relative path, this property will always contain the path fully qualified.

Last Edited: September 11, 2003


cWorkspace [Property psHelpPath]

psHelpPath - cWorkspace

Contains the path(s) of the Workspace used to store the help-related files

Type: Property

Access: Read/Write

Data Type: String

Description

The psHelpPath property will not have a value until a Workspace has been opened (using, for example, the OpenWorkspace or OpenWorkspaceFile functions). You can also set this property before opening a Workspace. When you do, this property will not be modified during the opening of a Workspace.

The value of this property corresponds to the HelpPath entry in the Workspace file; however, it differs in that while the entry in the Workspace file can contain relative paths, this property will always contain the paths fully qualified.

You can discover how many paths are contained in this property by using the CountOfPaths function, and you can retrieve an individual path by using the PathAtIndex function.

Last Edited: September 11, 2003


cWorkspace [Property psHome]

psHome - cWorkspace

Contains the path that the Workspace should use as its "home"

Type: Property

Access: Read/Write

Data Type: String

Description

The psHome property contains the path that the Workspace should use as its "home." That is, the single directory that will be used to offset the relative paths of the properties containing paths (psDataPath, for example.)

This property will not have a value until a Workspace has been opened (using, for example, the OpenWorkspace or OpenWorkspaceFile functions). You can also set this property before opening a Workspace. When you do, this property will not be modified during the opening of a Workspace.

The value of this property corresponds to the Home entry in the Workspace file; however, it differs in that while the entry in the Workspace file can contain a relative path, this property will always contain the path fully qualified.

Last Edited: September 11, 2003


cWorkspace [Property psIdeSrcPath]

psIdeSrcPath - cWorkspace

Contains the path(s) of the Workspace used to store the code that the Studio uses during development.

Type: Property

Access: Read/Write

Data Type: String

Description

The psIdeSrcPath property will not have a value until a Workspace has been opened (using, for example, the OpenWorkspace or OpenWorkspaceFile functions). You can also set this property before opening a Workspace. When you do, this property will not be modified during the opening of a Workspace.

The value of this property corresponds to the IdeSrcPath entry in the Workspace file; however, it differs in that while the entry in the Workspace file can contain relative paths, this property will always contain the paths fully qualified.

You can discover how many paths are contained in this property by using the CountOfPaths function, and you can retrieve an individual path by using the PathAtIndex function.

Last Edited: February 18, 2004


cWorkspace [Property psProgramPath]

psProgramPath - cWorkspace

Contains the path(s) of the Workspace used to store the compiled programs.

Type: Property

Access: Read/Write

Data Type: String

Description

The psProgramPath property will not have a value until a Workspace has been opened (using, for example, the OpenWorkspace or OpenWorkspaceFile functions). You can also set this property before opening a Workspace. When you do, this property will not be modified during the opening of a Workspace.

The value of this property corresponds to the ProgramPath entry in the Workspace file; however, it differs in that while the entry in the Workspace file can contain relative paths, this property will always contain the paths fully qualified.

You can discover how many paths are contained in this property by using the CountOfPaths function, and you can retrieve an individual path by using the PathAtIndex function.

Last Edited: September 11, 2003


cWorkspace [Property psSystemDfPath]

psSystemDfPath - cWorkspace

A string of the paths that are used in every Workspace for finding files at runtime

Type: Property

Access: Read/Write

Data Type: String

Description

psSystemDfPath contains a semi-colon delimited string of the paths that are used in every Workspace for finding files at runtime. This value typically contains the DataFlex system directories (Lib\ and Usr\, etc.) and you can add to this your own, or third-party, directories that you always want searched at runtime. This value is maintained in the Studio.

This property is automatically set when you open a Workspace (using, for example, the OpenWorkspace or OpenWorkspaceFile functions), unless it already has a value, and is used during DoAssignPaths to help create the psDfPath property.

Last Edited: February 18, 2004


cWorkspace [Property psSystemMakePath]

psSystemMakePath - cWorkspace

A string of the paths that are used in every Workspace for finding files at compile-time

Type: Property

Access: Read/Write

Data Type: String

Description

psSystemMakePath contains a semi-colon delimited string of the paths that are used in every Workspace for finding files at compile-time. This value typically contains the DataFlex system directories (Pkg\ and Usr\, etc.) and you can add to this your own, or third-party, directories that you always want searched at runtime. This value is maintained in the Studio.

This property is automatically set when you open a Workspace (using, for example, the OpenWorkspace or OpenWorkspaceFile functions), unless it already has a value.

Note that the class does not actually use this property to set its paths (unlike psSystemDfPath). It is provided so that you can obtain these paths if you need them in a program.

Last Edited: February 18, 2004


cWorkspace [Property psWorkspaceName]

psWorkspaceName - cWorkspace

The name of the current open Workspace

Type: Property

Access: Read/Write

Data Type: String

Description

The psWorkspaceName property is set to the name of the Workspace that you open (using, for example, the OpenWorkspace or OpenWorkspaceFile functions.)

Last Edited: September 11, 2003


cWorkspace [Property psWorkspaceWSFile]

psWorkspaceWSFile - cWorkspace

Contains the full path name of the workspace (.ws) file

Type: Property

Access: Read/Write

Data Type: String

Description

Contains the full path name of the workspace (.ws) file.

Last Edited: July 26, 2006


Events for cXMLDOMAttribute

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMAttribute [Function AddAttributeNode]

AddAttributeNode - cXMLDOMAttribute

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMAttribute [Function AddChildNode]

AddChildNode - cXMLDOMAttribute

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMAttribute [Function AddElement]

AddElement - cXMLDOMAttribute

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMAttribute [Function AddElementNS]

AddElementNS - cXMLDOMAttribute

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMAttribute [Function AppendNode]

AppendNode - cXMLDOMAttribute

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMAttribute [Function AttributeNodes]

AttributeNodes - cXMLDOMAttribute

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMAttribute [Function AttributeValueNode]

AttributeValueNode - cXMLDOMAttribute

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMAttribute [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMAttribute

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMAttribute [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMAttribute

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMAttribute [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMAttribute

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMAttribute [Function ChildElementNS]

ChildElementNS - cXMLDOMAttribute

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMAttribute [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMAttribute

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMAttribute [Function ChildNodes]

ChildNodes - cXMLDOMAttribute

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMAttribute [Function ChildNodeValue]

ChildNodeValue - cXMLDOMAttribute

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMAttribute [Function CloneNode]

CloneNode - cXMLDOMAttribute

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMAttribute [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMAttribute

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMAttribute [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMAttribute

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMAttribute [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMAttribute

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMAttribute [Function CreateChildComment]

CreateChildComment - cXMLDOMAttribute

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMAttribute [Function CreateChildNode]

CreateChildNode - cXMLDOMAttribute

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMAttribute [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMAttribute

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMAttribute [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMAttribute

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMAttribute [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMAttribute

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMAttribute [Function CreateElementNode]

CreateElementNode - cXMLDOMAttribute

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMAttribute [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMAttribute

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMAttribute [Function ElementNodes]

ElementNodes - cXMLDOMAttribute

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMAttribute [Function FindNode]

FindNode - cXMLDOMAttribute

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMAttribute [Function FindNodeList]

FindNodeList - cXMLDOMAttribute

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMAttribute [Function FirstChild]

FirstChild - cXMLDOMAttribute

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMAttribute [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMAttribute

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMAttribute [Function IsElementNS]

IsElementNS - cXMLDOMAttribute

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMAttribute [Function LastChild]

LastChild - cXMLDOMAttribute

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMAttribute [Function NextElementNS]

NextElementNS - cXMLDOMAttribute

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMAttribute [Function NextNode]

NextNode - cXMLDOMAttribute

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMAttribute [Function NextSibling]

NextSibling - cXMLDOMAttribute

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMAttribute [Function ParentNode]

ParentNode - cXMLDOMAttribute

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMAttribute [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMAttribute

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMAttribute [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMAttribute

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMAttribute [Function PreviousSibling]

PreviousSibling - cXMLDOMAttribute

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMAttribute [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMAttribute

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMAttribute [Function RemoveNode]

RemoveNode - cXMLDOMAttribute

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMAttribute [Function ReplaceNode]

ReplaceNode - cXMLDOMAttribute

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMAttribute [Function XSLTransformation]

XSLTransformation - cXMLDOMAttribute

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMAttribute [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMAttribute

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMAttribute

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
ParentNode | Function | Returns an object that is the parent of the current node |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMAttribute [Procedure AddAttribute]

AddAttribute - cXMLDOMAttribute

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMAttribute [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMAttribute

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMAttribute [Procedure AddCDataSection]

AddCDataSection - cXMLDOMAttribute

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMAttribute [Procedure AddChildComment]

AddChildComment - cXMLDOMAttribute

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMAttribute [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMAttribute

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMAttribute [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMAttribute

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMAttribute [Procedure AddElement]

AddElement - cXMLDOMAttribute

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMAttribute [Procedure AddElementNS]

AddElementNS - cXMLDOMAttribute

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMAttribute [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMAttribute

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMAttribute [Procedure EnumerateElements]

EnumerateElements - cXMLDOMAttribute

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMAttribute [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMAttribute

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMAttribute [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMAttribute

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMAttribute [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMAttribute

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMAttribute

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psName | Contains the attribute name | BaseXmlDomAttribute
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode
Value | Contains the attribute value | BaseXmlDomAttribute


Events for cXMLDOMCDATASection

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMCDATASection [Function AddAttributeNode]

AddAttributeNode - cXMLDOMCDATASection

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMCDATASection [Function AddChildNode]

AddChildNode - cXMLDOMCDATASection

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMCDATASection [Function AddElement]

AddElement - cXMLDOMCDATASection

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function AddElementNS]

AddElementNS - cXMLDOMCDATASection

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function AppendNode]

AppendNode - cXMLDOMCDATASection

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMCDATASection [Function AttributeNodes]

AttributeNodes - cXMLDOMCDATASection

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMCDATASection [Function AttributeValueNode]

AttributeValueNode - cXMLDOMCDATASection

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMCDATASection [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMCDATASection

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMCDATASection [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMCDATASection

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMCDATASection [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMCDATASection

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMCDATASection [Function ChildElementNS]

ChildElementNS - cXMLDOMCDATASection

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMCDATASection

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function ChildNodes]

ChildNodes - cXMLDOMCDATASection

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMCDATASection [Function ChildNodeValue]

ChildNodeValue - cXMLDOMCDATASection

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMCDATASection [Function CloneNode]

CloneNode - cXMLDOMCDATASection

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMCDATASection [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMCDATASection

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMCDATASection [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMCDATASection

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMCDATASection [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMCDATASection

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMCDATASection [Function CreateChildComment]

CreateChildComment - cXMLDOMCDATASection

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMCDATASection [Function CreateChildNode]

CreateChildNode - cXMLDOMCDATASection

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMCDATASection [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMCDATASection

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMCDATASection [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMCDATASection

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMCDATASection [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMCDATASection

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMCDATASection [Function CreateElementNode]

CreateElementNode - cXMLDOMCDATASection

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMCDATASection

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function ElementNodes]

ElementNodes - cXMLDOMCDATASection

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMCDATASection [Function FindNode]

FindNode - cXMLDOMCDATASection

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMCDATASection [Function FindNodeList]

FindNodeList - cXMLDOMCDATASection

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMCDATASection [Function FirstChild]

FirstChild - cXMLDOMCDATASection

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMCDATASection [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMCDATASection

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMCDATASection [Function IsElementNS]

IsElementNS - cXMLDOMCDATASection

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function LastChild]

LastChild - cXMLDOMCDATASection

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMCDATASection [Function NextElementNS]

NextElementNS - cXMLDOMCDATASection

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function NextNode]

NextNode - cXMLDOMCDATASection

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMCDATASection [Function NextSibling]

NextSibling - cXMLDOMCDATASection

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMCDATASection [Function ParentNode]

ParentNode - cXMLDOMCDATASection

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMCDATASection [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMCDATASection

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMCDATASection [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMCDATASection

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function PreviousSibling]

PreviousSibling - cXMLDOMCDATASection

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMCDATASection [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMCDATASection

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function RemoveNode]

RemoveNode - cXMLDOMCDATASection

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function ReplaceNode]

ReplaceNode - cXMLDOMCDATASection

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function XSLTransformation]

XSLTransformation - cXMLDOMCDATASection

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMCDATASection [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMCDATASection

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMCDATASection

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
ParentNode | Function | Returns an object that is the parent of the current node |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMCDATASection [Procedure AddAttribute]

AddAttribute - cXMLDOMCDATASection

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMCDATASection [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMCDATASection

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMCDATASection [Procedure AddCDataSection]

AddCDataSection - cXMLDOMCDATASection

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMCDATASection [Procedure AddChildComment]

AddChildComment - cXMLDOMCDATASection

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMCDATASection [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMCDATASection

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMCDATASection [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMCDATASection

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMCDATASection [Procedure AddElement]

AddElement - cXMLDOMCDATASection

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMCDATASection [Procedure AddElementNS]

AddElementNS - cXMLDOMCDATASection

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMCDATASection [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMCDATASection

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMCDATASection [Procedure EnumerateElements]

EnumerateElements - cXMLDOMCDATASection

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMCDATASection [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMCDATASection

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMCDATASection [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMCDATASection

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMCDATASection [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMCDATASection

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMCDATASection

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piLength | Returns the number of characters in the data string | BaseXmlDomCharacterData
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for cXMLDOMComment

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMComment [Function AddAttributeNode]

AddAttributeNode - cXMLDOMComment

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMComment [Function AddChildNode]

AddChildNode - cXMLDOMComment

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMComment [Function AddElement]

AddElement - cXMLDOMComment

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMComment [Function AddElementNS]

AddElementNS - cXMLDOMComment

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMComment [Function AppendNode]

AppendNode - cXMLDOMComment

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMComment [Function AttributeNodes]

AttributeNodes - cXMLDOMComment

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMComment [Function AttributeValueNode]

AttributeValueNode - cXMLDOMComment

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMComment [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMComment

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMComment [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMComment

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMComment [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMComment

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMComment [Function ChildElementNS]

ChildElementNS - cXMLDOMComment

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMComment [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMComment

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMComment [Function ChildNodes]

ChildNodes - cXMLDOMComment

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMComment [Function ChildNodeValue]

ChildNodeValue - cXMLDOMComment

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMComment [Function CloneNode]

CloneNode - cXMLDOMComment

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMComment [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMComment

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMComment [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMComment

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMComment [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMComment

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMComment [Function CreateChildComment]

CreateChildComment - cXMLDOMComment

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMComment [Function CreateChildNode]

CreateChildNode - cXMLDOMComment

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMComment [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMComment

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMComment [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMComment

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMComment [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMComment

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMComment [Function CreateElementNode]

CreateElementNode - cXMLDOMComment

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMComment [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMComment

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMComment [Function ElementNodes]

ElementNodes - cXMLDOMComment

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMComment [Function FindNode]

FindNode - cXMLDOMComment

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMComment [Function FindNodeList]

FindNodeList - cXMLDOMComment

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMComment [Function FirstChild]

FirstChild - cXMLDOMComment

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMComment [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMComment

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMComment [Function IsElementNS]

IsElementNS - cXMLDOMComment

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMComment [Function LastChild]

LastChild - cXMLDOMComment

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMComment [Function NextElementNS]

NextElementNS - cXMLDOMComment

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMComment [Function NextNode]

NextNode - cXMLDOMComment

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMComment [Function NextSibling]

NextSibling - cXMLDOMComment

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMComment [Function ParentNode]

ParentNode - cXMLDOMComment

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMComment [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMComment

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMComment [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMComment

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMComment [Function PreviousSibling]

PreviousSibling - cXMLDOMComment

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMComment [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMComment

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMComment [Function RemoveNode]

RemoveNode - cXMLDOMComment

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMComment [Function ReplaceNode]

ReplaceNode - cXMLDOMComment

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMComment [Function XSLTransformation]

XSLTransformation - cXMLDOMComment

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMComment [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMComment

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMComment

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
ParentNode | Function | Returns an object that is the parent of the current node |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMComment [Procedure AddAttribute]

AddAttribute - cXMLDOMComment

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMComment [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMComment

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMComment [Procedure AddCDataSection]

AddCDataSection - cXMLDOMComment

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMComment [Procedure AddChildComment]

AddChildComment - cXMLDOMComment

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMComment [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMComment

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMComment [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMComment

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMComment [Procedure AddElement]

AddElement - cXMLDOMComment

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMComment [Procedure AddElementNS]

AddElementNS - cXMLDOMComment

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMComment [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMComment

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMComment [Procedure EnumerateElements]

EnumerateElements - cXMLDOMComment

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMComment [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMComment

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMComment [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMComment

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMComment [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMComment

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMComment

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piLength | Returns the number of characters in the data string | BaseXmlDomCharacterData
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for cXMLDOMDocument

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMDocument [Function AddAttributeNode]

AddAttributeNode - cXMLDOMDocument

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMDocument [Function AddChildNode]

AddChildNode - cXMLDOMDocument

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMDocument [Function AddElement]

AddElement - cXMLDOMDocument

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMDocument [Function AddElementNS]

AddElementNS - cXMLDOMDocument

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMDocument [Function AppendNode]

AppendNode - cXMLDOMDocument

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMDocument [Function AttributeNodes]

AttributeNodes - cXMLDOMDocument

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMDocument [Function AttributeValueNode]

AttributeValueNode - cXMLDOMDocument

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMDocument [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMDocument

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMDocument [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMDocument

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMDocument [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMDocument

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMDocument [Function ChildElementNS]

ChildElementNS - cXMLDOMDocument

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMDocument [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMDocument

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMDocument [Function ChildNodes]

ChildNodes - cXMLDOMDocument

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMDocument [Function ChildNodeValue]

ChildNodeValue - cXMLDOMDocument

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMDocument [Function CloneNode]

CloneNode - cXMLDOMDocument

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMDocument [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMDocument

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMDocument [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMDocument

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMDocument [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMDocument

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocument [Function CreateChildComment]

CreateChildComment - cXMLDOMDocument

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocument [Function CreateChildNode]

CreateChildNode - cXMLDOMDocument

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMDocument [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMDocument

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocument [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMDocument

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocument [Function CreateDocumentElement]

CreateDocumentElement - cXMLDOMDocument

Sets up the first element in a document

Type: Function

Return Data Type: Handle

Parameters: String sTagName

Parameter | Description
sTagName | Tag name of root element

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateDocumentElementis not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use CreateDocumentElementNS in its place.

CreateDocumentElement is used to set up the first element in a document. It should only be used when creating a new XML Document.

See Also

CreateDocumentElementNS

Last Edited: April 8, 2004


cXMLDOMDocument [Function CreateDocumentElementNS]

CreateDocumentElementNS - cXMLDOMDocument

Sets up the first/root element in a document (that is namespace aware)

Type: Function

Return Data Type: Handle

Parameters: string sNamespace String sTagName

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The root element tag name

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateDocumentElementNS is used to set up the first element in a document. It should only be used when creating a new XML Document.

// namespace to use for document
Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace
// create XML document / Create root node
Get Create U_cXMLDomDocument To hoXML
// Create the Root element named CustomerList
Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
// build the rest of the document
:

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateDocumentElementNS and not CreateDocumentElement ).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMDocument [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMDocument

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocument [Function CreateElementNode]

CreateElementNode - cXMLDOMDocument

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMDocument [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMDocument

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMDocument [Function DocTypeNode]

DocTypeNode - cXMLDOMDocument

Returns a DocumentType object if a DTD exists for this document

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a cXMLDomDocumentType object representing the DTD. If there is not DTD, it returns 0.

Description

DocTypeNode returns a cXMLDomDocumentType object if a DTD exists for this XML document object.

Access to information from a cXMLDomDocumentType object is limited. You may wish to use psXML to get more information.

Last Edited: November 2, 2003


cXMLDOMDocument [Function DocumentElement]

DocumentElement - cXMLDOMDocument

Returns a handle to the root element of the document

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to the root element of the document

Description

DocumentElement returns a handle to the root element of the document. Access to the root node allows for searches and iterations.

Last Edited: July 31, 2003


cXMLDOMDocument [Function DocumentObject]

DocumentObject - cXMLDOMDocument

Returns handle of an XML node's parent document object

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns object handle of the XML node's parent document object

Description

DocumentObject returns the node of the main parent document object. It is used to child allow nodes and node lists to get the parent document object handle.

Last Edited: September 25, 2003


cXMLDOMDocument [Function ElementNodes]

ElementNodes - cXMLDOMDocument

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMDocument [Function FindNode]

FindNode - cXMLDOMDocument

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMDocument [Function FindNodeList]

FindNodeList - cXMLDOMDocument

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMDocument [Function FirstChild]

FirstChild - cXMLDOMDocument

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMDocument [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMDocument

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMDocument [Function IsElementNS]

IsElementNS - cXMLDOMDocument

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMDocument [Function LastChild]

LastChild - cXMLDOMDocument

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMDocument [Function LoadXML]

LoadXML - cXMLDOMDocument

Loads an XML document from a string

Type: Function

Return Data Type: Integer

Parameters: String sXMLText

Parameter | Description
sXMLText | An XML document represented as a string

Return Value

Returns True if document is properly loaded, False if an error occurred

Description

The LoadXML method loads an XML document from a passed string.

// create XML document and load it with passed string.
// If ok, return new XML object handle, else return 0
Function LoadMyDoc string sXML Returns Handle
    handle hoXML
    boolean bOk

    Get Create U_cXMLDOMDocument to hoXML
    Get LoadXml of hoXML sXML to bOK
    If not (bOK) begin
        Send Destroy of hoXML
        Move 0 to hoXML
    end
    Function_Return hoXML
End_Function

If you need to load a very large document, one that larger than the allowed maximum string size, you can use the LoadXMLFromAddress method.

An XML document may be loaded from a URL or disk using the LoadXMLDocument method.

An XML document may be moved to a string using the psXML property.

See Also

LoadXMLFromAddress | LoadXMLDocument | | SaveXMLDocument | psXMl | paXML

Last Edited: July 11, 2006


cXMLDOMDocument [Function LoadXMLDocument]

LoadXMLDocument - cXMLDOMDocument

Loads an XML Document

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns True if document was successfully loaded, False if error

Description

LoadXMLDocument loads an XML Document. The name of the document is stored in the property psDocumentName that must be set for this function to work correctly.

XML documents may be saved using the SaveXmlDocument method.

// create the xml document object
Object oXML is a cXmlDomDocument
End_Object

// set the document name and load it
Set psDocumentName of oXML to "http://localhost/xml/customer.xml"
Get LoadXmlDocument of oXML to bOk

// Do Stuff
Send ProcessThisObject

// Save XML document with a new name
Set psDocumentName of oXML to ".\MyXmlDocs\NewCustomer.xml"
Get SaveXmlDocument of oXML to bOk

// destroy the XML object
Send Destroy of oXML

You can use the method LoadXML to load an XML document from a passed string

You can use the method LoadXMLFromAddress to load an XML document from data poitned to by an address

See Also

psDocumentName | SaveXmlDocument | LoadXml | LoadXmlFromAddress

Last Edited: November 2, 2003


cXMLDOMDocument [Function LoadXMLFromAddress]

LoadXMLFromAddress - cXMLDOMDocument

Loads an XML document from data pointed to by address

Type: Function

Return Data Type: Integer

Parameters: Address aAddress

Parameter | Description
aAddress | An XML string pointed to by an address

Return Value

Returns True if document is properly loaded, False if an error occurred

Description

LoadXML loads an XML document from a memory area pointed to by the passed address. This is similar to the LoadXML method except the data is loaded from a memory area and not a passed string. It is, therefore, not limited to a maximum string size.

// create XML document and load it with passed string.
// If ok, return new XML object handle, else return 0
Function LoadMyDoc address aXML Returns Handle
    handle hoXML
    boolean bOk

    Get Create U_cXMLDOMDocument to hoXML
    Get LoadXMLFromAddress of hoXML aXML to bOK
    If not bOK Begin
        Send Destroy of hoXML
        Move 0 to hoXML
    end
    Function_Return hoXML
End_Function

If you need to load smaller documents, you may find the LoadXML method easier to use.

An XML document may be loaded from a URL or disk using the LoadXMLDocument method.

An XML document may be moved to a memory area pointed to by an address using the paXML property.

See Also

LoadXML | LoadXMLDocument | | SaveXMLDocument | psXMl | paXML

Last Edited: July 11, 2006


cXMLDOMDocument [Function NextElementNS]

NextElementNS - cXMLDOMDocument

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMDocument [Function NextNode]

NextNode - cXMLDOMDocument

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMDocument [Function NextSibling]

NextSibling - cXMLDOMDocument

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMDocument [Function NodeClassId]

NodeClassId - cXMLDOMDocument

Returns the classId for the passed iType

Type: Function

Return Data Type: Integer

Parameters: integer iType

Parameter | Description
iType | the type of node

Return Value

Returns the classId for the passed iType

Description

NodeClassId returns the classId for the passed iType. This is an advanced use method.

Whenever an XML node needs to be created the object will send the message NodeClassId to the document object passing the nodetype that needs to be created. This function returns the Visual DataFlex class id that is used to create the class. By default, these are the standard cXmlDom... classes. You can augment this method and use it to return custom sub-classes.

Last Edited: February 17, 2005


cXMLDOMDocument [Function ParentNode]

ParentNode - cXMLDOMDocument

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMDocument [Function phXMLErrorObject]

phXMLErrorObject - cXMLDOMDocument

Handle to the last parse error reported

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Description

phXMLErrorObject is the handle to the last parse error reported.

Example

Get phXMLErrorObject To hoParseErrorObject

Last Edited: September 11, 2003


cXMLDOMDocument [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMDocument

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMDocument [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMDocument

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMDocument [Function PreviousSibling]

PreviousSibling - cXMLDOMDocument

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMDocument [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMDocument

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMDocument [Function RemoveNode]

RemoveNode - cXMLDOMDocument

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMDocument [Function ReplaceNode]

ReplaceNode - cXMLDOMDocument

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMDocument [Function SaveXMLDocument]

SaveXMLDocument - cXMLDOMDocument

Saves an XML Document

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns 0 if successful, non-zero if an error ocurred.

Description

SaveXMLDocument saves an XML Document using the named supplied by the psDocumentName property.

XML documents may be loaded using the LoadXmlDocument method.

Return values can be:

Constant | Meaning
S_OK (0x00000000L) | The value returned if successful.
XML_BAD_ENCODING | The value returned if the document contains a character that does not belong in the specified encoding. The character must use a numeric entity reference. For example, the Japanese Unicode character 20013 does not fit into the encoding Windows-1250 (the Central European alphabet) and therefore must be represented in markup as the numeric entity reference 中 or 中 This version of save does not automatically convert characters to the numeric entity references.
E_INVALIDARG (0x80070057L) | The value returned if a string was provided, but it is not a valid file name.
E_ACCESSDENIED (0x80070005L) | The value returned if a save operation is not permitted.
E_OUTOFMEMORY (0x8007000EL) | The value returned if the save operation must allocate buffers.
(Other values) | Any other file system error can be returned in the save(string) case.

// create the xml document object
Object oXML is a cXmlDomDocument
End_Object

// set the document name and load it
Set psDocumentName of oXML to "http://localhost/xml/customer.xml"
Get LoadXmlDocument of oXML to iOk

// Do Stuff
Send ProcessThisObject

// Save XML document with a new name
Set psDocumentName of oXML to ".\MyXmlDocs\NewCustomer.xml"
Get SaveXmlDocument of oXML to iError

// destroy the XML object
Send Destroy of oXML

The value of psDocumentName MUST be a FILENAME when used with SaveXMLDocument.

An XML document may be copied to a string using the psXML property.
An XML document may be copied to a memory heap pointed to by an address using the paXML property.

See Also

psDocumentName | psXml | paXml | LoadXMLDocument

Last Edited: September 2, 2005


cXMLDOMDocument [Function XSLTransformation]

XSLTransformation - cXMLDOMDocument

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMDocument [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMDocument

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMDocument

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
BasicParseErrorReport | Procedure | Returns detailed information about the last parse error |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentElement | Function | Sets up the first element in a document |
CreateDocumentElementNS | Function | Sets up the first/root element in a document (that is namespace aware) |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
DocTypeNode | Function | Returns a DocumentType object if a DTD exists for this document |
DocumentElement | Function | Returns a handle to the root element of the document |
DocumentObject | Function | Returns handle of an XML node's parent document object |
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
LoadXML | Function | Loads an XML document from a string |
LoadXMLDocument | Function | Loads an XML Document |
LoadXMLFromAddress | Function | Loads an XML document from data pointed to by address |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
NodeClassId | Function | Returns the classId for the passed iType |
ParentNode | Function | Returns an object that is the parent of the current node |
phXMLErrorObject | Function | Handle to the last parse error reported |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SaveXMLDocument | Function | Saves an XML Document |
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMDocument [Procedure AddAttribute]

AddAttribute - cXMLDOMDocument

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMDocument [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMDocument

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMDocument [Procedure AddCDataSection]

AddCDataSection - cXMLDOMDocument

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocument [Procedure AddChildComment]

AddChildComment - cXMLDOMDocument

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocument [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMDocument

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocument [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMDocument

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocument [Procedure AddElement]

AddElement - cXMLDOMDocument

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocument [Procedure AddElementNS]

AddElementNS - cXMLDOMDocument

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMDocument [Procedure BasicParseErrorReport]

BasicParseErrorReport - cXMLDOMDocument

Returns detailed information about the last parse error

Type: Procedure

Parameters: No Parameters

Description

BasicParseErrorReport returns detailed information about the last parse error, including the error number, line number, character position, and a text description. Designed to be overwritten by the developer.

Example

Procedure BasicParseErrorReport
    String sProblem sLinePosition sDescr sReason sSource
    Integer hoParseErrorObject

    Get phXMLErrorObject To hoParseErrorObject
    Move ("Cannot load " + (psDocumentName(Self)) +;
          "."+character(13)+character(10)) To sProblem
    Move ("A Parsing Error has occurred on line " + ;
            string(piLine(hoParseErrorObject)) + " at pos " + ;
            string(piLinePos(hoParseErrorObject)) + "."+;
                   character(13)+character(10) ) To sLinePosition
    Move ("Reason: " + (psReason(hoParseErrorObject))) To sReason
    Move ("Source: " + (psSrcText(hoParseErrorObject))) To sSource
    Move (sProblem + sLinePosition + sReason + sSource) To sDescr
    Error 10000 sDescr
    Send Destroy of hoParseErrorObject
End_Procedure

Constant | Meaning
piLine | Returns the number of the line in the document that contains the error
piLinePos | Returns the character position of the error within the line in which it occurred
psReason | Returns the text description of the source and the reason for the error, and can also include the URL of the DTD or SCHEMA and the node within it that that corresponds to the error
psSrcText | Returns the full text of the line that contains the error, or an empty string if the error cannot be assigned to a specific line

Last Edited: February 17, 2005


cXMLDOMDocument [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMDocument

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMDocument [Procedure EnumerateElements]

EnumerateElements - cXMLDOMDocument

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMDocument [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMDocument

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMDocument [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMDocument

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMDocument [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMDocument

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMDocument

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbAsync | Indicates whether asynchronous download is enabled | BaseXmlDomDocument
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbPreserveWhiteSpace | Indicates whether whitespace will be preserved in the document | BaseXmlDomDocument
pbResolveExternals | Contains the external resolution state of the XML parser for this document | BaseXmlDomDocument
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
pbValidateOnParse | Returns the validation state of the parser | BaseXmlDomDocument
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psDocumentName | The property for the document name |
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psURL | Returns the URL of the most recent XML document that contained an error | BaseXmlDomDocument
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


cXMLDOMDocument [Property psDocumentName]

psDocumentName - cXMLDOMDocument

The property for the document name

Type: Property

Access: Read/Write

Data Type: String

Description

psDocumentName determines the document name and is used by the LoadXmlDocument and SaveXmlDocument methods.

The name may be a file name or a URL.

Example

// create the xml document object
Object oXML is a cXmlDomDocument
End_Object

// set the document name and load it
Set psDocumentName of oXML to "http://localhost/xml/customer.xml"
Get LoadXmlDocument of oXML to iOk

// Do Stuff
Send ProcessThisObject

// Save XML document with a new name
Set psDocumentName of oXML to ".\MyXmlDocs\NewCustomer.xml"
Get SaveXmlDocument of oXML to bError

// destroy the XML object
Send Destroy of oXML

See Also

LoadXmlDocument | SaveXmlDocument

Last Edited: February 16, 2005


Events for cXMLDOMDocumentFragment

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMDocumentFragment [Function AddAttributeNode]

AddAttributeNode - cXMLDOMDocumentFragment

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMDocumentFragment [Function AddChildNode]

AddChildNode - cXMLDOMDocumentFragment

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMDocumentFragment [Function AddElement]

AddElement - cXMLDOMDocumentFragment

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function AddElementNS]

AddElementNS - cXMLDOMDocumentFragment

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function AppendNode]

AppendNode - cXMLDOMDocumentFragment

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMDocumentFragment [Function AttributeNodes]

AttributeNodes - cXMLDOMDocumentFragment

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMDocumentFragment [Function AttributeValueNode]

AttributeValueNode - cXMLDOMDocumentFragment

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMDocumentFragment [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMDocumentFragment

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMDocumentFragment [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMDocumentFragment

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMDocumentFragment [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMDocumentFragment

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMDocumentFragment [Function ChildElementNS]

ChildElementNS - cXMLDOMDocumentFragment

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMDocumentFragment

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function ChildNodes]

ChildNodes - cXMLDOMDocumentFragment

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMDocumentFragment [Function ChildNodeValue]

ChildNodeValue - cXMLDOMDocumentFragment

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMDocumentFragment [Function CloneNode]

CloneNode - cXMLDOMDocumentFragment

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMDocumentFragment [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMDocumentFragment

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMDocumentFragment [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMDocumentFragment

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMDocumentFragment [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMDocumentFragment

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocumentFragment [Function CreateChildComment]

CreateChildComment - cXMLDOMDocumentFragment

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocumentFragment [Function CreateChildNode]

CreateChildNode - cXMLDOMDocumentFragment

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMDocumentFragment [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMDocumentFragment

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocumentFragment [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMDocumentFragment

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocumentFragment [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMDocumentFragment

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocumentFragment [Function CreateElementNode]

CreateElementNode - cXMLDOMDocumentFragment

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMDocumentFragment

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function ElementNodes]

ElementNodes - cXMLDOMDocumentFragment

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMDocumentFragment [Function FindNode]

FindNode - cXMLDOMDocumentFragment

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMDocumentFragment [Function FindNodeList]

FindNodeList - cXMLDOMDocumentFragment

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMDocumentFragment [Function FirstChild]

FirstChild - cXMLDOMDocumentFragment

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMDocumentFragment [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMDocumentFragment

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMDocumentFragment [Function IsElementNS]

IsElementNS - cXMLDOMDocumentFragment

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function LastChild]

LastChild - cXMLDOMDocumentFragment

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMDocumentFragment [Function NextElementNS]

NextElementNS - cXMLDOMDocumentFragment

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function NextNode]

NextNode - cXMLDOMDocumentFragment

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMDocumentFragment [Function NextSibling]

NextSibling - cXMLDOMDocumentFragment

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMDocumentFragment [Function ParentNode]

ParentNode - cXMLDOMDocumentFragment

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMDocumentFragment [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMDocumentFragment

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMDocumentFragment [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMDocumentFragment

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function PreviousSibling]

PreviousSibling - cXMLDOMDocumentFragment

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMDocumentFragment [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMDocumentFragment

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function RemoveNode]

RemoveNode - cXMLDOMDocumentFragment

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function ReplaceNode]

ReplaceNode - cXMLDOMDocumentFragment

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function XSLTransformation]

XSLTransformation - cXMLDOMDocumentFragment

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMDocumentFragment

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMDocumentFragment

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
ParentNode | Function | Returns an object that is the parent of the current node |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMDocumentFragment [Procedure AddAttribute]

AddAttribute - cXMLDOMDocumentFragment

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMDocumentFragment [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMDocumentFragment

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Procedure AddCDataSection]

AddCDataSection - cXMLDOMDocumentFragment

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Procedure AddChildComment]

AddChildComment - cXMLDOMDocumentFragment

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMDocumentFragment

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMDocumentFragment

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Procedure AddElement]

AddElement - cXMLDOMDocumentFragment

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Procedure AddElementNS]

AddElementNS - cXMLDOMDocumentFragment

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMDocumentFragment

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Procedure EnumerateElements]

EnumerateElements - cXMLDOMDocumentFragment

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMDocumentFragment

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMDocumentFragment

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMDocumentFragment [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMDocumentFragment

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMDocumentFragment

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for cXMLDOMDocumentType

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMDocumentType [Function AddAttributeNode]

AddAttributeNode - cXMLDOMDocumentType

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMDocumentType [Function AddChildNode]

AddChildNode - cXMLDOMDocumentType

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMDocumentType [Function AddElement]

AddElement - cXMLDOMDocumentType

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function AddElementNS]

AddElementNS - cXMLDOMDocumentType

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function AppendNode]

AppendNode - cXMLDOMDocumentType

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMDocumentType [Function AttributeNodes]

AttributeNodes - cXMLDOMDocumentType

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMDocumentType [Function AttributeValueNode]

AttributeValueNode - cXMLDOMDocumentType

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMDocumentType [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMDocumentType

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMDocumentType [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMDocumentType

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMDocumentType [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMDocumentType

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMDocumentType [Function ChildElementNS]

ChildElementNS - cXMLDOMDocumentType

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMDocumentType

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function ChildNodes]

ChildNodes - cXMLDOMDocumentType

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMDocumentType [Function ChildNodeValue]

ChildNodeValue - cXMLDOMDocumentType

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMDocumentType [Function CloneNode]

CloneNode - cXMLDOMDocumentType

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMDocumentType [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMDocumentType

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMDocumentType [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMDocumentType

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMDocumentType [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMDocumentType

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocumentType [Function CreateChildComment]

CreateChildComment - cXMLDOMDocumentType

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocumentType [Function CreateChildNode]

CreateChildNode - cXMLDOMDocumentType

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMDocumentType [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMDocumentType

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocumentType [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMDocumentType

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocumentType [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMDocumentType

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMDocumentType [Function CreateElementNode]

CreateElementNode - cXMLDOMDocumentType

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMDocumentType

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function ElementNodes]

ElementNodes - cXMLDOMDocumentType

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMDocumentType [Function FindNode]

FindNode - cXMLDOMDocumentType

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMDocumentType [Function FindNodeList]

FindNodeList - cXMLDOMDocumentType

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMDocumentType [Function FirstChild]

FirstChild - cXMLDOMDocumentType

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMDocumentType [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMDocumentType

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMDocumentType [Function IsElementNS]

IsElementNS - cXMLDOMDocumentType

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function LastChild]

LastChild - cXMLDOMDocumentType

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMDocumentType [Function NextElementNS]

NextElementNS - cXMLDOMDocumentType

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function NextNode]

NextNode - cXMLDOMDocumentType

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMDocumentType [Function NextSibling]

NextSibling - cXMLDOMDocumentType

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMDocumentType [Function ParentNode]

ParentNode - cXMLDOMDocumentType

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMDocumentType [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMDocumentType

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMDocumentType [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMDocumentType

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function PreviousSibling]

PreviousSibling - cXMLDOMDocumentType

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMDocumentType [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMDocumentType

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function RemoveNode]

RemoveNode - cXMLDOMDocumentType

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function ReplaceNode]

ReplaceNode - cXMLDOMDocumentType

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function XSLTransformation]

XSLTransformation - cXMLDOMDocumentType

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMDocumentType [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMDocumentType

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMDocumentType

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
ParentNode | Function | Returns an object that is the parent of the current node |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMDocumentType [Procedure AddAttribute]

AddAttribute - cXMLDOMDocumentType

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMDocumentType [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMDocumentType

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMDocumentType [Procedure AddCDataSection]

AddCDataSection - cXMLDOMDocumentType

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocumentType [Procedure AddChildComment]

AddChildComment - cXMLDOMDocumentType

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocumentType [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMDocumentType

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocumentType [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMDocumentType

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocumentType [Procedure AddElement]

AddElement - cXMLDOMDocumentType

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMDocumentType [Procedure AddElementNS]

AddElementNS - cXMLDOMDocumentType

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMDocumentType [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMDocumentType

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMDocumentType [Procedure EnumerateElements]

EnumerateElements - cXMLDOMDocumentType

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMDocumentType [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMDocumentType

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMDocumentType [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMDocumentType

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMDocumentType [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMDocumentType

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMDocumentType

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for cXMLDOMElement

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMElement [Function AddAttributeNode]

AddAttributeNode - cXMLDOMElement

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMElement [Function AddChildNode]

AddChildNode - cXMLDOMElement

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMElement [Function AddElement]

AddElement - cXMLDOMElement

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMElement [Function AddElementNS]

AddElementNS - cXMLDOMElement

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMElement [Function AppendNode]

AppendNode - cXMLDOMElement

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMElement [Function AttributeNodes]

AttributeNodes - cXMLDOMElement

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMElement [Function AttributeValueNode]

AttributeValueNode - cXMLDOMElement

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMElement [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMElement

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMElement [Function AttributeValueNS]

AttributeValueNS - cXMLDOMElement

Returns the value of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: String

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the text value of an attribute whose NamespaceURI and BaseName matches the passed values. Returns "" if no match is found.

Description

AttributeValueNS is used to get the attribute value in an element node that matches the passed NamespaceURI and BaseName.

Assume you have the following Xml document

<Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList" xmlns:x="SomeOtherURI">
    <Name x:cnum="12">3A Software</Name>
</Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". Because the attribute cnum has an explicit prefix defiend, it has a NamespaceURI of "SomeOtherURI". We could search for the attribute value as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Move "SomeOtherURI" to  sNS2
Get DocumentElement of hoXML to hoRoot
// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get AttributeValueNS of hoName sNS2 "cnum" to sNumber
Send Destroy of hoName

Assume you have the following Xml document

<Customer xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Name cnum="12">3A Software</Name>
</Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". However, since attributes do not use default namespaces, the NamespaceURI for the attribute cnum is "". We could search for the attribute value as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

When there is no namespace we can use the AttributeValue message get the value.

Get AttributeValue of hoName "cnum" to sNumber

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValue | AddAttributeNS | AttributeValueNodeNS

Last Edited: February 17, 2005


cXMLDOMElement [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMElement

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMElement [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMElement

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMElement [Function ChildElementNS]

ChildElementNS - cXMLDOMElement

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMElement [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMElement

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMElement [Function ChildNodes]

ChildNodes - cXMLDOMElement

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMElement [Function ChildNodeValue]

ChildNodeValue - cXMLDOMElement

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMElement [Function CloneNode]

CloneNode - cXMLDOMElement

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMElement [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMElement

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMElement [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMElement

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMElement [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMElement

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMElement [Function CreateChildComment]

CreateChildComment - cXMLDOMElement

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMElement [Function CreateChildNode]

CreateChildNode - cXMLDOMElement

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMElement [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMElement

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMElement [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMElement

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMElement [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMElement

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMElement [Function CreateElementNode]

CreateElementNode - cXMLDOMElement

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMElement [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMElement

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMElement [Function ElementNodes]

ElementNodes - cXMLDOMElement

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMElement [Function FindNode]

FindNode - cXMLDOMElement

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMElement [Function FindNodeList]

FindNodeList - cXMLDOMElement

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMElement [Function FirstChild]

FirstChild - cXMLDOMElement

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMElement [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMElement

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMElement [Function IsElementNS]

IsElementNS - cXMLDOMElement

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMElement [Function LastChild]

LastChild - cXMLDOMElement

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMElement [Function NextElementNS]

NextElementNS - cXMLDOMElement

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMElement [Function NextNode]

NextNode - cXMLDOMElement

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMElement [Function NextSibling]

NextSibling - cXMLDOMElement

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMElement [Function ParentNode]

ParentNode - cXMLDOMElement

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMElement [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMElement

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMElement [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMElement

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMElement [Function PreviousSibling]

PreviousSibling - cXMLDOMElement

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMElement [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMElement

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMElement [Function RemoveNode]

RemoveNode - cXMLDOMElement

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMElement [Function ReplaceNode]

ReplaceNode - cXMLDOMElement

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMElement [Function XSLTransformation]

XSLTransformation - cXMLDOMElement

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMElement [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMElement

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMElement

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
AttributeValueNS | Function | Returns the value of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
ParentNode | Function | Returns an object that is the parent of the current node |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveAttribute | Procedure | Removes an attribute from an element node |
RemoveAttributeNS | Procedure | Removes an attribute from an element node based on NamespaceURI and BaseName |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetAttributeValue | Procedure | Creates/Replaces and sets an attribute value |
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMElement [Procedure AddAttribute]

AddAttribute - cXMLDOMElement

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMElement [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMElement

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMElement [Procedure AddCDataSection]

AddCDataSection - cXMLDOMElement

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMElement [Procedure AddChildComment]

AddChildComment - cXMLDOMElement

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMElement [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMElement

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMElement [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMElement

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMElement [Procedure AddElement]

AddElement - cXMLDOMElement

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMElement [Procedure AddElementNS]

AddElementNS - cXMLDOMElement

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMElement [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMElement

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMElement [Procedure EnumerateElements]

EnumerateElements - cXMLDOMElement

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMElement [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMElement

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMElement [Procedure RemoveAttribute]

RemoveAttribute - cXMLDOMElement

Removes an attribute from an element node

Type: Procedure

Parameters: string sName

Parameter | Description
sName | Attribute name to be removed

Description

RemoveAttribute is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use RemoveAttributeNS in its place.

RemoveAttribute removes a named attribute from an element node.

Send RemoveAttribute of hoElement "Type"

Last Edited: April 7, 2004


cXMLDOMElement [Procedure RemoveAttributeNS]

RemoveAttributeNS - cXMLDOMElement

Removes an attribute from an element node based on NamespaceURI and BaseName

Type: Procedure

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNameSpace | The attribute NamespaceURI
sBaseName | the name of the attribute node to be removed

Description

RemoveAttributeNS removes a named (NamespaceURI and BaseName) attribute from an element node.

This sample removes an attribute with a global ("") namespace. This will be very typical.

Send RemoveAttributeNS of hoElement "" "Type"

This sample removes an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get ChildElementNS of hoRoot sNS "Customer" to hoCust

If (hoCust > 0) Begin
    Send RemoveAttributeNS of hoCust sNS "m:table" iTable
    Send Destroy of hoCust
End

Namespaces

This message removes a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use RemoveAttributeNS and not RemoveAttribute).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Attributes and Namespaces

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace) which means you will often be passing the "" NamespaceURI string.
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • A Prefix will get added to the attribute name by adding the prefix to the sName (e.g., sName="m:table").

See Also

AddAttributeNS | AttributeValueNS | AttributeValueNodeNS

Last Edited: February 17, 2005


cXMLDOMElement [Procedure SetAttributeValue]

SetAttributeValue - cXMLDOMElement

Creates/Replaces and sets an attribute value

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | Attribute Name
sValue | Attribute Value

Description

SetAttributeValue sets an attribute name and value node within an element. If the attribute name already exists, the value is replaced. If the attribute name does not exist a new attribute node is created.

Send SetAttributeValue of hoElement "Type" "Customer"

Last Edited: September 11, 2003


cXMLDOMElement [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMElement

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMElement [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMElement

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMElement

View property list in hierarchical order

Name | Description | Defining Class
AttributeValue | Gets and sets attributes in an element | BaseXmlDomElement
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psTagName | The element name | BaseXmlDomElement
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for cXMLDOMEntity

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMEntity [Function AddAttributeNode]

AddAttributeNode - cXMLDOMEntity

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMEntity [Function AddChildNode]

AddChildNode - cXMLDOMEntity

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMEntity [Function AddElement]

AddElement - cXMLDOMEntity

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMEntity [Function AddElementNS]

AddElementNS - cXMLDOMEntity

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMEntity [Function AppendNode]

AppendNode - cXMLDOMEntity

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMEntity [Function AttributeNodes]

AttributeNodes - cXMLDOMEntity

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMEntity [Function AttributeValueNode]

AttributeValueNode - cXMLDOMEntity

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMEntity [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMEntity

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMEntity [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMEntity

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMEntity [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMEntity

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMEntity [Function ChildElementNS]

ChildElementNS - cXMLDOMEntity

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMEntity [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMEntity

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMEntity [Function ChildNodes]

ChildNodes - cXMLDOMEntity

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMEntity [Function ChildNodeValue]

ChildNodeValue - cXMLDOMEntity

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMEntity [Function CloneNode]

CloneNode - cXMLDOMEntity

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMEntity [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMEntity

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMEntity [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMEntity

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMEntity [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMEntity

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMEntity [Function CreateChildComment]

CreateChildComment - cXMLDOMEntity

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMEntity [Function CreateChildNode]

CreateChildNode - cXMLDOMEntity

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMEntity [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMEntity

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMEntity [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMEntity

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMEntity [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMEntity

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMEntity [Function CreateElementNode]

CreateElementNode - cXMLDOMEntity

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMEntity [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMEntity

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMEntity [Function ElementNodes]

ElementNodes - cXMLDOMEntity

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMEntity [Function FindNode]

FindNode - cXMLDOMEntity

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMEntity [Function FindNodeList]

FindNodeList - cXMLDOMEntity

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMEntity [Function FirstChild]

FirstChild - cXMLDOMEntity

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMEntity [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMEntity

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMEntity [Function IsElementNS]

IsElementNS - cXMLDOMEntity

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMEntity [Function LastChild]

LastChild - cXMLDOMEntity

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMEntity [Function NextElementNS]

NextElementNS - cXMLDOMEntity

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMEntity [Function NextNode]

NextNode - cXMLDOMEntity

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMEntity [Function NextSibling]

NextSibling - cXMLDOMEntity

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMEntity [Function ParentNode]

ParentNode - cXMLDOMEntity

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMEntity [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMEntity

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMEntity [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMEntity

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMEntity [Function PreviousSibling]

PreviousSibling - cXMLDOMEntity

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMEntity [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMEntity

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMEntity [Function RemoveNode]

RemoveNode - cXMLDOMEntity

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMEntity [Function ReplaceNode]

ReplaceNode - cXMLDOMEntity

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMEntity [Function XSLTransformation]

XSLTransformation - cXMLDOMEntity

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMEntity [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMEntity

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMEntity

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
ParentNode | Function | Returns an object that is the parent of the current node |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMEntity [Procedure AddAttribute]

AddAttribute - cXMLDOMEntity

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMEntity [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMEntity

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMEntity [Procedure AddCDataSection]

AddCDataSection - cXMLDOMEntity

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMEntity [Procedure AddChildComment]

AddChildComment - cXMLDOMEntity

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMEntity [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMEntity

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMEntity [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMEntity

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMEntity [Procedure AddElement]

AddElement - cXMLDOMEntity

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMEntity [Procedure AddElementNS]

AddElementNS - cXMLDOMEntity

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMEntity [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMEntity

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMEntity [Procedure EnumerateElements]

EnumerateElements - cXMLDOMEntity

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMEntity [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMEntity

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMEntity [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMEntity

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMEntity [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMEntity

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMEntity

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psNotationName |  | BaseXmlDomEntity
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psPublicId |  | BaseXmlDomEntity
psSystemId |  | BaseXmlDomEntity
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for cXMLDOMEntityReference

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMEntityReference [Function AddAttributeNode]

AddAttributeNode - cXMLDOMEntityReference

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMEntityReference [Function AddChildNode]

AddChildNode - cXMLDOMEntityReference

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMEntityReference [Function AddElement]

AddElement - cXMLDOMEntityReference

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function AddElementNS]

AddElementNS - cXMLDOMEntityReference

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function AppendNode]

AppendNode - cXMLDOMEntityReference

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMEntityReference [Function AttributeNodes]

AttributeNodes - cXMLDOMEntityReference

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMEntityReference [Function AttributeValueNode]

AttributeValueNode - cXMLDOMEntityReference

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMEntityReference [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMEntityReference

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMEntityReference [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMEntityReference

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMEntityReference [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMEntityReference

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMEntityReference [Function ChildElementNS]

ChildElementNS - cXMLDOMEntityReference

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMEntityReference

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function ChildNodes]

ChildNodes - cXMLDOMEntityReference

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMEntityReference [Function ChildNodeValue]

ChildNodeValue - cXMLDOMEntityReference

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMEntityReference [Function CloneNode]

CloneNode - cXMLDOMEntityReference

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMEntityReference [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMEntityReference

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMEntityReference [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMEntityReference

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMEntityReference [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMEntityReference

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMEntityReference [Function CreateChildComment]

CreateChildComment - cXMLDOMEntityReference

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMEntityReference [Function CreateChildNode]

CreateChildNode - cXMLDOMEntityReference

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMEntityReference [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMEntityReference

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMEntityReference [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMEntityReference

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMEntityReference [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMEntityReference

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMEntityReference [Function CreateElementNode]

CreateElementNode - cXMLDOMEntityReference

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMEntityReference

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function ElementNodes]

ElementNodes - cXMLDOMEntityReference

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMEntityReference [Function FindNode]

FindNode - cXMLDOMEntityReference

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMEntityReference [Function FindNodeList]

FindNodeList - cXMLDOMEntityReference

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMEntityReference [Function FirstChild]

FirstChild - cXMLDOMEntityReference

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMEntityReference [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMEntityReference

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMEntityReference [Function IsElementNS]

IsElementNS - cXMLDOMEntityReference

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function LastChild]

LastChild - cXMLDOMEntityReference

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMEntityReference [Function NextElementNS]

NextElementNS - cXMLDOMEntityReference

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function NextNode]

NextNode - cXMLDOMEntityReference

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMEntityReference [Function NextSibling]

NextSibling - cXMLDOMEntityReference

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMEntityReference [Function ParentNode]

ParentNode - cXMLDOMEntityReference

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMEntityReference [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMEntityReference

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMEntityReference [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMEntityReference

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function PreviousSibling]

PreviousSibling - cXMLDOMEntityReference

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMEntityReference [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMEntityReference

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function RemoveNode]

RemoveNode - cXMLDOMEntityReference

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function ReplaceNode]

ReplaceNode - cXMLDOMEntityReference

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function XSLTransformation]

XSLTransformation - cXMLDOMEntityReference

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMEntityReference [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMEntityReference

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMEntityReference

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
ParentNode | Function | Returns an object that is the parent of the current node |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMEntityReference [Procedure AddAttribute]

AddAttribute - cXMLDOMEntityReference

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMEntityReference [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMEntityReference

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMEntityReference [Procedure AddCDataSection]

AddCDataSection - cXMLDOMEntityReference

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMEntityReference [Procedure AddChildComment]

AddChildComment - cXMLDOMEntityReference

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMEntityReference [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMEntityReference

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMEntityReference [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMEntityReference

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMEntityReference [Procedure AddElement]

AddElement - cXMLDOMEntityReference

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMEntityReference [Procedure AddElementNS]

AddElementNS - cXMLDOMEntityReference

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMEntityReference [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMEntityReference

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMEntityReference [Procedure EnumerateElements]

EnumerateElements - cXMLDOMEntityReference

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMEntityReference [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMEntityReference

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMEntityReference [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMEntityReference

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMEntityReference [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMEntityReference

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMEntityReference

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for cXMLDOMNamedNodeMap

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMNamedNodeMap [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMNamedNodeMap

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMNamedNodeMap [Function CollectionNode]

CollectionNode - cXMLDOMNamedNodeMap

Accesses items of a collection by item number

Type: Function

Return Data Type: Handle

Parameters: Integer I

Parameter | Description
I | the item number

Return Value

Description

CollectionNode is used to access items of a collection by item number I.

Last Edited: July 30, 2003


cXMLDOMNamedNodeMap [Function NamedNode]

NamedNode - cXMLDOMNamedNodeMap

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sName | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


cXMLDOMNamedNodeMap [Function NodeListLength]

NodeListLength - cXMLDOMNamedNodeMap

Returns number of items in the collection

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns number of items in the collection

Description

The NodeListLength function returns number of items in the collection.

Example

integer iItems
Get NodeListLength of hoList to iItems

Last Edited: February 17, 2005


cXMLDOMNamedNodeMap [Function QualifiedNode]

QualifiedNode - cXMLDOMNamedNodeMap

Returns an object handle to an attribute node that matches the NamespaceURI and Basename

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNameSpace | The attribute NamespaceURI
sBaseName | the name of the attribute node

Return Value

Returns the handle of the matching attribute object or zero if no match is found

Description

QualifiedNode returns a named node (NamespaceURI and BaseName) from an attributelist.

move "http://www.dataaccess.com/Test/CustomerList" to sNS
get AttributeNodes of hoEle to hoNamedNodeList
if hoNamedNodeList begin
   get QualifiedNode of hoNamedNodeList sNS "Type" to hoAttr
   if (hoAttr=0) send Stop_Box "attribute not found"
   else send Destroy of hoAttr
   send Destroy of hoNamedNodeList
end

Namespaces

This message finds a node in a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods.

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Attributes and Namespaces

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace) which means you will often be passing the "" NamespaceURI string.
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • A Prefix will get added to the attribute name by adding the prefix to the sName (e.g., sName="m:table").

See Also

RemoveQualifiedNode

Last Edited: February 17, 2005


cXMLDOMNamedNodeMap [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMNamedNodeMap

Removes a named attribute node and returns removed node

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sName | Name of attribute to remove

Return Value

Returns object handle of removed node or zero if not found

Description

RemoveNamedNode removes a named attribute.

handle hoRemovedNode
Get RemoveNamedNode of hoElement "AttName" to hoRemovedNode
Send Destroy of hoRemovedNode

Note:Note that returned object must be disposed of or moved somewhere else.

Last Edited: February 17, 2005


cXMLDOMNamedNodeMap [Function RemoveQualifiedNode]

RemoveQualifiedNode - cXMLDOMNamedNodeMap

Removes an attribute node that matches the NamespaceURI and Basename and returns the removed node's handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNameSpace | The attribute NamespaceURI
sBaseName | the name of the attribute node

Return Value

Returns the object handle of the removed node, zero if no node is removed.

Description

RemoveQualifiedNode removes a named node (NamespaceURI and BaseName) from an attribute list and returns the removed node. You must destroy the attribute node.

move "http://www.dataaccess.com/Test/CustomerList" to sNS
get AttributeNodes of hoEle to hoNamedNodeList
if hoNamedNodeList begin
   get RemoveQualifiedNode of hoNamedNodeList sNS "Type" to hoAttr
   if (hoAttr=0) send Stop_Box "attribute not found"
   else send Destroy of hoAttr
   send Destroy of hoNamedNodeList
end

Namespaces

This message removes a node in a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods.

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Attributes and Namespaces

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace) which means you will often be passing the "" NamespaceURI string.
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • A Prefix will get added to the attribute name by adding the prefix to the sName (e.g., sName="m:table").

See Also

QualifiedNode

Last Edited: February 17, 2005


cXMLDOMNamedNodeMap [Function SetNamedNode]

SetNamedNode - cXMLDOMNamedNodeMap

Type: Function

Return Data Type: Handle

Parameters: Handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for cXMLDOMNamedNodeMap

View method list in hierarchical order

Name | Type | Description | Defining Class
ChangeNodeClass | Function | Changes the class of an XML node |
CollectionNode | Function | Accesses items of a collection by item number |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
NamedNode | Function |  |
NodeListLength | Function | Returns number of items in the collection |
QualifiedNode | Function | Returns an object handle to an attribute node that matches the NamespaceURI and Basename |
RemoveNamedNode | Function | Removes a named attribute node and returns removed node |
RemoveQualifiedNode | Function | Removes an attribute node that matches the NamespaceURI and Basename and returns the removed node's handle |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Reset | Function |  | BaseXmlDomNamedNodeMap
SetNamedNode | Function |  |


Properties for cXMLDOMNamedNodeMap

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject


Events for cXMLDOMNode

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMNode [Function AddAttributeNode]

AddAttributeNode - cXMLDOMNode

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMNode [Function AddChildNode]

AddChildNode - cXMLDOMNode

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMNode [Function AddElement]

AddElement - cXMLDOMNode

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMNode [Function AddElementNS]

AddElementNS - cXMLDOMNode

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMNode [Function AppendNode]

AppendNode - cXMLDOMNode

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMNode [Function AttributeNodes]

AttributeNodes - cXMLDOMNode

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMNode [Function AttributeValueNode]

AttributeValueNode - cXMLDOMNode

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMNode [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMNode

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMNode [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMNode

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMNode [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMNode

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMNode [Function ChildElementNS]

ChildElementNS - cXMLDOMNode

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMNode [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMNode

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMNode [Function ChildNodes]

ChildNodes - cXMLDOMNode

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMNode [Function ChildNodeValue]

ChildNodeValue - cXMLDOMNode

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMNode [Function CloneNode]

CloneNode - cXMLDOMNode

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMNode [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMNode

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMNode [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMNode

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMNode [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMNode

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMNode [Function CreateChildComment]

CreateChildComment - cXMLDOMNode

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMNode [Function CreateChildNode]

CreateChildNode - cXMLDOMNode

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMNode [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMNode

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMNode [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMNode

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMNode [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMNode

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMNode [Function CreateElementNode]

CreateElementNode - cXMLDOMNode

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMNode [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMNode

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMNode [Function ElementNodes]

ElementNodes - cXMLDOMNode

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMNode [Function FindNode]

FindNode - cXMLDOMNode

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMNode [Function FindNodeList]

FindNodeList - cXMLDOMNode

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMNode [Function FirstChild]

FirstChild - cXMLDOMNode

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMNode [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMNode

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMNode [Function IsElementNS]

IsElementNS - cXMLDOMNode

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMNode [Function LastChild]

LastChild - cXMLDOMNode

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMNode [Function NextElementNS]

NextElementNS - cXMLDOMNode

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMNode [Function NextNode]

NextNode - cXMLDOMNode

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMNode [Function NextSibling]

NextSibling - cXMLDOMNode

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMNode [Function ParentNode]

ParentNode - cXMLDOMNode

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMNode [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMNode

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMNode [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMNode

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMNode [Function PreviousSibling]

PreviousSibling - cXMLDOMNode

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMNode [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMNode

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMNode [Function RemoveNode]

RemoveNode - cXMLDOMNode

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMNode [Function ReplaceNode]

ReplaceNode - cXMLDOMNode

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMNode [Function XSLTransformation]

XSLTransformation - cXMLDOMNode

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMNode [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMNode

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMNode

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
ParentNode | Function | Returns an object that is the parent of the current node |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMNode [Procedure AddAttribute]

AddAttribute - cXMLDOMNode

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMNode [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMNode

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMNode [Procedure AddCDataSection]

AddCDataSection - cXMLDOMNode

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMNode [Procedure AddChildComment]

AddChildComment - cXMLDOMNode

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMNode [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMNode

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMNode [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMNode

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMNode [Procedure AddElement]

AddElement - cXMLDOMNode

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMNode [Procedure AddElementNS]

AddElementNS - cXMLDOMNode

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMNode [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMNode

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMNode [Procedure EnumerateElements]

EnumerateElements - cXMLDOMNode

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMNode [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMNode

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMNode [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMNode

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMNode [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMNode

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMNode

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for cXMLDOMNodeList

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMNodeList [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMNodeList

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMNodeList [Function CollectionNode]

CollectionNode - cXMLDOMNodeList

Accesses items of a collection by item number

Type: Function

Return Data Type: Handle

Parameters: Integer I

Parameter | Description
I | the item number

Return Value

Description

CollectionNode is used to access items of a collection by item number I.

Last Edited: July 30, 2003


cXMLDOMNodeList [Function NodeListLength]

NodeListLength - cXMLDOMNodeList

Returns number of items in the collection

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns number of items in the collection

Description

The NodeListLength function returns number of items in the collection.

Example

integer iItems
Get NodeListLength of hoList to iItems

Last Edited: February 17, 2005


Methods for cXMLDOMNodeList

View method list in hierarchical order

Name | Type | Description | Defining Class
ChangeNodeClass | Function | Changes the class of an XML node |
CollectionNode | Function | Accesses items of a collection by item number |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
NodeListLength | Function | Returns number of items in the collection |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Reset | Function |  | BaseXmlDomNodeList


Properties for cXMLDOMNodeList

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject


Events for cXMLDOMNotation

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMNotation [Function AddAttributeNode]

AddAttributeNode - cXMLDOMNotation

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMNotation [Function AddChildNode]

AddChildNode - cXMLDOMNotation

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMNotation [Function AddElement]

AddElement - cXMLDOMNotation

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMNotation [Function AddElementNS]

AddElementNS - cXMLDOMNotation

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMNotation [Function AppendNode]

AppendNode - cXMLDOMNotation

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMNotation [Function AttributeNodes]

AttributeNodes - cXMLDOMNotation

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMNotation [Function AttributeValueNode]

AttributeValueNode - cXMLDOMNotation

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMNotation [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMNotation

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMNotation [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMNotation

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMNotation [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMNotation

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMNotation [Function ChildElementNS]

ChildElementNS - cXMLDOMNotation

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMNotation [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMNotation

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMNotation [Function ChildNodes]

ChildNodes - cXMLDOMNotation

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMNotation [Function ChildNodeValue]

ChildNodeValue - cXMLDOMNotation

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMNotation [Function CloneNode]

CloneNode - cXMLDOMNotation

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMNotation [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMNotation

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMNotation [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMNotation

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMNotation [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMNotation

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMNotation [Function CreateChildComment]

CreateChildComment - cXMLDOMNotation

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMNotation [Function CreateChildNode]

CreateChildNode - cXMLDOMNotation

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMNotation [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMNotation

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMNotation [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMNotation

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMNotation [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMNotation

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMNotation [Function CreateElementNode]

CreateElementNode - cXMLDOMNotation

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMNotation [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMNotation

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMNotation [Function ElementNodes]

ElementNodes - cXMLDOMNotation

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMNotation [Function FindNode]

FindNode - cXMLDOMNotation

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMNotation [Function FindNodeList]

FindNodeList - cXMLDOMNotation

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMNotation [Function FirstChild]

FirstChild - cXMLDOMNotation

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMNotation [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMNotation

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMNotation [Function IsElementNS]

IsElementNS - cXMLDOMNotation

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMNotation [Function LastChild]

LastChild - cXMLDOMNotation

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMNotation [Function NextElementNS]

NextElementNS - cXMLDOMNotation

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMNotation [Function NextNode]

NextNode - cXMLDOMNotation

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMNotation [Function NextSibling]

NextSibling - cXMLDOMNotation

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMNotation [Function ParentNode]

ParentNode - cXMLDOMNotation

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMNotation [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMNotation

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMNotation [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMNotation

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMNotation [Function PreviousSibling]

PreviousSibling - cXMLDOMNotation

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMNotation [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMNotation

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMNotation [Function RemoveNode]

RemoveNode - cXMLDOMNotation

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMNotation [Function ReplaceNode]

ReplaceNode - cXMLDOMNotation

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMNotation [Function XSLTransformation]

XSLTransformation - cXMLDOMNotation

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMNotation [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMNotation

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMNotation

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
ParentNode | Function | Returns an object that is the parent of the current node |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMNotation [Procedure AddAttribute]

AddAttribute - cXMLDOMNotation

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMNotation [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMNotation

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMNotation [Procedure AddCDataSection]

AddCDataSection - cXMLDOMNotation

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMNotation [Procedure AddChildComment]

AddChildComment - cXMLDOMNotation

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMNotation [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMNotation

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMNotation [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMNotation

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMNotation [Procedure AddElement]

AddElement - cXMLDOMNotation

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMNotation [Procedure AddElementNS]

AddElementNS - cXMLDOMNotation

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMNotation [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMNotation

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMNotation [Procedure EnumerateElements]

EnumerateElements - cXMLDOMNotation

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMNotation [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMNotation

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMNotation [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMNotation

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMNotation [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMNotation

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMNotation

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psPublicId |  | BaseXmlDomNotation
psSystemId |  | BaseXmlDomNotation
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for cXMLDOMProcessingInstruction

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMProcessingInstruction [Function AddAttributeNode]

AddAttributeNode - cXMLDOMProcessingInstruction

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMProcessingInstruction [Function AddChildNode]

AddChildNode - cXMLDOMProcessingInstruction

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMProcessingInstruction [Function AddElement]

AddElement - cXMLDOMProcessingInstruction

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function AddElementNS]

AddElementNS - cXMLDOMProcessingInstruction

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function AppendNode]

AppendNode - cXMLDOMProcessingInstruction

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMProcessingInstruction [Function AttributeNodes]

AttributeNodes - cXMLDOMProcessingInstruction

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMProcessingInstruction [Function AttributeValueNode]

AttributeValueNode - cXMLDOMProcessingInstruction

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMProcessingInstruction [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMProcessingInstruction

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMProcessingInstruction [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMProcessingInstruction

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMProcessingInstruction [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMProcessingInstruction

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMProcessingInstruction [Function ChildElementNS]

ChildElementNS - cXMLDOMProcessingInstruction

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMProcessingInstruction

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function ChildNodes]

ChildNodes - cXMLDOMProcessingInstruction

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMProcessingInstruction [Function ChildNodeValue]

ChildNodeValue - cXMLDOMProcessingInstruction

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMProcessingInstruction [Function CloneNode]

CloneNode - cXMLDOMProcessingInstruction

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMProcessingInstruction [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMProcessingInstruction

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMProcessingInstruction [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMProcessingInstruction

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMProcessingInstruction [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMProcessingInstruction

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMProcessingInstruction [Function CreateChildComment]

CreateChildComment - cXMLDOMProcessingInstruction

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMProcessingInstruction [Function CreateChildNode]

CreateChildNode - cXMLDOMProcessingInstruction

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMProcessingInstruction [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMProcessingInstruction

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMProcessingInstruction [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMProcessingInstruction

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMProcessingInstruction [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMProcessingInstruction

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMProcessingInstruction [Function CreateElementNode]

CreateElementNode - cXMLDOMProcessingInstruction

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMProcessingInstruction

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function ElementNodes]

ElementNodes - cXMLDOMProcessingInstruction

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMProcessingInstruction [Function FindNode]

FindNode - cXMLDOMProcessingInstruction

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMProcessingInstruction [Function FindNodeList]

FindNodeList - cXMLDOMProcessingInstruction

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMProcessingInstruction [Function FirstChild]

FirstChild - cXMLDOMProcessingInstruction

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMProcessingInstruction [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMProcessingInstruction

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMProcessingInstruction [Function IsElementNS]

IsElementNS - cXMLDOMProcessingInstruction

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function LastChild]

LastChild - cXMLDOMProcessingInstruction

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMProcessingInstruction [Function NextElementNS]

NextElementNS - cXMLDOMProcessingInstruction

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function NextNode]

NextNode - cXMLDOMProcessingInstruction

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMProcessingInstruction [Function NextSibling]

NextSibling - cXMLDOMProcessingInstruction

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMProcessingInstruction [Function ParentNode]

ParentNode - cXMLDOMProcessingInstruction

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMProcessingInstruction [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMProcessingInstruction

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMProcessingInstruction [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMProcessingInstruction

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function PreviousSibling]

PreviousSibling - cXMLDOMProcessingInstruction

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMProcessingInstruction [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMProcessingInstruction

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function RemoveNode]

RemoveNode - cXMLDOMProcessingInstruction

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function ReplaceNode]

ReplaceNode - cXMLDOMProcessingInstruction

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function XSLTransformation]

XSLTransformation - cXMLDOMProcessingInstruction

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMProcessingInstruction

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMProcessingInstruction

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
ParentNode | Function | Returns an object that is the parent of the current node |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMProcessingInstruction [Procedure AddAttribute]

AddAttribute - cXMLDOMProcessingInstruction

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMProcessingInstruction [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMProcessingInstruction

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Procedure AddCDataSection]

AddCDataSection - cXMLDOMProcessingInstruction

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Procedure AddChildComment]

AddChildComment - cXMLDOMProcessingInstruction

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMProcessingInstruction

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMProcessingInstruction

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Procedure AddElement]

AddElement - cXMLDOMProcessingInstruction

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Procedure AddElementNS]

AddElementNS - cXMLDOMProcessingInstruction

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMProcessingInstruction

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Procedure EnumerateElements]

EnumerateElements - cXMLDOMProcessingInstruction

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMProcessingInstruction

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMProcessingInstruction

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMProcessingInstruction [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMProcessingInstruction

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMProcessingInstruction

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psTarget |  | BaseXmlDomProcessingInstruction
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


Events for cXMLDOMTextNode

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


cXMLDOMTextNode [Function AddAttributeNode]

AddAttributeNode - cXMLDOMTextNode

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | [ToDo: In Progress]

Return Value

Description

Last Edited: March 24, 2004


cXMLDOMTextNode [Function AddChildNode]

AddChildNode - cXMLDOMTextNode

Adds a child node of specified type

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | NamespaceURI name of new node

Return Value

Returns object handle of newly created and added node, zero if failure

Description

AddChildNode adds a child node and returns the object handle of the newly created object.

Last Edited: April 7, 2004


cXMLDOMTextNode [Function AddElement]

AddElement - cXMLDOMTextNode

Creates a new node and appends it to the list

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Returns an object handle to a newly created XML node object. If zero, the object could not be created.

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and appends it to the list.

Example

Get AddElement of hoRoot sFile "" to hoTable

This sample creates a a new node element and returns a handle to the element.

The two following examples yield the same result:

Get AddElement Of hoRow 'CUSTOMERNAME' Customer.Name To hoField

Get AddElement Of hoRow 'CUSTOMERNAME' '' To hoField
If (hoField <> 0) Begin
    Set psText Of hoField To Customer.Name
End

Note: You are encouraged to check the value of hoField after the Get AddElement is executed because hoField will be zero if the operation failed for any reason (e.g. when sFieldName is blank.)

Last Edited: February 17, 2005


cXMLDOMTextNode [Function AddElementNS]

AddElementNS - cXMLDOMTextNode

Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Return Value

Return the object handle of the newly created XML element object

Description

AddElementNS creates a new node and appends it to the list. This procedure adds the node and returns an object. This allows you to create additional child nodes for the element. If you element does not have child nodes (elements or attributes) you can use the procedure AddElementNS.

Get AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

This sample creates a new node element and append it to hoRoot. It then calls a method to perform extra processing on the element node.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAllCustomers hoCust
Send Destroy of hoCust

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1 hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (Found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy Of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(send) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMTextNode [Function AppendNode]

AppendNode - cXMLDOMTextNode

Appends a node to the end of list

Type: Function

Return Data Type: Handle

Parameters: handle hoNode

Parameter | Description
hoNode | the object node that needs to be appended

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged.

Description

AppendNode appends a node to the end of list. The object node that needs to be appended is passed as hoNode. The object receiving this message will become the parent node for the node.

Last Edited: July 30, 2003


cXMLDOMTextNode [Function AttributeNodes]

AttributeNodes - cXMLDOMTextNode

Creates a collection of all attributes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a cXmlDomNamedNodeMap object or zero if no object is created.

Description

AttributeNodes is used to create a collection of all attributes. The attributes are returned as an object of class cXmlDomNamedNodeMap.

Get AttributeNodes of hoElement to hoAllAttributes

Last Edited: July 30, 2003


cXMLDOMTextNode [Function AttributeValueNode]

AttributeValueNode - cXMLDOMTextNode

Returns the object handle of an atttribute node whose Name matches the passed value

Type: Function

Return Data Type: Handle

Parameters: string sName

Parameter | Description
sBaseName | Name of attribute

Return Value

Returns the object handle of the attribute node whose Name matches the passed value. Returns zero if no match is found.

Description

AttributeValueNode is used to get the attribute node in an element node that matches the passed Name. Normally, you never need to return an attribute node. If you just need to get the attribute value use AttributeValue.

AttributeValueNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can useAttributeValueNodeNS .

See Also

AttributeValueNodeNS | AttributeValueNS

Last Edited: February 16, 2005


cXMLDOMTextNode [Function AttributeValueNodeNS]

AttributeValueNodeNS - cXMLDOMTextNode

Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sBaseName

Parameter | Description
sNamespace | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of attribute excluding the prefix

Return Value

Returns the object handle of the attribute node whose NamespaceURI and BaseName matches the passed values. Returns zero if no match is found.

Description

AttributeValueNodeNS is used to get the attribute node in an element node that matches the passed NamespaceURI and BaseName. Normally, you never need to return an attribute node. If you just need to get the attribute value use the AttributeValueNS method.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can use these namespace aware messages passing an empty string for the NameSpaceURI.
  • When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

AttributeValueNode | AttributeValueNS | AddAttributeNS

Last Edited: April 8, 2004


cXMLDOMTextNode [Function BaseNameFromQName]

BaseNameFromQName - cXMLDOMTextNode

Returns the BaseName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the basename, the name to the right of the ":"

Description

BaseNameFromQName is used to extract the BaseName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

PrefixNameFromQName

Last Edited: April 7, 2004


cXMLDOMTextNode [Function ChangeNodeClass]

ChangeNodeClass - cXMLDOMTextNode

Changes the class of an XML node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode integer iClassID

Parameter | Description
hoNode | The handle of the node class to be changed
iClassID | The DataFlex class ID (usually U_Classname)

Return Value

Returns an object handle to the newly changed node object.

Description

ChangeNodeClass would be used if you wished to change the class of a returned node. Using the passed object handle, the old object is destroyed and a new object is created based on the new type - that handle is returned.

You would only do this if you want to use a sub-class of the node's class.

This let's you change the class id of an object on an object by object basis. This would let you create nodes (e.g. elements) that have a custom interface for each node type. Normally, this would be sent after a node has been created using one of the default classes.

This is a an advanced topic.

Last Edited: July 30, 2003


cXMLDOMTextNode [Function ChildElementNS]

ChildElementNS - cXMLDOMTextNode

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

ChildElementNS is used to find a child element with a passed NamespaceURI and BaseName. It returns the object Id of first node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

If the node is a simple text only element you just need to get the node's text value you can use the ChildElementValueNS message.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name cnum="12">3A Software</m:Name>
    <m:State>CA</m:State>
</m:Customer>

The NamespaceURI for all of these elements is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName. We could search for elements as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot

// we need to get the element value and an attribute value from "Name". So we get its node
Get ChildElementNS of  hoRoot sNS "Name" to hoName
Get psText of hoName to sName
Get AttributeValueNS of hoName "" "cnum" to sNumber
Send Destroy of hoName

// State is a simple element. We can get the text an easier way
Get ChildElementValueNS of  hoRoot sNS "State" to sState

Send ShowInfo sName sNumber sState

You can also use this message along with NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementValueNS | NextElementNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMTextNode [Function ChildElementValueNS]

ChildElementValueNS - cXMLDOMTextNode

Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value

Type: Function

Return Data Type: String

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns a string representing the the text value of the first child element node that matches the passed NamespaceURI and BaseName. Returns an empty string if no match is found.

Description

ChildElementValueNS is used to find a child element with a passed NamespaceURI and BaseName and return that node's value. This can be used when the node is a simple text only element you just need to get the node's text value.

If the node contains child elements or attributes (that you wish to parse) you will need to get the node handle uisng ChildElementNS.

Assume we have the following XML document:

<m:Customer xmlns:m="http://www.dataaccess.com/Test/CustomerList">
    <m:Name>3A Software</m:Name>
    <m:Number>13</m:Number>
    <m:State>CA</m:State>
</m:Customer>

All elements are using the same NameSpaceURI which is "http://www.dataaccess.com/Test/CustomerList". As we parse this, notice that we ignore the prefix name ("m:"). We are only interested in the NamespaceURI and the BaseName.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get ChildElementValueNS of  hoRoot sNS "Name" to sName
Get ChildElementValueNS of  hoRoot sNS "Number" to sNumber
Get ChildElementValueNS of  hoRoot sNS "State" to sState

In this sample, ChildElementValueNS is used along with ChildElementNS and NextElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

Here the NamespaceURI is "http://www.dataaccess.com/Test/CustomerList". In this case, all elements are part of the default namespace (i.e., no prefixes). Once again, we ignore the prefixes and rely on the NamespaceURI and BaseName. You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CustomerList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While hoCust
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | NextElementNS | IsElementNS

Last Edited: February 17, 2005


cXMLDOMTextNode [Function ChildNodes]

ChildNodes - cXMLDOMTextNode

Creates a collection of all nodes

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns a handle to a [CLink:cXmlDomNodeList] object.

Description

ChildNodes is for creating a collection of all nodes.

Last Edited: July 30, 2003


cXMLDOMTextNode [Function ChildNodeValue]

ChildNodeValue - cXMLDOMTextNode

Gets the "value" of an element

Type: Function

Return Data Type: String

Parameters: String sTagName

Parameter | Description
sTagName | The Element tag Name

Return Value

The element's text value

Description

ChildNodeValue is used to get the "value" of an element. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This function lets you do this and hides the creation, finding and disposing of the text node.

If a node matching the passed sTagName does not exist, the result will be an empty string. If the node does exist, but is empty, the result will also be an empty string. So it is impossible to tell from the result of this call whether the node was there or not. If you want to handle empty nodes differently from non existing nodes, you should use the enumeration functions like NextSibling, PreviousSibling, NextNode.

Get ChildNodeValue of hoCustomerElement "Name" to sCustName

Last Edited: June 4, 2004


cXMLDOMTextNode [Function CloneNode]

CloneNode - cXMLDOMTextNode

Creates a clone of the passed node

Type: Function

Return Data Type: Handle

Parameters: integer bRecurse

Parameter | Description
bRecurse | If True, copy child nodes

Return Value

If successful, the method will return an object handle to the newly created cloned node. If a zero is returned, the operation failed.

Description

CloneNode creates a clone of the passed node. If bRecurse is true, the node and all its descendents will be cloned (a deep clone), if bRecurse if false, only the node will be cloned (a shallow clone).

Last Edited: July 30, 2003


cXMLDOMTextNode [Function CreateAttributeNode]

CreateAttributeNode - cXMLDOMTextNode

Creates an attribute in a document

Type: Function

Return Data Type: Handle

Parameters: String sName String sValue

Parameter | Description
sName | the name of the attribute
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateAttributeNode creates an attribute in a document. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

CreateAttributeNode is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use CreateAttributeNodeNS.

See Also

CreateAttributeNodeNS

Last Edited: April 8, 2004


cXMLDOMTextNode [Function CreateAttributeNodeNS]

CreateAttributeNodeNS - cXMLDOMTextNode

Creates an namespace aware attribute and returns its object handle

Type: Function

Return Data Type: Handle

Parameters: string sNameSpace string sName String sValue

Parameter | Description
sNameSpace | the element NamespaceURI
sName | the name of the attribute including a prefix
sValue | the value of the attribute

Return Value

If successful, the function returns an object handle for the newly created attribute node.

Description

CreateAttributeNodeNS creates an attribute node. This function creates an XML node but does not add it to an XML element. An attribute node can be created and appended in a single step using the AddAttributeNS message.

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddAttributeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: April 8, 2004


cXMLDOMTextNode [Function CreateCDATASectionNode]

CreateCDATASectionNode - cXMLDOMTextNode

Creates a cDataSection text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | Text to be added to node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateCDataSectionNode creates a cDataSection text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMTextNode [Function CreateChildComment]

CreateChildComment - cXMLDOMTextNode

Creates a child comment

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the comment text

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildComment creates a child comment. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMTextNode [Function CreateChildNode]

CreateChildNode - cXMLDOMTextNode

Creates a node in the document and assign its interface to the new DF object

Type: Function

Return Data Type: Handle

Parameters: Integer iNodeType String sTagName String sNameSpace

Parameter | Description
iNodeTypeValid node types are:

Constant | Meaning
NODE_ELEMENT | Element
NODE_ATTRIBUTE | Attribute
NODE_TEXT | Text
NODE_CDATA_SECTION | CData Section
NODE_ENTITY_REFERENCE | Entity Reference
NODE_ENTITY | Entity
NODE_PROCESSING_INSTRUCTION | Processing Instruction
NODE_COMMENT | Comment
NODE_DOCUMENT | Document
NODE_DOCUMENT_TYPE | Document Type (DTD)
NODE_DOCUMENT_FRAGMENT | Document Fragment
NODE_NOTATION | Notation

sTagName | Tag Name for new node
sNameSpace | Namespace name of new node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed.

Description

CreateChildNode creates a node in the document and assign its interface to the new DF object.

You can use the message CreateChildNode to create namespace nodes where you pass the tag and namespace as a separate parameter. See AddElement for more information on namespaces.

Last Edited: August 18, 2003


cXMLDOMTextNode [Function CreateChildProcessingInstruction]

CreateChildProcessingInstruction - cXMLDOMTextNode

Creates a child processing instruction

Type: Function

Return Data Type: Handle

Parameters: String sTarget String sValue

Parameter | Description
sTarget | The PI target
sValue | The PI Value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildProcessingInstruction creates a child processing instruction. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

This is how you would add a Processing instruction to the top of your document. Assume the document has been created and the root element is defined. You want to add the processing instruction before the root element:

Get CreateChildProcessingInstruction of hoRoot "xml-myPI" "whatever you want goes here" to hoPI
Get InsertBeforeNode of hoRoot hoPI hoRoot to hoPI
Send Destroy of hoPI

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMTextNode [Function CreateChildTextNode]

CreateChildTextNode - cXMLDOMTextNode

Creates a child text node

Type: Function

Return Data Type: Handle

Parameters: String sValue

Parameter | Description
sValue | the text value of the node

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateChildTextNode creates a child text node. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMTextNode [Function CreateDocumentFragmentNode]

CreateDocumentFragmentNode - cXMLDOMTextNode

Creates an XML Document Fragment node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateDocumentFragmentNode creates a document fragment node object. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add.. messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: July 31, 2003


cXMLDOMTextNode [Function CreateElementNode]

CreateElementNode - cXMLDOMTextNode

Creates an XML Element node

Type: Function

Return Data Type: Handle

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNode creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

Note: All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Last Edited: February 17, 2005


cXMLDOMTextNode [Function CreateElementNodeNS]

CreateElementNodeNS - cXMLDOMTextNode

Creates an XML Element node that is namespace aware

Type: Function

Return Data Type: Handle

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The element tag name
sValue | The element's value

Return Value

If successful, the function returns an object handle for the newly created node. If zero is returned, the operation failed. If a node is returned, it is your responsibility to eventually destroy the object (e.g. Send Destroy of hoMyCreatedNode).

Description

CreateElementNodeNS creates an node object for the element type. This function creates an XML node but does not add it to the XML document. Nodes can be created and appended in a single step using the Add... messages.

All XML objects created using any of the CreateXxxxx methods will create the DataFlex object as a child of the main document node (the cXmlDomDocumentObject). The actual hierarchy of your XML document has nothing to do with this object placement. The messages AppendNode, InsertBeforeNode and CloneNode determine placement of an XML node object within the document, where the object receiving the message will become the parent node.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use CreateElementNodeNS and not CreateElementNode).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateAttributeNodeNS | AddAttributeNS

Last Edited: February 17, 2005


cXMLDOMTextNode [Function ElementNodes]

ElementNodes - cXMLDOMTextNode

Returns a collection of just the elements

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | The query search string

Return Value

Returns a handle to a cXmlDomNodeList object containing elements. Returns zero if object cannot be created

Description

ElementNodes returns a collection of just the elements that meet the search requirements of the passed queried string. Returns a handle to a cXmlDomNodeList object containing elements.

Get ElementNodes of hoRoot "Customer" to hoAllCustomersNode

Last Edited: August 5, 2003


cXMLDOMTextNode [Function FindNode]

FindNode - cXMLDOMTextNode

Returns a handle to a single XML node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns an object handle to a single XML node, zero if no node found

Description

FindNode returns a handle to a single XML node.

Last Edited: August 18, 2003


cXMLDOMTextNode [Function FindNodeList]

FindNodeList - cXMLDOMTextNode

Returns a handle to a cXmlDomNodeList object

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Search Query string

Return Value

Returns a handle to a cXmlDomNodeList object

Description

FindNodeList returns a handle to a cXmlDomNodeList object.

Last Edited: August 18, 2003


cXMLDOMTextNode [Function FirstChild]

FirstChild - cXMLDOMTextNode

Finds the first child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to th first child, zero if none

Description

FirstChild finds the first child of a node and returns a handle to it. The message is sent to the parent node. If it often used with NextNode to traverse all child nodes.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

The NextSibling message can also be used to find the next sibling node (and not destroy the current node). NextNode is usually preferred.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

NextNode | NextSibling | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMTextNode [Function InsertBeforeNode]

InsertBeforeNode - cXMLDOMTextNode

Inserts a new node before the current node

Type: Function

Return Data Type: Handle

Parameters: Integer hoNewNode Integer hoNode

Parameter | Description
hoNewNode | the node to insert
hoNode | the node to insert before

Return Value

If the operation is successful, the method will return the object handle that was passed, which now represents the appended node. If zero is returned, the operation failed and the old node remains unchanged

Description

InsertBeforeNode inserts a new node before the current node.

InsertBeforeNode supports two parameters, the node to insert and the node to insert before (the reference node) as follows:

  Get InsertBeforeNode of hoRoot hoNewNode hoReferenceNode to hoNewNode

If the reference node is zero or a second parameter is not passed, it will append (as per dom specification) making it act just like AppendNode.

Last Edited: August 18, 2003


cXMLDOMTextNode [Function IsElementNS]

IsElementNS - cXMLDOMTextNode

Returns true if xml node is an element that matches the passed NamespaceURI and basename

Type: Function

Return Data Type: Boolean

Parameters: string sNamespaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns true if the node is an element and the element's NamespaceURI and BaseName matches the passed values

Description

This function is used to search for an xml element by NamespaceURI and BaseName. If the node is an element, it checks to see if the node's psBaseName and psNamespaceURI matches the passed sBaseName sNamespaceURI.

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot
Get FirstChild of hoXml to hoNode
While hoNode
    Get IsElementNS of hoNode sNS "customer" to bIsCust
    If bIsCust begin
        Send HandleCustomerNode hoNode
    end
    Get NextNode of hoNode to hoNode
end

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | NextElementNS | psBaseName | psNamespaceURI | psPrefix

Last Edited: February 17, 2005


cXMLDOMTextNode [Function LastChild]

LastChild - cXMLDOMTextNode

Finds the last child of a node and returns a handle to it

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to thlast child node, zero if none

Description

LastChild finds the last child of a node and returns a handle to it. The message is sent to the parent node.

Get LastChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling | PreviousSibling

Last Edited: August 18, 2003


cXMLDOMTextNode [Function NextElementNS]

NextElementNS - cXMLDOMTextNode

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values

Type: Function

Return Data Type: Handle

Parameters: string sNameSpaceURI string sBaseName

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix

Return Value

Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values. Returns zero if no node is found.

Description

NextElementNS is used to find the next sibling element with a passed NamespaceURI and BaseName. It returns the object Id of next node that matches or zero if no node is found. As with any XML object node, you must make sure you destroy the node when you are done with it.

This message will often be used with ChildElementNS to traverse a list of child objects. Assume you have the following xml document:

<CustomerList xmlns="http://www.dataaccess.com/Test/CustomerList">
    <Customer>
        <Name>3A Software</Name>
        <Number>13</Number>
        <State>CA</State>
    </Customer>
    <Customer>
        <Name>Ace Manufacturers, Inc.</Name>
        <Number>4</Number>
        <State>IL</State>
    </Customer>
    <Customer>
        <Name>All Canada Brewing Company</Name>
        <Number>24</Number>
        <State>CA</State>
    </Customer>
</CustomerList>

You could parse all customers as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS // the namespace
Get DocumentElement of hoXML to hoRoot // this is CusomterList
Get ChildElementNS of hoRoot sNS "Customer" to hoCust
While (hoCust)
    Get ChildElementValueNS of  hoCust sNS "Name" to sName
    Get ChildElementValueNS of  hoCust sNS "Number" to sNumber
    Get ChildElementValueNS of  hoCust sNS "State" to sState
    Send DoThisCustomer sName sNumber sState
    Get NextElementNS of hoCust sNS "Customer" to hoCust
Loop

If you were sure that all of your child elements were the same, you could also use FirstChild and NextNode to do the same thing.

Elements with no NamespaceURI

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Note:When parsing XML documents with namespaces you should always search by NamespaceURI and BaseName. You should not use the element's prefix and you should not attempt to ignore the NamespaceURI.

See Also

ChildElementNS | ChildElementValueNS | IsElementNS | FirstChild | NextNode

Last Edited: February 17, 2005


cXMLDOMTextNode [Function NextNode]

NextNode - cXMLDOMTextNode

Returns the object's next sibling node and destroys the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns the object's next sibling node and destroys the current node. If no next sibling exists, zero is returned.

Description

NextNode is used to find the node's next sibling Xml object. It also destroys itsself. This makes it very easy to traverse a list of nodes without needing to needing to destroy each node manually. It is often used with FirstChild.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

This is similar to the NextSibling method, which finds the next sibling but does not destroy the existing node. The following example is the same as the sample. In most cases, you will find it easier to use NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

See Also

FirstChild | NextSibling

Last Edited: April 7, 2004


cXMLDOMTextNode [Function NextSibling]

NextSibling - cXMLDOMTextNode

Returns a handle to the next sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

NextSibling returns a handle to the next sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent).

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextSibling of hoNode to hoNextNode // now get next sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoNextNode to hoNode
Loop

You can use the NextNode to find the next sibling and destroy the current node. NextNode is usually the preferred method. Here is the same example using NextNode.

Get FirstChild of hoRoot to hoNode // get the first node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get NextNode of hoNode to hoNode // now get next sibling node
Loop

See Also

NextNode | FirstChild | PreviousSibling | LastChild

Last Edited: April 7, 2004


cXMLDOMTextNode [Function ParentNode]

ParentNode - cXMLDOMTextNode

Returns an object that is the parent of the current node

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object that is the parent of the current node

Description

ParentNode creates and returns a parent node object

Get ParentMode of hoNode to hoParentNode

Last Edited: September 10, 2003


cXMLDOMTextNode [Function PrefixNameFromQName]

PrefixNameFromQName - cXMLDOMTextNode

Returns the PrefixName from a Qualified Name string

Type: Function

Return Data Type: String

Parameters: string sName

Parameter | Description
sName | Qualified Name, i.e., PrefixName + ":" + BaseName (e.g. ns:customer)

Return Value

Returns the prefix name, the name to the left of the ":"

Description

PrefixNameFromQName is used to extract the PrefixName from a qualified string (i.e., a string that contains a prefix and a basename).

Move "ns:MyName" to sQName
Get BaseNameFromQName to sBaseName // = MyName
Get PrefixNameFromQName to sPrefix // = ns

See Also

BaseNameFromQName

Last Edited: April 7, 2004


cXMLDOMTextNode [Function PrefixToNamespaceURI]

PrefixToNamespaceURI - cXMLDOMTextNode

Finds the NamespaceURi string for a prefix

Type: Function

Return Data Type: String

Parameters: string sPrefix

Parameter | Description
sPrefix | Prefix name

Return Value

Returns the NamespaceURI string associated with the prefix

Description

PrefixToNamespaceURI finds the namespaceURI for a prefix. It starts its search at the XML object node receiving the message and proceeds up the object's structure (e.g., parent node, grandparent node) searching for an xmlns: attribute that matches the prefix. If found, the value of the attribute (the NamespaceURI) is returned, if not found, an empty string is returned.

You will never need to use this message with element or atribute names. You can acquire this information using the much simpler psNamespaceURI, psPrefix and psBaseName properties.

This message is only required in advanced parsing situations. This may be used when an attribute's value (not its name) contains a prefix and you need to associate that prefix with a namespace.

Get AttributeValue of hoNode "type" to sName
Get PrefixNameFromQName sName to sPrefix
Get BaseNameFromName sName to sName
if (sPrefix<>"") begin
    Get PrefixToNamespace of hoSchemaNode sPrefix to sNamespace
end

See Also

PrefixNameFromQName | BaseNameFromQName | psNamespaceURI | psPrefix | psBaseName

Last Edited: February 17, 2005


cXMLDOMTextNode [Function PreviousSibling]

PreviousSibling - cXMLDOMTextNode

Returns a handle to the previous sibling of this node in the parent's child list

Type: Function

Return Data Type: Handle

Parameters: No Parameters

Return Value

Returns an object handle to the next node, zero if no more nodes.

Description

PreviousSibling returns a handle to the previous sibling of this node in the parent's child list. The message is sent to the child objects (i.e. the siblings - not the parent)

Handle hoNode hoPreviousNode
Get LastChild of hoRoot to hoNode // get the last node
While (hoNode<>0)
    Send ShowInformation hoNode
    Get PreviousSibling of hoNode to hoPreviousNode // now get previous sibling node
    Send Destroy of hoNode     // Important: get rid of the previous node object
    Move hoPreviousNode to hoNode
Loop

See Also

FirstChild | PreviousSibling | NextSibling

Last Edited: October 27, 2003


cXMLDOMTextNode [Function RemoveNamedNode]

RemoveNamedNode - cXMLDOMTextNode

Removes the named node

Type: Function

Return Data Type: Handle

Parameters: String sQueryString

Parameter | Description
sQueryString | Node Name

Return Value

The returned value is the object handle of the node that got removed (assuming the named node was found), or 0 if not.

Description

RemoveNamedNode removes the named node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got removed (assuming the named node was found), or 0 if not.

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a removed node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMTextNode [Function RemoveNode]

RemoveNode - cXMLDOMTextNode

Removes a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNode

Parameter | Description
hoNode | Object Handle of node to remove

Return Value

Returns the object handle of the node that was removed, zero if failure

Description

RemoveNode removes a node. The object handle of the node to be removed must be passed and the message must be sent to the parent of the node to be removed.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it.

Get RemoveNode of hoParentNode hoNodeToRemove to hoRemoved
Send destroy of hoRemoved

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node.

Last Edited: February 17, 2005


cXMLDOMTextNode [Function ReplaceNode]

ReplaceNode - cXMLDOMTextNode

Replaces a node

Type: Function

Return Data Type: Handle

Parameters: integer hoNewNode integer hoNodeToReplace

Parameter | Description
hoNewNode | Object Handle of the new node
hoNodeToReplace | Object Handle of the node to be replaced

Return Value

Returns the object handle of the node that was replaced, zero if failure

Description

ReplaceNode replaces a node.

An object handle is returned, and the object must be disposed of by sending the Destroy message to it. The returned value is the object ID of the node that got replaced.

Get ReplaceNode of hoElement hoNewChildElement hoOldChildElement to hoOldNode

Note:This function returns an XML node object and, like all XML node objects, it is the responsibility of the developer to destroy them when they are no longer needed. The reason IDs are returned and not automatically destroyed is that it gives you the ability to do something else with the node. You could, for example, take a replaced node and add it somewhere else.

Last Edited: February 17, 2005


cXMLDOMTextNode [Function XSLTransformation]

XSLTransformation - cXMLDOMTextNode

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string

Type: Function

Return Data Type: String

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns an XML string created by the transformation

Description

XSLTransformation processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Example

// Create and load the XML document
Get Create U_cXMLDOMDocument to hoXML
Set psDocumentName of hoXML to (sPath - "\customer.xml")
Get LoadXMLDocument of hoXML to bOK

// Create and load the XSL document
Get Create U_cXMLDOMDocument to hoXSL
Set psDocumentName of hoXSL to (sPath - "\customer.xsl")
Get LoadXMLDocument of hoXSL to bOK

// Transform the XML document using the XSL document as the stylesheet
// return the value as a string to sData
// Get DocumentElement of hoXML to hoRoot

Get XSLTransformation of hoRoot hoXSL to sData

Send Destroy of hoXSL
Send Destroy of hoXML

If the returned XML string is very large (larger than the allowed string size) you may wish to use the XSLTransformationToAddress method.

See Also

XSLTransformationToAddress

Last Edited: February 17, 2005


cXMLDOMTextNode [Function XSLTransformationToAddress]

XSLTransformationToAddress - cXMLDOMTextNode

Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer

Type: Function

Return Data Type: Address

Parameters: Integer hoXSLDocument

Parameter | Description
hoXSLDocument | Handle to XSL document which will be used in the transformation

Return Value

Returns a pointer to the XML data that was created by the transformation

Description

XSLTransformationToAddress processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, places the transformation in heap memory and returns a pointer to that data. This message can be used to transform large documents (documents that are larger than allowed string length).

Data created by this transformation is often loaded into another XML document using the LoadXMLFromAddress method.

The XSL stylesheet is passed as either an XML document (since XSL stylesheets are XML files) or as an XSL node. In either case the XSL transformation is applied to the object that receives the message. If this object is the XML root node (the document element), the entire XML document will be transformed.

The XSL stylesheet and the transformation uses "standard" XSL processing rules as defined by Microsoft's IE5 XMLDOM parser. Transformations can be used to transform XML to any type of format (e.g. another XML document; an HTML or an XHTML document; simple text, or whatever). The XSL stylesheet, which is itself an XML document, determines how the transformation will be applied.

Note:This method requires that you dispose of the memory allocated by the transformation. You do this with the Free() function.

Example

Function TransformDocument handle hoOldXML handle hoXSL returns Handle
     Handle hoNewXML hoRoot
     Address aNewXml
     Boolean bOk

     Get DocumentElement of hoOldXML to hoRoot

     // Transform the XML document from the root
     // using the XSL document as the stylesheet
     // return the value as a memory pointer
     Get XSLTransformationToAddress of hoRoot hoXSL to aNewXml

     // Create and load the new XML document
     Get Create U_cXMLDOMDocument to hoNewXml
     Get LoadXMLFromAddress of hoNewXml aNewXml to bOk

     // remember to free the memory
     Move (Free(aNewXml)) to bOk

     // destroy the old root node
     Send Destroy of hoRoot

     // return new XML document
     function_return hoNewXml
End_Function

XSLTransformationToAddress is normally only needed to transform very large documents (i.e., documents that may be larger than the maximum allowed string size.) For most transformations, you may use the XSLTransformation method to return the XML data as a string.

See Also

XSLTransformation | LoadXMLFromAddress

Last Edited: June 4, 2004


Methods for cXMLDOMTextNode

View method list in hierarchical order

Name | Type | Description | Defining Class
AddAttribute | Procedure | Encapsulates creation and addition of attributes to a node |
AddAttributeNode | Function |  |
AddAttributeNS | Procedure | Creates an attribute node (that is namespace aware) and adds it to the element node |
AddCDataSection | Procedure | Encapsulates creation and addition of cDataSection nodes to a node |
AddChildComment | Procedure | Encapsulates creation and addition of comments to a node |
AddChildNode | Function | Adds a child node of specified type |
AddChildProcessingInstruction | Procedure | Encapsulates creation and addition of processing instructions to a node |
AddChildTextNode | Procedure | Encapsulates creation and addition of text nodes to a node |
AddElement | Function | Creates a new node and appends it to the list |
AddElement | Procedure | Creates a new node and append it to the list |
AddElementNS | Function | Creates a new Element node (that is namespace aware), appends it to the list, and returns its object handle |
AddElementNS | Procedure | Creates a new Element node (that is namespace aware) and appends it to the list |
AppendNode | Function | Appends a node to the end of list |
AttributeNodes | Function | Creates a collection of all attributes |
AttributeValueNode | Function | Returns the object handle of an atttribute node whose Name matches the passed value |
AttributeValueNodeNS | Function | Returns the object handle of an atttribute node whose NamespaceURI and BaseName matches the passed values |
BaseNameFromQName | Function | Returns the BaseName from a Qualified Name string |
ChangeNodeClass | Function | Changes the class of an XML node |
ChildElementNS | Function | Returns the object handle of the first child element node whose NamespaceURI and BaseName matches the passed values |
ChildElementValueNS | Function | Finds the first child element node that matches the passed NamespaceURI and BaseName and returns its text value |
ChildNodes | Function | Creates a collection of all nodes |
ChildNodeValue | Function | Gets the "value" of an element |
CloneNode | Function | Creates a clone of the passed node |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateAttributeNode | Function | Creates an attribute in a document |
CreateAttributeNodeNS | Function | Creates an namespace aware attribute and returns its object handle |
CreateCDATASectionNode | Function | Creates a cDataSection text node |
CreateChildComment | Function | Creates a child comment |
CreateChildNode | Function | Creates a node in the document and assign its interface to the new DF object |
CreateChildProcessingInstruction | Function | Creates a child processing instruction |
CreateChildTextNode | Function | Creates a child text node |
CreateDocumentFragmentNode | Function | Creates an XML Document Fragment node |
CreateElementNode | Function | Creates an XML Element node |
CreateElementNodeNS | Function | Creates an XML Element node that is namespace aware |
Destroy | Procedure |  | cObject
ElementNodes | Function | Returns a collection of just the elements |
EnumerateAttributes | Procedure | Provides a way to enumerate through all child attributes |
EnumerateElements | Procedure | Provides a way to enumerate through all child elements |
EnumerateNodes | Procedure | Provides a way to enumerate through all child nodes |
Exit_Application | Procedure | Starts the process of closing an application | cObject
FindNode | Function | Returns a handle to a single XML node |
FindNodeList | Function | Returns a handle to a cXmlDomNodeList object |
FirstChild | Function | Finds the first child of a node and returns a handle to it |
InsertBeforeNode | Function | Inserts a new node before the current node |
IsElementNS | Function | Returns true if xml node is an element that matches the passed NamespaceURI and basename |
LastChild | Function | Finds the last child of a node and returns a handle to it |
NextElementNS | Function | Returns the object handle of the next sibling element node whose NamespaceURI and BaseName matches the passed values |
NextNode | Function | Returns the object's next sibling node and destroys the current node |
NextSibling | Function | Returns a handle to the next sibling of this node in the parent's child list |
ParentNode | Function | Returns an object that is the parent of the current node |
PrefixNameFromQName | Function | Returns the PrefixName from a Qualified Name string |
PrefixToNamespaceURI | Function | Finds the NamespaceURi string for a prefix |
PreviousSibling | Function | Returns a handle to the previous sibling of this node in the parent's child list |
RemoveNamedNode | Function | Removes the named node |
RemoveNode | Function | Removes a node |
ReplaceNode | Function | Replaces a node |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
SetChildElementValueNS | Procedure | Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value |
SetChildNodeValue | Procedure | Allows a parent to change the text of one of its elements |
XSLTransformation | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a string |
XSLTransformationToAddress | Function | Processes the node of the object receiving the message and all its children using the XSL stylesheet document passed, and returns the resulting transformation as a pointer |


cXMLDOMTextNode [Procedure AddAttribute]

AddAttribute - cXMLDOMTextNode

Encapsulates creation and addition of attributes to a node

Type: Procedure

Parameters: String sName String sValue

Parameter | Description
sName | the name of the node
sValue | the value of the node

Description

AddAttribute encapsulates creation and addition of attributes to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

   Send AddAttribute Of  hoTable "File" iFile

This sample creates a child attribute node for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

AddAttribute is not namespace aware and should only be used with attributes with no namespaces (i.e., in the global namespace). If you need to create attributes with namespaces you can use AttributeValueNS and AddAttributeNS.

See Also

AttributeValueNS | AddAttributeNS

Last Edited: April 20, 2005


cXMLDOMTextNode [Procedure AddAttributeNS]

AddAttributeNS - cXMLDOMTextNode

Creates an attribute node (that is namespace aware) and adds it to the element node

Type: Procedure

Parameters: String sNameSpace String sName String sValue

Parameter | Description
sNameSpace | the attribute NamespaceURI
sName | the name of the attribute node, including a prefix.
sValue | the value of the attribute node

Description

AddAttributeNS encapsulates creation and addition of attributes to an element node. This procedure creates the attribute, sets the values and adds it to the element node that received the message.

If for any reason the node cannot be added to the element, an error will be generated.

This sample adds an attribute using a namespace. Note the use of the prefix (m:).

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Get AddElementNS of hoRoot sNS "Customer"  ""  to hoCust
Send AddAttributeNS of hoCust sNS "m:table" iTable
Send Destroy of hoCust

Attributes are often added to the global namespace. This sample creates an attribute with a global ("") namespace.

// add attribute with no namespace or prefix
Send AddAttributeNS Of  hoEle "" "table" iTable

You could also use the AddAttribute to create such an attribute

Send AddAttribute Of  hoEle "table" iTable

Attributes and Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI.

  • Attributes are less likely to use namespaces (i.e., they are more likely to use the global namespace).
  • Attributes never use the default namespace (xmlns="xx"). If the attribute does not have a prefix, it is in the global namespace.
  • If a namespace is used, a prefix must be supplied.
  • A prefix is supplied by adding the prefix to the sName (e.g., sName="m:table").
  • If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AttributeValueNS | RemoveAttributeNS | CreateAttributeNodeNS | AddElementNS(send) | AddElementNS(get) | CreateDocumentElementNS | CreateElementNodeNS

Last Edited: February 17, 2005


cXMLDOMTextNode [Procedure AddCDataSection]

AddCDataSection - cXMLDOMTextNode

Encapsulates creation and addition of cDataSection nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The text value

Description

AddCDataSection encapsulates creation and addition of cDataSection nodes to a node. A cDataSection is a special section of code that XML does not attempt to parse. It uses an unusual start and stop markup: <![CDATA[....your text.....]]>

If you use this procedure, make sure your text does not contain ": <![CDATA[" or "]]: >"

Example

The following example shows how you'd add cDataSection text, showing the differences from adding normal text. With a cDataSection you will leave the element text blank and actually create a child cDataSection node to store the data:

Procedure OutPutRows handle hoNode integer iFile
    integer iField iFields bRetVal
    string sTag sField
    handle hoRow hoField

    Get AddElement of hoNode "Row" "" to hoRow
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile to iFields
    For iField from 1 to iFields
        Get_Field_Value iFile iField to sField
        Move (trim(sField)) to sfield
        Get_Attribute DF_FIELD_NAME of iFile iField to sTag

        //the following line is changed:
        //Get AddElement of hoRow "Field" sField to hoField
        Get AddElement of hoRow "Field" "" to hoField
        Send AddAttribute Of hoField "Field-number" iField
        Send AddAttribute Of hoField "Name" sTag
        //the following line is added:
        Send AddCDataSection of hoField sField
        Send Destroy of hoField
    Loop
    Send Destroy of hoRow
End_Procedure

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMTextNode [Procedure AddChildComment]

AddChildComment - cXMLDOMTextNode

Encapsulates creation and addition of comments to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | The comment text

Description

AddChildComment encapsulates creation and addition of comments to a node. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Example

Send AddChildComment of hoTable ("Add  all records for "+sFile)

This sample creats a child comment for an element, using an interface that created the node but did not create a new DataFlex object (which is why a handle is not returned).

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMTextNode [Procedure AddChildProcessingInstruction]

AddChildProcessingInstruction - cXMLDOMTextNode

Encapsulates creation and addition of processing instructions to a node

Type: Procedure

Parameters: String sTarget String sValue

Parameter | Description
sTarget | Target name
sValue | Value text

Description

AddChildProcessingInstruction encapsulates creation and addition of processing instructions to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMTextNode [Procedure AddChildTextNode]

AddChildTextNode - cXMLDOMTextNode

Encapsulates creation and addition of text nodes to a node

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the text value to be added

Description

AddChildTextNode encapsulates creation and addition of text nodes to a node.

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMTextNode [Procedure AddElement]

AddElement - cXMLDOMTextNode

Creates a new node and append it to the list

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElement is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use AddElementNS in its place.

AddElement creates a new node and append it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElement function).

Sample

This sample creates a a new node element and returns a handle to the element.

Send AddElement of hoRoot "Customer" sName

Note:If for any reason the node cannot be added to the document, an error will be generated.

Last Edited: February 17, 2005


cXMLDOMTextNode [Procedure AddElementNS]

AddElementNS - cXMLDOMTextNode

Creates a new Element node (that is namespace aware) and appends it to the list

Type: Procedure

Parameters: String sNameSpace String sTagName String sValue

Parameter | Description
sNameSpace | The element NamespaceURI
sTagName | The name of the Element Tag
sValue | Value of the element

Description

AddElementNS creates a new node and appends it to the list. When used as a procedure, the object is destroyed. This procedure adds the node but does not return an object. Only elements usually have children (which is why there is also an AddElementNS function).

Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Customer"  sCustName
Send AddElementNS of hoRoot "http://www.dataaccess.com/Test/CustomerList" "Vendor"  sVndrName

This sample creates two new node elements and appends them to hoRoot.

NamespaceURIs are always required. Usually the value will be represented as a string as follows:

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send AddElementNS of hoRoot sNS "Customer"  sCustName
Send AddElementNS of hoRoot sNS "Vendor"  sVndrName

Note: If for any reason the node cannot be added to the document, an error will be generated.

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use AddElementNS and not AddElement).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

Example

Function CustomerXMLList Returns XmlHandle
   Integer bOk
   Handle hoXML hoRoot hoEle hoXML1 hoRoot1
   Handle hoCustomerDD
   String sName sNumber sState sNamespace

   Move Customer_dd to hoCustomerDD

   // namespace to use for document
   Move "http://www.dataaccess.com/Test/CustomerList" to sNameSpace

   // create XML document / Create root node
   Get Create U_cXMLDomDocument To hoXML
   // Create the Root element named CustomerList
   Get CreateDocumentElementNS Of hoXML sNameSpace "CustomerList" To hoRoot
   // now go through all customer records
   Send Clear of hoCustomerDD
   Send Find of hoCustomerDD ge 2
   While (found)
       // get name, number and state to strings
       Move (trim(Customer.Name))    To sName
       Move Customer.Customer_Number To sNumber
       Move (trim(Customer.State))   To sState
       // for each customer create customer node with child elements
       Get AddElementNS Of hoRoot sNameSpace "Customer" "" To hoEle
          Send AddElementNS Of hoEle sNameSpace "Name"   sName
          Send AddElementNS Of hoEle sNameSpace "Number" sNumber
          Send AddElementNS Of hoEle sNameSpace "State"  sState
       Send Destroy of hoEle
       Send Find of hoCustomerDD gt 2
   Loop
   Function_Return hoXML
End_Function

See Also

AddElementNS(get) | CreateElementNodeNS | CreateAttributeNodeNS | AddAttributeNS | CreateDocumentElementNS

Last Edited: February 17, 2005


cXMLDOMTextNode [Procedure EnumerateAttributes]

EnumerateAttributes - cXMLDOMTextNode

Provides a way to enumerate through all child attributes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sSomeValue

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sSomeValue | Value passed to iMsg message as the second parameter

Description

EnumerateAttributes provides a way to enumerate through all child attributes. For each valid node type the message iMsg is sent to the object hoReceiver, passing two parameters - a handle to the attribute node and sSomeValue

Sample

Procedure ShowAtt handle hoNode integer iLevel
    string sName sValue

    Get psName of hoNode to sName
    Get psNodeValue of hoNode to sValue
    Showln iLevel " : " sName " - " sValue
End_Procedure

Procedure ShowNode handle hoNode integer iLevel string sX
    string sName

    Get psNodeName of hoNode to sName
    ShowLn iLevel " :" sName
    Increment iLevel
    Send EnumerateAttributes of hoNode msg_showAtt  self iLevel
    Send EnumerateElements   of hoNode msg_showNode self iLevel sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMTextNode [Procedure EnumerateElements]

EnumerateElements - cXMLDOMTextNode

Provides a way to enumerate through all child elements

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateElements provides a way to enumerate through all child elements. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateAttributes | EnumerateNodes

Last Edited: February 17, 2005


cXMLDOMTextNode [Procedure EnumerateNodes]

EnumerateNodes - cXMLDOMTextNode

Provides a way to enumerate through all child nodes

Type: Procedure

Parameters: Integer iMsg Integer hoReceiver String sVal1 String sVal2

Parameter | Description
iMsg | the message that is sent
hoReceiver | the object that the message is sent to
sVal1 | parameter which you define
sVal2 | parameter which you define

Description

EnumerateNodes provides a way to enumerate through all child nodes. For each valid node type the message iMsg is sent to the object hoReceiver. Three parameters are passed to this method: hoNode (the ID of the XML node), sVal1 and sVal2 (which you define). All node objects are created and destroyed as needed.

Example

Procedure ShowAtt handle hoNode integer  iLevel
    Showln iLevel " : " (psName(honode)) " : " (psNodeValue(hoNode))
End_Procedure

Procedure ShowNode handle hoNode string sLevel string sX
    integer i

    ShowLn sLevel " :" (psNodeName(honode))
    Move sLevel to i
    Increment i
    Send EnumerateAttributes of hoNode msg_showAtt  self i
    Send EnumerateElements   of hoNode msg_showNode self i sX
End_Procedure

Procedure ShowAll
    handle hoNode

    Get DocumentElement of hoMyXML to hoNode
    Send ShowNode hoNode 1 ""
End_Procedure

See Also

EnumerateElements | EnumerateAttributes

Last Edited: February 17, 2005


cXMLDOMTextNode [Procedure SetChildElementValueNS]

SetChildElementValueNS - cXMLDOMTextNode

Creates or replaces a child element which matches the passed NamespaceURI and BaseName and sets the element's text value

Type: Procedure

Parameters: string sNameSpaceURI string sBaseName String sValue

Parameter | Description
sNamespaceURI | Namespace-URI string (e.g. http://dataaccess.com/MyURI)
sBaseName | Name of Element excluding the prefix
sValue | The value of the Element's text

Description

SetChildElementValueNS can be used to search for a child element and replace its value. The first element that matches the passed sNamespaceURI and sBaseName will be found and its text value will be replaced with sValue. If a child element is not found, it will be created and appended to the node's list of child objects.

The method will be used when you need to find a simple element (i.e, an element that only contains text) and change its text value.

This sample will search for an element named "Status" and replace its text value with "x".

Move "http://www.dataaccess.com/Test/CustomerList" to sNS
:
Send SetChildElementValueNS of hoCustomer sNS "Status"  "x"

Namespaces

This message creates a node and a document that is namespace aware. This requires that you always pass a NameSpaceURI. It is suggested that you always create documents using namespace methods (the methods that end in NS) and that you no longer use the non-namespace methods (e.g. use SetChildElementValueNS and not SetChildNodeValue).

If your document does not have any namespaces or an element within the document does not have a namespace, its namespace is considered to be global and its NamespaceURI is represented as an empty string (""). In such a case you can and should use these namespace aware messages passing an empty string for the NameSpaceURI.

See Also

AddElementNS(send) | AddElement(get) | ChildElementValueNS | ChildElementNS | NextElementNS

Last Edited: February 17, 2005


cXMLDOMTextNode [Procedure SetChildNodeValue]

SetChildNodeValue - cXMLDOMTextNode

Allows a parent to change the text of one of its elements

Type: Procedure

Parameters: String sTagName String sValue

Parameter | Description
sTagName | the name of the element
sValue | the value of the element

Description

SetChildNodeValue is not namespace aware and only works reliably for attributes with no namespaces and no prefixes. You should use SetChildElementValueNS in its place.

SetChildNodeValue allows a parent to change the text of one of its elements. The "Value" of an element is really stored as a cXmlDomTextNode object. In most cases this is overkill, and you want to just get at the value of an element the same way you get at the value of an attribute. This procedure lets you do this and hides the creation, finding and disposing of the text node.

See Also

SetChildElementValueNS

Last Edited: April 7, 2004


Properties for cXMLDOMTextNode

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
HasChildNodes | Indicates whether a node has child nodes | BaseXmlDomNode
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
paXML | Returns an address of the XML representation of the node and its descendant nodes | BaseXmlDomNode
pbParsed | Returns true if node has been parsed | BaseXmlDomNode
pbSpecified | Indicates if attribute node is explicitly specified or derived from DTD or Schema | BaseXmlDomNode
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piLength | Returns the number of characters in the data string | BaseXmlDomCharacterData
piNodeType | The type of the node | BaseXmlDomNode
psBaseName | Returns the node name with the namespace prefix removed | BaseXmlDomNode
psNamespaceURI | Returns the URI for the namespace as a string | BaseXmlDomNode
psNodeName | Returns a string containing the name that was set at the time the node was created | BaseXmlDomNode
psNodeValue | Contains the contents of a node | BaseXmlDomNode
psPrefix | Returns the element namespace prefix | BaseXmlDomNode
psText | Returns a string that is the textual representation of the node and its descendants | BaseXmlDomNode
psXML | Returns the XML representation of the node and its descendant nodes as a string | BaseXmlDomNode


cXmlHttpTransfer [Event OnDataReceived]

OnDataReceived - cXmlHttpTransfer

Sent when data is received - this method should not be augmented.

Type: Event

Parameters: string sContentType string sData

Parameter | Description
sContentType | Specifies the content type of sData, for example, "text/html"
sData | Contains the data received from RemoteHost

Description

This method should not be augmented.

While its superclass, cHttpTransfer, considers this to be a public event, it should not be considered available in cXmlHttpTransfer. In this class, the method is augmented to provide all of the logic required to receive transmitted data and to load it into a memory buffer. This memory buffer does not have the same restrictions as the DataFlex string, allowing for your data transfers to be quite large.

You may wish to study this method to see how you could create other cHttpTransfer subclasses that allow you to transfer large amounts of data.

Last Edited: September 25, 2003


Events for cXmlHttpTransfer

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnDataReceived | Sent when data is received - this method should not be augmented. |


cXmlHttpTransfer [Function HttpGetXmlAddr]

HttpGetXmlAddr - cXmlHttpTransfer

Retrieves XML data and returns the memory address of that data

Type: Function

Return Data Type: Address

Parameters: string sHost string sFilePath

Parameter | Description
sHost | The URL host (e.g. DataAccess.com - Note: DO NOT include the "HTTP://")
sFilePath | The file path and any data passed in a query string (e.g. MyXMlSite/XmlSrvc.asp?ID=A)

Return Value

If an error occurs in the transfer, a zero is returned. It is up to you to dispose of the returned data using the Free function.

Description

The HttpGetXmlAddr function requests XML data. The data received is returned as a pointer. The data does not have to be valid XML, although this is assumed.

Sample

Procedure Example
    handle hoHttp hoXml
    address aXml
    integer bOk iVoid

    Get Create U_cXmlHttpTransfer to hoHttp

    Get HttpGetXmlAddr of hoHttp "dataaccess.com" ;
        "MyApplication/pricelist.xml" to aXml

    Send Destroy of hoHttp

    If (aXml=0) ;
        Send Stop_Box "No document returned" "Error"
    Else Begin
        Get Create U_cXmlDomDocument to hoXml

        Get LoadXmlFromAddress of hoXml aXml to bOk

        Move (Free(aXml)) to iVoid

        If (bOk=True) ;
            Send DoWhateverYouWantWithXmlDocument hoXml

        Send Destroy of hoXml
    End
End_Procedure  // Example

See Also

HttpGetXmlString

Last Edited: August 12, 2005


cXmlHttpTransfer [Function HttpGetXmlNode]

HttpGetXmlNode - cXmlHttpTransfer

Requests XML data

Type: Function

Return Data Type: Handle

Parameters: string sHost string sFilePath

Parameter | Description
sHost | The URL host (e.g. DataAccess.com - Note: DO NOT include the "HTTP://")
sFilePath | The file path and any data passed in a query string (e.g. MyXMlSite/XmlSrvc.asp?ID=A)

Return Value

The data received is returned as a new XML object. If an error occurs in the transfer or if the resulting data is not properly formed XML, a zero is returned.

Description

The HttpGetXmlNodefunction requests XML data.

This along with HttpPostXmlNode, will be the two most commonly used methods in this class.

Received data is translated as needed based on the property values of peTranslateReceived.

Sample

handle hoHttp
handle hoXml

Get Create U_cXmlHttpTransfer to hoHttp

Get HttpGetXmlNode of hoHttp "dataaccess.com" ;
    "MyApplication/pricelist.xml" to hoXml

Send Destroy of hoHttp

If (hoXml=0) ;
    Send Stop_Box "No document returned" "Error"
Else Begin
    Send Info_Box (psXml(hoXml))
    Send DoWhateverYouWantWithXmlDocument hoXml
    Send Destroy of hoXml
End

See Also

Info_Box

Last Edited: November 23, 2004


cXmlHttpTransfer [Function HttpGetXmlString]

HttpGetXmlString - cXmlHttpTransfer

Retrieves XML data as a string

Type: Function

Return Data Type: String

Parameters: string sHost string sFilePath

Parameter | Description
sHost | The URL host (e.g. DataAccess.com - Note: DO NOT include the "HTTP://")
sFilePath | The file path and any data passed in a query string (e.g. MyXMlSite/XmlSrvc.asp?ID=A)

Return Value

The returned string is subject to DataFlex string length limitations. If an error occurs in the transfer, an empty string is returned.

Description

The HttpGetXmlString function retrieves XML data as a string. The string does not have to be valid XML, although this is assumed.

Received data is translated as needed, based on the property values of peTranslateReceived.

Consider using the HttpGetXmlAddr function if you need to retrieve large blocks of data.

Sample

handle hoHttp
handle hoXml
string sXml

Get Create U_cXmlHttpTransfer to hoHttp

Get HttpGetXmlString of hoHttp "dataaccess.com" ;
    "MyApplication/pricelist.xml" to sXml

Send Destroy of hoHttp

If (sXml="") ;
    Send Stop_Box "No document returned" "Error"
Else Begin
    Send Info_Box sXml

    Get Create U_cXmlDomDocument to hoXml

    Send LoadXml of hoXml sXml to bOk

    If (bOk=True) ;
        Send DoWhateverYouWantWithXmlDocument hoXml

    Send Destroy of hoXml
End

See Also

HttpGetXmlAddr | Info_Box

Last Edited: November 23, 2004


cXmlHttpTransfer [Function HttpPostXmlAddr]

HttpPostXmlAddr - cXmlHttpTransfer

Posts and receives XML data as pointers

Type: Function

Return Data Type: Address

Parameters: string sHost string sFilePath address aXml integer iLen

Parameter | Description
sHost | The URL host (e.g. DataAccess.com - Note: DO NOT include the "HTTP://")
sFilePath | The file path and any data passed in a query string (e.g. MyXMlSite/XmlSrvc.asp?ID=A)
aXml | Memory address of a valid XML string. It is not required that this data be valid XML. As long as the server can process what you send it, the string contains whatever you wish
iLen | The length of the XML string

Return Value

The data received is returned via pointer addresses.

Description

The HttpPostXMLAddr function posts and receives XML data as pointers. The data received is returned via pointer addresses. It is assumed that the posted data will be zero terminated. The returned data, if translated, will be zero terminated and it is assumed that the returned data is zero terminated. If an error occurs in the transfer or if there is no resulting data, a zero is returned. The returned data does not have to be a valid XML document. It is up to you to dispose of the returned data using the free function.

Both posted and received data is translated as needed based on the values of peTranslateSent and peTranslateReceived.

Sample

Procedure Example
    handle hoHttp hoXML
    string sXML
    address aSentXML aRcvdXML
    integer iLen iVoid
    Boolean bOk

    Move "<customer><c1>test</c1><c1>test2</c1><c1>test3</c1></customer>" to sXML
    Move (Length(sXML)) to iLen
    Move (AddressOf(sXML)) to aSentXML

    // Create XMLHttp transfer object.

    // Post XML document and receive returned XML string

    Get Create U_cXMLHttpTransfer to hoHttp

    Get HttpPostXMLAddr of hoHttp "dataaccess.com" ;
        "MyApplication/XMLService.asp" aSentXML iLen to aRcvdXML

    Send Destroy of hoHttp

    If (aRcvdXML=0) ;
        Send Stop_Box "No document returned" "Error"
    Else Begin
        Get Create U_cXMLDomDocument to hoXML

        Get LoadXMLFromAddress of hoXML aRcvdXML to bOk

        Move (Free(aRcvdXML)) to iVoid

        If (bOk=True) ;
            Send DoWhateverYouWantWithXMLDocument hoXML

        Send Destroy of hoXML
    End
End_Procedure  // Example

Last Edited: June 20, 2005


cXmlHttpTransfer [Function HttpPostXmlNode]

HttpPostXmlNode - cXmlHttpTransfer

Posts and receives XML data via XML object nodes

Type: Function

Return Data Type: Handle

Parameters: String sHost String sFilePath Handle hoXmlNode

Parameter | Description
sHost | The URL host (e.g. DataAccess.com - Note: DO NOT include the "HTTP://")
sFilePath | The file path and any data passed in a query string (e.g. MyXMlSite/XmlSrvc.asp?ID=A)
hoXmlNode | A valid XML node

Return Value

The data received is returned as a new XML object. If an error occurs in the transfer or if the resulting data is not properly formed XML, a zero is returned.

Description

The HttpPostXmlNode function posts and receives XML data via XML object nodes. The data to be posted is passed as an XML DOM object. The data received is returned as a new XML object. If an error occurs in the transfer or if the resulting data is not properly formed XML, a zero is returned.

This along with HttpGetXmlNode, will be the two most commonly used methods in this class.

Both posted and received data is translated as needed based on the values of peTranslateSent and peTranslateReceived.

If successful, this method returns a handle to a newly created XML DOM document based on the cXmlDomDocument class. It becomes the programmer's responsibility to properly destroy this object when it is no longer needed. You do this by sending the destroy message of the object handle.

Sample

handle hoHttp
handle hoSentXml
handle hoRcvdXml
integer bOk

// create Xml document to post. Create document and load from local disk

Get Create U_cXmlDomDocument to hoSentXml

Set psDocumentName of hoSentXml to "d:\MyData\MyXmlData.xml"

Send LoadXmlDocument of hoSentXml to bOk

if (bOk=True) begin
    // Create xmlHttp transfer object.
    Get Create U_cXmlHttpTransfer to hoHttp

    // Post xml document and receive returned Xml document
    Get HttpPostXmlNode of hoHttp "dataaccess.com" ;
        "MyApplication/XmlService.asp" hoSentXml to hoRcvdXml

    Send Destroy of hoHttp // transfer object no longer needed

    If (hoRcvdXml=0) ;
         Send Stop_Box "No document returned" "Error"
    else begin
        send Info_Box (psXml(hoRcvdXml))
        send DoWhateverYouWantWithXmlDocument hoRcvdXml

        Send Destroy of hoRcvdXml
    end
end

Send Destroy of hoSentXml

See Also

Info_Box | Stop_Box

Last Edited: January 12, 2006


cXmlHttpTransfer [Function HttpPostXmlString]

HttpPostXmlString - cXmlHttpTransfer

Posts and receives XML data as string

Type: Function

Return Data Type: String

Parameters: String sHost String sFilePath String sXml

Parameter | Description
sHost | The URL host (e.g. DataAccess.com - Note: DO NOT include the "HTTP://")
sFilePath | The file path and any data passed in a query string (e.g. MyXMlSite/XmlSrvc.asp?ID=A)
sXml | An XML string. It is not required that this data be valid XML. As long as the server can process what you send it, the string may contain whatever you wish

Return Value

The data is received and returned as a DataFlex string and is therefore subject to string length limitations. If an error occurs in the transfer or if there is no resulting data, an empty string is returned.

Description

The HttpPostXmlString function posts and receives XML data as strings. The data is received and returned as a DataFlex string and is therefore subject to string length limitations. If an error occurs in the transfer or if there is no resulting data, an empty string is returned. The returned data does not have to be a valid XML document.

Both posted and received data is translated as needed, based on the values of peTranslateSent and peTranslateReceived.

Sample

handle hoHttp
handle hoXml
string sSentXml
string sRcvdXml

Move "<customer><c1>test</c1><c1>test2</c1><c1>test3</c1></customer>" to sSentXML

// Create xmlHttp transfer object.
// Post xml document and receive returned Xml document

Get Create U_cXmlHttpTransfer to hoHttp

Get HttpPostXmlString of hoHttp "dataaccess.com" ;
     "MyApplication/XmlService.asp" sSentXml to sRcvdXml

Send Destroy of hoHttp

If (sRcvdXml="") ;
    send Stop-Box "No document returned" "Error"

else begin
    send Info_Box sRcvdXml

    Get Create U_cXmlDomDocument to hoXml

    Send LoadXml of hoXml sRcvdXml to bOk

    if (bOk=True) ;
        send DoWhateverYouWantWithXmlDocument hoXml

    Send Destroy of hoXml
end

See Also

Info_Box

Last Edited: January 12, 2006


cXmlHttpTransfer [Function TransferErrorDescription]

TransferErrorDescription - cXmlHttpTransfer

Returns an error description for the last transfer

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

A string containing the description for the last error

Description

The peXmlTransferStatus property is set after a xml http request. If a transfer error occured (the value is not xtsOK), the text for that error may be determined by calling the TransferErrorDescription.

Get peXmlTransferStatus of oXmlHttp to eTransferStatus
If (eTransferStatus<>xtsOK) begin
    Get TransferErrorDescription of oXmlHttp to sErr
    Send WeHadAFaultError sErr
end

See Also

peXmlTransferStatus | LastError

Last Edited: April 7, 2004


cXmlHttpTransfer [Function TranslateData]

TranslateData - cXmlHttpTransfer

Translates the data based on the mode and returns a pointer to the translated data

Type: Function

Return Data Type: Address

Parameters: integer eXlt address aData integer iDataLen

Parameter | Description
eXlt | Translation mode. Must be one of xtUtf8toOem, xtOemtoUtf8 or xtNoTranslate
aData | Memory address of data to translate
iDataLen | Length of data pointed to by aData

Return Value

If no translation is required (eTranslate = xtNoTranslate) or an error occurs, a zero is returned.

Description

The TranslateData function translates the data based on the mode and returns a pointer to the translated data. This is passed a translation mode, a pointer to the data and the data length. The data is zero-terminated, so this function assumes that the translated data will not contain any embedded zeros.

This function never changes the passed data. This method is suitable for augmentation in sub-classes.

Last Edited: September 11, 2003


Methods for cXmlHttpTransfer

View method list in hierarchical order

Name | Type | Description | Defining Class
AddHeader | Function | Adds the HTTP header named sHeaderName with the value sHeaderValue to the HTTP headers | cBaseHTTPTransfer
ClearHeaders | Procedure | Clears all HTTP headers added using AddHeader | cBaseHTTPTransfer
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
HTTPGetRequest | Function | Performs an HTTP GET request using sFilePath | cBaseHTTPTransfer
HttpGetXmlAddr | Function | Retrieves XML data and returns the memory address of that data |
HttpGetXmlNode | Function | Requests XML data |
HttpGetXmlString | Function | Retrieves XML data as a string |
HTTPPostAddrRequest | Function | Performs an HTTP POST request | cBaseHTTPTransfer
HttpPostRequest | Function | Performs an HTTP POST request using sFilePath | cHttpTransfer
HttpPostXmlAddr | Function | Posts and receives XML data as pointers |
HttpPostXmlNode | Function | Posts and receives XML data via XML object nodes |
HttpPostXmlString | Function | Posts and receives XML data as string |
HTTPputAddrRequest | Function | Performs an HTTP PUT request using sFilePath | cBaseHTTPTransfer
HttpPutRequest | Function | Performs an HTTP PUT request using sFilePath | cHttpTransfer
LastError | Procedure | Used to report an error after a failed xml http transfer |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
ResponseHeader | Function | Returns the value for a named http response header | cBaseHTTPTransfer
ResponseStatusCode | Function | Returns the response http status code | cBaseHTTPTransfer
SelectClientCertificate | Function | Selects a client certificate to be used in an Http request | cBaseHTTPTransfer
TransferErrorDescription | Function | Returns an error description for the last transfer |
TranslateData | Function | Translates the data based on the mode and returns a pointer to the translated data |


cXmlHttpTransfer [Procedure LastError]

LastError - cXmlHttpTransfer

Used to report an error after a failed xml http transfer

Type: Procedure

Parameters: No Parameters

Description

If an xml/http request fails the return XML handle will be 0 and peXmlTransferStatus will contain a status code. Note that an error is not automatically generated. It is expected that you will want to check the peXmlTransferStatus after your request and handle any failures in your code. If you wish, you can send LastError to generate an error.

Calling LastError after a transfer will generate an error message explaining how the transfer failed. If no error occurred, LastError will do nothing.

Get HttpPostXmlNode of hoHttp "dataaccess.com" "MyApp/stuff.asp" hoSentXml to hoRcvdXml
If (hoRcvdXml=0) begin // if no data came back, probably and error
    Get peXmlTransferStatus of hoHttp to eStatus
    If (eStatus<>xtsOk) Begin
        Send LastError of hoHttp
    end
end

See Also

peXmlTransferStatus | TransferErrorDescription

Last Edited: April 7, 2004


Properties for cXmlHttpTransfer

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
LastErrorCode | Returns the last error code from the HTTP / FTP Transfer | InetTransfer
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
pbClearHeaders | Determines if Http Headers should be cleared before XML data is posted |
pbDataRequiredReceived | Determines if a respose of no data should be considered valid |
pbDataRequiredSent | Determines if a request of no data should be considered valid |
pbShowErrorDialog | Determines if a popup dialog will appear when a client certificate or usename/password is needed for an Http Request | cBaseHTTPTransfer
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peTransferFlags | Various flags that control how file/data should be transferred | InetTransfer
peTranslateReceived | Determines character translation for received data |
peTranslateSent | Determines character translation for posted (sent) data |
peXmlTransferStatus | Returns the status of the last xml http request |
piBufferSize | Specifies the size of the file transfer buffer | InetTransfer
piRemotePort | Specifies the port to connect to on RemoteHost | InetTransfer
psAcceptTypes | Specifies the HTTP content types accepted by the client | cBaseHTTPTransfer
psAgent | Specifies the name of the application | InetTransfer
psContentTypeExpected | Specifies the expected content type of the response |
psContentTypeReceived | Contains the content type of the received data after an XML Http request |
psContentTypeSent | Contains the content type that is used for posted data |
psPassword | Specifies the password to use to log on | InetTransfer
psProtocolVersion | Specifies the HTTP protocol version | cBaseHTTPTransfer
psProxy | Specifies the name of the Proxy server used, if any | InetTransfer
psRemoteHost | Specifies the hostname or the IP address of the remote server | InetTransfer
psSaveasFile | Saves response from the remote host to the specified file instead of triggering the OnDataReceived event | cBaseHTTPTransfer
psUserName | Specifies the name of the user to log on | InetTransfer
RootHandle | Returns the root HINTERNET handle used for the session | InetTransfer


cXmlHttpTransfer [Property pbClearHeaders]

pbClearHeaders - cXmlHttpTransfer

Determines if Http Headers should be cleared before XML data is posted

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbClearHeaders determines if the message ClearHeaders should be sent before posting XML data. By default, this value is is true and headers are cleared as part of the post.

Before XML data is posted using the HttpPostXmlNode, HttpPostXmlString or HttpPostXmlAddr methods, the Http headers must be cleared. If this is not done you may receive an error message whan you attempt to post data a second time. When pbClearHeaders is True, the default, the headers are cleared for you. In rare cases, you may wish to create additional headers using the AddHeader method. In such a case you must disable the automatic clearing of headers (set pbClearHeaders to false), clear the headers yourself (send ClearHeaders) and then add whatever headers you wish (send AddHeader).

Object oXmlHttpTransfer is a cXmlHttpTransfer
    Set pbClearHeaders to False
end_object

:

Send ClearHeaders   of oXmlHttpTransfer to False
Send AddHeader      of oXmlHttpTransfer "MyName" "MyValue"
Get HttpPostXmlNode of oXmlHttpTransfer sHost sFilePath hoXmlSent to hoXmlReceived

Last Edited: September 25, 2003


cXmlHttpTransfer [Property pbDataRequiredReceived]

pbDataRequiredReceived - cXmlHttpTransfer

Determines if a respose of no data should be considered valid

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The property pbDataRequiredReceived determines if data must be received for a request to be valid. The default value of this property is True, which means that valid XML data must be received. If no XML is received an error will occur and the peXmlTransferStatus property will be set to xtsNodata. If the property is set to false, an empty response is considered to be valid.

Set pbDataRequiredReceived to False // allow empty received data

See Also

pbDataRequiredSent

Last Edited: February 1, 2005


cXmlHttpTransfer [Property pbDataRequiredSent]

pbDataRequiredSent - cXmlHttpTransfer

Determines if a request of no data should be considered valid

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The property pbDataRequiredSent determines if data must be sent for a request to be valid. The default value of this property is True, which means that valid XML data must be sent in the reqeuest. If no XML is sent an error will occur and the peXmlTransferStatus property will be set to xtsBadRequest. If the property is set to false, an empty request is considered to be valid.

Set pbDataRequiredSent to False // allow empty data to be sent

See Also

pbDataRequiredReceived | peXmlTransferStatus

Last Edited: February 1, 2005


cXmlHttpTransfer [Property peTranslateReceived]

peTranslateReceived - cXmlHttpTransfer

Determines character translation for received data

Type: Property

Access: Read/Write

Data Type: Integer

Description

The peTranslateReceived property determines character translation for received data.

The modes supported are:

Constant | Meaning
xtNoTranslate | No translation. Data is unchanged
xtUtf8toOem | Convert from UTF-8 to Oem - most likely used when loading XML documents.
xtOemtoUtf8 | Convert from Oem to UTF-8 - most likely used when sending XML documents

The most likely translation modes for receiving data are OEM to UTF8 and None. The default is xtUtf8toOem.

The messages HttpPostXmlNode, HttpPostXmlString, HttpPostXmlAddr, HttpGetXmlNode, HttpGetXmlString and HttpGetXmlAddr use this property to determine how received data should be translated.

The function TranslateData is used to perform data translation. If additional translation modes are needed, this function can be augmented to support those modes.

Sample

Get Create U_cXmlHttpTransfer to hoHttp
Set peTranslateReceived of hoHttp to xtNoTranslate // no translate data
Get HttpGetXmlNode of hoHttp "dataaccess.com" ;
    "MyApplication/XmlService.asp" hoSentXml to hoRcvdXml
Send Destroy of hoHttp
If hoRcvdXml Begin
    // do whatever you need to do with the new XML document
    :
    Send Destroy of hoRcvdXml //programmer must destroy object when done
End

Last Edited: September 11, 2003


cXmlHttpTransfer [Property peTranslateSent]

peTranslateSent - cXmlHttpTransfer

Determines character translation for posted (sent) data

Type: Property

Access: Read/Write

Data Type: Integer

Description

The peTranslateSent property determines character translation for posted (sent) data.

The modes supported are:

Constant | Meaning
xtNoTranslate | No translation. Data is unchanged
xtUtf8toOem | Convert from UTF-8 to Oem - most likely used when loading XML documents.
xtOemtoUtf8 | Convert from Oem to UTF-8 - most likely used when sending XML documents

The most likely translation modes for receiving data are UTF8 to OEM and None. The default is xtOemtoUtf8.

The messages HttpPostXmlNode, HttpPostXmlString, and HttpPostXmlAddr use this property to determine how posted data should be translated.

The function TranslateData is used to perform data translation. If additional translation modes are needed, this function can be augmented to support those modes.

Sample

Get Create U_cXmlHttpTransfer to hoHttp
Set peTranslateSent of hoHttp to xtNoTranslate     //no translation for
Set peTranslateReceived of hoHttp to xtNoTranslate // posted or received data
Get HttpPostXmlNode of hoHttp "dataaccess.com" ;
    "MyApplication/XmlService.asp" hoSentXml to hoRcvdXml
Send Destroy of hoHttp
If hoRcvdXml Begin
    // do whatever you need to do with the new XML document
    :
    Send Destroy of hoRcvdXml // programmer must destroy object when done
End

Last Edited: September 11, 2003


cXmlHttpTransfer [Property peXmlTransferStatus]

peXmlTransferStatus - cXmlHttpTransfer

Returns the status of the last xml http request

Type: Property

Access: Read/Write

Data Type: Integer

Description

peXmlTransferStatus returns the status of the last xml http request. You should use this value to determine if your transfer was successful.
The possible return values are:

Constant | Meaning
xtsOk | Request succeeded
xtsHttpRequestFailed | Http request failed
xtsBadRequest | Bad or missing data sent
xtsInvalidContentType | Invalid contentType received
xtsNoData | No data was received
xtsNotXml | Received data not in proper XML format
xtsError | Unspecified error

If an xml/http request fails the return XML handle will be 0 and peXmlTransferStatus will contain a status code. Note that an error is not automatically generated. It is expected that you will want to check the peXmlTransferStatus after your request and handle any failures in your code. If you wish, you can send LastError to generate an error. Or, you can get TransferErrorDescription to return a description of problem.

Get HttpPostXmlNode of hoHttp "dataaccess.com" "MyApp/stuff.asp" hoSentXml to hoRcvdXml
If (hoRcvdXml=0) begin // if no data came back, probably and error
    Get peXmlTransferStatus of hoHttp to eStatus
    If (eStatus=xtsOk) Begin
        Send DoNoDataWasReturned
    end
    Else if (eStatus=xtsNotXml) Begin
        Send DoCustomNotXMLError // if not xml, do custom error
    end
    else begin
        Send LastError of hoHttp // all other errors reported by LastError
    end
end

See Also

LastError | TransferErrorDescription

Last Edited: April 7, 2004


cXmlHttpTransfer [Property psContentTypeExpected]

psContentTypeExpected - cXmlHttpTransfer

Specifies the expected content type of the response

Type: Property

Access: Read/Write

Data Type: String

Description

The psContentTypeExpected specifies the expected content type of the received XML response. If the content received (psContentTypeReceived) does not contain the content type expected a transfer error will occur and the peXmlTransferStatus property will be set to xtsInvalidContentType.

The default value of this property is 'text/xml'.

If psContentTypeExpected is set to an empty string, any content type will be accepted. This may be required if the server returning the XML data is not setting the proper content type.

Set psContentTypeExpected to "" // allow any content type

See Also

psContentTypeReceived | peXmlTransferStatus

Last Edited: February 1, 2005


cXmlHttpTransfer [Property psContentTypeReceived]

psContentTypeReceived - cXmlHttpTransfer

Contains the content type of the received data after an XML Http request

Type: Property

Access: Read/Write

Data Type: String

Description

After an XML Http request, the psContentTypeReceived property will contain the content type of the received data. Presumably this will be "text/xml". This property is maintained by the object and should not be explicitly set.

Last Edited: September 11, 2003


cXmlHttpTransfer [Property psContentTypeSent]

psContentTypeSent - cXmlHttpTransfer

Contains the content type that is used for posted data

Type: Property

Access: Read/Write

Data Type: String

Description

The psContentTypeSent property contains the content type that is used for posted data. The default tells the server that the posted data is text based XML. You will normally not need to change this.

Last Edited: September 11, 2003


DataDictionary [Event Attach_Main_File]

Attach_Main_File - DataDictionary

Performs attach command on main file

Type: Event

Parameters: No Parameters

Description

Attach_Main_File performs an attach. It gets called during save and find operations. An Attach moves related field data from a parent table to the DDO's table. This insures that the relationship values between tables are properly maintained.

Note that this attach is only applied to parent DDOs that are connected to this DDO. If a parent table is related to the DDO's main-file but there is no parent DDO connected to the DDO, no attach will occur.

You can use this procedure to create additional attaches, to cancel all attaches, or to create your own custom attaches. The following sample performs a normal attach except that one of the field's attaches is ignored.

Procedure Attach_Main_File
    String sTempVal

    Move Vndr.Parent_Stat to sTempVal // remember this value

    // the normal attach will attach data from all parent files
    // including an attach into Vndr.Parent_Stat. We want to
    // ignore this attach
    Forward Send Attach_Main_File

    Move sTempVal to Vndr.Parent_State // undo this one attach
End_Procedure  // Attach_Main_File

Note that Attach_Main_File and Relate_Main_File are not true inverses of each other. Relate_Main_File does nothing by default (the relate occurs as part of the find). Attach_Main_File actually performs the attach command. If you do not forward, the message no attach will occur.

When accessing table values you should always access the global file buffers and not the DDO buffers (i.e., use "Move File.Field to var" syntax). See Understanding File Buffers and DDO Field Buffers for more information.

See Also

Defining Data Dictionary Events | Relate_Main_File

Last Edited: July 11, 2005


DataDictionary [Event Define_Fields]

Define_Fields - DataDictionary

Defines DataDictionary rules for data file fields at the class level

Type: Event

Parameters: No Parameters

Description

The Define_Fields event defines DataDictionary rules for data file fields at the class level. This event is called by Construct_Object and is designed to be augmented at the class level to set up all data-dictionary rules. The Main_File property must be set before any other property; property settings that precede the setting of this property will not take effect.

Note:Since Define_Fields is called from Construct_Object, it cannot be augmented at the DataDictionary object (DDO) level, only at the class level.

Sample

(see Customer.DD in the VDF Order10 sample for more detail)

Class Customer_Data_Dictionary is a DataDictionary
    :
    Procedure Define_Fields
        Forward Send Define_Fields
        //DDB-Generated-Code-Location
        //DDB-DefineFieldStart

        Set Main_File            To Customer.File_Number
        Set Cascade_Delete_State To False

        Set Foreign_Field_Options  DD_KEYFIELD   To DD_FINDREQ
        Set Foreign_Field_Options  DD_INDEXFIELD To DD_NOPUT
        Set Foreign_Field_Options  DD_DEFAULT    To DD_DISPLAYONLY

        // Child (Client) file structure................
        Send Add_Client_File  Orderhea.File_Number

        // External (System) file structure.............
        Send Add_System_File  Ordsys.File_Number  DD_LOCK_ON_NEW_SAVE

        Define_Auto_Increment  Ordsys.Cust_Number  To Customer.Customer_Number

        // Field-based properties.......................

        // Customer.Customer_Number
        Set Field_Label_Long       Field Customer.Customer_Number To "Customer Number"
        Set Field_Label_Short      Field Customer.Customer_Number To "Number"
        Set Field_Options          Field Customer.Customer_Number To DD_AUTOFIND    DD_NOPUT
        Set Field_Prompt_Object    Field Customer.Customer_Number To (Customer_sl(Self))
        Set Key_Field_State        Field Customer.Customer_Number To True
        Set Status_Help            Field Customer.Customer_Number To "Customer Id Number (system assigned)."

        // Customer.Name
        Set Field_Label_Long       Field Customer.Name To "Customer Name"
        Set Field_Label_Short      Field Customer.Name To "Customer Name"
        Set Field_Options          Field Customer.Name To DD_REQUIRED
        Set Field_Prompt_Object    Field Customer.Name To (Customer_sl(Self))
        Set Status_Help            Field Customer.Name To "Customer/Company Name."
        :
        :
        :
        //DDB-DefineFieldEnd
    End_Procedure  //  Define_Fields
    :
End_Class

Last Edited: August 3, 2005


DataDictionary [Event Field_Defaults]

Field_Defaults - DataDictionary

Designed to be augmented to establish the default values that will appear after a clear operation

Type: Event

Parameters: No Parameters

Description

The Field_Defaults event is provided to support the setting of default values after a clear. You may set any field value, which will be reflected in the DEOs and will get saved with the new record.

Because the setting of defaults is coded in a procedure, it allows for complex rules.

The setting of a default is not recognized as a data change by the Data Dictionary; therefore, the setting of defaults will not generate a "data-loss" warning message.

Procedure Field_Defaults
    Forward Send Field_Defaults

    Set Field_Changed_Value field Customer.State to "CA"
    Set Field_Changed_Value field Customer.Discount to (Discount(self))
    Set Field_Changed_Value field Customer.City to "Miami"
End_Procedure

Defaults may also be set upon entry of a DEO by creating an Field Entry method and it setting it with the Field_Entry_msg property. That method could set the default value using the Field_Default_Value message.

See Also

Defining Data Dictionary Events | Retains and Setting Default Field Values

Last Edited: July 12, 2005


DataDictionary [Event New_Current_Record]

New_Current_Record - DataDictionary

Hook for performing operations during save, delete, and clear operations

Type: Event

Obsolete

Parameters: Integer iOldRecord Integer iNewRecord

Parameter | Description
iOldRecord | The old record number
iNewRecord | The new record number

Description

Obsolete

This event is obsolete. While it can still be used you are advised to use the method OnNewCurrentRecord.

The New_Current_Record event is a hook for performing operations during save, delete, and clear operations. By default, this procedure does nothing. It is intended for augmentation or override.

During a find/relate operation, the "origin" of the find receives this message unconditionally, while the updated (parent) DataDictionary objects (DDOs) only receive it if the Current_Record is changing.

This procedure is available as a hook by means of which you can do such things as keep track of a key value.

Sample

Procedure Construct_Object
    Forward Send Construct_Object
    Set Main_File to .....

    Property Integer piOldId Public 0

End_Procedure  // Construct_Object

Procedure New_Current_Record Integer iOldrec# Integer iNewrec#
    Forward Send New_Current_Record iOldrec# iNewrec#

    Set OldId to Myfile.Key_Field
End_Procedure  // New_Current_Record

Function Validate_Save returns integer
    Integer iRecNum iOldId iRetVal

    Forward Get Validate_Save to iRetVal
    if iRetVal ;
        Function_Return iRetVal

    get Current_Record to iRecNum
    get piOldId to iOldId
    if (iRecNum <>0 and Myfile.Key_Field <> iOldId) ;
        Send Operation_Not_Allowed 301  // custom error message
End_Function // Validate_Save

See Also

OnNewCurrentRecord

Last Edited: July 11, 2006


DataDictionary [Event OnNewCurrentRecord]

OnNewCurrentRecord - DataDictionary

Notification event that is sent every time the DDO's record is switched

Type: Event

Parameters: RowId riOldRowId RowId riNewRowId

Parameter | Description
riOldRowId | the RowId record identity of the old record
riNewRowId | the RowId record identity of the new record

Description

OnNewCurrentRecord can be thought of as a post-find/clear/save/delete event since it gets called after every record find, clear, save and delete. It is called whenever CurrentRowId changes.

OnNewCurrentRecord is passed two RowId parameters: the old record RowId and the new record RowId. By looking at these two parameters, you can tell if the DDO has found a record or if it is creating a new one (if the new RowId is null).

You cannot use this procedure to change the Current RowId This message is sent to notify of a change that is going to happen. You cannot abort the change.

OnNewCurrentRecord is sent when the current record is changing, with two exceptions. If a DDO becomes in-use and the record being established is null, OnNewCurrentRecord will be called (old record =null new record =null). After a save, OnNewCurrentRecord is called for all DDOs that participated in the save, even if the record did not change. If you need to test for this condition, you could check Operation_Mode and see if it is Mode_Saving.

Procedure OnNewCurrentRecord RowId riOldRowId RowId riNewRowId
    Forward Send OnNewCurrentRecord riOldRowId riNewRowId

    // Assume we want to trap saves of existing records.
    If (Operation_Mode = Mode_Saving AND ;
        IsSameRowId(riOldRowId,riNewRowId) ) Begin
        :
    End
    Else ...
End_Procedure

Special Notes

  • This message must be forwarded.

  • This event does not exist in Visual DataFlex version 10.1 and below. Instead the event New_Current_Record is used. This event is passed integer record numbers instead of RowIds. The New_Current_Record event is still called but is considered to be obsolete. OnNewCurrentRecord is the preferred replacement.

See Also

When to Use the File-Buffer | Defining Data Dictionary Events | HasRecord | CurrentRowId

Last Edited: July 11, 2006


Events for DataDictionary

View event list in hierarchical order

Name | Description | Defining Class
Attach_Main_File | Performs attach command on main file |
Backout | Hook for performing operations when editing or deleting a new record | BaseData_Set
Clear_Main_File | Performs clear command on main table of this object | BaseData_Set
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Creating | Hook for performing operations required when creating a new record | BaseData_Set
Define_Fields | Defines DataDictionary rules for data file fields at the class level |
Delete_Main_File | Performs the actual delete of the record | BaseData_Set
Deleting | Hook for performing operations when deleting a record | BaseData_Set
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Field_Defaults | Designed to be augmented to establish the default values that will appear after a clear operation |
New_Current_Record | (Obsolete) Hook for performing operations during save, delete, and clear operations |
OnConstrain | Defines constraint sets within a DataDictionary object (DDO) | DataSet
OnNewCurrentRecord | Notification event that is sent every time the DDO's record is switched |
Relate_Main_File | Does nothing by default. Called after the normal relate on the main table has been executed. | BaseData_Set
Reset_Filemodes_For_Lock | Temporarily resets the file modes of the Main_File of this object and of any updated DataDictionary objects for a save/delete operation | BaseData_Set
Save_Main_File | Saves the main file | BaseData_Set
Update | Hook for performing operations when saving a record | BaseData_Set
Validate_Delete | Guards execution of delete operation | BaseData_Set
Validate_Delete_No_Cascade | Guards against deleting records with existing child records | BaseData_Set
Validate_Save | Used to enforce business rules and integrity rules | BaseData_Set


DataDictionary [Function Data_Set]

Data_Set - DataDictionary

Returns the object id of the DataDictionary object whose main file is passed to the function

Type: Function

Return Data Type: Integer

Parameters: Integer iFile

Parameter | Description
iFile | Number of table

Return Value

Returns the object id of the DataDictionary object

Description

The Data_Set function returns the object id of the DataDictionary object (DDO) whose main file is passed to the function.

Last Edited: July 11, 2005


DataDictionary [Function Extended_Error_Field]

Extended_Error_Field - DataDictionary

Extends the extended error logic of the Error handler

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the field number associated with the error

Description

The Extended_Error_Field function extends the extended error logic of the Error handler.Currently in VDF, a global integer ghoErrorSource exists which may be used by any error handler to obtain additional error information from this source. If this value is zero, there is no additional error information. If the value contains an object id (i.e., it is non-zero), this object must understand the function Extended_Error_Message and it must return additional error text when called.

These two messages extend this such that the object pointed to by ghoErrorSource must also understand the messages Extended_Error_File and Extended_Error_Field and must return the file and field value of the last error. DataDictionary objects (DDOs) understand and support this protocol.

While these messages are public, they are advanced.

Sample

Integer iField
Get Extended_Error_Field of ghoErrorSource to iField

Last Edited: August 18, 2003


DataDictionary [Function Extended_Error_File]

Extended_Error_File - DataDictionary

Extends the extended error logic of the Error handler

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns the file number associated with the error

Description

The Extended_Error_File function extends the extended error logic of the Error handler. Currently in VDF, a global integer ghoErrorSource exists which may be used by any error handler to obtain additional error information from this source? If this value is zero, there is no additional error information. If the value contains an object id (i.e., it is non-zero), this object must understand the function Extended_Error_Message and it must return additional error text when called.

These two messages extend this such that the object pointed to by ghoErrorSource must also understand the messages Extended_Error_File and Extended_Error_Field and must return the file and field value of the last error. DataDictionary objects (DDOs) understand and support this protocol.

While these messages are public, they are advanced.

Sample

Integer iFile
Get Extended_Error_File of ghoErrorSource to iFile

Last Edited: August 18, 2003


DataDictionary [Function Extended_error_message]

Extended_error_message - DataDictionary

Called by the standard Visual DataFlex error handler when a DataDictionary error occurs

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Returns a string containing file and field number information that is used to compose the extended error message

Description

The Extended_error_message function is called by the standard Visual DataFlex error handler when a DataDictionary error occurs. You could augment this to pass additional or changed lines of error information to the error handler.

Last Edited: August 18, 2003


DataDictionary [Function Request_Validate_All]

Request_Validate_All - DataDictionary

Similar to Request_Validate, except that a validation will continue after a validation error has occurred

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If the return value is non-zero, a validation error occurs

Description

The Request_Validate_All procedure is similar to Request_Validate, except that a validation will continue after a validation error has occurred. If the return value is non-zero, a validation error occurs. This feature is useful for batch processing where you may wish to list all field validation errors.

If you use this feature you will want to change your error handler so that errors are logged and not reported as they occur.

The one exception to the validate-all process is the find-required validation. If a find-required field-validation fails, the remaining fields in the DataDictionary (DD) will not be processed. If a required record is not present there is no point in checking to see if the fields in the empty record are valid. Other fields in other files will still be checked.

Last Edited: September 11, 2003


Methods for DataDictionary

View method list in hierarchical order

Name | Type | Description | Defining Class
Add_Client_File | Procedure | Adds a table to this object's related-child list | BaseData_Set
Add_Server_File | Procedure | Adds a table to this object's related-parent list | BaseData_Set
Add_System_File | Procedure | Adds iFile to this object's system file list |
Add_User_Interface | Procedure | Adds the passed in hoDEO to the list of data entry objects (DEOs) for this object | BaseData_Set
Attach_Server | Procedure | (Obsolete) Use DDO_Server instead | BaseData_Set
Clear | Procedure | Clears all files owned by this object | BaseData_Set
Clear_All | Procedure | Clears all files owned by this object and all connected server DataDictionary objects (DDOs) | BaseData_Set
Constrain | Procedure | Defines constraint set for this object | BaseData_Set
Create | Function | Creates an object based on the passed Class Id | cObject
CurrentRowId | Function | Returns the RowId of the current record | BaseData_Set
Data_Set | Function | Returns the object id of the DataDictionary object whose main file is passed to the function |
Data_set_error | Procedure | Declares DataDictionary object (DDO) errors |
DefineAllExtendedFields | Procedure | Creates extended DataDictionary fields for all text and binary fields within a DataDictionary object (DDO) |
DefineExtendedField | Procedure | Creates extended DataDictionary field for a text or binary field within a DataDictionary object (DDO) |
Destroy | Procedure |  | cObject
Detach_Server | Procedure | Disconnects this object and the specified DataDictionary object (DDO), where this object was the client of that DDO server | BaseData_Set
Establish_Find_Direction | Procedure | Initializes the constrained find commands to perform searches using the given parameters | BaseData_Set
Exit_Application | Procedure | Starts the process of closing an application | cObject
Extended_Error_Field | Function | Extends the extended error logic of the Error handler |
Extended_Error_File | Function | Extends the extended error logic of the Error handler |
Extended_error_message | Function | Called by the standard Visual DataFlex error handler when a DataDictionary error occurs |
Field_Option_Clear | Procedure Set | Clears a DD field option |
Field_Option_Toggle | Procedure Set | Toggles (reverse) the value of a DD field option |
File_Field_AutoFind | Procedure | Performs an autofind based on the passed data file and field |
File_Field_Default_AutoFind | Procedure | Performs an autofind in "default" mode based on the passed file and field |
File_Field_Entry | Procedure Set | Allows you to place data into a DataDictionary field buffer using all the same logic that gets applied to data entry object/keyboard entry |
File_Field_Find | Procedure | Allows you to simulate the find-key process of data entry objects within batch processes |
File_Field_Option_Clear | Procedure Set | Clears a DD field option |
File_Field_Option_Toggle | Procedure Set | Toggles (reverse) the value of a DD field option |
File_Field_Pointer_Entry | Procedure Set | Called to move data from an entry source to the DataDictionary (DD) extended buffer |
Find | Procedure | Performs a find operation on the DataDictionary's main data file using the passed mode and index |
Find_By_Recnum | Procedure | Finds record in specified table with record number equal to the passed in record number | BaseData_Set
FindByRowId | Procedure | Finds record in specified table with record identity equal to the passed RowId and updates the DDO structure | BaseData_Set
HasRecord | Function | Determines if the DataDictionary object (DDO) has a current record | BaseData_Set
Locate_Next | Procedure | Finds the next logical record using the passed in find mode, file, and index specified in a prior Establish_Find_Direction invocation | BaseData_Set
Operation_Not_Allowed | Procedure | Executes the error command with the passed in error number. Intended for augmentation |
Read_By_Recnum | Procedure | Finds record in specified tabile with record number equal to the passed in record number | BaseData_Set
ReadByRowId | Procedure | Finds record in specified table with record identity equal to the passed RowId without updating or altering the DDO structure | BaseData_Set
Rebuild_Constraints | Procedure | Reconstructs constraints for a DDO | BaseData_Set
Refind_Records | Procedure | Checks to see if the record in the File-Buffer is the same as the record in the DDO-Field-Buffer and refinds the record if needed | BaseData_Set
Remove_Client_File | Procedure | Removes a table from this object's container-file list | BaseData_Set
Remove_Server_File | Procedure | Removes a table from this object's server-file list | BaseData_Set
Remove_System_File | Procedure | Removes a table from this object's system file list |
Remove_User_Interface | Procedure | Removes a table from this object's data entry object (DEO)-list | BaseData_Set
Request_Assign | Procedure | Causes the Refresh message to be sent to all data entry objects for this object and its client and server DataDictionary objects as appropriate | BaseData_Set
Request_Clear | Procedure | (Obsolete) See (and use) Clear message. |
Request_Clear_File | Procedure | Performs the Clear command on the specified table of the data-server structure | BaseData_Set
Request_Delete | Procedure | esponsible for deleting a record in the DDO for the main_file, updating all parent DDOs (and tables) and possibly deleting all child records | BaseData_Set
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Entry_Update | Procedure | Sends entry_update to all DEOs of the data set and DEOs of servers of the data set as required to store changes to record buffers | BaseData_Set
Request_Find | Procedure | Finds on specified table using given find mode and index | BaseData_Set
Request_Read | Procedure | Finds on specified table using given find mode and index | BaseData_Set
Request_Relate | Procedure | Performs a relate on the specified table without initializing the done-array | BaseData_Set
Request_Save | Procedure | Saves all changes in DEOs attached to this object or to any DDO that is a server of this object directly or indirectly | BaseData_Set
Request_Superfind | Procedure | Performs superfind on the designated table by the Main_Index of the designated field and notifies all connected DataDictionary objects (DDOs) of the result | BaseData_Set
Request_Validate | Function | Request_Validate sends validation messages to all DDO Field's that will participate in the upcoming save | BaseData_Set
Request_Validate_All | Function | Similar to Request_Validate, except that a validation will continue after a validation error has occurred |
Validate_Constraints | Function | Validates this object's constraints against the record buffer's current content | BaseData_Set


DataDictionary [Procedure Set Field_Option_Clear]

Field_Option_Clear - DataDictionary

Clears a DD field option

Type: Procedure Set

Data Type: Integer

Parameters: integer iField Integer iOptions

Parameter | Description
iField | Number of field in the table
iOptions | The option to get/set

Description

Field_Option_Clear is used to clear a DD field option. Any option change will be immediately reflected in all DEOs using this field. See File_field_Option for more information.

Set Field_Option_Clear of hDD iField to DD_NoPut
Set Field_Option_Clear of hDD FIELD FileName.FieldName to DD_NoPut

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Set Field_Option_Clear FIELD Customer.Name to DD_NoPut

// When using the File_Field_ message use the FILE_FIELD keyword
Set File_Field_Option_Clear of oCustomer_DD FILE_FIELD Customer.Name to DD_NoPut

See Also

Changing Field Properties within a DD Object | Changing Field Option Settings Dynamically | File_Field_Option_Clear | Field_Option_Toggle

Last Edited: July 12, 2005


DataDictionary [Procedure Set Field_Option_Toggle]

Field_Option_Toggle - DataDictionary

Toggles (reverse) the value of a DD field option

Type: Procedure Set

Data Type: Integer

Parameters: integer iField Integer iOption

Parameter | Description
iField | Number of field in the table
iOption | The option to get/set

Description

Field_Option_Toggle is used to toggle (reverse) the value of a DD field option. Any option change will be immediately reflected in all DEOs using this field. See File_field_Option for more information.

Set Field_Option_Toggle of hDD iField to DD_NoPut
Set Field_Option_Toggle of hDD FIELD FileName.FieldName to DD_NoPut

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Set Field_Option_Toggle FIELD Customer.Name to DD_NoPut

// When using the File_Field_ message use the FILE_FIELD keyword
Set File_Field_Option_Toggle of oCustomer_DD FILE_FIELD Customer.Name to DD_NoPut

See Also

Changing Field Properties within a DD Object | Changing Field Option Settings Dynamically | File_Field_Option_Toggle | Field_Option_Clear

Last Edited: July 12, 2005


DataDictionary [Procedure Set File_Field_Entry]

File_Field_Entry - DataDictionary

Allows you to place data into a DataDictionary field buffer using all the same logic that gets applied to data entry object/keyboard entry

Type: Procedure Set

Data Type: String

Parameters: integer iFile integer iField integer bShowErr string sValue

Parameter | Description
iFile | Number of the table in the current filelist
iField | Number of the field in the table
bShowErr | Determines whether error will be displayed
sValue | Entry value of the table field

Description

The File_Field_Entry procedure allows you to place data into a DataDictionary field buffer using all the same logic that gets applied to data entry object (DEO)/keyboard entry. It applies the following rules:

  • If the field is a Capslock field the value will be uppercased.
  • If the field is an AutoFind (or AutoFind ge) field , an AutoFind will be performed.
  • If the field is a DisplayOnly or NoEnter field, no action will occur.
  • If the new value is the same as the old value, no action will occur. If the fields are different the DataDictionary (DD) field value will be updated and Field_Changed_State will be set to True.

The following exceptions are applied here:

1. If the field is a ForcePut field the field is always updated.
2. If the field is NoPut and the field is changed it will be updated (needed for finding) but the Field_Changed_State will not be set (since it does not indicate a changed condition).

Foreign field values are properly applied. If the data value passed is not valid for the field's data type the data will not be entered. An example of an invalid data would be attempting to enter the string "test" into a date or numeric field. When the data is invalid, the bShowErr parameter determines if the error should reported (i.e., if an error should be generated). Normally you will want this to be True.

This message can be used for all data types. If you use this to set a text (or binary) field, the passed string will be converted to a pointer and the message will be directed to the private Field_Pointer_Entry method. If your DataDictionary object (DDO) does not support an extended field for the passed field an error will be declared.

This can be a useful message. While it is similar to File_Field_Current_Value (and Field_Current_Value), it is a more active message. It allows you to enter data in a DD field buffer in a manner similar to keyboard entry. This can be useful in batch processes.

Sample

Set File_Field_Entry of oCustomer_DD Customer.File_Number 5 True To "Last Name"

Of Note

You should use this message and not the private Field_Entry message. The File_Field_Entry message will figure out the foreign field state of your DD and apply the appropriate field options. Also, you must be careful about which DD receives this message. If a DD is being used as a parent field (e.g., the customer DD in an order entry application), this message should be sent to the main-DD and not parent DD (e.g., send message to the order DD, not the customer DD). If you do not send this to the proper DDO, you will not get the proper application of foreign field options.

This message does not perform a field validation on the field. Normally, during a batch entry process the field validation will be performed after all fields are updated by sending the message get Request_Validate or get Request_Validate_All.

Last Edited: August 12, 2005


DataDictionary [Procedure Set File_Field_Option_Clear]

File_Field_Option_Clear - DataDictionary

Clears a DD field option

Type: Procedure Set

Data Type: Integer

Parameters: integer iFile integer iField Integer iOptions

Parameter | Description
iFile | Number of table in current filelist
iField | Number of field in the table
iOptions | The option to get/set

Description

File_Field_Option_Clear is used to clear a DD field option. Any option change will be immediately reflected in all DEOs using this field. See File_field_Option for more information.

Set File_Field_Option_Clear of hDD iFile iField to DD_NoPut
Set File_Field_Option_Clear of hDD FILE_FIELD FileName.FieldName to DD_NoPut

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Set Field_Option_Clear FIELD Customer.Name to DD_NoPut

// When using the File_Field_ message use the FILE_FIELD keyword
Set File_Field_Option_Clear of oCustomer_DD FILE_FIELD Customer.Name to DD_NoPut

See Also

Changing Field Properties within a DD Object | Changing Field Option Settings Dynamically | Field_Option_Clear | File_Field_Option_Toggle

Last Edited: July 12, 2005


DataDictionary [Procedure Set File_Field_Option_Toggle]

File_Field_Option_Toggle - DataDictionary

Toggles (reverse) the value of a DD field option

Type: Procedure Set

Data Type: Integer

Parameters: integer iFile integer iField Integer iOption

Parameter | Description
iFile | Number of table in current filelist
iField | Number of field in the table
iOption | The option to get/set

Description

File_Field_Option_Toggle is used to toggle (reverse) the value of a DD field option. Any option change will be immediately reflected in all DEOs using this field. See File_Field_Option for more information.

Set File_Field_Option_Toggle of hDD iFile iField to DD_NoPut
Set File_Field_Option_Toggle of hDD FILE_FIELD FileName.FieldName to DD_NoPut

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Set Field_Option_Toggle FIELD Customer.Name to DD_NoPut

// When using the File_Field_ message use the FILE_FIELD keyword
Set File_Field_Option_Toggle of oCustomer_DD FILE_FIELD Customer.Name to DD_NoPut

See Also

Changing Field Properties within a DD Object | Changing Field Option Settings Dynamically | Field_Option_Toggle | File_Field_Option_Clear

Last Edited: July 12, 2005


DataDictionary [Procedure Set File_Field_Pointer_Entry]

File_Field_Pointer_Entry - DataDictionary

Called to move data from an entry source to the DataDictionary (DD) extended buffer

Type: Procedure Set

Data Type: Address

Parameters: integer iFile integer iField integer iLen integer bShowErr Address pData

Parameter | Description
iFile | Number of the table in the current filelist
iField | Number of the field in the table
iLen | Length of pData
bShowErr | Determines whether to display errors
pData | Address of data to set

Description

The File_Field_Pointer_Entry procedure is called to move data from an entry source to the DataDictionary (DD) extended buffer. This is identical to the File_Field_Entry message except that a pointer to the data is passed instead of the data itself.

You should rarely need to use this method. The File_Field_Entry method will also move data to an extended field as required (if the field type needs an extended field and extended fields are defined in the DD). For example, if you are need to pass a string value to a comment field you could simply use File_Field_Entry as follows:

Set File_Field_Entry of hDD iCustFile iCustCommentField True to sComment

You will only use File_Field_Pointer_Entry when the data you need to pass data from memory.

Set File_Field_Pointer_Entry of hDD iCustFile iCustCommentField iLengthOfData True to pCommentPointer

See Also

File_Field_Entry

Last Edited: January 10, 2006


DataDictionary [Procedure Add_System_File]

Add_System_File - DataDictionary

Adds iFile to this object's system file list

Type: Procedure

Parameters: integer iFile integer iLock_Mode

Parameter | Description
iFle | Number of the table to add to this object's system (externally locked) filelist
iLock_ModeThis parameter affects the events during which locks will affect table iFile. Can be one of the following constant values:

Constant | Meaning
DD_Lock_On_All | Lock on all saves and deletes (default)
DD_Lock_On_New_Save_Delete | Lock on new saves and deletes
DD_Lock_On_Save | Lock on all saves
DD_Lock_On_New_Save | Lock only on new saves
DD_Lock_On_Delete | Lock only on deletes

Description

Send Add_System_File  ordsys.last_cust_num  DD_Lock_On_New_Save_Delete

Each record in a Table should contain a field or set of fields that provides the record a unique ID. This will usually be your Primary key. In some cases, the value of the primary key must be manually provided by the operator (e.g. entering a unique string ID as part of data input). In some cases, the back-end database will provide the primary key automatically when the record is saved. In other cases, the Data Dictionary must to provide the unique ID when the record is first saved.

The auto-increment feature of the Data Dictionary provides this facility by automatically assigning unique sequential incrementing numbers for each new record.

In order for the Data Dictionary to know what next increment value will be for a new record, it must store the last assigned number in some other external table. To create an auto-increment field you will need to define the table and field of the external table as well as the ID field in your Data Dictionary. A special command, Define_Auto_Increment, is provided to do this:

Define_Auto_Increment ordsys.last_cust_num to Customer.cust_number

In this example, the field last _cust_num in the system table ordsys is designated to increment and provide a value to the field cust_number in the Table Customer.

Auto incrementing will only work correctly if the external table is a (one record) system table or is a related parent table.

You will use a system table if the unique ID is single segment as is shown in the above example with cust_number. If you are using a field from a system file, you need to register this table as an external table so that it will be correctly locked during save operations. For example:

Define_Auto_Increment ordsys.last_cust_num to Customer.cust_number
Send Add_System_File  ordsys.last_cust_num DD_Lock_On_New_Save_Delete

You may use a related parent table if your unique ID is multi-segment. For example, an order-detail ID may consist of an Order Number (OrderDtl.Order_number) and a system assigned detail number (OrderDtl.Detail_Number). If the last detail number was stored in each Order within the Order header table (OrderHea.Last_Detail_Num) the auto increment field would be defined as:

Define_Auto_Increment OrderHea.Last_Detail_Num to OrderDtl.Detail_Number

You may only assign one auto increment field per DDO. If you attempt to assign two, then the first field's auto-increment setting will be erased. If you need to assign additional auto-increment fields within your Data Dictionary you may easily do this by adding custom code to the Data Dictionary Creating event.

See Also

System_File_Count | System_File_Number | System_File_Lock_Mode | Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Procedure Data_set_error]

Data_set_error - DataDictionary

Declares DataDictionary object (DDO) errors

Type: Procedure

Parameters: Integer iField Integer iErr String sMess String sParam1 String sParam2

Parameter | Description
iField | Number of the field in the table
iErr | Eror number to display
sMess | Error text to display
sParam1 | Optional: if passed, replaces @PARAM1
sParam2 | Optional: if passed, replaces @PARAM2

Description

The Data_set_error procedure is used to declare DataDictionary object (DDO) errors.

Normally three parameters are passed to this procedure:
the field number, the error number and the error text defined for iField in the Field_Error property. The field number is passed but not used. It is available so that this information will be available to the procedure for use in any augmentation of it.

When iField is passed as -1, the originating field is unknown.
If iErr is 0, the DSO will use a default error number.

Last Edited: July 11, 2005


DataDictionary [Procedure DefineAllExtendedFields]

DefineAllExtendedFields - DataDictionary

Creates extended DataDictionary fields for all text and binary fields within a DataDictionary object (DDO)

Type: Procedure

Parameters: No Parameters

Description

When a DDO is created, DDO-field buffers are not created for text and binary fields. These types of fields are referred to as extended fields. Instead the DEOs deal directly with the table's File-Buffer (reports would do this same). Binary and Text fields rarely have validation requirements so full DDO support is not really needed. If these fields are not needed, you do not want to incur the added overhead of these fields.

When working with Business Processes that edit text fields you are going to want to have extended field support in your DDOs. If you are using a Web Application, you will also want to have extended field support.

An extended DDO field can be created for any field by sending the message DefineExtendedField passing the field number of the extended field.

Extended DD fields can be created for all text and binary fields within a Data Dictionary object by sending the message DefineAllExtendedFields. Normally, you will use this message.

Object Customer_DD is a Customer_DataDictionary
    Send DefineAllExtendedFields
End_Object

When an extended DD field is created, an internal field object is created for this field. Once created values are moved between the file-buffer and the extended fields in the same way they are moved in and out of the normal fields. The "refresh" process moves data from the file-buffer to the DDO-Field buffer, and the "update" process moves data from the DDO-Field buffer to the file buffer. In addition, a mechanism is provided for updating the DDO-Field buffer value.

You will only use extended fields for batch updating. When you use data entry objects (DEOs) to represent text fields, the DEO always communicates directly with the data file's buffer. If an extended field exists, it will not be used as part of the visual update.

Last Edited: July 11, 2005


DataDictionary [Procedure DefineExtendedField]

DefineExtendedField - DataDictionary

Creates extended DataDictionary field for a text or binary field within a DataDictionary object (DDO)

Type: Procedure

Parameters: integer iField

Parameter | Description
iField | Number of the field in the table

Description

When a DDO is created, DDO-field buffers are not created for text and binary fields. These types of fields are referred to as extended fields. Instead the DEOs deal directly with the table's File-Buffer (reports would do this same). Binary and Text fields rarely have validation requirements so full DDO support is not really needed. If these fields are not needed, you do not want to incur the added overhead of these fields.

When working with Business Processes that edit text fields you are going to want to have extended field support in your DDOs. If you are using a Web Application, you will also want to have extended field support.

An extended DDO field can be created for any field by sending the message DefineExtendedField passing the field number of the extended field.

Extended DD fields can be created for all text and binary fields within a Data Dictionary object by sending the message DefineAllExtendedFields. Normally, you will use this message.

Object Customer_DD is a Customer_DataDictionary
    Send DefineAllExtendedFields
End_Object

When an extended DD field is created, an internal field object is created for this field. Once created values are moved between the file-buffer and the extended fields in the same way they are moved in and out of the normal fields. The "refresh" process moves data from the file-buffer to the DDO-Field buffer, and the "update" process moves data from the DDO-Field buffer to the file buffer. In addition, a mechanism is provided for updating the DDO-Field buffer value.

You will only use extended fields for batch updating. When you use data entry objects (DEOs) to represent text fields, the DEO always communicates directly with the data file's buffer. If an extended field exists, it will not be used as part of the visual update.

Last Edited: July 11, 2005


DataDictionary [Procedure File_Field_AutoFind]

File_Field_AutoFind - DataDictionary

Performs an autofind based on the passed data file and field

Type: Procedure

Parameters: integer iFile integer iField integer iFindMode

Parameter | Description
iFile | Number of the table in the current filelist
iField | Number of the field in the table
iFindMode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record.

Description

The File_Field_AutoFind procedure performs an autofind based on the passed data file and field.

Sample

Send File_Field_AutoFind of hDD iFile iField iFindMode
Send File_Field_AutoFind of hDD FILE_FIELD FileName.FieldName iFindMode

Last Edited: July 11, 2005


DataDictionary [Procedure File_Field_Default_AutoFind]

File_Field_Default_AutoFind - DataDictionary

Performs an autofind in "default" mode based on the passed file and field

Type: Procedure

Parameters: integer iFile integer iField

Parameter | Description
iFile | Number of table in current filelist
iField | Number of field in the table

Description

The File_Field_Default_AutoFind procedure performs an autofind in "default" mode based on the passed file and field. This is similar to the file_field_autofind method except that it does not set the DDOs changed state to true. When a normal autofind is performed on a parent file (e.g. customer in order view) the main DD's changed-state is set true because a new parent has been changed. A default autofind does not set this changed_state which avoids the generation of a data-loss warning. This procedure should be used to perform an autofind as part of setting defaults. It will often be used inside of a DDO's clear and clear_all method and will be used in conjunction with retained field values.

Send File_Field_Default_AutoFind of hDD iFile iField
Send File_Field_Default_AutoFind of hDD FILE_FIELD FileName.FieldName

Adding the following code to the order view in the orderhea DDO will cause the customer key field to be retained and auto-found.

set file_field_option file_field customer.Customer_number to DD_Retain
// augment clear so that it performs an autofind for the customer. The
// retained data will be used to perform this autofind
Procedure Clear
   forward send Clear
   send File_Field_Default_AutoFind File_Field Customer.Customer_Number
End_Procedure

This procedure should only be used when a DDO is not busy (i.e. when operation_mode is 0 - mode_waiting). It cannot be used inside of field_defaults.

See Also

Changing Field Properties within a DD Object | Retains with Parent Fields

Last Edited: July 12, 2005


DataDictionary [Procedure File_Field_Find]

File_Field_Find - DataDictionary

Allows you to simulate the find-key process of data entry objects within batch processes

Type: Procedure

Parameters: Integer iFindMode Integer iFile Integer iField Integer bEntUpdt Integer bShowErr Integer bDfrd

Parameter | Description
iFindMode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
iFile | Number of the table in the current filelist
iField | Number of the field in the table
bEntUpdt | Determines whether data should be moved from local DD buffer to file buffer before the find
bShowErr | Determines whether find errors will be reported
bDfrd | Determines whether the find should be deferred

Description

The File_Field_Find procedure allows you to simulate the find-key process of data entry objects (DEOs) within batch processes. This is similar to Item_Find message except that the find is based around the DD's local buffer and not the data-entry object's item value.

Last Edited: January 12, 2006


DataDictionary [Procedure Find]

Find - DataDictionary

Performs a find operation on the DataDictionary's main data file using the passed mode and index

Type: Procedure

Parameters: integer iMode integer iIndex

Parameter | Description
iMode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
iIndex | The table index to use to perform the find operation

Description

The Find procedure performs a find operation on the DataDictionary's main data file using the passed mode and index. If find is successful, performs a relate on file. If file is the same as this object's Main_File, sends Relate_Main_File. Notifies other connected DataDictionary objects (DDOs) of the result of the find operation. Sets the Found indicator to reflect the success or failure of the find operation.

This is identical to Request_Find with the exception that a file number does not need to be passed. In fact, the find message sends Request_Find to perform its task. This message was provided to provide an easier way for developers find records. This will be used by batch processes to find records within a DD.

Sample

Procedure DoProcess
    Handle hDD
    String sStat

    Get Server to hDD
    Send Clear of hDD
    Repeat
        Send Find of hDD GT 1
        If not (Found) Procedure_Return
        Get Field_Current_Value of hDD FIELD Customer.Status to sStat
        If (sStat="D") ;
            Send Request_Delete of hDD
    Loop
End_Procedure

Note:Find mode Next_Record will use the same find direction as the prior Find operation. Using find mode Next_Record must be preceded by a find using one of the other modes, or it will result in an error.

Find is not re-entrant. Once a major Data-Dictionary operation (save, find, delete, clear) has begun you cannot start another major operation. The reentrancy restriction applies within DDO structures and across DDO structures.

See Also

Finding - Find, Request_Find and FindByRowId | Find and Clear Operations in DDOs

Last Edited: September 8, 2005


DataDictionary [Procedure Operation_Not_Allowed]

Operation_Not_Allowed - DataDictionary

Executes the error command with the passed in error number. Intended for augmentation

Type: Procedure

Parameters: Integer iError

Parameter | Description
iError | Error number to disallow

Description

By default, the Operation_Not_Allowed procedure simply executes the error command with the passed in iErr. You may, however, augment it to substitute other messages for iErr defined in Visual DataFlex, or undefined.

Sample

Procedure Operation_Not_Allowed Integer iError
    If (iError=4140) ;
        Error iError ". Customer has activity."
    Else ;
        Forward Send Operation_Not_Allowed iError
End_Procedure

Last Edited: July 11, 2006


DataDictionary [Procedure Remove_System_File]

Remove_System_File - DataDictionary

Removes a table from this object's system file list

Type: Procedure

Parameters: integer iFile

Parameter | Description
iFile | Number of table in current filelist

Description

The Remove_System_File procedure removes a table from the DataDictionary structure. It reverses action of Add_System_File.

Sample

Send Remove_System_File OrdSys.File_Number

Last Edited: December 16, 2004


DataDictionary [Procedure Request_Clear]

Request_Clear - DataDictionary

See (and use) Clear message.

Type: Procedure

Obsolete

Parameters: No Parameters

Description

See (and use) Clear message.

Last Edited: July 8, 2003


Properties for DataDictionary

View property list in hierarchical order

Name | Description | Defining Class
Allow_Foreign_New_Save_State | Allows saving of a new record when the file is being used as a foreign file (e.g. related parent or grandparent) in a component (e.g. dbView) |
Auto_Fill_State | Determines whether a DataDictionary object (DDO) will attempt to find the first record in its defined set when it becomes in-use | DataSet
Can_Delete | Determines if a delete operation of the current record is permitted | BaseData_Set
Cascade_Delete_State | Determines how a delete should be affected by the existence of child-file records that relate to the record being deleted | BaseData_Set
Changed_State | Determines whether DEOs attached to this object have changed and/or whether a related parent record has changed | BaseData_Set
Child_Count | Returns the number of child objects the object contains | cObject
Client_File | Returns the number of the table at the passed-in position in this object's client table list | BaseData_Set
Client_File_Count | Returns the number of files in this object's client file list | BaseData_Set
Constrain_File | The number of the table that should constrain the main file of this object | DataSet
Current_Record | The number of the record most recently retrieved from the database | BaseData_Set
Data_Set_Client | Returns the object id of the DataDictionary object (DDO) at position iItem in this object's container DDO list | BaseData_Set
Data_Set_Client_Count | Returns the number of DataDictionary objects (DDOs) in this object's container DDO list | BaseData_Set
Data_Set_Server | Returns the object id of the DataDictionary object (DDO) at position iItem in this object's server DDO list | BaseData_Set
Data_Set_Server_Count | Returns the number of DataDictionary objects (DDOs) in this object's server DDO list | BaseData_Set
Data_Set_User_Interface | Returns the object id of the data entry object (DEO) at position iItem in this object's user-interface DEO list | BaseData_Set
Data_Set_User_Interface_Count | Returns the number of data entry objects (DEOs) in this object's user-interface DEO list | BaseData_Set
DDO_Server | The Object_ID of this object's server DataDictionary object (DDO) | DataSet
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Entry_Permissive_State | (Obsolete) Determines whether changing of parent record relationships is permitted. | BaseData_Set
Error_Report_Mode | Determines how errors are generated through the messages Operation_Not_Allowed and Data_Set_Error |
Existing_Key_Value | Holds the concatenated values of all the fields that have been flagged to be key fields |
Field_Changed_State | Flags a field as changed or not, which determines whether the field participates in a save operation |
Field_Changed_Value | Changes the current value of a database field and to set the field's changed state to true. |
Field_CheckBox_Value | Returns the value for a field for the passed in checkbox state (checked or unchecked) |
Field_CheckBox_Values | Sets the field up for use in a checkbox contro |
Field_Class_Name | Assigns the class name of a specific control to each field |
Field_Count | Returns the number of fields in the object |
Field_Current_Description | Returns the description for the current value of a data file field as listed in the field's validation table |
Field_Current_Pointer_Value | Returns a pointer to the data in the extended field object |
Field_Current_Value | Gets or sets the current value of a database field |
Field_Default_Value | Sets the default value of a field, for defaulting values in new records |
Field_Entry_MSG | Sets the ID of the message to be sent when the cursor enters the field |
Field_Error | Assigns a specific error message for validation errors for this field |
Field_Error_Message | Retrieves the error message for a table field |
Field_Error_Number | Retrieves the error number for a data file field |
Field_Exit_MSG | Sets the ID of the message to be sent when the cursor exits the field |
Field_Index | Used to retrieve the index for a field owned by this DDO |
Field_Label | Returns the value of the Field_Label_Long or the Field_Label_Short properties, or the tag name of a data file field |
Field_Label_Long | A long description (or translation) of the name of iField for such purposes as form captions |
Field_Label_Short | A short description (or translation) of the name of iField for such purposes as form captions |
Field_Main_Index | (Obsolete) Returns the number of the index to use for finding on the specified table field. | DataSet
Field_Mask | Provides the token characters for the mask for a database field |
Field_Mask_Type | Controls the mask type of the field |
Field_Option | The state of the passed field property for the passed data file field |
Field_Options | Sets field properties for a database field |
Field_Prompt_Object | Used to get/set the ID of the Prompt_Object for a field, such as a lookup (selection) list |
Field_Select_State | Sets the field's state in the local buffer |
Field_Table_Object | Returns the object handle of a field's ValidationTable if one exists |
Field_Validate_MSG | Lets you assign a general-purpose message to be sent when a field should be validated |
Field_Value_Check | Defines the field to use a check-type validation |
Field_Value_Range | Allows you to define a minimum and maximum range for the field |
Field_Value_Table | Identifies the object id of a validation table set up to validate this field |
Field_Zoom_Object | Get/sets the ID of the Zoom_Object for a field, such as a lookup (selection) list |
File_Field_Changed_State | Flags a foreign field as changed or not, which determines whether the field participates in a save operation |
File_Field_Changed_Value | Changes the current value of a foreign database field and to set the field's changed state to true. |
File_Field_CheckBox_Value | Returns the value for a foreign field for the passed in checkbox state (checked or unchecked) |
File_Field_Current_Description | Returns the description for the current value of a data file field as listed in the field's validation table |
File_Field_Current_Pointer_Value | Returns a pointer to the data in the extended field object |
File_Field_Current_Value | Gets or sets the current value of a foreign database field |
File_Field_default_Value | Sets the default value of a foreign field, for defaulting values in new records |
File_Field_Index | Used to retrieve the index for a file and field |
File_Field_Label | Returns the value of the value of the Field_Label_Long or the Field_Label_Short properties, or the tag name of a data file field |
File_Field_Label_Long | A long description (or translation) of the name of a foreign field for such purposes as form captions |
File_Field_Label_Short | A short description (or translation) of the name of a foreign field for such purposes as form captions |
File_Field_Mask | Provides the token characters for the mask for a database field |
File_Field_Mask_Type | Controls the mask type of the field |
File_Field_Option | Sets a DD field option |
File_Field_Options | Sets field properties for a database field |
File_Field_Prompt_Object | Gets/sets the ID of the Prompt_Object for a field, such as a lookup (selection) list |
File_Field_Select_State | Sets the field's state in the local buffer |
File_Field_Status_Help | Gets/Sets status-line help text for the passed field |
File_Field_Table_Object | Returns the object handle of a file and field's ValidationTable if one exists |
File_Field_Zoom_Object | Gets/sets the ID of the Zoom_Object for a field, such as a lookup (selection) list |
Foreign_Field_Options | Allows you to assign additional item options to a field when that field is used as a parent field |
In_Use_State | Determines whether this object has at least one active user-interface object or one of this object's containers is in use | BaseData_Set
Key_Field_State | Designates a field as the primary key field for a table |
Key_Value | Returns the complete (all fields) key value for the current record |
Main_File | Identifies the table managed by this Data Dictionary class/object | BaseData_Set
Name | Returns the full name of the object including parentage | cObject
No_Delete_State | Determines whether delete operations via this object are permitted | BaseData_Set
No_Relate_State | Determines whether relate operations will be executed after find operations by this object | BaseData_Set
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Ordering | Specifies the index which should be used for all find operations | BaseData_Set
Parent | Returns the parent of an object | cObject
pbAutoFillFromFirst | Allows child DDOs to auto-fill from the last record | BaseData_Set
pbDDAttach | Detemines if an Attach is limited to the current DDO Structure |
pbInheritConstraints | Determines if a main DDO should inherit its constraints (finding filters) from its parent DDOs | BaseData_Set
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Protect_Key_State | Determines whether users are prevented from changing the values of key fields |
Read_Only_State | Determines whether save or delete operations will occur in this object's main table | BaseData_Set
Server_File | Returns the number of the table at the passed in position in this object's server-file list | BaseData_Set
Server_File_Count | Returns the number of table in this object's server-file list | BaseData_Set
Should_Save | Can be used to determine if a DDO has changed. | BaseData_Set
Should_Save_Row | Determines if a DDO is changed according to dbGrid "row" logic | BaseData_Set
Smart_Filemode_For_Lock | Determines the locked file mode setting for tables participating in save or delete operations | BaseData_Set
Smart_Filemode_For_No_Lock | Determines the unlocked file mode setting for tables that should not participate in save or delete operations | BaseData_Set
Smart_Filemode_State | Governs whether this object can use file-locking optimization for its tables | BaseData_Set
Status_Help | Gets/Sets status-line help text for the field |
System_File_Count | Determines the number of System Files used by the DDO |
System_File_Lock_Mode | Returns the File Lock mode for a system file |
System_File_Number | Returns the File number for a system file |
Validate_All_Fields_State | Supports Request_Validate_All |
Validate_Delete_Structure_Mode | Determines what type of DataDictionary object-structure validation will occur before a delete operation |
Validate_DEOs_Only_State | Determines whether validation is limited to fields represented in the current view |
Validate_Foreign_File_State | Determines if field validation should be applied to foreign (parent) tables |
Validate_Save_Structure_Mode | Determines what type of DataDictionary object structure validation will occur before a save operation |
Which_Data_Set | Returns object id of object owning specified table | BaseData_Set


DataDictionary [Property Allow_Foreign_New_Save_State]

Allow_Foreign_New_Save_State - DataDictionary

Allows saving of a new record when the file is being used as a foreign file (e.g. related parent or grandparent) in a component (e.g. dbView)

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Allow_Foreign_New_Save_State property allows saving of a new record when the file is being used as a foreign file (e.g. related parent or grandparent) in a component (e.g. dbView). This property has been created to provide a proper solution to saving new parent records within a DDO structure.

Set this property to true inside of your data-dictionary object (not class) in order to be able to save a new record when the file is being used as a foreign file in the view.

Normally, a data-dictionary object (DDO) parent file (e.g., the customer parent DDO in an order entry view) is foreign and will have foreign field options applied to it. Setting this property to true instructs the data-dictionary object fields in this file should not be treated as foreign. This makes it possible to save a new parent record while you are saving a new main (child) record.

For example, you may have an order entry system that allows you to create and save a new customer at the same time you are creating and saving a new order. Normally the customer in an order view is foreign. Typical foreign settings would make most fields display-only and key fields find-required. This would make it impossible to enter new customer data and, if the customer id is system generated, you would encounter a find required error when you attempt to save the order. If you set the customer DDO's Allow_Foreign_New_Save_State True, the DDO would not be treated as a foreign field. This would allow you to save the new parent.

In addition, foreign fields do not have default values applied to them when they are cleared. In the above example, your new (parent) customer would not have proper defaults set when you tried to save it. Setting Allow_Foreign_New_Save_State to True, will cause defaults to be applied - a desired behavior when saving a new parent.

Sample

Set Allow_Foreign_New_Save_State to True

Last Edited: January 12, 2006


DataDictionary [Property Error_Report_Mode]

Error_Report_Mode - DataDictionary

Determines how errors are generated through the messages Operation_Not_Allowed and Data_Set_Error

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Error_Report_Mode property determines how errors are generated through the messages Operation_Not_Allowed and Data_Set_Error.

Possible Values:

DD_Error_Report
DD_Error_No_Report

When set to DD_Error_Report (the default), errors are declared and handled by the DataFlex error system. If set to DD_Error_No_Report, the error is not reported, but the Err indicator is set, indicating that an error did occur. Use of this property can be expanded to support other types of error reporting (log to error file, etc.).

Sample

set Error_Report_Mode to DD_Error_No_Report

Last Edited: August 18, 2003


DataDictionary [Property Existing_Key_Value]

Existing_Key_Value - DataDictionary

Holds the concatenated values of all the fields that have been flagged to be key fields

Type: Property

Access: Read/Write

Data Type: String

Description

The Existing_Key_Value property holds the concatenated values of all the fields that have been flagged to be key fields. It is used to check whether a user has changed the value of one of the fields which make up a record's key.

Last Edited: August 14, 2003


DataDictionary [Property Field_Changed_State]

Field_Changed_State - DataDictionary

Flags a field as changed or not, which determines whether the field participates in a save operation

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iField Integer iState

Parameter | Description
iField | Number of the field in the table
iState | Indicates whether field iField has changed

Description

The Field_Changed_State property flags a field as changed or not, which determines whether the field participates in a save operation. Gets/sets Field_Changed_State of the passed field. Returns True when a field has been changed since this object was last cleared or a record found in it.

Sample

Boolean bState
Get Field_Changed_State Field Customer.Name to bState

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Changed_State FIELD Customer.Name to bState

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Changed_State of oCustomer_DD FILE_FIELD Customer.Name to bState

See Also

File_Field_Changed_State

Last Edited: July 11, 2005


DataDictionary [Property Field_Changed_Value]

Field_Changed_Value - DataDictionary

Changes the current value of a database field and to set the field's changed state to true.

Type: Property

Access: Write-Only

Data Type: String

Parameters: Integer iField String sValue

Parameter | Description
iField | Number of the field in the table
sValue | Current value of field iField

Description

Syntax

Set Field_Changed_Value of hoDD Field Customer.Name to sName

This message is used to change the current value of a field and to set the field's changed state to true. This is a commonly used message and is the suggested method for changing DDO field values in preparation for a save. This message is only used for changing values. There is no get version of this message.

Function ChangeName RowId riRecId string sName returns Boolean
    Boolean bErr

    Send Clear of oUser_DD
    Send FindByRowId of oUser_DD User.File_Number riRecId
    If (Found) Begin
        // update name and save
        Set Field_Changed_Value of oUser_DD field User.Name to sName
        Get Request_Validate of oUser_DD to bErr
        If (not(bErr)) begin
            Send Request_Save of oUser_DD
            // if save succeeds, Err indicator is False
            Move (Err) to bErr
        End
    End
    Else Begin
        Move True to bErr
    End
    Function_Return bErr
End_Function

You will note that many of the samples use the file buffer to directly obtain the value of a field (e.g. Move Customer.Name to sName). This is discussed in detail in Understanding File Buffers and DDO Field Buffers.

There are two variants of the message, "Field" and "File_Field". This is discussed in Understanding the File_Field and Field Keywords.

See Also

Understanding File Buffers and DDO Field Buffers | File_Field_Changed_Value

Last Edited: July 12, 2005


DataDictionary [Property Field_CheckBox_Value]

Field_CheckBox_Value - DataDictionary

Returns the value for a field for the passed in checkbox state (checked or unchecked)

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iField Integer iState String sValue

Parameter | Description
iField | Number of the field in the table
iState | Determines which Boolean state is being checked/assigned for iField
sValue | Value of the field iField

Description

Field_CheckBox_Value returns the value for a field for the passed in checkbox state (checked or unchecked). Symbolic values other than 1 or 0 (True or False) can be stored in a database for the checked and unchecked values of a checkbox.

For example, a driver's license database might have a checkbox for the "wears corrective lenses" field, and the values to be stored in the field are "Y" or "N" for checked and unchecked, respectively.

Sample

string sStatus
Get Field_Checkbox_Value FIELD Driver.CorrectiveLenses True to sStatus

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The File Field and Field Keywords.

The Field_ version of a message must use the keyword FIELD to identify the table.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_CheckBox_Value FIELD Customer.Sex to sCheckBoxValue

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_CheckBox_Value of oCustomer_DD FILE_FIELD Customer.Sex to sCheckBoxValue

See Also

File_Field_CheckBox_Value

Last Edited: July 11, 2005


DataDictionary [Property Field_CheckBox_Values]

Field_CheckBox_Values - DataDictionary

Sets the field up for use in a checkbox contro

Type: Property

Access: Write-Only

Data Type: String

Parameters: Integer iField String sTrue String sFalse

Parameter | Description
iField | Number of the field in the table
sTrue | Checkbox value of field iField when checkbox is checked
sFalse | Checkbox value of field iField when checkbox is not checked

Description

Set Field_Checkbox_Values field Customer.status to "A" "I"

The Field_Checkbox_Values message sets the field up for use in a checkbox control. A checkbox field can only store one of two values; a true value and a false value.

If the field is represented by a checkbox control (dbCheckBox), then the control will be checked when the field value equates to true, and is unchecked when the field value equates to false.

If the field is represented by a form control (dbForm) then data entry will be restricted to either the true value or the false value.

When a validation error occurs, the error number and text specified for the field in the Field_Error property are used to report an error. If no text was defined, a standard check-error text will be reported.

See Also

Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Property Field_Class_Name]

Field_Class_Name - DataDictionary

Assigns the class name of a specific control to each field

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iField string sName

Parameter | Description
iField | Number of the field in the table
sName | Name of the class to use as interface for field iField

Description

Set Field_Class_Name field Cust.Address to "cDbAddressForm"

Field_Class_Name assigns the class name of a specific control to each field. By default, the Studio will use this information to determine the class of control that is created whenever the field is dragged onto a component. This setting does not stop you from explicitly choosing a different control class for the field in the Studio, or from changing the class of control on an individual basis; it is only the default.

If you leave this blank, the Studio will determine the best control to use for the field. The Studio does a good job of assigning the right control, so this property will usually be left empty.

You can enter any class name in this form. If you enter the name of a non-standard class, then the class must be correctly registered with the Studio before it can be used.

See Also

Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Property Field_Count]

Field_Count - DataDictionary

Returns the number of fields in the object

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Field_Count property returns the number of fields in the object.

Last Edited: August 14, 2003


DataDictionary [Property Field_Current_Description]

Field_Current_Description - DataDictionary

Returns the description for the current value of a data file field as listed in the field's validation table

Type: Property

Access: Read-Only

Data Type: String

Parameters: integer iField String sValue

Parameter | Description
iField | Number of the field in the table
sValue | The value of the field iField

Description

Field_Current_Description returns the description for the current value of a data file field as listed in the field's validation table.This can be used to get at these descriptions within reports and batch processes. If there is no description value, or no validation table, the value of iField itself is returned.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Current_Description FIELD OrderHea.Ship_via to sDescription

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Current_Description of oOrderHea_DD FILE_FIELD OrderHea.Ship_via to sDescription

See Also

File_Field_Current_Description

Last Edited: July 11, 2005


DataDictionary [Property Field_Current_Pointer_Value]

Field_Current_Pointer_Value - DataDictionary

Returns a pointer to the data in the extended field object

Type: Property

Access: Read/Write

Data Type: Address

Parameters: integer iField integer iLen Address pData

Parameter | Description
iField | Number of field in table
iLen | Length of data in field
pData | Pointer to data in field

Description

The Field_Current_Pointer_Value property returns a pointer to the data in the extended field object. You can use this to make a copy of this data. While you could use this to change the data, you are not encouraged to do so. If you need to change the data in the extended field object use File_Field_Pointer_Entry.

This is called to move data from an entry source to the DD extended buffer. This is identical to the Field_Current_Value except that a pointer to the data is passed. You must make sure that this pointer addresses valid memory and that the length of the data is correct. If the length, iLen, passed is less than the field length, the rest of the field will be zero filled. If the length passed is greater than the length of the field, the length will be truncated.

It is expected that this message would only be used in batch processing.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Current_Pointer_Value FIELD Customer.Name to sName

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Current_Pointer_Value of oCustomer_DD FILE_FIELD Customer.Name to sName

See Also

File_Field_Current_Pointer_Value

Last Edited: January 10, 2006


DataDictionary [Property Field_Current_Value]

Field_Current_Value - DataDictionary

Gets or sets the current value of a database field

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iField String sValue

Parameter | Description
iField | Number of the field in the table
sValue | Current value of field iField

Description

Syntax

Get Field_Current_Value of hoDD Field Customer.Name to sName
Set Field_Current_Value of hoDD Field Customer.Name to sName

These messages are used to retrieve and change a field's value. Get Field_Current_Value is used to retrieve the current value of a field. This message is used frequently.

You will note that many of the samples use the file buffer to directly obtain the value of a field (e.g. Move Customer.Name to sName). This is discussed in detail in Understanding File Buffers and DDO Field Buffers.

There are two variants of the message, "Field" and "File_Field". This is discussed in Understanding the File_Field and Field Keywords.

The set version of this message is used to change the current value of a field. You change the value of DDO field in preparation for a save. When you change a field's value you must also change its changed-state. This can be done with the Field_Changed_State message.

Set Field_Current_Value of hoDD Field Customer.Name to sName
Set Field_Changed_state of hoDD Field Customer.Name to True

The message File_Field_Changed_Value performs both of these operations and is usually used for this purpose. Therefore, the Set File_Field_Current_Value message is rarely used.

Important

If a save operation is not changing the value of changed field, check if you are using Field_Current_Value instead of Field_Changed_Value. This is a common mistake.

See Also

Understanding File Buffers and DDO Field Buffers | File_Field_Current_Value

Last Edited: July 12, 2005


DataDictionary [Property Field_Default_Value]

Field_Default_Value - DataDictionary

Sets the default value of a field, for defaulting values in new records

Type: Property

Access: Write-Only

Data Type: String

Parameters: Integer iField String sValue

Parameter | Description
iField | Number of the field in the table
sValue | Default value field iField should have after a clear

Description

Field_Default_Value sets the field value without setting the DataDictionary object's (DDO's) Changed_State. This is used to set defaults inside Field_Entry_msg messages.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Set Field_Default_Value FIELD Customer.Name to sValue

// When using the File_Field_ message use the FILE_FIELD keyword
Set File_Field_Default_Value of oCustomer_DD FILE_FIELD Customer.Name to sValue

Sample

This sample sets the default value of the Customer.Date field to 0/01/2004.
Note that date values must be coded using U.S. date format.

set Field_Default_Value FIELD Customer.Date to 01/01/2004

See Also

File_Field_Default_Value | Field_Defaults

Last Edited: July 12, 2005


DataDictionary [Property Field_Entry_MSG]

Field_Entry_MSG - DataDictionary

Sets the ID of the message to be sent when the cursor enters the field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iField Integer iMsg

Parameter | Description
iField | Number of the field in the table
iMsg | Message id of the message to send when entering field iField

Description

The Field_Entry_msg and Field_Exit_msg properties are similar to the Field_Validate_msg and are sent whenever the cursor enters or exits an item connected to a field. You would create the procedures and then assign the procedure names to the field properties. When called, the procedures are passed the field number and field value. While returning a non-zero would stop the navigation event, this would be unusual usage. These procedures are usually used to handle pre-entry or post-exit processing.

Set Field_Entry_msg Field Customer.State To EntryCustomerState

Field_Entry_msg allows you to specify the name of a method that is executed whenever the cursor moves into a data-entry form connected to the field.

The Entry Method, a procedure, can be programmed to perform any action. For example, you might use it to display special information or default values each time the cursor goes to the field for data entry.

In Visual DataFlex, procedures can return an Integer value. In the case of an Entry Method, if a non-zero value is returned, then the cursor movement into the field's data-entry form is aborted. Using the entry method event to control navigation is strongly discouraged.

The Entry Method should be a member procedure of the Table's Data Dictionary class.

For example if you have the following member procedure

Procedure EntryOrderDate Integer iField Date dDate
    // Add a default date if the field is blank
    Boolean bChanged
    Get Field_Changed_State iField to bChanged

    If (not(bChanged) AND dDate =0) Begin
        SysDate dDate
        Set Field_Default_Value iField to dDate
    End
End_Procedure

To use this procedure on a date field of a file, you would set the field's Entry Method to EntryOrderDate. You are actually assigning the method handle msg_EntryOrderDate but the "msg" prefix, if omitted, will be supplied automatically.

Set Field_Entry_msg Field Orderhea.Order_Date To EntryOrderDate

The declaration prototype for an Entry Method takes the following general form.

procedure procedureName integer iField type currentValue

Where:

  • procedureName is the name of the procedure;
  • iField is the field number of the field that sent procedureName. The field number can be used to retrieve any information about the field; and,
  • type and currentValue are the type and current value of the field that sent procedureName.

The parameters that are passed to the entry method allow you to write generalized entry-method procedures that can be re-used in other fields and tables.

See Also

Field_Exit_msg | Field_Validate_msg | Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Property Field_Error]

Field_Error - DataDictionary

Assigns a specific error message for validation errors for this field

Type: Property

Access: Write-Only

Data Type: String

Parameters: Integer iField Integer iErr String sMsg

Parameter | Description
iField | Number of the field in the table
iErr | Number the error message for field iField should display
sMsg | Text the error message for field iField should display

Description

Set Field_Error field Customer.Credit_Limit to 200 "Not a legal number"

The Field_Error method allows you to define a specific error number and message to be raised whenever validation fails for the field. This means that each field can have its own specific validation error message.

The error is triggered when one of the following validation tests fails: Field_CheckBox_Values, Field_Value_Range, Field_Value_Check or Field_Value_Table. Field_Validate_MSGs should have their own error texts coded inside the member function.

See Also

Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Property Field_Error_Message]

Field_Error_Message - DataDictionary

Retrieves the error message for a table field

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iField String sValue

Parameter | Description
iField | Number of the field in the table
sValue | The value of the field iField

Description

The Field_Error_Message property retrieves the error message for a table field.

Note:
The constants @PARAM1 and @PARAM2 can be used in the text of the message. These constants will be replaced with either the value from the simple validation (Field_Value_Check) or the range values (Field_Value_Range). The constants @PARAM1 and @PARAM2 must be in UPPERCASE.

Last Edited: December 16, 2004


DataDictionary [Property Field_Error_Number]

Field_Error_Number - DataDictionary

Retrieves the error number for a data file field

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iField Integer iValue

Parameter | Description
iField | Number of the field in the table
iValue | The vaule of the field iField

Description

The Field_Error_Number property retrieves the error number for a data file field.

Last Edited: July 11, 2005


DataDictionary [Property Field_Exit_MSG]

Field_Exit_MSG - DataDictionary

Sets the ID of the message to be sent when the cursor exits the field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iField Integer iMsg

Parameter | Description
iField | Number of the field in the table
iMsg | Message id of the message to send when exiting field iField

Description

The Field_Entry_msg and Field_Exit_msg properties are similar to the Field_Validate_msg and are sent whenever the cursor enters or exits an item connected to a field. You would create the procedures and then assign the procedure names to the field properties. When called, the procedures are passed the field number and field value. While returning a non-zero would stop the navigation event, this would be unusual usage. These procedures are usually used to handle pre-entry or post-exit processing.

Set Field_Exit_msg Field Customer.Zip To ExitAdjustZip

Field_Exit_msg allows you to specify the name of a method that is executed whenever the cursor moves out of a data-entry form connected to the field.

The Exit Method, a procedure, can be programmed to perform any action. For example, you might use it to adjust the values of some calculated data that is dependent on the field value being entered.

In Visual DataFlex, procedures can return an Integer value. In the case of an Exit Method, if a non-zero value is returned, then the cursor movement out of the field's data-entry form is aborted. Using the exit method event to control navigation is strongly discouraged.

The Exit Method should be a member procedure of the Table's Data Dictionary class.

For example if you have the following member procedure

Procedure AdjustDisplayTotal Integer iField Integer iValue
    // This updates the extended price field, which will update any
    // display balances. This is only done for display purposes. The
    // actual amount is updated to the field during the save.
    Integer iQty
    Number nAmnt

    Get Field_Current_Value Field Orderdtl.Qty_Ordered to iQty
    Get Field_Current_Value Field Orderdtl.Price to nAmnt
    Set Field_Current_Value Field Orderdtl.Extended_Price to (nAmnt *iQty)
    // note we set value, but not changed state!
End_Procedure

To use this procedure on the appropriate field of a table, you would set the field's Entry Method to AdjustDisplayTotal. You are actually assigning the method handle msg_AdjustDisplayTotal but the "msg" prefix, if omitted, will be supplied automatically.

Set Field_Exit_msg Field Orderdtl.Qty_Ordered To Adjust_Display_Total

The declaration prototype for an exit method takes the following general form.

procedure procedureName integer iField type currentValue

Where:

  • procedureName is the name of the procedure;
  • iField is the field number of the field that sent procedureName. The field number can be used to retrieve any information about the field; and,
  • type and currentValue are the type and current value of the field that sent procedureName.

The parameters that are passed to the exit method allow you to write generalized procedures that can be re-used in other fields and tables.

See Also

Field_Entry_msg | Field_Validate_msg | | Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Property Field_Index]

Field_Index - DataDictionary

Used to retrieve the index for a field owned by this DDO

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: integer iField Integer iValue

Parameter | Description
iField | Number of the field in the table
iValue | Default value field iField should have after a clear

Description

The Field_Index property should be used to retrieve the index for a field owned by this DDO. If the DDO's ordering property is explicitly set (i.e., it is non-zero) that value will be returned. If it is not, the main index assigned that file and field in Database Builder will be returned. If no index is assigned, -1 is returned.

Get Field_Index of hDD iField to iIndex
Get Field_Index of hDD FIELD FileName.FieldName to iIndex

Function Field_Index integer iField returns integer
    : // augment as needed
End_Function

This property is usually called by File_Field_Index, which operates by finding the DDO that "owns" the passed file and sending the message Field_Index to that object. Therefore the message is actually resolved within Field_Index in the DDO owner object. For this reason, you should never augment File_Field_Index; augment Field_Index instead.

When sending this message you can use either File_Field_Index or Field_Index. Using File_Field_Index is easier because you do not have to worry that the message is sent to the correct DDO - it will find the owner DDO and send the message Field_Index.

When augmenting this method, always augment Field_Index in the owner DD. You can now be sure that this method will get called.

The messages File_Field_Index and Field_Index were created to replace the now obsolete message Field_Main_Index.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Index FIELD Customer.Name to sIndex

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Index of oCustomer_DD FILE_FIELD Customer.Name to sIndex

See Also

File_Field_Index

Last Edited: July 11, 2005


DataDictionary [Property Field_Label]

Field_Label - DataDictionary

Returns the value of the Field_Label_Long or the Field_Label_Short properties, or the tag name of a data file field

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iField Integer iType String sValue

Parameter | Description
iField | Number of the field in the table
iType | Type of label to return: one of DD_Label_Long, DD_Label_Short, DD_Label_Tag
sValue | The value of the field iField

Description

The Field_Label property returns the value of the Field_Label_Long or the Field_Label_Short properties, or the tag name of a data file field.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Label FIELD Customer.Name to sLabel

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Label of oCustomer_DD FILE_FIELD Customer.Name to sLabel

See Also

File_Field_Label

Last Edited: July 11, 2005


DataDictionary [Property Field_Label_Long]

Field_Label_Long - DataDictionary

A long description (or translation) of the name of iField for such purposes as form captions

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iField string sName

Parameter | Description
iField | Number of the field in the table
sName | Long label to use for field iField

Description

Set Field_Label_Long  Field Orderhea.Terms To "Terms of Payment"
Set Field_Label_Short Field Orderhea.Terms To "Terms"

Long and Short labels may be assigned to every field. Long and short field labels are defined using the Field_Label_Long and Field_Label_Short properties.

When getting the value of a label you should use Field_Label.

Get Field_Label Field DD_LABEL_SHORT To sHeaderName
Get Field_Label Field DD_LABEL_LONG  To sLabel

The Field_Label (and File_Field_Label) function provides additional flexibility in determining a label's value.

  • If a long label is requested and the long label name is not assigned, a label will be returned using the smart-cased name of the field.
  • If a short label is requested and the short label name is not assigned, the long label name will be returned. If the long label is not assigned, it will return a smart-cased field name.

The same logic is applied when the Studio or the Wizards are used to design views and reports. The Studio will apply the long label whenever a form-style control and reports (e.g., dbForm, dbComboForm) are created. The studio will apply a short label when column style controls and reports are created (e.g., dbGrid).

See Also

File_Field_Label_Long | Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Property Field_Label_Short]

Field_Label_Short - DataDictionary

A short description (or translation) of the name of iField for such purposes as form captions

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iField string sName

Parameter | Description
iField | Number of the field in the table
sName | Short label to use for field iField

Description

Set Field_Label_Long  Field Orderhea.Terms To "Terms of Payment"
Set Field_Label_Short Field Orderhea.Terms To "Terms"

Long and Short labels may be assigned to every field. Long and short field labels are defined using the Field_Label_Long and Field_Label_Short properties.

When getting the value of a label you should use Field_Label.

Get Field_Label Field DD_LABEL_SHORT To sHeaderName
Get Field_Label Field DD_LABEL_LONG  To sLabel

The Field_Label (and File_Field_Label) function provides additional flexibility in determining a label's value.

  • If a long label is requested and the long label name is not assigned, a label will be returned using the smart-cased name of the field.
  • If a short label is requested and the short label name is not assigned, the long label name will be returned. If the long label is not assigned, it will return a smart-cased field name.

The same logic is applied when the Studio or the Wizards are used to design views and reports. The Studio will apply the long label whenever a form-style control and reports (e.g., dbForm, dbComboForm) are created. The studio will apply a short label when column style controls and reports are created (e.g., dbGrid).

See Also

File_Field_Label_Short

Last Edited: July 11, 2005


DataDictionary [Property Field_Mask]

Field_Mask - DataDictionary

Provides the token characters for the mask for a database field

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iField string sMask

Parameter | Description
iField | Number of the field in the table
sMask | String defining the mask for field iField

Description

Masking is discussed in more detail in Masks in Windows Applications.

The Field_Mask property provides the token characters for the mask for iField. Any characters provided in this property for any mask type (defined in the Field_Mask_Type property) for which they are not token characters will be repeated in the displayed values literally. Token characters can be displayed literally by preceding each with a backslash (\).

The token characters for Field_Mask_Type Mask_Numeric_Window and Mask_Currency_Window are:

, | comma inserts local thousands' separator every three places to the left of the decimal
. | period is replaced with the local decimal indicator
; | semi-colon comes after format for positive quantities, before format for negative numbers
# | no digit or one digit
* | any number of digits, including none
0 | one digit, or a 0 (zero)

The token characters for Field_Mask_Type Mask_Window are:

# | any numeric digit (0-9)
@ | any alphabetic character
! | any punctuation character
* | any single printable character

The token characters for Field_Mask_Type Mask_Date_Window are:

m | month 1 - 12
mm | month 01 - 12
mmm | local abbreviation for month Jan - Dec
mmmm | local name for month January - December
d | day 1 - 31
dd | day 01 - 31
ddd | local abbreviation for day of week Sun - Sat
dddd | local name for day of week Sunday - Saturday
yy | 00 - 99
yyyy | 1700 - 2900
/ | diagonal is replaced with the local date separator

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The File Field and Field Keywords.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Mask FIELD Customer.Name to sMask

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Mask of oCustomer_DD FILE_FIELD Customer.Name to sMask

See Also

File_Field_Mask | Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Property Field_Mask_Type]

Field_Mask_Type - DataDictionary

Controls the mask type of the field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iField integer iType

Parameter | Description
iField | Number of the field in the table
iTypeType of mask to apply to field iField

Constant | Meaning
Mask_Window | General mask
Mask_Numeric_Window | Numeric mask
Mask_Date_Window | Date mask

Description

The Field_Mask_Type property controls the mask type of the field. This property may be set to any mask type consistent with the data type of the field. Doing so will automatically use the default mask (if any) for the mask type.

Use of Mask_Currency_Window will apply a mask generated from the Default_Currency_Mask ($,*;($,*)) for the field, where $ represents the local setting for currency symbol in Windows.

Use of Mask_Numeric_Window will apply a mask generated from the Default_Numeric_Mask (*).

The Field_Mask property can be used to specify the mask for fields of any mask type, and will override the defaults of those types that have defaults.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Mask_Type FIELD OrderHea.Date to sMaskType

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Mask_Type of oOrderHea_DD FILE_FIELD OrderHea.Date to sMaskType

See Also

File_Field_Mask_Type

Last Edited: September 14, 2005


DataDictionary [Property Field_Option]

Field_Option - DataDictionary

The state of the passed field property for the passed data file field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iField Integer iOptions

Parameter | Description
iField | Number of the field in the table
iOptions | The option to get/set

Description

Field_Option is the state of the passed field property for the passed data file field.

Set Field_Option of hDD iField to DD_NoPut
Set Field_Option of hDD FIELD FileName.FieldName to DD_NoPut

Set Field_Option of hDD iField to (DD_Retain IOR DD_NoEnter)

Sample

You can check whether a specific field_option is enabled by getting the Field_Option. For example, if you wish to check whether the Customer.Name field is required (the DD_Required field option is set), you can use this code:

Function IsCustomerNameRequired returns Boolean
    boolean bOptionEnabled

    Get Field_Option of Customer_DD field Customer.Name DD_Required to bOptionEnabled

    function_return bOptionEnabled
End_Function

Sample

The sample below is a more generic version of the above function, which allows checking if the field passed as iField in the DataDictionary passed as hDD has the field option passed as iOption enabled.

Function IsFieldOptionEnabled handle hDD integer iField integer iOption returns Boolean
    boolean bOptionEnabled

    Get Field_Option of hDD iField iOption to bOptionEnabled

    function_return bOptionEnabled
End_Function

Procedure MyExample
    integer iOptions iField
    boolean bOptionEnabled

    // get the field number of Customer.Name field
    Field_Map Customer.File_Number "Name" To iField
    // check if DD_Required is enabled for Customer.Name
    Get IsFieldOptionEnabled Customer_DD iField DD_Required to bOptionEnabled
End_Procedure

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Set Field_Option FIELD Customer.Customer_Name to DD_SkipFound

// When using the File_Field_ message use the FILE_FIELD keyword
Set File_Field_Current_Value of oCustomer_DD FILE_FIELD Customer.Name to DD_SkipFound

See Also

File_Field_Option

Last Edited: March 16, 2006


DataDictionary [Property Field_Options]

Field_Options - DataDictionary

Sets field properties for a database field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iField Integer iArg1

Parameter | Description
iField | Number of the field in the table
iArg1 | Field option to set for field iField

Description

The Field_Options property is used to set a number of options for any field. These options determine a variety of attributes including finding behaviors (e.g., Auto-Find, Find-Required), data entry behaviors (e.g., Capslock, No-Enter) and update behaviors (e.g., No-Put, Force-Put). These options are defined with various "DD_" constants and are listed below.

The options below shown with an asterisk (*) are finding options, and may be used only on indexed fields. The other options may be used with any field.

Auto-Find | DD_AutoFind *
Auto-Find GE | DD_AutoFind_GE *
Uppercase | DD_CapsLock
Display-Only | DD_DisplayOnly
Find-Required | DD_FindReq *
Force-Put | DD_ForcePut
No-Enter | DD_NoEnter
No-Put | DD_NoPut
Retain | DD_Retain
Retain-All | DD_RetainAll
Required | DD_Required
Skip-Found | DD_SkipFound
Zero-Suppress | DD_Zero_Suppress

For example, you could define that a field should be No-Put, Auto-Find and Capslock by setting the following properties:

Set Field_Options field Customer.Id to DD_NoPut
Set Field_Options field Customer.Id to DD_AutoFind
Set Field_Options field Customer.Id to DD_CapsLock

Because multiple options must often be applied to the same field, you are allowed to combine multiple options in a single line as follows:

Set Field_Options field Customer.Id to DD_NoPut DD_AutoFind DD_CapsLock

Field_Options can be set and changed at the DD object level. When used at the object level you will not use the Field_Options message. Instead you will use Field_Option, Field_Option_Clear and Field_Option_Toggle. See Changing Field Properties within a DD Object for more information.

Set Field_Option field Customer.State to DD_Retain
Set Field_Option_Clear field Customer.State to DD_Retain
Set Field_Option_Toggle field Customer.State to DD_Retain

Auto-Find (DD_AutoFind)

Set Field_Options field Customer.Id to DD_AutoFind

DD_AutoFind executes an automatic find eq (equals) by the Main Index of the field when the user navigates out of a data-entry form for the field. This option will not work on a field that does not have a main index.

If a record is found whose value in the main index of the field exactly matches the values in the data-entry form and any other items whose fields participate in the index, it is displayed to the screen. If no such record is found, the cursor exits the form normally and no record is moved into the buffer. No error will be declared.

You would usually set this option on every key field in your database.

Where you wish to find by a non-unique index, use Auto-Find GE.

Where you are auto finding by a multi-segment index, place the DD_AutoFind option on the last field that participates in the index.

If used together with Find-Required, Auto-find will require users to enter a valid existing key before continuing.

Auto-Find GE (DD_AutoFind_GE)

Set Field_Options field Customer.Id to DD_AutoFind_GE

DD_AutoFind_GE performs a find ge (greater than or equal to) by the main index of the field when the user navigates out of a data-entry form for the field. This option will not work on a field that does not have a main index. If a record is found whose value in the main index of the field exactly matches the values in the field's data-entry form and any other forms whose fields participate in the index, it is displayed to the screen. If no such record is found, the record whose index value next follows that in the form(s) is displayed.

Auto-Find GE is useful for finding records on partial entries to items or, in multi-segment indexes, by keys for only the first segment or segments (rather than all of them). All non-unique indexes, for example, are multi-segment (being composed of at least one field plus a record ID field).

You may use Auto-Find GE with any indexed field regardless of whether the field's main index is unique or non-unique.

If you are using Auto-Find GE by a multi-segment index, place the DD_AutoFind_GE option on the last field in the index for which you wish to use an entered key value. If any field that comes before the one with the DD_AutoFind_GE option on it in the index lacks an entered key value in its form, the value of that field will be considered empty for purposes of the find. The found record will be the one whose value for the first such field is the lowest in the index.

If you want to execute an automatic find eq (equals) command for an exact match with the entered data, use the Auto-Find option instead (above).

Auto-Find GE will always find a record, unless the table has no records in it.

Uppercase (DD_CapsLock)

Set Field_Options field Customer.Id to DD_CapsLock

DD_CapsLock automatically converts any lower-case characters entered into a data-entry form associated with the field, to upper case (capital letters). It has no effect on non-alphabetic characters. This assures that all input to the field through data-entry forms will be saved with letters in upper case.

Capitalization (what character is the uppercase of which other character, and vice versa) is set in the collate.cfg configuration file.

Force-Put (DD_ForcePut)

Set Field_Options field Customer.Id to DD_ForcePut

DD_ForcePut forces the contents of data-entry forms connected to the field to be put to the table's record buffer before a save even if no changes were made to the form.

Normally the contents of a data-entry form are put to the buffer only if they have been changed from what was originally displayed from the disk

No-Enter (DD_NoEnter)

Set Field_Options field Customer.Id to DD_NoEnter

DD_NoEnter prevents data entry through any form associated with the field.

Special Note:
The Skip-Found option has a similar effect, except that it allows the cursor to go to the item only if no record is found. No-Enter skips the form regardless of whether a record is found.

The DD_DisplayOnly option is a combination of DD_NoEnter and DD_NoPut.

Although data cannot be entered from the keyboard to a form controlled by No-Enter, data can still be moved to the form under program control. Such data changes will be moved to the record buffer and saved, unlike with the Display-Only or No-Put field options.

No-Put (DD_NoPut)

Set Field_Options field Customer.Id to DD_NoPut

DD_NoPut stops data being moved from the data-entry form back to the record buffer for the field, even if new data is entered from the keyboard. No-Put is useful for allowing data to be entered into a form for finding, where you do not wish to allow the field to be changed.

Use the No-Put field option when you want to prevent users from changing data.

The DD_DisplayOnly option is a combination of DD_NoEnter and DD_NoPut.

Display-Only (DD_DisplayOnly)

Set Field_Options field Customer.Id to DD_DisplayOnly

DD_DisplayOnly causes the cursor to skip the data-entry form associated with this field and prevents any data in the form from being changed. The form will display the field data as disabled.

DD_DisplayOnly is the equivalent of a combination of the DD_NoEnter and DD_NoPut options

// This is the same as DD_DisplayOnly

Set Field_Options field Customer.Id to DD_NoEnter DD_NoPut

Retain (DD_Retain)

Set Field_Options field Customer.Id to DD_Retain

DD_Retain prevents data-entry forms associated with the field from clearing when the user initiates an operation that would normally clear all the forms in a view.

If the user initiates a clear-all operation, then even retained data-entry forms will be cleared.

The choice to retain or not retain a value is not something that can usually be applied to all objects in all views using a particular DD class. Instead retains should be applied based on the data entry requirements of a particular view. Therefore, it is really expected that Retain will be applied at the DD object level and not as part of the class definition.

Retain-All (DD_RetainAll)

Set Field_Options field Customer.Id to DD_RetainAll

DD_RetainAll prevents data-entry forms associated with the field from ever being cleared.

Even though users cannot clear the data-entry form by pressing the Clear key, they still may erase it manually (character-by-character).

The choice to retain or not retain a value is not something that can usually be applied to all objects in all views using a particular DD class. Instead retains should be applied based on the data entry requirements of a particular view. Therefore, it is really expected that Retain will be applied at the DD object level and not as part of the class definition.

Skip-Found (DD_SkipFound)

Set Field_Options field Customer.Id to DD_SkipFound

DD_SkipFound prevents data entry to the field's data-entry form if the buffer for the table has an active record in it.

DD_NoEnter is a similar field option. However, it skips the form in all cases, regardless of whether an active record is in the buffer.

Zero-Suppress (DD_Zero_Suppress)

Set Field_Options field Customer.Id to DD_Zero_Suppress

DD_Zero_Suppress blanks the display of the field's data-entry form if it is a numeric field with value of zero (0).

DD_Zero_Suppress will appear not to work where a small absolute value is put to a form. For example, if a form specifies integer-only display and a field value less than 1 is put to it (say, 0.5), a zero will display in the form. Only a value that is truly zero will be displayed as blanks.

Required (DD_Required)

Set Field_Options field Customer.Id to DD_Required

DD_Required ensures that data is entered into a field.

Any character or characters entered in the data-entry form will allow the cursor to move on to the next form.

This required validation is also applied during a save.

Find-Required (DD_FindReq)

Set Field_Options field Customer.Id to DD_FindReq

DD_FindReq prevents the cursor from going to the next data-entry form until a successful find on the form connected to this field places an active record in the view. An unsuccessful find causes Error 90 (Please enter a valid record ID).

Find required has no effect if an active record for the field's table is already in the view.

You would normally apply Find Required only as a foreign-field option in a parent table to ensure that a related parent record is found before a save occurs in the child.

An Auto-Find option on the field with a Find Required will attempt the required find automatically when a user attempts to move the cursor out of the form. If the automatic find is successful, the cursor will proceed. If it is not, Error 90, Please enter a valid record ID, is declared.

A Find Required with an Auto-Find GE is unnecessary. Auto Find GE always finds a record in a non-empty database file.

This find required validation is also applied during a save.

Clearing Field Options

Additional messages are supported to allow item options to be cleared or toggled:

Field_Option_Clear (and File_Field_Option_Clear) clears the field options passed by this message.

Set Field_Option_Clear Field Customer.Name to DD_Retain

Field_Option_Toggle (and File_Field_Option_Toggle) toggles the field options passed by this message.

Set Field_Option_Toggle Field Customer.Name to DD_Retain

These messages are rarely used in Data Dictionary classes. When they are used, they will be used in Data Dictionary objects to dynamically control a data entry view. See Changing Field Properties within a DD Object for more information.

See Also

File_Field_Options | Defining Data Dictionary Field Attributes | Clear and Clear All | Defining Data Dictionary Foreign Fields Attributes

Last Edited: July 12, 2005


DataDictionary [Property Field_Prompt_Object]

Field_Prompt_Object - DataDictionary

Used to get/set the ID of the Prompt_Object for a field, such as a lookup (selection) list

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iField Integer iObj

Parameter | Description
iField | Number of the field in the table
iObj | Object id of the object to use as prompt object for field iField

Description

Set Field_Prompt_Object field Customer.name to (Cust_Lkup(Self))

Lookup lists are created to provide an easy way to lookup records in your application. Typically each table will have at least one lookup list associated with it. Columns in this lookup list will often consist of the most important fields in your table. These fields are often indexed and lookup lists are designed to let you easily search for records in any of these index orders.

You assign fields in a Data Dictionary to a lookup just be setting the Field_Prompt_Object property. Once assigned your windows applications will automatically attach those lookup lists to data entry objects that use that field.

You will want to create your lookup list objects before you assign them to a Field_Prompt_Object. You must know the name of the lookup list object before you assign it. Wizards are provided that allow you to create your lookup lists and assign them to the appropriate Data Dictionary fields in a single step.

If you are using one of the validation types (Field_CheckBox_Values, Field_Value_Range, Field_Value_Check or Field_Value_Table), the Data Dictionary is smart enough to be able to provide a default prompt list. It does this if there is no prompt list explicitly assigned. So if you assign a Field_Prompt_Object for a field, it will get used in place of the prompt list provided for extended validations.

See Also

File_Field_Prompt_Object | Field_Zoom_Object | Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Property Field_Select_State]

Field_Select_State - DataDictionary

Sets the field's state in the local buffer

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iField integer iState

Parameter | Description
iField | Number of the field in the table
iState | Select state of field iField

Description

The Field_Select_State property sets the field's state in the local buffer. It notifies DEOs if the value of the field has changed.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Select_State FIELD OrderHea.Posted to bState

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Select_State of oOrderHea_DD FILE_FIELD OrderHea.Posted to bState

See Also

File_Field_Select_State

Last Edited: August 12, 2005


DataDictionary [Property Field_Table_Object]

Field_Table_Object - DataDictionary

Returns the object handle of a field's ValidationTable if one exists

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: integer iField Integer iValue

Parameter | Description
iField | Number of the field in the table
iValue | The object handle of the validationTable. If zero, none exists

Description

This returns the object handle of a field's ValidationTable if one exists.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Table_Object FIELD Customer.Name to iTableObject

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Table_Object of oCustomer_DD FILE_FIELD Customer.Name to iTableObject

Last Edited: July 11, 2005


DataDictionary [Property Field_Validate_MSG]

Field_Validate_MSG - DataDictionary

Lets you assign a general-purpose message to be sent when a field should be validated

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iField Integer iMsg

Parameter | Description
iField | Number of the field in the table
iMsg | Message id of the function to use to validate field iField

Description

Set Field_Validate_msg field employee.pay_type to get_valid_pay_type

The Field_Validate_msg property lets you assign a general-purpose message to be sent when a field should be validated. This message will be the message-Id of a function and will get called whenever your program requires a validation. This validation method is used when you need to perform complex validations that can only be expressed with code. Since it is a very open-ended process, it can do just about anything. If the value is valid, the function should return a zero. If the value is invalid, the function should generate an error and return a non-zero value.

This validation method can be used in conjunction with the other validation techniques (checkbox, range, check, validation table) or as a replacement to them.

You must create the validation function(s). This function will get passed the field number and the current field value. Your function may use these values as it sees fit. For this purpose, the value of any other field in the data dictionary may be obtained by getting the Field_Current_Value property. It is important to note that the validation routine should never need to access a value in a DEO. The information required should be found in the DDO or in one of the DDOs connected to it.

For example, if you have the following member function.

Function ValidateCredit Integer iField Number nValue Returns Boolean
    Boolean bErr
    String sCustRating

    // get the customer rating for this customer from DD buffer
    Get Field_Current_Value field Customer.Rating to sCustRating

    // if Customer Rating is A1 their limit is 5000
    If (sCustRating="A1" and nValue > 5000) Begin
        Error DFERR_OPERATOR "Credit limit may not exceed $5000"
        Move True To bErr
    End

    Function_Return bErr
End_Function  //ValidateCredit

To use this function on the Credit_Limit field of a file, you must set the field's validate method (Field_Validate_msg) to the handle name of the function. The handle name of a function is the name of the function prefixed with "get_" (e.g., get_ValidateCredit).Set Field_Validate_msg field Customer.Credit_Limit to get_ValidateCredit

The declaration prototype for a validation method takes the following general form.

Function function_name integer iField type CurrentValue returns integer

Where:

  • Function_name is the name of the validation function;
  • iField is the field number of the field that sent function_name. The field number can be used to retrieve any information about the field; and,
  • type and CurrentValue are the data type and current value of the field that sent function_name.

This allows you to write generalized validation-method functions that can be re-used for other fields and tables.

See Also

Field_Error | Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Property Field_Value_Check]

Field_Value_Check - DataDictionary

Defines the field to use a check-type validation

Type: Property

Access: Write-Only

Data Type: String

Parameters: Integer iField String sCheck

Parameter | Description
iField | Number of the field in the table
sCheck | String of allowed values for field iField

Description

Set Field_Value_Check field Customer.region to "N|S|E|W"

The Field_Value_Check message is used when the list of valid field values is limited to a static, small set of simple values. These samples are identified in a "check" string. This consists of a list of valid values separated by the | symbol. For example, the choices A, B and C would be represented by the check string A|B|C. The choices CA, FL, and TX would be represented by the check string CA|FL|TX.

The validation is performed after the user has entered data into the field's data-entry form. If the validation fails, then the user is prohibited from leaving the form. (The user may still exit the form by clicking elsewhere on the screen with the mouse). The validation is also performed when a record is saved. If the validation fails, the save is aborted.

In addition to being used for validation, these values may also be used with combo-box entry items. If a dbComboForm is assigned to a field using check values, each value in the check string will be loaded into the combo list.

Set Field_Value_Check field Customer.state to "CA|FL|NY|AZ"

The Customer.state example above is probably not a good usage of this validation method. Adding new states to this list requires program changes, and the string may quickly become too large to be practical. In such a case, you will want to use a validation table to provide the values.

When a validation error occurs, the error number and text specified for the field in the Field_Error property are used to report an error. If no text was defined, a standard check-error text will be reported.

The check validation is limited. A more flexible and reusable way of specifying a list of valid entries is to use a Validation Table.

See Also

Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Property Field_Value_Range]

Field_Value_Range - DataDictionary

Allows you to define a minimum and maximum range for the field

Type: Property

Access: Write-Only

Data Type: String

Parameters: Integer iField String sMin String sMax

Parameter | Description
iField | Number of the field in the table
sMin | Lowest allowed value for field iField
sMax | Highest allowed value for field iField

Description

Set Field_Value_Range field Customer.discount to 0 60

The Field_Value_Range method allows you to define a minimum and maximum range for the field. It is expected that the field and its range will be Numeric or Date. The From value must be lower than the To value.

The validation is performed after the user has entered data into the field's data-entry form. If the validation fails, then the user is prohibited from leaving the form. (The user may still exit the form by clicking elsewhere on the screen with the mouse).

When a validation error occurs, the error number and text specified for the field in the Field_Error property are used to report an error. If no text was defined, a standard check-error text will be reported.

The validation is also performed when a record is saved. If the validation fails, the save is aborted.

See Also

Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Property Field_Value_Table]

Field_Value_Table - DataDictionary

Identifies the object id of a validation table set up to validate this field

Type: Property

Access: Write-Only

Data Type: Integer

Parameters: Integer iField integer iObj

Parameter | Description
iField | Number of the field in the table
iObj | Object id of the object to use as validation table for field iField

Description

Set Field_Value_Table Field Customer.Status to oStatusTable

If a field needs to be validated against one of two values, a limited set of values, or a range of values, you can use the checkbox, range or check validations. In many cases you will find that these types of validations are too limited for your needs. In such a case, you may use field validation tables.

Using a field-validation table has the following advantages:

  • You can specify a larger number of valid values than can easily fit within a check string
  • You can specify and display a description for each value
  • You can dynamically maintain your list of values (i.e., the values do not have to be coded directly in your program)
  • You can make the list choices optional (i.e., you can display a list of suggested values during data entry but users are not required to make a selection from the list)

When a validation error occurs, the error number and text specified for the field in the Field_Error property are used to report an error. If no text was defined, a standard check-error text will be reported.

The use of validation tables provides tremendous flexibility. They will be discussed in greater detail in Using Validation Tables. For now, we will introduce the primary validation-table classes:

ValidationTable

This class allows you to maintain a list of valid values.

Object oStatusTable is a ValidationTable

     Procedure Fill_List
          Send Add_Table_Value "O"
          Send Add_Table_Value "C"
          Send Add_Table_Value "D"
     End_Procedure

End_Object

DescriptionValidationTable

This class allows you to maintain a list of valid values and their associated descriptions.

Object oStatusTable is a DescriptionValidationTable
     Set List_Title to "Customer Status"

     Procedure Fill_List
          Send Add_Table_Value "O"  "Opened"
          Send Add_Table_Value "C"  "Closed"
          Send Add_Table_Value "D"  "Flagged for Deletion"
     End_Procedure

End_Object

FileValidationTable

This class allows you to maintain a list of values and descriptions that can be easily loaded from a specified Visual DataFlex table.

Object Status_Table is a FileValidationTable
    Set Main_File to CustStat.File_Number
End_Object

CodeValidationTable

This class allows you to load your data and description values from the Visual DataFlex Code List.

Object oStatusTable is a CodeValidationTable
    Set Type_Value to "Status"
End_Object

Any of the above validation tables can be linked to a field with the Field_Value_Table message in a data dictionary.

Set Field_Value_Table Field Customer.Status to oStatusTable

See Also

Defining Data Dictionary Field Attributes | Using Validation Tables

Last Edited: July 12, 2005


DataDictionary [Property Field_Zoom_Object]

Field_Zoom_Object - DataDictionary

Get/sets the ID of the Zoom_Object for a field, such as a lookup (selection) list

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iField Integer iObj

Parameter | Description
iField | Number of the field in the table
iObj | Object id of the object to use as zoom object for field iField

Description

Field_Zoom_Object is used to get/set the ID of the Zoom_Object for a field, such as a lookup (selection) list

Sample

Set Field_Zoom_Object FIELD Customer.Customer_Number To (Customer_sl(Self))

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Zoom_Object FIELD Customer.Name to iZoomObject

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Zoom_Object of oCustomer_DD FILE_FIELD Customer.Name to iZoomObject

See Also

File_Field_Zoom_Object | Field_Prompt_Object

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Changed_State]

File_Field_Changed_State - DataDictionary

Flags a foreign field as changed or not, which determines whether the field participates in a save operation

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iFile Integer iField Integer iState

Parameter | Description
iFile | Number of the table
iField | Number of the field in table iFile
iState | Indicates whether field iField has been changed

Description

The File_Field_Changed_State property flags a foreign field as changed or not, which determines whether the field participates in a save operation.

Sample

Boolean bState
Get File_Field_Changed_State FILE_FIELD Customer.Name to bState

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Changed_State FIELD Customer.Name to sName

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Changed_State of oCustomer_DD FILE_FIELD Customer.Name to sName

See Also

Field_Changed_State

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Changed_Value]

File_Field_Changed_Value - DataDictionary

Changes the current value of a foreign database field and to set the field's changed state to true.

Type: Property

Access: Write-Only

Data Type: String

Parameters: Integer iFile Integer iField String sValue

Parameter | Description
iFile | Number of table in current filelist
iField | Number of the field in the table
sValue | Current value of field iField

Description

Syntax

Set File_Field_Changed_Value of hoDD Field Customer.Name to sName

This message is used to change the current value of a field and to set the field's changed state to true. This is a commonly used message and is the suggested method for changing DDO field values in preparation for a save. This message is only used for changing values. There is no get version of this message.

Function ChangeName RowId riRecId string sName returns Boolean
    Boolean bErr

    Send Clear of oUser_DD
    Send FindByRowId of oUser_DD User.File_Number riRecId
    If (Found) Begin
        // update name and save
        Set File_Field_Changed_Value of oUser_DD field User.Name to sName
        Get Request_Validate of oUser_DD to bErr
        If (not(bErr)) begin
            Send Request_Save of oUser_DD
            // if save succeeds, Err indicator is False
            Move (Err) to bErr
        End
    End
    Else Begin
        Move True to bErr
    End
    Function_Return bErr
End_Function

You will note that many of the samples use the file buffer to directly obtain the value of a field (e.g. Move Customer.Name to sName). This is discussed in detail in Understanding File Buffers and DDO Field Buffers.

There are two variants of the message, "Field" and "File_Field". This is discussed in Understanding the File_Field and Field Keywords.

See Also

Understanding File Buffers and DDO Field Buffers | Field_Changed_Value

Last Edited: July 12, 2005


DataDictionary [Property File_Field_CheckBox_Value]

File_Field_CheckBox_Value - DataDictionary

Returns the value for a foreign field for the passed in checkbox state (checked or unchecked)

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iFile Integer iField Integer iState String sValue

Parameter | Description
iFile | Number of the table in the current filelist
iField | Number of the field in the table
iState | Determines which Boolean state is being checked/assigned for iField
sValue | Value of the field iField

Description

The File_Field_CheckBox_Value property returns the value for a foreign field for the passed in checkbox state (checked or unchecked).

Sample

string sStatus
Get File_Field_Checkbox_Value FILE_FIELD Driver.CorrectiveLenses True to sStatus

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_CheckBox_Value FIELD Customer.Sex to sCheckBoxValue

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_CheckBox_Value of oCustomer_DD FILE_FIELD Customer.Sex to sCheckBoxValue

See Also

Field_Checkbox_Value

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Current_Description]

File_Field_Current_Description - DataDictionary

Returns the description for the current value of a data file field as listed in the field's validation table

Type: Property

Access: Read-Only

Data Type: String

Parameters: integer iFile integer iField String sValue

Parameter | Description
iFile | Number of table in current filelist
iField | Number of field in table
sValue | Value of the field iField

Description

The File_Field_Current_Description property returns the description for the current value of a data file field as listed in the field's validation table.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Current_Description FIELD OrderHea.Ship_via to sDescription

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Current_Description of oOrderHea_DD FILE_FIELD OrderHea.Ship_via to sDescription

See Also

Field_Current_Description

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Current_Pointer_Value]

File_Field_Current_Pointer_Value - DataDictionary

Returns a pointer to the data in the extended field object

Type: Property

Access: Read/Write

Data Type: Address

Parameters: integer iFile integer iField integer iLen Address pData

Parameter | Description
iFile | Number of table in current filelist
iField | Number of field in table
iLen | Length of data in field
pData | Pointer to data in field

Description

The File_Field_Current_Pointer_Value property returns a pointer to the data in the extended field object.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Current_Pointer_Value FIELD Customer.Name to sName

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Current_Pointer_Value of oCustomer_DD FILE_FIELD Customer.Name to sName

See Also

Field_Current_Pointer_Value

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Current_Value]

File_Field_Current_Value - DataDictionary

Gets or sets the current value of a foreign database field

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iFile Integer iField String sValue

Parameter | Description
iFile | Number of the table in the current filelist
iField | Number of the field in the table
sValue | Current value of field iField

Description

Syntax

Get File_Field_Current_Value of hoDD Field Customer.Name to sName
Set File_Field_Current_Value of hoDD Field Customer.Name to sName

These messages are used to retrieve and change a field's value. Get Field_Current_Value is used to retrieve the current value of a field. This message is used frequently.

You will note that many of the samples use the file buffer to directly obtain the value of a field (e.g. Move Customer.Name to sName). This is discussed in detail in Understanding File Buffers and DDO Field Buffers.

There are two variants of the message, "Field" and "File_Field". This is discussed in Understanding the File_Field and Field Keywords.

The set version of this message is used to change the current value of a field. You change the value of DDO field in preparation for a save. When you change a field's value you must also change its changed-state. This can be done with the Field_Changed_State message.

Set File_Field_Current_Value of hoDD Field Customer.Name to sName
Set File_Field_Changed_state of hoDD Field Customer.Name to True

The message File_Field_Changed_Value performs both of these operations and is usually used for this purpose. Therefore, the Set File_Field_Current_Value message is rarely used.

Important

If a save operation is not changing the value of changed field, check if you are using Field_Current_Value instead of Field_Changed_Value. This is a common mistake.

See Also

Understanding File Buffers and DDO Field Buffers | Field_Current_Value

Last Edited: July 12, 2005


DataDictionary [Property File_Field_default_Value]

File_Field_default_Value - DataDictionary

Sets the default value of a foreign field, for defaulting values in new records

Type: Property

Access: Write-Only

Data Type: String

Parameters: integer iFile integer iField string sValue

Parameter | Description
iFile | Number of the table in the current filelist
iField | Number of the field in the table
sValue | Default value field iField should have after a clear

Description

The File_Field_default_Value property sets the default value of a foreign field, for defaulting values in new records.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Default_Value FIELD Customer.Name to sValue

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Default_Value of oCustomer_DD FILE_FIELD Customer.Name to sValue

Sample

This sample sets the default value of the Customer.Date field to 0/01/2004.
Note that date values must be coded using U.S. date format.

set File_Field_Default_Value of oCustomer_DD FILE_FIELD Customer.Date to 01/01/2004

See Also

Field_Default_Value | Field_Defaults

Last Edited: July 12, 2005


DataDictionary [Property File_Field_Index]

File_Field_Index - DataDictionary

Used to retrieve the index for a file and field

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: integer iFile integer iField Integer iValue

Parameter | Description
iFile | Number of the table in the current filelist
iField | Number of the field in the table
sValue | Default value field iField should have after a clear

Description

The File_Field_Index property should be used to retrieve the index for a file and field. If the DDO's ordering property is explicitly set (i.e., it is non-zero) that value will be returned. If it is not, the main index assigned that file and field in Database Builder will be returned. If no index is assigned, -1 is returned.

Get File_Field_Index of hDD iFile iField to iIndex
Get File_Field_Index of hDD FILE_FIELD FileName.FieldName to iIndex

This property operates by finding the DDO that "owns" the passed file and sending the message Field_Index to that object. Therefore the message is actually resolved within Field_Index in the DDO that owns the file. For this reason, you should never augment File_Field_Index; augment Field_Index.

When sending this message you can use either File_Field_Index or Field_Index. Using File_Field_Index is easier because you do not have to worry that the message is sent to the correct DDO - it will find the owner DDO and send the message Field_Index.

When augmenting this method, always augment Field_Index in the owner DD. You can now be sure that this method will get called.

The messages File_Field_Index and Field_Index were created to replace the now obsolete message Field_Main_Index.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get File_Field_Index FIELD Customer.Name to sIndex

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Index of oCustomer_DD FILE_FIELD Customer.Name to sIndex

See Also

Field_Index

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Label]

File_Field_Label - DataDictionary

Returns the value of the value of the Field_Label_Long or the Field_Label_Short properties, or the tag name of a data file field

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iFile Integer iField Integer iType String sValue

Parameter | Description
iFile | Number of table in current filelist
iField | Number of field in the table
iType | Type of label to return: one of DD_Label_Long, DD_Label_Short, DD_Label_Tag
sValue | Value of field iField

Description

The File_Field_Label property returns the value of the value of the Field_Label_Long or the Field_Label_Short properties, or the tag name of a data file field.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Label FIELD Customer.Name to sLabel

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Label of oCustomer_DD FILE_FIELD Customer.Name to sLabel

See Also

Field_Label

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Label_Long]

File_Field_Label_Long - DataDictionary

A long description (or translation) of the name of a foreign field for such purposes as form captions

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iFile Integer iField String sValue

Parameter | Description
iFile | Number of the table in the current filelist
iField | Number of the field in the table
sValue | Value of the field iField

Description

The File_Field_Label_Long property is a long description (or translation) of the name of a foreign field for such purposes as form captions.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Label_Long FIELD Customer.Name to sLabel

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Label_Long of oCustomer_DD FILE_FIELD Customer.Name to sLabel

See Also

Field_Label_Long

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Label_Short]

File_Field_Label_Short - DataDictionary

A short description (or translation) of the name of a foreign field for such purposes as form captions

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iFile Integer iField String sValue

Parameter | Description
iFile | Number of the table in the current filelist
iField | Number of the field in the table
sValue | Value of field iField

Description

The File_Field_Label_Short property is a short description (or translation) of the name of a foreign field for such purposes as form captions.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Label_Short FIELD Customer.Name to sLabel

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Label_Short of oCustomer_DD FILE_FIELD Customer.Name to sLabel

See Also

Field_Label_Short

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Mask]

File_Field_Mask - DataDictionary

Provides the token characters for the mask for a database field

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iFile Integer iField String sValue

Parameter | Description
iFile | Number of table in current filelist
iField | Number of field in the table
sValue | Value of field iField

Description

The File_Field_Mask property provides the token characters for the mask for a database field.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Mask FIELD Customer.Name to sMask

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Mask of oCustomer_DD FILE_FIELD Customer.Name to sMask

See Also

Field_Mask

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Mask_Type]

File_Field_Mask_Type - DataDictionary

Controls the mask type of the field

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iFile Integer iField Integer iValue

Parameter | Description
iFile | Number of table in current filelist
iField | Number of field in the table
iValueType of mask to apply to field iField

Constant | Meaning
Mask_Window | General mask
Mask_Numeric_Window | Numeric mask
Mask_Date_Window | Date mask

Description

The File_Field_Mask_Type property controls the mask type of the field. This property may be set to any mask type consistent with the data type of the field. Doing so will automatically use the default mask (if any) for the mask type.

Use of Mask_Currency_Window will apply a mask generated from the Default_Currency_Mask ($,*;($,*)) for the field, where $ represents the local setting for currency symbol in Windows.

Use of Mask_Numeric_Window will apply a mask generated from the Default_Numeric_Mask (*).

The Field_Mask property can be used to specify the mask for fields of any mask type, and will override the defaults of those types that have defaults.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Mask_Type FIELD OrderHea.Date to sMaskType

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Mask_Type of oOrderHea_DD FILE_FIELD OrderHea.Date to sMaskType

See Also

Field_Mask_Type

Last Edited: September 14, 2005


DataDictionary [Property File_Field_Option]

File_Field_Option - DataDictionary

Sets a DD field option

Type: Property

Access: Write-Only

Data Type: Integer

Parameters: integer iFile integer iField Integer iOptions

Parameter | Description
iFile | Number of table in current filelist
iField | Number of field in the table
iOptions | The option to get/set

Description

The File_Field_Option property is used to set a DD field option. This message was created so that DD option changes could be dynamic. Changes made to DD options will be immediately reflected by data-entry objects using this field.

Set File_Field_Option of hDD iFile iField to DD_Retain
Set File_Field_Option of hDD File_Field FileName.FieldName to DD_Retain

This message is similar to the old DD message set File_field_Options with two exceptions 1) File_Field_Options accepts multiple parameters, and 2) File_Field_Options does not dynamically update DEOs with the option change. File_field_Options (the old message) should only be used within the define_fields procedure which are normally generated automatically for you by Database Builder.

If you need to set or change field options anywhere else within an application you should use the message File_Field_Option, or the related messages File_Field_Option_Clear and File_Field_Option_Toggle.

The options that can be set in VDF are:

  • DD_AutoFind
  • DD_AutoFind_GE
  • DD_CapsLock
  • DD_DisplayOnly
  • DD_FindReq
  • DD_ForcePut
  • DD_NoEnter
  • DD_NoPut
  • DD_Required
  • DD_Retain
  • DD_Retain_All
  • DD_SkipFound
  • DD_Zero_Suppress

Normally you will only set single options with this message. If you wish to set multiple options you can IOR these options within an expression.

Set File_Field_Option of hDD iFile iField to (DD_Retain IOR DD_NoEnter)

Currently a DD_Capslock is not immediately reflected in all objects - the object has to be deactivated and reactivated for the Capslock to take effect.

Note that you can use the message Field_Option instead of File_Field_Option if you are sure the message is being sent directly to the DD that owns the field. Often you will find that within a DDO you need to set options for parent or child DDOs. In this case you must use the File_Field version of this message. Our advice is that you always use the file_field version of DD messages (e.g. file_field_option, file_field_option_clear, file_field_option_toggle) as this makes it simpler for you.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Set Field_Option FIELD Customer.Customer_Name to DD_SkipFound

// When using the File_Field_ message use the FILE_FIELD keyword
Set File_Field_Current_Value of oCustomer_DD FILE_FIELD Customer.Name to DD_SkipFound

See Also

Changing Field Properties within a DD Object | Field_Option

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Options]

File_Field_Options - DataDictionary

Sets field properties for a database field

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iFile Integer iField Integer iValue

Parameter | Description
iFile | Number of table in current filelist
iField | Number of the field in the table
iValue | Value of the field iField

Description

The File_Field_Options property sets field properties for a database field.

Sample

Set File_Field_Options FILE_FIELD Orderhea.Total to DD_DisplayOnly
Set File_Field_Options FILE_FIELD Orderhea.Number to DD_AutoFind DD_NoPut

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Set Field_Options FIELD Customer.Name to DD_NoPut DD_SkipFound

// When using the File_Field_ message use the FILE_FIELD keyword
Set File_Field_Options of oCustomer_DD FILE_FIELD Customer.Name to DD_NoPut DD_SkipFound

See Also

Changing Field Properties within a DD Object | Field_Options

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Prompt_Object]

File_Field_Prompt_Object - DataDictionary

Gets/sets the ID of the Prompt_Object for a field, such as a lookup (selection) list

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iFile Integer iField Integer iValue

Parameter | Description
iFile | Number of table in the filelist
iField | Number of the field in the table
iValue | Object id of the object to use as prompt object for field iField

Description

The File_Field_Prompt_Object property is used to get/set the ID of the Prompt_Object for a field, such as a lookup (selection) list.

Sample

handle hoPromptObject
Get File_Field_Prompt_Object FILE_FIELD Customer.Customer_Number To hoPromptObject

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

handle hoPromptObject
// When using Field_ message use the FIELD keyword
Get Field_Prompt_Object FIELD Customer.Name to hoPromptObject

// When using the File_Field_ message use the FILE_FIELD keyword
handle hoPromptObject
Get File_Field_Prompt_Object of oCustomer_DD FILE_FIELD Customer.Name to hoPromptObject

See Also

Field_Prompt_Object | File_Field_Zoom_Object

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Select_State]

File_Field_Select_State - DataDictionary

Sets the field's state in the local buffer

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iFile Integer iField Integer iState

Parameter | Description
iFile | Number of table in current filelist
iField | Number of the field in the table
iState | Select state of field iField

Description

The File_Field_Select_State property is used to set the field's state in the local buffer. It notifies DEOs if the value of the field has changed.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Boolean bState
Get Field_Select_State FIELD OrderHea.Posted to bState

// When using the File_Field_ message use the FILE_FIELD keyword
Boolean bState
Get File_Field_Select_State of oOrderHea_DD FILE_FIELD OrderHea.Posted to bState

See Also

Field_Select_State

Last Edited: June 21, 2005


DataDictionary [Property File_Field_Status_Help]

File_Field_Status_Help - DataDictionary

Gets/Sets status-line help text for the passed field

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iFile Integer iField String sValue

Parameter | Description
iFile | Number of table in the filelist
iField | Number of the field in the table
sValue | Text of status help to display for field iField

Description

The File_Field_Status_Help property is used to get/set status-line help text for the passed field.

Sample

Set File_Field_Status_Help FILE_FIELD Customer.Address to "Street Address"

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Current_Value FIELD Customer.Name to sName

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Current_Value of oCustomer_DD FILE_FIELD Customer.Name to sName

See Also

Status_Help

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Table_Object]

File_Field_Table_Object - DataDictionary

Returns the object handle of a file and field's ValidationTable if one exists

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: integer iFile integer iField Integer iValue

Parameter | Description
iFile | Number of table in the filelist
iField | Number of the field in the table
iValue | The object handle of the validationTable. If zero, none exists

Description

This returns the object handle of a file and field's ValidationTable if one exists.

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Table_Object FIELD Customer.Name to iTableObject

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Table_Object of oCustomer_DD FILE_FIELD Customer.Name to iTableObject

Last Edited: July 11, 2005


DataDictionary [Property File_Field_Zoom_Object]

File_Field_Zoom_Object - DataDictionary

Gets/sets the ID of the Zoom_Object for a field, such as a lookup (selection) list

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iFile Integer iField Integer iValue

Parameter | Description
iFile | Number of table in current filelist
iField | Number of field in the table
iValue | Object id of the object to use as zoom object for field iField

Description

The File_Field_Zoom_Object property is used to get/set the ID of the Zoom_Object for a field, such as a lookup (selection) list.

Sample

Set File_Field_Zoom_Object FILE_FIELD Customer.Customer_Number To (Customer_sl(Self))

File and File_Field Interfaces

Many of the DataDictionary methods contain a two variants of the same message: Field_Message and File_Field_Message. For a complete description of these messages please refer to The Field and File_Field DD Interfaces.

The Field_ version of a message must use the keyword FIELD to identify the file.field name. The File_Field_ version must use the keyword FILE_FIELD to identify the file.field values. These should never be mixed!

// When using Field_ message use the FIELD keyword
Get Field_Zoom_Object FIELD Customer.Name to iZoomObject

// When using the File_Field_ message use the FILE_FIELD keyword
Get File_Field_Zoom_Object of oCustomer_DD FILE_FIELD Customer.Name to iZoomObject

See Also

Field_Zoom_Object | File_Field_Prompt_Object

Last Edited: July 11, 2005


DataDictionary [Property Foreign_Field_Options]

Foreign_Field_Options - DataDictionary

Allows you to assign additional item options to a field when that field is used as a parent field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iField Integer iArg1

Parameter | Description
iField | Number of the field in the table
iArg1 | Field option to set for field iField

Description

When an entry item refers to a table.field that is an ancestor of its DataDictionary object's (DDO's) main_file, that field is considered to be a foreign field. Very often foreign fields require additional item-option settings. For example, a foreign field may require an additional DD_NoPut or DD_DisplayOnly. The Foreign_Field_Options property allows you to assign additional item options to a field when that field is used as a parent field.

See the Field_Options property for a complete list of available field properties.

See Defining Data Dictionary Foreign Fields Attributes in the Data Dictionary Guide for a conceptual review of Foreign Fields.

Sample

Set Foreign_Field_Options Field Customer.Address to DD_DisplayOnly

Often foreign fields will be assigned field properties based on whether the field is a key field, an index field, or a non-indexed (default) field. It is common for a key field to be DD_AutoFind and DD_NoPut, for an index field to be DD_NoPut, and for a non-indexed field to be DD_DisplayOnly. Three special iField values allow you to set properties for all fields of these types. These integers are DD_KeyField, DD_IndexField, and DD_Default.

Samples

Set Foreign_Field_Options DD_KeyField to DD_AutoFind DD_NoPut
Set Foreign_Field_Options DD_IndexField to DD_NoPut
Set Foreign_Field_Options DD_Default to DD_DisplayOnly

See Also

Key Foreign Fields | Indexed Foreign Fields | Default Foreign Fields

Last Edited: July 11, 2005


DataDictionary [Property Key_Field_State]

Key_Field_State - DataDictionary

Designates a field as the primary key field for a table

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iField Integer iState

Parameter | Description
iField | Number of the field in the table
iState | Boolean value determining whether this field is a key field

Description

Set Protect_Key_State to True
Set Key_Field_State Field Customer.Id to True

Key fields are fields that have been designated to uniquely identify records in a table (e.g., customer_number in a customer table). The property used to designate key fields is Key_Field_State.

After you have designated key fields, you may set options for them all with Foreign_Field_Options.

Set Key_Field_State Field Customer.Id to True

Key_Field_State marks a field as the primary key field for the table.

One use of setting this option can be to prevent changes to the data stored in the field. This is known as key-field protection. Key-field protection allows data to be entered into the key field only when the record is first created. Once the record is created, the key-field data cannot be changed.

You would normally set this option on primary key fields such as the Order Number field in an Order Header table or the Customer ID field in the Customer table. This offers orphan prevention by preventing the ID fields used in parent-child relationships from being changed.

If your primary Key consists of multiple field segments, all fields in the key should be marked as Key Fields.

Key fields are only protected in a table if the Protect_Key_State property is also set in the Data Dictionary.

See Also

Protect_Key_State | Defining Data Dictionary Table Attributes

Last Edited: July 11, 2005


DataDictionary [Property Key_Value]

Key_Value - DataDictionary

Returns the complete (all fields) key value for the current record

Type: Property

Access: Read-Only

Data Type: String

Description

The Key_Value property returns the complete (all fields) key value for the current record.

Last Edited: August 18, 2003


DataDictionary [Property pbDDAttach]

pbDDAttach - DataDictionary

Detemines if an Attach is limited to the current DDO Structure

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbDDAttach determines how the procedure Attach_main_file will attach related parent fields into the main file. When True, the default, the attaches only occur when the parent file is actually part of the current DDO structure. When False, all open parent files are attached.

Default: True

You normally never want non attached parent files to attach their data into a main-file and therefore you will rarely ever want to change this property. Older versions of the DataDicitionary class did not limit their attaches to DDOs within the structure. This property was created to provide support for this old syle usage. Before changing this property, check your code to see if this can be handled in a better way such as actually adding the parent DDO to your structure.

See Also

Attach_Main_File

Last Edited: January 12, 2006


DataDictionary [Property Protect_Key_State]

Protect_Key_State - DataDictionary

Determines whether users are prevented from changing the values of key fields

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set Protect_Key_State to True

Protect_Key_State determines if the fields that make up a primary key should be "protected" after they have been saved the first time in a new record.

When set to true, a field identified as being part of a key cannot be edited after it has been saved. This ensures that child records that relate to a parent through a primary key will not become accidentally orphaned.

The fields that make up a primary key are identified by using the Key_Field_State field property.

Note:
Protect_Key_State has no effect if used on a field in a child table that relates to a field in a parent table, because the field's content will be copied from the parent table at a later time during the Attach_Main_File event.

See Also

Key_Field_State | Defining Data Dictionary Table Attributes

Last Edited: January 12, 2006


DataDictionary [Property Status_Help]

Status_Help - DataDictionary

Gets/Sets status-line help text for the field

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iField string sVal

Parameter | Description
iField | Number of the field in the table
sVal | Text of status help to display for field iField

Description

Set Status_Help field cust.status to "Customer is (A)ctive or (I)nactive"

Status_Help defines a status-help text line for the field. Entry objects will use this to display status-bar help. When the user moves the cursor to a data-entry object for the field, the Status Help is displayed in the status bar.

Enter text that will aid the user with data entry to this field.

See Also

File_Field_Status_Help | Defining Data Dictionary Field Attributes

Last Edited: July 11, 2005


DataDictionary [Property System_File_Count]

System_File_Count - DataDictionary

Determines the number of System Files used by the DDO

Type: Property

Access: Read-Only

Data Type: Integer

Description

The System_File_Count property determines the number of System Files used by the DDO. This returns the number of system files and other externally updated tables required by this DDO. This property can be used with System_file_number to obtain all system/external files.

Get System_File_Count to iFiles
For i From 0 to (iFiles-1)
      Get System_File_Number  i to iFile
      Send ProcessThisSystemFile iFIle
Loop

System Files are added by using the Add_System_File message. Normally, this is done within DataBase Builder using the visual DD builder.

See Also

System_File_Number | System_File_Lock_Mode | Add_System_File

Last Edited: September 11, 2003


DataDictionary [Property System_File_Lock_Mode]

System_File_Lock_Mode - DataDictionary

Returns the File Lock mode for a system file

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: integer iItem Integer iValue

Parameter | Description
iItem | The System File item number (zero based)
iValueThe Lock mode for the item. Can be one of the following constant values:

Constant | Meaning
DD_Lock_On_All | Lock on all saves and deletes (default)
DD_Lock_On_New_Save_Delete | Lock on new saves and deletes
DD_Lock_On_Save | Lock on all saves
DD_Lock_On_New_Save | Lock only on new saves
DD_Lock_On_Delete | Lock only on deletes

Description

System_File_Lock_Mode determines the lock file mode for passed item number from DDO's required system files and externally updated tables. This property can be used with System_file_Count and System_file_number to process the system file list.

Get System_File_Count to iFiles
For i From 0 to (iFiles-1)
      Get System_File_Number  i to iFile
      Get System_File_Lock_mode to eMode
      Showln "Item: " i " File#: " iFile " Lock-mode: " eMode
Loop

System Files and their lock modes are added by using the Add_System_File message. Normally, this is done within DataBase Builder using the visual DD builder.

See Also

System_File_Count | System_File_Number | Add_System_File

Last Edited: September 11, 2003


DataDictionary [Property System_File_Number]

System_File_Number - DataDictionary

Returns the File number for a system file

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iItem Integer iValue

Parameter | Description
iItem | The System File item number (zero based)
iValue | The returned file number for iItem

Description

System_File_Number returns the file number for the passed item number from DDO's required system files and externally updated tables. This property can be used with System_file_Count to obtain all system/external files.

Get System_File_Count to iFiles
For i From 0 to (iFiles-1)
      Get System_File_Number  i to iFile
      Send ProcessThisSystemFile iFIle
Loop

System Files are added by using the Add_System_File message. Normally, this is done within DataBase Builder using the visual DD builder.

See Also

System_File_Count | System_File_Lock_Mode | Add_System_File

Last Edited: September 11, 2003


DataDictionary [Property Validate_All_Fields_State]

Validate_All_Fields_State - DataDictionary

Supports Request_Validate_All

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Validate_All_Fields_State property is used to support Request_Validate_All. This determines if a validation should stop upon the first validation failure or if all fields should be validated, generating an error for each failed field. It is then up to the developer to write the error handling code to handle all of the errors. Normally, this property is set to False and will rarely be changed.

See Also

Request_Validate_All

Last Edited: January 12, 2006


DataDictionary [Property Validate_Delete_Structure_Mode]

Validate_Delete_Structure_Mode - DataDictionary

Determines what type of DataDictionary object-structure validation will occur before a delete operation

Type: Property

Access: Read/Write

Data Type: Integer

Description

When a Save or a Delete request is made to a Data Dictionary, it will validate its object structure and make sure that all of the required parent and child DDOs are present and properly connected. Depending on the type of operation, save, delete with no cascade, or delete with cascade different types of validations are performed. If the current DDO structure is not complete for the specified operation, an error will be raised and the operation will not occur.

Verifying an entire DDO structure for a particular operation can be a complicated process. As long as you provide each Data Dictionary class with an accurate list of required parent and child tables this complicated process will be handled for you automatically.

Validation Mode

Set Validate_Save_Structure_Mode   to DD_VALIDATE_STRUCTURE_ONCE
Set Validate_Delete_Structure_Mode to DD_VALIDATE_STRUCTURE_ONCE

Properties are provided that allow you to modify how Save and Delete structure validation is handled. Since DDO structures tend to be static within an application you normally you only need to validate a save and delete structure one time, which will be the first time you try to save or delete within a DDO. This is the default.

If you are creating DDOs that change dynamically, you may need perform this validation before every save and delete. While this is unlikely, it is supported.

Finally, you may choose to turn this validation off completely. This should be done with caution.

Below is a summary of the validation modes:

Constant | Meaning
DD_VALIDATE_STRUCTURE_ALWAYS | The Data Dictionary will check the table structures every time a record is saved / deleted.
DD_VALIDATE_STRUCTURE_NEVER | Data Dictionary parent-tables-structure checking is disabled.
DD_VALIDATE_STRUCTURE_ONCE | The default. The Data Dictionary will check the table structures once when the first record is saved after loading the view. This assumes that the structure will not change during the session - normally a safe assumption.

See Also

Defining Data Dictionary Parent, Child and External Relationships

Last Edited: July 11, 2005


DataDictionary [Property Validate_DEOs_Only_State]

Validate_DEOs_Only_State - DataDictionary

Determines whether validation is limited to fields represented in the current view

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set to its default True state, the Validate_DEOs_Only_State property could allow data-integrity failures in fields not represented in the current view.

Last Edited: January 12, 2006


DataDictionary [Property Validate_Foreign_File_State]

Validate_Foreign_File_State - DataDictionary

Determines if field validation should be applied to foreign (parent) tables

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Set Validate_Foreign_File_State to False

Before a save occurs, you will want to validation all fields by sending the Request_Validate message to the DDO performing the save. Normally all fields in all tables that participate in a save will be validated. This includes fields that have no visual representation in the current view and this includes all fields in all ancestor tables. In almost all cases, this level of data protection is desired, and is a powerful feature of the data dictionary. In rare cases, you may wish to select lower levels of validation protection.

The property Validate_Foreign_File_State determines if field validation should be applied to foreign (parent) tables. Normally you want this level of validation, so its default value is true. Setting its value to false will skip field validation when the table is used as a parent table in your DDO structure. It will also suppress validation in all additional ancestor tables.

Setting this property away from their defaults essentially defeats full field validation and potentially compromises data integrity. They should only be used under carefully controlled circumstances.

Do not use this property as short-cut solutions to bad database design. Special conditional validation rules can be programmed directly into your validation routines. For example, you could build a validation routine that only applies a field validation to new records (check the record's status with the HasRecord property) or you could create validation routines that selectively skip certain fields when they are foreign (the Operation_Origin global integer tells you which DDO started the save). Rather than breaking a rule, attempt to define this rule change as part of your rule set. In the end, you will have a better, more-robust application.

See Also

Defining Data Dictionary Table Attributes

Last Edited: January 12, 2006


DataDictionary [Property Validate_Save_Structure_Mode]

Validate_Save_Structure_Mode - DataDictionary

Determines what type of DataDictionary object structure validation will occur before a save operation

Type: Property

Access: Read/Write

Data Type: Integer

Description

When a Save or a Delete request is made to a Data Dictionary, it will validate its object structure and make sure that all of the required parent and child DDOs are present and properly connected. Depending on the type of operation, save, delete with no cascade, or delete with cascade different types of validations are performed. If the current DDO structure is not complete for the specified operation, an error will be raised and the operation will not occur.

Verifying an entire DDO structure for a particular operation can be a complicated process. As long as you provide each Data Dictionary class with an accurate list of required parent and child tables this complicated process will be handled for you automatically.

Validation Mode

Set Validate_Save_Structure_Mode   to DD_VALIDATE_STRUCTURE_ONCE
Set Validate_Delete_Structure_Mode to DD_VALIDATE_STRUCTURE_ONCE

Properties are provided that allow you to modify how Save and Delete structure validation is handled. Since DDO structures tend to be static within an application you normally you only need to validate a save and delete structure one time, which will be the first time you try to save or delete within a DDO. This is the default.

If you are creating DDOs that change dynamically, you may need perform this validation before every save and delete. While this is unlikely, it is supported.

Finally, you may choose to turn this validation off completely. This should be done with caution.

Below is a summary of the validation modes:

Constant | Meaning
DD_VALIDATE_STRUCTURE_ALWAYS | The Data Dictionary will check the table structures every time a record is saved / deleted.
DD_VALIDATE_STRUCTURE_NEVER | Data Dictionary parent-tables-structure checking is disabled.
DD_VALIDATE_STRUCTURE_ONCE | The default. The Data Dictionary will check the table structures once when the first record is saved after loading the view. This assumes that the structure will not change during the session - normally a safe assumption.

See Also

Defining Data Dictionary Parent, Child and External Relationships

Last Edited: July 11, 2005


DataList [Event Header_Mouse_Click]

Header_Mouse_Click - DataList

Type: Event

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


DataList [Event OnBeginningOfPanel]

OnBeginningOfPanel - DataList

Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view

Type: Event

Parameters: Integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

In dbGrids and dbLists (actually the Datalist class) the OnBeginningOfPanel method is used to snap the grid back to column zero whenever the message beginning_of_panel is sent to a view. The message beginning_of_panel sends the message OnBeginningOfPanel to all objects. When the dbGrid or dbList receives the message it does the following:

// augment to always force the first column to be visible. This will occur during a
// panel's clear or save. It makes sense to restore the column. If you do no want this
// behavior just cancel it.
Procedure OnBeginningofPanel
   Send DoMakeColumnVisible 0
end_procedure

Last Edited: July 11, 2006


DataList [Event onInitSpin]

onInitSpin - DataList

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Events for DataList

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click |  |
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items | WideList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view |
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin |  |
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnNewOrdering | Called whenever the ordering is changed | DataList_
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DataList_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for DataList

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list | DataList_
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful | DataList_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Returns the message_id of itself | cUIObject
Clear_Current_Record | Procedure |  | DataList_
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Col_Index | Function | Returns the number of the main index for the field connected to Column Item# | DataList_
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Display | Procedure |  | DataList_
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoCheckDisplayableRows | Procedure |  | DataList_
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm |
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList | DataList_
DoToggleColumnOrdering | Procedure |  | DataList_
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Finds the last record in the main_file of this object, and displays a new list page ending with that record if the find was successful | DataList_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
Establish_Find_Mode | Procedure |  | DataList_
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
File_Record | Function | (Obsolete) | DataList_
FileRecord | Function |  | DataList_
FileRowId | Function |  | DataList_
Fill_List | Procedure |  | DataList_
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer | DataList_
Find_Init | Procedure |  | DataList_
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object | DataList_
find_RowId | Procedure |  | DataList_
Goto_Bottom_Row | Procedure |  | DataList_
Goto_Top_Row | Procedure |  | DataList_
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in | DataList_
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Read_By_Recnum | Procedure | (Obsolete) | DataList_
Read_Next_Record | Procedure |  | DataList_
ReadByRowId | Procedure |  | DataList_
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col# | DataList_
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Reorder_list | Procedure | Permits manual reordering of the contents of the data list | DataList_
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column | DataList_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines | EntryList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure |  | DataList_
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Validate_Prompt | Function | (Obsolete) | WideList
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


DataList [Procedure DoDisplayCheckBox]

DoDisplayCheckBox - DataList

Displays the appropriate checkbox bitmap in the passed iItm

Type: Procedure

Parameters: integer iItm integer bSt

Parameter | Description
iItm | The item number
bSt | Checked state- If true, item is checked

Description

The DoDisplayCheckbox message displays the appropriate checkbox bitmap in the passed iItm. One of four checkboxes is displayed based on the values of bSt and the item's item_select_state.

Data Value | Appearance | Bitmap Name
bSt=True Item_select_state=True | A red check mark inside a light grey (disabled) border | ChkOnD.bmp
bSt=False Item_select_state=True | An empty light grey (disabled) checkbox | ChkOffD.bmp
bSt=True Item_select_state=False | A red check mark inside a checkbox with a dark (enabled) border | ChkOnE.bmp
bSt=False Item_select_state=False | An empty checkbox with a dark (enabled) border | ChkOffE.bmp

This message will normally be sent from within entry_display and is used to display checkbox bitmaps for an item.

Begin_Row
    Entry_Item Customer.Number
    Entry_Item Customer.Cust_Name
    Entry_Item ("") // we will place our bitmap here
End_Row
:
Procedure Entry_Display integer i1 integer i2
    integer iBase
    integer bIsOver

    Forward send entry_display i1 i2 // normal display
    Move (Customer.Balance >Customer.Credit_Limit) to bIsOver
    Get base_item to iBase  // Item value of first column
    Send DoDisplayCheckBox (iBase +2) bIsOver
End_Procedure

Last Edited: August 6, 2004


Properties for DataList

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_index_state | Determines how the popup lists will be ordered | DataList_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Batch_State | Determines how much data from the database is read into memory | DataList_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Button |  |
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case |
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox |
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message |
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message |
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to |
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to |
Column_Option | Allows you to query or change the iOption option line for Column iCol |
Column_Options | Allows you to copy column options or set them in a group |
Column_Prompt_Object | Specifies the default receiving object for the popup message |
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled |
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message |
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Record | (Obsolete) The number of the record of the current row | DataList_
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRecordStatus |  | DataList_
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowHasRecord |  | DataList_
CurrentRowId |  | DataList_
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
CustomScrollState | Determines changing scroll bar behaviors |
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) |
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Init_from_Top_State | Determines in what order images are displayed | DataList_
Initial_Column | Determines where the cursor is located when the list is activated | DataList_
Initial_Row | Governs the location in the display of the record (if any) in the buffer | DataList_
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_File | Holds the file number of the main file of the list | DataList_
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
No_Relate_State | Determines if relates occur with lists that do not use DDOs | DataList_
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Ordering | Holds the index of the main file to be used to display the database records of the main file | DataList_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls |
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction |
pbReverseOrdering | Determines if the list should be displayed in reverse index order | DataList_
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object | Returns the object-id of the internal object | DataList_
psEmbeddedButtonValue |  |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object | DataList_
Record_Number | (Obsolete) Indicates the record number for the record in the specified row | DataList_
record_rowId |  | DataList_
RecordStatus |  | DataList_
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
RowHasRecord |  | DataList_
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released |
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | WideList_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Static_State | Determines if the list will only be initialized once the first time this object is activated | DataList_
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior |
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


DataList [Property Column_Button]

Column_Button - DataList

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iCol integer eMode

Parameter | Description
iCol | [ToDo: In Progress]
eMode | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


DataList [Property Column_CapsLock_State]

Column_CapsLock_State - DataList

Determines if all text entered to this column from the keyboard will be converted to upper case

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iCol Boolean bState

Parameter | Description
iCol | The column number (zero-based)
bState | If true column is capslock

Description

When the Column_capslock_state property is set true, all text entered to this column from the keyboard will be converted to upper case. Values set to this column by the program will not be affected by this property. This property cannot be changed while this object is active; for a change made while the program is running to take effect, the object must be (deactivated and) activated after this property has been set to the desired value.

Default is false.

Last Edited: July 11, 2006


DataList [Property Column_Checkbox_State]

Column_Checkbox_State - DataList

Specifies whether a column of a grid is presented as a checkbox

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iCol Boolean bSelect

Parameter | Description
iCol | The column number (zero-based)
bSelect | If True, column is a checkbox

Description

The Column_Checkbox_State property specifies whether iCol of this grid is presented as a checkbox. This will be used most-often when a column's field is defined by its data dictionary as a checkbox type. This property can be used with dbGrid objects and dbList as well.

Normally this property is set once in your program when the object is being created. If a data field value can be represented as a checkbox, you can set the dbGrid's column to be a checkbox by setting this property to true.

Set Column_Checkbox_State 4 to True

This property may be set dynamically, although such usage would be unusual. If the property is changed when the object is active, you will not see a change in the object's appearance until you redisplay the object. The following sample would toggle a column's checkbox state and update the dbGrid as required.

Procedure ToggleCB4
    Boolean bState

    Get Column_Checkbox_State 4 to bState
    Set Column_Checkbox_State 4 to (not(bState))

    // if the object is active, we must refresh to see changes
    If Active_State send Display
End_Procedure  // ToggleCB4

Note:
Column_xxx states must be set after the Entry_Items, in order for it to take effect (e.g. in the bottom code section - below the comment line in the editor).

Default is false

Last Edited: July 11, 2006


DataList [Property Column_Entry_msg]

Column_Entry_msg - DataList

Sent every time the item is entered by a user in response to the item_change or the entering message

Type: Property

Access: Read/Write

Data Type: Handle

Parameters: Integer iCol Handle hmMsg

Parameter | Description
iCol | The column number (zero-based)
hmMsg | The entry message id

Description

Each entry_item has a message which is sent every time the item is entered by a user. The Column_entry_msg message is sent in response to the item_change or the entering message. The value of this property is sent as a parameter to the item_entry function. You may override the function with custom entry processing of the item.

set column_entry_msg item 8 to msg_set_up_data

Last Edited: July 11, 2006


DataList [Property Column_Exit_msg]

Column_Exit_msg - DataList

Sent every time the item is exited by the user in response to the item_change or the exiting message

Type: Property

Access: Read/Write

Data Type: Handle

Parameters: Integer iCol Handle hmMsg

Parameter | Description
iCol | The column number (zero-based)
hmMsg | The exit message id

Description

Each entry_item has a message which is sent every time the item is exited by the user. The Column_exit_msg message is sent in response to the item_change or the exiting message. The column_exit_msg property is sent as a parameter to the item_exit function. You may override the function with custom exit processing of the item.

set column_exit_msg item 6 to msg_exiting_field

Last Edited: July 11, 2006


DataList [Property Column_Maximum_Position]

Column_Maximum_Position - DataList

Maintains the value that represents the highest value that the spin button will spin up to

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iCol integer iPos

Parameter | Description
iCol | Column number to apply maximum position to (zero-based)
iPos | Maximum position for the spin button

Description

The Maximum_Position property maintains the value that represents the highest value that the spin button will spin up to. The value is in the range of 32767 to -32767

Default is 32767.

Last Edited: June 16, 2005


DataList [Property Column_Minimum_Position]

Column_Minimum_Position - DataList

Maintains the value that represents the lowest value that the spin button will spin down to

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iCol integer iPos

Parameter | Description
iCol | Column number to apply mimimum position to (zero-based)
iPos | Minimum position for the spin button

Description

The Minimum_Position property maintains the value that represents the lowest value that the spin button will spin down to. The value is in the range of 32767 to -32767

Default is 32767.

Last Edited: June 16, 2005


DataList [Property Column_Option]

Column_Option - DataList

Allows you to query or change the iOption option line for Column iCol

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iCol integer iOption integer bState

Parameter | Description
iCol | The column number (zero-based)
iOption | The option
bState | True to set the option, false to clear it

Description

The Column_option property allows you to query or change the iOption option line for Column iCol. The setting of the option is returned as a boolean value. The option is set or turned off by setting a boolean value in the property. iOption may be autofind, autofind_ge, findreq, forceput, noput, retain, retainall, and skipfound.

set column_option 4 to autofind true

if (column_option(self, 8, autofind_ge)) send check_status

set column_option 3 to findreq true

if (column_option(self, 1, findreq)) send check_status

set column_option 7 to noput true

if (column_option(self, 5, retain)) send check_status

set column_option 9 to retainall true

if (column_option(self, 10, skipfound)) send check_status

Default is false.

Last Edited: November 29, 2004


DataList [Property Column_Options]

Column_Options - DataList

Allows you to copy column options or set them in a group

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iCol integer iOptions

Parameter | Description
iCol | The column number (zero-based)
iOptions | Column options

Description

The Column_options property is the combination of all of the column_options. The message is provided to allow you to copy column options or set them in a group. The top 16 bits of the item options are for internal use and should not be changed by users. When you set column_options, you will usually wish to set field_options as well.

Get column_options item 5 to opts
set column_options of (scanner(self)) item 5 to opts
set field_options of (scanner(self)) item 5 to opts

In this example, the column_options of the sixth column of Object scanner are set to those of the sixth column of the current object.

To query, or get, the column_options of an item, use the individual column_option messages documented in this class.

Last Edited: November 29, 2004


DataList [Property Column_Prompt_Object]

Column_Prompt_Object - DataList

Specifies the default receiving object for the popup message

Type: Property

Access: Read/Write

Data Type: Handle

Parameters: Integer iCol Handle hObj

Parameter | Description
iCol | The column number (zero-based)
hObj | The column_prompt_object handle

Description

The Column_prompt_object property specifies the default receiving object for the popup message. By default, the property is not used in objects of this class, but is used in many of its subclasses, such as dbGrid.

Last Edited: July 11, 2006


DataList [Property Column_Shadow_State]

Column_Shadow_State - DataList

Determines if a column is disabled (shadowed) or enabled

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iCol Boolean bState

Parameter | Description
iCol | The column number (zero-based)
bState | True if column is disabled (shadowed), false if enabled

Description

Shadowing a column affects both its appearance and its functionality. A shadowed column will be displayed in the shadowed color (defined by the desktop or its palette). If a user places the selection cursor on a shadowed column, the column will not respond to the Enter key or any mouse action.

set column_shadow_state item 4 to true

if (column_shadow_state(self,current)) send ignore_item

Note: Column_xxx states must be set after the Entry_Items, in order for it to take effect. (e.g. in the bottom code section - below the comment line in the editor).

Last Edited: July 11, 2006


DataList [Property Column_Validate_msg]

Column_Validate_msg - DataList

Sent every time the item is validated in response to the item_change or the exiting message

Type: Property

Access: Read/Write

Data Type: Handle

Parameters: Integer iCol Handle hmMsg

Parameter | Description
iCol | The column number (zero-based)
hmMsg | The column validate message id

Description

Each entry_item has a message which is sent every time the item is validated. The Column_Validate_msg message is sent in response to the item_change or the exiting message. You may override the property with custom validation processing of the item.

set Column_Validate_msg 3 to msg_Validate_Price

Last Edited: July 11, 2006


DataList [Property Column_Zoom_Object]

Column_Zoom_Object - DataList

Sets the destination object_id of the popup message to the specified object

Type: Property

Access: Read/Write

Data Type: Handle

Parameters: Integer iCol Handle hObj

Parameter | Description
iCol | The column number (zero-based)
hObj | The column_zoom_object handle

Description

The Column_Zoom_Object property is used to set the destination object_id of the popup message to the specified object. By default, the property is not used in objects of this class, but is provided for use in higher-level classes, such as dbGrid.

Last Edited: July 11, 2006


DataList [Property CustomScrollState]

CustomScrollState - DataList

Determines changing scroll bar behaviors

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Any time that you customize the scroll bar messages you should set the CustomScrollState property.

If you are going to be changing scroll bar behaviors you are going to need to replace the behaviors in the existing super-classes (the dfbase and dfdata packages), while making sure that these messages still get forwarded to the runtime. These messages must get forwarded to the runtime or scrollbar control will not be notified of changes. To accomplish this you must set the property CustomScrollState to True.

When set to True, the package augmentations for the messages SetVScrollInfo, SetVScrollPos and SetVScrollBox are ignored and the messages are forwarded to the runtime.

Default is true.

Last Edited: January 12, 2006


DataList [Property DEO_Control_Object]

DEO_Control_Object - DataList

Indicates whether the control is a Data Entry Object (DEO)

Type: Property

Access: Read-Only

Data Type: Integer

Description

Any Data Entry Object (DEO) has DEO_Control_Object set true, which means that it is a DEO control object, but not a container.

Any DEO control will also return true for DEO_Object because of delegation (DEO controls must always reside in DEO containers).

See Also

DEO_Object

Last Edited: May 4, 2005


DataList [Property pbEmbeddedPrompts]

pbEmbeddedPrompts - DataList

Toggles embedding of prompt buttons in cells in list-based controls

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Toggles embedding of prompt buttons in cells in list-based controls, such as dbList and dbGrid.

If set to True, prompt buttons are displayed in the cells of the current row in a list-based control.
If set to False, prompt buttons are not displayed in the cells of the current row in a list-based control, but only in the control's header.

Last Edited: January 12, 2006


DataList [Property pbHeaderTogglesDirection]

pbHeaderTogglesDirection - DataList

Lets you use the header to change indexes and to change the index direction

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When pbHeaderTogglesDirection is true, clicking on a header will reverse the index, if making such a change is appropriate. The change is appropriate a) the grid already has the focus, b) the header column selected contains the current item and c) the column has an index associated with it.

pbHeaderTogglesDirection lets you use the header to change indexes and to change the index direction. If you click on a new header, the focus is moved to the new column and the index is changed (assuming auto_index_state is True). If you click a second time, the index will change directions.

The message Header_Mouse_Click uses this property to provide this behavior.

This should not be used with batch lists.

Default is false.

Last Edited: September 10, 2003


DataList [Property psEmbeddedButtonValue]

psEmbeddedButtonValue - DataList

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


DataList [Property ScrollOnThumbTrackState]

ScrollOnThumbTrackState - DataList

Determines if scrolling should occur when the thumb is dragged or when it is dragged and released

Type: Property

Access: Read/Write

Data Type: Boolean

Description

ScrollOnThumbTrackState determines if scrolling should occur when the thumb is dragged or when it is dragged and released. When set to True (the default) the grid scrolls as the thumb is dragged.

Normally, you will want to leave this property set to True. If your list contains a great deal of custom code to support special scrolling behaviors such that your grids can not support scrolling in "real time", you may need to set this to False. Since non-virtual grids scroll in-memory data this is not a likely occurrence.

Default is true.

Last Edited: January 12, 2006


DataList [Property ThumbScrollState]

ThumbScrollState - DataList

Determines if the scrollbar should use the more standard windows scrollbar behavior

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The ThumbScrollState property determines if the scrollbar should use the more standard windows scrollbar behavior. When set to True (the default), thumb movements will cause the grid to scroll. When set to False, thumb movements will generate row-up and row-down behaviors similar to pressing the scroll bar up and down arrows.

These behaviors are easier to see than to describe. You are encouraged to create a Grid in the Studio and try changing these properties.

Note that by setting both ScrollOnThumbTrackState and ThumbScrollState to False your grids will behave the way they did in previous versions of VDF.

Default is true.

Last Edited: January 12, 2006


DataList_ [Event OnNewOrdering]

OnNewOrdering - DataList_

Called whenever the ordering is changed

Type: Event

Parameters: integer iOrdering

Parameter | Description
iOrdering | An event that is called whenever the ordering is changed

Description

The OnNewOrdering event is called whenever the ordering is changed (i.e. when the ordering property changes). By default, this event does nothing and is provided for augmentation. You can use this to force the ordering direction for different indexes.

For example, if you always wanted Index 2 to be reversed and all other indexes to be normal you do this:

Procedure OnNewOrdering  integer iOrdering
    Set pbReverseOrdering to (iOrdering=2)
end_procedure

Last Edited: September 10, 2003


DataList_ [Event Refresh]

Refresh - DataList_

Displays items from some files at the same time as clearing items from other files

Type: Event

Parameters: integer notifyMode

Parameter Description
notifyModeThe mode, which signifies the event or operation which generated this refresh message, may be one of the following five:

Constant | Meaning
mode_clear | used only for DEOs attached to the DSO that was the "origin" of a clear operation, i.e., the DSO that received the original clear request or message as a result of a user pressing kclear. All other DSOs send their DEOs the refresh message passing mode_find_or_clear_set.
mode_find_or_clear_set | used for DEOs attached to DSOs that have found and/or cleared records in response to a user's find-request (kfind, kfind_next, ksuperfind, et al.) or in response to another DSO's find or clear.
mode_clear_all | used for DEOs attached to any DSO that participated in a clear_all operation.
mode_delete | used for DEOs attached to any DSO that performed a successful deletion. DSOs that were merely updated as the result of a deletion use mode_find_or_clear_set.
mode_save | used for DEOs attached to any DSOinvolved in a successful save operation.

Description

Refresh displays items from some files at the same time as clearing items from other files. In all cases, refresh will be sent instead of the clear, clear_set, clear_all, display, and entry_display messages in response to a find, clear, clear _all, save, or delete. In some cases, the actions of refresh depend on the (old) messages clear, clear _all, save, and display.

Last Edited: July 11, 2006


Events for DataList_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click | Sent whenever a header has received a mouse click | EntryList
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items | WideList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | EntryList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin | Augmented to set the minimum and maximum positions for a spinner | EntryList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnNewOrdering | Called whenever the ordering is changed |
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


DataList_ [Function Col_Index]

Col_Index - DataList_

Returns the number of the main index for the field connected to Column Item#

Type: Function

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Return Value

If no such index can be found, returns -1.

Description

Col_index returns the number of the main index for the field connected to Column Item#. If the field has no main index, searches for an index that contains the field.

Last Edited: August 4, 2004


DataList_ [Function File_Record]

File_Record - DataList_

Type: Function

Obsolete

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: November 11, 2004


DataList_ [Function FileRecord]

FileRecord - DataList_

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: November 11, 2004


DataList_ [Function FileRowId]

FileRowId - DataList_

Type: Function

Return Data Type: RowId

Parameters: No Parameters

Return Value

Description

Last Edited: November 11, 2004


DataList_ [Function ServerOrderingOverride]

ServerOrderingOverride - DataList_

Determines whether the control will use its Server DDO's Ordering or its own

Type: Function

Return Data Type: Boolean

Parameters: No Parameters

Return Value

Description

Returns True if Ordering is determined by the control's Server DDO. This only happens if pbUseServerOrdering is True, the control is attached to a DDO and the DDO has an explicit Ordering set.

Returns False if Ordering is provided by the control itself.

Last Edited: February 16, 2005


Methods for DataList_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list |
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Returns the message_id of itself | cUIObject
Clear_Current_Record | Procedure |  |
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Col_Index | Function | Returns the number of the main index for the field connected to Column Item# |
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Display | Procedure |  |
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoCheckDisplayableRows | Procedure |  |
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList |
DoToggleColumnOrdering | Procedure |  |
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Finds the last record in the main_file of this object, and displays a new list page ending with that record if the find was successful |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
Establish_Find_Mode | Procedure |  |
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
File_Record | Function | (Obsolete) |
FileRecord | Function |  |
FileRowId | Function |  |
Fill_List | Procedure |  |
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer |
Find_Init | Procedure |  |
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object |
find_RowId | Procedure |  |
Goto_Bottom_Row | Procedure |  |
Goto_Top_Row | Procedure |  |
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in |
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Read_By_Recnum | Procedure | (Obsolete) |
Read_Next_Record | Procedure |  |
ReadByRowId | Procedure |  |
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col# |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Reorder_list | Procedure | Permits manual reordering of the contents of the data list |
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines | EntryList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own |
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure |  |
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Validate_Prompt | Function | (Obsolete) | WideList
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


DataList_ [Procedure auto_reorder_list]

auto_reorder_list - DataList_

Permits automatic reordering of the contents of the data list

Type: Procedure

Parameters: integer item#

Parameter | Description
item# | The item number

Description

The Auto_reorder_list message permits automatic reordering of the contents of the data list. Auto_reorder_list is intended to be used as an item# message on an indexed field, to cause the list to reorder using that field whenever the cursor lands on that item.

Last Edited: July 30, 2003


DataList_ [Procedure Beginning_of_Data]

Beginning_of_Data - DataList_

Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful

Type: Procedure

Parameters: Integer NoSave

Parameter | Description
NoSave | Determines if a changed row should first be saved

Description

The Beginning_of_data message finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful. If the find was not successful, the display is cleared of all records. The NoSave argument is ignored in this class, but subclasses may use this flag to inhibit an unintentional save operation when the object is initialized.

Last Edited: July 30, 2003


DataList_ [Procedure Clear_Current_Record]

Clear_Current_Record - DataList_

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


DataList_ [Procedure Display]

Display - DataList_

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


DataList_ [Procedure DoCheckDisplayableRows]

DoCheckDisplayableRows - DataList_

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


DataList_ [Procedure DoSetOrderingDirection]

DoSetOrderingDirection - DataList_

Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList

Type: Procedure

Parameters: integer bReverse

Parameter | Description
bReverse | If true ordering should be reversed, if false it should not

Description

The DoSetOrderingDirection message is used to set the reverse ordering property (pbReverseOrdering) and to visually reverse the order of an active non-batch dbGrid or dbList.

The following example creates a button that reverses the ordering of a dbList:

Object oReverse is a button
     Set location to 100 100
     Set Label to "Reverse Order"
     Procedure OnClick
          Send DoSetOrderingDirection of oSelList (not(pbReverseOrdering(oSelList)))
    End_procedure
End_object

This message should not be sent to batch lists.

Last Edited: August 5, 2003


DataList_ [Procedure DoToggleColumnOrdering]

DoToggleColumnOrdering - DataList_

Type: Procedure

Parameters: integer iCol

Parameter | Description
iCol | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


DataList_ [Procedure End_of_Data]

End_of_Data - DataList_

Finds the last record in the main_file of this object, and displays a new list page ending with that record if the find was successful

Type: Procedure

Parameters: Integer NoSave

Parameter | Description
NoSave | Determines if a changed row should first be saved

Description

End_of_data finds the last record in the main_file of this object, and displays a new list page ending with that record if the find was successful. If the find was not successful, clears the list page. The NoSave parameter is ignored in this class, but subclasses may use this flag to inhibit an unintentional save operation when the object is initialized.

Last Edited: June 23, 2005


DataList_ [Procedure Establish_Find_Mode]

Establish_Find_Mode - DataList_

Type: Procedure

Parameters: Integer eFindMode

Parameter | Description
mode | [ToDo: In Progress]

Description

Last Edited: April 28, 2003


DataList_ [Procedure Fill_List]

Fill_List - DataList_

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


DataList_ [Procedure Find_Current_Buffer]

Find_Current_Buffer - DataList_

Finds the record in the main file whose data are in the buffer

Type: Procedure

Parameters: No Parameters

Description

Find_Current_Buffer finds the record in the main file whose data are in the buffer. If the sought-for record is not in the main file, or such record does not satisfy the constraints currently in force, finds the first record after the sought-for record that satisfies the current constraints.

Last Edited: February 18, 2004


DataList_ [Procedure Find_Init]

Find_Init - DataList_

Type: Procedure

Parameters: Integer Dir

Parameter | Description
Dir | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


DataList_ [Procedure find_record]

find_record - DataList_

Finds the record identified by the given rec_number in the main_file of this object

Type: Procedure

Obsolete

Parameters: Integer rec#

Parameter | Description
rec# | The record number

Description

Find_record finds the record identified by the given rec# in the main_file of this object.

Last Edited: November 30, 2004


DataList_ [Procedure find_RowId]

find_RowId - DataList_

Type: Procedure

Parameters: RowId riRec

Parameter | Description
riRec | [ToDo: In Progress]

Description

Last Edited: November 11, 2004


DataList_ [Procedure Goto_Bottom_Row]

Goto_Bottom_Row - DataList_

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


DataList_ [Procedure Goto_Top_Row]

Goto_Top_Row - DataList_

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


DataList_ [Procedure Move_to_Column]

Move_to_Column - DataList_

Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in

Type: Procedure

Parameters: Integer Col#

Parameter | Description
Col# | The number of the column curser is moved to

Description

Move_to_column moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in. Columns of data lists are numbered starting with zero.

Last Edited: August 18, 2003


DataList_ [Procedure Read_By_Recnum]

Read_By_Recnum - DataList_

Type: Procedure

Obsolete

Parameters: integer rec#

Parameter | Description
rec# | [ToDo: In Progress]

Description

Last Edited: November 11, 2004


DataList_ [Procedure Read_Next_Record]

Read_Next_Record - DataList_

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


DataList_ [Procedure ReadByRowId]

ReadByRowId - DataList_

Type: Procedure

Parameters: RowId riRec

Parameter | Description
riRec | [ToDo: In Progress]

Description

Last Edited: November 11, 2004


DataList_ [Procedure Refresh_Page]

Refresh_Page - DataList_

Displays list page, with the currently active record at Row Row#, using the index for Column Col#

Type: Procedure

Parameters: integer Row# integer Col#

Parameter | Description
Row# | The number of any row in the display, or fill_from_center or fill_from_bottom
Col# | Optional; if it is not used, the current column is assumed

Description

Refresh_page displays list page, with the currently active record at Row Row#, using the index for Column Col#. Note that refresh_page does not affect the server of this object.

Last Edited: September 11, 2003


DataList_ [Procedure Reorder_list]

Reorder_list - DataList_

Permits manual reordering of the contents of the data list

Type: Procedure

Parameters: Integer iNewCol

Parameter | Description
iNewCol | Optional. The item number to reorder the list around.

Description

Reorder_list permits manual reordering of the contents of the data list. This message is intended to be used externally (e.g. by an accelerator key) to force the list to reorder based on the item number passed (or on the current item if no item number was passed).

Last Edited: September 11, 2003


DataList_ [Procedure Request_New_Index]

Request_New_Index - DataList_

Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column

Type: Procedure

Parameters: Integer iIndex

Parameter | Description
iIndex | The index number

Description

Request_new_index changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column.

Last Edited: September 11, 2003


DataList_ [Procedure Up_Row]

Up_Row - DataList_

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Properties for DataList_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_index_state | Determines how the popup lists will be ordered |
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Batch_State | Determines how much data from the database is read into memory |
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Record | (Obsolete) The number of the record of the current row |
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRecordStatus |  |
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowHasRecord |  |
CurrentRowId |  |
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Init_from_Top_State | Determines in what order images are displayed |
Initial_Column | Determines where the cursor is located when the list is activated |
Initial_Row | Governs the location in the display of the record (if any) in the buffer |
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_File | Holds the file number of the main file of the list |
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
No_Relate_State | Determines if relates occur with lists that do not use DDOs |
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Ordering | Holds the index of the main file to be used to display the database records of the main file |
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbReverseOrdering | Determines if the list should be displayed in reverse index order |
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object | Returns the object-id of the internal object |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object |
Record_Number | (Obsolete) Indicates the record number for the record in the specified row |
record_rowId |  |
RecordStatus |  |
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
RowHasRecord |  |
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | WideList_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Static_State | Determines if the list will only be initialized once the first time this object is activated |
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


DataList_ [Property Auto_index_state]

Auto_index_state - DataList_

Determines how the popup lists will be ordered

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_Index_State property is set to true, popup lists will be activated automatically in the order of the main index of the field for the column the cursor is located in on activation. If used together with auto_column_state, the lists will pop up with the cursor in the list column for the field to which the invoking item is connected, and the list will be ordered in the order of the main index of that field.

If Auto_Index_State is false, the list will be ordered by the index contained in the value of the ordering property.

Default is false.

Last Edited: January 12, 2006


DataList_ [Property Batch_State]

Batch_State - DataList_

Determines how much data from the database is read into memory

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Batch_state property is true, the data from the entire database for this list is read into memory (into entry_items) at once when the list is first activated, and again each time an explicit save to the database is executed. The property is set true by the use of the batch keyword in the object declaration, but can also be set directly with the set command. If this property is false (the default), only as much data from the database is read into memory as is required to fill the display. Whenever cursor movements change the range of what is displayed, additional records are drawn from the database.

Default is false.

Last Edited: January 12, 2006


DataList_ [Property Current_Record]

Current_Record - DataList_

The number of the record of the current row

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Current_Record is the number of the record of the current row.

Last Edited: November 11, 2004


DataList_ [Property CurrentRecordStatus]

CurrentRecordStatus - DataList_

Type: Property

Access: Write-Only

Data Type: Integer

Description

Last Edited: November 11, 2004


DataList_ [Property CurrentRowHasRecord]

CurrentRowHasRecord - DataList_

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Last Edited: November 11, 2004


DataList_ [Property CurrentRowId]

CurrentRowId - DataList_

Type: Property

Access: Read/Write

Data Type: RowId

Description

Last Edited: November 11, 2004


DataList_ [Property Init_from_Top_State]

Init_from_Top_State - DataList_

Determines in what order images are displayed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Init_from_top_state property is true, the first record in the main file (or index thereof) will be displayed in the top line of the list image, the second in the second line, and so on to the bottom of the image. When the property is false, the first record is displayed in the bottom line of the list image, the second in the next-higher line, and so on to the top of the image.

Default is true.

Last Edited: January 12, 2006


DataList_ [Property Initial_Column]

Initial_Column - DataList_

Determines where the cursor is located when the list is activated

Type: Property

Access: Read/Write

Data Type: Integer

Description

In multi-column lists, the Initial_column property determines where the cursor is located when the list is activated. 0 is the first column.

Last Edited: August 18, 2003


DataList_ [Property Initial_Row]

Initial_Row - DataList_

Governs the location in the display of the record (if any) in the buffer

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the Initial_row property governs the location in the display of the record (if any) in the buffer. Its value should be set according to the direction in which searches are most likely to proceed from the seeded value. In unseeded lists, fill_from_top is normally appropriate, except where init_from_top_state is set false, in which case fill_from_bottom would seem more appropriate.

Default is fill_from_top.

Last Edited: August 18, 2003


DataList_ [Property Main_File]

Main_File - DataList_

Holds the file number of the main file of the list

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Main_file property holds the file number of the main file of the list. If the value of this property is zero, the main_file of this object's server, if any, is used. IT is set by main_file option of object-creation statement.

Last Edited: August 18, 2003


DataList_ [Property No_Relate_State]

No_Relate_State - DataList_

Determines if relates occur with lists that do not use DDOs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

In lists that are not using a DDO, performing finds in a main file that has many open ancestor files can be greatly speeded up by setting this property true. When it is true, the relate to ancestor files is not done. This property has no effect in lists using a DDO or acquiring one temporarily through auto_server_state true.

Default is false.

Last Edited: January 12, 2006


DataList_ [Property Ordering]

Ordering - DataList_

Holds the index of the main file to be used to display the database records of the main file

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Ordering property holds the index of the main file to be used to display the database records of the main file.

If the Auto_Index_State property is set to true, popup lists will be activated automatically in the order of the main index of the field for the column the cursor is located in on activation.

Use an index number that is available in your table definition. If you set it to a value higher than the maximum number of indexes for the current table, you will be notified at runtime via an "invalid index" error. If you specify a non-existent index number, you will receive an "invalid index" error or a "field not indexed" error.

A value of zero indicates that the record number (RECNUM) index should be used.

When Ordering is changed, the OnNewOrdering event is called.

Default is -1, which tells the runtime to choose the most-appropriate index based on current constraints.

See Also

Auto_Index_State | ServerOrderingOverride

Last Edited: February 17, 2005


DataList_ [Property pbReverseOrdering]

pbReverseOrdering - DataList_

Determines if the list should be displayed in reverse index order

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbReverseOrdering determines if the list should be displayed in reverse index order.

Changing this property will not cause an active list to be immediately reordered. If you want to change the list ordering dynamically send the message DoSetOrderingDirection.

This message can be used along with the new DataDictionary message pbAutoFillFromFirst to create constrained child dbGrids that fill in reverse order from the end of a constrained list.

Default is false.

Last Edited: September 10, 2003


DataList_ [Property pbUseServerOrdering]

pbUseServerOrdering - DataList_

Determines whether the control will use its Server DDO's Ordering or its own

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If you set pbUseServerOrdering true then the dbGrid or dbList will use the DDO's ordering if: 1) there is a DDO (server) attached to the control, and 2) the DDO has an explicit ordering. Normally a DDO server does not set its own ordering.

One normally sets the ordering in a DDO when using constraints and want to make sure that all finds occur using an optimal index for that constraint. When a DDO has specified an ordering, it should be the one controlling the list order. This stops the list from attempting to reorder itself in ways that would generate non-optimal, slow searches.

By default this property is false and is set that way for compatibility reasons. In most cases, True would be the preferred setting.

Last Edited: February 16, 2005


DataList_ [Property Prototype_Object]

Prototype_Object - DataList_

Returns the object-id of the internal object

Type: Property

Access: Read-Only

Data Type: Integer

Description

To create rows in the data-aware list the prototype of those rows is stored in an internal object. The Prototype_Object property does return the object-id of the internal object. The name of this object is always ELEMENT.

The items in the internal object are filled with a series of ENTRY_ITEM commands which are placed between a pair of BEGIN_ROW...END_ROW commands.

Begin_Row
  Entry_Item Customer.Number
  Entry_Item Customer.Name
End_Row

Last Edited: September 11, 2003


DataList_ [Property Read_Only_State]

Read_Only_State - DataList_

Determines if saving or deletion of this object's main file may be done through this object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Read_only_state property is true, no saving or deletion of this object's main file may be done through this object. Request_save and request_delete messages are ignored and delete cascading is stopped along this branch.

Default is false.

Last Edited: January 12, 2006


DataList_ [Property Record_Number]

Record_Number - DataList_

Indicates the record number for the record in the specified row

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Parameters: integer row# integer newval

Parameter | Description
row# | The row number
newval | The record number for row#

Description

Record_number indicates the record number for the record in the specified row.

Last Edited: November 11, 2004


DataList_ [Property record_rowId]

record_rowId - DataList_

Type: Property

Access: Read/Write

Data Type: RowId

Parameters: integer row# RowId riNewval

Parameter | Description
row# | [ToDo: In Progress]
riNewval | [ToDo: In Progress]

Description

Last Edited: November 11, 2004


DataList_ [Property RecordStatus]

RecordStatus - DataList_

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer row# integer newval

Parameter | Description
row# | [ToDo: In Progress]
newval | [ToDo: In Progress]

Description

Last Edited: November 11, 2004


DataList_ [Property RowHasRecord]

RowHasRecord - DataList_

Type: Property

Access: Read-Only

Data Type: Boolean

Parameters: integer iRow Boolean bValue

Parameter | Description
iRow | [ToDo: In Progress]
bValue | [ToDo: In Progress]

Description

Last Edited: November 11, 2004


DataList_ [Property Static_State]

Static_State - DataList_

Determines if the list will only be initialized once the first time this object is activated

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If this flag is true, the list will only be initialized once (by initialize_list) the first time this object is activated. In applications that allow editing of the list ("Code Maintenance" functions and the like) it is important that the Static_state property be set false in order to give effect to such changes during the sessions in which they are made.

Default is false.

Last Edited: January 12, 2006


DataSet [Event OnConstrain]

OnConstrain - DataSet

Defines constraint sets within a DataDictionary object (DDO)

Type: Event

Parameters: No Parameters

Description

The OnConstrain event defines constraint sets within a DataDictionary object (DDO). Constraints are used to limit the records that are considered to be members of the data set. Constraints are specified within the OnConstrain procedure. Each DDO may have, at most, one constraint procedure, but within this procedure may be as complex a set of constraints (including constraints whose values can be changed by users at run time) as you may need.

Sample

Procedure OnConstrain
    Constrain Customer.Status eq "A"
End_Procedure

Note that this procedure is not called every time a record is found. It is called when the DataDictionary builds a constraint set. Once a constraint set is built, that same set is applied to all records until a new set is created. Constraints are built when a view is activated or when the message Rebuild_Constraints is explicitly sent to a DataDictionary object (DDO). You will never send the message OnConstrain. If you need to dynamically change a constraint, then you must change the appropriate properties and then send the message Rebuild_Constraints to the DDO.

Sample

Object Invt_DD is an Invt_DataDictionary
    :
    Property Boolean pbAllowOld False

    Procedure OnConstrain
        Boolean bAllowOld

        Get pbAllowOld to bAllowOld

        // Conditional constraint
        If Not bAllowOld ;
            Constrain Invt.Status eq "A"

        // Unconditional constraint
        Constrain Invt.Qty gt 100
    End_Procedure  // OnConstrain
    :
End_Object

The above procedure could be called within a view with the following code:

Set pbAllowOld of Invt_DD to True
Send Rebuild_Constraints of Invt_DD

Within objects, it is suggested that you use OnConstrain and not procedure Constrain for creating constraints.

The commands Begin_Constraints and End_Constraints are obsolete. You should use the procedure OnConstrain in their place.

Procedure OnConstrain
    Boolean bAllowOld

    Get pbAllowOld to bAllowOld

    // Conditional constraint
    If Not (bAllowOld) ;
        Constrain Invt.Status eq "A"

    // Unconditional constraint
    Constrain Invt.Qty gt 100
End_Procedure  // OnConstrain

A special type of constraint called a relates-to constraint establishes a constrained parent child relationship between two files. Because this type of constraint is used so often, a property is provided to define this relationship. This constraint is set within the child DDO and is normally set with the Constrain_File property.

// this is used to create a relates to constraint (parent-child)
set Constrain_File to ParentFile.File_Number

It is assumed that a child will only have a constrained relates-to relationship with a single parent. A relates-to constraint is the only type of constraint type that is not placed inside of the OnConstrain procedure - it is placed directly within the object.

Object Child_DD is a Child_DataDictionary
    set DDO_Server to (ParentFileDD(Self))
    set Constrain_File to ParentFile.File_Number
End_Object  // Child_DD

Relates-to constraints not only affect the finding of records, the clearing of records as well. In general, any time a child-file DDO is cleared, its parent files' DDO(s) will also be cleared if and only if the child has no constraints that depend upon the parent. For example:

Object Parent1_DD is a Parent1_DataDictionary
End_Object

Object Parent2_DD is a Parent2_DataDictionary
End_Object

Object Child_DD is a Child_DataDictionary

    Set DDO_Server to (Parent1_DD (Self))
    Set DDO_Server to (Parent2_DD (Self))

    // this is used to create a relates to constraint  (parent child)
    Set Constrain_File to Parent2.File_Number

    // OnConstrain is used to set all other constraints
    Procedure OnConstrain
        Constrain Child.Status ne "X"
    End_Procedure  // OnConstrain

End_Object  // Child_DD

If Child_DD is asked to clear (by one of its data entry objects (DEOs), etc.), the relates-to constraint from Child to parent2 will prevent Parent2_DD from clearing, but Parent1_DD will clear, since Child_DD's constraints do not depend on Parent1.

See Also

When to Use the File-Buffer | Constraints and Filters | Filter Constraints | Inheritance of Constraints | Constrain command

Last Edited: July 12, 2005


Events for DataSet

View event list in hierarchical order

Name | Description | Defining Class
Attach_Main_File | Performs attach command on main file | BaseData_Set
Backout | Hook for performing operations when editing or deleting a new record | BaseData_Set
Clear_Main_File | Performs clear command on main table of this object | BaseData_Set
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Creating | Hook for performing operations required when creating a new record | BaseData_Set
Delete_Main_File | Performs the actual delete of the record | BaseData_Set
Deleting | Hook for performing operations when deleting a record | BaseData_Set
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
New_Current_Record | (Obsolete) Hook for performing operations during save, delete, and clear operations | BaseData_Set
OnConstrain | Defines constraint sets within a DataDictionary object (DDO) |
OnNewCurrentRecord |  | BaseData_Set
Relate_Main_File | Does nothing by default. Called after the normal relate on the main table has been executed. | BaseData_Set
Reset_Filemodes_For_Lock | Temporarily resets the file modes of the Main_File of this object and of any updated DataDictionary objects for a save/delete operation | BaseData_Set
Save_Main_File | Saves the main file | BaseData_Set
Update | Hook for performing operations when saving a record | BaseData_Set
Validate_Delete | Guards execution of delete operation | BaseData_Set
Validate_Delete_No_Cascade | Guards against deleting records with existing child records | BaseData_Set
Validate_Save | Used to enforce business rules and integrity rules | BaseData_Set


Methods for DataSet

View method list in hierarchical order

Name | Type | Description | Defining Class
Add_Client_File | Procedure | Adds a table to this object's related-child list | BaseData_Set
Add_Server_File | Procedure | Adds a table to this object's related-parent list | BaseData_Set
Add_User_Interface | Procedure | Adds the passed in hoDEO to the list of data entry objects (DEOs) for this object | BaseData_Set
Attach_Server | Procedure | (Obsolete) Use DDO_Server instead | BaseData_Set
Clear | Procedure | Clears all files owned by this object | BaseData_Set
Clear_All | Procedure | Clears all files owned by this object and all connected server DataDictionary objects (DDOs) | BaseData_Set
Constrain | Procedure | Defines constraint set for this object | BaseData_Set
Create | Function | Creates an object based on the passed Class Id | cObject
CurrentRowId | Function | Returns the RowId of the current record | BaseData_Set
Destroy | Procedure |  | cObject
Detach_Server | Procedure | Disconnects this object and the specified DataDictionary object (DDO), where this object was the client of that DDO server | BaseData_Set
Establish_Find_Direction | Procedure | Initializes the constrained find commands to perform searches using the given parameters | BaseData_Set
Exit_Application | Procedure | Starts the process of closing an application | cObject
Find_By_Recnum | Procedure | Finds record in specified table with record number equal to the passed in record number | BaseData_Set
FindByRowId | Procedure | Finds record in specified table with record identity equal to the passed RowId and updates the DDO structure | BaseData_Set
HasRecord | Function | Determines if the DataDictionary object (DDO) has a current record | BaseData_Set
Locate_Next | Procedure | Finds the next logical record using the passed in find mode, file, and index specified in a prior Establish_Find_Direction invocation | BaseData_Set
Operation_Not_Allowed | Procedure | Executes the error command with the passed in error number. Intended for augmentation | BaseData_Set
Read_By_Recnum | Procedure | Finds record in specified tabile with record number equal to the passed in record number | BaseData_Set
ReadByRowId | Procedure | Finds record in specified table with record identity equal to the passed RowId without updating or altering the DDO structure | BaseData_Set
Rebuild_Constraints | Procedure | Reconstructs constraints for a DDO | BaseData_Set
Refind_Records | Procedure | Checks to see if the record in the File-Buffer is the same as the record in the DDO-Field-Buffer and refinds the record if needed | BaseData_Set
Remove_Client_File | Procedure | Removes a table from this object's container-file list | BaseData_Set
Remove_Server_File | Procedure | Removes a table from this object's server-file list | BaseData_Set
Remove_User_Interface | Procedure | Removes a table from this object's data entry object (DEO)-list | BaseData_Set
Request_Assign | Procedure | Causes the Refresh message to be sent to all data entry objects for this object and its client and server DataDictionary objects as appropriate | BaseData_Set
Request_Clear_File | Procedure | Performs the Clear command on the specified table of the data-server structure | BaseData_Set
Request_Delete | Procedure | esponsible for deleting a record in the DDO for the main_file, updating all parent DDOs (and tables) and possibly deleting all child records | BaseData_Set
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Entry_Update | Procedure | Sends entry_update to all DEOs of the data set and DEOs of servers of the data set as required to store changes to record buffers | BaseData_Set
Request_Find | Procedure | Finds on specified table using given find mode and index | BaseData_Set
Request_Read | Procedure | Finds on specified table using given find mode and index | BaseData_Set
Request_Relate | Procedure | Performs a relate on the specified table without initializing the done-array | BaseData_Set
Request_Save | Procedure | Saves all changes in DEOs attached to this object or to any DDO that is a server of this object directly or indirectly | BaseData_Set
Request_Superfind | Procedure | Performs superfind on the designated table by the Main_Index of the designated field and notifies all connected DataDictionary objects (DDOs) of the result | BaseData_Set
Request_Validate | Function | Request_Validate sends validation messages to all DDO Field's that will participate in the upcoming save | BaseData_Set
Validate_Constraints | Function | Validates this object's constraints against the record buffer's current content | BaseData_Set


Properties for DataSet

View property list in hierarchical order

Name | Description | Defining Class
Auto_Fill_State | Determines whether a DataDictionary object (DDO) will attempt to find the first record in its defined set when it becomes in-use |
Can_Delete | Determines if a delete operation of the current record is permitted | BaseData_Set
Cascade_Delete_State | Determines how a delete should be affected by the existence of child-file records that relate to the record being deleted | BaseData_Set
Changed_State | Determines whether DEOs attached to this object have changed and/or whether a related parent record has changed | BaseData_Set
Child_Count | Returns the number of child objects the object contains | cObject
Client_File | Returns the number of the table at the passed-in position in this object's client table list | BaseData_Set
Client_File_Count | Returns the number of files in this object's client file list | BaseData_Set
Constrain_File | The number of the table that should constrain the main file of this object |
Current_Record | The number of the record most recently retrieved from the database | BaseData_Set
Data_Set_Client | Returns the object id of the DataDictionary object (DDO) at position iItem in this object's container DDO list | BaseData_Set
Data_Set_Client_Count | Returns the number of DataDictionary objects (DDOs) in this object's container DDO list | BaseData_Set
Data_Set_Server | Returns the object id of the DataDictionary object (DDO) at position iItem in this object's server DDO list | BaseData_Set
Data_Set_Server_Count | Returns the number of DataDictionary objects (DDOs) in this object's server DDO list | BaseData_Set
Data_Set_User_Interface | Returns the object id of the data entry object (DEO) at position iItem in this object's user-interface DEO list | BaseData_Set
Data_Set_User_Interface_Count | Returns the number of data entry objects (DEOs) in this object's user-interface DEO list | BaseData_Set
DDO_Server | The Object_ID of this object's server DataDictionary object (DDO) |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Entry_Permissive_State | (Obsolete) Determines whether changing of parent record relationships is permitted. | BaseData_Set
Field_Main_Index | (Obsolete) Returns the number of the index to use for finding on the specified table field. |
In_Use_State | Determines whether this object has at least one active user-interface object or one of this object's containers is in use | BaseData_Set
Main_File | Identifies the table managed by this Data Dictionary class/object | BaseData_Set
Name | Returns the full name of the object including parentage | cObject
No_Delete_State | Determines whether delete operations via this object are permitted | BaseData_Set
No_Relate_State | Determines whether relate operations will be executed after find operations by this object | BaseData_Set
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Ordering | Specifies the index which should be used for all find operations | BaseData_Set
Parent | Returns the parent of an object | cObject
pbAutoFillFromFirst | Allows child DDOs to auto-fill from the last record | BaseData_Set
pbInheritConstraints | Determines if a main DDO should inherit its constraints (finding filters) from its parent DDOs | BaseData_Set
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Read_Only_State | Determines whether save or delete operations will occur in this object's main table | BaseData_Set
Server_File | Returns the number of the table at the passed in position in this object's server-file list | BaseData_Set
Server_File_Count | Returns the number of table in this object's server-file list | BaseData_Set
Should_Save | Can be used to determine if a DDO has changed. | BaseData_Set
Should_Save_Row | Determines if a DDO is changed according to dbGrid "row" logic | BaseData_Set
Smart_Filemode_For_Lock | Determines the locked file mode setting for tables participating in save or delete operations | BaseData_Set
Smart_Filemode_For_No_Lock | Determines the unlocked file mode setting for tables that should not participate in save or delete operations | BaseData_Set
Smart_Filemode_State | Governs whether this object can use file-locking optimization for its tables | BaseData_Set
Which_Data_Set | Returns object id of object owning specified table | BaseData_Set


DataSet [Property Auto_Fill_State]

Auto_Fill_State - DataSet

Determines whether a DataDictionary object (DDO) will attempt to find the first record in its defined set when it becomes in-use

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_Fill_State property is True, this object will attempt to find the first record in its defined set when it becomes in-use (see In_Use_State). If any attached data entry object (DEO) has its Auto_Fill_State set to True, this object's Auto_Fill_State will also be True until all such DEOs have been detached from this object by use of the Remove_User_Interface message.

Last Edited: January 12, 2006


DataSet [Property Constrain_File]

Constrain_File - DataSet

The number of the table that should constrain the main file of this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Set Constrain_File To Customer.File_Number

A relates-to constraint is used when you want to only display records in a table that are children of the record in a related-to parent DDO. The classic example of a relates-to constraint is found in an Order Entry System where a grid of order-detail records is only displays records belonging to an order-header record.

Relates-to constraints are defined by setting the Constrain_File property in a child Data Dictionary object. This is usually done statically at the DD object level. The following example would constrain all Order records to a customer record

Object oCustomer_DD Is A Customer_DataDictionary
End_Object    // oCustomer_DD

Object oOrderHea_DD Is A OrderHea_DataDictionary
    Set DDO_Server To oCustomer_DD
    Set Constrain_File To Customer.File_Number
End_Object    // oOrder_DD

Data Dictionaries handle relates-to constraints in a very special way. The propagation rules for finds and clears are different when a relates-to constraint is in effect. This is discussed in detail in DDO Propagation and Relate-to Constraints.

A number of requirements must be met for a relates-to constraint to operate properly:

1. A relationship must be defined between the child and parent table. This relationship must be defined inside of Database Builder. This requires that the child table define the field or fields that relate to a corresponding set of fields in the parent.

2. The value of the related-to field (or fields) in the parent must be unique and supported by an index whose segment (or segments) are the same as the related to field.

3. The child table should contain one or more indexes that allow for fast finding by the relating fields. This means that the first segments in this child should consist of the relating-to fields.

4. The Child DDO must be properly connected to the Parent DDO, by setting the DDO_Server property in the child.

Rules 1 and 2 are the standard rules used to define any parent-child relationship and is required for the relate and attach processes to work properly. Rule 3 makes it possible for DDOs to quickly find related records. It allows the DDOs to jump into an index to find the first (or last) related record and to jump out of the index when the last (or first) related record is found. While you can find related child records using other non-optimized indexes the performance with large tables will almost always be unsatisfactory.

In our above example, this would require that:

  • Our Order Table contains a field (OrderHea.Customer_number) that matches a similar field in Customer (Customer.Customer_Number).
  • The relationship is defined for Order Table within Database Builder.
  • The Customer table contains an index based on Customer.Customer_number.
  • The Order table contains at least one index whose first segment is OrderHea.Customer_Number (OrderHea.Customer_Number x OrderHea.Order_Number).
  • The Order DDO, oOrderHea_DD must define oCustomer_DD as a parent DDO using the Set DDO_Server message.

Object oCustomer_DD Is A Customer_DataDictionary
End_Object    // oCustomer_DD

Object oOrderHea_DD Is A OrderHea_DataDictionary
    Set DDO_Server To oCustomer_DD
    Set Constrain_File To Customer.File_Number
End_Object    // oOrder_DD

Relates-to Constraints may be applied at multiple levels. In the following example, Orders are constrained to Customers and Order-Detail items are constrained to Orders.

Object oCustomer_DD Is A Customer_DataDictionary
End_Object    // oCustomer_DD

Object oOrderHea_DD Is A OrderHea_DataDictionary
    Set DDO_Server To oCustomer_DD
    Set Constrain_File To Customer.File_Number
End_Object    // oOrder_DD

Object oOrderDtl_DD Is A OrderDtl_DataDictionary
    Set DDO_Server To oOrderHea_DD
    Set Constrain_File To OrderHea.File_Number
End_Object    // oOrder_DD

These types of constraints are most often used in top down data-entry and reporting. For example, you would first find a customer, then find an order that is the child of the customer, and then find an order detail that is a child of the order-detail.

Data Dictionaries support an auto-fill capability that can be used in conjunction with relates to constraints. A find in a related-to parent Data Dictionary always notify the related child Data Dictionary of this change. Since the child DDO must contain a valid constrained record it will either clear itself or, if Auto_Fill_State is true, find the first valid record. This auto-fill behavior is used to display detail grids in a data entry application.

It is a good rule to use only as many relates-to-constraints required to do the job. This kind of constraint is not needed to make saves and deletes work properly - it is only used to find records.

See Also

Constraints and Filters

Last Edited: July 11, 2005


DataSet [Property DDO_Server]

DDO_Server - DataSet

The Object_ID of this object's server DataDictionary object (DDO)

Type: Property

Access: Write-Only

Data Type: Handle

Description

The DDO_Server property holds the Object_ID of this object's server DataDictionary object (DDO). This object may have several such servers, and this property is in fact an array, which may hold as many server Object_IDs as it is set to hold. Only one Object_ID may be given with each set statement.

Last Edited: July 11, 2005


DataSet [Property Field_Main_Index]

Field_Main_Index - DataSet

Returns the number of the index to use for finding on the specified table field.

Type: Property

Obsolete

Access: Read-Only

Data Type: Integer

Parameters: integer file integer field Integer iValue

Parameter | Description
file | Number of the table in the current filelist
field | Number of the field in the table
sValue | Default value field should have after a clear

Description

If this object has an Ordering and the specified file number is the Main_File, the Ordering will be returned, regardless of whether the specified field number has a main index (specified in the data file definition). If this object has no Ordering, the main index of the field will be returned. If the field has no main index and this object has no Ordering, -1 is returned.

Field_Main_Index is now Obsolete

Prior to VDF8.2, the message Field_Main_Index was used by the DataDictionary and Dataset class to determine the main index for a passed file and field. This method had the drawback that the DDO (or DSO) receiving this message may not be the DDO that owns the file. For example, an Order DD may receive this message asking for the main index for a customer field (where Customer is the parent of Order). When this happens the order DD determines the main-index for this customer without sending a message to the owner customer DD. While this method works properly, it causes confusion when you want go to augment this method. An augmentation in the parent DD (the owner of the field) will not get called. It had been suggested that this be improved. We have implemented this improvement by adding the new messages File_Field_Index and Field_Index.

When sending this message you can use either File_Field_Index or Field_Index. Using File_Field_Index is easier because you do not have to worry that the message is sent to the correct DDO - it will find the owner DDO and send the message Field_Index.

When augmenting this method, always augment Field_Index in the owner DD. You can now be sure that this method will get called.

The packages have all been changed so they no longer call Field_Main_Index. They now call File_Field_Index.

Important Compatibility Note:

If you are using Field_Main_Index anywhere in your code it will still work exactly as before. We strongly encourage you to bring your code up to date. You should search your code and make the following changes:

1. Search for all occurrences where you call Field_Main_Index and change the name of the call to File_Field_Index.

2. Search for any occurrences of augmentations of Field_Main_Index (look for function Field_Main_Index) and change it as follows:

// Old pre VDF 8.2 code
function Field_Main_Index integer file integer field returns integer
// should be changed to
function Field_Index integer field returns integer

Notice the name change and the parameter change. Also make sure that the function is located in the owner DDO.

We do not expect that many developers call Field_Main_Index and we expect that even fewer developers have augmented this message. If you have augmented the message you might have already encountered the limitation with Field_Main_Index and, we hope, you will welcome this improvement!

Finally - if you are using datasets instead of DDOs no change is required. They continue to use the Field_Main_Index method. (Of course, you want to use DDOs.)

Last Edited: July 11, 2005


Events for dbAppClient_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Exit_Application | Called when an application is about to be closed | AppDialog
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnPaint | Sent every time a panel is painted | MdiDialog
OnResize | Sent every time a panel is resized | MdiDialog
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d
Verify_Exit_Application | Sent by the client area to verify that an application may be exited | AppDialog


dbAppClient_ [Function Verify_Data_Loss]

Verify_Data_Loss - dbAppClient_

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


dbAppClient_ [Function Verify_Delete]

Verify_Delete - dbAppClient_

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


dbAppClient_ [Function verify_Exit]

verify_Exit - dbAppClient_

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


dbAppClient_ [Function Verify_Save]

Verify_Save - dbAppClient_

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for dbAppClient_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Activate_View | Procedure | Activates the view | AppDialog
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  | MdiDialog
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area | MdiDialog
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | MdiDialog
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index |
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO |
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | MdiDialog
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


dbAppClient_ [Procedure Exit_Function]

Exit_Function - dbAppClient_

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


dbAppClient_ [Procedure Request_Cancel]

Request_Cancel - dbAppClient_

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


dbAppClient_ [Procedure Request_Clear]

Request_Clear - dbAppClient_

Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause the user to lose changes made to the text, verify_data_loss is used to confirm the action. Clear is requested of the DSO. This may result in other DEOs clearing, in addition to the DEOs connected to that DSO. Sent (via delegation) by DEOs within the container.

Last Edited: September 11, 2003


dbAppClient_ [Procedure Request_Clear_All]

Request_Clear_All - dbAppClient_

Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear_all clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause a user to lose changes made to the text, verify_data_loss is used to confirm the action. Clear_all is requested of the DSO. This may result in other DEOs clearing, in addition to the DEOs connected to that DSO.

Last Edited: September 11, 2003


dbAppClient_ [Procedure Request_Delete]

Request_Delete - dbAppClient_

Deletes current record in main_file of the server DSO, if any, else issues an error

Type: Procedure

Parameters: No Parameters

Description

Request_delete deletes current record in main_file of the server DSO, if any, else issues an error. Sent by DEOs attached to the data set. Note that deletion of the current main_file record may cause sets of records in container DSOs to be deleted, i.e., those records that relate to the DSO's current record. Sends can_delete and acts only if that returns true.

Last Edited: September 11, 2003


dbAppClient_ [Procedure Request_Find]

Request_Find - dbAppClient_

Finds on specified file using given find_mode and index

Type: Procedure

Parameters: Integer mode Integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true, perform entry_update before find

Description

Request_find finds on specified file using given find_mode and index. If find is successful, performs a relate on file. If file is the same as the DSO's main_file, sends relate_main_file. Notifies other connected DSOs of the result of the find. Mode may be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either next_record, first_record, or last_record. Sets the found indicator to reflect the success or failure of the find operation. Sent by DEOs and item_find.

Last Edited: July 11, 2006


dbAppClient_ [Procedure Request_Save]

Request_Save - dbAppClient_

Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO

Type: Procedure

Parameters: No Parameters

Description

Request_Save saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO (directly or indirectly). Sent by DEOs attached to the DSO.

Last Edited: August 19, 2004


dbAppClient_ [Procedure Request_Save_No_Clear]

Request_Save_No_Clear - dbAppClient_

Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state

Type: Procedure

Parameters: No Parameters

Description

Request_save_no_clears saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state.

Last Edited: September 11, 2003


dbAppClient_ [Procedure Request_Superfind]

Request_Superfind - dbAppClient_

Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Request_superfind performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result. Find_mode may be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either next_record, first_record, or last_record. Sets the found indicator to reflect the success or failure of the find operation. Sends of request_superfind to a DSO require Predefined Indicator err to be set to false beforehand, in case an error other than Find past end of file or Find prior to beginning of file is generated by the superfind. Sent by DEOs.

Last Edited: September 11, 2003


Properties for dbAppClient_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | MdiDialog
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | MdiDialog
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | MdiDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object |
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event |
Verify_Save_Msg | Specifies the message to use for save confirmation |
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbAppClient_ [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - dbAppClient_

Determines if object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


dbAppClient_ [Property Auto_Fill_State]

Auto_Fill_State - dbAppClient_

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


dbAppClient_ [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - dbAppClient_

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


dbAppClient_ [Property Changed_State]

Changed_State - dbAppClient_

Determines if one or more of the child objects has changed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If this flag is true, one or more of the child objects has changed. Augmented to set changed_state of server to true when changed_state of this object is set to true. Also augmented to detach this object from its server when set to false while this object is inactive.

This object will not save when this state is false. When necessary (as when changes are made other than through the keyboard), set this state to true explicitly.

Default is false.

Last Edited: January 12, 2006


dbAppClient_ [Property Deferred_State]

Deferred_State - dbAppClient_

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


dbAppClient_ [Property deo_delegate_mode]

deo_delegate_mode - dbAppClient_

Controls those requests for which delegate_..._state is set true

Type: Property

Access: Read/Write

Data Type: Integer

Description

Deo_delegate_mode controls those requests for which delegate_..._state is set true. The default delegate_server mode delegates request messages for objects that are not explicitly using a DDO. Delegate_always delegates regardless of whether a server is declared for the object, and delegate_never never delegates. This behavior may be set globally rather than just for this object by setting a function named default_deo_delegate_mode, and may also be queried with get.

Default is delegate_server.

Last Edited: July 31, 2003


dbAppClient_ [Property Server]

Server - dbAppClient_

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


dbAppClient_ [Property Should_Save]

Should_Save - dbAppClient_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


dbAppClient_ [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - dbAppClient_

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


dbAppClient_ [Property Verify_Delete_Msg]

Verify_Delete_Msg - dbAppClient_

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


dbAppClient_ [Property verify_exit_msg]

verify_exit_msg - dbAppClient_

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


dbAppClient_ [Property Verify_Save_Msg]

Verify_Save_Msg - dbAppClient_

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


dbAppView_ [Event Closing_View]

Closing_View - dbAppView_

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


dbAppView_ [Event Opening_View]

Opening_View - dbAppView_

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


dbAppView_ [Event Prepare_Data_Sets]

Prepare_Data_Sets - dbAppView_

Provides the developer a chance to check the condition of any file buffers before they are cleared

Type: Event

Parameters: No Parameters

Description

Prepare_data_sets is a hook procedure with no definition. It is sent during view activation. This provides the developer a chance to check the condition of any file buffers before they are cleared. Usually record numbers are stored in properties and then used by seed_data_sets.

Last Edited: September 11, 2003


dbAppView_ [Event Seed_data_sets]

Seed_data_sets - dbAppView_

Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used

Type: Event

Parameters: No Parameters

Description

The Seed_data_sets message is set when main_DD has been set and view_latch_state is true. By default it initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began. This causes the view to appear to "latch" on to the last record used. This can be augmented to customize the contents of the DSO (and also their attached DEOs).

Last Edited: September 11, 2003


Events for dbAppView_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Closing_View |  |
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Exit_Application | Called when an application is about to be closed | AppDialog
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnPaint | Sent every time a panel is painted | MdiDialog
OnResize | Sent every time a panel is resized | MdiDialog
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Opening_View |  |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared |
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d
Verify_Exit_Application | Sent by the client area to verify that an application may be exited | AppDialog


dbAppView_ [Function Exit_Application_Check]

Exit_Application_Check - dbAppView_

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


Methods for dbAppView_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Activate_View | Procedure | Activates the view | AppDialog
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  | MdiDialog
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area | MdiDialog
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Application_Check | Function |  |
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbAppClient_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | MdiDialog
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbAppClient_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbAppClient_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbAppClient_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbAppClient_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbAppClient_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbAppClient_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbAppClient_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbAppClient_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | MdiDialog
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbAppClient_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbAppClient_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbAppClient_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbAppClient_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for dbAppView_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbAppClient_
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbAppClient_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Auto_Top_Item_State |  |
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbAppClient_
Auto_top_view_State |  |
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | dbAppClient_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | MdiDialog
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | MdiDialog
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbAppClient_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Attach_All_State |  |
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbAppClient_
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function |
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | MdiDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
priInitialRowId |  |
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbAppClient_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbAppClient_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbAppClient_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbAppClient_
verify_exit_msg | Determines what message is sent during an exiting event | dbAppClient_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbAppClient_
View_Latch_State | Determines if the view's DSO structure will be initialized with the data |
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbAppView_ [Property Auto_Dependent_item_State]

Auto_Dependent_item_State - dbAppView_

Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If you set the auto_dependent_item_state property true, all items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to.

Default is false.

Last Edited: January 12, 2006


dbAppView_ [Property Auto_Top_Item_State]

Auto_Top_Item_State - dbAppView_

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


dbAppView_ [Property Auto_top_view_State]

Auto_top_view_State - dbAppView_

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


dbAppView_ [Property DEO_Attach_All_State]

DEO_Attach_All_State - dbAppView_

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


dbAppView_ [Property DSO_Detach_Mode]

DSO_Detach_Mode - dbAppView_

Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view

Type: Property

Access: Read/Write

Data Type: Integer

Description

The DSO_Detach_Mode property specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view.

Detach_always (the default), causes all DSOs to become "not in-use". The DSO buffers are all cleared and, if changes exist in the view, they will be lost. The next time the view is activated the DSO structure will be reinitialized. This is the most windows-like setting. When views are closed, all changes are lost. If you wish to hide a changed view, you can minimize it.

Detach_never causes the DSOs to remain in-use. When reactivated, the view will contain and display all previous data (including any unsaved changes).

Detach_if_no_change allows the DSOs to become "not in-use" only if there are no unsaved changed.

Default is Detach_Always.

Last Edited: August 5, 2003


dbAppView_ [Property Main_DD]

Main_DD - dbAppView_

Identifies the dataDictionary object that controls the database file whose data is central to this object's function

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Main_DD property identifies the dataDictionary object that controls the database file whose data is central to this object's function. It must be one of the dataDictionarys contained within this object.

Last Edited: August 18, 2003


dbAppView_ [Property priInitialRowId]

priInitialRowId - dbAppView_

Type: Property

Access: Read/Write

Data Type: RowId

Description

Last Edited: November 11, 2004


dbAppView_ [Property View_Latch_State]

View_Latch_State - dbAppView_

Determines if the view's DSO structure will be initialized with the data

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When View_Latch_State is set true, the view's DSO structure will be initialized with the data that happens to be in the record buffer of the main_dd

When View_Latch_State is set false, the view's DSO structure will initialize with cleared data.

Default is true.

Last Edited: January 16, 2006


Events for dbBasicComboForm

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Sets the item_changed_state of this object's item true | ComboEntry
Combo_Fill_List | Called when the combo list is to be filled | ComboEntry
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message | ComboEntry
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbBasicComboForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | ComboEntry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | ComboEntry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Called when a drop-down list closes | ComboEntry
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Called when a drop-down list opens | ComboEntry
OnDropKey |  | ComboEntry
OnKillFocus | Sent whenever the object is about to lose the focus | ComboEntry
OnMaxText |  | ComboEntry
OnSetFocus | Sent whenever windows is about to give this object the focus | ComboEntry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | ComboEntry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | ComboEntry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


dbBasicComboForm [Function Prompt_Description]

Prompt_Description - dbBasicComboForm

Type: Function

Obsolete

Return Data Type: String

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


dbBasicComboForm [Function Validate_Prompt]

Validate_Prompt - dbBasicComboForm

Type: Function

Obsolete

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for dbBasicComboForm

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | ComboEntry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist | ComboEntry
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbBasicComboForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | ComboEntry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | ComboEntry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbBasicComboForm_
Close_Panel | Procedure | Closes the panel or component currently open |
Combo_Add_Item | Procedure | Adds an item to the combo list | ComboEntry
Combo_Delete_Data | Procedure | Deletes all this object's items | ComboEntry
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object | ComboEntry
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list | ComboEntry
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText | ComboEntry
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | ComboEntry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) |
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | ComboEntry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbBasicComboForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | ComboEntry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbBasicComboForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | ComboEntry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbBasicComboForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | ComboEntry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | ComboEntry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbBasicComboForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbBasicComboForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Help | Procedure |  | ComboEntry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | ComboEntry
Help_For_Help | Procedure | (Obsolete) | ComboEntry
Help_Index | Procedure | (Obsolete) | ComboEntry
Help_on_topic | Procedure | (Obsolete) | ComboEntry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | ComboEntry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbBasicComboForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | ComboEntry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | ComboEntry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | ComboEntry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbBasicComboForm_
Prompt_Description | Function | (Obsolete) |
Prompt_Description | Procedure | (Obsolete) |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbBasicComboForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbBasicComboForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbBasicComboForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbBasicComboForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbBasicComboForm_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | dbBasicComboForm_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbBasicComboForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | ComboEntry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbBasicComboForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | ComboEntry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Combo_Value | Function | Determines if a combo form's value is valid | ComboEntry
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbBasicComboForm_
Validate_Prompt | Function | (Obsolete) |
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbBasicComboForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbBasicComboForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbBasicComboForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbBasicComboForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbBasicComboForm_


dbBasicComboForm [Procedure Close_Panel]

Close_Panel - dbBasicComboForm

Closes the panel or component currently open

Type: Procedure

Parameters: No Parameters

Description

Closes the panel or component currently open. If the control Close_Panel is sent to is not a panel, the call will be delegated to it's parent.

For example, if a cDbRichEdit control is in a dbView, sending Close_Panel to the cDbRichEdit control will close the dbView.

Sample

This sample causes the dbView control oDbView1 to close when button oCloseButton is clicked.

Object oDbView1 is a dbView
    :
    Object oDbRichEdit1 is a cDbRichEdit
        :
    End_Object  // oDbRichEdit1
    :
    Object oCloseButton is a Button
        :
        Procedure OnClick
            send Close_Panel of oDbRichEdit1
        End_Procedure  // OnClick
        :
    End_Object  // oCloseButton
    :
End_Object  // oDbView1

Last Edited: November 24, 2004


dbBasicComboForm [Procedure Default_Prompt]

Default_Prompt - dbBasicComboForm

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbBasicComboForm [Procedure Prompt_Description]

Prompt_Description - dbBasicComboForm

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Properties for dbBasicComboForm

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Blank_State | Determines if a blank value is valid | ComboEntry
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbBasicComboForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbBasicComboForm_
Auto_Save_State | Determines if auto save should be performed | dbBasicComboForm_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbBasicComboForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | ComboEntry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbBasicComboForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Combo_Data_Object | Specifies the object ID of the internal l combo object | DfBaseComboBoxEntry
Combo_Item_Count | Returns the number of choices in the combo object's list | ComboEntry
Combo_Sort_State | Determines if the object will sort its visual list | ComboEntry
Combo_Value | Specifies the value of an item in the combo objects data-list | ComboEntry
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | dbBasicComboForm_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbBasicComboForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) |
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbBasicComboForm_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | ComboEntry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Message | Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value |
Error_Number | The number of the error to be reported whenever validate_combo_item returns a non-zero value |
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | ComboEntry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | ComboEntry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | ComboEntry
Help_Keyword | Used to specify an object's context keyword | ComboEntry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | ComboEntry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | ComboEntry
Label_Col_Offset | The horizontal distance from the object to its label | ComboEntry
Label_Justification_Mode | The justification mode for the text within this object's label | ComboEntry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | ComboEntry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | ComboEntry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
ListRowCount | Determines the number of rows in a combo form | ComboEntry
ListWidth | Detrmines the width of a combo's drop down list | ComboEntry
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | ComboEntry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | ComboEntry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbBasicComboForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbBasicComboForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbBasicComboForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | ComboEntry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | ComboEntry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbBasicComboForm_
Validate_Mode | Determines how and when object validation occurs | dbBasicComboForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbBasicComboForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbBasicComboForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbBasicComboForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbBasicComboForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbBasicComboForm [Property DEO_Control_Object]

DEO_Control_Object - dbBasicComboForm

Indicates whether the control is a Data Entry Object (DEO)

Type: Property

Access: Read-Only

Data Type: Integer

Description

Any Data Entry Object (DEO) has DEO_Control_Object set true, which means that it is a DEO control object, but not a container.

Any DEO control will also return true for DEO_Object because of delegation (DEO controls must always reside in DEO containers).

See Also

DEO_Object

Last Edited: May 4, 2005


dbBasicComboForm [Property Error_Message]

Error_Message - dbBasicComboForm

Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value

Type: Property

Access: Read/Write

Data Type: String

Description

Error_message is the text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value.

Default is "".

Last Edited: August 5, 2003


dbBasicComboForm [Property Error_Number]

Error_Number - dbBasicComboForm

The number of the error to be reported whenever validate_combo_item returns a non-zero value

Type: Property

Access: Read/Write

Data Type: Integer

Description

Error_number is the number of the error to be reported whenever validate_combo_item returns a non-zero value.

Default is 15.

Last Edited: August 5, 2003


dbBasicComboForm_ [Event Entry_Defaults]

Entry_Defaults - dbBasicComboForm_

"Hook" for providing default-setting routines

Type: Event

Parameters: No Parameters

Description

Entry_defaults is a "Hook" for providing default-setting routines. It is sent by clear. You should never send this message. Note that this is not used with data dictionaries.

Last Edited: August 5, 2003


Events for dbBasicComboForm_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Sets the item_changed_state of this object's item true | ComboEntry
Combo_Fill_List | Called when the combo list is to be filled | ComboEntry
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message | ComboEntry
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines |
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | ComboEntry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | ComboEntry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Called when a drop-down list closes | ComboEntry
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Called when a drop-down list opens | ComboEntry
OnDropKey |  | ComboEntry
OnKillFocus | Sent whenever the object is about to lose the focus | ComboEntry
OnMaxText |  | ComboEntry
OnSetFocus | Sent whenever windows is about to give this object the focus | ComboEntry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | ComboEntry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | ComboEntry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


dbBasicComboForm_ [Function exec_entry]

exec_entry - dbBasicComboForm_

Invokes the item_entry_msg of the specified item#, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: integer item#

Parameter | Description
item# | The item number

Return Value

The result of the item_entry_msg of the specified item#

Description

Exec_entry invokes the item_entry_msg of the specified item#, if any, and returns the result.

Last Edited: August 13, 2003


dbBasicComboForm_ [Function exec_exit]

exec_exit - dbBasicComboForm_

Invokes the item_exit_msg of the specified item#, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: integer item#

Parameter | Description
item# | The item number

Return Value

The result of the item_entry_msg of the specified item#

Description

Exec_exit invokes the item_exit_msg of the specified item#, if any, and returns the result.

Last Edited: August 13, 2003


dbBasicComboForm_ [Function exec_validate]

exec_validate - dbBasicComboForm_

Invokes the item_validate_msg of the specified item#, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: integer item#

Parameter | Description
item# | The item number

Return Value

The result of the item_entry_msg of the specified item#

Description

Exec_validate invokes the item_validate_msg of the specified item#, if any, and returns the result. Performs autofind on value and field of specified item#, if required, using entry_autofind.

Last Edited: August 13, 2003


dbBasicComboForm_ [Function Validate_Items]

Validate_Items - dbBasicComboForm_

Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails

Type: Function

Return Data Type: Integer

Parameters: Boolean bNotFindReq

Parameter | Description
bNotFindReq | If true the find required validation is not enforced

Return Value

Returns 0 if all items are valid, or else returns the first invalid item number.

Description

The superclass definition of the Validate_items message is augmented to manipulate the value of validate_items (a property inherited from the entry class) when validate_mode is validate_default, and to give this object the focus in the event validation of any item fails.

Last Edited: July 11, 2006


dbBasicComboForm_ [Function Verify_Data_Loss]

Verify_Data_Loss - dbBasicComboForm_

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


dbBasicComboForm_ [Function Verify_Delete]

Verify_Delete - dbBasicComboForm_

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


dbBasicComboForm_ [Function verify_Exit]

verify_Exit - dbBasicComboForm_

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


dbBasicComboForm_ [Function Verify_Save]

Verify_Save - dbBasicComboForm_

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for dbBasicComboForm_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | ComboEntry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist | ComboEntry
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | ComboEntry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | ComboEntry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox |
Combo_Add_Item | Procedure | Adds an item to the combo list | ComboEntry
Combo_Delete_Data | Procedure | Deletes all this object's items | ComboEntry
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object | ComboEntry
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list | ComboEntry
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText | ComboEntry
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | ComboEntry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | ComboEntry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | ComboEntry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful |
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | ComboEntry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result |
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result |
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | ComboEntry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | ComboEntry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find |
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find |
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find |
Help | Procedure |  | ComboEntry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | ComboEntry
Help_For_Help | Procedure | (Obsolete) | ComboEntry
Help_Index | Procedure | (Obsolete) | ComboEntry
Help_on_topic | Procedure | (Obsolete) | ComboEntry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | ComboEntry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation |
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | ComboEntry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | ComboEntry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | ComboEntry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true |
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true |
Request_Delete | Procedure | Deletes the current record of this object's server, if any |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any |
Request_Save | Procedure | Saves changes to the current record of this object's server, if any |
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | ComboEntry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind |
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind |
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind |
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | ComboEntry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Combo_Value | Function | Determines if a combo form's value is valid | ComboEntry
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails |
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message |


dbBasicComboForm_ [Procedure Set CheckBox_Item]

CheckBox_Item - dbBasicComboForm_

Set after each item of this object that you wish to be a checkbox

Type: Procedure Set

Data Type: String

Parameters: String ItemVal String TrueVal String FalseVal

Parameter | Description
ItemVal | The item that you wish displayed with the checkbox
TrueVal | The database field value for which the item's select_state is to be true
FalseVal | The field value for which the select_state is false

Description

The Checkbox_item message should be set after each item of this object that you wish to be a checkbox. All field values other than TrueVal will set the item's select_state false on entry_display. If FalseVal is omitted, 0 will be used. If TrueVal also is omitted, 1 will be used for that parameter by default.

Last Edited: June 23, 2005


dbBasicComboForm_ [Procedure Beginning_of_Data]

Beginning_of_Data - dbBasicComboForm_

Finds and displays the first record of the file specified by the data_file of the current_item of this object

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_data finds and displays the first record of the file specified by the data_file of the current_item of this object. Sent by kbegin_of_data.

Last Edited: August 13, 2003


dbBasicComboForm_ [Procedure End_of_Data]

End_of_Data - dbBasicComboForm_

Finds and displays the last record of the file specified by the data_file of the current_item of this object

Type: Procedure

Parameters: No Parameters

Description

End_of_data finds and displays the last record of the file specified by the data_file of the current_item of this object. Sent by kend_of_data.

Last Edited: August 5, 2003


dbBasicComboForm_ [Procedure Entry_Autofind]

Entry_Autofind - dbBasicComboForm_

Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful

Type: Procedure

Parameters: Integer eFindMode Integer iItem

Parameter | Description
eFindMode

Constant | Meaning
EQ | Find equal to
GE | Find greater than or equal to

iItem | The item number

Description

Entry_autofind finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful. Augmented to request find of server, if any, using item_find message.

Last Edited: July 11, 2006


dbBasicComboForm_ [Procedure Exit_Function]

Exit_Function - dbBasicComboForm_

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


dbBasicComboForm_ [Procedure Find_First]

Find_First - dbBasicComboForm_

Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_first finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of beginning_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbBasicComboForm_ [Procedure Find_GE]

Find_GE - dbBasicComboForm_

Performs a find greater than or equal by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_ge performs a find greater than or equal by the data_file and data_field of the current item, using request_find. Sent by kfind.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbBasicComboForm_ [Procedure Find_Last]

Find_Last - dbBasicComboForm_

Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_last finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of end_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbBasicComboForm_ [Procedure Find_Next]

Find_Next - dbBasicComboForm_

Performs a find greater than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_next performs a find greater than by the data_file and data_field of the current item, using request_find. Sent by kfind_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbBasicComboForm_ [Procedure Find_Previous]

Find_Previous - dbBasicComboForm_

Performs a find less than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_previous performs a find less than by the data_file and data_field of the current item, using request_find. Sent by kfind_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbBasicComboForm_ [Procedure Next]

Next - dbBasicComboForm_

Makes validation in validate_on_save_next mode occur regardless of the state of object_validation

Type: Procedure

Parameters: No Parameters

Description

The superclass definition of the Next message is augmented to make validation in validate_on_save_next mode occur regardless of the state of object_validation (a property inherited from the entry superclass).

Last Edited: September 10, 2003


dbBasicComboForm_ [Procedure Prompt]

Prompt - dbBasicComboForm_

Activates prompt_object of current item, if any, using popup message

Type: Procedure

Parameters: No Parameters

Description

Prompt activates prompt_object of current item, if any, using popup message. Sent by kprompt.

Last Edited: June 29, 2005


dbBasicComboForm_ [Procedure Request_Cancel]

Request_Cancel - dbBasicComboForm_

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


dbBasicComboForm_ [Procedure Request_Clear]

Request_Clear - dbBasicComboForm_

Clears items, and changes focus to first item in this object if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear clears items, and changes focus to first item in this object if auto_top_panel_state is true. If clearing may cause loss of user changes to the text, verify_data_loss is used to confirm the action. If this object has a server, clear is requested of the server. This may result in other DEOs clearing in addition to this object. Sent by kclear.

Last Edited: September 11, 2003


dbBasicComboForm_ [Procedure Request_Clear_All]

Request_Clear_All - dbBasicComboForm_

Clears items, and changes focus to first item in this object if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear_all clears items, and changes focus to first item in this object if auto_top_panel_state is true. If clearing may cause loss of user changes to the text, verify_data_loss is used to confirm the action. If this object has a server, clear_all is requested of the server. This may result in other DEOs clearing in addition to this object. Sent by kclear_all.

Last Edited: September 11, 2003


dbBasicComboForm_ [Procedure Request_Delete]

Request_Delete - dbBasicComboForm_

Deletes the current record of this object's server, if any

Type: Procedure

Parameters: No Parameters

Description

Request_delete deletes the current record of this object's server, if any. If successful and auto_clear_deo_state is true, also clears the items using request_clear. Verify_delete is used to confirm the action. Sent by kdelete_record. Sends can_delete and acts only if that returns true.

Last Edited: September 11, 2003


dbBasicComboForm_ [Procedure Request_Find]

Request_Find - dbBasicComboForm_

Finds record using specified mode by requesting item_find from server, if any

Type: Procedure

Parameters: integer mode integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true perform entry update before Find.

Description

Request_find finds record using specified mode by requesting item_find from server, if any. Uses data_file and data_field to determine file and field for find. If this object has no server, no action is taken.

Last Edited: September 11, 2003


dbBasicComboForm_ [Procedure Request_Save]

Request_Save - dbBasicComboForm_

Saves changes to the current record of this object's server, if any

Type: Procedure

Parameters: No Parameters

Description

Request_Save saves changes to the current record of this object's server, if any. If successful and auto_clear_deo_state is true, clears items using request_clear. Verify_save is used to confirm the action. Sent by ksave_record.

Last Edited: August 19, 2004


dbBasicComboForm_ [Procedure Request_Save_No_Clear]

Request_Save_No_Clear - dbBasicComboForm_

Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state

Type: Procedure

Parameters: No Parameters

Description

Request_save_no_clear saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state.

Last Edited: September 11, 2003


dbBasicComboForm_ [Procedure Request_Superfind]

Request_Superfind - dbBasicComboForm_

Superfinds record using specified mode by requesting item_superfind from server, if any

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Request_superfind superfinds record using specified mode by requesting item_superfind from server, if any. Uses data_file and data_field to determine file and field for find. If this object has no server, no action is taken. Sends of request_superfind to a DSO require Predefined Indicator err to be set to false beforehand, in case an error other than Find past end of file or Find prior to beginning of file is generated by the superfind. Sent by DEOs.

Last Edited: September 11, 2003


dbBasicComboForm_ [Procedure SuperFind]

SuperFind - dbBasicComboForm_

Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbBasicComboForm_ [Procedure SuperFind_Next]

SuperFind_Next - dbBasicComboForm_

Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_next performs a superfind greater than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbBasicComboForm_ [Procedure SuperFind_Previous]

SuperFind_Previous - dbBasicComboForm_

Performs a superfind less than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_previous performs a superfind less than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbBasicComboForm_ [Procedure Zoom]

Zoom - dbBasicComboForm_

Activates zoom object of current item, if any, using popup message

Type: Procedure

Parameters: No Parameters

Description

Zoom activates zoom object of current item, if any, using popup message. Sent by kzoom.

Last Edited: September 15, 2003


Properties for dbBasicComboForm_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Blank_State | Determines if a blank value is valid | ComboEntry
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Save_State | Determines if auto save should be performed |
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | ComboEntry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object |
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Combo_Data_Object | Specifies the object ID of the internal l combo object | DfBaseComboBoxEntry
Combo_Item_Count | Returns the number of choices in the combo object's list | ComboEntry
Combo_Sort_State | Determines if the object will sort its visual list | ComboEntry
Combo_Value | Specifies the value of an item in the combo objects data-list | ComboEntry
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true |
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | ComboEntry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | ComboEntry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | ComboEntry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | ComboEntry
Help_Keyword | Used to specify an object's context keyword | ComboEntry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | ComboEntry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | ComboEntry
Label_Col_Offset | The horizontal distance from the object to its label | ComboEntry
Label_Justification_Mode | The justification mode for the text within this object's label | ComboEntry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | ComboEntry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | ComboEntry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
ListRowCount | Determines the number of rows in a combo form | ComboEntry
ListWidth | Detrmines the width of a combo's drop down list | ComboEntry
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | ComboEntry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | ComboEntry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object |
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | ComboEntry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | ComboEntry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated |
Validate_Mode | Determines how and when object validation occurs |
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event |
Verify_Save_Msg | Specifies the message to use for save confirmation |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbBasicComboForm_ [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - dbBasicComboForm_

If true, this object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


dbBasicComboForm_ [Property Auto_Fill_State]

Auto_Fill_State - dbBasicComboForm_

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


dbBasicComboForm_ [Property Auto_Save_State]

Auto_Save_State - dbBasicComboForm_

Determines if auto save should be performed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_save_state property is true, rotation from the last object within this object to the first object within this object will cause this object to save. Intended to be set.

Default is false.

Last Edited: January 12, 2006


dbBasicComboForm_ [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - dbBasicComboForm_

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


dbBasicComboForm_ [Property Changed_Value]

Changed_Value - dbBasicComboForm_

Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object

Type: Property

Access: Write-Only

Data Type: String

Parameters: integer Item# String Val

Parameter | Description
Item# | The item number
Val | The value of the item

Description

The Changed_value message merely changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object.

Last Edited: July 22, 2003


dbBasicComboForm_ [Property Default_Value]

Default_Value - dbBasicComboForm_

Changes the value property of Item item# to value, but leaves its item_changed_state unchanged

Type: Property

Access: Write-Only

Data Type: String

Parameters: integer Item# String Val

Parameter | Description
Item# | The item number
Val | The value of the item

Description

The Default_value message changes the value property of Item item# to value, but leaves its item_changed_state unchanged. This is the message for setting default values.

Last Edited: July 31, 2003


dbBasicComboForm_ [Property Deferred_State]

Deferred_State - dbBasicComboForm_

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


dbBasicComboForm_ [Property deo_delegate_mode]

deo_delegate_mode - dbBasicComboForm_

Controls those requests for which delegate_..._state is set true

Type: Property

Access: Read/Write

Data Type: Integer

Description

Deo_delegate_mode controls those requests for which delegate_..._state is set true. The default delegate_server mode delegates request messages for objects that are not explicitly using a DDO. Delegate_always delegates regardless of whether a server is declared for the object, and delegate_never never delegates. This behavior may be set globally rather than just for this object by setting a function named default_deo_delegate_mode, and may also be queried with get.

Default is delegate_server.

Last Edited: July 31, 2003


dbBasicComboForm_ [Property Retain_no_Change_state]

Retain_no_Change_state - dbBasicComboForm_

Determines if the item_changed_state of items have true or false values

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The default for the Retain_no_change_state property true keeps the item_changed_state of items receiving default values false until and unless they are explicitly changed. If your program needs the item_changed_state of such items to be true, you can provide such behavior by setting this property false.

Default is true.

Last Edited: January 12, 2006


dbBasicComboForm_ [Property Server]

Server - dbBasicComboForm_

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


dbBasicComboForm_ [Property Should_Save]

Should_Save - dbBasicComboForm_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


dbBasicComboForm_ [Property Validate_All_Items_State]

Validate_All_Items_State - dbBasicComboForm_

Determines if all items are being validated

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Validate_all_items_state property is set true when all items are validated in one process, as in a save. It is reset false when one or some other subset of all the items are validated, as in navigation between items.

Default is false.

Last Edited: January 12, 2006


dbBasicComboForm_ [Property Validate_Mode]

Validate_Mode - dbBasicComboForm_

Determines how and when object validation occurs

Type: Property

Access: Read/Write

Data Type: Integer

Description

The validate_mode property determines how and when object validation occurs.

Default is VALIDATE_ON_SAVE_NEXT.

Valid modes are:

Mode | Description
VALIDATE_DEFAULT | Obsolete (character-mode only)
VALIDATE_ON_SAVE | Validates are only sent during a save
VALIDATE_ON_SAVE_NEXT | Validates are sent during a save and forward keyboard navigation

Last Edited: August 12, 2005


dbBasicComboForm_ [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - dbBasicComboForm_

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


dbBasicComboForm_ [Property Verify_Delete_Msg]

Verify_Delete_Msg - dbBasicComboForm_

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


dbBasicComboForm_ [Property verify_exit_msg]

verify_exit_msg - dbBasicComboForm_

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


dbBasicComboForm_ [Property Verify_Save_Msg]

Verify_Save_Msg - dbBasicComboForm_

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


Events for dbBitmap

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d


dbBitmap [Function verify_Exit]

verify_Exit - dbBitmap

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


Methods for dbBitmap

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Invoke_Select_Bitmap | Procedure | Public message causing bitmap selection dialog to appear and if selected displays the bitmap | BitmapContainer
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


dbBitmap [Procedure Exit_Function]

Exit_Function - dbBitmap

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


dbBitmap [Procedure Request_Cancel]

Request_Cancel - dbBitmap

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


Properties for dbBitmap

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Select_Bitmap_State | Determines if users will be able to browse a list of the bitmap files in a directory and select one for display | BitmapContainer
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | BitmapContainer
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared |
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dialog_Caption | Specifies the legend (Select a bitmap file by default) to be displayed at the top of the common open-file dialog that users will interact with | BitmapContainer
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Initial_Folder | Specifies the path of the directory in which bitmap filenames will be searched for and displayed by the common file-open dialog | BitmapContainer
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
NoPut_State | Specifies whether this object should store the filename of its current bitmap back to the database during a save |
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object |
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Store_With_Pathname_State | Specifies whether the object should save back to the database the full pathname of the bitmap being displayed |
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
verify_exit_msg | Determines what message is sent during an exiting event |
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbBitmap [Property Auto_Fill_State]

Auto_Fill_State - dbBitmap

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


dbBitmap [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - dbBitmap

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


dbBitmap [Property Data_Field]

Data_Field - dbBitmap

Identifies the database field from which data is to be stored, retrieved, and cleared

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer item# integer Field#

Parameter | Description
item# | The item number
Field# | The field number

Description

Each entry_item may have a field in a database file associated with it. The data_field identifies the database field from which data is to be stored, retrieved, and cleared. Data_fields are most often set by the entry_item command.

entry_item customer.name

They may also be set using the data_field message. This may be done if an entry item needs to be set to another field number than the initialized one. Data_field numbers begin with 0 for recnum and count up to the number of fields in the file with which the item is associated. Values outside this range are errors.

set data_field item 0 to 4

get data_field item 0 to var

If the entry_item is not associated with a data field (it is associated with an expression or variable), the value of this property is 0.

Last Edited: August 5, 2003


dbBitmap [Property Data_File]

Data_File - dbBitmap

Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer item# integer File#

Parameter | Description
item# | The item number
File# | The file number

Description

Each entry_item may have a field in a database file associated with it. The Data_file property identifies the database file that contains the field from which data is to be stored, retrieved, and cleared. Data_files are most often set by the composition of the entry_item statement itself.

entry_item customer.name

They may also be set using the data_file message. This may be done if an entry item needs to be set to another file than the initialized one.

set data_file item 0 to customer.File_Number

get data_file item 0 to filenumber

If the entry_item is not associated with a data field (it is associated with an expression or variable) the value of this property is 0.

Last Edited: August 5, 2003


dbBitmap [Property Deferred_State]

Deferred_State - dbBitmap

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


dbBitmap [Property NoPut_State]

NoPut_State - dbBitmap

Specifies whether this object should store the filename of its current bitmap back to the database during a save

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Noput_state specifies whether this object should store the filename of its current bitmap back to the database during a save.

Default is false.

Last Edited: January 12, 2006


dbBitmap [Property Server]

Server - dbBitmap

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


dbBitmap [Property Should_Save]

Should_Save - dbBitmap

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


dbBitmap [Property Store_With_Pathname_State]

Store_With_Pathname_State - dbBitmap

Specifies whether the object should save back to the database the full pathname of the bitmap being displayed

Type: Property

Access: Read/Write

Data Type: Integer

Description

Store_With_Pathname_State specifies whether the object should save back to the database (save operation) the full pathname of the bitmap being displayed. This is usually used only when the bitmap is set during runtime by double-clicking on this object to invoke the common file dialog to select a bitmap file.

Default is false.

Last Edited: September 11, 2003


dbBitmap [Property verify_exit_msg]

verify_exit_msg - dbBitmap

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


Events for dbCheckbox

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message | Entry
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Entry
OnChange |  | dbCheckBoxDS
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Entry
OnMaxText |  | Entry
OnSetFocus | Sent whenever windows is about to give this object the focus | Entry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Entry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | Entry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbCheckbox

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Entry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Entry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Entry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbForm_
Close_Panel | Procedure | Closes the panel or component currently open | dbFormDS
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | Entry
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | Entry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | dbFormDS
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Entry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Entry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | Entry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Entry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Entry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbForm_
Help | Procedure |  | Entry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | Entry
Help_For_Help | Procedure | (Obsolete) | Entry
Help_Index | Procedure | (Obsolete) | Entry
Help_on_topic | Procedure | (Obsolete) | Entry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Entry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Entry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | Entry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Entry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbForm_
Prompt_Description | Function | (Obsolete) | dbFormDS
Prompt_Description | Procedure | (Obsolete) | dbFormDS
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbForm_
Request_Save | Procedure |  | dbFormDS
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Entry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Entry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbForm_
Validate_Prompt | Function | (Obsolete) | dbFormDS
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbForm_


Properties for dbCheckbox

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
AlignmentMode | Determines if the Label property will be displayed on the left or right of the checkbox icon | dbCheckBoxDS
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbForm_
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object |
Auto_Save_State | Determines if auto save should be performed | dbForm_
Auto_Size_State | Determines if object will be resized to the length of the label text | dbCheckBoxDS
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | Entry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Checked_State | Reflects whether this object is checked | dbCheckBoxDS
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | dbForm_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | dbFormDS
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbForm_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Entry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Entry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | Entry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Entry
Help_Keyword | Used to specify an object's context keyword | Entry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | Entry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label |  | dbCheckBoxDS
Label_Col_Offset | The horizontal distance from the object to its label | Entry
Label_Justification_Mode | The justification mode for the text within this object's label | Entry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Entry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Entry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Entry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form | Entry
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object | Entry
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Entry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Entry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Entry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbForm_
Validate_Mode | Determines how and when object validation occurs | dbForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbCheckbox [Property Auto_Label_State]

Auto_Label_State - dbCheckbox

Determines if this object will draw label values from the DDO rather than from any label that may be set in this object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_label_state property is set true, this object will draw label values from the DDO rather than from any label that may be set in this object.

When used within single-item objects (forms and edits), the object uses the field's long label name.

When used within multi-item objects (grids), the object uses the field's short label name.

Default is false.

Last Edited: January 12, 2006


dbCheckBoxDS [Event OnChange]

OnChange - dbCheckBoxDS

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Events for dbCheckBoxDS

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message | Entry
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Entry
OnChange |  |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Entry
OnMaxText |  | Entry
OnSetFocus | Sent whenever windows is about to give this object the focus | Entry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Entry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | Entry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbCheckBoxDS

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Entry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Entry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Entry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbForm_
Close_Panel | Procedure | Closes the panel or component currently open | dbFormDS
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | Entry
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | Entry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | dbFormDS
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Entry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Entry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | Entry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Entry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Entry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbForm_
Help | Procedure |  | Entry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | Entry
Help_For_Help | Procedure | (Obsolete) | Entry
Help_Index | Procedure | (Obsolete) | Entry
Help_on_topic | Procedure | (Obsolete) | Entry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Entry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Entry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | Entry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Entry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbForm_
Prompt_Description | Function | (Obsolete) | dbFormDS
Prompt_Description | Procedure | (Obsolete) | dbFormDS
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbForm_
Request_Save | Procedure |  | dbFormDS
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Entry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Entry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbForm_
Validate_Prompt | Function | (Obsolete) | dbFormDS
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbForm_


Properties for dbCheckBoxDS

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
AlignmentMode | Determines if the Label property will be displayed on the left or right of the checkbox icon |
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbForm_
Auto_Save_State | Determines if auto save should be performed | dbForm_
Auto_Size_State | Determines if object will be resized to the length of the label text |
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | Entry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Checked_State | Reflects whether this object is checked |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | dbForm_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | dbFormDS
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbForm_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Entry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Entry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | Entry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Entry
Help_Keyword | Used to specify an object's context keyword | Entry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | Entry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label |  |
Label_Col_Offset | The horizontal distance from the object to its label | Entry
Label_Justification_Mode | The justification mode for the text within this object's label | Entry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Entry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Entry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Entry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form | Entry
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object | Entry
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Entry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Entry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Entry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbForm_
Validate_Mode | Determines how and when object validation occurs | dbForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbCheckBoxDS [Property AlignmentMode]

AlignmentMode - dbCheckBoxDS

Determines if the Label property will be displayed on the left or right of the checkbox icon

Type: Property

Access: Read/Write

Data Type: Integer

Description

AlignmentMode determines if the text of the Label property will be displayed on the left or right of the checkbox icon.

Constant | Meaning
taRightJustify | Displays the text to the right of the checkbox
taLeftJustify | Displays the text to the left of the checkbox

Default is taRightJustify.

Last Edited: August 5, 2003


dbCheckBoxDS [Property Auto_Size_State]

Auto_Size_State - dbCheckBoxDS

Determines if object will be resized to the length of the label text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If this property is set true, this object will size itself according to the length of the label text.

When set false, it will not.

See Also

CheckBox | Radio

Last Edited: January 12, 2006


dbCheckBoxDS [Property Checked_State]

Checked_State - dbCheckBoxDS

Reflects whether this object is checked

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Checked_State property reflects whether this object is checked. You may set and get this property.

See Also

CheckBox | Radio

Last Edited: January 12, 2006


dbCheckBoxDS [Property Label]

Label - dbCheckBoxDS

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


Events for dbCodeComboForm

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Description_Value | A "hook" message that by default merely returns prompt | dbDataComboForm
Combo_Edit_Changed | Sets the item_changed_state of this object's item true | ComboEntry
Combo_Fill_List | Sent by the construct_object procedure, and must be defined in this object if the object does not draw its data from a database file via combo_data_file, code_field, description_field, etc | dbComboFormDS
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message | ComboEntry
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbBasicComboForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | ComboEntry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | ComboEntry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Called when a drop-down list closes | ComboEntry
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Called when a drop-down list opens | ComboEntry
OnDropKey |  | ComboEntry
OnKillFocus | Sent whenever the object is about to lose the focus | ComboEntry
OnMaxText |  | ComboEntry
OnSetFocus | Sent whenever windows is about to give this object the focus | ComboEntry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | ComboEntry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | ComboEntry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbCodeComboForm

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | ComboEntry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist | ComboEntry
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbBasicComboForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | ComboEntry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | ComboEntry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbBasicComboForm_
Close_Panel | Procedure | Closes the panel or component currently open | dbBasicComboForm
Combo_Add_Item | Procedure | Augmented to support two parameters: a display value and a database value | dbDataComboForm
Combo_Delete_Data | Procedure | Deletes all this object's items | ComboEntry
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object | ComboEntry
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list | ComboEntry
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText | ComboEntry
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | ComboEntry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Code | Procedure | Sets current_item to the item having prompt equal to the value of the default_value property | dbDataComboForm
Default_Prompt | Procedure | Sets the default item upon the cursor's first entering this object by sending default_code with parameter of default_value | dbDataComboForm
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | ComboEntry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbBasicComboForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | ComboEntry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbBasicComboForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | ComboEntry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbBasicComboForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | ComboEntry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | ComboEntry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbBasicComboForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbBasicComboForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Help | Procedure |  | ComboEntry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | ComboEntry
Help_For_Help | Procedure | (Obsolete) | ComboEntry
Help_Index | Procedure | (Obsolete) | ComboEntry
Help_on_topic | Procedure | (Obsolete) | ComboEntry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | ComboEntry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbBasicComboForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | ComboEntry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | ComboEntry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | ComboEntry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbBasicComboForm_
Prompt_Description | Function | (Obsolete) | dbBasicComboForm
Prompt_Description | Procedure | (Obsolete) | dbBasicComboForm
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbBasicComboForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbBasicComboForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbBasicComboForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbBasicComboForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbBasicComboForm_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | dbBasicComboForm_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbBasicComboForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | ComboEntry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbBasicComboForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | ComboEntry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Combo_Value | Function | Determines if a combo form's value is valid | ComboEntry
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbBasicComboForm_
Validate_Prompt | Function | (Obsolete) | dbBasicComboForm
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbBasicComboForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbBasicComboForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbBasicComboForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbBasicComboForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbBasicComboForm_


Properties for dbCodeComboForm

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Blank_State | Determines if a blank value is valid | ComboEntry
Allow_Undefined_State | Determines if an undefined value is added to the combo list | dbComboFormDS
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbBasicComboForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbBasicComboForm_
Auto_Save_State | Determines if auto save should be performed | dbBasicComboForm_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbBasicComboForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | ComboEntry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbBasicComboForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Code_Display_Mode | Specifies whether the list will display the choices' codes, descriptions, or both | dbDataComboForm
Code_Field | The number of the field in the combo_data_file from which values are to be drawn for insertion into the main database file through the Code_field object | dbComboFormDS
Code_File |  | dbComboFormDS
Code_Index |  | dbComboFormDS
Color | Sets the background color of the object | DfBaseWindow
Combo_Data_File | The file number containing the code_field | dbComboFormDS
Combo_Data_Object | Specifies the object ID of the internal l combo object | DfBaseComboBoxEntry
Combo_Index | The Index used by the combo form | dbComboFormDS
Combo_Item_Count | Returns the number of choices in the combo object's list | ComboEntry
Combo_Sort_State | Determines if the object will sort its visual list | ComboEntry
Combo_Value | Specifies the value of an item in the combo objects data-list | ComboEntry
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Used by default_prompt procedure to set the default item upon the cursor's first entering this object | dbDataComboForm
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbBasicComboForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | dbBasicComboForm
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbBasicComboForm_
Description_Field | The description field number in the combo_data_file | dbComboFormDS
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | ComboEntry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Message | Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value | dbBasicComboForm
Error_Number | The number of the error to be reported whenever validate_combo_item returns a non-zero value | dbBasicComboForm
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | ComboEntry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | ComboEntry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | ComboEntry
Help_Keyword | Used to specify an object's context keyword | ComboEntry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | ComboEntry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | ComboEntry
Label_Col_Offset | The horizontal distance from the object to its label | ComboEntry
Label_Justification_Mode | The justification mode for the text within this object's label | ComboEntry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | ComboEntry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | ComboEntry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
ListRowCount | Determines the number of rows in a combo form | ComboEntry
ListWidth | Detrmines the width of a combo's drop down list | ComboEntry
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | ComboEntry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | ComboEntry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbBasicComboForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbBasicComboForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbBasicComboForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | ComboEntry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Type_Field |  | dbComboFormDS
Type_Value | Determines the type value of the validation list | dbComboFormDS
Typeface | The typeface of the selected font | DfBaseWindow
Undefined_Display_Mode | Used by find_item to decide what to display when this object is filled from the database with a value that is not found among the values of this object's combo items | dbDataComboForm
Undefined_Save_Mode | Used by entry_update to decide what to save when a save is requested with a value in the window that is not among the prompts of this object | dbDataComboForm
Undefined_Value | Used for display by find_item and for insertion into the database by entry_update when this item's undefined_display_mode or undefined_save_mode respectively is cb_err_update_blank_value | dbDataComboForm
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | ComboEntry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbBasicComboForm_
Validate_Mode | Determines how and when object validation occurs | dbBasicComboForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbBasicComboForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbBasicComboForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbBasicComboForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbBasicComboForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


Events for dbComboForm

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Description_Value | A "hook" message that by default merely returns prompt | dbDataComboForm
Combo_Edit_Changed | Sets the item_changed_state of this object's item true | ComboEntry
Combo_Fill_List | Sent by the construct_object procedure, and must be defined in this object if the object does not draw its data from a database file via combo_data_file, code_field, description_field, etc | dbComboFormDS
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message | ComboEntry
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbBasicComboForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | ComboEntry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | ComboEntry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Called when a drop-down list closes | ComboEntry
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Called when a drop-down list opens | ComboEntry
OnDropKey |  | ComboEntry
OnKillFocus | Sent whenever the object is about to lose the focus | ComboEntry
OnMaxText |  | ComboEntry
OnSetFocus | Sent whenever windows is about to give this object the focus | ComboEntry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | ComboEntry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | ComboEntry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbComboForm

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | ComboEntry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist | ComboEntry
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbBasicComboForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | ComboEntry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | ComboEntry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbBasicComboForm_
Close_Panel | Procedure | Closes the panel or component currently open | dbBasicComboForm
Combo_Add_Item | Procedure | Augmented to support two parameters: a display value and a database value | dbDataComboForm
Combo_Delete_Data | Procedure | Deletes all this object's items | ComboEntry
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object | ComboEntry
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list | ComboEntry
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText | ComboEntry
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | ComboEntry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Code | Procedure | Sets current_item to the item having prompt equal to the value of the default_value property | dbDataComboForm
Default_Prompt | Procedure | Sets the default item upon the cursor's first entering this object by sending default_code with parameter of default_value | dbDataComboForm
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | ComboEntry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbBasicComboForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | ComboEntry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbBasicComboForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | ComboEntry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbBasicComboForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | ComboEntry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | ComboEntry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbBasicComboForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbBasicComboForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Help | Procedure |  | ComboEntry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | ComboEntry
Help_For_Help | Procedure | (Obsolete) | ComboEntry
Help_Index | Procedure | (Obsolete) | ComboEntry
Help_on_topic | Procedure | (Obsolete) | ComboEntry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | ComboEntry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbBasicComboForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | ComboEntry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | ComboEntry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | ComboEntry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbBasicComboForm_
Prompt_Description | Function | (Obsolete) | dbBasicComboForm
Prompt_Description | Procedure | (Obsolete) | dbBasicComboForm
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbBasicComboForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbBasicComboForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbBasicComboForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbBasicComboForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbBasicComboForm_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | dbBasicComboForm_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbBasicComboForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | ComboEntry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbBasicComboForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | ComboEntry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Combo_Value | Function | Determines if a combo form's value is valid | ComboEntry
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbBasicComboForm_
Validate_Prompt | Function | (Obsolete) | dbBasicComboForm
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbBasicComboForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbBasicComboForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbBasicComboForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbBasicComboForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbBasicComboForm_


Properties for dbComboForm

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Blank_State | Determines if a blank value is valid | ComboEntry
Allow_Undefined_State | Determines if an undefined value is added to the combo list | dbComboFormDS
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbBasicComboForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbBasicComboForm_
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object | dbComboFormDD_
Auto_Save_State | Determines if auto save should be performed | dbBasicComboForm_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbBasicComboForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | ComboEntry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbBasicComboForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Code_Display_Mode | Specifies whether the list will display the choices' codes, descriptions, or both | dbDataComboForm
Code_Field | The number of the field in the combo_data_file from which values are to be drawn for insertion into the main database file through the Code_field object | dbComboFormDS
Code_File |  | dbComboFormDS
Code_Index |  | dbComboFormDS
Color | Sets the background color of the object | DfBaseWindow
Combo_Data_File | The file number containing the code_field | dbComboFormDS
Combo_Data_Object | Specifies the object ID of the internal l combo object | DfBaseComboBoxEntry
Combo_Index | The Index used by the combo form | dbComboFormDS
Combo_Item_Count | Returns the number of choices in the combo object's list | ComboEntry
Combo_Sort_State | Determines if the object will sort its visual list | ComboEntry
Combo_Value | Specifies the value of an item in the combo objects data-list | ComboEntry
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Used by default_prompt procedure to set the default item upon the cursor's first entering this object | dbDataComboForm
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbBasicComboForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | dbBasicComboForm
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbBasicComboForm_
Description_Field | The description field number in the combo_data_file | dbComboFormDS
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | ComboEntry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Message | Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value | dbBasicComboForm
Error_Number | The number of the error to be reported whenever validate_combo_item returns a non-zero value | dbBasicComboForm
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | ComboEntry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | ComboEntry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | ComboEntry
Help_Keyword | Used to specify an object's context keyword | ComboEntry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | ComboEntry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | ComboEntry
Label_Col_Offset | The horizontal distance from the object to its label | ComboEntry
Label_Justification_Mode | The justification mode for the text within this object's label | ComboEntry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | ComboEntry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | ComboEntry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
ListRowCount | Determines the number of rows in a combo form | ComboEntry
ListWidth | Detrmines the width of a combo's drop down list | ComboEntry
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | ComboEntry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | ComboEntry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbBasicComboForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbBasicComboForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbBasicComboForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | ComboEntry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Type_Field |  | dbComboFormDS
Type_Value | Determines the type value of the validation list | dbComboFormDS
Typeface | The typeface of the selected font | DfBaseWindow
Undefined_Display_Mode | Used by find_item to decide what to display when this object is filled from the database with a value that is not found among the values of this object's combo items | dbDataComboForm
Undefined_Save_Mode | Used by entry_update to decide what to save when a save is requested with a value in the window that is not among the prompts of this object | dbDataComboForm
Undefined_Value | Used for display by find_item and for insertion into the database by entry_update when this item's undefined_display_mode or undefined_save_mode respectively is cb_err_update_blank_value | dbDataComboForm
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | ComboEntry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbBasicComboForm_
Validate_Mode | Determines how and when object validation occurs | dbBasicComboForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbBasicComboForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbBasicComboForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbBasicComboForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbBasicComboForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


Events for dbComboFormDD_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Description_Value | A "hook" message that by default merely returns prompt | dbDataComboForm
Combo_Edit_Changed | Sets the item_changed_state of this object's item true | ComboEntry
Combo_Fill_List | Sent by the construct_object procedure, and must be defined in this object if the object does not draw its data from a database file via combo_data_file, code_field, description_field, etc | dbComboFormDS
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message | ComboEntry
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbBasicComboForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | ComboEntry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | ComboEntry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Called when a drop-down list closes | ComboEntry
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Called when a drop-down list opens | ComboEntry
OnDropKey |  | ComboEntry
OnKillFocus | Sent whenever the object is about to lose the focus | ComboEntry
OnMaxText |  | ComboEntry
OnSetFocus | Sent whenever windows is about to give this object the focus | ComboEntry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | ComboEntry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | ComboEntry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbComboFormDD_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | ComboEntry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist | ComboEntry
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbBasicComboForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | ComboEntry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | ComboEntry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbBasicComboForm_
Close_Panel | Procedure | Closes the panel or component currently open | dbBasicComboForm
Combo_Add_Item | Procedure | Augmented to support two parameters: a display value and a database value | dbDataComboForm
Combo_Delete_Data | Procedure | Deletes all this object's items | ComboEntry
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object | ComboEntry
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list | ComboEntry
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText | ComboEntry
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | ComboEntry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Code | Procedure | Sets current_item to the item having prompt equal to the value of the default_value property | dbDataComboForm
Default_Prompt | Procedure | Sets the default item upon the cursor's first entering this object by sending default_code with parameter of default_value | dbDataComboForm
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | ComboEntry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbBasicComboForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | ComboEntry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbBasicComboForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | ComboEntry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbBasicComboForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | ComboEntry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | ComboEntry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbBasicComboForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbBasicComboForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Help | Procedure |  | ComboEntry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | ComboEntry
Help_For_Help | Procedure | (Obsolete) | ComboEntry
Help_Index | Procedure | (Obsolete) | ComboEntry
Help_on_topic | Procedure | (Obsolete) | ComboEntry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | ComboEntry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbBasicComboForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | ComboEntry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | ComboEntry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | ComboEntry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbBasicComboForm_
Prompt_Description | Function | (Obsolete) | dbBasicComboForm
Prompt_Description | Procedure | (Obsolete) | dbBasicComboForm
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbBasicComboForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbBasicComboForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbBasicComboForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbBasicComboForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbBasicComboForm_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | dbBasicComboForm_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbBasicComboForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | ComboEntry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbBasicComboForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | ComboEntry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Combo_Value | Function | Determines if a combo form's value is valid | ComboEntry
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbBasicComboForm_
Validate_Prompt | Function | (Obsolete) | dbBasicComboForm
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbBasicComboForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbBasicComboForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbBasicComboForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbBasicComboForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbBasicComboForm_


Properties for dbComboFormDD_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Blank_State | Determines if a blank value is valid | ComboEntry
Allow_Undefined_State | Determines if an undefined value is added to the combo list | dbComboFormDS
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbBasicComboForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbBasicComboForm_
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object |
Auto_Save_State | Determines if auto save should be performed | dbBasicComboForm_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbBasicComboForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | ComboEntry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbBasicComboForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Code_Display_Mode | Specifies whether the list will display the choices' codes, descriptions, or both | dbDataComboForm
Code_Field | The number of the field in the combo_data_file from which values are to be drawn for insertion into the main database file through the Code_field object | dbComboFormDS
Code_File |  | dbComboFormDS
Code_Index |  | dbComboFormDS
Color | Sets the background color of the object | DfBaseWindow
Combo_Data_File | The file number containing the code_field | dbComboFormDS
Combo_Data_Object | Specifies the object ID of the internal l combo object | DfBaseComboBoxEntry
Combo_Index | The Index used by the combo form | dbComboFormDS
Combo_Item_Count | Returns the number of choices in the combo object's list | ComboEntry
Combo_Sort_State | Determines if the object will sort its visual list | ComboEntry
Combo_Value | Specifies the value of an item in the combo objects data-list | ComboEntry
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Used by default_prompt procedure to set the default item upon the cursor's first entering this object | dbDataComboForm
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbBasicComboForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | dbBasicComboForm
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbBasicComboForm_
Description_Field | The description field number in the combo_data_file | dbComboFormDS
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | ComboEntry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Message | Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value | dbBasicComboForm
Error_Number | The number of the error to be reported whenever validate_combo_item returns a non-zero value | dbBasicComboForm
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | ComboEntry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | ComboEntry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | ComboEntry
Help_Keyword | Used to specify an object's context keyword | ComboEntry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | ComboEntry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | ComboEntry
Label_Col_Offset | The horizontal distance from the object to its label | ComboEntry
Label_Justification_Mode | The justification mode for the text within this object's label | ComboEntry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | ComboEntry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | ComboEntry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
ListRowCount | Determines the number of rows in a combo form | ComboEntry
ListWidth | Detrmines the width of a combo's drop down list | ComboEntry
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | ComboEntry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | ComboEntry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbBasicComboForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbBasicComboForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbBasicComboForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | ComboEntry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Type_Field |  | dbComboFormDS
Type_Value | Determines the type value of the validation list | dbComboFormDS
Typeface | The typeface of the selected font | DfBaseWindow
Undefined_Display_Mode | Used by find_item to decide what to display when this object is filled from the database with a value that is not found among the values of this object's combo items | dbDataComboForm
Undefined_Save_Mode | Used by entry_update to decide what to save when a save is requested with a value in the window that is not among the prompts of this object | dbDataComboForm
Undefined_Value | Used for display by find_item and for insertion into the database by entry_update when this item's undefined_display_mode or undefined_save_mode respectively is cb_err_update_blank_value | dbDataComboForm
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | ComboEntry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbBasicComboForm_
Validate_Mode | Determines how and when object validation occurs | dbBasicComboForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbBasicComboForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbBasicComboForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbBasicComboForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbBasicComboForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbComboFormDD_ [Property Auto_Label_State]

Auto_Label_State - dbComboFormDD_

Determines if this object will draw label values from the DDO rather than from any label that may be set in this object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_label_state property is set true, this object will draw label values from the DDO rather than from any label that may be set in this object.

When used within single-item objects (forms and edits), the object uses the field's long label name.

When used within multi-item objects (grids), the object uses the field's short label name.

Default is false.

Last Edited: January 12, 2006


dbComboFormDS [Event Combo_Fill_List]

Combo_Fill_List - dbComboFormDS

Sent by the construct_object procedure, and must be defined in this object if the object does not draw its data from a database file via combo_data_file, code_field, description_field, etc

Type: Event

Parameters: No Parameters

Description

The Combo_fill_list message is sent by the construct_object procedure, and must be defined in this object if the object does not draw its data from a database file via combo_data_file, code_field, description_field, etc. You may define this procedure simply as a series of combo_add_item messages with the desired arguments, or you may define it to open a file, sequential or database, and assemble the list using combo_add_items to fill it with data from such file.

Last Edited: July 31, 2003


Events for dbComboFormDS

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Description_Value | A "hook" message that by default merely returns prompt | dbDataComboForm
Combo_Edit_Changed | Sets the item_changed_state of this object's item true | ComboEntry
Combo_Fill_List | Sent by the construct_object procedure, and must be defined in this object if the object does not draw its data from a database file via combo_data_file, code_field, description_field, etc |
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message | ComboEntry
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbBasicComboForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | ComboEntry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | ComboEntry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Called when a drop-down list closes | ComboEntry
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Called when a drop-down list opens | ComboEntry
OnDropKey |  | ComboEntry
OnKillFocus | Sent whenever the object is about to lose the focus | ComboEntry
OnMaxText |  | ComboEntry
OnSetFocus | Sent whenever windows is about to give this object the focus | ComboEntry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | ComboEntry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | ComboEntry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbComboFormDS

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | ComboEntry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist | ComboEntry
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbBasicComboForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | ComboEntry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | ComboEntry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbBasicComboForm_
Close_Panel | Procedure | Closes the panel or component currently open | dbBasicComboForm
Combo_Add_Item | Procedure | Augmented to support two parameters: a display value and a database value | dbDataComboForm
Combo_Delete_Data | Procedure | Deletes all this object's items | ComboEntry
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object | ComboEntry
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list | ComboEntry
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText | ComboEntry
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | ComboEntry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Code | Procedure | Sets current_item to the item having prompt equal to the value of the default_value property | dbDataComboForm
Default_Prompt | Procedure | Sets the default item upon the cursor's first entering this object by sending default_code with parameter of default_value | dbDataComboForm
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | ComboEntry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbBasicComboForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | ComboEntry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbBasicComboForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | ComboEntry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbBasicComboForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | ComboEntry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | ComboEntry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbBasicComboForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbBasicComboForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Help | Procedure |  | ComboEntry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | ComboEntry
Help_For_Help | Procedure | (Obsolete) | ComboEntry
Help_Index | Procedure | (Obsolete) | ComboEntry
Help_on_topic | Procedure | (Obsolete) | ComboEntry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | ComboEntry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbBasicComboForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | ComboEntry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | ComboEntry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | ComboEntry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbBasicComboForm_
Prompt_Description | Function | (Obsolete) | dbBasicComboForm
Prompt_Description | Procedure | (Obsolete) | dbBasicComboForm
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbBasicComboForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbBasicComboForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbBasicComboForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbBasicComboForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbBasicComboForm_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | dbBasicComboForm_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbBasicComboForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | ComboEntry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbBasicComboForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | ComboEntry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Combo_Value | Function | Determines if a combo form's value is valid | ComboEntry
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbBasicComboForm_
Validate_Prompt | Function | (Obsolete) | dbBasicComboForm
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbBasicComboForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbBasicComboForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbBasicComboForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbBasicComboForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbBasicComboForm_


Properties for dbComboFormDS

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Blank_State | Determines if a blank value is valid | ComboEntry
Allow_Undefined_State | Determines if an undefined value is added to the combo list |
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbBasicComboForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbBasicComboForm_
Auto_Save_State | Determines if auto save should be performed | dbBasicComboForm_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbBasicComboForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | ComboEntry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbBasicComboForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Code_Display_Mode | Specifies whether the list will display the choices' codes, descriptions, or both | dbDataComboForm
Code_Field | The number of the field in the combo_data_file from which values are to be drawn for insertion into the main database file through the Code_field object |
Code_File |  |
Code_Index |  |
Color | Sets the background color of the object | DfBaseWindow
Combo_Data_File | The file number containing the code_field |
Combo_Data_Object | Specifies the object ID of the internal l combo object | DfBaseComboBoxEntry
Combo_Index | The Index used by the combo form |
Combo_Item_Count | Returns the number of choices in the combo object's list | ComboEntry
Combo_Sort_State | Determines if the object will sort its visual list | ComboEntry
Combo_Value | Specifies the value of an item in the combo objects data-list | ComboEntry
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Used by default_prompt procedure to set the default item upon the cursor's first entering this object | dbDataComboForm
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbBasicComboForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | dbBasicComboForm
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbBasicComboForm_
Description_Field | The description field number in the combo_data_file |
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | ComboEntry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Message | Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value | dbBasicComboForm
Error_Number | The number of the error to be reported whenever validate_combo_item returns a non-zero value | dbBasicComboForm
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | ComboEntry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | ComboEntry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | ComboEntry
Help_Keyword | Used to specify an object's context keyword | ComboEntry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | ComboEntry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | ComboEntry
Label_Col_Offset | The horizontal distance from the object to its label | ComboEntry
Label_Justification_Mode | The justification mode for the text within this object's label | ComboEntry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | ComboEntry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | ComboEntry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
ListRowCount | Determines the number of rows in a combo form | ComboEntry
ListWidth | Detrmines the width of a combo's drop down list | ComboEntry
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | ComboEntry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | ComboEntry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbBasicComboForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbBasicComboForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbBasicComboForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | ComboEntry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Type_Field |  |
Type_Value | Determines the type value of the validation list |
Typeface | The typeface of the selected font | DfBaseWindow
Undefined_Display_Mode | Used by find_item to decide what to display when this object is filled from the database with a value that is not found among the values of this object's combo items | dbDataComboForm
Undefined_Save_Mode | Used by entry_update to decide what to save when a save is requested with a value in the window that is not among the prompts of this object | dbDataComboForm
Undefined_Value | Used for display by find_item and for insertion into the database by entry_update when this item's undefined_display_mode or undefined_save_mode respectively is cb_err_update_blank_value | dbDataComboForm
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | ComboEntry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbBasicComboForm_
Validate_Mode | Determines how and when object validation occurs | dbBasicComboForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbBasicComboForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbBasicComboForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbBasicComboForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbBasicComboForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbComboFormDS [Property Allow_Undefined_State]

Allow_Undefined_State - dbComboFormDS

Determines if an undefined value is added to the combo list

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When entry_state is false, this adds the value <Undefined> to the top of the combo list. This is only used when a DD validation table is being used, allow_blank_state of the validation table is false, and the combo form's entry_state is false. The <Undefined> legend will be displayed when the combo is cleared (assuming that there is no default set in field defaults) but will generate an error when it is validated. This is used to force users to choose a selection instead of simply accepting what may be an improper default.

When a drop-down list is a non-edit list (Entry_state=False), users may only select choices from the list. What should happen when a form is cleared? Normally, the program will have a default value set in the DD's Field_Default section and that default will be chosen. If no default is provided, the first item in the list is selected. If the validation table allows blank items (allow_blank_state=True), that first item will be the value . If allow_blank_state is false, then the first item in the list is the default. This implies that a legal value is always selected. This type of behavior is most "Windows-like".

While this behavior is "Windows-like," some developers have noted that this is a poorly engineered solution for human data entry. Often users will ignore default values and just use whatever is provided. By setting Allow_Undefined_state to true, users will be forced to choose an item since the undefined selection will not be valid.

Default is false.

Last Edited: January 12, 2006


dbComboFormDS [Property Code_Field]

Code_Field - dbComboFormDS

The number of the field in the combo_data_file from which values are to be drawn for insertion into the main database file through the Code_field object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Code_Field is the number of the field in the combo_data_file from which values are to be drawn for insertion into the main database file through the Code_field object.

Default is 1.

Last Edited: July 30, 2003


dbComboFormDS [Property Code_File]

Code_File - dbComboFormDS

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


dbComboFormDS [Property Code_Index]

Code_Index - dbComboFormDS

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


dbComboFormDS [Property Combo_Data_File]

Combo_Data_File - dbComboFormDS

The file number containing the code_field

Type: Property

Access: Read/Write

Data Type: Integer

Description

Combo_Data_file contains the file number of the code_field.

Last Edited: September 25, 2003


dbComboFormDS [Property Combo_Index]

Combo_Index - dbComboFormDS

The Index used by the combo form

Type: Property

Access: Read/Write

Data Type: Integer

Description

Combo_Index is Index number of the combo_data_file by which records are to be found. This would normally be an index on the description_field.

Default is 1.

Last Edited: September 25, 2003


dbComboFormDS [Property Description_Field]

Description_Field - dbComboFormDS

The description field number in the combo_data_file

Type: Property

Access: Read/Write

Data Type: Integer

Description

Description_Field is the field number in the combo_data_file which is used to display a code desctiption.

Default is 2.

Last Edited: September 25, 2003


dbComboFormDS [Property Type_Field]

Type_Field - dbComboFormDS

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


dbComboFormDS [Property Type_Value]

Type_Value - dbComboFormDS

Determines the type value of the validation list

Type: Property

Access: Read/Write

Data Type: String

Description

You must set the Type_value property to the type value for which you need the record values (code_field and description_field) displayed in this object.

Last Edited: September 11, 2003


Events for dbContainer3d

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d


Methods for dbContainer3d

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbContainer3d_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbContainer3d_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbContainer3d_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbContainer3d_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbContainer3d_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbContainer3d_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbContainer3d_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbContainer3d_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbContainer3d_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbContainer3d_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbContainer3d_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbContainer3d_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbContainer3d_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


dbContainer3d [Procedure Close_Panel]

Close_Panel - dbContainer3d

Closes the panel or component currently open

Type: Procedure

Parameters: No Parameters

Description

Closes the panel or component currently open. If the control Close_Panel is sent to is not a panel, the call will be delegated to it's parent.

For example, if a cDbRichEdit control is in a dbView, sending Close_Panel to the cDbRichEdit control will close the dbView.

Sample

This sample causes the dbView control oDbView1 to close when button oCloseButton is clicked.

Object oDbView1 is a dbView
    :
    Object oDbRichEdit1 is a cDbRichEdit
        :
    End_Object  // oDbRichEdit1
    :
    Object oCloseButton is a Button
        :
        Procedure OnClick
            send Close_Panel of oDbRichEdit1
        End_Procedure  // OnClick
        :
    End_Object  // oCloseButton
    :
End_Object  // oDbView1

Last Edited: November 24, 2004


Properties for dbContainer3d

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbContainer3d_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbContainer3d_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbContainer3d_
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | dbContainer3d_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbContainer3d_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbContainer3d_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbContainer3d_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbContainer3d_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbContainer3d_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbContainer3d_
verify_exit_msg | Determines what message is sent during an exiting event | dbContainer3d_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbContainer3d_
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Events for dbContainer3d_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d


dbContainer3d_ [Function Verify_Data_Loss]

Verify_Data_Loss - dbContainer3d_

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


dbContainer3d_ [Function Verify_Delete]

Verify_Delete - dbContainer3d_

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


dbContainer3d_ [Function verify_Exit]

verify_Exit - dbContainer3d_

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


dbContainer3d_ [Function Verify_Save]

Verify_Save - dbContainer3d_

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for dbContainer3d_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index |
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO |
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


dbContainer3d_ [Procedure Exit_Function]

Exit_Function - dbContainer3d_

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


dbContainer3d_ [Procedure Request_Cancel]

Request_Cancel - dbContainer3d_

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


dbContainer3d_ [Procedure Request_Clear]

Request_Clear - dbContainer3d_

Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause the user to lose changes made to the text, verify_data_loss is used to confirm the action. Clear is requested of the DSO. This may result in other DEOs clearing, in addition to the DEOs connected to that DSO. Sent (via delegation) by DEOs within the container.

Last Edited: September 11, 2003


dbContainer3d_ [Procedure Request_Clear_All]

Request_Clear_All - dbContainer3d_

Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear_all clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause a user to lose changes made to the text, verify_data_loss is used to confirm the action. Clear_all is requested of the DSO. This may result in other DEOs clearing, in addition to the DEOs connected to that DSO.

Last Edited: September 11, 2003


dbContainer3d_ [Procedure Request_Delete]

Request_Delete - dbContainer3d_

Deletes current record in main_file of the server DSO, if any, else issues an error

Type: Procedure

Parameters: No Parameters

Description

Request_delete deletes current record in main_file of the server DSO, if any, else issues an error. Sent by DEOs attached to the data set. Note that deletion of the current main_file record may cause sets of records in container DSOs to be deleted, i.e., those records that relate to the DSO's current record. Sends can_delete and acts only if that returns true.

Last Edited: September 11, 2003


dbContainer3d_ [Procedure Request_Find]

Request_Find - dbContainer3d_

Finds on specified file using given find_mode and index

Type: Procedure

Parameters: Integer mode Integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true, perform entry_update before find

Description

Request_find finds on specified file using given find_mode and index. If find is successful, performs a relate on file. If file is the same as the DSO's main_file, sends relate_main_file. Notifies other connected DSOs of the result of the find. Mode may be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either next_record, first_record, or last_record. Sets the found indicator to reflect the success or failure of the find operation. Sent by DEOs and item_find.

Last Edited: July 11, 2006


dbContainer3d_ [Procedure Request_Save]

Request_Save - dbContainer3d_

Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO

Type: Procedure

Parameters: No Parameters

Description

Request_Save saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO (directly or indirectly). Sent by DEOs attached to the DSO.

Last Edited: August 19, 2004


dbContainer3d_ [Procedure Request_Save_No_Clear]

Request_Save_No_Clear - dbContainer3d_

Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state

Type: Procedure

Parameters: No Parameters

Description

Request_save_no_clears saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state.

Last Edited: September 11, 2003


dbContainer3d_ [Procedure Request_Superfind]

Request_Superfind - dbContainer3d_

Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Request_superfind performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result. Find_mode may be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either next_record, first_record, or last_record. Sets the found indicator to reflect the success or failure of the find operation. Sends of request_superfind to a DSO require Predefined Indicator err to be set to false beforehand, in case an error other than Find past end of file or Find prior to beginning of file is generated by the superfind. Sent by DEOs.

Last Edited: September 11, 2003


Properties for dbContainer3d_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object |
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event |
Verify_Save_Msg | Specifies the message to use for save confirmation |
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbContainer3d_ [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - dbContainer3d_

Determines if object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


dbContainer3d_ [Property Auto_Fill_State]

Auto_Fill_State - dbContainer3d_

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


dbContainer3d_ [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - dbContainer3d_

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


dbContainer3d_ [Property Changed_State]

Changed_State - dbContainer3d_

Determines if one or more of the child objects has changed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If this flag is true, one or more of the child objects has changed. Augmented to set changed_state of server to true when changed_state of this object is set to true. Also augmented to detach this object from its server when set to false while this object is inactive.

This object will not save when this state is false. When necessary (as when changes are made other than through the keyboard), set this state to true explicitly.

Default is false.

Last Edited: January 12, 2006


dbContainer3d_ [Property Deferred_State]

Deferred_State - dbContainer3d_

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


dbContainer3d_ [Property deo_delegate_mode]

deo_delegate_mode - dbContainer3d_

Controls those requests for which delegate_..._state is set true

Type: Property

Access: Read/Write

Data Type: Integer

Description

Deo_delegate_mode controls those requests for which delegate_..._state is set true. The default delegate_server mode delegates request messages for objects that are not explicitly using a DDO. Delegate_always delegates regardless of whether a server is declared for the object, and delegate_never never delegates. This behavior may be set globally rather than just for this object by setting a function named default_deo_delegate_mode, and may also be queried with get.

Default is delegate_server.

Last Edited: July 31, 2003


dbContainer3d_ [Property Server]

Server - dbContainer3d_

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


dbContainer3d_ [Property Should_Save]

Should_Save - dbContainer3d_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


dbContainer3d_ [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - dbContainer3d_

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


dbContainer3d_ [Property Verify_Delete_Msg]

Verify_Delete_Msg - dbContainer3d_

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


dbContainer3d_ [Property verify_exit_msg]

verify_exit_msg - dbContainer3d_

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


dbContainer3d_ [Property Verify_Save_Msg]

Verify_Save_Msg - dbContainer3d_

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


Events for dbContainer

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d


Methods for dbContainer

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open | dbContainer3d
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbContainer3d_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbContainer3d_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbContainer3d_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbContainer3d_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbContainer3d_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbContainer3d_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbContainer3d_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbContainer3d_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbContainer3d_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbContainer3d_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbContainer3d_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbContainer3d_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbContainer3d_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for dbContainer

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbContainer3d_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbContainer3d_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbContainer3d_
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | dbContainer3d_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbContainer3d_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbContainer3d_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbContainer3d_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbContainer3d_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbContainer3d_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbContainer3d_
verify_exit_msg | Determines what message is sent during an exiting event | dbContainer3d_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbContainer3d_
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbDataComboForm [Event Combo_Description_Value]

Combo_Description_Value - dbDataComboForm

A "hook" message that by default merely returns prompt

Type: Event

Return Data Type: String

Parameters: String DescVal String DataVal

Parameter | Description
DescVal | What you see in the combo form
DataVal | The value that is read and written to the datafile

Return Value

Returns prompt

Description

Combo_description_value is a "hook" message that by default merely returns prompt. Can be augmented to change what is displayed for all or specific items (e.g., to capitalize it, or lower-case it). It is used by combo_add_item.

Last Edited: July 31, 2003


Events for dbDataComboForm

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Description_Value | A "hook" message that by default merely returns prompt |
Combo_Edit_Changed | Sets the item_changed_state of this object's item true | ComboEntry
Combo_Fill_List | Called when the combo list is to be filled | ComboEntry
Combo_Item_Changed | Sets the item_changed_state of this object's item true and sends the onChange message | ComboEntry
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbBasicComboForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | ComboEntry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | ComboEntry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Called when a drop-down list closes | ComboEntry
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Called when a drop-down list opens | ComboEntry
OnDropKey |  | ComboEntry
OnKillFocus | Sent whenever the object is about to lose the focus | ComboEntry
OnMaxText |  | ComboEntry
OnSetFocus | Sent whenever windows is about to give this object the focus | ComboEntry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | ComboEntry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | ComboEntry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbDataComboForm

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | ComboEntry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Form_To_List | Procedure | Adds the current form value to the combo list if it does not already exist | ComboEntry
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbBasicComboForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | ComboEntry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | ComboEntry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbBasicComboForm_
Close_Panel | Procedure | Closes the panel or component currently open | dbBasicComboForm
Combo_Add_Item | Procedure | Augmented to support two parameters: a display value and a database value |
Combo_Delete_Data | Procedure | Deletes all this object's items | ComboEntry
Combo_Delete_Item | Procedure | Removes a Combo item from the list of values in a combo object | ComboEntry
Combo_Insert_Item | Procedure | Inserts a combo item in a combo object's list | ComboEntry
Combo_Item_Matching | Function | Returns the number of the combo item whose value matches sText | ComboEntry
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | ComboEntry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Code | Procedure | Sets current_item to the item having prompt equal to the value of the default_value property |
Default_Prompt | Procedure | Sets the default item upon the cursor's first entering this object by sending default_code with parameter of default_value |
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | ComboEntry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbBasicComboForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | ComboEntry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbBasicComboForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | ComboEntry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbBasicComboForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbBasicComboForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | ComboEntry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | ComboEntry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbBasicComboForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbBasicComboForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbBasicComboForm_
Help | Procedure |  | ComboEntry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | ComboEntry
Help_For_Help | Procedure | (Obsolete) | ComboEntry
Help_Index | Procedure | (Obsolete) | ComboEntry
Help_on_topic | Procedure | (Obsolete) | ComboEntry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | ComboEntry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbBasicComboForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | ComboEntry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | ComboEntry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | ComboEntry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbBasicComboForm_
Prompt_Description | Function | (Obsolete) | dbBasicComboForm
Prompt_Description | Procedure | (Obsolete) | dbBasicComboForm
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbBasicComboForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbBasicComboForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbBasicComboForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbBasicComboForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbBasicComboForm_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | dbBasicComboForm_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbBasicComboForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | ComboEntry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbBasicComboForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbBasicComboForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | ComboEntry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Combo_Value | Function | Determines if a combo form's value is valid | ComboEntry
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbBasicComboForm_
Validate_Prompt | Function | (Obsolete) | dbBasicComboForm
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbBasicComboForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbBasicComboForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbBasicComboForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbBasicComboForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbBasicComboForm_


dbDataComboForm [Procedure Combo_Add_Item]

Combo_Add_Item - dbDataComboForm

Augmented to support two parameters: a display value and a database value

Type: Procedure

Parameters: String sValue String sDataValue

Parameter | Description
sValue | What you see in the combo form
sDataValue | The value that is read and written to the table

Description

Combo_add_item is augmented to support two parameters: a display value (what you see in the combo form) and a database value (the value that is read and written to the datafile). If only one parameter is passed, it will be used for both purposes.

Last Edited: July 26, 2006


dbDataComboForm [Procedure Default_Code]

Default_Code - dbDataComboForm

Sets current_item to the item having prompt equal to the value of the default_value property

Type: Procedure

Parameters: string Dflt

Parameter | Description
Dflt | The default value

Description

If the window is blank and unchanged, Default_code sets current_item to the item having prompt equal to the value of the default_value property.

Last Edited: July 31, 2003


dbDataComboForm [Procedure Default_Prompt]

Default_Prompt - dbDataComboForm

Sets the default item upon the cursor's first entering this object by sending default_code with parameter of default_value

Type: Procedure

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Description

Default_prompt sets the default item upon the cursor's first entering this object by sending default_code with parameter of default_value. It can be used by iEntry or inside Entry_Defaults.

Last Edited: June 22, 2005


Properties for dbDataComboForm

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Blank_State | Determines if a blank value is valid | ComboEntry
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbBasicComboForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbBasicComboForm_
Auto_Save_State | Determines if auto save should be performed | dbBasicComboForm_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbBasicComboForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | ComboEntry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbBasicComboForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Code_Display_Mode | Specifies whether the list will display the choices' codes, descriptions, or both |
Color | Sets the background color of the object | DfBaseWindow
Combo_Data_Object | Specifies the object ID of the internal l combo object | DfBaseComboBoxEntry
Combo_Item_Count | Returns the number of choices in the combo object's list | ComboEntry
Combo_Sort_State | Determines if the object will sort its visual list | ComboEntry
Combo_Value | Specifies the value of an item in the combo objects data-list | ComboEntry
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Used by default_prompt procedure to set the default item upon the cursor's first entering this object |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbBasicComboForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | dbBasicComboForm
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbBasicComboForm_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | ComboEntry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Message | Text (in addition to that provided with error_number) to be displayed whenever validate_combo_item returns a non-zero value | dbBasicComboForm
Error_Number | The number of the error to be reported whenever validate_combo_item returns a non-zero value | dbBasicComboForm
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | ComboEntry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | ComboEntry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | ComboEntry
Help_Keyword | Used to specify an object's context keyword | ComboEntry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | ComboEntry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | ComboEntry
Label_Col_Offset | The horizontal distance from the object to its label | ComboEntry
Label_Justification_Mode | The justification mode for the text within this object's label | ComboEntry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | ComboEntry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | ComboEntry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
ListRowCount | Determines the number of rows in a combo form | ComboEntry
ListWidth | Detrmines the width of a combo's drop down list | ComboEntry
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | ComboEntry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | ComboEntry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbBasicComboForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbBasicComboForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbBasicComboForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | ComboEntry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Undefined_Display_Mode | Used by find_item to decide what to display when this object is filled from the database with a value that is not found among the values of this object's combo items |
Undefined_Save_Mode | Used by entry_update to decide what to save when a save is requested with a value in the window that is not among the prompts of this object |
Undefined_Value | Used for display by find_item and for insertion into the database by entry_update when this item's undefined_display_mode or undefined_save_mode respectively is cb_err_update_blank_value |
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | ComboEntry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbBasicComboForm_
Validate_Mode | Determines how and when object validation occurs | dbBasicComboForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbBasicComboForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbBasicComboForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbBasicComboForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbBasicComboForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbDataComboForm [Property Code_Display_Mode]

Code_Display_Mode - dbDataComboForm

Specifies whether the list will display the choices' codes, descriptions, or both

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Code_display_mode property specifies whether the list will display the choices' codes, descriptions, or both.

Possible values are:

Constant | Meaning
CB_Code_Display_Description | Displays the description
CB_Code_Display_Code | Displays the code
CB_Code_Display_Both | Displays the description and the code

Last Edited: November 30, 2004


dbDataComboForm [Property Default_Value]

Default_Value - dbDataComboForm

Used by default_prompt procedure to set the default item upon the cursor's first entering this object

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer Item# String Val

Parameter | Description
Item# | The item number
Val | The value of the item

Description

The default_prompt procedure uses the value of the Default_value property (if any) to set the default item upon the cursor's first entering this object.

Last Edited: July 11, 2006


dbDataComboForm [Property Undefined_Display_Mode]

Undefined_Display_Mode - dbDataComboForm

Used by find_item to decide what to display when this object is filled from the database with a value that is not found among the values of this object's combo items

Type: Property

Access: Read/Write

Data Type: Integer

Description

The undefined_display_mode property is used by find_item to decide what to display when this object is filled from the database with a value that is not found among the values of this object's combo items. The default, cb_err_update_window_value displays the value from the database. Cb_err_update_blank_value uses the value of the undefined_value property. Cb_err_update_none leaves the display unchanged from whatever it was before the undefined value was encountered.

Default is cb_err_update_window_value.

Last Edited: September 11, 2003


dbDataComboForm [Property Undefined_Save_Mode]

Undefined_Save_Mode - dbDataComboForm

Used by entry_update to decide what to save when a save is requested with a value in the window that is not among the prompts of this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Undefined_save_mode property is used by entry_update to decide what to save when a save is requested with a value in the window that is not among the prompts of this object. The default, cb_err_update_window_value uses the value, if any, actually in the window. Cb_err_update_blank_value uses the value of the undefined_value property. Cb_err_update_none leaves the record buffer unchanged (and field is not validated by this object).

Default is cb_err_update_window_value.

Last Edited: September 11, 2003


dbDataComboForm [Property Undefined_Value]

Undefined_Value - dbDataComboForm

Used for display by find_item and for insertion into the database by entry_update when this item's undefined_display_mode or undefined_save_mode respectively is cb_err_update_blank_value

Type: Property

Access: Read/Write

Data Type: String

Description

The Undefined_value (null by default) is used for display by find_item and for insertion into the database by entry_update when this item's undefined_display_mode or undefined_save_mode respectively is cb_err_update_blank_value.

Last Edited: September 11, 2003


Events for dbEdit

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Edit
OnChange | Sent every time the edit buffer is changed | Edit
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Edit
OnMaxText | Sent when the edit buffer is full and an attempt has been made to add additional data to the buffer | Edit
OnSetFocus | Sent whenever windows is about to give this object the focus | Edit
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Edit
Refresh | Displays items from some files at the same time as clearing items from other files | dbEdit_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Edit


Methods for dbEdit

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Edit
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Append_Text | Procedure | Inserts data to the end of the existing contents of the object | DfBaseEdit
Beginning_of_Data | Procedure | Moves the cursor to the beginning of the data in the object | DfBaseEdit
Beginning_of_Line | Procedure | Moves then cursor to the beginning of the current line | DfBaseEdit
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Edit
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Edit
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open | dbEditDS
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseEdit
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseEdit
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | dbEditDS
Delete | Procedure | Deletes the marked block of text | DfBaseEdit
Delete_Char | Procedure | Deletes the character under the cursor | DfBaseEdit
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Destroys all of the data in the object and returns the edit cursor to the top of the buffer | DfBaseEdit
Delete_Line | Procedure | Deletes the current line | DfBaseEdit
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Edit
Down | Procedure | Moves the cursor down one line | DfBaseEdit
End_of_Data | Procedure | Moves the cursor to the end of the data | DfBaseEdit
End_of_Line | Procedure | Moves the cursor to the end of the current line | DfBaseEdit
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Edit
Error_Help | Procedure | (Obsolete) | Edit
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbEdit_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Edit
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Edit
Find | Procedure | Searches the text in an edit window | DfBaseEdit
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbEdit_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbEdit_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbEdit_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbEdit_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbEdit_
Help | Procedure |  | Edit
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | dbEditDS
Help_For_Help | Procedure | (Obsolete) | Edit
Help_Index | Procedure | (Obsolete) | Edit
Help_on_topic | Procedure | (Obsolete) | Edit
Insert | Procedure | Inserts a string of text into the edit buffer at the current cursor location | DfBaseEdit
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Edit
Left | Procedure | Moves the cursor one space to the left | DfBaseEdit
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Edit
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Moves the edit cursor down one page | DfBaseEdit
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Moves the edit cursor up one page | DfBaseEdit
Paste | Procedure | Copies the contents of the Clipboard into this object at the current cursor position | DfBaseEdit
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Edit
Prompt | Procedure | Cancelled in this class | dbEdit_
Prompt_Description | Function | (Obsolete) | dbEditDS
Prompt_Description | Procedure | (Obsolete) | dbEditDS
Read | Procedure | Imports information from an external source to the Edit object's buffer | DfBaseEdit
Read_Dbms | Procedure | Reads information from a database file | DfBaseEdit
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Replace | Procedure | Finds and Replaces Text in an edit object | DfBaseEdit
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbEdit_
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true | dbEdit_
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true | dbEdit_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbEdit_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbEdit_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | dbEdit_
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was | dbEdit_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Edit
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbEdit_
Reset_Find | Procedure | Causes the next find to search from the start of the text | DfBaseEdit
Reset_Replace | Procedure | Causes the next replace to search from the start of the text. | DfBaseEdit
Right | Procedure | Moves the cursor one space to the right | DfBaseEdit
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Select | Procedure | Marks the text in the editor beginning at position iPosition for the number of bytes set in charcount | DfBaseEdit
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbEdit_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbEdit_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbEdit_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Edit
Undo | Procedure | Will undo the last change in the edit | DfBaseEdit
Up | Procedure | Moves the edit cursor up one line | DfBaseEdit
Validate_Items | Function | Returns 0 by default, to indicate that entered text is valid | dbEdit_
Validate_Prompt | Function | (Obsolete) | dbEditDS
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbEdit_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbEdit_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbEdit_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbEdit_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes the contents of the edit buffer to the specified file | DfBaseEdit
Write_Dbms | Procedure | Writes information from the edit buffer to a database field | DfBaseEdit
Zoom | Procedure | Cancelled in this class | dbEdit_


Properties for dbEdit

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbEdit_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbEdit_
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object |
Auto_Save_State | Determines if auto save should be performed | dbEdit_
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbEdit_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Capslock_State | Determines if all text displayed will be in upper-case letters | Edit
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | The field number of the target text field | dbEdit_
Data_File | The file number of target memo field | dbEdit_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbEdit_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbEdit_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Edit_Buffer_Count | The number of characters currently in the object | DfBaseEdit
Enabled_State | Determines if an object is enabled or disabled | Edit
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Edit
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
File_Name | Used whenever a read or write message is sent to the Edit object and a file_name parameter is not specified | DfBaseEdit
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Edit
Help_Keyword | Used to specify an object's context keyword | Edit
Item_Count | Created for simulation of entry item | dbEdit_
Item_Shadow_State | Determines if an object's item is enabled or disabled | Edit
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Edit
Label_Col_Offset | The horizontal distance from the object to its label | Edit
Label_Justification_Mode | The justification mode for the text within this object's label | Edit
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Edit
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Edit
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of "lines" in Edit object | DfBaseEdit
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Edit
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Position | Returns the location of the cursor in the object | DfBaseEdit
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Edit
Read_Only_State | Allows you to protect the contents of the buffer while still allowing users freedom to navigate | DfBaseEdit
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbEdit_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbEdit_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Edit
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
Text_Limit | The number of characters that can be entered into the edit | DfBaseEdit
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Edit
Value | Determines the value of an item/paragraph | Edit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbEdit_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbEdit_
verify_exit_msg | Determines what message is sent during an exiting event | dbEdit_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbEdit_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Governs whether strings of text input will break and wrap to the next line at the end of this object, or will continue onward on the same line until a carriage return/linefeed is input | Edit


dbEdit [Property Auto_Label_State]

Auto_Label_State - dbEdit

Determines if this object will draw label values from the DDO rather than from any label that may be set in this object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_label_state property is set true, this object will draw label values from the DDO rather than from any label that may be set in this object.

When used within single-item objects (forms and edits), the object uses the field's long label name.

When used within multi-item objects (grids), the object uses the field's short label name.

Default is false.

Last Edited: January 12, 2006


dbEdit_ [Event Refresh]

Refresh - dbEdit_

Displays items from some files at the same time as clearing items from other files

Type: Event

Parameters: integer notifyMode

Parameter Description
notifyModeThe mode, which signifies the event or operation which generated this refresh message, may be one of the following five:

Constant | Meaning
mode_clear | used only for DEOs attached to the server which was the "origin" of a clear operation, i.e., the DataSet which received the original clear request or message as a result of the user pressing kclear. All other servers send their DEOs the refresh message passing mode_find_or_clear_set.
mode_find_or_clear_set | used for DEOs attached to servers which have found and/or cleared records in response to a user's find-request (kfind, kfind_next, ksuperfind, et al.) or in response to another server's find or clear.
mode_clear_all | used for DEOs attached to any server which participated in a clear_all operation.
mode_delete | used for DEOs attached to any server which performed a successful deletion. DataSets that were merely updated as the result of a deletion use mode_find_or_clear_set.
mode_save | used for DEOs attached to any server involved in a successful save operation.

Description

Refresh displays items from some files at the same time as clearing items from other files. In all cases, refresh will be sent instead of the clear, clear_set, clear_all, display, and entry_display messages in response to a find, clear, clear _all, save, or delete. In some cases, the actions of refresh depend on the (old) messages clear, clear _all, save, and display.

Last Edited: September 11, 2003


Events for dbEdit_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Edit
OnChange | Sent every time the edit buffer is changed | Edit
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Edit
OnMaxText | Sent when the edit buffer is full and an attempt has been made to add additional data to the buffer | Edit
OnSetFocus | Sent whenever windows is about to give this object the focus | Edit
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Edit
Refresh | Displays items from some files at the same time as clearing items from other files |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Edit


dbEdit_ [Function Validate_Items]

Validate_Items - dbEdit_

Returns 0 by default, to indicate that entered text is valid

Type: Function

Return Data Type: Integer

Parameters: Boolean bNotFindReq

Parameter | Description
bNotFindReq | Not used. If false validates all item options; if true validates all item options except findreq.

Return Value

Always returns 0.

Description

Validate_items returns 0 by default, to indicate that entered text is valid. Text fields are always considered valid. Therefore, this function always returns 0. In unusual cases, this maybe overridden to enforce application-specific validations, i.e., size limits, inclusion of key words, etc.

Last Edited: July 11, 2006


dbEdit_ [Function Verify_Data_Loss]

Verify_Data_Loss - dbEdit_

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


dbEdit_ [Function Verify_Delete]

Verify_Delete - dbEdit_

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


dbEdit_ [Function verify_Exit]

verify_Exit - dbEdit_

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


dbEdit_ [Function Verify_Save]

Verify_Save - dbEdit_

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for dbEdit_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Edit
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Append_Text | Procedure | Inserts data to the end of the existing contents of the object | DfBaseEdit
Beginning_of_Data | Procedure | Moves the cursor to the beginning of the data in the object | DfBaseEdit
Beginning_of_Line | Procedure | Moves then cursor to the beginning of the current line | DfBaseEdit
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Edit
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Edit
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseEdit
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseEdit
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseEdit
Delete_Char | Procedure | Deletes the character under the cursor | DfBaseEdit
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Destroys all of the data in the object and returns the edit cursor to the top of the buffer | DfBaseEdit
Delete_Line | Procedure | Deletes the current line | DfBaseEdit
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Edit
Down | Procedure | Moves the cursor down one line | DfBaseEdit
End_of_Data | Procedure | Moves the cursor to the end of the data | DfBaseEdit
End_of_Line | Procedure | Moves the cursor to the end of the current line | DfBaseEdit
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Edit
Error_Help | Procedure | (Obsolete) | Edit
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Edit
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Edit
Find | Procedure | Searches the text in an edit window | DfBaseEdit
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find |
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find |
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find |
Help | Procedure |  | Edit
Help_For_Help | Procedure | (Obsolete) | Edit
Help_Index | Procedure | (Obsolete) | Edit
Help_on_topic | Procedure | (Obsolete) | Edit
Insert | Procedure | Inserts a string of text into the edit buffer at the current cursor location | DfBaseEdit
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Edit
Left | Procedure | Moves the cursor one space to the left | DfBaseEdit
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Edit
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Moves the edit cursor down one page | DfBaseEdit
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Moves the edit cursor up one page | DfBaseEdit
Paste | Procedure | Copies the contents of the Clipboard into this object at the current cursor position | DfBaseEdit
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Edit
Prompt | Procedure | Cancelled in this class |
Read | Procedure | Imports information from an external source to the Edit object's buffer | DfBaseEdit
Read_Dbms | Procedure | Reads information from a database file | DfBaseEdit
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Replace | Procedure | Finds and Replaces Text in an edit object | DfBaseEdit
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Delete | Procedure | Deletes the current record of this object's server, if any |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any |
Request_Save | Procedure | Saves changes to the current record of this object's server, if any |
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Edit
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any |
Reset_Find | Procedure | Causes the next find to search from the start of the text | DfBaseEdit
Reset_Replace | Procedure | Causes the next replace to search from the start of the text. | DfBaseEdit
Right | Procedure | Moves the cursor one space to the right | DfBaseEdit
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Select | Procedure | Marks the text in the editor beginning at position iPosition for the number of bytes set in charcount | DfBaseEdit
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind |
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind |
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind |
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Edit
Undo | Procedure | Will undo the last change in the edit | DfBaseEdit
Up | Procedure | Moves the edit cursor up one line | DfBaseEdit
Validate_Items | Function | Returns 0 by default, to indicate that entered text is valid |
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes the contents of the edit buffer to the specified file | DfBaseEdit
Write_Dbms | Procedure | Writes information from the edit buffer to a database field | DfBaseEdit
Zoom | Procedure | Cancelled in this class |


dbEdit_ [Procedure Exit_Function]

Exit_Function - dbEdit_

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


dbEdit_ [Procedure Find_First]

Find_First - dbEdit_

Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_first finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of beginning_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbEdit_ [Procedure Find_GE]

Find_GE - dbEdit_

Performs a find greater than or equal by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_ge performs a find greater than or equal by the data_file and data_field of the current item, using request_find. Sent by kfind.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbEdit_ [Procedure Find_Last]

Find_Last - dbEdit_

Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_last finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of end_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbEdit_ [Procedure Find_Next]

Find_Next - dbEdit_

Performs a find greater than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_next performs a find greater than by the data_file and data_field of the current item, using request_find. Sent by kfind_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbEdit_ [Procedure Find_Previous]

Find_Previous - dbEdit_

Performs a find less than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_previous performs a find less than by the data_file and data_field of the current item, using request_find. Sent by kfind_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbEdit_ [Procedure Prompt]

Prompt - dbEdit_

Cancelled in this class

Type: Procedure

Parameters: No Parameters

Description

The Prompt procedure is cancelled in this class.

Last Edited: September 11, 2003


dbEdit_ [Procedure Request_Cancel]

Request_Cancel - dbEdit_

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


dbEdit_ [Procedure Request_Clear]

Request_Clear - dbEdit_

Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause users to lose changes made to the text, verify_data_loss is used to confirm the action. If this object has a server, clear is requested of the server. This may result in other DEOs clearing in addition to this object. Sent by kclear.

Last Edited: September 11, 2003


dbEdit_ [Procedure Request_Clear_All]

Request_Clear_All - dbEdit_

Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear_all clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause the user to lose changes made to the text, verify_data_loss is used to confirm the action. If this object has a server, clear_all is requested of the server. This may result in other DEOs clearing in addition to this object. Sent by kclear_all.

Last Edited: September 11, 2003


dbEdit_ [Procedure Request_Delete]

Request_Delete - dbEdit_

Deletes the current record of this object's server, if any

Type: Procedure

Parameters: No Parameters

Description

Request_delete deletes the current record of this object's server, if any. If successful and auto_clear_deo_state is true, also clears the text area using request_clear. Verify_delete is used to confirm the action. Sent by kdelete_record. Sends can_delete and acts only if true is returned.

Last Edited: September 11, 2003


dbEdit_ [Procedure Request_Find]

Request_Find - dbEdit_

Finds record using specified mode by requesting item_find from server, if any

Type: Procedure

Parameters: integer mode integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true perform entry update before Find.

Description

Request_find finds record using specified mode by requesting item_find from server, if any. Uses data_file and data_field to determine file and field for find. If this object has no server, no action is taken.

Last Edited: September 11, 2003


dbEdit_ [Procedure Request_Save]

Request_Save - dbEdit_

Saves changes to the current record of this object's server, if any

Type: Procedure

Parameters: No Parameters

Description

Request_save saves changes to the current record of this object's server, if any. If successful and auto_clear_deo_state is true, clears text area using request_clear. Verify_save is used to confirm the action. Sent by ksave_record.

Last Edited: September 11, 2003


dbEdit_ [Procedure Request_Save_No_Clear]

Request_Save_No_Clear - dbEdit_

A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was

Type: Procedure

Parameters: No Parameters

Description

Request_save_no_clear is a version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was.

Last Edited: September 11, 2003


dbEdit_ [Procedure Request_Superfind]

Request_Superfind - dbEdit_

Superfinds record using specified mode by requesting item_superfind from server, if any

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Request_superfind superfinds record using specified mode by requesting item_superfind from server, if any. Uses data_file and data_field to determine file and field for find. If this object has no server, no action is taken. Sent by DEOs. Sends of request_superfind to a DataSet require Predefined Indicator err to be set to false beforehand, in case an error other than Find past end of file or Find prior to beginning of file is generated by the superfind.

Last Edited: September 11, 2003


dbEdit_ [Procedure SuperFind]

SuperFind - dbEdit_

Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbEdit_ [Procedure SuperFind_Next]

SuperFind_Next - dbEdit_

Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_next performs a superfind greater than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbEdit_ [Procedure SuperFind_Previous]

SuperFind_Previous - dbEdit_

Performs a superfind less than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_previous performs a superfind less than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbEdit_ [Procedure Zoom]

Zoom - dbEdit_

Cancelled in this class

Type: Procedure

Parameters: No Parameters

Description

The Zoom procedure is cancelled in this class.

Last Edited: September 15, 2003


Properties for dbEdit_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Save_State | Determines if auto save should be performed |
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Capslock_State | Determines if all text displayed will be in upper-case letters | Edit
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | The field number of the target text field |
Data_File | The file number of target memo field |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Edit_Buffer_Count | The number of characters currently in the object | DfBaseEdit
Enabled_State | Determines if an object is enabled or disabled | Edit
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Edit
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
File_Name | Used whenever a read or write message is sent to the Edit object and a file_name parameter is not specified | DfBaseEdit
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Edit
Help_Keyword | Used to specify an object's context keyword | Edit
Item_Count | Created for simulation of entry item |
Item_Shadow_State | Determines if an object's item is enabled or disabled | Edit
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Edit
Label_Col_Offset | The horizontal distance from the object to its label | Edit
Label_Justification_Mode | The justification mode for the text within this object's label | Edit
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Edit
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Edit
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of "lines" in Edit object | DfBaseEdit
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Edit
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Position | Returns the location of the cursor in the object | DfBaseEdit
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Edit
Read_Only_State | Allows you to protect the contents of the buffer while still allowing users freedom to navigate | DfBaseEdit
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object |
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Edit
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
Text_Limit | The number of characters that can be entered into the edit | DfBaseEdit
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Edit
Value | Determines the value of an item/paragraph | Edit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event |
Verify_Save_Msg | Specifies the message to use for save confirmation |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Governs whether strings of text input will break and wrap to the next line at the end of this object, or will continue onward on the same line until a carriage return/linefeed is input | Edit


dbEdit_ [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - dbEdit_

If true, this object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


dbEdit_ [Property Auto_Fill_State]

Auto_Fill_State - dbEdit_

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


dbEdit_ [Property Auto_Save_State]

Auto_Save_State - dbEdit_

Determines if auto save should be performed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_save_state property is true, rotation from the last object within this object to the first object within this object will cause this object to save. Intended to be set.

Default is false.

Last Edited: January 12, 2006


dbEdit_ [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - dbEdit_

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


dbEdit_ [Property Data_Field]

Data_Field - dbEdit_

The field number of the target text field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer item# integer newval

Parameter | Description
item# | The item number
newval | The field number

Description

Data_Field determines the field number of target memo field, if any, else 0. Item# will always be 0.

Last Edited: July 31, 2003


dbEdit_ [Property Data_File]

Data_File - dbEdit_

The file number of target memo field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer item# integer newval

Parameter | Description
item# | The item number
newval | The file number

Description

Data_File determines the file number of target memo field, if any, else 0. Item# will always be 0.

Last Edited: August 5, 2003


dbEdit_ [Property Deferred_State]

Deferred_State - dbEdit_

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


dbEdit_ [Property deo_delegate_mode]

deo_delegate_mode - dbEdit_

Controls those requests for which delegate_..._state is set true

Type: Property

Access: Read/Write

Data Type: Integer

Description

Deo_delegate_mode controls those requests for which delegate_..._state is set true. The default delegate_server mode delegates request messages for objects that are not explicitly using a DDO. Delegate_always delegates regardless of whether a server is declared for the object, and delegate_never never delegates. This behavior may be set globally rather than just for this object by setting a function named default_deo_delegate_mode, and may also be queried with get.

Default is delegate_server.

Last Edited: July 31, 2003


dbEdit_ [Property Item_Count]

Item_Count - dbEdit_

Created for simulation of entry item

Type: Property

Access: Read-Only

Data Type: Integer

Description

Item_count returns 1. It is created for simulation of entry item.

Last Edited: August 18, 2003


dbEdit_ [Property Server]

Server - dbEdit_

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


dbEdit_ [Property Should_Save]

Should_Save - dbEdit_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


dbEdit_ [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - dbEdit_

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


dbEdit_ [Property Verify_Delete_Msg]

Verify_Delete_Msg - dbEdit_

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


dbEdit_ [Property verify_exit_msg]

verify_exit_msg - dbEdit_

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


dbEdit_ [Property Verify_Save_Msg]

Verify_Save_Msg - dbEdit_

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


Events for dbEditDS

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Edit
OnChange | Sent every time the edit buffer is changed | Edit
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Edit
OnMaxText | Sent when the edit buffer is full and an attempt has been made to add additional data to the buffer | Edit
OnSetFocus | Sent whenever windows is about to give this object the focus | Edit
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Edit
Refresh | Displays items from some files at the same time as clearing items from other files | dbEdit_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Edit


dbEditDS [Function Help_Datafile]

Help_Datafile - dbEditDS

Returns the filename and fieldname in file.field format that contains help for the current item

Type: Function

Obsolete

Return Data Type: String

Parameters: No Parameters

Return Value

The filename and fieldname in file.field format that contains help for the current item

Description

The Help_datafile function returns the filename and fieldname in file.field format that contains help for the current item.

Last Edited: August 12, 2003


dbEditDS [Function Prompt_Description]

Prompt_Description - dbEditDS

Type: Function

Obsolete

Return Data Type: String

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


dbEditDS [Function Validate_Prompt]

Validate_Prompt - dbEditDS

Type: Function

Obsolete

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for dbEditDS

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Edit
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Append_Text | Procedure | Inserts data to the end of the existing contents of the object | DfBaseEdit
Beginning_of_Data | Procedure | Moves the cursor to the beginning of the data in the object | DfBaseEdit
Beginning_of_Line | Procedure | Moves then cursor to the beginning of the current line | DfBaseEdit
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Edit
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Edit
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseEdit
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseEdit
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) |
Delete | Procedure | Deletes the marked block of text | DfBaseEdit
Delete_Char | Procedure | Deletes the character under the cursor | DfBaseEdit
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Destroys all of the data in the object and returns the edit cursor to the top of the buffer | DfBaseEdit
Delete_Line | Procedure | Deletes the current line | DfBaseEdit
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Edit
Down | Procedure | Moves the cursor down one line | DfBaseEdit
End_of_Data | Procedure | Moves the cursor to the end of the data | DfBaseEdit
End_of_Line | Procedure | Moves the cursor to the end of the current line | DfBaseEdit
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Edit
Error_Help | Procedure | (Obsolete) | Edit
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbEdit_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Edit
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Edit
Find | Procedure | Searches the text in an edit window | DfBaseEdit
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbEdit_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbEdit_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbEdit_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbEdit_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbEdit_
Help | Procedure |  | Edit
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item |
Help_For_Help | Procedure | (Obsolete) | Edit
Help_Index | Procedure | (Obsolete) | Edit
Help_on_topic | Procedure | (Obsolete) | Edit
Insert | Procedure | Inserts a string of text into the edit buffer at the current cursor location | DfBaseEdit
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Edit
Left | Procedure | Moves the cursor one space to the left | DfBaseEdit
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Edit
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Moves the edit cursor down one page | DfBaseEdit
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Moves the edit cursor up one page | DfBaseEdit
Paste | Procedure | Copies the contents of the Clipboard into this object at the current cursor position | DfBaseEdit
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Edit
Prompt | Procedure | Cancelled in this class | dbEdit_
Prompt_Description | Function | (Obsolete) |
Prompt_Description | Procedure | (Obsolete) |
Read | Procedure | Imports information from an external source to the Edit object's buffer | DfBaseEdit
Read_Dbms | Procedure | Reads information from a database file | DfBaseEdit
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Replace | Procedure | Finds and Replaces Text in an edit object | DfBaseEdit
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbEdit_
Request_Clear | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true | dbEdit_
Request_Clear_All | Procedure | Clears text area, and changes focus to first object or item in panel if auto_top_panel_state is true | dbEdit_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbEdit_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbEdit_
Request_Save | Procedure | Saves changes to the current record of this object's server, if any | dbEdit_
Request_Save_No_Clear | Procedure | A version of request_save that sets auto_clear_deo_state false temporarily, does the save, and then restores auto_clear_deo_state to whatever it was | dbEdit_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Edit
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbEdit_
Reset_Find | Procedure | Causes the next find to search from the start of the text | DfBaseEdit
Reset_Replace | Procedure | Causes the next replace to search from the start of the text. | DfBaseEdit
Right | Procedure | Moves the cursor one space to the right | DfBaseEdit
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Select | Procedure | Marks the text in the editor beginning at position iPosition for the number of bytes set in charcount | DfBaseEdit
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbEdit_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbEdit_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbEdit_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Edit
Undo | Procedure | Will undo the last change in the edit | DfBaseEdit
Up | Procedure | Moves the edit cursor up one line | DfBaseEdit
Validate_Items | Function | Returns 0 by default, to indicate that entered text is valid | dbEdit_
Validate_Prompt | Function | (Obsolete) |
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbEdit_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbEdit_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbEdit_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbEdit_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes the contents of the edit buffer to the specified file | DfBaseEdit
Write_Dbms | Procedure | Writes information from the edit buffer to a database field | DfBaseEdit
Zoom | Procedure | Cancelled in this class | dbEdit_


dbEditDS [Procedure Close_Panel]

Close_Panel - dbEditDS

Closes the panel or component currently open

Type: Procedure

Parameters: No Parameters

Description

Closes the panel or component currently open. If the control Close_Panel is sent to is not a panel, the call will be delegated to it's parent.

For example, if a cDbRichEdit control is in a dbView, sending Close_Panel to the cDbRichEdit control will close the dbView.

Sample

This sample causes the dbView control oDbView1 to close when button oCloseButton is clicked.

Object oDbView1 is a dbView
    :
    Object oDbRichEdit1 is a cDbRichEdit
        :
    End_Object  // oDbRichEdit1
    :
    Object oCloseButton is a Button
        :
        Procedure OnClick
            send Close_Panel of oDbRichEdit1
        End_Procedure  // OnClick
        :
    End_Object  // oCloseButton
    :
End_Object  // oDbView1

Last Edited: November 24, 2004


dbEditDS [Procedure Default_Prompt]

Default_Prompt - dbEditDS

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbEditDS [Procedure Prompt_Description]

Prompt_Description - dbEditDS

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Properties for dbEditDS

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbEdit_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbEdit_
Auto_Save_State | Determines if auto save should be performed | dbEdit_
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbEdit_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Capslock_State | Determines if all text displayed will be in upper-case letters | Edit
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | The field number of the target text field | dbEdit_
Data_File | The file number of target memo field | dbEdit_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbEdit_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbEdit_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Edit_Buffer_Count | The number of characters currently in the object | DfBaseEdit
Enabled_State | Determines if an object is enabled or disabled | Edit
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Edit
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
File_Name | Used whenever a read or write message is sent to the Edit object and a file_name parameter is not specified | DfBaseEdit
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Edit
Help_Keyword | Used to specify an object's context keyword | Edit
Item_Count | Created for simulation of entry item | dbEdit_
Item_Shadow_State | Determines if an object's item is enabled or disabled | Edit
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Edit
Label_Col_Offset | The horizontal distance from the object to its label | Edit
Label_Justification_Mode | The justification mode for the text within this object's label | Edit
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Edit
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Edit
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of "lines" in Edit object | DfBaseEdit
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Edit
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Position | Returns the location of the cursor in the object | DfBaseEdit
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Edit
Read_Only_State | Allows you to protect the contents of the buffer while still allowing users freedom to navigate | DfBaseEdit
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbEdit_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbEdit_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Edit
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
Text_Limit | The number of characters that can be entered into the edit | DfBaseEdit
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Edit
Value | Determines the value of an item/paragraph | Edit
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbEdit_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbEdit_
verify_exit_msg | Determines what message is sent during an exiting event | dbEdit_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbEdit_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Governs whether strings of text input will break and wrap to the next line at the end of this object, or will continue onward on the same line until a carriage return/linefeed is input | Edit


Events for dbFloatingPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


Methods for dbFloatingPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbFloatingPanel_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbFloatingPanel_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbFloatingPanel_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbFloatingPanel_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbFloatingPanel_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbFloatingPanel_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbFloatingPanel_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbFloatingPanel_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbFloatingPanel_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbFloatingPanel_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbFloatingPanel_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbFloatingPanel_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbFloatingPanel_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


dbFloatingPanel [Procedure Close_Panel]

Close_Panel - dbFloatingPanel

Closes the panel or component currently open

Type: Procedure

Parameters: No Parameters

Description

Closes the panel or component currently open. If the control Close_Panel is sent to is not a panel, the call will be delegated to it's parent.

For example, if a cDbRichEdit control is in a dbView, sending Close_Panel to the cDbRichEdit control will close the dbView.

Sample

This sample causes the dbView control oDbView1 to close when button oCloseButton is clicked.

Object oDbView1 is a dbView
    :
    Object oDbRichEdit1 is a cDbRichEdit
        :
    End_Object  // oDbRichEdit1
    :
    Object oCloseButton is a Button
        :
        Procedure OnClick
            send Close_Panel of oDbRichEdit1
        End_Procedure  // OnClick
        :
    End_Object  // oCloseButton
    :
End_Object  // oDbView1

Last Edited: November 24, 2004


Properties for dbFloatingPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbFloatingPanel_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbFloatingPanel_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbFloatingPanel_
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | dbFloatingPanel_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbFloatingPanel_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbFloatingPanel_
DEO_Object |  |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbFloatingPanel_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbFloatingPanel_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbFloatingPanel_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbFloatingPanel_
verify_exit_msg | Determines what message is sent during an exiting event | dbFloatingPanel_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbFloatingPanel_
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbFloatingPanel [Property DEO_Object]

DEO_Object - dbFloatingPanel

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: December 29, 2005


Events for dbFloatingPanel_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


dbFloatingPanel_ [Function Verify_Data_Loss]

Verify_Data_Loss - dbFloatingPanel_

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


dbFloatingPanel_ [Function Verify_Delete]

Verify_Delete - dbFloatingPanel_

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


dbFloatingPanel_ [Function verify_Exit]

verify_Exit - dbFloatingPanel_

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


dbFloatingPanel_ [Function Verify_Save]

Verify_Save - dbFloatingPanel_

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for dbFloatingPanel_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  | FloatingPanel
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index |
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO |
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


dbFloatingPanel_ [Procedure Exit_Function]

Exit_Function - dbFloatingPanel_

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


dbFloatingPanel_ [Procedure Request_Cancel]

Request_Cancel - dbFloatingPanel_

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


dbFloatingPanel_ [Procedure Request_Clear]

Request_Clear - dbFloatingPanel_

Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause the user to lose changes made to the text, verify_data_loss is used to confirm the action. Clear is requested of the DSO. This may result in other DEOs clearing, in addition to the DEOs connected to that DSO. Sent (via delegation) by DEOs within the container.

Last Edited: September 11, 2003


dbFloatingPanel_ [Procedure Request_Clear_All]

Request_Clear_All - dbFloatingPanel_

Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear_all clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause a user to lose changes made to the text, verify_data_loss is used to confirm the action. Clear_all is requested of the DSO. This may result in other DEOs clearing, in addition to the DEOs connected to that DSO.

Last Edited: September 11, 2003


dbFloatingPanel_ [Procedure Request_Delete]

Request_Delete - dbFloatingPanel_

Deletes current record in main_file of the server DSO, if any, else issues an error

Type: Procedure

Parameters: No Parameters

Description

Request_delete deletes current record in main_file of the server DSO, if any, else issues an error. Sent by DEOs attached to the data set. Note that deletion of the current main_file record may cause sets of records in container DSOs to be deleted, i.e., those records that relate to the DSO's current record. Sends can_delete and acts only if that returns true.

Last Edited: September 11, 2003


dbFloatingPanel_ [Procedure Request_Find]

Request_Find - dbFloatingPanel_

Finds on specified file using given find_mode and index

Type: Procedure

Parameters: Integer mode Integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true, perform entry_update before find

Description

Request_find finds on specified file using given find_mode and index. If find is successful, performs a relate on file. If file is the same as the DSO's main_file, sends relate_main_file. Notifies other connected DSOs of the result of the find. Mode may be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either next_record, first_record, or last_record. Sets the found indicator to reflect the success or failure of the find operation. Sent by DEOs and item_find.

Last Edited: July 11, 2006


dbFloatingPanel_ [Procedure Request_Save]

Request_Save - dbFloatingPanel_

Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO

Type: Procedure

Parameters: No Parameters

Description

Request_Save saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO (directly or indirectly). Sent by DEOs attached to the DSO.

Last Edited: August 19, 2004


dbFloatingPanel_ [Procedure Request_Save_No_Clear]

Request_Save_No_Clear - dbFloatingPanel_

Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state

Type: Procedure

Parameters: No Parameters

Description

Request_save_no_clears saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state.

Last Edited: September 11, 2003


dbFloatingPanel_ [Procedure Request_Superfind]

Request_Superfind - dbFloatingPanel_

Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Request_superfind performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result. Find_mode may be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either next_record, first_record, or last_record. Sets the found indicator to reflect the success or failure of the find operation. Sends of request_superfind to a DSO require Predefined Indicator err to be set to false beforehand, in case an error other than Find past end of file or Find prior to beginning of file is generated by the superfind. Sent by DEOs.

Last Edited: September 11, 2003


Properties for dbFloatingPanel_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object |
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event |
Verify_Save_Msg | Specifies the message to use for save confirmation |
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbFloatingPanel_ [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - dbFloatingPanel_

Determines if object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


dbFloatingPanel_ [Property Auto_Fill_State]

Auto_Fill_State - dbFloatingPanel_

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


dbFloatingPanel_ [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - dbFloatingPanel_

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


dbFloatingPanel_ [Property Changed_State]

Changed_State - dbFloatingPanel_

Determines if one or more of the child objects has changed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If this flag is true, one or more of the child objects has changed. Augmented to set changed_state of server to true when changed_state of this object is set to true. Also augmented to detach this object from its server when set to false while this object is inactive.

This object will not save when this state is false. When necessary (as when changes are made other than through the keyboard), set this state to true explicitly.

Default is false.

Last Edited: January 12, 2006


dbFloatingPanel_ [Property Deferred_State]

Deferred_State - dbFloatingPanel_

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


dbFloatingPanel_ [Property deo_delegate_mode]

deo_delegate_mode - dbFloatingPanel_

Controls those requests for which delegate_..._state is set true

Type: Property

Access: Read/Write

Data Type: Integer

Description

Deo_delegate_mode controls those requests for which delegate_..._state is set true. The default delegate_server mode delegates request messages for objects that are not explicitly using a DDO. Delegate_always delegates regardless of whether a server is declared for the object, and delegate_never never delegates. This behavior may be set globally rather than just for this object by setting a function named default_deo_delegate_mode, and may also be queried with get.

Default is delegate_server.

Last Edited: July 31, 2003


dbFloatingPanel_ [Property Server]

Server - dbFloatingPanel_

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


dbFloatingPanel_ [Property Should_Save]

Should_Save - dbFloatingPanel_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


dbFloatingPanel_ [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - dbFloatingPanel_

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


dbFloatingPanel_ [Property Verify_Delete_Msg]

Verify_Delete_Msg - dbFloatingPanel_

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


dbFloatingPanel_ [Property verify_exit_msg]

verify_exit_msg - dbFloatingPanel_

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


dbFloatingPanel_ [Property Verify_Save_Msg]

Verify_Save_Msg - dbFloatingPanel_

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


Events for dbFloatingPopupMenu

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Initialize_Menu | Sent when the Menubar system is about to be selected | DfBaseActionBar
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for dbFloatingPopupMenu

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Exit_Menu | Procedure |  | DfBaseActionBar
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Redirect_Message | Procedure |  | DfBaseActionBar
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for dbFloatingPopupMenu

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Events for dbForm

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message | Entry
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Entry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | Entry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Entry
OnMaxText |  | Entry
OnSetFocus | Sent whenever windows is about to give this object the focus | Entry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Entry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | Entry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbForm

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Entry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Entry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Entry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbForm_
Close_Panel | Procedure | Closes the panel or component currently open | dbFormDS
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | Entry
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | Entry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | dbFormDS
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Entry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Entry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | Entry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Entry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Entry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbForm_
Help | Procedure |  | Entry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | Entry
Help_For_Help | Procedure | (Obsolete) | Entry
Help_Index | Procedure | (Obsolete) | Entry
Help_on_topic | Procedure | (Obsolete) | Entry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Entry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Entry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | Entry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Entry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbForm_
Prompt_Description | Function | (Obsolete) | dbFormDS
Prompt_Description | Procedure | (Obsolete) | dbFormDS
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbForm_
Request_Save | Procedure |  | dbFormDS
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Entry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Entry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbForm_
Validate_Prompt | Function | (Obsolete) | dbFormDS
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbForm_


Properties for dbForm

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbForm_
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object |
Auto_Save_State | Determines if auto save should be performed | dbForm_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | Entry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | dbForm_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | dbFormDS
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbForm_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Entry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Entry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | Entry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Entry
Help_Keyword | Used to specify an object's context keyword | Entry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | Entry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Entry
Label_Col_Offset | The horizontal distance from the object to its label | Entry
Label_Justification_Mode | The justification mode for the text within this object's label | Entry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Entry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Entry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Entry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form | Entry
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object | Entry
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Entry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Entry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Entry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbForm_
Validate_Mode | Determines how and when object validation occurs | dbForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbForm [Property Auto_Label_State]

Auto_Label_State - dbForm

Determines if this object will draw label values from the DDO rather than from any label that may be set in this object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_label_state property is set true, this object will draw label values from the DDO rather than from any label that may be set in this object.

When used within single-item objects (forms and edits), the object uses the field's long label name.

When used within multi-item objects (grids), the object uses the field's short label name.

Default is false.

Last Edited: January 12, 2006


dbForm_ [Event Entry_Defaults]

Entry_Defaults - dbForm_

"Hook" for providing default-setting routines

Type: Event

Parameters: No Parameters

Description

Entry_defaults is a "Hook" for providing default-setting routines. It is sent by clear. You should never send this message. Note that this is not used with data dictionaries.

Last Edited: August 5, 2003


Events for dbForm_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines |
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message | Entry
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Entry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | Entry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Entry
OnMaxText |  | Entry
OnSetFocus | Sent whenever windows is about to give this object the focus | Entry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Entry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | Entry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


dbForm_ [Function exec_entry]

exec_entry - dbForm_

Invokes the item_entry_msg of the specified item#, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: integer item#

Parameter | Description
item# | The item number

Return Value

The result of the item_entry_msg of the specified item#

Description

Exec_entry invokes the item_entry_msg of the specified item#, if any, and returns the result.

Last Edited: August 13, 2003


dbForm_ [Function exec_exit]

exec_exit - dbForm_

Invokes the item_exit_msg of the specified item#, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: integer item#

Parameter | Description
item# | The item number

Return Value

The result of the item_entry_msg of the specified item#

Description

Exec_exit invokes the item_exit_msg of the specified item#, if any, and returns the result.

Last Edited: August 13, 2003


dbForm_ [Function exec_validate]

exec_validate - dbForm_

Invokes the item_validate_msg of the specified item#, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: integer item#

Parameter | Description
item# | The item number

Return Value

The result of the item_entry_msg of the specified item#

Description

Exec_validate invokes the item_validate_msg of the specified item#, if any, and returns the result. Performs autofind on value and field of specified item#, if required, using entry_autofind.

Last Edited: August 13, 2003


dbForm_ [Function Validate_Items]

Validate_Items - dbForm_

Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails

Type: Function

Return Data Type: Integer

Parameters: Boolean bNotFindReq

Parameter | Description
bNotFindReq | If true the find required validation is not enforced

Return Value

Returns 0 if all items are valid, or else returns the first invalid item number.

Description

The superclass definition of the Validate_items message is augmented to manipulate the value of validate_items (a property inherited from the entry class) when validate_mode is validate_default, and to give this object the focus in the event validation of any item fails.

Last Edited: July 11, 2006


dbForm_ [Function Verify_Data_Loss]

Verify_Data_Loss - dbForm_

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


dbForm_ [Function Verify_Delete]

Verify_Delete - dbForm_

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


dbForm_ [Function verify_Exit]

verify_Exit - dbForm_

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


dbForm_ [Function Verify_Save]

Verify_Save - dbForm_

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for dbForm_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Entry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Entry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Entry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | Entry
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | Entry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Entry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Entry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful |
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | Entry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result |
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result |
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Entry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Entry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find |
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find |
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find |
Help | Procedure |  | Entry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | Entry
Help_For_Help | Procedure | (Obsolete) | Entry
Help_Index | Procedure | (Obsolete) | Entry
Help_on_topic | Procedure | (Obsolete) | Entry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Entry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation |
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Entry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | Entry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Entry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true |
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true |
Request_Delete | Procedure | Deletes the current record of this object's server, if any |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any |
Request_Save | Procedure | Saves changes to the current record of this object's server, if any |
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Entry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind |
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind |
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind |
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Entry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails |
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message |


dbForm_ [Procedure Set CheckBox_Item]

CheckBox_Item - dbForm_

Set after each item of this object that you wish to be a checkbox

Type: Procedure Set

Data Type: String

Parameters: String ItemVal String TrueVal String FalseVal

Parameter | Description
ItemVal | The item that you wish displayed with the checkbox
TrueVal | The database field value for which the item's select_state is to be true
FalseVal | The field value for which the select_state is false

Description

The Checkbox_item message should be set after each item of this object that you wish to be a checkbox. All field values other than TrueVal will set the item's select_state false on entry_display. If FalseVal is omitted, 0 will be used. If TrueVal also is omitted, 1 will be used for that parameter by default.

Last Edited: June 23, 2005


dbForm_ [Procedure Beginning_of_Data]

Beginning_of_Data - dbForm_

Finds and displays the first record of the file specified by the data_file of the current_item of this object

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_data finds and displays the first record of the file specified by the data_file of the current_item of this object. Sent by kbegin_of_data.

Last Edited: August 13, 2003


dbForm_ [Procedure End_of_Data]

End_of_Data - dbForm_

Finds and displays the last record of the file specified by the data_file of the current_item of this object

Type: Procedure

Parameters: No Parameters

Description

End_of_data finds and displays the last record of the file specified by the data_file of the current_item of this object. Sent by kend_of_data.

Last Edited: August 5, 2003


dbForm_ [Procedure Entry_Autofind]

Entry_Autofind - dbForm_

Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful

Type: Procedure

Parameters: Integer eFindMode Integer iItem

Parameter | Description
eFindMode

Constant | Meaning
EQ | Find equal to
GE | Find greater than or equal to

iItem | The item number

Description

Entry_autofind finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful. Augmented to request find of server, if any, using item_find message.

Last Edited: July 11, 2006


dbForm_ [Procedure Exit_Function]

Exit_Function - dbForm_

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


dbForm_ [Procedure Find_First]

Find_First - dbForm_

Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_first finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of beginning_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbForm_ [Procedure Find_GE]

Find_GE - dbForm_

Performs a find greater than or equal by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_ge performs a find greater than or equal by the data_file and data_field of the current item, using request_find. Sent by kfind.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbForm_ [Procedure Find_Last]

Find_Last - dbForm_

Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_last finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of end_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbForm_ [Procedure Find_Next]

Find_Next - dbForm_

Performs a find greater than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_next performs a find greater than by the data_file and data_field of the current item, using request_find. Sent by kfind_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbForm_ [Procedure Find_Previous]

Find_Previous - dbForm_

Performs a find less than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_previous performs a find less than by the data_file and data_field of the current item, using request_find. Sent by kfind_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbForm_ [Procedure Next]

Next - dbForm_

Makes validation in validate_on_save_next mode occur regardless of the state of object_validation

Type: Procedure

Parameters: No Parameters

Description

The superclass definition of the Next message is augmented to make validation in validate_on_save_next mode occur regardless of the state of object_validation (a property inherited from the entry superclass).

Last Edited: September 10, 2003


dbForm_ [Procedure Prompt]

Prompt - dbForm_

Activates prompt_object of current item, if any, using popup message

Type: Procedure

Parameters: No Parameters

Description

Prompt activates prompt_object of current item, if any, using popup message. Sent by kprompt.

Last Edited: June 29, 2005


dbForm_ [Procedure Request_Cancel]

Request_Cancel - dbForm_

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


dbForm_ [Procedure Request_Clear]

Request_Clear - dbForm_

Clears items, and changes focus to first item in this object if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear clears items, and changes focus to first item in this object if auto_top_panel_state is true. If clearing may cause loss of user changes to the text, verify_data_loss is used to confirm the action. If this object has a server, clear is requested of the server. This may result in other DEOs clearing in addition to this object. Sent by kclear.

Last Edited: September 11, 2003


dbForm_ [Procedure Request_Clear_All]

Request_Clear_All - dbForm_

Clears items, and changes focus to first item in this object if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear_all clears items, and changes focus to first item in this object if auto_top_panel_state is true. If clearing may cause loss of user changes to the text, verify_data_loss is used to confirm the action. If this object has a server, clear_all is requested of the server. This may result in other DEOs clearing in addition to this object. Sent by kclear_all.

Last Edited: September 11, 2003


dbForm_ [Procedure Request_Delete]

Request_Delete - dbForm_

Deletes the current record of this object's server, if any

Type: Procedure

Parameters: No Parameters

Description

Request_delete deletes the current record of this object's server, if any. If successful and auto_clear_deo_state is true, also clears the items using request_clear. Verify_delete is used to confirm the action. Sent by kdelete_record. Sends can_delete and acts only if that returns true.

Last Edited: September 11, 2003


dbForm_ [Procedure Request_Find]

Request_Find - dbForm_

Finds record using specified mode by requesting item_find from server, if any

Type: Procedure

Parameters: integer mode integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true perform entry update before Find.

Description

Request_find finds record using specified mode by requesting item_find from server, if any. Uses data_file and data_field to determine file and field for find. If this object has no server, no action is taken.

Last Edited: September 11, 2003


dbForm_ [Procedure Request_Save]

Request_Save - dbForm_

Saves changes to the current record of this object's server, if any

Type: Procedure

Parameters: No Parameters

Description

Request_Save saves changes to the current record of this object's server, if any. If successful and auto_clear_deo_state is true, clears items using request_clear. Verify_save is used to confirm the action. Sent by ksave_record.

Last Edited: August 19, 2004


dbForm_ [Procedure Request_Save_No_Clear]

Request_Save_No_Clear - dbForm_

Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state

Type: Procedure

Parameters: No Parameters

Description

Request_save_no_clear saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state.

Last Edited: September 11, 2003


dbForm_ [Procedure Request_Superfind]

Request_Superfind - dbForm_

Superfinds record using specified mode by requesting item_superfind from server, if any

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Request_superfind superfinds record using specified mode by requesting item_superfind from server, if any. Uses data_file and data_field to determine file and field for find. If this object has no server, no action is taken. Sends of request_superfind to a DSO require Predefined Indicator err to be set to false beforehand, in case an error other than Find past end of file or Find prior to beginning of file is generated by the superfind. Sent by DEOs.

Last Edited: September 11, 2003


dbForm_ [Procedure SuperFind]

SuperFind - dbForm_

Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbForm_ [Procedure SuperFind_Next]

SuperFind_Next - dbForm_

Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_next performs a superfind greater than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbForm_ [Procedure SuperFind_Previous]

SuperFind_Previous - dbForm_

Performs a superfind less than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_previous performs a superfind less than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbForm_ [Procedure Zoom]

Zoom - dbForm_

Activates zoom object of current item, if any, using popup message

Type: Procedure

Parameters: No Parameters

Description

Zoom activates zoom object of current item, if any, using popup message. Sent by kzoom.

Last Edited: September 15, 2003


Properties for dbForm_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Save_State | Determines if auto save should be performed |
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | Entry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object |
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true |
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Entry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Entry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | Entry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Entry
Help_Keyword | Used to specify an object's context keyword | Entry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | Entry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Entry
Label_Col_Offset | The horizontal distance from the object to its label | Entry
Label_Justification_Mode | The justification mode for the text within this object's label | Entry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Entry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Entry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Entry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form | Entry
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object | Entry
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Entry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object |
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Entry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Entry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated |
Validate_Mode | Determines how and when object validation occurs |
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event |
Verify_Save_Msg | Specifies the message to use for save confirmation |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbForm_ [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - dbForm_

If true, this object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


dbForm_ [Property Auto_Fill_State]

Auto_Fill_State - dbForm_

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


dbForm_ [Property Auto_Save_State]

Auto_Save_State - dbForm_

Determines if auto save should be performed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_save_state property is true, rotation from the last object within this object to the first object within this object will cause this object to save. Intended to be set.

Default is false.

Last Edited: January 12, 2006


dbForm_ [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - dbForm_

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


dbForm_ [Property Changed_Value]

Changed_Value - dbForm_

Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object

Type: Property

Access: Write-Only

Data Type: String

Parameters: integer Item# String Val

Parameter | Description
Item# | The item number
Val | The value of the item

Description

The Changed_value message merely changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object.

Last Edited: July 22, 2003


dbForm_ [Property Default_Value]

Default_Value - dbForm_

Changes the value property of Item item# to value, but leaves its item_changed_state unchanged

Type: Property

Access: Write-Only

Data Type: String

Parameters: integer Item# String Val

Parameter | Description
Item# | The item number
Val | The value of the item

Description

The Default_value message changes the value property of Item item# to value, but leaves its item_changed_state unchanged. This is the message for setting default values.

Last Edited: July 31, 2003


dbForm_ [Property Deferred_State]

Deferred_State - dbForm_

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


dbForm_ [Property deo_delegate_mode]

deo_delegate_mode - dbForm_

Controls those requests for which delegate_..._state is set true

Type: Property

Access: Read/Write

Data Type: Integer

Description

Deo_delegate_mode controls those requests for which delegate_..._state is set true. The default delegate_server mode delegates request messages for objects that are not explicitly using a DDO. Delegate_always delegates regardless of whether a server is declared for the object, and delegate_never never delegates. This behavior may be set globally rather than just for this object by setting a function named default_deo_delegate_mode, and may also be queried with get.

Default is delegate_server.

Last Edited: July 31, 2003


dbForm_ [Property Retain_no_Change_state]

Retain_no_Change_state - dbForm_

Determines if the item_changed_state of items have true or false values

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The default for the Retain_no_change_state property true keeps the item_changed_state of items receiving default values false until and unless they are explicitly changed. If your program needs the item_changed_state of such items to be true, you can provide such behavior by setting this property false.

Default is true.

Last Edited: January 12, 2006


dbForm_ [Property Server]

Server - dbForm_

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


dbForm_ [Property Should_Save]

Should_Save - dbForm_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


dbForm_ [Property Validate_All_Items_State]

Validate_All_Items_State - dbForm_

Determines if all items are being validated

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Validate_all_items_state property is set true when all items are validated in one process, as in a save. It is reset false when one or some other subset of all the items are validated, as in navigation between items.

Default is false.

Last Edited: January 12, 2006


dbForm_ [Property Validate_Mode]

Validate_Mode - dbForm_

Determines how and when object validation occurs

Type: Property

Access: Read/Write

Data Type: Integer

Description

The validate_mode property determines how and when object validation occurs.

Default is VALIDATE_ON_SAVE_NEXT.

Valid modes are:

Mode | Description
VALIDATE_DEFAULT | Obsolete (character-mode only)
VALIDATE_ON_SAVE | Validates are only sent during a save
VALIDATE_ON_SAVE_NEXT | Validates are sent during a save and forward keyboard navigation

Last Edited: August 12, 2005


dbForm_ [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - dbForm_

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


dbForm_ [Property Verify_Delete_Msg]

Verify_Delete_Msg - dbForm_

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


dbForm_ [Property verify_exit_msg]

verify_exit_msg - dbForm_

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


dbForm_ [Property Verify_Save_Msg]

Verify_Save_Msg - dbForm_

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


Events for dbFormDS

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message | Entry
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Entry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | Entry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Entry
OnMaxText |  | Entry
OnSetFocus | Sent whenever windows is about to give this object the focus | Entry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Entry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | Entry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


dbFormDS [Function Prompt_Description]

Prompt_Description - dbFormDS

Type: Function

Obsolete

Return Data Type: String

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


dbFormDS [Function Validate_Prompt]

Validate_Prompt - dbFormDS

Type: Function

Obsolete

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for dbFormDS

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Entry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Entry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Entry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbForm_
Close_Panel | Procedure | Closes the panel or component currently open |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | Entry
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | Entry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) |
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Entry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Entry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | Entry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Entry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Entry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbForm_
Help | Procedure |  | Entry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | Entry
Help_For_Help | Procedure | (Obsolete) | Entry
Help_Index | Procedure | (Obsolete) | Entry
Help_on_topic | Procedure | (Obsolete) | Entry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Entry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Entry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | Entry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Entry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbForm_
Prompt_Description | Function | (Obsolete) |
Prompt_Description | Procedure | (Obsolete) |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbForm_
Request_Save | Procedure |  |
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Entry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Entry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbForm_
Validate_Prompt | Function | (Obsolete) |
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbForm_


dbFormDS [Procedure Close_Panel]

Close_Panel - dbFormDS

Closes the panel or component currently open

Type: Procedure

Parameters: No Parameters

Description

Closes the panel or component currently open. If the control Close_Panel is sent to is not a panel, the call will be delegated to it's parent.

For example, if a cDbRichEdit control is in a dbView, sending Close_Panel to the cDbRichEdit control will close the dbView.

Sample

This sample causes the dbView control oDbView1 to close when button oCloseButton is clicked.

Object oDbView1 is a dbView
    :
    Object oDbRichEdit1 is a cDbRichEdit
        :
    End_Object  // oDbRichEdit1
    :
    Object oCloseButton is a Button
        :
        Procedure OnClick
            send Close_Panel of oDbRichEdit1
        End_Procedure  // OnClick
        :
    End_Object  // oCloseButton
    :
End_Object  // oDbView1

Last Edited: November 24, 2004


dbFormDS [Procedure Default_Prompt]

Default_Prompt - dbFormDS

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbFormDS [Procedure Prompt_Description]

Prompt_Description - dbFormDS

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbFormDS [Procedure Request_Save]

Request_Save - dbFormDS

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Properties for dbFormDS

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbForm_
Auto_Save_State | Determines if auto save should be performed | dbForm_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | Entry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | dbForm_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) |
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbForm_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Entry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Entry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | Entry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Entry
Help_Keyword | Used to specify an object's context keyword | Entry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | Entry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Entry
Label_Col_Offset | The horizontal distance from the object to its label | Entry
Label_Justification_Mode | The justification mode for the text within this object's label | Entry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Entry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Entry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Entry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form | Entry
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object | Entry
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Entry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Entry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Entry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbForm_
Validate_Mode | Determines how and when object validation occurs | dbForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbFormDS [Property DEO_Control_Object]

DEO_Control_Object - dbFormDS

Indicates whether the control is a Data Entry Object (DEO)

Type: Property

Access: Read-Only

Data Type: Integer

Description

Any Data Entry Object (DEO) has DEO_Control_Object set true, which means that it is a DEO control object, but not a container.

Any DEO control will also return true for DEO_Object because of delegation (DEO controls must always reside in DEO containers).

See Also

DEO_Object

Last Edited: May 4, 2005


Events for dbFormExternalControl

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message | Entry
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Entry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | Entry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Entry
OnMaxText |  | Entry
OnSetFocus | Sent whenever windows is about to give this object the focus | Entry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Entry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | Entry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbFormExternalControl

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Entry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Entry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Entry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbForm_
Close_Panel | Procedure | Closes the panel or component currently open | dbFormDS
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | Entry
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | Entry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | dbFormDS
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Entry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Entry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | Entry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Entry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Entry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbForm_
Help | Procedure |  | Entry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | Entry
Help_For_Help | Procedure | (Obsolete) | Entry
Help_Index | Procedure | (Obsolete) | Entry
Help_on_topic | Procedure | (Obsolete) | Entry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Entry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Entry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | Entry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Entry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbForm_
Prompt_Description | Function | (Obsolete) | dbFormDS
Prompt_Description | Procedure | (Obsolete) | dbFormDS
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbForm_
Request_Save | Procedure |  | dbFormDS
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Entry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Entry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbForm_
Validate_Prompt | Function | (Obsolete) | dbFormDS
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbForm_


Properties for dbFormExternalControl

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbForm_
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object | dbForm
Auto_Save_State | Determines if auto save should be performed | dbForm_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | Entry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | dbForm_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | dbFormDS
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbForm_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Entry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Entry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | Entry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Entry
Help_Keyword | Used to specify an object's context keyword | Entry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | Entry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Entry
Label_Col_Offset | The horizontal distance from the object to its label | Entry
Label_Justification_Mode | The justification mode for the text within this object's label | Entry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Entry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Entry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Entry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form | Entry
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object | Entry
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Entry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Entry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Entry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbForm_
Validate_Mode | Determines how and when object validation occurs | dbForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbGrid [Event Column_Combo_Description_Value]

Column_Combo_Description_Value - dbGrid

Called to determine what should be displayed in the combo form

Type: Event

Return Data Type: String

Parameters: integer iColumn integer eMode String sDescVal String sDataVal

Parameter | Description
iColumn | The column number (zero-based)
eModeDisplay mode. Can be:

Constant | Meaning
CB_Code_Display_Description | Displays the description
CB_Code_Display_Code | Displays the code
CB_Code_Display_Both | Displays the description and the code

sDescVal | Description value
sDataVal | Data (code) value

Return Value

Description

Called to determine what should be displayed in the combo form. By default, it properly creates a display value based on Column_Combo_Code_Display_Mode. This can be used as an augmentation point to customize the display. It must return the value that will be displayed in the combo list.

To augment this function for augmenation:

Function Column_Combo_Description_Value integer iColumn integer eMode string sDescVal string sDataVal returns String
    string sReturnValue

    // augment here

    forward get Column_Combo_Description_Value iColumn eMode sDescVal sDataVal to sReturnValue

    // augment here

    function_return sReturnValue
End_Function  // Column_Combo_Description_Value

Last Edited: November 30, 2004


dbGrid [Event Column_Combo_Fill_List]

Column_Combo_Fill_List - dbGrid

Called when the column combo form's dropdown list needs to be filled

Type: Event

Parameters: integer iCol

Parameter | Description
iCol | The column number

Description

Called when the column combo form's dropdown list needs to be filled. By default, it attempts to fill the list based on the data-dictionary. Therefore, when using DD code tables, you will not need to aumgent this message.

If you wish to fill a combo form with custom values, you may use this message. You will add items to the list by sending the Column_Combo_Add_Item message.

Sample

The following sample fills the 3rd column (column 2) with custom values.

Procedure Column_Combo_Fill_List integer iCol
    // only override for column 2
    if (iCol=2) begin
        // delete all existing items from dropdown list
        send Column_Combo_Delete_Data iCol
        // add items to dropdown list
        send Column_Combo_Add_Item iCol "A Description" "A"
        send Column_Combo_Add_Item iCol "B Description" "B"
        send Column_Combo_Add_Item iCol "C Description" "C"
        send Column_Combo_Add_Item iCol "D Description" "D"
        send Column_Combo_Add_Item iCol "E Description" "E"
    end
    else ;
        forward send Column_Combo_Fill_List iCol
End_Procedure  // Column_Combo_Fill_List

Last Edited: November 30, 2004


Events for dbGrid

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Child_Entering | Provided to permit programming of required grid actions when this object is a child of a header grid object | dbGrid_
Child_Exiting | Event that is sent when a child table is about to be exited | dbGrid_
Column_Combo_Description_Value | Called to determine what should be displayed in the combo form |
Column_Combo_Fill_List | Called when the column combo form's dropdown list needs to be filled |
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | Augmented to call child_entering if this object's child_table_state is true | dbGrid_
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbGrid_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click |  | dbGridDS
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items | WideList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view | DataList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin |  | DataList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnNewOrdering | Called whenever the ordering is changed | DataList_
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DataList_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbGrid

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
add_new_row | Procedure | Inserts a blank row into the grid if the cursor is not already in a new row | dbGrid_
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list | DataList_
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful | dbGrid_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbGrid_
Clear_Current_Record | Procedure |  | DataList_
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Col_Index | Function | Returns the number of the main index for the field connected to Column Item# | DataList_
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column |
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | dbGridDS
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Display | Procedure |  | DataList_
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoCheckDisplayableRows | Procedure |  | DataList_
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm | DataList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList | DataList_
DoToggleColumnOrdering | Procedure |  | DataList_
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Augmented to respect the value of the allow_row_change property | dbGrid_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
Establish_Find_Mode | Procedure |  | DataList_
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
File_Record | Function | (Obsolete) | DataList_
FileRecord | Function |  | DataList_
FileRowId | Function |  | DataList_
Fill_List | Procedure |  | DataList_
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer | DataList_
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbGrid_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbGrid_
Find_Init | Procedure |  | DataList_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbGrid_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbGrid_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbGrid_
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object | DataList_
find_RowId | Procedure |  | DataList_
Goto_Bottom_Row | Procedure |  | DataList_
Goto_Top_Row | Procedure |  | DataList_
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in | DataList_
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbGrid_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Read_By_Recnum | Procedure | (Obsolete) | DataList_
Read_Next_Record | Procedure |  | DataList_
ReadByRowId | Procedure |  | DataList_
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col# | DataList_
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Reorder_list | Procedure |  | dbGrid_
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Clear | Procedure | Clears the current row of any changes entered to it | dbGrid_
Request_Clear_All | Procedure | Clears list page, and changes focus to first object or item in panel if auto_top_panel_state is true | dbGrid_
Request_Delete | Procedure | Determines if the current record of the server of the object is deleted | dbGrid_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any | dbGrid_
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column | DataList_
Request_Save | Procedure | Saves changes to the current record | dbGrid_
Request_Save_No_Clear | Procedure |  | dbGrid_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Request_Superfind | Procedure | Superfinds record using specified mode, by sending request_superfind to server, if any | dbGrid_
Row_save | Function | Sent by request_save to save the current record in the server file | dbGrid_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure |  | dbGrid_
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbGrid_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbGrid_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbGrid_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure |  | DataList_
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbGrid_
Validate_Prompt | Function | (Obsolete) | WideList
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbGrid_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbGrid_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbGrid_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


dbGrid [Procedure Column_Combo_Add_Item]

Column_Combo_Add_Item - dbGrid

Adds an item to the end of the combo form's dropdown list for a column

Type: Procedure

Parameters: Integer iColumn String sValue

Parameter | Description
iColumn | The column number (zero-based)
sValue | Item description

Description

This is the message that must be used to fill the list of items that appear in the combo form's dropdown list.

Sample

This sample sets column 2 to be a combo column, then adds "Type 1" and "Type 2" to the combo's dropdown list.

set Column_Combo_State 2 to True
Send Column_Combo_Add_Item 2 "Type 1"
Send Column_Combo_Add_Item 2 "Type 2"

Sample

This sample fills a grid with 20 rows of 3 columns each. It then instructs the grid to make column 2 a combo form, to sort the combo form's dropdown list, and adds 3 items to the dropdown list.

Procedure DoFillGrid
    integer iRow iMaxRows iCount
    string sCustomerName

    move "John Q. Customer" to sCustomerName

    move 20 To iMaxRows
    For iRow From 1 To iMaxRows
        Send Add_Item Msg_None (sCustomerName + string (iRow)))
        Send Add_Item Msg_None ("305-555-1212")
        Send Add_Item Msg_None (if(mod(iCount,2)=0,"Type 1","Type 2"))
        increment iCount
    Loop
End_Procedure // DoFillGrid

send DoFillGrid

// make column 2 a combo
set Column_Combo_State 2 to True
// sort the dropdown list for the combo in column 2
set Column_Combo_Sort_State 2 to True
// add items to the dropdown list for the combo in column 2
Send Column_Combo_Add_Item 2 "Type 3"
Send Column_Combo_Add_Item 2 "Type 2"
Send Column_Combo_Add_Item 2 "Type 1"

Last Edited: July 11, 2006


Properties for dbGrid

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Bottom_add_State | Determines if additional rows may be added to the end of the grid | dbGrid_
Allow_Insert_Add_State | Determines if new rows may be inserted within the grid | dbGrid_
Allow_top_add_State | Determines if additional rows may be added to the top of the grid | dbGrid_
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbGrid_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_index_state | Determines how the popup lists will be ordered | DataList_
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object | dbGridDD
Auto_Regenerate_State | Controls the behavior of the object when add mode is exited, or when the object is initialized as it takes the focus | dbGrid_
Auto_Save_State | Determines if auto save should be performed | dbGrid_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Batch_State | Determines how much data from the database is read into memory | DataList_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbGrid_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Child_Table_State | Determines if the entering message sends the child_entering message and the exiting message sends the child_exiting message | dbGrid_
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Button |  | DataList
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case | DataList
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox | DataList
Column_Combo_Code_Display_mode | Determines what is displayed in the combo form and its dropdown list |
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message | DataList
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message | DataList
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to | DataList
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to | DataList
Column_Option | Allows you to query or change the iOption option line for Column iCol | DataList
Column_Options | Allows you to copy column options or set them in a group | DataList
Column_Prompt_Object | Specifies the default receiving object for the popup message | DataList
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled | DataList
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message | DataList
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object | DataList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Record | (Obsolete) The number of the record of the current row | DataList_
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRecordStatus |  | DataList_
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowHasRecord |  | DataList_
CurrentRowId |  | DataList_
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
CustomScrollState | Determines changing scroll bar behaviors | DataList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | dbGrid_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | DataList
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbGrid_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Export_Code_Description_State | Determines if the next item will be used to display a code description | dbGridDD
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Init_from_Top_State | Determines in what order images are displayed | DataList_
Initial_Column | Determines where the cursor is located when the list is activated | DataList_
Initial_Row | Governs the location in the display of the record (if any) in the buffer | DataList_
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_File | Holds the file number of the main file of the list | DataList_
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
No_Create_State | Controls whether or not this object can create records | dbGrid_
No_Delete_State | Controls whether this object can delete records | dbGrid_
No_Relate_State | Determines if relates occur with lists that do not use DDOs | DataList_
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Ordering | Holds the index of the main file to be used to display the database records of the main file | DataList_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls | DataList
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction | DataList
pbReverseOrdering | Determines if the list should be displayed in reverse index order | DataList_
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines if prompt_button_value will be displayed to the right of column labels | dbGridDS
Prompt_Button_Value | Specifies the character(s) to be appended to a column-header label to indicate that it supports prompting | dbGridDS
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object | Returns the object-id of the internal object | DataList_
psEmbeddedButtonValue |  | DataList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object | DataList_
Record_Number | (Obsolete) Indicates the record number for the record in the specified row | DataList_
record_rowId |  | DataList_
RecordStatus |  | DataList_
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbGrid_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
RowHasRecord |  | DataList_
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released | DataList
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Gets and returns the value of the row_changed function | dbGrid_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Static_State | Determines if the list will only be initialized once the first time this object is activated | DataList_
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior | DataList
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbGrid_
Validate_Mode | Determines how and when object validation occurs | dbGrid_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbGrid_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbGrid_
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbGrid_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbGrid [Property Column_Combo_Code_Display_mode]

Column_Combo_Code_Display_mode - dbGrid

Determines what is displayed in the combo form and its dropdown list

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iColumn integer eVal

Parameter | Description
iColumn | The column number (zero-based)
eValDisplay mode. Can be:

Constant | Meaning
CB_Code_Display_Description | Displays the description
CB_Code_Display_Code | Displays the code
CB_Code_Display_Both | Displays the description and the code

Description

Determines what is displayed in the combo form and its dropdown list.

Default is CB_Code_Display_Description

Sample

This sample causes the combo form in column 2 and the values in its dropdown list to display the description and the code for each item.

set Column_Combo_Code_Display_mode 2 to CB_Code_Display_Both

Last Edited: November 30, 2004


dbGrid_ [Event Child_Entering]

Child_Entering - dbGrid_

Provided to permit programming of required grid actions when this object is a child of a header grid object

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns 0 when entering is allowed

Description

Child_entering is a null function, provided to permit programming of required grid actions when this object is a child of a header grid object. This message is sent by entering when child_table_state is true, and should return 0 when entering is allowed.

Last Edited: July 30, 2003


dbGrid_ [Event Child_Exiting]

Child_Exiting - dbGrid_

Event that is sent when a child table is about to be exited

Type: Event

Return Data Type: Integer

Parameters: Integer toObj#

Parameter | Description
toObj# | The handle of the object that is about to take the focus

Return Value

Returns 0 when exit is allowed

Description

You can stop the exiting by returning a non-zero value. By default this will save the current record. If the save fails, the exiting is stopped. Note that the ID of the object the user is entering is passed. This can be useful to know. If the user is exiting to a form or editor that is part of the table (often a child of the table object), you may not want to save the table line. If the object being entered is part of the header, you would probably want to save the table. Note that the default errs on the side of caution (it always saves the table). This message is sent by exiting when child_table_state is true, and should return 0 when exit is allowed.

Last Edited: September 10, 2003


dbGrid_ [Event Entering]

Entering - dbGrid_

Augmented to call child_entering if this object's child_table_state is true

Type: Event

Parameters: No Parameters

Description

The superclass definition of the Entering event is augmented to call child_entering if this object's child_table_state is true.

Last Edited: August 5, 2003


dbGrid_ [Event Entry_Defaults]

Entry_Defaults - dbGrid_

"Hook" for providing default-setting routines

Type: Event

Parameters: No Parameters

Description

Entry_defaults is a "Hook" for providing default-setting routines. It is sent by clear. You should never send this message. Note that this is not used with data dictionaries.

Last Edited: August 5, 2003


Events for dbGrid_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Child_Entering | Provided to permit programming of required grid actions when this object is a child of a header grid object |
Child_Exiting | Event that is sent when a child table is about to be exited |
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | Augmented to call child_entering if this object's child_table_state is true |
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines |
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click |  | DataList
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items | WideList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view | DataList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin |  | DataList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnNewOrdering | Called whenever the ordering is changed | DataList_
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DataList_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


dbGrid_ [Function Row_save]

Row_save - dbGrid_

Sent by request_save to save the current record in the server file

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Constant | Meaning
0 | The save was accomplished successfully without error
1 | Validation failed
2 | The user did not validate the save request
3 | An error occurred during the save

Description

Row_save is sent by request_save to save the current record in the server file. This is a replacement for the save_row procedure, differing in that this function returns a status indicator. This function sends save_row.

Last Edited: September 11, 2003


dbGrid_ [Function Validate_Items]

Validate_Items - dbGrid_

Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails

Type: Function

Return Data Type: Integer

Parameters: Boolean bNotFindReq

Parameter | Description
bNotFindReq | If true the find required validation is not enforced

Return Value

Returns 0 if all items are valid, or else returns the first invalid item number.

Description

The superclass definition of the Validate_items message is augmented to manipulate the value of validate_items (a property inherited from the entry class) when validate_mode is validate_default, and to give this object the focus in the event validation of any item fails.

Last Edited: July 11, 2006


dbGrid_ [Function Verify_Data_Loss]

Verify_Data_Loss - dbGrid_

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


dbGrid_ [Function Verify_Delete]

Verify_Delete - dbGrid_

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


dbGrid_ [Function Verify_Save]

Verify_Save - dbGrid_

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for dbGrid_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
add_new_row | Procedure | Inserts a blank row into the grid if the cursor is not already in a new row |
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list | DataList_
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox |
Clear_Current_Record | Procedure |  | DataList_
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Col_Index | Function | Returns the number of the main index for the field connected to Column Item# | DataList_
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Display | Procedure |  | DataList_
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoCheckDisplayableRows | Procedure |  | DataList_
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm | DataList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList | DataList_
DoToggleColumnOrdering | Procedure |  | DataList_
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Augmented to respect the value of the allow_row_change property |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
Establish_Find_Mode | Procedure |  | DataList_
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
File_Record | Function | (Obsolete) | DataList_
FileRecord | Function |  | DataList_
FileRowId | Function |  | DataList_
Fill_List | Procedure |  | DataList_
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer | DataList_
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find |
Find_Init | Procedure |  | DataList_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find |
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find |
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object | DataList_
find_RowId | Procedure |  | DataList_
Goto_Bottom_Row | Procedure |  | DataList_
Goto_Top_Row | Procedure |  | DataList_
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in | DataList_
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation |
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Read_By_Recnum | Procedure | (Obsolete) | DataList_
Read_Next_Record | Procedure |  | DataList_
ReadByRowId | Procedure |  | DataList_
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col# | DataList_
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Reorder_list | Procedure |  |
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Clear | Procedure | Clears the current row of any changes entered to it |
Request_Clear_All | Procedure | Clears list page, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Delete | Procedure | Determines if the current record of the server of the object is deleted |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any |
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column | DataList_
Request_Save | Procedure | Saves changes to the current record |
Request_Save_No_Clear | Procedure |  |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Request_Superfind | Procedure | Superfinds record using specified mode, by sending request_superfind to server, if any |
Row_save | Function | Sent by request_save to save the current record in the server file |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure |  |
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind |
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind |
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind |
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure |  | DataList_
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails |
Validate_Prompt | Function | (Obsolete) | WideList
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


dbGrid_ [Procedure Set CheckBox_Item]

CheckBox_Item - dbGrid_

Set after each item of this object that you wish to be a checkbox

Type: Procedure Set

Data Type: String

Parameters: String ItemVal String TrueVal String FalseVal

Parameter | Description
ItemVal | The item that you wish displayed with the checkbox
TrueVal | The database field value for which the item's select_state is to be true
FalseVal | The field value for which the select_state is false

Description

The Checkbox_item message should be set after each item of this object that you wish to be a checkbox. All field values other than TrueVal will set the item's select_state false on entry_display. If FalseVal is omitted, 0 will be used. If TrueVal also is omitted, 1 will be used for that parameter by default.

Last Edited: June 23, 2005


dbGrid_ [Procedure add_new_row]

add_new_row - dbGrid_

Inserts a blank row into the grid if the cursor is not already in a new row

Type: Procedure

Parameters: Integer iLoc

Parameter Description
iLocDetermines where the new row is added:

Constant | Meaning
-1 | Add to top of grid
0 | Add at current row
1 | Add to bottom of grid

Description

Add_new_row inserts a blank row into the grid if the cursor is not already in a new row. If loc is 0, the row is inserted above the current row; if it is -1, it is inserted at the top of grid; if it is 1, at the bottom.

Last Edited: August 17, 2005


dbGrid_ [Procedure Beginning_of_Data]

Beginning_of_Data - dbGrid_

Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful

Type: Procedure

Parameters: No Parameters

Description

The Beginning_of_data message finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful. If the find was not successful, the display is cleared of all records.

Last Edited: July 30, 2003


dbGrid_ [Procedure End_of_Data]

End_of_Data - dbGrid_

Augmented to respect the value of the allow_row_change property

Type: Procedure

Parameters: No Parameters

Description

The superclass definition of the End_of_data message is augmented to respect the value of the allow_row_change property.

Last Edited: August 5, 2003


dbGrid_ [Procedure Find_First]

Find_First - dbGrid_

Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_first finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of beginning_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbGrid_ [Procedure Find_GE]

Find_GE - dbGrid_

Performs a find greater than or equal by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_ge performs a find greater than or equal by the data_file and data_field of the current item, using request_find. Sent by kfind.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbGrid_ [Procedure Find_Last]

Find_Last - dbGrid_

Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_last finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of end_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbGrid_ [Procedure Find_Next]

Find_Next - dbGrid_

Performs a find greater than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_next performs a find greater than by the data_file and data_field of the current item, using request_find. Sent by kfind_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbGrid_ [Procedure Find_Previous]

Find_Previous - dbGrid_

Performs a find less than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_previous performs a find less than by the data_file and data_field of the current item, using request_find. Sent by kfind_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbGrid_ [Procedure Next]

Next - dbGrid_

Makes validation in validate_on_save_next mode occur regardless of the state of object_validation

Type: Procedure

Parameters: No Parameters

Description

The superclass definition of the Next message is augmented to make validation in validate_on_save_next mode occur regardless of the state of object_validation (a property inherited from the entry superclass).

Last Edited: September 10, 2003


dbGrid_ [Procedure Reorder_list]

Reorder_list - dbGrid_

Type: Procedure

Parameters: Integer iNewCol

Parameter | Description
iNewCol | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbGrid_ [Procedure Request_Clear]

Request_Clear - dbGrid_

Clears the current row of any changes entered to it

Type: Procedure

Parameters: No Parameters

Description

The Request_clear message clears the current row of any changes entered to it. If the cursor is on an active record, this message does nothing. If already in add mode, the current row is cleared, losing any changes that may have been entered (verify_data_loss is sent for confirmation). If this object has a server, the clear message is sent to it. This message is sent by the Clear key (kclear).

Last Edited: September 11, 2003


dbGrid_ [Procedure Request_Clear_All]

Request_Clear_All - dbGrid_

Clears list page, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear_all clears list page, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause the user to lose changes made to the text, verify_data_loss is used to confirm the action. If this object has a server, clear_all is requested of the server. This may result in other DEOs clearing, in addition to this object. Sent by kclear.

Last Edited: September 11, 2003


dbGrid_ [Procedure Request_Delete]

Request_Delete - dbGrid_

Determines if the current record of the server of the object is deleted

Type: Procedure

Parameters: No Parameters

Description

If batch_state is false, Request_delete deletes the current record of the server of this object, if any. Uses verify_delete to confirm the action. If batch_state is true, sends toggle_shadow. Otherwise, if server is non-zero, sends request_delete to server. If delete was successful, removes the current row from the list, regenerating the page if necessary. Sent by kdelete_record. Sends can_delete and acts only if true is returned.

Last Edited: September 11, 2003


dbGrid_ [Procedure Request_Find]

Request_Find - dbGrid_

Finds record using specified mode, by requesting item_find from server, if any

Type: Procedure

Parameters: integer mode integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true perform entry update before Find.

Description

Request_find finds record using specified mode, by requesting item_find from server, if any. Uses data_file and data_field of current item to determine file and field for find.

Last Edited: September 11, 2003


dbGrid_ [Procedure Request_Save]

Request_Save - dbGrid_

Saves changes to the current record

Type: Procedure

Parameters: No Parameters

Description

Request_Save saves changes to the current record. Uses validate_items to verify items, and verify_save to confirm user's action. This sends request_save to server, if any. This is sent by ksave_record.

Last Edited: August 19, 2004


dbGrid_ [Procedure Request_Save_No_Clear]

Request_Save_No_Clear - dbGrid_

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


dbGrid_ [Procedure Request_Superfind]

Request_Superfind - dbGrid_

Superfinds record using specified mode, by sending request_superfind to server, if any

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Request_superfind superfinds record using specified mode, by sending request_superfind to server, if any. Uses data_file and data_field of current item to determine file and field for find. Sends of request_superfind to a DataSet require Predefined Indicator err to be set to false beforehand, in case an error other than Find past end of file or Find prior to beginning of file is generated by the superfind. This is sent by DEOs.

Last Edited: September 11, 2003


dbGrid_ [Procedure Scroll]

Scroll - dbGrid_

Type: Procedure

Parameters: Integer eDirection Integer iNumLines

Parameter | Description
eDirection | [ToDo: In Progress]
iNumLines | [ToDo: In Progress]

Description

Last Edited: July 11, 2006


dbGrid_ [Procedure SuperFind]

SuperFind - dbGrid_

Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbGrid_ [Procedure SuperFind_Next]

SuperFind_Next - dbGrid_

Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_next performs a superfind greater than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbGrid_ [Procedure SuperFind_Previous]

SuperFind_Previous - dbGrid_

Performs a superfind less than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_previous performs a superfind less than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


Properties for dbGrid_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Bottom_add_State | Determines if additional rows may be added to the end of the grid |
Allow_Insert_Add_State | Determines if new rows may be inserted within the grid |
Allow_top_add_State | Determines if additional rows may be added to the top of the grid |
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_index_state | Determines how the popup lists will be ordered | DataList_
Auto_Regenerate_State | Controls the behavior of the object when add mode is exited, or when the object is initialized as it takes the focus |
Auto_Save_State | Determines if auto save should be performed |
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Batch_State | Determines how much data from the database is read into memory | DataList_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object |
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Child_Table_State | Determines if the entering message sends the child_entering message and the exiting message sends the child_exiting message |
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Button |  | DataList
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case | DataList
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox | DataList
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message | DataList
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message | DataList
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to | DataList
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to | DataList
Column_Option | Allows you to query or change the iOption option line for Column iCol | DataList
Column_Options | Allows you to copy column options or set them in a group | DataList
Column_Prompt_Object | Specifies the default receiving object for the popup message | DataList
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled | DataList
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message | DataList
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object | DataList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Record | (Obsolete) The number of the record of the current row | DataList_
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRecordStatus |  | DataList_
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowHasRecord |  | DataList_
CurrentRowId |  | DataList_
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
CustomScrollState | Determines changing scroll bar behaviors | DataList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | DataList
deo_delegate_mode | Controls those requests for which delegate_..._state is set true |
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Init_from_Top_State | Determines in what order images are displayed | DataList_
Initial_Column | Determines where the cursor is located when the list is activated | DataList_
Initial_Row | Governs the location in the display of the record (if any) in the buffer | DataList_
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_File | Holds the file number of the main file of the list | DataList_
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
No_Create_State | Controls whether or not this object can create records |
No_Delete_State | Controls whether this object can delete records |
No_Relate_State | Determines if relates occur with lists that do not use DDOs | DataList_
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Ordering | Holds the index of the main file to be used to display the database records of the main file | DataList_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls | DataList
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction | DataList
pbReverseOrdering | Determines if the list should be displayed in reverse index order | DataList_
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object | Returns the object-id of the internal object | DataList_
psEmbeddedButtonValue |  | DataList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object | DataList_
Record_Number | (Obsolete) Indicates the record number for the record in the specified row | DataList_
record_rowId |  | DataList_
RecordStatus |  | DataList_
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
RowHasRecord |  | DataList_
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released | DataList
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Gets and returns the value of the row_changed function |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Static_State | Determines if the list will only be initialized once the first time this object is activated | DataList_
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior | DataList
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated |
Validate_Mode | Determines how and when object validation occurs |
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Verify_Save_Msg | Specifies the message to use for save confirmation |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbGrid_ [Property Allow_Bottom_add_State]

Allow_Bottom_add_State - dbGrid_

Determines if additional rows may be added to the end of the grid

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Allow_bottom_add_state property is true, and no_create_state is false, pressing down arrow from the bottom existing row of the grid opens a new row beneath it for data entry. If it is false, additional rows may not be added to the end of the grid.

Default is true.

Last Edited: January 12, 2006


dbGrid_ [Property Allow_Insert_Add_State]

Allow_Insert_Add_State - dbGrid_

Determines if new rows may be inserted within the grid

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Allow_insert_add_state property is true and no_create_state is false, new rows may be inserted in the grid in data entry. If it is false, additional rows may not be added within the grid.

Default is true.

Last Edited: January 12, 2006


dbGrid_ [Property Allow_top_add_State]

Allow_top_add_State - dbGrid_

Determines if additional rows may be added to the top of the grid

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Allow_top_add_state property is true and no_create_state is false, pressing up arrow in the top existing row of the grid opens up a new row above it for data entry. If it is false, additional rows may not be added to the top of the grid.

Default is false.

Last Edited: January 12, 2006


dbGrid_ [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - dbGrid_

If true, this object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


dbGrid_ [Property Auto_Regenerate_State]

Auto_Regenerate_State - dbGrid_

Controls the behavior of the object when add mode is exited, or when the object is initialized as it takes the focus

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Auto_regenerate_state property controls the behavior of the object when add mode is exited, or when the object is initialized as it takes the focus. With the default setting (true), if the grid has become unsorted (because new records were added in no particular order), the grid will automatically regenerate the display for the object by sending the regenerate message. If this property is set to false, the grid will not automatically regenerate when the grid is unsorted. In this case, the object may display the same record more than once. However, this does not indicate the database is corrupt; only that the display is incorrect.

Default is true.

Last Edited: January 12, 2006


dbGrid_ [Property Auto_Save_State]

Auto_Save_State - dbGrid_

Determines if auto save should be performed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_save_state property is true, rotation from the last object within this object to the first object within this object will cause this object to save. Intended to be set.

Default is false.

Last Edited: January 12, 2006


dbGrid_ [Property Changed_Value]

Changed_Value - dbGrid_

Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object

Type: Property

Access: Write-Only

Data Type: String

Parameters: integer Item# String Val

Parameter | Description
Item# | The item number
Val | The value of the item

Description

The Changed_value message merely changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object.

Last Edited: July 22, 2003


dbGrid_ [Property Child_Table_State]

Child_Table_State - dbGrid_

Determines if the entering message sends the child_entering message and the exiting message sends the child_exiting message

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Child_table_state property is true, the entering message sends the child_entering message and the exiting message sends the child_exiting message. These additional messages are provided for tables that are children of parent (header) tables.

Default is false.

Last Edited: January 12, 2006


dbGrid_ [Property Default_Value]

Default_Value - dbGrid_

Changes the value property of Item item# to value, but leaves its item_changed_state unchanged

Type: Property

Access: Write-Only

Data Type: String

Parameters: integer Item# String Val

Parameter | Description
Item# | The item number
Val | The value of the item

Description

The Default_value message changes the value property of Item item# to value, but leaves its item_changed_state unchanged. This is the message for setting default values.

Last Edited: July 31, 2003


dbGrid_ [Property deo_delegate_mode]

deo_delegate_mode - dbGrid_

Controls those requests for which delegate_..._state is set true

Type: Property

Access: Read/Write

Data Type: Integer

Description

Deo_delegate_mode controls those requests for which delegate_..._state is set true. The default delegate_server mode delegates request messages for objects that are not explicitly using a DDO. Delegate_always delegates regardless of whether a server is declared for the object, and delegate_never never delegates. This behavior may be set globally rather than just for this object by setting a function named default_deo_delegate_mode, and may also be queried with get.

Default is delegate_server.

Last Edited: July 31, 2003


dbGrid_ [Property No_Create_State]

No_Create_State - dbGrid_

Controls whether or not this object can create records

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The No_create_state property controls whether or not this object can create records. If true, any attempt to initiate a clear operation or save operation on a new record will be ignored. However, clear and save operations in other objects that result in a clear or save in this object's server will not be inhibited. As an example, selection_list objects typically set this true as they are not designed for editing records, only selecting them, while grid objects typically set this property to false to allow full data entry.

Default is true.

In dbGrid class, default is false.

Last Edited: January 12, 2006


dbGrid_ [Property No_Delete_State]

No_Delete_State - dbGrid_

Controls whether this object can delete records

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The No_delete_state property controls whether this object can delete records. If it is true, any attempt to initiate a delete operation will be ignored. However, delete operations in other objects that result in a delete in this object's main file will not be inhibited.

Default is false.

Last Edited: January 12, 2006


dbGrid_ [Property Retain_no_Change_state]

Retain_no_Change_state - dbGrid_

Determines if the item_changed_state of items have true or false values

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The default for the Retain_no_change_state property true keeps the item_changed_state of items receiving default values false until and unless they are explicitly changed. If your program needs the item_changed_state of such items to be true, you can provide such behavior by setting this property false.

Default is true.

Last Edited: January 12, 2006


dbGrid_ [Property Should_Save]

Should_Save - dbGrid_

Gets and returns the value of the row_changed function

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property gets and returns the value of the Row_Changed function.

Last Edited: September 6, 2005


dbGrid_ [Property Validate_All_Items_State]

Validate_All_Items_State - dbGrid_

Determines if all items are being validated

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Validate_all_items_state property is set true when all items are validated in one process, as in a save. It is reset false when one or some other subset of all the items are validated, as in navigation between items.

Default is false.

Last Edited: January 12, 2006


dbGrid_ [Property Validate_Mode]

Validate_Mode - dbGrid_

Determines how and when object validation occurs

Type: Property

Access: Read/Write

Data Type: Integer

Description

The validate_mode property determines how and when object validation occurs.

Default is VALIDATE_ON_SAVE_NEXT.

Valid modes are:

Mode | Description
VALIDATE_DEFAULT | Obsolete (character-mode only)
VALIDATE_ON_SAVE | Validates are only sent during a save
VALIDATE_ON_SAVE_NEXT | Validates are sent during a save and forward keyboard navigation

Last Edited: August 12, 2005


dbGrid_ [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - dbGrid_

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


dbGrid_ [Property Verify_Delete_Msg]

Verify_Delete_Msg - dbGrid_

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


dbGrid_ [Property Verify_Save_Msg]

Verify_Save_Msg - dbGrid_

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


Events for dbGridDD

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Child_Entering | Provided to permit programming of required grid actions when this object is a child of a header grid object | dbGrid_
Child_Exiting | Event that is sent when a child table is about to be exited | dbGrid_
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | Augmented to call child_entering if this object's child_table_state is true | dbGrid_
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbGrid_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click |  | dbGridDS
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items | WideList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view | DataList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin |  | DataList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnNewOrdering | Called whenever the ordering is changed | DataList_
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DataList_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbGridDD

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
add_new_row | Procedure | Inserts a blank row into the grid if the cursor is not already in a new row | dbGrid_
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list | DataList_
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful | dbGrid_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbGrid_
Clear_Current_Record | Procedure |  | DataList_
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Col_Index | Function | Returns the number of the main index for the field connected to Column Item# | DataList_
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | dbGridDS
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Display | Procedure |  | DataList_
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoCheckDisplayableRows | Procedure |  | DataList_
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm | DataList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList | DataList_
DoToggleColumnOrdering | Procedure |  | DataList_
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Augmented to respect the value of the allow_row_change property | dbGrid_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
Establish_Find_Mode | Procedure |  | DataList_
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
File_Record | Function | (Obsolete) | DataList_
FileRecord | Function |  | DataList_
FileRowId | Function |  | DataList_
Fill_List | Procedure |  | DataList_
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer | DataList_
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbGrid_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbGrid_
Find_Init | Procedure |  | DataList_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbGrid_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbGrid_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbGrid_
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object | DataList_
find_RowId | Procedure |  | DataList_
Goto_Bottom_Row | Procedure |  | DataList_
Goto_Top_Row | Procedure |  | DataList_
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in | DataList_
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbGrid_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Read_By_Recnum | Procedure | (Obsolete) | DataList_
Read_Next_Record | Procedure |  | DataList_
ReadByRowId | Procedure |  | DataList_
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col# | DataList_
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Reorder_list | Procedure |  | dbGrid_
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Clear | Procedure | Clears the current row of any changes entered to it | dbGrid_
Request_Clear_All | Procedure | Clears list page, and changes focus to first object or item in panel if auto_top_panel_state is true | dbGrid_
Request_Delete | Procedure | Determines if the current record of the server of the object is deleted | dbGrid_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any | dbGrid_
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column | DataList_
Request_Save | Procedure | Saves changes to the current record | dbGrid_
Request_Save_No_Clear | Procedure |  | dbGrid_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Request_Superfind | Procedure | Superfinds record using specified mode, by sending request_superfind to server, if any | dbGrid_
Row_save | Function | Sent by request_save to save the current record in the server file | dbGrid_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure |  | dbGrid_
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbGrid_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbGrid_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbGrid_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure |  | DataList_
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbGrid_
Validate_Prompt | Function | (Obsolete) | WideList
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbGrid_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbGrid_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbGrid_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


Properties for dbGridDD

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Bottom_add_State | Determines if additional rows may be added to the end of the grid | dbGrid_
Allow_Insert_Add_State | Determines if new rows may be inserted within the grid | dbGrid_
Allow_top_add_State | Determines if additional rows may be added to the top of the grid | dbGrid_
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbGrid_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_index_state | Determines how the popup lists will be ordered | DataList_
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object |
Auto_Regenerate_State | Controls the behavior of the object when add mode is exited, or when the object is initialized as it takes the focus | dbGrid_
Auto_Save_State | Determines if auto save should be performed | dbGrid_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Batch_State | Determines how much data from the database is read into memory | DataList_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbGrid_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Child_Table_State | Determines if the entering message sends the child_entering message and the exiting message sends the child_exiting message | dbGrid_
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Button |  | DataList
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case | DataList
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox | DataList
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message | DataList
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message | DataList
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to | DataList
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to | DataList
Column_Option | Allows you to query or change the iOption option line for Column iCol | DataList
Column_Options | Allows you to copy column options or set them in a group | DataList
Column_Prompt_Object | Specifies the default receiving object for the popup message | DataList
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled | DataList
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message | DataList
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object | DataList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Record | (Obsolete) The number of the record of the current row | DataList_
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRecordStatus |  | DataList_
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowHasRecord |  | DataList_
CurrentRowId |  | DataList_
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
CustomScrollState | Determines changing scroll bar behaviors | DataList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | dbGrid_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | DataList
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbGrid_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Export_Code_Description_State | Determines if the next item will be used to display a code description |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Init_from_Top_State | Determines in what order images are displayed | DataList_
Initial_Column | Determines where the cursor is located when the list is activated | DataList_
Initial_Row | Governs the location in the display of the record (if any) in the buffer | DataList_
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_File | Holds the file number of the main file of the list | DataList_
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
No_Create_State | Controls whether or not this object can create records | dbGrid_
No_Delete_State | Controls whether this object can delete records | dbGrid_
No_Relate_State | Determines if relates occur with lists that do not use DDOs | DataList_
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Ordering | Holds the index of the main file to be used to display the database records of the main file | DataList_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls | DataList
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction | DataList
pbReverseOrdering | Determines if the list should be displayed in reverse index order | DataList_
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines if prompt_button_value will be displayed to the right of column labels | dbGridDS
Prompt_Button_Value | Specifies the character(s) to be appended to a column-header label to indicate that it supports prompting | dbGridDS
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object | Returns the object-id of the internal object | DataList_
psEmbeddedButtonValue |  | DataList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object | DataList_
Record_Number | (Obsolete) Indicates the record number for the record in the specified row | DataList_
record_rowId |  | DataList_
RecordStatus |  | DataList_
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbGrid_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
RowHasRecord |  | DataList_
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released | DataList
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Gets and returns the value of the row_changed function | dbGrid_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Static_State | Determines if the list will only be initialized once the first time this object is activated | DataList_
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior | DataList
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbGrid_
Validate_Mode | Determines how and when object validation occurs | dbGrid_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbGrid_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbGrid_
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbGrid_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbGridDD [Property Auto_Label_State]

Auto_Label_State - dbGridDD

Determines if this object will draw label values from the DDO rather than from any label that may be set in this object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_label_state property is set true, this object will draw label values from the DDO rather than from any label that may be set in this object.

When used within single-item objects (forms and edits), the object uses the field's long label name.

When used within multi-item objects (grids), the object uses the field's short label name.

Default is false.

Last Edited: January 12, 2006


dbGridDD [Property Export_Code_Description_State]

Export_Code_Description_State - dbGridDD

Determines if the next item will be used to display a code description

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iState

Parameter | Description
iItem | The item number
iState | When true, the next item will be used to display this item's code description

Description

When the Export_code_description_state property is set true for an item attached through a DataDictionary to a code list that includes a field for the descriptions of the codes, those descriptions can be displayed in the validation prompt object by use of an additional entry_item statement addressed to the code_description function of the prompt object, as follows:

entry_item orderhea.code
set export_code_description_state item current to true
entry_item (code_description(self))

Default is false.

Last Edited: August 5, 2003


dbGridDS [Event Header_Mouse_Click]

Header_Mouse_Click - dbGridDS

Type: Event

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Events for dbGridDS

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Child_Entering | Provided to permit programming of required grid actions when this object is a child of a header grid object | dbGrid_
Child_Exiting | Event that is sent when a child table is about to be exited | dbGrid_
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | Augmented to call child_entering if this object's child_table_state is true | dbGrid_
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbGrid_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click |  |
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items | WideList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view | DataList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin |  | DataList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnNewOrdering | Called whenever the ordering is changed | DataList_
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DataList_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbGridDS

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
add_new_row | Procedure | Inserts a blank row into the grid if the cursor is not already in a new row | dbGrid_
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list | DataList_
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful | dbGrid_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbGrid_
Clear_Current_Record | Procedure |  | DataList_
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Col_Index | Function | Returns the number of the main index for the field connected to Column Item# | DataList_
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button |
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Display | Procedure |  | DataList_
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoCheckDisplayableRows | Procedure |  | DataList_
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm | DataList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList | DataList_
DoToggleColumnOrdering | Procedure |  | DataList_
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Augmented to respect the value of the allow_row_change property | dbGrid_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
Establish_Find_Mode | Procedure |  | DataList_
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
File_Record | Function | (Obsolete) | DataList_
FileRecord | Function |  | DataList_
FileRowId | Function |  | DataList_
Fill_List | Procedure |  | DataList_
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer | DataList_
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbGrid_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbGrid_
Find_Init | Procedure |  | DataList_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbGrid_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbGrid_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbGrid_
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object | DataList_
find_RowId | Procedure |  | DataList_
Goto_Bottom_Row | Procedure |  | DataList_
Goto_Top_Row | Procedure |  | DataList_
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in | DataList_
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbGrid_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Read_By_Recnum | Procedure | (Obsolete) | DataList_
Read_Next_Record | Procedure |  | DataList_
ReadByRowId | Procedure |  | DataList_
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col# | DataList_
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Reorder_list | Procedure |  | dbGrid_
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Clear | Procedure | Clears the current row of any changes entered to it | dbGrid_
Request_Clear_All | Procedure | Clears list page, and changes focus to first object or item in panel if auto_top_panel_state is true | dbGrid_
Request_Delete | Procedure | Determines if the current record of the server of the object is deleted | dbGrid_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any | dbGrid_
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column | DataList_
Request_Save | Procedure | Saves changes to the current record | dbGrid_
Request_Save_No_Clear | Procedure |  | dbGrid_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Request_Superfind | Procedure | Superfinds record using specified mode, by sending request_superfind to server, if any | dbGrid_
Row_save | Function | Sent by request_save to save the current record in the server file | dbGrid_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure |  | dbGrid_
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbGrid_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbGrid_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbGrid_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure |  | DataList_
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbGrid_
Validate_Prompt | Function | (Obsolete) | WideList
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbGrid_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbGrid_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbGrid_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


dbGridDS [Procedure Create_Prompt_Button]

Create_Prompt_Button - dbGridDS

Creates or removes a prompt button

Type: Procedure

Parameters: Integer CreateMode

Parameter Description
CreateModethe following modes are supported

Constant | Meaning
PB_promptOn | the button is created
PB_promptOff | the button is removed
PB_promptAuto | the button is created if a prompt object exists (prompt_object_id is non-zero)

Description

Create_Prompt_Button is used internally to create or remove a prompt button. When CreateMode is PB_promptOn, the button is created. When CreateMode is PB_promptOff, the button is removed. When CreateMode is PB_promptAuto, the button is created if a prompt object exists (prompt_object_id is non-zero). There should be no need to send or augment this message. You should be able to control prompt buttons with the prompt_button_mode property.

Last Edited: August 5, 2003


Properties for dbGridDS

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Allow_Bottom_add_State | Determines if additional rows may be added to the end of the grid | dbGrid_
Allow_Insert_Add_State | Determines if new rows may be inserted within the grid | dbGrid_
Allow_top_add_State | Determines if additional rows may be added to the top of the grid | dbGrid_
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbGrid_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_index_state | Determines how the popup lists will be ordered | DataList_
Auto_Regenerate_State | Controls the behavior of the object when add mode is exited, or when the object is initialized as it takes the focus | dbGrid_
Auto_Save_State | Determines if auto save should be performed | dbGrid_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Batch_State | Determines how much data from the database is read into memory | DataList_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbGrid_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Child_Table_State | Determines if the entering message sends the child_entering message and the exiting message sends the child_exiting message | dbGrid_
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Button |  | DataList
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case | DataList
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox | DataList
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message | DataList
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message | DataList
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to | DataList
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to | DataList
Column_Option | Allows you to query or change the iOption option line for Column iCol | DataList
Column_Options | Allows you to copy column options or set them in a group | DataList
Column_Prompt_Object | Specifies the default receiving object for the popup message | DataList
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled | DataList
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message | DataList
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object | DataList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Record | (Obsolete) The number of the record of the current row | DataList_
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRecordStatus |  | DataList_
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowHasRecord |  | DataList_
CurrentRowId |  | DataList_
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
CustomScrollState | Determines changing scroll bar behaviors | DataList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | dbGrid_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | DataList
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbGrid_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Init_from_Top_State | Determines in what order images are displayed | DataList_
Initial_Column | Determines where the cursor is located when the list is activated | DataList_
Initial_Row | Governs the location in the display of the record (if any) in the buffer | DataList_
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_File | Holds the file number of the main file of the list | DataList_
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
No_Create_State | Controls whether or not this object can create records | dbGrid_
No_Delete_State | Controls whether this object can delete records | dbGrid_
No_Relate_State | Determines if relates occur with lists that do not use DDOs | DataList_
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Ordering | Holds the index of the main file to be used to display the database records of the main file | DataList_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls | DataList
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction | DataList
pbReverseOrdering | Determines if the list should be displayed in reverse index order | DataList_
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines if prompt_button_value will be displayed to the right of column labels |
Prompt_Button_Value | Specifies the character(s) to be appended to a column-header label to indicate that it supports prompting |
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object | Returns the object-id of the internal object | DataList_
psEmbeddedButtonValue |  | DataList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object | DataList_
Record_Number | (Obsolete) Indicates the record number for the record in the specified row | DataList_
record_rowId |  | DataList_
RecordStatus |  | DataList_
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbGrid_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
RowHasRecord |  | DataList_
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released | DataList
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Gets and returns the value of the row_changed function | dbGrid_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Static_State | Determines if the list will only be initialized once the first time this object is activated | DataList_
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior | DataList
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbGrid_
Validate_Mode | Determines how and when object validation occurs | dbGrid_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbGrid_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbGrid_
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbGrid_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbGridDS [Property Prompt_Button_Mode]

Prompt_Button_Mode - dbGridDS

Determines if prompt_button_value will be displayed to the right of column labels

Type: Property

Access: Read/Write

Data Type: Integer

Description

The default value of the Prompt_button_mode property inherited from the superclass is changed to PB_promptAuto, which displays the prompt_button_value to the right of column labels. Changing this to PB_promptOff would disable this display for all columns.

Constant | Meaning
PB_PromptOff | The prompt button object is not displayed.
PB_PromptOn | The prompt button object is displayed and the message prompt is sent when the button is pressed.
PB_PromptAuto | The prompt button object is displayed automatically if a prompt object exists. This is determined at run time. If the prompt_object property is non-zero, a prompt button is displayed. This is the default value for the dbForm class.

Default is PB_PromptAuto.

Note: This property replaces the obsolete property Auto_Create_Prompt_Button.

Last Edited: August 16, 2004


dbGridDS [Property Prompt_Button_Value]

Prompt_Button_Value - dbGridDS

Specifies the character(s) to be appended to a column-header label to indicate that it supports prompting

Type: Property

Access: Read/Write

Data Type: String

Description

Prompt_Button_Value specifies the character(s) to be appended to a column-header label to indicate that it supports prompting. The two right darts are the default value.

Default is ">>".

Last Edited: August 16, 2004


Events for dbGroup

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Group
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Group
OnSetFocus | Sent whenever windows is about to give this object the focus | Group
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Group
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Group


Methods for dbGroup

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Group
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Group
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Group
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Group
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Group
Error_Help | Procedure | (Obsolete) | Group
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbGroup_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Group
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Group
Help | Procedure |  | Group
Help_For_Help | Procedure | (Obsolete) | Group
Help_Index | Procedure | (Obsolete) | Group
Help_on_topic | Procedure | (Obsolete) | Group
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Group
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Group
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Group
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbGroup_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbGroup_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbGroup_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbGroup_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbGroup_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbGroup_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbGroup_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Group
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbGroup_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Group
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbGroup_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbGroup_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbGroup_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbGroup_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


dbGroup [Procedure Close_Panel]

Close_Panel - dbGroup

Closes the panel or component currently open

Type: Procedure

Parameters: No Parameters

Description

Closes the panel or component currently open. If the control Close_Panel is sent to is not a panel, the call will be delegated to it's parent.

For example, if a cDbRichEdit control is in a dbView, sending Close_Panel to the cDbRichEdit control will close the dbView.

Sample

This sample causes the dbView control oDbView1 to close when button oCloseButton is clicked.

Object oDbView1 is a dbView
    :
    Object oDbRichEdit1 is a cDbRichEdit
        :
    End_Object  // oDbRichEdit1
    :
    Object oCloseButton is a Button
        :
        Procedure OnClick
            send Close_Panel of oDbRichEdit1
        End_Procedure  // OnClick
        :
    End_Object  // oCloseButton
    :
End_Object  // oDbView1

Last Edited: November 24, 2004


Properties for dbGroup

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbGroup_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbGroup_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Group
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbGroup_
Bitmap | Displays a bitmap in an object | Group
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Changed_State | Determines if one or more of the child objects has changed | dbGroup_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Group
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbGroup_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbGroup_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Group
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Group
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Group
Help_Keyword | Used to specify an object's context keyword | Group
Item_Shadow_State | Determines if an object's item is enabled or disabled | Group
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Group
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Group
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Group
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Group
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Group
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Group
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbGroup_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbGroup_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Group
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Group
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbGroup_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbGroup_
verify_exit_msg | Determines what message is sent during an exiting event | dbGroup_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbGroup_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Events for dbGroup_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Group
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Group
OnSetFocus | Sent whenever windows is about to give this object the focus | Group
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Group
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Group


dbGroup_ [Function Verify_Data_Loss]

Verify_Data_Loss - dbGroup_

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


dbGroup_ [Function Verify_Delete]

Verify_Delete - dbGroup_

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


dbGroup_ [Function verify_Exit]

verify_Exit - dbGroup_

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


dbGroup_ [Function Verify_Save]

Verify_Save - dbGroup_

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for dbGroup_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Group
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Group
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Group
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Group
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Group
Error_Help | Procedure | (Obsolete) | Group
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Group
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Group
Help | Procedure |  | Group
Help_For_Help | Procedure | (Obsolete) | Group
Help_Index | Procedure | (Obsolete) | Group
Help_on_topic | Procedure | (Obsolete) | Group
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Group
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Group
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Group
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index |
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO |
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Group
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Group
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


dbGroup_ [Procedure Exit_Function]

Exit_Function - dbGroup_

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


dbGroup_ [Procedure Request_Cancel]

Request_Cancel - dbGroup_

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


dbGroup_ [Procedure Request_Clear]

Request_Clear - dbGroup_

Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause the user to lose changes made to the text, verify_data_loss is used to confirm the action. Clear is requested of the DSO. This may result in other DEOs clearing, in addition to the DEOs connected to that DSO. Sent (via delegation) by DEOs within the container.

Last Edited: September 11, 2003


dbGroup_ [Procedure Request_Clear_All]

Request_Clear_All - dbGroup_

Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear_all clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause a user to lose changes made to the text, verify_data_loss is used to confirm the action. Clear_all is requested of the DSO. This may result in other DEOs clearing, in addition to the DEOs connected to that DSO.

Last Edited: September 11, 2003


dbGroup_ [Procedure Request_Delete]

Request_Delete - dbGroup_

Deletes current record in main_file of the server DSO, if any, else issues an error

Type: Procedure

Parameters: No Parameters

Description

Request_delete deletes current record in main_file of the server DSO, if any, else issues an error. Sent by DEOs attached to the data set. Note that deletion of the current main_file record may cause sets of records in container DSOs to be deleted, i.e., those records that relate to the DSO's current record. Sends can_delete and acts only if that returns true.

Last Edited: September 11, 2003


dbGroup_ [Procedure Request_Find]

Request_Find - dbGroup_

Finds on specified file using given find_mode and index

Type: Procedure

Parameters: Integer mode Integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true, perform entry_update before find

Description

Request_find finds on specified file using given find_mode and index. If find is successful, performs a relate on file. If file is the same as the DSO's main_file, sends relate_main_file. Notifies other connected DSOs of the result of the find. Mode may be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either next_record, first_record, or last_record. Sets the found indicator to reflect the success or failure of the find operation. Sent by DEOs and item_find.

Last Edited: July 11, 2006


dbGroup_ [Procedure Request_Save]

Request_Save - dbGroup_

Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO

Type: Procedure

Parameters: No Parameters

Description

Request_Save saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO (directly or indirectly). Sent by DEOs attached to the DSO.

Last Edited: August 19, 2004


dbGroup_ [Procedure Request_Save_No_Clear]

Request_Save_No_Clear - dbGroup_

Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state

Type: Procedure

Parameters: No Parameters

Description

Request_save_no_clears saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state.

Last Edited: September 11, 2003


dbGroup_ [Procedure Request_Superfind]

Request_Superfind - dbGroup_

Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Request_superfind performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result. Find_mode may be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either next_record, first_record, or last_record. Sets the found indicator to reflect the success or failure of the find operation. Sends of request_superfind to a DSO require Predefined Indicator err to be set to false beforehand, in case an error other than Find past end of file or Find prior to beginning of file is generated by the superfind. Sent by DEOs.

Last Edited: September 11, 2003


Properties for dbGroup_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Group
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Bitmap | Displays a bitmap in an object | Group
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Changed_State | Determines if one or more of the child objects has changed |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Group
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Group
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Group
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Group
Help_Keyword | Used to specify an object's context keyword | Group
Item_Shadow_State | Determines if an object's item is enabled or disabled | Group
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Group
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Group
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Group
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Group
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Group
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Group
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object |
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Group
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Group
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event |
Verify_Save_Msg | Specifies the message to use for save confirmation |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbGroup_ [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - dbGroup_

Determines if object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


dbGroup_ [Property Auto_Fill_State]

Auto_Fill_State - dbGroup_

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


dbGroup_ [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - dbGroup_

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


dbGroup_ [Property Changed_State]

Changed_State - dbGroup_

Determines if one or more of the child objects has changed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If this flag is true, one or more of the child objects has changed. Augmented to set changed_state of server to true when changed_state of this object is set to true. Also augmented to detach this object from its server when set to false while this object is inactive.

This object will not save when this state is false. When necessary (as when changes are made other than through the keyboard), set this state to true explicitly.

Default is false.

Last Edited: January 12, 2006


dbGroup_ [Property Deferred_State]

Deferred_State - dbGroup_

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


dbGroup_ [Property deo_delegate_mode]

deo_delegate_mode - dbGroup_

Controls those requests for which delegate_..._state is set true

Type: Property

Access: Read/Write

Data Type: Integer

Description

Deo_delegate_mode controls those requests for which delegate_..._state is set true. The default delegate_server mode delegates request messages for objects that are not explicitly using a DDO. Delegate_always delegates regardless of whether a server is declared for the object, and delegate_never never delegates. This behavior may be set globally rather than just for this object by setting a function named default_deo_delegate_mode, and may also be queried with get.

Default is delegate_server.

Last Edited: July 31, 2003


dbGroup_ [Property Server]

Server - dbGroup_

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


dbGroup_ [Property Should_Save]

Should_Save - dbGroup_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


dbGroup_ [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - dbGroup_

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


dbGroup_ [Property Verify_Delete_Msg]

Verify_Delete_Msg - dbGroup_

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


dbGroup_ [Property verify_exit_msg]

verify_exit_msg - dbGroup_

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


dbGroup_ [Property Verify_Save_Msg]

Verify_Save_Msg - dbGroup_

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


Events for dbList

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Export_Item | Sets the value of the item from which this object was invoked to the value in the selected row of this object that is in the column indicated by the value of the export_column property | dbList_
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click |  | DataList
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items | WideList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view | DataList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin |  | DataList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnNewOrdering | Called whenever the ordering is changed | DataList_
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DataList_
Restore_Defaults | Restores the previous values of the properties listed below after they have been stored before this object was popped up with the prompt_callback message and then deactivated | dbList_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Store_Defaults | Stores the existing values of the properties listed below so that they can be restored after this object is popped up with the prompt_callback message and then deactivated | dbList_
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbList

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list | DataList_
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful | DataList_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Deactivates this object and its scope, if any | dbList_
Clear_Current_Record | Procedure |  | DataList_
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Col_Index | Function | Returns the number of the main index for the field connected to Column Item# | DataList_
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Display | Procedure |  | DataList_
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoCheckDisplayableRows | Procedure |  | DataList_
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm | DataList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList | DataList_
DoToggleColumnOrdering | Procedure |  | DataList_
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Finds the last record in the main_file of this object, and displays a new list page ending with that record if the find was successful | DataList_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
Establish_Find_Mode | Procedure |  | DataList_
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
File_Record | Function | (Obsolete) | DataList_
FileRecord | Function |  | DataList_
FileRowId | Function |  | DataList_
Fill_List | Procedure |  | DataList_
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer | DataList_
Find_Init | Procedure |  | DataList_
Find_or_Ok | Procedure | Determines whether the value in the item window has been changed, or remains as retrieved from the database | dbList_
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object | DataList_
find_RowId | Procedure |  | DataList_
first_selected_item | Function | Returns the first selected item | dbList_
FirstSelectedRowId | Function | Returns the first selected RowId | dbList_
Goto_Bottom_Row | Procedure |  | DataList_
Goto_Top_Row | Procedure |  | DataList_
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Init_Selected_Item | Procedure | Sets enumeration_counter to zero | dbList_
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in | DataList_
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
next_selected_Item | Function | Returns the next selected item | dbList_
NextSelectedRowId | Function | Returns the next selected RowId | dbList_
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Oks a list selection | dbList_
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Read_By_Recnum | Procedure | (Obsolete) | DataList_
Read_Next_Record | Procedure |  | DataList_
ReadByRowId | Procedure |  | DataList_
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col# | DataList_
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Reorder_list | Procedure | Permits manual reordering of the contents of the data list | DataList_
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any | dbList_
Request_Lookup | Procedure | Enables you to program special finding behaviors for items for which you desire such | dbList_
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column | DataList_
Request_Search | Procedure | Scrolls the search list to display the database value found for the search string entered up to that point | dbListDS
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines | EntryList
Select_All | Procedure |  | DfBaseForm
Select_Best_Column | Function | Returns the number of the column of this object that is best for the file_number and field_number of the invoking-object item | dbList_
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Toggle_Select | Procedure | Sets select_state of current item to toggle_state, i.e., sets select_state of current item to true if it is currently false, and vice-versa | dbList_
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure |  | DataList_
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Validate_Prompt | Function | (Obsolete) | WideList
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


Properties for dbList

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Column_State | Determines if the cursor is automatically located upon activation in the column for the main-file field in the popup selection list | dbList_
Auto_Export_State | Determines if the invoking item should be updated relationally or non-relationally | dbList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_index_state | Determines how the popup lists will be ordered | DataList_
Auto_Label_State | Determines if the column is assigned a header label from the data dictionary |
Auto_Save_State | Returns zero to other DEOs, which send this message to this object | dbList_
Auto_Server_State | Determines if the object will use the constraints in the invoking object's server DDO or its own DDO | dbList_
Auto_Shadow_State | Determines if columns whose data file and field are not part of an index will be set to display-only or if they will be shadowed explicitly |
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Batch_State | Determines how much data from the database is read into memory | DataList_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Button |  | DataList
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case | DataList
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox | DataList
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message | DataList
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message | DataList
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to | DataList
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to | DataList
Column_Option | Allows you to query or change the iOption option line for Column iCol | DataList
Column_Options | Allows you to copy column options or set them in a group | DataList
Column_Prompt_Object | Specifies the default receiving object for the popup message | DataList
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled | DataList
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message | DataList
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object | DataList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Record | (Obsolete) The number of the record of the current row | DataList_
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRecordStatus |  | DataList_
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowHasRecord |  | DataList_
CurrentRowId |  | DataList_
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
CustomScrollState | Determines changing scroll bar behaviors | DataList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | DataList
Display_Buffer_Msg | Handle of an optional message that can be sent to the invoking object when a selection is complete | dbList_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Export_Column | Determines which column's value is returned to invoking object | dbList_
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational | dbList_
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Find_Search_State | Determines how list searching is performed | dbList_
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Init_from_Top_State | Determines in what order images are displayed | DataList_
Initial_Column | Determines where the cursor is located when the list is activated | DataList_
Initial_Row | Governs the location in the display of the record (if any) in the buffer | DataList_
Invoking_Object_ID | Identifies the object which activated this object | dbList_
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Load_Buffer_Msg | Handle of optional message sent to invoking object during list activation | dbList_
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_File | Holds the file number of the main file of the list | DataList_
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent | dbList_
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
No_Relate_State | Determines if relates occur with lists that do not use DDOs | DataList_
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Ordering | Holds the index of the main file to be used to display the database records of the main file | DataList_
Original_RowId |  | dbList_
Original_Selection | Identifies the item that was selected when this object was originally activated | dbList_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls | DataList
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction | DataList
pbReverseOrdering | Determines if the list should be displayed in reverse index order | DataList_
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_Search_State | Determines if pressing a key will cause the search pop-up dialog to appear | dbListDS
Popup_State | (Obsolete) | dbList_
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object | Returns the object-id of the internal object | DataList_
psEmbeddedButtonValue |  | DataList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object | DataList_
Record_Number | (Obsolete) Indicates the record number for the record in the specified row | DataList_
record_rowId |  | DataList_
RecordStatus |  | DataList_
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
RowHasRecord |  | DataList_
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released | DataList
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Seed_List_State | Determines if the seed_list message is sent when this object is activated causing the display of list items to scroll automatically | dbList_
Select_Count | Returns the value of the select_count of this object | dbList_
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | WideList_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Static_State | Determines if the list will only be initialized once the first time this object is activated | DataList_
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior | DataList
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbList [Property Auto_Label_State]

Auto_Label_State - dbList

Determines if the column is assigned a header label from the data dictionary

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_label_state property is true and the object is using a data dictionary, the column is assigned a header label from the data dictionary. When assigned from the data dictionary, a column's label will be assigned the field_label_short description from the appropriate DD field. If the short label is blank, the field_label_long is used. If the long label is blank, the field's tag name is used. This assignment occurs at compile time and not at run time. If a field's label is changed within a data dictionary, any program using its label (or any other DD attribute) must be recompiled.

Default is false.

Last Edited: January 12, 2006


dbList [Property Auto_Shadow_State]

Auto_Shadow_State - dbList

Determines if columns whose data file and field are not part of an index will be set to display-only or if they will be shadowed explicitly

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_shadow_state property is true, all columns whose data file and field are not part of an index will be set to display-only. There is no point in attempting to search on a field that is not indexed. If it is false, columns must be shadowed explicitly. Note that data dictionaries, if used, will also determine if a column should be shadowed. The effects of shadowing with auto_shadow_state and through a DD are additive.

Default is true.

Last Edited: January 12, 2006


dbList_ [Event Export_Item]

Export_Item - dbList_

Sets the value of the item from which this object was invoked to the value in the selected row of this object that is in the column indicated by the value of the export_column property

Type: Event

Parameters: Integer Item# Integer Rec#

Parameter | Description
Item# | The item number
Rec# | The record number

Description

When export_item_state is true, Export_item sets the value of the item from which this object was invoked to the value in the selected row of this object that is in the column indicated by the value of the export_column property.

Last Edited: August 5, 2003


dbList_ [Event Restore_Defaults]

Restore_Defaults - dbList_

Restores the previous values of the properties listed below after they have been stored before this object was popped up with the prompt_callback message and then deactivated

Type: Event

Parameters: No Parameters

Description

The Restore_defaults procedure restores the previous values of the properties listed below after they have been stored before this object was popped up with the prompt_callback message and then deactivated. The values are stored by store_defaults. Received only when move_value_out_state is true.

Server

auto_Server_State

deferred_State

Initial_Column

Export_Column

Auto_Column_State

Seed_List_State

Export_Item_State

Auto_Export_State

Auto_Index_State

Ordering

Display_Buffer_msg

Load_buffer_msg

Last Edited: September 11, 2003


dbList_ [Event Store_Defaults]

Store_Defaults - dbList_

Stores the existing values of the properties listed below so that they can be restored after this object is popped up with the prompt_callback message and then deactivated

Type: Event

Parameters: No Parameters

Description

The Store_defaults procedure stores the existing values of the properties listed below so that they can be restored after this object is popped up with the prompt_callback message and then deactivated. The values are restored by restore_defaults. Received only when move_value_out_state is true.

Server

Auto_Server_State

Deferred_State

Initial_Column

Export_Column

Auto_Column_State

Seed_List_State

Export_Item_State

Auto_Export_State

Auto_Index_State

Ordering

Display_Buffer_msg

Load_buffer_msg

If you need to save other properties, you may create the storage property for it and augment store_defaults and restore_defaults (which should always be mirrors of each other).

Object mydbList is a dbList
    :
    Property integer stored_highlight_row_State public 0

    Procedure Store_Defaults
        forward send Store_Defaults
        Set stored_highlight_row_State to highlight_row_State
    end_Procedure

    Procedure Restore_Defaults
        forward send Restore_Defaults
        Set highlight_row_State to stored_highlight_row_State
    end_Procedure
End_Object

You could now change highlight_row_State in the invoking object's prompt_callback procedure.

Last Edited: September 11, 2003


Events for dbList_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Export_Item | Sets the value of the item from which this object was invoked to the value in the selected row of this object that is in the column indicated by the value of the export_column property |
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click |  | DataList
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items | WideList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view | DataList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin |  | DataList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnNewOrdering | Called whenever the ordering is changed | DataList_
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DataList_
Restore_Defaults | Restores the previous values of the properties listed below after they have been stored before this object was popped up with the prompt_callback message and then deactivated |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Store_Defaults | Stores the existing values of the properties listed below so that they can be restored after this object is popped up with the prompt_callback message and then deactivated |
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


dbList_ [Function first_selected_item]

first_selected_item - dbList_

Returns the first selected item

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If batch_state is true | Returns the item number of the first selection item
If batch_state is false | Returns the record number of the first selection item
If there are no selected items | Returns -1

Description

Note:
Use first_selected_item and next_selected_item only for batch tables and use FirstSelectedRowId and NextSelectedRowId for non-batch tables.

First_selected_item returns either the item number of the first selected item (if batch_state is true), or the record number of the first selected item (if batch_state is false). If there are no selected items, returns -1.

Last Edited: September 2, 2005


dbList_ [Function FirstSelectedRowId]

FirstSelectedRowId - dbList_

Returns the first selected RowId

Type: Function

Return Data Type: RowId

Parameters: No Parameters

Return Value

The first selected RowId

Description

Sample

Object oButton is a Button
    ...

    Procedure OnClick
        RowId[] myRowIds

        get GetAllSelectedRowIds of oSelList to myRowIds
    End_Procedure
End_Object  // oButton

Object oSelList is a dbList
    ...

    Function GetAllSelectedRowIds returns RowId[]
        RowId riMyRowId
        RowId[] myRowIds
        integer iCount

        get FirstSelectedRowId to riMyRowId
        if not (IsNullRowId(riMyRowId)) begin
            move riMyRowId to myRowIds[iCount]
            increment iCount
        end
        get NextSelectedRowId True to riMyRowId
        if not (IsNullRowId(riMyRowId)) begin
            move riMyRowId to myRowIds[iCount]
            increment iCount
        end
        While not (IsNullRowId(riMyRowId))
            get NextSelectedRowId True to riMyRowId
            if not (IsNullRowId(riMyRowId)) begin
                move riMyRowId to myRowIds[iCount]
                increment iCount
            end
        end

        function_return myRowIds
    End_Procedure  // GetAllSelectedRowIds
End_Object  // oSelList

Last Edited: September 2, 2005


dbList_ [Function next_selected_Item]

next_selected_Item - dbList_

Returns the next selected item

Type: Function

Return Data Type: Integer

Parameters: Integer ClFg

Parameter | Description
ClFg | If true, the item is removed from the list of selected items

Return Value

If batch_state is true | Returns the item number of the first selection item
If batch_state is false | Returns the record number of the first selection item
If there are no selected items | Returns -1

Description

Note:
Use first_selected_item and next_selected_item only for batch tables and use FirstSelectedRowId and NextSelectedRowId for non-batch tables.

Next_selected_item returns identifier (either item_number if batch_state is true or record_number if batch_state is false) of next selected item after item specified by enumeration_counter, or returns -1 if there are no more selected items. If ClFg is true, the item's select_state is reset to false; otherwise, it is left unchanged. If batch_state is false, the record for the next selected item is found (using read_by_recnum, if server exists). Enumeration_counter is also incremented unless there are no more selected items.

You should always use Init_Selected_Item before you start your enumeration. If you do not, your enumeration will start at an unknown position.

When processing all of the items in a multi-select dbList you should always:

1. Send init_selected_item to start initialize the processing.
2. Send next_selected_item until the item returned is -1.

Do not use first_selected_item to start the enumeration. It does not initialize the list.

Sample

Get Init_Selected_Item of oMyDbList
// the bClearItem parameter determines if the item should be cleared after
// you've selected it. If you do this, you can only traverse the list once.
Get Next_Selected_item bClearItem to iItem
While (iItem>=0)
    Send ProcessThisItem iItem
    Get Next_Selected_item bClearItem to iItem
End

Last Edited: September 2, 2005


dbList_ [Function NextSelectedRowId]

NextSelectedRowId - dbList_

Returns the next selected RowId

Type: Function

Return Data Type: RowId

Parameters: Integer bClear

Parameter | Description
bClear | If true, the RowId is removed from the list of selected items

Return Value

The next selected RowId

Description

Sample

Object oButton is a Button
    ...

    Procedure OnClick
        RowId[] myRowIds

        get GetAllSelectedRowIds of oSelList to myRowIds
    End_Procedure
End_Object  // oButton

Object oSelList is a dbList
    ...

    Function GetAllSelectedRowIds returns RowId[]
        RowId riMyRowId
        RowId[] myRowIds
        integer iCount

        get FirstSelectedRowId to riMyRowId
        if not (IsNullRowId(riMyRowId)) begin
            move riMyRowId to myRowIds[iCount]
            increment iCount
        end
        get NextSelectedRowId True to riMyRowId
        if not (IsNullRowId(riMyRowId)) begin
            move riMyRowId to myRowIds[iCount]
            increment iCount
        end
        While not (IsNullRowId(riMyRowId))
            get NextSelectedRowId True to riMyRowId
            if not (IsNullRowId(riMyRowId)) begin
                move riMyRowId to myRowIds[iCount]
                increment iCount
            end
        end

        function_return myRowIds
    End_Procedure  // GetAllSelectedRowIds
End_Object  // oSelList

Last Edited: September 2, 2005


dbList_ [Function Select_Best_Column]

Select_Best_Column - dbList_

Returns the number of the column of this object that is best for the file_number and field_number of the invoking-object item

Type: Function

Return Data Type: Integer

Parameters: Integer FileNum Integer FieldNum

Parameter | Description
FileNum | The file number
FieldNum | The field number

Return Value

If no column will serve, 1 is returned.

Description

The Select_best_column function returns the number of the column of this object that is best for the file_number and field_number of the invoking-object item.

Last Edited: September 11, 2003


Methods for dbList_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list | DataList_
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful | DataList_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Deactivates this object and its scope, if any |
Clear_Current_Record | Procedure |  | DataList_
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Col_Index | Function | Returns the number of the main index for the field connected to Column Item# | DataList_
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Display | Procedure |  | DataList_
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoCheckDisplayableRows | Procedure |  | DataList_
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm | DataList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList | DataList_
DoToggleColumnOrdering | Procedure |  | DataList_
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Finds the last record in the main_file of this object, and displays a new list page ending with that record if the find was successful | DataList_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
Establish_Find_Mode | Procedure |  | DataList_
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
File_Record | Function | (Obsolete) | DataList_
FileRecord | Function |  | DataList_
FileRowId | Function |  | DataList_
Fill_List | Procedure |  | DataList_
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer | DataList_
Find_Init | Procedure |  | DataList_
Find_or_Ok | Procedure | Determines whether the value in the item window has been changed, or remains as retrieved from the database |
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object | DataList_
find_RowId | Procedure |  | DataList_
first_selected_item | Function | Returns the first selected item |
FirstSelectedRowId | Function | Returns the first selected RowId |
Goto_Bottom_Row | Procedure |  | DataList_
Goto_Top_Row | Procedure |  | DataList_
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Init_Selected_Item | Procedure | Sets enumeration_counter to zero |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in | DataList_
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
next_selected_Item | Function | Returns the next selected item |
NextSelectedRowId | Function | Returns the next selected RowId |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Oks a list selection |
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Read_By_Recnum | Procedure | (Obsolete) | DataList_
Read_Next_Record | Procedure |  | DataList_
ReadByRowId | Procedure |  | DataList_
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col# | DataList_
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Reorder_list | Procedure | Permits manual reordering of the contents of the data list | DataList_
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any |
Request_Lookup | Procedure | Enables you to program special finding behaviors for items for which you desire such |
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column | DataList_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines | EntryList
Select_All | Procedure |  | DfBaseForm
Select_Best_Column | Function | Returns the number of the column of this object that is best for the file_number and field_number of the invoking-object item |
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Toggle_Select | Procedure | Sets select_state of current item to toggle_state, i.e., sets select_state of current item to true if it is currently false, and vice-versa |
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure |  | DataList_
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Validate_Prompt | Function | (Obsolete) | WideList
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


dbList_ [Procedure Cancel]

Cancel - dbList_

Deactivates this object and its scope, if any

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns nothing (not used)

Description

Cancel deactivates this object and its scope, if any. If the list is batch, current_item is set to the value of original_selection. If the list is virtual, finds the record in the main_file identified by the record number stored in original_selection (using find_by_recnum). Sends request_cancel in all cases.

Last Edited: July 30, 2003


dbList_ [Procedure Find_or_Ok]

Find_or_Ok - dbList_

Determines whether the value in the item window has been changed, or remains as retrieved from the database

Type: Procedure

Parameters: No Parameters

Description

The Find_or_ok message is sent by the kenter accelerator key. It determines whether the value in the item window has been changed, or remains as retrieved from the database. In the case where it has been changed, this message assumes that users wish to find the record having the changed value and sends request_lookup, also defined in this class. Where it has not been changed, the message assumes the keypress signifies users' desire to select the item, and selects it.

Last Edited: August 18, 2003


dbList_ [Procedure Init_Selected_Item]

Init_Selected_Item - dbList_

Sets enumeration_counter to zero

Type: Procedure

Parameters: No Parameters

Description

The Init_selected_item procedure sets enumeration_counter to zero.

get Init_Selected_Item of oMyDbList

Last Edited: September 7, 2005


dbList_ [Procedure Ok]

Ok - dbList_

Oks a list selection

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Always returns 0 - value is never used

Description

If move_value_out_state is true, exits and deactivates this object. If the select_mode of this object is not multi_select, it sends move_value_out to export the value of the first item in the current row to the current item of the object which activated this object. If select_mode is multi_select, it sends init_selected_item to re-initialize the selected-item counter. Deactivation is accomplished using request_cancel. If move_value_out_state is false, sends next to cause rotation to the next object.

Last Edited: September 25, 2003


dbList_ [Procedure Request_Find]

Request_Find - dbList_

Finds record using specified mode, by requesting item_find from server, if any

Type: Procedure

Parameters: integer mode integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true perform entry update before Find.

Description

Request_find finds record using specified mode, by requesting item_find from server, if any. Uses data_file and data_field of current item to determine file and field for find.

Last Edited: June 21, 2005


dbList_ [Procedure Request_Lookup]

Request_Lookup - dbList_

Enables you to program special finding behaviors for items for which you desire such

Type: Procedure

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Description

The Request_lookup message is sent by find_or_ok when the list understands the user wishes to find a different row in the list. Its sole purpose is to enable you to program special finding behaviors for items for which you desire such. If this message is not defined in your object or subclass, it simply sends request_find.

Last Edited: September 11, 2003


dbList_ [Procedure Toggle_Select]

Toggle_Select - dbList_

Sets select_state of current item to toggle_state, i.e., sets select_state of current item to true if it is currently false, and vice-versa

Type: Procedure

Parameters: No Parameters

Description

Toggle_select sets select_state of current item to toggle_state, i.e., sets select_state of current item to true if it is currently false, and vice-versa.

Last Edited: September 11, 2003


Properties for dbList_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Column_State | Determines if the cursor is automatically located upon activation in the column for the main-file field in the popup selection list |
Auto_Export_State | Determines if the invoking item should be updated relationally or non-relationally |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_index_state | Determines how the popup lists will be ordered | DataList_
Auto_Save_State | Returns zero to other DEOs, which send this message to this object |
Auto_Server_State | Determines if the object will use the constraints in the invoking object's server DDO or its own DDO |
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Batch_State | Determines how much data from the database is read into memory | DataList_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Button |  | DataList
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case | DataList
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox | DataList
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message | DataList
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message | DataList
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to | DataList
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to | DataList
Column_Option | Allows you to query or change the iOption option line for Column iCol | DataList
Column_Options | Allows you to copy column options or set them in a group | DataList
Column_Prompt_Object | Specifies the default receiving object for the popup message | DataList
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled | DataList
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message | DataList
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object | DataList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Record | (Obsolete) The number of the record of the current row | DataList_
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRecordStatus |  | DataList_
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowHasRecord |  | DataList_
CurrentRowId |  | DataList_
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
CustomScrollState | Determines changing scroll bar behaviors | DataList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | DataList
Display_Buffer_Msg | Handle of an optional message that can be sent to the invoking object when a selection is complete |
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Export_Column | Determines which column's value is returned to invoking object |
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Find_Search_State | Determines how list searching is performed |
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Init_from_Top_State | Determines in what order images are displayed | DataList_
Initial_Column | Determines where the cursor is located when the list is activated | DataList_
Initial_Row | Governs the location in the display of the record (if any) in the buffer | DataList_
Invoking_Object_ID | Identifies the object which activated this object |
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Load_Buffer_Msg | Handle of optional message sent to invoking object during list activation |
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_File | Holds the file number of the main file of the list | DataList_
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent |
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
No_Relate_State | Determines if relates occur with lists that do not use DDOs | DataList_
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Ordering | Holds the index of the main file to be used to display the database records of the main file | DataList_
Original_RowId |  |
Original_Selection | Identifies the item that was selected when this object was originally activated |
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls | DataList
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction | DataList
pbReverseOrdering | Determines if the list should be displayed in reverse index order | DataList_
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | (Obsolete) |
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object | Returns the object-id of the internal object | DataList_
psEmbeddedButtonValue |  | DataList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object | DataList_
Record_Number | (Obsolete) Indicates the record number for the record in the specified row | DataList_
record_rowId |  | DataList_
RecordStatus |  | DataList_
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
RowHasRecord |  | DataList_
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released | DataList
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Seed_List_State | Determines if the seed_list message is sent when this object is activated causing the display of list items to scroll automatically |
Select_Count | Returns the value of the select_count of this object |
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | WideList_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Static_State | Determines if the list will only be initialized once the first time this object is activated | DataList_
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior | DataList
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbList_ [Property Auto_Column_State]

Auto_Column_State - dbList_

Determines if the cursor is automatically located upon activation in the column for the main-file field in the popup selection list

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_column_state defaults to true, which means that if the popup selection list has more than one column, the cursor is automatically located upon activation in the column for the main-file field used by the item from which the popup was invoked.

Default is true.

Last Edited: January 12, 2006


dbList_ [Property Auto_Export_State]

Auto_Export_State - dbList_

Determines if the invoking item should be updated relationally or non-relationally

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When this property is true, Auto_export_state will determine if the invoking item should be updated relationally or non-relationally. If the main file of this object is the same as that of the invoking item, the update will be relational. The invoking item's server (DDO) will be notified of the new record and the update will be controlled by the server.

If the main file of this object is not the same as the invoking item's main file, the export will be non-relational. The selected item will be returned directly to the invoking item.

It is best to leave this property true, allowing this object to choose automatically.

When this property is false, the export style will be determined by the export_item_state property. If export_item_state is false, updates are relational; if true, they are non-relational.

Default is true.

Last Edited: January 12, 2006


dbList_ [Property Auto_Save_State]

Auto_Save_State - dbList_

Returns zero to other DEOs, which send this message to this object

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Auto_save_state returns zero to other DEOs, which send this message to this object.

Last Edited: January 12, 2006


dbList_ [Property Auto_Server_State]

Auto_Server_State - dbList_

Determines if the object will use the constraints in the invoking object's server DDO or its own DDO

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_Server_State property is True, this object will use the invoking object's server DDO. If it is False, it will use its own DDO.

When Auto_Server_State is set to True, Deferred_State is set to True as well (setting Auto_Server_State to False will not set Deferred_State to False). This is the desired setting for this property for a lookup list.

If the dbList is used as a display list (i.e., not a popup-list), Deferred_State should be set to True after Auto_Server_State is set to False. This means that Deferred_State should be set to False in the "bottom" section of custom code area of the dbList in the Studio.

Default is False.

Last Edited: January 12, 2006


dbList_ [Property Display_Buffer_Msg]

Display_Buffer_Msg - dbList_

Handle of an optional message that can be sent to the invoking object when a selection is complete

Type: Property

Access: Read/Write

Data Type: Integer

Description

By default, selection lists return a value(s) from the selected record to the invoking item. Where you desire special handling at such a point, you can define message in the invoking object and place the ID of that message in the value of the Display_buffer_msg property. Then, instead of simply returning the selected value, the selection list will send message to the invoking object.

Last Edited: July 28, 2003


dbList_ [Property Export_Column]

Export_Column - dbList_

Determines which column's value is returned to invoking object

Type: Property

Access: Read/Write

Data Type: Integer

Description

When the export_item_state property is true, selection lists by default return the value in the first column of the list for the selected row to the invoking item. You can set the Export_column property to the number of any other column to export the value in that column instead. Setting this property to -1 provides for export of the value in the column specified by the initial_column property.

Last Edited: August 6, 2004


dbList_ [Property Export_Item_State]

Export_Item_State - dbList_

Determines if updates from lists to invoking objects are relational or non-relational

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When Auto_Export_State is false, the export style will be determined by Export_Item_State property. If Export_Item_State is false, updates are relational; if true, they are non-relational.

If Auto_Export_State is false and Export_Item_State is True (updated are non-relational), you can set Export_Column to the number of any other column to export the value in that column instead.

Default is false.

Last Edited: January 12, 2006


dbList_ [Property Find_Search_State]

Find_Search_State - dbList_

Determines how list searching is performed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Find_search_state property is true (default), list searching is performed by entering a full or partial search string and pressing Enter. If it is false, the mode set by the value of the search_mode property (default: incremental) is used. This property is only effective if popup_search_state is false (normally it is true).

Default is true.

Last Edited: January 12, 2006


dbList_ [Property Invoking_Object_ID]

Invoking_Object_ID - dbList_

Identifies the object which activated this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Invoking_object_id identifies the object which activated this object.

Last Edited: August 18, 2003


dbList_ [Property Load_Buffer_Msg]

Load_Buffer_Msg - dbList_

Handle of optional message sent to invoking object during list activation

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Load_buffer_msg property should be set to MSG_ followed by the ID of a procedure written by you to provide special buffer-loading procedures when the list is invoked. Message is sent by the list to the invoking object, which must understand message. When this property is zero, the message sent is request_entry_update, so message itself might send that message in the process of augmenting it.

Last Edited: August 18, 2003


dbList_ [Property Move_value_out_State]

Move_value_out_State - dbList_

Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If you set the Move_value_out_state property true, the value of the selected item of this object will be exported to the item of the object from which this object was invoked when ok is sent.

Default is false.

Last Edited: January 12, 2006


dbList_ [Property Original_RowId]

Original_RowId - dbList_

Type: Property

Access: Read/Write

Data Type: RowId

Description

Last Edited: August 16, 2005


dbList_ [Property Original_Selection]

Original_Selection - dbList_

Identifies the item that was selected when this object was originally activated

Type: Property

Access: Read/Write

Data Type: Integer

Description

Original_selection identifies the item that was selected when this object was originally activated.

Last Edited: September 10, 2003


dbList_ [Property Popup_State]

Popup_State - dbList_

Type: Property

Obsolete

Access: Write-Only

Data Type: Boolean

Description

Last Edited: January 12, 2006


dbList_ [Property Seed_List_State]

Seed_List_State - dbList_

Determines if the seed_list message is sent when this object is activated causing the display of list items to scroll automatically

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Seed_list_state property is true, the seed_list message is sent when this object is activated. This causes the display of list items to scroll automatically so that a particular record in the main file is displayed, typically the record from which the invoking item drew its contents.

Default is true.

Last Edited: January 12, 2006


dbList_ [Property Select_Count]

Select_Count - dbList_

Returns the value of the select_count of this object

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Select_count property returns the value of the select_count of this object.

Last Edited: September 11, 2003


Events for dbListDS

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Export_Item | Sets the value of the item from which this object was invoked to the value in the selected row of this object that is in the column indicated by the value of the export_column property | dbList_
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click |  | DataList
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items | WideList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Snaps the grid back to column zero whenever the message beginning_of_panel is sent to a view | DataList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin |  | DataList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnNewOrdering | Called whenever the ordering is changed | DataList_
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DataList_
Restore_Defaults | Restores the previous values of the properties listed below after they have been stored before this object was popped up with the prompt_callback message and then deactivated | dbList_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Store_Defaults | Stores the existing values of the properties listed below so that they can be restored after this object is popped up with the prompt_callback message and then deactivated | dbList_
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbListDS

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
auto_reorder_list | Procedure | Permits automatic reordering of the contents of the data list | DataList_
Beginning_of_Data | Procedure | Finds the first record in the main_file of this object, and fills the display, starting with that record if the find operation was successful | DataList_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Deactivates this object and its scope, if any | dbList_
Clear_Current_Record | Procedure |  | DataList_
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Col_Index | Function | Returns the number of the main index for the field connected to Column Item# | DataList_
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Display | Procedure |  | DataList_
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoCheckDisplayableRows | Procedure |  | DataList_
DoDisplayCheckBox | Procedure | Displays the appropriate checkbox bitmap in the passed iItm | DataList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
DoSetOrderingDirection | Procedure | Sets the reverse ordering property (pbReverseOrdering) and visually reverses the order of an active non-batch dbGrid or dbList | DataList_
DoToggleColumnOrdering | Procedure |  | DataList_
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Finds the last record in the main_file of this object, and displays a new list page ending with that record if the find was successful | DataList_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
Establish_Find_Mode | Procedure |  | DataList_
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
File_Record | Function | (Obsolete) | DataList_
FileRecord | Function |  | DataList_
FileRowId | Function |  | DataList_
Fill_List | Procedure |  | DataList_
Find_Current_Buffer | Procedure | Finds the record in the main file whose data are in the buffer | DataList_
Find_Init | Procedure |  | DataList_
Find_or_Ok | Procedure | Determines whether the value in the item window has been changed, or remains as retrieved from the database | dbList_
find_record | Procedure | (Obsolete) Finds the record identified by the given rec_number in the main_file of this object | DataList_
find_RowId | Procedure |  | DataList_
first_selected_item | Function | Returns the first selected item | dbList_
FirstSelectedRowId | Function | Returns the first selected RowId | dbList_
Goto_Bottom_Row | Procedure |  | DataList_
Goto_Top_Row | Procedure |  | DataList_
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Init_Selected_Item | Procedure | Sets enumeration_counter to zero | dbList_
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_to_Column | Procedure | Moves the cursor to the column whose number is in Col#, keeping it in the same row as it started out in | DataList_
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
next_selected_Item | Function | Returns the next selected item | dbList_
NextSelectedRowId | Function | Returns the next selected RowId | dbList_
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Oks a list selection | dbList_
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Read_By_Recnum | Procedure | (Obsolete) | DataList_
Read_Next_Record | Procedure |  | DataList_
ReadByRowId | Procedure |  | DataList_
Refresh_Page | Procedure | Displays list page, with the currently active record at Row Row#, using the index for Column Col# | DataList_
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Reorder_list | Procedure | Permits manual reordering of the contents of the data list | DataList_
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode, by requesting item_find from server, if any | dbList_
Request_Lookup | Procedure | Enables you to program special finding behaviors for items for which you desire such | dbList_
Request_New_Index | Procedure | Changes the index by which the list is sorted to any index that exists in the main file without changing the current record or column | DataList_
Request_Search | Procedure | Scrolls the search list to display the database value found for the search string entered up to that point |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines | EntryList
Select_All | Procedure |  | DfBaseForm
Select_Best_Column | Function | Returns the number of the column of this object that is best for the file_number and field_number of the invoking-object item | dbList_
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
ServerOrderingOverride | Function | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Toggle_Select | Procedure | Sets select_state of current item to toggle_state, i.e., sets select_state of current item to true if it is currently false, and vice-versa | dbList_
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure |  | DataList_
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Validate_Prompt | Function | (Obsolete) | WideList
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


dbListDS [Procedure Request_Search]

Request_Search - dbListDS

Scrolls the search list to display the database value found for the search string entered up to that point

Type: Procedure

Parameters: integer keyval

Parameter | Description
keyval | The value of each key typed

Description

When popup_search_state is true, the key procedure sends the Request_search message with the value of each key typed into the search window of the invoking object. This procedure scrolls the search list to display the database value found for the search string entered up to that point (the point at which each character is typed). When popup_search_state is false, the search procedure sends this message with the entire contents of the search window.

Last Edited: September 11, 2003


Properties for dbListDS

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Column_State | Determines if the cursor is automatically located upon activation in the column for the main-file field in the popup selection list | dbList_
Auto_Export_State | Determines if the invoking item should be updated relationally or non-relationally | dbList_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_index_state | Determines how the popup lists will be ordered | DataList_
Auto_Save_State | Returns zero to other DEOs, which send this message to this object | dbList_
Auto_Server_State | Determines if the object will use the constraints in the invoking object's server DDO or its own DDO | dbList_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Batch_State | Determines how much data from the database is read into memory | DataList_
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Button |  | DataList
Column_CapsLock_State | Determines if all text entered to this column from the keyboard will be converted to upper case | DataList
Column_Checkbox_State | Specifies whether a column of a grid is presented as a checkbox | DataList
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Column_Entry_msg | Sent every time the item is entered by a user in response to the item_change or the entering message | DataList
Column_Exit_msg | Sent every time the item is exited by the user in response to the item_change or the exiting message | DataList
Column_Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to | DataList
Column_Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to | DataList
Column_Option | Allows you to query or change the iOption option line for Column iCol | DataList
Column_Options | Allows you to copy column options or set them in a group | DataList
Column_Prompt_Object | Specifies the default receiving object for the popup message | DataList
Column_Shadow_State | Determines if a column is disabled (shadowed) or enabled | DataList
Column_Validate_msg | Sent every time the item is validated in response to the item_change or the exiting message | DataList
Column_Zoom_Object | Sets the destination object_id of the popup message to the specified object | DataList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Record | (Obsolete) The number of the record of the current row | DataList_
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRecordStatus |  | DataList_
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowHasRecord |  | DataList_
CurrentRowId |  | DataList_
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
CustomScrollState | Determines changing scroll bar behaviors | DataList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | DataList
Display_Buffer_Msg | Handle of an optional message that can be sent to the invoking object when a selection is complete | dbList_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Export_Column | Determines which column's value is returned to invoking object | dbList_
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational | dbList_
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Find_Search_State | Determines how list searching is performed | dbList_
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Init_from_Top_State | Determines in what order images are displayed | DataList_
Initial_Column | Determines where the cursor is located when the list is activated | DataList_
Initial_Row | Governs the location in the display of the record (if any) in the buffer | DataList_
Invoking_Object_ID | Identifies the object which activated this object | dbList_
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Load_Buffer_Msg | Handle of optional message sent to invoking object during list activation | dbList_
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_File | Holds the file number of the main file of the list | DataList_
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent | dbList_
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
No_Relate_State | Determines if relates occur with lists that do not use DDOs | DataList_
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Ordering | Holds the index of the main file to be used to display the database records of the main file | DataList_
Original_RowId |  | dbList_
Original_Selection | Identifies the item that was selected when this object was originally activated | dbList_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbEmbeddedPrompts | Toggles embedding of prompt buttons in cells in list-based controls | DataList
pbHeaderTogglesDirection | Lets you use the header to change indexes and to change the index direction | DataList
pbReverseOrdering | Determines if the list should be displayed in reverse index order | DataList_
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
pbUseServerOrdering | Determines whether the control will use its Server DDO's Ordering or its own | DataList_
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_Search_State | Determines if pressing a key will cause the search pop-up dialog to appear |
Popup_State | (Obsolete) | dbList_
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object | Returns the object-id of the internal object | DataList_
psEmbeddedButtonValue |  | DataList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Read_Only_State | Determines if saving or deletion of this object's main file may be done through this object | DataList_
Record_Number | (Obsolete) Indicates the record number for the record in the specified row | DataList_
record_rowId |  | DataList_
RecordStatus |  | DataList_
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
RowHasRecord |  | DataList_
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released | DataList
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Seed_List_State | Determines if the seed_list message is sent when this object is activated causing the display of list items to scroll automatically | dbList_
Select_Count | Returns the value of the select_count of this object | dbList_
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | WideList_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Static_State | Determines if the list will only be initialized once the first time this object is activated | DataList_
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior | DataList
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbListDS [Property Popup_Search_State]

Popup_Search_State - dbListDS

Determines if pressing a key will cause the search pop-up dialog to appear

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Popup_search_state property is true, pressing a key will cause the search pop-up dialog to appear. The user may type in a target and jump to a new location in the list. When this property is false, the search behavior of this object is controlled by the value of the find_search_state property.

Default is true.

Last Edited: January 12, 2006


Events for dbModalPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Closing_View |  | dbViewFloatingPanel
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Opening_View |  | dbViewFloatingPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared | dbViewFloatingPanel
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used | dbViewFloatingPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


Methods for dbModalPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Button | Procedure | (Obsolete) |
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open | dbFloatingPanel
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Application_Check | Function |  | dbViewFloatingPanel
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbFloatingPanel_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbFloatingPanel_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbFloatingPanel_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbFloatingPanel_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbFloatingPanel_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbFloatingPanel_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbFloatingPanel_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbFloatingPanel_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbFloatingPanel_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Search | Procedure | (Obsolete) |
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbFloatingPanel_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbFloatingPanel_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbFloatingPanel_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbFloatingPanel_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


dbModalPanel [Procedure Add_Button]

Add_Button - dbModalPanel

Type: Procedure

Obsolete

Parameters: string sLabel integer hMsg integer hoTo

Parameter | Description
sLabel | [ToDo: In Progress]
hMsg | [ToDo: In Progress]
hoTo | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbModalPanel [Procedure Search]

Search - dbModalPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Properties for dbModalPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbFloatingPanel_
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to | dbViewFloatingPanel
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbFloatingPanel_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Auto_Top_Item_State |  | dbViewFloatingPanel
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbFloatingPanel_
Auto_top_view_State |  | dbViewFloatingPanel
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
button_height | (Obsolete) |
button_width | (Obsolete) |
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | dbFloatingPanel_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbFloatingPanel_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Attach_All_State |  | dbViewFloatingPanel
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbFloatingPanel_
DEO_Object |  | dbFloatingPanel
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view | dbViewFloatingPanel
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
List_Object | (Obsolete) |
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function | dbViewFloatingPanel
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
priInitialRowId |  | dbViewFloatingPanel
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbFloatingPanel_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbFloatingPanel_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbFloatingPanel_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbFloatingPanel_
verify_exit_msg | Determines what message is sent during an exiting event | dbFloatingPanel_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbFloatingPanel_
View_Latch_State | Determines if the view's DSO structure will be initialized with the data | dbViewFloatingPanel
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbModalPanel [Property button_height]

button_height - dbModalPanel

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


dbModalPanel [Property button_width]

button_width - dbModalPanel

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


dbModalPanel [Property List_Object]

List_Object - dbModalPanel

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


Events for dbRadioContainer

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults |  | dbRadioGroupDS
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Fill_List |  | dbRadioGroupDS
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change |  | dbRadioGroup
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Select_State | Sent to notify the group that the current radio item has changed | RadioGroup
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Group
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Group
OnRadioGroupEntering |  | dbRadioGroupDS
OnRadioGroupExiting |  | dbRadioGroupDS
OnSetFocus | Sent whenever windows is about to give this object the focus | Group
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Group
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Group


Methods for dbRadioContainer

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Group
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Radio_Item | Procedure |  | dbRadioGroupDS
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Group
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Group
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Group
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Group
Error_Help | Procedure | (Obsolete) | Group
exec_entry | Function | Invokes the item_entry_msg of the specified item number, if any, and returns the result | dbRadioGroupDS
exec_exit | Function | Invokes the item_exit_msg of the specified item number, if any, and returns the result | dbRadioGroupDS
exec_validate | Function | Invokes the item_validate_msg of the specified item number, if any, and returns the result | dbRadioGroupDS
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbRadioGroupDS
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Group
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Group
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbRadioGroupDS
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbRadioGroupDS
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbRadioGroupDS
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbRadioGroupDS
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbRadioGroupDS
Help | Procedure |  | Group
Help_For_Help | Procedure | (Obsolete) | Group
Help_Index | Procedure | (Obsolete) | Group
Help_on_topic | Procedure | (Obsolete) | Group
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Group
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Group
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Group
Prompt | Procedure | Sends the Popup message to the prompt_object property ID | dbRadioGroupDS
Radio_Object | Function | Returns the handle of a radio object for a passed radio item | RadioGroup
Radio_Object_Item | Function | Returns the index (Item number) for a passed a radio object handle | RadioGroup
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbRadioGroupDS
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure |  | dbRadioGroupDS
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Group
Request_Superfind | Procedure |  | dbRadioGroupDS
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbRadioGroupDS
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbRadioGroupDS
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbRadioGroupDS
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Group
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbRadioGroupDS
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbRadioGroupDS
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbRadioGroupDS
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbRadioGroupDS
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Sends the Popup message to the zoom_object property ID | dbRadioGroupDS


Properties for dbRadioContainer

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbRadioGroupDS
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbRadioGroupDS
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object | dbRadioGroup
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Group
Auto_Save_State | Determines if auto save should be performed | dbRadioGroupDS
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbRadioGroupDS
Bitmap | Displays a bitmap in an object | Group
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Changed_State | Gets or sets the changed_state for the entire radio group | RadioGroup
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Code_Display_Mode | Specifies whether the radio object's label will display the choices' codes, descriptions, or both | dbRadioGroupDS
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Group
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Radio | Makes Item item_num the "selected" radio object | RadioGroup
Current_Radio_Object | Similar to Current_Radio except that it operates with object IDs instead of item IDs | RadioGroup
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | dbRadioGroupDS
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | dbRadioGroupDS
Default_Value |  | dbRadioGroupDS
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbRadioGroupDS
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Group
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Group
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Group
Help_Keyword | Used to specify an object's context keyword | Group
Item_Changed_State |  | dbRadioGroupDS
Item_Entry_Msg |  | dbRadioGroupDS
Item_Exit_Msg |  | dbRadioGroupDS
Item_Shadow_State | Determines if an object's item is enabled or disabled | Group
Item_Validate_Msg |  | dbRadioGroupDS
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Group
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Group
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
object_item_entry_exit |  | dbRadioGroupDS
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Group
Object_Validation |  | dbRadioGroupDS
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Group
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object |  | dbRadioGroupDS
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Group
Radio_Count | Returns the number of radio objects within this object | RadioGroup
Radio_Value | Gets and sets the label of a child radio object | RadioGroup
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Group
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Select_State |  | dbRadioGroupDS
Server | Identifies the object which provides database services to this object | dbRadioGroupDS
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbRadioGroupDS
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Group
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Group
Validate_All_Items_State |  | dbRadioGroupDS
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbRadioGroupDS
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbRadioGroupDS
verify_exit_msg | Determines what message is sent during an exiting event | dbRadioGroupDS
Verify_Save_Msg | Specifies the message to use for save confirmation | dbRadioGroupDS
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Zoom_Object |  | dbRadioGroupDS


dbRadioGroup [Event Item_Change]

Item_Change - dbRadioGroup

Type: Event

Return Data Type: Integer

Parameters: Integer iFromItem Integer iToItem

Parameter | Description
iFromItem | [ToDo: In Progress]
iToItem | [ToDo: In Progress]

Return Value

Description

Last Edited: July 11, 2006


Events for dbRadioGroup

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults |  | dbRadioGroupDS
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Fill_List |  | dbRadioGroupDS
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change |  |
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Select_State | Sent to notify the group that the current radio item has changed | RadioGroup
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Group
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Group
OnRadioGroupEntering |  | dbRadioGroupDS
OnRadioGroupExiting |  | dbRadioGroupDS
OnSetFocus | Sent whenever windows is about to give this object the focus | Group
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Group
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Group


Methods for dbRadioGroup

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Group
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Radio_Item | Procedure |  | dbRadioGroupDS
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Group
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Group
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Group
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Group
Error_Help | Procedure | (Obsolete) | Group
exec_entry | Function | Invokes the item_entry_msg of the specified item number, if any, and returns the result | dbRadioGroupDS
exec_exit | Function | Invokes the item_exit_msg of the specified item number, if any, and returns the result | dbRadioGroupDS
exec_validate | Function | Invokes the item_validate_msg of the specified item number, if any, and returns the result | dbRadioGroupDS
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbRadioGroupDS
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Group
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Group
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbRadioGroupDS
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbRadioGroupDS
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbRadioGroupDS
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbRadioGroupDS
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbRadioGroupDS
Help | Procedure |  | Group
Help_For_Help | Procedure | (Obsolete) | Group
Help_Index | Procedure | (Obsolete) | Group
Help_on_topic | Procedure | (Obsolete) | Group
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Group
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Group
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Group
Prompt | Procedure | Sends the Popup message to the prompt_object property ID | dbRadioGroupDS
Radio_Object | Function | Returns the handle of a radio object for a passed radio item | RadioGroup
Radio_Object_Item | Function | Returns the index (Item number) for a passed a radio object handle | RadioGroup
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbRadioGroupDS
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure |  | dbRadioGroupDS
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Group
Request_Superfind | Procedure |  | dbRadioGroupDS
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbRadioGroupDS
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbRadioGroupDS
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbRadioGroupDS
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Group
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbRadioGroupDS
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbRadioGroupDS
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbRadioGroupDS
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbRadioGroupDS
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Sends the Popup message to the zoom_object property ID | dbRadioGroupDS


Properties for dbRadioGroup

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbRadioGroupDS
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbRadioGroupDS
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object |
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Group
Auto_Save_State | Determines if auto save should be performed | dbRadioGroupDS
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbRadioGroupDS
Bitmap | Displays a bitmap in an object | Group
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Changed_State | Gets or sets the changed_state for the entire radio group | RadioGroup
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Code_Display_Mode | Specifies whether the radio object's label will display the choices' codes, descriptions, or both | dbRadioGroupDS
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Group
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Radio | Makes Item item_num the "selected" radio object | RadioGroup
Current_Radio_Object | Similar to Current_Radio except that it operates with object IDs instead of item IDs | RadioGroup
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | dbRadioGroupDS
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | dbRadioGroupDS
Default_Value |  | dbRadioGroupDS
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbRadioGroupDS
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Group
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Group
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Group
Help_Keyword | Used to specify an object's context keyword | Group
Item_Changed_State |  | dbRadioGroupDS
Item_Entry_Msg |  | dbRadioGroupDS
Item_Exit_Msg |  | dbRadioGroupDS
Item_Shadow_State | Determines if an object's item is enabled or disabled | Group
Item_Validate_Msg |  | dbRadioGroupDS
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Group
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Group
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
object_item_entry_exit |  | dbRadioGroupDS
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Group
Object_Validation |  | dbRadioGroupDS
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Group
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object |  | dbRadioGroupDS
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Group
Radio_Count | Returns the number of radio objects within this object | RadioGroup
Radio_Value | Gets and sets the label of a child radio object | RadioGroup
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Group
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Select_State |  | dbRadioGroupDS
Server | Identifies the object which provides database services to this object | dbRadioGroupDS
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbRadioGroupDS
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Group
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Group
Validate_All_Items_State |  | dbRadioGroupDS
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbRadioGroupDS
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbRadioGroupDS
verify_exit_msg | Determines what message is sent during an exiting event | dbRadioGroupDS
Verify_Save_Msg | Specifies the message to use for save confirmation | dbRadioGroupDS
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Zoom_Object |  | dbRadioGroupDS


dbRadioGroup [Property Auto_Label_State]

Auto_Label_State - dbRadioGroup

Determines if this object will draw label values from the DDO rather than from any label that may be set in this object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_label_state property is set true, this object will draw label values from the DDO rather than from any label that may be set in this object.

When used within single-item objects (forms and edits), the object uses the field's long label name.

When used within multi-item objects (grids), the object uses the field's short label name.

Default is false.

Last Edited: January 12, 2006


dbRadioGroupDS [Event Entry_Defaults]

Entry_Defaults - dbRadioGroupDS

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Event Fill_List]

Fill_List - dbRadioGroupDS

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Event OnRadioGroupEntering]

OnRadioGroupEntering - dbRadioGroupDS

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Event OnRadioGroupExiting]

OnRadioGroupExiting - dbRadioGroupDS

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


Events for dbRadioGroupDS

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults |  |
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Fill_List |  |
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Select_State | Sent to notify the group that the current radio item has changed | RadioGroup
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Group
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Group
OnRadioGroupEntering |  |
OnRadioGroupExiting |  |
OnSetFocus | Sent whenever windows is about to give this object the focus | Group
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Group
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Group


dbRadioGroupDS [Function exec_entry]

exec_entry - dbRadioGroupDS

Invokes the item_entry_msg of the specified item number, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result of the item_entry_msg of the specified item number

Description

Exec_entry invokes the item_entry_msg of the specified item number, if any, and returns the result.

Last Edited: August 18, 2003


dbRadioGroupDS [Function exec_exit]

exec_exit - dbRadioGroupDS

Invokes the item_exit_msg of the specified item number, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result of the item_entry_msg of the specified item number

Description

Exec_exit invokes the item_exit_msg of the specified item number, if any, and returns the result.

Last Edited: August 13, 2003


dbRadioGroupDS [Function exec_validate]

exec_validate - dbRadioGroupDS

Invokes the item_validate_msg of the specified item number, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result of the item_entry_msg of the specified item number

Description

Exec_validate invokes the item_validate_msg of the specified item number, if any, and returns the result. Performs autofind on value and field of specified item number, if required, using entry_autofind.

Last Edited: August 13, 2003


dbRadioGroupDS [Function Verify_Data_Loss]

Verify_Data_Loss - dbRadioGroupDS

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


dbRadioGroupDS [Function Verify_Delete]

Verify_Delete - dbRadioGroupDS

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


dbRadioGroupDS [Function verify_Exit]

verify_Exit - dbRadioGroupDS

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


dbRadioGroupDS [Function Verify_Save]

Verify_Save - dbRadioGroupDS

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for dbRadioGroupDS

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Group
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Radio_Item | Procedure |  |
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Group
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Group
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Group
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Group
Error_Help | Procedure | (Obsolete) | Group
exec_entry | Function | Invokes the item_entry_msg of the specified item number, if any, and returns the result |
exec_exit | Function | Invokes the item_exit_msg of the specified item number, if any, and returns the result |
exec_validate | Function | Invokes the item_validate_msg of the specified item number, if any, and returns the result |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Group
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Group
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find |
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item |
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find |
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find |
Help | Procedure |  | Group
Help_For_Help | Procedure | (Obsolete) | Group
Help_Index | Procedure | (Obsolete) | Group
Help_on_topic | Procedure | (Obsolete) | Group
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Group
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Group
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Group
Prompt | Procedure | Sends the Popup message to the prompt_object property ID |
Radio_Object | Function | Returns the handle of a radio object for a passed radio item | RadioGroup
Radio_Object_Item | Function | Returns the index (Item number) for a passed a radio object handle | RadioGroup
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure |  |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Group
Request_Superfind | Procedure |  |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind |
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind |
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind |
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Group
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Sends the Popup message to the zoom_object property ID |


dbRadioGroupDS [Procedure Add_Radio_Item]

Add_Radio_Item - dbRadioGroupDS

Type: Procedure

Parameters: String Descr_value String Data_Value

Parameter | Description
Descr_value | [ToDo: In Progress]
Data_Value | [ToDo: In Progress]

Description

Last Edited: November 11, 2004


dbRadioGroupDS [Procedure Exit_Function]

Exit_Function - dbRadioGroupDS

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


dbRadioGroupDS [Procedure Find_First]

Find_First - dbRadioGroupDS

Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_first finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of beginning_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbRadioGroupDS [Procedure Find_GE]

Find_GE - dbRadioGroupDS

Performs a find greater than or equal by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_ge performs a find greater than or equal by the data_file and data_field of the current item, using request_find. Sent by kfind.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbRadioGroupDS [Procedure Find_Last]

Find_Last - dbRadioGroupDS

Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item

Type: Procedure

Parameters: No Parameters

Description

Find_last finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item. Should be used in place of end_of_data.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbRadioGroupDS [Procedure Find_Next]

Find_Next - dbRadioGroupDS

Performs a find greater than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_next performs a find greater than by the data_file and data_field of the current item, using request_find. Sent by kfind_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbRadioGroupDS [Procedure Find_Previous]

Find_Previous - dbRadioGroupDS

Performs a find less than by the data_file and data_field of the current item, using request_find

Type: Procedure

Parameters: No Parameters

Description

Find_previous performs a find less than by the data_file and data_field of the current item, using request_find. Sent by kfind_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbRadioGroupDS [Procedure Prompt]

Prompt - dbRadioGroupDS

Sends the Popup message to the prompt_object property ID

Type: Procedure

Parameters: No Parameters

Description

Prompt sends the Popup message to the prompt_object property ID (if non-zero).

Last Edited: June 29, 2005


dbRadioGroupDS [Procedure Request_Cancel]

Request_Cancel - dbRadioGroupDS

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


dbRadioGroupDS [Procedure Request_Find]

Request_Find - dbRadioGroupDS

Type: Procedure

Parameters: integer mode integer entUpdtFlag

Parameter | Description
mode | [ToDo: In Progress]
entUpdtFlag | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Procedure Request_Superfind]

Request_Superfind - dbRadioGroupDS

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Last Edited: June 21, 2005


dbRadioGroupDS [Procedure SuperFind]

SuperFind - dbRadioGroupDS

Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbRadioGroupDS [Procedure SuperFind_Next]

SuperFind_Next - dbRadioGroupDS

Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_next performs a superfind greater than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_next.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbRadioGroupDS [Procedure SuperFind_Previous]

SuperFind_Previous - dbRadioGroupDS

Performs a superfind less than by the data_file and data_field of the current item, using request_superfind

Type: Procedure

Parameters: No Parameters

Description

Superfind_previous performs a superfind less than by the data_file and data_field of the current item, using request_superfind. Sent by ksuper_find_previous.

Note:
This method does not apply to edit classes (cDbTextEdit, cDbRichEdit, dbEdit).

Last Edited: June 16, 2005


dbRadioGroupDS [Procedure Zoom]

Zoom - dbRadioGroupDS

Sends the Popup message to the zoom_object property ID

Type: Procedure

Parameters: No Parameters

Description

Zoom sends the Popup message to the zoom_object property ID (if non-zero).

Last Edited: September 15, 2003


Properties for dbRadioGroupDS

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Group
Auto_Save_State | Determines if auto save should be performed |
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Bitmap | Displays a bitmap in an object | Group
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Changed_State | Gets or sets the changed_state for the entire radio group | RadioGroup
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Code_Display_Mode | Specifies whether the radio object's label will display the choices' codes, descriptions, or both |
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Group
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Radio | Makes Item item_num the "selected" radio object | RadioGroup
Current_Radio_Object | Similar to Current_Radio except that it operates with object IDs instead of item IDs | RadioGroup
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared |
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared |
Default_Value |  |
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Group
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Group
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Group
Help_Keyword | Used to specify an object's context keyword | Group
Item_Changed_State |  |
Item_Entry_Msg |  |
Item_Exit_Msg |  |
Item_Shadow_State | Determines if an object's item is enabled or disabled | Group
Item_Validate_Msg |  |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Group
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Group
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
object_item_entry_exit |  |
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Group
Object_Validation |  |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Group
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object |  |
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Group
Radio_Count | Returns the number of radio objects within this object | RadioGroup
Radio_Value | Gets and sets the label of a child radio object | RadioGroup
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Group
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Select_State |  |
Server | Identifies the object which provides database services to this object |
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Group
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Group
Validate_All_Items_State |  |
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event |
Verify_Save_Msg | Specifies the message to use for save confirmation |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Zoom_Object |  |


dbRadioGroupDS [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - dbRadioGroupDS

If true, this object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


dbRadioGroupDS [Property Auto_Fill_State]

Auto_Fill_State - dbRadioGroupDS

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


dbRadioGroupDS [Property Auto_Save_State]

Auto_Save_State - dbRadioGroupDS

Determines if auto save should be performed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_save_state property is true, rotation from the last object within this object to the first object within this object will cause this object to save. Intended to be set.

Default is false.

Last Edited: January 12, 2006


dbRadioGroupDS [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - dbRadioGroupDS

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


dbRadioGroupDS [Property Code_Display_Mode]

Code_Display_Mode - dbRadioGroupDS

Specifies whether the radio object's label will display the choices' codes, descriptions, or both

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Code_display_mode property specifies whether the radio object's label will display the choices' codes, descriptions, or both. By default the description is displayed.

Default is CD_Code_Display_Description.

Last Edited: July 30, 2003


dbRadioGroupDS [Property Data_Field]

Data_Field - dbRadioGroupDS

Identifies the database field from which data is to be stored, retrieved, and cleared

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer item# integer Field#

Parameter | Description
item# | The item number
Field# | The field number

Description

Each entry_item may have a field in a database file associated with it. The data_field identifies the database field from which data is to be stored, retrieved, and cleared. Data_fields are most often set by the entry_item command.

entry_item customer.name

They may also be set using the data_field message. This may be done if an entry item needs to be set to another field number than the initialized one. Data_field numbers begin with 0 for recnum and count up to the number of fields in the file with which the item is associated. Values outside this range are errors.

set data_field item 0 to 4

get data_field item 0 to var

If the entry_item is not associated with a data field (it is associated with an expression or variable), the value of this property is 0.

Last Edited: August 5, 2003


dbRadioGroupDS [Property Data_File]

Data_File - dbRadioGroupDS

Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer item# integer File#

Parameter | Description
item# | The item number
File# | The file number

Description

Each entry_item may have a field in a database file associated with it. The Data_file property identifies the database file that contains the field from which data is to be stored, retrieved, and cleared. Data_files are most often set by the composition of the entry_item statement itself.

entry_item customer.name

They may also be set using the data_file message. This may be done if an entry item needs to be set to another file than the initialized one.

set data_file item 0 to customer.File_Number

get data_file item 0 to filenumber

If the entry_item is not associated with a data field (it is associated with an expression or variable) the value of this property is 0.

Last Edited: August 5, 2003


dbRadioGroupDS [Property Default_Value]

Default_Value - dbRadioGroupDS

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Property Deferred_State]

Deferred_State - dbRadioGroupDS

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


dbRadioGroupDS [Property Item_Changed_State]

Item_Changed_State - dbRadioGroupDS

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iState

Parameter | Description
iItem | [ToDo: In Progress]
iState | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Property Item_Entry_Msg]

Item_Entry_Msg - dbRadioGroupDS

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer hMsg

Parameter | Description
iItem | [ToDo: In Progress]
hMsg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Property Item_Exit_Msg]

Item_Exit_Msg - dbRadioGroupDS

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer hMsg

Parameter | Description
iItem | [ToDo: In Progress]
hMsg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Property Item_Validate_Msg]

Item_Validate_Msg - dbRadioGroupDS

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer hMsg

Parameter | Description
iItem | [ToDo: In Progress]
hMsg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Property object_item_entry_exit]

object_item_entry_exit - dbRadioGroupDS

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Property Object_Validation]

Object_Validation - dbRadioGroupDS

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Property Prompt_Object]

Prompt_Object - dbRadioGroupDS

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer item# Integer Obj#

Parameter | Description
item# | [ToDo: In Progress]
Obj# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Property Select_State]

Select_State - dbRadioGroupDS

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | [ToDo: In Progress]
iState | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


dbRadioGroupDS [Property Server]

Server - dbRadioGroupDS

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


dbRadioGroupDS [Property Should_Save]

Should_Save - dbRadioGroupDS

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


dbRadioGroupDS [Property Validate_All_Items_State]

Validate_All_Items_State - dbRadioGroupDS

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


dbRadioGroupDS [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - dbRadioGroupDS

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


dbRadioGroupDS [Property Verify_Delete_Msg]

Verify_Delete_Msg - dbRadioGroupDS

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


dbRadioGroupDS [Property verify_exit_msg]

verify_exit_msg - dbRadioGroupDS

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


dbRadioGroupDS [Property Verify_Save_Msg]

Verify_Save_Msg - dbRadioGroupDS

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


dbRadioGroupDS [Property Zoom_Object]

Zoom_Object - dbRadioGroupDS

Type: Property

Access: Read/Write

Data Type: Handle

Parameters: Integer iItem Handle hoPrompt

Parameter | Description
iItem | [ToDo: In Progress]
hoPrompt | [ToDo: In Progress]

Description

Last Edited: July 11, 2006


Events for dbSpinForm

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message | Entry
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Entry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | Entry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Entry
OnMaxText |  | Entry
OnSetFocus | Sent whenever windows is about to give this object the focus | Entry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Entry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | Entry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbSpinForm

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Entry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Entry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Entry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbForm_
Close_Panel | Procedure | Closes the panel or component currently open | dbFormDS
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | Entry
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | Entry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | dbFormDS
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Entry
DoScrollDown | Procedure | Emulates pressing a spin button down | dbSpinFormDS
DoScrollUp | Procedure | Emulates pressing a spin button up | dbSpinFormDS
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Entry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | Entry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Entry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Entry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbForm_
Help | Procedure |  | Entry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | Entry
Help_For_Help | Procedure | (Obsolete) | Entry
Help_Index | Procedure | (Obsolete) | Entry
Help_on_topic | Procedure | (Obsolete) | Entry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Entry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Entry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | Entry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Entry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbForm_
Prompt_Description | Function | (Obsolete) | dbFormDS
Prompt_Description | Procedure | (Obsolete) | dbFormDS
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbForm_
Request_Save | Procedure |  | dbFormDS
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Entry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Entry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbForm_
Validate_Prompt | Function | (Obsolete) | dbFormDS
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbForm_


Properties for dbSpinForm

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbForm_
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object |
Auto_Save_State | Determines if auto save should be performed | dbForm_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | Entry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Position | Contains the current position of the spin button | dbSpinFormDS
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | dbForm_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | dbFormDS
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbForm_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Entry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Entry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | Entry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Entry
Help_Keyword | Used to specify an object's context keyword | Entry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | Entry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Entry
Label_Col_Offset | The horizontal distance from the object to its label | Entry
Label_Justification_Mode | The justification mode for the text within this object's label | Entry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Entry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Entry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to | dbSpinFormDS
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to | dbSpinFormDS
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Entry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form | Entry
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object | Entry
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Entry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value | Called anytime the spin button needs to synchronize its value with the form value | dbSpinFormDS
Status_Help | Determines the status text that will be displayed when this object takes the focus | Entry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Entry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbForm_
Validate_Mode | Determines how and when object validation occurs | dbForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Determines whether the spin button will wrap | dbSpinFormDS
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbSpinForm [Property Auto_Label_State]

Auto_Label_State - dbSpinForm

Determines if this object will draw label values from the DDO rather than from any label that may be set in this object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_label_state property is set true, this object will draw label values from the DDO rather than from any label that may be set in this object.

When used within single-item objects (forms and edits), the object uses the field's long label name.

When used within multi-item objects (grids), the object uses the field's short label name.

Default is false.

Last Edited: January 12, 2006


Events for dbSpinFormDS

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message | Entry
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Entry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | Entry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Entry
OnMaxText |  | Entry
OnSetFocus | Sent whenever windows is about to give this object the focus | Entry
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Entry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | Entry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbSpinFormDS

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Entry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Entry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Entry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbForm_
Close_Panel | Procedure | Closes the panel or component currently open | dbFormDS
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | Entry
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | Entry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | dbFormDS
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Entry
DoScrollDown | Procedure | Emulates pressing a spin button down |
DoScrollUp | Procedure | Emulates pressing a spin button up |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Entry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | Entry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Entry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Entry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbForm_
Help | Procedure |  | Entry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | Entry
Help_For_Help | Procedure | (Obsolete) | Entry
Help_Index | Procedure | (Obsolete) | Entry
Help_on_topic | Procedure | (Obsolete) | Entry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Entry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Entry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | Entry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Entry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbForm_
Prompt_Description | Function | (Obsolete) | dbFormDS
Prompt_Description | Procedure | (Obsolete) | dbFormDS
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbForm_
Request_Save | Procedure |  | dbFormDS
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Entry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Entry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbForm_
Validate_Prompt | Function | (Obsolete) | dbFormDS
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbForm_


dbSpinFormDS [Procedure DoScrollDown]

DoScrollDown - dbSpinFormDS

Emulates pressing a spin button down

Type: Procedure

Parameters: No Parameters

Description

Sending the DoScrollDown message emulates pressing a spin button down. If the active cell in a grid does not support a spin button, this procedure does nothing. Normally, you will assign keys to this procedure and to the procedure DoScrollUp.

// assign keys to manually spin value
On_Key Key_Ctrl+Key_U Send DoScrollUp
On_Key Key_Ctrl+Key_D Send DoScrollDown

Last Edited: August 5, 2003


dbSpinFormDS [Procedure DoScrollUp]

DoScrollUp - dbSpinFormDS

Emulates pressing a spin button up

Type: Procedure

Parameters: No Parameters

Description

Sending the DoScrollUp message emulates pressing a spin button up. If the active cell in a grid does not support a spin button, this procedure does nothing. Normally, you will assign keys to this procedure and to the procedure DoScrollDown.

// assign keys to manually spin value
On_Key Key_Ctrl+Key_U Send DoScrollUp
On_Key Key_Ctrl+Key_D Send DoScrollDown

Last Edited: August 5, 2003


Properties for dbSpinFormDS

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbForm_
Auto_Save_State | Determines if auto save should be performed | dbForm_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | Entry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Position | Contains the current position of the spin button |
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | dbForm_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | dbFormDS
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbForm_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Entry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Entry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | Entry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Entry
Help_Keyword | Used to specify an object's context keyword | Entry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | Entry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Entry
Label_Col_Offset | The horizontal distance from the object to its label | Entry
Label_Justification_Mode | The justification mode for the text within this object's label | Entry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Entry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Entry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to |
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Entry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form | Entry
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object | Entry
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Entry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value | Called anytime the spin button needs to synchronize its value with the form value |
Status_Help | Determines the status text that will be displayed when this object takes the focus | Entry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Entry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbForm_
Validate_Mode | Determines how and when object validation occurs | dbForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbForm_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Determines whether the spin button will wrap |
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbSpinFormDS [Property Current_Position]

Current_Position - dbSpinFormDS

Contains the current position of the spin button

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Current_position property contains the current position of the spin button. The value is in the range of 0-65,535.

Default is 0.

Last Edited: July 31, 2003


dbSpinFormDS [Property Maximum_Position]

Maximum_Position - dbSpinFormDS

Maintains the value that represents the highest value that the spin button will spin up to

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Maximum_Position property maintains the value that represents the highest value that the spin button will spin up to. The value is in the range of 32767 to -32767

Default is 32767.

Last Edited: August 16, 2004


dbSpinFormDS [Property Minimum_Position]

Minimum_Position - dbSpinFormDS

Maintains the value that represents the lowest value that the spin button will spin down to

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Minimum_Position property maintains the value that represents the lowest value that the spin button will spin down to. The value is in the range of 32767 to -32767

Default is 32767.

Last Edited: August 16, 2004


dbSpinFormDS [Property Spin_Value]

Spin_Value - dbSpinFormDS

Called anytime the spin button needs to synchronize its value with the form value

Type: Property

Access: Read/Write

Data Type: Integer

Description

Spin_Value is called anytime the spin button needs to synchronize its value with the form value. This can be augmented to convert the form's value into some other numeric spin value. You will usually need to augment the Spin_value function as well.

Procedure Set Spin_Value integer itm
    If itm eq 0      Set Value item 0 to "Open"
    Else if itm eq 1 Set Value item 0 to "Closed"
    Else if itm eq 2 Set Value item 0 to "Canceled"
end_procedure

Last Edited: September 11, 2003


dbSpinFormDS [Property Wrap_State]

Wrap_State - dbSpinFormDS

Determines whether the spin button will wrap

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Wrap_state property determines whether the spin button will wrap. If this property is true, once the Current_Position is spun beyond the Maximum_Position, it will rotate to the Minimum_Position, and vice-versa.

Default is true.

Last Edited: January 12, 2006


Events for dbTabDialog

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent to the tab-dialog when Beginning_of_panel is sent by a parent | TabDialog
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDisplay |  | TabDialog
OnKillFocus | Sent whenever the object is about to lose the focus | TabDialog_
OnResize | Fires when the tab-dialog is created and whenever it is resized | TabDialog
OnSetFocus | Sent whenever windows is about to give this object the focus | TabDialog_
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | TabDialog_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | TabDialog_


dbTabDialog [Function Exit_Loss_Confirmation]

Exit_Loss_Confirmation - dbTabDialog

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


Methods for dbTabDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | TabDialog_
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Auto_Page | Procedure |  | DfBasetabDialog
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | TabDialog_
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | TabDialog_
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | TabDialog_
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | TabDialog_
Error_Help | Procedure | (Obsolete) | TabDialog_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbTabDialog_
Exit_Loss_Confirmation | Function |  |
Extended_Help | Procedure | (Obsolete) | TabDialog_
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | TabDialog_
Help | Procedure |  | TabDialog_
Help_For_Help | Procedure | (Obsolete) | TabDialog_
Help_Index | Procedure | (Obsolete) | TabDialog_
Help_on_topic | Procedure | (Obsolete) | TabDialog_
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | TabDialog_
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | TabDialog_
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | TabDialog_
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbTabDialog_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbTabDialog_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbTabDialog_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbTabDialog_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbTabDialog_
Request_Next_Tab | Procedure | Causes the next tab page to be displayed | TabDialog
Request_Previous_Tab | Procedure | Causes the previous tab page to be displayed and take the focus | TabDialog
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbTabDialog_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbTabDialog_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | TabDialog_
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbTabDialog_
Request_Switch_To_Tab | Procedure | Displays and activates the requested tab# | TabDialog
Request_Tab_Display | Procedure | Causes the selected tab page to be displayed but does not give the page the focus | TabDialog
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | TabDialog_
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbTabDialog_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbTabDialog_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbTabDialog_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbTabDialog_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


dbTabDialog [Procedure Close_Panel]

Close_Panel - dbTabDialog

Closes the panel or component currently open

Type: Procedure

Parameters: No Parameters

Description

Closes the panel or component currently open. If the control Close_Panel is sent to is not a panel, the call will be delegated to it's parent.

For example, if a cDbRichEdit control is in a dbView, sending Close_Panel to the cDbRichEdit control will close the dbView.

Sample

This sample causes the dbView control oDbView1 to close when button oCloseButton is clicked.

Object oDbView1 is a dbView
    :
    Object oDbRichEdit1 is a cDbRichEdit
        :
    End_Object  // oDbRichEdit1
    :
    Object oCloseButton is a Button
        :
        Procedure OnClick
            send Close_Panel of oDbRichEdit1
        End_Procedure  // OnClick
        :
    End_Object  // oCloseButton
    :
End_Object  // oDbView1

Last Edited: November 24, 2004


Properties for dbTabDialog

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbTabDialog_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbTabDialog_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | TabDialog_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbTabDialog_
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | TabDialog_
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Button_Count | Returns the number of tabs in this object | TabDialog
Changed_State | Determines if one or more of the child objects has changed | dbTabDialog_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | TabDialog_
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Current_Tab | Returns the number of the tab in this object that has the focus | TabDialog
Default_Tab | Determines what tab page will be displayed as a default | TabDialog
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbTabDialog_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbTabDialog_
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | TabDialog_
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | TabDialog_
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | TabDialog_
Help_Keyword | Used to specify an object's context keyword | TabDialog_
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled | TabDialog_
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | TabDialog_
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | TabDialog_
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
MultiLine_State | Determines if tabs will wrap across multiple lines | TabDialog
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
NumberOfRows | Returns the number of rows of tabs that are displayed | TabDialog
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | TabDialog_
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | TabDialog_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbFlatSeparators | Determines if separators are drawn | TabDialog
pbHotTrack | Determines hot-tracking on the labels of the tab-pages | TabDialog
pbResetPageOnActivate | Determines how a tab dialog should behave when the dialog takes the focus as part of forward keyboard activation | TabDialog
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peTabPosition | Determines if positions of the tabs are at the top or the bottom of the tab-dialog | TabDialog
peTabStyle | Determines if tabs are displayed as tabs or buttons | TabDialog
phoImageList | Permits images to be displayed on tab-pages | TabDialog
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Pointer_only_State | Determines how tab buttons will respond to the mouse | TabDialog
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | TabDialog_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Rotate_Mode | Governs cursor movement on keyboard navigation when the Next key is pressed in the last object in a tab page | TabDialog
Row_Offset | Determines the offset to the invoking item by number of rows | TabDialog_
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbTabDialog_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbTabDialog_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_Button_Mode | Governs the way tab button navigation is done with the keyboard and mouse (when pointer_only_state is True) | TabDialog
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | TabDialog_
Tab_page_Id | Contains the object_ID of the tab_page object associated with each of this object's items | TabDialog
TabWidth_Mode | Makes each tab just wide enough to display its label, all the same width on each line sufficient to fill the width of this object, or all the width of the widest tab in the object | TabDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Tooltip_State |  | DfBasetabDialog
Tooltip_Value |  | DfBasetabDialog
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | TabDialog_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbTabDialog_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbTabDialog_
verify_exit_msg | Determines what message is sent during an exiting event | dbTabDialog_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbTabDialog_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Events for dbTabDialog_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent to the tab-dialog when Beginning_of_panel is sent by a parent | TabDialog
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDisplay |  | TabDialog
OnKillFocus | Sent whenever the object is about to lose the focus | TabDialog_
OnResize | Fires when the tab-dialog is created and whenever it is resized | TabDialog
OnSetFocus | Sent whenever windows is about to give this object the focus | TabDialog_
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | TabDialog_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | TabDialog_


dbTabDialog_ [Function Verify_Data_Loss]

Verify_Data_Loss - dbTabDialog_

Sends the verify_data_loss_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_data_loss function sends the verify_data_loss_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to allow the data loss, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere the potential for a loss of data exists. Sent by request_clear and request_clear_all.

Verify_Data_Loss_Msg is not sent unless Verify_Exit_Msg is defined.

Last Edited: November 9, 2006


dbTabDialog_ [Function Verify_Delete]

Verify_Delete - dbTabDialog_

Sends the verify_delete_msg message when user action causes the program to get this functio

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

The Verify_delete function sends the verify_delete_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the deletion, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a delete may occur. Sent by request_delete.

Last Edited: September 15, 2003


dbTabDialog_ [Function verify_Exit]

verify_Exit - dbTabDialog_

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


dbTabDialog_ [Function Verify_Save]

Verify_Save - dbTabDialog_

Sends the verify_save_msg message when user action causes the program to get this function

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true

Description

This Verify_save function sends the verify_save_msg message when user action causes the program to get this function. That message displays the verification prompt and processes user response to it. If users respond to verify the save, this function returns zero (false) and the requested action proceeds; all other responses result in a return value of true, in which case the request is cancelled and the state of the program is restored to that immediately before the action was requested. Intended to be sent anywhere a save may occur. Sent by request_save.

Last Edited: September 15, 2003


Methods for dbTabDialog_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | TabDialog_
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Auto_Page | Procedure |  | DfBasetabDialog
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | TabDialog_
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | TabDialog_
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | TabDialog_
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | TabDialog_
Error_Help | Procedure | (Obsolete) | TabDialog_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | TabDialog_
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | TabDialog_
Help | Procedure |  | TabDialog_
Help_For_Help | Procedure | (Obsolete) | TabDialog_
Help_Index | Procedure | (Obsolete) | TabDialog_
Help_on_topic | Procedure | (Obsolete) | TabDialog_
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | TabDialog_
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | TabDialog_
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | TabDialog_
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true |
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index |
Request_Next_Tab | Procedure | Causes the next tab page to be displayed | TabDialog
Request_Previous_Tab | Procedure | Causes the previous tab page to be displayed and take the focus | TabDialog
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO |
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | TabDialog_
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result |
Request_Switch_To_Tab | Procedure | Displays and activates the requested tab# | TabDialog
Request_Tab_Display | Procedure | Causes the selected tab page to be displayed but does not give the page the focus | TabDialog
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | TabDialog_
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function |
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


dbTabDialog_ [Procedure Exit_Function]

Exit_Function - dbTabDialog_

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


dbTabDialog_ [Procedure Request_Cancel]

Request_Cancel - dbTabDialog_

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


dbTabDialog_ [Procedure Request_Clear]

Request_Clear - dbTabDialog_

Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause the user to lose changes made to the text, verify_data_loss is used to confirm the action. Clear is requested of the DSO. This may result in other DEOs clearing, in addition to the DEOs connected to that DSO. Sent (via delegation) by DEOs within the container.

Last Edited: September 11, 2003


dbTabDialog_ [Procedure Request_Clear_All]

Request_Clear_All - dbTabDialog_

Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true

Type: Procedure

Parameters: No Parameters

Description

Request_clear_all clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true. If clearing may cause a user to lose changes made to the text, verify_data_loss is used to confirm the action. Clear_all is requested of the DSO. This may result in other DEOs clearing, in addition to the DEOs connected to that DSO.

Last Edited: September 11, 2003


dbTabDialog_ [Procedure Request_Delete]

Request_Delete - dbTabDialog_

Deletes current record in main_file of the server DSO, if any, else issues an error

Type: Procedure

Parameters: No Parameters

Description

Request_delete deletes current record in main_file of the server DSO, if any, else issues an error. Sent by DEOs attached to the data set. Note that deletion of the current main_file record may cause sets of records in container DSOs to be deleted, i.e., those records that relate to the DSO's current record. Sends can_delete and acts only if that returns true.

Last Edited: September 11, 2003


dbTabDialog_ [Procedure Request_Find]

Request_Find - dbTabDialog_

Finds on specified file using given find_mode and index

Type: Procedure

Parameters: Integer mode Integer entUpdtFlag

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record
entUpdtFlag | If true, perform entry_update before find

Description

Request_find finds on specified file using given find_mode and index. If find is successful, performs a relate on file. If file is the same as the DSO's main_file, sends relate_main_file. Notifies other connected DSOs of the result of the find. Mode may be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either next_record, first_record, or last_record. Sets the found indicator to reflect the success or failure of the find operation. Sent by DEOs and item_find.

Last Edited: July 11, 2006


dbTabDialog_ [Procedure Request_Save]

Request_Save - dbTabDialog_

Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO

Type: Procedure

Parameters: No Parameters

Description

Request_Save saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO (directly or indirectly). Sent by DEOs attached to the DSO.

Last Edited: August 19, 2004


dbTabDialog_ [Procedure Request_Save_No_Clear]

Request_Save_No_Clear - dbTabDialog_

Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state

Type: Procedure

Parameters: No Parameters

Description

Request_save_no_clears saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state.

Last Edited: September 11, 2003


dbTabDialog_ [Procedure Request_Superfind]

Request_Superfind - dbTabDialog_

Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result

Type: Procedure

Parameters: integer mode

Parameter | Description
mode | May be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either Next_Record, First_Record, or Last_Record

Description

Request_superfind performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result. Find_mode may be any of the standard find modes, i.e., lt, le, eq, ge, or gt, or it may be either next_record, first_record, or last_record. Sets the found indicator to reflect the success or failure of the find operation. Sends of request_superfind to a DSO require Predefined Indicator err to be set to false beforehand, in case an error other than Find past end of file or Find prior to beginning of file is generated by the superfind. Sent by DEOs.

Last Edited: September 11, 2003


Properties for dbTabDialog_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | TabDialog_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | TabDialog_
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Button_Count | Returns the number of tabs in this object | TabDialog
Changed_State | Determines if one or more of the child objects has changed |
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | TabDialog_
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Current_Tab | Returns the number of the tab in this object that has the focus | TabDialog
Default_Tab | Determines what tab page will be displayed as a default | TabDialog
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true |
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | TabDialog_
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | TabDialog_
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | TabDialog_
Help_Keyword | Used to specify an object's context keyword | TabDialog_
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled | TabDialog_
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | TabDialog_
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | TabDialog_
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
MultiLine_State | Determines if tabs will wrap across multiple lines | TabDialog
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
NumberOfRows | Returns the number of rows of tabs that are displayed | TabDialog
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | TabDialog_
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | TabDialog_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbFlatSeparators | Determines if separators are drawn | TabDialog
pbHotTrack | Determines hot-tracking on the labels of the tab-pages | TabDialog
pbResetPageOnActivate | Determines how a tab dialog should behave when the dialog takes the focus as part of forward keyboard activation | TabDialog
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peTabPosition | Determines if positions of the tabs are at the top or the bottom of the tab-dialog | TabDialog
peTabStyle | Determines if tabs are displayed as tabs or buttons | TabDialog
phoImageList | Permits images to be displayed on tab-pages | TabDialog
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Pointer_only_State | Determines how tab buttons will respond to the mouse | TabDialog
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | TabDialog_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Rotate_Mode | Governs cursor movement on keyboard navigation when the Next key is pressed in the last object in a tab page | TabDialog
Row_Offset | Determines the offset to the invoking item by number of rows | TabDialog_
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object |
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_Button_Mode | Governs the way tab button navigation is done with the keyboard and mouse (when pointer_only_state is True) | TabDialog
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | TabDialog_
Tab_page_Id | Contains the object_ID of the tab_page object associated with each of this object's items | TabDialog
TabWidth_Mode | Makes each tab just wide enough to display its label, all the same width on each line sufficient to fill the width of this object, or all the width of the widest tab in the object | TabDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Tooltip_State |  | DfBasetabDialog
Tooltip_Value |  | DfBasetabDialog
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | TabDialog_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation |
Verify_Delete_Msg | Specifies the message to use for delete confirmation |
verify_exit_msg | Determines what message is sent during an exiting event |
Verify_Save_Msg | Specifies the message to use for save confirmation |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


dbTabDialog_ [Property Auto_Clear_DEO_State]

Auto_Clear_DEO_State - dbTabDialog_

Determines if object will clear after a successful save occurs

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_clear_deo_state property is true, this object will clear after a successful save occurs. Intended to be set.

Default is true.

Last Edited: January 12, 2006


dbTabDialog_ [Property Auto_Fill_State]

Auto_Fill_State - dbTabDialog_

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


dbTabDialog_ [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - dbTabDialog_

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


dbTabDialog_ [Property Changed_State]

Changed_State - dbTabDialog_

Determines if one or more of the child objects has changed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If this flag is true, one or more of the child objects has changed. Augmented to set changed_state of server to true when changed_state of this object is set to true. Also augmented to detach this object from its server when set to false while this object is inactive.

This object will not save when this state is false. When necessary (as when changes are made other than through the keyboard), set this state to true explicitly.

Default is false.

Last Edited: January 12, 2006


dbTabDialog_ [Property Deferred_State]

Deferred_State - dbTabDialog_

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


dbTabDialog_ [Property deo_delegate_mode]

deo_delegate_mode - dbTabDialog_

Controls those requests for which delegate_..._state is set true

Type: Property

Access: Read/Write

Data Type: Integer

Description

Deo_delegate_mode controls those requests for which delegate_..._state is set true. The default delegate_server mode delegates request messages for objects that are not explicitly using a DDO. Delegate_always delegates regardless of whether a server is declared for the object, and delegate_never never delegates. This behavior may be set globally rather than just for this object by setting a function named default_deo_delegate_mode, and may also be queried with get.

Default is delegate_server.

Last Edited: July 31, 2003


dbTabDialog_ [Property Server]

Server - dbTabDialog_

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


dbTabDialog_ [Property Should_Save]

Should_Save - dbTabDialog_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


dbTabDialog_ [Property Verify_Data_Loss_Msg]

Verify_Data_Loss_Msg - dbTabDialog_

Specifies the message to use for data loss confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for data loss confirmation.

Sample

This sample turns off data loss confirmation.

set Verify_Data_Loss_msg to get_No_Confirmation

Sample

This sample sets data loss confirmation to the default data loss message.

set Verify_Data_Loss_msg to get_Data_Loss_Confirmation

Sample

This sample sets data loss confirmation to a custom confirmation message.

Function MyDataLossConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Data Loss Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDataLossConfirmation

set Verify_Data_Loss_msg to get_MyDataLossConfirmation

Last Edited: February 16, 2005


dbTabDialog_ [Property Verify_Delete_Msg]

Verify_Delete_Msg - dbTabDialog_

Specifies the message to use for delete confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record delete confirmation.

Sample

This sample turns off delete confirmation.

set Verify_Delete_Msg to get_No_Confirmation

Sample

This sample sets delete confirmation to the default delete confirmation message.

set Verify_Delete_Msg to get_Delete_Confirmation

Sample

This sample sets delete confirmation to a custom confirmation message.

Function MyDeleteConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to delete a record. Proceed?", "Delete Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyDeleteConfirmation

set Verify_Delete_Msg to get_MyDeleteConfirmation

Last Edited: February 16, 2005


dbTabDialog_ [Property verify_exit_msg]

verify_exit_msg - dbTabDialog_

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


dbTabDialog_ [Property Verify_Save_Msg]

Verify_Save_Msg - dbTabDialog_

Specifies the message to use for save confirmation

Type: Property

Access: Read/Write

Data Type: Integer

Description

Specifies the message to use for record save confirmation.

Sample

This sample turns off save confirmation.

set Verify_Save_Msg to get_No_Confirmation

Sample

This sample sets save confirmation to the default save confirmation message.

set Verify_Save_Msg to get_Save_Confirmation

Sample

This sample sets save confirmation to a custom confirmation message.

Function MySaveConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to save a record. Proceed?", "Save Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MySaveConfirmation

set Verify_Save_Msg to get_MySaveConfirmation

Last Edited: February 16, 2005


Events for dbTabDialogView

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent to the tab-dialog when Beginning_of_panel is sent by a parent | TabDialog
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDisplay |  | TabDialog
OnKillFocus | Sent whenever the object is about to lose the focus | TabDialog_
OnResize | Fires when the tab-dialog is created and whenever it is resized | TabDialog
OnSetFocus | Sent whenever windows is about to give this object the focus | TabDialog_
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | TabDialog_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | TabDialog_


Methods for dbTabDialogView

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | TabDialog_
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Auto_Page | Procedure |  | DfBasetabDialog
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | TabDialog_
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | TabDialog_
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open | dbTabDialog
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | TabDialog_
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | TabDialog_
Error_Help | Procedure | (Obsolete) | TabDialog_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbTabDialog_
Exit_Loss_Confirmation | Function |  | dbTabDialog
Extended_Help | Procedure | (Obsolete) | TabDialog_
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | TabDialog_
Help | Procedure |  | TabDialog_
Help_For_Help | Procedure | (Obsolete) | TabDialog_
Help_Index | Procedure | (Obsolete) | TabDialog_
Help_on_topic | Procedure | (Obsolete) | TabDialog_
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | TabDialog_
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | TabDialog_
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | TabDialog_
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbTabDialog_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbTabDialog_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbTabDialog_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbTabDialog_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbTabDialog_
Request_Next_Tab | Procedure | Causes the next tab page to be displayed | TabDialog
Request_Previous_Tab | Procedure | Causes the previous tab page to be displayed and take the focus | TabDialog
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbTabDialog_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbTabDialog_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | TabDialog_
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbTabDialog_
Request_Switch_To_Tab | Procedure | Displays and activates the requested tab# | TabDialog
Request_Tab_Display | Procedure | Causes the selected tab page to be displayed but does not give the page the focus | TabDialog
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | TabDialog_
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbTabDialog_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbTabDialog_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbTabDialog_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbTabDialog_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for dbTabDialogView

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbTabDialog_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbTabDialog_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | TabDialog_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbTabDialog_
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | TabDialog_
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Button_Count | Returns the number of tabs in this object | TabDialog
Changed_State | Determines if one or more of the child objects has changed | dbTabDialog_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | TabDialog_
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Current_Tab | Returns the number of the tab in this object that has the focus | TabDialog
Default_Tab | Determines what tab page will be displayed as a default | TabDialog
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbTabDialog_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbTabDialog_
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | TabDialog_
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | TabDialog_
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | TabDialog_
Help_Keyword | Used to specify an object's context keyword | TabDialog_
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled | TabDialog_
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | TabDialog_
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | TabDialog_
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
MultiLine_State | Determines if tabs will wrap across multiple lines | TabDialog
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
NumberOfRows | Returns the number of rows of tabs that are displayed | TabDialog
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | TabDialog_
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | TabDialog_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbFlatSeparators | Determines if separators are drawn | TabDialog
pbHotTrack | Determines hot-tracking on the labels of the tab-pages | TabDialog
pbResetPageOnActivate | Determines how a tab dialog should behave when the dialog takes the focus as part of forward keyboard activation | TabDialog
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peTabPosition | Determines if positions of the tabs are at the top or the bottom of the tab-dialog | TabDialog
peTabStyle | Determines if tabs are displayed as tabs or buttons | TabDialog
phoImageList | Permits images to be displayed on tab-pages | TabDialog
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Pointer_only_State | Determines how tab buttons will respond to the mouse | TabDialog
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | TabDialog_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Rotate_Mode | Governs cursor movement on keyboard navigation when the Next key is pressed in the last object in a tab page | TabDialog
Row_Offset | Determines the offset to the invoking item by number of rows | TabDialog_
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbTabDialog_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbTabDialog_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_Button_Mode | Governs the way tab button navigation is done with the keyboard and mouse (when pointer_only_state is True) | TabDialog
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | TabDialog_
Tab_page_Id | Contains the object_ID of the tab_page object associated with each of this object's items | TabDialog
TabWidth_Mode | Makes each tab just wide enough to display its label, all the same width on each line sufficient to fill the width of this object, or all the width of the widest tab in the object | TabDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Tooltip_State |  | DfBasetabDialog
Tooltip_Value |  | DfBasetabDialog
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | TabDialog_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbTabDialog_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbTabDialog_
verify_exit_msg | Determines what message is sent during an exiting event | dbTabDialog_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbTabDialog_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


dbTabPage [Event OnResize]

OnResize - dbTabPage

Fires when the tab-page is created and whenever it is resized

Type: Event

Parameters: No Parameters

Description

OnResize fires when the tab-page is created and whenever it is resized.

Last Edited: September 10, 2003


Events for dbTabPage

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnResize | Fires when the tab-page is created and whenever it is resized |
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d


Methods for dbTabPage

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open | dbContainer3d
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbContainer3d_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbContainer3d_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbContainer3d_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbContainer3d_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbContainer3d_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbContainer3d_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbContainer3d_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbContainer3d_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbContainer3d_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbContainer3d_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbContainer3d_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbContainer3d_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbContainer3d_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for dbTabPage

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbContainer3d_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbContainer3d_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbContainer3d_
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Button_Shadow_State | Determines if both the page and the button will be shadowed |
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | dbContainer3d_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbContainer3d_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbContainer3d_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label |  |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
pbHighlightTab | Highlights the tab, using the Windows clHighlight color |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piImageIndex | The index of the image from the tab-dialog's imagelist |
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbContainer3d_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbContainer3d_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Tab_Button_item | Contains this tab-page's item number |
Tab_ToolTip_Value | Sets the text that is displayed as a tool tip for this object's tab in the container tab-dialog object |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbContainer3d_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbContainer3d_
verify_exit_msg | Determines what message is sent during an exiting event | dbContainer3d_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbContainer3d_
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbTabPage [Property Button_Shadow_State]

Button_Shadow_State - dbTabPage

Determines if both the page and the button will be shadowed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Button_shadow_state property is set true, both the page and the button will be shadowed, making it impossible to ever display the shadowed tab page.

Default is false.

Last Edited: January 12, 2006


dbTabPage [Property Label]

Label - dbTabPage

Type: Property

Access: Write-Only

Data Type: String

Description

Last Edited: February 13, 2003


dbTabPage [Property pbHighlightTab]

pbHighlightTab - dbTabPage

Highlights the tab, using the Windows clHighlight color

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbHighlightTab highlights the tab, using the Windows clHighlight color.

Default is false.

Last Edited: January 16, 2006


dbTabPage [Property piImageIndex]

piImageIndex - dbTabPage

The index of the image from the tab-dialog's imagelist

Type: Property

Access: Read/Write

Data Type: Integer

Description

piImageIndex is the index of the image from the tab-dialog's imagelist. Before images can be displayed, the phoImageList property of the tab-dialog must be set the object-handle of a cImageList-derived object.

Default is 0.

Last Edited: September 11, 2003


dbTabPage [Property Tab_Button_item]

Tab_Button_item - dbTabPage

Contains this tab-page's item number

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Tab_button_item property contains this tab-page's item number. The parent tab-dialog object keeps track of each tab-age with an item number. This property may not be set.

Default is 1.

Last Edited: September 11, 2003


dbTabPage [Property Tab_ToolTip_Value]

Tab_ToolTip_Value - dbTabPage

Sets the text that is displayed as a tool tip for this object's tab in the container tab-dialog object

Type: Property

Access: Read/Write

Data Type: String

Description

The Tab_tooltip_value property sets the text that is displayed as a tool tip for this object's tab in the container tab-dialog object.

Default is "text".

Last Edited: September 11, 2003


dbTabView [Event OnResize]

OnResize - dbTabView

Fires when the tab-page is created and whenever it is resized

Type: Event

Parameters: No Parameters

Description

OnResize fires when the tab-page is created and whenever it is resized.

Last Edited: September 10, 2003


Events for dbTabView

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Closing_View |  | dbTabView_
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnResize | Fires when the tab-page is created and whenever it is resized |
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Opening_View |  | dbTabView_
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared | dbTabView_
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used | dbTabView_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d


Methods for dbTabView

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open | dbContainer3d
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Application_Check | Function |  | dbTabView_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbContainer3d_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbContainer3d_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbContainer3d_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbContainer3d_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbContainer3d_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbContainer3d_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbContainer3d_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbContainer3d_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbContainer3d_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbContainer3d_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbContainer3d_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbContainer3d_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbContainer3d_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for dbTabView

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbContainer3d_
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to | dbTabView_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbContainer3d_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Auto_Top_Item_State |  | dbTabView_
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbContainer3d_
Auto_top_view_State |  | dbTabView_
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Button_Shadow_State | Determines if both the page and the button will be shadowed |
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | dbContainer3d_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbContainer3d_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Attach_All_State |  | dbTabView_
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbContainer3d_
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view | dbTabView_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label |  |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function | dbTabView_
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
pbHighlightTab | Highlights the tab, using the Windows clHighlight color |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piImageIndex | The index of the image from the tab-dialog's imagelist |
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
priInitialRowId |  | dbTabView_
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbContainer3d_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbContainer3d_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Tab_Button_item | Contains this tab-page's item number |
Tab_ToolTip_Value | Sets the text that is displayed as a tool tip for this object's tab in the container tab-dialog object |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbContainer3d_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbContainer3d_
verify_exit_msg | Determines what message is sent during an exiting event | dbContainer3d_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbContainer3d_
View_Latch_State | Determines if the view's DSO structure will be initialized with the data | dbTabView_
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbTabView [Property Button_Shadow_State]

Button_Shadow_State - dbTabView

Determines if both the page and the button will be shadowed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Button_shadow_state property is set true, both the page and the button will be shadowed, making it impossible to ever display the shadowed tab page.

Default is false.

Last Edited: January 12, 2006


dbTabView [Property Label]

Label - dbTabView

Type: Property

Access: Write-Only

Data Type: String

Description

Last Edited: February 13, 2003


dbTabView [Property pbHighlightTab]

pbHighlightTab - dbTabView

Highlights the tab, using the Windows clHighlight color

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbHighlightTab highlights the tab, using the Windows clHighlight color.

Default is false.

Last Edited: January 16, 2006


dbTabView [Property piImageIndex]

piImageIndex - dbTabView

The index of the image from the tab-dialog's imagelist

Type: Property

Access: Read/Write

Data Type: Integer

Description

piImageIndex is the index of the image from the tab-dialog's imagelist. Before images can be displayed, the phoImageList property of the tab-dialog must be set the object-handle of a cImageList-derived object.

Default is 0.

Last Edited: September 11, 2003


dbTabView [Property Tab_Button_item]

Tab_Button_item - dbTabView

Contains this tab-page's item number

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Tab_button_item property contains this tab-page's item number. The parent tab-dialog object keeps track of each tab-age with an item number. This property may not be set.

Default is 1.

Last Edited: September 11, 2003


dbTabView [Property Tab_ToolTip_Value]

Tab_ToolTip_Value - dbTabView

Sets the text that is displayed as a tool tip for this object's tab in the container tab-dialog object

Type: Property

Access: Read/Write

Data Type: String

Description

The Tab_tooltip_value property sets the text that is displayed as a tool tip for this object's tab in the container tab-dialog object.

Default is "text".

Last Edited: September 11, 2003


dbTabView_ [Event Closing_View]

Closing_View - dbTabView_

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


dbTabView_ [Event Opening_View]

Opening_View - dbTabView_

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


dbTabView_ [Event Prepare_Data_Sets]

Prepare_Data_Sets - dbTabView_

Provides the developer a chance to check the condition of any file buffers before they are cleared

Type: Event

Parameters: No Parameters

Description

Prepare_data_sets is a hook procedure with no definition. It is sent during view activation. This provides the developer a chance to check the condition of any file buffers before they are cleared. Usually record numbers are stored in properties and then used by seed_data_sets.

Last Edited: September 11, 2003


dbTabView_ [Event Seed_data_sets]

Seed_data_sets - dbTabView_

Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used

Type: Event

Parameters: No Parameters

Description

The Seed_data_sets message is set when main_DD has been set and view_latch_state is true. By default it initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began. This causes the view to appear to "latch" on to the last record used. This can be augmented to customize the contents of the DSO (and also their attached DEOs).

Last Edited: September 11, 2003


Events for dbTabView_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Closing_View |  |
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Opening_View |  |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared |
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d


dbTabView_ [Function Exit_Application_Check]

Exit_Application_Check - dbTabView_

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


Methods for dbTabView_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open | dbContainer3d
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Application_Check | Function |  |
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbContainer3d_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbContainer3d_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbContainer3d_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbContainer3d_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbContainer3d_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbContainer3d_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbContainer3d_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbContainer3d_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbContainer3d_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbContainer3d_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbContainer3d_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbContainer3d_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbContainer3d_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for dbTabView_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbContainer3d_
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbContainer3d_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Auto_Top_Item_State |  |
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbContainer3d_
Auto_top_view_State |  |
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | dbContainer3d_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbContainer3d_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Attach_All_State |  |
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbContainer3d_
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function |
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
priInitialRowId |  |
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbContainer3d_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbContainer3d_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbContainer3d_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbContainer3d_
verify_exit_msg | Determines what message is sent during an exiting event | dbContainer3d_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbContainer3d_
View_Latch_State | Determines if the view's DSO structure will be initialized with the data |
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbTabView_ [Property Auto_Dependent_item_State]

Auto_Dependent_item_State - dbTabView_

Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If you set the auto_dependent_item_state property true, all items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to.

Default is false.

Last Edited: January 12, 2006


dbTabView_ [Property Auto_Top_Item_State]

Auto_Top_Item_State - dbTabView_

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


dbTabView_ [Property Auto_top_view_State]

Auto_top_view_State - dbTabView_

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


dbTabView_ [Property DEO_Attach_All_State]

DEO_Attach_All_State - dbTabView_

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


dbTabView_ [Property DSO_Detach_Mode]

DSO_Detach_Mode - dbTabView_

Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view

Type: Property

Access: Read/Write

Data Type: Integer

Description

The DSO_Detach_Mode property specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view.

Detach_always (the default), causes all DSOs to become "not in-use". The DSO buffers are all cleared and, if changes exist in the view, they will be lost. The next time the view is activated the DSO structure will be reinitialized. This is the most windows-like setting. When views are closed, all changes are lost. If you wish to hide a changed view, you can minimize it.

Detach_never causes the DSOs to remain in-use. When reactivated, the view will contain and display all previous data (including any unsaved changes).

Detach_if_no_change allows the DSOs to become "not in-use" only if there are no unsaved changed.

Default is Detach_Always.

Last Edited: August 5, 2003


dbTabView_ [Property Main_DD]

Main_DD - dbTabView_

Identifies the dataDictionary object that controls the database file whose data is central to this object's function

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Main_DD property identifies the dataDictionary object that controls the database file whose data is central to this object's function. It must be one of the dataDictionarys contained within this object.

Last Edited: August 18, 2003


dbTabView_ [Property priInitialRowId]

priInitialRowId - dbTabView_

Type: Property

Access: Read/Write

Data Type: RowId

Description

Last Edited: November 11, 2004


dbTabView_ [Property View_Latch_State]

View_Latch_State - dbTabView_

Determines if the view's DSO structure will be initialized with the data

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When View_Latch_State is set true, the view's DSO structure will be initialized with the data that happens to be in the record buffer of the main_dd

When View_Latch_State is set false, the view's DSO structure will initialize with cleared data.

Default is true.

Last Edited: January 16, 2006


dbTrackBar [Event OnFinishedSliding]

OnFinishedSliding - dbTrackBar

Sent whenever the slider has stopped moving by either the mouse or keyboard interface

Type: Event

Parameters: No Parameters

Description

The OnFinishedSliding message is sent whenever the slider has stopped moving by either the mouse or keyboard interface.

Last Edited: September 10, 2003


dbTrackBar [Event OnGoneToEnd]

OnGoneToEnd - dbTrackBar

Sent when a user pressed the End key to take the slider to the end

Type: Event

Parameters: No Parameters

Description

The OnGoneToEnd event is sent when a user pressed the End key to take the slider to the end. At this point Current_Position will equal Maximum_Position.

Last Edited: September 10, 2003


dbTrackBar [Event OnGoneToStart]

OnGoneToStart - dbTrackBar

Sent when a user pressed the Home key to return the slider to the beginning of the track

Type: Event

Parameters: No Parameters

Description

The OnGoneToStart event is sent when a user pressed the Home key to return the slider to the beginning of the track. At this point Current_Position will equal Minimum_Position.

Last Edited: September 10, 2003


dbTrackBar [Event OnLineDown]

OnLineDown - dbTrackBar

Sent when a user presses one of the arrow keys to increment the Current_Position by the value of Line_Size

Type: Event

Parameters: No Parameters

Description

The OnLineDown message is sent when a user presses one of the arrow keys to increment the Current_Position by the value of Line_Size.

Last Edited: September 10, 2003


dbTrackBar [Event OnLineUp]

OnLineUp - dbTrackBar

Sent when a user presses one of the arrow keys todecrement the Current_Position by the value of Line_Size

Type: Event

Parameters: No Parameters

Description

The OnLineUp message is sent when a user presses one of the arrow keys to decrement the Current_Position by the value of Line_Size.

Last Edited: September 10, 2003


dbTrackBar [Event OnPageDown]

OnPageDown - dbTrackBar

Sent when a user presses the PageDown key to increment the Current_Position by the value of Page_Size

Type: Event

Parameters: No Parameters

Description

The OnPageDown message is sent when a user presses the PageDown key to increment the Current_Position by the value of Page_Size.

Last Edited: September 10, 2003


dbTrackBar [Event OnPageUp]

OnPageUp - dbTrackBar

Sent when a user presses the PageUp key to decrement the Current_Position by the value of Page_Size

Type: Event

Parameters: No Parameters

Description

The OnPageUp message is sent when a user presses the PageUp key to decrement the Current_Position by the value of Page_Size.

Last Edited: September 10, 2003


dbTrackBar [Event OnSetPosition]

OnSetPosition - dbTrackBar

Sent whenever the value of Current_Position changes

Type: Event

Parameters: No Parameters

Description

The OnSetPosition message is sent whenever the value of Current_Position changes.

Last Edited: September 10, 2003


dbTrackBar [Event OnSliding]

OnSliding - dbTrackBar

Sent when a user drags the slider with the mouse

Type: Event

Parameters: No Parameters

Description

The OnSliding message is sent when a user drags the slider with the mouse.

Last Edited: September 10, 2003


Events for dbTrackBar

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Entry_Defaults | "Hook" for providing default-setting routines | dbForm_
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message | Entry
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Entry
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | Entry
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFinishedSliding | Sent whenever the slider has stopped moving by either the mouse or keyboard interface |
OnGoneToEnd | Sent when a user pressed the End key to take the slider to the end |
OnGoneToStart | Sent when a user pressed the Home key to return the slider to the beginning of the track |
OnKillFocus | Sent whenever the object is about to lose the focus | Entry
OnLineDown | Sent when a user presses one of the arrow keys to increment the Current_Position by the value of Line_Size |
OnLineUp | Sent when a user presses one of the arrow keys todecrement the Current_Position by the value of Line_Size |
OnMaxText |  | Entry
OnPageDown | Sent when a user presses the PageDown key to increment the Current_Position by the value of Page_Size |
OnPageUp | Sent when a user presses the PageUp key to decrement the Current_Position by the value of Page_Size |
OnSetFocus | Sent whenever windows is about to give this object the focus | Entry
OnSetPosition | Sent whenever the value of Current_Position changes |
OnSliding | Sent when a user drags the slider with the mouse |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Entry
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | Entry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for dbTrackBar

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Entry
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Finds and displays the first record of the file specified by the data_file of the current_item of this object | dbForm_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Entry
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Entry
Cancel | Procedure | Returns the message_id of itself | cUIObject
CheckBox_Item | Procedure Set | Set after each item of this object that you wish to be a checkbox | dbForm_
Close_Panel | Procedure | Closes the panel or component currently open | dbFormDS
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | Entry
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | Entry
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | dbFormDS
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Entry
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Finds and displays the last record of the file specified by the data_file of the current_item of this object | dbForm_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Entry
Entry_Autofind | Procedure | Finds using specified mode and data_file and data_field of current item, redisplaying the items if the find was successful | dbForm_
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | Entry
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | dbForm_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | dbForm_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | dbForm_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbForm_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Entry
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Entry
Find_First | Procedure | Finds the first valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_GE | Procedure | Performs a find greater than or equal by the data_file and data_field of the current item, using request_find | dbForm_
Find_Last | Procedure | Finds the last valid record for a DEO object based on the file and field assigned to the DEO's current item | dbForm_
Find_Next | Procedure | Performs a find greater than by the data_file and data_field of the current item, using request_find | dbForm_
Find_Previous | Procedure | Performs a find less than by the data_file and data_field of the current item, using request_find | dbForm_
Help | Procedure |  | Entry
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | Entry
Help_For_Help | Procedure | (Obsolete) | Entry
Help_Index | Procedure | (Obsolete) | Entry
Help_on_topic | Procedure | (Obsolete) | Entry
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Entry
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Makes validation in validate_on_save_next mode occur regardless of the state of object_validation | dbForm_
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Entry
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | Entry
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Entry
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | dbForm_
Prompt_Description | Function | (Obsolete) | dbFormDS
Prompt_Description | Procedure | (Obsolete) | dbFormDS
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbForm_
Request_Clear | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Clear_All | Procedure | Clears items, and changes focus to first item in this object if auto_top_panel_state is true | dbForm_
Request_Delete | Procedure | Deletes the current record of this object's server, if any | dbForm_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds record using specified mode by requesting item_find from server, if any | dbForm_
Request_Save | Procedure |  | dbFormDS
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbForm_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Entry
Request_Superfind | Procedure | Superfinds record using specified mode by requesting item_superfind from server, if any | dbForm_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
SuperFind | Procedure | Performs a superfind greater than or equal by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Next | Procedure | Performs a superfind greater than by the data_file and data_field of the current item, using request_superfind | dbForm_
SuperFind_Previous | Procedure | Performs a superfind less than by the data_file and data_field of the current item, using request_superfind | dbForm_
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Entry
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Manipulates the value of validate_items when validate_mode is validate_default, and gives this object the focus in the event validation of any item fails | dbForm_
Validate_Prompt | Function | (Obsolete) | dbFormDS
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbForm_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbForm_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbForm_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbForm_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | dbForm_


Properties for dbTrackBar

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | If true, this object will clear after a successful save occurs | dbForm_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbForm_
Auto_Label_State | Determines if this object will draw label values from the DDO rather than from any label that may be set in this object | dbForm
Auto_Save_State | Determines if auto save should be performed | dbForm_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbForm_
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | Entry
Changed_State | Set when users change information in the items of the menu | DfBaseList
Changed_Value | Changes the value property of Item item# to value and sets its item_changed_state to true, as well as the changed_state of this object | dbForm_
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
ControlValue |  |
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Position | Contains the absolute position of the slider |
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Default_Value | Changes the value property of Item item# to value, but leaves its item_changed_state unchanged | dbForm_
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbForm_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Control_Object | Indicates whether the control is a Data Entry Object (DEO) | dbFormDS
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbForm_
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Entry
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Entry
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | Entry
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Entry
Help_Keyword | Used to specify an object's context keyword | Entry
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | Entry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Entry
Label_Col_Offset | The horizontal distance from the object to its label | Entry
Label_Justification_Mode | The justification mode for the text within this object's label | Entry
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Entry
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Entry
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Determines the amount the Current_Position changes whenever users move the slider by use of the arrow keys |
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Maintains the absolute value of the slider when it is slid to its maximum position |
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Maintains the absolute value of the slider when it is slid to its lowest position |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Entry
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Orientation_Mode | Specifies whether the control should be displayed horizontally or vertically |
Page_Size | Determines the amount the Current_Position changes whenever users move the slider by use of the PageUp or PageDown keys |
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbTooltips | Determines if tooltips should be displayed for this object |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form | Entry
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object | Entry
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Entry
Retain_no_Change_state | Determines if the item_changed_state of items have true or false values | dbForm_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | dbForm_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbForm_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Entry
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Tick_Frequency | Maintains the increment at which to display tick marks |
Tick_Orientation | Specifies where the ticks should be placed in relation to the slider |
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Entry
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Validate_All_Items_State | Determines if all items are being validated | dbForm_
Validate_Mode | Determines how and when object validation occurs | dbForm_
Value | Gets and sets the data value for an item | DfBaseList
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbForm_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbForm_
verify_exit_msg | Determines what message is sent during an exiting event | dbForm_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbForm_
Visible_State | Determines whether object is visible | cUIObject
Visible_Tick_State | Specifies whether tick marks are displayed in the control |
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


dbTrackBar [Property ControlValue]

ControlValue - dbTrackBar

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


dbTrackBar [Property Current_Position]

Current_Position - dbTrackBar

Contains the absolute position of the slider

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Current_Position property contains the absolute position of the slider. The value is in the range of 0-65,535

Default is 0.

Last Edited: July 31, 2003


dbTrackBar [Property Line_Size]

Line_Size - dbTrackBar

Determines the amount the Current_Position changes whenever users move the slider by use of the arrow keys

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Line_Size property determines the amount the Current_Position changes whenever users move the slider by use of the arrow keys. The value is in the range of 0-65,535

Default is 1.

Last Edited: August 18, 2003


dbTrackBar [Property Maximum_Position]

Maximum_Position - dbTrackBar

Maintains the absolute value of the slider when it is slid to its maximum position

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Maximum_Position property maintains the absolute value of the slider when it is slid to its maximum position. The value is in the range of 0-65,535

Default is 100.

Last Edited: August 18, 2003


dbTrackBar [Property Minimum_Position]

Minimum_Position - dbTrackBar

Maintains the absolute value of the slider when it is slid to its lowest position

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Minimum_Position property maintains the absolute value of the slider when it is slid to its lowest position. The value is in the range of 0-65,535

Default is 0.

Last Edited: August 18, 2003


dbTrackBar [Property Orientation_Mode]

Orientation_Mode - dbTrackBar

Specifies whether the control should be displayed horizontally or vertically

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Orientation_Mode property specifies whether the control should be displayed horizontally or vertically.

Default is slHorz.

Last Edited: September 10, 2003


dbTrackBar [Property Page_Size]

Page_Size - dbTrackBar

Determines the amount the Current_Position changes whenever users move the slider by use of the PageUp or PageDown keys

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Page_Size property determines the amount the Current_Position changes whenever users move the slider by use of the PageUp or PageDown keys. The value is in the range of 0-65,535.

The default value means that users can 'page' five times from the minimum value to the maximum value.

Default is (maximum_value -minimum_value) /5.

Last Edited: September 10, 2003


dbTrackBar [Property pbTooltips]

pbTooltips - dbTrackBar

Determines if tooltips should be displayed for this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Set the pbTooltips property to True to display a tooltip, showing the value of the Current_Position property, whenever the slider is dragged with the mouse.

Note: You can only change this property at design-time. In other words, once the object has been created, any changes to this property will be ignored.

Default is true.

Last Edited: September 10, 2003


dbTrackBar [Property Tick_Frequency]

Tick_Frequency - dbTrackBar

Maintains the increment at which to display tick marks

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Tick_Frequency property maintains the increment at which to display tick marks. For example, using default values and a Tick_Frequency of 25, ticks would be placed at values 0, 25, 50, 75, 100. The value is in the range of 0-65,535

Default is 5.

Last Edited: September 11, 2003


dbTrackBar [Property Tick_Orientation]

Tick_Orientation - dbTrackBar

Specifies where the ticks should be placed in relation to the slider

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Tick_Orientation property specifies where the ticks should be placed in relation to the slider. tkTOP, for example, means on top of the control (assuming the control had an Orientation_Mode of slHorz). tkBoth means on top and on bottom (or on left and right if vertical). The slider box points in the direction of the ticks, unless they are on both sides of the control.

Default is tkTop.

Last Edited: September 11, 2003


dbTrackBar [Property Visible_Tick_State]

Visible_Tick_State - dbTrackBar

Specifies whether tick marks are displayed in the control

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Visible_Tick_State property specifies whether tick marks are displayed in the control.

Default is true.

Last Edited: January 12, 2006


Events for dbView

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Closing_View |  | dbAppView_
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Exit_Application | Called when an application is about to be closed | AppDialog
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnPaint | Sent every time a panel is painted | MdiDialog
OnResize | Sent every time a panel is resized | MdiDialog
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Opening_View |  | dbAppView_
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared | dbAppView_
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used | dbAppView_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d
Verify_Exit_Application | Sent by the client area to verify that an application may be exited | AppDialog


Methods for dbView

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Activate_View | Procedure | Activates the view | AppDialog
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area | MdiDialog
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Application_Check | Function |  | dbAppView_
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbAppClient_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | MdiDialog
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbAppClient_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbAppClient_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbAppClient_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbAppClient_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbAppClient_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbAppClient_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbAppClient_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbAppClient_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | MdiDialog
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbAppClient_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbAppClient_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbAppClient_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbAppClient_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


dbView [Procedure Close_Panel]

Close_Panel - dbView

Closes the panel or component currently open

Type: Procedure

Parameters: No Parameters

Description

Closes the panel or component currently open. If the control Close_Panel is sent to is not a panel, the call will be delegated to it's parent.

For example, if a cDbRichEdit control is in a dbView, sending Close_Panel to the cDbRichEdit control will close the dbView.

Sample

This sample causes the dbView control oDbView1 to close when button oCloseButton is clicked.

Object oDbView1 is a dbView
    :
    Object oDbRichEdit1 is a cDbRichEdit
        :
    End_Object  // oDbRichEdit1
    :
    Object oCloseButton is a Button
        :
        Procedure OnClick
            send Close_Panel of oDbRichEdit1
        End_Procedure  // OnClick
        :
    End_Object  // oCloseButton
    :
End_Object  // oDbView1

Last Edited: November 24, 2004


Properties for dbView

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbAppClient_
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to | dbAppView_
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbAppClient_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Auto_Top_Item_State |  | dbAppView_
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbAppClient_
Auto_top_view_State |  | dbAppView_
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | dbAppClient_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | MdiDialog
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | MdiDialog
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbAppClient_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Attach_All_State |  | dbAppView_
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbAppClient_
DEO_Object | Indicates whether the control is a Data Entry Object (DEO) container |
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view | dbAppView_
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function | dbAppView_
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | MdiDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
priInitialRowId |  | dbAppView_
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbAppClient_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbAppClient_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbAppClient_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbAppClient_
verify_exit_msg | Determines what message is sent during an exiting event | dbAppClient_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbAppClient_
View_Latch_State | Determines if the view's DSO structure will be initialized with the data | dbAppView_
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbView [Property DEO_Object]

DEO_Object - dbView

Indicates whether the control is a Data Entry Object (DEO) container

Type: Property

Access: Read-Only

Data Type: Integer

Description

Any DEO container has DEO_Object set true, which means that it is a DEO object, but a container, not a control.

Use DEO_Control_Object to determine whether a control is a DEO object rather than a DEO container. Any DEO control will also return true for DEO_Object because of delegation (DEO controls must always reside in DEO containers).

Last Edited: May 4, 2005


dbViewFloatingPanel [Event Closing_View]

Closing_View - dbViewFloatingPanel

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


dbViewFloatingPanel [Event Opening_View]

Opening_View - dbViewFloatingPanel

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


dbViewFloatingPanel [Event Prepare_Data_Sets]

Prepare_Data_Sets - dbViewFloatingPanel

Provides the developer a chance to check the condition of any file buffers before they are cleared

Type: Event

Parameters: No Parameters

Description

Prepare_data_sets is a hook procedure with no definition. It is sent during view activation. This provides the developer a chance to check the condition of any file buffers before they are cleared. Usually record numbers are stored in properties and then used by seed_data_sets.

Last Edited: September 11, 2003


dbViewFloatingPanel [Event Seed_data_sets]

Seed_data_sets - dbViewFloatingPanel

Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used

Type: Event

Parameters: No Parameters

Description

The Seed_data_sets message is set when main_DD has been set and view_latch_state is true. By default it initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began. This causes the view to appear to "latch" on to the last record used. This can be augmented to customize the contents of the DSO (and also their attached DEOs).

Last Edited: September 11, 2003


Events for dbViewFloatingPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Closing_View |  |
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Opening_View |  |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared |
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


dbViewFloatingPanel [Function Exit_Application_Check]

Exit_Application_Check - dbViewFloatingPanel

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


Methods for dbViewFloatingPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open | dbFloatingPanel
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Application_Check | Function |  |
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbFloatingPanel_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbFloatingPanel_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbFloatingPanel_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbFloatingPanel_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbFloatingPanel_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbFloatingPanel_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbFloatingPanel_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbFloatingPanel_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbFloatingPanel_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbFloatingPanel_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbFloatingPanel_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbFloatingPanel_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbFloatingPanel_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for dbViewFloatingPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbFloatingPanel_
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to |
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbFloatingPanel_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Auto_Top_Item_State |  |
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbFloatingPanel_
Auto_top_view_State |  |
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | dbFloatingPanel_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbFloatingPanel_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Attach_All_State |  |
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbFloatingPanel_
DEO_Object |  | dbFloatingPanel
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function |
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
priInitialRowId |  |
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbFloatingPanel_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbFloatingPanel_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbFloatingPanel_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbFloatingPanel_
verify_exit_msg | Determines what message is sent during an exiting event | dbFloatingPanel_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbFloatingPanel_
View_Latch_State | Determines if the view's DSO structure will be initialized with the data |
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


dbViewFloatingPanel [Property Auto_Dependent_item_State]

Auto_Dependent_item_State - dbViewFloatingPanel

Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If you set the auto_dependent_item_state property true, all items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to.

Default is false.

Last Edited: January 12, 2006


dbViewFloatingPanel [Property Auto_Top_Item_State]

Auto_Top_Item_State - dbViewFloatingPanel

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


dbViewFloatingPanel [Property Auto_top_view_State]

Auto_top_view_State - dbViewFloatingPanel

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


dbViewFloatingPanel [Property DEO_Attach_All_State]

DEO_Attach_All_State - dbViewFloatingPanel

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


dbViewFloatingPanel [Property DSO_Detach_Mode]

DSO_Detach_Mode - dbViewFloatingPanel

Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view

Type: Property

Access: Read/Write

Data Type: Integer

Description

The DSO_Detach_Mode property specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view.

Detach_always (the default), causes all DSOs to become "not in-use". The DSO buffers are all cleared and, if changes exist in the view, they will be lost. The next time the view is activated the DSO structure will be reinitialized. This is the most windows-like setting. When views are closed, all changes are lost. If you wish to hide a changed view, you can minimize it.

Detach_never causes the DSOs to remain in-use. When reactivated, the view will contain and display all previous data (including any unsaved changes).

Detach_if_no_change allows the DSOs to become "not in-use" only if there are no unsaved changed.

Default is Detach_Always.

Last Edited: August 5, 2003


dbViewFloatingPanel [Property Main_DD]

Main_DD - dbViewFloatingPanel

Identifies the dataDictionary object that controls the database file whose data is central to this object's function

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Main_DD property identifies the dataDictionary object that controls the database file whose data is central to this object's function. It must be one of the dataDictionarys contained within this object.

Last Edited: August 18, 2003


dbViewFloatingPanel [Property priInitialRowId]

priInitialRowId - dbViewFloatingPanel

Type: Property

Access: Read/Write

Data Type: RowId

Description

Last Edited: November 11, 2004


dbViewFloatingPanel [Property View_Latch_State]

View_Latch_State - dbViewFloatingPanel

Determines if the view's DSO structure will be initialized with the data

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When View_Latch_State is set true, the view's DSO structure will be initialized with the data that happens to be in the record buffer of the main_dd

When View_Latch_State is set false, the view's DSO structure will initialize with cleared data.

Default is true.

Last Edited: January 16, 2006


Events for dbViewToolPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Closing_View |  | dbViewFloatingPanel
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Opening_View |  | dbViewFloatingPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared | dbViewFloatingPanel
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used | dbViewFloatingPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


Methods for dbViewToolPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open | dbFloatingPanel
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Application_Check | Function |  | dbViewFloatingPanel
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbFloatingPanel_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbFloatingPanel_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbFloatingPanel_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbFloatingPanel_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbFloatingPanel_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbFloatingPanel_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbFloatingPanel_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbFloatingPanel_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbFloatingPanel_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbFloatingPanel_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbFloatingPanel_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbFloatingPanel_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbFloatingPanel_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for dbViewToolPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbFloatingPanel_
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to | dbViewFloatingPanel
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbFloatingPanel_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Auto_Top_Item_State |  | dbViewFloatingPanel
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbFloatingPanel_
Auto_top_view_State |  | dbViewFloatingPanel
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | dbFloatingPanel_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbFloatingPanel_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Attach_All_State |  | dbViewFloatingPanel
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbFloatingPanel_
DEO_Object |  | dbFloatingPanel
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view | dbViewFloatingPanel
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function | dbViewFloatingPanel
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
priInitialRowId |  | dbViewFloatingPanel
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbFloatingPanel_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbFloatingPanel_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbFloatingPanel_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbFloatingPanel_
verify_exit_msg | Determines what message is sent during an exiting event | dbFloatingPanel_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbFloatingPanel_
View_Latch_State | Determines if the view's DSO structure will be initialized with the data | dbViewFloatingPanel
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Events for DEOPopupMenu

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Initialize_Menu | Sent when the Menubar system is about to be selected | DfBaseActionBar
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChange | Called every time a menu changes | PopupMenu
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnInitMenu | Sent when a PopupMenu object is about to be selected | PopupMenu
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


DEOPopupMenu [Function Is_Function]

Is_Function - DEOPopupMenu

Returns a value from MsgId for ObjId

Type: Function

Return Data Type: Integer

Parameters: Integer MsgId Integer ObjId Integer DelegateFg

Parameter | Description
MsgId | The handle of the function name
ObjId | The object handle for the message
DelegateFg | Determines if delegation can be used to find the message

Return Value

Returns true if function is found

Description

Is_Function is used to return a value from MsgId for ObjId. If the function is not understood a zero will be returned (and an error will not occur). DelegateFg determines if the MsgId message can be delegated if not understood.

This is used to inquire if the object that invoked the menu (the focus object) is a DEO or if the object is a DEO control. This can be used inside of OnInitMenu to shadow items based on the type of invoking object.

To inquire if an object is a DEO the function should be:

Get is_Function Get_DEO_Object Obj# TRUE to IsDeo

To inquire if an object is a DEO control the function should be:

Get is_Function Get_DEO_Control_Object Obj# False to IsDeoControl

You can actually use this to indentify any type of object. Simple assign a unique function to an object or class and make that function return a 1. For example a dbGrid could be assigned the following function:

Function Im_a_Grid
    function_return 1
end_function

The popup menu could determine if the focus object is a grid with the following code:

Get Focus to Obj#
Get Is_Function Get_Im_a_Grid Obj# false to IsDeoControl

The DelegateFg parameter should be set to true, if it is appropriate for the item message to delegate to a valid parent. For example, it makes sense for any object within a DEO to be considered a DEO object and DelegateFg is set to true. It does not make sense to allow an object inside of a DEO control to be considered a DEO control and DelegateFg is set false.

The following example would disable all items in a menu if the invoking focus object is not a DEO.

Procedure OnInitMenu
    Integer IsDEO
    Integer Foc
    Integer Items Count

    Get Focus to Foc // the object that invoked the popup menu
    Get Is_Function Get_DEO_Object foc True to IsDeoControl
    Get Item_Count to Items
    Decrement Items
    For Count from 0 to Items
        Set Shadow_State item Count to (IsDEO=0) // shadow if NOT a DEO
    Loop
End_procedure

Last Edited: August 6, 2004


Methods for DEOPopupMenu

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Exit_Menu | Procedure |  | DfBaseActionBar
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Is_Function | Function | Returns a value from MsgId for ObjId |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Menu_Status_Help | Function |  | PopupMenu
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Redirect_Message | Procedure |  | DfBaseActionBar
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DEOPopupMenu

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Shadow_Status_Help | Specifies the display in the status bar for items of this object that are shadowed | PopupMenu
Simple_Status_Help_State |  | PopupMenu
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | The status-bar help text for Item item# | PopupMenu
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Events for DescriptionValidationTable

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Fill_List | Fills the list of entires in the validation table | ValidationTable


Methods for DescriptionValidationTable

View method list in hierarchical order

Name | Type | Description | Defining Class
Add_Table_Value | Procedure | Should be sent for each sDescription and sValue you wish to add to your validation table |
Create | Function | Creates an object based on the passed Class Id | cObject
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Find_Code_Description | Function |  | ValidationTable
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array
TableData | Function | Returns the validation table's data in a two dimensional variant array | ValidationTable
Validate_Value | Function | Determines whether a value is valid or not (is listed in the validation table or not) | ValidationTable


DescriptionValidationTable [Procedure Add_Table_Value]

Add_Table_Value - DescriptionValidationTable

Should be sent for each sDescription and sValue you wish to add to your validation table

Type: Procedure

Parameters: String sValue String sDescription RowId riRec

Parameter | Description
sValue | The short description for the element
sDescription | A longer description of the element
riRec | A user-definable value to associate with the element. This could be, for example, an object-handle or a record-id from a database table.

Description

Should be sent for each sDescription and sValue you wish to add to your validation table. The messages should be sent in the order in which you wish to have sDesciptions be presented in the list.

Last Edited: July 26, 2006


Properties for DescriptionValidationTable

View property list in hierarchical order

Name | Description | Defining Class
Allow_Blank_State | Controls whether blank entries are accepted in this object | ValidationTable
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Main_File | Identifies the data file from which the values are to be drawn to fill this object | ValidationTable
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Static_State | Determines whether object loads once per session or dynamically. | ValidationTable
Table_Title | The title shown in the caption bar of the validation table | ValidationTable
Validate_State | Determines whether values are validated against the items contained in the validation table. | ValidationTable
Value | Sets and Gets an array element's value | Array


DfBaseActionBar [Event Initialize_Menu]

Initialize_Menu - DfBaseActionBar

Sent when the Menubar system is about to be selected

Type: Event

Parameters: No Parameters

Description

The Initialize_menu message is sent when the Menubar system is about to be selected. It is used to notify the status bar that it is in "menu mode". It also sends the event message onInitMenu.

Last Edited: August 18, 2003


Events for DfBaseActionBar

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Initialize_Menu | Sent when the Menubar system is about to be selected |
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseActionBar

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Exit_Menu | Procedure |  |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Redirect_Message | Procedure |  |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


DfBaseActionBar [Procedure Exit_Menu]

Exit_Menu - DfBaseActionBar

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


DfBaseActionBar [Procedure Redirect_Message]

Redirect_Message - DfBaseActionBar

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


Properties for DfBaseActionBar

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Events for DfBaseButton

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseButton

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaseButton

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Events for DfBaseCheckbox

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseCheckbox

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaseCheckbox

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Events for DfBaseComboBox

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseComboBox

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaseComboBox

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Combo_Data_Object | Specifies the object ID of the internal l combo object |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


DfBaseComboBox [Property Combo_Data_Object]

Combo_Data_Object - DfBaseComboBox

Specifies the object ID of the internal l combo object

Type: Property

Access: Read/Write

Data Type: Handle

Description

The Combo_data_object property specifies the object ID of the internal combo object. This property is set when the object is created and is normally not changed. If changed, it is the program's responsibility to make sure that the new list object understands the combo message interface.

Setting this property causes the Windows list (if it is currently paged) to be refilled with the contents of the internal list.

// refill the windows list
Set combo_data_object to (combo_data_object(self))

Last Edited: September 25, 2003


Events for DfBaseComboBoxEntry

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for DfBaseComboBoxEntry

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaseComboBoxEntry

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Combo_Data_Object | Specifies the object ID of the internal l combo object |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


DfBaseComboBoxEntry [Property Combo_Data_Object]

Combo_Data_Object - DfBaseComboBoxEntry

Specifies the object ID of the internal l combo object

Type: Property

Access: Read/Write

Data Type: Handle

Description

The Combo_data_object property specifies the object ID of the internal combo object. This property is set when the object is created and is normally not changed. If changed, it is the program's responsibility to make sure that the new list object understands the combo message interface.

Setting this property causes the Windows list (if it is currently paged) to be refilled with the contents of the internal list.

// refill the windows list
Set combo_data_object to (combo_data_object(self))

Last Edited: September 25, 2003


DfBaseContainer [Event OnFileDropped]

OnFileDropped - DfBaseContainer

Provides a notification that a file drag and drop operation has occurred

Type: Event

Parameters: String sFilename Boolean bLast

Parameter | Description
sFilename | The name of the file being dropped
bLast | True if this is the last file being dropped

Description

The OnFileDropped event and the pbAcceptDropFiles property provide a mechanism for supporting file drag and drop within your application.

OnFileDropped is called when a file drag and drop operation has occurred. If multiple files have been dropped, this event will be called once for each file. When the last file has been dropped, the bLast parameter is set to True to indicate that there are no more files to be processed.

The OnFileDropped event is only sent if the container object or one of its parents has pbAcceptDropFile set to true. The event is sent to the object that has this property set to true.

The following code, when added to your panel object, would demonstrate how file drag and drop works:

Object oMain is a Panel
    :
    Set pbAcceptDropFiles to True

    Procedure OnFileDropped String sFilename Boolean bLast
        Showln "File Drop: " sFileName " " bLast
    End_Procedure
    :

The following example shows how a multiple file drop can be processed:

Object oMain is a Panel
    :
    Property String[] pArrayOfDroppedFiles

    :
    Set pbAcceptDropFiles to True

    Procedure OnFileDropped String sFilename Boolean bLast
        Integer  iFiles
        String[] pArrayOfDroppedFiles EmptyArray

        Get pArrayOfDroppedFiles to ArrayOfDroppedFiles

        // Add the filename to the list of dropped files....
        Move (SizeOfArray(ArrayOfDroppedFiles)) to iFiles
        Move sFilename to ArrayOfDroppedFiles[iFiles]

        // If this was the last file, process them and clear the list
        If (bLast) Begin
            Send ProcessDroppedFiles ArrayOfDroppedFiles
            // clear the property so it is ready for next drop
            Move EmptyArray to ArrayOfDroppedFiles
        End

        Set pArrayOfDroppedFiles to ArrayOfDroppedFiles

    End_Procedure
    :
End_Object

See Also

pbAcceptDropFiles

Last Edited: November 9, 2006


Events for DfBaseContainer

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseContainer

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaseContainer

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  |
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


DfBaseContainer [Property GetContainerClientSize]

GetContainerClientSize - DfBaseContainer

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


DfBaseContainer [Property pbAcceptDropFiles]

pbAcceptDropFiles - DfBaseContainer

Determines if the container object supports a file drop event

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The pbAcceptDropFile property and the OnFileDropped event provide a mechanism for supporting file drag and drop within your application.

pbAcceptDropFile determines if the container object supports file drag and drop. If true, dropping files onto the object will send OnFileDropped to the object. If false, and a parent container exists, this parent's pbAcceptDropFiles will be tested in the same manner. Therefore, this property only needs to be set in the outermost container that needs to support file drag and drop. This will normally be a view or panel object.

When file drop is enabled, the cursor will be changed as needed, to indicate that a drop is allowed.

Default is false.

See Also

OnFileDropped

Last Edited: November 9, 2006


Events for DfBaseControl

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseControl

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaseControl

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


DfBaseControl [Property Border_Style]

Border_Style - DfBaseControl

Specifies the border style of this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Border_Style property specifies the border style of this object. While all border styles are valid, not all styles are appropriate.

The useful styles are:

Constant | Meaning
Border_None | Displays no border
Border_Dialog | Displays a raised 3D border
Border_Normal | Displays a dark line around the border
Border_Thick | Displays tick border, allows panel to be resized
Border_ClientEdge | Displays a border with a sunken edge
Border_StaticEdge | Displays a lowered 3D border
Border_WindowEdge | Displays a border with a raised edge

Set Border_Style to Border_Thick

A 3D line may be drawn around a container by using the group class. Non-visual groupings are usually created using the container class.

Default is Border_Dialog

Last Edited: October 12, 2004


Events for DfBaseDialog

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaseDialog

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object |
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button |
Mdi_State |  |
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


DfBaseDialog [Property Border_Style]

Border_Style - DfBaseDialog

Specifies the border style of this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Border_Style property specifies the border style of this object. While all border styles are valid, not all styles are appropriate.

The useful styles are:

Constant | Meaning
Border_None | Displays no border
Border_Dialog | Displays a raised 3D border
Border_Normal | Displays a dark line around the border
Border_Thick | Displays tick border, allows panel to be resized
Border_ClientEdge | Displays a border with a sunken edge
Border_StaticEdge | Displays a lowered 3D border
Border_WindowEdge | Displays a border with a raised edge

Set Border_Style to Border_Thick

A 3D line may be drawn around a container by using the group class. Non-visual groupings are usually created using the container class.

Default is Border_Dialog

Last Edited: October 7, 2004


DfBaseDialog [Property Caption_Bar]

Caption_Bar - DfBaseDialog

contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Caption_Bar contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog. Text is placed in a Caption bar by setting the Value property of the DfBaseDialog.

Set Caption_Bar to True

Default is false.

Last Edited: July 30, 2003


DfBaseDialog [Property Icon]

Icon - DfBaseDialog

Allows you to set the name of an icon, which appears when the user minimizes a container

Type: Property

Access: Write-Only

Data Type: String

Description

The Icon message will allow you to set the name of an icon, which appears when the user minimizes a container.

Set Icon to "filename.ico"

Last Edited: October 26, 2006


DfBaseDialog [Property Maximize_Icon]

Maximize_Icon - DfBaseDialog

Determines if DfBaseDialog is displayed with a Maximize icon button

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If set to true, the DfBaseDialog is displayed with a Maximize icon button (an upward-pointing arrow).

Set Maximize_Icon to True

Default is false.

Last Edited: August 18, 2003


DfBaseDialog [Property Mdi_State]

Mdi_State - DfBaseDialog

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: February 13, 2003


DfBaseDialog [Property Minimize_Icon]

Minimize_Icon - DfBaseDialog

Determines if DfBaseDialog is displayed with a Minimize icon button

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If set to true, the DfBaseDialog is displayed with a Minimize icon button (a downward-pointing arrow).

Set Minimize_Icon to True

Default is false.

Last Edited: August 18, 2003


DfBaseDialog [Property Sysmenu_Icon]

Sysmenu_Icon - DfBaseDialog

Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If set to true, the DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations.

Set Sysmenu_Icon to true

Default is false.

Last Edited: September 11, 2003


DfBaseDialog [Property View_Mode]

View_Mode - DfBaseDialog

Changes the appearance of the DfBaseDialog window

Type: Property

Access: Read/Write

Data Type: Integer

Description

The View_Mode property changes the appearance of the DfBaseDialog window. If set to ViewMode_Zoom the window is maximized. If set to ViewMode_Normal, the window returns to the previous state before it was iconized.

Possible values are:

Mode | Description
ViewMode_Normal | Window returns to the previous state before it was iconized
ViewMode_Zoom | Window is maximized
ViewMode_Iconize | Window is minimized

Set View_Mode to ViewMode_Zoom

Default is ViewMode_Normal.

Last Edited: June 20, 2005


Events for DfBaseEdit

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseEdit

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Append_Text | Procedure | Inserts data to the end of the existing contents of the object |
Beginning_of_Data | Procedure | Moves the cursor to the beginning of the data in the object |
Beginning_of_Line | Procedure | Moves then cursor to the beginning of the current line |
Beginning_of_Panel | Procedure | Moves the cursor to the beginning of the data currently displayed |
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard |
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object |
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text |
Delete_Char | Procedure | Deletes the character under the cursor |
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Destroys all of the data in the object and returns the edit cursor to the top of the buffer |
Delete_Line | Procedure | Deletes the current line |
Destroy | Procedure |  | cObject
Down | Procedure | Moves the cursor down one line |
End_of_Data | Procedure | Moves the cursor to the end of the data |
End_of_Line | Procedure | Moves the cursor to the end of the current line |
End_of_Panel | Procedure | Moves the cursor to the end of the last line on the current screen |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Find | Procedure | Searches the text in an edit window |
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert | Procedure | Inserts a string of text into the edit buffer at the current cursor location |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Left | Procedure | Moves the cursor one space to the left |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Moves the edit cursor down one page |
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Moves the edit cursor up one page |
Paste | Procedure | Copies the contents of the Clipboard into this object at the current cursor position |
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Read | Procedure | Imports information from an external source to the Edit object's buffer |
Read_Dbms | Procedure | Reads information from a database file |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Replace | Procedure | Finds and Replaces Text in an edit object |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Reset_Find | Procedure | Causes the next find to search from the start of the text |
Reset_Replace | Procedure | Causes the next replace to search from the start of the text. |
Right | Procedure | Moves the cursor one space to the right |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Select | Procedure | Marks the text in the editor beginning at position iPosition for the number of bytes set in charcount |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Undo | Procedure | Will undo the last change in the edit |
Up | Procedure | Moves the edit cursor up one line |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes the contents of the edit buffer to the specified file |
Write_Dbms | Procedure | Writes information from the edit buffer to a database field |


DfBaseEdit [Procedure Append_Text]

Append_Text - DfBaseEdit

Inserts data to the end of the existing contents of the object

Type: Procedure

Parameters: String sText

Parameter | Description
sText | The text value to be appended

Description

Append_text inserts data to the end of the existing contents of the object.

Last Edited: July 30, 2003


DfBaseEdit [Procedure Beginning_of_Data]

Beginning_of_Data - DfBaseEdit

Moves the cursor to the beginning of the data in the object

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_data moves the cursor to the beginning of the data in the object. This message is often placed on an accelerator key. By default the kbegin_of_data key sends this message. When the movement is performed, the display is automatically updated. Note this message is equivalent to the move_absolute message with arguments of zero and zero.

Last Edited: July 30, 2003


DfBaseEdit [Procedure Beginning_of_Line]

Beginning_of_Line - DfBaseEdit

Moves then cursor to the beginning of the current line

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_line moves then cursor to the beginning of the current line. If the first character has horizontally scrolled off the screen, the display will automatically be updated. This message is often placed on an accelerator key. By default, the kbegin_of_line key sends this message.

Last Edited: July 30, 2003


DfBaseEdit [Procedure Beginning_of_Panel]

Beginning_of_Panel - DfBaseEdit

Moves the cursor to the beginning of the data currently displayed

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel moves the cursor to the beginning of the data currently displayed. This message is most often used as an argument to an accelerator key to aid users in navigation. By default, the kbeginning_of_panel key sends this message.

Last Edited: July 30, 2003


DfBaseEdit [Procedure Copy]

Copy - DfBaseEdit

Copies the marked block of text to the Clipboard

Type: Procedure

Parameters: Integer Arg1 Integer Arg2 Integer Arg3

Parameter | Description
Arg1 | not used
Arg2 | not used
Arg3 | not used

Description

The Copy procedure copies the marked block of text to the Clipboard.

Last Edited: July 31, 2003


DfBaseEdit [Procedure Cut]

Cut - DfBaseEdit

Copies the marked block of text to the Clipboard and deletes it from this object

Type: Procedure

Parameters: Integer Arg1 Integer Arg2 Integer Arg3

Parameter | Description
Arg1 | not used
Arg2 | not used
Arg3 | not used

Description

The Cut procedure copies the marked block of text to the Clipboard and deletes it from this object.

Last Edited: July 31, 2003


DfBaseEdit [Procedure Delete]

Delete - DfBaseEdit

Deletes the marked block of text

Type: Procedure

Parameters: No Parameters

Description

The Delete procedure deletes the marked block of text.

Last Edited: August 5, 2003


DfBaseEdit [Procedure Delete_Char]

Delete_Char - DfBaseEdit

Deletes the character under the cursor

Type: Procedure

Parameters: No Parameters

Description

Delete_char deletes the character under the cursor. The gap will be closed up and text will be unwrapped if necessary. By default, the kdelete_character key sends this message. The window has to be reactivated.

Last Edited: July 31, 2003


DfBaseEdit [Procedure Delete_Data]

Delete_Data - DfBaseEdit

Destroys all of the data in the object and returns the edit cursor to the top of the buffer

Type: Procedure

Parameters: No Parameters

Description

Delete_data destroys all of the data in the object and returns the edit cursor to the top of the buffer. The message is used to initialize the contents of an Edit object. This is often done just prior to loading new information into the text buffer. This text may come from a user, a data file, or a sequential file. The delete_data message is sent when the object is destroyed. When the message is received, the change_state of the object is set to false and any block marks are removed.

Last Edited: July 31, 2003


DfBaseEdit [Procedure Delete_Line]

Delete_Line - DfBaseEdit

Deletes the current line

Type: Procedure

Parameters: No Parameters

Description

Delete_line deletes the current line. The lines below are moved up and the display is updated.

Last Edited: July 31, 2003


DfBaseEdit [Procedure Down]

Down - DfBaseEdit

Moves the cursor down one line

Type: Procedure

Parameters: No Parameters

Description

The Down procedure moves the cursor down one line. The current column is retained. If there is a block mark in effect, the block boundary will be adjusted to the new cursor location. The window has to be reactivated.

Last Edited: August 5, 2003


DfBaseEdit [Procedure End_of_Data]

End_of_Data - DfBaseEdit

Moves the cursor to the end of the data

Type: Procedure

Parameters: No Parameters

Description

The End_of_data procedure moves the cursor to the end of the data. The cursor will be positioned one character past the end of text in the buffer. If there is no text in the buffer, then the cursor will be placed on the first character of the buffer. The screen is scrolled if necessary and any current block mark is extended to the new cursor location. This message is sent by the kend_of_data key. The window has to be reactivated.

Last Edited: August 5, 2003


DfBaseEdit [Procedure End_of_Line]

End_of_Line - DfBaseEdit

Moves the cursor to the end of the current line

Type: Procedure

Parameters: No Parameters

Description

The End_of_line message moves the cursor to the end of the current line. If the end of line is beyond the display size, the display will scroll horizontally. This message is sent by the kend_of_line key. The window has to be reactivated.

Last Edited: August 5, 2003


DfBaseEdit [Procedure End_of_Panel]

End_of_Panel - DfBaseEdit

Moves the cursor to the end of the last line on the current screen

Type: Procedure

Parameters: No Parameters

Description

The End_of_panel message moves the cursor to the end of the last line on the current screen. If the screen needs to scroll horizontally, it will be updated and any current block mark is extended to the new cursor location. This message is placed on the kend_of_panel key.

Last Edited: August 5, 2003


DfBaseEdit [Procedure Find]

Find - DfBaseEdit

Searches the text in an edit window

Type: Procedure

Return Data Type: Integer

Parameters: String sText

Parameter | Description
sText | The text to be searched for

Return Value

Return value not used

Description

The Find message searches the text in an edit window. If the text is found, it will be highlighted. It starts the search from the last Find position and searches to the end of the buffer. The Reset_Find message may be sent to force the find to start at the start of the buffer.

The search is case sensitive.

The find operation only works if the edit object is active and you will only see the results of the find if the edit object has the focus.

Send Find "Eureka"

In this example, the string Eureka if found, will be highlighted.

Last Edited: February 18, 2004


DfBaseEdit [Procedure Insert]

Insert - DfBaseEdit

Inserts a string of text into the edit buffer at the current cursor location

Type: Procedure

Parameters: String sText

Parameter | Description
sText | The text to be inserted

Description

The Insert message inserts a string of text into the edit buffer at the current cursor location. The message is equivalent to multiple msg_keys, and is provided for speed.

Last Edited: August 18, 2003


DfBaseEdit [Procedure Left]

Left - DfBaseEdit

Moves the cursor one space to the left

Type: Procedure

Parameters: No Parameters

Description

The Left message moves the cursor one space to the left.

Last Edited: August 18, 2003


DfBaseEdit [Procedure Page_Down]

Page_Down - DfBaseEdit

Moves the edit cursor down one page

Type: Procedure

Parameters: No Parameters

Description

The Page_down message moves the edit cursor down one page. This message is sent by the kscroll_forward accelerator key. The window has to be reactivated.

Last Edited: September 10, 2003


DfBaseEdit [Procedure Page_Up]

Page_Up - DfBaseEdit

Moves the edit cursor up one page

Type: Procedure

Parameters: No Parameters

Description

The Page_up message moves the edit cursor up one page. The window has to be reactivated.

Last Edited: September 10, 2003


DfBaseEdit [Procedure Paste]

Paste - DfBaseEdit

Copies the contents of the Clipboard into this object at the current cursor position

Type: Procedure

Parameters: Integer Arg1 Integer Arg2 Integer Arg3

Parameter | Description
Arg1 | not used
Arg2 | not used
Arg3 | not used

Description

The Paste procedure copies the contents of the Clipboard into this object at the current cursor position.

Last Edited: September 10, 2003


DfBaseEdit [Procedure Read]

Read - DfBaseEdit

Imports information from an external source to the Edit object's buffer

Type: Procedure

Parameters: String sFileName

Parameter | Description
sFileName | The name of the file to be read (optional)

Description

The Read message imports information from an external source to the object's buffer. If sFileName is omitted, then the File_Name property of the object is used. The external file is read until the end of file is reached. The Visual DataFlex sequential I/O system is used, so any valid file name and sequential modifier may be used. New line and tab are treated specially by the system; all other characters (that are greater than space) are inserted into the buffer.

send Read of oEdit1 "txt_file.txt"

set File_Name of oEdit1 to "note.txt"
send Read of oEdit1

Last Edited: November 16, 2004


DfBaseEdit [Procedure Read_Dbms]

Read_Dbms - DfBaseEdit

Reads information from a database file

Type: Procedure

Parameters: No Parameters

Description

The Read_dbms message is used to read information from a database file. The database may contain any type of data, but Text fields are most often used as the source of data. The message constructs a valid file name from the DBMS field passed. The read message is then called to read from the database.

send read_dbms to (txt_edit(self)) customer.note

There is a special form of the read_dbms message that does not read data from the database, but rather just sets the file_name property of the Edit object for use by subsequent read messages directed to the default file_name.

send read_dbms to (txt_edit(self)) customer.note true

The true parameter in the example above instructs the system to just set the file_name property of Object txt_edit to customer.note.

Last Edited: September 11, 2003


DfBaseEdit [Procedure Replace]

Replace - DfBaseEdit

Finds and Replaces Text in an edit object

Type: Procedure

Return Data Type: Integer

Parameters: String sOldtext String sNewText

Parameter | Description
sOldtext | The text to search for
sNewText | The text that replaces sOldText

Return Value

Return value not used

Description

The Replace function finds text matching sOldtext and replaces it with sNewText. It starts the search from the last replace position and searches to the end of the buffer. The Reset_Replace message may be sent to force the find to start at the start of the buffer.

The search is case sensitive.

The replace operation only works if the edit object is active.

Procedure DoReplace string sOldText string sNewText
    send Reset_Replace // start from top of buffer
    send Replace sOldText sNewText
End_Procedure

Last Edited: February 18, 2004


DfBaseEdit [Procedure Reset_Find]

Reset_Find - DfBaseEdit

Causes the next find to search from the start of the text

Type: Procedure

Parameters: No Parameters

Description

Reset_Find clears the internal "last find" marker, causing the next find to search from the start of the text.

Send Reset_Find
Send Find sSearchString

Last Edited: September 26, 2003


DfBaseEdit [Procedure Reset_Replace]

Reset_Replace - DfBaseEdit

Causes the next replace to search from the start of the text.

Type: Procedure

Parameters: No Parameters

Description

Reset_Replace clears the internal "last search/replace" marker, causing the next Replace to search from the start of the text.

procedure DoReplace string sOldText string sNewText
    send Reset_Replace // start from top of buffer
    send Replace sOldText sNewText
end_procedure

Last Edited: September 26, 2003


DfBaseEdit [Procedure Right]

Right - DfBaseEdit

Moves the cursor one space to the right

Type: Procedure

Parameters: No Parameters

Description

The Right message moves the cursor one space to the right. If the cursor moves past the right margin, then the cursor is advanced to the first character of the next line. If there is a block mark in effect, the block boundary will be adjusted to the new cursor location.

Last Edited: September 11, 2003


DfBaseEdit [Procedure Select]

Select - DfBaseEdit

Marks the text in the editor beginning at position iPosition for the number of bytes set in charcount

Type: Procedure

Parameters: Integer iPosition Integer iLength

Parameter | Description
iPosition | The position text is marked
iLength | The number of characters to be marked. If 0, text marking is cleared

Description

The Select procedure marks the text in the editor beginning at position iPosition for the number of bytes set in iLength. If iLength is 0, the marking is removed.

Last Edited: September 25, 2003


DfBaseEdit [Procedure Undo]

Undo - DfBaseEdit

Will undo the last change in the edit

Type: Procedure

Parameters: No Parameters

Description

The Undo procedure will undo the last change in the edit.

Last Edited: September 26, 2003


DfBaseEdit [Procedure Up]

Up - DfBaseEdit

Moves the edit cursor up one line

Type: Procedure

Parameters: No Parameters

Description

The up message moves the edit cursor up one line. If the cursor is at the top of the buffer, then the message is canceled. If there is a block mark in effect, the block boundary will be adjusted to the new cursor location.

Last Edited: September 11, 2003


DfBaseEdit [Procedure Write]

Write - DfBaseEdit

Writes the contents of the edit buffer to the specified file

Type: Procedure

Parameters: String sFileName Boolean bAppend

Parameter | Description
sFileName | The name of the file to be written
bAppend | If true the data will be appended to the file, if false the data will overwrite existing data

Description

The write message writes the contents of the edit buffer to the specified file. If neither parameter is given, the value of the File_Name property is used for sFileName and bAppend is false by default. If bAppend is true, then the data that is being written will be appended to sFileName. If it is false, sFileName, if it exists, will be overwritten. To set bAppend without sFileName, use a pair of quotation marks ("") for sFileName.

send Write of oEdit1 "ascii.txt"
:
set File_Name of oEdit1 to "txt.fil"
send Write of oEdit1

Last Edited: February 17, 2004


DfBaseEdit [Procedure Write_Dbms]

Write_Dbms - DfBaseEdit

Writes information from the edit buffer to a database field

Type: Procedure

Parameters: No Parameters

Description

The Write_dbms message is used to write information from the edit buffer to a database field. The message uses the passed file.field to construct the file name for the DBMS field and calls the write message.

send write_dbms to (txt_edit(self)) customer.note

Last Edited: September 15, 2003


Properties for DfBaseEdit

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Edit_Buffer_Count | The number of characters currently in the object |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
File_Name | Used whenever a read or write message is sent to the Edit object and a file_name parameter is not specified |
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of "lines" in Edit object |
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Position | Returns the location of the cursor in the object |
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Read_Only_State | Allows you to protect the contents of the buffer while still allowing users freedom to navigate |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
Text_Limit | The number of characters that can be entered into the edit |
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | The text value of an edit "line" |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


DfBaseEdit [Property Edit_Buffer_Count]

Edit_Buffer_Count - DfBaseEdit

The number of characters currently in the object

Type: Property

Access: Read-Only

Data Type: Integer

Description

Edit_Buffer_Count is the number of characters currently in the object.

Last Edited: August 5, 2003


DfBaseEdit [Property File_Name]

File_Name - DfBaseEdit

Used whenever a read or write message is sent to the Edit object and a file_name parameter is not specified

Type: Property

Access: Read/Write

Data Type: String

Description

File_name is the name of the default file used for the read and write messages. This property gets its initial value from this object's name. The file_name property is used whenever a read or write message is sent to the Edit object and a file_name parameter is not specified. If one is given, it will override the value of the file_name property. The value of this property is also displayed as the first field on the object's status line, if the status line is displayed.

Default is object_name.

Last Edited: August 18, 2003


DfBaseEdit [Property Line_Count]

Line_Count - DfBaseEdit

Returns number of "lines" in Edit object

Type: Property

Access: Read-Only

Data Type: Integer

Description

Line_Count returns the number of lines of text in an edit object. Definition of a line differs based on whether the edit object is active (in the focus tree) or not.

When an edit object is active, a line of text corresponds to the line that you see in the visual text window. Line_count represents the number of lines in the window.

When an edit object is not active, a line of text corresponds to a paragraph (all characters up to the end of line marker). Line_count represents the number of paragraphs.

Procedure ShowAllText
    string sText
    integer i iLines
    get line_count of oCustomer_Comments to iLines
    for i from 0 to (iLines-1)
        get Value of oCustomer_Comments i to sText
        showln i ':' sText
    loop
End_procedure

See Also

value

Last Edited: November 8, 2006


DfBaseEdit [Property Position]

Position - DfBaseEdit

Returns the location of the cursor in the object

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Position property returns the location of the cursor in the object. The location is returned as a complex-integer pair. The line is returned in the high part, and the column is in the low part of the complex integer.

Last Edited: September 11, 2003


DfBaseEdit [Property Read_Only_State]

Read_Only_State - DfBaseEdit

Allows you to protect the contents of the buffer while still allowing users freedom to navigate

Type: Property

Access: Read/Write

Data Type: Boolean

Description

It is often desirable to disallow the modification of an edit area by users. The read_only_state will allow you to protect the contents of the buffer while still allowing users freedom to navigate. Only the predefined accelerator keys are subject to the read_only_state-program messages are not affected. This allows the program to manipulate the text without having to change the value of the state.

set read_only_state to true

Note that if you define your own accelerator keys that perform text modifications, they will not automatically be subject to the read_only_state unless you program them to be, as you should.

if (read_only_state(code)) procedure_return

Default is false.

Last Edited: September 11, 2003


DfBaseEdit [Property Text_Limit]

Text_Limit - DfBaseEdit

The number of characters that can be entered into the edit

Type: Property

Access: Read/Write

Data Type: Integer

Description

Text_limit is the number of characters that can be entered into the edit.

Last Edited: September 11, 2003


DfBaseEdit [Property Value]

Value - DfBaseEdit

The text value of an edit "line"

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iItem String sValue

Parameter | Description
iItem | Line number - if edit object is active. Paragraph number - if edit object is not active
sValue | the text value

Description

Value retreives (get) and replaces (set) a line of text in an edit object. Defintion of a line differs based on whether the edit object is active (in the focus tree) or not.

When an edit object is active, a line of text corresponds to the line that you see in the visual text window. Getting the value returns the text. Setting the value replaces the current line with passed text.

When an edit object is not active, a line of text corresponds to a paragraph (all characters up to the end of line marker). Getting the value returns the entire paragraph. Setting the value replaces the paragraph number with the new value.

Procedure ShowAllText
    string sText
    integer i iLines

    get Line_Count of oCustomer_Comments to iLines
    for i from 0 to (iLines-1)
        get Value of oCustomer_Comments i to sText
        showln i ':' sText
    loop
End_Procedure

See Also

Line_Count

Last Edited: August 6, 2004


Events for DfBaseEditPullDown

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Initialize_Menu | Sent when the Menubar system is about to be selected | DfBaseActionBar
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseEditPullDown

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Exit_Menu | Procedure |  | DfBaseActionBar
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Redirect_Message | Procedure |  | DfBaseActionBar
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaseEditPullDown

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


DfBaseEntry [Event Item_Entry]

Item_Entry - DfBaseEntry

Sends iMessage to the current object if it is non-zero

Type: Event

Return Data Type: Integer

Parameters: Integer iMessage Integer iItem

Parameter | Description
iMessage | The Message id (e.g. get_IsEntryOk)
iItem | The entering item number

Return Value

Returns 0 if entry is ok, non-zero if entry should not be allowed

Description

The Item_Entry message sends iMessage to the current object if it is non-zero. This is an intermediate message sent during item change so that the program can intercept the change before it actually takes place. For example, you might check iMessage and if it is zero, substitute a generic message:

function item_entry integer entry_msg integer item_number returns integer
    integer ret_val
    if entry_msg eq 0 move generic_msg to entry_msg
    forward get item_entry entry_msg item_number to ret_val
    function_return ret_val
end_function

Last Edited: August 6, 2004


DfBaseEntry [Event Item_Exit]

Item_Exit - DfBaseEntry

Sends iMessage to the current object if it is non-zero

Type: Event

Return Data Type: Integer

Parameters: Integer iMessage Integer iItem

Parameter | Description
iMessage | The Message id (e.g. get_IsExitOk)
iItem | The exiting item number

Return Value

Returns 0 if exiting is ok, non-zero if exiting should not be allowed

Description

The Item_exit message sends iMessage to the current object if it is non-zero. This is an intermediate message sent during item change so that the program can intercept the change before it actually takes place. For example, you might check the iMessage parameter and if it is zero, substitute a generic message:

function item_exit integer exit_msg integer item_number returns integer
    integer ret_val
    if exit_msg eq 0 move generic_msg to exit_msg
    forward get item_exit exit_msg item_number to ret_val
    function_return ret_val
end_function

Last Edited: August 6, 2004


DfBaseEntry [Event Refresh]

Refresh - DfBaseEntry

Displays items from some files at the same time as clearing items from other files

Type: Event

Parameters: Integer notifyMode

Parameter Description
notifyModeThe mode, which signifies the event or operation which generated this refresh message, may be one of the following:

Constant | Meaning
mode_clear | used only for DEOs attached to the DSO that was the "origin" of a clear operation, i.e., the DSO that received the original clear request or message as a result of the user pressing kclear. All other DSOs send their DEOs the refresh message passing mode_find_or_clear_set.
mode_find_or_clear_set | used for DEOs attached to DataSets which have found and/or cleared records in response to a user's find-request (kfind, kfind_next, ksuperfind, et al.) or in response to another DSO's find or clear.
mode_clear_all | used for DEOs attached to any DSO that participated in a clear_all operation.
mode_delete | used for DEOs attached to any DSO that performed a successful deletion. DSOs that were merely updated as the result of a deletion use mode_find_or_clear_set.
mode_save | used for DEOs attached to any DSO involved in a successful save operation.

Description

Refresh displays items from some files at the same time as clearing items from other files.

This is a good message for augmentation. All changes in DSO activity are filtered through this message. When augmenting, you will almost always want to forward send the message.

// If order record exists, disallow entry in customer window.
Procedure Refresh Integer mode
    Integer Srvr# Crnt
    Get Server to Srvr#                 // get the ddo
    Get Current_Record of Srvr# to Crnt // get record in ddo
    // Make displayonly if Crnt is non-zero
    set enabled_state to (crnt =0)
    Forward Send Refresh mode          // do normal refrsh
End_Procedure

Last Edited: July 11, 2006


DfBaseEntry [Event Wrapping]

Wrapping - DfBaseEntry

Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

The Wrapping message is meant to be overridden. The message is sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item.

procedure wrapping
    send save_some_data
end_procedure

Last Edited: September 15, 2003


Events for DfBaseEntry

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero |
Item_Exit | Sends iMessage to the current object if it is non-zero |
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Refresh | Displays items from some files at the same time as clearing items from other files |
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item |


DfBaseEntry [Function Validate_Items]

Validate_Items - DfBaseEntry

Validates all items and sends each entry_item's Item_Validate_msg

Type: Function

Return Data Type: Integer

Parameters: Boolean bNotFindReq

Parameter | Description
bNotFindReq | If true, all item options are validated except findreq. If false, all item options are validated.

Return Value

Returns 0 if all items are valid, or else retrurns the first invalid item number.

Description

The Validate_Items function validates all items and sends each entry_item's Item_Validate_msg. If any item fails to validate, validation testing stops, the object's current item is set to the item that failed the test, and that same item number is returned. If all items pass validation, zero is returned.

if not (Validate_Items(Self, 1)) send Save_Some_Data

In this example, all options specified on all entry items of the current object except findreq are validated to control sending Message save_some_data.

Last Edited: August 6, 2004


Methods for DfBaseEntry

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window |
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall |
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall |
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it |
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


DfBaseEntry [Procedure Entry_Autofind]

Entry_Autofind - DfBaseEntry

Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window

Type: Procedure

Parameters: Integer eFindMode

Parameter Description
eFindMode

Constant | Meaning
EQ | Find equal to
GE | Find greater than or equal to

Description

When an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window, the entry_autofind message is sent. If the autofind is successful, then the data is displayed by the entry_display message, otherwise the find error condition is cleared and the message returns. Although this message would rarely be coded in an application with the send command, it may be augmented to place information in the record buffer prior to the find, or to display the information in a custom way (or not at all).

procedure entry_autofind integer find_mode
    move user_name to transaction.created_by
    forward send entry_autofind find_mode
end_procedure

Last Edited: August 5, 2003


DfBaseEntry [Procedure Entry_Clear]

Entry_Clear - DfBaseEntry

Clears all data-entry windows that are not controlled by a retain or retainall

Type: Procedure

Parameters: Boolean bClearedFiles

Parameter | Description
bClearedFiles | If true, only items for files which have been cleared in the current DDO operation will be affected

Description

The entry_clear message will clear all data-entry windows that are not controlled by a retain or retainall. If the item is cleared, the value is set to blanks and the changed_state is set to false. If the item is retained, its value will remain unchanged, and its item_changed_state set to true. This is done to ensure that the data will be moved into the record buffer on subsequent entry_update messages.

Last Edited: August 13, 2003


DfBaseEntry [Procedure Entry_Clear_All]

Entry_Clear_All - DfBaseEntry

Clears all data entry windows that are not marked as retainall

Type: Procedure

Parameters: Boolean bClearedFiles

Parameter | Description
bClearedFiles | If true, only items for files which have been cleared in the current DDO operation will be affected

Description

The entry_clear_all message will clear all data entry windows that are not marked as retainall. When the item is cleared, the value is set to blanks and the changed_state is set to false. If the item is retained, its value will remain unchanged, and its item_changed_state is set to true. This is done to ensure that the data will be moved into the record buffer on subsequent entry_update messages.

Last Edited: August 5, 2003


DfBaseEntry [Procedure Entry_Display]

Entry_Display - DfBaseEntry

Displays data from the data_file and data_field to every entry_item connected to it

Type: Procedure

Parameters: Integer iFile Boolean bDoAll

Parameter | Description
iFile | The file number
bDoAll | If true, all data is moved regardless of the items' item_changed_state

Description

Entry_display displays data from the data_file and data_field to every entry_item connected to it. If iFile is non-zero, the display is done only if iFile is the data_file or bDoAll is true. If iFile is zero and the data_file is included in the current data-set action, the display is done regardless of the value of bDoAll. Every item displayed by this message will have its item_changed_state set to false. Any displayed item whose checkbox_item_state is true will have its select_state set in accordance with the value of the field it is associated with.

Last Edited: October 6, 2004


DfBaseEntry [Procedure Entry_Update]

Entry_Update - DfBaseEntry

Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number

Type: Procedure

Parameters: Integer iFile Boolean bDoAll

Parameter | Description
iFile | The file number
bDoAll | If true, all data is moved regardless of the items' item_changed_state

Description

The entry_update message moves data from all entry items of an object whose data_file is equal to iFile and whose item_changed_state is true, to the record buffer of iFile. If iFile is 0, data is moved from all items regardless of their data_file, and if bDoAll is true, all data is moved regardless of the items' item_changed_state. This message is used by the dfBaseEntry packages.

send entry_update to (aform(self)) cust_file false

The data-entry system uses the entry_update message just prior to the entry_find. The update is performed by moving the values of all of the fields for the specified file to the record buffer. This is done by setting the value of the bDoAll parameter to true.

Last Edited: August 5, 2003


Properties for DfBaseEntry

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Autofind_Item |  |
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with |
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display |
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object |
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item |
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared |
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message |
Item_Exit_Msg | Sent in response to the item_change or the exiting message |
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with |
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem |
Item_Options | Allows you to copy item options or set them in a group |
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Validation | Controls whether the validate messages have any effect |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message |
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in |
Row_Count | Returns the number of rows in a dbGrid-class object |
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display |
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Valid_Item | Causes the validation of a single item identified by the iItem |
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object |


DfBaseEntry [Property Autofind_Item]

Autofind_Item - DfBaseEntry

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


DfBaseEntry [Property Base_Item]

Base_Item - DfBaseEntry

Defines the starting item number that the DfBaseEntry messages are to work with

Type: Property

Access: Read/Write

Data Type: Integer

Description

The base_item property (along with item_limit) is used to limit the scope of the standard entry-item manipulation messages. The base_item defines the starting item number that the DfBaseEntry messages are to work with. The messages affected are: entry_display, entry_update, entry_clear, item_change, validate_items. If the property is not set, the item set begins with the first item. The base_item along with the item_limit property are used to limit the scope of the standard entry messages.

This message is of no little use to single item entry objects (its value will always be 0). This message is used in the dbGrid class to define the current_row.

Last Edited: July 30, 2003


DfBaseEntry [Property Bottom_Item]

Bottom_Item - DfBaseEntry

Returns the item number of the last item on the display

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Bottom_item property returns the item number of the last item on the display. This property is used by dbGrid-class objects. It is of little use in single-item entry objects.

Last Edited: July 30, 2003


DfBaseEntry [Property Bottom_Row]

Bottom_Row - DfBaseEntry

Returns the number of the bottom row on the display of a dbGrid-class object

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Bottom_row property returns the number of the bottom row on the display of a dbGrid-class object. The item_limit of the grid must be set for this message to work.

Last Edited: July 30, 2003


DfBaseEntry [Property Current_Row]

Current_Row - DfBaseEntry

Return the row number of the current_item

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Current_row property is used with dbGrid-class objects to return the row number of the current_item. The item_limit must be set for this message to work.

Last Edited: August 13, 2003


DfBaseEntry [Property Data_Field]

Data_Field - DfBaseEntry

Identifies the database field from which data is to be stored, retrieved, and cleared

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iField

Parameter | Description
iItem | The item number
iField | The field number

Description

Each entry_item may have a field in a database file associated with it. The data_field identifies the database field from which data is to be stored, retrieved, and cleared. Data_fields are most often set by the entry_item command.

entry_item customer.name

They may also be set using the data_field message. This may be done if an entry item needs to be set to another field number than the initialized one. Data_field numbers begin with 0 for recnum and count up to the number of fields in the file with which the item is associated. Values outside this range are errors.

set data_field item 0 to 4

get data_field item 0 to var

If the entry_item is not associated with a data field (it is associated with an expression or variable), the value of this property is 0.

Last Edited: July 31, 2003


DfBaseEntry [Property Data_File]

Data_File - DfBaseEntry

Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iFile

Parameter | Description
iItem | The item number
iFile | The file number

Description

Each entry_item may have a field in a database file associated with it. The Data_file property identifies the database file that contains the field from which data is to be stored, retrieved, and cleared. Data_files are most often set by the composition of the entry_item statement itself.

entry_item customer.name

They may also be set using the data_file message. This may be done if an entry item needs to be set to another file than the initialized one.

set data_file item 0 to customer.File_Number

get data_file item 0 to filenumber

If the entry_item is not associated with a data field (it is associated with an expression or variable) the value of this property is 0.

Last Edited: August 5, 2003


DfBaseEntry [Property Displayable_Rows]

Displayable_Rows - DfBaseEntry

Returns the number of rows that are visible in the display of a dbGrid-class object

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Displayable_Rows property returns the number of rows that are visible in the display of a dbGrid-class object. The item_limit of the object must be set for this message to work.

Last Edited: October 6, 2004


DfBaseEntry [Property Item_Entry_Msg]

Item_Entry_Msg - DfBaseEntry

Sent in response to the item_change or the entering message

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iMessage

Parameter | Description
iItem | The item number
iMessage | The message number

Description

The entry_item has a message which is sent every time the item is entered by a user. The Item_entry_msg message is sent in response to the item_change or the Entering message. The value of this property is sent as a parameter to the item_entry function. You may override the function with custom entry processing of the item.

set item_entry_msg item 0 to msg_set_up_data

Last Edited: September 25, 2003


DfBaseEntry [Property Item_Exit_Msg]

Item_Exit_Msg - DfBaseEntry

Sent in response to the item_change or the exiting message

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iMessage

Parameter | Description
iItem | The item number
iMessage | The message number

Description

Each entry_item has a message which is sent every time the item is exited by the user. The Item_exit_msg message is sent in response to the item_change or the exiting message. The item_exit_msg property is sent as a parameter to the item_exit function. You may override the function with custom exit processing of the item.

set item_exit_msg item 0 to msg_exiting_field

Last Edited: September 25, 2003


DfBaseEntry [Property Item_Limit]

Item_Limit - DfBaseEntry

Defines the number of entry items in the group that the entry messages are to work with

Type: Property

Access: Read/Write

Data Type: Integer

Description

The item_limit property (along with base_item) are used to limit the scope of the standard entry-item-manipulation messages. The item_limit defines the number of entry items in the group that the entry messages are to work with. The messages affected are: entry_display, entry_update, entry_clear, item_change, and validate_items. If the property is not set, the total number of items is used. This property is of little use in single item entry objects. This property is used by dbGrid class objects to limit the scope of the data entry messages to the "current row".

When in the WideList class, default is 1.

Last Edited: August 18, 2003


DfBaseEntry [Property Item_Option]

Item_Option - DfBaseEntry

Allows you to query or change the skipfound format option on the entry_item command line for Item iItem

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Integer eOption boolean bEnable

Parameter | Description
iItem | The item number
eOption | The entry option
bEnable | True to enable, false to disable

Description

The Item_option property allows you to query or change the skipfound format option on the entry_item command line for Item iItem. The option setting is returned as a boolean value. The option is set or turned off by setting a boolean value in the property.

set item_option item 0 to skipfound true

if (item_option(self, 0, skipfound)) send check_status

Default is false.

Last Edited: August 18, 2003


DfBaseEntry [Property Item_Options]

Item_Options - DfBaseEntry

Allows you to copy item options or set them in a group

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iOptions

Parameter | Description
iItem | The item number
iOptions | The option number

Description

The Item_options property is the combination of all of the item_options. The message is provided to allow you to copy item options or set them in a group. The top 16 bits of the item options are for internal use and should not be changed by users. When you set item_options, you will usually wish to set field_options as well.

Get item_options item 0 to opts
set item_options of (scanner(self)) item 0 to opts
set field_options of (scanner(self)) item 0 to opts

In this example, the item_options of the current item of Object scanner are set to those of the first item of the current object.

To query, or get, the item_options of an item, use the individual item_option messages documented in this class.

Last Edited: August 18, 2003


DfBaseEntry [Property Item_Validate_Msg]

Item_Validate_Msg - DfBaseEntry

Sent in response to the item_change or the exiting message, every time the item is validated

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iMessage

Parameter | Description
iItem | The item number
iMessage | The message number

Description

Each entry_item has a message which is sent every time the item is validated. This message is sent in response to the item_change or the exiting message. You may override the property with custom validation processing of the item.

set item_validate_msg item 0 to validate_price_msg

Last Edited: January 12, 2006


DfBaseEntry [Property Object_Validation]

Object_Validation - DfBaseEntry

Controls whether the validate messages have any effect

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The object_validation property controls whether the validate messages have any effect. This is useful when a program needs to change the current_item and to disable the validation process that would occur when the item change takes place.

set object_validation to false

Default is true.

Last Edited: September 10, 2003


DfBaseEntry [Property Prompt_Object]

Prompt_Object - DfBaseEntry

Specifies the default receiving object for the popup message

Type: Property

Access: Read/Write

Data Type: Handle

Parameters: Integer iItem Handle hoPrompt

Parameter | Description
iItem | The item number
hoPrompt | Handle of the prompt object

Description

The Prompt_object property specifies the default receiving object for the popup message. By default, the property is not used in objects of this class, but is used in many of its subclasses, such as dbForm. Only single-item prompt objects are supported.

Last Edited: September 11, 2003


DfBaseEntry [Property Row]

Row - DfBaseEntry

Returns the row in a grid that a passed item is located in

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iItem Integer iValue

Parameter | Description
iItem | The item number
iValue | The row in a grid that the past iItem is located in

Description

The Row property returns the Row in a grid that a passed item is located in. The object's item_limit must be set to the number of items in a Row for this function to return a result. This message is used by the dbGrid class, and may be used by all rectangular types of dfBaseEntry objects.

integer iOldItem iNewItem
if (Row(Self,iOldItem)<>Row(Self,iNewItem)) ;
    send Save_Row (Row(Self,iOldItem))

The above code fragment checks to see if the user has changed Rows and if so, automatically saves the Row being exited.

Last Edited: August 6, 2004


DfBaseEntry [Property Row_Count]

Row_Count - DfBaseEntry

Returns the number of rows in a dbGrid-class object

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Row_Count property returns the number of rows in a dbGrid-class object. The item_limit must be set to the number of items in a row for this message to work.

The property returns the current number of rows filled with data. So if the number of visible rows (which you can query with Displayable_Rows) is 5 and you can see 4 rows filled with data the Row_Count property returns 4. If the table contains more than 5 records, so that all rows in the dbGrid are filled, Row_Count will be equal to Displayable_Rows.

integer i iCount
get Row_Count to iCount
decrement iCount
For i From 0 to iCount
    :
Loop

Last Edited: June 4, 2004


DfBaseEntry [Property Top_Row]

Top_Row - DfBaseEntry

Returns the row number of the top row on the display

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Top_row property returns the row number of the top row on the display. This message is used in dbGrid-class objects. The item_limit must be set for this message to work.

if (top_row(self) <>0) send scroll upward_direction 1

Last Edited: September 11, 2003


DfBaseEntry [Property Valid_Item]

Valid_Item - DfBaseEntry

Causes the validation of a single item identified by the iItem

Type: Property

Access: Read-Only

Data Type: Boolean

Parameters: Integer iItem Boolean bValue

Parameter | Description
iItem | The item number
bValue | 0 if valid, non 0 if invalid

Description

The Valid_item property will cause the validation of a single item identified by the iItem. The return value of the function is the result of the validation process (0 if valid).

if (valid_item(Self, current)) send bell

Last Edited: August 6, 2004


DfBaseEntry [Property Zoom_Object]

Zoom_Object - DfBaseEntry

Sets the destination object_id of the popup message to the specified object

Type: Property

Access: Read/Write

Data Type: Handle

Parameters: Integer iItem Handle hoPrompt

Parameter | Description
iItem | The item number
hoPrompt | Handle of the zoom object

Description

The zoom object property is used to set the destination object_id of the popup message to the specified object. By default, the property is not used in the base data-entry object, but is provided for use in higher-level classes, such as dbForm.

Last Edited: August 4, 2006


DfBaseEntryList [Event Header_Notification]

Header_Notification - DfBaseEntryList

Sent when the header has received a mouse event

Type: Event

Parameters: Integer eNotifyMode Integer iItem

Parameter | Description
eNotifyMode

Constant | Meaning
HD_NOTIFY_MOUSE_CLICK | mouse single click in header
HD_NOTIFY_MOUSE_DBLCLICK | mouse double click in header
HD_NOTIFY_DIVIDER_DBLCLICK | mouse double click in header divider

iItem | The item number

Description

The Header_notification message is sent when the header has received a mouse event. Three event notifications are supported: button mouse-click, button double click, and a double click on a header divider. If a single click occurs (HD_Notify_mouse_click) the message header_mouse_click is sent. If a double click occurs (HD_Notify_mouse_dblclick) the message header_mouse_double_click is sent. When possible, you should augment these two messages.

There is no default action taken for a divider double click. You would want to augment this procedure to handle such a case.

Procedure Header_notification integer mode integer item#
    If mode eq HD_Notify_Divider_DblCLick ;
        Send Special_notify_Event Item#
    Else ;
        forward send header_notifcation mode item#
End_procedure

Last Edited: August 18, 2003


DfBaseEntryList [Event OnMouseWheel]

OnMouseWheel - DfBaseEntryList

An event sent everytime a mouse wheel is clicked

Type: Event

Parameters: Integer iClicks Integer iKey

Parameter | Description
iClicks | The number of clicks of the mouse wheel
iKey | The windows bit mask that determines what other keys might have been pressed as you move the mouse-wheel. It is not being used in the default implementation. Consult the windows documentation for WM_MouseWheel if you need to use this.

Description

This event does nothing. It is augmented in super-classes to support scrolling in grids.

If you wish to create custom mouse wheel behaviors you can augment the event OnMouseWheel. This message is sent every time a mouse wheel is clicked.

If iClicks is positive the wheel is being moved forward (away from you). By default this is used to scroll towards the top of the list. If iClicks is negative the wheel is being moved backwards (towards you). By default this is used to scroll down the list.

Last Edited: September 10, 2003


Events for DfBaseEntryList

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Notification | Sent when the header has received a mouse event |
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnMouseWheel | An event sent everytime a mouse wheel is clicked |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


DfBaseEntryList [Function Column_Combo_Find]

Column_Combo_Find - DfBaseEntryList

Searches for an item in the dropdown list of a combo form for a column by value

Type: Function

Return Data Type: Integer

Parameters: integer iColumn integer iStart string sFindValue

Parameter | Description
iColumn | The column number (zero-based)
iStart | Starting item position to search (zero-based)
sFindValue | Value to find in list

Return Value

Returns the item number from the unsorted list or -1 if the search fails.

Description

Searches for an item in the dropdown list of a combo form for a column by value. You can use the starting position (iStart) to search for duplicates. Note that the combo value to be found must be an exact match to the item in the list, in both length and casing.

Sample

This sample fills a grid with 20 rows of 2 columns each. The first column (column 0) is filled alternatingly with values John, Anne and Judy. It then instructs the grid to make column 0 a combo form, to sort the combo form's dropdown list, and adds 7 items to the dropdown list of the combo form. When button oButton1 is clicked, it finds the first occurence of John in the list for the current column's combo form dropdown list and displays it in a message box.

Object oGrid1 is a Grid
    :
    Procedure DoFillGrid
        integer iRow iMaxRows iCount

        move 20 To iMaxRows
        For iRow From 1 To iMaxRows
            if (mod(iCount,3)=0) Send Add_Item Msg_None "John"
            else if (mod(iCount,3)=1) Send Add_Item Msg_None "Anne"
            else Send Add_Item Msg_None "Judy"

            Send Add_Item Msg_None ("305-555-1212")

            increment iCount
        Loop
    End_Procedure // DoFillGrid

    send DoFillGrid

    // make column 0 a combo
    set Column_Combo_State 0 to True
    // sort the dropdown list for the combo in column 0
    set Column_Combo_Sort_State 0 to True

    // add items to the dropdown list for the combo in column 0
    Send Column_Combo_Add_Item 0 "Anne"
    Send Column_Combo_Add_Item 0 "Elizabeth"
    Send Column_Combo_Add_Item 0 "Albert"
    Send Column_Combo_Add_Item 0 "John"
    Send Column_Combo_Add_Item 0 "Doug"
    Send Column_Combo_Add_Item 0 "Judy"
    Send Column_Combo_Add_Item 0 "David"
End_Object  // oGrid1

Object oButton1 is a Button
    :
    Procedure OnClick
        integer iColumn iStart iFoundItem
        string sValue

        move 0 to iColumn
        move 0 to iStart
        move "John" to sValue
        get Column_Combo_Find of oGrid1 iColumn iStart sValue to iFoundItem

        if (iFoundItem <> -1) ;
            send Info_Box ("Value "+sValue+" was found in item "+string(iFoundItem)) "Value found"
    End_Procedure // OnClick
    :
End_Object  // oButton1

Last Edited: November 30, 2004


DfBaseEntryList [Function Column_Combo_Item_Count]

Column_Combo_Item_Count - DfBaseEntryList

Returns number of items in the combo form's dropdown list for a column

Type: Function

Return Data Type: Integer

Parameters: integer iColumn

Parameter | Description
iColumn | The column number (zero-based)

Return Value

Description

Returns number of items in the combo form's dropdown list for a column.

Sample

This sample gets the number of items in the combo form dropdown list for column 2 of grid object oGrid1 to variable iListItemCount and then displays it in a message box.

Procedure CheckItemCount
    integer iListItemCount iColumn

    move 2 to iColumn
    get Column_Combo_Item_Count of oGrid1 iColumn to iListItemCount

    send Info_Box ;
        ("There are " + string(iListItemCount) + " items in the list for the combo form in column " + string(iColumn)) ;
            "Column Combo Item Count"
End_Procedure  // CheckItemCount

Last Edited: November 30, 2004


DfBaseEntryList [Function Column_Combo_Value]

Column_Combo_Value - DfBaseEntryList

Returns the value of a dropdown list item in the combo form for a column

Type: Function

Return Data Type: String

Parameters: integer iColumn integer iListItem

Parameter | Description
iColumn | The column number (zero-based)
iListItem | The item number to return the value of (zero-based)

Return Value

Value of a dropdown list item.

Description

Returns the value of a dropdown list item in the combo form for a column. This returns the value of the unsorted list, even if Column_Combo_Sort_State for the column is True..

Sample

This sample gets the value of item 5 in the combo form dropdown list for column 2 of grid object oGrid1 to variable sComboValue and then displays it in a message box.

Procedure CheckItemCount
    integer iColumn iItem
    string sComboValue

    move 2 to iColumn
    move 5 to iItem
    get Column_Combo_Value of oGrid1 iColumn iItem to sComboValue

    send Info_Box sComboValue "Combo Value"
End_Procedure  // CheckItemCount

Last Edited: November 30, 2004


Methods for DfBaseEntryList

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column |
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column |
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column |
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value |
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column |
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column |
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


DfBaseEntryList [Procedure Column_Combo_Add_Item]

Column_Combo_Add_Item - DfBaseEntryList

Adds an item to the end of the combo form's dropdown list for a column

Type: Procedure

Parameters: integer iColumn string sValue

Parameter | Description
iColumn | [ToDo: In Progress]
sValue | [ToDo: In Progress]

Description

This is the message that must be used to fill the list of items that appear in the combo form's dropdown list.

Sample

This sample sets column 2 to be a combo column, then adds "Type 1" and "Type 2" to the combo's dropdown list.

set Column_Combo_State 2 to True
Send Column_Combo_Add_Item 2 "Type 1"
Send Column_Combo_Add_Item 2 "Type 2"

Sample

This sample fills a grid with 20 rows of 3 columns each. It then instructs the grid to make column 2 a combo form, to sort the combo form's dropdown list, and adds 3 items to the dropdown list.

Procedure DoFillGrid
    integer iRow iMaxRows iCount
    string sCustomerName

    move "John Q. Customer" to sCustomerName

    move 20 To iMaxRows
    For iRow From 1 To iMaxRows
        Send Add_Item Msg_None (sCustomerName + string (iRow)))
        Send Add_Item Msg_None ("305-555-1212")
        Send Add_Item Msg_None (if(mod(iCount,2)=0,"Type 1","Type 2"))
        increment iCount
    Loop
End_Procedure // DoFillGrid

send DoFillGrid

// make column 2 a combo
set Column_Combo_State 2 to True
// sort the dropdown list for the combo in column 2
set Column_Combo_Sort_State 2 to True
// add items to the dropdown list for the combo in column 2
Send Column_Combo_Add_Item 2 "Type 3"
Send Column_Combo_Add_Item 2 "Type 2"
Send Column_Combo_Add_Item 2 "Type 1"

Last Edited: December 2, 2004


DfBaseEntryList [Procedure Column_Combo_Delete_Data]

Column_Combo_Delete_Data - DfBaseEntryList

Deletes all items from the combo form's dropdown list for a column

Type: Procedure

Parameters: integer iColumn

Parameter | Description
iColumn | The column number (zero-based)

Description

Deletes all items from the combo form's dropdown list for a column.

Sample

This sample deletes all items from the combo form dropdown list for column 2.

send Column_Combo_Delete_Item 2

Last Edited: November 30, 2004


DfBaseEntryList [Procedure Column_Combo_Delete_Item]

Column_Combo_Delete_Item - DfBaseEntryList

Deletes an item from the combo form's dropdown list for a column

Type: Procedure

Parameters: integer iColumn integer iItem

Parameter | Description
iColumn | The column number (zero-based)
iItem | The item number to delete (zero-based)

Description

Deletes an item from the combo form's dropdown list for a column.

Sample

This sample deletes item 2 from the combo form dropdown list for column 2.

send Column_Combo_Delete_Item 2 2

Last Edited: November 30, 2004


DfBaseEntryList [Procedure Column_Combo_Refresh]

Column_Combo_Refresh - DfBaseEntryList

Forces a refresh for the combo form of a column

Type: Procedure

Parameters: integer iColumn

Parameter | Description
iColumn | The column number (zero-based)

Description

If the combo form is displayed and changes are made to the dropdown list (e.g. via Column_Combo_Add_Item), the visual list is not updated until the user changes rows or columns in the grid. Sending this message will force a refresh for the column's combo form.

Sample

This sample forces a refresh of the combo form in column 2 of the grid.

send Column_Combo_Refresh 2

Last Edited: November 30, 2004


DfBaseEntryList [Procedure DoMakeColumnVisible]

DoMakeColumnVisible - DfBaseEntryList

Ensures that the passed column number is fully visible

Type: Procedure

Parameters: Integer iColumn

Parameter | Description
iColumn | The number of the column that must be visible

Description

Sending the DoMakeColumnVisible messages ensures that the passed column number is fully visible. If the column is not visible, the grid will be scrolled as needed to make it so.

Procedure ScrollLeft
       Send DoMakeColumnVisible 0
End_Procedure
Procedure ScrollRight
       Send DoMakeColumnVisible (item_limit(self)-0)
End_Procedure

This procedure is used in objects based on dbGrid and dbList (implemented in the Datalist super-class) to snap the grid back to column zero whenever the message beginning_of_panel is sent to a view. The message beginning_of_panel sends the message OnBeginningOfPanel to all objects. When the dbGrid or dbList receives the message it does the following:

// augmnt to always force the first column to be visible. This will occur during a
// panels clear or save. It makes sense to restore the column. If you do no want this
// behavior just cancel it.
Procedure OnBeginningofPanel
   Send DoMakeColumnVisible 0
end_procedure

Last Edited: August 13, 2003


Properties for DfBaseEntryList

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made |
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list |
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. |
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order |
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item |
CurrentCellTextColor | Sets the text color of the current focus item |
CurrentRowColor | Sets the background color of the current row |
CurrentRowTextColor | Sets the text color of the current row |
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid |
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers |
Header_Label | Define text for headers |
Header_Visible_State | Determines if the grid header will be visible |
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. |
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed |
IsColumnVisible | Determine if a particular column is visible |
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item |
ItemTextColor | Sets the text color of an individual item |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid |
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell |
peDisabledTextColor | Determines the text color of a disabled cell |
peGridLineColor | Determines the color of lines separating grid cells |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


DfBaseEntryList [Property AutoSize_Height_State]

AutoSize_Height_State - DfBaseEntryList

Determines if grid's automatic height adjustment will be made

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When this property is set to true, the grid's pixel height will be adjusted to exactly fit the number of rows in the display area. This avoids the display of partial rows. If set to false, no automatic height adjustment will be made.

If you are using anchors and plan on resizing your grids, you should set this property to false, the default.

Prior to VDF8, the default value was True. In VDF8, this was changed to false to more transparently support anchor-based resizing

Default is false.

Last Edited: July 30, 2003


DfBaseEntryList [Property Column_Combo_Entry_State]

Column_Combo_Entry_State - DfBaseEntryList

Determines if column allows entry into the cell or only allows selection of values from list

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: integer iColumn boolean bAllowEntry

Parameter | Description
iColumn | The column number (zero-based)
bAllowEntry | If true, allows entry into the cell

Description

Determines if the column allows entry into the cell, or if values can only be selected from the available values in the combo form's dropdown list.

Sample

This sample allows users to enter data that is not available in the dropdown list of the combo form in column 2 of a grid object.

set Column_Combo_Entry_State 2 to True

Sample

This sample disallows users to enter data and ensures that values can only be selected from the values available in the dropdown list of the combo form in column 2 of a grid object.

set Column_Combo_Entry_State 2 to False

Default is false

Last Edited: November 30, 2004


DfBaseEntryList [Property Column_Combo_ListRowCount]

Column_Combo_ListRowCount - DfBaseEntryList

Determines maximum number of rows in the combo's dropdown list that are displayed.

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iColumn integer iRows

Parameter | Description
iColumn | The column number (zero-based)
iRows | Maximum number of rows

Description

Determines the maximum number of rows in the combo form's dropdown list that are displayed. When exceeded, a scroll bar appears.

Sample

This sample fills a grid with 20 rows of 3 columns each. It then instructs the grid to make column 2 a combo form and adds 8 items to the dropdown list. It also instructs the grid to only display 5 items in the combo form's dropdown list and scroll to display additional items. So, when the user first clicks on the combo form's arrow to display the dropdown list, "Type 1", "Type 2", "Type 3", Type 4" and "Type 5" will be displayed. To view the other items on the list, the user will have to scroll down.

Procedure DoFillGrid
    integer iRow iMaxRows iCount
    string sCustomerName

    move "John Q. Customer" to sCustomerName

    move 20 To iMaxRows
    For iRow From 1 To iMaxRows
        Send Add_Item Msg_None (sCustomerName + string (iRow)))
        Send Add_Item Msg_None ("305-555-1212")
        Send Add_Item Msg_None (if(mod(iCount,2)=0,"Type 1","Type 2"))
        increment iCount
    Loop
End_Procedure // DoFillGrid

send DoFillGrid

// make column 2 a combo
set Column_Combo_State 2 to True
// set the number of displayed rows in dropdown list before scrolling
set Column_Combo_ListRowCount 2 to 5

// add items to the dropdown list for the combo in column 2
Send Column_Combo_Add_Item 2 "Type 1"
Send Column_Combo_Add_Item 2 "Type 2"
Send Column_Combo_Add_Item 2 "Type 3"
Send Column_Combo_Add_Item 2 "Type 4"
Send Column_Combo_Add_Item 2 "Type 5"
Send Column_Combo_Add_Item 2 "Type 6"
Send Column_Combo_Add_Item 2 "Type 7"
Send Column_Combo_Add_Item 2 "Type 8"

Last Edited: November 30, 2004


DfBaseEntryList [Property Column_Combo_Sort_State]

Column_Combo_Sort_State - DfBaseEntryList

Determines if a column should display dropdown list in sorted order

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: integer iColumn boolean bSort

Parameter | Description
iColumn | The column number
bSort | If True, the column displays in sorted order

Description

Determines if iColumn should display the combo form's dropdown list in sorted order. Only the visual list is sorted. The actual list of column-items that (added via column_combo_add_item) are not sorted.

Sample

This sample instructs the grid to display the combo's dropdown list for column 2 in sorted order.

set Column_Combo_Sort_State 2 to True

Sample

This sample fills a grid with 20 rows of 3 columns each. It then instructs the grid to make column 2 a combo form, to sort the combo form's dropdown list, and adds 3 items to the dropdown list.

Procedure DoFillGrid
    integer iRow iMaxRows iCount
    string sCustomerName

    move "John Q. Customer" to sCustomerName

    move 20 To iMaxRows
    For iRow From 1 To iMaxRows
        Send Add_Item Msg_None (sCustomerName + string (iRow)))
        Send Add_Item Msg_None ("305-555-1212")
        Send Add_Item Msg_None (if(mod(iCount,2)=0,"Type 1","Type 2"))
        increment iCount
    Loop
End_Procedure // DoFillGrid

send DoFillGrid

// make column 2 a combo
set Column_Combo_State 2 to True
// sort the dropdown list for the combo in column 2
set Column_Combo_Sort_State 2 to True
// add items to the dropdown list for the combo in column 2
Send Column_Combo_Add_Item 2 "Type 3"
Send Column_Combo_Add_Item 2 "Type 2"
Send Column_Combo_Add_Item 2 "Type 1"

Default is false

Last Edited: November 30, 2004


DfBaseEntryList [Property Column_Combo_State]

Column_Combo_State - DfBaseEntryList

Specifies whether a column of a grid is presented as a combo form

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: integer iColumn boolean bColumnCombo

Parameter | Description
iColumn | The column number (zero-based)
bColumnCombo | If True, column is a combo form

Description

The Column_Combo_State property specifies whether iColumn of this grid is presented as a combo form. This will be used most-often when a column's field is defined by its data dictionary as having a validation table. This property can be used with dbGrid objects and dbList as well.

This property is normally set once for each column that needs a combo. However, this can be set and unset on an item by item basis to allow for custom combos based on a row. This can be set/unset inside in the item_change message before the forward send. When this tecnique is used all column-combo data will need to be set on an item by item basis.

Sample

Normally this property is set once in your program when the object is being created. If a data field value can be represented as a combo form, you can set the dbGrid's column to be a combo form by setting this property to true.

Set Column_Combo_State 4 to TRUE

Toggling Column-Based Combos Dynamically

This property may be set dynamically, although such usage would be unusual. If the property is changed when the object is active, you will not see a change in the object's appearance until you redisplay the object.

Sample

This sample would toggle a column's combo state and update the dbGrid as required.

Procedure ToggleCombo4
    Boolean bState

    Get Column_Combo_State 4 to bState
    Set Column_Combo_State 4 to (not(bState))

    // if the object is active, we must refresh to see changes
    If (Active_State(Self)) send Display
End_Procedure  // ToggleCombo4

Cell-Specific Combos

You can take advantage of the fact that combo forms are drawn only when the cell that has a column-based combo form is entered and turn off the column-based combo as the user moves through the table. Item_Change is an excellent place to do this.

Sample

This sample shows how to make a combo form appear for a specific cell instead of the entire column. This sample can be tested in a Grid or dbGrid with 3 columns. When the user moves to item 5 (since items are zero-based, this would be the 3rd column in the 2nd row), a combo form appears in that cell. If moving to any other cell, the combo for the target item's column is turned off.

Procedure Item_Change integer iFromItem integer iToItem returns integer
    integer iRetVal iTargetColumn iTargetItem

    move 5 to iTargetItem

    // determine the column iTargetItem is in
    move (iTargetItem / (Base_Item(Self)) + 1) to iTargetColumn

    // turn on combo form for iToItem if we're in the right column
    if (iToItem = iTargetItem) begin
        set Column_Combo_State iTargetColumn to True
        send Column_Combo_Add_Item iTargetColumn "Joan" ""
        send Column_Combo_Add_Item iTargetColumn "George" ""
        send Column_Combo_Add_Item iTargetColumn "Zach" ""
    end
    // turn the combo off for iToItem's column if it is currently on
    else begin
        set Column_Combo_State iTargetColumn to False
    end

    forward get msg_Item_Change iFromItem iToItem to iRetVal

    procedure_return iRetVal
End_Procedure  // Item_Change

Sample

This sample fills a grid with 20 rows of 3 columns each. It then instructs the grid to make column 2 a combo form, to sort the combo form's dropdown list, and adds 3 items to the dropdown list.

Procedure DoFillGrid
    integer iRow iMaxRows iCount
    string sCustomerName

    move "John Q. Customer" to sCustomerName

    move 20 To iMaxRows
    For iRow From 1 To iMaxRows
        Send Add_Item Msg_None (sCustomerName + string (iRow)))
        Send Add_Item Msg_None ("305-555-1212")
        Send Add_Item Msg_None (if(mod(iCount,2)=0,"Type 1","Type 2"))
        increment iCount
    Loop
End_Procedure // DoFillGrid

send DoFillGrid

// make column 2 a combo
set Column_Combo_State 2 to True
// sort the dropdown list for the combo in column 2
set Column_Combo_Sort_State 2 to True
// add items to the dropdown list for the combo in column 2
Send Column_Combo_Add_Item 2 "Type 3"
Send Column_Combo_Add_Item 2 "Type 2"
Send Column_Combo_Add_Item 2 "Type 1"

Note:
Column_xxx states must be set after the Entry_Items, in order for it to take effect (e.g. in the bottom code section - below the comment line in the editor).

Default is false

Last Edited: June 21, 2005


DfBaseEntryList [Property CurrentCellColor]

CurrentCellColor - DfBaseEntryList

Sets the background color of the current focus item

Type: Property

Access: Read/Write

Data Type: Integer

Description

The CurrentCellColor property sets the background color of the current focus item. This is passed a single value representing an RGB color. Individual Red, Green, and Blue colors are converted to a single value by using the RGB function.

If no value is specifically set, a default color setting is used. The default is stored in a global integer named default_current_item_color. Its default value is aqua (rgb(0, 255, 255)). You may change this value in your program.

Set CurrentCellColor to (rgb(255, 0, 0)) // red
Set CurrentCellColor to clPurple
Set CurrentCellColor to clBtnFace

Note:The rgb.pkg package contains names for most of commonly used colors and names for all system colors.

Last Edited: August 12, 2005


DfBaseEntryList [Property CurrentCellTextColor]

CurrentCellTextColor - DfBaseEntryList

Sets the text color of the current focus item

Type: Property

Access: Read/Write

Data Type: Integer

Description

The CurrentCellTextColor property sets the text color of the current focus item. This is passed a single value representing an RGB color. Individual Red, Green, and Blue colors are converted to a single value by using the RGB function.

If no value is specifically set, a default color setting is used. The default is stored in a global integer named default_current_item_color. Its default value is aqua (rgb(0, 255, 255)). You may change this value in your program.

Set CurrentCellTextColor to (rgb(255, 0, 0)) // red
Set CurrentCellTextColor to clPurple
Set CurrentCellTextColor to clBtnFace

Note:The rgb.pkg package contains names for most of commonly used colors and names for all system colors.

Last Edited: August 12, 2005


DfBaseEntryList [Property CurrentRowColor]

CurrentRowColor - DfBaseEntryList

Sets the background color of the current row

Type: Property

Access: Read/Write

Data Type: Integer

Description

CurrentRowColor sets the background color of the current row. This is passed a single value representing an RGB color. Individual Red, Green, and Blue colors are converted to a single value by using the RGB function.

If no value is specifically set, a default color setting is used. The default is stored in a global integer named default_highlight_row_color. Its default value is aqua (rgb(0, 255, 255)). You may change this value in your program. You may also change a default value within your registry by changing the key TableRowColor. If you set the key TableRowColor in the registry, you must use a string value in the form of red, green, blue (e.g., 0, 255, 0 is green).

Set CurrentRowColor to (rgb(255, 0, 0)) // red

Set CurrentRowColor to clPurple

Set CurrentRowColor to clBtnFace

Note: The rgb.pkg package contains names for most of commonly used colors and names for all system colors.

Last Edited: August 11, 2003


DfBaseEntryList [Property CurrentRowTextColor]

CurrentRowTextColor - DfBaseEntryList

Sets the text color of the current row

Type: Property

Access: Read/Write

Data Type: Integer

Description

CurrentRowTextColor sets the text color of the current row. This is passed a single value representing an RGB color. Individual Red, Green, and Blue colors are converted to a single value by using the RGB function.

If no value is specifically set, a default color setting is used. The default is stored in a global integer named default_highlight_row_color. Its default value is aqua (rgb(0, 255, 255)). You may change this value in your program. You may also change a default value within your registry by changing the key TableRowColor. If you set the key TableRowColor in the registry, you must use a string value in the form of red, green, blue (e.g., 0, 255, 0 is green).

Set CurrentRowTextColor to (rgb(255, 0, 0)) // red

Set CurrentRowTextColor to clPurple

Set CurrentRowTextColor to clBtnFace

Note: The rgb.pkg package contains names for most of commonly used colors and names for all system colors.

Last Edited: August 11, 2003


DfBaseEntryList [Property GridLine_Mode]

GridLine_Mode - DfBaseEntryList

Determines how grid lines will be displayed in the grid

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Gridline_mode property determines how grid lines will be displayed in the grid. You may choose to display no lines, horizontal lines, vertical lines, or both horizontal and vertical lines.

If no value is specifically set, a default setting is used. The default is stored in a global integer named default_table_grid. Its default value is grid_visible_both. You may change this value in your program. You may also change this default value within your registry by changing the key TableGrid.

If you set the key TableGrid in the registry, you must use the values 0 through 3:

Constant | Meaning
0 | Grid_Visible_none
1 | Grid_Visible_Horz
2 | Grid_Visible_Vert
3 | Grid_Visible_Both

Last Edited: November 30, 2004


DfBaseEntryList [Property Header_Justification_Mode]

Header_Justification_Mode - DfBaseEntryList

Determines how text will be justified in list and grid headers

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iColumn Integer eMode

Parameter | Description
iColumn | The column number (zero-based)
eMode

Constant | Meaning
JMode_Left | Left justify
JMode_Right | Right justify
JMode_Center | Center

Description

Header_justification_mode allows you to define how text will be justified in list and grid headers. Text can be displayed from the left, the right, or centered.

Default is JMode_Left.

Last Edited: November 30, 2004


DfBaseEntryList [Property Header_Label]

Header_Label - DfBaseEntryList

Define text for headers

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iColumn String sText

Parameter | Description
iColumn | The column number
sText | The column label

Description

Header_label allows you to define text for headers. This property specifies the text that is to appear at the top of Column iColumn. In data-aware classes, the value of this property is overridden by label values in the DDO when auto_label_state has been set true.

Last Edited: August 18, 2003


DfBaseEntryList [Property Header_Visible_State]

Header_Visible_State - DfBaseEntryList

Determines if the grid header will be visible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Header_visible_state determines if the grid header will be visible. By default, a header will appear.

Default is true.

Last Edited: August 18, 2003


DfBaseEntryList [Property Highlight_Row_State]

Highlight_Row_State - DfBaseEntryList

When this property is true, the current row will be displayed in this object's CurrentRowColor.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When this property is true, the current row will be displayed in this object's CurrentRowColor.

Last Edited: November 30, 2004


DfBaseEntryList [Property Horz_Scroll_Bar_Visible_State]

Horz_Scroll_Bar_Visible_State - DfBaseEntryList

Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Horz_scroll_bar_visible_state specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed-when the length of a row exceeds the visible width of the grid.

Note: The horizontal scroll bar will not appear when all columns fit within the object's width.

Default is true.

Last Edited: August 18, 2003


DfBaseEntryList [Property IsColumnVisible]

IsColumnVisible - DfBaseEntryList

Determine if a particular column is visible

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iColumn Integer iValue

Parameter | Description
iColumn | The column number
iValue | Returns true if column is visible

Description

IsColumnVisible can be called to determine if a particular column is visible. You can use this to determine if you need to perform a scroll by sending the DoMakeColumnVisible message.

Procedure CheckCol integer iCol
      Boolean bVisible
      Get IsColumnVisible iCol to bVisible
      If not bVisible ;
          Send DoMakeColumnVisible iCol
End_procedure

Last Edited: August 18, 2003


DfBaseEntryList [Property ItemColor]

ItemColor - DfBaseEntryList

Sets the color of an individual item

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer eColor

Parameter | Description
iItem | The item number
eColor | The rgb color

Description

ItemColor sets the color of an individual item. The color is associated with the item, and not the window or the column. When the item scrolls, the color moves with the item. To change the color of an item that is already displayed, you must follow the set statement with a page statement that names this object.

This is passed a single value representing an RGB color. Individual red, green, and blue colors are converted to a single value by using the RGB function.

Set ItemColor item 3 to (rgb(255, 0, 0)) // red

Set ItemColor item 4 to  clPurple

Set ItemColor item 7 to clBtnFace

Note: The rgb.pkg package contains names for most of commonly used colors and for all system colors.

Last Edited: August 18, 2003


DfBaseEntryList [Property ItemTextColor]

ItemTextColor - DfBaseEntryList

Sets the text color of an individual item

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer eColor

Parameter | Description
iItem | The item number
eColor | The rgb color

Description

ItemTextColor sets the text color of an individual item. The color is associated with the item, and not the window or the column. When the item scrolls, the color moves with the item. To change the color of an item that is already displayed, you must follow the set statement with a page statement that names this object.

This is passed a single value representing an RGB color. Individual red, green, and blue colors are converted to a single value by using the RGB function.

Set ItemTextColor item 3 to (rgb(255, 0, 0)) // red

Set ItemTextColor item 4 to  clPurple

Set ItemTextColor item 7 to clBtnFace

Note: The rgb.pkg package contains names for most of commonly used colors and for all system colors.

Last Edited: August 18, 2003


DfBaseEntryList [Property pbComboNavigation]

pbComboNavigation - DfBaseEntryList

Determines how up and down arrow keys are handled by any combo form in a grid

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Determines how up and down arrow keys are handled by any combo form in a grid. When True (the default), arrows navigate within the combo form. When False, the arrows change rows in the grid. Note that this affects all combos in the grid and it is not applied on a column by column basis.

Sample

This sample sets up and down arrow navigation in combos in a grid to navigate inside the column's dropdown list.

Set pbComboNavigation to True

Sample

This sample sets up and down arrow navigation in combos in a grid to change rows in the grid.

Set pbComboNavigation to False

Last Edited: November 30, 2004


DfBaseEntryList [Property pbUseDisabledColor]

pbUseDisabledColor - DfBaseEntryList

Determines if a disabled cell should color text using peDisabledColor

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Normally a grid uses the same background color for enabled and disabled cells. You can choose to set a different color for disabled cells by setting the peDisabledColor property. This property color is used only if the pbUseDisabledColor is set to True. When pbUseDisabledColor is set to False, the default, a disabled cell's background color is determined by the Color Property - the same property used to set enabled cell background color

The pbUseDisabledColor property also changes the way disabled cells are displayed. When false, the highlight row color will be applied to all cells enabled and disabled. When true, the peDisabledColor takes precedence over the highlight row color.

This property is exposed in the Studio although you will not see the effect of the change until you run your application.

Default is false.

Last Edited: February 19, 2004


DfBaseEntryList [Property peDisabledColor]

peDisabledColor - DfBaseEntryList

Determines the background color of a disabled cell

Type: Property

Access: Read/Write

Data Type: Integer

Description

The peDisabledColor determines the background color of a disabled cell. This color is only applied if the pbUseDisabledColor property is set to true. When false, the Color property is used to set the background color of all cells in the grid.

Because pbUseDisabledColor defaults to false, this new property will have no affect on existing applications until you change that property.

This property is exposed in the Studio although you will not see the effect of the change until you run your application.

Default is clWindow.

Last Edited: February 19, 2004


DfBaseEntryList [Property peDisabledTextColor]

peDisabledTextColor - DfBaseEntryList

Determines the text color of a disabled cell

Type: Property

Access: Read/Write

Data Type: Integer

Description

The peDisabledTextColor property allows you to select a custom color for disabled cell text.

This property is exposed in the Studio, although you will not see the effect of the change until you run your application.

Default is clGrayText.

Last Edited: November 30, 2004


DfBaseEntryList [Property peGridLineColor]

peGridLineColor - DfBaseEntryList

Determines the color of lines separating grid cells

Type: Property

Access: Read/Write

Data Type: Integer

Description

The property peGridLineColor can be used to the color of lines separating grid cells (between rows and columns). By default, it will appear as clBtnFace, which is the color it has always been.

This property is exposed in the Studio.

Default is clBtnFace.

Last Edited: November 30, 2004


DfBaseEntryList [Property Resize_Column_State]

Resize_Column_State - DfBaseEntryList

Specifies whether grid columns can be resized by dragging the header divider.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Specifies whether grid columns can be resized by dragging the header divider. By default this is allowed.

Last Edited: August 16, 2004


Events for DfBaseForm

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseForm

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard |
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object |
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text |
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form |
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  |
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Undo | Procedure | Will undo the last change in the form |
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


DfBaseForm [Procedure Copy]

Copy - DfBaseForm

Copies the marked block of text to the Clipboard

Type: Procedure

Parameters: Integer Arg1 Integer Arg2 Integer Arg3

Parameter | Description
Arg1 | not used
Arg2 | not used
Arg3 | not used

Description

The Copy procedure copies the marked block of text to the Clipboard.

Last Edited: July 31, 2003


DfBaseForm [Procedure Cut]

Cut - DfBaseForm

Copies the marked block of text to the Clipboard and deletes it from this object

Type: Procedure

Parameters: Integer Arg1 Integer Arg2 Integer Arg3

Parameter | Description
Arg1 | not used
Arg2 | not used
Arg3 | not used

Description

The Cut procedure copies the marked block of text to the Clipboard and deletes it from this object.

Last Edited: July 31, 2003


DfBaseForm [Procedure Delete]

Delete - DfBaseForm

Deletes the marked block of text

Type: Procedure

Parameters: No Parameters

Description

The Delete procedure deletes the marked block of text.

Last Edited: August 5, 2003


DfBaseForm [Procedure Paste]

Paste - DfBaseForm

Copies text from the clipboard into the form

Type: Procedure

Parameters: Integer Arg1 Integer Arg2 Integer Arg3

Parameter | Description
Arg1 | not used
Arg2 | not used
Arg3 | not used

Description

The Paste procedure copies text from the clipboard into the form.

Last Edited: September 10, 2003


DfBaseForm [Procedure Select_All]

Select_All - DfBaseForm

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


DfBaseForm [Procedure Undo]

Undo - DfBaseForm

Will undo the last change in the form

Type: Procedure

Parameters: No Parameters

Description

The Undo procedure will undo the last change in the form.

Last Edited: September 11, 2003


Properties for DfBaseForm

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form |
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form |
Form_Button_Value | Determines the contents of a form prompt-button |
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button |
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed |
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field |
Form_Mask | Provides the token characters for the mask for item_num |
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character |
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


DfBaseForm [Property Form_Button]

Form_Button - DfBaseForm

Allows you to define and place a button within your form

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer eButtonStyle

Parameter | Description
iItem | The item number. If omitted, 0 is used.
eButtonStyle

Constant | Meaning
form_button_none | no button
form_button_prompt | prompt button
form_button_spin | spin button that does not wrap
form_button_spin_wrap | spin button that wraps

Description

This is a low level interface. If you need a prompt button or a spin button, sub-classes have been provided to support this at a higher level (SpinForm, dbSpinForm, dbForm). You should use Prompt_Button_Mode for this in most cases.

Form_Button allows you to define and place a button within your form. The button will be right justified. This is used in subclasses to create prompt buttons and spin buttons.

The form_button_prompt creates a button whose contents will defined by form_button_value. Form_button_spin creates a spin button and Form_button_spin_wrap create a spin button that will wrap when button value exceeds its maximum or minimum value.

Form Buttons in Grid

Form_Button can also be used to determine what kind of button will appear in a grid column when a cell in that column takes the focus. Normally, you will set this property when you add an item to a grid. Because Grids are lower level classes, you are allowed to set buttons in grids on a column-by-column basis.

Prompts
A prompt button is defined by setting a column's form_button to Form_Button_Prompt. If defined, pressing the prompt button will send the message Prompt which, by default, does nothing. It is up to you to decide what to do with this. When Prompt is called, the grid always has the focus and the cell with the prompt is the current_item. Typically, you will use the properties.

// if a column's Form_Button is set to Form_Button_Prompt,
// pressing the button will call this method
Procedure Prompt
   Integer iCell iColumn

   Get Current_Item to iCell
   Get Current_Col to iColumn
   Send Info_Box ("Prompt for item" + string(iCell) + ;
         " in column " + string(iColumn)) "Prompt"
End_Procedure

Spinners
A spin button is defined by setting a column's form_button to Form_Button_Spin or Form_Button_Spin_Wrap. If set to Form_Button_Spin, the spinner will stop when it reaches the maximum or minimum value. When set to Form_Button_Spin_Wrap, the spinner will wrap when it reaches an upper or lower limit.

When the spinner is pressed, the message OnInitSpin is called. It is up to you to set the properties minimum_position and maximum_position (which will properly initialize the spinner). Again, you can use current_item and current_col to figure out what you called.

The message DoScrollDown and DoScrollUp can be used to assign keys for the spinners (single item spin forms use the same messages and assign ctrl-up and ctrl-down to them). These are not assigned default keys in grids or dbGrids (because they ctrl-up/down keys are already assigned).

Here is how a sample grid might look:

Object oGrid1 is a Grid
    Set Size to 70 271
    Set Location to 15 15

    Set Line_Width to 2 0

    Set Form_Width   0 to 168
    Set Header_Label 0 to "Name"

    Set Form_Width   1 to 34
    Set Header_Label 1 to "Number"

    Procedure FillList
        integer i iCell

        // add 10 rows of data
        For i From 0 to 9
            Get Item_Count to iCell

             // set first column to use a prompt button
             Send Add_Item 0 ("Name"+string(i))
             Set Form_Button iCell to FORM_BUTTON_PROMPT

             // set second column to use a spin form
             Send Add_Item 0 i
             Set Form_Button (iCell+1) to FORM_BUTTON_SPIN_WRAP
             Set Form_Button_Value (iCell+1) to "..."
        Loop
    End_Procedure

    // this gets called from the first column.
    Procedure Prompt
        Send Info_Box ("prompt called for " + string(self(self)))
    End_Procedure

    // You must set these values each time a spinner is called.
    // In this example the spinner is only in one column and its
    //value is the same for each cell
    Procedure onInitSpin
        Set Minimum_Position to 0
        Set Maximum_Position to 10
    End_Procedure

    // assign keys to manually spin value
    On_Key Key_Ctrl+Key_U  Send DoScrollUp
    On_Key Key_Ctrl+Key_D  Send DoScrollDown
    // fill the list
    Send FillList

End_Object    // oGrid1

Default is Form_Button_None.

See Also

Info_Box

Last Edited: November 30, 2004


DfBaseForm [Property Form_Button_Bitmap]

Form_Button_Bitmap - DfBaseForm

Allows you to define the bitmap for a button within your form

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem String sBitmapName

Parameter | Description
iItem | Item number
sBitmapName | Bitmap file name

Description

This is a low level interface. If you need a prompt button or a spin button, sub-classes have been provided to support this at a higher level (SpinForm, dbSpinForm, dbForm). You should use Prompt_Button_Mode for this in most cases.

Form_Button allows you to define and place a button within your form. The button will be right justified. This is used in subclasses to create prompt buttons and spin buttons. Form_Button_Bitmap allows you to define a bitmap to display on the button.

Sample

This sample adds 10 rows to a Grid with 2 columns defined. It also instructs the grid to display a prompt button for each item in the 2nd column of the grid and set it's bitmap to MyNitmap.bmp.

Procedure DoFillGrid
    integer iRow iMaxRows iCount iItemCount

    move 10 to iMaxRows
    For iRow From 1 To iMaxRows
        Send Add_Item Msg_None "John Smith"
        Send Add_Item Msg_None ("305-555-1212")

        get Item_Count to iItemCount
        set Form_Button (iItemCount-1) to Form_Button_Prompt
        set Form_Button_Bitmap (iItemCount-1) to "MyBitmap.bmp"
    Loop
End_Procedure // DoFillGrid

send DoFillGrid

Last Edited: November 30, 2004


DfBaseForm [Property Form_Button_Value]

Form_Button_Value - DfBaseForm

Determines the contents of a form prompt-button

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iItem String sValue

Parameter | Description
iItem | The item number. If omitted, 0 is used.
sValue | Value to display within the prompt button

Description

This is a low level interface. If you need a prompt button or a spin button, sub-classes have been provided to support this at a higher level (SpinForm, dbSpinForm, dbForm). You should use Prompt_Button_Mode and/or Prompt_Button_Value for this in most cases.

Form_Button_Value determines the contents of a form prompt button. The value will only appear when the value of form_button is form_button_prompt.

Set Form_Button 0 to Form_Button_Prompt
Set Form_Button_Value 0 to "."

Form Buttons in Grid

Form_Button_Value can also be used to determine what text will appear in the embedded prompt button in a grid. This is set on a column-by-column basis and, by default, is blank.

Procedure FillList
    integer i iCell

    // add 10 rows of data
    For i From 0 to 9
        Get Item_Count to iCell

         // set first column to use a prompt button
         Send Add_Item 0 ("Name"+string(i))
         Set Form_Button iCell to FORM_BUTTON_PROMPT

         // set second column to use a spin form
         Send Add_Item 0 i
         Set Form_Button (iCell+1) to FORM_BUTTON_SPIN_WRAP
         Set Form_Button_Value (iCell+1) to "..."
    Loop
End_Procedure

Default is ''".

Last Edited: August 16, 2004


DfBaseForm [Property Form_Button_Window_Handle]

Form_Button_Window_Handle - DfBaseForm

Returns the Windows object handle of the prompt button

Type: Property

Access: Read-Only

Data Type: Handle

Parameters: Integer iItem Handle hValue

Parameter | Description
iItem | The item number. If omitted, 0 is used.
hValue | Window object handle of the prompt button

Description

Form_button_window_handle returns the Windows object handle of the prompt button.

Last Edited: August 18, 2003


DfBaseForm [Property Form_Justification_Mode]

Form_Justification_Mode - DfBaseForm

Determines how data will be displayed

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer eMode

Parameter | Description
iItem | The item number. If omitted, 0 is used.
eMode

Constant | Meaning
FORM_DISPLAYLEFT | form is displayed left justified
FORM_DISPLAYRIGHT | form is displayed right justified
FORM_DISPLAYCENTER | form is displayed centered
FORM_EDITLEFT | form is displayed for editing left justified
FORM_EDITRIGHT | form is displayed for editing right justified

Description

The Form_justification_mode determines how data will be displayed. A different setting is supported for display when the form has the focus and when it does not. The settings FORM_DISPLAYLEFT, FORM_DISPLAYRIGHT, and FORM_DISPLAYCENTER determine how a masked form appears when it is not the focus object. The form can be displayed in the left justified, centered, or right justified. The settings FORM_EDITLEFT and FORM_EDITRIGHT determine where the data appears when the form has the focus and is being used for entry. The edit and display settings should be ORed together.

Set form_justification_mode item 0 to (FORM_DISPLAYCENTER IOR FORM_EDITLEFT)

When form_datatype is set to a masked type the display and edit justification modes are set to appropriate values. Masked number and currency forms display and edit to the right. Masked date and string forms appear and are edited to the left.

This property has no effect on non-masked form_datatypes.

Last Edited: August 18, 2003


DfBaseForm [Property Form_Margin]

Form_Margin - DfBaseForm

Defines the maximum number of characters that can be typed into a data-entry field

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iMargin

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iMargin | the maximum number of characters that can be typed into a data-entry field

Description

Form_margin defines the maximum number of characters that can be typed into a data-entry field. If the number of characters is greater than the display area, the object will horizontally scroll left or right to accommodate the cursor. This is set by default to the width of the field addressed unless the item enters to a variable or expression, in which case it is set by default to 100.

Last Edited: August 18, 2003


DfBaseForm [Property Form_Mask]

Form_Mask - DfBaseForm

Provides the token characters for the mask for item_num

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iItem String sMask

Parameter | Description
iItem | The item number. If omitted, 0 is used.
sMask | the form mask

Description

The Form_mask property provides the token characters for the mask for item_num. Any characters provided in this property for any mask type (defined in the form_datatype property) for which they are not token characters will be repeated in the displayed values literally. Token characters can be displayed literally by preceding each with a backslash (\).

The token characters for form_datatypes mask_numeric_window and mask_currency_window are:

, | comma inserts local thousands' separator every three places to the left of the decimal
. | period is replaced with the local decimal indicator
; | semi-colon comes after format for positive quantities, before format for negative numbers
# | no digit or one digit
* | any number of digits, including none
0 | one digit, or a 0 (zero)

The token characters for form_datatype mask_window are:

# | any numeric digit (0-9)
@ | any alphabetic character
! | any punctuation character
* | any single printable character

The token characters for form_datatype mask_date_window are:

m | month 1 - 12
mm | month 01 - 12
mmm | local abbreviation for month Jan - Dec
mmmm | local name for month January - December
d | day 1 - 31
dd | day 01 - 31
ddd | local abbreviation for day of week Sun - Sat
dddd | local name for day of week Sunday - Saturday
yy | 00 - 99
yyyy | 1700 - 2900
/ | diagonal is replaced with the local date separator

Notes

  • Date masks must supply token characters for all date elements (day, month and year).
  • Masking is not supported in combo forms.

See Also

Form_DataType | Currency_Mask | Numeric_Mask | Value

Last Edited: August 12, 2005


DfBaseForm [Property Masked_Value]

Masked_Value - DfBaseForm

Returns a Form or grid value with masking character

Type: Property

Access: Read-Only

Data Type: String

Parameters: Integer iItem String sValue

Parameter | Description
iItem | Item number. Always 0 and optional in forms
sValue | The returned maksed value

Description

Masked_Value returns a form or grid value with masked formatting characters. You can use Value to return value of a form or grid without masking characters.

In this example, assume that oForm contains a currency mask

ShowValues
    string sValue
    set value of oForm1 to 1234.56
    Get Masked_Value of oForm1 to sValue
    showln "masked: " sValue        // should be: masked: $1,234.56
    Get Value  of oForm1 to sValue
    showln "un-masked: " sValue     // should be: masked: 1234.56
End_procedure

Note:Masking is not supported in Combo-forms

See Also

Value | Form_DataType | Form_Mask | Currency_Mask | Numeric_Mask

Last Edited: October 23, 2003


DfBaseForm [Property Password_State]

Password_State - DfBaseForm

Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Boolean bPassword

Parameter | Description
iItem | The item number. If omitted, 0 is used.
bPassword | True if form is a password, false if not.

Description

When the Password_state property is set true, each character of a form's value is displayed as an asterisk "*", rather than the characters that is typed.

Default is false.

Last Edited: December 28, 2004


DfBaseFormList [Event Header_Notification]

Header_Notification - DfBaseFormList

Sent when the header has received a mouse event

Type: Event

Parameters: Integer eNotifyMode Integer iItem

Parameter | Description
eNotifyMode

Constant | Meaning
HD_NOTIFY_MOUSE_CLICK | mouse single click in header
HD_NOTIFY_MOUSE_DBLCLICK | mouse double click in header
HD_NOTIFY_DIVIDER_DBLCLICK | mouse double click in header divider

iItem | The item number

Description

The Header_notification message is sent when the header has received a mouse event. Three event notifications are supported: button mouse-click, button double click, and a double click on a header divider. If a single click occurs (HD_Notify_mouse_click) the message header_mouse_click is sent. If a double click occurs (HD_Notify_mouse_dblclick) the message header_mouse_double_click is sent. When possible, you should augment these two messages.

There is no default action taken for a divider double click. You would want to augment this procedure to handle such a case.

Procedure Header_notification integer mode integer item#
    If mode eq HD_Notify_Divider_DblCLick ;
        Send Special_notify_Event Item#
    Else ;
        forward send header_notifcation mode item#
End_procedure

Last Edited: August 18, 2003


DfBaseFormList [Event OnMouseWheel]

OnMouseWheel - DfBaseFormList

An event sent everytime a mouse wheel is clicked

Type: Event

Parameters: Integer iClicks Integer iKey

Parameter | Description
iClicks | The number of clicks of the mouse wheel
iKey | The windows bit mask that determines what other keys might have been pressed as you move the mouse-wheel. It is not being used in the default implementation. Consult the windows documentation for WM_MouseWheel if you need to use this.

Description

This event does nothing. It is augmented in super-classes to support scrolling in grids.

If you wish to create custom mouse wheel behaviors you can augment the event OnMouseWheel. This message is sent every time a mouse wheel is clicked.

If iClicks is positive the wheel is being moved forward (away from you). By default this is used to scroll towards the top of the list. If iClicks is negative the wheel is being moved backwards (towards you). By default this is used to scroll down the list.

Last Edited: September 10, 2003


Events for DfBaseFormList

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Notification | Sent when the header has received a mouse event |
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnMouseWheel | An event sent everytime a mouse wheel is clicked |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


DfBaseFormList [Function Column_Combo_Find]

Column_Combo_Find - DfBaseFormList

Searches for an item in the dropdown list of a combo form for a column by value

Type: Function

Return Data Type: Integer

Parameters: integer iColumn integer iStart string sFindValue

Parameter | Description
iColumn | The column number (zero-based)
iStart | Starting item position to search (zero-based)
sFindValue | Value to find in list

Return Value

Returns the item number from the unsorted list or -1 if the search fails.

Description

Searches for an item in the dropdown list of a combo form for a column by value. You can use the starting position (iStart) to search for duplicates. Note that the combo value to be found must be an exact match to the item in the list, in both length and casing.

Sample

This sample fills a grid with 20 rows of 2 columns each. The first column (column 0) is filled alternatingly with values John, Anne and Judy. It then instructs the grid to make column 0 a combo form, to sort the combo form's dropdown list, and adds 7 items to the dropdown list of the combo form. When button oButton1 is clicked, it finds the first occurence of John in the list for the current column's combo form dropdown list and displays it in a message box.

Object oGrid1 is a Grid
    :
    Procedure DoFillGrid
        integer iRow iMaxRows iCount

        move 20 To iMaxRows
        For iRow From 1 To iMaxRows
            if (mod(iCount,3)=0) Send Add_Item Msg_None "John"
            else if (mod(iCount,3)=1) Send Add_Item Msg_None "Anne"
            else Send Add_Item Msg_None "Judy"

            Send Add_Item Msg_None ("305-555-1212")

            increment iCount
        Loop
    End_Procedure // DoFillGrid

    send DoFillGrid

    // make column 0 a combo
    set Column_Combo_State 0 to True
    // sort the dropdown list for the combo in column 0
    set Column_Combo_Sort_State 0 to True

    // add items to the dropdown list for the combo in column 0
    Send Column_Combo_Add_Item 0 "Anne"
    Send Column_Combo_Add_Item 0 "Elizabeth"
    Send Column_Combo_Add_Item 0 "Albert"
    Send Column_Combo_Add_Item 0 "John"
    Send Column_Combo_Add_Item 0 "Doug"
    Send Column_Combo_Add_Item 0 "Judy"
    Send Column_Combo_Add_Item 0 "David"
End_Object  // oGrid1

Object oButton1 is a Button
    :
    Procedure OnClick
        integer iColumn iStart iFoundItem
        string sValue

        move 0 to iColumn
        move 0 to iStart
        move "John" to sValue
        get Column_Combo_Find of oGrid1 iColumn iStart sValue to iFoundItem

        if (iFoundItem <> -1) ;
            send Info_Box ("Value "+sValue+" was found in item "+string(iFoundItem)) "Value found"
    End_Procedure // OnClick
    :
End_Object  // oButton1

Last Edited: November 30, 2004


DfBaseFormList [Function Column_Combo_Item_Count]

Column_Combo_Item_Count - DfBaseFormList

Returns number of items in the combo form's dropdown list for a column

Type: Function

Return Data Type: Integer

Parameters: integer iColumn

Parameter | Description
iColumn | The column number (zero-based)

Return Value

Description

Returns number of items in the combo form's dropdown list for a column.

Sample

This sample gets the number of items in the combo form dropdown list for column 2 of grid object oGrid1 to variable iListItemCount and then displays it in a message box.

Procedure CheckItemCount
    integer iListItemCount iColumn

    move 2 to iColumn
    get Column_Combo_Item_Count of oGrid1 iColumn to iListItemCount

    send Info_Box ;
        ("There are " + string(iListItemCount) + " items in the list for the combo form in column " + string(iColumn)) ;
            "Column Combo Item Count"
End_Procedure  // CheckItemCount

Last Edited: November 30, 2004


DfBaseFormList [Function Column_Combo_Value]

Column_Combo_Value - DfBaseFormList

Returns the value of a dropdown list item in the combo form for a column

Type: Function

Return Data Type: String

Parameters: integer iColumn integer iListItem

Parameter | Description
iColumn | The column number (zero-based)
iListItem | The item number to return the value of (zero-based)

Return Value

Value of a dropdown list item.

Description

Returns the value of a dropdown list item in the combo form for a column. This returns the value of the unsorted list, even if Column_Combo_Sort_State for the column is True..

Sample

This sample gets the value of item 5 in the combo form dropdown list for column 2 of grid object oGrid1 to variable sComboValue and then displays it in a message box.

Procedure CheckItemCount
    integer iColumn iItem
    string sComboValue

    move 2 to iColumn
    move 5 to iItem
    get Column_Combo_Value of oGrid1 iColumn iItem to sComboValue

    send Info_Box sComboValue "Combo Value"
End_Procedure  // CheckItemCount

Last Edited: November 30, 2004


Methods for DfBaseFormList

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column |
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column |
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column |
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value |
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column |
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column |
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


DfBaseFormList [Procedure Column_Combo_Add_Item]

Column_Combo_Add_Item - DfBaseFormList

Adds an item to the end of the combo form's dropdown list for a column

Type: Procedure

Parameters: integer iColumn string sValue

Parameter | Description
iColumn | [ToDo: In Progress]
sValue | [ToDo: In Progress]

Description

This is the message that must be used to fill the list of items that appear in the combo form's dropdown list.

Sample

This sample sets column 2 to be a combo column, then adds "Type 1" and "Type 2" to the combo's dropdown list.

set Column_Combo_State 2 to True
Send Column_Combo_Add_Item 2 "Type 1"
Send Column_Combo_Add_Item 2 "Type 2"

Sample

This sample fills a grid with 20 rows of 3 columns each. It then instructs the grid to make column 2 a combo form, to sort the combo form's dropdown list, and adds 3 items to the dropdown list.

Procedure DoFillGrid
    integer iRow iMaxRows iCount
    string sCustomerName

    move "John Q. Customer" to sCustomerName

    move 20 To iMaxRows
    For iRow From 1 To iMaxRows
        Send Add_Item Msg_None (sCustomerName + string (iRow)))
        Send Add_Item Msg_None ("305-555-1212")
        Send Add_Item Msg_None (if(mod(iCount,2)=0,"Type 1","Type 2"))
        increment iCount
    Loop
End_Procedure // DoFillGrid

send DoFillGrid

// make column 2 a combo
set Column_Combo_State 2 to True
// sort the dropdown list for the combo in column 2
set Column_Combo_Sort_State 2 to True
// add items to the dropdown list for the combo in column 2
Send Column_Combo_Add_Item 2 "Type 3"
Send Column_Combo_Add_Item 2 "Type 2"
Send Column_Combo_Add_Item 2 "Type 1"

Last Edited: December 2, 2004


DfBaseFormList [Procedure Column_Combo_Delete_Data]

Column_Combo_Delete_Data - DfBaseFormList

Deletes all items from the combo form's dropdown list for a column

Type: Procedure

Parameters: integer iColumn

Parameter | Description
iColumn | The column number (zero-based)

Description

Deletes all items from the combo form's dropdown list for a column.

Sample

This sample deletes all items from the combo form dropdown list for column 2.

send Column_Combo_Delete_Item 2

Last Edited: November 30, 2004


DfBaseFormList [Procedure Column_Combo_Delete_Item]

Column_Combo_Delete_Item - DfBaseFormList

Deletes an item from the combo form's dropdown list for a column

Type: Procedure

Parameters: integer iColumn integer iItem

Parameter | Description
iColumn | The column number (zero-based)
iItem | The item number to delete (zero-based)

Description

Deletes an item from the combo form's dropdown list for a column.

Sample

This sample deletes item 2 from the combo form dropdown list for column 2.

send Column_Combo_Delete_Item 2 2

Last Edited: November 30, 2004


DfBaseFormList [Procedure Column_Combo_Refresh]

Column_Combo_Refresh - DfBaseFormList

Forces a refresh for the combo form of a column

Type: Procedure

Parameters: integer iColumn

Parameter | Description
iColumn | The column number (zero-based)

Description

If the combo form is displayed and changes are made to the dropdown list (e.g. via Column_Combo_Add_Item), the visual list is not updated until the user changes rows or columns in the grid. Sending this message will force a refresh for the column's combo form.

Sample

This sample forces a refresh of the combo form in column 2 of the grid.

send Column_Combo_Refresh 2

Last Edited: November 30, 2004


DfBaseFormList [Procedure DoMakeColumnVisible]

DoMakeColumnVisible - DfBaseFormList

Ensures that the passed column number is fully visible

Type: Procedure

Parameters: Integer iColumn

Parameter | Description
iColumn | The number of the column that must be visible

Description

Sending the DoMakeColumnVisible messages ensures that the passed column number is fully visible. If the column is not visible, the grid will be scrolled as needed to make it so.

Procedure ScrollLeft
       Send DoMakeColumnVisible 0
End_Procedure
Procedure ScrollRight
       Send DoMakeColumnVisible (item_limit(self)-0)
End_Procedure

This procedure is used in objects based on dbGrid and dbList (implemented in the Datalist super-class) to snap the grid back to column zero whenever the message beginning_of_panel is sent to a view. The message beginning_of_panel sends the message OnBeginningOfPanel to all objects. When the dbGrid or dbList receives the message it does the following:

// augmnt to always force the first column to be visible. This will occur during a
// panels clear or save. It makes sense to restore the column. If you do no want this
// behavior just cancel it.
Procedure OnBeginningofPanel
   Send DoMakeColumnVisible 0
end_procedure

Last Edited: August 13, 2003


Properties for DfBaseFormList

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made |
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list |
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. |
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order |
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item |
CurrentCellTextColor | Sets the text color of the current focus item |
CurrentRowColor | Sets the background color of the current row |
CurrentRowTextColor | Sets the text color of the current row |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid |
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers |
Header_Label | Define text for headers |
Header_Visible_State | Determines if the grid header will be visible |
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. |
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed |
IsColumnVisible | Determine if a particular column is visible |
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
ItemColor | Sets the color of an individual item |
ItemTextColor | Sets the text color of an individual item |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid |
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell |
peDisabledTextColor | Determines the text color of a disabled cell |
peGridLineColor | Determines the color of lines separating grid cells |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


DfBaseFormList [Property AutoSize_Height_State]

AutoSize_Height_State - DfBaseFormList

Determines if grid's automatic height adjustment will be made

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When this property is set to true, the grid's pixel height will be adjusted to exactly fit the number of rows in the display area. This avoids the display of partial rows. If set to false, no automatic height adjustment will be made.

If you are using anchors and plan on resizing your grids, you should set this property to false, the default.

Prior to VDF8, the default value was True. In VDF8, this was changed to false to more transparently support anchor-based resizing

Default is false.

Last Edited: July 30, 2003


DfBaseFormList [Property Column_Combo_Entry_State]

Column_Combo_Entry_State - DfBaseFormList

Determines if column allows entry into the cell or only allows selection of values from list

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: integer iColumn boolean bAllowEntry

Parameter | Description
iColumn | The column number (zero-based)
bAllowEntry | If true, allows entry into the cell

Description

Determines if the column allows entry into the cell, or if values can only be selected from the available values in the combo form's dropdown list.

Sample

This sample allows users to enter data that is not available in the dropdown list of the combo form in column 2 of a grid object.

set Column_Combo_Entry_State 2 to True

Sample

This sample disallows users to enter data and ensures that values can only be selected from the values available in the dropdown list of the combo form in column 2 of a grid object.

set Column_Combo_Entry_State 2 to False

Default is false

Last Edited: November 30, 2004


DfBaseFormList [Property Column_Combo_ListRowCount]

Column_Combo_ListRowCount - DfBaseFormList

Determines maximum number of rows in the combo's dropdown list that are displayed.

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iColumn integer iRows

Parameter | Description
iColumn | The column number (zero-based)
iRows | Maximum number of rows

Description

Determines the maximum number of rows in the combo form's dropdown list that are displayed. When exceeded, a scroll bar appears.

Sample

This sample fills a grid with 20 rows of 3 columns each. It then instructs the grid to make column 2 a combo form and adds 8 items to the dropdown list. It also instructs the grid to only display 5 items in the combo form's dropdown list and scroll to display additional items. So, when the user first clicks on the combo form's arrow to display the dropdown list, "Type 1", "Type 2", "Type 3", Type 4" and "Type 5" will be displayed. To view the other items on the list, the user will have to scroll down.

Procedure DoFillGrid
    integer iRow iMaxRows iCount
    string sCustomerName

    move "John Q. Customer" to sCustomerName

    move 20 To iMaxRows
    For iRow From 1 To iMaxRows
        Send Add_Item Msg_None (sCustomerName + string (iRow)))
        Send Add_Item Msg_None ("305-555-1212")
        Send Add_Item Msg_None (if(mod(iCount,2)=0,"Type 1","Type 2"))
        increment iCount
    Loop
End_Procedure // DoFillGrid

send DoFillGrid

// make column 2 a combo
set Column_Combo_State 2 to True
// set the number of displayed rows in dropdown list before scrolling
set Column_Combo_ListRowCount 2 to 5

// add items to the dropdown list for the combo in column 2
Send Column_Combo_Add_Item 2 "Type 1"
Send Column_Combo_Add_Item 2 "Type 2"
Send Column_Combo_Add_Item 2 "Type 3"
Send Column_Combo_Add_Item 2 "Type 4"
Send Column_Combo_Add_Item 2 "Type 5"
Send Column_Combo_Add_Item 2 "Type 6"
Send Column_Combo_Add_Item 2 "Type 7"
Send Column_Combo_Add_Item 2 "Type 8"

Last Edited: November 30, 2004


DfBaseFormList [Property Column_Combo_Sort_State]

Column_Combo_Sort_State - DfBaseFormList

Determines if a column should display dropdown list in sorted order

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: integer iColumn boolean bSort

Parameter | Description
iColumn | The column number
bSort | If True, the column displays in sorted order

Description

Determines if iColumn should display the combo form's dropdown list in sorted order. Only the visual list is sorted. The actual list of column-items that (added via column_combo_add_item) are not sorted.

Sample

This sample instructs the grid to display the combo's dropdown list for column 2 in sorted order.

set Column_Combo_Sort_State 2 to True

Sample

This sample fills a grid with 20 rows of 3 columns each. It then instructs the grid to make column 2 a combo form, to sort the combo form's dropdown list, and adds 3 items to the dropdown list.

Procedure DoFillGrid
    integer iRow iMaxRows iCount
    string sCustomerName

    move "John Q. Customer" to sCustomerName

    move 20 To iMaxRows
    For iRow From 1 To iMaxRows
        Send Add_Item Msg_None (sCustomerName + string (iRow)))
        Send Add_Item Msg_None ("305-555-1212")
        Send Add_Item Msg_None (if(mod(iCount,2)=0,"Type 1","Type 2"))
        increment iCount
    Loop
End_Procedure // DoFillGrid

send DoFillGrid

// make column 2 a combo
set Column_Combo_State 2 to True
// sort the dropdown list for the combo in column 2
set Column_Combo_Sort_State 2 to True
// add items to the dropdown list for the combo in column 2
Send Column_Combo_Add_Item 2 "Type 3"
Send Column_Combo_Add_Item 2 "Type 2"
Send Column_Combo_Add_Item 2 "Type 1"

Default is false

Last Edited: November 30, 2004


DfBaseFormList [Property Column_Combo_State]

Column_Combo_State - DfBaseFormList

Specifies whether a column of a grid is presented as a combo form

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: integer iColumn boolean bColumnCombo

Parameter | Description
iColumn | The column number (zero-based)
bColumnCombo | If True, column is a combo form

Description

The Column_Combo_State property specifies whether iColumn of this grid is presented as a combo form. This will be used most-often when a column's field is defined by its data dictionary as having a validation table. This property can be used with dbGrid objects and dbList as well.

This property is normally set once for each column that needs a combo. However, this can be set and unset on an item by item basis to allow for custom combos based on a row. This can be set/unset inside in the item_change message before the forward send. When this tecnique is used all column-combo data will need to be set on an item by item basis.

Sample

Normally this property is set once in your program when the object is being created. If a data field value can be represented as a combo form, you can set the dbGrid's column to be a combo form by setting this property to true.

Set Column_Combo_State 4 to TRUE

Toggling Column-Based Combos Dynamically

This property may be set dynamically, although such usage would be unusual. If the property is changed when the object is active, you will not see a change in the object's appearance until you redisplay the object.

Sample

This sample would toggle a column's combo state and update the dbGrid as required.

Procedure ToggleCombo4
    Boolean bState

    Get Column_Combo_State 4 to bState
    Set Column_Combo_State 4 to (not(bState))

    // if the object is active, we must refresh to see changes
    If (Active_State(Self)) send Display
End_Procedure  // ToggleCombo4

Cell-Specific Combos

You can take advantage of the fact that combo forms are drawn only when the cell that has a column-based combo form is entered and turn off the column-based combo as the user moves through the table. Item_Change is an excellent place to do this.

Sample

This sample shows how to make a combo form appear for a specific cell instead of the entire column. This sample can be tested in a Grid or dbGrid with 3 columns. When the user moves to item 5 (since items are zero-based, this would be the 3rd column in the 2nd row), a combo form appears in that cell. If moving to any other cell, the combo for the target item's column is turned off.

Procedure Item_Change integer iFromItem integer iToItem returns integer
    integer iRetVal iTargetColumn iTargetItem

    move 5 to iTargetItem

    // determine the column iTargetItem is in
    move (iTargetItem / (Base_Item(Self)) + 1) to iTargetColumn

    // turn on combo form for iToItem if we're in the right column
    if (iToItem = iTargetItem) begin
        set Column_Combo_State iTargetColumn to True
        send Column_Combo_Add_Item iTargetColumn "Joan" ""
        send Column_Combo_Add_Item iTargetColumn "George" ""
        send Column_Combo_Add_Item iTargetColumn "Zach" ""
    end
    // turn the combo off for iToItem's column if it is currently on
    else begin
        set Column_Combo_State iTargetColumn to False
    end

    forward get msg_Item_Change iFromItem iToItem to iRetVal

    procedure_return iRetVal
End_Procedure  // Item_Change

Sample

This sample fills a grid with 20 rows of 3 columns each. It then instructs the grid to make column 2 a combo form, to sort the combo form's dropdown list, and adds 3 items to the dropdown list.

Procedure DoFillGrid
    integer iRow iMaxRows iCount
    string sCustomerName

    move "John Q. Customer" to sCustomerName

    move 20 To iMaxRows
    For iRow From 1 To iMaxRows
        Send Add_Item Msg_None (sCustomerName + string (iRow)))
        Send Add_Item Msg_None ("305-555-1212")
        Send Add_Item Msg_None (if(mod(iCount,2)=0,"Type 1","Type 2"))
        increment iCount
    Loop
End_Procedure // DoFillGrid

send DoFillGrid

// make column 2 a combo
set Column_Combo_State 2 to True
// sort the dropdown list for the combo in column 2
set Column_Combo_Sort_State 2 to True
// add items to the dropdown list for the combo in column 2
Send Column_Combo_Add_Item 2 "Type 3"
Send Column_Combo_Add_Item 2 "Type 2"
Send Column_Combo_Add_Item 2 "Type 1"

Note:
Column_xxx states must be set after the Entry_Items, in order for it to take effect (e.g. in the bottom code section - below the comment line in the editor).

Default is false

Last Edited: June 21, 2005


DfBaseFormList [Property CurrentCellColor]

CurrentCellColor - DfBaseFormList

Sets the background color of the current focus item

Type: Property

Access: Read/Write

Data Type: Integer

Description

The CurrentCellColor property sets the background color of the current focus item. This is passed a single value representing an RGB color. Individual Red, Green, and Blue colors are converted to a single value by using the RGB function.

If no value is specifically set, a default color setting is used. The default is stored in a global integer named default_current_item_color. Its default value is aqua (rgb(0, 255, 255)). You may change this value in your program.

Set CurrentCellColor to (rgb(255, 0, 0)) // red
Set CurrentCellColor to clPurple
Set CurrentCellColor to clBtnFace

Note:The rgb.pkg package contains names for most of commonly used colors and names for all system colors.

Last Edited: August 12, 2005


DfBaseFormList [Property CurrentCellTextColor]

CurrentCellTextColor - DfBaseFormList

Sets the text color of the current focus item

Type: Property

Access: Read/Write

Data Type: Integer

Description

The CurrentCellTextColor property sets the text color of the current focus item. This is passed a single value representing an RGB color. Individual Red, Green, and Blue colors are converted to a single value by using the RGB function.

If no value is specifically set, a default color setting is used. The default is stored in a global integer named default_current_item_color. Its default value is aqua (rgb(0, 255, 255)). You may change this value in your program.

Set CurrentCellTextColor to (rgb(255, 0, 0)) // red
Set CurrentCellTextColor to clPurple
Set CurrentCellTextColor to clBtnFace

Note:The rgb.pkg package contains names for most of commonly used colors and names for all system colors.

Last Edited: August 12, 2005


DfBaseFormList [Property CurrentRowColor]

CurrentRowColor - DfBaseFormList

Sets the background color of the current row

Type: Property

Access: Read/Write

Data Type: Integer

Description

CurrentRowColor sets the background color of the current row. This is passed a single value representing an RGB color. Individual Red, Green, and Blue colors are converted to a single value by using the RGB function.

If no value is specifically set, a default color setting is used. The default is stored in a global integer named default_highlight_row_color. Its default value is aqua (rgb(0, 255, 255)). You may change this value in your program. You may also change a default value within your registry by changing the key TableRowColor. If you set the key TableRowColor in the registry, you must use a string value in the form of red, green, blue (e.g., 0, 255, 0 is green).

Set CurrentRowColor to (rgb(255, 0, 0)) // red

Set CurrentRowColor to clPurple

Set CurrentRowColor to clBtnFace

Note: The rgb.pkg package contains names for most of commonly used colors and names for all system colors.

Last Edited: August 11, 2003


DfBaseFormList [Property CurrentRowTextColor]

CurrentRowTextColor - DfBaseFormList

Sets the text color of the current row

Type: Property

Access: Read/Write

Data Type: Integer

Description

CurrentRowTextColor sets the text color of the current row. This is passed a single value representing an RGB color. Individual Red, Green, and Blue colors are converted to a single value by using the RGB function.

If no value is specifically set, a default color setting is used. The default is stored in a global integer named default_highlight_row_color. Its default value is aqua (rgb(0, 255, 255)). You may change this value in your program. You may also change a default value within your registry by changing the key TableRowColor. If you set the key TableRowColor in the registry, you must use a string value in the form of red, green, blue (e.g., 0, 255, 0 is green).

Set CurrentRowTextColor to (rgb(255, 0, 0)) // red

Set CurrentRowTextColor to clPurple

Set CurrentRowTextColor to clBtnFace

Note: The rgb.pkg package contains names for most of commonly used colors and names for all system colors.

Last Edited: August 11, 2003


DfBaseFormList [Property GridLine_Mode]

GridLine_Mode - DfBaseFormList

Determines how grid lines will be displayed in the grid

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Gridline_mode property determines how grid lines will be displayed in the grid. You may choose to display no lines, horizontal lines, vertical lines, or both horizontal and vertical lines.

If no value is specifically set, a default setting is used. The default is stored in a global integer named default_table_grid. Its default value is grid_visible_both. You may change this value in your program. You may also change this default value within your registry by changing the key TableGrid.

If you set the key TableGrid in the registry, you must use the values 0 through 3:

Constant | Meaning
0 | Grid_Visible_none
1 | Grid_Visible_Horz
2 | Grid_Visible_Vert
3 | Grid_Visible_Both

Last Edited: November 30, 2004


DfBaseFormList [Property Header_Justification_Mode]

Header_Justification_Mode - DfBaseFormList

Determines how text will be justified in list and grid headers

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iColumn Integer eMode

Parameter | Description
iColumn | The column number (zero-based)
eMode

Constant | Meaning
JMode_Left | Left justify
JMode_Right | Right justify
JMode_Center | Center

Description

Header_justification_mode allows you to define how text will be justified in list and grid headers. Text can be displayed from the left, the right, or centered.

Default is JMode_Left.

Last Edited: November 30, 2004


DfBaseFormList [Property Header_Label]

Header_Label - DfBaseFormList

Define text for headers

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iColumn String sText

Parameter | Description
iColumn | The column number
sText | The column label

Description

Header_label allows you to define text for headers. This property specifies the text that is to appear at the top of Column iColumn. In data-aware classes, the value of this property is overridden by label values in the DDO when auto_label_state has been set true.

Last Edited: August 18, 2003


DfBaseFormList [Property Header_Visible_State]

Header_Visible_State - DfBaseFormList

Determines if the grid header will be visible

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Header_visible_state determines if the grid header will be visible. By default, a header will appear.

Default is true.

Last Edited: August 18, 2003


DfBaseFormList [Property Highlight_Row_State]

Highlight_Row_State - DfBaseFormList

When this property is true, the current row will be displayed in this object's CurrentRowColor.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When this property is true, the current row will be displayed in this object's CurrentRowColor.

Last Edited: November 30, 2004


DfBaseFormList [Property Horz_Scroll_Bar_Visible_State]

Horz_Scroll_Bar_Visible_State - DfBaseFormList

Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Horz_scroll_bar_visible_state specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed-when the length of a row exceeds the visible width of the grid.

Note: The horizontal scroll bar will not appear when all columns fit within the object's width.

Default is true.

Last Edited: August 18, 2003


DfBaseFormList [Property IsColumnVisible]

IsColumnVisible - DfBaseFormList

Determine if a particular column is visible

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: Integer iColumn Integer iValue

Parameter | Description
iColumn | The column number
iValue | Returns true if column is visible

Description

IsColumnVisible can be called to determine if a particular column is visible. You can use this to determine if you need to perform a scroll by sending the DoMakeColumnVisible message.

Procedure CheckCol integer iCol
      Boolean bVisible
      Get IsColumnVisible iCol to bVisible
      If not bVisible ;
          Send DoMakeColumnVisible iCol
End_procedure

Last Edited: August 18, 2003


DfBaseFormList [Property ItemColor]

ItemColor - DfBaseFormList

Sets the color of an individual item

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer eColor

Parameter | Description
iItem | The item number
eColor | The rgb color

Description

ItemColor sets the color of an individual item. The color is associated with the item, and not the window or the column. When the item scrolls, the color moves with the item. To change the color of an item that is already displayed, you must follow the set statement with a page statement that names this object.

This is passed a single value representing an RGB color. Individual red, green, and blue colors are converted to a single value by using the RGB function.

Set ItemColor item 3 to (rgb(255, 0, 0)) // red

Set ItemColor item 4 to  clPurple

Set ItemColor item 7 to clBtnFace

Note: The rgb.pkg package contains names for most of commonly used colors and for all system colors.

Last Edited: August 18, 2003


DfBaseFormList [Property ItemTextColor]

ItemTextColor - DfBaseFormList

Sets the text color of an individual item

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer eColor

Parameter | Description
iItem | The item number
eColor | The rgb color

Description

ItemTextColor sets the text color of an individual item. The color is associated with the item, and not the window or the column. When the item scrolls, the color moves with the item. To change the color of an item that is already displayed, you must follow the set statement with a page statement that names this object.

This is passed a single value representing an RGB color. Individual red, green, and blue colors are converted to a single value by using the RGB function.

Set ItemTextColor item 3 to (rgb(255, 0, 0)) // red

Set ItemTextColor item 4 to  clPurple

Set ItemTextColor item 7 to clBtnFace

Note: The rgb.pkg package contains names for most of commonly used colors and for all system colors.

Last Edited: August 18, 2003


DfBaseFormList [Property pbComboNavigation]

pbComboNavigation - DfBaseFormList

Determines how up and down arrow keys are handled by any combo form in a grid

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Determines how up and down arrow keys are handled by any combo form in a grid. When True (the default), arrows navigate within the combo form. When False, the arrows change rows in the grid. Note that this affects all combos in the grid and it is not applied on a column by column basis.

Sample

This sample sets up and down arrow navigation in combos in a grid to navigate inside the column's dropdown list.

Set pbComboNavigation to True

Sample

This sample sets up and down arrow navigation in combos in a grid to change rows in the grid.

Set pbComboNavigation to False

Last Edited: November 30, 2004


DfBaseFormList [Property pbUseDisabledColor]

pbUseDisabledColor - DfBaseFormList

Determines if a disabled cell should color text using peDisabledColor

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Normally a grid uses the same background color for enabled and disabled cells. You can choose to set a different color for disabled cells by setting the peDisabledColor property. This property color is used only if the pbUseDisabledColor is set to True. When pbUseDisabledColor is set to False, the default, a disabled cell's background color is determined by the Color Property - the same property used to set enabled cell background color

The pbUseDisabledColor property also changes the way disabled cells are displayed. When false, the highlight row color will be applied to all cells enabled and disabled. When true, the peDisabledColor takes precedence over the highlight row color.

This property is exposed in the Studio although you will not see the effect of the change until you run your application.

Default is false.

Last Edited: February 19, 2004


DfBaseFormList [Property peDisabledColor]

peDisabledColor - DfBaseFormList

Determines the background color of a disabled cell

Type: Property

Access: Read/Write

Data Type: Integer

Description

The peDisabledColor determines the background color of a disabled cell. This color is only applied if the pbUseDisabledColor property is set to true. When false, the Color property is used to set the background color of all cells in the grid.

Because pbUseDisabledColor defaults to false, this new property will have no affect on existing applications until you change that property.

This property is exposed in the Studio although you will not see the effect of the change until you run your application.

Default is clWindow.

Last Edited: February 19, 2004


DfBaseFormList [Property peDisabledTextColor]

peDisabledTextColor - DfBaseFormList

Determines the text color of a disabled cell

Type: Property

Access: Read/Write

Data Type: Integer

Description

The peDisabledTextColor property allows you to select a custom color for disabled cell text.

This property is exposed in the Studio, although you will not see the effect of the change until you run your application.

Default is clGrayText.

Last Edited: November 30, 2004


DfBaseFormList [Property peGridLineColor]

peGridLineColor - DfBaseFormList

Determines the color of lines separating grid cells

Type: Property

Access: Read/Write

Data Type: Integer

Description

The property peGridLineColor can be used to the color of lines separating grid cells (between rows and columns). By default, it will appear as clBtnFace, which is the color it has always been.

This property is exposed in the Studio.

Default is clBtnFace.

Last Edited: November 30, 2004


DfBaseFormList [Property Resize_Column_State]

Resize_Column_State - DfBaseFormList

Specifies whether grid columns can be resized by dragging the header divider.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Specifies whether grid columns can be resized by dragging the header divider. By default this is allowed.

Last Edited: August 16, 2004


Events for DfBaseGroup

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseGroup

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaseGroup

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Events for DfBaselineControl

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaselineControl

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaselineControl

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Line_Color |  |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Horizontal_State | Specifies whether the line is horizontal or vertical |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Offset |  |
Line_Style | Supports the line styles LnDip, LnBump, and LnSingle |
Line_Thickness | Determines the pixel thickness of the line |
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Line_Color |  |
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


DfBaselineControl [Property Bottom_Line_Color]

Bottom_Line_Color - DfBaselineControl

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


DfBaselineControl [Property Horizontal_State]

Horizontal_State - DfBaselineControl

Specifies whether the line is horizontal or vertical

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Horizontal_state specifies whether the line is horizontal or vertical. The size of a line must be set according to the setting of this property. When the line is horizontal, the width setting of the size determines the line's length-the height needs to be enough to make the line visible (e.g. Set Size to 2 100). When the line is vertical, the height size setting determines the length-the width needs to be enough to make the line visible (e.g., Set Size to 100 2).

Default is true.

Last Edited: August 18, 2003


DfBaselineControl [Property Line_Offset]

Line_Offset - DfBaselineControl

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


DfBaselineControl [Property Line_Style]

Line_Style - DfBaselineControl

Supports the line styles LnDip, LnBump, and LnSingle

Type: Property

Access: Read/Write

Data Type: Integer

Description

The following line-display styles are supported in Line_style:

Constant | Meaning
LnDip | creates a standard 3 D line with a dark-gray line displayed above a light-gray line.
LnBump | creates a 3 D line with a light-gray line displayed above a dark-gray line.
LnSingle | creates a single (non-3 D) black line.

Default is LnDip.

Last Edited: August 18, 2003


DfBaselineControl [Property Line_Thickness]

Line_Thickness - DfBaselineControl

Determines the pixel thickness of the line

Type: Property

Access: Read/Write

Data Type: Integer

Description

Line_thickness determines the pixel thickness of the line. This is used primarily with single lines (LnSingle) to create thicker dark lines. The Size of a line must be adjusted if the thickness is adjusted. If used with 3 D lines (which actually consist of two lines), the thickness of both lines is adjusted.

Default is 1.

Last Edited: August 18, 2003


DfBaselineControl [Property Top_Line_Color]

Top_Line_Color - DfBaselineControl

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


DfBaseList [Event Item_Change]

Item_Change - DfBaseList

A programming "hook" to perform an action on change of an item

Type: Event

Return Data Type: Integer

Parameters: Integer iFromItem Integer iToItem

Parameter | Description
iFromItem | Item to change from
iToItem | Item to change to

Return Value

Returns the whatever the item has changed to

Description

The Item_Change event is triggered each time the current item has changed. By default, the message will cause auto_select-mode objects to track the selected item along with the Current_Item. The message is provided as a programming "hook" to perform an action on change of an item.

Procedure Item_Change integer iFromItem integer iToItem returns integer
    integer iRetVal

    if (Validate(Self,iFromItem) <> 0) begin
        send Bell
        procedure_return iFromItem
    end
    forward get msg_Item_Change iFromItem iToItem to iRetVal
    Procedure_Return iRetVal
End_Procedure  // Item_Change

Last Edited: February 16, 2005


DfBaseList [Event Key]

Key - DfBaseList

Augmented to implement the GUI keyboard interface

Type: Event

Return Data Type: Integer

Parameters: Integer iKeyValue

Parameter | Description
iKeyValue | The key value

Return Value

Returns a Key value

Description

The Key message is augmented to implement the GUI keyboard interface.

You can augment this message to intercept keystrokes by the user and act on them.
You can also overwrite or intercept this message to disallow keyboard input or to ignore certain keyboard input.

Sample

This sample overwrites this message to disallow all keyboard input in the current object or class.

Procedure Key Integer iKeyVal
End_Procedure  // Key

Sample

This sample augments this message to disallow all keyboard of digits 0-9 in the current object or class.

Procedure Key Integer iKeyVal
    // 48 = '0', 57 = '9'
    if ((iKeyVal<48) and (iKeyVal>57)) ;
        forward send Key IKeyVal
End_Procedure  // Key

See Also

KeyAction

Last Edited: August 16, 2004


Events for DfBaseList

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item |
Key | Augmented to implement the GUI keyboard interface |
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseList

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list |
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object |
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed |
Delete_Item | Procedure | Deletes the specified item from the list if it exists |
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list |
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change |
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one |
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one |
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction |
Select_Count | Procedure Set | Maintains the total number of selected items in the menu |
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


DfBaseList [Procedure Set New_Item]

New_Item - DfBaseList

Sets the current_item without triggering the code that may be associated with item_change

Type: Procedure Set

Data Type: Integer

Parameters: Integer iItem

Parameter | Description
iItem | The item to be set

Description

The New_item message is the same as set current_item, except that item_change is not sent. This message is used when you want to set the current_item without triggering the code that may be associated with item_change.

set new_item to (current_item(self)  1)

Last Edited: September 10, 2003


DfBaseList [Procedure Set Select_Count]

Select_Count - DfBaseList

Maintains the total number of selected items in the menu

Type: Procedure Set

Data Type: Integer

Parameters: Integer iCount

Parameter | Description
iCount | Menu number

Description

The select_count property maintains the total number of selected items in the menu. As items are selected or deselected, the select_count property is updated. If the select_count property is set, it will affect all the items in the object. If the count parameter is true, all items (except shadowed / disabled items) will be selected. If the count parameter is false, then all items will be deselected. The select_count property is typically used with multi_select menus and lists. The user may select zero, one, or many items from the menu, and then submit the list. Use the select_count property to determine if users have selected any items, and if so how many.

Sample

The sample code below can be used in a button.

Object oChangeSelectAllButton is a Button
    Set Location To 100 100
    Set Label To "Select All"

    Procedure OnClick
        Get Select_Count of oList1 To iSelectedItems
        If (iSelectedItems > 0) Begin
            Set Select_Count of oList1 To 0
            Set Label To "Select All"
        End
        Else Begin
            Set Select_Count of oList1 To 1
            Set Label To "Deselect All"
        End
    End_Procedure // OnClick
End_Object // oChangeSelectAllButton

Last Edited: September 22, 2005


DfBaseList [Procedure Add_Item]

Add_Item - DfBaseList

Adds an item to the end of a list

Type: Procedure

Parameters: Integer iMessage String sValue

Parameter | Description
iMessage | The message ID
sValue | The value to add

Description

Items are added to the end of the object. The properties of the item are set according to the subclass of the object. If there are no items in the list, then the top_item property is set to the new item number. If the object is active, and the added item appears in the screen window, the display is automatically updated.

send add_item of oMyList msg_DoIt "Go!"

integer iCounter
for iCounter from 1 to 100
    send add_item of oMyList msg_None iCounter
loop

Last Edited: December 9, 2004


DfBaseList [Procedure Add_Row]

Add_Row - DfBaseList

Appends all of the items from the hoPrototype to the current object

Type: Procedure

Parameters: Handle hoPrototype

Parameter | Description
hoPrototype | Prototype object ID

Description

The add_row message is used to append all of the items from the hoPrototype to the current object. This message is typically used with dbGrid-class objects to add new prototype rows to the grid display.

send add_row to (alist(self)) proto_object

Last Edited: October 14, 2004


DfBaseList [Procedure Delete_Data]

Delete_Data - DfBaseList

Painted to update the screen after all items in the list are destroyed

Type: Procedure

Parameters: No Parameters

Description

All items in the list are destroyed, and the memory taken up by their data is returned back to the system. The object is then painted to update the screen.

send delete_data of (my_list(self))

Last Edited: February 17, 2004


DfBaseList [Procedure Delete_Item]

Delete_Item - DfBaseList

Deletes the specified item from the list if it exists

Type: Procedure

Parameters: Integer iItem

Parameter | Description
iItem | The item to be deleted

Description

Delete_Item is used to delete the specified item from the list if it exists. The screen is automatically updated to reflect the change.

send delete_item 3

get item_count to i
repeat
    decrement i
    if (value(self, i)) eq "delete_me" send delete_item i
until i le 0

In this example, all items in the current object whose value is delete_me are deleted, leaving all other items in the list unchanged except for their position in the list.

Last Edited: July 31, 2003


DfBaseList [Procedure Down]

Down - DfBaseList

Sends the key kdownarrow message to the object

Type: Procedure

Parameters: No Parameters

Description

The Down message sends the key kdownarrow message to the object. This will reset the current item to the new item.

send down to (amenu(self))

Last Edited: August 5, 2003


DfBaseList [Procedure Insert_Item]

Insert_Item - DfBaseList

Inserts an item in a list

Type: Procedure

Parameters: Integer iMessage String sValue Integer iItem

Parameter | Description
iMessage | The message ID
sValue | The value to be inserted
iItem | The item number to be inserted in front of

Description

The Insert_Item procedure inserts an item in a list. Items are inserted before the iItem specified. The properties of the item are set according to the subclass of the object. If there are no items in the list then the top_item property is set to the new item. If this object is active, and the added item appears in the screen window, the display is automatically updated.

send insert_item msg_do_something "GO" 3

Note: Because of the structure of items, it is sometimes faster to build a list of items by inserting each item at the beginning of the list. Do not forget that if the object is active, you probably should set the dynamic_update_state of the object to false, insert all of the items, and then set it back to true.

Last Edited: August 18, 2003


DfBaseList [Procedure Insert_Row]

Insert_Row - DfBaseList

Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number

Type: Procedure

Parameters: Handle hoProtoype Integer iRowToInsert

Parameter | Description
hoProtoype | The prototype object ID
iRowToInsert | The row number to be inserted in front of

Description

The Insert_row message is used by dbGrid-class objects to insert prototype rows in the grid at the specified row number. The hoProtoype is the prototype object that will be inserted.

send insert_row to (alist(self)) proto_object 4

Last Edited: August 18, 2003


DfBaseList [Procedure Page_Down]

Page_Down - DfBaseList

Scrolls the data down by the number of items in the display minus one

Type: Procedure

Parameters: No Parameters

Description

The Page_Down procedure allow the object to scroll the data down by the number of items in the display minus one. If there are not enough items, the object will place the last item on the screen on top. The current_item property will be reset based on the place in the list where the new item is calculated to reside.

send page_down to (alist(self))

Last Edited: September 10, 2003


DfBaseList [Procedure Page_Up]

Page_Up - DfBaseList

Scrolls the data up by the number of items in the display minus one

Type: Procedure

Parameters: No Parameters

Description

The Page_Up procedure allows the object to scroll the data up by the number of items in the display minus one. If there are not enough items, the object will place the first item of the list on top. The current_item property will be reset based on the place in the list where the new item is calculated to reside.

send page_up to (alist(self))

Last Edited: September 10, 2003


DfBaseList [Procedure Scroll]

Scroll - DfBaseList

Causes the contents of the object display window to scroll in given direction

Type: Procedure

Parameters: Integer eDirection Integer iNumLines

Parameter | Description
eDirection

Constant | Meaning
downward_direction | scrolls down
upward_directon | scrolls up

iNumLines | The number of lines to scroll

Description

Scroll causes the contents of the object display window to scroll upward (relative to the screen and cursor) when the upward_direction keyword is used or upward is true or downward when it is false or the downward_direction keyword is used, by the number of lines specified in lines.

send scroll downward_direction 1

send scroll upward_direction (current_item(self)  10)

Last Edited: September 11, 2003


DfBaseList [Procedure Sort_Items]

Sort_Items - DfBaseList

Sorts the items in a list in ascending or descending order

Type: Procedure

Parameters: Integer eDirection

Parameter Description
eDirection

Constant | Meaning
Ascending | list is sorted in ascending order
Descending | list is sorted in descending order

Description

The items displayed in the list are sorted. After the sort, the current_item property is set to the top_item. Then the object is painted. If the keyword descending is used or the boolean descending is true, the sort is done descending (in reverse). If it is false or the ascending keyword is used, the sort is done ascending. Sorting is case sensitive (uppercase letters come before lowercase, rather than intermixed).

Procedure SortList
    send Sort_Items of oList ascending
End_Procedure  // SortList

Last Edited: June 20, 2005


DfBaseList [Procedure Up]

Up - DfBaseList

Sends the key kuparrow to the object

Type: Procedure

Parameters: No Parameters

Description

The Up message sends the key kuparrow to the object. The object will set current_item to the proper item above the current one.

send up to (amenu(self))

Last Edited: September 11, 2003


Properties for DfBaseList

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus |
Aux_Value | Is only used by the system if an object is referenced on the on_item command line |
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form |
Changed_State | Set when users change information in the items of the menu |
Checkbox_Item_State | Allows any item to become a checkbox-type item |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to |
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu |
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields |
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  |
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem |
Form_Border | Sets the border style of a form region |
Form_Column | Controls the horizontal placement (column position) of the form display within the object |
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics |
Form_Extended_Style | Sets the extended-window style of form region |
Form_Fontheight | Sets the height of the font in the form display |
Form_FontItalics | Determines if the current form's font will be italicized |
Form_FontUnderline | Determines if the form's font will be underlined |
Form_FontWeight | Sets the Striking weight of form's font |
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels |
Form_Guiheight | Sets the height of the font in the form display in pixels |
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object |
Form_Guiwidth | Sets the width of the form item in pixels |
Form_Height | Sets the height of the font in the form display in logical units |
Form_Option |  |
Form_Options | Sets or gets all of the form_options for a form region |
Form_Row | Controls the vertical placement, in logical units, of the form display within the object |
Form_Style | Sets the window style for the form region |
Form_Typeface | Sets the form's Typeface |
Form_Width | Sets the width of the form item in logical units (usually dialog units) |
Form_Window_Handle | Returns the Windows window handle for the form region |
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true |
Item_Count | A read-only property of menu-class objects |
Item_Matching | Searches a menu of items for a matching string value |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu |
Line_Width | Specifies the number of columns and displayable rows in a list |
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice |
Select_Count | Maintains the total number of selected items in the menu |
Select_Mode | Determines how item-level selections are processed |
Select_State | Each item may be selected by setting the select_state of the item |
Shadow_State | Determines if item is enabled (not shadowed) |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window |
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation |


DfBaseList [Property Auto_Top_Item_State]

Auto_Top_Item_State - DfBaseList

Determines if the current_item is set to the top_item when the object takes the focus

Type: Property

Access: Read/Write

Data Type: Boolean

Description

By default, when a menu class object takes the focus, it will set the current_item to the top_item of the menu. This action is controlled by the state of the auto_top_item_state property. If the state is set to false, the current_item will not be reset by the system.

set auto_top_item_state to false

Default is true.

When in the EntryList class, default is false.

Last Edited: July 30, 2003


DfBaseList [Property Aux_Value]

Aux_Value - DfBaseList

Is only used by the system if an object is referenced on the on_item command line

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iValue

Parameter | Description
iItem | The item number
iValue | Integer value

Description

Each item has a property which is often used by the system to contain the object_id of the object to send the item's message to. The Aux_Value property is only used by the system if an object is referenced on the on_item command line. If no object is referenced, the message will be directed to the current object regardless of the value of this property.

If this property is not so used to hold an object reference in an on_item command, you may use it to store any integer value you might wish to have associated with the item.

set aux_value to (special_value(self))

on_item "test" send do_test to desktop
:
set aux_value to (anotherobject(self))

Last Edited: July 30, 2003


DfBaseList [Property Button_Aspect]

Button_Aspect - DfBaseList

A low-level form message that controls the appearance of a form

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer eAspect

Parameter | Description
iItem | The item number
eAspect | The button aspect mode

Description

Button_aspect is a low-level form message that controls the appearance of a form. It allows an object's appearance to change (form, button, radio, checkbox, etc.). This is for low-level implemenation. Changing an object's button_aspect does not ensure that its new appearance will match its expected behavior. You will probably never use this.

Valid eAspects are:

BASPECT_NONE

BASPECT_PUSHBUTTON

BASPECT_CHECKBOX

BASPECT_RADIO

BASPECT_TRISTATE

BASPECT_PULLDOWN

BASPECT_COMBOBUTTON

BASPECT_FORM

BASPECT_COMBOFORM

BASPECT_ACTIONBAR

BASPECT_MULTI

BASPECT_PUSHBUTTONLIST

BASPECT_CHECKLIST

BASPECT_RADIOLIST

BASPECT_TRISTATELIST

Last Edited: July 30, 2003


DfBaseList [Property Changed_State]

Changed_State - DfBaseList

Set when users change information in the items of the menu

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The changed_state of an object is set when users change information in the items of the menu. Users may change an item by performing data entry with the entry message, or changing its select_state with the kspace key. If the changed_state of the object is set true, then the item_changed_state of all the items of the object will be set true. This does not hold for setting the object's changed_state false.

set changed_state to false

get changed_state of (amenu(self)) to var

if changed_state send save_data

The object will not save when this state is false. When necessary (as when changes are made other than through the keyboard), set this state to true explicitly.

Default is false.

Last Edited: July 30, 2003


DfBaseList [Property Checkbox_Item_State]

Checkbox_Item_State - DfBaseList

Allows any item to become a checkbox-type item

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Boolean bCheckBox

Parameter | Description
iItem | The item number
bCheckBox | True if item is a checkbox, false if not

Description

Any item may become a checkbox-type item when its checkbox_item_state is set to true. The object's select_mode should be set to one of the modes other than no_select to allow users to select the choice that is desired.

The Select_State message should be used to let the checkbox show as marked/selected or not.

Default is false.

Sample code to create a grid with two columns and set the first column as a checkbox column:

Object oSelectGrid is a Grid
    Set CurrentCellColor to clYellow
    Set CurrentRowColor to clLime

    Set Size to 102 285
    Set Location to 5 5

    Set Resize_Column_state to FALSE
    Set Highlight_Row_state to TRUE

    Set Line_Width to 2 0
    Set Form_Width    item 0 to 15
    Set Header_Label  item 0 to ""
    Set Form_Width    item 1 to 262
    Set Header_Label  item 1 to "Bitmaps"

    Set Select_Mode To Multi_Select

    Procedure Activating
        Forward Send Activating
        Send DoLoadDirectory
    End_Procedure // DoLoadDirectory

    Procedure Select_Toggling Integer iItem Integer iState
        integer iColumns

        get Line_Size to iColumns
        if (iItem = Current) Begin
            Get Current_Item To iItem
        End
        If (Mod (iItem, iColumns) = 0) Begin
            Forward Send Select_Toggling iItem iState
        End
        Else Begin
            Forward Send Select_Toggling (Integer (iItem / iColumns) * iColumns) iState
        End
    End_Procedure // Select_Toggling

    Procedure DoLoadDirectory
        string sDirEntry
        integer iChannel

        move (Seq_New_Channel()) To iChannel
        if (iChannel >= 0) Begin
            Direct_Input Channel iChannel "DIR:C:\Program Files\Visual DataFlex 11.0\Bitmaps\*.bmp"
            while (not(SeqEOF))
               Readln Channel iChannel sDirEntry
               If ( (Not(SeqEOF)) And (Left (sDirEntry, 1) <> "[")) Begin
                  Send Add_Item Msg_None ""
                  Set Checkbox_Item_State (Item_Count (Self) - 1) To True
                  Send Add_Item Msg_None sDirEntry
                  Set Entry_State (Item_Count (Self) - 1) To False
               End
            loop
            Close_Input Channel iChannel
            Send Seq_Release_Channel iChannel
        end

        Set Dynamic_Update_State To True
    End_Procedure // DoLoadDirectory

End_Object    // oSelectGrid

Last Edited: August 10, 2006


DfBaseList [Property Current_Item]

Current_Item - DfBaseList

The object that the end user is currently pointing to

Type: Property

Access: Read/Write

Data Type: Integer

Description

The current_item of an object is the object that the end user is currently pointing to. Each menu has a current item at all times. The constant current is a shorthand way of identifying the current item. When users move from one item to the next, the interface will send the set current_item message to the focus. If the object needs to scroll, the screen will be updated immediately. The message item_change is also triggered by this event.

set Current_Item to 5

if (Current_Item = 7) ;
    set Current_Item to 0

Last Edited: June 20, 2005


DfBaseList [Property Display_Size]

Display_Size - DfBaseList

Returns the number of windows in the menu

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Display_size property returns the number of windows in the menu. This message is often used when the programmer needs to exercise a greater level of control over the interface. The display_size is often used to determine information such as the number of rows in a table-like object.

if (display_size(amenu)) eq 1 set special_case to true

Last Edited: July 31, 2003


DfBaseList [Property Entry_State]

Entry_State - DfBaseList

Determines if the items of menu class objects may become data-entry fields

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Boolean bAllowed

Parameter | Description
iItem | The item number
bAllowed | True if data can be entered into the item, false if not

Description

The items of menu class objects may become data-entry fields if their entry_state is set to true. When the selection cursor rests on a non-shadowed entry item, the system will gather input. If the item is shadowed, data entry is not allowed into the item.

Procedure DoAddReadOnlyItem String sText
    Send Add_Item Msg_None sText
    Set Entry_State Item (Item_Count (Self) - 1) To False
End_Procedure // DoAddReadOnlyItem

Default is false.

Last Edited: August 18, 2003


DfBaseList [Property FontSize]

FontSize - DfBaseList

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iHeight Integer iWidth

Parameter | Description
iHeight | Font height
iWidth | Font width

Description

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

The property is set as follows:

Set FontSize to iHeight iWidth

The property is retreived and unpacked as follows:

Get FontSize to cxyValue
Move (hi(cxyValue)) to iHeight
Move (Low(cxyValue)) to iWidth

Last Edited: June 23, 2005


DfBaseList [Property Form_Bitmap]

Form_Bitmap - DfBaseList

Places a bitmap named sBitmapName into iItem

Type: Property

Access: Write-Only

Data Type: String

Parameters: Integer iItem String sBitmapName

Parameter | Description
iItem | The item number. If omitted, 0 is used.
sBitmapName | Name of the bitmap.

Description

Form_bitmap places a bitmap named sBitmapName into iItem.

Last Edited: August 18, 2003


DfBaseList [Property Form_Border]

Form_Border - DfBaseList

Sets the border style of a form region

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer eBorderStyle

Parameter | Description
iItem | The item number. If omitted, 0 is used.
eBorderStyle

Constant | Meaning
border_dialog | a raised border used for containers
border_none | no border
border_normal | a single line border
border_thick | a raised resizable border for dialogs
border_ClientEdge | a 3-D sunken border
border_WindowEdge | undefined
border_StaticEdge | a sunken border for containers

Description

The Form_border property will set the border style of a form region. Border styles may be applied to form regions as well as objects. If you change this you will probably want to set the object's border_style to border_none. When changing the border in Form or dbForm class you will need to set this property. The dbForm class (and its descendants) uses this property and not its border_style property to create a border (it aligns better that way).

Note: Before using the this property in a control object, you should verify the property's validity within that specific object.

Default is border none.

Last Edited: August 18, 2003


DfBaseList [Property Form_Column]

Form_Column - DfBaseList

Controls the horizontal placement (column position) of the form display within the object

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iPosition

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iPosition | The column position in dialog units

Description

The Form_column property controls the horizontal placement (column position) of the form display within the object. This uses logical units (most likely dialog units). This is most often used to set up column positions. Most of the higher level row based classes do not require you to set this; it will be calculated automatically by using the form_width column values.

Set Form_Column item 0 to 0
Set Form_Column item 1 to 30
Set Form_Column item 2 to 50

Last Edited: August 18, 2003


DfBaseList [Property Form_Datatype]

Form_Datatype - DfBaseList

Defines a Form or Grid cell's datatype and masking characteristics

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iDataType

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iDataType

Constant | Meaning
mask_window | masked string datatype
mask_numeric_window | masked numeric datatype
mask_date_window | masked date datatype
mask_currency_window | masked currency datatype
ascii_window | unmasked string datatype
date_window | unmasked date datatype
number | unmasked number datatype with number digits to the right of the decimal point

Description

The Form_datatype property determines an item's datatype and mask type. The mask type selected will determine what type of form_mask value can be used for this item.

Note:Masking is not supported in Combo-forms

See Also

form_mask | Currency_Mask | Numeric_Mask | Value

Last Edited: November 2, 2003


DfBaseList [Property Form_Extended_Style]

Form_Extended_Style - DfBaseList

Sets the extended-window style of form region

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iStyle

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iStyle | Extended windows style mask.

Description

Form_extended_style sets the extended-window style of form region. This directly sets attributes of the Windows object. StyleMask is the extended-window style or styles. OnOff determines if the style is being added or removed. The style masks available are determined and defined by the Windows API. Knowledge of the Windows API is required to use this message. This is a very low-level interface message. You are bypassing the DataFlex object interface and communicating directly with the Windows object.

Last Edited: August 18, 2003


DfBaseList [Property Form_Fontheight]

Form_Fontheight - DfBaseList

Sets the height of the font in the form display

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iHeight

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iHeight | The height of the font in the form display

Description

The Form_FontHeight property sets the height of the font in the form display. This is normally not set.

Last Edited: August 18, 2003


DfBaseList [Property Form_FontItalics]

Form_FontItalics - DfBaseList

Determines if the current form's font will be italicized

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Boolean bItalicsOn

Parameter | Description
iItem | The item number. If omitted, 0 is used.
bItalicsOn | If true use italics, if false do not.

Description

If set to true, the Form_FontItalics property will italicize the current form's font.

Set form_FontItalics item 2 to True

Default is false.

Last Edited: August 18, 2003


DfBaseList [Property Form_FontUnderline]

Form_FontUnderline - DfBaseList

Determines if the form's font will be underlined

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Boolean bUnderlineOn

Parameter | Description
iItem | The item number. If omitted, 0 is used.
bUnderlineOn | If true use underline, if false do not.

Description

If set to true, the Form_FontUnderline property will underline the form's font.

Set form_FontUnderline item 2 to True

Default is fasle.

Last Edited: August 18, 2003


DfBaseList [Property Form_FontWeight]

Form_FontWeight - DfBaseList

Sets the Striking weight of form's font

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iWeight

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iWeight | the striking wight of the form's font

Description

Form_FontWeight sets the Striking weight of form's font (0-65536).

Last Edited: August 18, 2003


DfBaseList [Property Form_GuiColumn]

Form_GuiColumn - DfBaseList

Controls the horizontal placement (column position) of the form display within the object in pixels

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iPixels

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iPixels | The horizontal placement in pixel units

Description

The Form_guiColumn property controls the horizontal placement (column position) of the form display within the object in pixels. Normally you will use form_column and not this message.

Last Edited: August 18, 2003


DfBaseList [Property Form_Guiheight]

Form_Guiheight - DfBaseList

Sets the height of the font in the form display in pixels

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iPixels

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iPixels | The height in pixel units.

Description

The Form_guiHeight property sets the height of the font in the form display in pixels. This is usually set automatically.

Last Edited: August 18, 2003


DfBaseList [Property Form_Guirow]

Form_Guirow - DfBaseList

Controls the vertical placement, in pixel units, of the form display within the object

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iPixels

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iPixels | The vertical placement in pixel units.

Description

The Form_guiRow property controls the vertical placement, in pixel units, of the form display within the object. This is rarely used.

Last Edited: August 18, 2003


DfBaseList [Property Form_Guiwidth]

Form_Guiwidth - DfBaseList

Sets the width of the form item in pixels

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iPixels

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iPixels | The width in pixel units.

Description

The Form_guiWidth property sets the width of the form item in pixels. This is usually set with the form_width message.

Last Edited: August 18, 2003


DfBaseList [Property Form_Height]

Form_Height - DfBaseList

Sets the height of the font in the form display in logical units

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iHeight

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iHeight | The height of the font in logical units.

Description

The Form_height property sets the height of the font in the form display in logical units (most likely dialog units). This is usually set automatically.

Last Edited: August 18, 2003


DfBaseList [Property Form_Option]

Form_Option - DfBaseList

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Integer eOption Boolean bOn

Parameter | Description
iItem | [ToDo: In Progress]
eOption | [ToDo: In Progress]
bOn | [ToDo: In Progress]

Description

Last Edited: July 9, 2003


DfBaseList [Property Form_Options]

Form_Options - DfBaseList

Sets or gets all of the form_options for a form region

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iOptionMask

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iOptionMask | Form bit options

Description

Form_options sets or gets all of the form_options for a form region. These options are the same as item_options and must be set to apply the proper options to a form or column. Generally, anytime item_options are changed, you will also want to change form_options.

Get File_Field_Options of iDSO iFile iField to iDSO_Opt
Get Item_Options item iItem  to iDEO_Opt
Set Item_Options item iItem to (iDEO_Opt IOR iDSO_Opt)
Set Form_Options item iItem to (iDEO_Opt IOR iDSO_Opt)

Last Edited: August 18, 2003


DfBaseList [Property Form_Row]

Form_Row - DfBaseList

Controls the vertical placement, in logical units, of the form display within the object

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iRowPosition

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iRowPosition | The vertical placement of the form display in logical units.

Description

The Form_row property controls the vertical placement, in logical units, of the form display within the object. This is rarely used.

Last Edited: August 18, 2003


DfBaseList [Property Form_Style]

Form_Style - DfBaseList

Sets the window style for the form region

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iStyle

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iStyle | Window style mask

Description

Form_style sets the window style for the form region. This directly sets attributes of the Windows object. StyleMask is the window style or styles. Add specifies whether stylemask is being added or removed. The stylemasks available are determined and defined and by the Windows API. Knowledge of the Windows API is required to use this message. This is a very low-level interface message. You are bypassing the DataFlex object interface and communicating directly with the Windows object.

Last Edited: August 18, 2003


DfBaseList [Property Form_Typeface]

Form_Typeface - DfBaseList

Sets the form's Typeface

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iItem String sTypeFace

Parameter | Description
iItem | The item number. If omitted, 0 is used.
sTypeFace | Typeface name

Description

The Form_TypeFace property sets the form's typeface.

Last Edited: August 18, 2003


DfBaseList [Property Form_Width]

Form_Width - DfBaseList

Sets the width of the form item in logical units (usually dialog units)

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iWidth

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iWidth | The width of the form item in logical units.

Description

The Form_width property sets the width of the form item in logical units (usually dialog units). This is usually used to determine the with of columns in a table and is applied to each column in the object. In the higher level row based classes this property will automatically determine the column position of each form.

Set Form_width item 0 to 30
Set Form_width item 1 to 20
Set Form_width item 2 to 100

Last Edited: August 18, 2003


DfBaseList [Property Form_Window_Handle]

Form_Window_Handle - DfBaseList

Returns the Windows window handle for the form region

Type: Property

Access: Read-Only

Data Type: Handle

Parameters: Integer iItem Handle hValue

Parameter | Description
iItem | The item number. If omitted, 0 is used.
hValue | The window handle.

Description

The Form_window_handle property returns the Windows window handle for the form region.When a DataFlex object is paged (as part of activation) it creates the required windows object. The window object is identified by its window_handle and its form_window_handle. When the DataFlex object is deactivated, the window objects (object handle and window handle) are destroyed and the handles are reset to 0.

Last Edited: August 18, 2003


DfBaseList [Property Item_Changed_State]

Item_Changed_State - DfBaseList

Data entry to, or selection of, an item causes its item_changed_state property to become true

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Integer bChanged

Parameter | Description
iItem | The item number
bChanged | True if item changed, false if not

Description

Data entry to, or selection of, an item causes its item_changed_state property to become true. The program should not control any actions by use of this property. The value of this property may be inverted (regardless of its initial value) by setting it to toggle_state.

Last Edited: December 20, 2005


DfBaseList [Property Item_Count]

Item_Count - DfBaseList

A read-only property of menu-class objects

Type: Property

Access: Read-Only

Data Type: Integer

Description

The item_count property is a read-only property of menu-class objects. The property returns the total number of items owned by the object.

if (item_count(self)) gt 0 send fill_values

Move (item_count(self)-1) to count
for i from 0 to count
    :
loop

Last Edited: August 18, 2003


DfBaseList [Property Item_Matching]

Item_Matching - DfBaseList

Searches a menu of items for a matching string value

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: String sMatch Integer iItem Integer iValue

Parameter | Description
sMatch | The match string
iItem | Search start and returned matching item
iValue | 0 if found, 1 if not found

Description

The item_matching message searches a menu of items for a matching string value. By default, the search is not case sensitive. You may make the search case_sensitive by setting Search_Case to True.

The search begins at iItem and returns the item number of the first matching item. If the item was not found, then the message returns 1. The search string may include the ? and * wildcard characters. Literal asterisks (*) and question marks (?) may be found by preceding the characters with a tilde (~). You may add 1 to the returned iItem value to continue the search for the next occurrence. This message may not be used as a function in an expression since the return value is placed in the iItem parameter. This message is sent by the key message each time the object needs to perform an incremental search.

Procedure Test
    integer iItem

    get item_matching "FIND_ME" to iItem
    if (iItem =  -1) ;
        send Bell
    else ;
        set Current_Item to iItem
End_Procedure  // Test

Because the number of the item that matches is returned to the iItem parameter that is passed, iItem must be a variable (may not be a literal number). For example, to augment this message, the following technique should be used:

function item_matching string match_string integer item_number
    integer match_item
    move item_number to match_item
    get item_matching match_string to match_item
    :
    function_return match_item
end_function

Augmenting item_matching will not work for menu-based classes that handle databases (data-entry objects, or DEOs). In order to invoke case insensitivity in DEO lists (selection_list, table) you may either add a capslock format option to the entry_item command for the search field(s) or use a case-insensitive index.

Last Edited: June 21, 2006


DfBaseList [Property Line_Size]

Line_Size - DfBaseList

Returns number of columns of a grid or number windows per line of a menu

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Line_size property returns the number of columns of a grid object or the number of windows per line of a menu object.

In menus, this width is used along with the display_size to determine the number of rows of a rectangular area of windows.

Sample

This sample shows how to obtain the number of columns in a Grid.

Procedure DoSomething
    integer iColumns

    get Line_Size to iColumns

    :
End_Procedure  // DoSomething

Sample

Sample for a menu object.

get line_size of (abox(self)) to width

Last Edited: December 8, 2004


DfBaseList [Property Line_Width]

Line_Width - DfBaseList

Specifies the number of columns and displayable rows in a list

Type: Property

Access: Write-Only

Data Type: Integer

Parameters: Integer iColumns Integer iRows

Parameter | Description
iColumns | The number of columns
iRows | The number of rows

Description

Line_width specifies the number of columns and displayable rows in a list. The first value represents the number of columns and by default creates a single-column list. The second value should almost always be set to 0. This instructs the list to calculate the number of displayable rows based on the size of the object.

Last Edited: October 6, 2004


DfBaseList [Property Message]

Message - DfBaseList

Identifies the message that is sent when users press kenter on the item

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iItem Integer iMessage

Parameter | Description
iItem | The item number
iMessage | The message ID

Description

The Message property identifies the message that is sent when users press kenter on the item. Each item has a message property. The message will be sent to the current object. If that object does not understand the message, the system will use the normal delegation rules to delegate the message to another object.

set message item 3 to msg_none

Normally the message property of an item is set by the on_item command or the add_item and insert_item messages. The message property is usually used to get the ID of the message and send it as a parameter to another message.

send process (message(self,current))

Last Edited: August 18, 2003


DfBaseList [Property Prototype_Object]

Prototype_Object - DfBaseList

Type: Property

Access: Read-Only

Data Type: Handle

Description

Last Edited: February 13, 2003


DfBaseList [Property Search_Mode]

Search_Mode - DfBaseList

Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice

Type: Property

Access: Read/Write

Data Type: Integer

Description

The search_mode property determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice. By default, menu class objects are set to capital search. This type of search moves the cursor to the first choice beyond the cursor position in which the input letter is present in uppercase. Examples include the F in File and the X in eXit. Only the first capital letter in the choice content is respected. The search is insensitive to the case of the letter input. Capital letter search is not supported for virtual lists except within the current display page.

First_character search moves the cursor to the next choice beyond the cursor whose content begins with the input character. The search is case-insensitive in all respects. Starting from the top of a list made up of File, forMat, and eXit, repeated pressing of F or f would place the cursor first on File, then on forMat, and never on eXit. In a list of choices made up exclusively of capital letters, there is no difference between first_character and capital search modes. A first character search mechanism is available for virtual lists, with one exception: pressing the key for the same character repeatedly does not advance to the next item with the same first character for virtual lists (it does for non-virtual lists). This is a known limitation.

The incremental search mode moves the cursor to the next choice whose beginning characters match the sequence of characters input by users since the cursor entered the list. Unless the item the cursor is on already matches, each character entered moves the cursor to the next item whose beginning characters match, if any. Pressing backspace removes the last character typed and moves the cursor back to the previous choice that it was on. The incremental search mechanism permits incremental searching on parent files of the main file of the list.

No_search causes the object to ignore all alphanumeric keys and respond to standard navigation keys only.

set search_mode to no_search

if search_mode eq capital send find_key

Default is capital.

Last Edited: September 11, 2003


DfBaseList [Property Select_Count]

Select_Count - DfBaseList

Maintains the total number of selected items in the menu

Type: Property

Access: Read-Only

Data Type: Integer

Description

The select_count property maintains the total number of selected items in the menu. As items are selected or deselected the select_count property is updated.

The select_count property is typically used with multi_select menus and lists. The user may select zero, one, or multiple items and the program can process them. To select more than one item, the Select_Mode property should be set to Multi_Select. Use the select_count property to determine if users have selected any items and if so, how many.

Sample

Get Select_Count To iSelectedItems
If (iSelectedItems > 0) Begin
    Get Item_Count To iItems
    Decrement iItems
    While (iItems >= 0)
        Get Select_State Item iItems To bSelected
        If (bSelected) Begin
            // Do whatever you want to do with the selected item
        End
        Decrement iItems
    Loop
End

Last Edited: March 17, 2006


DfBaseList [Property Select_Mode]

Select_Mode - DfBaseList

Determines how item-level selections are processed

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Select_Mode of the object is used to determine how item-level selections are processed.

Constant | Meaning
No_Select | This mode will disable the user-driven selection key, kspace
Single_Select | Used when none or a single selection is allowed. As the user selects items in the menu, any item previously selected will be reset.
Auto_Select | Similar to Single_Select, but the Current_Item is always selected
Multi_Select | Allows the operator to select zero, one, or many items in the menu. The number of selected items is maintained by the select_count property.

set Select_Mode of oMultiMenu to Multi_Select

The default mode is No_Select.

Last Edited: September 22, 2005


DfBaseList [Property Select_State]

Select_State - DfBaseList

Each item may be selected by setting the select_state of the item

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Integer bSelected

Parameter | Description
iItem | The item number
bSelected | Determines if the item is selected (true) or not selected (false)

Description

Each item may be selected by setting the select_state of the item. The user sets this state by pressing the kspace key when on a menu which has its select_mode set to other than no_select. Shadowed items may not be selected. If the list is single_select, then only one item may be selected at a time. Select_Count is automatically updated by setting the select_state of an item. If the item is on the screen, the display will immediately reflect the change in state of the item.

integer iCurrent
get Current_Item to iCurrent
set Select_State of oChoices iCurrent to True

if (Select_State(Self, iCurrent)) send Process_Item

The value of this property may be inverted, regardless of its initial value, by setting it to toggle_state.

Default is false.

Last Edited: December 20, 2005


DfBaseList [Property Shadow_State]

Shadow_State - DfBaseList

Determines if item is enabled (not shadowed)

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Boolean bShadowed

Parameter | Description
iItem | The item number
bShadowed | True if disable/shadowed, false if enabled/not shadowed

Description

Shadowing an item affects both its appearance and its functionality. A shadowed item will be displayed in the shadowed color (defined by the desktop or its palette). If a user places the selection cursor on a shadowed item, the item will not respond to the kenter key or any mouse action.

set shadow_state 4 to true

if (shadow_state(Self, current)) send ignore_item

Default is false.

Last Edited: August 6, 2004


DfBaseList [Property Top_Item]

Top_Item - DfBaseList

The item that is first in the display window

Type: Property

Access: Read/Write

Data Type: Integer

Description

The top_item of a menu class object is the item that is first in the display window. That item may change through scrolling or direct navigation, i.e., incremental search. If the programmer sets the top_item, then the list will adjust itself to display the new item selected at the top of the list. If the selected item is outside the range of valid item numbers, then the operation is ignored. If the operation results in the current_item being moved off the screen, then the current_item is set to the top_item.

set top_item to (current_item(self)  5)

if top_item gt 10 send list_full

Last Edited: September 11, 2003


DfBaseList [Property Value]

Value - DfBaseList

Gets and sets the data value for an item

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iItem String sValue

Parameter | Description
iItem | The item number
sValue | Data value

Description

Each item and entry item has a value. The value is displayed when the object is painted and the item is in the visible portion of the screen. The value is stored as a string. If the item_number is out of range, the operation is ignored. The screen is updated to reflect the new value of the item.

set value to "Compile program"

set value to customer.purchases

set value of oMenu 4 to "Number 4"

if (value(Self,Current) = "TEST") send testing

The section below applies only to list-based classes

Each cell in a grid is an item. A grid can have 0 to many items. Item references start with 0. The form_datatype and form_mask properties set the type of the value (number, string, integer etc). The form_margin property determines the number of characters a user can enter in the cell. Before an item can be referenced it needs to be created.

Samples:

If a grid has 3 columns and you want to add the following information (stored in an array of structs):

"ABC", "ABC Corp", 100000
"DEF", "DEF Corp", 200000
"XYZ", "XYZ Corp", 400000

You can use:

    Procedure DoFillGrid tsCustomer[] sCustomer
        Integer iCustomers iCustomer

        Move (SizeOfArray (sCustomer)) To iCustomers
        Decrement iCustomers
          For iCustomer From 0 To iCustomers
            Send Add_Item Msg_None sCustomer[iCustomer].Code
            Send Add_Item Msg_None sCustomer[iCustomer].Name
            Send Add_Item Msg_None sCustomer[iCustomer].Budget
          Loop
    End_Procedure

The array of customer information is passed to the procedure with:

    Send DoFillGrid sCustomer

Getting the name of the second customer can be done with:

    Get Value Item 4 To sCustomerName

Or

    Get Value Item (iCustomer * 3 + 1) To sCustomerName

Last Edited: September 2, 2005


DfBaseList [Property Wrap_State]

Wrap_State - DfBaseList

Controls the action of the cursor control keys and search_mode ranges during item navigation

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The wrap_state controls the action of the cursor control keys and search_mode ranges during item navigation. If the wrap_state is set true, then when a(n arrow) key is pressed to move the cursor beyond the end or beginning of the list, the cursor will move to the item on the opposite end of the list. When a search_mode is in effect, the range of the search is extended beyond the end of the list to "wrap" back around to the beginning of the list if a qualifying item is not found.

set wrap_state of (amenu(self)) to true

Default is false.

Last Edited: September 15, 2003


Events for DfBaseListbox

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseListbox

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaseListbox

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Events for DfBasemdiclient

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBasemdiclient

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Arrange_Icons | Procedure | Arranges the icons for all minimized views contained by this object |
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
Cascade_Windows | Procedure | Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Next_View | Procedure | Switches the focus to the next view object in this object |
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Switch_Prior_View | Procedure | Switches the focus to the previous view object in this object |
Tile_Windows_Horizontal | Procedure | Arranges this object's views from left to right across the top, and then down to the next line, also so arranged |
Tile_Windows_Vertical | Procedure | Arranges this object's views from top to bottom down the left side, and then right to the next column, also so arranged |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


DfBasemdiclient [Procedure Arrange_Icons]

Arrange_Icons - DfBasemdiclient

Arranges the icons for all minimized views contained by this object

Type: Procedure

Parameters: No Parameters

Description

The Arrange_icons procedure arranges the icons for all minimized views contained by this object.

Last Edited: July 30, 2003


DfBasemdiclient [Procedure Cascade_Windows]

Cascade_Windows - DfBasemdiclient

Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it

Type: Procedure

Parameters: No Parameters

Description

The Cascade_windows procedure arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it.

Last Edited: August 5, 2003


DfBasemdiclient [Procedure Switch_Next_View]

Switch_Next_View - DfBasemdiclient

Switches the focus to the next view object in this object

Type: Procedure

Parameters: No Parameters

Description

The Switch_Next_View procedure switches the focus to the next view object in this object.

Last Edited: September 11, 2003


DfBasemdiclient [Procedure Switch_Prior_View]

Switch_Prior_View - DfBasemdiclient

Switches the focus to the previous view object in this object

Type: Procedure

Parameters: No Parameters

Description

The Switch_Prior_View procedure switches the focus to the previous view object in this object.

Last Edited: September 11, 2003


DfBasemdiclient [Procedure Tile_Windows_Horizontal]

Tile_Windows_Horizontal - DfBasemdiclient

Arranges this object's views from left to right across the top, and then down to the next line, also so arranged

Type: Procedure

Parameters: No Parameters

Description

The Tile_windows_horizontal procedure arranges this object's views from left to right across the top, and then down to the next line, also so arranged.

Last Edited: September 11, 2003


DfBasemdiclient [Procedure Tile_Windows_Vertical]

Tile_Windows_Vertical - DfBasemdiclient

Arranges this object's views from top to bottom down the left side, and then right to the next column, also so arranged

Type: Procedure

Parameters: No Parameters

Description

The Tile_windows_vertical procedure arranges this object's views from top to bottom down the left side, and then right to the next column, also so arranged.

Last Edited: September 11, 2003


Properties for DfBasemdiclient

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Scroll_Bar_Visible_State | Specifies whether this object is to display a scroll bar (or bars) when the content of the object exceeds this object's same-time display capacity |
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


DfBasemdiclient [Property Scroll_Bar_Visible_State]

Scroll_Bar_Visible_State - DfBasemdiclient

Specifies whether this object is to display a scroll bar (or bars) when the content of the object exceeds this object's same-time display capacity

Type: Property

Access: Write-Only

Data Type: Boolean

Description

The Scroll_bar_visible_state property specifies whether this object is to display a scroll bar (or bars) when the content of the object exceeds this object's same-time display capacity.

Default is true.

Last Edited: September 11, 2003


DfBaseObject [Event Form_Button_Mouse_Down]

Form_Button_Mouse_Down - DfBaseObject

A notification that the form's button has been selected with the mouse

Type: Event

Parameters: Integer iItem

Parameter | Description
iItem | The item number. If omitted, 0 is used.

Description

Form_button_mouse_down is a notification that the form's button has been selected with the mouse. This is used by spin buttons to initialize their value. This indicates the start of a form-button event.

Last Edited: August 18, 2003


DfBaseObject [Event Form_Button_Notification]

Form_Button_Notification - DfBaseObject

A notification of a form button event

Type: Event

Parameters: Integer iItem Integer iPosition

Parameter | Description
iItem | The item number. If omitted, 0 is used.
iPosition | The new value of the spin button.

Description

Form_button_notification is a notification of a form button event. Either a prompt-button has been selected or a spin button event has occurred. Pressing and not releasing the spin button will causes this event to fire multiple times. If the button is a spin button the position parameter indicates the new value of the spin button.

Last Edited: August 18, 2003


DfBaseObject [Event Notify_Application_Activation]

Notify_Application_Activation - DfBaseObject

Sends OnActivateApp or OnDeactivateApp

Type: Event

Parameters: Boolean bIsActivating

Parameter | Description
bIsActivating | Indicates whether to send OnActivateApp or OnDeactivateApp

Description

This procedure is augmented to send OnActivateApp when bIsActivating is True and OnDeactivateApp when bIsActivating is False.

Last Edited: November 23, 2004


DfBaseObject [Event onDeltaPos]

onDeltaPos - DfBaseObject

Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it

Type: Event

Return Data Type: Integer

Parameters: Integer iItem Integer iChange

Parameter | Description
iItem | The item number
iChange A complex variable defined as follows:

low (iChange) | The original value
hi (iChange) | The amount of change

Return Value

If a non-zero value is returned the change will not take place

Description

The OnDeltaPos event message has no definition by default. It can be used to provide actions based on the amount of change in this object (from the time it took the focus) and/or its value at the point the focus is moved off it. Its value at the time of taking focus is (low(iChange)). The amount of change made by users is (hi(iChange)), which may be negative. If you define this procedure to return any non-zero value, the change will not take place. If your procedure does not execute a procedure_return, the change will take place.

Last Edited: September 10, 2003


Events for DfBaseObject

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse |
Form_Button_Notification | A notification of a form button event |
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseObject

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject


Properties for DfBaseObject

View property list in hierarchical order

Name | Description | Defining Class
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control |
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Visible_State | Determines whether object is visible | cUIObject


DfBaseObject [Property Oem_Translate_State]

Oem_Translate_State - DfBaseObject

Determines of OEM / ANSI conversions should be applied to this control

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Oem_Translate_State determines if the control's value should be converted to ANSI when displayed in a window and converted back into OEM when stored in the DataFlex object.

Normally this property is True, which means that the conversion is made.

Windows controls need to display ANSI data. Internally, Visual DataFlex objects uses OEM data. Therefore, before a value is displayed it must be converted to ANSI. When a value is moved from a windows control back to the DataFlex object it must be converted to OEM. This translation occurs automatically and it is not something you normally need to deal with. If for some reason your application is directly working with ANSI data, you may need to turn of the translation within your windows controls.

Set Oem_Translate_State to False

Note:You can use the global functions ToAnsi() and ToOem() to manually convert data from OEM to ANSI and back.

Last Edited: September 2, 2005


Events for DfBasePanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBasePanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBasePanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Events for DfBasePullDown

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Initialize_Menu | Sent when the Menubar system is about to be selected | DfBaseActionBar
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBasePullDown

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Exit_Menu | Procedure |  | DfBaseActionBar
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Redirect_Message | Procedure |  | DfBaseActionBar
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBasePullDown

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Events for DfBasePushButton

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBasePushButton

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBasePushButton

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Events for DfBaseRadioButton

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseRadioButton

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaseRadioButton

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


DFBaseRichEdit [Event OnLinkClicked]

OnLinkClicked - DFBaseRichEdit

Fires when hyperlink in text is clicked

Type: Event

Parameters: integer iPositionStart integer iPositionEnd

Parameter | Description
iPositionStart | The starting position of the hyperlink
iPositionEnd | The ending position of the hyperlink

Description

Returns the starting and ending positions of the link clicked by the user.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, the first position in the second line will be 20.

Sample

This sample retrieves the text of the link that was clicked via TextRange. You can add your own handling of the link text in the begin...end code block.

Procedure OnLinkClicked integer iPositionStart integer iPositionEnd
    string sLinkText

    get TextRange iPositionStart iPositionEnd to sLinkText

    if (sLinkText <> "") begin
        // do something
    end
End_Procedure  // OnLinkClicked

Sample

This sample retrieves the text of the link that was clicked via TextRange. Afterwards, if the link text is not blank, it launches the link in the default browser using the ShellExecute Windows API call.

Procedure OnLinkClicked integer iPositionStart integer iPositionEnd
    handle hInstance hWnd
    string sLinkText

    get TextRange iPositionStart iPositionEnd to sLinkText

    if (sLinkText <> "") begin
        Get Window_Handle To hWnd
        Move (ShellExecute (hWnd, "open", (Trim (sLinkText)), '', '', 1)) To hInstance
    end
End_Procedure  // OnLinkClicked

Last Edited: December 2, 2004


DFBaseRichEdit [Event OnSelectionChanged]

OnSelectionChanged - DFBaseRichEdit

Fires when selection changes

Type: Event

Parameters: No Parameters

Description

Fires whenever the selected text changes, including when the cursor is moved. If no text is selected, the cursor position is considered the current selection.

Sample

This sample shows how to add Procedure OnSelectionChanged to a class or object in order to intercept this event in order to react to it.

Procedure OnSelectionChanged
    // do something
    :
End_Procedure  // OnSelectionChanged

Last Edited: April 6, 2005


Events for DFBaseRichEdit

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnLinkClicked | Fires when hyperlink in text is clicked |
OnSelectionChanged | Fires when selection changes |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


DFBaseRichEdit [Function CharCount]

CharCount - DFBaseRichEdit

Returns length of RTF stream in the control

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Length of the RTF stream in the control.

Description

Returns the length of the RTF stream in the control.

This function counts each line break as 2 characters (a linefeed character (ASCII 10) followed by a carriage return character (ASCII 13).

Sample

integer iStreamLength
get CharCount to iStreamLength

Sample

This sample sets the contents of the oRichEdit1 control to "Some RTF text". It then gets the content (RTF stream) to variable sRTFStream and its length to variable iCharCount. Last, it displays the RTF stream and it's length in a message box to the user.

Procedure DisplayText
    string sText sRTFStream
    integer iCharCount

    move "Some RTF text" to sText
    set Value of oRichEdit1 to sText

    get Value of oRichEdit1 to sRTFStream
    get CharCount of oRichEdit1 to iCharCount

    send Info_Box sRTFStream (string(iCharCount) + " characters in RTF stream")
End_Procedure  // DisplayText

Note:
It can take a while to retrieve the charcount. For example, if you insert an image into the control from the clipboard, the amount of characters may increase tremendously, depending on the size of the image.

Last Edited: January 7, 2005


DFBaseRichEdit [Function FindText]

FindText - DFBaseRichEdit

Searches for specified text in control

Type: Function

Return Data Type: Integer

Parameters: string sTarget integer eSearchOptions

Parameter | Description
sTarget | Text to search for
eSearchOptionsDefines search options. Can be a combination of:

Constant | Meaning
FR_WHOLEWORD | Search only for whole words that match sTarget
FR_MATCHCASE | Search operation is case-sensitive
0 (zero) | Search operation is case-insensitive

Return Value

Position of the first character in sTarget for the first occurrence of sTarget found or -1 if match is not found.

Description

Searches for specified text in the control using the specified option(s).

Search always occurs forward from the end of the current selection or cursor position. To begin searching at the beginning of the control, send Beginning_of_Data to place the cursor at the beginning of the text in the control.

Returns the position of the first character in sTarget for the first occurrence of sTarget found. If sTarget appears in the text more than once, the position of the first character in sTarget of the first occurence of Joe in the text is returned.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, the first position in the second line will be 20.

Returns -1 if match is not found for the position of the first character of the match.

This method has no effect if control is not paged.

Sample

This sample passes FR_MATCHCASE as the eSearchOptions parameter, so it performs a case-sensitive search for "Joe" in all text in the oRichEdit1 control following the current selection or cursor position. If "joe" appears in the portion of the control's text that is searched, -1 will be returned, since only case-sensitive matches of the word "Joe" will be considered successful.

Procedure DoSearch
    string sSearchText
    integer iSearchResult

    move "Joe" to sSearchText

    get FindText of oRichEdit1 sSearchText FR_MATCHCASE to iSearchResult
    // was search successful?
    if (iSearchResult <> -1) begin
        send Info_Box ("Text position: " + string(iSearchResult)) "Text Found"
    end
End_Procedure // DoSearch

Sample

This sample gets the search text from a user via Form oSearchText to variable sSearchText. It then performs a case-sensitive search for sSearchText in all text in the oRichEdit1 control following the current selection or cursor position. If sSearchText appears in the portion of the control's text that is searched, it is selected using the SetSel method. This sample assumes that a Form or dbForm control named oSearchText exists in your code. Also, since the first occurence of sSearchText is now selected, and searches always occur forward from the end of the current selection or cursor position, you can simply call DoSearch again to find the next occurence of sSearchText.

Procedure DoSearch
    string sSearchText
    integer iSelStart iSelEnd

    // get user's search text from form
    get Value of oSearchText to sSearchText

    get FindText of oRichEdit1 sSearchText FR_MATCHCASE to iSelStart
    // was search successful?
    if (iSelStart <> -1) begin
        // get length of search text
        move (length(sSearchText) + iSelStart) to iSelEnd
        // select search text found
        send SetSel of oRichEdit1 iSelStart iSelEnd
    end
End_Procedure // DoSearch

Sample

This sample passes (FR_WHOLEWORD + FR_MATCHCASE) as the eSearchOptions parameter, so it performs a case-sensitive search for the whole word "Joe" in all text in the oRichEdit1 control following the current selection or cursor position. If "Jo" appears in the portion of the control's text that is searched, -1 will be returned, since only matches of the whole word "Joe" will be considered successful.

Procedure DoSearch
    string sSearchText
    integer iSearchResult

    move "Joe" to sSearchText

    get FindText of oRichEdit1 sSearchText (FR_WHOLEWORD + FR_MATCHCASE) to iSearchResult
    // was search successful?
    if (iSearchResult <> -1) begin
        send Info_Box ("Text position: " + string(iSearchResult)) "Text Found"
    end
End_Procedure // DoSearch

Sample

This sample passes 0 (zero) as the eSearchOptions parameter, so it performs a case-insensitive search for "Joe" in all text in the oRichEdit1 control following the current selection or cursor position. If "joe" appears in the portion of the control's text that is searched, the position of its first character will be returned, since matches of any case combination of letters of the "Joe" will be considered successful.

Procedure DoSearch
    string sSearchText
    integer iSearchResult

    move "Joe" to sSearchText

    get FindText of oRichEdit1 sSearchText 0 to iSearchResult
    // was search successful?
    if (iSearchResult <> -1) begin
        send Info_Box ("Text position: " + string(iSearchResult)) "Text Found"
    end
End_Procedure // DoSearch

See Also

ReplaceAll | ReplaceSel

Last Edited: June 23, 2005


DFBaseRichEdit [Function FirstCharInLinePos]

FirstCharInLinePos - DFBaseRichEdit

Returns position of first character in a line

Type: Function

Return Data Type: Integer

Parameters: integer iLine

Parameter | Description
iLine | Number of line (zero-based)

Return Value

Zero-based position of first character in line number iLine.

Description

Returns zero-based position of first character in line number iLine from control.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, the first position in the second line will be 20.

If iLine is -1, returns the position of the first character in the current line. If text is selected, returns position of the first character in the line of the beginning of the selected text.

If iLine is greater than total number of lines in control, function returns -1.

This method has no effect if control is not paged.

Sample

This sample gets the position of the first character in the current line in control oRichEdit1 to variable iFirstCharPos and then displays it to the user in a message box.

Procedure GetFirstCharInCurrentLine
    integer iFirstCharPos iLineNum

    // indicates that we want the current line
    move -1 to iLineNum

    get FirstCharInLinePos of oRichEdit1 iLineNum to iFirstCharPos

    send Info_Box ("Position " + string(iFirstCharPos))
End_Procedure // GetFirstCharInCurrentLine

Last Edited: December 2, 2004


DFBaseRichEdit [Function FirstVisibleLine]

FirstVisibleLine - DFBaseRichEdit

Returns number of first visible line

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Zero-based number of the first visible line.

Description

Returns zero-based number of the first visible line in the control.

This function is useful if the user scrolls down in a document that is longer than the visible area of the control. For example, if the user scrolls down until the first 5 lines of the control are no longer visible, FirstVisibleLine will return 5 (rather than 6, since FirstVisibleLine is zero-based).

This method has no effect if control is not paged.

Sample

This sample gets the first visible line in the oRichEdit1 control and displays it to the user in a message box.

Procedure DetermineFirstVisibleLine
    integer iFirstVisibleLine

    get FirstVisibleLine of oRichEdit1 to iFirstVisibleLine

    send Info_Box ("The first visible line is: " + string(iFirstVisibleLine))
End_Procedure  // DetermineFirstVisibleLine

Last Edited: December 2, 2004


DFBaseRichEdit [Function LastErrorCode]

LastErrorCode - DFBaseRichEdit

Returns error code for last operation

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Error code for the last operation.

Description

Returns the error code for the last operation.

Possible return values are:

Constant | Meaning
ERR_RE_ATTR_INCONSISTENT _THROUGH_SELECTION | The attribute in question (e.g. pbBold) was inconsistently applied in the selected text
ERR_RE_SUCCESS | Success, operation successful, no error condition
ERR_RE_FNAME_TOO_LONG | File name is too long
ERR_RE_CANNOT_OPEN_FILE | Cannot open file

Sample

This sample gets the value of pbBold, then checks if pbBold was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin...end code block.

Boolean bIsBold
get pbBold to bIsBold
if (LastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Sample

This sample gets the name of a text file from a form named oFileNameForm and calls the Read method of the oRichEdit1 control to open that file. It then checks to see if the control was able to open the file by checking the LastErrorCode. If LastErrorCode returns ERR_RE_CANNOT_OPEN_FILE, it displays an error message to the user.

Procedure ReadFile
    string sFileName
    integer iLastErrorCode

    get Value of oFileNameForm to sFileName

    send Read of oRichEdit1 sFileName
    get LastErrorCode of oRichEdit1 to iLastErrorCode
    if (iLastErrorCode = ERR_RE_CANNOT_OPEN_FILE) begin
        send Stop_Box "Cannot open file" "ERROR"
    end
End_Procedure  // ReadFile

Last Edited: December 2, 2004


DFBaseRichEdit [Function Line]

Line - DFBaseRichEdit

Returns specified line of text

Type: Function

Return Data Type: String

Parameters: integer iLine

Parameter | Description
iLine | Number of line (zero-based)

Return Value

Text of specified line in control.

Description

Returns line of text with zero-based number iLine from control.

This method has no effect if control is not paged.

Sample

This sample gets the text of the current line in control oRichEdit1 and displays it to the user in a message box. The current line number is determined by calling function LineFromChar with a -1 parameter.

Procedure DisplayCurrentLine
    integer iLineNum iCurrentLineNum
    string sLine

    // indicates that we want the current line
    move -1 to iLineNum

    // get the line number of the current line
    get LineFromChar of oRichEdit1 iLineNum to iCurrentLineNum
    // get the text of the current line
    get Line of oRichEdit1 iCurrentLineNum to sLine

    send Info_Box sLine ("Line number " + string(iCurrentLineNum))
End_Procedure // DisplayCurrentLine

Last Edited: December 2, 2004


DFBaseRichEdit [Function LineFromChar]

LineFromChar - DFBaseRichEdit

Returns number of line that contains specified character position or current line

Type: Function

Return Data Type: Integer

Parameters: integer iCharPos

Parameter | Description
iCharPos | Position of character

Return Value

Zero-based number of the line that contains specified character position (iCharPos) or current line.

Description

Returns zero-based number of the line that contains specified character position (iCharPos) or current line.

If iCharPos is -1, returns the line number of the current line. If text is selected, returns the line number of the beginning of the selected text.

If iCharPos is greater than total number of lines in control, function returns -1.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, the first position in the second line will be 20.

This method has no effect if control is not paged.

Sample

This sample gets the text of the current line in control oRichEdit1 and displays it to the user in a message box. The current line text is retrieved by calling function Line with the current line number.

Procedure DisplayCurrentLine
    integer iFirstCharPos iLineNum iCurrentLineNum
    string sLine

    // indicates that we want the current line
    move -1 to iLineNum

    // get the line number of the current line
    get LineFromChar of oRichEdit1 iLineNum to iCurrentLineNum
    // get the text of the current line
    get Line of oRichEdit1 iCurrentLineNum to sLine

    send Info_Box sLine ("Line number " + string(iCurrentLineNum))
End_Procedure // DisplayCurrentLine

Last Edited: December 2, 2004


DFBaseRichEdit [Function LineLength]

LineLength - DFBaseRichEdit

Returns number of characters in line

Type: Function

Return Data Type: Integer

Parameters: Integer iLine

Parameter | Description
iLine | Number of line (zero-based)

Return Value

Number of characters in line number iLine.

Description

Returns the number of characters in line number iLine.

If iLine is -1, returns the number of characters in the current line. If text is selected, returns number of characters in the line of the beginning of the selected text.

If iLine is greater than total number of lines in control, function returns -1.

This method has no effect if control is not paged.

Sample

This sample gets the length of the current line in control oRichEdit1 and displays it to the user in a message box.

Procedure DisplayCurrentLineAndCount
    integer iLineLength

    // get the length of the current line
    get LineLength of oRichEdit1 -1 to iLineLength

    send Info_Box (string(iLineLength)) "Length of current line"
End_Procedure // DisplayCurrentLineAndCount

Sample

This sample gets the text and length of the current line in control oRichEdit1 and displays it to the user in a message box. The current line number is determined by calling function LineFromChar with a -1 parameter.

Note:
In this sample, the current line number is determined by calling function LineFromChar with a -1 parameter. LineLength is then called with the current line number. The simpler sample above achieves the same result by passing -1 to LineLength.

Procedure DisplayCurrentLineAndCount
    integer iLineNum iCurrentLineNum iLineLength
    string sLine

    // indicates that we want the current line
    move -1 to iLineNum

    // get the line number of the current line
    get LineFromChar of oRichEdit1 iLineNum to iCurrentLineNum
    // get the text of the current line
    get Line of oRichEdit1 iCurrentLineNum to sLine
    // get the length of the current line
    get LineLength of oRichEdit1 iCurrentLineNum to iLineLength

    send Info_Box sLine ("Length of current line: " + string(iLineLength))
End_Procedure // DisplayCurrentLineAndCount

Last Edited: January 12, 2006


DFBaseRichEdit [Function RedoType]

RedoType - DFBaseRichEdit

Returns type of redo operation at top of redo queue

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Type of redo operation at the top of the redo queue.

Description

Returns the type of redo operation at the top of the redo queue.

If the redo queue for the control is not empty, the value returned indicates the type of the next action in the control's redo queue.
If there are no redoable actions or the type of the next redoable action is unknown, the return value is zero (Unknown).

The types of actions that can be undone or redone include typing, delete, drag-drop, cut, and paste operations. This information can be useful for applications that provide an extended user interface for undo and redo operations, such as a drop-down list box of redoable actions

This function has no effect if control is not paged.

Possible return values are:

Constant | Meaning
utUnknown | Unknown
utTyping | Typing
utDelete | Delete
utDragDrop | Drag and Drop
utCut | Cut
utPaste | Paste

Sample

This sample determines the next redo operation type available for control oRichEdit1 and displays it to the user in a message box.

Procedure CheckRedoType
    integer iRedoType
    string sRedoType

    get RedoType of oRichEdit1 to iRedoType

    if (iRedoType = utUnknown) ;
        send Info_Box "No redo operations available"
    else begin
        if (iRedoType = utTyping) move "Typing" to sRedoType
        else if (iRedoType = utDelete) move "Delete" to sRedoType
        else if (iRedoType = utDragDrop) move "DragDrop" to sRedoType
        else if (iRedoType = utCut) move "Cut" to sRedoType
        else if (iRedoType = utPaste) move "Paste" to sRedoType

        send Info_Box sRedoType "Next Redo operation available"
    end
End_Procedure  // CheckRedoType

Last Edited: December 2, 2004


DFBaseRichEdit [Function ReplaceAll]

ReplaceAll - DFBaseRichEdit

Replaces all occurences of sTarget with sReplacement and returns the number of replacements

Type: Function

Return Data Type: Integer

Parameters: string sTarget string sReplacement

Parameter | Description
sTarget | String to be replaced with sReplacement
sReplacement | String to take the place of sTarget

Return Value

Number of replacements made. If no repalcements were made, returns 0.

Description

Replaces all occurences of sTarget with sReplacement in control and returns the number of replacements made.

This method has no effect if control is not paged.

Sample

This sample replaces all occurences of "Mike" in control oRichEdit1 with "Michael" and then displays the number of replacements made in a message box to the user.

Procedure ReplaceAll
    integer iReplacementCount

    get ReplaceAll of oRichEdit1 "Mike" "Michael" to iReplacementCount

    send Info_Box (string(iReplacementCount) + " replacements performed")
End_Procedure // ReplaceAll

See Also

FindText | ReplaceSel

Last Edited: December 2, 2004


DFBaseRichEdit [Function SelEnd]

SelEnd - DFBaseRichEdit

Returns end of selection

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Ending position of selection.

Description

Returns ending position of selection.

Returns the last character position inside the selection. If no text is selected, returns the current position of the caret.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, and the selected text is characters 5 through 10 of the second line, the return value of SelEnd will be 30.

Sample

This sample gets the beginning and ending position of the selected text of control oRichEdit1 and then displays the range to the user in a message box.

Procedure ShowSelectionRange
    integer iSelStart iSelEnd

    get SelStart of oRichEdit1 to iSelStart
    get SelEnd of oRichEdit1 to iSelEnd

    send Info_Box (string(iSelStart) + " to " + string(iSelEnd)) "Range of selected text"
End_Procedure  // ShowSelectionRange

See Also

SelStart | SelText

Last Edited: June 20, 2005


DFBaseRichEdit [Function SelStart]

SelStart - DFBaseRichEdit

Returns beginning of selection

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Beginning position of selection.

Description

Returns beginning position of selection.

Returns the first character position inside the selection. If no text is selected, returns the current position of the caret.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, and the selected text is characters 5 through 10 of the second line, the return value of SelStart will be 25.

Sample

This sample gets the beginning and ending position of the selected text of control oRichEdit1 and then displays the selection range (or length) to the user in a message box.

Procedure ShowSelectionRange
    integer iSelStart iSelEnd

    get SelStart of oRichEdit1 to iSelStart
    get SelEnd of oRichEdit1 to iSelEnd

    send Info_Box (string(iSelStart) + " to " + string(iSelEnd)) "Range of selected text"
End_Procedure  // ShowSelectionRange

See Also

SelEnd | SelText

Last Edited: June 20, 2005


DFBaseRichEdit [Function SelText]

SelText - DFBaseRichEdit

Returns selected text

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Selected text of the control.

Description

Returns the selected text of the control.

This method has no effect if control is not paged.

Sample

This sample gets the selected text of the oRichEdit1 control to variable sSelectedText and then displays it to the user in a message box.

Procedure ShowSelectedText
    string sSelectedText

    get SelText of oRichEdit1 to sSelectedText

    send Info_Box sSelectedText "Selected Text"
End_Procedure // ShowSelectedText

Last Edited: December 2, 2004


DFBaseRichEdit [Function TextRange]

TextRange - DFBaseRichEdit

Returns text in given position range

Type: Function

Return Data Type: String

Parameters: integer iPositionStart integer iPositionEnd

Parameter | Description
iPositionStart | The starting position of the text
iPositionEnd | The ending position of the text

Return Value

Text between the starting and ending positions.

Description

Returns the text between the starting and ending positions (iPositionStart and iPositionEnd).

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, the first position in the second line will be 20.

Sample

This sample retrieves the text of a link in control oRichEdit1 that was clicked (OnLinkClicked fires when this happens). You can add your own handling of the link text in the begin...end code block.

Procedure OnLinkClicked integer iPositionStart integer iPositionEnd
    string sLinkText

    get TextRange of oRichEdit1 iPositionStart iPositionEnd to sLinkText

    if (sLinkText <> "") begin
        // do something
    end
End_Procedure  // OnLinkClicked

Last Edited: February 16, 2005


DFBaseRichEdit [Function UndoType]

UndoType - DFBaseRichEdit

Returns type of undo operation at top of undo queue

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Type of undo operation at the top of the undo queue.

Description

Returns the type of undo operation at the top of the undo queue.

If the undo queue for the control is not empty, the value returned indicates the type of the next action in the control's undo queue.
If there are no undoable actions or the type of the next undoable action is unknown, the return value is zero (Unknown).

The types of actions that can be undone or redone include typing, delete, drag-drop, cut, and paste operations. This information can be useful for applications that provide an extended user interface for undo and redo operations, such as a drop-down list box of redoable actions

This function has no effect if control is not paged.

Possible return values are:

Constant | Meaning
utUnknown | Unknown
utTyping | Typing
utDelete | Delete
utDragDrop | Drag and Drop
utCut | Cut
utPaste | Paste

Sample

This sample determines the next undo operation type available for control oRichEdit1 and displays it to the user in a message box.

Procedure CheckUndoType
    integer iUndoType
    string sUndoType

    get UndoType of oRichEdit1 to iUndoType

    if (iUndoType = utUnknown) ;
        send Info_Box "No undo operations available"
    else begin
        if (iUndoType = utTyping) move "Typing" to sUndoType
        else if (iUndoType = utDelete) move "Delete" to sUndoType
        else if (iUndoType = utDragDrop) move "DragDrop" to sUndoType
        else if (iUndoType = utCut) move "Cut" to sUndoType
        else if (iUndoType = utPaste) move "Paste" to sUndoType

        send Info_Box sUndoType "Next Undo operation available"
    end
End_Procedure  // CheckUndoType

Last Edited: December 2, 2004


Methods for DFBaseRichEdit

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
AppendText | Procedure | Appends text to end of text in control |
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control |
Beginning_of_Line | Procedure | Places the cursor at beginning of current line |
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
CharCount | Function | Returns length of RTF stream in the control |
ClearUndoBuffer | Procedure | Clears undo buffer |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Deletes all data in control |
Destroy | Procedure |  | cObject
End_of_Data | Procedure | Places the cursor at end of the text in control |
End_of_Line | Procedure | Places the cursor at end of current line |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
FindText | Function | Searches for specified text in control |
FirstCharInLinePos | Function | Returns position of first character in a line |
FirstVisibleLine | Function | Returns number of first visible line |
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
HideSelection | Procedure | Toggles selection highlighting on or off |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
LastErrorCode | Function | Returns error code for last operation |
Line | Function | Returns specified line of text |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
LineFromChar | Function | Returns number of line that contains specified character position or current line |
LineLength | Function | Returns number of characters in line |
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Read | Procedure | Reads RTF document and displays it in the control |
Redo | Procedure | Redoes the last operation |
RedoType | Function | Returns type of redo operation at top of redo queue |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements |
ReplaceSel | Procedure | Replaces selected text with specified text |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls up or down the control using specified scroll mode |
ScrollCaret | Procedure | Scrolls caret into view |
ScrollLines | Procedure | Scrolls control vertically for specified number of lines |
Select_All | Procedure | Selects entire contents of control |
SelEnd | Function | Returns end of selection |
SelStart | Function | Returns beginning of selection |
SelText | Function | Returns selected text |
SetSel | Procedure | Selects text in given position range |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
TextRange | Function | Returns text in given position range |
Undo | Procedure | Undoes the last operation |
UndoType | Function | Returns type of undo operation at top of undo queue |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes RTF stream content of control to file |


DFBaseRichEdit [Procedure AppendText]

AppendText - DFBaseRichEdit

Appends text to end of text in control

Type: Procedure

Parameters: string sText

Parameter | Description
sText | Text to append to control text

Description

Adds text to the end of the text in the control, including RTF stream if the text in the control is an RTF stream.

This method has no effect if control is not paged.

Text can be appended as either an RTF stream or plain text, and will be converted to an RTF stream.

Use Value to set or get the entire content of the control.

A linefeed (LF) character can be added to text programmatically by adding ASCII character 10 to a string using the character function. A carriage return (CR) character can be added to text programmatically by adding ASCII character 13 to a string using the character function. Either a LF or CR character will break the current line in the control.

Sample

This sample adds a "This is line1", a linefeed character and "This is line 2" to the end of the text in the oRichEdit1 control.

Procedure AddToText
    string sLineFeed

    move (character(10)) to sLineFeed

    send AppendText of oRichEdit1 "This is line 1"
    send AppendText of oRichEdit1 sLineFeed
    send AppendText of oRichEdit1 "This is line 2"
End_Procedure  // AddToText

Sample

This sample adds "Some RTF text" to the end of the text in the oRichEdit1 control. The result is the same as the result of the sample above. The difference is that in this sample, sText contains an RTF stream, whereas in the sample above, sText contained plain text.

Procedure AddToText
    string sText

    move "{\rtf1\ansi\deff0{\fonttbl{\f0\fswiss\fprq2\fcharset0 MS Sans Serif;}}" to sText
    move (sText + "{\colortbl ;\red0\green0\blue0;}") to sText
    move (sText + "\viewkind4\uc1\pard\cf1\lang1033\f0\fs18 Some RTF text\par}") to sText

    send AppendText of oRichEdit1 sText
End_Procedure  // AddToText

Last Edited: February 22, 2005


DFBaseRichEdit [Procedure Beginning_of_Data]

Beginning_of_Data - DFBaseRichEdit

Places the cursor at beginning of the text in control

Type: Procedure

Parameters: No Parameters

Description

Places the cursor at the beginning of the text in the control.

Sample

This sample sets the contents of the oRichEdit1 control to "Some RTF text" and then places the cursor at the beginning of the text in the control

Procedure DisplayText
    string sText

    move "Some RTF text" to sText

    set Value of oRichEdit1 to sText
    send Beginning_of_Data of oRichEdit1
End_Procedure  // DisplayText

Last Edited: November 23, 2004


DFBaseRichEdit [Procedure Beginning_of_Line]

Beginning_of_Line - DFBaseRichEdit

Places the cursor at beginning of current line

Type: Procedure

Parameters: No Parameters

Description

Places the cursor at the beginning of the current line (the line the cursor is currently in) in the control.

If text is selected, places the cursor at the beginning of the line at the beginning of the selected text.

Sample

This sample places the cursor at the beginning of the current line in control oRichEdit1.

send Beginning_of_Line of oRichEdit1

Last Edited: November 24, 2004


DFBaseRichEdit [Procedure ClearUndoBuffer]

ClearUndoBuffer - DFBaseRichEdit

Clears undo buffer

Type: Procedure

Parameters: No Parameters

Description

Clears the undo buffer of the control. Immediately after this call, there are no undo or redo operations to be performed.

This method has no effect if control is not paged.

Sample

This sample clears the undo buffer of control oRichEdit1.

send ClearUndoBuffer of oRichEdit1

Last Edited: November 22, 2004


DFBaseRichEdit [Procedure Delete_Data]

Delete_Data - DFBaseRichEdit

Deletes all data in control

Type: Procedure

Parameters: No Parameters

Description

Deletes all data in the control.

This method has no effect if control is not paged.

Sample

This sample deletes all data in control oRichEdit1.

send Delete_Data of oRichEdit1

Last Edited: November 22, 2004


DFBaseRichEdit [Procedure End_of_Data]

End_of_Data - DFBaseRichEdit

Places the cursor at end of the text in control

Type: Procedure

Parameters: No Parameters

Description

Places the cursor at the end of the text in the control.

Sample

This sample places the cursor at the end of the text in the control

send End_of_Data of oRichEdit1

Last Edited: November 24, 2004


DFBaseRichEdit [Procedure End_of_Line]

End_of_Line - DFBaseRichEdit

Places the cursor at end of current line

Type: Procedure

Parameters: No Parameters

Description

Places the cursor at the end of the current line (the line the cursor is currently in) in the control.

If text is selected, places the cursor at the end of the line at the end of the selected text.

Sample

This sample places the cursor at the end of the current line in control oRichEdit1.

send End_of_Line of oRichEdit1

Last Edited: November 24, 2004


DFBaseRichEdit [Procedure HideSelection]

HideSelection - DFBaseRichEdit

Toggles selection highlighting on or off

Type: Procedure

Parameters: Boolean bHideSelection

Parameter | Description
bHideSelection | Boolean parameter that determines whether selection highlighting should be on or off

Description

Toggles selection highlighting on or off.

This method has no effect if control is not paged.

Sample

This sample changes the selection highlighting of control oRichEdit1 to be off.

send HideSelection of oRichEdit1 False

Sample

This sample changes the selection highlighting of control oRichEdit1 to be on.

send HideSelection of oRichEdit1 True

Last Edited: November 22, 2004


DFBaseRichEdit [Procedure Read]

Read - DFBaseRichEdit

Reads RTF document and displays it in the control

Type: Procedure

Parameters: String sFileName

Parameter | Description
sFileName | The name (and path to) of the RTF document to read

Description

Reads an RTF document and displays it in the control. Calling read will replace all text currently in the control with the contents of sFileName.

Sample

This sample reads a document named MyDocument.rtf and displays its content in the oRichEdit1 control.

Procedure ReadFile
    string sFileName

    move "MyDocument.rtf" to sFileName

    send Read of oRichEdit1 sFileName
End_Procedure  // ReadFile

Sample

This sample allows the user to select a document using an OpenDialog control, and then displays the content of the document the user has selected in the oRichEdit1 control. This sample assumes that an OpenDialog control named oOpenDialog1 exists in your code.

Procedure ReadFile
    string sFileName

    set Filter_String of oOpenDialog1 to 'RTF Documents (*.rtf)|*.rtf|All Files (*.*)|*.*'
    get Show_Dialog of oOpenDialog1 To bOk
    if (bOk = True) begin
        get File_Name of oOpenDialog1 to sFileName
        send Read of oRichEdit1 sFileName
    end
End_Procedure  // ReadFile

Last Edited: November 24, 2004


DFBaseRichEdit [Procedure Redo]

Redo - DFBaseRichEdit

Redoes the last operation

Type: Procedure

Parameters: No Parameters

Description

This property has no effect if control is not paged.

Sample

This sample redoes the last operation of control oRichEdit1.

send Redo of oRichEdit1

Sample

This sample checks if a redo operation can be performed in the oRichEdit1 control using pbCanRedo. If so, it sends the Redo message to the control.

Procedure RedoIfPossible
    if (pbCanRedo(oRichEdit1) = True) ;
        send Redo of oRichEdit1
End_Procedure  // RedoIfPossible

Last Edited: November 23, 2004


DFBaseRichEdit [Procedure ReplaceSel]

ReplaceSel - DFBaseRichEdit

Replaces selected text with specified text

Type: Procedure

Parameters: string sText

Parameter | Description
sText | Text to replace selected text with

Description

Replaces selected text with sText. If no text is selected, it inserts the text at the current caret position.

This method has no effect if control is not paged.

Sample

This sample replaces the selected text in control oRichEdit1 with "Michael".

send ReplaceSel of oRichEdit1 "Michael"

Sample

This sample gets the search text from a user via Form oSearchText to variable sSearchText and the text to replace the found text from a user via Form oReplaceText to variable sReplaceText . It then performs a case-sensitive search using FindText for sSearchText in all text in the oRichEdit1 control following the current selection or cursor position. If sSearchText appears in the portion of the control's text that is searched, it is selected using the SetSel method. This sample assumes that Form or dbForm controls named oSearchText and oReplaceText exists in your code.

Procedure DoSearch
    string sSearchText sReplaceText
    integer iSelStart iSelEnd

    // get user's search text from form
    get Value of oSearchText to sSearchText
    // get user's replace text from form
    get Value of oReplaceText to sReplaceText

    get FindText of oRichEdit1 sSearchText FR_MATCHCASE to iSelStart
    // was search successful?
    if (iSelStart <> -1) begin
        // get length of search text
        move (length(sSearchText) + iSelStart) to iSelEnd
        // select search text found
        send SetSel of oRichEdit1 iSelStart iSelEnd

        // now, replace the selected text
        send ReplaceSel of oRichEdit1 sReplaceText
    end
End_Procedure // DoSearch

Last Edited: July 26, 2005


DFBaseRichEdit [Procedure Scroll]

Scroll - DFBaseRichEdit

Scrolls up or down the control using specified scroll mode

Type: Procedure

Parameters: integer eScrollMode

Parameter Description
eScrollModeType of scroll mode. Possible modes are:

Constant | Meaning
SB_PAGEUP | Scroll up one page
SB_PAGEDOWN | Scroll down one page
SB_LINEUP | Scroll up one line
SB_LINEDOWN | Scroll down one line

Description

Scrolls up or down the control using the specified eScrollMode.

Sample

This sample scrolls the oRichEdit1 control down one page.

send Scroll of oRichEdit1 SB_PAGEDOWN

Sample

This sample scrolls the oRichEdit1 control using the specified eScrollMode.

Procedure DoScroll integer eScrollMode
    send Scroll of oRichEdit1 eScrollMode
End_Procedure  // DoScroll

Last Edited: November 24, 2004


DFBaseRichEdit [Procedure ScrollCaret]

ScrollCaret - DFBaseRichEdit

Scrolls caret into view

Type: Procedure

Parameters: No Parameters

Description

Scrolls caret into view. If the user has scrolled up or down in the control so that the caret is no longer visible, ScrollCaret will scroll the control until the caret is in the viewable area of the control.

Sample

This sample scrolls the caret into the viewable area of the oRichEdit1 control

send ScrollCaret of oRichEdit1

Last Edited: November 24, 2004


DFBaseRichEdit [Procedure ScrollLines]

ScrollLines - DFBaseRichEdit

Scrolls control vertically for specified number of lines

Type: Procedure

Parameters: integer iLines

Parameter | Description
iLines | Number of lines to scroll

Description

Scrolls control vertically for iLines number of lines.

If iLines is positive, control scrolls down.
If iLines is negative, control scrolls up.

This method has no effect if control is not paged.

Sample

This sample scrolls control oRichEdit1 down 20 lines.

send ScrollLines of oRichEdit1 20

Sample

This sample scrolls control oRichEdit1 up 20 lines.

send ScrollLines of oRichEdit1 -20

Last Edited: November 24, 2004


DFBaseRichEdit [Procedure Select_All]

Select_All - DFBaseRichEdit

Selects entire contents of control

Type: Procedure

Parameters: No Parameters

Description

Selects entire contents of control.

This method has no effect if control is not paged.

Sample

The sample selects entire contents of control oRichEdit1.

send Select_All of oRichEdit1

Last Edited: November 22, 2004


DFBaseRichEdit [Procedure SetSel]

SetSel - DFBaseRichEdit

Selects text in given position range

Type: Procedure

Parameters: integer iPositionStart integer iPositionEnd

Parameter | Description
iPositionStart | The starting position of the text
iPositionEnd | The ending position of the text

Description

Selects text in control in given position range.

Selects text from character immediately after position iPositionStart to character in the position iPositionEnd.

If iPositionStart is equal to iPositionEnd, the selection range is empty, so caret will be placed immediately after position iPositionStart.
If iPositionStart is equal to 0, and iPositionEnd is -1, the entire text is selected.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, the first position in the second line will be 20.

This method has no effect if control is not paged.

Sample

This sample gets the search text from a user via Form oSearchText to variable sSearchText. It then performs a case-sensitive search for sSearchText in all text in the oRichEdit1 control following the current selection or cursor position. If sSearchText appears in the portion of the control's text that is searched, it is selected (highlighted) using the SetSel method. This sample assumes that a Form or dbForm control named oSearchText exists in your code. Also, since the first occurence of sSearchText is now selected, and searches always occur forward from the end of the current selection or cursor position, you can simply call DoSearch again to find the next occurence of sSearchText.

Procedure DoSearch
    integer iSelStart iSelEnd

    send SetSel of oRichEdit1 iSelStart iSelEnd
End_Procedure // DoSearch

Sample

This sample performs a case-sensitive search for "Joe" in the oRichEdit1 control using the FindText method. If "Joe" appears in the portion of the control's text that is searched, it is selected using SetSel. This sample assumes that a Form or dbForm control named oSearchText exists in your code.

Note:
A more sophisticated version of this sample can be found in the FindText method documentation.

Procedure DoSearch
    integer iSelStart iSelEnd

    get FindText of oRichEdit1 "Joe" FR_MATCHCASE to iSelStart
    // was search successful?
    if (iSelStart <> -1) begin
        // get length of search text
        move (length(sSearchText) + iSelStart) to iSelEnd
        // select search text found
        send SetSel of oRichEdit1 iSelStart iSelEnd
    end
End_Procedure // DoSearch

Last Edited: December 2, 2004


DFBaseRichEdit [Procedure Undo]

Undo - DFBaseRichEdit

Undoes the last operation

Type: Procedure

Parameters: No Parameters

Description

This property has no effect if control is not paged.

Sample

This sample undoes the last operation of control oRichEdit1.

send Undo of oRichEdit1

Sample

This sample checks if an undo operation can be performed in the oRichEdit1 control using pbCanUndo. If so, it sends the Undo message to the control.

Procedure UndoIfPossible
    if (pbCanUndo(oRichEdit1) = True) ;
        send Undo of oRichEdit1
End_Procedure  // UndoIfPossible

Last Edited: November 23, 2004


DFBaseRichEdit [Procedure Write]

Write - DFBaseRichEdit

Writes RTF stream content of control to file

Type: Procedure

Parameters: String sFileName

Parameter | Description
sFileName | The name (and path to) of the RTF document to write to

Description

Writes the entire content of control as an RTF stream to file specified by sFileName.

Sample

This sample writes the entire content of control oRichEdit1 to a document named MyDocument.rtf.

Procedure ReadFile
    string sFileName

    move "MyDocument.rtf" to sFileName

    send Write of oRichEdit1 sFileName
End_Procedure  // ReadFile

Sample

This sample allows the user to select a document using an SaveAsDialog control, and then writes the entire content of control oRichEdit1 to the document name the user has specified in the SaveAsDialog. This sample assumes that a SaveAsDialog control named oSaveAsDialog1 exists in your code.

Procedure ReadFile
    string sFileName

    set Filter_String of oSaveAsDialog1 to 'RTF Documents (*.rtf)|*.rtf|All Files (*.*)|*.*'
    get Show_Dialog of oSaveAsDialog1 To bOk
    if (bOk = True) begin
        get File_Name of oSaveAsDialog1 to sFileName
        send Write of oRichEdit1 sFileName
    end
End_Procedure  // ReadFile

Last Edited: November 24, 2004


Properties for DFBaseRichEdit

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of lines in control |
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
paValue | Sets content of control from memory address or places RTF stream in control into memory address |
pbAutoUrl | Toggles the ability for the control to automatically detect URLs and add hyperlinks |
pbBold | Toggles selected text between bold and normal text |
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard |
pbCanRedo | Determines whether a redo operation can be performed |
pbCanUndo | Determines whether an undo operation can be performed |
pbItalics | Toggles selected text between italicized and normal text |
pbLink | Toggles selected text between hyperlinked and normal text |
pbProtect | Toggles selected text between protected and normal text |
pbStrikeOut | Toggles selected text between strikeout and normal text |
pbSubScript | Toggles selected text between subcripted and normal text |
pbSuperScript | Toggles selected text between superscripted and normal text |
pbUnderline | Toggles selected text between underlined and normal text |
pbWrap | Determines whether text input will break and wrap to the next line at right margin |
peAlignment | Sets or returns alignment of selected paragraph or paragraphs |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peBullets | Sets or returns bullets or numbering of selected paragraph or paragraphs |
peBulletStyle | Sets or returns numbering styles of selected paragraph or paragraphs |
peCharSet | Sets or returns character set of selected text |
peLineSpacingType | Determines type of line spacing of selected paragraph or paragraphs |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
pePitchandFamily | Sets or returns the font pitch and family of selected text |
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piBulletStart | Sets or returns the starting number of paragraph numbering of selected paragraph or paragraphs |
piBulletTab | Sets or returns the minimum space between a paragraph bullet or number and the paragraph text of selected paragraph or paragraphs |
piFontSize | Sets or returns font size of selected text |
piFontWeight | Sets or returns font weight of selected text |
piLineSpacing | Determines exact line spacing of selected paragraph or paragraphs |
piMaxChars | Sets or returns maximum number of characters |
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piOffsetIndent | Sets or returns indentation of 2nd and subsequent lines, relative to first line, of selected paragraph or paragraphs |
piParagraphIndent | Sets or returns indentation of selected paragraph or paragraphs |
piRightMargin | Determines indentation of right side of control's text, relative to the right margin |
piSpacingAfter | Determines the spacing below selected paragraph or paragraphs |
piSpacingBefore | Determines the spacing above selected paragraph or paragraphs |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psTypeFace | Sets or returns font typeface of selected text |
Read_Only_State | Determines whether users may edit the content of the control |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextBackColor | Sets or returns background color of selected text |
TextColor | Sets or returns color of selected text |
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Sets or returns content of control |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


DFBaseRichEdit [Property Line_Count]

Line_Count - DFBaseRichEdit

Returns number of lines in control

Type: Property

Access: Read-Only

Data Type: Integer

Description

Line_Count returns the number of lines of text displayed in control.

This method has no effect if control is not paged (returns zero).

Sample

This sample gets the number of lines displayed in control oRichEdit1 and displays it to the user in a message box.

Procedure DisplayCurrentLineCount
    integer iNumberOfLines

    // get the length of the current line
    get Line_Count of oRichEdit1 to iNumberOfLines

    send Info_Box (string(iNumberOfLines)) "Number of lines"
End_Procedure // DisplayCurrentLineCount

Last Edited: November 8, 2006


DFBaseRichEdit [Property paValue]

paValue - DFBaseRichEdit

Sets content of control from memory address or places RTF stream in control into memory address

Type: Property

Access: Read/Write

Data Type: Address

Description

Sets content of a control from memory address or places RTF stream in control into memory address.

When placing the content of the control into a memory address, the full RTF stream of the control is placed into that memory address (rather than just the text).

Sample

This sample sets the contents of control oRichEdit1 to the text contained in string variable sText.

Procedure GetControlContents
    address aMyAddress
    string sText

    // this could be the contents of an RTF document
    move "Some RTF text" to sText

    GetAddress of sText to aMyAddress
    set paValue of oRichEdit1 to aMyAddress
End_Procedure  // GetControlContents

Sample

This sample moves the contents of control oRichEdit1 into the memory address in address variable aMyAddress.

Procedure SetControlContents
    address aMyAddress
    string sText

    get paValue of oRichEdit1 to aMyAddress
    move aMyAddress to sText
End_Procedure  // SetControlContents

Last Edited: November 22, 2004


DFBaseRichEdit [Property pbAutoUrl]

pbAutoUrl - DFBaseRichEdit

Toggles the ability for the control to automatically detect URLs and add hyperlinks

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Toggles the ability for the control to automatically detect URLs (Uniform Resource Locators) and add hyperlinks to the control's text when URLs are detected.

If automatic URL detection is enabled (pbAutoUrl = True), the control scans any modified text to determine whether the text matches the format of a URL. The control detects URLs that begin with the following prefixes: http:, https:, file:, mailto:, ftp:, gopher:, nntp:, prospero:, telnet:, news:, wais:

When it detects a URL, the control highlights the URL string by underlining it and setting the text color.

This property has no effect if control is not paged.

Sample

This sample enables automatic URL detection.

set pbAutoUrl to True

Sample

This sample disables automatic URL detection.

set pbAutoUrl to False

Note:
When automatic URL detection is enabled (pbAutoUrl = True), the control removes the pbLink effect from modified text that does not have a URL format recognized by the control. If your application uses the pbLink effect to mark other types of text, do not enable automatic URL detection.

Last Edited: January 20, 2006


DFBaseRichEdit [Property pbBold]

pbBold - DFBaseRichEdit

Toggles selected text between bold and normal text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Toggles the selected text in the control between bold and normal text.
If no text is selected and this property is set to true, any text typed from this point forward will be bold.

This property has no effect if control is not paged.

Sample

This sample changes the font of the selected text in control oRichEdit1 to bold.

set pbBold of oRichEdit1 to True

Sample

This sample changes the font of the selected text in control oRichEdit1 to normal (non-bold).

set pbBold of oRichEdit1 to False

If you get this property and it is not consistent throughout the selection, it will return the pbBold value for the first character of the selection, and LastErrorCode will equal ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION.

Sample

This sample gets the value of pbBold, then checks if pbBold was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin...end code block.

Integer iLastErrorCode
Boolean bIsBold
get pbBold to bIsBold
get LastErrorCode to iLastErrorCode
if (iLastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Last Edited: January 12, 2005


DFBaseRichEdit [Property pbCanPaste]

pbCanPaste - DFBaseRichEdit

Determines whether paste operation can be performed with current format in clipboard

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Determines whether the contents of the clipboard in the current format can be pasted into the control.

This property has no effect if control is not paged.

Sample

This sample checks if the contents of the clipboard in the current format can be pasted into the oRichEdit1 control. If so, it sends the Paste message to the control.

Procedure PasteIfPossible
    if (pbCanPaste(oRichEdit1) = True) ;
        send Paste of oRichEdit1
End_Procedure // PasteIfPossible

Last Edited: November 19, 2004


DFBaseRichEdit [Property pbCanRedo]

pbCanRedo - DFBaseRichEdit

Determines whether a redo operation can be performed

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Determines whether a redo operation can be performed in the control.

This property has no effect if control is not paged.

Sample

This sample checks if a redo operation can be performed in the oRichEdit1 control. If so, it sends the Redo message to the control.

Procedure RedoIfPossible
    if (pbCanRedo(oRichEdit1) = True) ;
        send Redo of oRichEdit1
End_Procedure // RedoIfPossible

Last Edited: November 23, 2004


DFBaseRichEdit [Property pbCanUndo]

pbCanUndo - DFBaseRichEdit

Determines whether an undo operation can be performed

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Determines whether an undo operation can be performed in the control.

This property has no effect if control is not paged.

Sample

This sample checks if an undo operation can be performed in the oRichEdit1 control. If so, it sends the Undo message to the control.

Procedure UndoIfPossible
    if (pbCanUndo(oRichEdit1) = True) ;
        send Undo of oRichEdit1
End_Procedure // UndoIfPossible

Last Edited: November 23, 2004


DFBaseRichEdit [Property pbItalics]

pbItalics - DFBaseRichEdit

Toggles selected text between italicized and normal text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Toggles the selected text in the control between italicized and normal text.
If no text is selected and this property is set to true, any text typed from this point forward will be italicized.

This property has no effect if control is not paged.

Sample

This sample changes the font of the selected text in control oRichEdit1 to italic.

set pbItalics of oRichEdit1 to True

Sample

This sample changes the font of the selected text in control oRichEdit1 to normal (non-italic).

set pbItalics of oRichEdit1 to False

If you get this property and it is not consistent throughout the selection, it will return the pbItalics value for the first character of the selection, and LastErrorCode will equal ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION.

Sample

This sample gets the value of pbItalics, then checks if pbItalics was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin..end code block.

Integer iLastErrorCode
Boolean bIsItalic
get pbItalics to bIsItalic
get LastErrorCode to iLastErrorCode
if (iLastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Last Edited: January 12, 2005


DFBaseRichEdit [Property pbLink]

pbLink - DFBaseRichEdit

Toggles selected text between hyperlinked and normal text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Toggles selected text between hyperlinked and normal text.
If no text is selected and this property is set to true, any text typed from this point forward will be hyperlinked.

This property has no effect if control is not paged.

When the created link is clicked, OnLinkClicked is fired.

Sample

This sample changes the selected text to a hyperlink.

set pbLink to True

Sample

This sample changes the selected text to normal (non-hyperlinked) text.

set pbLink to False

If you get this property and it is not consistent throughout the selection, it will return the pbLink value for the first character of the selection, and LastErrorCode will equal ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION.

Sample

This sample gets the value of pbLink, then checks if pbLink was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin...end code block.

Integer iLastErrorCode
Boolean bIsLinked
get pbLink to bIsLinked
get LastErrorCode to iLastErrorCode
if (iLastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Note:
When automatic URL detection is enabled (pbAutoUrl = True), the control removes the pbLink effect from modified text that does not have a URL format recognized by the control. If your application uses the pbLink effect to mark other types of text, do not enable automatic URL detection.

Last Edited: January 12, 2005


DFBaseRichEdit [Property pbProtect]

pbProtect - DFBaseRichEdit

Toggles selected text between protected and normal text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Toggles the selected text of the control between protected and normal text.

The protected character effect is unique in that it does not change the appearance of text, but it does protect the text from being changed by the user.

This property has no effect if control is not paged.

Sample

This sample changes the font of the selected text to protected.

set pbProtect to True

Sample

This sample changes the font of the selected text to normal (non-protected).

set pbProtect to False

If you get this property and it is not consistent throughout the selection, it will return the pbProtect value for the first character of the selection, and LastErrorCode will equal ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION.

Sample

This sample gets the value of pbProtect, then checks if pbProtect was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin...end code block.

Integer iLastErrorCode
Boolean bIsProtected
get pbProtect to bIsProtected
get LastErrorCode to iLastErrorCode
if (iLastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Last Edited: January 12, 2005


DFBaseRichEdit [Property pbStrikeOut]

pbStrikeOut - DFBaseRichEdit

Toggles selected text between strikeout and normal text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Toggles the selected text in the control between strikeout and normal text.
If no text is selected and this property is set to true, any text typed from this point forward will be strikeout.
Strikeout text is sometimes also referred to as strikethrough text.

This property has no effect if control is not paged.

Sample

This sample changes the font of the selected text in control oRichEdit1 to strikeout.

set pbStrikeOut of oRichEdit1 to True

Sample

This sample changes the font of the selected text in control oRichEdit1 to normal (non-strikeout).

set pbStrikeOut of oRichEdit1 to False

If you get this property and it is not consistent throughout the selection, it will return the pbStrikeOut value for the first character of the selection, and LastErrorCode will equal ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION.

Sample

This sample gets the value of pbStrikeOut, then checks if pbStrikeOut was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin..end code block.

Integer iLastErrorCode
Boolean bIsStrikeOut
get pbStrikeOut to bIsStrikeOut
get LastErrorCode to iLastErrorCode
if (iLastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Last Edited: January 12, 2005


DFBaseRichEdit [Property pbSubScript]

pbSubScript - DFBaseRichEdit

Toggles selected text between subcripted and normal text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Toggles the selected text in the control between subcripted and normal text.
If no text is selected and this property is set to true, any text typed from this point forward will be subscripted.

This property has no effect if control is not paged.

Sample

This sample changes the font of the selected text in control oRichEdit1 to subcript.

set pbSubScript of oRichEdit1 to True

Sample

This sample changes the font of the selected text in control oRichEdit1 to normal (non-subcript).

set pbSubScript of oRichEdit1 to False

If you get this property and it is not consistent throughout the selection, it will return the pbSubScript value for the first character of the selection, and LastErrorCode will equal ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION.

Sample

This sample gets the value of pbSubScript, then checks if pbSubScript was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin..end code block.

Integer iLastErrorCode
Boolean bIsSubScript
get pbSubScript to bIsSubScript
get LastErrorCode to iLastErrorCode
if (iLastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Last Edited: January 12, 2005


DFBaseRichEdit [Property pbSuperScript]

pbSuperScript - DFBaseRichEdit

Toggles selected text between superscripted and normal text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Toggles the selected text in the control between superscripted and normal text.
If no text is selected and this property is set to true, any text typed from this point forward will be superscripted.

This property has no effect if control is not paged.

Sample

This sample changes the font of the selected text in control oRichEdit1 to superscript.

set pbSuperScript of oRichEdit1 to True

Sample

This sample changes the font of the selected text in control oRichEdit1 to normal (non-superscript).

set pbSuperScript of oRichEdit1 to False

If you get this property and it is not consistent throughout the selection, it will return the pbSuperScript value for the first character of the selection, and LastErrorCode will equal ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION.

Sample

This sample gets the value of pbSuperScript, then checks if pbSuperScript was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin..end code block.

Integer iLastErrorCode
Boolean bIsSuperScript
get pbSuperScript to bIsSuperScript
get LastErrorCode to iLastErrorCode
if (iLastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Last Edited: January 12, 2005


DFBaseRichEdit [Property pbUnderline]

pbUnderline - DFBaseRichEdit

Toggles selected text between underlined and normal text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Toggles the selected text in the control between underlined and normal text.
If no text is selected and this property is set to true, any text typed from this point forward will be underlined.

This property has no effect if control is not paged.

Sample

This sample changes the font of the selected text in control oRichEdit1 to underlined.

set pbUnderline of oRichEdit1 to True

Sample

This sample changes the font of the selected text in control oRichEdit1 to normal (non-underlined).

set pbUnderline of oRichEdit1 to False

If you get this property and it is not consistent throughout the selection, it will return the pbUnderline value for the first character of the selection, and LastErrorCode will equal ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION.

Sample

This sample gets the value of pbUnderline, then checks if pbUnderline was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin..end code block.

Integer iLastErrorCode
Boolean bIsUnderlined
get pbUnderline to bIsUnderlined
get LastErrorCode to iLastErrorCode
if (iLastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Last Edited: January 12, 2005


DFBaseRichEdit [Property pbWrap]

pbWrap - DFBaseRichEdit

Determines whether text input will break and wrap to the next line at right margin

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Determines whether text input will break and wrap to the next line at the right margin of this object, or will continue onward on the same line until a carriage return/linefeed is entered.

A rich edit control calls a function called a word-break procedure to find breaks between words and to determine where it can break lines. Word-break procedures for this control can determine whether a character is a delimiter and can find the nearest word break before or after the specified position. A delimiter is a character that marks the end of a word, such as a space. The control uses this information when performing word-wrap operations and when processing Ctrl+Left Arrow and Ctrl+Right Arrow key combinations.

A linefeed (LF) character can be added to text programmatically by adding ASCII character 10 to a string using the character function. A carriage return (CR) character can be added to text programmatically by adding ASCII character 13 to a string using the character function. Either a LF or CR character will break the current line in the control.

Sample

This sample turns on word wrapping of the control.

set pbWrap to True

Sample

This sample turns off word wrapping of the control.

set pbWrap to False

Sample

This sample adds linefeed characters to the end of lines of text to force a break of a long text string into multiple lines, then adds the text to the existing text of control oRichEdit1 using AppendText.

Procedure AddSomeText
    string sLineFeed sText

    move (character(10)) to sLineFeed

    move ("Procedure DoSomething"+sLinefeed) to sText
    move (sText+"    // add code here"+sLinefeed) to sText
    move (sText+"End_Procedure  // DoSomething"+sLinefeed) to sText

    send AppendText of oRichEdit1 sText
End_Procedure  // AddSomeText

Last Edited: February 22, 2005


DFBaseRichEdit [Property peAlignment]

peAlignment - DFBaseRichEdit

Sets or returns alignment of selected paragraph or paragraphs

Type: Property

Access: Read/Write

Data Type: Integer

Description

If any part of a paragraph is selected, this property applies to the entire paragraph. If the cursor is in a paragraph, this property applies to the entire paragraph.

This property has no effect if control is not paged.

Possible values are:

Constant | Meaning
alLeft | Left aligns selected paragraph
alRight | Right aligns selected text paragraph
alCenter | Center selected paragraph

Sample

This sample left aligns the paragraph or paragraphs of the currently selected text.

set peAlignment to alLeft

Note:
To use the alXXX constants in your code, you may have to include cRichEdit.pkg in your code (if it is not already included):
Use cRichEdit.pkg

Last Edited: February 17, 2005


DFBaseRichEdit [Property peBullets]

peBullets - DFBaseRichEdit

Sets or returns bullets or numbering of selected paragraph or paragraphs

Type: Property

Access: Read/Write

Data Type: Integer

Description

If any part of a paragraph is selected, this property applies to the entire paragraph. If the cursor is in a paragraph, this property applies to the entire paragraph.

This property has no effect if control is not paged.

To set the starting number or letter for paragraph numbering, use piBulletStart.
To set the style of the bullet or number for paragraph numbering, use peBulletStyle.

Possible values are:

Constant | Meaning
buNone | Apply no bullets or numbering
buBullets | Apply bullets
buArabicNumbers | Apply numbering with Arabic numbers
buLowerLetters | Apply numbering with lowercase letters
buUpperLetters | Apply numbering with uppercase letters
buLowerRomans | Apply numbering with lowercase Roman numerals
buUpperRomans | Apply numbering with uppercase Roman numerals

Sample

This sample applies bullets to the paragraph or paragraphs of the currently selected text.

set peBullets to buBullets

Sample

This sample applies numbering with lowercase Roman numerals to the selected paragraph or paragraphs, sets the starting number to 3 and sets the bullet style to enclose the number in parentheses..

set peBullets to buLowerRomans
set piBulletStart to 3
set peBulletStyle to busEncloseParen

Sample

This sample removes all bullets and numbering from the paragraph or paragraphs of the currently selected text.

set peBullets to buNone

Note:
To use the buXXX constants in your code, you may have to include cRichEdit.pkg in your code (if it is not already included):
Use cRichEdit.pkg

Last Edited: February 17, 2005


DFBaseRichEdit [Property peBulletStyle]

peBulletStyle - DFBaseRichEdit

Sets or returns numbering styles of selected paragraph or paragraphs

Type: Property

Access: Read/Write

Data Type: Integer

Description

If any part of a paragraph is selected, this property applies to the entire paragraph. If the cursor is in a paragraph, this property applies to the entire paragraph.

This property only affects paragraph numbering and has no effect on bullets.

This property has no effect if control is not paged.

Possible values are:

Constant | Meaning
busRightParen | The paragraph number is followed by a closing (right) parenthesis
busEncloseParen | The paragraph number is enclosed in parentheses
busPeriod | The paragraph number is followed by a period (.)
busNumberOnly | The paragraph number is displayed with no surrounding or following characters
busNoDisplay | The paragraph number is applied, but not displayed

To apply bullets or numbering to paragraphs, use peBullets.
To set the style of the bullet or number for paragraph numbering, use peBulletStyle.

Sample

This sample changes the paragraph numbering style to display the paragraph number followed by a period.

set peBulletStyle to busPeriod

Sample

This sample applies numbering with lowercase Roman numerals to the selected paragraph or paragraphs, sets the starting number to 3 and sets the bullet style to enclose the number in parentheses..

set peBullets to buLowerRomans
set piBulletStart to 3
set peBulletStyle to busEncloseParen

Note:
To use the busXXX constants in your code, you may have to include cRichEdit.pkg in your code (if it is not already included):
Use cRichEdit.pkg

Last Edited: February 17, 2005


DFBaseRichEdit [Property peCharSet]

peCharSet - DFBaseRichEdit

Sets or returns character set of selected text

Type: Property

Access: Read/Write

Data Type: Integer

Description

Sets or returns the character set of the selected text of the control.

Possible values are:

ANSI_CHARSET
DEFAULT_CHARSET
SYMBOL_CHARSET
SHIFTJIS_CHARSET
GB2312_CHARSET
HANGUL_CHARSET
CHINESEBIG5_CHARSET
OEM_CHARSET

If you get this property and it is not consistent throughout the selection, it will return the peCharSet value for the first character of the selection, and LastErrorCode will equal ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION.

Sample

This sample gets the value of peCharSet, then checks if peCharSet was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin...end code block.

integer iCharSet iLastErrorCode
get peCharSet to iCharSet
get LastErrorCode to iLastErrorCode
if (iLastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Sample

This sample returns the character set of the selected text to variable iCharSet.
Then, it displays a message box that displays the character set to the user.

Procedure RetrieveCharSet
    integer iCharSet

    get peCharset of oRichEdit1 to iCharSet
    if (iCharset = DEFAULT_CHARSET) ;
        send Info_Box "Default"
    else if (iCharset = ANSI_CHARSET) ;
        send Info_Box "ANSI"
    else if (iCharset = SYMBOL_CHARSET) ;
        send Info_Box "Symbol"
    else if (iCharset = SHIFTJIS_CHARSET) ;
        send Info_Box "Shift JIS"
    else if (iCharset = GB2312_CHARSET) ;
        send Info_Box "GB 2312"
    else if (iCharset = HANGUL_CHARSET) ;
        send Info_Box "Hangul"
    else if (iCharset = CHINESEBIG5_CHARSET) ;
        send Info_Box "Chinese Big 5"
    else if (iCharset = OEM_CHARSET) ;
        send Info_Box "OEM"
End_Procedure  // RetrieveCharSet

Note:
To use the constants displayed above in your code, you may have to include font_dlg.pkg in your code (if it is not already included):
Use font_dlg.pkg

Last Edited: February 17, 2005


DFBaseRichEdit [Property peLineSpacingType]

peLineSpacingType - DFBaseRichEdit

Determines type of line spacing of selected paragraph or paragraphs

Type: Property

Access: Read/Write

Data Type: Integer

Description

If any part of a paragraph is selected, this property applies to the entire paragraph. If the cursor is in a paragraph, this property applies to the entire paragraph.

This property has no effect if control is not paged.

peLineSpacingType sets line spacing to a predefined spacing, such as single or double. You can use piLineSpacing to to a specific number of twips.

Possible values are:

Constant | Meaning
lstSingle | Line spacing = 1 line
lstSingleAndOneHalf | Line spacing = 1.5 lines
lstDouble | Line spacing = 2 lines

Sample

This sample sets the line spacing of the selected paragraph or paragraphs to single spacing.

set peLineSpacingType to lstSingle

Sample

This sample retrieves the line spacing of the selected paragraph or paragraphs to variable eLineSpacingType and then displays a message to the user showing them what the current line spacing is.

Procedure DetermineLineSpacing
    integer eLineSpacingType

    get peLineSpacingType to eLineSpacingType

    if (eLineSpacingType = lstSingle) ;
        send Info_Box "Line spacing is 1 line" "Line spacing"
    else if (eLineSpacingType = lstSingleAndOneHalf);
        send Info_Box "Line spacing is 1.5 lines" "Line spacing"
    else if (eLineSpacingType = lstDouble) ;
        send Info_Box "Line spacing is 2 lines" "Line spacing"
End_Procedure  // DetermineLineSpacing

Note:
To use the lstXXX constants in your code, you may have to include cRichEdit.pkg in your code (if it is not already included):
Use cRichEdit.pkg

Last Edited: February 17, 2005


DFBaseRichEdit [Property pePitchandFamily]

pePitchandFamily - DFBaseRichEdit

Sets or returns the font pitch and family of selected text

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: November 19, 2004


DFBaseRichEdit [Property piBulletStart]

piBulletStart - DFBaseRichEdit

Sets or returns the starting number of paragraph numbering of selected paragraph or paragraphs

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property has no effect if control is not paged.

To apply bullets or numbering to paragraphs, use peBullets.
To set the style of the bullet or number for paragraph numbering, use peBulletStyle.

Sample

This sample sets the starting number for paragraph numbering to 1 (or the letter "a" or "A", if peBullets specifies letters).

set piBulletStart to 1

Sample

This sample sets the starting number for paragraph numbering to 4 (or the letter "d" or "D", if peBullets specifies letters).

set piBulletStart to 4

Last Edited: November 19, 2004


DFBaseRichEdit [Property piBulletTab]

piBulletTab - DFBaseRichEdit

Sets or returns the minimum space between a paragraph bullet or number and the paragraph text of selected paragraph or paragraphs

Type: Property

Access: Read/Write

Data Type: Integer

Description

If any part of a paragraph is selected, this property applies to the entire paragraph. If the cursor is in a paragraph, this property applies to the entire paragraph.

This property uses twips, which are 1/1440 of an inch, or 1/20 of a printer's point.

This property has no effect if control is not paged.

To apply bullets or numbering to paragraphs, use peBullets.
To set the style of the bullet or number for paragraph numbering, use peBulletStyle.
To set the starting number or letter for paragraph numbering, use piBulletStart.

Sample

This sample set the amount of space between the character number and the paragraph text to 360 twips (a quarter inch).

Procedure DoSetBulletSpacing
    integer iTwipsPerInch

    // number of twips per inch
    move 1440 to iTwipsPerInch

    set piBulletTab to (iTwipsPerInch * 0.25)
End_Procedure  // DoSetBulletSpacing

Last Edited: November 19, 2004


DFBaseRichEdit [Property piFontSize]

piFontSize - DFBaseRichEdit

Sets or returns font size of selected text

Type: Property

Access: Read/Write

Data Type: Integer

Description

Sets or returns the font size of selected text in the control.

This property uses twips, which are 1/1440 of an inch, or 1/20 of a printer's point.

Sample

This sample sets the font size of the selected text in control oRichEdit1 to 14 printer's points.

Procedure SetFontSize
    integer iFontSize iPoints

    // number of printer's points
    move 14 to iPoints

    // 20 twips = 1 printer's point
    set piFontSize of oRichEdit1 to (iPoints * 20)
End_Procedure  // SetFontSize

If you get this property and it is not consistent throughout the selection, it will return the piFontSize value for the first character of the selection, and LastErrorCode will equal ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION.

Sample

This sample gets the value of piFontSize, then checks if piFontSize was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin...end code block.

integer iFontSize iLastErrorCode
get piFontSize to iFontSize
get LastErrorCode to iLastErrorCode
if (iLastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Last Edited: January 12, 2005


DFBaseRichEdit [Property piFontWeight]

piFontWeight - DFBaseRichEdit

Sets or returns font weight of selected text

Type: Property

Access: Read/Write

Data Type: Integer

Description

Sets or returns the font weight of selected text in the control.

FontWeight specifies the weight of the font in the range 0 through 1000. For example, 400 is normal and 700 is bold. If this value is zero, a default weight is used.

The following values are defined for convenience:

FW_DONTCARE
FW_THIN
FW_EXTRALIGHT
FW_ULTRALIGHT
FW_LIGHT
FW_NORMAL
FW_REGULAR
FW_MEDIUM
FW_SEMIBOLD
FW_DEMIBOLD
FW_BOLD
FW_EXTRABOLD
FW_ULTRABOLD
FW_HEAVY
FW_BLACK

Sample

This sample sets the font weight of control oRichEdit 1 to FW_SEMIBOLD.

set FontWeight of oRichEdit1 to FW_SEMIBOLD

If you get this property and it is not consistent throughout the selection, it will return the piFontWeight value for the first character of the selection, and LastErrorCode will equal ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION.

Sample

This sample gets the value of piFontWeight, then checks if piFontWeight was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin...end code block.

integer iFontWeight iLastErrorCode
get piFontWeight to iFontWeight
get LastErrorCode to iLastErrorCode
if (iLastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Last Edited: January 12, 2005


DFBaseRichEdit [Property piLineSpacing]

piLineSpacing - DFBaseRichEdit

Determines exact line spacing of selected paragraph or paragraphs

Type: Property

Access: Read/Write

Data Type: Integer

Description

If any part of a paragraph is selected, this property applies to the entire paragraph. If the cursor is in a paragraph, this property applies to the entire paragraph.

This property uses twips, which are 1/1440 of an inch, or 1/20 of a printer's point.

This property has no effect if control is not paged.

piLineSpacing sets line spacing to a specific number of twips. You can use peLineSpacingType to set line spacing to a predefined spacing, such as single or double.

Sample

This sample determines the current line spacing of the selected paragraph or paragraphs.

Procedure DetermineLineSpacing
    integer iTwips

    get piLineSpacing to iTwips

    send Info_Box (string(iTwips) + " twips") "Current Line Spacing"
End_Procedure  // DetermineLineSpacing

Sample

This sample set the line spacing of the selected paragraph or paragraphs to 12 printer's points.

Procedure SetLineSpacing
    integer iPoints

    move 20 to iPoints

    set piLineSpacing to (iPoints * 12)
End_Procedure  // SetLineSpacing

Last Edited: November 22, 2004


DFBaseRichEdit [Property piMaxChars]

piMaxChars - DFBaseRichEdit

Sets or returns maximum number of characters

Type: Property

Access: Read/Write

Data Type: Integer

Description

The default maximum number of characters for the control is 64 KB (65536 bytes or characters).

Note:
piMaxChars determines the maximum number of visible characters the user can enter into the control. However, when getting the value or saving the value to a database field, the value will contain additional non-visible characters. Each time the user presses Enter or Shift+Enter to break the line, this will be counted as a single visible character, but the value will contain 2 characters, a linefeed character (ASCII 10) followed by a carriage return character (ASCII 13).

OnMaxText fires when the maximum text size the control can contain is exceeded.

Sample

This sample retrieves the maximum number of characters of control oRichEdit1 to iMaxChars.

integer iMaxChars
get piMaxChars of oRichEdit1 to iMaxChars

Sample

This sample sets the maximum number of characters of control oRichEdit1 to 128 KB.

set piMaxChars of oRichEdit1 to (128 * 1024)

Last Edited: December 16, 2004


DFBaseRichEdit [Property piOffsetIndent]

piOffsetIndent - DFBaseRichEdit

Sets or returns indentation of 2nd and subsequent lines, relative to first line, of selected paragraph or paragraphs

Type: Property

Access: Read/Write

Data Type: Integer

Description

Sets or returns the indentation of second and subsequent lines, relative to the indentation of the first line, of selected paragraph or paragraphs.

If any part of a paragraph is selected, this property applies to the entire paragraph. If the cursor is in a paragraph, this property applies to the entire paragraph.

piParagraphIndent sets or returns indentation of selected paragraph or paragraphs.

This property uses twips, which are 1/1440 of an inch, or 1/20 of a printer's point.

This property has no effect if control is not paged.

Sample

This sample indents the selected paragraph or paragraphs by 0.5 inches, and then indents the second and subsequent lines of the selected paragraph or paragraphs 0.5 inches less than the indentation of the first line. This results in a paragraph where the first line is indented, but the rest of the paragraph is not.

Procedure DoOffsetIndent
    integer iTwipsPerInch iCurrentIndent

    // number of twips per inch
    move 1440 to iTwipsPerInch

    // indent 0.5 inches from current indentation
    get piParagraphIndent to iCurrentIndent
    set piParagraphIndent to (iCurrentIndent + (iTwipsPerInch * 0.5))
    // indent 2nd and subsequent lines 0.5 inches from 1st line
    set piOffsetIndent to (iCurrentIndent - (iTwipsPerInch * 0.5))
End_Procedure  // DoOffsetIndent

Last Edited: November 22, 2004


DFBaseRichEdit [Property piParagraphIndent]

piParagraphIndent - DFBaseRichEdit

Sets or returns indentation of selected paragraph or paragraphs

Type: Property

Access: Read/Write

Data Type: Integer

Description

Sets or returns the indentation of selected paragraph or paragraphs.

If any part of a paragraph is selected, this property applies to the entire paragraph. If the cursor is in a paragraph, this property applies to the entire paragraph.

piOffsetIndent sets or returns indentation of 2nd and subsequent lines, relative to first line, of selected paragraph or paragraphs.

This property uses twips, which are 1/1440 of an inch, or 1/20 of a printer's point.

This property has no effect if control is not paged.

Sample

This sample indents the selected paragraph or paragraphs by 0.5 inches, which is the default for most RichEdit programs.

Procedure DoIndent
    integer iTwipsPerInch iCurrentIndent

    // number of twips per inch
    move 1440 to iTwipsPerInch

    // indent 0.5 inches from current indentation
    get piParagraphIndent to iCurrentIndent
    set piParagraphIndent to (iCurrentIndent + (iTwipsPerInch * 0.5))
End_Procedure  // DoIndent

Sample

This sample outdents the selected paragraph or paragraphs by 0.5 inches, which is the default for most RichEdit programs.

Procedure DoOutdent
    integer iTwipsPerInch iCurrentIndent

    // number of twips per inch
    move 1440 to iTwipsPerInch

    // outdent 0.5 inches from current indentation
    get piParagraphIndent to iCurrentIndent
    set piParagraphIndent to (iCurrentIndent - (iTwipsPerInch * 0.5))
End_Procedure  // DoOutdent

Last Edited: November 22, 2004


DFBaseRichEdit [Property piRightMargin]

piRightMargin - DFBaseRichEdit

Determines indentation of right side of control's text, relative to the right margin

Type: Property

Access: Read/Write

Data Type: Integer

Description

If any part of a paragraph is selected, this property applies to the entire paragraph. If the cursor is in a paragraph, this property applies to the entire paragraph.

This property uses twips, which are 1/1440 of an inch, or 1/20 of a printer's point.

This property has no effect if control is not paged.

Sample

This sample increases the right margin of the selected paragraph or paragraphs of control oRichEdit1 by half an inch.

Procedure IncreaseRightMargin
    integer iTwips iCurrentMargin

    // number of twips per inch
    move 1440 to iTwips

    get piRightMargin of oRichEdit1 to iCurrentMargin
    set piRightMargin of oRichEdit1 to (iCurrentMargin + (iTwips * 0.5))
End_Procedure // IncreaseRightMargin

Last Edited: November 24, 2004


DFBaseRichEdit [Property piSpacingAfter]

piSpacingAfter - DFBaseRichEdit

Determines the spacing below selected paragraph or paragraphs

Type: Property

Access: Read/Write

Data Type: Integer

Description

If any part of a paragraph is selected, this property applies to the entire paragraph. If the cursor is in a paragraph, this property applies to the entire paragraph.

This property uses twips, which are 1/1440 of an inch, or 1/20 of a printer's point.

This property has no effect if control is not paged.

Use piSpacingBefore to determine the spacing below selected paragraph or paragraphs.

Sample

This sample increases the spacing below the selected paragraph or paragraphs by half an inch.

Procedure IncreaseSpacingAfter
    integer iTwips iCurrentSpacing

    // number of twips per inch
    move 1440 to iTwips

    get piSpacingAfter to iCurrentSpacing
    set piSpacingAfter to (iCurrentSpacing + (iTwips * 0.5))
End_Procedure // IncreaseSpacingAfter

Last Edited: November 22, 2004


DFBaseRichEdit [Property piSpacingBefore]

piSpacingBefore - DFBaseRichEdit

Determines the spacing above selected paragraph or paragraphs

Type: Property

Access: Read/Write

Data Type: Integer

Description

If any part of a paragraph is selected, this property applies to the entire paragraph. If the cursor is in a paragraph, this property applies to the entire paragraph.

This property uses twips, which are 1/1440 of an inch, or 1/20 of a printer's point.

This property has no effect if control is not paged.

Use piSpacingAfter to determine the spacing below selected paragraph or paragraphs.

Sample

This sample increases the spacing above the selected paragraph or paragraphs by half an inch.

Procedure IncreaseSpacingBefore
    integer iTwips iCurrentSpacing

    // number of twips per inch
    move 1440 to iTwips

    get piSpacingBefore to iCurrentSpacing
    set piSpacingBefore to (iCurrentSpacing + (iTwips * 0.5))
End_Procedure // IncreaseSpacingBefore

Last Edited: November 22, 2004


DFBaseRichEdit [Property psTypeFace]

psTypeFace - DFBaseRichEdit

Sets or returns font typeface of selected text

Type: Property

Access: Read/Write

Data Type: String

Description

Sets or returns the font typeface of the selected text in the control.

Sample

This sample returns the typeface of the selected text in control oRichEdit1 to variable sTypeFace and then displays it in a message box to the user.

Procedure SetTypeFace
    string sTypeFace

    get psTypeFace of oRichEdit1 to psTypeFace

    send Info_Box sTypeFace "Current TypeFace"
End_Procedure  // SetTypeFace

Sample

This sample sets the typeface of the selected text of control oRichEdit1 to Courier.

Procedure SetTypeFace
    set psTypeFace of oRichEdit1 to "Courier"
End_Procedure  // SetTypeFace

If you get this property and it is not consistent throughout the selection, it will return the psTypeFace value for the first character of the selection, and LastErrorCode will equal ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION.

Sample

This sample gets the value of psTypeFace, then checks if psTypeFace was not consistent throughout the selected text by checking if LastErrorCode is equal to ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION. If so, you can do any special handling you wish in the begin...end code block.

integer iLastErrorCode
string sTypeFace

get psTypeFace to sTypeFace
get LastErrorCode to iLastErrorCode
if (iLastErrorCode = ERR_RE_ATTR_INCONSISTENT_THROUGH_SELECTION) begin
    // do something
end

Last Edited: April 28, 2005


DFBaseRichEdit [Property Read_Only_State]

Read_Only_State - DFBaseRichEdit

Determines whether users may edit the content of the control

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Read_Only_State allows protection of the content of the control while still allowing users freedom to navigate and perform operations that do not edit the contents of the control, such as copying text. This is useful for displaying existing text, such as an RTF document, in the control.

Read_Only_State does not prohibit programmatic changes to the control, only changes via the user interface, such as typing, cutting or deleting text.

The Read method reads RTF document and displays it in the control.

Sample

This sample sets control oRichEdit1 to read only.

set Read_Only_State of oRichEdit1 to True

Sample

This sample sets control oRichEdit1 to allow read and write access.

set Read_Only_State of oRichEdit1 to False

Last Edited: November 24, 2004


DFBaseRichEdit [Property TextBackColor]

TextBackColor - DFBaseRichEdit

Sets or returns background color of selected text

Type: Property

Access: Read/Write

Data Type: Integer

Description

Sets or returns the background color of selected text of the control to specified color.

This property has no effect if control is not paged.

Sample

This sample changes the background color of the selected text to yellow.

set TextBackColor to clYellow

Sample

This sample returns the background color of the selected text to variable iBackColor.

integer iBackColor
get TextBackColor to iBackColor

Sample

This sample sets the background color of the selected text to variable iBackColor.

Procedure SetTextBackColor integer iBackColor
    set TextBackColor to iBackColor
End_Procedure  // SetTextBackColor

Last Edited: November 19, 2004


DFBaseRichEdit [Property TextColor]

TextColor - DFBaseRichEdit

Sets or returns color of selected text

Type: Property

Access: Read/Write

Data Type: Integer

Description

Sets or returns the color of selected text of the control to specified color.

This property has no effect if control is not paged.

Sample

This sample changes the color of the selected text to yellow.

set TextColor to clYellow

Sample

This sample retrieves the color of the selected text to variable iTextColor.

integer iTextColor
get TextColor to iTextColor

Sample

This sample sets the color of the selected text to variable iColor.

Procedure SetTextColor integer iColor
    set TextColor to iColor
End_Procedure  // SetTextColor

Last Edited: November 19, 2004


DFBaseRichEdit [Property Value]

Value - DFBaseRichEdit

Sets or returns content of control

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iItem String sValue

Parameter | Description
iItem | [ToDo: In Progress]
sValue | [ToDo: In Progress]

Description

Sets or gets the entire contents of the control, including RTF stream if the text in the control is an RTF stream.

When placing the content of the control into a variable, the full RTF stream of the control is placed into that variable (rather than just the text).
When setting the content of the control, it can be set from either an RTF stream or plain text, and will be converted to an RTF stream.

Use AppendText to append text to the end of the text in the control.
CharCount returns length of RTF stream in the control.

A linefeed (LF) character can be added to text programmatically by adding ASCII character 10 to a string using the character function. A carriage return (CR) character can be added to text programmatically by adding ASCII character 13 to a string using the character function. Either a LF or CR character will break the current line in the control.

Sample

This sample sets the contents of the oRichEdit1 control to "This is line 1", then a line break, then "This is line 2".

Procedure DisplayText
    string sText sLineFeed

    move (character(10)) to sLineFeed
    move ("This is line 1" + sLineFeed + "This is line 2") to sText

    set Value of oRichEdit1 to sText
End_Procedure  // DisplayText

Sample

This sample also sets the contents of the oRichEdit1 control to "Some RTF text". The result is the same as the result of the sample above. The difference is that in this sample, sText contains an RTF stream, whereas in the sample above, sText contained plain text.

Procedure DisplayText
    string sText

    move "{\rtf1\ansi\deff0{\fonttbl{\f0\fswiss\fprq2\fcharset0 MS Sans Serif;}}" to sText
    move (sText + "{\colortbl ;\red0\green0\blue0;}") to sText
    move (sText + "\viewkind4\uc1\pard\cf1\lang1033\f0\fs18 Some RTF text\par}") to sText

    set Value of oRichEdit1 to sText
End_Procedure  // DisplayText

Last Edited: July 11, 2006


Events for DfBasetabDialog

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBasetabDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Auto_Page | Procedure |  |
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


DfBasetabDialog [Procedure Auto_Page]

Auto_Page - DfBasetabDialog

Type: Procedure

Parameters: Handle hoTabPage

Parameter | Description
hoTabPage | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Properties for DfBasetabDialog

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Tooltip_State |  |
Tooltip_Value |  |
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


DfBasetabDialog [Property Tooltip_State]

Tooltip_State - DfBasetabDialog

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: February 13, 2003


DfBasetabDialog [Property Tooltip_Value]

Tooltip_Value - DfBasetabDialog

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iItem String sText

Parameter | Description
iItem | [ToDo: In Progress]
sText | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Events for DfBaseTextbox

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseTextbox

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBaseTextbox

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Justification_Mode | Aligns the text in the control |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


DfBaseTextbox [Property Justification_Mode]

Justification_Mode - DfBaseTextbox

Aligns the text in the control

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer Arg1 Integer iValue

Parameter | Description
Arg1 | [ToDo: In Progress]
iValue | [ToDo: In Progress]

Description

This property aligns the text within the control. When using a mode other than JMode_Left, you will probably want to set Auto_Size_State to false.

Valid modes are:

Mode | Meaning
JMode_Left | Justify text to left
JMode_Center | Justify text in center
JMode_Right | Justify text to right
JMode_VCenter | Justify text to vertical center

You can combine any of the literal values listed above (e.g., JMode_Center + JMode_VCenter). However, try to avoid combinations that conflict (e.g. JMode_Left + JMode_Center).

Sample

This example would center static text both vertically and horizontally.

Set Justification_Mode to (JMode_Center +JMode_VCenter)

Last Edited: January 12, 2006


DFBaseTextEdit [Event OnSelectionChanged]

OnSelectionChanged - DFBaseTextEdit

Fires when selection changes

Type: Event

Parameters: No Parameters

Description

Fires whenever the selected text changes, including when the cursor is moved. If no text is selected, the cursor position is considered the current selection.

Sample

This sample shows how to add Procedure OnSelectionChanged to a class or object in order to intercept this event in order to react to it.

Procedure OnSelectionChanged
    // do something
    :
End_Procedure  // OnSelectionChanged

Last Edited: April 6, 2005


Events for DFBaseTextEdit

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnSelectionChanged | Fires when selection changes |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


DFBaseTextEdit [Function CharCount]

CharCount - DFBaseTextEdit

Returns the number of characters in the control

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Number of characters in the control.

Description

Returns the number of characters in the control.

This function counts each line break as 2 characters (a linefeed character (ASCII 10) followed by a carriage return character (ASCII 13).

Sample

integer iCharCount
get CharCount to iCharCount

Last Edited: December 23, 2004


DFBaseTextEdit [Function FindText]

FindText - DFBaseTextEdit

Searches for specified text in control

Type: Function

Return Data Type: Integer

Parameters: string sTarget integer eSearchOptions

Parameter | Description
sTarget | Text to search for
eSearchOptionsDefines search options. Can be a combination of:

Constant | Meaning
FR_WHOLEWORD | Search only for whole words that match sTarget
FR_MATCHCASE | Search operation is case-sensitive
0 (zero) | Search operation is case-insensitive

Return Value

Position of the first character in sTarget for the first occurrence of sTarget found or -1 if match is not found.

Description

Searches for specified text in the control using the specified option(s).

Search always occurs forward from the end of the current selection or cursor position. To begin searching at the beginning of the control, send Beginning_of_Data to place the cursor at the beginning of the text in the control.

Returns the position of the first character in sTarget for the first occurrence of sTarget found. If sTarget appears in the text more than once, the position of the first character in sTarget of the first occurence of Joe in the text is returned.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, the first position in the second line will be 20.

Returns -1 if match is not found or the position of the first character of the match.

This method has no effect if control is not paged.

Sample

This sample passes FR_MATCHCASE as the eSearchOptions parameter, so it performs a case-sensitive search for "Joe" in all text in the oTextEdit1 control following the current selection or cursor position. If "joe" appears in the portion of the control's text that is searched, -1 will be returned, since only case-sensitive matches of the word "Joe" will be considered successful.

Procedure DoSearch
    string sSearchText
    integer iSearchResult

    move "Joe" to sSearchText

    get FindText of oTextEdit1 sSearchText FR_MATCHCASE to iSearchResult
    // was search successful?
    if (iSearchResult <> -1) begin
        send Info_Box ("Text position: " + string(iSearchResult)) "Text Found"
    end
End_Procedure // DoSearch

Sample

This sample gets the search text from a user via Form oSearchText to variable sSearchText. It then performs a case-sensitive search for sSearchText in all text in the oTextEdit1 control following the current selection or cursor position. If sSearchText appears in the portion of the control's text that is searched, it is selected using the SetSel method. This sample assumes that a Form or dbForm control named oSearchText exists in your code. Also, since the first occurence of sSearchText is now selected, and searches always occur forward from the end of the current selection or cursor position, you can simply call DoSearch again to find the next occurence of sSearchText.

Procedure DoSearch
    string sSearchText
    integer iSelStart iSelEnd

    // get user's search text from form
    get Value of oSearchText to sSearchText

    get FindText of oTextEdit1 sSearchText FR_MATCHCASE to iSelStart
    // was search successful?
    if (iSelStart <> -1) begin
        // get length of search text
        move (length(sSearchText) + iSelStart) to iSelEnd
        // select search text found
        send SetSel of oTextEdit1 iSelStart iSelEnd
    end
End_Procedure // DoSearch

Sample

This sample passes (FR_WHOLEWORD + FR_MATCHCASE) as the eSearchOptions parameter, so it performs a case-sensitive search for the whole word "Joe" in all text in the oTextEdit1 control following the current selection or cursor position. If "Jo" appears in the portion of the control's text that is searched, -1 will be returned, since only matches of the whole word "Joe" will be considered successful.

Procedure DoSearch
    string sSearchText
    integer iSearchResult

    move "Joe" to sSearchText

    get FindText of oTextEdit1 sSearchText (FR_WHOLEWORD + FR_MATCHCASE) to iSearchResult
    // was search successful?
    if (iSearchResult <> -1) begin
        send Info_Box ("Text position: " + string(iSearchResult)) "Text Found"
    end
End_Procedure // DoSearch

Sample

This sample passes 0 (zero) as the eSearchOptions parameter, so it performs a case-insensitive search for "Joe" in all text in the oTextEdit1 control following the current selection or cursor position. If "joe" appears in the portion of the control's text that is searched, the position of its first character will be returned, since matches of any case combination of letters of the "Joe" will be considered successful.

Procedure DoSearch
    string sSearchText
    integer iSearchResult

    move "Joe" to sSearchText

    get FindText of oTextEdit1 sSearchText 0 to iSearchResult
    // was search successful?
    if (iSearchResult <> -1) begin
        send Info_Box ("Text position: " + string(iSearchResult)) "Text Found"
    end
End_Procedure // DoSearch

See Also

ReplaceAll | ReplaceSel

Last Edited: June 22, 2005


DFBaseTextEdit [Function FirstCharInLinePos]

FirstCharInLinePos - DFBaseTextEdit

Returns position of first character in a line

Type: Function

Return Data Type: Integer

Parameters: integer iLine

Parameter | Description
iLine | Number of line (zero-based)

Return Value

Zero-based position of first character in line number iLine.

Description

Returns zero-based position of first character in line number iLine from control.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, the first position in the second line will be 20.

If iLine is -1, returns the position of the first character in the current line. If text is selected, returns position of the first character in the line of the beginning of the selected text.

If iLine is greater than total number of lines in control, function returns -1.

This method has no effect if control is not paged.

Sample

This sample gets the position of the first character in the current line in control oTextEdit1 to variable iFirstCharPos and then displays it to the user in a message box.

Procedure GetFirstCharInCurrentLine
    integer iFirstCharPos iLineNum

    // indicates that we want the current line
    move -1 to iLineNum

    get FirstCharInLinePos of oTextEdit1 iLineNum to iFirstCharPos

    send Info_Box ("Position " + string(iFirstCharPos))
End_Procedure // GetFirstCharInCurrentLine

Last Edited: December 2, 2004


DFBaseTextEdit [Function FirstVisibleLine]

FirstVisibleLine - DFBaseTextEdit

Returns number of first visible line

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Zero-based number of the first visible line.

Description

Returns zero-based number of the first visible line in the control.

This function is useful if the user scrolls down in a document that is longer than the visible area of the control. For example, if the user scrolls down until the first 5 lines of the control are no longer visible, FirstVisibleLine will return 5 (rather than 6, since FirstVisibleLine is zero-based).

This method has no effect if control is not paged.

Sample

This sample gets the first visible line in the oTextEdit1 control and displays it to the user in a message box.

Procedure DetermineFirstVisibleLine
    integer iFirstVisibleLine

    get FirstVisibleLine of oTextEdit1 to iFirstVisibleLine

    send Info_Box ("The first visible line is: " + string(iFirstVisibleLine))
End_Procedure  // DetermineFirstVisibleLine

Last Edited: December 2, 2004


DFBaseTextEdit [Function LastErrorCode]

LastErrorCode - DFBaseTextEdit

Returns error code for last operation

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Error code for the last operation.

Description

Returns the error code for the last operation.

Possible return values are:

Constant | Meaning
ERR_RE_SUCCESS | Success, operation successful, no error condition
ERR_RE_FNAME_TOO_LONG | File name is too long
ERR_RE_CANNOT_OPEN_FILE | Cannot open file

Sample

This sample gets the name of a text file from a form named oFileNameForm and calls the Read method of the oTextEdit1 control to open that file. It then checks to see if the control was able to open the file by checking the LastErrorCode. If LastErrorCode returns ERR_RE_CANNOT_OPEN_FILE, it displays an error message to the user.

Procedure ReadFile
    string sFileName
    integer iLastErrorCode

    get Value of oFileNameForm to sFileName

    send Read of oTextEdit1 sFileName
    get LastErrorCode of oTextEdit1 to iLastErrorCode
    if (iLastErrorCode = ERR_RE_CANNOT_OPEN_FILE) begin
        send Stop_Box "Cannot open file" "ERROR"
    end
End_Procedure  // ReadFile

Last Edited: December 2, 2004


DFBaseTextEdit [Function Line]

Line - DFBaseTextEdit

Returns specified line of text

Type: Function

Return Data Type: String

Parameters: integer iLine

Parameter | Description
iLine | Number of line (zero-based)

Return Value

Text of specified line in control.

Description

Returns line with zero-based number iLine from control.

This method has no effect if control is not paged.

Sample

This sample gets the text of the current line in control oTextEdit1 and displays it to the user in a message box. The current line number is determined by calling function LineFromChar with a -1 parameter.

Procedure DisplayCurrentLine
    integer iLineNum iCurrentLineNum
    string sLine

    // indicates that we want the current line
    move -1 to iLineNum

    // get the line number of the current line
    get LineFromChar of oTextEdit1 iLineNum to iCurrentLineNum
    // get the text of the current line
    get Line of oTextEdit1 iCurrentLineNum to sLine

    send Info_Box sLine ("Line number " + string(iCurrentLineNum))
End_Procedure // DisplayCurrentLine

Last Edited: December 2, 2004


DFBaseTextEdit [Function LineFromChar]

LineFromChar - DFBaseTextEdit

Returns number of line that contains specified character position or current line

Type: Function

Return Data Type: Integer

Parameters: integer iCharPos

Parameter | Description
iCharPos | Position of character

Return Value

Zero-based number of the line that contains specified character position (iCharPos) or current line.

Description

Returns zero-based number of the line that contains specified character position (iCharPos) or current line.

If iCharPos is -1, returns the line number of the current line. If text is selected, returns the line number of the beginning of the selected text.

If iCharPos is greater than total number of lines in control, function returns -1.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, the first position in the second line will be 20.

This method has no effect if control is not paged.

Sample

This sample gets the text of the current line in control oTextEdit1 and displays it to the user in a message box. The current line text is retrieved by calling function Line with the current line number.

Procedure DisplayCurrentLine
    integer iFirstCharPos iLineNum iCurrentLineNum
    string sLine

    // indicates that we want the current line
    move -1 to iLineNum

    // get the line number of the current line
    get LineFromChar of oTextEdit1 iLineNum to iCurrentLineNum
    // get the text of the current line
    get Line of oTextEdit1 iCurrentLineNum to sLine

    send Info_Box sLine ("Line number " + string(iCurrentLineNum))
End_Procedure // DisplayCurrentLine

Last Edited: December 2, 2004


DFBaseTextEdit [Function LineLength]

LineLength - DFBaseTextEdit

Returns number of characters in line

Type: Function

Return Data Type: Integer

Parameters: Integer iLine

Parameter | Description
iLine | [ToDo: In Progress]

Return Value

Number of characters in line number iLine.

Description

Returns the number of characters in line number iLine.

If iLine is -1, returns the number of characters in the current line. If text is selected, returns number of characters in the line of the beginning of the selected text.

If iLine is greater than total number of lines in control, function returns -1.

This method has no effect if control is not paged.

Sample

This sample gets the length of the current line in control oTextEdit1 and displays it to the user in a message box.

Procedure DisplayCurrentLineAndCount
    integer iLineLength

    // get the length of the current line
    get LineLength of oTextEdit1 -1 to iLineLength

    send Info_Box (string(iLineLength)) "Length of current line"
End_Procedure // DisplayCurrentLineAndCount

Sample

This sample gets the text and length of the current line in control oTextEdit1 and displays it to the user in a message box. The current line number is determined by calling function LineFromChar with a -1 parameter.

Note:
In this sample, the current line number is determined by calling function LineFromChar with a -1 parameter. LineLength is then called with the current line number. The simpler sample above achieves the same result by passing -1 to LineLength.

Procedure DisplayCurrentLineAndCount
    integer iLineNum iCurrentLineNum iLineLength
    string sLine

    // indicates that we want the current line
    move -1 to iLineNum

    // get the line number of the current line
    get LineFromChar of oTextEdit1 iLineNum to iCurrentLineNum
    // get the text of the current line
    get Line of oTextEdit1 iCurrentLineNum to sLine
    // get the length of the current line
    get LineLength of oTextEdit1 iCurrentLineNum to iLineLength

    send Info_Box sLine ("Length of current line: " + string(iLineLength))
End_Procedure // DisplayCurrentLineAndCount

Last Edited: December 29, 2005


DFBaseTextEdit [Function RedoType]

RedoType - DFBaseTextEdit

Returns type of redo operation at top of redo queue

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Type of redo operation at the top of the redo queue.

Description

Returns the type of redo operation at the top of the redo queue.

If the redo queue for the control is not empty, the value returned indicates the type of the next action in the control's redo queue.
If there are no redoable actions or the type of the next redoable action is unknown, the return value is zero (Unknown).

The types of actions that can be undone or redone include typing, delete, drag-drop, cut, and paste operations. This information can be useful for applications that provide an extended user interface for undo and redo operations, such as a drop-down list box of redoable actions

This function has no effect if control is not paged.

Possible return values are:

Constant | Meaning
utUnknown | Unknown
utTyping | Typing
utDelete | Delete
utDragDrop | Drag and Drop
utCut | Cut
utPaste | Paste

Sample

This sample determines the next redo operation type available for control oTextEdit1 and displays it to the user in a message box.

Procedure CheckRedoType
    integer iRedoType
    string sRedoType

    get RedoType of oTextEdit1 to iRedoType

    if (iRedoType = utUnknown) ;
        send Info_Box "No redo operations available"
    else begin
        if (iRedoType = utTyping) move "Typing" to sRedoType
        else if (iRedoType = utDelete) move "Delete" to sRedoType
        else if (iRedoType = utDragDrop) move "DragDrop" to sRedoType
        else if (iRedoType = utCut) move "Cut" to sRedoType
        else if (iRedoType = utPaste) move "Paste" to sRedoType

        send Info_Box sRedoType "Next Redo operation available"
    end
End_Procedure  // CheckRedoType

Last Edited: December 2, 2004


DFBaseTextEdit [Function ReplaceAll]

ReplaceAll - DFBaseTextEdit

Replaces all occurences of sTarget with sReplacement and returns the number of replacements

Type: Function

Return Data Type: Integer

Parameters: string sTarget string sReplacement

Parameter | Description
sTarget | String to be replaced with sReplacement
sReplacement | String to take the place of sTarget

Return Value

Number of replacements made. If no repalcements were made, returns 0.

Description

Replaces all occurences of sTarget with sReplacement in control and returns the number of replacements made.

This method has no effect if control is not paged.

Sample

This sample replaces all occurences of "Mike" in control oTextEdit1 with "Michael" and then displays the number of replacements made in a message box to the user.

Procedure ReplaceAll
    integer iReplacementCount

    get ReplaceAll of oTextEdit1 "Mike" "Michael" to iReplacementCount

    send Info_Box (string(iReplacementCount) + " replacements performed")
End_Procedure // ReplaceAll

Last Edited: December 2, 2004


DFBaseTextEdit [Function SelEnd]

SelEnd - DFBaseTextEdit

Returns end of selection

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Ending position of selection.

Description

Returns ending position of selection.

Returns the last character position inside the selection. If no text is selected, returns the current position of the caret.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, and the selected text is characters 5 through 10 of the second line, the return value of SelEnd will be 30.

Sample

This sample gets the beginning and ending position of the selected text of control oTextEdit1 and then displays the range to the user in a message box.

Procedure ShowSelectionRange
    integer iSelStart iSelEnd

    get SelStart of oTextEdit1 to iSelStart
    get SelEnd of oTextEdit1 to iSelEnd

    send Info_Box (string(iSelStart) + " to " + string(iSelEnd)) "Range of selected text"
End_Procedure  // ShowSelectionRange

Last Edited: June 20, 2005


DFBaseTextEdit [Function SelStart]

SelStart - DFBaseTextEdit

Returns beginning position of selection

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Beginning position of selection.

Description

Returns beginning position of selection.

Returns the first character position inside the selection. If no text is selected, returns the current position of the caret.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. So, if the first line in the control contains 20 characters, and the selected text is characters 5 through 10 of the second line, the return value of SelStart will be 25.

Sample

This sample gets the beginning and ending position of the selected text of control oTextEdit1 and then displays the seletion range (or length) to the user in a message box.

Procedure ShowSelectionRange
    integer iSelStart iSelEnd

    get SelStart of oTextEdit1 to iSelStart
    get SelEnd of oTextEdit1 to iSelEnd

    send Info_Box (string(iSelStart) + " to " + string(iSelEnd)) "Range of selected text"
End_Procedure  // ShowSelectionRange

Last Edited: June 20, 2005


DFBaseTextEdit [Function SelText]

SelText - DFBaseTextEdit

Returns selected text

Type: Function

Return Data Type: String

Parameters: No Parameters

Return Value

Selected text of the control.

Description

Returns the selected text of the control.

This method has no effect if control is not paged.

Sample

This sample gets the selected text of the oTextEdit1 control to variable sSelectedText and then displays it to the user in a message box.

Procedure ShowSelectedText
    string sSelectedText

    get SelText of oTextEdit1 to sSelectedText

    send Info_Box sSelectedText "Selected Text"
End_Procedure // ShowSelectedText

Last Edited: December 2, 2004


DFBaseTextEdit [Function TextRange]

TextRange - DFBaseTextEdit

Returns text in given position range

Type: Function

Return Data Type: String

Parameters: integer iPositionStart integer iPositionEnd

Parameter | Description
iPositionStart | The starting position of the text
iPositionEnd | The ending position of the text

Return Value

Text between the starting and ending positions.

Description

Returns the text between the starting and ending positions (iPositionStart and iPositionEnd).

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, the first position in the second line will be 20.

Sample

This sample retrieves the text in a range of positions in control oTextEdit1 and displays it to the user in a message box.

Procedure DisplayTextInRange integer iPositionStart integer iPositionEnd
    string sText

    get TextRange of oTextEdit1 iPositionStart iPositionEnd to sText

    if (sText <> "") ;
        send Info_Box sText ("Text in range " + string(iPositionStart) + " to " + string(iPositionEnd))
End_Procedure  // DisplayTextInRange

Last Edited: December 2, 2004


DFBaseTextEdit [Function UndoType]

UndoType - DFBaseTextEdit

Returns type of undo operation at top of undo queue

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Type of undo operation at the top of the undo queue.

Description

Returns the type of undo operation at the top of the undo queue.

If the undo queue for the control is not empty, the value returned indicates the type of the next action in the control's undo queue.
If there are no undoable actions or the type of the next undoable action is unknown, the return value is zero (Unknown).

The types of actions that can be undone or redone include typing, delete, drag-drop, cut, and paste operations. This information can be useful for applications that provide an extended user interface for undo and redo operations, such as a drop-down list box of redoable actions

This function has no effect if control is not paged.

Possible return values are:

Constant | Meaning
utUnknown | Unknown
utTyping | Typing
utDelete | Delete
utDragDrop | Drag and Drop
utCut | Cut
utPaste | Paste

Sample

This sample determines the next undo operation type available for control oTextEdit1 and displays it to the user in a message box.

Procedure CheckUndoType
    integer iUndoType
    string sUndoType

    get UndoType of otextEdit1 to iUndoType

    if (iUndoType = utUnknown) ;
        send Info_Box "No undo operations available"
    else begin
        if (iUndoType = utTyping) move "Typing" to sUndoType
        else if (iUndoType = utDelete) move "Delete" to sUndoType
        else if (iUndoType = utDragDrop) move "DragDrop" to sUndoType
        else if (iUndoType = utCut) move "Cut" to sUndoType
        else if (iUndoType = utPaste) move "Paste" to sUndoType

        send Info_Box sUndoType "Next Undo operation available"
    end
End_Procedure  // CheckUndoType

Last Edited: December 2, 2004


Methods for DFBaseTextEdit

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
AppendText | Procedure | Appends text to end of text in control |
Beginning_of_Data | Procedure | Places the cursor at beginning of the text in control |
Beginning_of_Line | Procedure | Places the cursor at beginning of current line |
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
CharCount | Function | Returns the number of characters in the control |
ClearUndoBuffer | Procedure | Clears undo buffer |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Deletes all data in control |
Destroy | Procedure |  | cObject
End_of_Data | Procedure | Places the cursor at end of the text in control |
End_of_Line | Procedure | Places the cursor at end of current line |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
FindText | Function | Searches for specified text in control |
FirstCharInLinePos | Function | Returns position of first character in a line |
FirstVisibleLine | Function | Returns number of first visible line |
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
HideSelection | Procedure | Toggles selection highlighting on or off |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
LastErrorCode | Function | Returns error code for last operation |
Line | Function | Returns specified line of text |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
LineFromChar | Function | Returns number of line that contains specified character position or current line |
LineLength | Function | Returns number of characters in line |
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Read | Procedure | Reads text file and displays it in the control |
Redo | Procedure | Redoes the last operation |
RedoType | Function | Returns type of redo operation at top of redo queue |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
ReplaceAll | Function | Replaces all occurences of sTarget with sReplacement and returns the number of replacements |
ReplaceSel | Procedure | Replaces selected text with specified text |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls up or down the control using specified scroll mode |
ScrollCaret | Procedure | Scrolls caret into view |
ScrollLines | Procedure | Scrolls control vertically for specified number of lines |
Select_All | Procedure | Selects entire contents of control |
SelEnd | Function | Returns end of selection |
SelStart | Function | Returns beginning position of selection |
SelText | Function | Returns selected text |
SetSel | Procedure | Selects text in given position range |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
TextRange | Function | Returns text in given position range |
Undo | Procedure | Undoes the last operation |
UndoType | Function | Returns type of undo operation at top of undo queue |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes text file content of control to file |


DFBaseTextEdit [Procedure AppendText]

AppendText - DFBaseTextEdit

Appends text to end of text in control

Type: Procedure

Parameters: string sText

Parameter | Description
sText | Text to append to control text

Description

Adds text to the end of the text in the control.

This method has no effect if control is not paged.

Use Value to set or get the entire content of the control.

A linefeed (LF) character can be added to text programmatically by adding ASCII character 10 to a string using the character function. A carriage return (CR) character can be added to text programmatically by adding ASCII character 13 to a string using the character function. Either a LF or CR character will break the current line in the control.

Sample

This sample adds a "This is line1", a linefeed character and "This is line 2" to the end of the text in the oTextEdit1 control.

Procedure AddToText
    string sLineFeed

    move (character(10)) to sLineFeed

    send AppendText of oTextEdit1 "This is line 1"
    send AppendText of oTextEdit1 sLineFeed
    send AppendText of oTextEdit1 "This is line 2"
End_Procedure  // AddToText

Last Edited: February 22, 2005


DFBaseTextEdit [Procedure Beginning_of_Data]

Beginning_of_Data - DFBaseTextEdit

Places the cursor at beginning of the text in control

Type: Procedure

Parameters: No Parameters

Description

Places the cursor at the beginning of the text in the control.

Sample

This sample sets the contents of the oTextEdit1 control to "Some text" and then places the cursor at the beginning of the text in the control

Procedure DisplayText
    string sText

    move "Some text" to sText

    set Value of oTextEdit1 to sText
    send Beginning_of_Data of oTextEdit1
End_Procedure  // DisplayText

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure Beginning_of_Line]

Beginning_of_Line - DFBaseTextEdit

Places the cursor at beginning of current line

Type: Procedure

Parameters: No Parameters

Description

Places the cursor at the beginning of the current line (the line the cursor is currently in) in the control.

If text is selected, places the cursor at the beginning of the line at the beginning of the selected text.

Sample

This sample places the cursor at the beginning of the current line in control oTextEdit1.

send Beginning_of_Line of oTextEdit1

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure ClearUndoBuffer]

ClearUndoBuffer - DFBaseTextEdit

Clears undo buffer

Type: Procedure

Parameters: No Parameters

Description

Clears the undo buffer of the control. Immediately after this call, there are no undo or redo operations to be performed.

This method has no effect if control is not paged.

Sample

This sample clears the undo buffer of control oTextEdit1.

send ClearUndoBuffer of oTextEdit1

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure Delete_Data]

Delete_Data - DFBaseTextEdit

Deletes all data in control

Type: Procedure

Parameters: No Parameters

Description

Deletes all data in the control.

This method has no effect if control is not paged.

Sample

This sample deletes all data in control oTextEdit1.

send Delete_Data of oTextEdit1

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure End_of_Data]

End_of_Data - DFBaseTextEdit

Places the cursor at end of the text in control

Type: Procedure

Parameters: No Parameters

Description

Places the cursor at the end of the text in the control.

Sample

This sample places the cursor at the end of the text in the control

send End_of_Data of oTextEdit1

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure End_of_Line]

End_of_Line - DFBaseTextEdit

Places the cursor at end of current line

Type: Procedure

Parameters: No Parameters

Description

Places the cursor at the end of the current line (the line the cursor is currently in) in the control.

If text is selected, places the cursor at the end of the line at the end of the selected text.

Sample

This sample places the cursor at the end of the current line in control oTextEdit1.

send End_of_Line of oTextEdit1

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure HideSelection]

HideSelection - DFBaseTextEdit

Toggles selection highlighting on or off

Type: Procedure

Parameters: Boolean bHideSelection

Parameter | Description
bHideSelection | [ToDo: In Progress]

Description

Toggles selection highlighting on or off.

This method has no effect if control is not paged.

Sample

This sample changes the selection highlighting of control oTextEdit1 to be off.

send HideSelection of oTextEdit1 False

Sample

This sample changes the selection highlighting of control oTextEdit1 to be on.

send HideSelection of oTextEdit1 True

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure Read]

Read - DFBaseTextEdit

Reads text file and displays it in the control

Type: Procedure

Parameters: String sFileName

Parameter | Description
sFileName | The name (and path to) of the text file to read

Description

Reads a text file and displays it in the control. Calling read will replace all text currently in the control with the contents of sFileName.

Sample

This sample reads a file named MyFile.txt and displays its content in the oTextEdit1 control.

Procedure ReadFile
    string sFileName

    move "MyFile.txt" to sFileName

    send Read of oTextEdit1 sFileName
End_Procedure  // ReadFile

Sample

This sample allows the user to select a file using an OpenDialog control, and then displays the content of the document the user has selected in the oTextEdit1 control. This sample assumes that an OpenDialog control named oOpenDialog1 exists in your code.

Procedure ReadFile
    string sFileName

    set Filter_String of oOpenDialog1 to 'Text Files (*.txt)|*.txt|All Files (*.*)|*.*'
    get Show_Dialog of oOpenDialog1 To bOk
    if (bOk = True) begin
        get File_Name of oOpenDialog1 to sFileName
        send Read of oTextEdit1 sFileName
    end
End_Procedure  // ReadFile

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure Redo]

Redo - DFBaseTextEdit

Redoes the last operation

Type: Procedure

Parameters: No Parameters

Description

This property has no effect if control is not paged.

Sample

This sample redoes the last operation of control oTextEdit1.

send Redo of oTextEdit1

Sample

This sample checks if a redo operation can be performed in the oTextEdit1 control using pbCanRedo. If so, it sends the Redo message to the control.

Procedure RedoIfPossible
    if (pbCanRedo(oTextEdit1) = True) ;
        send Redo of oTextEdit1
End_Procedure  // RedoIfPossible

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure ReplaceSel]

ReplaceSel - DFBaseTextEdit

Replaces selected text with specified text

Type: Procedure

Parameters: string sText

Parameter | Description
sText | Text to replace selected text with

Description

Replaces selected text with sText. If no text is selected, it inserts the text at the current caret position.

This method has no effect if control is not paged.

Sample

This sample replaces the selected text in control oTextEdit1 with "Michael".

send ReplaceSel of oTextEdit1 "Michael"

Sample

This sample gets the search text from a user via Form oSearchText to variable sSearchText and the text to replace the found text from a user via Form oReplaceText to variable sReplaceText . It then performs a case-sensitive search using FindText for sSearchText in all text in the oTextEdit1 control following the current selection or cursor position. If sSearchText appears in the portion of the control's text that is searched, it is selected using the SetSel method. This sample assumes that Form or dbForm controls named oSearchText and oReplaceText exists in your code.

Procedure DoSearch
    string sSearchText sReplaceText
    integer iSelStart iSelEnd

    // get user's search text from form
    get Value of oSearchText to sSearchText
    // get user's replace text from form
    get Value of oReplaceText to sReplaceText

    get FindText of oTextEdit1 sSearchText FR_MATCHCASE to iSelStart
    // was search successful?
    if (iSelStart <> -1) begin
        // get length of search text
        move (length(sSearchText) + iSelStart) to iSelEnd
        // select search text found
        send SetSel of oTextEdit1 iSelStart iSelEnd

        // now, replace the selected text
        send ReplaceSel of oTextEdit1 sReplaceText
    end
End_Procedure // DoSearch

Last Edited: July 26, 2005


DFBaseTextEdit [Procedure Scroll]

Scroll - DFBaseTextEdit

Scrolls up or down the control using specified scroll mode

Type: Procedure

Parameters: integer eScrollMode

Parameter | Description
eScrollMode | [ToDo: In Progress]

Description

Scrolls up or down the control using the specified eScrollMode.

Sample

This sample scrolls the oTextEdit1 control down one page.

send Scroll of oTextEdit1 SB_PAGEDOWN

Sample

This sample scrolls the oTextEdit1 control using the specified eScrollMode.

Procedure DoScroll integer eScrollMode
    send Scroll of oTextEdit1 eScrollMode
End_Procedure  // DoScroll

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure ScrollCaret]

ScrollCaret - DFBaseTextEdit

Scrolls caret into view

Type: Procedure

Parameters: No Parameters

Description

Scrolls caret into view. If the user has scrolled up or down in the control so that the caret is no longer visible, ScrollCaret will scroll the control until the caret is in the viewable area of the control.

Sample

This sample scrolls the caret into the viewable area of the oTextEdit1 control

send ScrollCaret of oTextEdit1

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure ScrollLines]

ScrollLines - DFBaseTextEdit

Scrolls control vertically for specified number of lines

Type: Procedure

Parameters: integer iLines

Parameter | Description
iLines | Number of lines to scroll

Description

Scrolls control vertically for iLines number of lines.

If iLines is positive, control scrolls down.
If iLines is negative, control scrolls up.

This method has no effect if control is not paged.

Sample

This sample scrolls control oTextEdit1 down 20 lines.

send ScrollLines of oTextEdit1 20

Sample

This sample scrolls control oTextEdit1 up 20 lines.

send ScrollLines of oTextEdit1 -20

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure Select_All]

Select_All - DFBaseTextEdit

Selects entire contents of control

Type: Procedure

Parameters: No Parameters

Description

Selects entire contents of control.

This method has no effect if control is not paged.

Sample

The sample selects entire contents of control oTextEdit1.

send Select_All of oTextEdit1

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure SetSel]

SetSel - DFBaseTextEdit

Selects text in given position range

Type: Procedure

Parameters: integer iPositionStart integer iPositionEnd

Parameter | Description
iPositionStart | [ToDo: In Progress]
iPositionEnd | [ToDo: In Progress]

Description

Selects text in control in given position range.

Selects text from character immediately after position iPositionStart to character in the position iPositionEnd.

If iPositionStart is equal to iPositionEnd, the selection range is empty, so caret will be placed immediately after position iPositionStart.
If iPositionStart is equal to 0, and iPositionEnd is -1, the entire text is selected.

The character position is the zero-based absolute position of the character in the control. The first position in the first line is always 0. If the first line in the control contains 20 characters, the first position in the second line will be 20.

This method has no effect if control is not paged.

Sample

This sample gets the search text from a user via Form oSearchText to variable sSearchText. It then performs a case-sensitive search for sSearchText in all text in the oTextEdit1 control following the current selection or cursor position. If sSearchText appears in the portion of the control's text that is searched, it is selected (highlighted) using the SetSel method. This sample assumes that a Form or dbForm control named oSearchText exists in your code. Also, since the first occurence of sSearchText is now selected, and searches always occur forward from the end of the current selection or cursor position, you can simply call DoSearch again to find the next occurence of sSearchText.

Procedure DoSearch
    integer iSelStart iSelEnd

    send SetSel of oTextEdit1 iSelStart iSelEnd
End_Procedure // DoSearch

Sample

This sample performs a case-sensitive search for "Joe" in the oTextEdit1 control using the FindText method. If "Joe" appears in the portion of the control's text that is searched, it is selected using SetSel. This sample assumes that a Form or dbForm control named oSearchText exists in your code.

Note:
A more sophisticated version of this sample can be found in the FindText method documentation.

Procedure DoSearch
    integer iSelStart iSelEnd

    get FindText of oTextEdit1 "Joe" FR_MATCHCASE to iSelStart
    // was search successful?
    if (iSelStart <> -1) begin
        // get length of search text
        move (length(sSearchText) + iSelStart) to iSelEnd
        // select search text found
        send SetSel of oTextEdit1 iSelStart iSelEnd
    end
End_Procedure // DoSearch

Last Edited: December 2, 2004


DFBaseTextEdit [Procedure Undo]

Undo - DFBaseTextEdit

Undoes the last operation

Type: Procedure

Parameters: No Parameters

Description

This property has no effect if control is not paged.

Sample

This sample undoes the last operation of control oTextEdit1.

send Undo of oTextEdit1

Sample

This sample checks if an undo operation can be performed in the oTextEdit1 control using pbCanUndo. If so, it sends the Undo message to the control.

Procedure UndoIfPossible
    if (pbCanUndo(oTextEdit1) = True) ;
        send Undo of oTextEdit1
End_Procedure  // UndoIfPossible

Last Edited: November 24, 2004


DFBaseTextEdit [Procedure Write]

Write - DFBaseTextEdit

Writes text file content of control to file

Type: Procedure

Parameters: String sFileName

Parameter | Description
sFileName | The name (and path to) of the text file to write

Description

Writes the entire content of control to file specified by sFileName.

Sample

This sample writes the entire content of control oTextEdit1 to a document named MyFile.txt.

Procedure ReadFile
    string sFileName

    move "MyFile.txt" to sFileName

    send Write of oTextEdit1 sFileName
End_Procedure  // ReadFile

Sample

This sample allows the user to select a document using an SaveAsDialog control, and then writes the entire content of control oTextEdit1 to the document name the user has specified in the SaveAsDialog. This sample assumes that a SaveAsDialog control named oSaveAsDialog1 exists in your code.

Procedure ReadFile
    string sFileName

    set Filter_String of oSaveAsDialog1 to 'Text Files (*.txt)|*.txt|All Files (*.*)|*.*'
    get Show_Dialog of oSaveAsDialog1 To bOk
    if (bOk = True) begin
        get File_Name of oSaveAsDialog1 to sFileName
        send Write of oTextEdit1 sFileName
    end
End_Procedure  // ReadFile

Last Edited: June 20, 2005


Properties for DFBaseTextEdit

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of lines in control |
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
paValue | Sets content of control from memory address or places text in control into memory address |
pbBold | Toggles all text in control between bold and normal text |
pbCanPaste | Determines whether paste operation can be performed with current format in clipboard |
pbCanRedo | Determines whether a redo operation can be performed |
pbCanUndo | Determines whether an undo operation can be performed |
pbItalics | Toggles all text in control between italic and normal text |
pbWrap | Determines whether text input will break and wrap to the next line at right margin |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piFontSize | Sets or returns font size of all text in control |
piFontWeight | Sets or returns font weight of all text in control |
piMaxChars | Sets or returns maximum number of visible characters |
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piRightMargin | Determines indentation of right side of control's text, relative to the right margin |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psTypeFace | Sets or returns font typeface of all text in control |
Read_Only_State | Determines whether users may edit the content of the control |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Sets or returns content of control |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


DFBaseTextEdit [Property Line_Count]

Line_Count - DFBaseTextEdit

Returns number of lines in control

Type: Property

Access: Read-Only

Data Type: Integer

Description

Line_Count returns the number of lines of text displayed in control.

This method has no effect if control is not paged (returns zero).

Sample

This sample gets the number of lines displayed in control oTextEdit1 and displays it to the user in a message box.

Procedure DisplayCurrentLineCount
    integer iNumberOfLines

    // get the length of the current line
    get Line_Count of oTextEdit1 to iNumberOfLines

    send Info_Box (string(iNumberOfLines)) "Number of lines"
End_Procedure // DisplayCurrentLineCount

Last Edited: November 8, 2006


DFBaseTextEdit [Property paValue]

paValue - DFBaseTextEdit

Sets content of control from memory address or places text in control into memory address

Type: Property

Access: Read/Write

Data Type: Address

Description

Sets content of a control from memory address or places text in control into memory address.

Sample

This sample sets the contents of control oTextEdit1 to the text contained in string variable sText.

Procedure GetControlContents
    address aMyAddress
    string sText

    move "Some text" to sText

    GetAddress of sText to aMyAddress
    set paValue of oTextEdit1 to aMyAddress
End_Procedure  // GetControlContents

Sample

This sample moves the contents of control oTextEdit1 into the memory address in address variable aMyAddress.

Procedure SetControlContents
    address aMyAddress
    string sText

    get paValue of oTextEdit1 to aMyAddress
    move aMyAddress to sText
End_Procedure  // SetControlContents

Last Edited: November 24, 2004


DFBaseTextEdit [Property pbBold]

pbBold - DFBaseTextEdit

Toggles all text in control between bold and normal text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Toggles all text in the control between bold and normal text.

This property has no effect if control is not paged.

Sample

This sample changes the font of the text in control oTextEdit1 to bold.

set pbBold of oTextEdit1 to True

Sample

This sample changes the font of the text in control oTextEdit1 to normal (non-bold).

set pbBold of oTextEdit1 to False

Last Edited: June 20, 2005


DFBaseTextEdit [Property pbCanPaste]

pbCanPaste - DFBaseTextEdit

Determines whether paste operation can be performed with current format in clipboard

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Determines whether the contents of the clipboard in the current format can be pasted into the control.

This property has no effect if control is not paged.

Sample

This sample checks if the contents of the clipboard in the current format can be pasted into the oTextEdit1 control. If so, it sends the Paste message to the control.

Procedure PasteIfPossible
    if (pbCanPaste(oTextEdit1) = True) ;
        send Paste of oTextEdit1
End_Procedure // PasteIfPossible

Last Edited: November 24, 2004


DFBaseTextEdit [Property pbCanRedo]

pbCanRedo - DFBaseTextEdit

Determines whether a redo operation can be performed

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Determines whether a redo operation can be performed in the control.

This property has no effect if control is not paged.

Sample

This sample checks if a redo operation can be performed in the oTextEdit1 control. If so, it sends the Redo message to the control.

Procedure RedoIfPossible
    if (pbCanRedo(oTextEdit1) = True) ;
        send Redo of oTextEdit1
End_Procedure // RedoIfPossible

Last Edited: November 24, 2004


DFBaseTextEdit [Property pbCanUndo]

pbCanUndo - DFBaseTextEdit

Determines whether an undo operation can be performed

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Determines whether an undo operation can be performed in the control.

This property has no effect if control is not paged.

Sample

This sample checks if an undo operation can be performed in the oTextEdit1 control. If so, it sends the Undo message to the control.

Procedure UndoIfPossible
    if (pbCanUndo(oTextEdit1) = True) ;
        send Undo of oTextEdit1
End_Procedure // UndoIfPossible

Last Edited: November 24, 2004


DFBaseTextEdit [Property pbItalics]

pbItalics - DFBaseTextEdit

Toggles all text in control between italic and normal text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Toggles all text in the control between italic and normal text.

This property has no effect if control is not paged.

Sample

This sample changes the font of the text in control oTextEdit1 to italic.

set pbItalics of oTextEdit1 to True

Sample

This sample changes the font of the text in control oTextEdit1 to normal (non-italic).

set pbItalics of oTextEdit1 to False

Last Edited: June 20, 2005


DFBaseTextEdit [Property pbWrap]

pbWrap - DFBaseTextEdit

Determines whether text input will break and wrap to the next line at right margin

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Determines whether text input will break and wrap to the next line at the right margin of this object, or will continue onward on the same line until a carriage return/linefeed is entered.

A text edit control calls a function called a word-break procedure to find breaks between words and to determine where it can break lines. Word-break procedures for this control can determine whether a character is a delimiter and can find the nearest word break before or after the specified position. A delimiter is a character that marks the end of a word, such as a space. The control uses this information when performing word-wrap operations and when processing Ctrl+Left Arrow and Ctrl+Right Arrow key combinations.

A linefeed (LF) character can be added to text programmatically by adding ASCII character 10 to a string using the character function. A carriage return (CR) character can be added to text programmatically by adding ASCII character 13 to a string using the character function. Either a LF or CR character will break the current line in the control.

Sample

This sample turns on word wrapping of the control.

set pbWrap to True

Sample

This sample turns off word wrapping of the control.

set pbWrap to False

Sample

This sample adds linefeed characters to the end of lines of text to force a break of a long text string into multiple lines, then adds the text to the existing text of control oTextEdit1 using AppendText.

Procedure AddSomeText
    string sLineFeed sText

    move (character(10)) to sLineFeed

    move ("Procedure DoSomething"+sLinefeed) to sText
    move (sText+"    // add code here"+sLinefeed) to sText
    move (sText+"End_Procedure  // DoSomething"+sLinefeed) to sText

    send AppendText of oTextEdit1 sText
End_Procedure  // AddSomeText

Last Edited: February 22, 2005


DFBaseTextEdit [Property piFontSize]

piFontSize - DFBaseTextEdit

Sets or returns font size of all text in control

Type: Property

Access: Read/Write

Data Type: Integer

Description

Sets or returns the font size of all text in the control.

This property uses twips, which are 1/1440 of an inch, or 1/20 of a printer's point.

Sample

This sample sets the font size of the text in control oTextEdit1 to 14 printer's points.

Procedure SetFontSize
    integer iFontSize iPoints

    // number of printer's points
    move 14 to iPoints

    // 20 twips = 1 printer's point
    set piFontSize of oTextEdit1 to (iPoints * 20)
End_Procedure  // SetFontSize

Last Edited: June 20, 2005


DFBaseTextEdit [Property piFontWeight]

piFontWeight - DFBaseTextEdit

Sets or returns font weight of all text in control

Type: Property

Access: Read/Write

Data Type: Integer

Description

Sets or returns the font weight of all text in the control.

FontWeight specifies the weight of the font in the range 0 through 1000. For example, 400 is normal and 700 is bold. If this value is zero, a default weight is used.

The following values are defined for convenience:

FW_DONTCARE
FW_THIN
FW_EXTRALIGHT
FW_ULTRALIGHT
FW_LIGHT
FW_NORMAL
FW_REGULAR
FW_MEDIUM
FW_SEMIBOLD
FW_DEMIBOLD
FW_BOLD
FW_EXTRABOLD
FW_ULTRABOLD
FW_HEAVY
FW_BLACK

Sample

This sample sets the font weight of control oTextEdit 1 to FW_SEMIBOLD.

set FontWeight of oTextEdit1 to FW_SEMIBOLD

Last Edited: June 20, 2005


DFBaseTextEdit [Property piMaxChars]

piMaxChars - DFBaseTextEdit

Sets or returns maximum number of visible characters

Type: Property

Access: Read/Write

Data Type: Integer

Description

The default maximum number of visible characters for the control is 64 KB (65536 bytes or characters).

Note:
piMaxChars determines the maximum number of visible characters the user can enter into the control. However, when getting the value or saving the value to a database field, the value will contain additional non-visible characters. Each time the user presses Enter or Shift+Enter to break the line, this will be counted as a single visible character, but the value will contain 2 characters, a linefeed character (ASCII 10) followed by a carriage return character (ASCII 13).

OnMaxText fires when the maximum number of visible characters of the control is exceeded.

Sample

This sample retrieves the maximum number of visible characters of control oTextEdit1 to iMaxChars.

integer iMaxChars
get piMaxChars of oTextEdit1 to iMaxChars

Sample

This sample sets the maximum number of characters of control oTextEdit1 to 128 KB.

set piMaxChars of oTextEdit1 to (128 * 1024)

Last Edited: December 16, 2004


DFBaseTextEdit [Property piRightMargin]

piRightMargin - DFBaseTextEdit

Determines indentation of right side of control's text, relative to the right margin

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property uses twips, which are 1/1440 of an inch, or 1/20 of a printer's point.

This property has no effect if control is not paged.

Sample

This sample increases the right margin of the text of control oTextEdit1 by half an inch.

Procedure IncreaseRightMargin
    integer iTwips iCurrentMargin

    // number of twips per inch
    move 1440 to iTwips

    get piRightMargin of oTextEdit1 to iCurrentMargin
    set piRightMargin of oTextEdit1 to (iCurrentMargin + (iTwips * 0.5))
End_Procedure // IncreaseRightMargin

Last Edited: November 24, 2004


DFBaseTextEdit [Property psTypeFace]

psTypeFace - DFBaseTextEdit

Sets or returns font typeface of all text in control

Type: Property

Access: Read/Write

Data Type: String

Description

Sets or returns the font typeface of all text in the control.

Sample

This sample returns the typeface of the text in control oTextEdit1 to variable sTypeFace and then displays it in a message box to the user.

Procedure SetTypeFace
    string sTypeFace

    get psTypeFace of oTextEdit1 to sTypeFace

    send Info_Box sTypeFace "Current TypeFace"
End_Procedure  // SetTypeFace

Sample

This sample sets the typeface of the text of control oRichEdit1 to Courier.

Procedure SetTypeFace
    set psTypeFace of oTextEdit1 to "Courier"
End_Procedure  // SetTypeFace

Last Edited: June 20, 2005


DFBaseTextEdit [Property Read_Only_State]

Read_Only_State - DFBaseTextEdit

Determines whether users may edit the content of the control

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Read_Only_State allows protection of the content of the control while still allowing users freedom to navigate and perform operations that do not edit the contents of the control, such as copying text. This is useful for displaying existing text in the control.

Read_Only_State does not prohibit programmatic changes to the control, only changes via the user interface, such as typing, cutting or deleting text.

The Read method reads a document and displays it in the control.

Sample

This sample sets control oTextEdit1 to read only.

set Read_Only_State of oTextEdit1 to True

Sample

This sample sets control oTextEdit1 to allow read and write access.

set Read_Only_State of oTextEdit1 to False

Last Edited: November 24, 2004


DFBaseTextEdit [Property Value]

Value - DFBaseTextEdit

Sets or returns content of control

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iItem String sValue

Parameter | Description
iItem | [ToDo: In Progress]
sValue | [ToDo: In Progress]

Description

Sets or gets the entire contents of the control.

Use AppendText to append text to the end of the text in the control.
CharCount returns length of the text in the control.

A linefeed (LF) character can be added to text programmatically by adding ASCII character 10 to a string using the character function. A carriage return (CR) character can be added to text programmatically by adding ASCII character 13 to a string using the character function. Either a LF or CR character will break the current line in the control.

Sample

This sample sets the contents of the oTextEdit1 control to "This is line 1", then a line break, then "This is line 2".

Procedure DisplayText
    string sText sLineFeed

    move (character(10)) to sLineFeed
    move ("This is line 1" + sLineFeed + "This is line 2") to sText

    set Value of oTextEdit1 to sText
End_Procedure  // DisplayText

Last Edited: July 11, 2006


Events for DfBasetoolPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBasetoolPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DfBasetoolPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


DfBaseUIWindow [Event Command]

Command - DfBaseUIWindow

Sent from external controls

Type: Event

Parameters: Integer wParam Integer lParam

Parameter | Description
wParam | Windows w param
lParam | Windows l param

Description

Command messages are sent from external controls. They are cancelled in this class.

Last Edited: August 5, 2003


Events for DfBaseUIWindow

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls |
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseUIWindow

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


DfBaseUIWindow [Procedure Release_Mouse_Capture]

Release_Mouse_Capture - DfBaseUIWindow

Type: Procedure

Parameters: No Parameters

Description

Release_mouse_capture - DFUIWindow
Legend

release_mouse_capture - procedure

Last Edited: July 10, 2003


Properties for DfBaseUIWindow

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  |
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages |


DfBaseUIWindow [Property Mouse_Capture]

Mouse_Capture - DfBaseUIWindow

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer Arg1 Integer iValue

Parameter | Description
Arg1 | [ToDo: In Progress]
iValue | [ToDo: In Progress]

Description

Last Edited: January 12, 2006


DfBaseUIWindow [Property Windows_Override_State]

Windows_Override_State - DfBaseUIWindow

Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Windows_Override_State allows Visual DataFlex to stop the default Microsoft Windows behavior for mouse and keyboard messages. When set to true, the standard Windows behavior is canceled and the developer may send Visual DataFlex messages to handle the event. This stops the standard Windows beahvior.

Default is False.

If your Visual DataFlex program responds on a Windows message (mapped to a Visual DataFlex procedure via External_Message) and you want to pass a value back to the program sending the message, you need to set this property to True.

Example

Procedure Construct_Object
    Forward Send Construct_Object
    ...
    Set External_Message WM_FOO To msg_Foo
    ...
End_Procedure  // Construct_Object

Procedure Foo Integer wParam Integer lParam Returns Integer
    ...
    Set Windows_Override_State To True
    Procedure_Return 2 // The value to be returned
End_Procedure  // Foo

Last Edited: November 24, 2004


Events for DfBaseWindow

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfBaseWindow

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object |
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class |
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages |
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue |


DfBaseWindow [Procedure Set External_Class_Name]

External_Class_Name - DfBaseWindow

Used to "wrap" a windows control inside of a DataFlex class

Type: Procedure Set

Data Type: String

Parameters: String sVDFClassName String sWindowsClassName

Parameter | Description
sVDFClassName | DataFlex class name
sWindowsClassName | Windows class name

Description

External_class_name is used to "wrap" a windows control inside of a DataFlex class. This is an advanced technique which requires knowledge of both the Windows API and the Visual DataFlex method of "wrapping" classes. This used in conjunction with the external_message message.

Set External_Class_Name "DFTimer" to "static"

Set External_Class_Name 'DFTreeView' To 'SysTreeView32'

Last Edited: August 5, 2003


DfBaseWindow [Procedure Set External_Message]

External_Message - DfBaseWindow

Assigns Windows messages to DataFlex messages

Type: Procedure Set

Data Type: Integer

Parameters: Integer iWindowsMessage Integer iVDFMessage

Parameter | Description
iWindowsMessage | Windows message ID
iVDFMessage | DataFlex message ID

Description

External_message is used to assign Windows messages to DataFlex messages. This is an advanced technique which requires knowledge of both the Windows API and the Visual DataFlex method of "wrapping" classes. This used in conjunction with the external_class_name message.

// from dfline.pkg
Register_Procedure WMSG_Paint integer wParam integer lParam
// make it a benign object.
Set External_Class_Name "DFLine" To 'DFUserControl'
// We want to trap WM_PAINT for efficient painting.
Set External_Message WM_PAINT To msg_WMSG_Paint

// from DfTreeVw.Pkg
Set External_Class_Name 'DFTreeView' To 'SysTreeView32'
Set External_Message WM_SETFOCUS To msg_OnSetFocus
Set External_Message WM_KILLFOCUS To msg_OnKillFocus

Last Edited: August 5, 2003


DfBaseWindow [Procedure Adjust_Logicals]

Adjust_Logicals - DfBaseWindow

Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object

Type: Procedure

Parameters: No Parameters

Description

The Adjust_logicals message sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object. Adjust_Logicals sets the Size and/or Location properties, and should be sent anytime an object's physical size or location (GuiSize, GuiLocation) is directly set.

Set Guilocation to  20  30
Set GuiSize     to 100 200
Send Adjust_Logicals

Last Edited: July 30, 2003


DfBaseWindow [Procedure Windows_Message]

Windows_Message - DfBaseWindow

Sends a message to the Windows message queue

Type: Procedure

Parameters: integer iWindowsMessage integer iParam1 integer iParam2

Parameter | Description
iWindowsMessage | Specifies the message to be sent
iParam1 | Specifies additional message-specific information
iParam2 | Specifies additional message-specific information

Description

Use of this method requires Windows API knowledge about the message being sent and the control that will process the message.

Sample

This sample shows how to use WindowsMessage to retrieve the progress bar position VDF cProgressBar object.

Function Position Returns Integer
    If (Window_Handle(self)) Begin
        Function_Return (WindowsMessage(PBM_GETPOS, 0, 0))
    End
    Else ;
        Function_Return 0
End_Function  // Position

Sample

This sample shows how to use WindowsMessage to retrieve a handle to the next sibling of a passed node in a VDF TreeView object.

Function NextSibling Handle hItem returns Handle
    Move (WindowsMessage(TVM_GETNEXTITEM, TVGN_NEXT, hItem)) To hItem

    Function_Return hItem

End_Function

Last Edited: November 25, 2004


Properties for DfBaseWindow

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object |
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object |
Bitmap_Height | Returns the height of the image contained in the file named by bitmap |
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed |
Bitmap_Width | Returns the width of the image contained in the file named by bitmap |
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  |
Color | Sets the background color of the object |
Container_Handle | Returns the Windows window handle of the DataFlex object's container |
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object |
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized |
FontSize | Overrides the default font size of the current font |
FontUnderline | Determines if font will be printed with underscores at the base of the character |
FontWeight | Striking weight of font |
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object |
GuiSize | Determines the size (height and width) of the object expressed in physical pixels |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels |
piMaxSize | Determines the limit of the maximum size that a Component can be |
piMinSize | Determines the limit of the minimum size that a Component can be |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object |
TextColor | Sets the text color of the object |
Transparent_State |  |
Typeface | The typeface of the selected font |
Value |  |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object |
Window_Style | Sets the window style for the Windows object |


DfBaseWindow [Property Absolute_Guiorigin]

Absolute_Guiorigin - DfBaseWindow

Returns the screen coordinates of the top left corner of a DataFlex object

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Absolute_GUIorigin function returns the screen coordinates of the top left corner of a DataFlex object; it is the absolute GUILocation of the Windows Desktop.

Last Edited: April 22, 2005


DfBaseWindow [Property Bitmap]

Bitmap - DfBaseWindow

Displays a bitmap in an object

Type: Property

Access: Write-Only

Data Type: String

Description

The Bitmap message will display a bitmap in an object. In other words, the bitmap becomes the background of the object.
Bitmap_Style determines how and where the bitmap will display in the object.

There are two potential drawbacks to using bitmaps: the amount of storage (on disk) , and the constant memory consumption.

Sample

This sample sets the bitmap to "MyBitmap.bmp".

set Bitmap to "MyBitmap.bmp"

Note:
In order to make a cohesive application, Visual DataFlex must find the .EXE file and the .bmp (bitmap) file, by using DFPATH.

Last Edited: November 24, 2004


DfBaseWindow [Property Bitmap_Height]

Bitmap_Height - DfBaseWindow

Returns the height of the image contained in the file named by bitmap

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Bitmap_height property returns the height of the image contained in the file named by bitmap.

Last Edited: July 30, 2003


DfBaseWindow [Property Bitmap_Style]

Bitmap_Style - DfBaseWindow

Specifies the position, size, or shape in which the bitmap image for this object is to be displayed

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Bitmap_Style property specifies the position, size, or shape in which the bitmap image for this object is to be displayed.

Possibly styles are:

Constant | Meaning
Bitmap_Actual | Places the image in the upper left corner of the object
Bitmap_Stretch | Stretches the bitmap to fills the entire object with the image
Bitmap_Center | Centers the image in the object
Bitmap_Tile | Tiles the object with the bitmap

Default is Bitmap_Actual.

Last Edited: August 4, 2004


DfBaseWindow [Property Bitmap_Width]

Bitmap_Width - DfBaseWindow

Returns the width of the image contained in the file named by bitmap

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Bitmap_width property returns the width of the image contained in the file named by bitmap.

Last Edited: July 30, 2003


DfBaseWindow [Property Client_Size]

Client_Size - DfBaseWindow

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


DfBaseWindow [Property Color]

Color - DfBaseWindow

Sets the background color of the object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Color property sets the background color of the object. This is passed a single value representing an RGB color. Individual Red, Green, and Blue colors are converted to a single value by using the RGB function.

If no value is specifically set, a default color setting is used. The default is stored in a global integer named default_current_item_color. Its default value is aqua (rgb(0, 255, 255)). You may change this value in your program.

Set Color to (rgb(255, 0, 0)) // red
Set Color to clPurple
Set Color to clBtnFace

Note:The rgb.pkg package contains names for most of commonly used colors and names for all system colors.

Last Edited: August 12, 2005


DfBaseWindow [Property Container_Handle]

Container_Handle - DfBaseWindow

Returns the Windows window handle of the DataFlex object's container

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Container_Handle function returns the Windows window handle of the DataFlex object's container. If the object is a container object (e.g., Container3D), it will return the object's window_handle (i.e., the window handle is the container handle). If the object is a control (e.g., form), it will return its parent container's window_handle.

Note: A window handle (window_handle and container_handle) only exists if the object is currently paged.

Last Edited: July 31, 2003


DfBaseWindow [Property Extended_Window_Style]

Extended_Window_Style - DfBaseWindow

Sets the extended window style for the windows object

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: integer iStyleMask Boolean bOn

Parameter | Description
iStyleMask | The windows extended style mask
bOn | True to set style, false to clear style

Description

Extended_window_style sets the extended window style for the windows object. This directly sets attributes of the windows object. iStyleMask is the extended window style or styles. bOn determines if the style is being added or removed. The style masks available are determined and defined by the windows API. Knowledge of the windows API is required to use this message. This is a very low level interface message. This is a very low level interface message. You are bypassing the DataFlex object interface and communicating directly with the windows object.

Last Edited: August 5, 2003


DfBaseWindow [Property FontItalics]

FontItalics - DfBaseWindow

Determines if current font is to be italicized

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If set to true, the Fontitalics property will italicize the current font.

Set Fontitalics to true

Default is false.

Last Edited: August 18, 2003


DfBaseWindow [Property FontSize]

FontSize - DfBaseWindow

Overrides the default font size of the current font

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iHeight Integer iWidth

Parameter | Description
iHeight | Font height
iWidth | Font width

Description

The purpose of the FontSize message is to override the default font size of the current font.

Set Fontsize to 10 30

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

The property is set as follows:

Set FontSize to iHeight iWidth

The property is retrieved and unpacked as follows:

Get FontSize to cxyValue
Move (hi(cxyValue)) to iHeight
Move (Low(cxyValue)) to iWidth

Last Edited: June 22, 2005


DfBaseWindow [Property FontUnderline]

FontUnderline - DfBaseWindow

Determines if font will be printed with underscores at the base of the character

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If Fontunderline is set true, font will be printed with underscores at the base of the character. If false, the font will be printed normally.

Set Fontunderline to true

Default is false.

Last Edited: August 18, 2003


DfBaseWindow [Property FontWeight]

FontWeight - DfBaseWindow

Striking weight of font

Type: Property

Access: Read/Write

Data Type: Integer

Description

Fontweight is the striking weight of font (0-65536).

Set Fontweight to 500

Last Edited: August 18, 2003


DfBaseWindow [Property GuiLocation]

GuiLocation - DfBaseWindow

Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iRowPos Integer iColPos

Parameter | Description
iRowPos | Row position in pixels
iColPos | Column position in pixels

Description

The Guilocation property determines the position (row and column) of the object expressed in physical pixels (the native display-coordinate system) relative to the upper left-hand corner of the containing object.

Normally objects are located using the location message which uses logical coordinates (usually dialog units). Setting logical coordinates also sets the physical (gui) coordinates.

If an object's location is set using the guilocation message the adjust_logicals message should be sent to adjust the object's logical coordinates.

Get GuiLocation to RowCol
Move  (hi(RowCol)) to iRw
Move (low(RowCol)) to iCol
Set GuiLocation to (iRw +20) (iCol  10)
Set GuiSize to 100 200
Send Adjust_Logicals

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

The property is set as follows:

Set GuiLocation to iRowPos iColPos

The property is retreived and unpacked as follows:

Get GuiLocation to cxyValue
Move (hi(cxyValue)) to iRowPos
Move (Low(cxyValue)) to iColPos

Last Edited: June 22, 2005


DfBaseWindow [Property GuiSize]

GuiSize - DfBaseWindow

Determines the size (height and width) of the object expressed in physical pixels

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iHeight Integer iWidth

Parameter | Description
iHeight | Height in pixels
iWidth | Width in pixels

Description

The Guisize property determines the size (height and width) of the object expressed in physical pixels (the native display-coordinate system).

Normally objects are sized using the size message which uses logical coordinates (usually dialog units). Setting logical coordinates also sets the physical (gui) coordinates.

If an object's size is set using the guisize message the adjust_logicals message should be sent to adjust the object's logical coordinates.

Get GuiSize to HeightWidth
Move  (hi(HeightWidth)) to Height
Move (low(HeightWidth)) to Width
Set GuiSize to (Height +20) (Width  10)
Send Adjust_Logicals

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

The property is set as follows:

Set GuiSize to iHeight iWidth

The property is retreived and unpacked as follows:

Get GuiSize to cxyValue
Move (hi(cxyValue)) to iHeight
Move (Low(cxyValue)) to iWidth

Last Edited: June 22, 2005


DfBaseWindow [Property peAnchors]

peAnchors - DfBaseWindow

Describes how you want the control to react whenever its container changes size

Type: Property

Access: Read/Write

Data Type: Integer

Description

peAnchors describes how you want the control to react whenever its container (dbView, Group, etc.) changes size. It has been added to all controls (any visual objects), which ensures that the control retains the distance to the edges that it is anchored against, whenever the parent's size is changed.

Set peAnchors to one of the following constants:

Constant | Meaning
anNone | The control should do nothing when the parent changes size.
anAll | The control will maintain the same distance to the top, bottom, left and right edges of the parent. This will result in the control's height changing when the parent's does, and its width changing when its parent's does.
anBottomLeft | The control will maintain the same distance to the bottom and left edges. This will result in the control moving when the parent is resized.
anBottomLeftRight | The control will maintain the same distance to the bottom, left and right edges of the parent. This will result in the control getting wider when the width of the parent is changed and the control moving vertically when the parent's height is changed.
anBottomRight | The control will maintain the same distance to the bottom and right edges of the parent. This will result in the control moving vertically and horizontally when the width and height of the parent is changed.
anTopBottomLeft | The control will maintain the same distance to the top, bottom and left edges of the parent. This will result in the control changing its height when the parent is resized.
anTopBottomRight | The control will maintain the same distance to the top, bottom and right edges of the parent. This will result in the control's height changing and the control moving horizontally when the height and width of the parent is changed.
anTopLeftRight | The control will maintain the same distance to the top, left and right edges of the parent. This will result in the control getting wider when the width of the parent is changed.
anTopRight | The control will maintain the same distance to the top and right edges of the parent. This will result in the control moving horizontally when the width of the parent is changed.

The following anchor constants are also valid, but are not exposed in the Studio, since they are equivalent to one of the exposed constants listed above:

Constant | Meaning
anBottom | The control will maintain the same distance from the bottom edge of the parent. The control will move vertically when its parent's height is changed.
anLeft | The control will maintain the same distance from the left edge of the parent. The control will not move or resize itself.
anLeftRight | The control will maintain the same distance to the left and right edges of the parent. This will result in the control getting wider when the width of the parent is changed.
anRight | The control will maintain the same distance to the right edge of the parent. This will result in the control moving horizontally when the width of the parent is changed.
anTop | The control will maintain the same distance from the top edge of the parent. The control will not move or resize itself.
anTopBottom | The control will maintain the same distance from the top and bottom edges of the parent. The control's height will change when its parent's height is changed.
anTopLeft | The control will maintain the same distance from the left and top edges of the parent. The control will not move or resize itself.

Note: You will need to ensure that you set the Component's Border_Style property to Border_Thick; otherwise, you will not be able to resize the border, meaning that the Components can never get bigger, which, in turn, also means that none of the child control's anchors will ever be applied.

Think carefully about how you want to set the anchors. It is entirely possible to set anchors in such a way that they will not logically work together. For example, if you have two Forms on the same row and you set them both to anchor left-and-right, they will overlap each other, as the Component gets wider (the first Form's right edge will go beyond the left-unmoving-edge of the second Form.). The solution would be to make one anchor left-and-right, but the other to be anchored left (if it was the first control) or right (if it was the second control). Alternatively, if you really want them both to get wider, then put them on different rows.

Last Edited: July 26, 2006


DfBaseWindow [Property Physical_FontSize]

Physical_FontSize - DfBaseWindow

Specifies the fontsize in pixels

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iHeight Integer iWidth

Parameter | Description
iHeight | Height in pixels
iWidth | Width in pixels

Description

The size of the font is the height of the character cell and the width of the character cell expressed in units of the native coordinate system (e.g., pixels). If either height or width is zero, the system will set the font size using the aspect ratio of the typeface.

Last Edited: September 11, 2003


DfBaseWindow [Property piMaxSize]

piMaxSize - DfBaseWindow

Determines the limit of the maximum size that a Component can be

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iHeight Integer iWidth

Parameter | Description
iHeight | The maximum allowed height
iWidth | The maximum allowed width

Description

Allowing the end-user to change the sizes of Components (dbView, ModalPanels, etc.) brings a new challenge: specifically, the temptation to see what happens when the Component is shrunk as small as it will go. There is to limit the minimum size that a Component can be. You achieve this by setting the piMinSize property. The piMinSize property follows the same pattern as Size. That is, you set piMinSize in the same way that you set the Size:

Set Size To 100 250
Set piMinSize To 100 250

In the preceding example, the Component's minimum size will be the same as the size of the object, meaning that it can only get larger. If you wish, you can set it to be smaller, but test it to be certain that it cannot be shrunk to an unacceptable size.

You can control the maximum size to which a Component can be resized by setting the piMaxSize property:

Set Size To 100 100
Set piMinSize To 50 50
Set piMaxSize To 200 600

piMinSize and piMaxSize, have been added to the Component object (dbView, ModalPanel, etc) that limit the size to which the Component can be resized.

You need to ensure that you set the Component's Border_Style property to Border_Thick (which is not the default); otherwise, Windows will not let the end-user change the size of the Component.

Think carefully about how you want to set the anchors. It is entirely possible to set anchors in such a way that they will not logically work together. For example, if you have two Forms on the same row and you set them both to anchor left-and-right, they will overlap each other, as the Component gets wider (the first Form's right edge will go beyond the left-unmoving-edge of the second Form.). The solution would be to make one anchor left-and-right, but the other to be anchored left (if it was the first control) or right (if it was the second control). Alternatively, if you really want them both to get wider, then put them on different rows.

Last Edited: September 11, 2003


DfBaseWindow [Property piMinSize]

piMinSize - DfBaseWindow

Determines the limit of the minimum size that a Component can be

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iHeight Integer iWidth

Parameter | Description
iHeight | The minimum allowed height
iWidth | The minimum allowed width

Description

Allowing the end-user to change the sizes of Components (dbView, ModalPanels, etc.) brings a new challenge: specifically, the temptation to see what happens when the Component is shrunk as small as it will go. There is to limit the minimum size that a Component can be. You achieve this by setting the piMinSize property. The piMinSize property follows the same pattern as Size. That is, you set piMinSize in the same way that you set the Size:

Set Size To 100 250
Set piMinSize To 100 250

In the preceding example, the Component's minimum size will be the same as the size of the object, meaning that it can only get larger. If you wish, you can set it to be smaller, but test it to be certain that it cannot be shrunk to an unacceptable size.

You can control the maximum size to which a Component can be resized by setting the piMaxSize property:

Set Size To 100 100
Set piMinSize To 50 50
Set piMaxSize To 200 600

piMinSize and piMaxSize, have been added to the Component object (dbView, ModalPanel, etc) that limit the size to which the Component can be resized.

You need to ensure that you set the Component's Border_Style property to Border_Thick (which is not the default); otherwise, Windows will not let the end-user change the size of the Component.

Think carefully about how you want to set the anchors. It is entirely possible to set anchors in such a way that they will not logically work together. For example, if you have two Forms on the same row and you set them both to anchor left-and-right, they will overlap each other, as the Component gets wider (the first Form's right edge will go beyond the left-unmoving-edge of the second Form.). The solution would be to make one anchor left-and-right, but the other to be anchored left (if it was the first control) or right (if it was the second control). Alternatively, if you really want them both to get wider, then put them on different rows.

Last Edited: September 11, 2003


DfBaseWindow [Property Text_Extent]

Text_Extent - DfBaseWindow

Returns the pixel with of the passed TextValue based on the typeface and style of the current object

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: String sText Integer iValue

Parameter | Description
sText | Text value
iValue | Size of object returned as complex number

Description

Text_extent returns the pixel with of the passed TextValue based on the typeface and style of the current object. This can be used to determine the size of an object based on its text contents. The return value is complex with the hi value representing pixel height and the low value representing width.

Procedure Autosize String Val
    Integer Ext Ht Wd
    Get Text_Extent Val To Ext
    Move  (hi(ext)) to Ht
    Move (low(ext)) to Wd
    Set Guisize To (Ht+3) (Wd+2)
    Send Adjust_logicals
End_Procedure

Last Edited: August 6, 2004


DfBaseWindow [Property TextColor]

TextColor - DfBaseWindow

Sets the text color of the object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The TextColor property sets the text color of the object. This is passed a single value representing an RGB color. Individual Red, Green, and Blue colors are converted to a single value by using the RGB function.

If no value is specifically set, a default color setting is used. The default is stored in a global integer named default_current_item_color. Its default value is aqua (rgb(0, 255, 255)). You may change this value in your program.

Set TextColor to (rgb(255, 0, 0)) // red
Set TextColor to clPurple
Set TextColor to clBtnFace

Note:The rgb.pkg package contains names for most of commonly used colors and names for all system colors.

Last Edited: August 12, 2005


DfBaseWindow [Property Transparent_State]

Transparent_State - DfBaseWindow

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: February 13, 2003


DfBaseWindow [Property Typeface]

Typeface - DfBaseWindow

The typeface of the selected font

Type: Property

Access: Read/Write

Data Type: String

Description

Typeface is the typeface of the selected font.

Set Typeface to "Courier"

This property does not work for the cRichEdit, cTextEdit, cDbRichEdit and cDbTextEdit classes. Use the psTypeFace property for those classes.

Last Edited: April 28, 2005


DfBaseWindow [Property Value]

Value - DfBaseWindow

Type: Property

Access: Read/Write

Data Type: String

Parameters: Integer iItem String sValue

Parameter | Description
iItem | [ToDo: In Progress]
sValue | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


DfBaseWindow [Property Window_Handle]

Window_Handle - DfBaseWindow

Returns the Windows window handle of the DataFlex object

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Window_handle property returns the Windows window handle of the DataFlex object.

When a DataFlex object is paged (as part of activation) it creates the required windows object. The window object is identified by its window_handle. When the DataFlex object is deactivated, the window object is destroyed and window_handle is reset to 0. Therefore a window handle (window_handle or container_handle) only exists if the DataFlex object is currently paged.

Last Edited: September 15, 2003


DfBaseWindow [Property Window_Style]

Window_Style - DfBaseWindow

Sets the window style for the Windows object

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iStyleMask Boolean bOn

Parameter | Description
iStyleMask | Window style mask
bOn | True to set style, false to clear style

Description

Window_style sets the window style for the Windows object. This directly sets attributes of the Windows object. StyleMask is the window style or styles. bOn determines if the style is being added or removed. The style masks available are determined and defined and by the Windows API. Knowledge of the Windows API is required to use this message. This is a very low-level interface message. It bypasses the DataFlex object interface and communicates directly with the Windows object.

Set window_Style to CBS_SORT to TRUE // combo form control
Get window_Style CBS_SORT to SortedFlag

Last Edited: August 2, 2005


Events for DfComActiveXControl

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfComUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Key | Augmented to implement the GUI keyboard interface | DfComUIObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCreate |  | DfInPlaceComObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfComActiveXControl

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfComUIObject
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
ComAddref | Procedure |  | DfInPlaceComObject
ComQueryInterface | Function |  | DfInPlaceComObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object | DfInPlaceComObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
RegisterComEvent | Procedure |  | DfInPlaceComObject
RegisterPropertyChangeEvent | Procedure |  | DfInPlaceComObject
Release_Mouse_Capture | Procedure |  | DfComUIObject
ReleaseComObject | Procedure | Releases ActiveX control associated with this object | DfInPlaceComObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject


Properties for DfComActiveXControl

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfComUIObject
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfComUIObject
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfComUIObject
Color | Sets the background color of the object | DfComUIObject
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfComUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfComUIObject
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfComUIObject
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfComUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfComUIObject
peAutoCreate | Manipulates COM Object instantiation | DfInPlaceComObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piMaxSize | Determines the limit of the maximum size that a Component can be | DfComUIObject
piMinSize | Determines the limit of the minimum size that a Component can be | DfComUIObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psLicenseKey | Contains the license key when ActiveX controls use a run-time license | DfInPlaceComObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfInPlaceComObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfInPlaceComObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Shadow_State | Determines if item is enabled (not shadowed) | DfComUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
TextColor | Sets the text color of the object | DfComUIObject
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfComUIObject
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfComUIObject


DfComAutomationObject [Event OnCreate]

OnCreate - DfComAutomationObject

Sent right after a COM object is created

Type: Event

Parameters: No Parameters

Description

The OnCreate event is always sent right after a COM object is created. You should write an OnCreate event handler to initialize the properties of a COM object when it is created.

It is important to understand the difference between when a COM object is created and when its VDF wrapper object is created. This is discussed in detail in the topic COM Object Life Span.

It is always safe to set the properties of a COM object inside of the OnCreate event handler. It is also good practice to always Forward Send OnCreate when augmenting this event handler.

See Also

cComAutomationObject

Last Edited: September 10, 2003


Events for DfComAutomationObject

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnCreate | Sent right after a COM object is created |


DfComAutomationObject [Function ComQueryInterface]

ComQueryInterface - DfComAutomationObject

Type: Function

Return Data Type: Variant

Parameters: String Arg1

Parameter | Description
Arg1 | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for DfComAutomationObject

View method list in hierarchical order

Name | Type | Description | Defining Class
ComAddref | Procedure |  |
ComQueryInterface | Function |  |
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Connects to an instance of the Automation object |
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
RegisterComEvent | Procedure | Registers a COM event in the runtime COM event handler routine. |
ReleaseComObject | Procedure | Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


DfComAutomationObject [Procedure ComAddref]

ComAddref - DfComAutomationObject

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


DfComAutomationObject [Procedure CreateComObject]

CreateComObject - DfComAutomationObject

Connects to an instance of the Automation object

Type: Procedure

Parameters: No Parameters

Description

CreateComObject is sent to connect to an instance of the Automation object.

The example below demonstrates the use of CreateComObject in the Simple Automation Controller sample to connect to the Simple Automation Server.

Boolean bIsComObjectCreated

// Test to see If we are already connected. If we are connected,
// then the IsComObjectCreated Returns True.
Get IsComObjectCreated of oAutomationTest To bIsComObjectCreated

If (Not(bIsComObjectCreated)) Begin
    // Connect the VDF Automation Wrapper to the Automation Object.
    Send CreateComObject of oAutomationTest
End

See Also

cComAutomationObject | AttachActiveObject | ReleaseComObject | OnCreate

Last Edited: July 31, 2003


DfComAutomationObject [Procedure RegisterComEvent]

RegisterComEvent - DfComAutomationObject

Registers a COM event in the runtime COM event handler routine.

Type: Procedure

Parameters: Integer Arg1 Integer Arg2

Parameter | Description
Arg1 | Method ID (eg 1, -600 etc)
Arg2 | Visual DataFlex method ID (e.g. msg_OnComClick). When the virtual machine receives this event the Visual DataFlex method OnComClick will be executed.

Description

This method registers a COM event in the runtime COM event handler routine. Only events that exist in the COM component can be registered. You cannot extend the events with events of your own.

You will find the usage of this RegisterComEvent method inside the method RegisterComEvents of the events class wrapper. For example (from StdFont.Pkg):

// Event interface for the Font object
Class cComFontEvents is a Mixin

    //Doc/ Type=Event Interface=Public
    Procedure OnComFontChanged String llPropertyName
    End_Procedure

    //Doc/ Interface=Private NoDoc=True
    Procedure RegisterComEvents
        Send RegisterComEvent 9 msg_OnComFontChanged
    End_Procedure

End_Class  // cComFontEvents

If an event has parameters, these are automatially passed to the registered method. You cannot specify them with the RegisterComEvent procedure.

Last Edited: June 20, 2005


DfComAutomationObject [Procedure ReleaseComObject]

ReleaseComObject - DfComAutomationObject

Releases a reference to the Automation object without having to destroy the Visual DataFlex wrapper object

Type: Procedure

Parameters: No Parameters

Description

ReleaseComObject is sent to release a reference to the Automation object without having to destroy the Visual DataFlex wrapper object.

Destroying a Visual DataFlex COM wrapper object automatically releases its reference to a COM object.

The example below demonstrates the use of ReleaseComObject in the Simple Automation Controller sample to release the Simple Automation Server.

Procedure Test
    Boolean bIsComObjectCreated

    // Test to see If we are already connected. If we are connected,
    // then the IsComObjectCreated Returns True.
    Get IsComObjectCreated of oAutomationTest To bIsComObjectCreated

    If (bIsComObjectCreated) Begin
        // release the Automation Object from the VDF Automation Wrapper.
        Send ReleaseComObject of oAutomationTest
    End
End_Procedure  // Test

See Also

cComAutomationObject | CreateComObject

Last Edited: June 20, 2005


Properties for DfComAutomationObject

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAutoCreate | Manipulates COM Object instantiation |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psLicenseKey | Contains the license key for Automation objects using a run-time license |
psProgID | Holds the CLSID (class ID) of the COM class represented |
pvComObject | Returns an IDispatch pointer to the external COM object |


DfComAutomationObject [Property peAutoCreate]

peAutoCreate - DfComAutomationObject

Manipulates COM Object instantiation

Type: Property

Access: Read/Write

Data Type: Integer

Description

COM Object instantiation can be manipulated via the peAutoCreate property.

Possible Values

Constant | Meaning
acNoAutoCreate | Do not automatically instantiate the COM object upon VDF object creation. You must manually instantiate the COM object using CreateComObject
acAutoCreate | Automatically instantiate the COM object upon VDF object creation. You won't need to manually instantiate the COM object.
acDeferredAutoCreate | Automatically instantiate the COM object when it is paged (during Activate), and to be automatically destroyed when it is unpaged (during Deactivate).

For Automation objects the default value for this property is acNoAutoCreate. This means that you must manually instantiate the COM object using CreateComObject. You would normally not change this default.

See Also

cComAutomationObject

Last Edited: September 11, 2003


DfComAutomationObject [Property psLicenseKey]

psLicenseKey - DfComAutomationObject

Contains the license key for Automation objects using a run-time license

Type: Property

Access: Read/Write

Data Type: String

Description

The psLicenseKey property contains the license key for Automation objects using a run-time license. Some Automation objects use a run-time license, in which case this property would contain the license key.

See Also

cComAutomationObject

Last Edited: September 11, 2003


DfComAutomationObject [Property psProgID]

psProgID - DfComAutomationObject

Holds the CLSID (class ID) of the COM class represented

Type: Property

Access: Read/Write

Data Type: String

Description

The psProgID property is used to hold the CLSID (class ID) of the COM class represented.

The CLSID is a 128-bit integer, which is a GUID (Globally Unique Identifier) that uniquely identifies a COM class.

128-bit numbers are too large to store as an Integer type. The CLSID is instead stored as a string with the following format.

'{xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx}'

You should not change this Property.

See Also

cComAutomationObject

Last Edited: September 11, 2003


DfComAutomationObject [Property pvComObject]

pvComObject - DfComAutomationObject

Returns an IDispatch pointer to the external COM object

Type: Property

Access: Read/Write

Data Type: Variant

Description

pvComObject is a variant property which returns an IDispatch pointer to the external COM object.

Setting this property to the correct IDispatch* value connects a VDF wrapper object to its corresponding external COM object and increments the COM object's reference count.

Changing the pvComObject property or setting it to NULL (using the NullComObjectfunction) automatically releases any reference to the IDispatch pointed to by the old property value. Destroying the VDF wrapper object also automatically releases the reference to the COM object.

This property is automatically assigned and released when sending CreateComObject/ AttachActiveObject and ReleaseComObject.

Variant-type variables can be used to store IDispatch* values.

Note:The VDF runtime protects against pointer arithmetic and comparison expressions for variant variables containing an IDispatch*. Doing so would raise a runtime error. The helper functions IsNullComObject and IsSameComObject can be used to perform any operations that you would normally require on variants containing IDispatch* values.

Below is an example of creating a cComStdFont object and attaching it to an existing OLE font object using the pvComObject property:

// create an instance of OLE Font wrapper class...
Object oFont is a cComStdFont
End_Object

Procedure SetFontUnderline Variant vFont Boolean bMode
    // bind our wrapper Object to the passed IDispatch*
    Set pvComObject of oFont to vFont
    // now we can change the title font...
    Set ComUnderline of oFont To bMode
End_Procedure

See Also

cComAutomationObject

Last Edited: September 11, 2003


Events for DFComDocumentObject

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfComUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Key | Augmented to implement the GUI keyboard interface | DfComUIObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCreate |  | DfInPlaceComObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DFComDocumentObject

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfComUIObject
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
ComAddref | Procedure |  | DfInPlaceComObject
ComQueryInterface | Function |  | DfInPlaceComObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object | DfInPlaceComObject
CreateComObjectFromFile | Procedure | Creates a new document and initializes it with data read in from the file passed in the sFile parameter |
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
RegisterComEvent | Procedure |  | DfInPlaceComObject
RegisterPropertyChangeEvent | Procedure |  | DfInPlaceComObject
Release_Mouse_Capture | Procedure |  | DfComUIObject
ReleaseComObject | Procedure | Releases ActiveX control associated with this object | DfInPlaceComObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
SaveToFile | Procedure |  |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject


DFComDocumentObject [Procedure CreateComObjectFromFile]

CreateComObjectFromFile - DFComDocumentObject

Creates a new document and initializes it with data read in from the file passed in the sFile parameter

Type: Procedure

Parameters: String sFile

Parameter | Description
sFile | The file name

Description

The CreateComObjectFromFile message is sent to create a new document and initialize it with data read in from the file passed in the sFile parameter.

The embedded object wrapper class determines the type of document that is created.

The file name passes in the sFile parameter must be of a format that is understood by the OLE server application that is associated with the embedded object you are creating.

The example below demonstrates the use of CreateComObjectFromFile to choose a file, create a new MS Word 8 document and read the selected file into the new document.

Procedure OnClick
    String sFileName
    Boolean bIsCreated

    // only create a new document If we are Not already attached
    // to one.
    Get IsComObjectCreated of oWordDocument To bIsCreated
    If (Not(bIsCreated)) Begin
        // Use the open file dialog to Get the filename we
        // wish to open.
        If (Show_Dialog(oOpen_dlg)) Begin
            Get File_Name of oOpen_dlg To sFileName
            Send CreateComObjectFromFile of oWordDocument sFileName
        End
    End
End_Procedure

Last Edited: June 22, 2005


DFComDocumentObject [Procedure SaveToFile]

SaveToFile - DFComDocumentObject

Type: Procedure

Parameters: String sFile

Parameter | Description
sFile | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Properties for DFComDocumentObject

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfComUIObject
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfComUIObject
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfComUIObject
Color | Sets the background color of the object | DfComUIObject
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfComUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfComUIObject
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfComUIObject
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfComUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfComUIObject
peAutoCreate | Manipulates COM Object instantiation | DfInPlaceComObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piMaxSize | Determines the limit of the maximum size that a Component can be | DfComUIObject
piMinSize | Determines the limit of the minimum size that a Component can be | DfComUIObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psLicenseKey | Contains the license key when ActiveX controls use a run-time license | DfInPlaceComObject
psProgID | Holds the CLSID (class ID) of the COM class represented | DfInPlaceComObject
pvComObject | Returns an IDispatch pointer to the external COM object | DfInPlaceComObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Shadow_State | Determines if item is enabled (not shadowed) | DfComUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
TextColor | Sets the text color of the object | DfComUIObject
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfComUIObject
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfComUIObject


DfComUIObject [Event Command]

Command - DfComUIObject

Sent from external controls

Type: Event

Parameters: Integer wParam Integer lParam

Parameter | Description
wParam | Windows w param
lParam | Windows l param

Description

Command messages are sent from external controls. They are cancelled in this class.

Last Edited: August 5, 2003


DfComUIObject [Event Key]

Key - DfComUIObject

Augmented to implement the GUI keyboard interface

Type: Event

Return Data Type: Integer

Parameters: Integer iKeyValue

Parameter | Description
iKeyValue | The key value

Return Value

Returns a Key value

Description

The Key message is augmented to implement the GUI keyboard interface.

You can augment this message to intercept keystrokes by the user and act on them.
You can also overwrite or intercept this message to disallow keyboard input or to ignore certain keyboard input.

Sample

This sample overwrites this message to disallow all keyboard input in the current object or class.

Procedure Key Integer iKeyVal
End_Procedure  // Key

Sample

This sample augments this message to disallow all keyboard of digits 0-9 in the current object or class.

Procedure Key Integer iKeyVal
    // 48 = '0', 57 = '9'
    if ((iKeyVal<48) and (iKeyVal>57)) ;
        forward send Key IKeyVal
End_Procedure  // Key

See Also

KeyAction

Last Edited: August 16, 2004


Events for DfComUIObject

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls |
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Key | Augmented to implement the GUI keyboard interface |
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for DfComUIObject

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object |
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject


DfComUIObject [Procedure Adjust_Logicals]

Adjust_Logicals - DfComUIObject

Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object

Type: Procedure

Parameters: No Parameters

Description

The Adjust_logicals message sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object. Adjust_Logicals sets the Size and/or Location properties, and should be sent anytime an object's physical size or location (GuiSize, GuiLocation) is directly set.

Set Guilocation to  20  30
Set GuiSize     to 100 200
Send Adjust_Logicals

Last Edited: August 5, 2003


DfComUIObject [Procedure Release_Mouse_Capture]

Release_Mouse_Capture - DfComUIObject

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Properties for DfComUIObject

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object |
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  |
Color | Sets the background color of the object |
Container_Handle | Returns the Windows window handle of the DataFlex object's container |
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object |
GuiSize | Determines the size (height and width) of the object expressed in physical pixels |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  |
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piMaxSize | Determines the limit of the maximum size that a Component can be |
piMinSize | Determines the limit of the minimum size that a Component can be |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Shadow_State | Determines if item is enabled (not shadowed) |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
TextColor | Sets the text color of the object |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object |
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages |


DfComUIObject [Property Absolute_Guiorigin]

Absolute_Guiorigin - DfComUIObject

Returns the screen coordinates of the top left corner of a DataFlex object

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Absolute_GUIorigin function returns the screen coordinates of the top left corner of a DataFlex object; it is the absolute GUILocation of the Windows Desktop.

Last Edited: August 5, 2003


DfComUIObject [Property Border_Style]

Border_Style - DfComUIObject

Specifies the border style of this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Border_Style property specifies the border style of this object. While all border styles are valid, not all styles are appropriate.

The useful styles are:

Constant | Meaning
Border_None | Displays no border
Border_Dialog | Displays a raised 3D border
Border_Normal | Displays a dark line around the border
Border_Thick | Displays tick border, allows panel to be resized
Border_ClientEdge | Displays a border with a sunken edge
Border_StaticEdge | Displays a lowered 3D border
Border_WindowEdge | Displays a border with a raised edge

Set Border_Style to Border_Thick

A 3D line may be drawn around a container by using the group class. Non-visual groupings are usually created using the container class.

Default is Border_Dialog.

Last Edited: October 12, 2004


DfComUIObject [Property Client_Size]

Client_Size - DfComUIObject

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


DfComUIObject [Property Color]

Color - DfComUIObject

Sets the background color of the object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Color property sets the background color of the object. This is passed a single value representing an RGB color. Individual Red, Green, and Blue colors are converted to a single value by using the RGB function.

If no value is specifically set, a default color setting is used. The default is stored in a global integer named default_current_item_color. Its default value is aqua (rgb(0, 255, 255)). You may change this value in your program.

Set Color to (rgb(255, 0, 0)) // red
Set Color to clPurple
Set Color to clBtnFace

Note:The rgb.pkg package contains names for most of commonly used colors and names for all system colors.

Last Edited: August 12, 2005


DfComUIObject [Property Container_Handle]

Container_Handle - DfComUIObject

Returns the Windows window handle of the DataFlex object's container

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Container_Handle function returns the Windows window handle of the DataFlex object's container. If the object is a container object (e.g., Container3D), it will return the object's window_handle (i.e., the window handle is the container handle). If the object is a control (e.g., form), it will return its parent container's window_handle.

Note: A window handle (window_handle and container_handle) only exists if the object is currently paged.

Last Edited: August 5, 2003


DfComUIObject [Property GuiLocation]

GuiLocation - DfComUIObject

Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iRowPos Integer iColPos

Parameter | Description
iRowPos | Row position in pixels
iColPos | Column position in pixels

Description

The Guilocation property determines the position (row and column) of the object expressed in physical pixels (the native display-coordinate system) relative to the upper left-hand corner of the containing object.

Normally objects are located using the location message which uses logical coordinates (usually dialog units). Setting logical coordinates also sets the physical (gui) coordinates.

If an object's location is set using the guilocation message the adjust_logicals message should be sent to adjust the object's logical coordinates.

Get Guilocation to RowCol
Move  (hi(RowCol)) to Rw
Move (low(RowCol)) to Col
Set Guilocation to (Rw +20) (Col  10)
Set GuiSize to 100 200
Send Adjust_Logicals

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

The property is set as follows:

Set GuiLocation to iRowPos iColPos

The property is retreived and unpacked as follows:

Get GuiLocation to cxyValue
Move (hi(cxyValue)) to iRowPos
Move (Low(cxyValue)) to iColPos

Last Edited: June 22, 2005


DfComUIObject [Property GuiSize]

GuiSize - DfComUIObject

Determines the size (height and width) of the object expressed in physical pixels

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iHeight Integer iWidth

Parameter | Description
iHeight | Height in pixels
iWidth | Width in pixels

Description

The Guisize property determines the size (height and width) of the object expressed in physical pixels (the native display-coordinate system).

Normally objects are sized using the size message which uses logical coordinates (usually dialog units). Setting logical coordinates also sets the physical (gui) coordinates.

If an object's size is set using the guisize message the adjust_logicals message should be sent to adjust the object's logical coordinates.

Get GuiSize to HeightWidth
Move  (hi(HeightWidth)) to Height
Move (low(HeightWidth)) to Width
Set GuiSize to (Height +20) (Width  10)
Send Adjust_Logicals

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

The property is set as follows:

Set GuiSize to iHeight iWidth

The property is retreived and unpacked as follows:

Get GuiSize to cxyValue
Move (hi(cxyValue)) to iHeight
Move (Low(cxyValue)) to iWidth

Last Edited: June 22, 2005


DfComUIObject [Property Mouse_Capture]

Mouse_Capture - DfComUIObject

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer Arg1 Integer iValue

Parameter | Description
Arg1 | [ToDo: In Progress]
iValue | [ToDo: In Progress]

Description

Last Edited: July 11, 2006


DfComUIObject [Property peAnchors]

peAnchors - DfComUIObject

Describes how you want the control to react whenever its container changes size

Type: Property

Access: Read/Write

Data Type: Integer

Description

peAnchors describes how you want the control to react whenever its container (dbView, Group, etc.) changes size. It has been added to all controls (any visual objects), which ensures that the control retains the distance to the edges that it is anchored against, whenever the parent's size is changed.

Set peAnchors to one of the following constants:

Constant | Meaning
anNone | The control should do nothing when the parent changes size.
anAll | The control will maintain the same distance to the top, bottom, left and right edges of the parent. This will result in the control's height changing when the parent's does, and its width changing when its parent's does.
anBottomLeft | The control will maintain the same distance to the bottom and left edges. This will result in the control moving when the parent is resized.
anBottomLeftRight | The control will maintain the same distance to the bottom, left and right edges of the parent. This will result in the control getting wider when the width of the parent is changed and the control moving vertically when the parent's height is changed.
anBottomRight | The control will maintain the same distance to the bottom and right edges of the parent. This will result in the control moving vertically and horizontally when the width and height of the parent is changed.
anTopBottomLeft | The control will maintain the same distance to the top, bottom and left edges of the parent. This will result in the control changing its height when the parent is resized.
anTopBottomRight | The control will maintain the same distance to the top, bottom and right edges of the parent. This will result in the control's height changing and the control moving horizontally when the height and width of the parent is changed.
anTopLeftRight | The control will maintain the same distance to the top, left and right edges of the parent. This will result in the control getting wider when the width of the parent is changed.
anTopRight | The control will maintain the same distance to the top and right edges of the parent. This will result in the control moving horizontally when the width of the parent is changed.

The following anchor constants are also valid, but are not exposed in the Studio, since they are equivalent to one of the exposed constants listed above:

Constant | Meaning
anBottom | The control will maintain the same distance from the bottom edge of the parent. The control will move vertically when its parent's height is changed.
anLeft | The control will maintain the same distance from the left edge of the parent. The control will not move or resize itself.
anLeftRight | The control will maintain the same distance to the left and right edges of the parent. This will result in the control getting wider when the width of the parent is changed.
anRight | The control will maintain the same distance to the right edge of the parent. This will result in the control moving horizontally when the width of the parent is changed.
anTop | The control will maintain the same distance from the top edge of the parent. The control will not move or resize itself.
anTopBottom | The control will maintain the same distance from the top and bottom edges of the parent. The control's height will change when its parent's height is changed.
anTopLeft | The control will maintain the same distance from the left and top edges of the parent. The control will not move or resize itself.

Note: You will need to ensure that you set the Component's Border_Style property to Border_Thick; otherwise, you will not be able to resize the border, meaning that the Components can never get bigger, which, in turn, also means that none of the child control's anchors will ever be applied.

Think carefully about how you want to set the anchors. It is entirely possible to set anchors in such a way that they will not logically work together. For example, if you have two Forms on the same row and you set them both to anchor left-and-right, they will overlap each other, as the Component gets wider (the first Form's right edge will go beyond the left-unmoving-edge of the second Form.). The solution would be to make one anchor left-and-right, but the other to be anchored left (if it was the first control) or right (if it was the second control). Alternatively, if you really want them both to get wider, then put them on different rows.

Last Edited: July 26, 2006


DfComUIObject [Property piMaxSize]

piMaxSize - DfComUIObject

Determines the limit of the maximum size that a Component can be

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iHeight Integer iWidth

Parameter | Description
iHeight | The maximum allowed height
iWidth | The maximum allowed width

Description

Allowing the end-user to change the sizes of Components (dbView, ModalPanels, etc.) brings a new challenge: specifically, the temptation to see what happens when the Component is shrunk as small as it will go. There is to limit the minimum size that a Component can be. You achieve this by setting the piMinSize property. The piMinSize property follows the same pattern as Size. That is, you set piMinSize in the same way that you set the Size:

Set Size To 100 250
Set piMinSize To 100 250

In the preceding example, the Component's minimum size will be the same as the size of the object, meaning that it can only get larger. If you wish, you can set it to be smaller, but test it to be certain that it cannot be shrunk to an unacceptable size.

You can control the maximum size to which a Component can be resized by setting the piMaxSize property:

Set Size To 100 100
Set piMinSize To 50 50
Set piMaxSize To 200 600

piMinSize and piMaxSize, have been added to the Component object (dbView, ModalPanel, etc) that limit the size to which the Component can be resized.

You need to ensure that you set the Component's Border_Style property to Border_Thick (which is not the default); otherwise, Windows will not let the end-user change the size of the Component.

Think carefully about how you want to set the anchors. It is entirely possible to set anchors in such a way that they will not logically work together. For example, if you have two Forms on the same row and you set them both to anchor left-and-right, they will overlap each other, as the Component gets wider (the first Form's right edge will go beyond the left-unmoving-edge of the second Form.). The solution would be to make one anchor left-and-right, but the other to be anchored left (if it was the first control) or right (if it was the second control). Alternatively, if you really want them both to get wider, then put them on different rows.

Last Edited: September 11, 2003


DfComUIObject [Property piMinSize]

piMinSize - DfComUIObject

Determines the limit of the minimum size that a Component can be

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iHeight Integer iWidth

Parameter | Description
iHeight | The minimum allowed height
iWidth | The minimum allowed width

Description

Allowing the end-user to change the sizes of Components (dbView, ModalPanels, etc.) brings a new challenge: specifically, the temptation to see what happens when the Component is shrunk as small as it will go. There is to limit the minimum size that a Component can be. You achieve this by setting the piMinSize property. The piMinSize property follows the same pattern as Size. That is, you set piMinSize in the same way that you set the Size:

Set Size To 100 250
Set piMinSize To 100 250

In the preceding example, the Component's minimum size will be the same as the size of the object, meaning that it can only get larger. If you wish, you can set it to be smaller, but test it to be certain that it cannot be shrunk to an unacceptable size.

You can control the maximum size to which a Component can be resized by setting the piMaxSize property:

Set Size To 100 100
Set piMinSize To 50 50
Set piMaxSize To 200 600

piMinSize and piMaxSize, have been added to the Component object (dbView, ModalPanel, etc) that limit the size to which the Component can be resized.

You need to ensure that you set the Component's Border_Style property to Border_Thick (which is not the default); otherwise, Windows will not let the end-user change the size of the Component.

Think carefully about how you want to set the anchors. It is entirely possible to set anchors in such a way that they will not logically work together. For example, if you have two Forms on the same row and you set them both to anchor left-and-right, they will overlap each other, as the Component gets wider (the first Form's right edge will go beyond the left-unmoving-edge of the second Form.). The solution would be to make one anchor left-and-right, but the other to be anchored left (if it was the first control) or right (if it was the second control). Alternatively, if you really want them both to get wider, then put them on different rows.

Last Edited: September 11, 2003


DfComUIObject [Property Shadow_State]

Shadow_State - DfComUIObject

Determines if item is enabled (not shadowed)

Type: Property

Access: Read/Write

Data Type: Boolean

Parameters: Integer iItem Boolean bShadowed

Parameter | Description
iItem | The item number
bShadowed | True if disable/shadowed, false if enabled/not shadowed

Description

Shadowing an item affects both its appearance and its functionality. A shadowed item will be displayed in the shadowed color (defined by the desktop or its palette). If a user places the selection cursor on a shadowed item, the item will not respond to the kenter key or any mouse action.

set shadow_state 4 to true

if (shadow_state(Self, current)) send ignore_item

Default is false.

Last Edited: August 6, 2004


DfComUIObject [Property TextColor]

TextColor - DfComUIObject

Sets the text color of the object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The TextColor property sets the text color of the object. This is passed a single value representing an RGB color. Individual Red, Green, and Blue colors are converted to a single value by using the RGB function.

If no value is specifically set, a default color setting is used. The default is stored in a global integer named default_current_item_color. Its default value is aqua (rgb(0, 255, 255)). You may change this value in your program.

Set TextColor to (rgb(255, 0, 0)) // red
Set TextColor to clPurple
Set TextColor to clBtnFace

Note:The rgb.pkg package contains names for most of commonly used colors and names for all system colors.

Last Edited: August 12, 2005


DfComUIObject [Property Window_Handle]

Window_Handle - DfComUIObject

Returns the Windows window handle of the DataFlex object

Type: Property

Access: Read-Only

Data Type: Handle

Description

The Window_handle property returns the Windows window handle of the DataFlex object.

When a DataFlex object is paged (as part of activation) it creates the required windows object. The window object is identified by its window_handle. When the DataFlex object is deactivated, the window object is destroyed and window_handle is reset to 0. Therefore a window handle (window_handle or container_handle) only exists if the DataFlex object is currently paged.

Last Edited: September 15, 2003


DfComUIObject [Property Windows_Override_State]

Windows_Override_State - DfComUIObject

Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Windows_Override_State allows Visual DataFlex to stop the default Microsoft Windows behavior for mouse and keyboard messages. When set to true, the standard Windows behavior is canceled and the developer may send Visual DataFlex messages to handle the event. This stops the standard Windows beahvior.

Default is False.

If your Visual DataFlex program responds on a Windows message (mapped to a Visual DataFlex procedure via External_Message) and you want to pass a value back to the program sending the message, you need to set this property to True.

Example

Procedure Construct_Object
    Forward Send Construct_Object
    ...
    Set External_Message WM_FOO To msg_Foo
    ...
End_Procedure  // Construct_Object

Procedure Foo Integer wParam Integer lParam Returns Integer
    ...
    Set Windows_Override_State To True
    Procedure_Return 2 // The value to be returned
End_Procedure  // Foo

Last Edited: November 24, 2004


DfInPlaceComObject [Event OnCreate]

OnCreate - DfInPlaceComObject

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Events for DfInPlaceComObject

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfComUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Key | Augmented to implement the GUI keyboard interface | DfComUIObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCreate |  |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


DfInPlaceComObject [Function ComQueryInterface]

ComQueryInterface - DfInPlaceComObject

Type: Function

Return Data Type: Variant

Parameters: String Arg1

Parameter | Description
Arg1 | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for DfInPlaceComObject

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfComUIObject
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
ComAddref | Procedure |  |
ComQueryInterface | Function |  |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
CreateComObject | Procedure | Sent to create and connect to an instance of the ActiveX control associated with this object |
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
RegisterComEvent | Procedure |  |
RegisterPropertyChangeEvent | Procedure |  |
Release_Mouse_Capture | Procedure |  | DfComUIObject
ReleaseComObject | Procedure | Releases ActiveX control associated with this object |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject


DfInPlaceComObject [Procedure ComAddref]

ComAddref - DfInPlaceComObject

Type: Procedure

Parameters: No Parameters

Description

Last Edited: July 30, 2003


DfInPlaceComObject [Procedure CreateComObject]

CreateComObject - DfInPlaceComObject

Sent to create and connect to an instance of the ActiveX control associated with this object

Type: Procedure

Parameters: No Parameters

Description

CreateComObject is sent to create and connect to an instance of the ActiveX control associated with this object.

You would not normally send this message to an ActiveX wrapper object. Instead, creating and releasing the ActiveX control is performed automatically. This behavior is controlled by the peAutoCreate property.

See Also

cComActiveXControl | ReleaseComObject | peAutoCreate | OnCreate

Last Edited: July 31, 2003


DfInPlaceComObject [Procedure RegisterComEvent]

RegisterComEvent - DfInPlaceComObject

Type: Procedure

Parameters: Integer Arg1 Integer Arg2

Parameter | Description
Arg1 | [ToDo: In Progress]
Arg2 | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


DfInPlaceComObject [Procedure RegisterPropertyChangeEvent]

RegisterPropertyChangeEvent - DfInPlaceComObject

Type: Procedure

Parameters: Integer Arg1 Integer Arg2

Parameter | Description
Arg1 | [ToDo: In Progress]
Arg2 | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


DfInPlaceComObject [Procedure ReleaseComObject]

ReleaseComObject - DfInPlaceComObject

Releases ActiveX control associated with this object

Type: Procedure

Parameters: No Parameters

Description

ReleaseComObject is sent to release ActiveX control associated with this object.

You would not normally send this message to an ActiveX wrapper object. Instead, creating and releasing the ActiveX control is performed automatically. This behavior is controlled by the peAutoCreate property.

See Also

cComActiveXControl | CreateComObject | peAutoCreate | OnCreate

Last Edited: September 11, 2003


Properties for DfInPlaceComObject

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfComUIObject
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfComUIObject
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfComUIObject
Color | Sets the background color of the object | DfComUIObject
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfComUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfComUIObject
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfComUIObject
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfComUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfComUIObject
peAutoCreate | Manipulates COM Object instantiation |
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
piMaxSize | Determines the limit of the maximum size that a Component can be | DfComUIObject
piMinSize | Determines the limit of the minimum size that a Component can be | DfComUIObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psLicenseKey | Contains the license key when ActiveX controls use a run-time license |
psProgID | Holds the CLSID (class ID) of the COM class represented |
pvComObject | Returns an IDispatch pointer to the external COM object |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Shadow_State | Determines if item is enabled (not shadowed) | DfComUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
TextColor | Sets the text color of the object | DfComUIObject
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfComUIObject
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfComUIObject


DfInPlaceComObject [Property peAutoCreate]

peAutoCreate - DfInPlaceComObject

Manipulates COM Object instantiation

Type: Property

Access: Read/Write

Data Type: Integer

Description

COM Object instantiation can be manipulated via the peAutoCreate property.

Possible Values

Constant | Meaning
acNoAutoCreate | Do not automatically instantiate the COM object upon VDF object creation. You must manually instantiate the COM object using CreateComObject
acAutoCreate | Automatically instantiate the COM object upon VDF object creation. You won't need to manually instantiate the COM object.
acDeferredAutoCreate | Automatically instantiate the COM object when it is paged (during Activate), and to be automatically destroyed when it is unpaged (during Deactivate).

For ActiveX controls, the default peAutoCreate value is acDeferredAutoCreate.

For ActiveX controls you also have the option of setting peAutoCreate to acAutoCreate. This automatically instantiates the COM object when its VDF COM wrapper object is created. This means that the COM object will now exist and retain its state even when it's not paged, just like any other VDF control. This might seem like the most desirable setting for all ActiveX controls but you need to be careful when using the acAutoCreate setting. Certain ActiveX controls exhibit problems when invoking methods and setting properties while they're not displayed. For that reason the setting of acDeferredAutoCreate is considered safe in all cases. If you want your ActiveX control to retain its state while it is not visible, then you can use the acAutoCreate setting but it will be up to you to ensure that the control will operate without errors.

Some ActiveX controls are not visible by design. In these cases it is better for the COM object to be created at the same time as its VDF wrapper. This is because controls that are invisible, are controls that won't have any problems with setting properties when they're not displayed (they will never be displayed). Also, controls that are invisible are also controls that you are likely to want to use as soon as the VDF wrapper object has been created. The FlexCOM class generator has been designed to take this into consideration. It detects whether the object is invisible at runtime, and then sets peAutoCreate property of the generated wrapper class to acAutoCreate if it is invisible at runtime; otherwise it is set acDeferredAutoCreate.

See Also

cComActiveXControl

Last Edited: September 11, 2003


DfInPlaceComObject [Property psLicenseKey]

psLicenseKey - DfInPlaceComObject

Contains the license key when ActiveX controls use a run-time license

Type: Property

Access: Read/Write

Data Type: String

Description

The psLicenseKey property contains the license key when ActiveX controls use a run-time license. Some ActiveX controls use a run-time license, in which case this property would contain the license key.

See Also

cComActiveXControl

Last Edited: September 11, 2003


DfInPlaceComObject [Property psProgID]

psProgID - DfInPlaceComObject

Holds the CLSID (class ID) of the COM class represented

Type: Property

Access: Read/Write

Data Type: String

Description

The psProgID property is used to hold the CLSID (class ID) of the COM class represented.

The CLSID is a 128-bit integer, which is a GUID (Globally Unique Identifier) that uniquely identifies a COM class.

128-bit numbers are too large to store as an Integer type. The CLSID is instead stored as a string with the following format.

'{xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx}'

You should not change this Property.

See Also

cComActiveXControl

Last Edited: September 11, 2003


DfInPlaceComObject [Property pvComObject]

pvComObject - DfInPlaceComObject

Returns an IDispatch pointer to the external COM object

Type: Property

Access: Read/Write

Data Type: Variant

Description

pvComObject is a variant property which returns an IDispatch pointer to the external COM object.

Setting this property to the correct IDispatch* value connects a VDF wrapper object to its corresponding external COM object and increments the COM object's reference count.

Changing the pvComObject property or setting it to NULL (using the NullComObject function) automatically releases any reference to the IDispatch pointed to by the old property value. Destroying the VDF wrapper object also automatically releases the reference to the COM object.

This property is automatically assigned and released when sending CreateComObject and ReleaseComObject.

Variant-type variables can be used to store IDispatch* values.
Note:The VDF runtime protects against pointer arithmetic and comparison expressions for variant variables containing an IDispatch*. Doing so would raise a runtime error. The helper functions IsNullComObject and IsSameComObject can be used to perform any operations that you would normally require on variants containing IDispatch* values.

See Also

cComActiveXControl

Last Edited: September 11, 2003


DFTimer [Event OnTimer]

OnTimer - DFTimer

Sent every time the timeout interval passes

Type: Event

Parameters: Integer iwParam Integer ilParam

Parameter | Description
iwParam | not used (sent by windows)
ilParam | not used (sent by windows)

Description

The OnTimer message is sent every time the timeout interval passes. By default, it sends timer_message to timer_object. You may augment or override this message for any behavior that you desire on the timer event.

Last Edited: September 10, 2003


Events for DFTimer

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | TextBox
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnTimer | Sent every time the timeout interval passes |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | TextBox


Methods for DFTimer

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | TextBox
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | TextBox
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | TextBox
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | TextBox
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | TextBox
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | TextBox
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | TextBox
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for DFTimer

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Size_State | Determines if textbox object will automatically size itself | TextBox
Auto_Start_State | Specifies whether this object will initialize when its container object is activated |
Auto_Stop_State | Specifies whether this object will stop running when its container object is deactivated |
Bitmap | Displays a bitmap in an object | TextBox
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | TextBox
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | TextBox
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Shadow_State | Determines if an object's item is enabled or disabled | TextBox
Justification_Mode | Aligns the text in the control | DfBaseTextbox
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | TextBox
Label_Shadow_Display_Mode | Controls under what conditions this object is shadowed | TextBox
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | TextBox
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Timeout | Contains the number of milliseconds that you wish to pass between each timer event |
Timer_Active_State | Starts and stops the timer |
Timer_Message | Contains the message_id of the message to be sent on every timer event |
Timer_Object | Handle of optional object that timer will send timer_message to |
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


DFTimer [Property Auto_Start_State]

Auto_Start_State - DFTimer

Specifies whether this object will initialize when its container object is activated

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Auto_start_state property specifies whether this object will initialize when its container object is activated. In objects that remain active for long periods, you would normally want to set this property false.

Default is true.

Last Edited: January 12, 2006


DFTimer [Property Auto_Stop_State]

Auto_Stop_State - DFTimer

Specifies whether this object will stop running when its container object is deactivated

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Auto_stop_state property specifies whether this object will stop running when its container object is deactivated.

Default is true.

Last Edited: January 12, 2006


DFTimer [Property Timeout]

Timeout - DFTimer

Contains the number of milliseconds that you wish to pass between each timer event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Timeout property contains the number of milliseconds that you wish to pass between each timer event. The effective resolution of events is about 55 milliseconds, so there would be little point in specifying intervals more-precisely than this.

Default is 1000.

Last Edited: September 11, 2003


DFTimer [Property Timer_Active_State]

Timer_Active_State - DFTimer

Starts and stops the timer

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Timer_active_state property is set true, the timer begins to run, generating timer events. When it is set false again, this process stops.

Default is false.

Last Edited: January 12, 2006


DFTimer [Property Timer_Message]

Timer_Message - DFTimer

Contains the message_id of the message to be sent on every timer event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Timer_message property contains the message_id of the message to be sent on every timer event. You must define that message, or define an onTimer procedure, in which case you need not set this property.

Last Edited: September 11, 2003


DFTimer [Property Timer_Object]

Timer_Object - DFTimer

Handle of optional object that timer will send timer_message to

Type: Property

Access: Read/Write

Data Type: Integer

Description

If you wish the timer_message to be sent to an object other than Timer_object, you can arrange this by setting this property to the object_id of that object.

Last Edited: September 11, 2003


Dialog [Event OnPaint]

OnPaint - Dialog

Sent every time a panel is painted

Type: Event

Parameters: No Parameters

Description

The OnPaint event message is sent every time a panel is painted.

Last Edited: September 10, 2003


Dialog [Event OnResize]

OnResize - Dialog

Sent every time a panel is resized

Type: Event

Parameters: No Parameters

Description

The OnResize event message is sent every time a panel is resized. This message is only sent when the panel is active (paged on the screen). It is also sent when the panel is being paged. This message is most-often used to size and locate child objects when a panel has been paged or resized.

Procedure onResize
    // locate and size child objects relative to the size of the parent
    Broadcast Send Locate_yourself
End_procedure

Last Edited: September 10, 2003


Events for Dialog

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnPaint | Sent every time a panel is painted |
OnResize | Sent every time a panel is resized |
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d


Methods for Dialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated |
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Dialog [Procedure Close_Panel]

Close_Panel - Dialog

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Dialog [Procedure Popup_Modal]

Popup_Modal - Dialog

Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns non-zero if popup failed (this value is normally not used)

Description

The Popup_modal message activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated. This message sets the modal_state property true until this object is deactivated, at which time it is restored to false. This message has no effect on an already-active object.

Send Popup_modal to oCustomerList

Last Edited: September 25, 2003


Dialog [Procedure Stop_Modal_UI]

Stop_Modal_UI - Dialog

Causes the modal object to deactivate

Type: Procedure

Parameters: No Parameters

Description

When the Stop_modal_ui message is received, the current user interface is terminated. This causes the modal object to deactivate.

Last Edited: September 11, 2003


Properties for Dialog

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  |
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Dialog [Property Current_Action_Button]

Current_Action_Button - Dialog

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


Dialog [Property Default_Action_Button]

Default_Action_Button - Dialog

The object handle of the default action button

Type: Property

Access: Read/Write

Data Type: Integer

Description

A single button object within a panel/dialog object may be designated as the default-action button. This button is assigned by setting its default_action_button property. This property is not normally set directly. Instead, you will usually set the default_state of the button (which, in turn, will set the Default_action_button property). The following two samples will exhibit the same behavior.

Object OK_bn is a Button
    Set Label to "&Ok"
    Set Location to 115 152
    Set default_state to TRUE
    Procedure OnClick
        Send Save_record
    End_Procedure
End_Object

and:

Object OK_bn is a Button
    Set Label to "&Ok"
    Set Location to 115 152
    Procedure OnClick
        Send Save_record
    End_Procedure
End_Object
Set default_action_button to Ok_bn

See default_state in the button class for more information on default action buttons.

Last Edited: July 31, 2003


Dialog [Property Modal_State]

Modal_State - Dialog

Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated

Type: Property

Access: Read/Write

Data Type: Boolean

Description

This property is set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, and false when the object popped up by popup_modal is deactivated. When this property is set to true, the following properties are set:

Block_mouse_State | true
Attach_Parent_State | false
Scope_State | true
Ring_State | true
Popup_State | true

When this property is set to false, the following properties are set:

Block_mouse_State | false
Attach_Parent_State | true

Normally you will not set this property to false since this is the default. If you need to alter these individual property settings, you can either augment the modal_state procedure set or you can simply adjust any of the individual properties after you have set the modal_state.

If you wish to toggle an object's modality during runtime, it is suggested that you not set this property. You will need the object in its default modeless state. The object can then be activated non-modally by sending it the activate message and activated modally by sending it the popup_modal message.

Default is false.

Last Edited: January 12, 2006


Edit [Event OnBeginningOfPanel]

OnBeginningOfPanel - Edit

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


Edit [Event OnChange]

OnChange - Edit

Sent every time the edit buffer is changed

Type: Event

Parameters: No Parameters

Description

The OnChange event message is sent every time the edit buffer is changed. When entering text in the buffer this message is sent after each keystroke.

Note:The OnChange event should not be used to change focus or to alter the value of controls such as Form or ComboForm.

This event is created to respond to a data change event and not to trigger other data changes. If you want to respond to a change in a combo based on a user selection, it is suggested you augment other procedures such as Combo_Item_Changed and Combo_Edit_Changed.

Last Edited: February 18, 2004


Edit [Event OnKillFocus]

OnKillFocus - Edit

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


Edit [Event OnMaxText]

OnMaxText - Edit

Sent when the edit buffer is full and an attempt has been made to add additional data to the buffer

Type: Event

Parameters: No Parameters

Description

The OnMaxText event message is sent when the edit buffer is full and an attempt has been made to add additional data to the buffer. By default, this does nothing and is intended for augmentation.

Last Edited: September 10, 2003


Edit [Event OnSetFocus]

OnSetFocus - Edit

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


Edit [Event Prompt_Callback]

Prompt_Callback - Edit

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


Edit [Event Shadow_Display]

Shadow_Display - Edit

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for Edit

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange | Sent every time the edit buffer is changed |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus |
OnMaxText | Sent when the edit buffer is full and an attempt has been made to add additional data to the buffer |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |


Edit [Function Next_Object_Id]

Next_Object_Id - Edit

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


Edit [Function Prior_Object_Id]

Prior_Object_Id - Edit

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for Edit

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Append_Text | Procedure | Inserts data to the end of the existing contents of the object | DfBaseEdit
Beginning_of_Data | Procedure | Moves the cursor to the beginning of the data in the object | DfBaseEdit
Beginning_of_Line | Procedure | Moves then cursor to the beginning of the current line | DfBaseEdit
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseEdit
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseEdit
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseEdit
Delete_Char | Procedure | Deletes the character under the cursor | DfBaseEdit
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Destroys all of the data in the object and returns the edit cursor to the top of the buffer | DfBaseEdit
Delete_Line | Procedure | Deletes the current line | DfBaseEdit
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
Down | Procedure | Moves the cursor down one line | DfBaseEdit
End_of_Data | Procedure | Moves the cursor to the end of the data | DfBaseEdit
End_of_Line | Procedure | Moves the cursor to the end of the current line | DfBaseEdit
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Find | Procedure | Searches the text in an edit window | DfBaseEdit
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Insert | Procedure | Inserts a string of text into the edit buffer at the current cursor location | DfBaseEdit
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Left | Procedure | Moves the cursor one space to the left | DfBaseEdit
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Moves the edit cursor down one page | DfBaseEdit
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Moves the edit cursor up one page | DfBaseEdit
Paste | Procedure | Copies the contents of the Clipboard into this object at the current cursor position | DfBaseEdit
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Read | Procedure | Imports information from an external source to the Edit object's buffer | DfBaseEdit
Read_Dbms | Procedure | Reads information from a database file | DfBaseEdit
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Replace | Procedure | Finds and Replaces Text in an edit object | DfBaseEdit
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Reset_Find | Procedure | Causes the next find to search from the start of the text | DfBaseEdit
Reset_Replace | Procedure | Causes the next replace to search from the start of the text. | DfBaseEdit
Right | Procedure | Moves the cursor one space to the right | DfBaseEdit
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Select | Procedure | Marks the text in the editor beginning at position iPosition for the number of bytes set in charcount | DfBaseEdit
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Undo | Procedure | Will undo the last change in the edit | DfBaseEdit
Up | Procedure | Moves the edit cursor up one line | DfBaseEdit
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Write | Procedure | Writes the contents of the edit buffer to the specified file | DfBaseEdit
Write_Dbms | Procedure | Writes information from the edit buffer to a database field | DfBaseEdit


Edit [Procedure Activate_Area]

Activate_Area - Edit

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Edit [Procedure Beginning_of_Panel]

Beginning_of_Panel - Edit

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


Edit [Procedure Bottom_of_Panel]

Bottom_of_Panel - Edit

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


Edit [Procedure DoHtmlHelp]

DoHtmlHelp - Edit

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


Edit [Procedure End_of_Panel]

End_of_Panel - Edit

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


Edit [Procedure Error_Help]

Error_Help - Edit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Edit [Procedure Extended_Help]

Extended_Help - Edit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Edit [Procedure File_Help]

File_Help - Edit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Edit [Procedure Help]

Help - Edit

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Edit [Procedure Help_For_Help]

Help_For_Help - Edit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Edit [Procedure Help_Index]

Help_Index - Edit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Edit [Procedure Help_on_topic]

Help_on_topic - Edit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Edit [Procedure Keys_Help]

Keys_Help - Edit

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Edit [Procedure Request_Status_Help]

Request_Status_Help - Edit

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


Edit [Procedure Top_of_Panel]

Top_of_Panel - Edit

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for Edit

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Capslock_State | Determines if all text displayed will be in upper-case letters |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Edit_Buffer_Count | The number of characters currently in the object | DfBaseEdit
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
File_Name | Used whenever a read or write message is sent to the Edit object and a file_name parameter is not specified | DfBaseEdit
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object |
Label_Col_Offset | The horizontal distance from the object to its label |
Label_Justification_Mode | The justification mode for the text within this object's label |
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property |
Label_Row_Offset | The vertical distance from the top edge of the object and its label |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Count | Returns number of "lines" in Edit object | DfBaseEdit
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Position | Returns the location of the cursor in the object | DfBaseEdit
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Read_Only_State | Allows you to protect the contents of the buffer while still allowing users freedom to navigate | DfBaseEdit
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
Text_Limit | The number of characters that can be entered into the edit | DfBaseEdit
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value | Determines the value of an item/paragraph |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Governs whether strings of text input will break and wrap to the next line at the end of this object, or will continue onward on the same line until a carriage return/linefeed is input |


Edit [Property Capslock_State]

Capslock_State - Edit

Determines if all text displayed will be in upper-case letters

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Capslock_state property is set true, all text displayed by this object is displayed in upper-case letters. This property cannot be changed while this object is active; for a change made while the program is running to take effect, the object must be (deactivated and) activated after this property has been set to the desired value.

Default is false.

Last Edited: January 12, 2006


Edit [Property Enabled_State]

Enabled_State - Edit

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


Edit [Property Explicit_Shadow_State]

Explicit_Shadow_State - Edit

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


Edit [Property Help_id]

Help_id - Edit

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


Edit [Property Help_Keyword]

Help_Keyword - Edit

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


Edit [Property Item_Shadow_State]

Item_Shadow_State - Edit

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


Edit [Property Label]

Label - Edit

Sets the text for a label or heading for an entry control object

Type: Property

Access: Read/Write

Data Type: String

Description

The Label property sets the text for a label or heading for an entry control object (form, edit or list). In most classes, just setting this property is all that is required for the class to present the label in whatever particular way each class does this. In data-aware classes, the value of this property is overridden by label values in the DDO when auto_label_state has been set true.

Object F1 is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "First Name:"
End_object

Last Edited: August 18, 2003


Edit [Property Label_Col_Offset]

Label_Col_Offset - Edit

The horizontal distance from the object to its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Col_Offset is the horizontal distance from the object to its label. Units represent distance to the left (i.e., labels appear to the left of their object). If the label's justification-mode is left or top (jmode_left, jmode_top) this represents the distance from left edge of the object to the left edge of its label. If the justification-mode is right (jmode_right) this represents the distance from the left edge of the object to the right edge of the label. By default, this is the value of default_label_offset, which is supplied with a value of 60 (this is a global integer which can be changed).

Default is default label offset.

Last Edited: August 18, 2003


Edit [Property Label_Justification_Mode]

Label_Justification_Mode - Edit

The justification mode for the text within this object's label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Justification_Mode is the justification mode for the text within this object's label.

When the label_justification_mode is changed the row and col offset properties will often need to be changed as well.

The default mode for labels (jmode_left) is stored in the global integer default_label_jmode.

Object LeftForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Left Justify:" // use default column of 60
End_object

Object RightForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Right Justify:"
    Set label_justification_mode to jmode_right
    // set distance between right side of the label and the left side
    // of the object
    Set label_col_offset to 3
End_object

Object TopForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Top Justify:"
    Set label_justification_mode to jmode_top
    // label and object will align vertically
    Set label_col_offset to 0
End_object

Default is JMode Left.

Last Edited: August 18, 2003


Edit [Property Label_Offset]

Label_Offset - Edit

Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer i1 integer i2

Parameter | Description
i1 | The Row Offset of the Label
i2 | The Column Offset of the Label

Description

The Label_Offset property returns both the label_row_offset and the label_col_offset properties as a single (two-component) property. The Hi() value of the return parameter represents the row offset. The Low() value represents the column offset.

Get Label_Offset of oForm to iOffset
Move (Hi(iOffset))  to iRowOffset
Move (Low(iOffset)) to iColumnOffset

Label_offset is set as a single property passing the row offset and the column offset as two separate parameters.

Set Label_Offset of oForm to iRowOffset iColumnOffset

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

Last Edited: June 22, 2005


Edit [Property Label_Row_Offset]

Label_Row_Offset - Edit

The vertical distance from the top edge of the object and its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Row_Offset is the vertical distance from the top edge of the object and its label. If the label's justification-mode is jmode_top it represents the vertical distance from the top edge of this object to the bottom edge of its label and larger numbers moves the label up (and away from the object). If the mode is not top it represents the distance from the top edge of the object and the top edge of the label and larger numbers moves the label down. By default, this is zero which is suitable for both form and side labels.

Default is 0.

Last Edited: August 18, 2003


Edit [Property Object_Shadow_State]

Object_Shadow_State - Edit

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


Edit [Property psHtmlHelpTopic]

psHtmlHelpTopic - Edit

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


Edit [Property Status_Help]

Status_Help - Edit

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


Edit [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - Edit

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


Edit [Property Value]

Value - Edit

Determines the value of an item/paragraph

Type: Property

Access: Write-Only

Data Type: String

Parameters: Integer iItem String sValue

Parameter | Description
iItem | The item/paragraph number
sValue | The value of the item

Description

Before this object is displayed on the screen, each item value sets a paragraph of text that will be reformatted on the display using Windows-default word-wrapping. Once displayed, each item of this object corresponds to one displayed line. Once the object is removed from the screen (via page_delete), each item still corresponds to a line, but inserting or deleting text when the object is not displayed will not cause any word wrap to occur.

Last Edited: September 15, 2003


Edit [Property Wrap_State]

Wrap_State - Edit

Governs whether strings of text input will break and wrap to the next line at the end of this object, or will continue onward on the same line until a carriage return/linefeed is input

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Wrap_state property governs whether strings of text input will break and wrap to the next line at the end of this object (the default behavior), or will continue onward on the same line until a carriage return/linefeed is input. When not wrapping (false), this object will scroll its content so that the point at which input is occurring is visible at all times during input. When true, the text will only be broken by an explicit carriage return/linefeed and a horizontal scroll bar will appear at the bottom of the edit object.

Default is true.

Last Edited: January 12, 2006


Entry [Event Form_Button_Notification]

Form_Button_Notification - Entry

Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message

Type: Event

Parameters: integer Item# integer Dummy

Parameter | Description
Item# | The item number
Dummy | not used

Description

The Form_button_notification message is augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message. This is sent when the prompt button is pressed.

Last Edited: August 18, 2003


Entry [Event OnBeginningOfPanel]

OnBeginningOfPanel - Entry

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


Entry [Event OnChange]

OnChange - Entry

Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message

Type: Event

Parameters: No Parameters

Description

The OnChange event message is sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message. This is a notification. It does nothing by default and is intended for augmentation.

Note:The OnChange event should not be used to change focus or to alter the value of controls such as Form or ComboForm.

This event is created to respond to a data change event and not to trigger other data changes. If you want to respond to a change in a combo based on a user selection, it is suggested you augment other procedures such as Combo_Item_Changed and Combo_Edit_Changed.

See Also

Form

Last Edited: February 18, 2004


Entry [Event OnKillFocus]

OnKillFocus - Entry

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


Entry [Event OnMaxText]

OnMaxText - Entry

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Entry [Event OnSetFocus]

OnSetFocus - Entry

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


Entry [Event Prompt_Callback]

Prompt_Callback - Entry

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


Entry [Event Shadow_Display]

Shadow_Display - Entry

Creates the proper shadowed or unshadowed appearance for this object and its label

Type: Event

Parameters: No Parameters

Description

The Shadow_Display message is called whenever the object's enabled_state is changed. It is responsible for creating the proper shadowed or unshadowed appearance for this object and its label.

See Also

Form

Last Edited: September 11, 2003


Events for Entry

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message |
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus |
OnMaxText |  |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label |
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Entry [Function Help_Datafile]

Help_Datafile - Entry

Returns the filename and fieldname in file.field format that contains help for the current item

Type: Function

Obsolete

Return Data Type: String

Parameters: No Parameters

Return Value

The filename and fieldname in file.field format that contains help for the current item

Description

The Help_datafile function returns the filename and fieldname in file.field format that contains help for the current item.

Last Edited: August 12, 2003


Entry [Function Next_Object_Id]

Next_Object_Id - Entry

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


Entry [Function Prior_Object_Id]

Prior_Object_Id - Entry

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for Entry

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button |
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask |
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask |
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Entry [Procedure Set Currency_Mask]

Currency_Mask - Entry

Provides an easy method for creating a currency mask

Type: Procedure Set

Data Type: String

Parameters: Integer item# Integer LeftDigit Integer RightDigit String DfltMask

Parameter | Description
item# | The item number
LeftDigit | Digits to the left of the decimal separator
RightDigit | Digits to the right of the decimal separator
DfltMask | The mask string to be applied. Optional and normally not passed

Description

This provides an easy method for creating a currency mask. The message is passed the number of digits to the left and right of the decimal separator and an optional template mask. This message will construct a mask, set the object's form_mask to this mask and set the object's form_datatype to mask_current_window.

Normally the template is not passed and the default currency template default_currency_mask is used. Default_currency_mask is a global string (which you may change) which contains the default currency template. Its default value is $,*;($,*), where $ represents the local Windows setting for the currency symbol. If template is passed, it should, at minimum, contain an asterisk. When the mask is constructed, the asterisk is expanded to contain the proper number of left and right digits.

Setting of this property makes it unnecessary to actually set the object's form_datatype to mask_currency_window.

If the object is based on Form or Entry, item# will always be zero.

Set currency_mask 0 to 6 2

Set currency_mask 0 to 8 2 "$,*;$,* "

See Also

Form | Numeric_mask

Last Edited: January 12, 2006


Entry [Procedure Set Numeric_Mask]

Numeric_Mask - Entry

Provides an easy method for creating a numeric mask

Type: Procedure Set

Data Type: String

Parameters: Integer item# Integer LeftDigit Integer RightDigit String DfltMask

Parameter | Description
item# | The item number
LeftDigit | Digits to the left of the decimal separator
RightDigit | Digits to the right of the decimal separator
DfltMask | The mask string to be applied. Optional and normally not passed

Description

This provides an easy method for creating a numeric mask. The message is passed the number of digits to the left and right of the decimal separator and an optional template mask. This message will construct a mask, set the object's form_mask to this mask and set the object's form_datatype to mask_numeric_window.

Normally the template is not passed and the default currency template default_numeric_mask is used. Default_Numeric_mask is a global string (which you may change) which contains the default numeric template. Its default value is "*". If template is passed it should, at minimum, contain an asterisk. When the mask is constructed, the asterisk is expanded to contain the proper number of left and right digits.

Setting of this property makes it unnecessary to actually set the object's form_datatype to mask_numeric_window.

If the object is based on Form or Entry, item# will always be zero.

Set numeric_mask 0 to 4 4

Set numeric_mask 0 to 6 0 "*%"

See Also

Form | Currency_Mask

Last Edited: January 12, 2006


Entry [Procedure Activate_Area]

Activate_Area - Entry

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Entry [Procedure Beginning_of_Panel]

Beginning_of_Panel - Entry

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


Entry [Procedure Bottom_of_Panel]

Bottom_of_Panel - Entry

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


Entry [Procedure Create_Prompt_Button]

Create_Prompt_Button - Entry

Creates or removes a prompt button

Type: Procedure

Parameters: Integer CreateMode

Parameter Description
CreateModethe following modes are supported

Constant | Meaning
PB_promptOn | the button is created
PB_promptOff | the button is removed
PB_promptAuto | the button is created if a prompt object exists (prompt_object_id is non-zero)

Description

Create_Prompt_Button is used internally to create or remove a prompt button. When CreateMode is PB_promptOn, the button is created. When CreateMode is PB_promptOff, the button is removed. When CreateMode is PB_promptAuto, the button is created if a prompt object exists (prompt_object_id is non-zero). There should be no need to send or augment this message. You should be able to control prompt buttons with the prompt_button_mode property.

See Also

Form

Last Edited: August 5, 2003


Entry [Procedure DoHtmlHelp]

DoHtmlHelp - Entry

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


Entry [Procedure End_of_Panel]

End_of_Panel - Entry

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


Entry [Procedure Error_Help]

Error_Help - Entry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Entry [Procedure Extended_Help]

Extended_Help - Entry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Entry [Procedure File_Help]

File_Help - Entry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Entry [Procedure Help]

Help - Entry

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Entry [Procedure Help_For_Help]

Help_For_Help - Entry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Entry [Procedure Help_Index]

Help_Index - Entry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Entry [Procedure Help_on_topic]

Help_on_topic - Entry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Entry [Procedure Keys_Help]

Keys_Help - Entry

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Entry [Procedure Request_Status_Help]

Request_Status_Help - Entry

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


Entry [Procedure Top_of_Panel]

Top_of_Panel - Entry

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for Entry

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Autofind_Item |  | DfBaseEntry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case |
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object |
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object |
Label_Col_Offset | The horizontal distance from the object to its label |
Label_Justification_Mode | The justification mode for the text within this object's label |
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property |
Label_Row_Offset | The vertical distance from the top edge of the object and its label |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form |
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object |
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


Entry [Property Capslock_State]

Capslock_State - Entry

Determines if all text entered to this object from the keyboard will be converted to upper case

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Capslock_State property is set true, all text entered to this object from the keyboard will be converted to upper case. Values set to this object by the program will not be affected by this property. This property cannot be changed while this object is active; for a change made while the program is running to take effect, the object must be (deactivated and) activated after this property has been set to the desired value.

Last Edited: January 12, 2006


Entry [Property Enabled_State]

Enabled_State - Entry

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


Entry [Property Explicit_Shadow_State]

Explicit_Shadow_State - Entry

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


Entry [Property Floating_Menu_Object]

Floating_Menu_Object - Entry

Identifies the floating context menu for this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Floating_Menu_Object property identifies the floating menu for this object. The default setting will provide a standard edit context menu. You may create your own custom floating menus and assign them to objects by setting this property. You may also disable a floating menu by setting this property to zero.

See Also

Form

Last Edited: November 22, 2004


Entry [Property Help_id]

Help_id - Entry

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


Entry [Property Help_Keyword]

Help_Keyword - Entry

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


Entry [Property Item_Shadow_State]

Item_Shadow_State - Entry

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


Entry [Property Label]

Label - Entry

Sets the text for a label or heading for an entry control object

Type: Property

Access: Read/Write

Data Type: String

Description

The Label property sets the text for a label or heading for an entry control object (form, edit or list). In most classes, just setting this property is all that is required for the class to present the label in whatever particular way each class does this. In data-aware classes, the value of this property is overridden by label values in the DDO when auto_label_state has been set true.

Object F1 is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "First Name:"
End_object

Last Edited: August 18, 2003


Entry [Property Label_Col_Offset]

Label_Col_Offset - Entry

The horizontal distance from the object to its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Col_Offset is the horizontal distance from the object to its label. Units represent distance to the left (i.e., labels appear to the left of their object). If the label's justification-mode is left or top (jmode_left, jmode_top) this represents the distance from left edge of the object to the left edge of its label. If the justification-mode is right (jmode_right) this represents the distance from the left edge of the object to the right edge of the label. By default, this is the value of default_label_offset, which is supplied with a value of 60 (this is a global integer which can be changed).

Default is default label offset.

Last Edited: August 18, 2003


Entry [Property Label_Justification_Mode]

Label_Justification_Mode - Entry

The justification mode for the text within this object's label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Justification_Mode is the justification mode for the text within this object's label.

When the label_justification_mode is changed the row and col offset properties will often need to be changed as well.

The default mode for labels (jmode_left) is stored in the global integer default_label_jmode.

Object LeftForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Left Justify:" // use default column of 60
End_object

Object RightForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Right Justify:"
    Set label_justification_mode to jmode_right
    // set distance between right side of the label and the left side
    // of the object
    Set label_col_offset to 3
End_object

Object TopForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Top Justify:"
    Set label_justification_mode to jmode_top
    // label and object will align vertically
    Set label_col_offset to 0
End_object

Default is JMode Left.

Last Edited: August 18, 2003


Entry [Property Label_Offset]

Label_Offset - Entry

Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer i1 integer i2

Parameter | Description
i1 | The Row Offset of the Label
i2 | The Column Offset of the Label

Description

The Label_Offset property returns both the label_row_offset and the label_col_offset properties as a single (two-component) property. The Hi() value of the return parameter represents the row offset. The Low() value represents the column offset.

Get Label_Offset of oForm to iOffset
Move (Hi(iOffset))  to iRowOffset
Move (Low(iOffset)) to iColumnOffset

Label_offset is set as a single property passing the row offset and the column offset as two separate parameters.

Set Label_Offset of oForm to iRowOffset iColumnOffset

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

Last Edited: June 22, 2005


Entry [Property Label_Row_Offset]

Label_Row_Offset - Entry

The vertical distance from the top edge of the object and its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Row_Offset is the vertical distance from the top edge of the object and its label. If the label's justification-mode is jmode_top it represents the vertical distance from the top edge of this object to the bottom edge of its label and larger numbers moves the label up (and away from the object). If the mode is not top it represents the distance from the top edge of the object and the top edge of the label and larger numbers moves the label down. By default, this is zero which is suitable for both form and side labels.

Default is 0.

Last Edited: August 18, 2003


Entry [Property Object_Shadow_State]

Object_Shadow_State - Entry

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


Entry [Property Prompt_Button_Mode]

Prompt_Button_Mode - Entry

Determines how and if a prompt button will appear within a entry form

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property determines how and if prompt button objects are added to a form.

Constant | Meaning
PB_PromptOff | The prompt button object is not displayed.
PB_PromptOn | The prompt button object is displayed and the message prompt is sent when the button is pressed.
PB_PromptAuto | The prompt button object is displayed automatically if a prompt object exists. This is determined at run time. If the prompt_object property is non-zero, a prompt button is displayed. This is the default value for the dbForm class.

Note that the status of the prompt can be changed at any time. The following example, when added to the bottom code section of a dbForm, would toggle the prompt button on and off.

on_key key_Alt+Key_A Send PON
on_key key_Alt+Key_B Send POFF
on_key key_Alt+Key_C Send PAuto

procedure POn
    set prompt_button_mode to PB_PromptOn
end_Procedure

procedure POff
    set prompt_button_mode to PB_PromptOff
end_Procedure

procedure Pauto
    set prompt_button_mode to PB_Promptauto
end_Procedure

Note:This property replaces the obsolete property Auto_Create_Prompt_Button.

See Also

Form

Last Edited: August 16, 2004


Entry [Property Prompt_Button_Value]

Prompt_Button_Value - Entry

Specifies the text displayed in the prompt button for this object

Type: Property

Access: Read/Write

Data Type: String

Description

The Prompt_Button_Value property specifies the text displayed in the prompt button for this object. By default, three dots (...) are displayed.

See Also

Form

Last Edited: August 16, 2004


Entry [Property psHtmlHelpTopic]

psHtmlHelpTopic - Entry

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


Entry [Property Status_Help]

Status_Help - Entry

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


Entry [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - Entry

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


EntryList [Event Combo_Edit_Changed]

Combo_Edit_Changed - EntryList

Fires when combo item is changed by editing a value

Type: Event

Parameters: integer iItem

Parameter | Description
iItem | Number of item that has changed

Description

Fires when combo item is changed by editing a value. By default, it sets the Item_Changed_State to True and calls OnChange.

You can intercept this procedure to add your own event handling when a combo item has changed:

Procedure Combo_Edit_Changed integer iItem
    forward send Combo_Edit_Changed iItem
    :
    // add event handling here
    :
End_Procedure  // Combo_Edit_Changed

Last Edited: November 30, 2004


EntryList [Event Combo_Item_Changed]

Combo_Item_Changed - EntryList

Fires when combo item is changed by selecting a new combo item

Type: Event

Parameters: integer iItem

Parameter | Description
iItem | Number of item that has changed

Description

Fires when combo item is changed by selecting a new combo item. By default, it sets the Item_Changed_State to True and calls OnChange.

You can intercept this procedure to add your own event handling when a combo item has changed:

Procedure Combo_Item_Changed integer iItem
    forward send Combo_Item_Changed iItem
    :
    // add event handling here
    :
End_Procedure  // Combo_Item_Changed

Last Edited: November 30, 2004


EntryList [Event Header_Mouse_Click]

Header_Mouse_Click - EntryList

Sent whenever a header has received a mouse click

Type: Event

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Description

The Header_mouse_click message is sent whenever a header has received a mouse click. By default it sends the message activate_column, which will attempt to give this object the focus (if it does not already have the focus) and then move the focus to the selected column. This allows users to switch to a column by clicking on the column header.

Last Edited: August 18, 2003


EntryList [Event Header_Mouse_Double_Click]

Header_Mouse_Double_Click - EntryList

Sent whenever a header has received a mouse double-click

Type: Event

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Description

The Header_mouse_double_click message is sent whenever a header has received a mouse double-click. It does nothing by default and is suitable for augmentation.

Last Edited: August 18, 2003


EntryList [Event OnBeginningOfPanel]

OnBeginningOfPanel - EntryList

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


EntryList [Event OnChange]

OnChange - EntryList

A "hook" procedure for you to use for any action you wish to occur when the data in this object changes

Type: Event

Parameters: Integer iItem

Parameter | Description
iItem | The item number

Description

OnChange is a "hook" procedure for you to use for any action you wish to occur when the data in this object changes. As supplied, it does nothing. The message is sent by the key and value procedures.

Note:The OnChange event should not be used to change focus or to alter the value of controls such as Form or ComboForm.

This event is created to respond to a data change event and not to trigger other data changes. If you want to respond to a change in a combo based on a user selection, it is suggested you augment other procedures such as Combo_Item_Changed and Combo_Edit_Changed.

Last Edited: July 11, 2006


EntryList [Event OnCloseUp]

OnCloseUp - EntryList

Fires when combo form's dropdown list closes

Type: Event

Parameters: integer iItem

Parameter | Description
iItem | Grid item containing the combo form

Description

Fires when combo form's dropdown list closes.

You can use this procedure to add event handling when a combo form's dropdown list closes:

Procedure OnCloseUp item iItem
    if (iItem = 2) begin
        :
        // add event handling here for closing of list for item 2
        :
    end
End_Procedure  // OnCloseUp

Last Edited: November 30, 2004


EntryList [Event OnDropDown]

OnDropDown - EntryList

Fires when combo form's dropdown list drops down

Type: Event

Parameters: integer iItem

Parameter | Description
iItem | Grid item containing the combo form

Description

Fires when combo form's dropdown list drops down.

You can use this procedure to add event handling when a combo form's dropdown list drops down:

Procedure OnDropDown item iItem
    if (iItem = 2) begin
        :
        // add event handling here for dropping down of list for item 2
        :
    end
End_Procedure  // OnDropDown

Last Edited: November 30, 2004


EntryList [Event onInitSpin]

onInitSpin - EntryList

Augmented to set the minimum and maximum positions for a spinner

Type: Event

Parameters: No Parameters

Description

OnInitSpin should be augmented to set the minimum and maximum positions for a spinner. When the spinner is pressed, the message OnInitSpin is called. It is up to you to set the properties minimum_position and maximum_position (which will properly initialize the spinner). You can use current_item and Current_col to figure out what item or column you called.

// Assume we have spinners in column 1 and 2. Depending on the
// column we want to set different min and max positions
Procedure onInitSpin
   Integer iCol
   Get current_col to iCol
   If (iCol=1) Begin
      Set minimum_position to 0
      Set maximum_position to 10
   End
   Else begin
      Set minimum_position to 1
      Set maximum_position to 100
   End
End_procedure

Last Edited: September 10, 2003


EntryList [Event OnKillFocus]

OnKillFocus - EntryList

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


EntryList [Event OnMaxText]

OnMaxText - EntryList

Type: Event

Parameters: integer iItem

Parameter | Description
iItem | [ToDo: In Progress]

Description

Last Edited: November 30, 2004


EntryList [Event OnMouseWheel]

OnMouseWheel - EntryList

An event sent everytime a mouse wheel is clicked

Type: Event

Parameters: integer iClicks integer iKey

Parameter | Description
iClicks | The number of clicks of the mouse wheel
iKey | The windows bit mask that determines what other keys might have been pressed as you move the mouse-wheel. It is not being used in the default implementation. Consult the windows documentation for WM_MouseWheel if you need to use this.

Description

The mouse wheel is supported in grids. No changes are required to make this work. Scrolling the wheel forward or backwards will scroll your list forwards and backwards as expected.

If you wish to create custom mouse wheel behaviors you can augment the event OnMouseWheel. This message is sent every time a mouse wheel is clicked.

If iClicks is positive the wheel is being moved forward (away from you). By default this is used to scroll towards the top of the list. If iClicks is negative the wheel is being moved backwards (towards you). By default this is used to scroll down the list.

Last Edited: September 10, 2003


EntryList [Event OnSetFocus]

OnSetFocus - EntryList

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


EntryList [Event Prompt_Callback]

Prompt_Callback - EntryList

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


EntryList [Event Shadow_Display]

Shadow_Display - EntryList

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for EntryList

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value |
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item |
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click | Sent whenever a header has received a mouse click |
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click |
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes |
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down |
onInitSpin | Augmented to set the minimum and maximum positions for a spinner |
OnKillFocus | Sent whenever the object is about to lose the focus |
OnMaxText |  |
OnMouseWheel | An event sent everytime a mouse wheel is clicked |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


EntryList [Function Column]

Column - EntryList

Returns the number of the column that is connected to Item Item#

Type: Function

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Return Value

Description

Column returns the number of the column that is connected to Item Item#.

Last Edited: July 30, 2003


EntryList [Function Help_Datafile]

Help_Datafile - EntryList

Returns the filename and fieldname in file.field format that contains help for the current item

Type: Function

Obsolete

Return Data Type: String

Parameters: No Parameters

Return Value

The filename and fieldname in file.field format that contains help for the current item

Description

The Help_datafile function returns the filename and fieldname in file.field format that contains help for the current item.

Last Edited: August 12, 2003


EntryList [Function Next_Object_Id]

Next_Object_Id - EntryList

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


EntryList [Function Prior_Object_Id]

Prior_Object_Id - EntryList

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for EntryList

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item |
Activate_Item | Procedure | Activates this object with Item Item# as the current_item |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the current column of the first row |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
Column | Function | Returns the number of the column that is connected to Item Item# |
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask |
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoadjustGridWidths | Procedure | Called any time a grid is resized |
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down |
DoScrollUp | Procedure | Emulates pressing a spin button up |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Causes the grid's current item to be set to the current column of the last row |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask |
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Prompt | Procedure | The default message sent by this object's prompt button |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines |
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


EntryList [Procedure Set Currency_Mask]

Currency_Mask - EntryList

Provides an easy method for creating a currency mask

Type: Procedure Set

Data Type: String

Parameters: Integer item# Integer LeftDigit Integer RightDigit String DfltMask

Parameter | Description
item# | The item number
LeftDigit | Digits to the left of the decimal separator
RightDigit | Digits to the right of the decimal separator
DfltMask | The mask string to be applied. Optional and normally not passed

Description

This provides an easy method for creating a currency mask. The message is passed the number of digits to the left and right of the decimal separator and an optional template mask. This message will construct a mask, set the object's form_mask to this mask and set the object's form_datatype to mask_current_window.

Normally the template is not passed and the default currency template default_currency_mask is used. Default_currency_mask is a global string (which you may change) which contains the default currency template. Its default value is $,*;($,*), where $ represents the local Windows setting for the currency symbol. If template is passed, it should, at minimum, contain an asterisk. When the mask is constructed, the asterisk is expanded to contain the proper number of left and right digits.

Setting of this property makes it unnecessary to actually set the object's form_datatype to mask_currency_window.

If the object is based on Form or Entry, item# will always be zero.

Set currency_mask 0 to 6 2

Set currency_mask 0 to 8 2 "$,*;$,* "

See Also

Form | Numeric_mask

Last Edited: January 12, 2006


EntryList [Procedure Set Numeric_Mask]

Numeric_Mask - EntryList

Provides an easy method for creating a numeric mask

Type: Procedure Set

Data Type: String

Parameters: Integer item# Integer LeftDigit Integer RightDigit String DfltMask

Parameter | Description
item# | The item number
LeftDigit | Digits to the left of the decimal separator
RightDigit | Digits to the right of the decimal separator
DfltMask | The mask string to be applied. Optional and normally not passed

Description

This provides an easy method for creating a numeric mask. The message is passed the number of digits to the left and right of the decimal separator and an optional template mask. This message will construct a mask, set the object's form_mask to this mask and set the object's form_datatype to mask_numeric_window.

Normally the template is not passed and the default currency template default_numeric_mask is used. Default_Numeric_mask is a global string (which you may change) which contains the default numeric template. Its default value is "*". If template is passed it should, at minimum, contain an asterisk. When the mask is constructed, the asterisk is expanded to contain the proper number of left and right digits.

Setting of this property makes it unnecessary to actually set the object's form_datatype to mask_numeric_window.

If the object is based on Form or Entry, item# will always be zero.

Set numeric_mask 0 to 4 4

Set numeric_mask 0 to 6 0 "*%"

See Also

Form | Currency_Mask

Last Edited: January 12, 2006


EntryList [Procedure Activate_Area]

Activate_Area - EntryList

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


EntryList [Procedure Activate_Column]

Activate_Column - EntryList

Attempts to activate the object making the passed Item# in the current row the current_item

Type: Procedure

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Return Value

Returns 0 if successful, non-zero otherwise.

Description

Activate_column attempts to activate the object making the passed Item# in the current row the current_item.

Last Edited: July 30, 2003


EntryList [Procedure Activate_Item]

Activate_Item - EntryList

Activates this object with Item Item# as the current_item

Type: Procedure

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Return Value

Returns 0 if successful, non-zero otherwise.

Description

Activate_item activates this object with Item Item# as the current_item.

Last Edited: July 30, 2003


EntryList [Procedure Beginning_of_Data]

Beginning_of_Data - EntryList

Causes the grid's current item to be set to the current column of the first row

Type: Procedure

Parameters: No Parameters

Description

The Beginning_of_Data procedure sets the grid's current_item to the current column of the first row.

Last Edited: August 13, 2003


EntryList [Procedure Beginning_of_Panel]

Beginning_of_Panel - EntryList

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


EntryList [Procedure Bottom_of_Panel]

Bottom_of_Panel - EntryList

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


EntryList [Procedure DoadjustGridWidths]

DoadjustGridWidths - EntryList

Called any time a grid is resized

Type: Procedure

Parameters: integer iGuiDelta

Parameter | Description
iGuiDelta | The horizontal difference between the old and new grid size in GUI units

Description

The DoAdjustGridWidths procedure is called any time a grid is resized, passing iGuiDelta as the horizontal difference between the old and new grid size in GUI units. If the value is positive, the grid is wider; if it is negative, it is smaller. By default, this method uses the properties peResizeColumn and piResizeColumn to determine how grid columns are resized. You could choose to replace this with a resizing mechanism of your own choosing.

For example, the following example resizes the first column within maximum (50) and minimum (10) limits.

Procedure DoAdjustGridWidths integer iGuiDelta
  integer iWidth
   // get current width of first column
   Get form_guiwidth 0 to iWidth
   // determine the new width
   Move (iWidth + iGuiDelta) to iWidth
   // if the new width is within a valid range, change it
   If (iWidth>=10 and iWidth<=50) Set form_guiwidth 0 to iWidth
End_procedure

Last Edited: July 31, 2003


EntryList [Procedure DoHtmlHelp]

DoHtmlHelp - EntryList

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


EntryList [Procedure DoScrollDown]

DoScrollDown - EntryList

Emulates pressing a spin button down

Type: Procedure

Parameters: No Parameters

Description

Sending the DoScrollDown message emulates pressing a spin button down. If the active cell in a grid does not support a spin button, this procedure does nothing. Normally, you will assign keys to this procedure and to the procedure DoScrollUp.

// assign keys to manually spin value
On_Key Key_Ctrl+Key_U Send DoScrollUp
On_Key Key_Ctrl+Key_D Send DoScrollDown

Last Edited: August 5, 2003


EntryList [Procedure DoScrollUp]

DoScrollUp - EntryList

Emulates pressing a spin button up

Type: Procedure

Parameters: No Parameters

Description

Sending the DoScrollUp message emulates pressing a spin button up. If the active cell in a grid does not support a spin button, this procedure does nothing. Normally, you will assign keys to this procedure and to the procedure DoScrollDown.

// assign keys to manually spin value
On_Key Key_Ctrl+Key_U Send DoScrollUp
On_Key Key_Ctrl+Key_D Send DoScrollDown

Last Edited: August 5, 2003


EntryList [Procedure End_of_Data]

End_of_Data - EntryList

Causes the grid's current item to be set to the current column of the last row

Type: Procedure

Parameters: No Parameters

Description

The Beginning_of_Data procedure sets the grid's current_item to the current column of the last row.

Last Edited: August 13, 2003


EntryList [Procedure End_of_Panel]

End_of_Panel - EntryList

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


EntryList [Procedure Error_Help]

Error_Help - EntryList

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


EntryList [Procedure Extended_Help]

Extended_Help - EntryList

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


EntryList [Procedure File_Help]

File_Help - EntryList

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


EntryList [Procedure Help]

Help - EntryList

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


EntryList [Procedure Help_For_Help]

Help_For_Help - EntryList

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


EntryList [Procedure Help_Index]

Help_Index - EntryList

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


EntryList [Procedure Help_on_topic]

Help_on_topic - EntryList

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


EntryList [Procedure Keys_Help]

Keys_Help - EntryList

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


EntryList [Procedure Prompt]

Prompt - EntryList

The default message sent by this object's prompt button

Type: Procedure

Parameters: No Parameters

Description

The Prompt message is the default message sent by this object's prompt button. If prompt_object is non-zero, it will send popup to the object with that object id; else it will do nothing. This message is suitable for sending and for augmentation.

Last Edited: December 2, 2004


EntryList [Procedure Request_Status_Help]

Request_Status_Help - EntryList

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


EntryList [Procedure Scroll]

Scroll - EntryList

Scrolls the item list in the specified direction by the specified number of lines

Type: Procedure

Parameters: Integer eDirection Integer iNumLines

Parameter | Description
eDirection | Scroll direction
iNumLines | Number of lines to scroll

Description

Scroll scrolls the item list in the specified direction by the specified number of lines. Augmented to invoke the scroll function if batch_state is false, otherwise uses default scrolling mechanism. Use the keywords upward_direction or downward_direction or boolean integer values to control direction.

Last Edited: July 11, 2006


EntryList [Procedure Top_of_Panel]

Top_of_Panel - EntryList

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for EntryList

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in |
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object |
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button |
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns |
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  |
Status_Help | Sets the text of the help text that appears in the status bar |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


EntryList [Property Current_Col]

Current_Col - EntryList

Returns the number of the column of the list that the cursor currently is located in

Type: Property

Access: Read-Only

Data Type: Integer

Description

Current_col returns the number of the column of the list that the cursor currently is located in.

Last Edited: July 31, 2003


EntryList [Property Enabled_State]

Enabled_State - EntryList

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


EntryList [Property Explicit_Shadow_State]

Explicit_Shadow_State - EntryList

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


EntryList [Property Floating_Menu_Object]

Floating_Menu_Object - EntryList

Identifies the floating context menu for this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Floating_Menu_Object property identifies the floating menu for this object. The default setting will provide a standard edit context menu. You may create your own custom floating menus and assign them to objects by setting this property. You may also disable a floating menu by setting this property to zero.

See Also

Form

Last Edited: November 22, 2004


EntryList [Property Help_id]

Help_id - EntryList

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


EntryList [Property Help_Keyword]

Help_Keyword - EntryList

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


EntryList [Property Item_Shadow_State]

Item_Shadow_State - EntryList

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


EntryList [Property Maximum_Position]

Maximum_Position - EntryList

Determines the maximum position for a spin button

Type: Property

Access: Read/Write

Data Type: Integer

Description

Maximum_Position determines the maximum position for a spin button. This property should be set within the method onInitSpin. When the spinner is pressed, the message OnInitSpin is called. It is up to you to set the properties minimum_position and maximum_position (which will properly initialize the spinner). You can use current_item and Current_col to figure out what you called.

// Assume we have spinners in column 1 and 2. Depending on the
// column we want to set different min and max positions
Procedure onInitSpin
   Integer iCol
   Get current_col to iCol
   If (iCol=1) Begin
      Set minimum_position to 0
      Set maximum_position to 10
   End
   Else begin
      Set minimum_position to 1
      Set maximum_position to 100
   End
End_procedure

Default is 32767.

Last Edited: August 18, 2003


EntryList [Property Minimum_Position]

Minimum_Position - EntryList

Determines the minimum position for a spin button

Type: Property

Access: Read/Write

Data Type: Integer

Description

Minimum_Position determines the minimum position for a spin button. This property should be set within the method onInitSpin. When the spinner is pressed, the message OnInitSpin is called. It is up to you to set the properties minimum_position and maximum_position (which will properly initialize the spinner). You can use current_item and Current_col to figure out what you called.

// Assume we have spinners in column 1 and 2. Depending on the
// column we want to set different min and max positions
Procedure onInitSpin
  Integer iCol
   Get current_col to iCol
   If (iCol=1) Begin
      Set minimum_position to 0
      Set maximum_position to 10
   End
   Else Begin
      Set minimum_position to 1
      Set maximum_position to 100
   End
End_procedure

Default is -32767.

Last Edited: August 18, 2003


EntryList [Property Object_Shadow_State]

Object_Shadow_State - EntryList

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


EntryList [Property peResizeColumn]

peResizeColumn - EntryList

Determines the method used for resizing columns

Type: Property

Access: Read/Write

Data Type: Integer

Description

peResizeColumn determines the method used for resizing columns. The following constants are supported:

Constant | Meaning
rcNone | No resizing of columns
rcLastColumn | The last column is resized
 | All columns are proportionally resized
rcSelectedColumn | Resize the column specified by the property piResizeColumn

You may choose to never automatically resize columns, always resize all columns on a ratio basis, or resize any selected column. Setting these properties have no effect on how columns are resized manually. If the property resize_column_state is true, you may manually resize any column by dragging the edge of a header with the mouse.

If you need to define more sophisticated header sizing strategies, you can augment the message DoAdjustGridWidths and write your own resizing routine.

Default is rcLastColumn.

Last Edited: January 19, 2006


EntryList [Property piResizeColumn]

piResizeColumn - EntryList

Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn

Type: Property

Access: Read/Write

Data Type: Integer

Description

If the mode property peResizeColumn is set to rcSelectedColumn, the column to be resized is determined by the value in piResizeColumn. Columns are zero based; therefore setting peResizeColumn to 0 causes the first column to be resized. If peResizeColumn is set to any value other than rcSelectedColumn, the property is ignored.

In the following example, the column to be automatically resized is selected by clicking the column's header (Clicking on a grid column header sends the message Header_mouse_click).

Procedure Header_Mouse_Click Integer iColumn
   Set peResizeColumn to rcSelectedColumn // make sure mode is correct
   Set piResizeColumn to iColumn          // this is the column to resize
End_Procedure

Default is 0.

Last Edited: September 11, 2003


EntryList [Property psHtmlHelpTopic]

psHtmlHelpTopic - EntryList

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


EntryList [Property Spin_Value]

Spin_Value - EntryList

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: November 30, 2004


EntryList [Property Status_Help]

Status_Help - EntryList

Sets the text of the help text that appears in the status bar

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

Status_help property sets the text of the help text that appears in the status bar. Note that an item number and a help value must be passed. The item number is actually a column number and represents the status help value for all items within the passed column.

Last Edited: September 11, 2003


EntryList [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - EntryList

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


ErrorSystem [Event Error_Report]

Error_Report - ErrorSystem

Sent if you have redirected your errors to another object, and this new error object wishes to use the services of the standard error handler

Type: Event

Parameters: integer ErrNum integer Err_Line string ErrMsg

Parameter | Description
ErrNum | The error number
Err_Line | The error line number
ErrMsg | The additional error text that would have been passed with the error command (e.g., Error 300 "This is an error")

Description

The Error_report message may be sent if you have redirected your errors to another object, and this new error object wishes to use the services of the standard error handler. When this message is sent the following occurs:

1. The procedure makes sure that it is not already processing an error. If it is, it exits. If it is not, it sets error_processing_state to true to indicate that an error is in process.

2. If the error number is ignored (not trapped), the error process is passed on to the standard internal error handler (which does not report the error).

3. An error description is created by appending the standard DataFlex error text for the passed error number (if text exists) with the error message text passed (if text exists).

4. The handler checks to see if the Global Integer ghoErrorSource is non-zero. If it is, it will send the message get extended_error_message to ghoErrorSource. This function will be return additional error text. This provides an advanced method for generating additional error text. The return string may be multi-line text-each line should be separated with a \n end-of-line symbol.

5. The error and all error text is displayed in an message box via the Message_Box function call. If the error is considered critical (calls private Is_Critcal function), the icon displayed is MB_IconHand, otherwise MB_IconExclamation is shown.

6. If the error is critical, the program is halted

7. The global integer ghoErrorSource is reset to 0.

8. The property error_processing_state is reset to false.

The following sample shows how an error may redirected to a custom error handler and how this custom error handler will use the standard error handler.

Object Process is a SomeClass

    Property Integer OldErrorId 0
    Property Integer Error_Processing_State False // required

    Procedure Run_Process
        integer hID

        Set OldErrorId to Error_Object_Id        // remember old error object
        Move Self to Error_Object_Id   // make self the error object
        Repeat
            : //run the batch process
        Until (done)

        Get OldErrorId to hId
        Move hId to Error_Object_Id              // restore original error object
    End_Procedure

    Procedure Error_Report Integer iErrNum Integer iErrLine String sErrText
        Integer hId
        // Always check that we are not already in an error
        If (Error_Processing_State(Self)) ;
            Procedure_Return
        Set Error_Processing_State to true // we are now within an error
        : perform custom error handling
        // Now direct the error to the standard error handler
        Get OldErrorId to hId
        Send Error_Report of hId iErrNum iErrLine sErrText

        Set Error_Processing_State to false // we are no longer within an error
    End_Procedure

End_Object

In the following sample, ghoErrorSource and extended_error_message are used to provide additional error text to the error handler. This is an advanced technique and must be very carefully applied. This technique is used to provide additional information in errors generated by data dictionaries.

Procedure Error_Report Integer iErrNum Integer iErrLine String sErrText
    Integer hId

    If (Error_Processing_State(Self)) ;
        Procedure_Return
    Set Error_Processing_State to True
    : perform custom error handling
    Get OldErrorId to hId
    // By setting this value, we expect that standard error handler will now
    // send the message Get Extended_error to this object. We will create this
    // function in this object.

    Move Self to ghoErrorSource
    Send Error_Report of hId iErrNum iErrLine sErrtext
    Move 0 to ghoErrorSource
    Set Error_Processing_State to False
End_Procedure

Function Extended_Error_Message returns String
    string sText

    // Note that "\n" will break the line when displayed
    Move "This is a serious error.\nDo not ignore this." to sText

    Function_Return sText
End_Function

Note: The previous versions of Visual DataFlex only required two parameters for this message - the error number and line number was packed in a single complex integer. Three parameters are now required. If you have old code that uses this, it must be changed.

Last Edited: June 26, 2006


Events for ErrorSystem

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Error_Report | Sent if you have redirected your errors to another object, and this new error object wishes to use the services of the standard error handler |


Methods for ErrorSystem

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Ignore_All | Procedure | Used when all errors are to be ignored |
Ignore_Error | Procedure | Used when a specific error number is to be ignored |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Trap_All | Procedure | Used when all errors are to be trapped |
Trap_Error | Procedure | Used when a specific error number is to be trapped |


ErrorSystem [Procedure Ignore_All]

Ignore_All - ErrorSystem

Used when all errors are to be ignored

Type: Procedure

Parameters: No Parameters

Description

The Ignore_All procedure is used when all errors are to be ignored. All previous error assignments are modified. This message is often used when a small set of error numbers are to be trapped. The trap_error message is then used to add specific error messages to the set.

send Ignore_All of Error_Object_Id

Last Edited: August 19, 2004


ErrorSystem [Procedure Ignore_Error]

Ignore_Error - ErrorSystem

Used when a specific error number is to be ignored

Type: Procedure

Parameters: integer Error#

Parameter | Description
Error# | The error number passed

Description

The Ignore_Error procedure is used when a specific error number is to be ignored. The error number is passed in error#. Any number of these may be in effect concurrently.

send Ignore_Error of Error_Object_Id 45
send Ignore_Error of Error_Object_Id 72

Last Edited: August 19, 2004


ErrorSystem [Procedure Trap_All]

Trap_All - ErrorSystem

Used when all errors are to be trapped

Type: Procedure

Parameters: No Parameters

Description

The Trap_All procedure is used when all errors are to be trapped. All previous error assignments are modified. This is the initial condition of the error object.

send Trap_All of Error_Object_Id

Last Edited: August 19, 2004


ErrorSystem [Procedure Trap_Error]

Trap_Error - ErrorSystem

Used when a specific error number is to be trapped

Type: Procedure

Parameters: integer Error#

Parameter | Description
Error# | The error number passed

Description

The Trap_Error procedure is used when a specific error number is to be trapped. The error number is passed in Error#. Any number of these may be in effect concurrently.

send Trap_Error of Error_Object_Id 45
send Trap_Error of Error_Object_Id 72

Last Edited: August 19, 2004


Properties for ErrorSystem

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Current_Error_Number |  |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Error_line_Number |  |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Verbose_State | Hides/shows the technical details of the error in the error display |


ErrorSystem [Property Current_Error_Number]

Current_Error_Number - ErrorSystem

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


ErrorSystem [Property Error_line_Number]

Error_line_Number - ErrorSystem

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


ErrorSystem [Property Verbose_State]

Verbose_State - ErrorSystem

Hides/shows the technical details of the error in the error display

Type: Property

Access: Read/Write

Data Type: Integer

Description

Hides/shows the technical details of the error in the error display. If the property value is set to false, the line number and error number will not be shown to the user.

Default is True

Sample

In this sample, errors shown to the user via the default error handler (the object id is stored in the global handle variable Error_Object_Id) contains the technical details information.

Object oApplication Is A cApplication
    Procedure OnCreate
        Send DoOpenWorkspace CURRENT$WORKSPACE
        Set Verbose_State Of Error_Object_Id To False
    End_Procedure // OnCreate
End_Object  // oApplication

Sample

In this sample, the verbose_state property is temporarily set to false so that, for this particular operator error, the technical details of the error will not be displayed.

Function ValidateAge Integer iField Integer iAge Returns Integer
    Boolean bVerboseState

    If (iAge < 0 Or iAge > 114) Begin
        Get Verbose_State Of Error_Object_Id To bVerboseState
        Set Verbose_State Of Error_Object_Id To False
        Error DFERR_OPERATOR "Age cannot be negative nor higher than the oldest person in the world"
        Set Verbose_State Of Error_Object_Id To bVerboseState
        Function_Return 1
    End
End_Function  // ValidateAge

Note:If you want to suppress the information as above, and the validation method will be used inside a DataDictionary class (.DD file) that is shared in a Visual DataFlex Web interface object (.WO), you need to surround the lines with #IFNDEF, since verbose_state is not a property present in the Web interface.

So the code will be:

Function ValidateAge Integer iField Integer iAge Returns Integer
    Boolean bVerboseState

    If (iAge < 0 Or iAge > 114) Begin
        #IFNDEF IS$WEBAPP
        Get Verbose_State Of Error_Object_Id To bVerboseState
        Set Verbose_State Of Error_Object_Id To False
        #ENDIF
        Error DFERR_OPERATOR "Age cannot be negative nor higher than the oldest person in the world"
        #IFNDEF IS$WEBAPP
        Set Verbose_State Of Error_Object_Id To bVerboseState
        #ENDIF
        Function_Return 1
    End
End_Function  // ValidateAge

Last Edited: October 6, 2004


Events for FileValidationTable

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Fill_List | Fills the list of entires in the validation table | ValidationTable


Methods for FileValidationTable

View method list in hierarchical order

Name | Type | Description | Defining Class
Add_Table_Value | Procedure | Should be sent for each sDescription and sValue you wish to add to your validation table | DescriptionValidationTable
Create | Function | Creates an object based on the passed Class Id | cObject
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Find_Code_Description | Function |  | ValidationTable
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array
TableData | Function | Returns the validation table's data in a two dimensional variant array | ValidationTable
Validate_Value | Function | Determines whether a value is valid or not (is listed in the validation table or not) | ValidationTable


Properties for FileValidationTable

View property list in hierarchical order

Name | Description | Defining Class
Allow_Blank_State | Controls whether blank entries are accepted in this object | ValidationTable
Child_Count | Returns the number of child objects the object contains | cObject
Code_Field | The database field from which the values are to be drawn for validation and insertion into the database |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Description_Field | Identifies the field from which the descriptions are to be drawn for validation and insertion into the database |
Item_Count | Returns the number of items in an array object | Array
Main_File | Identifies the data file from which the values are to be drawn to fill this object | ValidationTable
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Ordering | Identifies the index to be used for ordering values in this object. |
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Static_State | Determines whether object loads once per session or dynamically. | ValidationTable
Table_Title | The title shown in the caption bar of the validation table | ValidationTable
Type_Field | Identifies the field in the CodeMast data file that contains the type values to be used for the validation table |
Type_Value | Sets the value in the Type_Field by which records for validation are selected |
Validate_State | Determines whether values are validated against the items contained in the validation table. | ValidationTable
Value | Sets and Gets an array element's value | Array


FileValidationTable [Property Code_Field]

Code_Field - FileValidationTable

The database field from which the values are to be drawn for validation and insertion into the database

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Code_Field property identifies the field in the Main_File from which the values are to be drawn for validation and insertion into the database.

Default is 1.

See Also

Description_Field

Last Edited: July 30, 2003


FileValidationTable [Property Description_Field]

Description_Field - FileValidationTable

Identifies the field from which the descriptions are to be drawn for validation and insertion into the database

Type: Property

Access: Read/Write

Data Type: Integer

Description

Description_Field identifies the field in the Main_File from which the descriptions are to be drawn that explain (and possibly sort) the values for validation and insertion into the database.

Default is 2.

See Also

Code_Field

Last Edited: August 18, 2003


FileValidationTable [Property Ordering]

Ordering - FileValidationTable

Identifies the index to be used for ordering values in this object.

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Ordering property identifies the index of the Main_File by which the values for validation and insertion into the database and their descriptions are to be ordered in this object. This index might be based on the Code_Field, the Description_Field, or others.

Default is -1, which tells the runtime to choose the most-appropriate index based on current constraints.

Last Edited: February 17, 2005


FileValidationTable [Property Type_Field]

Type_Field - FileValidationTable

Identifies the field in the CodeMast data file that contains the type values to be used for the validation table

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Type_Field property identifies the field in CodeMast data file that contains the type values by which records containing the values for validation and insertion into the database and their accompanying descriptions are selected for all objects of this class by default. The Ordering index is based on the value of this field followed by the value of the Code_Field.

See Also

Code_Field | Ordering

Last Edited: September 11, 2003


FileValidationTable [Property Type_Value]

Type_Value - FileValidationTable

Sets the value in the Type_Field by which records for validation are selected

Type: Property

Access: Read/Write

Data Type: String

Description

Type_Value sets the value in the Type_Field by which records containing the values for validation and insertion into the database and their accompanying descriptions are selected for this object.

See Also

Type_Field

Last Edited: September 11, 2003


FloatingPanel [Event OnActivateApp]

OnActivateApp - FloatingPanel

Type: Event

Parameters: No Parameters

Description

Last Edited: December 2, 2005


FloatingPanel [Event OnBeginningOfPanel]

OnBeginningOfPanel - FloatingPanel

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


FloatingPanel [Event OnDeactivateApp]

OnDeactivateApp - FloatingPanel

Type: Event

Parameters: No Parameters

Description

Last Edited: December 2, 2005


FloatingPanel [Event OnKillFocus]

OnKillFocus - FloatingPanel

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


FloatingPanel [Event OnPaint]

OnPaint - FloatingPanel

Sent every time a panel is painted

Type: Event

Parameters: No Parameters

Description

The OnPaint event message is sent every time a panel is painted.

Last Edited: September 10, 2003


FloatingPanel [Event OnResize]

OnResize - FloatingPanel

Sent every time a panel is resized

Type: Event

Parameters: No Parameters

Description

The OnResize event message is sent every time a panel is resized. This message is only sent when the panel is active (paged on the screen). It is also sent when the panel is being paged. This message is most-often used to size and locate child objects when a panel has been paged or resized.

Procedure onResize
    // locate and size child objects relative to the size of the parent
    Broadcast Send Locate_yourself
End_procedure

Last Edited: September 10, 2003


FloatingPanel [Event OnSetFocus]

OnSetFocus - FloatingPanel

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


FloatingPanel [Event Prompt_Callback]

Prompt_Callback - FloatingPanel

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


FloatingPanel [Event Shadow_Display]

Shadow_Display - FloatingPanel

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for FloatingPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  |
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus |
OnPaint | Sent every time a panel is painted |
OnResize | Sent every time a panel is resized |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |


FloatingPanel [Function Next_Object_Id]

Next_Object_Id - FloatingPanel

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


FloatingPanel [Function Prior_Object_Id]

Prior_Object_Id - FloatingPanel

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for FloatingPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated |
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


FloatingPanel [Procedure Activate_Area]

Activate_Area - FloatingPanel

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


FloatingPanel [Procedure Beginning_of_Panel]

Beginning_of_Panel - FloatingPanel

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


FloatingPanel [Procedure Bottom_of_Panel]

Bottom_of_Panel - FloatingPanel

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


FloatingPanel [Procedure Close_Panel]

Close_Panel - FloatingPanel

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


FloatingPanel [Procedure DoHtmlHelp]

DoHtmlHelp - FloatingPanel

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


FloatingPanel [Procedure End_of_Panel]

End_of_Panel - FloatingPanel

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


FloatingPanel [Procedure Error_Help]

Error_Help - FloatingPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


FloatingPanel [Procedure Extended_Help]

Extended_Help - FloatingPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


FloatingPanel [Procedure File_Help]

File_Help - FloatingPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


FloatingPanel [Procedure Help]

Help - FloatingPanel

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


FloatingPanel [Procedure Help_For_Help]

Help_For_Help - FloatingPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


FloatingPanel [Procedure Help_Index]

Help_Index - FloatingPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


FloatingPanel [Procedure Help_on_topic]

Help_on_topic - FloatingPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


FloatingPanel [Procedure Keys_Help]

Keys_Help - FloatingPanel

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


FloatingPanel [Procedure Popup_Modal]

Popup_Modal - FloatingPanel

Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns non-zero if popup failed (this value is normally not used)

Description

The Popup_modal message activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated. This message sets the modal_state property true until this object is deactivated, at which time it is restored to false. This message has no effect on an already-active object.

Send Popup_modal to oCustomerList

Last Edited: September 25, 2003


FloatingPanel [Procedure Request_Status_Help]

Request_Status_Help - FloatingPanel

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


FloatingPanel [Procedure Stop_Modal_UI]

Stop_Modal_UI - FloatingPanel

Causes the modal object to deactivate

Type: Procedure

Parameters: No Parameters

Description

When the Stop_modal_ui message is received, the current user interface is terminated. This causes the modal object to deactivate.

Last Edited: September 11, 2003


FloatingPanel [Procedure Top_of_Panel]

Top_of_Panel - FloatingPanel

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for FloatingPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true |
Bitmap | Displays a bitmap in an object |
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  |
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  |
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program |
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  |
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows |
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Statusbar_Id |  |
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  |
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


FloatingPanel [Property Auto_Locate_State]

Auto_Locate_State - FloatingPanel

Locates itself relative to any item that invokes it with a popup message when set true

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_Locate_State property is true, this object will locate itself relative to any item that invokes it with a popup message (i.e., relative to the position of the cursor in another object when the prompt key was pressed). The position at which this object pops up depends on the values of its column_offset and row_offset properties.

This property exists primarily for backwards compatibility. You are encouraged to use the more powerful locate_mode property in its place.

Default is false.

Last Edited: January 12, 2006


FloatingPanel [Property Bitmap]

Bitmap - FloatingPanel

Displays a bitmap in an object

Type: Property

Access: Read/Write

Data Type: String

Description

The Bitmap message will display a bitmap in an object. In other words, the bitmap becomes the background of the object.
Bitmap_Style determines how and where the bitmap will display in the object.

There are two potential drawbacks to using bitmaps: the amount of storage (on disk) , and the constant memory consumption.

Sample

This sample sets the bitmap to "MyBitmap.bmp".

set Bitmap to "MyBitmap.bmp"

Note:
In order to make a cohesive application, Visual DataFlex must find the .EXE file and the .bmp (bitmap) file, by using DFPATH.

Last Edited: November 24, 2004


FloatingPanel [Property Client_Id]

Client_Id - FloatingPanel

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: December 20, 2005


FloatingPanel [Property Column_Offset]

Column_Offset - FloatingPanel

Determines the offset to the invoking item by number of columns

Type: Property

Access: Read/Write

Data Type: Integer

Description

If this object is located using POPUP_LOCATE logic (or auto_locate_state is true), it will pop up to the right of the invoking item by the number of columns in the Column_Offset property and below it by the number of rows in row_offset. This property may have a negative, as well as positive, value. The offset is stated as a number of characters, these being of an averaged size for the font currently in effect.

Default is 2.

Last Edited: August 5, 2003


FloatingPanel [Property Current_Action_Button]

Current_Action_Button - FloatingPanel

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


FloatingPanel [Property Default_Action_Button]

Default_Action_Button - FloatingPanel

The object handle of the default action button

Type: Property

Access: Read/Write

Data Type: Integer

Description

A single button object within a panel/dialog object may be designated as the default-action button. This button is assigned by setting its default_action_button property. This property is not normally set directly. Instead, you will usually set the default_state of the button (which, in turn, will set the Default_action_button property). The following two samples will exhibit the same behavior.

Object OK_bn is a Button
    Set Label to "&Ok"
    Set Location to 115 152
    Set default_state to TRUE
    Procedure OnClick
        Send Save_record
    End_Procedure
End_Object

and:

Object OK_bn is a Button
    Set Label to "&Ok"
    Set Location to 115 152
    Procedure OnClick
        Send Save_record
    End_Procedure
End_Object
Set default_action_button to Ok_bn

See default_state in the button class for more information on default action buttons.

Last Edited: July 31, 2003


FloatingPanel [Property Enabled_State]

Enabled_State - FloatingPanel

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


FloatingPanel [Property Explicit_Shadow_State]

Explicit_Shadow_State - FloatingPanel

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


FloatingPanel [Property Help_id]

Help_id - FloatingPanel

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


FloatingPanel [Property Help_Keyword]

Help_Keyword - FloatingPanel

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


FloatingPanel [Property Item_Shadow_State]

Item_Shadow_State - FloatingPanel

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


FloatingPanel [Property Label]

Label - FloatingPanel

This is the text that appears within this control

Type: Property

Access: Read/Write

Data Type: String

Description

This is the text that appears within this control. It can be set and queried through this property.

When used with the Button class, this sets the text within the button.

When used with the CheckBox class, this sets the text that appears to the right of the checkbox.

When used with the TextBox class, this sets the text that appears inside of the textbox.

When used with containers (Panel, Group, dbGroup), this sets the text that appears in the container.

See Also

Button | CheckBox | TextBox | Panel | Group | dbGroup

Last Edited: August 18, 2003


FloatingPanel [Property Locate_Mode]

Locate_Mode - FloatingPanel

Provides several flexible methods for auto positioning container panels in your program

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Locate_Mode property provides several flexible methods for auto positioning container panels in your program. The following modes are supported:

Constant | Meaning
NO_LOCATE | No auto-location is performed. The object must be manually located by using the set location message.
POPUP_LOCATE | This causes the object to locate itself relative to the object (and item) that invoked it. It is ideal for locating popup modal objects (like selection-lists). The position at which this object pops up depends on the values of its column_offset and row_offset properties.
CENTER_ON_SCREEN | This causes the container to appear in the center of the screen.
CENTER_ON_PANEL | This causes the container to centered within the current main program panel.
CENTER_ON_PARENT | This causes the container to appear in the center of its parent container.
SMART_LOCATE | This mode "just does the right thing". This message will cause the object to apply the best locating strategy for current conditions. If the object is a modal popup (modal_state is true) and there is an invoking object it will locate relative to the invoking object (popup_locate), else, if the object already has been assigned a location it will use that location. else, if main-panel exists it will center within that panel (center_on_panel), else, it will center itself on the screen (center_on_screen). All panels default to this mode. This causes modal popup panels to locate relative to their parent and modeless panels to appeared centered unless explicitly located.

Default is SMART_LOCATE.

Last Edited: September 10, 2004


FloatingPanel [Property Modal_State]

Modal_State - FloatingPanel

Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated

Type: Property

Access: Read/Write

Data Type: Boolean

Description

This property is set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, and false when the object popped up by popup_modal is deactivated. When this property is set to true, the following properties are set:

Block_mouse_State | true
Attach_Parent_State | false
Scope_State | true
Ring_State | true
Popup_State | true

When this property is set to false, the following properties are set:

Block_mouse_State | false
Attach_Parent_State | true

Normally you will not set this property to false since this is the default. If you need to alter these individual property settings, you can either augment the modal_state procedure set or you can simply adjust any of the individual properties after you have set the modal_state.

If you wish to toggle an object's modality during runtime, it is suggested that you not set this property. You will need the object in its default modeless state. The object can then be activated non-modally by sending it the activate message and activated modally by sending it the popup_modal message.

Default is false.

Last Edited: January 12, 2006


FloatingPanel [Property Object_Shadow_State]

Object_Shadow_State - FloatingPanel

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


FloatingPanel [Property Offset_Location]

Offset_Location - FloatingPanel

Type: Property

Access: Write-Only

Data Type: Integer

Parameters: integer Row# Integer Col#

Parameter | Description
Row# | [ToDo: In Progress]
Col# | [ToDo: In Progress]

Description

Last Edited: July 8, 2003


FloatingPanel [Property psHtmlHelpTopic]

psHtmlHelpTopic - FloatingPanel

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


FloatingPanel [Property Row_Offset]

Row_Offset - FloatingPanel

Determines the offset to the invoking item by number of rows

Type: Property

Access: Read/Write

Data Type: Integer

Description

If this object is located using POPUP_LOCATE logic (or auto_locate_state is true), it will pop up to the right of the invoking item by the number of columns in column_offset and below it by the number of rows in the Row_Offset property. This property may have a negative, as well as positive, value. This offset is stated as a number of rows, these being the row height for the font currently in effect.

Default is 1.

Last Edited: September 11, 2003


FloatingPanel [Property Status_Help]

Status_Help - FloatingPanel

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


FloatingPanel [Property Statusbar_Id]

Statusbar_Id - FloatingPanel

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: December 20, 2005


FloatingPanel [Property Toolbar_Id]

Toolbar_Id - FloatingPanel

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: December 20, 2005


FloatingPanel [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - FloatingPanel

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


Events for FloatingPopupMenu

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Initialize_Menu | Sent when the Menubar system is about to be selected | DfBaseActionBar
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for FloatingPopupMenu

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Exit_Menu | Procedure |  | DfBaseActionBar
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Redirect_Message | Procedure |  | DfBaseActionBar
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for FloatingPopupMenu

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Events for FontDialog

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


FontDialog [Function FontDialog]

FontDialog - FontDialog

Starts the common Windows font dialog

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The function returns 0 (zero) if the user canceled the font dialog. A non-zero value is returned when a selection has been made by the user.

Description

FontDialog starts the common Windows font dialog. The dialog will appear as specified in the appearance properties. After the dialog been accepted by the user, the user selection can be queried by getting the appropriate properties.

Last Edited: August 18, 2003


Methods for FontDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
FontDialog | Function | Starts the common Windows font dialog |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for FontDialog

View property list in hierarchical order

Name | Description | Defining Class
ANSIOnly_State | Obsolete, provided for completeness |
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Effects_State | Indicates whether the dialog box displays the controls that allow users to specify strikeout, underline, and text color options |
FaceName | Specifies the typeface name of the font |
FixedPitchOnly_State | Indicates whether only fixed-pitch fonts can be selected in the dialog box |
FontCharSet | Specifies the character set |
FontClipPrecision | Specifies the clipping precision |
FontEscapement | Specifies the angle, in tenths of degrees, between the escapement vector and the x-axis of the device |
FontFamily | Describes the look of a font in a general way |
FontHeight | Specifies the height, in logical units, of the font's character cell or character |
FontItalic | Indicates whether the font is italic |
FontOrientation | Specifies the angle, in tenths of degrees, between each character's base line and the x axis of the device |
FontOutPrecision | Specifies the output precision |
FontPitch | Specifies the pitch of the font |
FontPointSize | Specifies the size of the selected font, in units of 1/10 of a point |
FontQuality | Specifies the output quality |
FontRGBColors | Determines the initial text color |
FontSizeMax | Specifies the maximum point size a user can select |
FontSizeMin | Specifies the minimum point size a user can select |
FontStrikeOut | Indicates whether the font is struck out |
FontType | Specifies the type of the selected font when the font dialog returns |
FontUnderline | Indicates whether the font is underlined |
FontWeight | Specifies the weight of the font in the range 0 through 1000 |
FontWidth | Specifies the average width, in logical units, of the font's character cell, or character |
ForceFontExist_State | Indicates whether the font and style that are selected by the user must exist |
Name | Returns the full name of the object including parentage | cObject
NoFaceSel_State | Indicates whether to selectively prevent the font dialog box from displaying an initial selection for the font name combo box |
NoOEMFonts_State | Indicates whether vector font selection is allowed in the dialog box |
NoScriptSel_State | Indicates whether the script combo box in the font dialog is disabled |
NoSimulations_State | Indicates whether graphics-device-interface (GDI) font simulations are allowed in the dialog box |
NoSizeSel_State | Indicates whether to selectively prevent the dialog box from displaying an initial selection for the font size combo box |
NoStyleSel_State | Indicates whether to selectively prevent the dialog box from displaying an initial selection for the font style combo box |
NoVectorFonts_State | Indicates whether vector font selection is allowed in the dialog box |
NoVertFonts_State | Indicates whether the font dialog should display vertically oriented fonts |
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
ScalableOnly_State | Indicates whether only scalable fonts should be selected |
ScreenFonts_State |  |
ScriptsOnly_State | Indicates whether the font dialog should allow selection of fonts for all non-OEM and Symbol character sets, as well as the ANSI character set |
SelectScript_State | Determines if only fonts with the character set identified by the FontCharSet property will be displayed by the font dialog box |
ShowHelp_State | Indicates if the dialog box shows the help button on the dialog box |
TTOnly_State | Indicates if only TrueType fonts should be selected in the font dialog box |


FontDialog [Property ANSIOnly_State]

ANSIOnly_State - FontDialog

Obsolete, provided for completeness

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The ANSIOnly_State property is obsolete; it is provided for completeness. The ANSIOnly behavior used to be supported in Windows 3.1 and is supported in the Win32 API for that reason. To limit font selections to all scripts except those that use the OEM or Symbol character sets, use ScriptsOnly_State. To get the Windows 3.1 CF_ANSIONLY behavior, use SelectScript_State and specify ANSI_CHARSET in the CharSet_State property.

Last Edited: January 12, 2006


FontDialog [Property Effects_State]

Effects_State - FontDialog

Indicates whether the dialog box displays the controls that allow users to specify strikeout, underline, and text color options

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Effects_State indicates whether the dialog box displays the controls that allow users to specify strikeout, underline, and text color options.

Last Edited: January 12, 2006


FontDialog [Property FaceName]

FaceName - FontDialog

Specifies the typeface name of the font

Type: Property

Access: Read/Write

Data Type: String

Description

FaceName is a null-terminated string that specifies the typeface name of the font. The length of this string must not exceed 32 characters, including the null terminator.

Last Edited: August 5, 2003


FontDialog [Property FixedPitchOnly_State]

FixedPitchOnly_State - FontDialog

Indicates whether only fixed-pitch fonts can be selected in the dialog box

Type: Property

Access: Read/Write

Data Type: Boolean

Description

FixedPitchOnly_State indicates whether only fixed-pitch fonts can be selected in the dialog box.

Last Edited: January 12, 2006


FontDialog [Property FontCharSet]

FontCharSet - FontDialog

Specifies the character set

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontCharSet specifies the character set.

Possible values are:

ANSI_CHARSET
DEFAULT_CHARSET
SYMBOL_CHARSET
SHIFTJIS_CHARSET
GB2312_CHARSET
HANGUL_CHARSET
CHINESEBIG5_CHARSET
OEM_CHARSET

Last Edited: November 16, 2004


FontDialog [Property FontClipPrecision]

FontClipPrecision - FontDialog

Specifies the clipping precision

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontClipPrecision specifies the clipping precision. The clipping precision defines how to clip characters that are partially outside the clipping region. It can be one or more of the following values:

Constant | Meaning
CLIP_DEFAULT_PRECIS | Specifies default clipping behavior.
_ | Not used.
CLIP_STROKE_PRECIS | Not used by the font mapper, but is returned when raster, vector, or TrueType fonts are enumerated.Windows NT: For compatibility, this value is always returned when enumerating fonts.
CLIP_MASK | Not used.
CLIP_EMBEDDED | You must specify this flag to use an embedded read-only font.
CLIP_LH_ANGLES | When this value is used, the rotation for all fonts depends on whether the orientation of the coordinate system is left-handed or right-handed. If not used, device fonts always rotate counterclockwise, but the rotation of other fonts is dependent on the orientation of the coordinate system.
CLIP_TT_ALWAYS. | Not used.

Last Edited: August 18, 2003


FontDialog [Property FontEscapement]

FontEscapement - FontDialog

Specifies the angle, in tenths of degrees, between the escapement vector and the x-axis of the device

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontEscapement specifies the angle, in tenths of degrees, between the escapement vector and the x-axis of the device. The escapement vector is parallel to the base line of a row of text. For more information, refer to the Windows API documentation.

Last Edited: August 18, 2003


FontDialog [Property FontFamily]

FontFamily - FontDialog

Describes the look of a font in a general way

Type: Property

Access: Read/Write

Data Type: Integer

Description

Font families describe the look of a font in a general way. They are intended for specifying fonts when the exact typeface desired is not available. The values for font families are as follows:

Constant | Meaning
FF_DECORATIVE | Novelty fonts. Old English is an example.
FF_DONTCARE | Don't care or don't know.
FF_MODERN | Fonts with constant stroke width (monospace), with or without serifs. Monospace fonts are usually modern. Pica, Elite, and Courier New are examples.
FF_ROMAN | Fonts with variable stroke width (proportional) and with serifs. MS Serif is an example.
FF_SCRIPT | Fonts designed to look like handwriting. Script and Cursive are examples.
FF_SWISS | Fonts with variable stroke width (proportional) and without serifs. MS Sans Serif is an example.

Last Edited: November 16, 2004


FontDialog [Property FontHeight]

FontHeight - FontDialog

Specifies the height, in logical units, of the font's character cell or character

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontHeight specifies the height, in logical units, of the font's character cell or character. If set to 1, the Hi value of the FontSize of this object will be passed to the font dialog.

Procedure SetupSize
  Integer Selected

  Get FontDialog To Selected
  If Selected ;
    Set FontSize of (FontTextBox(self)) To ;
                 (FontHeight(FontDlg)) ;
                 (FontWidth(FontDlg))
End_procedure // SetupSize

Last Edited: August 6, 2004


FontDialog [Property FontItalic]

FontItalic - FontDialog

Indicates whether the font is italic

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontItalic indicates whether the font is italic.

Last Edited: August 18, 2003


FontDialog [Property FontOrientation]

FontOrientation - FontDialog

Specifies the angle, in tenths of degrees, between each character's base line and the x axis of the device

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontOrientation specifies the angle, in tenths of degrees, between each character's base line and the x axis of the device.

Last Edited: August 18, 2003


FontDialog [Property FontOutPrecision]

FontOutPrecision - FontDialog

Specifies the output precision

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontOutPrecision specifies the output precision. The output precision defines how closely the output must match the requested font's height, width, character orientation, escapement, pitch, and font type. It can be one of the following values:

Constant | Meaning
OUT_CHARACTER_PRECIS | Not used.
OUT_DEFAULT_PRECIS | Specifies the default font mapper behavior.
OUT_DEVICE_PRECIS | Instructs the font mapper to choose a Device font when the system contains multiple fonts with the same name.
OUT_OUTLINE_PRECIS | Windows NT: This value instructs the font mapper to choose from TrueType and otheroutline-based fonts.Windows 95: This value is not used.
OUT_RASTER_PRECIS | Instructs the font mapper to choose a raster font when the system contains multiple fonts with the same name.
OUT_STRING_PRECIS | This value is not used by the font mapper, but it is returned when raster fonts are enumerated.
OUT_STROKE_PRECIS | Windows NT: This value is not used by the font mapper, but it is returned when TrueType, other outline-based fonts, and vector fonts are enumerated. Windows 95: This value is used to map vector fonts, and is returned when TrueType or vector fonts are enumerated.
OUT_TT_ONLY_PRECIS | Instructs the font mapper to choose from only TrueType fonts. If there are no TrueType fonts installed in the system, the font mapper returns to default behavior.
OUT_TT_PRECIS | Instructs the font mapper to choose a TrueType font when the system contains multiple fonts with the same name.

Applications can use the OUT_DEVICE_PRECIS, OUT_RASTER_PRECIS, and OUT_TT_PRECIS values to control how the font mapper chooses a font when the operating system contains more than one font with a given name. For example, if an operating system contains a font named Symbol in raster and TrueType form, specifying OUT_TT_PRECIS forces the font mapper to choose the TrueType version. Specifying OUT_TT_ONLY_PRECIS forces the font mapper to choose a TrueType font, even if it must substitute a TrueType font of another name.

Last Edited: August 18, 2003


FontDialog [Property FontPitch]

FontPitch - FontDialog

Specifies the pitch of the font

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontPitch specifies the pitch of the font. It can be one of the following values:

DEFAULT_PITCH
FIXED_PITCH
VARIABLE_PITCH

Last Edited: August 18, 2003


FontDialog [Property FontPointSize]

FontPointSize - FontDialog

Specifies the size of the selected font, in units of 1/10 of a point

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontPointSize specifies the size of the selected font, in units of 1/10 of a point. This property will be set by the FontDialog function.

Last Edited: August 18, 2003


FontDialog [Property FontQuality]

FontQuality - FontDialog

Specifies the output quality

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontQuality specifies the output quality. The output quality defines how carefully the graphics device interface (GDI) must attempt to match the logical-font attributes to those of an actual physical font. It can be one of the following values:

Constant | Meaning
DEFAULT_QUALITY | Appearance of the font does not matter.
DRAFT_QUALITY | Appearance of the font is less important than when PROOF_QUALITY is used. For GDI raster fonts, scaling is enabled, which means that more font sizes are available, but the quality may be lower. Bold, italic, underline, and strikeout fonts are synthesized if necessary.
PROOF_QUALITY | Character quality of the font is more important than exact matching of the logical-font attributes. For GDI raster fonts, scaling is disabled and the font closest in size is chosen. Although the chosen font size may not be mapped exactly when PROOF_QUALITY is used, the quality of the font is high and there is no distortion of appearance. Bold, italic, underline, and strikeout fonts are synthesized if necessary.

Last Edited: August 18, 2003


FontDialog [Property FontRGBColors]

FontRGBColors - FontDialog

Determines the initial text color

Type: Property

Access: Read/Write

Data Type: Integer

Description

If the Effects_State is set to true, FontRGBColors specifies the initial text color. When the font dialog returns successfully, this property contains the RGB value of the text color the user selected.

Last Edited: August 18, 2003


FontDialog [Property FontSizeMax]

FontSizeMax - FontDialog

Specifies the maximum point size a user can select

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontSizeMax specifies the maximum point size a user can select.

Last Edited: August 18, 2003


FontDialog [Property FontSizeMin]

FontSizeMin - FontDialog

Specifies the minimum point size a user can select

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontSizeMin specifies the minimum point size a user can select.

Last Edited: August 18, 2003


FontDialog [Property FontStrikeOut]

FontStrikeOut - FontDialog

Indicates whether the font is struck out

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontStrikeOut indicates whether the font is struck out.

Last Edited: August 18, 2003


FontDialog [Property FontType]

FontType - FontDialog

Specifies the type of the selected font when the font dialog returns

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontType specifies the type of the selected font when the font dialog returns. It can be a combination of the following values:

Constant | Meaning
BOLD_FONTTYPE | The font weight is bold. This information is duplicated in the FontWeight property and is equivalent to FW_BOLD.
ITALIC_FONTTYPE | The italic font attribute is set. This information is duplicated in the FontItalic property.
PRINTER_FONTTYPE | The font is a printer font.
REGULAR_FONTTYPE | The font weight is normal. This information is duplicated in the FontWeight property and is equivalent to FW_REGULAR.
SCREEN_FONTTYPE | The font is a screen font.
SIMULATED_FONTTYPE | The font is simulated by the graphics device interface (GDI).

Last Edited: August 18, 2003


FontDialog [Property FontUnderline]

FontUnderline - FontDialog

Indicates whether the font is underlined

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontUnderline indicates whether the font is underlined.

Last Edited: August 18, 2003


FontDialog [Property FontWeight]

FontWeight - FontDialog

Specifies the weight of the font in the range 0 through 1000

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontWeight specifies the weight of the font in the range 0 through 1000. For example, 400 is normal and 700 is bold. If this value is zero, a default weight is used.

The following values are defined for convenience:

FW_DONTCARE
FW_THIN
FW_EXTRALIGHT
FW_ULTRALIGHT
FW_LIGHT
FW_NORMAL
FW_REGULAR
FW_MEDIUM
FW_SEMIBOLD
FW_DEMIBOLD
FW_BOLD
FW_EXTRABOLD
FW_ULTRABOLD
FW_HEAVY
FW_BLACK

Last Edited: November 17, 2004


FontDialog [Property FontWidth]

FontWidth - FontDialog

Specifies the average width, in logical units, of the font's character cell, or character

Type: Property

Access: Read/Write

Data Type: Integer

Description

FontWidth specifies the average width, in logical units, of the font's character cell, or character. If set to 1, the Low value of the FontSize of this object will be passed to the font dialog.

Procedure SetupSize
  Integer Selected

  Get FontDialog To Selected
  If Selected ;
    Set FontSize (FontTextBox(self)) To ;
                 (FontHeight(FontDlg)) ;
                 (FontWidth(FontDlg))
End_procedure // SetupSize

Last Edited: August 6, 2004


FontDialog [Property ForceFontExist_State]

ForceFontExist_State - FontDialog

Indicates whether the font and style that are selected by the user must exist

Type: Property

Access: Read/Write

Data Type: Boolean

Description

ForceFontExist_State indicates whether the font and style that are selected by the user must exist.

Last Edited: January 12, 2006


FontDialog [Property NoFaceSel_State]

NoFaceSel_State - FontDialog

Indicates whether to selectively prevent the font dialog box from displaying an initial selection for the font name combo box

Type: Property

Access: Read/Write

Data Type: Boolean

Description

NoFaceSel_State indicates whether to selectively prevent the font dialog box from displaying an initial selection for the font name combo box. This is useful when there is no single font name that applies to the text selection.

Last Edited: January 12, 2006


FontDialog [Property NoOEMFonts_State]

NoOEMFonts_State - FontDialog

Indicates whether vector font selection is allowed in the dialog box

Type: Property

Access: Read/Write

Data Type: Boolean

Description

NoOEMFonts_State indicates whether vector font selection is allowed in the dialog box.

Last Edited: January 12, 2006


FontDialog [Property NoScriptSel_State]

NoScriptSel_State - FontDialog

Indicates whether the script combo box in the font dialog is disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

NoScriptSel_State indicates whether the script combo box in the font dialog is disabled.

Last Edited: January 12, 2006


FontDialog [Property NoSimulations_State]

NoSimulations_State - FontDialog

Indicates whether graphics-device-interface (GDI) font simulations are allowed in the dialog box

Type: Property

Access: Read/Write

Data Type: Boolean

Description

NoSimulations_State indicates whether graphics-device-interface (GDI) font simulations are allowed in the dialog box.

Last Edited: January 12, 2006


FontDialog [Property NoSizeSel_State]

NoSizeSel_State - FontDialog

Indicates whether to selectively prevent the dialog box from displaying an initial selection for the font size combo box

Type: Property

Access: Read/Write

Data Type: Boolean

Description

NoSizeSel_State indicates whether to selectively prevent the dialog box from displaying an initial selection for the font size combo box. This is useful when there is no single font size that applies to the text selection.

Last Edited: January 12, 2006


FontDialog [Property NoStyleSel_State]

NoStyleSel_State - FontDialog

Indicates whether to selectively prevent the dialog box from displaying an initial selection for the font style combo box

Type: Property

Access: Read/Write

Data Type: Boolean

Description

NoStyleSel_State indicates whether to selectively prevent the dialog box from displaying an initial selection for the font style combo box. This is useful when there is no single font style that applies to the text selection

Last Edited: January 12, 2006


FontDialog [Property NoVectorFonts_State]

NoVectorFonts_State - FontDialog

Indicates whether vector font selection is allowed in the dialog box

Type: Property

Access: Read/Write

Data Type: Boolean

Description

NoVectorFonts_State indicates whether vector font selection is allowed in the dialog box.

Last Edited: January 12, 2006


FontDialog [Property NoVertFonts_State]

NoVertFonts_State - FontDialog

Indicates whether the font dialog should display vertically oriented fonts

Type: Property

Access: Read/Write

Data Type: Boolean

Description

NoVertFonts_State indicates whether the font dialog should display vertically oriented fonts.

Last Edited: January 12, 2006


FontDialog [Property ScalableOnly_State]

ScalableOnly_State - FontDialog

Indicates whether only scalable fonts should be selected

Type: Property

Access: Read/Write

Data Type: Boolean

Description

ScalableOnly_State indicates whether only scalable fonts should be selected. Scalable fonts include vector fonts, scalable printer fonts, TrueType fonts, and fonts scaled by other technologies.

Last Edited: January 12, 2006


FontDialog [Property ScreenFonts_State]

ScreenFonts_State - FontDialog

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


FontDialog [Property ScriptsOnly_State]

ScriptsOnly_State - FontDialog

Indicates whether the font dialog should allow selection of fonts for all non-OEM and Symbol character sets, as well as the ANSI character set

Type: Property

Access: Read/Write

Data Type: Boolean

Description

ScriptsOnly_State indicates whether the font dialog should allow selection of fonts for all non-OEM and Symbol character sets, as well as the ANSI character set. This supersedes the ANSIOnly_State property.

Last Edited: January 12, 2006


FontDialog [Property SelectScript_State]

SelectScript_State - FontDialog

Determines if only fonts with the character set identified by the FontCharSet property will be displayed by the font dialog box

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When SelectScript_State is set to true only fonts with the character set identified by the FontCharSet property will be displayed by the font dialog box. Users will not be able to change the character set.

Default value is FALSE.

Last Edited: January 12, 2006


FontDialog [Property ShowHelp_State]

ShowHelp_State - FontDialog

Indicates if the dialog box shows the help button on the dialog box

Type: Property

Access: Read/Write

Data Type: Boolean

Description

ShowHelp_State indicates if the dialog box shows the help button on the dialog box. A Windows message HELPMSGSTRING will be sent to the container in which this object is placed if this property is set to true and the Help button is clicked.

Last Edited: January 12, 2006


FontDialog [Property TTOnly_State]

TTOnly_State - FontDialog

Indicates if only TrueType fonts should be selected in the font dialog box

Type: Property

Access: Read/Write

Data Type: Boolean

Description

TTOnly_State indicates if only TrueType fonts should be selected in the font dialog box.

Last Edited: January 12, 2006


Form [Event Form_Button_Notification]

Form_Button_Notification - Form

Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message

Type: Event

Parameters: integer Item# integer Dummy

Parameter | Description
Item# | The item number
Dummy | not used

Description

The Form_button_notification message is augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message. This is sent when the prompt button is pressed.

Last Edited: August 18, 2003


Form [Event OnBeginningOfPanel]

OnBeginningOfPanel - Form

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


Form [Event OnChange]

OnChange - Form

Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message

Type: Event

Parameters: No Parameters

Description

The OnChange event message is sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message. This is a notification. It does nothing by default and is intended for augmentation.

Note:The OnChange event should not be used to change focus or to alter the value of controls such as Form or ComboForm.

This event is created to respond to a data change event and not to trigger other data changes. If you want to respond to a change in a combo based on a user selection, it is suggested you augment other procedures such as Combo_Item_Changed and Combo_Edit_Changed.

See Also

Form

Last Edited: February 18, 2004


Form [Event OnKillFocus]

OnKillFocus - Form

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


Form [Event OnMaxText]

OnMaxText - Form

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Form [Event OnSetFocus]

OnSetFocus - Form

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


Form [Event Prompt_Callback]

Prompt_Callback - Form

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


Form [Event Shadow_Display]

Shadow_Display - Form

Creates the proper shadowed or unshadowed appearance for this object and its label

Type: Event

Parameters: No Parameters

Description

The Shadow_Display message is called whenever the object's enabled_state is changed. It is responsible for creating the proper shadowed or unshadowed appearance for this object and its label.

See Also

Form

Last Edited: September 11, 2003


Events for Form

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message |
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus |
OnMaxText |  |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label |


Form [Function Next_Object_Id]

Next_Object_Id - Form

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


Form [Function Prior_Object_Id]

Prior_Object_Id - Form

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for Form

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button |
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask |
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask |
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Prompt | Procedure | The default message sent by this object's prompt button |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Form [Procedure Set Currency_Mask]

Currency_Mask - Form

Provides an easy method for creating a currency mask

Type: Procedure Set

Data Type: String

Parameters: Integer item# Integer LeftDigit Integer RightDigit String DfltMask

Parameter | Description
item# | The item number
LeftDigit | Digits to the left of the decimal separator
RightDigit | Digits to the right of the decimal separator
DfltMask | The mask string to be applied. Optional and normally not passed

Description

This provides an easy method for creating a currency mask. The message is passed the number of digits to the left and right of the decimal separator and an optional template mask. This message will construct a mask, set the object's form_mask to this mask and set the object's form_datatype to mask_current_window.

Normally the template is not passed and the default currency template default_currency_mask is used. Default_currency_mask is a global string (which you may change) which contains the default currency template. Its default value is $,*;($,*), where $ represents the local Windows setting for the currency symbol. If template is passed, it should, at minimum, contain an asterisk. When the mask is constructed, the asterisk is expanded to contain the proper number of left and right digits.

Setting of this property makes it unnecessary to actually set the object's form_datatype to mask_currency_window.

If the object is based on Form or Entry, item# will always be zero.

Set currency_mask 0 to 6 2

Set currency_mask 0 to 8 2 "$,*;$,* "

See Also

Form | Numeric_mask

Last Edited: January 12, 2006


Form [Procedure Set Numeric_Mask]

Numeric_Mask - Form

Provides an easy method for creating a numeric mask

Type: Procedure Set

Data Type: String

Parameters: Integer item# Integer LeftDigit Integer RightDigit String DfltMask

Parameter | Description
item# | The item number
LeftDigit | Digits to the left of the decimal separator
RightDigit | Digits to the right of the decimal separator
DfltMask | The mask string to be applied. Optional and normally not passed

Description

This provides an easy method for creating a numeric mask. The message is passed the number of digits to the left and right of the decimal separator and an optional template mask. This message will construct a mask, set the object's form_mask to this mask and set the object's form_datatype to mask_numeric_window.

Normally the template is not passed and the default currency template default_numeric_mask is used. Default_Numeric_mask is a global string (which you may change) which contains the default numeric template. Its default value is "*". If template is passed it should, at minimum, contain an asterisk. When the mask is constructed, the asterisk is expanded to contain the proper number of left and right digits.

Setting of this property makes it unnecessary to actually set the object's form_datatype to mask_numeric_window.

If the object is based on Form or Entry, item# will always be zero.

Set numeric_mask 0 to 4 4

Set numeric_mask 0 to 6 0 "*%"

See Also

Form | Currency_Mask

Last Edited: January 12, 2006


Form [Procedure Activate_Area]

Activate_Area - Form

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Form [Procedure Beginning_of_Panel]

Beginning_of_Panel - Form

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


Form [Procedure Bottom_of_Panel]

Bottom_of_Panel - Form

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


Form [Procedure Create_Prompt_Button]

Create_Prompt_Button - Form

Creates or removes a prompt button

Type: Procedure

Parameters: Integer CreateMode

Parameter Description
CreateModethe following modes are supported

Constant | Meaning
PB_promptOn | the button is created
PB_promptOff | the button is removed
PB_promptAuto | the button is created if a prompt object exists (prompt_object_id is non-zero)

Description

Create_Prompt_Button is used internally to create or remove a prompt button. When CreateMode is PB_promptOn, the button is created. When CreateMode is PB_promptOff, the button is removed. When CreateMode is PB_promptAuto, the button is created if a prompt object exists (prompt_object_id is non-zero). There should be no need to send or augment this message. You should be able to control prompt buttons with the prompt_button_mode property.

See Also

Form

Last Edited: August 5, 2003


Form [Procedure DoHtmlHelp]

DoHtmlHelp - Form

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


Form [Procedure End_of_Panel]

End_of_Panel - Form

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


Form [Procedure Error_Help]

Error_Help - Form

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Form [Procedure Extended_Help]

Extended_Help - Form

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Form [Procedure File_Help]

File_Help - Form

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Form [Procedure Help]

Help - Form

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Form [Procedure Help_For_Help]

Help_For_Help - Form

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Form [Procedure Help_Index]

Help_Index - Form

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Form [Procedure Help_on_topic]

Help_on_topic - Form

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Form [Procedure Keys_Help]

Keys_Help - Form

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Form [Procedure Prompt]

Prompt - Form

The default message sent by this object's prompt button

Type: Procedure

Parameters: No Parameters

Description

The Prompt message is the default message sent by this object's prompt button. If prompt_object is non-zero, it will send popup to the object with that object id; else it will do nothing. This message is suitable for sending and for augmentation.

See Also

Prompt_Callback

Last Edited: June 29, 2005


Form [Procedure Request_Status_Help]

Request_Status_Help - Form

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


Form [Procedure Top_of_Panel]

Top_of_Panel - Form

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for Form

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case |
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object |
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object |
Label_Col_Offset | The horizontal distance from the object to its label |
Label_Justification_Mode | The justification mode for the text within this object's label |
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property |
Label_Row_Offset | The vertical distance from the top edge of the object and its label |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form |
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object |
Prompt_Object | Specifies the default receiving object for the popup message |
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Form [Property Capslock_State]

Capslock_State - Form

Determines if all text entered to this object from the keyboard will be converted to upper case

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Capslock_State property is set true, all text entered to this object from the keyboard will be converted to upper case. Values set to this object by the program will not be affected by this property. This property cannot be changed while this object is active; for a change made while the program is running to take effect, the object must be (deactivated and) activated after this property has been set to the desired value.

Last Edited: December 20, 2005


Form [Property Enabled_State]

Enabled_State - Form

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


Form [Property Explicit_Shadow_State]

Explicit_Shadow_State - Form

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


Form [Property Floating_Menu_Object]

Floating_Menu_Object - Form

Identifies the floating context menu for this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Floating_Menu_Object property identifies the floating menu for this object. The default setting will provide a standard edit context menu. You may create your own custom floating menus and assign them to objects by setting this property. You may also disable a floating menu by setting this property to zero.

See Also

Form

Last Edited: November 22, 2004


Form [Property Help_id]

Help_id - Form

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


Form [Property Help_Keyword]

Help_Keyword - Form

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


Form [Property Item_Shadow_State]

Item_Shadow_State - Form

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


Form [Property Label]

Label - Form

Sets the text for a label or heading for an entry control object

Type: Property

Access: Read/Write

Data Type: String

Description

The Label property sets the text for a label or heading for an entry control object (form, edit or list). In most classes, just setting this property is all that is required for the class to present the label in whatever particular way each class does this. In data-aware classes, the value of this property is overridden by label values in the DDO when auto_label_state has been set true.

Object F1 is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "First Name:"
End_object

Last Edited: August 18, 2003


Form [Property Label_Col_Offset]

Label_Col_Offset - Form

The horizontal distance from the object to its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Col_Offset is the horizontal distance from the object to its label. Units represent distance to the left (i.e., labels appear to the left of their object). If the label's justification-mode is left or top (jmode_left, jmode_top) this represents the distance from left edge of the object to the left edge of its label. If the justification-mode is right (jmode_right) this represents the distance from the left edge of the object to the right edge of the label. By default, this is the value of default_label_offset, which is supplied with a value of 60 (this is a global integer which can be changed).

Default is default label offset.

Last Edited: August 18, 2003


Form [Property Label_Justification_Mode]

Label_Justification_Mode - Form

The justification mode for the text within this object's label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Justification_Mode is the justification mode for the text within this object's label.

When the label_justification_mode is changed the row and col offset properties will often need to be changed as well.

The default mode for labels (jmode_left) is stored in the global integer default_label_jmode.

Object LeftForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Left Justify:" // use default column of 60
End_object

Object RightForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Right Justify:"
    Set label_justification_mode to jmode_right
    // set distance between right side of the label and the left side
    // of the object
    Set label_col_offset to 3
End_object

Object TopForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Top Justify:"
    Set label_justification_mode to jmode_top
    // label and object will align vertically
    Set label_col_offset to 0
End_object

Default is JMode Left.

Last Edited: August 18, 2003


Form [Property Label_Offset]

Label_Offset - Form

Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer i1 integer i2

Parameter | Description
i1 | The Row Offset of the Label
i2 | The Column Offset of the Label

Description

The Label_Offset property returns both the label_row_offset and the label_col_offset properties as a single (two-component) property. The Hi() value of the return parameter represents the row offset. The Low() value represents the column offset.

Get Label_Offset of oForm to iOffset
Move (Hi(iOffset))  to iRowOffset
Move (Low(iOffset)) to iColumnOffset

Label_offset is set as a single property passing the row offset and the column offset as two separate parameters.

Set Label_Offset of oForm to iRowOffset iColumnOffset

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

Last Edited: June 22, 2005


Form [Property Label_Row_Offset]

Label_Row_Offset - Form

The vertical distance from the top edge of the object and its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Row_Offset is the vertical distance from the top edge of the object and its label. If the label's justification-mode is jmode_top it represents the vertical distance from the top edge of this object to the bottom edge of its label and larger numbers moves the label up (and away from the object). If the mode is not top it represents the distance from the top edge of the object and the top edge of the label and larger numbers moves the label down. By default, this is zero which is suitable for both form and side labels.

Default is 0.

Last Edited: August 18, 2003


Form [Property Object_Shadow_State]

Object_Shadow_State - Form

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


Form [Property Prompt_Button_Mode]

Prompt_Button_Mode - Form

Determines how and if a prompt button will appear within a entry form

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property determines how and if prompt button objects are added to a form.

Constant | Meaning
PB_PromptOff | The prompt button object is not displayed.
PB_PromptOn | The prompt button object is displayed and the message prompt is sent when the button is pressed.
PB_PromptAuto | The prompt button object is displayed automatically if a prompt object exists. This is determined at run time. If the prompt_object property is non-zero, a prompt button is displayed. This is the default value for the dbForm class.

Note that the status of the prompt can be changed at any time. The following example, when added to the bottom code section of a dbForm, would toggle the prompt button on and off.

on_key key_Alt+Key_A Send PON
on_key key_Alt+Key_B Send POFF
on_key key_Alt+Key_C Send PAuto

procedure POn
    set prompt_button_mode to PB_PromptOn
end_Procedure

procedure POff
    set prompt_button_mode to PB_PromptOff
end_Procedure

procedure Pauto
    set prompt_button_mode to PB_Promptauto
end_Procedure

Note:This property replaces the obsolete property Auto_Create_Prompt_Button.

See Also

Form

Last Edited: August 16, 2004


Form [Property Prompt_Button_Value]

Prompt_Button_Value - Form

Specifies the text displayed in the prompt button for this object

Type: Property

Access: Read/Write

Data Type: String

Description

The Prompt_Button_Value property specifies the text displayed in the prompt button for this object. By default, three dots (...) are displayed.

See Also

Form

Last Edited: August 16, 2004


Form [Property Prompt_Object]

Prompt_Object - Form

Specifies the default receiving object for the popup message

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer hoPrompt

Parameter | Description
iItem | The item number
hoPrompt | The handle of the prompt object

Description

The Prompt_Object property specifies the default receiving object for the popup message. By default, the property is not used in objects of this class, but is used in many of its subclasses, such as dbForm. Only single-item prompt objects are supported.

Last Edited: September 11, 2003


Form [Property psHtmlHelpTopic]

psHtmlHelpTopic - Form

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


Form [Property Status_Help]

Status_Help - Form

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


Form [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - Form

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


Events for FormExternalControl

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message | Form
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Form
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | Form
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Form
OnMaxText |  | Form
OnSetFocus | Sent whenever windows is about to give this object the focus | Form
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Form
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | Form


Methods for FormExternalControl

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Form
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Form
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Form
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
ControlValueChanged | Procedure |  |
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | Form
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | Form
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Form
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Form
Error_Help | Procedure | (Obsolete) | Form
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Form
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Form
Help | Procedure |  | Form
Help_For_Help | Procedure | (Obsolete) | Form
Help_Index | Procedure | (Obsolete) | Form
Help_on_topic | Procedure | (Obsolete) | Form
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Form
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Form
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | Form
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Form
Prompt | Procedure | The default message sent by this object's prompt button | Form
RefreshControl | Procedure |  |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Form
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Form
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


FormExternalControl [Procedure ControlValueChanged]

ControlValueChanged - FormExternalControl

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


FormExternalControl [Procedure RefreshControl]

RefreshControl - FormExternalControl

Type: Procedure

Parameters: string sVal

Parameter | Description
sVal | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Properties for FormExternalControl

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | Form
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
ControlValue |  |
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Form
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Form
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | Form
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Form
Help_Keyword | Used to specify an object's context keyword | Form
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled | Form
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Form
Label_Col_Offset | The horizontal distance from the object to its label | Form
Label_Justification_Mode | The justification mode for the text within this object's label | Form
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Form
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Form
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Form
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form | Form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object | Form
Prompt_Object | Specifies the default receiving object for the popup message | Form
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Form
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Form
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Form
Value |  |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


FormExternalControl [Property ControlValue]

ControlValue - FormExternalControl

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


FormExternalControl [Property Value]

Value - FormExternalControl

Type: Property

Access: Write-Only

Data Type: String

Parameters: Integer iItem String sValue

Parameter | Description
iItem | [ToDo: In Progress]
sValue | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


Events for FormFloatingPopupMenu

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Initialize_Menu | Sent when the Menubar system is about to be selected | DfBaseActionBar
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for FormFloatingPopupMenu

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Exit_Menu | Procedure |  | DfBaseActionBar
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Redirect_Message | Procedure |  | DfBaseActionBar
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for FormFloatingPopupMenu

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Grid [Event Combo_Edit_Changed]

Combo_Edit_Changed - Grid

Fires when combo item is changed by editing a value

Type: Event

Parameters: integer iItem

Parameter | Description
iItem | Number of item that has changed

Description

Fires when combo item is changed by editing a value. By default, it sets the Item_Changed_State to True and calls OnChange.

You can intercept this procedure to add your own event handling when a combo item has changed:

Procedure Combo_Edit_Changed integer iItem
    forward send Combo_Edit_Changed iItem
    :
    // add event handling here
    :
End_Procedure  // Combo_Edit_Changed

Last Edited: November 30, 2004


Grid [Event Combo_Item_Changed]

Combo_Item_Changed - Grid

Fires when combo item is changed by selecting a new combo item

Type: Event

Parameters: integer iItem

Parameter | Description
iItem | Number of item that has changed

Description

Fires when combo item is changed by selecting a new combo item. By default, it sets the Item_Changed_State to True and calls OnChange.

You can intercept this procedure to add your own event handling when a combo item has changed:

Procedure Combo_Item_Changed integer iItem
    forward send Combo_Item_Changed iItem
    :
    // add event handling here
    :
End_Procedure  // Combo_Item_Changed

Last Edited: November 30, 2004


Grid [Event Header_Mouse_Click]

Header_Mouse_Click - Grid

Sent whenever a header has received a mouse click

Type: Event

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Description

The Header_mouse_click message is sent whenever a header has received a mouse click. By default it sends the message activate_column, which will attempt to give this object the focus (if it does not already have the focus) and then move the focus to the selected column. This allows users to switch to a column by clicking on the column header.

Last Edited: August 18, 2003


Grid [Event Header_Mouse_Double_Click]

Header_Mouse_Double_Click - Grid

Sent whenever a header has received a mouse double-click

Type: Event

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Description

The Header_mouse_double_click message is sent whenever a header has received a mouse double-click. It does nothing by default and is suitable for augmentation.

Last Edited: August 18, 2003


Grid [Event OnBeginningOfPanel]

OnBeginningOfPanel - Grid

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


Grid [Event OnChange]

OnChange - Grid

A "hook" procedure for you to use for any action you wish to occur when the data in this object changes

Type: Event

Parameters: Integer iItem

Parameter | Description
iItem | The item number

Description

OnChange is a "hook" procedure for you to use for any action you wish to occur when the data in this object changes. As supplied, it does nothing. The message is sent by the key and value procedures.

Note:The OnChange event should not be used to change focus or to alter the value of controls such as Form or ComboForm.

This event is created to respond to a data change event and not to trigger other data changes. If you want to respond to a change in a combo based on a user selection, it is suggested you augment other procedures such as Combo_Item_Changed and Combo_Edit_Changed.

Last Edited: July 11, 2006


Grid [Event OnCloseUp]

OnCloseUp - Grid

Fires when combo form's dropdown list closes

Type: Event

Parameters: integer iItem

Parameter | Description
iItem | Grid item containing the combo form

Description

Fires when combo form's dropdown list closes.

You can use this procedure to add event handling when a combo form's dropdown list closes:

Procedure OnCloseUp item iItem
    if (iItem = 2) begin
        :
        // add event handling here for closing of list for item 2
        :
    end
End_Procedure  // OnCloseUp

Last Edited: November 30, 2004


Grid [Event OnDropDown]

OnDropDown - Grid

Fires when combo form's dropdown list drops down

Type: Event

Parameters: integer iItem

Parameter | Description
iItem | Grid item containing the combo form

Description

Fires when combo form's dropdown list drops down.

You can use this procedure to add event handling when a combo form's dropdown list drops down:

Procedure OnDropDown item iItem
    if (iItem = 2) begin
        :
        // add event handling here for dropping down of list for item 2
        :
    end
End_Procedure  // OnDropDown

Last Edited: November 30, 2004


Grid [Event onInitSpin]

onInitSpin - Grid

Augmented to set the minimum and maximum positions for a spinner

Type: Event

Parameters: No Parameters

Description

OnInitSpin should be augmented to set the minimum and maximum positions for a spinner. When the spinner is pressed, the message OnInitSpin is called. It is up to you to set the properties minimum_position and maximum_position (which will properly initialize the spinner). You can use current_item and Current_col to figure out what item or column you called.

// Assume we have spinners in column 1 and 2. Depending on the
// column we want to set different min and max positions
Procedure onInitSpin
   Integer iCol
   Get current_col to iCol
   If (iCol=1) Begin
      Set minimum_position to 0
      Set maximum_position to 10
   End
   Else begin
      Set minimum_position to 1
      Set maximum_position to 100
   End
End_procedure

Last Edited: September 10, 2003


Grid [Event OnKillFocus]

OnKillFocus - Grid

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


Grid [Event OnMaxText]

OnMaxText - Grid

Type: Event

Parameters: integer iItem

Parameter | Description
iItem | [ToDo: In Progress]

Description

Last Edited: November 30, 2004


Grid [Event OnMouseWheel]

OnMouseWheel - Grid

An event sent everytime a mouse wheel is clicked

Type: Event

Parameters: integer iClicks integer iKey

Parameter | Description
iClicks | The number of clicks of the mouse wheel
iKey | The windows bit mask that determines what other keys might have been pressed as you move the mouse-wheel. It is not being used in the default implementation. Consult the windows documentation for WM_MouseWheel if you need to use this.

Description

The mouse wheel is supported in grids. No changes are required to make this work. Scrolling the wheel forward or backwards will scroll your list forwards and backwards as expected.

If you wish to create custom mouse wheel behaviors you can augment the event OnMouseWheel. This message is sent every time a mouse wheel is clicked.

If iClicks is positive the wheel is being moved forward (away from you). By default this is used to scroll towards the top of the list. If iClicks is negative the wheel is being moved backwards (towards you). By default this is used to scroll down the list.

Last Edited: September 10, 2003


Grid [Event OnSetFocus]

OnSetFocus - Grid

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


Grid [Event Prompt_Callback]

Prompt_Callback - Grid

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


Grid [Event Shadow_Display]

Shadow_Display - Grid

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for Grid

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value |
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item |
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click | Sent whenever a header has received a mouse click |
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click |
Header_Notification | Sent when the header has received a mouse event | DfBaseFormList
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes |
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down |
onInitSpin | Augmented to set the minimum and maximum positions for a spinner |
OnKillFocus | Sent whenever the object is about to lose the focus |
OnMaxText |  |
OnMouseWheel | An event sent everytime a mouse wheel is clicked |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |


Grid [Function Column]

Column - Grid

Returns the number of the column that is connected to Item Item#

Type: Function

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Return Value

Description

Column returns the number of the column that is connected to Item Item#.

Last Edited: July 30, 2003


Grid [Function Next_Object_Id]

Next_Object_Id - Grid

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


Grid [Function Prior_Object_Id]

Prior_Object_Id - Grid

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for Grid

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item |
Activate_Item | Procedure | Activates this object with Item Item# as the current_item |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the current column of the first row |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
Column | Function | Returns the number of the column that is connected to Item Item# |
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseFormList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseFormList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseFormList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseFormList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseFormList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseFormList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseFormList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask |
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoadjustGridWidths | Procedure | Called any time a grid is resized |
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseFormList
DoScrollDown | Procedure | Emulates pressing a spin button down |
DoScrollUp | Procedure | Emulates pressing a spin button up |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Data | Procedure | Causes the grid's current item to be set to the current column of the last row |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask |
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Prompt | Procedure | The default message sent by this object's prompt button |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines |
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Grid [Procedure Set Currency_Mask]

Currency_Mask - Grid

Provides an easy method for creating a currency mask

Type: Procedure Set

Data Type: String

Parameters: Integer item# Integer LeftDigit Integer RightDigit String DfltMask

Parameter | Description
item# | The item number
LeftDigit | Digits to the left of the decimal separator
RightDigit | Digits to the right of the decimal separator
DfltMask | The mask string to be applied. Optional and normally not passed

Description

This provides an easy method for creating a currency mask. The message is passed the number of digits to the left and right of the decimal separator and an optional template mask. This message will construct a mask, set the object's form_mask to this mask and set the object's form_datatype to mask_current_window.

Normally the template is not passed and the default currency template default_currency_mask is used. Default_currency_mask is a global string (which you may change) which contains the default currency template. Its default value is $,*;($,*), where $ represents the local Windows setting for the currency symbol. If template is passed, it should, at minimum, contain an asterisk. When the mask is constructed, the asterisk is expanded to contain the proper number of left and right digits.

Setting of this property makes it unnecessary to actually set the object's form_datatype to mask_currency_window.

If the object is based on Form or Entry, item# will always be zero.

Set currency_mask 0 to 6 2

Set currency_mask 0 to 8 2 "$,*;$,* "

See Also

Form | Numeric_mask

Last Edited: January 12, 2006


Grid [Procedure Set Numeric_Mask]

Numeric_Mask - Grid

Provides an easy method for creating a numeric mask

Type: Procedure Set

Data Type: String

Parameters: Integer item# Integer LeftDigit Integer RightDigit String DfltMask

Parameter | Description
item# | The item number
LeftDigit | Digits to the left of the decimal separator
RightDigit | Digits to the right of the decimal separator
DfltMask | The mask string to be applied. Optional and normally not passed

Description

This provides an easy method for creating a numeric mask. The message is passed the number of digits to the left and right of the decimal separator and an optional template mask. This message will construct a mask, set the object's form_mask to this mask and set the object's form_datatype to mask_numeric_window.

Normally the template is not passed and the default currency template default_numeric_mask is used. Default_Numeric_mask is a global string (which you may change) which contains the default numeric template. Its default value is "*". If template is passed it should, at minimum, contain an asterisk. When the mask is constructed, the asterisk is expanded to contain the proper number of left and right digits.

Setting of this property makes it unnecessary to actually set the object's form_datatype to mask_numeric_window.

If the object is based on Form or Entry, item# will always be zero.

Set numeric_mask 0 to 4 4

Set numeric_mask 0 to 6 0 "*%"

See Also

Form | Currency_Mask

Last Edited: January 12, 2006


Grid [Procedure Activate_Area]

Activate_Area - Grid

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Grid [Procedure Activate_Column]

Activate_Column - Grid

Attempts to activate the object making the passed Item# in the current row the current_item

Type: Procedure

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Return Value

Returns 0 if successful, non-zero otherwise.

Description

Activate_column attempts to activate the object making the passed Item# in the current row the current_item.

Last Edited: July 30, 2003


Grid [Procedure Activate_Item]

Activate_Item - Grid

Activates this object with Item Item# as the current_item

Type: Procedure

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | The item number

Return Value

Returns 0 if successful, non-zero otherwise.

Description

Activate_item activates this object with Item Item# as the current_item.

Last Edited: July 30, 2003


Grid [Procedure Beginning_of_Data]

Beginning_of_Data - Grid

Causes the grid's current item to be set to the current column of the first row

Type: Procedure

Parameters: No Parameters

Description

The Beginning_of_Data procedure sets the grid's current_item to the current column of the first row.

Last Edited: August 13, 2003


Grid [Procedure Beginning_of_Panel]

Beginning_of_Panel - Grid

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


Grid [Procedure Bottom_of_Panel]

Bottom_of_Panel - Grid

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


Grid [Procedure DoadjustGridWidths]

DoadjustGridWidths - Grid

Called any time a grid is resized

Type: Procedure

Parameters: integer iGuiDelta

Parameter | Description
iGuiDelta | The horizontal difference between the old and new grid size in GUI units

Description

The DoAdjustGridWidths procedure is called any time a grid is resized, passing iGuiDelta as the horizontal difference between the old and new grid size in GUI units. If the value is positive, the grid is wider; if it is negative, it is smaller. By default, this method uses the properties peResizeColumn and piResizeColumn to determine how grid columns are resized. You could choose to replace this with a resizing mechanism of your own choosing.

For example, the following example resizes the first column within maximum (50) and minimum (10) limits.

Procedure DoAdjustGridWidths integer iGuiDelta
  integer iWidth
   // get current width of first column
   Get form_guiwidth 0 to iWidth
   // determine the new width
   Move (iWidth + iGuiDelta) to iWidth
   // if the new width is within a valid range, change it
   If (iWidth>=10 and iWidth<=50) Set form_guiwidth 0 to iWidth
End_procedure

Last Edited: July 31, 2003


Grid [Procedure DoHtmlHelp]

DoHtmlHelp - Grid

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


Grid [Procedure DoScrollDown]

DoScrollDown - Grid

Emulates pressing a spin button down

Type: Procedure

Parameters: No Parameters

Description

Sending the DoScrollDown message emulates pressing a spin button down. If the active cell in a grid does not support a spin button, this procedure does nothing. Normally, you will assign keys to this procedure and to the procedure DoScrollUp.

// assign keys to manually spin value
On_Key Key_Ctrl+Key_U Send DoScrollUp
On_Key Key_Ctrl+Key_D Send DoScrollDown

Last Edited: August 5, 2003


Grid [Procedure DoScrollUp]

DoScrollUp - Grid

Emulates pressing a spin button up

Type: Procedure

Parameters: No Parameters

Description

Sending the DoScrollUp message emulates pressing a spin button up. If the active cell in a grid does not support a spin button, this procedure does nothing. Normally, you will assign keys to this procedure and to the procedure DoScrollDown.

// assign keys to manually spin value
On_Key Key_Ctrl+Key_U Send DoScrollUp
On_Key Key_Ctrl+Key_D Send DoScrollDown

Last Edited: August 5, 2003


Grid [Procedure End_of_Data]

End_of_Data - Grid

Causes the grid's current item to be set to the current column of the last row

Type: Procedure

Parameters: No Parameters

Description

The Beginning_of_Data procedure sets the grid's current_item to the current column of the last row.

Last Edited: August 13, 2003


Grid [Procedure End_of_Panel]

End_of_Panel - Grid

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


Grid [Procedure Error_Help]

Error_Help - Grid

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Grid [Procedure Extended_Help]

Extended_Help - Grid

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Grid [Procedure File_Help]

File_Help - Grid

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Grid [Procedure Help]

Help - Grid

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Grid [Procedure Help_For_Help]

Help_For_Help - Grid

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Grid [Procedure Help_Index]

Help_Index - Grid

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Grid [Procedure Help_on_topic]

Help_on_topic - Grid

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Grid [Procedure Keys_Help]

Keys_Help - Grid

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Grid [Procedure Prompt]

Prompt - Grid

The default message sent by this object's prompt button

Type: Procedure

Parameters: No Parameters

Description

The Prompt message is the default message sent by this object's prompt button. If prompt_object is non-zero, it will send popup to the object with that object id; else it will do nothing. This message is suitable for sending and for augmentation.

Last Edited: December 2, 2004


Grid [Procedure Request_Status_Help]

Request_Status_Help - Grid

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


Grid [Procedure Scroll]

Scroll - Grid

Scrolls the item list in the specified direction by the specified number of lines

Type: Procedure

Parameters: Integer eDirection Integer iNumLines

Parameter | Description
eDirection | Scroll direction
iNumLines | Number of lines to scroll

Description

Scroll scrolls the item list in the specified direction by the specified number of lines. Augmented to invoke the scroll function if batch_state is false, otherwise uses default scrolling mechanism. Use the keywords upward_direction or downward_direction or boolean integer values to control direction.

Last Edited: July 11, 2006


Grid [Procedure Top_of_Panel]

Top_of_Panel - Grid

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for Grid

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseFormList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseFormList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseFormList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseFormList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseFormList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in |
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseFormList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseFormList
CurrentRowColor | Sets the background color of the current row | DfBaseFormList
CurrentRowTextColor | Sets the text color of the current row | DfBaseFormList
CustomScrollState | Determines changing scroll bar behaviors |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object |
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseFormList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseFormList
Header_Label | Define text for headers | DfBaseFormList
Header_Visible_State | Determines if the grid header will be visible | DfBaseFormList
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseFormList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseFormList
IsColumnVisible | Determine if a particular column is visible | DfBaseFormList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled |
ItemColor | Sets the color of an individual item | DfBaseFormList
ItemTextColor | Sets the text color of an individual item | DfBaseFormList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button |
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseFormList
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseFormList
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseFormList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseFormList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseFormList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns |
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseFormList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
ScrollOnThumbTrackState | Determines if scrolling should occur when the thumb is dragged or when it is dragged and released |
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  |
Status_Help | Sets the text of the help text that appears in the status bar |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
ThumbScrollState | Determines if the scrollbar should use the more standard windows scrollbar behavior |
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Grid [Property Current_Col]

Current_Col - Grid

Returns the number of the column of the list that the cursor currently is located in

Type: Property

Access: Read-Only

Data Type: Integer

Description

Current_col returns the number of the column of the list that the cursor currently is located in.

Last Edited: July 31, 2003


Grid [Property CustomScrollState]

CustomScrollState - Grid

Determines changing scroll bar behaviors

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Any time you customize the scroll bar messages you should set the CustomScrollState.

If you are going to be changing scroll bar behaviors you are going to need to replace the behaviors in the existing super-classes (the dfbase and dfdata packages), while making sure that these messages still get forwarded to the runtime. These messages must get forwarded to the runtime or scrollbar control will not be notified of changes. To accomplish this you must set the property CustomScrollState to True.

When set to True, the package augmentations for the messages SetVScrollInfo, SetVScrollPos and SetVScrollBox are ignored and the messages are forwarded to the runtime.

Last Edited: January 12, 2006


Grid [Property Enabled_State]

Enabled_State - Grid

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


Grid [Property Explicit_Shadow_State]

Explicit_Shadow_State - Grid

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


Grid [Property Floating_Menu_Object]

Floating_Menu_Object - Grid

Identifies the floating context menu for this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Floating_Menu_Object property identifies the floating menu for this object. The default setting will provide a standard edit context menu. You may create your own custom floating menus and assign them to objects by setting this property. You may also disable a floating menu by setting this property to zero.

See Also

Form

Last Edited: November 22, 2004


Grid [Property Help_id]

Help_id - Grid

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


Grid [Property Help_Keyword]

Help_Keyword - Grid

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


Grid [Property Item_Shadow_State]

Item_Shadow_State - Grid

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


Grid [Property Maximum_Position]

Maximum_Position - Grid

Determines the maximum position for a spin button

Type: Property

Access: Read/Write

Data Type: Integer

Description

Maximum_Position determines the maximum position for a spin button. This property should be set within the method onInitSpin. When the spinner is pressed, the message OnInitSpin is called. It is up to you to set the properties minimum_position and maximum_position (which will properly initialize the spinner). You can use current_item and Current_col to figure out what you called.

// Assume we have spinners in column 1 and 2. Depending on the
// column we want to set different min and max positions
Procedure onInitSpin
   Integer iCol
   Get current_col to iCol
   If (iCol=1) Begin
      Set minimum_position to 0
      Set maximum_position to 10
   End
   Else begin
      Set minimum_position to 1
      Set maximum_position to 100
   End
End_procedure

Default is 32767.

Last Edited: August 18, 2003


Grid [Property Minimum_Position]

Minimum_Position - Grid

Determines the minimum position for a spin button

Type: Property

Access: Read/Write

Data Type: Integer

Description

Minimum_Position determines the minimum position for a spin button. This property should be set within the method onInitSpin. When the spinner is pressed, the message OnInitSpin is called. It is up to you to set the properties minimum_position and maximum_position (which will properly initialize the spinner). You can use current_item and Current_col to figure out what you called.

// Assume we have spinners in column 1 and 2. Depending on the
// column we want to set different min and max positions
Procedure onInitSpin
  Integer iCol
   Get current_col to iCol
   If (iCol=1) Begin
      Set minimum_position to 0
      Set maximum_position to 10
   End
   Else Begin
      Set minimum_position to 1
      Set maximum_position to 100
   End
End_procedure

Default is -32767.

Last Edited: August 18, 2003


Grid [Property Object_Shadow_State]

Object_Shadow_State - Grid

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


Grid [Property peResizeColumn]

peResizeColumn - Grid

Determines the method used for resizing columns

Type: Property

Access: Read/Write

Data Type: Integer

Description

peResizeColumn determines the method used for resizing columns. The following constants are supported:

Constant | Meaning
rcNone | No resizing of columns
rcLastColumn | The last column is resized
 | All columns are proportionally resized
rcSelectedColumn | Resize the column specified by the property piResizeColumn

You may choose to never automatically resize columns, always resize all columns on a ratio basis, or resize any selected column. Setting these properties have no effect on how columns are resized manually. If the property resize_column_state is true, you may manually resize any column by dragging the edge of a header with the mouse.

If you need to define more sophisticated header sizing strategies, you can augment the message DoAdjustGridWidths and write your own resizing routine.

Default is rcLastColumn.

Last Edited: January 19, 2006


Grid [Property piResizeColumn]

piResizeColumn - Grid

Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn

Type: Property

Access: Read/Write

Data Type: Integer

Description

If the mode property peResizeColumn is set to rcSelectedColumn, the column to be resized is determined by the value in piResizeColumn. Columns are zero based; therefore setting peResizeColumn to 0 causes the first column to be resized. If peResizeColumn is set to any value other than rcSelectedColumn, the property is ignored.

In the following example, the column to be automatically resized is selected by clicking the column's header (Clicking on a grid column header sends the message Header_mouse_click).

Procedure Header_Mouse_Click Integer iColumn
   Set peResizeColumn to rcSelectedColumn // make sure mode is correct
   Set piResizeColumn to iColumn          // this is the column to resize
End_Procedure

Default is 0.

Last Edited: September 11, 2003


Grid [Property psHtmlHelpTopic]

psHtmlHelpTopic - Grid

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


Grid [Property ScrollOnThumbTrackState]

ScrollOnThumbTrackState - Grid

Determines if scrolling should occur when the thumb is dragged or when it is dragged and released

Type: Property

Access: Read/Write

Data Type: Boolean

Description

ScrollOnThumbTrackState determines if scrolling should occur when the thumb is dragged or when it is dragged and released. When set to True (the default) the grid scrolls as the thumb is dragged.

Normally, you will want to leave this property set to True. If your list contains a great deal of custom code to support special scrolling behaviors such that your grids can not support scrolling in "real time", you may need to set this to False. Since non-virtual grids scroll in-memory data this is not a likely occurrence.

Last Edited: January 12, 2006


Grid [Property Spin_Value]

Spin_Value - Grid

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: November 30, 2004


Grid [Property Status_Help]

Status_Help - Grid

Sets the text of the help text that appears in the status bar

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

Status_help property sets the text of the help text that appears in the status bar. Note that an item number and a help value must be passed. The item number is actually a column number and represents the status help value for all items within the passed column.

Last Edited: September 11, 2003


Grid [Property ThumbScrollState]

ThumbScrollState - Grid

Determines if the scrollbar should use the more standard windows scrollbar behavior

Type: Property

Access: Read/Write

Data Type: Boolean

Description

ThumbScrollState property determines if the scrollbar should use the more standard windows scrollbar behavior. When set to True (the default), thumb movements will cause the grid to scroll. When set to False, thumb movements will generate row-up and row-down behaviors similar to pressing the scroll bar up and down arrows.

These behaviors are easier to see than to describe. You are encouraged to create a Grid in the Studio and try changing these properties.

Note: By setting both ScrollOnThumbTrackState and ThumbScrollState to False your grids will behave the way they did in previous versions of VDF.

Last Edited: January 12, 2006


Grid [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - Grid

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


Group [Event OnBeginningOfPanel]

OnBeginningOfPanel - Group

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


Group [Event OnKillFocus]

OnKillFocus - Group

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


Group [Event OnSetFocus]

OnSetFocus - Group

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


Group [Event Prompt_Callback]

Prompt_Callback - Group

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


Group [Event Shadow_Display]

Shadow_Display - Group

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for Group

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |


Group [Function Next_Object_Id]

Next_Object_Id - Group

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


Group [Function Prior_Object_Id]

Prior_Object_Id - Group

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for Group

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Group [Procedure Activate_Area]

Activate_Area - Group

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Group [Procedure Beginning_of_Panel]

Beginning_of_Panel - Group

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


Group [Procedure Bottom_of_Panel]

Bottom_of_Panel - Group

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


Group [Procedure DoHtmlHelp]

DoHtmlHelp - Group

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


Group [Procedure End_of_Panel]

End_of_Panel - Group

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


Group [Procedure Error_Help]

Error_Help - Group

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Group [Procedure Extended_Help]

Extended_Help - Group

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Group [Procedure File_Help]

File_Help - Group

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Group [Procedure Help]

Help - Group

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Group [Procedure Help_For_Help]

Help_For_Help - Group

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Group [Procedure Help_Index]

Help_Index - Group

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Group [Procedure Help_on_topic]

Help_on_topic - Group

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Group [Procedure Keys_Help]

Keys_Help - Group

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Group [Procedure Request_Status_Help]

Request_Status_Help - Group

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


Group [Procedure Top_of_Panel]

Top_of_Panel - Group

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for Group

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true |
Bitmap | Displays a bitmap in an object |
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program |
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  |
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows |
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Group [Property Auto_Locate_State]

Auto_Locate_State - Group

Locates itself relative to any item that invokes it with a popup message when set true

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_Locate_State property is true, this object will locate itself relative to any item that invokes it with a popup message (i.e., relative to the position of the cursor in another object when the prompt key was pressed). The position at which this object pops up depends on the values of its column_offset and row_offset properties.

This property exists primarily for backwards compatibility. You are encouraged to use the more powerful locate_mode property in its place.

Default is false.

Last Edited: January 12, 2006


Group [Property Bitmap]

Bitmap - Group

Displays a bitmap in an object

Type: Property

Access: Read/Write

Data Type: String

Description

The Bitmap message will display a bitmap in an object. In other words, the bitmap becomes the background of the object.
Bitmap_Style determines how and where the bitmap will display in the object.

There are two potential drawbacks to using bitmaps: the amount of storage (on disk) , and the constant memory consumption.

Sample

This sample sets the bitmap to "MyBitmap.bmp".

set Bitmap to "MyBitmap.bmp"

Note:
In order to make a cohesive application, Visual DataFlex must find the .EXE file and the .bmp (bitmap) file, by using DFPATH.

Last Edited: November 24, 2004


Group [Property Column_Offset]

Column_Offset - Group

Determines the offset to the invoking item by number of columns

Type: Property

Access: Read/Write

Data Type: Integer

Description

If this object is located using POPUP_LOCATE logic (or auto_locate_state is true), it will pop up to the right of the invoking item by the number of columns in the Column_Offset property and below it by the number of rows in row_offset. This property may have a negative, as well as positive, value. The offset is stated as a number of characters, these being of an averaged size for the font currently in effect.

Default is 2.

Last Edited: August 5, 2003


Group [Property Enabled_State]

Enabled_State - Group

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


Group [Property Explicit_Shadow_State]

Explicit_Shadow_State - Group

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


Group [Property Help_id]

Help_id - Group

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


Group [Property Help_Keyword]

Help_Keyword - Group

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


Group [Property Item_Shadow_State]

Item_Shadow_State - Group

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


Group [Property Label]

Label - Group

This is the text that appears within this control

Type: Property

Access: Read/Write

Data Type: String

Description

This is the text that appears within this control. It can be set and queried through this property.

When used with the Button class, this sets the text within the button.

When used with the CheckBox class, this sets the text that appears to the right of the checkbox.

When used with the TextBox class, this sets the text that appears inside of the textbox.

When used with containers (Panel, Group, dbGroup), this sets the text that appears in the container.

See Also

Button | CheckBox | TextBox | Panel | Group | dbGroup

Last Edited: August 18, 2003


Group [Property Locate_Mode]

Locate_Mode - Group

Provides several flexible methods for auto positioning container panels in your program

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Locate_Mode property provides several flexible methods for auto positioning container panels in your program. The following modes are supported:

Constant | Meaning
NO_LOCATE | No auto-location is performed. The object must be manually located by using the set location message.
POPUP_LOCATE | This causes the object to locate itself relative to the object (and item) that invoked it. It is ideal for locating popup modal objects (like selection-lists). The position at which this object pops up depends on the values of its column_offset and row_offset properties.
CENTER_ON_SCREEN | This causes the container to appear in the center of the screen.
CENTER_ON_PANEL | This causes the container to centered within the current main program panel.
CENTER_ON_PARENT | This causes the container to appear in the center of its parent container.
SMART_LOCATE | This mode "just does the right thing". This message will cause the object to apply the best locating strategy for current conditions. If the object is a modal popup (modal_state is true) and there is an invoking object it will locate relative to the invoking object (popup_locate), else, if the object already has been assigned a location it will use that location. else, if main-panel exists it will center within that panel (center_on_panel), else, it will center itself on the screen (center_on_screen). All panels default to this mode. This causes modal popup panels to locate relative to their parent and modeless panels to appeared centered unless explicitly located.

Default is SMART_LOCATE.

Last Edited: September 10, 2004


Group [Property Object_Shadow_State]

Object_Shadow_State - Group

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


Group [Property Offset_Location]

Offset_Location - Group

Type: Property

Access: Write-Only

Data Type: Integer

Parameters: integer Row# Integer Col#

Parameter | Description
Row# | [ToDo: In Progress]
Col# | [ToDo: In Progress]

Description

Last Edited: July 8, 2003


Group [Property psHtmlHelpTopic]

psHtmlHelpTopic - Group

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


Group [Property Row_Offset]

Row_Offset - Group

Determines the offset to the invoking item by number of rows

Type: Property

Access: Read/Write

Data Type: Integer

Description

If this object is located using POPUP_LOCATE logic (or auto_locate_state is true), it will pop up to the right of the invoking item by the number of columns in column_offset and below it by the number of rows in the Row_Offset property. This property may have a negative, as well as positive, value. This offset is stated as a number of rows, these being the row height for the font currently in effect.

Default is 1.

Last Edited: September 11, 2003


Group [Property Status_Help]

Status_Help - Group

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


Group [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - Group

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


Events for HelpSystem

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for HelpSystem

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
View_Context_Help | Procedure | Sent when the requesting object has requested keyword or ID help |
View_Context_ID_Help | Procedure | Sent when the requesting object has requested integer-ID context help |
View_Context_KeyWord_Help | Procedure | Sent when the requesting object has requested keyword-context help |
View_Error_Help | Procedure | Displays an error help topic |
View_File_Help | Procedure | Sent when the requesting object has requested help about a database file |
View_Help_for_help | Procedure | Calls the standard Windows "Help on Help" file |
View_help_index | Procedure | Displays the help file's index |
View_Help_on_Topic | Procedure | Pops up the help system's "Search" dialog |
View_Keys_Help | Procedure | Displays the help file's key topic |


HelpSystem [Procedure View_Context_Help]

View_Context_Help - HelpSystem

Sent when the requesting object has requested keyword or ID help

Type: Procedure

Parameters: integer Obj

Parameter | Description
Obj | The object ID of the object that is requesting help

Description

The requesting object (Obj) has requested keyword or ID help. It is up to the requesting object to determine what kind of context it wants to use. This context is obtained by calling the Function help_context in the requesting object. If help_context returns a number, it will be used for context-ID help. If a string is returned, it will be used for keyword help. Because of this message's flexibility, it is usually used instead of view_context_keyword_help or view_context_ID_help.

If the context value is an ID, it will be converted to a Windows ID by calling the function system_help_context_ID.

Last Edited: September 15, 2003


HelpSystem [Procedure View_Context_ID_Help]

View_Context_ID_Help - HelpSystem

Sent when the requesting object has requested integer-ID context help

Type: Procedure

Parameters: integer Obj

Parameter | Description
Obj | The object ID of the object that is requesting help

Description

The requesting object (Obj) has requested integer-ID context help. This ID context is obtained by calling the function help_context in the requesting object. The context ID returned by help_context is converted into a Windows Help ID by calling a help_object function named system_help_context_ID. This function is passed the DataFlex help ID and is expected to return a Windows Help ID. By default, these values will be the same. This is provided for augmentation purposes. It allows for complete independence between the program and the help system. You normally do not need this.

Last Edited: September 15, 2003


HelpSystem [Procedure View_Context_KeyWord_Help]

View_Context_KeyWord_Help - HelpSystem

Sent when the requesting object has requested keyword-context help

Type: Procedure

Parameters: integer Obj

Parameter | Description
Obj | The object ID of the object that is requesting help

Description

The requesting object (Obj) has requested keyword-context help. This keyword context is obtained by calling the function help_context in the requesting object. The returned keyword value is used when calling the Windows Help system.

Last Edited: September 15, 2003


HelpSystem [Procedure View_Error_Help]

View_Error_Help - HelpSystem

Displays an error help topic

Type: Procedure

Parameters: Integer Obj

Parameter | Description
Obj | The object ID of the object that is requesting help

Description

The error handler normally sends this message. The help system will find a context value by sending the message context_help to the requesting object. The context returned will probably be the last error number. If a number is returned, the translation of this error number into a help-file context is handled by the help_object's Function system_help_error_ID.

Suggesting a default method for converting an error number into a context value is difficult. Using the error number as a context ID is not good because the error number can span a very large range. The default behavior of this function is to return the help_object Property help_ID_errors. This would load the "General Error Help" topic. It is then up to users to navigate within the help system to find the specific error. If you wish to support context error help at the error-number level, you will have to program this support yourself.

Last Edited: September 15, 2003


HelpSystem [Procedure View_File_Help]

View_File_Help - HelpSystem

Sent when the requesting object has requested help about a database file

Type: Procedure

Parameters: Integer Obj

Parameter | Description
Obj | The object ID of the object that is requesting help

Description

The requesting object (Obj) has requested help about a database file. The file and field value must be obtained from the requesting object by sending it the message help_context. Unless modified, the function help_context will return the file and field as a string in file.field format or as a blank if there is no file.

This value needs to be processed one more level before it can be used as a help context value. It does this by calling the help_object function, system_help_file_ID. This function is passed the file.field string and is expected to return an appropriate context value (ID or keyword) for this file and field. The purpose of this function is to translate the DataFlex context (a file and a field) into help context. By default, it returns the file number (ignoring the field) or, if the file was 0, the help_ID_files property value. This assumes that the help file's topic ID will be the same as the file's file-list number.

This mechanism provides context support to the file-number level. It would require that users navigate within the help file to find documentation on a particular field. If you wish context support at the file and field level you will need to program this yourself.

Last Edited: September 15, 2003


HelpSystem [Procedure View_Help_for_help]

View_Help_for_help - HelpSystem

Calls the standard Windows "Help on Help" file

Type: Procedure

Parameters: integer obj

Parameter | Description
obj | The object ID of the object that is requesting help

Description

The view_help_for_help procedure will call the standard Windows "Help on Help" file.

Last Edited: September 15, 2003


HelpSystem [Procedure View_help_index]

View_help_index - HelpSystem

Displays the help file's index

Type: Procedure

Parameters: integer obj

Parameter | Description
obj | The object ID of the object that is requesting help

Description

The view_help_index procedure should display the help file's index. It will use the help_object property, help_ID_index, as the context value.

Last Edited: September 15, 2003


HelpSystem [Procedure View_Help_on_Topic]

View_Help_on_Topic - HelpSystem

Pops up the help system's "Search" dialog

Type: Procedure

Parameters: Integer obj

Parameter | Description
obj | The object ID of the object that is requesting help

Description

The view_help_on_topic procedure will pop up the help system's "Search" dialog.

Last Edited: September 15, 2003


HelpSystem [Procedure View_Keys_Help]

View_Keys_Help - HelpSystem

Displays the help file's key topic

Type: Procedure

Parameters: Integer Obj

Parameter | Description
Obj | The object ID of the object that is requesting help

Description

The view_keys_help procedure should display the help file's key topic. It will use the help_object property, help_ID_keys, as the context value.

Last Edited: September 15, 2003


Properties for HelpSystem

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Help_Id_Errors | Holds the name of the topic that should be presented for general error help |
Help_Id_Files | Should be set to the help file's help-on-data-files topic ID |
Help_Id_General | Should be set to the help file's general-help-topic ID |
Help_Id_Index | Should be set to the help file's index-topic ID |
Help_Id_Keys | Should be set to the help file's accelerator-keys-help-topic ID |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
psHelpFile | Assigns a help file name within the help object (not normally used) |


HelpSystem [Property Help_Id_Errors]

Help_Id_Errors - HelpSystem

Holds the name of the topic that should be presented for general error help

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Help_id_errors property holds the name of the topic that should be presented for general error help. Used by the view_error_help procedure.

Last Edited: August 18, 2003


HelpSystem [Property Help_Id_Files]

Help_Id_Files - HelpSystem

Should be set to the help file's help-on-data-files topic ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Help_ID_Files property should be set to the help file's help-on-data-files topic ID. When a file_help request is made to an object that does not have a file associated with it, this value will be passed to the help object.

Last Edited: August 18, 2003


HelpSystem [Property Help_Id_General]

Help_Id_General - HelpSystem

Should be set to the help file's general-help-topic ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Help_ID_General property should be set to the help file's general-help-topic ID. This context value is used when there is no other good context value to use.

Last Edited: August 18, 2003


HelpSystem [Property Help_Id_Index]

Help_Id_Index - HelpSystem

Should be set to the help file's index-topic ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Help_ID_Index property should be set to the help file's index-topic ID. This value is used to enable the help_index message to find the index in the help file.

Last Edited: August 18, 2003


HelpSystem [Property Help_Id_Keys]

Help_Id_Keys - HelpSystem

Should be set to the help file's accelerator-keys-help-topic ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Help_ID_Keys property should be set to the help file's accelerator-keys-help-topic ID. This value is used to enable the keys_help message to find this topic in the help file.

Last Edited: August 18, 2003


HelpSystem [Property psHelpFile]

psHelpFile - HelpSystem

Assigns a help file name within the help object (not normally used)

Type: Property

Access: Read/Write

Data Type: String

Description

The psHelpFile property assigns a help file name within the help object (not normally used).

When the help object opens a help file it uses the following logic to find a help file:

1. If psHelpFile is set, it uses that name. Normally, this property will not be set.

2. If psHelpFile is blank, it checks to see if the cApplication object exists and if it does, if it has a psHelpFile name set. If so, this name is used. This is the preferred place to set your help file name.

3. If no help file exists, the help system uses the old private help name which gets the full name from the registry. This last method is considered obsolete (and far too complicated).

It is always recommended that you set the help file name in the cApplication object.

If psHelpFile is used here or in the cApplication object, the property should contain just the filename and extension. The help system will attempt to find the file in an appropriate workspace path.

Last Edited: September 11, 2003


Events for InetTransfer

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for InetTransfer

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for InetTransfer

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
LastErrorCode | Returns the last error code from the HTTP / FTP Transfer |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peTransferFlags | Various flags that control how file/data should be transferred |
piBufferSize | Specifies the size of the file transfer buffer |
piRemotePort | Specifies the port to connect to on RemoteHost |
psAgent | Specifies the name of the application |
psPassword | Specifies the password to use to log on |
psProxy | Specifies the name of the Proxy server used, if any |
psRemoteHost | Specifies the hostname or the IP address of the remote server |
psUserName | Specifies the name of the user to log on |
RootHandle | Returns the root HINTERNET handle used for the session |


InetTransfer [Property LastErrorCode]

LastErrorCode - InetTransfer

Returns the last error code from the HTTP / FTP Transfer

Type: Property

Access: Read-Only

Data Type: Integer

Description

The LastErrorCode property returns the last error from an HTTP or FTP transfer.

Last Edited: August 18, 2003


InetTransfer [Property peTransferFlags]

peTransferFlags - InetTransfer

Various flags that control how file/data should be transferred

Type: Property

Access: Read/Write

Data Type: Integer

Description

peTransferFlags are various flags that control how file/data should be transferred.

This property, used with GetRequest, PostRequest and PutRequest, can contain any number of the following values:

ifCacheIfNetFail
ifHyperlink
ifIgnoreCertCnInvalid
ifIgnoreCertDateInvalid
ifIgnoreRedirectToHttp
ifIgnoreRedirectToHttps
ifKeepConnection
ifNeedFile
ifNoAuth
ifNoAutoRedirect
ifNoCacheWrite
ifNoCookies
ifNoUi
ifPragmaNocache
ifReload
ifResynchronize
ifSecure

If you are set the ifSecure flag to access an SSL site (HTTPS), you will probably also need to set the remote port (piRemotePort) to rpHttpSSL.

Set piRemotePort to rpHttpSSL
Set peTransferFlags to ifSecure

Last Edited: August 12, 2005


InetTransfer [Property piBufferSize]

piBufferSize - InetTransfer

Specifies the size of the file transfer buffer

Type: Property

Access: Read/Write

Data Type: Integer

Description

piBufferSize specifies the size of the file transfer buffer. The cHttpTransfer class tries to transfer the file in chunks of BufferSize bytes at the time. The OnDataReceive event is triggered after each successful transfer of BufferSize bytes.

When used with cHttpTransfer class, default is 1024.
When used with cFtpTransfer class, default is 8192.

Last Edited: September 11, 2003


InetTransfer [Property piRemotePort]

piRemotePort - InetTransfer

Specifies the port to connect to on RemoteHost

Type: Property

Access: Read/Write

Data Type: Integer

Description

piRemotePort specifies the port to connect to on RemoteHost. It can be any valid port number. The following constants may be also be used:

Constant | Meaning
rpHttp | The default Http port (80).
rpHttpSSL | The default Https (secure, SSL layer) port (443)
rpFtp | The default Ftp port (21)

When used with cHttpTransfer class, default is rpHttp.
When used with cFtpTransfer class, default is rpFtp.

If you need to access a secure SSL site (e.g., Https:) you will want to set the port to rpHttpSSL and will need to set the peTransferFlags so that it contains the ifSecure flag. If your secure site requires a client certificate, you may select this using SelectClientCertificate method.

Set piRemotePort to rpHttpSSL
Set peTransferFlags to ifSecure

Last Edited: August 12, 2005


InetTransfer [Property psAgent]

psAgent - InetTransfer

Specifies the name of the application

Type: Property

Access: Read/Write

Data Type: String

Description

psAgent specifies the name of the application. The value of this property is used as the "User Agent" in the HTTP protocol.

Default is "Visual DataFlex".

Last Edited: September 11, 2003


InetTransfer [Property psPassword]

psPassword - InetTransfer

Specifies the password to use to log on

Type: Property

Access: Read/Write

Data Type: String

Description

psPassword specifies the password to use to log on.

Last Edited: September 11, 2003


InetTransfer [Property psProxy]

psProxy - InetTransfer

Specifies the name of the Proxy server used, if any

Type: Property

Access: Read/Write

Data Type: String

Description

psProxy specifies the name of the Proxy server used, if any. If the value of this property is blank, no proxy server is used.

If you need to address a specific port, use the piRemotePort property to do so.

Sample

Procedure OnClick
    Boolean bStatus

    Set psRemoteHost Of oHTTPTransfer To "proxy.somedomain.com"
    Set piRemotePort Of oHTTPTransfer To 8080

    Get HttpGetRequest Of oHTTPTransfer "" To bStatus
    Send Info_Box bStatus "bStatus"
End_Procedure // OnClick

See Also

Info_Box

Last Edited: November 23, 2004


InetTransfer [Property psRemoteHost]

psRemoteHost - InetTransfer

Specifies the hostname or the IP address of the remote server

Type: Property

Access: Read/Write

Data Type: String

Description

psRemoteHost specifies the hostname or the IP address of the remote server.

Last Edited: September 11, 2003


InetTransfer [Property psUserName]

psUserName - InetTransfer

Specifies the name of the user to log on

Type: Property

Access: Read/Write

Data Type: String

Description

psUserName specifies the name of the user to log on.

Last Edited: September 11, 2003


InetTransfer [Property RootHandle]

RootHandle - InetTransfer

Returns the root HINTERNET handle used for the session

Type: Property

Access: Read-Only

Data Type: Handle

Description

RootHandle returns the root HINTERNET handle used for the session. You will not normally need to use this property, but it is provided so that you can access the low-level Windows API, if you need to.

Last Edited: September 11, 2003


Events for LineControl

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for LineControl

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for LineControl

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Line_Color |  | DfBaselineControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Horizontal_State | Specifies whether the line is horizontal or vertical | DfBaselineControl
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Offset |  | DfBaselineControl
Line_Style | Supports the line styles LnDip, LnBump, and LnSingle | DfBaselineControl
Line_Thickness | Determines the pixel thickness of the line | DfBaselineControl
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Line_Color |  | DfBaselineControl
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


List [Event OnBeginningOfPanel]

OnBeginningOfPanel - List

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


List [Event OnChange]

OnChange - List

A "hook" procedure for you to use for any action you wish to occur when the data in this object changes

Type: Event

Parameters: No Parameters

Description

The OnChange message is a "hook" procedure for you to use for any action you wish to occur when the data in this object changes. As supplied, it does nothing. Sent whenever the current_item is changed.

Note:The OnChange event should not be used to change focus or to alter the value of controls such as Form or ComboForm.

This event is created to respond to a data change event and not to trigger other data changes. If you want to respond to a change in a combo based on a user selection, it is suggested you augment other procedures such as Combo_Item_Changed and Combo_Edit_Changed.

Last Edited: February 18, 2004


List [Event OnKillFocus]

OnKillFocus - List

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


List [Event OnSetFocus]

OnSetFocus - List

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


List [Event Prompt_Callback]

Prompt_Callback - List

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


List [Event Shadow_Display]

Shadow_Display - List

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for List

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |


List [Function Next_Object_Id]

Next_Object_Id - List

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


List [Function Prior_Object_Id]

Prior_Object_Id - List

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for List

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set |  |
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


List [Procedure Set Select_Count]

Select_Count - List

Type: Procedure Set

Data Type: Integer

Parameters: Integer iCount

Parameter | Description
iCount | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


List [Procedure Activate_Area]

Activate_Area - List

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


List [Procedure Beginning_of_Panel]

Beginning_of_Panel - List

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


List [Procedure Bottom_of_Panel]

Bottom_of_Panel - List

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


List [Procedure DoHtmlHelp]

DoHtmlHelp - List

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


List [Procedure End_of_Panel]

End_of_Panel - List

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


List [Procedure Error_Help]

Error_Help - List

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


List [Procedure Extended_Help]

Extended_Help - List

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


List [Procedure File_Help]

File_Help - List

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


List [Procedure Help]

Help - List

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


List [Procedure Help_For_Help]

Help_For_Help - List

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


List [Procedure Help_Index]

Help_Index - List

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


List [Procedure Help_on_topic]

Help_on_topic - List

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


List [Procedure Keys_Help]

Keys_Help - List

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


List [Procedure Request_Status_Help]

Request_Status_Help - List

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


List [Procedure Top_of_Panel]

Top_of_Panel - List

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for List

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object |
Label_Col_Offset | The horizontal distance from the object to its label |
Label_Justification_Mode | The justification mode for the text within this object's label |
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property |
Label_Row_Offset | The vertical distance from the top edge of the object and its label |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count |  |
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State |  |
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


List [Property Enabled_State]

Enabled_State - List

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


List [Property Explicit_Shadow_State]

Explicit_Shadow_State - List

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


List [Property Help_id]

Help_id - List

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


List [Property Help_Keyword]

Help_Keyword - List

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


List [Property Item_Shadow_State]

Item_Shadow_State - List

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


List [Property Label]

Label - List

Sets the text for a label or heading for an entry control object

Type: Property

Access: Read/Write

Data Type: String

Description

The Label property sets the text for a label or heading for an entry control object (form, edit or list). In most classes, just setting this property is all that is required for the class to present the label in whatever particular way each class does this. In data-aware classes, the value of this property is overridden by label values in the DDO when auto_label_state has been set true.

Object F1 is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "First Name:"
End_object

Last Edited: August 18, 2003


List [Property Label_Col_Offset]

Label_Col_Offset - List

The horizontal distance from the object to its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Col_Offset is the horizontal distance from the object to its label. Units represent distance to the left (i.e., labels appear to the left of their object). If the label's justification-mode is left or top (jmode_left, jmode_top) this represents the distance from left edge of the object to the left edge of its label. If the justification-mode is right (jmode_right) this represents the distance from the left edge of the object to the right edge of the label. By default, this is the value of default_label_offset, which is supplied with a value of 60 (this is a global integer which can be changed).

Default is default label offset.

Last Edited: August 18, 2003


List [Property Label_Justification_Mode]

Label_Justification_Mode - List

The justification mode for the text within this object's label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Justification_Mode is the justification mode for the text within this object's label.

When the label_justification_mode is changed the row and col offset properties will often need to be changed as well.

The default mode for labels (jmode_left) is stored in the global integer default_label_jmode.

Object LeftForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Left Justify:" // use default column of 60
End_object

Object RightForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Right Justify:"
    Set label_justification_mode to jmode_right
    // set distance between right side of the label and the left side
    // of the object
    Set label_col_offset to 3
End_object

Object TopForm is a Form
    Set Size to 13 100
    Set location to 10 70
    Set label to "Top Justify:"
    Set label_justification_mode to jmode_top
    // label and object will align vertically
    Set label_col_offset to 0
End_object

Default is JMode Left.

Last Edited: August 18, 2003


List [Property Label_Offset]

Label_Offset - List

Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer i1 integer i2

Parameter | Description
i1 | The Row Offset of the Label
i2 | The Column Offset of the Label

Description

The Label_Offset property returns both the label_row_offset and the label_col_offset properties as a single (two-component) property. The Hi() value of the return parameter represents the row offset. The Low() value represents the column offset.

Get Label_Offset of oForm to iOffset
Move (Hi(iOffset))  to iRowOffset
Move (Low(iOffset)) to iColumnOffset

Label_offset is set as a single property passing the row offset and the column offset as two separate parameters.

Set Label_Offset of oForm to iRowOffset iColumnOffset

This is a Complex Property

When this property is set two integer parameters are passed as specified in the parameter list. When the value of the property is retreived (get), the value of these two properties is returned as a complex single integer. The data is packed in this value in hi/low format (first parameter=hi, second parameter=low). The value of these parameters are unpacked using the hi() and low() functions.

Last Edited: June 22, 2005


List [Property Label_Row_Offset]

Label_Row_Offset - List

The vertical distance from the top edge of the object and its label

Type: Property

Access: Read/Write

Data Type: Integer

Description

Label_Row_Offset is the vertical distance from the top edge of the object and its label. If the label's justification-mode is jmode_top it represents the vertical distance from the top edge of this object to the bottom edge of its label and larger numbers moves the label up (and away from the object). If the mode is not top it represents the distance from the top edge of the object and the top edge of the label and larger numbers moves the label down. By default, this is zero which is suitable for both form and side labels.

Default is 0.

Last Edited: August 18, 2003


List [Property Object_Shadow_State]

Object_Shadow_State - List

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


List [Property psHtmlHelpTopic]

psHtmlHelpTopic - List

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


List [Property Select_Count]

Select_Count - List

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


List [Property Select_State]

Select_State - List

Type: Property

Access: Write-Only

Data Type: Integer

Parameters: Integer iItem Integer bSelected

Parameter | Description
iItem | [ToDo: In Progress]
bSelected | [ToDo: In Progress]

Description

Last Edited: June 2, 2006


List [Property Status_Help]

Status_Help - List

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


List [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - List

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


MdiClientArea [Event OnKillFocus]

OnKillFocus - MdiClientArea

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


MdiClientArea [Event OnSetFocus]

OnSetFocus - MdiClientArea

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Events for MdiClientArea

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus |  |
OnSetFocus |  |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for MdiClientArea

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Arrange_Icons | Procedure | Arranges the icons for all minimized views contained by this object | DfBasemdiclient
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
Cascade_Windows | Procedure | Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it | DfBasemdiclient
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Next_View | Procedure | Switches the focus to the next view object in this object | DfBasemdiclient
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Switch_Prior_View | Procedure | Switches the focus to the previous view object in this object | DfBasemdiclient
Tile_Windows_Horizontal | Procedure | Arranges this object's views from left to right across the top, and then down to the next line, also so arranged | DfBasemdiclient
Tile_Windows_Vertical | Procedure | Arranges this object's views from top to bottom down the left side, and then right to the next column, also so arranged | DfBasemdiclient
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


MdiClientArea [Procedure DoHtmlHelp]

DoHtmlHelp - MdiClientArea

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


MdiClientArea [Procedure Error_Help]

Error_Help - MdiClientArea

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


MdiClientArea [Procedure Extended_Help]

Extended_Help - MdiClientArea

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


MdiClientArea [Procedure File_Help]

File_Help - MdiClientArea

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


MdiClientArea [Procedure Help]

Help - MdiClientArea

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


MdiClientArea [Procedure Help_For_Help]

Help_For_Help - MdiClientArea

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


MdiClientArea [Procedure Help_Index]

Help_Index - MdiClientArea

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


MdiClientArea [Procedure Help_on_topic]

Help_on_topic - MdiClientArea

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


MdiClientArea [Procedure Keys_Help]

Keys_Help - MdiClientArea

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


Properties for MdiClientArea

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object |
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Scroll_Bar_Visible_State | Specifies whether this object is to display a scroll bar (or bars) when the content of the object exceeds this object's same-time display capacity | DfBasemdiclient
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


MdiClientArea [Property Bitmap]

Bitmap - MdiClientArea

Displays a bitmap in an object

Type: Property

Access: Read/Write

Data Type: String

Description

The Bitmap message will display a bitmap in an object. In other words, the bitmap becomes the background of the object.
Bitmap_Style determines how and where the bitmap will display in the object.

There are two potential drawbacks to using bitmaps: the amount of storage (on disk) , and the constant memory consumption.

Sample

This sample sets the bitmap to "MyBitmap.bmp".

set Bitmap to "MyBitmap.bmp"

Note:
In order to make a cohesive application, Visual DataFlex must find the .EXE file and the .bmp (bitmap) file, by using DFPATH.

Last Edited: November 24, 2004


MdiClientArea [Property Help_id]

Help_id - MdiClientArea

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


MdiClientArea [Property Help_Keyword]

Help_Keyword - MdiClientArea

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


MdiClientArea [Property psHtmlHelpTopic]

psHtmlHelpTopic - MdiClientArea

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


MdiDialog [Event OnPaint]

OnPaint - MdiDialog

Sent every time a panel is painted

Type: Event

Parameters: No Parameters

Description

The OnPaint event message is sent every time a panel is painted.

Last Edited: September 10, 2003


MdiDialog [Event OnResize]

OnResize - MdiDialog

Sent every time a panel is resized

Type: Event

Parameters: No Parameters

Description

The OnResize event message is sent every time a panel is resized. This message is only sent when the panel is active (paged on the screen). It is also sent when the panel is being paged. This message is most-often used to size and locate child objects when a panel has been paged or resized.

Procedure onResize
    // locate and size child objects relative to the size of the parent
    Broadcast Send Locate_yourself
End_procedure

Last Edited: September 10, 2003


Events for MdiDialog

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnPaint | Sent every time a panel is painted |
OnResize | Sent every time a panel is resized |
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d


Methods for MdiDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area |
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated |
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate |
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


MdiDialog [Procedure Close_Panel]

Close_Panel - MdiDialog

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


MdiDialog [Procedure DoCenterMdiDialog]

DoCenterMdiDialog - MdiDialog

Locates an MDI Dialog in the center of the MDI client area

Type: Procedure

Parameters: No Parameters

Description

The DoCenterMdiDialog message locates an MDI Dialog in the center of the MDI client area. Its sub-classes View, dbView and ReportView inherit this behavior.

This can be sent at any time. An ideal place to send this is inside of the method Load environment as follows:

Procedure Load_Environment
   // if you forwarded the location and size is set from your
   // registry. So sometimes not forwarding this is a useful technique
   forward send Load_environment
   // by sending this after the forward, we can center any view
   // and counteract the effect of registry settings.
   send DoCenterMdiDialog
end_procedure

Developers have attempted unsuccessfully to use the locate_mode property to center views within the work area as follows:

// this does not work with Views or any mdi dialogs
set locate_mode to CENTER_ON_PANEL

This does not work and your view will not be properly centered. The property locate_mode is not supposed to be used with mdi dialogs (View or dbView objects). While the class understands the message, it will not do anything useful. You should not use this property in views. Use the DoCenterMdiDialog message.

Last Edited: July 31, 2003


MdiDialog [Procedure Popup_Modal]

Popup_Modal - MdiDialog

Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns non-zero if popup failed (this value is normally not used)

Description

The Popup_modal message activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated. This message sets the modal_state property true until this object is deactivated, at which time it is restored to false. This message has no effect on an already-active object.

Send Popup_modal to oCustomerList

Last Edited: September 25, 2003


MdiDialog [Procedure Stop_Modal_UI]

Stop_Modal_UI - MdiDialog

Causes the modal object to deactivate

Type: Procedure

Parameters: No Parameters

Description

When the Stop_modal_ui message is received, the current user interface is terminated. This causes the modal object to deactivate.

Last Edited: September 11, 2003


Properties for MdiDialog

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  |
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


MdiDialog [Property Current_Action_Button]

Current_Action_Button - MdiDialog

Type: Property

Access: Read-Only

Data Type: Integer

Description

Last Edited: February 13, 2003


MdiDialog [Property Default_Action_Button]

Default_Action_Button - MdiDialog

The object handle of the default action button

Type: Property

Access: Read/Write

Data Type: Integer

Description

A single button object within a panel/dialog object may be designated as the default-action button. This button is assigned by setting its default_action_button property. This property is not normally set directly. Instead, you will usually set the default_state of the button (which, in turn, will set the Default_action_button property). The following two samples will exhibit the same behavior.

Object OK_bn is a Button
    Set Label to "&Ok"
    Set Location to 115 152
    Set default_state to TRUE
    Procedure OnClick
        Send Save_record
    End_Procedure
End_Object

and:

Object OK_bn is a Button
    Set Label to "&Ok"
    Set Location to 115 152
    Procedure OnClick
        Send Save_record
    End_Procedure
End_Object
Set default_action_button to Ok_bn

See default_state in the button class for more information on default action buttons.

Last Edited: July 31, 2003


MdiDialog [Property Modal_State]

Modal_State - MdiDialog

Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated

Type: Property

Access: Read/Write

Data Type: Boolean

Description

This property is set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, and false when the object popped up by popup_modal is deactivated. When this property is set to true, the following properties are set:

Block_mouse_State | true
Attach_Parent_State | false
Scope_State | true
Ring_State | true
Popup_State | true

When this property is set to false, the following properties are set:

Block_mouse_State | false
Attach_Parent_State | true

Normally you will not set this property to false since this is the default. If you need to alter these individual property settings, you can either augment the modal_state procedure set or you can simply adjust any of the individual properties after you have set the modal_state.

If you wish to toggle an object's modality during runtime, it is suggested that you not set this property. You will need the object in its default modeless state. The object can then be activated non-modally by sending it the activate message and activated modally by sending it the popup_modal message.

Default is false.

Last Edited: January 12, 2006


MenuBar [Event OnChange]

OnChange - MenuBar

A "hook" procedure has no definition; it is provided for your use

Type: Event

Parameters: No Parameters

Description

OnChange is a "hook" procedure and has no definition; it is provided for your use. It is sent by change_menu.

Last Edited: September 10, 2003


MenuBar [Event OnInitMenu]

OnInitMenu - MenuBar

Sent when a menu-bar system is about to be activated

Type: Event

Parameters: No Parameters

Description

The OnInitMenu event message is sent when a menu-bar system is about to be activated.

Last Edited: September 10, 2003


Events for MenuBar

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Initialize_Menu | Sent when the Menubar system is about to be selected | DfBaseActionBar
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChange | A "hook" procedure has no definition; it is provided for your use |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnInitMenu | Sent when a menu-bar system is about to be activated |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


MenuBar [Function Menu_Status_Help]

Menu_Status_Help - MenuBar

Type: Function

Return Data Type: String

Parameters: Integer Item# Integer Flags

Parameter | Description
Item# | [ToDo: In Progress]
Flags | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for MenuBar

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Exit_Menu | Procedure |  | DfBaseActionBar
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Menu_Status_Help | Function |  |
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Redirect_Message | Procedure |  | DfBaseActionBar
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for MenuBar

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Shadow_Status_Help | Specifies the display in the status bar for items of this object that are shadowed |
Simple_Status_Help_State |  |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | The status-bar help text for Item item# |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


MenuBar [Property Shadow_Status_Help]

Shadow_Status_Help - MenuBar

Specifies the display in the status bar for items of this object that are shadowed

Type: Property

Access: Read/Write

Data Type: String

Description

The Shadow_status_help property specifies the display in the status bar for items of this object that are shadowed. This text value is appended to the end of the standard status help for the item. For example, if the status help value was Save Record and it was shadowed, the status help displayed would be Save Record (unavailable).

Default is (unavailable).

Last Edited: September 11, 2003


MenuBar [Property Simple_Status_Help_State]

Simple_Status_Help_State - MenuBar

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


MenuBar [Property Status_Help]

Status_Help - MenuBar

The status-bar help text for Item item#

Type: Property

Access: Read/Write

Data Type: String

Parameters: string item# string sval

Parameter | Description
item# | The item number
sval | The status help description

Description

Status_help is the status-bar help text for Item item#. If item# is omitted from the set command, the status-bar help text is set for the last item in the object. This makes it easy to add status help to a new item.

On_Item "Prompt" Send prompt
Set  Status_Help To "Show available selections (F4)"

Send Add_Item Msg_Prompt "Prompt"
Set  Status_Help To "Show available selections (F4)"

Set  Status_Help item 2 To "Show available selections (F4)"

Last Edited: September 11, 2003


Events for Mixin

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for Mixin

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for Mixin

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject


Events for ModalPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


Methods for ModalPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  | FloatingPanel
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for ModalPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Events for OpenDialog

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for OpenDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Show_Dialog | Function | Determines how the dialog box is constructed and behaves | AbstractFileDialog


Properties for OpenDialog

View property list in hierarchical order

Name | Description | Defining Class
AllowReadOnly_State | Determines whether users without write access can select files that are read-only or in a read-only folder | AbstractFileDialog
Child_Count | Returns the number of child objects the object contains | cObject
CreatePrompt_State | Determines if a message box will ask users whether they want to create the entered filename, when such filename is not found | AbstractFileDialog
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dialog_Caption | Sets this object's caption | AbstractFileDialog
File_Name | Holds the full pathname of the file and can be considered a read-only property | AbstractFileDialog
File_Title | Holds the title of the file (i.e., without path) | AbstractFileDialog
FileMustExist_State | Specifies whether users can enter a file title that doesn't exist | AbstractFileDialog
Filter_Index | Determines which filter you would like this object's Filter combobox to start with | AbstractFileDialog
Filter_String | Holds the descriptions and filters that will be available to users | AbstractFileDialog
HideReadOnly_State | Determines whether the checkbox is hidden | AbstractFileDialog
Initial_Folder | Determines the starting point for this object | AbstractFileDialog
Name | Returns the full name of the object including parentage | cObject
NoChangeDir_State | Restores the current directory to the original directory if the user switched the current directory while searching for files | AbstractFileDialog
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
OverwritePrompt_State | Specifies whether users should be prompted before selecting a file name that already exists | AbstractFileDialog
Parent | Returns the parent of an object | cObject
PathMustExist_State | Specifies whether users can enter a file path that doesn't exist | AbstractFileDialog
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
ShowFileTitle_State | Specifies whether the contents of the file_title property should be inserted into the dialog box as a default for selectin | AbstractFileDialog
TickReadOnly_State | Checks/un-checks the Read-only checkbox | AbstractFileDialog


Events for Panel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Exit_Application | Received when an application is about to be exited | AppPanel
OnActivateApp | Sent when the panel and, therefore, the application is activated | BasicPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | BasicPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp | Sent when this object is deactivated | BasicPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | BasicPanel
OnPaint | Sent every time a panel is painted | BasicPanel
OnResize | Sent every time a panel is resized | BasicPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | BasicPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | BasicPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | BasicPanel
Verify_Exit_Application | Called when an exit-application request has been made | AppPanel


Methods for Panel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | BasicPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | BasicPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | BasicPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Cascade_Windows | Procedure | Arranges this object's views so that the edge of each underlying view can be seen to the left of the left edge and above the top edge of the view overlying it | AppPanel
Close_Panel | Procedure |  | BasicPanel
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | BasicPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | BasicPanel
Error_Help | Procedure | (Obsolete) | BasicPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | BasicPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | BasicPanel
Help | Procedure |  | BasicPanel
Help_For_Help | Procedure | (Obsolete) | BasicPanel
Help_Index | Procedure | (Obsolete) | BasicPanel
Help_on_topic | Procedure | (Obsolete) | BasicPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | BasicPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Minimize_all_Windows | Procedure | Minimizes all views within the client area | AppPanel
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | BasicPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | BasicPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | BasicPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | BasicPanel
Restore_all_Windows | Procedure | Restores all minimized windows (views) in the client area | AppPanel
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | BasicPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Tile_Windows_Horizontal | Procedure | Horizontally tiles all windows (views) in the client area | AppPanel
Tile_Windows_Vertical | Procedure | Vertically tiles all windows (views) in the client area | AppPanel
Toggle_Statusbar | Procedure | Toggles the value of the statusBar_state property | AppPanel
Toggle_Toolbar | Procedure | Toggles the value of the Toolbar_state property | AppPanel
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | BasicPanel
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for Panel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Activate_State | Determines whether object will activate automatically after it has been created | AppPanel
Auto_Arrange_Icons_State | Determines if icons are rearranged each time this object is resized | AppPanel
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | BasicPanel
Bitmap | Displays a bitmap in an object | BasicPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id | The ID of the panels's client-area object | BasicPanel
Client_Scrollbar_State | Determines if a scroll bar should appear when a contained view's size or placement causes it to exceed the display capacity of its client area | AppPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | BasicPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | BasicPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | BasicPanel
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | BasicPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | BasicPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | BasicPanel
Help_Keyword | Used to specify an object's context keyword | BasicPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | BasicPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | BasicPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | BasicPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | BasicPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | BasicPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | BasicPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | BasicPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | BasicPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | BasicPanel
Statusbar_Id | The ID of the panel's status-bar object | BasicPanel
StatusBar_State | Determines if object will display a status bar | AppPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id | The ID of the panel's tool-bar objec | BasicPanel
ToolBar_State | Determines if the object will display its tool bar | AppPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | BasicPanel
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


PickList [Event Mouse_Click]

Mouse_Click - PickList

Type: Event

Parameters: Integer iWindowNumber Integer iPosition

Parameter | Description
iWindowNumber | [ToDo: In Progress]
iPosition | [ToDo: In Progress]

Description

Last Edited: July 11, 2006


Events for PickList

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Fill_List |  | PickList_
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click | Sent whenever a header has received a mouse click | EntryList
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List |  | PickList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click |  |
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | EntryList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin | Augmented to set the minimum and maximum positions for a spinner | EntryList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


Methods for PickList

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the first enterable column of the first row | PickList_
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Deactivates this object | PickList_
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Causes the grid's current item to be set to the last enterable column of the last row | PickList_
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
first_selected_item | Function |  | PickList_
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Init_Selected_Item | Procedure | Sets enumeration_counter to zero | PickList_
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_Value_Out | Procedure | Overridden to set the value of the current item of the invoking object to the code value of the current item of this object upon selection, and then to send display_description to the invoking object | PickList_
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
next_selection | Function | Returns identifier of next selected item | PickList_
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Oks a list selection | PickList_
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines | EntryList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure | Changes the current item to the prior row, if any, at the same item relative to the beginning of the row | WideList_
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Validate_Prompt | Function | (Obsolete) | WideList
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


Properties for PickList

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
CustomScrollState | Determines changing scroll bar behaviors |
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational | PickList_
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Invoking_Object_ID | Identifies the object which activated this object | PickList_
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent | PickList_
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Original_Selection | Identifies the item that was selected when this object was originally activated | PickList_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | (Obsolete) | PickList_
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
ScrollOnThumbTrackState |  |
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | WideList_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
ThumbScrollState |  |
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


PickList [Property CustomScrollState]

CustomScrollState - PickList

Determines changing scroll bar behaviors

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Any time that you customize the scroll bar messages you should set the CustomScrollState property.

If you are going to be changing scroll bar behaviors you are going to need to replace the behaviors in the existing super-classes (the dfbase and dfdata packages), while making sure that these messages still get forwarded to the runtime. These messages must get forwarded to the runtime or scrollbar control will not be notified of changes. To accomplish this you must set the property CustomScrollState to True.

When set to True, the package augmentations for the messages SetVScrollInfo, SetVScrollPos and SetVScrollBox are ignored and the messages are forwarded to the runtime.

Default is true.

Last Edited: January 12, 2006


PickList [Property ScrollOnThumbTrackState]

ScrollOnThumbTrackState - PickList

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


PickList [Property ThumbScrollState]

ThumbScrollState - PickList

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Last Edited: January 12, 2006


PickList_ [Event Fill_List]

Fill_List - PickList_

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


PickList_ [Event Initialize_List]

Initialize_List - PickList_

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Events for PickList_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Fill_List |  |
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click | Sent whenever a header has received a mouse click | EntryList
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List |  |
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | EntryList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin | Augmented to set the minimum and maximum positions for a spinner | EntryList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


PickList_ [Function first_selected_item]

first_selected_item - PickList_

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


PickList_ [Function next_selection]

next_selection - PickList_

Returns identifier of next selected item

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Returns identifier (either item_number if batch_state is true or record_number if batch_state is false) of next selected item after item specified by enumeration_counter, or returns -1 if there are no more selected items. As an item (or record) identifier is returned, it is removed from the set of selected items. If batch_state is false, the record for the next selected item is found (using read_by_recnum if server exists). Enumeration_counter is also incremented unless there are no more selected items.

Last Edited: August 6, 2004


Methods for PickList_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the first enterable column of the first row |
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Deactivates this object |
Close_Panel | Procedure | Closes the panel or component currently open | WideList
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) | WideList
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Causes the grid's current item to be set to the last enterable column of the last row |
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
first_selected_item | Function |  |
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Init_Selected_Item | Procedure | Sets enumeration_counter to zero |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Move_Value_Out | Procedure | Overridden to set the value of the current item of the invoking object to the code value of the current item of this object upon selection, and then to send display_description to the invoking object |
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
next_selection | Function | Returns identifier of next selected item |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Oks a list selection |
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) | WideList
Prompt_Description | Procedure | (Obsolete) | WideList
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines | EntryList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure | Changes the current item to the prior row, if any, at the same item relative to the beginning of the row | WideList_
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Validate_Prompt | Function | (Obsolete) | WideList
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


PickList_ [Procedure Beginning_of_Data]

Beginning_of_Data - PickList_

Causes the grid's current item to be set to the first enterable column of the first row

Type: Procedure

Parameters: No Parameters

Description

The Beginning_of_Data procedure sets the grid's current_item to the first enterable column of the first row.

Last Edited: August 13, 2003


PickList_ [Procedure Cancel]

Cancel - PickList_

Deactivates this object

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns nothing (not used)

Description

Cancel deactivates this object.

Last Edited: August 5, 2003


PickList_ [Procedure End_of_Data]

End_of_Data - PickList_

Causes the grid's current item to be set to the last enterable column of the last row

Type: Procedure

Parameters: No Parameters

Description

The Beginning_of_Data procedure sets the grid's current_item to the last enterable column of the last row.

Last Edited: August 13, 2003


PickList_ [Procedure Init_Selected_Item]

Init_Selected_Item - PickList_

Sets enumeration_counter to zero

Type: Procedure

Parameters: No Parameters

Description

The Init_selected_item procedure sets enumeration_counter to zero.

get Init_Selected_Item of oMyDbList

Last Edited: September 7, 2005


PickList_ [Procedure Move_Value_Out]

Move_Value_Out - PickList_

Overridden to set the value of the current item of the invoking object to the code value of the current item of this object upon selection, and then to send display_description to the invoking object

Type: Procedure

Parameters: No Parameters

Description

The Move_value_out procedure is overridden to set the value of the current item of the invoking object to the code value of the current item of this object upon selection, and then to send display_description to the invoking object.

Last Edited: August 18, 2003


PickList_ [Procedure Ok]

Ok - PickList_

Oks a list selection

Type: Procedure

Return Data Type: Integer

Parameters: No Parameters

Return Value

Always returns 0 - value is never used

Description

If move_value_out_state is true, exits and deactivates this object. If the select_mode of this object is not multi_select, it sends move_value_out to export the value of the first item in the current row to the current item of the object which activated this object. If select_mode is multi_select, it sends init_selected_item to re-initialize the selected-item counter. Deactivation is accomplished using request_cancel. If move_value_out_state is false, sends next to cause rotation to the next object.

Last Edited: September 25, 2003


Properties for PickList_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Export_Item_State | Determines if updates from lists to invoking objects are relational or non-relational |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
Invoking_Object_ID | Identifies the object which activated this object |
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Move_value_out_State | Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent |
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Original_Selection | Identifies the item that was selected when this object was originally activated |
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | (Obsolete) |
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | WideList_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


PickList_ [Property Export_Item_State]

Export_Item_State - PickList_

Determines if updates from lists to invoking objects are relational or non-relational

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When Auto_Export_State is false, the export style will be determined by Export_Item_State property. If Export_Item_State is false, updates are relational; if true, they are non-relational.

If Auto_Export_State is false and Export_Item_State is True (updated are non-relational), you can set Export_Column to the number of any other column to export the value in that column instead.

Default is false.

Last Edited: January 12, 2006


PickList_ [Property Invoking_Object_ID]

Invoking_Object_ID - PickList_

Identifies the object which activated this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Invoking_object_id identifies the object which activated this object.

Last Edited: August 18, 2003


PickList_ [Property Move_value_out_State]

Move_value_out_State - PickList_

Determines if value of the selected item will be exported to the item of the object from which this object was invoked when ok is sent

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If you set the Move_value_out_state property true, the value of the selected item of this object will be exported to the item of the object from which this object was invoked when ok is sent.

Default is false.

Last Edited: January 12, 2006


PickList_ [Property Original_Selection]

Original_Selection - PickList_

Identifies the item that was selected when this object was originally activated

Type: Property

Access: Read/Write

Data Type: Integer

Description

Original_selection identifies the item that was selected when this object was originally activated.

Last Edited: September 10, 2003


PickList_ [Property Popup_State]

Popup_State - PickList_

Type: Property

Obsolete

Access: Write-Only

Data Type: Boolean

Description

Last Edited: January 12, 2006


PopupMenu [Event OnChange]

OnChange - PopupMenu

Called every time a menu changes

Type: Event

Parameters: No Parameters

Description

The OnChange "hook" procedure has no definition; it is provided for your use. This event is called every time a menu changes.

Last Edited: February 18, 2004


PopupMenu [Event OnInitMenu]

OnInitMenu - PopupMenu

Sent when a PopupMenu object is about to be selected

Type: Event

Parameters: No Parameters

Description

The OnInitMenu event message is sent when a PopupMenu object is about to be selected. This is a powerful augmentation point. You can use this to set shadow states, set select states, and even build entire new menu-item structures.

Last Edited: September 10, 2003


Events for PopupMenu

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Initialize_Menu | Sent when the Menubar system is about to be selected | DfBaseActionBar
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChange | Called every time a menu changes |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnInitMenu | Sent when a PopupMenu object is about to be selected |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


PopupMenu [Function Menu_Status_Help]

Menu_Status_Help - PopupMenu

Type: Function

Return Data Type: String

Parameters: Integer Item# Integer Flags

Parameter | Description
Item# | [ToDo: In Progress]
Flags | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for PopupMenu

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Exit_Menu | Procedure |  | DfBaseActionBar
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Menu_Status_Help | Function |  |
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Redirect_Message | Procedure |  | DfBaseActionBar
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for PopupMenu

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Shadow_Status_Help | Specifies the display in the status bar for items of this object that are shadowed |
Simple_Status_Help_State |  |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | The status-bar help text for Item item# |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


PopupMenu [Property Shadow_Status_Help]

Shadow_Status_Help - PopupMenu

Specifies the display in the status bar for items of this object that are shadowed

Type: Property

Access: Read/Write

Data Type: String

Description

The Shadow_status_help property specifies the display in the status bar for items of this object that are shadowed. This text value is appended to the end of the standard status help for the item. For example, if the status help value was Save Record and it was shadowed, the status help displayed would be Save Record (unavailable).

Default is (unavailable).

Last Edited: September 11, 2003


PopupMenu [Property Simple_Status_Help_State]

Simple_Status_Help_State - PopupMenu

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


PopupMenu [Property Status_Help]

Status_Help - PopupMenu

The status-bar help text for Item item#

Type: Property

Access: Read/Write

Data Type: String

Parameters: string item# string sval

Parameter | Description
item# | The item number
sval | The status help description

Description

Status_help is the status-bar help text for Item item#. If item# is omitted from the set command, the status-bar help text is set for the last item in the object. This makes it easy to add status help to a new item.

On_Item "Prompt" Send prompt
Set  Status_Help To "Show available selections (F4)"

Send Add_Item Msg_Prompt "Prompt"
Set  Status_Help To "Show available selections (F4)"

Set  Status_Help item 2 To "Show available selections (F4)"

Last Edited: September 11, 2003


Events for PrintDialog

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


PrintDialog [Function PrintDialog]

PrintDialog - PrintDialog

Used to display the print dialog box

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns non zero if an error occurred

Description

PrintDialog is used to display the Print dialog box.

This function sets the properties to reflect the users choices. If the user clicks the OK button, the return value is zero. If the user cancels the dialog or an error occurs the return value is non-zero.

Normally this is considered to be a private method and it is not expected that this function will ever get called directly. This function allocates memory that is not automatically freed when you call this function directly. If you do call this function, you must make sure that you deallocate the memory assigned to this function. If you use this function you are encouraged to review the method SelectAndSetPrinter in the CrystalReport class as this shows how PrintDialog is safely used.

Procedure DoSetPrinter
    String sDriver sDevice sPort
    Integer iResult
    Pointer pHeap

    Get PrintDialog of oPrintDialog To iResult
    If (iResult) Procedure_Return
    Get DeviceName of oPrintDialog To sDevice
    Get OutputName of oPrintDialog To sPort
    :
    :
    // Unlock and free allocated memory
    Move (GlobalUnlock(DevModeHandle(oPrintDialog))) To iResult
    Move (GlobalFree(DevModeHandle(of oPrintDialog))) To iResult
    Move (GlobalFree(DevNamesHandle(of oPrintDialog))) To iResult
End_Procedure

Last Edited: November 23, 2004


Methods for PrintDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
PrintDialog | Function | Used to display the print dialog box |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


Properties for PrintDialog

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Collate | Specifies whether collation should be used when printing multiple copies |
Color | Specifies whether color printing should be used with color printers |
Copies | Specifies the number of copies printed |
DefaultSource | Specifies the default paper source (tray) |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DeviceContext | Holds a handle to the device context that can be used in windows API calls. |
DeviceName | Specifies the name of the printer |
DitherType | Specifies the dithering type |
DriverName | Specifies the driver name |
Duplex | specifies the double-sided printing type |
Flags | Print Dialog bit flag property |
FormName | Specifies the name of the form |
FromPage | The value of the starting page |
ICMIntent | Specifies the color matching method, or intent |
ICMMethod | Specifies how ICM is handled |
MaxPage | The maximum value for the ToPage property |
MediaType | Specifies the type of media, paper or film, being printed on |
MinPage | The minimum value for the FromPage property. |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Orientation | specifies the orientation of the paper |
OutputName | Holds the device name for the physical output medium (output port) |
PaperLength | If set, overrides the length of the paper specified by the PaperSize |
PaperSize | Specifies the size of the paper to print on |
PaperWidth | If set, overrides the width of the paper specified by the PaperSize property |
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
PrintQuality | Specifies the printer resolution |
Scale | Specifies the factor by which the printed output is to be scaled |
ToPage | The value of the ending page |
TTOption | Specifies how TrueType fonts should be printed |
YResolution | Specifies the y-resolution, in dots per inch (DPI), of the printer |


PrintDialog [Property Collate]

Collate - PrintDialog

Specifies whether collation should be used when printing multiple copies

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies whether collation should be used when printing multiple copies. Possible values are:

Constant | Meaning
DMCOLLATE_TRUE | Collate
DMCOLLATE_FALSE | Do not collate

Last Edited: November 17, 2003


PrintDialog [Property Color]

Color - PrintDialog

Specifies whether color printing should be used with color printers

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies whether color printing should be used with color printers. Possible value are:

Constant | Meaning
DMCOLOR_COLOR | Color
DMCOLOR_MONOCHROME | No Color

Last Edited: November 17, 2003


PrintDialog [Property Copies]

Copies - PrintDialog

Specifies the number of copies printed

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies the number of copies printed.

Last Edited: November 17, 2003


PrintDialog [Property DefaultSource]

DefaultSource - PrintDialog

Specifies the default paper source (tray)

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies the default paper source (tray). For a complete list of constants (DMBIN_*) refer to the prnt_dlg.pkg file.

Last Edited: November 17, 2003


PrintDialog [Property DeviceContext]

DeviceContext - PrintDialog

Holds a handle to the device context that can be used in windows API calls.

Type: Property

Access: Read/Write

Data Type: Handle

Description

After the Print dialog box is closed and the Flags property contains the PD_RETURNDC flag this property holds a handle to the device context that can be used in windows API calls.

Last Edited: November 17, 2003


PrintDialog [Property DeviceName]

DeviceName - PrintDialog

Specifies the name of the printer

Type: Property

Access: Read/Write

Data Type: String

Description

This property specifies the name of the printer.

Last Edited: November 17, 2003


PrintDialog [Property DitherType]

DitherType - PrintDialog

Specifies the dithering type

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies the dithering type. For a complete list of possible values (DMDITHER_* ) refer to the prnt_dlg.pkg file.

Last Edited: November 17, 2003


PrintDialog [Property DriverName]

DriverName - PrintDialog

Specifies the driver name

Type: Property

Access: Read/Write

Data Type: String

Description

This property specifies the driver name.

Last Edited: November 17, 2003


PrintDialog [Property Duplex]

Duplex - PrintDialog

specifies the double-sided printing type

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies the double-sided printing type. Possible values are:

Constant | Meaning
DMDUP_SIMPLEX | Simplex
DMDUP_HORIZONTAL | Horizontal
DMDUP_VERTICAL | Vertical

Last Edited: November 17, 2003


PrintDialog [Property Flags]

Flags - PrintDialog

Print Dialog bit flag property

Type: Property

Access: Read/Write

Data Type: Integer

Description

This bit-flag property can be used to initialize the Print dialog box and indicates which properties are valid after the Print dialog is closed. See the windows API help for a complete list of flags.

Last Edited: November 17, 2003


PrintDialog [Property FormName]

FormName - PrintDialog

Specifies the name of the form

Type: Property

Access: Read/Write

Data Type: String

Description

This property holds the name of the form (Letter, Legal, etc.).

Last Edited: November 17, 2003


PrintDialog [Property FromPage]

FromPage - PrintDialog

The value of the starting page

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property holds the value of the starting page edit control of the Print dialog. The value of this property must be greater or equal to than the value of the MinPage property. This property is ignored unless the Flags property includes the PD_PAGENUMS flag.

See Also

ToPage | MinPage | MaxPage

Last Edited: November 17, 2003


PrintDialog [Property ICMIntent]

ICMIntent - PrintDialog

Specifies the color matching method, or intent

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies the color matching method, or intent. For a complete list of possible values (DMICM_*)refer to the prn_dlg.pkg file.

Last Edited: November 17, 2003


PrintDialog [Property ICMMethod]

ICMMethod - PrintDialog

Specifies how ICM is handled

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies how ICM is handled. For a complete list of possible values (DMICMMETHOD_*)refer to the prn_dlg.pkg file.

Last Edited: November 17, 2003


PrintDialog [Property MaxPage]

MaxPage - PrintDialog

The maximum value for the ToPage property

Type: Property

Access: Read/Write

Data Type: Integer

Description

MaxPage specifies the maximum value for the ToPage property.

See Also

ToPage | FromPage | MinPage

Last Edited: November 17, 2003


PrintDialog [Property MediaType]

MediaType - PrintDialog

Specifies the type of media, paper or film, being printed on

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies the type of media, paper or film, being printed on. For a complete list of possible values (DMMEDIA_*) refer to the prn_dlg.pkg file.

Last Edited: November 17, 2003


PrintDialog [Property MinPage]

MinPage - PrintDialog

The minimum value for the FromPage property.

Type: Property

Access: Read/Write

Data Type: Integer

Description

MinPage specifies the minimum value for the FromPage property.

See Also

ToPage | FromPage | MaxPage

Last Edited: November 17, 2003


PrintDialog [Property Orientation]

Orientation - PrintDialog

specifies the orientation of the paper

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies the orientation of the paper. Possible values are:

Constant | Meaning
DMORIENT_PORTRAIT | Portrait
DMORIENT_LANDSCAPE | Landscape

Last Edited: November 17, 2003


PrintDialog [Property OutputName]

OutputName - PrintDialog

Holds the device name for the physical output medium (output port)

Type: Property

Access: Read/Write

Data Type: String

Description

The property holds the device name for the physical output medium (output port).

Last Edited: November 17, 2003


PrintDialog [Property PaperLength]

PaperLength - PrintDialog

If set, overrides the length of the paper specified by the PaperSize

Type: Property

Access: Read/Write

Data Type: Integer

Description

If set, this property overrides the length of the paper specified by the PaperSize property, either for custom paper sizes or for devices such as dot-matrix printers, which can print on a page of arbitrary length. The value of this property is in tenths of a millimeter.

Last Edited: November 17, 2003


PrintDialog [Property PaperSize]

PaperSize - PrintDialog

Specifies the size of the paper to print on

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property holds the size of the paper to print on. This property can be zero if the length and width of the paper are both set by the PaperLength and PaperWidth properties. Otherwise, this property can be set to one of the DMPAPER_* constants. For a complete list of possible constants refer to the prnt_dlg.pkg file.

Last Edited: November 17, 2003


PrintDialog [Property PaperWidth]

PaperWidth - PrintDialog

If set, overrides the width of the paper specified by the PaperSize property

Type: Property

Access: Read/Write

Data Type: Integer

Description

If set, this property overrides the width of the paper specified by the PaperSize property. The value of this property is in tenths of a millimeter.

Last Edited: November 17, 2003


PrintDialog [Property PrintQuality]

PrintQuality - PrintDialog

Specifies the printer resolution

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies the printer resolution. There are four predefined device-independent constants (DMRES_*). For a complete list of possible constants refer to the prnt_dlg.pkg file. If a positive value is specified, it specifies the number of dots per inch (DPI) and is therefore device dependent.

Last Edited: November 17, 2003


PrintDialog [Property Scale]

Scale - PrintDialog

Specifies the factor by which the printed output is to be scaled

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies the factor by which the printed output is to be scaled. The apparent page size is scaled from the physical page size by a factor of Scale/100. For example, a letter-sized page with a Scale value of 50 would contain as much data as a page of 17- by 22-inches because the output text and graphics would be half their original height and width.

Last Edited: November 17, 2003


PrintDialog [Property ToPage]

ToPage - PrintDialog

The value of the ending page

Type: Property

Access: Read/Write

Data Type: Integer

Description

Holds the value of the ending page edit control of the Print dialog.

See Also

FromPage | MinPage | MaxPage

Last Edited: November 17, 2003


PrintDialog [Property TTOption]

TTOption - PrintDialog

Specifies how TrueType fonts should be printed

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies how TrueType fonts should be printed. For a complete list of DMTT_* constants refer to the prnt_dlg.pkg file.

Last Edited: November 17, 2003


PrintDialog [Property YResolution]

YResolution - PrintDialog

Specifies the y-resolution, in dots per inch (DPI), of the printer

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property specifies the y-resolution, in dots per inch (DPI), of the printer. If this property is set the PrintQuality property specifies the x resolution, in dots per inch, of the printer.

Last Edited: November 17, 2003


Events for Prototype_Entry

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Item_Change | A programming "hook" to perform an action on change of an item | Cm_Menu
Item_Entry | Sends iMessage to the current object if it is non-zero | Cm_Entry
Item_Exit | Sends iMessage to the current object if it is non-zero | Cm_Entry
Key | Augmented to implement the GUI keyboard interface | Cm_Menu
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Refresh | Displays items from some files at the same time as clearing items from other files | Cm_Entry
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | Cm_Entry


Methods for Prototype_Entry

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | Cm_Menu
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | Cm_Menu
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | Cm_Entry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | Cm_Entry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | Cm_Entry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | Cm_Entry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | Cm_Entry
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | Cm_Menu
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | Cm_Menu
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | Cm_Menu
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | Cm_Entry


Properties for Prototype_Entry

View property list in hierarchical order

Name | Description | Defining Class
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | Cm_Menu
Autofind_Item |  | Cm_Entry
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | Cm_Menu
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | Cm_Entry
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Bottom_Item | Returns the item number of the last item on the display | Cm_Entry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | Cm_Entry
Changed_State | Set when users change information in the items of the menu | Cm_Menu
Checkbox_Item_State | Allows any item to become a checkbox-type item | Cm_Menu
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | Cm_Menu
Current_Row | Return the row number of the current_item | Cm_Entry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | Cm_Entry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | Cm_Entry
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | Cm_Menu
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | Cm_Entry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | Cm_Menu
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | Cm_Menu
Item_Count | A read-only property of menu-class objects | Cm_Menu
Item_Entry_Msg | Sent in response to the item_change or the entering message | Cm_Entry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | Cm_Entry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | Cm_Entry
Item_Matching | Searches a menu of items for a matching string value | Cm_Menu
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | Cm_Entry
Item_Options | Allows you to copy item options or set them in a group | Cm_Entry
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | Cm_Entry
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | Cm_Menu
Line_Width | Specifies the number of columns and displayable rows in a list | Cm_Menu
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | Cm_Menu
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Validation | Controls whether the validate messages have any effect | Cm_Entry
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | Cm_Entry
Prototype_Object |  | Cm_Menu
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | Cm_Entry
Row_Count | Returns the number of rows in a dbGrid-class object | Cm_Entry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | Cm_Menu
Select_Count | Maintains the total number of selected items in the menu | Cm_Menu
Select_Mode | Determines how item-level selections are processed | Cm_Menu
Select_State | Each item may be selected by setting the select_state of the item | Cm_Menu
Shadow_State | Determines if item is enabled (not shadowed) | Cm_Menu
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Top_Item | The item that is first in the display window | Cm_Menu
Top_Row | Returns the row number of the top row on the display | Cm_Entry
Valid_Item | Causes the validation of a single item identified by the iItem | Cm_Entry
Value | Gets and sets the data value for an item | Cm_Menu
Visible_State | Determines whether object is visible | cUIObject
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | Cm_Menu
Zoom_Object | Sets the destination object_id of the popup message to the specified object | Cm_Entry


Events for Radio

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | RadioButton
OnChange |  | RadioButton
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | RadioButton
OnSetFocus | Sent whenever windows is about to give this object the focus | RadioButton
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | RadioButton
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | RadioButton


Methods for Radio

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | RadioButton
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | RadioButton
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | RadioButton
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | RadioButton
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | RadioButton
Error_Help | Procedure | (Obsolete) | RadioButton
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | RadioButton
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | RadioButton
Help | Procedure |  | RadioButton
Help_For_Help | Procedure | (Obsolete) | RadioButton
Help_Index | Procedure | (Obsolete) | RadioButton
Help_on_topic | Procedure | (Obsolete) | RadioButton
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | RadioButton
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Item | Procedure | Moves to the next radio object within the group and sets the object's changed_state to true |
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | RadioButton
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Previous_Item | Procedure | Moves to the prior radio object within the group and sets the object's changed_state to true |
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | RadioButton
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | RadioButton
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | RadioButton
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Radio [Procedure Next_Item]

Next_Item - Radio

Moves to the next radio object within the group and sets the object's changed_state to true

Type: Procedure

Parameters: No Parameters

Description

Next_item moves to the next radio object within the group and sets the object's changed_state to true.

Last Edited: September 10, 2003


Radio [Procedure Previous_Item]

Previous_Item - Radio

Moves to the prior radio object within the group and sets the object's changed_state to true

Type: Procedure

Parameters: No Parameters

Description

Previous_item moves to the prior radio object within the group and sets the object's changed_state to true.

Last Edited: September 11, 2003


Properties for Radio

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
AlignmentMode | Determines if text is displayed to the right of the radio or the left of the radio | RadioButton
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Size_State | Determines if object will be resized to the length of the label text | RadioButton
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | RadioButton
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Checked_State | Reflects whether this object is checked | RadioButton
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | RadioButton
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | RadioButton
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | RadioButton
Help_Keyword | Used to specify an object's context keyword | RadioButton
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled | RadioButton
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label |  | RadioButton
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | RadioButton
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | RadioButton
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | RadioButton
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | RadioButton
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


RadioButton [Event OnBeginningOfPanel]

OnBeginningOfPanel - RadioButton

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


RadioButton [Event OnChange]

OnChange - RadioButton

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


RadioButton [Event OnKillFocus]

OnKillFocus - RadioButton

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


RadioButton [Event OnSetFocus]

OnSetFocus - RadioButton

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


RadioButton [Event Prompt_Callback]

Prompt_Callback - RadioButton

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


RadioButton [Event Shadow_Display]

Shadow_Display - RadioButton

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for RadioButton

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChange |  |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |


RadioButton [Function Next_Object_Id]

Next_Object_Id - RadioButton

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


RadioButton [Function Prior_Object_Id]

Prior_Object_Id - RadioButton

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for RadioButton

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


RadioButton [Procedure Activate_Area]

Activate_Area - RadioButton

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


RadioButton [Procedure Beginning_of_Panel]

Beginning_of_Panel - RadioButton

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


RadioButton [Procedure Bottom_of_Panel]

Bottom_of_Panel - RadioButton

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


RadioButton [Procedure DoHtmlHelp]

DoHtmlHelp - RadioButton

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


RadioButton [Procedure End_of_Panel]

End_of_Panel - RadioButton

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


RadioButton [Procedure Error_Help]

Error_Help - RadioButton

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


RadioButton [Procedure Extended_Help]

Extended_Help - RadioButton

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


RadioButton [Procedure File_Help]

File_Help - RadioButton

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


RadioButton [Procedure Help]

Help - RadioButton

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


RadioButton [Procedure Help_For_Help]

Help_For_Help - RadioButton

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


RadioButton [Procedure Help_Index]

Help_Index - RadioButton

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


RadioButton [Procedure Help_on_topic]

Help_on_topic - RadioButton

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


RadioButton [Procedure Keys_Help]

Keys_Help - RadioButton

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


RadioButton [Procedure Request_Status_Help]

Request_Status_Help - RadioButton

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


RadioButton [Procedure Top_of_Panel]

Top_of_Panel - RadioButton

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for RadioButton

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
AlignmentMode | Determines if text is displayed to the right of the radio or the left of the radio |
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Size_State | Determines if object will be resized to the length of the label text |
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object |
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Checked_State | Reflects whether this object is checked |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label |  |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


RadioButton [Property AlignmentMode]

AlignmentMode - RadioButton

Determines if text is displayed to the right of the radio or the left of the radio

Type: Property

Access: Read/Write

Data Type: Integer

Description

AlignmentMode determines if the text of the Label property will be displayed on the left or right of the button icon.

Set the AlignmentMode property to taRightJustify, to display the text to the right of the radio; set it to taLeftJustify, to display the text to the left of the radio.

Default is taRightJustify.

Last Edited: July 30, 2003


RadioButton [Property Auto_Size_State]

Auto_Size_State - RadioButton

Determines if object will be resized to the length of the label text

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If this property is set true, this object will size itself according to the length of the label text.

When set false, it will not.

See Also

CheckBox | Radio

Last Edited: January 12, 2006


RadioButton [Property Bitmap]

Bitmap - RadioButton

Displays a bitmap in an object

Type: Property

Access: Read/Write

Data Type: String

Description

The Bitmap message will display a bitmap in an object. In other words, the bitmap becomes the background of the object.
Bitmap_Style determines how and where the bitmap will display in the object.

There are two potential drawbacks to using bitmaps: the amount of storage (on disk) , and the constant memory consumption.

Sample

This sample sets the bitmap to "MyBitmap.bmp".

set Bitmap to "MyBitmap.bmp"

Note:
In order to make a cohesive application, Visual DataFlex must find the .EXE file and the .bmp (bitmap) file, by using DFPATH.

Last Edited: November 24, 2004


RadioButton [Property Checked_State]

Checked_State - RadioButton

Reflects whether this object is checked

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Checked_State property reflects whether this object is checked. You may set and get this property.

See Also

CheckBox | Radio

Last Edited: January 12, 2006


RadioButton [Property Enabled_State]

Enabled_State - RadioButton

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


RadioButton [Property Explicit_Shadow_State]

Explicit_Shadow_State - RadioButton

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


RadioButton [Property Help_id]

Help_id - RadioButton

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


RadioButton [Property Help_Keyword]

Help_Keyword - RadioButton

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


RadioButton [Property Item_Shadow_State]

Item_Shadow_State - RadioButton

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


RadioButton [Property Label]

Label - RadioButton

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


RadioButton [Property Object_Shadow_State]

Object_Shadow_State - RadioButton

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


RadioButton [Property psHtmlHelpTopic]

psHtmlHelpTopic - RadioButton

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


RadioButton [Property Status_Help]

Status_Help - RadioButton

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


RadioButton [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - RadioButton

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


Events for RadioContainer

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Select_State | Sent to notify the group that the current radio item has changed | RadioGroup
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Group
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Group
OnRadioGroupEntering |  | RadioGroup
OnRadioGroupExiting |  | RadioGroup
OnSetFocus | Sent whenever windows is about to give this object the focus | Group
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Group
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Group


Methods for RadioContainer

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Group
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Group
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Group
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Group
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Group
Error_Help | Procedure | (Obsolete) | Group
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Group
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Group
Help | Procedure |  | Group
Help_For_Help | Procedure | (Obsolete) | Group
Help_Index | Procedure | (Obsolete) | Group
Help_on_topic | Procedure | (Obsolete) | Group
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Group
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Group
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Group
Radio_Object | Function | Returns the handle of a radio object for a passed radio item | RadioGroup
Radio_Object_Item | Function | Returns the index (Item number) for a passed a radio object handle | RadioGroup
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Group
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Group
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for RadioContainer

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Group
Bitmap | Displays a bitmap in an object | Group
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Changed_State | Gets or sets the changed_state for the entire radio group | RadioGroup
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Group
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Radio | Makes Item item_num the "selected" radio object | RadioGroup
Current_Radio_Object | Similar to Current_Radio except that it operates with object IDs instead of item IDs | RadioGroup
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Group
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Group
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Group
Help_Keyword | Used to specify an object's context keyword | Group
Item_Shadow_State | Determines if an object's item is enabled or disabled | Group
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Group
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Group
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Group
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Group
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Group
Radio_Count | Returns the number of radio objects within this object | RadioGroup
Radio_Value | Gets and sets the label of a child radio object | RadioGroup
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Group
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Group
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Group
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


RadioGroup [Event Notify_Select_State]

Notify_Select_State - RadioGroup

Sent to notify the group that the current radio item has changed

Type: Event

Parameters: Integer NewId Integer OldId

Parameter | Description
NewId | The number of the new current item
OldId | The number of the old item

Description

The Notify_Select_State event is sent to notify the group that the current radio item has changed. It is passed the number of the new current item and the number of the old item. By default, this does nothing, and is intended for augmentation. It should never be sent. Note that the passed radio item numbers may be converted to object IDs with the Radio_Object message.

You may use this message to change the states of other objects. A common use of this message is to shadow other objects based on the condition of the constituents of the radio group.

Sample

This sample shows how to augment Notify_Select_State to dynamically enable and disable different Form controls depending on which radio object is selected by the user.

Object oNotifySelectStateSampleView is a dbView
    Set Border_Style to Border_Thick
    Set Location to 1 1
    Set Size to 78 300

    Object oTypeOfIdRadioGroup is a RadioGroup
        Set Size to 39 89
        Set Location to 7 14
        Set Label to "Type of Id Presented:"
        Object oRadio1 is a Radio
            Set Label to "Driver's License"
            Set Size to 10 67
            Set Location to 10 5
        End_Object    // oRadio1

        Object oRadio2 is a Radio
            Set Label to "Passport"
            Set Size to 10 44
            Set Location to 25 5
        End_Object    // oRadio2

        Procedure Notify_Select_State Integer iToItem Integer iFromItem
            Forward Send Notify_Select_State iToItem iFromItem

            // if oRadio1 is selected, enable driver's license number form
            // and disable passport number form
            if (iToItem = 0) begin
                set Enabled_State of oDLNForm to True
                set Enabled_State of oPassportNumberForm to False
            end
            // if oRadio2 is selected, enable passport number form
            // and disable driver's license number form
            else if (iToItem = 1) begin
                set Enabled_State of oDLNForm to False
                set Enabled_State of oPassportNumberForm to True
            end
        End_Procedure // Notify_Select_State

    End_Object   // oTypeOfIdRadioGroup

    Object oDLNForm is a Form
        Set Label to "Driver's License Number:"
        Set Size to 13 85
        Set Location to 12 195
        Set Label_Col_Offset to 0
        Set Label_Justification_Mode to jMode_Right
    End_Object    // oDLNForm

    Object oPassportNumberForm is a Form
        Set Label to "Passport Number:"
        Set Size to 13 85
        Set Location to 29 195
        Set Label_Col_Offset to 0
        Set Label_Justification_Mode to jMode_Right
    End_Object    // oPassportNumberForm

End_Object    // oNotifySelectStateSampleView

Last Edited: January 12, 2006


RadioGroup [Event OnRadioGroupEntering]

OnRadioGroupEntering - RadioGroup

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


RadioGroup [Event OnRadioGroupExiting]

OnRadioGroupExiting - RadioGroup

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Last Edited: February 13, 2003


Events for RadioGroup

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Select_State | Sent to notify the group that the current radio item has changed |
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Group
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Group
OnRadioGroupEntering |  |
OnRadioGroupExiting |  |
OnSetFocus | Sent whenever windows is about to give this object the focus | Group
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Group
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Group


RadioGroup [Function Radio_Object]

Radio_Object - RadioGroup

Returns the handle of a radio object for a passed radio item

Type: Function

Return Data Type: Integer

Parameters: integer Item#

Parameter | Description
Item# | The item number

Return Value

Returns the radio object handle for index position Item#

Description

Radio_object returns the handle of a radio object for a passed radio Item#.

Last Edited: September 25, 2003


RadioGroup [Function Radio_Object_Item]

Radio_Object_Item - RadioGroup

Returns the index (Item number) for a passed a radio object handle

Type: Function

Return Data Type: Integer

Parameters: integer RObj

Parameter | Description
RObj | The radio object

Return Value

Returns a zero based index (Item number) for RObj

Description

Radio_object_item is used to fidn the the index number) for a passed a radio object handle,

Last Edited: September 25, 2003


Methods for RadioGroup

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Group
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Group
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Group
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Group
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Group
Error_Help | Procedure | (Obsolete) | Group
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Group
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Group
Help | Procedure |  | Group
Help_For_Help | Procedure | (Obsolete) | Group
Help_Index | Procedure | (Obsolete) | Group
Help_on_topic | Procedure | (Obsolete) | Group
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Group
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Group
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Group
Radio_Object | Function | Returns the handle of a radio object for a passed radio item |
Radio_Object_Item | Function | Returns the index (Item number) for a passed a radio object handle |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Group
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Group
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for RadioGroup

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Group
Bitmap | Displays a bitmap in an object | Group
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Changed_State | Gets or sets the changed_state for the entire radio group |
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Group
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Radio | Makes Item item_num the "selected" radio object |
Current_Radio_Object | Similar to Current_Radio except that it operates with object IDs instead of item IDs |
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Group
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Group
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Group
Help_Keyword | Used to specify an object's context keyword | Group
Item_Shadow_State | Determines if an object's item is enabled or disabled | Group
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Group
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Group
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Group
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Group
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Group
Radio_Count | Returns the number of radio objects within this object |
Radio_Value | Gets and sets the label of a child radio object |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Group
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Group
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Group
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


RadioGroup [Property Changed_State]

Changed_State - RadioGroup

Gets or sets the changed_state for the entire radio group

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Changed_state gets or sets the changed_state for the entire radio group.

Default is false.

Last Edited: January 12, 2006


RadioGroup [Property Current_Radio]

Current_Radio - RadioGroup

Makes Item item_num the "selected" radio object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Current_radio makes Item item_num the "selected" radio object. If the focus currently resides within the radio group, the focus will be switched to the selected radio object. Current_Radio returns the item number of the currently selected radio item.

Last Edited: July 31, 2003


RadioGroup [Property Current_Radio_Object]

Current_Radio_Object - RadioGroup

Similar to Current_Radio except that it operates with object IDs instead of item IDs

Type: Property

Access: Read/Write

Data Type: Integer

Description

Current_radio_object is similar to Current_Radio except that it operates with object IDs instead of item IDs.

Last Edited: July 31, 2003


RadioGroup [Property Radio_Count]

Radio_Count - RadioGroup

Returns the number of radio objects within this object

Type: Property

Access: Read-Only

Data Type: Integer

Description

Radio_count returns the number of radio objects within this object.

Last Edited: September 11, 2003


RadioGroup [Property Radio_Value]

Radio_Value - RadioGroup

Gets and sets the label of a child radio object

Type: Property

Access: Read/Write

Data Type: String

Parameters: integer Item# String RValue

Parameter | Description
Item# | The item number
RValue | The radio value

Description

Radio_value gets and sets the label of a child radio object. This allows the group to set the values of its radio children. You may also set this directly within the radio object with the label property.

Last Edited: September 11, 2003


Report [Event Assign_Report_Channel]

Assign_Report_Channel - Report

Makes the current output channel the channel number represented by the report_channel property

Type: Event

Parameters: No Parameters

Description

Assign_report_channel makes the current output channel the channel number represented by the report_channel property. If the property is -1, then no action is taken. This is called anytime a report is entered and ensures that the proper channel is active at output time. In addition, setting the report_channel sets the linecount integer to the current value for that channel.

Last Edited: August 4, 2004


Report [Event Body]

Body - Report

Called once for every record selected for the report to provide processing for record data (if any) not used for subheaders and subtotals

Type: Event

Parameters: No Parameters

Description

Body is called once for every record selected for the report to provide processing for record data (if any) not used for subheaders and subtotals. Unlike most of the other procedure_sections, the body procedure is defined in this class to actually do something. It it queries the has_children_rpt_state and, if it is true, it broadcasts the start_report message to all child objects. This is why a report object that has child reports will usually not contain a procedure_section body (so that the default body behavior in the report class will be inherited). You can manually control how and if nested reports get executed by augmenting this procedure.

Last Edited: July 30, 2003


Report [Event Ending_Main_Report]

Ending_Main_Report - Report

Sent by the report object only if the current report is the outer report (it has no parent-its child_rpt_state is false)

Type: Event

Parameters: No Parameters

Description

Ending_main_report does nothing by default, and is intended for override. This message is sent by the report object only if the current report is the outer report (it has no parent-its child_rpt_state is false). If you wish to know under what condition the report was ended, query to cancelled_state property in this event.

Last Edited: August 5, 2003


Report [Event Ending_Report]

Ending_Report - Report

This handler is called at the end of every report

Type: Event

Parameters: No Parameters

Description

Ending_report does nothing by default, and is intended for override. This handler is called at the end of every report (nested and outer). If you wish to know under what condition the report was ended, query the cancelled_state property in this event.

Last Edited: August 5, 2003


Report [Event Final_Formfeed]

Final_Formfeed - Report

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Report [Event OnConstrain]

OnConstrain - Report

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


Report [Event Page_Bottom]

Page_Bottom - Report

The last thing printed on every page

Type: Event

Parameters: No Parameters

Description

Page_bottom is the last thing printed on every page.

Last Edited: September 10, 2003


Report [Event Page_Footer]

Page_Footer - Report

Printed after page_total on every page except the last page

Type: Event

Parameters: No Parameters

Description

Page_footer is printed after page_total on every page except the last page.

Last Edited: September 10, 2003


Report [Event Page_Header]

Page_Header - Report

Called after page_top on every new page except the first

Type: Event

Parameters: No Parameters

Description

Page_header is called after page_top on every new page except the first.

Last Edited: September 10, 2003


Report [Event Page_Title]

Page_Title - Report

Called on every new page after report_header or page_header

Type: Event

Parameters: No Parameters

Description

Page_title is called on every new page after report_header or page_header.

Last Edited: September 10, 2003


Report [Event Page_Top]

Page_Top - Report

Called first at the top of each new page

Type: Event

Parameters: No Parameters

Description

Page_top is called first at the top of each new page.

Last Edited: September 10, 2003


Report [Event Page_Total]

Page_Total - Report

Called on every new page and is printed as the first part of a page break at the bottom of each page

Type: Event

Parameters: No Parameters

Description

Page_total is called on every new page and is printed as the first part of a page break at the bottom of each page.

Last Edited: September 10, 2003


Report [Event Relate_Main_File]

Relate_Main_File - Report

Called during find_rec and read_by_recnum if a record has been found

Type: Event

Parameters: No Parameters

Description

Relate_main_file is called during find_rec and read_by_recnum if a record has been found. This does nothing by default, and is intended for override. It is called regardless of the value of no_relate_state.

Last Edited: September 11, 2003


Report [Event Report_Footer]

Report_Footer - Report

Printed after page_total on the last page of the report

Type: Event

Parameters: No Parameters

Description

Report_footer is printed after page_total on the last page of the report.

Last Edited: September 11, 2003


Report [Event Report_Header]

Report_Header - Report

Called only on the first page of the report, after page_top

Type: Event

Parameters: No Parameters

Description

Report_header is called only on the first page of the report, after page_top.

Send Run_Report to (Vndr_Report(self))

Last Edited: September 11, 2003


Report [Event Selection]

Selection - Report

Validates a record

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns RPT_OK, RPT_END, RPT_NOT_SELECT or RPT_CANCEL

Description

Selection is used to validate a record. It is intended for override.
The function should return an integer rpt_status value where:

Constant | Meaning
RPT_OK (0) | The record is valid.
RPT_END (1) | The record represents the end of the file.
RPT_NOT_SELECT (2) | The record is not valid, but is not at the end of the file.
RPT_CANCEL (3) | Cancel a report. This would be an unusual return value.

If you are using constrained finding, you will usually not override the handler. Your selection will be within the begin_constraints-end_constraints block. If you are not using constrained finding, you must use this handler to handle your custom constraints.

There is an advantage in using the selection function in conjunction with constrained finds in that an invalid record that is processed through the selection handler is tested for a keypress interrupt and can therefore be interrupted. A constrained find will not return any control to the report object until a valid record or no record is found. Depending on your constraint, this could "tie up" your machine for a long time. The advantage of constraints is that the finding is much faster.

As an example, the following could take a long time to process in a very large database. In the first example, the processing would be faster but the machine would appear to be locked up until a record is found:

Begin_Constraints
    Constrain Vndr.Id GT 'J' // this is fast
    Constrain as (Mid(Vndr.Name, 2, 3) ="zz") // this is slow
End_Constraints

In the second example, the report would take longer, but it could be interrupted at any time with a keypress.

Begin_Constraints
    Constrain Vndr.Id GT 'J' // this is fast
End_Constraints

Function Selection returns Integer
    If (Mid(Vndr.Name, 2, 3) ="zz" Function_return RPT_OK
    Else Function_return RPT_NOT_SELECT
End_function

Last Edited: September 25, 2003


Report [Event Starting_Main_Report]

Starting_Main_Report - Report

Can be used to set flags in WinPrint reports

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Description

Can be used to set flags in WinPrint (class cWinReport2) reports.

Sample

This sample sets page orinetation to landscape in Starting_Main_Report and back to portait in Ending_Main_Report.

Function Starting_Main_Report Returns Integer
        Integer iRetVal

        Forward Get Starting_Main_Report to iRetVal

        // change to landscape
        Send DFSetSpecPrintFlag to WinPrintID DF_LANDSCAPE
        Function_Return iRetVal
End_Function

Procedure Ending_Main_Report
    Forward Send Ending_Main_Report

    // reset to portrait
    Send DFSetSpecPrintFlag to WinPrintId DF_PORTRAIT
End_Procedure

Last Edited: July 22, 2005


Report [Event Starting_Report]

Starting_Report - Report

Called at the start of every report

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

A non-zero return value will cancel the report.

Description

Starting_report does nothing by default, and is intended for override. This handler is called at the start of every report.

Last Edited: September 11, 2003


Report [Event SubHeader1..n]

SubHeader1..n - Report

Called for every break level (n) for which you define a subHeader procedure section in your program

Type: Event

Parameters: No Parameters

Description

These procedures are called for every break level (n) for which you define a subHeader procedure section in your program. This can be the first time a subheader is printed, or when it is repeated for a new page.

Last Edited: September 11, 2003


Report [Event SubHeader_Init1..n]

SubHeader_Init1..n - Report

Called for every break level (n) for which you define a SubHeader_init1..n procedure section in your program

Type: Event

Parameters: No Parameters

Description

These procedures are called for every break level (n) for which you define a SubHeader_init1..n procedure section in your program. It is not called during the repaging of a subheader. For this reason, it is the appropriate place only for one-time subheader initialization code.

Last Edited: September 11, 2003


Report [Event SubTotal1..n]

SubTotal1..n - Report

Called for every break level (n) for which you define a subTotal procedure section in your program

Type: Event

Parameters: No Parameters

Description

These procedures are called for every break level (n) for which you define a subTotal procedure section in your program.

Last Edited: September 11, 2003


Report [Event Total]

Total - Report

Called once at the end of a report after the final subtotals are output

Type: Event

Parameters: No Parameters

Description

Total is called once at the end of a report after the final subtotals are output.

Last Edited: September 11, 2003


Events for Report

View event list in hierarchical order

Name | Description | Defining Class
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property |
Body | Called once for every record selected for the report to provide processing for record data (if any) not used for subheaders and subtotals |
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Ending_Main_Report | Sent by the report object only if the current report is the outer report (it has no parent-its child_rpt_state is false) |
Ending_Report | This handler is called at the end of every report |
Final_Formfeed |  |
OnConstrain |  |
Page_Bottom | The last thing printed on every page |
Page_Footer | Printed after page_total on every page except the last page |
Page_Header | Called after page_top on every new page except the first |
Page_Title | Called on every new page after report_header or page_header |
Page_Top | Called first at the top of each new page |
Page_Total | Called on every new page and is printed as the first part of a page break at the bottom of each page |
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found |
Report_Footer | Printed after page_total on the last page of the report |
Report_Header | Called only on the first page of the report, after page_top |
Selection | Validates a record |
Starting_Main_Report | Can be used to set flags in WinPrint reports |
Starting_Report | Called at the start of every report |
SubHeader_Init1..n | Called for every break level (n) for which you define a SubHeader_init1..n procedure section in your program |
SubHeader1..n | Called for every break level (n) for which you define a subHeader procedure section in your program |
SubTotal1..n | Called for every break level (n) for which you define a subTotal procedure section in your program |
Total | Called once at the end of a report after the final subtotals are output |


Report [Function Start_Report]

Start_Report - Report

Augmented to check the server property and if the property is non-zero (and a DSO exists), to establish a client-server link between the report object and the DSO

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Returns how report was ended. Rpt_Cancelled or Rpt_End.

Description

Start_report is augmented to check the server property and if the property is non-zero (and a DSO exists), to establish a client-server link between the report object and the DSO. This link is established by sending the message add_user_interface to the DSO.

Last Edited: September 25, 2003


Methods for Report

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Formfeed | Procedure | Handles formfeeds |
Output_ImageNum | Procedure | Outputs the image represented by ImageNum |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Run_Report | Procedure | Sends a message to the report object telling it to start the report with internal finding |
Start_Report | Function | Augmented to check the server property and if the property is non-zero (and a DSO exists), to establish a client-server link between the report object and the DSO |
WriteLn | Procedure | Outputs the string message to the current output channel |
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data |


Report [Procedure Formfeed]

Formfeed - Report

Handles formfeeds

Type: Procedure

Parameters: No Parameters

Description

Formfeed handles formfeeds. It increments the page_count property, zeros the linecount integer, and executes a formfeed command based on the value of the page_feed property. This is a useful procedure to augment or override to handle UI-based formfeeds. If you do override this procedure, it is your responsibility to see that linecount is zeroed, that page_count is incremented, and that a formfeed occurs.

Do not get confused between the formfeed command and the procedure of the same name. The Report Package handles a formfeed by sending the formfeed message (this calls the formfeed procedure). The formfeed procedure executes the formfeed command and does other things.

Last Edited: August 18, 2003


Report [Procedure Output_ImageNum]

Output_ImageNum - Report

Outputs the image represented by ImageNum

Type: Procedure

Parameters: Integer ImageNum

Parameter | Description
ImageNum | the image number

Description

Output_imagenum outputs the image represented by ImageNum.

The command of the same name, Output_imageNum, calls this method. Some older reports that use the BasicReport object may use this command.

Last Edited: September 25, 2003


Report [Procedure Run_Report]

Run_Report - Report

Sends a message to the report object telling it to start the report with internal finding

Type: Procedure

Parameters: No Parameters

Description

Run_report sends a message to the report object telling it to start the report with internal finding. It does not return any status value to indicate if the report ended normally or was aborted. Syntactically, this is the simplest way to run a report.

Last Edited: September 11, 2003


Report [Procedure WriteLn]

WriteLn - Report

Outputs the string message to the current output channel

Type: Procedure

Parameters: String WrStr

Parameter | Description
WrStr | the string

Description

Writeln outputs the string message to the current output channel.

Note: All output in a report object is eventually funnelled to three procedures: output_imagenum, writeln, and formfeed. By controlling these three procedures, you can exercise extensive control over the report's output.

Assume you actually wish a report to be sent to three output channels at the same time (Channels 1, 2, and 3). Assume that the report_channel property is set to 1:

Procedure FormFeed
    Forward Send FormFeed // ff to channel 1
    Direct_outPut Channel 2// ff to ch 2
    Formfeed
    Direct_output Channel 3// ff to ch 3
    Formfeed
    Direct_Output Channel 1// restore channel 1
End_Procedure

Procedure WriteLn String S
    Writeln S// to channel 1
    Direct_output Channel 2// to ch 2
    Writeln S
    Direct_output Channel 3// to ch 3
    Writeln S
    Direct_Output Channel 1// restore channel 1
End_Procedure

Procedure OutPut_ImageNum Integer i
    Output_imageNum i // to channel 1
    Direct_outPut Channel 2// to ch 2
    Output_ImageNum i
    Direct_output Channel 3// to ch 3
    Output_imageNum i
    Direct_Output Channel 1// restore channel 1
End_Procedure

Last Edited: September 15, 2003


Report [Procedure Writeln_PageCheck]

Writeln_PageCheck - Report

Allows you to output to your report with non-image data

Type: Procedure

Parameters: String WrStr Integer Lines

Parameter | Description
WrStr | the string
Lines | the lines

Description

Writeln_pageCheck allows you to output to your report with non-image data. First, this procedure checks to determine whether lines lines remain available for output on the current page, and a pagebreak is handled as needed. Then message is output.

Unlike the output_pagecheck and output_wrap_pagecheck procedures, there is no command for sending the writeln_pagecheck message.

This message is very potent. It frees you of the requirement of always needing an image for report output.

The following example would output a warning message each time a customer's balance due exceeds 1,000:

Procedure_Section Body as CustBody
    forward send body
    Print Customer.Id
    Print Customer.Name
    Print Customer.Due
    OutPut_PageCheck // regular image output
// check if due is too much
    if Customer.Due gt 1000 ;
    send WriteLn_PageCheck '*** Balance too high ***'
End_Procedure

Last Edited: September 15, 2003


Properties for Report

View property list in hierarchical order

Name | Description | Defining Class
Assigned_Channel |  |
Cancelled_State | Setting this true will cancel a report |
Child_Count | Returns the number of child objects the object contains | cObject
Child_Rpt_State | Set true if the current Report object is nested |
Current_Rec | (Obsolete) Contains the record number of the current valid record found |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Find_Down_state | Determines if an index should be traversed in forward or reverse order |
Find_Mode | Maintains the current finding mode |
Footer_Lines | Contains the number of lines in the page_bottom image plus the page_footer image plus the page_total image |
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function |
Has_Children_Rpt_State | Is set true if other reports are nested inside this report object |
Last_Rec | (Obsolete) Contains the record number of the last selected record found |
Main_File | Contains the filenumber of the file which the report will use for finding records |
Main_Report_Id | Contains the object ID of the outer report |
Name | Returns the full name of the object including parentage | cObject
New_Page_State | Set true when a new page is needed |
No_Constrained_Find_State | Determines if constrained record finding should be disabled |
No_Finding_State | Determines how the Report object will find records |
No_PageCheck_State | Set true when the Report object is processing a new page |
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found |
Num_Breaks | Returns the number of breaks in a report |
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Ordering | Contains the index number which will be used for finding records |
Page_Count | Keeps track of the current page number |
Page_End | Determines how many lines on a page are allowed before a page break will occur |
Page_End_State | If this property is set true below the forward send statement in the starting_main_report procedure, then the next page_check will cause an end-of-page/new-page sequence |
Page_Feed | Used by the formfeed procedure |
Page_Footer_Lines | The number of lines in the page_footer image |
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
priCurrentRec | Contains the RowId of the current valid record found |
priFoundRec | Contains the RowId of the record found by the find_rec function |
priLastRec | Contains the RowId of the last selected record found |
Rec_Count | Contains the number of records found for the current report |
Refind_for_SubTotal_State | Ensures that the subtotal is processed with the last valid record for that break level |
Report_Channel | Determines which output channel will be used for your report output |
Report_Footer_Lines | The number of lines in the report_footer image |
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing |
Sub_Totaling_State | Set true when the Report object is processing subtotals or totals |


Report [Property Assigned_Channel]

Assigned_Channel - Report

Type: Property

Access: Read/Write

Data Type: Integer

Description

Last Edited: February 13, 2003


Report [Property Cancelled_State]

Cancelled_State - Report

Setting this true will cancel a report

Type: Property

Access: Read/Write

Data Type: Integer

Description

Cancelled_state is set to true when a report has been cancelled. Setting this true will cancel a report. You can query the property to find out if a report was ended normally or was cancelled. This is particularly useful in the ending_report and ending_main_report procedures.

Last Edited: July 30, 2003


Report [Property Child_Rpt_State]

Child_Rpt_State - Report

Set true if the current Report object is nested

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Child_rpt_state is set true if the current Report object is nested (the current report has a parent report). If child_rpt_state is false, then the report object is the main (or only) report.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: January 12, 2006


Report [Property Current_Rec]

Current_Rec - Report

Contains the record number of the current valid record found

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Obsolete

This method is obsolete, use priCurrentRec

Current_rec contains the record number of the current valid record found. Normally found_rec and current_rec will be the same. In situations where you use the selection function to filter records, the current_rec will be the current valid record found and found_rec will be the current record found. If no_finding_state is true then this property is not maintained.

See Also

priCurrentRec

Last Edited: February 2, 2005


Report [Property Find_Down_state]

Find_Down_state - Report

Determines if an index should be traversed in forward or reverse order

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Find_Down_State determines if an index should be traversed in forward or reverse order. This can be set by the report_index command or the by down command-line option in the report-object definition. Setting this property true will cause the report to find records in the reverse index order.

Last Edited: January 12, 2006


Report [Property Find_Mode]

Find_Mode - Report

Maintains the current finding mode

Type: Property

Access: Read/Write

Data Type: Integer

Description

Find_mode maintains the current finding mode, where 0 =lt, 1 =le, 3 =ge, and 4 =gt. It is maintained by the find_init procedure and the find_rec function. It is only maintained if no_finding_state is false and no_constrained_find_state is true. When in constrained finding mode (the default), these properties do not need to be maintained.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: December 6, 2004


Report [Property Footer_Lines]

Footer_Lines - Report

Contains the number of lines in the page_bottom image plus the page_footer image plus the page_total image

Type: Property

Access: Read/Write

Data Type: Integer

Description

Footer_lines contains the number of lines in the page_bottom image plus the page_footer image plus the page_total image. See the handle_footer procedure to see how the footer_lines, report_footer_lines, and page_footer_lines properties are used.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: December 6, 2004


Report [Property Found_Rec]

Found_Rec - Report

Contains the record number of the record found by the find_rec function

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Obsolete

This method is obsolete, use priFoundRec

Found_rec contains the record number of the record found by the find_rec function. If no_finding_state is true, this property is not maintained.

See Also

priFoundRec

Last Edited: February 2, 2005


Report [Property Has_Children_Rpt_State]

Has_Children_Rpt_State - Report

Is set true if other reports are nested inside this report object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Has_children_rpt_state is set true if other reports are nested inside this report object.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: January 12, 2006


Report [Property Last_Rec]

Last_Rec - Report

Contains the record number of the last selected record found

Type: Property

Obsolete

Access: Read/Write

Data Type: Integer

Description

Obsolete

This method is obsolete, use priLastRec

Last_rec contains the record number of the last selected record found. This is tracked so that a previous record can be retrieved for subtotal processing.

See Also

priLastRec

Last Edited: February 2, 2005


Report [Property Main_File]

Main_File - Report

Contains the filenumber of the file which the report will use for finding records

Type: Property

Access: Read/Write

Data Type: Integer

Description

Main_file contains the filenumber of the file which the report will use for finding records. This can be set with the report_main_file command or the main_file command-line option in the report-object definition.

Last Edited: August 18, 2003


Report [Property Main_Report_Id]

Main_Report_Id - Report

Contains the object ID of the outer report

Type: Property

Access: Read/Write

Data Type: Integer

Description

Main_report_id contains the object ID of the outer report. This should never be set. All objects including the outer report object have this ID.

Upon occasion, you need to get at a property that was set only in the outer main report. If the property is unique to the outer object (meaning that you created a custom property for this one outer object), you will be able to access this property from all child objects through a simple get or set (delegation will find the property). If the property also exists in the child reports (which happens when all reports are based on the same subclass), this will not work. A get or set will find the current child object's property. By using the main_report_id property, you can directly get at the outer main report.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

The following procedure finds the object ID of the main outer report and gets a property of this object and sends it a message.

Procedure Something Integer Val
    Integer Obj#
    Get Main_report_Id to Obj#
    Get Some_parent_property of Obj# to Val
    Send Some_Parent_Message to Obj#
End_Procedure

Last Edited: December 6, 2004


Report [Property New_Page_State]

New_Page_State - Report

Set true when a new page is needed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

New_page_state is set true when a new page is needed. This property is automatically set true at the start of a report and after a page break.

Last Edited: January 12, 2006


Report [Property No_Constrained_Find_State]

No_Constrained_Find_State - Report

Determines if constrained record finding should be disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Normally a report uses constraints to handle all record initializing, finding, and selection. Occasionally, the automatic constraints can work against you. In such a case, you can set the no_constrained_find_state to true. When it is true, it is up to you to program the file-buffer initialization (use either Function starting_report or Procedure find_init) and record selection (use Function selection). This property must be manually set.

Last Edited: January 12, 2006


Report [Property No_Finding_State]

No_Finding_State - Report

Determines how the Report object will find records

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If set to true, then the Report object will not find records internally. Instead, the report object will expect to be called each time a record (or item) needs to be output. Normally when this is needed, you will not define a main_file for the report (there is no need to). In fact, if after a report object is created the object's main_file property is zero, then the no_finding_state will automatically be set to true.

Last Edited: January 12, 2006


Report [Property No_PageCheck_State]

No_PageCheck_State - Report

Set true when the Report object is processing a new page

Type: Property

Access: Read/Write

Data Type: Boolean

Description

No_page_check_state is set true when the Report object is processing a new page (a new page or reprinting subheaders). When true, the output_pagecheck, output_wrap_pagecheck, and writeln_pagecheck procedures do not perform a page check.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: January 12, 2006


Report [Property No_Relate_State]

No_Relate_State - Report

Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found

Type: Property

Access: Read/Write

Data Type: Boolean

Description

No_relate_state is only used when no_constrained_find_state is true. When no_relate_state is true, relates are not automatically performed and it is up to you to make sure the records that you need related are found. The manual relates will be handled in the relate_main_file procedure.

This property has no effect on regular constrained finding. If you wish to control relates with constrained finds, you may wish to use the set_relate command.

Last Edited: January 12, 2006


Report [Property Num_Breaks]

Num_Breaks - Report

Returns the number of breaks in a report

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: February 2, 2005


Report [Property Ordering]

Ordering - Report

Contains the index number which will be used for finding records

Type: Property

Access: Read/Write

Data Type: Integer

Description

Ordering contains the index number which will be used for finding records. A value of -1 tells the runtime to choose the most-appropriate index based on current constraints. This is normally set by the report_index command or the by| down command-line option in the report-object definition.

Last Edited: August 6, 2004


Report [Property Page_Count]

Page_Count - Report

Keeps track of the current page number

Type: Property

Access: Read/Write

Data Type: Integer

Description

Page_count keeps track of the current page number. A report object automatically sets this to 1 when a report is started. In nested reports, only the page_count value of the outermost parent report is used.

Last Edited: September 10, 2003


Report [Property Page_End]

Page_End - Report

Determines how many lines on a page are allowed before a page break will occur

Type: Property

Access: Read/Write

Data Type: Integer

Description

Page_end determines how many lines on a page are allowed before a page break will occur. In nested reports, only the Page_End value of the outermost parent report is used.

Last Edited: September 10, 2003


Report [Property Page_End_State]

Page_End_State - Report

If this property is set true below the forward send statement in the starting_main_report procedure, then the next page_check will cause an end-of-page/new-page sequence

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If Page_end_state is set true below the forward send statement in the starting_main_report procedure, then the next page_check (normally executed as part of an output_pagecheck) will cause an end-of-page/new-page sequence. Although the report object never sets this property to true, it does reset it to false after a page break.

You can set page_end_state to true if you wish to force a page break. Often you will want a page break to be executed at the end of a subtotal section. Setting this property to true after the last image in a section has been output will inform the report to break a page before any images or lines are printed.

Last Edited: January 12, 2006


Report [Property Page_Feed]

Page_Feed - Report

Used by the formfeed procedure

Type: Property

Access: Read/Write

Data Type: Integer

Description

Page_feed is used by the formfeed procedure. The formfeed procedure looks at the page_feed property to determine how to handle a formfeed. Look at Procedure formfeed to understand how it uses the formfeed command. Set this property below the forward get statement in the starting_main_report function.

If page_feed is: |  |
1 ~32767 | Linefeed Mode | Output linefeed characters until linecount equals page_feed
0 | Hardware Formfeed Mode | Output a formfeed character (ASCII 12)
1 | Full-screen Mode | Output the number of lines in Predefined Variable screenend, then display a message on the screen to press a key to continue and pause until the user does so.
2 | Custom Mode | Do nothing. This is what you would use if you are printing to the screen and you want to create your own UI end-of-screen handler inside the formfeed procedure.

In nested reports, only the page_feed value of the outermost parent report is used.

Last Edited: September 10, 2003


Report [Property Page_Footer_Lines]

Page_Footer_Lines - Report

The number of lines in the page_footer image

Type: Property

Access: Read/Write

Data Type: Integer

Description

Page_footer_lines is the number of lines in the page_footer image.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: December 6, 2004


Report [Property priCurrentRec]

priCurrentRec - Report

Contains the RowId of the current valid record found

Type: Property

Access: Read/Write

Data Type: RowId

Description

priCurrentRec contains the RowId of the current valid record found. Normally priFoundRec and priCurrentRec will be the same. In situations where you use the selection function to filter records, the priCurrentRec will be the current valid record found and priFoundRec will be the current record found. If no_finding_state is true then this property is not maintained.

See Also

priFoundRec

Last Edited: February 2, 2005


Report [Property priFoundRec]

priFoundRec - Report

Contains the RowId of the record found by the find_rec function

Type: Property

Access: Read/Write

Data Type: RowId

Description

priFoundRec contains the rRowId of the record found by the find_rec function. If no_finding_state is true, this property is not maintained.

See Also

priCurrentRec

Last Edited: February 2, 2005


Report [Property priLastRec]

priLastRec - Report

Contains the RowId of the last selected record found

Type: Property

Access: Read/Write

Data Type: RowId

Description

priLastRowId contains the RowId of the last selected record found. This is tracked so that a previous record can be retrieved for subtotal processing.

Last Edited: February 2, 2005


Report [Property Rec_Count]

Rec_Count - Report

Contains the number of records found for the current report

Type: Property

Access: Read/Write

Data Type: Integer

Description

Rec_count contains the number of records found for the current report.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: December 6, 2004


Report [Property Refind_for_SubTotal_State]

Refind_for_SubTotal_State - Report

Ensures that the subtotal is processed with the last valid record for that break level

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Refind_for_subtotal_state is for advanced use. Normally before a subtotal is printed, the report object refinds the previous record and its related records. This ensures that the subtotal is processed with the last valid record for that break level. When this process is completed, the new record is refound. In reports having many subtotals, this process can slow down the reporting a small amount and where you have subtotals none of whose sections uses any data from the last record in the group, you may disable this refinding process by setting this property to false.

Last Edited: January 12, 2006


Report [Property Report_Channel]

Report_Channel - Report

Determines which output channel will be used for your report output

Type: Property

Access: Read/Write

Data Type: Integer

Description

Report_channel determines which output channel will be used for your report output. If the value is -1 (the default), then no channel reassignment occurs and whatever channel is current is used. In nested reports, only the report_channel value of the outermost parent report is used.

Last Edited: August 6, 2004


Report [Property Report_Footer_Lines]

Report_Footer_Lines - Report

The number of lines in the report_footer image

Type: Property

Access: Read/Write

Data Type: Integer

Description

Report_footer_lines is the number of lines in the report_footer image.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: December 6, 2004


Report [Property Rpt_Ttl_Level]

Rpt_Ttl_Level - Report

Keeps track of the current sub-total level during subtotal processing

Type: Property

Access: Read/Write

Data Type: Integer

Description

Rpt_ttl_level keeps track of the current sub-total level during subtotal processing.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: December 6, 2004


Report [Property Sub_Totaling_State]

Sub_Totaling_State - Report

Set true when the Report object is processing subtotals or totals

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Sub_totaling_state is set true when the Report object is processing subtotals or totals.

This property is maintained by the Report object and you should be careful if you decide to change its value. The consequences of having it set to an invalid value are unpredictable.

Last Edited: January 12, 2006


Events for Report_DS

View event list in hierarchical order

Name | Description | Defining Class
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property | Report
Body | Called once for every record selected for the report to provide processing for record data (if any) not used for subheaders and subtotals | Report
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Ending_Main_Report | Sent by the report object only if the current report is the outer report (it has no parent-its child_rpt_state is false) | Report
Ending_Report | This handler is called at the end of every report | Report
Final_Formfeed |  | Report
OnConstrain |  | Report
Page_Bottom | The last thing printed on every page | Report
Page_Footer | Printed after page_total on every page except the last page | Report
Page_Header | Called after page_top on every new page except the first | Report
Page_Title | Called on every new page after report_header or page_header | Report
Page_Top | Called first at the top of each new page | Report
Page_Total | Called on every new page and is printed as the first part of a page break at the bottom of each page | Report
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found | Report
Report_Footer | Printed after page_total on the last page of the report | Report
Report_Header | Called only on the first page of the report, after page_top | Report
Selection | Validates a record | Report
Starting_Main_Report | Can be used to set flags in WinPrint reports | Report
Starting_Report | Called at the start of every report | Report
SubHeader_Init1..n | Called for every break level (n) for which you define a SubHeader_init1..n procedure section in your program | Report
SubHeader1..n | Called for every break level (n) for which you define a subHeader procedure section in your program | Report
SubTotal1..n | Called for every break level (n) for which you define a subTotal procedure section in your program | Report
Total | Called once at the end of a report after the final subtotals are output | Report


Methods for Report_DS

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Formfeed | Procedure | Handles formfeeds | Report
Output_ImageNum | Procedure | Outputs the image represented by ImageNum | Report
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Save | Procedure | If sent, this saves the current record |
Run_Report | Procedure | Sends a message to the report object telling it to start the report with internal finding | Report
Start_Report | Function | Augmented to check the server property and if the property is non-zero (and a DSO exists), to establish a client-server link between the report object and the DSO | Report
WriteLn | Procedure | Outputs the string message to the current output channel | Report
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data | Report


Report_DS [Procedure Request_Delete]

Request_Delete - Report_DS

If sent (usually in the body) this will delete the current record through the DDO

Type: Procedure

Parameters: No Parameters

Description

If Request_delete is sent (usually in the body) this will delete the current record through the DDO. After the delete, the record remains unchanged in the buffer (including the recnum). All parent files are properly updated and all multi user requirements are met. If the DDO has a child DDO connected to it, all child records will also get automatically deleted.

Last Edited: September 11, 2003


Report_DS [Procedure Request_Save]

Request_Save - Report_DS

If sent, this saves the current record

Type: Procedure

Parameters: No Parameters

Description

If Request_Save is sent, this saves the current record. This is usually sent in a body procedure section. Use the entry_update message to make the changes during the save process. All parent files are properly modified. Sends request_validate.

Last Edited: August 19, 2004


Properties for Report_DS

View property list in hierarchical order

Name | Description | Defining Class
Assigned_Channel |  | Report
Cancelled_State | Setting this true will cancel a report | Report
Child_Count | Returns the number of child objects the object contains | cObject
Child_Rpt_State | Set true if the current Report object is nested | Report
Current_Rec | (Obsolete) Contains the record number of the current valid record found | Report
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Find_Down_state | Determines if an index should be traversed in forward or reverse order | Report
Find_Mode | Maintains the current finding mode | Report
Footer_Lines | Contains the number of lines in the page_bottom image plus the page_footer image plus the page_total image | Report
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function | Report
Has_Children_Rpt_State | Is set true if other reports are nested inside this report object | Report
Last_Rec | (Obsolete) Contains the record number of the last selected record found | Report
Main_File | Contains the filenumber of the file which the report will use for finding records | Report
Main_Report_Id | Contains the object ID of the outer report | Report
Name | Returns the full name of the object including parentage | cObject
New_Page_State | Set true when a new page is needed | Report
No_Constrained_Find_State | Determines if constrained record finding should be disabled | Report
No_Finding_State | Determines how the Report object will find records | Report
No_PageCheck_State | Set true when the Report object is processing a new page | Report
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found | Report
Num_Breaks | Returns the number of breaks in a report | Report
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Ordering | Contains the index number which will be used for finding records | Report
Page_Count | Keeps track of the current page number | Report
Page_End | Determines how many lines on a page are allowed before a page break will occur | Report
Page_End_State | If this property is set true below the forward send statement in the starting_main_report procedure, then the next page_check will cause an end-of-page/new-page sequence | Report
Page_Feed | Used by the formfeed procedure | Report
Page_Footer_Lines | The number of lines in the page_footer image | Report
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
priCurrentRec | Contains the RowId of the current valid record found | Report
priFoundRec | Contains the RowId of the record found by the find_rec function | Report
priLastRec | Contains the RowId of the last selected record found | Report
Rec_Count | Contains the number of records found for the current report | Report
Refind_for_SubTotal_State | Ensures that the subtotal is processed with the last valid record for that break level | Report
Report_Channel | Determines which output channel will be used for your report output | Report
Report_Footer_Lines | The number of lines in the report_footer image | Report
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing | Report
Server | Contains the object ID of this object's server |
Sub_Totaling_State | Set true when the Report object is processing subtotals or totals | Report


Report_DS [Property Server]

Server - Report_DS

Contains the object ID of this object's server

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server contains the object ID of this object's server. If the value is zero, this object is not using a DSO. This property is set at object-creation time.

Last Edited: September 11, 2003


Events for ReportPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


Methods for ReportPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  | FloatingPanel
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Sends deactivate |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Run_Report | Procedure | Runs the report inside the reportpanel |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


ReportPanel [Procedure Request_Cancel]

Request_Cancel - ReportPanel

Sends deactivate

Type: Procedure

Parameters: No Parameters

Description

The Request_cancel procedure sends deactivate.

Last Edited: September 11, 2003


ReportPanel [Procedure Run_Report]

Run_Report - ReportPanel

Runs the report inside the reportpanel

Type: Procedure

Parameters: No Parameters

Description

When the Run_Report procedure receives this message, it sends run_report to its child report (identified by report_object_id). It is expected that all reporting objects understand the message run_report.

Procedure StartReport
    Send Run_report // this will get directed to the report
End_Procedure

Last Edited: September 11, 2003


Properties for ReportPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_DD |  |
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Output_Device_Mode | Directs the output of reports from WinReport and CrystalReport objects |
Output_Device_Name | Directs the output of reports from BasicReport objects |
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server |  |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


ReportPanel [Property Main_DD]

Main_DD - ReportPanel

Type: Property

Access: Read/Write

Data Type: Handle

Description

Last Edited: April 29, 2004


ReportPanel [Property Output_Device_Mode]

Output_Device_Mode - ReportPanel

Directs the output of reports from WinReport and CrystalReport objects

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Output_device_mode property directs the output of reports from WinReport and CrystalReport objects; it has no use in objects containing other types of report objects.

Default is PRINT_TO_PRINTER.

Last Edited: September 10, 2003


ReportPanel [Property Output_Device_Name]

Output_Device_Name - ReportPanel

Directs the output of reports from BasicReport objects

Type: Property

Access: Read/Write

Data Type: String

Description

The Output_device_name property directs the output of reports from BasicReport objects; it has no use in objects containing other types of report objects.

Last Edited: September 10, 2003


ReportPanel [Property Server]

Server - ReportPanel

Type: Property

Access: Read/Write

Data Type: Handle

Description

Last Edited: April 29, 2004


Events for ReportView

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Exit_Application | Called when an application is about to be closed | AppDialog
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnPaint | Sent every time a panel is painted | MdiDialog
OnResize | Sent every time a panel is resized | MdiDialog
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d
Verify_Exit_Application | Sent by the client area to verify that an application may be exited | AppDialog


Methods for ReportView

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Activate_View | Procedure | Activates the view | AppDialog
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  | MdiDialog
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area | MdiDialog
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | MdiDialog
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Sends deactivate |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Run_Report | Procedure | Runs the report inside the reportpanel |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | MdiDialog
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


ReportView [Procedure Request_Cancel]

Request_Cancel - ReportView

Sends deactivate

Type: Procedure

Parameters: No Parameters

Description

The Request_cancel procedure sends deactivate.

Last Edited: September 11, 2003


ReportView [Procedure Run_Report]

Run_Report - ReportView

Runs the report inside the reportpanel

Type: Procedure

Parameters: No Parameters

Description

When the Run_Report procedure receives this message, it sends run_report to its child report (identified by report_object_id). It is expected that all reporting objects understand the message run_report.

Procedure StartReport
    Send Run_report // this will get directed to the report
End_Procedure

Last Edited: September 11, 2003


Properties for ReportView

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | MdiDialog
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | MdiDialog
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_DD |  |
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | MdiDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Output_Device_Mode | Directs the output of reports from WinReport and CrystalReport objects |
Output_Device_Name | Directs the output of reports from BasicReport objects |
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server |  |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


ReportView [Property Main_DD]

Main_DD - ReportView

Type: Property

Access: Read/Write

Data Type: Handle

Description

Last Edited: April 29, 2004


ReportView [Property Output_Device_Mode]

Output_Device_Mode - ReportView

Directs the output of reports from WinReport and CrystalReport objects

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Output_device_mode property directs the output of reports from WinReport and CrystalReport objects; it has no use in objects containing other types of report objects.

Default is PRINT_TO_PRINTER.

Last Edited: September 10, 2003


ReportView [Property Output_Device_Name]

Output_Device_Name - ReportView

Directs the output of reports from BasicReport objects

Type: Property

Access: Read/Write

Data Type: String

Description

The Output_device_name property directs the output of reports from BasicReport objects; it has no use in objects containing other types of report objects.

Last Edited: September 10, 2003


ReportView [Property Server]

Server - ReportView

Type: Property

Access: Read/Write

Data Type: Handle

Description

Last Edited: April 29, 2004


Events for SaveAsDialog

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for SaveAsDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Show_Dialog | Function | Determines how the dialog box is constructed and behaves | AbstractFileDialog


Properties for SaveAsDialog

View property list in hierarchical order

Name | Description | Defining Class
AllowReadOnly_State | Determines whether users without write access can select files that are read-only or in a read-only folder | AbstractFileDialog
Child_Count | Returns the number of child objects the object contains | cObject
CreatePrompt_State | Determines if a message box will ask users whether they want to create the entered filename, when such filename is not found | AbstractFileDialog
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dialog_Caption | Sets this object's caption | AbstractFileDialog
File_Name | Holds the full pathname of the file and can be considered a read-only property | AbstractFileDialog
File_Title | Holds the title of the file (i.e., without path) | AbstractFileDialog
FileMustExist_State | Specifies whether users can enter a file title that doesn't exist | AbstractFileDialog
Filter_Index | Determines which filter you would like this object's Filter combobox to start with | AbstractFileDialog
Filter_String | Holds the descriptions and filters that will be available to users | AbstractFileDialog
HideReadOnly_State | Determines whether the checkbox is hidden | AbstractFileDialog
Initial_Folder | Determines the starting point for this object | AbstractFileDialog
Name | Returns the full name of the object including parentage | cObject
NoChangeDir_State | Restores the current directory to the original directory if the user switched the current directory while searching for files | AbstractFileDialog
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
OverwritePrompt_State | Specifies whether users should be prompted before selecting a file name that already exists | AbstractFileDialog
Parent | Returns the parent of an object | cObject
PathMustExist_State | Specifies whether users can enter a file path that doesn't exist | AbstractFileDialog
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
ShowFileTitle_State | Specifies whether the contents of the file_title property should be inserted into the dialog box as a default for selectin | AbstractFileDialog
TickReadOnly_State | Checks/un-checks the Read-only checkbox | AbstractFileDialog


Events for Set

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Set [Function Find_Element]

Find_Element - Set

Returns the index of an element in a set or -1 if not found

Type: Function

Return Data Type: Integer

Parameters: string ElemStr

Parameter | Description
ElemStr | Element value to be found in the set

Return Value

Returns the index of the element whose value matches ElemStr. If no element matches, returns -1.

Description

Find_Element returns the index of an element whose value matches ElemStr. If no element matches, it returns -1. Like its superclass, the index numbers start at zero.

// Search for a set value and, if found, replace it with a new value
Procedure ReplaceElement string sOldElement string sNewElement
    integer iPos
    get Find_Element of oSet sOldElement to iPos
    If (iPos<>-1) Begin
        Set Value of oSet iPos to sNewElement
    End
End

See Also

Add_Element | Remove_Element | Value

Last Edited: February 17, 2004


Methods for Set

View method list in hierarchical order

Name | Type | Description | Defining Class
Add_Element | Procedure | Adds an element to the set if the element does not already exist |
Create | Function | Creates an object based on the passed Class Id | cObject
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Find_Element | Function | Returns the index of an element in a set or -1 if not found |
Remove_Element | Procedure | Removes specified value from the set if present, and compacts remaining values |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array


Set [Procedure Add_Element]

Add_Element - Set

Adds an element to the set if the element does not already exist

Type: Procedure

Return Data Type: Integer

Parameters: string Elem_Str

Parameter | Description
Elem_Str | Element value to be added to the set

Return Value

Returns index where element was added (optional and not normally used)

Description

Add_Element adds an element to end of the set if the element does not yet exist. If the element value already exists, nothing happens.

object oSet is a set
    send add_element 12        //add first (0th) element
    send add_element 47.3        //add second (1st) element
    send add_element "Igor"    //add third (2nd) element
end_object
send add_element of oSet 12 // a duplicate, will not be added again
send add_element of oSet "new" // will be added to the set

See Also

Find_Element | Remove_Element | Value

Last Edited: November 11, 2003


Set [Procedure Remove_Element]

Remove_Element - Set

Removes specified value from the set if present, and compacts remaining values

Type: Procedure

Parameters: string sElement

Parameter | Description
sElement | value to be removed from the set

Description

Remove_Element removes specified value from the set if present, and compacts remaining values.

Procedure RemoveName string sOldName
    send remove_element of oSet sOldName
end_procedure

See Also

Find_Element | Add_Element | Value

Last Edited: November 11, 2003


Properties for Set

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Value | Sets and Gets an array element's value | Array


ShapeControl [Event UserPaint]

UserPaint - ShapeControl

An interface for augmentation to the internal painting of the control

Type: Event

Parameters: Handle hDC

Parameter | Description
hDC | The device control handle

Description

The UserPaint message is provided as an interface for augmentation to the internal painting of the control.

Last Edited: September 11, 2003


Events for ShapeControl

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
UserPaint | An interface for augmentation to the internal painting of the control |


Methods for ShapeControl

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for ShapeControl

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Shape_Back_Color | Maintains the RGB color of the object's background that is visible beyond the boundaries of the GDI object | AbstractShapeControl
Shape_Fill_Color | Maintains the RGB value of the "brush" to use to fill the object | AbstractShapeControl
Shape_Pen_Color | Maintains the RGB color value that the object's pen will use | AbstractShapeControl
Shape_Pen_Style | Specifies the style of pen that Windows will use to draw the object | AbstractShapeControl
Shape_Pen_Width | Maintains the width of the pen to use | AbstractShapeControl
Shape_Style | Determines which GDI object to draw in the container area | AbstractShapeControl
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Events for SpinForm

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message | Form
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Form
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | Form
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus | Form
OnMaxText |  | Form
OnSetFocus | Sent whenever windows is about to give this object the focus | Form
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Form
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | Form


Methods for SpinForm

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Form
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Form
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Form
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | Form
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | Form
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Form
DoScrollDown | Procedure | Emulates pressing a spin button down |
DoScrollUp | Procedure | Emulates pressing a spin button up |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Form
Error_Help | Procedure | (Obsolete) | Form
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Form
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Form
Help | Procedure |  | Form
Help_For_Help | Procedure | (Obsolete) | Form
Help_Index | Procedure | (Obsolete) | Form
Help_on_topic | Procedure | (Obsolete) | Form
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Form
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Form
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | Form
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Form
Prompt | Procedure | The default message sent by this object's prompt button | Form
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Form
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Form
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


SpinForm [Procedure DoScrollDown]

DoScrollDown - SpinForm

Emulates pressing a spin button down

Type: Procedure

Parameters: No Parameters

Description

Sending the DoScrollDown message emulates pressing a spin button down. If the active cell in a grid does not support a spin button, this procedure does nothing. Normally, you will assign keys to this procedure and to the procedure DoScrollUp.

// assign keys to manually spin value
On_Key Key_Ctrl+Key_U Send DoScrollUp
On_Key Key_Ctrl+Key_D Send DoScrollDown

Last Edited: August 5, 2003


SpinForm [Procedure DoScrollUp]

DoScrollUp - SpinForm

Emulates pressing a spin button up

Type: Procedure

Parameters: No Parameters

Description

Sending the DoScrollUp message emulates pressing a spin button up. If the active cell in a grid does not support a spin button, this procedure does nothing. Normally, you will assign keys to this procedure and to the procedure DoScrollDown.

// assign keys to manually spin value
On_Key Key_Ctrl+Key_U Send DoScrollUp
On_Key Key_Ctrl+Key_D Send DoScrollDown

Last Edited: August 5, 2003


Properties for SpinForm

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | Form
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Position | Contains the current position of the spin button |
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Form
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Form
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | Form
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Form
Help_Keyword | Used to specify an object's context keyword | Form
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled | Form
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Form
Label_Col_Offset | The horizontal distance from the object to its label | Form
Label_Justification_Mode | The justification mode for the text within this object's label | Form
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Form
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Form
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Maintains the value that represents the highest value that the spin button will spin up to |
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Maintains the value that represents the lowest value that the spin button will spin down to |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Form
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form | Form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object | Form
Prompt_Object | Specifies the default receiving object for the popup message | Form
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Form
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value | Called anytime the spin button needs to synchronize its value with the form value |
Status_Help | Determines the status text that will be displayed when this object takes the focus | Form
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Form
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Determines whether the spin button will wrap |


SpinForm [Property Current_Position]

Current_Position - SpinForm

Contains the current position of the spin button

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Current_position property contains the current position of the spin button. The value is in the range of 0-65,535.

Default is 0.

Last Edited: July 31, 2003


SpinForm [Property Maximum_Position]

Maximum_Position - SpinForm

Maintains the value that represents the highest value that the spin button will spin up to

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Maximum_Position property maintains the value that represents the highest value that the spin button will spin up to. The value is in the range of 32767 to -32767

Default is 32767.

Last Edited: August 16, 2004


SpinForm [Property Minimum_Position]

Minimum_Position - SpinForm

Maintains the value that represents the lowest value that the spin button will spin down to

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Minimum_Position property maintains the value that represents the lowest value that the spin button will spin down to. The value is in the range of 32767 to -32767

Default is 32767.

Last Edited: August 16, 2004


SpinForm [Property Spin_Value]

Spin_Value - SpinForm

Called anytime the spin button needs to synchronize its value with the form value

Type: Property

Access: Read/Write

Data Type: Integer

Description

Spin_Value is called anytime the spin button needs to synchronize its value with the form value. This can be augmented to convert the form's value into some other numeric spin value. You will usually need to augment the Spin_value function as well.

Procedure Set Spin_Value integer itm
    If itm eq 0      Set Value item 0 to "Open"
    Else if itm eq 1 Set Value item 0 to "Closed"
    Else if itm eq 2 Set Value item 0 to "Canceled"
end_procedure

Last Edited: September 11, 2003


SpinForm [Property Wrap_State]

Wrap_State - SpinForm

Determines whether the spin button will wrap

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Wrap_state property determines whether the spin button will wrap. If this property is true, once the Current_Position is spun beyond the Maximum_Position, it will rotate to the Minimum_Position, and vice-versa.

Default is true.

Last Edited: January 12, 2006


Events for SplashScreenPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


Methods for SplashScreenPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  | FloatingPanel
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for SplashScreenPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
WaveFile |  |
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


SplashScreenPanel [Property WaveFile]

WaveFile - SplashScreenPanel

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


Events for StatusAsciiLog

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


Methods for StatusAsciiLog

View method list in hierarchical order

Name | Type | Description | Defining Class
Close_Log | Procedure | Closes the status log ascii file |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Log_Clear | Procedure | Clears (empties) the Status log ascii file |
Log_Status | Procedure | Creates a new log entry in the status-log file |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


StatusAsciiLog [Procedure Close_Log]

Close_Log - StatusAsciiLog

Closes the status log ascii file

Type: Procedure

Parameters: No Parameters

Description

The Close_Log message closes the status log ascii file. The file's name to be closed is determined by the Log_Name property.

Last Edited: August 18, 2003


StatusAsciiLog [Procedure Log_Clear]

Log_Clear - StatusAsciiLog

Clears (empties) the Status log ascii file

Type: Procedure

Parameters: No Parameters

Description

The Log_Clear message clears (empties) the status log ascii file. The file's name to be cleared is determined by the Log_Name property.

Last Edited: August 18, 2003


StatusAsciiLog [Procedure Log_Status]

Log_Status - StatusAsciiLog

Creates a new log entry in the status-log file

Type: Procedure

Parameters: string Txt

Parameter | Description
Txt | The text to be added to the log

Description

Log_status creates a log entry in the status-log file.

During the execution of this procedure, the error handler is temporarily set to this object. If an error occurs inside this procedure, the error will be ignored. This was done to prevent recursion. Often status logging is used to record errors.

Last Edited: August 18, 2003


Properties for StatusAsciiLog

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Close_Always_State | Determines if the ascii File should be closed between each log |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Log_Channel | Determines the Channel number used for the ascii file |
Log_Name | Determines the file name of the ascii log file |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject


StatusAsciiLog [Property Close_Always_State]

Close_Always_State - StatusAsciiLog

Determines if the ascii File should be closed between each log

Type: Property

Access: Read/Write

Data Type: Integer

Description

Close_Always_state determines if the ascii log file should normally be closed and opened only long enough to record a log event. Normally, this property is false which means that status log file remains open between logs. Closing the file each time, slows down processing but has the advantage of writing the file to disk after each event which can be a useful debugging technqiue in an unstable environment.

Default is False.

Last Edited: August 18, 2003


StatusAsciiLog [Property Log_Channel]

Log_Channel - StatusAsciiLog

Determines the Channel number used for the ascii file

Type: Property

Access: Read/Write

Data Type: Integer

Description

Setting Log_Channel allows you to specify an output channel (between 1 and 9) for your ASCII log.

Default is 8.

Last Edited: June 4, 2004


StatusAsciiLog [Property Log_Name]

Log_Name - StatusAsciiLog

Determines the file name of the ascii log file

Type: Property

Access: Read/Write

Data Type: String

Description

Log_Name determines the file path and name of the ascii log file.

Default is ".\DFLog.txt"

Last Edited: August 18, 2003


StatusdbLog [Event OnNewRecord]

OnNewRecord - StatusdbLog

Called before the actual save but after the status text and date/time stamp have been moved to the database

Type: Event

Parameters: No Parameters

Description

OnNewRecord is called before the actual save but after the status text and date/time stamp have been moved to the database. It does nothing by default and should be used for augmentation. If you added extra fields to your database, you could set those fields' values in this procedure

Last Edited: September 10, 2003


Events for StatusdbLog

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
OnNewRecord | Called before the actual save but after the status text and date/time stamp have been moved to the database |


Methods for StatusdbLog

View method list in hierarchical order

Name | Type | Description | Defining Class
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Log_Clear | Procedure | Removes all records from the STATLOG file |
Log_Status | Procedure | Creates a new record in the status-log file |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject


StatusdbLog [Procedure Log_Clear]

Log_Clear - StatusdbLog

Removes all records from the STATLOG file

Type: Procedure

Parameters: No Parameters

Description

Log_clear removes all records from the STATLOG file.

Last Edited: August 18, 2003


StatusdbLog [Procedure Log_Status]

Log_Status - StatusdbLog

Creates a new record in the status-log file

Type: Procedure

Parameters: string Txt

Parameter | Description
Txt | The text to be added to the log

Description

Log_status creates a new record in the status-log file. It sets the following database values:

Statlog.Description | txt
Statlog.Date | Current date
Statlog.Time | Current time in HH:MM string format

It also sends the message onNewRecord. This is called after the information has been moved to the buffer but before the save. You can use this hook to customize the record data before the save.

During the execution of this procedure, the error handler is temporarily set to this object. If an error occurs inside this procedure, the error will be ignored. This was done to prevent recursion. Often status logging is used to record errors.

Last Edited: August 18, 2003


Properties for StatusdbLog

View property list in hierarchical order

Name | Description | Defining Class
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject


Events for StatusPanel

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject


StatusPanel [Function Check_StatusPanel]

Check_StatusPanel - StatusPanel

Returns a status value from the status panel

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

Normally a non-zero return value means that the process has been canceled.

Description

Check_StatusPanel returns a status value from the status panel.

Last Edited: July 30, 2003


Methods for StatusPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Check_StatusPanel | Function | Returns a status value from the status panel |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Initialize_StatusPanel | Procedure | Sets the values of the popup-status-panel elements |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Start_StatusPanel | Procedure | Starts the status panel process |
Stop_StatusPanel | Procedure | Stops the status popup and restores the current program's normal modality |
Update_StatusPanel | Procedure | Places a value in the "action window" of an active status panel |


StatusPanel [Procedure Initialize_StatusPanel]

Initialize_StatusPanel - StatusPanel

Sets the values of the popup-status-panel elements

Type: Procedure

Parameters: String sCaption String sTitle String sMessage String sParams

Parameter | Description
sCaption | The content of the caption bar
sTitle | A centered title that appears in the dialog
sMessage | A longer message that can appear below the title
sParams | Additional parameters passed to the sentinal program in the command line

Description

Initialize_StatusPanel sets the values of the popup-status-panel elements sCaption, sTitle, sMessage, and sParams.

This should be done before the status panel is activated. This data should be considered static. Once the status panel has popped up, these characteristics will not change. Note: If the strings are very long, they may not all fit within a single command line. You can also set these values individually by sending Set Caption_text, Set Title_Text, Set Message_Text, and Set Status_Params.

Last Edited: August 18, 2003


StatusPanel [Procedure Start_StatusPanel]

Start_StatusPanel - StatusPanel

Starts the status panel process

Type: Procedure

Parameters: No Parameters

Description

Start_StatusPanel starts the status panel process.

Last Edited: September 11, 2003


StatusPanel [Procedure Stop_StatusPanel]

Stop_StatusPanel - StatusPanel

Stops the status popup and restores the current program's normal modality

Type: Procedure

Parameters: No Parameters

Description

Stop_StatusPanel stops the status popup and restores the current program's normal modality. This must be sent at the end of the process.

Last Edited: September 11, 2003


StatusPanel [Procedure Update_StatusPanel]

Update_StatusPanel - StatusPanel

Places a value in the "action window" of an active status panel

Type: Procedure

Parameters: String sAction

Parameter | Description
sAction | The action text

Description

Update_StatusPanel places a value in the "action window" of an active status panel. This is where the progress information is added. Each sAction replaces the one that was sent before it.

Send Update_StatusPanel to (Status_Panel(self)) ;
    reccount " records processed"

Last Edited: September 11, 2003


Properties for StatusPanel

View property list in hierarchical order

Name | Description | Defining Class
Action_Text | Determines the action text - an area below that message that is used to display progress |
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button |
Button_Text | Determines the button text - a Cancel button that appears below the display |
Caption_Text | Determines the caption text - the value in the caption bar |
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Message_Text | Determines the message text - a longer message that appears below the title |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Status_Default_params |  |
Status_Params |  |
Title_Text | Determines the title text - a centered title that appears inside the dialog |


StatusPanel [Property Action_Text]

Action_Text - StatusPanel

Determines the action text - an area below that message that is used to display progress

Type: Property

Access: Read/Write

Data Type: String

Description

This display value is normally changed, at regular intervals, via the Update_StatusPanel message

Last Edited: July 30, 2003


StatusPanel [Property Allow_Cancel_State]

Allow_Cancel_State - StatusPanel

Specifies whether the status panel will support a Cancel button

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Allow_Cancel_State specifies whether the status panel will support a Cancel button. When false, the status panel is used only to show progress.

Default is true.

Last Edited: January 12, 2006


StatusPanel [Property Button_Text]

Button_Text - StatusPanel

Determines the button text - a Cancel button that appears below the display

Type: Property

Access: Read/Write

Data Type: String

Description

The button_text property determines the button text - a Cancel button that appears below the display. This display value is not normally changed after the object is initialized, but it can be.

Last Edited: August 18, 2003


StatusPanel [Property Caption_Text]

Caption_Text - StatusPanel

Determines the caption text - the value in the caption bar

Type: Property

Access: Read/Write

Data Type: String

Description

The Caption_Text property determines the caption text - the value in the caption bar. This display value is not normally changed after the object is initialized, but it can be.

Last Edited: August 18, 2003


StatusPanel [Property Message_Text]

Message_Text - StatusPanel

Determines the message text - a longer message that appears below the title

Type: Property

Access: Read/Write

Data Type: String

Description

This display value is not normally changed after the object is initialized, but it can be.

Last Edited: August 18, 2003


StatusPanel [Property Status_Default_params]

Status_Default_params - StatusPanel

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


StatusPanel [Property Status_Params]

Status_Params - StatusPanel

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


StatusPanel [Property Title_Text]

Title_Text - StatusPanel

Determines the title text - a centered title that appears inside the dialog

Type: Property

Access: Read/Write

Data Type: String

Description

This display value is not normally changed after the object is initialized, but it can be.

Last Edited: September 11, 2003


Events for SystemMenu

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Initialize_Menu | Sent when the Menubar system is about to be selected | DfBaseActionBar
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for SystemMenu

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Exit_Menu | Procedure |  | DfBaseActionBar
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Redirect_Message | Procedure |  | DfBaseActionBar
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for SystemMenu

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


TabDialog [Event OnBeginningOfPanel]

OnBeginningOfPanel - TabDialog

Sent to the tab-dialog when Beginning_of_panel is sent by a parent

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

OnBeginningOfPanel is sent to the tab-dialog when Beginning_of_panel is sent by a parent (normally the view). This notification can be used to switch to any desired tab page as part of a beginning_of_panel event. These events are most often triggered by a clear or a save.

By default this method brings the tab page number stored in the default_tab property back to the top. The code in the package looks like this:

Procedure OnBeginningOfPanel integer hoPanel
   // note if default tab is -1, this behavior is stopped
   if (Button_Count(self) and Default_Tab(self)>=0) ;
            send Request_Tab_display
end_procedure

By default, default_tab is 0 so this will cause the first tab page to be displayed.

This method can be augmented to change the behavior as you wish. Note that setting the default_tab property of the tab-dialog to -1 will disable this behavior.

To see this behavior try running the customer view with tab dialogs. When you press clear, the first tab page is restored.

Last Edited: September 10, 2003


TabDialog [Event OnDisplay]

OnDisplay - TabDialog

Type: Event

Parameters: No Parameters

Description

Last Edited: February 13, 2003


TabDialog [Event OnResize]

OnResize - TabDialog

Fires when the tab-dialog is created and whenever it is resized

Type: Event

Parameters: No Parameters

Description

OnResize fires when the tab-dialog is created and whenever it is resized.

Last Edited: September 10, 2003


Events for TabDialog

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent to the tab-dialog when Beginning_of_panel is sent by a parent |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDisplay |  |
OnKillFocus | Sent whenever the object is about to lose the focus | TabDialog_
OnResize | Fires when the tab-dialog is created and whenever it is resized |
OnSetFocus | Sent whenever windows is about to give this object the focus | TabDialog_
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | TabDialog_
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | TabDialog_


Methods for TabDialog

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | TabDialog_
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Auto_Page | Procedure |  | DfBasetabDialog
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | TabDialog_
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | TabDialog_
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | TabDialog_
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | TabDialog_
Error_Help | Procedure | (Obsolete) | TabDialog_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | TabDialog_
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | TabDialog_
Help | Procedure |  | TabDialog_
Help_For_Help | Procedure | (Obsolete) | TabDialog_
Help_Index | Procedure | (Obsolete) | TabDialog_
Help_on_topic | Procedure | (Obsolete) | TabDialog_
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | TabDialog_
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | TabDialog_
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | TabDialog_
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Next_Tab | Procedure | Causes the next tab page to be displayed |
Request_Previous_Tab | Procedure | Causes the previous tab page to be displayed and take the focus |
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | TabDialog_
Request_Switch_To_Tab | Procedure | Displays and activates the requested tab# |
Request_Tab_Display | Procedure | Causes the selected tab page to be displayed but does not give the page the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | TabDialog_
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


TabDialog [Procedure Request_Next_Tab]

Request_Next_Tab - TabDialog

Causes the next tab page to be displayed

Type: Procedure

Parameters: integer Mode

Parameter Description
Mode Determines where focus will move to. Allowed values are:

Constant | Meaning
0 | Emulate keyboard navigation
1 | Emulate mouse navigation
2 | Force focus to tab button
3 | Force focus to control inside the tab page

Description

Request_next_tab causes the next tab page to be displayed. When no parameter is passed, it will use standard keyboard navigation rules to determine if the tab button or the first focusable object within the tab page should take the focus. Sending a mode of 2 will force the tab button to take the focus. Passing a value of 3 will force the first focusable object in the tab page to take the focus. The values 0 and 1 are private.

Last Edited: September 11, 2003


TabDialog [Procedure Request_Previous_Tab]

Request_Previous_Tab - TabDialog

Causes the previous tab page to be displayed and take the focus

Type: Procedure

Parameters: integer Mode

Parameter Description
Mode Determines where focus will move to. Allowed values are:

Constant | Meaning
0 | Emulate keyboard navigation
1 | Emulate mouse navigation
2 | Force focus to tab button
3 | Force focus to control inside the tab page

Description

Request_previous_tab causes the previous tab page to be displayed and take the focus. When no parameter is passed, it will use standard keyboard navigation rules to determine if the tab button or the first focusable object in the tab page should take the focus. Sending a mode of 2 will force the tab button to take the focus. Passing a mode of 3 will force the first focusable object in the tab page to take the focus. The values 0 and 1 are private.

Last Edited: September 11, 2003


TabDialog [Procedure Request_Switch_To_Tab]

Request_Switch_To_Tab - TabDialog

Displays and activates the requested tab#

Type: Procedure

Parameters: Integer tab# integer PointerMode

Parameter | Description
tab# | The tab item number
PointerMode Determines where focus will move to. Allowed values are:

Constant | Meaning
0 | Emulate keyboard navigation
1 | Emulate mouse navigation
2 | Force focus to tab button
3 | Force focus to control inside the tab page

Description

The Request_switch_to_tab procedure will display and activate the requested tab#. When no parameter is passed, you will get the error message "required message argument missing". Sending a mode value of 2 will force the tab button to take the focus. Passing a value of 3 will force the first focusable object in the tab page to take the focus. The values 0 and 1 are private.

Last Edited: September 11, 2003


TabDialog [Procedure Request_Tab_Display]

Request_Tab_Display - TabDialog

Causes the selected tab page to be displayed but does not give the page the focus

Type: Procedure

Parameters: integer iTab

Parameter | Description
iTab | The tab item number

Description

The Request_tab_display procedure will cause the selected tab page to be displayed but it will not give the page the focus. If iTab is not passed, or passed as -1, the default_tab is displayed.

Last Edited: September 11, 2003


Properties for TabDialog

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | TabDialog_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | TabDialog_
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Button_Count | Returns the number of tabs in this object |
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | TabDialog_
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Current_Tab | Returns the number of the tab in this object that has the focus |
Default_Tab | Determines what tab page will be displayed as a default |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | TabDialog_
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | TabDialog_
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | TabDialog_
Help_Keyword | Used to specify an object's context keyword | TabDialog_
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled | TabDialog_
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | TabDialog_
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | TabDialog_
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
MultiLine_State | Determines if tabs will wrap across multiple lines |
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
NumberOfRows | Returns the number of rows of tabs that are displayed |
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | TabDialog_
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | TabDialog_
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbFlatSeparators | Determines if separators are drawn |
pbHotTrack | Determines hot-tracking on the labels of the tab-pages |
pbResetPageOnActivate | Determines how a tab dialog should behave when the dialog takes the focus as part of forward keyboard activation |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peTabPosition | Determines if positions of the tabs are at the top or the bottom of the tab-dialog |
peTabStyle | Determines if tabs are displayed as tabs or buttons |
phoImageList | Permits images to be displayed on tab-pages |
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Pointer_only_State | Determines how tab buttons will respond to the mouse |
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | TabDialog_
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Rotate_Mode | Governs cursor movement on keyboard navigation when the Next key is pressed in the last object in a tab page |
Row_Offset | Determines the offset to the invoking item by number of rows | TabDialog_
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_Button_Mode | Governs the way tab button navigation is done with the keyboard and mouse (when pointer_only_state is True) |
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | TabDialog_
Tab_page_Id | Contains the object_ID of the tab_page object associated with each of this object's items |
TabWidth_Mode | Makes each tab just wide enough to display its label, all the same width on each line sufficient to fill the width of this object, or all the width of the widest tab in the object |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Tooltip_State |  | DfBasetabDialog
Tooltip_Value |  | DfBasetabDialog
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | TabDialog_
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


TabDialog [Property Button_Count]

Button_Count - TabDialog

Returns the number of tabs in this object

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Button_count property returns the number of tabs in this object.

Last Edited: July 30, 2003


TabDialog [Property Current_Tab]

Current_Tab - TabDialog

Returns the number of the tab in this object that has the focus

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Current_tab property returns the number of the tab in this object that has the focus. This returns the tab page's item number. Its object ID may be obtained by getting its tab_page_id.

Get Current_Tab to Itm
Get Tab_Page_Id Itm to ObjId

Last Edited: July 31, 2003


TabDialog [Property Default_Tab]

Default_Tab - TabDialog

Determines what tab page will be displayed as a default

Type: Property

Access: Read/Write

Data Type: Integer

Description

Default_Tab determines what tab page will be displayed as a default. This default tab page is displayed when the messages beginning_of_panel or Request_tab_display (with no parameter) are sent. It also may be displayed during forward keyboard navigation when pbResetPageOnActivate is true.

If the value is set to -1, no default tab page is selected and no page change will occur (this was added to 8.2)

Default is 0.

Last Edited: August 1, 2003


TabDialog [Property MultiLine_State]

MultiLine_State - TabDialog

Determines if tabs will wrap across multiple lines

Type: Property

Access: Read/Write

Data Type: Boolean

Description

By default, this object shows all the tabs in one line across the top of the control; if there are too many tabs to fit on one line, a spin control is displayed to navigate to the rest. The Multiline_state property, if set to true, will wrap the tabs across multiple lines.

Default is false.

Last Edited: January 12, 2006


TabDialog [Property NumberOfRows]

NumberOfRows - TabDialog

Returns the number of rows of tabs that are displayed

Type: Property

Access: Read-Only

Data Type: Integer

Description

The NumberOfRows property will return the number of rows of tabs that are displayed. If this object is not active, -1 will be returned

Last Edited: August 6, 2004


TabDialog [Property pbFlatSeparators]

pbFlatSeparators - TabDialog

Determines if separators are drawn

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the tab-dialog has its peTabStyle property set to tsFlatButtons, 3d-separators can be drawn between the buttons.

Set the pbFlatSeparators property to True, to draw the separators and False to remove them.

Default is false.

Last Edited: January 12, 2006


TabDialog [Property pbHotTrack]

pbHotTrack - TabDialog

Determines hot-tracking on the labels of the tab-pages

Type: Property

Access: Read/Write

Data Type: Boolean

Description

To enable hot-tracking on the labels of the tab-pages, set the pbHotTrack property to True.

Hot-tracking only operates if the peTabStyle property is set to tsTabs.

Design-time only: you cannot change the pbHotTrack property once the program is running.

Default is true.

Last Edited: January 12, 2006


TabDialog [Property pbResetPageOnActivate]

pbResetPageOnActivate - TabDialog

Determines how a tab dialog should behave when the dialog takes the focus as part of forward keyboard activation

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbResetPageOnActivate determines how a tab dialog should behave when the dialog takes the focus as part of forward keyboard activation. If this property is false the tab page that is currently active will take the focus. This is how VDF has always behaved.

If the property is true, the tab page identified by the property default_tab will be brought forward.

For example, if pbResetPageOnActivate is True and default_tab is 0, navigating into the tab dialog by pressing the tab key will cause the first focusable item in the first tab page to take the focus. If the first tab page was not already visible it will first be displayed.

Default is false.

Last Edited: January 12, 2006


TabDialog [Property peTabPosition]

peTabPosition - TabDialog

Determines if positions of the tabs are at the top or the bottom of the tab-dialog

Type: Property

Access: Read/Write

Data Type: Integer

Description

The position of the tabs can be on the top or the bottom of the tab-dialog.

To display them on the top, set the peTabPosition property to tpTop; to display them on the bottom set this property to tpBottom

Note: Setting peTabPosition to tpBottom will set the peTabStyle property to tsTabs, as windows does not support buttons or flat buttons on the bottom of the tab-dialog.

Default is tpTop.

Last Edited: September 11, 2003


TabDialog [Property peTabStyle]

peTabStyle - TabDialog

Determines if tabs are displayed as tabs or buttons

Type: Property

Access: Read/Write

Data Type: Integer

Description

The position of the tabs can be on the top or the bottom of the tab-dialog.

To display them on the top, set the peTabStyle property to tpTop; to display them on the bottom set this property to tpBottom

The tabs can be displayed as regular tabs, buttons or flat buttons.

To display them as tabs, set the peTabStyle property to tsTabs; to display them as buttons, set it to tbButtons; to set it to flat buttons, set it to tbFlatButtons.

Note: Setting peTabStyle to either tsButtons or tbFlatButtons will set the peTabPosition property to tpTop, as windows does not support buttons or flat buttons on the bottom of the tab-dialog.

Default is tsTabs.

Last Edited: September 11, 2003


TabDialog [Property phoImageList]

phoImageList - TabDialog

Permits images to be displayed on tab-pages

Type: Property

Access: Read/Write

Data Type: Integer

Description

To permit images to be displayed on tab-pages, you need to assign an imagelist to the tab-dialog.

Set the phoImageList property to the object-handle of a cImageList instance.

Design-time only: you cannot change this property once the program is running.

Last Edited: September 11, 2003


TabDialog [Property Pointer_only_State]

Pointer_only_State - TabDialog

Determines how tab buttons will respond to the mouse

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Pointer_only_state determines how tab buttons will respond to the mouse. When set to true, the tab button will never take the focus. Clicking on a tab button will cause the tab page to be displayed and for the focus to be moved to the first focusable object in the page. This is a non standard windows behavior but may be useful in some data entry conditions.

When false, the default, button or the first focusable object will take the focus based on the setting of skip_button_mode which when set to SBM_smart will provide standard windows button navigation behavior.

Default is false.

Last Edited: January 12, 2006


TabDialog [Property Rotate_Mode]

Rotate_Mode - TabDialog

Governs cursor movement on keyboard navigation when the Next key is pressed in the last object in a tab page

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Rotate_mode property governs cursor movement on keyboard navigation when the Next key is pressed in the last object in a tab page.

When set to RM_None, the default, the focus will rotate out of the tab page and on to the next object. When set to RM_Ring, the focus will rotate in a ring within the current tab page moving either to the tab button or the first focusable object within the page (determined by skip_button_mode).

When set to RM_Rotate_in_Ring, the focus will rotate through all objects in all tab pages and then ring back to the first (or last) tab page.

When set to RM_Rotate, it rotates through the pages in this object, and then out of the tab dialog after the last tab page (or before the first tab page).

Default is RM_None.

Last Edited: September 11, 2003


TabDialog [Property Skip_Button_Mode]

Skip_Button_Mode - TabDialog

Governs the way tab button navigation is done with the keyboard and mouse (when pointer_only_state is True)

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Skip_Button_Mode property governs the way tab button navigation is done with the keyboard and mouse (when Pointer_Only_State is True).

In its default state of SBM_SMART, the navigation follows standard Windows behavior, which while easy to use, is actually difficult to explain. When moving from an object on the tab page to its tab button, the tab button will take the focus. When moving from an object on the tab page to a tab button on a different page, the new page will be displayed and the first focusable object in the page will receive the focus. When moving from a tab button to another tab button, the new page will be displayed and the tab button will take the focus. This sounds complicated, but feels intuitive to users, and it is a standard behavior.

When set to SBM_NEVER, the tab button will never be skipped (it always takes the focus).

When set to SBM_ALWAYS, the tab button will always be skipped (it never takes the focus).

Default is SBM_SMART.

Last Edited: February 17, 2004


TabDialog [Property Tab_page_Id]

Tab_page_Id - TabDialog

Contains the object_ID of the tab_page object associated with each of this object's items

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer item# integer Obj#

Parameter | Description
item# | The item number
Obj# | The object number

Description

The Tab_page_id property contains the object_ID of the tab_page object associated with each of this object's items (tabs).

Last Edited: September 11, 2003


TabDialog [Property TabWidth_Mode]

TabWidth_Mode - TabDialog

Makes each tab just wide enough to display its label, all the same width on each line sufficient to fill the width of this object, or all the width of the widest tab in the object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Tabwidth_mode makes each tab just wide enough to display its label (TWRAGGEDRIGHT), all the same width on each line sufficient to fill the width of this object (TWRIGHTJUSTIFY) (if multiline_state is true), or all the width of the widest tab (TWFIXEDWIDTH) in the object.

Default is TWRAGGEDRIGHT.

Last Edited: September 11, 2003


TabDialog_ [Event OnBeginningOfPanel]

OnBeginningOfPanel - TabDialog_

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


TabDialog_ [Event OnKillFocus]

OnKillFocus - TabDialog_

Sent whenever the object is about to lose the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever the object is about to lose the focus. The focus will be moved to another DataFlex object or to another Windows object. This is a notification message. There is no way you can cancel the event.

Last Edited: September 10, 2003


TabDialog_ [Event OnSetFocus]

OnSetFocus - TabDialog_

Sent whenever windows is about to give this object the focus

Type: Event

Parameters: No Parameters

Description

This event message is sent whenever windows is about to give this object the focus. This is a notification message. You cannot cancel this event.

Last Edited: September 10, 2003


TabDialog_ [Event Prompt_Callback]

Prompt_Callback - TabDialog_

Sends a callback event to an object that requested a prompt object

Type: Event

Parameters: integer hPrompt

Parameter | Description
hPrompt | handle of prompt object being invoked (usually a dbList)

Description

When dbList objects are used as popups (move_value_state = true) they send a callback message to their invoking object. This message, Prompt_Callback, is passed the object handle of the dbList object. This message must be understood by the invoking object. This can be used to customize the dbList for the particular invoking object. This enables you to use a single selection list for multiple purposes. Normally, this message sets properties in the dbList

The properties most-often affected within a dbList will be:

Server
Auto_Server_State
Deferred_State
Initial_Column
Export_Column
Auto_Column_State
Seed_List_State
Export_Item_State
Auto_Export_State
Auto_Index_State
Ordering
Display_Buffer_msg
Load_Buffer_msg

If any of these properties is changed by Prompt_Callback, the dbList will automatically restore them when the list is deactivated. This way, the normal behavior of the list will not be altered when it is used by other invoking objects. If you need to change other properties, you will have to store and restore the original property values (see store_defaults and restore_defaults in dblist).
In the following example, a form uses the customer_sl prompt list. It initializes in the customer name and returns the name:

Object oMyForm is a Form
    :
    Set Prompt_object to oCustomerSL

    Procedure Prompt_Callback integer hoPrompt
        Set Initial_Column of hoPrompt to 1  // col 1 is Name. Start there!
        Set Export_column of hoPrompt to 1
    End_Procedure
End_Object

Last Edited: June 20, 2005


TabDialog_ [Event Shadow_Display]

Shadow_Display - TabDialog_

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for TabDialog_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnKillFocus | Sent whenever the object is about to lose the focus |
OnSetFocus | Sent whenever windows is about to give this object the focus |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object |
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |


TabDialog_ [Function Next_Object_Id]

Next_Object_Id - TabDialog_

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


TabDialog_ [Function Prior_Object_Id]

Prior_Object_Id - TabDialog_

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for TabDialog_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Auto_Page | Procedure |  | DfBasetabDialog
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Error_Help | Procedure | (Obsolete) |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) |
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) |
Help | Procedure |  |
Help_For_Help | Procedure | (Obsolete) |
Help_Index | Procedure | (Obsolete) |
Help_on_topic | Procedure | (Obsolete) |
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) |
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus |
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


TabDialog_ [Procedure Activate_Area]

Activate_Area - TabDialog_

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


TabDialog_ [Procedure Beginning_of_Panel]

Beginning_of_Panel - TabDialog_

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


TabDialog_ [Procedure Bottom_of_Panel]

Bottom_of_Panel - TabDialog_

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


TabDialog_ [Procedure DoHtmlHelp]

DoHtmlHelp - TabDialog_

Launches Compiled HTML Help

Type: Procedure

Parameters: No Parameters

Description

Launches Compiled HTML Help.

First searches first for a context id and then for a keyword. If no context id is defined, it launches the table of contents (TOC).

Last Edited: December 2, 2004


TabDialog_ [Procedure End_of_Panel]

End_of_Panel - TabDialog_

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


TabDialog_ [Procedure Error_Help]

Error_Help - TabDialog_

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


TabDialog_ [Procedure Extended_Help]

Extended_Help - TabDialog_

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


TabDialog_ [Procedure File_Help]

File_Help - TabDialog_

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


TabDialog_ [Procedure Help]

Help - TabDialog_

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


TabDialog_ [Procedure Help_For_Help]

Help_For_Help - TabDialog_

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


TabDialog_ [Procedure Help_Index]

Help_Index - TabDialog_

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


TabDialog_ [Procedure Help_on_topic]

Help_on_topic - TabDialog_

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


TabDialog_ [Procedure Keys_Help]

Keys_Help - TabDialog_

Type: Procedure

Obsolete

Parameters: No Parameters

Description

Last Edited: August 12, 2003


TabDialog_ [Procedure Request_Status_Help]

Request_Status_Help - TabDialog_

Sent when an object is about to take or lose the focus

Type: Procedure

Parameters: Integer Fg

Parameter | Description
Fg | True if adding Status help, False if removing status help

Description

The Request_Status_Help message is sent when an object is about to take or lose the focus. When the object is about to take the focus (flag is true), this message will attempt to display status help for this object. It does this by getting the status-bar object ID and sending the message show_status_help to the status-bar object, passing it the object's status_help value.

Last Edited: September 25, 2003


TabDialog_ [Procedure Top_of_Panel]

Top_of_Panel - TabDialog_

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for TabDialog_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true |
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object |
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns |
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID |
Help_Keyword | Used to specify an object's context keyword |
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program |
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  |
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. |
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows |
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Tooltip_State |  | DfBasetabDialog
Tooltip_Value |  | DfBasetabDialog
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty |
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


TabDialog_ [Property Auto_Locate_State]

Auto_Locate_State - TabDialog_

Locates itself relative to any item that invokes it with a popup message when set true

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Auto_Locate_State property is true, this object will locate itself relative to any item that invokes it with a popup message (i.e., relative to the position of the cursor in another object when the prompt key was pressed). The position at which this object pops up depends on the values of its column_offset and row_offset properties.

This property exists primarily for backwards compatibility. You are encouraged to use the more powerful locate_mode property in its place.

Default is false.

Last Edited: January 12, 2006


TabDialog_ [Property Bitmap]

Bitmap - TabDialog_

Displays a bitmap in an object

Type: Property

Access: Read/Write

Data Type: String

Description

The Bitmap message will display a bitmap in an object. In other words, the bitmap becomes the background of the object.
Bitmap_Style determines how and where the bitmap will display in the object.

There are two potential drawbacks to using bitmaps: the amount of storage (on disk) , and the constant memory consumption.

Sample

This sample sets the bitmap to "MyBitmap.bmp".

set Bitmap to "MyBitmap.bmp"

Note:
In order to make a cohesive application, Visual DataFlex must find the .EXE file and the .bmp (bitmap) file, by using DFPATH.

Last Edited: November 24, 2004


TabDialog_ [Property Column_Offset]

Column_Offset - TabDialog_

Determines the offset to the invoking item by number of columns

Type: Property

Access: Read/Write

Data Type: Integer

Description

If this object is located using POPUP_LOCATE logic (or auto_locate_state is true), it will pop up to the right of the invoking item by the number of columns in the Column_Offset property and below it by the number of rows in row_offset. This property may have a negative, as well as positive, value. The offset is stated as a number of characters, these being of an averaged size for the font currently in effect.

Default is 2.

Last Edited: August 5, 2003


TabDialog_ [Property Enabled_State]

Enabled_State - TabDialog_

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


TabDialog_ [Property Explicit_Shadow_State]

Explicit_Shadow_State - TabDialog_

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


TabDialog_ [Property Help_id]

Help_id - TabDialog_

Used to specify an object's context ID

Type: Property

Access: Read/Write

Data Type: Integer

Description

This property is used to specify an object's context ID. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Usually the context IDs are defined in advance and represented as symbolics.

#REPLACE HLP_Vendor_Address_Help  2020
:
Object Vendor_Address is a dbForm
    Set location to 10 70
    Set size to 13 100
    Entry_item Vendor.Address
    Set Label to "Address"
    Set Help_id to HLP_Vendor_Address_Help
End_Object

Last Edited: August 18, 2003


TabDialog_ [Property Help_Keyword]

Help_Keyword - TabDialog_

Used to specify an object's context keyword

Type: Property

Access: Read/Write

Data Type: String

Description

The Help_Keyword property is used to specify an object's context keyword. You must set it.

When help is invoked by sending the message help to an object, the object will try to find a context. It will first check to see if the object has a help_id assigned. If not, it will check to see if a help_keyword has been assigned. If both are unassigned it will delegate and check to see if context is provided for the parent object. This continues until a help context is provided or there are no more parent objects. This allows you do define your context help at a very specific level (the object) to a very general level (the view or the application)

Assigning a help_id context is more flexible way to assign help. One would rarely mix help_id and help_keyword contexts within a single application.

Last Edited: August 18, 2003


TabDialog_ [Property Item_Shadow_State]

Item_Shadow_State - TabDialog_

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


TabDialog_ [Property Label]

Label - TabDialog_

This is the text that appears within this control

Type: Property

Access: Read/Write

Data Type: String

Description

This is the text that appears within this control. It can be set and queried through this property.

When used with the Button class, this sets the text within the button.

When used with the CheckBox class, this sets the text that appears to the right of the checkbox.

When used with the TextBox class, this sets the text that appears inside of the textbox.

When used with containers (Panel, Group, dbGroup), this sets the text that appears in the container.

See Also

Button | CheckBox | TextBox | Panel | Group | dbGroup

Last Edited: August 18, 2003


TabDialog_ [Property Locate_Mode]

Locate_Mode - TabDialog_

Provides several flexible methods for auto positioning container panels in your program

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Locate_Mode property provides several flexible methods for auto positioning container panels in your program. The following modes are supported:

Constant | Meaning
NO_LOCATE | No auto-location is performed. The object must be manually located by using the set location message.
POPUP_LOCATE | This causes the object to locate itself relative to the object (and item) that invoked it. It is ideal for locating popup modal objects (like selection-lists). The position at which this object pops up depends on the values of its column_offset and row_offset properties.
CENTER_ON_SCREEN | This causes the container to appear in the center of the screen.
CENTER_ON_PANEL | This causes the container to centered within the current main program panel.
CENTER_ON_PARENT | This causes the container to appear in the center of its parent container.
SMART_LOCATE | This mode "just does the right thing". This message will cause the object to apply the best locating strategy for current conditions. If the object is a modal popup (modal_state is true) and there is an invoking object it will locate relative to the invoking object (popup_locate), else, if the object already has been assigned a location it will use that location. else, if main-panel exists it will center within that panel (center_on_panel), else, it will center itself on the screen (center_on_screen). All panels default to this mode. This causes modal popup panels to locate relative to their parent and modeless panels to appeared centered unless explicitly located.

Default is SMART_LOCATE.

Last Edited: September 10, 2004


TabDialog_ [Property Object_Shadow_State]

Object_Shadow_State - TabDialog_

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


TabDialog_ [Property Offset_Location]

Offset_Location - TabDialog_

Type: Property

Access: Write-Only

Data Type: Integer

Parameters: integer Row# Integer Col#

Parameter | Description
Row# | [ToDo: In Progress]
Col# | [ToDo: In Progress]

Description

Last Edited: July 8, 2003


TabDialog_ [Property psHtmlHelpTopic]

psHtmlHelpTopic - TabDialog_

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

Type: Property

Access: Read/Write

Data Type: String

Description

Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page.

The topic is an HTML page that is part of the help file for your application, meaning it is compiled into a compiled HTML Help (CHM) file, which should be set via psHelpFile.

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm'.

set psHtmlHelpTopic to "MyHelpTopic.htm"

Sample

This sample sets psHtmlHelpTopic to help topic 'MyHelpTopic.htm', and bookmark 'Bookmark1' on that page.

set psHtmlHelpTopic to "MyHelpTopic.htm#Bookmark1"

Last Edited: September 8, 2005


TabDialog_ [Property Row_Offset]

Row_Offset - TabDialog_

Determines the offset to the invoking item by number of rows

Type: Property

Access: Read/Write

Data Type: Integer

Description

If this object is located using POPUP_LOCATE logic (or auto_locate_state is true), it will pop up to the right of the invoking item by the number of columns in column_offset and below it by the number of rows in the Row_Offset property. This property may have a negative, as well as positive, value. This offset is stated as a number of rows, these being the row height for the font currently in effect.

Default is 1.

Last Edited: September 11, 2003


TabDialog_ [Property Status_Help]

Status_Help - TabDialog_

Determines the status text that will be displayed when this object takes the focus

Type: Property

Access: Read/Write

Data Type: String

Parameters: String Item# String Shelp

Parameter | Description
Item# | The item number
Shelp | The status help text

Description

This is the status-bar help text for the object. This determines the status text that will be displayed when this object takes the focus. Normally the setting of this property is the only step required to produce status-help for this object. With single item objects the text is the only information passed with this message. This message is augmented in multi-item objects to require both an item number and status-text. Normally, you will set and not get this property.

Set Status_Help to "Please enter your User ID" // single-item status

Set Status_Help item 3 to "Please enter your User ID" // multi-item status

If the local status help value is blank and the object's use_parent_status_help property is true, the parent object's status_help value will be returned (which, in turn, may return its parent's status_help value).

Last Edited: September 11, 2003


TabDialog_ [Property Use_Parent_Status_Help]

Use_Parent_Status_Help - TabDialog_

Determines if parent's status help is used when object status help is empty

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If an object or an item does not have its own status-bar help, the status help of the parent object will be used when this property is true.

Last Edited: January 12, 2006


TabPage [Event OnResize]

OnResize - TabPage

Fires when the tab-page is created and whenever it is resized

Type: Event

Parameters: No Parameters

Description

OnResize fires when the tab-page is created and whenever it is resized.

Last Edited: September 10, 2003


Events for TabPage

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnResize | Fires when the tab-page is created and whenever it is resized |
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d


Methods for TabPage

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for TabPage

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Button_Shadow_State | Determines if both the page and the button will be shadowed |
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label |  |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
pbHighlightTab | Highlights the tab, using the Windows clHighlight color |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piImageIndex | The index of the image from the tab-dialog's imagelist |
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Tab_Button_item | Contains this tab-page's item number |
Tab_ToolTip_Value | Sets the text that is displayed as a tool tip for this object's tab in the container tab-dialog object |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


TabPage [Property Button_Shadow_State]

Button_Shadow_State - TabPage

Determines if both the page and the button will be shadowed

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Button_shadow_state property is set true, both the page and the button will be shadowed, making it impossible to ever display the shadowed tab page.

Default is false.

Last Edited: January 12, 2006


TabPage [Property Label]

Label - TabPage

Type: Property

Access: Write-Only

Data Type: String

Description

Last Edited: February 13, 2003


TabPage [Property pbHighlightTab]

pbHighlightTab - TabPage

Highlights the tab, using the Windows clHighlight color

Type: Property

Access: Read/Write

Data Type: Boolean

Description

pbHighlightTab highlights the tab, using the Windows clHighlight color.

Default is false.

Last Edited: January 16, 2006


TabPage [Property piImageIndex]

piImageIndex - TabPage

The index of the image from the tab-dialog's imagelist

Type: Property

Access: Read/Write

Data Type: Integer

Description

piImageIndex is the index of the image from the tab-dialog's imagelist. Before images can be displayed, the phoImageList property of the tab-dialog must be set the object-handle of a cImageList-derived object.

Default is 0.

Last Edited: September 11, 2003


TabPage [Property Tab_Button_item]

Tab_Button_item - TabPage

Contains this tab-page's item number

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Tab_button_item property contains this tab-page's item number. The parent tab-dialog object keeps track of each tab-age with an item number. This property may not be set.

Default is 1.

Last Edited: September 11, 2003


TabPage [Property Tab_ToolTip_Value]

Tab_ToolTip_Value - TabPage

Sets the text that is displayed as a tool tip for this object's tab in the container tab-dialog object

Type: Property

Access: Read/Write

Data Type: String

Description

The Tab_tooltip_value property sets the text that is displayed as a tool tip for this object's tab in the container tab-dialog object.

Default is "text".

Last Edited: September 11, 2003


TextBox [Event OnBeginningOfPanel]

OnBeginningOfPanel - TextBox

Sent by panel to notify all its objects when a beginning_of_panel message is executed

Type: Event

Parameters: integer hoPanel

Parameter | Description
hoPanel | The handle of the panel object

Description

When a beginning_of_panel message is executed the panel will notify all its objects by sending the message OnBeginningOfPanel. By default this does nothing. DbGrids, dbLists and TabDialogs use this message to perform special changes.

You can augment this method to perform any desired initialization required by a beginning of panel event.

Last Edited: September 10, 2003


TextBox [Event Shadow_Display]

Shadow_Display - TextBox

Called whenever a change in shadow state occurs, or when an object is paged

Type: Event

Parameters: No Parameters

Description

The Shadow_Display event is called whenever a change in shadow state occurs, or when an object is paged. It is used to properly set the display to reflect an enterable or non-enterable object. By default, this sets visual attributes that are consistent with enabled and non-enabled objects in Windows. You may use this to set other custom conditions. This message should be forwarded. This message is meant to be used as part of object shadowing and not item shadowing.

When augmenting this procedure, you may access the current shadow condition of the object by querying the enabled_state property and in more-unusual conditions, the implicit_shadow_state and explicit_shadow_state properties.

Last Edited: September 11, 2003


Events for TextBox

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed |
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged |


TextBox [Function Next_Object_Id]

Next_Object_Id - TextBox

Called by the switch message to determine the object_id of the next object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | bNoDescend controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Next_object_id function is called by the switch message to determine the object_id of the next object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the next object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Prior_object_id | OnChildWrapping

Last Edited: September 25, 2003


TextBox [Function Prior_Object_Id]

Prior_Object_Id - TextBox

Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree

Type: Function

Return Data Type: Integer

Parameters: integer bNoDescend

Parameter | Description
bNoDescend | Controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

Return Value

If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Description

The Prior_object_id function is called by the switch_back message to determine the object handle of the previous object to go to in the focus tree. The message is sent to the current object, which may use this message to change the destination of a navigation if necessary. The bNoDescend flag controls whether the search for the prior object will descend levels of the focus tree. If it is false, the descent will take place.

The messages next_object_id and prior_object_id are used to determine what the next or prior object would be for keyboard navigation. They are called by the next and previous messages to change focus. You should also be able to call them to figure out where the focus should be. If a value is returned, that's the object to move to. If zero is returned, no focus change should take place.

Prior to VDF8.2, a return of zero, sometimes meant "no focus change" and it sometimes meant, "a focus change has taken place". This was a bad design. You would send a message to get the next object and instead of getting an object, a focus event might take place. This occurred because these messages sent child_wrapping and our packages used this to occasionally perform focus changes. Child_wrapping would change the focus and return 1, which caused the next_object_id and prior_object_id to return 0. You had no way to determine what that return of 0 actually meant.

In 8.2 we no longer use child_wrapping for this purpose (actually we do not use it at all). Instead we use a new method named OnChildWrapping. OnChildWrapping never changes the focus; it returns an object handle that indicates where the focus should go. The next_object_id / prior_object_id messages use this so it can determine where the next focus will be.

This means that next_object_id / prior_object_id will never change the focus any more. They return a value that indicates where the focus ought to go. If 0 is returned, a focus change is not possible. Therefore you can always safely call these methods without worrying that the focus might get changed without you knowing it.

IMPORTANT NOTE: Child_wrapping is now obsolete. It still works but you should use the new message OnChildWrapping.

See Also

Next_object_id | OnChildWrapping

Last Edited: September 25, 2003


Methods for TextBox

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  |
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy |
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any |
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree |
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


TextBox [Procedure Activate_Area]

Activate_Area - TextBox

Type: Procedure

Parameters: Integer TakeFocusFg

Parameter | Description
TakeFocusFg | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


TextBox [Procedure Beginning_of_Panel]

Beginning_of_Panel - TextBox

Gives the focus to the first item in the first object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

Beginning_of_panel gives the focus to the first item in the first object in the current parent-child hierarchy. Sends top_of_panel or, if parent exists and this object is not a scope, delegates beginning_of_panel.

Last Edited: July 30, 2003


TextBox [Procedure Bottom_of_Panel]

Bottom_of_Panel - TextBox

Activates the last child object of this object that is a DEO, if any

Type: Procedure

Parameters: No Parameters

Description

Bottom_of_panel activates the last child object of this object that is a DEO, if any. If none, activates this object. Sent by end_of_panel.

Last Edited: July 30, 2003


TextBox [Procedure End_of_Panel]

End_of_Panel - TextBox

Gives the focus to the last item in the last object in the current parent-child hierarchy

Type: Procedure

Parameters: No Parameters

Description

End_of_panel gives the focus to the last item in the last object in the current parent-child hierarchy. Uses bottom_of_panel and may delegate end_of_panel if parent exists and this object is neither a scope nor ringed.

Last Edited: August 5, 2003


TextBox [Procedure Top_of_Panel]

Top_of_Panel - TextBox

Activates the first child object of this object that is a DEO, if any; else activates this object

Type: Procedure

Parameters: No Parameters

Description

Top_of_panel activates the first child object of this object that is a DEO, if any; else activates this object.

Last Edited: September 11, 2003


Properties for TextBox

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Size_State | Determines if textbox object will automatically size itself |
Bitmap | Displays a bitmap in an object |
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled |
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor |
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Shadow_State | Determines if an object's item is enabled or disabled |
Justification_Mode | Aligns the text in the control | DfBaseTextbox
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control |
Label_Shadow_Display_Mode | Controls under what conditions this object is shadowed |
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Location | Determines the position of the upper left character of the object's window | cUIObject
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's |
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value |  | DfBaseWindow
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


TextBox [Property Auto_Size_State]

Auto_Size_State - TextBox

Determines if textbox object will automatically size itself

Type: Property

Access: Read/Write

Data Type: Boolean

Description

By default a textbox objects automatically sizes itself based on the length of the label text. If the Auto_size_state property is set false, this object will not auto-size.

Default is true.

Last Edited: January 12, 2006


TextBox [Property Bitmap]

Bitmap - TextBox

Displays a bitmap in an object

Type: Property

Access: Read/Write

Data Type: String

Description

The Bitmap message will display a bitmap in an object. In other words, the bitmap becomes the background of the object.
Bitmap_Style determines how and where the bitmap will display in the object.

There are two potential drawbacks to using bitmaps: the amount of storage (on disk) , and the constant memory consumption.

Sample

This sample sets the bitmap to "MyBitmap.bmp".

set Bitmap to "MyBitmap.bmp"

Note:
In order to make a cohesive application, Visual DataFlex must find the .EXE file and the .bmp (bitmap) file, by using DFPATH.

Last Edited: November 24, 2004


TextBox [Property Enabled_State]

Enabled_State - TextBox

Determines if an object is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Boolean

Description

When the Enabled_State property is set false, users cannot perform data entry through this object, and the object is displayed with the shadowed attribute. All descendant objects are also shadowed and are similarly disabled. When it is set true, the object is displayed normally and users can perform data entry, unless an ancestor of this object has its enabled_state set false, in which case this object behaves in all ways as though shadowed, including returning false for this property.

Default is true.

Last Edited: January 12, 2006


TextBox [Property Explicit_Shadow_State]

Explicit_Shadow_State - TextBox

Indicates if an object is contextually shadowed by an ancestor

Type: Property

Access: Read-Only

Data Type: Boolean

Description

Explicit_Shadow_State indicates if an object is contextually shadowed by an ancestor. This property should not be set.

Default is false.

Last Edited: August 5, 2003


TextBox [Property Item_Shadow_State]

Item_Shadow_State - TextBox

Determines if an object's item is enabled or disabled

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: integer iItem integer iState

Parameter | Description
iItem | The item number
iState | The state of the item iItem

Description

When the Item_Shadow_State property is set true, users cannot perform data entry through this item, and the item is displayed with the shadowed attribute. When it is in its default false state, the item is displayed normally and users can perform data entry, unless this object or an ancestor of this object has its enabled_state set false, in which case all items of this object are shadowed. This property is only used with multi-item objects.

Last Edited: August 18, 2003


TextBox [Property Label]

Label - TextBox

This is the text that appears within this control

Type: Property

Access: Read/Write

Data Type: String

Description

This is the text that appears within this control. It can be set and queried through this property.

When used with the Button class, this sets the text within the button.

When used with the CheckBox class, this sets the text that appears to the right of the checkbox.

When used with the TextBox class, this sets the text that appears inside of the textbox.

When used with containers (Panel, Group, dbGroup), this sets the text that appears in the container.

See Also

Button | CheckBox | TextBox | Panel | Group | dbGroup

Last Edited: August 18, 2003


TextBox [Property Label_Shadow_Display_Mode]

Label_Shadow_Display_Mode - TextBox

Controls under what conditions this object is shadowed

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Label_shadow_display_mode property controls under what conditions this object is shadowed. The values are:

Constant | Meaning
TBSHADOW_ON_GROUP | Visually shadow text if object is contextually shadowed (by ancestor). This is the default value
TBSHADOW_ON_NONE | Never visually shadow the text
TBSHADOW_ON_LOCAL | Visually shadow text if object is inherently shadowed
TBSHADOW_ON_ALL | Visually shadow text whenever the object is shadowed

Default is TBSHADOW_ON_GROUP.

Last Edited: August 18, 2003


TextBox [Property Object_Shadow_State]

Object_Shadow_State - TextBox

Replaced by enabled_state, whose boolean logic is the inverse of this property's

Type: Property

Access: Read/Write

Data Type: Integer

Description

Replaced by enabled_state, whose boolean logic is the inverse of this property's.

Default is false.

Last Edited: September 10, 2003


Events for ToolPanel

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


Methods for ToolPanel

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  | FloatingPanel
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for ToolPanel

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


TrackBar [Event OnFinishedSliding]

OnFinishedSliding - TrackBar

Sent whenever the slider has stopped moving by either the mouse or keyboard interface

Type: Event

Parameters: No Parameters

Description

The OnFinishedSliding message is sent whenever the slider has stopped moving by either the mouse or keyboard interface.

Last Edited: September 10, 2003


TrackBar [Event OnGoneToEnd]

OnGoneToEnd - TrackBar

Sent when a user pressed the End key to take the slider to the end

Type: Event

Parameters: No Parameters

Description

The OnGoneToEnd event is sent when a user pressed the End key to take the slider to the end. At this point Current_Position will equal Maximum_Position.

Last Edited: September 10, 2003


TrackBar [Event OnGoneToStart]

OnGoneToStart - TrackBar

Sent when a user pressed the Home key to return the slider to the beginning of the track

Type: Event

Parameters: No Parameters

Description

The OnGoneToStart event is sent when a user pressed the Home key to return the slider to the beginning of the track. At this point Current_Position will equal Minimum_Position.

Last Edited: September 10, 2003


TrackBar [Event OnLineDown]

OnLineDown - TrackBar

Sent when a user presses one of the arrow keys to increment the Current_Position by the value of Line_Size

Type: Event

Parameters: No Parameters

Description

The OnLineDown message is sent when a user presses one of the arrow keys to increment the Current_Position by the value of Line_Size.

Last Edited: September 10, 2003


TrackBar [Event OnLineUp]

OnLineUp - TrackBar

Sent when a user presses one of the arrow keys todecrement the Current_Position by the value of Line_Size

Type: Event

Parameters: No Parameters

Description

The OnLineUp message is sent when a user presses one of the arrow keys to decrement the Current_Position by the value of Line_Size.

Last Edited: September 10, 2003


TrackBar [Event OnPageDown]

OnPageDown - TrackBar

Sent when a user presses the PageDown key to increment the Current_Position by the value of Page_Size

Type: Event

Parameters: No Parameters

Description

The OnPageDown message is sent when a user presses the PageDown key to increment the Current_Position by the value of Page_Size.

Last Edited: September 10, 2003


TrackBar [Event OnPageUp]

OnPageUp - TrackBar

Sent when a user presses the PageUp key to decrement the Current_Position by the value of Page_Size

Type: Event

Parameters: No Parameters

Description

The OnPageUp message is sent when a user presses the PageUp key to decrement the Current_Position by the value of Page_Size.

Last Edited: September 10, 2003


TrackBar [Event OnSetPosition]

OnSetPosition - TrackBar

Sent whenever the value of Current_Position changes

Type: Event

Parameters: No Parameters

Description

The OnSetPosition message is sent whenever the value of Current_Position changes.

Last Edited: September 10, 2003


TrackBar [Event OnSliding]

OnSliding - TrackBar

Sent when a user drags the slider with the mouse

Type: Event

Parameters: No Parameters

Description

The OnSliding message is sent when a user drags the slider with the mouse.

Last Edited: September 10, 2003


Events for TrackBar

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | Augmented to give the object the focus (if it is not already the focus object) and, if the focus is successful, to send the prompt message | Form
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Form
OnChange | Sent whenever the value of an item is changed either by the user (a keypress or mouse event) or by an explicit set value message | Form
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFinishedSliding | Sent whenever the slider has stopped moving by either the mouse or keyboard interface |
OnGoneToEnd | Sent when a user pressed the End key to take the slider to the end |
OnGoneToStart | Sent when a user pressed the Home key to return the slider to the beginning of the track |
OnKillFocus | Sent whenever the object is about to lose the focus | Form
OnLineDown | Sent when a user presses one of the arrow keys to increment the Current_Position by the value of Line_Size |
OnLineUp | Sent when a user presses one of the arrow keys todecrement the Current_Position by the value of Line_Size |
OnMaxText |  | Form
OnPageDown | Sent when a user presses the PageDown key to increment the Current_Position by the value of Page_Size |
OnPageUp | Sent when a user presses the PageUp key to decrement the Current_Position by the value of Page_Size |
OnSetFocus | Sent whenever windows is about to give this object the focus | Form
OnSetPosition | Sent whenever the value of Current_Position changes |
OnSliding | Sent when a user drags the slider with the mouse |
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Form
Shadow_Display | Creates the proper shadowed or unshadowed appearance for this object and its label | Form


Methods for TrackBar

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Form
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Form
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Form
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
ControlValueChanged | Procedure |  | FormExternalControl
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Create_Prompt_Button | Procedure | Creates or removes a prompt button | Form
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | Form
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Form
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Form
Error_Help | Procedure | (Obsolete) | Form
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Form
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Form
Help | Procedure |  | Form
Help_For_Help | Procedure | (Obsolete) | Form
Help_Index | Procedure | (Obsolete) | Form
Help_on_topic | Procedure | (Obsolete) | Form
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Form
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Form
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | Form
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Form
Prompt | Procedure | The default message sent by this object's prompt button | Form
RefreshControl | Procedure |  | FormExternalControl
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Form
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Form
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for TrackBar

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Capslock_State | Determines if all text entered to this object from the keyboard will be converted to upper case | Form
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
ControlValue |  |
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Position | Contains the absolute position of the slider |
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Form
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Form
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | Form
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Form
Help_Keyword | Used to specify an object's context keyword | Form
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled | Form
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | Form
Label_Col_Offset | The horizontal distance from the object to its label | Form
Label_Justification_Mode | The justification mode for the text within this object's label | Form
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | Form
Label_Row_Offset | The vertical distance from the top edge of the object and its label | Form
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Determines the amount the Current_Position changes whenever users move the slider by use of the arrow keys |
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Maintains the absolute value of the slider when it is slid to its maximum position |
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Maintains the absolute value of the slider when it is slid to its lowest position |
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Form
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Orientation_Mode | Specifies whether the control should be displayed horizontally or vertically |
Page_Size | Determines the amount the Current_Position changes whenever users move the slider by use of the PageUp or PageDown keys |
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbTooltips | Determines if tooltips should be displayed for this object |
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Button_Mode | Determines how and if a prompt button will appear within a entry form | Form
Prompt_Button_Value | Specifies the text displayed in the prompt button for this object | Form
Prompt_Object | Specifies the default receiving object for the popup message | Form
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Form
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Form
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Tick_Frequency | Maintains the increment at which to display tick marks |
Tick_Orientation | Specifies where the ticks should be placed in relation to the slider |
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Form
Value |  | FormExternalControl
Visible_State | Determines whether object is visible | cUIObject
Visible_Tick_State | Specifies whether tick marks are displayed in the control |
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


TrackBar [Property ControlValue]

ControlValue - TrackBar

Type: Property

Access: Read/Write

Data Type: String

Description

Last Edited: February 13, 2003


TrackBar [Property Current_Position]

Current_Position - TrackBar

Contains the absolute position of the slider

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Current_Position property contains the absolute position of the slider. The value is in the range of 0-65,535

Default is 0.

Last Edited: July 31, 2003


TrackBar [Property Line_Size]

Line_Size - TrackBar

Determines the amount the Current_Position changes whenever users move the slider by use of the arrow keys

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Line_Size property determines the amount the Current_Position changes whenever users move the slider by use of the arrow keys. The value is in the range of 0-65,535

Default is 1.

Last Edited: August 18, 2003


TrackBar [Property Maximum_Position]

Maximum_Position - TrackBar

Maintains the absolute value of the slider when it is slid to its maximum position

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Maximum_Position property maintains the absolute value of the slider when it is slid to its maximum position. The value is in the range of 0-65,535

Default is 100.

Last Edited: August 18, 2003


TrackBar [Property Minimum_Position]

Minimum_Position - TrackBar

Maintains the absolute value of the slider when it is slid to its lowest position

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Minimum_Position property maintains the absolute value of the slider when it is slid to its lowest position. The value is in the range of 0-65,535

Default is 0.

Last Edited: August 18, 2003


TrackBar [Property Orientation_Mode]

Orientation_Mode - TrackBar

Specifies whether the control should be displayed horizontally or vertically

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Orientation_Mode property specifies whether the control should be displayed horizontally or vertically.

Default is slHorz.

Last Edited: September 10, 2003


TrackBar [Property Page_Size]

Page_Size - TrackBar

Determines the amount the Current_Position changes whenever users move the slider by use of the PageUp or PageDown keys

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Page_Size property determines the amount the Current_Position changes whenever users move the slider by use of the PageUp or PageDown keys. The value is in the range of 0-65,535.

The default value means that users can 'page' five times from the minimum value to the maximum value.

Default is (maximum_value -minimum_value) /5.

Last Edited: September 10, 2003


TrackBar [Property pbTooltips]

pbTooltips - TrackBar

Determines if tooltips should be displayed for this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Set the pbTooltips property to True to display a tooltip, showing the value of the Current_Position property, whenever the slider is dragged with the mouse.

Note: You can only change this property at design-time. In other words, once the object has been created, any changes to this property will be ignored.

Default is true.

Last Edited: September 10, 2003


TrackBar [Property Tick_Frequency]

Tick_Frequency - TrackBar

Maintains the increment at which to display tick marks

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Tick_Frequency property maintains the increment at which to display tick marks. For example, using default values and a Tick_Frequency of 25, ticks would be placed at values 0, 25, 50, 75, 100. The value is in the range of 0-65,535

Default is 5.

Last Edited: September 11, 2003


TrackBar [Property Tick_Orientation]

Tick_Orientation - TrackBar

Specifies where the ticks should be placed in relation to the slider

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Tick_Orientation property specifies where the ticks should be placed in relation to the slider. tkTOP, for example, means on top of the control (assuming the control had an Orientation_Mode of slHorz). tkBoth means on top and on bottom (or on left and right if vertical). The slider box points in the direction of the ticks, unless they are on both sides of the control.

Default is tkTop.

Last Edited: September 11, 2003


TrackBar [Property Visible_Tick_State]

Visible_Tick_State - TrackBar

Specifies whether tick marks are displayed in the control

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Visible_Tick_State property specifies whether tick marks are displayed in the control.

Default is true.

Last Edited: January 12, 2006


TreeView [Event OnCreateTree]

OnCreateTree - TreeView

Populates the control with items

Type: Event

Parameters: No Parameters

Description

OnCreateTree is the key event of this class. This is the event that you use to populate the control with items. AddTreeItem can be used at any time "during or after" OnCreateTree. It can only be used when the control has been created. This event will fire whenever the control becomes visible, to rebuild the list.

Note that data in this object is created when the object is paged, and destroyed when the object is unpaged. If you are using tab dialogs a tree view object;s data is rebuilt each time the object is paged. This means that if you use this control inside a TabDialog control, this event will fire each time a user rotates the pages to display it, so you should avoid lengthy computations, if at all possible.

Last Edited: September 10, 2003


Events for TreeView

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginDrag | Whenever a user instigates a drag operation, this event is fired | AbstractTreeView
OnBeginLabelEdit | Fired just prior to the user starting in-line editing of the label | AbstractTreeView
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | List
OnBeginRDrag | Whenever the user instigates a drag operation, this event is fired | AbstractTreeView
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | List
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCreateTree | Populates the control with items |
OnDeleteItem | Whenever an item is deleted from the control, this event is fired | AbstractTreeView
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnEndLabelEdit | Fired if the user completes the edit when user performs in-line editing of the label | AbstractTreeView
OnGetDispInfo |  | AbstractTreeView
OnItemChanged | Fired whenever the current item has just changed | AbstractTreeView
OnItemChanging | Fired whenever the current item is about to change | AbstractTreeView
OnItemClick | Fired whenever a user clicks an item to make it become the current item | AbstractTreeView
OnItemCollapsed | Fired whenever a parent item has just been collapsed and its children hidden | AbstractTreeView
OnItemCollapsing | Fired whenever a parent item is about to be collapsed | AbstractTreeView
OnItemDblClick | Fired whenever a user double-clicks an item | AbstractTreeView
OnItemEnter | Fired whenever a user presses Enter on an item | AbstractTreeView
OnItemExpanded | Fired whenever a parent item has just been expanded to display its child items | AbstractTreeView
OnItemExpanding | Fired whenever an item is about to be opened | AbstractTreeView
OnItemRClick | Sent when a user clicks on an item | AbstractTreeView
OnItemRDblClick | Sent when a user double-clicks on an item | AbstractTreeView
OnKeyDown |  | AbstractTreeView
OnKillFocus | Sent whenever the object is about to lose the focus | List
OnSetDispInfo |  | AbstractTreeView
OnSetFocus | Sent whenever windows is about to give this object the focus | List
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | List
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | List


TreeView [Function ItemExpandedState]

ItemExpandedState - TreeView

Returns a boolean value indicating whether hItem is currently expande

Type: Function

Return Data Type: Integer

Parameters: Handle hItem

Parameter | Description
hItem | The item handle

Return Value

If no child items exist, it will return false.

Description

The ItemExpandedState function returns a boolean value indicating whether hItem is currently expanded. This function is only appropriate for items that have child items. You can determine whether an item has any child items by calling Get ItemChildCount.

Last Edited: August 18, 2003


Methods for TreeView

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | List
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
AddTreeItem | Function | Adds an entry to the treeview | AbstractTreeView
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | List
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | List
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoCollapseAll | Procedure | Programmatically collapses hItem and all its siblings |
DoCollapseItem | Procedure | Programmatically collapses hItem |
DoDeleteItem | Procedure | Deletes an item | AbstractTreeView
DoEnumerateTree | Procedure | Recurses the items in the control starting with the item you pass, hItem | AbstractTreeView
DoEnumerateTreeUp | Procedure | Recurses the items in the control starting with the item you pass, hItem | AbstractTreeView
DoExpandAll | Procedure | Expands the item represented by the hItem parameter and all its children |
DoExpandItem | Procedure | Expands hItem |
DoHtmlHelp | Procedure | Launches Compiled HTML Help | List
DoMakeItemFirstVisible | Procedure | Forces hItem to be placed at the top of the control |
DoMakeItemVisible | Procedure | Forces hItem to become visible |
DoReadTree | Procedure | Constructs a simple tree view by loading the values from an external file |
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | List
Error_Help | Procedure | (Obsolete) | List
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | List
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | List
Help | Procedure |  | List
Help_For_Help | Procedure | (Obsolete) | List
Help_Index | Procedure | (Obsolete) | List
Help_on_topic | Procedure | (Obsolete) | List
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
InsertTreeItem | Function |  | AbstractTreeView
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
ItemExpandedState | Function | Returns a boolean value indicating whether hItem is currently expande |
Keys_Help | Procedure | (Obsolete) | List
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | List
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | List
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | List
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set |  | List
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | List
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


TreeView [Procedure DoCollapseAll]

DoCollapseAll - TreeView

Programmatically collapses hItem and all its siblings

Type: Procedure

Parameters: Handle hItem

Parameter | Description
hItem | The handle of the item to be collapsed

Description

You should send the DoCollapseAll message to programmatically collapse hItem and all its siblings. If you want to collapse the whole tree, pass zero as hItem.

Last Edited: July 31, 2003


TreeView [Procedure DoCollapseItem]

DoCollapseItem - TreeView

Programmatically collapses hItem

Type: Procedure

Parameters: Handle hItem

Parameter | Description
hItem | The handle of the item to be collapsed

Description

You should send the DoCollapseItem message to programmatically collapse hItem.

See Also

DoCollapseAll

Last Edited: July 31, 2003


TreeView [Procedure DoExpandAll]

DoExpandAll - TreeView

Expands the item represented by the hItem parameter and all its children

Type: Procedure

Parameters: Handle hItem

Parameter | Description
hItem | The handle of the item to be expanded

Description

You should send the DoExpandAll procedure to expand the item represented by the hItem parameter and all its children.

See Also

DoExpandItem

Last Edited: June 22, 2005


TreeView [Procedure DoExpandItem]

DoExpandItem - TreeView

Expands hItem

Type: Procedure

Parameters: Handle hItem

Parameter | Description
hItem | The handle of the item to be expanded

Description

You should send the DoExpandItem procedure to expand hItem.

See Also

DoExpandAll

Last Edited: July 31, 2003


TreeView [Procedure DoMakeItemFirstVisible]

DoMakeItemFirstVisible - TreeView

Forces hItem to be placed at the top of the control

Type: Procedure

Parameters: Handle hItem

Parameter | Description
hItem | The item handle

Description

By sending the DoMakeItemFirstVisible procedure, you will force hItem to be placed at the top of the control. If necessary, the item will be expanded to ensure it becomes visible.

See Also

DoMakeItemVisible

Last Edited: July 31, 2003


TreeView [Procedure DoMakeItemVisible]

DoMakeItemVisible - TreeView

Forces hItem to become visible

Type: Procedure

Parameters: Handle hItem

Parameter | Description
hItem | The item handle

Description

By sending the DoMakeItemVisible procedure, you will force hItem to become visible. If necessary, the item will be expanded or scrolled to bring it into view.

See Also

DoMakeItemFirstVisible

Last Edited: July 31, 2003


TreeView [Procedure DoReadTree]

DoReadTree - TreeView

Constructs a simple tree view by loading the values from an external file

Type: Procedure

Parameters: string sFile

Parameter | Description
sFile | The name of the file containing strings that should be loaded

Description

It is possible to construct a simple display by loading the values from an external file. Each string in the file will be parsed to form the hierarchy. The TreeLevelDelimeter property is used to distinguish levels of the hierarchy.

This sample file would create a root item with two child items:

Food
/Cake
/Steak

You can only call this method inside the OnCreateTree event.

Last Edited: September 25, 2003


Properties for TreeView

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
ChildItem | Returns the handle of the first child item of hItem |
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
CountTreeLevels |  |
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentTreeItem | Gets or sets the handle of the item that is currently selected | AbstractTreeView
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | List
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
ExpandedOnceState | Returns a boolean value of true if hItem has been expanded since it was created | AbstractTreeView
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | List
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
FirstVisibleItem | Returns the handle of the item that is currently displayed at the very top of the control |
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | List
Help_Keyword | Used to specify an object's context keyword | List
ImageListObject | Uses an ImageList control to supply the images that each item displays | AbstractTreeView
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Shadow_State | Determines if an object's item is enabled or disabled | List
ItemChildCount | Getting this property returns whether there are childitems | AbstractTreeView
ItemCount | Returns the total number of items in the control |
ItemData | Stores an application-specific value | AbstractTreeView
ItemFullPath | Returns a string representing the "full path" of the item |
ItemImage | Gets and sets the index of the regular image in the control's ImageList | AbstractTreeView
ItemLabel | Sets label that is displayed alongside the image | AbstractTreeView
ItemSelectedImage | Gets and sets the index of the selected image in the control's ImageList that you associated with the item | AbstractTreeView
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | Sets the text for a label or heading for an entry control object | List
Label_Col_Offset | The horizontal distance from the object to its label | List
Label_Justification_Mode | The justification mode for the text within this object's label | List
Label_Offset | Returns both the label_row_offset and the label_col_offset properties as a single (two-component) property | List
Label_Row_Offset | The vertical distance from the top edge of the object and its label | List
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
NextSiblingItem | Returns the item handle for the item that is the next sibling of the hItem-parameter item |
NextVisibleItem | Returns the handle of the next visible item in relation to the item passed as a parameter |
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | List
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
ParentItem | Returns the handle of the parent of hItem |
pbCancelEdit | Used in OnBeginLabelEdit and OnEndLabelEdit to cancel the editing of a treeview label | AbstractTreeView
pbFullRowSelect | Enables full-row selection in the treeview | AbstractTreeView
pbHotTracking | automatically highlights an item when the mouse hovers over it | AbstractTreeView
pbShowTooltips | Determines if a tool tip should be displayed when the mouse hovers over a long tip | AbstractTreeView
pbSingleExpand | Determines if item being selected will collapse if it was expanded, or expand if it was collapsed | AbstractTreeView
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piBackColor | Controls the color of the background of the treeview | AbstractTreeView
piLineColor | Controls the color of the lines drawn in the treeview | AbstractTreeView
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piTextColor | Controls the color of text in the items of the treeview | AbstractTreeView
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
PreviousSiblingItem | Returns the item handle for the previous sibling of hItem |
PreviousVisibleItem | Returns the handle of the previous visible item in relation to the item passed as a parameter |
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | List
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
RootItem | Returns the item-handle of the item that is the parent-most item |
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count |  | List
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State |  | List
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | List
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
TreeButtonsState | Determines if button will be displayed | AbstractTreeView
TreeEditLabelsState | Supports in-line editing of the label | AbstractTreeView
TreeIndentWidth | Governs the number of pixels that are used to indent child items from their parent items | AbstractTreeView
TreeLevelDelimeter | Holds the character to use as a delimiter of tree levels | AbstractTreeView
TreeLinesState | Determines if the control draws graphical lines between connecting items | AbstractTreeView
TreeRetainSelState | Determines if item will still visibly indicate that it was the focused item, whenever this object loses the focus | AbstractTreeView
TreeRootLinesState | Specifies whether graphical lines should be drawn to connect "Root Items" | AbstractTreeView
TreeSortedState |  | AbstractTreeView
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | List
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
VisibleItemCount | Returns the number of items that are currently visible in the control |
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


TreeView [Property ChildItem]

ChildItem - TreeView

Returns the handle of the first child item of hItem

Type: Property

Access: Read-Only

Data Type: Handle

Parameters: Handle hItem Handle hValue

Parameter | Description
hItem | The parent item
hValue | The first child of hItem

Description

Use the ChildItem property to return the handle of the first child item of hItem. Once you have this handle, you can traverse the child items using the NextSiblingItem and PreviousSiblingItem properties.

Last Edited: July 30, 2003


TreeView [Property CountTreeLevels]

CountTreeLevels - TreeView

Type: Property

Access: Read-Only

Data Type: Integer

Parameters: string sLine Integer iValue

Parameter | Description
sLine | [ToDo: In Progress]
iValue | [ToDo: In Progress]

Description

Last Edited: August 5, 2003


TreeView [Property FirstVisibleItem]

FirstVisibleItem - TreeView

Returns the handle of the item that is currently displayed at the very top of the control

Type: Property

Access: Read-Only

Data Type: Handle

Description

The FirstVisibleItem property returns the handle of the item that is currently displayed at the very top of the control. This is not the first item in the control (although it may be, if no items have scrolled), but the first visible item.

Last Edited: August 18, 2003


TreeView [Property ItemCount]

ItemCount - TreeView

Returns the total number of items in the control

Type: Property

Access: Read-Only

Data Type: Integer

Description

The ItemCount property returns the total number of items in the control.

Last Edited: August 18, 2003


TreeView [Property ItemFullPath]

ItemFullPath - TreeView

Returns a string representing the "full path" of the item

Type: Property

Access: Read-Only

Data Type: String

Parameters: Handle hItem String sValue

Parameter | Description
hItem | The item handle
sValue | A string representing the "full path" of the item

Description

When you call the ItemFullPath propertry, it returns a string representing the "full path" of the item. This is evaluated by getting the item's label and inserting the label the parent's label at the beginning. This process is continued by find each item's successive parent. For example, If you called this function at the time the control looked like this diagram, the ItemFullPath would be "Attributes/Classes_DD/Data Dictionaries".

This value assumes that the TreeLevelDelimeter property has its default value of / and that the item handle you passed was that of the current item (use Get CurrentTreeItem to return the handle of the current item).

Last Edited: September 11, 2003


TreeView [Property NextSiblingItem]

NextSiblingItem - TreeView

Returns the item handle for the item that is the next sibling of the hItem-parameter item

Type: Property

Access: Read-Only

Data Type: Handle

Parameters: Handle hItem Handle hValue

Parameter | Description
hItem | The item handle
hValue | The item handle of the next sibling of hItem

Description

The NextSiblingItem property returns the item handle for the item that is the next sibling of the hItem-parameter item. Sibling items are defined as items with the same parent. So, for example, if you added a parent item of Food then added two child items to it as Cake and Steak-the NextSiblingItem of Cake would be Steak; Steak does not have any next siblings, while Food does not have any siblings at all-just children. A handle of zero will be returned if there is not a next sibling item.

See Also

PreviousSiblingItem

Last Edited: June 22, 2005


TreeView [Property NextVisibleItem]

NextVisibleItem - TreeView

Returns the handle of the next visible item in relation to the item passed as a parameter

Type: Property

Access: Read-Only

Data Type: Handle

Parameters: Handle hItem Handle hValue

Parameter | Description
hItem | The item handle
hValue | The item handle of the next sibling of hItem

Description

The NextVisibleItem property returns the handle of the next visible item in relation to the item passed as an parameter. This property only considers "visible" items. So, items that are children of un-expanded items, for example, are not included when it searches for the next visible item.

See Also

PreviousVisibleItem

Last Edited: June 22, 2005


TreeView [Property ParentItem]

ParentItem - TreeView

Returns the handle of the parent of hItem

Type: Property

Access: Read-Only

Data Type: Handle

Parameters: Handle hItem Handle hValue

Parameter | Description
hItem | The item handle
hValue | The item handle of the parent of hItem

Description

The ParentItem property returns the handle of the parent of hItem. If no parent exists, a handle of zero will be returned.

Last Edited: September 10, 2003


TreeView [Property PreviousSiblingItem]

PreviousSiblingItem - TreeView

Returns the item handle for the previous sibling of hItem

Type: Property

Access: Read-Only

Data Type: Handle

Parameters: Handle hItem Handle hValue

Parameter | Description
hItem | The item handle
hValue | The item handle of the next sibling of hItem

Description

The PreviousSiblingItem property returns the item handle for the previous sibling of hItem. Sibling items are defined as items with the same parent. So, for example, if you added a parent item of Food and then added two children items to it as Cake and Steak-the PreviousSiblingItem of Steak would be Cake; Cake does not have any other previous siblings while Food does not have any siblings at all-just children. A handle of zero will be returned if there is not a previous sibling item.

See Also

NextSiblingItem

Last Edited: September 11, 2003


TreeView [Property PreviousVisibleItem]

PreviousVisibleItem - TreeView

Returns the handle of the previous visible item in relation to the item passed as a parameter

Type: Property

Access: Read-Only

Data Type: Handle

Parameters: Handle hItem Handle hValue

Parameter | Description
hItem | The item handle
hValue | The item handle of the next sibling of hItem

Description

The PreviousVisibleItem property returns the handle of the previous visible item in relation to the item passed as an parameter. This property only considers "visible" items. So, items that are children of un-expanded items, for example, are not included when it searches for the next visible item.

See Also

NextVisibleItem

Last Edited: June 22, 2005


TreeView [Property RootItem]

RootItem - TreeView

Returns the item-handle of the item that is the parent-most item

Type: Property

Access: Read-Only

Data Type: Handle

Description

The RootItem property returns the item-handle of the item that is the parent-most item (that is, the first item you added to the control). The root item does not have any parents, just children.

Last Edited: September 11, 2003


TreeView [Property VisibleItemCount]

VisibleItemCount - TreeView

Returns the number of items that are currently visible in the control

Type: Property

Access: Read-Only

Data Type: Integer

Description

The VisibleItemCount property returns the number of items that are currently visible in the control. As you would expect, you can only call this property once the control has been displayed.

Last Edited: September 15, 2003


Events for ValidationList

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Closing_View |  | dbViewFloatingPanel
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnActivateApp |  | FloatingPanel
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | FloatingPanel
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnDeactivateApp |  | FloatingPanel
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | FloatingPanel
OnPaint | Sent every time a panel is painted | FloatingPanel
OnResize | Sent every time a panel is resized | FloatingPanel
OnSetFocus | Sent whenever windows is about to give this object the focus | FloatingPanel
Opening_View |  | dbViewFloatingPanel
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prepare_Data_Sets | Provides the developer a chance to check the condition of any file buffers before they are cleared | dbViewFloatingPanel
Prompt_Callback | Sends a callback event to an object that requested a prompt object | FloatingPanel
Seed_data_sets | Initiailizes the main DSO (main_DD) with the record that was in the buffer when the view initialization began and causes the view to appear to "latch" on to the last record used | dbViewFloatingPanel
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | FloatingPanel


ValidationList [Function Code_Description_Value]

Code_Description_Value - ValidationList

Enables you to perform any processing on, or even substitution for, the description that displays with or for each code

Type: Function

Return Data Type: String

Parameters: String DescVal String DataVal

Parameter | Description
DescVal | The description provided from the validation table
DataVal | The code provided from the validation table

Return Value

The description to be used in the validation list

Description

Code_description_value is a "hook" function that enables you to perform any processing on, or even substitution for, the description that displays with or for each code.

Last Edited: July 30, 2003


Methods for ValidationList

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | FloatingPanel
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Button | Procedure | (Obsolete) | dbModalPanel
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | FloatingPanel
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | FloatingPanel
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open | dbFloatingPanel
Code_Description_Value | Function | Enables you to perform any processing on, or even substitution for, the description that displays with or for each code |
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoHtmlHelp | Procedure | Launches Compiled HTML Help | FloatingPanel
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | FloatingPanel
Error_Help | Procedure | (Obsolete) | FloatingPanel
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Application_Check | Function |  | dbViewFloatingPanel
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | dbFloatingPanel_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | FloatingPanel
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | FloatingPanel
Help | Procedure |  | FloatingPanel
Help_For_Help | Procedure | (Obsolete) | FloatingPanel
Help_Index | Procedure | (Obsolete) | FloatingPanel
Help_on_topic | Procedure | (Obsolete) | FloatingPanel
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | FloatingPanel
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | FloatingPanel
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | FloatingPanel
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | FloatingPanel
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | dbFloatingPanel_
Request_Clear | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbFloatingPanel_
Request_Clear_All | Procedure | Clears panel, and changes focus to first object or item in panel if auto_top_panel_state is true | dbFloatingPanel_
Request_Delete | Procedure | Deletes current record in main_file of the server DSO, if any, else issues an error | dbFloatingPanel_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Find | Procedure | Finds on specified file using given find_mode and index | dbFloatingPanel_
Request_Save | Procedure | Saves all changes in DEOs attached to the DSO or to any DSO which is a server of the DSO | dbFloatingPanel_
Request_Save_No_Clear | Procedure | Saves changes to the current record of this object's server, if any, and does not clear the buffer, regardless of the value of auto_clear_deo_state | dbFloatingPanel_
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | FloatingPanel
Request_Superfind | Procedure | Performs superfind on the designated file by the main index of field and notifies all connected DSOs of the result | dbFloatingPanel_
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Search | Procedure | (Obsolete) | dbModalPanel
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | FloatingPanel
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | FloatingPanel
Verify_Data_Loss | Function | Sends the verify_data_loss_msg message when user action causes the program to get this function | dbFloatingPanel_
Verify_Delete | Function | Sends the verify_delete_msg message when user action causes the program to get this functio | dbFloatingPanel_
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | dbFloatingPanel_
Verify_Save | Function | Sends the verify_save_msg message when user action causes the program to get this function | dbFloatingPanel_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for ValidationList

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Clear_DEO_State | Determines if object will clear after a successful save occurs | dbFloatingPanel_
Auto_Dependent_item_State | Determines if items in all objects within this object will be arranged into dependency groups according to the file and field each is connected to | dbViewFloatingPanel
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | dbFloatingPanel_
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | FloatingPanel
Auto_Size_State | Determines if object will size itself to accommodate the code_display_mode automatically |
Auto_Top_Item_State |  | dbViewFloatingPanel
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | dbFloatingPanel_
Auto_top_view_State |  | dbViewFloatingPanel
Bitmap | Displays a bitmap in an object | FloatingPanel
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
button_height | (Obsolete) | dbModalPanel
button_width | (Obsolete) | dbModalPanel
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Changed_State | Determines if one or more of the child objects has changed | dbFloatingPanel_
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Id |  | FloatingPanel
Client_Size |  | DfBaseWindow
Code_Display_Mode | Specifies whether the list will display the choices' codes, descriptions, or both |
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | FloatingPanel
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | FloatingPanel
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | FloatingPanel
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | dbFloatingPanel_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
DEO_Attach_All_State |  | dbViewFloatingPanel
deo_delegate_mode | Controls those requests for which delegate_..._state is set true | dbFloatingPanel_
DEO_Object |  | dbFloatingPanel
DSO_Detach_Mode | Specifies the circumstances in which this object's DSOs should become not in-use upon deactivation of this view | dbViewFloatingPanel
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | FloatingPanel
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | FloatingPanel
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | FloatingPanel
Help_Keyword | Used to specify an object's context keyword | FloatingPanel
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | FloatingPanel
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | FloatingPanel
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
List_Object | (Obsolete) | dbModalPanel
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | FloatingPanel
Location | Determines the position of the upper left character of the object's window | cUIObject
Main_DD | Identifies the dataDictionary object that controls the database file whose data is central to this object's function | dbViewFloatingPanel
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | FloatingPanel
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | FloatingPanel
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | FloatingPanel
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
priInitialRowId |  | dbViewFloatingPanel
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | FloatingPanel
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | FloatingPanel
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Server | Identifies the object which provides database services to this object | dbFloatingPanel_
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | dbFloatingPanel_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Sort_State |  |
Static_State |  |
Status_Help | Determines the status text that will be displayed when this object takes the focus | FloatingPanel
Statusbar_Id |  | FloatingPanel
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Table_Title | The title of the validation list |
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Toolbar_Id |  | FloatingPanel
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | FloatingPanel
Value |  | DfBaseWindow
Verify_Data_Loss_Msg | Specifies the message to use for data loss confirmation | dbFloatingPanel_
Verify_Delete_Msg | Specifies the message to use for delete confirmation | dbFloatingPanel_
verify_exit_msg | Determines what message is sent during an exiting event | dbFloatingPanel_
Verify_Save_Msg | Specifies the message to use for save confirmation | dbFloatingPanel_
View_Latch_State | Determines if the view's DSO structure will be initialized with the data | dbViewFloatingPanel
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


ValidationList [Property Auto_Size_State]

Auto_Size_State - ValidationList

Determines if object will size itself to accommodate the code_display_mode automatically

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_size_state property is true, this object sizes itself to accommodate the code_display_mode automatically.

Default is true.

Last Edited: January 12, 2006


ValidationList [Property Code_Display_Mode]

Code_Display_Mode - ValidationList

Specifies whether the list will display the choices' codes, descriptions, or both

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iState Integer iValue

Parameter | Description
iState | [ToDo: In Progress]
iValue | [ToDo: In Progress]

Description

The Code_display_mode property specifies whether the list will display the choices' codes, descriptions, or both. If it is set to -1, the mode is "auto-assign," which means it will be governed in each DEO according to the setting of the item's code_description_export_state.

Possible values are:

Constant | Meaning
-1 | Auto-Assign
CB_Code_Display_Description | Displays the description
CB_Code_Display_Code | Displays the code
CB_Code_Display_Both | Displays the description and the code

Last Edited: January 12, 2006


ValidationList [Property Sort_State]

Sort_State - ValidationList

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iState Integer iValue

Parameter | Description
iState | [ToDo: In Progress]
iValue | [ToDo: In Progress]

Description

Last Edited: January 12, 2006


ValidationList [Property Static_State]

Static_State - ValidationList

Type: Property

Access: Read/Write

Data Type: Integer

Parameters: Integer iState Integer iValue

Parameter | Description
iState | [ToDo: In Progress]
iValue | [ToDo: In Progress]

Description

Last Edited: July 11, 2006


ValidationList [Property Table_Title]

Table_Title - ValidationList

The title of the validation list

Type: Property

Access: Read/Write

Data Type: String

Description

Table_Title is the title of the validation list. A null value for the Table_title property specifies "auto-assign," which uses the Table_Title of the File_Field_Table_Object, if any, of the field. If there is none, the system default data-dictionary grid title is used. If title is other than null, that is used as the title of this object.

Default is "".

Last Edited: September 11, 2003


ValidationTable [Event Fill_List]

Fill_List - ValidationTable

Fills the list of entires in the validation table

Type: Event

Parameters: No Parameters

Description

The Fill_List event should be used to fill the list of entires in the validation table. This event should be written (with Add_Table_Value messages) so as to contain all the values required for validation.

Last Edited: August 18, 2003


Events for ValidationTable

View event list in hierarchical order

Name | Description | Defining Class
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Fill_List | Fills the list of entires in the validation table |


ValidationTable [Function Find_Code_Description]

Find_Code_Description - ValidationTable

Type: Function

Return Data Type: String

Parameters: String sCode

Parameter | Description
sCode | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


ValidationTable [Function TableData]

TableData - ValidationTable

Returns the validation table's data in a two dimensional variant array

Type: Function

Return Data Type: Variant[][]

Parameters: No Parameters

Return Value

Returns table data in a variant array: vData[x][0] = data value vData[x][1] = description value where x represents one "row" of data

Description

TableData returns validation table's data in a two dimensional variant array where the first dimension contains data and the second dimension contains the description.

Procedure ShowAllData
    Integer i iRows
    Variant[][2] vTerms

    Get TableData of Terms_table to vTerms
    Move (SizeOfArray(vTerms)) to iRows
    For i from 0 to (iRows-1)
        Showln   i " Data=" vTerms[i][0] " Description="vTerms[i][1]
    Loop
End_Procedure

This method was created to make it easy to pass validation data to a Crystal Reports report via CDO.

Procedure OnInitializeReport Handle hoReport
    Handle hoCDOStates hoCDOTerms
    Variant[][2] vStates
    Variant[][2] vTerms

    Get CreateCDO of hoReport "States.ttx" to hoCDOStates
    Get TableData of Customer_State_VT to vStates
    Send ComAddRows of hoCDOStates vStates

    Get CreateCDO of hoReport "Terms.ttx" to hoCDOTerms
    Get TableData of Terms_table to vTerms
    Send ComAddRows of hoCDOTerms vTerms

End_Procedure // OnInitializeReport

See Also

CreateCDO | AppendCDOData | cCrystal

Last Edited: January 5, 2006


ValidationTable [Function Validate_Value]

Validate_Value - ValidationTable

Determines whether a value is valid or not (is listed in the validation table or not)

Type: Function

Return Data Type: Integer

Parameters: String sCode

Parameter | Description
sCode | the string to test to see if it exists in the list

Return Value

Returns zero when value is found to be valid, and non-zero otherwise

Description

The Validate_Value function determines whether a value is valid or not (is listed in the validation table or not). This function, received from DEOs, returns zero when value is found to be valid, and non-zero otherwise. You may augment it in this object. It is not sent when validate_state is set to False.

Last Edited: September 15, 2003


Methods for ValidationTable

View method list in hierarchical order

Name | Type | Description | Defining Class
Add_Table_Value | Procedure | Should be sent for each sValue and description you wish to add to your validation table. |
Create | Function | Creates an object based on the passed Class Id | cObject
Delete_Data | Procedure | Deletes all data from the Array object | Array
Delete_Item | Procedure | Removes the specified item from the Array and compacts the remaining elements | Array
Destroy | Procedure |  | cObject
Exit_Application | Procedure | Starts the process of closing an application | cObject
Find_Code_Description | Function |  |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Sort_Items | Procedure | Sorts the items in an array in ascending or descending order | Array
TableData | Function | Returns the validation table's data in a two dimensional variant array |
Validate_Value | Function | Determines whether a value is valid or not (is listed in the validation table or not) |


ValidationTable [Procedure Add_Table_Value]

Add_Table_Value - ValidationTable

Should be sent for each sValue and description you wish to add to your validation table.

Type: Procedure

Parameters: String sValue

Parameter | Description
sValue | the description of the element

Description

Should be sent for each sValue and description you wish to add to your validation table. The messages should be sent in the order in which you wish to have values be presented in the list.

Last Edited: July 30, 2003


Properties for ValidationTable

View property list in hierarchical order

Name | Description | Defining Class
Allow_Blank_State | Controls whether blank entries are accepted in this object |
Child_Count | Returns the number of child objects the object contains | cObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Item_Count | Returns the number of items in an array object | Array
Main_File | Identifies the data file from which the values are to be drawn to fill this object |
Name | Returns the full name of the object including parentage | cObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Static_State | Determines whether object loads once per session or dynamically. |
Table_Title | The title shown in the caption bar of the validation table |
Validate_State | Determines whether values are validated against the items contained in the validation table. |
Value | Sets and Gets an array element's value | Array


ValidationTable [Property Allow_Blank_State]

Allow_Blank_State - ValidationTable

Controls whether blank entries are accepted in this object

Type: Property

Access: Read/Write

Data Type: Boolean

Description

The Allow_Blank_State property controls whether blank entries are accepted in this object. The default value of this property is False.

Default is false.

Last Edited: January 12, 2006


ValidationTable [Property Main_File]

Main_File - ValidationTable

Identifies the data file from which the values are to be drawn to fill this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Main_File property identifies the data file from which the values are to be drawn for validation and insertion into the database and the descriptions that explain (and possibly sort) them.

Last Edited: August 18, 2003


ValidationTable [Property Static_State]

Static_State - ValidationTable

Determines whether object loads once per session or dynamically.

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If this property is set to False, this object loads its list every time it is requested to validate or fill a foreign list. In its default state, it loads its list only once in each session. In applications that allow editing of the list ("Code Maintenance" functions and the like), it is important that this property be set to False in order to give effect to such changes during the sessions in which they are made. The default value of this property is True.

Last Edited: January 12, 2006


ValidationTable [Property Table_Title]

Table_Title - ValidationTable

The title shown in the caption bar of the validation table

Type: Property

Access: Read/Write

Data Type: String

Description

Table_Title is the title shown in the caption bar of the validation table. This property may be used to present text at the top of the list to describe or explain the list as a whole.

Last Edited: September 11, 2003


ValidationTable [Property Validate_State]

Validate_State - ValidationTable

Determines whether values are validated against the items contained in the validation table.

Type: Property

Access: Read/Write

Data Type: Integer

Description

If the Validate_State property is set to False, entries to the field to which this object is assigned need not match any of the values in this object's list, which would in such case, be used only to provide suggested values and facilitate selecting among these. In its default state of True, it requires that all entries exactly match one of the values in the list. Governs the sending of Validate_Value.

Last Edited: September 15, 2003


Events for View

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
Notify_Exit_Application | Called when an application is about to be closed | AppDialog
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | Container3d
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnFileDropped | Provides a notification that a file drag and drop operation has occurred | DfBaseContainer
OnKillFocus | Sent whenever the object is about to lose the focus | Container3d
OnPaint | Sent every time a panel is painted | MdiDialog
OnResize | Sent every time a panel is resized | MdiDialog
OnSetFocus | Sent whenever windows is about to give this object the focus | Container3d
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | Container3d
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | Container3d
Verify_Exit_Application | Sent by the client area to verify that an application may be exited | AppDialog


Methods for View

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | Container3d
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Activate_View | Procedure | Activates the view | AppDialog
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | Container3d
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | Container3d
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure |  | MdiDialog
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Destroy | Procedure |  | cObject
DoCenterMdiDialog | Procedure | Locates an MDI Dialog in the center of the MDI client area | MdiDialog
DoHtmlHelp | Procedure | Launches Compiled HTML Help | Container3d
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | Container3d
Error_Help | Procedure | (Obsolete) | Container3d
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | Container3d
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | Container3d
Help | Procedure |  | Container3d
Help_For_Help | Procedure | (Obsolete) | Container3d
Help_Index | Procedure | (Obsolete) | Container3d
Help_on_topic | Procedure | (Obsolete) | Container3d
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | Container3d
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | Container3d
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Object | Procedure | Adds or removes an object | cUIObject
Popup | Procedure | Activates the object as a pop-up | cUIObject
Popup_Modal | Procedure | Activates this object modally-that is, confining the mouse and the cursor to it and prohibiting interaction with other objects until this one is deactivated | MdiDialog
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | Container3d
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | Container3d
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Stop_Modal_UI | Procedure | Causes the modal object to deactivate | MdiDialog
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | Container3d
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for View

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Locate_State | Locates itself relative to any item that invokes it with a popup message when set true | Container3d
Bitmap | Displays a bitmap in an object | Container3d
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseDialog
Caption_Bar | contains the title of the DfBaseDialog object and allows you to move the DfBaseDialog | DfBaseDialog
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Offset | Determines the offset to the invoking item by number of columns | Container3d
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Action_Button |  | MdiDialog
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Default_Action_Button | The object handle of the default action button | MdiDialog
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | Container3d
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | Container3d
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize | Overrides the default font size of the current font | DfBaseWindow
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
GetContainerClientSize |  | DfBaseContainer
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Help_id | Used to specify an object's context ID | Container3d
Help_Keyword | Used to specify an object's context keyword | Container3d
Icon | Allows you to set the name of an icon, which appears when the user minimizes a container | DfBaseDialog
Item_Shadow_State | Determines if an object's item is enabled or disabled | Container3d
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Label | This is the text that appears within this control | Container3d
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Locate_Mode | Provides several flexible methods for auto positioning container panels in your program | Container3d
Location | Determines the position of the upper left character of the object's window | cUIObject
Maximize_Icon | Determines if DfBaseDialog is displayed with a Maximize icon button | DfBaseDialog
Mdi_State |  | DfBaseDialog
Minimize_Icon | Determines if DfBaseDialog is displayed with a Minimize icon button | DfBaseDialog
Modal_State | Set true by the popup_modal procedure or when this object is the argument of a ui_accept statement, false when object popped up by popup_modal is deactivated | MdiDialog
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | Container3d
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Offset_Location |  | Container3d
Parent | Returns the parent of an object | cObject
pbAcceptDropFiles | Determines if the container object supports a file drop event | DfBaseContainer
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | Container3d
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row_Offset | Determines the offset to the invoking item by number of rows | Container3d
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | Determines the status text that will be displayed when this object takes the focus | Container3d
Sysmenu_Icon | Determines if DfBaseDialog is displayed with a system menu-icon that displays a list of standard operations | DfBaseDialog
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | Container3d
Value |  | DfBaseWindow
View_Mode | Changes the appearance of the DfBaseDialog window | DfBaseDialog
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow


Events for ViewPopupMenu

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Initialize_Menu | Sent when the Menubar system is about to be selected | DfBaseActionBar
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnChange | Called every time a menu changes | PopupMenu
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnInitMenu | Sent when a PopupMenu object is about to be selected | PopupMenu
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject


Methods for ViewPopupMenu

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Bell | Procedure | Rings the PC bell | cUIObject
Cancel | Procedure | Returns the message_id of itself | cUIObject
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Create | Function | Creates an object based on the passed Class Id | cObject
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
Down | Procedure | Sends the key kdownarrow message to the object | DfBaseList
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Exit_Menu | Procedure |  | DfBaseActionBar
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
Help | Procedure | Overridden in the help_system to activate context-sensitive help | cUIObject
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
Menu_Status_Help | Function |  | PopupMenu
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | cUIObject
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | cUIObject
Redirect_Message | Procedure |  | DfBaseActionBar
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Causes the contents of the object display window to scroll in given direction | DfBaseList
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Up | Procedure | Sends the key kuparrow to the object | DfBaseList
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow


Properties for ViewPopupMenu

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prototype_Object |  | DfBaseList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Shadow_Status_Help | Specifies the display in the status bar for items of this object that are shadowed | PopupMenu
Simple_Status_Help_State |  | PopupMenu
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Status_Help | The status-bar help text for Item item# | PopupMenu
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Value | Gets and sets the data value for an item | DfBaseList
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList


Events for WideList

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click | Sent whenever a header has received a mouse click | EntryList
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items | WideList_
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | EntryList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin | Augmented to set the minimum and maximum positions for a spinner | EntryList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


WideList [Function Prompt_Description]

Prompt_Description - WideList

Type: Function

Obsolete

Return Data Type: String

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


WideList [Function Validate_Prompt]

Validate_Prompt - WideList

Type: Function

Obsolete

Return Data Type: Integer

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Return Value

Description

Last Edited: February 13, 2003


Methods for WideList

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the current column of the first row | EntryList
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Returns the message_id of itself | cUIObject
Close_Panel | Procedure | Closes the panel or component currently open |
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Default_Prompt | Procedure | (Obsolete) |
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
Down | Procedure |  | WideList_
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row | WideList_
End_of_Data | Procedure | Causes the grid's current item to be set to the current column of the last row | EntryList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result | WideList_
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result | WideList_
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result | WideList_
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel | WideList_
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message | WideList_
Prompt_Description | Function | (Obsolete) |
Prompt_Description | Procedure | (Obsolete) |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action | WideList_
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines | EntryList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  | WideList_
Up_Row | Procedure | Changes the current item to the prior row, if any, at the same item relative to the beginning of the row | WideList_
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
Validate_Prompt | Function | (Obsolete) |
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result | WideList_
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message | WideList_


WideList [Procedure Close_Panel]

Close_Panel - WideList

Closes the panel or component currently open

Type: Procedure

Parameters: No Parameters

Description

Closes the panel or component currently open. If the control Close_Panel is sent to is not a panel, the call will be delegated to it's parent.

For example, if a cDbRichEdit control is in a dbView, sending Close_Panel to the cDbRichEdit control will close the dbView.

Sample

This sample causes the dbView control oDbView1 to close when button oCloseButton is clicked.

Object oDbView1 is a dbView
    :
    Object oDbRichEdit1 is a cDbRichEdit
        :
    End_Object  // oDbRichEdit1
    :
    Object oCloseButton is a Button
        :
        Procedure OnClick
            send Close_Panel of oDbRichEdit1
        End_Procedure  // OnClick
        :
    End_Object  // oCloseButton
    :
End_Object  // oDbView1

Last Edited: November 24, 2004


WideList [Procedure Default_Prompt]

Default_Prompt - WideList

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


WideList [Procedure Prompt_Description]

Prompt_Description - WideList

Type: Procedure

Obsolete

Parameters: Integer Item#

Parameter | Description
Item# | [ToDo: In Progress]

Description

Last Edited: February 13, 2003


Properties for WideList

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Fill_State | Determines if the object's DDO should perform an auto fill | WideList_
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy | WideList_
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Deferred_State | Determines if all finds by the object will occur without changing the server's current record | WideList_
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object | WideList_
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit | WideList_
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
verify_exit_msg | Determines what message is sent during an exiting event | WideList_
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


WideList_ [Event Initialize_List]

Initialize_List - WideList_

Will be invoked prior to activation of the list for the purpose of filling the empty list with items

Type: Event

Parameters: No Parameters

Description

No action by default. Initialize_list is intended for augmentation by subclasses. This operation will be invoked prior to activation of the list for the purpose of filling the empty list with items.

Last Edited: August 18, 2003


Events for WideList_

View event list in hierarchical order

Name | Description | Defining Class
Activating | Sent by the object to itself whenever the object is placed on the screen | cUIObject
Combo_Edit_Changed | Fires when combo item is changed by editing a value | EntryList
Combo_Item_Changed | Fires when combo item is changed by selecting a new combo item | EntryList
Command | Sent from external controls | DfBaseUIWindow
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Deactivating | Sent to the object when it is being removed from the focus tree as the result of a release_focus message | cUIObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Entering | When the focus is to move to a new object, the entering event is sent to the object receiving the focus | cUIObject
Entering_Scope | Sent to the object if its scope_state is true, and one of the objects within its scope takes the focus | cUIObject
Error_Report | Used by the error object to declare errors at the bottom of the screen | cUIObject
Exiting | When the focus is to move to a new object, the exiting event is sent to the object losing the focus | cUIObject
Exiting_Scope | Sent whenever the focus is moving to an object that is outside the current scope | cUIObject
Form_Button_Mouse_Down | A notification that the form's button has been selected with the mouse | DfBaseObject
Form_Button_Notification | A notification of a form button event | DfBaseObject
Header_Mouse_Click | Sent whenever a header has received a mouse click | EntryList
Header_Mouse_Double_Click | Sent whenever a header has received a mouse double-click | EntryList
Header_Notification | Sent when the header has received a mouse event | DfBaseEntryList
Initialize_List | Will be invoked prior to activation of the list for the purpose of filling the empty list with items |
Item_Change | A programming "hook" to perform an action on change of an item | DfBaseList
Item_Entry | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Item_Exit | Sends iMessage to the current object if it is non-zero | DfBaseEntry
Key | Augmented to implement the GUI keyboard interface | DfBaseList
Mouse_Click | Sent whenever the first button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Click2 | Sent whenever the second button of the mouse is double clicked on an item or in the edit window of the object | cUIObject
Mouse_Down | Sent whenever the first button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Down2 | Sent whenever the second button of the mouse is pressed down while on an item or in the edit window of the object | cUIObject
Mouse_Drag | Sent whenever the first button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Drag2 | Sent whenever the second button of the mouse is being held down while users drag the mouse cursor from one item or edit line of the object to the next | cUIObject
Mouse_Up | Sent whenever the first button of the mouse is released while on an item is in the edit window of the object | cUIObject
Mouse_Up2 | Sent whenever the second button of the mouse is released while on an item is in the edit window of the object | cUIObject
Notify_Application_Activation | Sends OnActivateApp or OnDeactivateApp | DfBaseObject
OnBeginningOfPanel | Sent by panel to notify all its objects when a beginning_of_panel message is executed | EntryList
OnChange | A "hook" procedure for you to use for any action you wish to occur when the data in this object changes | EntryList
OnChildWrapping | Sent any time a wrapping event occurs | cUIObject
OnCloseUp | Fires when combo form's dropdown list closes | EntryList
onDeltaPos | Provides actions based on the amount of change in this object and/or its value at the point the focus is moved off it | DfBaseObject
OnDropDown | Fires when combo form's dropdown list drops down | EntryList
onInitSpin | Augmented to set the minimum and maximum positions for a spinner | EntryList
OnKillFocus | Sent whenever the object is about to lose the focus | EntryList
OnMaxText |  | EntryList
OnMouseWheel | An event sent everytime a mouse wheel is clicked | EntryList
OnSetFocus | Sent whenever windows is about to give this object the focus | EntryList
Page | Used internally to display the image of an object on the screen | cUIObject
Page_Delete | Used internally to remove the image of an object from the screen | cUIObject
Prompt_Callback | Sends a callback event to an object that requested a prompt object | EntryList
Refresh | Displays items from some files at the same time as clearing items from other files | DfBaseEntry
Shadow_Display | Called whenever a change in shadow state occurs, or when an object is paged | EntryList
Wrapping | Sent by the item_change message each time the current_item is changed from the last to the first or the first to the last item | DfBaseEntry


WideList_ [Function exec_entry]

exec_entry - WideList_

Invokes the item_entry_msg of the specified item#, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: integer item#

Parameter | Description
item# | The item number

Return Value

The result of the item_entry_msg of the specified item#

Description

Exec_entry invokes the item_entry_msg of the specified item#, if any, and returns the result.

Last Edited: August 13, 2003


WideList_ [Function exec_exit]

exec_exit - WideList_

Invokes the item_exit_msg of the specified item#, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: integer item#

Parameter | Description
item# | The item number

Return Value

The result of the item_entry_msg of the specified item#

Description

Exec_exit invokes the item_exit_msg of the specified item#, if any, and returns the result.

Last Edited: August 13, 2003


WideList_ [Function exec_validate]

exec_validate - WideList_

Invokes the item_validate_msg of the specified item#, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: integer item#

Parameter | Description
item# | The item number

Return Value

The result of the item_entry_msg of the specified item#

Description

Exec_validate invokes the item_validate_msg of the specified item#, if any, and returns the result. Performs autofind on value and field of specified item#, if required, using entry_autofind.

Last Edited: August 13, 2003


WideList_ [Function verify_Exit]

verify_Exit - WideList_

Sends this object's verify_exit_msg, if any, and returns the result

Type: Function

Return Data Type: Integer

Parameters: No Parameters

Return Value

The result should be zero if exit is allowed to continue, non-zero if it is not.

Description

Verify_exit sends this object's verify_exit_msg, if any, and returns the result.

Last Edited: September 15, 2003


Methods for WideList_

View method list in hierarchical order

Name | Type | Description | Defining Class
Activate | Procedure | Gives an object the focus (and adds it to the focus tree) | cUIObject
Activate_Area | Procedure |  | EntryList
Activate_Column | Procedure | Attempts to activate the object making the passed Item# in the current row the current_item | EntryList
Activate_Item | Procedure | Activates this object with Item Item# as the current_item | EntryList
Activate_Scope | Procedure | Activates objects that are separate tools to the application | cUIObject
Add_Focus | Procedure | Adds the object into the focus tree at the next_level of the hoParent in the focus tree | cUIObject
Add_Item | Procedure | Adds an item to the end of a list | DfBaseList
Add_Row | Procedure | Appends all of the items from the hoPrototype to the current object | DfBaseList
Adjust_Logicals | Procedure | Sets the logical coordinates for size and location to the best approximations of the actual physical coordinates of the object | DfBaseWindow
Beginning_of_Data | Procedure | Causes the grid's current item to be set to the current column of the first row | EntryList
Beginning_of_Panel | Procedure | Gives the focus to the first item in the first object in the current parent-child hierarchy | EntryList
Bell | Procedure | Rings the PC bell | cUIObject
Bottom_of_Panel | Procedure | Activates the last child object of this object that is a DEO, if any | EntryList
Cancel | Procedure | Returns the message_id of itself | cUIObject
Column | Function | Returns the number of the column that is connected to Item Item# | EntryList
Column_Combo_Add_Item | Procedure | Adds an item to the end of the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Data | Procedure | Deletes all items from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Delete_Item | Procedure | Deletes an item from the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Find | Function | Searches for an item in the dropdown list of a combo form for a column by value | DfBaseEntryList
Column_Combo_Item_Count | Function | Returns number of items in the combo form's dropdown list for a column | DfBaseEntryList
Column_Combo_Refresh | Procedure | Forces a refresh for the combo form of a column | DfBaseEntryList
Column_Combo_Value | Function | Returns the value of a dropdown list item in the combo form for a column | DfBaseEntryList
confirm | Function | Pops up a "Yes/No" confirmation | cUIObject
Copy | Procedure | Copies the marked block of text to the Clipboard | DfBaseForm
Create | Function | Creates an object based on the passed Class Id | cObject
Currency_Mask | Procedure Set | Provides an easy method for creating a currency mask | EntryList
Cut | Procedure | Copies the marked block of text to the Clipboard and deletes it from this object | DfBaseForm
Data_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for data loss | cUIObject
Deactivate | Procedure | Removes the object from the focus tree by sending the release_focus message, and if successful, send the deactivation message | cUIObject
Delete | Procedure | Deletes the marked block of text | DfBaseForm
Delete_Confirmation | Function | Pops up a "Yes/No" confirmation for a delete | cUIObject
Delete_Data | Procedure | Painted to update the screen after all items in the list are destroyed | DfBaseList
Delete_Item | Procedure | Deletes the specified item from the list if it exists | DfBaseList
Destroy | Procedure |  | cObject
DoadjustGridWidths | Procedure | Called any time a grid is resized | EntryList
DoHtmlHelp | Procedure | Launches Compiled HTML Help | EntryList
DoMakeColumnVisible | Procedure | Ensures that the passed column number is fully visible | DfBaseEntryList
DoScrollDown | Procedure | Emulates pressing a spin button down | EntryList
DoScrollUp | Procedure | Emulates pressing a spin button up | EntryList
Down | Procedure |  |
Down_Row | Procedure | Changes the current item to the next row, if any, at the same item relative to the beginning of the row |
End_of_Data | Procedure | Causes the grid's current item to be set to the current column of the last row | EntryList
End_of_Panel | Procedure | Gives the focus to the last item in the last object in the current parent-child hierarchy | EntryList
Entry_Autofind | Procedure | Sent when an item with an autofind or autofind_ge option is exited after a change has been made to the data in the window | DfBaseEntry
Entry_Clear | Procedure | Clears all data-entry windows that are not controlled by a retain or retainall | DfBaseEntry
Entry_Clear_All | Procedure | Clears all data entry windows that are not marked as retainall | DfBaseEntry
Entry_Display | Procedure | Displays data from the data_file and data_field to every entry_item connected to it | DfBaseEntry
Entry_Update | Procedure | Moves data from all entry items of an object whose data_file is equal to file_number and whose item_changed_state is true, to the record buffer of file_number | DfBaseEntry
Error_Help | Procedure | (Obsolete) | EntryList
exec_entry | Function | Invokes the item_entry_msg of the specified item#, if any, and returns the result |
exec_exit | Function | Invokes the item_exit_msg of the specified item#, if any, and returns the result |
exec_validate | Function | Invokes the item_validate_msg of the specified item#, if any, and returns the result |
Exit_Application | Procedure | Starts the process of closing an application | cObject
Exit_Function | Procedure | Causes the deactivation of this object's panel by sending request_cancel |
Exit_Loss_Confirmation | Function | Pops up a "Yes/No" confirmation for exit loss | cUIObject
Extended_Help | Procedure | (Obsolete) | EntryList
External_Class_Name | Procedure Set | Used to "wrap" a windows control inside of a DataFlex class | DfBaseWindow
External_Message | Procedure Set | Assigns Windows messages to DataFlex messages | DfBaseWindow
File_Help | Procedure | (Obsolete) | EntryList
Help | Procedure |  | EntryList
Help_Datafile | Function | (Obsolete) Returns the filename and fieldname in file.field format that contains help for the current item | EntryList
Help_For_Help | Procedure | (Obsolete) | EntryList
Help_Index | Procedure | (Obsolete) | EntryList
Help_on_topic | Procedure | (Obsolete) | EntryList
Insert_Item | Procedure | Inserts an item in a list | DfBaseList
Insert_Row | Procedure | Used by dbGrid-class objects to insert prototype rows in the grid at the specified row number | DfBaseList
Item | Procedure Set | Changes the current item to the first or last data item (depending on the value of last) in the displayed range of items | cUIObject
Keys_Help | Procedure | (Obsolete) | EntryList
Line_delete_confirmation | Function | Pops up a "Yes/No" confirmation for a line delete | cUIObject
Line_save_confirmation | Function | Pops up a "Yes/No" confirmation for a line save | cUIObject
New_Item | Procedure Set | Sets the current_item without triggering the code that may be associated with item_change | DfBaseList
Next | Procedure | Moves the focus to the next item or object, as appropriate | cUIObject
Next_Object_Id | Function | Called by the switch message to determine the object_id of the next object to go to in the focus tree | EntryList
No_Confirmation | Function | Pops up a "Yes/No" confirmation for no confirmation | cUIObject
None | Procedure | Does nothing - used by on_key and commands to stop a key assignment | cUIObject
Numeric_Mask | Procedure Set | Provides an easy method for creating a numeric mask | EntryList
Ok | Procedure | Returns the message_id of itself | cUIObject
Page_Down | Procedure | Scrolls the data down by the number of items in the display minus one | DfBaseList
Page_Object | Procedure | Adds or removes an object | cUIObject
Page_Up | Procedure | Scrolls the data up by the number of items in the display minus one | DfBaseList
Paste | Procedure | Copies text from the clipboard into the form | DfBaseForm
Popup | Procedure | Activates the object as a pop-up | cUIObject
Previous | Procedure | Moves the focus to the previous item or object, as appropriate | cUIObject
Prior_Object_Id | Function | Called by the switch_back message to determine the object_id of the previous object to go to in the focus tree | EntryList
Prompt | Procedure | Activates prompt_object of current item, if any, using popup message |
Release_Mouse_Capture | Procedure |  | DfBaseUIWindow
Request_Cancel | Procedure | Deactivates this object's area using verify_exit to confirm user's action |
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Status_Help | Procedure | Sent when an object is about to take or lose the focus | EntryList
Save_Confirmation | Function | Pops up a "Yes/No" confirmation for a save | cUIObject
Scroll | Procedure | Scrolls the item list in the specified direction by the specified number of lines | EntryList
Select_All | Procedure |  | DfBaseForm
Select_Count | Procedure Set | Maintains the total number of selected items in the menu | DfBaseList
Sort_Items | Procedure | Sorts the items in a list in ascending or descending order | DfBaseList
Stop_UI | Procedure | Terminates a popup_modal message and returns execution to the next line after the one on which this message was sent | cUIObject
Switch | Procedure | Moves the focus to the object returned by the next_object_id function | cUIObject
Switch_Back | Procedure | Moves the focus to the object returned by the prior_object_id function | cUIObject
Switch_Next_Group | Procedure | Moves the focus to the first object in the next_level of the next_object of the prior_level of this object | cUIObject
Switch_Next_Scope | Procedure | Moves the focus to the scope focus of the next scope | cUIObject
Switch_Prior_Group | Procedure | Moves the focus to the last object in the prior_level of the prior_object of the next_level of this object | cUIObject
Switch_Prior_Scope | Procedure | Moves the focus to the scope focus of the prior_scope | cUIObject
Top_of_Panel | Procedure | Activates the first child object of this object that is a DEO, if any; else activates this object | EntryList
Undo | Procedure | Will undo the last change in the form | DfBaseForm
Up | Procedure |  |
Up_Row | Procedure | Changes the current item to the prior row, if any, at the same item relative to the beginning of the row |
Validate_Items | Function | Validates all items and sends each entry_item's Item_Validate_msg | DfBaseEntry
verify_Exit | Function | Sends this object's verify_exit_msg, if any, and returns the result |
Windows_Message | Procedure | Sends a message to the Windows message queue | DfBaseWindow
Zoom | Procedure | Activates zoom object of current item, if any, using popup message |


WideList_ [Procedure Down]

Down - WideList_

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


WideList_ [Procedure Down_Row]

Down_Row - WideList_

Changes the current item to the next row, if any, at the same item relative to the beginning of the row

Type: Procedure

Parameters: No Parameters

Description

Down_row changes the current item to the next row, if any, at the same item relative to the beginning of the row. It is sent by kdown_arrow.

Last Edited: August 5, 2003


WideList_ [Procedure Exit_Function]

Exit_Function - WideList_

Causes the deactivation of this object's panel by sending request_cancel

Type: Procedure

Parameters: No Parameters

Description

Exit_function causes the deactivation of this object's panel by sending request_cancel.

Last Edited: August 5, 2003


WideList_ [Procedure Prompt]

Prompt - WideList_

Activates prompt_object of current item, if any, using popup message

Type: Procedure

Parameters: No Parameters

Description

Prompt activates prompt_object of current item, if any, using popup message. Sent by kprompt.

Last Edited: June 29, 2005


WideList_ [Procedure Request_Cancel]

Request_Cancel - WideList_

Deactivates this object's area using verify_exit to confirm user's action

Type: Procedure

Parameters: No Parameters

Description

Request_cancel deactivates this object's area (area is determined by scope_state or popup_state of this object or its parent object(s)-see below), using verify_exit to confirm user's action. An object's area is defined as the part of the focus tree containing this object, with the root of the tree having either its scope_state and/or popup_state true.

Last Edited: September 11, 2003


WideList_ [Procedure Up]

Up - WideList_

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


WideList_ [Procedure Up_Row]

Up_Row - WideList_

Changes the current item to the prior row, if any, at the same item relative to the beginning of the row

Type: Procedure

Parameters: No Parameters

Description

Up_row changes the current item to the prior row, if any, at the same item relative to the beginning of the row. It is sent by kup_arrow.

Last Edited: September 11, 2003


WideList_ [Procedure Zoom]

Zoom - WideList_

Activates zoom object of current item, if any, using popup message

Type: Procedure

Parameters: No Parameters

Description

Zoom activates zoom object of current item, if any, using popup message. Sent by kzoom.

Last Edited: September 15, 2003


Properties for WideList_

View property list in hierarchical order

Name | Description | Defining Class
Absolute_Guiorigin | Returns the screen coordinates of the top left corner of a DataFlex object | DfBaseWindow
Active_State | Indicates whether or not the object is activated | cUIObject
Attach_Parent_State | Determines whether an object that is activated will be added to the next level of the current focus (false) or the next level of its parent (true) | cUIObject
Auto_Fill_State | Determines if the object's DDO should perform an auto fill |
Auto_Top_Item_State | Determines if the current_item is set to the top_item when the object takes the focus | DfBaseList
Auto_Top_Panel_State | If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy |
Autofind_Item |  | DfBaseEntry
AutoSize_Height_State | Determines if grid's automatic height adjustment will be made | DfBaseEntryList
Aux_Value | Is only used by the system if an object is referenced on the on_item command line | DfBaseList
Base_Item | Defines the starting item number that the DfBaseEntry messages are to work with | DfBaseEntry
Bitmap | Displays a bitmap in an object | DfBaseWindow
Bitmap_Height | Returns the height of the image contained in the file named by bitmap | DfBaseWindow
Bitmap_Style | Specifies the position, size, or shape in which the bitmap image for this object is to be displayed | DfBaseWindow
Bitmap_Width | Returns the width of the image contained in the file named by bitmap | DfBaseWindow
Block_Mouse_State | Determines whether or not the use of the mouse is restricted | cUIObject
Border_Style | Specifies the border style of this object | DfBaseControl
Bottom_Item | Returns the item number of the last item on the display | DfBaseEntry
Bottom_Row | Returns the number of the bottom row on the display of a dbGrid-class object | DfBaseEntry
Button_Aspect | A low-level form message that controls the appearance of a form | DfBaseList
Changed_State | Set when users change information in the items of the menu | DfBaseList
Checkbox_Item_State | Allows any item to become a checkbox-type item | DfBaseList
Child_Count | Returns the number of child objects the object contains | cObject
Client_Area_State | Determines if object is a user interface container for children | cUIObject
Client_Size |  | DfBaseWindow
Color | Sets the background color of the object | DfBaseWindow
Column_Combo_Entry_State | Determines if column allows entry into the cell or only allows selection of values from list | DfBaseEntryList
Column_Combo_ListRowCount | Determines maximum number of rows in the combo's dropdown list that are displayed. | DfBaseEntryList
Column_Combo_Sort_State | Determines if a column should display dropdown list in sorted order | DfBaseEntryList
Column_Combo_State | Specifies whether a column of a grid is presented as a combo form | DfBaseEntryList
Container_Handle | Returns the Windows window handle of the DataFlex object's container | DfBaseWindow
ContainsFocus | Determines if the container contains the focus | cUIObject
Current_Col | Returns the number of the column of the list that the cursor currently is located in | EntryList
Current_Item | The object that the end user is currently pointing to | DfBaseList
Current_Row | Return the row number of the current_item | DfBaseEntry
Current_Scope | Returns the object_id of the currently active scoping object | cUIObject
CurrentCellColor | Sets the background color of the current focus item | DfBaseEntryList
CurrentCellTextColor | Sets the text color of the current focus item | DfBaseEntryList
CurrentRowColor | Sets the background color of the current row | DfBaseEntryList
CurrentRowTextColor | Sets the text color of the current row | DfBaseEntryList
Data_Field | Identifies the database field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Data_File | Identifies the database file that contains the field from which data is to be stored, retrieved, and cleared | DfBaseEntry
Deferred_State | Determines if all finds by the object will occur without changing the server's current record |
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Size | Returns the number of windows in the menu | DfBaseList
Displayable_Rows | Returns the number of rows that are visible in the display of a dbGrid-class object | DfBaseEntry
Dynamic_Update_State | Determines whether or not the image of an object that can be seen will be updated when a change to the object occurs | cUIObject
Enabled_State | Determines if an object is enabled or disabled | EntryList
Entry_Msg | Sent whenever the object is about to receive the focus | cUIObject
Entry_State | Determines if the items of menu class objects may become data-entry fields | DfBaseList
Error_Text | Gets the text from FLEXERRS.DAT that corresponds to the passed error number | cUIObject
Error_Text_Available | Determines if Error Text is available for this error number | cUIObject
Exit_Msg | Sent whenever the object is about to lose the focus | cUIObject
Explicit_Shadow_State | Indicates if an object is contextually shadowed by an ancestor | EntryList
Extended_Window_Style | Sets the extended window style for the windows object | DfBaseWindow
Find_Scope | Returns the scoping object of the current object | cUIObject
Floating_Menu_Object | Identifies the floating context menu for this object | EntryList
Focus | Returns the ID of the object that currently has the focus | cUIObject
Focus_Mode | Determines the conditions under which the object will take the focus | cUIObject
FontItalics | Determines if current font is to be italicized | DfBaseWindow
FontSize |  | DfBaseList
FontUnderline | Determines if font will be printed with underscores at the base of the character | DfBaseWindow
FontWeight | Striking weight of font | DfBaseWindow
Form_Bitmap | Places a bitmap named sBitmapName into iItem | DfBaseList
Form_Border | Sets the border style of a form region | DfBaseList
Form_Button | Allows you to define and place a button within your form | DfBaseForm
Form_Button_Bitmap | Allows you to define the bitmap for a button within your form | DfBaseForm
Form_Button_Value | Determines the contents of a form prompt-button | DfBaseForm
Form_Button_Window_Handle | Returns the Windows object handle of the prompt button | DfBaseForm
Form_Column | Controls the horizontal placement (column position) of the form display within the object | DfBaseList
Form_Datatype | Defines a Form or Grid cell's datatype and masking characteristics | DfBaseList
Form_Extended_Style | Sets the extended-window style of form region | DfBaseList
Form_Fontheight | Sets the height of the font in the form display | DfBaseList
Form_FontItalics | Determines if the current form's font will be italicized | DfBaseList
Form_FontUnderline | Determines if the form's font will be underlined | DfBaseList
Form_FontWeight | Sets the Striking weight of form's font | DfBaseList
Form_GuiColumn | Controls the horizontal placement (column position) of the form display within the object in pixels | DfBaseList
Form_Guiheight | Sets the height of the font in the form display in pixels | DfBaseList
Form_Guirow | Controls the vertical placement, in pixel units, of the form display within the object | DfBaseList
Form_Guiwidth | Sets the width of the form item in pixels | DfBaseList
Form_Height | Sets the height of the font in the form display in logical units | DfBaseList
Form_Justification_Mode | Determines how data will be displayed | DfBaseForm
Form_Margin | Defines the maximum number of characters that can be typed into a data-entry field | DfBaseForm
Form_Mask | Provides the token characters for the mask for item_num | DfBaseForm
Form_Option |  | DfBaseList
Form_Options | Sets or gets all of the form_options for a form region | DfBaseList
Form_Row | Controls the vertical placement, in logical units, of the form display within the object | DfBaseList
Form_Style | Sets the window style for the form region | DfBaseList
Form_Typeface | Sets the form's Typeface | DfBaseList
Form_Width | Sets the width of the form item in logical units (usually dialog units) | DfBaseList
Form_Window_Handle | Returns the Windows window handle for the form region | DfBaseList
GridLine_Mode | Determines how grid lines will be displayed in the grid | DfBaseEntryList
GuiLocation | Determines the position of the object expressed in physical pixels relative to the upper left-hand corner of the containing object | DfBaseWindow
GuiSize | Determines the size (height and width) of the object expressed in physical pixels | DfBaseWindow
Header_Justification_Mode | Determines how text will be justified in list and grid headers | DfBaseEntryList
Header_Label | Define text for headers | DfBaseEntryList
Header_Visible_State | Determines if the grid header will be visible | DfBaseEntryList
Help_id | Used to specify an object's context ID | EntryList
Help_Keyword | Used to specify an object's context keyword | EntryList
Highlight_Row_State | When this property is true, the current row will be displayed in this object's CurrentRowColor. | DfBaseEntryList
Horz_Scroll_Bar_Visible_State | Specifies whether a horizontal scroll bar should be displayed when horizontal scrolling is allowed | DfBaseEntryList
IsColumnVisible | Determine if a particular column is visible | DfBaseEntryList
Item_Changed_State | Data entry to, or selection of, an item causes its item_changed_state property to become true | DfBaseList
Item_Count | A read-only property of menu-class objects | DfBaseList
Item_Entry_Msg | Sent in response to the item_change or the entering message | DfBaseEntry
Item_Exit_Msg | Sent in response to the item_change or the exiting message | DfBaseEntry
Item_Limit | Defines the number of entry items in the group that the entry messages are to work with | DfBaseEntry
Item_Matching | Searches a menu of items for a matching string value | DfBaseList
Item_Option | Allows you to query or change the skipfound format option on the entry_item command line for Item iItem | DfBaseEntry
Item_Options | Allows you to copy item options or set them in a group | DfBaseEntry
Item_Shadow_State | Determines if an object's item is enabled or disabled | EntryList
Item_Validate_Msg | Sent in response to the item_change or the exiting message, every time the item is validated | DfBaseEntry
ItemColor | Sets the color of an individual item | DfBaseEntryList
ItemTextColor | Sets the text color of an individual item | DfBaseEntryList
Key_Path | Determines the delegation path for on_key key assignments | cUIObject
Last_Child | Returns the object_id of the last focus child of a base_object | cUIObject
Line_Size | Returns number of columns of a grid or number windows per line of a menu | DfBaseList
Line_Width | Specifies the number of columns and displayable rows in a list | DfBaseList
Location | Determines the position of the upper left character of the object's window | cUIObject
Masked_Value | Returns a Form or grid value with masking character | DfBaseForm
Maximum_Position | Determines the maximum position for a spin button | EntryList
Message | Identifies the message that is sent when users press kenter on the item | DfBaseList
Minimum_Position | Determines the minimum position for a spin button | EntryList
Module_Name | Assists in the process of locating context-sensitive help information | cUIObject
Mouse_Capture |  | DfBaseUIWindow
Name | Returns the full name of the object including parentage | cObject
Next_Focus | Returns the object that is positioned in the focus tree as the next object at the same level as this object | cUIObject
Next_Level | Returns the object that is positioned in the focus tree as the first object in the next level | cUIObject
Next_Scope | Returns the object that is the next_scope object of the current scope | cUIObject
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Object_Shadow_State | Replaced by enabled_state, whose boolean logic is the inverse of this property's | EntryList
Object_Validation | Controls whether the validate messages have any effect | DfBaseEntry
Oem_Translate_State | Determines of OEM / ANSI conversions should be applied to this control | DfBaseObject
Parent | Returns the parent of an object | cObject
Password_State | Determines if each character of a form's value is displayed as an asterisk "*", rather than the characters that are typed | DfBaseForm
pbComboNavigation | Determines how up and down arrow keys are handled by any combo form in a grid | DfBaseEntryList
pbUseDisabledColor | Determines if a disabled cell should color text using peDisabledColor | DfBaseEntryList
peAnchors | Describes how you want the control to react whenever its container changes size | DfBaseWindow
peDisabledColor | Determines the background color of a disabled cell | DfBaseEntryList
peDisabledTextColor | Determines the text color of a disabled cell | DfBaseEntryList
peGridLineColor | Determines the color of lines separating grid cells | DfBaseEntryList
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
peResizeColumn | Determines the method used for resizing columns | EntryList
Physical_FontSize | Specifies the fontsize in pixels | DfBaseWindow
piMaxSize | Determines the limit of the maximum size that a Component can be | DfBaseWindow
piMinSize | Determines the limit of the minimum size that a Component can be | DfBaseWindow
piResizeColumn | Determines if column is to be resized when peResizeColumn is set to rcSelectedColumn | EntryList
Popup_State | Determines whether the object should respond to the activate message normally, or wait until the object receives the popup message | cUIObject
Prior_Focus | Returns the object that is positioned in the focus tree as the prior object at the same level as this object | cUIObject
Prior_Level | Returns the object that is the root of this object's level in the focus tree | cUIObject
Prior_Scope | Returns the object that is the prior_scope object of the current scope | cUIObject
Prompt_Object | Specifies the default receiving object for the popup message | DfBaseEntry
Prototype_Object |  | DfBaseList
psHtmlHelpTopic | Html help page name (e.g. reporting.htm) and optional bookmark. Can be used to locate the proper contextual help page. | EntryList
Resize_Column_State | Specifies whether grid columns can be resized by dragging the header divider. | DfBaseEntryList
Ring_State | Determines whether or not the objects added into the next level of this object are to act as a ring | cUIObject
RingParent | Returns the object handle of the object that is its ring parent | cUIObject
Row | Returns the row in a grid that a passed item is located in | DfBaseEntry
Row_Count | Returns the number of rows in a dbGrid-class object | DfBaseEntry
Scope_Focus | A property of scope objects in the focus tree | cUIObject
Scope_State | Determines whether the objects at the next level of this object and beyond, are to be scoped by this object | cUIObject
Search_Case |  | cUIObject
Search_Mode | Determines how users may move the selection cursor to a choice by use of (alphanumeric) keys matching the content of the choice | DfBaseList
Select_Count | Maintains the total number of selected items in the menu | DfBaseList
Select_Mode | Determines how item-level selections are processed | DfBaseList
Select_State | Each item may be selected by setting the select_state of the item | DfBaseList
Server | Identifies the object which provides database services to this object |
Shadow_State | Determines if item is enabled (not shadowed) | DfBaseList
Should_Save | Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit |
Size | Allows the programmer to affect the size of an object's display window | cUIObject
Skip_State | Determines whether or not the switch and switch_back messages skip over this object during focus movement | cUIObject
Spin_Value |  | EntryList
Status_Help | Sets the text of the help text that appears in the status bar | EntryList
Text_Extent | Returns the pixel with of the passed TextValue based on the typeface and style of the current object | DfBaseWindow
TextColor | Sets the text color of the object | DfBaseWindow
Top_Item | The item that is first in the display window | DfBaseList
Top_Row | Returns the row number of the top row on the display | DfBaseEntry
Transparent_State |  | DfBaseWindow
Typeface | The typeface of the selected font | DfBaseWindow
Use_Parent_Status_Help | Determines if parent's status help is used when object status help is empty | EntryList
Valid_Item | Causes the validation of a single item identified by the iItem | DfBaseEntry
Value | Gets and sets the data value for an item | DfBaseList
verify_exit_msg | Determines what message is sent during an exiting event |
Visible_State | Determines whether object is visible | cUIObject
Window_Handle | Returns the Windows window handle of the DataFlex object | DfBaseWindow
Window_Style | Sets the window style for the Windows object | DfBaseWindow
Windows_Override_State | Allows Visual DataFlex to stop the default windows behavior for mouse and keyboard messages | DfBaseUIWindow
Wrap_State | Controls the action of the cursor control keys and search_mode ranges during item navigation | DfBaseList
Zoom_Object | Sets the destination object_id of the popup message to the specified object | DfBaseEntry


WideList_ [Property Auto_Fill_State]

Auto_Fill_State - WideList_

Determines if the object's DDO should perform an auto fill

Type: Property

Access: Read/Write

Data Type: Boolean

Description

Auto_Fill_State determines if its DDO should attempt to find a record when the DDO becomes in-use.

Default is false for all DEOs with the exception of data-aware grid-classes such as dbList and dbGrid.

Last Edited: January 12, 2006


WideList_ [Property Auto_Top_Panel_State]

Auto_Top_Panel_State - WideList_

If true, clearing this object will cause the focus to be given to the first object and item in the current parent-child hierarchy

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the Auto_top_panel_state property is true, clearing this object (using request_clear or request_clear_all) will cause the focus to be given to the first object and item in the current parent-child hierarchy.

Default is true.

Last Edited: January 12, 2006


WideList_ [Property Deferred_State]

Deferred_State - WideList_

Determines if all finds by the object will occur without changing the server's current record

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If the value of the Deferred_State property is true, all finds by the object via its server will occur without notifying other DDOs (i.e., those connected to the server of this object) of the result of the find, and also without changing the server's current record. In addition, when this object is deactivated, it requests a "normal" find (i.e., one that notifies other DDOs of the result) of its server to ensure that the server has the proper current record.

Default is false.

Last Edited: January 12, 2006


WideList_ [Property Server]

Server - WideList_

Identifies the object which provides database services to this object

Type: Property

Access: Read/Write

Data Type: Integer

Description

Server identifies the object which provides database services to this object. When this property is set to a new value, this object detaches from the old server object and attaches to the new server object, if any. In addition, access of this property (i.e., by get or expression) will return the server of the parent of this object if this object's server property is zero, using the locate_server function. It is broadcast by the parent object when the parent's server property is changed while the object is active.

Default is 0.

Last Edited: September 11, 2003


WideList_ [Property Should_Save]

Should_Save - WideList_

Confirms successful request_saves and detects unsuccessful ones to report possible data losses on exit

Type: Property

Access: Read-Only

Data Type: Integer

Description

The Should_save property is false whenever the DEO and its server DEO have no changes since the last (successful) save. It also checks the server DSO's updating DSOs, and all DEOs using any of those. It is used to confirm successful request_saves and to detect unsuccessful ones to report possible data losses on exit.

Default is false.

Last Edited: September 11, 2003


WideList_ [Property verify_exit_msg]

verify_exit_msg - WideList_

Determines what message is sent during an exiting event

Type: Property

Access: Read/Write

Data Type: Integer

Description

The value of the verify_exit_msg property should be a message which, when sent, will return a zero if exiting should continue, or non-zero if exiting should not continue. If this object's verify_exit_msg is zero, and this object is the child of another DEO, the parent DEO's verify_exit_msg is used instead.

Sample

This sample turns off exit loss confirmation.

set Verify_Exit_Loss_msg to get_No_Confirmation

Sample

This sample sets exit loss confirmation to the default exit loss confirmation message.

set Verify_Exit_Loss_msg to get_Exit_Confirmation

Sample

This sample sets exit loss confirmation to a custom confirmation message.

Function MyExitConfirmation returns Integer
    integer eResponse

    move (YesNo_Box("You are about to lose changed data. Proceed?", "Exit Warning")) to eResponse

    if (eResponse = MBR_YES) ;
        Function_Return True
    else ;
        Function_Return False

End_Function  // MyExitConfirmation

set Verify_Exit_Loss_msg to get_MyExitConfirmation

Last Edited: February 16, 2005


WinReport [Event Report_Interrupt]

Report_Interrupt - WinReport

Augmented to support a preview mode

Type: Event

Return Data Type: Integer

Parameters: No Parameters

Return Value

Return a non-zero value to cancel the report

Description

The Report_interrupt function is augmented to support a preview mode. When a user presses an interrupt key, they are asked if they wish to cancel the report and is offered three choices: Yes, No and Preview. If they select preview, the current report is displayed to the screen before cancel.

Last Edited: September 11, 2003


Events for WinReport

View event list in hierarchical order

Name | Description | Defining Class
Assign_Report_Channel | Makes the current output channel the channel number represented by the report_channel property | Report
Body | Called once for every record selected for the report to provide processing for record data (if any) not used for subheaders and subtotals | Report
Construct_Object | Object constructor. Initializes the object during object creation in class definitions | cObject
Destroy_Object | Sent when an object is about to be destroyed | cObject
End_Construct_Object | End of object constructor. | cObject
Ending_Main_Report | Augmented to print/preview the report if AutoOutput_State is set to true | BasicReport
Ending_Report | This handler is called at the end of every report | Report
Error_Report | Sent whenever an error is generated | BasicReport
Final_Formfeed |  | Report
OnConstrain |  | Report
onError | Provided as a hook to handle custom error reporting | BasicReport
Page_Bottom | The last thing printed on every page | Report
Page_Footer | Printed after page_total on every page except the last page | Report
Page_Header | Called after page_top on every new page except the first | Report
Page_Title | Called on every new page after report_header or page_header | Report
Page_Top | Called first at the top of each new page | Report
Page_Total | Called on every new page and is printed as the first part of a page break at the bottom of each page | Report
Relate_Main_File | Called during find_rec and read_by_recnum if a record has been found | Report
Report_Footer | Printed after page_total on the last page of the report | Report
Report_Header | Called only on the first page of the report, after page_top | Report
Report_Interrupt | Augmented to support a preview mode |
Selection | Validates a record | Report
Starting_Main_Report | Called only if the current report is an outer report | BasicReport
Starting_Report | Called at the start of every report | Report
SubHeader_Init1..n | Called for every break level (n) for which you define a SubHeader_init1..n procedure section in your program | Report
SubHeader1..n | Called for every break level (n) for which you define a subHeader procedure section in your program | Report
SubTotal1..n | Called for every break level (n) for which you define a subTotal procedure section in your program | Report
Total | Called once at the end of a report after the final subtotals are output | Report


WinReport [Function SubTotal]

SubTotal - WinReport

Returns the value of the subtotal for the passed iTotal and zeroes the subtotal accumulator

Type: Function

Return Data Type: Number

Parameters: Integer iTotal

Parameter | Description
iTotal | A developer defined subtotal index

Return Value

Returns the value of the subtotal for the passed iTotal

Description

The Subtotal function returns the value of the subtotal for the passed iTotal and zeroes the subtotal accumulator. The value for iTotal should be assigned by the developer. In a complex report, you may choose to name the iTotal values you wish to use with mnemonics that identify the columns or fields being subtotalled.

Last Edited: September 11, 2003


WinReport [Function Sum_SubTotal]

Sum_SubTotal - WinReport

Returns the value of the subtotal for the passed iTotal, but does not zero the subtotal accumulator

Type: Function

Return Data Type: Number

Parameters: Integer iTotal

Parameter | Description
iTotal | A developer defined subtotal index

Return Value

Returns the value of the subtotal for the passed iTotal

Description

The Sum_subtotal function returns the value of the subtotal for the passed iTotal, but does not zero the subtotal accumulator.The value for iTotal should be assigned by the developer. In a complex report, you may choose to name the iTotal values you wish to use with mnemonics that identify the columns or fields being subtotalled.

Last Edited: September 11, 2003


Methods for WinReport

View method list in hierarchical order

Name | Type | Description | Defining Class
Add_SubTotal | Procedure | Adds the value of nData to the subtotal for the passed iCounter |
Clr_AllSubTotals | Procedure | Zeroes all the subtotal accumulators for the report |
Clr_SubTotal | Procedure | Zeroes the subtotal accumulator for the passed iCounter |
Create | Function | Creates an object based on the passed Class Id | cObject
Destroy | Procedure |  | cObject
DFNew_Page | Procedure | Creates a new page with Cols |
End_Log | Procedure | Sends an end-log message to the log object | BasicReport
Error_Log_Status | Procedure | Called by error_report if status_log_state is true | BasicReport
Exit_Application | Procedure | Starts the process of closing an application | cObject
Formfeed | Procedure | Handles formfeeds | Report
Log_Status | Procedure | Sends passed message to the log object | BasicReport
Output_ImageNum | Procedure | Outputs the image represented by ImageNum | Report
PrintReport | Procedure |  |
Request_Delete | Procedure | If sent (usually in the body) this will delete the current record through the DDO | Report_DS
Request_Destroy_Object | Procedure | (Obsolete) Use the Destroy method instead | cObject
Request_Save | Procedure | If sent, this saves the current record | Report_DS
Run_Report | Procedure | Sends a message to the report object telling it to start the report with internal finding | Report
ShowRuler | Procedure | Displays a ruler in the report |
Start_Log | Procedure | Sends a start-log message to the log object | BasicReport
Start_Report | Function | Augmented to check the server property and if the property is non-zero (and a DSO exists), to establish a client-server link between the report object and the DSO | Report
SubTotal | Function | Returns the value of the subtotal for the passed iTotal and zeroes the subtotal accumulator |
Sum_SubTotal | Function | Returns the value of the subtotal for the passed iTotal, but does not zero the subtotal accumulator |
Update_Status | Procedure | Send this message to update the action area of the status panel | BasicReport
WriteLn | Procedure | Outputs the string message to the current output channel | Report
Writeln_PageCheck | Procedure | Allows you to output to your report with non-image data | Report


WinReport [Procedure Add_SubTotal]

Add_SubTotal - WinReport

Adds the value of nData to the subtotal for the passed iCounter

Type: Procedure

Parameters: Integer iCounter Number nData

Parameter | Description
iCounter | A developer defined subtotal index
nData | The value to be added to the subtotal

Description

The Add_subtotal procedure adds the value of nData to the subtotal for the passed iCounter. The value for iCounter should be assigned by the developer. In a complex report, you may choose to name the iCounter values you wish to use with mnemonics that identify the columns or fields being subtotalled.

Last Edited: July 30, 2003


WinReport [Procedure Clr_AllSubTotals]

Clr_AllSubTotals - WinReport

Zeroes all the subtotal accumulators for the report

Type: Procedure

Parameters: No Parameters

Description

The Clr_allSubtotals procedure zeroes all the subtotal accumulators for the report.

Last Edited: April 14, 2004


WinReport [Procedure Clr_SubTotal]

Clr_SubTotal - WinReport

Zeroes the subtotal accumulator for the passed iCounter

Type: Procedure

Parameters: Integer iCounter

Parameter | Description
iCounter | A developer defined subtotal index

Description

The Clr_subtotal procedure zeroes the subtotal accumulator for the passed iCounter. The value for iCounter should be assigned by the developer. In a complex report, you may choose to name the iCounter values you wish to use with mnemonics that identify the columns or fields being subtotalled.

Last Edited: July 30, 2003


WinReport [Procedure DFNew_Page]

DFNew_Page - WinReport

Creates a new page with Cols

Type: Procedure

Parameters: Integer Cols

Parameter | Description
Cols | The number of columns for the page (optional)

Description

The DFNew_page procedure creates a new page with Cols. If columns is omitted, the new page will be started with the number of Cols equal to the value of the print_columns property. Page headers or footers will be printed automatically. If you have set DFSubHeader or DFSubTotal to wrap (reprint), they will also be printed on the new page.

Last Edited: July 31, 2003


WinReport [Procedure PrintReport]

PrintReport - WinReport

Type: Procedure

Parameters: No Parameters

Description

Last Edited: February 13, 2003


WinReport [Procedure ShowRuler]

ShowRuler - WinReport

Displays a ruler in the report

Type: Procedure

Parameters: No Parameters

Description

When sent, the ShowRuler message displays a ruler in the report. This can be used for design and debugging. It gives you a ruler that you can use to determine where to place fields and labels.

Procedure_Section Body
    Send ShowRuler // show a ruler for lining up fields

Last Edited: September 11, 2003


Properties for WinReport

View property list in hierarchical order

Name | Description | Defining Class
Allow_Cancel_State | Specifies whether the status panel will support a Cancel button | BasicReport
Assigned_Channel |  | Report
AutoNew_Page_State | Determines if a DFNew_Page is sent when the report is started or if new pages are explicitly generated |
AutoOutPut_State | Determines if the report is automatically output to the printer or the Previewer when it is complete |
Cancelled_State | Setting this true will cancel a report | Report
Child_Count | Returns the number of child objects the object contains | cObject
Child_Rpt_State | Set true if the current Report object is nested | Report
Current_Rec | (Obsolete) Contains the record number of the current valid record found | Report
Delegation_Mode | Determines if and how unknown messages are delegated | cObject
Display_Error_State |  | BasicReport
Find_Down_state | Determines if an index should be traversed in forward or reverse order | Report
Find_Mode | Maintains the current finding mode | Report
Footer_Lines | Contains the number of lines in the page_bottom image plus the page_footer image plus the page_total image | Report
Found_Rec | (Obsolete) Contains the record number of the record found by the find_rec function | Report
Has_Children_Rpt_State | Is set true if other reports are nested inside this report object | Report
Last_Rec | (Obsolete) Contains the record number of the last selected record found | Report
Main_File | Contains the filenumber of the file which the report will use for finding records | Report
Main_Report_Id | Contains the object ID of the outer report | Report
Name | Returns the full name of the object including parentage | cObject
New_Page_State | Set true when a new page is needed | Report
No_Constrained_Find_State | Determines if constrained record finding should be disabled | Report
No_Finding_State | Determines how the Report object will find records | Report
No_PageCheck_State | Set true when the Report object is processing a new page | Report
No_Relate_State | Determines if relates are automatically performed or if it is up to you to make sure the records that you need related are found | Report
Num_Breaks | Returns the number of breaks in a report | Report
Object_Id | Returns the object handler of the object | cObject
Object_Label | Returns the short name of an object | cObject
Ordering | Contains the index number which will be used for finding records | Report
Output_Device | Handles the name of the output device | BasicReport
Output_Device_Mode | Determines if this object will use this container's output_device_mode |
Page_Count | Keeps track of the current page number | Report
Page_End | Determines how many lines on a page are allowed before a page break will occur | Report
Page_End_State | If this property is set true below the forward send statement in the starting_main_report procedure, then the next page_check will cause an end-of-page/new-page sequence | Report
Page_Feed | Used by the formfeed procedure | Report
Page_Footer_Lines | The number of lines in the page_footer image | Report
Parent | Returns the parent of an object | cObject
peNeighborhood | Determines how an object and its descendents participate in object neighborhood referencing | cObject
priCurrentRec | Contains the RowId of the current valid record found | Report
priFoundRec | Contains the RowId of the record found by the find_rec function | Report
priLastRec | Contains the RowId of the last selected record found | Report
Print_Columns | Determines the number of columns in a report |
Rec_Count | Contains the number of records found for the current report | Report
Refind_for_SubTotal_State | Ensures that the subtotal is processed with the last valid record for that break level | Report
Report_Caption | Contains the text that will appear in the status panel's caption bar | BasicReport
Report_Channel | Determines which output channel will be used for your report output | Report
Report_Footer_Lines | The number of lines in the report_footer image | Report
Report_Message | An additional message area that will appear below the report_title in the status panel | BasicReport
Report_Status_Panel |  | BasicReport
Report_Title | A centered title that appears in the status panel | BasicReport
Rpt_Ttl_Level | Keeps track of the current sub-total level during subtotal processing | Report
RptToday | Contains the current date |
Server | Contains the object ID of this object's server | Report_DS
Status_Log_Id | Object ID of status-log object | BasicReport
Status_Log_State | Determines if automatic status logging will occur when process starts, stops, and when an error occurs | BasicReport
Status_Panel_State | Enables or disables the status panel that reports the status of the report as it runs | BasicReport
Sub_Totaling_State | Set true when the Report object is processing subtotals or totals | Report


WinReport [Property AutoNew_Page_State]

AutoNew_Page_State - WinReport

Determines if a DFNew_Page is sent when the report is started or if new pages are explicitly generated

Type: Property

Access: Read/Write

Data Type: Integer

Description

When the AutoNew_page_state property is true, a DFNew_Page is sent when the report is started. Most of the time, this is what is wanted. In the rare cases where you wish to generate new pages explicitly (probably in the subheader sections) you can set this property false.

Default is true.

Last Edited: July 30, 2003


WinReport [Property AutoOutPut_State]

AutoOutPut_State - WinReport

Determines if the report is automatically output to the printer or the Previewer when it is complete

Type: Property

Access: Read/Write

Data Type: Boolean

Description

If Auto_output_state is true (the default), the report is automatically output to the printer or the Previewer when it is complete. It uses the value of Property output_device_mode to determine if it should do a DFPrint (mode= PRINT_TO_PRINTER) or a DFPreview (mode = PRINT_TO_WINDOW).

If this property is set false, then no auto-print occurs and you have to send DFPrint or DFPreview at the end of the report.

Default is true.

Last Edited: January 12, 2006


WinReport [Property Output_Device_Mode]

Output_Device_Mode - WinReport

Determines if this object will use this container's output_device_mode

Type: Property

Access: Read/Write

Data Type: Integer

Description

If the value of the Output_device_mode property is PRINT_TO_UNDEFINED (the default) and this object is in a report view or report panel, it will use this container's output_device_mode. If this is undefined, this function will return PRINT_TO_WINDOW. Otherwise, it returns the container's output_device_mode.

Default is PRINT_TO_UNDEFINED.

Last Edited: September 10, 2003


WinReport [Property Print_Columns]

Print_Columns - WinReport

Determines the number of columns in a report

Type: Property

Access: Read/Write

Data Type: Integer

Description

The Print_Columns property determines the number of columns in a report. If DFNew_Page is received with no parameter, it will start the new page with the number of columns (default: no columns) in the value of the Print_columns property.

Default is 0.

Last Edited: September 11, 2003


WinReport [Property RptToday]

RptToday - WinReport

Contains the current date

Type: Property

Access: Read/Write

Data Type: Date

Description

The RptToday property contains the current date.

Last Edited: September 11, 2003